// jhaley 20111031: MSVC++ compiler - enable WinSock support
#ifdef _MSC_VER
#define USE_WINSOCK
#define _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_DEPRECATE
#endif

#include <stdio.h>

#ifndef USE_WINSOCK
// jhaley 20111031: Linux-alike includes and typedefs:
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <sys/poll.h>
#include <sys/uio.h>
#include <unistd.h>
typedef int socket_basic_type;
#else
// jhaley 20111031: Winsock includes and typedefs:
#include <windows.h>
#include <winsock2.h>
#include <time.h>
typedef unsigned int socket_basic_type; // SOCKET is an unsigned type on Win32
#endif

#include <stdlib.h>
#include <signal.h>
#include <errno.h>
#include <string.h>

#include <iostream>
#include <fstream>
#include <string>
#include <map>
#include <set>
#include <vector>
#include <list>

using namespace std;

// jhaley 20111031: socket_map typedef defined to use socket_basic_type as first parameter
struct socket_info;
typedef map<socket_basic_type, socket_info> socket_map;

#define message_text_separator "~"
#define atlas_keyvalue_separator "|"
#define max_chunk_size 1024
#define size_separator ':'

class inbound_message_queue
{
 private:
  list<string> pending_messages;
  string       current_message;
  int          chunk_size;
 public:
  inbound_message_queue () : chunk_size (0) {};
  bool   IsMessageProcessing ();
  bool   IsMessagePending ();
  string GetMessage ();
  bool   AttemptRead (socket_basic_type file_descriptor);
  void   PrepMessage ();
};

class outbound_message_queue
{
 private:
  list<string> pending_messages;
  string       current_message;
  int          chunk_size;
  int          errno_on_close;
 public:
  outbound_message_queue () : chunk_size (0), errno_on_close (0) {};
  bool IsMessageProcessing ();
  bool IsMessagePending ();
  void AddMessage (string new_message);
  bool AttemptWrite (socket_basic_type file_descriptor);
  void PrepMessage ();
  int  GetCloseReason ();
};

struct socket_info
{
 map<string, string> properties; // key/value pairs about the connection
 map<string, string> requests;   // event/channel pairs for notifications
 inbound_message_queue in;
 outbound_message_queue out;
 bool is_active;
};

enum message_types {msg_unknown, msg_to_any, msg_to_all, msg_to_server, msg_to_connection};
enum output_types {output_debug, output_status, output_prefork, output_error, output_data};

extern char read_buffer [max_chunk_size];

bool RouteMessage (int sending_socket, string message_to_route, socket_map & other_connections);
string IntToString(int incoming);
int StringToInt(string incoming);
string twodigit(int incoming);
void SplitStringToVec(string incoming, string separator, vector<string> &vec);

string right_now ();
void output (output_types output_type, string text);
void output_map (output_types, string text, map<string, string> & params);
string map_string (const map<string, string> & params);
string rebuild_end (vector<string> & params, int start_at);
void PostEvent (int cause_socket, string event_name, socket_map & all_connections);
