/*

   HL7Daemon - Command-line argument management

*/

#include <cstring>
using namespace std;

#include "argvs.h"

// Global argument manager
ArgumentManager *globalArgMgr;

//
// ArgumentManager::checkParam
//
// Returns true if the program was given the specified argument.
//
bool ArgumentManager::checkParam(const char *param) const
{
   for(int i = 1; i < argc; i++)
   {
      if(!stricmp(param, argv[i]))
         return true;
   }

   return false;
}

//
// ArgumentManager::getParamTo
//
// If the program was given the specified argument, this will return the next
// argument after that as a parameter to the given argument, for example, given:
//  > hl7daemon -debugflags all
// Asking for "-debugflags" will return "all". Returns NULL if not found.
//
const char *ArgumentManager::getParamTo(const char *param) const
{
   int i;

   for(i = 1; i < argc; i++)
   {
      if(!stricmp(param, argv[i]))
         break;
   }

   return (i && i + 1 < argc) ? argv[i + 1] : NULL;
}

// EOF

