/*

   HL7Daemon - Miscellaneous utilities for use with PrometheusDB

*/

#include "dbmisc.h"
#include "prometheusdb.h"

#pragma hdrstop
#include "util.h"

//=============================================================================
//
// Zip Code Utilities (Derived loosely from Prometheus components.cpp stuff)
//

//
// CountyByZip
//
// Look up the county for a given zip code.
//
bool CountyByZip(PrometheusDB *db, const string &zipCode, string &countyID)
{
   pdb::vecmap zipVec;
   bool result = false;
   string zip5 = zipCode.substr(0,5);
   string sql  = "select * from zip_codes_view where zip_code = '" + zip5 + "'";

   db->sqlToVecMap(sql, zipVec);

   if(zipVec.size() > 0)
   {
      // county will be the same for a given zip code, so just pick the first
      countyID = zipVec[0]["county_types_id"].c_str();
      result = true;
   }

   return result;
}


// EOF

