/*

   HL7Daemon - Initialization File

   Derived from Prometheus inifile module - "PANDORA"

*/

#ifndef pandorafunctions__
#define pandorafunctions__

#include <string>
#include <map>

class IniFile
{
public:
   typedef std::string IniToken;
   typedef std::map<IniToken, IniToken> IniValue;
   typedef std::map<IniToken, IniValue> IniMap;

protected:
   IniMap pandora;

   // Protected constructor for singleton object
   IniFile() : pandora()
   {
   }

public:
   bool loadOptionsFromFile(const std::string &filename);
   bool saveOptionsToFile(const std::string &filename);

   IniMap &getIniOptions() { return pandora; }

   static IniFile &GetIniFile();
   static IniMap  &GetIniOptions() { return GetIniFile().getIniOptions(); }
};

#endif

// EOF

