//---------------------------------------------------------------------------
#ifndef ScannerH
#define ScannerH
//---------------------------------------------------------------------------

#include <vcl.h>
#include <queue>

using namespace std;

class fileinfo
{
public:
  AnsiString path;
  AnsiString filename;
  AnsiString creation_date;
  AnsiString creation_time;
public:
  fileinfo() {}
  AnsiString GetFullyQualifiedName()
  {
	return IncludeTrailingBackslash(path) + filename;
  }
};

// A generic functor base class; use this for the most generic form of the
// ScanForFiles function by inheriting from it.
class GenericFunctor
{
public:
   virtual void operator ()(fileinfo &fi) = 0;
};

typedef void (*AddPath)(fileinfo&);
typedef void (TObject::*MemberAddPath)(fileinfo&);
typedef void (__closure *ClosureAddPath)(fileinfo&);

void format_date(const FILETIME *ft, AnsiString &outstr);
void format_time(const FILETIME *ft, AnsiString &outstr);
void get_file_specs(const WIN32_FIND_DATA &filename, fileinfo &info);
bool IsDirectory(const AnsiString &filename);
void ScanForFiles(queue<AnsiString> &paths_to_scan, GenericFunctor &functor);
void ScanForFiles(queue<AnsiString> &paths_to_scan, AddPath add_callback);
void ScanForFiles(queue<AnsiString> &paths_to_scan, TObject* member, MemberAddPath add_callback);
void ScanForFiles(queue<AnsiString> &paths_to_scan, ClosureAddPath add_callback);

#endif

// EOF


