/*

   HL7Daemon - SQL Manager

   Loads and manages SQL scripts

*/

#ifndef SQLMANAGER_H__
#define SQLMANAGER_H__

#include <map>
#include <string>

class fileinfo;

class SQLManager
{
public:
   typedef std::map<std::string, std::string> QueryMap;
   typedef std::map<std::string, std::string> VariableMap;

protected:
   QueryMap scripts;

   void scriptCallback(fileinfo &fi);

   // protected constructor for singleton instance
   SQLManager() : scripts()
   {
   }

   static bool LoadMcpp();

public:
   void loadScripts();
   bool haveScript(const std::string &scriptName) const;
   const std::string &getScript(const std::string &scriptName) const;

   void prepareScript(const std::string &scriptName,
                      const VariableMap &variables,
                      std::string &output) const;

   static SQLManager &GetSQLManager();
   static bool LoadScripts();
   static bool HaveScript(const std::string &scriptName);
   static const std::string &GetScript(const std::string &scriptName);

   static void PrepareScript(const std::string &scriptName,
                             const VariableMap &variables,
                             std::string &output);
};

#endif

// EOF

