//PAN
#include <iostream>
#include <sstream>
#include "utils.h"
#pragma hdrstop

#include "util.h"

//---------------------------------------------------------------------------
//map<debug_form_types, int> debug_level;
int debug_level[numdebugformtypes];

// jhaley 20120620: HL7Daemon has no TApplication instance so we can't use it
// to output debug messages. Instead we need to route them to the debug output
// used by the rest of the application.
#define NO_TAPPLICATION_INSTANCE

#ifndef NO_TAPPLICATION_INSTANCE
#define AppDebugMsg(msg, cat, opt) Application->MessageBox(msg, cat, opt)
#else
#define AppDebugMsg(msg, cat, opt) DEBUGOUT(dbg_library, cat << ": " << msg)
#endif

// jhaley 20110701: Changed to pointer so is not destroyed during program shutdown, and added typedef.
typedef map<AnsiString, log_file_item> LogFileMap;
LogFileMap *log_files_map;
//---------------------------------------------------------------------------

char * hardcoded_usps_abbrs [] = // used by FormatAddress to make addresses pretty, concise, but mostly consistent (original list came from USPS website)
{
  // basic/common
  "Po","PO","Ne","NE","Nw","NW","Se","SE","Sw","SW","North","N","South","S","East","E","West","W","Northeast","NE","Northwest","NW","Southeast","SE","Southwest","SW",
  // military
  "Aa","AA","Ae","AE","Ap","AP",
  // primary unit designators
  "Alley","Aly","Annex","Anx","Arcade","Arc","Avenue","Ave","Bayoo","Byu","Bayou","Byu","Beach","Bch","Bend","Bnd","Bluff","Blf","Bluffs","Blfs",
  "Bottom","Btm","Boulevard","Blvd","Branch","Br","Bridge","Brg","Brook","Brk","Brooks","Brks","Burg","Bg","Burgs","Bgs","Bypass","Byp","Camp","Cp",
  "Canyon","Cyn","Cape","Cpe","Causeway","Cswy","Center","Ctr","Centers","Ctrs","Circle","Cir","Circles","Cirs","Cliff","Clf","Cliffs","Clfs","Club","Clb",
  "Common","Cmn","Corner","Cor","Corners","Cors","Course","Crse","Court","Ct","Courts","Cts","Cove","Cv","Coves","Cvs","Creek","Crk","Crescent","Cres",
  "Crest","Crst","Crossing","Xing","Crossroad","Xrd","Curve","Curv","Dale","Dl","Dam","Dm","Divide","Dv","Drive","Dr","Drives","Drs","Estate","Est",
  "Estates","Ests","Expressway","Expy","Extension","Ext","Extention","Ext","Extensions","Exts","Extentions","Exts","Falls","Fls","Ferry","Fry","Field","Fld",
  "Fields","Flds","Flat","Flt","Flats","Flts","Ford","Frd","Fords","Frds","Forest","Frst","Forge","Frg","Forges","Frgs","Fork","Frk","Forks","Frks",
  "Fort","Ft","Freeway","Fwy","Garden","Gdn","Gardens","Gdns","Gateway","Gtwy","Glen","Gln","Glens","Glns","Green","Grn","Greens","Grns","Grove","Grv",
  "Groves","Grvs","Harbor","Hbr","Harbors","Hbrs","Haven","Hvn","Heights","Hts","Highway","Hwy","Hill","Hl","Hills","Hls","Hollow","Holw","Inlet","Inlt",
  "Island","Is","Islands","Iss","Isles","Isle","Junction","Jct","Junctions","Jcts","Key","Ky","Keys","Kys","Knoll","Knl","Knolls","Knls","Lake","Lk",
  "Lakes","Lks","Landing","Lndg","Lane","Ln","Light","Lgt","Lights","Lgts","Loaf","Lf","Lock","Lck","Locks","Lcks","Lodge","Ldg","Loops","Loop",
  "Manor","Mnr","Manors","Mnrs","Meadow","Mdw","Meadows","Mdws","Mill","Ml","Mills","Mls","Mission","Msn","Motorway","Mtwy","Mount","Mt","Mountain","Mtn",
  "Mountains","Mtns","Neck","Nck","Orchard","Orch","Overpass","Opas","Parks","Park","Parkway","Pkwy","Parkways","Pkwy","Passage","Psge","Paths","Path",
  "Pine","Pne","Pines","Pnes","Place","Pl","Plain","Pln","Plains","Plns","Plaza","Plz","Point","Pt","Points","Pts","Port","Prt","Ports","Prts","Prairie","Pr",
  "Radial","Radl","Ranch","Rnch","Ranches","Rnch","Rapid","Rpd","Rapids","Rpds","Rest","Rst","Ridge","Rdg","Ridges","Rdgs","River","Riv","Road","Rd",
  "Roads","Rds","Shoal","Shl","Shoals","Shls","Shore","Shr","Shores","Shrs","Skyway","Skwy","Spring","Spg","Springs","Spgs","Square","Sq","Squares","Sqs",
  "Station","Sta","Stravenue","Stra","Stream","Strm","Street","St","Streets","Sts","Summit","Smt","Terrace","Ter","Throughway","Trwy","Trace","Trce",
  "Track","Trak","Tracks","Trak","Trafficway","Trfy","Trail","Trl","Tunnel","Tunl","Turnpike","Tpke","Underpass","Upas",/*"Union","Un",*/"Unions","Uns",
  // if the FormatAddress() code is updated to identify the parts of an address, then the above commented out abbreviations can be restored.  the problem
  // is that we end up with things like 123 S Un St, or 345 NW Blvd Ave, and that can be confusing
  "Valley","Vly","Valleys","Vlys","Viaduct","Via","View","Vw","Views","Vws","Village","Vlg","Villages","Vlgs","Ville","Vl","Vista","Vis","Walks","Walk",
  "Well","Wl","Wells","Wls",
  // secondary unit designator
  "Apartment","Apt","Basement","Bsmt","Department","Dept","Floor","Fl","Front","Frnt","Hangar","Hngr","Lobby","Lbby","Lower","Lowr","Office","Ofc",
  "Penthouse","Ph","Room","Rm","Space","Spc","Suite","Ste","Trailer","Trlr","Upper","Uppr",
  NULL
};

char * show_type_names [num_show_types] =
 {"Initial Caps", "Uppercase", "Lowercase", "Sentence", "Social Security Number",
  "Phone Number", "Zip Code", "Yes/No", "Decimal/$ Amount", "Repeating Appointment",
  "Decimal/$ Amount (zero is blank)", "In/Out", "Raw (unformatted)", "Number (integer)", "Decimal Number (one decimal)", "Decimal/$ Amount (with $)",
  "Address"};

char * sort_type_names [num_sort_types] = {"Text", "Date", "Date and Time", "Time", "Number", "Decimal Number", "Yes/No"};
map<string, string> usps_abbr_map;

void InitUspsAbbrMap() // initialize the USPS abbreviation map, if not already done
{
  if (usps_abbr_map.empty())
  {
    unsigned int i = 0;
    while (hardcoded_usps_abbrs[i])
    {
     usps_abbr_map.insert(pair<string,string>(hardcoded_usps_abbrs[i], hardcoded_usps_abbrs[i+1]));
     i+=2; // pairs
    }
  }
}

//START DATE MANIPULATION STUFF---------------------------------------------
int daysinnorm [13] = { 0,
                       31, 28, 31, 30,
                       31, 30, 31, 31,
                       30, 31, 30, 31};
int daysinleap [13] = { 0,
                       31, 29, 31, 30,
                       31, 30, 31, 31,
                       30, 31, 30, 31};

int month_code_norm [13] = {0,1,4,4,0,2,5,0,3,6,1,4,6};
int month_code_leap [13] = {0,0,3,4,0,2,5,0,3,6,1,4,6};

bool IsLeapYear(int year)
{
        if (year % 4)    return false;//not divisible by 4, not leap
        if (year < 1582) return true; //divisible by 4 before 1582, leap
        if (year % 100)  return true; //divisible by 4, not by 100, leap
        if (year % 400)  return false;//divisible by 4, 100, not 400, not leap
        return true;                  //divisible by 400, leap
}

int LastDayOf (int month, int year)
{
 return (IsLeapYear(year) ? daysinleap[month] : daysinnorm[month]);
}

//pad to the left with a zero to make it two digits.
string twodigit(int incoming)
{
 string answer = IntToString(incoming);
 if (answer.length() < 2) answer = "0" + answer;
 return answer;
}

//separate a string into three integers, ignoring leading spaces,
//and differentiating the three integers by a single character.
//used both for time and date parsing, to get h:m:s or m/d/y
//or any other combination (see the date stuff to understand.)
void septhree (const string &incoming, char separator, int &A, int&B, int&C)
{
 unsigned int beginA; //first digit
 unsigned int beginB; //first mark
 unsigned int beginC; //second mark
 unsigned int beginD; //after last digit

 beginA = incoming.find_first_of ("0123456789");

 if (beginA < incoming.length() - 1 && beginA != string::npos)
 {
  beginB = incoming.find_first_of (separator, beginA + 1);
  if (beginB < incoming.length() - 1 && beginB != string::npos)
  {
   A = StringToInt(incoming.substr(beginA, beginB - beginA));
   beginC = incoming.find_first_of (separator, beginB + 1);
   if (beginC < incoming.length() - 1 && beginC != string::npos)
   {
    B = StringToInt(incoming.substr(beginB + 1, beginC - beginB - 1));
    beginD = incoming.find_first_not_of ("0123456789", beginC + 1);
    if (beginD == string::npos)
      C = StringToInt(incoming.substr(beginC + 1));
    else
      C = StringToInt(incoming.substr(beginC + 1, beginD - beginC - 1));
   }
   else if (beginC == string::npos)
   {
    B = StringToInt(incoming.substr(beginB + 1));
   }
  }
  else if (beginB == string::npos)
  {
   A = StringToInt(incoming.substr(beginA));
  }
 }
}

//END DATE MANIPULATION STUFF-----------------------------------------------

//START DATE TIME TIMESTAMP CLASS DEFINITIONS-------------------------------
//Pstamp is derived from Pdate and Ptime. As such, it is mostly a combination
//of code from its ancestors. Not much is added. All three support the
//.Out* (mode), .In* (string, mode), and .IsValid* () functions, where * is
//one of time, date, or stamp. They all support empty constructors and
//constructors with (string, mode) passed.
//Note on "mode" - this value indicates how the string is to be interpreted.
//It's okay to pass time values to date, or date to time, because the bits
//don't overlap. In the case of stamp, you'll want to pass some of each,
//which will be passed on to the base class constructors. There are defaults.
//To see what the defaults are, check the .h file and see which values have
//a zero next to them.
//Internally, everything is kept in 4-digit year, military time format.
//All three classes support the <, >, <=, >=, ==, != relational operators.

//DATE----------------------------------------------------------------------

Pdate::Pdate ()
{
 year = 0;
 month = 0;
 day = 0;
}

Pdate::Pdate (const string &incoming, int mode)
{
 InDate (incoming, mode);
}

Pdate::Pdate (TDate incoming)
{
 InDate (incoming);
}

void Pdate::InDate (TDate incoming)
{
 InDate(incoming.FormatString("m/d/yyyy").c_str(), mdy | yyyy);
}

void Pdate::InDate (const string &incoming, int mode)
{
 int y;
 int m;
 int d;

 int a = 0;
 int b = 0;
 int c = 0;

 //take three chunks out
 septhree (incoming, datechar, a, b, c);

 //determine which is which
 if (mode & ymd)
 {
  y = a;
  m = b;
  d = c;
 }
 else if (mode & dmy)
 {
  d = a;
  m = b;
  y = c;
 }
 else //mdy
 {
  m = a;
  d = b;
  y = c;
 }
 //convert two-digit year to four-digit year
 if (! (mode & yyyy) && y < 200)
 {
  y += 1900;
  if (y < y2kcut) y += 100;
 }
 //store locally
 year = y;
 month = m;
 day = d;
}

void Pdate::InDate (const Pdate & incoming)
{
 year  = incoming.year;
 month = incoming.month;
 day   = incoming.day;
}

bool Pdate::IsValidDate () const
{
 if (month < 1 || month > 12) return false;
 if (year  < 1) return false;
 if (day   < 1) return false;
 if (day > LastDayOf (month, year)) return false;
 return true;
}

string Pdate::OutDate (int mode) const
{
 string y, m, d, c;

 y = IntToString(year);
 if (mode & left_zeros)
  m = twodigit(month);
 else
  m = IntToString(month);
 if (mode & left_zeros)
  d = twodigit(day);
 else
  d = IntToString(day);
 c = "";
 c += datechar;
 string answer = "";
 if (mode & yyyy);
  else
   y = y.substr(2);
 if (mode & ymd)
  answer = y + c + m + c + d;
 else if (mode & dmy)
  answer = d + c + m + c + y;
 else // (mode & mdy)
  answer = m + c + d + c + y;
 return answer;
}

TDate Pdate::OutDate () const
{
 TDateTime to_return((unsigned short)year, (unsigned short)month, (unsigned short)day);
 return (TDate)to_return;
}

bool Pdate::operator < (const Pdate & rhs) const
{
 if (year < rhs.year) return true;
 if (year > rhs.year) return false;
 //same year
 if (month < rhs.month) return true;
 if (month > rhs.month) return false;
 //same month
 if (day < rhs.day) return true;
 //doesn't matter anymore
 return false;
}

bool Pdate::operator <= (const Pdate & rhs) const
{
 if (year < rhs.year) return true;
 if (year > rhs.year) return false;
 //same year
 if (month < rhs.month) return true;
 if (month > rhs.month) return false;
 //same month
 if (day <= rhs.day) return true;
 return false;
}

bool Pdate::operator > (const Pdate & rhs) const
{
 if (year > rhs.year) return true;
 if (year < rhs.year) return false;
 //same year
 if (month > rhs.month) return true;
 if (month < rhs.month) return false;
 //same month
 if (day > rhs.day) return true;
 //doesn't matter anymore
 return false;
}

bool Pdate::operator >= (const Pdate & rhs) const
{
 if (year > rhs.year) return true;
 if (year < rhs.year) return false;
 //same year
 if (month > rhs.month) return true;
 if (month < rhs.month) return false;
 //same month
 if (day >= rhs.day) return true;
 //doesn't matter anymore
 return false;
}

bool Pdate::operator != (const Pdate & rhs) const
{
 if (year != rhs.year || month != rhs.month || day != rhs.day)
  return true;
 else
  return false;
}

bool Pdate::operator == (const Pdate & rhs) const
{
 if (year == rhs.year && month == rhs.month && day == rhs.day)
  return true;
 else
  return false;
}

Pdate Pdate::operator ++ (int)
{
 day++;
 int upper_bound = LastDayOf (month, year);
 if (day > upper_bound)
 {
  month++;
  if (month > 12)
  {
   year++;
   month = 1;
  }
  day = 1;
 }
 return *this;
}

Pdate Pdate::operator -- (int)
{
 day--;
 if (day < 1)
 {
  month--;
  if (month < 1)
  {
   year--;
   month = 12;
  }
  int upper_bound = LastDayOf (month, year);
  day = upper_bound;
 }
 return *this;
}

int Pdate::mod (int p_distance, int p_metric)
{
 if (p_metric == in_days)
 {
  while (p_distance)
  {
   if (p_distance > 0)
   {
    (*this)++;
    p_distance--;
   }
   else
   {
    (*this)--;
    p_distance++;
   }
  }
 }
 else
 if (p_metric == in_weeks)
 {
  while (p_distance)
  {
   if (p_distance > 0)
   {
    for (int i = 0; i < 7; i++) (*this)++;
    p_distance--;
   }
   else
   {
    for (int i = 0; i < 7; i++) (*this)--;
    p_distance++;
   }
  }
 }
 else
 if (p_metric == in_months)
 {
  while (p_distance)
  {
   if (p_distance > 0)
   {
    month++;
    if (month > 12)
    {
     month = 1;
     year++;
    }
    p_distance--;
   }
   else
   {
    month--;
    if (month < 1)
    {
     month = 12;
     year--;
    }
    p_distance++;
   }
  }
 }
 else
 if (p_metric == in_years)
 {
  while (p_distance)
  {
   if (p_distance > 0)
   {
    year++;
    p_distance--;
   }
   else
   {
    year--;
    p_distance++;
   }
  }
 }

 // handle both leap years and changing from a month with 31 days
 // to a month with 30 days, but only after done moving through the
 // months, etc. so as not to have to go up and down, etc.
 // oh, and much faster!
 if (day > LastDayOf(month, year))
  day = LastDayOf(month, year);
 return 0;
}

int Pdate::mod (const Pdate & p_distance)
{
 this->mod (p_distance.year, in_years);
 this->mod (p_distance.month, in_months);
 this->mod (p_distance.day, in_days);
 return 0;
}

int Pdate::DayOfWeek () const
{
 int c,y,m,d;
 int C,Y,M,D;
 int x;

 // initial values;
 c = (year / 100) + 1;
 y = year - ((c - 1) * 100);
 m = month;
 d = day;

 // codes
 C = (8 - ((c % 4) * 2)) % 8;
 Y = (y + (y / 4)) % 7;
 M = (IsLeapYear(year)) ? month_code_leap[m] : month_code_norm[m];
 D = d;

 // day of week
 x = (C + Y + M + D) % 7;
 
 // so far, sunday is 1, friday is 6, saturday is 0
 // since ashley's code has sunday as 1 and saturday as 7,...
 if (!x) 
  x = 7;

 return x;
}

string Pdate::NameOfDay() const
{
  switch(DayOfWeek())
  {
    case 1: return "Sunday";
    case 2: return "Monday";
    case 3: return "Tuesday";
    case 4: return "Wednesday";
    case 5: return "Thursday";
    case 6: return "Friday";
    case 7: return "Saturday";
    default: return "";
  }
}

string Pdate::NameOfMonth() const
{
  switch(month)
  {
    case 1: return "January";
    case 2: return "February";
    case 3: return "March";
    case 4: return "April";
    case 5: return "May";
    case 6: return "June";
    case 7: return "July";
    case 8: return "August";
    case 9: return "September";
    case 10: return "October";
    case 11: return "November";
    case 12: return "December";
    default: return "";
  }
}

Pdate Pdate::operator += (int rhs)
{
 if (rhs > 0)
  while (rhs > 0)
  {
   (*this)++;
   rhs--;
  }
 else if (rhs < 0)
  while (rhs < 0)
  {
   (*this)--;
   rhs++;
  }
 return *this;
}

Pdate Pdate::operator -= (int rhs)
{
 if (rhs > 0)
  while (rhs > 0)
  {
   (*this)--;
   rhs--;
  }
 else if (rhs < 0)
  while (rhs < 0)
  {
   (*this)++;
   rhs++;
  }
 return *this;
}

// external operators (don't need "friend", but it would make sense)

Pdate operator + (const Pdate & lhs, const int & rhs)
{
 Pdate answer = lhs;
 answer += rhs;
 return answer;
}

Pdate operator - (const Pdate & lhs, const int & rhs)
{
 Pdate answer = lhs;
 answer -= rhs;
 return answer;
}

int operator - (const Pdate & lhs, const Pdate & rhs)
{
 // calculate date difference in days.
 // if days are the same, return zero.
 // if left later than right, return positive.
 // if left earlier than right, return negative.
 int days_diff = 0;
 Pdate lowerbound(min(lhs, rhs));
 Pdate upperbound(max(lhs, rhs));
 while (lowerbound < upperbound)
 {
  days_diff++;
  lowerbound++;
 }

 // negative amounts are possible
 if (lhs < rhs)
  days_diff *= -1;

 return days_diff;
}

int CalcAge(Pdate lhs)
{
 // 12/11/1980 to 12/11/1980: 0
 // 12/11/1980 to 13/11/1980: 0
 // 12/11/1980 to 11/11/1981: 0
 // 12/11/1980 to 12/11/1981: 1
 // 12/11/1980 to 13/11/1981: 1

 int c = 0;
 Pdate today = Pdate(Date());
 Pdate a = min(lhs, today);
 Pdate b = max(lhs, today);
 while (a < b)
 {
  a.mod(1, in_years);
  if (a <= b)
   c++;
 }
 return c;
}

int CalcAge(Pdate lhs, Pdate rhs)
{
 // 12/11/1980 to 12/11/1980: 0
 // 12/11/1980 to 13/11/1980: 0
 // 12/11/1980 to 11/11/1981: 0
 // 12/11/1980 to 12/11/1981: 1
 // 12/11/1980 to 13/11/1981: 1

 int c = 0;
 Pdate a = min(lhs, rhs);
 Pdate b = max(lhs, rhs);
 while (a < b)
 {
  a.mod(1, in_years);
  if (a <= b)
   c++;
 }
 return c;
}

string GetTimeSince(Pdate now_date, Pdate then_date)
{
 Pdate g_date = max(now_date, then_date);
 Pdate l_date = min(now_date, then_date);

 int y, m, d;
 y = m = d = 0;

 Pdate t_date;

 t_date = l_date;
 while (t_date <= g_date)
 {
  t_date.year++;
  if (t_date <= g_date)
  {
   y++;
   l_date = t_date;
  }
 }

 t_date = l_date;
 while (t_date <= g_date)
 {
  t_date.mod(+1, in_months);
  if (t_date <= g_date)
  {
   m++;
   l_date = t_date;
  }
 }

 t_date = l_date;
 while (t_date <= g_date)
 {
  t_date.mod(+1, in_days);
  if (t_date <= g_date)
  {
   d++;
   l_date = t_date;
  }
 }

 string answer;

 if (y)
  answer += IntToString(y) + " year" + string(y != 1 ? "s" : "");

 if (m)
 {
  if (y)
   answer += ", ";
  answer += IntToString(m) + " month" + string(m != 1 ? "s" : "");
 }

 if (d) // && !(y && m))
 {
  if (y || m)
   answer += ", ";
  answer += IntToString(d) + " day" + string(d != 1 ? "s" : "");
 }

 return answer;
}

// jhaley 20100928: This is done on almost every Prometheus report, so I made a function for it.
// The first day of the month prior to the given date is returned in pair::first. The last day of the same month is
// returned in pair::second.
pair<Pdate, Pdate> GetPriorMonthDateRange(Pdate for_date)
{
  Pdate begin_date = for_date;
  begin_date.day   = 1;           // first day of this month
  Pdate end_date = begin_date;    // first day of this month
  begin_date.mod(-1, in_months);  // first day of last month
  end_date.mod(-1, in_days);      // last day of last month

  return pair<Pdate, Pdate>(begin_date, end_date);
}

void GetLog(AnsiString filename, fstream * &f)
{
  fstream *new_file = NULL;
  AnsiString app_path;
  AnsiString file_name;

  // DONE error_checking : good idea?
  // - jhaley 20110719: I'd say so judging from the massive "The handle is invalid" errors showing up in CRASHLOG.TXT :)
  // TODO: jhaley - could use FileCache routines for this stuff.

  app_path = ExtractFilePath(ParamStr(0));
  if(app_path[app_path.Length()] == '\\')
    app_path = app_path.SubString(1, app_path.Length()-1);
  file_name = app_path + "\\" + filename;

  new_file = new fstream(file_name.c_str(), ios::out | ios::trunc);
  if(new_file->fail())
  {
    delete new_file; // Fixed memory leak. NB: iostream destructors close files if they're open.
    f = NULL;        // Return NULL on error
  }
  else
    f = new_file;

  // TODO -c investigate : this is being ignored for no apparent reason; we are manually syncing after each write in LogIt, instead
  // f->rdbuf()->pubsetbuf(0, 0); // no output buffer
}

void LogIt(AnsiString filename, string message)
{
#ifdef _DEBUG
  try
  {
    if(log_files_map == NULL) // No log_files_map yet? - jhaley 20110701
      log_files_map = new LogFileMap;
    LogFileMap &log_files = *log_files_map;

    Pstamp curr_timestamp = CurrentPstamp();
    AnsiString fn = (filename!="" ? LowerCase(filename) : AnsiString("debug.log"));
    if (log_files.find(fn) == log_files.end())
    {
      fstream *f = NULL;
      GetLog(fn, f);
      if (f)
        log_files.insert(pair<AnsiString, log_file_item>(fn, log_file_item(f, curr_timestamp)));
    }
    if (log_files.find(fn) != log_files.end())
    {
      if (log_files[fn].file)
      {
        string elapsed = GetTimeSince(curr_timestamp, log_files[fn].last_timestamp);
        *(log_files[fn].file) << "[" << curr_timestamp.OutStamp(datefirst | ymd | yyyy | left_zeros | military) << "] " <<
          (elapsed != "" ? "[" + elapsed + "] " : string("")) <<
          ReplaceStringWithString(StripTrailing(message, "\n"), "\n\n", "") << "\n";
        log_files[fn].last_timestamp = curr_timestamp;
        log_files[fn].file->rdbuf()->pubsync(); // shouldn't be necessary!  See above comment (in GetLog(...))
      }
    }
    // monolithic log, so you can see all messages merged together, without cross-referencing logs when dealing with
    // interrelated units
    if (filename != "everything.log")
      LogIt("everything.log", string(filename.c_str()) + ": " + message);
  }
  catch(...) // jhaley 20110718 - Absolutely no throws out of this function. Need exception-safe error reporting.
  {
    // TODO: reporting something important has failed. To whom do we report the failure to report?
  }
#endif
}

void CloseLogs()
{
  if(!log_files_map) // jhaley 20110701
    return;

  LogFileMap &log_files = *log_files_map;

  for(LogFileMap::iterator itr = log_files.begin(); itr != log_files.end(); ++itr)
  {
    if (itr->second.file)
      delete itr->second.file; // jhaley 20110719: Don't leak; and also, it will close the file too if it's open.
  }
  log_files.clear(); // jhaley 20110718: clear map so that this is guaranteed to be once-only.
}

// returns a friendly string representing the difference between two dates 
bool FriendlyDiffDate(string anchor_datestring, string relative_datestring, string &result, string relative_suffix, bool force_relative_syntax)
{
  bool to_return = false;
  string class_name = "util";
  AV_TRY
    LogIt("util.log",
       "anchor=" + anchor_datestring + "\n" +
       "relative=" + relative_datestring + "\n" +
       "result=" + result + "\n"
       "suffix=" + relative_suffix + "\n"
       "force=" + BoolToBoolString(force_relative_syntax, true_false) + '\n');
    result = "";
    Pdate today(Date());
    LogIt("util.log", "checkpoint 1\n");
    Pdate anchor_date(anchor_datestring, global_mode);
    LogIt("util.log", "checkpoint 2\n");
    bool from_today = (today == anchor_date && !force_relative_syntax);
    LogIt("util.log", "checkpoint 3: from_today=" + BoolToBoolString(from_today, true_false) + '\n');
    bool have_sfx = relative_suffix != "";
    LogIt("util.log", "checkpoint 4: have_sfx=" + BoolToBoolString(have_sfx, true_false) + '\n');
    Pdate relative_date(relative_datestring, global_mode);
    LogIt("util.log", "checkpoint 5\n");
    if (anchor_date.IsValidDate() && relative_date.IsValidDate())
    {
     LogIt("util.log", "checkpoint 6\n");
     // hey, see, i was feeling polite ... this could be move to a slightly prettier version of that function that -assumes- we're talking about 'today'
     // but what if we were talking about some random date? then we'd want "before" and "after" rather than "ago" and "hence", and "today", "tomorrow", and "yesterday" would be far messier. ("that day", "the day before", "the day after"?)
     // i don't want to build right now.
     if (anchor_date == relative_date)
     {
       if (from_today)
         result = "today";
       else
       {
         result = "the same day";
         if (have_sfx)
           result += " as " + relative_suffix;
       }
     }
     else if (anchor_date == relative_date + 1)
     {
       if (from_today)
         result = "yesterday";
       else
       {
         result = "the day before";
         if (have_sfx)
           result += " " + relative_suffix;
       }
     }
     else if (anchor_date == relative_date - 1)
     {
       if (from_today)
         result = "tomorrow";
       else
       {
         result = "the day after";
         if (have_sfx)
           result += " " + relative_suffix;
       }
     }
     else if (anchor_date > relative_date)
     {
      // previously these were all written like:
      //result = GetTimeSince(anchor_date, relative_date) + (from_today ? string(" ago") : (" prior" + (have_sfx ? " to " + relative_suffix : string(""))));
      // which worked fine ... most of the time ... and occasionally produced Access Violations for no good reason.  So we write it in expanded form:
      result = GetTimeSince(anchor_date, relative_date);
      if (from_today)
        result += " ago";
      else
      {
        result += " prior";
        if (have_sfx)
          result += " to " + relative_suffix;
      }
     }
     else if (anchor_date < relative_date)
      result = GetTimeSince(anchor_date, relative_date) + (from_today ? string(" from now") : (" since" + (have_sfx ? " " + relative_suffix : string(""))));
     LogIt("util.log", "checkpoint 7\n");
     to_return = true;
    }
    LogIt("util.log", "checkpoint 8\n");
  AV_CATCH_SILENT
  return to_return;
}

//TIME----------------------------------------------------------------------

Ptime::Ptime ()
{
 hour = 0;
 minute = 0;
 second = 0;
 millisecond = 0;
}

Ptime::Ptime (const string &incoming, int mode)
{
 InTime (incoming, mode);
}

Ptime::Ptime (TDateTime incoming)
{
 InTime (incoming);
}

void Ptime::InTime (TDateTime incoming)
{
 InTime (incoming.FormatString("h:n:s").c_str(), withsec | military);
}

void Ptime::InTime (const string &incoming, int mode)
{
 int  h = 0;
 int  m = 0;
 int  s = 0;

 //take three chunks out
 septhree (incoming, timechar, h, m, s);

 //determine military time internally
 // guess whether they mean ampm or not by looking for a p, P, a, or A ...
 if (incoming.find_first_of("pPaA") != string::npos)
  mode = ampm;

 if (!(mode & military))
 {
  h = h % 12;
  if (incoming.find_first_of("pP") != string::npos)
    h += 12;
 }

 //store locally
 hour = h;
 minute = m;
 second = s;
 millisecond = 0; // FIXME: can't set milliseconds from here...
}
void Ptime::InTime (const Ptime & incoming)
{
 hour        = incoming.hour;
 minute      = incoming.minute;
 second      = incoming.second;
 millisecond = incoming.millisecond;
}

bool Ptime::IsValidTime () const
{
 if (hour        >  23 || hour        < 0) return false;
 if (minute      >  59 || minute      < 0) return false;
 if (second      >  59 || second      < 0) return false;
 if (millisecond > 999 || millisecond < 0) return false;
 return true;
}

string Ptime::OutTime (int mode) const
{
 string answer = "";
 if (mode & military)
 {
  if (mode & left_zeros)
   answer = twodigit(hour);
  else
   answer = IntToString(hour);
  answer += timechar + twodigit(minute);
  if (!(mode & withoutsec))
   answer += timechar + twodigit(second);
 }
 else
 {
  int h = hour;
  bool pm = false;
  if (h > 11)
  {
   pm = true;
   h -= 12;
  }
  if (!h) 
   h = 12;
  if (mode & left_zeros)
   answer = twodigit(h);
  else
   answer = IntToString(h);
  answer += timechar + twodigit(minute);
  if (!(mode & withoutsec))
   answer += timechar + twodigit(second);
  answer += (pm) ? " pm" : " am";
 }
 return answer;
}

TDateTime Ptime::OutTime () const
{
 TDateTime to_return((unsigned short)hour, (unsigned short)minute,
                     (unsigned short)second, (unsigned short)millisecond);
 return to_return;
}

bool Ptime::operator < (const Ptime & rhs) const
{
 if (hour < rhs.hour) return true;
 if (hour > rhs.hour) return false;
 //same hour
 if (minute < rhs.minute) return true;
 if (minute > rhs.minute) return false;
 //same minute
 if (second < rhs.second) return true;
 if (second > rhs.second) return false;
 //same second
 if (millisecond < rhs.millisecond) return true;
 //doesn't matter anymore
 return false;
}

bool Ptime::operator <= (const Ptime & rhs) const
{
 if (hour < rhs.hour) return true;
 if (hour > rhs.hour) return false;
 //same hour
 if (minute < rhs.minute) return true;
 if (minute > rhs.minute) return false;
 //same minute
 if (second < rhs.second) return true;
 if (second > rhs.second) return false;
 //same second
 if (millisecond <= rhs.millisecond) return true;
 return false;
}

bool Ptime::operator > (const Ptime & rhs) const
{
 if (hour > rhs.hour) return true;
 if (hour < rhs.hour) return false;
 //same hour
 if (minute > rhs.minute) return true;
 if (minute < rhs.minute) return false;
 //same minute
 if (second > rhs.second) return true;
 if (second < rhs.second) return false;
 //same second
 if (millisecond > rhs.millisecond) return true;
 //doesn't matter anymore
 return false;
}

bool Ptime::operator >= (const Ptime & rhs) const
{
 if (hour > rhs.hour) return true;
 if (hour < rhs.hour) return false;
 //same hour
 if (minute > rhs.minute) return true;
 if (minute < rhs.minute) return false;
 //same minute
 if (second > rhs.second) return true;
 if (second < rhs.second) return false;
 //same second
 if (millisecond >= rhs.millisecond) return true;
 //doesn't matter anymore
 return false;
}

bool Ptime::operator != (const Ptime & rhs) const
{
 return (hour != rhs.hour || minute != rhs.minute ||
         second != rhs.second || millisecond != rhs.millisecond);
}

bool Ptime::operator == (const Ptime & rhs) const
{
 return (hour == rhs.hour && minute == rhs.minute &&
         second == rhs.second && millisecond == rhs.millisecond);
}

Ptime Ptime::operator ++ (int)
{
 this->mod(1, in_minutes);
 return (*this);
}

Ptime Ptime::operator -- (int)
{
 this->mod(-1, in_minutes);
 return (*this);
}

int Ptime::mod (int p_distance, int p_metric)
{
 int rolled = 0;
 if (p_metric & in_msec)
 {
  while(p_distance)
  {
   if(p_distance > 0)
   {
    millisecond++;
    if (millisecond > 999)
    {
     second++;
     if (second > 59)
     {
      minute++;
      if (minute > 59)
      {
       hour++;
       if(hour > 23)
       {
        rolled++;
        hour = 0;
       }
       minute = 0;
      }
      second = 0;
     }
     millisecond = 0;
    }
    p_distance--;
   }
   else
   {
    millisecond--;
    if (millisecond < 0)
    {
     second--;
     if (second < 0)
     {
      minute--;
      if(minute < 0)
      {
       hour--;
       if(hour < 0)
       {
        rolled--;
        hour = 23;
       }
       minute = 59;
      }
      second = 59;
     }
     millisecond = 999;
    }
    p_distance++;
   }
  }
 }
 else
 if (p_metric & in_seconds)
 {
  while (p_distance)
  {
   if (p_distance > 0)
   {
    second++;
    if (second > 59)
    {
     minute++;
     if (minute > 59)
     {
      hour++;
      if (hour > 23)
      {
       rolled++;
       hour = 0;
      }
      minute = 0;
     }
     second = 0;
    }
    p_distance--;
   }
   else
   {
    second--;
    if (second < 0)
    {
     minute--;
     if (minute < 0)
     {
      hour--;
      if (hour < 0)
      {
       rolled--;
       hour = 23;
      }
      minute = 59;
     }
     second = 59;
    }
    p_distance++;
   }
  }
 }
 else
 if (p_metric & in_minutes)
 {
  while (p_distance)
  {
   if (p_distance > 0)
   {
    minute++;
    if (minute > 59)
    {
     hour++;
     if (hour > 23)
     {
      rolled++;
      hour = 0;
     }
     minute = 0;
    }
    p_distance--;
   }
   else
   {
    minute--;
    if (minute < 0)
    {
     hour--;
     if (hour < 0)
     {
      rolled--;
      hour = 23;
     }
     minute = 59;
    }
    p_distance++;
   }
  }
 }
 else
 if (p_metric & in_hours)
 {
  while (p_distance)
  {
   if (p_distance > 0)
   {
    hour++;
    if (hour > 23)
    {
     rolled++;
     hour = 0;
    }
    p_distance--;
   }
   else
   {
    hour--;
    if (hour < 0)
    {
     rolled--;
     hour = 23;
    }
    p_distance++;
   }
  }
 }
 return rolled;
}

int Ptime::mod (const Ptime & p_distance)
{
 int rolled = 0;
 rolled += this->mod(p_distance.hour,        in_hours);
 rolled += this->mod(p_distance.minute,      in_minutes);
 rolled += this->mod(p_distance.second,      in_seconds);
 rolled += this->mod(p_distance.millisecond, in_msec);
 return rolled;
}

int operator - (const Ptime & lhs, const Ptime & rhs)
{
 // calculate time difference in seconds.
 // if times are the same, return zero.
 // if left later than right, return positive.
 // if left earlier than right, return negative.
 int mseconds_diff = 0;
 Ptime lowerbound(min(lhs, rhs));
 Ptime upperbound(max(lhs, rhs));

 mseconds_diff += 3600 * 1000 * (upperbound.hour        - lowerbound.hour);
 mseconds_diff +=   60 * 1000 * (upperbound.minute      - lowerbound.minute);
 mseconds_diff +=        1000 * (upperbound.second      - lowerbound.second);
 mseconds_diff +=               (upperbound.millisecond - lowerbound.millisecond);

 // negative amounts are possible
 if (lhs < rhs)
  mseconds_diff *= -1;

 return mseconds_diff; // jhaley: WARNING: *1000 compared to Prometheus!
}

string GetTimeSince(Ptime now_time, Ptime then_time)
{
 Ptime g_time = max(now_time, then_time);
 Ptime l_time = min(now_time, then_time);

 int h, m, s, ms;
 h = m = s = ms = 0;

 Ptime t_time;

 t_time = l_time;
 while (t_time <= g_time)
 {
  t_time.hour++;
  if (t_time <= g_time)
  {
   h++;
   l_time = t_time;
  }
 }

 t_time = l_time;
 while (t_time <= g_time)
 {
  t_time.mod(+1, in_minutes);
  if (t_time <= g_time)
  {
   m++;
   l_time = t_time;
  }
 }

 t_time = l_time;
 while (t_time <= g_time)
 {
  t_time.mod(+1, in_seconds);
  if (t_time <= g_time)
  {
   s++;
   l_time = t_time;
  }
 }

 t_time = l_time;
 while (t_time <= g_time)
 {
  t_time.mod(+1, in_msec);
  if (t_time <= g_time)
  {
   ms++;
   l_time = t_time;
  }
 }

 string answer;

 if (h)
  answer += IntToString(h) + " hour" + string(h != 1 ? "s" : "");

 if (m)
 {
  if (h)
   answer += ", ";
  answer += IntToString(m) + " minute" + string(m != 1 ? "s" : "");
 }

 if (s) // && !(h && m))
 {
  if (h || m)
   answer += ", ";
  answer += IntToString(s) + " second" + string(s != 1 ? "s" : "");
 }

 if (ms)
 {
  if (h || m || s)
   answer += ", ";
  answer += IntToString(ms) + " millisecond" + string(ms != 1 ? "s" : "");
 }

 return answer;
}
//STAMP---------------------------------------------------------------------

Pstamp::Pstamp () : Pdate (), Ptime ()
{
}

Pstamp::Pstamp (const string &incoming, int mode)
{
 InStamp (incoming, mode);
}

Pstamp::Pstamp (TDateTime incoming)
{
 InStamp(incoming);
}

void Pstamp::InStamp (TDateTime incoming)
{
 InStamp(incoming.FormatString("m/d/yyyy h:n:s").c_str(), mdy | yyyy | datefirst | withsec);
}

void Pstamp::InStamp (const string &incoming, int mode)
{
 unsigned int splitarea;
 string work_str = StripTrailing(StripLeading(incoming, " "), " ");
 string d = "";
 string t = "";
 if (mode & datefirst)
 {
  splitarea = work_str.find_first_of(" ",0);
  if (splitarea != string::npos)
  {
   d = work_str.substr(0, splitarea);
   t = work_str.substr(splitarea);
   InDate (d, mode);
   InTime (t, mode);
  }
 }
 else
 {
  splitarea = work_str.find_last_of(" ", work_str.length() - 1);
  if (splitarea != string::npos)
  {
   t = work_str.substr(0, splitarea);
   d = work_str.substr(splitarea);
   InDate (d, mode);
   InTime (t, mode);
  }
 }
}

bool Pstamp::IsValidStamp () const
{
 bool isgood = IsValidDate() && IsValidTime ();
 return isgood;
}

string Pstamp::OutStamp (int mode) const
{
 string d = OutDate (mode);
 string t = OutTime (mode);
 string answer = "";
 if (mode & datefirst)
   answer = d + string(" ") + t;
 else
   answer = t + string(" ") + d;
 return answer;
}

bool Pstamp::operator < (const Pstamp & rhs) const
{
 if (Pdate::operator < (rhs)) return true;
 if (Pdate::operator > (rhs)) return false;
 //same date
 if (Ptime::operator < (rhs)) return true;
 //doesn't matter
 return false;
}

bool Pstamp::operator <= (const Pstamp & rhs) const
{
 if (Pdate::operator < (rhs)) return true;
 if (Pdate::operator > (rhs)) return false;
 //same date
 if (Ptime::operator <= (rhs)) return true;
 //doesn't matter
 return false;
}

bool Pstamp::operator > (const Pstamp & rhs) const
{
 if (Pdate::operator > (rhs)) return true;
 if (Pdate::operator < (rhs)) return false;
 //same date
 if (Ptime::operator > (rhs)) return true;
 //doesn't matter
 return false;
}

bool Pstamp::operator >= (const Pstamp & rhs) const
{
 if (Pdate::operator > (rhs)) return true;
 if (Pdate::operator < (rhs)) return false;
 //same date
 if (Ptime::operator >= (rhs)) return true;
 //doesn't matter
 return false;
}

bool Pstamp::operator != (const Pstamp & rhs) const
{
 if (Pdate::operator != (rhs) || Ptime::operator != (rhs))
  return true;
 else return false;
}

bool Pstamp::operator == (const Pstamp & rhs) const
{
 if (Pdate::operator == (rhs) && Ptime::operator == (rhs))
  return true;
 else return false;
}

int Pstamp::mod (int p_distance, int p_metric)
{
 int rolled_days = 0;
 if (p_metric & (in_msec | in_seconds | in_minutes | in_hours))
 {
  rolled_days = Ptime::mod(p_distance, p_metric);
 }
 else
 if (p_metric & (in_days | in_weeks | in_months | in_years))
 {
  Pdate::mod(p_distance, p_metric);
 }
 // make up for time doing stuff by pushing that over to the stamp part
 Pdate::mod(rolled_days, in_days);
 return 0;
}

int Pstamp::mod (const Pstamp & p_distance)
{
 // TODO :
 mod (Ptime::mod(Ptime(p_distance)), in_days);
 Pdate::mod(Pdate(p_distance));
 return 0;
}

int Pstamp::mod (const Pdate & p_distance)
{
 // TODO :
 Pdate::mod(p_distance);
 return 0;
}

int Pstamp::mod (const Ptime & p_distance)
{
 // TODO :
 mod (Ptime::mod(p_distance), in_days);
 return 0;
}

int operator - (const Pstamp & lhs, const Pstamp & rhs)
{
 // calculate time difference in seconds.
 // if times are the same, return zero.
 // if left later than right, return positive.
 // if left earlier than right, return negative.

 // NB: must divide out milliseconds or this can only do a difference of 49
 // days at most, which is not enough to be useful at all.

 int seconds_diff = 0;
 int ptime_diff = (Ptime(lhs) - Ptime(rhs)) / 1000;
 int pdate_diff = Pdate(lhs) - Pdate(rhs);
 seconds_diff = ptime_diff + (24*60*60 * pdate_diff);

 return seconds_diff;
}

string GetTimeSince(Pstamp now_stamp, Pstamp then_stamp)
{
 Pstamp g_stamp = max(now_stamp, then_stamp);
 Pstamp l_stamp = min(now_stamp, then_stamp);

 int y, mo, d, h, mn, s, ms;
 y = mo = d = h = mn = s = ms = 0;

 Pstamp t_stamp;

 t_stamp = l_stamp;
 while (t_stamp <= g_stamp)
 {
  t_stamp.year++;
  if (t_stamp <= g_stamp)
  {
   y++;
   l_stamp = t_stamp;
  }
 }

 t_stamp = l_stamp;
 while (t_stamp <= g_stamp)
 {
  t_stamp.mod(+1, in_months);
  if (t_stamp <= g_stamp)
  {
   mo++;
   l_stamp = t_stamp;
  }
 }

 t_stamp = l_stamp;
 while (t_stamp <= g_stamp)
 {
  t_stamp.mod(+1, in_days);
  if (t_stamp <= g_stamp)
  {
   d++;
   l_stamp = t_stamp;
  }
 }

 while (t_stamp <= g_stamp)
 {
  t_stamp.mod(+1, in_hours);
  if (t_stamp <= g_stamp)
  {
   h++;
   l_stamp = t_stamp;
  }
 }

 t_stamp = l_stamp;
 while (t_stamp <= g_stamp)
 {
  t_stamp.mod(+1, in_minutes);
  if (t_stamp <= g_stamp)
  {
   mn++;
   l_stamp = t_stamp;
  }
 }

 t_stamp = l_stamp;
 while (t_stamp <= g_stamp)
 {
  t_stamp.mod(+1, in_seconds);
  if (t_stamp <= g_stamp)
  {
   s++;
   l_stamp = t_stamp;
  }
 }

 t_stamp = l_stamp;
 while (t_stamp <= g_stamp)
 {
  t_stamp.mod(+1, in_msec);
  if (t_stamp <= g_stamp)
  {
   ms++;
   l_stamp = t_stamp;
  }
 }

 string answer;

 if (y)
  answer += IntToString(y) + " year" + string(y != 1 ? "s" : "");

 if (mo)
 {
  if (y)
   answer += ", ";
  answer += IntToString(mo) + " month" + string(mo != 1 ? "s" : "");
 }

 if (d) //&& !(y && mo))
 {
  if (y || mo)
   answer += ", ";
  answer += IntToString(d) + " day" + string(d != 1 ? "s" : "");
 }

 if (h)
 {
  if (y || mo || d)
   answer += ", ";
  answer += IntToString(h) + " hour" + string(h != 1 ? "s" : "");
 }

 if (mn)
 {
  if (y || mo || d || h)
   answer += ", ";
  answer += IntToString(mn) + " minute" + string(mn != 1 ? "s" : "");
 }

 if (s) // && !(h && mn))
 {
  if (y || mo || d || h || mn)
   answer += ", ";
  answer += IntToString(s) + " second" + string(s != 1 ? "s" : "");
 }

 if (ms)
 {
  if (y || mo || d || h || mn || s)
   answer += ", ";
  answer += IntToString(ms) + " millisecond" + string(s != 1 ? "s" : "");
 }

 return answer;
}

//END DATE TIME TIMESTAMP CLASS DEFINITIONS---------------------------------

//START STRING MANIPULATION FUNCTIONS---------------------------------------

//Like performs a basic regular expression check. A is an expression which
//must be found in B, and match B entirely. If B is longer than what A is
//mean to express, LikeString returns false. The same goes for A. The
//two special characters (matchany, matchone) are #define'd at the top of
//the .h file. They are set to % and _, like interbase. If they were
//changed to * and ?, this function would act like an MS-DOS string matching
//function on the command line.
bool LikeString (const string &a, const string &b)
{
 bool does_match = true;
 unsigned int i = 0;
 bool all_b_used = false;
 while (i < a.length() && i < b.length() && does_match)
 {
  if (a[i] == match_any)
  {
   //last character is a %, don't recurse
   if (i == a.length() - 1)
   {
    i++; //goes to the end of a, gets out of the loop
    all_b_used = true;
   }
   else
   {
    bool matching_sub = false;
    for (unsigned int j = i; j < b.length(); j++)
    {
     string subquery = a.substr(i + 1);
     string subthing = b.substr(j);
     if (LikeString(subquery, subthing))
      matching_sub = true;
    }
    if (!matching_sub) does_match = false;
    i = a.length();
    all_b_used = true;
   }
  }
  else if (a[i] == match_one)
  {
   i++;
  }
  else if (a[i] == b[i])
  {
   i++;
  }
  else
  {
   does_match = false;
  }
 }
 //make sure all of the matched expression is used up in matching
 if (!all_b_used && i != b.length())
  does_match = false;
 //make sure all of the expression is used up, except for trailing %
 if (i != a.length() && a.find_first_not_of("%", i) != string::npos)
  does_match = false;
 return does_match;
}

//SentenceString attempts to capitalize strings in a way that makes sense
//in the context of a sentence, that is, any first character following a
//period, exclamation mark, question mark, or double quote, and any number
//of white spaces.
string SentenceString (const string &incoming)
{
 string answer = LowercaseString(incoming);
 char prevchar = '.';
 for (unsigned int i = 0; i < answer.length(); i++)
 {
  if ((prevchar == '.' || prevchar == '!' || prevchar == '?' || prevchar == '\"') &&
      (answer[i] >= 'a' && answer[i] <= 'z'))
   answer[i] += ('A' - 'a');
  if (answer[i] != ' ' && answer[i] != '\n' && answer[i] != '\t' && answer[i] != '\a' &&
      answer[i] != '\b' && answer[i] != '\f' && answer[i] != '\r' && answer[i] != '\v')
   prevchar = answer[i];
 }

 answer = ReplaceStringWithString(answer, " i ", " I ");
 return answer;
}

string SpecialNameString (const string &incoming)
{
 // look for ^O'xxxx, ^Macxxxx, ^Mcxxxx, and ^I., ^Ii., ^Iii., ^Iv., ^V., ^Vi., etc.
 // -->      ^O'Xxxx, ^MacXxxx, ^McXxxx, and ^I., ^II., ^III., ^IV., ^V., ^VI., etc.
 // where ^ is the beginning of a chunk, and . is whitespace.
 // ... or something like that.

 // heh, let's add a first space, so we can look for spaces ... yeah, that sounds good.
 // and then take it off. yup. that'll be fine, right? what about the whole 'single blank
 // space' thingie? that's an ordering question, yup.
 // TODO :
 string answer;
 return answer;
}

// Transformation function that does not transform :-)
string RawString (const string &incoming)
{
  return incoming;
}

//PrettyString will uppercase the first letter of every distinct word, as
//defined by a white space, slash, or dash.
string PrettyString (const string &incoming)
{
 string answer = LowercaseString(incoming);
 char prevchar = ' ';
 for (unsigned int i = 0; i < answer.length(); i++)
 {
  if ((prevchar == ' ' || prevchar == '/' || prevchar == '-' || prevchar == '(' || prevchar == ')' || prevchar == '.') &&
      (answer[i] >= 'a' && answer[i] <= 'z'))
   answer[i] += ('A' - 'a');
  prevchar = answer[i];
 }
 return answer;
}

//Lowercase every character of a string.
string LowercaseString (const string &incoming)
{
  string answer = incoming;
  unsigned int len = answer.length();
  for (unsigned int i = 0; i < len; i++)
  {
    if (answer[i] >= 'A' && answer[i] <= 'Z')
      answer[i] -= ('A' - 'a');
  }
  return answer;
}

// "blah" becomes "%b%l%a%h%" ... dropped into a like clause in stupid cases like
// insurance policies where they're really inconsistent about punctuation and we want to
// return too many matches rather than too few....
string PowerSearchString (const string &incoming)
{
   string result = "%";
   for (unsigned int i = 0; i < incoming.length(); i++)
   {
      result = result + incoming[i] + "%";
   }
   return result;
}

// "blah" becomes "b% l% a% h%" ... dropped into a like clause to attempt to match
// initials... eg they put in OHCA and we want to return Oklahoma Health Care Authority
// this one matches the first word beginning at the beginning of the string
string InitialsSearchString1 (const string &incoming)
{
   string result = "";
   for (unsigned int i = 0; i < incoming.length(); i++)
   {
     if (incoming[i] != ' ')
       result = result + incoming[i] + "% ";
     else
       result = result + "%";
   }
   result = result.substr(0, result.length()-1);
   return result;
}

// "blah" becomes "% b% l% a% h%" ... dropped into a like clause to attempt to match
// initials... eg they put in OHCA and we want to return Oklahoma Health Care Authority
// this one matches the first word starting anywhere in the middle of the string
string InitialsSearchString2 (const string &incoming)
{
   string result = "% ";
   for (unsigned int i = 0; i < incoming.length(); i++)
   {
     if (incoming[i] != ' ')
       result = result + incoming[i] + "% ";
     else
       result = result + "%";
   }
   result = result.substr(0, result.length()-1);
   return result;
}

//Uppercase every character of a string.
string UppercaseString(const string &incoming)
{
  string answer = incoming;
  unsigned int len = answer.length();
  for (unsigned int i = 0; i < len; i++)
  {
    if (answer[i] >= 'a' && answer[i] <= 'z')
      answer[i] += ('A' - 'a');
  }
  return answer;
}

//Uppercase the first letter, without touching the rest
string UppercaseFirstChar(const string &incoming)
{
 string answer = incoming;
 if (!answer.empty())
  if (answer[0] >= 'a' && answer[0] <= 'z')
   answer[0] += ('A' - 'a');
 return answer;
}

//Lowercase the first letter, without touching the rest
string LowercaseFirstChar(const string &incoming)
{
 string answer = incoming;
 if (!answer.empty())
  if (answer[0] >= 'A' && answer[0] <= 'Z')
   answer[0] -= ('A' - 'a');
 return answer;
}

//replace any occurence of a certain character in a string into another character.
string ReplaceCharWithChar(const string &incoming, char from, char to)
{
  string answer = "";
  answer = incoming;
  if (from != to)
  {
    unsigned int match = answer.find(from, 0);
    while (match != string::npos)
    {
      answer[match] = to;
      match = answer.find(from, match);
    }
  }
  return answer;
}

//replace any occurence of a string inside a string with another string.
//correctness verified (but not since Paul added recursive_collapsing, really.  *cough*
string ReplaceStringWithString(const string &incoming, const string &from, const string &to, bool recursive_collapsing)
{
  if(from.length() == 0 || from == to) return incoming; // nothing to do
  if(from.length() == 1 && to.length() == 1)
    return ReplaceCharWithChar(incoming, from[0], to[0]); // faster

  if (recursive_collapsing && (to.find(from, 0) != string::npos))
    throw ("ReplaceStringWithString detected a request that would result in an infinite loop.  Aborted.");
  string answer = "";
  unsigned int match = incoming.find(from, 0);
  unsigned int len = incoming.length();
  unsigned int fromlen = from.length();
  unsigned int lastbeg = 0;
  bool done = false;
  while (match != string::npos && !done)
  {
    answer += incoming.substr(lastbeg, match-lastbeg);
    if (recursive_collapsing) // skip over things that would cause multiple matches
      while (incoming.substr(match+1, from.length())==from)
        match += 1;
    answer += to;
    if (match + fromlen == len)
    {
      done = true;
    }
    else
    {
      lastbeg = match + fromlen;
      match = incoming.find(from, lastbeg);
    }
  }
  if (!done) answer += incoming.substr(lastbeg);
  // next bit's a hack and should probably be a while loop outside the stuff above, but ...
  // ReplaceStringWithString("ABABBA", "BA", "A", true)
  // returns AABA rather than the AAA it should (because we're only looking for matches forward, not where we've been...
  while (recursive_collapsing && answer.find(from) != string::npos)
    answer = ReplaceStringWithString(answer, from, to, recursive_collapsing);
  return answer;
}

//replace any occurrence of any one of a group of characters with a string.
//correctness verified
string ReplaceAnyCharWithString(const string &incoming, const string &characters, const string &to)
{
  string answer;
  unsigned int match = incoming.find_first_of(characters, 0);
  unsigned int len = incoming.length();
  unsigned int fromlen = 1;
  unsigned int lastbeg = 0;
  bool done = false;
  while (match != string::npos && !done)
  {
    answer += incoming.substr(lastbeg, match-lastbeg);
    answer += to;
    if (match + fromlen == len)
    {
      done = true;
    }
    else
    {
      lastbeg = match + fromlen;
      match = incoming.find_first_of(characters, lastbeg);
    }
  }
  if (!done) answer += incoming.substr(lastbeg);
  return answer;
}

// replaces occurrences of whole words with other strings, from a map.  used by FormatAddress()
// I think it should handle recursive cases thrown at it, but I didn't explicitly test that.
string ReplaceWordsWithWords(const string &incoming, const map<string, string> &replacement_map)
{
   string result_string;
   string split_chars = " `~=_+!@#$%^&*()[]\\;',./{}|:\"<>?\n\t"; // - excluded on purpose
   unsigned int word_begin = incoming.find_first_not_of(split_chars, 0);
   unsigned int word_end = incoming.find_first_of(split_chars, word_begin);
   result_string = incoming.substr(0, word_begin); // initial chunk, if string starts with stripped characters
   while (word_end != string::npos)
   {
     string word = incoming.substr(word_begin, word_end - word_begin);
     map<string, string>::const_iterator found_word = replacement_map.find(word);
     if (found_word != replacement_map.end())
       result_string += found_word->second; // found a match, replace it
     else
       result_string += word; // no match, keep existing word
     // find next word
     word_begin = incoming.find_first_not_of(split_chars, word_end);
     if (word_begin == string::npos) // only stripped characters remain
       result_string += incoming.substr(word_end);
     else // at least one more word
       result_string += incoming.substr(word_end, word_begin - word_end); // add stripped characters
     word_end = incoming.find_first_of(split_chars, word_begin);
   }
   if (word_begin != string::npos) // one last word
   {
     string word = incoming.substr(word_begin);
     map<string, string>::const_iterator found_word = replacement_map.find(word);
     if (found_word != replacement_map.end())
       result_string += found_word->second; // found a match, replace it
     else
       result_string += word; // no match, keep existing word
   }
   return result_string;
}

//remove any occurrence of any character in a group of characters from a string.
//correctness verified
string StripAll(const string &incoming, const string &characters)
{
  string answer = "";
  if (incoming.length())
  {
    unsigned int match = incoming.find_first_not_of(characters, 0);
    unsigned int until;
    bool done = false;
    while (match != string::npos && !done)
    {
      until = incoming.find_first_of (characters, match);
      if (until != string::npos)
      {
        answer += incoming.substr(match, until-match);
        match = incoming.find_first_not_of(characters, until);
      }
      else
      {
        answer += incoming.substr(match);
        done = true;
      }
    }
  }
  return answer;
}

//remove all identical characters from the leading edge of a string if the
//first character matches a character in the supplied set.
//correctness verified
string StripLeading(const string &incoming, const string &characters)
{
  string answer = "";
  if (incoming.length())
  {
    if (incoming.find_first_of(characters, 0) == 0)
    {
      string leading = incoming.substr(0,1);
      unsigned int match = incoming.find_first_not_of(leading, 0);
      if (match != string::npos)
        answer = incoming.substr(match);
    }
    else answer = incoming;
  }
  return answer;
}

//removes all identical characters from the end of a string if the last character
//matches a character in the supplied set
//correctness verified
string StripTrailing(const string &incoming, const string &characters)
{
  string answer = "";
  if (incoming.length())
  {
    if (incoming.find_last_of(characters, incoming.length() - 1) == incoming.length() - 1)
    {
      string trailing = incoming.substr(incoming.length() - 1,1);
      unsigned int match = incoming.find_last_not_of(trailing, incoming.length() - 1);
      if (match != string::npos)
        answer = incoming.substr(0, match + 1);
    }
    else answer = incoming;
  }
  return answer;
}

// Pad a string with the given character, to the given length.  You can pad on the left, on the
// right, or both (center given text).  If final_size is less than the length of the incoming
// string, the string will be truncated on the left, right, or (not yet implemented) both sides,
// depending on how_to_pad.
string PadString(const string &incoming, pad_string_types how_to_pad, char pad_with, int final_size)
{ // Paul's code
  string result = incoming;
  switch (how_to_pad)
  {
    case pad_left:
    {
      int diff = final_size - incoming.size();
      if (diff > 0) // we've got padding to do!
      {
        string pad = "";
        pad.resize(diff, pad_with);
        result = pad + incoming;
      }
      else if (diff < 0) // we've got truncation to do!
      {
        result = incoming.substr(abs(diff));
      }
      break;
    }
    case pad_right:
    {
      int diff = final_size - incoming.size();
      if (diff > 0) // we've got padding to do!
      {
        string pad = "";
        pad.resize(diff, pad_with);
        result = incoming + pad;
      }
      else if (diff < 0) // we've got truncation to do!
      {
        result = incoming.substr(0, final_size);
      }
      break;
    }
    case pad_to_center:
    {
      int diff = final_size - incoming.size();
      if (diff > 0) // we've got padding to do!
      {
        string lpad = "", rpad = "";
        lpad.resize(int(diff / 2.0), pad_with);
        rpad.resize(int(diff / 2.0 + 0.5), pad_with);
        result = lpad + incoming + rpad;
      }
      else if (diff < 0) // we've got truncation to do!
      {
        // truncate evenly from both sides?  I'm feeling lazy...
        /* doing nothing might actually be a desired (at least default) behavior ... I would not expect
           a padding function to truncate if it's already longer than what I specified ... maybe as an
           optional extra parameter though.  but the stuff above truncates left or right based on how_to_pad
           which still seems contrary to the name.  I mean, it's called PadString, not FitString....  :-\  */
      }
      break;
    }
  }

  return result;
}

// jhaley 20110412: Hard to believe this didn't exist already O_o
// Collapses consecutive space characters, and also changes tabs into single spaces. Line breaks are not affected.
string CollapseSpaces(const string &input)
{
  string return_str;
  size_t i, len = input.length();
  bool on_space = false;

  for (i = 0; i < len; i++)
  {
    if (input[i] == ' ' || input[i] == '\t')
    {
      if (!on_space) // Not sitting on a sequence of spaces currently?
      {
        return_str += ' ';
        on_space = true;   // We are now.
      }
      // Otherwise this is a consecutive space; do nothing
    }
    else
    {
      return_str += input[i];
      on_space = false;    // Any other character breaks the run of whitespace.
    }
  }

  return return_str;
}

//END STRING MANIPULATION FUNCTIONS-----------------------------------------

//START FORMAT MANIPULATION FUNCTIONS---------------------------------------

//convert 1,2,4 bytes of character data into integer value (binary)
string ConvertBinary(const string &incoming)
{
        string answer = "";
        unsigned int len = incoming.length();
        //assuming that an int is 4 bytes wide, we pad the data to the
        //left with char 0 and assume the result is to be an unsigned int
        char bytearray[4];

        if (len == 1)
        {
                bytearray[0] = 0;
                bytearray[1] = 0;
                bytearray[2] = 0;
                bytearray[3] = incoming[0];
        }
        if (len == 2)
        {
                bytearray[0] = 0;
                bytearray[1] = 0;
                bytearray[2] = incoming[0];
                bytearray[3] = incoming[1];
        }
        if (len == 4)
        {
                bytearray[0] = incoming[0];
                bytearray[1] = incoming[1];
                bytearray[2] = incoming[2];
                bytearray[3] = incoming[3];
        }

        answer = IntToString(*(unsigned int *)(bytearray));
        return answer;
}

//convert an AM/PM time to 24 hour time. assumes "h:mm:ss a" input. might not
//be right for every occasion. use with moderation. blank on error.
string ConvertTime(const string &incoming)
{
        string answer = "";
        //from ' 9:05:00 A? ' to '21:05:00'
        bool pm = (incoming.find_first_of ("pP") != string::npos);
        unsigned int first_num;
        unsigned int first_col;
        unsigned int second_col;
        unsigned int after_sec;
        string stringhours = "";
        string stringminutes = "";
        string stringseconds = "";

        first_num = incoming.find_first_of ("0123456789");
        if (first_num < incoming.length() - 1 && first_num != string::npos)
        {
          first_col = incoming.find_first_of (":", first_num + 1);
          if (first_col < incoming.length() - 1 && first_col != string::npos)
          {
            second_col = incoming.find_first_of (":", first_col + 1);
            if (second_col < incoming.length() - 1 && second_col != string::npos)
            {
              stringhours   = IntToString(StringToInt(incoming.substr(first_num, first_col - first_num)));
              stringminutes = IntToString(StringToInt(incoming.substr(first_col + 1, second_col - first_col - 1)));
              after_sec = incoming.find_first_not_of ("0123456789", second_col + 1);
              if (after_sec == string::npos)
                stringseconds = incoming.substr(second_col + 1);
              else
                stringseconds = incoming.substr(second_col + 1, after_sec - second_col - 1);
              if (pm) stringhours = IntToString(12 + (StringToInt(stringhours) % 12));
                else  stringhours = IntToString(StringToInt(stringhours) % 12);
              if (stringhours.length() < 2) stringhours = string("0") + stringhours;
              if (stringminutes.length() < 2) stringminutes = string("0") + stringminutes;
              if (stringseconds.length() < 2) stringseconds = string("0") + stringseconds;
              answer = stringhours + ":" + stringminutes + ":" + stringseconds;
            }
          }
        }
        return answer;
}

//convert a 2-digit year to a 4-digit, with the following format change:
//mm/dd/yy -> yyyy-mm-dd (paradox to interbase conversion)
//not usually what you want. assumes too much. takes a two-digit year spec
//below which years are in the 2000 range, otherwise converted to 1900.
//blank on error.
//three digit year becomes 2036 as a joke (And indicator)
string ConvertDate(const string &incoming, int y2kcutoff)
{
        string answer = "";
        //from ' 12/23/97 ' to '1997-12-23'
        unsigned int first_num;
        unsigned int first_slash;
        unsigned int second_slash;
        unsigned int after_sec;
        string stringmonth = "";
        string stringday = "";
        string stringyear = "";

        first_num = incoming.find_first_of ("0123456789");
        if (first_num < incoming.length() - 1 && first_num != string::npos)
        {
          first_slash = incoming.find_first_of ("/-.", first_num + 1);
          if (first_slash < incoming.length() - 1 && first_slash != string::npos)
          {
            second_slash = incoming.find_first_of ("/-.", first_slash + 1);
            if (second_slash < incoming.length() - 1 && second_slash != string::npos)
            {
              stringmonth = IntToString(StringToInt(incoming.substr(first_num, first_slash - first_num)));
              stringday   = IntToString(StringToInt(incoming.substr(first_slash + 1, second_slash - first_slash - 1)));
              after_sec = incoming.find_first_not_of ("0123456789", second_slash + 1);
              if (after_sec == string::npos)
                stringyear = incoming.substr(second_slash + 1);
              else
                stringyear = incoming.substr(second_slash + 1, after_sec - second_slash - 1);
              stringyear = IntToString(StringToInt(stringyear));
              if (stringyear.length() < 2) stringyear = string("0") + stringyear;
              if (stringmonth.length() < 2) stringmonth = string("0") + stringmonth;
              if (stringday.length() < 2) stringday = string("0") + stringday;
              if (stringyear.length() == 3) stringyear = "2036";
              if (stringyear.length() < 3)
                if (StringToInt(stringyear) < y2kcutoff) stringyear = string("20") + stringyear;
                  else                                   stringyear = string("19") + stringyear;
              answer = stringyear + "-" + stringmonth + "-" + stringday;
            }
          }
        }
        return answer;
}

//converts paradox timestamp to interbase timestamp. involves a time and date
//conversion using other functions, but also a reversal -
// h:mm:ss ?? m/dd/yy -> yyyy-mm-dd hh:mm:ss
//good format for ordering.
//blank on error.
string ConvertStamp(const string &incoming, int y2kcutoff)
{
        //from ' 11:25:41 A? 2/18/1999 ' to '1999-02-18 11:25:41'
        string answer = "";
        string newtime = "";
        string newdate = "";
        unsigned int middlespace;

        string work_str = StripTrailing(incoming, " ");
        middlespace = work_str.find_last_of(" ", work_str.length() - 1);
        if (middlespace != string::npos)
        {
                newtime = ConvertTime (work_str.substr(middlespace));
                newdate = ConvertDate (work_str.substr(0, middlespace), y2kcutoff);
                answer = newdate + string(" ") + newtime;
        }
        return answer;
}

//converts a text field of F or N to 0, T or Y to 1 for use in an integer
//field. blank on error.
string ConvertBool(const string &incoming)
{
        string answer = "";
        string work_str = UppercaseString(incoming);
        if (work_str == "F" || work_str == "N" || work_str == "0")
         answer = "0";
        else if (work_str == "T" || work_str == "Y" || work_str == "1" || work_str == "M")
         answer = "1";
        return answer;
}

//END FORMAT MANIPULATION FUNCTIONS------------------------------------------

//START INTEGER AND FLOAT TO STRING TRANSLATIONS AND MANIPULATIONS-----------

//returns true if a string contains only digits 0-9 and/or a - sign.
bool IsInt (const string &incoming)
{
 // symbols come before digits, always
 if (incoming.find_first_not_of(ints) != string::npos)
  return false;
 unsigned int last_symb = incoming.find_last_of ("+-");
 unsigned int first_dig = incoming.find_first_not_of ("-+");
 if (first_dig != string::npos)
 {
  if (last_symb != string::npos)
   if (last_symb > first_dig)
    return false;
 }
 else
  if (last_symb != string::npos)
   return false;
 // allow blank, but don't allow symbols without digits!
 // if digits, and if symbols, then only allow symbols -before- digits
 return true;
}

//returns true if a string contains only digits 0-9, a decimal point, and/or
//a hyphen.
bool IsFloat (const string &incoming)
{
 // symbols come before digits, always
 if (incoming.find_first_not_of(floats) != string::npos)
  return false;
 unsigned int last_symb = incoming.find_last_of ("+-");
 unsigned int first_dig = incoming.find_first_of (uints);
 unsigned int last_dig  = incoming.find_last_not_of (uints);
 unsigned int decimal_p = incoming.find ('.');
 if (first_dig != string::npos)
 {
  if (last_symb != string::npos)
   if (last_symb > first_dig)
    return false;
  if (decimal_p != string::npos)
   if (decimal_p < first_dig || decimal_p > last_dig)
    return false;
 }
 else
  if (last_symb != string::npos)
   return false;
 // allow blank, but don't allow symbols without digits!
 // if digits, and if symbols, then only allow symbols -before- digits
 return true;
}

//convert float to string using C libraries.
string FloatToString(float incoming, int right_num)
{
        string answer = "";
        char floatnumber[30];
        sprintf(floatnumber, string("%1." + IntToString(right_num) + "f").c_str(), incoming);
        answer = floatnumber;
        return answer;
}

//convert float to string using C libraries. -- shows "up to" right_num decimals rather than "exactly" right_num decimals
string FloatToStringApprox(float incoming, int right_num)
{
        string answer = "";
        char floatnumber[30];
        sprintf(floatnumber, string("%1." + IntToString(right_num) + "g").c_str(), incoming);
        answer = floatnumber;
        return answer;
}

//convert string to float using C libraries.
float StringToFloat(const string &incoming)
{
        float answer;
        answer = atof(incoming.c_str());
        return answer;
}

//convert int to string using C libraries.
string IntToString(int incoming)
{
        string answer = "";
        char floatnumber[30];
        sprintf(floatnumber, "%1i", incoming);
        answer = floatnumber;
        return answer;
}

//convert int to string using C libraries.
string UIntToString(unsigned int incoming)
{
        string answer = "";
        char floatnumber[30];
        sprintf(floatnumber, "%1u", incoming);
        answer = floatnumber;
        return answer;
}

//convert string to int using C libraries.
int StringToInt(const string &incoming)
{
  int answer;
  answer = atoi(incoming.c_str());
  return answer;
}

string IntToHexString(int incoming, int padto, bool prepend0x)
{
  string answer = "";
  char chars[30];
  sprintf(chars, "%1X", incoming);
  answer = chars;
  if ((size_t)padto > answer.length())
    answer = PadString(answer, pad_left, '0', padto);
  if (prepend0x)
    answer = "0x" + answer;
  return answer;
}

int HexStringToInt(const string &incoming)
{
  string temp = incoming;
  if (temp.substr(0, 2) == "0x" || temp.substr(0, 2) == "0X") // jhaley: allow 0X too
    temp = temp.substr(2);
  // TODO
// the internet says this sucks, so we do something different
//sscanf(hex_num,"%x",&dec_num);

/* // peeps online said this is slower than strtoul, so we use strtoul ...
  unsigned int x;
  std::stringstream ss;
  ss << std::hex << temp.c_str();
  //or //ss << setbase(16) << "0xFDE8";
  ss >> x;
  // output it as a signed type
  return static_cast<int>(x);
*/
  char *endpt;
  long n = strtoul(temp.c_str(), &endpt, 16);
  if (*endpt == 0)
    return n;
  else
    return 0; // on error return 0?  same behavior as atoi / StringToInt()
}

// jhaley 20110816: Input validation for hexadecimal integers (unsigned only)
bool IsHexInt(const string &incoming, int maxbits)
{
  size_t maxlen = maxbits / 4; // Ex: 32-bit integer == 8 characters (4 bits per hex char)

  // symbols come before digits, always
  if(incoming.find_first_not_of(hexints) != string::npos)
    return false;

  // If has an "X" or "x" character:
  // * First char must be '0'
  // * Second char must be X or x
  // * No other char must be an X or x
  if(incoming.find_first_of("Xx") != string::npos)
  {
    if(incoming.length() > maxlen + 2)
      return false; // Too long

    if(incoming.length() < 3)
      return false; // Not long enough to be an 0x-style hex number

    if(incoming[0] != '0' || (incoming[1] != 'X' && incoming[1] != 'x'))
      return false; // No leading zero, or x in the wrong position

    if(incoming.substr(2).find_first_of("Xx") != string::npos)
      return false; // Has more than one x
  }
  else if(incoming.length() > maxlen)
    return false; // Too long

  // allow blank, but don't allow symbols without digits!
  // if digits, and if symbols, then only allow symbols -before- digits
  return true;
}


string IntToRGBString(int incoming)
{
 string answer = "";
 char floatnumber[30];
 sprintf(floatnumber, "%1X", incoming);
 answer = floatnumber;
 answer = PadString(answer, pad_left, '0', 6);  // pad with zeros to 6 characters; remember, still in
 answer = FlipRGB(answer);                      // reverse RGB so pad on left
 return answer;
}

string FlipRGB(const string &incoming)
{
  string answer = "";
  if(incoming.length() == 6)
    answer = incoming.substr(4,2) + incoming.substr(2,2) + incoming.substr(0,2);
  return answer;
}

int RGBStringToInt(const string &incoming)
{
  int to_return = 0;
  string incoming_str = incoming;
  incoming_str = FlipRGB(incoming_str);
  sscanf(incoming_str.c_str(), "%X", &to_return); // name does not imply this behavior??  maybe bool treat_as_color could be an optional extra param?
  return to_return;
}

enum states_checking_float {state_float_none, state_float_dollar, state_float_sign, state_float_significant, state_float_dot, state_float_decimal};

bool IsAmount (const string &incoming, int left_num, int right_num)
{
 states_checking_float curr_state = state_float_none;
 int  count_significant = 0;
 int  count_decimals    = 0;

 for (unsigned int i = 0; i < incoming.length(); i++)
 {
  switch (incoming[i])
  {
   case '$':
   {
    if (curr_state == state_float_none)
     curr_state = state_float_dollar;
    else
    {
     string message = "$ encountered while not in state_float_none";
     #ifdef use_prometheus_util
     PPretendToSay(message, m_debug, "util::IsAmount");
     #else
     AppDebugMsg(message.c_str(), "debug", MB_OK);
     #endif
     return false;
    }
    break;
   }
   case ' ':
   {
    if (curr_state != state_float_none && curr_state != state_float_dollar && curr_state != state_float_sign)
    {
     string message = "Space encountered while not in state_float_none, state_float_dollar, or state_float_sign";
     #ifdef use_prometheus_util
     PPretendToSay(message, m_debug, "util::IsAmount");
     #else
     AppDebugMsg(message.c_str(), "debug", MB_OK);
     #endif
     return false;
    }
    break;
   }
   case '+': case '-':
   {
    if (curr_state == state_float_none || curr_state == state_float_dollar)
     curr_state = state_float_sign;
    else
    {
     string message = "+ or - enountered while not in state_float_none or state_float_dollar";
     #ifdef use_prometheus_util
     PPretendToSay(message, m_debug, "util::IsAmount");
     #else
     AppDebugMsg(message.c_str(), "debug", MB_OK);
     #endif
     return false;
    }
    break;
   }
   case '0': case '1': case '2': case '3': case '4': case '5': case '6': case '7': case '8': case '9':
   {
    if (curr_state == state_float_sign || curr_state == state_float_significant || curr_state == state_float_dollar || curr_state == state_float_none)
    {
     curr_state = state_float_significant;
     count_significant++;
    }
    else if (curr_state == state_float_dot || curr_state == state_float_decimal)
    {
     curr_state = state_float_decimal;
     count_decimals++;
    }
    else
    {
     string message = "Digit enountered while not in state_float_none, state_float_dollar, state_float_sign, state_float_significant, state_float_dot, or state_float_decimal (what does that leave?)";
     #ifdef use_prometheus_util
     PPretendToSay(message, m_debug, "util::IsAmount");
     #else
     AppDebugMsg(message.c_str(), "debug", MB_OK);
     #endif
     return false;
    }
    break;
   }
   case ',':
   {
    if (curr_state != state_float_significant)
    {
     string message = "Comma enountered while not in state_float_significant";
     #ifdef use_prometheus_util
     PPretendToSay(message, m_debug, "util::IsAmount");
     #else
     AppDebugMsg(message.c_str(), "debug", MB_OK);
     #endif
     return false;
    }
    break;
   }
   case '.':
   {
    if (curr_state == state_float_significant)
     curr_state = state_float_dot;
    else
    {
     string message = "Dot enountered while not in state_float_significant";
     #ifdef use_prometheus_util
     PPretendToSay(message, m_debug, "util::IsAmount");
     #else
     AppDebugMsg(message.c_str(), "debug", MB_OK);
     #endif
     return false;
    }
    break;
   }
   default:
   {
     string message = "Unknown character '" + string(1, incoming[i]) + "' encountered"; // jhaley - better error msg
     #ifdef use_prometheus_util
     PPretendToSay(message, m_debug, "util::IsAmount");
     #else
     AppDebugMsg(message.c_str(), "debug", MB_OK);
     #endif
    return false;
   }
  }
 }

 if (curr_state != state_float_none && curr_state != state_float_significant && curr_state != state_float_decimal)
 {
  // PSay("Did not end in either state_float_significant or state_float_decimal", m_debug, MB_OK, "util");
  return false;
 }

 // it seems that interbase doesn't care if you have lots of stuff -after-
 // a decimal place... but too much before drives it batty!

 if (count_significant > left_num)
 {
   string message = "Too many significant digits found: sorry, but you need to keep it under " + IntToString(left_num);
   #ifdef use_prometheus_util
   PSay(message, m_debug, MB_OK, "util::IsAmount");
   #else
   AppDebugMsg(message.c_str(), "debug", MB_OK);
   #endif
   return false;
 }

 return true;
}

/*
string PrettyAmountString (const string &incoming, bool blank_zero_amounts)
{
 if(blank_zero_amounts)
  if (StringToFinancial(incoming) == 0.00)
   return string("");

 return FinancialToString(StringToFinancial(incoming), true, 2);
}

string StringToAmount (const string &incoming, int left_num, int right_num)
{
 string result;
 // comes in in the form '3145.19'and must become '3,145.19'
 // dollar sign can be added by someone using this...
 // already has a '-' on the front if negative, i'll assume. put a space
 // there otherwise?

 // first, remove extra characters before adding them again
 // just in case we have odd cases where, say, someone already -has- commas in the string?
 // it would just completely suck, now wouldn't it, to get "55,,432.28" back, yes?
 result = AmountToString(incoming);

 if (!result.empty())
 {
  unsigned int decimal_p = result.find('.');
  if (decimal_p != string::npos)
  {
   unsigned int current_num_insig = (result.length() - decimal_p) - 1;
   result.resize (result.length() + (right_num - current_num_insig), '0');
  }
  else
  {
   result += ".";
   result.resize(result.length() + (unsigned int)right_num, '0');
  }

  unsigned int where_is_dot = result.find('.');
  unsigned int where_is_first_sig = result.find_first_of (uints);
  unsigned int where_is_last_sig = ((where_is_dot != string::npos) ? (where_is_dot - 1) : (result.length() - 1));
  unsigned int c = 1;
  for (unsigned int i = where_is_last_sig; i != where_is_first_sig; i--, c++)
  {
   if (c % 3 == 0)
    result.insert(i, ",");
  }
 }
 if (result[result.size()-1] == '.')
   result = result.substr(0, result.size()-1);
 return result;
}

string AmountToString (const string &incoming, int left_num, int right_num)
{
 string result;
 result = StripAllExcept(incoming, floats);
 return result;
}
*/

//END INTEGER AND FLOAT TO STRING TRANSLATIONS AND MANIPULATIONS-------------
int BoolToInt(bool incoming)
{
 return (incoming == true) ? 1 : 0;
}
//---------------------------------------------------------------------------
string IntToBoolString (int incoming, bool_types how)
{
 string answer;
 if (how == yes_no)
   switch(incoming)
   {
     case 0: answer = "No"; break;
     case 1: answer = "Yes"; break;
     default: answer = "";
   }
 else if (how == true_false)
   switch(incoming)
   {
     case 0: answer = "False"; break;
     case 1: answer = "True"; break;
     default: answer = "";
   }
 else if (how == zero_one)
   switch(incoming)
   {
     case 0: answer = "0"; break;
     case 1: answer = "1"; break;
     default: answer = "";
   }
 else
   answer = "undefined type";
 return answer;
}
//---------------------------------------------------------------------------
string BoolToBoolString (bool incoming, bool_types how)
{
  return IntToBoolString(BoolToInt(incoming), how);
}
//---------------------------------------------------------------------------
//ASHLEY'S CODE - ASHLEY'S CODE - ASHLEY'S CODE - ASHLEY'S CODE - ASHLEY'S CODE
//---------------------------------------------------------------------------

string AddOptions(int searchOption, const string &field)
{
 // add % chars to do a like on a field for a select
 // 0 = contains     '%field%'
 // 1 = ends with    '%field'
 // 2 = exact match  'field'
 // 3 = starts with  'field%'

 string returnString = "";
 if(field != "")
 {
   string work_str = UppercaseString(field);
   returnString = ReplaceStringWithString(work_str, "'", "''");
   switch (searchOption)
   {
    case 0: returnString = "'%" + returnString + "%'";  break;
    case 1: returnString = "'%" + returnString + "'";  break;
    case 2: returnString = "'" + returnString + "'";   break;
    case 3: returnString = "'" + returnString + "%'";  break;
   }
 }
 else
   returnString = "''";
 return returnString;
}

//checks to see if a given ansistring appears in a tstringlist.
bool IsInTStringList (TStringList* incomingList, AnsiString incomingString)
{
   for (int i = 0; i < incomingList->Count; i++)
      if (incomingString == incomingList->Strings[i])
         return true;
   return false;
}

//FindComboBoxItem will attempt to match a given keystroke on a combo box
//with a matching string in the list of available values for that combo
//box. The main problem is that although it disallows completely wrong values
//by refusing a keystroke that would result in a new entry, it allows
//values that are partially correct, like "Calif" if you have a list of
//states. That requires backspacing, but it is a problem which must be watched
//for before a value is directly used out of a combo box using this function.
void FindComboBoxItem (TObject *Sender, char &Key)
{
   TComboBox *cboIncoming = (TComboBox *)Sender;
   AnsiString tempString;
   AnsiString origString;
   bool backSpace = (Key == (char)VK_BACK);
   bool do_change = false;

   tempString = cboIncoming->Text;
   origString = tempString;
   int selBegin = cboIncoming->SelStart;
   int lenBefore = selBegin - 1;

   if (backSpace && selBegin >= 1)
   {
      tempString = tempString.SubString(1, lenBefore);
      selBegin--;
   }
   else if (backSpace && selBegin == 0)
   {
      tempString = "";
   }
   else
   {
     // copied from 'fast' function -- avoids having 'enter' be treated as a key that makes the rest of the string 'wrong'
     for (int i = 0; i < cboIncoming->Items->Count; i++)
     {
      AnsiString suggested_typed_string = tempString.SubString(1, selBegin) + Key;
      if (UpperCase(suggested_typed_string) == UpperCase((cboIncoming->Items->Strings[i].SubString(1, suggested_typed_string.Length()))))
      {
       tempString = tempString.SubString(1, selBegin) + Key;
       selBegin++;
       // do_change = true; // they're typing, but they're typing 'correct' stuff ... meh. could go either way. probably not needed.
       break;
      }
     }
//      tempString = tempString.SubString(1, selBegin) + Key;
//      selBegin++;
   }

   if (selBegin != 0)
   {
      bool found = false;
         for (int i = 0; i < cboIncoming->Items->Count && found == false; i++)
         {
             if (UpperCase(tempString) == UpperCase((cboIncoming->Items->Strings[i].SubString(1, tempString.Length()))))
             {
                cboIncoming->Text = cboIncoming->Items->Strings[i];
                cboIncoming->SelStart = selBegin;
                cboIncoming->SelLength = cboIncoming->Text.Length() - selBegin;
                cboIncoming->ItemIndex = i;
                found = true;
             }
         }
      if (found == false)
      {
         tempString = tempString.SubString(1, tempString.Length() - 1);
         selBegin--;
         cboIncoming->Text = tempString;
      }
   }
   else
      cboIncoming->Text = "";

   // catch-all? whatever.
   if (cboIncoming->Text != origString)
    do_change = true;

   cboIncoming->SelStart = selBegin;
   cboIncoming->SelLength = cboIncoming->Text.Length() - selBegin;

   if (do_change && cboIncoming->OnChange)
    cboIncoming->OnChange(cboIncoming);

   Key = 0;
}

void FindComboBoxItemAndSetItemIndex(TObject *Sender, char &Key)
{
 FindComboBoxItem(Sender, Key);
 ResetItemIndex(Sender);
}

void ResetItemIndex(TObject *Sender)
{
 TComboBox * box = (TComboBox *)Sender;
 // i get annoyed at it not picking up on this
 bool found = false;
 for (int i = 0; i < box->Items->Count; i++)
  if (box->Text == box->Items->Strings[i])
  {
   box->ItemIndex = i;
   found = true;
   break;
  }
 if (!found && box->Text == "")
  box->ItemIndex = -1;
}

// this one requires less typing, but it's confusing to the user -- you have to watch -exactly- what you're typing
// also, it was never finished. when backspacing, we should backspace as much as makes sense
// people who have
// people who are
// people who know
// people with stuff
// current string:
// people who|
// backspacing should backspace over the ' who' part?
void FindComboBoxItemFast (TObject *Sender, char &Key)
{
 TComboBox* box = (TComboBox*)Sender;
 AnsiString typed_string;
 AnsiString whole_string;
 bool is_backspace = (Key == (char)VK_BACK);

 int sel_start = box->SelStart;
 whole_string = box->Text;
 if (sel_start)
  typed_string = whole_string.SubString(1, sel_start);
 else
  typed_string = whole_string;

 if (is_backspace && sel_start > 0)
 {
  typed_string = typed_string.SubString(1, typed_string.Length() - 1); // AnsiString is 1-based, not 0-based
  sel_start--;
 }
 else if (is_backspace && sel_start == 0)
 {
  typed_string = "";
 }
 else // some random key, eh?
 {
  for (int i = 0; i < box->Items->Count; i++)
  {
   AnsiString suggested_typed_string = typed_string + Key;
   if (UpperCase(suggested_typed_string) == UpperCase((box->Items->Strings[i].SubString(1, suggested_typed_string.Length()))))
   {
    typed_string = suggested_typed_string;
    sel_start++;
    break;
   }
  }

  bool one_choice_only = true;
  while (one_choice_only)
  {
   char the_choice = 0;
   for (int i = 0; i < box->Items->Count; i++)
    if (UpperCase(typed_string) == UpperCase(box->Items->Strings[i].SubString(1, typed_string.Length())) && typed_string.Length() < box->Items->Strings[i].Length())
     if (!the_choice)
      the_choice = box->Items->Strings[i][typed_string.Length() + 1];
     else
      if (box->Items->Strings[i][typed_string.Length() + 1] != the_choice)
      {
       one_choice_only = false;
       break;
      }
   if (!the_choice)
    one_choice_only = false;
   if (one_choice_only)
   {
    typed_string = typed_string + the_choice;
    sel_start++;
   }
  }
 }

 whole_string = typed_string;
 if (sel_start != 0)
 {
  for (int i = 0; i < box->Items->Count; i++)
  {
   if (UpperCase(typed_string) == UpperCase((box->Items->Strings[i].SubString(1, typed_string.Length()))))
   {
    whole_string = box->Items->Strings[i];
    box->ItemIndex = i;
    break;
   }
  }
 }

 box->Text = whole_string;
 box->SelStart = sel_start;
 box->SelLength = box->Text.Length() - sel_start;

 Key = 0;
}

//PrettySSN will insert dashes into a string expected to be a social security
//number, if such a string happens to be 9 characters long.
string PrettySSN(const string &incoming)
{
  string returnString;
  string first;
  string second;
  string third;

  if (incoming.length() == 9)
  {
    first = incoming.substr(0, 3);
    second = incoming.substr(3, 2);
    third = incoming.substr(5, 4);
    returnString = first + "-" + second + "-" + third;
    return returnString;
  }
  else
    return incoming;
}

string PrettyDate(const string &incoming)
{
 if (!incoming.empty() && Pdate(incoming, global_mode).IsValidDate())
  return Pdate(incoming, global_mode).OutDate(global_mode | left_zeros);
 else
  return incoming;
}

string TwoDecimals(const string &incoming)
{
  string returnString = "0.00";
  string incomingStripped = StripLeading(incoming, "0");

  if (IsInt(incoming))
  {
    if(incomingStripped == "")
      returnString = "0.00";
    else if(incomingStripped.length() == 1)
      returnString = "0.0" + incomingStripped;
    else if(incomingStripped.length() == 2)
      returnString = "0." + incomingStripped;
    else
      returnString = incomingStripped.substr(0, incomingStripped.length() - 2) + "." +
                     incomingStripped.substr(incomingStripped.length() - 2, 2);
  }
  return returnString;

}

string ConvertStupidNumber(const string &incoming)
{
  string returnString = "";
  char last_char = incoming.substr(incoming.length()-1, 1)[0];
  bool is_negative = false;
  int number = 0;

  if ((last_char < 'S') && (last_char >= 'A'))
    number = ((last_char - 'A') % 9) + 1;

  if (last_char > 'I')
    is_negative = true;
  if (last_char == '{')
    is_negative = false;

  returnString = incoming.substr(0, incoming.length()-1) + IntToString(number);
  returnString = TwoDecimals(returnString);

  if (is_negative)
    if (returnString != "0.00")
      returnString = "-" + returnString;

  return returnString;

}

// determine if a key that was pressed is the enter key
bool IsEnter (char key)
{
  if (key == VK_RETURN)
    return true;
  else
    return false;
}

// takes a phone number from the database which should have only digits
// if the phone number has 10 digits, return the string (999) 999-9999
// else if the phone number hs 7 digits, return the string 999-9999
// else return the string that was passed
// we can assume that the number entered in the database only contains digits
//
// jhaley 20110715: Shared logic between phone number formatting routines moved here.
//
static string FormatPhoneNumberSub(const string &incoming, const string &dash, const string &space)
{
  string return_string = incoming;

  if (incoming.length() == 11)
  {
    if (incoming[0] == '1')
    {
      return_string = incoming.substr(0, 1) + dash + incoming.substr(1, 3) + dash +
                      incoming.substr(4, 3) + dash + incoming.substr(7, 4);
    }
  }
  else if (incoming.length() == 10)
  {
    return_string = "(" + incoming.substr(0, 3) + ")" + space + incoming.substr(3, 3) + dash +
                    incoming.substr(6, 4);
  }
  else if (incoming.length() == 7)
  {
    return_string = incoming.substr(0, 3) + dash + incoming.substr(3, 4);
  }
  return return_string;
}

// Normal phone number formatting
string FormatPhoneNumber(const string &incoming)
{
  return FormatPhoneNumberSub(incoming, "-", " ");
}

// jhaley 20110715: Format a phone number in a manner that won't break across lines in reports. Necessitated by the
// addition of the word "Diabetes" to appointment reminder letters, which pushed the phone number across two lines and
// looked positively nasty.
string FormatPhoneNumberNoBreak(const string &incoming)
{
  // Use en-dash (0x96) and non-breaking space (0xA0), which are in the Windows/ANSI character set (0xA0 is also UTF)
  return FormatPhoneNumberSub(incoming, "\x96", "\xA0");
}

// takes an address and tarts it up a bit
string FormatAddress (const string &incoming)
{
  InitUspsAbbrMap(); // does so only if not already done
  string return_string = PrettyString(incoming);
  /*string return_string = incoming;
  string all_chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
                     "`~1234567890-=_+!@#$%^&*()[]\;',./{}|:\"<>?\n\t ";
  */
  string chars_to_strip = "`~=_+!@$%^&*()[]\\;',.{}|:\"<>?"; // excluding - and #, which we're keeping
  /*                                                         // excluding forwardslash, which they need for 1/2 etc.
  //convert anything that isn't alphanumeric or a hyphen to a space
  string chars_to_keep = string(upper_alphas) + string(alpha_numerics) + "-#";
  string chars_to_strip = StripAll(all_chars, chars_to_keep);
  //for (int i=0; i<chars_to_strip.length(); i++)
  //  return_string = ReplaceStringWithString(return_string, chars_to_strip[i], " ");
  return_string = ReplaceAnyCharWithString(return_string, chars_to_strip, " ");
  // TODO: replace cardinal directions, street types, etc. with abbreviations....
  // http://www.usps.com/ncsc/lookups/abbreviations.html
  //collapse all repeating spaces into a single space
  //return_string = ReplaceStringWithString(return_string, "  ", " ", true);
  */
  return_string = StripAll(return_string, chars_to_strip);
  return_string = ReplaceWordsWithWords(return_string, usps_abbr_map);

  // a couple of extras that won't get picked up as they're not single whole words:
  return_string = " " + return_string + " ";
  return_string = ReplaceStringWithString(return_string, " P O "," PO ");
  return_string = ReplaceStringWithString(return_string, " N E "," NE ");
  return_string = ReplaceStringWithString(return_string, " N W "," NW ");
  return_string = ReplaceStringWithString(return_string, " S E "," SE ");
  return_string = ReplaceStringWithString(return_string, " S W "," SW ");
  // these aren't necessary as by this point "North" and "East" would have collapsed to "N E" and would therefore be handled above
  //return_string = ReplaceStringWithString(return_string, " North East "," NE ");
  //return_string = ReplaceStringWithString(return_string, " North West "," NW ");
  //return_string = ReplaceStringWithString(return_string, " South East "," SE ");
  //return_string = ReplaceStringWithString(return_string, " South West "," SW ");
  return_string = StripTrailing(StripLeading(return_string, " "), " ");

  return return_string;
}

// Mary P. (Williams) Hickens-Smith = MPWHS
string AcronymString(const string &incoming)
{
  string stupid, acceptable_chars, simpler, answer;
  stupid = incoming;
  acceptable_chars = string(alphas) + string(upper_alphas);
  for (size_t i=0; i<stupid.length(); i++)
    simpler += acceptable_chars.find(stupid.substr(i,1)) != string::npos ? stupid.substr(i,1) : string(" "); // if it's an acceptable character, we use it; else we use space
  simpler = ReplaceStringWithString(simpler, "  ", " ", true);
  // modified from SplitStringToVec
  string separator = " ";
  int lastmatch = 0 - separator.size();
  unsigned int mainmatch = simpler.find(separator, 0);
  string chunk;
  while (mainmatch != string::npos)
  {
     chunk = simpler.substr(lastmatch + separator.size(), mainmatch - (lastmatch + separator.size() - 1) - 1);
     answer += chunk.substr(0, 1);
     lastmatch = mainmatch;
     mainmatch = simpler.find(separator, lastmatch + separator.size());
  }
  chunk = simpler.substr(lastmatch + separator.size());
  answer += chunk.substr(0, min((unsigned int)1, chunk.length()));
  return UppercaseString(answer);
}

string PrettySql(const string &incoming)
{
/*  deque<string> context;
  string working_sql = LowercaseString(incoming);
  if (working_sql.substr(0, 7) == "select ")
  {
    size_type from_pos
    while(working_sql.find(" from ") !=
  }
*/
  string working_sql = incoming;
  working_sql = ReplaceStringWithString(working_sql, "select", "\nselect");
  working_sql = ReplaceStringWithString(working_sql, "from", "\nfrom");
  working_sql = ReplaceStringWithString(working_sql, "inner join", "\ninner join");
  working_sql = ReplaceStringWithString(working_sql, "left join", "\nleft join");
  working_sql = ReplaceStringWithString(working_sql, "right join", "\nright join");
  working_sql = ReplaceStringWithString(working_sql, "working_sql, left outer join", "\nleft outer join");
  working_sql = ReplaceStringWithString(working_sql, "right outer join", "\nright outer join");
  working_sql = ReplaceStringWithString(working_sql, "natural join", "\nnatural join");
  working_sql = ReplaceStringWithString(working_sql, "full outer join", "\nfull outer join");
  working_sql = ReplaceStringWithString(working_sql, "cross join", "\ncross join");
  working_sql = ReplaceStringWithString(working_sql, "where", "\nwhere");
  working_sql = ReplaceStringWithString(working_sql, "group by", "\ngroup by");
  working_sql = ReplaceStringWithString(working_sql, "order by", "\norder by");
  return ReplaceStringWithString(StripTrailing(StripLeading(working_sql, "\n"), "\n"), "\n\n", "\n", true);
}

// uppercases the string and escapes apostrophes
string SafeSQLString(const string &incoming, bool preserve_fieldname_case)
{
  string return_string = incoming;
  if (!preserve_fieldname_case)
    return_string = UppercaseString(return_string);
  return_string = ReplaceStringWithString(return_string, "'", "''");
  return_string = StripLeading(return_string, " ");
  return_string = StripTrailing(return_string, " ");
  return return_string;
}

string FormatZipCode(const string &incoming)
{
  string return_string = incoming;

  if (return_string.length() == 9)
    return_string = return_string.substr(0, 5) + "-" + return_string.substr(5, 4);
  return return_string;

}

string StripAllExcept(const string &incoming, const string &to_keep)
{
  string return_string = incoming;
  if (incoming != "")
  {
    string all_chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
                       "`~1234567890-=_+!@#$%^&*()[]\\;',./{}|:\"<>?\n\t ";
    string to_strip = StripAll(all_chars, to_keep);
    return_string = StripAll(incoming, to_strip);
  }

  return return_string;
}

//---------------------------------------------------------------------------
string RightNow(bool compact)
{
 string answer;
 string rawdate;
 Pstamp rightnow;

 rawdate = DateTimeToStr(Now()).c_str();
 rightnow.InStamp(rawdate, datefirst | mdy | yyyy | military);
 if (!compact) // the format interbase/firebird uses
   answer = rightnow.OutStamp(datefirst | mdy | yyyy | military);
 else // fully qualified date/time stamp that sorts properly (used by, e.g., IHS/NDW's HL7 file naming convention)
   answer = StripAllExcept(rightnow.OutStamp(datefirst | ymd | yyyy | left_zeros | military), uints);

 return answer;
}

string CurrentDate()
{
 return Pdate(Date()).OutDate(mdy | yyyy);
}

string CurrentTime()
{
 return Ptime(Time()).OutTime(military | withsec);
}

Pdate CurrentPdate()
{
 return Pdate(Date());
}

Ptime CurrentPtime()
{
 return Ptime(Time());
}

Pstamp CurrentPstamp()
{
 Pstamp to_return;
 to_return.InDate(CurrentPdate());
 to_return.InTime(CurrentPtime());
 return to_return;
}

//--------------------------------------------------------------------------
//ASHLEY'S CODE - ASHLEY'S CODE - ASHLEY'S CODE - ASHLEY'S CODE - ASHLEY'S CODE
//--------------------------------------------------------------------------
int RoundNearest(double D)
{
  int answer = D;
  if(fabs(D - (double)answer) >= 0.50)
  {
    if (D < 0.0)
      answer--;
    else
      answer++;
  }
  return answer;
}
//--------------------------------------------------------------------------
void SplitStringToVec(const string &incoming, const string &separator, vector<string> &vec)
{
   int lastmatch = 0 - separator.size();
   unsigned int mainmatch = incoming.find(separator, 0);
   while (mainmatch != string::npos)
   {
      vec.push_back(incoming.substr(lastmatch + separator.size(), mainmatch - (lastmatch + separator.size() - 1) - 1));

      lastmatch = mainmatch;
      mainmatch = incoming.find(separator, lastmatch + separator.size());
   }
   vec.push_back(incoming.substr(lastmatch + separator.size()));
}
//--------------------------------------------------------------------------
void SplitStringToSet(const string &incoming, const string &separator, set<string> &incoming_set)
{
   int lastmatch = 0 - separator.size();
   unsigned int mainmatch = incoming.find(separator, 0);
   while (mainmatch != string::npos)
   {
      incoming_set.insert(incoming.substr(lastmatch + separator.size(), mainmatch - (lastmatch + separator.size() - 1) - 1));

      lastmatch = mainmatch;
      mainmatch = incoming.find(separator, lastmatch + separator.size());
   }
   incoming_set.insert(incoming.substr(lastmatch + separator.size()));
}
//--------------------------------------------------------------------------
string VecToDelimString(const vector<string> &p_vec, const string &left, const string &right, const string &between)
{
  string return_string;
  for(vector<string>::const_iterator itr = p_vec.begin(); itr != p_vec.end(); itr++)
    return_string += (left + *itr + right + between);
  return_string = return_string.substr(0, return_string.length() - between.length());
  return return_string;
}
//--------------------------------------------------------------------------
string VecToCommaString(const vector<string> &p_vec)
{
  return VecToDelimString(p_vec, "", "", ", ");
}
//--------------------------------------------------------------------------
bool VecMapColumnToVec(const vector<map<string, string> > &p_vecmap, vector<string> &p_vec, const string &field, bool include_blank)
{
  bool result = true;
  // loop through vecmap
  for(vector<map<string, string> >::const_iterator vec_itr = p_vecmap.begin(); vec_itr != p_vecmap.end(); vec_itr++)
  {
    // find the right column, if it exists
    map<string, string>::const_iterator map_itr = vec_itr->find(field);
    if (map_itr != vec_itr->end())
    {
      // add it to the column values vector
      if (map_itr->second != "" || include_blank)
        p_vec.push_back(map_itr->second);
    }
    else
      // column missing (on at least one row)
      result = false;
  }
  return result;
}
//--------------------------------------------------------------------------
/* DONE: This function should be renamed, as its name currently implies that it does the same thing the other *ToDelimString functions do, but for a vecmap,
   which it does not.  What it actually does is -extract- a column from a vecmap, and give it to you as a delim string.  Fix should be easy, as this function
   is only used one place in the code, and it's commented out.  Just feeling lazy right now.  */
/* The great thing about having a compiler that doesn't suck is that making changes that require a full rebuild are far less onerous.  Go go gadget TwineCompile.  */
string VecMapColumnToDelimString(const vector<map<string, string> > &p_vecmap, const string &field, const string &left, const string &right, const string &between)
{
  // build a vector that contains all the values for the requested column
  vector<string> column_to_delim;
  if (VecMapColumnToVec(p_vecmap, column_to_delim, field, false))   // TODO: make the bool on the end here a parameter passed to VecMapColumnToDelimString
    // now we can pass our existing function the vector of values   // previous default was true, but VecMapColumnToDelimString isn't used anywhere, so it doesn't matter
    return VecToDelimString(column_to_delim, left, right, between);
  else
    // oops?
    return "";
}
//--------------------------------------------------------------------------
string VecMapColumnToCommaString(const vector<map<string, string> > &p_vecmap, const string &field)
{
  return VecMapColumnToDelimString(p_vecmap, field, "", "", ", ");
}
//--------------------------------------------------------------------------
string SetToDelimString(const set<string> &p_set, const string &left, const string &right, const string &between)
{
  string return_string;
  for(set<string>::const_iterator itr = p_set.begin(); itr != p_set.end(); itr++)
    return_string += (left + *itr + right + between);
  return_string = return_string.substr(0, return_string.length() - between.length());
  return return_string;
}
//--------------------------------------------------------------------------
string SetToCommaString(const set<string> &p_set)
{
  return SetToDelimString(p_set, "", "", ", ");
}
//--------------------------------------------------------------------------
string ListToDelimString(const list<string> &p_list, const string &left, const string &right, const string &between)
{
  string return_string;
  for(list<string>::const_iterator itr = p_list.begin(); itr != p_list.end(); itr++)
    return_string += (left + *itr + right + between);
  return_string = return_string.substr(0, return_string.length() - between.length());
  return return_string;
}
//--------------------------------------------------------------------------
string ListToCommaString(const list<string> &p_list)
{
  return ListToDelimString(p_list, "", "", ", ");
}
//--------------------------------------------------------------------------
string MapToDelimString(const map<string,string> &p_map, const string &left_outer, const string &right_outer, const string &between_pair,
  const string &left_key, const string &right_key, const string &left_value, const string &right_value, const string &between_key_value)
{
  string return_string;
  for(map<string,string>::const_iterator itr = p_map.begin(); itr != p_map.end(); itr++)
    return_string += (left_outer + left_key + itr->first + right_key + between_key_value + left_value + itr->second + right_value + right_outer + between_pair);
  return_string = return_string.substr(0, return_string.length() - between_pair.length());
  return return_string;
}
//--------------------------------------------------------------------------
string MapToCommaString(const map<string,string> &p_map)
{
  return MapToDelimString(p_map, "", "", ", ", "", "", "", "", "=");
}
//--------------------------------------------------------------------------
void SKVToPreparedInsert(const map<string, map<string, string> >& skv_map, list<vector<string> >& output_data)
{
 vector<string> one_row;
 one_row.resize(3);
 for (map<string, map<string, string> >::const_iterator i_skv = skv_map.begin(); i_skv != skv_map.end(); i_skv++)
 {
  #ifdef use_prometheus_util
  if (i_skv->first.length() > 255) PPretendToSay("SKVToPreparedInsert encountered a long 's' value: '" + i_skv->first + "'", m_debug, "util");
  #endif
  one_row[0] = i_skv->first;
  for (map<string, string>::const_iterator i_row = i_skv->second.begin(); i_row != i_skv->second.end(); i_row++)
  {
   #ifdef use_prometheus_util
   if (i_row->first.length() > 255) PPretendToSay("SKVToPreparedInsert encountered a long 'k' value: '" + i_row->first + "'", m_debug, "util");
   #endif
   one_row[1] = i_row->first;
   #ifdef use_prometheus_util
   if (i_row->second.length() > 4094) PPretendToSay("SKVToPreparedInsert encountered a long 'k' value: '" + i_row->second + "'", m_debug, "util");
   #endif
   one_row[2] = i_row->second;
   output_data.push_back(one_row);
  }
 }
 return;
}
//--------------------------------------------------------------------------
string ShowTypeName(int show_type)
{
 if (show_type > -1 && show_type < num_show_types)
 {
  return show_type_names[show_type];
 } else
  return "Warning: unknown";
}
//--------------------------------------------------------------------------
string SortTypeName(int sort_type)
{
 if (sort_type > -1 && sort_type < num_sort_types)
 {
  return sort_type_names[sort_type];
 } else
  return "Warning: unknown";
}
//--------------------------------------------------------------------------
int ShowTypeId(const string &show_type_name)
{
 for (int i = 0; i < num_show_types; i++)
 {
  if (show_type_name == show_type_names[i])
   return i;
 }
 return -1;
}
//--------------------------------------------------------------------------
int SortTypeId(const string &sort_type_name)
{
 for (int i = 0; i < num_sort_types; i++)
 {
  if (sort_type_name == sort_type_names[i])
   return i;
 }
 return -1;
}
//--------------------------------------------------------------------------
void ShowTypeNames (vector<string> & p_return)
{
 p_return.clear();
 for (int i = 0; i < num_show_types; i++)
  p_return.push_back(show_type_names[i]);
}
//--------------------------------------------------------------------------
void SortTypeNames (vector<string> & p_return)
{
 p_return.clear();
 for (int i = 0; i < num_sort_types; i++)
  p_return.push_back(sort_type_names[i]);
}
//--------------------------------------------------------------------------
void TStringsToVec(TStrings * ts, vector<string> &vec)
{
  vec.clear();
  for (int i = 0; i != ts->Count; i++)
  {
     vec.push_back(ts->Strings[i].c_str());
  }
}
//--------------------------------------------------------------------------
bool IsVisible (TControl * p_control)
{
 try
 {
  if(p_control)
  {
   while (p_control->Parent)
   {
    if (!p_control->Visible)
     return false;
    p_control = p_control->Parent;
   }
   return p_control->Visible;
  }
  else
   return false;
 }
 catch(...)
 {
  return false;
 }
}
//--------------------------------------------------------------------------
bool IsEnabled (TControl * p_control)
{
 while (p_control->Parent)
 {
  if (!p_control->Enabled)
   return false;
  p_control = p_control->Parent;
 }
 return p_control->Enabled;
}
//--------------------------------------------------------------------------
bool HasFocusedAncestor (TWinControl * p_control)
{
 try
 {
  if(p_control)
  {
    while (p_control->Parent)
    {
     if (p_control->Focused())
      return true;
     p_control = p_control->Parent;
    }
    return p_control->Focused();
  }
  else
   return false;
 }
 catch(...)
 {
  return false;
 }
}
//--------------------------------------------------------------------------
bool HasAncestor (TWinControl *p_test, TWinControl *p_ancestor)
{
 try
 {
  if(p_test && p_ancestor)
  {
    while (p_test->Parent)
    {
     if (p_test->Handle == p_ancestor->Handle)
      return true;
     p_test = p_test->Parent;
    }
    return (p_test->Handle == p_ancestor->Handle);
  }
  else
   return false;
 }
 catch(...)
 {
  return false;
 }
}
//--------------------------------------------------------------------------
/*
financial StringToFinancial(const string & text_value)
{
 financial temp_out;
 string temp_in = StripAllExcept (text_value, floats);
 temp_out = _atold(temp_in.c_str());
 return temp_out;
}
//--------------------------------------------------------------------------
string FinancialToStringEx(const financial & numeric_value)
{
 return FinancialToString(numeric_value.AsLongDouble(), true, 2);
}
//--------------------------------------------------------------------------
string FinancialToString(const financial numeric_value, bool with_comma, unsigned int decimal_places)
{
 string temp_out;
 financial to_print = numeric_value;
 char financialnumber[30];
 if (to_print == 0.00)
  to_print = 0.00;
 sprintf(financialnumber, string("%1." + IntToString(decimal_places) + "Lf").c_str(), to_print.AsLongDouble());
 temp_out = financialnumber;
 if (with_comma)
  temp_out = StringToAmount(temp_out);
 return temp_out;
}
*/
//---------------------------------------------------------------------------
bool IsInvalidDate(const string &date_entered)
{
  if ((! Pdate(date_entered, mdy | yy).IsValidDate()) && (date_entered != ""))
    return true;
  else
    return false;
}
//---------------------------------------------------------------------------
bool IsInvalidDate(TEdit * edit_box)
{
  if ((! Pdate(edit_box->Text.c_str(), mdy | yy).IsValidDate()) && (edit_box->Text != ""))
    return true;
  else
    return false;
}
//---------------------------------------------------------------------------
string KeywordParseString(const string &incoming, const string &fieldname)
{
 string outgoing;
 string current_substring;
 keyword_statement current_statement;
 bool is_first = true;
 unsigned int string_index1 = 0;
 int string_index2 = 0;
 int length;
 while (string_index1 != string::npos)
 {
  if (incoming.length() == 0)
  {
   return string("");
  }
  else
  {
   string_index2 = incoming.find(string(" "), string_index1+1);
   length = string_index2 - string_index1;
   current_substring = incoming.substr(string_index1, length);
   if (current_substring[0] == ' ')
   {
    if (current_substring[1] == '!')
    {
     current_statement.not_words.push_back(current_substring.substr(2, (current_substring.length() - 1)));
    }
    else
    {
     current_statement.and_words.push_back(current_substring.substr(1, (current_substring.length() - 1)));
    }
   }
   else
   {
    if (current_substring[0] == '!')
    {
     current_statement.not_words.push_back(current_substring.substr(1, (current_substring.length() - 1)));
    }
    else
    {
     current_statement.and_words.push_back(current_substring);
    }
   }
  }
  string_index1 = string_index2;
 }
 for (unsigned int i = 0; i < current_statement.not_words.size(); i++)
 {
  if (is_first)
  {
        outgoing += string(" " + fieldname + " not containing '" + current_statement.not_words[i] + "' ");
        is_first = false;
  }
  else
  {
        outgoing += string(" and " + fieldname + " not containing '" + current_statement.not_words[i] + "' ");
  }
 }
 for (unsigned int i = 0; i < current_statement.and_words.size(); i++)
 {
  if (is_first)
  {
        outgoing += string(" " + fieldname + " containing '" + current_statement.and_words[i] + "' ");
        is_first = false;
  }
  else
  {
        outgoing += string(" and " + fieldname + " containing '" + current_statement.and_words[i] + "' ");
  }
 }
 return outgoing;
}
//---------------------------------------------------------------------------
bool IsBlankOrZero(const string &id_field_value)
{
 if (id_field_value == "" || id_field_value == "0" || !IsInt(id_field_value) || StringToInt(id_field_value) == 0)
  return true;
 else
  return false;
}
//---------------------------------------------------------------------------
// NOTE:  despite the name, these can be used for any delimited text files
//---------------------------------------------------------------------------
// Converts a raw line from a CSV file into a vector of string (field) values, based on quote and delim
// characters specified and whether or not you want it to watch for double (quote) characters w/i quoted fields.
// Input: raw_line, quote_char, delim_char, watch_doubles;  Output: vecCSV
// Lifted from the File Upload utility and revised to have clearer variable names & comments, handle the
// double thing as a bool rather than a separate character that must be null or match quote_char, etc.
bool DelimStringToVec(const string &raw_line, char quote_char, char delim_char, vector<string> &vecCSV, bool watch_doubles)
{
  // vecCSV.clear(); // should be doing this on your side, not in function, yeah?

  // parse raw_line into a vector of strings
  bool quoted = false;           // are we within a quoted field?  Behave appropriately.
  unsigned int char_number = 0;  // current position in raw_line during processing
  char this_char;                // current character during processing
  char next_char;                // next character during processing (checking for doubles)
  string string_value = "";      // the value of the current field once we've figured it out

  while (char_number < raw_line.length())
  {
    this_char = raw_line[char_number];
    // get the next character too, in case of doubling
    if (char_number < raw_line.length() - 1)
      next_char = raw_line[char_number + 1];
    else
      next_char = 0;

    // determine appropriate action
    if (quoted)
    {
      if (watch_doubles && this_char == quote_char && next_char == quote_char)
      {
        string_value += quote_char;
        char_number += 2;
      }
      else if (this_char == quote_char)
      {
        if (next_char == delim_char || next_char == 0) // end of field quote == quoted field termination
          quoted = false;
        else
          string_value = string_value + this_char; // middle of field quote == just another character (and improperly formatted CSV, but we'll be nice, since Excel and some other third-party utilities are in importing these)
        char_number ++;
      }
      else
      {
        string_value += this_char;
        char_number++;
      }
    }
    else
    {
      if  (this_char == quote_char)
      {
        if (string_value == "") // beginning of field quote == quoted field entry
          quoted = true;
        else
          string_value = string_value + this_char; // middle of field quote == just another character (and improperly formatted CSV, but we'll be nice, since Excel and some other third-party utilities are in importing these)
        char_number ++;
      }
      else if (this_char == delim_char)
      {
        vecCSV.push_back(string_value);
        string_value = "";
        char_number++;
      }
      else
      {
        string_value += this_char;
        char_number++;
      }
    }
  } // end while

  vecCSV.push_back(string_value);
  return true;
}
//---------------------------------------------------------------------------
// wrapper for DelimStringToVec
bool CSVtoVecMap(const string &filename, char quote_char, char delim_char, vector<map<string,string> > &vecmap, string &err_message, bool watch_doubles)
{
  vector<string> fields;
  vector<string> datas;
  map<string, string> field_data_map;
  string raw_line;
  bool all_is_well = true;
  err_message = "";
  fstream the_file;
  unsigned int row = 0;
  if (!FileExists(filename.c_str()))
  {
    err_message = "Input file does not exist";
    all_is_well = false;
  }
  if (all_is_well)
  {
    try { the_file.open(filename.c_str(), ios::in); }
    catch (...) { all_is_well = false; }
    if (!the_file.is_open() || !all_is_well)
    {
      err_message = "Could not open file";
      all_is_well = false;
    }
    try { getline(the_file, raw_line, '\n'); row++; }
    catch (...) { err_message = "Error reading from input file"; all_is_well = false; }
    if (raw_line[raw_line.length() - 1] == '\0')
      raw_line = raw_line.substr(0, raw_line.length() - 1);
    // first line should contain header row with field names
    if (all_is_well &&
     DelimStringToVec(raw_line, quote_char, delim_char, fields, watch_doubles))
    {
      field_data_map.clear();
      while (!the_file.eof() && all_is_well)
      {
        raw_line = "";
        try { getline(the_file, raw_line, '\n'); row++; }
        catch (...) { err_message = "Error reading from input file"; all_is_well = false; }
        if (raw_line[raw_line.length() - 1] == '\0')
          raw_line = raw_line.substr(0, raw_line.length() - 1);
        datas.clear();
        if (all_is_well && raw_line.length() > 0 && 
          DelimStringToVec(raw_line, quote_char, delim_char, datas, watch_doubles))
        {
          if (datas.size() >= fields.size())
          {
            for (unsigned int i=0; i<fields.size(); i++)
              field_data_map[fields[i]] = datas[i];
            //Application->MessageBox(MapToDelimString(field_data_map, "{", "}", "", "'", "'", "'", "'", ",").c_str(), ("row " + IntToString(row)).c_str(), MB_OK);
            vecmap.push_back(field_data_map);
          }
          else
          {
            err_message = "Insufficient columns on row " + IntToString(row) + ":\n\n" + raw_line;
            all_is_well = false;
          }
        }
        else ;
          //Application->MessageBox(("SKIPPED:\n\n" + raw_line).c_str(), ("row " + IntToString(row)).c_str(), MB_OK);
      }
    }
  }
  the_file.close();
  return all_is_well;
}
//---------------------------------------------------------------------------
bool CopyCSVToClipboard(vector<vector<string> > &incoming, vector<string> headers, bool include_headers, bool always_quote)
{
  string csv;
  if (include_headers)
  {
    for (vector<string>::iterator col_itr = headers.begin(); col_itr != headers.end(); col_itr++)
    { // if always quote is on, OR the field contains a comma (then we NEED to quote), then bracket with quotes
      if (always_quote || col_itr->find(",") != string::npos)
        csv += "\"" + ReplaceStringWithString(ReplaceStringWithString(ReplaceStringWithString(*col_itr, "\"", "\"\""), "\n", " "), "\r", "") + "\",";
      else
        csv += ReplaceStringWithString(ReplaceStringWithString(ReplaceStringWithString(*col_itr, "\"", "\"\""), "\n", " "), "\r", "") + ",";
    }
    if (csv[csv.length()-1] == ',') csv = csv.substr(0, csv.length()-1);
    csv += "\r\n";
  }
  for (vector<vector<string> >::iterator row_itr = incoming.begin(); row_itr != incoming.end(); row_itr++)
  {
    for (vector<string>::iterator col_itr = row_itr->begin(); col_itr != row_itr->end(); col_itr++)
    { // if always quote is on, OR the field contains a comma (then we NEED to quote), then bracket with quotes
      if (always_quote || col_itr->find(",") != string::npos)
        csv += "\"" + ReplaceStringWithString(ReplaceStringWithString(ReplaceStringWithString(*col_itr, "\"", "\"\""), "\n", " "), "\r", "") + "\",";
      else
        csv += ReplaceStringWithString(ReplaceStringWithString(ReplaceStringWithString(*col_itr, "\"", "\"\""), "\n", " "), "\r", "") + ",";
    }
    if (csv[csv.length()-1] == ',') csv = csv.substr(0, csv.length()-1);
    csv += "\r\n";
  }

  bool result = false;
  try
  {
   /* http://forums.microsoft.com/MSDN/ShowPost.aspx?PostID=238181&SiteID=1
   On version 11.8033.6568 (SP2) you cannot use upper case string ("CSV") for the data object format. If you do, you get the "cannot paste" message.
   However, on version 11.8033.8036 (SP2), you cannot use the camel-cased string ("Csv") or you get the paste error.
   So my final code looks like the following:
   data.SetData("CSV", s);
   data.SetData("Csv", s); */
   static int cfid = 0;
   if(!cfid) cfid = RegisterClipboardFormat("CSV");
   static int cfid2 = 0;
   if(!cfid2) cfid2 = RegisterClipboardFormat("Csv");
   // Open the clipboard...
   if(OpenClipboard(0))
   {
     // Empty what's in there...
     if (EmptyClipboard())
     {
       // Allocate global memory for transfer...
       HGLOBAL hText = GlobalAlloc(GMEM_MOVEABLE |GMEM_DDESHARE, csv.length()+1);
       // Put your string in the global memory...
       char *ptr = (char *)GlobalLock(hText);
       strcpy(ptr, csv.c_str());
       GlobalUnlock(hText);
       ::SetClipboardData(cfid, hText);
       ::SetClipboardData(cfid2, hText);
       CloseClipboard();
       // Free memory...
       GlobalFree(hText);
       result = true;
     }
   }
  }
  catch (EAccessViolation &E) { result = false; }
  catch (...) { result = false; }
  return result;
}
//---------------------------------------------------------------------------
bool is_in (string val, ...) // Philip named this "in" because he's a dumbass
{                            // Paul renamed it "is_in" because ... he's a smartass?
                             // Paul also changed this to const string & to make it faster
                             // Philip changed it back when he discovered that va_start is not compatible with reference parameters
                             // (it tries to take the address of the parameter to determine stuff about the parameter array, and ... this throws it off somehow.)
 bool answer = false;
 va_list argument_list;
 va_start (argument_list, val);
 char * next_val = va_arg(argument_list, char *);
 while (next_val)
 {
  if (val == next_val)
  {
   answer = true;
   break;
  }
  next_val = va_arg(argument_list, char *);
 }
 va_end (argument_list);
 return answer;
}
//---------------------------------------------------------------------------
bool is_in (AnsiString val, ...) // Let's have an AnsiString version too.
{
 bool answer = false;
 va_list argument_list;
 va_start (argument_list, val);
 char * next_val = va_arg(argument_list, char *);
 while (next_val)
 {
  if (val == next_val)
  {
   answer = true;
   break;
  }
  next_val = va_arg(argument_list, char *);
 }
 va_end (argument_list);
 return answer;
}
//---------------------------------------------------------------------------
string ParseFileVersionInfo(AnsiString FQFN) // fully-qualified file name
{
  VS_FIXEDFILEINFO *pFixedInfo; // pointer to fixed file info structure
  UINT  VersionLen;
  DWORD unused;
  DWORD VersionInfoSize = GetFileVersionInfoSize(FQFN.c_str(), &unused);
  if (VersionInfoSize != 0)
  {
    char *buffer = new char[VersionInfoSize];
    GetFileVersionInfo(FQFN.c_str(), unused, VersionInfoSize, (void *)buffer);
    VerQueryValue(buffer,"\\",(void**)&pFixedInfo,(UINT *)&VersionLen);
    char cver[30];
    sprintf(cver, "%u\.%u\.%u\.%u",
            HIWORD (pFixedInfo->dwProductVersionMS),
            LOWORD (pFixedInfo->dwProductVersionMS),
            HIWORD (pFixedInfo->dwProductVersionLS),
            LOWORD (pFixedInfo->dwProductVersionLS));
    if (buffer)
      delete []buffer;
    return string(cver);
  }
  return "";
}
//---------------------------------------------------------------------------
void GetFileVersionMap(AnsiString FQFN, map<string, int> &version_map)
{
  VS_FIXEDFILEINFO *pFixedInfo; // pointer to fixed file info structure
  UINT  VersionLen;
  DWORD unused;
  DWORD VersionInfoSize = GetFileVersionInfoSize(FQFN.c_str(), &unused);
  if (VersionInfoSize != 0)
  {
    char *buffer = new char[VersionInfoSize];
    GetFileVersionInfo(FQFN.c_str(), unused, VersionInfoSize, (void *)buffer);
    VerQueryValue(buffer,"\\",(void**)&pFixedInfo,(UINT *)&VersionLen);
    version_map["major"]   = HIWORD(pFixedInfo->dwProductVersionMS);
    version_map["minor"]   = LOWORD(pFixedInfo->dwProductVersionMS);
    version_map["release"] = HIWORD(pFixedInfo->dwProductVersionLS);
    version_map["build"]   = LOWORD(pFixedInfo->dwProductVersionLS);
    if (buffer)
      delete []buffer;
  }
}
//---------------------------------------------------------------------------
// jhaley 20110428: GetLogicalAddress - debugging aid, translates an address into the format used by Borland .map files,
// which is the executable file segment + offset.
bool GetLogicalAddress(PVOID addr, DWORD &section, DWORD &offset)
{
  MEMORY_BASIC_INFORMATION mbi;

  if (!VirtualQuery((PVOID)GetLogicalAddress, &mbi, sizeof(mbi))) // get MBI for process
    return false;

  DWORD                 hMod    = (DWORD)(mbi.AllocationBase);                   // base of image in memory
  PIMAGE_DOS_HEADER     pDosHdr = (PIMAGE_DOS_HEADER)hMod;                       // MZ header
  PIMAGE_NT_HEADERS     pNtHdr  = (PIMAGE_NT_HEADERS)(hMod + pDosHdr->e_lfanew); // PE header
  PIMAGE_SECTION_HEADER pSec    = IMAGE_FIRST_SECTION(pNtHdr);                   // PE section table
  DWORD                 rva     = (DWORD)addr - hMod;                            // rva is relative to image base

  for (unsigned int i = 0; i < (unsigned int)(pNtHdr->FileHeader.NumberOfSections); i++, pSec++)
  {
    DWORD secStart = pSec->VirtualAddress;
    DWORD secEnd   = secStart + max(pSec->SizeOfRawData, pSec->Misc.VirtualSize);

    if (rva >= secStart && rva <= secEnd)
    {
      section = i + 1;          // section count is 1-based
      offset  = rva - secStart; // rebase rva relative to segment start
      return true;
    }
  }

  return false; // couldn't find that address in a valid segment
}
//---------------------------------------------------------------------------

