#include "Filter.h"

// static variables are here, lucky us.
TIBTransaction * classFilterObject::default_transaction;
bool classFilterObject::always_autosize_columns;
TPoint classFilterObject::floating_hint_offset;
TTimer * classFilterObject::timerFilterHint;
THintWindow * classFilterObject::hintFloating;
TListView * classFilterObject::listPrevious;
TNotifyEvent classFilterObject::funcDoubleClick;
TLVColumnClickEvent classFilterObject::funcColumnClick;
TLVAdvancedCustomDrawEvent classFilterObject::funcAdvancedCustomDraw;
map<string, map<string, string> >* classFilterObject::user_permissions;
map<string, map<string, string> >* classFilterObject::user_preferences;
TPopupMenu* classFilterObject::default_popup_menu;
TImageList* classFilterObject::default_image_list;
TIBDatabase* classFilterObject::default_database;
classFilterObject::DeleteCallback classFilterObject::funcDelete;

TNotifyEvent classFilterObject::funcClick;
TKeyEvent classFilterObject::funcKeyDown;
TLVOwnerDataEvent classFilterObject::funcNeedData;
TLVOwnerDataFindEvent classFilterObject::funcFindNextData;
TLVOwnerDataHintEvent classFilterObject::funcNeedDataRange;
TLVOwnerDataStateChangeEvent classFilterObject::funcStateChange;

typedef void __fastcall (*OnHintTimer)(TObject *Sender);

//-----------------------------------------------------------------------
classColumn::classColumn(string a, string r, sort_type b, bool c, int d, show_type e, TAlignment al, int aw, int colnum)
{
   //intialize the values for classColumn
   columnName = a;
   as_what = b;
   showCol = c;
   ColumnWidth = d;
   StringType = e;
   requires = r;
   currently_at = NULL;
   align_how = al;
   AutosizeWidth = aw;
   indices.first = colnum;
   indices.second = 0;
}
//-----------------------------------------------------------------------
classCurrent::classCurrent(bool d, string f)
{
  //intialize the values for classCurrent
  showCurrent = d;
  currentItem = f;
}
//-----------------------------------------------------------------------
bool classFilterObject::EnableTransaction (TIBDatabase * p_database)
{
 // classFilterObject::upper_bound_sort_quantity = 25000;
 TIBDatabase* db_to_connect = default_database;
 if (p_database != NULL) db_to_connect = p_database;
 try
 {
  default_transaction = new TIBTransaction (NULL);
  /* sqlLib::SpyTransaction(default_transaction, db_to_connect); */
  default_transaction->DefaultDatabase = db_to_connect;
  default_transaction->DefaultAction = TARollback;
  default_transaction->Params->Add("nowait");
  default_transaction->Params->Add("read_committed");
  default_transaction->Params->Add("rec_version");
  default_transaction->Active = true;
  /* end of sqlLib::SpyTransaction(default_transaction, db_to_connect); */
 }
 catch (...)
 {
  return false;
 }
 return true;
}
//-----------------------------------------------------------------------
void classFilterObject::DisableTransaction ()
{
 default_transaction->Commit();
 delete default_transaction;
 default_transaction = NULL;
}
//-----------------------------------------------------------------------
classFilterObject::classFilterObject()
  : sql_source(), original_window_proc(NULL), listview_hint(), listview_text(), set_where_id(), set_where_not_id(),
    field_names(), field_types(), raw_data(), visible_data(), checked_data(), requires(), preferences_name(),
    original_preferences(), floating_hint_pos(), visible_row_count(0), all_row_count(0), lack_columns(true),
    lack_dataset(true), prev_scroll(0) // jhaley 20111228: make sure everything is initialized.
{
 sort_column_index = 0;

 column_id           = -1;
 column_icon         = -1;
 column_valid        = -1;
 column_color_swatch = -1;

 sort_asc       = true;
 show_headers   = true;
 show_icons     = true;
 is_checkboxes  = false;
 is_multiselect = false;
 is_compress    = false;
 is_pending     = false;
 is_pending_check_all          = false;
 is_pending_check_where_id     = false;
 is_make_checked_where_id      = false;
 is_pending_check_where_not_id = false;
 is_make_checked_where_not_id  = false;
 auto_column_specs      = false;
 auto_format_by_type    = false;
 is_refreshing_listview = false;
 is_check_locked        = false;
 is_hiding_unchecked    = false;
 saved_onclick_handler  = false; // jhaley 20110615

 listSearchResults   = NULL;
 listview_label      = NULL;
 sort_column_pointer = NULL;
 wheretoAddEdit      = NULL;
 wheretoInform       = NULL;
 wheretoCheck        = NULL;
 howtoAdd            = NULL;
 howtoEdit           = NULL;
 howtoCheck          = NULL;
 howtoInform         = NULL;
 associatedForm      = NULL;

 data_source = &sql_source;

 // TODO: grab values instead from the lookup table or somesuch ... set all to true.
 AddCurrentSpec(true, "Deleted");
 AddCurrentSpec(true, "Incorrect");
 AddCurrentSpec(true, "Expired");
 AddCurrentSpec(true, "Incomplete");
 AddCurrentSpec(true, "Current");
 AddCurrentSpec(true, "Primary");

 //TODO: we need Get/Set functions for these
 popup_menu = default_popup_menu;
 image_list = default_image_list;
 //but not these, unless we design filter to connect to multiple DB at once
 local_database = default_database;
 local_transaction = default_transaction;
}
//-----------------------------------------------------------------------
classFilterObject::~classFilterObject()
{
//  listSearchResults->OnDblClick    = NULL;
//  listSearchResults->OnColumnClick = NULL;
  ThrowPreferences();

  if (listview_label) {delete listview_label; listview_label = NULL;}

  listPrevious = NULL;
  if(hintFloating) hintFloating->ReleaseHandle();

  if (data_source && data_source != &sql_source)
   delete data_source;

  // jhaley 20100720: calling app may want notification of this deletion
  if (funcDelete)
    funcDelete(this);
}
//-----------------------------------------------------------------------
string classFilterObject::GetSQLStatement()
{
 if (data_source == &sql_source)
  return sql_source.GetSqlStatement();
 else
  return "custom data source, no sql available";
}
//-----------------------------------------------------------------------
void classFilterObject::SetSQLStatement (const string &tempsqlstring)
{
 sql_source.SetSqlStatement(tempsqlstring);
}
//-----------------------------------------------------------------------
void classFilterObject::SetListViewHandle (TListView * tempListView)
{
 //the pointer to the listview, good time to setup properties of the listview

 // TODO: passing a NULL pointer here will make things go BOOM!

 listSearchResults = tempListView;

 listSearchResults->OwnerData = true;

 if(!saved_onclick_handler) // Why is this necessary?!?!?
 {
   saved_onclick_handler = true;
   DisplacedOnClickHandler = listSearchResults->OnClick; // jhaley: save original OnClick event handler
 }

 listSearchResults->OnClick = funcClick;
 listSearchResults->OnKeyDown = funcKeyDown;
 listSearchResults->OnData = funcNeedData;
 listSearchResults->OnDataStateChange = funcStateChange;
 // not yet implemented in codePrometheus
 // listSearchResults->OnDataFind = funcFindNextData;
 // listSearchResults->OnDataHint = funcNeedDataRange;

 listSearchResults->ReadOnly      = true;
 listSearchResults->FullDrag      = true;
 listSearchResults->RowSelect     = true;
 listSearchResults->HideSelection = false;
 listSearchResults->ViewStyle     = vsReport;
 listSearchResults->Tag           = int(this);
 listSearchResults->PopupMenu     = popup_menu;
 //if (optionsPreferences["filter"]["no_persistent_hints"] == "true")
   listSearchResults->ShowHint    = true;
 //else
 {
 /*
   listSearchResults->ShowHint    = false;
   listSearchResults->OnMouseMove = listSearchResultsMouseMove;
 */
 }

 if (!listview_label)
 {
  listview_label              = new TStaticText((void*)NULL);
  listview_label->AutoSize    = true;
  listview_label->Caption     = "Intentionally blank.";
  listview_label->Parent      = listSearchResults;
  listview_label->Top         = listview_label->Height * 1.50;
  listview_label->Anchors << akTop >> akLeft >> akRight >> akBottom;
  listview_text = "Intentionally blank.";
 }

 UpdateHint    ();
 UpdateText    ();
 SetCompress   (is_compress);
 SetHeader     (show_headers);
 SetMulti      (is_multiselect);
 SetCheck      (is_checkboxes);
 if (howtoEdit)
  listSearchResults->OnDblClick    = funcDoubleClick;
 listSearchResults->OnColumnClick = funcColumnClick;
}
//-----------------------------------------------------------------------
void classFilterObject::AddColumnSpec (string columnName, string requires_table, sort_type as_what, bool showCol, int ColumnWidth, show_type StringType, filter_column_alignments al)
{
 //create vector of classColumn to be used with the Filter Object
 string needed_permission = FullPerm(requires_table);
 if (needed_permission != "")
 {
  if (LikeString("table.%", needed_permission))
  {
   if ((*user_permissions)[needed_permission]["view"] != "true")
    showCol = false;
  } else
  {
   if ((*user_permissions)[needed_permission]["enabled"] != "true")
    showCol = false;
  }
 }

 TAlignment AlignHow = taLeftJustify;
 if (al == fc_right || (al == fc_default && (StringType == amountString || StringType == nonzeroAmountString || StringType == statString || StringType == intString || as_what == as_date || as_what == as_time)))
  AlignHow = taRightJustify;

 int size = ColumnVec.size();
 ColumnVec.push_back(classColumn(columnName, requires_table, as_what, showCol, ColumnWidth, StringType, AlignHow, 0, size));
 UpdateHint();
}
//-----------------------------------------------------------------------
void classFilterObject::AddCurrentSpec (bool showCurrent, string currentItem)
{
 //create a vector of classCurrent to be used with the Filter Object
 CurrentVec.push_back(classCurrent(showCurrent, currentItem));
}
//-----------------------------------------------------------------------
void classFilterObject::SetAddEdit(TObject * p_form, AddRecord p_howtoAdd, EditRecord p_howtoEdit)
{
 // set these local variables
 wheretoAddEdit = p_form;
 associatedForm = p_form;
 howtoAdd = p_howtoAdd;
 howtoEdit = p_howtoEdit;
 if (howtoEdit)
  listSearchResults->OnDblClick = funcDoubleClick;
 return;
}
//-----------------------------------------------------------------------
void classFilterObject::SetCheck(TObject * p_form, CheckRecord p_howtoCheck)
{
 // set these local variables
 // yes, i know -- add and edit use associatedForm, and you call them together...
 // and then, this function. where you ALSO set associatedForm. well... i'm worried
 // about the order in which SetAddEdit gets called -- you want this to be set WAY early,
 // so ... yeah. we'll just do it my way.
 wheretoCheck = p_form;
 associatedForm = p_form;
 howtoCheck = p_howtoCheck;
 return;
}
//-----------------------------------------------------------------------
void classFilterObject::SetInform(TObject * p_form, InformForm p_howtoInform)
{
 // set these local variables
 // yes, i know -- add and edit use associatedForm, and you call them together...
 // and then, this function. where you ALSO set associatedForm. well... i'm worried
 // about the order in which SetAddEdit gets called -- you want this to be set WAY early,
 // so ... yeah. we'll just do it my way.
 wheretoInform = p_form;
 associatedForm = p_form;
 howtoInform = p_howtoInform;
 return;
}
//-----------------------------------------------------------------------
AddRecord classFilterObject::HowToAdd()
{
 // make sure they can view their own data after putting it in. heh.
 if (HasSecurityAdd() && HasSecurityView())
  return howtoAdd;
 return NULL;
}
//-----------------------------------------------------------------------
EditRecord classFilterObject::HowToEdit()
{
 // must allow the edit screen to come up even if you don't have edit
 // permissions, since that's the only way of viewing the WHOLE record,
 // and the form is responsible for security on its own... the following
 // code is correct.
 if (HasSecurityView())
  return howtoEdit;
 return NULL;
}
//-----------------------------------------------------------------------
CheckRecord classFilterObject::HowToCheck()
{
 return howtoCheck;
}
//-----------------------------------------------------------------------
InformForm classFilterObject::HowToInform()
{
 return howtoInform;
}
//-----------------------------------------------------------------------
TObject * classFilterObject::WhereAction()
{
 return associatedForm;
}
//-----------------------------------------------------------------------
string classFilterObject::GetSelectedRecordID()
{
 if (column_id != -1 && listSearchResults->Selected)
  return visible_data[listSearchResults->Selected->Index][column_id];
 return "";
}
//-----------------------------------------------------------------------
// jhaley 20110906: Added as needed by IV filter in TframeAssessmentIVs
bool classFilterObject::SetSelectedRecordID(const string &id)
{
  // Must have id
  if(!listSearchResults || column_id == -1)
    return false;

  // Find id in visible_data:
  int index = -1;

  for(int i = 0; i < (int)(visible_data.size()); i++)
  {
    if(visible_data[i][column_id] == id)
    {
      index = i;
      break;
    }
  }
  if(index == -1) // Not found?
    return false;

  // Find the list item with that index
  TListItem *item = NULL;

  for(int i = 0; i < (int)(listSearchResults->Items->Count); i++)
  {
    if(listSearchResults->Items->Item[i]->Index == index)
    {
      item = listSearchResults->Items->Item[i];
      break;
    }
  }
  if(item == NULL) // Not found?
    return false;

  // Got it.
  listSearchResults->Selected = item;
  return true;
}
//-----------------------------------------------------------------------
bool classFilterObject::GetHeader()
{
 //pass the status of the headers in the list view
 return show_headers;
}
//-----------------------------------------------------------------------
void classFilterObject::SetHeader(bool new_header_status)
{
  //set the headers to show or not show
  show_headers = new_header_status;
  if (listSearchResults)
   listSearchResults->ShowColumnHeaders = show_headers;
}
//-----------------------------------------------------------------------
bool classFilterObject::GetIconStatus ()
{
 //pass the status of the icons in the list view
 return show_icons;
}
//-----------------------------------------------------------------------
void classFilterObject::SetIconStatus(bool new_icon_status)
{
 //set the icons to show  or not show
 show_icons = new_icon_status;

 // copied from SetCheck(bool) rather than causing a rebuild by adding a function.
 if (is_checkboxes && show_icons)
 {
  listSearchResults->SmallImages = image_list;
  listSearchResults->StateImages = image_list;
 } else
// if (is_checkboxes || show_icons)
 {
  listSearchResults->SmallImages = image_list;
  listSearchResults->StateImages = NULL;
/*
 } else
 {
  listSearchResults->SmallImages = NULL;
  listSearchResults->StateImages = NULL;
*/
 }
}
//-----------------------------------------------------------------------
int CompareByType (string a, string b, sort_type as_what)
{
 switch (as_what)
 {
  case as_text:
   return TemplateCompare (a, b);
  case as_date:
   return TemplateCompare (Pdate(a, global_mode), Pdate(b, global_mode));
  case as_int:
   return TemplateCompare (StringToInt(a), StringToInt(b));
  case as_double:
   return TemplateCompare (StringToFinancial(a), StringToFinancial(b));
  case as_time:
   return TemplateCompare (Ptime(a, global_mode), Ptime(b, global_mode));
  case as_stamp:
   return TemplateCompare (Pstamp(a, global_mode), Pstamp(b, global_mode));
 }
 return 0;
}

template <class T>
int TemplateCompare (T a, T b)
{
 if (a < b) return -1;
 if (a > b) return 1;
 return 0;
}
//-----------------------------------------------------------------------
struct field_compare
{
 sort_type as_what;
 bool asc;
 field_compare (sort_type _as_what, bool _asc) : as_what(_as_what), asc(_asc) {};
 bool operator () (string a, string b)
 {
  if (!asc)
   swap(a, b);
  switch (as_what)
  {
   case as_text:
    return a < b;
   case as_date:
    return Pdate(a, global_mode) < Pdate(b, global_mode);
   case as_int:
    return StringToInt(a) < StringToInt(b);
   case as_double:
    return StringToFinancial(a) < StringToFinancial(b);
   case as_time:
    return Ptime(a, global_mode) < Ptime(b, global_mode);
   case as_stamp:
    return Pstamp(a, global_mode) < Pstamp(b, global_mode);
  }
  return false;                        
 }
};

struct row_compare
{
 field_compare how;
 unsigned int col;
 row_compare (field_compare _how, int _col) : how(_how), col(_col) {};
 bool operator () (const vector<string> & a, const vector<string> & b)
 {
  if (col < min(a.size(), b.size()))
   return how(a[col], b[col]);
  else
   return true;
 }
};

//-----------------------------------------------------------------------
void classFilterObject::RefreshDataSet()
{
  if (listSearchResults)
  {
   if (!IsVisible(listSearchResults))
   {
    is_pending =  true;
    listSearchResults->OnAdvancedCustomDraw = funcAdvancedCustomDraw;
   } else
   {
    is_pending = false;
    listSearchResults->OnAdvancedCustomDraw = NULL;
    ForceRefreshDataSet();
   }
  }
}
//-----------------------------------------------------------------------
void classFilterObject::RefreshIfPending ()
{
 if (is_pending)
  ForceRefreshDataSet();
}
//-----------------------------------------------------------------------
void classFilterObject::ForceRefreshDataSet()
{
  if (listSearchResults) // jhaley 20101007: Evidently this was checked everywhere *but* here.
    listSearchResults->OnAdvancedCustomDraw = NULL;
  is_pending = false;

  string form_name = (associatedForm) ? AnsiString(associatedForm->ClassName(associatedForm->ClassType())).c_str() : "";
  #ifdef use_tcpip_messaging
  if(debug_level[libraries]>=2 && tcpip_message_router)
  {
    tcpip_message_router->SendMessageToAll("debug",
      "Refreshing dataset for listview with preferences '" + preferences_name + "' on form '" + form_name
      + "' using SQL:\n" + GetSQLStatement());
  }
  #endif

  // jhaley 20101007: This may be meant to be able to work without a valid listview, but it historically has not, so I'm
  // going to watch for places that try to use it this way and make sure they're all working properly.
#ifdef use_prometheus_util
  if (!listSearchResults)
  {
    string message = "Refreshing a filter (" + preferences_name + ") with NULL listSearchResults on form " + form_name;
    PPretendToSay(message, m_debug, "util");
  }
#endif

  // Warning!  It assumes if no transaction is set, you know what you're doing!  Built-in data
  // sources are not currently written to check for valid transaction, open database, etc.
  if(!local_transaction || local_transaction->DefaultDatabase->TestConnected())
  {
   vector<string> previously_selected_id_values;
   set<string> to_be_reselected_id_values;
   TListColumn * temp_col = NULL;

   if (listSearchResults)
   {
    // try to remember this so we can fix it up later ... ?
    previously_selected_id_values = GetMultiID();
    VecToSet(previously_selected_id_values, to_be_reselected_id_values);

    prev_scroll = listSearchResults->TopItem->Index;

    listSearchResults->Items->BeginUpdate();
    listSearchResults->Items->Count = 0;
    listSearchResults->Columns->Clear();
    listSearchResults->Items->EndUpdate();

    listSearchResults->Cursor = crAppStart;
    listSearchResults->ShowColumnHeaders = show_headers;
    temp_col = listSearchResults->Columns->Add();
    // jhaley 20100903: Check for a NULL pointer here. Evidently Add() can silently fail and return NULL.
    if (temp_col)
    {
      temp_col->Caption = "Searching...";
      temp_col->Width = listSearchResults->ClientWidth;
    }
   }

   lack_dataset = true;

   if (listSearchResults)
    listSearchResults->Repaint();

   listview_text = "";
   UpdateText();

   // if the sqlstmt is empty still display the column headers
   try
   {
    data_source->Begin(local_transaction);

    if (temp_col)
     temp_col->Caption = "Retrieving...";
    listSearchResults->Repaint();

    raw_data.clear();
    visible_data.clear();

    // names
    data_source->GetFieldNames(field_names);

    // types
    data_source->GetFieldTypes(field_types);

    // values
    vector<string> temporary_data_row;
    while (data_source->GetRow(temporary_data_row))
     raw_data.push_back(temporary_data_row);

    raw_data.resize(raw_data.size());
    all_row_count = raw_data.size();

    data_source->End();
    lack_dataset = false;
   }
   catch (...)
   {
    string form_class_name = "";
    string list_view_name  = "";
    string class_name = "classFilterObject";

    AV_TRY
     if (associatedForm)
     {
      ShortString temp_short = associatedForm->ClassName(associatedForm->ClassType());
      AnsiString  temp_ansi(temp_short);
      form_class_name = temp_ansi.c_str();
     }
    AV_CATCH
    AV_TRY
     if (listSearchResults)
     {
      list_view_name = listSearchResults->Name.c_str();
     }
    AV_CATCH

    string message = "Could not execute query";
    string extended_info = form_class_name + "::" + list_view_name + "(" + preferences_name + ") " + GetSQLStatement();
    #ifdef use_prometheus_util
    PPretendToSay(message, m_debug, "util");
    PSay(message, m_database_error, MB_OK, "classFilterObject", extended_info);
    #else
    Application->MessageBox(message.c_str(), "debug", MB_OK);
    #endif
   }

   //AutoGenerateColumnSpecs can return false... how should we handle that?  :-)
   if (auto_column_specs)
     AutoGenerateColumnSpecs();

   if (listSearchResults)
   {
    RefreshListView(); // you need this to run so visible_data will contain data so that set-checked functions have something to run against!

    // try to make it like it was again ...
    // -if- there's something to do -and- we're not risking already checking/unchecking stuff
    if (!to_be_reselected_id_values.empty())
    {
     UncheckAll();
     SetCheckedWhereID(to_be_reselected_id_values, true);
     MoveToFirstUsefulItem();
    }

    // fresh data for the external conditional-checking function, if any
    map<string, string> transformed_row;
    if (column_id != -1 && is_checkboxes && howtoCheck && wheretoCheck)
    {
     UncheckAll();
     for (deque<vector<string> >::iterator z = raw_data.begin(); z != raw_data.end(); z++)
     {
      for (unsigned int i = 0; i < ColumnVec.size(); i++)
       transformed_row[ColumnVec[i].columnName] = FormatString((*z)[i], ColumnVec[i].StringType);
      if ((wheretoCheck->*howtoCheck)(transformed_row))
       checked_data.insert((*z)[column_id]);
     }
     MoveToFirstUsefulItem();
    }

    // process anything else pending on top of the previous (should the previous happen only if none of the following will?)
    if (is_pending_check_all)
     CheckAll();
    if (is_pending_check_where_id)
     SetCheckedWhereID(set_where_id, is_make_checked_where_id);
    if (is_pending_check_where_not_id)
     SetCheckedWhereNotID(set_where_not_id, is_make_checked_where_not_id);
    listSearchResults->Cursor = crDefault;
    if (is_hiding_unchecked) // then we need another pass
      RefreshListView(true);
    listSearchResults->Refresh();
   }
  }
}
//-----------------------------------------------------------------------
bool classFilterObject::CheckRawDataRowSizes(int index)
{
  // jhaley 20110907: If columns are accidentally omitted from the SQL query, this will cause an out-of-bounds
  // access to the vector<string> row of the raw_data deque. This error could, on occasion, cause the entire program
  // to abort via causing heap corruption.
  for(deque<vector<string> >::iterator z = raw_data.begin(); z != raw_data.end(); ++z)
  {
    if(index >= (*z).size())
    {
      PSay("There seems to be a problem with the SQL statement for this filter (missing data columns).\n\n"
           "Please contact a programmer immediately.",
           m_debug, MB_OK, "classFilterObject", GetSQLStatement());
      return false;
    }
  }

  return true;
}
//-----------------------------------------------------------------------
void classFilterObject::RefreshListView(bool apply_hiding_unchecked_logic)
{
 string form_name = (associatedForm) ? AnsiString(associatedForm->ClassName(associatedForm->ClassType())).c_str() : "";

 #ifdef use_tcpip_messaging
 if(debug_level[libraries]>=2 && tcpip_message_router)
   tcpip_message_router->SendMessageToAll("debug", "Refreshing listview with preferences '" + preferences_name + "' on form '" + form_name + "'");
 #endif

 // display the column headers (this resets sort_column_pointer, id_column_index,
 // and icon_column_index)
 if (!listSearchResults)
  return;

 // jhaley 20110907: Must range-check column_icon here. See function above for full explanation.
 if (column_icon != -1 && !CheckRawDataRowSizes(column_icon))
   return;

 is_refreshing_listview = true;

 listSearchResults->Items->BeginUpdate();

 RefreshHeaders ();

 visible_data.clear();
 for (deque<vector<string> >::iterator z = raw_data.begin(); z != raw_data.end(); z++)
 {
  if (column_icon == -1 || CurrentVec[StringToInt((*z)[column_icon])].showCurrent)
  {
   if(!apply_hiding_unchecked_logic || !is_hiding_unchecked || checked_data.find((*z)[column_id]) != checked_data.end())
   {
    visible_data.push_back(*z);

    // this is as good a place as any...keep track of the widest value in each column
    int first_visible_column = -1; // first visible column will have current_types icons, if any
    for (unsigned int i = 0; i < ColumnVec.size(); i++)
    {
     if (ColumnVec[i].showCol && first_visible_column == -1)
       first_visible_column = i;
     string the_text = FormatString((*z)[i], ColumnVec[i].StringType);

     int aw = listSearchResults->Canvas->TextWidth(the_text.c_str());
     if (aw <= 0)
      aw = 8; // TODO -c MAGIC_NUMBER: minimum field width
     else
     {
      if (show_icons && i == first_visible_column) // there be icons on this 'ere column
       aw += 26; // TODO -c MAGIC_NUMBER: icon width + internal column padding
      else
       aw += 12; // TODO -c MAGIC_NUMBER: internal column padding
     }

     ColumnVec[i].AutosizeWidth = max(ColumnVec[i].AutosizeWidth, aw);
    } // end for
   } // end if
  } // end if
 } // end for

 visible_data.resize(visible_data.size());
 visible_row_count = visible_data.size();

 listSearchResults->Items->Count = visible_row_count;

 //if there are no columns shown, do nothing with the listview
 //also, if the user doesn't have permissions, humbug once and for all!

 listview_text = "";
 if (!lack_columns && !lack_dataset && HasSecurityView())
 {
  UpdateHint();
  if (sort_column_pointer)
   Sort(sort_column_pointer, false);
 }
 else if (!HasSecurityView())
 {
  listview_text = "Permission denied.";
 }
 else if (lack_columns)
 {
  listview_text = "No columns selected.";
 }
 else if (lack_dataset)
 {
  listview_text = "Intentionally blank.";
 }
 else if (!GetResultSize() && GetDatasetSize())
 {
  listview_text = IntToString(GetDatasetSize()) + " rows filtered out."; // TODO: don't suppose we could put this thing at the end of the list regardless, eh?
 }
 else
  listview_text = "";

 UpdateText();

 if (GetAutosizeColumns())
  AutosizeColumns();

 listSearchResults->Items->EndUpdate();
 is_refreshing_listview = false;

 // fine idea, but:
 // - MakeVisible doesn't place said item at the -top- of the list, so it's off by a few rows
 // - the top item wasn't necessarily perfectly aligned
 // - the better functions don't apply to vsReport
 // - scrollbars aren't directly accessible
 // - this gets overridden anyway by the ->Selected item being made visible via MakeVisible
 // if (prev_scroll < listSearchResults->Items->Count && prev_scroll >= 0)
 //  listSearchResults->Items->Item[prev_scroll]->MakeVisible(false);

 // tell the form that stuff has ACTUALLY happened, yup =)
 if (howtoInform && wheretoInform)
  (wheretoInform->*howtoInform)();

 // woah, this gets heavy! (subclassing would be so much easier, neh? later!)
/*
 original_window_proc = (WNDPROC)GetWindowLong(listSearchResults->Handle, GWL_WNDPROC);
 SetWindowLong(listSearchResults->Handle, GWL_WNDPROC, (LONG)FilterRedirectedWndProc);
*/
}
//-----------------------------------------------------------------------
string FormatString(string tempstring, show_type columntype)
{
 switch (columntype)
 {
  case prettyString:
   return PrettyString(tempstring);
  case uppercaseString:
   return UppercaseString(tempstring);
  case lowercaseString:
   return LowercaseString(tempstring);
  case sentenceString:
   return SentenceString(tempstring);
  case prettySSNString:
   return PrettySSN(tempstring);
  case prettyPhoneString:
   return FormatPhoneNumber(tempstring);
  case prettyZipString:
   return FormatZipCode(tempstring);
  case amountString:
   return FinancialToString(StringToFinancial(tempstring), true, 2);
  case dollarString:
   return "$ " + FinancialToString(StringToFinancial(tempstring), true, 2);
  case prettyBoolString:
   return PrettyString(IntToBoolString(StringToInt(tempstring)));
  case repeatingString:
   return RepeatingString(tempstring);
  case nonzeroAmountString:
   if (StringToFinancial(tempstring) == 0.00)
    return string("");
   else
    return FinancialToString(StringToFinancial(tempstring), true, 2);
  case prettyLogString:
   if(tempstring == "1")
    return "In";
   else
    return "Out";
  case rawString:
   return tempstring;
  case intString:
   return tempstring;
  case statString:
   return FinancialToString(StringToFinancial(tempstring), false, 1);
  case addressString:
   return FormatAddress(tempstring);
  default:
   return PrettyString(tempstring);
 }
}
//-----------------------------------------------------------------------
void classFilterObject::ChangeColumnIcon (TListColumn *Column, bool flip_direction)
{
 if (!listSearchResults)
  return;

 //Once in a land called Classes, there was a function called blacksquare...
 if (flip_direction)
  if (Column == sort_column_pointer)
   sort_asc = !sort_asc;
  else
   sort_asc = true;

 // erase images on all column headers
 for (int i = 0; i < listSearchResults->Columns->Count; i++)
  listSearchResults->Columns->Items[i]->ImageIndex = -1;

 // put an image on the one we're moving to
 sort_column_pointer = Column;
 sort_column_pointer->ImageIndex = (sort_asc) ? 2 : 1;

 // figure out which absolute column number that corresponds to
 // jhaley: "first" member is the index into ColumnVec that corresponds to this Column.
 pair<int, int> *column_indices = (pair<int, int> *)(Column->Tag);
 sort_column_index = column_indices->first;
 return;
}
//-----------------------------------------------------------------------
void classFilterObject::RefreshHeaders ()
{
 if (!listSearchResults || ColumnVec.empty())
  return;

  // if the currently sorting column is -not- set to be visible, we
  // should elect a new one. and that should be the first one visible.
  if (!ColumnVec[sort_column_index].showCol)
  {
   int temp_sort_index = 0;
   for (vector<classColumn>::iterator i_column = ColumnVec.begin();
        i_column != ColumnVec.end(); i_column++, temp_sort_index++)
   {
    if (i_column->showCol)
    {
     sort_column_index = temp_sort_index;
     sort_asc = true;
     break;
    }
   }
  }
  // take out current column headers
  listSearchResults->Columns->Clear();
  listSearchResults->ShowColumnHeaders = show_headers;

  // add new ones
  int temp_column_index = 0;
  TListColumn * temp_column_pointer;
  sort_column_pointer = NULL;
  column_icon = -1;
  column_id = -1;
  for (vector<classColumn>::iterator i_column = ColumnVec.begin();
       i_column != ColumnVec.end(); i_column++, temp_column_index++)
  {
   // since this is called before refresh list view, we will also
   // figure out where the icon and id fields are...
   if (i_column->requires == "current_id")
    column_icon = temp_column_index;

   if (i_column->requires == "internal_id")
    column_id = temp_column_index;

   // actual column creation
   if (i_column->showCol)
   {
    temp_column_pointer = listSearchResults->Columns->Add();
    temp_column_pointer->Caption = i_column->columnName.c_str();
    // initially we set AutosizeWidth to the width of the column header; if field values are wider, they will override this in RefreshListView()
    string the_text = i_column->columnName;
    int aw = listSearchResults->Canvas->TextWidth(the_text.c_str());
    if (aw <= 0)
     aw = 8; // TODO -c MAGIC_NUMBER: minimum field width
    else
    {
     if (temp_column_index == sort_column_index) // are we sorting by this column?
      aw += 44; // TODO -c MAGIC_NUMBER: sort icon + internal column padding
     else
      aw += 12; // TODO -c MAGIC_NUMBER: internal column padding
    }
    i_column->AutosizeWidth = aw;
    i_column->indices.second = temp_column_pointer->Index; // jhaley: store original index into Columns collection
    temp_column_pointer->Tag = (int)&(i_column->indices);  // jhaley: make Tag point to indices pair
    temp_column_pointer->Width = i_column->ColumnWidth;
    temp_column_pointer->AutoSize = (i_column->ColumnWidth == 0);
    temp_column_pointer->Alignment = (i_column->align_how);
    i_column->currently_at = temp_column_pointer;
    if (temp_column_index == sort_column_index)
    {
     if (listSearchResults->SmallImages)
      temp_column_pointer->ImageIndex = (sort_asc) ? 2 : 1;
     sort_column_pointer = temp_column_pointer;
    }
   }
  }

  //if there are no columns do nothing in the listview
  lack_columns = (listSearchResults->Columns->Count == 0);
}
//----------------------------------------------------------------------
void classFilterObject::Sort (TListColumn *Column, bool flip_direction)
{
 if (!listSearchResults)
  return;
 if (!Column)
  return;

 if (is_pending)
 {
  ForceRefreshDataSet ();
  return;
 }
 // this code and the chunk slightly farther down were to fix the issue of selection not following the appropriate items when sorting (asc/desc, or by different column) changes.
 // this bug was introduced with virtual listviews and is now fixed (though I'd still like to know why UncheckAll didn't work and I had to use SetCheckedWhereNotID(...,false) instead).
 // from ForceRefreshDataset, part 1
 vector<string> previously_selected_id_values;
 set<string> to_be_reselected_id_values;
 previously_selected_id_values = GetMultiID();
 VecToSet(previously_selected_id_values, to_be_reselected_id_values);
 // end from ForceRefreshDataset, part 1


 ChangeColumnIcon (Column, flip_direction);
 if (sort_column_index > -1 && sort_column_index < ColumnVec.size())
  stable_sort(visible_data.begin(), visible_data.end(), row_compare(field_compare(ColumnVec[sort_column_index].as_what, sort_asc), sort_column_index));

 // from ForceRefreshDataset, part 2
 if (!to_be_reselected_id_values.empty())
 {
  // UncheckAll(); // not..fucking..working.  We'll -force- it!
  SetCheckedWhereNotID(to_be_reselected_id_values, false);
  SetCheckedWhereID(to_be_reselected_id_values, true);
 }
 // end from ForceRefreshDataset, part 2

 listSearchResults->Refresh();
 MoveToFirstUsefulItem();
}
//-----------------------------------------------------------------------
bool classFilterObject::HasData ()
{ // have we fetched data yet?  Useful for, say, calling Get(Result|Dataset)Size
  // for informational purposes only (don't want to refresh if the filter hasn't
  // been made visible on the screen yet), etc.
 return !lack_dataset;
}
//-----------------------------------------------------------------------
int classFilterObject::GetResultSize ()
{
 RefreshIfPending ();

 return visible_row_count; // visible rows
}
//-----------------------------------------------------------------------
int classFilterObject::GetDatasetSize ()
{
 RefreshIfPending ();

 return all_row_count; // all rows
}
//-----------------------------------------------------------------------
string classFilterObject::GetPreferences()
{
 // [show_headers:0|1][sort_asc:0|1][last_column:int]|[show columns:0|1]|[current_types:0|1]
 string answer;
 answer += (show_headers) ? "1" : "0";
 answer += (sort_asc) ? "1" : "0";
 answer += IntToString (sort_column_index);
 answer += "|";
 for (vector<classColumn>::iterator i_column = ColumnVec.begin();
      i_column != ColumnVec.end(); i_column++)
  answer += (i_column->showCol) ? "1" : "0";
 answer += "|";
 for (vector<classCurrent>::iterator i_current = CurrentVec.begin();
      i_current != CurrentVec.end(); i_current++)
  answer += (i_current->showCurrent) ? "1" : "0";
 return answer;
}
//-----------------------------------------------------------------------
void classFilterObject::SetPreferences(const string & p_preferences)
{
 string serialized = p_preferences;
 unsigned int p_extra = serialized.find("|");

 if (p_extra == string::npos)
  return;

 string bool_int = serialized.substr(0, p_extra);
 serialized = serialized.substr (p_extra + 1);

 // process the bool_int part of this, which is xyz, where x and y are "0" or "1"
 // and z is an int of unknown length (1 character at least)
 if (p_extra < 3)
  return;
 show_headers = (bool_int[0] == '1');
 sort_asc     = (bool_int[1] == '1');
 sort_column_index = StringToInt(bool_int.substr(2));

 // Set up preferences based on a string of booleans (on/off current/column)
 unsigned int p_length = serialized.length();
 unsigned int p_pipe   = serialized.find("|");

 // no pref, no pipe, or pipe at the end (which is livable, but might as well not)
 if (p_length == 0 || p_pipe == string::npos || p_pipe == p_length - 1)
  return;
 else
 {
  string p_columns;
  string p_current;
  p_columns = serialized.substr(0, p_pipe);
  p_current = serialized.substr(p_pipe + 1);

  unsigned int num_pref_columns = p_columns.length();
  unsigned int num_pref_current = p_current.length();
  unsigned int num_actual_columns = ColumnVec.size();
  unsigned int num_actual_current = CurrentVec.size();

  // for both column and current, go through the shortest list of given values, and assign
  // them to the vectors - '0' is off, '1' is on.
  for (unsigned int i_column = 0; i_column < min(num_pref_columns, num_actual_columns); i_column++)
  {
   ColumnVec[i_column].showCol = false;
   string needed_permission = FullPerm(ColumnVec[i_column].requires);

   if (needed_permission == "")
   {
    ColumnVec[i_column].showCol = (p_columns[i_column] == '1');
   } else if (LikeString("table.%", needed_permission))
   {
    if  ((*user_permissions)[needed_permission]["view"] == "true")
     ColumnVec[i_column].showCol = (p_columns[i_column] == '1');
   } else
   {
    if ((*user_permissions)[needed_permission]["enabled"] == "true")
     ColumnVec[i_column].showCol = (p_columns[i_column] == '1');
   }
  }
  for (unsigned int i_current = 0; i_current < min(num_pref_current, num_actual_current); i_current++)
   CurrentVec[i_current].showCurrent = (p_current[i_current] == '1');
 }
 return;
}

//-----------------------------------------------------------------------
void classFilterObject::SetSecurity (const string & p_table_name)
{
 requires = p_table_name;
 return;
}
//-----------------------------------------------------------------------
string classFilterObject::GetSecurity ()
{
 return requires;
}
//-----------------------------------------------------------------------
bool classFilterObject::HasSecurityView ()
{
 string needed_permission = FullPerm(requires);

 if (needed_permission == "")
  return true;
 else if (LikeString("table.%", needed_permission))
  return ((*user_permissions)[needed_permission]["view"] == "true");
 else
  return ((*user_permissions)[needed_permission]["enabled"] == "true");
}
//-----------------------------------------------------------------------
bool classFilterObject::HasSecurityAdd ()
{
 string needed_permission = FullPerm(requires);

 if (needed_permission == "")
  return true;
 else if (LikeString("table.%", needed_permission))
  return ((*user_permissions)[needed_permission]["insert"] == "true");
 else
  return ((*user_permissions)[needed_permission]["enabled"] == "true");
}
//-----------------------------------------------------------------------
bool classFilterObject::HasSecurityEdit ()
{
 string needed_permission = FullPerm(requires);

 if (needed_permission == "")
  return true;
 else if (LikeString("table.%", needed_permission))
  return ((*user_permissions)[needed_permission]["update"] == "true");
 else
  return ((*user_permissions)[needed_permission]["enabled"] == "true");
}
//-----------------------------------------------------------------------
void classFilterObject::FetchPreferences (string p_name)
{
 if (original_preferences.empty())
  original_preferences = GetPreferences();
 preferences_name = p_name;
 // Let's look and see if any columns are visible, and if they're not, reset
 // preferences to defaults.  This is a workaround that doesn't address the
 // underlying problem:  we're losing user preferences somewhere, but at least
 // they won't get "No columns selected" and not know what it means....
 string prefs = (*user_preferences)["filter"][preferences_name];
 vector<string> pref_vec;
 SplitStringToVec(prefs, "|", pref_vec);
 // Note:  pref_vec[0] is: [show_headers:0|1][sort_asc:0|1][last_column:int]
 //        pref_vec[1] is: [show columns:0|1] (one digit for each column on/off)
 //        pref_vec[2] is: [current_types:0|1] (one digit for each current_type on/off)
 string on_off;
 if (pref_vec.size() < 3) // They don't have preferences to examine, so go with defaults
   SetPreferences(prefs);
 else                     // They have preferences for this filter...
 {
   bool all_off = true;
   for (int i=0; i<pref_vec[1].length(); i++) // So, look at them
   {
     on_off = pref_vec[1].substr(i, 1);
     if (on_off == "1")
     {
       all_off = false;
       break;
     }
   }
   if (!all_off)  // Go with their settings if they look valid
     SetPreferences(prefs);
   else           // But reset to defaults if all columns are turned off
     SetPreferences(original_preferences);
 }
 return;
}
//-----------------------------------------------------------------------
void classFilterObject::ThrowPreferences ()
{
 (*user_preferences)["filter"][preferences_name] = GetPreferences();
 return;
}
//-----------------------------------------------------------------------
string classFilterObject::GetDefaultPreferences ()
{
 return original_preferences;
}
//-----------------------------------------------------------------------
string classFilterObject::FullPerm (string p_partial_pref)
{
 string result;

 if (p_partial_pref == "")
  result = "";
 else if (p_partial_pref == "current_id" || p_partial_pref == "internal_id")
  result = "admin." + p_partial_pref;
 else
  result = "table." + p_partial_pref;

 return result;
}
//-----------------------------------------------------------------------
void classFilterObject::SetMulti (bool p_multiselect)
{
 if (!listSearchResults)
  return;

 // hopefully, this takes care of unselecting stuff ... and hopefully,
 // we'll never need to call it anywhere but on setup of the listview
 is_multiselect = p_multiselect;
 listSearchResults->MultiSelect = is_multiselect;
 if (is_multiselect)
  SetCheck(false);
 return;
}
//-----------------------------------------------------------------------
bool classFilterObject::GetMulti ()
{
 return is_multiselect;
}
//-----------------------------------------------------------------------
void classFilterObject::SetCheck (bool p_checkboxes)
{
 if (!listSearchResults)
  return;

 is_checkboxes = p_checkboxes;

 if (is_checkboxes && show_icons)
 {
  listSearchResults->SmallImages = image_list;
  listSearchResults->StateImages = image_list;
 } else
 if (is_checkboxes || show_icons)
 {
  listSearchResults->SmallImages = image_list;
  listSearchResults->StateImages = NULL;
 } else
 {
  listSearchResults->SmallImages = NULL;
  listSearchResults->StateImages = NULL;
 }

 // hopefully, this takes care of unselecting stuff ... and hopefully,
 // we'll never need to call it anywhere but on setup of the listview
 // listSearchResults->Checkboxes = is_checkboxes; // this was causing trouble? or not? useless now.
 if (is_checkboxes)
  SetMulti(false);
 return;
}
//-----------------------------------------------------------------------
bool classFilterObject::GetCheck ()
{
 return is_checkboxes;
}
//-----------------------------------------------------------------------
vector<string> classFilterObject::GetMultiID()
{
 vector<string> answer;

 if (!listSearchResults)
  return answer;

 RefreshIfPending ();

 if (column_id == -1)
  return answer;

 if (is_checkboxes)
 {
  string id;
  for (unsigned int i = 0; i < visible_row_count; i++)
  {
   id = visible_data[i][column_id];
   if (checked_data.find(id) != checked_data.end())
    answer.push_back(id);
  }
 }
 else
 {
  if (listSearchResults->SelCount)
  {
   TItemStates selected = TItemStates() << isSelected;
   TListItem * Item = listSearchResults->Selected;
   string id;
   while (Item)
   {
    id = visible_data[Item->Index][column_id];
    answer.push_back(id);
    Item = listSearchResults->GetNextItem(Item, sdAll, selected);
   }
  }
 }

 // nothing found -- this is possible, we won't guarantee the vector will get any
 // values ... unlike the other thingie. Search screen will have to adapt? we want
 // this one to be a little more accurate.

 return answer;
}
//-----------------------------------------------------------------------
vector<string> classFilterObject::GetAllID()
{
 vector<string> answer;

 if (!listSearchResults)
  return answer;

 RefreshIfPending ();

 if (column_id == -1)
  return answer;

 answer.reserve(visible_row_count);
 string id;
 for (unsigned int i = 0; i < visible_row_count; i++)
 {
  id = visible_data[i][column_id];
  answer.push_back(id);
 }
 return answer;
}
//-----------------------------------------------------------------------
int classFilterObject::GetIconColumnIndex ()
{
 RefreshIfPending ();
 return column_icon;
}
//-----------------------------------------------------------------------
void classFilterObject::SetCompress (bool p_compress)
{
 // debug -- for some reason, StateIndex requires SmallImages to be set, or clicking will result in divide by zero!
 is_compress = false;

 if (!listSearchResults)
  return;

 // hacked. the old behavior of Compress has been disabled, but we do want to turn off icons if possible.
 SetIconStatus (!p_compress);

 return;
}
//-----------------------------------------------------------------------
bool classFilterObject::GetCompress ()
{
 // hacked. the old behavior of Compress has been disabled, but we do want to turn off icons if possible.
 return !GetIconStatus();
}
//-----------------------------------------------------------------------
void classFilterObject::CheckAll ()
{
 if (!listSearchResults)
  return;

 // TODO -c HACK: this second condition shouldn't even be happening.  Why are we getting called sometimes with the listview not ready yet?
 if (is_pending || (!listSearchResults->Items->Count && !visible_data.empty()))
 {
  is_pending = true; // TODO -c HACK: moar
  is_pending_check_all = true;
 }
 else
 {
  is_pending_check_all = false;
  string id;
  checked_data.clear();
  for (unsigned int i = 0; i < visible_data.size(); i++)
  {
   id = visible_data[i][column_id];
   checked_data.insert(id);
  }
 }

 listSearchResults->Refresh();
 return;
}
//-----------------------------------------------------------------------
void classFilterObject::UncheckAll ()
{
 if (!listSearchResults)
  return;

 checked_data.clear();
 listSearchResults->Refresh();
 return;
}
//-----------------------------------------------------------------------
void classFilterObject::SetTransaction (TIBTransaction * p_local_transaction)
{
 if (p_local_transaction)
  local_transaction = p_local_transaction;
 else
  local_transaction = default_transaction; // the static (global) one
}
//-----------------------------------------------------------------------
void classFilterObject::FlipCheck () // danger, more of the same
{
 if (!listSearchResults)
  return;

 RefreshIfPending ();

 string id;
 for (unsigned int i = 0; i < visible_data.size(); i++)
 {
  id = visible_data[i][column_id];
  if (checked_data.find(id) != checked_data.end())
   checked_data.erase(id);
  else
   checked_data.insert(id);
 }

 listSearchResults->Refresh();
 return;
}
//-----------------------------------------------------------------------
bool classFilterObject::CanFilter () // current_id must be a known field
{
 RefreshIfPending ();
 return (column_icon != -1);
}
//-----------------------------------------------------------------------
bool classFilterObject::CanIdentify () // internal_id must be a known field
{
 RefreshIfPending ();
 return (column_id != -1);
}
//-----------------------------------------------------------------------
void classFilterObject::SetCheckedWhereID (const set<string> & id_to_check, bool make_checked)
{ // TODO -c HACK: this second condition shouldn't even be happening.  Why are we getting called sometimes with the listview not ready yet?
 if (is_pending || (!listSearchResults->Items->Count && !visible_data.empty()))
 {
  is_pending = true; // TODO -c HACK: moar
  is_pending_check_where_id = true;
  is_make_checked_where_id = make_checked;
  set_where_id = id_to_check;
 } else
 {
  if (listSearchResults && CanIdentify())
  {
   is_pending_check_where_id = false;

   string id;
   for (unsigned int i = 0; i < visible_data.size(); i++)
   {
    int local_column_id = column_id;
    id = visible_data[i][column_id];
    set<string>::const_iterator bob;
    if ((bob = id_to_check.find(id)) != id_to_check.end())
    {
     if (is_checkboxes)
     {
      if (make_checked && checked_data.find(id) == checked_data.end())
       checked_data.insert(id);
      else
      if (!make_checked && checked_data.find(id) != checked_data.end())
       checked_data.erase(id);
     } else
     {
      if (make_checked && !listSearchResults->Items->Item[i]->Selected)
       listSearchResults->Items->Item[i]->Selected = true;
      else
      if (!make_checked && listSearchResults->Items->Item[i]->Selected)
       listSearchResults->Items->Item[i]->Selected = false;
     }
     listSearchResults->UpdateItems(i, i);
    }
   }
  }
 }
 return;
}
//-----------------------------------------------------------------------
void classFilterObject::SetCheckedWhereNotID (const set<string> & id_to_check, bool make_checked)
{ // TODO -c HACK: this second condition shouldn't even be happening.  Why are we getting called sometimes with the listview not ready yet?
 if (is_pending || (!listSearchResults->Items->Count && !visible_data.empty()))
 {
  is_pending = true; // TODO -c HACK: moar
  is_pending_check_where_not_id = true;
  is_make_checked_where_not_id = make_checked;
  set_where_not_id = id_to_check;
 } else
 {
  if (listSearchResults && CanIdentify())
  {
   is_pending_check_where_id = false;

   string id;
   for (unsigned int i = 0; i < visible_data.size(); i++)
   {
    id = visible_data[i][column_id];
    set<string>::const_iterator bob;
    if ((bob = id_to_check.find(id)) == id_to_check.end())
    {
     if (is_checkboxes)
     {
      if (make_checked && checked_data.find(id) == checked_data.end())
       checked_data.insert(id);
      else
      if (!make_checked && checked_data.find(id) != checked_data.end())
       checked_data.erase(id);
     } else
     {
      if (make_checked && !listSearchResults->Items->Item[i]->Selected)
       listSearchResults->Items->Item[i]->Selected = true;
      else
      if (!make_checked && listSearchResults->Items->Item[i]->Selected)
       listSearchResults->Items->Item[i]->Selected = false;
     }
     listSearchResults->UpdateItems(i, i);
    }
   }
  }
 }
 return;
}
//-----------------------------------------------------------------------
void classFilterObject::SetHint(string p_hint)
{
  listview_hint = p_hint;
}
//-----------------------------------------------------------------------
void classFilterObject::UpdateHint()
{
  if (listSearchResults)
  {
    string the_hint;
    if (HasSecurityView())
    {
      int num_visible = 0;
      for (vector<classColumn>::iterator i_column = ColumnVec.begin(); i_column != ColumnVec.end(); i_column++)
        if (i_column->showCol)
          num_visible++;
      the_hint = "Displaying\n"
        "     " + IntToString(num_visible) + " of " + IntToString(ColumnVec.size()) + " columns\n"
        "     " + IntToString(visible_row_count) + " of " + IntToString(all_row_count) + " rows";
      /* // actually we need another
      if (is_checkboxes || is_multiselect)
        the_hint += "\n";
      if (is_checkboxes)
        the_hint += "\n" + IntToString(checked_data.size()) + " checked";
      if (is_multiselect)
        the_hint += "\n" + IntToString(listSearchResults->SelCount) + " selected";
      */
      if (listview_hint != "")
        the_hint = the_hint + "\n\n" + listview_hint;
    }
    else
      the_hint = "You do not have permission to view this data";

    listSearchResults->Hint = the_hint.c_str();
  }
}
//-----------------------------------------------------------------------
void classFilterObject::UpdateText()
{
 if (listview_label && listSearchResults)
 {
  listview_label->AutoSize = true;
  listview_label->Caption  = listview_text.c_str();
  listview_label->Left     = (listSearchResults->Width - listview_label->Width) / 2;
  listview_label->Visible  = !(listview_text.empty());
 }
}
//-----------------------------------------------------------------------
void __fastcall classFilterObject::listSearchResultsMouseMove(TObject *Sender, TShiftState Shift, int X, int Y)
{
/* This code is not ready to go live yet
   // if the listview has changed...
   if (listPrevious != listSearchResults)
   {
     // attach static timer OnTimer event to proxy handler in formPrometheusMenu
     // which calls classFilterObject::timerFilterHintTimer, which is static
     timerFilterHint->OnTimer = formPrometheusMenu->timerFilterHintTimerProxy;
     // current listview is now the 'previous' listview for next time
     listPrevious = listSearchResults;
   }
   // update hint text, calculate dimensions of the hint hint window
   UpdateHint();
   floating_hint_pos = hintFloating->CalcHintRect(listSearchResults->Width, listSearchResults->Hint, NULL);
   // convert mouse position from listview (X, Y) to screen (X, Y)
   TPoint relative_pos = listSearchResults->ClientToScreen(TPoint(X, Y));
   // now position the hint relative to the screen and show the hint window (and adjust for offset from mouse)
   floating_hint_pos.Left += relative_pos.x + floating_hint_offset.x;
   floating_hint_pos.Top += relative_pos.y + floating_hint_offset.y;
   floating_hint_pos.Right += relative_pos.x + floating_hint_offset.x;
   floating_hint_pos.Bottom += relative_pos.y + floating_hint_offset.y;
   hintFloating->ActivateHint(floating_hint_pos, listSearchResults->Hint);
*/
}
//-----------------------------------------------------------------------
bool classFilterObject::EnableFloatingHint ()
{
/* This code is not ready to go live yet
 try
 {
  timerFilterHint = new TTimer(NULL);
  timerFilterHint->Interval = 50;
  timerFilterHint->Enabled = true;
  hintFloating = new THintWindow((Classes::TComponent *)(NULL));
  listPrevious = NULL;
  floating_hint_offset = TPoint(0, 20);
 }
 catch (...)
 {
  return false;
 }
 return true;
*/
 return true;
}
//-----------------------------------------------------------------------
void classFilterObject::DisableFloatingHint ()
{
/* This code is not ready to go live yet
 try
 {
   try
   {
     if (timerFilterHint)
     {
       timerFilterHint->OnTimer = NULL;
       timerFilterHint->Enabled = false;
       delete timerFilterHint;
       timerFilterHint = NULL;
     }
     if (hintFloating)
     {
       delete hintFloating;
       hintFloating = NULL;
     }
   }
   catch (Exception &exception)
   {
      Application->MessageBox("caught exception", "debug", MB_OK);
   }
 }
 catch (...)
 {
   Application->MessageBox("caught error", "debug", MB_OK);
 }
*/
}
//-----------------------------------------------------------------------
void __fastcall classFilterObject::timerFilterHintTimer(TObject *Sender)
{
/* This code is not ready to go live yet
    if(listPrevious)
    {
      // get the mouse cursor, relative to the screen
      TMouse *mouse = new TMouse(); TPoint global_mouse = mouse->CursorPos; delete mouse;
      TForm * active_form = Screen->ActiveForm;
      // get the upper left corner and lower right corner coordinates of the listview, relative to the screen
      TPoint top_left = listPrevious->ClientToScreen(TPoint(0,0));
      TPoint bottom_right = listPrevious->ClientToScreen(TPoint(listPrevious->Width, listPrevious->Height));
      RECT ClipBox, ListViewBox;
      HDC handleListView = GetDC(listPrevious->Handle);
      int region_type = GetClipBox(handleListView, &ClipBox);
      ReleaseDC(listPrevious->Handle, handleListView);
      ListViewBox.left = top_left.x;
      ListViewBox.top = top_left.y;
      ListViewBox.right = bottom_right.x;
      ListViewBox.bottom = bottom_right.y;
      // if the mouse cursor is outside of the listview or the listview is not completely visible, hide the hint
      if (global_mouse.x < top_left.x || global_mouse.x > bottom_right.x ||
          global_mouse.y < top_left.y || global_mouse.y > bottom_right.y || // ClipBox != ListViewBox
          !listPrevious->Showing || !listPrevious->Enabled || !Application->Active || !HasAncestor(listPrevious, active_form) ||
          region_type == COMPLEXREGION || region_type == NULLREGION)
      {
        if (region_type != ERROR)
           hintFloating->ReleaseHandle();
      }

     string clip_box = "((" + IntToString(ClipBox.left) + ", " + IntToString(ClipBox.top) + "), (" +
                              IntToString(ClipBox.right) + ", " + IntToString(ClipBox.bottom) + "))";
     string listview_box = "((" + IntToString(ListViewBox.left) + ", " + IntToString(ListViewBox.top) + "), (" +
                                IntToString(ListViewBox.right) + ", " + IntToString(ListViewBox.bottom) + "))";

     //if(debug_level[libraries]>=3 && tcpip_message_router)
     tcpip_message_router->SendMessageToAll("debug", "filter: hint: listview rect: " + listview_box);
     if (region_type == SIMPLEREGION)
       tcpip_message_router->SendMessageToAll("debug", "filter: hint: simple region: " + clip_box);
     else if (region_type == NULLREGION)
       tcpip_message_router->SendMessageToAll("debug", "filter: hint: null region: " + clip_box);
     else if (region_type == COMPLEXREGION)
       tcpip_message_router->SendMessageToAll("debug", "filter: hint: complex region: " + clip_box);
     else if (region_type == ERROR)
       tcpip_message_router->SendMessageToAll("debug", "filter: hint: error (" + IntToString(GetLastError()) + "): " + clip_box);
     else
       tcpip_message_router->SendMessageToAll("debug", "filter: hint: unknown region value: " + clip_box);
    }
*/
}
//-----------------------------------------------------------------------
void classFilterObject::MoveToFirstUsefulItem ()
{
 // TODO: no, this doesn't go to the first non-selected checked thingie ... later. later.
 if (listSearchResults)
 {
  if (listSearchResults->SelCount > 0)
  {
   listSearchResults->Selected->MakeVisible(false); // scrolls to make sure it's visible
  }
 }
}
//-----------------------------------------------------------------------
void classFilterObject::SetAutoColumnSpecs(bool AutoColumnSpecs, bool AutoFormatByType)
{
  auto_column_specs = AutoColumnSpecs;
  auto_format_by_type = AutoFormatByType;
}
//-----------------------------------------------------------------------
void classFilterObject::GetAutoColumnSpecs(bool &AutoColumnSpecs, bool &AutoFormatByType)
{
  AutoColumnSpecs = auto_column_specs;
  AutoFormatByType = auto_format_by_type;
}
//-----------------------------------------------------------------------
bool classFilterObject::ClearColumnSpecs()
{
 try { ColumnVec.clear(); return true; }
 catch (...) { return false; }
}
//-----------------------------------------------------------------------
bool classFilterObject::AutoGenerateColumnSpecs()
{
  bool all_is_well = true;

//  if (SQLstring != "")
//  {
//    SetHeader(false);
    ColumnVec.clear();

//  If it's not a "select" statement, it's going to have problems regardless; this
//  would not have fixed it.
//    string query_type = LowercaseString(StripLeading(SQLstring, " ").substr(0, 6));
//    if (query_type == "select")
    SetSecurity(""); // TODO: why? paul, any ideas?
                     // why what, philip?
    for (unsigned int i = 0; i != field_types.size(); i++)
    {
      // use the field type to determine how to display the data (for sorting, etc.)
      TFieldType ft = field_types[i];
      sort_type compare_as;
      show_type show_as;
/*      if (auto_format_by_type)
      {
        show_as = prettyString;
        if(ft==ftInteger||ft==ftWord||ft==ftSmallint||ft==ftWord||ft==ftAutoInc||ft==ftLargeint)
        {
          compare_as = as_int;
          show_as = intString;
        }
        else if(ft==ftDate)
          compare_as = as_date;
        else if(ft==ftTime)
          compare_as = as_time;
        else if(ft==ftDateTime)
          compare_as = as_stamp;
        else if(ft==ftBoolean)
        {
          compare_as = as_bool;
          show_as = prettyBoolString;
        }
        else if(ft==ftFloat||ft==ftCurrency)
        {
          compare_as = as_date;
          show_as = amountString;
        }
        else
          compare_as = as_text;
      }
      else
      {
        compare_as = as_text;
        show_as = rawString;
      }
*/
      // Changing the logic up slightly: auto_format_by_type will now only set the default for strings, etc.
      // (anything we don't know how to automatically format.  I honestly can't think of a reason you -wouldn't- want
      // to sort obviously-integer fields as integers, etc., and it has been working reliably ... so this now only
      // affects strings.
      // Possible exceptions (in the future?):  Very large integers that don't get converted properly by our existing
      // function, dates or times that you don't want re-formatted with regional settings, floating point numbers that
      // you don't want truncated at 2 digits past the decimal, etc.
      if (auto_format_by_type)
        show_as = prettyString;
      else
        show_as = rawString;

      if(ft==ftInteger||ft==ftWord||ft==ftSmallint||ft==ftWord||ft==ftAutoInc||ft==ftLargeint)
      {
        compare_as = as_int;
        show_as = intString;
      }
      else if(ft==ftDate)
        compare_as = as_date;
      else if(ft==ftTime)
        compare_as = as_time;
      else if(ft==ftDateTime)
        compare_as = as_stamp;
      else if(ft==ftBoolean)
      {
        compare_as = as_bool;
        show_as = prettyBoolString;
      }
      else if(ft==ftFloat||ft==ftCurrency)
      {
        compare_as = as_double;
        show_as = amountString;
      }
      else
        compare_as = as_text;

      string field_name = LowercaseString(field_names[i]);
      AddColumnSpec(field_name,
        (field_name == "id" || field_name == "internal_id") ? "internal_id" :
        (field_name == "current_id" ? "current_id" : ""), // magic
        compare_as, true, 100, show_as);
    }
//  }
//  SetHeader(show_headers);
  return all_is_well;
}
//-----------------------------------------------------------------------
vector<map<string, string> > classFilterObject::GetAllData (bool use_original_field_names, bool selected_rows_only)
{
 vector<map<string, string> > answer;
 vector<string> selected_rows;
 set<string> selected_ids;

 RefreshIfPending ();

 // PSay("'" + ColumnVec[column_id].columnName + "'", m_debug, MB_OK, "classFilterObject");

 if (selected_rows_only)
 {
  selected_rows = GetMultiID();
  VecToSet (selected_rows, selected_ids);
 }

 /*
 for (int i=0; i<ColumnVec.size(); i++)
 {
  PSay("'" + ColumnVec[i].columnName + "'", m_debug, MB_OK, "classFilterObject");
 }

 for (set<string>::iterator itr = selected_ids.begin(); itr != selected_ids.end(); itr++)
 {
  PSay("'" + (*itr) + "'", m_debug, MB_OK, "classFilterObject");
 }
 */

 if (!lack_columns && !lack_dataset && HasSecurityView())
 {
  string temp_string = "";
  map<string, string> row_values;
  int absolute_column_index;
  for (deque<vector<string> >::iterator z = raw_data.begin(); z != raw_data.end(); z++)
  {
   bool ok_to_add = true;
   if (selected_rows_only) // exporting only selected rows and this row (by ID) isn't selected...
    if (selected_ids.find((*z)[column_id]) == selected_ids.end())
     ok_to_add = false;    // then don't add it

   if (ok_to_add)
   {
    absolute_column_index = 0;
    for (vector<classColumn>::iterator i_column = ColumnVec.begin();
         i_column != ColumnVec.end(); i_column++, absolute_column_index++)
    {
     temp_string = (*z)[absolute_column_index];
     temp_string = FormatString(temp_string, i_column->StringType);
     if (use_original_field_names)
      row_values[LowercaseString(field_names[absolute_column_index])] = temp_string;
     else
      row_values[i_column->columnName] = temp_string;
    }
    answer.push_back(row_values);
   }
  }
 }

 return answer;
}
//-----------------------------------------------------------------------
vector<vector<string> > classFilterObject::GetAllData (vector<string> &col_names, vector<show_type> &col_types, bool use_original_field_names, bool selected_rows_only)
{
 vector<vector<string> > answer;
 vector<string> selected_rows;
 set<string> selected_ids;

 RefreshIfPending ();

 if (selected_rows_only)
 {
  selected_rows = GetMultiID();
  VecToSet (selected_rows, selected_ids);
 }

 if (!lack_columns && !lack_dataset && HasSecurityView())
 {
  col_names.clear();
  col_types.clear();
  string temp_string = "";
  vector<string> row_values;
  int absolute_column_index;
  absolute_column_index = 0;
  for (vector<classColumn>::iterator i_column = ColumnVec.begin();
       i_column != ColumnVec.end(); i_column++, absolute_column_index++)
  {
   if (use_original_field_names)
    col_names.push_back(LowercaseString(field_names[absolute_column_index]));
   else
    col_names.push_back(i_column->columnName);
   col_types.push_back(i_column->StringType);
  }
  for (deque<vector<string> >::iterator z = raw_data.begin(); z != raw_data.end(); z++)
  {
   bool ok_to_add = true;
   if (selected_rows_only) // exporting only selected rows and this row (by ID) isn't selected...
    if (selected_ids.find((*z)[column_id]) == selected_ids.end())
     ok_to_add = false;    // then don't add it
   row_values.clear();
   if (ok_to_add)
   {
    absolute_column_index = 0;
    for (vector<classColumn>::iterator i_column = ColumnVec.begin();
         i_column != ColumnVec.end(); i_column++, absolute_column_index++)
    {
     temp_string = (*z)[absolute_column_index];
     temp_string = FormatString(temp_string, i_column->StringType);
      row_values.push_back(temp_string);
    }
    answer.push_back(row_values);
   }
  }
 }

 return answer;
}
//-----------------------------------------------------------------------
TListView * classFilterObject::GetListViewHandle ()
{
 return listSearchResults;
}
//-----------------------------------------------------------------------
void classFilterObject::AutosizeColumns ()
{
 if (listSearchResults)
 {
  for (int i = listSearchResults->Columns->Count - 1, j = ColumnVec.size() - 1; i > -1, j > -1; i--, j--)
  {
   while (!ColumnVec[j].showCol)
     j--; // to keep ColumnVec in lockstep with the listview, we have to skip invisible columns
   if (i>=0 && j>=0)
     listSearchResults->Columns->Items[i]->Width = ColumnVec[j].AutosizeWidth;
   //listSearchResults->Columns->Items[i]->Width = -2; // old stupid way
  }
 }
}
//-----------------------------------------------------------------------
void classFilterObject::SetAutosizeColumns(bool value)
{
 always_autosize_columns = value;
}
//-----------------------------------------------------------------------
bool classFilterObject::GetAutosizeColumns()
{
 return always_autosize_columns;
}
//-----------------------------------------------------------------------
void classFilterObject::CheckSelected ()
{
 if (!listSearchResults)
  return;

 RefreshIfPending ();

 if (is_checkboxes)
 {
  if (listSearchResults->SelCount)
  {
   TItemStates selected = TItemStates() << isSelected;
   TListItem * Item = listSearchResults->Selected;
   string id;
   while (Item)
   {
    int i = Item->Index;
    id = visible_data[i][column_id];
    if (checked_data.find(id) == checked_data.end())
    {
     checked_data.insert(id);
     listSearchResults->UpdateItems(i, i);
    }
    Item = listSearchResults->GetNextItem(Item, sdAll, selected);
   }
  }
 }
 return;
}
//-----------------------------------------------------------------------
void classFilterObject::UncheckSelected ()
{
 if (!listSearchResults)
  return;

 RefreshIfPending ();

 if (is_checkboxes)
 {
  if (listSearchResults->SelCount)
  {
   TItemStates selected = TItemStates() << isSelected;
   TListItem * Item = listSearchResults->Selected;
   string id;
   while (Item)
   {
    int i = Item->Index;
    id = visible_data[i][column_id];
    if (checked_data.find(id) != checked_data.end())
    {
     checked_data.erase(id);
     listSearchResults->UpdateItems(i, i);
    }
    Item = listSearchResults->GetNextItem(Item, sdAll, selected);
   }
  }
 }
 return;
}
//-----------------------------------------------------------------------
void classFilterObject::FlipCheckSelected ()
{
 if (!listSearchResults)
  return;

 RefreshIfPending ();

 if (is_checkboxes)
 {
  if (listSearchResults->SelCount)
  {
   TItemStates selected = TItemStates() << isSelected;
   TListItem * Item = listSearchResults->Selected;
   string id;
   while (Item)
   {
    int i = Item->Index;
    id = visible_data[i][column_id];
    if (checked_data.find(id) == checked_data.end())
     checked_data.insert(id);
    else
     checked_data.erase(id);
    listSearchResults->UpdateItems(i, i);
    Item = listSearchResults->GetNextItem(Item, sdAll, selected);
   }
  }
 }
 return;
}
//-----------------------------------------------------------------------
const vector<string> & classFilterObject::GetFieldNames()
{
 return field_names;
}
//-----------------------------------------------------------------------
const vector<TFieldType> & classFilterObject::GetFieldTypes()
{
 return field_types;
}
//-----------------------------------------------------------------------
const deque<vector<string> > & classFilterObject::GetRawData()
{
 return raw_data;
}
//-----------------------------------------------------------------------
void classFilterObject::SetRowAttributes(TListItem *Item)
{
 if (Item->Index < visible_data.size())
 {
  vector<string> & z = visible_data[Item->Index];

  int state_index;
  int image_index;

  // set 'checked'
  if (is_checkboxes && column_id != -1)
   if (checked_data.find(z[column_id]) != checked_data.end())
    state_index = 1 + 9;
   else
    state_index = 0 + 9;
  else
   state_index = -1;

  // set the icon
  if (show_icons)
   if (column_icon != -1)
    if (!z[column_icon].empty() && IsInt(z[column_icon]))
     image_index = StringToInt(z[column_icon]) + 3; // data! and very hard to change! yay! // TODO -c magic: current_types! w00t!
    else
     image_index = 0; // blank!
   else
    image_index = 0; // no such column
  else
   image_index = -1; // don't care about it

  // actually assign to the right spot, based on how many we need to show ... (ew? but works? i hope?)
  if (state_index != -1 && image_index != -1)
  {
   Item->StateIndex = state_index;
   Item->ImageIndex = image_index;
  } else
  if (state_index != -1)
  {
   Item->ImageIndex = state_index;
  } else
  if (image_index != -1)
  {
   Item->ImageIndex = image_index;
  } else
  {
  }

  string temp_string;

  // set the caption/subitems, with formatting
  int visible_column_index = 0;
  for (unsigned int i = 0; i < ColumnVec.size(); i++)
  {
   if (ColumnVec[i].showCol)
   {
    temp_string = FormatString(ReplaceAnyCharWithString(z[i], "\n\r\t", "; "), ColumnVec[i].StringType);
    if (visible_column_index == 0)
     Item->Caption = temp_string.c_str();
    else
     Item->SubItems->Add(temp_string.c_str());
    visible_column_index++;
   }
  }
 }
}
//-----------------------------------------------------------------------

template <class T>
string bit_representation(T i)
{
 string answer;
 T one = 1;
 for (int j = 0; j < sizeof(T) * 8; j++)
 {
  answer = (i & one ? "1" : "0") + answer;
  if ((j + 1) % 4 == 0)
  {
   answer = " " + answer;
   if ((j + 1) % 8 == 0)
    answer = " " + answer;
  }
  i >>= 1;
 }
 return answer;
}

void classFilterObject::KeyPressed(WORD &Key, TShiftState Shift)
{
 // respond to exactly control-a, not control-shift-a, control-alt-a, etc.
 if (is_multiselect &&
      Shift.Contains(ssCtrl) &&
     !Shift.Contains(ssShift) &&
     !Shift.Contains(ssAlt) &&
     (Key == 'a' || Key == 'A'))
  for (int i = 0; i < visible_row_count; i++)
   listSearchResults->Items->Item[i]->Selected = true;

 if (column_id != -1 && !is_check_locked)
  if (!Shift.Contains(ssCtrl) &&
      !Shift.Contains(ssShift) &&
      !Shift.Contains(ssAlt) &&
      Key == VK_SPACE &&
      listSearchResults->Selected)
  {
   int i = listSearchResults->Selected->Index;
   string id = visible_data[i][column_id];
   if (checked_data.find(id) == checked_data.end())
    checked_data.insert(id);
   else
    checked_data.erase(id);
   listSearchResults->UpdateItems(i, i);
  }

 if (sort_column_pointer)
  if (!Shift.Contains(ssCtrl) &&
      !Shift.Contains(ssShift) &&
      !Shift.Contains(ssAlt) &&
      Key != VK_SPACE)
  {
   UINT bob = MapVirtualKey(Key, 2);
   if (bob)
   {
    char d = (char)bob;
    if (d >= 'a' && d <= 'z')
     d += ('A' - 'a');

    TListItem * s = listSearchResults->Selected;
    if (!s)
     s = listSearchResults->Items->Item[0];
    if (s)
    {
     int k = 0;
     bool col_found = false;
     for (unsigned int o = 0; o < ColumnVec.size() && (!col_found); o++, k++)
      if (ColumnVec[o].showCol)
       if (ColumnVec[o].currently_at == sort_column_pointer)
       {
        col_found = true;
        break; // if we don't break, k gets incremented again, -then- it stops. oops?
       }

     if (!col_found)
      return;

     int i = s->Index;
     for (unsigned int j = 0; j < visible_data.size(); j++)
     {
      if (i != s->Index)
      {
       string t = visible_data[i][k];
       if (!t.empty())
       {
        char c = t[0];
        if (c >= 'a' && c <= 'z')
         c += ('A' - 'a');
        if (c == d)
        {
         listSearchResults->Selected = NULL;
         listSearchResults->Selected = listSearchResults->Items->Item[i];
         listSearchResults->ItemFocused = listSearchResults->Selected;
         listSearchResults->Selected->MakeVisible(false);
         break;
        }
       }
      }
      i++;
      if (i >= visible_data.size())
       i -= visible_data.size();
     }
    }
   }
  }
}
//---------------------------------------------------------------------------
void classFilterObject::Clicked(TObject *Sender)
{
 if (column_id != -1 && is_checkboxes)
 {
  TPoint current_mouse_position = Mouse->CursorPos;
  TPoint current_window_position = listSearchResults->ClientOrigin;
  int X = current_mouse_position.x - current_window_position.x;
  int Y = current_mouse_position.y - current_window_position.y;

  THitTests t = listSearchResults->GetHitTestInfoAt(X, Y);

  if (!is_check_locked &&
      ((t.Contains(htOnStateIcon) && show_icons) || // StateIndex
       (t.Contains(htOnIcon) && !show_icons)))      // ImageIndex
  {
   int i = listSearchResults->GetItemAt(X, Y)->Index;
   string id = visible_data[i][column_id];
   if (checked_data.find(id) == checked_data.end())
    checked_data.insert(id);
   else
    checked_data.erase(id);
   listSearchResults->UpdateItems(i, i);
  }
 }
 // jhaley: call original OnClick event handler
 if(DisplacedOnClickHandler != NULL)
   DisplacedOnClickHandler(Sender);
}
//---------------------------------------------------------------------------
 // disabled -- winds up in a recursive loop (stack overflow)
 // this is -despite- the fact that at the end of that function, we call the original one, not our own
 // windows must, somehow, still be seeing ours?
 // or ... something else is resending the message to us? grrr.
 // no clue.
LRESULT FilterRedirectedWndProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
 TWinControl * c = FindControl(hwnd);
 TListView * l = (TListView*)(c);
 classFilterObject * f = (classFilterObject *)(l->Tag);

 if (msg == LVM_SETCOLUMNWIDTH && lparam < 0 && c && f)
 {
  // if we're told to autosize a column, turn around and figure out what a proper size would be and set -that- instead?
  // this way, we avoid calling ourselves ... maybe ... and it's no longer an autosize column, which is good, right?
  int column_number = wparam;
  if (column_number > -1 && column_number < f->listSearchResults->Columns->Count)
  {
   // jhaley: The "first" member is the index into ColumnVec for that TListColumn object. This is what Tag was, on its own, previously.
   pair<int, int> *column_indices = (pair<int, int> *)(f->listSearchResults->Column[column_number]->Tag);
   int field_number = column_indices->first;
   if (field_number > -1 && field_number < f->ColumnVec.size())
   {
    int field_type = f->ColumnVec[field_number].StringType;
    int proposed_width = f->listSearchResults->StringWidth(f->listSearchResults->Column[column_number]->Caption);
    // TODO: optimize by storing the ideal width as we create visible_data ... in the column structure somewhere (ColumnVec)
    for (int i = 0; i < f->visible_row_count; i++)
     proposed_width = max(proposed_width, f->listSearchResults->StringWidth(FormatString(ReplaceAnyCharWithString(f->visible_data[i][field_number], "\n\r\t", "; "), field_type).c_str()));
     // TODO -c HACK: initializing show_type with int?
    // f->listSearchResults->Column[column_number]->Width = proposed_width;
    // instead: modify the message and forward it ... mouah!
    lparam = proposed_width;
   }
  }
 }

 #ifdef STRICT
  WNDPROC MyWindowProcedure = f->original_window_proc;
 #else
  FARPROC MyWindowProcedure = (FARPROC)(f->original_window_proc); // note: this is the code actually being compiled ... included both because a) is seems stupid to be using FARPROC, and b) because the MSDN said so!
 #endif
 return CallWindowProc(MyWindowProcedure, hwnd, msg, wparam, lparam);
}
//---------------------------------------------------------------------------
void classFilterObject::SetCheckLocked (bool v)
{
 is_check_locked = v;
}
//---------------------------------------------------------------------------
bool classFilterObject::GetCheckLocked ()
{
 return is_check_locked;
}
//---------------------------------------------------------------------------
void classFilterObject::SetHideUnchecked (bool v)
{
 is_hiding_unchecked = v;
 if (!is_pending) // if it's pending, we'll just refresh when filter's good and ready
  //RefreshListView(); // otherwise, we'll do it now
  RefreshDataSet(); // better maybe?
}
//---------------------------------------------------------------------------
bool classFilterObject::GetHideUnchecked ()
{
 return is_hiding_unchecked;
}
//---------------------------------------------------------------------------
void classFilterObject::SetDataSource(classFilterSource * ds)
{
 if (ds)
  data_source = ds;
 else
  data_source = &sql_source;
}
//---------------------------------------------------------------------------
classFilterSource * classFilterObject::GetDataSource()
{
 return data_source;
}
//---------------------------------------------------------------------------
classFilterSqlSource::classFilterSqlSource() : classFilterSource(), FSqlStatement()
{
 FTransaction = NULL;

 FDataSet = NULL;
 FORM_TRY
  FDataSet = new TIBDataSet(NULL);
 FORM_CATCH

 FStringList = NULL;
 FORM_TRY
  FStringList = new TStringList;
 FORM_CATCH
}
//---------------------------------------------------------------------------
bool classFilterSqlSource::Begin(TIBTransaction * dbTransaction)
{
 FDataSet->Database = dbTransaction->DefaultDatabase;
 FDataSet->Transaction = dbTransaction;
 FDataSet->UniDirectional = true;

 if (!FSqlStatement.empty())
 {
  FStringList->Clear();
  FStringList->Add(FSqlStatement.c_str());
  FDataSet->Close();
  FDataSet->SelectSQL = FStringList;
  FDataSet->Open();
  FDataSet->First();
 }
 return true;
}
//---------------------------------------------------------------------------
unsigned int classFilterSqlSource::GetFieldCount()
{
 return FDataSet->Fields->Count;
}
//---------------------------------------------------------------------------
bool classFilterSqlSource::GetFieldNames(vector<string> & field_vec)
{
 unsigned int fc = GetFieldCount();
 field_vec.resize(fc);
 for (unsigned int i = 0; i < fc; i++)
  field_vec[i] = FDataSet->Fields->Fields[i]->FieldName.c_str();
 return true;
}
//---------------------------------------------------------------------------
bool classFilterSqlSource::GetFieldTypes(vector<TFieldType> & field_vec)
{
 unsigned int fc = GetFieldCount();
 field_vec.resize(fc);
 for (unsigned int i = 0; i < fc; i++)
  field_vec[i] = FDataSet->Fields->Fields[i]->DataType;
 return true;
}
//---------------------------------------------------------------------------
bool classFilterSqlSource::GetRow(vector<string> & field_vec)
{
 // empty dataset, eh?
 if (FSqlStatement.empty())
  return false;
 if (FDataSet->Eof)
  return false;
 unsigned int fc = GetFieldCount();
 field_vec.resize(fc);
 for (unsigned int i = 0; i < fc; i++)
  field_vec[i] = FDataSet->Fields->Fields[i]->AsString.c_str();
 FDataSet->Next();
 return true;
}
//---------------------------------------------------------------------------
void classFilterSqlSource::End()
{
 FDataSet->Close();
}
//---------------------------------------------------------------------------
void classFilterSqlSource::SetSqlStatement(string sql)
{
 FSqlStatement = sql;
}
//---------------------------------------------------------------------------
string classFilterSqlSource::GetSqlStatement()
{
 return FSqlStatement;
}
//---------------------------------------------------------------------------
classFilterSqlSource::~classFilterSqlSource()
{
 delete FStringList;
 delete FDataSet;
}

//---------------------------------------------------------------------------
classFilterSimpleSource::classFilterSimpleSource()
  : classFilterSource(), row_index(0), field_names(), field_types(), field_values()
{
}
//---------------------------------------------------------------------------
bool classFilterSimpleSource::Begin(TIBTransaction * dbTransaction)
{
 row_index = 0;
 return true;
}
//---------------------------------------------------------------------------
unsigned int classFilterSimpleSource::GetFieldCount()
{
 return field_names.size();
}
//---------------------------------------------------------------------------
bool classFilterSimpleSource::GetFieldNames(vector<string> & field_vec)
{
 field_vec = field_names;
 return true;
}
//---------------------------------------------------------------------------
bool classFilterSimpleSource::GetFieldTypes(vector<TFieldType> & field_vec)
{
 field_vec = field_types;
 return true;
}
//---------------------------------------------------------------------------
bool classFilterSimpleSource::GetRow(vector<string> & field_vec)
{
 if (row_index >= field_values.size())
  return false;
 field_vec = field_values[row_index];
 row_index++;
 return true;
}
//---------------------------------------------------------------------------
void classFilterSimpleSource::End()
{
 row_index = 0;
}
//---------------------------------------------------------------------------
classFilterSimpleSource::~classFilterSimpleSource()
{
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
classFilterVecmapSource::classFilterVecmapSource()
  : classFilterSource(), FFilter(NULL), field_names(), field_values(), source_vecmap(), field_types(), row_index(0),
    sql()
{
}
//---------------------------------------------------------------------------
classFilterVecmapSource::~classFilterVecmapSource()
{
}
//---------------------------------------------------------------------------
bool classFilterVecmapSource::Begin(TIBTransaction * dbTransaction)
{
  // setup default fields
  field_names.clear();
  field_types.clear();
  field_values.clear();
  row_index = 0;

  // setup data and 'extra' fields
  vector<string> fields_in_order;

  // the first row will give us our field names
  for (map<string,string>::iterator itr=source_vecmap[0].begin(); itr!=source_vecmap[0].end(); itr++)
    field_names.push_back(itr->first);

  fields_in_order.clear();
  // jhaley 20100902: You could tell this has never been used, because it was adding the field names as a data row.
  // We need to start on the second row of the vector.
  vector<map<string,string> >::iterator row_itr = source_vecmap.begin();
  row_itr++;
  for (; row_itr != source_vecmap.end(); row_itr++)
  {
    //Application->MessageBox(MapToDelimString((*row_itr), "{", "}", "", "'", "'", "'", "'", ",").c_str(), "row", MB_OK);
    for (vector<string>::iterator col_itr=field_names.begin(); col_itr!=field_names.end(); col_itr++)
    {
      fields_in_order.push_back((*row_itr)[(*col_itr)]);
      //Application->MessageBox(((*row_itr)[(*col_itr)]).c_str(), (*col_itr).c_str(), MB_OK);
    }
    field_values.push_back(fields_in_order);
    fields_in_order.clear();
  }
  return true;
}
//---------------------------------------------------------------------------
bool classFilterVecmapSource::SetSource(vector<map<string, string> > &src)
{
  source_vecmap = src;
  return true;
}
//---------------------------------------------------------------------------
unsigned int classFilterVecmapSource::GetFieldCount()
{
 return field_names.size();
}
//---------------------------------------------------------------------------
bool classFilterVecmapSource::GetFieldNames(vector<string> & field_vec)
{
 field_vec = field_names;
 return true;
}
//---------------------------------------------------------------------------
bool classFilterVecmapSource::GetFieldTypes(vector<TFieldType> & field_vec)
{
 field_vec = field_types;
 return true;
}
//---------------------------------------------------------------------------
bool classFilterVecmapSource::GetRow(vector<string> & field_vec)
{
 if (row_index >= field_values.size())
  return false;
 field_vec = field_values[row_index];
 row_index++;
 return true;
}
//---------------------------------------------------------------------------
void classFilterVecmapSource::End()
{
 row_index = 0;
}
//---------------------------------------------------------------------------
void classFilterVecmapSource::SetFilter (classFilterObject * f)
{
 FFilter = f;
}
//---------------------------------------------------------------------------