//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeBaseDropDown.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TBaseDropDown *)
{
        new TBaseDropDown(NULL);
}
//---------------------------------------------------------------------------
__fastcall TBaseDropDown::TBaseDropDown(TComponent* Owner) : TCustomControl(Owner)
{
 ControlStyle << csAcceptsControls << csReplicatable;
 Width  = 201;
 Height = 21;

 _FORM_TRY
 rubberContainer = new TRubberContainer(this);
 _FORM_CATCH
 rubberContainer->Parent = this;
 rubberContainer->Visible = false;
 rubberContainer->Top = 22;
 rubberContainer->Width = Width;
 rubberContainer->Left = 0;
 rubberContainer->Height = 200;
 rubberContainer->OnPopOut = rubberPopOut;
 rubberContainer->OnPopIn = rubberPopIn;
 rubberContainer->BottomMargin = 0;
 rubberContainer->RightMargin = 0;

 _FORM_TRY
 panelStuff = new TPanel(this);
 _FORM_CATCH
 panelStuff->Parent = this;
 panelStuff->Align = alClient;

 _FORM_TRY
 editSelected = new TEdit(this);
 _FORM_CATCH
 editSelected->Top = 0;
 editSelected->Left = 0;
 editSelected->Height = 21;
 editSelected->Width = panelStuff->Width - 16; // 185;
 editSelected->Anchors = editSelected->Anchors << akLeft << akTop << akRight;
 editSelected->Parent = panelStuff; // this;
 editSelected->ReadOnly = true;
 editSelected->TabOrder = 0;
 editSelected->OnKeyDown = editSelectedKeyDown;

 _FORM_TRY
 buttonSelect = new THalfButton(this);
 _FORM_CATCH
 buttonSelect->Top = 0;
 buttonSelect->Left = panelStuff->Width - 18; // 183;
 buttonSelect->Height = 21;
 buttonSelect->Width = 18;
 buttonSelect->Anchors = buttonSelect->Anchors >> akLeft << akTop << akRight;
 buttonSelect->Parent = panelStuff; // this;
 buttonSelect->TabOrder = 1;
 buttonSelect->Cursor = crHandPoint;
 buttonSelect->OnClick = buttonSelectClick;
 buttonSelect->Glyph->LoadFromResourceName(FindClassHInstance(__classid(TBaseDropDown)), "BDROPDOWNARROW");

 _FORM_TRY
 buttonEscape = new TButton(this);
 _FORM_CATCH
 buttonEscape->Parent  = rubberContainer;
 // keep it out of sight?
 buttonEscape->Top = -8;
 buttonEscape->Height = 4;
 buttonEscape->Cancel = true;
 buttonEscape->TabStop = false;
 buttonEscape->OnClick = buttonEscapeClick;

 FDropDownWidth = Width;
}
//---------------------------------------------------------------------------
__fastcall TBaseDropDown::~TBaseDropDown()
{
 // TODO: destroy?
 // are these necessary?
 buttonEscape->Visible = false;
 buttonEscape->Parent = this;
}
//---------------------------------------------------------------------------
namespace Codebasedropdown
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TBaseDropDown)};
                 RegisterComponents("prometheus", classes, 0);
        }
}
//---------------------------------------------------------------------------
void __fastcall TBaseDropDown::buttonSelectClick(TObject *Sender)
{
 rubberContainer->Width = FDropDownWidth;
 rubberContainer->PoppedOut = true;
}
//---------------------------------------------------------------------------
void __fastcall TBaseDropDown::editSelectedKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
 rubberContainer->Width = FDropDownWidth;
 if (Key == VK_DOWN || Key == VK_RETURN)
  rubberContainer->PoppedOut = true;
}
//---------------------------------------------------------------------------
void __fastcall TBaseDropDown::buttonEscapeClick(TObject *Sender)
{
 rubberContainer->PoppedOut = false;
}
//---------------------------------------------------------------------------
void __fastcall TBaseDropDown::rubberPopIn(TObject *Sender)
{
 // nada?
 if (FOnUp)
  FOnUp(this);
 panelStuff->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TBaseDropDown::rubberPopOut(TObject *Sender)
{
 panelStuff->Enabled = false;
 if (FOnDown)
  FOnDown(this);
}
//---------------------------------------------------------------------------
int  __fastcall TBaseDropDown::GetDropDownHeight()
{
 return rubberContainer->Height;
}
//---------------------------------------------------------------------------
void __fastcall TBaseDropDown::SetDropDownHeight(int Value)
{
 rubberContainer->Height = Value;
}
//---------------------------------------------------------------------------
int  __fastcall TBaseDropDown::GetDropDownWidth()
{
 return FDropDownWidth;
}
//---------------------------------------------------------------------------
void __fastcall TBaseDropDown::SetDropDownWidth(int Value)
{
 FDropDownWidth = Value;
 rubberContainer->Width = FDropDownWidth;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TBaseDropDown::GetText()
{
 return editSelected->Text;
}
//---------------------------------------------------------------------------
void __fastcall TBaseDropDown::SetText(AnsiString Value)
{
 editSelected->Text = Value;
}
//---------------------------------------------------------------------------
TColor __fastcall TBaseDropDown::GetEditColor()
{
 return editSelected->Color;
}
//---------------------------------------------------------------------------
void __fastcall TBaseDropDown::SetEditColor(TColor Value)
{
 editSelected->Color = Value;
}
//---------------------------------------------------------------------------


