//---------------------------------------------------------------------------

#ifndef codeBaseDropDownH
#define codeBaseDropDownH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include "codeRubberContainer.h"
#include "codeHalfButton.h"
//---------------------------------------------------------------------------
class PACKAGE TBaseDropDown : public TCustomControl
{
private:
        void __fastcall buttonSelectClick(TObject *Sender);
        void __fastcall editSelectedKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
        void __fastcall buttonEscapeClick(TObject *Sender);
protected:
        TRubberContainer * rubberContainer;
        TEdit * editSelected;
        THalfButton * buttonSelect;
        TButton * buttonEscape;
        TPanel * panelStuff;

        TNotifyEvent FOnDown;
        TNotifyEvent FOnUp;
        unsigned int FDropDownWidth;

        void __fastcall virtual rubberPopIn(TObject *Sender);
        void __fastcall virtual rubberPopOut(TObject *Sender);

        AnsiString __fastcall GetText();
        void __fastcall SetText(AnsiString Value);

        int  __fastcall GetDropDownHeight();
        void __fastcall SetDropDownHeight(int Value);

        int  __fastcall GetDropDownWidth();
        void __fastcall SetDropDownWidth(int Value);

        TColor __fastcall GetEditColor();
        void   __fastcall SetEditColor(TColor Value);
public:
        __fastcall TBaseDropDown(TComponent* Owner);
        __fastcall virtual ~TBaseDropDown();
__published:
        __property int DropDownHeight = {read = GetDropDownHeight, write = SetDropDownHeight};
        __property int DropDownWidth = {read = GetDropDownWidth, write = SetDropDownWidth};
        __property TRubberContainer * Container = {read = rubberContainer};
        __property AnsiString Text = {read = GetText, write = SetText};
        __property TNotifyEvent OnDown = {read = FOnDown, write = FOnDown};
        __property TNotifyEvent OnUp = {read = FOnUp, write = FOnUp};
        __property TColor Color = {read = GetEditColor, write = SetEditColor};

        __property Align;
        __property Anchors;
        __property Enabled;
        __property Visible;
        __property TabOrder;
        __property TabStop;
};
//---------------------------------------------------------------------------
#endif
