//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeHalfButton.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(THalfButton *)
{
        new THalfButton(NULL);
}
//---------------------------------------------------------------------------
__fastcall THalfButton::THalfButton(TComponent* Owner)
        : TCustomControl(Owner)
{
 ControlStyle << csAcceptsControls << csReplicatable;
 Width  = 18;
 Height = 21;

 buttonThing = new TSpeedButton (this);
 buttonThing->Left = 0;
 buttonThing->Width = 16;
 buttonThing->Top = 2;
 buttonThing->Height = 17;
 buttonThing->Caption = "";
 buttonThing->Layout = blGlyphTop;
 buttonThing->Margin = 0;
 buttonThing->ShowHint = true;
 buttonThing->Parent = this;
 buttonThing->Anchors << akRight << akBottom << akLeft << akTop;

 buttonThing->OnClick = this->DoOnClick;

 Cursor = crHandPoint;
}
//---------------------------------------------------------------------------
__fastcall THalfButton::~THalfButton()
{
 Associate = NULL;
}
//---------------------------------------------------------------------------
void __fastcall THalfButton::DoOnClick(TObject *Sender)
{
 if (FOnClick)
  FOnClick(this);
}
//---------------------------------------------------------------------------
void __fastcall THalfButton::Paint()
{
 TRect rectAll;
 rectAll.Top = 0;
 rectAll.Bottom = Height;
 rectAll.Left = 0;
 rectAll.Right = Width;

 // Canvas->Brush->Color = Color;
 // Canvas->FillRect(rectAll);

 rectAll.Left = -2;
 HDC box_dc = GetWindowDC(this->Handle);
 // DrawFrameControl(box_dc, &rectAll, DFC_BUTTON, DFCS_BUTTONPUSH | DFCS_PUSHED);
 DrawEdge(box_dc, &rectAll, EDGE_SUNKEN, BF_BOTTOM | BF_BOTTOMRIGHT | BF_RIGHT | BF_TOPRIGHT | BF_TOP);
 ReleaseDC(this->Handle, box_dc);

 // buttonThing->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall THalfButton::SetCaption(AnsiString Value)
{
 buttonThing->Caption = Value;
}
//---------------------------------------------------------------------------
void __fastcall THalfButton::SetGlyph(Graphics::TBitmap* Value)
{
 buttonThing->Glyph = Value;
}
//---------------------------------------------------------------------------
void __fastcall THalfButton::SetEnabled(bool Value)
{
 buttonThing->Enabled = Value;
 TCustomControl::SetEnabled(Value);
}
//---------------------------------------------------------------------------
void __fastcall THalfButton::SetHint(AnsiString Value)
{
 buttonThing->Hint = Value;
}
//---------------------------------------------------------------------------
void __fastcall THalfButton::SetAssociate(Controls::TWinControl* Value)
{
 if (Value != FAssociate)
 {
  if (FAssociate)
   FAssociate->WindowProc = FOriginalWndProc;
  if (Value != this)
   FAssociate = Value;
  else
   FAssociate = NULL;
  if (FAssociate)
  {
   Adjust(false);
   // Enabled = FAssociate->Enabled;
   // Visible = FAssociate->Enabled;
   FOriginalWndProc = FAssociate->WindowProc;
   FAssociate->WindowProc = RedirectedWndProc;
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall THalfButton::Adjust(bool MoveAssociatedControl)
{
 if (FAssociate && !ComponentState.Contains(csLoading)) // avoid moving for no good reason?
 {
  if (MoveAssociatedControl)
  {
   FAssociate->Left   = this->Left - FAssociate->Width + 2;
   FAssociate->Top    = this->Top;
   FAssociate->Height = this->Height;
  } else
  {
   this->Left   = FAssociate->Left + FAssociate->Width - 2;
   this->Top    = FAssociate->Top;
   this->Height = FAssociate->Height;
   this->BringToFront(); // make sure it overlaps in the right order
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall THalfButton::WndProc(Messages::TMessage &Message)
{
 // handle stuff for the control we're attached to (pass everything on, we're just spying)
 if (FAssociate && !FUpdating)
 {
  FUpdating = true;
  switch (Message.Msg)
  {
   case CM_ENABLEDCHANGED:
    // FAssociate->Enabled = this->Enabled;
    break;
   case CM_VISIBLECHANGED:
    // FAssociate->Visible = this->Visible;
    break;
   case WM_SIZE:
   case WM_MOVE:
   case WM_WINDOWPOSCHANGED:
    // Adjust(false);
    break;
  }
  FUpdating = false;
 }
 TCustomControl::WndProc(Message);
}
//---------------------------------------------------------------------------
void __fastcall THalfButton::RedirectedWndProc(Messages::TMessage &Message)
{
 // handle stuff for the control we're attached to (pass everything on, we're just spying)
 if (FAssociate && !FUpdating)
 {
  FUpdating = true;
  switch (Message.Msg)
  {
   case WM_DESTROY:
    // goodbye, ol' buddy...
    Associate = NULL;
    break;
   case CM_ENABLEDCHANGED:
    // this->Enabled = FAssociate->Enabled;
    break;
   case CM_VISIBLECHANGED:
    // this->Visible = FAssociate->Visible;
    break;
   case WM_SIZE:
   case WM_MOVE:
   case WM_WINDOWPOSCHANGED:
    Adjust(false);
    break;
  }
  FUpdating = false;
  FOriginalWndProc(Message);
 }
}
//---------------------------------------------------------------------------
AnsiString __fastcall THalfButton::GetCaption()
{
 return buttonThing->Caption;
}
//---------------------------------------------------------------------------
Graphics::TBitmap* __fastcall THalfButton::GetGlyph()
{
 return buttonThing->Glyph;
}
//---------------------------------------------------------------------------
AnsiString __fastcall THalfButton::GetHint()
{
 return buttonThing->Hint;
}
//---------------------------------------------------------------------------
void __fastcall THalfButton::Click()
{
 DoOnClick(NULL);
}
//---------------------------------------------------------------------------
namespace Codehalfbutton
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(THalfButton)};
                 RegisterComponents("Prometheus", classes, 0);
        }
}
//---------------------------------------------------------------------------

