//---------------------------------------------------------------------------

#ifndef codeHalfButtonH
#define codeHalfButtonH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>

#include <Buttons.hpp>
#include <ToolWin.hpp>
//---------------------------------------------------------------------------
class PACKAGE THalfButton : public TCustomControl
{
 private:
 protected:
        TWinControl * FAssociate;
        TSpeedButton * buttonThing;                         
        TNotifyEvent FOnClick;
        TWndMethod FOriginalWndProc;
        bool FUpdating;

        void __fastcall Paint();

        void __fastcall virtual SetCaption(AnsiString Value);
        void __fastcall virtual SetGlyph(Graphics::TBitmap* Value);
        void __fastcall virtual SetEnabled(bool Value);
        void __fastcall virtual SetHint(AnsiString Value);
        void __fastcall virtual SetAssociate(TWinControl* Value);
        void __fastcall virtual DoOnClick(TObject *Sender);
        void __fastcall virtual RedirectedWndProc(Messages::TMessage &Message);
        void __fastcall virtual WndProc(Messages::TMessage &Message);
        void __fastcall virtual Adjust(bool MoveAssociatedControl);

        AnsiString __fastcall virtual GetCaption();
        Graphics::TBitmap* __fastcall GetGlyph(); /* why can this one not be virtual? */
        AnsiString __fastcall virtual GetHint();
 public:
        __fastcall THalfButton(TComponent* Owner);
        __fastcall ~THalfButton();
        DYNAMIC void __fastcall Click(void);
 __published:
        __property TNotifyEvent OnClick = {read=FOnClick, write=FOnClick};
        __property TWinControl* Associate = {read=FAssociate, write=SetAssociate};
        __property AnsiString Caption = {read = GetCaption, write = SetCaption, nodefault};
        __property Graphics::TBitmap* Glyph = {read = GetGlyph, write = SetGlyph, nodefault};
        __property Align;
        __property Anchors;
        // __property Color;
        // __property ParentColor;
        __property bool Enabled = {read = GetEnabled, write = SetEnabled, nodefault};
        __property AnsiString Hint = {read = GetHint, write = SetHint, nodefault};
        __property Visible;
        __property DoubleBuffered;
        __property TabOrder;
        __property TabStop;
};
//---------------------------------------------------------------------------
#endif
