//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeInlineContainer.h"
#include <map>
using namespace std;
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TInlineContainer *)
{
        new TInlineContainer(NULL);
}
//---------------------------------------------------------------------------
__fastcall TInlineContainer::TInlineContainer(TComponent* Owner)
        : TCustomControl(Owner)
{
 ControlStyle << csAcceptsControls << csReplicatable << csOpaque;
 Arrangement = ic_rows;
 PrimaryPadding = 0;
 SecondaryPadding = 8;
 Height = 48;
 Width = 201;
 OnResize = HasResized;
}
//---------------------------------------------------------------------------
namespace Codeinlinecontainer
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TInlineContainer)};
                 RegisterComponents("prometheus", classes, 0);
        }
}
//---------------------------------------------------------------------------
void __fastcall TInlineContainer::SetArrangement (ic_arrangements Value)
{
 FArrangement = Value;
 Arrange();
}
//---------------------------------------------------------------------------
void __fastcall TInlineContainer::SetPrimaryPadding (int Value)
{
 FPrimaryPadding = Value;
 Arrange();
}
//---------------------------------------------------------------------------
void __fastcall TInlineContainer::SetSecondaryPadding (int Value)
{
 FSecondaryPadding = Value;
 Arrange();
}
//---------------------------------------------------------------------------
void TInlineContainer::Arrange ()
{
 bool is_vertical = (Arrangement == ic_columns);
 int primary_padding = PrimaryPadding;
 int secondary_padding = SecondaryPadding;

 multimap<int, TControl *> controls_in_order;
 TControl* t = NULL;
 for (int i = 0; i < ControlCount; i++)
 {
  t = Controls[i];
  if (t->Visible)
  {
   int to = 0;
   if(t->InheritsFrom(__classid(TWinControl)))
    to = ((TWinControl*)t)->TabOrder;
   controls_in_order.insert(pair<int, TControl *>(to, t));
  }
 }

 // order them visually
 int current_primary   = 0;
 int next_primary      = 0;
 int current_secondary = 0;
 TControl * current_control = NULL;
 bool current_control_fits = false;

 // loop in order, move to next appropriate position
 for (multimap<int, TControl *>::iterator i_control = controls_in_order.begin(); i_control != controls_in_order.end(); i_control++)
 {
  current_control = i_control->second;

  // does it fit here?
  if (is_vertical)
   current_control_fits = (current_secondary + current_control->Height <= ClientHeight);
  else
   current_control_fits = (current_secondary + current_control->Width <= ClientWidth);

  // if not, and it might possibly by itself, go there.
  if (!current_control_fits && current_secondary != 0)
  {
   current_primary = next_primary;
   current_secondary = 0;
  }

  // put it where it goes.
  if (is_vertical)
  {
   current_control->Top = current_secondary;
   current_control->Left = current_primary;
  } else
  {
   current_control->Left = current_secondary;
   current_control->Top = current_primary;
  }

  // update the next position, make sure primary groups don't overlap
  if (is_vertical)
  {
   next_primary = max(next_primary, current_primary + current_control->Width + primary_padding);
   current_secondary = current_control->Top + current_control->Height;
  } else
  {
   next_primary = max(next_primary, current_primary + current_control->Height + primary_padding);
   current_secondary = current_control->Left + current_control->Width;
  }
  current_secondary += secondary_padding;
 }
 // return the amount of primary space required
 int primary_space_used = max(0, next_primary - primary_padding);

 if (!controls_in_order.empty()) // avoid resizing if we don't contain anything yet!
 {
  if (is_vertical)
   Width = primary_space_used;
  else
   Height = primary_space_used;
 }

 if (OnArrange)
  OnArrange(this);
}
//---------------------------------------------------------------------------
void __fastcall TInlineContainer::HasResized(TObject* Sender)
{
 Arrange();
}
//---------------------------------------------------------------------------
void __fastcall TInlineContainer::Paint()
{
 TRect rectAll;
 rectAll.Top = 0;
 rectAll.Bottom = Height;
 rectAll.Left = 0;
 rectAll.Right = Width;

 Canvas->Brush->Color = Color;
 Canvas->FillRect(rectAll);

 if (ComponentState.Contains(csDesigning))
 {
  Canvas->Pen->Color = clBlack;
  Canvas->Pen->Style = psDot;
  Canvas->Brush->Style = bsClear;
  Canvas->Rectangle(rectAll);
 }
}
//---------------------------------------------------------------------------

