//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codePaddedBox.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TPaddedBox *)
{
        new TPaddedBox(NULL);
}
//---------------------------------------------------------------------------
__fastcall TPaddedBox::TPaddedBox(TComponent* Owner)
        : TCustomControl(Owner)
{
 FPaintSuspended = false;
 ControlStyle << csAcceptsControls << csReplicatable << csOpaque;
 Edge = true;
 EdgeColor = clGray;

 Inner = true;
 InnerColor = 0x00D3D9DD;

 PadBottom = 2;
 PadLeft = 4;
 PadRight = 4;
 PadTop = 4;

 MarginBottom = 0;
 MarginLeft = 0;
 MarginRight = 0;
 MarginTop = 0;

 Width  = 193;
 Height = 57;
}
//---------------------------------------------------------------------------
namespace Codepaddedbox
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TPaddedBox)};
                 RegisterComponents("prometheus", classes, 0);
        }
}
//---------------------------------------------------------------------------
Windows::TRect __fastcall TPaddedBox::GetClientRect()
{
 TRect answer;
 answer.Top = FPadTop + FMarginTop;
 answer.Left = FPadLeft + FMarginLeft;
 answer.Right = Width - (FPadRight + FMarginRight);
 answer.Bottom = Height - (FPadBottom + FMarginBottom);
 return answer;
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::Paint()
{
 if (!FPaintSuspended)
 {
  TRect rectAll;

  rectAll.Top = 0;
  rectAll.Bottom = Height;
  rectAll.Left = 0;
  rectAll.Right = Width;

  Canvas->Brush->Color = Color;
  Canvas->FillRect(rectAll);

  if (Inner)
  {
   rectAll.Top = FMarginTop;
   rectAll.Bottom = Height - FMarginBottom;
   rectAll.Left = FMarginLeft;
   rectAll.Right = Width - FMarginRight;

   Canvas->Brush->Color = InnerColor;
   Canvas->FillRect(rectAll);
  }

  if (Edge)
  {
   rectAll.Top = FMarginTop;
   rectAll.Bottom = Height - FMarginBottom;
   rectAll.Left = FMarginLeft;
   rectAll.Right = Width - FMarginRight;

    Canvas->Pen->Color = FEdgeColor;
   Canvas->Brush->Style = bsClear;
   Canvas->Rectangle(rectAll);
  }

  TCustomControl::Paint();
 }
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::SetPadLeft (int Value)
{
 if (Value < 0)
  Value = 0;
 FPadLeft = Value;
 RepositionChildren();
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::SetPadTop (int Value)
{
 if (Value < 0)
  Value = 0;
 FPadTop = Value;
 RepositionChildren();
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::SetPadRight (int Value)
{
 if (Value < 0)
  Value = 0;
 FPadRight = Value;
 RepositionChildren();
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::SetPadBottom (int Value)
{
 if (Value < 0)
  Value = 0;
 FPadBottom = Value;
 RepositionChildren();
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::SetMarginLeft (int Value)
{
 if (Value < 0)
  Value = 0;
 FMarginLeft = Value;
 RepositionChildren();
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::SetMarginTop (int Value)
{
 if (Value < 0)
  Value = 0;
 FMarginTop = Value;
 RepositionChildren();
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::SetMarginRight (int Value)
{
 if (Value < 0)
  Value = 0;
 FMarginRight = Value;
 RepositionChildren();
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::SetMarginBottom (int Value)
{
 if (Value < 0)
  Value = 0;
 FMarginBottom = Value;
 RepositionChildren();
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::SetEdge (bool Value)
{
 FEdge = Value;
 Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::SetPaintSuspended (bool Value)
{
 FPaintSuspended = Value;
 Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::SetEdgeColor (TColor Value)
{
 FEdgeColor = Value;
 Repaint();                                    
}
//---------------------------------------------------------------------------
bool __fastcall TPaddedBox::CanResize(int &NewWidth, int &NewHeight)
{
 if (TCustomControl::CanResize(NewWidth, NewHeight))
 {
  NewWidth = max(NewWidth, PadLeft + PadRight);
  NewHeight = max(NewHeight, PadTop + PadBottom);
  return true;
 }
 return false;
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::RepositionChildren()
{
 for (int i = 0; i < ControlCount; i++)
  Controls[i]->Align = Controls[i]->Align;

 AdjustSize();
 Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::WndProc(Messages::TMessage &Message)
{
 TCustomControl::WndProc(Message);
 switch (Message.Msg)
 {
  // resend a message to children with correct colors? may flash?
  case CM_COLORCHANGED:
  case CM_PARENTCOLORCHANGED:
   FakeParentColor();
   break;
  // a control has been inserted -- take the opportunity to tell it who its daddy is ...
  case CM_CONTROLCHANGE:
   if (Message.LParam)
    if (Inner)
     ((TControl*)(Message.WParam))->Perform(CM_PARENTCOLORCHANGED, 1, InnerColor);
    else
     ((TControl*)(Message.WParam))->Perform(CM_PARENTCOLORCHANGED, 0, Color);
   // Repaint();
   break;
   /* epic fail!
   case WM_PAINT:
    if (!FPaintSuspended)
     Paint();
    else
     SendMessage(this->Handle, WM_PAINT, Message.WParam, 0);
   */
 }
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::FakeParentColor()
{
 for (int i = 0; i < ControlCount; i++)
 {
  if (Inner)
   Controls[i]->Perform(CM_PARENTCOLORCHANGED, 1, InnerColor);
  else
   Controls[i]->Perform(CM_PARENTCOLORCHANGED, 0, Color); // don't actually need to send Color as it'll pick up on it anyway. stupid fucks.
  // Controls[i]->Invalidate();
 }
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::SetInner (bool Value)
{
 FInner = Value;
 FakeParentColor();
 Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TPaddedBox::SetInnerColor (TColor Value)
{
 FInnerColor = Value;
 FakeParentColor();
 Repaint();
}
//---------------------------------------------------------------------------

