//---------------------------------------------------------------------------

#ifndef codePaddedBoxH
#define codePaddedBoxH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------
class PACKAGE TPaddedBox : public TCustomControl
{
private:
        bool FInner;
        TColor FInnerColor;

        bool FEdge;
        TColor FEdgeColor;

        bool FPaintSuspended;

        int FPadLeft;
        int FPadTop;
        int FPadRight;
        int FPadBottom;

        int FMarginLeft;
        int FMarginTop;
        int FMarginRight;
        int FMarginBottom;
protected:
        void __fastcall SetPadLeft (int Value);
        void __fastcall SetPadTop (int Value);
        void __fastcall SetPadRight (int Value);
        void __fastcall SetPadBottom (int Value);

        void __fastcall SetMarginLeft (int Value);
        void __fastcall SetMarginTop (int Value);
        void __fastcall SetMarginRight (int Value);
        void __fastcall SetMarginBottom (int Value);

        void __fastcall SetEdge (bool Value);
        void __fastcall SetEdgeColor (TColor Value);

        void __fastcall SetInner (bool Value);
        void __fastcall SetInnerColor (TColor Value);

        void __fastcall SetPaintSuspended (bool Value);

        void __fastcall Paint ();
        Windows::TRect __fastcall GetClientRect ();
        bool __fastcall CanResize(int &NewWidth, int &NewHeight);
        void __fastcall RepositionChildren();
        void __fastcall virtual WndProc(Messages::TMessage &Message);
        void __fastcall FakeParentColor();
public:
        __fastcall TPaddedBox (TComponent* Owner);
__published:
        __property int PadLeft   = {read = FPadLeft,   write = SetPadLeft, default = 4};
        __property int PadTop    = {read = FPadTop,    write = SetPadTop, default = 4};
        __property int PadRight  = {read = FPadRight,  write = SetPadRight, default = 4};
        __property int PadBottom = {read = FPadBottom, write = SetPadBottom, default = 2};

        __property int MarginLeft   = {read = FMarginLeft,   write = SetMarginLeft, default = 0};
        __property int MarginTop    = {read = FMarginTop,    write = SetMarginTop, default = 0};
        __property int MarginRight  = {read = FMarginRight,  write = SetMarginRight, default = 0};
        __property int MarginBottom = {read = FMarginBottom, write = SetMarginBottom, default = 0};

        __property bool Edge = {read = FEdge, write = SetEdge, default = true};
        __property TColor EdgeColor = {read = FEdgeColor, write = SetEdgeColor, default = clGray};
        __property bool Inner = {read = FInner, write = SetInner, default = true};
        __property TColor InnerColor = {read = FInnerColor, write = SetInnerColor, default = 0x00D3D9DD};
        __property bool PaintSuspended = {read = FPaintSuspended, write = SetPaintSuspended, default = false};

        __property OnResize;

        __property Align;
        __property Anchors;
        __property AutoSize;
        __property Color;
        __property ParentColor;
        __property Enabled;
        __property Visible;
        __property DoubleBuffered;
        __property TabOrder;
        __property TabStop;
};
//---------------------------------------------------------------------------
#endif
