//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQueryContainer.h"
#include "query_factory_registry.h"
#include "query_factories.h"
#include "codeSpecialHtmlPreview.h"
#include "html_reporting.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TframeQueryContainer *frameQueryContainer;

/*
 I'm curious why I didn't make this derive from TframeQueryGeneric ... seems ... like that would have been smart somehow.
 But I didn't, and I remember thinking about it and having a reason.
 I just have no clue what it was, and I didn't write it down. And it won't come back to mind.
 There's a weird difference with the concept of 'context' and having queries pull settings from the host/context ...
 That, and codeQueryGeneric should have been a few classes?
  - codeQueryGeneric (interface, no implementation at all)
  -
  - codeQueryAggregate, for things that have several unordered children ('all', 'some', 'none', 'any')
  - codeQueryProxy, for things that have only one child, ever ('random', 'has', 'points to', 'magic' -> 'magicclosable')
 But ... meh. Could still be fixed, maybe. After all, I did fix search/record/wizard to be specials, rather than top-levels.
 Just not today. (8/19/2005 -- Philip)
*/

//---------------------------------------------------------------------------
__fastcall TframeQueryContainer::TframeQueryContainer(TComponent* Owner)
        : TFrame(Owner)
{
 FORM_TRY
  FQuery = new TframeQueryMagic(this);
  FQuery->Parent = scrollQuery;
  // temp->SourceTableName = "people";
  // temp->Context = my_context;
  FQuery->Top = 8;
  FQuery->Left = 8;
 FORM_CATCH
}
//---------------------------------------------------------------------------
__fastcall TframeQueryContainer::~TframeQueryContainer()
{
 // just to get it over with, you know?
 delete FQuery;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryContainer::SetContext(query_context* Value)
{
 FContext = Value;
 FQuery->Context = Value;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryContainer::SetSourceTableName(AnsiString Value)
{
 FSourceTableName = Value;
 FQuery->SourceTableName = Value;
}
//---------------------------------------------------------------------------
string TframeQueryContainer::Prepare()
{
 return FQuery->Prepare();
}
//---------------------------------------------------------------------------
void TframeQueryContainer::CleanUp()
{
 FQuery->CleanUp();
}
//---------------------------------------------------------------------------
bool TframeQueryContainer::Valid()
{
 return FQuery->Valid();
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryContainer::scrollQueryMouseWheelDown(
      TObject *Sender, TShiftState Shift, TPoint &MousePos, bool &Handled)
{
  if(scrollQuery->Visible)
    scrollQuery->VertScrollBar->Position += scrollQuery->VertScrollBar->Increment;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryContainer::scrollQueryMouseWheelUp(
      TObject *Sender, TShiftState Shift, TPoint &MousePos, bool &Handled)
{
  if(scrollQuery->Visible)
    scrollQuery->VertScrollBar->Position -= scrollQuery->VertScrollBar->Increment;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryContainer::SetProxy (bool Value)
{
 if (FQuery)
  FQuery->Proxy = Value;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryContainer::SetCache (bool Value)
{
 if (FQuery)
  FQuery->Cache = Value;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryContainer::SetSimple (bool Value)
{
 if (FQuery)
  FQuery->Simple = Value;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryContainer::SetClip (bool Value)
{
 if (FQuery)
  FQuery->Clip = Value;
}
//---------------------------------------------------------------------------
bool __fastcall TframeQueryContainer::GetProxy ()
{
 return (FQuery && FQuery->Proxy);
}
//---------------------------------------------------------------------------
bool __fastcall TframeQueryContainer::GetCache ()
{
 return (FQuery && FQuery->Cache);
}
//---------------------------------------------------------------------------
bool __fastcall TframeQueryContainer::GetSimple ()
{
 return (FQuery && FQuery->Simple);
}
//---------------------------------------------------------------------------
bool __fastcall TframeQueryContainer::GetClip ()
{
 return (FQuery && FQuery->Clip);
}
//---------------------------------------------------------------------------
xValue TframeQueryContainer::Save (bool with_params)
{
 if (!FQuery)
  return "";
 return FQuery->Save(with_params);
}
//---------------------------------------------------------------------------
void TframeQueryContainer::Load (xValue config, bool with_params)
{
 if (!FQuery)
  return;
 FQuery->Load(config, with_params);
}
//---------------------------------------------------------------------------
void TframeQueryContainer::Describe (bool as_html)
{
 if (!FQuery)
  return;

 if (!FQuery->Valid())
  return;

 //Processing(true);
 try
 {
   ofstream ze_file;
   ze_file.open("query_description.html", ios::trunc | ios::out);
   if (!ze_file.is_open())
   {
    PSay("Failed to create temporary file for report output.", m_debug, MB_OK, "TframeQueryContainer");
    throw(97);
   }
   htmlStart(ze_file, "Query description (cover page)");

   ze_file << FQuery->Describe(as_html);

   htmlStop(ze_file);
   ze_file.close();

   string real_cwd = GetCurrentDir().c_str();
   //Processing(false);
   TformSpecialHtmlPreview::DoPrintPreview(real_cwd + "\\query_description.html");
   //this->CloseNow();
 }
 catch (...)
 {
   //Processing(false);
   PSay("Error generating query-description report", m_database_error, MB_OK, "TframeQueryContainer");
 }
}
//---------------------------------------------------------------------------

