//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQueryFileSave.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryFile"
#pragma resource "*.dfm"
TframeQueryFileSave *frameQueryFileSave;
//---------------------------------------------------------------------------
__fastcall TframeQueryFileSave::TframeQueryFileSave(TComponent* Owner)
        : TframeQueryFile(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryFileSave::buttonSaveClick(TObject *Sender)
{
 // save

 if (editDescription->Text == "")
 {
  PSay("Please enter some sort of name for this query (try to be specific).", m_missing_data, MB_OK, "TframeQueryFileSave");
  return;
 }

 map<string, string> change_map;
 change_map["current_id"]        = "4";
 change_map["last_update_stamp"] = RightNow();
 change_map["last_updated_by"]   = current_userid;
 change_map["source_table_name"] = SourceTableName.c_str();
 change_map["description"]       = editDescription->Text.c_str();
 change_map["query_parameters"]  = FValueToSave;
 change_map["class_type"]        = IntToString(FType);

 string previously_saved_query_id = query_filter.GetSelectedRecordID();

 // rather than check to see if an -id- is selected (previously_saved_query_id)
 // ... let's check to see if the id's name matches the one they have typed in:
 // - if it's the same name, assume they want to overwrite (but confirm)
 // - if it's a different name, assume that (like paul) they just wanted to reuse the name slightly, but never overwrite
 // ... don't check for duplicate names because:
 // - we might hide other entries with the same name, can't expect the user to know that (nor see them)
 // - the name isn't the pk, no need to do watch for it ...
 // TODO:
 // - a way to rename (now that we can't do it from here)
 // - a way to delete, supposedly
 // - a way to organize (woohoo! my area of interest! build alexandria directly into prometheus!)
 // - some sort of permissions system?

 // yes, this would be simpler if it were done with files. not have to rebuild file-access/permissions/folder semantics, but ...
 // file/folder semantics are actually rather simple, particularly on unix.
 // folders are files
 // files and folders go in folders
 // files and folders have permissions
 // files and folders are uniquely identified by their name and their parent folder, if any
 // i don't like pure trees though. unix introduced symlinks and hardlinks, and ... things got messy. hard to map out.
 // ugh.
 // ugh so more, for good measure.

 if (!previously_saved_query_id.empty())
 {
  string prev_name = GetOneField(dbDatabase, "select description from user_queries where id = " + previously_saved_query_id);
  string curr_name = editDescription->Text.c_str();
  if (prev_name != curr_name)
   previously_saved_query_id = "";
 }

 // god fucking damn it ... i -hate- that ID_YES and IDYES are both defined, particularly when you use MB_YESNO with IDYES, not ID_YES ... god ... fucking ... damn!
 if (!previously_saved_query_id.empty())
 {
  int answer = PSay("Are you sure you want to overwrite the selected query definition?\nAnswering 'No' will save the query under the selected name, without overwriting the existing query.", m_confirmation, MB_YESNOCANCEL, "TformQueryFileSave");
  if (IDNO == answer)
   previously_saved_query_id = "";
  else
  if (IDCANCEL == answer)
   return;
 }

 if (!previously_saved_query_id.empty())
 {
  change_map["id"] = previously_saved_query_id;
  map<string, int> leave_alone;
  for (map<string, string>::iterator itr=change_map.begin(); itr!=change_map.end(); itr++)
    leave_alone[itr->first] = sql_no_uppercasing;
  if (!ExecuteUpdateStatement(dbDatabase, "user_queries", change_map, leave_alone))
   ::PSay("Failed to save query. If the problem won't go away, ask a programmer.", m_database_error, MB_OK, "TformQueryFileSave - updating id " + change_map["id"]);
  else
   ((TForm*)(Parent))->ModalResult = mrOk;
 } else
 {
  change_map["id"] = GetNextId(dbDatabase, "user_queries");
  map<string, int> leave_alone;
  for (map<string, string>::iterator itr=change_map.begin(); itr!=change_map.end(); itr++)
    leave_alone[itr->first] = sql_no_uppercasing;
  if (!ExecuteInsertStatement(dbDatabase, "user_queries", change_map, leave_alone))
   ::PSay("Failed to save query. If the problem won't go away, ask a programmer.", m_database_error, MB_OK, "TformQueryFileSave - inserting");
  else
   ((TForm*)(Parent))->ModalResult = mrOk;
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryFileSave::listQueriesSelectItem(TObject *Sender,
      TListItem *Item, bool Selected)
{
 // eep, avoid!
 if (ComponentState.Contains(csDestroying) ||
     ComponentState.Contains(csFreeNotification))
  return;

 string sel_id = query_filter.GetSelectedRecordID();
 vector<map<string, string> > temp_data = query_filter.GetAllData(true);
 for (vector<map<string, string> >::iterator i = temp_data.begin(); i != temp_data.end(); i++)
  if ((*i)["id"] == sel_id)
  {
   editDescription->Text = (*i)["description"].c_str();
   break;
  }
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryFileSave::listQueriesDblClick(TObject *Sender)
{
 buttonSave->Click();
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryFileSave::SetType(query_file_types Value)
{
 TframeQueryFile::SetType(Value);
 if (Value == qf_query)
  the_form->Caption = "Save query as...";
 else if (Value == qf_action)
  the_form->Caption = "Save action as...";
 else if (Value == qf_taxonomy)
  the_form->Caption = "Save taxonomy as...";
 else if (Value == qf_actions)
  the_form->Caption = "Save action list as...";
 else if (Value == qf_query_actions)
  the_form->Caption = "Save query and action 'combo' as...";
}
//---------------------------------------------------------------------------

