//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQueryGeneric.h"
#include "prometheus_util.h"
#include "util.h"
#include "lookuptablewrapper.h"
#include "db_hardcoded_metadata.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TframeQueryGeneric *frameQueryGeneric;
//---------------------------------------------------------------------------
__fastcall TframeQueryGeneric::TframeQueryGeneric(TComponent* Owner)
        : TFrame(Owner)
{
 Name = Name + IntToString((unsigned int)(void*)this).c_str();

 FHowAppropriate = Appropriate;
 FHowCreate = Create;

 Cache  = false;
 Proxy  = false;
 Simple = false;
 Clip   = false;

 FPrepared   = false;
 FCachedSave = "";

 OnResize = selfResize;

 // this ... really isn't ready. at all. need to think it through slightly more. the mapping process ... hmmm.
 // a) one query could be used in several contexts, each supplying differently-named globals ...
 // b) is this something users should be able to do?
 // c) if we rely on what a query saves, many variables will be invisible unless every field is used when saving!
 // d) should this be remembered between sessions (saved into the xValue)? currently yes, but ...
 // e) gah!
 // f) gah, some more!
 // g) Paul really wants this to work, but I'm not sure I can make the system suit his ill-defined desires. 
 // h) new issue: several queries -change- clip/cache/proxy as they're running (Prepare) and ... should these
 //    -override- those? that seems useful, but confusing (don't know how it's -going- to run if you don't do
 //    anything, plus checkbox menus aren't tri-state), and ... yeah.
 // if (optionsPermissions["special.debug_query_action"]["enabled"] == "true")
 //  PopupMenu = popupQueryOptions;
}
//---------------------------------------------------------------------------
__fastcall TframeQueryGeneric::~TframeQueryGeneric()
{
 // ::PSay(Name.c_str() + string(" is being deleted and taking ") + IntToString(FHostedQueries.size()) + " sub-queries with it.", m_debug, MB_OK, "TframeQueryGeneric::~TframeQueryGeneric");
 while (FHostedQueries.size())
  delete FHostedQueries[0];
 HostQuery = NULL;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TframeQueryGeneric::GetSourceTableName ()
{
 return FSourceTableName.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::SetSourceTableName (AnsiString Value)
{
 FSourceTableName = Value.c_str();
 // Hint = SourceTableName;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::SetCache (bool Value)
{
 FCache = Value;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::SetProxy (bool Value)
{
 FProxy = Value;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::SetClip (bool Value)
{
 FClip = Value;
}
//---------------------------------------------------------------------------
int __fastcall TframeQueryGeneric::GetIndent ()
{
 return FIndent;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::SetIndent (int Value)
{
 FIndent = Value;
 if (FHostQuery)
  FHostQuery->Moved();
 else
  Moved();
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::SetSimple (bool Value)
{
 FSimple = Value;
 for (vector<TframeQueryGeneric*>::iterator i = FHostedQueries.begin(); i != FHostedQueries.end(); i++)
  if ((*i)->Simple != Value)
   (*i)->Simple = Value;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::SetContext (query_context* Value)
{
 FContext = Value;
 for (vector<TframeQueryGeneric*>::iterator i = FHostedQueries.begin(); i != FHostedQueries.end(); i++)
  if ((*i)->Context != Value)
   (*i)->Context = Value;
}
//---------------------------------------------------------------------------
int __fastcall TframeQueryGeneric::GetHeightHint ()
{
 // hack hack hack hack hakc kach cakh cahk kahc achk ahck ahkc akch ...
 if (Hidden)
  return 0;

 int z = Height;
 for (vector<TframeQueryGeneric*>::iterator i = FHostedQueries.begin(); i != FHostedQueries.end(); i++)
  z += (*i)->GetHeightHint();
 return z;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::DeleteHostedQuery (TMessage &Message)
{
 delete (TframeQueryGeneric*)(Message.WParam);
}
//---------------------------------------------------------------------------
string TframeQueryGeneric::ReadLog ()
{
 return FLog;
}
//---------------------------------------------------------------------------
void TframeQueryGeneric::WriteLog (string chunk)
{
 chunk = (Ptime(TDateTime::CurrentTime()).OutTime(global_mode) + ": ") + chunk;
 FLog = FLog + (chunk + "\n");
 if (Context && Context->LogOutput)
  Context->LogOutput->Lines->Add((Name + ": ") + chunk.c_str());
}
//---------------------------------------------------------------------------
void TframeQueryGeneric::ClearLog ()
{
 FLog = "";
}
//---------------------------------------------------------------------------
string TframeQueryGeneric::Prepare ()
{
 ClearLog();
 WriteLog("Prepare() called");
 WriteLog("\n----------------------------------------\n" + Describe(false) + "----------------------------------------");

 FCachedSave = Save(true);
 FPrepared   = true;

 // end-points should be clipped, as well as other cases (see individual operators)
/*
 if (!FHostQuery)
  Clip = true;
*/

 string answer;

 // try to find a cache, if Same() works
 answer = Context->FindCache(this);

 bool already_cached  = (!answer.empty());
 bool already_proxied = already_cached && Context->IsProxied(answer);

 if (already_cached)
  if (already_proxied)
   WriteLog("Using existing proxied cache: " + answer);
  else
   WriteLog("Using existing cache: " + answer);

/*
 if (answer.empty())
  PSay(Name.c_str() + string(" did not find a cache result to steal."), m_debug, MB_OK, "TframeQueryGeneric::Prepare");
*/

 Application->ProcessMessages();

 // no cache found, prepare
 if (answer.empty())
 {
  WriteLog("Starting to prepare view");
  answer = PrepareImpl();
  string plan;
  GetSqlPlan(FContext->Transaction, "select * from " + answer, plan);
  WriteLog("Plan for 'select * from " + answer + "': " + TranslateSqlPlan(FContext->Transaction, plan));
 }

 if (answer.empty())
 {
  // PSay(Name.c_str() + string(" did not prepare properly."), m_debug, MB_OK, "TframeQueryGeneric::Prepare");
  WriteLog("Did not prepare properly (no view name)");
  throw(99);
 }

 Application->ProcessMessages();

 // switched to looking at FClip, FCache, and FProxy because of magic / magiccloseable which forward get/set requests, but maintain 'false' values themselves (and ought to)

 // this WAS being done after clipping. but that join seems to usually kill stuff. worth trying this way?
 if (FProxy && !already_proxied) // that'd be stupid, don't you think?
 {
  WriteLog("Proxying view: " + answer);
  FViewProxied = Context->CreateProxyView(answer);
  if (!FViewProxied.empty()) // there's already a message box in CreateProxyView, we don't need to double it.
  {
   answer = FViewProxied;
   WriteLog("Proxied view: " + answer);
   string plan;
   GetSqlPlan(FContext->Transaction, "select * from " + answer, plan);
   WriteLog("Plan for 'select * from " + answer + "': " + TranslateSqlPlan(FContext->Transaction, plan));
  }
 }

 Application->ProcessMessages();

 if (FClip && !already_cached) // Same() returns false if we want to clip and the other guy isn't clipping -- so if we're using a cache, it -should- be perfectly identical
 {
  string whole_view = Context->FindWhole(SourceTableName.c_str());
  if (whole_view.empty())
   WriteLog("Empty whole view discovered during clipping");
  string sql = "select " + answer + ".id from " + answer + " inner join " + whole_view + " on " + whole_view + ".id = " + answer + ".id";
  // string sql = "select " + answer + ".id from " + answer + " left join " + whole_view + " on " + whole_view + ".id = " + answer + ".id where " + whole_view + ".id is not null";
  set<string> dep;
  dep.insert(whole_view);
  dep.insert(answer);
  FViewClipped = Context->CreateView(sql, dep, "clip");
  if (!FViewClipped.empty())
  {
   answer = FViewClipped;
   WriteLog("Clipped view: " + answer);
   string plan;
   GetSqlPlan(FContext->Transaction, "select * from " + answer, plan);
   WriteLog("Plan for 'select * from " + answer + "': " + TranslateSqlPlan(FContext->Transaction, plan));
  }
 }

 Application->ProcessMessages();

 // try to cache it
 // come to think of it, if already_cached ... why bother? we're just filling up junk space, you know?
 // && !already_cached: this was seriously fucking up Query_Whole (FindWhole would create a new one, it would use a cache, but then not add itself to the cache, it would be the only Query_Whole in the list of WholeQueries, but it wouldn't be in the PreparedQuery list, and ... that'd make stuff freak out.)
 if (FCache /* && !already_cached*/)
 {
  Context->CreateCache(this, answer);
  WriteLog("Cached view: " + answer);
  string plan;
  GetSqlPlan(FContext->Transaction, "select * from " + answer, plan);
  WriteLog("Plan for 'select * from " + answer + "': " + TranslateSqlPlan(FContext->Transaction, plan));
 }
/*
 if (answer.empty())
  PSay(Name.c_str() + string(" is mucking everything up."), m_debug, MB_OK, "TframeQueryGeneric::Prepare");
*/
 WriteLog("Returning view: " + answer);
 AfterPrepare(answer);

 // Color = 0x00DDFFDD; -- failed idea
 Application->ProcessMessages();
 return answer;
}
//---------------------------------------------------------------------------
void TframeQueryGeneric::AfterPrepare (string view_name)
{
 string num_results = GetOneField(FContext->Transaction, "select * from " + view_name);
 WriteLog(num_results + " results from 'select * from " + view_name + "'.");
}
//---------------------------------------------------------------------------
void TframeQueryGeneric::CleanUp ()
{
 // ParentColor = true; -- failed idea

 FPrepared   = false;
 FCachedSave = "";

 // note: this is a stupid thing to forget
 for (vector<TframeQueryGeneric*>::iterator i = FHostedQueries.begin(); i != FHostedQueries.end(); i++)
  (*i)->CleanUp();

 // views are automatically cleaned up by the context, we don't have to do it
 // but we might have to delete -data- from the temp_id table, if we put some there (proxy)
 // TODO: clear proxy data, if any

 CleanUpImpl();
}
//---------------------------------------------------------------------------
string TframeQueryGeneric::PrepareImpl ()
{
 return "";
}
//---------------------------------------------------------------------------
void TframeQueryGeneric::CleanUpImpl ()
{
 return;
}
//---------------------------------------------------------------------------
void TframeQueryGeneric::Resized ()
{
 if (FHostQuery)
  FHostQuery->Resized();
 else
 {
  Moved();
  // go in and reset tab orders?
  if (Parent)
  {
   // redirect a bit
   OnMouseWheelDown = ((TScrollBox*)Parent)->OnMouseWheelDown;
   OnMouseWheelUp   = ((TScrollBox*)Parent)->OnMouseWheelUp;
   OnClick          = ((TScrollBox*)Parent)->OnClick;

   map<int, TframeQueryGeneric*> queries_in_top_order;
   for (int i = 0; i < Parent->ControlCount; i++)
    if (Parent->Controls[i]->InheritsFrom(__classid(TframeQueryGeneric)))
     queries_in_top_order[((TframeQueryGeneric*)(Parent->Controls[i]))->Top] = ((TframeQueryGeneric*)(Parent->Controls[i]));
   unsigned int k = 0;
   for (map<int, TframeQueryGeneric*>::iterator i = queries_in_top_order.begin(); i != queries_in_top_order.end(); i++, k++)
    i->second->TabOrder = k;
  }
 }
}
//---------------------------------------------------------------------------
void TframeQueryGeneric::Moved ()
{
 int z = Height;
 for (vector<TframeQueryGeneric*>::iterator i = FHostedQueries.begin(); i != FHostedQueries.end(); i++)
 {
  if (Parent)
   (*i)->Parent = Parent; // added because of timing issues ... setting Parent in constructor isn't possible, etc.

  (*i)->Top  = Top + z;
  (*i)->Left = Left + (*i)->Indent;
  (*i)->Moved();
  z += (*i)->GetHeightHint();
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::selfResize (TObject* Sender)
{
 Resized();
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::SetHostQuery (TframeQueryGeneric* Value)
{
 if (FHostQuery)
 {
  FHostQuery->FHostedQueries.erase(remove(FHostQuery->FHostedQueries.begin(), FHostQuery->FHostedQueries.end(), this), FHostQuery->FHostedQueries.end());
  FHostQuery->ChangeHostedQuery(this);
  FHostQuery->Resized();
 }
 FHostQuery = Value;
 // Owner      = Value;
 if (Owner)
  Owner->RemoveComponent(this);
 if (Value)
  Value->InsertComponent(this);
 if (FHostQuery)
 {
  FHostQuery->FHostedQueries.insert(FHostQuery->FHostedQueries.begin(), this);
  FHostQuery->ChangeHostedQuery(this);
  Context = FHostQuery->Context;
  Simple  = FHostQuery->Simple;
  FHostQuery->Resized();
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::ChangeHostedQuery (TframeQueryGeneric* Value)
{
 return;
}
//---------------------------------------------------------------------------
bool TframeQueryGeneric::Valid ()
{
 // allow them to all color-code themselves even if others failed
 bool answer = true;
 for (vector<TframeQueryGeneric*>::iterator i = FHostedQueries.begin(); i != FHostedQueries.end(); i++)
  answer = (answer && (*i)->Valid());
 return answer;
}
//---------------------------------------------------------------------------
bool TframeQueryGeneric::Same (TframeQueryGeneric* other_query)
{
 if (!other_query)
  return false;
 if (other_query->SourceTableName != this->SourceTableName)
  return false;
 if (other_query->Clip == false && this->Clip == true)
  return false;
 if (other_query->FPrepared && this->FPrepared)
  return (other_query->FCachedSave == this->FCachedSave);
 return (other_query->Save(true) == this->Save(true));
}
//---------------------------------------------------------------------------
string TframeQueryGeneric::Save (bool with_params)
{
 // when overriding, call this first, take the return value, parse it as a map again, make your changes, then return the changed map ... (as an xValue)
 // how to put this ...
 // the value returned by Save, and given to Load, should always be a map.
 // what's stored is actually a value whose type is the name of the query type, and whose value is a map value
 // example ...
 // TframeQuery_All(map(...))
 // this map should always contain at least:
 //  "source_table_name" (a string)
 //  "hosted_queries" (a set of TframeQuery% values)
 // the type name is used to determine (via the factory registry) which class to instantiate -- the type name is then stripped off before passing to Load()
 map<string, xValue> config_map;
 config_map["source_table_name"] = xFromString(SourceTableName.c_str());
 vector<xValue> hosted_queries;
 // xAutoSave should automatically tack-on the correct type name for the query as a whole
 for (vector<TframeQueryGeneric*>::reverse_iterator i = FHostedQueries.rbegin(); i != FHostedQueries.rend(); i++)
  hosted_queries.push_back(xAutoSave(*i, with_params));
 // do not save an empty set!
 if (hosted_queries.size())
  config_map["hosted_queries"] = xFromVec(hosted_queries);
 return xFromMap(config_map);
}
//---------------------------------------------------------------------------
void TframeQueryGeneric::Load (string config, bool with_params)
{
 // uh ...
 // override, but call this (for simplicity) ... derived classes can get the map again and find their own entries as needed.
 if (xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);
  if (xTag(config_map["source_table_name"]) == "string")
  {
   string attempted_stn = xToString(config_map["source_table_name"]);
   if (SourceTableName != "" && SourceTableName != attempted_stn.c_str()) // try to allow xAutoLoad to do its job?
   {
    ::PSay("The query you are attempting to load is of the wrong type;\nit is intended to find " + dbPrettyPlural(LowercaseString(attempted_stn)) + " rather than " + dbPrettyPlural(LowercaseString(SourceTableName.c_str())) + ".", m_invalid_data, MB_OK, "TframeQueryGeneric::Load");
    return;
   }
   SourceTableName = attempted_stn.c_str();
  }
  // delete old content, as we'll be replacing it (most likely)
  while (FHostedQueries.size())
   delete FHostedQueries[0];
  // set up the source table name
  // set up the hosted queries using xAutoLoad which will automatically create the queries, attach them, load them, etc. (recursively)
  if (xTag(config_map["hosted_queries"]) == "vector")
  {
   vector<xValue> hosted_queries = xToVec(config_map["hosted_queries"]);
   for (vector<xValue>::iterator i = hosted_queries.begin(); i != hosted_queries.end(); i++)
    xAutoLoad(this, Parent, *i, with_params);
  }
 } else
  ::PSay("Parameters being loaded are of an unexpected format: no property map.", m_invalid_data, MB_OK, "TframeQueryGeneric::Load", config);
 return;
}
//---------------------------------------------------------------------------
string TframeQueryGeneric::Describe (bool as_html)
{
 return "This query does not yet know how to describe itself." + string(as_html ? "<br>" : "\r\n");
}
//---------------------------------------------------------------------------
string TframeQueryGeneric::GetTag ()
{
 // try to figure out how we were created, derive tag from this (in the db) ... return the tag (for use when saving?)
 q_factory_info temp_factory = query_factories.GetFactoryByTag(query_factories.GetTagByFactory (HowCreate));
 if (temp_factory.create_pointer)
  return temp_factory.serialization_tag;
 else
  return "";
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQueryGeneric::Create (TComponent* owner)
{
 // shouldn't this be a pure-virtual function? apart from alpha-testing, you'd never want to create one of these ...
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQueryGeneric(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeQueryGeneric::Appropriate (string source_table_name)
{
 return false;
}
//---------------------------------------------------------------------------
void TframeQueryGeneric::RehostTo (TframeQueryGeneric* other_query)
{
 while(FHostedQueries.size())
  FHostedQueries[FHostedQueries.size() - 1]->HostQuery = other_query;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::FrameEnter(TObject *Sender)
{
 // that color idea i had? bad. bad bad.

 // ooh, ooh, idea: have simple=true -just- for the currently-selected component! woohoo!
 // okay, maybe not. (besides, the propagation thing could get weird.)
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::FrameExit(TObject *Sender)
{
 // color idea? still bad.
 // might try some other indicator of "here-ness"
}
//---------------------------------------------------------------------------
xValue __fastcall TframeQueryGeneric::ReplaceWithGlobals(xValue config)
{
 xValue answer = config;
 if (xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);

  for (map<string, xValue>::iterator j = config_map.begin(); j != config_map.end(); j++)
   if (xTag(j->second) == "global")
    if (Context->Globals->find(xContent(j->second)) != Context->Globals->end())
     j->second = (*(Context->Globals))[xContent(j->second)];
    else
    {
     map<string, xValue>::iterator k = j++;
     config_map.erase(k);
     j--;
    }

  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::menuGenericCacheClick(TObject *Sender)
{
 Cache = !Cache;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::menuGenericClipClick(TObject *Sender)
{
 Clip = !Clip;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::menuGenericProxyClick(TObject *Sender)
{
 Proxy = !Proxy;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::menuGenericGlobalsClick(TObject *Sender)
{
 //
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::popupQueryOptionsPopup(TObject *Sender)
{
 menuGenericCache->Checked = Cache;
 menuGenericClip->Checked = Clip;
 menuGenericProxy->Checked = Proxy;
}
//---------------------------------------------------------------------------
bool __fastcall TframeQueryGeneric::GetHidden ()
{
 return !Visible;
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::SetHidden (bool Value)
{
 Visible = !Value;
 for (vector<TframeQueryGeneric*>::iterator i = FHostedQueries.begin(); i != FHostedQueries.end(); i++)
  (*i)->Hidden = Value;
 Resized();
}
//---------------------------------------------------------------------------
void __fastcall TframeQueryGeneric::RecurseShowDefinition()
{
 for (vector<TframeQueryGeneric*>::iterator i = FHostedQueries.begin(); i != FHostedQueries.end(); i++)
  (*i)->RecurseShowDefinition();
}
//---------------------------------------------------------------------------
void TframeQueryGeneric::ApplySettings (xValue settings)
{
 for (vector<TframeQueryGeneric*>::iterator i = FHostedQueries.begin(); i != FHostedQueries.end(); i++)
  (*i)->ApplySettings(settings);
 ApplySettingsImpl(settings);
}
//---------------------------------------------------------------------------
void TframeQueryGeneric::ApplySettingsImpl (xValue settings)
{
 return;
}
//---------------------------------------------------------------------------

