//---------------------------------------------------------------------------


#ifndef codeQueryGenericH
#define codeQueryGenericH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "sqllib.h"
#include "query_factory_registry.h"
#include "query_context.h"
#include "x_serialization.h"
#include <Buttons.hpp>
#include <Menus.hpp>
#include "query_action_utils.h"
//---------------------------------------------------------------------------
class TframeQueryGeneric : public TFrame
{
__published:	// IDE-managed Components
        TPopupMenu *popupQueryOptions;
        TMenuItem *menuGenericProxy;
        TMenuItem *menuGenericClip;
        TMenuItem *menuGenericCache;
        TMenuItem *menuGenericSplit;
        TMenuItem *menuGenericGlobals;
        void __fastcall FrameEnter(TObject *Sender);
        void __fastcall FrameExit(TObject *Sender);
        void __fastcall menuGenericCacheClick(TObject *Sender);
        void __fastcall menuGenericClipClick(TObject *Sender);
        void __fastcall menuGenericProxyClick(TObject *Sender);
        void __fastcall menuGenericGlobalsClick(TObject *Sender);
        void __fastcall popupQueryOptionsPopup(TObject *Sender);
private:	// User declarations
protected:
        string                      FSourceTableName;
        int                         FIndent;
        bool                        FProxy;
        bool                        FCache;
        bool                        FSimple;
        bool                        FClip;
        TframeQueryGeneric*         FHostQuery;
        vector<TframeQueryGeneric*> FHostedQueries;
        q_factory_appropriate       FHowAppropriate;
        q_factory_create            FHowCreate;
        string                      FViewClipped;
        string                      FViewProxied;
        query_context*              FContext;
        bool                        FPrepared;
        xValue                      FCachedSave;

        string FLog;

protected: // override rarely
        void       __fastcall virtual selfResize (TObject* Sender);
        void       __fastcall virtual SetHostQuery (TframeQueryGeneric* Value);
        void       __fastcall virtual ChangeHostedQuery (TframeQueryGeneric* Value);
        AnsiString __fastcall virtual GetSourceTableName ();
        void       __fastcall virtual SetSourceTableName (AnsiString Value);
        void       __fastcall virtual SetProxy   (bool Value);
        void       __fastcall virtual SetCache   (bool Value);
        void       __fastcall virtual SetSimple  (bool Value);
        void       __fastcall virtual SetClip    (bool Value);
        int        __fastcall virtual GetIndent  ();
        void       __fastcall virtual SetIndent  (int Value);
        bool       __fastcall virtual GetHidden  ();
        void       __fastcall virtual SetHidden  (bool Value);
        void       __fastcall virtual SetContext (query_context* Value);
        int        __fastcall virtual GetHeightHint ();
        void       __fastcall         DeleteHostedQuery(TMessage &Message);
        xValue     __fastcall         ReplaceWithGlobals(xValue config);
        void       __fastcall virtual RecurseShowDefinition();

        #define WM_DELETE_HOSTED_QUERY (WM_USER + 2187)
        BEGIN_MESSAGE_MAP
         MESSAGE_HANDLER(WM_DELETE_HOSTED_QUERY, TMessage, DeleteHostedQuery)
        END_MESSAGE_MAP(TFrame)

protected: // override
        string virtual PrepareImpl ();
        void   virtual CleanUpImpl ();
        void   virtual ApplySettingsImpl (xValue settings);
        void   virtual AfterPrepare (string view_name);
public:	// usually ignore
        __fastcall TframeQueryGeneric(TComponent* Owner);
        __fastcall virtual ~TframeQueryGeneric();

        bool   virtual Same     (TframeQueryGeneric* other_query);
        void   virtual Resized  ();
        void   virtual Moved    ();
        void   virtual RehostTo (TframeQueryGeneric* other_query);
        string virtual GetTag   ();

        string ReadLog ();
        void   WriteLog (string chunk);
        void   ClearLog ();

        string Prepare ();
        void   CleanUp ();
        void   ApplySettings (xValue settings);
public: // override
        // ... run
        bool   virtual Valid   ();
        // ... load/save
        xValue virtual Save (bool with_params);
        void   virtual Load (xValue config, bool with_params);
        string virtual Describe (bool as_html);
        __property query_context* Context = {read = FContext, write = SetContext};
        // ... create/appropriate
        static TframeQueryGeneric* Create      (TComponent* owner);
        static bool                Appropriate (string source_table_name);
        __property q_factory_appropriate HowAppropriate = {read = FHowAppropriate};
        __property q_factory_create      HowCreate      = {read = FHowCreate};
        __property xValue CachedSave = {read = FCachedSave};
__published:
        __property AnsiString SourceTableName = {read = GetSourceTableName, write = SetSourceTableName};
        __property int Indent = {read = GetIndent, write = SetIndent};
        __property bool Clip = {read = FClip, write = SetClip};
        __property bool Simple = {read = FSimple, write = SetSimple};
        __property bool Cache = {read = FCache, write = SetCache};
        __property bool Proxy = {read = FProxy, write = SetProxy};
        __property bool Hidden = {read = GetHidden, write = SetHidden};
        __property bool Prepared = {read = FPrepared};
        __property int HeightHint = {read = GetHeightHint};
        __property TframeQueryGeneric* HostQuery = {read = FHostQuery, write = SetHostQuery};
};
//---------------------------------------------------------------------------
extern PACKAGE TframeQueryGeneric *frameQueryGeneric;
//---------------------------------------------------------------------------
#endif
