//---------------------------------------------------------------------------

#ifndef codeQueryMagicH
#define codeQueryMagicH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeQueryGeneric.h"
#include "query_factory_registry.h"
#include "codeHalfButton.h"
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include "codeRubberContainer.h"
//---------------------------------------------------------------------------
class TframeQueryMagic : public TframeQueryGeneric
{
__published:	// IDE-managed Components
        TComboBox *comboPicker;
        THalfButton *buttonActions;
        TPopupMenu *popupActions;
        TMenuItem *menuCopy;
        TMenuItem *menuPaste;
        TMenuItem *N1;
        TMenuItem *menuSave;                                   
        TMenuItem *menuLoad;
        TMenuItem *N2;
        TMenuItem *menuDefaults;
        TLabel *labelType;
        THalfButton *buttonComment;
        THalfButton *buttonDefinition;
        TRubberContainer *rubberComment;
        TRichEdit *editComment;
        TMenuItem *menuExpandDefinitions;
        void __fastcall menuCopyClick(TObject *Sender);
        void __fastcall menuPasteClick(TObject *Sender);
        void __fastcall menuSaveClick(TObject *Sender);
        void __fastcall menuLoadClick(TObject *Sender);
        void __fastcall buttonActionsClick(TObject *Sender);
        void __fastcall popupActionsPopup(TObject *Sender);
        void __fastcall menuDefaultsClick(TObject *Sender);
        void __fastcall buttonCommentClick(TObject *Sender);
        void __fastcall buttonDefinitionClick(TObject *Sender);
        void __fastcall menuExpandDefinitionsClick(TObject *Sender);
private:	// User declarations
        bool UsefulClipboard();
protected:
        vector<q_factory_info> picker_content;
        static string copy_buffer;
        void __fastcall virtual comboPickerKeyPress(TObject *Sender, char &Key);
        void __fastcall virtual comboPickerChange(TObject *Sender);

        void __fastcall virtual SetCache (bool Value);
        void __fastcall virtual SetProxy (bool Value);
        void __fastcall virtual SetClip (bool Value);

        string virtual PrepareImpl ();
        void AfterPrepare (string view_name);

        void __fastcall virtual SetSimple (bool Value);
        void __fastcall virtual ChangeHostedQuery (TframeQueryGeneric* Value);
        void __fastcall virtual SetSourceTableName (AnsiString Value);

        bool FShowComment;
        void __fastcall virtual SetShowComment (bool Value);
        bool __fastcall virtual GetShowComment ();
        void __fastcall virtual SetHidden      (bool Value);
        void __fastcall virtual RecurseShowDefinition();
public:
        __fastcall TframeQueryMagic(TComponent* Owner);
public:
        bool   virtual Valid ();
        string virtual Describe (bool as_html);
        xValue virtual Save  (bool with_params);
        void   virtual Load  (xValue config, bool with_params);
        bool   virtual Same  (TframeQueryGeneric* other_query);
        static TframeQueryGeneric* Create (TComponent* owner);
        static bool                Appropriate (string source_table_name);
__published:
        __property bool ShowComment = {read = GetShowComment, write = SetShowComment};
        __property SourceTableName;
        __property Indent;
        __property HeightHint;
        __property HostQuery;
};
//---------------------------------------------------------------------------
extern PACKAGE TframeQueryMagic *frameQueryMagic;
//---------------------------------------------------------------------------
#endif
