//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery_All.h"
#include "util.h"
#include "db_hardcoded_metadata.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryOperator"
#pragma resource "*.dfm"
TframeQuery_All *frameQuery_All;
//---------------------------------------------------------------------------
__fastcall TframeQuery_All::TframeQuery_All(TComponent* Owner)
        : TframeQueryOperator(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
 Cache = true;
 Clip = true;
 // Proxy = false; // this one ... we can do as a view, yes? it's simple enough.
}
//---------------------------------------------------------------------------
string TframeQuery_All::PrepareImpl ()
{
 string answer;

 ProxyMultiChildren();

 if (FHostedQueries.size() == 1)
 {
  this->Clip = false;
  FHostedQueries[0]->Clip = true;
  answer = FHostedQueries[0]->Prepare();
 } else
 if (!FHostedQueries.empty())
 {
  this->Clip = true;
  set<string> hosted_queries;
  for (vector<TframeQueryGeneric*>::iterator i = FHostedQueries.begin(); i != FHostedQueries.end(); i++)
  {
   (*i)->Clip = false; // don't bother, we'll clip when you're done
   hosted_queries.insert((*i)->Prepare());
  }

  string sql;
  string b;
  for (set<string>::iterator i = hosted_queries.begin(); i != hosted_queries.end(); i ++)
  {
   if (i == hosted_queries.begin())
    sql = "select " + *i + ".id from " + *i, b = *i;
   else
    sql += " inner join " + *i + " on " + *i + ".id = " + b + ".id";
  }

  answer = Context->CreateView(sql, hosted_queries);
 }

 return answer;
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery_All::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery_All(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
string TframeQuery_All::Describe (bool as_html)
{
 return UppercaseFirstChar(LowercaseString(dbPrettyPlural(LowercaseString(SourceTableName.c_str()))) + " that match all of the following:") + (as_html ? "<br>" : "\r\n") + TframeQueryOperator::Describe(as_html);
}
//---------------------------------------------------------------------------

