//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery_Any.h"
#include "util.h"
#include "db_hardcoded_metadata.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryOperator"
#pragma resource "*.dfm"
TframeQuery_Any *frameQuery_Any;
//---------------------------------------------------------------------------
__fastcall TframeQuery_Any::TframeQuery_Any(TComponent* Owner)
        : TframeQueryOperator(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
 Cache = true;
 Clip = true; // we do the clipping and tell our children not to bother. we -could- avoid clipping if they all refused to not clip ... 
}
//---------------------------------------------------------------------------
string TframeQuery_Any::PrepareImpl ()
{
 string answer;

 ProxyMultiChildren();

 if (FHostedQueries.size() == 1)
 {
  this->Clip = false;
  FHostedQueries[0]->Clip = true;
  answer = FHostedQueries[0]->Prepare();
 } else
 if (!FHostedQueries.empty())
 {
  this->Clip = true;
  set<string> hosted_queries;
  for (vector<TframeQueryGeneric*>::iterator i = FHostedQueries.begin(); i != FHostedQueries.end(); i++)
  {
   (*i)->Clip = false; // don't bother, we'll clip when you're done
   hosted_queries.insert((*i)->Prepare());
  }

  string sql;
  for (set<string>::iterator i = hosted_queries.begin(); i != hosted_queries.end(); i ++)
  {
   if (i != hosted_queries.begin())
    sql += " union ";
   sql += "select " + *i + ".id from " + *i;
  }

  answer = Context->CreateView(sql, hosted_queries);
 }

 return answer;
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery_Any::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery_Any(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
string TframeQuery_Any::Describe (bool as_html)
{
 return UppercaseFirstChar(LowercaseString(dbPrettyPlural(LowercaseString(SourceTableName.c_str()))) + " that match any of the following:") + (as_html ? "<br>" : "\r\n") + TframeQueryOperator::Describe(as_html);
}
//---------------------------------------------------------------------------

