//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery_ByField.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryGeneric"
#pragma link "codeRubberContainer"
#pragma link "codeRubberContainer"
#pragma link "codeRubberContainer"
#pragma link "codeRubberContainer"
#pragma link "codeQueryGeneric"
#pragma link "codeRubberContainer"
#pragma link "codeFrameCheckListDropDown"
#pragma resource "*.dfm"
TframeQuery_ByField *frameQuery_ByField;
//---------------------------------------------------------------------------
__fastcall TframeQuery_ByField::TframeQuery_ByField(TComponent* Owner)
        : TframeQueryGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
 Cache = true;

 comboValues->Filter->SetSecurity("");
 comboValues->Filter->AddColumnSpec("Value", "", as_text, true, 220, prettyString);
 comboValues->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 comboValues->Filter->FetchPreferences("query_byfield.value_filter");
 comboValues->Filter->SetIconStatus(false);
 comboValues->Filter->SetAutosizeColumns(false);
 comboValues->Filter->SetHeader(true);
 comboValues->Filter->RefreshDataSet();
 comboValues->DisplayFieldName = "Value";

 SetMode(tqbf_none);
 SetBetween(false);
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_ByField::comboFieldChange(TObject *Sender)
{
 FFieldName = "";
 Mode = tqbf_none;
 Between = false;

 if (comboField->ItemIndex != -1)
 {
  field_info about_field = picker_content[comboField->ItemIndex];
  FFieldName = about_field.source_field;

  if (about_field.source_field_type == "text")
   Mode = tqbf_text;
  else if (about_field.source_field_type == "bool")
   Mode = tqbf_bool;
  else if (about_field.source_field_type == "date")
   Mode = tqbf_date;
  else if (about_field.source_field_type == "time")
   Mode = tqbf_time;
  else if (about_field.source_field_type == "int")
   Mode = tqbf_int;
  else if (about_field.source_field_type == "float")
   Mode = tqbf_float;
  else if (about_field.source_field_type == "lookup")
  {
   Mode = tqbf_list;
   string pk_table;
   vector<string> pk_fields;
   if (GetPrimaryKey(dbDatabase, UppercaseString(about_field.source_table), UppercaseString(about_field.source_field), pk_table, pk_fields))
   {
    string new_statement = "select item, id from " + pk_table;
    string old_statement = comboValues->Filter->GetSQLStatement();
    if (new_statement != old_statement)
    {
     comboValues->Filter->SetSQLStatement(new_statement);
     comboValues->Filter->ForceRefreshDataSet();
     comboValues->Filter->UncheckAll();
    }
   } else
   {
    comboValues->Filter->SetSQLStatement("");
    comboValues->Filter->ForceRefreshDataSet();
    comboValues->Filter->UncheckAll();
   }
   comboValues->RefreshText();
   // value_filter.AutosizeColumns();
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_ByField::SetBetween(bool Value)
{
 if (FBetween != Value)
 {
  editValue->Text = "";
  editValue2->Text = "";
  dateValue->DateTime = Date();
  dateValue2->DateTime = Date();
 }

 FBetween = Value;

 editValue2->Visible = (FBetween && editValue->Visible);
 dateValue2->Visible = (FBetween && dateValue->Visible);
 _labelAnd->Visible = FBetween;

 CorrectSize();
}
//---------------------------------------------------------------------------
void TframeQuery_ByField::CorrectSize()
{
 int desired_height = Height;
 if (FMode == tqbf_list)
 {
  Width = 320;
  desired_height = 48;
 } else
 {
  Width = 452;
  if (FBetween)
   desired_height = 48;
  else
   desired_height = 24;
 }

 if (desired_height != Height)
 {
  Height = desired_height;
  Resized();
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_ByField::SetMode(TQueryByFieldModes Value)
{
 if (FMode != Value)
 {
  editValue->Text = "";
  dateValue->DateTime = Date();
  radioTrue->Checked = true;
 }

 FMode = Value;

 _labelList->Visible = (FMode == tqbf_list);
 comboValues->Visible = (FMode == tqbf_list);

 comboRelation->Visible = (FMode == tqbf_text ||
                           FMode == tqbf_int ||
                           FMode == tqbf_float ||
                           FMode == tqbf_date ||
                           FMode == tqbf_time);

 editValue->Visible = (FMode == tqbf_text ||
                       FMode == tqbf_int ||
                       FMode == tqbf_float);

 dateValue->Visible = (FMode == tqbf_date ||
                       FMode == tqbf_time);

 if (FMode == tqbf_date)
  dateValue->Kind = dtkDate;
 else
  dateValue->Kind = dtkTime;

 _labelBool->Visible = (FMode == tqbf_bool);
 radioTrue->Visible = (FMode == tqbf_bool);
 radioFalse->Visible = (FMode == tqbf_bool);

 if (comboRelation->Visible)
 {
  comboRelation->Items->Clear();
  comboRelation->Text = "";
  comboRelation->Items->Add("is empty");
  comboRelation->Items->Add("is not empty");
  comboRelation->Items->Add("is equal to");
  comboRelation->Items->Add("is not equal to");
  comboRelation->Items->Add("is greater than");
  comboRelation->Items->Add("is not greater than");
  comboRelation->Items->Add("is less than");
  comboRelation->Items->Add("is not less than");
  comboRelation->Items->Add("is between (inclusive)");
  if (FMode == tqbf_text)
  {
   comboRelation->Items->Add("starts with");
   comboRelation->Items->Add("does not start with");
   comboRelation->Items->Add("contains");
   comboRelation->Items->Add("does not contain");
   comboRelation->Items->Add("ends with");
   comboRelation->Items->Add("does not end with");
   comboRelation->Items->Add("matches");
   comboRelation->Items->Add("does not match");
  }
 }

 CorrectSize();
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_ByField::SetSourceTableName (AnsiString Value)
{
 AnsiString old_stn = SourceTableName;
 TframeQueryGeneric::SetSourceTableName(Value);
 // list of tables we have FK's to
 if (old_stn != SourceTableName)
 {
  comboField->Items->Clear();

  picker_content = dbFieldsIn(SourceTableName.c_str());
  for (vector<field_info>::iterator i = picker_content.begin(); i != picker_content.end(); i++)
   comboField->Items->Add(i->source_field_pretty.c_str());
 }
}
//---------------------------------------------------------------------------
string TframeQuery_ByField::PrepareImpl ()
{
 string sql;
 string stn = dbActualTable(SourceTableName.c_str());

 if (!IsIndexed(FContext->Transaction, stn, FFieldName))
  Proxy = true;

 switch (FMode)
 {
  case tqbf_list:
   {
    vector<string> pos_values = comboValues->Filter->GetMultiID();
    vector<string> all_values = comboValues->Filter->GetAllID();
    set<string> s_pos_values;
    set<string> s_all_values;
    set<string> s_neg_values;

    VecToSet(pos_values, s_pos_values);
    VecToSet(all_values, s_all_values);
    set_difference(s_all_values.begin(), s_all_values.end(),
                   s_pos_values.begin(), s_pos_values.end(),
                   insert_iterator<set<string> >(s_neg_values, s_neg_values.begin()));
    if (s_neg_values.size() > s_pos_values.size())
     sql = "select " + stn + ".id from " + stn + " where " + stn + "." + FFieldName + " in (" + SetToCommaString(s_pos_values) + ")";
    else
     sql = "select " + stn + ".id from " + stn + " where " + stn + "." + FFieldName + " not in (" + SetToCommaString(s_neg_values) + ")";
   }
   break;
  case tqbf_bool:
   if (radioTrue->Checked)
    sql = "select " + stn + ".id from " + stn + " where " + stn + "." + FFieldName + " = '1'";
   else
    sql = "select " + stn + ".id from " + stn + " where " + stn + "." + FFieldName + " = '0'";
   break;
  case tqbf_text:
  case tqbf_int:
  case tqbf_float:
  case tqbf_date:
  case tqbf_time:
   // null / not-null have no extra params
   if (comboRelation->Text == "is empty")
   {
    sql = "select " + stn + ".id from " + stn + " where " + stn + "." + FFieldName + " is null";
    if (FMode == tqbf_text)
     sql += " or " + stn + "." + FFieldName + " = ''";
   } else if (comboRelation->Text == "is not empty")
   {
    sql = "select " + stn + ".id from " + stn + " where " + stn + "." + FFieldName + " is not null";
    if (FMode == tqbf_text)
     sql += " and " + stn + "." + FFieldName + " != ''";
   } else
   {
    string val;
    string val2;

    switch (FMode)
    {
     case tqbf_text:
      // TODO: uppercase could be an issue -- for those fields we have now allowing mixed case ...
      val = SafeSQLString(UppercaseString(editValue->Text.c_str()));
      val2 = SafeSQLString(UppercaseString(editValue2->Text.c_str()));
      break;
     case tqbf_int:
      val = IntToString(StringToInt(editValue->Text.c_str())); // mouah!
      val2 = IntToString(StringToInt(editValue2->Text.c_str())); // mouah!
      break;
     case tqbf_float:
      val = FinancialToString(StringToFinancial(editValue->Text.c_str())); // weee? (brain.lost is true!)
      val2 = FinancialToString(StringToFinancial(editValue2->Text.c_str())); // weee? (brain.lost is true!)
      break;
     case tqbf_date:
      val = Pdate(dateValue->DateTime).OutDate(global_mode);
      val2 = Pdate(dateValue2->DateTime).OutDate(global_mode);
      break;
     case tqbf_time:
      val = Ptime(dateValue->DateTime).OutTime(global_mode);
      val2 = Ptime(dateValue2->DateTime).OutTime(global_mode);
      break;
    }

    bool need_uppercase = (FMode == tqbf_text);
    if (need_uppercase)
     sql = "select " + stn + ".id from " + stn + " where upper(" + stn + "." + FFieldName + ")";
    else
     sql = "select " + stn + ".id from " + stn + " where " + stn + "." + FFieldName;

         if (comboRelation->Text == "is equal to")
     sql += " = '" + val + "'";
    else if (comboRelation->Text == "is not equal to")
     sql += " != '" + val + "'";
    else if (comboRelation->Text == "is greater than")
     sql += " > '" + val + "'";
    else if (comboRelation->Text == "is not greater than")
     sql += " <= '" + val + "'";
    else if (comboRelation->Text == "is less than")
     sql += " < '" + val + "'";
    else if (comboRelation->Text == "is not less than")
     sql += " >= '" + val + "'";
    else if (comboRelation->Text == "is between (inclusive)")
     sql += " between '" + val + "' and '" + val2 + "'";
    else if (comboRelation->Text == "starts with")
     sql += " like '" + ReplaceStringWithString(ReplaceStringWithString(val, "%", "\\%"), "_", "\\_") + "%' escape '\\'";
    else if (comboRelation->Text == "does not start with")
     sql += " not like '" + ReplaceStringWithString(ReplaceStringWithString(val, "%", "\\%"), "_", "\\_") + "%' escape '\\'";
    else if (comboRelation->Text == "contains")
     sql += " like '%" + ReplaceStringWithString(ReplaceStringWithString(val, "%", "\\%"), "_", "\\_") + "%' escape '\\'";
    else if (comboRelation->Text == "does not contain")
     sql += " not like '%" + ReplaceStringWithString(ReplaceStringWithString(val, "%", "\\%"), "_", "\\_") + "%' escape '\\'";
    else if (comboRelation->Text == "ends with")
     sql += " like '%" + ReplaceStringWithString(ReplaceStringWithString(val, "%", "\\%"), "_", "\\_") + "' escape '\\'";
    else if (comboRelation->Text == "does not end with")
     sql += " not like '%" + ReplaceStringWithString(ReplaceStringWithString(val, "%", "\\%"), "_", "\\_") + "' escape '\\'";
    else if (comboRelation->Text == "matches")
     sql += " like '" + val + "'";
    else if (comboRelation->Text == "does not match")
     sql += " not like '" + val + "'";
   }
   break;
 }

 string answer;
 answer = Context->CreateView(sql, set<string>());
 return answer;
}
//---------------------------------------------------------------------------
bool TframeQuery_ByField::Valid ()
{
 bool failure = false;
 comboField->Color    = clWindow;
 comboRelation->Color = clWindow;
 comboValues->comboWhatever->Color = clWindow;
 dateValue->Color     = clWindow;
 editValue->Color     = clWindow;
 dateValue2->Color    = clWindow;
 editValue2->Color    = clWindow;

 switch (FMode)
 {
  case tqbf_none:
   comboField->Color = clBad;
   failure = true;
   break;
  case tqbf_list:
   {
    vector<string> temp_values = comboValues->Filter->GetMultiID();
    vector<string> all_values = comboValues->Filter->GetAllID();
    // can't have 'none' and can't have 'all'
    failure = (temp_values.empty() || temp_values.size() == all_values.size());
    if (failure)
     comboValues->comboWhatever->Color = clBad;
   }
   break;
  case tqbf_text:
   if (!editValue->Visible)
    break;
   if (FBetween)
    failure = !quValidSortedRequiredText(editValue, editValue2);
   else
    failure = !quValidRequiredText(editValue);
   break;
  case tqbf_int:
   if (!editValue->Visible)
    break;
   if (FBetween)
    failure = !quValidSortedRequiredInt(editValue, editValue2);
   else
    failure = !quValidRequiredInt(editValue);
  case tqbf_float:
   if (!editValue->Visible)
    break;
   if (FBetween)
    failure = !quValidSortedRequiredFloat(editValue, editValue2);
   else
    failure = !quValidRequiredFloat(editValue);
   break;
  case tqbf_date:
   if (FBetween)
    failure = !quSortedRequiredDate(dateValue, dateValue2);
   break;
  case tqbf_time:
   if (FBetween)
    failure = !quSortedRequiredTime(dateValue, dateValue2);
   break;
 }
 return TframeQueryGeneric::Valid() && (!failure);
}
//---------------------------------------------------------------------------
xValue TframeQuery_ByField::Save (bool with_params)
{
 xValue answer = TframeQueryGeneric::Save(with_params);
 if (with_params && xTag(answer) == "map")
 {
  map<string, xValue> config_map = xToMap(answer);

  // field
  if (comboField->ItemIndex != -1)
   config_map["field"] = xFromString(picker_content[comboField->ItemIndex].source_field);

  // relation
  if (comboRelation->Visible)
   config_map["relation"] = xFromString(comboRelation->Text.c_str());

  // per-mode
  switch (FMode)
  {
   case tqbf_list:
    {
     set<string> values;
     vector<string> temp_values = comboValues->Filter->GetMultiID();
     VecToSet(temp_values, values);
     config_map["values"] = xFromStringSet(values);
    }
    break;
   case tqbf_text:
    quSaveOptionalText(config_map, "value", editValue);
    if (FBetween)
     quSaveOptionalText(config_map, "value2", editValue2);
    break;
   case tqbf_int:
    quSaveOptionalInt(config_map, "value", editValue);
    if (FBetween)
     quSaveOptionalInt(config_map, "value2", editValue2);
    break;
   case tqbf_float:
    quSaveOptionalFloat(config_map, "value", editValue);
    if (FBetween)
     quSaveOptionalFloat(config_map, "value2", editValue2);
    break;
   case tqbf_date:
    quSaveRequiredDate(config_map, "value", dateValue);
    if (FBetween)
     quSaveRequiredDate(config_map, "value2", dateValue2);
    break;
   case tqbf_time:
    quSaveRequiredTime(config_map, "value", dateValue);
    if (FBetween)
     quSaveRequiredTime(config_map, "value2", dateValue2);
    break;
   case tqbf_bool:
    config_map["value"] = xFromBool(radioTrue->Checked);
    break;
  }

  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery_ByField::Load (xValue config, bool with_params)
{
 config = ReplaceWithGlobals(config);

 TframeQueryGeneric::Load(config, with_params);
 if (with_params && xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);

  if (xTag(config_map["field"]) == "string")
  {
   int j = 0;
   for (vector<field_info>::iterator i = picker_content.begin(); i != picker_content.end(); i++, j++)
    if (xToString(config_map["field"]) == i->source_field)
    {
     comboField->ItemIndex = j;
     if (comboField->OnChange)
      comboField->OnChange(comboField);
     break;
    }
  }

  if (xTag(config_map["relation"]) == "string")
  {
   for (int j = 0; j < comboRelation->Items->Count; j++)
    if (xToString(config_map["relation"]) == comboRelation->Items->Strings[j].c_str())
    {
     comboRelation->ItemIndex = j;
     if (comboRelation->OnChange)
      comboRelation->OnChange(comboRelation);
     break;
    }
  }

  switch (FMode)
  {
   case tqbf_list:
    if (xTag(config_map["values"]) == "set")
    {
     set<string> values_to_check = xToStringSet(config_map["values"]);
     comboValues->Filter->UncheckAll();
     comboValues->Filter->SetCheckedWhereID(values_to_check, true);
     comboValues->RefreshText();
    }
    break;
   case tqbf_text:
    quLoadRequiredText(config_map, "value", editValue);
    if (FBetween)
     quLoadRequiredText(config_map, "value2", editValue2);
    break;
   case tqbf_int:
    quLoadRequiredInt(config_map, "value", editValue);
    if (FBetween)
     quLoadRequiredInt(config_map, "value2", editValue2);
    break;
   case tqbf_float:
    quLoadRequiredFloat(config_map, "value", editValue);
    if (FBetween)
     quLoadRequiredFloat(config_map, "value2", editValue2);
    break;
   case tqbf_date:
    quLoadRequiredDate(config_map, "value", dateValue);
    if (FBetween)
     quLoadRequiredDate(config_map, "value2", dateValue2);
    break;
   case tqbf_time:
    quLoadRequiredTime(config_map, "value", dateValue);
    if (FBetween)
     quLoadRequiredTime(config_map, "value2", dateValue2);
    break;
   case tqbf_bool:
    if (xTag(config_map["value"]) == "bool")
     if (xToBool(config_map["value"]))
      radioTrue->Checked = true;
     else
      radioFalse->Checked = true;
    break;
  }
 }
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery_ByField::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery_ByField(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeQuery_ByField::Appropriate (string source_table_name)
{
 return dbIsAvailable(source_table_name);
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_ByField::comboRelationChange(TObject *Sender)
{
 if (comboRelation->Text == "is empty" || comboRelation->Text == "is not empty")
 {
  editValue->Visible = false;
  dateValue->Visible = false;
 } else
 if (FMode == tqbf_date || FMode == tqbf_time)
  dateValue->Visible = true;
 else
  editValue->Visible = true;
 Between = (comboRelation->Text == "is between (inclusive)");
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_ByField::comboFieldKeyPress(TObject *Sender,
      char &Key)
{
 bool is_enter = (Key == (char)VK_RETURN);
 FindComboBoxItem(Sender, Key);
 if (is_enter)
  comboFieldChange(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_ByField::comboRelationKeyPress(TObject *Sender,
      char &Key)
{
 bool is_enter = (Key == (char)VK_RETURN);
 FindComboBoxItem(Sender, Key);
 if (is_enter)
  comboRelationChange(Sender);
}
//---------------------------------------------------------------------------
string TframeQuery_ByField::Describe (bool as_html)
{
 string answer = UppercaseFirstChar(LowercaseString(dbPrettyPlural(LowercaseString(SourceTableName.c_str()))));

 switch (FMode)
 {
  case tqbf_list:
   {
    vector<string> pos_values = comboValues->Filter->GetMultiID();
    answer += " whose " + LowercaseString(comboField->Text.c_str()) + " is ";
    if (pos_values.size() > 1)
     answer += "one of: ";

    vector<string> pos_items;
    field_info about_field = picker_content[comboField->ItemIndex];
    string pk_table;
    vector<string> pk_fields;
    if (GetPrimaryKey(dbDatabase, UppercaseString(about_field.source_table), UppercaseString(about_field.source_field), pk_table, pk_fields) &&
        SqlToVec(dbDatabase, "select item from " + pk_table + " where id in (" + VecToCommaString(pos_values) + ")", pos_items))
    {
     string lookup_sql = "select display_option from lookup_tables where table_name = '" + UppercaseString(about_field.source_table) + "'";
     string result = GetOneField(dbDatabase, lookup_sql);
     int display_option = StringToInt(result);
     if (result == "")
      display_option = as_lowercase;

     for (vector<string>::iterator i = pos_items.begin(); i != pos_items.end(); i++)
      if (i->empty())
       *i = "[blank]";

     if(display_option == as_pretty)
      for (vector<string>::iterator i = pos_items.begin(); i != pos_items.end(); i++)
       *i = PrettyString(*i);
     else if (display_option == as_uppercase)
      for (vector<string>::iterator i = pos_items.begin(); i != pos_items.end(); i++)
       *i = UppercaseString(*i);
     else if (display_option == as_sentence)
      for (vector<string>::iterator i = pos_items.begin(); i != pos_items.end(); i++)
       *i = SentenceString(*i);
     else /* if (display_option == as_lowercase) */ // other cases too?
      for (vector<string>::iterator i = pos_items.begin(); i != pos_items.end(); i++)
       *i = LowercaseString(*i);
     /*
      for (vector<string>::iterator i = pos_items.begin(); i != pos_items.end(); i++)
       *i = LowercaseFirstChar(*i);
     */
     answer += VecToCommaString(pos_items);
    } else
     answer += "[failed to retrieve list of item names]";
    answer += (as_html ? ".<br>" : ".\r\n");
   }
   break;
  case tqbf_bool:
   if (radioTrue->Checked)
    answer += " that are identified as '" + LowercaseString(comboField->Text.c_str()) + "'";
   else
    answer += " that are not identified as '" + LowercaseString(comboField->Text.c_str()) + "'";
   answer += (as_html ? ".<br>" : ".\r\n");
   break;
  case tqbf_text:
  case tqbf_int:
  case tqbf_float:
  case tqbf_date:
  case tqbf_time:
   // null / not-null have no extra params
   answer += " whose " + LowercaseString(comboField->Text.c_str()) + " ";
   if (comboRelation->Text == "is empty")
   {
    answer += "is unknown";
    if (FMode == tqbf_text)
     answer += " or blank";
   } else if (comboRelation->Text == "is not empty")
   {
    answer += "is known";
    if (FMode == tqbf_text)
     answer += " and not blank";
   } else
   {
    string val;

    switch (FMode)
    {
     case tqbf_text:
      // TODO: uppercase could be an issue -- for those fields we have now allowing mixed case ...
      val = "'" + string(editValue->Text.c_str()) + "'";
      break;
     case tqbf_int:
      val = IntToString(StringToInt(editValue->Text.c_str())); // mouah!
      break;
     case tqbf_float:
      val = FinancialToString(StringToFinancial(editValue->Text.c_str())); // weee? (brain.lost is true!)
      break;
     case tqbf_date:
      val = Pdate(dateValue->DateTime).OutDate(global_mode);
      break;
     case tqbf_time:
      val = Ptime(dateValue->DateTime).OutTime(global_mode);
      break;
    }

    answer += string(comboRelation->Text.c_str()) + " " + val + (as_html ? ".<br>" : ".\r\n");
   }
   break;
 }

 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery_ByField::ApplySettingsImpl (xValue config)
{
 if (xTag(config) == "TframeOptions_DateRange" && FMode == tqbf_date)
 {
  config = xContent(config);
  if (xTag(config) == "map")
  {
   map<string, xValue> config_map = xToMap(config);
   quLoadRequiredDate(config_map, "value", dateValue);
   if (FBetween)
    quLoadRequiredDate(config_map, "value2", dateValue2);
  }
 }
}
//---------------------------------------------------------------------------

