//---------------------------------------------------------------------------

#ifndef codeQuery_ByFieldH
#define codeQuery_ByFieldH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include "codeQueryGeneric.h"
#include "codeRubberContainer.h"
#include "codeFrameCheckListDropDown.h"
#include <algorithm>
#include "filter.h"
#include "db_hardcoded_metadata.h"
//---------------------------------------------------------------------------
enum TQueryByFieldModes {tqbf_none, tqbf_list, tqbf_text, tqbf_int, tqbf_float, tqbf_date, tqbf_time, tqbf_bool};
class TframeQuery_ByField : public TframeQueryGeneric
{
__published:	// IDE-managed Components
        TComboBox *comboField;
        TComboBox *comboRelation;
        TEdit *editValue;
        TRadioButton *radioTrue;
        TRadioButton *radioFalse;
        TLabel *_labelList;
        TLabel *_labelBool;
        TDateTimePicker *dateValue;
        TDateTimePicker *dateValue2;
        TEdit *editValue2;
        TLabel *_labelAnd;
        TframeCheckListDropDown *comboValues;
        void __fastcall comboFieldChange(TObject *Sender);
        void __fastcall comboRelationChange(TObject *Sender);
        void __fastcall comboFieldKeyPress(TObject *Sender, char &Key);
        void __fastcall comboRelationKeyPress(TObject *Sender, char &Key);
private:	// User declarations
        TQueryByFieldModes FMode;
        bool FBetween;
        vector<field_info> picker_content;
        string FFieldName;
protected:
        void CorrectSize();
        void __fastcall virtual SetMode(TQueryByFieldModes Value);
        void __fastcall virtual SetBetween(bool Value);
        void __fastcall virtual SetSourceTableName (AnsiString Value);
        string virtual PrepareImpl ();
        void   virtual ApplySettingsImpl (xValue settings);
public:
        bool   virtual Valid ();
        string virtual Describe (bool as_html);
        xValue virtual Save  (bool with_params);
        void   virtual Load  (xValue config, bool with_params);
        static TframeQueryGeneric* Create (TComponent* owner);
        static bool                Appropriate (string source_table_name);
public:		// User declarations
        __property TQueryByFieldModes Mode = {read = FMode, write = SetMode};
        __property bool Between = {read = FBetween, write = SetBetween};
        __fastcall TframeQuery_ByField(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeQuery_ByField *frameQuery_ByField;
//---------------------------------------------------------------------------
#endif
