//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery_ByResultSet.h"
#include "db_hardcoded_metadata.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryGeneric"
#pragma resource "*.dfm"
TframeQuery_ByResultSet *frameQuery_ByResultSet;
//---------------------------------------------------------------------------
__fastcall TframeQuery_ByResultSet::TframeQuery_ByResultSet(TComponent* Owner)
        : TframeQueryGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
 Cache = true;
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_ByResultSet::SetSourceTableName (AnsiString Value)
{
 TframeQueryGeneric::SetSourceTableName(Value);

 vector<map<string, string> > set_entries;
 if (!SqlToVecMap(dbDatabase, "select id, description from user_results where source_table_name = '" + SafeSQLString(LowercaseString(SourceTableName.c_str())) + "'", set_entries))
  PSay("Failed to retrieve the list of available result sets.", m_database_error, MB_OK, "TframeQuery_ByResultSet");
 else
 {
  comboSet->Items->Clear();
  set_ids.clear();
  for (vector<map<string, string> >::iterator i = set_entries.begin(); i != set_entries.end(); i++)
  {
   set_ids.push_back((*i)["id"]);
   comboSet->Items->Add(SentenceString((*i)["description"]).c_str());
  }
 }
}
//---------------------------------------------------------------------------
string TframeQuery_ByResultSet::PrepareImpl ()
{
 if (comboSet->ItemIndex > -1 && comboSet->ItemIndex < set_ids.size())
 {
  string sql = "select id from user_result_items where user_result_id = " + set_ids[comboSet->ItemIndex];
  string answer = Context->CreateView(sql, set<string>());
  return answer;
 } else
 {
  PSay("Result set name drop-down should have had an item selected at this point, but didn't!", m_program_error, MB_OK, "TframeQuery_ByResultSet");
  return "";
 }
}
//---------------------------------------------------------------------------
bool TframeQuery_ByResultSet::Valid ()
{
 comboSet->Color = clWindow;
 if (comboSet->Text == "" || comboSet->ItemIndex == -1)
  comboSet->Color = clBad;
 return TframeQueryGeneric::Valid() && (comboSet->Color != clBad);
}
//---------------------------------------------------------------------------
string TframeQuery_ByResultSet::Describe (bool as_html)
{
 return UppercaseFirstChar(LowercaseString(dbPrettyPlural(LowercaseString(SourceTableName.c_str())))) +
        " present in a saved result set, " + string(comboSet->Text.c_str()) + (as_html ? ".<br>" : ".\r\n");
}
//---------------------------------------------------------------------------
xValue TframeQuery_ByResultSet::Save (bool with_params)
{
 xValue answer = TframeQueryGeneric::Save(with_params);
 if (with_params && xTag(answer) == "map")
 {
  map<string, xValue> config_map = xToMap(answer);
  if (comboSet->ItemIndex > -1 && comboSet->ItemIndex < set_ids.size())
   config_map["user_result_id"] = xFromInt(StringToInt(set_ids[comboSet->ItemIndex]));
  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery_ByResultSet::Load (xValue config, bool with_params)
{
 config = ReplaceWithGlobals(config);

 TframeQueryGeneric::Load(config, with_params);
 if (with_params && xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);
  for (int i = 0; i < set_ids.size(); i++)
   if (set_ids[i] == IntToString(xToInt(config_map["user_result_id"])))
    comboSet->ItemIndex = i;
 }
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery_ByResultSet::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery_ByResultSet(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeQuery_ByResultSet::Appropriate (string source_table_name)
{
 return dbIsAvailable(source_table_name);
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_ByResultSet::comboSetKeyPress(TObject *Sender,
      char &Key)
{
 FindComboBoxItem(Sender, Key);
}
//---------------------------------------------------------------------------

