//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery_CustomSql.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryGeneric"
#pragma resource "*.dfm"
TframeQuery_CustomSql *frameQuery_CustomSql;
//---------------------------------------------------------------------------
__fastcall TframeQuery_CustomSql::TframeQuery_CustomSql(TComponent* Owner)
        : TframeQueryGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_CustomSql::buttonPlanClick(TObject *Sender)
{
 // stuff
 string plan;
 if (GetSqlPlan (dbDatabase, editSql->Text.c_str(), plan))
  PSay(plan, m_debug, MB_OK, "TframeQuery_CustomSql");
 else
  PSay(last_sql_lib_error.message, m_database_error, MB_OK, "TframeQuery_CustomSql");
}
//---------------------------------------------------------------------------
string TframeQuery_CustomSql::PrepareImpl ()
{
 string answer;
 answer = Context->CreateView(editSql->Text.c_str(), set<string>());
 Cache = checkCache->Checked;
 Proxy = checkProxy->Checked;
 Clip = checkClip->Checked;
 return answer;
}
//---------------------------------------------------------------------------
bool TframeQuery_CustomSql::Valid ()
{
 editSql->Color = clWindow;

 string plan;
 if (!GetSqlPlan (dbDatabase, editSql->Text.c_str(), plan))
  editSql->Color = clBad;

 return TframeQueryGeneric::Valid() && (editSql->Color != clBad);
}
//---------------------------------------------------------------------------
xValue TframeQuery_CustomSql::Save (bool with_params)
{
 xValue answer = TframeQueryGeneric::Save(with_params);
 if (with_params && xTag(answer) == "map")
 {
  map<string, xValue> config_map = xToMap(answer);

  config_map["sql"] = xFromString(editSql->Text.c_str());
  config_map["is_cached"]  = xFromBool(checkCache->Checked);
  config_map["is_proxied"] = xFromBool(checkProxy->Checked);
  config_map["is_clipped"] = xFromBool(checkClip->Checked);

  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery_CustomSql::Load (xValue config, bool with_params)
{
 config = ReplaceWithGlobals(config);

 TframeQueryGeneric::Load(config, with_params);
 if (with_params && xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);
  if (xTag(config_map["sql"]) == "string")
   editSql->Text = xToString(config_map["sql"]).c_str();
  checkCache->Checked = xToBool(config_map["is_cached"]);
  checkProxy->Checked = xToBool(config_map["is_proxied"]);
  checkClip->Checked  = xToBool(config_map["is_clipped"]);
  CheckboxesChanged(NULL);
 }
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery_CustomSql::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery_CustomSql(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeQuery_CustomSql::Appropriate (string source_table_name)
{
 return (optionsPermissions["special.debug_query_action"]["enabled"] == "true");
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_CustomSql::CheckboxesChanged (TObject *Sender)
{
 Cache = checkCache->Checked;
 Proxy = checkProxy->Checked;
 Clip = checkClip->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_CustomSql::SetProxy (bool Value)
{
 TframeQueryGeneric::SetProxy(Value);
 checkCache->Checked = Cache;
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_CustomSql::SetCache (bool Value)
{
 TframeQueryGeneric::SetCache(Value);
 checkProxy->Checked = Proxy;
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_CustomSql::SetClip (bool Value)
{
 TframeQueryGeneric::SetClip(Value);
 checkClip->Checked = Clip;
}
//---------------------------------------------------------------------------

