//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery_Has.h"
#include "codeQueryMagic.h"
#include "codeQuery_Whole.h"
#include "util.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryGeneric"
#pragma resource "*.dfm"
TframeQuery_Has *frameQuery_Has;
//---------------------------------------------------------------------------
__fastcall TframeQuery_Has::TframeQuery_Has(TComponent* Owner)
        : TframeQueryGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;

 FORM_TRY
  TframeQueryMagic* z = new TframeQueryMagic(this);
  z->HostQuery = this;
  z->SourceTableName = "-";
 FORM_CATCH

 comboType->OnKeyPress = comboTypeKeyPress;
 comboType->OnChange   = comboTypeChange;

 // Proxy = true;
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_Has::SetClip (bool Value)
{
 // all three methods pull from 'whole' themselves
 FClip = false;
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_Has::comboTypeKeyPress(TObject *Sender, char &Key)
{
 bool is_enter = (Key == (char)VK_RETURN); // just in case it gets reset by the next function?
 FindComboBoxItem(Sender, Key);
 if (is_enter)
  comboTypeChange(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_Has::comboTypeChange(TObject *Sender)
{
 if (comboType->Text != "" && comboType->ItemIndex != -1)
 {
  if (FHostedQueries.size())
   FHostedQueries[0]->SourceTableName = picker_content[comboType->ItemIndex].source_table.c_str();
 } else
 {
  if (FHostedQueries.size())
   FHostedQueries[0]->SourceTableName = "-";
 }
}
//---------------------------------------------------------------------------
string TframeQuery_Has::PrepareImpl ()
{
 string answer;

 if (FHostedQueries.size())
 {
  FHostedQueries[0]->Proxy = true;
  FHostedQueries[0]->Clip = true;
  string data_source = (FHostedQueries[0])->Prepare();
  string whole_source = Context->FindWhole(SourceTableName.c_str());

  fk_info about_fk = picker_content[comboType->ItemIndex];

  bool min_attempted = false;
  bool max_attempted = false;
  bool has_min = false;
  bool has_max = false;
  int  min_val = 0;
  int  max_val = 0;

  min_attempted = (editMin->Text != "");
  has_min = min_attempted && IsInt(editMin->Text.c_str());
  if (has_min)
   min_val = StringToInt(editMin->Text.c_str());

  max_attempted = (editMax->Text != "");
  has_max = max_attempted && IsInt(editMax->Text.c_str());
  if (has_max)
   max_val = StringToInt(editMax->Text.c_str());

  string sql;

  if (has_min && !has_max && min_val == 1)
  {
   // PSay("Method 1: simple distinct", m_debug, MB_OK, "TframeQuery_Has");
   if (true /* IDYES == PSay("Use standard method for 'has' queries?", m_confirmation, MB_YESNO, "TframeQuery_Has")*/)
   {
    set<string> temp;
    temp.clear();
    temp.insert(data_source);
    sql = "select " + about_fk.source_table_actual + "." + about_fk.source_field + " from " + about_fk.source_table_actual +
          " inner join " + data_source + " on " + data_source + ".id = " + about_fk.source_table_actual + ".id";
    string phase_one = Context->CreateView(sql, temp);
    string phase_two = Context->CreateProxyView(phase_one);
    sql = "select distinct id from " + phase_two;
    temp.clear();
    temp.insert(phase_two);
    string phase_three = Context->CreateView(sql, temp);
    string phase_four = Context->CreateProxyView(phase_three);
    temp.clear();
    temp.insert(phase_four);
    temp.insert(whole_source);
    sql = "select " + phase_four + ".id from " + phase_four + " inner join " + whole_source + " on " + phase_four + ".id = " + whole_source + ".id";
    string phase_five = Context->CreateView(sql, temp);
    answer = phase_five;
   } else
   {
    set<string> temp;
    temp.clear();
    temp.insert(data_source);
    temp.insert(whole_source);

    sql = "select " + whole_source + ".id from " + whole_source + " where exists ("
          "select " + data_source + ".id from " + data_source +
          " left join " + about_fk.source_table_actual +
          " on " + about_fk.source_table_actual + ".id = " + data_source + ".id"
          " where " + about_fk.source_table_actual + "." + about_fk.source_field + " = " + whole_source + ".id)";
    answer = Context->CreateView(sql, temp);
   }
  } else
  if (has_max && max_val == 0)
  {
   // PSay("Method 2: simple left-join with not", m_debug, MB_OK, "TframeQuery_Has");
   if (true /* IDYES == PSay("Use standard method for 'doesn't have' queries?", m_confirmation, MB_YESNO, "TframeQuery_Has")*/)
   {
    set<string> temp;
    temp.clear();
    temp.insert(data_source);
    sql = "select " + about_fk.source_table_actual + "." + about_fk.source_field + " from " + about_fk.source_table_actual +
          " inner join " + data_source + " on " + data_source + ".id = " + about_fk.source_table_actual + ".id";
    string phase_one = Context->CreateView(sql, temp);
    string phase_two = Context->CreateProxyView(phase_one);
    // we don't care about 'distinct', do we?
    temp.clear();
    temp.insert(phase_two);
    temp.insert(whole_source);
    // we don't need 'distinct' here because it's those who -didn't- match anything that they -could- have.
    // (if they had something attached, they'll never join to null)
    sql = "select " + whole_source + ".id from " + whole_source + " left join " + phase_two + " on " + phase_two + ".id = " + whole_source + ".id where " + phase_two + ".id is null";
    string phase_three = Context->CreateView(sql, temp);
    answer = phase_three;
   } else
   {
    set<string> temp;
    temp.clear();
    temp.insert(data_source);
    temp.insert(whole_source);

    sql = "select " + whole_source + ".id from " + whole_source + " where not exists ("
          "select " + data_source + ".id from " + data_source +
          " left join " + about_fk.source_table_actual +
          " on " + about_fk.source_table_actual + ".id = " + data_source + ".id"
          " where " + about_fk.source_table_actual + "." + about_fk.source_field + " = " + whole_source + ".id)";
    answer = Context->CreateView(sql, temp);
   }
  } else
  {
   // PSay("Method 3: group by, having", m_debug, MB_OK, "TframeQuery_Has");
   sql = "select " + whole_source + ".id from " + whole_source;
   if (has_min)
    sql += " inner join " + about_fk.source_table_actual + " on " + about_fk.source_table_actual + "." + about_fk.source_field + " = " + whole_source /* about_fk.destination_table */ + ".id "
           " inner join " + data_source + " on " + data_source + ".id = " + about_fk.source_table_actual + ".id ";
   else
    sql += " left join " + about_fk.source_table_actual + " on " + about_fk.source_table_actual + "." + about_fk.source_field + " = " + whole_source /* about_fk.destination_table */ + ".id "
           " left join " + data_source + " on " + data_source + ".id = " + about_fk.source_table_actual + ".id ";
   set<string> temp;
   temp.insert(whole_source);
   temp.insert(data_source);
   string phase_one = Context->CreateView(sql, temp);
   string phase_two = Context->CreateProxyView(phase_one);

   sql = "select " + phase_two + ".id from " + phase_two +
         " group by " + phase_two + ".id"
         " having count(" + phase_two + ".id)";
   if (has_min && has_max)
    sql += " between " + IntToString(min_val) + " and " + IntToString(max_val);
   else if (has_min)
    sql += " >= " + IntToString(min_val);
   else // if (has_max) -- only!
    sql += " <= " + IntToString(max_val) + " or count(" + phase_two + ".id) is null";
   temp.clear();
   temp.insert(phase_two);
   string phase_three = Context->CreateView(sql, temp);
   answer = phase_three;
  }
 }

 return answer;
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_Has::ChangeHostedQuery (TframeQueryGeneric* Value)
{
 // in case it's auto-created for us?
 if (FHostedQueries.size())
  FHostedQueries[0]->Indent = 24;
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_Has::SetSourceTableName (AnsiString Value)
{
 AnsiString old_stn = SourceTableName;
 TframeQueryGeneric::SetSourceTableName(Value);
 // list of tables we have FK's to
 if (old_stn != SourceTableName)
 {
  comboType->Items->Clear();
  picker_content = dbPointsTo(SourceTableName.c_str());
  for (int i = 0; i < picker_content.size(); i++)
  {
   string a = picker_content[i].source_table_plural + (picker_content[i].note.empty() ? string("") : " (" + picker_content[i].note + ")");
   comboType->Items->Add(a.c_str());
   if (a == comboType->Text.c_str())
    comboType->ItemIndex = i;
  }
 }

 if (FHostedQueries.size() && comboType->ItemIndex != -1)
  (FHostedQueries[0])->SourceTableName = picker_content[comboType->ItemIndex].source_table.c_str();
}
//---------------------------------------------------------------------------
bool TframeQuery_Has::Valid ()
{
 editMin->Color = clWindow;
 editMax->Color = clWindow;
 comboType->Color = clWindow;

 bool min_attempted = false;
 bool max_attempted = false;
 bool has_min = false;
 bool has_max = false;
 int  min_val = 0;
 int  max_val = 0;

 min_attempted = (editMin->Text != "");
 has_min = min_attempted && IsInt(editMin->Text.c_str());
 if (has_min)
  min_val = StringToInt(editMin->Text.c_str());

 max_attempted = (editMax->Text != "");
 has_max = max_attempted && IsInt(editMax->Text.c_str());
 if (has_max)
  max_val = StringToInt(editMax->Text.c_str());

 if (min_attempted && !has_min)
  editMin->Color = clBad;
 if (max_attempted && !has_max)
  editMax->Color = clBad;
 if (comboType->ItemIndex == -1)
  comboType->Color = clBad;

 if (has_min && has_max && min_val > max_val)
 {
  editMin->Color = clBad;
  editMax->Color = clBad;
 }

/*
 if (!(has_min || has_max))
  PSay("(has_min || has_max)", m_debug, MB_OK, "");
 if (!(!has_min || !has_max || min_val <= max_val))
  PSay("(!has_min || !has_max || min_val <= max_val)", m_debug, MB_OK, "");
 if (!(comboType->ItemIndex != -1))
  PSay("(comboType->ItemIndex != -1)", m_debug, MB_OK, "");
*/

 // no good way to color this
 if (!(has_min || has_max) || (has_min && !has_max && min_val == 0))
  PSay("'Has' queries need at least one minimum or maximum, \nand a minimum of zero must be accompanied by some sort of maximum (even zero.)", m_missing_data, MB_OK, "TframeQuery_Has");

 return TframeQueryGeneric::Valid() &&
        (!min_attempted || has_min) &&
        (!max_attempted || has_max) &&
        (has_min || has_max) &&                         // at least one is required
        (!has_min || !has_max || min_val <= max_val) && // if both, min <= max
        (has_max || (has_min && min_val != 0)) &&       // if the minimum is zero, need a non-null maximum 
        (comboType->ItemIndex != -1);                   // source chosen
}
//---------------------------------------------------------------------------
xValue TframeQuery_Has::Save (bool with_params)
{
 xValue answer = TframeQueryGeneric::Save(with_params);
 if (with_params && xTag(answer) == "map")
 {
  map<string, xValue> config_map = xToMap(answer);
  if (editMin->Text != "" && IsInt(editMin->Text.c_str()))
   config_map["min"] = xFromInt(StringToInt(editMin->Text.c_str()));
  if (editMax->Text != "" && IsInt(editMax->Text.c_str()))
   config_map["max"] = xFromInt(StringToInt(editMax->Text.c_str()));
  config_map["type"] = xFromString(comboType->Text.c_str());
  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery_Has::Load (xValue config, bool with_params)
{
 // let it auto-recreate the sub-query for us
 while (FHostedQueries.size())
  delete FHostedQueries[0];

 TframeQueryGeneric::Load(config, with_params);
 if (with_params && xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);
  if (xTag(config_map["min"]) == "int")
   editMin->Text = IntToString(xToInt(config_map["min"])).c_str();
  else
   editMin->Text = "";
  if (xTag(config_map["max"]) == "int")
   editMax->Text = IntToString(xToInt(config_map["max"])).c_str();
  else
   editMax->Text = "";
  if (xTag(config_map["type"]) == "string")
   for (int j = 0; j < comboType->Items->Count; j++)
    if (comboType->Items->Strings[j].c_str() == xToString(config_map["type"]))
    {
     comboType->ItemIndex = j;
     break;
    }
   // comboType->Text = xToString(config_map["type"]).c_str();
 }

 // recreate stuff if necessary -- code copied from codeQuery_Has
 if (FHostedQueries.empty())
 {
  FORM_TRY
   TframeQueryMagic* z = new TframeQueryMagic(this);
   z->HostQuery = this;
   if (comboType->ItemIndex != -1)
    z->SourceTableName = picker_content[comboType->ItemIndex].source_table.c_str();
  FORM_CATCH
 }
}
//---------------------------------------------------------------------------
bool TframeQuery_Has::Appropriate (string source_table_name)
{
 bool temp = (!dbPointsTo(source_table_name).empty());
 return temp;
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery_Has::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery_Has(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_Has::SetSimple (bool Value)
{
 TframeQueryGeneric::SetSimple(Value);
 comboType->Visible = !Simple;
 labelType->Visible = Simple;
 labelType->Caption = comboType->Text;
}
//---------------------------------------------------------------------------
string TframeQuery_Has::Describe (bool as_html)
{
 string desc;

 int min_val = StringToInt(editMin->Text.c_str());
 int max_val = StringToInt(editMax->Text.c_str());
 bool has_min = (editMin->Text != "" && IsInt(editMin->Text.c_str())) && min_val;
 bool has_max = (editMax->Text != "" && IsInt(editMax->Text.c_str()));

 if (has_min && has_max && min_val == max_val)
  desc = "exactly " + IntToString(min_val);
 else
 if (has_min && has_max)
  desc = "between " + IntToString(min_val) + " and " + IntToString(max_val);
 else
 if (has_min)
  desc = "at least " + IntToString(min_val);
 else
 if (has_max && max_val)
  desc = "at most " + IntToString(max_val);
 else
 if (has_max && !max_val)
  desc = "no";
 else
  desc = "unknown";

 fk_info about_fk = picker_content[comboType->ItemIndex];
 bool is_singular = (has_min && !has_max && min_val == 1) ||
                    (has_min && has_max && min_val == max_val && min_val == 1) ||
                    (!has_min && has_max && max_val == 1);
 string t_desc = ((is_singular) ? dbPrettySingular(LowercaseString(about_fk.source_table)) : dbPrettyPlural(LowercaseString(about_fk.source_table)));

 if (!FHostedQueries.empty())
  return UppercaseFirstChar(LowercaseString(dbPrettyPlural(LowercaseString(SourceTableName.c_str()))) +
   " that have " + desc + " " +
   LowercaseString(t_desc) + " among the following:") +
   (as_html ? "<br>" : "\r\n") +
   string(as_html ? "<div style='padding-left: 24px;'>" : "  ") + FHostedQueries[0]->Describe(as_html) + string(as_html ? "</div>" : "");
 else
  return "Undefined query (no sub-query.)" + string(as_html ? "<br>" : "\r\n");
}
//---------------------------------------------------------------------------

