//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery_None.h"
#include "util.h"
#include "db_hardcoded_metadata.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryOperator"
#pragma resource "*.dfm"
TframeQuery_None *frameQuery_None;
//---------------------------------------------------------------------------
__fastcall TframeQuery_None::TframeQuery_None(TComponent* Owner)
        : TframeQueryOperator(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
 Cache = true;
 // Proxy = true; // could get rather nasty.
 Clip = false;
 Proxy = true;
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery_None::SetClip (bool Value)
{
 // our method already clips
 // as to sub-queries ... "find all people who are not among [people we can't see + some people we can see]" = "some more people we can see" ... we can't get around it, which is good?
 FClip = false;
}
//---------------------------------------------------------------------------
string TframeQuery_None::PrepareImpl ()
{
 string answer;

 ProxyMultiChildren();

 set<string> dependent_views;

 set<string> hosted_views;
 for (vector<TframeQueryGeneric*>::iterator i = FHostedQueries.begin(); i != FHostedQueries.end(); i++)
 {
  // (*i)->Proxy = true;
  (*i)->Clip = true;
  hosted_views.insert((*i)->Prepare());
 }
 dependent_views = hosted_views;

 string whole_view = Context->FindWhole(SourceTableName.c_str());
 dependent_views.insert(whole_view);

 string sql;
 // works, but seems slow.
/*
 sql = "select " + whole_view + ".id from " + whole_view;
 for (set<string>::iterator i = hosted_views.begin(); i != hosted_views.end(); i++)
  sql += " left join " + *i + " on " + *i + ".id = " + whole_view + ".id";
 sql += " where ";
 for (set<string>::iterator i = hosted_views.begin(); i != hosted_views.end(); i++)
  sql += (i != hosted_views.begin() ? "and " : "") + *i + ".id is null ";
*/

 // untested
 sql = "select " + whole_view + ".id from " + whole_view;
 sql += " where";
 for (set<string>::iterator i = hosted_views.begin(); i != hosted_views.end(); i++)
  sql += (i != hosted_views.begin() ? string(" and") : string("")) + " not exists(select " + *i + ".id from " + *i + " where " + *i + ".id = " + whole_view + ".id) ";

 answer = Context->CreateView(sql, dependent_views);

 return answer;
}
//---------------------------------------------------------------------------
bool TframeQuery_None::Appropriate (string source_table_name)
{
 return TframeQuery_Whole::Appropriate(source_table_name);
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery_None::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery_None(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
string TframeQuery_None::Describe (bool as_html)
{
 return UppercaseFirstChar(LowercaseString(dbPrettyPlural(LowercaseString(SourceTableName.c_str()))) + " that match none of the following:") + (as_html ? "<br>" : "\r\n") + TframeQueryOperator::Describe(as_html);
}
//---------------------------------------------------------------------------

