//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery__ByGroup.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryGeneric"
#pragma resource "*.dfm"
TframeQuery__ByGroup *frameQuery__ByGroup;
//---------------------------------------------------------------------------
__fastcall TframeQuery__ByGroup::TframeQuery__ByGroup(TComponent* Owner)
        : TframeQueryGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
 Cache = true;
 // ListExpanded = false;

 group_filter.SetListViewHandle(listGroups);
 group_filter.SetSecurity("");
 group_filter.AddColumnSpec("Department / Group", "", as_text, true, 100, prettyString);
 group_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 group_filter.FetchPreferences("query__bygroup.group_filter");
 group_filter.SetIconStatus(false);
 group_filter.SetAutosizeColumns(false);
 group_filter.SetCheck(true);
 group_filter.SetHeader(false);
 group_filter.SetSQLStatement("select item, id from groups");
 group_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
string TframeQuery__ByGroup::PrepareImpl ()
{
 string answer;

 // copied from peoplebygender

 vector<string> pos_groups = group_filter.GetMultiID();
 vector<string> all_groups = group_filter.GetAllID();
 set<string> s_pos_groups;
 set<string> s_all_groups;
 set<string> s_neg_groups;

 VecToSet(pos_groups, s_pos_groups);
 VecToSet(all_groups, s_all_groups);
 set_difference(s_all_groups.begin(), s_all_groups.end(),
                s_pos_groups.begin(), s_pos_groups.end(),
                insert_iterator<set<string> >(s_neg_groups, s_neg_groups.begin()));
 string sql;
 string stn = SourceTableName.c_str();

 if (s_neg_groups.size() > s_pos_groups.size())
  sql = "select " + stn + ".id from " + stn + " where " + stn + ".group_id in (" + SetToCommaString(s_pos_groups) + ")";
 else
  sql = "select " + stn + ".id from " + stn + " where " + stn + ".group_id not in (" + SetToCommaString(s_neg_groups) + ")";
 answer = Context->CreateView(sql, set<string>());
 return answer;
}
//---------------------------------------------------------------------------
bool TframeQuery__ByGroup::Valid ()
{
 listGroups->Color = clWindow;

 vector<string> temp_groups = group_filter.GetMultiID();
 vector<string> all_groups = group_filter.GetAllID();

 // none -- what's the point?
 if (temp_groups.empty())
  listGroups->Color = clBad;

 // all -- what's the point?
 if (temp_groups.size() == all_groups.size())
  listGroups->Color = clBad;

 return TframeQueryGeneric::Valid() && (listGroups->Color == clWindow);
}
//---------------------------------------------------------------------------
xValue TframeQuery__ByGroup::Save (bool with_params)
{
 xValue answer = TframeQueryGeneric::Save(with_params);
 if (with_params && xTag(answer) == "map")
 {
  map<string, xValue> config_map = xToMap(answer);

  set<string> groups;
  vector<string> temp_groups = group_filter.GetMultiID();
  VecToSet(temp_groups, groups);
  config_map["groups"] = xFromStringSet(groups);

  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery__ByGroup::Load (xValue config, bool with_params)
{
 config = ReplaceWithGlobals(config);

 TframeQueryGeneric::Load(config, with_params);
 if (with_params && xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);
  if (xTag(config_map["groups"]) == "set")
  {
   set<string> groups_to_check = xToStringSet(config_map["groups"]);
   group_filter.UncheckAll();
   group_filter.SetCheckedWhereID(groups_to_check, true);
  }
 }
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery__ByGroup::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery__ByGroup(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeQuery__ByGroup::Appropriate (string source_table_name)
{
 return ((source_table_name == "tasks") && (optionsPermissions["table.tasks"]["view"] == "true")) ||
        ((source_table_name == "conditions") && (optionsPermissions["table.conditions"]["view"] == "true"));
}
//---------------------------------------------------------------------------
