//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery__ConditionsByCode.h"
#include "codeSearchCode.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryGeneric"
#pragma link "codeFrameCodeTaxonomy"
#pragma resource "*.dfm"
TframeQuery__ConditionsByCode *frameQuery__ConditionsByCode;
//---------------------------------------------------------------------------
__fastcall TframeQuery__ConditionsByCode::TframeQuery__ConditionsByCode(TComponent* Owner)
        : TframeQueryGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
 Cache = true;
 codeCodes->Type = txn_condition;
}
//---------------------------------------------------------------------------
string TframeQuery__ConditionsByCode::PrepareImpl ()
{
 string answer;
 string sql = "select conditions.id from conditions where " + codeCodes->SQL;
 answer = Context->CreateView(sql, set<string>());
 return answer;
}
//---------------------------------------------------------------------------
bool TframeQuery__ConditionsByCode::Valid ()
{
 bool answer = true;
 codeCodes->Color = clWindow;
 if (!codeCodes->Valid)
 {
  codeCodes->BoxColor = clBad;
  answer = false;
 }
 return TframeQueryGeneric::Valid() && answer;
}
//---------------------------------------------------------------------------
xValue TframeQuery__ConditionsByCode::Save (bool with_params)
{
 xValue answer = TframeQueryGeneric::Save(with_params);
 if (with_params && xTag(answer) == "map")
 {
  map<string, xValue> config_map = xToMap(answer);
  config_map["matches"] = codeCodes->xCodeDescription;
  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery__ConditionsByCode::Load (xValue config, bool with_params)
{
 config = ReplaceWithGlobals(config);

 TframeQueryGeneric::Load(config, with_params);
 if (with_params && xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);
  codeCodes->xCodeDescription = config_map["matches"];
 }
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery__ConditionsByCode::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery__ConditionsByCode(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeQuery__ConditionsByCode::Appropriate (string source_table_name)
{
 return (source_table_name == "conditions" ||
         source_table_name == "self-conditions" ||
         source_table_name == "rel-conditions") && (optionsPermissions["table.conditions"]["view"] == "true");
}
//---------------------------------------------------------------------------
string TframeQuery__ConditionsByCode::Describe (bool as_html)
{
 return "Diagnosed conditions with an ICD-9 code among: " + string(codeCodes->Text.c_str()) + string(as_html ? ".<br>" : ".\r\n");
}
//---------------------------------------------------------------------------

