//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery__ObsResponseSetsByResponse.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryGeneric"
#pragma resource "*.dfm"
TframeQuery__ObsResponseSetsByResponse *frameQuery__ObsResponseSetsByResponse;
//---------------------------------------------------------------------------
__fastcall TframeQuery__ObsResponseSetsByResponse::TframeQuery__ObsResponseSetsByResponse(TComponent* Owner)
        : TframeQueryGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
 Cache = true;
 Proxy = true; // the clipping seems to create HUGE problems ...
 lookupTables->RegisterComboBox("obs_questions", comboKey);
 comboKey->OnKeyPress = comboKeyKeyPress; // redirect -- because of OnChange we want to use
 RefreshObsQuestionType();
}
//---------------------------------------------------------------------------
__fastcall TframeQuery__ObsResponseSetsByResponse::~TframeQuery__ObsResponseSetsByResponse()
{
 lookupTables->UnregisterComboBox(comboKey);
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery__ObsResponseSetsByResponse::comboKeyChange(TObject *Sender)
{
 // change which ops are available based on type
 comboKey->Color = clWindow;
 comboOp->Color  = clWindow;
 editVal->Color  = clWindow;
 comboVal->Color = clWindow;

 RefreshObsQuestionType();

 bool allow_lesser = false;
 bool allow_equal = false;

 editVal->Visible = false;
 comboVal->Visible = false;
 lookupTables->UnregisterComboBox(comboVal);

 if (obs_type == "5") // date
 {
  allow_lesser = true;
  allow_equal = true;
  editVal->Text = "";
  editVal->Visible = true;
 }
 if (obs_type == "4") // metric
 {
  allow_lesser = true;
  editVal->Text = "0.00";
  editVal->Visible = true;
 }
 else if (obs_type == "3") // ordinal
 {
  allow_lesser = true;
  allow_equal = true;
  lookupTables->RegisterComboBox("obs_option_types", comboVal, "select id, item, valid from obs_option_types where obs_option_set_id = " + obs_opt + " order by rank");
  comboVal->Visible = true;
 }
 else if (obs_type == "2") // text
 {
  allow_equal = true;
  editVal->Text = "";
  editVal->Visible = true;
 }
 else if (obs_type == "1") // choice
 {
  allow_equal = true;
  lookupTables->RegisterComboBox("obs_option_types", comboVal, "select id, item, valid from obs_option_types where obs_option_set_id = " + obs_opt + " order by rank");
  comboVal->Visible = true;
 }
 else
  ; // not a clue. fucked? yup. fucked.

 if (editVal->Visible)
  editVal->BringToFront();
 if (comboVal->Visible)
  comboVal->BringToFront();

 panelVal->Visible = !(editVal->Visible || comboVal->Visible);

 string t = comboOp->Text.c_str();
 comboOp->Items->Clear();
 comboOp->Text = "";
 if (allow_equal)
 {
  comboOp->Items->Add("=");
  comboOp->Items->Add("<>");
  if (is_in(t, "=", "<>", NULL))
   comboOp->Text = t.c_str();
 }
 if (allow_lesser)
 {
  comboOp->Items->Add(">");
  comboOp->Items->Add(">=");
  comboOp->Items->Add("<");
  comboOp->Items->Add("<=");
  if (is_in(t, ">", ">=", "<", "<=", NULL))
   comboOp->Text = t.c_str();
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery__ObsResponseSetsByResponse::comboKeyKeyPress(
      TObject *Sender, char &Key)
{
 FindComboBoxItemAndSetItemIndex(Sender, Key);
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery__ObsResponseSetsByResponse::comboOpKeyPress(
      TObject *Sender, char &Key)
{
 FindComboBoxItem(Sender, Key);
}
//---------------------------------------------------------------------------
string TframeQuery__ObsResponseSetsByResponse::PrepareImpl ()
{
 string answer;

 string op, val;

 // input!
 op  = comboOp->Text.c_str();
 val = editVal->Text.c_str();

 // decide which field to grab!
 string obs_field;
 if (obs_type == "5") // date
  obs_field = "response_date";
 else if (obs_type == "4") // metric
  obs_field = "response_metric";
 else if (obs_type == "3") // ordinal
  obs_field = "rank";
 else if (obs_type == "2") // text
  obs_field = "upper(response_text)";
 else if (obs_type == "1") // choice
  obs_field = "obs_option_id";
 else
  ; // not a clue. fucked? yup. fucked.

 // special stuff
 if (obs_type == "3") // ordinals can be compared by rank
  val = GetOneField(dbDatabase, "select rank from obs_option_types where id = " + lookupTables->IdOf("obs_option_types", comboVal));
 if (obs_type == "1") // choices can be compared for equality only!
  val = lookupTables->IdOf("obs_option_types", comboVal);
 if (obs_type == "2" || obs_type == "5") // text can be compared, we suppose, though that's mostly stupid
  val = SafeSQLString(val);

 string sql = "select obs_responses.obs_response_set_id from "
              "obs_responses "
              "left join obs_response_sets on obs_response_sets.id = obs_responses.obs_response_set_id "
              "left join obs_option_types on obs_option_types.id = obs_responses.obs_option_id "
              "where obs_responses.obs_question_id = " + q_id +
              " and " + obs_field + " " + op + " '" + val + "'"
              " and (1 = 0 or obs_response_sets.id is not null)";
 answer = Context->CreateView(sql, set<string>());
 return answer;
}
//---------------------------------------------------------------------------
bool TframeQuery__ObsResponseSetsByResponse::Valid ()
{
 bool answer = true;

 comboKey->Color = clWindow;
 comboOp->Color  = clWindow;
 editVal->Color  = clWindow;
 comboVal->Color = clWindow;

 ResetItemIndex(comboOp); // just in case. seems to have issues with ... that. somehow. this fixes things. yup.
 if (comboOp->ItemIndex == -1)
 {
  comboOp->Color = clBad;
  answer = false;
 }

 if (comboKey->Text == "" || !lookupTables->IsInLookUpTable("obs_questions", comboKey->Text.c_str()))
 {
  comboKey->Color = clBad;
  answer = false;
 } else
 {
  if (obs_type == "5") // date
  {
   if (editVal->Text == "" || !Pdate(editVal->Text.c_str(), global_mode).IsValidDate())
   {
    editVal->Color = clBad;
    answer = false;
   }
  }
  else if (obs_type == "4") // metric
  {
   if (editVal->Text == "" || !IsFloat(editVal->Text.c_str()))
   {
    editVal->Color = clBad;
    answer = false;
   }
  }
  else if (obs_type == "3") // ordinal
  {
   if (comboVal->Text == "" || !lookupTables->IsInLookUpTable("obs_option_types", comboVal))
   {
    comboVal->Color = clBad;
    answer = false;
   }
  }
  else if (obs_type == "2") // text
  {
   // anything goes?
  }
  else if (obs_type == "1") // choice
  {
   if (comboVal->Text == "" || !lookupTables->IsInLookUpTable("obs_option_types", comboVal))
   {
    comboVal->Color = clBad;
    answer = false;
   }
  }
  else
   answer = false; // nope, not gonna fly. sorry!
 }

 return TframeQueryGeneric::Valid() && answer;
}
//---------------------------------------------------------------------------
xValue TframeQuery__ObsResponseSetsByResponse::Save (bool with_params)
{
 xValue answer = TframeQueryGeneric::Save(with_params);
 if (with_params && xTag(answer) == "map")
 {
  map<string, xValue> config_map = xToMap(answer);

  config_map["key"] = xFromInt(StringToInt(lookupTables->IdOf("obs_questions", comboKey)));
  config_map["op"]  = xFromString(comboOp->Text.c_str());

  if (obs_type == "5") // date
   config_map["val"] = xFromPdate(Pdate(editVal->Text.c_str(), global_mode));
  else if (obs_type == "4") // metric
   config_map["val"] = xFromFloat(StringToFloat(editVal->Text.c_str()));
  else if (obs_type == "3") // ordinal
   config_map["val"] = xFromString(lookupTables->IdOf("obs_option_types", comboVal));
  else if (obs_type == "2") // text
   config_map["val"] = xFromString(editVal->Text.c_str());
  else if (obs_type == "1") // choice
   config_map["val"] = xFromString(lookupTables->IdOf("obs_option_types", comboVal));
  else
   ;

  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery__ObsResponseSetsByResponse::Load (xValue config, bool with_params)
{
 config = ReplaceWithGlobals(config);

 TframeQueryGeneric::Load(config, with_params);
 if (with_params && xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);

  comboKey->Text = lookupTables->ValueOf("obs_questions", IntToString(xToInt(config_map["key"]))).c_str();
  comboKeyChange(comboKey);
  for (int i = 0; i < comboOp->Items->Count; i++)
   if (comboOp->Items->Strings[i] == xToString(config_map["op"]).c_str())
   {
    comboOp->ItemIndex = i;
    break;
   }

  if (obs_type == "5") // date
  {
   if (xTag(config_map["val"]) == "date")
    editVal->Text = xToPdate(config_map["val"]).OutDate(global_mode).c_str();
  }
  else if (obs_type == "4") // metric
  {
   if (xTag(config_map["val"]) == "float")
    editVal->Text = FloatToString(xToFloat(config_map["val"])).c_str();
  }
  else if (obs_type == "3") // ordinal
  {
   if (xTag(config_map["val"]) == "string")
    comboVal->Text = lookupTables->ValueOf("obs_option_types", xToString(config_map["val"])).c_str();
  }
  else if (obs_type == "2") // text
  {
   if (xTag(config_map["val"]) == "string")
    editVal->Text = xToString(config_map["val"]).c_str();
  }
  else if (obs_type == "1") // choice
  {
   if (xTag(config_map["val"]) == "string")
    comboVal->Text = lookupTables->ValueOf("obs_option_types", xToString(config_map["val"])).c_str();
  }
  else
   ;
 }
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery__ObsResponseSetsByResponse::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery__ObsResponseSetsByResponse(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeQuery__ObsResponseSetsByResponse::Appropriate (string source_table_name)
{
 return (source_table_name == "obs_response_sets") &&
        (optionsPermissions["table.obs_response_sets"]["view"] == "true"); // TODO: permissions!
}
//---------------------------------------------------------------------------
string TframeQuery__ObsResponseSetsByResponse::Describe (bool as_html)
{
 string desc_op;
 if (comboOp->Text == ">")
  desc_op = "greater than ";
 else
 if (comboOp->Text == ">=")
  desc_op = "greater than or equal to ";
 else
 if (comboOp->Text == "<")
  desc_op = "less than ";
 else
 if (comboOp->Text == "<=")
  desc_op = "less than or equal to ";
 else
 if (comboOp->Text == "=")
  desc_op = "equal to ";
 else
 if (comboOp->Text == "<>")
  desc_op = "not equal to ";
 else
  desc_op = "unknown";

 return "Observations (sets) where " + string(comboKey->Text.c_str()) + " was " + desc_op + string(editVal->Text.c_str()) + string(as_html ? ".<br>" : ".\r\n");
}
//---------------------------------------------------------------------------
void TframeQuery__ObsResponseSetsByResponse::RefreshObsQuestionType()
{
 q_id     = "0";
 obs_type = "0";
 obs_opt  = "0";

 if (lookupTables->IsInLookUpTable("obs_questions", comboKey))
 {
  q_id     = lookupTables->IdOf("obs_questions", comboKey);
  obs_type = GetOneField(dbDatabase, "select obs_questions.obs_question_id from obs_questions where obs_questions.id = " + q_id);
  obs_opt  = GetOneField(dbDatabase, "select obs_questions.obs_option_set_id from obs_questions where obs_questions.id = " + q_id);
  labelUnits->Caption = GetOneField(dbDatabase, "select units.item from units right join obs_questions on obs_questions.unit_id = units.id where obs_questions.id = " + q_id).c_str();
 }
}
//---------------------------------------------------------------------------
