//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery__PeopleAlive.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryGeneric"
#pragma resource "*.dfm"
TframeQuery__PeopleAlive *frameQuery__PeopleAlive;
//---------------------------------------------------------------------------
__fastcall TframeQuery__PeopleAlive::TframeQuery__PeopleAlive(TComponent* Owner)
        : TframeQueryGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
 Cache = true;
 dateComp->DateTime = Date();
}
//---------------------------------------------------------------------------
string TframeQuery__PeopleAlive::PrepareImpl ()
{
 string answer;
 Pdate as_of = Pdate(dateComp->DateTime);

 // we're going to require a birth_date, 'cause ... lots of non-people will have no birth_date, and ... argh.
 string sql = "select people.id from people where "
              "(people.birth_date is null or "
              "people.birth_date <= '" + as_of.OutDate(global_mode) + "') and "
              "(people.death_date is null or "
              "people.death_date > '" + as_of.OutDate(global_mode) + "')";
 answer = Context->CreateView(sql, set<string>());
 return answer;
}
//---------------------------------------------------------------------------
bool TframeQuery__PeopleAlive::Valid ()
{
 return TframeQueryGeneric::Valid();
}
//---------------------------------------------------------------------------
xValue TframeQuery__PeopleAlive::Save (bool with_params)
{
 xValue answer = TframeQueryGeneric::Save(with_params);
 if (with_params && xTag(answer) == "map")
 {
  map<string, xValue> config_map = xToMap(answer);
  quSaveRequiredDate(config_map, "as_of", dateComp);
  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery__PeopleAlive::Load (xValue config, bool with_params)
{
 config = ReplaceWithGlobals(config);

 TframeQueryGeneric::Load(config, with_params);
 if (with_params && xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);
  quLoadRequiredDate(config_map, "as_of", dateComp);
 }
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery__PeopleAlive::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery__PeopleAlive(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeQuery__PeopleAlive::Appropriate (string source_table_name)
{
 return (source_table_name == "people") && (optionsPermissions["table.people"]["view"] == "true");
}
//---------------------------------------------------------------------------
string TframeQuery__PeopleAlive::Describe (bool as_html)
{
 return "People alive on " + Pdate(dateComp->DateTime).OutDate(global_mode) + string(as_html ? ".<br>" : ".\r\n");
}
//---------------------------------------------------------------------------
