//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "codeQuery__PeopleByAffiliation.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"

#include "lookuptablewrapper.h"
#include "derivedheaders.h"
TframeQuery__PeopleByAffiliation *frameQuery__PeopleByAffiliation;
//---------------------------------------------------------------------------
__fastcall TframeQuery__PeopleByAffiliation::TframeQuery__PeopleByAffiliation(TComponent* Owner)
        : TframeQueryGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
 Cache = true;
 // lookupTables->RegisterComboBox("tribe_types", cboTribe);

 // 'today' is just nicer, you know?
 dateEnrolledOn->DateTime = Date();

 // w00t!
 tribe_filter.SetListViewHandle(listTribes);
 tribe_filter.SetSecurity("affiliations");
 tribe_filter.AddColumnSpec("Tribe", "affiliations", as_text, true, 260, prettyString);
 tribe_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 tribe_filter.FetchPreferences("query__peoplebyaffiliation.tribe_filter");
 tribe_filter.SetIconStatus(false);
 tribe_filter.SetCheck(true);
 tribe_filter.SetHeader(false);
 tribe_filter.RefreshDataSet();
 tribe_filter.SetSQLStatement("select item, id from tribe_types");
 tribe_filter.ForceRefreshDataSet();
}
//---------------------------------------------------------------------------
__fastcall TframeQuery__PeopleByAffiliation::~TframeQuery__PeopleByAffiliation()
{
 // lookupTables->UnregisterComboBox("tribe_types", cboTribe);
}
//---------------------------------------------------------------------------
string TframeQuery__PeopleByAffiliation::PrepareImpl ()
{
 string answer;
/*
 Pdate enrolled_on = dateEnrolledOn->Date; // Pdate(editEnrolledOn->Text.c_str(), global_mode);
 string sql = "select distinct people.id from people inner join affiliations on affiliations.person_id = people.id "
              "where affiliations.tribe_id = '" + lookupTables->IdOf("tribe_types", cboTribe) + "' "
                    "and (select result from is_enrolled(affiliations.id, '" + enrolled_on.OutDate(global_mode) + "')) = 1 "
                    "and affiliations.current_id >= 3";
*/

/*
if (:cdib is not null and
        (:birth_date is null or :birth_date <= :p_current_date) and
        (:death_date is null or :death_date >= :p_current_date) and
        (:join_date is not null and :join_date <= :p_current_date) and
        (:relinquish_date is null or :relinquish_date >= :p_current_date)
       ) then result = 1;
*/

 vector<string> pos_values = tribe_filter.GetMultiID();
 vector<string> all_values = tribe_filter.GetAllID();
 set<string> s_pos_values;
 set<string> s_all_values;
 set<string> s_neg_values;
 VecToSet(pos_values, s_pos_values);
 VecToSet(all_values, s_all_values);
 set_difference(s_all_values.begin(), s_all_values.end(),
                s_pos_values.begin(), s_pos_values.end(),
                insert_iterator<set<string> >(s_neg_values, s_neg_values.begin()));

 Pdate as_of(dateEnrolledOn->Date);

 string sql = "select distinct person_id from affiliations "
              "inner join people on people.id = affiliations.person_id "
              "where "
              "affiliations.current_id > 2 and " +
              (checkRequireCDIB->Checked 
               ? string("affiliations.cdib is not null and affiliations.cdib != '' and ")
               : string("")) +
              (s_neg_values.size() < s_pos_values.size() /* use the smaller set, as a favor */
               ? string("affiliations.tribe_id not in (" + SetToCommaString(s_neg_values) + ") and ")
               : string("affiliations.tribe_id in (" + SetToCommaString(s_pos_values) + ") and ")) +
             // "(people.birth_date is null or people.birth_date <= '" + as_of.OutDate(global_mode) + "') and "
             // "(people.death_date is null or people.death_date >= '" + as_of.OutDate(global_mode) + "') and "
              "(affiliations.join_date is null or affiliations.join_date <= '" + as_of.OutDate(global_mode) + "') and "
              "(affiliations.relinquish_date is null or affiliations.relinquish_date >= '" + as_of.OutDate(global_mode) + "')";
 DebugSql(NULL, &sql, other_forms, 9);
 answer = Context->CreateView(sql, set<string>());
 return answer;
}
//---------------------------------------------------------------------------
bool TframeQuery__PeopleByAffiliation::Valid ()
{
 dateEnrolledOn->Color = clWindow;
 // cboTribe->Color = clWindow;

 bool result = true;
 // date-time pickers can't be bad, Paul =)~
/*
 Pdate enrolled_on    = Pdate(dateEnrolledOn->Date);
 bool  enrolled_valid = (enrolled_on.IsValidDate());
 if (!enrolled_valid)
 {
  dateEnrolledOn->Color = clBad;
  //editEnrolledOn->SetFocus();
  result = false;
 }
*/

 listTribes->Color = clWindow;
 vector<string> temp_tribes = tribe_filter.GetMultiID();
 vector<string> all_tribes = tribe_filter.GetAllID();
 // can't have 'none' and can't have 'all'
 if (temp_tribes.empty() || temp_tribes.size() == all_tribes.size())
 {
   listTribes->Color = clBad;
   result = false;
 }

/*
 if (cboTribe->Text == "" || !lookupTables->IsInLookUpTable("tribe_types", cboTribe->Text.c_str()))
 {
  cboTribe->Color = clBad;
  //cboTribe->SetFocus();
  result = false;
 }
*/
 return TframeQueryGeneric::Valid() && result;
}
//---------------------------------------------------------------------------
xValue TframeQuery__PeopleByAffiliation::Save (bool with_params)
{
 xValue answer = TframeQueryGeneric::Save(with_params);
 if (with_params && xTag(answer) == "map")
 {
  map<string, xValue> config_map = xToMap(answer);

  if (Pdate(dateEnrolledOn->Date).IsValidDate())
   config_map["enrolled_on"] = xFromPdate(Pdate(dateEnrolledOn->Date));

  config_map["require_cdib"] = xFromBool(checkRequireCDIB->Checked);

  // why set? because order shouldn't matter when comparing two similar queries.
  set<string> tribes;
  vector<string> temp_tribes = tribe_filter.GetMultiID();
  VecToSet(temp_tribes, tribes);
  config_map["tribe_ids"] = xFromStringSet(tribes);
  // config_map["tribe_id"] = xFromInt(StringToInt(lookupTables->IdOf("tribe_types", cboTribe)));

  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery__PeopleByAffiliation::Load (xValue config, bool with_params)
{
 config = ReplaceWithGlobals(config);

 TframeQueryGeneric::Load(config, with_params);
 if (with_params && xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);

  // cboTribe->Text = lookupTables->ValueOf("tribe_types", IntToString(xToInt(config_map["tribe_id"]))).c_str();
  if (xTag(config_map["enrolled_on"]) == "date")
   dateEnrolledOn->Date = xToPdate(config_map["enrolled_on"]).OutDate();

  if (xTag(config_map["require_cdib"]) == "bool")
   checkRequireCDIB->Checked = xToBool(config_map["require_cdib"]);

  if (xTag(config_map["tribe_ids"]) == "set")
  {
   set<string> tribes_to_check = xToStringSet(config_map["tribe_ids"]);
   tribe_filter.UncheckAll();
   tribe_filter.SetCheckedWhereID(tribes_to_check, true);
  }
 }
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery__PeopleByAffiliation::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery__PeopleByAffiliation(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeQuery__PeopleByAffiliation::Appropriate (string source_table_name)
{
 return (source_table_name == "people") && (optionsPermissions["table.people"]["view"] == "true" &&
                                            optionsPermissions["table.affiliations"]["view"] == "true");
}
//---------------------------------------------------------------------------
string TframeQuery__PeopleByAffiliation::Describe (bool as_html)
{
 vector<string> checked_tribes_v = tribe_filter.GetMultiID();
 vector<string>     all_tribes_v = tribe_filter.GetAllID();

 set<string> checked_tribes;
 set<string>     all_tribes;
 VecToSet(checked_tribes_v, checked_tribes);
 VecToSet(all_tribes_v, all_tribes);

 string bad_tribe_list = "0,33,34,53,54,64,90,98"; // TODO -c MAGIC: tribe_types id's
 set<string> bad_tribes;
 SplitStringToSet(bad_tribe_list, ",", bad_tribes);

 set<string> good_tribes;
 set_difference (all_tribes.begin(), all_tribes.end(),
                 bad_tribes.begin(), bad_tribes.end(),
                 insert_iterator<set<string> >(good_tribes, good_tribes.begin()));

 string header;
 if (checkRequireCDIB->Checked)
  header = "People enrolled (with known CDIB) in ";
 else
  header = "People enrolled in ";

 if (checked_tribes == good_tribes)
  return header + "a verifiable tribe as of " + Pdate(dateEnrolledOn->DateTime).OutDate(global_mode) + string(as_html ? ".<br>" : ".\r\n");
 else
 if (checked_tribes.size() == 1)
  return header + lookupTables->ValueOf("tribe_types", *(checked_tribes.begin())) + " as of " + Pdate(dateEnrolledOn->DateTime).OutDate(global_mode) + string(as_html ? ".<br>" : ".\r\n");
 else
 {
  for (set<string>::iterator i = checked_tribes.begin(); i != checked_tribes.end(); i++)
   *i = lookupTables->ValueOf("tribe_types", *i);
  return header + "one of the following tribes as of " + Pdate(dateEnrolledOn->DateTime).OutDate(global_mode) + ": " + SetToCommaString(checked_tribes) + string(as_html ? ".<br>" : ".\r\n");
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery__PeopleByAffiliation::buttonCheckVerifiableTribesClick(TObject *Sender)
{
 string bad_tribe_list = "0,33,34,53,54,64,90,98"; // TODO -c MAGIC: tribe_types id's
 set<string> bad_tribes;
 SplitStringToSet(bad_tribe_list, ",", bad_tribes);
 // check, then uncheck
 // could change this to "uncheck only the bad ones" (but leave other checkboxes alone)
 // or to "check only the good ones" (leave others alone)
 // or ... yeah. whole range of possible ways of doing it. we don't care.
 tribe_filter.CheckAll();
 tribe_filter.SetCheckedWhereID(bad_tribes, false);

 // ugly button!
 listTribes->SetFocus();
}
//---------------------------------------------------------------------------

