//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery__PeopleByAngelaAudit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryGeneric"
#pragma link "codeHalfButton"
#pragma link "codeSectionsGeneric"
#pragma resource "*.dfm"
TframeQuery__PeopleByAngelaAudit *frameQuery__PeopleByAngelaAudit;
//---------------------------------------------------------------------------
__fastcall TframeQuery__PeopleByAngelaAudit::TframeQuery__PeopleByAngelaAudit(TComponent* Owner)
        : TframeQueryGeneric(Owner)
{
 FHowCreate = Create;
 FHowAppropriate = Appropriate;

 Pdate today = Now();
 Pdate year_ago = today;
 year_ago.mod(-1, in_years);
 datePropagateStart->DateTime = year_ago.OutDate();
 datePropagateStop->DateTime = today.OutDate();

 // just 'cause ...
 dateDiagMax->DateTime = today.OutDate();
 dateAliveMax->DateTime = today.OutDate();

 radioAutomaticClick(radioAutomatic);
}
//---------------------------------------------------------------------------
string TframeQuery__PeopleByAngelaAudit::PrepareImpl ()
{
 q_clinic   = GetNextId(Context->Transaction, "temp_id");
 q_anderson = GetNextId(Context->Transaction, "temp_id");
 q_diab     = GetNextId(Context->Transaction, "temp_id");
 q_any      = GetNextId(Context->Transaction, "temp_id");
 q_diag     = GetNextId(Context->Transaction, "temp_id");
 q_tribal   = GetNextId(Context->Transaction, "temp_id");
 q_alive    = GetNextId(Context->Transaction, "temp_id");
 q_nearby   = GetNextId(Context->Transaction, "temp_id");
 q_final    = GetNextId(Context->Transaction, "temp_id");

 string sql;

 // count at medical clinic
 sql = "insert into temp_id (q, id, c, d) "
       " select " + q_clinic + ", person_id, count(*), max(date_of_task) "
       " from tasks "
       " where group_id = 17 "
         " and tax_entity_id != 2662 " /* exclude burk */
         " and current_id > 2 "
         " and " + SqlOptionalBetween("date_of_task", editClinicMin->Text.c_str(), editClinicMax->Text.c_str()) +
       " group by person_id";
 if (!ExecuteStatement(Context->Transaction, sql))
  PSay("Audit query failed, q_clinic.", m_database_error, MB_OK, "TframeQuery__PeopleByAngelaAudit"), throw(99);

 // count at anderson
 sql = "insert into temp_id (q, id, c, d) "
       " select " + q_anderson + ", person_id, count(*), max(date_of_task) "
       " from tasks "
       " where tax_entity_id = 1683 "
         " and current_id > 2 "
         " and " + SqlOptionalBetween("date_of_task", editAndersonMin->Text.c_str(), editAndersonMax->Text.c_str()) +
       " group by person_id";
 if (!ExecuteStatement(Context->Transaction, sql))
  PSay("Audit query failed, q_anderson.", m_database_error, MB_OK, "TframeQuery__PeopleByAngelaAudit"), throw(98);

 // count at diab
 sql = "insert into temp_id (q, id, c) "
       " select " + q_diab + ", person_id, count(*) "
       " from tasks "
       " where group_id = 6 "
         " and current_id > 2 "
         " and (method_id = 3 or method_id is null) "
       " group by person_id";
 if (!ExecuteStatement(Context->Transaction, sql))
  PSay("Audit query failed, q_diab (a).", m_database_error, MB_OK, "TframeQuery__PeopleByAngelaAudit"), throw(97);

 sql = "delete from temp_id where q = " + q_diab + " and c < " + string(editDiabCount->Text.c_str());
 if (!ExecuteStatement(Context->Transaction, sql))
  PSay("Audit query failed, q_diab (b).", m_database_error, MB_OK, "TframeQuery__PeopleByAngelaAudit"), throw(96);

 // count at any
 sql = "insert into temp_id (q, id, c) "
       " select " +  q_any + ", person_id, count(*) "
       " from tasks "
       " where (method_id = 3 or method_id is null) "
         " and current_id > 2 "
         " and " + SqlOptionalBetween("date_of_task", editAnyMin->Text.c_str(), editAnyMax->Text.c_str()) +
       " group by person_id";
 // if (!ExecuteStatement(Context->Transaction, sql))
 //  PSay("Audit query failed, q_any (a).", m_database_error, MB_OK, "TframeQuery__PeopleByAngelaAudit"), throw(95);

 sql = "delete from temp_id where q = " + q_any + " and c < " + string(editAnyCount->Text.c_str());
 // if (!ExecuteStatement(Context->Transaction, sql))
 //  PSay("Audit query failed, q_any (b).", m_database_error, MB_OK, "TframeQuery__PeopleByAngelaAudit"), throw(94);

 // diagnosed
 sql = "insert into temp_id (q, id) "
       " select distinct " + q_diag + ", person_id "
       " from conditions "
       " where (code = '250' or code like '250.%') "
         " and condition_id = 5 "
         " and current_id > 2 "
         " and (start_date < '" + Pdate(dateDiagMax->Date).OutDate(global_mode) + "' "
              " or last_update_stamp < '" + Pdate(dateDiagMax->Date).OutDate(global_mode) + "')";
 if (!ExecuteStatement(Context->Transaction, sql))
  PSay("Audit query failed, q_diag.", m_database_error, MB_OK, "TframeQuery__PeopleByAngelaAudit"), throw(93);

 // tribal
 Pdate tmin (editTribeMin->Text.c_str(), global_mode);
 Pdate tmax (editTribeMax->Text.c_str(), global_mode);
 sql = "insert into temp_id (q, id) "
       " select distinct " + q_tribal + ", person_id "
       " from affiliations "
       " where current_id > 2 "
         " and (cdib is not null and cdib != '') "
         " and tribe_id not in (0, 33, 34, 53, 54, 64, 90, 98) "; // TODO -c MAGIC: tribe_types id's
 if (tmin.IsValidDate())
  sql += " and (join_date is null or join_date < '" + tmin.OutDate(global_mode) + "')";
 if (tmax.IsValidDate())
  sql += " and (relinquish_date is null or relinquish_date > '" + tmax.OutDate(global_mode) + "')";
 if (!ExecuteStatement(Context->Transaction, sql))
  PSay("Audit query failed, q_tribal.", m_database_error, MB_OK, "TframeQuery__PeopleByAngelaAudit"), throw(92);

 // catchment area
 sql = "insert into temp_id (q, id) "
       " select distinct " + q_nearby + ", person_id "
       " from person_contact_info "
       " where current_id > 2 "
         " and county_id in (592, 1725, 1756, 2185, 2383)";
 // if (!ExecuteStatement(Context->Transaction, sql))
 //  PSay("Audit query failed, q_nearby.", m_database_error, MB_OK, "TframeQuery__PeopleByAngelaAudit"), throw(91);

 // alive
 sql = "insert into temp_id (q, id) "
       " select " + q_alive + ", id "
       " from people "
       " where death_date is null or death_date > '" + Pdate(dateAliveMax->Date).OutDate(global_mode) + "'";
 if (!ExecuteStatement(Context->Transaction, sql))
  PSay("Audit query failed, q_alive.", m_database_error, MB_OK, "TframeQuery__PeopleByAngelaAudit"), throw(90);

 /* skip parts about "latest at anderson / latest at */
 sql = "insert into temp_id (q, id, c) "
 "select " + q_final + ", people.id, "
/*
 "       case when coalesce(sum(cvis.c), 0) + coalesce(sum(avis.c), 0) >= " + string(editClinicAndersonCount->Text.c_str()) +
 "        then "
 "         case when coalesce(sum(cvis.c), 0) > coalesce(sum(avis.c), 0) "
 "          then 1 "
 "          else "
 "           case when max(cvis.d) >= max(avis.d) "
 "            then 1 "
 "            else 0 "
 "           end "
 "          end "
 "        else 0 "
 "       end "
*/
 " coalesce(sum(cvis.c), 0) + coalesce(sum(avis.c), 0) " // total visits, rather than anderson vs. clinic patient bool.
 " from people "
 /* "inner join temp_id inear on inear.q = " + q_nearby + " and inear.id = people.id "*/
 /* inner join temp_id ivis on ivis.q = " + q_any + " and ivis.id = people.id " */
 "inner join temp_id ialiv on ialiv.q = " + q_alive + " and ialiv.id = people.id "
 "inner join temp_id itrib on itrib.q = " + q_tribal + " and itrib.id = people.id "
 "inner join temp_id idiag on idiag.q = " + q_diag + " and idiag.id = people.id "
 "inner join temp_id idiab on idiab.q = " + q_diab + " and idiab.id = people.id "
 "left join temp_id cvis on cvis.q = " + q_clinic + " and cvis.id = people.id "
 "left join temp_id avis on avis.q = " + q_anderson + " and avis.id = people.id "
 "group by people.id";
 if (!ExecuteStatement(Context->Transaction, sql))
  PSay("Audit query failed, q_final (a).", m_database_error, MB_OK, "TframeQuery__PeopleByAngelaAudit"), throw(89);

 sql = "delete from temp_id where q = " + q_final + " and c < " + string(editClinicAndersonCount->Text.c_str());
 if (!ExecuteStatement(Context->Transaction, sql))
  PSay("Audit query failed, q_final (b).", m_database_error, MB_OK, "TframeQuery__PeopleByAngelaAudit"), throw(88);

 sql = "select id from temp_id where q = " + q_final;
 string answer = Context->CreateView(sql, set<string>());
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery__PeopleByAngelaAudit::CleanUpImpl ()
{
 ExecuteStatement(Context->Transaction, "delete from temp_id where q = " + q_clinic);
 ExecuteStatement(Context->Transaction, "delete from temp_id where q = " + q_anderson);
 ExecuteStatement(Context->Transaction, "delete from temp_id where q = " + q_diab);
 // ExecuteStatement(Context->Transaction, "delete from temp_id where q = " + q_any);
 ExecuteStatement(Context->Transaction, "delete from temp_id where q = " + q_diag);
 ExecuteStatement(Context->Transaction, "delete from temp_id where q = " + q_tribal);
 ExecuteStatement(Context->Transaction, "delete from temp_id where q = " + q_alive);
 // ExecuteStatement(Context->Transaction, "delete from temp_id where q = " + q_nearby);
 ExecuteStatement(Context->Transaction, "delete from temp_id where q = " + q_final);
}
//---------------------------------------------------------------------------
bool TframeQuery__PeopleByAngelaAudit::Valid ()
{
 bool answer;

 // & doesn't do short-circuit evaluation, && does, and we want not to
 answer = quValidSortedSomeOptionalDate(editClinicMin, editClinicMax) &
          quValidSortedSomeOptionalDate(editAndersonMin, editAndersonMax) &
          quValidRequiredInt(editClinicAndersonCount) &
          quValidRequiredInt(editDiabCount) &
          // quValidRequiredInt(editAnyCount) &
          // quValidSortedSomeOptionalDate(editAnyMin, editAnyMax) &
          quValidSortedSomeOptionalDate(editTribeMin, editTribeMax);

 return TframeQueryGeneric::Valid() & answer;
}
//---------------------------------------------------------------------------
xValue TframeQuery__PeopleByAngelaAudit::Save  (bool with_params)
{
 xValue answer = TframeQueryGeneric::Save(with_params);
 if (with_params && xTag(answer) == "map")
 {
  map<string, xValue> config_map = xToMap(answer);

  config_map["is_automatic"] = xFromBool(radioAutomatic->Checked);

  quSaveRequiredDate(config_map, "report_start", datePropagateStart);
  quSaveRequiredDate(config_map, "report_stop", datePropagateStop);

  quSaveOptionalDate(config_map, "clinic_start", editClinicMin);
  quSaveOptionalDate(config_map, "clinic_stop", editClinicMax);
  quSaveOptionalDate(config_map, "anderson_start", editAndersonMin);
  quSaveOptionalDate(config_map, "anderson_stop", editAndersonMax);
  quSaveOptionalDate(config_map, "any_start", editAnyMin);
  quSaveOptionalDate(config_map, "any_stop", editAnyMax);
  quSaveOptionalDate(config_map, "tribe_start", editTribeMin);
  quSaveOptionalDate(config_map, "tribe_stop", editTribeMax);

  // actually required, code is the same
  quSaveOptionalInt(config_map, "clinic_count", editClinicAndersonCount);
  quSaveOptionalInt(config_map, "diab_count", editDiabCount);
  quSaveOptionalInt(config_map, "any_count", editAnyCount);

  quSaveRequiredDate(config_map, "diag_max", dateDiagMax);
  quSaveRequiredDate(config_map, "alive_max", dateAliveMax);

  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery__PeopleByAngelaAudit::Load  (xValue config, bool with_params)
{
 config = ReplaceWithGlobals(config);

 TframeQueryGeneric::Load(config, with_params);
 if (with_params && xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);

  if (xTag(config_map["is_automatic"]) == "bool")
  {
   radioAutomatic->Checked = xToBool(config_map["is_automatic"]);
   radioManual->Checked = !xToBool(config_map["is_automatic"]);
  }

  quLoadRequiredDate(config_map, "report_start", datePropagateStart);
  quLoadRequiredDate(config_map, "report_stop", datePropagateStop);

  quLoadOptionalDate(config_map, "clinic_start", editClinicMin);
  quLoadOptionalDate(config_map, "clinic_stop", editClinicMax);
  quLoadOptionalDate(config_map, "anderson_start", editAndersonMin);
  quLoadOptionalDate(config_map, "anderson_stop", editAndersonMax);
  quLoadOptionalDate(config_map, "any_start", editAnyMin);
  quLoadOptionalDate(config_map, "any_stop", editAnyMax);
  quLoadOptionalDate(config_map, "tribe_start", editTribeMin);
  quLoadOptionalDate(config_map, "tribe_stop", editTribeMax);

  quLoadRequiredInt(config_map, "clinic_count", editClinicAndersonCount, 2);
  quLoadRequiredInt(config_map, "diab_count", editDiabCount, 2);
  quLoadRequiredInt(config_map, "any_count", editAnyCount, 2);

  quLoadRequiredDate(config_map, "diag_max", dateDiagMax);
  quLoadRequiredDate(config_map, "alive_max", dateAliveMax);

  if (radioAutomatic->Checked)
   buttonPropagate->Click();
 }
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery__PeopleByAngelaAudit::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery__PeopleByAngelaAudit(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeQuery__PeopleByAngelaAudit::Appropriate (string source_table_name)
{
 return (source_table_name == "people"); // && (optionsPermissions["special.query_angela_audit"]["enabled"] == "true");
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery__PeopleByAngelaAudit::buttonPropagateClick(TObject *Sender)
{
 // auto-calc values
 if (quSortedRequiredDate(datePropagateStart, datePropagateStop))
 {
  Pdate report_min = Pdate(datePropagateStart->DateTime);
  Pdate report_max = Pdate(datePropagateStop->DateTime);

  editClinicAndersonCount->Text = "2";

  editClinicMin->Text = report_min.OutDate(global_mode).c_str();
  editClinicMax->Text = report_max.OutDate(global_mode).c_str();

  editAndersonMin->Text = report_min.OutDate(global_mode).c_str();
  editAndersonMax->Text = report_max.OutDate(global_mode).c_str();

  editDiabCount->Text = "2";
  editAnyCount->Text = "2";

  editAnyMin->Text = report_min.OutDate(global_mode).c_str();
  editAnyMax->Text = report_max.OutDate(global_mode).c_str();

  editTribeMin->Text = report_min.OutDate(global_mode).c_str();
  editTribeMax->Text = report_max.OutDate(global_mode).c_str();

  Pdate year_prior_to_min = report_min;
  year_prior_to_min.mod(-1, in_years);
  dateDiagMax->DateTime = year_prior_to_min.OutDate();

  dateAliveMax->DateTime = report_max.OutDate();
 }
 // err ... in case they change their mind ... this isn't required for running the query itself ...
 // we -could- move these controls elsewhere, but i'm not sure where. or ... whether or not that'd be a good idea.
 datePropagateStart->Color = clWindow;
 datePropagateStop->Color = clWindow;
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery__PeopleByAngelaAudit::radioAutomaticClick(TObject *Sender)
{
 if (radioManual->Checked)
 {
  sectionOptions->Enabled = true;
  sectionOptions->Open = true;
 } else
 {
  sectionOptions->Enabled = false;
  buttonPropagate->Click();
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery__PeopleByAngelaAudit::sectionOptionsOpenShut(TObject *Sender)
{
 Height = sectionOptions->Top + sectionOptions->Height;
 if (radioManual->Checked && sectionOptions->Open)
  Width = sectionOptions->Left + sectionOptions->Width;
 else
  Width = buttonPropagate->Left + buttonPropagate->Width + 8;
}
//---------------------------------------------------------------------------

