//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery__PeopleByFirstProcedured.h"
#include "codeSearchCode.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryGeneric"
#pragma link "codeFrameCodeTaxonomy"
#pragma resource "*.dfm"
TframeQuery__PeopleByFirstProcedured *frameQuery__PeopleByFirstProcedured;
//---------------------------------------------------------------------------
__fastcall TframeQuery__PeopleByFirstProcedured::TframeQuery__PeopleByFirstProcedured(TComponent* Owner)
        : TframeQueryGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
 Cache = true;
 codeCodes->Type = txn_procedure;
}
//---------------------------------------------------------------------------
string TframeQuery__PeopleByFirstProcedured::PrepareImpl ()
{
 string answer;

 Pdate start_date = Pdate(editStartDate->Text.c_str(), global_mode);
 Pdate stop_date  = Pdate(editStopDate->Text.c_str(), global_mode);
 bool start_given = (editStartDate->Text != "");
 bool stop_given  = (editStopDate->Text != "");
 bool start_valid = (!start_given || start_date.IsValidDate());
 bool stop_valid  = (!stop_given || stop_date.IsValidDate());

 // TODO: see if we can use 'whole' ... inner joins inside the exists() clauses, to avoid issues with permissions, etc.
 string sql = "select people.id from people where ";
 if (start_given && !stop_given)
  sql += "people.id in (select tasks.person_id from procedures left join tasks on tasks.id = procedures.task_id where " + codeCodes->SQL + " and start_date >= '" + start_date.OutDate(global_mode) + "' and procedures.current_id + 1 > 3) "
         "and (0=1 or not exists (select procedures.id from tasks inner join procedures on tasks.id = procedures.task_id where tasks.person_id = people.id and " + codeCodes->SQL + " and start_date < '" + start_date.OutDate(global_mode) + "' and procedures.current_id + 1 > 3)) ";
 else
 if (start_given && stop_given)
  sql += "people.id in (select tasks.person_id from procedures left join tasks on tasks.id = procedures.task_id where " + codeCodes->SQL + " and start_date >= '" + start_date.OutDate(global_mode) + "' and start_date <= '" + stop_date.OutDate(global_mode) + "'and current_id + 1 > 3) "
         "and (0=1 or not exists (select procedures.id from procedures inner join tasks on tasks.id = procedures.task_id where tasks.person_id = people.id and " + codeCodes->SQL + " and start_date < '" + start_date.OutDate(global_mode) + "' and procedures.current_id + 1 > 3)) ";
 else
 if (!start_given && stop_given)
  sql += "people.id in (select tasks.person_id from procedures left join tasks on tasks.id = procedures.task_id where " + codeCodes->SQL + " and start_date <= '" + stop_date.OutDate(global_mode) + "' and procedures.current_id + 1 > 3)";
 else
  sql += "people.id in (select tasks.person_id from procedures left join tasks on tasks.id = procedures.task_id where " + codeCodes->SQL + " and procedures.current_id + 1 > 3)";

 answer = Context->CreateView(sql, set<string>());
 return answer;
}
//---------------------------------------------------------------------------
bool TframeQuery__PeopleByFirstProcedured::Valid ()
{
 bool answer = true;

 editStartDate->Color = clWindow;
 editStopDate->Color = clWindow;

 Pdate start_date = Pdate(editStartDate->Text.c_str(), global_mode);
 Pdate stop_date  = Pdate(editStopDate->Text.c_str(), global_mode);
 bool start_given = (editStartDate->Text != "");
 bool stop_given  = (editStopDate->Text != "");
 bool start_valid = (!start_given || start_date.IsValidDate());
 bool stop_valid  = (!stop_given || stop_date.IsValidDate());

 if (!start_valid)
 {
  editStartDate->Color = clBad;
  answer = false;
 }

 if (!stop_valid)
 {
  editStopDate->Color = clBad;
  answer = false;
 }

 if (start_given && stop_given && start_valid && stop_valid && start_date > stop_date)
 {
  PSay("The start date should be earlier than the stop date, if both are provided.", m_invalid_data, MB_OK, "TframeQuery__PeopleByFirstProcedured");
  answer = false;
 }

 codeCodes->BoxColor = clWindow;
 if (!codeCodes->Valid)
 {
  codeCodes->BoxColor = clBad;
  answer = false;
 }

 return TframeQueryGeneric::Valid() && answer;
}
//---------------------------------------------------------------------------
xValue TframeQuery__PeopleByFirstProcedured::Save (bool with_params)
{
 xValue answer = TframeQueryGeneric::Save(with_params);
 if (with_params && xTag(answer) == "map")
 {
  map<string, xValue> config_map = xToMap(answer);
  if (Pdate(editStartDate->Text.c_str(), global_mode).IsValidDate())
   config_map["start"] = xFromPdate(Pdate(editStartDate->Text.c_str(), global_mode));
  if (Pdate(editStopDate->Text.c_str(), global_mode).IsValidDate())
   config_map["stop"] = xFromPdate(Pdate(editStopDate->Text.c_str(), global_mode));
  config_map["matches"] = codeCodes->xCodeDescription;
  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery__PeopleByFirstProcedured::Load (xValue config, bool with_params)
{
 config = ReplaceWithGlobals(config);

 TframeQueryGeneric::Load(config, with_params);
 if (with_params && xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);
  if (xTag(config_map["start"]) == "date")
   editStartDate->Text = xToPdate(config_map["start"]).OutDate(global_mode).c_str();
  if (xTag(config_map["stop"]) == "date")
   editStopDate->Text = xToPdate(config_map["stop"]).OutDate(global_mode).c_str();
  codeCodes->xCodeDescription = config_map["matches"];
 }
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery__PeopleByFirstProcedured::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery__PeopleByFirstProcedured(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeQuery__PeopleByFirstProcedured::Appropriate (string source_table_name)
{
 return (source_table_name == "people") && (optionsPermissions["table.people"]["view"] == "true") && (optionsPermissions["table.procedures"]["view"] == "true");
}
//---------------------------------------------------------------------------
string TframeQuery__PeopleByFirstProcedured::Describe (bool as_html)
{
 Pdate start_date = Pdate(editStartDate->Text.c_str(), global_mode);
 Pdate stop_date  = Pdate(editStopDate->Text.c_str(), global_mode);
 bool start_given = (editStartDate->Text != "");
 bool stop_given  = (editStopDate->Text != "");
 bool start_valid = (!start_given || start_date.IsValidDate());
 bool stop_valid  = (!stop_given || stop_date.IsValidDate());
 string d_desc;
 if (start_valid && start_given && stop_valid && stop_given)
  d_desc = "between " + start_date.OutDate(global_mode) + " and " + stop_date.OutDate(global_mode);
 else
 if (start_valid && start_given)
  d_desc = "on or after " + start_date.OutDate(global_mode);
 else
 if (stop_valid && stop_given)
  d_desc = "on or before " + stop_date.OutDate(global_mode);
 else
  d_desc = "unknown";

 string c_desc = codeCodes->Text;
 return "People first treated with one of the following procedures (by CPT-4 code) " + d_desc + ": " + c_desc + string(as_html ? ".<br>" : ".\r\n");
}
//---------------------------------------------------------------------------

