//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery__PeopleByGender.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeHalfButton"
#pragma link "codeQueryGeneric"
#pragma resource "*.dfm"
TframeQuery__PeopleByGender *frameQuery__PeopleByGender;
//---------------------------------------------------------------------------
__fastcall TframeQuery__PeopleByGender::TframeQuery__PeopleByGender(TComponent* Owner)
        : TframeQueryGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
 Cache = true;
 // ListExpanded = false;

 gender_filter.SetListViewHandle(listGenders);
 gender_filter.SetSecurity("");
 gender_filter.AddColumnSpec("Gender", "", as_text, true, 100, prettyString);
 gender_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 gender_filter.FetchPreferences("query__peoplebygender.gender_filter");
 gender_filter.SetIconStatus(false);
 gender_filter.SetAutosizeColumns(false);
 gender_filter.SetCheck(true);
 gender_filter.SetHeader(false);
 gender_filter.SetSQLStatement("select item, id from gender_types");
 gender_filter.ForceRefreshDataSet();
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery__PeopleByGender::SetListExpanded(bool Value)
{
 // this is now disabled, but i'm leaving the code here because it's rather fun ... might be useful elsewhere?
 FListExpanded = Value;
 if (FListExpanded)
 {
  Height = 72;
  listGenders->Height = 69;
  buttonListExpand->Height = 69;
  buttonListExpand->Glyph->LoadFromResourceName(FindClassHInstance(__classid(TframeQueryGeneric)), "BCONTRACT");
 } else
 {
  Height = 24;
  listGenders->Height = 21;
  buttonListExpand->Height = 21;
  buttonListExpand->Glyph->LoadFromResourceName(FindClassHInstance(__classid(TframeQueryGeneric)), "BEXPAND");
 }
 Application->ProcessMessages();
 Resized();
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery__PeopleByGender::buttonListExpandClick(TObject *Sender)
{
 ListExpanded = !ListExpanded;
}
//---------------------------------------------------------------------------
string TframeQuery__PeopleByGender::PrepareImpl ()
{
 string answer;

 // COMPLETE AND UTTER OVERKILL
 // -but- it'll work for any changes to the table ...
 // ... and this code can be used elsewhere (tested!).
 // copy-paste? make a function? whatever!
 // even found and fixed a bug in classFilterObject::GetAllID() while writing this!

 vector<string> pos_genders = gender_filter.GetMultiID();
 vector<string> all_genders = gender_filter.GetAllID();
 set<string> s_pos_genders;
 set<string> s_all_genders;
 set<string> s_neg_genders;

 VecToSet(pos_genders, s_pos_genders);
 VecToSet(all_genders, s_all_genders);
 set_difference(s_all_genders.begin(), s_all_genders.end(),
                s_pos_genders.begin(), s_pos_genders.end(),
                insert_iterator<set<string> >(s_neg_genders, s_neg_genders.begin()));
 string sql;
 if (s_neg_genders.size() > s_pos_genders.size())
  sql = "select people.id from people where people.gender_id in (" + SetToCommaString(s_pos_genders) + ")";
 else
  sql = "select people.id from people where people.gender_id not in (" + SetToCommaString(s_neg_genders) + ")";
 answer = Context->CreateView(sql, set<string>());
 return answer;
}
//---------------------------------------------------------------------------
bool TframeQuery__PeopleByGender::Valid ()
{
 listGenders->Color = clWindow;

 vector<string> temp_genders = gender_filter.GetMultiID();
 vector<string> all_genders = gender_filter.GetAllID();

 // none -- what's the point?
 if (temp_genders.empty())
  listGenders->Color = clBad;

 // all -- what's the point?
 if (temp_genders.size() == all_genders.size())
  listGenders->Color = clBad;

 return TframeQueryGeneric::Valid() && (listGenders->Color == clWindow);
}
//---------------------------------------------------------------------------
xValue TframeQuery__PeopleByGender::Save (bool with_params)
{
 xValue answer = TframeQueryGeneric::Save(with_params);
 if (with_params && xTag(answer) == "map")
 {
  map<string, xValue> config_map = xToMap(answer);

  set<string> genders;
  vector<string> temp_genders = gender_filter.GetMultiID();
  VecToSet(temp_genders, genders);
  config_map["genders"] = xFromStringSet(genders);

  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery__PeopleByGender::Load (xValue config, bool with_params)
{
 config = ReplaceWithGlobals(config);

 TframeQueryGeneric::Load(config, with_params);
 if (with_params && xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);
  if (xTag(config_map["genders"]) == "set")
  {
   set<string> genders_to_check = xToStringSet(config_map["genders"]);
   gender_filter.UncheckAll();
   gender_filter.SetCheckedWhereID(genders_to_check, true);
  }
 }
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery__PeopleByGender::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery__PeopleByGender(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeQuery__PeopleByGender::Appropriate (string source_table_name)
{
 return (source_table_name == "people") && (optionsPermissions["table.people"]["view"] == "true");
}
//---------------------------------------------------------------------------