//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery__PeopleByInsurance.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryGeneric"
#pragma resource "*.dfm"
TframeQuery__PeopleByInsurance *frameQuery__PeopleByInsurance;
//---------------------------------------------------------------------------
__fastcall TframeQuery__PeopleByInsurance::TframeQuery__PeopleByInsurance(TComponent* Owner)
        : TframeQueryGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
 Cache = true;
 lookupTables->RegisterComboBox("insurance_types", cboInsurance);
}
//---------------------------------------------------------------------------
__fastcall TframeQuery__PeopleByInsurance::~TframeQuery__PeopleByInsurance()
{
 lookupTables->UnregisterComboBox("insurance_types", cboInsurance);
}
//---------------------------------------------------------------------------
string TframeQuery__PeopleByInsurance::PrepareImpl ()
{
 string answer;
 Pdate covered_on = Pdate(editCoveredOn->Text.c_str(), global_mode);
 bool  covered_given = (editCoveredOn->Text != "");
 bool  covered_valid = (covered_given && covered_on.IsValidDate());

 string sql = "select distinct people.id from people "
              "inner join insurance_coverage on insurance_coverage.person_id = people.id "
              "inner join insurance_policies on insurance_coverage.insurance_policy_id = insurance_policies.id "
              "where insurance_policies.insurance_id = '" + lookupTables->IdOf("insurance_types", cboInsurance) + "' "
                    "and insurance_coverage.current_id >= 3 and insurance_policies.current_id >= 3 ";
 if (covered_valid)
   sql += "and ('" + covered_on.OutDate(global_mode) + "' >= insurance_policies.start_date or insurance_policies.start_date is null) "
          "and ('" + covered_on.OutDate(global_mode) + "' < insurance_policies.stop_date or insurance_policies.stop_date is null) ";

 // 'this' isn't SpecialGeneric derived.
 DebugSql(NULL, &sql, other_forms, 9);
 answer = Context->CreateView(sql, set<string>());
 return answer;
}
//---------------------------------------------------------------------------
bool TframeQuery__PeopleByInsurance::Valid ()
{
 cboInsurance->Color = clWindow;

 bool answer = true;
 if (cboInsurance->Text == "" || !lookupTables->IsInLookUpTable("insurance_types", cboInsurance->Text.c_str()))
 {
  cboInsurance->Color = clBad;
  //cboInsurance->SetFocus();
  answer = false;
 }
 return TframeQueryGeneric::Valid() && answer;
}
//---------------------------------------------------------------------------
xValue TframeQuery__PeopleByInsurance::Save (bool with_params)
{
 xValue answer = TframeQueryGeneric::Save(with_params);
 if (with_params && xTag(answer) == "map")
 {
  map<string, xValue> config_map = xToMap(answer);

  config_map["insurance_id"] = xFromInt(StringToInt(lookupTables->IdOf("insurance_types", cboInsurance)));

  if (Pdate(editCoveredOn->Text.c_str(), global_mode).IsValidDate())
   config_map["covered_on"] = xFromPdate(Pdate(editCoveredOn->Text.c_str(), global_mode));

  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery__PeopleByInsurance::Load (xValue config, bool with_params)
{
 config = ReplaceWithGlobals(config);

 TframeQueryGeneric::Load(config, with_params);
 if (with_params && xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);

  cboInsurance->Text = lookupTables->ValueOf("insurance_types", IntToString(xToInt(config_map["insurance_id"]))).c_str();

  if (xTag(config_map["covered_on"]) == "date")
   editCoveredOn->Text = xToPdate(config_map["covered_on"]).OutDate(global_mode).c_str();
 }
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery__PeopleByInsurance::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery__PeopleByInsurance(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeQuery__PeopleByInsurance::Appropriate (string source_table_name)
{
 return (source_table_name == "people") && (optionsPermissions["table.people"]["view"] == "true" &&
                                            optionsPermissions["table.insurance_coverage"]["view"] == "true" &&
                                            optionsPermissions["table.insurance_policies"]["view"] == "true");
}
//---------------------------------------------------------------------------
string TframeQuery__PeopleByInsurance::Describe (bool as_html)
{
 bool has_date = Pdate(editCoveredOn->Text.c_str(), global_mode).IsValidDate();
 string d_desc = (has_date ? (string(" as of ") + Pdate(editCoveredOn->Text.c_str(), global_mode).OutDate(global_mode)) : string(""));
 return "People " + string(has_date ? "" : "ever ") +
        "covered under a " + string(cboInsurance->Text.c_str()) + " insurance policy" +
        d_desc + string(as_html ? ".<br>" : ".\r\n");
}
//---------------------------------------------------------------------------

