//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery__PeopleByMeasurementImprovement.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryGeneric"
#pragma resource "*.dfm"
TframeQuery__PeopleByMeasurementImprovement *frameQuery__PeopleByMeasurementImprovement;
//---------------------------------------------------------------------------
__fastcall TframeQuery__PeopleByMeasurementImprovement::TframeQuery__PeopleByMeasurementImprovement(TComponent* Owner)
        : TframeQueryGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
 Cache = true;
 lookupTables->RegisterComboBox("obs_questions", comboKey, "select id, item, valid from obs_questions where improvement_id != 0 and obs_question_id in (3, 4) order by item");
 comboKey->OnKeyPress = comboKeyKeyPress; // redirect -- because of OnChange we want to use (is this -actually- necessary?)
 comboBy->ItemIndex = 0;
 comboByChange(comboBy);
}
//---------------------------------------------------------------------------
__fastcall TframeQuery__PeopleByMeasurementImprovement::~TframeQuery__PeopleByMeasurementImprovement()
{
 lookupTables->UnregisterComboBox(comboKey);
}
//---------------------------------------------------------------------------
string SqlOptionalBetweenFloat (string field, string a, string b)
{
 if (!a.empty() && !b.empty())
 {
  return field + " between '" + SafeSQLString(a) + "' and '" + SafeSQLString(b) + "'";
 } else
 if (!a.empty())
 {
  return field + " >= '" + SafeSQLString(a) + "'";
 } else
 if (!b.empty())
 {
  return field + " <= '" + SafeSQLString(b) + "'";
 } else
 {
  return "1 = 1";
 }
}
//--------------------------------------------------------------------------
string TframeQuery__PeopleByMeasurementImprovement::PrepareImpl ()
{
 string answer;
 string op;

 string date_string = SqlOptionalBetween ("date_of_observation", editStart->Text.c_str(), editStop->Text.c_str());
 bool is_improved = (comboDir->ItemIndex == 0);
 bool is_better_lower = (GetOneField(Context->Transaction, "select improvement_id from obs_questions where id = " + q_id) == lookupTables->IdOf("improvement_types", "LOWER IS BETTER"));
 // we search for people where (old_val op new_val)

/*
 PSay("is_improved: " + string(is_improved ? "y" : "n") + "\n"
      "is_better_lower: " + string(is_better_lower ? "y" : "n") + "\n"
      "operator: old " + op + " new", m_debug, MB_OK, "TframeQuery__PeoplebyMeasurementImprovement");
*/


 // some of the following code stolen from codeQuery__PeopleByLatestMeasurement!

 // decide which field to grab!
 string obs_field;
 if (obs_type == "4") // metric
  obs_field = "response_metric";
 else if (obs_type == "3") // ordinal
  obs_field = "rank";
/* -- should not be needed!
 else if (obs_type == "2") // text
  obs_field = "upper(response_text)";
 else if (obs_type == "1") // choice
  obs_field = "obs_option_id";
*/
 else
  ; // not a clue. fucked? yup. fucked.

 set<string> allowed_groups;
 if (optionsPermissions["table.measurements.common"]["view"] == "true")
   allowed_groups.insert("0");
 if (optionsPermissions["table.measurements.diab"]["view"] == "true")
   allowed_groups.insert(lookupTables->IdOf("groups", "Diabetes"));
 if (optionsPermissions["table.measurements.beh"]["view"] == "true")
   allowed_groups.insert(lookupTables->IdOf("groups", "Behavioral Health"));
 if (optionsPermissions["table.measurements.com"]["view"] == "true")
   allowed_groups.insert(lookupTables->IdOf("groups", "Community Health"));
 if (optionsPermissions["table.measurements.lac"]["view"] == "true")
   allowed_groups.insert(lookupTables->IdOf("groups", "Little Axe Clinic"));
 if (optionsPermissions["table.measurements.den"]["view"] == "true")
   allowed_groups.insert(lookupTables->IdOf("groups", "Dental Clinic"));
 if (optionsPermissions["table.measurements.cob"]["view"] == "true")
   allowed_groups.insert(lookupTables->IdOf("groups", "Contract Health"));
 if (optionsPermissions["table.measurements.pub"]["view"] == "true")
   allowed_groups.insert(lookupTables->IdOf("groups", "Public Health"));
 // TODO: possibly dangerous ... members of a group might need stuff taken away from them, even from their own group?
 allowed_groups.insert(current_groupid);
 string permission_string =
  "(1 = 0 or obs_response_sets.group_id in (" + SetToCommaString(allowed_groups) + ")) "
  "and "
  "obs_response_sets.obs_question_set_id in (select oqs.id from obs_question_set_types oqs inner join permissions p on p.s = oqs.permission_name and p.k = 'VIEW' and p.v = 'TRUE' and p.user_id = " + current_userid + ") ";

 // pre-filter for people at least who have had this question asked at some point -- speeds things up?
 string sql = "select distinct person_id "
              "from obs_responses "
              "left join obs_response_sets on obs_response_sets.id = obs_responses.obs_response_set_id "
              "left join obs_option_types on obs_option_types.id = obs_responses.obs_option_id "
              "where "
              "obs_responses.obs_question_id = " + q_id +
              " and " + date_string;

 string t = Context->CreateView(sql, set<string>());
 t = Context->CreateProxyView(t);

 comp_data = GetNextId(Context->Transaction, "temp_id");

 sql = "insert into temp_id (q, id, c, e, f) "
       "select " + comp_data + " q, people.id,  "

        "(select count(" + obs_field + ") "
        " from obs_responses "
        "right join obs_response_sets on obs_response_sets.id = obs_responses.obs_response_set_id "
        "left join obs_option_types on obs_option_types.id = obs_responses.obs_option_id "
        "where "
        "obs_responses.obs_question_id = " + q_id + " and "
        "obs_response_sets.person_id = people.id and " +
        date_string +
        "and obs_response_sets.current_id + 1 > 3 "
        ") c, "

        "(select first 1 " + obs_field +
        " from obs_responses "
        "right join obs_response_sets on obs_response_sets.id = obs_responses.obs_response_set_id "
        "left join obs_option_types on obs_option_types.id = obs_responses.obs_option_id "
        "where "
        "obs_responses.obs_question_id = " + q_id + " and "
        "obs_response_sets.person_id = people.id and " +
        date_string +
        "and obs_response_sets.current_id + 1 > 3 "
        "order by date_of_observation asc) e, "

        "(select first 1 " + obs_field +
        " from obs_responses "
        "right join obs_response_sets on obs_response_sets.id = obs_responses.obs_response_set_id "
        "left join obs_option_types on obs_option_types.id = obs_responses.obs_option_id "
        "where "
        "obs_responses.obs_question_id = " + q_id + " and "
        "obs_response_sets.person_id = " + t + ".id and " +
        date_string +
        " and obs_response_sets.current_id + 1 > 3 "
        "order by date_of_observation desc) f "

       "from people "
       "inner join " + t + " on " + t + ".id = people.id ";

 if (!ExecuteStatement(Context->Transaction, sql))
  PSay("Failed to insert comparison data.", m_database_error, MB_OK, "TframeQuery__PeopleByMeasurementImprovement");

 sql = "select id from temp_id where c > 1 and "; // now at least test there were two answers, not a first and last both pulled from the same measurement!

 // note: we want to test for a minimum of 0.00 improvement/worsening. DON'T let the specify "improved by at most 5%" and allow that to return all worsenings too.
 bool want_lower = !(is_improved ^ is_better_lower); // xor
 switch (comboBy->ItemIndex)
 {
  case 0:
   sql += "e " + string(want_lower ? "<" : ">") + " f";
   break;
  case 1:
  {
   float a = StringToFloat(editMin->Text.c_str()) / 100.0;
   float b = StringToFloat(editMax->Text.c_str()) / 100.0;
   sql += "e != 0.00 and " + SqlOptionalBetweenFloat(string(want_lower ? "1.0 - (f / e)" : "(f / e) - 1.0"), (editMin->Text == "" ? "0.00" : FloatToString(a).c_str()), (editMax->Text == "" ? "" : FloatToString(b).c_str()));
   break;
  }
  case 2:
  {
   string a = editMin->Text.c_str();
   string b = editMax->Text.c_str();
   if (a.empty())
    a = "0.00";
   sql += SqlOptionalBetweenFloat(string(want_lower ? "e - f" : "f - e"), a, b);
   break;
  }
 }

 DebugSql(NULL, &sql, other_forms, 9);
 set<string> requires_t;
 requires_t.insert(t);
 answer = Context->CreateView(sql, requires_t);
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery__PeopleByMeasurementImprovement::CleanUpImpl ()
{
 if (!comp_data.empty())
 {
  if (!ExecuteStatement(Context->Transaction, "delete from temp_id where q = " + comp_data))
   PSay("Failed to delete temporary data, q = " + comp_data, m_database_error, MB_OK, "TframeQuery__PeopleByMeasurementImprovement");
  comp_data = "";
 }
 return;
}
//---------------------------------------------------------------------------
bool TframeQuery__PeopleByMeasurementImprovement::Valid ()
{
 bool answer = true;

 comboKey->Color = clWindow;
 comboDir->Color = clWindow;

 comboBy->Color = clWindow;
 editMin->Color = clWindow;
 editMax->Color = clWindow;

 if (comboKey->Text == "" || !lookupTables->IsInLookUpTable("obs_questions", comboKey))
 {
  comboKey->Color = clBad;
  answer = false;
 }

 ResetItemIndex(comboDir); // just in case. seems to have issues with ... that. somehow. this fixes things. yup.
 if (comboDir->ItemIndex == -1)
 {
  comboDir->Color = clBad;
  answer = false;
 }

 ResetItemIndex(comboBy);
 if (comboBy->ItemIndex == -1)
 {
  comboBy->Color = clBad;
  answer = false;
 } else
 if (comboBy->ItemIndex != 0)
 {
  answer &= quValidSortedSomeOptionalFloat(editMin, editMax);
  if (IsFloat(editMin->Text.c_str()) && StringToFloat(editMin->Text.c_str()) < 0)
  {
   editMin->Color = clBad;
   answer = false;
  }
  if (IsFloat(editMax->Text.c_str()) && StringToFloat(editMax->Text.c_str()) < 0)
  {
   editMax->Color = clBad;
   answer = false;
  }
 }

 answer &= quValidSortedOptionalDate(editStart, editStop);

 return TframeQueryGeneric::Valid() && answer;
}
//---------------------------------------------------------------------------
xValue TframeQuery__PeopleByMeasurementImprovement::Save (bool with_params)
{
 xValue answer = TframeQueryGeneric::Save(with_params);
 if (with_params && xTag(answer) == "map")
 {
  map<string, xValue> config_map = xToMap(answer);

  config_map["key"] = xFromInt(StringToInt(lookupTables->IdOf("obs_questions", comboKey)));
  config_map["dir"] = xFromInt(comboDir->ItemIndex);
  quSaveOptionalDate(config_map, "start", editStart);
  quSaveOptionalDate(config_map, "stop", editStop);
  config_map["by"] = xFromInt(comboBy->ItemIndex);
  if (comboBy->ItemIndex)
  {
   quSaveOptionalFloat(config_map, "min", editMin);
   quSaveOptionalFloat(config_map, "max", editMax);
  }
  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery__PeopleByMeasurementImprovement::Load (xValue config, bool with_params)
{
 config = ReplaceWithGlobals(config);

 TframeQueryGeneric::Load(config, with_params);
 if (with_params && xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);

  comboKey->Text = lookupTables->ValueOf("obs_questions", IntToString(xToInt(config_map["key"]))).c_str();
  comboKeyChange(comboKey);
  comboDir->ItemIndex = xToInt(config_map["dir"]);
  quLoadOptionalDate(config_map, "start", editStart);
  quLoadOptionalDate(config_map, "stop", editStop);

  if (xTag(config_map["by"]) == "int")
  {
   comboBy->ItemIndex = xToInt(config_map["by"]);
   comboByChange(comboBy);
   if (comboBy->ItemIndex)
   {
    quLoadOptionalFloat(config_map, "min", editMin);
    quLoadOptionalFloat(config_map, "max", editMax);
   }
  }
 }
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery__PeopleByMeasurementImprovement::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery__PeopleByMeasurementImprovement(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeQuery__PeopleByMeasurementImprovement::Appropriate (string source_table_name)
{
 return (source_table_name == "people") &&
        (optionsPermissions["table.people"]["view"] == "true") &&
        (optionsPermissions["table.measurements"]["view"] == "true");
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery__PeopleByMeasurementImprovement::comboDirKeyPress(
      TObject *Sender, char &Key)
{
 FindComboBoxItem(Sender, Key);
}
//---------------------------------------------------------------------------
string TframeQuery__PeopleByMeasurementImprovement::Describe (bool as_html)
{
 string desc;

 // juuuuuust in case.
 ResetItemIndex(comboDir);
 ResetItemIndex(comboBy);

 Pdate a = Pdate(editStart->Text.c_str(), global_mode);
 Pdate o = Pdate(editStop->Text.c_str(), global_mode);

 if (comboBy->ItemIndex)
 {
  desc += "by ";
  float m = -1.0;
  float M = -1.0;
  if (editMin->Text != "")
   m = StringToFloat(editMin->Text.c_str());
  if (editMax->Text != "")
   M = StringToFloat(editMax->Text.c_str());
  if (m > -0.5 && M > -0.5)
   desc += FloatToString(m) + " to " + FloatToString(M);
  else if (m > -0.5)
   desc += "at least " + FloatToString(m);
  else if (M > -0.5)
   desc += "at most " + FloatToString(M);
  else
   desc += "[error]";
  desc += " ";
  if (comboBy->ItemIndex == 1)
   desc += "%";
  else
   desc += labelUnits->Caption.c_str();
 } else
  desc += "at all";

 desc += " ";
 if (a.IsValidDate() && o.IsValidDate())
  desc += "between " + a.OutDate(global_mode) + " and " + o.OutDate(global_mode);
 else
 if (a.IsValidDate())
  desc += "after " + a.OutDate(global_mode);
 else
 if (o.IsValidDate())
  desc += "before " + o.OutDate(global_mode);
 else
  desc += "(no date restriction)";

 return "People whose " + string(comboKey->Text.c_str()) + " " + string(comboDir->Text.c_str()) + " " + desc + string(as_html ? ".<br>" : ".\r\n");
}
//---------------------------------------------------------------------------
void TframeQuery__PeopleByMeasurementImprovement::RefreshObsQuestionType()
{
 q_id     = "0";
 obs_type = "0";
 obs_opt  = "0";

 if (lookupTables->IsInLookUpTable("obs_questions", comboKey))
 {
  q_id     = lookupTables->IdOf("obs_questions", comboKey);
  obs_type = GetOneField(dbDatabase, "select obs_questions.obs_question_id from obs_questions where obs_questions.id = " + q_id);
  obs_opt  = GetOneField(dbDatabase, "select obs_questions.obs_option_set_id from obs_questions where obs_questions.id = " + q_id);

  if (comboBy->ItemIndex == 1)
   labelUnits->Caption = "%";
  else if (obs_type == "4")
   labelUnits->Caption = GetOneField(dbDatabase, "select units.item from units inner join obs_questions on obs_questions.unit_id = units.id where obs_questions.id = " + lookupTables->IdOf("obs_questions", comboKey)).c_str();
  else
   labelUnits->Caption = "\"points\"";
 } else
  labelUnits->Caption = "";
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery__PeopleByMeasurementImprovement::comboKeyChange(
      TObject *Sender)
{
 RefreshObsQuestionType();
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery__PeopleByMeasurementImprovement::comboKeyKeyPress(
      TObject *Sender, char &Key)
{
 // just to make -damned- sure the OnChange thing happens?
 FindComboBoxItemAndSetItemIndex(Sender, Key);
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery__PeopleByMeasurementImprovement::comboByChange(
      TObject *Sender)
{
 ResetItemIndex(comboBy);
 bool need_fields  = (comboBy->ItemIndex != 0);
 _labelC->Visible = need_fields;
 editMin->Visible = need_fields;
 _labelD->Visible = need_fields;
 editMax->Visible = need_fields;
 labelUnits->Visible = need_fields;

 RefreshObsQuestionType();

 int new_height;
 if (need_fields)
  new_height = 72;
 else
  new_height = 48;
 if (Height != new_height)
 {
  Height = new_height;
  Resized();
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeQuery__PeopleByMeasurementImprovement::comboByKeyPress(
      TObject *Sender, char &Key)
{
 FindComboBoxItemAndSetItemIndex(Sender, Key);
}
//---------------------------------------------------------------------------

