//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery__ProceduresByCode.h"
#include "codeSearchCode.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryGeneric"
#pragma link "codeFrameCodeTaxonomy"
#pragma resource "*.dfm"
TframeQuery__ProceduresByCode *frameQuery__ProceduresByCode;
//---------------------------------------------------------------------------
__fastcall TframeQuery__ProceduresByCode::TframeQuery__ProceduresByCode(TComponent* Owner)
        : TframeQueryGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
 Cache = true;
 codeCodes->Type = txn_procedure;
}
//---------------------------------------------------------------------------
string TframeQuery__ProceduresByCode::PrepareImpl ()
{
 string answer;
 string sql = "select procedures.id from procedures where " + codeCodes->SQL;
 answer = Context->CreateView(sql, set<string>());
 return answer;
}
//---------------------------------------------------------------------------
bool TframeQuery__ProceduresByCode::Valid ()
{
 bool answer = true;
 codeCodes->Color = clWindow;
 if (!codeCodes->Valid)
 {
  codeCodes->BoxColor = clBad;
  answer = false;
 }
 return TframeQueryGeneric::Valid() && answer;
}
//---------------------------------------------------------------------------
xValue TframeQuery__ProceduresByCode::Save (bool with_params)
{
 xValue answer = TframeQueryGeneric::Save(with_params);
 if (with_params && xTag(answer) == "map")
 {
  map<string, xValue> config_map = xToMap(answer);
  config_map["matches"] = codeCodes->xCodeDescription;
  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery__ProceduresByCode::Load (xValue config, bool with_params)
{
 config = ReplaceWithGlobals(config);

 TframeQueryGeneric::Load(config, with_params);
 if (with_params && xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);
  codeCodes->xCodeDescription = config_map["matches"];
 }
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery__ProceduresByCode::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery__ProceduresByCode(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeQuery__ProceduresByCode::Appropriate (string source_table_name)
{
 return (source_table_name == "procedures") && (optionsPermissions["table.procedures"]["view"] == "true");
}
//---------------------------------------------------------------------------
string TframeQuery__ProceduresByCode::Describe (bool as_html)
{
 return "Performed procedures with a CPT-4 code among " + string(codeCodes->Text.c_str()) + string(as_html ? ".<br>" : ".\r\n");
}
//---------------------------------------------------------------------------

