//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeQuery__TasksByMethodOfContact.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQueryGeneric"
#pragma resource "*.dfm"
TframeQuery__TasksByMethodOfContact *frameQuery__TasksByMethodOfContact;
//---------------------------------------------------------------------------
__fastcall TframeQuery__TasksByMethodOfContact::TframeQuery__TasksByMethodOfContact(TComponent* Owner)
        : TframeQueryGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
 Cache = true;
 // ListExpanded = false;

 type_filter.SetListViewHandle(listMethodTypes);
 type_filter.SetSecurity("");
 type_filter.AddColumnSpec("Method", "", as_text, true, 100, prettyString);
 type_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 type_filter.FetchPreferences("query_tasksbymethodofcontact.method_type_filter");
 type_filter.SetIconStatus(false);
 type_filter.SetAutosizeColumns(false);
 type_filter.SetCheck(true);
 type_filter.SetHeader(false);
 type_filter.SetSQLStatement("select item, id from method_types");
 type_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
string TframeQuery__TasksByMethodOfContact::PrepareImpl ()
{
 string answer;

 // copied from peoplebygender

 vector<string> pos_methods = type_filter.GetMultiID();
 vector<string> all_methods = type_filter.GetAllID();
 set<string> s_pos_methods;
 set<string> s_all_methods;
 set<string> s_neg_methods;

 VecToSet(pos_methods, s_pos_methods);
 VecToSet(all_methods, s_all_methods);
 set_difference(s_all_methods.begin(), s_all_methods.end(),
                s_pos_methods.begin(), s_pos_methods.end(),
                insert_iterator<set<string> >(s_neg_methods, s_neg_methods.begin()));
 string sql;
 if (s_neg_methods.size() > s_pos_methods.size())
  sql = "select tasks.id from tasks where tasks.method_id in (" + SetToCommaString(s_pos_methods) + ")";
 else
  sql = "select tasks.id from tasks where tasks.method_id not in (" + SetToCommaString(s_neg_methods) + ")";
 answer = Context->CreateView(sql, set<string>());
 return answer;
}
//---------------------------------------------------------------------------
bool TframeQuery__TasksByMethodOfContact::Valid ()
{
 listMethodTypes->Color = clWindow;

 vector<string> temp_methods = type_filter.GetMultiID();
 vector<string> all_methods = type_filter.GetAllID();

 // none -- what's the point?
 if (temp_methods.empty())
  listMethodTypes->Color = clBad;

 // all -- what's the point?
 if (temp_methods.size() == all_methods.size())
  listMethodTypes->Color = clBad;

 return TframeQueryGeneric::Valid() && (listMethodTypes->Color == clWindow);
}
//---------------------------------------------------------------------------
xValue TframeQuery__TasksByMethodOfContact::Save (bool with_params)
{
 xValue answer = TframeQueryGeneric::Save(with_params);
 if (with_params && xTag(answer) == "map")
 {
  map<string, xValue> config_map = xToMap(answer);

  set<string> methods;
  vector<string> temp_methods = type_filter.GetMultiID();
  VecToSet(temp_methods, methods);
  config_map["methods"] = xFromStringSet(methods);

  answer = xFromMap(config_map);
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeQuery__TasksByMethodOfContact::Load (xValue config, bool with_params)
{
 config = ReplaceWithGlobals(config);

 TframeQueryGeneric::Load(config, with_params);
 if (with_params && xTag(config) == "map")
 {
  map<string, xValue> config_map = xToMap(config);
  if (xTag(config_map["methods"]) == "set")
  {
   set<string> methods_to_check = xToStringSet(config_map["methods"]);
   type_filter.UncheckAll();
   type_filter.SetCheckedWhereID(methods_to_check, true);
  }
 }
}
//---------------------------------------------------------------------------
TframeQueryGeneric* TframeQuery__TasksByMethodOfContact::Create (TComponent* owner)
{
 TframeQueryGeneric* temp;
 FORM_TRY
  temp = new TframeQuery__TasksByMethodOfContact(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeQuery__TasksByMethodOfContact::Appropriate (string source_table_name)
{
 return (source_table_name == "tasks") && (optionsPermissions["table.tasks"]["view"] == "true");
}
//---------------------------------------------------------------------------
