//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRelationGeneric.h"
#include "codeRelationMagic.h"
#pragma link "codeValueGeneric"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// statics, defined here
void (*TRelationGeneric::_funcFilter)(TRelationGeneric *);
void (*TRelationGeneric::_funcModify)(TRelationGeneric *);
void (*TRelationGeneric::_funcExport)(TRelationGeneric *);
void (*TRelationGeneric::_funcInsert)(TRelationGeneric *);
void (*TRelationGeneric::_funcUpdate)(TRelationGeneric *);

//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TRelationGeneric *)
{
 // new TRelationGeneric(NULL);
}
//---------------------------------------------------------------------------
__fastcall TRelationGeneric::TRelationGeneric(TComponent* Owner)
        : TValueGeneric(Owner)
{
 _menuWhole = new TPopupMenu(this);
 _menuWhole->AutoPopup = true;
 OnPopup = DefaultPopup;
 PopupMenu = _menuWhole;

 _menuFilter = new TMenuItem(this);
 _menuModify = new TMenuItem(this);
 _menuExport = new TMenuItem(this);
 _menuInsert = new TMenuItem(this);
 _menuUpdate = new TMenuItem(this);

 _menuFilter->Caption = "Filter...";
 _menuModify->Caption = "Calculate...";
 _menuExport->Caption = "Export...";
 _menuInsert->Caption = "Add...";
 _menuUpdate->Caption = "Edit...";

 _menuFilter->OnClick = DefaultFilterClick;
 _menuModify->OnClick = DefaultModifyClick;
 _menuExport->OnClick = DefaultExportClick;
 _menuInsert->OnClick = DefaultInsertClick;
 _menuUpdate->OnClick = DefaultUpdateClick;

 _menuWhole->Items->Add(_menuFilter);
 _menuWhole->Items->Add(_menuModify);
 _menuWhole->Items->Add(_menuExport);
 _menuWhole->Items->Add(_menuInsert);
 _menuWhole->Items->Add(_menuUpdate);
}
//---------------------------------------------------------------------------
/*
namespace Coderelationgeneric
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TRelationGeneric)};
                 RegisterComponents("prometheus", classes, 0);
        }
}
*/
//---------------------------------------------------------------------------
void __fastcall TRelationGeneric::SetOnPopup (TNotifyEvent pValue)
{
 FOnPopup = pValue;
 // if (FPopupMenu)
 //  FPopupMenu->OnPopup = pValue;
 if (PopupMenu)
  PopupMenu->OnPopup = pValue;
}
//---------------------------------------------------------------------------
void __fastcall TRelationGeneric::DefaultPopup(TObject * Sender)
{
 _menuFilter->Enabled = (_funcFilter != NULL);
 _menuModify->Enabled = (_funcModify != NULL);
 _menuExport->Enabled = (_funcExport != NULL);
 _menuInsert->Enabled = (_funcInsert != NULL);
 _menuUpdate->Enabled = (_funcUpdate != NULL);

 _menuUpdate->Default = true; // Selection.size() == 1 // if multiple items are selected, double-clicking won't work anyway?
}
//---------------------------------------------------------------------------
void __fastcall TRelationGeneric::SetOnFilter (TNotifyEvent pValue)
{
 FOnFilter = pValue;
 if (_menuFilter)
  _menuFilter->OnClick = pValue;
}
//---------------------------------------------------------------------------
void __fastcall TRelationGeneric::DefaultFilterClick(TObject * Sender)
{
 if (_funcFilter)
  _funcFilter(this);
}
//---------------------------------------------------------------------------
void __fastcall TRelationGeneric::SetOnModify (TNotifyEvent pValue)
{
 FOnModify = pValue;
 if (_menuModify)
  _menuModify->OnClick = pValue;
}
//---------------------------------------------------------------------------
void __fastcall TRelationGeneric::DefaultModifyClick(TObject * Sender)
{
 if (_funcModify)
  _funcModify(this);
}
//---------------------------------------------------------------------------
void __fastcall TRelationGeneric::SetOnExport (TNotifyEvent pValue)
{
 FOnExport = pValue;
 if (_menuExport)
  _menuExport->OnClick = pValue;
}
//---------------------------------------------------------------------------
void __fastcall TRelationGeneric::DefaultExportClick(TObject * Sender)
{
 if (_funcExport)
  _funcExport(this);
}
//---------------------------------------------------------------------------
void __fastcall TRelationGeneric::SetOnInsert (TNotifyEvent pValue)
{
 FOnInsert = pValue;
 if (_menuInsert)
  _menuInsert->OnClick = pValue;
}
//---------------------------------------------------------------------------
void __fastcall TRelationGeneric::DefaultInsertClick(TObject * Sender)
{
 if (_funcInsert)
  _funcInsert(this);
}
//---------------------------------------------------------------------------
void __fastcall TRelationGeneric::SetOnUpdate (TNotifyEvent pValue)
{
 FOnUpdate = pValue;
 if (_menuUpdate)
  _menuUpdate->OnClick = pValue;
}
//---------------------------------------------------------------------------
void __fastcall TRelationGeneric::DefaultUpdateClick(TObject * Sender)
{
 if (_funcUpdate)
  _funcUpdate(this);
}
//---------------------------------------------------------------------------

