//---------------------------------------------------------------------------

#ifndef codeRelationGenericH
#define codeRelationGenericH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include "codeValueGeneric.h"
#include <string>
#include <map>
#include <vector>

using namespace std;

typedef pair<map<string, string>, vector<vector<string> > > relation; // we need a better definition at some point?
//---------------------------------------------------------------------------
class PACKAGE TRelationGeneric : public TValueGeneric
{
public:
        static void (*_funcFilter)(TRelationGeneric *);
        static void (*_funcModify)(TRelationGeneric *);
        static void (*_funcExport)(TRelationGeneric *);
        static void (*_funcInsert)(TRelationGeneric *);
        static void (*_funcUpdate)(TRelationGeneric *);
private:
        const static unsigned int revision_number = 25;
protected:
        relation __fastcall virtual GetRelationValue() = 0;
        void     __fastcall virtual SetRelationValue(const relation & pValue) = 0;
        relation __fastcall virtual GetRelationSelection() = 0;
        void     __fastcall virtual SetRelationSelection(const relation & pValue) = 0;
        relation __fastcall virtual GetRelationHighlight() = 0;
        void     __fastcall virtual SetRelationHighlight(const relation & pValue) = 0;

        bool __fastcall virtual GetAllowSelection() = 0;
        void __fastcall virtual SetAllowSelection(bool pValue) = 0;
        bool __fastcall virtual GetAllowMultiSelection() = 0;
        void __fastcall virtual SetAllowMultiSelection(bool pValue) = 0;
        bool __fastcall virtual GetAllowMultiHighlight() = 0;
        void __fastcall virtual SetAllowMultiHighlight(bool pValue) = 0;

        TNotifyEvent __fastcall virtual GetOnValueChange() = 0;
        void         __fastcall virtual SetOnValueChange(TNotifyEvent pValue) = 0;
        TNotifyEvent __fastcall virtual GetOnSelectionChange() = 0;
        void         __fastcall virtual SetOnSelectionChange(TNotifyEvent pValue) = 0;
        TNotifyEvent __fastcall virtual GetOnHighlightChange() = 0;
        void         __fastcall virtual SetOnHighlightChange(TNotifyEvent pValue) = 0;

        TPopupMenu * _menuWhole;
        TNotifyEvent FOnPopup;
        void __fastcall virtual SetOnPopup (TNotifyEvent pValue);
        void __fastcall virtual DefaultPopup(TObject * Sender);
        TMenuItem *  _menuFilter;
        TNotifyEvent FOnFilter;
        void __fastcall virtual SetOnFilter (TNotifyEvent pValue);
        void __fastcall virtual DefaultFilterClick(TObject * Sender);
        TMenuItem *  _menuModify;
        TNotifyEvent FOnModify;
        void __fastcall virtual SetOnModify (TNotifyEvent pValue);
        void __fastcall virtual DefaultModifyClick(TObject * Sender);
        TMenuItem *  _menuExport;
        TNotifyEvent FOnExport;
        void __fastcall virtual SetOnExport (TNotifyEvent pValue);
        void __fastcall virtual DefaultExportClick(TObject * Sender);
        TMenuItem *  _menuInsert;
        TNotifyEvent FOnInsert;
        void __fastcall virtual SetOnInsert (TNotifyEvent pValue);
        void __fastcall virtual DefaultInsertClick(TObject * Sender);
        TMenuItem *  _menuUpdate;
        TNotifyEvent FOnUpdate;
        void __fastcall virtual SetOnUpdate (TNotifyEvent pValue);
        void __fastcall virtual DefaultUpdateClick(TObject * Sender);
public:
        __fastcall TRelationGeneric(TComponent* Owner);
        __property relation Value     = {read = GetRelationValue, write = SetRelationValue};
        __property relation Selection = {read = GetRelationSelection, write = SetRelationSelection};
        __property relation Highlight = {read = GetRelationHighlight, write = SetRelationHighlight};
        __property TPopupMenu * RelationPopupMenu = {read = PopupMenu};
        __property TNotifyEvent OnPopup = {read = FOnPopup, write = SetOnPopup};
        __property TNotifyEvent OnFilter = {read = FOnFilter, write = SetOnFilter};
        __property TNotifyEvent OnModify = {read = FOnModify, write = SetOnModify};
        __property TNotifyEvent OnExport = {read = FOnExport, write = SetOnExport};
        __property TNotifyEvent OnInsert = {read = FOnInsert, write = SetOnInsert};
        __property TNotifyEvent OnUpdate = {read = FOnUpdate, write = SetOnUpdate};
        bool __fastcall virtual Valid(VGValidationMethods Method) = 0;
__published:
        // AllowHighlight is assumed always true; have you ever seen a view that didn't? except maybe reports?
        __property bool AllowSelection = {read = GetAllowSelection, write = SetAllowSelection};
        __property bool AllowMultiSelection = {read = GetAllowMultiSelection, write = SetAllowMultiSelection};
        __property bool AllowMultiHighlight = {read = GetAllowMultiHighlight, write = SetAllowMultiHighlight};
        __property TNotifyEvent OnValueChange = {read = GetOnValueChange, write = SetOnValueChange};
        __property TNotifyEvent OnSelectionChange = {read = GetOnSelectionChange, write = SetOnSelectionChange};
        __property TNotifyEvent OnHighlightChange = {read = GetOnHighlightChange, write = SetOnHighlightChange};
        // inherited
        __property InputState;
        __property OnInitShow;
        __property OnValidate;
        // inherited
        __property DoubleBuffered;
        __property TabOrder;
        __property TabStop;
        __property Align;
        __property Anchors;
};
//---------------------------------------------------------------------------
#endif
