//---------------------------------------------------------------------------

#ifndef codeRelationMagicH
#define codeRelationMagicH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include "codeRelationGeneric.h"
#include "allsymbols.h"
enum RMDelegateTypes {dtNone, dtTabular, dtChart, dtEventTimeline, dtObservationTimeline, dtSchedule, dtDirectedGraph, dtUndirectedGraph};
//---------------------------------------------------------------------------
class PACKAGE TRelationMagic : public TRelationGeneric
{
private:
        TRelationGeneric * FDelegate;
        RMDelegateTypes    FDelegateType;
        void __fastcall Paint();
protected:
        relation __fastcall virtual GetRelationValue();
        void     __fastcall virtual SetRelationValue(const relation & pValue);
        relation __fastcall virtual GetRelationSelection();
        void     __fastcall virtual SetRelationSelection(const relation & pValue);
        relation __fastcall virtual GetRelationHighlight();
        void     __fastcall virtual SetRelationHighlight(const relation & pValue);

        bool __fastcall virtual GetAllowSelection();
        void __fastcall virtual SetAllowSelection(bool pValue);
        bool __fastcall virtual GetAllowMultiSelection();
        void __fastcall virtual SetAllowMultiSelection(bool pValue);
        bool __fastcall virtual GetAllowMultiHighlight();
        void __fastcall virtual SetAllowMultiHighlight(bool pValue);

        TNotifyEvent __fastcall virtual GetOnValueChange();
        void         __fastcall virtual SetOnValueChange(TNotifyEvent pValue);
        TNotifyEvent __fastcall virtual GetOnSelectionChange();
        void         __fastcall virtual SetOnSelectionChange(TNotifyEvent pValue);
        TNotifyEvent __fastcall virtual GetOnHighlightChange();
        void         __fastcall virtual SetOnHighlightChange(TNotifyEvent pValue);

        void __fastcall virtual SetDelegateType(RMDelegateTypes pValue);

        TNotifyEvent FDelegatePopup;
        TMenuItem *  _menuSwitch;
        TMenuItem *  _menuSwitchNone; // debug?
        TMenuItem *  _menuSwitchTabular;
        TMenuItem *  _menuSwitchEventTimeline;
        TMenuItem *  _menuSwitchObservationTimeline;
        void __fastcall virtual DefaultSwitchClick(TObject * Sender);
        void __fastcall virtual DelegateDefaultPopup(TObject * Sender);
        void __fastcall virtual DefaultPopup(TObject * Sender);
public:
        __fastcall TRelationMagic(TComponent* Owner);
        // inherited but VCL-incompatible
        __property Value;
        bool __fastcall virtual Valid(VGValidationMethods Method);
__published:
        __property RMDelegateTypes DelegateType = {read = FDelegateType, write = SetDelegateType};
        // inherited
        __property InputState;
        __property OnInitShow;
        __property OnValidate;
        // inherited
        __property DoubleBuffered;
        __property TabOrder;
        __property TabStop;
        __property Align;
        __property Anchors;
};
//---------------------------------------------------------------------------
#endif
 