//---------------------------------------------------------------------------

#ifndef codeRelationObservationTimelineH
#define codeRelationObservationTimelineH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include "codeRelationGeneric.h"
#include "codeValueGeneric.h"
//---------------------------------------------------------------------------
class PACKAGE TRelationObservationTimeline : public TRelationGeneric
{
private:
        bool         FAllowSelection;
        bool         FAllowMultiSelection;
        bool         FAllowMultiHighlight;
        relation     FValue;
        TNotifyEvent FOnValueChange;
        TNotifyEvent FOnSelectionChange;
        TNotifyEvent FOnHighlightChange;

        void __fastcall Paint();
protected:
        relation __fastcall virtual GetRelationValue();
        void     __fastcall virtual SetRelationValue(const relation & pValue);
        relation __fastcall virtual GetRelationSelection();
        void     __fastcall virtual SetRelationSelection(const relation & pValue);
        relation __fastcall virtual GetRelationHighlight();
        void     __fastcall virtual SetRelationHighlight(const relation & pValue);

        bool __fastcall virtual GetAllowSelection();
        void __fastcall virtual SetAllowSelection(bool pValue);
        bool __fastcall virtual GetAllowMultiSelection();
        void __fastcall virtual SetAllowMultiSelection(bool pValue);
        bool __fastcall virtual GetAllowMultiHighlight();
        void __fastcall virtual SetAllowMultiHighlight(bool pValue);

        TNotifyEvent __fastcall virtual GetOnValueChange();
        void         __fastcall virtual SetOnValueChange(TNotifyEvent pValue);
        TNotifyEvent __fastcall virtual GetOnSelectionChange();
        void         __fastcall virtual SetOnSelectionChange(TNotifyEvent pValue);
        TNotifyEvent __fastcall virtual GetOnHighlightChange();
        void         __fastcall virtual SetOnHighlightChange(TNotifyEvent pValue);
public:
        __fastcall TRelationObservationTimeline(TComponent* Owner);
        __property Value ;
        __property Selection;
        __property Highlight;
        bool __fastcall virtual Valid(VGValidationMethods Method);
__published:
        // inherited
        __property AllowSelection;
        __property AllowMultiSelection;
        __property AllowMultiHighlight;
        __property OnValueChange;
        __property OnSelectionChange;
        __property OnHighlightChange;
        __property InputState;
        __property OnInitShow;
        __property OnValidate;
        // inherited
        __property DoubleBuffered;
        __property TabOrder;
        __property TabStop;
        __property Align;
        __property Anchors;
};
//---------------------------------------------------------------------------
#endif
