//---------------------------------------------------------------------------

#ifndef codeRubberContainerH
#define codeRubberContainerH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>

#define _max_form_try_attempts 10000
#define _FORM_TRY {bool form_try_success = false; unsigned int form_try_attempts = 0; while (!form_try_success && form_try_attempts < _max_form_try_attempts) {form_try_attempts++; try {
#define _FORM_CATCH form_try_success = true;} catch (EOutOfResources &) {} catch (EOutOfMemory &) {} catch(EAccessViolation &) {} catch(EAbstractError &) {} catch(EReadError &) {}} if (!form_try_success) {throw("Failed maximum attempts during a form_try block");}}
POINT _point(long x, long y)
{
 POINT temp;
 temp.x = x;
 temp.y = y;
 return temp;
}
//---------------------------------------------------------------------------
class PACKAGE TRubberContainer : public TCustomControl
{
private:
        TPanel    * FGripHolder;
        TPaintBox * FGrip;
        TForm     * FRubberBand;
        TPanel    * FRubberBack;
        bool FCaptured;
        bool FPoppedOut;
        int sizegrip_x;
        int sizegrip_y;
        bool first_paint;

        TNotifyEvent FOnPopOut;
        TNotifyEvent FOnPopIn;

        bool FHidden;
        int FRightMargin;
        int FBottomMargin;
protected:
        void __fastcall ClipGrip();
        void __fastcall Paint();
        void __fastcall PopOut();
        void __fastcall PopIn();

        void __fastcall SetHidden (bool Value);
        void __fastcall SetRightMargin (int Value);
        void __fastcall SetBottomMargin (int Value);

        void __fastcall SetPoppedOut (bool Value);

        void __fastcall GripMouseDown (TObject* Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall GripPaint     (TObject* Sender);
        void __fastcall RubberEnter (TObject* Sender);
        void __fastcall RubberExit  (TObject* Sender);
public:
        __fastcall TRubberContainer(TComponent* Owner);
__published:
        __property Align;
        __property Anchors;
        __property Color;
        __property ParentColor;
        __property Enabled;
        __property Visible;
        __property DoubleBuffered;
        __property TabOrder;
        __property TabStop;
        __property bool Hidden = {read = FHidden, write = SetHidden, nodefault};
        __property int RightMargin = {read = FRightMargin, write = SetRightMargin, nodefault};
        __property int BottomMargin = {read = FBottomMargin, write = SetBottomMargin, nodefault};
        __property TNotifyEvent OnPopOut = {read = FOnPopOut, write = FOnPopOut};
        __property TNotifyEvent OnPopIn = {read = FOnPopIn, write = FOnPopIn};
        __property bool PoppedOut = {read = FPoppedOut, write = SetPoppedOut};
};
//---------------------------------------------------------------------------
#endif
