//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSectionsGeneric.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TSectionsGeneric *)
{
        new TSectionsGeneric(NULL);
}
//---------------------------------------------------------------------------
__fastcall TSectionsGeneric::TSectionsGeneric(TComponent* Owner)
        : TCustomControl(Owner)
{
 ControlStyle << csAcceptsControls << csReplicatable;
 Width  = 193;
 Height = 57;
 reopen_when_enabled = false;

 OnResize = AfterResize; // register changes to height into FOpenHeight;

 panelTop = new TPanel(this);
 panelTop->Left = 0;
 panelTop->Top = 0;
 panelTop->Height = 16;
 panelTop->Width = Width;
 panelTop->Anchors << akRight;
 panelTop->BevelInner = bvNone;
 panelTop->BevelOuter = bvNone;
 panelTop->ParentColor = true;
 panelTop->Caption = "";
 panelTop->OnClick = UserClick;
 panelTop->Parent = this;
/*
 buttonArrow = new TSpeedButton (this);
 buttonArrow->Left = 0;
 buttonArrow->Width = 16;
 buttonArrow->Top = 0;
 buttonArrow->Height = 16;
 // buttonArrow->Anchors << akRight;
 // buttonArrow->BevelInner = bvNone;
 // buttonArrow->BevelOuter = bvNone;
 buttonArrow->Caption = "";
 buttonArrow->Flat = true;
 buttonArrow->Layout = blGlyphTop;
 buttonArrow->Margin = 3;
 // buttonArrow->Color = clAppWorkSpace;
 buttonArrow->Parent = this;
 buttonArrow->OnClick = UserClick;
 buttonArrow->Transparent = true;
*/
 buttonArrow = new TImage (this);
 buttonArrow->Left = 4;
 buttonArrow->Width = 7;
 buttonArrow->Top = 4;
 buttonArrow->Height = 7;
 // buttonArrow->Anchors << akRight;
 // buttonArrow->BevelInner = bvNone;
 // buttonArrow->BevelOuter = bvNone;
 // buttonArrow->Color = clAppWorkSpace;
 buttonArrow->Stretch = true;
 buttonArrow->Transparent = true;
 buttonArrow->Parent = panelTop; // this;
 buttonArrow->OnClick = UserClick;

 labelTop = new TLabel (this);
 labelTop->Left = 24;
 labelTop->Top  = 0;
 labelTop->Caption = FCaption;
 labelTop->Enabled = Enabled;
 labelTop->Parent = panelTop; // this;
 labelTop->OnClick = UserClick;

 OpenHeight = 57;
 Open = true;
}
//---------------------------------------------------------------------------
namespace Codesectionsgeneric
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TSectionsGeneric)};
                 RegisterComponents("prometheus", classes, 0);
        }
}
//---------------------------------------------------------------------------
Windows::TRect __fastcall TSectionsGeneric::GetClientRect()
{
 TRect answer;
 answer.Top = 16;
 answer.Left = 0;
 answer.Right = Width;
 answer.Bottom = Height;
 return answer;
}
//---------------------------------------------------------------------------
void __fastcall TSectionsGeneric::Paint()
{
 TRect rectAll;
 rectAll.Top = 0;
 rectAll.Bottom = Height;
 rectAll.Left = 0;
 rectAll.Right = Width;

 Canvas->Brush->Color = Color;
 Canvas->FillRect(rectAll);
/*
 TRect rectTop;
 rectTop.Top = 0;
 rectTop.Bottom = 16;
 rectTop.Left = 0;
 rectTop.Right = Width;

 Canvas->Brush->Color = clAppWorkSpace;
 Canvas->FillRect(rectTop);

 if (Enabled)
  Canvas->Font->Color = clActiveCaption;
 else
  Canvas->Font->Color = clInactiveCaption;
 Canvas->TextOut(0, 0, Caption);
*/
}
//---------------------------------------------------------------------------
void __fastcall TSectionsGeneric::UpdateGlyph()
{
/*
 if (FOpen)
  buttonArrow->Glyph->LoadFromResourceName(FindClassHInstance(__classid(TSectionsGeneric)), "BARROWDOWN");
 else
  buttonArrow->Glyph->LoadFromResourceName(FindClassHInstance(__classid(TSectionsGeneric)), "BARROWRIGHT");
*/

 Graphics::TBitmap *temp = new Graphics::TBitmap();
 try
 {
  if (FOpen)
   temp->LoadFromResourceName(FindClassHInstance(__classid(TSectionsGeneric)), "BARROWDOWN");
  else
   temp->LoadFromResourceName(FindClassHInstance(__classid(TSectionsGeneric)), "BARROWRIGHT");
  buttonArrow->Picture->Assign(temp);
 }
 catch (...) {}
 delete temp;

/* -- didn't wind up needing these after all, because it was all being caused by the order of SetEnabled code
 if (FOpen && Enabled)
  buttonArrow->Glyph->LoadFromResourceName(FindClassHInstance(__classid(TSectionsGeneric)), "BARROWRIGHT");
 else if (FOpen)
  buttonArrow->Glyph->LoadFromResourceName(FindClassHInstance(__classid(TSectionsGeneric)), "BARROWRIGHTD");
 else if (Enabled)
  buttonArrow->Glyph->LoadFromResourceName(FindClassHInstance(__classid(TSectionsGeneric)), "BARROWDOWN");
 else
  buttonArrow->Glyph->LoadFromResourceName(FindClassHInstance(__classid(TSectionsGeneric)), "BARROWDOWND");
*/
}
//---------------------------------------------------------------------------
void __fastcall TSectionsGeneric::SetOpen(bool Value)
{
 if (!Enabled)
 {
  reopen_when_enabled = FOpen;
  Value = false;
 }

 bool is_changing = (Value != FOpen);
 FOpen = Value;
 UpdateGlyph();
 if (!Value)
 {
  Height = 16;
  if (FOnShut && is_changing)
   FOnShut(this);
 } else
 {
  Height = FOpenHeight;
  if (FOnOpen && is_changing)
   FOnOpen(this);
 }
}
//---------------------------------------------------------------------------
bool __fastcall TSectionsGeneric::CanResize(int &NewWidth, int &NewHeight)
{
 if (TCustomControl::CanResize(NewWidth, NewHeight))
 {
  if (!FOpen)
   NewHeight = 16;
  return true;
 } else
  return false;
}
//---------------------------------------------------------------------------
void __fastcall TSectionsGeneric::SetCaption(AnsiString Value)
{
 FCaption = Value;
 labelTop->Caption = FCaption;
 Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TSectionsGeneric::UserClick(TObject * Sender)
{
 Open = !Open;
}
//---------------------------------------------------------------------------
void __fastcall TSectionsGeneric::SetEnabled(bool Value)
{
 bool should_reopen = FOpen;
 if (!Value)
  Open = false;
 else
  Open = reopen_when_enabled;
 reopen_when_enabled = should_reopen;
 buttonArrow->Enabled = Value;
 labelTop->Enabled = Value;
 TCustomControl::SetEnabled(Value);
}
//---------------------------------------------------------------------------
void __fastcall TSectionsGeneric::SetOpenHeight(int Value)
{
 FOpenHeight = Value;
 if (FOpen)
  Height = Value;
}
//---------------------------------------------------------------------------
void __fastcall TSectionsGeneric::AfterResize(TObject* Sender)
{
 if (FOpen)
  FOpenHeight = Height;
}
//---------------------------------------------------------------------------

