//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSoftDropShadow.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TSoftDropShadow *)
{
        new TSoftDropShadow(NULL);
}
//---------------------------------------------------------------------------
__fastcall TSoftDropShadow::TSoftDropShadow(TComponent* Owner)
        : TCustomControl(Owner)
{
 ControlStyle << csAcceptsControls << csReplicatable;
 Width  = 121;
 Height = 24;
}
//---------------------------------------------------------------------------
namespace Codesoftdropshadow
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TSoftDropShadow)};
                 RegisterComponents("prometheus", classes, 0);
        }
}
//---------------------------------------------------------------------------
TColor average_color (TColor a, TColor b, float percent_of_a)
{
 struct _rgb {unsigned char r; unsigned char g; unsigned char b; unsigned int z;};
 union rgb {unsigned int i; _rgb c; unsigned char a[4];};
 rgb u; // input == a
 rgb v; // input == b
 rgb w; // output
 u.i = a;
 v.i = b;
 for (unsigned int k = 0; k < 3; k++) // starts at the end -- RR, GG, BB, other
  w.a[k] = (unsigned char)(u.a[k] * percent_of_a) + (v.a[k] * (1.00 - percent_of_a));
 return (TColor)(w.i);
}
//---------------------------------------------------------------------------

void __fastcall TSoftDropShadow::Paint()
{
 // some quick color-average code ... including learning about order of bytes. damn little-endian architectures! (or is it the other way around? i don't know!)

 TColor my_color = (TColor)ColorToRGB(this->Color);
 TColor black_color = 0x000000;
 TColor shadow_color = average_color(black_color, my_color, 0.50);
 TColor stage1 = average_color(shadow_color, my_color, 1.00);
 TColor stage2 = average_color(shadow_color, my_color, 0.60);
 TColor stage3 = average_color(shadow_color, my_color, 0.30);
 TColor stage4 = average_color(shadow_color, my_color, 0.10);

 Canvas->Pen->Mode  = pmCopy;
 Canvas->Pen->Style = psSolid;
 Canvas->Pen->Width = 1;
 Canvas->Pen->Color = stage1; // 0x00808080;
 Canvas->MoveTo(0, 0);
 Canvas->LineTo(Width, 0);
 Canvas->Pen->Color = stage2; // 0x00909090;
 Canvas->MoveTo(0, 1);
 Canvas->LineTo(Width, 1);
 Canvas->MoveTo(0, 1);
 Canvas->LineTo(0, Height);
 Canvas->Pen->Color = stage3; // 0x00A0A0A0;
 Canvas->MoveTo(1,2);
 Canvas->LineTo(1, Height);
 Canvas->MoveTo(1,2);
 Canvas->LineTo(Width - 1, 2);
 Canvas->LineTo(Width - 1, Height);
 Canvas->Pen->Color = stage4; // 0x00B0B0B0;
 Canvas->MoveTo(2,3);
 Canvas->LineTo(2, Height - 1);
 Canvas->LineTo(Width - 2, Height - 1);
 Canvas->LineTo(Width - 2, 3);
 Canvas->LineTo(2, 3);

 TCustomControl::Paint();
}
//---------------------------------------------------------------------------
