//---------------------------------------------------------------------------

#ifndef codeValueGenericH
#define codeValueGenericH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>

enum VGValidationMethods {vmPrompt, vmSilent};
enum VGInputStates {isNotRelevant, isReadOnly, isWriteProtect, isWriteAllow};
//---------------------------------------------------------------------------
class PACKAGE TValueGeneric : public TCustomControl
{
public:
private:
protected:
        VGInputStates FInputState; // see enum above, self-describing?
        TNotifyEvent  FOnInitShow; // once only, for "first time becomes visible"; run SQL only when needed, etc.
        TNotifyEvent  FOnValidate; // for custom validation without deriving (override for default validation)
                                   // TODO: should we forward the 'Method' param? probably? (custom closure definition)
        void __fastcall virtual SetInputState(VGInputStates pValue);
public:
        __fastcall TValueGeneric(TComponent* Owner);
        __fastcall virtual ~TValueGeneric();
        bool __fastcall virtual Valid(VGValidationMethods Method) = 0;
__published:
        // original
        __property VGInputStates InputState = {read = FInputState, write = SetInputState, nodefault};
        __property TNotifyEvent  OnInitShow = {read = FOnInitShow, write = FOnInitShow};
        __property TNotifyEvent  OnValidate = {read = FOnValidate, write = FOnValidate};

        // inherited
        __property DoubleBuffered;
        __property TabOrder;
        __property TabStop;
        __property Align;
        __property Anchors;
};
//---------------------------------------------------------------------------
#endif
/*
enum DGNodeStates {ndHover, ndSelected, ndFocused, ndDragging};
typedef Set<DGNodeStates, ndHover, ndDragging> TDGNodeState;
enum DGEdgeStates {edHover};
typedef Set<DGNodeStates, edHover, edHover> TDGEdgeState;
typedef void __fastcall (__closure *TDGDrawNodeEvent)(System::TObject* Sender, Graphics::TCanvas* Canvas, string Item, Windows::TPoint Point);
typedef void __fastcall (__closure *TDGDrawEdgeEvent)(System::TObject* Sender, Graphics::TCanvas* Canvas, string ItemA, Windows::TPoint PointA, string ItemB, Windows::TPoint PointB);
typedef void __fastcall (__closure *TDGNodeClickEvent) (System::TObject* Sender, string Item);
typedef void __fastcall (__closure *TDGEdgeClickEvent) (System::TObject* Sender, string ItemA, string ItemB);
typedef void __fastcall (__closure *TDGNodeDblClickEvent) (System::TObject* Sender, string Item);
typedef void __fastcall (__closure *TDGEdgeDblClickEvent) (System::TObject* Sender, string ItemA, string ItemB);
// handle context-menu by providing TMenu properties for nodes and edges and 'nothing'? multi-selection of nodes, right-click?
// typedef void __fastcall (__closure *TDGNodeChangingEvent) (System::TObject* Sender, ..., bool & Accept);
// typedef void __fastcall (__closure *TDGEdgeChangingEvent) (System::TObject* Sender, ..., bool & Accept);
typedef void __fastcall (__closure *TDGNodeChangeEvent) (System::TObject* Sender, string Item, TDGNodeState OldState, TDGNodeState NewState);
typedef void __fastcall (__closure *TDGEdgeChangeEvent) (System::TObject* Sender, string ItemA, TDGEdgeState OldStateA, TDGEdgeState NewStateA, string ItemB, TDGEdgeState OldStateB, TDGEdgeState NewStateB);
typedef void __fastcall (__closure *TDGInfoHintEvent) (System::TObject* Sender, string Item, string & Hint);
// typedef void __fastcall (__closure *TDGNodeHitTest) (System::TObject* Sender, Windows::TPoint Point, string Item, bool & Confirm);
// typedef void __fastcall (__closure *TDGEdgeHitTest) (System::TObject* Sender, );

        void __fastcall virtual SetActive(bool Value);
        void __fastcall virtual SetBandColor(TColor Value);
        void __fastcall virtual SetBandWidth(unsigned int Value);
        void __fastcall virtual SetPadding(unsigned int Value);
        void __fastcall DefaultDrawNode (System::TObject* Sender, Graphics::TCanvas* Canvas, std::string Item, Windows::TPoint Point);
        void __fastcall DefaultDrawEdge (System::TObject* Sender, Graphics::TCanvas* Canvas, std::string ItemA, Windows::TPoint PointA, std::string ItemB, Windows::TPoint PointB);

        __property TDGDrawNodeEvent OnDrawNode = {read=FOnDrawNode, write=FOnDrawNode, nodefault};
        __property TDGDrawEdgeEvent OnDrawEdge = {read=FOnDrawEdge, write=FOnDrawEdge, nodefault};
        __property TDGNodeClickEvent OnNodeClick = {read=FOnNodeClick, write=FOnNodeClick, nodefault};
        __property TDGEdgeClickEvent OnEdgeClick = {read=FOnEdgeClick, write=FOnEdgeClick, nodefault};
        __property TDGNodeDblClickEvent OnNodeDblClick = {read=FOnNodeDblClick, write=FOnNodeDblClick, nodefault};
        __property TDGEdgeDblClickEvent OnEdgeDblClick = {read=FOnEdgeDblClick, write=FOnEdgeDblClick, nodefault};
        __property TDGNodeChangeEvent OnNodeChange = {read=FOnNodeChange, write=FOnNodeChange, nodefault};
        __property TDGEdgeChangeEvent OnEdgeChange = {read=FOnEdgeChange, write=FOnEdgeChange, nodefault};
        __property TDGInfoHintEvent OnInfoHint = {read=FOnInfoHint, write=FOnInfoHint, nodefault};
*/

