#include "db_hardcoded_metadata.h"

// TODO: singular, for "POINT TO" drop-down ("points to a ...")

/* STN, ACTUAL_TABLE, PLURAL, SINGULAR */
char * hardcoded_pk [] = {
"conditions",      "conditions",     "Conditions",       "Condition",
/* messy! */
"self-conditions", "conditions",     "Conditions (self-reported)",  "Condition (self-reported)",
"rel-conditions",  "conditions",     "Conditions (family history)", "Condition (family history)",
/* end messy! */
"procedures",      "procedures",     "Procedures",       "Procedure",
"people",          "people",         "People",           "Person",
"tasks",           "tasks",          "Visits",           "Visit",
"bills",           "bills",          "Bills",            "Bill",
/*
"measurements",    "measurements",   "Measurements (classic)", "Measurement (classic)",
*/
"participations",    "participations",    "Participations",       "Participation",
"events",            "events",            "Events",               "Event",
"participations",    "participations",    "Participations",       "Participations",
"diab_education",    "diab_education",    "Education (diabetes)", "Education (diab)",
"obs_response_sets", "obs_response_sets", "Observation (sets)",   "Observation (set)",
"obs_responses",     "obs_responses",     "Observation",          "Observation",
"charts",            "charts",            "Charts",               "Chart",
/* end */
NULL};

/* SOURCE_TABLE (STN), SOURCE_FIELD, DESTINATION_TABLE (STN), EXTRA_NOTE*/
char * hardcoded_fk [] = {
/* to people */
"conditions",        "person_id", "people", "",
"tasks",             "person_id", "people", "",
"diab_education",    "person_id", "people", "",
"obs_response_sets", "person_id", "people", "",
"participations",    "person_id", "people", "",
"charts",            "person_id", "people", "",

/* to tasks */
"conditions",        "task_id", "tasks", "",
"procedures",        "task_id", "tasks", "",
"bills",             "task_id", "tasks", "",
"obs_response_sets", "task_id", "tasks", "",

/* to events */
"tasks",             "event_id", "events", "",
"obs_response_sets", "event_id", "events", "",
"participations",    "event_id", "events", "",

/* to participations */
"obs_response_sets", "participations_id", "participations", "",

/* other */
"tasks",             "diab_education_id", "diab_education", "",
"obs_response_sets", "participations_id", "participations", "",
"obs_responses",     "obs_response_set_id", "obs_response_sets", "",

/* messy! */
"self-conditions",   "person_id", "people", "",
"rel-conditions",    "person_id", "people", "",
/* end messy! */

/* end */
NULL};

/* STN, FIELD, PRETTY, TYPE */
char * hardcoded_fields [] = {
"people", "gender_id",     "Gender",         "lookup",
"people", "marital_id",    "Marital status", "lookup",
"people", "occupation",    "Occupation",     "text",
"people", "yearly_income", "Yearly income",  "float",
"people", "birth_date",    "Date of birth",  "date",
"people", "death_date",    "Date of death",  "date",
"people", "yearly_income", "Yearly income",  "float",

// jhaley: removed all extinct enrollment fields
"people", "lac_diab_client", "LAC diabetes client", "bool",
"people", "asc_diab_client", "ASC diabetes client", "bool",

"people", "refused_beh_services", "Refused Behavioral Health services", "bool",
"people", "beh_code_id", "Behavioral Health code type", "lookup",
"people", "race_id", "Race type", "lookup",
"people", "in_beh_jurisdiction", "Is in Behavioral Health jurisdiction", "bool",
"people", "is_primary_support", "Is primary support", "bool",

"people", "refused_com_services", "Refused Community Health services", "bool",

"people", "refused_public_services", "Refused Public Health services", "bool",

"conditions", "start_date",   "Date (start)", "date",
"conditions", "stop_date",    "Date (stop)", "date",
"conditions", "group_id",     "Group",  "lookup",

// "charts",     "location_id",  "Location", "lookup", -- deprecated
"charts",     "chart_number", "Chart number", "text",
"charts",     "group_id",     "Group",  "lookup",

/* messy! */
"self-conditions", "start_date",   "Date (start)", "date",
"self-conditions", "stop_date",    "Date (stop)", "date",
"self-conditions", "group_id",     "Group",  "lookup",

"rel-conditions", "start_date",   "Date (start)", "date",
"rel-conditions", "stop_date",    "Date (stop)", "date",
"rel-conditions", "group_id",     "Group",  "lookup",
/* end messy! */

"procedures", "start_date",   "Date (start)", "date",
"procedures", "stop_date",    "Date (stop)", "date",

"tasks", "date_of_task", "Date", "date",
"tasks", "group_id", "Group", "lookup",
"tasks", "method_id", "Method", "lookup",
"tasks", "diab_activity_id", "Activity Type (diab)", "lookup",
/*
"tasks",  "visit_commments", "Visit comments", "text",
*/
"tasks",  "task_comments",   "Comments",  "text", /* LAC and DIAB record screens use this exclusively? */

"events", "date_of_event", "Date", "date",
"events", "event_type_id", "Type", "lookup",
"events", "event_name_id", "Name", "lookup",
"events", "event_location_id", "Location", "lookup",
"events", "group_id", "Group", "lookup",
"events", "number_attended", "Unverified attendance count", "int",

"participations", "group_id", "Group", "lookup",
"participations", "diab_special_id", "Reservation", "lookup",
"participations", "note", "Note", "text",

"diab_education", "diab_topic_id", "Topic", "lookup",
"diab_education", "pre_test_date", "Date of pre-test", "date",
"diab_education", "pre_score", "Score on pre-test", "float",
"diab_education", "post_test_date", "Date of post-test", "date",
"diab_education", "post_score", "Score on post-test", "float",

/* do we need these? */
"obs_response_sets", "date_of_observation", "Date", "date",
"obs_response_sets", "group_id", "Group", "lookup",
"obs_response_sets", "is_steps_observation", "Is for STEPS", "bool",
"obs_response_sets", "obs_question_set_id", "Question set", "lookup",
"obs_responses", "obs_question_id", "Question", "lookup",

NULL};

fk_info::fk_info ()
{
}

fk_info::fk_info (string src_table, string src_field, string dest_table, string comment) :
          source_table(src_table), source_field(src_field), destination_table(dest_table), note(comment)
{
 source_table_actual      = dbActualTable(source_table);
 destination_table_actual = dbActualTable(source_table);
 source_table_plural       = dbPrettyPlural(source_table);
 destination_table_plural  = dbPrettyPlural(destination_table);
 source_table_singular      = dbPrettySingular(source_table);
 destination_table_singular = dbPrettySingular(destination_table);
};

string dbActualTable (string table)
{
 unsigned int i = 0;
 while (hardcoded_pk[i])
 {
  if (hardcoded_pk[i] == table)
   return hardcoded_pk[i+1];
  i+=4;
 }
 return "";
}

string dbPrettyPlural (string table)
{
 unsigned int i = 0;
 while (hardcoded_pk[i])
 {
  if (hardcoded_pk[i] == table)
   return hardcoded_pk[i+2];
  i+=4;
 }
 return "";
}

string dbPrettySingular (string table)
{
 unsigned int i = 0;
 while (hardcoded_pk[i])
 {
  if (hardcoded_pk[i] == table)
   return hardcoded_pk[i+3];
  i+=4;
 }
 return "";
}

vector<fk_info> dbPointsTo (string destination_table)
{
 vector<fk_info> answer;
 unsigned int i = 0;
 while (hardcoded_fk[i])
 {
  if (hardcoded_fk[i+2] == destination_table)
   answer.push_back(fk_info(hardcoded_fk[i], hardcoded_fk[i+1], hardcoded_fk[i+2], hardcoded_fk[i+3]));
  i+=4;
 }
 return answer;
}

vector<fk_info> dbPointsFrom (string source_table)
{
 vector<fk_info> answer;
 unsigned int i = 0;
 while (hardcoded_fk[i])
 {
  if (hardcoded_fk[i] == source_table)
   answer.push_back(fk_info(hardcoded_fk[i], hardcoded_fk[i+1], hardcoded_fk[i+2], hardcoded_fk[i+3]));
  i+=4;
 }
 return answer;
}

bool dbIsAvailable (string source_table)
{
 string l_stn = LowercaseString(source_table);
 for(unsigned int i = 0; hardcoded_pk[i]; i+=4)
  if (l_stn == hardcoded_pk[i])
   return true;
 return false;
}

field_info::field_info (string src_table, string src_field, string src_field_pretty, string src_field_type) :
             source_table (src_table), source_field (src_field), source_field_pretty (src_field_pretty), source_field_type (src_field_type)
{
 source_table_actual   = dbActualTable(source_table);
 source_table_plural   = dbPrettyPlural(source_table);
 source_table_singular = dbPrettySingular(source_table);
}

vector<field_info> dbFieldsIn (string source_table)
{
 vector<field_info> answer;
 vector<fk_info> fks;
 fks = dbPointsFrom(source_table);
 unsigned int i = 0;
 while (hardcoded_fields[i])
 {
  if (hardcoded_fields[i] == source_table)
  {
   answer.push_back(field_info(hardcoded_fields[i], hardcoded_fields[i+1], hardcoded_fields[i+2], hardcoded_fields[i+3]));
   for (vector<fk_info>::iterator j = fks.begin(); j != fks.end(); j++)
    if (j->source_field == hardcoded_fields[i+1])
    {
     answer.back().about_fk = *j;
     break;
    }
  }
  i+=4;
 }
 return answer;
}

