#ifndef db_hardcoded_metadata_h
#define db_hardcoded_metadata_h

#include "util.h"

extern char* hardcoded_pk[];
extern char* hardcoded_fk[];
extern char* hardcoded_fields[];

struct fk_info
{
 string source_table;
 string source_table_actual;
 string source_table_plural;
 string source_table_singular;
 string source_field;
 string destination_table;
 string destination_table_actual;
 string destination_table_plural;
 string destination_table_singular;
 string note;
 fk_info ();
 fk_info (string src_table, string src_field, string dest_table, string comment);
};

string dbActualTable (string table);
string dbPrettyPlural (string table);
string dbPrettySingular (string table);
vector<fk_info> dbPointsTo (string destination_table);
vector<fk_info> dbPointsFrom (string source_table);
bool dbIsAvailable (string source_table);

struct field_info
{
 string source_table;
 string source_table_actual;
 string source_table_plural;
 string source_table_singular;
 string source_field;
 string source_field_pretty;
 string source_field_type;
 fk_info about_fk;
 field_info (string src_table, string src_field, string src_field_pretty, string src_field_type);
};

vector<field_info> dbFieldsIn (string source_table);

#endif
