//PANDORA
#include "inifile.h"
//load/save a file in the following format
/*
[bob]
rupert=naughty
zoop=nowhere
larry=good

[nugget]
gold=true
laughable=yes
*/
//to/from a map of string to map of string to string.
//this is, as far as i know, the standard format of an
//ini file.

bool LoadOptionsFromFile(string filename, map<string, map<string, string> > & pandora)
{
 fstream thefile;
 string oneline;
 string section = "undefined";
 string key;
 string value;

 string valid_characters;
 valid_characters = "abcdefghijklmnopqrstuvwxyz"
                    "ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890"
                    " `~!@#$%^&*()-_+=[]{}<>|\\/?'\";:,.";

 thefile.open (filename.c_str(), ios::in | ios::nocreate);
 if (thefile.is_open())
 {
  getline (thefile, oneline, '\n');
  if (oneline.size() > 0 && oneline.find_first_not_of(valid_characters) != string::npos)
   oneline = StripLast (oneline);
  while (!thefile.eof())
  {
   if (IsBracketed (oneline))
    section = StripFirst(StripLast(oneline));
   else
    if (oneline.length())
    {
     if (SplitKeyValue(oneline, key, value))
      pandora[section][key] = value;
    }
   getline (thefile, oneline, '\n');

   if (oneline.size() > 0 && oneline.find_first_not_of(valid_characters) != string::npos)
    oneline = StripLast (oneline);
  }
  thefile.close();
 }
 else
  return false;
 return true;
}

bool SaveOptionsToFile(string filename, map<string, map<string, string> > & pandora)
{
 fstream thefile;

 thefile.open (filename.c_str(), ios::out | ios::trunc);
 if (thefile.is_open())
 {
  for (map<string, map<string, string> >::iterator outer = pandora.begin(); outer != pandora.end(); outer++)
  {
   thefile << "[" << outer->first << "]\n";
   for (map<string, string>::iterator inner = outer->second.begin(); inner != outer->second.end(); inner++)
    thefile << inner->first << "=" << inner->second << "\n";
   thefile << "\n";
  }
  thefile.close();
 }
 else
  return false;
 return true;
}

bool SplitKeyValue (string incoming, string &key, string &value)
{
 if (incoming.find_first_of ("=") != string::npos)
 {
  key = incoming.substr(0, incoming.find_first_of("="));
  value = StripFirst(incoming.substr(incoming.find_first_of("=")));
 }
 else
  return false;
 return true;
}

string StripFirst (string incoming)
{
 if (incoming.length() > 1)
  return incoming.substr(1, incoming.length() - 1);
 return "";
}

string StripLast (string incoming)
{
 return incoming.substr(0, incoming.length() - 1);
}

bool IsBracketed (string incoming)
{
 if (incoming.length())
  if (incoming[0] == '[' && incoming[incoming.length() - 1] == ']')
   return true;
 return false;
}