//PHOBOS
//---------------------------------------------------------------------------
#ifndef lookUpTableClass
#define lookUpTableClass
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>
#include <Db.hpp>
#include <IBDatabase.hpp>
#include <IBCustomDataSet.hpp>
#include <IBSQL.hpp>
#include <Buttons.hpp>
#include <string>
#include <vector>
#include <map>
#include <stdlib.h>
#include <stdio.h>
#ifdef use_tcpip_messaging
#include "tcpip_messaging.h"
#endif
#ifdef use_prometheus_util
#include "prometheus_util.h"
#endif
#include "util.h"
#include "allsymbols.h"
using namespace std;

struct record
{
  string id;
  string item;
  string valid;
};

struct lookuptable_box
{
  lookuptable_box(TComboBox * p_combo_box, TStringList * p_item_list, string p_sql = "", bool (*p_follow_up)(TIBTransaction *, const string &, const string &) = NULL)
  {
    combo_box = p_combo_box;
    item_list = p_item_list;
    sql = p_sql;
    follow_up = p_follow_up;
  }
  ~lookuptable_box() {}
  TComboBox * combo_box;
  TStringList * item_list;
  string sql;
  bool (*follow_up)(TIBTransaction *, const string &, const string &);
};
//--------------------------------------------------------------------------
class classLookUpTable
{
  private:
//    map<string, string> idToItem;
//    map<string, string> itemToId;
    vector<record> table_vec;
    string tableName;
    bool isFine;
    string errorMessage;
    TIBTransaction * dbTransaction;
    TIBDataSet * dbDataSet;
    TIBSQL * dbSQL;
    vector<lookuptable_box> boxes;
    string sqlstring;
    TStringList * itemList;
    string id;
    string item;
    bool canChange;
    int display_option;
    int hide_option;
    int autoload_option;
    bool is_pending;
    TPopupMenu * lookup_popup;

  public:
    void __fastcall classLookUpTable::OnComboKeyPress(TObject *Sender, char &Key);
    void ExpectRefresh (); // called from atlas to say we should refresh when next asked for a value/registration
    void RefreshDatasets ();
    void RefreshDataset(TStringList * p_item_list, string p_sql);
    void RegisterComboBox (TComboBox * box, string sql = "", bool (*)(TIBTransaction *, const string &, const string &) = NULL);
    void UnregisterComboBox (TComboBox * box);
    void RefreshAllBoxes ();
    bool IsFine();
    bool IsInLookUpTable(string enteredString, TComboBox * box = NULL);
    bool AddValue(string value, TComboBox *box = NULL);
    bool UnsafeAddValue(string value, TComboBox *box = NULL);
    bool CanAddToTable();
    bool BoxIsRegistered(TComboBox * box);
    vector<string> GetValueList(TComboBox * box = NULL);
    string TableName();
    string IdOf(string value, TComboBox * box = NULL);
    string ValueOf(string id, TComboBox * box = NULL);
    bool IsValidId(string id, TComboBox * box = NULL);
    string ErrorMessage();
    classLookUpTable (TIBDatabase * dbDatabase, TIBTransaction * transaction, string table, bool change, int display, int hide, TPopupMenu * popup, int autoload);
    ~classLookUpTable ();
};
//--------------------------------------------------------------------------

#endif

