//PHOBOS
#ifndef lookuptablewrapper
#define lookuptablewrapper
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>                     
#include <StdCtrls.hpp>
#include <Db.hpp>
#include <IBDatabase.hpp>
#include <string>
#include <vector>
#include <map>
#include <stdlib.h>
#include <stdio.h>
#ifdef use_tcpip_messaging
#include "tcpip_messaging.h"
#endif
#ifdef use_prometheus_util
#include "prometheus_util.h"
#endif
#include "lookUpTableClass.h"

using namespace std;

//--------------------------------------------------------------------------
class classLookUpTableWrapper
{
  private:
    map<string, classLookUpTable *> lookuptables;
    TIBTransaction * dbTransaction;
    TIBDatabase * dbDatabase;
    bool canChange;

  public:
    classLookUpTableWrapper (TIBDatabase * database);
    ~classLookUpTableWrapper ();
    void ExpectRefresh (string tableName); // called by atlas
    bool AddLookUpTable (string tableName, bool change, int display, int hide, TPopupMenu * popup, int autoload);
    bool RegisterComboBox (string tableName, TComboBox * box, string sql = "", bool (*)(TIBTransaction *, const string &, const string &) = NULL);
    bool UnregisterComboBox (string tableName, TComboBox * box);
    bool UnregisterComboBox (TComboBox * box);
    int IsInLookUpTable (string tableName, string enteredString);
    int IsInLookUpTable (string tableName, TComboBox * box);
    bool RefreshAllBoxes (string tableName);
    bool AddValue (string tableName, string value, TComboBox* box = NULL);
    bool UnsafeAddValue(string tableName, string value, TComboBox* box = NULL);
    bool CanAddToTable(string tableName);
    string TableName(TComboBox * box);
    string IdOf (string tableName, string value);
    string IdOf (string tableName, TComboBox * box);
    string IdOf (string tableName, string value, TComboBox * box);
    vector<string> IdsOf(string tableName, const vector<string> &values, TComboBox * box);
    set<string> IdsOf(string tableName, const set<string> &values, TComboBox * box);
    string ValueOf (string tableName, string id, TComboBox * box = NULL);
    vector<string> ValuesOf (string tableName, const vector<string> &ids, TComboBox * box);
    set<string> ValuesOf (string tableName, const set<string> &ids, TComboBox * box);
    bool IsValidId (string tableName, string id, TComboBox * box = NULL);
    vector<string> ListTables();
    vector<string> GetValueList(string tableName, TComboBox * box = NULL);
};
//--------------------------------------------------------------------------

#endif