#ifndef mesg_q_h
#define mesg_q_h

#include <list>
#include <string>
#include <ScktComp.hpp>

using namespace std;

#define max_chunk_size 1024
#define size_separator ':'

extern char read_buffer [max_chunk_size];

class inbound_message_queue
{
 private:
  list<string> pending_messages;
  string       current_message;
  int          chunk_size;
 public:
  bool   IsMessageProcessing ();
  bool   IsMessagePending ();
  string GetMessage ();
  bool   AttemptRead (TClientSocket *the_socket);
  void   PrepMessage ();
};

class outbound_message_queue
{
 private:
  list<string> pending_messages;
  string       current_message;
  int          chunk_size;
 public:
  bool IsMessageProcessing ();
  bool IsMessagePending ();
  void AddMessage (string new_message);
  bool AttemptWrite (TClientSocket *the_socket);
  void PrepMessage ();
};

#endif
