//IO
#include "messaging.h"

classMailSlot::classMailSlot(string name)
{
 slotname = name;
 mailslot = CreateMailslot(name.c_str(), 0, 0, NULL);
 if (mailslot == INVALID_HANDLE_VALUE) ready = false;
 else ready = true;
}

classMailSlot::~classMailSlot()
{
 ready = false;
 CloseHandle (mailslot);
}

int classMailSlot::CountMessages()
{
 if (ready)
 {
  GetMailslotInfo (mailslot, NULL, &next_size, &next_count, NULL);
  if (next_size == MAILSLOT_NO_MESSAGE) next_count = 0;
  return next_count;
 }
 else return 0;
}

string classMailSlot::GetMessage()
{
 //get number and size... mostly care about size. hopefully, they've checked
 //to make sure there -is- a message they care about waiting.
 string answer;
 unsigned long read;
 if (CountMessages() && ready)
 {
  char *buffer;
  buffer = new char[next_size + 1];
  buffer[0] = '\0';
  ReadFile(mailslot, buffer, next_size, &read, NULL);
  answer = buffer;
  delete[] buffer;
 }
 else answer = "";
 return answer;
}

bool classMailSlot::IsReady()
{
 return ready;
}

string classMailSlot::GetName()
{
 return slotname;
}

bool SendMessage(string destination, string message)
{
 unsigned long written;
 HANDLE outgoingslot;

 outgoingslot = CreateFile(destination.c_str(),
                           GENERIC_WRITE, FILE_SHARE_READ,
                           (LPSECURITY_ATTRIBUTES) NULL, OPEN_EXISTING,
                           FILE_ATTRIBUTE_NORMAL, (HANDLE) NULL);
 if (outgoingslot == INVALID_HANDLE_VALUE)
    return false;

 WriteFile(outgoingslot, message.c_str(), (DWORD) message.length() + 1,
    &written, (LPOVERLAPPED) NULL);
 CloseHandle(outgoingslot);
 return true;
}

