//EPIMETHEUS
#include "netrefresh.h"

classNetworkRequestHandler::classNetworkRequestHandler (classTcpipMessaging *p_message_router) : classRequestHandler()
{
 message_router = p_message_router;
 need_calling.clear();
}

void classNetworkRequestHandler::Notify(string f, string i)
{
 string message = f + "|" + i;
 message_router->SendMessageToAll("atlas", message);
}

bool classNetworkRequestHandler::IsReady ()
{
 return true;
}

void classNetworkRequestHandler::Check ()
{
 while (message_router->IsMessageWaiting("atlas"))
 {
  string message = message_router->GetNextMessage("atlas");
  string f = message.substr(0, message.find_first_of('|', 0));
  string i = message.substr(message.find_first_of('|', 0) + 1);
  for (map<int, classRequest>::iterator itr = requests.begin(); itr != requests.end(); itr++)
   if (itr->second.MatchesNotification(f,i))
    need_calling[itr->first] = i;
    // no longer check to see if already_sent, because the map<int,string> makes sure
    // we only call once per ticket number, and if several requests go to the
    // same function, we want that function called for each request. it was causing
    // problems, especially on recordPerson.
 }

 //now call all the ones that got messages this time 'round, and call them once
 for (map<int,string>::iterator j = need_calling.begin(); j != need_calling.end(); j++)
 {
  try
  {
   requests[j->first].Fulfill(j->first, j->second);
  } catch(...)
  {
   caused_errors.insert(requests[j->first].WasFor());
  }
 }

 for (set<TObject*>::iterator j = caused_errors.begin(); j != caused_errors.end(); j++)
  CancelRequestFrom(*j);

 // all done calling stuff =)
 need_calling.clear();
 caused_errors.clear();
}

classNetworkRequestHandler::~classNetworkRequestHandler()
{
 need_calling.clear();
 //localbox gets its destructor called now
 //base class gets destructor called
}

void classNetworkRequestHandler::HandleMissingCallback (EAccessViolation & e)
{
 if(debug_level[libraries]>=1 && message_router) message_router->SendMessageToAll("debug", "Tried to call a missing callback from atlas (access violation trapped)");
}
