#ifndef prometheus_util
#define prometheus_util

#include <string>
#include <vector>
#include <deque>
#include <list>
#include <map>
#include <set>
#include "tcpip_messaging.h"
#include "allsymbols.h"
#include "util.h"
#include "sqllib.h"
//#include "lookuptablewrapper.h"
#include "externheaders.h"

// jhaley 20110506: I've about had it with STL type names :)  Here are some typedefs to start prettying up the code with.
typedef map<string, int>                  pmapstrtoint;
typedef map<int, string>                  pmapinttostr;
typedef map<int, int>                     pmapints;
typedef map<string, string>               pmapstrs;
typedef map<string, map<string, string> > pmapstrtomapstrs;
typedef set<string>                       psetstr;
typedef vector<int>                       pvecint;
typedef vector<string>                    pvecstr;
typedef vector<map<string, string> >      pvecmap;

int PSay(const string &p_message, prometheus_message_types p_message_type, int p_buttons, const string &p_class_name, const string &p_other_info = "", HWND hwnd = NULL);
void PPretendToSay(const string &p_message, prometheus_message_types p_message_type, const string &p_class_name, const string &p_other_info = "");
void DefaultAction(string id, string table_name);
void DefaultAction(string table_name, map<string, string> &field_map);
string PMakeTempFilePath(const string &filename);
bool PIsRunningUnderPath(const string &filepath);
string CleverCurrentId(const string &field, const string &compare_value, const string &current_id_if_equals, const string &current_id_if_notequals);
bool InsertCHSMailTask(TIBTransaction *task_transaction, string person_id, string message);
void UploadCrashLog();
char *PLoadTextFile(const char *filename);

#endif


