#ifndef query_action_utils_h
#define query_action_utils_h

#include <Controls.hpp>
#include <StdCtrls.hpp>
#include "x_serialization.h"

// DATES -----------------------------------------------------------------------
// no 'required' entries as we'd use a date-time picker for that
bool quValidOptionalDate(TEdit* control);
bool quSomeOptionalDate(TEdit* control_a, TEdit* control_b);
bool quSortedOptionalDate(TEdit* control_a, TEdit* control_b);

// sorted
bool quValidSortedOptionalDate(TEdit* control_a, TEdit* control_b);
bool quValidSortedSomeOptionalDate(TEdit* control_a, TEdit* control_b);
bool quSortedRequiredDate(TDateTimePicker* control_a, TDateTimePicker* control_b);

// picker/text combinations
bool quSortedOptionalDate(TDateTimePicker* control_a, TEdit* control_b);
bool quSortedOptionalDate(TEdit* control_a, TDateTimePicker* control_b);
bool quValidSortedOptionalDate(TDateTimePicker* control_a, TEdit* control_b);
bool quValidSortedOptionalDate(TEdit* control_a, TDateTimePicker* control_b);
// validsortedsomeoptionaldate doesn't make sense with a date-picker, as one side is -always- provided

// load/save
void quSaveOptionalDate(map<string, xValue> & config_map, string attribute_name, TEdit* control);
void quLoadOptionalDate(map<string, xValue> & config_map, string attribute_name, TEdit* control);

void quSaveRequiredDate(map<string, xValue> & config_map, string attribute_name, TDateTimePicker* control);
void quLoadRequiredDate(map<string, xValue> & config_map, string attribute_name, TDateTimePicker* control);

// TIMES -----------------------------------------------------------------------

bool quSortedRequiredTime(TDateTimePicker* control_a, TDateTimePicker* control_b);

// load/save
void quSaveOptionalTime(map<string, xValue> & config_map, string attribute_name, TEdit* control);
void quLoadOptionalTime(map<string, xValue> & config_map, string attribute_name, TEdit* control);

void quSaveRequiredTime(map<string, xValue> & config_map, string attribute_name, TDateTimePicker* control);
void quLoadRequiredTime(map<string, xValue> & config_map, string attribute_name, TDateTimePicker* control);

// INTEGERS --------------------------------------------------------------------
bool quValidRequiredInt(TEdit* control);

// optional
bool quValidOptionalInt(TEdit* control);
bool quSomeOptionalInt(TEdit* control_a, TEdit* control_b);
bool quSortedOptionalInt(TEdit* control_a, TEdit* control_b);

// sorted
bool quValidSortedOptionalInt(TEdit* control_a, TEdit* control_b);
bool quValidSortedSomeOptionalInt(TEdit* control_a, TEdit* control_b);
bool quValidSortedRequiredInt(TEdit* control_a, TEdit* control_b);

// load/save
void quSaveOptionalInt(map<string, xValue> & config_map, string attribute_name, TEdit* control);
void quLoadOptionalInt(map<string, xValue> & config_map, string attribute_name, TEdit* control);

void quLoadRequiredInt(map<string, xValue> & config_map, string attribute_name, TEdit* control, int default_int = 1);

// FINANCIAL -------------------------------------------------------------------
bool quValidRequiredFinancial(TEdit* control);

// optional
bool quValidOptionalFinancial(TEdit* control);
bool quSomeOptionalFinancial(TEdit* control_a, TEdit* control_b);
bool quSortedOptionalFinancial(TEdit* control_a, TEdit* control_b);

// sorted
bool quValidSortedOptionalFinancial(TEdit* control_a, TEdit* control_b);
bool quValidSortedSomeOptionalFinancial(TEdit* control_a, TEdit* control_b);
bool quValidSortedRequiredFinancial(TEdit* control_a, TEdit* control_b);

// load/save
void quSaveOptionalFinancial(map<string, xValue> & config_map, string attribute_name, TEdit* control);
void quLoadOptionalFinancial(map<string, xValue> & config_map, string attribute_name, TEdit* control);

void quLoadRequiredFinancial(map<string, xValue> & config_map, string attribute_name, TEdit* control, financial default_financial = 0.00);

// FLOAT -----------------------------------------------------------------------
bool quValidRequiredFloat(TEdit* control);

// optional
bool quValidOptionalFloat(TEdit* control);
bool quSomeOptionalFloat(TEdit* control_a, TEdit* control_b);
bool quSortedOptionalFloat(TEdit* control_a, TEdit* control_b);

// sorted
bool quValidSortedOptionalFloat(TEdit* control_a, TEdit* control_b);
bool quValidSortedSomeOptionalFloat(TEdit* control_a, TEdit* control_b);
bool quValidSortedRequiredFloat(TEdit* control_a, TEdit* control_b);

// load/save
void quSaveOptionalFloat(map<string, xValue> & config_map, string attribute_name, TEdit* control);
void quLoadOptionalFloat(map<string, xValue> & config_map, string attribute_name, TEdit* control);

void quLoadRequiredFloat(map<string, xValue> & config_map, string attribute_name, TEdit* control, float default_float = 0.00);

// TEXT ------------------------------------------------------------------------
bool quValidRequiredText(TEdit* control);

// optional
bool quSomeOptionalText(TEdit* control_a, TEdit* control_b);
bool quSortedOptionalText(TEdit* control_a, TEdit* control_b);

// sorted
bool quValidSortedSomeOptionalText(TEdit* control_a, TEdit* control_b);
bool quValidSortedRequiredText(TEdit* control_a, TEdit* control_b);

// load/save
void quSaveOptionalText(map<string, xValue> & config_map, string attribute_name, TEdit* control);
void quLoadOptionalText(map<string, xValue> & config_map, string attribute_name, TEdit* control);

void quLoadRequiredText(map<string, xValue> & config_map, string attribute_name, TEdit* control, string default_text = "");

#endif

