#ifndef query_context_h
#define query_context_h
#include "util.h"
#include "x_serialization.h"

class TframeQueryGeneric;
class TframeQuery_Whole;

class query_context
{
 private:
  xTuple*                          FGlobals;
  TIBTransaction*                  FTransaction;
  TRichEdit*                       FLogOutput;
  map<TframeQueryGeneric*, string> FPreparedQueries;
  map<string, set<string> >        FViewDependencies;
  map<string, string>              FViewDefinitions;
  vector<string>                   FProxyQueries;
  map<string, TframeQuery_Whole*>  FWholeQueries;

 public:
  query_context(TIBDatabase* dbDatabase);
  ~query_context();

  __property xTuple* Globals = {read = FGlobals};
  __property TIBTransaction* Transaction = {read = FTransaction};
  __property TRichEdit* LogOutput = {read = FLogOutput, write = FLogOutput};

  string FindWhole (string table_name);

  void   CreateCache (TframeQueryGeneric* source_query, string result_view);
  string FindCache (TframeQueryGeneric* query_to_match);
  string CreateView (string statement, set<string> views_used, string purpose = "query");
  string CreateProxyView (string view_name);
  void   Clear ();
  string DebugExplainView (string view_name);
  bool   IsProxied (string view_name);
};


#endif