#ifndef query_factory_registry_h
#define query_factory_registry_h

#include <string>
#include <vector>
#include <map>
#include <set>
using namespace std;

#include <Classes.hpp>

class TframeQueryGeneric;

typedef TframeQueryGeneric* (*q_factory_create)(Classes::TComponent*);
typedef bool (*q_factory_appropriate)(string);

struct  q_factory_info
{
 bool                  is_separator;
 string                description;
 string                serialization_tag;
 q_factory_appropriate appropriate_pointer;
 q_factory_create      create_pointer;
};

class set_query_factory_registry
{
 public:
 private:
  vector<q_factory_info> factories;
 public:
  vector<q_factory_info> GetFactories (string source_table_name);
  void AddSeparator ();
  void AddFactory (string description, string serialization_tag, q_factory_appropriate appropriate_pointer, q_factory_create create_pointer);
  q_factory_info GetFactoryByTag (string serialization_tag);
  string GetTagByFactory (q_factory_create create_pointer);
};

extern set_query_factory_registry query_factories;

#endif
