//ATLAS
#ifndef atlasfunctions
#define atlasfunctions

#include <sysutils.hpp>

#include <string>
#include <vector>
#include <set>
#ifdef use_prometheus_util
#include "prometheus_util.h"
#endif
#include "util.h"
#include "fieldtypes.h"
#include "allsymbols.h"

using namespace std;

class classRequest
{
 private:
  string fieldname;
  string itemvalue;
  int    relsymbol; //one of rel_*
  int    fieldtype; //one of as_*
  RefreshHandler how;
  TObject* where;
 public:
  classRequest ();
  classRequest (const classRequest & other_request);
  classRequest (string key, string value, int relational_op, int field_type, TObject * p_form, RefreshHandler p_callback);
  string classRequest::Description ();
  void Fulfill (int request_number, string matched_value);
  bool MatchesNotification (string key, string value);
  bool IsFrom (TObject * p_form);
  bool IsSameMethodAs (classRequest & other_request);
  TObject * WasFor ();
};

class classRequestHandler
{
 protected:
  map <int, classRequest> requests;
  int last_inserted;
 public:
  //string message;
  classRequestHandler ();
  ~classRequestHandler ();
  int  RequestNotificationWhen(string key, string value, int relational_op, int field_type, TObject * p_form, RefreshHandler p_callback);
  void Notify (string key, string value);
  void CancelRequestFrom (TObject * p_form);
  void CancelRequest (int request_number);
  void virtual HandleMissingCallback(EAccessViolation & e);
};

#endif

