// TODO - add sorting function for TTreeNode->CustomSort so that it can be called
// when a tree node is expanded (and thus is also sorted like the rest of the tree
// currently is)
//---------------------------------------------------------------------------
// TreeListView class 0.4 RC1 beta
//---------------------------------------------------------------------------
// DISCLAIMER:  This code is beta.  Do not attempt to use it in serious
// projects yet.  If you do, you'll have to fix your code yourself when
// updates come out.
//---------------------------------------------------------------------------
// Changelog and planned release features
//---------------------------------------------------------------------------
// 0.1 - basic column functionality
// 0.2 - now designed around physical rather than logical columns
//     - has all basic add/edit/move/delte/etc. public functions
// 0.3 - mouse tracking utilized for row selection and popup menus
// 0.4 - column dragging
// 0.5 - column sorting - sort_method and show_method actuall mean something now
//---------------------------------------------------------------------------
// TODO:  row_data[Node] should check if Node exists so as not to create
// a new row_data tree node accidentally.
#include <vcl.h>
#include "util.h"

#pragma hdrstop

#include "ttreelistview.h"
USEPACKAGE("Vcl50.bpi");
USEUNIT("util.cpp");
//---------------------------------------------------------------------------
#pragma package(smart_init)
//
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
        return 1;
}
//---------------------------------------------------------------------------
namespace Ttreelistview
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TTreeListView)};
                 RegisterComponents("freelib", classes, 0);
        }
}
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
static inline void ValidCtrCheck(TTreeListView *)
{
        new TTreeListView(NULL);
}

//---------------------------------------------------------------------------
// TTreeListView implementation
//---------------------------------------------------------------------------
__fastcall TTreeListView::TTreeListView(TComponent* Owner)
 : TWinControl(Owner)
{
/*  header_images = new TImageList(this);
  header_images->Width = 16;
  header_images->Height = 16;
  header_images->Masked = true;

  Graphics::TBitmap *bmp = new Graphics::TBitmap();
  Graphics::TBitmap *mask = new Graphics::TBitmap();
  bmp->LoadFromFile("C:\\sandbox\\FileRenamer\\img_down.bmp");
  mask->Assign(bmp);
  mask->Mask(mask->Canvas->Pixels[0][15]);
  header_images->Add(bmp, mask);
//  bmp->LoadFromFile("C:\\sandbox\\FileRenamer\\img_up.bmp");
//  header_images->Add(bmp, bmp);
  bmp->Dormant();
  bmp->FreeImage();
*/
  Columns = new tlv_column_container_type(this);

  border = new TPanel(this);
  border->Parent = this;
  border->Align = alClient;
  border->BevelInner = bvNone;
  border->BevelOuter = bvNone;
  border->BorderStyle = bsSingle;
  border->Caption = "Shouldn't see me";

  header = new THeaderControl(this);
  header->Parent = border;
  header->Align = alTop;

  THeaderSection * sect = header->Sections->Add();
  sect->Text = "tree";

  ShowHeader = true;
  header->DragReorder = true;
  header->OnSectionTrack = HeaderSectionTrack;
  header->OnSectionDrag = HeaderSectionDrag;
  header->OnSectionEndDrag = HeaderSectionEndDrag;
  header->OnSectionResize = HeaderSectionResize;
  header->OnSectionClick = HeaderSectionClick;
//  header->Images = header_images;

  tree = new TTreeView(this);
  tree->Parent = border;
  tree->Align = alClient;
  tree->BorderStyle = bsNone;
  tree->ReadOnly = true;
  tree->RightClickSelect = false;
  tree->OnAdvancedCustomDraw = AdvancedCustomDraw;
  tree->OnAdvancedCustomDrawItem = AdvancedCustomDrawItem;
  tree->OnMouseMove = TLVMouseMove;
  tree->OnMouseUp = TLVMouseUp;
  tree->OnCompare = NULL;
  tree->ChangeDelay = 50;
//  tree->SortType = stNone;

  // establish column 0
  Columns->Add("tree", 250, 0);

  sort_asc = true;
  sort_column_index = "";

//  delete bmp;
//  delete mask;
}
//---------------------------------------------------------------------------
__fastcall TTreeListView::~TTreeListView()
{
   delete Columns;
   delete header;
   delete tree;
   delete header_images;
   delete border;
}
//---------------------------------------------------------------------------
void TTreeListView::SetSize(TControl * control, TRect rect)
{
   control->Left = rect.Left;
   control->Top = rect.Top;
   control->Width = rect.Right - rect.Left + 1;
   control->Height = rect.Top - rect.Bottom + 1;
}
//---------------------------------------------------------------------------
void __fastcall TTreeListView::HeaderSectionTrack(THeaderControl *HeaderControl,
   THeaderSection *Section, int Width, TSectionTrackState State)
{
 if (State == tsTrackEnd)
 {
   //column_data[Section->Index].width = Section->Width;
   //RefreshHeader;
   //Application->MessageBox("SectionTrack", "Event", MB_OK);
   //Repaint();
 }
}
//---------------------------------------------------------------------------
void __fastcall TTreeListView::HeaderSectionResize(THeaderControl* HeaderControl,
   THeaderSection* Section)
{
   Columns->ColumnByLogicalIndex(Section->Index)->Width = Section->Width;
   //RefreshHeader;
   //Application->MessageBox("SectionResize", "Event", MB_OK);
   //Repaint();
   this->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TTreeListView::HeaderSectionDrag(TObject* Sender, THeaderSection* FromSection,
   THeaderSection* ToSection, bool &AllowDrag)
{
   if((FromSection->Index > 0) && (ToSection->Index > 0))
   {
      //Application->MessageBox(string(IntToString(FromSection->Index) + "->" + IntToString(ToSection->Index)).c_str(), "Moving column...", MB_OK);
      Columns->Move(FromSection->Index, ToSection->Index);
   }
   //else
   //   AllowDrag = false;
   AllowDrag = true;

}
//---------------------------------------------------------------------------
void __fastcall TTreeListView::HeaderSectionEndDrag(TObject* Sender)
{
   //this->Invalidate();
   RefreshHeaders();
   Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TTreeListView::HeaderSectionClick (THeaderControl* HeaderControl, THeaderSection* Section)
{
   if(Columns->ColumnByLogicalIndex(Section->Index)->Title == sort_column_index)
      sort_asc = !sort_asc;
   else // we expect ascending the first time for a new column
      sort_asc = true;
   if (sort_column_index != "")
   {
      tlv_column_type *prev_col = Columns->Column(sort_column_index);
      if (prev_col)
      {
        int prev_sort_col;
        prev_sort_col = prev_col->LogicalIndex;
        header->Sections->Items[prev_sort_col]->ImageIndex = -1;
      }
   }
   Section->ImageIndex = sort_asc ? 0 : 1;
   sort_column_index = Columns->ColumnByLogicalIndex(Section->Index)->Title;
   Sort(Section);
}
//---------------------------------------------------------------------------
TRect TTreeListView::ShiftRect(TRect rect, bool shift_bottom)
{
   if(header_visible)
     if(shift_bottom)
       return Rect(rect.Left, rect.Top + header->Height, rect.Right, rect.Bottom + header->Height);
     else
       return Rect(rect.Left, rect.Top + header->Height, rect.Right, rect.Bottom);
   else
     return rect;
}
//---------------------------------------------------------------------------
void __fastcall TTreeListView::AdvancedCustomDraw(TCustomTreeView* Sender, const TRect &ARect,
   TCustomDrawStage Stage, bool &DefaultDraw)
{
   if(Stage==cdPrePaint)
     header->Visible = header_visible;
}
//---------------------------------------------------------------------------
int TTreeListView::GetColumnWidth(int logical_index)
{
   if(Columns->ColumnByLogicalIndex(logical_index)->Visible)
      return Columns->ColumnByLogicalIndex(logical_index)->Width;
   else
      return 0;
}
//---------------------------------------------------------------------------
void __fastcall TTreeListView::AdvancedCustomDrawItem(TCustomTreeView *Sender, TTreeNode *Node,
   TCustomDrawState State, TCustomDrawStage Stage, bool &PaintImages, bool &DefaultDraw)
{
 DefaultDraw = true;
 PaintImages = true;

 if (Stage == cdPostPaint)
 {
   TRect NodeRect, LineRect, ClearRect;
   NodeRect = Node->DisplayRect(true);
   ClearRect = Node->DisplayRect(false);
   LineRect = Node->DisplayRect(false);
   HDC hDC = Sender->Canvas->Handle;

   COLORREF clBackground = GetSysColor(COLOR_WINDOW);
   COLORREF clText = GetSysColor(COLOR_WINDOWTEXT);

   if (State.Contains(cdsSelected))
   {
     clBackground = GetSysColor(COLOR_BTNFACE);
     clText = GetSysColor(COLOR_WINDOWTEXT);
   }
   if (State.Contains(cdsFocused))
   {
     clBackground = GetSysColor(COLOR_HIGHLIGHT);
     clText = GetSysColor(COLOR_HIGHLIGHTTEXT);
   }

   SetBkColor(hDC, clBackground);

   //THeaderSections* sections = header->Sections;
   TRect rect = NodeRect;
   LineRect.Left = NodeRect.Left;
   ClearRect.Left = NodeRect.Right;
   if(select_row)
      tree->Canvas->Brush->Color = TColor(clBackground);
   else
      tree->Canvas->Brush->Color = tree->Color;
   tree->Canvas->FillRect(ClearRect);
   int used_width = 0;
   int header_index = 0;
   for (unsigned int i = 0; i != Columns->Count; i++)
   {
      if (Columns->ColumnByLogicalIndex(i)->Visible)
      {
         if(i > 0) // no need to draw the tree node text
         {
            string the_text = GetColumnValue(Node, i);
            ShowFunction howToShow = Columns->ColumnByLogicalIndex(i)->ShowAs;
            if (howToShow)
               the_text = (*howToShow)(the_text);
            if(the_text != "")
            {
               SetTextColor(hDC, clText);
               UINT uDrawMode;
               if (Columns->ColumnByLogicalIndex(i)->Alignment == taRightJustify)
                  uDrawMode =  DT_RIGHT;
               else if (Columns->ColumnByLogicalIndex(i)->Alignment == taCenter)
                  uDrawMode =  DT_CENTER;
               else
                  uDrawMode = DT_LEFT;

               uDrawMode |= DT_SINGLELINE | DT_NOPREFIX | DT_END_ELLIPSIS;

               THeaderSection *sect = header->Sections->Items[header_index];
               rect.Left = sect->Left;
               rect.Right = rect.Left + sect->Width;
               DrawText(hDC, the_text.c_str(), the_text.length(),&rect, uDrawMode);
            }
            used_width += Columns->ColumnByLogicalIndex(i)->Width;
         }
         header_index++;
      }
   }

   if (State.Contains(cdsFocused) && select_row)
   {
     DrawFocusRect(hDC, &NodeRect);  // First turn off the one already drawn
     DrawFocusRect(hDC, &LineRect);  // Now draw our own
   }
 }
}
//---------------------------------------------------------------------------
void __fastcall TTreeListView::TLVMouseUp(
   TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if(Button == mbLeft)
  {
     TTreeNode * at_click = tree->GetNodeAt(X, Y);
     if(at_click)
        at_click->Selected = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TTreeListView::TLVMouseMove(
   TObject *Sender, TShiftState Shift, int X, int Y)
{
   //tree->Canvas->FillRect(Rect(300, 300, 600, 350));
   //string stuff = "(" + IntToString(X) + ", " + IntToString(Y) + ") " + IntToString((int)(tree->GetNodeAt(X, Y)));
   //tree->Canvas->TextOut(300, 300, stuff.c_str());
}
//---------------------------------------------------------------------------
void TTreeListView::RefreshHeaders()
{
   header->Sections->Clear();
   //Application->MessageBox(IntToString(column_data.size()).c_str(), "#cols", MB_OK);
   for (unsigned int i=0; i!= Columns->Count; i++)
   {
      if(Columns->ColumnByLogicalIndex(i)->Visible)
      {
         THeaderSection *sect = header->Sections->Add();
         sect->Text = Columns->ColumnByLogicalIndex(i)->Title.c_str();
         sect->Alignment = Columns->ColumnByLogicalIndex(i)->Alignment;
         sect->Width = Columns->ColumnByLogicalIndex(i)->Width;
         sect->MinWidth = 5;
      }
   }
   header->Repaint();
}
//---------------------------------------------------------------------------
TTreeNode * TTreeListView::AddRow(vector<string> data, add_row_method method, TTreeNode * node)
{
   TTreeNode *result;
   switch(method)
   {
     case sib_first:
        result = tree->Items->AddFirst(node, data[0].c_str()); break;
     case sib_last:
        result = tree->Items->Add(node, data[0].c_str()); break;
     case sib_previous:
        result = tree->Items->Insert(node, data[0].c_str()); break;
     case sib_next:      // TODO node->GetNext...
                         // if at sibling level, insert before sib node
                         // if at parent level, AddChild (last) from my parent node
                         // if NULL (at end of tree), ditto parent level case
                         // if at child level, GetNext node until one of the above three cases happen
        break;
     case child_first:
        result = tree->Items->AddChildFirst(node, data[0].c_str()); break;
     case child_last:
        result = tree->Items->AddChild(node, data[0].c_str()); break;
     default:
        result = NULL; break; // should never happen
   }
   // We have to add the columns in the correct order... they are passed to the
   // function in logical order (on screen) but they're stored in physical order
   // in row_data (in memory)... so, we convert... stuff.
   if(result)
   {
      // TODO:  Figure out what to really do here--I'm currently just copying
      // the data vector and rearranging only those values that have a column_index
      // entry and leaving the ones (on the end, for which columns haven't been
      // added yet) alone
      //vector<string> result_vec = data;
      //for(unsigned int i=0; i!= column_data.size(); i++)
      //   result_vec[column_data[i].position] = data[i];
      //for(int j=0; j!=result_vec.size(); j++)
      //   Application->MessageBox(result_vec[j].c_str(), IntToString(j).c_str(), MB_OK);
      //row_data[result] = result_vec;
      row_data[result] = data;
   }
   return result;
}
//---------------------------------------------------------------------------
string TTreeListView::GetColumnValue(TTreeNode * row_node, unsigned int column)
{
   // are there even that many columns -in- this row?
   //Application->MessageBox(IntToString(column_data[column].position).c_str(),
   //   IntToString(row_data[row_node].size()).c_str(), MB_OK);
   //if(Columns->ColumnByLogicalIndex(column)->LogicalIndex < row_data[row_node].size())
  if(row_node)
  {
    // is there a row of data for the given node?
    map<TTreeNode *, vector<string> >::iterator row = row_data.find(row_node);
    if (row != row_data.end())
    {
      // is the column even in the vector of data for this row?
      if(column < row->second.size())
        return row->second[column];
    }
  }
  return "";
}
//---------------------------------------------------------------------------
/*
column_data_type* TTreeListView::Column(string name)
{
   / *
   if(logical_index < column_data.size())
      return &(column_data[logical_index]);
   else
      return NULL;
   * /
   column_data_type* result;
   if (logical_index_lookup.find(name) != logical_index_lookup.end())
     result = &(column_data[logical_index_lookup[name]]);
   else
     result = NULL;
   return result;
}
*/
//---------------------------------------------------------------------------
void TTreeListView::GetRow(TTreeNode* node, map<string, string>& row)
{
   for (unsigned int i=0; i != Columns->Count; i++)
   {
      row[Columns->ColumnByLogicalIndex(i)->Title] = GetColumnValue(node, i);
   }
}
//---------------------------------------------------------------------------
void TTreeListView::GetSelectedRows(vector<map<string, string> >& rows)
{
// if we're not using BCB6, then we don't have multiselect treeviews
#if !defined(__BORLANDC__) || (__BORLANDC__ < 0x560)
   map<string, string> row;
   GetRow(tree->Selected, row);
   rows.push_back(row);
// otherwise we do, so go nuts
#else
   for (unsigned int i=0; i < tree->SelectionCount; i++)
   {
      map<string, string> row;
      GetRow(tree->Selections[i], row);
      rows.push_back(row);
   }
#endif
}
//---------------------------------------------------------------------------
void TTreeListView::Sort(THeaderSection *Column)
{
 tree->CustomSort(TTLVCompare, Column->Index);
}
//---------------------------------------------------------------------------
int __stdcall TTLVCompare(long Param1, long Param2, long columnToSort)
{
 TTreeNode * N1 = (TTreeNode*)Param1;
 TTreeNode * N2 = (TTreeNode*)Param2;
 TTreeListView * theTLV = (TTreeListView *)(N1->TreeView->Owner);

 if (theTLV)
   return theTLV->CompareByColumn (N1, N2, columnToSort);
 else
   return 0;
}
//---------------------------------------------------------------------------
int TTreeListView::CompareByColumn (TTreeNode* T1, TTreeNode* T2, long SortColumn)
{
  string s1, s2;

  s1 = GetColumnValue(T1, SortColumn);
  s2 = GetColumnValue(T2, SortColumn);

  // do the comparison, and flip it if we're not sorting ascending
  // (CompareByType assumes ascending)
  sort_method sm = Columns->ColumnByLogicalIndex(SortColumn)->SortAs;
  return CompareByType(s1, s2, sm) * (sort_asc? 1 : -1);
}
//---------------------------------------------------------------------------
int CompareByType (string in_a, string in_b, sort_method sort_type)
{
  string itemvalue = in_a;
  string i = in_b;

// If the information in the table is text, it will be sorted alphabetically.
// Or the information will be sorted by the date.
switch (sort_type)
 {
   case sort_text:
        {
                string a = itemvalue;
                string b = i;
                return TemplateCompare (a, b);
        }
   case sort_date:
         {
                Pdate a(itemvalue, global_mode);
                Pdate b(i, global_mode);
                return TemplateCompare (a, b);
         }
   case sort_int:
         {
                int a = StringToInt(itemvalue);
                int b = StringToInt(i);
                return TemplateCompare (a, b);
         }
   case sort_double:
         {
                 financial a = StringToFinancial(itemvalue);
                 financial b = StringToFinancial(i);
                 return TemplateCompare (a, b);
         }
   case sort_time:
         {
                 Ptime a(itemvalue, global_mode);
                 Ptime b(i, global_mode);
                 return TemplateCompare (a, b);
         }
   case sort_stamp:
         {
                 Pstamp a(itemvalue, global_mode);
                 Pstamp b(i, global_mode);
                 return TemplateCompare (a, b);
         }
   case sort_bool:
   {
     ;
   }
 }
 return 0;
}
//---------------------------------------------------------------------------
template <class T>
int TemplateCompare (T a, T b)
{
 if (a < b) return -1;
 if (a > b) return 1;
 return 0;
}
//---------------------------------------------------------------------------
bool TTreeListView::EditRow(vector<string> data, add_row_method method, TTreeNode * node)
{
   map<TTreeNode *, vector<string> >::iterator row = row_data.find(node);
   if (row != row_data.end())
   {
      row->second = data;
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------

