//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabLogsheetSummaryReport.h"
#include "reportDiabLogsheetSummary.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabLogsheetSummaryReport *formLaunchDiabLogsheetSummaryReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabLogsheetSummaryReport::TformLaunchDiabLogsheetSummaryReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
 dateBegin->Date = Now();
 dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabLogsheetSummaryReport::btnCloseClick(
      TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabLogsheetSummaryReport::btnRunClick(
      TObject *Sender)
{
  Processing(true);
  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;
    sql =  "select people.id, person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix name, "
           "activity_logsheets.date_turned_in, activity_logsheets.begin_date, activity_logsheets.end_date, "
           "count(activities.id) total "
           "from "
           "activity_logsheets inner join activities on activities.activity_logsheet_id = activity_logsheets.id "
           "inner join people on activity_logsheets.person_id = people.id "
           "left join person_names on people.person_names_id = person_names.id "
           "where "
           "exists (select enrollment.id from enrollment "   // jhaley: changed steps_member -> enrollment
            "where enrollment.person_id = people.id and enrollment.current_id+1 >= 4 and "
            "enrollment.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "STEPS Participant") + "' and "
            "enrollment.enrollment_status_id = '" + lookupTables->IdOf("enrollment_status_types", "Member") + "') and ";
    if (radioTurnedIn->Checked)
      sql += "activity_logsheets.date_turned_in between '" + begin_date + "' and '" + end_date + "' ";
    else if (radioBeginEnd->Checked)
      sql += "activity_logsheets.begin_date >= '" + begin_date + "' and "
             "activity_logsheets.end_date <= '" + end_date + "' ";
    sql += "group by person_names.last_name, person_names.first_name, person_names.suffix, people.id, activity_logsheets.date_turned_in, "
           "activity_logsheets.begin_date, activity_logsheets.end_date "
           "order by person_names.last_name, person_names.first_name";

    dbTransaction->StartTransaction();
    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportDiabLogsheetSummary * logsheetReport = new TformReportDiabLogsheetSummary(NULL);
      logsheetReport->logsheetReport->DataSet = dbDataSet;
      logsheetReport->lblDateTitle->Caption = date_title.c_str();
      logsheetReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      logsheetReport->txtName->DataSet = dbDataSet;
      logsheetReport->txtName->DataField = "name";
      logsheetReport->txtDateTurnedIn->DataSet = dbDataSet;
      logsheetReport->txtDateTurnedIn->DataField = "date_turned_in";
      logsheetReport->txtBeginDate->DataSet = dbDataSet;
      logsheetReport->txtBeginDate->DataField = "begin_date";
      logsheetReport->txtEndDate->DataSet = dbDataSet;
      logsheetReport->txtEndDate->DataField = "end_date";
      logsheetReport->txtTotalActivities->DataSet = dbDataSet;
      logsheetReport->txtTotalActivities->DataField = "total";
      logsheetReport->exprTotalActivities->Expression = "SUM(total)";
      Processing(false);
      logsheetReport->logsheetReport->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabLogsheetSummaryReport::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

