#include "action_factory_registry.h"
#include "codeActionGeneric.h"

set_action_factory_registry action_factories;

vector<a_factory_info> set_action_factory_registry::GetFactories (string source_table_name)
{
 vector<a_factory_info> answer;

 // use callbacks to determine appropriateness
 for (vector<a_factory_info>::iterator i = factories.begin(); i != factories.end(); i++)
  if (i->appropriate_pointer && i->appropriate_pointer(source_table_name))
   answer.push_back(*i);

 return answer;
}

void set_action_factory_registry::AddFactory (string description, string serialization_tag, a_factory_appropriate appropriate_pointer, a_factory_create create_pointer)
{
 a_factory_info temp;

 temp.description         = description;
 temp.serialization_tag   = serialization_tag;
 temp.appropriate_pointer = appropriate_pointer;
 temp.create_pointer      = create_pointer;

 // uniqueness check -- consider the "create_pointer" to be the PK (close enough?)
 for (vector<a_factory_info>::iterator i = factories.begin(); i != factories.end(); i++)
  if (i->create_pointer == create_pointer)
   return;

 // add if not otherwise found
 factories.push_back(temp);
}

a_factory_info set_action_factory_registry::GetFactoryByTag (string serialization_tag)
{
 for (vector<a_factory_info>::iterator i = factories.begin(); i != factories.end(); i++)
  if (i->serialization_tag == serialization_tag)
   return *i;
 return a_factory_info();
}

string set_action_factory_registry::GetTagByFactory (a_factory_create create_pointer)
{
 for (vector<a_factory_info>::iterator i = factories.begin(); i != factories.end(); i++)
  if (i->create_pointer == create_pointer)
   return i->serialization_tag;
 return "";
}

