#ifndef action_factory_registry_h
#define action_factory_registry_h

#include <string>
#include <vector>
#include <map>
#include <set>
using namespace std;

#include <Classes.hpp>

class TframeActionGeneric;

typedef TframeActionGeneric* (*a_factory_create)(Classes::TComponent*);
typedef bool (*a_factory_appropriate)(string);

struct  a_factory_info
{
 string                description;
 string                serialization_tag;
 a_factory_appropriate appropriate_pointer;
 a_factory_create      create_pointer;
};

class set_action_factory_registry
{
 public:
 private:
  vector<a_factory_info> factories;
 public:
  vector<a_factory_info> GetFactories (string source_table_name);
  void AddFactory (string description, string serialization_tag, a_factory_appropriate appropriate_pointer, a_factory_create create_pointer);
  a_factory_info GetFactoryByTag (string serialization_tag);
  string GetTagByFactory (a_factory_create create_pointer);
};

extern set_action_factory_registry action_factories;

#endif
 