//---------------------------------------------------------------------------


#ifndef codeActionContainerH
#define codeActionContainerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "util.h"
#include "action_factory_registry.h"
class TframeActionGeneric;
//---------------------------------------------------------------------------
class TframeActionContainer : public TFrame
{
__published:	// IDE-managed Components
        TScrollBox *scrollActions;
        TPanel *panelTop;
        TComboBox *comboPicker;
        TButton *buttonAddAction;
        TPanel *panelBottom;
        TButton *buttonLoad;
        TButton *buttonSave;
        void __fastcall buttonAddActionClick(TObject *Sender);
        void __fastcall scrollActionsMouseWheelDown(TObject *Sender,
          TShiftState Shift, TPoint &MousePos, bool &Handled);
        void __fastcall scrollActionsMouseWheelUp(TObject *Sender,
          TShiftState Shift, TPoint &MousePos, bool &Handled);
        void __fastcall comboPickerKeyPress(TObject *Sender, char &Key);
        void __fastcall buttonLoadClick(TObject *Sender);
        void __fastcall buttonSaveClick(TObject *Sender);
private:	// User declarations
protected:
        vector<TframeActionGeneric*> FHostedActions;
        friend TframeActionGeneric;
        void AddAction(TframeActionGeneric* Action);
        void DelAction(TframeActionGeneric* Action);

        vector<a_factory_info> picker_content;
        AnsiString FSourceTableName;

        void __fastcall SetSourceTableName (AnsiString Value);
        void __fastcall DeleteHostedAction(TMessage &Message);

        #define WM_DELETE_HOSTED_ACTION (WM_USER + 2188)
        BEGIN_MESSAGE_MAP
         MESSAGE_HANDLER(WM_DELETE_HOSTED_ACTION, TMessage, DeleteHostedAction)
        END_MESSAGE_MAP(TFrame)
public:		// User declarations
        void ReArrange();
        bool RequestAction (a_factory_create desired_action);
        __fastcall TframeActionContainer(TComponent* Owner);
        __fastcall ~TframeActionContainer();
        bool virtual Execute (TIBTransaction* dbTransaction, string source_view_name);
        bool virtual Single ();
        bool virtual Valid ();
        string Save (bool with_params);
        void Load (string config, bool with_params);
__published:
        __property AnsiString SourceTableName = {read = FSourceTableName, write = SetSourceTableName};
};
//---------------------------------------------------------------------------
extern PACKAGE TframeActionContainer *frameActionContainer;
//---------------------------------------------------------------------------
#endif
