//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeAction_Count.h"
#include "utilityheaders.h"
#include "db_hardcoded_metadata.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeActionGeneric"
#pragma resource "*.dfm"
TframeAction_Count *frameAction_Count;
//---------------------------------------------------------------------------
__fastcall TframeAction_Count::TframeAction_Count(TComponent* Owner)
        : TframeActionGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
}
//---------------------------------------------------------------------------
bool TframeAction_Count::Execute (TIBTransaction* dbTransaction, string source_view_name)
{
 string c = GetOneField(dbTransaction, "select count(id) from " + source_view_name);
 if (IsInt(c))
 {
  PSay(c + " " + LowercaseString(dbPrettyPlural(LowercaseString(SourceTableName.c_str()))) + " were found.", m_message, MB_OK, "TframeAction_Count");
  return true;
 } else
 {
  PSay("There was an error while counting " + LowercaseString(dbPrettyPlural(LowercaseString(SourceTableName.c_str()))) + ".", m_database_error, MB_OK, "TframeAction_Count");
  return false;
 }
}
//---------------------------------------------------------------------------
bool TframeAction_Count::Valid ()
{
 return true /* ole! */;
}
//---------------------------------------------------------------------------
TframeActionGeneric* TframeAction_Count::Create (TComponent* owner)
{
 TframeActionGeneric* temp;
 FORM_TRY
  temp = new TframeAction_Count(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeAction_Count::Appropriate (string source_table_name)
{
 return dbIsAvailable(source_table_name);
}
//---------------------------------------------------------------------------
void __fastcall TframeAction_Count::SetSourceTableName (AnsiString Value)
{
 TframeActionGeneric::SetSourceTableName(Value);
 _labelDescription->Caption = ("Count " + LowercaseString(dbPrettyPlural(LowercaseString(SourceTableName.c_str())))).c_str();
}
//---------------------------------------------------------------------------
