//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeAction__PeopleInListview.h"
#include "codeSpecialListview.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeActionGeneric"
#pragma resource "*.dfm"
TframeAction__PeopleInListview *frameAction__PeopleInListview;
//---------------------------------------------------------------------------
__fastcall TframeAction__PeopleInListview::TframeAction__PeopleInListview(TComponent* Owner)
        : TframeActionGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;
}
//---------------------------------------------------------------------------
bool TframeAction__PeopleInListview::Execute (TIBTransaction* dbTransaction, string source_view_name)
{
 FORM_TRY
  TformSpecialListview* z = new TformSpecialListview(NULL);

  z->Filter->SetSecurity("people");
  z->Filter->AddColumnSpec("Last Name", "people", as_text, true, 100);
  z->Filter->AddColumnSpec("First Name", "people", as_text, true, 100);
  z->Filter->AddColumnSpec("Middle Name", "people", as_text, false, 100);
  z->Filter->AddColumnSpec("Suffix", "people", as_text, true, 50);
  z->Filter->AddColumnSpec("CDIB", "affiliations", as_text, true, 70, lowercaseString);
  z->Filter->AddColumnSpec("Tribe", "affiliations", as_text, true, 115);
  z->Filter->AddColumnSpec("Joined", "affiliations", as_date, true, 80);
  z->Filter->AddColumnSpec("Relinquished", "affiliations", as_date, true, 80);
  z->Filter->AddColumnSpec("Birthday", "people", as_date, true, 80);
  z->Filter->AddColumnSpec("SSN", "people", as_text, true, 90, prettySSNString);
  z->Filter->AddColumnSpec("Chart Num", "charts", as_text, false, 90);
  z->Filter->AddColumnSpec("Code", "conditions", as_text, false, 90);
  z->Filter->AddColumnSpec("Address", "person_contact_info", as_text, false, 140, addressString);
  z->Filter->AddColumnSpec("City", "person_contact_info", as_text, false, 80);
  z->Filter->AddColumnSpec("State", "person_contact_info", as_text, false, 80, uppercaseString);
  z->Filter->AddColumnSpec("Zip", "person_contact_info", as_text, false, 80, prettyZipString);
  z->Filter->AddColumnSpec("Phone Number", "person_contact_info", as_text, false, 120, prettyPhoneString);
  z->Filter->AddColumnSpec("Gender", "people", as_text, false, 80);
  z->Filter->AddColumnSpec("Client Type", "people", as_text, false, 80);
  z->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  z->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  z->Filter->SetIconStatus(true);
  z->SourceTableName = "people";

  // stolen from codeSearchPerson
  set<string> can_see_charts = GetSpecialGroupPermissions("charts");
  string sql =
        "select "
        "person_names.last_name, person_names.first_name, person_names.middle_name, "
        "person_names.suffix, affiliations.cdib, "
        "tribe_types.item tribe, affiliations.join_date, affiliations.relinquish_date, "
        "people.birth_date, people.social_security_number, "
        "(select first 1 charts.chart_number from charts "
        "inner join groups on charts.location_id = groups.chart_location_id and groups.has_charts = 1 and charts.location_id > 0 "
        "where charts.person_id = people.id and " + SafeInClause("groups.id", SetToVec(can_see_charts)) +
/*
 if(optionsPermissions["special.lac.charts"]["enabled"] == "true")
   sql += " and charts.group_id = " + lookupTables->IdOf("groups", "Little Axe Clinic");
 else if(optionsPermissions["special.sc.charts"]["enabled"] == "true")
   sql += " and charts.group_id = " + lookupTables->IdOf("groups", "Shawnee Clinic");
 else if(optionsPermissions["special.den.charts"]["enabled"] == "true")
   sql += " and charts.group_id = " + lookupTables->IdOf("groups", "Little Axe Clinic");
 else if((optionsPermissions["special.cob.general"]["enabled"] == "true") ||
   (optionsPermissions["special.bill.general"]["enabled"] == "true") ||
   (optionsPermissions["special.res.general"]["enabled"] == "true"))
   sql += " and charts.group_id = " + lookupTables->IdOf("groups", "Contract Health");
*/
        " and charts.current_id > 2 order by groups.hl7_priority asc nulls last) chart_num, "
        "(select first 1 conditions.code from conditions "
        "where conditions.person_id = people.id) code_num, "
        "person_contact_info.line1, person_contact_info.city, "
        "state_types.item state, person_contact_info.zip, "
        "person_contact_info.phone_number, gender_types.item, enrollment_status_types.item, "
        "people.current_id, people.id "
        "from people "
        "inner join " + source_view_name + " on people.id = " + source_view_name + ".id "
        "left join affiliations on affiliations.id = people.affiliations_id "
        "left join tribe_types on affiliations.tribe_id = tribe_types.id "
        "left join person_names on person_names.id = people.person_names_id "
        "left join person_contact_info on person_contact_info.id = people.person_contact_info_id "
        "left join state_types on person_contact_info.state_id = state_types.id "
        "left join gender_types on people.gender_id = gender_types.id "
        "left join enrollment on enrollment.person_id = people.id and enrollment.current_id+1 >= 4 and " // jhaley: changed diab_client_id -> enrollment
        " enrollment.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "' "
        "left join enrollment_status_types on enrollment.enrollment_status_id = enrollment_status_types.id ";
  z->Execute(dbTransaction, sql);
 FORM_CATCH

 return /* bloody */ true;
}
//---------------------------------------------------------------------------
bool TframeAction__PeopleInListview::Valid ()
{
 return true;
}
//---------------------------------------------------------------------------
TframeActionGeneric* TframeAction__PeopleInListview::Create (TComponent* owner)
{
 TframeActionGeneric* temp;
 FORM_TRY
  temp = new TframeAction__PeopleInListview(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeAction__PeopleInListview::Appropriate (string source_table_name)
{
 // technically, I don't care about permissions -- they won't have any data to play with.
 return (source_table_name == "people") && (optionsPermissions["table.people"]["view"] == "true");
}
//---------------------------------------------------------------------------
