//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeAction__PersonAudit.h"
#include "reportPersonAudit.h"
#include "query_load_save.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeActionGeneric"
#pragma link "codeSectionsGeneric"
#pragma link "codeFrameCodeTaxonomy"
#pragma link "codeSoftDropShadow"
#pragma resource "*.dfm"
TframeAction__PersonAudit *frameAction__PersonAudit;
//---------------------------------------------------------------------------
__fastcall TframeAction__PersonAudit::TframeAction__PersonAudit(TComponent* Owner)
        : TframeActionGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;

 string location_groups_sql = "select id, item, valid from groups where has_charts = 1 or id = 0 order by item"; // clinics have charts
 lookupTables->RegisterComboBox("groups", comboPersonChartLocation, location_groups_sql);

 taxonomyConditionCodes->Type = txn_condition;
 taxonomyProcedureCodes->Type = txn_procedure;

 list_conditions.setup_listview(listConditions, false);
 list_conditions.add_or_modify_column("category", "Category", true, 0, 100, as_text, rawString);
 list_conditions.add_or_modify_column("codes",    "Codes",   false, 1, 100, as_text, rawString);
 list_conditions.add_or_modify_column("note",     "Show",     true, 2, 100, as_text, rawString);
 list_conditions.add_or_modify_column("subset",   "Subset",  false, 3, 100, as_int,  rawString);
 list_conditions.add_or_modify_column("count",    "Count",   false, 4, 100, as_int,  rawString);
 list_conditions.setup_callbacks((TFrame*)this, InformForm(&(TframeAction__PersonAudit::ConditionSelected)), NULL);

 list_procedures.setup_listview(listProcedures, false);
 list_procedures.add_or_modify_column("category", "Category", true, 0, 100, as_text, rawString);
 list_procedures.add_or_modify_column("codes",    "Codes",   false, 1, 100, as_text, rawString);
 list_procedures.add_or_modify_column("note",     "Show",     true, 2, 100, as_text, rawString);
 list_procedures.add_or_modify_column("subset",   "Subset",  false, 3, 100, as_int,  rawString);
 list_procedures.add_or_modify_column("count",    "Count",   false, 4, 100, as_int,  rawString);
 list_procedures.setup_callbacks((TFrame*)this, InformForm(&(TframeAction__PersonAudit::ProcedureSelected)), NULL);

 list_measurements.setup_listview(listMeasurements, false);
 list_measurements.add_or_modify_column("id",       "Obs Id", false, 0,  60, as_int,  rawString);
 list_measurements.add_or_modify_column("meas",     "Metric",  true, 1, 100, as_text, rawString);
 list_measurements.add_or_modify_column("note",     "Show",    true, 2, 100, as_text, rawString);
 list_measurements.add_or_modify_column("subset",   "Subset", false, 3, 100, as_int,  rawString);
 list_measurements.add_or_modify_column("count",    "Count",  false, 4, 100, as_int,  rawString);
 list_measurements.setup_callbacks((TFrame*)this, InformForm(&(TframeAction__PersonAudit::MeasurementSelected)), NULL);

 // pre-fill measurement list (also needs to be done if doing a Load(), so consider a separate function!)

/*
 sectionPerson->Open = false;
 sectionConditions->Open = false;
 sectionProcedures->Open = false;
 sectionMeasurements->Open = false;

 sectionConditions->Enabled = (optionsPermissions["table.conditions"]["view"] == "true");
 sectionProcedures->Enabled = (optionsPermissions["table.procedures"]["view"] == "true");
 sectionMeasurements->Enabled = (optionsPermissions["table.obs_response_sets"]["view"] == "true");
*/
 sheetConditions->Enabled = (optionsPermissions["table.conditions"]["view"] == "true");
 sheetProcedures->Enabled = (optionsPermissions["table.procedures"]["view"] == "true");
 sheetObservations->Enabled = (optionsPermissions["table.obs_response_sets"]["view"] == "true");
}
//---------------------------------------------------------------------------
__fastcall TframeAction__PersonAudit::~TframeAction__PersonAudit()
{
 lookupTables->UnregisterComboBox(comboPersonChartLocation);
}
//---------------------------------------------------------------------------
bool TframeAction__PersonAudit::Valid ()
{
 comboPersonChartLocation->Color = clWindow;

 bool result = true;

 if (!lookupTables->IsInLookUpTable("groups", comboPersonChartLocation))
 {
  comboPersonChartLocation->Color = clBad;
  result = false;
 }
 
 return result;
}
//---------------------------------------------------------------------------
TframeActionGeneric* TframeAction__PersonAudit::Create (TComponent* owner)
{
 TframeActionGeneric* temp;
 FORM_TRY
  temp = new TframeAction__PersonAudit(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeAction__PersonAudit::Appropriate (string source_table_name)
{
 // technically, I don't care about permissions -- they won't have any data to play with.
 return (source_table_name == "people") && (optionsPermissions["table.people"]["view"] == "true");
}
//---------------------------------------------------------------------------
bool TframeAction__PersonAudit::Execute (TIBTransaction* dbTransaction, string source_view_name)
{
 xValue temp = Save(true);
 TformReportPersonAudit::Do(dbTransaction, source_view_name, temp);
 return /* bloody */ true;
}
//---------------------------------------------------------------------------
xValue TframeAction__PersonAudit::Save (bool with_params)
{
 // you know, this with_params thing ... seems kinda stupid now, doesn't it. yup. ("copy blank"? what was i thinking?)
 // TODO: what -doesn't- seem stupid is going back and figuring out how the -hell- i'm going to set up globals now that i use size-before-content rather than escape characters...
 map<string, xValue> config_map;
 if (with_params)
 {
  config_map["person_chart_location_id"] = xFromString(lookupTables->IdOf("groups", comboPersonChartLocation));

  vector<xValue> xconditions;
  vector<map<string, string> > conditions;
  list_conditions.export_data(conditions);
  for (vector<map<string, string> >::iterator i = conditions.begin(); i != conditions.end(); i++)
  {
   map<string, xValue> condition;
   condition["category"] = xFromString((*i)["category"]);
   condition["codes"]    = xFromCodeDescription((*i)["codes"]);
   condition["subset"]   = xFromInt(StringToInt((*i)["subset"]));
   if (IsInt((*i)["count"]))
    condition["count"]   = xFromInt(StringToInt((*i)["count"]));
   xconditions.push_back(xFromMap(condition));
  }
  config_map["conditions"] = xFromVec(xconditions);

  vector<xValue> xprocedures;
  vector<map<string, string> > procedures;
  list_procedures.export_data(procedures);
  for (vector<map<string, string> >::iterator i = procedures.begin(); i != procedures.end(); i++)
  {
   map<string, xValue> procedure;
   procedure["category"] = xFromString((*i)["category"]);
   procedure["codes"]    = xFromCodeDescription((*i)["codes"]);
   procedure["subset"]   = xFromInt(StringToInt((*i)["subset"]));
   if (IsInt((*i)["count"]))
    procedure["count"]   = xFromInt(StringToInt((*i)["count"]));
   xprocedures.push_back(xFromMap(procedure));
  }
  config_map["procedures"] = xFromVec(xprocedures);

  vector<xValue> xmeasurements;
  vector<map<string, string> > measurements;
  list_measurements.export_data(measurements);
  for (vector<map<string, string> >::iterator i = measurements.begin(); i != measurements.end(); i++)
  {
   map<string, xValue> measurement;
   // measurement["meas"] = xFromString((*i)["meas"]);
   measurement["id"]     = xFromString((*i)["id"]);
   measurement["subset"] = xFromInt(StringToInt((*i)["subset"]));
   if (IsInt((*i)["count"]))
    measurement["count"] = xFromInt(StringToInt((*i)["count"]));
   if (IsInt((*i)["subset"]) && StringToInt((*i)["subset"]) > 0) // only if relevant -- ignore other cases
    xmeasurements.push_back(xFromMap(measurement));
  }
  config_map["measurements"] = xFromVec(xmeasurements);
 }
 return xFromMap(config_map);
}
//---------------------------------------------------------------------------
void TframeAction__PersonAudit::Load (xValue config, bool with_params)
{
 map<string, xValue> config_map = xToMap(config);
 if (with_params)
 {
  comboPersonChartLocation->Text = lookupTables->ValueOf("groups", xToString(config_map["person_chart_location_id"])).c_str();

  // conditions -------------------------

  vector<xValue> xconditions = xToVec(config_map["conditions"]);
  vector<map<string, string> > conditions;
  for (vector<xValue>::iterator i = xconditions.begin(); i != xconditions.end(); i++)
  {
   map<string, xValue> j = xToMap(*i);
   map<string, string> condition;
   condition["category"] = xToString(j["category"]);
   condition["codes"]    = xToCodeDescription(j["codes"]);
   condition["subset"]   = IntToString(xToInt(j["subset"]));
   condition["count"]    = IntToString(xToInt(j["count"]));
   if (xToInt(j["subset"]) > -1 && xToInt(j["subset"]) < comboConditionSubset->Items->Count)
   {
    condition["note"] = comboConditionSubset->Items->Strings[xToInt(j["subset"])].c_str();
    if (xToInt(j["subset"]) > 0)
     condition["note"] += string(" ") + IntToString(xToInt(j["count"]));
   }
   conditions.push_back(condition);
  }
  list_conditions.clear_data();
  list_conditions.import_data(conditions);

  // procedures -------------------------

  vector<xValue> xprocedures = xToVec(config_map["procedures"]);
  vector<map<string, string> > procedures;
  for (vector<xValue>::iterator i = xprocedures.begin(); i != xprocedures.end(); i++)
  {
   map<string, xValue> j = xToMap(*i);
   map<string, string> procedure;
   procedure["category"] = xToString(j["category"]);
   procedure["codes"]    = xToCodeDescription(j["codes"]);
   procedure["subset"]   = IntToString(xToInt(j["subset"]));
   procedure["count"]    = IntToString(xToInt(j["count"]));
   if (xToInt(j["subset"]) > -1 && xToInt(j["subset"]) < comboProcedureSubset->Items->Count)
   {
    procedure["note"] = comboProcedureSubset->Items->Strings[xToInt(j["subset"])].c_str();
    if (xToInt(j["subset"]) > 0)
     procedure["note"] += string(" ") + IntToString(xToInt(j["count"]));
   }
   procedures.push_back(procedure);
  }
  list_procedures.clear_data();
  list_procedures.import_data(procedures);

  // measurements -----------------------

  vector<xValue> xmeasurements = xToVec(config_map["measurements"]);
  vector<map<string, string> > measurements;
  if (!SqlToVecMap(dbDatabase, "select id, item meas from obs_questions where id > 0 and valid = 1" /* and obs_questions.id in (select obs_questions_in_sets.obs_question_id from obs_questions_in_sets inner join obs_question_set_types oqs on oqs.id = obs_questions_in_sets.obs_question_set_id inner join permissions p on p.s = oqs.permission_name and p.k = 'VIEW' and p.v = 'TRUE' and p.user_id = " + current_userid + ") "*/, measurements))
   PSay("Failed to retrieve the list of possible observations.", m_database_error, MB_OK, "TframeAction__PersonAudit");
  for (vector<xValue>::iterator i = xmeasurements.begin(); i != xmeasurements.end(); i++)
  {
   map<string, xValue> o = xToMap(*i);
   string meas_id = xToString(o["id"]);
   for (vector<map<string, string> >::iterator j = measurements.begin(); j != measurements.end(); j++)
    if ((*j)["id"] == meas_id)
    {
     (*j)["subset"]   = IntToString(xToInt(o["subset"]));
     (*j)["count"]    = IntToString(xToInt(o["count"]));
     if (xToInt(o["subset"]) > -1 && xToInt(o["subset"]) < comboMeasurementSubset->Items->Count)
     {
      (*j)["note"] = comboMeasurementSubset->Items->Strings[xToInt(o["subset"])].c_str();
      if (xToInt(o["subset"]) > 2)
       (*j)["note"] += string(" ") + IntToString(xToInt(o["count"]));
     }
    }
  }

  list_measurements.clear_data();
  list_measurements.import_data(measurements);
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::buttonSettingsLoadClick(TObject *Sender)
{
 xValue possibly_loaded = QueryLoad(this->SourceTableName, qf_action);
 if (!possibly_loaded.empty())
  if (xTag(possibly_loaded) == "TframeAction__PersonAudit")
   Load(xContent(possibly_loaded), true);
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::buttonSettingsSaveClick(TObject *Sender)
{
 if (Valid())
  QuerySave(this->SourceTableName, qf_action, xVal("TframeAction__PersonAudit", this->Save(true)));
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::comboConditionSubsetChange(TObject *Sender)
{
 editConditionCount->Enabled = (comboConditionSubset->ItemIndex > 0);
 if (editConditionCount->Enabled && editConditionCount->Text == "")
  editConditionCount->Text = "5";
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::comboProcedureSubsetChange(TObject *Sender)
{
 editProcedureCount->Enabled = (comboProcedureSubset->ItemIndex > 0);
 if (editProcedureCount->Enabled && editProcedureCount->Text == "")
  editProcedureCount->Text = "5";
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::comboMeasurementSubsetChange(TObject *Sender)
{
 // none, all, all (averaged) -- no need for a 'count'
 editMeasurementCount->Enabled = (comboMeasurementSubset->ItemIndex > 2);
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::buttonConditionAddClick(TObject *Sender)
{
 // add condition
 listConditions->Selected = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::buttonConditionRemoveClick(TObject *Sender)
{
 // remove condition
 list_conditions.remove_current_row(true);
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::buttonConditionClearClick(TObject *Sender)
{
 // clear condition
 list_conditions.clear_data();
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::buttonConditionSaveClick(TObject *Sender)
{
 // save condition

 if (editConditionCategory->Text == "")
 {
  PSay("Please enter a category name.", m_missing_data, MB_OK, "TframeAction__PersonAudit");
  return;
 }

 if (taxonomyConditionCodes->Text == "")
 {
  PSay("Please enter one or more condition codes.", m_missing_data, MB_OK, "TframeAction__PersonAudit");
  return;
 }

 if (comboConditionSubset->ItemIndex == -1)
 {
  PSay("Please enter a subset selection (dropdown).", m_missing_data, MB_OK, "TframeAction__PersonAudit");
  return;
 }

 if (editConditionCount->Enabled && (editConditionCount->Text == "" || !IsInt(editConditionCount->Text.c_str()) || StringToInt(editConditionCount->Text.c_str()) < 1))
 {
  PSay("Please enter a number of conditions to show for this category.", m_missing_data, MB_OK, "TframeAction__PersonAudit");
  return;
 }

 map<string, string> row_data;
 row_data["category"] = editConditionCategory->Text.c_str();
 row_data["codes"]    = taxonomyConditionCodes->Text;
 row_data["subset"]   = IntToString(comboConditionSubset->ItemIndex);
 row_data["count"]    = editConditionCount->Enabled ? editConditionCount->Text.c_str() : "";
 row_data["note"]     = comboConditionSubset->Text.c_str();
 if (editConditionCount->Enabled)
  row_data["note"] += string(" ") + editConditionCount->Text.c_str();

 set<string> dupe_columns;
 dupe_columns.insert("category");
 if (list_conditions.is_future_duplicate (row_data, dupe_columns))
 {
  PSay("Saving this row as it is would create a duplicate entry in the list.\nYou may not have two rows with the same category name.", m_duplicate_data, MB_OK, "TframeAction__PersonAudit");
  return;
 }

 list_conditions.add_or_modify_row_data(row_data, false);
 listConditions->Selected = NULL;

 if (IsVisible(editConditionCategory) && editConditionCategory->Enabled)
  editConditionCategory->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::comboConditionSubsetKeyPress(TObject *Sender, char &Key)
{
 FindComboBoxItem(Sender, Key);
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::comboProcedureSubsetKeyPress(TObject *Sender, char &Key)
{
 FindComboBoxItem(Sender, Key);
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::comboMeasurementSubsetKeyPress(TObject *Sender, char &Key)
{
 FindComboBoxItem(Sender, Key);
}
//---------------------------------------------------------------------------
void TframeAction__PersonAudit::ConditionSelected ()
{
 // select condition
 map<string, string> row_data;
 if (!list_conditions.get_current_row(row_data))
 {
  // set default values
  row_data["category"] = "";
  row_data["codes"]    = "";
  row_data["subset"]   = "2";
  row_data["count"]    = "5";
 }

 // update controls to reflect data in row_data
 editConditionCategory->Text     = row_data["category"].c_str();
 taxonomyConditionCodes->Text    = row_data["codes"].c_str();
 editConditionCount->Text        = row_data["count"].c_str();
 comboConditionSubset->ItemIndex = StringToInt(row_data["subset"]);
 comboConditionSubset->OnChange(comboConditionSubset);

// if (IsVisible(editConditionCategory) && editConditionCategory->Enabled)
//  editConditionCategory->SetFocus();
}
//---------------------------------------------------------------------------
void TframeAction__PersonAudit::ProcedureSelected ()
{
 // select procedure
 map<string, string> row_data;
 if (!list_procedures.get_current_row(row_data))
 {
  // set default values
  row_data["category"] = "";
  row_data["codes"]    = "";
  row_data["subset"]   = "2";
  row_data["count"]    = "5";
 }

 // update controls to reflect data in row_data
 editProcedureCategory->Text     = row_data["category"].c_str();
 taxonomyProcedureCodes->Text    = row_data["codes"].c_str();
 editProcedureCount->Text        = row_data["count"].c_str();
 comboProcedureSubset->ItemIndex = StringToInt(row_data["subset"]);
 comboProcedureSubset->OnChange(comboProcedureSubset);

 // if (IsVisible(editProcedureCategory) && editProcedureCategory->Enabled)
 //  editProcedureCategory->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::buttonProcedureAddClick(TObject *Sender)
{
 // add procedure
 listProcedures->Selected = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::buttonProcedureRemoveClick(TObject *Sender)
{
 // remove procedure
 list_procedures.remove_current_row(true);
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::buttonProcedureClearClick(TObject *Sender)
{
 // clear procedure
 list_procedures.clear_data();
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::buttonProcedureSaveClick(TObject *Sender)
{
 // save procedure

 if (editProcedureCategory->Text == "")
 {
  PSay("Please enter a category name.", m_missing_data, MB_OK, "TframeAction__PersonAudit");
  return;
 }

 if (taxonomyProcedureCodes->Text == "")
 {
  PSay("Please enter one or more procedure codes.", m_missing_data, MB_OK, "TframeAction__PersonAudit");
  return;
 }

 if (comboProcedureSubset->ItemIndex == -1)
 {
  PSay("Please enter a subset selection (dropdown).", m_missing_data, MB_OK, "TframeAction__PersonAudit");
  return;
 }

 if (editProcedureCount->Enabled && (editProcedureCount->Text == "" || !IsInt(editProcedureCount->Text.c_str()) || StringToInt(editProcedureCount->Text.c_str()) < 1))
 {
  PSay("Please enter a number of procedures to show for this category.", m_missing_data, MB_OK, "TframeAction__PersonAudit");
  return;
 }

 map<string, string> row_data;
 row_data["category"] = editProcedureCategory->Text.c_str();
 row_data["codes"]    = taxonomyProcedureCodes->Text;
 row_data["subset"]   = IntToString(comboProcedureSubset->ItemIndex);
 row_data["count"]    = editProcedureCount->Enabled ? editProcedureCount->Text.c_str() : "";
 row_data["note"]     = comboProcedureSubset->Text.c_str();
 if (editProcedureCount->Enabled)
  row_data["note"] += string(" ") + editProcedureCount->Text.c_str();

 set<string> dupe_columns;
 dupe_columns.insert("category");
 if (list_procedures.is_future_duplicate (row_data, dupe_columns))
 {
  PSay("Saving this row as it is would create a duplicate entry in the list.\nYou may not have two rows with the same category name.", m_duplicate_data, MB_OK, "TframeAction__PersonAudit");
  return;
 }

 list_procedures.add_or_modify_row_data(row_data, false);
 listProcedures->Selected = NULL;

 if (IsVisible(editProcedureCategory) && editProcedureCategory->Enabled)
  editProcedureCategory->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::buttonMeasurementSaveClick(TObject *Sender)
{
 //
 // something -must- be selected before we can hit save!
/*
 list_measurements.add_or_modify_column("meas",     "Metric",  true, 0, 100, as_text, rawString);
 list_measurements.add_or_modify_column("note",     "Show",    true, 1, 100, as_text, rawString);
 list_measurements.add_or_modify_column("subset",   "Subset", false, 2, 100, as_int,  rawString);
 list_measurements.add_or_modify_column("count",    "Count",  false, 3, 100, as_int,  rawString);
*/
 // save measurement

 if (comboMeasurementSubset->ItemIndex == -1)
 {
  PSay("Please enter a subset selection (dropdown).", m_missing_data, MB_OK, "TframeAction__PersonAudit");
  return;
 }

 if (editMeasurementCount->Enabled && (editMeasurementCount->Text == "" || !IsInt(editMeasurementCount->Text.c_str()) || StringToInt(editMeasurementCount->Text.c_str()) < 1))
 {
  PSay("Please enter a number of measurements to show for this category.", m_missing_data, MB_OK, "TframeAction__PersonAudit");
  return;
 }

 map<string, string> row_data;
 list_measurements.get_current_row(row_data);
 row_data["subset"] = IntToString(comboMeasurementSubset->ItemIndex);
 row_data["count"]  = editMeasurementCount->Enabled ? editMeasurementCount->Text.c_str() : "";
 if (comboMeasurementSubset->ItemIndex != 0)
 {
  row_data["note"]     = comboMeasurementSubset->Text.c_str();
  if (editMeasurementCount->Enabled)
   row_data["note"] += string(" ") + editMeasurementCount->Text.c_str();
 } else
 {
  row_data["note"]  = "";
  row_data["count"] = "";
 }

 // terribly unlikely
 set<string> dupe_columns;
 dupe_columns.insert("id");
 if (list_measurements.is_future_duplicate (row_data, dupe_columns))
 {
  PSay("Saving this row as it is would create a duplicate entry in the list.\nYou may not have two rows for the same measurement.", m_duplicate_data, MB_OK, "TframeAction__PersonAudit");
  return;
 }

 list_measurements.add_or_modify_row_data(row_data, true); // move to next item, as we're editing a pre-made list of items
 // don't do any of the other things we normally do here, as we're advancing through the list. controls will get selected by MeasurementSelected

 if (IsVisible(comboMeasurementSubset) && comboMeasurementSubset->Enabled)
  comboMeasurementSubset->SetFocus();
}
//---------------------------------------------------------------------------
void TframeAction__PersonAudit::MeasurementSelected ()
{
 // select measurement
 map<string, string> row_data;
 if (!list_measurements.get_current_row(row_data))
 {
  // set default values
  row_data["id"]       = "0";
  row_data["meas"]     = "";
  row_data["subset"]   = "0";
  row_data["count"]    = "99";
  buttonMeasurementSave->Enabled = false;
  editMeasurementCount->Enabled = false;
  comboMeasurementSubset->Enabled = false;
 } else
 {
  buttonMeasurementSave->Enabled = true;
  comboMeasurementSubset->Enabled = true;
 }

 // update controls to reflect data in row_data
 editMeasurementCount->Text        = row_data["count"].c_str();
 comboMeasurementSubset->ItemIndex = StringToInt(row_data["subset"]);
 comboMeasurementSubset->OnChange(comboMeasurementSubset);

// if (IsVisible(comboMeasurementSubset) && comboMeasurementSubset->Enabled)
//  comboMeasurementSubset->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__PersonAudit::sheetObservationsShow(TObject *Sender)
{
 // apparently, if you load data into an edit_listview during the constructor, the pointers to rows don't match up or somesuch crap? it acted like no rows were valid when clicking on them ... weird.
 // moved from the sectionGeneric "OnOpen" event.
 if (listMeasurements->Items->Count == 0)
 {
  vector<map<string, string> > measurements_possible;
  if (!SqlToVecMap(dbDatabase, "select id, item meas from obs_questions where id > 0 and valid = 1" /* and obs_questions.id in (select obs_questions_in_sets.obs_question_id from obs_questions_in_sets inner join obs_question_set_types oqs on oqs.id = obs_questions_in_sets.obs_question_set_id inner join permissions p on p.s = oqs.permission_name and p.k = 'VIEW' and p.v = 'TRUE' and p.user_id = " + current_userid + ") "*/, measurements_possible))
   PSay("Failed to retrieve the list of possible observations.", m_database_error, MB_OK, "TframeAction__PersonAudit");
  list_measurements.clear_data();
  list_measurements.import_data(measurements_possible);
 }
 ((TTabSheet*)Sender)->OnShow = NULL;
}
//---------------------------------------------------------------------------

