//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeAction__YearlyMeasurementSummary.h"
#include "reportYearlyMeasurementSummary.h"
#include "query_load_save.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeActionGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TframeAction__YearlyMeasurementSummary *frameAction__YearlyMeasurementSummary;
//---------------------------------------------------------------------------
__fastcall TframeAction__YearlyMeasurementSummary::TframeAction__YearlyMeasurementSummary(TComponent* Owner)
        : TframeActionGeneric(Owner)
{
 FHowAppropriate = Appropriate;
 FHowCreate = Create;

 question_filter.SetListViewHandle(listQuestions);
 question_filter.SetSecurity("obs_questions");
 question_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 question_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 question_filter.AddColumnSpec("Valid", "people", as_text, false, 150, prettyBoolString);
 question_filter.AddColumnSpec("Name", "people", as_text, true, 180, rawString);
 question_filter.AddColumnSpec("Abbrev.", "affiliations", as_text, false, 70, rawString);
 question_filter.AddColumnSpec("CPT", "affiliations", as_text, false, 160, rawString);
 question_filter.AddColumnSpec("Type", "tasks", as_text, false, 90, prettyString);
 question_filter.AddColumnSpec("Options", "tasks", as_text, false, 90, prettyString);
 question_filter.SetIconStatus(false);
 question_filter.SetCheck(true);
 question_filter.FetchPreferences("action__yearlymeasurementsummary.question_filter");
 string sql =
   "select obs_questions.id, obs_questions.current_id, obs_questions.valid, "
   "obs_questions.item, obs_questions.short_item, obs_questions.cpt_code, "
   "obs_question_types.item question_type_item, obs_option_set_types.item option_type_item "
   "from obs_questions "
   "left join obs_question_types on obs_question_types.id = obs_questions.obs_question_id "
   "left join obs_option_set_types on obs_option_set_types.id = obs_questions.obs_option_set_id "
   "where "
   "obs_questions.valid = 1 "
   // "and obs_questions.id in (select obs_questions_in_sets.obs_question_id from obs_questions_in_sets inner join obs_question_set_types oqs on oqs.id = obs_questions_in_sets.obs_question_set_id inner join permissions p on p.s = oqs.permission_name and p.k = 'VIEW' and p.v = 'TRUE' and p.user_id = " + current_userid + ") "
   "and obs_questions.obs_question_id in (3, 4)"; // ordinal & metric (because we need to do averaging)
 question_filter.SetSQLStatement(sql);
 question_filter.RefreshDataSet();


// TODO: defaults!
/*
    // oddly enough, this means we could make it setup-able. w00t?
    vector<string> field_names;
    field_names.push_back("blood_pressure_hi");
    field_names.push_back("blood_pressure_low");
    field_names.push_back("weight");
    field_names.push_back("blood_sugar");
    field_names.push_back("temperature");
    field_names.push_back("bmi");
*/
}
//---------------------------------------------------------------------------
bool TframeAction__YearlyMeasurementSummary::Execute (TIBTransaction* dbTransaction, string source_view_name)
{
 vector<string> selected_question_ids = question_filter.GetMultiID();
 string date_a = editStart->Text.c_str();
 string date_b = editStop->Text.c_str();
 yms_methods c;
 if (comboCalcMethod->ItemIndex == 0)
  c = yms_average;
 else
  c = yms_median;
 TformReportYearlyMeasurementSummary::Do(dbTransaction, source_view_name, selected_question_ids, date_a, date_b, c);
 return /* shittin' */ true;
}
//---------------------------------------------------------------------------
bool TframeAction__YearlyMeasurementSummary::Valid ()
{
 bool answer = true;
 listQuestions->Color = clWindow;
 comboCalcMethod->Color = clWindow;

 if (question_filter.GetMultiID().empty())
 {
  listQuestions->Color = clBad;
  answer = false;
 }

 ResetItemIndex(comboCalcMethod); // just in case. seems to have issues with ... that. somehow. this fixes things. yup.
 if (comboCalcMethod->ItemIndex == -1)
 {
  comboCalcMethod->Color = clBad;
  answer = false;
 }

 answer &= quValidSortedOptionalDate(editStart, editStop);
 return TframeActionGeneric::Valid() && answer;
}
//---------------------------------------------------------------------------
TframeActionGeneric* TframeAction__YearlyMeasurementSummary::Create (TComponent* owner)
{
 TframeActionGeneric* temp;
 FORM_TRY
  temp = new TframeAction__YearlyMeasurementSummary(owner);
 FORM_CATCH
 return temp;
}
//---------------------------------------------------------------------------
bool TframeAction__YearlyMeasurementSummary::Appropriate (string source_table_name)
{
 return (source_table_name == "people") &&
        (optionsPermissions["table.people"]["view"] == "true") &&
        (optionsPermissions["table.measurements"]["view"] == "true");
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__YearlyMeasurementSummary::buttonSettingsLoadClick(
      TObject *Sender)
{
 xValue possibly_loaded = QueryLoad(this->SourceTableName, qf_action);
 if (!possibly_loaded.empty())
  if (xTag(possibly_loaded) == "TframeAction__YearlyMeasurementSummary")
   Load(xContent(possibly_loaded), true);
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__YearlyMeasurementSummary::buttonSettingsSaveClick(
      TObject *Sender)
{
 if (Valid())
  QuerySave(this->SourceTableName, qf_action, xVal("TframeAction__YearlyMeasurementSummary", this->Save(true)));
}
//---------------------------------------------------------------------------
xValue TframeAction__YearlyMeasurementSummary::Save (bool with_params)
{
 // you know, this with_params thing ... seems kinda stupid now, doesn't it. yup. ("copy blank"? what was i thinking?)
 map<string, xValue> config_map;
 if (with_params)
 {
  vector<string> selected_question_ids = question_filter.GetMultiID();
  config_map["obs_question_ids"] = xFromStringVec(selected_question_ids);
  config_map["method"] = xFromInt(comboCalcMethod->ItemIndex);
  quSaveOptionalDate(config_map, "start", editStart);
  quSaveOptionalDate(config_map, "stop", editStop);
 }
 return xFromMap(config_map);
}
//---------------------------------------------------------------------------
void TframeAction__YearlyMeasurementSummary::Load (xValue config, bool with_params)
{
 map<string, xValue> config_map = xToMap(config);
 if (with_params)
 {
  vector<string> selected_question_ids = xToStringVec(config_map["obs_question_ids"]);
  set<string> t;
  VecToSet(selected_question_ids, t);
  question_filter.UncheckAll ();
  question_filter.SetCheckedWhereID(t, true);
  comboCalcMethod->ItemIndex = xToInt(config_map["method"]);
  quLoadOptionalDate(config_map, "start", editStart);
  quLoadOptionalDate(config_map, "stop", editStop);
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeAction__YearlyMeasurementSummary::comboCalcMethodKeyPress(
      TObject *Sender, char &Key)
{
 FindComboBoxItemAndSetItemIndex(Sender, Key);
}
//---------------------------------------------------------------------------

