//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "codeDrawerDataQuery.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeDrawerGeneric"
#pragma resource "*.dfm"
TformDrawerDataQuery *formDrawerDataQuery;
//---------------------------------------------------------------------------
__fastcall TformDrawerDataQuery::TformDrawerDataQuery(TComponent* Owner)
        : TformDrawerGeneric(Owner)
{
 labelDrawerName->Caption = "DQ Objects";
 domains_loaded = false;
 tables_loaded = false;
 views_loaded = false;
 indexes_loaded = false;
 stored_procedures_loaded = false;
 generators_loaded = false;
}
//---------------------------------------------------------------------------
// Clicking on the little dropdown thingie switches pages
//---------------------------------------------------------------------------
void __fastcall TformDrawerDataQuery::popupGroupsDomainsClick(TObject *Sender)
{
  pageGroups->ActivePage = sheetDomains;
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerDataQuery::popupGroupsTablesClick(TObject *Sender)
{
  pageGroups->ActivePage = sheetTables;
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerDataQuery::popupGroupsViewsClick(TObject *Sender)
{
  pageGroups->ActivePage = sheetViews;
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerDataQuery::popupGroupsIndexesClick(TObject *Sender)
{
  pageGroups->ActivePage = sheetIndexes;
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerDataQuery::popupGroupsStoredProceduresClick(TObject *Sender)
{
  pageGroups->ActivePage = sheetStoredProcedures;
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerDataQuery::popupGroupsGeneratorsClick(TObject *Sender)
{
  pageGroups->ActivePage = sheetGenerators;
}
//---------------------------------------------------------------------------
// Refresh the appropriate listview, when requested
//---------------------------------------------------------------------------
void __fastcall TformDrawerDataQuery::popupListsRefreshClick(TObject *Sender)
{
  TListView *to_refresh = (TListView *)Sender;
  if (to_refresh == listDomains)
    RefreshDomains();
  else if (to_refresh == listTables)
    RefreshTables();
  else if (to_refresh == listViews)
    RefreshViews();
  else if (to_refresh == listIndexes)
    RefreshIndexes();
  else if (to_refresh == listStoredProcedures)
    RefreshStoredProcedures();
  else if (to_refresh == listGenerators)
    RefreshGenerators();
}
//---------------------------------------------------------------------------
// Actually refresh the appropriate listview
//---------------------------------------------------------------------------
bool TformDrawerDataQuery::RefreshDomains()
{
  return true;
}
//---------------------------------------------------------------------------
/* different (better?) way from ibphoenix website
SELECT RDB$RELATION_NAME FROM RDB$RELATIONS;

This query will show you both system and user tables. To select user tables only, use this:

SELECT RDB$RELATION_NAME FROM RDB$RELATIONS WHERE RDB$SYSTEM_FLAG = 0;

Note for advanced users:
The above query will select both user tables and views. To select tables only use this:

SELECT RDB$RELATION_NAME FROM RDB$RELATIONS WHERE RDB$SYSTEM_FLAG = 0 AND RDB$VIEW_BLR IS NULL;
*/
//---------------------------------------------------------------------------
bool TformDrawerDataQuery::RefreshTables()
{
  vector<string> table_vec;
  string table_sql;
  table_sql = "select rdb$relation_name from rdb$relations ";
  table_sql+= "where rdb$view_source is null ";
  if (!menuShowRDB->Checked)
   table_sql+= "and rdb$relation_name not like 'RDB$%' and rdb$relation_name not like 'MON$%' ";
  if (!menuShowTemp->Checked)
   table_sql+= "and rdb$relation_name not like 'TEMP_%' ";
  table_sql += "order by rdb$relation_name";
  TLVChangeEvent listTablesChange = listTables->OnChange; // save a copy of current
  listTables->OnChange = NULL; // we don't want the event triggered each time we add an item to the list
  listTables->Items->BeginUpdate();
  listTables->Items->Clear();
  bool result = true;
  if (SqlToVec(dbDatabase, table_sql, table_vec))
  {
    for (unsigned int i=0; i<table_vec.size(); i++)
    {
      TListItem * node = listTables->Items->Add();
      node->Caption = StripTrailing(table_vec[i], " ").c_str();
    }
  }
  else
  {
   PSay("Could not get list of tables from the database", m_database_error, MB_OK);
   result = false;
  }
  listTables->Selected = NULL;
  listTables->Items->EndUpdate();
  listTables->OnChange = listTablesChange; // set event back to original state
  return true;
}
//---------------------------------------------------------------------------
bool TformDrawerDataQuery::RefreshViews()
{
  vector<string> view_vec;
  string view_sql;
  view_sql = "select rdb$relation_name from rdb$relations ";
  view_sql+= "where rdb$view_source is not null ";
  view_sql += "order by rdb$relation_name";
  TLVChangeEvent listViewsChange = listViews->OnChange; // save a copy of current
  listViews->OnChange = NULL; // we don't want the event triggered each time we add an item to the list
  listViews->Items->BeginUpdate();
  listViews->Items->Clear();
  bool result = true;
  if (SqlToVec(dbDatabase, view_sql, view_vec))
  {
    for (unsigned int i=0; i<view_vec.size(); i++)
    {
      TListItem * node = listViews->Items->Add();
      node->Caption = StripTrailing(view_vec[i], " ").c_str();
    }
  }
  else
  {
   PSay("Could not get list of views from the database", m_database_error, MB_OK);
   result = false;
  }
  listViews->Selected = NULL;
  listViews->Items->EndUpdate();
  listViews->OnChange = listViewsChange; // set event back to original state
  return true;
}
//---------------------------------------------------------------------------
bool TformDrawerDataQuery::RefreshIndexes()
{
  return true;
}
//---------------------------------------------------------------------------
bool TformDrawerDataQuery::RefreshStoredProcedures()
{
  return true;
}
//---------------------------------------------------------------------------
bool TformDrawerDataQuery::RefreshGenerators()
{
  return true;
}
//---------------------------------------------------------------------------
// When we activate a tabsheet, load its data, if not already loaded
//---------------------------------------------------------------------------
void __fastcall TformDrawerDataQuery::sheetDomainsShow(TObject *Sender)
{
  if (!domains_loaded)
    domains_loaded = RefreshDomains();
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerDataQuery::sheetTablesShow(TObject *Sender)
{
  if (!tables_loaded)
    tables_loaded = RefreshTables();
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerDataQuery::sheetViewsShow(TObject *Sender)
{
  if (!views_loaded)
    views_loaded = RefreshViews();
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerDataQuery::sheetIndexesShow(TObject *Sender)
{
  if (!indexes_loaded)
    indexes_loaded = RefreshIndexes();
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerDataQuery::sheetStoredProceduresShow(TObject *Sender)
{
  if (!stored_procedures_loaded)
    stored_procedures_loaded = RefreshStoredProcedures();
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerDataQuery::sheetGeneratorsShow(TObject *Sender)
{
  if (!generators_loaded)
    generators_loaded = RefreshGenerators();
}
//---------------------------------------------------------------------------
TListView *TformDrawerDataQuery::GetActiveList()
{
  TListView *the_list = NULL;
  if (pageGroups->ActivePage == sheetDomains)
    the_list = listDomains;
  else if (pageGroups->ActivePage == sheetTables)
    the_list = listTables;
  else if (pageGroups->ActivePage == sheetViews)
    the_list = listViews;
  else if (pageGroups->ActivePage == sheetIndexes)
    the_list = listIndexes;
  else if (pageGroups->ActivePage == sheetStoredProcedures)
    the_list = listStoredProcedures;
  else if (pageGroups->ActivePage == sheetGenerators)
    the_list = listGenerators;

  return the_list;
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerDataQuery::menuShowRDBClick(TObject *Sender)
{
  menuShowRDB->Checked = !menuShowRDB->Checked;
  RefreshTables();
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerDataQuery::menuShowTempClick(TObject *Sender)
{
  menuShowTemp->Checked = !menuShowTemp->Checked;
  RefreshTables();
}
//---------------------------------------------------------------------------

