//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeDrawerGeneric.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformDrawerGeneric *formDrawerGeneric;
//---------------------------------------------------------------------------
__fastcall TformDrawerGeneric::TformDrawerGeneric(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
 if(debug_level[generic_forms]>=7 && message_router) message_router->SendMessageToAll("debug", "DrawerGeneric constructor entry");
 kidnapped_control = NULL;
 kidnapped_control_parent = NULL;
 HelpButtonVisible = false;
 dragging_caption = false;
 if(debug_level[generic_forms]>=7 && message_router) message_router->SendMessageToAll("debug", "DrawerGeneric constructor exit");
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerGeneric::CreateParams(TCreateParams &Params)
{
 TformSpecialGeneric::CreateParams(Params);
 // not a top-level window deserving stuff
 Params.ExStyle &= ~WS_EX_APPWINDOW;
 // no caption -- I found this in Borland's FAQ, which disagrees with all other examples involving WS_CAPTION and WS_BORDER, etc.
 Params.Style   &= ~WS_DLGFRAME;
 Params.Style   |= WS_POPUP;
}
//---------------------------------------------------------------------------
void TformDrawerGeneric::KidnapControl (TWinControl * to_kidnap)
{
 UnkidnapControl();
 if (to_kidnap)
 {
  kidnapped_control = to_kidnap;
  kidnapped_control_parent = to_kidnap->Parent;
  to_kidnap->ManualDock(scrollStandard, NULL, alNone);
  to_kidnap->Align = alClient;
  to_kidnap->Visible = true;
 }
}
//---------------------------------------------------------------------------
void TformDrawerGeneric::UnkidnapControl ()
{
 if (kidnapped_control && kidnapped_control_parent)
 {
  kidnapped_control->Visible = false;
  kidnapped_control->ManualDock(kidnapped_control_parent, NULL, alNone);
  kidnapped_control = NULL;
  kidnapped_control_parent = NULL;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerGeneric::FormClose(TObject *Sender, TCloseAction &Action)
{
 if(debug_level[generic_forms]>=7 && message_router) message_router->SendMessageToAll("debug", "DrawerGeneric FormClose entry");
 UnkidnapControl();
 if(debug_level[generic_forms]>=7 && message_router) message_router->SendMessageToAll("debug", "DrawerGeneric FormClose exiting, calling ancestor");
 TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerGeneric::buttonDrawerOptionsClick(TObject *Sender)
{
 // close/hide
 DrawerExpanded = false;
}
//---------------------------------------------------------------------------

void __fastcall TformDrawerGeneric::menuDrawerPositionClick(TObject *Sender)
{
 if (Sender == menuTop)
 {
  menuTop->Checked = true;
  DrawerPosition = akTop;
 } else
 if (Sender == menuRight)
 {
  menuRight->Checked = true;
  DrawerPosition = akRight;
 } else
 if (Sender == menuBottom)
 {
  menuBottom->Checked = true;
  DrawerPosition = akBottom;
 } else
 if (Sender == menuLeft)
 {
  menuLeft->Checked = true;
  DrawerPosition = akLeft;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerGeneric::popupDrawerOptionsPopup(TObject *Sender)
{
 menuTop->Checked = (DrawerPosition == akTop);
 menuRight->Checked = (DrawerPosition == akRight);
 menuBottom->Checked = (DrawerPosition == akBottom);
 menuLeft->Checked = (DrawerPosition == akLeft);
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerGeneric::buttonDrawerAttachmentClick(TObject *Sender)
{
 // change drawer attachment relative to parent window
 // basically, we keep DrawerOwner, but most booleans now need -both- (attached, and what it's attached to)
 // closing the DrawerOwner would still kill the drawer though. (is this a problem?)
 DrawerAttached = !DrawerAttached;
/*
 if (DrawerAttached)
 {
  buttonDrawerAttachment->ImageIndex = 1;
  buttonDrawerAttachment->Hint = "Detach from main form";
 } else
 {
  buttonDrawerAttachment->ImageIndex = 2;
  buttonDrawerAttachment->Hint = "Attach to main form";
 }
*/
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerGeneric::panelDrawerNameMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
 if (!DrawerAttached)
 {
  dragging_x = X;
  dragging_y = Y;
  dragging_caption = true;
  SetCapture(((TWinControl*)Sender)->Handle);
 }
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerGeneric::panelDrawerNameMouseMove(TObject *Sender, TShiftState Shift, int X, int Y)
{
 if (dragging_caption)
 {
  this->Left += (X - dragging_x);
  this->Top  += (Y - dragging_y);
 }
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerGeneric::panelDrawerNameMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
 if (dragging_caption)
 {
  dragging_caption = false;
  ReleaseCapture();
 }
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerGeneric::SetDrawerAttached (bool Value)
{
 TformSpecialGeneric::SetDrawerAttached(Value);
 if (DrawerAttached)
 {
  buttonDrawerAttachment->ImageIndex = 1;
  buttonDrawerAttachment->Hint = "Detach from main form";
 } else
 {
  buttonDrawerAttachment->ImageIndex = 2;
  buttonDrawerAttachment->Hint = "Attach to main form";
 }
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerGeneric::FormDestroy(TObject *Sender)
{
  if(debug_level[generic_forms]>=7 && message_router) message_router->SendMessageToAll("debug", "DrawerGeneric FormDestroy");
}
//---------------------------------------------------------------------------


