//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeDrawerSearchFavorites.h"
#include "codeSearchGeneric.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeDrawerGeneric"
#pragma resource "*.dfm"
TformDrawerSearchFavorites *formDrawerSearchFavorites;
//---------------------------------------------------------------------------
__fastcall TformDrawerSearchFavorites::TformDrawerSearchFavorites(TComponent* Owner)
        : TformDrawerGeneric(Owner)
{
 labelDrawerName->Caption = "Favorites";
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerSearchFavorites::buttonAddClick(TObject *Sender)
{
 // add from search screen
 TformSearchGeneric * s = (TformSearchGeneric*)DrawerOwner;
 vector<string> selected_items = s->Filter->GetMultiID();
 set<string> set_favorites = FavoritesToSet();

 for (vector<string>::iterator i = selected_items.begin(); i != selected_items.end(); i++)
  set_favorites.insert(*i);

 SetToFavorites(set_favorites);
 RefreshFavorites();
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerSearchFavorites::buttonRemoveClick(TObject *Sender)
{
 // remove from favorites
 set<string> set_favorites = FavoritesToSet();

 vector<map<string, string> > selected_items;
 list_favorites.export_selected_data (selected_items);
 for (vector<map<string, string> >::iterator i = selected_items.begin(); i != selected_items.end(); i++)
  set_favorites.erase((*i)["id"]);

 SetToFavorites(set_favorites);
 RefreshFavorites();
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerSearchFavorites::buttonClearClick(TObject *Sender)
{
 // clear favorites

 if (IDNO == PSay("Are you sure you want to clear your favorites?", m_confirmation, MB_YESNO))
  return;

 set<string> set_favorites;
 SetToFavorites(set_favorites);
 RefreshFavorites();
}
//---------------------------------------------------------------------------
void TformDrawerSearchFavorites::RefreshFavorites()
{
 // redraw the list

 TformSearchGeneric * s = (TformSearchGeneric*)DrawerOwner;
 string table_name = s->table_name;

 if (!DefaultTextAvailable(table_name))
 {
  buttonAdd->Enabled     = false;
  buttonRemove->Enabled  = false;
  buttonClear->Enabled   = false;
  listFavorites->Enabled = false;
  listFavorites->Visible = false;
 } else
 {
  set<string> set_favorites = FavoritesToSet();
  vector<map<string, string> > end_result;
  map<string, string> temp;
  for (set<string>::iterator i = set_favorites.begin(); i != set_favorites.end(); i++)
  {
   temp["id"] = *i;
   temp["item"] = DefaultText(*i, table_name);
   end_result.push_back(temp);
  }

  list_favorites.clear_data();
  list_favorites.import_data(end_result);
 }
}
//---------------------------------------------------------------------------
set<string> TformDrawerSearchFavorites::FavoritesToSet()
{
 TformSearchGeneric * s = (TformSearchGeneric*)DrawerOwner;
 string table_name = s->table_name;
 string string_favorites = optionsPreferences["favorites"][table_name];
 set<string> set_favorites;
 SplitStringToSet(string_favorites, "|", set_favorites);
 set_favorites.erase("");
 return set_favorites;
}
//---------------------------------------------------------------------------
void TformDrawerSearchFavorites::SetToFavorites(set<string> new_favorites)
{
 TformSearchGeneric * s = (TformSearchGeneric*)DrawerOwner;
 string table_name = s->table_name;
 string string_favorites = SetToDelimString(new_favorites, "", "", "|");
 optionsPreferences["favorites"][table_name] = string_favorites;
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerSearchFavorites::FormShow(TObject *Sender)
{
 TformDrawerGeneric::FormShow(Sender);

 list_favorites.setup_listview(listFavorites, true);
 list_favorites.setup_callbacks((TForm*)this, NULL, InformForm(&(TformDrawerSearchFavorites::FavoriteZoomed)));
 list_favorites.add_or_modify_column("id", "id", false, 0, 64, as_int, rawString);
 list_favorites.add_or_modify_column("item", "Item", true, 1, 150, as_text, rawString);
 list_favorites.sort_by_column_name("item");

 RefreshFavorites();
}
//---------------------------------------------------------------------------
void TformDrawerSearchFavorites::FavoriteZoomed ()
{
 if (listFavorites->Selected)
 {
  map<string, string> row_data;
  if (list_favorites.get_current_row(row_data))
  {
   string id = row_data["id"];
   TformSearchGeneric * s = (TformSearchGeneric*)DrawerOwner;
   s->Zoom(id);
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall TformDrawerSearchFavorites::listFavoritesKeyPress(TObject *Sender, char &Key)
{
  if (IsEnter(Key))
    FavoriteZoomed();
}
//---------------------------------------------------------------------------

