//---------------------------------------------------------------------------

#ifndef codeEnrollmentDiabRegistryH
#define codeEnrollmentDiabRegistryH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeEnrollmentGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include "codeRubberContainer.h"
#include "codePaddedBox.h"
//---------------------------------------------------------------------------
class classFilterRegistrySource : public classFilterEnrollmentSource
{
 public:
  classFilterRegistrySource();
  virtual bool Begin(TIBTransaction * dbTransaction);
  bool only_show_registry_changes;
};
//---------------------------------------------------------------------------
class classFilterNewDiabeticSource : public classFilterEnrollmentSource
{
 public:
  classFilterNewDiabeticSource();
  virtual bool Begin(TIBTransaction * dbTransaction);
  bool only_show_positive_visits;
};
//---------------------------------------------------------------------------
class classFilterAtRiskSource : public classFilterEnrollmentSource
{
 public:
  classFilterAtRiskSource();
  virtual bool Begin(TIBTransaction * dbTransaction);
  bool only_show_positive_visits;
};
//---------------------------------------------------------------------------
class TformEnrollmentDiabRegistry : public TformEnrollmentGeneric
{
__published:	// IDE-managed Components
        TPanel *panelRegistryControls;
        TCheckBox *checkRegistryChanges;
        TPanel *panelRegistry;
        TLabel *lblRefreshRegistry;
        TButton *btnRefreshRegistry;
        TTabSheet *sheetNewDiabetics;
        TTabSheet *sheetWelcome;
        TPaddedBox *padWelcome;
        TRichEdit *richWelcome;
        TTabSheet *sheetAtRisk;
        TRubberContainer *rubberNewDiabetics;
        TListView *listNewDiabetics;
        TPanel *panelNewDiabetics;
        TLabel *lblRefreshNewDiabetics;
        TButton *btnRefreshNewDiabetics;
        TPanel *panelNewDiabeticControls;
        TCheckBox *checkNewDiabeticVisits;
        TPanel *panelAtRisk;
        TLabel *lblRefreshAtRisk;
        TButton *btnRefreshAtRisk;
        TPanel *panelAtRiskControls;
        TCheckBox *checkAtRiskVisits;
        TRubberContainer *rubberAtRisk;
        TListView *listAtRisk;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall pageEnrollmentChange(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall btnRefreshRegistryClick(TObject *Sender);
        void __fastcall btnRefreshNewDiabeticsClick(TObject *Sender);
        void __fastcall btnRefreshAtRiskClick(TObject *Sender);
        void __fastcall btnRefreshAllClick(TObject *Sender);
        void __fastcall checkRegistryChangesClick(TObject *Sender);
        void __fastcall checkNewDiabeticVisitsClick(TObject *Sender);
        void __fastcall checkAtRiskVisitsClick(TObject *Sender);
private:	// User declarations
        vector<string> instructions;
        classFilterRegistrySource * RegistryDataSource;
        classFilterNewDiabeticSource * NewDiabeticDataSource;
        classFilterAtRiskSource * AtRiskDataSource;
        map<string, string> sql;
        TIBTransaction *our_transaction;
        int enrollment_request;
public:		// User declarations
        __fastcall TformEnrollmentDiabRegistry(TComponent* Owner);
        void EditEnrollment();
        void EditNewDiabetic();
        void EditAtRisk();
        void DoFilterStuff();
        void SetUpAtlasRequests();
        bool AtlasRefreshListView(int request_num, string matched_value);
};
//---------------------------------------------------------------------------
extern PACKAGE TformEnrollmentDiabRegistry *formEnrollmentDiabRegistry;
//---------------------------------------------------------------------------
#endif
