//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeEnrollmentDiabSteps.h"
#include "codeRecordEnrollment.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeEnrollmentGeneric"                                            
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformEnrollmentDiabSteps *formEnrollmentDiabSteps;
//---------------------------------------------------------------------------
__fastcall TformEnrollmentDiabSteps::TformEnrollmentDiabSteps(TComponent* Owner)
        : TformEnrollmentGeneric(Owner)
{
  //our_transaction = new TIBTransaction(NULL);
  //StdTransaction(our_transaction, dbDatabase);

  classFilterObject *filter;

  listParticipants->MultiSelect = true;
  filter = filter_atlas_handler["participants"].filter;
  ParticipantsDataSource = NULL;
  FORM_TRY
    ParticipantsDataSource = new classFilterStepsSource();
  FORM_CATCH
  ParticipantsDataSource->SetFilter(filter);
  ParticipantsDataSource->what_to_show = participants;

  filter->SetListViewHandle(listParticipants);
  filter->SetSecurity("enrollment");
  filter->AddColumnSpec("Name", "people", as_text, true, 150);
  filter->AddColumnSpec("DOB", "people", as_date,  true, 75);
  filter->AddColumnSpec("DOD", "people", as_date,  true, 75);
  filter->AddColumnSpec("Gender", "people", as_text, true, 75);
  filter->AddColumnSpec("Tribe", "affiliations", as_text, false, 100);
  filter->AddColumnSpec("Enroll #", "enrollment", as_int, true, 75);
  filter->AddColumnSpec("PCP", "tax_entities", as_text, false, 150, rawString);
  filter->AddColumnSpec("DM Client", "people", as_text, true, 65, prettyBoolString);
  filter->AddColumnSpec("Status", "enrollment", as_text, true, 100);
  filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter->FetchPreferences("specialdiabsteps.participants");
  filter->SetCheck(false);
  filter->SetCompress(false);
  filter->SetAddEdit(this, NULL, EditRecord(&(TformEnrollmentDiabSteps::EditEnrollment)));
  filter->SetInform(this, InformForm(&(TformEnrollmentDiabSteps::DoFilterStuff)));
  filter->SetHint("double click row to open that person's STEPS enrollment record");
  filter->GetListViewHandle()->ShowHint = true;
  filter->SetDataSource(ParticipantsDataSource);
  filter->RefreshDataSet();

  //---
  listMembers->MultiSelect = true;
  filter = filter_atlas_handler["members"].filter;
  MembersDataSource = NULL;
  FORM_TRY
    MembersDataSource = new classFilterStepsSource();
  FORM_CATCH
  MembersDataSource->SetFilter(filter);
  MembersDataSource->what_to_show = members;

  filter->SetListViewHandle(listMembers);
  //filter->SetTransaction(our_transaction);
  filter->SetSecurity("enrollment");
  filter->AddColumnSpec("Name", "people", as_text, true, 150);
  filter->AddColumnSpec("DOB", "people", as_date,  true, 75);
  filter->AddColumnSpec("DOD", "people", as_date,  false, 75);
  filter->AddColumnSpec("Gender", "people", as_text, true, 75);
  filter->AddColumnSpec("Tribe", "affiliations", as_text, false, 100);
  filter->AddColumnSpec("Enroll #", "enrollment", as_int, true, 75);
  //filter->AddColumnSpec("Visits in Past Year", "tasks", as_int, true, 30);
  filter->AddColumnSpec("PCP", "tax_entities", as_text, true, 150, rawString);
  //filter->AddColumnSpec("Most Recent Provider", "tax_entities", as_text, false, 150, rawString);
  //filter->AddColumnSpec("Most Used Provider (in past year)", "tax_entities", as_text, false, 150, rawString);
  //filter->AddColumnSpec("F/U in Past Year", "tasks", as_int, true, 30);
  filter->AddColumnSpec("DM Client", "people", as_text, true, 45, prettyBoolString);
  filter->AddColumnSpec("Status", "enrollment", as_text, false, 100);
  //filter->AddColumnSpec("Suggested Status", "enrollment", as_text, true, 105);
  filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter->FetchPreferences("specialdiabsteps.members");
  filter->SetCheck(false);
  filter->SetCompress(false);
  filter->SetAddEdit(this, NULL, EditRecord(&(TformEnrollmentDiabSteps::EditEnrollment)));
  filter->SetInform(this, InformForm(&(TformEnrollmentDiabSteps::DoFilterStuff)));
  filter->SetHint("double click row to open that person's STEPS enrollment record");
  filter->GetListViewHandle()->ShowHint = true;
  //filter->SetSQLStatement(registry_sql);
  filter->SetDataSource(MembersDataSource);
  filter->RefreshDataSet();
  //filter->CheckAll();

  //---
  listAffiliates->MultiSelect = true;
  filter = filter_atlas_handler["affiliates"].filter;
  AffiliatesDataSource = NULL;
  FORM_TRY
    AffiliatesDataSource = new classFilterStepsSource();
  FORM_CATCH
  AffiliatesDataSource->SetFilter(filter);
  AffiliatesDataSource->what_to_show = affiliates;

  filter->SetListViewHandle(listAffiliates);
  filter->SetSecurity("enrollment");
  filter->AddColumnSpec("Name", "people", as_text, true, 150);
  filter->AddColumnSpec("DOB", "people", as_date,  true, 75);
  filter->AddColumnSpec("DOD", "people", as_date,  true, 75);
  filter->AddColumnSpec("Gender", "people", as_text, true, 75);
  filter->AddColumnSpec("Tribe", "affiliations", as_text, false, 100);
  filter->AddColumnSpec("Enroll #", "enrollment", as_int, true, 75);
  filter->AddColumnSpec("PCP", "tax_entities", as_text, true, 150, rawString);
  filter->AddColumnSpec("DM Client", "people", as_text, true, 65, prettyBoolString);
  filter->AddColumnSpec("Status", "enrollment", as_text, false, 100);
  filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter->FetchPreferences("specialdiabsteps.affiliates");
  filter->SetCheck(false);
  filter->SetCompress(false);
  filter->SetAddEdit(this, NULL, EditRecord(&(TformEnrollmentDiabSteps::EditEnrollment)));
  filter->SetInform(this, InformForm(&(TformEnrollmentDiabSteps::DoFilterStuff)));
  filter->SetHint("double click row to open that person's STEPS enrollment record");
  filter->GetListViewHandle()->ShowHint = true;
  filter->SetDataSource(AffiliatesDataSource);
  filter->RefreshDataSet();

  enrollment_request = atlas->RequestNotificationWhen("enrollment.id", "", rel_any, as_int, this,
                       RefreshHandler(&(TformEnrollmentDiabSteps::AtlasRefreshListView)));
}
//---------------------------------------------------------------------------
void __fastcall TformEnrollmentDiabSteps::btnRefreshAllClick(TObject *Sender)
{
  filter_atlas_handler["steps"].filter->RefreshDataSet();
}
//---------------------------------------------------------------------------
void TformEnrollmentDiabSteps::EditEnrollment()
{
  map<string, string> temp_map;
  if (pageEnrollment->ActivePage == sheetParticipants)
    temp_map["id"] = filter_atlas_handler["participants"].filter->GetSelectedRecordID();
  else if (pageEnrollment->ActivePage == sheetMembers)
    temp_map["id"] = filter_atlas_handler["members"].filter->GetSelectedRecordID();
  else if (pageEnrollment->ActivePage == sheetAffiliates)
    temp_map["id"] = filter_atlas_handler["affiliates"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordEnrollment *view_enrollment = new TformRecordEnrollment(NULL, temp_map);
    view_enrollment->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformEnrollmentDiabSteps::DoFilterStuff()
{
  vector <string> sections;
  sections.push_back("STEPS Participants"); // always
  if (filter_atlas_handler["participants"].filter->HasData())
   sections.push_back(IntToString(filter_atlas_handler["participants"].filter->GetResultSize()) + " Participants");
  if (filter_atlas_handler["members"].filter->HasData())
   sections.push_back(IntToString(filter_atlas_handler["members"].filter->GetResultSize()) + " Members");
  if (filter_atlas_handler["affiliates"].filter->HasData())
   sections.push_back(IntToString(filter_atlas_handler["affiliates"].filter->GetResultSize()) + " Affiliates");
  this->Caption = VecToDelimString(sections, "", "", " - ").c_str();
  SetUpAtlasRequests();
}
//---------------------------------------------------------------------------
void TformEnrollmentDiabSteps::SetUpAtlasRequests()
{
  // what?  why?  no.
  /*
  vector<string> selected_id_vec = filter_atlas_handler["members"].filter->GetAllID();
  for(vector<string>::iterator itr = selected_id_vec.begin(); itr != selected_id_vec.end(); itr++)
  {
    atlas->RequestNotificationWhen("enrollment.person_id", *itr, rel_e, as_int, this,
    RefreshHandler(&(TformEnrollmentDiabSteps::AtlasRefreshListView)));
  }
  */
}
//---------------------------------------------------------------------------
bool TformEnrollmentDiabSteps::AtlasRefreshListView(int request_num, string matched_value)
{
  HandleAtlasRequest(request_num);

  if (request_num == enrollment_request)
  {
    // okay ... now ... how do we know what the change actually WAS?
    // we really need the itemvalue passed back to us here....
    // philip says the API doesn't do that.
    // ...
    // Hey look, I made the API do that now.  matched_value (above) is the
    // changed record.  now what to do with it?  suddenly I feel all lazy.
  }

  filter_atlas_handler["participants"].filter->RefreshDataSet();
  filter_atlas_handler["members"].filter->RefreshDataSet();
  filter_atlas_handler["affiliates"].filter->RefreshDataSet();

  return true;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
classFilterStepsSource::classFilterStepsSource() : classFilterEnrollmentSource()
{
}
//---------------------------------------------------------------------------
bool classFilterStepsSource::Begin(TIBTransaction * dbTransaction)
{
  sql["steps"] = "select first_name || (case when middle_name != '' then ' ' else '' end) || middle_name || (case when last_name != '' then ' ' else '' end) || last_name || (case when suffix != '' then ' ' else '' end) || suffix name, "
                 "birth_date, death_date, gender_types.item, tribe_types.item, steps_enrollment.enrollment_number, provider.name, "
                 "case when client_enrollment.id is not null then 1 else 0 end is_diabetes_client, "
                 "enrollment_status_types.item, steps_enrollment.current_id, steps_enrollment.id "
                 "from enrollment steps_enrollment "
                 "inner join enrollment_status_types on steps_enrollment.enrollment_status_id = enrollment_status_types.id "
                 "inner join people on steps_enrollment.person_id = people.id "
                 "left join person_names on people.person_names_id = person_names.id "
                 "left join gender_types on people.gender_id = gender_types.id "
                 "left join affiliations on people.affiliations_id = affiliations.id "
                 "left join tribe_types on affiliations.tribe_id = tribe_types.id "
                 "left join tax_entities provider on steps_enrollment.provider_id = provider.id "
                 "left join enrollment client_enrollment on client_enrollment.person_id = people.id and client_enrollment.current_id+1 >= 4 and "
                 " client_enrollment.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "' "
                 "where steps_enrollment.enrollment_id = " + lookupTables->IdOf("enrollment_types", "STEPS Participant") + " and steps_enrollment.enrollment_status_id in (";

  switch (what_to_show)
  {
    case participants:
      sql["steps"] += (lookupTables->IdOf("enrollment_status_types", "Member") + "," +
                       lookupTables->IdOf("enrollment_status_types", "Affiliate") + ")");
      break;
    case members:
      sql["steps"] += (lookupTables->IdOf("enrollment_status_types", "Member") + ")");
      break;
    case affiliates:
      sql["steps"] += (lookupTables->IdOf("enrollment_status_types", "Affiliate") + ")");
      break;
  }
  DebugSql(NULL, &(sql["steps"]), other_forms, 9);
  //QueryData(NULL, dbTransaction, sql["steps"]);

  // setup default fields
  field_names.clear();
  field_types.clear();
  field_values.clear();
  row_index = 0;

  // setup data and 'extra' fields
  map<string, string> data_row;
  vector<string> fields_in_order;
  easy_streaming_dataset data_stream(dbTransaction, sql["steps"]);

  unsigned int next_column;
  next_column = 6;

  string prev_obs_set_id = "";
  deque<vector<string> >::iterator current_row;
  while (data_stream.GetRow(data_row))
  {
    data_stream.GetRow(fields_in_order);
    field_values.push_back(fields_in_order);

    data_stream.Next();
  }

  return true;
}
//---------------------------------------------------------------------------

