//---------------------------------------------------------------------------

#ifndef codeEnrollmentDiabStepsH
#define codeEnrollmentDiabStepsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeEnrollmentGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include "codeRubberContainer.h"
//---------------------------------------------------------------------------
enum members_or_affiliates {participants, members, affiliates};

class classFilterStepsSource : public classFilterEnrollmentSource
{
 public:
  classFilterStepsSource();
  virtual bool Begin(TIBTransaction * dbTransaction);
  members_or_affiliates what_to_show;
};
//---------------------------------------------------------------------------
class TformEnrollmentDiabSteps : public TformEnrollmentGeneric
{
__published:	// IDE-managed Components
        TTabSheet *sheetAffiliates;
        TRubberContainer *rubberAffiliates;
        TListView *listAffiliates;
        TTabSheet *sheetParticipants;
        TRubberContainer *rubberParticipants;
        TListView *listParticipants;
        void __fastcall btnRefreshAllClick(TObject *Sender);
private:	// User declarations
        classFilterStepsSource * ParticipantsDataSource;
        classFilterStepsSource * MembersDataSource;
        classFilterStepsSource * AffiliatesDataSource;
        map<string, string> sql;
        TIBTransaction *our_transaction;
        int enrollment_request;
public:		// User declarations
        void EditEnrollment();
        void DoFilterStuff();
        void SetUpAtlasRequests();
        bool AtlasRefreshListView(int request_num, string matched_value);
        __fastcall TformEnrollmentDiabSteps(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TformEnrollmentDiabSteps *formEnrollmentDiabSteps;
//---------------------------------------------------------------------------
#endif
