//---------------------------------------------------------------------------

#ifndef codeEnrollmentGenericH
#define codeEnrollmentGenericH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include "codeRubberContainer.h"

//---------------------------------------------------------------------------
class classFilterEnrollmentSource : public classFilterSource
{
 protected:
  // input
  classFilterObject * FFilter;

  // output
  vector<string> field_names;
  vector<TFieldType> field_types;
  deque<vector<string> > field_values;
  unsigned int row_index;
  map<string, string> sql;
 public:
  classFilterEnrollmentSource();
  virtual bool Begin(TIBTransaction * dbTransaction);
  virtual unsigned int GetFieldCount();
  virtual bool GetFieldNames(vector<string> & field_vec);
  virtual bool GetFieldTypes(vector<TFieldType> & field_vec);
  virtual bool GetRow(vector<string> & field_vec);
  virtual void End();
  virtual ~classFilterEnrollmentSource();

  virtual void SetFilter (classFilterObject * f);
};
//---------------------------------------------------------------------------
class TformEnrollmentGeneric : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *btnRefreshAll;
        TToolButton *btnInvisible;
        TPageControl *pageEnrollment;
        TTabSheet *sheetMembers;
        TRubberContainer *rubberMembers;
        TListView *listMembers;
private:	// User declarations
public:		// User declarations
        __fastcall TformEnrollmentGeneric(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TformEnrollmentGeneric *formEnrollmentGeneric;
//---------------------------------------------------------------------------
#endif
