//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeFilterPreferences.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformFilterPreferences *formFilterPreferences;
//---------------------------------------------------------------------------
__fastcall TformFilterPreferences::TformFilterPreferences(TComponent* Owner, classFilterObject * tempfilterObj)
        : TformSpecialGeneric(Owner)
{
 listCurrent->SmallImages = imagesCurrent;
 imageCurrentID = imagesCurrent;
 FilterObj = tempfilterObj;

 prev_pref = FilterObj->GetPreferences();

 TListColumn *columns;
 columns = listCurrent->Columns->Add();
 columns->Width = 100;
 columns = listColumns->Columns->Add();
 columns->Width = 230;
 Refetch();
}
//---------------------------------------------------------------------------
void __fastcall TformFilterPreferences::buttonOkClick(TObject *Sender)
{
 // keep changes
 int y = 0;
 int z = 0;

 // Go through the two vectors when the item is checked, change the show value
 //in the vector as true, else change it to false.

 if (FilterObj->CanFilter())
 {
  for(vector<classCurrent>::iterator itra = FilterObj->CurrentVec.begin();
      itra != FilterObj->CurrentVec.end(); itra++, y++)
   itra->showCurrent = (listCurrent->Items->Item[y]->Checked);
 }

 for (vector<classColumn>:: iterator itr = FilterObj->ColumnVec.begin();
      itr != FilterObj->ColumnVec.end(); itr++)
 {
  itr->showCol = false;
  // skip over those we don't show because they can't have it, even if they
  // want it =)
  string needed_permission = FilterObj->FullPerm(itr->requires);
  if ((needed_permission == "") ||
      (optionsPermissions[needed_permission][LikeString("table.%", needed_permission) ? "view" : "enabled"] == "true"))
  {
   if (listColumns->Items->Item[z]->Checked)
    itr->showCol = true;
   z++;
  }
 }

 FilterObj->SetHeader(checkHeaders->Checked);
 FilterObj->RefreshListView();
 FilterObj->ThrowPreferences();
 Close ();
}
//---------------------------------------------------------------------------
void __fastcall TformFilterPreferences::buttonCancelClick(TObject *Sender)
{
 // discard changes
 FilterObj->SetPreferences(prev_pref);
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TformFilterPreferences::buttonResetClick(TObject *Sender)
{
 FilterObj->SetPreferences(FilterObj->GetDefaultPreferences());
 Refetch();
}
//---------------------------------------------------------------------------
void TformFilterPreferences::Refetch()
{
 int i = 0;
 TListItem *rows;

 listCurrent->Items->Clear();
 if (FilterObj->CanFilter())
 {
  //go through the vector listing the current types and current columns so the user can choose
  //his/her preferences
  for (vector<classCurrent>::iterator itr = FilterObj->CurrentVec.begin();
       itr != FilterObj->CurrentVec.end(); itr++, i++)
  {
   rows = listCurrent->Items->Add();
   rows->ImageIndex = i + 3; // current specs are in order 0-5, images are 3-8
   rows->Caption = itr->currentItem.c_str();
   rows->Checked = itr->showCurrent;
  }
 } else
 {
  listCurrent->Enabled = false;
  groupCurrent->Enabled = false;
 }

 listColumns->Items->Clear();
 for (vector<classColumn>::iterator itr = FilterObj->ColumnVec.begin();
      itr != FilterObj->ColumnVec.end(); itr++)
 {
  string needed_permission = FilterObj->FullPerm(itr->requires);
  if ((needed_permission == "") ||
      (optionsPermissions[needed_permission][LikeString("table.%", needed_permission) ? "view" : "enabled"] == "true"))
  {
   rows = listColumns->Items->Add();
   rows->Checked = itr->showCol;
   rows->Caption = itr->columnName.c_str();
  }
 }
  checkHeaders->Checked = FilterObj->GetHeader();
}
//---------------------------------------------------------------------------

