//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentActivityLevelH
#define codeFrameAssessmentActivityLevelH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "Filter.h"
//---------------------------------------------------------------------------
class TframeAssessmentActivityLevel : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TListView *listLevels;
        TPanel *panelLevels;
        TSplitter *Splitter1;
        TCheckBox *checkNPI;
        TLabel *lblActivityLevels;
        TLabel *lblComments;
        TListView *listActivityTypes;
        TMemo *memoComments;
        TToolButton *sepThree;
        TToolButton *btnReferral;
        void __fastcall listActivityTypesClick(TObject *Sender);
        void __fastcall checkNPIClick(TObject *Sender);
        void __fastcall btnReferralClick(TObject *Sender);
private:	// User declarations
        classFilterObject levels_filter;
        classFilterObject checks_filter;
        int levels_request;
        pvecmap editing_level_items;
        pvecmap final_ending_state;

        bool Initialize();
        void Lock();
        void TaskIdChanging(const string &new_id);
        void UpdateForEdit();
        bool LockRecords();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        void FilterAddActivityLevel();
        void FilterEditActivityLevel();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool IsValidOnScreen();
        bool WriteReport(TComponent *compositeReportCtrl);

        void PutUpActivityLevels(pvecmap &level_items);
        bool UpdateActivityLevel(int record_index, string comment);
        bool InsertActivityLevel(string activity_level_id, string comment);
        bool DeleteActivityLevel(int record_index);

public:		// User declarations
        __fastcall TframeAssessmentActivityLevel(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentActivityLevel *frameAssessmentActivityLevel;
//---------------------------------------------------------------------------
#endif
