//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentAllergiesH
#define codeFrameAssessmentAllergiesH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "codeHalfButton.h"
#include <ExtCtrls.hpp>
#include "Filter.h"
#include <Db.hpp>
#include <IBCustomDataSet.hpp>
#include <IBDatabase.hpp>
//---------------------------------------------------------------------------
class TframeAssessmentAllergies : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TToolButton *sepThree;
        TToolButton *btnAdd;
        TListView *listAllergies;
        TPanel *panelAllergy;
        TComboBox *cboConditionType;
        TLabel *Label1;
        TLabel *lblAllergyType;
        TComboBox *cboAllergyType;
        TRichEdit *editNotes;
        TLabel *lblNote;
        TEdit *editStartDate;
        TLabel *lblStartDate;
        TLabel *lblCode;
        TEdit *editCode;
        THalfButton *btnCodeWizard;
        THalfButton *btnCodeSearch;
        THalfButton *btnExpandCode;
        TSplitter *Splitter1;
        void __fastcall btnAddClick(TObject *Sender);
        void __fastcall btnCodeSearchClick(TObject *Sender);
        void __fastcall btnExpandCodeClick(TObject *Sender);
private:	// User declarations
        classFilterObject allergy_filter;
        map<string, string> editing_condition;
        map<string, string> ending_state; // for remembering what was saved
        int allergy_request;
        string editing_id;

        bool Initialize();
        void Lock();
        void TaskIdChanging(const string &new_id);
        bool LockRecords();
        bool CanUnlock(bool &creating_new);
        void UpdateForEdit();
        bool SavingNew();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        void FilterAddAllergy();
        void FilterEditAllergy();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool IsValidOnScreen();
        bool WriteReport(TComponent *compositeReportCtrl);
public:		// User declarations
        __fastcall TframeAssessmentAllergies(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentAllergies *frameAssessmentAllergies;
//---------------------------------------------------------------------------
#endif
