//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentCardioH
#define codeFrameAssessmentCardioH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "Filter.h"
#include <Db.hpp>
#include <IBCustomDataSet.hpp>
#include <IBDatabase.hpp>
//---------------------------------------------------------------------------
class TframeAssessmentCardio : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TListView *listCardio;
        TPanel *panelCardio;
        TSplitter *Splitter1;
        TToolButton *sepThree;
        TToolButton *btnAdd;
        TCheckBox *checkNPI;
        TCheckBox *checkPacemaker;
        TCheckBox *checkTele;
        TCheckBox *checkAICD;
        TGroupBox *groupExtPulse;
        TLabel *lblAssessment;
        TLabel *lblURight;
        TLabel *lblLRight;
        TLabel *lblULeft;
        TLabel *lblLLeft;
        TLabel *lblStrong;
        TLabel *lblFaint;
        TLabel *lblExtCold;
        TLabel *lblAbsent;
        TLabel *lblExtDiscolored;
        TCheckBox *checkUR1;
        TCheckBox *checkUR2;
        TCheckBox *checkUR3;
        TCheckBox *checkUR4;
        TCheckBox *checkUR5;
        TCheckBox *checkLR1;
        TCheckBox *checkLR2;
        TCheckBox *checkLR3;
        TCheckBox *checkLR4;
        TCheckBox *checkLR5;
        TCheckBox *checkUL1;
        TCheckBox *checkUL2;
        TCheckBox *checkUL3;
        TCheckBox *checkUL4;
        TCheckBox *checkUL5;
        TCheckBox *checkLL1;
        TCheckBox *checkLL2;
        TCheckBox *checkLL3;
        TCheckBox *checkLL4;
        TCheckBox *checkLL5;
        TCheckBox *checkEdema;
        TLabel *lblEdemaType;
        TComboBox *cboEdemaType;
        TLabel *lblLocation;
        TEdit *editLocation;
        TLabel *lblRate;
        TEdit *editBPM;
        TLabel *lblRhythm;
        TComboBox *cboRhythm;
        TLabel *lblCapRefill;
        TEdit *editCapRefill;
        TLabel *lblComments;
        TMemo *memoComments;
        TBevel *Bevel1;
        void __fastcall btnAddClick(TObject *Sender);
private:	// User declarations
        classFilterObject cardio_filter;
        pmapstrs editing_cardio;
        pmapstrs ending_state; // for remembering what was saved
        int cardio_request;
        string editing_id;
        pvecmap editing_cardio_items; // vecmap of cardio_items data

        // cardio_itemsmap is a three-dimensional map with the following structure:
        //  [ext_pulse_types.item][body_side_types.item][extremity_types.item] = checkBoxName
        typedef map<string, map<string, map<string, string> > > cardio_itemsmap;

        cardio_itemsmap cardio_items_data;

        // struct in which extremity pulses will be returned by reading out the checkbox states
        struct cardio_save_data
        {
          string ext_pulse_id;
          string body_side_id;
          string extremity_id;
        };

        void SetupCardioItemsMap();
        TCheckBox *CheckBoxForItems(string ext_pulse_type, string body_side_type, string extremity_type);
        TCheckBox *CheckBoxForIDs(string ext_pulse_id, string body_side_id, string extremity_id);
        vector<cardio_save_data> GetExtremityPulses();

        bool Initialize();
        void Lock();
        void TaskIdChanging(const string &new_id);
        bool LockRecords();
        bool CanUnlock(bool &creating_new);
        void UpdateForEdit();
        bool SavingNew();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        void FilterAddCardio();
        void FilterEditCardio();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool IsValidOnScreen();
        string CaseForItem(string extremity_type, string body_side_type, string ext_pulse_type);
        bool WriteReport(TComponent *compositeReportCtrl);
        
        void PutUpCardioItems(pvecmap &cardio_items);
public:		// User declarations
        __fastcall TframeAssessmentCardio(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentCardio *frameAssessmentCardio;
//---------------------------------------------------------------------------
#endif
