//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentDietH
#define codeFrameAssessmentDietH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "Filter.h"
//---------------------------------------------------------------------------
class TframeAssessmentDiet : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TListView *listDiet;
        TPanel *panelDiet;
        TSplitter *Splitter1;
        TCheckBox *checkNPI;
        TLabel *lblDietType;
        TLabel *lblComments;
        TMemo *memoComments;
        TListView *listDietTypes;
        void __fastcall listDietTypesClick(TObject *Sender);
        void __fastcall checkNPIClick(TObject *Sender);
private:	// User declarations
        classFilterObject diet_filter;
        classFilterObject checks_filter;
        int diet_request;
        pvecmap editing_diet_items;
        pvecmap final_ending_state;

        bool Initialize();
        void Lock();
        void TaskIdChanging(const string &new_id);
        void UpdateForEdit();
        bool LockRecords();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        void FilterAddDiet();
        void FilterEditDiet();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool IsValidOnScreen();
        bool WriteReport(TComponent *compositeReportCtrl);

        void PutUpDietItems(pvecmap &diet_items);
        bool UpdateDietItem(int record_index, string comment);
        bool InsertDietItem(string diet_id, string comment);
        bool DeleteDietItem(int record_index);

public:		// User declarations
        __fastcall TframeAssessmentDiet(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentDiet *frameAssessmentDiet;
//---------------------------------------------------------------------------
#endif
