//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentGastroH
#define codeFrameAssessmentGastroH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "Filter.h"
//---------------------------------------------------------------------------
class TframeAssessmentGastro : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TListView *listGastro;
        TPanel *panelGastro;
        TSplitter *Splitter1;
        TCheckBox *checkNPI;
        TListView *listGastroTypes;
        TLabel *lblGastroType;
        TLabel *lblOstomy;
        TLabel *lblDrainage;
        TLabel *lblFormula;
        TLabel *lblResidual;
        TLabel *lblComments;
        TMemo *memoComments;
        TEdit *editDrainage;
        TEdit *editFormula;
        TEdit *editOstomy;
        TEdit *editResidual;
        void __fastcall listGastroTypesClick(TObject *Sender);
        void __fastcall checkNPIClick(TObject *Sender);
private:	// User declarations
        classFilterObject gastro_filter;
        classFilterObject checks_filter;
        int gastro_request;
        pvecmap editing_gastro_items;
        pvecmap final_ending_state;

        bool Initialize();
        void Lock();
        void TaskIdChanging(const string &new_id);
        void UpdateForEdit();
        bool LockRecords();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        void FilterAddGastro();
        void FilterEditGastro();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool IsValidOnScreen();
        bool WriteReport(TComponent *compositeReportCtrl);

        void PutUpGastroItems(pvecmap &gastro_items);
        bool UpdateGastroItem(int record_index, string comment);
        bool InsertGastroItem(string gastro_id, string comment);
        bool DeleteGastroItem(int record_index);

public:		// User declarations
        __fastcall TframeAssessmentGastro(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentGastro *frameAssessmentGastro;
//---------------------------------------------------------------------------
#endif
