//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentGenitourinaryH
#define codeFrameAssessmentGenitourinaryH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "Filter.h"
//---------------------------------------------------------------------------
class TframeAssessmentGenitourinary : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TListView *listGenuri;
        TPanel *panelGenuri;
        TSplitter *Splitter1;
        TCheckBox *checkNPI;
        TListView *listUrineAppearance;
        TListView *listCondition;
        TListView *listDetailed;
        TLabel *lblUrine;
        TLabel *lblConditions;
        TLabel *lblDetailed;
        TLabel *lblCatheter;
        TLabel *lblFrequency;
        TLabel *lblUrgency;
        TLabel *lblOther;
        TEdit *editFrequency;
        TEdit *editUrgency;
        TMemo *memoComments;
        TMemo *memoCatheter;
        void __fastcall checkNPIClick(TObject *Sender);
        void __fastcall listUrineAppearanceClick(TObject *Sender);
        void __fastcall listConditionClick(TObject *Sender);
        void __fastcall listDetailedClick(TObject *Sender);
private:	// User declarations
        classFilterObject genuri_filter;    // main filter

        classFilterObject urine_filter;     // checkbox filters
        classFilterObject condition_filter;
        classFilterObject detail_filter;

        int genuri_request;
        pvecmap editing_genuri_items;
        pvecmap final_ending_state;

        bool Initialize();
        void Lock();
        void TaskIdChanging(const string &new_id);
        void UpdateForEdit();
        bool LockRecords();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        void FilterAddGenUri();
        void FilterEditGenUri();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool IsValidOnScreen();
        bool WriteReport(TComponent *compositeReportCtrl);

        void PutUpGenUriItems(pvecmap &genuri_items);
        bool UpdateGenUriItem(int record_index, string comment);
        bool InsertGenUriItem(string genuri_item_id, string comment);
        bool DeleteGenUriItem(int record_index);

public:		// User declarations
        __fastcall TframeAssessmentGenitourinary(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentGenitourinary *frameAssessmentGenitourinary;
//---------------------------------------------------------------------------
#endif
