//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentIVsH
#define codeFrameAssessmentIVsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "Filter.h"
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TframeAssessmentIVs : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TToolButton *sepThree;
        TToolButton *btnAdd;
        TPanel *panelIVs;
        TLabel *lblType;
        TLabel *lblSize;
        TLabel *lblStartDate;
        TLabel *lblLocation;
        TLabel *lblDevice;
        TLabel *lblDressing;
        TLabel *lblFluid;
        TLabel *lblChangeDate;
        TComboBox *cboIVType;
        TLabel *lblSite;
        TComboBox *cboIVSite;
        TEdit *editSize;
        TEdit *editStartDate;
        TEdit *editChangeDate;
        TEdit *editLocation;
        TEdit *editDevice;
        TEdit *editDressing;
        TCheckBox *checkPrimary;
        TLabel *lblPrimaryIV;
        TStaticText *staticIVLink;
        TBitBtn *btnSetPrimary;
        TEdit *editFluid;
        TEdit *editRate;
        TLabel *lblRate;
        TButton *btnClear;
        TListView *listIVs;
        TSplitter *Splitter1;
        void __fastcall btnAddClick(TObject *Sender);
        void __fastcall btnSetPrimaryClick(TObject *Sender);
        void __fastcall staticIVLinkClick(TObject *Sender);
        void __fastcall btnClearClick(TObject *Sender);
        void __fastcall checkPrimaryClick(TObject *Sender);
private:	// User declarations
        classFilterObject iv_filter;
        pmapstrs editing_iv;
        pmapstrs ending_state; // for remembering what was saved
        int iv_request;
        string editing_id;

        string primary_iv_id;

        bool Initialize();
        void Lock();
        void TaskIdChanging(const string &new_id);
        bool LockRecords();
        bool CanUnlock(bool &creating_new);
        void UpdateForEdit();
        bool SavingNew();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        void FilterAddIV();
        void FilterEditIV();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool IsValidOnScreen();
        bool WriteReport(TComponent *compositeReportCtrl);

public:		// User declarations
        __fastcall TframeAssessmentIVs(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentIVs *frameAssessmentIVs;
//---------------------------------------------------------------------------
#endif
