//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentLimitsH
#define codeFrameAssessmentLimitsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "Filter.h"
//---------------------------------------------------------------------------
class TframeAssessmentLimits : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TListView *listLimits;
        TPanel *panelLimits;
        TSplitter *Splitter1;
        TCheckBox *checkNPI;
        TLabel *lblLimitType;
        TLabel *lblComments;
        TListView *listLimitTypes;
        TMemo *memoComments;
        TToolButton *sepThree;
        TToolButton *btnReferral;
        void __fastcall listLimitTypesClick(TObject *Sender);
        void __fastcall checkNPIClick(TObject *Sender);
        void __fastcall btnReferralClick(TObject *Sender);
private:	// User declarations
        classFilterObject limits_filter;
        classFilterObject checks_filter;
        int limits_request;
        pvecmap editing_limits_items;
        pvecmap final_ending_state;

        bool Initialize();
        void Lock();
        void TaskIdChanging(const string &new_id);
        void UpdateForEdit();
        bool LockRecords();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        void FilterAddLimits();
        void FilterEditLimits();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool IsValidOnScreen();
        bool WriteReport(TComponent *compositeReportCtrl);

        void PutUpLimitsItems(pvecmap &limits_items);
        bool UpdateLimitsItem(int record_index, string comment);
        bool InsertLimitsItem(string func_limit_id, string comment);
        bool DeleteLimitsItem(int record_index);

public:		// User declarations
        __fastcall TframeAssessmentLimits(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentLimits *frameAssessmentLimits;
//---------------------------------------------------------------------------
#endif
