//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentMuscleH
#define codeFrameAssessmentMuscleH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "Filter.h"
//---------------------------------------------------------------------------
class TframeAssessmentMuscle : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TListView *listMuscle;
        TPanel *panelMuscle;
        TSplitter *Splitter1;
        TCheckBox *checkNPI;
        TLabel *lblMSType;
        TListView *listMSTypes;
        TEdit *editAmputation;
        TEdit *editContractures;
        TEdit *editSwelling;
        TEdit *editWeakness;
        TEdit *editPain;
        TEdit *editTenderness;
        TLabel *lblAmputation;
        TLabel *lblContracture;
        TLabel *lblJointSwelling;
        TLabel *lblMuscleWeakness;
        TLabel *lblPainLocation;
        TLabel *lblTenderness;
        TLabel *lblOther;
        TMemo *memoComments;
        void __fastcall listMSTypesClick(TObject *Sender);
        void __fastcall checkNPIClick(TObject *Sender);
private:	// User declarations
        classFilterObject muscle_filter;
        classFilterObject checks_filter;
        int muscle_request;
        pvecmap editing_muscle_items;
        pvecmap final_ending_state;

        bool Initialize();
        void Lock();
        void TaskIdChanging(const string &new_id);
        void UpdateForEdit();
        bool LockRecords();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        void FilterAddMuscle();
        void FilterEditMuscle();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool IsValidOnScreen();
        bool WriteReport(TComponent *compositeReportCtrl);

        void PutUpMuscleItems(pvecmap &musculo_items);
        bool UpdateMuscleItem(int record_index, string comment);
        bool InsertMuscleItem(string musculo_item_id, string comment);
        bool DeleteMuscleItem(int record_index);

public:		// User declarations
        __fastcall TframeAssessmentMuscle(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentMuscle *frameAssessmentMuscle;
//---------------------------------------------------------------------------
#endif
