//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentNeuroH
#define codeFrameAssessmentNeuroH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "Filter.h"
//---------------------------------------------------------------------------
class TframeAssessmentNeuro : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TListView *listNeuro;
        TPanel *panelNeuro;
        TSplitter *Splitter1;
        TCheckBox *checkNPI;
        TListView *listOrientation;
        TListView *listDisposition;
        TListView *listSymptoms;
        TListView *listResponses;
        TListView *listSpeech;
        TListView *listDetailed;
        TLabel *lblOrientation;
        TLabel *lblDisposition;
        TLabel *lblSymptoms;
        TLabel *lblResponses;
        TLabel *lblSpeech;
        TLabel *lblDetailed;
        TLabel *lblOtherSpeech;
        TMemo *memoSpeech;
        TLabel *lblNumbessNotes;
        TEdit *editNumbness;
        TLabel *lblWeakness;
        TEdit *editWeakness;
        TLabel *lblTingling;
        TEdit *editTingling;
        void __fastcall checkNPIClick(TObject *Sender);
        void __fastcall listOrientationClick(TObject *Sender);
        void __fastcall listDispositionClick(TObject *Sender);
        void __fastcall listSymptomsClick(TObject *Sender);
        void __fastcall listResponsesClick(TObject *Sender);
        void __fastcall listSpeechClick(TObject *Sender);
        void __fastcall listDetailedClick(TObject *Sender);
private:	// User declarations
        classFilterObject neuro_filter;
        classFilterObject ori_filter;
        classFilterObject disp_filter;
        classFilterObject sympt_filter;
        classFilterObject resp_filter;
        classFilterObject speech_filter;
        classFilterObject detail_filter;
        int neuro_request;
        pvecmap editing_neuro_items;
        pvecmap final_ending_state;

        bool Initialize();
        void Lock();
        void TaskIdChanging(const string &new_id);
        void UpdateForEdit();
        bool LockRecords();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        void FilterAddNeuro();
        void FilterEditNeuro();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool IsValidOnScreen();
        bool WriteReport(TComponent *compositeReportCtrl);

        void PutUpNeuroItems(pvecmap &neuro_items);
        bool UpdateNeuroItem(int record_index, string comment);
        bool InsertNeuroItem(string neuro_item_id, string comment);
        bool DeleteNeuroItem(int record_index);

public:		// User declarations
        __fastcall TframeAssessmentNeuro(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentNeuro *frameAssessmentNeuro;
//---------------------------------------------------------------------------
#endif
