//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentNotesH
#define codeFrameAssessmentNotesH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>
#include "Filter.h"
//---------------------------------------------------------------------------
class TframeAssessmentNotes : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TRichEdit *editTaskNote;
        TListView *listNotes;
        TSplitter *Splitter1;
        TToolButton *btnAdd;
        TToolButton *ToolButton2;
        void __fastcall btnAddClick(TObject *Sender);
        void __fastcall editTaskNoteChange(TObject *Sender);
        void __fastcall listNotesSelectItem(TObject *Sender,
          TListItem *Item, bool Selected);
private:	// User declarations
        classFilterObject notes_filter;
        map<string, string> editing_note;
        map<string, string> ending_state; // for remembering what was saved
        int notes_request;
        string editing_id;

        void TaskIdChanging(const string &new_id);
        bool CanUnlock(bool &creating_new);
        bool LockRecords();
        void UpdateForEdit();
        bool SavingNew();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();

        void FilterAddNote();
        void FilterEditNote();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();

        bool WriteReport(TComponent *compositeReportCtrl);

public:		// User declarations
        __fastcall TframeAssessmentNotes(TComponent* Owner);

        bool Initialize();
        void Lock();
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentNotes *frameAssessmentNotes;
//---------------------------------------------------------------------------
#endif
