//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentReferralsH
#define codeFrameAssessmentReferralsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "codeFrameFilterBar.h"
#include "codePaddedBox.h"
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TframeAssessmentReferrals : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TToolButton *sepThree;
        TToolButton *btnAdd;
        TListView *listRefs;
        TPanel *panelRef;
        TSplitter *Splitter1;
        TPaddedBox *paddedBox;
        TListView *listRefNotes;
        TframeFilterBar *frameRefNoteBar;
        TLabel *lblDate;
        TEdit *editDate;
        TLabel *lblStatus;
        TComboBox *cboStatus;
        TLabel *lblReason;
        TComboBox *cboReason;
        TGroupBox *groupReferredBy;
        TLabel *lblByFacility;
        TLabel *lblByProvider;
        TBitBtn *btnByFacilitySearch;
        TBitBtn *btnByProviderSearch;
        TGroupBox *groupReferredTo;
        TLabel *lblToFacility;
        TLabel *lblToProvider;
        TBitBtn *btnToFacilitySearch;
        TBitBtn *btnToProviderSearch;
        TStaticText *txtByFacility;
        TStaticText *txtByProvider;
        TStaticText *txtToFacility;
        TStaticText *txtToProvider;
        TLabel *lblNotes;
        void __fastcall btnAddClick(TObject *Sender);
        void __fastcall listRefsSelectItem(TObject *Sender,
          TListItem *Item, bool Selected);
        void __fastcall btnByFacilitySearchClick(TObject *Sender);
        void __fastcall btnByProviderSearchClick(TObject *Sender);
        void __fastcall btnToFacilitySearchClick(TObject *Sender);
        void __fastcall btnToProviderSearchClick(TObject *Sender);
private:	// User declarations
        classFilterObject refs_filter;
        classFilterObject refnotes_filter;
        pmapstrs editing_ref;
        pmapstrs ending_state; // for remembering what was saved
        int refs_request;
        string editing_id;

        // Overrides and filter handlers
        bool Initialize();
        void Lock();
        void TaskIdChanging(const string &new_id);
        bool LockRecords();
        bool CanUnlock(bool &creating_new);
        void UpdateForEdit();
        bool SavingNew();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        void FilterAddRef();
        void FilterEditRef();
        void FilterAddRefNote();
        void FilterEditRefNote();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool IsValidOnScreen();
        bool WriteReport(TComponent *compositeReportCtrl);

        // Private utils
        void BlankLinks();

public:		// User declarations
        __fastcall TframeAssessmentReferrals(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentReferrals *frameAssessmentReferrals;
//---------------------------------------------------------------------------
#endif
