//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentRespiratoryH
#define codeFrameAssessmentRespiratoryH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "Filter.h"
//---------------------------------------------------------------------------
class TframeAssessmentRespiratory : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TListView *listResp;
        TPanel *panelResp;
        TSplitter *Splitter1;
        TToolButton *sepThree;
        TToolButton *btnAdd;
        TCheckBox *checkNPI;
        TCheckBox *checkIrregular;
        TCheckBox *checkLabored;
        TCheckBox *checkSOB;
        TGroupBox *groupProblems;
        TLabel *lblName;
        TLabel *lblRight;
        TLabel *lblLeft;
        TLabel *lblFrictionRub;
        TLabel *lblCrackles;
        TLabel *lblWheezes;
        TLabel *lblAbsent;
        TLabel *lblDiminished;
        TLabel *lblRhonchi;
        TLabel *lblChestTube;
        TCheckBox *check1R;
        TCheckBox *check2R;
        TCheckBox *check3R;
        TCheckBox *check4R;
        TCheckBox *check5R;
        TCheckBox *check6R;
        TCheckBox *check7R;
        TCheckBox *check1L;
        TCheckBox *check2L;
        TCheckBox *check3L;
        TCheckBox *check4L;
        TCheckBox *check5L;
        TCheckBox *check6L;
        TCheckBox *check7L;
        TLabel *lblSuction;
        TLabel *lblOxygen;
        TLabel *lblBiPap;
        TLabel *lblCough;
        TLabel *lblSmoker;
        TLabel *lblPpd;
        TLabel *lblYears;
        TLabel *lblComments;
        TEdit *editSuction;
        TEdit *editOxygen;
        TEdit *editBiPap;
        TComboBox *cboCough;
        TEdit *editPpd;
        TEdit *editYears;
        TMemo *memoComments;
        void __fastcall btnAddClick(TObject *Sender);
private:	// User declarations
        classFilterObject resp_filter;
        pmapstrs editing_resp;
        pmapstrs ending_state; // for remembering what was saved
        int resp_request;
        string editing_id;
        pvecmap editing_resp_items; // vecmap of respiratory_items data

        struct respiratory_items_data
        {
          const char *respiratory_type; // Name of respiratory_types item that corresponds to these checkboxes
          const char *controlNameR;     // Right checkbox control name
          const char *controlNameL;     // Left  checkbox control name
        };
        static respiratory_items_data respiratory_items[];
        static respiratory_items_data *DataForRespiratoryID(const string &id);

        bool Initialize();
        void Lock();
        void TaskIdChanging(const string &new_id);
        bool LockRecords();
        bool CanUnlock(bool &creating_new);
        void UpdateForEdit();
        bool SavingNew();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        void FilterAddResp();
        void FilterEditResp();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool IsValidOnScreen();
        bool WriteReport(TComponent *compositeReportCtrl);

        void PutUpRespiratoryItems(pvecmap &resp_items);
        void GetRespItemsAsMap(pmapstrs &to_return);
        string CaseForItem(string body_side_type, string respiratory_type);

public:		// User declarations
        __fastcall TframeAssessmentRespiratory(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentRespiratory *frameAssessmentRespiratory;
//---------------------------------------------------------------------------
#endif
