//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentSafetyH
#define codeFrameAssessmentSafetyH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "Filter.h"
//---------------------------------------------------------------------------
class TframeAssessmentSafety : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TListView *listSafety;
        TPanel *panelSafety;
        TSplitter *Splitter1;
        TCheckBox *checkNPI;
        TLabel *lblSafetyType;
        TListView *listSafetyTypes;
        TLabel *lblComments;
        TRichEdit *editComments;
        TToolButton *ToolButton1;
        TToolButton *btnReferral;
        void __fastcall listSafetyTypesClick(TObject *Sender);
        void __fastcall checkNPIClick(TObject *Sender);
        void __fastcall btnReferralClick(TObject *Sender);
private:	// User declarations
        classFilterObject safety_filter;
        classFilterObject checks_filter;
        int safety_request;
        pvecmap editing_safety_items;
        pvecmap final_ending_state;

        bool Initialize();
        void Lock();
        void TaskIdChanging(const string &new_id);
        void UpdateForEdit();
        bool LockRecords();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        void FilterAddSafety();
        void FilterEditSafety();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool IsValidOnScreen();
        bool WriteReport(TComponent *compositeReportCtrl);

        void PutUpSafetyItems(pvecmap &safety_items);
        bool UpdateSafetyItem(int record_index, string comment);
        bool InsertSafetyItem(string safety_id, string comment);
        bool DeleteSafetyItem(int record_index);

public:		// User declarations
        __fastcall TframeAssessmentSafety(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentSafety *frameAssessmentSafety;
//---------------------------------------------------------------------------
#endif
