//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentSensoryH
#define codeFrameAssessmentSensoryH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "Filter.h"
//---------------------------------------------------------------------------
class TframeAssessmentSensory : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TListView *listSensory;
        TPanel *panelSensory;
        TSplitter *Splitter1;
        TCheckBox *checkNPI;
        TLabel *lblSafetyType;
        TListView *listSensoryTypes;
        TLabel *lblCataracts;
        TLabel *lblGlaucoma;
        TLabel *lblProsthesis;
        TLabel *lblDeafness;
        TLabel *lblHoH;
        TLabel *lblHearingAid;
        TLabel *lblTinnitus;
        TBevel *Bevel1;
        TComboBox *cboCataracts;
        TComboBox *cboGlaucoma;
        TComboBox *cboProsthesis;
        TComboBox *cboDeafness;
        TComboBox *cboHOH;
        TComboBox *cboHearingAid;
        TComboBox *cboTinnitus;
        TLabel *lblOtherVision;
        TMemo *memoOtherVision;
        TLabel *Label1;
        TMemo *memoOtherHearing;
        void __fastcall listSensoryTypesClick(TObject *Sender);
        void __fastcall checkNPIClick(TObject *Sender);
private:	// User declarations
        classFilterObject sensory_filter;
        classFilterObject checks_filter;
        int sensory_request;
        pvecmap editing_sensory_items;
        pvecmap final_ending_state;

        bool Initialize();
        void Lock();
        void TaskIdChanging(const string &new_id);
        void UpdateForEdit();
        bool LockRecords();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        void FilterAddSensory();
        void FilterEditSensory();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool IsValidOnScreen();
        bool WriteReport(TComponent *compositeReportCtrl);

        void PutUpSensoryItems(pvecmap &safety_items);
        bool UpdateSensoryItem(int record_index, string body_side_id, string comment);
        bool InsertSensoryItem(string sensory_id, string body_side_id, string comment);
        bool DeleteSensoryItem(int record_index);
        TComboBox *ComboBoxForSensoryType(const string &sensory_type);

public:		// User declarations
        __fastcall TframeAssessmentSensory(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentSensory *frameAssessmentSensory;
//---------------------------------------------------------------------------
#endif
