//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentSkinH
#define codeFrameAssessmentSkinH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "Filter.h"
//---------------------------------------------------------------------------
class TframeAssessmentSkin : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TListView *listSkin;
        TPanel *panelSkin;
        TSplitter *Splitter1;
        TCheckBox *checkNPI;
        TLabel *lblQualities;
        TLabel *lblFeatures;
        TListView *listQualities;
        TListView *listFeatures;
        TEdit *editOtherFeature;
        TEdit *editOtherQuality;
        TEdit *editDressing;
        TLabel *lblOtherQuality;
        TLabel *lblOtherFeature;
        TLabel *lblDressing;
        void __fastcall checkNPIClick(TObject *Sender);
        void __fastcall listQualitiesClick(TObject *Sender);
        void __fastcall listFeaturesClick(TObject *Sender);
private:	// User declarations
        classFilterObject skin_filter;
        classFilterObject qualities_filter;
        classFilterObject features_filter;
        int skin_request;
        pvecmap editing_skin_items;
        pvecmap final_ending_state;

        bool Initialize();
        void Lock();
        void TaskIdChanging(const string &new_id);
        void UpdateForEdit();
        bool LockRecords();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        void FilterAddSkin();
        void FilterEditSkin();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool IsValidOnScreen();
        bool WriteReport(TComponent *compositeReportCtrl);

        void PutUpSkinItems(pvecmap &skin_items);
        bool UpdateSkinItem(int record_index, string comment);
        bool InsertSkinItem(string skin_assessment_id, string comment);
        bool DeleteSkinItem(int record_index);

public:		// User declarations
        __fastcall TframeAssessmentSkin(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentSkin *frameAssessmentSkin;
//---------------------------------------------------------------------------
#endif
