//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentVitalsH
#define codeFrameAssessmentVitalsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>
#include "Filter.h"
#include <Grids.hpp>
#include <Db.hpp>
#include <IBCustomDataSet.hpp>
#include <IBDatabase.hpp>
//---------------------------------------------------------------------------
class TframeAssessmentVitals : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TPanel *panelVitals;
        TListView *listVitalsDisplay;
        TSplitter *Splitter1;
        TStringGrid *gridVitalsEntry;
        TDateTimePicker *dateObservation;
        TToolButton *sepThree;
        void __fastcall gridVitalsEntryDrawCell(TObject *Sender, int ACol,
          int ARow, TRect &Rect, TGridDrawState State);
        void __fastcall gridVitalsEntrySelectCell(TObject *Sender,
          int ACol, int ARow, bool &CanSelect);
        void __fastcall gridVitalsEntrySetEditText(TObject *Sender,
          int ACol, int ARow, const AnsiString Value);
        void __fastcall gridVitalsEntryGetEditText(TObject *Sender,
          int ACol, int ARow, AnsiString &Value);
        void __fastcall dateObservationChange(TObject *Sender);
private:	// User declarations
        classFilterObject historical_filter; // historical data filter
        int historical_request;              // historical filter refresh
        pmapstrs obs_set_map;                // map of observation set data
        string   editing_id;                 // ID of record being unlocked
        pmapstrs editing_obs_set;            // full observation set record being edited
        pmapstrs ending_state;

        pvecmap      all_questions;           // All Vitals observation questions, queried from the database
        pvecmap      all_answers;             // Answers accumulated during validation
        pmapstrtoint question_id_to_rownum;   // Map for looking up a string grid row by obs_questions ID
        pmapinttostr rownum_to_question_id;   // Inverse mapping
        pmapints     rownum_to_all_questions; // Map from row numbers to indices into the all_questions vecmap

        string remembering_text;              // Some TStringGrid support for remembering the value it started with

        // overrides
        bool Initialize();
        void FirstVisible();
        void Lock();
        void TaskIdChanging(const string &new_id);
        bool LockRecords();
        bool CanUnlock(bool &creating_new);
        void UpdateForEdit();
        bool SavingNew();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool IsValidOnScreen();
        void PutUpCurrentVitals(string obs_set_id, TIBTransaction *dbTransaction);
        void ClearVitalsDisplay();
        void RefreshObsSetMap(const string &task_id);
        bool WriteReport(TComponent *compositeReportCtrl);

public:		// User declarations
        __fastcall TframeAssessmentVitals(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentVitals *frameAssessmentVitals;
//---------------------------------------------------------------------------
#endif
