//---------------------------------------------------------------------------

#ifndef codeFrameAssessmentWoundH
#define codeFrameAssessmentWoundH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include "Filter.h"
//---------------------------------------------------------------------------
class TframeAssessmentWound : public TframeAssessmentGeneric
{
__published:	// IDE-managed Components
        TListView *listWounds;
        TPanel *panelWound;
        TSplitter *Splitter1;
        TToolButton *sepThree;
        TToolButton *btnAdd;
        TLabel *lblLength;
        TEdit *editLength;
        TLabel *lblWidth;
        TEdit *editWidth;
        TLabel *lblDepth;
        TEdit *editDepth;
        TLabel *lblTunneling;
        TEdit *editTunnelPos;
        TLabel *lblMaxDistance;
        TLabel *lblMinDistance;
        TEdit *editMaxDistance;
        TEdit *editMinDistance;
        TLabel *lblSinusTractPos;
        TEdit *editSinusPos;
        TLabel *lblExudateAmt;
        TComboBox *cboExudateAmt;
        TLabel *lblExudateType;
        TComboBox *cboExudateType;
        TLabel *lblOtherType;
        TEdit *editOtherType;
        TLabel *lblOdor;
        TComboBox *cboOdor;
        TLabel *lblMargins;
        TComboBox *cboMargins;
        TLabel *lblOtherMargin;
        TEdit *editOtherMargin;
        TLabel *lblPain;
        TEdit *editPain;
        TLabel *lblPeriTemp;
        TComboBox *cboPeriTemp;
        TLabel *lblPeriTexture;
        TComboBox *cboPeriTexture;
        TBevel *Bevel1;
        TBevel *Bevel2;
        TLabel *lblColors;
        TLabel *lblWoundBase;
        TComboBox *cboColorPresent;
        TComboBox *cboWoundBase;
        TBevel *Bevel3;
        TLabel *lblSlough;
        TEdit *editSlough;
        TLabel *Label1;
        TEdit *editEschar;
        TLabel *lblGranulation;
        TEdit *editGranulation;
        TLabel *lblGranColor;
        TEdit *editGranColor;
        TBevel *Bevel4;
        TLabel *lblCleansing;
        TEdit *editCleansing;
        TLabel *lblDressings;
        TEdit *editDressings;
        TLabel *lblLocation;
        TEdit *editLocation;
        TLabel *lblComments;
        TRichEdit *editComments;
        void __fastcall btnAddClick(TObject *Sender);
private:	// User declarations
        classFilterObject wound_filter;
        pmapstrs editing_wound;
        pmapstrs ending_state; // for remembering what was saved
        int      wound_request;
        string   editing_id;

        bool ValidateInteger(TEdit *editBox, int min_value, int max_value, const char *name);
        bool ValidateLookup(TComboBox *cboTheBox, const char *lookupTableName, const char *name);

        bool Initialize();
        void Lock();
        void TaskIdChanging(const string &new_id);
        bool LockRecords();
        bool CanUnlock(bool &creating_new);
        void UpdateForEdit();
        bool SavingNew();
        bool IsValidOnScreen();
        bool DoSaveData();
        void SetViewMode();
        void SetEditMode();
        void FilterAddWound();
        void FilterEditWound();
        bool AtlasNotify(int request_num, string matched_value);
        void SendAtlas();
        bool WriteReport(TComponent *compositeReportCtrl);

public:		// User declarations
        __fastcall TframeAssessmentWound(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeAssessmentWound *frameAssessmentWound;
//---------------------------------------------------------------------------
#endif
