//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeFrameCodeTaxonomy.h"
#include "codeSearchCode.h"
#include "query_load_save.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TframeCodeTaxonomy *frameCodeTaxonomy;
//---------------------------------------------------------------------------
__fastcall TframeCodeTaxonomy::TframeCodeTaxonomy(TComponent* Owner)
        : TFrame(Owner)
{
 Type = txn_condition;
 editCodes->Lines->Clear(); // for some reason, ->Text = "" doesn't work in the constructor, but works elsewhere?
}
//---------------------------------------------------------------------------
void __fastcall TframeCodeTaxonomy::buttonActionsClick(TObject *Sender)
{
 popupTaxonomyActions->PopupComponent = (TComponent*)Sender;
 popupTaxonomyActions->Popup(((TWinControl*)Sender)->ClientOrigin.x, ((TWinControl*)Sender)->ClientOrigin.y + ((TWinControl*)Sender)->Height);
}
//---------------------------------------------------------------------------
void __fastcall TframeCodeTaxonomy::menuLoadTaxonomyClick(TObject *Sender)
{
 xValue possibly_loaded = QueryLoad((Type == txn_condition ? "conditions" : "procedures"), qf_taxonomy);
 if (!possibly_loaded.empty())
  this->xCodeDescription = possibly_loaded;
}
//---------------------------------------------------------------------------
void __fastcall TframeCodeTaxonomy::menuSaveTaxonomyClick(TObject *Sender)
{
 QuerySave((Type == txn_condition ? "conditions" : "procedures"), qf_taxonomy, this->xCodeDescription);
}
//---------------------------------------------------------------------------
void __fastcall TframeCodeTaxonomy::buttonLoadTaxonomyClick(TObject *Sender)
{
 menuLoadTaxonomy->Click();
}
//---------------------------------------------------------------------------
void __fastcall TframeCodeTaxonomy::buttonInstructionsClick(TObject *Sender)
{
 PSay(code_matches_help, m_message, MB_OK, "TframeCodeTaxonomy");
}
//---------------------------------------------------------------------------
void __fastcall TframeCodeTaxonomy::menuAddCodesClick(TObject *Sender)
{
 vector<string> id_to_add;
 if (Type == txn_condition)
  id_to_add = TformSearchCode::Do(NULL, lookupTables->IdOf("code_types", "ICD-9"));
 else
  id_to_add = TformSearchCode::Do(NULL, lookupTables->IdOf("code_types", "CPT-4"));

 if (id_to_add.empty())
  return;
 vector<string> code_to_add;
 if (!SqlToVec(dbDatabase, "select code from codes where id in (" + VecToCommaString(id_to_add) + ") order by code", code_to_add))
  PSay("Failed to grab codes you requested", m_database_error, MB_OK, "TframeCodeTaxonomy");
 for (vector<string>::iterator i = code_to_add.begin(); i != code_to_add.end(); i++)
  editCodes->Text = editCodes->Text + (string(editCodes->Text == "" ? "" : ", ") + *i).c_str();
 editCodes->SetFocus();
}
//---------------------------------------------------------------------------
bool __fastcall TframeCodeTaxonomy::IsValid()
{
 if (xToCodeMatchingSql(xFromCodeDescription(editCodes->Text.c_str()), "anything") == "")
  return false;
 return true;
}
//---------------------------------------------------------------------------
string __fastcall TframeCodeTaxonomy::GetSQL()
{
 string field_name;
 if (Type == txn_condition)
  field_name = "conditions.code";
 else
  field_name = "procedures.cpt_hcpcs";
 return xToCodeMatchingSql(xFromCodeDescription(editCodes->Text.c_str()), field_name);
}
//---------------------------------------------------------------------------
taxonomy_types __fastcall TframeCodeTaxonomy::GetType()
{
 return FType;
}
//---------------------------------------------------------------------------
void __fastcall TframeCodeTaxonomy::SetType(taxonomy_types Value)
{
 FType = Value;
}
//---------------------------------------------------------------------------
xValue __fastcall TframeCodeTaxonomy::GetDescription()
{
 return xFromCodeDescription(editCodes->Text.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TframeCodeTaxonomy::SetDescription(xValue Value)
{
 if (xTag(Value) == "code_matches")
  editCodes->Text = xToCodeDescription(Value).c_str();
 else
  editCodes->Text = "";
}
//---------------------------------------------------------------------------
string __fastcall TframeCodeTaxonomy::GetText()
{
 return editCodes->Text.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TframeCodeTaxonomy::SetText(string Value)
{
 editCodes->Text = Value.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TframeCodeTaxonomy::SetBoxColor(TColor Value)
{
 editCodes->Color = Value;
}
//---------------------------------------------------------------------------
