//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "tcpip_messaging.h"
#include "codeFrameDependencyGraph.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TframeDependencyGraph *frameDependencyGraph;
//---------------------------------------------------------------------------
__fastcall TframeDependencyGraph::TframeDependencyGraph(TComponent* Owner)
        : TFrame(Owner)
{
 // defaults, set again because they seem -not- to be set by the default=value clause in __property's
 node_drag  = NULL;
 FActive    = false;
 FBandColor = clSilver;
 FBandWidth = 30;
 FPadding   = 10;

 // tensor_angular<3> bob(NULL, NULL, 5.00, M_PI / 8, t_vector<3>(3, 0.00, 0.00, 0.00));

 // not accessible via ide gui designer
 scrollDependencyGraph->DoubleBuffered = true;
}
//---------------------------------------------------------------------------
void __fastcall TframeDependencyGraph::paintDependencyGraphMouseDown(
      TObject *Sender, TMouseButton Button, TShiftState Shift, int X,
      int Y)
{
 //
}
//---------------------------------------------------------------------------
void __fastcall TframeDependencyGraph::paintDependencyGraphMouseMove(
      TObject *Sender, TShiftState Shift, int X, int Y)
{
 //
}
//---------------------------------------------------------------------------
void __fastcall TframeDependencyGraph::paintDependencyGraphMouseUp(
      TObject *Sender, TMouseButton Button, TShiftState Shift, int X,
      int Y)
{
 //
}
//---------------------------------------------------------------------------
void __fastcall TframeDependencyGraph::paintDependencyGraphPaint(
      TObject *Sender)
{
 // if (!FActive)
 //  return;

 // clear the area
 // just in case
 paintDependencyGraph->Canvas->Brush->Style = bsSolid;

 // paintDependencyGraph->Canvas->Brush->Color = clWindow;
 // paintDependencyGraph->Canvas->FillRect(TRect(0, 0, paintDependencyGraph->Width, paintDependencyGraph->Height));
 paintDependencyGraph->Canvas->Brush->Color = FBandColor;
 for (unsigned int i = 0; i < bands_of_items.size(); i++)
 {
  if (i % 2)
   paintDependencyGraph->Canvas->FillRect(TRect(i * FBandWidth, 0, (i + 1) * FBandWidth, paintDependencyGraph->Height));
 }

 // draw lines
 if (FOnDrawEdge)
  for (list<tensor_base<3> *>::iterator i = world.tensors.begin(); i != world.tensors.end(); i++)
  {
   TPoint a((*i)->node_a->position[0] + FBandWidth / 2.00, (*i)->node_a->position[1] + FPadding);
   TPoint b((*i)->node_b->position[0] + FBandWidth / 2.00, (*i)->node_b->position[1] + FPadding);
   // TPoint a((*i)->node_b->position[0] + FPadding, (*i)->node_b->position[1] + FPadding);
   // TPoint b((*i)->node_b->position[0] + FPadding, (*i)->node_b->position[1] + FPadding);
   FOnDrawEdge(this, paintDependencyGraph->Canvas, nodes_to_items[(*i)->node_a], a, nodes_to_items[(*i)->node_b], b);
  }
 else
 {
  // just in case
  paintDependencyGraph->Canvas->Pen->Color = clBlack;
  paintDependencyGraph->Canvas->Pen->Width = 1;
  paintDependencyGraph->Canvas->Pen->Style = psSolid; // psDash;
  paintDependencyGraph->Canvas->Pen->Mode  = pmCopy;
  for (list<tensor_base<3> *>::iterator i = world.tensors.begin(); i != world.tensors.end(); i++)
  {
   TPoint a((*i)->node_a->position[0] + FBandWidth / 2.00, (*i)->node_a->position[1] + FPadding);
   TPoint b((*i)->node_b->position[0] + FBandWidth / 2.00, (*i)->node_b->position[1] + FPadding);
   // TPoint a((*i)->node_b->position[0] + FPadding, (*i)->node_b->position[1] + FPadding);
   // TPoint b((*i)->node_b->position[0] + FPadding, (*i)->node_b->position[1] + FPadding);
   DefaultDrawEdge(this, paintDependencyGraph->Canvas, nodes_to_items[(*i)->node_a], a, nodes_to_items[(*i)->node_b], b);
  }
 }
 
 // draw nodes
 if (FOnDrawEdge)
  for (list<node_base<3> *>::iterator i = world.nodes.begin(); i != world.nodes.end(); i++)
  {
   TPoint p((*i)->position[0] + FBandWidth / 2.00, (*i)->position[1] + FPadding);
   // TPoint p((*i)->position[0] + FPadding, (*i)->position[1] + FPadding);
   FOnDrawNode(this, paintDependencyGraph->Canvas, nodes_to_items[(*i)], p);
  }
 else
 {
  // just in case
  paintDependencyGraph->Canvas->Pen->Color = clBlack;
  paintDependencyGraph->Canvas->Pen->Width = 1;
  paintDependencyGraph->Canvas->Pen->Style = psSolid;
  paintDependencyGraph->Canvas->Pen->Mode  = pmCopy;
  // just in case
  paintDependencyGraph->Canvas->Brush->Color = clWhite;
  paintDependencyGraph->Canvas->Brush->Style = bsSolid;
  for (list<node_base<3> *>::iterator i = world.nodes.begin(); i != world.nodes.end(); i++)
  {
   TPoint p((*i)->position[0] + FBandWidth / 2.00, (*i)->position[1] + FPadding);
   // TPoint p((*i)->position[0] + FPadding, (*i)->position[1] + FPadding);
   DefaultDrawNode(this, paintDependencyGraph->Canvas, nodes_to_items[(*i)], p);
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeDependencyGraph::paintDependencyGraphClick(
      TObject *Sender)
{
 //
}
//---------------------------------------------------------------------------
void __fastcall TframeDependencyGraph::paintDependencyGraphContextPopup(
      TObject *Sender, TPoint &MousePos, bool &Handled)
{
 //
}
//---------------------------------------------------------------------------
void __fastcall TframeDependencyGraph::paintDependencyGraphDblClick(
      TObject *Sender)
{
 //
}
//---------------------------------------------------------------------------
void TframeDependencyGraph::ResetNodePositions ()
{
 dimension min_y = paintDependencyGraph->Height;
 for (list<node_base<3> *>::iterator i = world.nodes.begin(); i != world.nodes.end(); i++)
  min_y = min(min_y, (*i)->position[1]);

 node_base<3> * u;
 map<string, node_base<3> *>::iterator v;
 for (unsigned int i = 0; i < bands_of_items.size(); i++)
  for (set<string>::iterator j = bands_of_items[i].begin(); j != bands_of_items[i].end(); j++)
  {
   v = items_to_nodes.find(*j);
   if (v != items_to_nodes.end())
   {
    u = v->second;
    if (u)
    {
     u->position[0] = (i * FBandWidth);
     u->position[1] -= min_y;
     /*
     if (u->position[1] < 0.00)
     {
      u->position[1] = 0.00; ((rand() / (RAND_MAX + 0.0)) * 0.50);
      u->velocity *= -1.00;
     }
     */
    }
   }
  }
}
//---------------------------------------------------------------------------
bool TframeDependencyGraph::ResetPaintboxExtents ()
{
 bool answer = false;

 dimension max_height = 0.00;
 for (list<node_base<3> *>::iterator i = world.nodes.begin(); i != world.nodes.end(); i++)
  max_height = max(max_height, (*i)->position[1]);
 max_height += 2 * FPadding;

 int new_width = int(bands_of_items.size() * FBandWidth);
 if (new_width != paintDependencyGraph->Width)
  paintDependencyGraph->Width = new_width, answer = true;

 int new_height = max(scrollDependencyGraph->ClientHeight, int(max_height));
 if (new_height != paintDependencyGraph->Height)
  paintDependencyGraph->Height = new_height, answer = true;

 return answer;
}
//---------------------------------------------------------------------------
void __fastcall TframeDependencyGraph::SetActive(bool Value)
{
 FActive = Value;
 timerSimulateDependencyGraph->Enabled = Value;
}
//---------------------------------------------------------------------------
void __fastcall TframeDependencyGraph::SetBandColor(TColor Value)
{
 FBandColor = Value;
 scrollDependencyGraph->Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TframeDependencyGraph::SetBandWidth(unsigned int Value)
{
 FBandWidth = Value;
 // not ideal as some tensors span several widths!
 for (list<tensor_base<3> *>::iterator i = world.tensors.begin(); i != world.tensors.end(); i++)
  (*i)->size = FBandWidth;
 ResetNodePositions();
 if (!ResetPaintboxExtents())
  scrollDependencyGraph->Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TframeDependencyGraph::SetPadding(unsigned int Value)
{
 FPadding = Value;
 if (!ResetPaintboxExtents())
  scrollDependencyGraph->Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TframeDependencyGraph::DefaultDrawNode (System::TObject* Sender, Graphics::TCanvas* Canvas, std::string Item, Windows::TPoint Point)
{
/*
 // just in case
 Canvas->Pen->Color = clBlack;
 Canvas->Pen->Width = 1;
 Canvas->Pen->Style = psSolid;
 Canvas->Pen->Mode  = pmCopy;
 // just in case
 Canvas->Brush->Color = clWhite;
 Canvas->Brush->Style = bsSolid;
*/
 // roundish thing
 Canvas->Ellipse(Point.x - 5, Point.y - 5, Point.x + 5, Point.y + 5);
}
//---------------------------------------------------------------------------
void __fastcall TframeDependencyGraph::DefaultDrawEdge (System::TObject* Sender, Graphics::TCanvas* Canvas, std::string ItemA, Windows::TPoint PointA, std::string ItemB, Windows::TPoint PointB)
{
/*
 // just in case
 Canvas->Pen->Color = clBlack;
 Canvas->Pen->Width = 1;
 Canvas->Pen->Style = psSolid; // psDash;
 Canvas->Pen->Mode  = pmCopy;
*/
 // simple dashed line
 Canvas->MoveTo(PointA.x, PointA.y);
 Canvas->LineTo(PointB.x, PointB.y);
}
//---------------------------------------------------------------------------
void TframeDependencyGraph::SetDependencies (const map<string, set<string> > & item_dependencies, const vector<pair<string, string> > & item_relationships)
{
 // clear
 for (list<node_base<3> *>::iterator i = world.nodes.begin(); i != world.nodes.end(); i++)
  delete *i;
 for (list<tensor_base<3> *>::iterator i = world.tensors.begin(); i != world.tensors.end(); i++)
  delete *i;

 items_to_requirements.clear();
 bands_of_items.clear();
 nodes_to_items.clear();
 items_to_nodes.clear();
 world.nodes.clear();
 world.tensors.clear();
 node_drag = NULL;

 // calculate
 // ignore errors?
 dependency_graph (item_dependencies, bands_of_items, true);

 // setup nodes
 node_base<3> * temp_node = NULL;
 for (unsigned int i = 0; i < bands_of_items.size(); i++)
  for (set<string>::iterator k = bands_of_items[i].begin(); k != bands_of_items[i].end(); k++)
  {
   // ((rand() / (RAND_MAX + 0.0)) * max_wanted)
   t_vector<3> temp_vector(3, 1.00 * i * FBandWidth, ((rand() / (RAND_MAX + 0.0)) * 200.00), ((rand() / (RAND_MAX + 0.0)) * 10.00) - 5.00);
   temp_node = new node_standard<3>(temp_vector,                             // position
                                    100.00,                                  // mass
                                    0.87,                                    // drag
                                    0.00,                                    // min_vel
                                    300.00,                                  // charge
                                    false);                                  // infinite mass (dragging)
   world.nodes.push_back(temp_node);
   items_to_nodes[*k] = temp_node;
   nodes_to_items[temp_node] = *k;
  }

 // copy dependencies
 items_to_requirements = item_dependencies;

 // setup tensors
 tensor_base<3> * temp_tensor = NULL;
 for (map<string, set<string> >::iterator i = items_to_requirements.begin(); i != items_to_requirements.end(); i++)
  for (set<string>::iterator k = i->second.begin(); k != i->second.end(); k++)
  {
   // t_vector<3> new_center;
   // new_center = t_vector<3> (3, 100.00, 100.00, 100.00);
   // temp_tensor = new tensor_angular<3>(items_to_nodes[i->first], items_to_nodes[*k], 1.00, M_PI / 8.00, new_center);
   temp_tensor = new tensor_standard<3>(items_to_nodes[i->first], // a
                                        items_to_nodes[*k],       // b
                                        5.00,                     // tension
                                        FBandWidth / 2.00);       // size
   world.tensors.push_back(temp_tensor);
  }

 // setup extra tensors
 items_to_items = item_relationships;
 for (vector<pair<string, string> >::iterator i = items_to_items.begin(); i != items_to_items.end(); i++)
 {
  // t_vector<3> new_center;
  // new_center = t_vector<3> (3, 100.00, 100.00, 100.00);
  // tensor_angular<3> * temp_tensor2 = new tensor_angular<3>(items_to_nodes[i->first], items_to_nodes[i->second], 1.00, M_PI / 8.00, new_center);
  // temp_tensor = temp_tensor2;
  temp_tensor = new tensor_standard<3>(items_to_nodes[i->first],  // a
                                       items_to_nodes[i->second], // b
                                       5.00,                      // tension
                                       FBandWidth / 2.00);        // size
  // PSay ("A and B:" + IntToString((unsigned int)(void*)(items_to_nodes[i->first])) + ", " + IntToString((unsigned int)(void*)(items_to_nodes[i->second])), m_debug, MB_OK, "TFrameDependencyGraph");
  // if (!(temp_tensor->node_a) || !(temp_tensor->node_b))
  //  PSay("At least one side of the segment is missing!", m_debug, MB_OK, "TFrameDependencyGraph");
  // if (temp_tensor)
  world.tensors.push_back(temp_tensor);
 }

 // go!
 ResetNodePositions();
 if (!ResetPaintboxExtents())
  scrollDependencyGraph->Refresh();

}
//---------------------------------------------------------------------------
TDGNodeState TframeDependencyGraph::GetNodeState (string item)
{
 TDGNodeState answer;
 // TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO TODO
 // throw if not found
 return answer;
}
//---------------------------------------------------------------------------
void __fastcall TframeDependencyGraph::timerSimulateDependencyGraphTimer(
      TObject *Sender)
{
 // timerSimulateDependencyGraph->Enabled = false;
 // add forces for node-to-node push inside of each set (only)
 set<string>::iterator k;
 for (unsigned int i = 0; i < bands_of_items.size(); i++)
  for (set<string>::iterator j = bands_of_items[i].begin(); j != bands_of_items[i].end(); j++)
  {
   k = j;
   for (k++; k != bands_of_items[i].end(); k++)
    items_to_nodes[*j]->apply_charge_mutually(items_to_nodes[*k]);
  }

 for (list<node_base<3> *>::iterator i = world.nodes.begin(); i != world.nodes.end(); i++)
 {
  {
   // add forces to bring them back to flatness
   // code lifted from changes made to pseudotheos' graph.
   t_vector<3> vec_oa = (*i)->position;
   vec_oa[0] = 0.00;
   vec_oa[1] = 0.00;
   dimension dist_oa_squared = vec_oa.size_squared();
   // dimension dist_oa = sqrt(dist_oa_squared);
   if (dist_oa_squared != 0.00)
   {
    t_vector<3> unit_vec_oa = vec_oa; // ... / dist_oa // _squared;
    dimension force = 2.00; // was 2.00 // ... * dist_oa // was 0.50
    t_vector<3> force_a = unit_vec_oa * force * (-1.00);
    (*i)->push(force_a);
   }
  }

  {
   // add forces to bring them back to top
   t_vector<3> vec_oa = (*i)->position;
   vec_oa[0] = 0.00;
   vec_oa[2] = 0.00;
   dimension dist_oa_squared = vec_oa.size_squared();
   // dimension dist_oa = sqrt(dist_oa_squared);
   if (dist_oa_squared != 0.00)
   {
    t_vector<3> unit_vec_oa = vec_oa; // ... / dist_oa // _squared;
    dimension force = 0.10; // ... * dist_oa
    t_vector<3> force_a = unit_vec_oa * force * (-1.00);
    (*i)->push(force_a);
   }
  }

 }

 // simulate
 world.simulate(timerSimulateDependencyGraph->Interval / 10.00);

 // reset
 ResetNodePositions();

 // resize
 if (!ResetPaintboxExtents())
  scrollDependencyGraph->Refresh();

 // redraw

 // timerSimulateDependencyGraph->Enabled = true;
}
//---------------------------------------------------------------------------
