//---------------------------------------------------------------------------


#ifndef codeFrameObservationListH
#define codeFrameObservationListH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "util.h"
#include "Filter.h"
#include "sqlLib.h"
enum obs_list_types {obs_list_none, obs_list_person, obs_list_task, obs_list_participation, obs_list_custom};
//---------------------------------------------------------------------------
class classFilterObservationSource : public classFilterSource
{
 private:
  // input
  classFilterObject * FFilter;
  obs_list_types FType;
  string         FId;
  set<string>    FGroups;
  bool           FRestricted;

  // output
  vector<string> field_names;
  vector<TFieldType> field_types;
  deque<vector<string> > field_values;
  unsigned int row_index;
 public:
  classFilterObservationSource();
  virtual bool Begin(TIBTransaction * dbTransaction);
  virtual unsigned int GetFieldCount();
  virtual bool GetFieldNames(vector<string> & field_vec);
  virtual bool GetFieldTypes(vector<TFieldType> & field_vec);
  virtual bool GetRow(vector<string> & field_vec);
  virtual void End();
  virtual ~classFilterObservationSource();

  virtual void RestrictByGroups (vector<string> & group_ids);
  virtual void UnRestrictByGroups ();
  virtual void SetType (obs_list_types t, string id);
  virtual void SetFilter (classFilterObject * f);
};

//---------------------------------------------------------------------------
class TframeObservationList : public TFrame
{
__published:	// IDE-managed Components
        TListView *listObservations;
private:	// User declarations
        classFilterObservationSource * FDataSource;
        obs_list_types FType;
        string FId;
        classFilterObject FFilter;
        int FRequest;
        classFilterObject * GetFilter();
public:		// User declarations
        bool AtlasRefresh (int request_num, string matched_value);
        void AddObservation();
        void EditObservation();
        void SetSource (obs_list_types _Type, string _Id);
        void RestrictByGroups (vector<string> & group_ids);
        void UnRestrictByGroups ();
        __property classFilterObject * Filter = {read = GetFilter};
        __property obs_list_types Type = {read = FType};
        __property string Id = {read = FId};
        __fastcall TframeObservationList(TComponent* Owner);
        inline virtual __fastcall ~TframeObservationList(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeObservationList *frameObservationList;
//---------------------------------------------------------------------------
#endif
