//---------------------------------------------------------------------------


#ifndef codeFrameObservationResponseH
#define codeFrameObservationResponseH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>

#include "utilityheaders.h"
#include "baseheaders.h"
#include "components.h"
#include <Buttons.hpp>
#include <Graphics.hpp>

enum obs_question_types {obs_unknown, obs_choice, obs_text, obs_ordinal, obs_metric, obs_date};
//---------------------------------------------------------------------------
class TframeObservationResponse : public TFrame
{
__published:	// IDE-managed Components
        TPanel *panelObservation;
        TLabel *labelCPT;
        TEdit *editMetric;
        TLabel *labelUnits;
        TComboBox *comboOptions;
        TEdit *editText;
        TLabel *labelItem;
        void __fastcall ValueEntry(TObject *Sender);
        void __fastcall ValueExit(TObject *Sender);
private:	// User declarations
        map<string, string> _row;
        bool _ready;
        obs_question_types obs_conversion (string id);
        void __fastcall SetRow (const map<string, string> & Value);
        bool __fastcall GetBlank ();
        map<string, string> __fastcall GetRow ();
public:		// User declarations
        bool IsValid(bool silent = false);
        bool IsAutoCalc();
        __property map<string, string> Row = {read = GetRow, write = SetRow};
        __property bool Ready = {read = _ready, write = _ready};
        __property bool Blank = {read = GetBlank};
        __fastcall TframeObservationResponse(TComponent* Owner);
        __fastcall ~TframeObservationResponse();
};
//---------------------------------------------------------------------------
extern PACKAGE TframeObservationResponse *frameObservationResponse;
//---------------------------------------------------------------------------
#endif
