//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "codeFrameSearchTaskBeh.h"
#include "codeSearchTask.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeFrameSearchTaskGeneric"
#pragma resource "*.dfm"
TframeSearchTaskBeh *frameSearchTaskBeh;
//---------------------------------------------------------------------------
__fastcall TframeSearchTaskBeh::TframeSearchTaskBeh(TComponent* Owner)
        : TframeSearchTaskGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void TframeSearchTaskBeh::RegisterControls(TformSearchTask *task_form)
{
  // add fields which are widely shared with other frames
  task_form->AddStaff(cboStaff);
  task_form->AddEventName(cboEventName);
  task_form->AddPerson("Client");
  task_form->AddMinMaxTimes(editMinTime, editMaxTime);
  task_form->AddMinMaxMileage(editMinMileage, editMaxMileage);
  task_form->AddMethodOfContact(cboMethod);
  task_form->AddDirection(cboDirection);
  task_form->AddClassification();            // display only, not currently searchable from here.
  task_form->AddTaskPurpose(cboTaskType);
  task_form->AddProgramType(cboProgramType);
  task_form->AddVisitLocation(cboLocation);
  task_form->AddNewClient(checkNew, "New Client");

  // add lookups
  //                   Table Name            Pretty Name      Custom SQL Combo Box
  task_form->AddLookUp("beh_meeting_types",  "meeting type",  "",        cboMeeting);
  task_form->AddLookUp("beh_activity_types", "activity type", "",        cboActivity);
  task_form->AddLookUp("beh_visit_types",    "visit type",    "",        cboVisitType);
  task_form->AddLookUp("beh_service_types",  "service",       "",        cboService);

  // add query items
  //                      Field name             Query Type                     Control       Lookup Table
  task_form->AddQueryItem("T.beh_meeting_id",  TformSearchTask::QUERY_LOOKUP, cboMeeting,   "beh_meeting_types");
  task_form->AddQueryItem("T.beh_activity_id", TformSearchTask::QUERY_LOOKUP, cboActivity,  "beh_activity_types");
  task_form->AddQueryItem("T.beh_visit_id",    TformSearchTask::QUERY_LOOKUP, cboVisitType, "beh_visit_types");
  task_form->AddQueryItem("T.beh_service_id",  TformSearchTask::QUERY_LOOKUP, cboService,   "beh_service_types");
}
//---------------------------------------------------------------------------
void TframeSearchTaskBeh::SetFilterSecurity(classFilterObject *cfoTaskFilter)
{
  cfoTaskFilter->SetSecurity("tasks.beh");
}
//---------------------------------------------------------------------------
void TframeSearchTaskBeh::AddFilterColumnSpecs(classFilterObject *cfoTaskFilter)
{
  cfoTaskFilter->AddColumnSpec("Meeting Type", "tasks", as_text, false, 110);
  cfoTaskFilter->AddColumnSpec("Activity Type", "tasks", as_text, true, 110);
  cfoTaskFilter->AddColumnSpec("Task Comments", "tasks", as_text, false, 150, sentenceString);
  cfoTaskFilter->AddColumnSpec("Visit Type", "tasks", as_text, true, 110);
  cfoTaskFilter->AddColumnSpec("Service Type", "tasks", as_text, false, 110);
  cfoTaskFilter->AddColumnSpec("Time Spent w/Client", "tasks", as_double, false, 100);
  cfoTaskFilter->AddColumnSpec("Visit Comments", "tasks", as_text, false, 150, sentenceString);
}
//---------------------------------------------------------------------------
void TframeSearchTaskBeh::SetFilterPreferences(classFilterObject *cfoTaskFilter)
{
  cfoTaskFilter->FetchPreferences("searchtaskbeh.filter");
}
//---------------------------------------------------------------------------
string TframeSearchTaskBeh::GetSelectSQL()
{
  return "beh_meeting_types.item, beh_activity_types.item, T.task_comments, beh_visit_types.item, "
         "beh_service_types.item, T.visit_time_spent, T.visit_comments, ";
}
//---------------------------------------------------------------------------
string TframeSearchTaskBeh::GetFromSQL()
{
  return "left join beh_meeting_types on T.beh_meeting_id = beh_meeting_types.id "
         "left join beh_activity_types on T.beh_activity_id = beh_activity_types.id "
         "left join beh_visit_types on T.beh_visit_id = beh_visit_types.id "
         "left join beh_service_types on T.beh_service_id = beh_service_types.id ";
}
//---------------------------------------------------------------------------
vector<string> TframeSearchTaskBeh::GetGroups()
{
  vector<string> groups_vec;
  groups_vec.push_back(lookupTables->IdOf("groups", "Behavioral Health"));
  return groups_vec;
}
//---------------------------------------------------------------------------
