//---------------------------------------------------------------------------


#ifndef frameTaskSearchGenericH
#define frameTaskSearchGenericH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "Filter.h"
//---------------------------------------------------------------------------
// Needed forward declarations:
class TformSearchTask;

//---------------------------------------------------------------------------
class TframeSearchTaskGeneric : public TFrame
{
__published:	// IDE-managed Components
private:	// User declarations
protected:      // User declarations
        friend class TformSearchTask; // task search form can see our innards.

        // Overridables - called by TformSearchTask::ScreenStart
        virtual void RegisterControls(TformSearchTask *task_form) = 0;           // Register controls with parent form.
        virtual void SetFilterSecurity(classFilterObject *cfoTaskFilter);        // Set filter security - has a default implementation.
        virtual void AddFilterColumnSpecs(classFilterObject *cfoTaskFilter) = 0; // Add filter column specs to parent form's Filter.
        virtual void SetFilterPreferences(classFilterObject *cfoTaskFilter) = 0; // Set group-specific filter preferences.
        virtual string GetSelectSQL();                                           // Get select-clause additions for custom fields
        virtual string GetFromSQL();                                             // Get from-clause joins for custom fields
        virtual vector<string> GetGroups();                                      // Get a vector of the groups for which the child-class frame applies.

public:		// User declarations
        // Note: this class is an interface with pure virtuals. Don't instantiate it directly.
        __fastcall TframeSearchTaskGeneric(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeSearchTaskGeneric *frameSearchTaskGeneric;
//---------------------------------------------------------------------------
#endif
