//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeFrameTinyRecordContainer.h"
#include "codeFrameTinyRecordGeneric.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TframeTinyRecordContainer *frameTinyRecordContainer;
//---------------------------------------------------------------------------
__fastcall TframeTinyRecordContainer::TframeTinyRecordContainer(TComponent* Owner)
        : TFrame(Owner)
{
 FAutoCreate = false;
}
//---------------------------------------------------------------------------
__fastcall TframeTinyRecordContainer::~TframeTinyRecordContainer()
{
 FAutoCreate = false;
 Clear();
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordContainer::DeleteHostedTinyRecord (TMessage &Message)
{
 delete (TframeTinyRecordGeneric*)(Message.WParam);
}
//---------------------------------------------------------------------------
TframeTinyRecordGeneric* TframeTinyRecordContainer::Add(bool should_focus)
{
 if (CreateMethod)
 {
  TframeTinyRecordGeneric * z = NULL;
  FORM_TRY
   z = CreateMethod(this);
  FORM_CATCH
  if (z)
  {
   z->Concentrator = FConcentrator; // uh ... because, see, in wizardnewperson, we want to use the OnAdd event (firebird by SetContainer) to do stuff with SameAs, for which we need the concentrator ... see? yeah. thus ... yeah.
   z->Container = this;
   if (should_focus)
    z->Tag = 1;
   return z;
  } else
   return NULL;
 } else
  return NULL;
}
//---------------------------------------------------------------------------
void TframeTinyRecordContainer::NotifyAdded(TframeTinyRecordGeneric* val)
{
 if (val)
 {
  FTinyRecords.push_back(val);

  val->Parent = this;
  val->Align = alTop;
  int z = 0;
  for (deque<TframeTinyRecordGeneric*>::iterator i = FTinyRecords.begin(); i != FTinyRecords.end(); i++)
   z = max(z, (*i)->Top + (*i)->Height);
  val->Top = z + 1;

/*
  if (val->Tag)
   ActiveControl = val; // ->SetFocus();
*/

  if (OnAdd)
   OnAdd(val);
  if (OnChange)
   OnChange(val);
 }
}
//---------------------------------------------------------------------------
void TframeTinyRecordContainer::NotifyRemoved(TframeTinyRecordGeneric* val)
{
 for (deque<TframeTinyRecordGeneric*>::iterator i = FTinyRecords.begin(); i != FTinyRecords.end(); i++)
  if (*i == val)
  {
   FTinyRecords.erase(i);
   break;
  }

 if (OnRemove)
  OnRemove(val);
 if (OnChange)
  OnChange(val);

 // if they manage to delete them all ...
 if (Empty && AutoCreate)
  Add();
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordContainer::SetAutoCreate (bool Value)
{
 FAutoCreate = Value;
 if (Empty && AutoCreate)
  Add(); // don't worry, it checks for non-null CreateMethod ...
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordContainer::SetCreateMethod (tr_create_func Value)
{
 FCreateMethod = Value;
 if (Empty && AutoCreate)
  Add(); // don't worry, it checks for non-null CreateMethod ...
}
//---------------------------------------------------------------------------
bool __fastcall TframeTinyRecordContainer::GetEmpty ()
{
 return (FTinyRecords.empty());
}
//---------------------------------------------------------------------------
int __fastcall TframeTinyRecordContainer::GetRecordCount ()
{
 return (FTinyRecords.size());
}
//---------------------------------------------------------------------------
TframeTinyRecordGeneric* __fastcall TframeTinyRecordContainer::GetRecord (int Value)
{
 if (Value > -1 && Value < FTinyRecords.size())
 {
  return FTinyRecords[Value];
 } else
  return NULL;
}
//---------------------------------------------------------------------------
void TframeTinyRecordContainer::Clear ()
{
 // with safeguards to avoid infinite looping ...
 bool was_autocreate = AutoCreate;
 AutoCreate = false;
 while (!FTinyRecords.empty())
  delete FTinyRecords.front();
 if (was_autocreate)
  AutoCreate = true;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordContainer::SetConcentrator (tr_magic_concentrator * Value)
{
 FConcentrator = Value;
 for (deque<TframeTinyRecordGeneric*>::iterator i = FTinyRecords.begin(); i != FTinyRecords.end(); i++)
  (*i)->Concentrator = Value;
}
//---------------------------------------------------------------------------
