//---------------------------------------------------------------------------


#ifndef codeFrameTinyRecordContainerH
#define codeFrameTinyRecordContainerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <deque>
#include "util.h"
class TframeTinyRecordGeneric;
class tr_magic_concentrator;
typedef TframeTinyRecordGeneric* (*tr_create_func)(Classes::TComponent*);
//---------------------------------------------------------------------------
class TframeTinyRecordContainer : public TFrame
{
__published:	// IDE-managed Components
private:	// User declarations
        tr_create_func FCreateMethod;
        deque<TframeTinyRecordGeneric*> FTinyRecords;
        bool FAutoCreate;

        TNotifyEvent FOnAdd;
        TNotifyEvent FOnRemove;
        TNotifyEvent FOnChange;

        tr_magic_concentrator * FConcentrator;
protected:
        void __fastcall virtual SetAutoCreate (bool Value);
        void __fastcall virtual SetCreateMethod (tr_create_func Value);
        bool __fastcall virtual GetEmpty ();
        int  __fastcall virtual GetRecordCount ();
        virtual TframeTinyRecordGeneric* __fastcall GetRecord (int Value); // why is builder so picky about where 'virtual' goes? sheesh. can never please it.
        void virtual __fastcall SetConcentrator (tr_magic_concentrator * Value);

        void __fastcall virtual DeleteHostedTinyRecord (TMessage &Message);
        #define WM_DELETE_HOSTED_TINYRECORD (WM_USER + 2187)
        BEGIN_MESSAGE_MAP
         MESSAGE_HANDLER(WM_DELETE_HOSTED_TINYRECORD, TMessage, DeleteHostedTinyRecord)
        END_MESSAGE_MAP(TFrame)
public:		// User declarations
        void NotifyAdded(TframeTinyRecordGeneric* val);
        void NotifyRemoved(TframeTinyRecordGeneric* val);

        TframeTinyRecordGeneric* Add(bool should_focus = false);
        void Clear();

        __fastcall TframeTinyRecordContainer(TComponent* Owner);
        __fastcall ~TframeTinyRecordContainer();

        __property tr_create_func CreateMethod = {read = FCreateMethod, write = SetCreateMethod};
        __property bool AutoCreate = {read = FAutoCreate, write = SetAutoCreate, default = false};
        __property bool Empty = {read = GetEmpty};
        __property int RecordCount = {read = GetRecordCount};
        __property TframeTinyRecordGeneric* Record[int Index] = {read = GetRecord};

        __property TNotifyEvent OnAdd = {read = FOnAdd, write = FOnAdd};
        __property TNotifyEvent OnRemove = {read = FOnRemove, write = FOnRemove};
        __property TNotifyEvent OnChange = {read = FOnChange, write = FOnChange};

        __property tr_magic_concentrator * Concentrator = {read = FConcentrator, write = SetConcentrator, nodefault};
};
//---------------------------------------------------------------------------
extern PACKAGE TframeTinyRecordContainer *frameTinyRecordContainer;
//---------------------------------------------------------------------------
#endif
