//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeFrameTinyRecordGeneric.h"
#include "codeFrameTinyRecordContainer.h"
#include "tinyrecord_concentrator.h"
#include "sqllib.h"
#include "codeFrameTinyRecordMagic.h" // very specific case in the shortcut-keys ...
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TframeTinyRecordGeneric *frameTinyRecordGeneric;
//---------------------------------------------------------------------------
__fastcall TframeTinyRecordGeneric::TframeTinyRecordGeneric(TComponent* Owner)
        : FExpanded(false), TFrame(Owner)
{
 ShortString temp_short = this->ClassName();
 AnsiString temp_ansi(temp_short);
 class_name = temp_ansi.c_str();

 can_view = can_view_unknown;
 can_insert = can_insert_unknown;
 can_update = can_update_unknown;

 FCanExpand = false;
 FExpanded  = false;
 FCanDelete = true;

 FConcentrator = NULL;
 FContainer = NULL;

 DoubleBuffered = true;

 Name = Name + IntToString((unsigned int)(void*)this).c_str();
 TframeTinyRecordGeneric::SetId (""); // just want to clean up, without calling any virtuals ... as that'd be bad.

 CurrentId = "4";
 Expanded = Expanded;
 CanDelete = CanDelete;
}
//---------------------------------------------------------------------------
__fastcall TframeTinyRecordGeneric::~TframeTinyRecordGeneric()
{
 Container = NULL;
 Concentrator = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordGeneric::buttonExpandClick(TObject *Sender)
{
 Expanded = !Expanded;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordGeneric::menuMarkClick(TObject *Sender)
{
 CurrentId = IntToString(((TMenuItem*)Sender)->Tag);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordGeneric::SetId (string Value)
{
 // needs completion -- should probably be done before this, at least to have CurrentId set.
 // and technically we could still cancel if there's an error loading?
 bool allow_view   = _CanView();
 bool allow_update = _CanView() && _CanUpdate();
 bool allow_insert = _CanView() && _CanInsert();

 FId = Value;
 if (HasId)
 {
  panelMark->Visible = true;
  panelDelete->Visible = false;
  panelMark->Enabled = allow_update;
 } else
 {
  panelDelete->Visible = CanDelete;
  panelMark->Visible = true; // false;
  panelMark->Enabled = allow_insert;
 }
 ArrangeByTabOrder(panelButtons, false);
 CurrentId = CurrentId;
 if (FOnSetId)
  FOnSetId(this);
 if (FOnFieldChange)
  FOnFieldChange(this);
}
//---------------------------------------------------------------------------
string __fastcall TframeTinyRecordGeneric::GetId ()
{
 return FId;
}
//---------------------------------------------------------------------------
bool __fastcall TframeTinyRecordGeneric::GetHasId ()
{
 if (IsBlankOrZero(Id))
  return false;
 else
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordGeneric::SetCurrentId (string Value)
{
 if (IsInt(Value))
 {
  int c = StringToInt(Value);
  if (c >= 0 && c <= 5)
  {
   FCurrentId = IntToString(c);
   buttonMark->Glyph = NULL;
   imagesMark->GetBitmap(c + 4, buttonMark->Glyph);
   buttonMark->Repaint();
   for (int i = 0; i < popupMark->Items->Count; i++)
    if (popupMark->Items->Items[i]->Tag == c)
     popupMark->Items->Items[i]->Checked = true;
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordGeneric::SetExpanded (bool Value)
{
 FExpanded = Value; 
 buttonExpand->Glyph = NULL;
 imagesMark->GetBitmap(FExpanded ? 1 : 0, buttonExpand->Glyph);
 buttonExpand->Hint = (FExpanded ? "Hide details (Control + E)" : "Show details (Control + E)");
 buttonExpand->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordGeneric::SetCanExpand (bool Value)
{
 FCanExpand = Value;
 panelExpand->Visible = FCanExpand;
 ArrangeByTabOrder(panelButtons, false);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordGeneric::SetCanDelete (bool Value)
{
 FCanDelete = Value;
 panelDelete->Visible = FCanDelete && !HasId;
 ArrangeByTabOrder(panelButtons, false);
}
//---------------------------------------------------------------------------
string __fastcall TframeTinyRecordGeneric::GetSourceTableName ()
{
 return "";
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordGeneric::SetContainer (TframeTinyRecordContainer* Value)
{
 if (Container)
  Container->NotifyRemoved(this);
 FContainer = Value;
 if (Container)
  Container->NotifyAdded(this);
 PostMessage(this->Handle, WM_FOCUS_TINYRECORD, NULL, NULL);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordGeneric::buttonDeleteClick(TObject *Sender)
{
 if (!HasId)
  if (Parent)
   PostMessage(Parent->Handle, WM_DELETE_HOSTED_TINYRECORD, (unsigned int)((void*)this), NULL); // request to be deleted when next convenient, without deleting objects in the middle of a function call, which seems to piss off the VCL ...
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordGeneric::buttonMarkClick(TObject *Sender)
{
 popupMark->PopupComponent = (TComponent*)Sender;
 popupMark->Popup(((TWinControl*)Sender)->ClientOrigin.x, ((TWinControl*)Sender)->ClientOrigin.y + ((TWinControl*)Sender)->Height);
}
//---------------------------------------------------------------------------
void TframeTinyRecordGeneric::AtlasClear()
{
 pending_atlas_notifications.clear();
}
//---------------------------------------------------------------------------
void TframeTinyRecordGeneric::AtlasAdd(string key, string value)
{
 pending_atlas_notifications[LowercaseString(key)].insert(value);
}
//---------------------------------------------------------------------------
void TframeTinyRecordGeneric::AtlasAdd(string table_name, string field_name, string field_value)
{
 pending_atlas_notifications[LowercaseString(table_name + "." + field_name)].insert(field_value);
}
//---------------------------------------------------------------------------
void TframeTinyRecordGeneric::AtlasAdd(string table_name, string field_name, vector<string> & field_values)
{
 for (vector<string>::iterator i = field_values.begin(); i != field_values.end(); i++)
  pending_atlas_notifications[LowercaseString(table_name + "." + field_name)].insert(*i);
}
//---------------------------------------------------------------------------
void TframeTinyRecordGeneric::AtlasAdd(string table_name, map<string, string> & field_names_values)
{
 for (map<string, string>::iterator i = field_names_values.begin(); i != field_names_values.end(); i++)
  if (LikeString("%id", LowercaseString(i->first)) || LikeString("%last_updated_by", LowercaseString(i->first)))
   AtlasAdd(table_name, i->first, i->second);
}
//---------------------------------------------------------------------------
void TframeTinyRecordGeneric::AtlasAdd(string table_name, vector<map<string, string> > & field_names_values)
{
 for (vector<map<string, string> >::iterator j = field_names_values.begin(); j != field_names_values.end(); j++)
  for (map<string, string>::iterator i = j->begin(); i != j->end(); i++)
   if (LikeString("%id", LowercaseString(i->first)) || LikeString("%last_updated_by", LowercaseString(i->first)))
    AtlasAdd(table_name, i->first, i->second);
}
//---------------------------------------------------------------------------
void TframeTinyRecordGeneric::AtlasGet(map<string, set<string> > & add_to_this)
{
 for (map<string, set<string> >::iterator i = pending_atlas_notifications.begin(); i != pending_atlas_notifications.end(); i++)
  add_to_this[i->first] = add(add_to_this[i->first], i->second);
}
//---------------------------------------------------------------------------
bool TframeTinyRecordGeneric::Valid ()
{
 return true;
}
//---------------------------------------------------------------------------
bool TframeTinyRecordGeneric::Save (TIBTransaction * dbTransaction)
{
 return false;
}
//---------------------------------------------------------------------------
void TframeTinyRecordGeneric::AtlasDiff (string table_name, map<string, string> & old_record, map<string, string> & new_record)
{
 if (!old_record.empty())
  for (map<string, string>::iterator i = old_record.begin(); i != old_record.end(); i++)
  {
   string key = table_name + "." + i->first;
   string val = i->second;
   if (LikeString("%id", LowercaseString(key)) || LikeString("%last_updated_by", LowercaseString(key)))
    AtlasAdd(LowercaseString(key), val);
  }

 for (map<string, string>::iterator i = new_record.begin(); i != new_record.end(); i++)
 {
  string key = table_name + "." + i->first;
  string val = i->second;
  if ((LikeString("%id", LowercaseString(key)) || LikeString("%last_updated_by", LowercaseString(key))) &&
      (old_record.empty() || old_record[i->first] != val))
   AtlasAdd(LowercaseString(key), val);
 }

 // for the sake of lookuptable modifications, if that ever happens for any reason ... (it's cheap, okay?)
 AtlasAdd(table_name, "");
}
//---------------------------------------------------------------------------
void TframeTinyRecordGeneric::LogDiff (TIBTransaction* dbTransaction, string table_name, map<string, string> & old_record, map<string, string> & new_record)
{
 list <map<string, string> > differences;
 map<string, string> this_difference;

 // setup the basic fields for default_difference;
 this_difference ["change_by"]    = current_userid;
 this_difference ["change_stamp"] = RightNow();
 this_difference ["record_id"]    = new_record["id"];
 this_difference ["table_name"]   = table_name;

 // changed to also use hack_state rather than initial_state, for the same reasons as in SendAtlas()
 map<string, string>::iterator i_after;
 map<string, string>::iterator i_after_end = new_record.end();
 for (map<string, string>::iterator i_before = old_record.begin(); i_before != old_record.end(); i_before++)
 {
  if (i_before->first != "id")
  {
   i_after = new_record.find(i_before->first);
   if (i_after != i_after_end)
   {
    if (UppercaseString(i_after->second) != UppercaseString(i_before->second))
    {
     i_before->second = i_before->second.substr(0, 255);
     i_after->second = i_after->second.substr(0, 255);
     this_difference["field_name"]     = i_after->first;
     /* TODO: should consult fields_to_leave_raw and UppercaseString() or not accordingly */
     this_difference["previous_value"] = i_before->second;
     this_difference["present_value"]  = i_after->second;
     differences.push_back (this_difference);
    }
   }
  }
 }

 for (list<map<string, string> >::iterator i_difference = differences.begin();
      i_difference != differences.end(); i_difference++)
  if (!ExecuteInsertStatement(dbTransaction, "change_log", *i_difference))
   PSay("Could not save log data to change_log!", m_database_error, MB_OK, "");
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordGeneric::SetConcentrator (tr_magic_concentrator * Value)
{
 // don't do anything else -- while we *know* about the concentrator, and derived classes will forward this knowledge, etc. ... we can't do anything with it here. we're not a magic. we can't remove and re-add ourselves.
 FConcentrator = Value;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordGeneric::ShortCut(TWMKey &Msg, bool &Handled)
{
 if(HIBYTE(GetAsyncKeyState(VK_CONTROL)) && !HIBYTE(GetAsyncKeyState(VK_MENU)) && (Msg.CharCode == 'm' || Msg.CharCode == 'M') && Container && _CanInsert() && _CanView())
 {
  Container->Add(true);
  Handled = true;
 }

 if(HIBYTE(GetAsyncKeyState(VK_CONTROL)) && !HIBYTE(GetAsyncKeyState(VK_MENU)) && (Msg.CharCode == 'd' || Msg.CharCode == 'D'))
 {
  // DON'T PASS THIS ON TO THE PARENT -- DESTRUCTIVE, WOULD PROBABLY PISS USERS OFF
  if (panelDelete->Visible && buttonDelete->Visible && panelDelete->Enabled && buttonDelete->Enabled)
   if (buttonDelete->OnClick)
    buttonDelete->OnClick(buttonDelete);
  // alternate method
  if (!panelDelete->Visible && panelMark->Visible && buttonMark->Visible && panelMark->Enabled && buttonMark->Enabled)
   CurrentId = "0";
  Handled = true;
 }

 if(HIBYTE(GetAsyncKeyState(VK_CONTROL)) && !HIBYTE(GetAsyncKeyState(VK_MENU)) && (Msg.CharCode == 'u' || Msg.CharCode == 'U') && panelMark->Visible && buttonMark->Visible && panelMark->Enabled && buttonMark->Enabled)
 {
  if (buttonMark->OnClick)
   buttonMark->OnClick(buttonMark);
  Handled = true;
 }

 // "REVERT" command? for saved records being modified? (would it reload all children too? yes. it would.)
 bool magic_problem = false;
 // please don't let us revert on a 'same' entry ... it HasId(), but that's not sufficiently safe.
 if(this->InheritsFrom(__classid(TframeTinyRecordMagic)))
  if (dynamic_cast<TframeTinyRecordMagic*>(this)->Magic != trm_existing)
   magic_problem = true;
 if(HIBYTE(GetAsyncKeyState(VK_CONTROL)) && (Msg.CharCode == 'z' || Msg.CharCode == 'Z') && !magic_problem && HasId)
 {
  // MESSY!
  // magic has Desc(), but generic doesn't ...
  // this is really stinkin' ugly. but i don't want to deal with fixing it to be pretty right now.
  // hopefully ... livable? for now?
  // someone can feel free to comment this whole thing out if it's a problem ... but it's a handy feature, yes?
  if (IDYES == PSay("Would you like to undo your changes (if any) to this '" + SourceTableName + "'?", m_confirmation, MB_YESNO))
   Id = Id;
  Handled = true;
 }

 if(HIBYTE(GetAsyncKeyState(VK_CONTROL)) && !HIBYTE(GetAsyncKeyState(VK_MENU)) && (Msg.CharCode == 'e' || Msg.CharCode == 'E') && panelExpand->Visible && buttonExpand->Visible && buttonExpand->Enabled)
 {
  if (buttonExpand->OnClick)
   buttonExpand->OnClick(buttonExpand);
  Handled = true;
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordGeneric::HandleShortCut(TControl * ActiveControl, TWMKey &Msg, bool &Handled)
{
 TControl * z = ActiveControl;
 TframeTinyRecordGeneric * h = NULL;
 while (!Handled && (h = dynamic_cast<TframeTinyRecordGeneric *>(FindNearestParentOfType(z, __classid(TframeTinyRecordGeneric)))))
 {
  h->ShortCut(Msg, Handled);
  z = h->Parent; // so we don't keep getting the same one
 }
 // as a last resort, send to parent.
 // WRONG: not needed, as the form is what's calling -us-. the problem was in wizardnewperson, not here.
/*
 if (!Handled)
 {
  TForm * i;
  if ((i = dynamic_cast<TForm *>(FindNearestParentOfType(z, __classid(TForm)))) && (i->OnShortCut))
   i->OnShortCut(Msg, Handled);
 }
*/
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordGeneric::Refocus()
{
 if (Tag)
 {
  TWinControl * z = FindNextControl(this, true, true, false); // (TWinControl *)(a->First());
  if (z)
   z->SetFocus();
  Tag = 0;
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordGeneric::FocusSelf (TMessage &Message)
{
 Refocus();
}
//---------------------------------------------------------------------------
bool TframeTinyRecordGeneric::AtlasBeforeSave (TIBTransaction * dbTransaction)
{
 AtlasClear();
 if (HasId)
  if (!SqlToMap(dbTransaction, "select * from " + SourceTableName + " where id = " + Id, previous_state))
   return false;
}
//---------------------------------------------------------------------------
bool TframeTinyRecordGeneric::AtlasAfterSave (TIBTransaction * dbTransaction)
{
 if (HasId)
  if (!SqlToMap(dbTransaction, "select * from " + SourceTableName + " where id = " + Id, next_state))
   return false;
 AtlasDiff(SourceTableName, previous_state, next_state);
 LogDiff(dbTransaction, SourceTableName, previous_state, next_state);
}
//---------------------------------------------------------------------------
int TframeTinyRecordGeneric::PSay(string p_message, prometheus_message_types p_message_type, int p_buttons, string p_other_info)
{
 return ::PSay(p_message, p_message_type, p_buttons, class_name, p_other_info, this->Handle);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordGeneric::AfterConstruction()
{
 bool allow_view   = _CanView();
 bool allow_update = _CanView() && _CanUpdate();
 bool allow_insert = _CanView() && _CanInsert();

 // buttonMark->Enabled = (allow_update || allow_insert);
 buttonDelete->Enabled = (allow_insert); // we should also disable the adding! (erk?)
 // shouldn't -hide- ourselves ... that'd be ... bad? if no allow_view, someone needs to just not load us!

 ArrangeByTabOrder(panelButtons, false);
}
//---------------------------------------------------------------------------
bool TframeTinyRecordGeneric::WorthSaving (TIBTransaction * dbTransaction, map<string, string> & new_record)
{
 if (!HasId)
  return true;

 map<string, string> old_record;
 if (!SqlToMap(dbTransaction, "select * from " + SourceTableName + " where id = " + Id, old_record))
  return true;

 // only look at what may have changed in the new record, but account for string modifications that -will- be performed ...
 for (map<string, string>::iterator i = new_record.begin(); i != new_record.end(); i++)
 {
  try
  {
  string a = i->first;
  if (!is_in(a, "id", "last_update_stamp", "last_updated_by", (char*)NULL))
  {
   string o = old_record[i->first];
   string n = i->second;

   // apply the changes ExecuteUpdateStatement would apply, minus the doubling of singlequotes and the adding of singlequotes
   n = StripLeading(StripTrailing(n, " "), " ");
   if (fields_to_leave_raw.find(i->first) == fields_to_leave_raw.end())
    n = UppercaseString(n);

   if (n != o)
    return true;
  }
  } catch (...)
  {
   PSay(i->first, m_debug, MB_OK);
  }
 }
 return false;
}
//---------------------------------------------------------------------------
bool TframeTinyRecordGeneric::_CanView()
{ // no reason to override this function; override CanView() instead
  if (can_view == can_view_true)
    return true;
  if (can_view == can_view_false)
    return false;
  // otherwise, it's can_view_unknown, and we figure it out.

  if (CanView())
  {
    can_view = can_view_true;
    return true;
  }
  else
  {
    can_view = can_view_false;
    return false;
  }
}
//---------------------------------------------------------------------------
bool TframeTinyRecordGeneric::CanView()
{
  return optionsPermissions["table."+SourceTableName]["view"] == "true";
}
//---------------------------------------------------------------------------
bool TframeTinyRecordGeneric::_CanInsert()
{ // no reason to override this function; override CanInsert() instead
  if (can_insert == can_insert_true)
    return true;
  if (can_insert == can_insert_false)
    return false;
  // otherwise, it's can_insert_unknown, and we figure it out.

  if (CanInsert())
  {
    can_insert = can_insert_true;
    return true;
  }
  else
  {
    can_insert = can_insert_false;
    return false;
  }
}
//---------------------------------------------------------------------------
bool TframeTinyRecordGeneric::CanInsert()
{
  return optionsPermissions["table."+SourceTableName]["insert"] == "true";
}
//---------------------------------------------------------------------------
bool TframeTinyRecordGeneric::_CanUpdate()
{ // no reason to override this function; override CanUpdate() instead
  // if we already know, then go with that
  if (can_update == can_update_true)
    return true;
  if (can_update == can_update_false)
    return false;
  // otherwise it's can_update_unknown, and we figure it out.
  if (CanUpdate())
  {
    can_update = can_update_true;
    return true;
  }
  else
  {
    can_update = can_update_false;
    return false;
  }
}
//---------------------------------------------------------------------------
bool TframeTinyRecordGeneric::CanUpdate()
{
  // explicit update permissions to the table?  then yes, we're done
  if (optionsPermissions["table."+SourceTableName]["update"] == "true")
    return true;
  // if they (still) have insert permissions to the table, and
  // they were the last user to modify the record, that's a pass too
  if (CanInsert() &&
      previous_state["last_updated_by"] == current_userid)
    return true;
  // if they have insert permissions to the table, and
  // the user who last modified the record is no longer valid, and
  // the current user is in the same department as the now-invalid user
  // then that's a pass (just let the whole department modify their old data)
  string last_updated_by_group = GetOneField(dbDatabase, "select group_id from users where id = '" + previous_state["last_updated_by"] + "'");
  string last_updated_by_user_valid = GetOneField(dbDatabase, "select valid from users where id = '" + previous_state["last_updated_by"] + "'");
  if (_CanInsert() &&
      IsBlankOrZero(last_updated_by_user_valid) &&
      current_groupid == last_updated_by_group && !IsBlankOrZero(last_updated_by_group))
    return true;

  // otherwise, so sorry, you can't modify this record
  return false;
}
//---------------------------------------------------------------------------
string TframeTinyRecordGeneric::GetPreviousState(string key)
{
  if (previous_state.find(key) != previous_state.end()) return previous_state[key];
  else return "";
}
//---------------------------------------------------------------------------
string TframeTinyRecordGeneric::GetNextState(string key)
{
  if (next_state.find(key) != next_state.end()) return next_state[key];
  else return "";
}
//---------------------------------------------------------------------------

