//---------------------------------------------------------------------------


#ifndef codeFrameTinyRecordGenericH
#define codeFrameTinyRecordGenericH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include "util.h"
#include <ExtCtrls.hpp>
#include <Buttons.hpp>

#include "utilityheaders.h"
#include "baseheaders.h"
#include "components.h"
class TframeTinyRecordContainer;
class tr_magic_concentrator;
//---------------------------------------------------------------------------
class TframeTinyRecordGeneric : public TFrame
{
__published:	// IDE-managed Components
        TPopupMenu *popupMark;
        TMenuItem *menuMark5;
        TMenuItem *menuMark4;
        TMenuItem *menuMark3;
        TMenuItem *menuMark2;
        TMenuItem *menuMark1;
        TMenuItem *menuMark0;
        TPanel *panelButtons;
        TPanel *panelMark;
        TPanel *panelExpand;
        TPanel *panelDelete;
        TSpeedButton *buttonMark;
        TSpeedButton *buttonDelete;
        TSpeedButton *buttonExpand;
        TImageList *imagesPopup;
        TImageList *imagesMark;
        void __fastcall buttonExpandClick(TObject *Sender);
        void __fastcall menuMarkClick(TObject *Sender);
        void __fastcall buttonDeleteClick(TObject *Sender);
        void __fastcall buttonMarkClick(TObject *Sender);
private:	// User declarations
        map<string, string> previous_state;
        map<string, string> next_state;
protected:
        string class_name;
        int PSay(string p_message, prometheus_message_types p_message_type, int p_buttons, string p_other_info = "");
        set<string> fields_to_leave_raw;

        void __fastcall FocusSelf (TMessage &Message);
        #define WM_FOCUS_TINYRECORD (WM_USER + 2188)
        BEGIN_MESSAGE_MAP
         MESSAGE_HANDLER(WM_FOCUS_TINYRECORD, TMessage, FocusSelf)
        END_MESSAGE_MAP(TFrame)

        TNotifyEvent FOnSetId;
        TNotifyEvent FOnFieldChange;

        // key ["table.field"] -> set of values ["97"]
        map<string, set<string> > pending_atlas_notifications;
        void AtlasClear();
        void AtlasAdd(string key, string value);
        void AtlasAdd(string table_name, string field_name, string field_value);
        void AtlasAdd(string table_name, string field_name, vector<string> & field_values);
        void AtlasAdd(string table_name, map<string, string> & field_names_values);
        void AtlasAdd(string table_name, vector<map<string, string> > & field_names_values);

        void AtlasDiff (string table_name, map<string, string> & old_record, map<string, string> & new_record);
        void LogDiff (TIBTransaction* dbTransaction, string table_name, map<string, string> & old_record, map<string, string> & new_record);
        bool WorthSaving (TIBTransaction * dbTransaction, map<string, string> & new_record);

        bool AtlasBeforeSave (TIBTransaction * dbTransaction);
        bool AtlasAfterSave (TIBTransaction * dbTransaction);

        string FId;
        void virtual __fastcall SetId (string Value);
        string virtual __fastcall GetId ();
        bool virtual __fastcall GetHasId ();

        string FCurrentId;
        void virtual __fastcall SetCurrentId (string Value);

        bool FExpanded;
        void virtual __fastcall SetExpanded (bool Value);

        bool FCanExpand;
        void virtual __fastcall SetCanExpand (bool Value);

        bool FCanDelete;
        void virtual __fastcall SetCanDelete (bool Value);

        tr_magic_concentrator * FConcentrator;
        void virtual __fastcall SetConcentrator (tr_magic_concentrator * Value);

        string virtual __fastcall GetSourceTableName ();

        void __fastcall virtual AfterConstruction();

        TframeTinyRecordContainer * FContainer;
        void virtual __fastcall SetContainer (TframeTinyRecordContainer* Value);
        bool virtual _CanView();
        bool virtual _CanInsert();
        bool virtual _CanUpdate();
        bool virtual CanView();             // does the current user have view permissions on this record?
        bool virtual CanInsert();           // does the current user have insert permissions on this record?
        bool virtual CanUpdate();           // does the current user have update permissions on this record?
        can_view_status can_view;
        can_insert_status can_insert;
        can_update_status can_update;
        string GetPreviousState(string key); // because Philip didn't think it was necessary for descendents to look at, essentially, initial_state.  wtf?
        string GetNextState(string key);     // because Philip didn't think it was necessary for descendents to look at, essentially, ending_state.  wtf?
public:		// User declarations
        __fastcall TframeTinyRecordGeneric(TComponent* Owner);
        __fastcall virtual ~TframeTinyRecordGeneric();

        void __fastcall virtual ShortCut(TWMKey &Msg, bool &Handled);
        void static __fastcall HandleShortCut(TControl * ActiveControl, TWMKey &Msg, bool &Handled);
        void virtual __fastcall Refocus();

        bool virtual Valid ();
        bool virtual Save (TIBTransaction * dbTransaction);
        void virtual AtlasGet(map<string, set<string> > & add_to_this);

        __property string Id = {read = GetId, write = SetId};
        __property string CurrentId = {read = FCurrentId, write = SetCurrentId};
        __property bool HasId = {read = GetHasId};
        __property bool Expanded = {read = FExpanded, write = SetExpanded, nodefault};
        __property bool CanExpand = {read = FCanExpand, write = SetCanExpand, nodefault};
        __property bool CanDelete = {read = FCanDelete, write = SetCanDelete, nodefault};
        __property string SourceTableName = {read = GetSourceTableName};
        __property TframeTinyRecordContainer * Container = {read = FContainer, write = SetContainer};
        __property TNotifyEvent OnSetId = {read = FOnSetId, write = FOnSetId};
        __property TNotifyEvent OnFieldChange = {read = FOnFieldChange, write = FOnFieldChange};
        __property tr_magic_concentrator * Concentrator = {read = FConcentrator, write = SetConcentrator, nodefault};
};
//---------------------------------------------------------------------------
extern PACKAGE TframeTinyRecordGeneric *frameTinyRecordGeneric;
//---------------------------------------------------------------------------
#endif
