//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeFrameTinyRecordMagic.h"
#include "tinyrecord_concentrator.h"
#include "codePrometheus.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeFrameTinyRecordGeneric"
#pragma link "codeHalfButton"
#pragma resource "*.dfm"
TframeTinyRecordMagic *frameTinyRecordMagic;
// tiny fairy sugar, sayeth the paul
//---------------------------------------------------------------------------
__fastcall TframeTinyRecordMagic::TframeTinyRecordMagic(TComponent* Owner)
        : TframeTinyRecordGeneric(Owner)
{
 FLastMagic = -1;
 FSameAs    = NULL;

 FSourceNames.clear();
 for (int i = 0; i < comboSource->Items->Count; i++)
  FSourceNames.push_back(comboSource->Items->Strings[i].c_str());

 // aren't we just so NICE by default?
 FAllowNew  = true;
 FAllowSame = true;
 FAllowNone = true;
 FAllowSourceChange = true;
 FAutoExpandOnSetId = false;

 staticExisting->Font->Color = link_color;
 staticMatches->Font->Color  = link_color;
 staticSummary->Font->Color  = link_color;
 CanDelete = false;
 Expanded = false;

 AllowNew = (optionsPermissions["table." + SourceTableName]["insert"] == "true");
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::SetParent(TWinControl * AParent)
{
 TframeTinyRecordGeneric::SetParent(AParent);
 if (AParent)
  Magic = trm_existing; // safe! can't possibly be refused. right? right.
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::comboSourceChange(TObject *Sender)
{
 Magic = Magic;
}
//---------------------------------------------------------------------------
void TframeTinyRecordMagic::MagicChanged ()
{
 bool allow_view   = (optionsPermissions["table." + SourceTableName]["view"] == "true");
 bool allow_update = allow_view && (optionsPermissions["table." + SourceTableName]["update"] == "true");
 bool allow_insert = allow_view && (optionsPermissions["table." + SourceTableName]["insert"] == "true");
 // buttonMark->Enabled = (Magic == trm_existing && allow_update) || (Magic == trm_new && allow_insert);
 buttonDelete->Enabled = (allow_insert); // we should also disable the adding! (erk?)
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::SetMagic (tr_magic_types Value)
{
 if ((Value == trm_new && !AllowNew) ||
     (Value == trm_same && !AllowSame) ||
     (Value == trm_none && !AllowNone))
 {
  if (Value == trm_new)
   PSay("You cannot use 'new' here.", m_message, MB_OK);
  if (Value == trm_same)
   PSay("You cannot use 'same' here.", m_message, MB_OK);
  if (Value == trm_none)
   PSay("You cannot use 'none' here.", m_message, MB_OK);

  if (FLastMagic != trm_new)
   Value = FLastMagic;
  else
   Value = trm_existing; // safe default?
 }

 staticExisting->Visible = (Value == trm_existing);
 buttonSearch->Visible   = (Value == trm_existing);
 staticMatches->Visible  = (Value == trm_new);
 comboSameAs->Visible    = (Value == trm_same);
 buttonExpand->Enabled   = ((Value == trm_existing && HasId) || Value == trm_new);

 if (FromCombo(comboSource->ItemIndex) != Value)
 {
  comboSource->ItemIndex = ToCombo(Value);
  RefreshComboSameAs();
 }

 if ((Value != FLastMagic))
 {
  if (Value == trm_new)
  {
   Id = "";
   matched_ids_to_values.clear();
   MatchesRefresh(NULL);
  }
  if (Value == trm_same)
  {
   TframeTinyRecordMagic * frameOther = NULL;
   if (Concentrator && !IsBlankOrZero(Id))
    frameOther = Concentrator->Find(SourceTableName, Id, this); // avoid reselecting ourselves
   SameAs = frameOther;
  }
  if (Value == trm_existing)
  {
   TframeTinyRecordMagic * prev_same_as = FSameAs;
   if (FLastMagic == trm_same && prev_same_as)
    Id = prev_same_as->Id;
   else
    Id = "0";
  }
  if (Value != trm_same)
   SameAs = NULL; // just ... to make sure.
  if (!buttonExpand->Enabled)
   Expanded = false;
  if (buttonExpand->Enabled && Value == trm_new)
   Expanded = true;

  if (FConcentrator)
   FConcentrator->Refresh();
  if (FOnFieldChange)
   FOnFieldChange(this);
  MagicChanged ();
 }

 FLastMagic = Value;
}
//---------------------------------------------------------------------------
tr_magic_types __fastcall TframeTinyRecordMagic::GetMagic ()
{
 ResetItemIndex(comboSource);
 if (comboSource->ItemIndex == -1)
  comboSource->ItemIndex = 0;
 tr_magic_types i = FromCombo(comboSource->ItemIndex);
 return i;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::panelButtonsResize(TObject *Sender)
{
 panelMagic->Left = ((panelButtons->Width + 8) / 8) * 8; // next multiple of 8, but not touching? (i hope)
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::SetId (string Value)
{
 TframeTinyRecordGeneric::SetId(Value);

 bool allow_view   = (optionsPermissions["table." + SourceTableName]["view"] == "true");
 bool allow_update = allow_view && (optionsPermissions["table." + SourceTableName]["update"] == "true");
 bool allow_insert = allow_view && (optionsPermissions["table." + SourceTableName]["insert"] == "true");
 buttonMark->Enabled = WillHaveId;
 panelMark->Enabled = (Magic == trm_existing && allow_update) || (Magic == trm_new && allow_insert);
 buttonDelete->Enabled = (allow_insert); // we should also disable the adding! (erk?)

 if (Magic == trm_same)
  panelMark->Visible = false;
 buttonExpand->Enabled = ((Magic == trm_existing && HasId) || Magic == trm_new);
 if (!buttonExpand->Enabled)
  Expanded = false;
 if (FConcentrator)
  FConcentrator->Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::comboSourceKeyPress(TObject *Sender,
      char &Key)
{
 FindComboBoxItemAndSetItemIndex(Sender, Key);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::comboSameAsKeyPress(TObject *Sender,
      char &Key)
{
 FindComboBoxItemAndSetItemIndex(Sender, Key);
}
//---------------------------------------------------------------------------
string __fastcall TframeTinyRecordMagic::GetDesc ()
{
 return "Default: no description";
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::SetSameAs (TframeTinyRecordMagic * Value)
{
 TframeTinyRecordMagic * old_sameas = FSameAs;
 FSameAs = Value;
 if (Magic == trm_same && SameAs && SameAs->HasId)
  Id = SameAs->Id; // yes? no? seemed like a good idea? actually calls SetId which fills in data and whatnot? fires events?
 if (old_sameas != FSameAs)
  RefreshComboSameAs();
 ResetItemIndex(comboSameAs);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::SetConcentrator (tr_magic_concentrator * Value)
{
 tr_magic_concentrator * old_c = FConcentrator;
 FConcentrator = Value; // <- is all the ancestor (generic) does at the moment.
 // try to avoid doing this more than necessary
 if (old_c && old_c != Value)
  old_c->Remove(this);
 if (Value && old_c != Value)
  FConcentrator->Add(this);
 // both of these cause refreshing, fyi (Refresh())
 RefreshComboSameAs();
}
//---------------------------------------------------------------------------
void TframeTinyRecordMagic::RefreshComboSameAs ()
{
 if (FConcentrator)
 {
  if (FSameAs && !FConcentrator->Exists(FSameAs))
   FSameAs = NULL;
  FConcentrator->List(this);

  // imageWarnDupes->Visible = (!IsBlankOrZero(Id) && Concentrator->Find(SourceTableName, Id, this));
 }
 else
 {
  FSameAs = NULL;
  comboSameAs->Items->Clear();
  vectorSameAs.clear();
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::comboSameAsChange(TObject *Sender)
{
 ResetItemIndex(comboSameAs);
 if (comboSameAs->ItemIndex == -1)
  SameAs = NULL;
 else if (comboSameAs->ItemIndex < vectorSameAs.size())
  SameAs = vectorSameAs[comboSameAs->ItemIndex];
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::ShortCut(TWMKey &Msg, bool &Handled)
{
 TframeTinyRecordGeneric::ShortCut(Msg, Handled);

 if(HIBYTE(GetAsyncKeyState(VK_CONTROL)) && !HIBYTE(GetAsyncKeyState(VK_MENU)) && (Msg.CharCode == 'f' || Msg.CharCode == 'F') && buttonSearch->Visible && buttonSearch->Enabled)
 {
  if (buttonSearch->OnClick)
   buttonSearch->OnClick(buttonSearch);
  Handled = true;
 }

 if(HIBYTE(GetAsyncKeyState(VK_CONTROL)) && !HIBYTE(GetAsyncKeyState(VK_MENU)) && (Msg.CharCode == 'l' || Msg.CharCode == 'L') && staticMatches->Visible && staticMatches->Enabled)
 {
  if (staticMatches->OnClick)
   staticMatches->OnClick(staticMatches);
  Handled = true;
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::SetExpanded (bool Value)
{
 TframeTinyRecordGeneric::SetExpanded(Value);
 if (!Expanded && (Magic == trm_new || (Magic == trm_existing && HasId)))
 {
  RefreshSummary();
  panelMagic->Visible = false;
  panelSummary->Visible = true;
 } else
 {
  panelSummary->Visible = false;
  panelMagic->Visible = true;
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::editAnyExit(TObject *Sender)
{
 if (should_send_change)
 {
  MatchesRefresh(NULL);
  if (OnFieldChange)
   OnFieldChange(this);
  should_send_change = false;
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::editAnyChange(TObject *Sender)
{
 should_send_change = true;
 RefreshSummary(); // 'cause?
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::MatchesRefresh(TObject *Sender)
{
 if (FConcentrator)
  FConcentrator->Refresh();

 staticMatches->Caption = "Searching for possible duplicates...";
}
//---------------------------------------------------------------------------
void TframeTinyRecordMagic::RefreshSummary()
{
 staticSummary->Caption = Desc.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::staticSummaryClick(TObject *Sender)
{
 if (HasId)
  DefaultAction(Id, SourceTableName);
}
//----------------------------------------------------------------------------
void TframeTinyRecordMagic::AtlasGet(map<string, set<string> > & add_to_this)
{
 if (Magic == trm_same && SameAs)
  SameAs->AtlasGet(add_to_this);
 else
  TframeTinyRecordGeneric::AtlasGet(add_to_this);
}
//----------------------------------------------------------------------------
bool __fastcall TframeTinyRecordMagic::GetWillHaveId()
{
 bool answer = ((Magic == trm_same && SameAs && SameAs->WillHaveId) ||
                (Magic == trm_existing && HasId) ||
                (Magic == trm_new));
 return answer;
}
//----------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::AfterConstruction()
{
 TframeTinyRecordGeneric::AfterConstruction();
 if (optionsPermissions["table." + SourceTableName]["insert"] != "true")
  AllowNew = false;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::SetAllowNew (bool Value)
{
 FAllowNew = Value;
 if (!Value && Magic == trm_new)
  Magic = trm_existing;
 FixComboSource();
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::SetAllowSame (bool Value)
{
 FAllowSame = Value;
 if (!Value && Magic == trm_same)
  Magic = trm_existing;
 FixComboSource();
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::SetAllowNone (bool Value)
{
 FAllowNone = Value;
 if (!Value && Magic == trm_none)
  Magic = trm_existing;
 FixComboSource();
}
//---------------------------------------------------------------------------
tr_magic_types TframeTinyRecordMagic::FromCombo(int Value)
{
 if (ToCombo(trm_existing) == Value)
  return trm_existing;
 if (ToCombo(trm_new) == Value)
  return trm_new;
 if (ToCombo(trm_same) == Value)
  return trm_same;
 if (ToCombo(trm_none) == Value)
  return trm_none;
 return trm_existing; // ?? it's the only one that -has- to exist ...
}
//---------------------------------------------------------------------------
int TframeTinyRecordMagic::ToCombo(tr_magic_types Value)
{
 int answer = -1;
 switch (Value)
 {
  case trm_existing:
   answer = 0;
   break;
  case trm_new:
   if (AllowNew)
    answer = 1;
   else
    answer = -1;
   break;
  case trm_same:
   if (AllowSame)
   {
    int j = 1;
    if (AllowNew) j++;
    answer = j;
   } else
    answer = -1;
   break;
  case trm_none:
   if (AllowNone)
   {
    int j = 1;
    if (AllowNew) j++;
    if (AllowSame) j++;
    answer = j;
   } else
    answer = -1;
   break;
 }
 return answer;
}
//---------------------------------------------------------------------------
void TframeTinyRecordMagic::FixComboSource()
{
 tr_magic_types prev = Magic;
 comboSource->Items->Clear();
 comboSource->Items->Add(FSourceNames[0].c_str());
 if (AllowNew)
  comboSource->Items->Add(FSourceNames[1].c_str());
 if (AllowSame)
  comboSource->Items->Add(FSourceNames[2].c_str());
 if (AllowNone)
  comboSource->Items->Add(FSourceNames[3].c_str());
 Magic = prev;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecordMagic::SetAllowSourceChange (bool Value)
{
 FAllowSourceChange    = Value;
 buttonSearch->Enabled = Value;
 comboSource->Enabled  = Value;
 comboSameAs->Enabled  = Value; // not sure how you would -get- to this point? but whatever. it's safer.
}
//---------------------------------------------------------------------------
string __fastcall TframeTinyRecordMagic::GetId()
{
 if (Magic == trm_same && SameAs)
  return SameAs->Id;
 else
  return TframeTinyRecordGeneric::GetId();
}
//---------------------------------------------------------------------------
bool __fastcall TframeTinyRecordMagic::GetHasId ()
{
 if (Magic == trm_same && SameAs)
  return SameAs->HasId;
 else
  return TframeTinyRecordGeneric::GetHasId();
}
//---------------------------------------------------------------------------
bool TframeTinyRecordMagic::Save (TIBTransaction * dbTransaction)
{
 if (Magic == trm_none)
  return true;

 if (Magic == trm_same && SameAs)
  if (!SameAs->HasId) // if it's new, save it right away -- future calls will find it has an id and not re-save it ... if it's old, we only need to save it wherever it's not trm_same, can defer
   return SameAs->Save(dbTransaction);
  else
   return true;

 return MagicSave(dbTransaction);
}
//---------------------------------------------------------------------------
bool TframeTinyRecordMagic::Valid ()
{
 if (Magic == trm_none)
  return true; // let the host decide if that's acceptable or not
 if (Magic == trm_same)
 {
  if (SameAs)
   return SameAs->Valid();
  else
  {
   PSay(Label + ": You chose 'same as' but forgot to select something to re-use from the drop-down.", m_missing_data, MB_OK);
   if (IsVisible(comboSameAs)) comboSameAs->SetFocus();
   return false;
  }
 }
 if (Magic == trm_existing && !HasId)
 {
  if (!AllowNone)
  {
   PSay(Label + ": You chose 'existing' but have not yet searched for anything, and 'none' is not allowed here.", m_missing_data, MB_OK);
   if (IsVisible(comboSource)) comboSource->SetFocus();
   return false;
  }
  else
   return true;
 }
 return MagicValid();
}
//---------------------------------------------------------------------------
TframeTinyRecordMagic * __fastcall TframeTinyRecordMagic::GetActual ()
{
 if (Magic == trm_same && SameAs)
  return SameAs;
 if (Magic == trm_existing || Magic == trm_new)
  return this;
 // Same but no SameAs, or None
 return NULL;
}
//---------------------------------------------------------------------------

