//---------------------------------------------------------------------------

#ifndef codeFrameTinyRecordMagicH
#define codeFrameTinyRecordMagicH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameTinyRecordGeneric.h"
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include "codeHalfButton.h"
#include <Graphics.hpp>
enum tr_magic_types {trm_existing, trm_new, trm_same, trm_none};
//---------------------------------------------------------------------------
class TframeTinyRecordMagic : public TframeTinyRecordGeneric
{
__published:	// IDE-managed Components
        TPanel *panelMagic;
        TComboBox *comboSource;
        TComboBox *comboSameAs;
        TStaticText *staticExisting;
        THalfButton *buttonSearch;
        TStaticText *staticMatches;
        TPanel *panelSummary;
        TStaticText *staticSummary;
        void __fastcall comboSourceChange(TObject *Sender);
        void __fastcall panelButtonsResize(TObject *Sender);
        void __fastcall comboSourceKeyPress(TObject *Sender, char &Key);
        void __fastcall comboSameAsKeyPress(TObject *Sender, char &Key);
        void __fastcall comboSameAsChange(TObject *Sender);
        void __fastcall editAnyChange(TObject *Sender);
        void __fastcall editAnyExit(TObject *Sender);
        void __fastcall staticSummaryClick(TObject *Sender);
private:	// User declarations
        tr_magic_types FLastMagic;
protected:
        void __fastcall virtual SetMagic (tr_magic_types Value);
        void virtual MagicChanged ();
        tr_magic_types virtual __fastcall GetMagic ();
        void   virtual __fastcall SetId (string Value);
        string virtual __fastcall GetId();
        bool   virtual __fastcall GetHasId ();

        TframeTinyRecordMagic * FSameAs;
        void   virtual __fastcall SetSameAs (TframeTinyRecordMagic * Value);
        void   virtual __fastcall SetConcentrator (tr_magic_concentrator * Value);
        string virtual __fastcall GetDesc ();
        void RefreshComboSameAs ();
        vector<TframeTinyRecordMagic *> vectorSameAs;
        friend tr_magic_concentrator;

        map<string, string> matched_ids_to_values;
        int last_max_score;
        bool should_send_change;
        void virtual RefreshSummary();
        void __fastcall virtual MatchesRefresh(TObject *Sender);
        bool __fastcall virtual GetWillHaveId();
        void __fastcall virtual AfterConstruction();
        void __fastcall virtual SetParent(TWinControl * AParent);
        void __fastcall virtual SetExpanded (bool Value);

        tr_magic_types FromCombo(int Value);
        int ToCombo(tr_magic_types Value);
        vector<string> FSourceNames;
        void FixComboSource();

        bool FAllowNew;
        bool FAllowSame;
        bool FAllowNone;
        void __fastcall virtual SetAllowNew (bool Value);
        void __fastcall virtual SetAllowSame (bool Value);
        void __fastcall virtual SetAllowNone (bool Value);

        bool FAllowSourceChange;
        void __fastcall virtual SetAllowSourceChange (bool Value);
        bool virtual MagicSave (TIBTransaction * dbTransaction) = 0;
        bool virtual MagicValid () = 0;

        string FLabel;
        bool FAutoExpandOnSetId;

        virtual TframeTinyRecordMagic* __fastcall GetActual ();
public:		// User declarations
        bool virtual Valid ();
        bool virtual Save (TIBTransaction * dbTransaction);
        void virtual AtlasGet(map<string, set<string> > & add_to_this);
        void virtual __fastcall ShortCut(TWMKey &Msg, bool &Handled);
        __fastcall TframeTinyRecordMagic(TComponent* Owner);
        __property tr_magic_types Magic = {read = GetMagic, write = SetMagic, nodefault};
        __property string Desc = {read = GetDesc};
        __property TframeTinyRecordMagic * SameAs = {read = FSameAs, write = SetSameAs, nodefault};
        __property bool WillHaveId = {read = GetWillHaveId};

        __property bool AllowNew = {read = FAllowNew, write = SetAllowNew};
        __property bool AllowSame = {read = FAllowSame, write = SetAllowSame};
        __property bool AllowNone = {read = FAllowNone, write = SetAllowNone};
        __property bool AllowSourceChange = {read = FAllowSourceChange, write = SetAllowSourceChange};

        __property bool AutoExpandOnSetId = {read = FAutoExpandOnSetId, write = FAutoExpandOnSetId};

        __property string Label = {read = FLabel, write = FLabel}; // use to describe what it's being used "for"
        __property TframeTinyRecordMagic * Actual = {read = GetActual};
};
//---------------------------------------------------------------------------
extern PACKAGE TframeTinyRecordMagic *frameTinyRecordMagic;
//---------------------------------------------------------------------------
#endif
