//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeFrameTinyRecord_Address.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeFrameTinyRecordGeneric"
#pragma link "codeHalfButton"
#pragma link "codeInlineContainer"
#pragma resource "*.dfm"
TframeTinyRecord_Address *frameTinyRecord_Address;
//---------------------------------------------------------------------------
__fastcall TframeTinyRecord_Address::TframeTinyRecord_Address(TComponent* Owner)
        : TframeTinyRecordGeneric(Owner)
{
 CanExpand = true;
 Expanded = true;

 // lookupTables->RegisterComboBox("contact_info_types", comboLocation);
 // lookupTables->RegisterComboBox("residence_types", comboResidence);
 lookupTables->RegisterComboBox("state_types", comboState);
 lookupTables->RegisterComboBox("country_types", comboCountry);
}
//---------------------------------------------------------------------------
__fastcall TframeTinyRecord_Address::~TframeTinyRecord_Address()
{
 // lookupTables->UnregisterComboBox("contact_info_types", comboLocation);
 // lookupTables->UnregisterComboBox("residence_types", comboResidence);
 lookupTables->UnregisterComboBox("state_types", comboState);
 if (lookupTables->TableName(comboCounty) != "") // if this combo box is registered
   lookupTables->UnregisterComboBox("county_types", comboCounty);
 lookupTables->UnregisterComboBox("country_types", comboCountry);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Address::SetExpanded (bool Value)
{
 if (Value)
  inlineAddress->Height = 120;

 panelAddress->Visible = Value;
 panelZip->Visible     = Value;
 panelCity->Visible    = Value;
 panelCounty->Visible  = Value;
 panelState->Visible   = Value;
 panelCountry->Visible = Value;

 if (!Value)
  inlineAddress->Height = 24;

 inlineAddress->Arrange();

 TframeTinyRecordGeneric::SetExpanded(Value);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Address::inlineAddressArrange(
      TObject *Sender)
{
 Height = inlineAddress->Height;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Address::panelButtonsResize(
      TObject *Sender)
{
 inlineAddress->Left = ((panelButtons->Width + 8) / 8) * 8; // next multiple of 8, but not touching? (i hope)
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_Address::Valid()
{
 if (StringToInt(CurrentId) > 3 && editLine1->Text != "" &&
     (editZip->Text == "" || comboCity->Text == "" ||
      comboState->Text == "" || comboCounty->Text == ""))
 {
   int answer = PSay("At least one address record on this screen has an address, but a city, state, county, or zip code is missing.\n\n"
                     "Note that if you enter the zip code and press Enter, the city, state, and county will automatically be filled in for you.\n\n"
                     "You can continue, but the record in question will automatically be marked as incomplete due to missing data.\n\n"
                     "Continue with missing data and mark record as incomplete?", m_confirmation, MB_YESNO);
   if (answer == IDYES)
     CurrentId = lookupTables->IdOf("current_types", "Incomplete");
   else
     return false;
 }
 if (!lookupTables->IsInLookUpTable("state_types", comboState->Text.c_str()))
 {
  PSay("Please ensure that each contact info record containing an address has a valid state.", m_invalid_data, MB_OK);
  Expanded = true;
  return false;
 } else
 if (comboCounty->Text != "" && !lookupTables->IsInLookUpTable("county_types", comboCounty))
 {
  PSay("Please ensure that each contact info record containing an address has a valid county.\n\nNote that if you enter the zip code and press Enter, the city, state, and county will automatically be filled in for you.", m_invalid_data, MB_OK);
  return false;
 } else
 if (!lookupTables->IsInLookUpTable("country_types", comboCountry->Text.c_str()))
 {
  PSay("Please ensure that each contact info record containing an address has a valid country.", m_invalid_data, MB_OK);
  return false;
 } else
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Address::buttonZipLookupClick(TObject *Sender)
{
 string zip_code = editZip->Text.c_str(), state_name, county_name, preferred_city_name;
 vector<map<string, string> > zip_vec;
 if (!ZipLookup(zip_code, zip_vec, state_name, county_name, preferred_city_name, comboState, comboCounty, comboCity))
   PSay("Zip code not found.  Please check that it is in either 5 digit or 5-4 digit format, and that the number is correct.  If you are sure that this zip code is correct and continue to get this error, contact a programmer.", m_invalid_data, MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Address::comboStateChange(TObject *Sender)
{
 string state_id, county_sql;
 if (!CountyLookupByState(comboState->Text.c_str(), state_id, county_sql, comboCounty)) /* whoops */ ;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Address::comboStateExit(TObject *Sender)
{
 string state_id, county_sql;
 if (!CountyLookupByState(comboState->Text.c_str(), state_id, county_sql, comboCounty)) /* whoops */ ;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Address::editZipKeyPress(TObject *Sender, char &Key)
{
 if (Key == VK_RETURN)
  buttonZipLookup->Click();
}
//---------------------------------------------------------------------------


