//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeFrameTinyRecord_InsuranceCoverage.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeFrameTinyRecordGeneric"
#pragma link "codeInlineContainer"
#pragma link "codeFrameTinyRecord_TaxEntity"
#pragma link "codeFrameTinyRecordMagic"
#pragma link "codeFrameTinyRecord_InsurancePolicy"
#pragma link "codePaddedBox"
#pragma resource "*.dfm"
TframeTinyRecord_InsuranceCoverage *frameTinyRecord_InsuranceCoverage;
//---------------------------------------------------------------------------
__fastcall TframeTinyRecord_InsuranceCoverage::TframeTinyRecord_InsuranceCoverage(TComponent* Owner)
        : TframeTinyRecordGeneric(Owner)
{
 CanExpand = true;
 panelResize(NULL);
 Expanded = true;

 framePolicy->Id = "0";
 framePolicy->Magic = trm_new;
 framePolicy->AllowNone = false;
 framePolicy->Label = "Policy";

 labelDescription->Caption = framePolicy->Desc.c_str(); // temporary?

 framePCP->Id = "0";
 framePCP->Magic = trm_existing;
 framePCP->Label = "Primay Care Physician";

 framePolicy->OnFieldChange = PolicyChanged;
}
//---------------------------------------------------------------------------
TframeTinyRecordGeneric* TframeTinyRecord_InsuranceCoverage::Create(TComponent* Owner)
{
 TframeTinyRecordGeneric * z = NULL;
 FORM_TRY
  z = new TframeTinyRecord_InsuranceCoverage(Owner);                 
 FORM_CATCH
 return z;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsuranceCoverage::FrameResize(
      TObject *Sender)
{
 framePolicy->Width = Width - framePolicy->Left;
 framePCP->Width = Width - framePCP->Left;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsuranceCoverage::panelResize(
      TObject *Sender)
{
 Height = panelDetails->Height
        + (panelCoverage->Visible ? panelCoverage->Height : 0)
        + (panelBottom->Visible ? panelBottom->Height : 0);
 ArrangeByTabOrder(this, true);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsuranceCoverage::panelButtonsResize(
      TObject *Sender)
{
 labelDescription->Left = ((panelButtons->Width + 8) / 8) * 8;
/*
 panelCoverage->Left = ((panelButtons->Width + 8) / 8) * 8; // next multiple of 8, but not touching? (i hope)

 framePolicy->Left  = panelCoverage->Left;
 framePCP->Left     = panelCoverage->Left;
 _labelPolicy->Left = framePolicy->Left - 48;
 _labelPCP->Left    = framePCP->Left - 48;
*/
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsuranceCoverage::SetExpanded (bool Value)
{
 TframeTinyRecordGeneric::SetExpanded(Value);
 panelCoverage->Visible = Expanded;
 panelBottom->Visible = Expanded;
 panelResize(NULL);
 if (Value && framePolicy->WillHaveId)
  framePolicy->Expanded = Value;
}
//---------------------------------------------------------------------------
string __fastcall TframeTinyRecord_InsuranceCoverage::GetSourceTableName ()
{
 return "insurance_coverage";
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsuranceCoverage::SetConcentrator (tr_magic_concentrator * Value)
{
 TframeTinyRecordGeneric::SetConcentrator(Value); // just stores it.
 framePolicy->Concentrator = Value;
 framePCP->Concentrator = Value;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsuranceCoverage::SetId (string Value)
{
 // TODO: clear local fields
 editName->Text           = "";
 editEffectiveDate->Text  = "";
 editTerminatedDate->Text = "";
 editPersonCode->Text     = "";

 bool can_change = ((!IsBlankOrZero(Value) && optionsPermissions["table." + SourceTableName]["update"] == "true") ||
                    ( IsBlankOrZero(Value) && optionsPermissions["table." + SourceTableName]["insert"] == "true"));
 framePolicy->AllowSourceChange = can_change;
 framePCP->AllowSourceChange    = can_change;
 panelCoverage->Enabled         = can_change;

 if (IsBlankOrZero(Value))
 {
  FCurrentId = "4";
  TframeTinyRecordGeneric::SetId(Value);
  framePolicy->Id = "0";
  framePolicy->Magic = trm_existing;
  framePCP->Id = "0";
  framePCP->Magic = trm_existing;
 } else
 {
  map<string, string> t;

  string coverage_sql =
    "select tax_entity_id, name_on_card, insurance_policy_id, person_code, start_date, stop_date, person_id, current_id "
    "from insurance_coverage where id = " + Value;

  if (SqlToMap(dbDatabase, coverage_sql, t))
  {
   FCurrentId = t["current_id"];

   // set local fields
   editName->Text           = PrettyString(t["name_on_card"]).c_str();
   editEffectiveDate->Text  = t["start_date"].c_str();
   editTerminatedDate->Text = t["stop_date"].c_str();
   editPersonCode->Text     = t["person_code"].c_str();

   PersonId = t["person_id"]; 

   // set id on child frames
   framePolicy->Magic    = trm_existing;
   framePolicy->Id       = t["insurance_policy_id"];
   framePolicy->Expanded = false;

   if (!IsBlankOrZero(t["tax_entity_id"]))
   {
    framePCP->Magic     = trm_existing;
    framePCP->Id        = t["tax_entity_id"];
    framePCP->Expanded  = false;
   } else
   {
    framePCP->Magic = trm_none;
   }

   TframeTinyRecordGeneric::SetId(Value);
   Expanded = true;
  } else
   PSay("Failed to load a plausible record number", m_database_error, MB_OK, Value);
 }
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_InsuranceCoverage::Save (TIBTransaction * dbTransaction)
{
 string curr_time = RightNow(); // jhaley: call only once for consistency
 AtlasBeforeSave(dbTransaction);

 map<string, string> row;
 if (!HasId)
 {
  CreateInsertMap (dbTransaction, SourceTableName, row);
  row["id"] = GetNextId(dbTransaction, SourceTableName);
  // jhaley: need to populate creation_stamp and created_by from here
  row["creation_stamp"] = curr_time;
  row["created_by"] = current_userid;
 } else
  row["id"] = Id;

 // weird: this is done out of order so the policy record can, upon ::Save(),
 // try to modify this one coverage when it's trying to terminate them all
 // (because this one gets saved after the policy, overwriting any changes it might have made to 'all coverages' --
 // for that matter, this coverage could be new, so the policy wouldn't be able to modify it directly in the db)
 // so ... yeah. save the policy before pulling any fields from the record, so they can be modified.
 bool success = true;

 if (success)
  success = framePolicy->Save(dbTransaction);
 framePolicy->AtlasGet(pending_atlas_notifications);
 row["insurance_policy_id"] = framePolicy->Id;

 row["name_on_card"] = editName->Text.c_str();
 if (editEffectiveDate->Text != "")
  row["start_date"] = Pdate(editEffectiveDate->Text.c_str(), global_mode).OutDate(global_mode).c_str();
 else
  row["start_date"] = "";
 if (editTerminatedDate->Text != "")
  row["stop_date"] = Pdate(editTerminatedDate->Text.c_str(), global_mode).OutDate(global_mode).c_str();
 else
  row["stop_date"] = "";
 row["person_code"] = editPersonCode->Text.c_str();

 row["person_id"] = PersonId;

 row["current_id"]        = CurrentId;
 row["last_update_stamp"] = curr_time;
 row["last_updated_by"]   = current_userid;

 if (success)
  success = framePCP->Save(dbTransaction);
 framePCP->AtlasGet(pending_atlas_notifications);
 row["tax_entity_id"] = framePCP->Id;

 if (success)
  if (!HasId && (optionsPermissions["table." + SourceTableName]["insert"] == "true"))
   success = ExecuteInsertStatement(dbTransaction, SourceTableName, row);
  else if (HasId && (optionsPermissions["table." + SourceTableName]["update"] == "true"))
   if (WorthSaving(dbTransaction, row))
    success = ExecuteUpdateStatement(dbTransaction, SourceTableName, row);

 if (success)
  FId = row["id"];

 AtlasAfterSave(dbTransaction);

 return success;
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_InsuranceCoverage::Valid ()
{
  if((editPersonCode->Text != "") && (! IsInt(editPersonCode->Text.c_str())))
  {
    PSay("Please enter a valid person code (it must be a number.)", m_invalid_data, MB_OK);
    if(IsVisible(editPersonCode))
      editPersonCode->SetFocus();
    return false;
  }
  if(!framePolicy->WillHaveId)
  {
    PSay("Please select a policy", m_missing_data, MB_OK);
    return false;
  }
  if(!Pdate(editEffectiveDate->Text.c_str(), mdy | yy).IsValidDate()) // jhaley 20110824: required
  {
    PSay("Please enter a valid effective date.\n\n"
         "If no date is available from either the patient or his/her insurance card, please use today's date "
         "as a placeholder.", m_invalid_data, MB_OK);
    if (IsVisible(editEffectiveDate))
      editEffectiveDate->SetFocus();
    return false;
  }
  if(!Pdate(editTerminatedDate->Text.c_str(), mdy | yy).IsValidDate() && !(editTerminatedDate->Text == ""))
  {
    PSay("Please enter a valid terminated date.", m_invalid_data, MB_OK);
    if(IsVisible(editTerminatedDate))
      editTerminatedDate->SetFocus();
    return false;
  }

  string coverage_sql =
    "select count(*) from insurance_coverage where insurance_policy_id = "
     + framePolicy->Id + (HasId ? string(" and id != " + Id) : string(""));

  if(editPersonCode->Text != "" && IsInt(editPersonCode->Text.c_str()) && framePolicy->HasId &&
     StringToInt(GetOneField(dbDatabase, coverage_sql)) > 1)
  {
    if (IDNO == PSay("Another insurance coverage for this same insurance policy already has this 'Person Code'.\n"
                     "Are you sure you want to continue?", m_invalid_data, MB_YESNO))
    {
      if (IsVisible(editPersonCode))
        editPersonCode->SetFocus();
      return false;
    }
  }

  // jhaley 20110824: Fixed serious glitch: subframes not validated at all if above "if" was taken. "else"'s are really
  // killing correctness in these validation routines - considering mass extermination.
  bool success = true;
  success = success && framePolicy->Valid();
  success = success && framePCP->Valid();
  return success;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsuranceCoverage::PolicyChanged(TObject *Sender)
{
 if (framePolicy->WillHaveId)
 {
  if (editEffectiveDate->Text == "" && framePolicy->editEffectiveDate->Text != "")
   editEffectiveDate->Text = framePolicy->editEffectiveDate->Text;
  if (editTerminatedDate->Text == "" && framePolicy->editTerminatedDate->Text != "")
   editTerminatedDate->Text = framePolicy->editTerminatedDate->Text;
 }
 labelDescription->Caption = framePolicy->Desc.c_str();
}
//---------------------------------------------------------------------------

