//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeFrameTinyRecord_InsurancePolicy.h"
#include "codeFrameTinyRecord_InsuranceCoverage.h"
#include "codeSearchInsurancePolicy.h"
#include "codeSpecialSelectListview.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeFrameTinyRecordMagic"
#pragma link "codeInlineContainer"
#pragma link "codeFrameTinyRecord_TaxEntity"
#pragma link "codeFrameTinyRecordGeneric"
#pragma link "codeFrameTinyRecord_Person"
#pragma link "codeHalfButton"
#pragma link "codeFrameCheckListDropDown"
#pragma link "codePaddedBox"
#pragma resource "*.dfm"
TframeTinyRecord_InsurancePolicy *frameTinyRecord_InsurancePolicy;
//---------------------------------------------------------------------------
__fastcall TframeTinyRecord_InsurancePolicy::TframeTinyRecord_InsurancePolicy(TComponent* Owner)
        : TframeTinyRecordMagic(Owner)
{
 CanExpand = true;
 panelResize(NULL);
 Expanded = true;
                                                              
 frameInsurer->Id = "0";
 frameInsurer->Magic = trm_existing;
 frameInsurer->AllowNone = false;
 frameInsurer->Label = "Insurance company";
 // frameInsurer->OnSetId = frameInsurerSetId;
 frameInsurer->OnFieldChange = frameInsurerChanged;

 framePolicyHolder->Id = "0";
 framePolicyHolder->Magic = trm_existing;
 framePolicyHolder->Label = "Policy holder";
 framePolicyHolder->OnFieldChange = framePolicyHolderChanged;

 frameEmployer->Id = "0";
 frameEmployer->Magic = trm_existing;
 frameEmployer->Label = "Employer";

 framePolicyHolder->OnNameChange = framePolicyHolderNameChange;

 lookupTables->RegisterComboBox("insurance_types", comboType);

 comboAreas->Filter->SetSecurity("insurance_benefits");
 comboAreas->Filter->AddColumnSpec("Area", "insurance_benefits", as_text, true, 120);
 comboAreas->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 comboAreas->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 comboAreas->Filter->SetSQLStatement("select item, 4, id from area_types where id > 0");
 comboAreas->Filter->ForceRefreshDataSet();
 comboAreas->DisplayFieldName = "Area";
 comboAreas->DropDownHeight = 144;
}
//---------------------------------------------------------------------------
__fastcall TframeTinyRecord_InsurancePolicy::~TframeTinyRecord_InsurancePolicy()
{
 // frame???->OnChange         = NULL;
 lookupTables->UnregisterComboBox(comboType);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsurancePolicy::frameInsurerChanged(TObject *Sender)
{
 editAnyChange(Sender);
 editAnyExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsurancePolicy::framePolicyHolderChanged(TObject *Sender)
{
 editAnyChange(Sender);
 editAnyExit(Sender);
}
//---------------------------------------------------------------------------
TframeTinyRecordGeneric* TframeTinyRecord_InsurancePolicy::Create(TComponent* Owner)
{
 TframeTinyRecordGeneric * z = NULL;
 FORM_TRY
  z = new TframeTinyRecord_InsurancePolicy(Owner);
 FORM_CATCH
 return z;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsurancePolicy::panelResize(TObject *Sender)
{
 Height = panelInsurancePolicyTop->Height
        + (panelDetails->Visible ? panelDetails->Height : 0);
 ArrangeByTabOrder(panelDetails, true);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsurancePolicy::SetExpanded (bool Value)
{
 panelDetails->Visible = Value;
 panelResize(panelDetails);
 TframeTinyRecordMagic::SetExpanded(Value);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsurancePolicy::FrameResize(TObject *Sender)
{
 // recalc width
 frameInsurer->Width      = Width - frameInsurer->Left;
 framePolicyHolder->Width = Width - framePolicyHolder->Left;
 frameEmployer->Width     = Width - frameEmployer->Left;
}
//---------------------------------------------------------------------------
string __fastcall TframeTinyRecord_InsurancePolicy::GetSourceTableName ()
{
 return "insurance_policies";
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsurancePolicy::SetConcentrator (tr_magic_concentrator * Value)
{
 TframeTinyRecordGeneric::SetConcentrator(Value); // just stores it.
 frameInsurer->Concentrator = Value;
 framePolicyHolder->Concentrator = Value;
 frameEmployer->Concentrator = Value;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsurancePolicy::SetId (string Value)
{
 // TODO: clear local fields
 // DONE?: comboType->Text = lookupTables->ValueOf("", t[""]);
 comboType->Text           = "";
 editGroupNumber->Text     = "";
 editPolicyNumber->Text    = "";
 editBinNumber->Text       = "";
 editProcessorNumber->Text = "";
 editEffectiveDate->Text   = "";
 editTerminatedDate->Text  = "";
 editName->Text            = "";
 comboAreas->Filter->UncheckAll();
 previously_known_benefits.clear();

 bool can_change = ((!IsBlankOrZero(Value) && optionsPermissions["table." + SourceTableName]["update"] == "true") ||
                    ( IsBlankOrZero(Value) && optionsPermissions["table." + SourceTableName]["insert"] == "true"));
 frameInsurer->AllowSourceChange      = can_change;
 framePolicyHolder->AllowSourceChange = can_change;
 frameEmployer->AllowSourceChange     = can_change;
 panelPolicyDetails->Enabled          = can_change;
 panelAbovePolicy->Enabled            = can_change;
 comboAreas->Filter->SetCheckLocked(!can_change);

 if (IsBlankOrZero(Value))
 {
  FCurrentId = "4";
  TframeTinyRecordMagic::SetId(Value);
  frameInsurer->Id = "0";
  frameInsurer->Magic = trm_existing;
  framePolicyHolder->Id = "0";
  framePolicyHolder->Magic = trm_existing;
  frameEmployer->Id = "0";
  frameEmployer->Magic = trm_existing;
  CreateLink(staticExisting, NULL, Screen->ActiveForm, "0", "insurance_policies");
 }
 else
 {
  map<string, string> t;

  // TODO: select the policy holder id (person_???_id ?)
  // should the other field be renamed, or ... ?
  string policy_sql =
    "select tax_entity_id, policy_number, group_number, start_date, stop_date, name_on_policy, person_id, "
    " policy_holder_id, bin_number, processor_control_number, current_id, insurance_id "
    "from insurance_policies where id = " + Value;

  if (SqlToMap(dbDatabase, policy_sql, t))
  {
   FCurrentId = t["current_id"];

   // set local fields
   // DONE?: comboType->Text = lookupTables->ValueOf("", t[""]);
   comboType->Text           = lookupTables->ValueOf("insurance_types", t["insurance_id"]).c_str();
   editGroupNumber->Text     = t["group_number"].c_str();
   editPolicyNumber->Text    = t["policy_number"].c_str();
   editBinNumber->Text       = t["bin_number"].c_str();
   editProcessorNumber->Text = t["processor_control_number"].c_str();
   editEffectiveDate->Text   = t["start_date"].c_str();
   editTerminatedDate->Text  = t["stop_date"].c_str();
   editName->Text            = PrettyString(t["name_on_policy"]).c_str();

   // set id on child frames
   frameInsurer->Magic    = trm_existing;
   frameInsurer->Id       = t["tax_entity_id"];
   frameInsurer->Expanded = false;

   if (!IsBlankOrZero(t["person_id"]))
   {
    frameEmployer->Magic     = trm_existing;
    frameEmployer->Id        = t["person_id"];
    frameEmployer->Expanded  = false;
   }
   else
   {
    frameEmployer->Magic = trm_none;
   }

   framePolicyHolder->Magic = trm_none;
   if (!IsBlankOrZero(t["policy_holder_id"]))
   {
    framePolicyHolder->Magic     = trm_existing;
    framePolicyHolder->Id        = t["policy_holder_id"];
    framePolicyHolder->Expanded  = false;
   }
   else
   {
    framePolicyHolder->Magic = trm_none;
   }

   string benefits_sql =
     "select area_id from insurance_benefits where insurance_benefits.is_covered = 1 and "
     " insurance_benefits.insurance_policy_id = " + Value;

   if (SqlToSet(dbDatabase, benefits_sql, previously_known_benefits))
    comboAreas->Filter->SetCheckedWhereID (previously_known_benefits, true);
   else
    PSay("Failed to select list of included benefits.", m_database_error, MB_OK);

/* -- SQL from elsewhere. reminder: there are NOTES on these records! must preserve if *stuff* ...
   "select area_types.id, area_types.item, "
   "insurance_benefits.id benefit_id, insurance_benefits.is_covered, insurance_benefits.note benefit_note "
   "from area_types "
   "left join insurance_benefits on insurance_benefits.area_id = area_types.id and insurance_benefits.insurance_policy_id = " + current_policy_id + " "
   "where area_types.id > 0 order by area_types.item"
*/

   CreateLink(staticExisting, NULL, Screen->ActiveForm, Value, "insurance_policies");
   TframeTinyRecordMagic::SetId(Value);
   // Expanded = true;
  }
  else
   PSay("Failed to load a plausible record number", m_database_error, MB_OK, Value);
 }
 comboAreas->RefreshText();
 RefreshSuggestions();
 checkTerminateCoverages->Enabled = false;
 checkTerminateCoverages->Checked = false;
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_InsurancePolicy::MagicSave (TIBTransaction * dbTransaction)
{
 // TODO: magic stuff as with person and tax entity?
 string curr_time = RightNow(); // jhaley: call only once for consistency

 AtlasBeforeSave(dbTransaction);

 map<string, string> row;
 if (!HasId)
 {
  CreateInsertMap (dbTransaction, SourceTableName, row);
  row["id"] = GetNextId(dbTransaction, SourceTableName);
  // jhaley: need to populate creation_stamp and created_by from here
  row["creation_stamp"] = curr_time;
  row["created_by"] = current_userid;
 }
 else
  row["id"] = Id;

 // DONE?: comboType->Text = lookupTables->ValueOf("", t[""]);
 row["insurance_id"] = lookupTables->IdOf("insurance_types", comboType);
 row["group_number"] = editGroupNumber->Text.c_str();
 row["policy_number"] = editPolicyNumber->Text.c_str();
 row["bin_number"] = editBinNumber->Text.c_str();
 row["processor_control_number"] = editProcessorNumber->Text.c_str();
 if (editEffectiveDate->Text != "")
  row["start_date"] = Pdate(editEffectiveDate->Text.c_str(), global_mode).OutDate(global_mode).c_str();
 else
  row["start_date"] = "";
 if (editTerminatedDate->Text != "")
  row["stop_date"] = Pdate(editTerminatedDate->Text.c_str(), global_mode).OutDate(global_mode).c_str();
 else
  row["stop_date"] = "";
 row["name_on_policy"] = editName->Text.c_str();

 bool success = true;

 if (success)
 {
  success = frameInsurer->Save(dbTransaction);
  frameInsurer->AtlasGet(pending_atlas_notifications);
  row["tax_entity_id"] = frameInsurer->Id;
 }

 if (success)
 {
  success = frameEmployer->Save(dbTransaction);
  frameEmployer->AtlasGet(pending_atlas_notifications);
  row["person_id"] = frameEmployer->Id;
 }

 if (success)
 {
  success = framePolicyHolder->Save(dbTransaction);
  framePolicyHolder->AtlasGet(pending_atlas_notifications);
  row["policy_holder_id"] = framePolicyHolder->Id;
 }

 row["current_id"]        = CurrentId;
 row["last_update_stamp"] = curr_time;
 row["last_updated_by"]   = current_userid;

 bool expire_rows = false;
 bool copy_term_date = false;
 Pdate date_to_copy(row["stop_date"], global_mode);
 if (checkTerminateCoverages->Enabled && checkTerminateCoverages->Checked)
 {
  expire_rows = (date_to_copy <= Pdate(Date()));
  copy_term_date = true;
 }
 if (expire_rows)
  row["current_id"] = lookupTables->IdOf("current_types", "Expired");

 if (success)
 {
  if (!HasId && (optionsPermissions["table." + SourceTableName]["insert"] == "true"))
   success = ExecuteInsertStatement(dbTransaction, SourceTableName, row);
  else if (HasId && (optionsPermissions["table." + SourceTableName]["update"] == "true"))
  {
   if (WorthSaving(dbTransaction, row))
    success = ExecuteUpdateStatement(dbTransaction, SourceTableName, row);
  }
 }

 if ((!HasId && (optionsPermissions["table." + SourceTableName]["insert"] == "true")) ||
     ( HasId && (optionsPermissions["table." + SourceTableName]["update"] == "true")))
 {
  // previously_known_benefits vs.
  string policy_id = row["id"];
  set<string> keep_checked = VecToSet(comboAreas->Filter->GetMultiID());
  set<string> to_delete = subtract(previously_known_benefits, keep_checked);
  set<string> to_insert = subtract(keep_checked, previously_known_benefits);

  string delete_comma_list = SetToCommaString(to_delete);
  string insert_comma_list = SetToCommaString(to_insert);
  string sql;

  // delete where it's to_delete and note is null
  sql = "delete from insurance_benefits where insurance_policy_id = " + policy_id + " and area_id in (" + delete_comma_list + ") and note is null";
  if (!to_delete.empty())
   success = success && ExecuteStatement(dbTransaction, sql);

  // update, set is_covered = 0 where note is not null (after deleting the rest, that should actually be the rest of them)
  sql = "update insurance_benefits set is_covered = 0 where insurance_policy_id = " + policy_id + " and area_id in (" + delete_comma_list + ") and note is not null";
  if (!to_delete.empty())
   success = success && ExecuteStatement(dbTransaction, sql);

  // update, set is_covered = 1 where note is not null and is_covered = 0 and ... all that.
  sql = "update insurance_benefits set is_covered = 1 where insurance_policy_id = " + policy_id + " and area_id in (" + insert_comma_list + ") and note is not null";
  if (!to_insert.empty())
   success = success && ExecuteStatement(dbTransaction, sql);

  // crap. let's avoid duplicates, shall we?
  set<string> do_not_insert;
  success = success && SqlToSet(dbTransaction, "select area_id from insurance_benefits where insurance_policy_id = " + policy_id, do_not_insert);
  to_insert = subtract(to_insert, do_not_insert);

  // insert, set is_covered = 1, note is null for the new ones
  map<string, string> benefit_row;
  CreateInsertMap (dbTransaction, "insurance_benefits", benefit_row);
  benefit_row["current_id"]        = CurrentId;
  benefit_row["last_update_stamp"] = RightNow();
  benefit_row["last_updated_by"]   = current_userid;
  for (set<string>::iterator i = to_insert.begin(); i != to_insert.end(); i++)
  {
   benefit_row["id"] = GetNextId(dbTransaction, "insurance_benefits");
   benefit_row["area_id"] = (*i);
   benefit_row["is_covered"] = "1";
   benefit_row["insurance_policy_id"] = policy_id;
   success = success && ExecuteInsertStatement(dbTransaction, "insurance_benefits", benefit_row);
  }
 }

 if (optionsPermissions["table.insurance_coverage"]["update"] == "true" && (copy_term_date || expire_rows))
 {
  // TODO: change-log missing ...
  string sql = "update insurance_coverage set last_updated_by = '" + current_userid + "', last_update_stamp = '" + RightNow() + "' ";
  if (copy_term_date)
   sql += ", stop_date = '" + date_to_copy.OutDate(global_mode) + "' ";
  if (expire_rows)
   sql += ", current_id = '" + lookupTables->IdOf("current_types", "Expired") + "' ";
  sql += "where insurance_policy_id = '" + row["id"] + "'";
  success = success && ExecuteStatement(dbTransaction, sql);
 }

 TframeTinyRecord_InsuranceCoverage * z = dynamic_cast<TframeTinyRecord_InsuranceCoverage*>(FindNearestParentOfType(this, __classid(TframeTinyRecord_InsuranceCoverage)));
 if (z && ((z->HasId && optionsPermissions["table.insurance_coverage"]["update"] == "true")
           || optionsPermissions["table.insurance_coverage"]["insert"] == "true"))
 {
  // copy stuff to the coverage for saving ...
  if (copy_term_date && z->editTerminatedDate->Text == "")
   z->editTerminatedDate->Text = date_to_copy.OutDate(global_mode).c_str();
  if (expire_rows)
   z->CurrentId = lookupTables->IdOf("current_types", "Expired");
 }

 if (success)
  FId = row["id"];

 AtlasAfterSave(dbTransaction);

 return success;
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_InsurancePolicy::MagicValid ()
{
  if(!frameInsurer->WillHaveId)
  {
    PSay("Please select an insurance company", m_missing_data, MB_OK);
    return false;
  }
  if(!Pdate(editEffectiveDate->Text.c_str(), mdy | yy).IsValidDate()) // jhaley 20110824: Now required.
  {
    PSay("Please enter a valid effective date.\n\n"
         "If no date is available from either the patient or his/her insurance card, please use today's date "
         "as a placeholder.", m_invalid_data, MB_OK);
    if(IsVisible(editEffectiveDate))
      editEffectiveDate->SetFocus();
    return false;
  }
  if(!Pdate(editTerminatedDate->Text.c_str(), mdy | yy).IsValidDate() && !(editTerminatedDate->Text == ""))
  {
    PSay("Please enter a valid terminated date", m_invalid_data, MB_OK);
    if(IsVisible(editTerminatedDate))
      editTerminatedDate->SetFocus();
    return false;
  }
  if(!lookupTables->IsInLookUpTable("insurance_types", comboType->Text.c_str()))
  {
    PSay("Please enter a valid insurance type.", m_invalid_data, MB_OK);
    if(IsVisible(comboType))
      comboType->SetFocus();
    return false;
  }

  // jhaley 20110824: Ensure at least one coverage area is specified
  if(VecToSet(comboAreas->Filter->GetMultiID()).empty())
  {
    PSay("Please specify one or more areas of coverage for this insurance policy.", m_missing_data, MB_OK);
    if(IsVisible(comboAreas))
      comboAreas->SetFocus();
    return false;
  }

  // jhaley 20110824: Name on Policy should be valid
  if(editName->Text == "")
  {
    PSay("Please specify the name on the insurance policy.\n\n"
         "Note you can use the << button next to the field to auto-populate its value with the policy holder's name.",
         m_missing_data, MB_OK);
    if(IsVisible(editName))
      editName->SetFocus();
    return false;
  }

  // jhaley: removed all "else"'s because they are detrimental to maintenance programming
  if(editPolicyNumber->Text == "" &&
     IDNO == PSay("No policy number provided; are you sure you want to do without?", m_missing_data, MB_YESNO))
  {
    if(IsVisible(editPolicyNumber))
      editPolicyNumber->SetFocus();
    return false;
  }

  // jhaley 20110824: Obnoxious warning for blank insurance type
  if(comboType->Text == "")
  {
    int result =
      PSay("You have not specified an Insurance Type. Although this is allowed, it is highly detrimental to reporting "
           "and general use of insurance data. If possible, please verify the type of this policy against the "
           "available items in the Insurance Type combo box, and then choose the one which is most correct.\n\n"
           "Do you want to STOP saving and re-check the insurance policy type now?",
           m_missing_data, MB_YESNO);
    if(result == IDYES) // Intentionally opposite of the prior check. Do not change it, or they will click through.
    {                   // This means they must pay attention to what they're doing and not be mindless drones.
      if(IsVisible(comboType))
        comboType->SetFocus();
      return false;
    }
  }

  // jhaley 20110824: Enforced consistency between expired status and stop date:
  // * If has terminated date at or before current date, make expired
  // * If is expired, ensure has terminated date
  if(editTerminatedDate->Text != "" && Pdate(editTerminatedDate->Text.c_str(), mdy|yy) <= Pdate(Now()) &&
     (CurrentId == lookupTables->IdOf("current_types", "Current") ||
      CurrentId == lookupTables->IdOf("current_types", "Primary")))
  {
    CurrentId = lookupTables->IdOf("current_types", "Expired");
  }

  if(CurrentId == lookupTables->IdOf("current_types", "Expired") && editTerminatedDate->Text == "")
    editTerminatedDate->Text = Pdate(Now()).OutDate(mdy | yyyy).c_str();

  // Validate subframes
  bool success = true;
  success = success && frameInsurer->Valid();
  success = success && framePolicyHolder->Valid();
  success = success && frameEmployer->Valid();
  return success;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsurancePolicy::framePolicyHolderNameChange(TObject *Sender)
{
 if (editName->Text == "") // if (Magic == trm_new)
  editName->Text = framePolicyHolder->PersonName.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsurancePolicy::MatchesRefresh(TObject *Sender)
{
 TframeTinyRecordMagic::MatchesRefresh(Sender);

 if (Magic == trm_new)
 {
  int max_cond = 0;

  string sql;

  sql = "select id, 0 ";

  // 2 points for an exact match, 1 point if the record has a blank value (so we don't know it's -not- a match)
  if (lookupTables->IdOf("insurance_types", comboType) != "0")
  {
   sql += " + case when (insurance_id = " + lookupTables->IdOf("insurance_types", comboType) + ") then 2 when (insurance_id = 0) then 1 else 0 end ";
   max_cond += 2;
  }

  if (frameInsurer->HasId)
  {
   sql += " + case when (tax_entity_id = " + frameInsurer->Id + ") then 2 when (tax_entity_id = 0) then 1 else 0 end ";
   max_cond += 2;
  }

  if (editPolicyNumber->Text != "")
  {
   sql += " + case when (";

   // from search-insurance-policy
   string policy_number_string = SafeSQLString(UppercaseString(PowerSearchString(StripAllExcept(LowercaseString(editPolicyNumber->Text.c_str()), alpha_numerics))));
   sql += "policy_number like '%" + policy_number_string + "%' ";

   string digits = StripAllExcept(editPolicyNumber->Text.c_str(), uints);
   if(digits.length() > 9) // jhaley 20110824: Bug fix - this cannot execute on strings less than 9 characters long.
   {
     for (size_t i = 0; i < digits.length() - 8; i++)
     {
       sql += "or policy_number like '%" + digits.substr(i, 9) +  "%' "
              "or policy_number like '%" + PrettySSN(digits.substr(i, 9)) + "%' ";
     }
   }

   sql += ") then 2 when (policy_number is null) then 1 else 0 end ";

   max_cond += 2;
  }

  if (editGroupNumber->Text != "")
  {
   sql += " + case when (";

   // from search-insurance-policy
   string group_number_string = SafeSQLString(UppercaseString(PowerSearchString(editGroupNumber->Text.c_str())));
   sql += "group_number like '%" + group_number_string + "%' ";

   // do we have any OR's to throw in here?

   sql += ") then 2 when (group_number is null) then 1 else 0 end ";

   max_cond += 2;
  }

  sql += " from insurance_policies";

  // don't bother, as that results in a Really Big Number (tm) of results.
  if (!max_cond)
  {
   staticMatches->Caption = "Not yet searched for matches.";
   matched_ids_to_values.clear();
   return;
  }

  map<string, string> tz;
  if (!SqlToValueMap(dbDatabase, sql, tz))
   PSay(sql, m_debug, MB_OK, sql);

  int min_cond = max(1, (int)(max_cond * 0.75)); // TODO: tune until something suitable is found?
  int good_matches = 0;

  map<string, string> id_to_value;
  for (map<string, string>::iterator i = tz.begin(); i != tz.end(); i++)
   if (StringToInt(i->second) >= min_cond)
   {
    id_to_value.insert(*i);
    if (StringToInt(i->second) == max_cond)
     good_matches++;
   }

  if (id_to_value.empty())
   staticMatches->Caption = "No matches found.";
  else if (id_to_value.size() == 1)
   staticMatches->Caption = "1 match found.";
  else
   staticMatches->Caption = (IntToString(id_to_value.size()) + " matches found.").c_str();

  if (good_matches)
   staticMatches->Caption = (staticMatches->Caption.c_str() + string(" (") + IntToString(good_matches) + " exact match" + string(good_matches == 1 ? "" : "es") + ")").c_str();

  // save 'ids' for later
  matched_ids_to_values = id_to_value;
  last_max_score = max_cond;

  // do something with clicking on the number of matches (show list?)
  // allow users to say "yeah, that one"
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsurancePolicy::buttonSearchClick(TObject *Sender)
{
 // create and show new person search form
 vector<string> return_vector = TformSearchInsurancePolicy::Do(dynamic_cast<TformSpecialGeneric*>(FindNearestParentOfType(this, __classid(TformSpecialGeneric))));
 if (! return_vector.empty())
 {
  Id = return_vector[0];
  if (AutoExpandOnSetId)
   Expanded = true;
 }
}
//---------------------------------------------------------------------------
string __fastcall TframeTinyRecord_InsurancePolicy::GetDesc ()
{
 // Do we need insurance_type here too?
 // string ins_type = LowercaseString(comboType->Text.c_str());
 // string(gender.empty() ? "" : (", " + gender).c_str()) +

 string i = (frameInsurer->Desc);
 string p = editPolicyNumber->Text.c_str();
 string h = (framePolicyHolder->PersonName);
 string u = i + " / " + p + " / " + h;
 return u;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsurancePolicy::staticMatchesClick(TObject *Sender)
{
 if (matched_ids_to_values.empty())
  return;

 TIBTransaction * dbTransaction = NULL;
 FORM_TRY
  dbTransaction = new TIBTransaction(NULL);
 FORM_CATCH

 try
 {
  StdTransaction(dbTransaction, dbDatabase);
  string assigned_query_number = GetNextId(dbTransaction, "temp_id");
  vector<string> fields;
  fields.push_back("q");
  fields.push_back("id");
  fields.push_back("c");
  list<vector<string> > values;
  vector<string> blank_values;
  blank_values.push_back(assigned_query_number);
  blank_values.push_back("");
  blank_values.push_back("0");
  for(map<string, string>::const_iterator i = matched_ids_to_values.begin(); i != matched_ids_to_values.end(); i++)
  {
   blank_values[1] = i->first;
   blank_values[2] = IntToString((100.0 * StringToInt(i->second)) / last_max_score);
   values.push_back(blank_values);
  }
  if (!ExecutePreparedInsert (dbTransaction, "temp_id", fields, values))
   throw(99);

  string answer;
  TformSpecialSelectListview * z = NULL;
  FORM_TRY
   z = new TformSpecialSelectListview(NULL, &answer);
  FORM_CATCH

  z->Filter->SetSecurity("insurance_policies");
  z->Filter->AddColumnSpec("Score", "tax_entities", as_int, true, 80, rawString, fc_right); // ADDED! apparently you can't fc_right the first column. d'oh.
  z->Filter->AddColumnSpec("Company", "tax_entities", as_text, true, 140, rawString);
  z->Filter->AddColumnSpec("Policy Number", "insurance_policies", as_text, true, 110, rawString);
  z->Filter->AddColumnSpec("Group Number", "insurance_policies", as_text, false, 100, rawString);
  z->Filter->AddColumnSpec("Effective Date", "insurance_policies", as_date, true, 100);
  z->Filter->AddColumnSpec("Termination Date", "insurance_policies", as_date, false, 100);
  z->Filter->AddColumnSpec("Insurance", "tax_entities", as_text, true, 100);
  z->Filter->AddColumnSpec("Coverage", "insurance_policies", as_text, false, 100);
  z->Filter->AddColumnSpec("Source", "insurance_policies", as_text, false, 100);
  z->Filter->AddColumnSpec("Name on Policy", "insurance_policies", as_text, true, 120);
  z->Filter->AddColumnSpec("BIN #", "insurance_policies", as_text, false, 75, rawString);
  z->Filter->AddColumnSpec("PCN", "insurance_policies", as_text, false, 65, rawString);
  z->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  z->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  z->Filter->SetIconStatus(true);
  z->SourceTableName = "insurance_policies";

  // stolen from codeSearchPerson
  string sql =
        "select "
        "temp_id.c || '%', "
        "tax_entities.name, insurance_policies.policy_number, insurance_policies.group_number, "
        "insurance_policies.start_date, insurance_policies.stop_date, insurance_types.item, coverage_types.item, "
        "source_types.item, insurance_policies.name_on_policy, insurance_policies.bin_number, insurance_policies.processor_control_number, "
        "insurance_policies.current_id, insurance_policies.id "
        "from insurance_policies inner join tax_entities on insurance_policies.tax_entity_id = tax_entities.id "
        "inner join coverage_types on insurance_policies.coverage_id = coverage_types.id "
        "inner join insurance_types on insurance_policies.insurance_id = insurance_types.id "
        "inner join source_types on insurance_policies.source_id = source_types.id "
        "inner join temp_id on temp_id.q = " + assigned_query_number + " and insurance_policies.id = temp_id.id "
        "where insurance_policies.id > 0 ";

  z->Width = 600;
  z->Execute(dbTransaction, sql);
  z->Filter->Sort(z->listStuff->Columns->Items[0], true); // defaults to sorting in the wrong direction? (messy!)
  z->ShowTaskModal(dynamic_cast<TformSpecialGeneric*>(FindNearestParentOfType(this, __classid(TformSpecialGeneric))));

  sql = "delete from temp_id where q = " + assigned_query_number;
  if (!ExecuteStatement(dbTransaction, sql))
  {
   PSay("Failed to delete temporary data.", m_database_error, MB_OK);
   throw(1);
  }

  if (!answer.empty())
  {
   // TODO: do we need to ask for confirmation?
   Magic = trm_existing; // 'cause ... it's not automatic when setting Id? maybe I should fix that.
   Id = answer; // this expands automatically ... but setting Magic, well, that contracts. so we do it this way (least fuss.)
   Expanded = true;
   // PSay("Selected: " + answer, m_debug, MB_OK);
  }

  dbTransaction->Commit();
 }
 catch(...)
 {
  if (dbTransaction->Active)
   dbTransaction->Rollback();
 }
 delete dbTransaction;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsurancePolicy::editPolicyNumberChange(TObject *Sender)
{
 editAnyChange(Sender);
 RefreshSuggestions();
}
//---------------------------------------------------------------------------
void TframeTinyRecord_InsurancePolicy::RefreshSuggestions()
{
 string a;
 string num = UppercaseString(editPolicyNumber->Text.c_str());
 if (LikeString("%______0_", num) || LikeString("%______-_", num) || LikeString("%______-__", num) ||
     LikeString("%______A",  num) || LikeString("%______B",  num) || LikeString("%______D",   num))
 {
  if (IsInt(num.substr(num.size() - 2))) // a '-' won't hurt it
   a += "'" + StripLeading(num.substr(num.size() - 2), "-") + "' might be a 'person code', best indicated above.\n";
  else
   a += "'" + num.substr(num.size() - 1) + "' might be optional, especially with Medicare (put A, B, D on separate policies.)\n";
 }
 if (LikeString("%______ ______%", num))
  a += "Make sure you split policy and group numbers into separate fields.\n";

 labelSuggestions->Caption = a.c_str();
 paddedSuggestions->Visible = !a.empty();
 panelArrow->Visible = paddedSuggestions->Visible;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsurancePolicy::editTerminatedDateChange(TObject *Sender)
{
 editAnyChange(Sender);
 checkTerminateCoverages->Enabled = (editTerminatedDate->Text != "");
 checkTerminateCoverages->Checked = checkTerminateCoverages->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_InsurancePolicy::buttonGrabPolicyHolderNameClick(TObject *Sender)
{
 // probably redundant ...
 if (framePolicyHolder->WillHaveId && !framePolicyHolder->PersonName.empty())
 {
  editName->Text = framePolicyHolder->PersonName.c_str();
  editAnyChange(editName);
  editAnyExit(editName);
 }
}
//---------------------------------------------------------------------------
