//---------------------------------------------------------------------------

#ifndef codeFrameTinyRecord_InsurancePolicyH
#define codeFrameTinyRecord_InsurancePolicyH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameTinyRecordMagic.h"
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include "codeInlineContainer.h"
#include "codeFrameTinyRecord_TaxEntity.h"
#include "codeFrameTinyRecordGeneric.h"
#include "codeFrameTinyRecord_Person.h"
#include "codeHalfButton.h"
#include "Filter.h"
#include "codeFrameCheckListDropDown.h"
#include "codePaddedBox.h"
#include <Graphics.hpp>
//---------------------------------------------------------------------------
class TframeTinyRecord_InsurancePolicy : public TframeTinyRecordMagic
{
__published:	// IDE-managed Components
        TPanel *panelInsurancePolicyTop;
        TPanel *panelDetails;
        TPanel *panelInsurer;
        TLabel *_labelInsurer;
        TframeTinyRecord_TaxEntity *frameInsurer;
        TPanel *panelPolicyHolder;
        TLabel *_labelPolicyHolder;
        TframeTinyRecord_Person *framePolicyHolder;
        TPanel *panelEmployer;
        TLabel *_labelEmployer;
        TframeTinyRecord_Person *frameEmployer;
        TPanel *panelAbovePolicy;
        TPanel *panelName;
        TLabel *_labelPolicyName;
        TEdit *editName;
        TPanel *panelPolicyDetails;
        TPanel *panelGRP;
        TLabel *_labelGRP;
        TEdit *editGroupNumber;
        TPanel *panelPOL;
        TLabel *_labelPOL;
        TEdit *editPolicyNumber;
        TPanel *panelType;
        TLabel *_labelType;
        TComboBox *comboType;
        TPanel *panelDates;
        TLabel *_labelStart;
        TLabel *_labelStop;
        TEdit *editEffectiveDate;
        TEdit *editTerminatedDate;
        TPanel *panelBIN;
        TLabel *_labelBIN;
        TEdit *editBinNumber;
        TPanel *panelPCN;
        TLabel *_labelPCN;
        TEdit *editProcessorNumber;
        TPanel *panelAreas;
        TLabel *_labelAreas;
        TframeCheckListDropDown *comboAreas;
        TPaddedBox *paddedSuggestions;
        TLabel *labelSuggestions;
        TCheckBox *checkTerminateCoverages;
        TPanel *panelArrow;
        TImage *imageArrow;
        THalfButton *buttonGrabPolicyHolderName;
        void __fastcall panelResize(TObject *Sender);
        void __fastcall FrameResize(TObject *Sender);
        void __fastcall framePolicyHolderNameChange(TObject *Sender);
        void __fastcall buttonSearchClick(TObject *Sender);
        void __fastcall staticMatchesClick(TObject *Sender);
        void __fastcall editPolicyNumberChange(TObject *Sender);
        void __fastcall editTerminatedDateChange(TObject *Sender);
        void __fastcall buttonGrabPolicyHolderNameClick(TObject *Sender);
        void __fastcall frameInsurerChanged(TObject *Sender);
        void __fastcall framePolicyHolderChanged(TObject *Sender);
private:	// User declarations
        classFilterObject benefits_filter;
        set<string> previously_known_benefits;
protected:
        void __fastcall virtual SetExpanded (bool Value);
        string __fastcall virtual GetSourceTableName ();
        void __fastcall virtual SetConcentrator (tr_magic_concentrator * Value);
        void __fastcall virtual SetId (string Value);
        bool virtual MagicSave (TIBTransaction * dbTransaction);
        bool virtual MagicValid ();
        string __fastcall virtual GetDesc ();
        void __fastcall virtual MatchesRefresh(TObject *Sender);
        void RefreshSuggestions();
public:		// User declarations
        __fastcall TframeTinyRecord_InsurancePolicy(TComponent* Owner);
        __fastcall ~TframeTinyRecord_InsurancePolicy();
        static TframeTinyRecordGeneric* Create(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TframeTinyRecord_InsurancePolicy *frameTinyRecord_InsurancePolicy;
//---------------------------------------------------------------------------
#endif
