//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeFrameTinyRecordContainer.h"
#include "codeFrameTinyRecord_Person.h"
#include "codeFrameTinyRecord_PersonName.h"
#include "codeFrameTinyRecord_Affiliation.h"
#include "codeFrameTinyRecord_PersonAddress.h"
#include "codeFrameTinyRecord_Relationship.h"
#include "codeFrameTinyRecord_Chart.h"
#include "codeSearchPerson.h"
#include "codeSpecialSelectListview.h"
#include "tinyrecord_concentrator.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeFrameTinyRecordContainer"
#pragma link "codeFrameTinyRecordMagic"
#pragma link "codeInlineContainer"
#pragma link "codePaddedBox"
#pragma link "codeHalfButton"
#pragma resource "*.dfm"
TframeTinyRecord_Person *frameTinyRecord_Person;
//---------------------------------------------------------------------------
__fastcall TframeTinyRecord_Person::TframeTinyRecord_Person(TComponent* Owner)
        : TframeTinyRecordMagic(Owner)
{
 Business = false;
 barNames->AutoSize = true;
 barAffiliations->AutoSize = true;
 barAddresses->AutoSize = true;
 barCharts->AutoSize = true;
 lookupTables->RegisterComboBox("gender_types", comboGender);
 panelMark->Visible = false;

 buttonNames->Enabled        = (optionsPermissions["table.person_names"]["insert"] == "true");
 buttonAffiliations->Enabled = (optionsPermissions["table.affiliations"]["insert"] == "true");
 buttonAddresses->Enabled    = (optionsPermissions["table.person_contact_info"]["insert"] == "true");
 buttonCharts->Enabled       = (optionsPermissions["table.charts"]["insert"] == "true");
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::SetParent (TWinControl * AParent)
{
 TframeTinyRecordMagic::SetParent(AParent);
 if (AParent)
 {
  frameNames->OnChange         = frameNamesChange;
  frameNames->OnAdd            = frameNamesAdd;
  frameAffiliations->OnChange  = frameAffiliationsChange;
  frameAffiliations->OnAdd     = frameAffiliationsAdd;
  frameAddresses->OnChange     = frameAddressesChange;
  frameCharts->OnChange        = frameChartsChange;
  frameCharts->OnAdd           = frameChartsAdd;

  frameNames->AutoCreate = true;

  frameNames->CreateMethod         = TframeTinyRecord_PersonName::Create;
  frameAffiliations->CreateMethod  = TframeTinyRecord_Affiliation::Create;
  frameAddresses->CreateMethod     = TframeTinyRecord_PersonAddress::Create;
  frameCharts->CreateMethod        = TframeTinyRecord_Chart::Create;
 }
}
//---------------------------------------------------------------------------
__fastcall TframeTinyRecord_Person::~TframeTinyRecord_Person()
{
 frameNames->OnChange         = NULL;
 frameAffiliations->OnChange  = NULL;
 frameAddresses->OnChange     = NULL;
 frameCharts->OnChange        = NULL;
 lookupTables->UnregisterComboBox(comboGender);
}
//---------------------------------------------------------------------------
TframeTinyRecordGeneric* TframeTinyRecord_Person::Create(TComponent* Owner)
{
 TframeTinyRecordGeneric * z = NULL;
 FORM_TRY
  z = new TframeTinyRecord_Person(Owner);
 FORM_CATCH
 return z;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::buttonNamesClick(TObject *Sender)
{
 paddedNames->Visible = true;
 frameNames->Add();
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::buttonAddressesClick(TObject *Sender)
{
 paddedAddresses->Visible = true;
 frameAddresses->Add();
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::buttonAffiliationsClick(TObject *Sender)
{
 paddedAffiliations->Visible = true; // if you don't do this (applies to all of these), it won't resize correctly. it's weird. (order of events? doesn't resize if not yet visible, but doesn't resize when it becomes visible?)
 frameAffiliations->Add();
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::buttonChartsClick(TObject *Sender)
{
 paddedCharts->Visible = true;
 frameCharts->Add();
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::FrameResize(TObject *Sender)
{
 if (Color != clBtnFace)
 {
  paddedNames->InnerColor         = clBtnFace;
  paddedAffiliations->InnerColor  = clBtnFace;
  paddedAddresses->InnerColor     = clBtnFace;
  paddedCharts->InnerColor        = clBtnFace;
 } else
 {
  paddedNames->InnerColor         = 0x00D3D9DD;
  paddedAffiliations->InnerColor  = 0x00D3D9DD;
  paddedAddresses->InnerColor     = 0x00D3D9DD;
  paddedCharts->InnerColor        = 0x00D3D9DD;
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::panelPersonBottomResize(TObject *Sender)
{
 Height = panelPersonTop->Height
        + (panelPersonBottom->Visible ? panelPersonBottom->Height : 0);
 ArrangeByTabOrder(panelPersonBottom, true);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::frameNamesChange(TObject *Sender)
{
 paddedNames->Visible = !frameNames->Empty; // -- will never be empty, except temporarily. avoid excessive flashing.
 buttonNames->Caption = ("Names (" + IntToString(frameNames->RecordCount) + ")").c_str();
 ArrangeButtons();
 Business = Business;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::frameAffiliationsChange(TObject *Sender)
{
 paddedAffiliations->Visible = !frameAffiliations->Empty;
 buttonAffiliations->Caption = ("Tribes (" + IntToString(frameAffiliations->RecordCount) + ")").c_str();
 ArrangeButtons();
 Business = Business;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::frameAddressesChange(TObject *Sender)
{
 paddedAddresses->Visible = !frameAddresses->Empty;
 buttonAddresses->Caption = ("Addresses (" + IntToString(frameAddresses->RecordCount) + ")").c_str();
 ArrangeButtons();
 Business = Business;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::frameChartsChange(TObject *Sender)
{
 paddedCharts->Visible = !frameCharts->Empty;
 buttonCharts->Caption = ("Charts (" + IntToString(frameCharts->RecordCount) + ")").c_str();
 ArrangeButtons();
 Business = Business;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::SetBusiness (bool Value)
{
 FBusiness = Value;
 buttonBusiness->Glyph = NULL;
 imagesPerson->GetBitmap(FBusiness ? 1 : 0, buttonBusiness->Glyph);
 buttonBusiness->Repaint();

 for (int i = 0; i < frameNames->RecordCount; i++)
  (dynamic_cast<TframeTinyRecord_PersonName*>(frameNames->Record[i]))->Business = FBusiness;

 buttonAffiliations->Visible = (!FBusiness || !frameAffiliations->Empty);
 buttonCharts->Visible = (!FBusiness || !frameCharts->Empty);
                     // not business OR non-blank -> visible
 panelGender->Visible = !Value || comboGender->Text != ""; // !IsBlankOrZero(lookupTables->IdOf("gender_types", comboGender));
 panelDOB->Visible = !Value || editDOB->Text != "";
 _labelSSN->Caption = Value ? "Tax ID" : "SSN";
 inlineDemographics->Arrange();
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::buttonBusinessClick(TObject *Sender)
{
 Business = !Business;
}
//---------------------------------------------------------------------------
void TframeTinyRecord_Person::ArrangeButtons ()
{
 TToolBar * next = barNames;

 if (!frameNames->Empty)
 {
  buttonNames->Parent = barNames;
  ArrangeByTag(next, false);
  next = barAffiliations;
 } else
  buttonNames->Parent = next; // yes, i know, it's all the same.

 if (!frameAffiliations->Empty)
 {
  buttonAffiliations->Parent = barAffiliations;
  ArrangeByTag(next, false);
  next = barAddresses;
 } else
  buttonAffiliations->Parent = next;

 if (!frameAddresses->Empty)
 {
  buttonAddresses->Parent = barAddresses;
  ArrangeByTag(next, false);
  next = barCharts;
 } else
  buttonAddresses->Parent = next;

 if (!frameCharts->Empty)
 {
  buttonCharts->Parent = barCharts;
  ArrangeByTag(next, false);
  next = barLeftovers;
 } else
  buttonCharts->Parent = next;

 // why twice? well, see ... because buttonCharts was erroneously being assigned a Left of 0, yet not really.
 // it would -look- like it was in the right place
 // it would act (in terms of raising/Flat) right
 // it would not have the right Cursor
 // it would not respond to clicking in its "should have been" position
 // it would react to clicks if you tried to click on buttonAffiliations
 // ... this was reproducible if you:
 // - took a 'new person'
 // - added a chart
 // - removed the chart
 // - tried to add a new chart or affiliation (one error or the other would happen here)

 // this seems to convince it to place things correctly. should it be done every time we ArrangeByTag above? dunno. didn't notice bugs there.
 ArrangeByTag(next, false);
 Application->ProcessMessages();
 ArrangeByTag(next, false);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::SetId (string Value)
{
 panelMark->Visible = false;

 bool can_change = ((!IsBlankOrZero(Value) && optionsPermissions["table." + SourceTableName]["update"] == "true") ||
                    ( IsBlankOrZero(Value) && optionsPermissions["table." + SourceTableName]["insert"] == "true"));
 inlineDemographics->Visible = (optionsPermissions["table." + SourceTableName]["view"] == "true");
 inlineDemographics->Enabled = can_change;
 panelBusiness->Enabled      = can_change;

 // always needed?
 comboGender->Text = "";
 editDOB->Text = "";
 editSSN->Text = "";
 frameNames->AutoCreate = false; // we don't just want this off for the Clear() function [which does this also], but also while loading data.
 frameNames->Clear();
 frameAffiliations->Clear();
 frameAddresses->Clear();
 frameCharts->Clear();

 if (IsBlankOrZero(Value))
 {
  FCurrentId = "4";
  TframeTinyRecordMagic::SetId(Value);
  CreateLink(staticExisting, NULL, Screen->ActiveForm, "0", "people");
 } else
 {
  map<string, string> t;
  if (SqlToMap(dbDatabase, "select gender_id, birth_date, social_security_number, current_id from people where id = " + Value, t))
  {
   FCurrentId = "4"; // t["current_id"];
   comboGender->Text = lookupTables->ValueOf("gender_types", t["gender_id"]).c_str();
   editDOB->Text = t["birth_date"].c_str();
   editSSN->Text = PrettySSN(t["social_security_number"]).c_str();

   string sql;
   vector<string> ids;

   if (optionsPermissions["table.person_names"]["view"] == "true")
   {
    paddedNames->Visible = true;
    int is_person = 0;
    int is_business = 0;
    sql = "select id from person_names where person_id = " + Value + " and current_id > 2";
    if (SqlToVec(dbDatabase, sql, ids))
     for (vector<string>::iterator i = ids.begin(); i != ids.end(); i++)
     {
      TframeTinyRecordGeneric * z = frameNames->Add();
      z->Id = *i;
      if (dynamic_cast<TframeTinyRecord_PersonName*>(z)->Business)
       is_business++;
      else
       is_person++;
     } else
      PSay("Failed to get list of name records", m_database_error, MB_OK, sql);

    if (is_business && !is_person)
     Business = true;
    else
     Business = false;
   } else
    Business = false;

   if (optionsPermissions["table.affiliations"]["view"] == "true")
   {
    paddedAffiliations->Visible = true;
    sql = "select id from affiliations where person_id = " + Value + " and current_id > 2";
    if (SqlToVec(dbDatabase, sql, ids))
     for (vector<string>::iterator i = ids.begin(); i != ids.end(); i++)
      frameAffiliations->Add()->Id = *i;
     else
      PSay("Failed to get list of tribal affiliation records", m_database_error, MB_OK, sql);
    if (ids.empty())
     paddedAffiliations->Visible = false;
   }

   if (optionsPermissions["table.person_contact_info"]["view"] == "true")
   {
    paddedAddresses->Visible = true;
    sql = "select id from person_contact_info where person_id = " + Value + " and current_id > 2";
    if (SqlToVec(dbDatabase, sql, ids))
     for (vector<string>::iterator i = ids.begin(); i != ids.end(); i++)
      frameAddresses->Add()->Id = *i;
     else
      PSay("Failed to get list of address records", m_database_error, MB_OK, sql);
    if (ids.empty())
     paddedAddresses->Visible = false;
   }

   if (optionsPermissions["table.charts"]["view"] == "true")
   {
    paddedCharts->Visible = true;
    set<string> can_view = GetGroupPermissions("table.charts", "", "view", "true");
    sql = "select id from charts where person_id = " + Value + " and current_id > 2 "
          "and " + SafeInClause("group_id", SetToVec(can_view));
    if (SqlToVec(dbDatabase, sql, ids))
     for (vector<string>::iterator i = ids.begin(); i != ids.end(); i++)
      frameCharts->Add()->Id = *i;
     else
      PSay("Failed to get list of chart records", m_database_error, MB_OK, sql);
    if (ids.empty())
     paddedCharts->Visible = false;
   }

   CreateLink(staticExisting, NULL, Screen->ActiveForm, Value, "people");
   TframeTinyRecordMagic::SetId(Value);
   // Expanded = true;
  } else
   PSay("Failed to load a plausible record number", m_database_error, MB_OK, Value);
 }

 if (optionsPermissions["table.person_names"]["insert"] == "true")
  frameNames->AutoCreate = true;
 buttonBusiness->Enabled = ((Magic == trm_existing && HasId) || Magic == trm_new);
}
//---------------------------------------------------------------------------
string __fastcall TframeTinyRecord_Person::GetSourceTableName ()
{
 return "people";
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_Person::MagicValid ()
{
 bool has_useful_name = false;
 for (int i = 0; i < frameNames->RecordCount; i++)
 {
  TframeTinyRecord_PersonName * z = dynamic_cast<TframeTinyRecord_PersonName*>(frameNames->Record[i]);
  int j = StringToInt(z->CurrentId);
  if (j > 2)
  {
   string first  = StripLeading(StripTrailing(z->editFirst->Text.c_str(), " "), " ");
   string middle = StripLeading(StripTrailing(z->editMiddle->Text.c_str(), " "), " ");
   string last   = StripLeading(StripTrailing(z->editLast->Text.c_str(), " "), " ");
   if (!first.empty() || !middle.empty() || !last.empty())
    has_useful_name = true;
  }
 }
 if (!has_useful_name)
 {
  PSay("Please enter at the very least one first, middle, last, or business name (that isn't marked as deleted/incorrect/expired.)", m_invalid_data, MB_OK);
  return false;
 }

 // jhaley: Protect against IBExceptions on unreasonably large future dates, which get entered by accident easily.
 Pdate dob = Pdate(editDOB->Text.c_str(), mdy | yy);
 Pdate now = Pdate(Now());
 if ((!dob.IsValidDate() || dob.year > now.year + 1000) && !(editDOB->Text == ""))
 {
  PSay("Please ensure that all dates of birth are valid.", m_invalid_data, MB_OK);
  if (IsVisible(editDOB)) editDOB->SetFocus();
  return false;
 }
 else if ((StripAllExcept(editSSN->Text.c_str(), uints).length() != 9) && (editSSN->Text != ""))
 {
  PSay("Please ensure that all SSN provided is valid (" + PrettySSN(StripAllExcept(editSSN->Text.c_str(), ints)) + ").", m_invalid_data, MB_OK);
  if (IsVisible(editSSN)) editSSN->SetFocus();
  return false;
 }
 else if (! lookupTables->IsInLookUpTable("gender_types", comboGender->Text.c_str()))
 {
  PSay("Please enter a valid gender.", m_invalid_data, MB_OK);
  if (IsVisible(comboGender)) comboGender->SetFocus();
  return false;
 }
 else
 {
  bool success = true;

  for(int i = 0; i < frameNames->RecordCount && success; i++)
  {
   TframeTinyRecord_PersonName * z = dynamic_cast<TframeTinyRecord_PersonName *>(frameNames->Record[i]);
   success = success && z->Valid();
  }

  for(int i = 0; i < frameAffiliations->RecordCount && success; i++)
  {
   TframeTinyRecord_Affiliation * z = dynamic_cast<TframeTinyRecord_Affiliation *>(frameAffiliations->Record[i]);
   success = success && z->Valid();
  }

  for(int i = 0; i < frameAddresses->RecordCount && success; i++)
  {
   TframeTinyRecord_PersonAddress * z = dynamic_cast<TframeTinyRecord_PersonAddress *>(frameAddresses->Record[i]);
   success = success && z->Valid();
  }

  for(int i = 0; i < frameCharts->RecordCount && success; i++)
  {
   TframeTinyRecord_Chart * z = dynamic_cast<TframeTinyRecord_Chart *>(frameCharts->Record[i]);
   success = success && z->Valid();
  }

  return success;
 }
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_Person::MagicSave (TIBTransaction * dbTransaction)
{
 if (Magic == trm_same && SameAs)
  return SameAs->Save(dbTransaction);
 if (Magic == trm_none)
  return true;
 if (Magic == trm_existing && !HasId)
  return true;

 AtlasBeforeSave(dbTransaction);

 map<string, string> row;
 if (!HasId)
 {
  CreateInsertMap (dbTransaction, SourceTableName, row);
  row["id"] = GetNextId(dbTransaction, SourceTableName);
 } else
  row["id"] = Id;

 row["gender_id"] = lookupTables->IdOf("gender_types", comboGender);
 row["social_security_number"] = StripAllExcept(editSSN->Text.c_str(), uints);
 if (editDOB->Text != "")
  row["birth_date"] = Pdate(editDOB->Text.c_str(), global_mode).OutDate(global_mode).c_str();
 else
  row["birth_date"] = "";

 row["current_id"]        = CurrentId;
 row["last_update_stamp"] = RightNow();
 row["last_updated_by"]   = current_userid;

 bool success = true;
 if (!HasId && (optionsPermissions["table." + SourceTableName]["insert"] == "true"))
  success = ExecuteInsertStatement(dbTransaction, SourceTableName, row);
 else if (HasId && (optionsPermissions["table." + SourceTableName]["update"] == "true"))
  if (WorthSaving(dbTransaction, row))
   success = ExecuteUpdateStatement(dbTransaction, SourceTableName, row);

 for(int i = 0; i < frameNames->RecordCount && success; i++)
 {
  TframeTinyRecord_PersonName * z = dynamic_cast<TframeTinyRecord_PersonName *>(frameNames->Record[i]);
  z->PersonId = row["id"];
  success = z->Save(dbTransaction);
  z->AtlasGet(pending_atlas_notifications);
 }

 for(int i = 0; i < frameAffiliations->RecordCount && success; i++)
 {
  TframeTinyRecord_Affiliation * z = dynamic_cast<TframeTinyRecord_Affiliation *>(frameAffiliations->Record[i]);
  z->PersonId = row["id"];
  success = z->Save(dbTransaction);
  z->AtlasGet(pending_atlas_notifications);
 }

 for(int i = 0; i < frameAddresses->RecordCount && success; i++)
 {
  TframeTinyRecord_PersonAddress * z = dynamic_cast<TframeTinyRecord_PersonAddress *>(frameAddresses->Record[i]);
  z->PersonId = row["id"];
  success = z->Save(dbTransaction);
  z->AtlasGet(pending_atlas_notifications);
 }

 for(int i = 0; i < frameCharts->RecordCount && success; i++)
 {
  TframeTinyRecord_Chart * z = dynamic_cast<TframeTinyRecord_Chart *>(frameCharts->Record[i]);
  z->PersonId = row["id"];
  success = z->Save(dbTransaction);
  z->AtlasGet(pending_atlas_notifications);
 }

 if (success)
  FId = row["id"];

 AtlasAfterSave(dbTransaction);

 return success;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::buttonSearchClick(TObject *Sender)
{
 // create and show new person search form
 vector<string> return_vector = TformSearchPerson::Do(dynamic_cast<TformSpecialGeneric*>(FindNearestParentOfType(this, __classid(TformSpecialGeneric))));
 if (! return_vector.empty())
 {
  Id = return_vector[0];
  if (AutoExpandOnSetId)
   Expanded = true;
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::SetExpanded (bool Value)
{
 TframeTinyRecordMagic::SetExpanded(Value);
 panelPersonBottom->Visible = Expanded;
 panelPersonBottomResize(panelPersonBottom);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::MatchesRefresh(TObject *Sender)
{
 TframeTinyRecordMagic::MatchesRefresh(Sender);

 if (Magic == trm_new)
 {
  int max_cond = 0;

  string sql;

  sql = "select id, 0 ";
  // sql +=" from people where 0 ";

  // 2 points for an exact match, 1 point if the record has a blank value (so we don't know it's -not- a match)
  if (!IsBlankOrZero(lookupTables->IdOf("gender_types", comboGender)))
  {
   sql += " + case when (gender_id = " + lookupTables->IdOf("gender_types", comboGender) + ") then 2 when (gender_id = 0) then 1 else 0 end ";
   max_cond += 2;
  }

  if (editDOB->Text != "" && Pdate(editDOB->Text.c_str(), global_mode).IsValidDate())
  {
   sql += " + case when (birth_date = '" + Pdate(editDOB->Text.c_str(), global_mode).OutDate(global_mode) + "') then 2 when (birth_date is null) then 1 else 0 end ";
   max_cond += 2;
  }

  if (editSSN->Text != "")
  {
   sql += " + case when (social_security_number = '" + SafeSQLString(StripAllExcept(editSSN->Text.c_str(), uints)) + "') then 2 when (social_security_number is null) then 1 else 0 end ";
   max_cond += 2;
  }

  // by name? -- up to 2 points
  for(int i = 0; i < frameNames->RecordCount; i++)
  {
   TframeTinyRecord_PersonName * z = dynamic_cast<TframeTinyRecord_PersonName *>(frameNames->Record[i]);
   if (z->editFirst->Text != "")
   {
    sql +=  " + case when exists (select id from person_names where person_id = people.id and first_name like '" + SafeSQLString(z->editFirst->Text.c_str()) + "%') then 1 else 0 end ";
    max_cond += 1;
   }
   if (z->editLast->Text != "")
   {
    sql +=  " + case when exists (select id from person_names where person_id = people.id and last_name like '" + SafeSQLString(z->editLast->Text.c_str()) + "%') then 1 else 0 end ";
    max_cond += 1;
   }
  }

  // by affiliation? -- 2 points
  for(int i = 0; i < frameAffiliations->RecordCount; i++)
  {
   TframeTinyRecord_Affiliation * z = dynamic_cast<TframeTinyRecord_Affiliation *>(frameAffiliations->Record[i]);
   if (z->editCDIB->Text != "" && lookupTables->IsInLookUpTable("tribe_types", z->comboTribe) && lookupTables->IdOf("tribe_types", z->comboTribe) != "0")
   {
    sql +=  " + case when exists (select id from affiliations where person_id = people.id and cdib like '" + SafeSQLString(z->editCDIB->Text.c_str()) + "%' and tribe_id = " + lookupTables->IdOf("tribe_types", z->comboTribe) + ") then 2 else 0 end ";
    max_cond += 2;
   }
  }

  // by chart? -- 2 points
  for(int i = 0; i < frameCharts->RecordCount; i++)
  {
   TframeTinyRecord_Chart * z = dynamic_cast<TframeTinyRecord_Chart *>(frameCharts->Record[i]);
   if (z->editNumber->Text != "" && lookupTables->IsInLookUpTable("groups", z->comboLocation) && lookupTables->IdOf("groups", z->comboLocation) != "0")
   {
    sql +=  " + case when exists (select id from charts where person_id = people.id and chart_number like '" + SafeSQLString(z->editNumber->Text.c_str()) + "%' and group_id = " + lookupTables->IdOf("groups", z->comboLocation) + ") then 2 else 0 end ";
    max_cond += 2;
   }
  }

  // by ... address? no. god no. please no?

  sql += " from people";

  // don't bother, as that results in a Really Big Number (tm) of results.
  if (!max_cond)
  {
   staticMatches->Caption = "Not yet searched for matches.";
   matched_ids_to_values.clear();
   return;
  }

  map<string, string> tz;
  if (!SqlToValueMap(dbDatabase, sql, tz))
   PSay("Failed to search for duplicates", m_database_error, MB_OK, sql);

  int min_cond = max(1, (int)(max_cond * 0.75)); // TODO: tune until something suitable is found?
  int good_matches = 0;

  map<string, string> id_to_value;
  for (map<string, string>::iterator i = tz.begin(); i != tz.end(); i++)
   if (StringToInt(i->second) >= min_cond)
   {
    id_to_value.insert(*i);
    if (StringToInt(i->second) == max_cond)
     good_matches++;
   }

  if (id_to_value.empty())
   staticMatches->Caption = "No matches found.";
  else if (id_to_value.size() == 1)
   staticMatches->Caption = "1 match found.";
  else
   staticMatches->Caption = (IntToString(id_to_value.size()) + " matches found.").c_str();

  if (good_matches)
   staticMatches->Caption = (staticMatches->Caption.c_str() + string(" (") + IntToString(good_matches) + " exact match" + string(good_matches == 1 ? "" : "es") + ")").c_str();

  // save 'ids' for later
  matched_ids_to_values = id_to_value;
  last_max_score = max_cond;

  // do something with clicking on the number of matches (show list?)
  // allow users to say "yeah, that one"
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::frameNamesAdd(TObject *Sender)
{
 dynamic_cast<TframeTinyRecord_PersonName *>(Sender)->OnFieldChange = NameChanged; // MatchesRefresh;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::NameChanged(TObject *Sender)
{
 if (FOnNameChange)
  FOnNameChange(this);
 if (FOnFieldChange)
  FOnFieldChange(this); // 'cause ... name *sorta* counts as a field.
 MatchesRefresh(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::frameAffiliationsAdd(TObject *Sender)
{
 dynamic_cast<TframeTinyRecord_Affiliation *>(Sender)->OnFieldChange = MatchesRefresh;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::frameChartsAdd(TObject *Sender)
{
 dynamic_cast<TframeTinyRecord_Chart *>(Sender)->OnFieldChange = MatchesRefresh;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::staticMatchesClick(TObject *Sender)
{
 if (matched_ids_to_values.empty())
  return;

 TIBTransaction * dbTransaction = NULL;
 FORM_TRY
  dbTransaction = new TIBTransaction(NULL);
 FORM_CATCH

 try
 {
  StdTransaction(dbTransaction, dbDatabase);
  string assigned_query_number = GetNextId(dbTransaction, "temp_id");
  vector<string> fields;
  fields.push_back("q");
  fields.push_back("id");
  fields.push_back("c");
  list<vector<string> > values;
  vector<string> blank_values;
  blank_values.push_back(assigned_query_number);
  blank_values.push_back("");
  blank_values.push_back("0");
  for(map<string, string>::const_iterator i = matched_ids_to_values.begin(); i != matched_ids_to_values.end(); i++)
  {
   blank_values[1] = i->first;
   blank_values[2] = IntToString((100.0 * StringToInt(i->second)) / last_max_score);
   values.push_back(blank_values);
  }
  if (!ExecutePreparedInsert (dbTransaction, "temp_id", fields, values))
   throw(99);

  string answer;
  TformSpecialSelectListview * z = NULL;
  FORM_TRY
   z = new TformSpecialSelectListview(NULL, &answer);
  FORM_CATCH

  z->Filter->SetSecurity("people");
  z->Filter->AddColumnSpec("Score", "people", as_int, true, 80, rawString, fc_right); // ADDED! apparently you can't fc_right the first column. d'oh. 
  z->Filter->AddColumnSpec("Last Name", "people", as_text, true, 100);
  z->Filter->AddColumnSpec("First Name", "people", as_text, true, 100);
  z->Filter->AddColumnSpec("Middle Name", "people", as_text, false, 100);
  z->Filter->AddColumnSpec("Suffix", "people", as_text, true, 50);
  z->Filter->AddColumnSpec("CDIB", "affiliations", as_text, true, 70, lowercaseString);
  z->Filter->AddColumnSpec("Tribe", "affiliations", as_text, true, 115);
  z->Filter->AddColumnSpec("Joined", "affiliations", as_date, true, 80);
  z->Filter->AddColumnSpec("Relinquished", "affiliations", as_date, true, 80);
  z->Filter->AddColumnSpec("Birthday", "people", as_date, true, 80);
  z->Filter->AddColumnSpec("SSN", "people", as_text, true, 90, prettySSNString);
  z->Filter->AddColumnSpec("Chart Num", "charts", as_text, false, 90);
  z->Filter->AddColumnSpec("Code", "conditions", as_text, false, 90);
  z->Filter->AddColumnSpec("Address", "person_contact_info", as_text, false, 140);
  z->Filter->AddColumnSpec("City", "person_contact_info", as_text, false, 80);
  z->Filter->AddColumnSpec("State", "person_contact_info", as_text, false, 80);
  z->Filter->AddColumnSpec("Zip", "person_contact_info", as_text, false, 80, prettyZipString);
  z->Filter->AddColumnSpec("Phone Number", "person_contact_info", as_text, false, 120, prettyPhoneString);
  z->Filter->AddColumnSpec("Gender", "people", as_text, false, 80);
  z->Filter->AddColumnSpec("Client Type", "people", as_text, false, 80);
  z->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  z->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  z->Filter->SetIconStatus(true);
  z->SourceTableName = "people";

  // stolen from codeSearchPerson
  set<string> can_see_charts = GetSpecialGroupPermissions("charts");
  string sql =
        "select "
        "temp_id.c || '%', "
        "person_names.last_name, person_names.first_name, person_names.middle_name, "
        "person_names.suffix, affiliations.cdib, "
        "tribe_types.item tribe, affiliations.join_date, affiliations.relinquish_date, "
        "people.birth_date, people.social_security_number, "
        "(select first 1 charts.chart_number from charts "
        "inner join groups on charts.location_id = groups.chart_location_id and groups.has_charts = 1 and charts.location_id > 0 "
        "where charts.person_id = people.id and " + SafeInClause("groups.id", SetToVec(can_see_charts)) +
/*
 if(optionsPermissions["special.lac.charts"]["enabled"] == "true")
   sql += " and charts.group_id = " + lookupTables->IdOf("groups", "Little Axe Clinic");
 else if(optionsPermissions["special.sc.charts"]["enabled"] == "true")
   sql += " and charts.group_id = " + lookupTables->IdOf("groups", "Shawnee Clinic");
 else if(optionsPermissions["special.den.charts"]["enabled"] == "true")
   sql += " and charts.group_id = " + lookupTables->IdOf("groups", "Little Axe Clinic");
 else if((optionsPermissions["special.cob.general"]["enabled"] == "true") ||
   (optionsPermissions["special.bill.general"]["enabled"] == "true") ||
   (optionsPermissions["special.res.general"]["enabled"] == "true"))
   sql += " and charts.group_id = " + lookupTables->IdOf("groups", "Contract Health");
*/
        " and charts.current_id > 2 order by groups.hl7_priority asc nulls last) chart_num, "
        "(select first 1 conditions.code from conditions "
        "where conditions.person_id = people.id) code_num, "
        "person_contact_info.line1, person_contact_info.city, "
        "state_types.item state, person_contact_info.zip, "
        "person_contact_info.phone_number, gender_types.item, enrollment_status_types.item, "
        "people.current_id, people.id "
        "from people "
        "inner join temp_id on temp_id.q = " + assigned_query_number + " and people.id = temp_id.id "
        "left join affiliations on affiliations.id = people.affiliations_id "
        "left join tribe_types on affiliations.tribe_id = tribe_types.id "
        "left join person_names on person_names.id = people.person_names_id "
        "left join person_contact_info on person_contact_info.id = people.person_contact_info_id "
        "left join state_types on person_contact_info.state_id = state_types.id "
        "left join gender_types on people.gender_id = gender_types.id "
        "left join enrollment on enrollment.person_id = people.id and enrollment.current_id+1 >= 4 and "  // jhaley: changed diab_client_id -> enrollment
        " enrollment.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "' "
        "left join enrollment_status_types on enrollment.enrollment_status_id = enrollment_status_types.id ";
  z->Width = 600;
  z->Execute(dbTransaction, sql);
  z->Filter->Sort(z->listStuff->Columns->Items[0], true); // defaults to sorting in the wrong direction? (messy!)
  z->ShowTaskModal(dynamic_cast<TformSpecialGeneric*>(FindNearestParentOfType(this, __classid(TformSpecialGeneric))));

  sql = "delete from temp_id where q = " + assigned_query_number;
  if (!ExecuteStatement(dbTransaction, sql))
  {
   PSay("Failed to delete temporary data.", m_database_error, MB_OK);
   throw(1);
  }

  if (!answer.empty())
  {
   // TODO: do we need to ask for confirmation?
   Magic = trm_existing; // 'cause ... it's not automatic when setting Id? maybe I should fix that.
   Id = answer; // this expands automatically ... but setting Magic, well, that contracts. so we do it this way (least fuss.)
   Expanded = true;
   // PSay("Selected: " + answer, m_debug, MB_OK);
  }

  dbTransaction->Commit();
 } catch (...)
 {
  if (dbTransaction->Active)
   dbTransaction->Rollback();
 }
 delete dbTransaction;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::panelButtonsResize(TObject *Sender)
{
 // note: it's not actually virtual. uh ... yeah. this is an entirely different function. with the same name. and params. but not virtual. the other is hidden.
 TframeTinyRecordMagic::panelButtonsResize(Sender);
 panelSummary->Left = panelMagic->Left;
}
//---------------------------------------------------------------------------
string __fastcall TframeTinyRecord_Person::GetDesc ()
{
 if (Magic == trm_same && SameAs)
  return SameAs->Desc;

 string gender = LowercaseString(comboGender->Text.c_str());
 string bdate;

 Pdate t(editDOB->Text.c_str(), global_mode);
 if (t.IsValidDate())
  bdate = t.OutDate(global_mode);

 string u = // "[First [Middle ]]Last[:[ gender][ born birth_date]]"
            PersonName +
            string(gender.empty() ? "" : (", " + gender).c_str()) +
            string(bdate.empty() ? "" : (", born " + bdate).c_str());
 return u;
}
//---------------------------------------------------------------------------
string __fastcall TframeTinyRecord_Person::GetPersonName ()
{
 if (Magic == trm_same && SameAs)
  return (dynamic_cast<TframeTinyRecord_Person*>(SameAs))->PersonName;

 string first;
 string middle;
 string last;

 // try to find a good name, by current_id, out of the available data.
 TframeTinyRecord_PersonName * best_match = NULL;
 int best_current_id = 0;
 for (int i = 0; i < frameNames->RecordCount; i++)
 {
  TframeTinyRecord_PersonName * z = dynamic_cast<TframeTinyRecord_PersonName*>(frameNames->Record[i]);
  int j = StringToInt(z->CurrentId);
  if (j > best_current_id)
  {
   best_current_id = j;
   best_match = z;
  }
 }
 if (best_match)
 {
  first  = PrettyString(StripLeading(StripTrailing(best_match->editFirst->Text.c_str(), " "), " "));
  middle = PrettyString(StripLeading(StripTrailing(best_match->editMiddle->Text.c_str(), " "), " "));
  last   = PrettyString(StripLeading(StripTrailing(best_match->editLast->Text.c_str(), " "), " "));
 }

 string answer = string(first.empty() ? "" : (first + " ").c_str()) + last;
 return answer;
 // string((first.empty() || middle.empty()) ? "" : (middle + " ").c_str()) + // just started to annoy me!
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::SetConcentrator (tr_magic_concentrator * Value)
{
 TframeTinyRecordMagic::SetConcentrator(Value);

 // and now, inform people. yup.
 frameNames->Concentrator        = Value;
 frameAffiliations->Concentrator = Value;
 frameAddresses->Concentrator    = Value;
 frameCharts->Concentrator       = Value;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::ShortCut(TWMKey &Msg, bool &Handled)
{
 TframeTinyRecordMagic::ShortCut(Msg, Handled);

 if(HIBYTE(GetAsyncKeyState(VK_CONTROL)) && !HIBYTE(GetAsyncKeyState(VK_MENU)) && Msg.CharCode == '1' && buttonNames->Visible && buttonNames->Enabled)
 {
  paddedNames->Visible = true;
  frameNames->Add(true);
  Handled = true;
 }

 if(HIBYTE(GetAsyncKeyState(VK_CONTROL)) && !HIBYTE(GetAsyncKeyState(VK_MENU)) && Msg.CharCode == '2' && buttonAffiliations->Visible && buttonAffiliations->Enabled)
 {
  paddedAffiliations->Visible = true;
  frameAffiliations->Add(true);
  Handled = true;
 }

 if(HIBYTE(GetAsyncKeyState(VK_CONTROL)) && !HIBYTE(GetAsyncKeyState(VK_MENU)) && Msg.CharCode == '3' && buttonAddresses->Visible && buttonAddresses->Enabled)
 {
  paddedAddresses->Visible = true;
  frameAddresses->Add(true);
  Handled = true;
 }

 if(HIBYTE(GetAsyncKeyState(VK_CONTROL)) && !HIBYTE(GetAsyncKeyState(VK_MENU)) && Msg.CharCode == '4' && buttonCharts->Visible && buttonCharts->Enabled)
 {
  paddedCharts->Visible = true;
  frameCharts->Add(true);
  Handled = true;
 }

 if(HIBYTE(GetAsyncKeyState(VK_CONTROL)) && !HIBYTE(GetAsyncKeyState(VK_MENU)) && (Msg.CharCode == 'i' || Msg.CharCode == 'I') && panelBusiness->Visible && buttonBusiness->Visible && buttonBusiness->Enabled)
 {
  if (buttonBusiness->OnClick)
   buttonBusiness->OnClick(buttonBusiness);
  Handled = true;
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Person::SetCurrentId (string Value)
{
 // prevent them from setting it!
 TframeTinyRecordMagic::SetCurrentId("4");
}
//---------------------------------------------------------------------------

