//---------------------------------------------------------------------------

#ifndef codeFrameTinyRecord_PersonH
#define codeFrameTinyRecord_PersonH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeFrameTinyRecordContainer.h"
#include "codeFrameTinyRecordMagic.h"
#include "codeInlineContainer.h"
#include "codePaddedBox.h"
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include "codeHalfButton.h"
#include <Graphics.hpp>
void ArrangeByTabOrder(TWinControl * p, bool vertical);
//---------------------------------------------------------------------------
class TframeTinyRecord_Person : public TframeTinyRecordMagic
{
__published:	// IDE-managed Components
        TPopupMenu *popupActions;
        TMenuItem *menuAdd;
        TMenuItem *menuHide;
        TMenuItem *menuShow;
        TPanel *panelPersonTop;
        TPanel *panelPersonBottom;
        TPaddedBox *paddedNames;
        TframeTinyRecordContainer *frameNames;
        TPaddedBox *paddedDemographics;
        TInlineContainer *inlineDemographics;
        TPanel *panelGender;
        TLabel *_labelGender;
        TComboBox *comboGender;
        TPanel *panelDOB;
        TLabel *_labelDOB;
        TEdit *editDOB;
        TPanel *panelSSN;
        TLabel *_labelSSN;
        TEdit *editSSN;
        TPaddedBox *paddedAffiliations;
        TPaddedBox *paddedAddresses;
        TPaddedBox *paddedCharts;
        TframeTinyRecordContainer *frameAffiliations;
        TframeTinyRecordContainer *frameAddresses;
        TframeTinyRecordContainer *frameCharts;
        TToolBar *barAffiliations;
        TToolBar *barAddresses;
        TToolBar *barCharts;
        TToolBar *barLeftovers;
        TToolButton *buttonNames;
        TToolButton *buttonAffiliations;
        TToolButton *buttonAddresses;
        TToolButton *buttonCharts;
        TToolBar *barNames;
        TPanel *panelBusiness;
        TSpeedButton *buttonBusiness;
        TImageList *imagesPerson;
        TPanel *panelBottomSpacer;
        void __fastcall buttonNamesClick(TObject *Sender);
        void __fastcall buttonAddressesClick(TObject *Sender);
        void __fastcall buttonAffiliationsClick(TObject *Sender);
        void __fastcall buttonChartsClick(TObject *Sender);
        void __fastcall FrameResize(TObject *Sender);
        void __fastcall panelPersonBottomResize(TObject *Sender);
        void __fastcall frameNamesChange(TObject *Sender);
        void __fastcall frameAffiliationsChange(TObject *Sender);
        void __fastcall frameAddressesChange(TObject *Sender);
        void __fastcall frameChartsChange(TObject *Sender);
        void __fastcall buttonBusinessClick(TObject *Sender);
        void __fastcall buttonSearchClick(TObject *Sender);
        void __fastcall frameNamesAdd(TObject *Sender);
        void __fastcall frameAffiliationsAdd(TObject *Sender);
        void __fastcall frameChartsAdd(TObject *Sender);
        void __fastcall staticMatchesClick(TObject *Sender);
        void __fastcall panelButtonsResize(TObject *Sender);
private:	// User declarations
        map<string, string> matched_ids_to_values;
        int last_max_score;
        bool should_send_change;
        void ArrangeButtons ();
        bool FBusiness;
        TNotifyEvent FOnNameChange;
protected:
        void __fastcall SetBusiness (bool Value);
        void __fastcall virtual SetParent (TWinControl * AParent);
        void __fastcall virtual SetExpanded (bool Value);
        void virtual __fastcall SetId (string Value);
        string virtual __fastcall GetSourceTableName ();
        string virtual __fastcall GetDesc ();
        string virtual __fastcall GetPersonName ();
        void virtual __fastcall SetConcentrator (tr_magic_concentrator * Value);
        void __fastcall MatchesRefresh(TObject *Sender);
        void __fastcall NameChanged(TObject *Sender);
        bool virtual MagicSave (TIBTransaction * dbTransaction);
        bool virtual MagicValid ();
        void virtual __fastcall SetCurrentId (string Value);
public:		// User declarations
        void __fastcall virtual ShortCut(TWMKey &Msg, bool &Handled);

        static TframeTinyRecordGeneric* Create(TComponent* Owner);
        __fastcall TframeTinyRecord_Person(TComponent* Owner);
        __fastcall ~TframeTinyRecord_Person();
        __property bool Business = {read = FBusiness, write = SetBusiness};
        __property string PersonName = {read = GetPersonName};
        __property TNotifyEvent OnNameChange = {read = FOnNameChange, write = FOnNameChange};
};
//---------------------------------------------------------------------------
extern PACKAGE TframeTinyRecord_Person *frameTinyRecord_Person;
//---------------------------------------------------------------------------
#endif
