//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeFrameTinyRecord_PersonAddress.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeFrameTinyRecord_Address"
#pragma link "codeHalfButton"
#pragma link "codeInlineContainer"
#pragma resource "*.dfm"
TframeTinyRecord_PersonAddress *frameTinyRecord_PersonAddress;
//---------------------------------------------------------------------------
__fastcall TframeTinyRecord_PersonAddress::TframeTinyRecord_PersonAddress(TComponent* Owner)
        : TframeTinyRecord_Address(Owner)
{
 lookupTables->RegisterComboBox("contact_info_types", comboType);
}
//---------------------------------------------------------------------------
__fastcall TframeTinyRecord_PersonAddress::~TframeTinyRecord_PersonAddress()
{
 lookupTables->UnregisterComboBox("contact_info_types", comboType);
}
//---------------------------------------------------------------------------
TframeTinyRecordGeneric* TframeTinyRecord_PersonAddress::Create(TComponent* Owner)
{
 TframeTinyRecordGeneric * z = NULL;
 FORM_TRY
  z = new TframeTinyRecord_PersonAddress(Owner);
 FORM_CATCH
 return z;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_PersonAddress::SetId (string Value)
{
 // always needed?
 // some clearing ...
 editLine1->Text = "";
 editLine2->Text = "";
 comboCity->Text = "";
 editZip->Text = "";
 comboState->Text = "";
 string state_id, county_sql;
 if (!CountyLookupByState(comboState->Text.c_str(), state_id, county_sql, comboCounty)) /* whoops? */ ;
  comboCounty->Text = PrettyString(lookupTables->ValueOf("county_types", "", comboCounty)).c_str();
 comboCountry->Text = "";
 // comboResidence->Text = PrettyString(lookupTables->ValueOf("residence_types", initial_state["residence_id"])).c_str();
 editPhone->Text = "";
 comboType->Text = "";

 bool can_change = ((!IsBlankOrZero(Value) && optionsPermissions["table." + SourceTableName]["update"] == "true") ||
                    ( IsBlankOrZero(Value) && optionsPermissions["table." + SourceTableName]["insert"] == "true"));
 inlineAddress->Visible = (optionsPermissions["table." + SourceTableName]["view"] == "true");
 inlineAddress->Enabled = can_change;

 if (IsBlankOrZero(Value))
 {
  FCurrentId = "4";
  comboCountry->Text = "United States";
  TframeTinyRecord_Address::SetId(Value);
 } else
 {
  map<string, string> t;
  if (SqlToMap(dbDatabase, "select line1, line2, city, zip, state_id, county_id, country_id, phone_number, contact_info_id, current_id from person_contact_info where id = " + Value, t))
  {
   FCurrentId = t["current_id"];

   // comboLocation->Text = PrettyString(lookupTables->ValueOf("contact_info_types", t["contact_info_id"])).c_str();
   editLine1->Text = FormatAddress(t["line1"]).c_str();
   editLine2->Text = FormatAddress(t["line2"]).c_str();
   comboCity->Text = PrettyString(t["city"]).c_str();
   editZip->Text = FormatZipCode(t["zip"]).c_str();
   comboState->Text = PrettyString(lookupTables->ValueOf("state_types", t["state_id"])).c_str();
   string state_id, county_sql;
   if (!CountyLookupByState(comboState->Text.c_str(), state_id, county_sql, comboCounty)) /* whoops? */ ;
    comboCounty->Text = PrettyString(lookupTables->ValueOf("county_types", t["county_id"], comboCounty)).c_str();
   comboCountry->Text = PrettyString(lookupTables->ValueOf("country_types", t["country_id"])).c_str();
   // comboResidence->Text = PrettyString(lookupTables->ValueOf("residence_types", t["residence_id"])).c_str();
   editPhone->Text = FormatPhoneNumber(t["phone_number"]).c_str();
   comboType->Text = lookupTables->ValueOf("contact_info_types", t["contact_info_id"]).c_str();

   TframeTinyRecord_Address::SetId(Value);
  } else
   PSay("Failed to load a plausible record number", m_database_error, MB_OK, Value);
 }
}
//---------------------------------------------------------------------------
string __fastcall TframeTinyRecord_PersonAddress::GetSourceTableName ()
{
 return "person_contact_info";
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_PersonAddress::Valid ()
{
 if (!TframeTinyRecord_Address::Valid())
  return false;
 if (StringToInt(CurrentId) > 3 &&
 (comboType->Text == "" || !lookupTables->IsInLookUpTable("contact_info_types", comboType->Text.c_str())))
 {
  int answer = PSay("At least one contact record on this screen is lacking a contact type.\n\n"
                    "If you know whether the contact info in question is mailing, home, work, cell, etc., you should supply this missing data.\n\n"
                    "There are times when you may not know what this contact info indicates, and it is valid to continue without it--for instance, if it is the contact info of a relative of the person you are updating.\n\n"
                    "Do you want to continue without a contact info type?  If you say yes, the record in question will be marked as Incomplete due to missing data.\n\n"
                    "Continue with missing data and mark contact info record as Incomplete?", m_confirmation, MB_YESNO);
  if (answer == IDYES)
    CurrentId = lookupTables->IdOf("current_types", "Incomplete");
  else
  {
  	if (IsVisible(comboType)) comboType->SetFocus();
    return false;
  }
 } else { /* no else if; if they say YES, it should continue checking validity of data */ }
 
 return true;
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_PersonAddress::Save (TIBTransaction * dbTransaction)
{
 AtlasBeforeSave(dbTransaction);

 map<string, string> row;
 if (!HasId)
 {
  if (!CreateInsertMap (dbTransaction, SourceTableName, row))
   return false;
  row["id"] = GetNextId(dbTransaction, SourceTableName);
 } else
  row["id"] = Id;

 row["contact_info_id"] = lookupTables->IdOf("contact_info_types", comboType->Text.c_str());
 row["line1"]           = FormatAddress(editLine1->Text.c_str());
 row["line2"]           = FormatAddress(editLine2->Text.c_str());
 row["city"]            = comboCity->Text.c_str();
 row["state_id"]        = lookupTables->IdOf("state_types", comboState->Text.c_str());
 row["zip"]             = StripAllExcept(editZip->Text.c_str(), ints);
 row["county_id"]       = lookupTables->IdOf("county_types", comboCounty); // need to pass the cbo box so it can look up the ID since it's got custom sql / item list
 row["country_id"]      = lookupTables->IdOf("country_types", comboCountry->Text.c_str());
 row["phone_number"]    = StripAllExcept(editPhone->Text.c_str(), uints);
// row["fax_number"]     = StripAllExcept(editFax->Text.c_str(), uints);
// row["website"]        = editWebsite->Text.c_str();
// row["email_address"]  = editEmail->Text.c_str();
// row["notes"]          = editNotes->Text.c_str();
 row["person_id"]  = PersonId;

 row["current_id"]        = CurrentId;
 row["last_update_stamp"] = RightNow();
 row["last_updated_by"]   = current_userid;

 bool success = true;
 if (!HasId && (optionsPermissions["table." + SourceTableName]["insert"] == "true"))
  success = ExecuteInsertStatement(dbTransaction, SourceTableName, row);
 else if (HasId && (optionsPermissions["table." + SourceTableName]["update"] == "true"))
  if (WorthSaving(dbTransaction, row))
   success = ExecuteUpdateStatement(dbTransaction, SourceTableName, row);

 if (success)
  FId = row["id"];

 AtlasAfterSave(dbTransaction);

 return success;
}
//---------------------------------------------------------------------------

