//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeFrameTinyRecord_PersonName.h"
#include "sqllib.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeFrameTinyRecordGeneric"
#pragma link "codeInlineContainer"
#pragma resource "*.dfm"
TframeTinyRecord_PersonName *frameTinyRecord_PersonName;
//---------------------------------------------------------------------------
__fastcall TframeTinyRecord_PersonName::TframeTinyRecord_PersonName(TComponent* Owner)
        : TframeTinyRecordGeneric(Owner)
{
 // panelBusiness->Left = 100; // move it to the right.
 CanExpand = true;
 Expanded = false;
 Business = false;
 should_send_change = false;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_PersonName::SetExpanded (bool Value)
{
 TframeTinyRecordGeneric::SetExpanded(Value);

 panelPrefix->Visible = !FBusiness && FExpanded;
 panelFirst->Visible  = !FBusiness;
 panelMiddle->Visible = !FBusiness;

 // when switching ... prefer to use the same field. same underlying field anyway. might as well ... do this. (lazy.)
 if (FBusiness)
 {
  _labelLast->Caption = "Company name";
  editLast->Width     = 273;
  panelLast->Width    = 353;
  editLast->Left      = 80;
 } else
 {
  _labelLast->Caption = "Last";
  editLast->Width     = 81;
  panelLast->Width    = 113;
  editLast->Left      = 32;
 }

 panelSuffix->Visible = !FBusiness && FExpanded;

 inlineName->Arrange();
}
//---------------------------------------------------------------------------
TframeTinyRecordGeneric* TframeTinyRecord_PersonName::Create(TComponent* Owner)
{
 TframeTinyRecordGeneric * z = NULL;
 FORM_TRY
  z = new TframeTinyRecord_PersonName(Owner);
 FORM_CATCH
 return z;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_PersonName::SetId (string Value)
{
 // always needed?
 // some clearing ...
 editPrefix->Text = "";
 editFirst->Text  = "";
 editMiddle->Text = "";
 editLast->Text   = "";
 editSuffix->Text = "";

 bool can_change = ((!IsBlankOrZero(Value) && optionsPermissions["table." + SourceTableName]["update"] == "true") ||
                    ( IsBlankOrZero(Value) && optionsPermissions["table." + SourceTableName]["insert"] == "true"));
 inlineName->Visible = (optionsPermissions["table." + SourceTableName]["view"] == "true");
 inlineName->Enabled = can_change;

 if (IsBlankOrZero(Value))
 {
  FCurrentId = "4";
  Business = false;
  TframeTinyRecordGeneric::SetId(Value);
 } else
 {
  map<string, string> t;
  if (SqlToMap(dbDatabase, "select prefix, first_name, middle_name, last_name, suffix, current_id from person_names where id = " + Value, t))
  {
   FCurrentId = t["current_id"];
   editPrefix->Text = StripTrailing(PrettyString(t["prefix"]), " ").c_str();
   editFirst->Text  = StripTrailing(PrettyString(t["first_name"]), " ").c_str();
   editMiddle->Text = StripTrailing(PrettyString(t["middle_name"]), " ").c_str();
   editLast->Text   = StripTrailing(PrettyString(t["last_name"]), " ").c_str();
   editSuffix->Text = StripTrailing(PrettyString(t["suffix"]), " ").c_str();

   if (editLast->Text != "" && editPrefix->Text == "" && editFirst->Text == "" && editMiddle->Text == "" && editSuffix->Text == "")
    Business = true;
   else
    Business = false;

   TframeTinyRecordGeneric::SetId(Value);
  } else
   PSay("Failed to load a plausible record number", m_database_error, MB_OK, Value);
 }
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_PersonName::Valid ()
{
 if (StripLeading(StripTrailing(editLast->Text.c_str(), " "), " ") == "")
 {
  PSay("Please provide at least a last name in each name record; business names should be put in the 'Last' field.\nTo prevent confusion in the case of business names, switch to business mode by clicking on the person/business icon above.", m_missing_data, MB_OK);
  if (IsVisible(editLast)) editLast->SetFocus();
  return false;
 }
 return TframeTinyRecordGeneric::Valid();
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_PersonName::Save (TIBTransaction * dbTransaction)
{
 AtlasBeforeSave(dbTransaction);

 map<string, string> row;
 if (!HasId)
 {
  if (!CreateInsertMap (dbTransaction, SourceTableName, row))
   return false;
  row["id"] = GetNextId(dbTransaction, SourceTableName);
 } else
  row["id"] = Id;

 row["prefix"]      = (editPrefix->Text == "" ? " " : editPrefix->Text.c_str());
 row["first_name"]  = (editFirst->Text  == "" ? " " : editFirst->Text.c_str());
 row["middle_name"] = (editMiddle->Text == "" ? " " : editMiddle->Text.c_str());
 row["last_name"]   = (editLast->Text   == "" ? " " : editLast->Text.c_str());
 row["suffix"]      = (editSuffix->Text == "" ? " " : editSuffix->Text.c_str());
 row["person_id"]   = PersonId;

 row["current_id"]        = CurrentId;
 row["last_update_stamp"] = RightNow();
 row["last_updated_by"]   = current_userid;

 bool success = true;
 if (!HasId && (optionsPermissions["table." + SourceTableName]["insert"] == "true"))
  success = ExecuteInsertStatement(dbTransaction, SourceTableName, row);
 else if (HasId && (optionsPermissions["table." + SourceTableName]["update"] == "true"))
  if (WorthSaving(dbTransaction, row))
   success = ExecuteUpdateStatement(dbTransaction, SourceTableName, row);

 if (success)
  FId = row["id"];

 AtlasAfterSave(dbTransaction);

 return success;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_PersonName::inlineNameResize(
      TObject *Sender)
{
 Height = inlineName->Height;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_PersonName::SetBusiness (bool Value)
{
 FBusiness = Value;
/*
 buttonBusiness->Glyph = NULL;
 imagesToolbar->GetBitmap(FBusiness ? 11 : 10, buttonBusiness->Glyph);
 buttonBusiness->Repaint();
*/
 CanExpand = !FBusiness;
 Expanded = Expanded; // refresh via the other function.
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_PersonName::buttonBusinessClick(
      TObject *Sender)
{
 Business = !Business;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_PersonName::panelButtonsResize(
      TObject *Sender)
{
 inlineName->Left = ((panelButtons->Width + 8) / 8) * 8; // next multiple of 8, but not touching? (i hope)
 inlineName->Width = Width - inlineName->Left;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_PersonName::editAnyExit(
      TObject *Sender)
{
 if (should_send_change)
  if (OnFieldChange)
   OnFieldChange(this);
 should_send_change = false;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_PersonName::editAnyChange(TObject *Sender)
{
 should_send_change = true;
}
//---------------------------------------------------------------------------
string __fastcall TframeTinyRecord_PersonName::GetSourceTableName ()
{
 return "person_names";
}
//---------------------------------------------------------------------------

