//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeFrameTinyRecord_Relationship.h"
#include "tinyrecord_concentrator.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeFrameTinyRecord_Person"
#pragma link "codeFrameTinyRecordGeneric"
#pragma link "codeFrameTinyRecordMagic"
#pragma link "codeFrameCheckListDropDown"
#pragma resource "*.dfm"
TframeTinyRecord_Relationship *frameTinyRecord_Relationship;
//---------------------------------------------------------------------------
__fastcall TframeTinyRecord_Relationship::TframeTinyRecord_Relationship(TComponent* Owner)
        : TframeTinyRecordGeneric(Owner)
{
 CanExpand = true;
 Expanded = true;

 string rel_sql = "select id, item, valid from relationship_types where is_self != 1 and valid = 1 order by item";
 lookupTables->RegisterComboBox("relationship_types", comboRelA, rel_sql);
 lookupTables->RegisterComboBox("relationship_types", comboRelB, rel_sql);

 framePerson->Id = "0";
 framePerson->Magic = trm_existing;
 framePerson->AllowNone = false;
 framePerson->Label = "Person (relationship)";
 framePerson->OnFieldChange = framePersonChanged;

 // well, see, ... *sigh* ... i didn't make it support static ... stuff.
 string sql = "select cast('Emerg.' as varchar(250)), cast('Emergency contact' as varchar(250)), 1 from uno"
              " union "
              "select cast('Resp.' as varchar(250)), cast('Responsible party' as varchar(250)), 2 from uno"
              " union "
              "select cast('Banned' as varchar(250)), cast('Banned from info' as varchar(250)), 3 from uno";

 checkExtraA->Filter->SetSecurity(""); // not really, but ... meh.
 checkExtraA->Filter->AddColumnSpec("Type", "", as_text, false, 120);
 checkExtraA->Filter->AddColumnSpec("Desc", "", as_text, true, 120, rawString);
 checkExtraA->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 checkExtraA->Filter->SetSQLStatement(sql);
 checkExtraA->Filter->ForceRefreshDataSet();
 checkExtraA->DisplayFieldName = "Type";
 checkExtraA->DropDownHeight = 72;

 checkExtraB->Filter->SetSecurity(""); // not really, but ... meh.
 checkExtraB->Filter->AddColumnSpec("Type", "", as_text, false, 120);
 checkExtraB->Filter->AddColumnSpec("Desc", "", as_text, true, 120, rawString);
 checkExtraB->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 checkExtraB->Filter->SetSQLStatement(sql);
 checkExtraB->Filter->ForceRefreshDataSet();
 checkExtraB->DisplayFieldName = "Type";
 checkExtraB->DropDownHeight = 72;
}
//---------------------------------------------------------------------------
__fastcall TframeTinyRecord_Relationship::~TframeTinyRecord_Relationship()
{
 lookupTables->UnregisterComboBox(comboRelA);
 lookupTables->UnregisterComboBox(comboRelB);
}
//---------------------------------------------------------------------------
TframeTinyRecordGeneric* TframeTinyRecord_Relationship::Create(TComponent* Owner)
{
 TframeTinyRecordGeneric * z = NULL;
 FORM_TRY
  z = new TframeTinyRecord_Relationship(Owner);
 FORM_CATCH
 return z;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Relationship::panelBottomResize(
      TObject *Sender)
{
 Height = (panelTop->Visible ? panelTop->Height : 0)
        + (panelBottom->Visible ? panelBottom->Height : 0)
        + (panelDesc->Visible ? panelDesc->Height : 0);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Relationship::FrameResize(TObject *Sender)
{
 framePerson->Width = panelBottom->Width - 48;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Relationship::SetExpanded (bool Value)
{
 TframeTinyRecordGeneric::SetExpanded(Value);
 panelTop->Visible = Expanded;
 panelBottom->Visible = Expanded;
 panelBottomResize(panelBottom);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Relationship::panelButtonsResize(
      TObject *Sender)
{
 int i = ((panelButtons->Width + 8) / 8) * 8; // next multiple of 8, but not touching? (i hope)
 // framePerson->Left = i;
 // panelRel->Left    = i;
 labelDesc->Left   = i;
}
//---------------------------------------------------------------------------
string __fastcall TframeTinyRecord_Relationship::GetSourceTableName ()
{
 return "relationships";
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Relationship::SetId (string Value)
{
 comboRelA->Text = "";
 comboRelB->Text = "";
 checkExtraA->Filter->UncheckAll();
 checkExtraB->Filter->UncheckAll();
 checkHousehold->Checked = false;

 bool can_change = ((!IsBlankOrZero(Value) && optionsPermissions["table." + SourceTableName]["update"] == "true") ||
                    ( IsBlankOrZero(Value) && optionsPermissions["table." + SourceTableName]["insert"] == "true"));
 framePerson->AllowSourceChange = can_change;
 panelRel->Visible = (optionsPermissions["table." + SourceTableName]["view"] == "true");
 panelRel->Enabled = can_change;

 if (IsBlankOrZero(Value))
 {
  FCurrentId = "4";
  TframeTinyRecordGeneric::SetId(Value);
  framePerson->Id = "0";
  framePerson->Magic = trm_new;
 } else
 {
  map<string, string> t;

  if (SqlToMap(dbDatabase, "select person_a_id, person_b_id, rel_a_to_b_id, rel_b_to_a_id, a_is_responsible, b_is_responsible, a_is_emergency, b_is_emergency, a_is_banned, b_is_banned, same_household, current_id from relationships where id = " + Value, t))
  {
   FCurrentId = t["current_id"];

   string a = t["person_a_id"];
   if (ParentPerson && ParentPerson->Actual && a == ParentPerson->Actual->Id)
   {
    comboRelA->Text = lookupTables->ValueOf("relationship_types", t["rel_a_to_b_id"]).c_str();
    comboRelB->Text = lookupTables->ValueOf("relationship_types", t["rel_b_to_a_id"]).c_str();
    set<string> to_check_a;
    if (t["a_is_responsible"] == "1") to_check_a.insert("2");
    if (t["a_is_emergency"] == "1") to_check_a.insert("1");
    if (t["a_is_banned"] == "1") to_check_a.insert("3");
    checkExtraA->Filter->SetCheckedWhereID(to_check_a, true);
    set<string> to_check_b;
    if (t["b_is_responsible"] == "1") to_check_b.insert("2");
    if (t["b_is_emergency"] == "1") to_check_b.insert("1");
    if (t["b_is_banned"] == "1") to_check_b.insert("3");
    checkExtraB->Filter->SetCheckedWhereID(to_check_b, true);
    checkHousehold->Checked = (t["same_household"] == "1");

    framePerson->Magic = trm_existing;
    framePerson->Id = t["person_b_id"];
    framePerson->Expanded = false;
   } else
   {
    comboRelA->Text = lookupTables->ValueOf("relationship_types", t["rel_b_to_a_id"]).c_str();
    comboRelB->Text = lookupTables->ValueOf("relationship_types", t["rel_a_to_b_id"]).c_str();
    set<string> to_check_a;
    if (t["b_is_responsible"] == "1") to_check_a.insert("2");
    if (t["b_is_emergency"] == "1") to_check_a.insert("1");
    if (t["b_is_banned"] == "1") to_check_a.insert("3");
    checkExtraA->Filter->SetCheckedWhereID(to_check_a, true);
    set<string> to_check_b;
    if (t["a_is_responsible"] == "1") to_check_b.insert("2");
    if (t["a_is_emergency"] == "1") to_check_b.insert("1");
    if (t["a_is_banned"] == "1") to_check_b.insert("3");
    checkExtraB->Filter->SetCheckedWhereID(to_check_b, true);
    checkHousehold->Checked = (t["same_household"] == "1");

    framePerson->Magic = trm_existing;
    framePerson->Id = t["person_a_id"];
    framePerson->Expanded = false;
   }

   TframeTinyRecordGeneric::SetId(Value);
   // Expanded = true;
  } else
   PSay("Failed to load a plausible record number", m_database_error, MB_OK, Value);
 }
 checkExtraA->RefreshText();
 checkExtraB->RefreshText();
 framePersonChanged(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Relationship::SetConcentrator (tr_magic_concentrator * Value)
{
 TframeTinyRecordGeneric::SetConcentrator(Value); // just stores it.

 // and now, inform people. yup.
 framePerson->Concentrator = Value;
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_Relationship::Valid ()
{
 // TODO: warning, 'blank' entries are marked as valid in the database! they can enter relationships with no a-to-b and b-to-a relationship types!
 if (!lookupTables->IsInLookUpTable("relationship_types", comboRelA))
 {
  PSay("Please enter a valid relationship type for '" + string(labelPersonA->Caption.c_str()) + "'.", m_invalid_data, MB_OK);
  if (IsVisible(comboRelA)) comboRelA->SetFocus();
  return false;
 }
 else if (!lookupTables->IsInLookUpTable("relationship_types", comboRelB))
 {
  PSay("Please enter a valid relationship type for '" + string(labelPersonB->Caption.c_str()) + "'.", m_invalid_data, MB_OK);
  if (IsVisible(comboRelB)) comboRelB->SetFocus();
  return false;
 }
 else if (!framePerson->WillHaveId)
 {
  string a = "[noname]";
/*
  TframeTinyRecord_Person * frameParentPerson = NULL;
  if (Concentrator)
   frameParentPerson = dynamic_cast<TframeTinyRecord_Person *>(Concentrator->Find("people", ParentPersonId));
*/
  if (ParentPerson && ParentPerson->Actual)
   a = dynamic_cast<TframeTinyRecord_Person *>(ParentPerson->Actual)->PersonName;

  PSay("Please select the person to whom " + a + " is related.", m_missing_data, MB_OK);
  return false;
 }
 else if ((ParentPerson && ParentPerson->Actual && framePerson->Id == ParentPerson->Actual->Id && !IsBlankOrZero(ParentPerson->Actual->Id)) || (framePerson->SameAs == ParentPerson->Actual))
 {
  // TODO -c OVERKILL: some self-relationships (I am my own employer) may make sense, might want to downgrade this to a warning.
  PSay("Please don't relate people to themselves.", m_invalid_data, MB_OK);
  return false;
 }
 else
  return (framePerson->Valid() && TframeTinyRecordGeneric::Valid());
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_Relationship::Save (TIBTransaction * dbTransaction)
{
 AtlasBeforeSave(dbTransaction);

 map<string, string> row;
 if (!HasId)
 {
  CreateInsertMap (dbTransaction, SourceTableName, row);
  row["id"] = GetNextId(dbTransaction, SourceTableName);
 } else
  row["id"] = Id;

 bool success = true;

 success = framePerson->Save(dbTransaction);
 framePerson->AtlasGet(pending_atlas_notifications);

 // fields -- we assume a particular order to the FK's, and hope for the best?
 vector<string> vec_about_a = checkExtraA->Filter->GetMultiID();
 set<string> set_about_a = VecToSet(vec_about_a);
 row["person_a_id"]      = ((ParentPerson && ParentPerson->Actual) ? dynamic_cast<TframeTinyRecord_Person *>(ParentPerson->Actual)->Id.c_str() : "0");
 row["rel_a_to_b_id"]    = lookupTables->IdOf("relationship_types", comboRelA);
 row["a_is_responsible"] = (set_about_a.find("2") != set_about_a.end()) ? "1" : "0";
 row["a_is_emergency"]   = (set_about_a.find("1") != set_about_a.end()) ? "1" : "0";
 row["a_is_banned"]      = (set_about_a.find("3") != set_about_a.end()) ? "1" : "0";

 vector<string> vec_about_b = checkExtraB->Filter->GetMultiID();
 set<string> set_about_b = VecToSet(vec_about_b);
 row["person_b_id"]      = framePerson->Id;
 row["rel_b_to_a_id"]    = lookupTables->IdOf("relationship_types", comboRelB);
 row["b_is_responsible"] = (set_about_b.find("2") != set_about_b.end()) ? "1" : "0";
 row["b_is_emergency"]   = (set_about_b.find("1") != set_about_b.end()) ? "1" : "0";
 row["b_is_banned"]      = (set_about_b.find("3") != set_about_b.end()) ? "1" : "0";

 row["same_household"] = checkHousehold->Checked ? "1" : "0";

 row["current_id"]        = CurrentId;
 row["last_update_stamp"] = RightNow();
 row["last_updated_by"]   = current_userid;

 if (success)
  if (!HasId && (optionsPermissions["table." + SourceTableName]["insert"] == "true"))
   success = ExecuteInsertStatement(dbTransaction, SourceTableName, row);
  else if (HasId && (optionsPermissions["table." + SourceTableName]["update"] == "true"))
   if (WorthSaving(dbTransaction, row))
    success = ExecuteUpdateStatement(dbTransaction, SourceTableName, row);

 if (success)
  FId = row["id"];

 AtlasAfterSave(dbTransaction);
 return success;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Relationship::framePersonChanged(TObject *Sender)
{
 string z;
 if (lookupTables->IsInLookUpTable("relationship_types", comboRelB))
  z = (" (" + comboRelB->Text + ")").c_str();
 labelDesc->Caption = ("Relationship with " + framePerson->PersonName + z).c_str();

 string a;

/*
 TframeTinyRecord_Person * frameParentPerson = NULL;
 if (Concentrator)
  frameParentPerson = dynamic_cast<TframeTinyRecord_Person *>(Concentrator->Find("people", ParentPersonId));
*/
 if (ParentPerson && ParentPerson->Actual)
  a = dynamic_cast<TframeTinyRecord_Person *>(ParentPerson->Actual)->PersonName;
 if (a.empty())
  a = "[noname]";

 string b = framePerson->PersonName;
 if (b.empty())
  b = "[noname]";
 labelPersonA->Caption = (a + " is the").c_str();
 labelPersonB->Caption = (b + " is the").c_str();
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Relationship::SetParentPerson (TframeTinyRecord_Person* Value)
{
 FParentPerson = Value;
 framePersonChanged(NULL);
}
//---------------------------------------------------------------------------
string GetOppositeRelationship (TIBDatabase * dbDatabase, string source_relationship_id, string destination_gender_id)
{
 string sql = "select to_relationship_id from opposite_relationships where gender_id = '" + destination_gender_id + "' and from_relationship_id = '" + source_relationship_id + "'";
 string answer;
 answer = GetOneField(dbDatabase, sql);
 if (destination_gender_id != "0" && answer.empty())
  return GetOppositeRelationship (dbDatabase, source_relationship_id, "0"); // try it genderless just in case, but don't recurse forever.
 return answer;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Relationship::comboRelChange(
      TObject *Sender)
{
 // to refresh the little parenthetical description -- technically, we only need to update if 'b' changes?
 framePersonChanged(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_Relationship::comboRelExit(
      TObject *Sender)
{
 // do we want to set 'responsible party' in the case of Legal Guardian, Mother, and Father if the child is under 18?
 // one problem is that, well, this gets called in more cases than just when the user manually changes it ...
 // auto-guess other relationship
 if (Sender == comboRelA && lookupTables->IsInLookUpTable("relationship_types", comboRelA) && comboRelB->Text == "")
 {
  string b_gender_id = "0";
  TframeTinyRecord_Person * b = dynamic_cast<TframeTinyRecord_Person *>(framePerson->Actual);
  if (b)
   b_gender_id = lookupTables->IdOf("gender_types", b->comboGender);
  comboRelB->Text = lookupTables->ValueOf("relationship_types", GetOppositeRelationship(dbDatabase, lookupTables->IdOf("relationship_types", comboRelA), b_gender_id)).c_str();
 } else
 if (Sender == comboRelB && lookupTables->IsInLookUpTable("relationship_types", comboRelB) && comboRelA->Text == "")
 {
  string a_gender_id = "0";

/*
  TframeTinyRecord_Person * a = NULL;
  if (Concentrator)
   a = dynamic_cast<TframeTinyRecord_Person *>(Concentrator->Find("people", ParentPersonId));
*/
  if (ParentPerson && ParentPerson->Actual) // we trust that it's an 'existing', not a 'same as', so we don't bother with ->Actual ?
   a_gender_id = lookupTables->IdOf("gender_types", dynamic_cast<TframeTinyRecord_Person *>(ParentPerson->Actual)->comboGender->Text.c_str());
  comboRelA->Text = lookupTables->ValueOf("relationship_types", GetOppositeRelationship(dbDatabase, lookupTables->IdOf("relationship_types", comboRelB), a_gender_id)).c_str();
 }
}
//---------------------------------------------------------------------------

