//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeFrameTinyRecord_TaxEntity.h"
#include "codeFrameTinyRecord_TaxEntityAddress.h"
#include "codeSearchTaxEntity.h"
#include "codeSpecialSelectListview.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeFrameTinyRecordMagic"
#pragma link "codePaddedBox"
#pragma link "codeFrameTinyRecordContainer"
#pragma link "codeHalfButton"
#pragma resource "*.dfm"
TframeTinyRecord_TaxEntity *frameTinyRecord_TaxEntity;
//---------------------------------------------------------------------------
__fastcall TframeTinyRecord_TaxEntity::TframeTinyRecord_TaxEntity(TComponent* Owner)
        : TframeTinyRecordMagic(Owner), done_search(false)
{
 lookupTables->RegisterComboBox("tax_entity_types", comboType);

 panelTaxEntity->Visible  = (optionsPermissions["table.tax_entities"]["view"] == "true");
 panelTaxEntity->Enabled  = (optionsPermissions["table.tax_entities"]["update"] == "true");
 buttonAddresses->Enabled = (optionsPermissions["table.tax_addresses"]["insert"] == "true");
 
 fields_to_leave_raw.insert("name");
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_TaxEntity::SetParent (TWinControl * AParent)
{
 TframeTinyRecordMagic::SetParent(AParent);
 if (Parent)
 {
  frameAddresses->OnAdd = frameAddressesAdd;
  frameAddresses->OnChange = frameAddressesChange;
  frameAddresses->CreateMethod = TframeTinyRecord_TaxEntityAddress::Create;
 }
}
//---------------------------------------------------------------------------
__fastcall TframeTinyRecord_TaxEntity::~TframeTinyRecord_TaxEntity()
{
 frameAddresses->OnChange = NULL;
 lookupTables->UnregisterComboBox(comboType);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_TaxEntity::buttonAddressesClick(TObject *Sender)
{
 paddedAddresses->Visible = true;
 frameAddresses->Add();
 paddedAddresses->Height = paddedAddresses->Height + 1;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_TaxEntity::FrameResize(TObject *Sender)
{
 if (Color != clBtnFace)
  paddedAddresses->InnerColor = clBtnFace;
 else
  paddedAddresses->InnerColor = 0x00D3D9DD;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_TaxEntity::panelTaxEntityBottomResize(TObject *Sender)
{
 Height = panelTaxEntityTop->Height
        + (panelTaxEntityBottom->Visible ? panelTaxEntityBottom->Height : 0);
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_TaxEntity::frameAddressesChange(TObject *Sender)
{
 paddedAddresses->Visible = !frameAddresses->Empty;
 paddedAddresses->Height  = paddedAddresses->Height + 1;
 buttonAddresses->Caption = ("Addresses (" + IntToString(frameAddresses->RecordCount) + ")").c_str();
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_TaxEntity::frameAddressesAdd(TObject *Sender)
{
 // probably not needed.
}
//---------------------------------------------------------------------------
TframeTinyRecordGeneric* TframeTinyRecord_TaxEntity::Create(TComponent* Owner)
{
 TframeTinyRecordGeneric * z = NULL;
 FORM_TRY
  z = new TframeTinyRecord_TaxEntity(Owner);
 FORM_CATCH
 return z;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_TaxEntity::SetExpanded (bool Value)
{
 TframeTinyRecordMagic::SetExpanded(Value);
 panelTaxEntityBottom->Visible = Expanded;
 paddedAddresses->Height = paddedAddresses->Height + 1;
 panelTaxEntityBottomResize(panelTaxEntityBottom);
}
//---------------------------------------------------------------------------
string __fastcall TframeTinyRecord_TaxEntity::GetSourceTableName ()
{
 return "tax_entities";
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_TaxEntity::buttonSearchClick(TObject *Sender)
{
 // create and show new person search form
 vector<string> return_vector = TformSearchTaxEntity::Do(dynamic_cast<TformSpecialGeneric*>(FindNearestParentOfType(this, __classid(TformSpecialGeneric))));
 done_search = true; // jhaley 20110829: User has searched
 if (! return_vector.empty())
 {
  Id = return_vector[0];
  if (AutoExpandOnSetId)
   Expanded = true;
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_TaxEntity::MatchesRefresh(TObject *Sender)
{
  TframeTinyRecordMagic::MatchesRefresh(Sender);

  if(Magic == trm_new)
  {
    int max_cond = 0;

    string sql;

    sql = "select id, 0 ";

    // 2 points for an exact match, 1 point if the record has a blank value (so we don't know it's -not- a match)
    if(lookupTables->IdOf("tax_entity_types", comboType) != "0")
    {
      sql += " + case when (tax_entity_id = " + lookupTables->IdOf("tax_entity_types", comboType)
             + ") then 2 when (tax_entity_id = 0) then 1 else 0 end ";
      max_cond += 2;
    }

    if(editName->Text != "")
    {
      // jhaley 20110829: Vast improvements:
      // 1. upper(name) and UppercaseString make even basic matching functional by removing case differences.
      // 2. PowerSearchString ensures minor spelling/spacing differences are largely irrelevant to matching ability.
      sql += " + case when (upper(name) like '" + SafeSQLString(PowerSearchString(UppercaseString(editName->Text.c_str())))
             + "') then 2 when (name is null) then 1 else 0 end ";
      max_cond += 2;
    }

    sql += " from tax_entities";

    // don't bother, as that results in a Really Big Number (tm) of results.
    if(!max_cond)
    {
      staticMatches->Caption = "Not yet searched for matches.";
      matched_ids_to_values.clear();
      return;
    }

    pmapstrs tz;
    if(!SqlToValueMap(dbDatabase, sql, tz))
      PSay("Failed to search for duplicates", m_database_error, MB_OK, sql);

    int min_cond = max(1, (int)(max_cond * 0.75)); // TODO: tune until something suitable is found?
    int good_matches = 0;

    pmapstrs id_to_value;
    for(pmapstrs::iterator i = tz.begin(); i != tz.end(); i++)
    {
      if (StringToInt(i->second) >= min_cond)
      {
        id_to_value.insert(*i);
        if (StringToInt(i->second) == max_cond)
          good_matches++;
      }
    }

    if(id_to_value.empty())
      staticMatches->Caption = "No matches found.";
    else if (id_to_value.size() == 1)
      staticMatches->Caption = "1 match found.";
    else
      staticMatches->Caption = (IntToString(id_to_value.size()) + " matches found.").c_str();

    if(good_matches)
    {
      staticMatches->Caption = (staticMatches->Caption.c_str() + string(" (") + IntToString(good_matches)
                                + " exact match" + string(good_matches == 1 ? "" : "es") + ")").c_str();
    }

    // save 'ids' for later
    matched_ids_to_values = id_to_value;
    last_max_score = max_cond;

    // do something with clicking on the number of matches (show list?)
    // allow users to say "yeah, that one"
  }
}
//---------------------------------------------------------------------------
string __fastcall TframeTinyRecord_TaxEntity::GetDesc ()
{
  string t = ""; // LowercaseString(comboType->Text.c_str());
  string u = editName->Text.c_str()
             + (t.empty() ? string("") : string(" (" + t + ")"));
  return u;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_TaxEntity::staticMatchesClick(TObject *Sender)
{
 if (matched_ids_to_values.empty())
  return;

 TIBTransaction * dbTransaction = NULL;
 FORM_TRY
  dbTransaction = new TIBTransaction(NULL);
 FORM_CATCH

 try
 {
  StdTransaction(dbTransaction, dbDatabase);
  string assigned_query_number = GetNextId(dbTransaction, "temp_id");
  vector<string> fields;
  fields.push_back("q");
  fields.push_back("id");
  fields.push_back("c");
  list<vector<string> > values;
  vector<string> blank_values;
  blank_values.push_back(assigned_query_number);
  blank_values.push_back("");
  blank_values.push_back("0");
  for(map<string, string>::const_iterator i = matched_ids_to_values.begin(); i != matched_ids_to_values.end(); i++)
  {
   blank_values[1] = i->first;
   blank_values[2] = IntToString((100.0 * StringToInt(i->second)) / last_max_score);
   values.push_back(blank_values);
  }
  if (!ExecutePreparedInsert (dbTransaction, "temp_id", fields, values))
   throw(99);

  string answer;
  TformSpecialSelectListview * z = NULL;
  FORM_TRY
   z = new TformSpecialSelectListview(NULL, &answer);
  FORM_CATCH

  z->Filter->SetSecurity("tax_entities");
  z->Filter->AddColumnSpec("Score", "tax_entities", as_int, true, 80, rawString, fc_right); // ADDED! apparently you can't fc_right the first column. d'oh.
  z->Filter->AddColumnSpec("Name", "tax_entities", as_text, true, 200, rawString);
  z->Filter->AddColumnSpec("Line 1", "tax_addresses", as_text, false, 100, addressString);
  z->Filter->AddColumnSpec("Line 2", "tax_addresses", as_text, false, 100, addressString);
  z->Filter->AddColumnSpec("City", "tax_addresses", as_text, true, 100);
  z->Filter->AddColumnSpec("State", "tax_addresses", as_text, false, 100, uppercaseString);
  z->Filter->AddColumnSpec("Zip", "tax_addresses", as_text, false, 100, prettyZipString);
  z->Filter->AddColumnSpec("Phone", "tax_addresses", as_text, true, 100, prettyPhoneString);
  z->Filter->AddColumnSpec("Fax", "tax_addresses", as_text, false, 100, prettyPhoneString);
  z->Filter->AddColumnSpec("E-mail", "tax_addresses", as_text, false, 100, lowercaseString);
  z->Filter->AddColumnSpec("Account", "tax_entities", as_text, false, 100);
  z->Filter->AddColumnSpec("Specialty", "tax_entities", as_text, true, 100);
  z->Filter->AddColumnSpec("Tax ID", "tax_entities", as_text, false, 100);
  z->Filter->AddColumnSpec("Care", "tax_entities", as_text, false, 100);
  z->Filter->AddColumnSpec("Served", "tax_entities", as_text, false, 100);
  z->Filter->AddColumnSpec("Agency", "tax_entities", as_text, false, 100);
  z->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  z->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  z->Filter->SetIconStatus(true);
  z->SourceTableName = "tax_entities";

  // stolen from codeSearchPerson
  string sql =
        "select "
        "temp_id.c || '%', "
        "tax_entities.name, tax_addresses.line1, tax_addresses.line2, "
        "tax_addresses.city, state_types.abbreviation, tax_addresses.zip, "
        "tax_addresses.phone_number, tax_addresses.fax_number, tax_addresses.email_address, "
        "chs_acct.identifier, tax_entities.specialty, "
        "tin.identifier, beh_care_types.item, beh_pop_types.item, "
        "beh_agency_types.item, tax_entities.current_id, tax_entities.id "
        "from tax_entities "
        "inner join tax_addresses on tax_addresses.id = tax_entities.physical_address_id "
        "inner join temp_id on temp_id.q = " + assigned_query_number + " and tax_entities.id = temp_id.id "
        "left join state_types on tax_addresses.state_id = state_types.id "
        "left join entity_ids chs_acct on chs_acct.tax_entity_id = tax_entities.id and chs_acct.current_id >= 3 and chs_acct.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "CHS Account") + "' "
        "left join entity_ids tin on tin.tax_entity_id = tax_entities.id and tin.current_id >= 3 and tin.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "TIN/EIN") + "' "
        "left join beh_care_types on tax_entities.beh_care_id = beh_care_types.id "
        "left join beh_pop_types on tax_entities.beh_pop_id = beh_pop_types.id "
        "left join beh_agency_types on tax_entities.beh_agency_id = beh_agency_types.id ";
  z->Width = 600;
  z->Execute(dbTransaction, sql);
  z->Filter->Sort(z->listStuff->Columns->Items[0], true); // defaults to sorting in the wrong direction? (messy!)
  z->ShowTaskModal(dynamic_cast<TformSpecialGeneric*>(FindNearestParentOfType(this, __classid(TformSpecialGeneric))));

  sql = "delete from temp_id where q = " + assigned_query_number;
  if (!ExecuteStatement(dbTransaction, sql))
  {
   PSay("Failed to delete temporary data.", m_database_error, MB_OK);
   throw(1);
  }

  if (!answer.empty())
  {
   // TODO: do we need to ask for confirmation?
   Magic = trm_existing; // 'cause ... it's not automatic when setting Id? maybe I should fix that.
   Id = answer; // this expands automatically ... but setting Magic, well, that contracts. so we do it this way (least fuss.)
   Expanded = true;
   // PSay("Selected: " + answer, m_debug, MB_OK);
  }

  dbTransaction->Commit();
 } catch (...)
 {
  if (dbTransaction->Active)
   dbTransaction->Rollback();
 }
 delete dbTransaction;
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_TaxEntity::ShortCut(TWMKey &Msg, bool &Handled)
{
 TframeTinyRecordMagic::ShortCut(Msg, Handled);

 if(HIBYTE(GetAsyncKeyState(VK_CONTROL)) && !HIBYTE(GetAsyncKeyState(VK_MENU)) && Msg.CharCode == '7' && buttonAddresses->Visible && buttonAddresses->Enabled)
 {
  frameAddresses->Add(true);
  Handled = true;
 }
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_TaxEntity::SetId (string Value)
{
 // always needed?
 comboType->Text = "";
 editName->Text = "";
 frameAddresses->Clear();

 bool can_change = ((!IsBlankOrZero(Value) && optionsPermissions["table." + SourceTableName]["update"] == "true") ||
                    ( IsBlankOrZero(Value) && optionsPermissions["table." + SourceTableName]["insert"] == "true"));
 panelTaxEntity->Visible = (optionsPermissions["table." + SourceTableName]["view"] == "true");
 panelTaxEntity->Enabled = can_change;

 if (IsBlankOrZero(Value))
 {
  FCurrentId = "4";
  TframeTinyRecordMagic::SetId(Value);
  CreateLink(staticExisting, NULL, Screen->ActiveForm, "0", "tax_entities");
 } else
 {
  map<string, string> t;
  if (SqlToMap(dbDatabase, "select name, tax_entity_id, current_id from tax_entities where id = " + Value, t))
  {
   FCurrentId = t["current_id"];
   comboType->Text = lookupTables->ValueOf("tax_entity_types", t["tax_entity_id"]).c_str();
   editName->Text = t["name"].c_str();

   string sql;
   vector<string> ids;

   if (optionsPermissions["table.tax_addresses"]["view"] == "true")
   {
    paddedAddresses->Visible = true;
    sql = "select id from tax_addresses where tax_entity_id = " + Value + " and current_id > 2";
    if (SqlToVec(dbDatabase, sql, ids))
     for (vector<string>::iterator i = ids.begin(); i != ids.end(); i++)
      frameAddresses->Add()->Id = *i;
     else
      PSay("Failed to get list of address records", m_database_error, MB_OK, sql);
    if (ids.empty())
     paddedAddresses->Visible = false;
    paddedAddresses->Height = paddedAddresses->Height + 1;
   } else
    paddedAddresses->Visible = false;

   CreateLink(staticExisting, NULL, Screen->ActiveForm, Value, "tax_entities");
   TframeTinyRecordMagic::SetId(Value);
   // Expanded = true;
  } else
   PSay("Failed to load a plausible record number", m_database_error, MB_OK, Value);
 }
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_TaxEntity::MagicValid ()
{
 if(Magic == trm_new && !done_search) // jhaley 20110829: Search is now required.
 {
   PSay("You must search for an existing entity at least once before creating a new one.", m_reminder, MB_OK);
   if(IsVisible(buttonSearch))
     buttonSearch->SetFocus();
   return false;
 }

 if (StripAll(editName->Text.c_str(), " ") == "")
 {
  PSay("Please enter a valid name for this tax entity.", m_invalid_data, MB_OK);
  if (IsVisible(editName)) editName->SetFocus();
  return false;
 }

 if(Magic == trm_new) // Only when saving a new one...
 {
   pvecstr blacklist = lookupTables->GetValueList("tax_entity_blacklist"); // ... compare against blacklist.

   for(pvecstr::iterator i_bl = blacklist.begin(); i_bl != blacklist.end(); ++i_bl)
   {
     if(LikeString(UppercaseString(*i_bl), UppercaseString(editName->Text.c_str())))
     {
       string type_id = GetOneField(dbDatabase, "select blacklist_id from tax_entity_blacklist where item = '" + *i_bl + "' ");
       string reason  = lookupTables->ValueOf("blacklist_types", type_id);
       string message;
       bool   allowcreate;
       bool   doreturn = false;

       if(type_id == lookupTables->IdOf("blacklist_types", "Duplicate")) // Duplicate, warn only and remind to search
       {
         pvecstr entity_names;
         string entity_sql =
           "select first 5 name from tax_entities where upper(name) like '" + *i_bl + "' order by rand()";
         SqlToVec(dbDatabase, entity_sql, entity_names);
         message =
           "The tax entity name you have entered is similar to many tax entities, including the following:\n\n";
         for(pvecstr::iterator i_name = entity_names.begin(); i_name != entity_names.end(); ++i_name)
           message += *i_name + "\n";
         message += "\nPlease verify that you are not creating a duplicate insurance company.\n\n"
                    "Do you want to stop saving and search for an existing company again?";
         allowcreate = true;
       }
       else if(type_id == lookupTables->IdOf("blacklist_types", "Policy Type")) // Policy type, NO! Not allowed.
       {
         message =
           "The tax entity name you have entered is on a list of names which are not allowed because they represent "
           "insurance policy types.\n\n"
           "If you are creating an insurance policy, you need to set the \"Insurance Type\" field, "
           "and not enter that data as the Insurance Company name instead. A tax entity additionally already exists "
           "for most policy types such as Medicaid, Medicare, and SoonerCare (OHCA).\n\n"
           "You will not be allowed to save a new tax entity using this name.";
         allowcreate = false;
       }
       // TODO: Other types, ex.: Employer
       if(allowcreate)
       {
         int result = PSay(message, m_reminder, MB_YESNO);
         if(result == IDYES)
           doreturn = true;
       }
       else
       {
         PSay(message, m_invalid_data, MB_OK);
         doreturn = true;
       }

       if(doreturn)
       {
         if(IsVisible(editName))
           editName->SetFocus();
         return false;
       }
     } // end if
   } // end for
 } // end if(Magic == trm_new)

/*
  if (!is_new_record && UppercaseString(editName->Text.c_str()) != UppercaseString(initial_state["name"]))
  {
    int response;
    response = PSay(
               "You have chosen to change this tax entity's name.  This should rarely happen.  Changing an entity's name on this screen will change their name EVERYWHERE.\n\n"
               "Changing a tax entity's name can make it difficult for other people to find them, resulting in the creation of a duplicate.\n"
               "Worse still, it could cause people to attach data to the wrong tax entity, which would be difficult to set right again.\n\n"
               "\nThe following are GOOD reasons to change this tax entity's name:\n\n"
               "Their name has changed, for example, Jane Doe is now Jane Smith.  You might indicate both names so people searching by the old name will also find her.\n\n"
               "You see a mistake or misspelling.\n\n"
               "The name does not follow naming convention, for example, changing 'Dr. John Doe' to 'John Doe, Dr.' or better yet, 'John Doe, M.D.'\n\n"
               "\nThe following should NOT be done:\n\n"
               "Do NOT change their name to another person entirely, for example, do NOT change 'John Doe' to 'Henrietta Pickenburg'.\n\n"
               "\nIf your intention was to change a link (from this tax entity to a different one), you have come to the WRONG place.  Say NO below, close this screen, and click the SEARCH button INSTEAD of the LINK.\n\n\n"
               "Are you sure you want to change this tax entity's name?", m_warning, MB_YESNO);
    if (response == IDNO)
      return false;
  }
*/

 if (editName->Text.c_str() == UppercaseString(editName->Text.c_str()))
 {
   int response;
   response = PSay(
              "You should never use ALL CAPS, unless the entire entity's name is an acronym.\n\n"
              "Is the name you entered an acronym?", m_warning, MB_YESNO);
   if (response == IDNO)
     editName->Text = PrettyString(editName->Text.c_str()).c_str();
 }

 if (editName->Text.c_str() == LowercaseString(editName->Text.c_str()))
 {
   // they're just dumb fuckers.  fix it for them and move on.
   editName->Text = PrettyString(editName->Text.c_str()).c_str();
 }

 if (!lookupTables->IsInLookUpTable("tax_entity_types", comboType->Text.c_str()))
 {
  PSay("Please enter a valid tax entity type.", m_invalid_data, MB_OK);
  if (IsVisible(comboType)) comboType->SetFocus();
  return false;
 }

 bool success = true;
 for(int i = 0; i < frameAddresses->RecordCount && success; i++)
 {
  TframeTinyRecord_TaxEntityAddress * z = dynamic_cast<TframeTinyRecord_TaxEntityAddress *>(frameAddresses->Record[i]);
  success = success && z->Valid();
 }
 return success;
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_TaxEntity::MagicSave (TIBTransaction * dbTransaction)
{
 if (Magic == trm_same && SameAs)
  return SameAs->Save(dbTransaction);
 if (Magic == trm_none)
  return true;
 if (Magic == trm_existing && !HasId)
  return true;

 // TODO: some sort of CanEdit property? set when loaded?
 if (HasId && GetOneField(dbDatabase, "select tin.identifier "
                                      "from tax_entities "
                                      "left join entity_ids tin on tin.tax_entity_id = tax_entities.id and tin.current_id >= 3 and tin.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "TIN/EIN") + "' "
                                      "where tax_entities.id = " + Id) == "730772869") // TODO -c MAGIC NUMBER :
 {
  PSay("You cannot add or edit records with the Absentee Shawnee Health Authority TIN/EIN (730772869).\n"
       "Your changes to this tax entity will not be saved.\n"
       "Please ask your systems administrator to make any\nnecessary changes or additions.", m_message, MB_OK);
  return true;
 }

 AtlasBeforeSave(dbTransaction);

 map<string, string> row;
 if (!HasId)
 {
  CreateInsertMap (dbTransaction, SourceTableName, row);
  row["id"] = GetNextId(dbTransaction, SourceTableName);
 } else
  row["id"] = Id;

 row["name"] = editName->Text.c_str();
 row["tax_entity_id"] = lookupTables->IdOf("tax_entity_types", comboType->Text.c_str());
/*
 row["specialty"] = editSpecialty->Text.c_str();
 row["taxid"] = editTaxid->Text.c_str();
 row["account_number"] = editAccount->Text.c_str();
 row["id_number"] = editIdNumber->Text.c_str();
 row["beh_care_id"] = lookupTables->IdOf("beh_care_types", cboCare->Text.c_str());
 row["beh_agency_id"] = lookupTables->IdOf("beh_agency_types", cboAgency->Text.c_str());
 row["beh_pop_id"] = lookupTables->IdOf("beh_pop_types", cboServed->Text.c_str());
*/
 row["current_id"]        = CurrentId;
 row["last_update_stamp"] = RightNow();
 row["last_updated_by"]   = current_userid;

 bool success = true;
 map<string, int> leave_alone;
 for (set<string>::iterator itr=fields_to_leave_raw.begin(); itr!=fields_to_leave_raw.end(); itr++)
  leave_alone[*itr] = sql_no_uppercasing;
 if (!HasId && (optionsPermissions["table." + SourceTableName]["insert"] == "true"))
  success = ExecuteInsertStatement(dbTransaction, SourceTableName, row, leave_alone);
 else if (HasId && (optionsPermissions["table." + SourceTableName]["update"] == "true"))
  if (WorthSaving(dbTransaction, row))
   success = ExecuteUpdateStatement(dbTransaction, SourceTableName, row, leave_alone);

 for(int i = 0; i < frameAddresses->RecordCount && success; i++)
 {
  TframeTinyRecord_TaxEntityAddress * z = dynamic_cast<TframeTinyRecord_TaxEntityAddress *>(frameAddresses->Record[i]);
  z->TaxEntityId = row["id"];
  success = z->Save(dbTransaction);
  z->AtlasGet(pending_atlas_notifications);
 }

 if (success)
  FId = row["id"];

 AtlasAfterSave(dbTransaction);

 return success;
}
//---------------------------------------------------------------------------
// jhaley 20110829: Overridden from the parent class in order to enforce early the concept that they must actually try
// to search for existing tax entities and not just start blindly creating new ones every single time there is a new
// insurance policy entry. I have seen consecutive policies created for people who should probably be covered under the
// same policy to begin with having consecutively created like-named tax entities - this is absolutely ridiculous.
void __fastcall TframeTinyRecord_TaxEntity::SetMagic(tr_magic_types Value)
{
  if(Value == trm_new && !done_search)
  {
    PSay("You must search for an existing entity before you will be allowed to create a new one.", m_reminder, MB_OK);
    if(IsVisible(buttonSearch))
      buttonSearch->SetFocus();

    if(Magic != trm_new) // Borrowed from the parent implementation.
      Value = Magic;
    else
      Value = trm_existing; // safe default?
  }

  TframeTinyRecordMagic::SetMagic(Value);
}
//---------------------------------------------------------------------------
