//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeFrameTinyRecord_TaxEntityAddress.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeFrameTinyRecord_Address"
#pragma link "codeHalfButton"
#pragma link "codeInlineContainer"
#pragma resource "*.dfm"
TframeTinyRecord_TaxEntityAddress *frameTinyRecord_TaxEntityAddress;
//---------------------------------------------------------------------------
__fastcall TframeTinyRecord_TaxEntityAddress::TframeTinyRecord_TaxEntityAddress(TComponent* Owner)
        : TframeTinyRecord_Address(Owner)
{
 lookupTables->RegisterComboBox("tax_address_types", comboType);
}
//---------------------------------------------------------------------------
__fastcall TframeTinyRecord_TaxEntityAddress::~TframeTinyRecord_TaxEntityAddress()
{
 lookupTables->UnregisterComboBox("tax_address_types", comboType);
}
//---------------------------------------------------------------------------
TframeTinyRecordGeneric* TframeTinyRecord_TaxEntityAddress::Create(TComponent* Owner)
{
 TframeTinyRecordGeneric * z = NULL;
 FORM_TRY
  z = new TframeTinyRecord_TaxEntityAddress(Owner);
 FORM_CATCH
 return z;
}
//---------------------------------------------------------------------------
string __fastcall TframeTinyRecord_TaxEntityAddress::GetSourceTableName ()
{
 return "tax_addresses";
}
//---------------------------------------------------------------------------
void __fastcall TframeTinyRecord_TaxEntityAddress::SetId (string Value)
{
 // always needed?
 // some clearing ...
 editLine1->Text = "";
 editLine2->Text = "";
 comboCity->Text = "";
 editZip->Text = "";
 comboState->Text = "";
 string state_id, county_sql;
 if (!CountyLookupByState(comboState->Text.c_str(), state_id, county_sql, comboCounty)) /* whoops? */ ;
  comboCounty->Text = PrettyString(lookupTables->ValueOf("county_types", "", comboCounty)).c_str();
 comboCountry->Text = "";
 // comboResidence->Text = PrettyString(lookupTables->ValueOf("residence_types", initial_state["residence_id"])).c_str();
 editPhone->Text = "";
 comboType->Text = "";

 bool can_change = ((!IsBlankOrZero(Value) && optionsPermissions["table." + SourceTableName]["update"] == "true") ||
                    ( IsBlankOrZero(Value) && optionsPermissions["table." + SourceTableName]["insert"] == "true"));
 inlineAddress->Visible = (optionsPermissions["table." + SourceTableName]["view"] == "true");
 inlineAddress->Enabled = can_change;

 if (IsBlankOrZero(Value))
 {
  FCurrentId = "4";
  comboCountry->Text = "United States";
  TframeTinyRecord_Address::SetId(Value);
 } else
 {
  map<string, string> t;
  if (SqlToMap(dbDatabase, "select line1, line2, city, zip, state_id, county_id, country_id, phone_number, tax_address_id, current_id from tax_addresses where id = " + Value, t))
  {
   FCurrentId = t["current_id"];

   // comboLocation->Text = PrettyString(lookupTables->ValueOf("contact_info_types", t["contact_info_id"])).c_str();
   editLine1->Text = FormatAddress(t["line1"]).c_str();
   editLine2->Text = FormatAddress(t["line2"]).c_str();
   comboCity->Text = PrettyString(t["city"]).c_str();
   editZip->Text = FormatZipCode(t["zip"]).c_str();
   comboState->Text = PrettyString(lookupTables->ValueOf("state_types", t["state_id"])).c_str();
   string state_id, county_sql;
   if (!CountyLookupByState(comboState->Text.c_str(), state_id, county_sql, comboCounty)) /* whoops? */ ;
    comboCounty->Text = PrettyString(lookupTables->ValueOf("county_types", t["county_id"], comboCounty)).c_str();
   comboCountry->Text = PrettyString(lookupTables->ValueOf("country_types", t["country_id"])).c_str();
   // comboResidence->Text = PrettyString(lookupTables->ValueOf("residence_types", t["residence_id"])).c_str();
   editPhone->Text = FormatPhoneNumber(t["phone_number"]).c_str();
   comboType->Text = lookupTables->ValueOf("tax_address_types", t["tax_address_id"]).c_str();

   TframeTinyRecord_Address::SetId(Value);
  } else
   PSay("Failed to load a plausible record number", m_database_error, MB_OK, Value);
 }
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_TaxEntityAddress::Valid ()
{
 if (!TframeTinyRecord_Address::Valid())
  return false;
 else if (!lookupTables->IsInLookUpTable("tax_address_types", comboType->Text.c_str()))
 {
  PSay("Please ensure that each tax entity address record has a valid phone/address type", m_invalid_data, MB_OK);
  if (IsVisible(comboType)) comboType->SetFocus();
  return false;
 } else
  return true;
}
//---------------------------------------------------------------------------
bool TframeTinyRecord_TaxEntityAddress::Save (TIBTransaction * dbTransaction)
{
 AtlasBeforeSave(dbTransaction);

 map<string, string> row;
 if (!HasId)
 {
  CreateInsertMap (dbTransaction, SourceTableName, row);
  row["id"] = GetNextId(dbTransaction, SourceTableName);
 } else
  row["id"] = Id;

 row["tax_address_id"] = lookupTables->IdOf("tax_address_types", comboType->Text.c_str());
 row["line1"]          = FormatAddress(editLine1->Text.c_str());
 row["line2"]          = FormatAddress(editLine2->Text.c_str());
 row["city"]           = comboCity->Text.c_str();
 row["state_id"]       = lookupTables->IdOf("state_types", comboState->Text.c_str());
 row["zip"]            = StripAllExcept(editZip->Text.c_str(), ints);
 row["county_id"]      = lookupTables->IdOf("county_types", comboCounty); // need to pass the cbo box so it can look up the ID since it's got custom sql / item list
 row["country_id"]     = lookupTables->IdOf("country_types", comboCountry->Text.c_str());
 row["phone_number"]   = StripAllExcept(editPhone->Text.c_str(), uints);
// row["fax_number"]     = StripAllExcept(editFax->Text.c_str(), uints);
// row["website"]        = editWebsite->Text.c_str();
// row["email_address"]  = editEmail->Text.c_str();
// row["notes"]          = editNotes->Text.c_str();
 row["tax_entity_id"]  = TaxEntityId;

 row["current_id"]        = CurrentId;
 row["last_update_stamp"] = RightNow();
 row["last_updated_by"]   = current_userid;

 bool success = true;
 if (!HasId && (optionsPermissions["table." + SourceTableName]["insert"] == "true"))
  success = ExecuteInsertStatement(dbTransaction, SourceTableName, row);
 else if (HasId && (optionsPermissions["table." + SourceTableName]["update"] == "true"))
  if (WorthSaving(dbTransaction, row))
   success = ExecuteUpdateStatement(dbTransaction, SourceTableName, row);

 if (success)
  FId = row["id"];

 AtlasAfterSave(dbTransaction);

 return success;
}
//---------------------------------------------------------------------------

