//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeLoginBox.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TformLoginBox *formLoginBox;
//---------------------------------------------------------------------------
__fastcall TformLoginBox::TformLoginBox(TComponent* Owner, string * p_username, string * p_password, bool do_database_prompt, string *p_db_override_section)
        : TForm(Owner)
{
 must_choose_database = false;
 username = p_username;
 password = p_password;
 db_override_section = p_db_override_section;
 editUsername->Text = username->c_str();
 editPassword->Text = password->c_str();
 if(do_database_prompt)
 {
   must_choose_database = true;
   panelBottom->Visible = true;
   this->ClientHeight = panelTop->Height + panelBottom->Height + 32;
   DatabasesListview = new edit_listview();
   DatabasesListview->setup_listview(listDatabases);
   //listDatabases->ShowColumnHeaders = false; // TODO -c HACK :
   listDatabases->SmallImages = NULL; // TODO -c HACK :
   map<string,string> overridden;
   // build a complete map of keys to use below, i.e. overridden will now contain every key, from every section of the ini file
   for(map<string,map<string,string> >::iterator itr = optionsIni.begin(); itr != optionsIni.end(); itr++)
     for(map<string,string>::iterator subitr = itr->second.begin(); subitr != itr->second.end(); subitr++)
       overridden[subitr->first] = "";
   // a bit of setting up the edit_listview
   DatabasesListview->add_or_modify_column("__name","name",true,0,-1,as_text,rawString);
   DatabasesListview->setup_callbacks((TForm*)this, NULL, InformForm(&(TformLoginBox::dbselected)));
   // build a vecmap of data to import into the listview
   vector<map<string, string> > data_to_import;
   for(map<string,map<string,string> >::iterator itr = optionsIni.begin(); itr != optionsIni.end(); itr++)
   {
//     if (itr->first != "server")
     {
       for(map<string,string>::iterator subitr = overridden.begin(); subitr != overridden.end(); subitr++)
       {
         // if the overridden branch contains the key we're looking for, use that value
         if (itr->second.find(subitr->first) != itr->second.end())
           subitr->second = itr->second[subitr->first];
         // if not, fall back to the server (default) branch and see if the key's there
         else if (optionsIni["server"].find(subitr->first) != itr->second.end())
           subitr->second = optionsIni["server"][subitr->first];
//         else // and if we can't find it there either, use blank
//           subitr->second = ""; // actually, isn't it already blank from the initialization of overridden above?
       }
       //PSay("In OptionsINI branch: " + itr->first + "\nLooking for key: " + subitr->first +
       //  MapToDelimString(overridden, "", "", "\n", "'", "'", "'", "'", "="), m_debug, MB_OK, "login");
       // TODO -c HACK : __name shouldn't conflict with an existing key, right?  :-)
       // stick in key/value for section name, so edit_listview knows what to display
       overridden["__name"] = itr->first;
       // Now just push_back into a vector
       data_to_import.push_back(overridden);
       // remove section name key/value again so it doesn't get in the way
       overridden.erase(overridden.find("__name"));
     }
   }

   // now we loop through the columns (pain in the ass with a vecmap) and remove columns where all values are the same
   for(map<string,string>::iterator itr = overridden.begin(); itr != overridden.end(); itr++)
   {
     bool column_values_equal = true; // until we find a case where they're not
     string column_value = data_to_import[0][itr->first]; // initialize
     unsigned int i = 1;
     while (column_values_equal && i < data_to_import.size())
     {
       if(data_to_import[i][itr->first] != column_value) column_values_equal = false;
       i++;
     }
     if(column_values_equal)
     {
       //PSay("removing column '" + itr->first + "' because all values are '" + column_value + "'", m_message, MB_OK, "login");
       // column dies a horrible death
       for (unsigned int i=0; i < data_to_import.size(); i++)
         data_to_import[i].erase(data_to_import[i].find(itr->first));
     }
   }
   // add the diff'd columns to the edit_listview
   int i = 1;
   for(map<string,string>::iterator itr = data_to_import[0].begin(); itr != data_to_import[0].end(); itr++,i++)
     if (itr->first,itr->first != "__name")
       DatabasesListview->add_or_modify_column(itr->first,itr->first,true,i,-1,as_text,rawString);
   // and when we're all done, import_data into the edit_listview
   DatabasesListview->import_data(data_to_import);
 }
 else
   this->ClientHeight = panelTop->Height + 33;
}
//---------------------------------------------------------------------------
void __fastcall TformLoginBox::FormClose(TObject *Sender,TCloseAction &Action)
{
 if(must_choose_database && listDatabases->Selected)
 {
   string override_section = listDatabases->Selected->Caption.c_str();
   //PSay(override_section, m_message, MB_OK, "login");
   if(db_override_section) (*db_override_section) = override_section;
   // now override "server" key/value pairs with the ones in the selected override section
   for(map<string,string>::iterator itr = optionsIni[override_section].begin(); itr != optionsIni[override_section].end(); itr++)
     optionsIni["server"][itr->first] = itr->second;
 }
 username->operator =(editUsername->Text.c_str());
 password->operator =(editPassword->Text.c_str());
 Action = caFree;
 delete DatabasesListview;
}
//---------------------------------------------------------------------------
void __fastcall TformLoginBox::FormShow(TObject *Sender)
{
 if ((*username) != "")
  editPassword->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TformLoginBox::FormCloseQuery(TObject *Sender,bool &CanClose)
{
 bool result = true;
 if(must_choose_database && !listDatabases->Selected && ModalResult == mrOk)
 {
   PSay("You must choose a database.  If you are not one of the Prometheus developers, you should report this to a programmer immediately.", m_warning, MB_OK, "formLoginBox");
   result = false;
 }
 CanClose = result;
}
//---------------------------------------------------------------------------
// Philip decided that it would be fun to make extra callbacks for no good reason
// that have no advantages whatsoever over the existing ones.  So rather than using
// the listview's OnDblClick event, we use this, and call setup_callbacks above.
// Everyone say "thank you, Philip!"
// Philip: You're welcome
//         =)~
void TformLoginBox::dbselected ()
{
  buttonLogin->Click();
}
//---------------------------------------------------------------------------
void __fastcall TformLoginBox::FormPaint(TObject *Sender)
{
 // just try once
 if (editPassword->Text != "")
  buttonLogin->Click();
 this->OnPaint = NULL;
}
//---------------------------------------------------------------------------

