//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "codeMessaging.h"

#include "utilityheaders.h"
#include "baseheaders.h"
#include "components.h"
//#include "util.h"
//#include "inifile.h"
#include <vector>
#include <string>
using namespace std;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TformMessaging *formMessaging;
//---------------------------------------------------------------------------
KGB_type::KGB_type(TPageControl* Tpc, TPopupMenu* Tpm, TListView* Tlv)
{
   page_control = Tpc;
   popup_clear = Tpm;
   box_list = Tlv;
   defaultKeepOnly = "100";
   map<string, map<string,string> > optionsIni;
   if (optionsIni["messaging-general"]["default-keep-only"] != "")
      defaultKeepOnly = optionsIni["messaging-general"]["default-keep-only"].c_str();
}
bool KGB_type::addSpy(string name)
{
    bool result = false;
    string tab_name = name;
    TTabSheet* tab_sheet = new TTabSheet(page_control);
    tab_sheet->Caption = tab_name.c_str();
    tab_sheet->TabVisible = true;
    tab_sheet->Visible = true;
    tab_sheet->Enabled = true;
    tab_sheet->PageControl = page_control;
    tab_sheet->Parent = page_control;

    TListView* list_view = new TListView(tab_sheet);
    TAnchors stupid;
    stupid << akLeft << akRight << akTop << akBottom;
    list_view->Anchors = stupid;
    list_view->Left = 8;
    list_view->Top = 6;
    list_view->Width = page_control->Width - 24;
    list_view->Height = page_control->Height - 64;
    list_view->ViewStyle = vsReport;
    list_view->PopupMenu = popup_clear;
    list_view->Visible = true;
    list_view->Enabled = true;
    TListColumn * column = list_view->Columns->Add();
    column->Width = list_view->Width - 4;
    column->Caption = "messages";
    list_view->ShowColumnHeaders = true;
    list_view->Parent = tab_sheet;

    TAnchors stupid2;
    stupid2 << akLeft << akBottom;

    TLabel* aLabel = new TLabel(tab_sheet);
    aLabel->Anchors = stupid2;
    aLabel->Left = 12;
    aLabel->Top = list_view->Top + list_view->Height + 8;
    aLabel->Width = 47;
    aLabel->Height = 13;
    aLabel->Caption = "Keep Only:";
    aLabel->AutoSize = true;
    aLabel->Visible = true;
    aLabel->Enabled = true;
    aLabel->Parent = tab_sheet;

    TEdit* keepOnly = new TEdit(tab_sheet);
    keepOnly->Anchors = stupid2;
    keepOnly->Left = 70;
    keepOnly->Top = list_view->Top + list_view->Height + 4;
    keepOnly->Width = 50;
    keepOnly->Height = 21;
    keepOnly->MaxLength = 5;
    keepOnly->Text = defaultKeepOnly.c_str();
    keepOnly->Visible = true;
    keepOnly->Enabled = true;
    keepOnly->Parent = tab_sheet;

    spy_type bob;
    bob.aChannel = name;
    bob.aTab = tab_sheet;
    bob.aList = list_view;
    bob.aLabel = aLabel;
    bob.keepOnly = keepOnly;
    spies[name] = bob;
    result = true;
    return result;
}
void KGB_type::populateList()
{
   //box_list->Items->Clear();
   for (map_itr = spies.begin(); map_itr != spies.end(); map_itr++)
   {
      bool found = false;
      for (int i = 0; i < box_list->Items->Count; i++)
      {
         if (box_list->Items->Item[i]->Caption == map_itr->second.aChannel.c_str())
         {
            found = true;
            box_list->Items->Item[i]->SubItems->Strings[0] = IntToString(map_itr->second.aList->Items->Count).c_str();
         }
      }
      if (!found)
      {
         TListItem* newitem = box_list->Items->Add();
         newitem->Caption = (map_itr->second.aChannel).c_str();
         newitem->SubItems->Add(IntToString(map_itr->second.aList->Items->Count).c_str());
      }
      else ;
   }
}

bool KGB_type::deleteSpy(string name)
{
    map<string, spy_type>::iterator bob = spies.find(name);
    delete bob->second.aLabel;
    delete bob->second.keepOnly;
    delete bob->second.aList;
    delete bob->second.aTab;
    bool result = spies.erase(name);
    for (int i = 0; i < box_list->Items->Count; i++)
    {
       if (box_list->Items->Item[i]->Caption == name.c_str())
          box_list->Items->Delete(i);
    }
    populateList();
    return result;
}
void KGB_type::getMessages()
{
   for (map_itr = spies.begin(); map_itr != spies.end(); map_itr++)
   {
      while (message_router->IsMessageWaiting(map_itr->second.aChannel))
      {
         TListItem* newitem = map_itr->second.aList->Items->Add();
         newitem->Caption = message_router->GetNextMessage(map_itr->second.aChannel).c_str();
         newitem->SubItems->Add(map_itr->second.aChannel.c_str());
         if (StringToInt(map_itr->second.keepOnly->Text.c_str()) < map_itr->second.aList->Items->Count)
         {
            map_itr->second.aList->Items->Item[0]->Delete();
         }
      }
   }
   populateList();
}
string KGB_type::getActivePageName()
{
   string result;
   for (map_itr = spies.begin(); map_itr != spies.end(); map_itr++)
   {
      if (map_itr->second.aTab->TabIndex == page_control->ActivePageIndex)
         result = map_itr->second.aChannel.c_str();
   }
   return result;
}
string KGB_type::getActiveTabName()
{
   string result;
   for (map_itr = spies.begin(); map_itr != spies.end(); map_itr++)
   {
      if (map_itr->second.aTab->TabIndex == page_control->ActivePageIndex)
         result = map_itr->second.aTab->Caption.c_str();
   }
   return result;
}
void KGB_type::clearMessages(string name)
{
   spies[name].aList->Items->Clear();
}
void KGB_type::clearSpies()
{
// int i = 0;
 for (map_itr = spies.begin(); map_itr != spies.end(); map_itr++)
 {
//    i++;
//    PSay(IntToString(i).c_str(), m_warning, MB_OK);
    deleteSpy(map_itr->second.aChannel);
 }
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TformMessaging::TformMessaging(TComponent* Owner)
        : TForm(Owner), KGB(mainPageControl, popupClear, listBoxes)
{
  editNewBoxName->Text = "";
  cboChannel->Text = "";

  if (optionsIni["messaging-general"]["default-new"] != "")
   editNewBoxName->Text = optionsIni["messaging-general"]["default-new"].c_str();
  if (optionsIni["messaging-general"]["default-channel"] != "")
   cboChannel->Text = optionsIni["messaging-general"]["default-channel"].c_str();
  map<string, string>::iterator itr;

  for (itr = optionsIni["messaging-messages"].begin(); itr != optionsIni["messaging-messages"].end(); itr++)
     if (itr->second == "true")
        cboMessage->Items->Add(itr->first.c_str());

  for (itr = optionsIni["messaging-channels"].begin(); itr != optionsIni["messaging-channels"].end(); itr++)
    if (itr->second == "true")
      if (!KGB.addSpy(itr->first))
         PSay(("The box " + itr->first + "\nis already in use, or is invalid."), m_warning, MB_OK, "TformMessaging");

  KGB.populateList();
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::timerPollMessagesTimer(TObject *Sender)
{
 KGB.getMessages();
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::buttonSendClick(TObject *Sender)
{
 if (cboToType->Text == "*")
 {
    message_router->SendMessageToAll(cboChannel->Text.c_str(), cboMessage->Text.c_str());
 }
 else
 {
    message_router->SendMessageToAny(cboToType->Text.c_str(), cboToValue->Text.c_str(),
                                     cboChannel->Text.c_str(), cboMessage->Text.c_str());
 }
 int i;
 bool foundChannel = false, foundMessage = false;
 for (i = 0; i != cboChannel->Items->Count; i++)
    if (UpperCase(cboChannel->Items->Strings[i]) == UpperCase(cboChannel->Text))
       foundChannel = true;
 for (i = 0; i != cboMessage->Items->Count; i++)
    if (UpperCase(cboMessage->Items->Strings[i]) == UpperCase(cboMessage->Text))
       foundMessage = true;
 if (!foundChannel)
    cboChannel->Items->Add(cboChannel->Text);
 if (!foundMessage)
    cboMessage->Items->Add(cboMessage->Text);
 cboMessage->Text = "";
 cboMessage->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::FormClose(TObject *Sender, TCloseAction &Action)
{
   KGB.clearSpies();
   int i;
   for (i = 0; i != cboMessage->Items->Count; i++)
      optionsIni["messaging-messages"][cboMessage->Items->Strings[i].c_str()] = "true";
   for (i = 0; i != listBoxes->Items->Count; i++)
      optionsIni["messaging-channels"][listBoxes->Items->Item[i]->Caption.c_str()] = "true";
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::menuPrometheusCommandClick(TObject *Sender)
{
 cboChannel->Text = optionsIni["server"]["admin_get"].c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::buttonAddClick(TObject *Sender)
{
 if (KGB.addSpy(editNewBoxName->Text.c_str()))
 {
  editNewBoxName->Text = "";
  KGB.populateList();
 }
 else PSay("Could not add channel", m_program_error, MB_OK, "TformMessaging");
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::buttonDelClick(TObject *Sender)
{
 if (listBoxes->SelCount)
 {
  string name = listBoxes->Selected->Caption.c_str();
  KGB.deleteSpy(name);
  KGB.populateList();
 }
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::buttonCloseClick(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::buttonClearClick(TObject *Sender)
{
 cboMessage->Text = "";
 cboMessage->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::menuCmdDieClick(TObject *Sender)
{
 cboMessage->Text = "cmd:die";
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::menuCmdDiagnoseClick(TObject *Sender)
{
 cboMessage->Text = "cmd:diagnose";
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::menuCmdPingClick(TObject *Sender)
{
 cboMessage->Text = "cmd:ping";
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::menuCmdCloseClick(TObject *Sender)
{
 cboMessage->Text = "cmd:close";
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::menuCmdSaveClick(TObject *Sender)
{
 cboMessage->Text = "cmd:save";
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::menuGetClick(TObject *Sender)
{
 cboMessage->Text = "get:section.key";
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::menuSetClick(TObject *Sender)
{
 cboMessage->Text = "set:section.key=value";
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::menuRunClick(TObject *Sender)
{
 cboMessage->Text = "run:program";
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::menuSayClick(TObject *Sender)
{
 cboMessage->Text = "say:message";
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::menuAckClick(TObject *Sender)
{
 cboMessage->Text = "ack:message";
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::menuMbClick(TObject *Sender)
{
 cboMessage->Text = "mb:type,title,message";
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::menuClearClick(TObject *Sender)
{
  string name = KGB.getActivePageName();
  KGB.clearMessages(name);
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::menuChannelsClearClick(TObject *Sender)
{
   cboChannel->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::menuCommandsClearClick(TObject *Sender)
{
   cboMessage->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::menuKillTabClick(TObject *Sender)
{
   string name = KGB.getActivePageName();
   KGB.deleteSpy(name);
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::popupKillTabPopup(TObject *Sender)
{
   string name = KGB.getActiveTabName();
   mainPageControl->PopupMenu->Items->Items[0]->Caption = ("Delete " + name).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::FormResize(TObject *Sender)
{
//   buttonSend->Left = cboMessage->Left + cboMessage->Width + 5;
//   buttonAdd->Left = editNewBoxName->Left + editNewBoxName->Width + 5;
//   buttonDel->Left = buttonAdd->Left + buttonAdd->Width + 5;
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::cboToTypeChange(TObject *Sender)
{
  if (cboToType->Text == "*")
     cboToValue->Enabled = false;
  else
     cboToValue->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TformMessaging::editNewBoxNameKeyPress(TObject *Sender, char &Key)
{
   if (Key == VK_RETURN)
      buttonAdd->Click();
}
//---------------------------------------------------------------------------

