//---------------------------------------------------------------------------
#ifndef codePrometheusH
#define codePrometheusH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <Menus.hpp>
#include <Db.hpp>
#include <IBCustomDataSet.hpp>
#include <IBDatabase.hpp>
#include <IBSQL.hpp>
#include <ImgList.hpp>
#include <IBSQLMonitor.hpp>
#include <ScktComp.hpp>
#include <Buttons.hpp> // Okay, Builder, you need to quit removing this line.

#include <string>
#include <map>
#include <vector>

using namespace std;

#include "allsymbols.h"
#include "codePrometheusSplash.h"
#include <DB.hpp>
#include <ScktComp.hpp>
#include <IBSQLMonitor.hpp>

class classFilterObject;
class classMainMenuListener;
class classDeferredMessageQueue;
class TframePrometheusMenu;

// jhaley 20110415: For tray icon:
#define MYWM_NOTIFY (WM_APP+100)
#define IDC_MYICON  1006

//---------------------------------------------------------------------------
class TformPrometheusMenu : public TForm
{
__published:	// IDE-managed Components
        TIBDatabase *GdbDatabase;
        TImageList *GimagesCurrent;
        TImageList *GimagesRecordTypes;
        TPopupMenu *GpopupListActions;
        TPopupMenu *GpopupCurrentTypes;
        TMenuItem *menuFilter;
        TMenuItem *menuHeaders;
        TMenuItem *menuSepPopupListActions2;
        TMenuItem *menuAddRecord;
        TMenuItem *menuEditRecord;
        TPopupMenu *GpopupLookupTables;
        TMenuItem *menuAddValue;
        TMenuItem *menuSaveListView;
        TMenuItem *menuSepPopupListActions1;
        TMenuItem *menuModifySQL;
        TClientSocket *sockClientSocket;
        TMenuItem *menuSepPopupListActions3;
        TMenuItem *menuCheckAll;
        TMenuItem *menuCheckFlip;
        TMenuItem *menuCheckNone;
        TMenuItem *menuExportListview;
        TIBSQLMonitor *GdbMonitor;
        TMenuItem *menuAutosizeColumns;
        TMenuItem *menuRefresh;
        TPanel *panelQuickMenus;
        TMenuItem *menuSepPopupListActions4;
        TMenuItem *menuCheckThese;
        TMenuItem *menuCheckFlipThese;
        TMenuItem *menuUncheckThese;
        TTimer *timerNetworkRefresh;
        TTimer *timerAdmin;
        TTimer *timerReplaceOld;
        TTimer *timerDie;
        TTimer *timerAppointments;
        TTimer *timerPendingFilters;
        TTimer *timerReconnect;
        TTimer *timerChatFlash;
        TTimer *timerCheckIdle;
        TTimer *timerDisableCapsLock;
        TMenuItem *menuCheck;
        TMenuItem *menuActions;
        TMenuItem *N2;
        TIBDatabase *GdbUpdateDatabase;
        TTimer *timerGetValueTimeout;
        TMenuItem *menuCopyListView;
        TPanel *panelMenuContainer;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall menuCurrentTypesChoice(TObject *Sender);
        void __fastcall menuHeadersClick(TObject *Sender);
        void __fastcall menuFilterClick(TObject *Sender);
        void __fastcall GpopupListActionsPopup(TObject *Sender);
        void __fastcall menuAddRecordClick(TObject *Sender);
        void __fastcall menuEditRecordClick(TObject *Sender);
        void __fastcall menuCreateCallBehClick(TObject *Sender);
        void __fastcall DoubleClickListView (TObject * Sender);
        void __fastcall OnColumnClickListView (TObject * Sender, TListColumn * Column);
        void __fastcall OnEditListviewRowSelect(TObject *Sender, TListItem *Item, bool Selected);
        void __fastcall OnEditListviewColumnClick(TObject *Sender, TListColumn *Column);
        void __fastcall OnEditListviewDoubleClick (TObject * Sender);
        void __fastcall person1Click(TObject *Sender);
        void __fastcall GpopupLookupTablesPopup(TObject *Sender);
        void __fastcall menuAddValueClick(TObject *Sender);
        void __fastcall menuSaveListViewClick(TObject *Sender);
        void __fastcall OnLinkClick(TObject *Sender);
        void __fastcall OnLinkMenuItemClick(TObject *Sender);
        void __fastcall OnComboKeyPress(TObject *Sender, char &Key);
        void __fastcall menuModifySQLClick(TObject *Sender);
        void __fastcall FilterListViewAdvancedCustomDraw(TCustomListView *Sender, const TRect &ARect, TCustomDrawStage Stage, bool &DefaultDraw);
        void __fastcall sockClientSocketRead(TObject *Sender, TCustomWinSocket *Socket);
        void __fastcall sockClientSocketWrite(TObject *Sender, TCustomWinSocket *Socket);
        void __fastcall sockClientSocketConnect(TObject *Sender, TCustomWinSocket *Socket);
        void __fastcall sockClientSocketError(TObject *Sender, TCustomWinSocket *Socket, TErrorEvent ErrorEvent, int &ErrorCode);
        void __fastcall sockClientSocketDisconnect(TObject *Sender, TCustomWinSocket *Socket);
        bool __fastcall FormHelp(WORD Command, int Data, bool &CallHelp);
        void __fastcall GdbDatabaseAfterDisconnect(TObject *Sender);
        void __fastcall GdbDatabaseAfterConnect(TObject *Sender);
        void __fastcall GdbDatabaseBeforeConnect(TObject *Sender);
        void __fastcall GdbDatabaseBeforeDisconnect(TObject *Sender);
        void __fastcall menuCheckAllClick(TObject *Sender);
        void __fastcall menuCheckFlipClick(TObject *Sender);
        void __fastcall menuCheckNoneClick(TObject *Sender);
        void __fastcall menuExportListviewClick(TObject *Sender);
        void __fastcall timerNetworkRefreshTimer(TObject *Sender);
        void __fastcall timerAdminTimer(TObject *Sender);
        void __fastcall timerReplaceOldTimer(TObject *Sender);
        void __fastcall timerDieTimer(TObject *Sender);
        void __fastcall timerAppointmentsTimer(TObject *Sender);
        void __fastcall timerFilterHintTimerProxy(TObject *Sender);
        void __fastcall timerPendingFiltersTimer(TObject *Sender);
        void __fastcall timerReconnectTimer(TObject *Sender);
        void __fastcall timerChatFlashTimer(TObject *Sender);
        void __fastcall timerCheckIdleTimer(TObject *Sender);
        void __fastcall HandleClosingExceptions(TObject *Sender, Exception *E);
        void __fastcall FormDeactivate(TObject *Sender);
        void __fastcall FormActivate(TObject *Sender);
        void __fastcall GdbMonitorSQL(AnsiString EventText, TDateTime EventTime);
        void __fastcall menuAutosizeColumnsClick(TObject *Sender);
        void __fastcall menuRefreshClick(TObject *Sender);
        void __fastcall menuCheckTheseClick(TObject *Sender);
        void __fastcall menuCheckFlipTheseClick(TObject *Sender);
        void __fastcall menuUncheckTheseClick(TObject *Sender);
        void __fastcall timerDisableCapsLockTimer(TObject *Sender);
        void __fastcall menuActionsClick(TObject *Sender);
        void __fastcall GetListViewData(TObject *Sender, TListItem *Item);
        void __fastcall ListViewKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
        void __fastcall ListViewClick(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall timerGetValueTimeoutTimer(TObject *Sender);
        void __fastcall menuCopyListViewClick(TObject *Sender);
private:	// User declarations
        friend class classMainMenuListener; // jhaley 20110121: deferred message listener needs access to everything
        friend class TframePrometheusMenu;  // jhaley 20110125: menu frame needs access to everything

        // Dynamic and external controls
        TformPrometheusSplash *formSplash;
        TframePrometheusMenu  *menuFrame;
        vector<TSpeedButton *> quick_menus;

        // State flags
        bool logged_in;
        bool do_database_prompt;
        bool is_new_version;
        bool is_idle;
        bool stuff_happened;             // used to track idle status
        bool get_value_timed_out;
        bool shutdown_due_to_inactivity;

        // String data
        string db_override_section;
        string a_username;
        string a_password;
        string get_ip_guid;
        string my_ip;
        string class_name; // for AV_TRY/AV_CATCH call to PPretendToSay

        // Counters and metrics
        int replace_attempts;
        int referrals_request;
        int ip_request;
        int seconds_idle;
        int startup_form_width;
        int startup_form_height;

        // Atlas
        map<int, string> lookupAtlasTickets;

        // Database
        TIBTransaction *dbTransaction;
        TIBTransaction *dbUpdateTransaction;

        // SQL Monitor stuff
        TDateTime sql_monitor_time_to_live;
        struct monitored_sql_query
        {
         TDateTime requested;
         TDateTime answered;
         TDateTime terminated;
         TDateTime last_activity;
        };
        map<string, monitored_sql_query> monitored_sql_queries;
        string monitored_sql;
        monitor_actions monitored_action;

        // Deferred messaging
        classDeferredMessageQueue *menu_msg_queue; // jhaley 20110119
        classMainMenuListener     *menu_listener;  // jhaley 20110119

        // Private Methods
        void SplashShow(string p_section); // jhaley 20110617: convenience method, calls down to formSplash->SplashShow
        void SplashSet(string p_section, string p_value); // ditto
        void StartUp(bool &all_is_well);
        void LogIn(bool &all_is_well);
        void LogOut();
        void ShutDown();
        void WriteLogs();
        bool CloseAllForms();
        void CreateTempDir();
        void DeleteTempDir();
        bool SavePreferences ();
        int  AnyFormsBusy();
        void getPreferences(bool &all_is_well);
        void getPermissions(bool &all_is_well);
        bool doLogin(bool &all_is_well, bool suppress_prompt_once = false);
        void RecurseMenuItem(TMenuItem *menu_item, int tagVal, bool boolVal);
        void RecurseMenu(TMainMenu *menu, int tagVal, bool boolVal);
        void ShowUsefulFolders(TMenuItem *menu_item);
        void HandleChatMessages(string channel);
        int  PSay(string p_message, prometheus_message_types p_message_type, int p_buttons, string p_other_info = "");
        void __fastcall HandleApplicationMessages(tagMSG &Msg, bool &Handled);
        void DisableCapsLock();
        void DebugWidth(string info);
        int  NumReportsOpen();  // jhaley 20110118
        void CloseAllReports(); // jhaley 20110121
        void DoSwitchUsers();

        // Startup subroutines - jhaley 20110531
        void startupInitVersions();
        void startupInitDateFormats();
        void startupSetConstraints();
        void startupInitExterns();
        void startupInitRelationGeneric();
        void startupInitSpecialActions();
        void startupInitClassFilterObject();
        void startupInitEditListView();
        void startupInitComponents();
        void startupSplashScreen();
        void startupReadIni(bool &all_is_well);
        void startupProcessCmdLine();
        void startupInitMsgRouter();
        void startupGetComputerName();
        void startupConnectToDatabase(bool &all_is_well, TIBTransaction **created_transaction, TIBDataSet **created_dataset);
        void startupInitAtlas();
        void startupExecNewVersion(bool &all_is_well, bool launch_new, int local_ver_a, int local_ver_b, int local_ver_c, const string &exe_to_launch);
        void startupDownloadLookups(bool &all_is_well, TIBTransaction *dbTransaction, TIBDataSet *dbDataset);
        void startupInitCurrentTypes();
        void startupInitRemoteAdmin();
        void startupAtlasLookupTables();

        // jhaley 20110415: tray icon methods
        void __fastcall DrawItem(TMessage &Msg);
        void __fastcall MyNotify(TMessage &Msg);
        bool __fastcall TrayMessage(DWORD dwMessage);

        // Private Statics
        static void FilterListViewDeleted(classFilterObject *cfo);
public:		// User declarations
        __fastcall TformPrometheusMenu(TComponent* Owner);
        __fastcall ~TformPrometheusMenu(); // jhaley 20110119
        void AtlasLookupTables(int request_number, string matched_value);
        void GetValueHandler(int request_number, string matched_value);
        void EnableMenus(bool all_is_well);
        void DisplayNewReferralNotification(int request_number, string matched_value);
        void PreferencesChanged();
        string __fastcall GetDBOverrideSection();
        void ProcessIni(); // might get called externally?  maybe?  bah.

// jhaley 20110415: message map for tray icon support
BEGIN_MESSAGE_MAP
MESSAGE_HANDLER(WM_DRAWITEM,TMessage,DrawItem)
MESSAGE_HANDLER(MYWM_NOTIFY,TMessage,MyNotify)
END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TformPrometheusMenu *formPrometheusMenu;
//---------------------------------------------------------------------------
#endif
