//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codePrometheusSplash.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TformPrometheusSplash *formPrometheusSplash;
//---------------------------------------------------------------------------
__fastcall TformPrometheusSplash::TformPrometheusSplash(TComponent* Owner)
        : TForm(Owner)
{
 errorsyet = false;
}
//---------------------------------------------------------------------------
void TformPrometheusSplash::SplashSet (string p_section, string p_value)
{
 TColor newcolor;

 newcolor = clSilver;
 string message = "[unknown]";

 if (p_value == "ok")
 {
  newcolor = clLime;
  message = "[ok]";
 }
 if (p_value == "passed")
 {
  newcolor = clYellow;
  message = "[passed]";
 }
 if (p_value == "n/a")
 {
  newcolor = clSilver;
  message = "[skipped]";
 }
 if (p_value == "failed")
 {
  newcolor = clRed;
  message = "[failed]";
  if (!errorsyet)
   SplashSet ("notes", "Errors have occured, you should contact your systems administrator.");
  errorsyet = true;
 }

 TLabel * thelabel = NULL;

 if (p_section == "ini") thelabel = labelstatusIni;
 if (p_section == "messaging") thelabel = labelstatusMessaging;
 if (p_section == "db") thelabel = labelstatusDb;
 if (p_section == "version") thelabel = labelstatusVersion;
 if (p_section == "download") thelabel = labelstatusDownload;
 if (p_section == "switch") thelabel = labelstatusSwitchOver;
 if (p_section == "lookup") thelabel = labelstatusLookup;
 if (p_section == "login") thelabel = labelstatusLogin;
 if (p_section == "permissions") thelabel = labelstatusPermissions;
 if (p_section == "preferences") thelabel = labelstatusPreferences;

 if (thelabel)
 {
  thelabel->Caption = message.c_str();
  thelabel->Font->Color = newcolor;
  thelabel->Visible = true;
 }

 if (p_section == "notes")
 {
  labelNotes->Caption = labelNotes->Caption + "\n" + AnsiString(p_value.c_str());
  labelNotes->Visible = true;
 }
 this->Update();
}
//---------------------------------------------------------------------------
void TformPrometheusSplash::SplashShow (string p_section)
{
 if (p_section == "ini") labelIni->Visible = true;
 if (p_section == "messaging") labelMessaging->Visible = true;
 if (p_section == "db") labelDb->Visible = true;
 if (p_section == "version") labelVersion->Visible = true;
 if (p_section == "download") labelDownload->Visible = true;
 if (p_section == "switch") labelSwitchOver->Visible = true;
 if (p_section == "lookup") labelLookup->Visible = true;
 if (p_section == "login") labelLogin->Visible = true;
 if (p_section == "permissions") labelPermissions->Visible = true;
 if (p_section == "preferences") labelPreferences->Visible = true;
 if (p_section == "notes") labelNotes->Visible = true;
 this->Update();
}
//---------------------------------------------------------------------------
void __fastcall TformPrometheusSplash::FormClose(TObject *Sender,
      TCloseAction &Action)
{
 Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TformPrometheusSplash::labelCloseClick(TObject *Sender)
{
 if (allowclose)
  Visible = false;
 // Close();
}
//---------------------------------------------------------------------------
void TformPrometheusSplash::SplashReset ()
{
 labelIni->Visible = false;
 labelMessaging->Visible = false;
 labelDb->Visible = false;
 labelVersion->Visible = false;
 labelDownload->Visible = false;
 labelSwitchOver->Visible = false;
 labelLookup->Visible = false;
 labelLogin->Visible = false;
 labelPermissions->Visible = false;
 labelPreferences->Visible = false;
 labelNotes->Visible = false;
 labelstatusIni->Caption = "";
 labelstatusMessaging->Caption = "";
 labelstatusDb->Caption = "";
 labelstatusVersion->Caption = "";
 labelstatusDownload->Caption = "";
 labelstatusSwitchOver->Caption = "";
 labelstatusLookup->Caption = "";
 labelstatusLogin->Caption = "";
 labelstatusPermissions->Caption = "";
 labelstatusPreferences->Caption = "";
 labelNotes->Caption = ""; // duplicated error messages were getting annoying
 this->Update();
}
//---------------------------------------------------------------------------
/*HBRUSH CTransparentCtlDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
    HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

    if(nCtlColor == CTLCOLOR_STATIC)
    {
        hbr = (HBRUSH)::GetStockObject(HOLLOW_BRUSH);
        pDC->SetBkMode(TRANSPARENT);
    }

    return hbr;
}

*/
