//---------------------------------------------------------------------------

#ifndef codeRecordAccountH
#define codeRecordAccountH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <Mask.hpp>
#include <Menus.hpp>
#include <Buttons.hpp>

#include "codeSpecialTransactionSummary.h"

//---------------------------------------------------------------------------
class TformRecordAccount : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TToolButton *btnCreateFK;
        TToolButton *sepStandard3;
        TPageControl *pageAccount;
        TTabSheet *sheetRecord;
        TTabSheet *sheetTransactions;
        TPanel *panelGroup;
        TLabel *labelAccount;
        TLabel *labelType;
        TLabel *labelCycle;
        TLabel *labelDisplayAs;
        TLabel *labelNotes;
        TLabel *labelFund;
        TLabel *labelGL;
        TLabel *labelDept;
        TLabel *labelSubDepts;
        TEdit *editAccount;
        TComboBox *comboAccountType;
        TComboBox *comboOne;
        TComboBox *comboTwo;
        TComboBox *comboThree;
        TComboBox *comboFour;
        TCheckBox *checkBudget;
        TCheckBox *checkClosed;
        TCheckBox *checkYearly;
        TComboBox *comboCycle;
        TEdit *editName;
        TListView *listTransactions;
        TTabSheet *sheetAccounts;
        TListView *listAccounts;
        TLabel *labelAccounts;
        TLabel *labelTransactions;
        TStaticText *staticTransactionDetails;
        TTabSheet *sheetTotals;
        TPanel *panelGroupTotals;
        TLabel *labelDollarBalance;
        TLabel *labelDollarPending;
        TLabel *labelDollarCash;
        TLabel *labelDollarBudget;
        TLabel *labelDollarActual;
        TLabel *labelDollarRepay;
        TLabel *labelTotalBalance;
        TLabel *labelTotalPending;
        TLabel *labelTotalCash;
        TLabel *labelTotalBudget;
        TLabel *labelTotalActual;
        TLabel *labelTotalRepay;
        TLabel *labelDollarThis;
        TLabel *labelTotalThis;
        TLabel *labelThis;
        TLabel *labelTotalRemaining;
        TLabel *labelDollarRemaining;
        TLabel *labelExtraRemaining;
        TBitBtn *buttonSearchBalance;
        TBitBtn *buttonSearchPending;
        TBitBtn *buttonSearchCash;
        TBitBtn *buttonSearchBudget;
        TBitBtn *buttonSearchActual;
        TBitBtn *buttonSearchRepay;
        TLabel *labelMinimumFiscalDate;
        TEdit *editMinimumFiscalDate;
        TStaticText *staticBalance;
        TStaticText *staticPending;
        TStaticText *staticCash;
        TStaticText *staticBudget;
        TStaticText *staticActual;
        TStaticText *staticRepay;
        TBevel *bevelCallMeBetsy;
        TStaticText *labelBalance;
        TStaticText *labelPending;
        TStaticText *labelCash;
        TStaticText *labelBudget;
        TStaticText *labelActual;
        TStaticText *labelRepay;
        TStaticText *staticBudgetReport;
        TRichEdit *editDescription;
        TCheckBox *checkTransactionShowName;
        void __fastcall editAccountChange(TObject *Sender);
        void __fastcall comboAnyChange(TObject *Sender);
        void __fastcall btnCreateFKClick(TObject *Sender);
        void __fastcall buttonSearchBalanceClick(TObject *Sender);
        void __fastcall buttonSearchPendingClick(TObject *Sender);
        void __fastcall buttonSearchCashClick(TObject *Sender);
        void __fastcall buttonSearchBudgetClick(TObject *Sender);
        void __fastcall buttonSearchActualClick(TObject *Sender);
        void __fastcall buttonSearchRepayClick(TObject *Sender);
        void __fastcall checkBudgetClick(TObject *Sender);
        void __fastcall comboAccountTypeChange(TObject *Sender);
        void __fastcall staticTransactionDetailsClick(TObject *Sender);
        void __fastcall staticBudgetReportClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall checkTransactionShowNameClick(TObject *Sender);
private:	// User declarations
        bool ready_for_drop_down_change;
        // map<string, string> new_ref_id;
        map<account_links, acc_info> new_ref_info;
        void SetupAccount (string fund, string gl, string dept, string sub_dept, string is_budget, TStaticText * link, string column_name);
        void RefreshLinkStatus ();
        string GetCurrentAccountBalance (string p_account_id);
        //classFilterObject transactions_filter;
        classFilterObject accounts_filter;
        //int transactions_request;
        int accounts_request;
        classTransactionSummarizer transactions_summary; // jhaley: use summary utility class
public:		// User declarations
        __fastcall TformRecordAccount(TComponent* Owner, map<string,string> p_parameters);
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();

        bool ScreenStart();
        bool ScreenStop();
        bool ScreenLock();
        bool ScreenUnlock();

        bool NotNewAnymore();
        bool IsNewAgain();
        void AtlasRefreshListView(int request_num, string matched_value);

        void EditTransaction();
        void EditAccount();
        static void Do(map<string, string> & p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordAccount *formRecordAccount;
//---------------------------------------------------------------------------
#endif
