//---------------------------------------------------------------------------
/* TODO -c TABORDER: in order for the taborder to be correct, since the Description richedit is directly on the main form
(so it can still be scrollable with the form locked), two panels should be made...the stuff above and the stuff below
the richedit, so taborder can still be set properly... */
#include <vcl.h>
#pragma hdrstop

#include "codeRecordAppointment.h"
#include "codeSpecialSelectGroups.h"
#include "codeSearchPerson.h"
#include "codeSearchTaxEntity.h"
#include "codeRecordTaskDiab.h"
#include "codeRecordTaskBeh.h"
#include "codeRecordComVisit.h"
#include "codeRecordTaskLac.h"
#include "codeRecordAppointment.h"
#include "codeRecordTaskDen.h"
#include "codeRecordTaskTrans.h"
#include "reportDiabAppointmentLetter.h"
#include "codeSpecialAppointmentOccurrences.h"
#include "launchPatientDemographicsReport.h"
#include "codeSpecialDisambiguate.h" // for Disambiguation
#include "codeWizardNewPerson.h"
#include "codePrometheus.h" // for DefaultAction
#include "derivedheaders.h" //
#include "codeSpecialPersonNotesSummary.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma link "codeRubberContainer"
#pragma link "codeHalfButton"
#pragma link "codePaddedBox"
#pragma resource "*.dfm"
TformRecordAppointment *formRecordAppointment;
//---------------------------------------------------------------------------
__fastcall TformRecordAppointment::TformRecordAppointment(TComponent* Owner, map<string,string> p_parameters, set<string> *p_imported_viewers)
        : TformRecordGeneric(Owner, p_parameters, string("appointments"))
{
  txtLetter->Font->Color = link_color;
  txtCancelAppointment->Font->Color = link_color;
  txtRescheduleAppointment->Font->Color = link_color;
  txtDemographics->Font->Color = link_color;
  staticListOccur->Font->Color = link_color;
  //staticAddUsersFromGroups->Font->Color = link_color;

  user_filter.SetListViewHandle(listViewableUsers);
  user_filter.SetSecurity("appointments");
  user_filter.AddColumnSpec("User", "appointments", as_text, true, 180);
  user_filter.AddColumnSpec("Dept", "appointments", as_text, false, 90);
  user_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  user_filter.AddColumnSpec("Is Linked", "~", as_int, false, 80);
  user_filter.FetchPreferences("recordappointment.viewers_filter");
  user_filter.SetCheck(true);
  user_filter.SetCompress(true);
  user_filter.SetSQLStatement("");
  user_filter.SetCheck(this, CheckRecord(&(TformRecordAppointment::CheckUser)));
  user_filter.SetCheckLocked(true);
  user_filter.SetHideUnchecked(true);
  user_filter.RefreshDataSet();

  editDescription->Text = "";
  // setup the repeating drop downs, etc.
  comboRepeat_d->ItemIndex = 0;
  comboRepeat_w->ItemIndex = 0;
  comboRepeat_m->ItemIndex = 0;
  comboRepeat_y->ItemIndex = 0;
  editSpecific_d->Text = "";
  editSpecific_w->Text = "";
  editSpecific_m->Text = "";
  editSpecific_y->Text = "";
  comboMatch_d->ItemIndex = 0;
  comboMatch_w->ItemIndex = 0;
  comboMatch_m->ItemIndex = 0;
  comboMatch_y->ItemIndex = 0;

  pagesDates->ActivePage = 0;
  radioDateClick(NULL);
  pagesGroups->ActivePage = 0;
  radioViewUsersClick(NULL);

  num_blocks_overridden = 0;

  // jhaley 20110113: remember viewers imported from a rescheduled appointment
  if (p_imported_viewers)
  {
    importing_viewers = true;
    imported_viewers = *p_imported_viewers;
  }
  else
    importing_viewers = false;

  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordAppointment::ScreenStart()
{
  set<string> allowed_groups = GetGroupPermissions("table.appointments", "", "insert", "true");
  string groups_sql = "select groups.id, groups.item, groups.valid from groups where " + SafeInClause("id", SetToVec(allowed_groups)) + " order by groups.item";
  EditSql(this, &groups_sql);
  lookupTables->RegisterComboBox("groups", cboDepartment, groups_sql);
  /* this sql isn't entirely useless, so I'll leave it in a comment:  get all groups that are valid AND have at least one valid user:
  //"select groups.id, groups.item, 1 valid from groups inner join users on users.group_id = groups.id where groups.id > 0 and groups.valid = 1 and users.valid = 1 group by 1, 2, 3");
  */
  lookupTables->RegisterComboBox("visit_outcome_types", cboOutcome);
  lookupTables->RegisterComboBox("duration_types", cboSimpleDuration);
  lookupTables->RegisterComboBox("duration_types", cboAdvancedDuration);

  // must set a group first
  cboReason->Enabled = false;
  cboLocation->Enabled = false;

  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordAppointment::ScreenStop()
{
  // unregister combo box
  lookupTables->UnregisterComboBox("users", cboUser);
  lookupTables->UnregisterComboBox("groups", cboDepartment);
  lookupTables->UnregisterComboBox("visit_outcome_types", cboOutcome);
  lookupTables->UnregisterComboBox("duration_types", cboSimpleDuration);
  lookupTables->UnregisterComboBox("duration_types", cboAdvancedDuration);

  if (lookupTables->TableName(cboReason) != "") // if this cbo box is registered
    lookupTables->UnregisterComboBox("appt_reason_types", cboReason);

  if (lookupTables->TableName(cboLocation) != "") // if this cbo box is registered
    lookupTables->UnregisterComboBox("appt_location_types", cboLocation);

  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordAppointment::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record
  Pdate begin_date(initial_state["begin_date"], mdy | yyyy);
  Pdate end_date(initial_state["end_date"], mdy | yyyy);
  Pdate display_date(initial_state["display_date"], mdy | yyyy);
  Ptime appt_time(initial_state["appointment_time"], withsec | military);

  // jhaley: When displaying an existing appointment, the lookups below *must* be filled in or the controls will remain
  // blank until the record is unlocked, whereupon the values magically appear.

  string user_sql = "select id, item, 1 valid from users where (valid = 1 or is_role = 1) and id > 0 order by item";
  lookupTables->RegisterComboBox("users", cboUser, user_sql);

  if (!IsBlankOrZero(initial_state["group_id"]))
  {
    string group_to_use      = initial_state["group_id"];
    string addl_group_to_use = ""; // jhaley 20110216: allow an extra group so Shawnee Clinic can have its own items

    // Shawnee Clinic needs Little Axe Clinic lookups as well
    if (group_to_use == lookupTables->IdOf("groups", "Shawnee Clinic"))
      addl_group_to_use = ", " + lookupTables->IdOf("groups", "Little Axe Clinic");

    string custom_location_sql = "select id, item, valid from appt_location_types where group_id in (0, "
                                 + group_to_use + addl_group_to_use + ") and valid = 1 order by item ";
    string custom_reason_sql   = "select id, item, valid from appt_reason_types where group_id in (0, "
                                 + group_to_use + addl_group_to_use + ") and valid = 1 order by item ";

    lookupTables->RegisterComboBox("appt_location_types", cboLocation, custom_location_sql);
    cboLocation->Enabled = true;
    lookupTables->RegisterComboBox("appt_reason_types",   cboReason,   custom_reason_sql);
    cboReason->Enabled = true;

    cboLocation->Text = lookupTables->ValueOf("appt_location_types", initial_state["appt_location_id"], cboLocation).c_str();
    cboReason->Text   = lookupTables->ValueOf("appt_reason_types",   initial_state["appt_reason_id"],   cboReason).c_str();
  }

  // jhaley 20110106: must remember initial state of group_id in a mutable form, and ***before*** trying to set cboDepartment below.
  prev_group_id = initial_state["group_id"];

  // jhaley 20101025: We don't put an invalid value in the box only to gripe about it later.
  if (IsBlankOrZero(initial_state["group_id"])) // no initial group_id? *try* current_groupname...
  {
    cboDepartment->Text = PGlobals->current_groupname.c_str();
    if (!lookupTables->IsInLookUpTable("groups", cboDepartment)) // in order for custom SQL to kick in, the value must be put into the box first.
      cboDepartment->Text = ""; // Can't do it, sorry.
  }
  else // have an initial_state["group_id"] - it ought to be valid already.
    cboDepartment->Text = lookupTables->ValueOf("groups", initial_state["group_id"]).c_str();

  cboDepartmentChange(NULL);

  if((initial_state["task_id"] == "") || (initial_state["task_id"] == "0"))
    is_cob_appointment = false;
  else
    is_cob_appointment = GetOneField(dbDatabase, "select group_id from tasks where id = '" + initial_state["task_id"] + "'") == lookupTables->IdOf("groups", "Contract Health");

  if((! is_new_record) &&
    ((optionsPermissions["special.diab.general"]["enabled"] == "true") ||
     (optionsPermissions["special.den.general"]["enabled"] == "true") ||
     (optionsPermissions["special.lac.general"]["enabled"] == "true") ||
     (optionsPermissions["special.sc.general"]["enabled"] == "true") ||
     (optionsPermissions["special.mis.general"]["enabled"] == "true")))
    txtLetter->Enabled = true;
  else
    txtLetter->Enabled = false;

  dateSingle->Date = Now();
  dateRepeating->Date = Now();
  dateEnding->Date = Now();
  if(initial_state["appointment_time"] == "")
  {
    timeSingle->Time = StrToTime("08:00:00");
    timeRepeating->Time = StrToTime("08:00:00");
  }
  else
  {
    timeSingle->Time = appt_time.OutTime();
    timeRepeating->Time = appt_time.OutTime();
  }
  check24Hours->Checked = initial_state["within_24_hours"] == "1";
  checkNewClient->Checked = initial_state["new_client"] == "1";
  //editNewClientName->Text = initial_state["new_client_name"].c_str();
  editDescription->Text = SentenceString(initial_state["description"]).c_str();
  cboOutcome->Text = PrettyString(lookupTables->ValueOf("visit_outcome_types", initial_state["visit_outcome_id"])).c_str();

  // jhaley: Here are the two reasons we need cboUser registered from the get-go:
  if (initial_state["created_for"] != "")
    cboUser->Text = PrettyString(lookupTables->ValueOf("users", initial_state["created_for"], cboUser)).c_str();
  else
    cboUser->Text = PrettyString(lookupTables->ValueOf("users", current_userid, cboUser)).c_str();
  if (initial_state["created_by"] != "")
    lblUser->Caption = PrettyString(lookupTables->ValueOf("users", initial_state["created_by"], cboUser)).c_str();
  else
    lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid, cboUser)).c_str();

  if (initial_state["display_date"] != "")
  {
    dateSingle->Date = display_date.OutDate();
    dateRepeating->Date = display_date.OutDate();
  }

  if (initial_state["repeating_string"] != "")
  {
    if (initial_state["single_date"] == "1")
    {
      radioSingle->Checked = true;
      //radioRepeating->Checked = false;
      if (initial_state["appointment_time"] != "")
      {
        timeSingle->Time = appt_time.OutTime();
      }
      dateSingle->Date = begin_date.OutDate();
      editSimpleDuration->Text = initial_state["duration"].c_str();
      cboSimpleDuration->Text = PrettyString(lookupTables->ValueOf("duration_types", initial_state["duration_id"])).c_str();
    }
    else if (initial_state["single_date"] == "0")
    {
      //radioSingle->Checked = false;
      radioRepeating->Checked = true;
      radioDateClick(NULL);
      string serialized = initial_state["repeating_string"].c_str();
      repeat_spec<int> match_this;
      match_this.Load(serialized, begin_date, end_date);

      comboRepeat_d->ItemIndex = (int)match_this.Day().Repeats();
      comboRepeat_w->ItemIndex = (int)match_this.Week().Repeats();
      comboRepeat_m->ItemIndex = (int)match_this.Month().Repeats();
      comboRepeat_y->ItemIndex = (int)match_this.Year().Repeats();

      editSpecific_d->Text = IntToString(match_this.Day().Specific()).c_str();
      editSpecific_w->Text = IntToString(match_this.Week().Specific()).c_str();
      editSpecific_m->Text = IntToString(match_this.Month().Specific()).c_str();
      editSpecific_y->Text = IntToString(match_this.Year().Specific()).c_str();

      comboMatch_d->ItemIndex = (int)match_this.Day().Matching();
      comboMatch_w->ItemIndex = (int)match_this.Week().Matching();
      comboMatch_m->ItemIndex = (int)match_this.Month().Matching();
      comboMatch_y->ItemIndex = (int)match_this.Year().Matching();

      if (match_this.Start().IsValidDate())
        dateRepeating->Date = StrToDate(match_this.Start().OutDate(mdy | yyyy).c_str());
      if (match_this.Stop().IsValidDate())
        dateEnding->Date = StrToDate(match_this.Stop().OutDate(mdy | yyyy).c_str());
      if (initial_state["appointment_time"] != "")
      {
        timeRepeating->Time = appt_time.OutTime();
      }
      editAdvancedDuration->Text = initial_state["duration"].c_str();
      cboAdvancedDuration->Text = PrettyString(lookupTables->ValueOf("duration_types", initial_state["duration_id"])).c_str();
    }
  }

  txtTask->OnClick = NULL;
  if(IsBlankOrZero(initial_state["task_id"]))
    txtTask->OnClick = taskClick;

  CreateLink(txtClient, btnPersonSearch, this, initial_state["person_id"], "people");
  CreateLink(txtTask, NULL, this, initial_state["task_id"], "tasks");
  if((initial_state["tax_entity_id"] == ""))
    initial_state["tax_entity_id"] = GetOneField(dbDatabase, "select appointment_provider_id from groups where id = " + current_groupid);
  CreateLink(txtProvider, btnProviderSearch, this, initial_state["tax_entity_id"], "tax_entities");

  TformRecordGeneric::PutDataOnScreen();
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::radioDateClick(TObject *Sender)
{
  if (radioSingle->Checked)
  {
    sheetSimpleDate->Show();
    pagesDates->Height = 105; // TODO -c MAGIC_NUMBER
  }
  else if (radioRepeating->Checked)
  {
    sheetAdvancedDate->Show();
    pagesDates->Height = 217; // TODO -c MAGIC_NUMBER
  }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::radioViewUsersClick(TObject *Sender)
{
  if (radioViewUsers->Checked) sheetViewableUsers->Show();
  if (radioViewUsersAndGroups->Checked) sheetViewableUsersAndGroups->Show();
}
//---------------------------------------------------------------------------
bool TformRecordAppointment::ScreenLock()
{
  user_filter.SetCheckLocked(true);
  user_filter.SetHideUnchecked(true);
  //user_filter.RefreshDataSet();

  panelSimpleTop->Enabled = false;
  panelSimpleDate->Enabled = false;
  panelAdvancedDate->Enabled = false;
  editDescription->ReadOnly = true;
  editDescription->TabStop = false;
  if((optionsPermissions["special.diab.general"]["enabled"] == "true") ||
     (optionsPermissions["special.den.general"]["enabled"] == "true") ||
     (optionsPermissions["special.lac.general"]["enabled"] == "true") ||
     (optionsPermissions["special.sc.general"]["enabled"] == "true") ||
     (optionsPermissions["special.beh.general"]["enabled"] == "true") ||
     (optionsPermissions["special.mis.general"]["enabled"] == "true"))
    txtLetter->Enabled = true;
  else
    txtLetter->Enabled = false;
  //staticAddUsersFromGroups->Enabled = false;
  listViewableUsers->PopupMenu = NULL;

  string task_id = GetValidLinkId(txtTask);
  if(IsBlankOrZero(task_id))
    txtTask->OnClick = taskClick;

  // jhaley 20100922: Enable cancel and reschedule links, if appropriate:
  // * Must be viewing an existing record, not creating a new one
  // * No task should be attached
  // * No visit outcome should have been determined
  // * The current_id should be 'Current' or 'Primary'
  if (!is_new_record && IsBlankOrZero(task_id) && IsBlankOrZero(initial_state["visit_outcome_id"]) &&
      (initial_state["current_id"] == lookupTables->IdOf("current_types", "Current") ||
       initial_state["current_id"] == lookupTables->IdOf("current_types", "Primary")))
  {
    txtCancelAppointment->Enabled = true;
    txtRescheduleAppointment->Enabled = true;
  }
  else
  {
    txtCancelAppointment->Enabled = false;
    txtRescheduleAppointment->Enabled = false;
  }

  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordAppointment::ScreenUnlock()
{
  user_filter.SetCheckLocked(false);
  user_filter.SetHideUnchecked(false);
  //user_filter.RefreshDataSet();

  panelSimpleTop->Enabled = true;
  panelSimpleDate->Enabled = true;
  panelAdvancedDate->Enabled = true;
  editDescription->ReadOnly = false;
  editDescription->TabStop = true;
  txtLetter->Enabled = false;
  //staticAddUsersFromGroups->Enabled = true;
  listViewableUsers->PopupMenu = popupGroups;

  // jhaley 20100922: Enable cancel and reschedule links, if appropriate:
  // * Must be viewing an existing record, not creating a new one
  // * No task should be attached
  // * No visit outcome should have been determined
  // * The current_id should be 'Current' or 'Primary'
  string task_id = GetValidLinkId(txtTask);
  if (!is_new_record && IsBlankOrZero(task_id) && IsBlankOrZero(initial_state["visit_outcome_id"]) &&
      (initial_state["current_id"] == lookupTables->IdOf("current_types", "Current") ||
       initial_state["current_id"] == lookupTables->IdOf("current_types", "Primary")))
  {
    txtCancelAppointment->Enabled = true;
    txtRescheduleAppointment->Enabled = true;
  }
  else
  {
    txtCancelAppointment->Enabled = false;
    txtRescheduleAppointment->Enabled = false;
  }

  cboDepartmentChange(NULL);
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordAppointment::IsNewAgain()
{
  user_filter.SetSQLStatement("select users.item, groups.item, users.id, 0 from users left join groups on groups.id = users.group_id where users.valid = 1 and users.id > 0");
  user_filter.RefreshDataSet();
  user_filter.SetAddEdit(this, NULL, NULL);

  // jhaley 20110113: If we have imported viewers from another appointment, now is the time to populate the user filter with them.
  //        20111214: be smarter
  if(importing_viewers)
  {
    user_filter.SetCheckedWhereNotID(imported_viewers, false);
    user_filter.SetCheckedWhereID(imported_viewers, true);
  }

  prev_group_id = ""; // jhaley: clear previously remembered group_id value

  TformRecordGeneric::IsNewAgain();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordAppointment::NotNewAnymore()
{
  user_filter.SetSQLStatement("select users.item, groups.item, users.id, case when appointment_viewers.user_id is not null then 1 else 0 end "
                              "from users "
                              "left join groups on groups.id = users.group_id "
                              "left join appointment_viewers on appointment_viewers.user_id = users.id and appointment_viewers.appointment_id = '" + initial_state["id"] + "' "
                              "where users.valid = 1 and users.id > 0");
  user_filter.RefreshDataSet();
  user_request = atlas->RequestNotificationWhen("users.id", "", rel_any, as_int, this, RefreshHandler(&(TformRecordAppointment::AtlasRefresh)));
  txtDemographics->Enabled = true;

  TformRecordGeneric::NotNewAnymore();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordAppointment::GetDataFromScreen()
{
  if (lookupTables->TableName(cboLocation) != "") // if this cbo box is registered
    ending_state["appt_location_id"] = lookupTables->IdOf("appt_location_types", cboLocation);
  else
    ending_state["appt_location_id"] = IntToString(0);

  if (lookupTables->TableName(cboReason) != "") // if this cbo box is registered
    ending_state["appt_reason_id"] = lookupTables->IdOf("appt_reason_types", cboReason);
  else
    ending_state["appt_reason_id"] = IntToString(0);

  if (cboOutcome->Text == "Walk-In")
    check24Hours->Checked = true;

  ending_state["within_24_hours"] = (check24Hours->Checked ? "1" : "0");
  ending_state["new_client"] = (checkNewClient->Checked ? "1" : "0");
  //ending_state["new_client_name"] = (checkNewClient->Checked ? string(editNewClientName->Text.c_str()) : string(""));

  ending_state["description"] = editDescription->Text.c_str();
  if (cboUser->Text != "")
    ending_state["created_for"] = lookupTables->IdOf("users", cboUser);
  else
    ending_state["created_for"] = current_userid;
  if (initial_state["created_by"] == "")
    ending_state["created_by"] = current_userid;
  else
    ending_state["created_by"] = initial_state["created_by"];
  string person_id = GetValidLinkId(txtClient);
  if(StringToInt(person_id) > 0)
    ending_state["person_id"] = person_id;
  else
    ending_state["person_id"] = "0";
  ending_state["visit_outcome_id"] = lookupTables->IdOf("visit_outcome_types", cboOutcome->Text.c_str());
  //ending_state["group_id"] = initial_state["group_id"];

  // jhaley 20101025: (DONE: This is ***NOT*** being done on the new form that is awaiting merger with the CVS trunk!
  // I guess it needs to be verified that group settings work there as well, though as far as I can remember they were
  // working just fine when I tested it - yet how can that be if cboDepartment's value is never propagated to ending_state["group_id"] ???)
  ending_state["group_id"] = lookupTables->IdOf("groups", cboDepartment);

  // if we don't have a group_id, we need to get one.  Also, if the provider changes, we need to update the group_id also.
  //  jhaley 20101026: This is definitely wrong. While doing the above seems to fix updating, saving a NEW appointment is caught by
  //  this code incorrectly. If we want to do this, then we need to do it when the value of created_for is changed. Note that it can't
  //  be blank at this point because IsValidOnScreen already makes sure of that.
  /*
  if (IsBlankOrZero(ending_state["group_id"]) || initial_state["created_for"] != ending_state["created_for"])
   ending_state["group_id"] = GetOneField(dbDatabase, "select group_id from users where id = '" + ending_state["created_for"] + "'");
  // still zero?  there are a couple of providers with no group id.  In that case, use created_by.
  if (IsBlankOrZero(ending_state["group_id"]))
   ending_state["group_id"] = GetOneField(dbDatabase, "select group_id from users where id = '" + ending_state["created_by"] + "'");
  */

  if (radioSingle->Checked)
  {
    ending_state["single_date"] = "1";
    ending_state["duration"] = editSimpleDuration->Text.c_str();
    ending_state["duration_id"] = lookupTables->IdOf("duration_types", cboSimpleDuration->Text.c_str());
    ending_state["appointment_time"] = Ptime (timeSingle->Time).OutTime(military | withsec);
    ending_state["repeating_string"] = "0,0,0|0,0,0|0,0,0|0,0,0";
    string appt_date = Pdate(dateSingle->Date).OutDate(mdy | yyyy);
    ending_state["begin_date"] = appt_date;
    ending_state["end_date"] = appt_date;
    int duration = StringToInt(ending_state["duration"]);
    string duration_type = LowercaseString(cboSimpleDuration->Text.c_str());
    Pstamp begin_stamp(appt_date + " " + ending_state["appointment_time"], mdy | yyyy | military | withsec | datefirst);
    Pstamp end_stamp = begin_stamp;
    if((duration > 0) && (duration_type != ""))
    {
      if(duration_type == "minutes")
        end_stamp.mod(duration, in_minutes);
      else if(duration_type == "hours")
        end_stamp.mod(duration, in_hours);
      else if(duration_type == "days")
        end_stamp.mod(duration, in_days);
      else if(duration_type == "weeks")
        end_stamp.mod(duration, in_weeks);
      else if(duration_type == "months")
        end_stamp.mod(duration, in_months);
      else if(duration_type == "years")
        end_stamp.mod(duration, in_years);
    }
    ending_state["final_end_stamp"] = end_stamp.OutStamp(mdy | yyyy | military | withsec | datefirst);
    ending_state["appointment_date"] = appt_date;

  }
  else
  {
    ending_state["single_date"] = "0";

    repeat_spec<int> match_this = GetRepeatSpec();
    ending_state["begin_date"] = match_this.Start().OutDate(mdy | yyyy);
    ending_state["end_date"] = match_this.Stop().OutDate(mdy | yyyy);
    string serialized = match_this.SaveWithoutDates();
    ending_state["repeating_string"] = serialized;
    ending_state["appointment_time"] = Ptime (timeRepeating->Time).OutTime(military | withsec);
    ending_state["duration"] = editAdvancedDuration->Text.c_str();
    ending_state["duration_id"] = lookupTables->IdOf("duration_types", cboAdvancedDuration->Text.c_str());
    int duration = StringToInt(ending_state["duration"]);
    string duration_type = LowercaseString(cboAdvancedDuration->Text.c_str());
    vector<Pdate> date_matches = match_this.AllMatches(date_range(match_this.Start(), match_this.Stop()));
    if(! date_matches.empty())
    {
      Pdate last_date = date_matches[date_matches.size()-1];
      Pstamp end_stamp(last_date.OutDate(mdy | yyyy) + " " + ending_state["appointment_time"], mdy | yyyy | military | withsec | datefirst);
      if((duration > 0) && (duration_type != ""))
      {
        if(duration_type == "minutes")
          end_stamp.mod(duration, in_minutes);
        else if(duration_type == "hours")
          end_stamp.mod(duration, in_hours);
        else if(duration_type == "days")
          end_stamp.mod(duration, in_days);
        else if(duration_type == "weeks")
          end_stamp.mod(duration, in_weeks);
        else if(duration_type == "months")
          end_stamp.mod(duration, in_months);
        else if(duration_type == "years")
          end_stamp.mod(duration, in_years);
      }
      ending_state["final_end_stamp"] = end_stamp.OutStamp(mdy | yyyy | military | withsec | datefirst);
    }
  }

  string tax_entity_id = GetValidLinkId(txtProvider);
  if(tax_entity_id == "")
    ending_state["tax_entity_id"] = "0";
  else
    ending_state["tax_entity_id"] = tax_entity_id;

  string task_id = GetValidLinkId(txtTask);
  if(task_id == "")
    ending_state["task_id"] = "0";
  else
    ending_state["task_id"] = task_id;

  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();

  importing_viewers = false; // jhaley 20111214: don't care about imported viewers any more, since resched. appt is saved.
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordAppointment::BeforeSave()
{
 AtlasClear();
 // appointment-viewers
 vector<string> previously_checked_ids;
 if (SqlToVec(lock_transaction, "select appointment_viewers.user_id from appointment_viewers where appointment_id = " + ending_state["id"], previously_checked_ids))
 {
  for (vector<string>::iterator i = previously_checked_ids.begin(); i != previously_checked_ids.end(); i++)
   AtlasAdd("appointment_viewers.user_id", *i);
  if (ExecuteStatement(lock_transaction, "delete from appointment_viewers where appointment_id = " + ending_state["id"]))
  {
   vector<string> t_checked_ids = user_filter.GetMultiID();
   set<string> checked_ids;
   VecToSet(t_checked_ids, checked_ids);
   // you can't not see something for you ...
   if (!IsBlankOrZero(ending_state["created_for"]))
     checked_ids.insert(ending_state["created_for"]);
   // jhaley 20110127: also, you can't *not* see something created *by* you.
   if (!IsBlankOrZero(ending_state["created_by"]))
     checked_ids.insert(ending_state["created_by"]);
   map<string, string> field_map;
   field_map["current_id"] = "4";
   field_map["last_update_stamp"] = RightNow();
   field_map["last_updated_by"] = current_userid;
   for (set<string>::iterator i = checked_ids.begin(); i != checked_ids.end(); i++)
   {
    field_map["id"] = GetNextId(lock_transaction, "appointment_viewers");
    field_map["user_id"] = *i;
    field_map["appointment_id"] = ending_state["id"];
    ExecuteInsertStatement(lock_transaction, "appointment_viewers", field_map);
    AtlasAdd("appointment_viewers", field_map);
   }
   AtlasAdd("appointments.created_for", ending_state["created_for"]);
   AtlasAdd("appointments.created_for", initial_state["created_for"]);
   return TformRecordGeneric::BeforeSave();
  } else
  {
   PSay("Failed to save changes to the list of users who can view this appointment [deletion phase]", m_database_error, MB_OK);
   return false;
  }
 } else
 {
  PSay("Failed to get the previous list of appointment viewers", m_database_error, MB_OK);
  return false;
 }
}
//---------------------------------------------------------------------------
bool TformRecordAppointment::AfterSave()
{
 AtlasSend();
 TformRecordGeneric::AfterSave();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordAppointment::IsValidOnScreen()
{
  if (editDescription->Text == "" && GetValidLinkId(txtClient) == "")
  {
    PSay("Please enter a description", m_missing_data, MB_OK);
    editDescription->SetFocus();
    return false;
  }
  else if (cboDepartment->Text == "" || !lookupTables->IsInLookUpTable("groups", cboDepartment))
  {
    PSay("Please select a department", m_invalid_data, MB_OK);
    cboDepartment->SetFocus();
    return false;
  }
/* // this made sense when group was implicit, but now it is in the way.
  else if (!HasLocationPermissions(GetSpecialGroupPermissions("general"), cboDepartment->Text.c_str()))
  {
    PSay("You don't have permission to create or edit " + string(cboDepartment->Text.c_str()) + " appointments.", m_invalid_data, MB_OK);
    cboDepartment->SetFocus();
    return false;
  }
*/
  else if (cboLocation->Text != "" && !lookupTables->IsInLookUpTable("appt_location_types", cboLocation))
  {
    PSay("Please enter a valid location for " + string(cboDepartment->Text.c_str()), m_invalid_data, MB_OK);
    cboLocation->SetFocus();
    return false;
  }
  else if (cboReason->Text != "" && !lookupTables->IsInLookUpTable("appt_reason_types", cboReason))
  {
    PSay("Please enter a valid reason for " + string(cboDepartment->Text.c_str()), m_invalid_data, MB_OK);
    cboReason->SetFocus();
    return false;
  }
  else if (!lookupTables->IsInLookUpTable("visit_outcome_types", cboOutcome))
  {
    PSay("Please enter a valid outcome", m_invalid_data, MB_OK);
    cboOutcome->SetFocus();
    return false;
  }
  else if (!lookupTables->IsInLookUpTable("users", cboUser) && !is_cob_appointment)
  {
    PSay("Please enter a valid employee", m_invalid_data, MB_OK);
    cboUser->SetFocus();
    return false;
  }

  if (radioSingle->Checked)
  {
    if (! IsInt(editSimpleDuration->Text.c_str()))
    {
      PSay("Please enter a valid number with no decimal places for duration", m_invalid_data, MB_OK);
      editSimpleDuration->SetFocus();
      return false;
    }
    else if (! lookupTables->IsInLookUpTable("duration_types", cboSimpleDuration->Text.c_str()))
    {
      PSay("Please enter a valid type of duration", m_invalid_data, MB_OK);
      cboSimpleDuration->SetFocus();
      return false;
    }
  }
  else if (radioRepeating->Checked)
  {
    if (! IsInt(editSimpleDuration->Text.c_str()))
    {
      PSay("Please enter a valid number with no decimal places for duration", m_invalid_data, MB_OK);
      editAdvancedDuration->SetFocus();
      return false;
    }
    else if (! lookupTables->IsInLookUpTable("duration_types", cboSimpleDuration->Text.c_str()))
    {
      PSay("Please enter a valid type of duration", m_invalid_data, MB_OK);
      cboAdvancedDuration->SetFocus();
      return false;
    }
    else
    {
      repeat_spec<int> match_this  = GetRepeatSpec();
      vector<Pdate> temp_vec = match_this.AllMatches(date_range(match_this.Start(), match_this.Stop()));
      if(temp_vec.empty())
      {
        PSay("This repeating appointment will never happen. Please review the way you entered the appointment", m_warning, MB_OK);
        comboRepeat_d->SetFocus();
        return false;
      }
      // jhaley 20110106: no early return here.
    }
  }

  // begin il-logic testing
  /* I don't think we want to require a person to be attached, do we?  If they no-show, we don't want those garbage person records....
  if (checkNewClient->Checked &&
  //editNewClientName->Text == ""
  IsBlankOrZero(initial_state["person_id"]))
  {
    PSay("You must enter information for this new patient.", m_warning, MB_OK);
    //editNewClientName->SetFocus();
    //checkNewClientClick();
  }
  else
  */

  // jhaley 20110106: This must not be else'd with the above conditions, as they don't always return if taken
  string person_id = GetValidLinkId(txtClient);
  if ((cboOutcome->Text == "As Scheduled" || cboOutcome->Text == "Walk-In" || cboOutcome->Text == "Arrived Late")
      && IsBlankOrZero(person_id))
  {
    string error = "An appointment marked As Scheduled, Walk-In, or Arrived Late must have a person associated with it.";
    if (checkNewClient->Checked)
      error += "\n\nSince this is a new patient for your department, you may need to create the person, but search first!"
               "  They may already be in the system as a client of another department.";
    PSay(error, m_warning, MB_OK);
    btnPersonSearchClick(NULL);
    return false; // jhaley 20110106: missing
  }

  // jhaley 20101230: Check for blocks; we won't allow saving a new appointment for a person with blocks unless the user
  // has block override permissions.
  if (is_new_record && !IsBlankOrZero(person_id))
  {
    int numblocks = 0, numwarnings = 0;
    string group_id  = lookupTables->IdOf("groups", cboDepartment);
    GetBlocksAndWarnings(numblocks, numwarnings, group_id, person_id);
    if ((numblocks - num_blocks_overridden) > 0)
    {
      if (optionsPermissions["special.note_block_override"]["enabled"] != "true")
        BlockOverrideErrorMessage(); // Standard "You cannot override block notes..." message.
      else
        PSay("You need to review and override blocks for this client first. Click on the yellow bar above to see his/her blocks.", m_reminder, MB_OK);
      return false;
    }
  }

  // jhaley 20110608: Optometric appointments need a warning to be given on saving an appointment with an optometric
  // reason for visit when the person is over the CHS limit of $350.00 on Vision benefits for the year.
  if (is_new_record && !IsBlankOrZero(person_id) && cboReason->Text != "")
  {
    string appt_service_id_sql =
      "select ART.appt_service_id from appt_reason_types ART where ART.id = "
      + lookupTables->IdOf("appt_reason_types", cboReason);
    string appt_service_id = GetOneField(dbDatabase, appt_service_id_sql);

    // appt_service_types tells us if an appt_reason_type is potentially Optometric
    if (appt_service_id == lookupTables->IdOf("appt_service_types", "Optometry"))
    {
      string chs_vision_benefits_sql =
        "select sum(transactions.debit_amount - transactions.credit_amount) amount, max(visit_tasks.date_of_task) maxdate "
        "from visit_tasks "
        "inner join cob_tasks on visit_tasks.parent_task_id = cob_tasks.id "
        "inner join services_provided on cob_tasks.services_provided_id = services_provided.id "
        " and services_provided.area_id = " + lookupTables->IdOf("area_types", "Vision") + " "
        "inner join bills on bills.task_id = visit_tasks.id "
        "inner join transactions on transactions.bill_id = bills.id "
        "inner join accounts on accounts.id = transactions.account_id and accounts.account_type_id = "
        + lookupTables->IdOf("account_types", "Expense") + " "
        "where visit_tasks.person_id = " + person_id + " and visit_tasks.parent_task_id > 0 and "
        "extract(year from current_date) - extract(year from visit_tasks.date_of_task) <= 1 ";

      pmapstrs chs_vision_costs;
      SqlToMap(dbDatabase, chs_vision_benefits_sql, chs_vision_costs);

      float amt  = StringToFloat(chs_vision_costs["amount"]);
      Pdate date = Pdate(chs_vision_costs["maxdate"], mdy|yyyy);

      if (amt >= 350.0) // TODO -c MAGIC: hardcoded annual CHS VISION expense limit
      {
        string msg =
          "This client has exceeded their annual Contract Health expenditure limit of $350.00 for Vision benefits "
          "as of " + date.OutDate(mdy|yyyy) + ".\n\n"
          "Are you sure you want to schedule this Optometric appointment?";

        int res = PSay(msg, m_warning, MB_YESNO);
        if (res == IDYES)
        {
          PSay("Please inform the patient at this time that no products (frames, lenses, contact lenses, etc.) will "
               "be dispensed in the course of this visit.", m_reminder, MB_OK);
        }
        else
          return false; // Canceled saving
      }
    }
  }

  // jhaley 20110711: 'Block Schedule' reason support. A 'Block Schedule' appointment exists to block off a portion of
  // a provider's schedule and is not a "real" appointment on which reporting should be done (except if considering
  // scheduler workload I suppose). Block Schedule appointments have the following restrictions:
  // * Must not have a person attached
  // * Outcome must be unspecified, rescheduled, or cancelled (these are allowed to allow changing the block)
  string block_reason_id = lookupTables->IdOf("appt_reason_types", "Block Schedule");
  if(lookupTables->IdOf("appt_reason_types", cboReason) == block_reason_id)
  {
    if(!IsBlankOrZero(person_id))
    {
      PSay("A 'Block Schedule' appointment should not have a client attached. Please either clear the Person link, or "
           "change the appointment reason to a client-applicable reason for visit.", m_invalid_data, MB_OK);
      btnPersonSearch->SetFocus();
      return false;
    }
    string outcome_id = lookupTables->IdOf("visit_outcome_types", cboOutcome);
    if(!IsBlankOrZero(outcome_id) &&                                             // Allowed: Blank,
       outcome_id != lookupTables->IdOf("visit_outcome_types", "Rescheduled") && //   Rescheduled,
       outcome_id != lookupTables->IdOf("visit_outcome_types", "Cancelled"))     //   Cancelled.
    {
      PSay("A 'Block Schedule' appointment should not have an outcome other than blank, Rescheduled, or Cancelled. "
           "Please change the Outcome value, or use a different appointment reason if this appointment is not meant "
           "to block scheduling.", m_invalid_data, MB_OK);
      cboOutcome->SetFocus();
      return false;
    }
  }

  // anything else?  probably...

  return true;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::comboRepeat_dChange(TObject *Sender)
{
 switch (comboRepeat_d->ItemIndex)
 {
  case 0: comboMatch_d->ItemIndex = 0;
  case 3:
  case 4: editSpecific_d->Text = ""; break;
  case 1:
  case 2: editSpecific_d->Text = "1"; break;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::comboRepeat_wChange(TObject *Sender)
{
 // same as above about Any/first, etc.
 switch (comboRepeat_w->ItemIndex)
 {
  case 0: comboMatch_w->ItemIndex = 0;
  case 3:
  case 4: editSpecific_w->Text = ""; break;
  case 1:
  case 2: editSpecific_w->Text = "1"; break;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::comboRepeat_mChange(TObject *Sender)
{
 // more of the same...
 switch (comboRepeat_m->ItemIndex)
 {
  case 0: comboMatch_m->ItemIndex = 0;
  case 3:
  case 4: editSpecific_m->Text = ""; break;
  case 1:
  case 2: editSpecific_m->Text = "1"; break;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::comboRepeat_yChange(TObject *Sender)
{
 // boring...
 switch (comboRepeat_y->ItemIndex)
 {
  case 0: comboMatch_y->ItemIndex = 0;
  case 3:
  case 4: editSpecific_y->Text = ""; break;
  case 1:
  case 2: editSpecific_y->Text = "1"; break;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::btnPersonSearchClick(TObject *Sender)
{
  string orig_person_id = GetValidLinkId(txtClient);

  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * personSearch = new TformSearchPerson(NULL,&return_vector);
    /*
    if (checkNewClient->Checked)
    { // be a pal and help them out.  their poor, tired fingers.
      string full_name = editNewClientName->Text.c_str();
      int first_space = full_name.find_first_of(" ");
      personSearch->editFirstName->Text = full_name.substr(0, first_space).c_str();
      personSearch->editLastName->Text = full_name.substr(first_space + 1, full_name.length() - first_space).c_str();
    }
    */
    personSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
  {
    CreateLink(txtClient, btnPersonSearch, this, return_vector[0], "people");

    // update notes status if client and department are both valid, and client has actually changed
    string new_person_id = GetValidLinkId(txtClient);
    if (new_person_id != "" && orig_person_id != new_person_id &&
        cboDepartment->Text != "" && lookupTables->IsInLookUpTable("groups", cboDepartment))
    {
      num_blocks_overridden = 0; // person has changed, overrides no longer apply.
      UpdateNotesStatus(lookupTables->IdOf("groups", cboDepartment), GetValidLinkId(txtClient));
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::btnAddProviderClick(TObject *Sender)
{
  if(lookupTables->IsInLookUpTable("users", cboUser))
  {
    string tax_entity_id = GetOneField(dbDatabase, "select tax_entity_id from users where id = "
                           + lookupTables->IdOf("users", cboUser));
    if (tax_entity_id != "")
      CreateLink(txtProvider, btnProviderSearch, this, tax_entity_id, "tax_entities");
  }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::btnProviderSearchClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchTaxEntity * providerSearch = new TformSearchTaxEntity(NULL,&return_vector);
    providerSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtProvider, btnProviderSearch, this, return_vector[0], "tax_entities");
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::taskClick(TObject *Sender)
{
  string person_id = GetValidLinkId(txtClient);
  string group_name  = cboDepartment->Text.c_str();
  if (person_id == "")
  {
    PSay("You must select the person for whom this appointment was scheduled.  Select a person, then you can create a task/visit.", m_missing_data, MB_OK);
    return;
  }
  if (group_name == "") // jhaley: verify valid group
  {
    PSay("Please select a department for this appointment. You can then create a task/visit.", m_missing_data, MB_OK);
    return;
  }
  if (!HasLocationPermissions(GetGroupPermissions("table.tasks", "", "insert", "true"), cboDepartment->Text.c_str()))
  {
    PSay("You don't have permission to create or edit " + string(cboDepartment->Text.c_str()) + " tasks/visits.", m_warning, MB_OK);
    return;
  }
  else
  {
    map<string, string> field_map;
    field_map["id"] = "new";
    field_map["appointment_id"] = initial_state["id"];
    field_map["person_id"] = person_id;
    int duration;
    string duration_type;
    if(radioSingle->Checked)
    {
      field_map["date_of_task"] = DateToStr(dateSingle->Date).c_str();
      field_map["time_of_task"] = TimeToStr(timeSingle->Time).c_str();
      duration = StringToInt(string(editSimpleDuration->Text.c_str()));
      duration_type = LowercaseString(cboSimpleDuration->Text.c_str());
    }
    else if(radioRepeating->Checked)
    {
      field_map["time_of_task"] = TimeToStr(timeRepeating->Time).c_str();
      duration = StringToInt(string(editAdvancedDuration->Text.c_str()));
      duration_type = LowercaseString(cboAdvancedDuration->Text.c_str());
    }

    float duration_in_minutes;
    if((duration > 0) && (duration_type != ""))
    {  // we want the dental duration in hours.
      if(duration_type == "minutes")
        duration_in_minutes = duration;
      else if(duration_type == "hours")
        duration_in_minutes = duration * 60;
      else if(duration_type == "days")
        duration_in_minutes = duration * 60 * 24;
      else if(duration_type == "weeks")
        duration_in_minutes = duration * 60 * 24 * 7; // seven days or five in a week?
      else if(duration_type == "months")
        duration_in_minutes = 0;                      // not even going to guess
      else if(duration_type == "years")
        duration_in_minutes = 0;                      // not even going to guess
    }

    field_map["user_id"] = initial_state["created_for"];
    field_map["tax_entity_id"] = GetValidLinkId(txtProvider);

    // special fields for DefaultAction (these are not actual fields in the tasks table, so don't be confused)
    field_map["duration"]   = IntToString(duration_in_minutes);
    field_map["new_client"] = IntToString(BoolToInt(checkNewClient->Checked));
    
    field_map["group_id"]   = lookupTables->IdOf("groups", group_name); // jhaley 20110218: bug fix!

/*    
    map<string, string> params;
    if (IsBlankOrZero(initial_state["group_id"]))
    {
      // do they have permission to create multiple tasks?  If so, ask them which department the task should be associated with...
      set<string> groups;
      params["prefix"]       = "table.tasks";
      params["suffix"]       = "";
      params["key"]          = "insert";
      params["value"]        = "true";
      params["instructions"] = "You have permission to create tasks/visits for multiple departments.  Please select the department with which to associate this task/visit.";
      // for testing purposes mostly, let's try restricting it to just clinics they have permission to
      //string clinic_names    = "select id from groups where clinic_id > 0 and has_charts = 1 and id > 0 order by item";
      string groups_w_users  = "select groups.id from groups inner join users on users.group_id = groups.id where groups.id > 0 and groups.valid = 1 and users.valid = 1 group by groups.id";
      SqlToSet(dbDatabase, groups_w_users, groups);
      params["include"]      = SetToCommaString(groups);
      params["exclude"]      = "";
      params["table"]        = "groups";
                                    // PK      // permission-string  // string to show in drop-down
      params["sql"]          = "select id row_id, short_item row_value, item show_value from groups where valid = 1 and id > 0";

      field_map["group_id"]    = TformSpecialDisambiguate::Disambiguate(this, params, PrettyString);
    }
*/
    if (IsBlankOrZero(field_map["group_id"]))
      PSay("You don't seem to have permission to create tasks or visits for any departments.\n\nFeel free to contact a programmer to request any additional permissions you need.", m_message, MB_OK /*, "\"" + params["to_include"] + "\" - \"" + params["to_exclude"] + "\""*/);
    else
    {
      // jhaley: Comm. Health should always see their task form, vs. visit, from here evidently, as they use it for handling phone
      // calls and setting up appointments. Setting com_dept_id to 0 is the means to accomplish that unconditionally.
      if (field_map["group_id"] == lookupTables->IdOf("groups", "Community Health"))
        field_map["com_dept_id"] = "0";

      DefaultAction("tasks", field_map);
    }
  }
}
//---------------------------------------------------------------------------
bool TformRecordAppointment::DeleteRecord()
{
  if (ExecuteStatement(delete_transaction, "delete from appointment_viewers where appointment_id = " + initial_state["id"]))
  {
    // jhaley 20101101: Issue Atlas notifications on tax_entity_id and created_for to wake up interested schedulers
    if (!IsBlankOrZero(initial_state["tax_entity_id"]))
      atlas->Notify("appointments.tax_entity_id", initial_state["tax_entity_id"]);
    if (!IsBlankOrZero(initial_state["created_for"]))
      atlas->Notify("appointments.created_for", initial_state["created_for"]);
    return TformRecordGeneric::DeleteRecord();
  }
  else
  {
    PSay("Failed to delete appointment_viewers; cancelled.", m_database_error, MB_OK);
    return false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::txtLetterClick(TObject *Sender)
{
  string person_id = GetValidLinkId(txtClient);
  string tax_entity_id = GetValidLinkId(txtProvider);
  if(person_id != "")
  {
    bool acceptable_group = false;
    string group_id = GetOneField(dbDatabase, "select group_id from users where id = '" + initial_state["created_for"] + "'");
    if (group_id == lookupTables->IdOf("groups", "Behavioral Health") ||
        group_id == lookupTables->IdOf("groups", "Dental Clinic") ||
        group_id == lookupTables->IdOf("groups", "Diabetes") ||
        group_id == lookupTables->IdOf("groups", "Little Axe Clinic") ||
        group_id == lookupTables->IdOf("groups", "Shawnee Clinic"))
      acceptable_group = true;

    if (!acceptable_group) // try try again
    { // this time get the user associated with the tax entity (provider) on the appointment, if any, and see what group they are in
      group_id = GetOneField(dbDatabase, "select group_id from users inner join tax_entities on users.tax_entity_id = tax_entities.id where tax_entities.id = '" + tax_entity_id + "'");
      if (group_id == lookupTables->IdOf("groups", "Behavioral Health") ||
          group_id == lookupTables->IdOf("groups", "Dental Clinic") ||
          group_id == lookupTables->IdOf("groups", "Diabetes") ||
          group_id == lookupTables->IdOf("groups", "Little Axe Clinic") ||
          group_id == lookupTables->IdOf("groups", "Shawnee Clinic"))
        acceptable_group = true;
    }

    if (!acceptable_group)
      PSay("This appointment is not for a Behavioral Health, Diabetes, or Clinic provider.\n\nThe appointment reminder letters are currently only set up for those departments; if your department needs to send appointment reminder letters also, let a programmer know.", m_missing_data, MB_OK);
    else
    {
      vector<string> appointments;
      appointments.push_back(initial_state["id"]);
      TformReportDiabAppointmentLetter::Do(appointments, group_id);
    }
/*
    TIBTransaction *dbLetterTransaction = new TIBTransaction(NULL);
    TIBDataSet *dbLetterDataset = new TIBDataSet(NULL);
    string sql;
    string temp = "";
    vector<string> employee_vec;
    try
    {
      FORM_TRY
        TformReportDiabAppointmentLetter *report_form = new TformReportDiabAppointmentLetter(NULL);
        StdTransaction(dbLetterTransaction, dbDatabase);
        dbLetterDataset->Database = dbDatabase;
        dbLetterDataset->Transaction = dbLetterTransaction;
        sql = "select users.item || ' - ' || users.title employee "
              "from users where users.valid = 1 and "
              "users.group_id = " + lookupTables->IdOf("groups", "Diabetes") + " "
              "order by users.item";
        SqlToVec(dbLetterTransaction, sql, employee_vec);
        for(vector<string>::iterator itr = employee_vec.begin(); itr != employee_vec.end(); itr++)
           report_form->memoEmployees->Lines->Add((*itr).c_str());
        sql = "select person_names.first_name || ' ' || person_names.last_name full_name, "
              "person_contact_info.line1, "
              "person_contact_info.city || ', ' || state_types.abbreviation || '  ' || "
              "person_contact_info.zip line2, people.gender_id, "
              "appointments.appointment_date, appointments.appointment_time, "
              "cast(appointments.duration as int) || ' ' || duration_types.item duration, "
              "appointments.description, appt_location_types.item location, "
              "appt_reason_types.item reason "
              "from appointments inner join duration_types on appointments.duration_id = duration_types.id "
              "inner join people on appointments.person_id = people.id "
              "inner join person_names on people.person_names_id = person_names.id "
              "inner join person_contact_info on people.person_contact_info_id = person_contact_info.id "
              "inner join state_types on person_contact_info.state_id = state_types.id "
              "left join appt_reason_types on appointments.appt_reason_id = appt_reason_types.id "
              "left join appt_location_types on appointments.appt_location_id = appt_location_types.id "
              "where appointments.id = " + initial_state["id"];
        DebugSql(this, &sql, other_forms, 9);
        dbLetterDataset->SelectSQL->Add(sql.c_str());
        dbLetterDataset->Open();

        report_form->report->DataSet = dbLetterDataset;
        report_form->txtPerson->DataSet = dbLetterDataset;
        report_form->txtPerson->DataField = "full_name";
        report_form->txtLine1->DataSet = dbLetterDataset;
        report_form->txtLine1->DataField = "line1";
        report_form->txtLine2->DataSet = dbLetterDataset;
        report_form->txtLine2->DataField = "line2";
        report_form->txtGreeting->DataSet = dbLetterDataset;
        report_form->txtGreeting->DataField = "gender_id";
        report_form->txtHeader->DataSet = dbLetterDataset;
        report_form->txtHeader->DataField = "reason";
        report_form->txtDescription->DataSet = dbLetterDataset;
        report_form->txtDescription->DataField = "reason";
        report_form->txtDate->DataSet = dbLetterDataset;
        report_form->txtDate->DataField = "appointment_date";
        report_form->txtTime->DataSet = dbLetterDataset;
        report_form->txtTime->DataField = "appointment_time";
        report_form->txtDuration->DataSet = dbLetterDataset;
        report_form->txtDuration->DataField = "duration";
        report_form->txtLocation->DataSet = dbLetterDataset;
        report_form->txtLocation->DataField = "location";
        report_form->report->Preview();
      FORM_CATCH
      dbLetterDataset->Close();
      dbLetterTransaction->Commit();
    }
    catch(...)
    {
      if (dbLetterTransaction->Active)
        dbLetterTransaction->Rollback();
      PSay("Error printing letter", m_database_error, MB_OK);
    }
    delete dbLetterDataset;
    delete dbLetterTransaction;
*/
  }
  else
    PSay("There is no person attached to this appointment. Please select a person "
                            "and save the record before printing a letter", m_missing_data, MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::staticListOccurClick(TObject *Sender)
{
 // stuff!
 repeat_spec<int> match_this = GetRepeatSpec();
 vector<Pdate> matched_these = match_this.AllMatches (date_range(match_this.Start(), match_this.Stop()));
 FORM_TRY
  TformSpecialAppointmentOccurrences * occ = new TformSpecialAppointmentOccurrences(NULL);
  TListItem * t = NULL;
  for (vector<Pdate>::iterator i = matched_these.begin(); i != matched_these.end(); i++)
  {
   t = occ->listOccurrences->Items->Add();
   t->Caption = i->OutDate(global_mode).c_str();
   t->SubItems->Add(i->NameOfDay().c_str());
  }
  occ->ShowTaskModal(this);
 FORM_CATCH
}
//---------------------------------------------------------------------------
repeat_spec<int> TformRecordAppointment::GetRepeatSpec ()
{
 repeat_items day_r   = (repeat_items)comboRepeat_d->ItemIndex;
 repeat_items week_r  = (repeat_items)comboRepeat_w->ItemIndex;
 repeat_items month_r = (repeat_items)comboRepeat_m->ItemIndex;
 repeat_items year_r  = (repeat_items)comboRepeat_y->ItemIndex;

 int day_s   = StringToInt(string(editSpecific_d->Text.c_str()));
 int week_s  = StringToInt(string(editSpecific_w->Text.c_str()));
 int month_s = StringToInt(string(editSpecific_m->Text.c_str()));
 int year_s  = StringToInt(string(editSpecific_y->Text.c_str()));

 day_items   day_m   = (day_items)comboMatch_d->ItemIndex;
 week_items  week_m  = (week_items)comboMatch_w->ItemIndex;
 month_items month_m = (month_items)comboMatch_m->ItemIndex;
 year_items  year_m  = (year_items)comboMatch_y->ItemIndex;

 day_spec   when_day   (day_r, day_s, day_m);
 week_spec  when_week  (week_r, week_s, week_m);
 month_spec when_month (month_r, month_s, month_m);
 year_spec  when_year  (year_r, year_s, year_m);

 Pdate when_start (dateRepeating->Date);
 Pdate when_end   (dateEnding->Date);
 repeat_spec<int> match_this (when_day, when_week, when_month, when_year, when_start, when_end, 0);
 return match_this;
}
//---------------------------------------------------------------------------
void TformRecordAppointment::Do(map<string, string> & p_parameters, set<string> *p_imported_viewers)
{
 FORM_TRY
  TformRecordAppointment * z = new TformRecordAppointment(NULL, p_parameters, p_imported_viewers);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::cboUserChange(TObject *Sender)
{
// moved to OnExit
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::menuSelectGroupsClick(TObject *Sender)
{
  set<string> return_set;
  string id;
  FORM_TRY
    TformSpecialSelectGroups * select_group_form = new TformSpecialSelectGroups(NULL, &return_set, NULL);
    select_group_form->ShowTaskModal(this);
  FORM_CATCH
  if(!return_set.empty()) // if it's empty ... we don't do anything. which makes it annoying to unselect everyone. but at least our sql will be valid.
  {                       // TODO: if you're just worried about the in () clause being empty, a call to SafeInClause() would handle that as well --Paul
   user_filter.SetCheckedWhereID(return_set, true);
   user_filter.SetCheckedWhereNotID(return_set, false);
  }
}
//---------------------------------------------------------------------------
bool TformRecordAppointment::AtlasRefresh(int request_num, string matched_value)
{
  if (request_num == user_request)
    user_filter.RefreshDataSet();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordAppointment::CheckUser(const map<string, string> & row_data)
{
 // if there's a link, check it!
 map<string, string>::const_iterator i_link = row_data.find("Is Linked");
 return (i_link != row_data.end() && i_link->second == "1");
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::cboUserKeyPress(TObject *Sender, char &Key)
{
  if (Key == VK_RETURN)
    btnAddProvider->Click();
  else
    FindComboBoxItem(Sender, Key); // otherwise do what lookuptables would have done ... let auto-type take over
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::txtDemographicsClick(TObject *Sender)
{
  LogIt("appt_demographics.log", "Launching demographics report");
  FORM_TRY
    TformLaunchPatientDemographicsReport * demographics = new TformLaunchPatientDemographicsReport(NULL, "appointments", initial_state["id"], initial_state["group_id"]);
    demographics->ShowTaskModal(this);
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::cboUserExit(TObject *Sender)
{
  // jhaley 20101026: On user exit, set department
  if (cboDepartment->Text == "" && cboUser->Text != "" && lookupTables->IsInLookUpTable("users", cboUser))
  {
    string group_id = GetOneField(dbDatabase, "select group_id from users where id = '" + lookupTables->IdOf("users", cboUser) + "'");
    cboDepartment->Text = lookupTables->ValueOf("groups", group_id).c_str();
    if (!lookupTables->IsInLookUpTable("groups", cboDepartment))
      cboDepartment->Text = ""; // can't set it to this
    timerDeptChangeTimer(NULL); // Force reason/location refresh
  }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::cboReasonLacChange(TObject *Sender)
{
  return;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::cboOutcomeChange(TObject *Sender)
{
  if (cboOutcome->Text == "Walk-In") check24Hours->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::txtCancelAppointmentClick(TObject *Sender)
{
  // jhaley 20100922: Handle clicks on the "Cancel appointment" link, which:
  // * Sets this record's current_id to 'Expired'
  // * Sets this record's outcome to 'Cancelled'
  // * Saves the record.
  // Note the link is not enabled unless current_id starts out as 'Current' or 'Primary' and there is no task or visit outcome.

  // If already editing, go ahead; but if not, try to unlock the record now.
  if (is_editing || DataUnlock())
  {
    string expired_id = lookupTables->IdOf("current_types", "Expired");
    ending_state["current_id"]  = expired_id;
    cboOutcome->Text = "Cancelled";

    // Call DataSave - this will pull in any other changes that were made via GetDataFromScreen, and save it all.
    // If errors occur, the normal mechanisms will intercept them. Plus, the resulting call to ScreenLock automatically
    // updates our links and the such for us - much simpler than what I tried at first ;)
    DataSave();
  }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::txtRescheduleAppointmentClick(TObject *Sender)
{
  // jhaley 20100923: Handle clicks on the "Reschedule" link, which:
  // * Sets this record's current_id to 'Expired'
  // * Sets this record's outcome to 'Rescheduled'
  // * Saves this record.
  // * Opens a new appointment screen for creation, auto-filled with all the applicable data from this record.

  // jhaley 20101230: Check notes status and deny if has blocks; that way the appointment won't get nerfed.
  string person_id = GetValidLinkId(txtClient);
  string group_id  = lookupTables->IdOf("groups", cboDepartment);
  if (!IsBlankOrZero(group_id) && !IsBlankOrZero(person_id) &&
      optionsPermissions["special.note_block_override"]["enabled"] != "true")
  {
    int numblocks = 0, numwarnings = 0;
    GetBlocksAndWarnings(numblocks, numwarnings, group_id, person_id);
    if (numblocks > 0)
    {
      BlockOverrideErrorMessage(); // Standard "You cannot override block notes..." message.
      return;
    }
  }

  // If already editing, go ahead; but if not, try to unlock the record now.
  if (is_editing || DataUnlock())
  {
    string expired_id = lookupTables->IdOf("current_types", "Expired");
    ending_state["current_id"] = expired_id;
    cboOutcome->Text = "Rescheduled";

    // Call DataSave, as above.
    if (DataSave())
    {
      map<string, string> temp_map = initial_state; // initial_state was updated by DataSave.

      // Assuming there was not an error in the process of saving this record, open a new one.
      temp_map["id"] = "new";

      // clear what we modified, as well as finger-pointing stuff which is not needed.
      temp_map.erase("current_id");
      temp_map.erase("last_update_stamp");
      temp_map.erase("last_updated_by");
      temp_map.erase("visit_outcome_id");

      // clear all date/time fields
      temp_map.erase("appointment_time");
      temp_map.erase("final_end_stamp");
      temp_map.erase("appointment_date");
      temp_map.erase("begin_date");
      temp_map.erase("end_date");
      temp_map.erase("single_date");

      // jhaley 20110113: Get viewers
      vector<string> viewer_ids = user_filter.GetMultiID();
      set<string> viewer_set;
      VecToSet(viewer_ids, viewer_set);

      // launch the new appointment form and then close this one.
      Do(temp_map, &viewer_set);
      Close();
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::FormShortCut(TWMKey &Msg, bool &Handled)
{
  if(HIBYTE(GetAsyncKeyState(VK_CONTROL)))
  {
    Handled = true;
    //if (staticAddUsersFromGroups->Enabled && (Msg.CharCode == 'g' || Msg.CharCode == 'G'))
    if (!listViewableUsers->ReadOnly && listViewableUsers->PopupMenu && (Msg.CharCode == 'g' || Msg.CharCode == 'G'))
      menuSelectGroupsClick(NULL); //staticAddUsersFromGroupsClick(NULL);
    else
      Handled = false;
  }
  else
    Handled = false;

  TformRecordGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::checkNewClientClick(TObject *Sender)
{
  // if they uncheck it, clear it, so it doesn't look like they're saving data when they're not
  // (they can always Undo if this was due to an errant click...or key the name back in)
  /*editNewClientName->Enabled = checkNewClient->Checked;
  if (!checkNewClient->Checked)
    editNewClientName->Text = " New patient's name ";
  */
  string person_id = GetValidLinkId(txtClient); // jhaley 20110106: Do not modify initial_state here!
  if (checkNewClient->Checked && IsBlankOrZero(person_id))
  {
    TformWizardNewPerson * z;
    FORM_TRY
      z = new TformWizardNewPerson(NULL, &person_id);
    FORM_CATCH
    if (z->framePerson->AllowNew)
    {
      z->framePerson->Magic = trm_new;
      z->framePerson->buttonAffiliationsClick(NULL);
      z->framePerson->buttonAddressesClick(NULL);
      z->last_necessary_page = 1;
    }
    z->ShowTaskModal(this);
    if (IsBlankOrZero(person_id))
    {
      PSay("You did not complete the information for the new patient.  The new patient checkbox will be unchecked.", m_message, MB_OK);
      checkNewClient->Checked = false;
    }
    else
      CreateLink(txtClient, btnPersonSearch, this, person_id, "people");
  }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::editNewClientNameEnter(TObject *Sender)
{ // clear instructions on entry
  //if (editNewClientName->Text == " New patient's name ")
  //  editNewClientName->Text = "";
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::cboDepartmentChange(TObject *Sender)
{
  timerDeptChange->Enabled = true; // wait for it...
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::cboDepartmentExit(TObject *Sender)
{
  timerDeptChangeTimer(NULL); // on exit, fire NOW
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::timerDeptChangeTimer(TObject *Sender)
{
  timerDeptChange->Enabled = false;

  string original_reason;
  string original_location;

  TIBTransaction *dbTransaction = new TIBTransaction(NULL);
  StdTransaction(dbTransaction, dbDatabase);
  string dept_name = cboDepartment->Text.c_str();
  bool have_dept = lookupTables->IsInLookUpTable("groups", cboDepartment) && dept_name != ""; // jhaley: bug fix - first param is table name
  map<string, string> dept;
  string dept_id;

  if (have_dept)
  {
    dept_id = lookupTables->IdOf("groups", dept_name);
    SqlToMap(dbTransaction, "select * from groups where id = " + dept_id + " order by groups.item", dept);

    // If there is a valid group and the person has been specified, update the notes status
    if (dept_id != prev_group_id && GetValidLinkId(txtClient) != "")
    {
      num_blocks_overridden = 0; // group has changed, block overrides no longer apply
      UpdateNotesStatus(lookupTables->IdOf("groups", cboDepartment), GetValidLinkId(txtClient));
    }
  }

  // jhaley: don't register the box again without unregistering it first, as that would cause a resource leak and possibly even a double free error
  // TODO: this check should be done in classLookUpTableWrapper::RegisterComboBox and a debug message sent/logged
  if (lookupTables->TableName(cboUser) != "")
    lookupTables->UnregisterComboBox(lookupTables->TableName(cboUser), cboUser);

  set<string> users = GetUsersWithGroupPermissions("special", "provider", lookupTables->IdOf("groups", cboDepartment));
  string user_sql =                         
    (have_dept ? "select users.id, users.item, 1 valid from users where (users.valid = 1 or users.is_role = 1) and users.group_id = " + dept_id + " or " + SafeInClause("users.id", SetToVec(users)) + " order by users.item"
              : string("select users.id, users.item, 1 valid from users where (users.valid = 1 or users.is_role = 1) and users.id > 0 order by users.item"));
  lookupTables->RegisterComboBox("users", cboUser, user_sql);

  if (cboUser->Text == "" || !lookupTables->IsInLookUpTable("users", cboUser))
  {
    if (initial_state["created_for"] != "")
      cboUser->Text = PrettyString(lookupTables->ValueOf("users", initial_state["created_for"], cboUser)).c_str();
    else
      cboUser->Text = PrettyString(lookupTables->ValueOf("users", current_userid, cboUser)).c_str();
    if (!lookupTables->IsInLookUpTable("users", cboUser)) // that user isn't valid for this combo box
      cboUser->Text = "";
  }

  if (lookupTables->TableName(cboReason) != "") // if this cbo box is registered
    lookupTables->UnregisterComboBox(lookupTables->TableName(cboReason), cboReason);
  original_reason = cboReason->Text.c_str();
  cboReason->Text = ""; // jhaley 20101026: Need to clear value
  cboReason->Enabled = false;
  if (lookupTables->TableName(cboLocation) != "") // if this cbo box is registered
    lookupTables->UnregisterComboBox(lookupTables->TableName(cboLocation), cboLocation);
  original_location = cboLocation->Text.c_str();
  cboLocation->Text = ""; // jhaley 20101026: Need to clear value
  cboLocation->Enabled = false;

  if (have_dept)
  {
    // department changed, update reasons/locations accordingly.
    // We've already verified that they have table.appointments.DEPT create permissions.  I think that is
    // sufficient permission, and thus we can strip the special.DEPT.general permissions here.

    string custom_dept_name = dept_name;
    if (dept_name == "Shawnee Clinic") // Shawnee Clinic should see Little Axe Clinic items in the below lookups
      custom_dept_name = "Little Axe Clinic";

    string custom_location_sql = "select id, item, valid from appt_location_types where group_id in (0, "
                                 + lookupTables->IdOf("groups", custom_dept_name) + ", "
                                 + lookupTables->IdOf("groups", dept_name) +   // jhaley: add dept_name too for SC items
                                 ") and valid = 1 order by item ";
    string custom_reason_sql   = "select id, item, valid from appt_reason_types where group_id in (0, "
                                 + lookupTables->IdOf("groups", custom_dept_name) + ", "
                                 + lookupTables->IdOf("groups", dept_name) +
                                 ") and valid = 1 order by item ";

    lookupTables->RegisterComboBox("appt_location_types", cboLocation, custom_location_sql);
    cboLocation->Enabled = true;
    lookupTables->RegisterComboBox("appt_reason_types",   cboReason,   custom_reason_sql);
    cboReason->Enabled = true;

    // jhaley 20101026: try to set the old location again
    cboLocation->Text = original_location.c_str();
    if (!lookupTables->IsInLookUpTable("appt_location_types", cboLocation))
      cboLocation->Text = ""; // can't do it.

    // jhaley 20101026: try to set the old reason again
    cboReason->Text = original_reason.c_str();
    if (!lookupTables->IsInLookUpTable("appt_reason_types", cboReason))
      cboReason->Text = ""; // can't do it.

    // Let's try to look up a LAC reason based on who they picked, shall we?'
    if (custom_dept_name == "Little Axe Clinic") // jhaley 20101102: Bug fix - use custom_dept_name or Shawnee Clinic gets left out.
    {
      // Valid user selected, no LAC Reason (or an invalid one) selected
      if (lookupTables->IsInLookUpTable("users", cboUser) && /* && cboReason->Enabled && */
          (cboReason->Text == "" || !lookupTables->IsInLookUpTable("appt_reason_types", cboReason)))
      {
        if(debug_level[other_forms]>=8 && message_router) message_router->SendMessageToAll("debug", "TformRecordAppointment::cboUserChange cboUser: '" + string(cboUser->Text.c_str()) + "'");
        string sql = "select L.item from appt_reason_types L inner join users U on L.user_position_id = U.user_position_id and U.id = '" + lookupTables->IdOf("users", cboUser) + "'";
        string lac_reason = GetOneField(dbDatabase, sql);
        if(debug_level[other_forms]>=8 && message_router) message_router->SendMessageToAll("debug", "TformRecordAppointment::cboUserChange lac_reason: '" + lac_reason + "'");
        cboReason->Text = lac_reason.c_str();
      }
    }

    // check default appointment viewer groups for selected department
    // - jhaley: We neither want this to spontaneously change when a record is unlocked for subsequent editing, nor when
    //   the group setting has not actually changed. This is the trouble we get into for having a routine that's
    //   supposed to reflect a change to the value of group_id but is called even when the group_id has not changed.
    //   We need to know when a change has actually happened before we throw away user-specified values.
    if (dept_id != prev_group_id)
    {
      if(!importing_viewers)
      {
        set<string> default_groups_set;
        SplitStringToSet(dept["default_appt_viewer_groups"], ",", default_groups_set);
        // jhaley 20110128: added support for group-external appointment schedulers who get to see appointments for other groups.
        string default_user_sql =
          "select id from users where valid = 1 and (" + SafeInClause("group_id", SetToVec(default_groups_set)) + " or "
          "exists (select EXT.id from external_appt_schedulers EXT where EXT.group_id = '" + dept_id + "' and EXT.user_id = users.id))";
        set<string> default_users_set;
        SqlToSet(dbDatabase, default_user_sql, default_users_set);
        user_filter.SetCheckedWhereNotID (default_users_set, false); // uncheck users not in group
        user_filter.SetCheckedWhereID (default_users_set, true);     // check users in group
      }
      else
      {
        // jhaley 20111214: be more careful when importing viewers
        user_filter.SetCheckedWhereNotID(imported_viewers, false);
        user_filter.SetCheckedWhereID(imported_viewers, true);
      }
    }

    // TODO -c optional: It really only makes sense to enable txtDemographics if the appt group_id is one of the clinics...
    //txtDemographics->Enabled =

    /* DONE -c cleanup: duration and duration_type really should be fields in groups ... all this hard-coding and having to up a
       version if we add a dept or a dept decides they want 60 minute appts by default instead of 15 minute ones, is ridiculous. */
    // jhaley 20110106: && between these conditions, not ||, or it appears to reset while saving (but the specified value is saved anyway)
    if (is_new_record && editSimpleDuration->Text == "")
    {
      editSimpleDuration->Text = dept["default_appt_duration"].c_str();
      cboSimpleDuration->Text = "Minutes";
    }

    paddedWarning->Visible = false;
    string person_id = GetValidLinkId(txtClient);
    if (radioSingle->Checked && !IsBlankOrZero(person_id))
    {
      string end_date = Pdate(dateSingle->Date).OutDate(mdy | yyyy);
      Pdate pbegin = Pdate(dateSingle->Date); pbegin.mod(-1, in_years); pbegin.mod(1, in_days);
      string begin_date = pbegin.OutDate(mdy | yyyy);
      string sql = "select count(A.id) from appointments A "
        "where A.current_id+1>3 and A.group_id = '" + dept_id + "' and "
        "A.visit_outcome_id in (" + lookupTables->IdOf("visit_outcome_types", "No Show") + "," + lookupTables->IdOf("visit_outcome_types", "Arrived Late") + ") and "
        "A.person_id = '" + person_id + "' and "
        "A.appointment_date between '" + begin_date + "' and '" + end_date + "' ";
      string no_shows = GetOneField(dbDatabase, sql);
      if (StringToInt(no_shows) >= 2)
      {
        lblAlert->Caption = ("Warning:  Patient has " + no_shows + " no-show or arrived late appointments with " + dept_name + " between " + begin_date + " and " + end_date + ".").c_str();
        paddedWarning->Visible = true;
      }
    }
  }

  // jhaley 20110106: Track previous group id here rather than above, for full visibility of changes
  prev_group_id = dept_id;

  if (dbTransaction->Active)
    dbTransaction->Commit();
  delete dbTransaction;
}
//---------------------------------------------------------------------------
// jhaley 20101230: Subroutine for UpdateNotesStatus and IsValidOnScreen; Download the person's blocks/warnings and
// count them up.
bool TformRecordAppointment::GetBlocksAndWarnings(int &numblocks, int &numwarnings, string &group_id, string &person_id)
{
  set<string> one_group;

  // Add the one group, for now. If needed, this could be made permissions-based. If so, create a combined solution that
  // will also work for the New CHS Item Wizard, preferably.
  one_group.insert(group_id);

  return CountPersonBlocksAndWarnings(numblocks, numwarnings, person_id, one_group, lookupTables->IdOf("current_types", "Incomplete"));
}
//---------------------------------------------------------------------------
// jhaley 20101229: Support for display of group-relevant warnings and blocks on the appointment record screen. Call
// at all points which update group_id or person_id. As these values may come from initial_state or the form controls,
// they must be passed in from the point of change.
void TformRecordAppointment::UpdateNotesStatus(string group_id, string person_id)
{
  if (IsBlankOrZero(group_id) || IsBlankOrZero(person_id)) // No can do, bub.
    return;

  int numblocks = 0, numwarnings = 0;
  bool user_can_save = (optionsPermissions["special.note_block_override"]["enabled"] == "true");
  string dept_name = PrettyString(GetOneField(dbDatabase, "select item from groups where id = '" + group_id + "' "));

  bool success = GetBlocksAndWarnings(numblocks, numwarnings, group_id, person_id);
  if (!success)
    PSay("Could not retrieve the number of blocks and warnings for this person.", m_warning, MB_OK);

  // Check for block overrides. If all blocks are overridden, that will cause the block warning to go away.
  numblocks -= num_blocks_overridden;
  if (numblocks < 0) // ???
    numblocks = 0;

  // The message will be displayed if there are any warnings. In the case that there are blocks, the user will also be
  // unable to save the appointment unless they have special.note_block_override permission.
  if (numwarnings || numblocks)
  {
    if (numblocks) // Blocks (and maybe warnings too).
    {
      warn_and_block_message = "This person has " + IntToString(numwarnings) + " warning(s) and " + IntToString(numblocks)
        + " block(s) for " + dept_name + ". ";

      if (!user_can_save)
      {
        warn_and_block_message += "You will not be able to save this appointment because you are not allowed to "
          "override blocks. Please contact your supervisor.";
      }
      else
      {
        warn_and_block_message += "Click here to override blocks.";
      }
    }
    else // Just warnings.
    {
      warn_and_block_message = "This person has " + IntToString(numwarnings) + " warning(s) for " + dept_name + ".";
    }

    lblInformation->Width = scrollStandard->Width - 48; // In case being called before the form is visible...
    InfoBarText = warn_and_block_message;
    ShowInfoBar(); // Transform and roll out
    panelInfoBar->OnClick   = infoBarClick;
    lblInformation->OnClick = infoBarClick;
  }
  else
  {
    warn_and_block_message = "";
    HideInfoBar(); // Hide Decepticons
    panelInfoBar->OnClick   = NULL;
    lblInformation->OnClick = NULL;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::FormShow(TObject *Sender)
{
  TformRecordGeneric::FormShow(Sender);

  // Try showing the infobar; this will only succeed at the time if initial_state is filled out beforehand,
  // but that's OK. We manually update it if the information changes later.
  UpdateNotesStatus(initial_state["group_id"], initial_state["person_id"]);
}
//---------------------------------------------------------------------------
void __fastcall TformRecordAppointment::infoBarClick(TObject *Sender)
{
  TformSpecialPersonNotesSummary *notes_form;
  string person_id;
  string group_id;
  vector<string> group_ids;
  int num_checked = 0;

  person_id = GetValidLinkId(txtClient);
  group_id  = lookupTables->IdOf("groups", cboDepartment);

  // this really shouldn't happen as you wouldn't get here to begin with, but as always, being super-safe.
  if (IsBlankOrZero(person_id) || IsBlankOrZero(group_id))
    return;

  // You need view permissions on the person_notes table for this department before you can view for overrides.
  set<string> can_view = GetGroupPermissions("table.person_notes", "", "view", "true");
  if (can_view.find(group_id) == can_view.end())
  {
    PSay("You do not have permission to view blocks for this department. Please contact your supervisor.", m_warning, MB_OK);
    return;
  }

  group_ids.push_back(group_id);

  FORM_TRY
    notes_form = new TformSpecialPersonNotesSummary(NULL, person_id, group_ids, num_checked);
  FORM_CATCH
  notes_form->ShowTaskModal(this);

  // If user can override, set num_blocks_overridden
  // FIXME: otherwise this action gets ignored... post a message?
  if (optionsPermissions["special.note_block_override"]["enabled"] == "true")
  {
    if (num_checked > num_blocks_overridden) // we only increase this here, to keep it from resetting if you view it subsequently
      num_blocks_overridden = num_checked;
    UpdateNotesStatus(group_id, person_id); // bar will go away if all blocks are overridden (and there are no warnings).
  }
}
//---------------------------------------------------------------------------
/* Philip wrote me some SQL to fetch groups/users as a tree.  kind of fancy.  I'm keeping it around.  I don't even know why.
select distinct
       groups.item as visible_name,
       groups.item as sorting_column,
       groups.id as group_id,
       groups.item as group_name,
       cast(null as varchar(255)) as user_name,
       cast(null as integer) as user_id
from groups inner join users on users.group_id = groups.id
where users.valid = 1 and users.id > 0
union
select
       cast('      ' || users.item as varchar(255)),
       cast(groups.item || ' - ' || users.item as varchar(255)),
       group_id,
       groups.item,
       users.item,
       users.id
from users
inner join groups on groups.id = users.group_id
where users.valid = 1 and users.id > 0
order by 2
*/

