//---------------------------------------------------------------------------

#ifndef codeRecordAppointmentH
#define codeRecordAppointmentH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <Buttons.hpp>
#include "codeRubberContainer.h"
#include "codeHalfButton.h"
#include "codePaddedBox.h"
//---------------------------------------------------------------------------
class TformRecordAppointment : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TStaticText *txtClient;
        TStaticText *txtTask;
        TPanel *panelSimpleTop;
        TLabel *lblDescription;
        TLabel *lblClientLabel;
        TBitBtn *btnPersonSearch;
        TStaticText *txtProvider;
        TStaticText *txtLetter;
        TStaticText *txtDemographics;
        TCheckBox *check24Hours;
        TCheckBox *checkNewClient;
        TEdit *editNewClientName;
        TLabel *lblCreatedBy;
        TLabel *lblUser;
        TLabel *lblOutcome;
        TComboBox *cboOutcome;
        TRichEdit *editDescription;
        TRadioButton *radioSingle;
        TRadioButton *radioRepeating;
        TPanel *panelRightSide;
        TPageControl *pagesDates;
        TTabSheet *sheetSimpleDate;
        TPanel *panelSimpleDate;
        TLabel *lblDateSingle;
        TLabel *lblTimeSingle;
        TLabel *lblSimpleDuration;
        TEdit *editSimpleDuration;
        TComboBox *cboSimpleDuration;
        TDateTimePicker *timeSingle;
        TDateTimePicker *dateSingle;
        TStaticText *txtCancelAppointment;
        TStaticText *txtRescheduleAppointment;
        TTabSheet *sheetAdvancedDate;
        TPanel *panelAdvancedDate;
        TLabel *labelStarting;
        TLabel *labelEnding;
        TLabel *lblRepeatTime;
        TLabel *lblAdvancedDuration;
        TComboBox *comboRepeat_d;
        TEdit *editSpecific_d;
        TComboBox *comboMatch_d;
        TComboBox *comboMatch_w;
        TEdit *editSpecific_w;
        TComboBox *comboRepeat_w;
        TComboBox *comboRepeat_m;
        TEdit *editSpecific_m;
        TComboBox *comboMatch_m;
        TComboBox *comboMatch_y;
        TEdit *editSpecific_y;
        TComboBox *comboRepeat_y;
        TDateTimePicker *dateRepeating;
        TDateTimePicker *timeRepeating;
        TEdit *editAdvancedDuration;
        TComboBox *cboAdvancedDuration;
        TDateTimePicker *dateEnding;
        TStaticText *staticListOccur;
        TPanel *panelBottomRight;
        TLabel *lblViewedBy;
        TPopupMenu *popupGroups;
        TMenuItem *menuSelectGroups;
        TPageControl *pagesGroups;
        TTabSheet *sheetViewableUsers;
        TTabSheet *sheetViewableUsersAndGroups;
        TRubberContainer *rubberViewableUsers;
        TListView *listViewableUsers;
        TRubberContainer *rubberViewableUsersAndGroups;
        TListView *listViewableUsersAndGroups;
        TRadioButton *radioViewUsers;
        TRadioButton *radioViewUsersAndGroups;
        TLabel *lblTask;
        TLabel *lblCreatedFor;
        TTimer *timerDeptChange;
        TPaddedBox *paddedWarning;
        TLabel *lblAlert;
        TPaddedBox *PaddedBox1;
        TLabel *lblCreatedForUser;
        TLabel *lblTaxEntity;
        TLabel *lblCreatedForDepartment;
        TLabel *lblReason;
        TLabel *lblLocation;
        TComboBox *cboUser;
        TBitBtn *btnProviderSearch;
        TComboBox *cboDepartment;
        TComboBox *cboReason;
        TComboBox *cboLocation;
        THalfButton *btnAddProvider;
        void __fastcall radioDateClick(TObject *Sender);
        void __fastcall comboRepeat_dChange(TObject *Sender);
        void __fastcall comboRepeat_wChange(TObject *Sender);
        void __fastcall comboRepeat_mChange(TObject *Sender);
        void __fastcall comboRepeat_yChange(TObject *Sender);
        void __fastcall btnPersonSearchClick(TObject *Sender);
        void __fastcall btnAddProviderClick(TObject *Sender);
        void __fastcall btnProviderSearchClick(TObject *Sender);
        void __fastcall taskClick(TObject *Sender);
        void __fastcall txtLetterClick(TObject *Sender);
        void __fastcall staticListOccurClick(TObject *Sender);
        void __fastcall cboUserChange(TObject *Sender);
        void __fastcall cboUserKeyPress(TObject *Sender, char &Key);
        void __fastcall txtDemographicsClick(TObject *Sender);
        void __fastcall cboUserExit(TObject *Sender);
        void __fastcall cboReasonLacChange(TObject *Sender);
        void __fastcall cboOutcomeChange(TObject *Sender);
        void __fastcall txtCancelAppointmentClick(TObject *Sender);
        void __fastcall txtRescheduleAppointmentClick(TObject *Sender);
        void __fastcall FormShortCut(TWMKey &Msg, bool &Handled);
        void __fastcall cboDepartmentChange(TObject *Sender);
        void __fastcall checkNewClientClick(TObject *Sender);
        void __fastcall menuSelectGroupsClick(TObject *Sender);
        void __fastcall radioViewUsersClick(TObject *Sender);
        void __fastcall editNewClientNameEnter(TObject *Sender);
        void __fastcall timerDeptChangeTimer(TObject *Sender);
        void __fastcall cboDepartmentExit(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
private:	// User declarations
        int task_request;
        bool is_cob_appointment;
        string original_current_id;
        string warn_and_block_message;
        int num_blocks_overridden;
        string prev_group_id;
        set<string> imported_viewers; // jhaley 20110113: support importing viewers from source appointment during rescheduling
        bool importing_viewers; // jhaley 20111214: gotta be more thorough about this...

        classFilterObject user_filter;
        int user_request;
protected:
        bool DeleteRecord();
        void UpdateNotesStatus(string group_id, string person_id);
        bool GetBlocksAndWarnings(int &numblocks, int &numwarnings, string &group_id, string &person_id);
        void __fastcall infoBarClick(TObject *Sender);
public:		// User declarations
        __fastcall TformRecordAppointment(TComponent* Owner, map<string,string> p_parameters, set<string> *p_imported_viewers = NULL);
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenStart();
        bool ScreenStop();
        bool ScreenLock();
        bool ScreenUnlock();
        bool BeforeSave();
        bool AfterSave();
        bool IsNewAgain();
        bool NotNewAnymore();
        bool AtlasRefresh(int request_num, string matched_value);
        bool CheckUser(const map<string, string> & row_data);
        repeat_spec<int> GetRepeatSpec ();
        static void Do(map<string, string> & p_parameters, set<string> *p_imported_viewers = NULL);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordAppointment *formRecordAppointment;
//---------------------------------------------------------------------------
#endif
