//---------------------------------------------------------------------------

// NOTE: search buttons are disabled because they're too great of a risk at the moment.
//       to re-enable them, look for uses of ...
//       CreateLink([...] , "", false)
//       ... in the code. the rest of the code should be about ready, except for the insurance_coverage. didn't care enough.

#include <vcl.h>
#pragma hdrstop

#include "codeRecordBill.h"
#include "codeSearchTaxEntity.h"
#include "codeRecordTaxEntity.h"
#include "codeRecordTransaction.h"
#include "codeRecordProcedurePayment.h"
#include "codeWizardModifyTransactions.h"
#include "codeSpecialTransactionSummary.h"
#include "reportBulkEOB.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordBill *formRecordBill;
//---------------------------------------------------------------------------
__fastcall TformRecordBill::TformRecordBill(TComponent* Owner, map<string,string> &p_parameters)
         : TformRecordGeneric(Owner, p_parameters, string("bills"))
{
  transactions_filter.SetListViewHandle(listTransactions);
  transactions_filter.SetSecurity("transactions");
  transactions_filter.AddColumnSpec("Tax Entity", "tax_entities", as_text, true, 120, rawString);
  transactions_filter.AddColumnSpec("Eff. Date", "transactions", as_date, true, 75);
  transactions_filter.AddColumnSpec("Fisc. Date", "transactions", as_date, true, 75);
  transactions_filter.AddColumnSpec("Account", "accounts", as_text, true, 140);
  transactions_filter.AddColumnSpec("Type", "accounts", as_text, true, 75);
  transactions_filter.AddColumnSpec("Note", "transactions", as_text, false, 120, sentenceString);
  transactions_filter.AddColumnSpec("Debit", "transactions", as_double, true, 75, nonzeroAmountString);
  transactions_filter.AddColumnSpec("Credit", "transactions", as_double, true, 75, nonzeroAmountString);
  transactions_filter.AddColumnSpec("Trans #", "transactions", as_int, true, 75);
  transactions_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  transactions_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  transactions_filter.FetchPreferences("recordincomingbill.transactions_filter");
  transactions_filter.SetIconStatus(true);
  transactions_filter.SetSQLStatement("");
  transactions_filter.RefreshDataSet();

  payments_filter.SetListViewHandle (listProcedurePayments);
  payments_filter.SetSecurity("procedure_payments");
  payments_filter.AddColumnSpec("Procedure", "procedures", as_text, true, 60, rawString);
  payments_filter.AddColumnSpec("Residual", "procedure_payments", as_double, true, 60, amountString);
  payments_filter.AddColumnSpec("Paid", "procedure_payments", as_double, true, 60, amountString);
  payments_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  payments_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  payments_filter.FetchPreferences("recordincomingbill.payments_filter");
  payments_filter.SetSQLStatement("");
  payments_filter.RefreshDataSet();

  staticTransactionSummary->Font->Color = link_color;
  staticModifyTransactions->Font->Color = link_color;
  staticPrintEOB->Font->Color           = link_color;

  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordBill::IsValidOnScreen()
{
 if (!lookupTables->IsInLookUpTable("bill_types", comboBillType) || (lookupTables->IdOf("bill_types", "") == lookupTables->IdOf("bill_types", comboBillType)))
 {
  PSay("Please specify a (non-blank) type of bill.", m_missing_data, MB_OK);
  ActiveControl = comboBillType;
  return false;
 } else
 if (!is_provider_bill() && !radioVendor->Checked)
 {
   PSay("Please make sure you have selected to pay a vendor.", m_missing_data, MB_OK);
 } else
 if (is_provider_bill() && !radioProvider->Checked && !radioFacility->Checked && !radioGroup->Checked)
 {
   PSay("Please select the primary tax entity (provider, facility, or group.)", m_missing_data, MB_OK);
   radioProvider->SetFocus();
   return false;
 } else
 if (radioVendor->Checked && IsBlankOrZero(vendor_tax_id))
 {
   PSay("Please select a vendor.", m_missing_data, MB_OK);
 } else
 if (radioProvider->Checked && IsBlankOrZero(provider_tax_id))
 {
   PSay("Please select a provider.", m_missing_data, MB_OK);
   return false;
 } else
 if (radioFacility->Checked && IsBlankOrZero(facility_tax_id))
 {
   PSay("Please select a facility.", m_missing_data, MB_OK);
   return false;
 } else
 if ((radioGroup->Checked) && IsBlankOrZero(group_tax_id))
 {
   PSay("Please select a group.", m_missing_data, MB_OK);
   return false;
 } else
 if (!IsAmount(editCharges->Text.c_str()))
 {
   PSay("Please enter a valid total (original) charge.", m_invalid_data, MB_OK);
   editCharges->SetFocus();
   return false;
 } else
 if (!IsAmount(editResiduals->Text.c_str()))
 {
   PSay("Please enter a valid residual (invoice) amount.", m_invalid_data, MB_OK);
   editResiduals->SetFocus();
   return false;
 } else
 if (!IsAmount(editPaid->Text.c_str()))
 {
   PSay("Please enter a valid paid amount.", m_invalid_data, MB_OK);
   editPaid->SetFocus();
   return false;
 } else
 if (!is_incoming_bill() && (IsBlankOrZero(insurance_coverage_id) /* || IsBlankOrZero(person_id)*/))
 {
   PSay("Please select an insurance coverage to bill.", m_invalid_data, MB_OK);
   return false;
 }

 // return false is optional below, so we should NOT do the if/else if thing.
 // TODO: look for other cases that do this -- IsValid*() functions with 'else if' and optional 'return false' (incorrect results)

 if (UppercaseString(lookupTables->ValueOf("current_types", ending_state["current_id"])) == "DELETED")
 {
  if (IDNO == PSay(
             "Marking this bill as deleted will have no effect on the transactions attached to it.\n"
             "Marking the transactions as deleted will also have no effect.\n"
             "Please use the 'modify transactions' link to the bottom-left of the transaction list to make\n"
             "appropriate changes, such as reversing existing transactions. All non-zero totals\n"
             "shown in the 'summary' screen will be reflected everywhere else in Prometheus.\n"
             "Are you sure you want to continue anyway?", m_warning, MB_YESNO))
   return false;
 }

 if (actual_tax_id != initial_state["actual_tax_id"])
 {
  if (IDNO == PSay("You have changed who is to be paid for this bill.\n"
                   "If transactions have already been created for this bill, they will not be modified.\n"
                   "You must make sure that the transactions on this bill are as you would expect them\n"
                   "to be after your changes. If they are not, please use the 'modify transactions' link\n"
                   "to the bottom-left of the transaction list to make appropriate changes.\n"
                   "Are you sure you want to continue anyway?", m_warning, MB_YESNO))
   return false;
 }

 return true;
}
//---------------------------------------------------------------------------
bool TformRecordBill::PutDataOnScreen()
{
  if(initial_state["bill_date"] != "")
    dateBillDate->Date = Pdate(initial_state["bill_date"], mdy | yyyy).OutDate();
  else
    dateBillDate->Date = Date();

  editCharges->Text   = AmountToString(StringToAmount(initial_state["total_charge"])).c_str();
  editResiduals->Text = AmountToString(StringToAmount(initial_state["invoice_amount"])).c_str();
  editPaid->Text      = AmountToString(StringToAmount(initial_state["paid_amount"])).c_str();

  editInvoiceNumber->Text = SentenceString(initial_state["invoice_number"]).c_str();
  editNote->Text          = SentenceString(initial_state["note"]).c_str();
  comboBillType->Text     = lookupTables->ValueOf("bill_types", initial_state["bill_id"]).c_str();

  radioVendor->Checked   = false;
  radioProvider->Checked = false;
  radioFacility->Checked = false;
  radioGroup->Checked    = false;

  radioVendor->Enabled   = false;
  radioProvider->Enabled = false;
  radioFacility->Enabled = false;
  radioGroup->Enabled    = false;

  CreateLink(staticVendor, buttonSearchVendor, this, "0", "tax_entities", "", false);
  CreateLink(staticProvider, buttonSearchProvider, this, "0", "tax_entities", "", false);
  CreateLink(staticFacility, buttonSearchFacility, this, "0", "tax_entities", "", false);
  CreateLink(staticGroup, buttonSearchGroup, this, "0", "tax_entities", "", false);
  CreateLink(staticInsuranceCoverage, buttonSearchInsuranceCoverage, this, "0", "insurance_coverage", "", false);

  if(!is_provider_bill())
  {
   radioVendor->Enabled  = true;
   radioVendor->Checked  = true;
   buttonSearchVendor->Enabled = IsBlankOrZero(initial_state["purchase_req_id"]);
   CreateLink(staticVendor, buttonSearchVendor, this, initial_state["actual_tax_id"], "tax_entities", "", false);
  }
  else
  {
   radioProvider->Enabled = true;
   radioFacility->Enabled = true;
   radioGroup->Enabled    = true;

   radioProvider->Checked = (initial_state["provider_tax_id"] == initial_state["actual_tax_id"]);
   radioFacility->Checked = (initial_state["facility_tax_id"] == initial_state["actual_tax_id"]);
   radioGroup->Checked    = (initial_state["group_tax_id"] == initial_state["actual_tax_id"]);

   buttonSearchProvider->Enabled = IsBlankOrZero(initial_state["purchase_req_id"]);
   buttonSearchFacility->Enabled = IsBlankOrZero(initial_state["purchase_req_id"]);
   buttonSearchGroup->Enabled    = IsBlankOrZero(initial_state["purchase_req_id"]);

   CreateLink(staticProvider, buttonSearchProvider, this, initial_state["provider_tax_id"], "tax_entities", "", false);
   CreateLink(staticFacility, buttonSearchFacility, this, initial_state["facility_tax_id"], "tax_entities", "", false);
   CreateLink(staticGroup, buttonSearchGroup, this, initial_state["group_tax_id"], "tax_entities", "", false);
  }

  if (!is_incoming_bill())
  {
   // currently, buttons are always disabled. don't give a damn. a wizard is a wizard's wizard's mom. wizard.
   CreateLink(staticInsuranceCoverage, buttonSearchInsuranceCoverage, this, initial_state["insurance_coverage_id"], "insurance_coverage", "", false);
  }

  CreateLink(staticPurchaseRequest, NULL, this, initial_state["purchase_req_id"], "purchase_reqs");
  CreateLink(staticVisit, NULL, this, initial_state["task_id"], "tasks");

  actual_tax_id         = initial_state["actual_tax_id"];
  vendor_tax_id         = initial_state["actual_tax_id"];
  provider_tax_id       = initial_state["provider_tax_id"];
  facility_tax_id       = initial_state["facility_tax_id"];
  group_tax_id          = initial_state["group_tax_id"];
  insurance_coverage_id = initial_state["insurance_coverage_id"];

  if (IsBlankOrZero(actual_tax_id))
   actual_tax_id = "0";
  if (IsBlankOrZero(vendor_tax_id))
   vendor_tax_id = "0";
  if (IsBlankOrZero(provider_tax_id))
   provider_tax_id = "0";
  if (IsBlankOrZero(facility_tax_id))
   facility_tax_id = "0";
  if (IsBlankOrZero(group_tax_id))
   group_tax_id = "0";
  if (IsBlankOrZero(insurance_coverage_id))
   insurance_coverage_id = "0";

  string check_id = "0";
  if (!IsBlankOrZero(initial_state["purchase_req_id"]))
   check_id = GetOneField(dbDatabase, "select check_id from purchase_reqs where id = " + initial_state["purchase_req_id"]);
  CreateLink(staticCheck, NULL, this, check_id, "checks");

  TformRecordGeneric::PutDataOnScreen();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordBill::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  ending_state["id"] = initial_state["id"];

  ending_state["bill_date"]      = Pdate(dateBillDate->Date).OutDate(mdy | yyyy);
  ending_state["total_charge"]   = editCharges->Text.c_str();
  ending_state["invoice_amount"] = editResiduals->Text.c_str();
  ending_state["paid_amount"]    = editPaid->Text.c_str();
  ending_state["note"]           = editNote->Text.c_str();
  ending_state["invoice_number"] = editInvoiceNumber->Text.c_str();

  ending_state["bill_id"] = lookupTables->IdOf("bill_types", comboBillType);

  if (initial_state["purchase_req_id"] == "")
    ending_state["purchase_req_id"] = "0";
  else
    ending_state["purchase_req_id"] = initial_state["purchase_req_id"];

  ending_state["actual_tax_id"]   = actual_tax_id;
  ending_state["provider_tax_id"] = provider_tax_id;
  ending_state["facility_tax_id"] = facility_tax_id;
  ending_state["group_tax_id"]    = group_tax_id;
  ending_state["insurance_coverage_id"] = insurance_coverage_id;

  // TODO -- delete fields
  ending_state["user_id"] = initial_state["user_id"]; // lookupTables->IdOf("users", cboUser->Text.c_str());
  ending_state["group_or_user"] = initial_state["group_or_user"];
  ending_state["groups"] = initial_state["groups"];

  TformRecordGeneric::GetDataFromScreen();
  return true; // again, not much can go wrong here
}
//---------------------------------------------------------------------------
bool TformRecordBill::ScreenStart()
{
 lookupTables->RegisterComboBox("bill_types", comboBillType);
 // lookupTables->RegisterComboBox("bill_form_types", comboFormType);
 TformRecordGeneric::ScreenStart();
 return true;}
//---------------------------------------------------------------------------
bool TformRecordBill::ScreenStop()
{
 lookupTables->UnregisterComboBox("bill_types", comboBillType);
 // lookupTables->UnregisterComboBox("bill_form_types", comboFormType);
 TformRecordGeneric::ScreenStop();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordBill::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordBill::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordBill::NotNewAnymore()
{
  string sql;
  sql = "select tax_entities.name, transactions.effective_date, transactions.fiscal_date, "
        "accounts.name, account_types.item, "
        "transactions.note, transactions.debit_amount, transactions.credit_amount, "
        "transactions.transaction_number, transactions.current_id, transactions.id "
        "from transactions "
        "inner join accounts on transactions.account_id = accounts.id "
        "inner join account_types on accounts.account_type_id = account_types.id "
        "left join tax_entities on transactions.tax_entity_id = tax_entities.id "
        "where "
        "transactions.bill_id = " + initial_state["id"];
  transactions_filter.SetSQLStatement (sql);
  transactions_filter.RefreshDataSet();
  transactions_filter.SetAddEdit(this, NULL, EditRecord(&(TformRecordBill::EditTransaction)));
  transactions_request = atlas->RequestNotificationWhen("transactions.bill_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordBill::AtlasRefreshListView)));

  payments_filter.SetSQLStatement("select procedures.cpt_hcpcs, procedure_payments.amount_charged, procedure_payments.amount_paid, procedure_payments.current_id, procedure_payments.id from procedure_payments left join procedures on procedures.id = procedure_payments.procedure_id where procedure_payments.bill_id = " + initial_state["id"]);
  payments_filter.RefreshDataSet();
  payments_filter.SetAddEdit(this, NULL /*AddRecord(&(TformRecordBill::AddPayment))*/,
                               EditRecord(&(TformRecordBill::EditPayment)));
  payment_request = atlas->RequestNotificationWhen("procedure_payments.bill_id", initial_state["id"], rel_e, as_int, this,
                     RefreshHandler(&(TformRecordBill::AtlasRefreshListView)));

  staticTransactionSummary->Enabled = true;
  staticModifyTransactions->Enabled = true;
  staticPrintEOB->Enabled           = true;
  buttonPrintBill->Enabled          = true;

  CalcTransTotals();
  CalcProcTotals();

  TformRecordGeneric::NotNewAnymore();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordBill::IsNewAgain()
{
  transactions_filter.SetSQLStatement(string(""));
  transactions_filter.RefreshDataSet();
  transactions_filter.SetAddEdit(this, NULL, NULL);

  payments_filter.SetSQLStatement(string(""));
  payments_filter.RefreshDataSet();
  payments_filter.SetAddEdit(this, NULL, NULL);

  staticTransactionSummary->Enabled = false;
  staticModifyTransactions->Enabled = false;
  staticPrintEOB->Enabled           = false;
  buttonPrintBill->Enabled          = false;

  TformRecordGeneric::IsNewAgain();
  return true;
}
//---------------------------------------------------------------------------

void __fastcall TformRecordBill::radioBillByClick(TObject *Sender)
{
 if (radioVendor->Checked)
  actual_tax_id = vendor_tax_id;
 else
 if (radioProvider->Checked)
  actual_tax_id = provider_tax_id;
 else
 if (radioFacility->Checked)
  actual_tax_id = facility_tax_id;
 else
 if (radioGroup->Checked)
  actual_tax_id = group_tax_id;
}
//---------------------------------------------------------------------------

void __fastcall TformRecordBill::buttonSearchVendorClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchTaxEntity * providerSearch = new TformSearchTaxEntity(NULL,&return_vector);
    providerSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
  {
    vendor_tax_id = return_vector[0];
    CreateLink(staticVendor, buttonSearchVendor, this, vendor_tax_id, "tax_entities", "", false);
    radioBillByClick(NULL);
  }
}
//---------------------------------------------------------------------------

void __fastcall TformRecordBill::buttonSearchProviderClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchTaxEntity * providerSearch = new TformSearchTaxEntity(NULL,&return_vector);
    providerSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
  {
    provider_tax_id = return_vector[0];
    CreateLink(staticProvider, buttonSearchProvider, this, provider_tax_id, "tax_entities", "", false);
    radioBillByClick(NULL);
  }
}
//---------------------------------------------------------------------------

void __fastcall TformRecordBill::buttonSearchFacilityClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchTaxEntity * providerSearch = new TformSearchTaxEntity(NULL,&return_vector);
    providerSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
  {
    facility_tax_id = return_vector[0];
    CreateLink(staticFacility, buttonSearchFacility, this, facility_tax_id, "tax_entities", "", false);
    radioBillByClick(NULL);
  }
}
//---------------------------------------------------------------------------

void __fastcall TformRecordBill::buttonSearchGroupClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchTaxEntity * providerSearch = new TformSearchTaxEntity(NULL,&return_vector);
    providerSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
  {
    group_tax_id = return_vector[0];
    CreateLink(staticGroup, buttonSearchGroup, this, group_tax_id, "tax_entities", "", false);
    radioBillByClick(NULL);
  }
}
//---------------------------------------------------------------------------

void __fastcall TformRecordBill::buttonSearchInsuranceCoverageClick(TObject *Sender)
{
 // TODO: -- except it won't do anything, as above ... or will it? should it, ever?
}
//---------------------------------------------------------------------------

void __fastcall TformRecordBill::buttonPrintBillClick(TObject *Sender)
{
 // TODO:
}
//---------------------------------------------------------------------------

void __fastcall TformRecordBill::staticTransactionSummaryClick(
      TObject *Sender)
{
 if (optionsPermissions["table.transactions"]["view"] == "true")
 {
  FORM_TRY
   TformSpecialTransactionSummary * sum = new TformSpecialTransactionSummary(NULL, initial_state["id"], "bills");
   sum->Show();
  FORM_CATCH
 }
}
//---------------------------------------------------------------------------

void __fastcall TformRecordBill::staticModifyTransactionsClick(
      TObject *Sender)
{
 if (optionsPermissions["table.transactions"]["insert"] == "true")
 {
  FORM_TRY
   TformWizardModifyTransactions * wiz = new TformWizardModifyTransactions(NULL, initial_state["id"], mod_in_bill);
   wiz->Show();
  FORM_CATCH
 }
}
//---------------------------------------------------------------------------

void __fastcall TformRecordBill::staticPrintEOBClick(TObject *Sender)
{
 // print just this one EOB
 Processing(true);

 TIBTransaction * dbTransaction = new TIBTransaction(NULL);
 TIBDataSet * eobDataset = new TIBDataSet(NULL);

 try
 {
  StdTransaction(dbTransaction, dbDatabase);
  eobDataset->Database = dbDatabase;
  eobDataset->Transaction = dbTransaction;
  eobDataset->UniDirectional = false;

  string sql_get_eob =
   "select bills.id, "
   "affiliations.cdib, person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix name, tasks.patient_control_number, "
   "procedures.start_date, procedures.cpt_hcpcs code, procedures.charges charged, procedure_payments.amount_charged billed, procedure_payments.amount_allowed allowed, procedure_payments.amount_paid paid "
   "from bills "
   "left join tasks on tasks.id = bills.task_id "
   "left join procedures on procedures.task_id = tasks.id "
   "left join procedure_payments on procedure_payments.procedure_id = procedures.id "
   "left join people on tasks.person_id = people.id "
   "left join person_names on people.person_names_id = person_names.id "
   "left join affiliations on people.affiliations_id = affiliations.id "
   "where bills.id = " + initial_state["id"];
  eobDataset->SelectSQL->Add(sql_get_eob.c_str());
  eobDataset->Open();
  eobDataset->First();

  FORM_TRY
   TformReportBulkEOB * report = new TformReportBulkEOB(NULL);
   report->qpBulkEOB->DataSet = eobDataset;
   report->_labelProviderPaid->Caption = "";
   report->qrpProviderName->Caption = "";
   report->_labelPRNumber->Caption = "";
   report->qrpPR->Caption = "";
   report->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
   report->qrpCDIB->DataSet = eobDataset;
   report->qrpCDIB->DataField = "cdib";
   report->qrpName->DataSet = eobDataset;
   report->qrpName->DataField = "name";
   report->qrpPatientAccountNum->DataSet = eobDataset;
   report->qrpPatientAccountNum->DataField = "patient_control_number";
   report->qrpDate->DataSet = eobDataset;
   report->qrpDate->DataField = "start_date";
   report->qrpProcedure->DataSet = eobDataset;
   report->qrpProcedure->DataField = "code";
   report->bandGroup->Expression = "id";
   Processing(false);
   report->qpBulkEOB->Preview();
  FORM_CATCH
  eobDataset->Close();
 }
 catch(...)
 {
  Processing(false);
  PSay("Error printing EOB", m_database_error, MB_OK);
 }

 if(dbTransaction->Active)
  dbTransaction->Rollback();

 delete eobDataset;
 delete dbTransaction;
}
//---------------------------------------------------------------------------
void TformRecordBill::AtlasRefreshListView(int request_num, string matched_value)
{
 if(request_num == transactions_request)
 {
  transactions_filter.RefreshDataSet();
  CalcTransTotals();
 }

 if (request_num == payment_request)
 {
  payments_filter.RefreshDataSet();
  CalcProcTotals();
 }

 return;
}
//---------------------------------------------------------------------------
void TformRecordBill::EditTransaction()
{
  map<string, string> temp_map;
  temp_map["id"] = transactions_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordTransaction * view_transaction = new TformRecordTransaction(NULL, temp_map);
    view_transaction->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordBill::AddPayment()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["bill_id"] = initial_state["id"];
  FORM_TRY
    TformRecordProcedurePayment * pay = new TformRecordProcedurePayment(NULL, temp_map);
    pay->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordBill::EditPayment()
{
  map<string,string> temp_map;
  temp_map["id"] = payments_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordProcedurePayment * pay = new TformRecordProcedurePayment(NULL, temp_map);
    pay->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordBill::CalcProcTotals()
{
 map<string, string> totals;
 string sql = "select sum(charges) proc_charges, sum(amount_charged) pay_charges, sum(amount_allowed) pay_allowed, sum(amount_paid) pay_paid "
              "from procedure_payments left join procedures on procedures.id = procedure_payments.procedure_id where bill_id = " + initial_state["id"];
 if (!SqlToMap(dbDatabase, sql, totals))
  PSay("Failed to retrieve procedure-payment totals.", m_database_error, MB_OK);
 else
 {
  labelProcPayCharges->Caption   = StringToAmount(totals["proc_charges"]).c_str();
  labelProcPayResiduals->Caption = StringToAmount(totals["pay_charges"]).c_str();
  labelProcPayAllowed->Caption   = StringToAmount(totals["pay_allowed"]).c_str();
  labelProcPayPaid->Caption      = StringToAmount(totals["pay_paid"]).c_str();

  if (labelProcPayCharges->Caption == "")
   labelProcPayCharges->Caption = "0.00";
  if (labelProcPayResiduals->Caption == "")
   labelProcPayResiduals->Caption = "0.00";
  if (labelProcPayAllowed->Caption == "")
   labelProcPayAllowed->Caption = "0.00";
  if (labelProcPayPaid->Caption == "")
   labelProcPayPaid->Caption = "0.00";
 }
}
//---------------------------------------------------------------------------
void TformRecordBill::CalcTransTotals()
{
}
//---------------------------------------------------------------------------
void TformRecordBill::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordBill * z = new TformRecordBill(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

