//---------------------------------------------------------------------------

#ifndef codeRecordBillH
#define codeRecordBillH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TformRecordBill : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TPanel *panelGroup;
        TGroupBox *groupAmounts;
        TLabel *_labelResidual;
        TLabel *_labelCharges;
        TLabel *_labelPaid;
        TLabel *_labelAllowed;
        TLabel *labelProcPayResiduals;
        TLabel *labelProcPayPaid;
        TLabel *labelProcPayAllowed;
        TLabel *_labelProcedurePaymentTotals;
        TLabel *_labelBillTotals;
        TLabel *_labelDollarCharges;
        TLabel *_labelDollarResidual;
        TLabel *_labelDollarPaid;
        TLabel *labelProcPayCharges;
        TEdit *editResiduals;
        TEdit *editCharges;
        TEdit *editPaid;
        TGroupBox *groupAbout;
        TLabel *_labelBillDate;
        TLabel *_labelPurchaseRequest;
        TLabel *_labelVisit;
        TLabel *_labelCheck;
        TLabel *_labelFomType;
        TLabel *_labelBillType;
        TLabel *_labelInvoiceNumber;
        TLabel *_labelNote;
        TDateTimePicker *dateBillDate;
        TComboBox *comboFormType;
        TComboBox *comboBillType;
        TEdit *editInvoiceNumber;
        TEdit *editNote;
        TGroupBox *groupBilledBy;
        TRadioButton *radioVendor;
        TRadioButton *radioProvider;
        TRadioButton *radioFacility;
        TRadioButton *radioGroup;
        TBitBtn *buttonSearchVendor;
        TBitBtn *buttonSearchProvider;
        TBitBtn *buttonSearchFacility;
        TBitBtn *buttonSearchGroup;
        TGroupBox *groupBilledTo;
        TLabel *_labelInsuranceCoverage;
        TBitBtn *buttonSearchInsuranceCoverage;
        TStaticText *staticVendor;
        TStaticText *staticProvider;
        TStaticText *staticFacility;
        TStaticText *staticGroup;
        TStaticText *staticInsuranceCoverage;
        TStaticText *staticVisit;
        TStaticText *staticPurchaseRequest;
        TStaticText *staticCheck;
        TBitBtn *buttonPrintBill;
        TScrollBox *ScrollBox2;
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TScrollBox *ScrollBox1;
        TTabSheet *TabSheet2;
        TListView *listTransactions;
        TStaticText *staticTransactionSummary;
        TStaticText *staticModifyTransactions;
        TTabSheet *TabSheet3;
        TListView *listProcedurePayments;
        TStaticText *staticPrintEOB;
        void __fastcall radioBillByClick(TObject *Sender);
        void __fastcall buttonSearchVendorClick(TObject *Sender);
        void __fastcall buttonSearchProviderClick(TObject *Sender);
        void __fastcall buttonSearchFacilityClick(TObject *Sender);
        void __fastcall buttonSearchGroupClick(TObject *Sender);
        void __fastcall buttonSearchInsuranceCoverageClick(TObject *Sender);
        void __fastcall buttonPrintBillClick(TObject *Sender);
        void __fastcall staticTransactionSummaryClick(TObject *Sender);
        void __fastcall staticModifyTransactionsClick(TObject *Sender);
        void __fastcall staticPrintEOBClick(TObject *Sender);
private:	// User declarations
        classFilterObject transactions_filter;
        classFilterObject payments_filter;
        int transactions_request;
        int payment_request;

        string actual_tax_id;
        string vendor_tax_id;
        string provider_tax_id;
        string facility_tax_id;
        string group_tax_id;
        string insurance_coverage_id;

        void CalcProcTotals();
        void CalcTransTotals();

        bool is_provider_bill()
        {
         return lookupTables->IdOf("bill_types", comboBillType) == lookupTables->IdOf("bill_types", "Incoming provider bill") ||
                lookupTables->IdOf("bill_types", comboBillType) == lookupTables->IdOf("bill_types", "Outgoing provider bill");
        }
        bool is_incoming_bill()
        {
         return lookupTables->IdOf("bill_types", comboBillType) == lookupTables->IdOf("bill_types", "Incoming provider bill") ||
                lookupTables->IdOf("bill_types", comboBillType) == lookupTables->IdOf("bill_types", "Incoming vendor bill");
        }

public:		// User declarations
        __fastcall TformRecordBill(TComponent* Owner, map<string,string> &p_parameters);

        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenStart();
        bool ScreenStop();
        bool ScreenLock();
        bool ScreenUnlock();
        bool NotNewAnymore();
        bool IsNewAgain();

        void AtlasRefreshListView(int request_num, string matched_value);

        void EditTransaction();
        void AddPayment();
        void EditPayment();
        static void Do(map<string, string> & p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordBill *formRecordBill;
//---------------------------------------------------------------------------
#endif
