//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordBugNotes.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordBugNotes *formRecordBugNotes;
//---------------------------------------------------------------------------
__fastcall TformRecordBugNotes::TformRecordBugNotes(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("bug_notes"))
{
  fields_to_leave_raw.insert("note");
  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordBugNotes::ScreenStart()
{
  lookupTables->RegisterComboBox("bug_note_types",cboType);
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordBugNotes::ScreenStop()
{
  lookupTables->UnregisterComboBox("bug_note_types", cboType);
  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordBugNotes::IsValidOnScreen()
{
  // check to make sure that the note is not longer than 255 characters
  // give the user a message box and prompt to re-enter if too long
  // make sure there is a link to a person, although there's not much the user
  // can do to fix that if there's not
  if (!lookupTables->IsInLookUpTable ("bug_note_types", cboType->Text.c_str()))
  {
   PSay("Please enter a valid note type", m_invalid_data, MB_OK);
   cboType->SetFocus();
   return false;
  } else
  if (initial_state["date_of_post"] == "")
  {
    PSay("There is no date associated with this record", m_missing_data, MB_OK);
    return false;
  } else
  if (editNote->Text == "")
  {
    PSay("You have not entered a note.", m_missing_data, MB_OK);
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformRecordBugNotes::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  //PSay(MapToDelimString(initial_state, "", "", "\n", "'", "'", "'", "'", "="), m_debug, MB_OK);
  editNote->Text = initial_state["note"].c_str();
  cboType->Text = PrettyString(lookupTables->ValueOf("bug_note_types", initial_state["bug_note_id"])).c_str();
  lblStatus->Caption = lookupTables->ValueOf("bug_status_types", initial_state["status_id"]).c_str();
  if (initial_state["date_of_post"] == "")
    initial_state["date_of_post"] = Pdate(Date()).OutDate(global_mode);
  lblDateOfPost->Caption = Pdate(initial_state["date_of_post"], mdy | yyyy).OutDate();
  if (IsBlankOrZero(initial_state["posted_by"]))
    initial_state["posted_by"] = current_userid;
  lblPostedBy->Caption = lookupTables->ValueOf("users", initial_state["posted_by"]).c_str();
  CreateLink(txtBug, NULL, this, initial_state["bug_id"], "bugs");

  TformRecordGeneric::PutDataOnScreen();
  return true; // what can really go wrong?
}
//---------------------------------------------------------------------------
bool TformRecordBugNotes::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  ending_state["note"] = editNote->Text.c_str();
  ending_state["bug_id"] = initial_state["bug_id"];
  ending_state["date_of_post"] = initial_state["date_of_post"];
  ending_state["posted_by"] = initial_state["posted_by"];     
  ending_state["status_id"] = initial_state["status_id"];
  ending_state["bug_note_id"] = lookupTables->IdOf("bug_note_types", cboType->Text.c_str());
  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();

  return true; // again, not much can go wrong here
}
//---------------------------------------------------------------------------
bool TformRecordBugNotes::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  editNote->ReadOnly = true;
  editNote->TabStop = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordBugNotes::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  editNote->ReadOnly = false;
  editNote->TabStop = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordBugNotes::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordBugNotes * z = new TformRecordBugNotes(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
