//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordCallLog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordCallLog *formRecordCallLog;
//---------------------------------------------------------------------------
__fastcall TformRecordCallLog::TformRecordCallLog(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("call_log"))
{
   Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordCallLog::ScreenStart()
{
  // register combo box
  lookupTables->RegisterComboBox("users", cboEmployee);
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordCallLog::ScreenStop()
{
  // unregister combo box
  lookupTables->UnregisterComboBox("users", cboEmployee);

  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordCallLog::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxe
  // corrospond to values in that look up table.
  // check to make sure the dates entered are valid
  // give the user a message box and prompt to re-enter if incorrect
  // make sure there is a link to a person, although there's not much the user
  // can do to fix that if there's not
  if (! lookupTables->IsInLookUpTable("users", cboEmployee->Text.c_str()))
  {
    PSay("Please enter a valid employee", m_invalid_data, MB_OK);
    cboEmployee->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformRecordCallLog::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  editCallerName->Text = PrettyString(initial_state["caller_name"]).c_str();
  cboEmployee->Text = lookupTables->ValueOf("users", initial_state["employee_id"]).c_str();
  editNotes->Text = SentenceString(initial_state["note"]).c_str();

  // get the person name associated with the person id that was either selected
  // from the database if it's an existing record, or passed to the form if
  // it's a new record. display the name as a link to the person record.

  TformRecordGeneric::PutDataOnScreen();
  return true; // what can really go wrong?
}
//---------------------------------------------------------------------------
bool TformRecordCallLog::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id

// is this line necessary?  Firebird doesn't like the format.  Check into it later
//  ending_state["call_time"] = initial_state["call_time"];
  ending_state["receptionist_id"] = initial_state["receptionist_id"];
  ending_state["caller_name"] = editCallerName->Text.c_str();
  ending_state["employee_id"] = lookupTables->IdOf("users", cboEmployee->Text.c_str()); 
  ending_state["id"] = initial_state["id"];
  ending_state["note"] = editNotes->Text.c_str();

  TformRecordGeneric::GetDataFromScreen();

  return true; // again, not much can go wrong here
}
//---------------------------------------------------------------------------
bool TformRecordCallLog::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordCallLog::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordCallLog::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordCallLog * z = new TformRecordCallLog(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------


