//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordCaseNotes.h"
#include "reportCaseNotes.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordCaseNotes *formRecordCaseNotes;
//---------------------------------------------------------------------------
__fastcall TformRecordCaseNotes::TformRecordCaseNotes(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner,  p_parameters, string("case_notes"))
{
  fields_to_leave_raw.insert("note");

  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordCaseNotes::ScreenStart()
{
  txtPrint->Font->Color = link_color;

  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordCaseNotes::ScreenStop()
{
  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordCaseNotes::IsValidOnScreen()
{
  if ((initial_state["person_id"] == "") || (initial_state["person_id"] == "0"))
  {
    PSay("There is no person associated with this record", m_missing_data, MB_OK);
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformRecordCaseNotes::IsNewAgain()
{
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordCaseNotes::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  editNote->Text = initial_state["note"].c_str();
  CreateLink(txtPerson, NULL, this, initial_state["person_id"], "people");

  TformRecordGeneric::PutDataOnScreen();
  return true; // what can really go wrong?
}
//---------------------------------------------------------------------------
bool TformRecordCaseNotes::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  ending_state["note"] = editNote->Text.c_str();
  if (initial_state["group_id"] == "")
    ending_state["group_id"] = "0";
  else
    ending_state["group_id"] = initial_state["group_id"];
  ending_state["person_id"] = initial_state["person_id"];
  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();

  return true; // again, not much can go wrong here
}
//---------------------------------------------------------------------------
bool TformRecordCaseNotes::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  editNote->ReadOnly = true;
  editNote->TabStop = false;
  TformRecordGeneric::ScreenLock();

  set<string> group_permissions = GetGroupPermissions("table.case_notes", "", "update", "true");
  buttonA->Enabled = group_permissions.find(initial_state["group_id"]) != group_permissions.end();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordCaseNotes::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  editNote->ReadOnly = false;
  editNote->TabStop = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordCaseNotes::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordCaseNotes * z = new TformRecordCaseNotes(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordCaseNotes::txtPrintClick(TObject *Sender)
{
  FORM_TRY
   TformCaseNotesReport *notes = new TformCaseNotesReport(NULL);
   notes->lblPerson->Caption = "for " + txtPerson->Caption;
   notes->memoNote->Lines->Clear();
   notes->memoNote->Lines->Add(editNote->Text);
   notes->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
   notes->report->Preview();
  FORM_CATCH
}
//---------------------------------------------------------------------------

