//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordComDrug.h"
#include "codeSearchPerson.h"
#include "codeRecordPerson.h"
#include "codeRecordTaskDiab.h"
#include "codeRecordTaskBeh.h"
#include "codeRecordComVisit.h"
#include "codeSearchFDADrug.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma link "codeHalfButton"
#pragma resource "*.dfm"
TformRecordComDrug *formRecordComDrug;
//---------------------------------------------------------------------------
__fastcall TformRecordComDrug::TformRecordComDrug(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("com_drug_regimen"))
{
  fields_to_leave_raw.insert("purpose");
  fields_to_leave_raw.insert("note");

  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordComDrug::ScreenStart()
{
  lookupTables->RegisterComboBox("com_medication_types", cboMedicationType);
  lookupTables->RegisterComboBox("com_frequency_types",  cboFrequency);
  lookupTables->RegisterComboBox("com_status_types",     cboStatus);

  TformRecordGeneric::ScreenStart();
  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComDrug::ScreenStop()
{
  lookupTables->UnregisterComboBox("com_medication_types", cboMedicationType);
  lookupTables->UnregisterComboBox("com_frequency_types",  cboFrequency);
  lookupTables->UnregisterComboBox("com_status_types",     cboStatus);

  TformRecordGeneric::ScreenStop();
  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComDrug::IsValidOnScreen()
{
  if(editMedication->Text == "")
  {
    PSay("Please specify a medication", m_invalid_data, MB_OK);
    return false;
  }
  if (!lookupTables->IsInLookUpTable("com_medication_types", cboMedicationType->Text.c_str()))
  {
    PSay("Please enter a valid medication type", m_invalid_data, MB_OK);
    cboMedicationType->SetFocus();
    return false;
  }
  if (!lookupTables->IsInLookUpTable("com_status_types", cboStatus->Text.c_str()))
  {
    PSay("Please enter a valid status type", m_invalid_data, MB_OK);
    cboStatus->SetFocus();
    return false;
  }
  if (editDose->Text == "")
  {
    PSay("Please enter a valid dosage", m_invalid_data, MB_OK);
    editDose->SetFocus();
    return false;
  }
  if (!lookupTables->IsInLookUpTable("com_frequency_types", cboFrequency->Text.c_str()))
  {
    PSay("Please enter a valid frequency", m_invalid_data, MB_OK);
    cboFrequency->SetFocus();
    return false;
  }
  if (editDateOrdered->Text != "" && !Pdate(editDateOrdered->Text.c_str(), mdy|yy).IsValidDate())
  {
    PSay("Please enter a valid date ordered", m_invalid_data, MB_OK);
    editDateOrdered->SetFocus();
    return false;
  }
  if (editDateDiscont->Text != "" && !Pdate(editDateDiscont->Text.c_str(), mdy|yy).IsValidDate())
  {
    PSay("Please enter a valid date discontinued", m_invalid_data, MB_OK);
    editDateDiscont->SetFocus();
    return false;
  }

  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComDrug::PutDataOnScreen()
{
  editDateOrdered->Text   = initial_state["date_ordered"].c_str();
  editDateDiscont->Text   = initial_state["date_discontinued"].c_str();
  cboMedicationType->Text = PrettyString(lookupTables->ValueOf("com_medication_types", initial_state["com_medication_id"])).c_str();
  cboFrequency->Text      = PrettyString(lookupTables->ValueOf("com_frequency_types",  initial_state["com_frequency_id" ])).c_str();
  cboStatus->Text         = PrettyString(lookupTables->ValueOf("com_status_types",     initial_state["com_status_id"    ])).c_str();
  editMedication->Text    = PrettyString(initial_state["medication"]).c_str();
  editDose->Text          = LowercaseString(initial_state["dosage"]).c_str();
  editRxNumber->Text      = initial_state["rx_number"].c_str();
  editPurpose->Text       = initial_state["purpose"].c_str();
  editNotes->Text         = initial_state["note"].c_str();

  CreateLink(staticName, btnPatientSearch, this, initial_state["person_id"], "people");

  TformRecordGeneric::PutDataOnScreen();
  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComDrug::GetDataFromScreen()
{
  // jhaley: Dates are now optional as they're not tracking that information in Community Health.
  // Other departments may want to use it, though.
  if(editDateOrdered->Text != "")
    ending_state["date_ordered"] = Pdate(editDateOrdered->Text.c_str(), mdy|yy).OutDate(mdy | yyyy);
  else
    ending_state["date_ordered"] = "";
  if(editDateDiscont->Text != "")
    ending_state["date_discontinued"] = Pdate(editDateDiscont->Text.c_str(), mdy|yy).OutDate(mdy | yyyy);
  else
    ending_state["date_discontinued"] = "";
  ending_state["com_medication_id"] = lookupTables->IdOf("com_medication_types", cboMedicationType->Text.c_str());
  ending_state["com_frequency_id"]  = lookupTables->IdOf("com_frequency_types", cboFrequency->Text.c_str());
  ending_state["com_status_id"]     = lookupTables->IdOf("com_status_types", cboStatus->Text.c_str());
  ending_state["task_id"]           = initial_state["task_id"];
  ending_state["id"]                = initial_state["id"];
  ending_state["group_id"]          = initial_state["group_id"];
  ending_state["purpose"]           = editPurpose->Text.c_str();
  ending_state["note"]              = editNotes->Text.c_str();

  // jhaley 20101027: Moved here from PutDataOnScreen
  string person_id = GetValidLinkId(staticName);
  if(StringToInt(person_id) > 0)
    ending_state["person_id"] = person_id;
  else
    ending_state["person_id"] = "0";

  if (editMedication->Text != "")
    ending_state["medication"] = editMedication->Text.c_str();
  else
    ending_state["medication"] = "";

  ending_state["dosage"] = editDose->Text.c_str();

  if (editRxNumber->Text != "")
    ending_state["rx_number"] = editRxNumber->Text.c_str();
  else
    ending_state["rx_number"] = "";


  TformRecordGeneric::GetDataFromScreen();

  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComDrug::ScreenLock()
{
  panelGroup->Enabled = false;
  // jhaley: These controls must not be on the panel - the link was hidden, and one of the half buttons should also
  // remain enabled when the form is locked.
  btnPatientSearch->Enabled = false; // you can click the link but not search for a new person
  editMedication->ReadOnly = true;   // you cannot change the medication text or click the search button
  hbtnSearchFDA->Enabled = false;    // (but you CAN use the "..." button to look it up!)
  TformRecordGeneric::ScreenLock();
  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComDrug::ScreenUnlock()
{
  panelGroup->Enabled = true;
  btnPatientSearch->Enabled = true;
  editMedication->ReadOnly = false;
  hbtnSearchFDA->Enabled = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordComDrug::btnPatientSearchClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson *formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(staticName, btnPatientSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformRecordComDrug::txtTaskClick(TObject *Sender)
{
  if ((initial_state["task_id"] != "") && (initial_state["task_id"] != "0"))
  {
    map<string, string> temp_map;
    temp_map["id"] = initial_state["task_id"];
    string group_id = GetOneField(dbDatabase, "select group_id from tasks where id = " + initial_state["task_id"]);
    if((group_id == lookupTables->IdOf("groups", "Diabetes")) &&
       (optionsPermissions["table.tasks.diab"]["view"] == "true"))
    {
      FORM_TRY
        TformRecordTaskDiab * diabTaskScreen = new TformRecordTaskDiab(NULL, temp_map);
        diabTaskScreen->Show();
      FORM_CATCH
    }
    if((group_id == lookupTables->IdOf("groups", "Community Health"))||
       (group_id == lookupTables->IdOf("groups", "Public Health")) &&
           (optionsPermissions["table.tasks.com"]["view"] == "true"))
    {
      FORM_TRY
        TformRecordComVisit *comTaskScreen = new TformRecordComVisit(NULL, temp_map);
        comTaskScreen->Show();
      FORM_CATCH
    }
  }
}
//---------------------------------------------------------------------------
void TformRecordComDrug::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordComDrug * z = new TformRecordComDrug(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
// jhaley 20110506: Allow searching for a medication in the FDA drug database
void __fastcall TformRecordComDrug::hbtnSearchFDAClick(TObject *Sender)
{
  pvecstr drug_vec = TformSearchFDADrug::Do(this);

  if(drug_vec.size() > 0)
    editMedication->Text = PrettyString(drug_vec[0]).c_str();
}
//---------------------------------------------------------------------------
// jhaley 20110506: Allow finding the specified medication in the FDA drug database
void __fastcall TformRecordComDrug::hbtnLookupFDAClick(TObject *Sender)
{
  if(editMedication->Text != "")
  {
    string med_text = editMedication->Text.c_str();
    string drug_id;   // ID, assuming there is one in the string
    string drug_name; // name, used if there's no ID
    int as_int = StringToInt(med_text);
    if(as_int > 0)
      drug_id = IntToString(as_int);
    else
    {
      size_t first_letter = med_text.find_first_not_of("0123456789- ");
      if(first_letter != string::npos)
        drug_name = med_text.substr(first_letter);
    }
    TformSearchFDADrug::Do(drug_id, drug_name);
  }
}
//---------------------------------------------------------------------------

