//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordComHealth.h"
#include "codeSearchTaskCom.h"
#include "codeSearchTaskPub.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordComHealth *formRecordComHealth;
//---------------------------------------------------------------------------
__fastcall TformRecordComHealth::TformRecordComHealth(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("com_health_edu"))
{
  Initialize();
}
//------------------------------------------ ---------------------------------
bool TformRecordComHealth::ScreenStart()
{
  if (initial_state["group_id"] == lookupTables->IdOf("groups", "Community Health"))
  {
    lookupTables->RegisterComboBox ("com_adult_topic_types", cboTopic);
  }
  else if (initial_state["group_id"] == lookupTables->IdOf("groups", "Caregiver Support Program"))
  {
    lookupTables->RegisterComboBox ("care_topic_types", cboTopic);
  }
  else
  {
    lookupTables->RegisterComboBox ("com_topic_types", cboTopic);
  }

  if (initial_state["group_id"] == lookupTables->IdOf("groups", "Caregiver Support Program"))
    lookupTables->RegisterComboBox ("care_classification_types", cboLearner);
  else
    lookupTables->RegisterComboBox ("com_learner_types", cboLearner);

  lookupTables->RegisterComboBox ("com_method_types", cboMethod);
  lookupTables->RegisterComboBox ("com_evaluation_types", cboEvaluation);

  TformRecordGeneric::ScreenStart();
  return true;

}
//----------------------------------------------------------------------------
bool TformRecordComHealth::ScreenStop()
{
  if (initial_state["group_id"] == lookupTables->IdOf("groups", "Community Health"))
  {
    lookupTables->UnregisterComboBox ("com_adult_topic_types", cboTopic);
  }
  else if (initial_state["group_id"] == lookupTables->IdOf("groups", "Caregiver Support Program"))
  {
    lookupTables->UnregisterComboBox ("care_topic_types", cboTopic);
  }
  else
  {
    lookupTables->UnregisterComboBox("com_topic_types", cboTopic);
  }

  if (initial_state["group_id"] == lookupTables->IdOf("groups", "Caregiver Support Program"))
    lookupTables->UnregisterComboBox ("care_classification_types", cboLearner);
  else
    lookupTables->UnregisterComboBox ("com_learner_types", cboLearner);

  lookupTables->UnregisterComboBox("com_method_types", cboMethod);
  lookupTables->UnregisterComboBox("com_evaluation_types", cboEvaluation);

  TformRecordGeneric::ScreenStop();
  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComHealth::IsValidOnScreen()
{
 if(! lookupTables->IsInLookUpTable("com_method_types", cboMethod->Text.c_str()))
  {
    PSay("Please enter a valid method of contact", m_invalid_data, MB_OK);
    cboMethod->SetFocus();
    return false;
  }
 else if (cboMethod->Text =="")
 {
    PSay("Please enter a valid method of contact", m_invalid_data, MB_OK);
    cboMethod->SetFocus();
    return false;
 }
 else if ((initial_state["group_id"] == lookupTables->IdOf("groups", "Community Health")) &&
         (!lookupTables->IsInLookUpTable("com_adult_topic_types", cboTopic->Text.c_str())))
  {
    PSay("Please enter a valid Community Health topic", m_invalid_data, MB_OK);
    cboTopic->SetFocus();
    return false;
  }
 else if ((initial_state["group_id"] == lookupTables->IdOf("groups", "Public Health")) &&
          (! lookupTables->IsInLookUpTable("com_topic_types", cboTopic->Text.c_str())))
  {
    PSay("Please enter a valid Public Health topic", m_invalid_data, MB_OK);
    cboTopic->SetFocus();
    return false;
  }
 else if ((initial_state["group_id"] == lookupTables->IdOf("groups", "Caregiver Support Program")) &&
          (! lookupTables->IsInLookUpTable("care_topic_types", cboTopic->Text.c_str())))
  {
    PSay("Please enter a valid Caregiver Support Program topic", m_invalid_data, MB_OK);
    cboTopic->SetFocus();
    return false;
  }
 else if (cboTopic->Text == "")
 {
    PSay("Please enter a valid topic", m_invalid_data, MB_OK);
    cboTopic->SetFocus();
    return false;
 }
 else if ((initial_state["group_id"] == lookupTables->IdOf("groups", "Community Health") || initial_state["group_id"] == lookupTables->IdOf("groups", "Public Health")) &&
          (!lookupTables->IsInLookUpTable("com_learner_types", cboLearner->Text.c_str())))
  {
    PSay("Please enter a valid learner", m_invalid_data, MB_OK);
    cboLearner->SetFocus();
    return false;
  }
 else if ((initial_state["group_id"] == lookupTables->IdOf("groups", "Caregiver Support Program")) &&
          (!lookupTables->IsInLookUpTable("care_classification_types", cboLearner->Text.c_str())))
  {
    PSay("Please enter a valid Caregiver Support Program learner", m_invalid_data, MB_OK);
    cboLearner->SetFocus();
    return false;
  }
 else if (cboLearner->Text == "")
 {
    PSay("Please enter a valid learner", m_invalid_data, MB_OK);
    cboLearner->SetFocus();
    return false;
 }
 else if (!lookupTables->IsInLookUpTable("com_evaluation_types", cboEvaluation->Text.c_str()))
  {
    PSay("Please enter a valid evaluation", m_invalid_data, MB_OK);
    cboEvaluation->SetFocus();
    return false;
  }
 else if (cboEvaluation->Text == "")
 {
    PSay("Please enter a valid evaluation", m_invalid_data, MB_OK);
    cboEvaluation->SetFocus();
    return false;
 }
 else
    return true;
}
//----------------------------------------------------------------------------
bool TformRecordComHealth::PutDataOnScreen()
{
  string sql;
  string sql_id;

  if ((initial_state["person_id"]== "") || (initial_state["person_id"] == "0"))
      initial_state["person_id"] = person;

  if (lookupTables->ValueOf("groups", initial_state["group_id"]) == "Community Health")
    cboTopic->Text = PrettyString(lookupTables->ValueOf("com_adult_topic_types", initial_state["com_adult_topic_id"])).c_str();
  else if (lookupTables->ValueOf("groups", initial_state["group_id"]) == "Caregiver Support Program")
    cboTopic->Text = PrettyString(lookupTables->ValueOf("care_topic_types", initial_state["care_topic_id"])).c_str();
  else
    cboTopic->Text = PrettyString(lookupTables->ValueOf("com_topic_types", initial_state["com_topic_id"])).c_str();

  if (lookupTables->ValueOf("groups", initial_state["group_id"]) == "Caregiver Support Program")
    cboLearner->Text = PrettyString(lookupTables->ValueOf("care_classification_types", initial_state["care_classification_id"])).c_str();
  else
    cboLearner->Text = PrettyString(lookupTables->ValueOf("com_learner_types", initial_state["com_learner_id"])).c_str();

  cboMethod->Text = PrettyString(lookupTables->ValueOf("com_method_types", initial_state["com_method_id"])).c_str();
  cboEvaluation->Text = PrettyString(lookupTables->ValueOf("com_evaluation_types", initial_state["com_evaluation_id"])).c_str();

  CreateLink(txtPerson, NULL, this, initial_state["person_id"], "people");
  CreateLink(lblVisit, NULL, this, initial_state["task_id"], "tasks");

  TformRecordGeneric::PutDataOnScreen();
  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComHealth::GetDataFromScreen()
{
  if (lookupTables->ValueOf("groups", initial_state["group_id"]) == "Community Health")
  {
   ending_state["com_adult_topic_id"] = lookupTables->IdOf("com_adult_topic_types", cboTopic->Text.c_str());
   ending_state["com_topic_id"] = "0";
   ending_state["care_topic_id"] = "0";
  }
  else if (lookupTables->ValueOf("groups", initial_state["group_id"]) == "Caregiver Support Program")
  {
   ending_state["care_topic_id"] = lookupTables->IdOf("care_topic_types", cboTopic->Text.c_str());
   ending_state["com_topic_id"] =  "0";
   ending_state["com_adult_topic_id"] = "0";
  }
  else
  {
   ending_state["com_topic_id"] = lookupTables->IdOf("com_topic_types", cboTopic->Text.c_str());
   ending_state["com_adult_topic_id"] = "0";
   ending_state["care_topic_id"] = "0";
  }

  if (lookupTables->ValueOf("groups", initial_state["group_id"]) == "Caregiver Support Program")
  {
   ending_state["care_classification_id"] = lookupTables->IdOf("care_classification_types", cboLearner->Text.c_str());
   ending_state["com_learner_id"]= "0";
  }
  else
  {                 
   ending_state["com_learner_id"] = lookupTables->IdOf("com_learner_types",cboLearner->Text.c_str());
   ending_state["care_classification_id"] = "0";
  }

   person = initial_state["person_id"];
   ending_state["com_method_id"] = lookupTables->IdOf("com_method_types", cboMethod->Text.c_str());
   ending_state["com_evaluation_id"] = lookupTables->IdOf("com_evaluation_types", cboEvaluation->Text.c_str());
   ending_state["task_id"] = initial_state["task_id"];
   ending_state["group_id"] = initial_state["group_id"];
   ending_state["id"] = initial_state["id"];

 TformRecordGeneric::GetDataFromScreen();

  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComHealth::ScreenLock()
{
  // disable panel containing edit boxes
  panelEducation->Enabled = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComHealth::ScreenUnlock()
{
  panelEducation->Enabled = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//----------------------------------------------------------------------------
void __fastcall TformRecordComHealth::btnVisitSearchClick(TObject *Sender)
{
  if(lookupTables->ValueOf("groups", initial_state["group_id"]) == "Community Health")
  {
   // create and show new visit search form
   vector<string> return_vector;
   FORM_TRY
     TformSearchTaskCom * task_search = new TformSearchTaskCom(NULL, &return_vector);
     task_search->ShowTaskModal(this);
   FORM_CATCH

   if (! return_vector.empty())
   {
     initial_state["task_id"] = return_vector[0];
     CreateLink(lblVisit, NULL, this, initial_state["task_id"], "tasks");
   }
  }
  else if(lookupTables->ValueOf("groups", initial_state["group_id"]) == "Caregiver Support Program")
  {
   PSay("This search screen does not exist yet", m_warning, MB_OK);
   return;

   // TODO: seems [matt?] meant to kill this off until the TformSearchTaskPub was ready -- never happened?
   /* this code was generating a warning about unreachable code -- who the FUCK turned off warnings globally ?!?
   // create and show new visit search form
   vector<string> return_vector;
   FORM_TRY
     TformSearchTaskPub * task_search = new TformSearchTaskPub(NULL, &return_vector);
     task_search->ShowTaskModal(this);
   FORM_CATCH
   if (! return_vector.empty())
   {
     initial_state["task_id"] = return_vector[0];
     CreateLink(lblVisit, NULL, this, initial_state["task_id"], "tasks");
   }
   */
  }
  else
  {
   // create and show new visit search form
   vector<string> return_vector;
   FORM_TRY
     TformSearchTaskPub * task_search = new TformSearchTaskPub(NULL, &return_vector);
     task_search->ShowTaskModal(this);
   FORM_CATCH

   if (! return_vector.empty())
   {
     initial_state["task_id"] = return_vector[0];
     CreateLink(lblVisit, NULL, this, initial_state["task_id"], "tasks");
   }
  }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordComHealth::FormClose(TObject *Sender, TCloseAction &Action)
{
  TformRecordGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void TformRecordComHealth::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordComHealth * z = new TformRecordComHealth(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

