//---------------------------------------------------------------------------

#include <vcl.h>                                   
#pragma hdrstop

#include "codeRecordComNutrition.h"
#include "codeRecordPerson.h"
#include "codeRecordTaskDiab.h"
#include "codeRecordTaskBeh.h"
#include "codeRecordComVisit.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordComNutrition *formRecordComNutrition;
//---------------------------------------------------------------------------
__fastcall TformRecordComNutrition::TformRecordComNutrition(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("com_nutrition"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordComNutrition::ScreenStart()
{
  lookupTables->RegisterComboBox ("com_formula_types", cboFormula);
  lookupTables->RegisterComboBox ("com_ingredient_types", cboFormulaType);
  lookupTables->RegisterComboBox ("com_feeding_types", cboFeedingType);

  TformRecordGeneric::ScreenStart();
  return true;

}
//----------------------------------------------------------------------------
bool TformRecordComNutrition::ScreenStop()
{
  lookupTables->UnregisterComboBox("com_formula_types", cboFormula);
  lookupTables->UnregisterComboBox("com_ingredient_types", cboFormulaType);
  lookupTables->UnregisterComboBox("com_feeding_types", cboFeedingType);

  TformRecordGeneric::ScreenStop();
  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComNutrition::IsValidOnScreen()
{
  if (! IsInt(editNumFeeding->Text.c_str()))
  {
    PSay("Please enter a valid number for how often", m_invalid_data, MB_OK);
    editNumFeeding->SetFocus();
    return false;
  }
  else if (! IsFloat(editTime->Text.c_str()))
  {
    PSay("Please enter a valid time for how long the feedings are", m_invalid_data, MB_OK);
    editTime->SetFocus();
    return false;
  }
  else if (! IsInt(editStools->Text.c_str()))
  {
    PSay("Please enter a valid number of stools", m_invalid_data, MB_OK);
    editStools->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("com_formula_types", cboFormula->Text.c_str()))
  {
    PSay("Please enter a valid formula", m_invalid_data, MB_OK);
    cboFormula->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("com_ingredient_types", cboFormulaType->Text.c_str()))
  {
    PSay("Please enter a valid formula type", m_invalid_data, MB_OK);
    cboFormulaType->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("com_feeding_types", cboFeedingType->Text.c_str()))
  {
    PSay("Please enter a valid feeding type", m_invalid_data, MB_OK);
    cboFeedingType->SetFocus();
    return false;
  }
  else if (! IsFloat(editAmount->Text.c_str()))
  {
    PSay("Please enter a valid amount of formula", m_invalid_data, MB_OK);
    editAmount->SetFocus();
    return false;
  }
  else
    return true;
}
//----------------------------------------------------------------------------
bool TformRecordComNutrition::PutDataOnScreen()
{
 editNumFeeding->Text = initial_state["feeding_number"].c_str();
 editTime->Text = initial_state["feeding_time"].c_str();
 editAmount->Text = initial_state["feeding_amount"].c_str();
 cboFormula->Text = PrettyString(lookupTables->ValueOf("com_formula_types", initial_state["com_formula_id"])).c_str();
 cboFormulaType->Text = PrettyString(lookupTables->ValueOf("com_ingredient_types", initial_state["com_ingredient_id"])).c_str();
 cboFeedingType->Text = PrettyString(lookupTables->ValueOf("com_feeding_types", initial_state["com_feeding_id"])).c_str();
 editStools->Text = initial_state["stool_number"].c_str();

 if (initial_state["feeding_observed"]!= "0")
   chkObserved->Checked;
 if (initial_state["diaper_number"] != "0")
   chkWetDiapers->Checked;

  CreateLink(staticName, NULL, this, initial_state["person_id"], "people");
  CreateLink(lblVisit, NULL, this, initial_state["task_id"], "tasks");

  TformRecordGeneric::PutDataOnScreen();
  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComNutrition::GetDataFromScreen()
{

  if(editNumFeeding->Text != "")
    ending_state["feeding_number"] = editNumFeeding->Text.c_str();
  else
    ending_state["feeding_number"] = "0";
  if(editTime->Text != "")
    ending_state["feeding_time"] = editTime->Text.c_str();
  else
    ending_state["feeding_time"] = "";
  if (editStools->Text != "")
    ending_state["stool_number"] = editStools->Text.c_str();
  else
    ending_state["stool_number"] = "0";
  if (editAmount->Text != "")
    ending_state["feeding_amount"] = editAmount->Text.c_str();
  else
    ending_state["feeding_amount"] = "0";
  if (! chkObserved->Checked)
    ending_state["feeding_observed"] = "0";
  else
    ending_state["feeding_observed"] = "1";
  if (! chkWetDiapers->Checked)
    ending_state["diaper_number"] = "0";
  else
    ending_state["diaper_number"] = "1";

  if (cboFormula->Text != "")
    ending_state["com_formula_id"] = lookupTables->IdOf("com_formula_types", cboFormula->Text.c_str());
  else
    ending_state["com_formula_id"] = "0";
  if (cboFormulaType->Text != "")
    ending_state["com_ingredient_id"] = lookupTables->IdOf("com_ingredient_types", cboFormulaType->Text.c_str());
  else
    ending_state["com_ingredient_id"] = "0";
  if (cboFeedingType->Text != "")
    ending_state["com_feeding_id"] = lookupTables->IdOf("com_feeding_types", cboFeedingType->Text.c_str());
  else
    ending_state["com_feeding_id"] = "0";

  ending_state["id"] = initial_state["id"];
  ending_state["task_id"] = initial_state["task_id"];


  TformRecordGeneric::GetDataFromScreen();

  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComNutrition::ScreenLock()
{
 // disable panel containing edit boxes
  panelGroup->Enabled = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComNutrition::ScreenUnlock()
{
  panelGroup->Enabled = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//----------------------------------------------------------------------------
void __fastcall TformRecordComNutrition::StaticText1Click(TObject *Sender)
{
 if ((initial_state["task_id"] != "") && (initial_state["task_id"] != "0"))
  {
    map<string, string> temp_map;
    temp_map["id"] = initial_state["task_id"];
    string group_id = GetOneField(dbDatabase, "select group_id from tasks where id = " + initial_state["task_id"]);
//    PSay(group_id.c_str(), m_message, MB_OK);
 /*   if((group_id == lookupTables->IdOf("groups", "Diabetes")) &&
      (optionsPermissions["table.tasks.diab"]["view"] == "true"))
    {
      FORM_TRY
        TformRecordTaskDiab * diabTaskScreen = new TformRecordTaskDiab(NULL, temp_map);
        diabTaskScreen->Show();
      FORM_CATCH
    } */
    if((group_id == lookupTables->IdOf("groups", "Public Health")) &&
           (optionsPermissions["table.tasks.com"]["view"] == "true"))
    {
      FORM_TRY
        TformRecordComVisit * comTaskScreen = new TformRecordComVisit(NULL, temp_map);
        comTaskScreen->Show();
      FORM_CATCH
    }
  }
}
//---------------------------------------------------------------------------
void TformRecordComNutrition::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordComNutrition * z = new TformRecordComNutrition(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

