//---------------------------------------------------------------------------

// is map getting everything?
#include <vcl.h>
#pragma hdrstop

#include "codeRecordComVisit.h"
#include "codeSearchPerson.h"
#include "codeRecordComNutrition.h"
#include "codeRecordCondition.h"
#include "codeRecordComHealth.h"
#include "codeRecordTaskNotes.h"
#include "codeRecordProcedure.h"
#include "codeSearchEvent.h"
#include "codeSpecialSelectListview.h"
#include "codeRecordPatientAssessment.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma link "codeRubberContainer"
#pragma link "codeFrameObservationList"
#pragma resource "*.dfm"
TformRecordComVisit *formRecordComVisit;

//---------------------------------------------------------------------------
__fastcall TformRecordComVisit::TformRecordComVisit(TComponent* Owner,map<string,string> p_parameters)
        :com_filter() , TformRecordGeneric(Owner, p_parameters, string("tasks"))
{
  community_comments_filter.SetListViewHandle (listComComments);
  community_comments_filter.SetSecurity("task_notes.com");
  community_comments_filter.AddColumnSpec("Notes", "task_notes", as_text, true, 300, sentenceString);
  community_comments_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  community_comments_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  community_comments_filter.FetchPreferences("recordcomvisit.community_comments_filter");
  community_comments_filter.SetSQLStatement("");
  community_comments_filter.RefreshDataSet();

  community_procedure_filter.SetListViewHandle (listComProcedure);
  community_procedure_filter.SetSecurity("procedures");
  community_procedure_filter.AddColumnSpec("Start Date", "procedures", as_date, true, 100);
  community_procedure_filter.AddColumnSpec("Stop Date", "procedures", as_date, false, 100);
  community_procedure_filter.AddColumnSpec("Place of Service", "procedures", as_text, false, 110);
  community_procedure_filter.AddColumnSpec("Type of Service", "procedures", as_text, false, 110);
  community_procedure_filter.AddColumnSpec("Cpt/Hcpcs Code", "procedures", as_text, true, 105);
  community_procedure_filter.AddColumnSpec("Modifier", "procedures", as_text, false, 105);
  community_procedure_filter.AddColumnSpec("Charges", "procedures", as_text, false, 100);
  community_procedure_filter.AddColumnSpec("Days/Units", "procedures", as_text, false, 100);
  community_procedure_filter.AddColumnSpec("EPSDT", "procedures", as_text, false, 100);
  community_procedure_filter.AddColumnSpec("EMG", "procedures", as_text, false, 100);
  community_procedure_filter.AddColumnSpec("COB", "procedures", as_text, false, 100);
  community_procedure_filter.AddColumnSpec("Local Use", "procedures", as_text, false, 100);
  community_procedure_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  community_procedure_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  community_procedure_filter.FetchPreferences("recordcomvisit.community_procedures_filter");
  community_procedure_filter.SetSQLStatement("");
  community_procedure_filter.RefreshDataSet();

  community_conditions_filter.SetListViewHandle(listComCondition);
  community_conditions_filter.SetSecurity("conditions.com");
  community_conditions_filter.AddColumnSpec("Condition Type", "conditions", as_text, true, 120);
  community_conditions_filter.AddColumnSpec("Begin", "conditions", as_date, false, 100);
  community_conditions_filter.AddColumnSpec("End", "conditions", as_date, false, 100);
  community_conditions_filter.AddColumnSpec("Code", "conditions", as_text, true, 100);
  community_conditions_filter.AddColumnSpec("Note", "conditions", as_text, false, 100, sentenceString);
  community_conditions_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  community_conditions_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  community_conditions_filter.SetIconStatus(true);
  community_conditions_filter.FetchPreferences("recordcomvisit.community_conditions_filter");
  community_conditions_filter.SetSQLStatement("");
  community_conditions_filter.RefreshDataSet();

  community_edu_filter.SetListViewHandle(listComEducation);
  community_edu_filter.SetSecurity("com_health_edu");
  community_edu_filter.AddColumnSpec("Topic", "com_health_edu", as_text, true, 80);
  community_edu_filter.AddColumnSpec("Learner", "com_health_edu", as_text, true,80);
  community_edu_filter.AddColumnSpec("Method", "com_health_edu",as_text,true,80);
  community_edu_filter.AddColumnSpec("Evaluation", "com_health_edu", as_text, true, 80);  
  community_edu_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  community_edu_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  community_edu_filter.FetchPreferences("recordcomvisit.community_edu_filter");
  community_edu_filter.SetSQLStatement("");
  community_edu_filter.RefreshDataSet();

  community_nutrition_filter.SetListViewHandle(listComNutrition);
  community_nutrition_filter.SetSecurity("com_nutrition");
  community_nutrition_filter.AddColumnSpec("Method", "com_nutrition", as_text, true, 120);
  community_nutrition_filter.AddColumnSpec("Formula", "com_nutrition", as_text, true, 120);
  community_nutrition_filter.AddColumnSpec("Ingredients", "com_nutrition", as_int, true, 120);
  community_nutrition_filter.AddColumnSpec("Number of Feedings", "com_nutrition", as_text, true, 120);
  community_nutrition_filter.AddColumnSpec("Feeding Time", "com_nutrition", as_text, true, 120);
  community_nutrition_filter.AddColumnSpec("Amount (oz)", "com_nutrition", as_int, true, 80);
  community_nutrition_filter.AddColumnSpec("Number of Stools", "com_nutrition", as_int, false, 80);
  community_nutrition_filter.AddColumnSpec("Feeding Observed", "com_nutrition", as_text,true, 80);
  community_nutrition_filter.AddColumnSpec("Diaper Number", "com_nutrition", as_text, false, 80);
  community_nutrition_filter.AddColumnSpec("Task_id", "com_nutrition", as_text, false, 80);    
  community_nutrition_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  community_nutrition_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  community_nutrition_filter.FetchPreferences("recordcomvisit.community_nutrition_filter");
  community_nutrition_filter.SetSQLStatement("");
  community_nutrition_filter.RefreshDataSet();

  middle_section = new custom_row_container(scrollVisit);

  txtAssessmentLink->Font->Color = link_color;

  Initialize();
}
//------------------------------------------------------------------
bool TformRecordComVisit::ScreenStart()
{
  // set the date to today
  cboDate->Date = Now();
  cboTime->Time = Now();

  lookupTables->RegisterComboBox("users", cboStaff);
  lookupTables->RegisterComboBox("com_visit_types", cboVisitType);
  lookupTables->RegisterComboBox("visit_location_types", cboLocation);
  lookupTables->RegisterComboBox("visit_outcome_types", cboOutcome);

  // note there was never a pub_task_id in tasks so just use Community Health's idea of the lookup.
  string task_sql = "select id, item, valid from task_purpose_types where group_id = 0 or group_id = '"
                    + lookupTables->IdOf("groups", "Community Health") + "' ";
  lookupTables->RegisterComboBox("task_purpose_types", cboTaskType, task_sql);

  TformRecordGeneric::ScreenStart();

  if (is_editing)
   NotNewAnymore();

  return true;

}
//----------------------------------------------------------------------------
bool TformRecordComVisit::ScreenStop()
{
   // unregister combo box
  lookupTables->UnregisterComboBox("users", cboStaff);
  lookupTables->UnregisterComboBox("com_visit_types", cboVisitType);
  lookupTables->UnregisterComboBox("visit_location_types", cboLocation);
  lookupTables->UnregisterComboBox("visit_outcome_types", cboOutcome);
  lookupTables->UnregisterComboBox("task_purpose_types", cboTaskType);

  delete middle_section;

  TformRecordGeneric::ScreenStop();
  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComVisit::IsValidOnScreen()
{

  // check to make sure that the values entered in the combo box
  // corrospond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect

  if (!lookupTables->IsInLookUpTable("users", cboStaff->Text.c_str()))
  {
    PSay("Please enter a valid staff name", m_invalid_data, MB_OK);
    cboStaff->SetFocus();
    return false;
  }
  else if (cboStaff->Text == "")
  {
    PSay("Please enter a valid staff name", m_invalid_data, MB_OK);
    cboStaff->SetFocus();
    return false;
  }
  else if (!IsFloat(editMileage->Text.c_str()))
  {
    PSay("Please enter a valid mileage", m_invalid_data, MB_OK);
    editMileage->SetFocus();
    return false;
  }
  else if (!IsFloat(editPatientTime->Text.c_str()))
  {
    PSay("Please enter a valid patient time", m_invalid_data, MB_OK);
    editPatientTime->SetFocus();
    return false;
  }
  else if (!IsFloat(editTotalTime->Text.c_str()))
  {
    PSay("Please enter a valid total time", m_invalid_data, MB_OK);
    editTotalTime->SetFocus();
    return false;
  }
  else if (!lookupTables->IsInLookUpTable("com_visit_types", cboVisitType->Text.c_str()))
  {
    PSay("Please enter a valid visit type", m_invalid_data, MB_OK);
    cboVisitType->SetFocus();
    return false;
  }
  else if (!lookupTables->IsInLookUpTable("visit_location_types", cboLocation->Text.c_str()))
  {
    PSay("Please enter a valid location", m_invalid_data, MB_OK);
    cboLocation->SetFocus();
    return false;
  }
  else if (!lookupTables->IsInLookUpTable("visit_outcome_types", cboOutcome->Text.c_str()))
  {
    PSay("Please enter a valid outcome", m_invalid_data, MB_OK);
    cboOutcome->SetFocus();
    return false;
  }
  else if (cboStaff->Text == "")
  {
    PSay("Please enter a staff name", m_invalid_data, MB_OK);
    cboStaff->SetFocus();
    return false;
  }
  else if (!lookupTables->IsInLookUpTable("task_purpose_types", cboTaskType))
  {
    PSay("Please enter a valid task type", m_invalid_data, MB_OK);
    cboTaskType->SetFocus();
    return false;
  }
  else if (!IsInt(initial_state["group_id"]) || StringToInt(initial_state["group_id"]) <= 0)
  {
    // jhaley: invalid group_id isn't allowed and should not be possible.
    PSay("This visit does not belong to a valid department. Please contact a programmer if this occured while creating a new visit.",
         m_program_error, MB_OK);
    return false;
  }

  if (cboVisitType->Text == "")
  {
    if (IDNO == PSay("Temporary: Blank visit types are currently allowed.\nHowever, the search screen will ignore "
                     "records that have no visit type.\nLeaving it as-is may make it difficult or impossible to find "
                     "this record later.\nAre you sure you want to continue?", m_confirmation, MB_YESNO))
      return false;
  }

  // jhaley 20100802: logic adapted from Diabetes task form to do special logic checks for task types
  string person_id = GetValidLinkId(txtPerson);
  if (GetValidLinkId(txtEvent) == "")
  {
    // no event...
    if (cboTaskType->Text == "Event Preparation" || cboTaskType->Text == "Event Teaching/Leading" ||
        cboTaskType->Text == "Event Contact")
    {
      // ...but this task type implies that the task should be attached to an event.
      PSay("This task is not attached to an event, but you have specified a 'Task Type' reserved for events.\n\n"
           "Please attach this task to the appropriate event, or select a different (or blank) Task Type.",
           m_invalid_data, MB_OK);
      cboTaskType->Show();
      cboTaskType->SetFocus();
      return false;
    }

    // for Com/Pub visits, a person is always required when not attached to an event
    if (person_id == "")
    {
      PSay("Please select a valid client", m_missing_data, MB_OK);
      btnPersonSearch->SetFocus();
      return false;
    }
  }
  else
  {
    // attached to an event...
    if(person_id == "" && cboTaskType->Text == "Event Contact")
    {
      // ...but this task type implies that a person should be specified, and one is not.
      PSay("This task is part of an event with a 'Task Type' indicating credit for contact with a client, but no client is "
           "selected.\n\nPlease search for the Client Name of the event participant, or select a different (or blank) Task "
           "Type.", m_invalid_data, MB_OK);
      btnPersonSearch->Show();
      btnPersonSearch->SetFocus();
      return false;
    }
    else if (StringToInt(person_id) > 0 &&
             (cboTaskType->Text == "Event Preparation" || cboTaskType->Text == "Event Teaching/Leading"))
    {
      // ..but this task type shouldn't have a person, and it does.
      PSay("This task is part of an event with a 'Task Type' indicating teaching/leading or preparation, but a Client Name "
           "is selected.\n\nPlease unlink the client that is selected and use the Event screen to create contacts for the "
           "appropriate participants. You can unlink the client by pressing the search button, then pressing 'Select' without "
           "performing a search (link text will change to 'None').", m_invalid_data, MB_OK);
      btnPersonSearch->Show();
      btnPersonSearch->SetFocus();
      return false;
    }
  }

  return true;
}
//----------------------------------------------------------------------------
// ResetAssessmentLink - jhaley 20111028
void TformRecordComVisit::ResetAssessmentLink()
{
  // jhaley 20111028: Assessment link
  if(IsInt(initial_state["id"]))
  {
    string assessment_sql =
      "select first 1 id "
      "from patient_assessment "
      "where task_id = '" + initial_state["id"] + "' "
      "order by last_update_stamp desc, current_id desc "; // latest and most current assessment only.

    if(!IsBlankOrZero(GetOneField(dbDatabase, assessment_sql)))
      txtAssessmentLink->Caption = "Go to assessment";
    else
      txtAssessmentLink->Caption = "Click to add an assessment";
  }
  else
    txtAssessmentLink->Caption = "None";
}
//----------------------------------------------------------------------------
bool TformRecordComVisit::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  CreateLink(txtPerson, btnPersonSearch, this, initial_state["person_id"], "people");
  CreateLink(txtEvent,  btnEventSearch,  this, initial_state["event_id"],  "events");

  // jhaley:
  ResetAssessmentLink();

  if (initial_state["date_of_task"] != "")
    cboDate->Date = Pdate(initial_state["date_of_task"], mdy | yyyy).OutDate();
  else
    cboDate->Date = Date();
  if (initial_state["time_of_task"] != "")
    cboTime->Time = Ptime(initial_state["time_of_task"], withsec | military).OutTime();
  else
    cboTime->Time = StrToTime("08:00:00");

  editTotalTime->Text = initial_state["time_spent"].c_str();
  editMileage->Text = initial_state["mileage"].c_str();
  editPatientTime->Text = initial_state["visit_time_spent"].c_str();
  if (initial_state["new_client"] == "1")
    chkNew->Checked = true;
  else
    chkNew->Checked = false;

  cboStaff->Text     = PrettyString(lookupTables->ValueOf("users",                initial_state["user_id"])).c_str();
  cboVisitType->Text = PrettyString(lookupTables->ValueOf("com_visit_types",      initial_state["com_visit_id"])).c_str();
  cboLocation->Text  = PrettyString(lookupTables->ValueOf("visit_location_types", initial_state["visit_location_id"])).c_str();
  cboOutcome->Text   = PrettyString(lookupTables->ValueOf("visit_outcome_types",  initial_state["visit_outcome_id"])).c_str();
  cboTaskType->Text  = PrettyString(lookupTables->ValueOf("task_purpose_types",   initial_state["task_purpose_id"], cboTaskType)).c_str();

  groupComVisit->Caption =
    string(lookupTables->ValueOf("com_dept_types", initial_state["com_dept_id"]) +
           " Visit Information (comments are saved only if the checkbox is checked)").c_str();

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  try
  {
    StdTransaction (dbTransaction, dbDatabase);
    if (initial_state["com_dept_id"] == "")
      initial_state["com_dept_id"] = "0";
    scrollVisit->VertScrollBar->Visible = false;
    if (!middle_section->load_entries(dbTransaction, initial_state["com_dept_id"], initial_state["id"]))
      throw(1);
    scrollVisit->VertScrollBar->Visible = true;
    if (dbTransaction->Active)
      dbTransaction->Commit();
  }
  catch (...)
  {
    PSay("Failed to update middle section to match rest of screen. (Not good.) Please inform a programmer of this.", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;

  TformRecordGeneric::PutDataOnScreen();
  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComVisit::GetDataFromScreen()
{
  TformRecordGeneric::GetDataFromScreen();
  if (!CreateInsertMap(dbDatabase, "tasks", ending_state))
    return false;

  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id

  ending_state["id"] = initial_state["id"];
  string person_id = GetValidLinkId(txtPerson);
  if(StringToInt(person_id) > 0)
    ending_state["person_id"] = person_id;
  else
    ending_state["person_id"] = "0";
  string event_id = GetValidLinkId(txtEvent);
  if(StringToInt(event_id) > 0)
    ending_state["event_id"] = event_id;
  else
    ending_state["event_id"] = "0";
  if(cboStaff->Text != "")
    ending_state["user_id"] = lookupTables->IdOf("users", cboStaff->Text.c_str());
  else
    ending_state["user_id"] = "0";
  if (editPatientTime->Text != "")
    ending_state["visit_time_spent"] = editPatientTime->Text.c_str();
  else
    ending_state["visit_time_spent"] = "0";
  if (editTotalTime->Text != "")
    ending_state["time_spent"] = editTotalTime->Text.c_str();
  else
    ending_state["time_spent"] = "0";
  if (editMileage->Text != "")
    ending_state["mileage"] = editMileage->Text.c_str();
  else
    ending_state["mileage"] = "0";
  if (cboOutcome->Text != "")
    ending_state["visit_outcome_id"] = lookupTables->IdOf("visit_outcome_types", cboOutcome->Text.c_str());
  else
    ending_state["visit_outcome_id"] = "0";
  if (cboLocation->Text != "")
    ending_state["visit_location_id"] = lookupTables->IdOf("visit_location_types", cboLocation->Text.c_str());
  else
    ending_state["visit_location_id"] = "0";
  if (cboVisitType->Text != "")
    ending_state["com_visit_id"]= lookupTables->IdOf("com_visit_types", cboVisitType->Text.c_str());
  else
    ending_state["com_visit_id"] = "0";
  if(chkNew->Checked == true)
    ending_state["new_client"]="1";
  else
    ending_state["new_client"]="0";

  ending_state["group_id"] = initial_state["group_id"]; // jhaley: constant across this form.
  ending_state["date_of_task"] = Pdate(cboDate->Date).OutDate(mdy | yyyy);
  ending_state["time_of_task"] = Ptime(cboTime->Time).OutTime(withsec | military);
  ending_state["com_dept_id"] = initial_state["com_dept_id"];
  ending_state["task_purpose_id"] = lookupTables->IdOf("task_purpose_types", cboTaskType->Text.c_str(), cboTaskType);

  if (ending_state["com_dept_id"] == "" || ending_state["com_dept_id"] == "0")
  {
    PSay("You are attempting to save a record with an invalid com_dept_id.\n"
         "This isn't your fault. However, we're trying to track down how this happens.\n"
         "Please contact any programmer immediately and tell them what you did to get to this screen.", m_program_error, MB_OK);
    return false;
  }

  ending_state["method_id"] = lookupTables->IdOf("method_types", "Visit");

  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComVisit::ScreenLock()
{
  // disable group boxes
  groupGenVisit->Enabled = false;
  groupPatient->Enabled = false;
  // scrollVisit->Enabled = false;
  middle_section->set_lock(true);
  TformRecordGeneric::ScreenLock();
  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComVisit::ScreenUnlock()
{
  // enable group boxes
  groupGenVisit->Enabled = true;
  groupPatient->Enabled = true;
  // scrollVisit->Enabled = true;
  middle_section->set_lock(false);
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordComVisit::btnPersonSearchClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (!return_vector.empty())
    CreateLink(txtPerson, btnPersonSearch, this, return_vector[0], "people");
}
//----------------------------------------------------------------------------
void __fastcall TformRecordComVisit::FormClose(TObject *Sender, TCloseAction &Action)
{
  TformRecordGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
bool TformRecordComVisit::BeforeSave()
{
  return (middle_section->save_entries(lock_transaction, ending_state["id"]));
}
//-----------------------------------------------------------------------------
bool TformRecordComVisit::NotNewAnymore()
{
  frameObs->SetSource(obs_list_task, initial_state["id"]);

  string sql;
  string where;

  if (optionsPermissions["table.procedures"]["view"] == "true")
  {
    sql =   "select procedures.start_date, procedures.stop_date, procedures.place_of_service, "
            "procedures.type_of_service, procedures.cpt_hcpcs, procedures.modifier, "
            "procedures.charges, procedures.days_units, procedures.epsdt, procedures.emg, procedures.cob, "
            "procedures.local_use, procedures.current_id, procedures.id "
            "from procedures "
            "where procedures.task_id = " + initial_state["id"];

    community_procedure_filter.SetSQLStatement(sql);
    community_procedure_filter.RefreshDataSet();
    community_procedure_filter.SetAddEdit(this, AddRecord(&(TformRecordComVisit::AddComProcedure)),
                                                EditRecord(&(TformRecordComVisit::EditComProcedure)));
    community_procedure_request = atlas->RequestNotificationWhen("procedures.task_id", initial_state["id"], rel_any, as_int, this,
                                    RefreshHandler(&(TformRecordComVisit::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.task_notes.com"]["view"] == "true")
  {
    sql = "select note, current_id, id from task_notes where ";

    if (lookupTables->ValueOf("groups", initial_state["group_id"]) == "Community Health")
      sql += "group_id = " + lookupTables->IdOf("groups", "Community Health") + " and ";
    else
      sql += "group_id = " +lookupTables->IdOf("groups", "Public Health") + " and ";
    sql +="task_notes.task_id = " + initial_state["id"];

    community_comments_filter.SetSQLStatement(sql);
    community_comments_filter.RefreshDataSet();
    community_comments_filter.SetAddEdit(this, AddRecord(&(TformRecordComVisit::AddComComments)),
                                               EditRecord(&(TformRecordComVisit::EditComComments)));
    community_comments_request = atlas->RequestNotificationWhen("task_notes.task_id", initial_state["id"], rel_any, as_int, this,
                                   RefreshHandler(&(TformRecordComVisit::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.conditions.com"]["view"] == "true")
  {
    sql = "select condition_types.item, conditions.start_date, conditions.stop_date, "
          "conditions.code, conditions.note, conditions.current_id, conditions.id "
          "from conditions, condition_types "
          "where conditions.condition_id = condition_types.id and ";
    if (lookupTables->ValueOf("groups", initial_state["group_id"]) == "Community Health")
      sql += "conditions.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and ";
    else
      sql += "conditions.group_id = " +lookupTables->IdOf("groups", "Public Health") + " and ";
    sql +="conditions.task_id = " + initial_state["id"];

    community_conditions_filter.SetSQLStatement(sql);
    community_conditions_filter.RefreshDataSet();
    community_conditions_filter.SetAddEdit(this, AddRecord(&(TformRecordComVisit::AddComConditions)),
                                                 EditRecord(&(TformRecordComVisit::EditComConditions)));
    community_conditions_request = atlas->RequestNotificationWhen("conditions.task_id", initial_state["id"], rel_any, as_int, this,
                               RefreshHandler(&(TformRecordComVisit::AtlasRefreshListViews)));
  }

  if (initial_state["group_id"] == lookupTables->IdOf("groups", "Public Health"))
  {
    if (optionsPermissions["table.com_health_edu"]["view"] == "true")
    {
      sql = "select com_topic_types.item, com_learner_types.item, com_method_types.item, "
            "com_evaluation_types.item, com_health_edu.current_id, com_health_edu.id "
            "from "
            "com_health_edu, com_learner_types, com_topic_types, com_method_types, com_evaluation_types "
            "where com_learner_types.id = com_health_edu.com_learner_id and "
            "com_topic_types.id = com_health_edu.com_topic_id and "
            "com_method_types.id = com_health_edu.com_method_id and "
            "com_evaluation_types.id = com_evaluation_id and "
            "com_health_edu.task_id = " + initial_state["id"];

      community_edu_filter.SetSQLStatement(sql);
      community_edu_filter.RefreshDataSet();
      community_edu_filter.SetAddEdit(this, AddRecord(&(TformRecordComVisit::AddComEdu)),
                                            EditRecord (&(TformRecordComVisit::EditComEdu)));
      community_edu_request = atlas->RequestNotificationWhen("com_health_edu.task_id", initial_state["id"], rel_any, as_int, this,
                                RefreshHandler(&(TformRecordComVisit::AtlasRefreshListViews)));
    }
  }

  if (initial_state["group_id"] == lookupTables->IdOf("groups", "Community Health"))
  {
    if (optionsPermissions["table.com_health_edu"]["view"] == "true")
    {
      sql = "select com_adult_topic_types.item, "
            "com_learner_types.item, com_method_types.item, com_evaluation_types.item, "
            "com_health_edu.current_id, com_health_edu.id "
            "from "
            "com_health_edu, com_learner_types, com_adult_topic_types, com_method_types, com_evaluation_types "
            "where com_learner_types.id = com_health_edu.com_learner_id and "
            "com_adult_topic_types.id = com_health_edu.com_adult_topic_id and "
            "com_method_types.id = com_health_edu.com_method_id and "
            "com_evaluation_types.id = com_evaluation_id and "
            "com_health_edu.task_id = " + initial_state["id"];

      community_edu_filter.SetSQLStatement(sql);
      community_edu_filter.RefreshDataSet();
      community_edu_filter.SetAddEdit(this, AddRecord(&(TformRecordComVisit::AddComEdu)),
                                            EditRecord (&(TformRecordComVisit::EditComEdu)));
      community_edu_request = atlas->RequestNotificationWhen("com_health_edu.task_id", initial_state["id"], rel_any, as_int, this,
                                RefreshHandler(&(TformRecordComVisit::AtlasRefreshListViews)));
    }
  }

  if (optionsPermissions["table.com_nutrition"]["view"] == "true")
  {
    sql = "select com_feeding_types.item, "
          "com_formula_types.item, com_ingredient_types.item, com_nutrition.feeding_number, "
          "com_nutrition.feeding_time, com_nutrition.feeding_amount, com_nutrition.stool_number, "
          "com_nutrition.feeding_observed, com_nutrition.diaper_number,  "
          "com_nutrition.task_id, com_nutrition.current_id, com_nutrition.id "
          "from "
          "com_nutrition, com_ingredient_types, com_formula_types, com_feeding_types where "
          "com_ingredient_types.id = com_nutrition.com_ingredient_id and "
          "com_formula_types.id = com_nutrition.com_formula_id and "
          "com_feeding_types.id = com_nutrition.com_feeding_id and "
          "com_nutrition.task_id = " + initial_state["id"];

    community_nutrition_filter.SetSQLStatement(sql);
    community_nutrition_filter.RefreshDataSet();
    community_nutrition_filter.SetAddEdit(this, AddRecord(&(TformRecordComVisit::AddComNutrition)),
                                            EditRecord (&(TformRecordComVisit::EditComNutrition)));
    community_nutrition_request = atlas->RequestNotificationWhen("com_nutrition.task_id", initial_state["id"], rel_any, as_int, this,
                               RefreshHandler(&(TformRecordComVisit::AtlasRefreshListViews)));
  }

  // jhaley 20111028: assessment request
  patient_assessment_request =
    atlas->RequestNotificationWhen("patient_assessment.task_id", initial_state["id"], rel_any, as_int, this,
                                   RefreshHandler(&TformRecordComVisit::AtlasRefreshListViews));

  TformRecordGeneric::NotNewAnymore();
  return true;
}
//----------------------------------------------------------------------------
bool TformRecordComVisit::IsNewAgain()
{
  frameObs->SetSource(obs_list_none, "0");

  community_comments_filter.SetSQLStatement(string(""));
  community_comments_filter.RefreshDataSet();
  community_comments_filter.SetAddEdit(this, NULL, NULL);

  community_conditions_filter.SetSQLStatement(string(""));
  community_conditions_filter.RefreshDataSet();
  community_conditions_filter.SetAddEdit(this, NULL, NULL);

  community_procedure_filter.SetSQLStatement(string(""));
  community_procedure_filter.RefreshDataSet();
  community_procedure_filter.SetAddEdit(this, NULL, NULL);

  community_edu_filter.SetSQLStatement(string(""));
  community_edu_filter.RefreshDataSet();
  community_edu_filter.SetAddEdit(this, NULL, NULL);

  community_nutrition_filter.SetSQLStatement(string(""));
  community_nutrition_filter.RefreshDataSet();
  community_nutrition_filter.SetAddEdit(this, NULL, NULL);

  TformRecordGeneric::IsNewAgain();
  return true;
}
//---------------------------------------------------------------------------
/*
void TformRecordComVisit::EditComMeasurement()
{
  map<string,string> temp_map;
  temp_map["task_id"] = initial_state["id"];
  temp_map["id"] = community_measurement_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordMeasurement * measurementRecord = new TformRecordMeasurement(NULL, temp_map);
    measurementRecord->Show();
  FORM_CATCH
}
*/
//---------------------------------------------------------------------------
void TformRecordComVisit::AddComProcedure()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = GetValidLinkId(txtPerson);
  temp_map["task_id"] = initial_state["id"];
  temp_map["group_id"] = initial_state["group_id"];
  FORM_TRY
    TformRecordProcedure * procedureRecord = new TformRecordProcedure(NULL, temp_map);
    procedureRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordComVisit::EditComProcedure()
{
  map<string,string> temp_map;
  temp_map["task_id"] = initial_state["id"];
  temp_map["id"] = community_procedure_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordProcedure * procedureRecord = new TformRecordProcedure(NULL, temp_map);
    procedureRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
/*
void TformRecordComVisit::AddComMeasurement()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["person_id"];
  temp_map["task_id"] = initial_state["id"];
  temp_map["group_id"] = initial_state["group_id"];
  FORM_TRY
    TformRecordMeasurement * measurementRecord = new TformRecordMeasurement(NULL, temp_map);
    measurementRecord->Show();
  FORM_CATCH
}
*/
//---------------------------------------------------------------------------
void TformRecordComVisit::EditComComments()
{
  map<string,string> temp_map;
  temp_map["task_id"] = initial_state["id"];
  temp_map["person_id"] = GetValidLinkId(txtPerson);         // added person and group id --MTEG 12/5/2002
  temp_map["group_id"] =  initial_state["group_id"];
  temp_map["id"] = community_comments_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordTaskNotes * noteRecord = new TformRecordTaskNotes(NULL, temp_map);
     noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordComVisit::AddComComments()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["task_id"] = initial_state["id"];
  temp_map["person_id"] = GetValidLinkId(txtPerson);
  temp_map["group_id"] =  initial_state["group_id"];
  FORM_TRY
    TformRecordTaskNotes * noteRecord = new TformRecordTaskNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordComVisit::EditComConditions()
{
  map<string,string> temp_map;
  temp_map["id"] = community_conditions_filter.GetSelectedRecordID();
  temp_map["task_id"] = initial_state["id"];
  FORM_TRY
    TformRecordCondition * conditionRecord = new TformRecordCondition(NULL, temp_map);
    conditionRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordComVisit::AddComConditions()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = GetValidLinkId(txtPerson);
  temp_map["task_id"] = initial_state["id"];
  temp_map["group_id"] = initial_state["group_id"];
  FORM_TRY
    TformRecordCondition * conditionRecord = new TformRecordCondition(NULL, temp_map);
    conditionRecord->Show();
  FORM_CATCH
}

//---------------------------------------------------------------------------
void TformRecordComVisit::EditComEdu()
{
  map<string,string> temp_map;
  temp_map["person_id"] = GetValidLinkId(txtPerson);
  temp_map["group_id"] = initial_state["group_id"];
  temp_map["id"] = community_edu_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordComHealth * comHealthRecord = new TformRecordComHealth(NULL, temp_map);
    comHealthRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordComVisit::AddComEdu()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["task_id"] = initial_state["id"];
  temp_map["person_id"] = GetValidLinkId(txtPerson);
  temp_map["group_id"] = initial_state["group_id"];
  FORM_TRY
    TformRecordComHealth * comHealthRecord = new TformRecordComHealth(NULL, temp_map);
    comHealthRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordComVisit::EditComNutrition()
{
  map<string,string> temp_map;
  temp_map["person_id"] = GetValidLinkId(txtPerson);
  temp_map["task_id"] = initial_state["id"];
  temp_map["id"] = community_nutrition_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordComNutrition * comNutritionRecord = new TformRecordComNutrition(NULL, temp_map);
    comNutritionRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordComVisit::AddComNutrition()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = GetValidLinkId(txtPerson);
  temp_map["task_id"] = initial_state["id"];
  FORM_TRY
    TformRecordComNutrition *comNutritionRecord = new TformRecordComNutrition(NULL, temp_map);
    comNutritionRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
bool TformRecordComVisit::AtlasRefreshListViews(int request_num, string matched_value)
{
  if (request_num == community_comments_request)
    community_comments_filter.RefreshDataSet();
  else if (request_num == community_conditions_request)
    community_conditions_filter.RefreshDataSet();
  else if (request_num == community_edu_request)
    community_edu_filter.RefreshDataSet();
  else if (request_num == community_procedure_request)
    community_procedure_filter.RefreshDataSet();
  else if (request_num == community_nutrition_request)
    community_nutrition_filter.RefreshDataSet();
  else if (request_num == com_filter_request)
    com_filter.RefreshDataSet();
  else if (request_num == patient_assessment_request)
    ResetAssessmentLink(); // jhaley 20111028
  return true;
}
//--------------------------------------------------------------------------
void TformRecordComVisit::Do(map<string, string> & p_parameters)
{
  bool should_exit = false;

  // jhaley: support selection of com_dept_id when invoked using this static method. This comes in handy from places
  // like the person form where a dept_type was just being guessed and then could not be changed afterward.
  if(p_parameters.find("com_dept_id") == p_parameters.end() || p_parameters["com_dept_id"] == "" ||
     StringToInt(p_parameters["com_dept_id"]) <= 0)
  {
    ::PSay("Select a Visit Type from the next window. If you are unsure, you can cancel by clicking 'Close'.",
           m_message, MB_OK, "TformRecordComVisit::Do");
    TIBTransaction *local_transaction = new TIBTransaction(NULL);
    try
    {
      string answer_str = "";
      string sql;
      StdTransaction(local_transaction, dbDatabase);
      FORM_TRY
        TformSpecialSelectListview *selectDeptForm = new TformSpecialSelectListview(NULL, &answer_str);
        selectDeptForm->Filter->AddColumnSpec("Visit Type", "", as_text, true, 100);
        selectDeptForm->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 40);
        selectDeptForm->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 40);
        selectDeptForm->Filter->SetIconStatus(true);
        selectDeptForm->SourceTableName = "com_dept_types";
        sql = "select (item || ' Visit'), " + CleverCurrentId("valid", "1", "Current", "Expired") + ", id "
              "from com_dept_types "
              "where valid = 1 and item <> '' "
              "order by item";
        selectDeptForm->Execute(local_transaction, sql);
        selectDeptForm->ShowModal();
      FORM_CATCH

      if (answer_str != "") // only if something valid was chosen do we go on.
        p_parameters["com_dept_id"] = answer_str;
      else
        should_exit = true;

      local_transaction->Commit();
    }
    catch (...)
    {
      ::PSay("An error occured while trying to retrieve the list of visit types.", m_database_error, MB_OK, "TformRecordComVisit::Do");
      if (local_transaction->Active)
        local_transaction->Rollback();
      should_exit = true;
    }
    delete local_transaction;
  }

  if (!should_exit)
  {
    FORM_TRY
      TformRecordComVisit * z = new TformRecordComVisit(NULL, p_parameters);
      z->Show();
    FORM_CATCH
  }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordComVisit::scrollVisitMouseWheelDown(
      TObject *Sender, TShiftState Shift, TPoint &MousePos, bool &Handled)
{
  if (scrollVisit->Visible)
    scrollVisit->VertScrollBar->Position += scrollVisit->VertScrollBar->Increment;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordComVisit::scrollVisitMouseWheelUp(
      TObject *Sender, TShiftState Shift, TPoint &MousePos, bool &Handled)
{
  if (scrollVisit->Visible)
    scrollVisit->VertScrollBar->Position -= scrollVisit->VertScrollBar->Increment;
}
//---------------------------------------------------------------------------
// jhaley 20100813: Added to allow attachment to events.
void __fastcall TformRecordComVisit::btnEventSearchClick(TObject *Sender)
{
  vector<string> return_vector;
  FORM_TRY
    TformSearchEvent *eventSearch = new TformSearchEvent(NULL, &return_vector, initial_state["group_id"]);
    eventSearch->ShowTaskModal(this);
  FORM_CATCH
  if (!return_vector.empty())
    CreateLink(txtEvent, btnEventSearch, this, return_vector[0], "events");
}
//---------------------------------------------------------------------------
void __fastcall TformRecordComVisit::txtAssessmentLinkClick(TObject *Sender)
{
  // jhaley 20111028: Assessment link
  if(IsInt(initial_state["id"]))
  {
    string assessment_sql =
      "select first 1 id "
      "from patient_assessment "
      "where task_id = '" + initial_state["id"] + "' "
      "order by last_update_stamp desc, current_id desc "; // latest and most current assessment only.

    string assessment_id = GetOneField(dbDatabase, assessment_sql);
    map<string, string> field_map;

    if(!IsBlankOrZero(assessment_id))
      field_map["id"] = assessment_id; // View the assessment
    else
    {
      field_map["id"]      = "new";               // Create a new assessment
      field_map["task_id"] = initial_state["id"]; // Attach to this task
    }
    TformRecordPatientAssessment *assmtForm = NULL;
    FORM_TRY
      assmtForm = new TformRecordPatientAssessment(NULL, field_map);
    FORM_CATCH_RETURN("TformRecordPatientAssessment", )
    assmtForm->Show();
  }
  else
    PSay("Please save the visit you are working on first.", m_reminder, MB_OK);
}
//---------------------------------------------------------------------------

