//---------------------------------------------------------------------------

#ifndef codeRecordComVisitH
#define codeRecordComVisitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <CheckLst.hpp>
#include <Menus.hpp>
#include "codeRubberContainer.h"
#include "codeFrameObservationList.h"
//---------------------------------------------------------------------------
// template <class T>
// int TemplateDetails (T z, T a, T b, T c);

struct custom_row_pointers
{
  TPanel *    entry_panel;
  TCheckBox * entry_done;
  TEdit *     entry_comment;
  string      com_nurse_topics_id;
  string      com_visit_topics_id;
};

class custom_row_container
{
 private:
  vector<custom_row_pointers> custom_rows;
  bool should_be_locked;
  string current_com_dept_id;
  string current_task_id;
  TWinControl * current_containing_window;
 public:
  custom_row_container (TWinControl * containing_window) : current_containing_window(containing_window), should_be_locked(false) {}

  void set_lock (bool value)
  {
   should_be_locked = value;
   for (vector<custom_row_pointers>::iterator i_row = custom_rows.begin(); i_row != custom_rows.end(); i_row++)
    i_row->entry_panel->Enabled = !should_be_locked;
  }

  bool load_entries (TIBTransaction * dbTransaction, string com_dept_id, string task_id)
  {
   // we hope it doesn't contain anything else of importance ... oops =)
   current_containing_window->DestroyComponents();
   custom_rows.clear();
   current_containing_window->Repaint();
   current_com_dept_id = com_dept_id;
   current_task_id     = task_id;
   if (current_task_id == "" || current_task_id == "new")
    current_task_id = "0";
   vector<map<string, string> > entries_and_values;
   if (!SqlToVecMap(dbTransaction, "select com_nurse_topics.id nurse_id, com_nurse_topics.nurse_label nurse_label, com_visit_topics.id visit_id, com_visit_topics.comments visit_comment from com_nurse_topics left join com_visit_topics on com_visit_topics.com_nurse_topic_id = com_nurse_topics.id and com_visit_topics.task_id = " + current_task_id + " where com_nurse_topics.com_dept_id = " + current_com_dept_id + " order by com_nurse_topics.id", entries_and_values))
    return false;
   else
   {
    unsigned int current_top = 1;
    unsigned int big_width = current_containing_window->ClientWidth - 6; // that'd be scrollbar, some other size ... stuff. magic.
    for (vector<map<string, string> >::iterator i_entry = entries_and_values.begin(); i_entry != entries_and_values.end(); i_entry++)
    {
     custom_row_pointers new_row;
     new_row.entry_panel         = new TPanel(current_containing_window);
     new_row.entry_done          = new TCheckBox(new_row.entry_panel);
     new_row.entry_comment       = new TEdit(new_row.entry_panel);
     new_row.com_nurse_topics_id = (*i_entry)["nurse_id"];
     new_row.com_visit_topics_id = (*i_entry)["visit_id"];

     current_containing_window->InsertControl(new_row.entry_panel);

     new_row.entry_panel->Top = current_top;
     new_row.entry_panel->Left = 0;
     new_row.entry_panel->Width = big_width; // TODO: should be GetSystemMetrics, something about width of bars?
     new_row.entry_panel->Height = 24; // that's how much we change between rows
     new_row.entry_panel->BevelInner = bvNone;
     new_row.entry_panel->BevelOuter = bvNone;
     new_row.entry_panel->Caption = "";
     new_row.entry_panel->Enabled = !should_be_locked;
     new_row.entry_panel->Anchors << akRight;

     new_row.entry_done->Checked = (new_row.com_visit_topics_id != "");
     new_row.entry_done->Caption = PrettyString((*i_entry)["nurse_label"]).c_str();
     new_row.entry_done->Left    = 6;   // the scroll box eats 2 already, so to get 8, add 6 to the left side
     new_row.entry_done->Top     = 0; // current_top;
     new_row.entry_done->Width   = 215; // 222 - 8 -- (entry_comment->Left - 8)

     new_row.entry_comment->Left = 223; // 224 - 8 + 6 -- label minus other lable plus scroll box left side (8-2)
     new_row.entry_comment->Top  = 0; // current_top;
     new_row.entry_comment->Width = new_row.entry_panel->ClientWidth - new_row.entry_comment->Left; // (145 + 80) - 16; // width of text + width of label - scroll bar area
     new_row.entry_comment->MaxLength = 250;
     new_row.entry_comment->Text = SentenceString((*i_entry)["visit_comment"]).c_str();
     new_row.entry_comment->Anchors << akRight;

     new_row.entry_panel->InsertControl(new_row.entry_done);
     new_row.entry_panel->InsertControl(new_row.entry_comment);

     new_row.entry_done->Visible = true;
     new_row.entry_comment->Visible = true;
     new_row.entry_panel->Visible = true;

     custom_rows.push_back(new_row);

     current_top += 24;
    }

    // jog it back into responding?
    for (vector<custom_row_pointers>::iterator i_row = custom_rows.begin(); i_row != custom_rows.end(); i_row++)
    {
     i_row->entry_panel->Left = i_row->entry_panel->Left + 1;
     i_row->entry_panel->Left = i_row->entry_panel->Left - 1;
     i_row->entry_comment->Left = i_row->entry_comment->Left + 1;
     i_row->entry_comment->Left = i_row->entry_comment->Left - 1;
    }

    // none selected?
    if (current_top == 1)
    {
     TLabel * oops_label = new TLabel(current_containing_window);
     oops_label->Top = current_top;
     oops_label->Left = 8;
     oops_label->AutoSize = true;
     oops_label->Caption = "No items were found for this topic group: please contact a programmer.";
     oops_label->Visible = true;
     current_containing_window->InsertControl(oops_label);
    }
   }
   return true;
  }

  bool save_entries (TIBTransaction * dbTransaction, string task_id)
  {
   if ((current_task_id != "" && current_task_id != "new" && current_task_id != "0") && task_id != current_task_id)
    {PSay("ID values do not match!", m_debug, MB_OK, "save_entries"); return false;}
   else
   {
    vector<string> valid_entries;
    for (vector<custom_row_pointers>::iterator i_row = custom_rows.begin(); i_row != custom_rows.end(); i_row++)
    {
     map<string, string> field_values;
     if (i_row->entry_done->Checked)
      if (i_row->com_visit_topics_id == "")
      {
       // insert
       field_values["id"]                 = GetNextId(dbTransaction, "com_visit_topics");
       field_values["comments"]           = i_row->entry_comment->Text.c_str();
       field_values["current_id"]         = "4";
       field_values["last_update_stamp"]  = RightNow();
       field_values["last_updated_by"]    = current_userid;
       field_values["com_nurse_topic_id"] = i_row->com_nurse_topics_id;
       field_values["task_id"]            = task_id;
       valid_entries.push_back(field_values["id"]);
       if(!ExecuteInsertStatement(dbTransaction, "com_visit_topics", field_values))
        {PSay("Could not insert a row", m_debug, MB_OK, "save_entries"); return false;}
      }
      else
      {
       // update
       field_values["id"]                 = i_row->com_visit_topics_id;
       field_values["comments"]           = i_row->entry_comment->Text.c_str();
       field_values["last_update_stamp"]  = RightNow();
       field_values["last_updated_by"]    = current_userid;
       valid_entries.push_back(field_values["id"]);
       if (!ExecuteUpdateStatement(dbTransaction, "com_visit_topics", field_values))
        {PSay("Could not update a row", m_debug, MB_OK, "save_entries"); return false;}
      }
    }
    // delete anything not inserted or updated
    if (valid_entries.empty())
    {
     if (!ExecuteStatement(dbTransaction, "delete from com_visit_topics where task_id = " + task_id))
      {PSay("Could not delete all non-essential dependent rows", m_debug, MB_OK, "save_entries"); return false;}
    }
    else
    {
     if (!ExecuteStatement(dbTransaction, "delete from com_visit_topics where task_id = " + task_id + " and id not in (" + VecToCommaString(valid_entries) + ")"))
      {PSay("Could not delete some non-essential dependent rows", m_debug, MB_OK, "save_entries"); return false;}
    }
   }
   return true;
  }
};

class TformRecordComVisit : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TPanel *panelVisit;
        TGroupBox *groupComVisit;
        TScrollBox *scrollVisit;
        TGroupBox *groupPatient;
        TLabel *lblStaff;
        TLabel *lblClient;
        TLabel *lblDate;
        TLabel *lblTime;
        TComboBox *cboStaff;
        TBitBtn *btnPersonSearch;
        TDateTimePicker *cboDate;
        TDateTimePicker *cboTime;
        TGroupBox *groupGenVisit;
        TLabel *lblVisitType;
        TLabel *lblLocation;
        TLabel *lblMileage;
        TLabel *lblOutcome;
        TLabel *lblPatientTime;
        TLabel *lblTotalTime;
        TComboBox *cboVisitType;
        TComboBox *cboLocation;
        TComboBox *cboOutcome;
        TEdit *editMileage;
        TEdit *editPatientTime;
        TEdit *editTotalTime;
        TPageControl *pageVisit;
        TTabSheet *tabEducation;
        TTabSheet *tabMeasurements;
        TTabSheet *tabConditions;
        TTabSheet *tabNutrition;
        TTabSheet *tabProcedures;
        TTabSheet *tabComments;
        TLabel *lblNew;
        TCheckBox *chkNew;
        TStaticText *txtPerson;
        TRubberContainer *rubberEducation;
        TListView *listComEducation;
        TRubberContainer *rubberConditions;
        TListView *listComCondition;
        TRubberContainer *rubberNutrition;
        TListView *listComNutrition;
        TRubberContainer *rubberProcedures;
        TListView *listComProcedure;
        TRubberContainer *rubberComments;
        TListView *listComComments;
        TRubberContainer *rubberMeasurements;
        TframeObservationList *frameObs;
        TLabel *lblEvent;
        TStaticText *txtEvent;
        TBitBtn *btnEventSearch;
        TLabel *lblTaskType;
        TComboBox *cboTaskType;
        TLabel *lblAssessment;
        TStaticText *txtAssessmentLink;
        void __fastcall btnPersonSearchClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall scrollVisitMouseWheelDown(TObject *Sender,
          TShiftState Shift, TPoint &MousePos, bool &Handled);
        void __fastcall scrollVisitMouseWheelUp(TObject *Sender,
          TShiftState Shift, TPoint &MousePos, bool &Handled);
        void __fastcall btnEventSearchClick(TObject *Sender);
        void __fastcall txtAssessmentLinkClick(TObject *Sender);
        // void __fastcall buttonCClick(TObject *Sender);
        


private:	// User declarations

        // TComboBox      * cboChoice;
        // TIBTransaction * dbTransaction;
        // TIBDataSet     * dbDataSet;
        // TStringList    * sqlstmt;
        // TEdit *editDetails;
        // TCheckBox *chkNurse;
        // map<TCheckBox *, int> mapTag;
        // map<TEdit *, int> mapComment;
        // map<int, string> mapDbForm;
        // map<int, string>mapSave;
        // set<string>notify_set;
        // list<int> listValues;
        // bool already_saved;

        custom_row_container * middle_section;

/*
        classFilterObject community_measurement_filter;
        int community_measurement_request;
*/
        classFilterObject community_comments_filter;
        int community_comments_request;
        classFilterObject community_conditions_filter;
        int community_conditions_request;
        classFilterObject community_edu_filter;
        int community_edu_request;
        classFilterObject community_nutrition_filter;
        int community_nutrition_request;
        classFilterObject community_procedure_filter;
        int community_procedure_request;
        classFilterObject com_filter;
        int com_filter_request;

        int patient_assessment_request; // jhaley 20111028: Patient assessment link
        void ResetAssessmentLink();

public:		// User declarations
        __fastcall TformRecordComVisit(TComponent* Owner,map<string,string> p_parameters);
        //what is on a normal form
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenStart();
        bool ScreenStop();
        bool ScreenLock();
        bool ScreenUnlock();
        bool BeforeSave();
        bool NotNewAnymore();
        bool IsNewAgain();
//        void EditComMeasurement();
//        void AddComMeasurement();
        void EditComComments();
        void AddComComments();
        void EditComConditions();
        void AddComConditions();
        void EditComEdu();
        void AddComEdu();
       // void EditPubEdu();
       // void AddPubEdu();
        void EditComNutrition();
        void AddComNutrition();
        void AddComProcedure();
        void EditComProcedure();
        bool AtlasRefreshListViews(int request_num, string matched_value);

        static void Do(map<string, string> & p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordComVisit *formRecordComVisit;
//---------------------------------------------------------------------------
#endif
