//---------------------------------------------------------------------------

#ifndef codeRecordConditionH
#define codeRecordConditionH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Menus.hpp>
#include "codeHalfButton.h"
//---------------------------------------------------------------------------
class TformRecordCondition : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TPanel *panelGroup;
        TLabel *lblType;
        TLabel *lblStartDate;
        TLabel *lblStopDate;
        TLabel *lblCode;
        TComboBox *cboCondition;
        TEdit *editStartDate;
        TEdit *editStopDate;
        TEdit *editCode;
        TLabel *lblName;
        TStaticText *txtPerson;
        TLabel *lblNotes;
        TLabel *lblTask;
        TStaticText *txtTask;
        TLabel *lblIndex;
        TEdit *editIndex;
        TRichEdit *editNote;
        TListView *listProcedures;
        TLabel *lblProcedures;
        THalfButton *btnCodeWizard;
        THalfButton *btnCodeSearch;
        THalfButton *btnExpandCode;
        TLabel *lblAllergyType;
        TComboBox *cboAllergyType;
        void __fastcall btnCodeSearchClick(TObject *Sender);
        void __fastcall btnExpandCodeClick(TObject *Sender);
        void __fastcall listProceduresChanging(TObject *Sender,
          TListItem *Item, TItemChange Change, bool &AllowChange);
        void __fastcall FormShow(TObject *Sender);
private:	// User declarations
        classFilterObject procedures_filter;
        int procedure_request;
        int procedure_reason_request;
        string non_reportable_info_text;
public:		// User declarations
        __fastcall TformRecordCondition(TComponent* Owner, map<string,string> p_parameters);
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenStart();
        bool ScreenStop();
        bool ScreenLock();
        bool ScreenUnlock();
        bool BeforeSave();
        bool CheckProcedure(const map<string, string> & row_data);
        void DownloadProcedures();
        void AtlasRefreshListView(int request_num, string matched_value);
        void AddProcedure();
        void EditProcedure();
        static void Do(map<string, string> & p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordCondition *formRecordCondition;
//---------------------------------------------------------------------------
#endif
