//---------------------------------------------------------------------------

#ifndef codeRecordCrashLogH
#define codeRecordCrashLogH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TformRecordCrashLog : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TPageControl *pageCtrl;
        TTabSheet *sheetBasic;
        TTabSheet *sheetCPU;
        TTabSheet *sheetStack;
        TLabel *lblBugStatus;
        TComboBox *cboBugStatus;
        TLabel *lblAssignedTo;
        TComboBox *cboAssignedTo;
        TGroupBox *groupCrash;
        TLabel *lblException;
        TEdit *editException;
        TLabel *lblLogicalAddr;
        TEdit *editLogicalAddr;
        TLabel *lblAppState;
        TEdit *editAppState;
        TLabel *lblErrorTime;
        TEdit *editTimeStamp;
        TLabel *lblProgram;
        TEdit *editProgram;
        TLabel *lblModule;
        TEdit *editModule;
        TLabel *lblVersion;
        TEdit *editVersion;
        TGroupBox *groupUser;
        TLabel *lblRunBy;
        TLabel *lblOSVersion;
        TLabel *lblProcessors;
        TLabel *lblProcType;
        TLabel *lblMemInUse;
        TLabel *lblPhysMem;
        TLabel *lblPageFile;
        TLabel *lblPageFree;
        TLabel *lblUserSpace;
        TLabel *lblUserSpaceFree;
        TEdit *editRunBy;
        TEdit *editProcessors;
        TEdit *editMemInUse;
        TEdit *editPageFile;
        TEdit *editUserSpace;
        TEdit *editOSVersion;
        TEdit *editProcType;
        TEdit *editPhysMem;
        TEdit *editPageFree;
        TEdit *editUserFree;
        TGroupBox *groupAV;
        TLabel *lblAVAddress;
        TEdit *editAVAddress;
        TLabel *lblAVMode;
        TEdit *editAVMode;
        TGroupBox *groupCPURegs;
        TLabel *lblEDI;
        TLabel *lblESI;
        TLabel *lblSegCs;
        TLabel *lblEIP;
        TLabel *lblSegSs;
        TLabel *lblESP;
        TLabel *lblEFlags;
        TLabel *lblEBP;
        TLabel *lblEAX;
        TLabel *lblEBX;
        TLabel *lblECX;
        TLabel *lblEDX;
        TEdit *editEdi;
        TEdit *editEsi;
        TEdit *editSegCs;
        TEdit *editSegSs;
        TEdit *editEFlags;
        TEdit *editEax;
        TEdit *editEcx;
        TEdit *editEip;
        TEdit *editEsp;
        TEdit *editEbp;
        TEdit *editEbx;
        TEdit *editEdx;
        TGroupBox *groupEIPBytes;
        TEdit *editEIPBytes;
        TMemo *memoStack;
        TPanel *panelBottom;
        TEdit *editStackAddress;
        TButton *btnAddrConvert;
        TEdit *editStackSeg;
        TEdit *editStackOffs;
        TLabel *lblColon;
        TLabel *lblPriority;
        TComboBox *cboBugPriority;
        TTabSheet *sheetOccurrences;
        TListView *listOccurrences;
        TTabSheet *sheetStackTrace;
        TPanel *panelTrace;
        TMemo *memoTrace;
        TButton *btnLoadMap;
        TOpenDialog *openDialog;
        void __fastcall btnAddrConvertClick(TObject *Sender);
        void __fastcall btnLoadMapClick(TObject *Sender);
private:	// User declarations
        bool ScreenStart();
        bool ScreenStop();
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenLock();
        bool ScreenUnlock();
        bool NotNewAnymore();
        bool IsNewAgain();

        // Crash log data processing functions
        const char *DescriptionForAppState(int appstate);
        const char *PhraseForException(DWORD code);
        string      FormatBytesAtEIP(string source);
        void        ProcessStack(const string &input);

        class DebugMap
        {
        public:
          typedef map<unsigned int, string> SymbolMap;
        protected:
          unsigned int base;
          unsigned int len;
          SymbolMap symbols;
        public:
          DebugMap() : base(0), len(0), symbols() {}
          void   readMapFile(const string &filename);
          string nameForAddress(unsigned int address);
          unsigned int getBase() const { return base; }
          unsigned int getLen()  const { return len;  }
        };

        DebugMap debugMapData;
        bool IsProbableRetnTarget(unsigned int address);

public:		// User declarations
        __fastcall TformRecordCrashLog(TComponent* Owner, map<string, string> p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordCrashLog *formRecordCrashLog;
//---------------------------------------------------------------------------
#endif
