//---------------------------------------------------------------------------

#ifndef codeRecordDenialLetterH
#define codeRecordDenialLetterH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <Buttons.hpp>
#include "codeRubberContainer.h"
//---------------------------------------------------------------------------
class TformRecordDenialLetter : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TStaticText *txtPerson;
        TPanel *panelGroup;
        TStaticText *txtPrintDenialLetter;
        TLabel *lblPerson;
        TLabel *lblBatch;
        TStaticText *txtBatch;
        TLabel *lblReasons;
        TRubberContainer *rubberReasons;
        TListView *listReasons;
        TLabel *lblStatus;
        TComboBox *cboStatus;
        TRubberContainer *rubberDatesAndAmounts;
        TListView *listDatesAndAmounts;
        TLabel *lblDatesAndAmounts;
        TComboBox *cboDenialType;
        TLabel *lblDenialType;
        TLabel *lblEffective;
        TDateTimePicker *dateEffective;
        TLabel *lblProcessed;
        TGroupBox *groupDOS;
        TButton *btnDOSAdd;
        TButton *btnDOSDelete;
        TButton *btnDOSUndo;
        TDateTimePicker *dateDOSBegin;
        TDateTimePicker *dateDOSEnd;
        TLabel *lblBeginDate;
        TLabel *lblEndDate;
        TLabel *lblBilledAmount;
        TEdit *editBilledAmount;
        TLabel *lblPatientOwes;
        TEdit *editPatientOwes;
        TLabel *lblPayableAmount;
        TEdit *editPayableAmount;
        TButton *btnDOSSave;
        TButton *btnDOSSaveAndAdd;
        TCheckBox *checkDuplicates;
        TCheckBox *checkCustomDate;
        TDateTimePicker *dateCustomLetter;
        void __fastcall txtPrintDenialLetterClick(TObject *Sender);
        void __fastcall cboStatusChange(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall btnDOSAddClick(TObject *Sender);
        void __fastcall btnDOSDeleteClick(TObject *Sender);
        void __fastcall btnDOSUndoClick(TObject *Sender);
        void __fastcall btnDOSSaveClick(TObject *Sender);
        void __fastcall btnDOSSaveAndAddClick(TObject *Sender);
private:	// User declarations
        string person_id;
        string tax_entity_id;
        set<string> authority_permissions;
        classFilterObject reasons_filter;
        classFilterObject items_filter;
        classFilterVecmapSource *items_source; // jhaley 20101011
        vector<map<string, string> > original_dos_data;
        vector<map<string, string> > current_dos_data;
        int reason_request;
        int item_request;
        string oldLetterInfoText;
        string current_editing_dos_id; // if editing, is id #; if adding, is "new"
        bool   is_dos_edit_active;     // true if DOS controls are loaded up with data
        void UpdateDOSFilter();
        void SetDOSEnabled(bool p_enabled);
        void SetDOSAddMode(bool setfocus = true);
        void SetDOSEditMode(bool setfocus = true);
        bool AllDOSAreValid();
        bool IsDOSValidOnScreen();
        void ReFetchDOS(string letter_id);
        bool ConflictsWithExistingRecord();
        bool CheckDOSPermissions(const string &action_type, bool silent = false);
        bool CanUpdate();
        bool CanInsert();
protected:      // User declarations
        bool DeleteRecord();
        void __fastcall OnDOSSelectItem(TObject *Sender, TListItem *Item, bool Selected);
public:		// User declarations
        __fastcall TformRecordDenialLetter(TComponent* Owner, map<string,string> p_parameters);
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenLock();
        bool ScreenUnlock();
        bool NotNewAnymore();
        bool IsNewAgain();
        bool AfterSave();
        bool BeforeSave();
        bool ScreenStart();
        bool ScreenStop();
        bool AtlasRefresh(int request_num, string matched_value);
        bool CheckReason(const map<string, string> & row_data);
        void AddItem();
        void EditItem();
        static void Do(map<string, string> & p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordDenialLetter *formRecordDenialLetter;
//---------------------------------------------------------------------------
#endif
