//---------------------------------------------------------------------------

#ifndef codeRecordEntityContractH
#define codeRecordEntityContractH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
//---------------------------------------------------------------------------
class TformRecordEntityContract : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TPanel *panelGroup;
        TLabel *_labelEntity;
        TLabel *_labelTerms;
        TLabel *_labelType;
        TComboBox *comboContractType;
        TStaticText *staticTaxEntity;
        TLabel *_labelDates;
        TEdit *editStart;
        TEdit *editStop;
        TLabel *_labelDatesThrough;
        TMemo *memoTerms;
private:	// User declarations
public:		// User declarations
        __fastcall TformRecordEntityContract(TComponent* Owner, map<string,string> p_parameters);
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenStart();
        bool ScreenStop();
        bool ScreenLock();
        bool ScreenUnlock();
        static void Do(map<string, string> & p_parameters);

        static void ShowAppropriate(string tax_entity_id, vector<string> possible_contract_ids);
        static void FindAppropriate(string tax_entity_id);
        static void FindAppropriate(string tax_entity_id, Pdate as_of);
        static int  CheckNumContracts(string tax_entity_id, Pdate as_of);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordEntityContract *formRecordEntityContract;
//---------------------------------------------------------------------------
#endif
