//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordEntityIDs.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordEntityIDs *formRecordEntityIDs;
//---------------------------------------------------------------------------
__fastcall TformRecordEntityIDs::TformRecordEntityIDs(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("entity_ids"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordEntityIDs::ScreenStart()
{
  lookupTables->RegisterComboBox("entity_id_types", cboIDType);

  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordEntityIDs::ScreenStop()
{
  lookupTables->UnregisterComboBox("entity_id_types", cboIDType);

  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordEntityIDs::IsValidOnScreen()
{
  if(! lookupTables->IsInLookUpTable("entity_id_types", cboIDType->Text.c_str()) || cboIDType->Text == "")
  {
    PSay("Please select a valid identifier type.", m_invalid_data, MB_OK);
    cboIDType->SetFocus();
    return false;
  }
  else if ((initial_state["tax_entity_id"] == "") || (initial_state["tax_entity_id"] == "0"))
  {
    PSay("There is no tax entity associated with this record.", m_missing_data, MB_OK);
    return false;
  }
  else if (ConflictsWithExistingRecord())
  {
    PSay(("This tax entity already has a(n) " + cboIDType->Text + ".  Please click the tax entity link and, in the list of identifiers, modify their existing " + cboIDType->Text + ".").c_str(), m_invalid_data, MB_OK);
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformRecordEntityIDs::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record
  cboIDType->Text = lookupTables->ValueOf("entity_id_types", initial_state["entity_id_id"]).c_str();
  editIDValue->Text = (initial_state["identifier"]).c_str();
  CreateLink(txtTaxEntity, NULL, this, initial_state["tax_entity_id"], "tax_entities");

  TformRecordGeneric::PutDataOnScreen();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordEntityIDs::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  ending_state["entity_id_id"] = lookupTables->IdOf("entity_id_types", cboIDType->Text.c_str());
  ending_state["identifier"] = editIDValue->Text.c_str();
  ending_state["tax_entity_id"] = initial_state["tax_entity_id"];
  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();
  return true; // again, not much can go wrong here
}
//---------------------------------------------------------------------------
bool TformRecordEntityIDs::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;

  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordEntityIDs::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;

  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordEntityIDs::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordEntityIDs * z = new TformRecordEntityIDs(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
bool TformRecordEntityIDs::ConflictsWithExistingRecord()
{
  if (is_in(ending_state["current_id"], "0", "1", "2", NULL))
    return false;

  TIBTransaction *tx = NULL;
  if (lock_transaction && lock_transaction->Active)
    tx = lock_transaction;
  else
  {
    tx = new TIBTransaction(NULL);
    StdTransaction(tx, dbDatabase);
  }
  string conflict_sql = "select id from entity_ids "
                        "where entity_id_id = '" + lookupTables->IdOf("entity_id_types", cboIDType->Text.c_str()) + "' "
                        "and tax_entity_id = '" + initial_state["tax_entity_id"] + "' and current_id+1 >= 4 ";
  if (!is_new_record)
    conflict_sql += "and id != '" + initial_state["id"] + "' ";
  DebugSql(this, &conflict_sql, 8);
  vector<string> conflict_vec;
  SqlToVec(dbDatabase, conflict_sql, conflict_vec);
  return !conflict_vec.empty();
}
//---------------------------------------------------------------------------

