//---------------------------------------------------------------------------

#ifndef codeRecordEventH
#define codeRecordEventH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "codeRubberContainer.h"
//---------------------------------------------------------------------------
class TformRecordEvent : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TPanel *eventGroup;
        TLabel *lblName;
        TLabel *lblDate;
        TDateTimePicker *dateEvent;
        TLabel *lblDescription;
        TLabel *lblEventType;
        TComboBox *cboEventType;
        TLabel *lblLocation;
        TComboBox *cboLocation;
        TEdit *editAttendance;
        TLabel *lblAttendance;
        TStaticText *txtLabels;
        TStaticText *txtAddActivities;
        TPageControl *pageTasksAndActivitiesTabsheet;
        TTabSheet *tabTasks;
        TTabSheet *tabActivities;
        TRichEdit *editDescription;
        TStaticText *txtAddContacts;
        TComboBox *cboEventName;
        TRubberContainer *rubberTasks;
        TListView *listTasks;
        TRubberContainer *RubberContainer1;
        TListView *listActivities;
        TRubberContainer *rubberParticipants;
        TListView *listParticipants;
        TComboBox *cboProgramType;
        TLabel *lblProgramType;
        TStaticText *txtViewRollSheet;
        void __fastcall txtLabelsClick(TObject *Sender);
        void __fastcall txtAddContactsClick(TObject *Sender);
        void __fastcall txtViewRollSheetClick(TObject *Sender);

private:	// User declarations
        string viewing_group_id;
        classFilterObject people_filter;
        int people_request;
        classFilterObject task_filter;
        int task_request;
        classFilterObject activity_filter;
        int activity_request;
        classFilterObject ;
        int participant_request;
        int event_roll_request;
        string GetRollSheetID();
public:		// User declarations
        __fastcall TformRecordEvent(TComponent* Owner, map<string,string> p_parameters);
        void RefreshListView(int request_num, string matched_value);
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenStart();
        bool ScreenStop();
        bool ScreenLock();
        bool ScreenUnlock();
        bool NotNewAnymore();
        bool IsNewAgain();
        void AddPerson();
        void EditPerson();
        void AddTask();
        void EditTask();
        void AddEventActivity();
        void EditEventActivity();
        static void Do(pmapstrs & p_parameters);
        static void DoCreateMedical(TForm *parent, TComponent* Owner, pmapstrs &p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordEvent *formRecordEvent;
//---------------------------------------------------------------------------
#endif
