//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordEventActivity.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordEventActivity *formRecordEventActivity;
//---------------------------------------------------------------------------
__fastcall TformRecordEventActivity::TformRecordEventActivity(TComponent* Owner, map<string, string> & p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("event_activities"))
{
 Initialize();
 event_id = initial_state["event_id"];
}
//---------------------------------------------------------------------------
bool TformRecordEventActivity::ScreenStart()
{
 // register combo box
 lookupTables->RegisterComboBox("activity_code_types",cboActivity);
 lookupTables->RegisterComboBox("intensity_types",cboIntensity);
 TformRecordGeneric::ScreenStart();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordEventActivity::ScreenStop()
{
 // unregister combo box

 lookupTables->UnregisterComboBox("activity_code_types",cboActivity);
 lookupTables->UnregisterComboBox("intensity_types",cboIntensity);

 TformRecordGeneric::ScreenStop();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordEventActivity::IsValidOnScreen()
{
 if (!lookupTables->IsInLookUpTable ("activity_code_types", cboActivity->Text.c_str()))
 {
  PSay("Please enter a valid activity", m_invalid_data, MB_OK);
  cboActivity->SetFocus();
  return false;
 }
 else if (!lookupTables->IsInLookUpTable ("intensity_types", cboIntensity->Text.c_str()))
 {
  PSay("Please enter a valid intensity", m_invalid_data, MB_OK);
  cboIntensity->SetFocus();
  return false;
 }
 else if (! IsFloat(editTime->Text.c_str()))
 {
  PSay("Please enter a valid time", m_invalid_data, MB_OK);
  editTime->SetFocus();
  return false;
 }
 else if (! IsFloat(editDistance->Text.c_str()))
 {
  PSay("Please enter a valid distance", m_invalid_data, MB_OK);
  editDistance->SetFocus();
  return false;
 }
 else if (! IsFloat(editSteps->Text.c_str()))
 {
  PSay("Please enter a valid number of steps", m_invalid_data, MB_OK);
  editSteps->SetFocus();
  return false;
 }
 else
   return true;
}
//---------------------------------------------------------------------------
bool TformRecordEventActivity::PutDataOnScreen()
{
 if (initial_state["date_of_activity"] != "")
   dateActivity->Date = Pdate(initial_state["date_of_activity"], mdy | yyyy).OutDate();
 else
   dateActivity->Date = Pdate(initial_state["date_of_event"], mdy | yyyy).OutDate();
 cboActivity->Text = PrettyString(lookupTables->ValueOf("activity_code_types", initial_state["activity_code_id"])).c_str();
 cboIntensity->Text = PrettyString(lookupTables->ValueOf("intensity_types",initial_state["intensity_id"])).c_str();
 editTime->Text = initial_state["time_spent"].c_str();
 editDistance->Text = initial_state["distance"].c_str();
 editSteps->Text = initial_state["steps"].c_str();

 TformRecordGeneric::PutDataOnScreen();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordEventActivity::GetDataFromScreen()
{
 ending_state["date_of_activity"] = Pdate(dateActivity->Date).OutDate(mdy | yyyy);
 ending_state["activity_code_id"] = lookupTables->IdOf("activity_code_types", cboActivity->Text.c_str());
 ending_state["intensity_id"] = lookupTables->IdOf("intensity_types", cboIntensity->Text.c_str());
 ending_state["time_spent"] = StripAllExcept(editTime->Text.c_str(), floats);
 ending_state["distance"] = StripAllExcept(editDistance->Text.c_str(), floats);
 ending_state["steps"] = StripAllExcept(editSteps->Text.c_str(), floats);
 ending_state["id"] = initial_state["id"];
 ending_state["event_id"] = initial_state["event_id"];
 TformRecordGeneric::GetDataFromScreen();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordEventActivity::ScreenLock()
{
 panelGroupBox->Enabled = false;
 TformRecordGeneric::ScreenLock();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordEventActivity::ScreenUnlock()
{
 panelGroupBox->Enabled = true;
 TformRecordGeneric::ScreenUnlock();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordEventActivity::BeforeSave()
{
 Processing(true);
 vector<map<string, string> > people_vecmap;
 vector<map<string, string> > activity_vecmap;
 vector<map<string, string> > test_map;
 map<string, string> data_map;
 string sql;
 bool can_commit = true;

 sql = "select participations.person_id, person_names.last_name, person_names.first_name, "
         "participations.current_id, participations.id "
         "from participations, people, person_names "
         "where participations.event_id = " + ending_state["event_id"] + " and "
         "participations.person_id = people.id and "
         "person_names.id = people.person_names_id order by person_names.last_name, "
         "person_names.first_name";
 if (!SqlToVecMap(lock_transaction, sql, people_vecmap))
   can_commit = false;

 sql = "select event_activities.id, event_activities.activity_code_id, activity_code_types.item, "
          "event_activities.intensity_id, intensity_types.item, event_activities.distance, event_activities.time_spent, "
          "event_activities.steps, event_activities.current_id, event_activities.id, "
          "events.date_of_event "
          "from event_activities, activity_code_types, intensity_types, events "
          "where event_activities.activity_code_id = activity_code_types.id and "
          "event_activities.intensity_id = intensity_types.id and "
          "event_activities.event_id = '" + ending_state["event_id"] + "' and "
          "events.id = '" + ending_state["event_id"] + "'";
 if (!SqlToVecMap(lock_transaction, sql, activity_vecmap))
   can_commit = false;

   for (unsigned int i = 0; i < people_vecmap.size(); i++)
   {
    for (unsigned int j = 0; j < activity_vecmap.size(); j++)
    {
     sql = "select activities.person_id, "
                  "activities.activity_code_id, "
                  "activities.intensity_id, "
                  "activities.date_of_activity, "
                  "activities.distance, "
                  "activities.time_spent, "
                  "activities.steps, "
                  "activities.event_activity_id "
             "from activities, "
                  "event_activities, "
                  "participations "
             "where event_activities.id = '" + activity_vecmap[j]["id"] + "' "
                 "and participations.person_id = '" + people_vecmap[i]["person_id"] + "' "
                 "and activities.person_id = participations.person_id "
                 "and activities.event_activity_id = event_activities.id ";
     if (SqlToVecMap(lock_transaction, sql, test_map))
     {
      if (activity_vecmap[j]["current_id"] < people_vecmap[i]["current_id"])
        data_map["current_id"] = activity_vecmap[j]["current_id"];
      else
        data_map["current_id"] = people_vecmap[i]["current_id"];
      data_map["last_update_stamp"] = RightNow();
      data_map["last_updated_by"] = current_userid;
      data_map["person_id"] = people_vecmap[i]["person_id"];
      data_map["activity_code_id"] = activity_vecmap[j]["activity_code_id"];
      data_map["intensity_id"] = activity_vecmap[j]["intensity_id"];
      data_map["date_of_activity"] = activity_vecmap[j]["date_of_event"];
      data_map["distance"] = activity_vecmap[j]["distance"];
      data_map["time_spent"] = activity_vecmap[j]["time_spent"];
      data_map["steps"] = activity_vecmap[j]["steps"];
      data_map["activity_logsheet_id"]  = "0";
      data_map["event_activity_id"] = activity_vecmap[j]["id"];
      data_map["fitness_attendance_id"] = "0";
      if (test_map.size() == 0)
      {
       data_map["id"] = GetNextId (lock_transaction, "activities");
       if (!ExecuteInsertStatement(lock_transaction, "activities", data_map))
         can_commit = false;
      }
      else
      {
       sql = "select id from activities "
             "where activities.event_activity_id = '" + activity_vecmap[j]["id"] + "' "
             "and activities.person_id = '" + people_vecmap[i]["person_id"] + "'";
       data_map["id"] = GetOneField(lock_transaction,sql);
       if (!ExecuteUpdateStatement(lock_transaction, "activities", data_map))
         can_commit = false;
      }
     }
     else
     {
      can_commit = false;
     }
    }
   }
 vector<map<string, string> > test_vecmap;
 sql="select id from event_activities where event_activities.event_id = '" + initial_state["event_id"] + "'";
 SqlToVecMap(lock_transaction, sql, test_vecmap);
 if (test_vecmap.size() > 0)
 {
  sql = "update events set added_activities = 1 where id = '" + initial_state["event_id"] + "'";
  ExecuteStatement(lock_transaction, sql);
 }
 else
 {
  sql = "update events set added_activities = 0 where id = '" + initial_state["event_id"] + "'";
  ExecuteStatement(lock_transaction, sql);
 }
 Processing(false);
 return can_commit;
}
//---------------------------------------------------------------------------
void TformRecordEventActivity::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordEventActivity * z = new TformRecordEventActivity(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

