//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordFeeSchedule.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordFeeSchedule *formRecordFeeSchedule;
//---------------------------------------------------------------------------
__fastcall TformRecordFeeSchedule::TformRecordFeeSchedule(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("codes"))
{
   Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordFeeSchedule::ScreenStart()
{
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordFeeSchedule::ScreenStop()
{
  // unregister combo box
  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordFeeSchedule::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxe
  // corrospond to values in that look up table.
  // check to make sure the dates entered are valid
  // give the user a message box and prompt to re-enter if incorrect
  // make sure there is a link to a person, although there's not much the user
  // can do to fix that if there's not
  if (! IsAmount (editClinicFee->Text.c_str()) && ! (editClinicFee->Text == ""))
  {
    PSay("Please enter a valid clinic fee", m_invalid_data, MB_OK);
    editClinicFee->SetFocus();
    return false;
  }
  if (! IsAmount (editMedicareFee->Text.c_str()) && ! (editMedicareFee->Text == ""))
  {
    PSay("Please enter a valid medicare fee", m_invalid_data, MB_OK);
    editMedicareFee->SetFocus();
    return false;
  }
  if (! IsAmount (editMedicaidFee->Text.c_str()) && ! (editMedicaidFee->Text == ""))
  {
    PSay("Please enter a valid medicaid fee", m_invalid_data, MB_OK);
    editMedicaidFee->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformRecordFeeSchedule::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  editCode->Text = initial_state["code"].c_str();
  editDescription->Text = SentenceString(initial_state["description"]).c_str();
  editClinicFee->Text = StringToAmount(initial_state["clinic_cost"]).c_str();
  editMedicareFee->Text = StringToAmount(initial_state["medicare_cost"]).c_str();
  editMedicaidFee->Text = StringToAmount(initial_state["medicaid_cost"]).c_str();

  // get the person name associated with the person id that was either selected
  // from the database if it's an existing record, or passed to the form if
  // it's a new record. display the name as a link to the person record.

  TformRecordGeneric::PutDataOnScreen();
  return true; // what can really go wrong?
}
//---------------------------------------------------------------------------
bool TformRecordFeeSchedule::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  ending_state["clinic_cost"] = AmountToString(editClinicFee->Text.c_str());
  ending_state["medicare_cost"] = AmountToString(editMedicareFee->Text.c_str());
  ending_state["medicaid_cost"] = AmountToString(editMedicaidFee->Text.c_str());
  ending_state["id"] = initial_state["id"];
  TformRecordGeneric::GetDataFromScreen();
  return true; // again, not much can go wrong here
}
//---------------------------------------------------------------------------
bool TformRecordFeeSchedule::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  editDescription->ReadOnly = true;
  editDescription->TabStop = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordFeeSchedule::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  // editDescription->ReadOnly = false; // TODO: always disabled?
  // editDescription->TabStop = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------

