//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordFitnessAttendance.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordFitnessAttendance *formRecordFitnessAttendance;
//---------------------------------------------------------------------------
__fastcall TformRecordFitnessAttendance::TformRecordFitnessAttendance(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("fitness_attendance"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordFitnessAttendance::ScreenStart()
{
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordFitnessAttendance::ScreenStop()
{
  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordFitnessAttendance::IsValidOnScreen()
{
  // make sure there is a link to a person, although there's not much the user
  // can do to fix that if there's not
  if ((initial_state["fitness_membership_id"] == "") || (initial_state["fitness_membership_id"] == "0"))
  {
    PSay("There is no fitness membership associated with this record", m_invalid_data, MB_OK);
    return false;
  }
  else if ((initial_state["person_id"] == "") || (initial_state["person_id"] == "0"))
  {
    PSay("There is no person associated with this record", m_missing_data, MB_OK);
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformRecordFitnessAttendance::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record
  if (initial_state["date_of_attendance"] != "")
    dateAttendance->Date = Pdate(initial_state["date_of_attendance"], mdy | yyyy).OutDate();
  else
    dateAttendance->Date = Date();

  if (initial_state["time_in"] != "")
  {
    timeInAttendance->Time = Ptime(initial_state["time_in"], global_mode).OutTime();
  }
  else
  {
    timeInAttendance->Time = Time();
  }

  if (initial_state["time_out"] != "")
  {
    timeOutAttendance->Time = Ptime(initial_state["time_out"], global_mode).OutTime();
  }
  else
  {
    timeOutAttendance->Time = Time();
  }

  // get the person name associated with the person id that was either selected
  // from the database if it's an existing record, or passed to the form if
  // it's a new record. display the name as a link to the person record.

  CreateLink(txtPerson, NULL, this, initial_state["person_id"], "people");
  CreateLink(txtFacility, NULL, this, initial_state["fitness_membership_id"], "fitness_memberships");

  TformRecordGeneric::PutDataOnScreen();
  return true; // what can really go wrong?
}
//---------------------------------------------------------------------------
bool TformRecordFitnessAttendance::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  timeInAttendance->Date = dateAttendance->Date;
  timeOutAttendance->Date = dateAttendance->Date;
  ending_state["date_of_attendance"] = Pdate(dateAttendance->Date).OutDate(mdy | yyyy);
  ending_state["fitness_membership_id"] = initial_state["fitness_membership_id"];
  ending_state["person_id"] = initial_state["person_id"];
  ending_state["id"] = initial_state["id"];
  ending_state["time_in"] = Ptime(timeInAttendance->Time).OutTime(global_mode);
  ending_state["time_out"] = Ptime(timeOutAttendance->Time).OutTime(global_mode);
  TformRecordGeneric::GetDataFromScreen();

  return true; // again, not much can go wrong here
}
//---------------------------------------------------------------------------
bool TformRecordFitnessAttendance::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordFitnessAttendance::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordFitnessAttendance::CheckForUselessRecord()
{
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordFitnessAttendance::BeforeSave()
{
  bool can_commit=true;
  vector<map<string,string> > test_vecmap;
  map<string,string> insert_map;
  map<string,string> update_map;
  string sql = "select activities.id "
               "from activities, people "
               "where activities.person_id = " + ending_state["person_id"] + " and "
                     "activities.fitness_attendance_id = " + ending_state["id"] + " "
               "and exists (select enrollment.id from enrollment "
               "where enrollment.person_id = people.id and enrollment.current_id+1 >= 4 and "
               "enrollment.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "STEPS Participant") + "' and "
               "enrollment.enrollment_status_id = '" + lookupTables->IdOf("enrollment_status_types", "Member") + "') ";
  if (SqlToVecMap(lock_transaction, sql, test_vecmap))
  {
   if (test_vecmap.size() < 1)
   {
    insert_map["id"] = GetNextId(lock_transaction, "activities");
    insert_map["current_id"] = ending_state["current_id"];
    insert_map["last_update_stamp"] = RightNow();
    insert_map["last_updated_by"] = current_userid;
    insert_map["person_id"] = ending_state["person_id"];
    insert_map["activity_code_id"] = "11"; // TODO -c MAGIC NUMBER :
    insert_map["intensity_id"] = "2";      // TODO -c MAGIC NUMBER :
    insert_map["date_of_activity"] = ending_state["date_of_attendance"];
    insert_map["time_spent"] = IntToString((Ptime(timeOutAttendance->Time)-Ptime(timeInAttendance->Time))/60);
    insert_map["activity_logsheet_id"] = "0";
    insert_map["event_activity_id"] = "0";
    insert_map["fitness_attendance_id"] = ending_state["id"];

    if (!ExecuteInsertStatement(lock_transaction, "activities", insert_map))
      can_commit = false;
   }
   else
   {
    update_map["current_id"] = ending_state["current_id"];
    update_map["last_update_stamp"] = RightNow();
    update_map["last_updated_by"] = current_userid;
    update_map["person_id"] = ending_state["person_id"];
    update_map["activity_code_id"] = "11"; // TODO -c MAGIC NUMBER :
    update_map["intensity_id"] = "2";      // TODO -c MAGIC NUMBER :
    update_map["date_of_activity"] = ending_state["date_of_attendance"];
    update_map["time_spent"] = IntToString((Ptime(timeOutAttendance->Time) - Ptime(timeInAttendance->Time))/60);
    sql = "update activities set current_id = '" + update_map["current_id"] + "',"
                                "last_update_stamp = '" + update_map["last_update_stamp"] + "',"
                                "last_updated_by = '" + update_map["last_updated_by"] + "',"
                                "activity_code_id = '" + update_map["activity_code_id"] + "',"
                                "date_of_activity = '" + update_map["date_of_activity"] + "',"
                                "time_spent = '" + update_map["time_spent"] + "' "
                                "where activities.fitness_attendance_id = '" + ending_state["id"] + "' "
                                "and activities.person_id = '" + ending_state["person_id"] + "'";

       if (!ExecuteStatement(lock_transaction,sql))
         can_commit = false;
   }
  }
  else
  {
   can_commit = false;
  }
  return can_commit;
}
