//---------------------------------------------------------------------------

#ifndef codeRecordGenericH
#define codeRecordGenericH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>

#include "codeSpecialGeneric.h"
//#include "utilityheaders.h"
//#include "baseheaders.h"
//#include "components.h"
#include <Menus.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TformRecordGeneric : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *buttonA;
        TToolButton *buttonB;
        TToolButton *buttonCurrent;
        TToolButton *sepStandard2;
        TToolButton *buttonC;
        TPopupMenu *popupRecord;
        TMenuItem *menuDeleteRecord;
        TMenuItem *menuViewChangeLog;
        TMenuItem *menuDataNavigate;
        TMenuItem *menuActions;
        void __fastcall buttonBClick(TObject *Sender);
        void __fastcall buttonAClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall buttonCurrentClick(TObject *Sender);
        void __fastcall buttonCClick(TObject *Sender);
        void __fastcall menuDeleteRecordClick(TObject *Sender);
        void __fastcall menuViewChangeLogClick(TObject *Sender);
        void __fastcall FormShortCut(TWMKey &Msg, bool &Handled);
        void __fastcall menuDataNavigateClick(TObject *Sender);
        void __fastcall menuActionsClick(TObject *Sender);
//---------------------------------------------------------------------------
protected:      // User declarations
        int  atlas_screen_request;          // latest request number from atlas (in case it needs to
                                            // change it for some reason - and cancel)
        bool is_editing;                    // currently unlocked screen, user is editing the record
        bool is_new_record;                 // started without ID, need to get one
        bool is_database_started;           // transaction is, in fact, in progress (update)
        string table_name;                  // table name to be used during sql operations
        string title_name;                  // title on the form, to have "new, edit, view" added to
        TIBTransaction * lock_transaction;  // list view refreshers have their own local transaction,
                                            // as does the main form's select statement. only use this
                                            // transaction when starting or finishing an update/insert.
        //TIBDataSet * no_name00            // no dataset: local to the update functions,
                                            // but derived classes should keep datasets for each listview,
                                            // for non-database updates (filter) ... update them on atlas
                                            // notification.
        map<string, string> initial_state;  // stable state, from database
        map<string, string> blank_state;    // used to do the Save/Add Another thingie
        map<string, string> ending_state;   // data, on screen, after an update
        map<string, string> hack_state;     // re-fetch data from the database before overwriting so we can correctly
                                            // calculate the difference between the maps in SendAtlas()
                                            // -- currently, links, etc. store their temporary values in initial_state,
                                            // which causes SendAtlas() to not see those fields as changed! (bad!)
                                            // these maps contain data as it should be in the database,
                                            // that is, none of the drop-downs or links should have text
                                            // values, as they are foreign keys. thus, foreign key fields
                                            // should contain numbers. text values for these fields will be
                                            // kept by individual derived classes and manipulated by them.
                                            // getdatafromscreen, getdatafromdatabase, putdataonscreen must
                                            // cooperate to get those other fields together (from database
                                            // must place the text values from the inner join in the sep.
                                            // fields.)
        set<string> db_table_fields;        // jhaley 20110107: A set of fields the database says the table has, for wherever needed.
        TIBTransaction * delete_transaction;  // used for the *DeleteRecord() functions
        bool record_useless_override;       // record the record id of a newly-created record if the user circumvented the warning?
        AnsiString __fastcall virtual GetRecordTitle();
        void __fastcall virtual SetRecordTitle(AnsiString Value);

        set<string> fields_to_leave_raw;    // don't ask =) ... very special cases, where we want to avoid UppercaseString();
        //functions, most of which need override
        bool virtual ScreenStart();         // atlas, getdatafromdatabase, putdataonscreen, listviews, ...
        bool virtual ScreenStop();          // atlas, clear listviews, ...
        bool virtual GetDataFromDatabase(); // database to initial_state
        bool virtual PutDataOnScreen();     // initial_state to screen AND update listviews, etc.
        bool virtual GetDataFromScreen();   // screen to ending_state
        bool virtual IsValidOnScreen();     // screen validation
        bool virtual GetLockFromDatabase(); // lock record
        bool virtual PutDataInDatabase();   // is_new_record: ending_state -> insert -> database (lock)
                                            // is_locked: ending_state -> update -> database (lock)
        bool virtual DataUnlock();          // getdatafromdatabase , putdataonscreen, getlockfromdatabase
        bool virtual DataSave();            // getdatafromscreen , putdataindatabase
        bool virtual DataUndo();            // getdatafromdatabase, putdataonscreen
        bool virtual DataClose();           // is_locked: ask -> yes: usersave, no: userundo
        bool virtual DataNext();            // getdata, putdata, clear and re-putdatataonscreen (>> save/add another)

        bool virtual ScreenLock();          // user-defined
        bool virtual ScreenUnlock();        // user-defined

        bool virtual AskUser();             // yes/no question about saving data
        bool virtual UpdateCurrent();       // redo the bottom toolbar based on initial_state
        bool virtual UpdateTitle();         // redo the title at the top of the screen
        bool virtual AtlasScreen(int r_n, string matched_value);
                                            // atlas needs to inform us of changes for the screen
        bool virtual SendAtlas();           // send out info for other users
        bool virtual GenericTransaction();  // used by both new and editing records
        bool virtual Initialize();          // called by derived forms to start old constructor behavior
        bool virtual NotNewAnymore();       // called by putdataindatabase when an id is assigned, so
                                            // as to setup listviews, atlas, etc. for dependent tables.
        bool virtual IsNewAgain();          // used when >> is used! oh my god!
        bool virtual BeforeSave();          // for relationships: after updating, use transaction to do other stuff,
                                            // then see if we should still save anyway ... otherwise no.
        bool virtual AfterSave();           // for janet, to save dependent records
        bool virtual SaveLog();             // save changes as records in change_log
        bool virtual CheckForUselessRecord(); // make the user confirm they really intend to put in a blank record
        bool virtual BeforeDeleteRecord();   // set up deletion transaction (because Philip bitched)
        bool virtual DeleteRecord();         // delete this record...
                                             // if you have FKs to it, override and delete them then call this function
        bool virtual AfterDeleteRecord();    // does nothing now, but ... just in case?
        bool virtual _CanView();
        bool virtual _CanInsert();
        bool virtual _CanUpdate(); 
        bool virtual CanView();             // does the current user have view permissions on this record?
        bool virtual CanInsert();           // does the current user have insert permissions on this record?
        bool virtual CanUpdate();           // does the current user have update permissions on this record?
        can_view_status can_view;
        can_insert_status can_insert;
        can_update_status can_update;
public:		// User declarations
        __property AnsiString Title = {read = GetRecordTitle, write = SetRecordTitle};
        __fastcall TformRecordGeneric(TComponent* Owner, map<string,string> & p_parameters, string p_table_name);
        // bool virtual CloseAsk();            // if open, ask save/undo
        // bool virtual CloseSave();           // if open, always save
        bool virtual CloseNow();            // if open, always undo
        bool virtual IsBusy();              // checking on shutdown to see if the user might want to cancel shutdown
        bool virtual PopupMessage (string p_popup_name, string p_popup_id, string p_popup_data); // current_types, list_views...
};
//---------------------------------------------------------------------------
//extern PACKAGE TformRecordGeneric *formRecordGeneric;
//---------------------------------------------------------------------------
#endif
