//---------------------------------------------------------------------------

#ifndef codeRecordIncomingBillH
#define codeRecordIncomingBillH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Menus.hpp>
#include "codeSpecialTransactionSummary.h"
//---------------------------------------------------------------------------
class TformRecordIncomingBill : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TPanel *panelGroup;
        TLabel *lblInvoiceAmount;
        TEdit *editInvoiceAmount;
        TLabel *lblDateReceived;
        TLabel *lblPr;
        TStaticText *txtVendor;
        TStaticText *txtPr;
        TLabel *lblTotalCharge;
        TEdit *editTotalCharge;
        TGroupBox *groupTaxEntities;
        TRadioButton *radioVendor;
        TRadioButton *radioProvider;
        TRadioButton *radioFacility;
        TRadioButton *radioGroup;
        TStaticText *txtProvider;
        TStaticText *txtFacility;
        TStaticText *txtGroup;
        TLabel *lblVisit;
        TStaticText *txtVisit;
        TBitBtn *btnVendorSearch;
        TBitBtn *btnProviderSearch;
        TBitBtn *btnFacilitySearch;
        TBitBtn *btnGroupSearch;
        TDateTimePicker *dateReceived;
        TEdit *editNote;
        TLabel *lblNote;
        TLabel *lblPaidAmount;
        TEdit *editPaidAmount;
        TPopupMenu *popupGroups;
        TMenuItem *menuAddByGroups;
        TEdit *editInvoiceNumber;
        TLabel *lblInvoiceNumber;
        TPageControl *pageLists;
        TTabSheet *sheetTransactions;
        TTabSheet *sheetProcedurePayments;
        TListView *listTransactions;
        TStaticText *staticTransactionDetails;
        TStaticText *staticBetaModifyTransactions;
        TListView *listProcedurePayments;
        TStaticText *staticPrintEOB;
        TCheckBox *checkBeforeAccount;
        TLabel *lblTransactionsSplitBy;
        TCheckBox *checkBeforeName;
        void __fastcall btnVendorSearchClick(TObject *Sender);
        void __fastcall btnProviderSearchClick(TObject *Sender);
        void __fastcall btnFacilitySearchClick(TObject *Sender);
        void __fastcall btnGroupSearchClick(TObject *Sender);
        void __fastcall staticModifyAccPayableClick(TObject *Sender);
        void __fastcall radioVendorClick(TObject *Sender);
        void __fastcall radioOtherClick(TObject *Sender);
        void __fastcall radioClick(TObject *Sender);
        void __fastcall menuAddByGroupsClick(TObject *Sender);
        void __fastcall staticBetaModifyTransactionsClick(TObject *Sender);
        void __fastcall staticTransactionDetailsClick(TObject *Sender);
        void __fastcall staticPrintEOBClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall checkBeforeAccountClick(TObject *Sender);
        void __fastcall checkBeforeNameClick(TObject *Sender);
private:	// User declarations
        //classFilterObject transactions_filter;
        classFilterObject payments_filter;
        //int transactions_request;
        int payment_request;
        int lastRadioChecked;
        classTransactionSummarizer transactions_summary; // jhaley: use transaction summary object
public:		// User declarations
        __fastcall TformRecordIncomingBill(TComponent* Owner, map<string,string> &p_parameters);
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenStart();
        bool ScreenStop();
        bool ScreenLock();
        bool ScreenUnlock();
        void AtlasRefreshListView(int request_num, string matched_value);
        void EditTransaction();
        bool NotNewAnymore();
        bool IsNewAgain();
        void AddPayment();
        void EditPayment();
        static void Do(map<string, string> & p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordIncomingBill *formRecordIncomingBill;
//---------------------------------------------------------------------------
#endif
