//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordLab.h"
#include "codeSpecialViewExpectedLabValues.h"
#include "reportSingleLab.h"
#include "codeRecordObservationResponseSet.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordLab *formRecordLab;
//---------------------------------------------------------------------------
__fastcall TformRecordLab::TformRecordLab(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("measurements"))
{
  Initialize();

  // DEBUG -- avoids modifying code in random places for testing
  FORM_TRY
   TformRecordObservationResponseSet * t = new TformRecordObservationResponseSet(NULL, p_parameters);
   t->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
bool TformRecordLab::ScreenStart()
{
  txtViewExpectedValues->Font->Color = link_color;
  txtPrintLab->Font->Color = link_color;
  // since sherry is being irritating and refuses to let anyone but herself update lab information
  // (i mean, what would a doctor know about labs... obviously less that she does), we have to overwrite
  // this function here. since they might have update permissions to measurements, but not
  // measurements.lab, we have to do the checking
  if(optionsPermissions["table.measurements.lab"]["update"] != "true")
  {
    buttonA->OnClick = NULL;
  }

  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordLab::ScreenStop()
{
  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordLab::IsValidOnScreen()
{
  // check to make sure all values are valid floats
  // give the user a message box and prompt to re-enter if incorrect
  // make sure there is a link to a person, although there's not much the user
  // can do to fix that if there's not

  if (! IsAmount(editN->Text.c_str()))
  {
    PSay("Please enter a valid value for N", m_invalid_data, MB_OK);
    editN->SetFocus();
    return false;
  }
  else if (! IsAmount(editK->Text.c_str()))
  {
    PSay("Please enter a valid value for K", m_invalid_data, MB_OK);
    editK->SetFocus();
    return false;
  }
  else if (! IsAmount(editCo2->Text.c_str()))
  {
    PSay("Please enter a valid value for CO2", m_invalid_data, MB_OK);
    editCo2->SetFocus();
    return false;
  }
  else if (! IsAmount(editGlu->Text.c_str()))
  {
    PSay("Please enter a valid value for GLU", m_invalid_data, MB_OK);
    editGlu->SetFocus();
    return false;
  }
  else if (! IsAmount(editBun->Text.c_str()))
  {
    PSay("Please enter a valid value for BUN", m_invalid_data, MB_OK);
    editBun->SetFocus();
    return false;
  }
  else if (! IsAmount(editCreat->Text.c_str()))
  {
    PSay("Please enter a valid value for CREAT", m_invalid_data, MB_OK);
    editCreat->SetFocus();
    return false;
  }
  else if (! IsAmount(editCa->Text.c_str()))
  {
    PSay("Please enter a valid value for CA", m_invalid_data, MB_OK);
    editCa->SetFocus();
    return false;
  }
  else if (! IsAmount(editAlk_p->Text.c_str()))
  {
    PSay("Please enter a valid value for ALK_P", m_invalid_data, MB_OK);
    editAlk_p->SetFocus();
    return false;
  }
  else if (! IsAmount(editAst->Text.c_str()))
  {
    PSay("Please enter a valid value for AST", m_invalid_data, MB_OK);
    editAst->SetFocus();
    return false;
  }
  else if (! IsAmount(editAlt->Text.c_str()))
  {
    PSay("Please enter a valid value for ALT", m_invalid_data, MB_OK);
    editAlt->SetFocus();
    return false;
  }
  else if (! IsAmount(editTbili->Text.c_str()))
  {
    PSay("Please enter a valid value for TBILI", m_invalid_data, MB_OK);
    editTbili->SetFocus();
    return false;
  }
  else if (! IsAmount(editAlb->Text.c_str()))
  {
    PSay("Please enter a valid value for ALB", m_invalid_data, MB_OK);
    editAlb->SetFocus();
    return false;
  }
  else if (! IsAmount(editTp->Text.c_str()))
  {
    PSay("Please enter a valid value for Tp", m_invalid_data, MB_OK);
    editTp->SetFocus();
    return false;
  }
  else if (! IsAmount(editChol->Text.c_str()))
  {
    PSay("Please enter a valid value for CHOL", m_invalid_data, MB_OK);
    editChol->SetFocus();
    return false;
  }
  else if (! IsAmount(editTrig->Text.c_str()))
  {
    PSay("Please enter a valid value for TRIG", m_invalid_data, MB_OK);
    editTrig->SetFocus();
    return false;
  }
  else if (! IsAmount(editHdlc->Text.c_str()))
  {
    PSay("Please enter a valid value for HDL_C", m_invalid_data, MB_OK);
    editHdlc->SetFocus();
    return false;
  }
  else if (! IsAmount(editLdlc->Text.c_str()))
  {
    PSay("Please enter a valid value for LDL_C", m_invalid_data, MB_OK);
    editLdlc->SetFocus();
    return false;
  }
  else if (! IsAmount(editChhdl->Text.c_str()))
  {
    PSay("Please enter a valid value for CH_HDL", m_invalid_data, MB_OK);
    editChhdl->SetFocus();
    return false;
  }
  else if (! IsAmount(editVldl->Text.c_str()))
  {
    PSay("Please enter a valid value for VLDL", m_invalid_data, MB_OK);
    editVldl->SetFocus();
    return false;
  }
  else if (! IsAmount(editHa1c->Text.c_str()))
  {
    PSay("Please enter a valid value for HA1_C", m_invalid_data, MB_OK);
    editHa1c->SetFocus();
    return false;
  }
  else if (! IsAmount(editMglu->Text.c_str()))
  {
    PSay("Please enter a valid value for M_GLU", m_invalid_data, MB_OK);
    editMglu->SetFocus();
    return false;
  }
  else if (! IsAmount(editUcr->Text.c_str()))
  {
    PSay("Please enter a valid value for U_RC", m_invalid_data, MB_OK);
    editUcr->SetFocus();
    return false;
  }
  else if (! IsAmount(editCa->Text.c_str()))
  {
    PSay("Please enter a valid value for CA", m_invalid_data, MB_OK);
    editCa->SetFocus();
    return false;
  }
  else if (! IsAmount(editAc->Text.c_str()))
  {
    PSay("Please enter a valid value for A_C", m_invalid_data, MB_OK);
    editAc->SetFocus();
    return false;
  }
  else if (! IsAmount(editDpstkua->Text.c_str()))
  {
    PSay("Please enter a valid value for DPSTK UA", m_invalid_data, MB_OK);
    editDpstkua->SetFocus();
    return false;
  }
  else if ((initial_state["person_id"] == "") || (initial_state["person_id"] == "0"))
  {
    PSay("There is no person associated with this record", m_missing_data, MB_OK);
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformRecordLab::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record
  if (initial_state["date_of_measurement"] != "")
    dateMeasurement->Date = Pdate(initial_state["date_of_measurement"], mdy | yyyy).OutDate();
  else
    dateMeasurement->Date = Date();

  editN->Text = initial_state["n"].c_str();
  editK->Text = initial_state["k"].c_str();
  editCl->Text = initial_state["cl"].c_str();
  editCo2->Text = initial_state["co2"].c_str();
  editGlu->Text = initial_state["glu"].c_str();
  editBun->Text = initial_state["bun"].c_str();
  editCreat->Text = initial_state["creat"].c_str();
  editCa->Text = initial_state["ca"].c_str();
  editAlk_p->Text = initial_state["alk_p"].c_str();
  editAst->Text = initial_state["ast"].c_str();
  editAlt->Text = initial_state["alt"].c_str();
  editTbili->Text = initial_state["tbili"].c_str();
  editAlb->Text = initial_state["alb"].c_str();
  editTp->Text = initial_state["tp"].c_str();
  editChol->Text = initial_state["chol"].c_str();
  editTrig->Text = initial_state["trig"].c_str();
  editHdlc->Text = initial_state["hdl_c"].c_str();
  editLdlc->Text = initial_state["ldl_c"].c_str();
  editChhdl->Text = initial_state["ch_hdl"].c_str();
  editVldl->Text = initial_state["vldl"].c_str();
  editHa1c->Text = initial_state["ha1c"].c_str();
  editMglu->Text = initial_state["m_glu"].c_str();
  editMalb->Text = initial_state["m_alb"].c_str();
  editUcr->Text = initial_state["u_cr"].c_str();
  editAc->Text = initial_state["a_c"].c_str();
  editDpstkua->Text = initial_state["dpstk_ua"].c_str();
  if(initial_state["mono"] == "1")
    checkMono->Checked = true;
  else
    checkMono->Checked = false;
  if(initial_state["strep"] == "1")
    checkStrep->Checked = true;
  else
    checkStrep->Checked = false;
  if(initial_state["hcg"] == "1")
    checkHcg->Checked = true;
  else
    checkHcg->Checked = false;
  if(initial_state["flu"] == "1")
    checkFlu->Checked = true;
  else
    checkFlu->Checked = false;
  if(initial_state["hpylori"] == "1")
    checkHpylori->Checked = true;
  else
    checkHpylori->Checked = false;
  if(initial_state["rf"] == "1")
    checkRf->Checked = true;
  else
    checkRf->Checked = false;

  // get the person name associated with the person id that was either selected
  // from the database if it's an existing record, or passed to the form if
  // it's a new record. display the name as a link to the person record.

  CreateLink(txtPerson, NULL, this, initial_state["person_id"], "people");
  CreateLink(txtTask, NULL, this, initial_state["task_id"], "tasks");

  TformRecordGeneric::PutDataOnScreen();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordLab::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  ending_state["date_of_measurement"] = Pdate(dateMeasurement->Date).OutDate(mdy | yyyy);
  ending_state["is_steps_measurement"] = "0";

    ending_state["n"] = editN->Text.c_str();
    ending_state["k"] = editK->Text.c_str();
    ending_state["cl"] = editCl->Text.c_str();
    ending_state["co2"] = editCo2->Text.c_str();
    ending_state["glu"] = editGlu->Text.c_str();
    ending_state["bun"] = editBun->Text.c_str();
    ending_state["creat"] = editCreat->Text.c_str();
    ending_state["ca"] = editCa->Text.c_str();
    ending_state["alk_p"] = editAlk_p->Text.c_str();
    ending_state["ast"] = editAst->Text.c_str();
    ending_state["alt"] = editAlt->Text.c_str();
    ending_state["tbili"] = editTbili->Text.c_str();
    ending_state["alb"] = editAlb->Text.c_str();
    ending_state["tp"] = editTp->Text.c_str();
    ending_state["chol"] = editChol->Text.c_str();
    ending_state["trig"] = editTrig->Text.c_str();
    ending_state["hdl_c"] = editHdlc->Text.c_str();
    ending_state["ldl_c"] = editLdlc->Text.c_str();
    ending_state["ch_hdl"] = editChhdl->Text.c_str();
    ending_state["vldl"] = editVldl->Text.c_str();
    ending_state["ha1c"] = editHa1c->Text.c_str();
    ending_state["m_glu"] = editMglu->Text.c_str();
    ending_state["m_alb"] = editMalb->Text.c_str();
    ending_state["u_cr"] = editUcr->Text.c_str();
    ending_state["a_c"] = editAc->Text.c_str();
    ending_state["dpstk_ua"] = editDpstkua->Text.c_str();
  if(checkMono->Checked)
    ending_state["mono"] = "1";
  else
    ending_state["mono"] = "0";
  if(checkStrep->Checked)
    ending_state["strep"] = "1";
  else
    ending_state["strep"] = "0";
  if(checkHcg->Checked)
    ending_state["hcg"] = "1";
  else
    ending_state["hcg"] = "0";
  if(checkFlu->Checked)
    ending_state["flu"] = "1";
  else
    ending_state["flu"] = "0";
  if(checkHpylori->Checked)
    ending_state["hpylori"] = "1";
  else
    ending_state["hpylori"] = "0";
  if(checkRf->Checked)
    ending_state["rf"] = "1";
  else
    ending_state["rf"] = "0";

  if (initial_state["task_id"] != "")
    ending_state["task_id"] = initial_state["task_id"];
  else
    ending_state["task_id"] = "0";
  ending_state["person_id"] = initial_state["person_id"];
  if (initial_state["participations_id"] == "")
    ending_state["participations_id"] = "0";
  else
    ending_state["participations_id"] = initial_state["participations_id"];
  if (initial_state["group_id"] == "")
    ending_state["group_id"] = "0";
  else
    ending_state["group_id"] = initial_state["group_id"];
  ending_state["is_lab"] = "1";
  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();

  return true;
}
//---------------------------------------------------------------------------
bool TformRecordLab::ScreenLock()
{
  // disable panel containing edit boxes

    panelGroup->Enabled = false;
    TformRecordGeneric::ScreenLock();
    return true;

}
//---------------------------------------------------------------------------
bool TformRecordLab::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordLab::NotNewAnymore()
{
  txtPrintLab->Enabled = true;
  TformRecordGeneric::NotNewAnymore();
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordLab::editNKeyPress(TObject *Sender, char &Key)
{
 if (Key == VK_RETURN)
 {
  if (editN->Focused())
   editK->SetFocus();
  else if (editK->Focused())
   editCl->SetFocus();
  else if (editCl->Focused())
   editCo2->SetFocus();
  else if (editCo2->Focused())
   editGlu->SetFocus();
  else if (editGlu->Focused())
   editBun->SetFocus();
  else if (editBun->Focused())
   editCreat->SetFocus();
  else if (editCreat->Focused())
   editCa->SetFocus();
  else if (editCa->Focused())
   editAlk_p->SetFocus();
  else if (editAlk_p->Focused())
   editAst->SetFocus();
  else if (editAst->Focused())
   editAlt->SetFocus();
  else if (editAlt->Focused())
   editTbili->SetFocus();
  else if (editTbili->Focused())
   editAlb->SetFocus();
  else if (editAlb->Focused())
   editTp->SetFocus();
  else if (editTp->Focused())
   editChol->SetFocus();
  else if (editChol->Focused())
   editTrig->SetFocus();
  else if (editTrig->Focused())
   editHdlc->SetFocus();
  else if (editHdlc->Focused())
   editLdlc->SetFocus();
  else if (editLdlc->Focused())
   editChhdl->SetFocus();
  else if (editChhdl->Focused())
   editVldl->SetFocus();
  else if (editVldl->Focused())
   editHa1c->SetFocus();
  else if (editHa1c->Focused())
   editMglu->SetFocus();
  else if (editMglu->Focused())
   editMalb->SetFocus();
  else if (editMalb->Focused())
   editUcr->SetFocus();
  else if (editUcr->Focused())
   editAc->SetFocus();

  // Philip did this in the code where I copied this from (TformSpecialNewProviderBill)  I don't know if it is important or not
  Key = 0;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordLab::txtViewExpectedValuesClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialViewExpectedLab *value_form = new TformSpecialViewExpectedLab(NULL);
    value_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------

void __fastcall TformRecordLab::txtPrintLabClick(TObject *Sender)
{
//    report_form->report->Prepare();
//    report_form->report->Print();
//    report_form->CloseNow();
  string gender_id = GetOneField(dbDatabase, "select people.gender_id from people where id = " + initial_state["person_id"]);
  string title = "Lab results for ";
  title += GetPersonName(dbDatabase, initial_state["person_id"], first_last) + " - ";
  title += initial_state["date_of_measurement"];
  FORM_TRY
    TformReportSingleLab *report_form = new TformReportSingleLab(NULL);
    report_form->lblTitle->Caption = title.c_str();
    report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
    if(lookupTables->ValueOf("gender_types", gender_id) == "male")
    {
      report_form->lblExpectedAlkp->Caption = "53 - 128";
      report_form->lblExpectedCreat->Caption = "0.7 - 1.3";
    }
    else if(lookupTables->ValueOf("gender_types", gender_id) == "female")
    {
      report_form->lblExpectedAlkp->Caption = "42 - 98";
      report_form->lblExpectedCreat->Caption = "0.6 - 1.2";
    }
    report_form->lblNa->Caption = initial_state["na"].c_str();
    report_form->lblK->Caption = initial_state["k"].c_str();
    report_form->lblCl->Caption = initial_state["cl"].c_str();
    report_form->lblGlu->Caption = initial_state["glu"].c_str();
    report_form->lblBun->Caption = initial_state["bun"].c_str();
    report_form->lblCreat->Caption = initial_state["creat"].c_str();
    report_form->lblCa->Caption = initial_state["ca"].c_str();
    report_form->lblAlkp->Caption = initial_state["alk_p"].c_str();
    report_form->lblAst->Caption = initial_state["ast"].c_str();
    report_form->lblAlt->Caption = initial_state["alt"].c_str();
    report_form->lblTbili->Caption = initial_state["tbili"].c_str();
    report_form->lblAlb->Caption = initial_state["alb"].c_str();
    report_form->lblTp->Caption = initial_state["tp"].c_str();
    report_form->lblChol->Caption = initial_state["chol"].c_str();
    report_form->lblTrig->Caption = initial_state["trig"].c_str();
    report_form->lblHdl->Caption = initial_state["hdl_c"].c_str();
    report_form->lblLdl->Caption = initial_state["ldl_c"].c_str();
    report_form->lblChHdl->Caption = initial_state["ch_hdl"].c_str();
    report_form->lblVldl->Caption = initial_state["vldl"].c_str();
    report_form->lblHa1c->Caption = initial_state["ha1_c"].c_str();
    report_form->report->Preview();
  FORM_CATCH


}
//---------------------------------------------------------------------------

