// TODO: should we check for overlap?
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "codeRecordLogsheet.h"
#include "codeRecordActivity.h"
#include "codeRecordPerson.h"
#include "codeSearchPerson.h"
#include "reportPrintLogsheets.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordLogsheet *formRecordLogsheet;
//---------------------------------------------------------------------------
__fastcall TformRecordLogsheet::TformRecordLogsheet(TComponent* Owner, map<string, string> & p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("activity_logsheets"))
{
 diab_activity_filter.SetListViewHandle(listDiabActivities);
 diab_activity_filter.SetSecurity("activities");
 diab_activity_filter.AddColumnSpec("Date", "activities", as_date, true, 80);
 diab_activity_filter.AddColumnSpec("Activity", "activities", as_text, true, 125);
 diab_activity_filter.AddColumnSpec("Intensity", "activities", as_text, true, 80);
 diab_activity_filter.AddColumnSpec("Distance", "activities", as_double, false, 90);
 diab_activity_filter.AddColumnSpec("Time Spent", "activities", as_double, true, 95);
 diab_activity_filter.AddColumnSpec("Steps", "activities", as_double, false, 80);
 diab_activity_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 diab_activity_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 diab_activity_filter.FetchPreferences("recordperson.diab_activity_filter");
 diab_activity_filter.SetIconStatus(true);
 diab_activity_filter.SetSQLStatement("");
 diab_activity_filter.RefreshDataSet();
 Initialize();
 //current_person_id = initial_state["person_id"];
}
//---------------------------------------------------------------------------
bool TformRecordLogsheet::ScreenStart()
{
 // register combo box
 TformRecordGeneric::ScreenStart();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordLogsheet::ScreenStop()
{
 // unregister combo box
 TformRecordGeneric::ScreenStop();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordLogsheet::IsValidOnScreen()
{
 // Check to see that if a date is entered in txtDate_Turned_In, it is valid
 if (! Pdate (txtDate_Turned_In->Text.c_str(), mdy | yy).IsValidDate() && (txtDate_Turned_In->Text != ""))
  {
   PSay("Please enter a valid date turned in", m_invalid_data, MB_OK);
   txtDate_Turned_In->SetFocus();
   return false;
  }
 // Check to see that a person is attached to the logsheet
 else if (GetValidLinkId(txtPerson) == "")
 {
  PSay("There is no person attached to this record", m_missing_data, MB_OK);
  return false;
 }
 // Check to see that the begin date is before the end date
 else if (Pdate(dateBeginDate->DateTime) > Pdate(dateEndDate->DateTime))
 {
  PSay("Your logsheet's End Date must be after its Begin Date", m_invalid_data, MB_OK);
  return false;
 }
 else
   return true;
}
//---------------------------------------------------------------------------
bool TformRecordLogsheet::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  txtDate_Turned_In->Text = initial_state["date_turned_in"].c_str();
  Pdate thingie = CurrentPdate();
  thingie.day = 1;
  thingie.mod(-1, in_days); // end of last month
  if (initial_state["end_date"] == "")
  {
   dateEndDate->Date = thingie.OutDate();
  }
  else
  {
   dateEndDate->Date = Pdate(initial_state["end_date"], mdy | yyyy).OutDate();
  }
  thingie.day = 1; // beginning of last month
  if (initial_state["begin_date"] == "")
  {
   dateBeginDate->Date = thingie.OutDate();
  }
  else
  {
   dateBeginDate->Date = Pdate(initial_state["begin_date"], mdy | yyyy).OutDate();
  }
  // get the person name associated with the person id that was either selected
  // from the database if it's an existing record, or passed to the form if
  // it's a new record. display the name as a link to the person record.

  CreateLink(txtPerson, NULL, this, initial_state["person_id"], "people");

  TformRecordGeneric::PutDataOnScreen();
  return true; // what can really go wrong?
}
//---------------------------------------------------------------------------
bool TformRecordLogsheet::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  if (txtDate_Turned_In->Text != "")
    ending_state["date_turned_in"] =  Pdate (txtDate_Turned_In->Text.c_str(), mdy | yy).OutDate(mdy | yyyy);
  else
    ending_state["date_turned_in"] = "";
  ending_state["begin_date"] =  Pdate (dateBeginDate->Date).OutDate(mdy | yyyy);
  ending_state["end_date"] =  Pdate (dateEndDate->Date).OutDate(mdy | yyyy);
  ending_state["person_id"] = GetValidLinkId(txtPerson);
  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();

  return true; // again, not much can go wrong here
}
//---------------------------------------------------------------------------
bool TformRecordLogsheet::ScreenLock()
{
 panelGroupBox->Enabled = false;
 TformRecordGeneric::ScreenLock();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordLogsheet::ScreenUnlock()
{
 panelGroupBox->Enabled = true;
 TformRecordGeneric::ScreenUnlock();
 return true;
}
//---------------------------------------------------------------------------
void TformRecordLogsheet::EditDiabActivity()
{
  map<string,string> temp_map;
  temp_map["id"] = diab_activity_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordActivity * activityRecord = new TformRecordActivity(NULL, temp_map);
    activityRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordLogsheet::AddDiabActivity()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["person_id"];
  temp_map["activity_logsheet_id"] = initial_state["id"];
  FORM_TRY
    TformRecordActivity * activityRecord = new TformRecordActivity(NULL, temp_map);
    activityRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
bool TformRecordLogsheet::IsNewAgain()
{
 diab_activity_filter.SetSQLStatement(string(""));
 diab_activity_filter.RefreshDataSet();
 diab_activity_filter.SetAddEdit(this, NULL, NULL);
 TformRecordGeneric::IsNewAgain();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordLogsheet::NotNewAnymore()
{
 string sql;
 //current_person_id = initial_state["person_id"];
 if (optionsPermissions["table.activities"]["view"] == "true")
  {
    sql = "select activities.date_of_activity, activity_code_types.item, "
          "intensity_types.item, activities.distance, activities.time_spent, "
          "activities.steps, activities.current_id, activities.id "
          "from activities, activity_code_types, intensity_types "
          "where activities.activity_code_id = activity_code_types.id and "
          "activities.intensity_id = intensity_types.id and "
          "activities.activity_logsheet_id = " + initial_state["id"];
    diab_activity_filter.SetSQLStatement(sql);
    diab_activity_filter.RefreshDataSet();
    diab_activity_filter.SetAddEdit(this, AddRecord(&(TformRecordLogsheet::AddDiabActivity)),
                                    EditRecord(&(TformRecordLogsheet::EditDiabActivity)));
    diab_activity_request = atlas->RequestNotificationWhen("activities.activity_logsheet_id", initial_state["id"], rel_e, as_int, this,
                            RefreshHandler(&(TformRecordLogsheet::AtlasRefreshListViews)));
  }
  TformRecordGeneric::NotNewAnymore();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordLogsheet::AtlasRefreshListViews(int request_num, string matched_value)
{
 if (request_num == diab_activity_request)
    diab_activity_filter.RefreshDataSet();
 return true;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordLogsheet::btnPersonSearchClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtPerson, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformRecordLogsheet::buttonAClick(TObject *Sender)
{
 string sql;
 if (buttonA->Caption == "Save")
 {
  string current_person_id = GetValidLinkId(txtPerson);
  if (current_person_id != "" && current_person_id != initial_state["person_id"] && initial_state["person_id"] != "" )
  {
   if (PSay("Do you want to attach all of the activities on this logsheet to the new person?",m_message,MB_YESNO) == IDYES)
   {
    if (PSay("Are you sure you want to make this change? ",m_message,MB_YESNO) == IDYES)
    {
     sql="update activities set person_id = '" + current_person_id + "' where activity_logsheet_id = '" + initial_state["id"] + "'";
     ExecuteStatement(dbDatabase, sql);
    }
    else
    {
     PSay("Action cancelled.", m_message, MB_OK);
    }
   }
   else
   {
     PSay("Action cancelled.", m_message, MB_OK);
     //current_person_id = initial_state["person_id"];
     CreateLink(txtPerson, btnPersonSearch, this, initial_state["person_id"], "people");
   }
   TformRecordGeneric::buttonAClick(this);
  }
  else
  {
   TformRecordGeneric::buttonAClick(this);
  }
 }
 else
 {
  TformRecordGeneric::buttonAClick(this);
 }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordLogsheet::txtPrintLogsheetClick(TObject *Sender)
{
    Processing(true);
    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBeginDate->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEndDate->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string current_person_id = GetValidLinkId(txtPerson);
    string title = "Activity report for " + GetPersonName(dbDatabase, current_person_id, first_last);

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select activities.date_of_activity, activity_code_types.item activity, intensity_types.item intensity, "
            "activities.distance, activities.time_spent, activities.steps, activities.current_id, "
            "activities.id "
            "from activities, activity_code_types, intensity_types "
            "where activities.activity_code_id = activity_code_types.id and "
            "activities.intensity_id = intensity_types.id and activities.activity_logsheet_id = '" + initial_state["id"] + "' " +
            "order by activities.date_of_activity";

      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();
      FORM_TRY
       TformReportPrintLogsheets * report_form = new TformReportPrintLogsheets(NULL);
       report_form->report->DataSet = dbDataSet;
       report_form->lblPersonName->Caption = txtPerson->Caption;
       report_form->lblBeginDate->Caption = Pdate(dateBeginDate->Date).OutDate(mdy | yyyy).c_str();
       report_form->lblEndDate->Caption = Pdate(dateEndDate->Date).OutDate(mdy | yyyy).c_str();
       report_form->txtDateOfActivity->DataSet = dbDataSet;
       report_form->txtDateOfActivity->DataField = "date_of_activity";
       report_form->txtActivity->DataSet = dbDataSet;
       report_form->txtActivity->DataField = "activity";
       report_form->txtIntensity->DataSet = dbDataSet;
       report_form->txtIntensity->DataField = "intensity";
       report_form->exprTime->Expression = "FORMATNUMERIC('##0.00', time_spent)";
       report_form->exprDistance->Expression = "FORMATNUMERIC('##0.00', distance)";
       report_form->exprNumberOfSteps->Expression = "FORMATNUMERIC('##,##0.00', steps)";
       report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
       Processing(false);
       report_form->report->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
}
//---------------------------------------------------------------------------

