//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordMeasurement.h"
#include "codeRecordObservationResponseSet.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordMeasurement *formRecordMeasurement;
//---------------------------------------------------------------------------
__fastcall TformRecordMeasurement::TformRecordMeasurement(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("measurements"))
{
  Initialize();

  // DEBUG -- avoids modifying code in random places for testing
  FORM_TRY
   TformRecordObservationResponseSet * t = new TformRecordObservationResponseSet(NULL, p_parameters);
   t->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
bool TformRecordMeasurement::ScreenStart()
{
  lookupTables->RegisterComboBox("rating_types", cboCardioEndurance);
  lookupTables->RegisterComboBox("rating_types", cboMuscEndurance);
  lookupTables->RegisterComboBox("rating_types", cboMuscleStrength);
  lookupTables->RegisterComboBox("rating_types", cboFlexability);
  lookupTables->RegisterComboBox("rating_types", cboBodyComposition);
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordMeasurement::ScreenStop()
{
  lookupTables->UnregisterComboBox("rating_types", cboCardioEndurance);
  lookupTables->UnregisterComboBox("rating_types", cboMuscEndurance);
  lookupTables->UnregisterComboBox("rating_types", cboMuscleStrength);
  lookupTables->UnregisterComboBox("rating_types", cboFlexability);
  lookupTables->UnregisterComboBox("rating_types", cboBodyComposition);
  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordMeasurement::IsValidOnScreen()
{
  if (! IsAmount(editHeight->Text.c_str()))
  {
    PSay("Please enter a valid height", m_invalid_data, MB_OK);
    editHeight->SetFocus();
    return false;
  }
  else if (! IsAmount(editWeight->Text.c_str()))
  {
    PSay("Please enter a valid weight", m_invalid_data, MB_OK);
    editWeight->SetFocus();
    return false;
  }
  else if (! IsAmount(editWaist->Text.c_str()))
  {
    PSay("Please enter a valid waist measurement", m_invalid_data, MB_OK);
    editWaist->SetFocus();
    return false;
  }
  else if (! IsAmount(editHip->Text.c_str()))
  {
    PSay("Please enter a valid hip measurement", m_invalid_data, MB_OK);
    editHip->SetFocus();
    return false;
  }
  else if (! IsAmount(editTricep->Text.c_str()))
  {
    PSay("Please enter a valid tricep measurement", m_invalid_data, MB_OK);
    editTricep->SetFocus();
    return false;
  }
  else if (! IsAmount(editCalf->Text.c_str()))
  {
    PSay("Please enter a valid calf measurement", m_invalid_data, MB_OK);
    editCalf->SetFocus();
    return false;
  }
  else if (! IsAmount(editFoc->Text.c_str()))
  {
    PSay("Please enter a valid value for FOC", m_invalid_data, MB_OK);
    editFoc->SetFocus();
    return false;
  }
  else if (! IsAmount(editTemperature->Text.c_str()))
  {
    PSay("Please enter a valid temperature", m_invalid_data, MB_OK);
    editTemperature->SetFocus();
    return false;
  }
  else if (! IsAmount(editPulse->Text.c_str()))
  {
    PSay("Please enter a valid pulse", m_invalid_data, MB_OK);
    editPulse->SetFocus();
    return false;
  }
  else if (! IsAmount(editResiprations->Text.c_str()))
  {
    PSay("Please enter a valid number of respirations", m_invalid_data, MB_OK);
    editResiprations->SetFocus();
    return false;
  }
  else if (! IsInt(editBloodPressureHi->Text.c_str()))
  {
    PSay("Please enter a valid blood pressure (di)", m_invalid_data, MB_OK);
    editBloodPressureHi->SetFocus();
    return false;
  }
  else if (! IsInt(editBloodPressureLow->Text.c_str()))
  {
    PSay("Please enter a valid blood pressure (sys)", m_invalid_data, MB_OK);
    editBloodPressureLow->SetFocus();
    return false;
  }
  else if (! IsAmount(editBloodSugar->Text.c_str()))
  {
    PSay("Please enter a valid blood sugar", m_invalid_data, MB_OK);
    editBloodSugar->SetFocus();
    return false;
  }
  else if (! IsAmount(editFastingBloodSugar->Text.c_str()))
  {
    PSay("Please enter a valid fasting blood sugar", m_invalid_data, MB_OK);
    editFastingBloodSugar->SetFocus();
    return false;
  }

  else if (! IsAmount(editSpo2->Text.c_str()))
  {
    PSay("Please enter a valid value for SPO2", m_invalid_data, MB_OK);
    editSpo2->SetFocus();
    return false;
  }
  else if(! lookupTables->IsInLookUpTable("rating_types", cboCardioEndurance))
  {
    PSay("Please enter a valid value for cardiovascular endurance", m_invalid_data, MB_OK);
    cboCardioEndurance->SetFocus();
    return false;
  }
  else if(! lookupTables->IsInLookUpTable("rating_types", cboMuscEndurance))
  {
    PSay("Please enter a valid value for muscular endurance", m_invalid_data, MB_OK);
    cboMuscEndurance->SetFocus();
    return false;
  }
  else if(! lookupTables->IsInLookUpTable("rating_types", cboMuscleStrength))
  {
    PSay("Please enter a valid value for muscle strength", m_invalid_data, MB_OK);
    cboMuscleStrength->SetFocus();
    return false;
  }
  else if(! lookupTables->IsInLookUpTable("rating_types", cboFlexability))
  {
    PSay("Please enter a valid value for flexability", m_invalid_data, MB_OK);
    cboFlexability->SetFocus();
    return false;
  }
  else if(! lookupTables->IsInLookUpTable("rating_types", cboBodyComposition))
  {
    PSay("Please enter a valid value for body composition", m_invalid_data, MB_OK);
    cboBodyComposition->SetFocus();
    return false;
  }
  else if ((initial_state["person_id"] == "") || (initial_state["person_id"] == "0"))
  {
    PSay("There is no person associated with this record", m_missing_data, MB_OK);
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformRecordMeasurement::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record
  if (initial_state["date_of_measurement"] != "")
    dateMeasurement->Date = Pdate(initial_state["date_of_measurement"], mdy | yyyy).OutDate();
  else
    dateMeasurement->Date = Date();
  if (initial_state["is_steps_measurement"] == "1")
    checkSteps->Checked = true;
  else
    checkSteps->Checked = false;
  lblBMI->Caption = initial_state["bmi"].c_str();

  editHeight->Text = initial_state["height"].c_str();
  editWeight->Text = initial_state["weight"].c_str();
  editWaist->Text = initial_state["waist"].c_str();
  editHip->Text = initial_state["hip"].c_str();
  editTricep->Text = initial_state["tricep"].c_str();
  editCalf->Text = initial_state["calf"].c_str();
  editBloodSugar->Text = initial_state["blood_sugar"].c_str();
  editFastingBloodSugar->Text = initial_state["fasting_blood_sugar"].c_str();
  editBloodPressureHi->Text = initial_state["blood_pressure_hi"].c_str();
  editBloodPressureLow->Text = initial_state["blood_pressure_low"].c_str();
  editTemperature->Text = initial_state["temperature"].c_str();
  editPulse->Text = initial_state["pulse"].c_str();
  editResiprations->Text = initial_state["respirations"].c_str();
  editFoc->Text = initial_state["foc"].c_str();
  editSpo2->Text = initial_state["spo2"].c_str();
  cboCardioEndurance->Text = lookupTables->ValueOf("rating_types", initial_state["cardiovascular_endurance_id"]).c_str();
  cboMuscEndurance->Text = lookupTables->ValueOf("rating_types", initial_state["muscular_endurance_id"]).c_str();
  cboMuscleStrength->Text = lookupTables->ValueOf("rating_types", initial_state["muscle_strength_id"]).c_str();
  cboFlexability->Text = lookupTables->ValueOf("rating_types", initial_state["flexability_id"]).c_str();
  cboBodyComposition->Text = lookupTables->ValueOf("rating_types", initial_state["body_composition_id"]).c_str();

  // get the person name associated with the person id that was either selected
  // from the database if it's an existing record, or passed to the form if
  // it's a new record. display the name as a link to the person record.

  CreateLink(txtPerson, NULL, this, initial_state["person_id"], "people");
  CreateLink(txtTask, NULL, this, initial_state["task_id"], "tasks");
  CreateLink(txtParticipation, NULL, this, initial_state["participations_id"], "participations");

  if(optionsPermissions["table.measurements.diab"]["insert"] != "true")
    checkSteps->Enabled = false;
  TformRecordGeneric::PutDataOnScreen();  
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordMeasurement::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  ending_state["date_of_measurement"] = Pdate(dateMeasurement->Date).OutDate(mdy | yyyy);
  if (checkSteps->Checked)
    ending_state["is_steps_measurement"] = "1";
  else
    ending_state["is_steps_measurement"] = "0";
   
  if(editHeight->Text != "" && StringToFloat(AmountToString(editHeight->Text.c_str())) != 0.00)
    ending_state["height"] = editHeight->Text.c_str();
  else
    ending_state["height"] = "";

  if(editWeight->Text != "" && StringToFloat(AmountToString(editWeight->Text.c_str())) != 0.00)
    ending_state["weight"] = editWeight->Text.c_str();
  else
    ending_state["weight"] = "";


  if ((ending_state["height"] != "0") && (ending_state["height"] != "") &&
      (ending_state["weight"] != "0") && (ending_state["weight"] != ""))
  {
    // bmi = weight in kg / height^2 in meters
    ending_state["bmi"] = FloatToString((StringToFloat(ending_state["weight"]) / 2.2) /
                          ((StringToFloat(ending_state["height"]) * 0.0254) *
                           (StringToFloat(ending_state["height"]) * 0.0254)));
  }

  if(editWaist->Text != "" && StringToFloat(AmountToString(editWaist->Text.c_str())) != 0.00)
    ending_state["waist"] = editWaist->Text.c_str();
  else
    ending_state["waist"] = "";

  if(editHip->Text != "" && StringToFloat(AmountToString(editHip->Text.c_str())) != 0.00)
    ending_state["hip"] = editHip->Text.c_str();
  else
    ending_state["hip"] = "";

  if(editTricep->Text != "" && StringToFloat(AmountToString(editTricep->Text.c_str())) != 0.00)
    ending_state["tricep"] = editTricep->Text.c_str();
  else
    ending_state["tricep"] = "";

  if(editCalf->Text != "" && StringToFloat(AmountToString(editCalf->Text.c_str())) != 0.00)
    ending_state["calf"] = editCalf->Text.c_str();
  else
    ending_state["calf"] = "";

  if(editFoc->Text != "" && StringToFloat(AmountToString(editFoc->Text.c_str())) != 0.00)
    ending_state["foc"] = editFoc->Text.c_str();
  else
    ending_state["foc"] = "";

  if(editBloodSugar->Text != "" && StringToFloat(AmountToString(editBloodSugar->Text.c_str())) != 0.00)
    ending_state["blood_sugar"] = editBloodSugar->Text.c_str();
  else
    ending_state["blood_sugar"] = "";

  if(editFastingBloodSugar->Text != "" && StringToFloat(AmountToString(editFastingBloodSugar->Text.c_str())) != 0.00)
    ending_state["fasting_blood_sugar"] = editFastingBloodSugar->Text.c_str();
  else
    ending_state["fasting_blood_sugar"] = "";

  if(editBloodPressureHi->Text != "" && StringToFloat(AmountToString(editBloodPressureHi->Text.c_str())) != 0.00)
    ending_state["blood_pressure_hi"] = editBloodPressureHi->Text.c_str();
  else
    ending_state["blood_pressure_hi"] = "";

  if(editBloodPressureLow->Text != "" && StringToFloat(AmountToString(editBloodPressureLow->Text.c_str())) != 0.00)
    ending_state["blood_pressure_low"] = editBloodPressureLow->Text.c_str();
  else
    ending_state["blood_pressure_low"] = "";

  if(editTemperature->Text != "" && StringToFloat(AmountToString(editTemperature->Text.c_str())) != 0.00)
    ending_state["temperature"] = editTemperature->Text.c_str();
  else
    ending_state["temperature"] = "";

  if(editPulse->Text != "" && StringToFloat(AmountToString(editPulse->Text.c_str())) != 0.00)
    ending_state["pulse"] = editPulse->Text.c_str();
  else
    ending_state["pulse"] = "";

  if(editResiprations->Text != "" && StringToFloat(AmountToString(editResiprations->Text.c_str())) != 0.00)
    ending_state["respirations"] = editResiprations->Text.c_str();
  else
    ending_state["respirations"] = "";

  if(editSpo2->Text != "" && StringToFloat(AmountToString(editSpo2->Text.c_str())) != 0.00)
    ending_state["spo2"] = editSpo2->Text.c_str();
  else
    ending_state["spo2"] = "";

  ending_state["cardiovascular_endurance_id"] = lookupTables->IdOf("rating_types", cboCardioEndurance);
  ending_state["muscular_endurance_id"] = lookupTables->IdOf("rating_types", cboMuscEndurance);
  ending_state["muscle_strength_id"] = lookupTables->IdOf("rating_types", cboMuscleStrength);
  ending_state["flexability_id"] = lookupTables->IdOf("rating_types", cboFlexability);
  ending_state["body_composition_id"] = lookupTables->IdOf("rating_types", cboBodyComposition);

  ending_state["mono"] = ""; // "0";
  ending_state["strep"] = ""; //"0";
  ending_state["hcg"] = ""; //"0";
  ending_state["flu"] = ""; //"0";
  ending_state["hpylori"] = ""; //"0";
  ending_state["rf"] = ""; //"0";

  if (initial_state["task_id"] != "")
    ending_state["task_id"] = initial_state["task_id"];
  else
    ending_state["task_id"] = "0";
  ending_state["person_id"] = initial_state["person_id"];
  if (initial_state["participations_id"] == "")
    ending_state["participations_id"] = "0";
  else
    ending_state["participations_id"] = initial_state["participations_id"];
  if (initial_state["group_id"] == "")
    ending_state["group_id"] = "0";
  else
    ending_state["group_id"] = initial_state["group_id"];
  ending_state["is_lab"] = "0";
  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();

  return true;
}
//---------------------------------------------------------------------------
bool TformRecordMeasurement::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordMeasurement::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
