//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordMessageBoxLog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformRecordMessageBoxLog *formRecordMessageBoxLog;
//---------------------------------------------------------------------------
__fastcall TformRecordMessageBoxLog::TformRecordMessageBoxLog(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("message_box_log"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordMessageBoxLog::ScreenStart()
{
  lookupTables->RegisterComboBox("users", cboUser);
  lookupTables->RegisterComboBox("message_box_types", cboType);
  lookupTables->RegisterComboBox("message_box_response_types", cboResponse);
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordMessageBoxLog::ScreenStop()
{
  lookupTables->UnregisterComboBox("users", cboUser);
  lookupTables->UnregisterComboBox("message_box_types", cboType);
  lookupTables->UnregisterComboBox("message_box_response_types", cboResponse);
  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordMessageBoxLog::IsValidOnScreen()
{
  // This record is read-only, so it's never valid for saving.
  return false;
}
//---------------------------------------------------------------------------
bool TformRecordMessageBoxLog::PutDataOnScreen()
{
  Pstamp date_time;
  cboUser->Text = PrettyString(lookupTables->ValueOf("users", initial_state["user_id"])).c_str();
  date_time = Pstamp(initial_state["event_stamp"], global_mode);
  dateMessage->Date = date_time.OutDate();
  timeMessage->Time = date_time.OutTime();
  editForm->Text = initial_state["form_name"].c_str();
  cboType->Text = SentenceString(lookupTables->ValueOf("message_box_types", initial_state["message_box_id"])).c_str();
  cboResponse->Text = PrettyString(lookupTables->ValueOf("message_box_response_types", initial_state["message_box_response_id"])).c_str();
  editResponseTime->Text = IntToString(StringToInt(initial_state["response_time"])).c_str();
  editMessage->Text = initial_state["message_text"].c_str();
  editOtherInfo->Text = initial_state["other_info"].c_str();
  TformRecordGeneric::PutDataOnScreen();

  return true;
}
//---------------------------------------------------------------------------
bool TformRecordMessageBoxLog::GetDataFromScreen()
{
  // This record is read-only, so we never get data from the screen.
  return false;
}
//---------------------------------------------------------------------------
bool TformRecordMessageBoxLog::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  editMessage->ReadOnly = true;
  editMessage->TabStop = false;
  editOtherInfo->ReadOnly = true;
  editOtherInfo->TabStop = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordMessageBoxLog::ScreenUnlock()
{
  // This record is read-only, so we keep the Unlock button disabled.
  return false;
}
//---------------------------------------------------------------------------
bool TformRecordMessageBoxLog::CanUpdate()
{
  // This record is read-only, so we cannot update at any time.
  return false;
}
//---------------------------------------------------------------------------
bool TformRecordMessageBoxLog::CanInsert()
{
  // This record is read-only, so we cannot insert at any time.
  return false;
}
//---------------------------------------------------------------------------
bool TformRecordMessageBoxLog::UpdateCurrent()
{
  // Note that the message_box_log table does not presently have any finger-pointing fields,
  // and they would be largely redundant to the information already contained. As long as I'm
  // not allowing new log items to be created here, I'll just set a fake current_id and hide
  // the meaningless Current info button. That way the icon and button don't give the
  // impression that something is wrong with the record.
  initial_state["current_id"] = lookupTables->IdOf("current_types", "Current");
  TformRecordGeneric::UpdateCurrent();
  buttonCurrent->Enabled = false;
  buttonCurrent->Visible = false;
  return true;
}
