//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordMetricUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordMetricUnit *formRecordMetricUnit;
//---------------------------------------------------------------------------
__fastcall TformRecordMetricUnit::TformRecordMetricUnit(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("units"))
{
 fields_to_leave_raw.insert("item");
 Initialize();
}
//---------------------------------------------------------------------------
void TformRecordMetricUnit::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordMetricUnit * z = new TformRecordMetricUnit(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
bool TformRecordMetricUnit::IsValidOnScreen()
{
 if (comboDimension->Text == "" || !lookupTables->IsInLookUpTable("dimension_types", comboDimension->Text.c_str()))
 {
  PSay("Please select a dimension", m_missing_data, MB_OK);
  comboDimension->SetFocus();
  return false;
 }

 if (editItem->Text == "")
 {
  PSay("Please enter a unit name", m_missing_data, MB_OK);
  editItem->SetFocus();
  return false;
 }

 if (editRatio->Text != "" && !IsFloat(editRatio->Text.c_str()))
 {
  PSay("Please enter a valid (numeric) ratio", m_invalid_data, MB_OK);
  editRatio->SetFocus();
  return false;
 }

 if (editOffset->Text != "" && !IsFloat(editOffset->Text.c_str()))
 {
  PSay("Please enter a valid (numeric) offset", m_invalid_data, MB_OK);
  editOffset->SetFocus();
  return false;
 }

 return true;
}
//---------------------------------------------------------------------------
bool TformRecordMetricUnit::PutDataOnScreen()
{
  editItem->Text = initial_state["item"].c_str();
  checkValid->Checked = (initial_state["valid"] == "1");
  comboDimension->Text = lookupTables->ValueOf("dimension_types", initial_state["dimension_id"]).c_str();
  editRatio->Text = initial_state["conversion_ratio"].c_str();
  editOffset->Text = initial_state["conversion_offset"].c_str();

  TformRecordGeneric::PutDataOnScreen();
  return true;}
//---------------------------------------------------------------------------
bool TformRecordMetricUnit::GetDataFromScreen()
{
  ending_state["id"] = initial_state["id"];

  ending_state["item"] = editItem->Text.c_str();
  ending_state["valid"] = (checkValid->Checked ? "1" : "0");
  ending_state["dimension_id"] = lookupTables->IdOf("dimension_types", comboDimension->Text.c_str());
  ending_state["conversion_ratio"] = editRatio->Text.c_str();
  ending_state["conversion_offset"] = editOffset->Text.c_str();

  TformRecordGeneric::GetDataFromScreen();
  return true;}
//---------------------------------------------------------------------------
bool TformRecordMetricUnit::ScreenStart()
{
  lookupTables->RegisterComboBox("dimension_types", comboDimension);
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordMetricUnit::ScreenStop()
{
  lookupTables->UnregisterComboBox(comboDimension);
  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordMetricUnit::ScreenLock()
{
  panelGroup->Enabled = false;
  TformRecordGeneric::ScreenLock();
  return true;}
//---------------------------------------------------------------------------
bool TformRecordMetricUnit::ScreenUnlock()
{
  panelGroup->Enabled = true;
  TformRecordGeneric::ScreenUnlock();
  return true;}
//---------------------------------------------------------------------------

