//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordName.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordName *formRecordName;
//---------------------------------------------------------------------------
__fastcall TformRecordName::TformRecordName(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("person_names"))
{
 Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordName::ScreenStart()
{
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordName::ScreenStop()
{
  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordName::IsValidOnScreen()
{
  if (StripLeading(StripTrailing(editLastName->Text.c_str(), " "), " ") == "")
  {
   PSay("Please provide at least a last name; business names should be put in the 'Last Name' field.", m_missing_data, MB_OK);
   return false;
  }

  // they can enter pretty much whatever they like (HA!) so we'll just check to make
  // sure there is a person id attached

  if ((initial_state["person_id"] == "") || (initial_state["person_id"] == "0"))
  {
    PSay("There is no person associated with this record", m_missing_data, MB_OK);
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformRecordName::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  editPrefix->Text = PrettyString(initial_state["prefix"]).c_str();
  editFirstName->Text = PrettyString(initial_state["first_name"]).c_str();
  editMiddleName->Text = PrettyString(initial_state["middle_name"]).c_str();
  editLastName->Text = PrettyString(initial_state["last_name"]).c_str();
  editSuffix->Text = PrettyString(initial_state["suffix"]).c_str();
  if (editPrefix->Text == " ")
   editPrefix->Text = "";
  if (editFirstName->Text == " ")
   editFirstName->Text = "";
  if (editMiddleName->Text == " ")
   editMiddleName->Text = "";
  if (editLastName->Text == " ")
   editLastName->Text = "";
  if (editSuffix->Text == " ")
   editSuffix->Text = "";

  // get the person name associated with the person id that was either selected
  // from the database if it's an existing record, or passed to the form if
  // it's a new record. display the name as a link to the person record.
  CreateLink(txtPerson, NULL, this, initial_state["person_id"], "people");

  TformRecordGeneric::PutDataOnScreen();

  return true; // what can really go wrong?
}
//---------------------------------------------------------------------------
bool TformRecordName::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, et the id
  // number if necessary, and take care of current_id
  if (editPrefix->Text == "")
    ending_state["prefix"] = " ";
  else
    ending_state["prefix"] = editPrefix->Text.c_str();
  if (editFirstName->Text == "")
    ending_state["first_name"] = " ";
  else
    ending_state["first_name"] = editFirstName->Text.c_str();
  if (editMiddleName->Text == "")
    ending_state["middle_name"] = " ";
  else
    ending_state["middle_name"] = editMiddleName->Text.c_str();
  if (editLastName->Text == "")
    ending_state["last_name"] = " ";
  else
    ending_state["last_name"] = editLastName->Text.c_str();
  if (editSuffix->Text == "")
    ending_state["suffix"] = " ";
  else
    ending_state["suffix"] = editSuffix->Text.c_str();
  ending_state["person_id"] = initial_state["person_id"];
  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();      

  return true; // again, not much can go wrong here
}
//---------------------------------------------------------------------------
bool TformRecordName::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordName::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------


