//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordObsExpectedRange.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordObsExpectedRange *formRecordObsExpectedRange;
//---------------------------------------------------------------------------
__fastcall TformRecordObsExpectedRange::TformRecordObsExpectedRange(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("obs_expected_ranges"))
{
 Initialize();
}
//---------------------------------------------------------------------------
void TformRecordObsExpectedRange::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordObsExpectedRange * z = new TformRecordObsExpectedRange(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
bool TformRecordObsExpectedRange::IsValidOnScreen()
{
 if (comboQuestion->Text == "" || !lookupTables->IsInLookUpTable("obs_questions", comboQuestion->Text.c_str()))
 {
  PSay("Please select a question", m_invalid_data, MB_OK);
  comboQuestion->SetFocus();
  return false;
 }

 // gender is optional
 // might want to check for dupes, neh?

 if (last_type == lookupTables->IdOf("obs_question_types", "Ordinal"))
 {
  bool has_lower = (comboLower->Text != "" && lookupTables->IsInLookUpTable("obs_option_types", comboLower));
  bool has_upper = (comboUpper->Text != "" && lookupTables->IsInLookUpTable("obs_option_types", comboUpper));
  if (!has_lower && !has_upper)
  {
   PSay("An expected range requires at least a lower or upper bound", m_missing_data, MB_OK);
   if (!has_lower)
    comboLower->SetFocus();
   else
    comboUpper->SetFocus();
   return false;
  }

  // order?
  // requires looking at the 'rank' values
  // we assume a.rank < b.rank
  // TODO: order!
 } else
 if (last_type == lookupTables->IdOf("obs_question_types", "Metric"))
 {
  bool has_lower = (editLower->Text != "" && IsFloat(editLower->Text.c_str()));
  bool has_upper = (editUpper->Text != "" && IsFloat(editUpper->Text.c_str()));
  if (!has_lower && !has_upper)
  {
   PSay("An expected range requires at least a valid (numeric) lower or upper bound", m_missing_data, MB_OK);
   if (!has_lower)
    editLower->SetFocus();
   else
    editUpper->SetFocus();
   return false;
  }

  // order?
  // we assume a < b
  // TODO: order!
 } else
 {
  PSay("Ranges do not makes sense for this type of question", m_invalid_data, MB_OK);
  return false;
 }

 return true;
}
//---------------------------------------------------------------------------
bool TformRecordObsExpectedRange::PutDataOnScreen()
{
  comboQuestion->Text = lookupTables->ValueOf("obs_questions", initial_state["obs_question_id"]).c_str();
  comboGender->Text   = lookupTables->ValueOf("gender_types", initial_state["gender_id"]).c_str();

  editLower->Text = initial_state["min_response_metric"].c_str();
  editUpper->Text = initial_state["max_response_metric"].c_str();

  comboQuestionChange(comboQuestion);

  comboLower->Text = lookupTables->ValueOf("obs_option_types", initial_state["min_obs_option_id"]).c_str();
  comboUpper->Text = lookupTables->ValueOf("obs_option_types", initial_state["max_obs_option_id"]).c_str();

  TformRecordGeneric::PutDataOnScreen();
  return true;}
//---------------------------------------------------------------------------
bool TformRecordObsExpectedRange::GetDataFromScreen()
{
  ending_state["id"] = initial_state["id"];

  ending_state["obs_question_id"] = lookupTables->IdOf("obs_questions", comboQuestion->Text.c_str());
  ending_state["gender_id"]       = lookupTables->IdOf("gender_types", comboGender->Text.c_str());

  if (last_type == lookupTables->IdOf("obs_question_types", "Metric"))
  {
   ending_state["min_response_metric"] = editLower->Text.c_str();
   ending_state["max_response_metric"] = editUpper->Text.c_str();
  } else
  if (last_type == lookupTables->IdOf("obs_question_types", "Ordinal"))
  {
   ending_state["min_obs_option_id"] = lookupTables->IdOf("obs_option_types", comboLower);
   ending_state["max_obs_option_id"] = lookupTables->IdOf("obs_option_types", comboUpper);
  }

  TformRecordGeneric::GetDataFromScreen();
  return true;}
//---------------------------------------------------------------------------
bool TformRecordObsExpectedRange::ScreenStart()
{
  lookupTables->RegisterComboBox("obs_questions", comboQuestion);
  lookupTables->RegisterComboBox("gender_types", comboGender);
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordObsExpectedRange::ScreenStop()
{
  lookupTables->UnregisterComboBox(comboQuestion);
  lookupTables->UnregisterComboBox(comboGender);
  lookupTables->UnregisterComboBox(comboLower);
  lookupTables->UnregisterComboBox(comboUpper);
  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordObsExpectedRange::ScreenLock()
{
  panelGroup->Enabled = false;
  TformRecordGeneric::ScreenLock();
  return true;}
//---------------------------------------------------------------------------
bool TformRecordObsExpectedRange::ScreenUnlock()
{
  panelGroup->Enabled = true;
  TformRecordGeneric::ScreenUnlock();
  return true;}
//---------------------------------------------------------------------------
void __fastcall TformRecordObsExpectedRange::comboQuestionChange(
      TObject *Sender)
{
 // flip between two sets of responses
 // disable entirely if type 'text' (hint!) -- but also refuse to save?

 last_type = "0";
 lookupTables->UnregisterComboBox(comboLower);
 lookupTables->UnregisterComboBox(comboUpper);
 labelLowerUnit->Caption = "";
 labelUpperUnit->Caption = "";

 if (lookupTables->IsInLookUpTable("obs_questions", comboQuestion->Text.c_str()))
 {
  string q_id = lookupTables->IdOf("obs_questions", comboQuestion->Text.c_str());
  last_type = GetOneField(dbDatabase, "select obs_question_id from obs_questions where id = " + q_id);
  string option_set_id = GetOneField(dbDatabase, "select obs_option_set_id from obs_questions where id = " + q_id);

  string unit_item = GetOneField(dbDatabase, "select units.item from obs_questions inner join units on units.id = obs_questions.unit_id where obs_questions.id = " + q_id);
  labelLowerUnit->Caption = unit_item.c_str();
  labelUpperUnit->Caption = unit_item.c_str();

  lookupTables->RegisterComboBox("obs_option_types", comboLower, "select id, item, valid from obs_option_types where obs_option_set_id = " + option_set_id + " and valid = 1 order by rank, item");
  lookupTables->RegisterComboBox("obs_option_types", comboUpper, "select id, item, valid from obs_option_types where obs_option_set_id = " + option_set_id + " and valid = 1 order by rank, item");
 }

 bool is_metric = (last_type == lookupTables->IdOf("obs_question_types", "Metric"));
 bool is_ordinal = (last_type == lookupTables->IdOf("obs_question_types", "Ordinal"));

 comboLower->Visible = is_ordinal;
 comboUpper->Visible = is_ordinal;
 editLower->Visible = is_metric;
 editUpper->Visible = is_metric;
 labelLowerUnit->Visible = is_metric;
 labelUpperUnit->Visible = is_metric;
}
//---------------------------------------------------------------------------

