//---------------------------------------------------------------------------

#ifndef codeRecordObservationQuestionH
#define codeRecordObservationQuestionH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include "codeHalfButton.h"
#include "codeRubberContainer.h"
//---------------------------------------------------------------------------
class TformRecordObservationQuestion : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TPanel *panelGroup;
        TComboBox *comboType;
        TLabel *_labelType;
        TLabel *_labelImprovement;
        TComboBox *comboImprovement;
        TLabel *_labelLOINC;
        TEdit *editLOINC;
        THalfButton *buttonSearchLoinc;
        TCheckBox *checkValid;
        TLabel *_labelValid;
        TLabel *_labelShortItem;
        TEdit *editShortItem;
        TEdit *editItem;
        TLabel *_labelItem;
        TRubberContainer *rubberExpectedRanges;
        TListView *listRanges;
        TLabel *_labelExpectedRanges;
        TLabel *_labelMetricUnit;
        TComboBox *comboUnit;
        TLabel *_labelOptionSet;
        TComboBox *comboOptionSet;
        THalfButton *buttonExpandLoinc;
        THalfButton *buttonEditUnit;
        THalfButton *buttonEditOptionSet;
        THalfButton *buttonAddUnit;
        TStaticText *staticQuestionSetEditor;
        THalfButton *buttonImprovementInfo;
        TEdit *editAbsMin;
        TEdit *editAbsMax;
        TLabel *_labelAbsMin;
        TLabel *_labelAbsMax;
        TEdit *editCachedMean;
        TEdit *editCachedStdDev;
        TLabel *_labelCachedMean;
        TLabel *_labelCachedStdDev;
        TLabel *labelUnitsMean;
        TLabel *labelUnitsStdDev;
        TLabel *labelUnitsMin;
        TLabel *labelUnitsMax;
        TEdit *editMSR;
        TLabel *_labelMSR;
        TLabel *_labelLongItem;
        TEdit *editLongItem;
        TCheckBox *checkCalculated;
        TLabel *_labelCalculate;
        TLabel *_labelDefaultOption;
        TComboBox *comboDefaultOption;
        TLabel *_labelCPT;
        TEdit *editCPT;
        THalfButton *buttonSearchCpt;
        THalfButton *buttonExpandCpt;
        void __fastcall buttonExpandLoincClick(TObject *Sender);
        void __fastcall buttonSearchLoincClick(TObject *Sender);
        void __fastcall buttonEditOptionSetClick(TObject *Sender);
        void __fastcall buttonEditUnitClick(TObject *Sender);
        void __fastcall comboTypeChange(TObject *Sender);
        void __fastcall buttonAddUnitClick(TObject *Sender);
        void __fastcall staticQuestionSetEditorClick(TObject *Sender);
        void __fastcall buttonImprovementInfoClick(TObject *Sender);
        void __fastcall comboUnitChange(TObject *Sender);
        void __fastcall buttonSearchCptClick(TObject *Sender);
        void __fastcall buttonExpandCptClick(TObject *Sender);
        void __fastcall comboOptionSetChange(TObject *Sender);
private:	// User declarations
        classFilterObject ranges_filter;
        int ranges_request;
public:		// User declarations
        __fastcall TformRecordObservationQuestion(TComponent* Owner, map<string,string> p_parameters);
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenStart();
        bool ScreenStop();
        bool ScreenLock();
        bool ScreenUnlock();
        bool IsNewAgain();
        bool NotNewAnymore();
        void AtlasRefreshListView(int request_num, string matched_value);
        void AddRange();
        void EditRange();
        static void Do(map<string, string> & p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordObservationQuestion *formRecordObservationQuestion;
//---------------------------------------------------------------------------
#endif
