//---------------------------------------------------------------------------

#ifndef codeRecordOutgoingBillH
#define codeRecordOutgoingBillH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
#include "codeRubberContainer.h"
#include "codeBaseDropDown.h"
#include "codeCheckListDropDown.h"
#include "codeSpecialTransactionSummary.h"
//---------------------------------------------------------------------------
class TformRecordOutgoingBill : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TPageControl *pageControl;
        TTabSheet *sheetGeneral;
        TPanel *panelGeneral;
        TLabel *lblVisit;
        TLabel *lblDateBilled;
        TLabel *lblInsurance;
        TLabel *lblSelect;
        TRadioButton *radioProvider;
        TRadioButton *radioFacility;
        TBitBtn *btnProviderSearch;
        TBitBtn *btnFacilitySearch;
        TDateTimePicker *dateBilled;
        TStaticText *txtProvider;
        TStaticText *txtFacility;
        TStaticText *txtVisit;
        TStaticText *txtUbBilling;
        TStaticText *txtHcfaBilling;
        TTabSheet *sheetDental;
        TRubberContainer *rubberInsurance;
        TListView *listInsurance;
        TTabSheet *sheetTransactions;
        TLabel *lblTransactions;
        TLabel *lblSum;
        TListView *listTransactions;
        TStaticText *txtSum;
        TStaticText *staticBetaModifyTransactions;
        TStaticText *staticTransactionDetails;
        TLabel *lblTotalCharge;
        TLabel *lblInvoiceAmount;
        TEdit *editTotalCharge;
        TEdit *editInvoiceAmount;
        TPanel *panelDental;
        TLabel *lblMissing;
        TLabel *lblRemarks;
        TLabel *lblMissing2;
        TLabel *lblEnclosures;
        TLabel *lblRadiographs;
        TLabel *labelOralImages;
        TLabel *lblModels;
        TLabel *lblMissing3;
        TLabel *lblMissingTeeth;
        TEdit *editRemarks;
        TEdit *editRadiographs;
        TEdit *editOralImages;
        TEdit *editModels;
        TGroupBox *groupOrtho;
        TLabel *lblOrthoDatePlaced;
        TLabel *lblOrthoMonths;
        TEdit *editOrthoDatePlaced;
        TEdit *editOrthoMonthsRemaining;
        TCheckBox *checkOrtho;
        TGroupBox *groupInjury;
        TLabel *lblInjuryDate;
        TLabel *lblInjuryState;
        TCheckBox *checkInjuryJob;
        TCheckBox *checkInjuryAuto;
        TCheckBox *checkInjuryOther;
        TEdit *editInjuryDate;
        TComboBox *cboInjuryState;
        TCheckListDropDown *cbddTeeth;
        TStaticText *txtADAForm;
        TStaticText *txtOldDentalForm;
        TLabel *lblTransactionsSplitBy;
        TCheckBox *checkTransactionAccount;
        TCheckBox *checkTransactionName;
        void __fastcall btnProviderSearchClick(TObject *Sender);
        void __fastcall btnFacilitySearchClick(TObject *Sender);
        void __fastcall txtOldDentalFormClick(TObject *Sender);
        void __fastcall txtHcfaBillingClick(TObject *Sender);
        void __fastcall staticBetaModifyTransactionsClick(TObject *Sender);
        void __fastcall staticTransactionDetailsClick(TObject *Sender);
        void __fastcall txtADAFormClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall checkTransactionAccountClick(TObject *Sender);
        void __fastcall checkTransactionNameClick(TObject *Sender);
private:	// User declarations
        //classFilterObject transactions_filter;
        //int transactions_request;
        classFilterObject insurance_filter;
        int insurance_request;
        bool missing_insurance;
        classTransactionSummarizer transactions_summary; // jhaley: use transaction summary object
        void ValidateKey(string key_type, string key, const string &sql);
public:		// User declarations
        __fastcall TformRecordOutgoingBill(TComponent* Owner, map<string,string> &p_parameters);
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenStart();
        bool ScreenStop();
        bool ScreenLock();
        bool ScreenUnlock();
        void AtlasRefreshListView(int request_num, string matched_value);
        void EditTransaction();
        bool NotNewAnymore();
        bool IsNewAgain();
        void SelectInsurance();
        void EditInsurance();
        static void Do(map<string, string> & p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordOutgoingBill *formRecordOutgoingBill;
//---------------------------------------------------------------------------
#endif
