//---------------------------------------------------------------------------

#ifndef codeRecordPatientAssessmentH
#define codeRecordPatientAssessmentH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <Buttons.hpp>
#include "codeFrameAssessmentGeneric.h"
#include <AppEvnts.hpp>
#include "codePaddedBox.h"
#include <QuickRpt.hpp>
//---------------------------------------------------------------------------
class TformRecordPatientAssessment : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TPanel *panelTop;
        TPanel *panelLeft;
        TPanel *panelRight;
        TSplitter *Splitter1;
        TLabel *lblPerson;
        TStaticText *txtPerson;
        TLabel *lblVisit;
        TStaticText *txtVisit;
        TBitBtn *btnVisitSearch;
        TListView *listAreas;
        TApplicationEvents *appEvents;
        TPaddedBox *paddedPrintLink;
        TStaticText *txtPrintReport;
        TQRCompositeReport *compositeReport;
        void __fastcall FormShow(TObject *Sender);
        void __fastcall btnVisitSearchClick(TObject *Sender);
        void __fastcall listAreasSelectItem(TObject *Sender,
          TListItem *Item, bool Selected);
        void __fastcall appEventsHint(TObject *Sender);
        void __fastcall FormActivate(TObject *Sender);
        void __fastcall txtPrintReportClick(TObject *Sender);
        void __fastcall compositeReportAddReports(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
        vector<string> area_names;
        vector<TframeAssessmentGeneric *> child_frames; // set of all frames
        TframeAssessmentGeneric *current_frame;         // the currently active frame
        int  lock_count;                                // number of times locked by a child form

        // Frame maintenance
        void SetAreaNames();
        void CreateFrames();

        // RecordGeneric overrides
        bool DataClose();
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenLock();
        bool ScreenUnlock();
        bool NotNewAnymore();
        bool AtlasRefresh(int request_num, string matched_value);

        // Reporting
        TForm *task_report_form;
        TIBTransaction *report_transaction;
        bool DoTaskReport();

public:		// User declarations
        __fastcall TformRecordPatientAssessment(TComponent* Owner, map<string, string> &p_parameters);

        // Assessment areas enumeration
        // There is one child frame per area
        enum
        {
          area_allergies,
          area_vitals,
          area_medications,
          area_skin,
          area_wound_care,
          area_neurology,
          area_respiratory,
          area_cardio,
          area_gastro,
          area_genitouri,
          area_musculo,
          area_safety,
          area_fall_risk,
          area_sensory,
          area_func_limits,
          area_activitylvl,
          area_nutrition,
          area_equipment,
          area_intravenous,
          area_education,
          area_notes,
          area_referrals,
          num_assessment_areas
        };

        // Utilities provided for use by TframeAssessmentGeneric and descendant classes:
        void SetUnlockEnabled(bool enabled);
        int RequestNotificationWhen(string key, string value, int relational_op, int field_type);
        string GetAssessmentID();
        bool ChangeToArea(int area_id);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordPatientAssessment *formRecordPatientAssessment;
//---------------------------------------------------------------------------
#endif
