//---------------------------------------------------------------------------

#ifndef codeRecordPersonH
#define codeRecordPersonH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Menus.hpp>
#include "codeFrameDependencyGraph.h"
#include "codeRelationGeneric.h"
#include "codeRelationMagic.h"
#include "codeValueGeneric.h"
#include "codeRubberContainer.h"
#include "codeFrameObservationList.h"

// standard heights of panels on this form, so it doesn't bounce too much
// 257
// 377
// 425
//---------------------------------------------------------------------------
class TformRecordPerson : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TPageControl *pageSelectArea;
        TTabSheet *sheetGeneral;
        TTabSheet *sheetInsurance;
        TTabSheet *sheetRelations;
        TTabSheet *sheetCases;
        TTabSheet *sheetPharmacy;
        TTabSheet *sheetDiabetes;
        TTabSheet *sheetBehavioral;
        TTabSheet *sheetCommunity;
        TPanel *panelGeneral;
        TPanel *panelInsurance;
        TPanel *panelRelations;
        TPanel *panelCases;
        TPanel *panelPharmacy;
        TPanel *panelDiabetes;
        TPanel *panelBehavioral;
        TPanel *panelCommunity;
        TLabel *labelNames;
        TLabel *labelAffiliations;
        TLabel *labelContacts;
        TLabel *labelSSN;
        TEdit *editSSN;
        TLabel *labelBirth;
        TEdit *editBirth;
        TLabel *labelDeath;
        TEdit *editDeath;
        TLabel *labelOccupation;
        TEdit *editOccupation;
        TLabel *labelGender;
        TComboBox *comboGender;
        TLabel *labelMarital;
        TComboBox *comboMarital;
        TLabel *labelCoverages;
        TPageControl *pageDiabetes;
        TTabSheet *sheetDiabetesGeneral;
        TTabSheet *sheetDiabetesTasks;
        TTabSheet *sheetDiabetesSteps;
        TLabel *lblDiabConditions;
        TLabel *lblDiabComments;
        TLabel *lblDiabEvents;
        TLabel *lblDiabTasks;
        TLabel *lblLogsheets;
        TLabel *lblDiabLogsheetReport;
        TLabel *lblDiabTaskReport;
        TLabel *lblDiabEventReport;
        TTabSheet *sheetCommon;
        TPanel *panelCommon;
        TLabel *lblIncome;
        TEdit *editIncome;
        TEdit *editEducation;
        TLabel *lblGrade;
        TPageControl *pageBehavioral;
        TTabSheet *sheetBehGeneral;
        TTabSheet *sheetBehAdditional;
        TPanel *panelBehGeneral;
        TLabel *lblRefused;
        TCheckBox *checkRefused;
        TLabel *lblBehComments;
        TTabSheet *sheetBehTasks;
        TLabel *lblTasks;
        TTabSheet *sheetBehEvents;
        TLabel *lblEvents;
        TTabSheet *sheetPublicHealth;
        TPanel *panelPublicHealth;
        TTabSheet *sheetDiabFitness;
        TLabel *lblFitness;
        TLabel *lblAttendance;
        TLabel *lblFitnessAttendanceReport;
        TLabel *labelRelations;
        TLabel *lblTreatment;
        TLabel *lblPreviousCare;
        TLabel *lblBehLocalTreatment;
        TLabel *lblBehOutsideTreatment;
        TLabel *lblRace;
        TComboBox *cboRace;
        TLabel *lblBehClient;
        TCheckBox *checkBehClient;
        TLabel *lblJurisdiction;
        TCheckBox *checkJurisdiction;
        TLabel *lblPrimary;
        TCheckBox *checkPrimarySupport;
        TPageControl *pageCommunity;
        TTabSheet *tabGeneral;
        TLabel *lblComVisit;
        TTabSheet *tabComMeasurement;
        TLabel *lblComCondition;
        TLabel *lblComMeasurement;
        TTabSheet *tabComEdu;
        TLabel *lblComNutrition;
        TLabel *lblComComments;
        TTabSheet *tabDrug;
        TLabel *lblTask;
        TStaticText *lblComVisitReport;
        TStaticText *lblComEducationReport;
        TStaticText *lblComMeasurementReport;
        TStaticText *lblComCommentsReport;
        TLabel *lblBehLocalTreatmentReport;
        TLabel *lblBehOutsideTreatmentReport;
        TLabel *lblBehTaskReport;
        TLabel *lblBehEventReport;
        TTabSheet *sheetAppointments;
        TPanel *panelAppointments;
        TLabel *lblAppointments;
        TTabSheet *sheetConsents;
        TPanel *panelConsents;
        TLabel *lblConsents;
        TTabSheet *sheetReferrals;
        TPanel *panelReferrals;
        TLabel *lblReferrals;
        TLabel *lblComDrug;
        TLabel *lblComEvent;
        TStaticText *lblComEventReport;
        TTabSheet *sheetClinic;
        TPanel *panelClinic;
        TPageControl *pageClinic;
        TTabSheet *sheetClinicVisits;
        TTabSheet *sheetClinicMeasurements;
        TTabSheet *sheetClinicProcedures;
        TLabel *lblClinicNotes;
        TLabel *lblClinicVisits;
        TTabSheet *sheetClinicBills;
        TLabel *lblClinicMeasurements;
        TLabel *lblClinicProcedures;
        TLabel *lblClinicBills;
        TLabel *lblComEducation;
        TPanel *panelComClient;
        TLabel *lblComClient;
        TCheckBox *checkComClient;
        TLabel *lblRefusedServices;
        TCheckBox *checkComRefusedServices;
        TTabSheet *sheetDiabetesMeasurements;
        TLabel *lblDiabMeasureReport;
        TLabel *lblMeasurements;
        TLabel *lblIncentives;
        TLabel *lblGoals;
        TTabSheet *sheetDental;
        TLabel *lblPharmacy;
        TTabSheet *sheetContractHealth;
        TPanel *panelContractHealth;
        TPageControl *pageContractHealth;
        TTabSheet *sheetConNotes;
        TTabSheet *sheetConCobVisits;
        TLabel *lblVisits;
        TTabSheet *sheetConCobBills;
        TLabel *lblBills;
        TTabSheet *sheetConCob;
        TLabel *lblCobs;
        TLabel *lblConNotes;
        TTabSheet *sheetConditions;
        TPanel *panelConditions;
        TPageControl *pagePublic;
        TTabSheet *tabPublicGeneral;
        TLabel *lblPublicVisit;
        TLabel *lblPublicEdu;
        TPanel *panelPublicClient;
        TLabel *lblPublicClient;
        TLabel *lblPublicRefused;
        TCheckBox *checkPublicClient;
        TCheckBox *checkPublicRefused;
        TTabSheet *tabPublicConditions;
        TLabel *lblPublicConditions;
        TLabel *lblPublicMetric;
        TLabel *lblPublicDrug;
        TTabSheet *tabPublicNutrition;
        TLabel *lblPublicNutrition;
        TLabel *lblPublicComment;
        TTabSheet *tabPublicTasks;
        TLabel *lblPublicTask;
        TLabel *lblPublicEvent;
        TStaticText *lblPublicVisitReport;
        TStaticText *lblPublicEduReport;
        TStaticText *lblPublicMetricReport;
        TStaticText *lblPublicCommentReport;
        TStaticText *lblPublicEventReport;
        TStaticText *txtPatientProviderInfo;
        TLabel *labelGotoLimits;
        TStaticText *staticPersonLimits;
        TLabel *labelDiabetesProvider;
        TStaticText *txtProvider;
        TBitBtn *btnProviderSearch;
        TStaticText *txtUpdateWMedicalConsent;
        TStaticText *staticViewRelationshipGraph;
        TStaticText *staticHeadHousehold;
        TStaticText *staticModifyHeadHousehold;
        TTabSheet *sheetCaregiver;
        TTabSheet *sheetConTree;
        TProgressBar *progressContractHealthTree;
        TPanel *panelCaregiver;
        TPanel *panelCaregiverLock;
        TCheckBox *checkCareClient;
        TStaticText *txtCaregiverLimits;
        TLabel *lblCaregiverCobs;
        TLabel *lblCaregiverBills;
        TPanel *panelDental;
        TPageControl *pageDental;
        TTabSheet *sheetDentalVisits;
        TLabel *lblDentalNotes;
        TLabel *lblDentalVisits;
        TTabSheet *sheetDentalProcedures;
        TLabel *lblDentalProcedures;
        TTabSheet *sheetDentalBills;
        TLabel *lblDentalBills;
        TLabel *lblDiabEducation;
        TStaticText *txtConditions;
        TStaticText *txtProcedures;
        TLabel *labelConditions;
        TCheckBox *checkShowConditionsAllergies;
        TCheckBox *checkShowConditionsOther;
        TCheckBox *checkShowConditionsRelatives;
        TRadioButton *radioShowConditionsDiagnosed;
        TRadioButton *radioShowConditionsReported;
        TRadioButton *radioShowConditionsBoth;
        TCheckBox *checkShowConditionsDrugAllergies;
        TStaticText *txtUpdateWDentalConsent;
        TStaticText *staticViewFamilyTree;
        TTabSheet *sheetRelationships2;
        TPanel *panelRelationships2;
        TLabel *labelHeadOfHH;
        TPanel *panelRelationships2Head;
        TLabel *_labelHeadHousehold2;
        TStaticText *staticModifyHeadHousehold2;
        TStaticText *staticHeadHousehold2;
        TPanel *panelRelationships2Household;
        TListView *listRelationships2Household;
        TLabel *_labelHousehold2;
        TSplitter *splitterRelationships2Household;
        TPanel *panelRelationships2Trees;
        TPanel *panelRelationships2TreesLower;
        TLabel *_labelRelationships2;
        TframeDependencyGraph *depgraphRelationships2;
        TLabel *_labelFakeData;
        TStaticText *txtUpdate;
        TTabSheet *sheetTimelines;
        TPanel *panelTimelines;
        TPanel *panelSelectArea;
        TStaticText *staticHeaderName;
        TStaticText *staticSelectArea;
        TComboBox *comboSelectArea;
        TRubberContainer *rubberBehNotes;
        TListView *listBehComments;
        TRubberContainer *rubberBehLocalTreatment;
        TListView *listBehTreatment;
        TRubberContainer *rubberBehOutsideTreatment;
        TListView *listBehOutsideTreatment;
        TRubberContainer *rubberBehTasks;
        TListView *listTasksBeh;
        TRubberContainer *rubberBehEvents;
        TListView *listEventsBeh;
        TRubberContainer *rubberLacNotes;
        TListView *listLacComments;
        TRubberContainer *rubberLacVisits;
        TListView *listLacTasks;
        TRubberContainer *rubberLacProcedures;
        TListView *listLacProcedures;
        TRubberContainer *rubberLacBills;
        TListView *listClinicBills;
        TRubberContainer *rubberComVisits;
        TListView *listComVisit;
        TRubberContainer *rubberComEducation;
        TListView *listComEducation;
        TRubberContainer *rubberComConditions;
        TListView *listComCondition;
        TRubberContainer *rubberComDrugs;
        TListView *listComDrug;
        TRubberContainer *rubberComNutrition;
        TListView *listComNutrition;
        TRubberContainer *rubberComComments;
        TListView *listComComments;
        TRubberContainer *rubberComTasks;
        TListView *listComTask;
        TRubberContainer *rubberComEvents;
        TListView *listComEvents;
        TRubberContainer *rubberConNotes;
        TListView *listCobNotes;
        TRubberContainer *rubberConCOBs;
        TListView *listCobs;
        TRubberContainer *rubberConVisits;
        TListView *listCobVisits;
        TRubberContainer *rubberConBills;
        TListView *listCobBills;
        TRubberContainer *rubberCOBTree;
        TTreeView *treeCobTree;
        TRubberContainer *rubberDenNotes;
        TListView *listDenComments;
        TRubberContainer *rubberDenVisits;
        TListView *listDenTasks;
        TRubberContainer *rubberDenProcedures;
        TListView *listDenProcedures;
        TRubberContainer *rubberDenBills;
        TListView *listDentalBills;
        TRubberContainer *rubberDiabNotes;
        TListView *listDiabComments;
        TRubberContainer *rubberDiabTasks;
        TListView *listDiabTasks;
        TRubberContainer *rubberDiabEducation;
        TListView *listDiabEducation;
        TRubberContainer *rubberDiabEvents;
        TListView *listDiabEvents;
        TRubberContainer *rubberDiabLogsheets;
        TListView *listDiabLogsheets;
        TRubberContainer *rubberDiabIncentives;
        TListView *listIncentives;
        TRubberContainer *rubberDiabGoals;
        TListView *listGoals;
        TRubberContainer *rubberFitnessMemberships;
        TListView *listFitness;
        TRubberContainer *rubberDiabAttendance;
        TListView *listFitnessAttendance;
        TRubberContainer *rubberInsurance;
        TListView *listCoverage;
        TRubberContainer *rubberPharmacy;
        TListView *listPharmacy;
        TRubberContainer *rubberPubVisits;
        TListView *listPublicVisit;
        TRubberContainer *rubberPubEducation;
        TListView *listPublicEdu;
        TRubberContainer *rubberPubConditions;
        TListView *listPublicConditions;
        TRubberContainer *rubberPubDrugs;
        TListView *listPublicDrug;
        TRubberContainer *rubberPubNutrition;
        TListView *listPublicNutrition;
        TRubberContainer *rubberPubComments;
        TListView *listPublicComments;
        TRubberContainer *rubberPubTasks;
        TListView *listPublicTask;
        TRubberContainer *rubberPubEvents;
        TListView *listPublicEvents;
        TRubberContainer *rubberReferrals;
        TListView *listReferrals;
        TRubberContainer *rubberRelations;
        TListView *listRelationships;
        TRubberContainer *rubberNames;
        TListView *listNames;
        TRubberContainer *rubberAffiliations;
        TListView *listAffiliations;
        TRubberContainer *rubberContacts;
        TListView *listContacts;
        TRubberContainer *rubberAppointments;
        TListView *listAppointments;
        TRubberContainer *rubberCaregiverCOB;
        TListView *listCaregiverCOB;
        TRubberContainer *rubberCaregiverBills;
        TListView *listCaregiverBills;
        TRubberContainer *rubberDiabConditions;
        TListView *listDiabConditions;
        TRubberContainer *rubberConsents;
        TListView *listConsents;
        TRubberContainer *rubberConditions;
        TListView *listConditions;
        TListView *listQuickIcons;
        TBevel *bevelPerson;
        TRubberContainer *rubberDiabObservations;
        TframeObservationList *frameDiabObservations;
        TRubberContainer *rubberComObservations;
        TframeObservationList *frameComObservations;
        TRubberContainer *rubberPubObservations;
        TframeObservationList *framePubObservations;
        TRubberContainer *rubberClinicObservations;
        TframeObservationList *frameClinicObservations;
        TStaticText *txtDemographics;
        TStaticText *txtUpdateNoSignature;
        TStaticText *txtWizard;
        TTabSheet *sheetEnrollment;
        TPanel *panelEnrollment;
        TLabel *labelEnrollment;
        TRubberContainer *rubberEnrollment;
        TListView *listEnrollment;
        TTabSheet *sheetConDenials;
        TRubberContainer *rubberConDenials;
        TListView *listConDenials;
        TLabel *lblConDenial;
        TStaticText *txtHealthSummary;
        TPageControl *pageCases;
        TRubberContainer *rubberCaseNotes;
        TListView *listCaseNotes;
        TRubberContainer *rubberInsApps;
        TListView *listInsApps;
        TLabel *lblInsApp;
        TLabel *lblInsAppInfo;
        TTabSheet *sheetCaseNotes;
        TTabSheet *sheetBehProcedures;
        TLabel *lblBehProcedures;
        TRubberContainer *rubberBehProcedures;
        TListView *listBehProcedures;
        TRubberContainer *rubberBehConditions;
        TListView *listBehConditions;
        TLabel *lblBehConditionReport;
        TLabel *lblBehConditions;
        TPageControl *pageCommon;
        TTabSheet *sheetCommonNotes;
        TTabSheet *sheetCommonObservations;
        TRubberContainer *rubberCommonObservations;
        TframeObservationList *frameCommonObservations;
        TRubberContainer *rubberCommonNotes;
        TListView *listCommonPersonNotes;
        TLabel *lblCommonNotes;
        TLabel *lblCommonObservations;
        TRubberContainer *rubberCommonCharts;
        TListView *listCharts;
        TLabel *lblBehForms;
        TRubberContainer *rubberBehForms;
        TListView *listBehForms;
        TLabel *lblDiabCareSummaryReport;
        TTabSheet *sheetCommonEvents;
        TRubberContainer *rubberCommonEvents;
        TListView *listCommonPersonEvents;
        TLabel *lblCommonEvents;
        TTabSheet *sheetDentalEvents;
        TRubberContainer *RubberContainer1;
        TListView *listDentalEvents;
        TLabel *lblDenEvents;
        TTabSheet *sheetClinicEvents;
        TRubberContainer *RubberContainer2;
        TListView *listClinicEvents;
        TLabel *lblClinicEvents;
        TGroupBox *groupDiabEnrollment;
        TPanel *panelDiabetesGeneral;
        TLabel *lblClient;
        TCheckBox *checkDiabMailingList;
        TCheckBox *checkDiabClient;
        TCheckBox *checkStarParticipant;
        TCheckBox *checkCVDParticipant;
        TPanel *panelDiabGeneralEnrollment;
        TCheckBox *checkStepsAffiliate;
        TCheckBox *checkStepsMember;
        TLabel *lblDiabClientType;
        TPanel *panelDiabClientCBs;
        TCheckBox *checkAscDiabClient;
        TCheckBox *checkLacDiabClient;
        TCheckBox *checkResource;
        TTabSheet *sheetMail;
        TLabel *lblCHSMail;
        TRubberContainer *rubberCHSMail;
        TListView *listCHSMail;
        TRubberContainer *rubberComAssessment;
        TLabel *lblComAssessment;
        TListView *listComAssessment;
        TTabSheet *sheetConDefCOB;
        TLabel *lblConDefCob;
        TRubberContainer *rubberConDefCOB;
        TListView *listConDefCOBs;
        void __fastcall comboSelectAreaChange(TObject *Sender);
        void __fastcall comboGenderKeyPress(TObject *Sender, char &Key);
        void __fastcall comboMaritalKeyPress(TObject *Sender, char &Key);
        //void __fastcall comboClientTypeKeyPress(TObject *Sender, char &Key);
        void __fastcall lblDiabTaskReportClick(TObject *Sender);
        void __fastcall lblDiabLogsheetReportClick(TObject *Sender);
        void __fastcall lblDiabEventReportClick(TObject *Sender);
        void __fastcall lblDiabMeasureReportClick(TObject *Sender);
        void __fastcall lblFitnessAttendanceReportClick(TObject *Sender);
        void __fastcall cboBehCodeKeyPress(TObject *Sender, char &Key);
        void __fastcall cboRaceKeyPress(TObject *Sender, char &Key);
        void __fastcall lblBehConditionReportClick(TObject *Sender);
        void __fastcall lblBehLocalTreatmentReportClick(TObject *Sender);
        void __fastcall lblBehOutsideTreatmentReportClick(TObject *Sender);
        void __fastcall lblBehTaskReportClick(TObject *Sender);
        void __fastcall lblBehEventReportClick(TObject *Sender);
        void __fastcall lblComEventReportClick(TObject *Sender);
        void __fastcall lblComVisitReportClick(TObject *Sender);
        void __fastcall lblComEducationReportClick(TObject *Sender);
        void __fastcall lblComMeasurementReportClick(TObject *Sender);
        void __fastcall lblComCommentsReportClick(TObject *Sender);
        void __fastcall lblPublicVisitReportClick(TObject *Sender);
        void __fastcall lblPublicMetricReportClick(TObject *Sender);
        void __fastcall lblPublicEduReportClick(TObject *Sender);
        void __fastcall lblPublicEventReportClick(TObject *Sender);
        void __fastcall lblPublicCommentReportClick(TObject *Sender);
        void __fastcall txtUpdateClick(TObject *Sender);
        void __fastcall staticPersonLimitsClick(TObject *Sender);
        void __fastcall btnProviderSearchClick(TObject *Sender);
        void __fastcall staticViewRelationshipGraphClick(TObject *Sender);
        void __fastcall staticModifyHeadHouseholdClick(TObject *Sender);
        void __fastcall txtCaregiverLimitsClick(TObject *Sender);
        void __fastcall treeCobTreeAdvancedCustomDraw(TCustomTreeView *Sender, const TRect &ARect, TCustomDrawStage Stage, bool &DefaultDraw);
        void __fastcall treeCobTreeDblClick(TObject *Sender);
        void __fastcall txtProceduresClick(TObject *Sender);
        void __fastcall txtConditionsClick(TObject *Sender);
        void __fastcall checkShowConditionsClick(TObject *Sender);
        void __fastcall staticViewFamilyTreeClick(TObject *Sender);
        void __fastcall txtPatientProviderInfoClick(TObject *Sender);
        void __fastcall pageSelectAreaChange(TObject *Sender);
        void __fastcall sheetRelationships2Show(TObject *Sender);
        void __fastcall listQuickIconsChange(TObject *Sender,
          TListItem *Item, TItemChange Change);
        void __fastcall txtDemographicsClick(TObject *Sender);
        void __fastcall txtUpdateNoSignatureClick(TObject *Sender);
        void __fastcall txtWizardClick(TObject *Sender);
        void __fastcall txtHealthSummaryClick(TObject *Sender);
        void __fastcall FormShortCut(TWMKey &Msg, bool &Handled);
        void __fastcall lblDiabCareSummaryReportClick(TObject *Sender);
private:	// User declarations
        int extra_space;
        string temp_head_of_household;
        void DoRelationships2Thing();
        bool DetermineEnrollment(vector<map<string, string> > &enrollments, string enrollment_type, const char *status_type = NULL);
        string GetEnrollmentStatus(vector<map<string, string> > &enrollments, string enrollment_type);
public:		// User declarations
        __fastcall TformRecordPerson(TComponent* Owner, map<string,string> & p_parameters, int initial_page_number = 0);
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenStart();
        bool ScreenStop();
        bool ScreenLock();
        bool ScreenUnlock();
        bool NotNewAnymore();
        bool IsNewAgain();
        bool AtlasRefreshListViews(int request_num, string matched_value);
        void SetConstraints();
        // functions for filter objects
        void EditContactInfo();
        void AddContactInfo();
        void EditName();
        void AddName();
        void AddAffiliation();
        void EditAffiliation();
        void AddEnrollment();
        void EditEnrollment();
        void AddDiabLogsheet();
        void EditDiabLogsheet();
        void AddDiabTask();
        void EditDiabTask();
        void AddDiabEducation();
        void EditDiabEducation();
        void AddDiabEvent();
        void EditDiabEvent();
        void AddDiabParticipation();
        void EditDiabParticipation();
        void AddFitnessMembership();
        void EditFitnessMembership();
        void AddBehTreatment();
        void EditBehTreatment();
        void AddFitnessAttendance();
        void EditFitnessAttendance();
        void AddCommonPersonNote();
        void EditCommonPersonNote();
        void AddDiabPersonNote();
        void EditDiabPersonNote();
        void AddBehPersonNote();
        void EditBehPersonNote();
        void AddBehForm();
        void EditBehForm();
        void AddDiabCondition();
        void EditDiabCondition();
        void EditComVisit();
        void AddComVisit();
        void EditComComments();
        void AddComComments();
        void EditComConditions();
        void AddComConditions();
        void EditComEdu();
        void AddComEdu();
        void AddComParticipation();
        void EditComParticipation();
        void EditPubDrug();
        void AddPubDrug();
        void EditComDrug();
        void AddComDrug();
        void EditComTask();
        void AddComTask();
        void EditPublicVisit();
        void AddPublicVisit();
        void AddPublicNutrition();
        void EditPublicNutrition();
        void EditPublicComments();
        void AddPublicComments();
        void EditPublicEdu();
        void AddPublicEdu();
        void EditPublicConditions();
        void AddPublicConditions();
        void EditPublicTask();
        void AddPublicTask();
        void EditPublicParticipation();
        void AddPublicParticipation();
        void AddRelationship();
        void EditRelationship();
        void AddIncentive();
        void EditIncentive();
        void AddBehTask();
        void EditBehTask();
        void AddParticipationCom();
        void EditParticipationCom();
        void AddBehParticipation();
        void EditBehParticipation();
        void AddCommonParticipation();
        void EditCommonParticipation();
        void AddBehOutTreatment();
        void EditBehOutTreatment();
        void AddBehCondition();
        void EditBehCondition();
        void EditBehProcedure();
        void AddAppointment();
        void EditAppointment();
        void AddConsent();
        void EditConsent();
        void AddReferral();
        void EditReferral();
        void AddChart();
        void EditChart();
        void AddGoal();
        void EditGoal();
        void AddLacPersonNote();
        void EditLacPersonNote();
        void AddLacTask();
        void EditLacTask();
        void AddLacParticipation();
        void EditLacParticipation();
        void AddDenPersonNote();
        void AddDenTask();
        void EditDenTask();
        void EditDenPersonNote();
        void EditDenProcedure();
        void AddDenParticipation();
        void EditDenParticipation();
        void EditCob();
        void EditCobVisit();
        void EditDeferredCOB();
        void AddDeferredCOB();
        void EditCobBill();
        void AddCaseNote();
        void EditCaseNote();
        void AddCobPersonNote();
        void EditCobPersonNote();
        void AddConDenial();
        void EditConDenial();
        void AddInsApp();
        void EditInsApp();
        void AddCoverage();
        void EditCoverage();
        void EditLacProcedure();
        void EditLacBill();
        void EditDenBill();
        void AddAnyCondition();
        void EditAnyCondition();
        void AddComAssessment();
        void EditComAssessment();

        // tree stuff
        enum node_types {node_person, node_cob, node_visit, node_bill, node_transaction, node_tax_entity, node_account, node_purchase_req, node_check};
        void DrawCobTree();
        void RecurseCobTreeItem(TIBTransaction * dbTransaction, TTreeNode * parent_node, node_types parent_type, string parent_id, int chunk_size);
        string DrawCobTreeItem(node_types node_type, map<string, string> node_data);

        static bool GetWarningsPreventingContractHealthActions (TIBTransaction * dbTransaction, string person_id, Pdate as_of_date, set<string> & problems_found);
        static void Do(map<string, string> & p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordPerson *formRecordPerson;
//---------------------------------------------------------------------------
#endif
