//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordProcedurePayment.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordProcedurePayment *formRecordProcedurePayment;
//---------------------------------------------------------------------------
__fastcall TformRecordProcedurePayment::TformRecordProcedurePayment(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("procedure_payments"))
{
 Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordProcedurePayment::IsValidOnScreen()
{
 // TODO: finish
 bool is_charged = (editCharged->Text != "");
 bool is_allowed = (editAllowed->Text != "");
 bool is_paid = (editPaid->Text != "");
 financial charged = StringToFinancial(editCharged->Text.c_str());
 financial allowed = StringToFinancial(editAllowed->Text.c_str());
 financial paid = StringToFinancial(editPaid->Text.c_str());
 if (is_charged && charged < financial(0.00))
 {
  PSay("The amount charged is negative.", m_invalid_data, MB_OK);
  return false;
 }
 if (is_allowed && allowed < financial(0.00))
 {
  PSay("The amount allowed is negative.", m_invalid_data, MB_OK);
  return false;
 }
 if (is_paid && paid < financial(0.00))
 {
  PSay("The amount paid is negative.", m_invalid_data, MB_OK);
  return false;
 }
 if (is_charged && is_paid && charged < paid)
 {
  PSay("The amount paid is greater than the amount charged.", m_invalid_data, MB_OK);
  return false;
 }
 if (is_allowed && is_paid && allowed < paid)
 {
  PSay("The amount paid is greater than the amount allowed.", m_invalid_data, MB_OK);
  return false;
 }
 if (is_charged && is_allowed && charged < allowed)
 {
  PSay("The amount allowed is greater than the amount charged.", m_invalid_data, MB_OK);
  return false;
 }
 return TformRecordGeneric::IsValidOnScreen();
}
//---------------------------------------------------------------------------
bool TformRecordProcedurePayment::PutDataOnScreen()
{
 CreateLink(staticBill, NULL, this, initial_state["bill_id"], "bills");
 CreateLink(staticProcedure, NULL, this, initial_state["procedure_id"], "procedures"); // TODO: does CreateLink know how to handle procedures?
 editCharged->Text = initial_state["amount_charged"].c_str();
 editAllowed->Text = initial_state["amount_allowed"].c_str();
 editPaid->Text = initial_state["amount_paid"].c_str();
 return TformRecordGeneric::PutDataOnScreen();
}
//---------------------------------------------------------------------------
bool TformRecordProcedurePayment::GetDataFromScreen()
{
 ending_state["id"] = initial_state["id"];
 ending_state["bill_id"] = initial_state["bill_id"];
 ending_state["procedure_id"] = initial_state["procedure_id"];
 ending_state["amount_charged"] = ((editCharged->Text != "") ? FinancialToString(StringToFinancial(editCharged->Text.c_str())) : string(""));
 ending_state["amount_allowed"] = ((editAllowed->Text != "") ? FinancialToString(StringToFinancial(editAllowed->Text.c_str())) : string(""));
 ending_state["amount_paid"] = ((editPaid->Text != "") ? FinancialToString(StringToFinancial(editPaid->Text.c_str())) : string(""));
 return TformRecordGeneric::GetDataFromScreen();
}
//---------------------------------------------------------------------------
bool TformRecordProcedurePayment::ScreenLock()
{
 panelGroup->Enabled = false;
 return TformRecordGeneric::ScreenLock();
}
//---------------------------------------------------------------------------
bool TformRecordProcedurePayment::ScreenUnlock()
{
 panelGroup->Enabled = true;
 return TformRecordGeneric::ScreenUnlock();
}
//---------------------------------------------------------------------------
void TformRecordProcedurePayment::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordProcedurePayment * z = new TformRecordProcedurePayment(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

