//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordPurchaseReq.h"
#include "codeRecordIncomingBill.h"
#include "codeRecordOutgoingBill.h"
#include "codeSpecialCancelPurchaseReq.h"
#include "codeWizardModifyTransactions.h"
#include "launchPRReport.h"
#include "reportPRModification.h"
#include "codeSpecialTransactionSummary.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordPurchaseReq *formRecordPurchaseReq;
//---------------------------------------------------------------------------
__fastcall TformRecordPurchaseReq::TformRecordPurchaseReq(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("purchase_reqs"))
{
// something about list index out of bounds
// launch stuff

  bills_filter.SetListViewHandle (listBills);
  bills_filter.SetSecurity("bills");
  bills_filter.AddColumnSpec("Person", "people", as_text, true, 120, prettyString);
  bills_filter.AddColumnSpec("Visit Date", "bills", as_date, true, 120);
  bills_filter.AddColumnSpec("Bill Date", "bills", as_date, true, 120);
  bills_filter.AddColumnSpec("Tax Entity", "tax_entities", as_text, true, 140, rawString);
  bills_filter.AddColumnSpec("Invoice Number", "bills", as_text, true, 120);
  bills_filter.AddColumnSpec("Note", "bills", as_text, true, 120, sentenceString);
  bills_filter.AddColumnSpec("Total Charge", "bills", as_double, true, 120, nonzeroAmountString);
  bills_filter.AddColumnSpec("Invoice Amount", "bills", as_double, true, 120, nonzeroAmountString);
  bills_filter.AddColumnSpec("Expenses", "bills", as_double, true, 120, nonzeroAmountString);
  bills_filter.AddColumnSpec("Payable", "bills", as_double, true, 120, nonzeroAmountString);
  bills_filter.AddColumnSpec("Paid", "bills", as_double, true, 120, nonzeroAmountString);
  bills_filter.AddColumnSpec("Revenue", "bills", as_double, true, 120, nonzeroAmountString);
  bills_filter.AddColumnSpec("Receivable", "bills", as_double, true, 120, nonzeroAmountString);
  bills_filter.AddColumnSpec("Received", "bills", as_double, true, 120, nonzeroAmountString);
  bills_filter.AddColumnSpec("Bill Type", "bills", as_text, true, 100, prettyString);
  bills_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  bills_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  bills_filter.SetIconStatus(true);
  bills_filter.FetchPreferences("recordpurchasereq.bills_filter");
  bills_filter.SetSQLStatement ("");
  bills_filter.RefreshDataSet();

  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordPurchaseReq::ScreenStart()
{
  textPrintChanges->Font->Color = link_color;
  txtPrintPR->Font->Color       = link_color;
  staticBetaModifyTransactions->Font->Color = link_color;
  staticTransactionSummary->Font->Color = link_color;
  staticVoidPurchaseReq->Font->Color = link_color;
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordPurchaseReq::ScreenStop()
{

  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordPurchaseReq::IsValidOnScreen()
{
  if ((initial_state["tax_entity_id"] == "") || (initial_state["tax_entity_id"] == "0"))
  {
    PSay("There is no tax entity associated with this record", m_missing_data, MB_OK);
    return false;
  }
  else if (!((initial_state["check_id"] == "") || (initial_state["check_id"] == "0")))
  {
    PSay("You may not edit a PR after a check has been posted", m_message, MB_OK);
    return false;
  }
  else if(editPrNumber->Text == "")
  {
    PSay("There is no pr number for this record", m_missing_data, MB_OK);
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformRecordPurchaseReq::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  editPrNumber->Text = initial_state["purchase_req_number"].c_str();
  editExpReason->Text = SentenceString(initial_state["exp_reason"]).c_str();
  if(initial_state["date_sent"] != "")
    dateSent->Date = Pdate(initial_state["date_sent"], mdy | yyyy).OutDate();
  else
    dateSent->Date = Date();

  CreateLink(txtTaxEntity, NULL, this, initial_state["tax_entity_id"], "tax_entities");
  CreateLink(txtCheck, NULL, this, initial_state["check_id"], "checks");


  TformRecordGeneric::PutDataOnScreen();  
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordPurchaseReq::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  ending_state["tax_entity_id"] = initial_state["tax_entity_id"];
  ending_state["check_id"] = initial_state["check_id"];
  ending_state["purchase_req_number"] = initial_state["purchase_req_number"];
  ending_state["exp_reason"] = editExpReason->Text.c_str();
  ending_state["date_sent"] = Pdate(dateSent->Date).OutDate(mdy | yyyy);
  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();

  return true; // again, not much can go wrong here
}
//---------------------------------------------------------------------------
bool TformRecordPurchaseReq::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordPurchaseReq::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordPurchaseReq::NotNewAnymore()
{
  string sql;
  sql = "select person_names.last_name || ', ' || person_names.first_name, "
        "tasks.date_of_task, "
        "bills.bill_date, tax_entities.name, bills.invoice_number, bills.note, "
        "bills.total_charge, bills.invoice_amount, "
        "(select sum(debit_amount-credit_amount) from transactions where bill_id = bills.id and account_id in (select accounts.id from accounts where account_type_id = " + lookupTables->IdOf("account_types", "Expense") + ")) expense, "
        "(select sum(credit_amount-debit_amount) from transactions where bill_id = bills.id and account_id in (select accounts.id from accounts where account_type_id = " + lookupTables->IdOf("account_types", "Payable") + ")) payable, "
        "(select sum(credit_amount-debit_amount) from transactions where bill_id = bills.id and transactions.tax_entity_id = bills.actual_tax_id and account_id in (select accounts.id from accounts where account_type_id = " + lookupTables->IdOf("account_types", "Cash") + ")) paid, "
        "(select sum(credit_amount-debit_amount) from transactions where bill_id = bills.id and account_id in (select accounts.id from accounts where account_type_id = " + lookupTables->IdOf("account_types", "Revenue") + ")) revenue, "
        "(select sum(debit_amount-credit_amount) from transactions where bill_id = bills.id and account_id in (select accounts.id from accounts where account_type_id = " + lookupTables->IdOf("account_types", "Receivable") + ")) receivable, "
        "(select sum(debit_amount-credit_amount) from transactions where bill_id = bills.id and transactions.tax_entity_id != bills.actual_tax_id and account_id in (select accounts.id from accounts where account_type_id = " + lookupTables->IdOf("account_types", "Cash") + ")) received, "
        "bill_types.item, bills.current_id, bills.id "
        "from bills "
        "inner join tax_entities on bills.actual_tax_id = tax_entities.id "
        "inner join bill_types on bills.bill_id = bill_types.id "
        "left join tasks on bills.task_id = tasks.id "
        "left join people on tasks.person_id = people.id "
        "left join person_names on people.person_names_id = person_names.id "
        "where "
        "bills.purchase_req_id = " + initial_state["id"];
  bills_filter.SetSQLStatement (sql);
  bills_filter.RefreshDataSet();
  bills_filter.SetAddEdit(this, NULL, EditRecord(&(TformRecordPurchaseReq::EditBill)));
  bills_request = atlas->RequestNotificationWhen("bills.purchase_req_id", initial_state["id"], rel_e, as_int, this,
                       RefreshHandler(&(TformRecordPurchaseReq::AtlasRefreshListView)));

  txtPrintPR->Enabled = true;
  staticVoidPurchaseReq->Enabled = true;
  staticTransactionSummary->Enabled = true;
  staticBetaModifyTransactions->Enabled = true;
  textPrintChanges->Enabled = true;

  TformRecordGeneric::NotNewAnymore();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordPurchaseReq::AtlasRefreshListView(int request_num, string matched_value)
{
  if (request_num == bills_request)
    bills_filter.RefreshDataSet();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordPurchaseReq::IsNewAgain()
{
  bills_filter.SetSQLStatement(string(""));
  bills_filter.RefreshDataSet();
  bills_filter.SetAddEdit(this, NULL, NULL);
  TformRecordGeneric::IsNewAgain();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordPurchaseReq::EditBill()
{
  map<string, string> temp_map;
  temp_map["id"] = bills_filter.GetSelectedRecordID();
  string bill_id = GetOneField(dbDatabase, "select bill_id from bills where id = " + temp_map["id"]);
  if((bill_id == lookupTables->IdOf("bill_types", "incoming provider bill")) ||
     (bill_id == lookupTables->IdOf("bill_types", "incoming vendor bill")))
  {
    FORM_TRY
      TformRecordIncomingBill * in_bill = new TformRecordIncomingBill(NULL, temp_map);
      in_bill->Show();
    FORM_CATCH
  }
  else if(bill_id == lookupTables->IdOf("bill_types", "outgoing provider bill"))
  {
    FORM_TRY
      TformRecordOutgoingBill * out_bill = new TformRecordOutgoingBill(NULL, temp_map);
      out_bill->Show();
    FORM_CATCH
  }
}
//--------------------------------------------------------------------------

void __fastcall TformRecordPurchaseReq::txtPrintPRClick(TObject *Sender)
{
  if((initial_state["id"] != "") && (IsInt(initial_state["id"])) && (StringToInt(initial_state["id"]) > 0))
  {
    FORM_TRY
      TformLaunchPRReport *print_report = new TformLaunchPRReport(NULL, initial_state["id"]);
      print_report->Show();
    FORM_CATCH
  }
}
//---------------------------------------------------------------------------

void __fastcall TformRecordPurchaseReq::staticVoidPurchaseReqClick(TObject *Sender)
{
 FORM_TRY
  TformSpecialCancelPurchaseReq * void_purchase_req = new TformSpecialCancelPurchaseReq(NULL, initial_state["id"]);
  void_purchase_req->Show();
 FORM_CATCH
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPurchaseReq::staticBetaModifyTransactionsClick(TObject *Sender)
{
 if (optionsPermissions["table.transactions"]["insert"] == "true")
 {
  FORM_TRY
   TformWizardModifyTransactions * wiz = new TformWizardModifyTransactions(NULL, initial_state["id"], mod_purchase_req);
   wiz->Show();
  FORM_CATCH
 }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPurchaseReq::textPrintChangesClick(TObject *Sender)
{
 string pr_number = initial_state["id"];
 TIBTransaction * dbTransaction = new TIBTransaction(NULL);
 TIBDataSet *     dbDataset     = new TIBDataSet(NULL);

 try
 {
  StdTransaction(dbTransaction, dbDatabase);
  dbDataset->Database = dbDatabase;
  dbDataset->Transaction = dbTransaction;
  dbDataset->UniDirectional = false;

  string sql_get_header_info = "select "
    "purchase_reqs.purchase_req_number pr_number, purchase_reqs.date_sent pr_sent, pr_entity.name pr_name, pr_tin.identifier pr_taxid, purchase_reqs.last_update_stamp pr_stamp, pr_user.item pr_username, "
    "checks.check_number check_number, checks.date_sent check_sent, check_entity.name check_name, check_tin.identifier check_taxid, checks.last_update_stamp check_stamp, check_user.item check_username "
    "from purchase_reqs "
    "inner join checks on checks.id = purchase_reqs.check_id "
    "inner join tax_entities pr_entity on pr_entity.id = purchase_reqs.tax_entity_id "
    "left join entity_ids pr_tin on pr_tin.tax_entity_id = pr_entity.id and pr_tin.current_id >= 3 and pr_tin.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "TIN/EIN") + "' "
    "inner join tax_entities check_entity on check_entity.id = checks.tax_entity_id "
    "left join entity_ids check_tin on check_tin.tax_entity_id = check_entity.id and check_tin.current_id >= 3 and check_tin.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "TIN/EIN") + "' "
    "inner join users pr_user on pr_user.id = purchase_reqs.last_updated_by "
    "inner join users check_user on check_user.id = checks.last_updated_by "
    "where purchase_reqs.id = " + pr_number;

  map<string, string> header_info;
  if(!SqlToMap(dbTransaction, sql_get_header_info, header_info))
   throw(1);

  string sql_get_body_info = "select "
    "bills.id bill_id, bills.bill_date bill_date, bills.invoice_number bill_invoice_number, bills.note bill_note, bills.total_charge bill_charges, bills.invoice_amount bill_invoice, bills.paid_amount bill_paid, bills.last_update_stamp bill_stamp, bill_user.item bill_username, "
    "transactions.transaction_number tx_number, transactions.effective_date tx_date, accounts.name tx_account, tx_entity.name tx_entity_name, transactions.note tx_note, transactions.debit_amount tx_debit, transactions.credit_amount tx_credit, transactions.last_update_stamp tx_stamp, tx_user.item tx_username "
    "from bills "
    "inner join users bill_user on bill_user.id = bills.last_updated_by "
    "inner join transactions on transactions.bill_id = bills.id "
    "inner join users tx_user on tx_user.id = transactions.last_updated_by "
    "inner join tax_entities tx_entity on tx_entity.id = transactions.tax_entity_id "
    "inner join accounts on accounts.id = transactions.account_id "
    "where bills.purchase_req_id = " + pr_number +
    " order by bills.id, transactions.transaction_number, transactions.credit_amount asc /* null first */, transactions.debit_amount asc /* null first */";

  dbDataset->SelectSQL->Add(sql_get_body_info.c_str());
  dbDataset->Open();
  dbDataset->First();
  TformReportPRModification * report = NULL;
  FORM_TRY
   report = new TformReportPRModification(NULL);
  FORM_CATCH

  report->reportChanges->DataSet = dbDataset;
  report->labelUser->Caption = current_fullname.c_str();

  // one-time header info
  report->labelPRNumber->Caption          = header_info["pr_number"].c_str();
  report->labelPRDateSent->Caption        = header_info["pr_sent"].c_str();
  report->labelPREntityName->Caption      = header_info["pr_name"].c_str();
  report->labelPREntityTax->Caption       = header_info["pr_taxid"].c_str();
  report->labelPRModifiedDate->Caption    = header_info["pr_stamp"].c_str();
  report->labelPRModifiedUser->Caption    = header_info["pr_username"].c_str();
  report->labelCheckNumber->Caption       = header_info["check_number"].c_str();
  report->labelCheckDateSent->Caption     = header_info["check_sent"].c_str();
  report->labelCheckEntityName->Caption   = header_info["check_name"].c_str();
  report->labelCheckEntityTax->Caption    = header_info["check_taxid"].c_str();
  report->labelCheckModifiedDate->Caption = header_info["check_stamp"].c_str();
  report->labelCheckModifiedUser->Caption = header_info["check_username"].c_str();

  // detail rows of stuff (body)
  report->textBillDate->DataSet                = dbDataset;
  report->textBillInvoiceNumber->DataSet       = dbDataset;
  report->textBillNote->DataSet                = dbDataset;
  report->textBillCharges->DataSet             = dbDataset;
  report->textBillInvoice->DataSet             = dbDataset;
  report->textBillPaid->DataSet                = dbDataset;
  report->textBillModifiedDate->DataSet        = dbDataset;
  report->textBillModifiedUser->DataSet        = dbDataset;
  report->textTransactionNumber->DataSet       = dbDataset;
  report->textTransactionDate->DataSet         = dbDataset;
  report->textTransactionAccount->DataSet      = dbDataset;
  report->textTransactionEntityName->DataSet   = dbDataset;
  report->textTransactionNote->DataSet         = dbDataset;
  report->textTransactionDebit->DataSet        = dbDataset;
  report->textTransactionCredit->DataSet       = dbDataset;
  report->textTransactionModifiedDate->DataSet = dbDataset;
  report->textTransactionModifiedUser->DataSet = dbDataset;

  report->textBillDate->DataField                = "bill_date";
  report->textBillInvoiceNumber->DataField       = "bill_invoice_number";
  report->textBillNote->DataField                = "bill_note";
  report->textBillCharges->DataField             = "bill_charges";
  report->textBillInvoice->DataField             = "bill_invoice";
  report->textBillPaid->DataField                = "bill_paid";
  report->textBillModifiedDate->DataField        = "bill_stamp";
  report->textBillModifiedUser->DataField        = "bill_username";
  report->textTransactionNumber->DataField       = "tx_number";
  report->textTransactionDate->DataField         = "tx_date";
  report->textTransactionAccount->DataField      = "tx_account";
  report->textTransactionEntityName->DataField   = "tx_entity_name";
  report->textTransactionNote->DataField         = "tx_note";
  report->textTransactionDebit->DataField        = "tx_debit";
  report->textTransactionCredit->DataField       = "tx_credit";
  report->textTransactionModifiedDate->DataField = "tx_stamp";
  report->textTransactionModifiedUser->DataField = "tx_username";

  // group bands
  report->bandGroupBill->Expression        = "bill_id";
  report->bandGroupTransaction->Expression = "tx_number";

  report->reportChanges->Preview();
  dbTransaction->Commit();
 } catch (...)
 {
  dbTransaction->Rollback();
  PSay("Report of changes (transactions) made to bills on this purchase request could not be run: unknown reason.", m_database_error, MB_OK);
 }
 delete dbDataset;
 delete dbTransaction;
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformRecordPurchaseReq::staticTransactionSummaryClick(
      TObject *Sender)
{
 if (optionsPermissions["table.transactions"]["view"] == "true")
 {
  FORM_TRY
   TformSpecialTransactionSummary * sum = new TformSpecialTransactionSummary(NULL, initial_state["id"], "purchase_reqs");
   sum->Show();
  FORM_CATCH
 }
}
//---------------------------------------------------------------------------
void TformRecordPurchaseReq::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordPurchaseReq * z = new TformRecordPurchaseReq(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

