//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordReferralNote.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordReferralNote *formRecordReferralNote;
//---------------------------------------------------------------------------
__fastcall TformRecordReferralNote::TformRecordReferralNote(TComponent* Owner, map<string,string> & p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("referral_notes"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordReferralNote::ScreenStart()
{
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordReferralNote::ScreenStop()
{
  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordReferralNote::IsValidOnScreen()
{
  if(editNote->Text.Length() > 2554)
  {
    PSay("Notes can only contain up to 2555 characters", m_invalid_data, MB_OK);
    editNote->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformRecordReferralNote::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  if(initial_state["date_of_note"] == "")
    dateNote->Date = Date();
  else
    dateNote->Date = Pdate(initial_state["date_of_note"], mdy | yyyy).OutDate();
  editNote->Text = SentenceString(initial_state["note"]).c_str();

  CreateLink(txtReferral, NULL, this, initial_state["referral_id"], "referrals");  

  TformRecordGeneric::PutDataOnScreen();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordReferralNote::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id

  ending_state["id"] = initial_state["id"];
  ending_state["date_of_note"] = Pdate(dateNote->Date).OutDate(mdy | yyyy);
  ending_state["note"] = editNote->Text.c_str();
  ending_state["referral_id"] = initial_state["referral_id"];
  TformRecordGeneric::GetDataFromScreen();

  return true;
}
//---------------------------------------------------------------------------
bool TformRecordReferralNote::ScreenLock()
{
  panelGroup->Enabled = false;
  editNote->ReadOnly = true;
  editNote->TabStop = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordReferralNote::ScreenUnlock()
{
  panelGroup->Enabled = true;
  editNote->ReadOnly = false;
  editNote->TabStop = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordReferralNote::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordReferralNote * z = new TformRecordReferralNote(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

