//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordServiceProvided.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordServiceProvided *formRecordServiceProvided;
//---------------------------------------------------------------------------
__fastcall TformRecordServiceProvided::TformRecordServiceProvided(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("services_provided"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordServiceProvided::ScreenStart()
{
  lookupTables->RegisterComboBox("service_types", cboService);
  lookupTables->RegisterComboBox("area_types", cboArea);
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordServiceProvided::ScreenStop()
{
  lookupTables->UnregisterComboBox("service_types", cboService);
  lookupTables->UnregisterComboBox("area_types", cboArea);
  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordServiceProvided::IsValidOnScreen()
{
  if(! lookupTables->IsInLookUpTable("service_types", cboService->Text.c_str()) || cboService->Text == "")
  {
    PSay("Please enter a valid service", m_invalid_data, MB_OK);
    cboService->SetFocus();
    return false;
  }
  else if(! lookupTables->IsInLookUpTable("area_types", cboArea->Text.c_str()) || cboArea->Text == "")
  {
    PSay("Please enter a valid area", m_invalid_data, MB_OK);
    cboArea->SetFocus();
    return false;
  }
  else if ((initial_state["tax_entity_id"] == "") || (initial_state["tax_entity_id"] == "0"))
  {
    PSay("There is no tax entity associated with this record", m_missing_data, MB_OK);
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformRecordServiceProvided::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  cboService->Text = lookupTables->ValueOf("service_types", initial_state["service_id"]).c_str();
  cboArea->Text = lookupTables->ValueOf("area_types", initial_state["area_id"]).c_str();  

  CreateLink(txtTaxEntity, NULL, this, initial_state["tax_entity_id"], "tax_entities");

  TformRecordGeneric::PutDataOnScreen();  
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordServiceProvided::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  ending_state["service_id"] = lookupTables->IdOf("service_types", cboService->Text.c_str());
  ending_state["area_id"] = lookupTables->IdOf("area_types", cboArea->Text.c_str());
  ending_state["tax_entity_id"] = initial_state["tax_entity_id"];
  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();

  return true; // again, not much can go wrong here
}
//---------------------------------------------------------------------------
bool TformRecordServiceProvided::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordServiceProvided::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordServiceProvided::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordServiceProvided * z = new TformRecordServiceProvided(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

