//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordSurveyQuestion.h"
#include "codeSpecialPossibleSurveyAnswers.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordSurveyQuestion *formRecordSurveyQuestion;
//---------------------------------------------------------------------------
__fastcall TformRecordSurveyQuestion::TformRecordSurveyQuestion(TComponent* Owner, map<string, string> & p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("survey_questions"))
{
  response_filter.SetListViewHandle (listResponses);
  response_filter.SetSecurity("survey_responses");
  response_filter.AddColumnSpec("Date", "survey_responses", as_date, true, 90);
  response_filter.AddColumnSpec("Person", "survey_responses", as_text, true, 120);
//response_filter.AddColumnSpec("Numeric Response", "survey_responses", as_double, true, 130);
//response_filter.AddColumnSpec("Text Response", "survey_responses", as_text, true, 150, sentenceString);
//response_filter.AddColumnSpec("Dropdown Response", "survey_responses", as_text, true, 150, sentenceString);
  response_filter.AddColumnSpec("Response", "survey_responses", as_text, true, 150);
  response_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  response_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  response_filter.FetchPreferences("recordsurveyquestion.response_filter");
  response_filter.SetIconStatus(true);
  response_filter.SetSQLStatement ("");
  response_filter.RefreshDataSet();
  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordSurveyQuestion::ScreenStart()
{
 TformRecordGeneric::ScreenStart();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyQuestion::ScreenStop()
{
 TformRecordGeneric::ScreenStop();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyQuestion::IsValidOnScreen()
{
  if(! IsInt(editQuestionNumber->Text.c_str()))
  {
    PSay("Please enter a valid question number", m_invalid_data, MB_OK);
    editQuestion->SetFocus();
    return false;
  }
  else if(! IsFloat(editMinValue->Text.c_str()))
  {
    PSay("Please enter a valid number for min value", m_invalid_data, MB_OK);
    editMinValue->SetFocus();
    return false;
  }
  else if(! IsFloat(editMaxValue->Text.c_str()))
  {
    PSay("Please enter a valid number for max value", m_invalid_data, MB_OK);
    editMaxValue->SetFocus();
    return false;
  }
  else if((initial_state["survey_id"] == "") || (initial_state["survey_id"] == "0"))
  {
    PSay("There is no survey associated with this record", m_missing_data, MB_OK);
    return false;
  }
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyQuestion::PutDataOnScreen()
{
 editQuestion->Text = SentenceString(initial_state["question"]).c_str();
 editQuestionNumber->Text = initial_state["question_number"].c_str();
 editMinValue->Text = initial_state["min_value"].c_str();
 editMaxValue->Text = initial_state["max_value"].c_str();
 if(initial_state["is_numeric"] == "1")
 {
   radioText->Checked = false;
   radioDropdown->Checked = false;
   radioNumeric->Checked = true;   
   EnableNumeric(true);
   txtEditPossibleResponses->Enabled = false;
 }
 else if(initial_state["is_text"] == "1")
 {
   radioNumeric->Checked = false;
   radioDropdown->Checked = false;
   radioText->Checked = true;
   EnableNumeric(false);
   txtEditPossibleResponses->Enabled = false;
 }
 else if(initial_state["is_dropdown"] == "1")
 {
   radioText->Checked = false;
   radioNumeric->Checked = false;
   radioDropdown->Checked = true;
   EnableNumeric(false);
   if(! is_new_record)
     txtEditPossibleResponses->Enabled = true;
 }

 TformRecordGeneric::PutDataOnScreen();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyQuestion::GetDataFromScreen()
{
 ending_state["question"] = editQuestion->Text.c_str();
 ending_state["question_number"] = editQuestionNumber->Text.c_str();
 if(radioNumeric->Checked)
 {
   ending_state["min_value"] = editMinValue->Text.c_str();
   ending_state["max_value"] = editMaxValue->Text.c_str();
   ending_state["is_numeric"] = "1";
   ending_state["is_text"] = "0";
   ending_state["is_dropdown"] = "0";
 }
 else if(radioText->Checked)
 {
   ending_state["min_value"] = "";
   ending_state["max_value"] = "";
   ending_state["is_numeric"] = "0";
   ending_state["is_text"] = "1";
   ending_state["is_dropdown"] = "0";
 }
 else if(radioDropdown->Checked)
 {
   ending_state["min_value"] = "";
   ending_state["max_value"] = "";
   ending_state["is_numeric"] = "0";
   ending_state["is_text"] = "0";
   ending_state["is_dropdown"] = "1";
 }
 ending_state["survey_id"] = initial_state["survey_id"];
 ending_state["id"] = initial_state["id"];

 TformRecordGeneric::GetDataFromScreen();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyQuestion::ScreenLock()
{
 panelGroup->Enabled = false;
 editQuestion->ReadOnly = true;
 editQuestion->TabStop = false;
 TformRecordGeneric::ScreenLock();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyQuestion::ScreenUnlock()
{
 panelGroup->Enabled = true;
 editQuestion->ReadOnly = false;
 editQuestion->TabStop = true;
 TformRecordGeneric::ScreenUnlock();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyQuestion::IsNewAgain()
{
  string max_question = GetOneField(dbDatabase, "select max(question_number) from survey_questions "
                       "where survey_id = " + initial_state["survey_id"]);
  if(max_question == "")
    initial_state["question_number"] = "0";
  else
    initial_state["question_number"] = IntToString(StringToInt(max_question) + 1);
  if(panelGroup->Enabled)
    editQuestion->SetFocus();
  if(radioDropdown->Checked)
    txtEditPossibleResponses->Enabled = true;
  response_filter.SetSQLStatement(string(""));
  response_filter.RefreshDataSet();
  response_filter.SetAddEdit(this, NULL, NULL);
  TformRecordGeneric::IsNewAgain();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyQuestion::NotNewAnymore()
{
  string sql;
  sql = "select surveys_taken.date_taken, "
        "person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix, "
//        "survey_responses.numeric_response, survey_responses.text_response, question_responses.response, "
        "(select result from get_survey_response(survey_responses.id, survey_questions.is_numeric, survey_questions.is_text, survey_questions.is_dropdown)) response, "
        "survey_responses.current_id, survey_responses.id "
        "from survey_responses "
        "inner join survey_questions on survey_responses.survey_question_id = survey_questions.id "
        "inner join surveys_taken on survey_responses.survey_taken_id = surveys_taken.id "
        "inner join question_responses on survey_responses.question_response_id = question_responses.id "
        "left join people on surveys_taken.person_id = people.id "
        "left join person_names on people.person_names_id = person_names.id "
        "where survey_responses.survey_question_id = " + initial_state["id"];

  response_filter.SetSQLStatement(sql);
  response_filter.RefreshDataSet();
  response_request = atlas->RequestNotificationWhen("survey_responses.survey_question_id", initial_state["id"], rel_e, as_int, this,
                    RefreshHandler(&(TformRecordSurveyQuestion::AtlasRefreshListViews)));
  if(radioDropdown->Checked)
    txtEditPossibleResponses->Enabled = true;

  TformRecordGeneric::NotNewAnymore();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyQuestion::AtlasRefreshListViews(int request_num, string matched_value)
{
  if (request_num == response_request)
    response_filter.RefreshDataSet();
  return true;
}
//---------------------------------------------------------------------------

void __fastcall TformRecordSurveyQuestion::radioNumericClick(
      TObject *Sender)
{
  if(radioNumeric->Checked)
    EnableNumeric(true);
  else
    EnableNumeric(false);
  if((radioDropdown->Checked) && (! is_new_record))
    txtEditPossibleResponses->Enabled = true;
  else
    txtEditPossibleResponses->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordSurveyQuestion::txtEditPossibleResponsesClick(
      TObject *Sender)
{
  FORM_TRY
   TformSpecialPossibleSurveyAnswers *modify_questions = new TformSpecialPossibleSurveyAnswers(NULL, initial_state["id"]);
   modify_questions->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordSurveyQuestion::EnableNumeric(bool enable)
{
  lblMinValue->Enabled = enable;
  editMinValue->Enabled = enable;
  lblMaxValue->Enabled = enable;
  editMaxValue->Enabled = enable;
}
//---------------------------------------------------------------------------
void TformRecordSurveyQuestion::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordSurveyQuestion * z = new TformRecordSurveyQuestion(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

