//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordSurveyTaken.h"
#include "codeSearchSurvey.h"
#include "codeSearchPerson.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordSurveyTaken *formRecordSurveyTaken;
//---------------------------------------------------------------------------
__fastcall TformRecordSurveyTaken::TformRecordSurveyTaken(TComponent* Owner, map<string, string> & p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("surveys_taken"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordSurveyTaken::ScreenStart()
{
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyTaken::ScreenStop()
{
  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyTaken::IsValidOnScreen()
{
  if(GetValidLinkId(txtSurvey) == "")
  {
    PSay("Please select a survey", m_missing_data, MB_OK);
    return false;
  }
  else if (! Pdate (editDateTaken->Text.c_str(), mdy | yy).IsValidDate() && ! (editDateTaken->Text == ""))
  {
    PSay("Please enter a valid date taken", m_invalid_data, MB_OK);
    editDateTaken->SetFocus();
    return false;
  }
  else if(! ResponsesAreValid())
    return false;
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyTaken::PutDataOnScreen()
{
  CreateLink(txtPerson, btnPersonSearch, this, initial_state["person_id"], "people");
  CreateLink(txtSurvey, btnSurveySearch, this, initial_state["survey_id"], "surveys");
  editDateTaken->Text = initial_state["date_taken"].c_str();
  ShowQuestions();

  TformRecordGeneric::PutDataOnScreen();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyTaken::GetDataFromScreen()
{
  string person_id = GetValidLinkId(txtPerson);
  if (person_id != "")
    ending_state["person_id"] = person_id;
  else
    ending_state["person_id"] = "0"; // TODO -c BUG : jhaley - is this really supposed to be allowed? old logic didn't check it.
  ending_state["survey_id"] = GetValidLinkId(txtSurvey);
  if (editDateTaken->Text != "")
    ending_state["date_taken"] =  Pdate (editDateTaken->Text.c_str(), mdy | yy).OutDate(mdy | yyyy);
  else
    ending_state["date_taken"] = "";
  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyTaken::ScreenLock()
{
  panelGroup->Enabled = false;
  panelResponses->Enabled = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyTaken::ScreenUnlock()
{
  panelGroup->Enabled = true;
  panelResponses->Enabled = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyTaken::CheckForUselessRecord()
{
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordSurveyTaken::btnSurveySearchClick(
      TObject *Sender)
{
  string old_survey_id = GetValidLinkId(txtSurvey);
  if((initial_state["group_id"] == "") || (initial_state["group_id"] == "0"))
    initial_state["group_id"] = current_groupid;
  vector<string> return_vector;
  FORM_TRY
    TformSearchSurvey * survey_search = new TformSearchSurvey(NULL,&return_vector, initial_state["group_id"]);
    survey_search->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
  {
    CreateLink(txtSurvey, btnSurveySearch, this, return_vector[0], "surveys");
    if(old_survey_id != GetValidLinkId(txtSurvey))
    {
      ShowQuestions();
      if((old_survey_id != "") && (old_survey_id != "0") && (! is_new_record))
        ExecuteStatement(dbDatabase, "delete from survey_responses where survey_taken_id = " + initial_state["id"]);
    }
  }
}
//---------------------------------------------------------------------------
void TformRecordSurveyTaken::ShowQuestions()
{
  for(list<question_info_class>::iterator itr = question_info.begin(); itr != question_info.end(); itr++)
  {
    if(itr->question_text)
    {
      itr->question_text->Parent = NULL;
      RemoveComponent(itr->question_text);
    }
    if(itr->numeric_response)
    {
      itr->numeric_response->Parent = NULL;
      RemoveComponent(itr->numeric_response);
    }
    if(itr->text_response)
    {
      itr->text_response->Parent = NULL;
      RemoveComponent(itr->text_response);
    }
    if(itr->dropdown_response)
    {
      itr->dropdown_response->Parent = NULL;
      RemoveComponent(itr->dropdown_response);
    }
  }
  question_info.clear();
  combo_box_items.clear();
  string survey_id = GetValidLinkId(txtSurvey);
  if(survey_id != "")
  {
    TIBTransaction *dbTransaction = new TIBTransaction(NULL);
    dbTransaction->DefaultDatabase = dbDatabase;
    dbTransaction->StartTransaction();
    vector<map<string, string> > question_map;
    string sql;

    if(is_new_record)
      sql = "select survey_questions.question, survey_questions.id, survey_questions.min_value, "
            "survey_questions.max_value, survey_questions.is_numeric, survey_questions.is_text, "
            "survey_questions.is_dropdown "
            "from survey_questions "
            "where survey_questions.current_id >= 3 and survey_questions.survey_id = '" + survey_id + "' "
            "order by survey_questions.question_number";
    else
      sql = "select survey_questions.question, survey_responses.numeric_response, survey_responses.text_response, "
            "survey_questions.id, survey_questions.min_value, survey_questions.max_value, survey_questions.is_numeric, "
            "survey_questions.is_text, survey_questions.is_dropdown, survey_responses.question_response_id, "
            "question_responses.response "
            "from survey_questions "
            "left join survey_responses on survey_responses.survey_question_id = survey_questions.id "
            "and survey_responses.survey_taken_id = " + initial_state["id"] + " "
            "left join question_responses on survey_responses.question_response_id = question_responses.id "
            "where survey_questions.current_id >= 3 "
            "and survey_questions.survey_id = '" + survey_id + "' "
            "order by survey_questions.question_number";
    DebugSql(this, &sql, other_forms, 9);
    SqlToVecMap(dbTransaction, sql, question_map);
    int current_top = 8;
    int width_needed;
    string question;
    question_info_class temp_class;
    bool is_numeric;
    bool is_text;
    bool is_dropdown;
    double text_width;
    int max_height;
    vector<map<string, string> > response_vec;
    temp_class.dropdown_response = NULL;
    for(vector<map<string, string> >::iterator itr = question_map.begin(); itr != question_map.end(); itr++)
    {
      question = SentenceString((*itr)["question"]);
      is_numeric = ((*itr)["is_numeric"] == "1");
      is_text = ((*itr)["is_text"] == "1");
      is_dropdown = ((*itr)["is_dropdown"] == "1");
      width_needed = this->Canvas->TextWidth(question.c_str());
      TStaticText *question_text = new TStaticText(panelResponses);
      question_text->AutoSize = false;
      question_text->Top = current_top;
      question_text->Left = 8;
      if(is_numeric)
        text_width = 329;
      else
        text_width = 257;
      question_text->Height = (int)(ceil(width_needed / text_width) * 17.0);
      max_height = question_text->Height;
      question_text->Width = text_width;
      question_text->Caption = question.c_str();
      question_text->Parent = panelResponses;

      TEdit *numeric_response;
      TRichEdit *text_response;
      TComboBox *dropdown_response;
      if(is_numeric)
      {
        numeric_response = new TEdit(panelResponses);
        numeric_response->Top = current_top;
        numeric_response->Left = 352;
        numeric_response->Width = 49;
        numeric_response->Height = 21;
        if(! is_new_record)
          numeric_response->Text = (*itr)["numeric_response"].c_str();
        numeric_response->Hint = string("min value: " + (*itr)["min_value"] + ", max_value: " + (*itr)["max_value"]).c_str();
        numeric_response->ShowHint = true;
        numeric_response->Parent = panelResponses;
      }
      else if(is_text)
      {
        text_response = new TRichEdit(panelResponses);
        text_response->Top = current_top;
        text_response->Left = 272;
        text_response->Width = 129;
        text_response->Height = 63;
        if(text_response->Height > max_height)
          max_height = text_response->Height;
        text_response->MaxLength = 2000;
        text_response->PlainText = true;
        if(! is_new_record)
          text_response->Text = SentenceString((*itr)["text_response"]).c_str();
        text_response->Parent = panelResponses;
      }
      else if(is_dropdown)
      {
        map<string, int> item_index_map;
        dropdown_response = new TComboBox(panelResponses);
        dropdown_response->Top = current_top;
        dropdown_response->Left = 272;
        dropdown_response->Width = 129;
        dropdown_response->Height = 21;
        dropdown_response->Text = "";
        dropdown_response->Style = Stdctrls::csDropDownList;
        dropdown_response->Parent = panelResponses;

        sql = "select question_responses.response, question_responses.id from question_responses where "
              "question_responses.survey_question_id = " + (*itr)["id"];
        SqlToVecMap(dbTransaction, sql, response_vec);
        response_info temp_response_class;
        int i = 0;
        for(vector<map<string, string> >::iterator response_itr = response_vec.begin(); response_itr != response_vec.end(); response_itr++)
        {
          dropdown_response->Items->Add(SentenceString((*response_itr)["response"]).c_str());
          item_index_map[SentenceString((*response_itr)["response"])] = i;
          temp_response_class.id_to_item[(*response_itr)["id"]] = SentenceString((*response_itr)["response"]);
          temp_response_class.item_to_id[SentenceString((*response_itr)["response"])] = (*response_itr)["id"];
          i++;
        }
        combo_box_items[dropdown_response] = temp_response_class;
        if(! is_new_record)
        {
          if(((*itr)["question_response_id"] != "0") && ((*itr)["question_response_id"] != ""))
            dropdown_response->ItemIndex = item_index_map[SentenceString((*itr)["response"])];
        }
      }

      current_top += max_height + 7;

      temp_class.question_text = question_text;
      if(is_numeric)
      {
        temp_class.is_numeric = true;
        temp_class.is_text = false;
        temp_class.is_dropdown = false;
        temp_class.numeric_response = numeric_response;
        temp_class.text_response = NULL;
        temp_class.dropdown_response = NULL;
      }
      else if(is_text)
      {
        temp_class.is_numeric = false;
        temp_class.is_text = true;
        temp_class.is_dropdown = false;
        temp_class.numeric_response = NULL;
        temp_class.dropdown_response = NULL;
        temp_class.text_response = text_response;
      }
      else if(is_dropdown)
      {
        temp_class.is_numeric = false;
        temp_class.is_text = false;
        temp_class.is_dropdown = true;
        temp_class.numeric_response = NULL;
        temp_class.dropdown_response = dropdown_response;
        temp_class.text_response = NULL;
      }
      temp_class.id = (*itr)["id"];
      temp_class.min_value = (*itr)["min_value"];
      temp_class.max_value = (*itr)["max_value"];
      question_info.push_back(temp_class);
    }
    panelResponses->Height = current_top;
    dbTransaction->Commit();
    delete dbTransaction;
  }
}
//---------------------------------------------------------------------------
bool TformRecordSurveyTaken::ResponsesAreValid()
{
  string response;
  for(list<question_info_class>::iterator itr = question_info.begin(); itr != question_info.end(); itr++)
  {
    if((itr->is_numeric) && (itr->numeric_response->Text != ""))
    {
      response = itr->numeric_response->Text.c_str();
      if(! IsFloat(response))
      {
        PSay("Responses can only be numeric. Please enter a valid number.", m_invalid_data, MB_OK);
        itr->numeric_response->SetFocus();
        return false;
      }
      else if((itr->min_value != "") && (StringToFloat(response) < StringToFloat(itr->min_value)))
      {
        PSay("The minimum value that can be entered for this question is " + itr->min_value + ".\n"
             "Please enter a number greater than this value.", m_invalid_data, MB_OK);
        itr->numeric_response->SetFocus();
        return false;
      }
      else if((itr->max_value != "") && (StringToFloat(response) > StringToFloat(itr->max_value)))
      {
        PSay("The maximum value that can be entered for this question is " + itr->max_value + ".\n"
             "Please enter a number lower than this value.", m_invalid_data, MB_OK);
        itr->numeric_response->SetFocus();
        return false;
      }
    }
    if((itr->is_dropdown) && (itr->dropdown_response->Text != ""))
    {
      response_info *possible_responses = &combo_box_items[itr->dropdown_response];
      if(possible_responses->item_to_id.find(itr->dropdown_response->Text.c_str()) == possible_responses->item_to_id.end())
      {
        PSay("Please choose a valid response", m_invalid_data, MB_OK);
        itr->dropdown_response->SetFocus();
        return false;
      }

    }
  }
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordSurveyTaken::BeforeSave()
{
  map<string, string> insert_map;
  // TIBTransaction *dbTransaction = new TIBTransaction(NULL);
  string current_timestamp = RightNow();
  try
  {
    // dbTransaction->DefaultDatabase = dbDatabase;
    // dbTransaction->StartTransaction();
    if(! ExecuteStatement(lock_transaction /*dbTransaction*/, "delete from survey_responses where survey_taken_id = " + ending_state["id"]))
      /* throw 1; */ return false;
    for(list<question_info_class>::iterator itr = question_info.begin(); itr != question_info.end(); itr++)
    {
      if(((itr->is_numeric) && (itr->numeric_response->Text != "")) ||
         ((itr->is_text) && (itr->text_response->Text != "")) ||
         ((itr->is_dropdown) && (itr->dropdown_response->Text != "")))
      {
        insert_map["id"] = GetNextId(lock_transaction /*dbTransaction*/, "survey_responses");
        insert_map["current_id"] = "4";
        insert_map["last_updated_by"] = current_userid;
        insert_map["last_update_stamp"] = RightNow();
        insert_map["survey_taken_id"] = ending_state["id"];
        insert_map["survey_question_id"] = itr->id;
        if(itr->is_numeric)
        {
          insert_map["numeric_response"] = itr->numeric_response->Text.c_str();
          insert_map["text_response"] = "";
          insert_map["question_response_id"] = "0";
        }
        else if(itr->is_text)
        {
          insert_map["text_response"] = itr->text_response->Text.c_str();
          insert_map["numeric_response"] = "";
          insert_map["question_response_id"] = "0";
        }
        else if(itr->is_dropdown)
        {
          insert_map["text_response"] = "";
          insert_map["numeric_response"] = "";
          response_info *possible_responses = &combo_box_items[itr->dropdown_response];
          insert_map["question_response_id"] = possible_responses->item_to_id[itr->dropdown_response->Text.c_str()];
        }
        if(! ExecuteInsertStatement(lock_transaction /*dbTransaction*/, "survey_responses", insert_map))
          /*throw 2;*/ return false;
      }
    }
    // dbTransaction->Commit();
  }
  catch(int i)
  {
   //  if(dbTransaction->Active)
   //    dbTransaction->Rollback();
    if(i == 1)
      PSay("Error deleting old responses", m_database_error, MB_OK);
    else if(i == 2)
      PSay("Error saving responses", m_database_error, MB_OK);
    else
      PSay("Unknown error while saving responses", m_database_error, MB_OK);
    return false;
  }
  catch(...)
  {
    // if(dbTransaction->Active)
    //  dbTransaction->Rollback();
    PSay("Error saving responses", m_database_error, MB_OK);
    return false;
  }

  return TformRecordGeneric::BeforeSave();
}
//---------------------------------------------------------------------------
void __fastcall TformRecordSurveyTaken::btnPersonSearchClick(TObject *Sender)
{
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * person_search = new TformSearchPerson(NULL,&return_vector);
    person_search->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtPerson, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void TformRecordSurveyTaken::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordSurveyTaken * z = new TformRecordSurveyTaken(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

