//---------------------------------------------------------------------------

#ifndef codeRecordSurveyTakenH
#define codeRecordSurveyTakenH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class question_info_class
{
  public:
    TStaticText *question_text;
    TEdit *numeric_response;
    TRichEdit *text_response;
    TComboBox *dropdown_response;
    string id;
    string min_value;
    string max_value;
    bool is_numeric;
    bool is_text;
    bool is_dropdown;
};

class response_info
{
  public:
  map<string, string> id_to_item;
  map<string, string> item_to_id;
};

class TformRecordSurveyTaken : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TPanel *panelGroup;
        TLabel *lblPerson;
        TLabel *lblSurvey;
        TStaticText *txtSurvey;
        TStaticText *txtPerson;
        TBitBtn *btnSurveySearch;
        TGroupBox *groupResponses;
        TScrollBox *scrollQuestions;
        TPanel *panelResponses;
        TBitBtn *btnPersonSearch;
        TLabel *Label1;
        TEdit *editDateTaken;
        void __fastcall btnSurveySearchClick(TObject *Sender);
        void __fastcall btnPersonSearchClick(TObject *Sender);
private:	// User declarations
        bool CheckForUselessRecord();
        bool IsValidOnScreen ();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenStart();
        bool ScreenStop();
        bool ScreenLock();
        bool ScreenUnlock();
        void ShowQuestions();
        bool BeforeSave();
        list<question_info_class> question_info;
        bool ResponsesAreValid();
        map<TComboBox *, response_info> combo_box_items;
public:		// User declarations
        __fastcall TformRecordSurveyTaken(TComponent* Owner, map<string, string> & p_parameters);

        static void Do(map<string, string> & p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordSurveyTaken *formRecordSurveyTaken;
//---------------------------------------------------------------------------
#endif
