//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordTaskCob.h"
#include "codeSearchPerson.h"
#include "codeSearchServiceProvided.h"
#include "codeRecordReferral.h"
#include "codeRecordAppointment.h"
#include "codeRecordTransaction.h"
#include "codeRecordTaskCobVisit.h"
#include "launchPrintCobReport.h"
#include "launchARRAExemptionForm.h"
#include "codeSpecialModifyPayable.h"
#include "codeWizardModifyTransactions.h"
#include "codeSpecialTransactionSummary.h"
#include "codeSpecialTransactionDetails.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformRecordTaskCob *formRecordTaskCob;
//---------------------------------------------------------------------------
__fastcall TformRecordTaskCob::TformRecordTaskCob(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("tasks")), transactions_summary(this, listTransactions)
{
  // for cynthia chancellor & co. ... because they finally bitched enough about it ...
  fields_to_leave_raw.insert("task_comments");
  fields_to_leave_raw.insert("visit_comments");

  appointments_filter.SetListViewHandle (listAppointments);
  appointments_filter.SetSecurity("appointments.people");
  appointments_filter.AddColumnSpec("Provider", "appointments", as_text, true, 100, rawString);
  appointments_filter.AddColumnSpec("Patient", "appointments", as_text, false, 120);
  appointments_filter.AddColumnSpec("Date", "appointments", as_date, true, 90/*, repeatingString*/);
  appointments_filter.AddColumnSpec("Time", "appointments", as_text, true, 80);
  appointments_filter.AddColumnSpec("Description", "appointments", as_text, true, 130, sentenceString);
  appointments_filter.AddColumnSpec("Created For", "appointments", as_text, false, 100);
  appointments_filter.AddColumnSpec("Outcome", "appointments", as_text, false, 90);
  appointments_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  appointments_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  appointments_filter.FetchPreferences("recordtaskcob.appointments_filter");
  appointments_filter.SetIconStatus(true);
  appointments_filter.SetSQLStatement ("");
  appointments_filter.RefreshDataSet();

  referrals_filter.SetListViewHandle (listReferrals);
  referrals_filter.SetSecurity("referrals");
  referrals_filter.AddColumnSpec("Date", "referrals", as_date, true, 80);
  referrals_filter.AddColumnSpec("Referred To (Facility)", "referrals", as_text, false, 200);
  referrals_filter.AddColumnSpec("Referred To (Provider)", "referrals", as_text, false, 200);
  referrals_filter.AddColumnSpec("Referred By (Facility)", "referrals", as_text, true, 200);
  referrals_filter.AddColumnSpec("Referred By (Provider)", "referrals", as_text, true, 200);
  referrals_filter.AddColumnSpec("Reason", "referrals", as_text, false, 100);
  referrals_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  referrals_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  referrals_filter.FetchPreferences("recordtaskcob.referrals_filter");
  referrals_filter.SetIconStatus(true);
  referrals_filter.SetSQLStatement ("");
  referrals_filter.RefreshDataSet();

  visits_filter.SetListViewHandle (listVisits);
  visits_filter.SetSecurity("tasks");
  visits_filter.AddColumnSpec("Date", "tasks", as_date, true, 90);
  visits_filter.AddColumnSpec("Time", "tasks", as_time, true, 90);
  visits_filter.AddColumnSpec("Provider", "tax_entities", as_text, true, 140, rawString);
  visits_filter.AddColumnSpec("Patient", "people", as_text, false, 120);
  visits_filter.AddColumnSpec("Reason", "tasks", as_text, true, 120, sentenceString);
  visits_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  visits_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  visits_filter.FetchPreferences("recordtaskcob.visits_filter");
  visits_filter.SetIconStatus(true);
  visits_filter.SetSQLStatement ("");
  visits_filter.RefreshDataSet();

  txtPrintCob->Font->Color  = link_color;
  txtPrintARRA->Font->Color = link_color;
  staticTransactionDetails->Font->Color = link_color;
  staticBetaModifyTransactions->Font->Color = link_color;

  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordTaskCob::ScreenStart()
{
  pageControl->ActivePageIndex = 0;
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskCob::ScreenStop()
{
  // unregister combo boxes

  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskCob::IsValidOnScreen()
{
  if(GetValidLinkId(txtPerson) == "")
  {
    PSay("Please enter a person", m_missing_data, MB_OK);
    btnPersonSearch->Show();
    btnPersonSearch->SetFocus();
    return false;
  }
  else if(GetValidLinkId(txtService) == "")
  {
    PSay("Please enter a service", m_missing_data, MB_OK);
    btnServiceSearch->Show();
    btnServiceSearch->SetFocus();
    return false;
  }
  else
    return true;

}
//---------------------------------------------------------------------------
bool TformRecordTaskCob::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  lblCob->Caption = initial_state["cob_number"].c_str();
  if (initial_state["date_of_task"] != "")
    dateEntered->Date = Pdate(initial_state["date_of_task"], mdy | yyyy).OutDate();
  else
    dateEntered->Date = Date();
  if (initial_state["time_of_task"] != "")
    timeEntered->Time = Ptime(initial_state["time_of_task"], withsec | military).OutTime();
  else
  {
    Ptime current_time(Time());
    current_time.second = 0;
    timeEntered->Time = current_time.OutTime();
  }
  string cob_type = lookupTables->ValueOf("cob_types", initial_state["cob_id"]);
  if (cob_type != "")
   Title = cob_type.c_str();
  editReason->Text = /*SentenceString(*/initial_state["task_comments"]/*)*/.c_str();
  editLimits->Text = /*SentenceString(*/initial_state["visit_comments"]/*)*/.c_str();
  editPreconditions->Text = SentenceString(initial_state["preconditions_note"]).c_str();
  editFollowup->Text = SentenceString(initial_state["followup_note"]).c_str();
  editReported->Text = SentenceString(initial_state["reported_by_note"]).c_str();
  checkHospitalized->Checked = (initial_state["hospitalized"] == "1");
  checkRoom->Checked         = (initial_state["given_room"] == "1");

  CreateLink(txtPerson,  btnPersonSearch,  this, initial_state["person_id"],            "people");
  CreateLink(txtService, btnServiceSearch, this, initial_state["services_provided_id"], "services_provided");

  if(! is_new_record)
    old_person_id = initial_state["person_id"];
  else
    old_person_id = "";

  if(! is_new_record)
    old_entity_id = GetOneField(dbDatabase, "select tax_entity_id from services_provided where id = " + initial_state["services_provided_id"]);
  else
    old_entity_id = "";

  TformRecordGeneric::PutDataOnScreen();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskCob::GetDataFromScreen()
{
  TformRecordGeneric::GetDataFromScreen();
  if (!CreateInsertMap(dbDatabase, "tasks", ending_state))
     return false;

  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id

  ending_state["id"] = initial_state["id"];
  ending_state["cob_number"] = initial_state["cob_number"];

  string person_id = GetValidLinkId(txtPerson);
  if (StringToInt(person_id) > 0)
    ending_state["person_id"] = person_id;
  else
    ending_state["person_id"] = "0";

  ending_state["date_of_task"] = Pdate(dateEntered->Date).OutDate(mdy | yyyy);
  ending_state["time_of_task"] = Ptime(timeEntered->Time).OutTime(military | withsec);
  ending_state["task_comments"] = editReason->Text.c_str();
  ending_state["visit_comments"] = editLimits->Text.c_str();
  ending_state["preconditions_note"] = editPreconditions->Text.c_str();
  ending_state["followup_note"] = editFollowup->Text.c_str();
  ending_state["reported_by_note"] = editReported->Text.c_str();
  ending_state["hospitalized"] = checkHospitalized->Checked ? "1" : "0";
  ending_state["given_room"] = checkRoom->Checked ? "1" : "0";

  string services_provided_id = GetValidLinkId(txtService);
  if (StringToInt(services_provided_id) > 0)
    ending_state["services_provided_id"] = services_provided_id;
  else
    ending_state["services_provided_id"] = "0"; // jhaley: added check for invalid link

  ending_state["group_id"] = lookupTables->IdOf("groups", "Contract Health");
  if(initial_state["user_id"] != "")
    ending_state["user_id"] = initial_state["user_id"];
  else
    ending_state["user_id"] = "0";

  // these are apparently set (somewhere), but not shown anywhere. must preserve.
  ending_state["tax_entity_id"] = initial_state["tax_entity_id"];
  ending_state["cob_id"] = initial_state["cob_id"]; // someone forgot this! and guess what! CreateInsertMap doesn't fix it!

  // bools that we want to preserve (even though they should all be zero)
  ending_state["contacts_added"] = initial_state["contacts_added"];
  ending_state["in_progress"]    = initial_state["in_progress"];
  ending_state["is_educational"] = initial_state["is_educational"];
  ending_state["is_personal"]    = initial_state["is_personal"];
  ending_state["new_client"]     = initial_state["new_client"];

/*  // No longer necessary.  CreateInsertMap takes care of default values for FKs
  // set the rest of the values in the tasks table, even though we don't use them
  // on this form, to avoid null values in the table
  // NOTE: when fields (foreign keys, that is) are added to the tasks table, they should be added here
  // TODO: paul added stuff to derive automatic values for these, should be using that, or even better ...
  // TODO: can't recordGeneric make ending_state == initial_state by default, then override things that have changed?
  // Philip says not always--in places we pass extra variables to record screens via initial_state ... until these are
  // fixed, we can't depend on initial_state containing only valid field names for that table
*/
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskCob::ScreenLock()
{
  // disable group boxes
  panelGroup->Enabled = false;
  panelGroup2->Enabled = false;
  editReason->ReadOnly = true;
  editReason->TabStop = false;
  editLimits->ReadOnly = true;
  editLimits->TabStop = false;
  editPreconditions->ReadOnly = true;
  editPreconditions->TabStop = false;
  editReported->ReadOnly = true;
  editReported->TabStop = false;
  editFollowup->ReadOnly = true;
  editFollowup->TabStop = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskCob::ScreenUnlock()
{
  // enable group boxes
  panelGroup->Enabled = true;
  panelGroup2->Enabled = true;
  editReason->ReadOnly = false;
  editReason->TabStop = true;
  editLimits->ReadOnly = false;
  editLimits->TabStop = true;
  editPreconditions->ReadOnly = false;
  editPreconditions->TabStop = true;
  editReported->ReadOnly = false;
  editReported->TabStop = true;
  editFollowup->ReadOnly = false;
  editFollowup->TabStop = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordTaskCob::btnPersonSearchClick(TObject *Sender)
{
 vector<string> return_vector = TformSearchPerson::Do(this);
 if (!return_vector.empty())
 {
  CreateLink(txtPerson, btnPersonSearch, this, return_vector[0], "people");
  PSay ("Associated appointments, referrals, visits, etc. should all be fixed for you when you save this COB.", m_message, MB_OK);
 }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordTaskCob::btnServiceSearchClick(TObject *Sender)
{
  string count_sql = "select count(*) from tasks where parent_task_id = " + initial_state["id"];
  string task_count = GetOneField(dbDatabase, count_sql);

  if(!IsBlankOrZero(task_count))
  {
    if(optionsPermissions["special.fix_cob"]["enabled"] != "true")
    {
      string sql_get_users =
        "select users.item "
        "from users "
        "inner join permissions on permissions.user_id = users.id and "
        " permissions.s = 'SPECIAL.FIX_COB' and permissions.k = 'ENABLED' and permissions.v = 'TRUE' "
        "where valid = 1";
      pvecstr users_with_fix_cob;
      if(!SqlToVec(dbDatabase, sql_get_users, users_with_fix_cob))
        PSay("Failed to get a list of users with permission to fully fix a cob with visits.", m_database_error, MB_OK);
      else
      {
        PSay("Some visits have already been entered on this COB, fixing this situation is going to be messy.\n"
             "Please ask one of the following to help you instead:\n" + VecToCommaString(users_with_fix_cob),
             m_message, MB_OK, "Danger, Will Robinson, Danger!");
      }
      return;
    }
  }

  pvecstr return_vector = TformSearchServiceProvided::Do(this, old_entity_id);
  if(!return_vector.empty())
  {
    CreateLink(txtService, btnServiceSearch, this, return_vector[0], "services_provided");
    PSay("Associated appointments, referrals, visits, transactions, etc. "
         "should all be fixed for you when you save this COB.", m_message, MB_OK);
  }
}
//---------------------------------------------------------------------------
bool TformRecordTaskCob::NotNewAnymore()
{
  string sql;

  if (IsBlankOrZero(initial_state["id"])) // jhaley 20110616: I have no idea how it happened, but...
  {
    PSay("Critical error: the COB record ID is invalid. Please notify a programmer immediately.",
         m_program_error, MB_OK);
    return false;
  }

  if (optionsPermissions["table.appointments.people"]["view"] == "true")
  {
    sql = "select tax_entities.name, person_names.last_name || ', ' || person_names.first_name, "
          // "appointments.repeating_string || '|' || appointments.begin_date || '|' || appointments.end_date, " // WTF?
          "appointments.begin_date, "
          "appointments.appointment_time, appointments.description, "
          "users.item, visit_outcome_types.item, appointments.current_id, appointments.id "
          "from appointments, users, visit_outcome_types, tax_entities, people "
          "left join person_names on people.person_names_id = person_names.id "
          "where appointments.created_for = users.id and "
          "appointments.person_id = people.id and "
          "appointments.visit_outcome_id = visit_outcome_types.id and "
          "appointments.tax_entity_id = tax_entities.id and "
          "appointments.task_id = " + initial_state["id"];
    appointments_filter.SetSQLStatement (sql);
    appointments_filter.RefreshDataSet();
    appointments_filter.SetAddEdit(this, AddRecord(&(TformRecordTaskCob::AddAppointment)),
                               EditRecord(&(TformRecordTaskCob::EditAppointment)));
    appointments_request = atlas->RequestNotificationWhen("appointments.task_id", initial_state["id"], rel_e, as_int, this,
                          RefreshHandler(&(TformRecordTaskCob::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.referrals"]["view"] == "true")
  {
    sql = "select referrals.date_of_referral, a.name, b.name, c.name, d.name, referral_reason_types.item, "
          "referrals.current_id, referrals.id "
          "from referrals "
          "left join tax_entities a on referrals.by_facility_id = a.id "
          "left join tax_entities b on referrals.by_provider_id = b.id "
          "left join tax_entities c on referrals.to_facility_id = c.id "
          "left join tax_entities d on referrals.to_provider_id = d.id "
          "left join referral_reason_types on referrals.referral_reason_id = referral_reason_types.id "
          "where referrals.task_id = " + initial_state["id"];
    referrals_filter.SetSQLStatement(sql);
    referrals_filter.RefreshDataSet();
    referrals_filter.SetAddEdit(this, AddRecord(&(TformRecordTaskCob::AddReferral)),
                                          EditRecord(&(TformRecordTaskCob::EditReferral)));
    referrals_request = atlas->RequestNotificationWhen("referrals.task_id", initial_state["id"], rel_e, as_int, this,
                                 RefreshHandler(&(TformRecordTaskCob::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.tasks"]["view"] == "true")
  {
    sql = "select tasks.date_of_task, tasks.time_of_task, tax_entities.name, "
          "person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix, "
          "tasks.task_comments, tasks.current_id, tasks.id "
          "from tasks "
          "left join tax_entities on tax_entities.id = tasks.tax_entity_id "
          "left join people on people.id = tasks.person_id "
          "left join person_names on people.person_names_id = person_names.id "
          "where tasks.parent_task_id = " + initial_state["id"];
    visits_filter.SetSQLStatement(sql);
    visits_filter.RefreshDataSet();
    visits_filter.SetAddEdit(this, NULL, EditRecord(&(TformRecordTaskCob::EditVisit)));
    visits_request = atlas->RequestNotificationWhen("tasks.parent_task_id", initial_state["id"], rel_e, as_int, this,
                                 RefreshHandler(&(TformRecordTaskCob::AtlasRefreshListViews)));
  }

  // jhaley 20100910: use transaction summary object
  transactions_summary.SetSQLStatement("select * from transactions where task_id = " + initial_state["id"]);
  transactions_summary.SetRecord("tasks", initial_state["id"], "task_id",
                                 RefreshHandler(&(TformRecordTaskCob::AtlasRefreshListViews)));

  staticTransactionDetails->Enabled = true;

  txtPrintCob->OnClick  = txtPrintCobClick;
  txtPrintARRA->OnClick = txtPrintARRAClick;
  TformRecordGeneric::NotNewAnymore();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordTaskCob::AddReferral()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["task_id"] = initial_state["id"];
  string person_id = GetValidLinkId(txtPerson);
  if (person_id != "")
    temp_map["person_id"] = person_id;
  if (initial_state["date_of_task"] != "")
    temp_map["date_of_referral"] = initial_state["date_of_task"];
  FORM_TRY
    TformRecordReferral * referralRecord = new TformRecordReferral(NULL, temp_map);
    referralRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaskCob::EditReferral()
{
  map<string,string> temp_map;
  temp_map["id"] = referrals_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordReferral * referralRecord = new TformRecordReferral(NULL, temp_map);
    referralRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaskCob::AddAppointment()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["task_id"] = initial_state["id"];
  string person_id = GetValidLinkId(txtPerson);
  if (person_id != "")
    temp_map["person_id"] = person_id;
  string services_provided_id = GetValidLinkId(txtService);
  if (services_provided_id != "")
  {
    temp_map["tax_entity_id"] = GetOneField(dbDatabase,
      "select tax_entity_id from services_provided where id = " + services_provided_id);
  }

  TformRecordAppointment * appointmentRecord = NULL;
  FORM_TRY
    appointmentRecord = new TformRecordAppointment(NULL, temp_map);
  FORM_CATCH
  if(appointmentRecord)
  {
    appointmentRecord->editDescription->Text = ("COB number " + initial_state["cob_number"]).c_str();
    appointmentRecord->Show();
  }
  else
    PSay("Failed to open an appointment form.", m_program_error, MB_OK);
}
//---------------------------------------------------------------------------
void TformRecordTaskCob::EditAppointment()
{
  map<string,string> temp_map;
  temp_map["id"] = appointments_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordAppointment * appointmentRecord = new TformRecordAppointment(NULL, temp_map);
    appointmentRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaskCob::EditVisit()
{
  map<string,string> temp_map;
  temp_map["id"] = visits_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordTaskCobVisit * visitRecord = new TformRecordTaskCobVisit(NULL, temp_map);
    visitRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaskCob::EditTransaction()
{
  /*
  map<string, string> temp_map;
  temp_map["id"] = transactions_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordTransaction * view_transaction = new TformRecordTransaction(NULL, temp_map);
    view_transaction->Show();
  FORM_CATCH
  */
}
//---------------------------------------------------------------------------
bool TformRecordTaskCob::AtlasRefreshListViews(int request_num, string matched_value)
{
  if (request_num == appointments_request)
    appointments_filter.RefreshDataSet();
  else if (referrals_request == request_num)
    referrals_filter.RefreshDataSet();
  else if (visits_request == request_num)
    visits_filter.RefreshDataSet();
  else
    transactions_summary.AtlasRefresh(request_num, matched_value); // jhaley: try transaction summary object

  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskCob::IsNewAgain()
{
  appointments_filter.SetSQLStatement(string(""));
  appointments_filter.RefreshDataSet();
  appointments_filter.SetAddEdit(this, NULL, NULL);
  referrals_filter.SetSQLStatement(string(""));
  referrals_filter.RefreshDataSet();
  referrals_filter.SetAddEdit(this, NULL, NULL);
  visits_filter.SetSQLStatement(string(""));
  visits_filter.RefreshDataSet();
  visits_filter.SetAddEdit(this, NULL, NULL);

  // jhaley 2010910: use transaction summary object
  transactions_summary.Clear();

  TformRecordGeneric::IsNewAgain();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskCob::AfterSave()
{
 AtlasSend();
 return TformRecordGeneric::AfterSave();
}
//---------------------------------------------------------------------------
bool TformRecordTaskCob::BeforeSave()
{
 AtlasClear();

 string new_person_id = ending_state["person_id"];
 string new_entity_id = GetOneField(lock_transaction,
   "select tax_entity_id from services_provided where id = " + ending_state["services_provided_id"]);

 if(!is_new_record)
 {
  string sql;
  string right_now = RightNow();
  string insert_into_change_log =
    "insert into change_log (change_stamp, change_by, table_name, field_name, previous_value, present_value, record_id) "
    "select '" + right_now + "', " + current_userid;
  string set_fingerpointing = "set last_update_stamp = '" + right_now + "', last_updated_by = " + current_userid;

  if(old_person_id != new_person_id)
  {
   try
   {
    vector<string> statements;

    // referrals
    statements.push_back(insert_into_change_log + ", 'REFERRALS', 'LAST_UPDATE_STAMP', last_update_stamp, '" + right_now + "', id "
          "from referrals where task_id = " + ending_state["id"] + " and person_id != " + new_person_id);
    statements.push_back(insert_into_change_log + ", 'REFERRALS', 'LAST_UPDATED_BY', last_updated_by, '" + current_userid + "', id "
          "from referrals where task_id = " + ending_state["id"] + " and last_updated_by != " + current_userid + " and person_id != " + new_person_id);
    statements.push_back(insert_into_change_log + ", 'REFERRALS', 'PERSON_ID', person_id, '" + new_person_id + "', id "
          "from referrals where task_id = " + ending_state["id"] + " and person_id != " + new_person_id);
    statements.push_back("update referrals " + set_fingerpointing + ", person_id = " + new_person_id
                         + " where task_id = " + ending_state["id"] + " and person_id = " + old_person_id);
    AtlasAdd("referrals", "person_id", old_person_id);
    AtlasAdd("referrals", "person_id", new_person_id);
    AtlasAdd("referrals", "task_id", ending_state["id"]);

    // appointments
    statements.push_back(insert_into_change_log + ", 'APPOINTMENTS', 'LAST_UPDATE_STAMP', last_update_stamp, '" + right_now + "', id "
          "from appointments where task_id = " + ending_state["id"] + " and person_id != " + new_person_id);
    statements.push_back(insert_into_change_log + ", 'APPOINTMENTS', 'LAST_UPDATED_BY', last_updated_by, '" + current_userid + "', id "
          "from appointments where task_id = " + ending_state["id"] + " and last_updated_by != " + current_userid + " and person_id != " + new_person_id);
    statements.push_back(insert_into_change_log + ", 'APPOINTMENTS', 'PERSON_ID', person_id, '" + new_person_id + "', id "
          "from appointments where task_id = " + ending_state["id"] + " and person_id != " + new_person_id);
    statements.push_back("update appointments " + set_fingerpointing + ", person_id = " + new_person_id
                         + " where task_id = " + ending_state["id"] + " and person_id = " + old_person_id);
    AtlasAdd("appointments", "person_id", old_person_id);
    AtlasAdd("appointments", "person_id", new_person_id);
    AtlasAdd("appointments", "task_id", ending_state["id"]);

    // visits
    statements.push_back(insert_into_change_log + ", 'TASKS', 'LAST_UPDATE_STAMP', last_update_stamp, '" + right_now + "', id "
          "from tasks where parent_task_id = " + ending_state["id"] + " and person_id != " + new_person_id);
    statements.push_back(insert_into_change_log + ", 'TASKS', 'LAST_UPDATED_BY', last_updated_by, '" + current_userid + "', id "
          "from tasks where parent_task_id = " + ending_state["id"] + " and last_updated_by != " + current_userid + " and person_id != " + new_person_id);
    statements.push_back(insert_into_change_log + ", 'TASKS', 'PERSON_ID', person_id, '" + new_person_id + "', id "
          "from tasks where parent_task_id = " + ending_state["id"] + " and person_id != " + new_person_id);
    statements.push_back("update tasks " + set_fingerpointing + ", person_id = " + new_person_id
                         + " where parent_task_id = " + ending_state["id"] + " and person_id = " + old_person_id);
    AtlasAdd("tasks", "person_id", old_person_id);
    AtlasAdd("tasks", "person_id", new_person_id);
    AtlasAdd("tasks", "parent_task_id", ending_state["id"]);

    // conditions on visits
    statements.push_back(insert_into_change_log + ", 'CONDITIONS', 'LAST_UPDATE_STAMP', last_update_stamp, '" + right_now + "', id "
          "from conditions where task_id in (select tasks.id from tasks where parent_task_id = " + ending_state["id"] + ") and person_id != " + new_person_id);
    statements.push_back(insert_into_change_log + ", 'CONDITIONS', 'LAST_UPDATED_BY', last_updated_by, '" + current_userid + "', id "
          "from conditions where task_id in (select tasks.id from tasks where parent_task_id = " + ending_state["id"] + ") and last_updated_by != " + current_userid + " and person_id = " + old_person_id);
    statements.push_back(insert_into_change_log + ", 'CONDITIONS', 'PERSON_ID', person_id, '" + new_person_id + "', id "
          "from conditions where task_id in (select tasks.id from tasks where parent_task_id = " + ending_state["id"] + ") and person_id != " + new_person_id);
    statements.push_back("update conditions " + set_fingerpointing + ", person_id = " + new_person_id
                         + " where task_id in (select tasks.id from tasks where parent_task_id = "
                         + ending_state["id"] + ") and person_id = " + old_person_id);
    AtlasAdd("conditions", "person_id", old_person_id);
    AtlasAdd("conditions", "person_id", new_person_id);
    vector<string> task_ids;
    if (!SqlToVec(lock_transaction, "select id from tasks where parent_task_id = " + ending_state["id"], task_ids))
     throw(5);
    AtlasAdd("conditions", "task_id", task_ids);

    // not procedures (no person_id)
    // not measurements and observations, because we don't get those from CHS data.

    for (vector<string>::iterator i = statements.begin(); i != statements.end(); i++)
     if (!ExecuteStatement(lock_transaction, *i))
      throw(1);
   }
   catch(...)
   {
    PSay("Your attempt to change the person on this COB was thwarted by some unknown error.\n"
         "You will unfortunately have to try again, and/or have a talk with a programmer.", m_database_error, MB_OK);
    return false;
   }
  }

  if(old_entity_id != new_entity_id)
  {
   try
   {
    vector<string> statements;

    // referrals
    statements.push_back(insert_into_change_log + ", 'REFERRALS', 'LAST_UPDATE_STAMP', last_update_stamp, '" + right_now + "', id "
          "from referrals where task_id = " + ending_state["id"] + " and to_provider_id = " + old_entity_id);
    statements.push_back(insert_into_change_log + ", 'REFERRALS', 'LAST_UPDATED_BY', last_updated_by, '" + current_userid + "', id "
          "from referrals where task_id = " + ending_state["id"] + " and last_updated_by != " + current_userid + " and to_provider_id = " + old_entity_id);
    statements.push_back(insert_into_change_log + ", 'REFERRALS', 'TO_PROVIDER_ID', to_provider_id, '" + new_entity_id + "', id "
          "from referrals where task_id = " + ending_state["id"] + " and to_provider_id = " + old_entity_id);
    statements.push_back("update referrals " + set_fingerpointing + ", to_provider_id = " + new_entity_id
                         + " where task_id = " + ending_state["id"] + " and to_provider_id = " + old_entity_id);
    AtlasAdd("referrals", "to_provider_id", old_entity_id);
    AtlasAdd("referrals", "to_provider_id", new_entity_id);
    AtlasAdd("referrals", "task_id", ending_state["id"]);

    // appointments
    statements.push_back(insert_into_change_log + ", 'APPOINTMENTS', 'LAST_UPDATE_STAMP', last_update_stamp, '" + right_now + "', id "
          "from appointments where task_id = " + ending_state["id"] + " and tax_entity_id = " + old_entity_id);
    statements.push_back(insert_into_change_log + ", 'APPOINTMENTS', 'LAST_UPDATED_BY', last_updated_by, '" + current_userid + "', id "
          "from appointments where task_id = " + ending_state["id"] + " and last_updated_by != " + current_userid + " and tax_entity_id = " + old_entity_id);
    statements.push_back(insert_into_change_log + ", 'APPOINTMENTS', 'TAX_ENTITY_ID', tax_entity_id, '" + new_entity_id + "', id "
          "from appointments where task_id = " + ending_state["id"] + " and tax_entity_id = " + old_entity_id);
    statements.push_back("update appointments " + set_fingerpointing + ", tax_entity_id = " + new_entity_id
                         + " where task_id = " + ending_state["id"] + " and tax_entity_id = " + old_entity_id);
    AtlasAdd("appointments", "tax_entity_id", old_entity_id);
    AtlasAdd("appointments", "tax_entity_id", new_entity_id);
    AtlasAdd("appointments", "task_id", ending_state["id"]);

    if (!IsBlankOrZero(GetOneField(lock_transaction, "select count(*) from tasks where parent_task_id = "
                                   + ending_state["id"] + " and tax_entity_id = " + old_entity_id)) &&  // TODO: >.<
        IDNO != PSay("Would you like to fix the visits attached to this COB?\n"
                     "At least one visit had the same entity as the COB's old entity; it can be changed to match.\n"
                     "Visits with non-matching entities won't be changed at all.",
                     m_confirmation, MB_YESNO, "Danger, Will Robinson, Danger!"))
    {
     // visits
     statements.push_back(insert_into_change_log + ", 'TASKS', 'LAST_UPDATE_STAMP', last_update_stamp, '" + right_now + "', id "
           "from tasks where parent_task_id = " + ending_state["id"] + " and tax_entity_id = " + old_entity_id);
     statements.push_back(insert_into_change_log + ", 'TASKS', 'LAST_UPDATED_BY', last_updated_by, '" + current_userid + "', id "
           "from tasks where parent_task_id = " + ending_state["id"] + " and last_updated_by != " + current_userid + " and tax_entity_id = " + old_entity_id);
     statements.push_back(insert_into_change_log + ", 'TASKS', 'TAX_ENTITY_ID', tax_entity_id, '" + new_entity_id + "', id "
           "from tasks where parent_task_id = " + ending_state["id"] + " and tax_entity_id = " + old_entity_id);
     statements.push_back("update tasks " + set_fingerpointing + ", tax_entity_id = " + new_entity_id
                          + " where parent_task_id = " + ending_state["id"] + " and tax_entity_id = " + old_entity_id);
     AtlasAdd("tasks", "tax_entity_id", old_entity_id);
     AtlasAdd("tasks", "tax_entity_id", new_entity_id);
     AtlasAdd("tasks", "parent_task_id", ending_state["id"]);
    }

    if (!IsBlankOrZero(GetOneField(lock_transaction,
                         "select count(*) from bills where task_id in "
                         "(select tasks.id from tasks where parent_task_id = " + ending_state["id"] + ") and "
                         "(provider_tax_id = " + old_entity_id + " or facility_tax_id = " + old_entity_id +
                         " or group_tax_id = " + old_entity_id + " or actual_tax_id = " + old_entity_id + ")")))
    {
     PSay("There are bills to fix (they in some way use the same entity that was on the COB.)\n"
          "They will NOT be fixed automatically.", m_warning, MB_OK, "Danger, Will Robinson, Danger!");
    }

    for (vector<string>::iterator i = statements.begin(); i != statements.end(); i++)
     if (!ExecuteStatement(lock_transaction, *i))
      throw(1);

    // obligated transactions
    transaction_summary sum_before, sum_after, sum_diff;

    vector<map<string, string> > raw_before;
    if (!SqlToVecMap(lock_transaction, "select * from transactions where task_id = " + ending_state["id"], raw_before))
     throw(2);
    sum_before.RawInput(raw_before);

    sum_after = sum_before;
    if (sum_after.ChangeEntityTo(old_entity_id, new_entity_id))
    {
     sum_diff = sum_after - sum_before;

     map<string, string> insert_row;
     if (!CreateInsertMap(lock_transaction, "transactions", insert_row))
      throw(3);
     insert_row["current_id"]         = "4";
     insert_row["last_update_stamp"]  = right_now;
     insert_row["last_updated_by"]    = current_userid;
     insert_row["task_id"]            = ending_state["id"];
     insert_row["effective_date"]     = GetOneField(lock_transaction, "select max(effective_date) from transactions where task_id = " + ending_state["id"]);
     insert_row["note"]               = "Modification entries for accounting item (cob or bill)";
     insert_row["transaction_number"] = GetNextId(lock_transaction, "transact_number");

     vector<map<string, string> > raw_diff = sum_diff.GetFinalOutput(insert_row);
     for (vector<map<string, string> >::iterator i_tx = raw_diff.begin(); i_tx != raw_diff.end(); i_tx++)
     {
      (*i_tx)["id"] = GetNextId(lock_transaction, "transactions");
      if (!ExecuteInsertStatement(lock_transaction, "transactions", (*i_tx)))
       throw(20);
      AtlasAdd("transactions", (*i_tx));
     }
    }
   }
   catch(...)
   {
    PSay("Your attempt to change the entity on this COB was thwarted by some unknown error.\nYou will unfortunately have to try again, and/or have a talk with a programmer.", m_database_error, MB_OK);
    return false;
   }
  }
 }
 return TformRecordGeneric::BeforeSave();
}
//---------------------------------------------------------------------------
void __fastcall TformRecordTaskCob::txtPrintCobClick(TObject *Sender)
{
 TformLaunchPrintCobReport::DoSilently(initial_state["id"]);
}
//---------------------------------------------------------------------------
// jhaley 20101117: Launch link for ARRA exemption form letter
void __fastcall TformRecordTaskCob::txtPrintARRAClick(TObject *Sender)
{
  string service_id = GetValidLinkId(txtService); // need a valid services_provided ID
  string person_id  = GetValidLinkId(txtPerson);  // 20110707: need a valid person too
  if (service_id == "")
  {
    PSay("Please select a valid service associated with this COB first.", m_missing_data, MB_OK);
    if (btnServiceSearch->Enabled && btnServiceSearch->Visible)
      btnServiceSearch->SetFocus();
    return;
  }
  if (person_id == "")
  {
    PSay("Please attach a valid person to the COB first.", m_missing_data, MB_OK);
    if (btnPersonSearch->Enabled && btnPersonSearch->Visible)
      btnPersonSearch->SetFocus();
    return;
  }
  // Get the associated tax entity ID - note it can be changed on the form if so desired.
  string tax_entity_id = GetOneField(dbDatabase, "select tax_entity_id from services_provided where id = '" + service_id + "' ");
  FORM_TRY
    TformLaunchARRAExemptionForm *launchARRA = new TformLaunchARRAExemptionForm(NULL, tax_entity_id, person_id);
    launchARRA->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordTaskCob::staticModifyAccPayableClick(TObject *Sender)
{
  /* Deprecated!  Woo!
  FORM_TRY
    TformSpecialModifyPayable * edit_payable = new TformSpecialModifyPayable(NULL, "", initial_state["id"]);
    edit_payable->Show();
  FORM_CATCH
  */
}
//---------------------------------------------------------------------------
void __fastcall TformRecordTaskCob::staticBetaModifyTransactionsClick(TObject *Sender)
{
 if (optionsPermissions["table.transactions"]["insert"] == "true")
 {
  FORM_TRY
   TformWizardModifyTransactions *wiz = new TformWizardModifyTransactions(NULL, initial_state["id"], mod_cob);
   wiz->Show();
  FORM_CATCH
 }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordTaskCob::staticTransactionDetailsClick(TObject *Sender)
{
  // jhaley 20100910: Launch transaction details form when link is clicked
  if (optionsPermissions["table.transactions"]["view"] == "true")
  {
    string sql = "select tax_entities.name, transactions.effective_date, transactions.fiscal_date, accounts.name, "
                 "account_types.item, transactions.note, transactions.debit_amount, transactions.credit_amount, "
                 "transactions.transaction_number, transactions.current_id, transactions.id "
                 "from transactions "
                 "inner join accounts on transactions.account_id = accounts.id "
                 "inner join account_types on accounts.account_type_id = account_types.id "
                 "left join tax_entities on transactions.tax_entity_id = tax_entities.id "
                 "where transactions.task_id = " + initial_state["id"];

    TformSpecialTransactionDetails *details = NULL;
    FORM_TRY
      details = new TformSpecialTransactionDetails(NULL, initial_state["id"], "task_id");
    FORM_CATCH
    details->Filter->AddColumnSpec("Tax Entity",  "tax_entities", as_text,   true,  120, rawString);
    details->Filter->AddColumnSpec("Eff. Date",   "transactions", as_date,   true,   75);
    details->Filter->AddColumnSpec("Fisc. Date",  "transactions", as_date,   true,   75);
    details->Filter->AddColumnSpec("Account",     "accounts",     as_text,   true,  140);
    details->Filter->AddColumnSpec("Type",        "accounts",     as_text,   true,   75);
    details->Filter->AddColumnSpec("Note",        "transactions", as_text,   false, 120, sentenceString);
    details->Filter->AddColumnSpec("Debit",       "transactions", as_double, true,   75, nonzeroAmountString);
    details->Filter->AddColumnSpec("Credit",      "transactions", as_double, true,   75, nonzeroAmountString);
    details->Filter->AddColumnSpec("Trans #",     "transactions", as_int,    true,   75);
    details->Filter->AddColumnSpec("Current Id",  "current_id",   as_int,    false,  80);
    details->Filter->AddColumnSpec("Internal Id", "internal_id",  as_int,    false,  80);
    details->Filter->FetchPreferences("recordtaskcob.transactions_filter");
    details->Execute(sql);
    details->Show();
  }
}
//---------------------------------------------------------------------------
void TformRecordTaskCob::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordTaskCob * z = new TformRecordTaskCob(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordTaskCob::FormClose(TObject *Sender, TCloseAction &Action)
{
  TformRecordGeneric::FormClose(Sender, Action);
  transactions_summary.Close(Action); // jhaley 20100910: shutdown transaction summary object
}
//---------------------------------------------------------------------------
// jhaley 20100910: Added checkbox to control transaction summary grouping by account
void __fastcall TformRecordTaskCob::checkTransactionAccountClick(TObject *Sender)
{
  transactions_summary.SetShowAccount(checkTransactionAccount->Checked); // set state
  transactions_summary.CheckBoxClicked();                                // update it.
}
//---------------------------------------------------------------------------
// jhaley 20100910: Added checkbox to control transaction summary grouping by tax entity name
void __fastcall TformRecordTaskCob::checkTransactionNameClick(TObject *Sender)
{
  transactions_summary.SetShowName(checkTransactionName->Checked); // set state
  transactions_summary.CheckBoxClicked();                          // update it.
}
//---------------------------------------------------------------------------

