//---------------------------------------------------------------------------

#ifndef codeRecordTaskCobH
#define codeRecordTaskCobH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "codeRubberContainer.h"
#include "codeSpecialTransactionSummary.h"
//---------------------------------------------------------------------------
class TformRecordTaskCob : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TPageControl *pageControl;
        TTabSheet *sheetGeneral;
        TPanel *panelGroup;
        TLabel *lblCobLabel;
        TLabel *lblCob;
        TLabel *lblService;
        TLabel *lblDate;
        TLabel *lblTime;
        TDateTimePicker *dateEntered;
        TDateTimePicker *timeEntered;
        TTabSheet *sheetAdditional;
        TLabel *lblReason;
        TLabel *lblLimits;
        TLabel *lblReferrals;
        TLabel *lblVisits;
        TLabel *lblTransactions;
        TBitBtn *btnServiceSearch;
        TLabel *lblPerson;
        TStaticText *txtPerson;
        TBitBtn *btnPersonSearch;
        TStaticText *txtService;
        TStaticText *txtPrintCob;
        TTabSheet *sheetEmergencyRoom;
        TPanel *panelGroup2;
        TLabel *lblPreconditions;
        TLabel *lblReported;
        TLabel *lblFollowup;
        TCheckBox *checkHospitalized;
        TCheckBox *checkRoom;
        TLabel *lblAppointments;
        TStaticText *staticTransactionDetails;
        TRichEdit *editReason;
        TRichEdit *editLimits;
        TRichEdit *editPreconditions;
        TRichEdit *editFollowup;
        TRichEdit *editReported;
        TStaticText *staticBetaModifyTransactions;
        TRubberContainer *rubberAppointments;
        TListView *listAppointments;
        TRubberContainer *rubberReferrals;
        TListView *listReferrals;
        TRubberContainer *rubberVisits;
        TListView *listVisits;
        TRubberContainer *rubberTransactions;
        TListView *listTransactions;
        TLabel *lblBy;
        TLabel *lblTransactionSplitBy;
        TCheckBox *checkTransactionAccount;
        TCheckBox *checkTransactionName;
        TStaticText *txtPrintARRA;
        void __fastcall btnPersonSearchClick(TObject *Sender);
        void __fastcall btnServiceSearchClick(TObject *Sender);
        void __fastcall txtPrintCobClick(TObject *Sender);
        void __fastcall txtPrintARRAClick(TObject *Sender);
        void __fastcall staticModifyAccPayableClick(TObject *Sender);
        void __fastcall staticBetaModifyTransactionsClick(TObject *Sender);
        void __fastcall staticTransactionDetailsClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall checkTransactionAccountClick(TObject *Sender);
        void __fastcall checkTransactionNameClick(TObject *Sender);
private:	// User declarations
        classFilterObject referrals_filter;
        int referrals_request;
        classFilterObject appointments_filter;
        int appointments_request;
        classFilterObject visits_filter;
        int visits_request;
        //classFilterObject transactions_filter;
        //int transactions_request;
        classTransactionSummarizer transactions_summary; // jhaley: use transaction summary object
        string old_person_id;
        string old_entity_id;
public:		// User declarations
        __fastcall TformRecordTaskCob(TComponent* Owner, map<string,string> p_parameters);
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenStart();
        bool ScreenStop();
        bool ScreenLock();
        bool ScreenUnlock();
        bool NotNewAnymore();
        bool IsNewAgain();
        void AddReferral();
        void EditReferral();
        void AddAppointment();
        void EditAppointment();
        void EditVisit();
        void EditTransaction();
        bool AtlasRefreshListViews(int request_num, string matched_value);
        bool AfterSave();
        bool BeforeSave();
        static void Do(map<string, string> & p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordTaskCob *formRecordTaskCob;
//---------------------------------------------------------------------------
#endif
