//---------------------------------------------------------------------------

#ifndef codeRecordTaskDenH
#define codeRecordTaskDenH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "codeRubberContainer.h"
//---------------------------------------------------------------------------
class TformRecordTaskDen : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TPageControl *pagesTask;
        TTabSheet *sheetTask;
        TTabSheet *sheetProcedures;
        TPanel *panelGroup;
        TLabel *lblProvider;
        TLabel *lblDate;
        TLabel *lblTimeSpent;
        TLabel *lblTime;
        TLabel *lblPatient;
        TLabel *lblNewPatient;
        TBitBtn *btnProviderSearch;
        TDateTimePicker *dateTask;
        TEdit *editTimeSpent;
        TDateTimePicker *timeTask;
        TBitBtn *btnPersonSearch;
        TCheckBox *checkNewPatient;
        TLabel *lblComments;
        TStaticText *txtPerson;
        TStaticText *txtProvider;
        TRichEdit *editComments;
        TLabel *lblAppointments;
        TStaticText *staticAppointmentAutoAttacher;
        TRubberContainer *rubberAppointments;
        TListView *listAppointments;
        TLabel *lbDiagnosis;
        TLabel *lblProcedure;
        TLabel *lblBills;
        TRubberContainer *rubberDiagnosis;
        TListView *listConditions;
        TRubberContainer *rubberProcedure;
        TListView *listProcedures;
        TRubberContainer *rubberBills;
        TListView *listBills;
        TStaticText *txtEvent;
        TLabel *lblEvent;
        TBitBtn *btnEventSearch;
        TLabel *lblTaskType;
        TComboBox *cboTaskType;
        void __fastcall btnProviderSearchClick(TObject *Sender);
        void __fastcall btnPersonSearchClick(TObject *Sender);
        void __fastcall staticAppointmentAutoAttacherClick(
          TObject *Sender);
        void __fastcall btnEventSearchClick(TObject *Sender);
private:	// User declarations
        classFilterObject conditions_filter;
        int conditions_request;
        classFilterObject procedures_filter;
        int procedures_request;
        classFilterObject appointments_filter;
        int appointments_request;
        classFilterObject bills_filter;
        int bills_request;
        string appointment_to_attach;
public:		// User declarations
        __fastcall TformRecordTaskDen(TComponent* Owner, map<string,string> p_parameters);
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenStart();
        bool ScreenStop();
        bool ScreenLock();
        bool ScreenUnlock();
        bool NotNewAnymore();
        bool AtlasRefreshListViews(int request_num, string matched_value);
        bool IsNewAgain();
        void AddCondition();
        void EditCondition();
        void AddProcedure();
        void EditProcedure();
        void AddAppointment();
        void EditAppointment();
        void AddBill();
        void EditBill();           
        bool BeforeSave();
        bool AfterSave();
        static void Do(map<string, string> & p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordTaskDen *formRecordTaskDen;
//---------------------------------------------------------------------------
#endif
