//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordTaskDiab.h"
#include "codeSearchPerson.h"
#include "codeSearchEvent.h"
#include "codeSearchTaxEntity.h"
#include "codeRecordCondition.h"
#include "codeRecordReferral.h"
#include "codeRecordProcedure.h"
#include "codeRecordAppointment.h"
#include "codeRecordOutgoingBill.h"
#include "codeSearchDiabEducation.h"
#include "codeRecordSurveyTaken.h"
#include "codeSpecialAppointmentToTaskAttacher.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma link "codeRubberContainer"
#pragma link "codeFrameObservationList"
#pragma link "codeFrameObservationList"
#pragma resource "*.dfm"
TformRecordTaskDiab *formRecordTaskDiab;
//---------------------------------------------------------------------------
__fastcall TformRecordTaskDiab::TformRecordTaskDiab(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("tasks"))
{
  fields_to_leave_raw.insert("task_comments");
  fields_to_leave_raw.insert("visit_comments");                                               

  referrals_filter.SetListViewHandle (listReferrals);
  referrals_filter.SetSecurity("referrals");
  referrals_filter.AddColumnSpec("Date", "referrals", as_date, true, 80);
  referrals_filter.AddColumnSpec("Referred To (Facility)", "referrals", as_text, true, 200);
  referrals_filter.AddColumnSpec("Referred To (Provider)", "referrals", as_text, true, 200);
  referrals_filter.AddColumnSpec("Referred By (Facility)", "referrals", as_text, true, 200);
  referrals_filter.AddColumnSpec("Referred By (Provider)", "referrals", as_text, true, 200);
  referrals_filter.AddColumnSpec("Reason", "referrals", as_text, false, 100);
  referrals_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  referrals_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  referrals_filter.FetchPreferences("recordtaskdiab.referrals_filter");
  referrals_filter.SetIconStatus(true);
  referrals_filter.SetSQLStatement ("");
  referrals_filter.RefreshDataSet();

  conditions_filter.SetListViewHandle (listConditions);
  conditions_filter.SetSecurity("conditions.diab");
  conditions_filter.AddColumnSpec("Condition Type", "conditions", as_text, true, 120);
  conditions_filter.AddColumnSpec("Start Date", "conditions", as_date, false, 100);
  conditions_filter.AddColumnSpec("Stop Date", "conditions", as_date, false, 100);
  conditions_filter.AddColumnSpec("Code", "conditions", as_text, true, 100);
  conditions_filter.AddColumnSpec("Note", "conditions", as_text, false, 100, sentenceString);
  conditions_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  conditions_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  conditions_filter.FetchPreferences("recordtaskdiab.conditions_filter");
  conditions_filter.SetIconStatus(true);
  conditions_filter.SetSQLStatement("");
  conditions_filter.RefreshDataSet();

  procedures_filter.SetListViewHandle (listProcedures);
  procedures_filter.SetSecurity("procedures");
  procedures_filter.AddColumnSpec("Start Date", "procedures", as_date, true, 100);
  procedures_filter.AddColumnSpec("Stop Date", "procedures", as_date, false, 100);
  procedures_filter.AddColumnSpec("Place of Service", "procedures", as_text, false, 110);
  procedures_filter.AddColumnSpec("Type of Service", "procedures", as_text, false, 110);
  procedures_filter.AddColumnSpec("Cpt/Hcpcs Code", "procedures", as_text, true, 105);
  procedures_filter.AddColumnSpec("Modifier", "procedures", as_text, false, 105);
  procedures_filter.AddColumnSpec("Charges", "procedures", as_text, false, 100);
  procedures_filter.AddColumnSpec("Days/Units", "procedures", as_text, false, 100);
  procedures_filter.AddColumnSpec("EPSDT", "procedures", as_text, false, 100);
  procedures_filter.AddColumnSpec("EMG", "procedures", as_text, false, 100);
  procedures_filter.AddColumnSpec("COB", "procedures", as_text, false, 100);
  procedures_filter.AddColumnSpec("Local Use", "procedures", as_text, false, 100);
  procedures_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  procedures_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  procedures_filter.FetchPreferences("recordtaskdiab.procedures_filter");
  procedures_filter.SetIconStatus(true);
  procedures_filter.SetSQLStatement("");
  procedures_filter.RefreshDataSet();

  appointments_filter.SetListViewHandle (listAppointments);
  appointments_filter.SetSecurity("appointments.people");
  appointments_filter.AddColumnSpec("Date", "appointments", as_date, true, 90/*, repeatingString*/);
  appointments_filter.AddColumnSpec("Time", "appointments", as_text, true, 80);
  appointments_filter.AddColumnSpec("Description", "appointments", as_text, true, 130, sentenceString);
  appointments_filter.AddColumnSpec("Created For", "appointments", as_text, true, 100);
  appointments_filter.AddColumnSpec("Outcome", "appointments", as_text, false, 90);  
  appointments_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  appointments_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  appointments_filter.FetchPreferences("recordtaskdiab.appointments_filter");
  appointments_filter.SetIconStatus(true);
  appointments_filter.SetSQLStatement ("");
  appointments_filter.RefreshDataSet();

  bills_filter.SetListViewHandle (listBills);
  bills_filter.SetSecurity("bills");
  bills_filter.AddColumnSpec("Date Sent", "bills", as_date, true, 110);
  bills_filter.AddColumnSpec("Insurance Company", "tax_entities", as_text, true, 140, rawString);
  bills_filter.AddColumnSpec("Total Charge", "bills", as_double, true, 120);
  bills_filter.AddColumnSpec("Invoice Amount", "bills", as_double, true, 120);
  bills_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  bills_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  bills_filter.FetchPreferences("recordtaskdiab.bills_filter");
  bills_filter.SetIconStatus(true);
  bills_filter.SetSQLStatement ("");
  bills_filter.RefreshDataSet();

  staticAppointmentAutoAttacher->Font->Color = link_color;
  appointment_to_attach = initial_state["appointment_id"];
  
 Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordTaskDiab::ScreenStart()
{
  // register combo boxes
  lookupTables->RegisterComboBox("users", cboStaff);
  lookupTables->RegisterComboBox("method_types", cboMethod);
  lookupTables->RegisterComboBox("direction_types", cboDirection);
  lookupTables->RegisterComboBox("classification_types", cboClassification);
  lookupTables->RegisterComboBox("diab_meeting_types", cboMeeting);
  lookupTables->RegisterComboBox("diab_activity_types", cboActivity);

  string location_sql = "select event_location_types.id, case "
                        "when event_location_types.zip_code_id = 0 then item "
                        "when item = '' then (city || ', ' || state) "
                        "else (city || ', ' || state || ' - ' || item) end item, event_location_types.valid "
                        "from event_location_types "
                        "inner join zip_codes on event_location_types.zip_code_id = zip_codes.id "
                        "where (group_id = 0 or group_id = '" + lookupTables->IdOf("groups", "Diabetes") + "') "
                        "and valid = 1 order by state, city, item ";
  lookupTables->RegisterComboBox("event_location_types", cboLocation, location_sql);

  // jhaley 20100913: custom SQL for program_types
  string program_sql = "select id, item, valid from program_types "
                             "where (group_id = 0 or group_id = '" + lookupTables->IdOf("groups", "Diabetes") + "') "
                             "and valid = 1 order by item ";
  lookupTables->RegisterComboBox("program_types", cboProgram, program_sql);

  string task_sql = "select id, item, valid from task_purpose_types where group_id = 0 or group_id = '"
                    + lookupTables->IdOf("groups", "Diabetes") + "' ";
  lookupTables->RegisterComboBox("task_purpose_types", cboTaskType, task_sql);

  pageControl->ActivePageIndex = 0;
  //txtContacts->Font->Color = link_color;

  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------

bool TformRecordTaskDiab::ScreenStop()
{
  // unregister combo boxes
  lookupTables->UnregisterComboBox("users", cboStaff);
  lookupTables->UnregisterComboBox("method_types", cboMethod);
  lookupTables->UnregisterComboBox("direction_types", cboDirection);
  lookupTables->UnregisterComboBox("classification_types", cboClassification);
  lookupTables->UnregisterComboBox("program_types", cboProgram);
  lookupTables->UnregisterComboBox("task_purpose_types", cboTaskType);
  lookupTables->UnregisterComboBox("diab_meeting_types", cboMeeting);
  lookupTables->UnregisterComboBox("diab_activity_types", cboActivity);
  lookupTables->UnregisterComboBox("event_location_types", cboLocation);

  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskDiab::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxe
  // corrospond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect

  if (! lookupTables->IsInLookUpTable("users", cboStaff->Text.c_str()))
  {
    PSay("Please enter a valid staff name", m_invalid_data, MB_OK);
    cboStaff->Show();
    cboStaff->SetFocus();
    return false;
  }
  else if ((cboStaff->Text == "") && (GetValidLinkId(txtProvider) == ""))
  {
    PSay("You must enter either an employee name or provider.", m_missing_data, MB_OK);
    cboStaff->Show();
    cboStaff->SetFocus();
    return false;
  }
  else if (! IsFloat(editTimeSpent->Text.c_str()))
  {
    PSay("Please enter a valid time spent", m_invalid_data, MB_OK);
    editTimeSpent->Show();
    editTimeSpent->SetFocus();
    return false;
  }
  else if (! IsFloat(editMileage->Text.c_str()))
  {
    PSay("Please enter a valid mileage", m_invalid_data, MB_OK);
    editMileage->Show();
    editMileage->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("method_types", cboMethod->Text.c_str()))
  {
    PSay("Please enter a valid method of contact", m_invalid_data, MB_OK);
    cboMethod->Show();
    cboMethod->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("direction_types", cboDirection->Text.c_str()))
  {
    PSay("Please enter either incoming or outgoing", m_invalid_data, MB_OK);
    cboDirection->Show();
    cboDirection->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("program_types", cboProgram))
  {
    PSay("Please enter a valid program type", m_invalid_data, MB_OK);
    cboProgram->Show();
    cboProgram->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("task_purpose_types", cboTaskType))
  {
    PSay("Please enter a valid task type", m_invalid_data, MB_OK);
    cboTaskType->Show();
    cboTaskType->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("classification_types", cboClassification->Text.c_str()))
  {
    PSay("Please enter a valid classification", m_invalid_data, MB_OK);
    cboClassification->Show();
    cboClassification->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("diab_meeting_types", cboMeeting->Text.c_str()))
  {
    PSay("Please enter a valid meeting type", m_invalid_data, MB_OK);
    cboMeeting->Show();
    cboMeeting->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("diab_activity_types", cboActivity->Text.c_str()))
  {
    PSay("Please enter a valid activity type", m_invalid_data, MB_OK);
    cboActivity->Show();
    cboActivity->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("event_location_types", cboLocation))
  {
    PSay("Please enter a valid location", m_invalid_data, MB_OK);
    cboLocation->Show();
    cboLocation->SetFocus();
    return false;
  }
  else if (initial_state["group_id"] == "" || StringToInt(initial_state["group_id"]) <= 0)
  {
    PSay("This task does not belong to a valid department. Please contact a programmer if this occured while creating a new task.",
         m_program_error, MB_OK);
    return false;
  }

  bool to_return = true;
  // the following rules relate to Events/Participations/Tasks; they can't seem to create tasks
  // properly for their events, so we'll just force them, eh?
  string event_id = GetValidLinkId(txtEvent);
  if (event_id == "")
  { // no event
    if (cboTaskType->Text == "Event Preparation" || cboTaskType->Text == "Event Teaching/Leading" ||
        cboTaskType->Text == "Event Contact")
    { // but they're using a diab_task_type intended for use with events...
      PSay("This task is not attached to an event, yet you are using a 'Task Type' reserved for events.\n\nPlease attach this task to the appropriate event, or select a different (or blank) Task Type.", m_invalid_data, MB_OK);
      cboTaskType->Show();
      cboTaskType->SetFocus();
      to_return = false;
    }
  }
  else
  { // attached to event
    string person_id = GetValidLinkId(txtPerson);
    if(person_id == "" && cboTaskType->Text == "Event Contact")
    { // no person, but event contact.  contact with whom??
      PSay("This task is part of an event with a 'Task Type' indicating credit for contact with a client, but no client is selected.\n\nPlease search for the Client Name of the event participant, or select a different (or blank) Task Type.", m_invalid_data, MB_OK);
      btnPersonSearch->Show();
      btnPersonSearch->SetFocus();
      to_return = false;
    }
    else if (StringToInt(person_id) > 0 &&
             (cboTaskType->Text == "Event Preparation" || cboTaskType->Text == "Event Teaching/Leading"))
    { // person attached but these event types aren't FOR people
      PSay("This task is part of an event with a 'Task Type' indicating teaching/leading, or preparation, but a Client Name is selected.\n\nPlease unlink the client that is selected and use the Event screen to create contacts for the appropriate participants.  You can unlink the client by pressing the search button, then pressing 'Select' without performing a search (link text will change to 'None').", m_invalid_data, MB_OK);
      btnPersonSearch->Show();
      btnPersonSearch->SetFocus();
      to_return = false;
    }
  }
  if (to_return == true) // no errors yet ... we don't want to cascade errors at them
  {
    string person_id = GetValidLinkId(txtPerson);
    if (person_id == "" && cboMethod->Text == "Visit")
    { // no person attached but they've indicated it's a visit.  Should rarely be valid!
      int yesno_answer = PSay("You've indicated this task should count as a visit but have not selected a client the visit was with.  In rare cases, such a task may be valid.  If you forgot to select the client, say 'No' below and then choose a client.\n\nAre you sure you want to create this visit without a client?", m_warning, MB_YESNO);
      if (yesno_answer == IDNO)
      { // if they don't want to continue, help them fix it, otherwise ... let them go on.
        btnPersonSearch->Show();
        btnPersonSearch->SetFocus();
        to_return = false;
      }
    }
  }

  return to_return; 
}
//---------------------------------------------------------------------------
bool TformRecordTaskDiab::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  cboStaff->Text = PrettyString(lookupTables->ValueOf("users", initial_state["user_id"])).c_str();
  if (initial_state["date_of_task"] != "")
    dateTask->Date = Pdate(initial_state["date_of_task"], mdy | yyyy).OutDate();
  else
    dateTask->Date = Date();
  editTimeSpent->Text = initial_state["time_spent"].c_str();
  editMileage->Text = initial_state["mileage"].c_str();
  cboMethod->Text = PrettyString(lookupTables->ValueOf("method_types", initial_state["method_id"])).c_str();
  cboDirection->Text = PrettyString(lookupTables->ValueOf("direction_types", initial_state["direction_id"])).c_str();
  cboClassification->Text = PrettyString(lookupTables->ValueOf("classification_types", initial_state["classification_id"])).c_str();
  cboMeeting->Text = PrettyString(lookupTables->ValueOf("diab_meeting_types", initial_state["diab_meeting_id"])).c_str();
  cboActivity->Text = PrettyString(lookupTables->ValueOf("diab_activity_types", initial_state["diab_activity_id"])).c_str();
  cboLocation->Text = lookupTables->ValueOf("event_location_types", initial_state["event_location_id"], cboLocation).c_str();
  editComments->Text = SentenceString(initial_state["task_comments"]).c_str();
  cboProgram->Text = lookupTables->ValueOf("program_types", initial_state["program_id"], cboProgram).c_str();
  cboTaskType->Text = PrettyString(lookupTables->ValueOf("task_purpose_types", initial_state["task_purpose_id"], cboTaskType)).c_str();
  if (initial_state["is_educational"] == "1")
    checkEducational->Checked = true;
  else
    checkEducational->Checked = false;
  if (initial_state["is_personal"] == "1")
    checkPersonal->Checked = true;
  else
    checkPersonal->Checked = false;

  CreateLink(txtPerson, btnPersonSearch, this, initial_state["person_id"], "people");
  CreateLink(txtEvent, btnEventSearch, this, initial_state["event_id"], "events");
  CreateLink(txtProvider, btnProviderSearch, this, initial_state["tax_entity_id"], "tax_entities");
  CreateLink(txtEducation, btnEducationSearch, this, initial_state["diab_education_id"], "diab_education");  

/* This is all related to the old way of doing event contacts.  None of this is needed anymore.
  if((initial_state["event_id"] != "0") && (initial_state["event_id"] != "") &&
    (initial_state["id"] != "new") && (StringToInt(initial_state["current_id"]) > 3))
  {
    string contacts;
    string sql;
    TIBTransaction * dbLinkTransaction = new TIBTransaction(NULL);
    StdTransaction(dbLinkTransaction, dbDatabase);

    sql = "select contacts_added from tasks where id = " + initial_state["id"];
    contacts = GetOneField(dbLinkTransaction, sql);
    if((contacts == "0") || (contacts == ""))
    {
      //txtContacts->Enabled = true;
      sql = "select tasks.id from tasks where tasks.event_id = " + initial_state["event_id"] + " and "
            "tasks.user_id = " + initial_state["user_id"] + " and tasks.contacts_added = 1";
      if(GetOneField(dbLinkTransaction, sql) != "")
        //txtContacts->Enabled = false;
    }
    else
      txtContacts->Enabled = false;

    dbLinkTransaction->Commit();
    delete dbLinkTransaction;
  }
*/
  TformRecordGeneric::PutDataOnScreen();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskDiab::GetDataFromScreen()
{
  TformRecordGeneric::GetDataFromScreen();
  if (!CreateInsertMap(dbDatabase, "tasks", ending_state))
     return false;

  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id

  ending_state["id"] = initial_state["id"];
  string person_id = GetValidLinkId(txtPerson);
  if(StringToInt(person_id) > 0)
    ending_state["person_id"] = person_id;
  else
    ending_state["person_id"] = "0";

  string event_id = GetValidLinkId(txtEvent);
  if(StringToInt(event_id) > 0)
    ending_state["event_id"] = event_id;
  else
    ending_state["event_id"] = "0";

  string tax_entity_id = GetValidLinkId(txtProvider);
  if(StringToInt(tax_entity_id) > 0)
    ending_state["tax_entity_id"] = tax_entity_id;
  else
    ending_state["tax_entity_id"] = "0";

  string education_id = GetValidLinkId(txtEducation);
  if(StringToInt(education_id) > 0)
    ending_state["diab_education_id"] = education_id;
  else
    ending_state["diab_education_id"] = "0";

  ending_state["user_id"] = lookupTables->IdOf("users", cboStaff->Text.c_str());
  ending_state["date_of_task"] = Pdate(dateTask->Date).OutDate(mdy | yyyy);

  if (editTimeSpent->Text != "")
    ending_state["time_spent"] = editTimeSpent->Text.c_str();
  else
    ending_state["time_spent"] = "";

  if (editMileage->Text != "")
    ending_state["mileage"] = editMileage->Text.c_str();
  else
    ending_state["mileage"] = "";

  ending_state["method_id"] = lookupTables->IdOf("method_types", cboMethod->Text.c_str());
  ending_state["direction_id"] = lookupTables->IdOf("direction_types", cboDirection->Text.c_str());
  ending_state["classification_id"] = lookupTables->IdOf("classification_types", cboClassification->Text.c_str());
  ending_state["task_comments"]    = editComments->Text.c_str();
  ending_state["diab_meeting_id"]  = lookupTables->IdOf("diab_meeting_types",  cboMeeting->Text.c_str());
  ending_state["diab_activity_id"] = lookupTables->IdOf("diab_activity_types", cboActivity->Text.c_str());
  ending_state["event_location_id"] = lookupTables->IdOf("event_location_types", cboLocation);
  ending_state["task_purpose_id"]  = lookupTables->IdOf("task_purpose_types",  cboTaskType->Text.c_str(), cboTaskType);
  ending_state["program_id"]       = lookupTables->IdOf("program_types",       cboProgram);
  ending_state["group_id"] = initial_state["group_id"];

  if (checkEducational->Checked)
    ending_state["is_educational"] = "1";
  else
    ending_state["is_educational"] = "0";

  if (checkPersonal->Checked)
    ending_state["is_personal"] = "1";
  else
    ending_state["is_personal"] = "0";

  if(StringToInt(initial_state["fitness_membership_id"]) > 0)
    ending_state["fitness_membership_id"] = initial_state["fitness_membership_id"];
  else
    ending_state["fitness_membership_id"] = "0";

/*  // No longer necessary.  CreateInsertMap takes care of default values for FKs
  // set the rest of the values in the tasks table, even though we don't use them
  // on this form, to avoid null values in the table
  // NOTE: when fields are added to the tasks table, they should be added here
*/
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskDiab::ScreenLock()
{
  // disable group boxes
  panelGroup->Enabled = false;
  editComments->ReadOnly = true;
  editComments->TabStop = false;
/*if(txtContacts->Tag == 1)
  {
    txtContacts->Enabled = true;
    txtContacts->Tag = 0;
  }
*/
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskDiab::ScreenUnlock()
{
  // enable group boxes
  panelGroup->Enabled = true;
  editComments->ReadOnly = false;
  editComments->TabStop = true;
/*if(txtContacts->Enabled)
  {
    txtContacts->Tag = 1;
    txtContacts->Enabled = false;
  }
*/
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------

void __fastcall TformRecordTaskDiab::btnPersonSearchClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtPerson, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformRecordTaskDiab::btnEventSearchClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchEvent * eventSearch = new TformSearchEvent(NULL,&return_vector,lookupTables->IdOf("groups", "Diabetes"));
    eventSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtEvent, btnEventSearch, this, return_vector[0], "events");
}
//---------------------------------------------------------------------------
bool TformRecordTaskDiab::NotNewAnymore()
{
  frameObs->SetSource(obs_list_task, initial_state["id"]);

  string sql;

  if (optionsPermissions["table.referrals"]["view"] == "true")
  {
    sql = "select referrals.date_of_referral, a.name, b.name, c.name, d.name, referral_reason_types.item, "
          "referrals.current_id, referrals.id "
          "from referrals, tax_entities a, tax_entities b, tax_entities c, tax_entities d, referral_reason_types "
          "where referrals.by_facility_id = a.id and "
          "referrals.by_provider_id = b.id and "
          "referrals.to_facility_id = c.id and "
          "referrals.to_provider_id = d.id and "
          "referrals.referral_reason_id = referral_reason_types.id and "
          "referrals.task_id = " + initial_state["id"];
    referrals_filter.SetSQLStatement(sql);
    referrals_filter.RefreshDataSet();
    referrals_filter.SetAddEdit(this, AddRecord(&(TformRecordTaskDiab::AddReferral)),
                                          EditRecord(&(TformRecordTaskDiab::EditReferral)));
    referrals_request = atlas->RequestNotificationWhen("referrals.task_id", initial_state["id"], rel_e, as_int, this,
                                 RefreshHandler(&(TformRecordTaskDiab::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.conditions.diab"]["view"] == "true")
  {
    sql = "select condition_types.item, conditions.start_date, conditions.stop_date, "
          "conditions.code, conditions.note, conditions.current_id, conditions.id "
          "from conditions, condition_types "
          "where conditions.condition_id = condition_types.id and "
          "conditions.task_id = " + initial_state["id"];
    conditions_filter.SetSQLStatement(sql);
    conditions_filter.RefreshDataSet();
    conditions_filter.SetAddEdit(this, AddRecord(&(TformRecordTaskDiab::AddCondition)),
                                  EditRecord(&(TformRecordTaskDiab::EditCondition)));
    conditions_request = atlas->RequestNotificationWhen("conditions.task_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordTaskDiab::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.procedures"]["view"] == "true")
  {
    sql = "select procedures.start_date, procedures.stop_date, procedures.place_of_service, "
          "procedures.type_of_service, procedures.cpt_hcpcs, procedures.modifier, "
          "procedures.charges, procedures.days_units, procedures.epsdt, procedures.emg, procedures.cob, "
          "procedures.local_use, procedures.current_id, procedures.id "
          "from procedures "
          "where procedures.task_id = " + initial_state["id"];
    procedures_filter.SetSQLStatement(sql);
    procedures_filter.RefreshDataSet();
    procedures_filter.SetAddEdit(this, AddRecord(&(TformRecordTaskDiab::AddProcedure)),
                                  EditRecord(&(TformRecordTaskDiab::EditProcedure)));
    procedures_request = atlas->RequestNotificationWhen("procedures.task_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordTaskDiab::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.appointments.people"]["view"] == "true")
  {
    sql = //"select appointments.repeating_string || '|' || appointments.begin_date || '|' || appointments.end_date, " // WTF?
          "select appointments.begin_date, "
          "appointments.appointment_time, appointments.description, "
          "users.item, visit_outcome_types.item, appointments.current_id, appointments.id "
          "from appointments, users, visit_outcome_types "
          "where appointments.created_for = users.id and "
          "appointments.visit_outcome_id = visit_outcome_types.id and "
          "appointments.task_id = " + initial_state["id"];
    appointments_filter.SetSQLStatement (sql);
    appointments_filter.RefreshDataSet();
    appointments_filter.SetAddEdit(this, AddRecord(&(TformRecordTaskDiab::AddAppointment)),
                               EditRecord(&(TformRecordTaskDiab::EditAppointment)));
    appointments_request = atlas->RequestNotificationWhen("appointments.task_id", initial_state["id"], rel_e, as_int, this,
                          RefreshHandler(&(TformRecordTaskDiab::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.bills.outgoing.diab"]["view"] == "true")
  {
    sql = "select bills.bill_date, tax_entities.name, bills.total_charge, "
          "bills.invoice_amount, bills.current_id, bills.id "
          "from bills, tax_entities, insurance_coverage, insurance_policies "
          "where bills.insurance_coverage_id = insurance_coverage.id and "
          "insurance_coverage.insurance_policy_id = insurance_policies.id and "
          "insurance_policies.tax_entity_id = tax_entities.id and "
          "bills.task_id = " + initial_state["id"];
    bills_filter.SetSQLStatement(sql);
    bills_filter.RefreshDataSet();
    bills_filter.SetAddEdit(this, AddRecord(&(TformRecordTaskDiab::AddBill)),
                                  EditRecord(&(TformRecordTaskDiab::EditBill)));
    bills_request = atlas->RequestNotificationWhen("bills.task_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordTaskDiab::AtlasRefreshListViews)));
  }

  staticAppointmentAutoAttacher->Enabled = true;
  TformRecordGeneric::NotNewAnymore();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordTaskDiab::AddReferral()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["task_id"] = initial_state["id"];
  string person_id = GetValidLinkId(txtPerson);
  if (person_id != "")
    temp_map["person_id"] = person_id;
  if (initial_state["date_of_task"] != "")
    temp_map["date_of_referral"] = initial_state["date_of_task"];
  FORM_TRY
    TformRecordReferral * referralRecord = new TformRecordReferral(NULL, temp_map);
    referralRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaskDiab::EditReferral()
{
  map<string,string> temp_map;
  temp_map["id"] = referrals_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordReferral * referralRecord = new TformRecordReferral(NULL, temp_map);
    referralRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
/*
void TformRecordTaskDiab::AddMeasurement()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["task_id"] = initial_state["id"];
  if ((initial_state["person_id"] != "") || (initial_state["person_id"] != "0"))
    temp_map["person_id"] = initial_state["person_id"];
  if (initial_state["date_of_task"] != "")
    temp_map["date_of_measurement"] = initial_state["date_of_task"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Diabetes");
  FORM_TRY
    TformRecordMeasurement * measurementRecord = new TformRecordMeasurement(NULL, temp_map);
    measurementRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaskDiab::EditMeasurement()
{
  map<string,string> temp_map;
  temp_map["id"] = measure_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordMeasurement * measurementRecord = new TformRecordMeasurement(NULL, temp_map);
    measurementRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaskDiab::AddLab()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["task_id"] = initial_state["id"];
  if ((initial_state["person_id"] != "") || (initial_state["person_id"] != "0"))
    temp_map["person_id"] = initial_state["person_id"];
  if (initial_state["date_of_task"] != "")
    temp_map["date_of_measurement"] = initial_state["date_of_task"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Diabetes");
  FORM_TRY
    TformRecordLab * labRecord = new TformRecordLab(NULL, temp_map);
    labRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaskDiab::EditLab()
{
  map<string,string> temp_map;
  temp_map["id"] = lab_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordLab * labRecord = new TformRecordLab(NULL, temp_map);
    labRecord->Show();
  FORM_CATCH
}
*/
//---------------------------------------------------------------------------
void TformRecordTaskDiab::AddCondition()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["task_id"] = initial_state["id"];
  string person_id = GetValidLinkId(txtPerson);
  if (person_id != "")
    temp_map["person_id"] = person_id;
  if (initial_state["date_of_task"] != "")
    temp_map["start_date"] = initial_state["date_of_task"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Diabetes");
  FORM_TRY
    TformRecordCondition * conditionRecord = new TformRecordCondition(NULL, temp_map);
    conditionRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaskDiab::EditCondition()
{
  map<string,string> temp_map;
  temp_map["id"] = conditions_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordCondition * conditionRecord = new TformRecordCondition(NULL, temp_map);
    conditionRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaskDiab::AddProcedure()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["task_id"] = initial_state["id"];
  if (initial_state["date_of_task"] != "")
    temp_map["start_date"] = initial_state["date_of_task"];
  FORM_TRY
    TformRecordProcedure * procedureRecord = new TformRecordProcedure(NULL, temp_map);
    procedureRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaskDiab::EditProcedure()
{
  map<string,string> temp_map;
  temp_map["id"] = procedures_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordProcedure * procedureRecord = new TformRecordProcedure(NULL, temp_map);
    procedureRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
bool TformRecordTaskDiab::AtlasRefreshListViews(int request_num, string matched_value)
{
  if (referrals_request == request_num)
    referrals_filter.RefreshDataSet();
  else if (conditions_request == request_num)
    conditions_filter.RefreshDataSet();
  else if (procedures_request == request_num)
    procedures_filter.RefreshDataSet();
  else if (appointments_request == request_num)
    appointments_filter.RefreshDataSet();
  else if (bills_request == request_num)
    bills_filter.RefreshDataSet();
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordTaskDiab::btnProviderSearchClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchTaxEntity * providerSearch = new TformSearchTaxEntity(NULL,&return_vector);
    providerSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtProvider, btnProviderSearch, this, return_vector[0], "tax_entities");
}
//---------------------------------------------------------------------------
bool TformRecordTaskDiab::IsNewAgain()
{
  frameObs->SetSource(obs_list_none, "0");

  referrals_filter.SetSQLStatement(string(""));
  referrals_filter.RefreshDataSet();
  referrals_filter.SetAddEdit(this, NULL, NULL);
  conditions_filter.SetSQLStatement(string(""));
  conditions_filter.RefreshDataSet();
  conditions_filter.SetAddEdit(this, NULL, NULL);
  procedures_filter.SetSQLStatement(string(""));
  procedures_filter.RefreshDataSet();
  procedures_filter.SetAddEdit(this, NULL, NULL);
  appointments_filter.SetSQLStatement(string(""));
  appointments_filter.RefreshDataSet();
  appointments_filter.SetAddEdit(this, NULL, NULL);
  bills_filter.SetSQLStatement(string(""));
  bills_filter.RefreshDataSet();
  bills_filter.SetAddEdit(this, NULL, NULL);

  TformRecordGeneric::IsNewAgain();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordTaskDiab::AddAppointment()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["task_id"] = initial_state["id"];
  temp_map["person_id"] = GetLinkId(txtPerson);       // TODO : a blank check might be beneficial here
  temp_map["tax_entity_id"] = GetLinkId(txtProvider); // TODO : a blank check might be beneficial here
  temp_map["created_for"] = initial_state["user_id"];
  Pdate entered_year(DateToStr(dateTask->Date).c_str(), mdy | yyyy);
  temp_map["repeating_string"] = "0,0,0|0,0,0|0,0,0|0,0,0";
  temp_map["begin_date"] = entered_year.OutDate(mdy | yyyy);
  temp_map["end_date"] = entered_year.OutDate(mdy | yyyy);
  temp_map["single_date"] = "1";
  FORM_TRY
    TformRecordAppointment * appointmentRecord = new TformRecordAppointment(NULL, temp_map);
    appointmentRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaskDiab::EditAppointment()
{
  map<string,string> temp_map;
  temp_map["id"] = appointments_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordAppointment * appointmentRecord = new TformRecordAppointment(NULL, temp_map);
    appointmentRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaskDiab::AddBill()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["task_id"] = initial_state["id"];
  temp_map["bill_date"] = initial_state["date_of_task"];

  FORM_TRY
    TformRecordOutgoingBill * billRecord = new TformRecordOutgoingBill(NULL, temp_map);
    billRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaskDiab::EditBill()
{
  map<string,string> temp_map;
  temp_map["id"] = bills_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordOutgoingBill * billRecord = new TformRecordOutgoingBill(NULL, temp_map);
    billRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordTaskDiab::btnEducationSearchClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchDiabEducation * educationSearch = new TformSearchDiabEducation(NULL,&return_vector, GetLinkId(txtPerson));
    educationSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtEducation, btnEducationSearch, this, return_vector[0], "diab_education");
}
//---------------------------------------------------------------------------
/*
bool TformRecordTaskDiab::BeforeSave()
{
  bool result = true;
  if(is_new_record && (appointment_to_attach != ""))
  {
    map<string, string> field_map;
    field_map["id"] = appointment_to_attach;
    field_map["task_id"] = ending_state["id"];
    if (ExecuteUpdateStatement(lock_transaction, "appointments", field_map))
      atlas->Notify("appointments.id", field_map["id"]);
    else
    {
      result = false;
      PSay("Unable to attach appointment to task/visit.  If the appointment is still unlocked for editing, "
           "save the appointment and try again.", m_program_error, MB_OK);
    }
  }
  return result;
}
*/
//---------------------------------------------------------------------------
bool TformRecordTaskDiab::BeforeSave()
{ // If you change code in this function, change it on the other TformRecordTask* screens as well!

  // if task is new, auto-attach the appt to the task for the appt from which the task
  // was created (if created from an appt) when they save the task
  bool result = true;
  vector<string> IDs_to_refresh;
  if(is_new_record)
  {
    map<string, string> field_map;
    field_map["id"] = appointment_to_attach;
    field_map["task_id"] = ending_state["id"];
    if (IsInt(appointment_to_attach))
    {
      if (appointment_to_attach != "")
      {
        if(ExecuteUpdateStatement(lock_transaction, "appointments", field_map))
          atlas->Notify("appointments.id", field_map["id"]);
        else
        {
          PSay("Unable to attach appointment to task/visit.  If you have the appointment unlocked for editing, "
               "save the appointment and then try saving the task/visit again.  Otherwise, someone else may have "
               "the appointment unlocked for editing.", m_warning, MB_OK);
          result = false;
        }
      }
      if (ending_state["person_id"] != "0" &&
          (cboMethod->Text == "" || cboMethod->Text == "Visit" || cboMethod->Text == "Meeting"))
      {
        int button_pressed;
        FORM_TRY
          //PSay(ReplaceStringWithString(MapToCommaString(ending_state), ", ", "\n"), m_debug, MB_OK);
          TformSpecialAppointmentToTaskAttacher * auto_attacher =
            new TformSpecialAppointmentToTaskAttacher(NULL, ending_state["id"], ending_state["person_id"], lock_transaction, &IDs_to_refresh, true);
          button_pressed = auto_attacher->ShowTaskModal(this);
        FORM_CATCH
        if(button_pressed == mrCancel || button_pressed == mrAbort)
        {
          PSay("The visit was not saved.", m_warning, MB_OK);
          result = false;  // don't save the task if they cancel
        }
        // since using lock_transaction, add to pending atlas requests and send them once transaction is committed
        for(vector<string>::iterator itr = IDs_to_refresh.begin(); itr != IDs_to_refresh.end(); itr++)
          AtlasAdd("appointments", "id", (*itr));
      }
    }
    else
    {
      PSay("Unable to attach appointment to task/visit.  It seems that you created a new appointment and forgot "
           "to save it before clicking on the task/visit link.\n\n"
           "If this is the case, close the visit, save the appointment, and then try creating and saving the task/visit again.  "
           "Otherwise, report this error to a programmer.", m_warning, MB_OK);
      result = false;
    }
  }
  return result;
}
//---------------------------------------------------------------------------
bool TformRecordTaskDiab::AfterSave()
{ // If you change code in this function, change it on the other TformRecordTask* screens as well!
   bool result = true;
   AtlasSend();

   // if we encounter an error (result == false) or the ancestor does, either
   // way, we should return false; only if both say true do we return true:
   return result && TformRecordGeneric::AfterSave();
}
//---------------------------------------------------------------------------
void __fastcall TformRecordTaskDiab::staticAppointmentAutoAttacherClick(TObject *Sender)
{ // If you change code in this function, change it on the other TformRecordTask* screens as well!

 // they clicked the Attach link to manually alter appointment-to-task relationships
 if(optionsPermissions["table.appointments"]["view"] == "true")
 {
   TIBTransaction * transaction_to_use;
   if(is_editing)
      transaction_to_use = lock_transaction;
   else
   {
      transaction_to_use = new TIBTransaction(NULL);
      StdTransaction(transaction_to_use, dbDatabase);
   }
   string person_id = GetValidLinkId(txtPerson);
   if (person_id != "")
   {
     vector<string> IDs_to_refresh;
     FORM_TRY
       //PSay(ReplaceStringWithString(MapToCommaString(initial_state), ", ", "\n"), m_debug, MB_OK);
       TformSpecialAppointmentToTaskAttacher * auto_attacher =
         new TformSpecialAppointmentToTaskAttacher(NULL, initial_state["id"], person_id, transaction_to_use, &IDs_to_refresh);
       auto_attacher->ShowTaskModal(this);
     FORM_CATCH
     // add to pending atlas requests and send them once transaction is committed
     AtlasAdd("appointments", "task_id", initial_state["id"]);
     for(vector<string>::iterator itr = IDs_to_refresh.begin(); itr != IDs_to_refresh.end(); itr++)
       AtlasAdd("appointments", "id", (*itr));
   }
   if(!is_editing)
   {
     if (transaction_to_use->Active)
       transaction_to_use->Commit();
     if (transaction_to_use)
       delete transaction_to_use;
     AfterSave();  // since we're not editing, this isn't going to be called by recordGeneric, so we do it manually.
   }
 }
}
//---------------------------------------------------------------------------
void TformRecordTaskDiab::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordTaskDiab * z = new TformRecordTaskDiab(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

