//---------------------------------------------------------------------------

#ifndef codeRecordTaskDiabH
#define codeRecordTaskDiabH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "codeRubberContainer.h"
#include "codeFrameObservationList.h"
//---------------------------------------------------------------------------
class TformRecordTaskDiab : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TToolButton *ToolButton1;
        TPageControl *pageControl;
        TTabSheet *sheetGeneral;
        TTabSheet *sheetMeasurements;
        TPanel *panelGroup;
        TLabel *lblStaff;
        TLabel *lblEventLabel;
        TLabel *lblClientLabel;
        TLabel *lblDate;
        TLabel *lblTimeSpent;
        TLabel *lblMileage;
        TLabel *lblMethod;
        TLabel *lblDirection;
        TLabel *lblComments;
        TLabel *lblEducational;
        TLabel *lblPersonal;
        TLabel *lblActivity;
        TLabel *lblMeeting;
        TLabel *lblClassification;
        TLabel *lblTask;
        TLabel *lblProgram;
        TComboBox *cboStaff;
        TDateTimePicker *dateTask;
        TEdit *editTimeSpent;
        TEdit *editMileage;
        TComboBox *cboMethod;
        TComboBox *cboDirection;
        TCheckBox *checkEducational;
        TCheckBox *checkPersonal;
        TComboBox *cboActivity;
        TComboBox *cboMeeting;
        TComboBox *cboClassification;
        TComboBox *cboTaskType;
        TComboBox *cboProgram;
        TBitBtn *btnEventSearch;
        TBitBtn *btnPersonSearch;
        TStaticText *txtPerson;
        TStaticText *txtEvent;
        TLabel *lblProvider;
        TBitBtn *btnProviderSearch;
        TStaticText *txtProvider;
        TLabel *lblMeasurements;
        TTabSheet *sheetCodes;
        TLabel *lblConditions;
        TLabel *lblProcedures;
        TLabel *lblBills;
        TLabel *Label1;
        TBitBtn *btnEducationSearch;
        TStaticText *txtEducation;
        TTabSheet *sheetAppointments;
        TLabel *lblAppointments;
        TLabel *lblReferrals;
        TComboBox *cboLocation;
        TLabel *lblLocation;
        TStaticText *staticAppointmentAutoAttacher;
        TRichEdit *editComments;
        TLabel *lblSpecial;
        TComboBox *cboSpecial;
        TRubberContainer *rubberAppointments;
        TListView *listAppointments;
        TRubberContainer *rubberReferrals;
        TListView *listReferrals;
        TRubberContainer *rubberMeasurements;
        TRubberContainer *rubberConditions; 
        TListView *listConditions;
        TRubberContainer *rubberProcedure;
        TListView *listProcedures;
        TRubberContainer *rubberBills;
        TListView *listBills;
        TframeObservationList *frameObs;
        void __fastcall btnPersonSearchClick(TObject *Sender);
        void __fastcall btnEventSearchClick(TObject *Sender);
        void __fastcall btnProviderSearchClick(TObject *Sender);
//        void __fastcall txtContactsClick(TObject *Sender);
        void __fastcall btnEducationSearchClick(TObject *Sender);
        void __fastcall staticAppointmentAutoAttacherClick(
          TObject *Sender);
private:	// User declarations
        classFilterObject referrals_filter;
        int referrals_request;
        classFilterObject measure_filter;
        int measure_request;
        classFilterObject conditions_filter;
        int conditions_request;
        classFilterObject procedures_filter;
        int procedures_request;
        classFilterObject appointments_filter;
        int appointments_request;
        classFilterObject bills_filter;
        int bills_request;
        classFilterObject lab_filter;
        int lab_request;
        string appointment_to_attach;
public:		// User declarations
        __fastcall TformRecordTaskDiab(TComponent* Owner, map<string,string> p_parameters);
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenStart();
        bool ScreenStop();
        bool ScreenLock();
        bool ScreenUnlock();
        bool NotNewAnymore();
        void AddReferral();
        void EditReferral();
        void AddMeasurement();
        void EditMeasurement();
        void AddCondition();
        void EditCondition();
        void AddProcedure();
        void EditProcedure();
        bool AtlasRefreshListViews(int request_num, string matched_value);
        bool IsNewAgain();
        void AddAppointment();
        void EditAppointment();
        void AddBill();
        void EditBill();
        void AddLab();
        void EditLab();
        bool BeforeSave();
        bool AfterSave();
        static void Do(map<string, string> & p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordTaskDiab *formRecordTaskDiab;
//---------------------------------------------------------------------------
#endif
