//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordTaskNotes.h"
#include "codeSearchTaskCom.h"
#include "codeSearchTaskPub.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordTaskNotes *formRecordTaskNotes;
//---------------------------------------------------------------------------
__fastcall TformRecordTaskNotes::TformRecordTaskNotes(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner,  p_parameters, string("task_notes"))
{
  fields_to_leave_raw.insert("note");
  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordTaskNotes::ScreenStart()
{
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskNotes::ScreenStop()
{
  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskNotes::IsValidOnScreen()
{
  // check to make sure that the note is not longer than 255 characters
  // give the user a message box and prompt to re-enter if too long
  // make sure there is a link to a person, although there's not much the user
  // can do to fix that if there's not

  if (GetValidLinkId(txtTask) == "")
  {
    PSay("There is no task associated with this record", m_missing_data, MB_OK);
    return false;
  }
  /*
  if ((initial_state["person_id"] == "") || (initial_state["person_id"] == "0"))
  {
    PSay("There is no person associated with this record", m_missing_data, MB_OK);
    return false;
  }
  */
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskNotes::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  //if ((initial_state["person_id"]== "") || (initial_state["person_id"] == "0"))
  //    initial_state["person_id"] = person;


  editNote->Text = SentenceString(initial_state["note"]).c_str();
  CreateLink(txtTask, btnVisitSearch, this, initial_state["task_id"], "tasks");
  // CreateLink(txtPerson, NULL, this, initial_state["person_id"], "people");

  TformRecordGeneric::PutDataOnScreen();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskNotes::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  ending_state["note"] = editNote->Text.c_str();
  if (initial_state["group_id"] == "")
    ending_state["group_id"] = "0";
  else
    ending_state["group_id"] = initial_state["group_id"];

  ending_state["task_id"] = GetValidLinkId(txtTask);
  // ending_state["person_id"] = initial_state["person_id"];
  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();

  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskNotes::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  editNote->ReadOnly = true;
  editNote->TabStop = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaskNotes::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  editNote->ReadOnly = false;
  editNote->TabStop = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordTaskNotes::btnVisitSearchClick(TObject *Sender)
{
  if(lookupTables->ValueOf("groups", initial_state["group_id"]) == "Community Health")
  {
   // create and show new visit search form
   vector<string> return_vector;
   FORM_TRY
     TformSearchTaskCom * task_search = new TformSearchTaskCom(NULL, &return_vector);
     task_search->ShowTaskModal(this);
   FORM_CATCH

   if (! return_vector.empty())
    CreateLink(txtTask, btnVisitSearch, this, return_vector[0], "tasks");
  }
  else
  {
   // create and show new visit search form
   vector<string> return_vector;
   FORM_TRY
     TformSearchTaskPub * task_search = new TformSearchTaskPub(NULL, &return_vector);
     task_search->ShowTaskModal(this);
   FORM_CATCH

   if (! return_vector.empty())
     CreateLink(txtTask, btnVisitSearch, this, return_vector[0], "tasks");
  }
}
//---------------------------------------------------------------------------
void TformRecordTaskNotes::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordTaskNotes * z = new TformRecordTaskNotes(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

