//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "codePrometheus.h"
#include "codeRecordTaxEntity.h"
#include "codeRecordReferral.h"
#include "codeRecordServiceProvided.h"
#include "codeRecordAppointment.h"
#include "codeRecordTaskCob.h"
#include "codeRecordTaskCobVisit.h"
#include "codeRecordCheck.h"
#include "codeRecordPurchaseReq.h"
#include "codeRecordIncomingBill.h"
#include "codeRecordOutgoingBill.h"
#include "codeRecordTransaction.h"
#include "codeRecordInsurancePolicy.h"
#include "codeRecordTaxAddress.h"
#include "codeSpecialTransactionSummary.h"
#include "codeRecordEntityContract.h"
#include "codeRecordEntityIDs.h"
#include "codeSpecialTransactionDetails.h"  // jhaley
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma link "codeSectionsGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformRecordTaxEntity *formRecordTaxEntity;
//---------------------------------------------------------------------------
__fastcall TformRecordTaxEntity::TformRecordTaxEntity(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("tax_entities")), transactions_summary(this, listTransactions)
{
  fields_to_leave_raw.insert("name");
  if (optionsPermissions["special.beh.general"]["enabled"] != "true")
  {
    lblCare->Enabled = false;
    cboCare->Enabled = false;
    lblServed->Enabled = false;
    cboServed->Enabled = false;
    lblAgency->Enabled = false;
    cboAgency->Enabled = false;
  }

  identifiers_filter.SetListViewHandle(listIdentifiers);
  identifiers_filter.SetSecurity("entity_ids");
  identifiers_filter.AddColumnSpec("ID", "entity_ids", as_text, true, 65, rawString);
  identifiers_filter.AddColumnSpec("Value", "entity_ids", as_text, true, 70, rawString);
  identifiers_filter.AddColumnSpec("Description", "entity_ids", as_text, false, 175, rawString);
  identifiers_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  identifiers_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  identifiers_filter.FetchPreferences("recordtaxentity.identifiers_filter");
  identifiers_filter.SetIconStatus(true);
  identifiers_filter.SetSQLStatement("");
  identifiers_filter.RefreshDataSet();

  services_filter.SetListViewHandle(listServices);
  services_filter.SetSecurity("services_provided");
  services_filter.AddColumnSpec("Service", "services_provided", as_text, true, 150);
  services_filter.AddColumnSpec("Area", "services_provided", as_text, true, 150);
  services_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  services_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  services_filter.FetchPreferences("recordtaxentity.services_filter");
  services_filter.SetIconStatus(true);
  services_filter.SetSQLStatement("");
  services_filter.RefreshDataSet();

  policies_filter.SetListViewHandle(listPolicies);
  policies_filter.SetSecurity("insurance_policies");
  policies_filter.AddColumnSpec("Policy Number", "insurance_policies", as_text, true, 110, rawString);
  policies_filter.AddColumnSpec("Group Number", "insurance_policies", as_text, true, 100, rawString);
  policies_filter.AddColumnSpec("Effective Date", "insurance_policies", as_date, true, 100);
  policies_filter.AddColumnSpec("Termination Date", "insurance_policies", as_date, true, 100);
  policies_filter.AddColumnSpec("Insurance", "insurance_policies", as_text, true, 100);
  policies_filter.AddColumnSpec("Coverage", "insurance_policies", as_text, false, 100);
  policies_filter.AddColumnSpec("Source", "insurance_policies", as_text, false, 100);
  policies_filter.AddColumnSpec("Name on Policy", "insurance_policies", as_text, true, 120);
  policies_filter.AddColumnSpec("BIN #", "insurance_policies", as_text, false, 75, rawString);
  policies_filter.AddColumnSpec("PCN", "insurance_policies", as_text, false, 65, rawString);
  policies_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  policies_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  policies_filter.FetchPreferences("recordtaxentity.filter");
  policies_filter.SetIconStatus(true);
  policies_filter.SetSQLStatement("");
  policies_filter.RefreshDataSet();

  bills_filter.SetListViewHandle (listBills);
  bills_filter.SetSecurity("bills");
  bills_filter.AddColumnSpec("Received Date", "bills", as_date, true, 120);
  bills_filter.AddColumnSpec("Invoice Number", "bills", as_text, true, 120);
  bills_filter.AddColumnSpec("PR Number", "purchase_reqs", as_int, true, 100);
  bills_filter.AddColumnSpec("Employee", "bills", as_date, true, 100);
  bills_filter.AddColumnSpec("Total Charge", "bills", as_double, true, 120, amountString);
  bills_filter.AddColumnSpec("Invoice Amount", "bills", as_double, true, 120, amountString);
  bills_filter.AddColumnSpec("Bill Type", "bills", as_text, true, 100);
  bills_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  bills_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  bills_filter.FetchPreferences("recordtaxentity.bills_filter");
  bills_filter.SetIconStatus(true);
  bills_filter.SetSQLStatement ("");
  bills_filter.RefreshDataSet();

  contracts_filter.SetListViewHandle (listContracts);
  contracts_filter.SetSecurity("entity_contracts");
  contracts_filter.AddColumnSpec("Contract Type", "entity_contracts", as_text, true, 100, prettyString);
  contracts_filter.AddColumnSpec("Start Date", "entity_contracts", as_date, true, 80);
  contracts_filter.AddColumnSpec("Stop Date", "entity_contracts", as_date, true, 80);
  contracts_filter.AddColumnSpec("Terms", "entity_contracts", as_text, true, 120, rawString);
  contracts_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  contracts_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  contracts_filter.FetchPreferences("recordtaxentity.contracts_filter");
  contracts_filter.SetIconStatus(true);
  contracts_filter.SetSQLStatement ("");
  contracts_filter.RefreshDataSet();

  prs_filter.SetListViewHandle (listPrs);
  prs_filter.SetSecurity("purchase_reqs");
  prs_filter.AddColumnSpec("Date Sent", "purchase_reqs", as_date, true, 100);
  prs_filter.AddColumnSpec("PR Number", "purchase_reqs", as_int, true, 120);
  prs_filter.AddColumnSpec("Check Number", "checks", as_int, true, 120);
  prs_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  prs_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  prs_filter.FetchPreferences("recordtaxentity.prs_filter");
  prs_filter.SetIconStatus(true);
  prs_filter.SetSQLStatement ("");
  prs_filter.RefreshDataSet();

  checks_filter.SetListViewHandle(listChecks);
  checks_filter.SetSecurity("checks");
  checks_filter.AddColumnSpec("Date Sent", "checks", as_date, true, 110);
  checks_filter.AddColumnSpec("Check Number", "checks", as_int, true, 130);
  checks_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  checks_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  checks_filter.FetchPreferences("recordtaxentity.checks.filter");
  checks_filter.SetSQLStatement("");
  checks_filter.RefreshDataSet();

  referrals_to_filter.SetListViewHandle(listReferralsTo);
  referrals_to_filter.SetSecurity("referrals");
  referrals_to_filter.AddColumnSpec("Date", "referrals", as_date, true, 90);
  referrals_to_filter.AddColumnSpec("Person", "people", as_text, true, 120);
  referrals_to_filter.AddColumnSpec("Referred By (Facility)", "referrals", as_text, true, 200);
  referrals_to_filter.AddColumnSpec("Referred By (Provider)", "referrals", as_text, true, 200);
  referrals_to_filter.AddColumnSpec("Referred To (Facility)", "referrals", as_text, true, 200);
  referrals_to_filter.AddColumnSpec("Referred To (Provider)", "referrals", as_text, true, 200);
  if (optionsPermissions["special.beh.general"]["enabled"] == "true")
    referrals_to_filter.AddColumnSpec("Reason", "referrals", as_text, false, 100);
  else if (optionsPermissions["special.com.general"]["enabled"] == "true")
    referrals_to_filter.AddColumnSpec("Reason", "referrals", as_text, false, 100);
  else if (optionsPermissions["special.diab.general"]["enabled"] == "true")
    referrals_to_filter.AddColumnSpec("Reason", "referrals", as_text, false, 100);
  referrals_to_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  referrals_to_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  referrals_to_filter.FetchPreferences("recordtaxentity.referrals_to_filter");
  referrals_to_filter.SetIconStatus(true);
  referrals_to_filter.SetSQLStatement("");
  referrals_to_filter.RefreshDataSet();

  referrals_from_filter.SetListViewHandle(listReferralsFrom);
  referrals_from_filter.SetSecurity("referrals");
  referrals_from_filter.AddColumnSpec("Date", "referrals", as_date, true, 90);
  referrals_from_filter.AddColumnSpec("Person", "people", as_text, true, 120);
  referrals_from_filter.AddColumnSpec("Referred By (Facility)", "referrals", as_text, true, 200);
  referrals_from_filter.AddColumnSpec("Referred By (Provider)", "referrals", as_text, true, 200);
  referrals_from_filter.AddColumnSpec("Referred To (Facility)", "referrals", as_text, true, 200);
  referrals_from_filter.AddColumnSpec("Referred To (Provider)", "referrals", as_text, true, 200);
  if (optionsPermissions["special.beh.general"]["enabled"] == "true")
    referrals_from_filter.AddColumnSpec("Reason", "referrals", as_text, false, 100);
  else if (optionsPermissions["special.com.general"]["enabled"] == "true")
    referrals_from_filter.AddColumnSpec("Reason", "referrals", as_text, false, 100);
  else if (optionsPermissions["special.diab.general"]["enabled"] == "true")
    referrals_from_filter.AddColumnSpec("Reason", "referrals", as_text, false, 100);
  referrals_from_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  referrals_from_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  referrals_from_filter.FetchPreferences("recordtaxentity.referrals_from_filter");
  referrals_from_filter.SetIconStatus(true);
  referrals_from_filter.SetSQLStatement("");
  referrals_from_filter.RefreshDataSet();

  appointments_filter.SetListViewHandle (listAppointments);
  appointments_filter.SetSecurity("appointments.people");
  appointments_filter.AddColumnSpec("Date", "appointments", as_date, true, 90/*, repeatingString*/); // DONE: this doesn't sort properly because it's trying to create Pdate objects from a repeating string, not a date!
  appointments_filter.AddColumnSpec("Time", "appointments", as_text, true, 80);
  appointments_filter.AddColumnSpec("Person", "appointments", as_text, true, 120);
  appointments_filter.AddColumnSpec("Description", "appointments", as_text, true, 130, sentenceString);
  appointments_filter.AddColumnSpec("Created For", "appointments", as_text, false, 100);
  appointments_filter.AddColumnSpec("Outcome", "appointments", as_text, false, 90);
  appointments_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  appointments_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  appointments_filter.FetchPreferences("recordtaxentity.appointments_filter");
  appointments_filter.SetIconStatus(true);
  appointments_filter.SetSQLStatement ("");
  appointments_filter.RefreshDataSet();

  cobs_filter.SetListViewHandle(listCOB);
  cobs_filter.SetSecurity("tasks.cob");
  cobs_filter.AddColumnSpec("Person", "people", as_text, true, 140);
  cobs_filter.AddColumnSpec("Date", "tasks", as_date, true, 80);
  cobs_filter.AddColumnSpec("Appt. Date", "appointments", as_date, true, 80);
  cobs_filter.AddColumnSpec("Time", "tasks", as_time, true, 80);
  cobs_filter.AddColumnSpec("COB Number", "tasks", as_int, true, 100);
  cobs_filter.AddColumnSpec("Service", "services_provided", as_text, true, 140);
  cobs_filter.AddColumnSpec("Area", "services_provided", as_text, true, 140);
  cobs_filter.AddColumnSpec("Obligated Amount", "tasks", as_double, true, 130, amountString);
  cobs_filter.AddColumnSpec("Reason", "tasks", as_text, true, 130, rawString);
  cobs_filter.AddColumnSpec("Limits", "tasks", as_text, true, 130, rawString);
  cobs_filter.AddColumnSpec("Preconditions", "tasks", as_text, false, 130, sentenceString);
  cobs_filter.AddColumnSpec("Follow up", "tasks", as_text, false, 130, sentenceString);
  cobs_filter.AddColumnSpec("Reported by", "tasks", as_text, false, 130, sentenceString);
  cobs_filter.AddColumnSpec("Hospitalized", "tasks", as_text, false, 130, prettyBoolString);
  cobs_filter.AddColumnSpec("Given Room", "tasks", as_text, false, 130, prettyBoolString);
  cobs_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  cobs_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  cobs_filter.FetchPreferences("recordtaxentity.cobs_filter");
  cobs_filter.SetSQLStatement("");
  cobs_filter.RefreshDataSet();

  visits_filter.SetListViewHandle (listTasks);
  visits_filter.SetSecurity("tasks");
  visits_filter.AddColumnSpec("Date", "tasks", as_date, true, 90);
  visits_filter.AddColumnSpec("Time", "tasks", as_time, true, 90);
  visits_filter.AddColumnSpec("Person", "people", as_text, true, 120);
  visits_filter.AddColumnSpec("COB Number", "tasks", as_int, true, 80);
  visits_filter.AddColumnSpec("Reason", "tasks", as_text, true, 120, sentenceString);
  visits_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  visits_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  visits_filter.FetchPreferences("recordtaxentity.visits_filter");
  visits_filter.SetIconStatus(true);
  visits_filter.SetSQLStatement ("");
  visits_filter.RefreshDataSet();

  addresses_filter.SetListViewHandle (listAddresses);
  addresses_filter.SetSecurity("tax_addresses");
  addresses_filter.AddColumnSpec("Type", "tax_addresses", as_text, true, 80);
  addresses_filter.AddColumnSpec("Line 1", "tax_addresses", as_text, true, 150, addressString);
  addresses_filter.AddColumnSpec("Line 2", "tax_addresses", as_text, false, 150, addressString);
  addresses_filter.AddColumnSpec("City", "tax_addresses", as_text, true, 100);
  addresses_filter.AddColumnSpec("State", "tax_addresses", as_text, true, 70, uppercaseString);
  addresses_filter.AddColumnSpec("Zip", "tax_addresses", as_text, true, 70, prettyZipString);
  addresses_filter.AddColumnSpec("Country", "tax_addresses", as_text, false, 100);
  addresses_filter.AddColumnSpec("Phone Number", "tax_addresses", as_text, true, 115, prettyPhoneString);
  addresses_filter.AddColumnSpec("Fax Number", "tax_addresses", as_text, true, 135, prettyPhoneString);
  addresses_filter.AddColumnSpec("Email Address", "tax_addresses", as_text, false, 135, lowercaseString);
  addresses_filter.AddColumnSpec("Notes", "tax_addresses", as_text, false, 120, sentenceString);
  addresses_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  addresses_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  addresses_filter.FetchPreferences("recordtaxentity.addresses_filter");
  addresses_filter.SetIconStatus(true);
  addresses_filter.SetSQLStatement ("");
  addresses_filter.RefreshDataSet();

  staticTransactionDetails->Font->Color = link_color;

  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordTaxEntity::ScreenStart()
{
  // register combo box
  lookupTables->RegisterComboBox("tax_entity_types", cboType);
  lookupTables->RegisterComboBox("beh_care_types", cboCare);
  lookupTables->RegisterComboBox("beh_pop_types", cboServed);
  lookupTables->RegisterComboBox("beh_agency_types", cboAgency);

  pageControl->ActivePageIndex = 0;

  TformRecordGeneric::ScreenStart();

  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaxEntity::ScreenStop()
{
  // unregister combo box
  lookupTables->UnregisterComboBox("tax_entity_types", cboType);
  lookupTables->UnregisterComboBox("beh_care_types", cboCare);
  lookupTables->UnregisterComboBox("beh_pop_types", cboServed);
  lookupTables->UnregisterComboBox("beh_agency_types", cboAgency);

  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaxEntity::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxe
  // corrospond to values in that look up table.
  // check to make sure the dates entered are valid
  // give the user a message box and prompt to re-enter if incorrect
  if (! lookupTables->IsInLookUpTable("tax_entity_types", cboType->Text.c_str()))
  {
    PSay("Please enter a valid tax entity type", m_invalid_data, MB_OK);
    cboType->Show();
    cboType->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("beh_care_types", cboCare->Text.c_str()))
  {
    PSay("Please enter a valid type of care", m_invalid_data, MB_OK);
    cboCare->Show();
    cboCare->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("beh_agency_types", cboAgency->Text.c_str()))
  {
    PSay("Please enter a valid agency type", m_invalid_data, MB_OK);
    cboAgency->Show();
    cboAgency->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("beh_pop_types", cboServed->Text.c_str()))
  {
    PSay("Please enter a valid population served", m_invalid_data, MB_OK);
    cboServed->Show();
    cboServed->SetFocus();
    return false;
  }
  else if (StripAll(editName->Text.c_str(), " ") == "")
  {
    int response = PSay("You have attempted to save a tax entity without providing a name.  Contact a programmer immediately for training on how to use record screens correctly.", m_warning, MB_OK);
    return false;
  }

  if (!is_new_record && UppercaseString(editName->Text.c_str()) != UppercaseString(initial_state["name"]))
  {
    int response;
    response = PSay(
               "You have chosen to change this tax entity's name.  This should rarely happen.  Changing an entity's name on this screen will change their name EVERYWHERE.\n\n"
               "Changing a tax entity's name can make it difficult for other people to find them, resulting in the creation of a duplicate.\n"
               "Worse still, it could cause people to attach data to the wrong tax entity, which would be difficult to set right again.\n\n"
               "\nThe following are GOOD reasons to change this tax entity's name:\n\n"
               "Their name has changed, for example, Jane Doe is now Jane Smith.  You might indicate both names so people searching by the old name will also find her.\n\n"
               "You see a mistake or misspelling.\n\n"
               "The name does not follow naming convention, for example, changing 'Dr. John Doe' to 'John Doe, Dr.' or better yet, 'John Doe, MD'\n\n"
               "\nThe following should NOT be done:\n\n"
               "Do NOT change their name to another person entirely, for example, do NOT change 'John Doe' to 'Henrietta Pickenburg'.\n\n"
               "\nIf your intention was to change a link (from this tax entity to a different one), you have come to the WRONG place.  Say NO below, close this screen, and click the SEARCH button INSTEAD of the LINK.\n\n\n"
               "Are you sure you want to change this tax entity's name?", m_warning, MB_YESNO);
    if (response == IDNO)
      return false;
  }

  if (editName->Text.c_str() != initial_state["name"] && editName->Text.c_str() == UppercaseString(editName->Text.c_str()))
  {
    int response;
    response = PSay(
               "You should never use ALL CAPS, unless the entire entity's name is an acronym.\n\n"
               "Is the name you entered an acronym?", m_warning, MB_YESNO, editName->Text.c_str());
    if (response == IDNO)
    {
      editName->Text = PrettyString(editName->Text.c_str()).c_str();
      return false;
    }
  }

  if (editName->Text.c_str() != initial_state["name"] && editName->Text.c_str() == LowercaseString(editName->Text.c_str()))
  {
    // they're just dumb fuckers.  fix it for them and move on.
    initial_state["name"] = PrettyString(initial_state["name"]);
    return true;
  }

  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaxEntity::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  editName->Text = initial_state["name"].c_str();
  cboType->Text = PrettyString(lookupTables->ValueOf("tax_entity_types", initial_state["tax_entity_id"])).c_str();
  editSpecialty->Text = PrettyString(initial_state["specialty"]).c_str();
  cboCare->Text = PrettyString(lookupTables->ValueOf("beh_care_types", initial_state["beh_care_id"])).c_str();
  cboAgency->Text = PrettyString(lookupTables->ValueOf("beh_agency_types", initial_state["beh_agency_id"])).c_str();
  cboServed->Text = PrettyString(lookupTables->ValueOf("beh_pop_types", initial_state["beh_pop_id"])).c_str();
  if(initial_state["is_referring"] == "1")
    checkReferring->Checked = true;
  else
    checkReferring->Checked = false;

  ShowAppropriateControls();

  TformRecordGeneric::PutDataOnScreen();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaxEntity::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  ending_state["name"] = editName->Text.c_str();
  ending_state["tax_entity_id"] = lookupTables->IdOf("tax_entity_types", cboType->Text.c_str());
  ending_state["specialty"] = editSpecialty->Text.c_str();
  ending_state["beh_care_id"] = lookupTables->IdOf("beh_care_types", cboCare->Text.c_str());
  ending_state["beh_agency_id"] = lookupTables->IdOf("beh_agency_types", cboAgency->Text.c_str());
  ending_state["beh_pop_id"] = lookupTables->IdOf("beh_pop_types", cboServed->Text.c_str());
  if(checkReferring->Checked)
    ending_state["is_referring"] = "1";
  else
    ending_state["is_referring"] = "0";

  if(is_new_record)
  {
    ending_state["billing_address_id"] = "0";
    ending_state["physical_address_id"] = "0";
  }

  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();

  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaxEntity::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  panelGroup2->Enabled = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaxEntity::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  panelGroup2->Enabled = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTaxEntity::NotNewAnymore()
{
  string sql;

  if(optionsPermissions["table.entity_ids"]["view"] == "true")
  {
    sql = "select entity_id_types.item, entity_ids.identifier, entity_id_types.description, entity_ids.current_id, entity_ids.id "
          "from entity_ids inner join entity_id_types on entity_ids.entity_id_id = entity_id_types.id "
          "where entity_ids.tax_entity_id = " + initial_state["id"];
    identifiers_filter.SetSQLStatement(sql);
    identifiers_filter.RefreshDataSet();
    identifiers_filter.SetAddEdit(this, AddRecord(&(TformRecordTaxEntity::AddIdentifier)),
                                  EditRecord(&(TformRecordTaxEntity::EditIdentifier)));
    identifiers_request = atlas->RequestNotificationWhen("entity_ids.tax_entity_id", initial_state["id"], rel_e, as_int, this,
                       RefreshHandler(&(TformRecordTaxEntity::AtlasRefreshListViews)));
  }

  if(optionsPermissions["table.services_provided"]["view"] == "true")
  {
    sql = "select service_types.item, area_types.item, services_provided.current_id, "
          "services_provided.id "
          "from services_provided inner join service_types on services_provided.service_id = service_types.id "
          "inner join area_types on services_provided.area_id = area_types.id "
          "where services_provided.tax_entity_id = " + initial_state["id"];
    services_filter.SetSQLStatement(sql);
    services_filter.RefreshDataSet();
    services_filter.SetAddEdit(this, AddRecord(&(TformRecordTaxEntity::AddService)),
                                  EditRecord(&(TformRecordTaxEntity::EditService)));
    services_request = atlas->RequestNotificationWhen("services_provided.tax_entity_id", initial_state["id"], rel_e, as_int, this,
                       RefreshHandler(&(TformRecordTaxEntity::AtlasRefreshListViews)));
  }

  if(optionsPermissions["table.bills"]["view"] == "true")
  {
    sql = "select bills.bill_date, bills.invoice_number, purchase_reqs.purchase_req_number, "
          "users.item, bills.total_charge, bills.invoice_amount, bill_types.item, bills.current_id, bills.id "
          "from bills inner join purchase_reqs on bills.purchase_req_id = purchase_reqs.id "
          "inner join users on bills.user_id = users.id "
          "inner join bill_types on bills.bill_id = bill_types.id "
          "where bills.actual_tax_id = " + initial_state["id"];
    bills_filter.SetSQLStatement (sql);
    bills_filter.RefreshDataSet();
    bills_filter.SetAddEdit(this, NULL, EditRecord(&(TformRecordTaxEntity::EditBill)));
    bills_request = atlas->RequestNotificationWhen("bills.actual_tax_id", initial_state["id"], rel_e, as_int, this,
                       RefreshHandler(&(TformRecordTaxEntity::AtlasRefreshListViews)));
  }

  if(optionsPermissions["table.entity_contracts"]["view"] == "true")
  {
    sql = "select entity_contract_types.item, entity_contracts.start_date, entity_contracts.stop_date, entity_contracts.terms, entity_contracts.current_id, entity_contracts.id "
          "from entity_contracts "
          "inner join entity_contract_types on entity_contracts.entity_contract_id = entity_contract_types.id "
          "where entity_contracts.tax_entity_id = " + initial_state["id"];
    contracts_filter.SetSQLStatement (sql);
    contracts_filter.RefreshDataSet();
    contracts_filter.SetAddEdit(this, AddRecord(&(TformRecordTaxEntity::AddContract)), EditRecord(&(TformRecordTaxEntity::EditContract)));
    contracts_request = atlas->RequestNotificationWhen("entity_contracts.tax_entity_id", initial_state["id"], rel_e, as_int, this,
                       RefreshHandler(&(TformRecordTaxEntity::AtlasRefreshListViews)));
  }

  if(optionsPermissions["table.insurance_policies"]["view"] == "true")
  {
    sql = "select insurance_policies.policy_number, insurance_policies.group_number, "
          "insurance_policies.start_date, insurance_policies.stop_date, insurance_types.item, coverage_types.item, "
          "source_types.item, insurance_policies.name_on_policy, insurance_policies.bin_number, insurance_policies.processor_control_number, "
          "insurance_policies.current_id, insurance_policies.id "
          "from insurance_policies inner join coverage_types on insurance_policies.coverage_id = coverage_types.id "
          "inner join source_types on insurance_policies.source_id = source_types.id "
          "inner join insurance_types on insurance_policies.insurance_id = insurance_types.id "
          "where insurance_policies.tax_entity_id = " + initial_state["id"];
    policies_filter.SetSQLStatement (sql);
    policies_filter.RefreshDataSet();
    policies_filter.SetAddEdit(this, AddRecord(&(TformRecordTaxEntity::AddPolicy)),
                               EditRecord(&(TformRecordTaxEntity::EditPolicy)));
    policies_request = atlas->RequestNotificationWhen("insurance_policies.tax_entity_id", initial_state["id"], rel_e, as_int, this,
                       RefreshHandler(&(TformRecordTaxEntity::AtlasRefreshListViews)));
  }

  if(optionsPermissions["table.transactions"]["view"] == "true")
  {
    // jhaley: populate transactions summary list view
    transactions_summary.SetSQLStatement("select * from transactions where tax_entity_id = " + initial_state["id"]);
    transactions_summary.SetRecord("tax_entities", initial_state["id"], "tax_entity_id", RefreshHandler(&(TformRecordTaxEntity::AtlasRefreshListViews)));
  }

  if(optionsPermissions["table.purchase_reqs"]["view"] == "true")
  {
    sql = "select purchase_reqs.date_sent, purchase_reqs.purchase_req_number, checks.check_number, "
          "purchase_reqs.current_id, purchase_reqs.id "
          "from purchase_reqs inner join checks on purchase_reqs.check_id = checks.id "
          "where purchase_reqs.tax_entity_id = " + initial_state["id"];
    prs_filter.SetSQLStatement(sql);
    prs_filter.RefreshDataSet();
    prs_filter.SetAddEdit(this, NULL, EditRecord(&(TformRecordTaxEntity::EditPr)));
    prs_request = atlas->RequestNotificationWhen("purchase_reqs.tax_entity_id", initial_state["id"], rel_e, as_int, this,
                       RefreshHandler(&(TformRecordTaxEntity::AtlasRefreshListViews)));
  }

  if(optionsPermissions["table.checks"]["view"] == "true")
  {
    sql = "select checks.date_sent, checks.check_number, checks.current_id, checks.id from checks where "
          "checks.tax_entity_id = " + initial_state["id"];
    checks_filter.SetSQLStatement(sql);
    checks_filter.RefreshDataSet();
    checks_filter.SetAddEdit(this, NULL, EditRecord(&(TformRecordTaxEntity::EditCheck)));
    checks_request = atlas->RequestNotificationWhen("checks.tax_entity_id", initial_state["id"], rel_e, as_int, this,
                       RefreshHandler(&(TformRecordTaxEntity::AtlasRefreshListViews)));
  }

  if(optionsPermissions["table.referrals"]["view"] == "true")
  {
    sql = "select referrals.date_of_referral, person_names.last_name || ', ' || person_names.first_name, "
          "a.name, b.name, c.name, d.name, referral_reason_types.item, "
          "referrals.current_id, referrals.id "
          "from referrals inner join tax_entities a on referrals.by_facility_id = a.id "
          "inner join tax_entities b on referrals.by_provider_id = b.id "
          "inner join tax_entities c on referrals.to_facility_id = c.id "
          "inner join tax_entities d on referrals.to_provider_id = d.id "
          "inner join referral_reason_types on referrals.referral_reason_id = referral_reason_types.id "
          "inner join people on referrals.person_id = people.id "
          "left join person_names on people.person_names_id = person_names.id "
          "where (referrals.to_provider_id = " + initial_state["id"] + " or "
          "referrals.to_facility_id = " + initial_state["id"] + ")";
    referrals_to_filter.SetSQLStatement (sql);
    referrals_to_filter.RefreshDataSet();
    referrals_to_filter.SetAddEdit(this, AddRecord(&(TformRecordTaxEntity::AddReferralTo)),
                                  EditRecord(&(TformRecordTaxEntity::EditReferralTo)));
    referrals_to_request1 = atlas->RequestNotificationWhen("referrals.to_provider_id", initial_state["id"], rel_e, as_int, this,
                           RefreshHandler(&(TformRecordTaxEntity::AtlasRefreshListViews)));
    referrals_to_request2 = atlas->RequestNotificationWhen("referrals.to_facility_id", initial_state["id"], rel_e, as_int, this,
                           RefreshHandler(&(TformRecordTaxEntity::AtlasRefreshListViews)));

    sql = "select referrals.date_of_referral, person_names.last_name || ', ' || person_names.first_name, "
          "a.name, b.name, c.name, d.name, referral_reason_types.item, "
          "referrals.current_id, referrals.id "
          "from referrals inner join tax_entities a on referrals.by_facility_id = a.id "
          "inner join tax_entities b on referrals.by_provider_id = b.id "
          "inner join tax_entities c on referrals.to_facility_id = c.id "
          "inner join tax_entities d on referrals.to_provider_id = d.id "
          "inner join referral_reason_types on referrals.referral_reason_id = referral_reason_types.id "
          "inner join people on referrals.person_id = people.id "
          "left join person_names on people.person_names_id = person_names.id "
          "where (referrals.by_provider_id = " + initial_state["id"] + " or "
          "referrals.by_facility_id = " + initial_state["id"] + ")";
    referrals_from_filter.SetSQLStatement (sql);
    referrals_from_filter.RefreshDataSet();
    referrals_from_filter.SetAddEdit(this, AddRecord(&(TformRecordTaxEntity::AddReferralFrom)),
                               EditRecord(&(TformRecordTaxEntity::EditReferralFrom)));
    referrals_from_request1 = atlas->RequestNotificationWhen("referrals.by_provider_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordTaxEntity::AtlasRefreshListViews)));
    referrals_from_request2 = atlas->RequestNotificationWhen("referrals.by_facility_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordTaxEntity::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.appointments.people"]["view"] == "true")
  {
    sql = // "select appointments.repeating_string || '|' || appointments.begin_date || '|' || appointments.end_date, "
          "select appointments.begin_date, "
          "appointments.appointment_time, "
          "person_names.last_name || ', ' || person_names.first_name, "
          "appointments.description, "
          "users.item, visit_outcome_types.item, appointments.current_id, appointments.id "
          "from appointments inner join users on appointments.created_for = users.id "
          "inner join visit_outcome_types on appointments.visit_outcome_id = visit_outcome_types.id "
          "inner join people on appointments.person_id = people.id "
          "left join person_names on people.person_names_id = person_names.id "
          "where appointments.tax_entity_id = " + initial_state["id"];
    appointments_filter.SetSQLStatement (sql);
    appointments_filter.RefreshDataSet();
    appointments_filter.SetAddEdit(this, NULL, EditRecord(&(TformRecordTaxEntity::EditAppointment)));
    appointments_request = atlas->RequestNotificationWhen("appointments.tax_entity_id", initial_state["id"], rel_e, as_int, this,
                          RefreshHandler(&(TformRecordTaxEntity::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.tasks.cob"]["view"] == "true")
  {
    // jhaley 20100818: table alias 'A' must be used throughout for Firebird 2.x compliance
    sql = "select "
          "person_names.last_name || ', ' || person_names.first_name, "
          "tasks.date_of_task, A.appointment_date, tasks.time_of_task, tasks.cob_number, "
          "service_types.item, area_types.item, sum(transactions.credit_amount - transactions.debit_amount), "
          "tasks.task_comments, tasks.visit_comments, tasks.preconditions_note, tasks.followup_note, "
          "tasks.reported_by_note, tasks.hospitalized, tasks.given_room, tasks.current_id, tasks.id "
          "from "
          "tasks "
          "inner join services_provided on tasks.services_provided_id = services_provided.id "
          "inner join tax_entities on services_provided.tax_entity_id = tax_entities.id "
          "left join transactions on transactions.task_id = tasks.id and "
            "transactions.account_id in (select accounts.id from accounts where accounts.account_type_id = 3) "
          "left join people on tasks.person_id = people.id "
          "left join person_names on person_names.id = people.person_names_id "
          "left join service_types on services_provided.service_id = service_types.id "
          "left join area_types on services_provided.area_id = area_types.id "
          "left join appointments A on A.id = (select first 1 IA.id from appointments IA where IA.task_id = tasks.id and IA.current_id >= 3 order by IA.appointment_date desc) "
          "where "
          "tasks.group_id = " + lookupTables->IdOf("groups", "Contract Health") + " and "
          "tasks.services_provided_id > 0 and "
          "services_provided.tax_entity_id = '" + initial_state["id"] + "' "
          // "and appointments.current_id >= 3 "
          "group by "
          "person_names.last_name, person_names.first_name, tasks.date_of_task, A.appointment_date, "
          "tasks.time_of_task, tasks.cob_number, service_types.item, area_types.item, tasks.task_comments, "
          "tasks.visit_comments, tasks.preconditions_note, tasks.followup_note, tasks.reported_by_note, "
          "tasks.hospitalized, tasks.given_room, tasks.current_id, tasks.id";

    cobs_filter.SetSQLStatement(sql);
    cobs_filter.RefreshDataSet();
    cobs_filter.SetAddEdit(this, NULL, EditRecord(&(TformRecordTaxEntity::EditCob)));
    cobs_request = atlas->RequestNotificationWhen("tasks.tax_entity_id", initial_state["id"], rel_e, as_int, this,
                                 RefreshHandler(&(TformRecordTaxEntity::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.tasks.cob"]["view"] == "true")
  {
    // TODO -c HACK: actually, not really, just some interesting optimization of the PLAN by manipulating the SQL
    // this version actually worked quickly on both local and remote copies,
    // whereas the old one for some reason was optimizing well locally but not remotely. better? hopefully?
    // (had to put the "id" thing in the first join to make it start with tax entities rather than "all visits" or
    // "all people")
    sql = "select visit.date_of_task, visit.time_of_task, person_names.last_name || ', ' || person_names.first_name, "
          "cob.cob_number, visit.task_comments, visit.current_id, visit.id "
          "from tax_entities "
          "inner join tasks visit on tax_entities.id = " + initial_state["id"] + " and visit.tax_entity_id = tax_entities.id "
          "inner join people on people.id = visit.person_id "
          "inner join tasks cob on cob.id = visit.parent_task_id "
          "left join person_names on people.person_names_id = person_names.id "
          "where "
          "visit.group_id = " + lookupTables->IdOf("groups", "Contract Health") + " and "
          "visit.parent_task_id > 0 and "
          "visit.services_provided_id = 0";

    visits_filter.SetSQLStatement(sql); // was disabled -- seems to be working okay? what the ... ?
    visits_filter.RefreshDataSet();     // was disabled
    visits_filter.SetAddEdit(this, NULL, EditRecord(&(TformRecordTaxEntity::EditVisit)));
    visits_request = atlas->RequestNotificationWhen("tasks.tax_entity_id", initial_state["id"], rel_e, as_int, this,
                                 RefreshHandler(&(TformRecordTaxEntity::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.tax_addresses"]["view"] == "true")
  {
    sql = "select tax_address_types.item, tax_addresses.line1, tax_addresses.line2, "
          "tax_addresses.city, state_types.abbreviation, tax_addresses.zip, country_types.item, "
          "tax_addresses.phone_number, tax_addresses.fax_number, tax_addresses.email_address, tax_addresses.notes, "
          "tax_addresses.current_id, tax_addresses.id "
          "from tax_addresses inner join state_types on tax_addresses.state_id = state_types.id "
          "inner join country_types on tax_addresses.country_id = country_types.id "
          "inner join tax_address_types on tax_addresses.tax_address_id = tax_address_types.id "
          "where tax_addresses.tax_entity_id = " + initial_state["id"];
    addresses_filter.SetSQLStatement(sql);
    addresses_filter.RefreshDataSet();
    addresses_filter.SetAddEdit(this, AddRecord(&(TformRecordTaxEntity::AddAddress)), EditRecord(&(TformRecordTaxEntity::EditAddress)));
    addresses_request = atlas->RequestNotificationWhen("tax_addresses.tax_entity_id", initial_state["id"], rel_e, as_int, this,
                        RefreshHandler(&(TformRecordTaxEntity::AtlasRefreshListViews)));
  }
  staticTransactionDetails->Enabled = true;

  TformRecordGeneric::NotNewAnymore();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::AtlasRefreshListViews(int request_num, string matched_value)
{
  if(request_num == identifiers_request)
    identifiers_filter.RefreshDataSet();
  if(request_num == services_request)
    services_filter.RefreshDataSet();
  else if(request_num == policies_request)
    policies_filter.RefreshDataSet();
  else if(request_num == bills_request)
    bills_filter.RefreshDataSet();
  else if(request_num == contracts_request)
    contracts_filter.RefreshDataSet();
  else if(request_num == checks_request)
    checks_filter.RefreshDataSet();
  else if(request_num == prs_request)
    prs_filter.RefreshDataSet();
  else if((request_num == referrals_to_request1) || (request_num == referrals_to_request2))
    referrals_to_filter.RefreshDataSet();
  else if((request_num == referrals_from_request1) || (request_num == referrals_from_request2))
    referrals_from_filter.RefreshDataSet();
  else if(request_num == cobs_request)
    cobs_filter.RefreshDataSet();
  else if(request_num == visits_request)
    visits_filter.RefreshDataSet();
  else if(request_num == appointments_request)
    appointments_filter.RefreshDataSet();
  else if(request_num == addresses_request)
    addresses_filter.RefreshDataSet();
  else // jhaley: refresh transaction summary
    transactions_summary.AtlasRefresh(request_num, matched_value);
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::AddAddress()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["tax_entity_id"] = initial_state["id"];
  FORM_TRY
    TformRecordTaxAddress * addressRecord = new TformRecordTaxAddress(NULL, temp_map);
    addressRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::EditAddress()
{
  map<string,string> temp_map;
  temp_map["id"] = addresses_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordTaxAddress * addressRecord = new TformRecordTaxAddress(NULL, temp_map);
    addressRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::AddIdentifier()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["tax_entity_id"] = initial_state["id"];
  FORM_TRY
    TformRecordEntityIDs * identifierRecord = new TformRecordEntityIDs(NULL, temp_map);
    identifierRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::EditIdentifier()
{
  map<string,string> temp_map;
  temp_map["id"] = identifiers_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordEntityIDs * identifierRecord = new TformRecordEntityIDs(NULL, temp_map);
    identifierRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::AddService()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["tax_entity_id"] = initial_state["id"];
  FORM_TRY
    TformRecordServiceProvided * serviceRecord = new TformRecordServiceProvided(NULL, temp_map);
    serviceRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::EditService()
{
  map<string,string> temp_map;
  temp_map["id"] = services_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordServiceProvided * serviceRecord = new TformRecordServiceProvided(NULL, temp_map);
    serviceRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::AddPolicy()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["tax_entity_id"] = initial_state["id"];
  FORM_TRY
    TformRecordInsurancePolicy * policyRecord = new TformRecordInsurancePolicy(NULL, temp_map);
    policyRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::EditPolicy()
{
  map<string,string> temp_map;
  temp_map["id"] = policies_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordInsurancePolicy * policyRecord = new TformRecordInsurancePolicy(NULL, temp_map);
    policyRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::EditBill()
{
  map<string, string> temp_map;
  temp_map["id"] = bills_filter.GetSelectedRecordID();
  string bill_id = GetOneField(dbDatabase, "select bill_id from bills where id = " + temp_map["id"]);
  if((bill_id == lookupTables->IdOf("bill_types", "incoming provider bill")) ||
     (bill_id == lookupTables->IdOf("bill_types", "incoming vendor bill")))
  {
    FORM_TRY
      TformRecordIncomingBill * in_bill = new TformRecordIncomingBill(NULL, temp_map);
      in_bill->Show();
    FORM_CATCH
  }
  else if(bill_id == lookupTables->IdOf("bill_types", "outgoing provider bill"))
  {
    FORM_TRY
      TformRecordOutgoingBill * out_bill = new TformRecordOutgoingBill(NULL, temp_map);
      out_bill->Show();
    FORM_CATCH
  }
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::EditContract()
{
  DefaultAction(contracts_filter.GetSelectedRecordID(), "entity_contracts");
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::AddContract()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["tax_entity_id"] = initial_state["id"];
  FORM_TRY
    TformRecordEntityContract * new_contract = new TformRecordEntityContract(NULL, temp_map);
    new_contract->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::EditTransaction()
{
  /*
  // TODO: jhaley - not used any more
  map<string, string> temp_map;
  temp_map["id"] = transactions_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordTransaction * view_transaction = new TformRecordTransaction(NULL, temp_map);
    view_transaction->Show();
  FORM_CATCH
  */
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::EditCheck()
{
  map<string, string> temp_map;
  temp_map["id"] = checks_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordCheck * check_record = new TformRecordCheck(NULL, temp_map);
    check_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::EditPr()
{
  map<string, string> temp_map;
  temp_map["id"] = prs_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordPurchaseReq * pr_record = new TformRecordPurchaseReq(NULL, temp_map);
    pr_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::AddReferralTo()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["to_provider_id"] = initial_state["id"];
  FORM_TRY
    TformRecordReferral * referralRecord = new TformRecordReferral(NULL, temp_map);
    referralRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::EditReferralTo()
{
  map<string,string> temp_map;
  temp_map["id"] = referrals_to_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordReferral * referralRecord = new TformRecordReferral(NULL, temp_map);
    referralRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::AddReferralFrom()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["by_provider_id"] = initial_state["id"];
  FORM_TRY
    TformRecordReferral * referralRecord = new TformRecordReferral(NULL, temp_map);
    referralRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::EditReferralFrom()
{
  map<string,string> temp_map;
  temp_map["id"] = referrals_from_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordReferral * referralRecord = new TformRecordReferral(NULL, temp_map);
    referralRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::EditCob()
{
  map<string,string> temp_map;
  temp_map["id"] = cobs_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordTaskCob * cobRecord = new TformRecordTaskCob(NULL, temp_map);
    cobRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::EditVisit()
{
  map<string,string> temp_map;
  temp_map["id"] = visits_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordTaskCobVisit * visitRecord = new TformRecordTaskCobVisit(NULL, temp_map);
    visitRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::EditAppointment()
{
  map<string,string> temp_map;
  temp_map["id"] = appointments_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordAppointment * appointmentRecord = new TformRecordAppointment(NULL, temp_map);
    appointmentRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
bool TformRecordTaxEntity::IsNewAgain()
{
  identifiers_filter.SetSQLStatement(string(""));
  identifiers_filter.RefreshDataSet();
  services_filter.SetSQLStatement(string(""));
  services_filter.RefreshDataSet();
  services_filter.SetAddEdit(this, NULL, NULL);
  referrals_to_filter.SetSQLStatement(string(""));
  referrals_to_filter.RefreshDataSet();
  referrals_to_filter.SetAddEdit(this, NULL, NULL);
  referrals_from_filter.SetSQLStatement(string(""));
  referrals_from_filter.RefreshDataSet();
  referrals_from_filter.SetAddEdit(this, NULL, NULL);
  appointments_filter.SetSQLStatement(string(""));
  appointments_filter.RefreshDataSet();
  appointments_filter.SetAddEdit(this, NULL, NULL);
  cobs_filter.SetSQLStatement(string(""));
  cobs_filter.RefreshDataSet();
  cobs_filter.SetAddEdit(this, NULL, NULL);
  visits_filter.SetSQLStatement(string(""));
  visits_filter.RefreshDataSet();
  visits_filter.SetAddEdit(this, NULL, NULL);
  checks_filter.SetSQLStatement(string(""));
  checks_filter.RefreshDataSet();
  checks_filter.SetAddEdit(this, NULL, NULL);
  prs_filter.SetSQLStatement(string(""));
  prs_filter.RefreshDataSet();
  prs_filter.SetAddEdit(this, NULL, NULL);
  bills_filter.SetSQLStatement(string(""));
  bills_filter.RefreshDataSet();
  bills_filter.SetAddEdit(this, NULL, NULL);
  contracts_filter.SetSQLStatement(string(""));
  contracts_filter.RefreshDataSet();
  contracts_filter.SetAddEdit(this, NULL, NULL);
  policies_filter.SetSQLStatement(string(""));
  policies_filter.RefreshDataSet();
  policies_filter.SetAddEdit(this, NULL, NULL);
  addresses_filter.SetSQLStatement(string(""));
  addresses_filter.RefreshDataSet();
  addresses_filter.SetAddEdit(this, NULL, NULL);
  // jhaley - transaction summary
  transactions_summary.Clear();

  TformRecordGeneric::IsNewAgain();
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordTaxEntity::staticTransactionDetailsClick(TObject *Sender)
{
  // jhaley 20100907: Launch new details form rather than summary (summary is now on the form)
  if (optionsPermissions["table.transactions"]["view"] == "true")
  {
    string sql = "select transactions.effective_date, transactions.fiscal_date, accounts.name, account_types.item, transactions.note, "
                 "transactions.debit_amount, transactions.credit_amount, transactions.transaction_number,  "
                 "transactions.current_id, transactions.id "
                 "from transactions "
                 "inner join accounts on transactions.account_id = accounts.id "
                 "inner join account_types on accounts.account_type_id = account_types.id "
                 "where transactions.tax_entity_id = " + initial_state["id"];

    TformSpecialTransactionDetails *details = NULL;
    FORM_TRY
      details = new TformSpecialTransactionDetails(NULL, initial_state["id"], "tax_entity_id");
    FORM_CATCH
    details->Filter->AddColumnSpec("Eff. Date",   "transactions", as_date,   true,   80);
    details->Filter->AddColumnSpec("Fisc. Date",  "transactions", as_date,   true,   75);
    details->Filter->AddColumnSpec("Account",     "accounts",     as_text,   true,  140);
    details->Filter->AddColumnSpec("Type",        "accounts",     as_text,   true,   75);
    details->Filter->AddColumnSpec("Note",        "transactions", as_text,   false, 140, sentenceString);
    details->Filter->AddColumnSpec("Debit",       "transactions", as_double, true,   75, nonzeroAmountString);
    details->Filter->AddColumnSpec("Credit",      "transactions", as_double, true,   75, nonzeroAmountString);
    details->Filter->AddColumnSpec("Trans #",     "transactions", as_int,    true,   75);
    details->Filter->AddColumnSpec("Current Id",  "current_id",   as_int,    false,  80);
    details->Filter->AddColumnSpec("Internal Id", "internal_id",  as_int,    false,  80);
    details->Filter->FetchPreferences("recordtaxentity.transactions_filter");
    details->Execute(sql);
    details->Show();
  }
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordTaxEntity * z = new TformRecordTaxEntity(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordTaxEntity::cboTypeChange(TObject *Sender)
{
  ShowAppropriateControls();
}
//---------------------------------------------------------------------------
void TformRecordTaxEntity::ShowAppropriateControls()
{
  // start by making all non-general tabs (Tag==0) etc. invisible
  for (int i = 0; i < pageControl->PageCount; i++)
    if (pageControl->Pages[i]->Tag != 0)
      pageControl->Pages[i]->TabVisible = false;
  lblName->Visible = false;
  editName->Visible = false;
  panelBilling->Visible = false;
  panelAddresses->Visible = false;

  if (lookupTables->IsInLookUpTable("tax_entity_types", cboType->Text.c_str()) && cboType->Text != "")
  {
    int to_enable;
    // now determine which non-general ones (Tab > 0) to enable based on ... stuff
    if (cboType->Text == "Insurance Company")
      to_enable = 2;
    else
      to_enable = 1;

    // and enable them
    for (int i = 0; i < pageControl->PageCount; i++)
      if (pageControl->Pages[i]->Tag == to_enable)
        pageControl->Pages[i]->TabVisible = true;

    // insurance companies get a chunk of the general tab disabled
    if (to_enable != 2)
      panelBilling->Visible = true;

    // if we have a valid tax entity type then enable this stuff too
    lblName->Visible = true;
    editName->Visible = true;
    panelAddresses->Visible = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordTaxEntity::FormClose(TObject *Sender, TCloseAction &Action)
{
  TformRecordGeneric::FormClose(Sender, Action);
  transactions_summary.Close(Action); // jhaley
}
//---------------------------------------------------------------------------
// jhaley 20100910: Added checkbox to control transactions summary grouping
void __fastcall TformRecordTaxEntity::checkBeforeShowAccountClick(TObject *Sender)
{
  transactions_summary.SetShowAccount(checkBeforeShowAccount->Checked); // set state
  transactions_summary.CheckBoxClicked();                               // refresh it
}
//---------------------------------------------------------------------------

