//---------------------------------------------------------------------------

#ifndef codeRecordTaxEntityH
#define codeRecordTaxEntityH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeRecordGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <Menus.hpp>
#include "codeRubberContainer.h"
#include "codeSpecialTransactionSummary.h"
//---------------------------------------------------------------------------
class TformRecordTaxEntity : public TformRecordGeneric
{
__published:	// IDE-managed Components
        TPageControl *pageControl;
        TTabSheet *sheetGeneral;
        TTabSheet *sheetPolicies;
        TTabSheet *sheetBills;
        TTabSheet *sheetChecks;
        TTabSheet *sheetReferrals;
        TTabSheet *sheetAppointmenst;
        TLabel *lblPolicies;
        TLabel *lblBills;
        TLabel *lblTransactions;
        TLabel *lblPrs;
        TLabel *lblChecks;
        TLabel *lblReferrals;
        TLabel *lblAppointments;
        TLabel *lblTasks;
        TLabel *lblTo;
        TLabel *Label1;
        TLabel *Label2;
        TStaticText *staticTransactionDetails;
        TPanel *panelGroup;
        TLabel *lblType;
        TComboBox *cboType;
        TLabel *lblName;
        TEdit *editName;
        TPanel *panelBilling;
        TPanel *panelAddresses;
        TLabel *lblAddresses;
        TLabel *lblServices;
        TLabel *lblProvided;
        TPanel *panelGroup2;
        TLabel *lblSpecialty;
        TLabel *lblCare;
        TLabel *lblServed;
        TLabel *lblAgency;
        TLabel *lblReferring;
        TEdit *editSpecialty;
        TCheckBox *checkReferring;
        TComboBox *cboCare;
        TComboBox *cboServed;
        TComboBox *cboAgency;
        TLabel *Label3;
        TRubberContainer *rubberServices;
        TListView *listServices;
        TRubberContainer *rubberAddresses;
        TListView *listAddresses;
        TRubberContainer *rubberBills;
        TListView *listBills;
        TRubberContainer *rubberContracts;
        TListView *listContracts;
        TRubberContainer *rubberTransactions;
        TListView *listTransactions;
        TRubberContainer *rubberPRs;
        TListView *listPrs;
        TRubberContainer *rubberChecks;
        TListView *listChecks;
        TRubberContainer *rubberReferTo;
        TListView *listReferralsTo;
        TRubberContainer *rubberReferFrom;
        TListView *listReferralsFrom;
        TRubberContainer *rubberAppointments;
        TListView *listAppointments;
        TRubberContainer *rubberCOBVisits;
        TListView *listTasks;
        TRubberContainer *rubberPolicies;
        TListView *listPolicies;
        TRubberContainer *rubberCOB;
        TListView *listCOB;
        TLabel *lblCOB;
        TLabel *lblIdentifiers;
        TRubberContainer *rubberIdentifiers;
        TListView *listIdentifiers;
        TCheckBox *checkBeforeShowAccount;
        void __fastcall staticTransactionDetailsClick(TObject *Sender);
        void __fastcall cboTypeChange(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall checkBeforeShowAccountClick(TObject *Sender);
private:	// User declarations
        classFilterObject identifiers_filter;
        int identifiers_request;
        classFilterObject services_filter;
        int services_request;
        classFilterObject policies_filter;
        int policies_request;
        classFilterObject bills_filter;
        int bills_request;
        classFilterObject contracts_filter;
        int contracts_request;
        //classFilterObject transactions_filter;
        //int transactions_request;
        classFilterObject checks_filter;
        int checks_request;
        classFilterObject prs_filter;
        int prs_request;
        classFilterObject referrals_to_filter;
        int referrals_to_request1;
        int referrals_to_request2;
        classFilterObject referrals_from_filter;
        int referrals_from_request1;
        int referrals_from_request2;
        classFilterObject cobs_filter;
        int cobs_request;
        classFilterObject visits_filter;
        int visits_request;
        classFilterObject appointments_filter;
        int appointments_request;
        classFilterObject addresses_filter;
        int addresses_request;
        classTransactionSummarizer transactions_summary; // jhaley
        void ShowAppropriateControls();
public:		// User declarations
        __fastcall TformRecordTaxEntity(TComponent* Owner, map<string,string> p_parameters);
        bool IsValidOnScreen();
        bool PutDataOnScreen();
        bool GetDataFromScreen();
        bool ScreenStart();
        bool ScreenStop();
        bool ScreenLock();
        bool ScreenUnlock();
        bool NotNewAnymore();
        void AtlasRefreshListViews(int request_num, string matched_value);
        void AddService();
        void EditService();
        void AddIdentifier();
        void EditIdentifier();
        void AddPolicy();
        void EditPolicy();
        void EditBill();
        void EditContract();
        void AddContract();
        void EditTransaction();
        void EditCheck();
        void EditPr();
        void AddReferralTo();
        void EditReferralTo();
        void AddReferralFrom();
        void EditReferralFrom();
        void EditCob();
        void EditVisit();
        void EditAppointment();
        bool IsNewAgain();
        void AddAddress();
        void EditAddress();
        static void Do(map<string, string> & p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformRecordTaxEntity *formRecordTaxEntity;
//---------------------------------------------------------------------------
#endif
