//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordToDo.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordToDo *formRecordToDo;
//---------------------------------------------------------------------------
__fastcall TformRecordToDo::TformRecordToDo(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("todo"))
{
 Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordToDo::ScreenStart()
{
  // register combo box
  lookupTables->RegisterComboBox("priority_types", cboPriority);
  lookupTables->RegisterComboBox("todo_status_types", cboStatus);


  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordToDo::ScreenStop()
{
  // unregister combo box
  lookupTables->UnregisterComboBox("priority_types", cboPriority);
  lookupTables->UnregisterComboBox("todo_status_types", cboStatus);

  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordToDo::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxe
  // corrospond to values in that look up table.
  // check to make sure the dates entered are valid
  // give the user a message box and prompt to re-enter if incorrect
  if (! lookupTables->IsInLookUpTable("priority_types", cboPriority->Text.c_str()))
  {
    PSay("Please enter a valid priority", m_invalid_data, MB_OK);
    cboPriority->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("todo_status_types", cboStatus->Text.c_str()))
  {
    PSay("Please enter a valid status", m_invalid_data, MB_OK);
    cboStatus->SetFocus();
    return false;
  }
  else if (! Pdate (editDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editDate->Text == ""))
  {
    PSay("Please enter a valid due date", m_invalid_data, MB_OK);
    editDate->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformRecordToDo::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  editDate->Text = initial_state["due_date"].c_str();
  cboPriority->Text = PrettyString(lookupTables->ValueOf("priority_types", initial_state["priority_id"])).c_str();
  cboStatus->Text = PrettyString(lookupTables->ValueOf("todo_status_types", initial_state["todo_status_id"])).c_str();
  editItem->Text = SentenceString(initial_state["item"]).c_str();

  TformRecordGeneric::PutDataOnScreen();
  return true; // what can really go wrong?
}
//---------------------------------------------------------------------------
bool TformRecordToDo::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  if(editDate->Text != "")
    ending_state["due_date"] = Pdate (editDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy);
  else
    ending_state["due_date"] = "";
  ending_state["priority_id"] = lookupTables->IdOf("priority_types", cboPriority->Text.c_str());
  ending_state["todo_status_id"] = lookupTables->IdOf("todo_status_types", cboStatus->Text.c_str());
  ending_state["item"] = editItem->Text.c_str();
  ending_state["user_id"] = current_userid;
  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();

  return true; // again, not much can go wrong here
}
//---------------------------------------------------------------------------
bool TformRecordToDo::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  editItem->ReadOnly = true;
  editItem->TabStop = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordToDo::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  editItem->ReadOnly = false;
  editItem->TabStop = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordToDo::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordToDo * z = new TformRecordToDo(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

