//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordTransaction.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordTransaction *formRecordTransaction;
//---------------------------------------------------------------------------
__fastcall TformRecordTransaction::TformRecordTransaction(TComponent* Owner, map<string,string> &p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("transactions"))
{
  transactions_filter.SetListViewHandle(listOtherTransactions);
  transactions_filter.SetSecurity("transactions");
  transactions_filter.AddColumnSpec("Tax Entity", "tax_entities", as_text, true, 120, rawString);
  transactions_filter.AddColumnSpec("Eff. Date", "transactions", as_date, true, 75);
  transactions_filter.AddColumnSpec("Fisc. Date", "transactions", as_date, true, 75);
  transactions_filter.AddColumnSpec("Account", "accounts", as_text, true, 140);
  transactions_filter.AddColumnSpec("Type", "accounts", as_text, true, 75);
  transactions_filter.AddColumnSpec("Note", "transactions", as_text, false, 120, sentenceString);
  transactions_filter.AddColumnSpec("Debit", "transactions", as_double, true, 75, nonzeroAmountString);
  transactions_filter.AddColumnSpec("Credit", "transactions", as_double, true, 75, nonzeroAmountString);
  transactions_filter.AddColumnSpec("Trans #", "transactions", as_int, true, 75);
  transactions_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  transactions_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  transactions_filter.FetchPreferences("recordtransaction.transactions_filter");
  transactions_filter.SetIconStatus(true);
  transactions_filter.SetSQLStatement("");
  transactions_filter.RefreshDataSet();
  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordTransaction::ScreenStart()
{
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTransaction::ScreenStop()
{

  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTransaction::IsValidOnScreen()
{
  PSay("Directly modifying transactions is entirely disabled for reasons necessary to accounting and auditing.\n\n"
       "The proper way to modify transaction amounts is using the Modify Transactions Wizard.  You should "
       "find a link to it next to the list of transactions on the appropriate bill, PR, COB, etc.", m_warning, MB_OK);
  return false;

  // check to make sure that the values entered in the combo boxe
  // corrospond to values in that look up table.
  // check to make sure the dates entered are valid
  // give the user a message box and prompt to re-enter if incorrect
 /*
  if (! Pdate (editEffectiveDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editEffectiveDate->Text == ""))
  {
    PSay("Please enter a valid effective date", m_invalid_data, MB_OK);
    editEffectiveDate->SetFocus();
    return false;
  }
  else if (! IsAmount(editCreditAmount->Text.c_str()))
  {
    PSay("Please enter a valid credit amount", m_invalid_data, MB_OK);
    editCreditAmount->SetFocus();
    return false;
  }
  else if (! IsAmount(editDebitAmount->Text.c_str()))
  {
    PSay("Please enter a valid debit amount", m_invalid_data, MB_OK);
    editDebitAmount->SetFocus();
    return false;
  }

  else
    return true;
 */
}
//---------------------------------------------------------------------------

bool TformRecordTransaction::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  editEffectiveDate->Text     = initial_state["effective_date"].c_str();
  editFiscalDate->Text        = initial_state["fiscal_date"].c_str();
  editCreditAmount->Text      = AmountToString(StringToAmount(initial_state["credit_amount"])).c_str();
  editDebitAmount->Text       = AmountToString(StringToAmount(initial_state["debit_amount"])).c_str();
  editTransactionNumber->Text = initial_state["transaction_number"].c_str();
  editNote->Text              = SentenceString(initial_state["note"]).c_str();

  CreateLink(txtAccount, NULL, this, initial_state["account_id"], "accounts");
  CreateLink(txtTaxEntity, NULL, this, initial_state["tax_entity_id"], "tax_entities");
  CreateLink(txtBill, NULL, this, initial_state["bill_id"], "bills");
  CreateLink(txtTask, NULL, this, initial_state["task_id"], "tasks");

  TformRecordGeneric::PutDataOnScreen();
  return true; // what can really go wrong?
}
//---------------------------------------------------------------------------
bool TformRecordTransaction::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id

  if (editEffectiveDate->Text != "")
    ending_state["effective_date"] =  Pdate (editEffectiveDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy);
  else
    ending_state["effective_date"] = "";
  if (editFiscalDate->Text != "")
    ending_state["fiscal_date"] =  Pdate (editFiscalDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy);
  else
    ending_state["fiscal_date"] = "";
  ending_state["credit_amount"] = initial_state["credit_amount"]; // editCreditAmount->Text.c_str();
  ending_state["debit_amount"] = initial_state["debit_amount"]; // editDebitAmount->Text.c_str();
  ending_state["note"] = editNote->Text.c_str();
  if (initial_state["account_id"] == "")
    ending_state["account_id"] = "0";
  else
    ending_state["account_id"] = initial_state["account_id"];
  if (initial_state["tax_entity_id"] == "")
    ending_state["tax_entity_id"] = "0";
  else
    ending_state["tax_entity_id"] = initial_state["tax_entity_id"];
  if (initial_state["bill_id"] == "")
    ending_state["bill_id"] = "0";
  else
    ending_state["bill_id"] = initial_state["bill_id"];
  if (initial_state["task_id"] == "")
    ending_state["task_id"] = "0";
  else
    ending_state["task_id"] = initial_state["task_id"];

  ending_state["transaction_number"] = initial_state["transaction_number"];
  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();

  return true; // again, not much can go wrong here
}
//---------------------------------------------------------------------------
bool TformRecordTransaction::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  editNote->ReadOnly = true;
  editNote->TabStop = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTransaction::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  editNote->ReadOnly = false;
  editNote->TabStop = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTransaction::NotNewAnymore()
{
  string sql;
  sql = "select tax_entities.name, transactions.effective_date, transactions.fiscal_date, "
        "accounts.name, account_types.item, "
        "transactions.note, transactions.debit_amount, transactions.credit_amount, "
        "transactions.transaction_number, transactions.current_id, transactions.id "
        "from transactions "
        "inner join accounts on transactions.account_id = accounts.id "
        "inner join account_types on accounts.account_type_id = account_types.id "
        "left join tax_entities on transactions.tax_entity_id = tax_entities.id "
        "where "
        "transactions.transaction_number = " + initial_state["transaction_number"];
        // + " and transactions.id != " + initial_state["id"];
  transactions_filter.SetSQLStatement (sql);
  transactions_filter.RefreshDataSet();
  transactions_filter.SetAddEdit(this, NULL, EditRecord(&(TformRecordTransaction::EditTransaction)));
  transactions_request = atlas->RequestNotificationWhen("transactions.transaction_number", initial_state["transaction_number"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordTransaction::AtlasRefreshListView)));

  TformRecordGeneric::NotNewAnymore();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordTransaction::AtlasRefreshListView(int request_num, string matched_value)
{
 if(request_num == transactions_request)
  transactions_filter.RefreshDataSet();
 return;
}
//---------------------------------------------------------------------------
void TformRecordTransaction::EditTransaction()
{
  map<string, string> temp_map;
  temp_map["id"] = transactions_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordTransaction * view_transaction = new TformRecordTransaction(NULL, temp_map);
    view_transaction->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
bool TformRecordTransaction::IsNewAgain()
{
  transactions_filter.SetSQLStatement(string(""));
  transactions_filter.RefreshDataSet();
  transactions_filter.SetAddEdit(this, NULL, NULL);

  TformRecordGeneric::IsNewAgain();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordTransaction::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordTransaction * z = new TformRecordTransaction(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

