//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordTreatmentBeh.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordTreatmentBeh *formRecordTreatmentBeh;
//---------------------------------------------------------------------------
__fastcall TformRecordTreatmentBeh::TformRecordTreatmentBeh(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("beh_treatment"))
{
 Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordTreatmentBeh::ScreenStart()
{
  lookupTables->RegisterComboBox("beh_discharge_types", cboDischarge);
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTreatmentBeh::ScreenStop()
{
  lookupTables->UnregisterComboBox("beh_discharge_types", cboDischarge);
  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTreatmentBeh::IsValidOnScreen()
{
  // make sure the comments are not longer than 255 characters
  // make sure there is a link to a person, although there's not much the user
  // can do to fix that if there's not
  if (! Pdate (editAdmitDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editAdmitDate->Text == ""))
  {
    PSay("Please enter a valid admit date", m_invalid_data, MB_OK);
    editAdmitDate->SetFocus();
    return false;
  }
  else if (! Pdate(editDischargeDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editDischargeDate->Text == ""))
  {
    PSay("Please enter a valid discharge date", m_invalid_data, MB_OK);
    editDischargeDate->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("beh_discharge_types", cboDischarge->Text.c_str()))
  {
    PSay("Please enter a valid reason for discharge", m_invalid_data, MB_OK);
    cboDischarge->SetFocus();
    return false;
  }
  else if ((initial_state["person_id"] == "") || (initial_state["person_id"] == "0"))
  {
    PSay("There is no person associated with this record", m_missing_data, MB_OK);
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformRecordTreatmentBeh::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  editAdmitDate->Text = initial_state["admit_date"].c_str();
  editDischargeDate->Text = initial_state["discharge_date"].c_str();
  cboDischarge->Text = PrettyString(lookupTables->ValueOf("beh_discharge_types", initial_state["beh_discharge_id"])).c_str();
  editNotes->Text = SentenceString(initial_state["comments"]).c_str();

  CreateLink(txtPerson, NULL, this, initial_state["person_id"], "people");

  TformRecordGeneric::PutDataOnScreen();
  return true; // what can really go wrong?
}
//---------------------------------------------------------------------------
bool TformRecordTreatmentBeh::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  if(editAdmitDate->Text != "")
    ending_state["admit_date"] = Pdate(editAdmitDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy);
  else
    ending_state["admit_date"] = "";
  if(editDischargeDate->Text != "")
    ending_state["discharge_date"] = Pdate(editDischargeDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy);
  else
    ending_state["discharge_date"] = "";
  ending_state["beh_discharge_id"] = lookupTables->IdOf("beh_discharge_types", cboDischarge->Text.c_str()).c_str();
  ending_state["comments"] = editNotes->Text.c_str();
  ending_state["person_id"] = initial_state["person_id"];
  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();

  return true; // again, not much can go wrong here
}
//---------------------------------------------------------------------------
bool TformRecordTreatmentBeh::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  editNotes->ReadOnly = true;
  editNotes->TabStop = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordTreatmentBeh::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  editNotes->ReadOnly = false;
  editNotes->TabStop = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordTreatmentBeh::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordTreatmentBeh * z = new TformRecordTreatmentBeh(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

