//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordWaiver.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordWaiver *formRecordWaiver;
//---------------------------------------------------------------------------
__fastcall TformRecordWaiver::TformRecordWaiver(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("affiliations"))
{
 Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordWaiver::ScreenStart()
{
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordWaiver::ScreenStop()
{
  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordWaiver::IsValidOnScreen()
{
  // check to make sure the dates entered are valid
  // check to make sure the comment is no longer than 255 chars
  // give the user a message box and prompt to re-enter if incorrect
  // make sure there is a link to a person, although there's not much the user
  // can do to fix that if there's not
  if (! Pdate (editStartDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editStartDate->Text == ""))
  {
    PSay("Please enter a valid start date", m_invalid_data, MB_OK);
    editStartDate->SetFocus();
    return false;
  }
  else if (! Pdate(editStopDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editStopDate->Text == ""))
  {
    PSay("Please enter a valid stop date", m_invalid_data, MB_OK);
    editStopDate->SetFocus();
    return false;
  }
  else if ((initial_state["person_id"] == "") || (initial_state["person_id"] == "0"))
  {
    PSay("There is no person associated with this record", m_missing_data, MB_OK);
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformRecordWaiver::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  editStartDate->Text = initial_state["start_date"].c_str();
  editStopDate->Text = initial_state["stop_date"].c_str();
  editNotes->Text = SentenceString(initial_state["note"].c_str()).c_str();

  CreateLink(txtPerson, NULL, this, initial_state["person_id"], "people");
  
  TformRecordGeneric::PutDataOnScreen();  
  return true; // what can really go wrong?
}
//---------------------------------------------------------------------------
bool TformRecordWaiver::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  if (editStartDate->Text != "")
    ending_state["start_date"] = Pdate(editStartDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy);
  else
    ending_state["start_date"] = "";
  if (editStopDate->Text != "")
    ending_state["stop_date"] = Pdate(editStopDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy);
  else
    ending_state["stop_date"] = "";
  ending_state["note"] = editNotes->Text.c_str();
  ending_state["person_id"] = initial_state["person_id"];
  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();

  return true; // again, not much can go wrong here
}
//---------------------------------------------------------------------------
bool TformRecordWaiver::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  editNotes->ReadOnly = true;
  editNotes->TabStop = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordWaiver::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  editNotes->ReadOnly = false;
  editNotes->TabStop = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordWaiver::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordWaiver * z = new TformRecordWaiver(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

