//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSearchActivity.h"
#include "codeRecordActivity.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchActivity *formSearchActivity;
//---------------------------------------------------------------------------
__fastcall TformSearchActivity::TformSearchActivity(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("activities"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchActivity::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxes
  // corrospond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect
  if (! Pdate (editBeginDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editBeginDate->Text == ""))
  {
    PSay("Please enter a valid begin date", m_invalid_data, MB_OK);
    editBeginDate->SetFocus();
    return false;
  }
  else if (! Pdate (editEndDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editEndDate->Text == ""))
  {
    PSay("Please enter a valid end date", m_invalid_data, MB_OK);
    editEndDate->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("activity_code_types", cboActivity->Text.c_str()))
  {
    PSay("Please enter a valid activity", m_invalid_data, MB_OK);
    cboActivity->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("intensity_types", cboIntensity->Text.c_str()))
  {
    PSay("Please enter a valid intensity", m_invalid_data, MB_OK);
    cboIntensity->SetFocus();
    return false;
  }
  else if (! IsAmount(editMinTime->Text.c_str(), 15, 2))
  {
    PSay("Please enter a valid min time", m_invalid_data, MB_OK);
    editMinTime->SetFocus();
    return false;
  }
  else if (! IsAmount(editMaxTime->Text.c_str(), 15, 2))
  {
    PSay("Please enter a valid max time", m_invalid_data, MB_OK);
    editMaxTime->SetFocus();
    return false;
  }
  else if (! IsAmount(editMinDistance->Text.c_str(), 15, 2))
  {
    PSay("Please enter a valid min distance", m_invalid_data, MB_OK);
    editMinDistance->SetFocus();
    return false;
  }
  else if (! IsAmount(editMaxDistance->Text.c_str(), 15, 2))
  {
    PSay("Please enter a valid max distance", m_invalid_data, MB_OK);
    editMaxDistance->SetFocus();
    return false;
  }
  else if (! IsAmount(editMinSteps->Text.c_str(), 15, 2))
  {
    PSay("Please enter a valid min steps", m_invalid_data, MB_OK);
    editMinSteps->SetFocus();
    return false;
  }
  else if (! IsAmount(editMaxSteps->Text.c_str(), 15, 2))
  {
    PSay("Please enter a valid max steps", m_invalid_data, MB_OK);
    editMaxSteps->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformSearchActivity::Search()
{
 string sql = "";

 sql = "select activities.date_of_activity, person_names.last_name || ', ' || person_names.first_name name, "
       "activity_code_types.item activity, intensity_types.item intensity, activities.time_spent, "
       "activities.distance, activities.steps, activities.activity_logsheet_id, activities.current_id, activities.id "
       "from activities "
       "inner join activity_code_types on activity_code_types.id = activities.activity_code_id "
       "inner join intensity_types on intensity_types.id = activities.intensity_id "
       "inner join people on people.id = activities.person_id "
       "left join person_names on people.person_names_id = person_names.id "
       "where 1=1 and ";

 if (editLastName->Text != "")
   sql += "exists (select person_names.last_name from person_names "
           "where person_names.person_id = people.id and "
           "person_names.last_name like '" + SafeSQLString(editLastName->Text.c_str()) + "%') and ";
 if (editFirstName->Text != "")
   sql += "exists (select person_names.first_name from person_names "
           "where person_names.person_id = people.id and "
           "person_names.first_name like '" + SafeSQLString(editFirstName->Text.c_str()) + "%') and ";
 if (editBeginDate->Text != "")
   sql += "activities.date_of_activity >= '" + Pdate(editBeginDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
 if (editEndDate->Text != "")
   sql += "activities.date_of_activity <= '" + Pdate(editEndDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
 if (cboActivity->Text != "")
   sql += "activities.activity_code_id = " + lookupTables->IdOf("activity_code_types", cboActivity->Text.c_str()) + " and ";
 if (cboIntensity->Text != "")
   sql += "activities.intensity_id = " + lookupTables->IdOf("intensity_types", cboIntensity->Text.c_str()) + " and ";
 if (editMinTime->Text != "")
   sql += "activities.time_spent >= " + string(editMinTime->Text.c_str()) + " and ";
 if (editMaxTime->Text != "")
   sql += "activities.time_spent <= " + string(editMaxTime->Text.c_str()) + " and ";
 if (editMinDistance->Text != "")
   sql += "activities.distance >= " + string(editMinDistance->Text.c_str()) + " and ";
 if (editMaxDistance->Text != "")
   sql += "activities.distance <= " + string(editMaxDistance->Text.c_str()) + " and ";
 if (editMinSteps->Text != "")
   sql += "activities.steps >= " + string(editMinSteps->Text.c_str()) + " and ";
 if (editMaxSteps->Text != "")
   sql += "activities.steps <= " + string(editMaxSteps->Text.c_str()) + " and ";
 if (checkShowOnlyUnattachedActivities->Checked == true)
   sql += "activities.activity_logsheet_id = 0 and ";

  sql = sql.substr(0, sql.length()-4);
  // sql += " order by date_of_activity, person_names.last_name, person_names.first_name";
  Filter->SetSQLStatement (sql);
  Filter->RefreshDataSet ();

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchActivity::ScreenStart()
{
  lookupTables->RegisterComboBox("activity_code_types", cboActivity);
  lookupTables->RegisterComboBox("intensity_types", cboIntensity);

  Filter->SetSecurity("activities");
  Filter->AddColumnSpec("Date", "activities", as_date, true, 80);
  Filter->AddColumnSpec("Person", "person_names", as_text, true, 120);
  Filter->AddColumnSpec("Activity", "activities", as_text, true, 130);
  Filter->AddColumnSpec("Intensity", "activities", as_text, false, 100);
  Filter->AddColumnSpec("Time Spent", "activities", as_double, false, 70);
  Filter->AddColumnSpec("Distance", "activities", as_double, false, 70);
  Filter->AddColumnSpec("Steps", "activities", as_double, true, 70);
  Filter->AddColumnSpec("Attached to Logsheet", "activities", as_int, true, 100);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchactivity.filter");
  Filter->SetIconStatus(true);
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

 return true;
}
//---------------------------------------------------------------------------
bool TformSearchActivity::ScreenStop()
{
 // instead of formclose, do shutdown stuff here (combo boxes, etc.)
  lookupTables->UnregisterComboBox("activity_code_types", cboActivity);
  lookupTables->UnregisterComboBox("intensity_types", cboIntensity);
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchActivity::Create()
{
  PSay("Cannot create records from this form", m_message, MB_OK);
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchActivity::Zoom(const string & p_id)
{
  map<string,string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordActivity * activityRecord = new TformRecordActivity(NULL, temp_map);
    activityRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchActivity::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchActivity * z = new TformSearchActivity(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

