//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSearchBugLog.h"
#include "codeRecordBug.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchBugLog *formSearchBugLog;
//---------------------------------------------------------------------------
__fastcall TformSearchBugLog::TformSearchBugLog(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("bugs"))
{
 Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchBugLog::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxes
  // corrospond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect
  if (! lookupTables->IsInLookUpTable("users", cboCreatedBy))
  {
    PSay("Please enter a valid user's name", m_invalid_data, MB_OK);
    cboCreatedBy->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("users", cboReportedBy))
  {
    PSay("Please enter a valid user's name", m_invalid_data, MB_OK);
    cboReportedBy->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("users", cboClaimedBy))
  {
    PSay("Please enter a valid user's name", m_invalid_data, MB_OK);
    cboClaimedBy->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("users", cboFixedBy))
  {
    PSay("Please enter a valid user's name", m_invalid_data, MB_OK);
    cboFixedBy->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("bug_priority_types", cboPriority->Text.c_str()))
  {
    PSay("Please enter a valid priority", m_invalid_data, MB_OK);
    cboPriority->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("bug_status_types", cboBugStatus->Text.c_str()))
  {
    PSay("Please enter a valid bug status", m_invalid_data, MB_OK);
    cboBugStatus->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("users", cboForUser))
  {
    PSay("Please enter a valid user name", m_invalid_data, MB_OK);
    cboForUser->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("groups", cboForGroup))
  {
    PSay("Please enter a valid department name", m_invalid_data, MB_OK);
    cboForGroup->SetFocus();
    return false;
  }
  else if (! Pdate (editCreatedBetweenStart->Text.c_str(), mdy | yy).IsValidDate() && ! (editCreatedBetweenStart->Text == ""))
  {
    PSay("Please enter a valid starting creation date", m_invalid_data, MB_OK);
    editCreatedBetweenStart->SetFocus();
    return false;
  }
  else if (! Pdate (editCreatedBetweenEnd->Text.c_str(), mdy | yy).IsValidDate() && ! (editCreatedBetweenEnd->Text == ""))
  {
    PSay("Please enter a valid ending creation date", m_invalid_data, MB_OK);
    editCreatedBetweenEnd->SetFocus();
    return false;
  }
  else if ((editCreatedBetweenStart->Text != "" && editCreatedBetweenEnd->Text != "") && ! (Pdate (editCreatedBetweenEnd->Text.c_str(), mdy | yy) > Pdate (editCreatedBetweenStart->Text.c_str(), mdy | yy)))
  {
    PSay("Your ending creation date must come after your starting creation date", m_invalid_data, MB_OK);
    editCreatedBetweenStart->SetFocus();
    return false;
  }
  else if (! Pdate (editReportedBetweenStart->Text.c_str(), mdy | yy).IsValidDate() && ! (editReportedBetweenStart->Text == ""))
  {
    PSay("Please enter a valid starting reported date", m_invalid_data, MB_OK);
    editReportedBetweenStart->SetFocus();
    return false;
  }
  else if (! Pdate (editReportedBetweenEnd->Text.c_str(), mdy | yy).IsValidDate() && ! (editReportedBetweenStart->Text == ""))
  {
    PSay("Please enter a valid ending reported date", m_invalid_data, MB_OK);
    editReportedBetweenEnd->SetFocus();
    return false;
  }
  else if ((editReportedBetweenStart->Text != "" && editReportedBetweenEnd->Text != "") && ! (Pdate (editReportedBetweenEnd->Text.c_str(), mdy | yy) > Pdate (editReportedBetweenStart->Text.c_str(), mdy | yy)))
  {
    PSay("Your ending reported date must come after your starting reported date", m_invalid_data, MB_OK);
    editReportedBetweenStart->SetFocus();
    return false;
  }
  else if (! Pdate (editClaimedBetweenStart->Text.c_str(), mdy | yy).IsValidDate() && ! (editClaimedBetweenStart->Text == ""))
  {
    PSay("Please enter a valid starting claimed date", m_invalid_data, MB_OK);
    editClaimedBetweenStart->SetFocus();
    return false;
  }
  else if (! Pdate (editClaimedBetweenEnd->Text.c_str(), mdy | yy).IsValidDate() && ! (editClaimedBetweenStart->Text == ""))
  {
    PSay("Please enter a valid ending claimed date", m_invalid_data, MB_OK);
    editClaimedBetweenEnd->SetFocus();
    return false;
  }
  else if (editClaimedBetweenStart->Text != "" && editClaimedBetweenEnd->Text != "" && ! (Pdate (editClaimedBetweenEnd->Text.c_str(), mdy | yy) > Pdate (editClaimedBetweenStart->Text.c_str(), mdy | yy)))
  {
    PSay("Your ending claimed date must come after your starting claimed date", m_invalid_data, MB_OK);
    editClaimedBetweenStart->SetFocus();
    return false;
  }
  else if (! Pdate (editFixedBetweenStart->Text.c_str(), mdy | yy).IsValidDate() && ! (editFixedBetweenStart->Text == ""))
  {
    PSay("Please enter a valid starting fixed date", m_invalid_data, MB_OK);
    editFixedBetweenStart->SetFocus();
    return false;
  }
  else if (! Pdate (editFixedBetweenEnd->Text.c_str(), mdy | yy).IsValidDate() && ! (editFixedBetweenStart->Text == ""))
  {
    PSay("Please enter a valid ending fixed date", m_invalid_data, MB_OK);
    editFixedBetweenEnd->SetFocus();
    return false;
  }
  else if (editFixedBetweenStart->Text != "" && editFixedBetweenEnd->Text != "" && ! (Pdate (editFixedBetweenEnd->Text.c_str(), mdy | yy) > Pdate (editFixedBetweenStart->Text.c_str(), mdy | yy)))
  {
    PSay("Your ending fixed date must come after your starting fixed date", m_invalid_data, MB_OK);
    editFixedBetweenStart->SetFocus();
    return false;
  }
  else if (! Pdate (editDueBetweenStart->Text.c_str(), mdy | yy).IsValidDate() && ! (editDueBetweenStart->Text == ""))
  {
    PSay("Please enter a valid starting due date", m_invalid_data, MB_OK);
    editDueBetweenStart->SetFocus();
    return false;
  }
  else if (! Pdate (editDueBetweenEnd->Text.c_str(), mdy | yy).IsValidDate() && ! (editDueBetweenStart->Text == ""))
  {
    PSay("Please enter a valid ending due date", m_invalid_data, MB_OK);
    editDueBetweenEnd->SetFocus();
    return false;
  }
  else if (editDueBetweenStart->Text != "" && editDueBetweenEnd->Text != "" && ! (Pdate (editDueBetweenEnd->Text.c_str(), mdy | yy) > Pdate (editDueBetweenStart->Text.c_str(), mdy | yy)))
  {
    PSay("Your ending creation date must come after your starting creation date", m_invalid_data, MB_OK);
    editDueBetweenStart->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("bug_note_types", cboNoteType->Text.c_str()))
  {
    PSay("Please enter a valid note type", m_invalid_data, MB_OK);
    cboNoteType->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("users", cboPostedBy))
  {
    PSay("Please enter a valid user's name", m_invalid_data, MB_OK);
    cboPostedBy->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("bug_types", cboBugType->Text.c_str()))
  {
    PSay("Please enter a valid bug type", m_invalid_data, MB_OK);
    cboBugType->SetFocus();
    return false;
  }
  else if (! Pdate (editPostedBetweenStart->Text.c_str(), mdy | yy).IsValidDate() && ! (editPostedBetweenStart->Text == ""))
  {
    PSay("Please enter a valid starting posted date", m_invalid_data, MB_OK);
    editPostedBetweenStart->SetFocus();
    return false;
  }
  else if (! Pdate (editPostedBetweenEnd->Text.c_str(), mdy | yy).IsValidDate() && ! (editPostedBetweenStart->Text == ""))
  {
    PSay("Please enter a valid ending posted date", m_invalid_data, MB_OK);
    editPostedBetweenEnd->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("bug_status_types", cboNoteStatus->Text.c_str()))
  {
    PSay("Please enter a valid note status", m_invalid_data, MB_OK);
    cboNoteStatus->SetFocus();
    return false;
  }
/*else if (! Pdate (editStatusBetweenStart->Text.c_str(), mdy | yy).IsValidDate() && ! (editStatusBetweenStart->Text == ""))
  {
    PSay("Please enter a valid starting status date", m_invalid_data, MB_OK);
    editStatusBetweenStart->SetFocus();
    return false;
  }
  else if (! Pdate (editStatusBetweenEnd->Text.c_str(), mdy | yy).IsValidDate() && ! (editStatusBetweenStart->Text == ""))
  {
    PSay("Please enter a valid ending status date", m_invalid_data, MB_OK);
    editStatusBetweenEnd->SetFocus();
    return false;
  }
*/
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformSearchBugLog::ScreenStart()
{
  string all_users_sql = "select id, item, 1 valid from users order by item"; // make valid = 1 for all
  lookupTables->RegisterComboBox("users", cboCreatedBy, all_users_sql);
  lookupTables->RegisterComboBox("users", cboReportedBy, all_users_sql);
  lookupTables->RegisterComboBox("users", cboClaimedBy, all_users_sql);
  lookupTables->RegisterComboBox("users", cboFixedBy, all_users_sql);
  lookupTables->RegisterComboBox("bug_priority_types", cboPriority);
  lookupTables->RegisterComboBox("bug_status_types", cboBugStatus);
  lookupTables->RegisterComboBox("bug_types", cboBugType);
  lookupTables->RegisterComboBox("users", cboForUser, all_users_sql);
  lookupTables->RegisterComboBox("groups", cboForGroup);
  lookupTables->RegisterComboBox("bug_note_types", cboNoteType);
  lookupTables->RegisterComboBox("users", cboPostedBy, all_users_sql);
  lookupTables->RegisterComboBox("bug_status_types", cboNoteStatus);
/*  if (optionsPermissions["table.person_names"]["view"] != "true")
  {
    editLastName->Enabled = false;
    editFirstName->Enabled = false;
  } */
  /*if (optionsPermissions["table.bugs"]["view"] != "true")
  {
    //scrollStandard->Enabled = false;
    cboCreatedBy->Enabled = false;
    cboReportedBy->Enabled = false;
    cboClaimedBy->Enabled = false;
    cboFixedBy->Enabled = false;
    cboPriority->Enabled = false;
    cboStatus->Enabled = false;
    cboForUser->Enabled = false;
    cboForGroup->Enabled = false;
    editProbableCause->Enabled = false;
    editProbableLocation->Enabled = false;
    editProbableSolution->Enabled = false;
    editCreatedBetweenStart->Enabled = false;
    editCreatedBetweenEnd->Enabled = false;
    editReportedBetweenStart->Enabled = false;
    editReportedBetweenEnd->Enabled = false;
    editClaimedBetweenStart->Enabled = false;
    editClaimedBetweenEnd->Enabled = false;
    editDueBetweenStart->Enabled = false;
    editDueBetweenEnd->Enabled = false;
    cboType->Enabled = false;
    editDescription->Enabled = false;
    editActualCause->Enabled = false;
    editActualLocation->Enabled = false;
    editActualSolution->Enabled = false;
    buttonSearch->Enabled = false;
  }
  if (optionsPermissions["table.bugs"]["insert"] != "true")
  {
    buttonNew->Enabled = false;
  }
  if (optionsPermissions["table.bug_priority_types"]["view"] != "true")
  {
    cboPriority->Enabled = false;
  }
  if (optionsPermissions["table.bug_status_types"]["view"] != "true")
  {
    cboStatus->Enabled = false;
  }
  if (optionsPermissions["table.bug_types"]["view"] != "true")
  {
    cboType->Enabled = false;
  }*/

  Filter->SetSecurity("bugs");
  Filter->AddColumnSpec("Created By", "users", as_text, true, 100);
  Filter->AddColumnSpec("Created On", "bugs", as_date, true, 80);
  Filter->AddColumnSpec("Reported By", "users", as_text, true, 100);
  Filter->AddColumnSpec("Reported On", "bugs", as_date, true, 80);
  Filter->AddColumnSpec("Claimed By", "users", as_text, true, 100);
  Filter->AddColumnSpec("Claimed On", "bugs", as_date, true, 80);
  Filter->AddColumnSpec("Fixed By", "users", as_text, true, 100);
  Filter->AddColumnSpec("Fixed On", "bugs", as_date, true, 80);
  Filter->AddColumnSpec("Priority", "bugs", as_text, true, 100);
/*Filter->AddColumnSpec("Description", "bugs", as_text, true, 100);
  Filter->AddColumnSpec("Probable Cause", "bugs", as_text, false, 100);
  Filter->AddColumnSpec("Probable Location", "bugs", as_text, false, 100);
  Filter->AddColumnSpec("Probable Solution", "bugs", as_text, false, 100);
  Filter->AddColumnSpec("Actual Cause", "bugs", as_text, false, 100);
  Filter->AddColumnSpec("Actual Location", "bugs", as_text, false, 100);
  Filter->AddColumnSpec("Actual Solution", "bugs", as_text, false, 100);
*/
  Filter->AddColumnSpec("Status", "bugs", as_text, true, 100);
  Filter->AddColumnSpec("Due On", "bugs", as_date, true, 80);
  Filter->AddColumnSpec("Type", "bugs", as_text, true, 100);
  Filter->AddColumnSpec("For Employee", "users", as_text, true, 100);
  Filter->AddColumnSpec("For Department", "bugs", as_text, true, 100); // no table.groups ... could leave permission "" also
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchbuglog.filter");
  Filter->SetIconStatus(true);
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();
  TformSearchGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchBugLog::ScreenStop()
{
 // instead of formclose, do shutdown stuff here (combo boxes, etc.)
  optionsPreferences["formSearchBugLog"]["Filter"] = Filter->GetPreferences();
  // unregister combo boxes
  lookupTables->UnregisterComboBox("users", cboCreatedBy);
  lookupTables->UnregisterComboBox("users", cboReportedBy);
  lookupTables->UnregisterComboBox("users", cboClaimedBy);
  lookupTables->UnregisterComboBox("users", cboFixedBy);
  lookupTables->UnregisterComboBox("bug_priority_types", cboPriority);
  lookupTables->UnregisterComboBox("bug_status_types", cboBugStatus);
  lookupTables->UnregisterComboBox("bug_types", cboBugType);
  lookupTables->UnregisterComboBox("users", cboForUser);
  lookupTables->UnregisterComboBox("groups", cboForGroup);
  lookupTables->UnregisterComboBox("bug_note_types", cboNoteType);
  lookupTables->UnregisterComboBox("users", cboPostedBy);
  lookupTables->UnregisterComboBox("bug_status_types", cboNoteStatus);
  TformSearchGeneric::ScreenStop();
 return true;
}
//---------------------------------------------------------------------------
bool TformSearchBugLog::Create()
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  FORM_TRY
    TformRecordBug * bugRecord = new TformRecordBug(NULL, temp_map);
    bugRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchBugLog::Search()
{
 string fields = "";
 string from = "";
 string where = "";
 string sql = "";

 sql = "select distinct "
              "created_by_user.item created_by, created_on, "
              "reported_by_user.item reported_by, reported_on, "
              "claimed_by_user.item claimed_by, claimed_on, "
              "fixed_by_user.item fixed_by, fixed_on, "
              "bug_priority_types.item priority, "
              "bug_status.item status, "
              "due_on, "
              "bug_types.item bug_type, "
              "created_for_user.item created_for_user, "
              "created_for_group.item created_for_group, "
              "bugs.current_id, bugs.id "
       "from bugs left join current_types on bugs.current_id = current_types.id "
          "left join users reported_by_user on bugs.reported_by = reported_by_user.id "
	  "left join users created_by_user on bugs.created_by = created_by_user.id "
          "left join users claimed_by_user on bugs.claimed_by = claimed_by_user.id "
          "left join users fixed_by_user on bugs.fixed_by = fixed_by_user.id "
          "left join users created_for_user on bugs.created_for_user = created_for_user.id "
          "left join bug_priority_types on bugs.bug_priority_id = bug_priority_types.id "
          "left join groups created_for_group on bugs.created_for_group = created_for_group.id "
          "left join bug_types on bugs.bug_type_id = bug_types.id "
          "left join bug_status_types bug_status on bugs.status_id = bug_status.id "
          "left join bug_notes on bug_notes.bug_id = bugs.id "
          "left join bug_note_types on bug_notes.bug_note_id = bug_note_types.id "
          "left join users posted_by on bug_notes.posted_by = posted_by.id "
          "left join bug_status_types note_status on bug_notes.status_id = note_status.id "
       "where bugs.id > 0 and ";

  if (cboCreatedBy->Text != "")
    sql += "bugs.created_by = " + lookupTables->IdOf("users", cboCreatedBy->Text.c_str()) + " and ";
  if (cboReportedBy->Text != "")
    sql += "bugs.reported_by = " + lookupTables->IdOf("users", cboReportedBy->Text.c_str()) + " and ";
  if (cboClaimedBy->Text != "")
    sql += "bugs.reported_by = " + lookupTables->IdOf("users", cboClaimedBy->Text.c_str()) + " and ";
  if (cboFixedBy->Text != "")
    sql += "bugs.reported_by = " + lookupTables->IdOf("users", cboFixedBy->Text.c_str()) + " and ";
  if (cboPriority->Text != "")
    sql += "bugs.bug_priority_id = " + lookupTables->IdOf("bug_priority_types", cboPriority->Text.c_str()) + " and ";
         /*"exists (select bug_priority_types.id from bug_priority_types, bugs "
           "where bug_priority_types.id = " + lookupTables->IdOf("bug_priority_types", cboPriority->Text.c_str()) + " and "
           "bugs.bug_priority_id = bug_priority_types.id) and ";
         */ // ... what???
  if (cboBugStatus->Text != "")
    sql += "bugs.status_id = '" + lookupTables->IdOf("bug_status_types", cboBugStatus->Text.c_str()) + "' and ";
  if (cboForUser->Text != "")
    sql += "bugs.created_for_user = " + lookupTables->IdOf("users", cboForUser->Text.c_str()) + " and ";
  // if they want bugs with a specific group, give them bugs indicated to be with that group OR any user IN that group
  // This was a good idea, at the time.  Really it was.  I see a problem with this logic now though.  Users change departments
  // occasionally, so old bugs might show / not show the way you'd expect this way.
  if (cboForGroup->Text != "")
    sql += "(bugs.created_for_group = " + lookupTables->IdOf("groups", cboForGroup->Text.c_str()) + " or "
           "bugs.created_for_user in (select id from users where group_id = " + lookupTables->IdOf("groups", cboForGroup->Text.c_str()) + " )) and ";
  // DONE: note that I didn't do "and valid = 1" ... I'd like it to pull bugs even if the person it was created for is no longer around, I think.
  // DONE: so I guess all the user combo boxes should be modified to have custom sql to match?  Bah.  Later
  if (editCreatedBetweenStart->Text != "")
    sql += "bugs.created_on >= '" + Pdate(editCreatedBetweenStart->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
  if (editCreatedBetweenEnd->Text != "")
    sql += "bugs.created_on <= '" + Pdate(editCreatedBetweenEnd->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
  if (editReportedBetweenStart->Text != "")
    sql += "bugs.reported_on >= '" + Pdate(editReportedBetweenStart->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
  if (editReportedBetweenEnd->Text != "")
    sql += "bugs.reported_on <= '" + Pdate(editReportedBetweenEnd->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
  if (editClaimedBetweenStart->Text != "")
    sql += "bugs.claimed_on >= '" + Pdate(editClaimedBetweenStart->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
  if (editClaimedBetweenEnd->Text != "")
    sql += "bugs.claimed_on <= '" + Pdate(editClaimedBetweenEnd->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
  if (editFixedBetweenStart->Text != "")
    sql += "bugs.fixed_on >= '" + Pdate(editFixedBetweenStart->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
  if (editFixedBetweenEnd->Text != "")
    sql += "bugs.fixed_on <= '" + Pdate(editFixedBetweenEnd->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
  if (editDueBetweenStart->Text != "")
    sql += "bugs.due_on >= '" + Pdate(editDueBetweenStart->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
  if (editDueBetweenEnd->Text != "")
    sql += "bugs.due_on <= '" + Pdate(editDueBetweenEnd->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
  if (cboBugType->Text != "")
    sql += "bugs.bug_type_id = " + lookupTables->IdOf("bug_types", cboBugType->Text.c_str()) + "and ";
         /*"exists (select bug_types.id from bug_types, bugs "
           "where bug_types.id = " + lookupTables->IdOf("bug_types", cboType->Text.c_str()) + " and "
           "bugs.bug_type_id = bug_types.id) and ";
         */ // ... what???
  if (cboNoteType->Text != "")
    sql += "bug_notes.bug_note_id = " + lookupTables->IdOf("bug_note_types", cboNoteType->Text.c_str()) + "and ";
  if (editNote->Text != "")
    sql += KeywordParseString(SafeSQLString(editNote->Text.c_str()),SafeSQLString("bug_notes.note")) + " and ";
  if (cboPostedBy->Text != "")
    sql += "bug_notes.posted_by = " + lookupTables->IdOf("users", cboPostedBy->Text.c_str()) + " and ";
  if (editPostedBetweenStart->Text != "")
    sql += "bug_notes.date_of_post >= '" + Pdate(editPostedBetweenStart->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
  if (editPostedBetweenEnd->Text != "")
    sql += "bug_notes.date_of_post <= '" + Pdate(editPostedBetweenEnd->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
  if (cboNoteStatus->Text != "")
    sql += "bug_notes.status_id = '" + lookupTables->IdOf("bug_status_types", cboNoteStatus->Text.c_str()) + "' and ";
/*
  if (editStatusBetweenStart->Text != "")
    sql += "bug_notes.date_of_post >= '" + Pdate(editPostedBetweenStart->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
  if (editStatusBetweenEnd->Text != "")
    sql += "bug_notes.date_of_post <= '" + Pdate(editPostedBetweenEnd->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
*/

  sql = sql.substr(0, sql.length()-4);
  sql += " order by bug_priority_types.item ";
  DebugSql(this, &sql, other_forms, 9);
  Filter->SetSQLStatement (sql);
  Filter->RefreshDataSet ();

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchBugLog::Zoom(const string & p_id)
{
  map<string,string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordBug * bugRecord = new TformRecordBug(NULL, temp_map);
    bugRecord->Show();
  FORM_CATCH

 return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchBugLog::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchBugLog * z = new TformSearchBugLog(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

