//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
 
#include "codeSearchCallLog.h"
#include "codeSpecialCallLog.h"
#include "codeRecordCallLog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchCallLog *formSearchCallLog;
//---------------------------------------------------------------------------
__fastcall TformSearchCallLog::TformSearchCallLog(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("call_log"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchCallLog::IsValidOnScreen()
{

  // check to make sure that the values entered in the combo boxes
  // corrospond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect
  if (! lookupTables->IsInLookUpTable("users", comboReceptionist->Text.c_str()))
  {
    PSay("Please enter a valid receptionist name", m_invalid_data, MB_OK);
    comboReceptionist->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("users", comboEmployee->Text.c_str()))
  {
    PSay("Please enter a valid employee name", m_invalid_data, MB_OK);
    comboEmployee->SetFocus();
    return false;
  }
  else if (! Pdate (editStartStamp->Text.c_str(), mdy | yy).IsValidDate() && ! (editStartStamp->Text == ""))
  {
    PSay("Please enter a valid beginning date (or none at all)", m_invalid_data, MB_OK);
    editStartStamp->SetFocus();
    return false;
  }
  else if (! Pdate (editStopStamp->Text.c_str(), mdy | yy).IsValidDate() && ! (editStopStamp->Text == ""))
  {
    PSay("Please enter a valid ending date (or none at all)", m_invalid_data, MB_OK);
    editStopStamp->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformSearchCallLog::Search()
{
  string sql;
  sql = "select cast(call_log.call_time as date), cast(call_log.call_time as time), "
        "call_log.caller_name, a.item, b.item, call_log.note, call_log.current_id, call_log.id "
        "from call_log, users a, users b "
        "where call_log.employee_id = a.id and call_log.receptionist_id = b.id";

  if(comboReceptionist->Text != "")
    sql += " and b.id = " + lookupTables->IdOf("users", comboReceptionist->Text.c_str());
  if(comboEmployee->Text != "")
    sql += " and a.id = " + lookupTables->IdOf("users", comboEmployee->Text.c_str());
  if(editStartStamp->Text != "")
    sql += " and call_log.call_time >= '" + Pdate(editStartStamp->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + " 00:01:00'";
  if(editStopStamp->Text != "")
    sql += " and call_log.call_time <= '" + Pdate(editStopStamp->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + " 23:59:00'";
  if(editCallerName->Text != "")
    sql += " and call_log.caller_name like '%" + SafeSQLString(editCallerName->Text.c_str()) + "%'";
  if(editNote->Text != "")
    sql += " and call_log.note like '%" + SafeSQLString(editNote->Text.c_str()) + "%'";
  Filter->SetSQLStatement(sql);
  Filter->RefreshDataSet();
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchCallLog::ScreenStart()
{
 // instead of formcreate, do startup stuff here or in the constructor
 // this gets called after stuff in the base classes's constructor
  TDateTime today = Date();
  editStartStamp->Text = today.DateString();
  editStopStamp->Text = today.DateString();

  Filter->SetListViewHandle(listSearchResults);
  Filter->SetSecurity("call_log");
  Filter->AddColumnSpec("Date", "call_log", as_date, true, 90);
  Filter->AddColumnSpec("Time", "call_log", as_time, true, 90);
  Filter->AddColumnSpec("Caller Name", "call_log", as_text, true, 100);
  Filter->AddColumnSpec("Employee", "call_log", as_text, true, 100);
  Filter->AddColumnSpec("Receptionist", "call_log", as_text, true, 100);
  Filter->AddColumnSpec("Note", "call_log", as_text, true, 120);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->SetIconStatus(false);
  Filter->FetchPreferences("searchcalllog.filter");
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

  lookupTables->RegisterComboBox("users", comboReceptionist);
  lookupTables->RegisterComboBox("users", comboEmployee);

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchCallLog::ScreenStop()
{
 // instead of formclose, do shutdown stuff here (combo boxes, etc.)
  lookupTables->UnregisterComboBox("users", comboReceptionist);
  lookupTables->UnregisterComboBox("users", comboEmployee);
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchCallLog::Create()
{
 return true;
}
//---------------------------------------------------------------------------
bool TformSearchCallLog::Zoom(const string & p_id)
{
  map<string, string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordCallLog * record_form = new TformRecordCallLog(NULL, temp_map);
    record_form->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchCallLog::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchCallLog * z = new TformSearchCallLog(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

