//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
 
#include "codeSearchCheck.h"
#include "codeRecordCheck.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchCheck *formSearchCheck;
//---------------------------------------------------------------------------
__fastcall TformSearchCheck::TformSearchCheck(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("purchase_reqs"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchCheck::IsValidOnScreen()
{
  if (!IsInt(editCheckNumber->Text.c_str()))
  {
     PSay("Please enter a valid check number", m_invalid_data, MB_OK);
     editBeginDate->SetFocus();
     return false;
  }
  else if (!IsInt(editPrNumber->Text.c_str()))
  {
     PSay("Please enter a valid purchase request number", m_invalid_data, MB_OK);
     editPrNumber->SetFocus();
     return false;
  }
  else if (! Pdate (editBeginDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editBeginDate->Text == ""))
  {
    PSay("Please enter a valid begin date", m_invalid_data, MB_OK);
    editBeginDate->SetFocus();
    return false;
  }
  else if (! Pdate (editEndDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editEndDate->Text == ""))
  {
    PSay("Please enter a valid end date", m_invalid_data, MB_OK);
    editEndDate->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformSearchCheck::Search()
{
  string sql;
  sql = "select checks.check_number, checks.date_sent, tax_entities.name, count(purchase_reqs.id), "
        "checks.current_id, checks.id "
        "from checks "
        "left join tax_entities on checks.tax_entity_id = tax_entities.id "
        "left join purchase_reqs on purchase_reqs.check_id = checks.id "
        "where checks.id > 0 ";

  if(editBeginDate->Text != "")
    sql += "and checks.date_sent >= '" + Pdate(editBeginDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
  if(editEndDate->Text != "")
    sql += "and checks.date_sent <= '" + Pdate(editEndDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
  if(editPrNumber->Text != "")
    sql += "and purchase_reqs.purchase_req_number like '%" + SafeSQLString(editPrNumber->Text.c_str()) + "%' ";
  if(editCheckNumber->Text != "")
    sql += "and checks.check_number like '%" + SafeSQLString(editCheckNumber->Text.c_str()) + "%' ";

  sql += "group by checks.check_number, checks.date_sent, tax_entities.name, checks.current_id, checks.id ";

  Filter->SetSQLStatement(sql);
  Filter->RefreshDataSet();
  return true;

}
//---------------------------------------------------------------------------
bool TformSearchCheck::ScreenStart()
{
 // instead of formcreate, do startup stuff here or in the constructor
 // this gets called after stuff in the base classes's constructor

  Filter->SetListViewHandle(listSearchResults);
  Filter->SetSecurity("checks");
  Filter->AddColumnSpec("Check Number", "checks", as_int, true, 100);
  Filter->AddColumnSpec("Date Sent", "checks", as_date, true, 90);
  Filter->AddColumnSpec("Tax Entity", "tax_entities", as_text, true, 150, rawString);
  Filter->AddColumnSpec("Count of PRs", "purchase_reqs", as_int, true, 75);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchchecks.filter");
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchCheck::ScreenStop()
{

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchCheck::Create()
{

 return true;
}
//---------------------------------------------------------------------------
bool TformSearchCheck::Zoom(const string & p_id)
{
 map<string, string> temp_map;
 temp_map["id"] = p_id;

 FORM_TRY
   TformRecordCheck * check_record = new TformRecordCheck(NULL, temp_map);
   check_record->Show();
 FORM_CATCH

 return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchCheck::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchCheck * z = new TformSearchCheck(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

