//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
 
#include "codeSearchCode.h"
#include "codeSpecialViewCode.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchCode *formSearchCode;
//---------------------------------------------------------------------------
__fastcall TformSearchCode::TformSearchCode(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("codes"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchCode::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxes
  // corrospond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect
  if (! lookupTables->IsInLookUpTable("code_types", cboCode->Text.c_str()))
  {
    PSay("Please enter a valid code type", m_invalid_data, MB_OK);
    cboCode->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformSearchCode::Search()
{
  string sql = "select code_types.item, codes.code, codes.description, "
               "codes.current_id, codes.id "
               "from codes, code_types "
               "where codes.code_id = code_types.id and ";
  if (cboCode->Text != "")
    sql += "codes.code_id = " + lookupTables->IdOf("code_types", cboCode->Text.c_str()) + " and ";
  if (editCode->Text != "")
    sql += "codes.code like '%" + SafeSQLString(editCode->Text.c_str()) + "%' and ";
  if (editDescription->Text != "")
    sql += "codes.description like '%" + SafeSQLString(editDescription->Text.c_str()) + "%' and ";
  sql = sql.substr(0, sql.length()-5);
  // sql += " order by codes.code";

  Filter->SetSQLStatement (sql);
  Filter->RefreshDataSet ();

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchCode::ScreenStart()
{
  lookupTables->RegisterComboBox("code_types", cboCode);

  Filter->SetSecurity("codes");
  Filter->AddColumnSpec("Type", "codes", as_text, true, 90);
  Filter->AddColumnSpec("Code", "codes", as_text, true, 90);
  Filter->AddColumnSpec("Description", "codes", as_text, true, 230, sentenceString);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->SetPreferences(optionsPreferences["formSearchCode"]["Filter"]);
  Filter->SetIconStatus(true);
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

 return true;
}
//---------------------------------------------------------------------------
bool TformSearchCode::ScreenStop()
{
 // instead of formclose, do shutdown stuff here (combo boxes, etc.)
  lookupTables->UnregisterComboBox("code_types", cboCode);
 return true;
}
//---------------------------------------------------------------------------
bool TformSearchCode::Zoom(const string & p_id)
{
  string id = p_id;
  FORM_TRY
    TformSpecialViewCode * codeViewer = new TformSpecialViewCode(NULL, id);
    codeViewer->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchCode::Create()
{
  PSay("I'm sorry, but you cannot create new codes", m_message, MB_OK);
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchCode::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchCode * z = new TformSearchCode(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------
vector<string> TformSearchCode::Do(TformSpecialGeneric * p_parent, string code_type_id)
{
 vector<string> answer;
 FORM_TRY
  TformSearchCode * z = new TformSearchCode(NULL, &answer);
  z->cboCode->Text = lookupTables->ValueOf("code_types", code_type_id).c_str();
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------
void TformSearchCode::Do(string code_type_id, string code_value)
{
 FORM_TRY
  TformSearchCode * z = new TformSearchCode(NULL, NULL);
  z->cboCode->Text = lookupTables->ValueOf("code_types", code_type_id).c_str();
  z->editCode->Text = code_value.c_str();
  z->Show();
  if (code_value != "")
   z->Search();
 FORM_CATCH
}
//---------------------------------------------------------------------------

