//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
 
#include "codeSearchComPubTask.h"
#include "codeSearchEvent.h"
#include "codeRecordTaskCom.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchComTask *formSearchComTask;
//---------------------------------------------------------------------------
__fastcall TformSearchComTask::TformSearchComTask(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("tasks"))
{
   Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchComTask::IsValidOnScreen()
{
  if (! lookupTables->IsInLookUpTable("users", cboStaff->Text.c_str()))
  {
    PSay("Please enter a valid staff name", m_invalid_data, MB_OK);
    cboStaff->SetFocus();
    return false;
  }
  else if (! Pdate (editBeginDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editBeginDate->Text == ""))
  {
    PSay("Please enter a valid begin date", m_invalid_data, MB_OK);
    editBeginDate->SetFocus();
    return false;
  }
  else if (! Pdate (editEndDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editEndDate->Text == ""))
  {
    PSay("Please enter a valid end date", m_invalid_data, MB_OK);
    editEndDate->SetFocus();
    return false;
  }
  else if (! IsFloat(editMinTime->Text.c_str()))
  {
    PSay("Please enter a valid min time spent", m_invalid_data, MB_OK);
    editMinTime->SetFocus();
    return false;
  }
  else if (! IsFloat(editMaxTime->Text.c_str()))
  {
    PSay("Please enter a valid max time spent", m_invalid_data, MB_OK);
    editMaxTime->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("method_types", cboMethod->Text.c_str()))
  {
    PSay("Please enter a valid method of contact", m_invalid_data, MB_OK);
    cboMethod->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("direction_types", cboDirection->Text.c_str()))
  {
    PSay("Please enter either incoming or outgoing", m_invalid_data, MB_OK);
    cboDirection->SetFocus();
    return false;
  }

  else if (! lookupTables->IsInLookUpTable("com_meeting_types", cboMeeting->Text.c_str()))
  {
    PSay("Please enter a valid meeting type", m_invalid_data, MB_OK);
    cboMeeting->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("com_activity_types", cboActivity->Text.c_str()))
  {
    PSay("Please enter a valid activity type", m_invalid_data, MB_OK);
    cboActivity->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("classification", cboClassification->Text.c_str()))
  {
    PSay("Please enter a valid classification type", m_invalid_data, MB_OK);
    cboClassification->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("task_purpose_types", cboTaskType))
  {
    PSay("Please enter a valid task type", m_invalid_data, MB_OK);
    cboTaskType->SetFocus();
    return false;
  }

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchComTask::Search()
{
  string sql;

  sql = "select tasks.date_of_task, users.item, event_name_types.item event_name, "
        "person_names.first_name || ' ' || person_names.last_name || ' ' || person_names.suffix name, "
        "tasks.time_spent, tasks.mileage, method_types.item, direction_types.item, classification_types.item, "
        "com_meeting_types.item, com_activity_types.item, tasks.new_client, "
        "tasks.task_comments, tasks.group_id, tasks.current_id, tasks.id  "
        "from tasks inner join users on tasks.user_id = users.id "
        "inner join events on tasks.event_id = events.id "
        "inner join method_types on tasks.method_id = method_types.id "
        "inner join direction_types on tasks.direction_id = direction_types.id "
        "inner join classification_types on tasks.classification_id = classification_types.id "
        "inner join com_meeting_types on tasks.com_meeting_id = com_meeting_types.id "
        "inner join com_activity_types on tasks.com_activity_id = com_activity_types.id "
        "inner join people on tasks.person_id = people.id "
        "left join person_names on people.person_names_id = person_names.id "
        "inner join event_name_types on events.event_name_id = event_name_types.id "
        "where tasks.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
        "tasks.com_dept_id = 0 and ";  // added so the filter wouldn't pull visits (they should come up on a different screen)

  if(cboStaff->Text != "")
    sql += "tasks.user_id = " + lookupTables->IdOf("users", cboStaff->Text.c_str()) + " and ";
//  if(editEvent->Text != "")
//    sql += "events.event_name like '%" + SafeSQLString(editEvent->Text.c_str()) + "%' and ";
  if (cboEventName->Text != "")
    sql += "events.event_name_id = " + lookupTables->IdOf("event_name_types", cboEventName) + " and ";
  if(editBeginDate->Text != "")
    sql += "tasks.date_of_task >= '" + Pdate(editBeginDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
  if(editEndDate->Text != "")
    sql += "tasks.date_of_task <= '" + Pdate(editEndDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
  if(editMinTime->Text != "")
    sql += "tasks.time_spent >= " + string(editMinTime->Text.c_str()) + " and ";
  if(editMaxTime->Text != "")
     sql += "tasks.time_spent <= " + string(editMaxTime->Text.c_str()) + " and ";
  if(cboMethod->Text != "")
    sql += "tasks.method_id = " + lookupTables->IdOf("method_types", cboMethod->Text.c_str()) + " and ";
  if(cboDirection->Text != "")
    sql += "tasks.direction_id = " + lookupTables->IdOf("direction_types", cboDirection->Text.c_str()) + " and ";
  if(cboMeeting->Text != "")
    sql += "tasks.com_meeting_id = " + lookupTables->IdOf("com_meeting_types", cboMeeting->Text.c_str()) + " and ";
  if(cboActivity->Text != "")
    sql += "tasks.com_activity_id = " + lookupTables->IdOf("com_activity_types", cboActivity->Text.c_str()) + " and ";
  if(cboTaskType->Text != "")
    sql += "tasks.task_purpose_id = " + lookupTables->IdOf("task_purpose_types", cboTaskType->Text.c_str(), cboTaskType) + " and ";
 
  sql = sql.substr(0, sql.length()-5);
  // sql += " order by tasks.date_of_task, users.item";
  Filter->SetSQLStatement(sql);
  Filter->RefreshDataSet();
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchComTask::ScreenStart()
{
 // instead of formcreate, do startup stuff here or in the constructor
 // this gets called after stuff in the base classes's constructor
  // instead of formcreate, do startup stuff here or in the constructor
 // this gets called after stuff in the base classes's constructor
  Filter->SetListViewHandle(listSearchResults);
  Filter->SetSecurity("tasks");
  Filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  Filter->AddColumnSpec("Staff", "tasks", as_text, true, 110);
  Filter->AddColumnSpec("Event", "events", as_text, false, 110, rawString);
  Filter->AddColumnSpec("Client", "people", as_text, true, 110);
  Filter->AddColumnSpec("Time Spent", "tasks", as_double, true, 100);
  Filter->AddColumnSpec("Mileage", "tasks", as_double, false, 80);
  Filter->AddColumnSpec("Method of Contact", "tasks", as_text, true, 130);
  Filter->AddColumnSpec("In/Out", "tasks", as_text, false, 80);
  Filter->AddColumnSpec("Classification", "tasks", as_text, false, 110);
  Filter->AddColumnSpec("Meeting Type", "tasks", as_text, false, 110);
  Filter->AddColumnSpec("Activity Type", "tasks", as_text, true, 110);
  Filter->AddColumnSpec("New Client", "tasks", as_text, false, 110, prettyBoolString);
  Filter->AddColumnSpec("Comments", "tasks", as_text, false, 150, sentenceString);
  Filter->AddColumnSpec("Group Id", "internal_id", as_int, false, 80);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchtaskdiab.filter");
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();


  Pdate begin_date(DateToStr(Date()).c_str(), mdy | yyyy);
  begin_date.mod(-14, in_days);
  editBeginDate->Text = begin_date.OutDate(mdy | yyyy).c_str();
  editEndDate->Text = DateToStr(Date()).c_str();

  lookupTables->RegisterComboBox("users", cboStaff);
  lookupTables->RegisterComboBox("method_types", cboMethod);
  lookupTables->RegisterComboBox("direction_types", cboDirection);
  lookupTables->RegisterComboBox("com_meeting_types", cboMeeting);
  lookupTables->RegisterComboBox("com_activity_types", cboActivity);
  lookupTables->RegisterComboBox("classification_types", cboClassification);
  string task_sql = "select id, item, valid from task_purpose_types where group_id = 0 or group_id = '"
                    + lookupTables->IdOf("groups", "Public Health") + "' ";
  lookupTables->RegisterComboBox("task_purpose_types", cboTaskType, task_sql);

  string group_sql = "select id, item, valid from event_name_types "
                     "where (group_id = 0 or group_id = '" + lookupTables->IdOf("groups", "Community Health") + "') and valid = 1 order by item";
  lookupTables->RegisterComboBox("event_name_types", cboEventName, group_sql, SetGroupIdForNewLookupTableItem);

 return true;
}
//---------------------------------------------------------------------------
bool TformSearchComTask::ScreenStop()
{
 // instead of formclose, do shutdown stuff here (combo boxes, etc.)
  lookupTables->UnregisterComboBox("users", cboStaff);

  lookupTables->UnregisterComboBox("method_types", cboMethod);
  lookupTables->UnregisterComboBox("direction_types", cboDirection);
  lookupTables->UnregisterComboBox("com_meeting_types", cboMeeting);
  lookupTables->UnregisterComboBox("com_activity_types", cboActivity);
  lookupTables->UnregisterComboBox("classification_types", cboClassification);
  lookupTables->UnregisterComboBox("task_purpose_types", cboTaskType);
  lookupTables->UnregisterComboBox("event_name_types", cboEventName);

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchComTask::Create()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  FORM_TRY
    TformRecordTaskCom* taskRecord = new TformRecordTaskCom(NULL, temp_map);
    taskRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchComTask::Zoom(const string & p_id)
{
  map<string,string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordTaskCom * taskRecord = new TformRecordTaskCom(NULL, temp_map);
    taskRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchComTask::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchComTask * z = new TformSearchComTask(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

