//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSearchDenialLetter.h"
#include "codeRecordDenialLetter.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRubberContainer"
#pragma link "codeSearchGeneric"
#pragma resource "*.dfm"
TformSearchDenialLetter *formSearchDenialLetter;
//---------------------------------------------------------------------------
__fastcall TformSearchDenialLetter::TformSearchDenialLetter(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string("denial_letters"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchDenialLetter::IsValidOnScreen()
{
  if (!lookupTables->IsInLookUpTable("service_types", cboServiceType->Text.c_str()))
  {
    PSay("Please enter a valid service type.", m_invalid_data, MB_OK);
    cboServiceType->SetFocus();
    return false;
  }
  else if (!lookupTables->IsInLookUpTable("denial_authority_types", cboAuthority->Text.c_str()))
  {
    PSay("Please enter a valid authority type.", m_invalid_data, MB_OK);
    cboAuthority->SetFocus();
    return false;
  }
  else if (!lookupTables->IsInLookUpTable("denial_status_types", cboStatus->Text.c_str()))
  {
    PSay("Please enter a valid status type.", m_invalid_data, MB_OK);
    cboStatus->SetFocus();
    return false;
  }
  else if (!lookupTables->IsInLookUpTable("denial_reason_types", cboReason->Text.c_str()))
  {
    PSay("Please enter a valid reason.", m_invalid_data, MB_OK);
    cboReason->SetFocus();
    return false;
  }
  else if (!Pdate(editEffectiveBeginDate->Text.c_str(), global_mode).IsValidDate() && !(editEffectiveBeginDate->Text == ""))
  {
    PSay("Please enter a valid beginning effective date.", m_invalid_data, MB_OK);
    editEffectiveBeginDate->SetFocus();
    return false;
  }
  else if (!Pdate(editEffectiveEndDate->Text.c_str(), global_mode).IsValidDate() && !(editEffectiveEndDate->Text == ""))
  {
    PSay("Please enter a valid ending effective date.", m_invalid_data, MB_OK);
    editEffectiveEndDate->SetFocus();
    return false;
  }
  else if (!Pdate(editProcessedBeginDate->Text.c_str(), global_mode).IsValidDate() && !(editProcessedBeginDate->Text == ""))
  {
    PSay("Please enter a valid beginning processed date.", m_invalid_data, MB_OK);
    editProcessedBeginDate->SetFocus();
    return false;
  }
  else if (!Pdate(editProcessedEndDate->Text.c_str(), global_mode).IsValidDate() && !(editProcessedEndDate->Text == ""))
  {
    PSay("Please enter a valid ending processed date.", m_invalid_data, MB_OK);
    editProcessedEndDate->SetFocus();
    return false;
  }
  else if (!Pdate(editDOSBeginDate->Text.c_str(), global_mode).IsValidDate() && !(editDOSBeginDate->Text == ""))
  {
    PSay("Please enter a valid beginning date of service.", m_invalid_data, MB_OK);
    editDOSBeginDate->SetFocus();
    return false;
  }
  else if (!Pdate(editDOSEndDate->Text.c_str(), global_mode).IsValidDate() && !(editDOSEndDate->Text == ""))
  {
    PSay("Please enter a valid ending date of service.", m_invalid_data, MB_OK);
    editDOSEndDate->SetFocus();
    return false;
  }
  else if (!IsAmount(editMinAmount->Text.c_str()))
  {
    PSay("Please enter a valid minimum billed amount.", m_invalid_data, MB_OK);
    editMinAmount->SetFocus();
    return false;
  }
  else if (!IsAmount(editMaxAmount->Text.c_str()))
  {
    PSay("Please enter a valid maximum billed amount.", m_invalid_data, MB_OK);
    editMaxAmount->SetFocus();
    return false;
  }
  else if (!IsAmount(editMinOwed->Text.c_str()))
  {
    PSay("Please enter a valid minimum patient owed amount.", m_invalid_data, MB_OK);
    editMinOwed->SetFocus();
    return false;
  }
  else if (!IsAmount(editMaxOwed->Text.c_str()))
  {
    PSay("Please enter a valid maximum patient owed amount.", m_invalid_data, MB_OK);
    editMaxOwed->SetFocus();
    return false;
  }
  else if (!IsAmount(editMinPayable->Text.c_str()))
  {
    PSay("Please enter a valid minimum payable amount.", m_invalid_data, MB_OK);
    editMinPayable->SetFocus();
    return false;
  }
  else if (!IsAmount(editMaxPayable->Text.c_str()))
  {
    PSay("Please enter a valid maximum payable amount.", m_invalid_data, MB_OK);
    editMaxPayable->SetFocus();
    return false;
  }

  return TformSearchGeneric::IsValidOnScreen();
}
//---------------------------------------------------------------------------
bool TformSearchDenialLetter::Search()
{
  string sql = "select person_names.last_name || ', ' || person_names.first_name name, "
               "tax_entities.name, service_types.item, denial_authority_types.item, denial_status_types.item, "
               "denial_letters.effective_date, denial_letters.date_processed, "
               "denial_items.begin_date_of_service, denial_items.end_date_of_service, denial_items.billed_amount, denial_items.patient_amount, denial_items.payable_amount, "
               "denial_letters.current_id, denial_letters.id "
               "from denial_letters "
               "inner join denials on denial_letters.denial_id = denials.id "
               "inner join people on denials.person_id = people.id "
               "inner join person_names on people.person_names_id = person_names.id "
               "inner join services_provided on denials.services_provided_id = services_provided.id "
               "inner join tax_entities on services_provided.tax_entity_id = tax_entities.id "
               "inner join service_types on services_provided.service_id = service_types.id "
               "inner join denial_authority_types on denial_letters.denial_authority_id = denial_authority_types.id "
               "inner join denial_status_types on denial_letters.denial_status_id = denial_status_types.id "
               "inner join denial_items on denial_items.denial_letter_id = denial_letters.id "
               "where denial_letters.id > 0 ";

  if (editLastName->Text != "")
    sql += "and upper(person_names.last_name) like '%" + SafeSQLString(editLastName->Text.c_str()) + "%' ";
  if (editFirstName->Text != "")
    sql += "and upper(person_names.first_name) like '%" + SafeSQLString(editFirstName->Text.c_str()) + "%' ";
  if (editEffectiveBeginDate->Text != "")
    sql += "and denial_letters.effective_date >= '" + Pdate(editEffectiveBeginDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
  if (editEffectiveEndDate->Text != "")
    sql += "and denial_letters.effective_date <= '" + Pdate(editEffectiveEndDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
  if (editProcessedBeginDate->Text != "")
    sql += "and denial_letters.date_processed >= '" + Pdate(editProcessedBeginDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
  if (editProcessedEndDate->Text != "")
    sql += "and denial_letters.date_processed <= '" + Pdate(editProcessedEndDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
  if (editDOSBeginDate->Text != "")
  {
    string begin_date = Pdate(editDOSBeginDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy);
    sql += "and (denial_items.begin_date_of_service >= '" + begin_date + "' or "
           "denial_items.end_date_of_service >= '" + begin_date + "') ";
  }
  if (editDOSEndDate->Text != "")
  {
    string end_date = Pdate(editDOSEndDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy);
    sql += "and (denial_items.begin_date_of_service <= '" + end_date + "' or "
           "denial_items.end_date_of_service <= '" + end_date + "') ";
  }
  if (editServiceProvider->Text != "")
    sql += "and upper(tax_entities.name) like '%" + SafeSQLString(editServiceProvider->Text.c_str()) + "%' ";
  if (cboServiceType->Text != "")
    sql += "and service_types.id = '" + lookupTables->IdOf("service_types", cboServiceType->Text.c_str()) + "' ";
  if (cboAuthority->Text != "")
    sql += "and denial_authority_types.id = '" + lookupTables->IdOf("denial_authority_types", cboAuthority->Text.c_str()) + "' ";
  if (cboStatus->Text != "")
    sql += "and denial_status_types.id = '" + lookupTables->IdOf("denial_status_types", cboStatus->Text.c_str()) + "' ";
  if (cboReason->Text != "")
  {
    sql += "and exists (select * from denial_reasons "
           "where denial_letter_id = denial_letters.id and denial_reason_id = '" + lookupTables->IdOf("denial_reason_types", cboReason->Text.c_str()) +  "') ";
  }
  if (editMinAmount->Text != "")
    sql += "and denial_items.billed_amount >= '" + SafeSQLString(editMinAmount->Text.c_str()) + "' ";
  if (editMaxAmount->Text != "")
    sql += "and denial_items.billed_amount <= '" + SafeSQLString(editMaxAmount->Text.c_str()) + "' ";
  if (editMinOwed->Text != "")
    sql += "and denial_items.patient_amount >= '" + SafeSQLString(editMinOwed->Text.c_str()) + "' ";
  if (editMaxOwed->Text != "")
    sql += "and denial_items.patient_amount <= '" + SafeSQLString(editMaxOwed->Text.c_str()) + "' ";
  if (editMinPayable->Text != "")
    sql += "and denial_items.payable_amount >= '" + SafeSQLString(editMinPayable->Text.c_str()) + "' ";
  if (editMaxPayable->Text != "")
    sql += "and denial_items.payable_amount <= '" + SafeSQLString(editMaxPayable->Text.c_str()) + "' ";

  Filter->SetSQLStatement(sql);
  Filter->RefreshDataSet();

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchDenialLetter::ScreenStart()
{
  lookupTables->RegisterComboBox("service_types", cboServiceType);
  lookupTables->RegisterComboBox("denial_authority_types", cboAuthority);
  lookupTables->RegisterComboBox("denial_status_types", cboStatus);
  lookupTables->RegisterComboBox("denial_reason_types", cboReason);

  Filter->SetListViewHandle(listResults);
  Filter->SetSecurity("denial_letters");
  Filter->AddColumnSpec("Name", "people", as_text, true, 130);
  Filter->AddColumnSpec("Provider", "tax_entities", as_text, true, 120);
  Filter->AddColumnSpec("Service", "services_provided", as_text, true, 90);
  Filter->AddColumnSpec("Authority", "denial_letters", as_text, true, 100, rawString);
  Filter->AddColumnSpec("Status", "denial_letters", as_text, true, 60, rawString);
  Filter->AddColumnSpec("Effective", "denial_letters", as_date, true, 80);
  Filter->AddColumnSpec("Processed", "denial_letters", as_date, true, 80);
  Filter->AddColumnSpec("DOS From", "denial_items", as_date, true, 80);
  Filter->AddColumnSpec("DOS To", "denial_items", as_date, true, 80);
  Filter->AddColumnSpec("Bill amount", "denial_items", as_double, true, 80, amountString);
  Filter->AddColumnSpec("Patient owes", "denial_items", as_double, true, 80, amountString);
  Filter->AddColumnSpec("Payable amount", "denial_items", as_double, true, 90, amountString);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchdenialletter.filter");
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

  TformSearchGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchDenialLetter::ScreenStop()
{
  lookupTables->UnregisterComboBox("service_types", cboServiceType);
  lookupTables->UnregisterComboBox("denial_authority_types", cboAuthority);
  lookupTables->UnregisterComboBox("denial_status_types", cboStatus);
  lookupTables->UnregisterComboBox("denial_reason_types", cboReason);

  TformSearchGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchDenialLetter::Create()
{
  PSay("To create a denial letter, use the Person Search screen, navigate to Contract Health, and select the Denials tab.\n"
       "You can create a new denial batch there and add letters to it.", m_message, MB_OK);
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchDenialLetter::Zoom(const string &p_id)
{
  map<string, string> temp_map;
  temp_map["id"] = p_id;
  TformRecordDenialLetter::Do(temp_map);
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchDenialLetter::Do(TformSpecialGeneric *p_parent)
{
  vector<string> answer;
  FORM_TRY
    TformSearchDenialLetter *nf = new TformSearchDenialLetter(NULL, &answer);
    nf->ShowTaskModal(p_parent);
  FORM_CATCH
  return answer;
}
//---------------------------------------------------------------------------

