//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
 
#include "codeSearchDiabEducation.h"
#include "codeRecordDiabScore.h"
#include "codeSearchPerson.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchDiabEducation *formSearchDiabEducation;
//---------------------------------------------------------------------------
__fastcall TformSearchDiabEducation::TformSearchDiabEducation(TComponent* Owner, vector<string> * p_return_vector, string p_person_id)
        : TformSearchGeneric(Owner, p_return_vector, string ("diab_education"))
{
  person_id = p_person_id;
  map<string, string> temp_map;
  string sql;
  if((person_id != "") && (person_id != "0") && (IsInt(person_id)))
  {
    sql = "select first_name, last_name from person_names inner join people on "
          "people.person_names_id = person_names.id";
    SqlToMap(dbDatabase, sql, temp_map);
    editLastName->Text = PrettyString(temp_map["last_name"]).c_str();
    editFirstName->Text = PrettyString(temp_map["first_name"]).c_str();    
  }
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchDiabEducation::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxes
  // corrospond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect
  if (! lookupTables->IsInLookUpTable("diab_topic_types", cboTopic->Text.c_str()))
  {
    PSay("Please enter a valid topic", m_invalid_data, MB_OK);
    cboTopic->SetFocus();
    return false;
  }
  else if (! Pdate (editBeginDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editBeginDate->Text == ""))
  {
    PSay("Please enter a valid begin date", m_invalid_data, MB_OK);
    editBeginDate->SetFocus();
    return false;
  }
  else if (! Pdate (editEndDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editEndDate->Text == ""))
  {
    PSay("Please enter a valid end date", m_invalid_data, MB_OK);
    editEndDate->SetFocus();
    return false;
  }
  else if (! IsAmount(editMinPreScore->Text.c_str(), 15, 2))
  {
    PSay("Please enter a valid min pre-score", m_invalid_data, MB_OK);
    editMinPreScore->SetFocus();
    return false;
  }
  else if (! IsAmount(editMaxPreScore->Text.c_str(), 15, 2))
  {
    PSay("Please enter a valid max pre-score", m_invalid_data, MB_OK);
    editMaxPreScore->SetFocus();
    return false;
  }
  else if (! IsAmount(editMinPostScore->Text.c_str(), 15, 2))
  {
    PSay("Please enter a valid min post-score", m_invalid_data, MB_OK);
    editMinPostScore->SetFocus();
    return false;
  }
  else if (! IsAmount(editMaxPostScore->Text.c_str(), 15, 2))
  {
    PSay("Please enter a valid max post-score", m_invalid_data, MB_OK);
    editMaxPostScore->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformSearchDiabEducation::Search()
{
  string sql = "";

  sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix, "
        "diab_topic_types.item, diab_education.pre_test_date, diab_education.pre_score, "
        "diab_education.post_test_date, diab_education.post_score, diab_education.note, "
        "diab_education.current_id, diab_education.id "
        "from diab_education inner join people on diab_education.person_id = people.id "
        "left join person_names on people.person_names_id = person_names.id "
        "inner join diab_topic_types on diab_education.diab_topic_id = diab_topic_types.id "
        "where diab_education.id > 0 ";

  if(editLastName->Text != "")
    sql += "and person_names.last_name like '%" + SafeSQLString(editLastName->Text.c_str()) + "%' ";
  if(editFirstName->Text != "")
    sql += "and person_names.first_name like '%" + SafeSQLString(editFirstName->Text.c_str()) + "%' ";
  if (cboTopic->Text != "")
    sql += "and diab_education.diab_topic_id = " + lookupTables->IdOf("diab_topic_types", cboTopic->Text.c_str()) + " ";
  if (editBeginDate->Text != "")
    sql += "and (diab_education.pre_test_date >= '" + Pdate(editBeginDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' or "
           " diab_education.post_test_date >= '" + Pdate(editBeginDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "') ";
  if (editEndDate->Text != "")
    sql += "and (diab_education.pre_test_date <= '" + Pdate(editEndDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' or "
           " diab_education.post_test_date <= '" + Pdate(editEndDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "') ";
  if (editMinPreScore->Text != "")
    sql += "and diab_education.pre_score >= " + string(editMinPreScore->Text.c_str()) + " ";
  if (editMaxPreScore->Text != "")
    sql += "and diab_education.pre_score <= " + string(editMaxPreScore->Text.c_str()) + " ";
  if (editMinPostScore->Text != "")
    sql += "and diab_education.post_score >= " + string(editMinPostScore->Text.c_str()) + " ";
  if (editMaxPostScore->Text != "")
    sql += "and diab_education.post_score <= " + string(editMaxPostScore->Text.c_str()) + " ";

  Filter->SetSQLStatement (sql);
  Filter->RefreshDataSet ();

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchDiabEducation::ScreenStart()
{
  lookupTables->RegisterComboBox("diab_topic_types", cboTopic);

  Filter->SetSecurity("activities");
  Filter->AddColumnSpec("Person", "people", as_text, true, 100);
  Filter->AddColumnSpec("Topic", "diab_education", as_text, true, 100);
  Filter->AddColumnSpec("Pre-Test Date", "diab_education", as_date, true, 110);
  Filter->AddColumnSpec("Pre-Score", "diab_education", as_double, true, 90);
  Filter->AddColumnSpec("Post-Test Date", "diab_education", as_date, true, 110);
  Filter->AddColumnSpec("Post-Score", "diab_education", as_double, true, 90);
  Filter->AddColumnSpec("Note", "diab_education", as_text, true, 110, sentenceString);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchdiabeducation.filter");
  Filter->SetIconStatus(true);
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

 return true;
}
//---------------------------------------------------------------------------
bool TformSearchDiabEducation::ScreenStop()
{
 // instead of formclose, do shutdown stuff here (combo boxes, etc.)
  lookupTables->UnregisterComboBox("diab_topic_types", cboTopic);
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchDiabEducation::Create()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  FORM_TRY
    TformRecordDiabScore * educationRecord = new TformRecordDiabScore(NULL, temp_map);
    educationRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchDiabEducation::Zoom(const string & p_id)
{
  map<string,string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordDiabScore * educationRecord = new TformRecordDiabScore(NULL, temp_map);
    educationRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchDiabEducation::Do(TformSpecialGeneric * p_parent)
{
 return TformSearchDiabEducation::Do(p_parent, "");
}
//---------------------------------------------------------------------------
vector<string> TformSearchDiabEducation::Do(TformSpecialGeneric * p_parent, string p_person_id)
{
 vector<string> answer;
 FORM_TRY
  TformSearchDiabEducation * z = new TformSearchDiabEducation(NULL, &answer, p_person_id);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

