//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
 
#include "codeSearchFeeSchedule.h"
#include "codeRecordFeeSchedule.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchFeeSchedule *formSearchFeeSchedule;
//---------------------------------------------------------------------------
__fastcall TformSearchFeeSchedule::TformSearchFeeSchedule(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("codes"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchFeeSchedule::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxes
  // correspond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect
  if (! IsAmount (editMinFee->Text.c_str()) && ! (editMinFee->Text == ""))
  {
    PSay("Please enter a valid minimum fee", m_invalid_data, MB_OK);
    editMinFee->SetFocus();
    return false;
  }
  else if (! IsAmount (editMaxFee->Text.c_str()) && ! (editMaxFee->Text == ""))
  {
    PSay("Please enter a valid maximum fee", m_invalid_data, MB_OK);
    editMaxFee->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformSearchFeeSchedule::Search()
{
  string sql = "select codes.code, codes.description, codes.clinic_cost, codes.medicare_cost, codes.medicaid_cost, "
               "codes.current_id, codes.id "
               "from codes "
               "where codes.code_id = " + lookupTables->IdOf("code_types", "CPT-4");
  if (editCode->Text != "")
    sql += " and codes.code like '" + SafeSQLString(editCode->Text.c_str()) + "%'";
  if (editDescription->Text != "")
    sql += "and codes.description like '%" + SafeSQLString(editDescription->Text.c_str()) + "%'";
  if (editMinFee->Text != "")
    sql += " and codes.clinic_cost >= '" + StripAllExcept(editMinFee->Text.c_str(), floats) + "'";
  if (editMaxFee->Text != "")
    sql += " and codes.clinic_cost <= '" + StripAllExcept(editMaxFee->Text.c_str(), floats) + "'";
  // sql += " order by codes.code";

  Filter->SetSQLStatement (sql);
  Filter->RefreshDataSet ();

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchFeeSchedule::ScreenStart()
{
  Filter->SetSecurity("codes");
  Filter->AddColumnSpec("Code", "codes", as_text, true, 90);
  Filter->AddColumnSpec("Description", "codes", as_text, true, 230, sentenceString);
  Filter->AddColumnSpec("Clinic Fee", "codes", as_double, true, 90, amountString);
  Filter->AddColumnSpec("Medicare Fee", "codes", as_double, false, 90, amountString);
  Filter->AddColumnSpec("Medicaid Fee", "codes", as_double, false, 90, amountString);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->SetPreferences("searchfeeschedule.filter");
  Filter->SetIconStatus(true);
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

 return true;
}
//---------------------------------------------------------------------------
bool TformSearchFeeSchedule::ScreenStop()
{
 // instead of formclose, do shutdown stuff here (combo boxes, etc.)
 return true;
}
//---------------------------------------------------------------------------
bool TformSearchFeeSchedule::Zoom(const string & p_id)
{
  map<string,string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordFeeSchedule * feeScheduleRecord = new TformRecordFeeSchedule(NULL, temp_map);
    feeScheduleRecord->Show();
  FORM_CATCH
  return true;

}
//---------------------------------------------------------------------------
bool TformSearchFeeSchedule::Create()
{
  PSay("I'm sorry, but you cannot create new codes.", m_message, MB_OK);
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchFeeSchedule::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchFeeSchedule * z = new TformSearchFeeSchedule(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

