//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
 
#include "codeSearchFitnessMembership.h"
#include "codeRecordFitnessMembership.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchFitnessMembership *formSearchFitnessMembership;
//---------------------------------------------------------------------------
__fastcall TformSearchFitnessMembership::TformSearchFitnessMembership(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("fitness_memberships"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchFitnessMembership::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxes
  // corrospond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect
  if (! lookupTables->IsInLookUpTable("fit_facility_types", cboFacility->Text.c_str()))
  {
    PSay("Please enter a valid facility", m_invalid_data, MB_OK);
    cboFacility->SetFocus();
    return false;
  }
  else if (! Pdate (editBeginWarningDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editBeginWarningDate->Text == ""))
  {
    PSay("Please enter a valid begin warning date", m_invalid_data, MB_OK);
    editBeginWarningDate->SetFocus();
    return false;
  }
  else if (! Pdate (editEndWarningDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editEndWarningDate->Text == ""))
  {
    PSay("Please enter a valid end warning date", m_invalid_data, MB_OK);
    editEndWarningDate->SetFocus();
    return false;
  }
  else if (! Pdate (editBeginJoinDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editBeginJoinDate->Text == ""))
  {
    PSay("Please enter a valid begin join date", m_invalid_data, MB_OK);
    editBeginJoinDate->SetFocus();
    return false;
  }
  else if (! Pdate (editEndJoinDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editEndJoinDate->Text == ""))
  {
    PSay("Please enter a valid end join date", m_invalid_data, MB_OK);
    editEndJoinDate->SetFocus();
    return false;
  }
  else if (! Pdate (editBeginCancelDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editBeginCancelDate->Text == ""))
  {
    PSay("Please enter a valid begin cancel date", m_invalid_data, MB_OK);
    editBeginCancelDate->SetFocus();
    return false;
  }
  else if (! Pdate (editEndCancelDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editEndCancelDate->Text == ""))
  {
    PSay("Please enter a valid end cancel date", m_invalid_data, MB_OK);
    editEndCancelDate->SetFocus();
    return false;
  }
  else if (! Pdate (editBeginWaitingDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editBeginWaitingDate->Text == ""))
  {
    PSay("Please enter a valid begin waiting date", m_invalid_data, MB_OK);
    editBeginWaitingDate->SetFocus();
    return false;
  }
  else if (! Pdate (editEndWaitingDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editEndWaitingDate->Text == ""))
  {
    PSay("Please enter a valid end waiting date", m_invalid_data, MB_OK);
    editEndWaitingDate->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformSearchFitnessMembership::Search()
{
 string sql = "";

 sql = "select fit_facility_types.item, "
       "person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix, "
       "fitness_memberships.begin_date, fitness_memberships.end_date, fitness_memberships.membership_number, "
       "max(tasks.date_of_task), fitness_memberships.is_waiting, "
       "fitness_memberships.waiting_list_date, fitness_memberships.current_id, "
       "fitness_memberships.id "
       "from fitness_memberships "
       "left join fitness_people on fitness_people.fitness_membership_id = fitness_memberships.id and "
       "fitness_people.is_primary = 1 "
       "left join people on fitness_people.person_id = people.id "
       "left join person_names on people.person_names_id = person_names.id "
       "left join fit_facility_types on fitness_memberships.fit_facility_id = fit_facility_types.id "
       "left join tasks on tasks.fitness_membership_id = fitness_memberships.id and "
       "tasks.diab_activity_id = " + lookupTables->IdOf("diab_activity_types", "attendance warning letter") + " and "
       "tasks.current_id >= 3 "
       "where fitness_memberships.id > 0 ";

 if (cboFacility->Text != "")
   sql += "and fitness_memberships.fit_facility_id = " + lookupTables->IdOf("fit_facility_types", cboFacility->Text.c_str()) + " ";
 if ((editFirstName->Text != "") || (editLastName->Text != ""))
 {
  sql += "and exists(select * from people inner_people inner join person_names inner_person_names on "
          "inner_people.person_names_id = inner_person_names.id "
          "inner join fitness_people inner_fitness_people on inner_fitness_people.person_id = inner_people.id "
          "and inner_fitness_people.fitness_membership_id = fitness_memberships.id where ";
   if(editLastName->Text != "")
     sql += "inner_person_names.last_name like '%" + SafeSQLString(editLastName->Text.c_str()) + "%' and ";
   if(editFirstName->Text != "")
     sql += "inner_person_names.first_name like '%" + SafeSQLString(editFirstName->Text.c_str()) + "%' and ";
   sql = sql.substr(0, sql.length()-4);
   sql += ") ";
 }
 if (editCdib->Text != "")
 {
  sql += "and exists(select * from people inner_people inner join affiliations inner_affiliations on "
          "inner_people.affiliations_id = inner_affiliations.id "
          "inner join fitness_people inner_fitness_people on inner_fitness_people.person_id = inner_people.id "
          "and inner_fitness_people.fitness_membership_id = fitness_memberships.id where "
          "inner_affiliations.cdib like '%" + SafeSQLString(editCdib->Text.c_str()) + "%')";
 }
 if(radioMembership->Checked)
 {
   sql += "and fitness_memberships.is_waiting = 0 ";
   if(editMembershipNumber->Text != "")
     sql += "and fitness_memberships.membership_number = '" + SafeSQLString(editMembershipNumber->Text.c_str()) + "' ";
   if(editBeginJoinDate->Text != "")
     sql += "and fitness_memberships.begin_date >= '" + Pdate(editBeginJoinDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
   if(editEndJoinDate->Text != "")
     sql += "and fitness_memberships.begin_date <= '" + Pdate(editEndJoinDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
   if(editBeginCancelDate->Text != "")
     sql += "and fitness_memberships.end_date >= '" + Pdate(editBeginCancelDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
   if(editEndCancelDate->Text != "")
     sql += "and fitness_memberships.end_date <= '" + Pdate(editEndCancelDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
 }
 if(radioWaiting->Checked)
 {
   sql += "and fitness_memberships.is_waiting = 1 ";
   if(editBeginWaitingDate->Text != "")
     sql += "and fitness_memberships.waiting_list_date >= '" + Pdate(editBeginWaitingDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
   if(editEndWaitingDate->Text != "")
     sql += "and fitness_memberships.waiting_list_date <= '" + Pdate(editEndWaitingDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
 }

  sql += "group by fit_facility_types.item, person_names.last_name, person_names.first_name, person_names.suffix, "
         "fitness_memberships.begin_date, fitness_memberships.end_date, fitness_memberships.membership_number, "
         "fitness_memberships.is_waiting, "
         "fitness_memberships.waiting_list_date, fitness_memberships.current_id, fitness_memberships.id ";

 if(radioWaiting->Checked)
 {
  if((editBeginWarningDate->Text != "") || (editEndWarningDate->Text != ""))
  {
    sql += "having ";
    if(editBeginWarningDate->Text != "")
      sql += "tasks.date_of_task >= '" + Pdate(editBeginWarningDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
    if(editEndWarningDate->Text != "")
      sql += "tasks.date_of_task <= '" + Pdate(editEndWarningDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
    // add more having clauses? okay, i made that more difficult. so sue me. -philip
    sql = sql.substr(0, sql.length()-4);
  }
 }
  Filter->SetSQLStatement (sql);
  Filter->RefreshDataSet ();

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchFitnessMembership::ScreenStart()
{
  lookupTables->RegisterComboBox("fit_facility_types", cboFacility);

  Filter->SetSecurity("fitness_memberships");
  Filter->AddColumnSpec("Facility", "fitness_memberships", as_text, true, 150);
  Filter->AddColumnSpec("Primary", "people", as_text, true, 150);
  Filter->AddColumnSpec("Join Date", "fitness_memberships", as_date, true, 100);
  Filter->AddColumnSpec("Cancel Date", "fitness_memberships", as_date, true, 100);
  Filter->AddColumnSpec("Membership #", "fitness_memberships", as_text, true, 60);
  Filter->AddColumnSpec("Last Warning", "fitness_memberships", as_date, true, 100);
  Filter->AddColumnSpec("Is waiting", "fitness_memberships", as_text, true, 100, prettyBoolString);
  Filter->AddColumnSpec("Wait Add Date", "fitness_memberships", as_date, true, 100);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchfitnessmembership.filter");
  Filter->SetIconStatus(true);
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

 return true;
}
//---------------------------------------------------------------------------
bool TformSearchFitnessMembership::ScreenStop()
{
 // instead of formclose, do shutdown stuff here (combo boxes, etc.)
  lookupTables->UnregisterComboBox("fit_facility_types", cboFacility);
 return true;
}
//---------------------------------------------------------------------------
bool TformSearchFitnessMembership::Create()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  FORM_TRY
    TformRecordFitnessMembership * membershipRecord = new TformRecordFitnessMembership(NULL, temp_map);
    membershipRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchFitnessMembership::Zoom(const string & p_id)
{
  map<string,string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordFitnessMembership * membershipRecord = new TformRecordFitnessMembership(NULL, temp_map);
    membershipRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TformSearchFitnessMembership::radioMembershipClick(
      TObject *Sender)
{
 RecurseEnabledAny(panelMembership, radioMembership->Checked);
 RecurseEnabledAny(panelWaiting, radioWaiting->Checked);
}
//---------------------------------------------------------------------------
void __fastcall TformSearchFitnessMembership::FormShow(TObject *Sender)
{
 TformSearchGeneric::FormShow(Sender);
 radioMembershipClick(NULL);
}
//---------------------------------------------------------------------------
vector<string> TformSearchFitnessMembership::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchFitnessMembership * z = new TformSearchFitnessMembership(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

