//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#pragma warn -8057
 
#include "codeSearchGeneric.h"
// extern list<TformSearchGeneric*>  generic_searches;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"

//---------------------------------------------------------------------------
__fastcall TformSearchGeneric::TformSearchGeneric(TComponent* Owner, vector<string> * p_return_vector, string p_table_name)
        : TformSpecialGeneric(Owner)
{
 title_name = this->Caption.c_str();
 IconIndex = 12;
 this->Constraints->MaxHeight = 0;
 this->Constraints->MaxWidth = 0;
 return_vector = p_return_vector;
 table_name = p_table_name;
 no_perm_needed = false; // jhaley 20110505: for search forms that don't need a permission

 // generic_searches.push_back(this);
 if (!return_vector)
  buttonSelect->Enabled = false;
 else
  buttonSelect->Enabled = true;
 buttonCancel->Enabled = true;
 if (optionsPermissions["table."+table_name]["view"] == "true")
  buttonSearch->Enabled = true;
 else
  buttonSearch->Enabled = false;
 if (optionsPermissions["table."+table_name]["insert"] == "true")
  buttonNew->Enabled = true;
 else
  buttonNew->Enabled = false;

 FORM_TRY
  favorites_window                = new TformDrawerSearchFavorites(NULL);
 FORM_CATCH
 favorites_window->DrawerOwner    = this;
 favorites_window->Width          = 200;
 favorites_window->DrawerPosition = akRight;

 if (!DefaultTextAvailable(table_name))
  buttonFavorites->Enabled = false;
 else
  if (optionsPreferences["search_generic"]["auto_open_favorites"] == "true")
   favorites_window->DrawerExpanded = true;

 // try to enforce a slight minimum. not very exactly calculated, but a lot of search forms don't have a good minheight.
 Constraints->MinHeight = max(Constraints->MinHeight, toolsStandard->Height + scrollStandard->Height + 25);
}
//---------------------------------------------------------------------------
void __fastcall TformSearchGeneric::buttonSelectClick(TObject *Sender)
{
 if (return_vector)
 {
  vector<string> possible_return_vector;
  vector<string> main_result;
  vector<string> favorites_result;

  main_result = Filter->GetMultiID();

  vector<map<string, string> > favorites_raw_result;
  favorites_window->list_favorites.export_selected_data (favorites_raw_result);
  for (vector<map<string, string> >::iterator i = favorites_raw_result.begin(); i != favorites_raw_result.end(); i++)
   favorites_result.push_back((*i)["id"]);

  // favorites get priority?
  possible_return_vector.insert(possible_return_vector.end(), favorites_result.begin(), favorites_result.end());
  possible_return_vector.insert(possible_return_vector.end(), main_result.begin(), main_result.end());

  if (!possible_return_vector.empty())
  {
   // bah, just hand it over. swapping was the fastest way to write it ...
   // and maybe even the fastest way to do it? not having to do the bit-copy
   // could improve speed, and we don't care about possible_return_vector at
   // all after this ... hmph. cool.
   return_vector->swap(possible_return_vector);
  }
  else
  {
   // if hitting 'select' rather than 'cancel' they want to change stuff...
   // so since we have zero-id's everywhere, and they're valid for pointers,
   // we return zero as the id number, so it'll point to an empty and
   // pretty much meaningless record. yup.
   // Sorry, Philip, that didn't make sense.  Let ME explain:  If they don't
   // select anything (or don't search) and then hit Select, we return an ID
   // of 0 which will replace whatever was in the link with "None", effectively
   // "unlinking" that item.
   return_vector->clear();
   return_vector->push_back("0");
  }
 }
  // no vector expected (non-modal) - just exit
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSearchGeneric::buttonNewClick(TObject *Sender)
{
 // opens window to create new record of this type
 if (optionsPermissions["table."+table_name]["insert"] == "true")
 {
  // open "new" window
  Create();
 }
 else
  PSay("You are not authorized to create new records of this type.", m_message, MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TformSearchGeneric::buttonSearchClick(TObject *Sender)
{
 if (no_perm_needed || optionsPermissions["table."+table_name]["view"] == "true")
 {
  // perform the search
  if (IsValidOnScreen())
  {
   Screen->Cursor = crHourGlass;
   this->Update();
   FocusAway();
   Search();
   FocusBack();
   if(return_vector)
   {
     listSearchResults->SetFocus();
     // changed the following so that searches would keep an item selected from search to search if possible ... to be consistent with changes elsewhere.
     if(listSearchResults->Items->Count > 0 && listSearchResults->SelCount == 0)
       listSearchResults->Items->Item[0]->Selected = true;
   }
   //string new_title(title_name + " - " + IntToString(Filter->GetResultSize()) + " results found");
   //this->Caption = new_title.c_str();
   Screen->Cursor = crDefault;
  }
 }
 else
  PSay("You are not authorized to view records of this type.", m_message, MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TformSearchGeneric::buttonCancelClick(TObject *Sender)
{
 if (return_vector)
 {
  return_vector->clear();
 }
 Close();
}
//---------------------------------------------------------------------------
bool TformSearchGeneric::CloseNow()
{
 if (return_vector)
 {
  return_vector->clear();
 }
 Close();
 return true;
}
//---------------------------------------------------------------------------
void __fastcall TformSearchGeneric::FormClose(TObject *Sender,
      TCloseAction &Action)
{
 ScreenStop();
 // UnregisterLinks(this);
 // generic_searches.remove(this);
 Action = caFree;
 TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
bool TformSearchGeneric::Search()
{
 return true;
}
//---------------------------------------------------------------------------
bool TformSearchGeneric::Create()
{
 return true;
}
//---------------------------------------------------------------------------
bool TformSearchGeneric::Zoom(const string & p_id)
{
 return true;
}
//---------------------------------------------------------------------------
bool TformSearchGeneric::IsValidOnScreen()
{
 return true;
}
//---------------------------------------------------------------------------
bool TformSearchGeneric::ScreenStart()
{
 // this gets overriden all the time, and deals with the derived-form's controls
 // it's part of the setup logic ... and although we could call 'ScreenStart'
 // directly ... well, since RecordGeneric did it this way, it seemed easier to
 // remember. compiler will probably optimize it away anyway. so who cares?
 // yeah, you probably do if you're reading this. you'll be okay. i swear.

 // actually, I don't, but thanks  :-)
 return true;
}
//---------------------------------------------------------------------------
bool TformSearchGeneric::ScreenStop()
{
 return true;
}

//---------------------------------------------------------------------------
bool TformSearchGeneric::Initialize()
{
 // moved from constructor
 Filter->SetListViewHandle(listSearchResults);
 Filter->SetAddEdit(this, AddRecord(&(TformSearchGeneric::Create)), EditRecord(&(TformSearchGeneric::Zoom)));
 Filter->SetInform(this, InformForm(&(TformSearchGeneric::SqlModified)));
 Filter->SetMulti(true); // new, shouldn't cause any problems (but people may be confused about only the first item being used?)
 // moved from constructor
 panelInfoBar->Top = -1; // that shit should be on top
 ScreenStart();
 return true;
}
//---------------------------------------------------------------------------
void __fastcall TformSearchGeneric::listResultsKeyPress(TObject *Sender, char &Key)
{
 // let's try to do the Select button thing if they hit enter, eh?
 if (IsEnter(Key) && buttonSelect->Enabled)
  buttonSelect->Click();
}
//---------------------------------------------------------------------------
void __fastcall TformSearchGeneric::FormShortCut(TWMKey &Msg, bool &Handled)
{
  TformSpecialGeneric::FormShortCut(Msg, Handled);

  Handled = false;
  if((Msg.CharCode == VK_RETURN) && (! listSearchResults->Focused()))
  {
    Handled = true;
    buttonSearchClick(NULL);
  }
  if(HIBYTE(GetAsyncKeyState(VK_CONTROL)) && (Msg.CharCode == 'f' || Msg.CharCode == 'F'))
  {
    Handled = true;
    favorites_window->DrawerExpanded = true;
  }
}
//---------------------------------------------------------------------------
void TformSearchGeneric::SqlModified()
{
  string new_title(title_name + " - " + IntToString(Filter->GetResultSize()) + " results found");
  this->Caption = new_title.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformSearchGeneric::buttonFavoritesClick(TObject *Sender)
{
  favorites_window->DrawerExpanded = buttonFavorites->Down;
}
//---------------------------------------------------------------------------
void TformSearchGeneric::DrawerIsChanging (TformSpecialGeneric * Drawer, bool Expanding)
{
  if (Drawer == favorites_window)
   buttonFavorites->Down = favorites_window->DrawerExpanded;
  TformSpecialGeneric::DrawerIsChanging(Drawer, Expanding);
  return;
}
//---------------------------------------------------------------------------
int TformSearchGeneric::CalcHeight()
{
  return TformSpecialGeneric::CalcHeight() + listSearchResults->Height;
}
//---------------------------------------------------------------------------
classFilterObject * TformSearchGeneric::GetFilter()
{
 return &results_filter;
}
//---------------------------------------------------------------------------
TListView * TformSearchGeneric::GetListSearchResults()
{
 return listResults;
}
//---------------------------------------------------------------------------

