//---------------------------------------------------------------------------

#ifndef codeSearchGenericH
#define codeSearchGenericH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>

#include "codeSpecialGeneric.h"
#include "codeDrawerSearchFavorites.h"
#include "Filter.h"
#include "codeRubberContainer.h"
//#include "utilityheaders.h"
//#include "baseheaders.h"
//#include "components.h"
//---------------------------------------------------------------------------
class TformSearchGeneric : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *buttonSearch;
        TToolButton *buttonSelect;
        TToolButton *buttonNew;
        TToolButton *sepStandard3;
        TSplitter *splitterSearch;
        TToolButton *sepStandard2;
        TToolButton *buttonCancel;
        TToolButton *buttonFavorites;
        TRubberContainer *rubberSearchResults;
        TListView *listResults;
        void __fastcall buttonSelectClick(TObject *Sender);
        void __fastcall buttonNewClick(TObject *Sender);
        void __fastcall buttonSearchClick(TObject *Sender);
        void __fastcall buttonCancelClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall listResultsKeyPress(TObject *Sender,
          char &Key);
        void __fastcall FormShortCut(TWMKey &Msg, bool &Handled);
        void __fastcall buttonFavoritesClick(TObject *Sender);
private:	// User declarations
        vector <string> * return_vector;
        classFilterObject results_filter;
protected:      // User declarations
        bool no_perm_needed;
        TformDrawerSearchFavorites * favorites_window;
        string title_name;
        void DrawerIsChanging (TformSpecialGeneric * Drawer, bool Expanding);
        bool virtual IsValidOnScreen();
        bool virtual ScreenStart();
        bool virtual ScreenStop();
        bool virtual Initialize();          // called by derived forms to start old constructor behavior
        void virtual SqlModified();
        int CalcHeight();
public:		// User declarations
        string table_name;                           // for security checks
        virtual classFilterObject * GetFilter();
        virtual TListView * GetListSearchResults();

        __property TListView * listSearchResults = {read = GetListSearchResults};
        __property classFilterObject * Filter = {read = GetFilter};

        __fastcall TformSearchGeneric(TComponent* Owner, vector<string> * p_return_vector, string p_table_name);
        bool virtual CloseNow();
        bool virtual Search();
        bool virtual Create();
        bool virtual Zoom(const string & p_id);

        void SetNoPermNeeded(bool p) { no_perm_needed = p; }
};
//---------------------------------------------------------------------------
//extern PACKAGE TformSearchGeneric *formSearchGeneric;
//---------------------------------------------------------------------------
#endif
