//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSearchLogsheet.h"
#include "codeRecordLogsheet.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchLogsheet *formSearchLogsheet;
//---------------------------------------------------------------------------
__fastcall TformSearchLogsheet::TformSearchLogsheet(TComponent* Owner,vector<string> * p_return_vector, string activity_person_id)
        : TformSearchGeneric(Owner, p_return_vector, string ("activity_logsheets"))
{
 string sql;
 vector<map<string,string> > field_vec;
 person_id = activity_person_id;
 if (person_id != "")
 {
  sql = "select person_names.last_name, person_names.first_name from people left join person_names on people.person_names_id = person_names.id where person_names.person_id = '" + person_id + "'";
  SqlToVecMap(dbDatabase, sql, field_vec);
  editLastName->Text = PrettyString(field_vec[0]["last_name"]).c_str();
  editFirstName->Text = PrettyString(field_vec[0]["first_name"]).c_str();
  editLastName->Enabled = false;
  editFirstName->Enabled = false;
 }
 Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchLogsheet::Search()
{
 string sql = "";

 sql = "select activity_logsheets.date_turned_in, person_names.last_name || ', ' || person_names.first_name name, "
       "activity_logsheets.begin_date, activity_logsheets.end_date, activity_logsheets.current_id, activity_logsheets.id "
       "from activity_logsheets, "
       "people left join person_names on people.person_names_id = person_names.id "
       "where activity_logsheets.person_id = people.id and ";

 if (person_id != "")
 {
   sql += "activity_logsheets.person_id = " + person_id + " and ";
 }
 else
 {
   if (editLastName->Text != "")
     sql += "exists (select person_names.last_name from person_names "
             "where person_names.person_id = people.id and person_names.current_id>0 and "
             "person_names.last_name like '" + SafeSQLString(editLastName->Text.c_str()) + "%') and ";
   if (editFirstName->Text != "")
     sql += "exists (select person_names.first_name from person_names "
             "where person_names.person_id = people.id and person_names.current_id>0 and "
             "person_names.first_name like '" + SafeSQLString(editFirstName->Text.c_str()) + "%') and ";
 }
 if (editBeginDate->Text != "")
   sql += "activity_logsheets.begin_date = '" + Pdate(editBeginDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
 if (editEndDate->Text != "")
   sql += "activity_logsheets.end_date = '" + Pdate(editEndDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";
 if (editDateTurnedIn->Text != "")
   sql += "activity_logsheets.date_turned_in = '" + Pdate(editDateTurnedIn->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' and ";

  sql = sql.substr(0, sql.length()-4);
  // sql += " order by date_turned_in, person_names.last_name, person_names.first_name";
  Filter->SetSQLStatement (sql);
  Filter->RefreshDataSet ();

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchLogsheet::IsValidOnScreen()
{
  // give the user a message box and prompt to re-enter if incorrect
  if (! Pdate (editBeginDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editBeginDate->Text == ""))
  {
    PSay("Please enter a valid begin date", m_invalid_data, MB_OK);
    editBeginDate->SetFocus();
    return false;
  }
  else if (! Pdate (editEndDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editEndDate->Text == ""))
  {
    PSay("Please enter a valid end date", m_invalid_data, MB_OK);
    editEndDate->SetFocus();
    return false;
  }
  else if (! Pdate (editDateTurnedIn->Text.c_str(), mdy | yy).IsValidDate() && ! (editDateTurnedIn->Text == ""))
  {
    PSay("Please enter a valid end date", m_invalid_data, MB_OK);
    editDateTurnedIn->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformSearchLogsheet::ScreenStart()
{
  Filter->SetSecurity("activity_logsheets");
  Filter->AddColumnSpec("Date Turned In", "activity_logsheets", as_date, true, 80);
  Filter->AddColumnSpec("Person", "person_names", as_text, true, 120);
  Filter->AddColumnSpec("Begin Date", "activity_logsheets", as_text, true, 130);
  Filter->AddColumnSpec("End Date", "activity_logsheets", as_text, true, 100);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchactivity_logsheet.filter");
  Filter->SetIconStatus(true);
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

 return true;
}
//---------------------------------------------------------------------------
bool TformSearchLogsheet::ScreenStop()
{
 // instead of formclose, do shutdown stuff here (combo boxes, etc.)
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchLogsheet::Create()
{
  PSay("Cannot create records from this form", m_message, MB_OK);
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchLogsheet::Zoom(const string & p_id)
{
  map<string,string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordLogsheet * logsheetRecord = new TformRecordLogsheet(NULL, temp_map);
    logsheetRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchLogsheet::Do(TformSpecialGeneric * p_parent)
{
 return TformSearchLogsheet::Do(p_parent, "");
}
//---------------------------------------------------------------------------
vector<string> TformSearchLogsheet::Do(TformSpecialGeneric * p_parent, string p_person_id)
{
 vector<string> answer;
 FORM_TRY
  TformSearchLogsheet * z = new TformSearchLogsheet(NULL, &answer, p_person_id);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

