//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop 

#include "codeSearchMessageBoxLog.h"
#include "codeRecordMessageBoxLog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchMessageBoxLog *formSearchMessageBoxLog;
//---------------------------------------------------------------------------
__fastcall TformSearchMessageBoxLog::TformSearchMessageBoxLog(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("message_box_log"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchMessageBoxLog::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxes
  // corrospond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect
  if (! Pdate (editBeginDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editBeginDate->Text == ""))
  {
    PSay("Please enter a valid begin date", m_invalid_data, MB_OK);
    editBeginDate->SetFocus();
    return false;
  }
  else if (! Pdate (editEndDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editEndDate->Text == ""))
  {
    PSay("Please enter a valid end date", m_invalid_data, MB_OK);
    editEndDate->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("users", cboUser->Text.c_str()) )
  {
    PSay("Please enter a valid user", m_invalid_data, MB_OK);
    cboUser->SetFocus();
    return false;
  }
  else if ((! lookupTables->IsInLookUpTable("message_box_types", cboType->Text.c_str())) &&
          (cboType->Text != ""))
  {
    PSay("Please enter a valid type", m_invalid_data, MB_OK);
    cboType->SetFocus();
    return false;
  }
  else if ((! lookupTables->IsInLookUpTable("message_box_resopnse_types", cboResponse->Text.c_str())) &&
          (cboResponse->Text != ""))
  {
    PSay("Please enter a valid response", m_invalid_data, MB_OK);
    cboResponse->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformSearchMessageBoxLog::Search()
{
 string sql = "";

 sql = "select cast(message_box_log.event_stamp as date), cast(message_box_log.event_stamp as time), "
       "users.item, message_box_log.form_name, "
       "message_box_types.item, message_box_log.message_text, message_box_response_types.item, "
       "message_box_log.response_time, message_box_log.other_info, 4, message_box_log.id "
       "from message_box_log "
       "left join users on message_box_log.user_id = users.id "
       "left join message_box_types on message_box_log.message_box_id = message_box_types.id "
       "left join message_box_response_types on message_box_log.message_box_response_id = message_box_response_types.id "
       "where 1=1 ";

 Pdate min_date = Pdate(editBeginDate->Text.c_str(), global_mode);
 Pdate max_date = Pdate(editEndDate->Text.c_str(), global_mode);
 if (max_date.IsValidDate())
  max_date.mod(1, in_days);

 if (editBeginDate->Text != "" && min_date.IsValidDate())
   sql += "and message_box_log.event_stamp >= '" + min_date.OutDate(global_mode) + "' ";
 if (editEndDate->Text != "" && max_date.IsValidDate())
   sql += "and message_box_log.event_stamp < '" + max_date.OutDate(global_mode) + "' ";
 if (cboUser->Text != "")
   sql += "and message_box_log.user_id = " + lookupTables->IdOf("users", cboUser->Text.c_str()) + " ";
 if (editFormName->Text != "")
   sql += "and UPPER(message_box_log.form_name) like '%" + SafeSQLString(editFormName->Text.c_str()) + "%' ";
 if (cboType->Text != "")
   sql += "and message_box_log.message_box_id = " + lookupTables->IdOf("message_box_types", cboType->Text.c_str()) + " ";
 if (editMessage->Text != "")
   sql += "and UPPER(message_box_log.message_text) like '%" + SafeSQLString(editMessage->Text.c_str()) + "%' ";
 if (cboResponse->Text != "")
   sql += "and message_box_log.message_box_response_id = " + lookupTables->IdOf("message_box_response_types", cboResponse->Text.c_str()) + " ";
 if (editOther->Text != "")
   sql += "and UPPER(message_box_log.other_info) like '%" + SafeSQLString(editOther->Text.c_str()) + "%' ";

  Filter->SetSQLStatement (sql);
  Filter->RefreshDataSet ();

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchMessageBoxLog::ScreenStart()
{
  lookupTables->RegisterComboBox("users", cboUser);
  lookupTables->RegisterComboBox("message_box_types", cboType);
  lookupTables->RegisterComboBox("message_box_response_types", cboResponse);

  Filter->SetSecurity("message_box_log");
  Filter->AddColumnSpec("Date", "message_box_log", as_date, true, 90);
  Filter->AddColumnSpec("Time", "message_box_log", as_time, true, 80);
  Filter->AddColumnSpec("User", "message_box_log", as_text, true, 100);
  Filter->AddColumnSpec("Form", "message_box_log", as_text, true, 160, rawString);
  Filter->AddColumnSpec("Type", "message_box_log", as_text, true, 90, sentenceString);
  Filter->AddColumnSpec("Message", "message_box_log", as_text, true, 180, rawString);
  Filter->AddColumnSpec("Response", "message_box_log", as_text, true, 90);
  Filter->AddColumnSpec("Response Time", "message_box_log", as_int, true, 100);  
  Filter->AddColumnSpec("Other Info", "message_box_log", as_text, false, 120, rawString);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchmessageboxlog.filter");
  Filter->SetIconStatus(true);
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

 return true;
}
//---------------------------------------------------------------------------
bool TformSearchMessageBoxLog::ScreenStop()
{
 // instead of formclose, do shutdown stuff here (combo boxes, etc.)
  lookupTables->UnregisterComboBox("users", cboUser);
  lookupTables->UnregisterComboBox("message_box_types", cboType);
  lookupTables->UnregisterComboBox("message_box_response_types", cboResponse);
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchMessageBoxLog::Create()
{
  // jhaley 20100823: oh-so-helpful message in case one of us develops amnesia?
  PSay("You cannot create a message box log item. They are reserved for error messages.", m_message, MB_OK);
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchMessageBoxLog::Zoom(const string & p_id)
{
  // jhaley 20100823: open new message box log record form (which is read-only)
  map<string, string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordMessageBoxLog *msgBoxLogRecord = new TformRecordMessageBoxLog(NULL, temp_map);
    msgBoxLogRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchMessageBoxLog::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchMessageBoxLog * z = new TformSearchMessageBoxLog(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

