//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSearchObsResponseSet.h"
#include "codeRecordObservationResponseSet.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeQuery__ObsResponseSetsByResponse"
#pragma link "codeQueryGeneric"
#pragma link "codeRubberContainer"
#pragma link "codeSearchGeneric"
#pragma link "codeFrameObservationList"
#pragma resource "*.dfm"
TformSearchObsResponseSet *formSearchObsResponseSet;
//---------------------------------------------------------------------------
__fastcall TformSearchObsResponseSet::TformSearchObsResponseSet(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("obs_response_sets"))
{
 context = NULL;
 FORM_TRY
  context = new query_context(dbDatabase);
 FORM_CATCH
 // context->LogOutput = editLog;
 Initialize();
 Pdate bob (Date());
 bob.mod(-1, in_months);
 editDateMin->Text = bob.OutDate(global_mode).c_str();
 bob.mod(+2, in_months);
 editDateMax->Text = bob.OutDate(global_mode).c_str();
}
//---------------------------------------------------------------------------
bool TformSearchObsResponseSet::IsValidOnScreen()
{
 if (comboQuestionSet->Text != "" && !lookupTables->IsInLookUpTable("obs_question_set_types", comboQuestionSet))
 {
  PSay("Please select a question set.", m_invalid_data, MB_OK);
  comboQuestionSet->SetFocus();
  return false;
 }
 if (comboGroup->Text != "" && !lookupTables->IsInLookUpTable("groups", comboGroup))
 {
  PSay("Please select a group.", m_invalid_data, MB_OK);
  comboGroup->SetFocus();
  return false;
 }
 if (editDateMin->Text != "" && !Pdate(editDateMin->Text.c_str(), mdy | yy).IsValidDate())
 {
  PSay("Please enter a valid begin date.", m_invalid_data, MB_OK);
  editDateMin->SetFocus();
  return false;
 }
 if (editDateMax->Text != "" && !Pdate(editDateMax->Text.c_str(), mdy | yy).IsValidDate())
 {
  PSay("Please enter a valid end date.", m_invalid_data, MB_OK);
  editDateMax->SetFocus();
  return false;
 }

 if (frameQueryResponse->comboKey->Text != "" && !frameQueryResponse->Valid())
  return false;

 return true;
}
//---------------------------------------------------------------------------
bool TformSearchObsResponseSet::Search()
{
 string where_clause;

 if (comboQuestionSet->Text != "")
  where_clause += "obs_response_sets.obs_question_set_id = " + lookupTables->IdOf("obs_question_set_types", comboQuestionSet) + " and ";
 if (comboGroup->Text != "")
  where_clause += "obs_response_sets.group_id = " + lookupTables->IdOf("groups", comboGroup) + " and ";
 if (editDateMin->Text != "")
  where_clause += "obs_response_sets.date_of_observation >= '" + Pdate(editDateMin->Text.c_str(), mdy | yy).OutDate(global_mode) + "' and ";
 if (editDateMax->Text != "")
  where_clause += "obs_response_sets.date_of_observation <= '" + Pdate(editDateMax->Text.c_str(), mdy | yy).OutDate(global_mode) + "' and ";
 if (radioStepsYes->Checked)
  where_clause += "(0=1 or obs_response_sets.is_steps_observation = 1) and ";
 if (radioStepsNo->Checked)
  where_clause += "(0=1 or obs_response_sets.is_steps_observation = 0) and ";

 frameResults->Filter->SetTransaction(context->Transaction);
 if (frameQueryResponse->comboKey->Text != "")
 {
  frameQueryResponse->SourceTableName = "obs_response_sets";
  frameQueryResponse->Context = context;
  frameQueryResponse->Cache = false;
  frameQueryResponse->Proxy = true;
  frameQueryResponse->Clip = false;
  string resulting_view = frameQueryResponse->Prepare();
  where_clause += "obs_response_sets.id in (select id from " + resulting_view + ") and ";
 }
// not needed because the frameObsList thing already checks permissions. redundant & slow. ergo, stupid.
/*
  else
 {
  string whole_view = context->FindWhole("obs_response_sets");
  where_clause += "obs_response_sets.id in (select id from " + whole_view + ") and ";
 }
*/

 if (!where_clause.empty())
  where_clause = where_clause.substr(0, where_clause.length() - 4);

 frameResults->SetSource(obs_list_custom, where_clause);
 return true;
}
//---------------------------------------------------------------------------
void TformSearchObsResponseSet::SqlModified()
{
 TformSearchGeneric::SqlModified();

 if (context)
 {
  frameQueryResponse->CleanUp();
  context->Transaction->Commit();
  context->Transaction->StartTransaction();
  context->Clear();
  // context->Clear();
 }
}
//---------------------------------------------------------------------------
bool TformSearchObsResponseSet::ScreenStart()
{
 lookupTables->RegisterComboBox("obs_question_set_types", comboQuestionSet);
 lookupTables->RegisterComboBox("groups", comboGroup);
 return TformSearchGeneric::ScreenStart();
}
//---------------------------------------------------------------------------
bool TformSearchObsResponseSet::ScreenStop()
{
 // unregister combo boxes
 lookupTables->UnregisterComboBox("obs_question_set_types", comboQuestionSet);
 lookupTables->UnregisterComboBox("groups", comboGroup);
 return TformSearchGeneric::ScreenStop();
}
//---------------------------------------------------------------------------
bool TformSearchObsResponseSet::Create()
{
 map<string,string> temp_map;
 temp_map["id"] = "new";
 TformRecordObservationResponseSet::Do(temp_map);
 return true;
}
//---------------------------------------------------------------------------
bool TformSearchObsResponseSet::Zoom(const string & p_id)
{
 map<string,string> temp_map;
 temp_map["id"] = p_id;
 TformRecordObservationResponseSet::Do(temp_map);
 return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchObsResponseSet::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchObsResponseSet * z = new TformSearchObsResponseSet(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------
void TformSearchObsResponseSet::Do()
{
 FORM_TRY
  TformSearchObsResponseSet * z = new TformSearchObsResponseSet(NULL, NULL);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
classFilterObject * TformSearchObsResponseSet::GetFilter()
{
 return frameResults->Filter;
}
//---------------------------------------------------------------------------
TListView * TformSearchObsResponseSet::GetListSearchResults()
{
 return frameResults->listObservations;
}
//---------------------------------------------------------------------------
void __fastcall TformSearchObsResponseSet::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  frameResults->Filter->SetTransaction(NULL);
  context->Transaction->Commit();
  delete context;
  context = NULL;
  TformSearchGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------

