//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSearchPurchaseReq.h"
#include "codeRecordPurchaseReq.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchPurchaseReq *formSearchPurchaseReq;
//---------------------------------------------------------------------------
__fastcall TformSearchPurchaseReq::TformSearchPurchaseReq(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("purchase_reqs"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchPurchaseReq::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxes
  // corrospond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect
  if (! Pdate (editBeginDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editBeginDate->Text == ""))
  {
    PSay("Please enter a valid begin date", m_invalid_data, MB_OK);
    editBeginDate->SetFocus();
    return false;
  }
  else if (! Pdate (editEndDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editEndDate->Text == ""))
  {
    PSay("Please enter a valid end date", m_invalid_data, MB_OK);
    editEndDate->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformSearchPurchaseReq::Search()
{
  string sql;
  sql = "select purchase_reqs.purchase_req_number, checks.check_number, tax_entities.name, purchase_reqs.date_sent,"
        "purchase_reqs.current_id, purchase_reqs.id "
        "from purchase_reqs, checks, tax_entities "
        "where purchase_reqs.check_id = checks.id and "
        "purchase_reqs.tax_entity_id = tax_entities.id and "
        "purchase_reqs.id > 0 ";

  if(editBeginDate->Text != "")
    sql += "and purchase_reqs.date_sent >= '" + Pdate(editBeginDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
  if(editEndDate->Text != "")
    sql += "and purchase_reqs.date_sent <= '" + Pdate(editEndDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
  if(editPrNumber->Text != "")
    sql += "and purchase_reqs.purchase_req_number like '" + SafeSQLString(editPrNumber->Text.c_str()) + "' ";
  if(editCheckNumber->Text != "")
    sql += "and checks.check_number like '%" + SafeSQLString(editCheckNumber->Text.c_str()) + "%' ";

  Filter->SetSQLStatement(sql);
  Filter->RefreshDataSet();
  return true;

}
//---------------------------------------------------------------------------
bool TformSearchPurchaseReq::ScreenStart()
{
 // instead of formcreate, do startup stuff here or in the constructor
 // this gets called after stuff in the base classes's constructor

  Filter->SetListViewHandle(listSearchResults);
  Filter->SetSecurity("purchase_reqs");
  Filter->AddColumnSpec("PR Number", "purchase_reqs", as_int, true, 100);
  Filter->AddColumnSpec("Check Number", "purchase_reqs", as_int, true, 100);
  Filter->AddColumnSpec("Tax Entity", "tax_entities", as_text, true, 150, rawString);
  Filter->AddColumnSpec("Date Sent", "purchase_reqs", as_date, true, 90);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchpurchasereq.filter");
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchPurchaseReq::ScreenStop()
{

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchPurchaseReq::Create()
{

 return true;
}
//---------------------------------------------------------------------------
bool TformSearchPurchaseReq::Zoom(const string & p_id)
{
  map<string, string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordPurchaseReq * pr_record = new TformRecordPurchaseReq(NULL, temp_map);
    pr_record->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchPurchaseReq::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchPurchaseReq * z = new TformSearchPurchaseReq(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

