//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSearchServiceProvided.h"
#include "codeRecordServiceProvided.h"
#include "codeSearchTaxEntity.h"

extern map<TStaticText *, link_struct> registered_links;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchServiceProvided *formSearchServiceProvided;
//---------------------------------------------------------------------------
__fastcall TformSearchServiceProvided::TformSearchServiceProvided(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("services_provided"))
{
  txtProvider->Font->Color = link_color;
  CreateLink(txtProvider, btnProviderSearch, this, "", "tax_entities");
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchServiceProvided::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxes
  // corrospond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect
  if(! lookupTables->IsInLookUpTable("service_types", cboService->Text.c_str()))
  {
    PSay("Please enter a valid service", m_invalid_data, MB_OK);
    cboService->SetFocus();
    return false;
  }
  else if(! lookupTables->IsInLookUpTable("area_types", cboArea->Text.c_str()))
  {
    PSay("Please enter a valid area", m_invalid_data, MB_OK);
    cboArea->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformSearchServiceProvided::Search()
{
  string sql;
  sql = "select tax_entities.name, service_types.item, area_types.item, "
        "services_provided.current_id, services_provided.id "
        "from services_provided, service_types, area_types, tax_entities "
        "where services_provided.tax_entity_id = tax_entities.id and "
        "services_provided.service_id = service_types.id and "
        "services_provided.area_id = area_types.id and "
        "services_provided.id > 0 ";

  if(cboService->Text != "")
    sql += "and services_provided.service_id = " + lookupTables->IdOf("service_types", cboService->Text.c_str());
  if(cboArea->Text != "")
    sql += "and services_provided.area_id = " + lookupTables->IdOf("area_types", cboArea->Text.c_str());
  string tax_id = GetValidLinkId(txtProvider); // jhaley: updated to use GetValidLinkId for safety (doesn't error if link not registered somehow)
  if (tax_id != "")
    sql += "and services_provided.tax_entity_id = '" + tax_id + "'";

  Filter->SetSQLStatement(sql);
  Filter->RefreshDataSet();
  return true;

}
//---------------------------------------------------------------------------
bool TformSearchServiceProvided::ScreenStart()
{
 // instead of formcreate, do startup stuff here or in the constructor
 // this gets called after stuff in the base classes's constructor

  lookupTables->RegisterComboBox("service_types", cboService);
  lookupTables->RegisterComboBox("area_types", cboArea);

  Filter->SetListViewHandle(listSearchResults);
  Filter->SetSecurity("services_provided");
  Filter->AddColumnSpec("Tax Entity", "tax_entities", as_text, true, 150, rawString);
  Filter->AddColumnSpec("Service", "services_provided", as_text, true, 100);
  Filter->AddColumnSpec("Area", "services_provided", as_text, true, 100);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchserviceprovided.filter");
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchServiceProvided::ScreenStop()
{
  lookupTables->UnregisterComboBox("service_types", cboService);
  lookupTables->UnregisterComboBox("area_types", cboArea);
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchServiceProvided::Create()
{

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchServiceProvided::Zoom(const string & p_id)
{
  map<string, string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordServiceProvided * service_record = new TformRecordServiceProvided(NULL, temp_map);
    service_record->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchServiceProvided::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchServiceProvided * z = new TformSearchServiceProvided(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------
vector<string> TformSearchServiceProvided::Do(TformSpecialGeneric * p_parent, string entity_id)
{
 vector<string> answer;
 FORM_TRY
  TformSearchServiceProvided * z = new TformSearchServiceProvided(NULL, &answer);
  CreateLink(z->txtProvider, z->btnProviderSearch, z, entity_id, "tax_entities");
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------
void __fastcall TformSearchServiceProvided::btnProviderSearchClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> provider_return_vector;
  FORM_TRY
    TformSearchTaxEntity * providerSearch = new TformSearchTaxEntity(NULL,&provider_return_vector);
    providerSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! provider_return_vector.empty())
  {
    CreateLink(txtProvider, btnProviderSearch, this, provider_return_vector[0], "tax_entities");
    Search();
  }
}
//---------------------------------------------------------------------------


