//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSearchSurvey.h"
#include "codeRecordSurvey.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchSurvey *formSearchSurvey;
//---------------------------------------------------------------------------
__fastcall TformSearchSurvey::TformSearchSurvey(TComponent* Owner, vector<string> * p_return_vector, string p_group_id)
        : TformSearchGeneric(Owner, p_return_vector, string ("surveys"))
{
  group_id = p_group_id;
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchSurvey::IsValidOnScreen()
{
  return true;
}
//---------------------------------------------------------------------------

bool TformSearchSurvey::Search()
{
  string sql = "";

  sql = "select surveys.survey_name, count(surveys_taken.id), "
        "surveys.current_id, surveys.id "
        "from surveys "
        "left join surveys_taken on surveys_taken.survey_id = surveys.id "
        "where surveys.id > 0 ";

  if (editName->Text != "")
    sql += "and surveys.survey_name like '%" + SafeSQLString(editName->Text.c_str()) + "%' ";
  if (editQuestion->Text != "")
    sql += "and survey_questions.question like '%" + SafeSQLString(editQuestion->Text.c_str()) + "%' ";

  if((group_id != "") && (IsInt(group_id)))
    sql += "and surveys.group_id = " + group_id + " ";
  sql += "group by surveys.survey_name, surveys.id, surveys.current_id";
  Filter->SetSQLStatement (sql);
  Filter->RefreshDataSet ();     

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchSurvey::ScreenStart()
{
  Filter->SetSecurity("surveys");
  Filter->AddColumnSpec("Survey Name", "surveys", as_text, true, 200);
  Filter->AddColumnSpec("Times Taken", "surveys_taken", as_int, true, 120);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchsurvey.filter");
  Filter->SetIconStatus(true);
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchSurvey::ScreenStop()
{
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchSurvey::Create()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  if((group_id != "") && (IsInt(group_id)))
    temp_map["group_id"] = group_id;
  else
    temp_map["group_id"] = current_groupid;
  FORM_TRY
    TformRecordSurvey * surveyRecord = new TformRecordSurvey(NULL, temp_map);
    surveyRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchSurvey::Zoom(const string & p_id)
{
  map<string,string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordSurvey * surveyRecord = new TformRecordSurvey(NULL, temp_map);
    surveyRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchSurvey::Do(TformSpecialGeneric * p_parent)
{
 return TformSearchSurvey::Do(p_parent, "");
}
//---------------------------------------------------------------------------
vector<string> TformSearchSurvey::Do(TformSpecialGeneric * p_parent, string group_id)
{
 vector<string> answer;
 FORM_TRY
  TformSearchSurvey * z = new TformSearchSurvey(NULL, &answer, group_id);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

