//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSearchTaskBeh.h"
#include "codeRecordTaskBeh.h"
#include "codeSearchEvent.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchTaskBeh *formSearchTaskBeh;
//---------------------------------------------------------------------------
__fastcall TformSearchTaskBeh::TformSearchTaskBeh(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("tasks"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchTaskBeh::IsValidOnScreen()
{

  // check to make sure that the values entered in the combo boxes
  // corrospond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect
  if (! lookupTables->IsInLookUpTable("users", cboStaff->Text.c_str()))
  {
    PSay("Please enter a valid staff name", m_invalid_data, MB_OK);
    cboStaff->SetFocus();
    return false;
  }
  else if (! IsFloat(editMinTime->Text.c_str()))
  {
    PSay("Please enter a valid time spent", m_invalid_data, MB_OK);
    editMinTime->SetFocus();
    return false;
  }
  else if (! IsFloat(editMaxTime->Text.c_str()))
  {
    PSay("Please enter a valid time spent", m_invalid_data, MB_OK);
    editMaxTime->SetFocus();
    return false;
  }
  else if (! IsFloat(editMinMileage->Text.c_str()))
  {
    PSay("Please enter a valid mileage", m_invalid_data, MB_OK);
    editMinMileage->SetFocus();
    return false;
  }
  else if (! IsFloat(editMaxTime->Text.c_str()))
  {
    PSay("Please enter a time spent", m_invalid_data, MB_OK);
    editMaxTime->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("method_types", cboMethod->Text.c_str()))
  {
    PSay("Please enter a valid method of contact", m_invalid_data, MB_OK);
    cboMethod->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("direction_types", cboDirection->Text.c_str()))
  {
    PSay("Please enter incoming or outcoming", m_invalid_data, MB_OK);
    cboDirection->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("beh_meeting_types", cboMeeting->Text.c_str()))
  {
    PSay("Please enter a valid meeting type", m_invalid_data, MB_OK);
    cboMeeting->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("beh_activity_types", cboActivity->Text.c_str()))
  {
    PSay("Please enter a valid activity type", m_invalid_data, MB_OK);
    cboActivity->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("beh_visit_types", cboVisitType->Text.c_str()))
  {
    PSay("Please enter a valid visit type", m_invalid_data, MB_OK);
    cboVisitType->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("visit_location_types", cboLocation->Text.c_str()))
  {
    PSay("Please enter a valid location", m_invalid_data, MB_OK);
    cboLocation->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("beh_service_types", cboService->Text.c_str()))
  {
    PSay("Please enter a valid service", m_invalid_data, MB_OK);
    cboService->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("program_types", cboProgramType))
  {
    PSay("Please enter a valid program type", m_invalid_data, MB_OK);
    cboProgramType->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("task_purpose_types", cboTaskType))
  {
    PSay("Please enter a valid task type", m_invalid_data, MB_OK);
    cboTaskType->SetFocus();
    return false;
  }

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskBeh::Search()
{
  string sql;
  sql = "select tasks.date_of_task, users.item, event_name_types.item, "
        "person_names.first_name || ' ' || person_names.last_name || ' ' || person_names.suffix name, "
        "tasks.time_spent, tasks.mileage, method_types.item, "
        "direction_types.item, classification_types.item, beh_meeting_types.item, "
        "beh_activity_types.item, tasks.task_comments, tasks.new_client, "
        "beh_visit_types.item, visit_location_types.item, "
        "beh_service_types.item, program_types.item, tasks.visit_time_spent, tasks.visit_comments, "
        "tasks.group_id, tasks.current_id, tasks.id "
        "from tasks left join users on tasks.user_id = users.id "
        "left join events on tasks.event_id = events.id "
        "left join event_name_types on events.event_name_id = event_name_types.id "
        "left join method_types on tasks.method_id = method_types.id "
        "left join direction_types on tasks.direction_id = direction_types.id "
        "left join beh_meeting_types on tasks.beh_meeting_id = beh_meeting_types.id "
        "left join classification_types on tasks.classification_id = classification_types.id "
        "left join beh_activity_types on tasks.beh_activity_id = beh_activity_types.id "
        "left join beh_visit_types on tasks.beh_visit_id = beh_visit_types.id "
        "left join visit_location_types on tasks.visit_location_id = visit_location_types.id "
        "left join beh_service_types on tasks.beh_service_id = beh_service_types.id "
        "left join program_types on tasks.program_id = program_types.id "
        "left join people on tasks.person_id = people.id "
        "left join person_names on people.person_names_id = person_names.id "
        "where tasks.id + 1 > 1 and "
        "tasks.group_id = " + lookupTables->IdOf("groups", "Behavioral Health") + " and "
        "tasks.date_of_task >= '" + Pdate(dateBegin->Date).OutDate(mdy | yyyy) + "' and "
        "tasks.date_of_task <= '" + Pdate(dateEnd->Date).OutDate(mdy | yyyy) + "' and ";

  if(cboStaff->Text != "")
    sql += "tasks.user_id = " + lookupTables->IdOf("users", cboStaff->Text.c_str()) + " and ";
//  if(editEvent->Text != "")
//    sql += "events.event_name like '%" + SafeSQLString(editEvent->Text.c_str()) + "%' and ";
  if (cboEventName->Text != "")
    sql += "events.event_name_id = " + lookupTables->IdOf("event_name_types", cboEventName) + " and ";
  if(editMinTime->Text != "")
    sql += "tasks.time_spent >= " + string(editMinTime->Text.c_str()) + " and ";
  if(editMaxTime->Text != "")
     sql += "tasks.time_spent <= " + string(editMaxTime->Text.c_str()) + " and ";
  if(editMinMileage->Text != "")
    sql += "tasks.mileage >= " + string(editMinMileage->Text.c_str()) + " and ";
  if(editMaxMileage->Text != "")
     sql += "tasks.mileage <= " + string(editMaxMileage->Text.c_str()) + " and ";
  if(cboMethod->Text != "")
    sql += "tasks.method_id = " + lookupTables->IdOf("method_types", cboMethod->Text.c_str()) + " and ";
  if(cboDirection->Text != "")
    sql += "tasks.direction_id = " + lookupTables->IdOf("direction_types", cboDirection->Text.c_str()) + " and ";
  if(cboMeeting->Text != "")
    sql += "tasks.beh_meeting_id = " + lookupTables->IdOf("beh_meeting_types", cboMeeting->Text.c_str()) + " and ";
  if(cboActivity->Text != "")
    sql += "tasks.beh_activity_id = " + lookupTables->IdOf("beh_activity_types", cboActivity->Text.c_str()) + " and ";
  if(cboVisitType->Text != "")
    sql += "tasks.beh_visit_id = " + lookupTables->IdOf("beh_visit_types", cboVisitType->Text.c_str()) + " and ";
  if(cboLocation->Text != "")
    sql += "tasks.visit_location_id = " + lookupTables->IdOf("visit_location_types", cboLocation->Text.c_str()) + " and ";
  if(cboService->Text != "")
    sql += "tasks.beh_service_id = " + lookupTables->IdOf("beh_service_types", cboService->Text.c_str()) + " and ";
  if(cboProgramType->Text != "")
    sql += "tasks.program_id = " + lookupTables->IdOf("program_types", cboProgramType->Text.c_str(), cboProgramType) + " and ";
  if(cboTaskType->Text != "")
    sql += "tasks.task_purpose_id = " + lookupTables->IdOf("task_purpose_types", cboTaskType->Text.c_str(), cboTaskType) + " and ";
  if(checkNew->Checked)
    sql += "tasks.new_client = 1 and ";


  sql = sql.substr(0, sql.length()-5);
  // sql += " order by tasks.date_of_task, users.item";
  Filter->SetSQLStatement(sql);
  Filter->RefreshDataSet();
  return true;
  
}
//---------------------------------------------------------------------------
bool TformSearchTaskBeh::ScreenStart()
{
 // instead of formcreate, do startup stuff here or in the constructor
 // this gets called after stuff in the base classes's constructor

  Filter->SetListViewHandle(listSearchResults);
  Filter->SetSecurity("tasks.beh");
  Filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  Filter->AddColumnSpec("Staff", "tasks", as_text, true, 110);
  Filter->AddColumnSpec("Event", "events", as_text, true, 110, rawString);
  Filter->AddColumnSpec("Client", "people", as_text, true, 110);
  Filter->AddColumnSpec("Time Spent", "tasks", as_double, true, 100);
  Filter->AddColumnSpec("Mileage", "tasks", as_double, false, 80);
  Filter->AddColumnSpec("Method of Contact", "tasks", as_text, false, 130);
  Filter->AddColumnSpec("In/Out", "tasks", as_text, true, 80);
  Filter->AddColumnSpec("Classification", "tasks", as_text, false, 110);
  Filter->AddColumnSpec("Meeting Type", "tasks", as_text, false, 110);
  Filter->AddColumnSpec("Activity Type", "tasks", as_text, true, 110);
  Filter->AddColumnSpec("Task Comments", "tasks", as_text, false, 150, sentenceString);
  Filter->AddColumnSpec("New Client", "tasks", as_text, false, 100, prettyBoolString);
  Filter->AddColumnSpec("Visit Type", "tasks", as_text, true, 110);
  Filter->AddColumnSpec("Location", "tasks", as_text, false, 110);
  Filter->AddColumnSpec("Service Type", "tasks", as_text, false, 110);
  Filter->AddColumnSpec("Program Type", "tasks", as_text, false, 110, rawString);
  Filter->AddColumnSpec("Time Spent w/Client", "tasks", as_double, false, 100);
  Filter->AddColumnSpec("Visit Comments", "tasks", as_text, false, 150, sentenceString);
  Filter->AddColumnSpec("Group Id", "internal_id", as_int, false, 80); // jhaley - view group_id's
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchtaskbeh.filter");
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

  Pdate begin_date(DateToStr(Date()).c_str(), mdy | yyyy);
  begin_date.mod(-14, in_days);
  dateBegin->Date = StrToDate(begin_date.OutDate(mdy | yyyy).c_str());
  dateEnd->Date = Date();

  set<string> general_perms = GetSpecialGroupPermissions("general");

  lookupTables->RegisterComboBox("users", cboStaff);
  lookupTables->RegisterComboBox("method_types", cboMethod);
  lookupTables->RegisterComboBox("direction_types", cboDirection);
  lookupTables->RegisterComboBox("beh_meeting_types", cboMeeting);
  lookupTables->RegisterComboBox("beh_activity_types", cboActivity);
  lookupTables->RegisterComboBox("beh_visit_types", cboVisitType);
  lookupTables->RegisterComboBox("visit_location_types", cboLocation);
  lookupTables->RegisterComboBox("beh_service_types", cboService);
  string task_sql = "select id, item, valid from task_purpose_types where group_id = 0 or group_id = '"
                    + lookupTables->IdOf("groups", "Behavioral Health") + "' ";
  lookupTables->RegisterComboBox("task_purpose_types", cboTaskType, task_sql);

  string group_sql = "select id, item, valid from event_name_types "
                     "where (group_id = 0 or group_id = '" + lookupTables->IdOf("groups", "Behavioral Health") + "') "
                     "and valid = 1 order by item";
  lookupTables->RegisterComboBox("event_name_types", cboEventName, group_sql, SetGroupIdForNewLookupTableItem);

  string event_program_sql = "select id, item, valid from program_types "
                             "where (group_id = 0 or group_id = '" + lookupTables->IdOf("groups", "Behavioral Health") + "') "
                             "and valid = 1 order by item ";
  lookupTables->RegisterComboBox("program_types", cboProgramType, event_program_sql);

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskBeh::ScreenStop()
{
 // instead of formclose, do shutdown stuff here (combo boxes, etc.)
  lookupTables->UnregisterComboBox("users", cboStaff);
  lookupTables->UnregisterComboBox("method_types", cboMethod);
  lookupTables->UnregisterComboBox("direction_types", cboDirection);
  lookupTables->UnregisterComboBox("beh_meeting_types", cboMeeting);
  lookupTables->UnregisterComboBox("beh_activity_types", cboActivity);
  lookupTables->UnregisterComboBox("beh_visit_types", cboVisitType);
  lookupTables->UnregisterComboBox("visit_location_types", cboLocation);
  lookupTables->UnregisterComboBox("beh_service_types", cboService);
  lookupTables->UnregisterComboBox("program_types", cboProgramType);
  lookupTables->UnregisterComboBox("event_name_types", cboEventName);
  lookupTables->UnregisterComboBox("task_purpose_types", cboTaskType);
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskBeh::Create()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Behavioral Health");
  FORM_TRY
    TformRecordTaskBeh * taskRecord = new TformRecordTaskBeh(NULL, temp_map);
    taskRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskBeh::Zoom(const string & p_id)
{
  map<string, string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordTaskBeh * taskRecord = new TformRecordTaskBeh(NULL, temp_map);
    taskRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchTaskBeh::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchTaskBeh * z = new TformSearchTaskBeh(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

