//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSearchTaskCare.h"
#include "codeSearchEvent.h"
#include "codeRecordTaskCare.h"
#include "codeSearchPerson.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
__fastcall TformSearchTaskCare::TformSearchTaskCare(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("tasks"))
{
 Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchTaskCare::IsValidOnScreen()
{
  if (! lookupTables->IsInLookUpTable("users", cboStaff->Text.c_str()))
  {
    PSay("Please enter a valid staff name", m_invalid_data, MB_OK);
    cboStaff->SetFocus();
    return false;
  }
  else if (! IsFloat(editMinTime->Text.c_str()))
  {
    PSay("Please enter a valid min time spent", m_invalid_data, MB_OK);
    editMinTime->SetFocus();
    return false;
  }
  else if (! IsFloat(editMaxTime->Text.c_str()))
  {
    PSay("Please enter a valid max time spent", m_invalid_data, MB_OK);
    editMaxTime->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("method_types", cboMethod->Text.c_str()))
  {
    PSay("Please enter a valid method of contact", m_invalid_data, MB_OK);
    cboMethod->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("direction_types", cboDirection->Text.c_str()))
  {
    PSay("Please enter either incoming or outgoing", m_invalid_data, MB_OK);
    cboDirection->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("care_classification_types", cboClassification->Text.c_str()))
  {
    PSay("Please enter a valid classification", m_invalid_data, MB_OK);
    cboClassification->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("care_meeting_types", cboMeeting->Text.c_str()))
  {
    PSay("Please enter a valid meeting type", m_invalid_data, MB_OK);
    cboMeeting->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("com_activity_types", cboActivity->Text.c_str()))
  {
    PSay("Please enter a valid activity type", m_invalid_data, MB_OK);
    cboActivity->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("care_service_types", cboServiceType->Text.c_str()))
  {
    PSay("Please enter a valid service type", m_invalid_data, MB_OK);
    cboServiceType->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("task_purpose_types", cboTaskType))
  {
    PSay("Please enter a valid task type", m_invalid_data, MB_OK);
    cboTaskType->SetFocus();
    return false;
  }

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCare::Search()
{
// wierd stuff going on here
// whaa??  --Paul
 string sql;

  sql =  "select tasks.date_of_task, users.item, event_name_types.item event_name, "
         "person_names.first_name || ' ' || person_names.last_name || ' ' || person_names.suffix name, "
         "tasks.time_spent, tasks.mileage, method_types.item method_type, direction_types.item direction_type, "
         "care_classification_types.item classification_type, care_meeting_types.item meeting_type, "
         "com_activity_types.item activity_type, tasks.task_comments, tasks.group_id, tasks.current_id, tasks.id "
         "from tasks "
         "left join users on tasks.user_id = users.id "
         "left join events on tasks.event_id = events.id "
         "left join event_name_types on events.event_name_id = event_name_types.id "
         "left join method_types on tasks.method_id = method_types.id "
         "left join direction_types on tasks.direction_id = direction_types.id "
//         "left join care_service_types on tasks.care_service_id = care_service_types.id "
         "left join care_classification_types on tasks.care_classification_id = care_classification_types.id "
         "left join care_meeting_types on tasks.care_meeting_id = care_meeting_types.id "
         "left join com_activity_types on tasks.com_activity_id = com_activity_types.id "
         "left join people on tasks.person_id = people.id "
         "left join person_names on people.person_names_id = person_names.id ";
  if(cboServiceType->Text != "")
    sql += "left join tasks_to_care_services on tasks_to_care_services.task_id = tasks.id ";
  sql += "where "
         "tasks.group_id = " + lookupTables->IdOf("groups", "Caregiver Support Program") + " and "
         "tasks.date_of_task >= '" + Pdate(dateBegin->Date).OutDate(mdy | yyyy) + "' and "
         "tasks.date_of_task <= '" + Pdate(dateEnd->Date).OutDate(mdy | yyyy) + "' and ";

  if(cboStaff->Text != "")
    sql += "tasks.user_id = " + lookupTables->IdOf("users", cboStaff->Text.c_str()) + " and ";
//  if(editEvent->Text != "")
//    sql += "events.event_name like '%" + SafeSQLString(editEvent->Text.c_str()) + "%' and ";
  if (cboEventName->Text != "")
    sql += "events.event_name_id = " + lookupTables->IdOf("event_name_types", cboEventName) + " and ";
  if(editPerson->Text != "")
  {
    string name = SafeSQLString(editPerson->Text.c_str());
    if(name.find(" ") != string::npos)
    {
      string first_name;
      string last_name;
      first_name = name.substr(0, name.find(" "));
      last_name = name.substr(name.find(" ") + 1, name.length() - name.find(" "));
      sql += "person_names.first_name like '%" + first_name + "%' and "
             "person_names.last_name like '%" + last_name + "%' and ";
    }
    else
    {
      sql += "(person_names.first_name like '%" + name + "%' or "
             "person_names.last_name like '%" + name + "%') and ";
    }
  }
  if(editMinTime->Text != "")
    sql += "tasks.time_spent >= " + string(editMinTime->Text.c_str()) + " and ";
  if(editMaxTime->Text != "")
     sql += "tasks.time_spent <= " + string(editMaxTime->Text.c_str()) + " and ";
  if(cboMethod->Text != "")
    sql += "tasks.method_id = " + lookupTables->IdOf("method_types", cboMethod->Text.c_str()) + " and ";
  if(cboDirection->Text != "")
    sql += "tasks.direction_id = " + lookupTables->IdOf("direction_types", cboDirection->Text.c_str()) + " and ";
  if(cboClassification->Text != "")
    sql += "tasks.care_classification_id = " + lookupTables->IdOf("care_classification_types", cboClassification->Text.c_str()) + " and ";
  if(cboServiceType->Text != "")
    sql += "tasks_to_care_services.care_service_id = " + lookupTables->IdOf("care_service_types", cboServiceType->Text.c_str()) + " and ";
  if(cboMeeting->Text != "")
    sql += "tasks.care_meeting_id = " + lookupTables->IdOf("care_meeting_types", cboMeeting->Text.c_str()) + " and ";
  if(cboActivity->Text != "")
    sql += "tasks.com_activity_id = " + lookupTables->IdOf("com_activity_types", cboActivity->Text.c_str()) + " and ";
  if(cboTaskType->Text != "")
    sql += "tasks.task_purpose_id = " + lookupTables->IdOf("task_purpose_types", cboTaskType->Text.c_str(), cboTaskType) + " and ";
  if(editComments->Text != "")
    sql += "tasks.task_comments = " + string(editComments->Text.c_str()) + " and ";

  sql = sql.substr(0, sql.length()-5);
  // sql += " order by tasks.date_of_task, users.item";
  Filter->SetSQLStatement(sql);
  Filter->RefreshDataSet();
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCare::ScreenStart()
{
 // instead of formcreate, do startup stuff here or in the constructor
 // this gets called after stuff in the base classes's constructor
  Filter->SetListViewHandle(listSearchResults);
  Filter->SetSecurity("tasks");
  Filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  Filter->AddColumnSpec("Staff", "tasks", as_text, true, 110);
  Filter->AddColumnSpec("Event", "events", as_text, false, 110, rawString);
  Filter->AddColumnSpec("Client", "people", as_text, true, 110);
  Filter->AddColumnSpec("Time Spent", "tasks", as_double, true, 100);
  Filter->AddColumnSpec("Mileage", "tasks", as_double, true, 80);
  Filter->AddColumnSpec("Method of Contact", "tasks", as_text, true, 130);
  Filter->AddColumnSpec("In/Out", "tasks", as_text, true, 80);
  Filter->AddColumnSpec("Classification", "tasks", as_text, true, 100);
  Filter->AddColumnSpec("Meeting Type", "tasks", as_text, true, 110);
  Filter->AddColumnSpec("Activity Type", "tasks", as_text, true, 110);
//Filter->AddColumnSpec("Service Type", "tasks", as_text, true, 100);
  Filter->AddColumnSpec("Comments", "tasks", as_text, true, 150, sentenceString);
  Filter->AddColumnSpec("Group Id", "internal_id", as_int, false, 80);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchtaskcare.filter");
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

  Pdate begin_date(DateToStr(Date()).c_str(), mdy | yyyy);
  begin_date.mod(-14, in_days);
  dateBegin->Date = StrToDate(begin_date.OutDate(mdy | yyyy).c_str());
  dateEnd->Date = Date();

  lookupTables->RegisterComboBox("users", cboStaff);

  lookupTables->RegisterComboBox("method_types", cboMethod);
  lookupTables->RegisterComboBox("direction_types", cboDirection);
  lookupTables->RegisterComboBox("care_meeting_types", cboMeeting);
  lookupTables->RegisterComboBox("care_classification_types", cboClassification);
  lookupTables->RegisterComboBox("com_activity_types", cboActivity);
  lookupTables->RegisterComboBox("care_service_types", cboServiceType);
  string task_sql = "select id, item, valid from task_purpose_types where group_id = 0 or group_id = '"
                    + lookupTables->IdOf("groups", "Caregiver Support Program") + "' ";
  lookupTables->RegisterComboBox("task_purpose_types", cboTaskType, task_sql);

  string group_sql = "select id, item, valid from event_name_types "
                     "where (group_id = 0 or group_id = '" + lookupTables->IdOf("groups", "Community Health") + "') and valid = 1 order by item";
  lookupTables->RegisterComboBox("event_name_types", cboEventName, group_sql, SetGroupIdForNewLookupTableItem);

  person_id = "";

 return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCare::ScreenStop()
{
 // instead of formclose, do shutdown stuff here (combo boxes, etc.)
  lookupTables->UnregisterComboBox("users", cboStaff);

  lookupTables->UnregisterComboBox("method_types", cboMethod);
  lookupTables->UnregisterComboBox("direction_types", cboDirection);
  lookupTables->UnregisterComboBox("care_meeting_types", cboMeeting);
  lookupTables->UnregisterComboBox("care_classification_types", cboClassification);
  lookupTables->UnregisterComboBox("com_activity_types", cboActivity);
  lookupTables->UnregisterComboBox("care_service_types", cboServiceType);
  lookupTables->UnregisterComboBox("event_name_types", cboEventName);
  lookupTables->UnregisterComboBox("task_purpose_types", cboTaskType);
  
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCare::Create()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Caregiver Support Program");
  FORM_TRY
    TformRecordTaskCare * taskRecord = new TformRecordTaskCare(NULL, temp_map);
    taskRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCare::Zoom(const string & p_id)
{
  map<string,string> temp_map;
  temp_map["id"] = p_id;
  //temp_map["group_id"] = lookupTables->IdOf("groups", "Caregiver Support Program");
  FORM_TRY
    TformRecordTaskCare * taskRecord = new TformRecordTaskCare(NULL, temp_map);
    taskRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchTaskCare::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchTaskCare * z = new TformSearchTaskCare(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

