//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSearchTaskCob.h"
#include "codeRecordTaskCob.h"
#include "codeSearchTaxEntity.h"
#include "codeWizardNewContractHealthItem.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchTaskCob *formSearchTaskCob;
//---------------------------------------------------------------------------
__fastcall TformSearchTaskCob::TformSearchTaskCob(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("tasks"))
{
  tax_entity_id = "";
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchTaskCob::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxes
  // corrospond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect
  if (! Pdate (editBeginDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editBeginDate->Text == ""))
  {
    PSay("Please enter a valid begin date", m_invalid_data, MB_OK);
    editBeginDate->SetFocus();
    return false;
  }
  else if (! Pdate (editEndDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editEndDate->Text == ""))
  {
    PSay("Please enter a valid end date", m_invalid_data, MB_OK);
    editEndDate->SetFocus();
    return false;
  }
  else if (! IsInt(editCobNumber->Text.c_str()))
  {
    PSay("Please enter a valid cob number", m_invalid_data, MB_OK);
    editCobNumber->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("service_types", cboService->Text.c_str()))
  {
    PSay("Please enter a valid service", m_invalid_data, MB_OK);
    cboService->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("area_types", cboArea->Text.c_str()))
  {
    PSay("Please enter a valid area", m_invalid_data, MB_OK);
    cboArea->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("visit_outcome_types", cboOutcome->Text.c_str()))
  {
    PSay("Please enter a valid outcome", m_invalid_data, MB_OK);
    cboOutcome->SetFocus();
    return false;
  }
  else if (! IsFloat(editMinAmount->Text.c_str()))
  {
    PSay("Please enter a valid min amount", m_invalid_data, MB_OK);
    editMinAmount->SetFocus();
    return false;
  }
  else if (! IsFloat(editMaxAmount->Text.c_str()))
  {
    PSay("Please enter a valid max amount", m_invalid_data, MB_OK);
    editMaxAmount->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("cob_types", cboType->Text.c_str()))
  {
    PSay("Please enter a valid type", m_invalid_data, MB_OK);
    cboType->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCob::Search()
{
  string sql;
  string obligated = "(select sum(transactions.credit_amount - transactions.debit_amount) from transactions where transactions.task_id = tasks.id and transactions.account_id in (select accounts.id from accounts where accounts.account_type_id = " + lookupTables->IdOf("account_types", "Payable") + "))";

  sql =  "select tasks.date_of_task, tasks.time_of_task, tasks.cob_number, "
         "person_names.first_name || ' ' || person_names.last_name || ' ' || person_names.suffix name, "
         "tax_entities.name provider, service_types.item service_provided, "
         + obligated + ", "
         "tasks.task_comments, tasks.visit_comments, tasks.preconditions_note, tasks.followup_note, "
         "tasks.reported_by_note, tasks.hospitalized, tasks.given_room, tasks.current_id, tasks.id "
         "from tasks "
         "left join people on tasks.person_id = people.id "
         "left join person_names on people.person_names_id = person_names.id "
         "left join services_provided on tasks.services_provided_id = services_provided.id "
         "left join tax_entities on services_provided.tax_entity_id = tax_entities.id "
         "left join service_types on services_provided.service_id = service_types.id ";
  if(cboOutcome->Text != "")
   sql += "left join appointments on appointments.task_id = tasks.id ";
  sql += "where tasks.group_id = " + lookupTables->IdOf("groups", "Contract Health") + " and tasks.services_provided_id > 0 and tasks.parent_task_id = 0 ";

  if(editTaxEntity->Text != "")
    sql += "and upper(tax_entities.name) like '%" + SafeSQLString(editTaxEntity->Text.c_str()) + "%' ";
  if(editBeginDate->Text != "")
    sql += "and tasks.date_of_task >= '" + Pdate(editBeginDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
  if(editEndDate->Text != "")
    sql += "and tasks.date_of_task <= '" + Pdate(editEndDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
  if(editCobNumber->Text != "")
    sql += "and tasks.cob_number = " + string(editCobNumber->Text.c_str()) + " ";
  if(cboService->Text != "")
    sql += "and services_provided.service_id = " + lookupTables->IdOf("service_types", cboService->Text.c_str()) + " ";
  if(cboArea->Text != "")
    sql += "and services_provided.area_id = " + lookupTables->IdOf("area_types", cboArea->Text.c_str()) + " ";
  if(cboOutcome->Text != "")
    sql += "and appointments.visit_outcome_id = " + lookupTables->IdOf("visit_outcome_types", cboOutcome->Text.c_str()) + " ";
  if(editReason->Text != "")
    sql += "and upper(tasks.task_comments) like '%" + SafeSQLString(editReason->Text.c_str()) + "%' ";
  if(editLimits->Text != "")
    sql += "and upper(tasks.visit_comments) like '%" + SafeSQLString(editLimits->Text.c_str()) + "%' ";
  if(cboType->Text != "")
    sql += "and tasks.cob_id = " + lookupTables->IdOf("cob_types", cboType->Text.c_str()) + " ";
  if(editMinAmount->Text != "" && editMaxAmount->Text == "")
  {
    sql += " and " + obligated + " >= " + StripAllExcept(editMinAmount->Text.c_str(), floats);

  }
  else if(editMaxAmount->Text != "" && editMinAmount->Text == "")
  {
    sql += " and (" + obligated + " <= " + StripAllExcept(editMaxAmount->Text.c_str(), floats) + " or " + obligated + " is null) ";
  }
  else if(editMaxAmount->Text != "" && editMinAmount->Text != "")
  {
    // jhaley 20101115: Repaired to avoid EIBException 'Unsupported field type specified in BETWEEN predicate' w/Firebird 2.x
    sql += " and ((" + obligated + " >= " + StripAllExcept(editMinAmount->Text.c_str(), floats) + " and "
                     + obligated + " <= " + StripAllExcept(editMaxAmount->Text.c_str(), floats) + ") or " + obligated + " is null) ";
  }

  Filter->SetSQLStatement(sql);
  Filter->RefreshDataSet();
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCob::ScreenStart()
{
  Pdate begin_date(DateToStr(Date()).c_str(), mdy | yyyy);
  begin_date.mod(-14, in_days);
  editBeginDate->Text = begin_date.OutDate(mdy | yyyy).c_str();
  editEndDate->Text = DateToStr(Date()).c_str();

  // instead of formcreate, do startup stuff here or in the constructor
  // this gets called after stuff in the base classes's constructor
  lookupTables->RegisterComboBox("service_types", cboService);
  lookupTables->RegisterComboBox("area_types", cboArea);
  lookupTables->RegisterComboBox("visit_outcome_types", cboOutcome);
  lookupTables->RegisterComboBox("cob_types", cboType);

  Filter->SetListViewHandle(listSearchResults);
  Filter->SetSecurity("tasks.cob");
  Filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  Filter->AddColumnSpec("Time", "tasks", as_time, true, 80);
  Filter->AddColumnSpec("COB Number", "tasks", as_int, true, 100);
  Filter->AddColumnSpec("Person", "people", as_text, true, 110);
  Filter->AddColumnSpec("Provider", "tax_entities", as_text, true, 100, rawString);
  Filter->AddColumnSpec("Service", "services_provided", as_text, true, 75);
  Filter->AddColumnSpec("Obligated Amount", "tasks", as_double, true, 130, amountString);
  Filter->AddColumnSpec("Reason", "tasks", as_text, true, 130, rawString);
  Filter->AddColumnSpec("Limits", "tasks", as_text, true, 130, rawString);
  Filter->AddColumnSpec("Preconditions", "tasks", as_text, false, 130, sentenceString);
  Filter->AddColumnSpec("Follow up", "tasks", as_text, false, 130, sentenceString);
  Filter->AddColumnSpec("Reported by", "tasks", as_text, false, 130, sentenceString);
  Filter->AddColumnSpec("Hospitalized", "tasks", as_text, false, 130, prettyBoolString);
  Filter->AddColumnSpec("Given Room", "tasks", as_text, false, 130, prettyBoolString);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchtaskcob.filter");
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

  if(optionsPermissions["table.services_provided"]["view"] != "true")
  {
    lblService->Enabled = false;
    cboService->Enabled = false;
    lblArea->Enabled = false;
    cboArea->Enabled = false;
  }
  if(optionsPermissions["table.appointments.people"]["view"] != "true")
  {
    lblOutcome->Enabled = false;
    cboOutcome->Enabled = false;
  }
  if(optionsPermissions["table.transactions"]["view"] != "true")
  {
    lblMinAmount->Enabled = false;
    editMinAmount->Enabled = false;
    lblMaxAmount->Enabled = false;
    editMaxAmount->Enabled = false;
  }

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCob::ScreenStop()
{
  lookupTables->UnregisterComboBox("service_types", cboService);
  lookupTables->UnregisterComboBox("area_types", cboArea);
  lookupTables->UnregisterComboBox("visit_outcome_types", cboOutcome);
  lookupTables->UnregisterComboBox("cob_types", cboType);
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCob::Create()
{
  TformWizardNewContractHealthItem::Do(); // jhaley 20120227: because, why not? Needed for deferred COB workflow.
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCob::Zoom(const string & p_id)
{
  map<string, string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordTaskCob * taskRecord = new TformRecordTaskCob(NULL, temp_map);
    taskRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchTaskCob::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchTaskCob * z = new TformSearchTaskCob(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

