//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSearchTaskCobVisit.h"
#include "codeRecordTaskCobVisit.h"
#include "codeSearchTaxEntity.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchTaskCobVisit *formSearchTaskCobVisit;
//---------------------------------------------------------------------------
__fastcall TformSearchTaskCobVisit::TformSearchTaskCobVisit(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("tasks"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchTaskCobVisit::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxes
  // corrospond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect
  if (! Pdate (editBeginDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editBeginDate->Text == ""))
  {
    PSay("Please enter a valid begin date", m_invalid_data, MB_OK);
    editBeginDate->SetFocus();
    return false;
  }
  else if (! Pdate (editEndDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editEndDate->Text == ""))
  {
    PSay("Please enter a valid end date", m_invalid_data, MB_OK);
    editEndDate->SetFocus();
    return false;
  }
  else if (! IsInt(editCobNumber->Text.c_str()))
  {
    PSay("Please enter a valid COB number", m_invalid_data, MB_OK);
    editCobNumber->SetFocus();
    return false;
  }
  else if (! IsInt(editPrNumber->Text.c_str()))
  {
    PSay("Please enter a valid PR number", m_invalid_data, MB_OK);
    editPrNumber->SetFocus();
    return false;
  }
  else if (! IsInt(editCheckNumber->Text.c_str()))
  {
    PSay("Please enter a valid check number", m_invalid_data, MB_OK);
    editCheckNumber->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformSearchTaskCobVisit::Search()
{
  string sql;
  string from;
  string where;

  sql = "select distinct visit.date_of_task, visit.time_of_task, cob.cob_number, "
        "person_names.first_name || ' ' || person_names.last_name || ' ' || person_names.suffix name, "
        "tax_entities.name, visit.task_comments, visit.current_id, visit.id ";

  from = "from tasks visit "
         "left join tasks cob on cob.id = visit.parent_task_id "
         "left join tax_entities on tax_entities.id = visit.tax_entity_id "
         "left join people on people.id = visit.person_id "
         "left join person_names on people.person_names_id = person_names.id ";

  where = "where visit.group_id = " + lookupTables->IdOf("groups", "Contract Health") + " and visit.parent_task_id != 0 ";
  // + "(visit.services_provided_id = 0 or visit.services_provided_id is null) "; // why? this makes no sense to me.

  if(editTaxEntity->Text != "")
    where += "and upper(tax_entities.name) like '%" + SafeSQLString(editTaxEntity->Text.c_str()) + "%' ";
  if(editBeginDate->Text != "")
    where += "and visit.date_of_task >= '" + Pdate(editBeginDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
  if(editEndDate->Text != "")
    where += "and visit.date_of_task <= '" + Pdate(editEndDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
  if(editCobNumber->Text != "")
    where += "and cob.cob_number = '" + string(editCobNumber->Text.c_str()) + "' ";
  if(editReason->Text != "")
    where += "and visit.task_comments like '%" + SafeSQLString(editReason->Text.c_str()) + "%' ";

  if(editDiagnosis->Text != "")
  {
    from += "inner join conditions on conditions.task_id = visit.id "
            "and conditions.code like '%" + SafeSQLString(editDiagnosis->Text.c_str()) + "%' "
            "and conditions.current_id + 1 > 3 "
            "and conditions.group_id = " + lookupTables->IdOf("groups", "Contract Health") + " ";
  }
  if(editProcedure->Text != "")
  {
    from += "inner join procedures on procedures.task_id = visit.id "
            "and procedures.cpt_hcpcs like '%" + SafeSQLString(editProcedure->Text.c_str()) + "%' "
            "and procedures.current_id + 1 > 3 ";
  }

  if (editPrNumber->Text != "" || editCheckNumber->Text != "")
    from += "left join bills on bills.task_id = visit.id left join purchase_reqs on purchase_reqs.id = bills.purchase_req_id ";
  if(editPrNumber->Text != "")
  {
    where += "and purchase_reqs.purchase_req_number = '" + string(editPrNumber->Text.c_str()) + "' ";
  }
  if(editCheckNumber->Text != "")
  {
    from += "left join checks on checks.id = purchase_reqs.check_id ";
    where += "and checks.check_number = '" + string(editCheckNumber->Text.c_str()) + "' ";
  }

  sql = sql + from + where;
  // sql += " order by visit.date_of_task, person_names.last_name, person_names.first_name";
  Filter->SetSQLStatement(sql);
  Filter->RefreshDataSet();

  return true;

}
//---------------------------------------------------------------------------
bool TformSearchTaskCobVisit::ScreenStart()
{

 // instead of formcreate, do startup stuff here or in the constructor
 // this gets called after stuff in the base classes's constructor
  Pdate begin_date(DateToStr(Date()).c_str(), mdy | yyyy);
  begin_date.mod(-14, in_days);
  editBeginDate->Text = begin_date.OutDate(mdy | yyyy).c_str();
  editEndDate->Text = DateToStr(Date()).c_str();

  Filter->SetListViewHandle(listSearchResults);
  Filter->SetSecurity("tasks");
  Filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  Filter->AddColumnSpec("Time", "tasks", as_time, true, 80);
  Filter->AddColumnSpec("COB Number", "tasks", as_int, true, 100);
  Filter->AddColumnSpec("Person", "people", as_text, true, 110);
  Filter->AddColumnSpec("Tax Entity", "tax_entities", as_text, true, 140, rawString);
  Filter->AddColumnSpec("Reason", "tasks", as_text, true, 130, sentenceString);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchtaskcobvisit.filter");
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

  if(optionsPermissions["table.conditions.cob"]["view"] != "true")
  {
    lblDiagnosis->Enabled = false;
    editDiagnosis->Enabled = false;
  }
  if(optionsPermissions["table.procedures"]["view"] != "true")
  {
    lblProcedure->Enabled = false;
    editProcedure->Enabled = false;
  }
  if(optionsPermissions["table.checks"]["view"] != "true")
  {
    lblCheckNumber->Enabled = false;
    editCheckNumber->Enabled = false;
  }
  if(optionsPermissions["table.purchase_reqs"]["view"] != "true")
  {
    lblPrNumber->Enabled = false;
    editPrNumber->Enabled = false;
  }

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCobVisit::ScreenStop()
{
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCobVisit::Create()
{
 return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCobVisit::Zoom(const string & p_id)
{
  map<string, string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordTaskCobVisit * taskRecord = new TformRecordTaskCobVisit(NULL, temp_map);
    taskRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchTaskCobVisit::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchTaskCobVisit * z = new TformSearchTaskCobVisit(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

