//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSearchTaskCom.h"
#include "codeSearchEvent.h"
#include "codeRecordComVisit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchTaskCom *formSearchTaskCom;
//---------------------------------------------------------------------------
__fastcall TformSearchTaskCom::TformSearchTaskCom(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("tasks"))
{
 Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchTaskCom::IsValidOnScreen()
{
  if (! lookupTables->IsInLookUpTable("users", cboStaff->Text.c_str()))
  {
    PSay("Please enter a valid staff name", m_invalid_data, MB_OK);
    cboStaff->SetFocus();
    return false;
  }
  else if (! IsFloat(editMinTime->Text.c_str()))
  {
    PSay("Please enter a valid min time spent", m_invalid_data, MB_OK);
    editMinTime->SetFocus();
    return false;
  }
  else if (! IsFloat(editMaxTime->Text.c_str()))
  {
    PSay("Please enter a valid max time spent", m_invalid_data, MB_OK);
    editMaxTime->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("visit_outcome_types", cboOutcome->Text.c_str()))
  {
    PSay("Please enter a valid outcome type", m_invalid_data, MB_OK);
    cboOutcome->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("visit_location_types", cboLocation->Text.c_str()))
  {
    PSay("Please enter a valid location", m_invalid_data, MB_OK);
    cboLocation->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("com_visit_types", cboVisitType->Text.c_str()))
  {
    PSay("Please enter a valid visit type", m_invalid_data, MB_OK);
    cboVisitType->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("task_purpose_types", cboTaskType))
  {
    PSay("Please enter a valid task type", m_invalid_data, MB_OK);
    cboTaskType->SetFocus();
    return false;
  }

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCom::Search()
{
 string sql;

  sql = "select tasks.date_of_task, users.item, event_name_types.item event_name, "
        "person_names.first_name || ' ' || person_names.last_name || ' ' || person_names.suffix name, "
        "tasks.time_spent, tasks.mileage, com_visit_types.item, visit_location_types.item, visit_outcome_types.item, "
        "tasks.new_client, tasks.group_id, tasks.current_id, tasks.id  "
        "from tasks "
        "left join users on tasks.user_id = users.id "
        "left join events on tasks.event_id = events.id "
        "left join event_name_types on events.event_name_id = event_name_types.id "
        "left join com_visit_types on tasks.com_visit_id = com_visit_types.id "
        "left join visit_location_types on tasks.visit_location_id = visit_location_types.id "
        "left join visit_outcome_types on tasks.visit_outcome_id = visit_outcome_types.id "
        "left join people on tasks.person_id = people.id "
        "left join person_names on people.person_names_id = person_names.id "
        "where "
        "tasks.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
        "tasks.date_of_task >= '" + Pdate(dateBegin->Date).OutDate(mdy | yyyy) + "' and "
        "tasks.date_of_task <= '" + Pdate(dateEnd->Date).OutDate(mdy | yyyy) + "' and "
        "tasks.com_dept_id + 1 > 1 and ";  // added so the filter wouldn't pull phone tasks (they should come up on a different screen)

  if(cboStaff->Text != "")
    sql += "tasks.user_id = " + lookupTables->IdOf("users", cboStaff->Text.c_str()) + " and ";
//  if(editEvent->Text != "")
//    sql += "events.event_name like '%" + SafeSQLString(editEvent->Text.c_str()) + "%' and ";
  if (cboEventName->Text != "")
    sql += "events.event_name_id = " + lookupTables->IdOf("event_name_types", cboEventName) + " and ";
  if(editMinTime->Text != "")
    sql += "tasks.time_spent >= " + string(editMinTime->Text.c_str()) + " and ";
  if(editMaxTime->Text != "")
     sql += "tasks.time_spent <= " + string(editMaxTime->Text.c_str()) + " and ";
  if(cboVisitType->Text != "")
    sql += "tasks.com_visit_id = " + lookupTables->IdOf("com_visit_types", cboVisitType->Text.c_str()) + " and ";
  if(cboLocation->Text != "")
    sql += "tasks.visit_location_id = " + lookupTables->IdOf("visit_location_types", cboLocation->Text.c_str()) + " and ";
  if(cboOutcome->Text != "")
    sql += "tasks.visit_outcome_id = " + lookupTables->IdOf("visit_outcome_types", cboOutcome->Text.c_str()) + " and ";
  if(cboTaskType->Text != "")
    sql += "tasks.task_purpose_id = " + lookupTables->IdOf("task_purpose_types", cboTaskType->Text.c_str(), cboTaskType) + " and ";
  if(checkNew->Checked)
    sql += "tasks.new_client = 1 and ";


  sql = sql.substr(0, sql.length()-5);
  // sql += " order by tasks.date_of_task, users.item";
  Filter->SetSQLStatement(sql);
  Filter->RefreshDataSet();
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCom::ScreenStart()
{
 // instead of formcreate, do startup stuff here or in the constructor
 // this gets called after stuff in the base classes's constructor
  Filter->SetListViewHandle(listSearchResults);
  Filter->SetSecurity("tasks.com");
  Filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  Filter->AddColumnSpec("Staff", "tasks", as_text, true, 110);
  Filter->AddColumnSpec("Event", "events", as_text, false, 110, rawString);
  Filter->AddColumnSpec("Client", "people", as_text, true, 110);
  Filter->AddColumnSpec("Time Spent", "tasks", as_double, true, 100);
  Filter->AddColumnSpec("Mileage", "tasks", as_double, false, 80);
  Filter->AddColumnSpec("Visit Type", "tasks", as_text, true, 110);
  Filter->AddColumnSpec("Location", "tasks", as_text, true, 110);
  Filter->AddColumnSpec("Outcome", "tasks", as_text, true, 110);
  Filter->AddColumnSpec("New Client", "tasks", as_text, false, 110, prettyBoolString);
  Filter->AddColumnSpec("Group Id", "internal_id", as_int, false, 80);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchtaskdiab.filter");
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

  Pdate begin_date(DateToStr(Date()).c_str(), mdy | yyyy);
  begin_date.mod(-14, in_days);
  dateBegin->Date = StrToDate(begin_date.OutDate(mdy | yyyy).c_str());
  dateEnd->Date = Date();

  lookupTables->RegisterComboBox("users", cboStaff);

  lookupTables->RegisterComboBox("visit_location_types", cboLocation);
  lookupTables->RegisterComboBox("com_visit_types", cboVisitType);
  lookupTables->RegisterComboBox("visit_outcome_types", cboOutcome);
  string task_sql = "select id, item, valid from task_purpose_types where group_id = 0 or group_id = '"
                    + lookupTables->IdOf("groups", "Community Health") + "' ";
  lookupTables->RegisterComboBox("task_purpose_types", cboTaskType, task_sql);

  string group_sql = "select id, item, valid from event_name_types "
                     "where (group_id = 0 or group_id = '" + lookupTables->IdOf("groups", "Community Health") + "') and valid = 1 order by item";
  lookupTables->RegisterComboBox("event_name_types", cboEventName, group_sql, SetGroupIdForNewLookupTableItem);

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCom::ScreenStop()
{
 // instead of formclose, do shutdown stuff here (combo boxes, etc.)
  lookupTables->UnregisterComboBox("users", cboStaff);
  lookupTables->UnregisterComboBox("visit_location_types", cboLocation);
  lookupTables->UnregisterComboBox("com_visit_types", cboVisitType);
  lookupTables->UnregisterComboBox("visit_outcome_types", cboOutcome);
  lookupTables->UnregisterComboBox("task_purpose_types", cboTaskType);
  lookupTables->UnregisterComboBox("event_name_types", cboEventName);

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCom::Create()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["com_dept_id"] = lookupTables->IdOf("com_dept_types", "adult"); // jhaley: Comm only uses Adult com_dept_id, evidently.
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health"); // jhaley 20100813: important!
  FORM_TRY
    TformRecordComVisit * taskRecord = new TformRecordComVisit(NULL, temp_map);
    taskRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskCom::Zoom(const string & p_id)
{
  map<string,string> temp_map;
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordComVisit * taskRecord = new TformRecordComVisit(NULL, temp_map);
    taskRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchTaskCom::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchTaskCom * z = new TformSearchTaskCom(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

