//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSearchTaskDiab.h"
#include "codeRecordTaskDiab.h"
#include "codeSearchEvent.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchTaskDiab *formSearchTaskDiab;
//---------------------------------------------------------------------------
__fastcall TformSearchTaskDiab::TformSearchTaskDiab(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("tasks"))
{
  Initialize();
}
//---------------------------------------------------------------------------

bool TformSearchTaskDiab::IsValidOnScreen()
{
  if (! lookupTables->IsInLookUpTable("users", cboStaff->Text.c_str()))
  {
    PSay("Please enter a valid staff name", m_invalid_data, MB_OK);
    cboStaff->SetFocus();
    return false;
  }
  else if (! IsFloat(editMinTime->Text.c_str()))
  {
    PSay("Please enter a valid min time spent", m_invalid_data, MB_OK);
    editMinTime->SetFocus();
    return false;
  }
  else if (! IsFloat(editMaxTime->Text.c_str()))
  {
    PSay("Please enter a valid max time spent", m_invalid_data, MB_OK);
    editMaxTime->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("diab_contact_types", cboContactType->Text.c_str()))
  {
    PSay("Please enter a valid type of contact", m_invalid_data, MB_OK);
    cboContactType->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("method_types", cboMethod->Text.c_str()))
  {
    PSay("Please enter a valid method of contact", m_invalid_data, MB_OK);
    cboMethod->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("direction_types", cboDirection->Text.c_str()))
  {
    PSay("Please enter either incoming or outgoing", m_invalid_data, MB_OK);
    cboDirection->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("program_types", cboProgram))
  {
    PSay("Please enter a valid program type", m_invalid_data, MB_OK);
    cboProgram->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("task_purpose_types", cboTaskType))
  {
    PSay("Please enter a valid task type", m_invalid_data, MB_OK);
    cboTaskType->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("classification_types", cboClassification->Text.c_str()))
  {
    PSay("Please enter a valid classification", m_invalid_data, MB_OK);
    cboClassification->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("diab_meeting_types", cboMeeting->Text.c_str()))
  {
    PSay("Please enter a valid meeting type", m_invalid_data, MB_OK);
    cboMeeting->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("diab_activity_types", cboActivity->Text.c_str()))
  {
    PSay("Please enter a valid activity type", m_invalid_data, MB_OK);
    cboActivity->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("event_location_types", cboLocation))
  {
    PSay("Please enter a valid location", m_invalid_data, MB_OK);
    cboLocation->SetFocus();
    return false;
  }

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskDiab::Search()
{
  string sql;

  sql = "select tasks.date_of_task, users.item, event_name_types.item, "
        "person_names.first_name || ' ' || person_names.last_name || ' ' || person_names.suffix name, "
        "tasks.time_spent, tasks.mileage, "
        "diab_contact_types.item, method_types.item, direction_types.item, program_types.item, "
        "task_purpose_types.item, classification_types.item, "
        "diab_meeting_types.item, diab_activity_types.item, "
        "case when event_location_types.zip_code_id = 0 then event_location_types.item "
             "when event_location_types.item = '' then (zip_codes.city || ', ' || zip_codes.state) "
             "else (zip_codes.city || ', ' || zip_codes.state || ' - ' || event_location_types.item) end event_location, "
        "tasks.is_educational, tasks.is_personal, "
        "tasks.task_comments, tasks.group_id, tasks.current_id, tasks.id "
        "from tasks "
        "left join users on tasks.user_id = users.id "
        "left join events on tasks.event_id = events.id "
        "left join event_name_types on events.event_name_id = event_name_types.id "
        "left join diab_contact_types on tasks.diab_contact_id = diab_contact_types.id "
        "left join method_types on tasks.method_id = method_types.id "
        "left join direction_types on tasks.direction_id = direction_types.id "
        "left join program_types on tasks.program_id = program_types.id "
        "left join task_purpose_types on tasks.task_purpose_id = task_purpose_types.id "
        "left join classification_types on tasks.classification_id = classification_types.id "
        "left join diab_meeting_types on tasks.diab_meeting_id = diab_meeting_types.id "
        "left join diab_activity_types on tasks.diab_activity_id = diab_activity_types.id "
        "left join event_location_types on tasks.event_location_id = event_location_types.id "
        "left join zip_codes on event_location_types.zip_code_id = zip_codes.id "
        "left join people on tasks.person_id = people.id "
        "left join person_names on people.person_names_id = person_names.id "
        "where "
        "tasks.group_id = " + lookupTables->IdOf("groups", "Diabetes") + " and "
        "tasks.date_of_task >= '" + Pdate(dateBegin->Date).OutDate(mdy | yyyy) + "' and "
        "tasks.date_of_task <= '" + Pdate(dateEnd->Date).OutDate(mdy | yyyy) + "' and ";

  if(cboStaff->Text != "")
    sql += "tasks.user_id = " + lookupTables->IdOf("users", cboStaff->Text.c_str()) + " and ";
//  if(editEvent->Text != "")
//    sql += "events.event_name like '%" + SafeSQLString(editEvent->Text.c_str()) + "%' and ";
  if (cboEventName->Text != "")
    sql += "events.event_name_id = " + lookupTables->IdOf("event_name_types", cboEventName) + " and ";
  if(editMinTime->Text != "")
    sql += "tasks.time_spent >= " + string(editMinTime->Text.c_str()) + " and ";
  if(editMaxTime->Text != "")
     sql += "tasks.time_spent <= " + string(editMaxTime->Text.c_str()) + " and ";
  if(cboContactType->Text != "")
    sql += "tasks.diab_contact_id = " + lookupTables->IdOf("diab_contact_types", cboContactType->Text.c_str()) + " and ";
  if(cboMethod->Text != "")
    sql += "tasks.method_id = " + lookupTables->IdOf("method_types", cboMethod->Text.c_str()) + " and ";
  if(cboDirection->Text != "")
    sql += "tasks.direction_id = " + lookupTables->IdOf("direction_types", cboDirection->Text.c_str()) + " and ";
  if(cboProgram->Text != "")
    sql += "tasks.program_id = " + lookupTables->IdOf("program_types", cboProgram) + " and ";
  if(cboTaskType->Text != "")
    sql += "tasks.task_purpose_id = " + lookupTables->IdOf("task_purpose_types", cboTaskType->Text.c_str(), cboTaskType) + " and ";
  if(cboClassification->Text != "")
    sql += "tasks.classification_id = " + lookupTables->IdOf("classification_types", cboClassification->Text.c_str()) + " and ";
  if(cboMeeting->Text != "")
    sql += "tasks.diab_meeting_id = " + lookupTables->IdOf("diab_meeting_types", cboMeeting->Text.c_str()) + " and ";
  if(cboActivity->Text != "")
    sql += "tasks.diab_activity_id = " + lookupTables->IdOf("diab_activity_types", cboActivity->Text.c_str()) + " and ";
  if(cboLocation->Text != "")
    sql += "tasks.event_location_id = " + lookupTables->IdOf("event_location_types", cboLocation) + " and ";
  if(checkEducational->Checked)
    sql += "tasks.is_educational = 1 and ";
  if(checkPersonal->Checked)
    sql += "tasks.is_personal = 1 and ";

  sql = sql.substr(0, sql.length()-5);
  // sql += " order by tasks.date_of_task, users.item";
  Filter->SetSQLStatement(sql);
  Filter->RefreshDataSet();
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskDiab::ScreenStart()
{
 // instead of formcreate, do startup stuff here or in the constructor
 // this gets called after stuff in the base classes's constructor
  Filter->SetListViewHandle(listSearchResults);
  Filter->SetSecurity("tasks.diab");
  Filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  Filter->AddColumnSpec("Staff", "tasks", as_text, true, 110);
  Filter->AddColumnSpec("Event", "events", as_text, false, 110, rawString);
  Filter->AddColumnSpec("Client", "people", as_text, true, 110);
  Filter->AddColumnSpec("Time Spent", "tasks", as_double, true, 100);
  Filter->AddColumnSpec("Mileage", "tasks", as_double, false, 80);
  Filter->AddColumnSpec("Type of Contact", "tasks", as_text, false, 120);
  Filter->AddColumnSpec("Method of Contact", "tasks", as_text, true, 130);
  Filter->AddColumnSpec("In/Out", "tasks", as_text, false, 80);
  Filter->AddColumnSpec("Program", "tasks", as_text, false, 90);
  Filter->AddColumnSpec("Task Type", "tasks", as_text, false, 100);
  Filter->AddColumnSpec("Classification", "tasks", as_text, false, 110);
  Filter->AddColumnSpec("Meeting Type", "tasks", as_text, false, 110);
  Filter->AddColumnSpec("Activity Type", "tasks", as_text, true, 110);
  Filter->AddColumnSpec("Location", "tasks", as_text, false, 110, rawString);
  Filter->AddColumnSpec("Is Educational", "tasks", as_text, false, 110, prettyBoolString);
  Filter->AddColumnSpec("Is Personal", "tasks", as_text, false, 100, prettyBoolString);
  Filter->AddColumnSpec("Comments", "tasks", as_text, false, 150, sentenceString);
  Filter->AddColumnSpec("Group Id", "internal_id", as_int, false, 80);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchtaskdiab.filter");
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();
  
  Pdate begin_date(DateToStr(Date()).c_str(), mdy | yyyy);
  begin_date.mod(-14, in_days);
  dateBegin->Date = StrToDate(begin_date.OutDate(mdy | yyyy).c_str());
  dateEnd->Date = Date();

  lookupTables->RegisterComboBox("users", cboStaff);
  lookupTables->RegisterComboBox("diab_contact_types", cboContactType);
  lookupTables->RegisterComboBox("method_types", cboMethod);
  lookupTables->RegisterComboBox("direction_types", cboDirection);
  lookupTables->RegisterComboBox("diab_meeting_types", cboMeeting);
  lookupTables->RegisterComboBox("classification_types", cboClassification);
  lookupTables->RegisterComboBox("diab_activity_types", cboActivity);
  string location_sql = "select event_location_types.id, case "
                        "when event_location_types.zip_code_id = 0 then item "
                        "when item = '' then (city || ', ' || state) "
                        "else (city || ', ' || state || ' - ' || item) end item, event_location_types.valid "
                        "from event_location_types "
                        "inner join zip_codes on event_location_types.zip_code_id = zip_codes.id "
                        "where (group_id = 0 or group_id = '" + lookupTables->IdOf("groups", "Diabetes") + "') "
                        "and valid = 1 order by state, city, item ";
  lookupTables->RegisterComboBox("event_location_types", cboLocation, location_sql);

  string task_sql = "select id, item, valid from task_purpose_types where group_id = 0 or group_id = '"
                    + lookupTables->IdOf("groups", "Diabetes") + "' ";
  lookupTables->RegisterComboBox("task_purpose_types", cboTaskType, task_sql);

  string group_sql = "select id, item, valid from event_name_types "
                     "where (group_id = 0 or group_id = '" + lookupTables->IdOf("groups", "Diabetes") + "') and valid = 1 order by item";
  lookupTables->RegisterComboBox("event_name_types", cboEventName, group_sql, SetGroupIdForNewLookupTableItem);

  string event_program_sql = "select id, item, valid from program_types "
                             "where (group_id = 0 or group_id = '" + lookupTables->IdOf("groups", "Diabetes") + "') "
                             "and valid = 1 order by item ";
  lookupTables->RegisterComboBox("program_types", cboProgram, event_program_sql);

 return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskDiab::ScreenStop()
{
 // instead of formclose, do shutdown stuff here (combo boxes, etc.)
  lookupTables->UnregisterComboBox("users", cboStaff);
  lookupTables->UnregisterComboBox("diab_contact_types", cboContactType);
  lookupTables->UnregisterComboBox("method_types", cboMethod);
  lookupTables->UnregisterComboBox("direction_types", cboDirection);
  lookupTables->UnregisterComboBox("diab_meeting_types", cboMeeting);
  lookupTables->UnregisterComboBox("classification_types", cboClassification);
  lookupTables->UnregisterComboBox("diab_activity_types", cboActivity);
  lookupTables->UnregisterComboBox("event_location_types", cboLocation);
  lookupTables->UnregisterComboBox("program_types", cboProgram);
  lookupTables->UnregisterComboBox("task_purpose_types", cboTaskType);
  lookupTables->UnregisterComboBox("event_name_types", cboEventName);

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskDiab::Create()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Diabetes");
  FORM_TRY
    TformRecordTaskDiab * taskRecord = new TformRecordTaskDiab(NULL, temp_map);
    taskRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskDiab::Zoom(const string & p_id)
{
  map<string,string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordTaskDiab * taskRecord = new TformRecordTaskDiab(NULL, temp_map);
    taskRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchTaskDiab::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchTaskDiab * z = new TformSearchTaskDiab(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

