//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
 
#include "codeSearchTaskTrans.h"
#include "codeRecordTaskTrans.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchTaskTrans *formSearchTaskTrans;
//---------------------------------------------------------------------------
__fastcall TformSearchTaskTrans::TformSearchTaskTrans(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("tasks"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchTaskTrans::IsValidOnScreen()
{
  if (! lookupTables->IsInLookUpTable("users", cboStaff->Text.c_str()))
  {
    PSay("Please enter a valid staff name", m_invalid_data, MB_OK);
    cboStaff->SetFocus();
    return false;
  }
  else if (! IsFloat(editMinTime->Text.c_str()))
  {
    PSay("Please enter a valid min time spent", m_invalid_data, MB_OK);
    editMinTime->SetFocus();
    return false;
  }
  else if (! IsFloat(editMaxTime->Text.c_str()))
  {
    PSay("Please enter a valid max time spent", m_invalid_data, MB_OK);
    editMaxTime->SetFocus();
    return false;
  }
  else if (! IsFloat(editMinMileage->Text.c_str()))
  {
    PSay("Please enter a valid min mileage", m_invalid_data, MB_OK);
    editMinMileage->SetFocus();
    return false;
  }
  else if (! IsFloat(editMaxMileage->Text.c_str()))
  {
    PSay("Please enter a valid max mileage", m_invalid_data, MB_OK);
    editMaxMileage->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskTrans::Search()
{
  string sql;

  sql = "select tasks.date_of_task, tasks.time_of_task, transp_action_types.item, users.item, "
        "person_names.first_name || ' ' || person_names.last_name || ' ' || person_names.suffix name, "
        "tasks.time_spent, tasks.mileage, "
        "tasks.task_comments, tasks.current_id, tasks.id "
        "from tasks "
        "inner join users on tasks.user_id = users.id "
        "left join transp_action_types on transp_action_types.id = tasks.transp_action_id "
        "left join people on tasks.person_id = people.id "
        "left join person_names on people.person_names_id = person_names.id "
        "where "
        "tasks.group_id = " + lookupTables->IdOf("groups", "Transportation") + " and "
        "tasks.date_of_task >= '" + Pdate(dateBegin->Date).OutDate(mdy | yyyy) + "' and "
        "tasks.date_of_task <= '" + Pdate(dateEnd->Date).OutDate(mdy | yyyy) + "' and ";

  if(cboStaff->Text != "")
    sql += "tasks.user_id = " + lookupTables->IdOf("users", cboStaff->Text.c_str()) + " and ";
  if(editMinTime->Text != "")
    sql += "tasks.time_spent >= " + string(editMinTime->Text.c_str()) + " and ";
  if(editMaxTime->Text != "")
     sql += "tasks.time_spent <= " + string(editMaxTime->Text.c_str()) + " and ";
  if(editMinMileage->Text != "")
    sql += "tasks.mileage >= " + string(editMinMileage->Text.c_str()) + " and ";
  if(editMaxMileage->Text != "")
     sql += "tasks.mileage <= " + string(editMaxMileage->Text.c_str()) + " and ";
  if(editComment->Text != "")
     sql += "upper(tasks.task_comments) like '%" + UppercaseString(editComment->Text.c_str()) + "%' and ";


  sql = sql.substr(0, sql.length()-5);
  // sql += " order by tasks.date_of_task, users.item";
  Filter->SetSQLStatement(sql);
  Filter->RefreshDataSet();
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskTrans::ScreenStart()
{
 // instead of formcreate, do startup stuff here or in the constructor
 // this gets called after stuff in the base classes's constructor
  Filter->SetListViewHandle(listSearchResults);
  Filter->SetSecurity("tasks");
  Filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  Filter->AddColumnSpec("Time", "tasks", as_time, true, 80);
  Filter->AddColumnSpec("Type", "tasks", as_text, true, 80);
  Filter->AddColumnSpec("Employee", "tasks", as_text, true, 110);
  Filter->AddColumnSpec("Person", "people", as_text, true, 110);
  Filter->AddColumnSpec("Time Spent", "tasks", as_double, true, 100);
  Filter->AddColumnSpec("Mileage", "tasks", as_double, true, 80);
  Filter->AddColumnSpec("Comments", "tasks", as_text, true, 150, sentenceString);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchtasktrans.filter");
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();
  
  Pdate begin_date(DateToStr(Date()).c_str(), mdy | yyyy);
  begin_date.mod(-14, in_days);
  dateBegin->Date = StrToDate(begin_date.OutDate(mdy | yyyy).c_str());
  dateEnd->Date = Date();

  lookupTables->RegisterComboBox("users", cboStaff);

 return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskTrans::ScreenStop()
{
 // instead of formclose, do shutdown stuff here (combo boxes, etc.)
  lookupTables->UnregisterComboBox("users", cboStaff);
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskTrans::Create()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  FORM_TRY
    TformRecordTaskTrans * taskRecord = new TformRecordTaskTrans(NULL, temp_map);
    taskRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaskTrans::Zoom(const string & p_id)
{
  map<string,string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordTaskTrans * taskRecord = new TformRecordTaskTrans(NULL, temp_map);
    taskRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchTaskTrans::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchTaskTrans * z = new TformSearchTaskTrans(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

