//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSearchTaxEntity.h"
#include "codeRecordTaxEntity.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchTaxEntity *formSearchTaxEntity;
//---------------------------------------------------------------------------
__fastcall TformSearchTaxEntity::TformSearchTaxEntity(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("tax_entities"))
{
  if (optionsPermissions["special.beh.general"]["enabled"] != "true")
  {
    lblCare->Enabled = false;
    cboCare->Enabled = false;
    lblServed->Enabled = false;
    cboServed->Enabled = false;
    lblAgency->Enabled = false;
    cboAgency->Enabled = false;
  }
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchTaxEntity::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxes
  // corrospond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect
  if (! lookupTables->IsInLookUpTable("state_types", cboState->Text.c_str()))
  {
    PSay("Please enter a valid state", m_invalid_data, MB_OK);
    cboState->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("tax_entity_types", cboType->Text.c_str()))
  {
    PSay("Please enter a valid entity type", m_invalid_data, MB_OK);
    cboType->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("insurance_types", cboInsurance->Text.c_str()))
  {
    PSay("Please enter a valid insurance type", m_invalid_data, MB_OK);
    cboInsurance->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("beh_care_types", cboCare->Text.c_str()))
  {
    PSay("Please enter a valid type of care", m_invalid_data, MB_OK);
    cboCare->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("beh_agency_types", cboAgency->Text.c_str()))
  {
    PSay("Please enter a valid agency type", m_invalid_data, MB_OK);
    cboAgency->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("beh_pop_types", cboServed->Text.c_str()))
  {
    PSay("Please enter a valid population served", m_invalid_data, MB_OK);
    cboServed->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaxEntity::Search()
{
  string sql;
  string subsql;

  sql = "select tax_entities.name, tax_entity_types.item, tax_addresses.line1, tax_addresses.line2, "
        "tax_addresses.city, state_types.abbreviation, tax_addresses.zip, "
        "tax_addresses.phone_number, tax_addresses.fax_number, tax_addresses.email_address, "
        "chs_acct.identifier, tax_entities.specialty, "
        "tin.identifier, beh_care_types.item, beh_pop_types.item, "
        "beh_agency_types.item, tax_entities.current_id, tax_entities.id "
        "from tax_entities "
        "inner join tax_entity_types on tax_entities.tax_entity_id = tax_entity_types.id "
        "inner join tax_addresses on tax_addresses.id = tax_entities.physical_address_id "
        "inner join state_types on tax_addresses.state_id = state_types.id "
        "left join entity_ids chs_acct on chs_acct.tax_entity_id = tax_entities.id and chs_acct.current_id >= 3 and chs_acct.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "CHS Account") + "' "
        "left join entity_ids tin on tin.tax_entity_id = tax_entities.id and tin.current_id >= 3 and tin.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "TIN/EIN") + "' "
        "left join insurance_policies on insurance_policies.tax_entity_id = tax_entities.id "
        "left join insurance_types on insurance_policies.insurance_id = insurance_types.id "
        "inner join beh_care_types on tax_entities.beh_care_id = beh_care_types.id "
        "inner join beh_pop_types on tax_entities.beh_pop_id = beh_pop_types.id "
        "inner join beh_agency_types on tax_entities.beh_agency_id = beh_agency_types.id "
        "where tax_entities.id > 0 ";
  if (editProvider->Text != "")
    sql += " and (upper(tax_entities.name) like '%" + SafeSQLString(ReplaceStringWithString(editProvider->Text.c_str(), " ", "%")) + "%' or "
                 "upper(tax_entities.name) like '" + SafeSQLString(InitialsSearchString1(editProvider->Text.c_str())) + "' or "
                 "upper(tax_entities.name) like '" + SafeSQLString(InitialsSearchString2(editProvider->Text.c_str())) + "') ";
  if (editAccount->Text != "")
    sql += " and chs_acct.identifier like '%" + SafeSQLString(editProvider->Text.c_str()) + "%' ";
  if (editSpecialty->Text != "")
    sql += " and tax_entities.specialty like '%" + SafeSQLString(editSpecialty->Text.c_str()) + "%' ";
  if (editTaxid->Text != "")
    sql += " and tin.identifier like '%" + SafeSQLString(editTaxid->Text.c_str()) + "%' ";
  if (cboInsurance->Text != "")
    sql += " and insurance_policies.insurance_id = " + lookupTables->IdOf("insurance_types", cboInsurance->Text.c_str()) + " ";
  if (cboCare->Text != "")
    sql += " and tax_entities.beh_care_id = " + lookupTables->IdOf("beh_care_types", cboCare->Text.c_str()) + " ";
  if (cboServed->Text != "")
    sql += " and tax_entities.beh_pop_id = " + lookupTables->IdOf("beh_pop_types", cboServed->Text.c_str()) + " ";
  if (cboAgency->Text != "")
    sql += " and tax_entities.beh_agency_id = " + lookupTables->IdOf("beh_agency_types", cboAgency->Text.c_str()) + " ";

  if ((editCity->Text != "") || (cboState->Text != "") || (editZip->Text != "") || (editPhone->Text != ""))
  {
    sql += " and exists(select tax_addresses.id from tax_addresses where tax_addresses.tax_entity_id = tax_entities.id";
    if(editCity->Text != "")
      sql += " and tax_addresses.city like '%" + SafeSQLString(editCity->Text.c_str()) + "%'";
    if (cboState->Text != "")
      sql += " and tax_addresses.state_id = " + lookupTables->IdOf("state_types", cboState->Text.c_str());
    if (editZip->Text != "")
      sql += " and tax_addresses.zip like '%" + StripAllExcept(SafeSQLString(editZip->Text.c_str()), uints) + "%'";
    if (editPhone->Text != "")
      sql += " and tax_addresses.phone_number like '%" + StripAllExcept(SafeSQLString(editPhone->Text.c_str()), uints) + "%'";
    sql += ")";
  }

  if (cboType->Text != "")
    sql += " and tax_entities.tax_entity_id = " + lookupTables->IdOf("tax_entity_types", cboType);

  sql += " group by tax_entities.name, tax_entity_types.item, tax_addresses.line1, tax_addresses.line2, "
         "tax_addresses.city, state_types.abbreviation, tax_addresses.zip, "
         "tax_addresses.phone_number, tax_addresses.fax_number, tax_addresses.email_address, "
         "chs_acct.identifier, tax_entities.specialty, "
         "tin.identifier, beh_care_types.item, beh_pop_types.item, "
         "beh_agency_types.item, tax_entities.current_id, tax_entities.id ";

  Filter->SetSQLStatement (sql);
  Filter->RefreshDataSet ();

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaxEntity::ScreenStart()
{
  lookupTables->RegisterComboBox("state_types", cboState);
  lookupTables->RegisterComboBox("tax_entity_types", cboType);
  lookupTables->RegisterComboBox("insurance_types", cboInsurance);
  lookupTables->RegisterComboBox("beh_care_types", cboCare);
  lookupTables->RegisterComboBox("beh_pop_types", cboServed);
  lookupTables->RegisterComboBox("beh_agency_types", cboAgency);

  Filter->SetSecurity("tax_entities");
  Filter->AddColumnSpec("Name", "tax_entities", as_text, true, 200, rawString);
  Filter->AddColumnSpec("Type", "tax_entities", as_text, false, 50);
  Filter->AddColumnSpec("Line 1", "tax_addresses", as_text, false, 100, addressString);
  Filter->AddColumnSpec("Line 2", "tax_addresses", as_text, false, 100, addressString);
  Filter->AddColumnSpec("City", "tax_addresses", as_text, true, 100);
  Filter->AddColumnSpec("State", "tax_addresses", as_text, false, 100, uppercaseString);
  Filter->AddColumnSpec("Zip", "tax_addresses", as_text, false, 100, prettyZipString);
  Filter->AddColumnSpec("Phone", "tax_addresses", as_text, true, 100, prettyPhoneString);
  Filter->AddColumnSpec("Fax", "tax_addresses", as_text, false, 100, prettyPhoneString);
  Filter->AddColumnSpec("E-mail", "tax_addresses", as_text, false, 100, lowercaseString);
  Filter->AddColumnSpec("Account", "tax_entities", as_text, false, 100);
  Filter->AddColumnSpec("Specialty", "tax_entities", as_text, true, 100);
  Filter->AddColumnSpec("Tax ID", "tax_entities", as_text, false, 100);
//  Filter->AddColumnSpec("Insurance", "tax_entities", as_text, false, 100);  // Philip says no
  Filter->AddColumnSpec("Care", "tax_entities", as_text, false, 100);
  Filter->AddColumnSpec("Served", "tax_entities", as_text, false, 100);
  Filter->AddColumnSpec("Agency", "tax_entities", as_text, false, 100);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchtaxentity.filter");
  Filter->SetIconStatus(true);
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

 return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaxEntity::ScreenStop()
{
  lookupTables->UnregisterComboBox("state_types", cboState);
  lookupTables->UnregisterComboBox("tax_entity_types", cboType);
  lookupTables->UnregisterComboBox("insurance_types", cboInsurance);
  lookupTables->UnregisterComboBox("beh_care_types", cboCare);
  lookupTables->UnregisterComboBox("beh_pop_types", cboServed);
  lookupTables->UnregisterComboBox("beh_agency_types", cboAgency);
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaxEntity::Create()
{
   map<string,string> temp_map;
   temp_map["id"] = "new";
   FORM_TRY
     TformRecordTaxEntity * tax_entity = new TformRecordTaxEntity(NULL, temp_map);
     tax_entity->Show();
   FORM_CATCH
   return true;
}
//---------------------------------------------------------------------------
bool TformSearchTaxEntity::Zoom(const string & p_id)
{

  map<string,string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordTaxEntity * tax_entity = new TformRecordTaxEntity(NULL, temp_map);
    tax_entity->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchTaxEntity::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchTaxEntity * z = new TformSearchTaxEntity(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

