//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSearchTransaction.h"
#include "codeRecordTransaction.h"
#include "codeSearchTaxEntity.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSearchGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSearchTransaction *formSearchTransaction;
//---------------------------------------------------------------------------
__fastcall TformSearchTransaction::TformSearchTransaction(TComponent* Owner, vector<string> * p_return_vector)
        : TformSearchGeneric(Owner, p_return_vector, string ("transactions"))
{
  tax_entity_id = "";
  Initialize();
}
//---------------------------------------------------------------------------
bool TformSearchTransaction::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxes
  // corrospond to values in that look up table.
  // give the user a message box and prompt to re-enter if incorrect
  if (! Pdate (editEffectiveBeginDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editEffectiveBeginDate->Text == ""))
  {
    PSay("Please enter a valid effective begin date", m_invalid_data, MB_OK);
    editEffectiveBeginDate->SetFocus();
    return false;
  }
  else if (! Pdate (editEffectiveEndDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editEffectiveEndDate->Text == ""))
  {
    PSay("Please enter a valid effective end date", m_invalid_data, MB_OK);
    editEffectiveEndDate->SetFocus();
    return false;
  }
  else if (! Pdate (editFiscalBeginDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editFiscalBeginDate->Text == ""))
  {
    PSay("Please enter a valid fiscal begin date", m_invalid_data, MB_OK);
    editFiscalBeginDate->SetFocus();
    return false;
  }
  else if (! Pdate (editFiscalEndDate->Text.c_str(), mdy | yy).IsValidDate() && ! (editFiscalEndDate->Text == ""))
  {
    PSay("Please enter a valid fiscal end date", m_invalid_data, MB_OK);
    editFiscalEndDate->SetFocus();
    return false;
  }
  else if(! lookupTables->IsInLookUpTable("account_types", cboAccount->Text.c_str()))
  {
    PSay("Please enter a valid account", m_invalid_data, MB_OK);
    cboAccount->SetFocus();
    return false;
  }
  else if(! IsAmount(editMinAmount->Text.c_str()))
  {
    PSay("Please enter a valid min amount", m_invalid_data, MB_OK);
    editMinAmount->SetFocus();
    return false;
  }
  else if(! IsAmount(editMaxAmount->Text.c_str()))
  {
    PSay("Please enter a valid max amount", m_invalid_data, MB_OK);
    editMaxAmount->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformSearchTransaction::Search()
{
  string sql;
  sql = "select tax_entities.name, transactions.effective_date, transactions.fiscal_date, accounts.name, "
        "account_types.item, transactions.note, transactions.debit_amount, "
        "transactions.credit_amount, transactions.transaction_number, "
        "purchase_reqs.purchase_req_number, checks.check_number, "
        "transactions.current_id, transactions.id "
        "from transactions "
        "inner join bills on transactions.bill_id = bills.id "
        "inner join purchase_reqs on bills.purchase_req_id = purchase_reqs.id "
        "inner join checks on purchase_reqs.check_id = checks.id "
        "inner join accounts on transactions.account_id = accounts.id "
        "inner join account_types on accounts.account_type_id = account_types.id "
        "inner join tax_entities on transactions.tax_entity_id = tax_entities.id "
        "where transactions.id > 0 ";

  if(editTaxEntity->Text != "")
    sql += "and upper(tax_entities.name) like '%" + SafeSQLString(editTaxEntity->Text.c_str()) + "%' ";
  if(editEffectiveBeginDate->Text != "")
    sql += "and transactions.effective_date >= '" + Pdate(editEffectiveBeginDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
  if(editEffectiveEndDate->Text != "")
    sql += "and transactions.effective_date <= '" + Pdate(editEffectiveEndDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
  if(editFiscalBeginDate->Text != "")
    sql += "and transactions.fiscal_date >= '" + Pdate(editFiscalBeginDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
  if(editFiscalEndDate->Text != "")
    sql += "and transactions.fiscal_date <= '" + Pdate(editFiscalEndDate->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
  if(cboAccount->Text != "")
    sql += "and accounts.account_type_id = " + lookupTables->IdOf("account_types", cboAccount->Text.c_str());
  if(editMinAmount->Text != "")
    sql += "and ((transactions.credit_amount >= " + SafeSQLString(editMinAmount->Text.c_str()) + " and transactions.debit_amount = 0.00) or "
           "(transactions.debit_amount >= " + SafeSQLString(editMinAmount->Text.c_str()) + " and transactions.credit_amount = 0.00)) ";
  if(editMaxAmount->Text != "")
    sql += "and ((transactions.credit_amount <= " + SafeSQLString(editMaxAmount->Text.c_str()) + " and transactions.debit_amount = 0.00) or "
           "(transactions.debit_amount <= " + SafeSQLString(editMaxAmount->Text.c_str()) + " and transactions.credit_amount = 0.00)) ";
  if(editTransactionNum->Text != "")
    sql += "and transactions.transaction_number like '%" + SafeSQLString(editTransactionNum->Text.c_str()) + "%' ";
  if(editPrNumber->Text != "")
    sql += "and purchase_reqs.purchase_req_number like '%" + SafeSQLString(editPrNumber->Text.c_str()) + "%' ";
  if(editCheckNumber->Text != "")
    sql += "and checks.check_number like '%" + SafeSQLString(editCheckNumber->Text.c_str()) + "%' ";
  if(editNote->Text != "")
    sql += "and transactions.note like '%" + SafeSQLString(editNote->Text.c_str()) + "%' ";

  Filter->SetSQLStatement(sql);
  Filter->RefreshDataSet();
  return true;

}
//---------------------------------------------------------------------------
bool TformSearchTransaction::ScreenStart()
{
 // instead of formcreate, do startup stuff here or in the constructor
 // this gets called after stuff in the base classes's constructor

  lookupTables->RegisterComboBox("account_types", cboAccount);

  Filter->SetListViewHandle(listSearchResults);
  Filter->SetSecurity("transactions");
  Filter->AddColumnSpec("Tax Entity", "tax_entities", as_text, true, 120, rawString);
  Filter->AddColumnSpec("Eff. Date", "transactions", as_date, true, 75);
  Filter->AddColumnSpec("Fisc. Date", "transactions", as_date, true, 75);
  Filter->AddColumnSpec("Account", "accounts", as_text, true, 140);
  Filter->AddColumnSpec("Type", "accounts", as_text, true, 75);
  Filter->AddColumnSpec("Note", "transactions", as_text, false, 120, sentenceString);
  Filter->AddColumnSpec("Debit", "transactions", as_double, true, 75, nonzeroAmountString);
  Filter->AddColumnSpec("Credit", "transactions", as_double, true, 75, nonzeroAmountString);
  Filter->AddColumnSpec("Trans #", "transactions", as_text, true, 75);
  Filter->AddColumnSpec("PR #", "purchase_reqs", as_text, true, 75);
  Filter->AddColumnSpec("Check #", "checks", as_text, true, 75);
  Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter->FetchPreferences("searchtransaction.filter");
  Filter->SetSQLStatement("");
  Filter->RefreshDataSet();

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTransaction::ScreenStop()
{
  lookupTables->UnregisterComboBox("account_types", cboAccount);
  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTransaction::Create()
{

  return true;
}
//---------------------------------------------------------------------------
bool TformSearchTransaction::Zoom(const string & p_id)
{
  map<string, string> temp_map;
  temp_map["id"] = p_id;
  FORM_TRY
    TformRecordTransaction * transaction_record = new TformRecordTransaction(NULL, temp_map);
    transaction_record->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
vector<string> TformSearchTransaction::Do(TformSpecialGeneric * p_parent)
{
 vector<string> answer;
 FORM_TRY
  TformSearchTransaction * z = new TformSearchTransaction(NULL, &answer);
  z->ShowTaskModal(p_parent);
 FORM_CATCH
 return answer;
}
//---------------------------------------------------------------------------

