//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialAddEventTaskContacts.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialAddEventTaskContacts *formSpecialAddEventTaskContacts;
//---------------------------------------------------------------------------
__fastcall TformSpecialAddEventTaskContacts::TformSpecialAddEventTaskContacts(TComponent* Owner, map<string,string> event_state)
        : TformSpecialGeneric(Owner)
{
  current_event_state = event_state;
  this->IconIndex = 44;

  dbTransaction = new TIBTransaction(NULL);

  // jhaley 20100802: use StdTransaction and a try block around everything here for added safety.
  try
  {
    vector<map<string,string> > unique_employees, event_tasks, event_contacts;

    StdTransaction(dbTransaction, dbDatabase);

    all_checked = true;

    string sql = "select distinct users.id, users.item user_name "
                 "from tasks "
                 "left join users on tasks.user_id = users.id "
                 "where ";

    // jhaley: I'll just get this manually rather than create an entire dummy lookup for the two id gets in this module.
    string task_purpose_id = GetOneField(dbTransaction,
                                         "select id from task_purpose_types where UPPER(item) like 'EVENT TEACHING/LEADING'");

    string task_criteria = "tasks.current_id >= 3 and tasks.event_id = '" + current_event_state["id"] + "' and "
                           "tasks.task_purpose_id = '" + task_purpose_id + "'";
    sql += task_criteria;

    SqlToVecMap(dbTransaction, sql, unique_employees);
    for (unsigned int i = 0; i < unique_employees.size(); i++)
    {
      struct column_with_id current_employee;

      current_employee.column_name = listTableTaskContacts->Columns->Add();
      current_employee.id = unique_employees[i]["id"];
      current_employee.column_name->Caption = unique_employees[i]["user_name"].c_str();
      list_columns.push_back(current_employee);

      // get the most recent task matching the above criteria plus being for the current employee
      string task_sql = "select first 1 * from tasks where user_id = '" + unique_employees[i]["id"]
                        + "' and " + task_criteria + " order by id desc";

      // SqlToMap only looks at the first row of the resultant dataset and the ending map will contain is in that row.  Since we
      // sort descending by id, this will give us the same thing as the above statement without the subselect.  Bonus!
      // employee_tasks == map<user_id, map<tasks_field, tasks_field_value> > == employee -> task_map
      SqlToMap(dbDatabase, task_sql, employee_tasks[unique_employees[i]["id"]]);
    }

    sql = "select participations.id participations_id, people.id, "
          "person_names.last_name || ', ' || person_names.first_name participant_name, "
          "participations.current_id participant_current_id "
          "from participations "
          "left join people on participations.person_id = people.id "
          "left join person_names on people.person_names_id = person_names.id "
          "where event_id = '" + current_event_state["id"] + "' "
          "order by person_names.last_name, person_names.first_name";

    SqlToVecMap(dbTransaction, sql, event_contacts);
    for (unsigned int i = 0; i < event_contacts.size(); i++)
      event_contacts[i]["participant_name"] = PrettyString(event_contacts[i]["participant_name"]);

    if (!unique_employees.empty())
    {
      for (unsigned int i = 0; i < event_contacts.size(); i++)
      {
        struct item_with_id current_participant;

        current_participant.row_name = listTableTaskContacts->Items->Add();
        current_participant.id = event_contacts[i]["id"];
        current_participant.row_name->Caption = event_contacts[i]["participant_name"].c_str();
        current_participant.participations_id = event_contacts[i]["participations_id"].c_str();

        for (unsigned int j = 0; j < unique_employees.size(); j++)
        {
          // jhaley: note that diab_contact_id is not really used any more, and is effectively a constant.
          // It remains here for legacy reasons only, and no longer implies that contacts only attach to Diabetes events.
          sql = "select id "
                "from tasks "
                "where user_id = '" + list_columns[j].id        + "' "
                "and person_id = '" + current_participant.id    + "' "
                "and event_id = '"  + current_event_state["id"] + "' "
                "and diab_contact_id = '" + lookupTables->IdOf("diab_contact_types", "Contact") + "' "
                "and current_id >= 3 ";

          current_participant.row_name->SubItems->Add("");

          if (!StringToInt(GetOneField(dbTransaction, sql)))
          {
            current_participant.row_name->SubItemImages[j] = 0;
            all_checked = false;
          }
          else
          {
            current_participant.row_name->SubItemImages[j] = 1;
          }
          // current_participant.row_name->ImageIndex = -1;
          current_participant.row_name->ImageIndex = StringToInt(event_contacts[i]["participant_current_id"]) + 2;
        }
        list_items.push_back(current_participant);
      }
      if (!all_checked)
      {
        btnCheckAll->Caption = "Check All";
      }

      // jhaley: size up the contact name columns
      if (listTableTaskContacts->Columns->Count >= 2)
      {
        for (int i = 1; i < listTableTaskContacts->Columns->Count; i++)
          listTableTaskContacts->Columns->Items[i]->Width = 120;
      }
    }
    else
    {
      // this is still rather odd. but okay. whatever, bryan. maybe this means listviews need a property that is
      // "alternate message to show at top" or somesuch?
      listview_label           = new TStaticText((void*)NULL);
      listview_label->AutoSize = true;
      listview_label->Caption  = "Please add at least one task to the event of type 'Event Teaching/Leading'.";
      listview_label->Parent   = listTableTaskContacts;
      listview_label->Left     = (listTableTaskContacts->Width - listview_label->Width) / 2;
      listview_label->Top      = listview_label->Height * 1.50;
      listview_label->Anchors << akTop;
      listview_label->Anchors >> akLeft >> akRight >> akBottom;
    }
    dbTransaction->Commit();
  } // end try
  catch (...)
  {
    PSay("Error getting contacts list.", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
}
//---------------------------------------------------------------------------
// jhaley 20100803: Dynamic resources held by this class were possibly not being released in the event of problems
// with the form that prevented a FormClose event, and the database transaction object wasn't being freed at all,
// in fact.
__fastcall TformSpecialAddEventTaskContacts::~TformSpecialAddEventTaskContacts()
{
  if (listview_label)
  {
    delete listview_label; // why did bryan dynamically create this? no idea. but at least we can avoid memory leaks, eh?
    listview_label = NULL;
  }

  // jhaley: destroy the form-local transaction object
  if (dbTransaction)
  {
    if(dbTransaction->Active)
      dbTransaction->Rollback();
    delete dbTransaction;
    dbTransaction = NULL;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddEventTaskContacts::listTableTaskContactsClick(TObject *Sender)
{
  // determine x and y position
  if (listTableTaskContacts->SelCount > 0)
  {
    TListItem * row = listTableTaskContacts->Selected;

    x_pos -= row->Position.x - 2; // TODO -c MAGIC : no idea where '2' comes from exactly, or when it might change.

    int i;
    int left = 0;
    for (i = 0; i < listTableTaskContacts->Columns->Count; i++)
    {
      if (x_pos >= left && x_pos < left + min(imageList->Width, listTableTaskContacts->Columns->Items[i]->Width))
        break;
      left += listTableTaskContacts->Columns->Items[i]->Width;
    }

    if (i > 0 && (i-1 < row->SubItems->Count))
    {
      row->SubItemImages[i-1] = (row->SubItemImages[i-1] + 1) % 2;

      // now, for all currently selected rows, modify rows such that their column value matches this one exactly
      TItemStates selected = TItemStates() << isSelected;
      for (TListItem * Item = listTableTaskContacts->Selected; Item != NULL; Item = listTableTaskContacts->GetNextItem(Item, sdAll, selected))
        Item->SubItemImages[i-1] = row->SubItemImages[i-1];
    }
  }
}
//----------------------------------------------------------------------------
void __fastcall TformSpecialAddEventTaskContacts::listTableTaskContactsMouseMove(TObject *Sender, TShiftState Shift, int X, int Y)
{
  x_pos = X;
}
//----------------------------------------------------------------------------
void __fastcall TformSpecialAddEventTaskContacts::btnCheckAllClick(TObject *Sender)
{
  if (btnCheckAll->Caption == "Check All")
  {
    for (int i = 0; i < listTableTaskContacts->Items->Count; i++)
    {
      for (int j = 0; j < listTableTaskContacts->Items->Item[i]->SubItems->Count; j++)
      {
        listTableTaskContacts->Items->Item[i]->SubItemImages[j] = 1;
      }
    }
    btnCheckAll->Caption = "Uncheck All";
  }
  else
  {
    for (int i = 0; i < listTableTaskContacts->Items->Count; i++)
    {
      for (int j = 0; j < listTableTaskContacts->Items->Item[i]->SubItems->Count; j++)
      {
        listTableTaskContacts->Items->Item[i]->SubItemImages[j] = 0;
      }
    }
    btnCheckAll->Caption = "Check All";
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddEventTaskContacts::btnSaveClick(TObject *Sender)
{
  Processing(true);
  try
  {
    string sql, task_purpose_id;
    map<string, string> insert_map;
    dbTransaction->StartTransaction();

    // jhaley: I'll just get this manually rather than create an entire dummy lookup for the two id gets in this module.
    task_purpose_id = GetOneField(dbTransaction, "select id from task_purpose_types where UPPER(item) like 'EVENT CONTACT'");

    for (unsigned int j = 0; j < list_items.size(); j++)
    {
      for (unsigned int i = 0; i < list_columns.size(); i++)
      {
        if (listTableTaskContacts->Items->Item[j]->SubItemImages[i] == 1)
        {
          sql = "select * "
                "from tasks "
                "where user_id = '" + list_columns[i].id + "' and person_id = '" + list_items[j].id + "' "
                "and event_id = '" + current_event_state["id"] + "' and diab_contact_id = '" + lookupTables->IdOf("diab_contact_types", "Contact") + "'";

          if (!StringToInt(GetOneField(dbTransaction, sql)))
          {
            string current_employee = list_columns[i].id;
            //insert_map.clear();
            // start off with the "parent" (teaching/leading) task as our base for contact tasks, and override from there
            insert_map = employee_tasks[current_employee];
            insert_map["id"] = GetNextId (dbTransaction, "tasks");
            insert_map["current_id"] = lookupTables->IdOf("current_types", "Current");
            insert_map["last_update_stamp"] = RightNow();
            insert_map["last_updated_by"] = current_userid;
            insert_map["date_of_task"] = current_event_state["date_of_event"];
            insert_map["user_id"] = current_employee;
            insert_map["person_id"] = list_items[j].id;
            insert_map["event_id"] = current_event_state["id"];
            insert_map["group_id"] = GetOneField(dbTransaction, "select group_id from events where id = '" + current_event_state["id"] + "'");
            insert_map["diab_contact_id"] = lookupTables->IdOf("diab_contact_types", "Contact");
            insert_map["task_purpose_id"] = task_purpose_id; // jhaley
            insert_map["method_id"] = lookupTables->IdOf("method_types", "Visit");
            insert_map["classification_id"] = lookupTables->IdOf("classification_types", "Client");
            insert_map["participations_id"] = list_items[j].participations_id;
            ExecuteInsertStatement(dbTransaction, "tasks", insert_map);
          }
          else
          {
            sql = "select * "
                  "from tasks "
                  "where user_id = '" + list_columns[i].id + "' and person_id = '" + list_items[j].id + "' "
                  "and event_id = '" + current_event_state["id"] + "' and diab_contact_id = '" + lookupTables->IdOf("diab_contact_types", "Contact") + "' "
                  "and current_id < 3";

            if (StringToInt(GetOneField(dbTransaction,sql)))
            {
              sql = "update tasks set current_id = '" + lookupTables->IdOf("current_types", "Current") +
                    "' where user_id = '" + list_columns[i].id.c_str() + "' and person_id = '" + list_items[j].id.c_str() +
                    "' and event_id = '" + current_event_state["id"].c_str() +
                    "' and current_id < 3 and diab_contact_id = '" + lookupTables->IdOf("diab_contact_types", "Contact") + "'";
              ExecuteStatement(dbTransaction, sql);
            }
          }
        }
        else
        {
          sql = "select * "
                "from tasks "
                "where user_id = '" + list_columns[i].id + "' and person_id = '" + list_items[j].id + "' "
                "and event_id = '" + current_event_state["id"] + "'";

          if (StringToInt(GetOneField(dbTransaction, sql)))
          {
            sql = "update tasks set current_id = '" + lookupTables->IdOf("current_types", "Deleted") +
                  "' where user_id = '" + list_columns[i].id + "' and person_id = '" + list_items[j].id +
                  "' and event_id = '" + current_event_state["id"] +
                  "' and current_id >= 3 and diab_contact_id = '" + lookupTables->IdOf("diab_contact_types", "Contact") + "'";
            ExecuteStatement(dbTransaction, sql);
          }
        } // end else
      } // end for (i)
    } // end for (j)
    atlas->Notify("tasks.event_id", current_event_state["id"]);
    dbTransaction->Commit();
  }
  catch(...)
  {
    if(dbTransaction->Active)
      dbTransaction->Rollback();
    PSay("Error saving contacts", m_database_error, MB_OK);
  }
  Processing(false);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddEventTaskContacts::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddEventTaskContacts::FormClose(TObject *Sender, TCloseAction &Action)
{
  TformSpecialGeneric::FormClose(Sender, Action);

  // jhaley: moved the listview delete action to the destructor where it should execute more reliably.
  // I guess this isn't really needed any more but I'll keep it here just in case of future development.
}
//---------------------------------------------------------------------------

