//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialAddProcsDone.h"
#include "codeSearchCode.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialAddProcsDone *formSpecialAddProcsDone;
//---------------------------------------------------------------------------
__fastcall TformSpecialAddProcsDone::TformSpecialAddProcsDone(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  try
  {
    string sql;
    vector<map<string, string> > code_vec;
    sql = "select procs_done_types.item, procs_done_codes.code "
          "from procs_done_types "
          "left join procs_done_codes on procs_done_codes.procs_done_id = procs_done_types.id "
          "order by procs_done_types.item, procs_done_codes.code";
    if(! SqlToVecMap(dbDatabase, sql, code_vec))
      throw 1;
    TTreeNode *root_node;
    TTreeNode *child_node;
    string current_item = "";
    string previous_item = "0";
    for(vector<map<string, string> >::iterator itr = code_vec.begin(); itr != code_vec.end(); itr++)
    {
      current_item = (*itr)["item"];
      if(current_item != previous_item)
        root_node = treeCodes->Items->Add(NULL, PrettyString((*itr)["item"]).c_str());
      if((*itr)["code"] != "")
        child_node = treeCodes->Items->AddChild(root_node, (*itr)["code"].c_str());
      previous_item = current_item;
    }
  }
  catch(...)
  {
    btnSave->Enabled = false;
    PSay("Error loading list of codes", m_database_error, MB_OK);
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddProcsDone::btnCancelClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddProcsDone::btnAddCategoryClick(
      TObject *Sender)
{
  if(editCategory->Text != "")
  {
    bool already_added = false;
    string to_add = PrettyString(editCategory->Text.c_str());
    TTreeNode *current_node = treeCodes->Items->GetFirstNode();
    TTreeNode *next_node = NULL;
    if(current_node)
      next_node = current_node->getNextSibling();
    TTreeNode *new_node = NULL;
    if((! current_node) || (to_add < string(current_node->Text.c_str())))
    {
      new_node = treeCodes->Items->AddFirst(NULL, to_add.c_str());
      already_added = true;
      next_node = NULL;
    }
    while(next_node)
    {
      if((to_add == string(current_node->Text.c_str())) || (to_add == string(next_node->Text.c_str())))
      {
        PSay("This category already exists and cannot be added again", m_duplicate_data, MB_OK);
        already_added = true;
        next_node = NULL;
      }
      if((to_add > string(current_node->Text.c_str())) && (to_add < string(next_node->Text.c_str())))
      {
        new_node = treeCodes->Items->Insert(next_node, to_add.c_str());
        already_added = true;
        next_node = NULL;
      }
      if(next_node)
      {
        current_node = next_node;
        next_node = next_node->getNextSibling();
      }
    }
    if(! already_added)
      new_node = treeCodes->Items->Add(NULL, to_add.c_str());
    if(new_node)
    {
      new_node->Selected = true;
      editCategory->Text = "";
      editCode->SetFocus();
    }
  }
  else
  {
    PSay("Please enter the name of the category", m_missing_data, MB_OK);
    editCategory->SetFocus();
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddProcsDone::btnCodeSearchClick(
      TObject *Sender)
{
  vector<string> return_vector;
  string sql;
  FORM_TRY
    TformSearchCode * codeSearch = new TformSearchCode(NULL, &return_vector);
    codeSearch->cboCode->Text = "Cpt-4";
    codeSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
  {
    sql = "select code from codes where id = " + return_vector[0];
    editCode->Text = GetOneField(dbDatabase, sql).c_str();
    if(editCode->Text != "")
      btnAddCode->SetFocus();
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddProcsDone::btnAddCodeClick(TObject *Sender)
{
  if(! treeCodes->Selected->Parent)
  {
    TTreeNode *old_selected;
    if(editCode->Text != "")
    {
      bool already_added = false;
      string to_add = editCode->Text.c_str();
      TTreeNode *current_node = treeCodes->Selected->getFirstChild();
      TTreeNode *next_node = NULL;
      if(current_node)
        next_node = current_node->getNextSibling();
      TTreeNode *new_node = NULL;
      if((! current_node) || (to_add < string(current_node->Text.c_str())))
      {
        new_node = treeCodes->Items->AddChildFirst(treeCodes->Selected, to_add.c_str());
        already_added = true;
        next_node = NULL;
      }
      while(next_node)
      {
        if((to_add == string(current_node->Text.c_str())) || (to_add == string(next_node->Text.c_str())))
        {
          PSay("This category already exists and cannot be added again", m_duplicate_data, MB_OK);
          already_added = true;
          next_node = NULL;
        }
        if((to_add > string(current_node->Text.c_str())) && (to_add < string(next_node->Text.c_str())))
        {
          new_node = treeCodes->Items->Insert(next_node, to_add.c_str());
          already_added = true;
          next_node = NULL;
        }
        if(next_node)
        {
          current_node = next_node;
          next_node = next_node->getNextSibling();
        }
      }
      if(! already_added)
        new_node = treeCodes->Items->AddChild(treeCodes->Selected, to_add.c_str());
      if(new_node)
      {
        editCode->Text = "";
        editCode->SetFocus();
      }
    }
    else
    {
      PSay("Please enter a code to add", m_missing_data, MB_OK);
      editCode->SetFocus();
    }
  }
  else
    PSay("Please select the category this code should be added to", m_missing_data, MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddProcsDone::btnSaveClick(TObject *Sender)
{
  Processing(true);
  // save to database
  TIBTransaction *dbTransaction = new TIBTransaction(NULL);
  string sql;
  string id;
  map<string, string> type_insert_map;
  map<string, string> code_insert_map;
  code_insert_map["current_id"] = "4";
  code_insert_map["last_updated_by"] = current_userid;
  code_insert_map["last_update_stamp"] = RightNow();

  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbTransaction->StartTransaction();
    ExecuteStatement(dbTransaction, "delete from procs_done_codes");
    ExecuteStatement(dbTransaction, "delete from procs_done_types");

    TTreeNode *current_node = treeCodes->Items->GetFirstNode();
    TTreeNode *current_child;
    while(current_node)
    {
      id = GetNextId(dbTransaction, "procs_done_types");
      type_insert_map["id"] = id;
      type_insert_map["item"] = SafeSQLString(current_node->Text.c_str());
      type_insert_map["valid"] = "1";
      ExecuteInsertStatement(dbTransaction, "procs_done_types", type_insert_map);
      current_child = current_node->getFirstChild();
      while(current_child)
      {
        code_insert_map["id"] = GetNextId(dbTransaction, "procs_done_codes");
        code_insert_map["procs_done_id"] = id;
        code_insert_map["code"] = SafeSQLString(current_child->Text.c_str());
        ExecuteInsertStatement(dbTransaction, "procs_done_codes", code_insert_map);
        current_child = current_child->getNextSibling();
      }
      current_node = current_node->getNextSibling();
    }
    dbTransaction->Commit();
  }
  catch(...)
  {
    Processing(false);
    if(dbTransaction->Active)
      dbTransaction->Rollback();
    PSay("Error saving to database", m_database_error, MB_OK);
  }
  delete dbTransaction;
  Processing(false);  
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialAddProcsDone::btnRemoveClick(TObject *Sender)
{

  TTreeNode *to_delete = NULL;
  to_delete = treeCodes->Selected;
  if(to_delete)
    treeCodes->Items->Delete(to_delete);
}
//---------------------------------------------------------------------------

