//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialAddTable.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialAddTable *formSpecialAddTable;
//---------------------------------------------------------------------------
__fastcall TformSpecialAddTable::TformSpecialAddTable(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddTable::btnSaveClick(TObject *Sender)
{
  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  map<string,string> insert_map;
  string table_name = editNewTable->Text.c_str();
  bool can_close = false;

  if (lookupTables->IsInLookUpTable("possible_permissions", editNewTable->Text.c_str()))
  {
    PSay("That value already exists... you can't add it again\n", m_invalid_data, MB_OK);
  }
  else if (table_name.find(" ", 0) != string::npos)
  {
    PSay("Please don't enter spaces in names", m_invalid_data, MB_OK);
  }
  else
  {
    try
    {
      StdTransaction(dbTransaction, dbDatabase, false);
      insert_map["item"] = UppercaseString(table_name);
      insert_map["valid"] = "1";
      ExecuteInsertStatement(dbTransaction, "possible_permissions", insert_map);
      // lookupTables->RefreshAllBoxes("possible_permissions");
      atlas->Notify("possible_permissions", insert_map["item"]);
      can_close = true;
    }
    catch(EIBError &error)
    {
      string error_message = "InterBase error: ";
      error_message += error.Message.c_str();
      PSay(error_message, m_database_error, MB_OK);
    }
  }
  delete dbTransaction;  
  if (can_close)
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialAddTable::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

