//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialAddUser.h"
#include "codeSearchTaxEntity.h"
#include "codeSearchPerson.h"
#include "codeSpecialMakeUserViewable.h"
#include "codeSpecialSelectGroups.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialAddUser *formSpecialAddUser;
//---------------------------------------------------------------------------
__fastcall TformSpecialAddUser::TformSpecialAddUser(TComponent* Owner, map<string,string> p_parameters, vector<string> * p_return_vec)
        : TformSpecialGeneric(Owner)
{
  incoming_values = p_parameters;
  return_vec = p_return_vec;
  lookupTables->RegisterComboBox("groups", cboGroup);
  lookupTables->RegisterComboBox("user_position_types", cboPosition);
  lookupTables->RegisterComboBox("user_discipline_types", cboDiscipline);
  map<string, string> user_map;
  string sql;
  lblAppointments->Font->Color = link_color;
  lblExternalScheduler->Font->Color = link_color;
  dbTransaction = new TIBTransaction(NULL);
  StdTransaction(dbTransaction, dbDatabase, false);

  if ((incoming_values["id"] != "new") && (incoming_values["id"] != ""))
  {
    sql = "select users.id, users.username, users.pass, users.item, users.valid, users.can_log_in, users.title, "
          "users.contact, users.group_id, tax_entities.name, users.tax_entity_id, users.password_expired, "
          "users.person_id, users.i_level, users.employee_number, users.user_position_id, users.user_discipline_id, "
          "users.is_role "
          "from users, tax_entities where users.tax_entity_id = tax_entities.id and "
          "users.id = " + incoming_values["id"];
    SqlToMap(dbDatabase, sql, user_map);

    if (! user_map.empty())
    {
      lblAppointments->Enabled = true;
      lblExternalScheduler->Enabled = true;
      lblId->Caption = user_map["id"].c_str();
      editUserName->Text = user_map["username"].c_str();
      editPassword->Text = user_map["pass"].c_str();
      editFullName->Text = PrettyString(user_map["item"]).c_str();
      editTitle->Text = user_map["title"].c_str();
      editContact->Text = user_map["contact"].c_str();
      cboGroup->Text = lookupTables->ValueOf("groups", user_map["group_id"]).c_str();
      cboPosition->Text = lookupTables->ValueOf("user_position_types", user_map["user_position_id"]).c_str();
      cboDiscipline->Text = lookupTables->ValueOf("user_discipline_types", user_map["user_discipline_id"]).c_str();
      editEmployeeNum->Text = user_map["employee_number"].c_str();
      if(user_map["name"] != "")
        txtProvider->Caption = user_map["name"].c_str();
      if(StringToInt(user_map["i_level"]) > trackBar->Max)
        trackBar->Position = trackBar->Max;
      if(StringToInt(user_map["i_level"]) < trackBar->Min)
        trackBar->Position = trackBar->Min;        
      trackBar->Position = StringToInt(user_map["i_level"]);
      if(user_map["password_expired"] == "1")
        checkPassword->Checked = true;
      else
        checkPassword->Checked = false;
      if(user_map["valid"] == "1")
        checkValid->Checked = true;
      else
        checkValid->Checked = false; \
      if(user_map["can_log_in"] == "1") // jhaley 20110104: separate ability to login out of "is valid"
        checkCanLogIn->Checked = true;
      else
        checkCanLogIn->Checked = false;
      if(user_map["is_role"] == "1")
        checkRole->Checked = true;
      else
        checkRole->Checked = false;
      CreateLink(txtProvider, btnProviderSearch, this, user_map["tax_entity_id"], "tax_entities");
      CreateLink(txtPerson, btnPersonSearch, this, user_map["person_id"], "people");

      string sql = "select log_log.log_timestamp, log_log.computer_name, log_log.is_log_in, "
                   "4, log_log.id "
                   "from log_log where user_id = " + user_map["id"];
      log_filter.SetListViewHandle(listLog);
      log_filter.SetSecurity("log_log");
      log_filter.AddColumnSpec("Timestamp", "log_log", as_stamp, true, 140);
      log_filter.AddColumnSpec("Computer Name", "log_log", as_text, true, 120);
      log_filter.AddColumnSpec("Log In/Out", "log_log", as_text, true, 100, prettyLogString);
      log_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
      log_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
      log_filter.FetchPreferences("specialadduser.log_filter");
      log_filter.SetCompress(true);
      log_filter.SetSQLStatement(sql);
      log_filter.RefreshDataSet();
      log_request = atlas->RequestNotificationWhen("log_log.user_id", user_map["id"], rel_e, as_int, this,
                    RefreshHandler(&(TformSpecialAddUser::AtlasRefreshListView)));

      sql = "select usage_log.form_name, sum(usage_log.occurances), 4, 1 "
             "from usage_log "
             "where usage_log.event_name = 'form opened' and usage_log.user_id = " + user_map["id"] + " "
             "group by usage_log.form_name";
      usage_filter.SetListViewHandle (listUsage);
      usage_filter.SetSecurity("usage_log");
      usage_filter.AddColumnSpec("Form Name", "usage_log", as_text, true, 205, rawString);
      usage_filter.AddColumnSpec("Times Opened", "usage_log", as_int, true, 100);
      usage_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
      usage_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
      usage_filter.FetchPreferences("specialscreenstatistics.usage_filter");
      usage_filter.SetCompress(true);
      usage_filter.SetSQLStatement (sql);
      usage_filter.RefreshDataSet();
      usage_request = atlas->RequestNotificationWhen("usage_log.user_id", user_map["id"], rel_e, as_int, this,
                    RefreshHandler(&(TformSpecialAddUser::AtlasRefreshListView)));

    }
  } // end if existing record
  else
  {
    lblId->Caption = "new";
  }

}
//---------------------------------------------------------------------------
void TformSpecialAddUser::AtlasRefreshListView(int request_num, string matched_value)
{
  if(request_num == log_request)
    log_filter.RefreshDataSet();
  else if(request_num == usage_request)
    usage_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddUser::FormClose(TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("groups", cboGroup);
  lookupTables->UnregisterComboBox("user_position_types", cboPosition);
  lookupTables->UnregisterComboBox("user_discipline_types", cboDiscipline);
  if (dbTransaction->Active)
    dbTransaction->Rollback();
  delete dbTransaction;
  
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddUser::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddUser::btnSaveClick(TObject *Sender)
{
  // warn
  if (checkRole->Checked && checkValid->Checked)
  {
    if (IDNO == PSay("Roles should not generally be marked as valid.\nValid items appear in most lists.\nRoles should only appear in a few specially-designated lists.\nAre you sure you want to continue?", m_warning, MB_YESNO))
      return;
  }
  // warn - jhaley 20110104: not valid, but can log in??
  if (checkValid->Checked == false && checkCanLogIn->Checked == true)
  {
    if (IDNO == PSay("The user is marked invalid but is allowed to login; this is unusual.\nAre you sure you want to continue?", m_warning, MB_YESNO))
      return;
  }
  // prevent
  if (! lookupTables->IsInLookUpTable("groups", cboGroup->Text.c_str()))
  {
    PSay("That group does not exist", m_invalid_data, MB_OK);
    cboGroup->SetFocus();
  } else
  if (! lookupTables->IsInLookUpTable("user_position_types", cboPosition->Text.c_str()))
  {
    PSay("That position does not exist", m_invalid_data, MB_OK);
    cboPosition->SetFocus();
  }
  if (! lookupTables->IsInLookUpTable("user_discipline_types", cboDiscipline->Text.c_str()))
  {
    PSay("That discipline does not exist", m_invalid_data, MB_OK);
    cboDiscipline->SetFocus();
  }
  else if (editUserName->Text == "")
  {
    PSay("You must enter a user name", m_missing_data, MB_OK);
    editUserName->SetFocus();
  }
  else if (editPassword->Text == "")
  {
    PSay("You must enter a password", m_missing_data, MB_OK);
    editPassword->SetFocus();
  }
  else if (editFullName->Text == "")
  {
    PSay("You must enter a full name", m_missing_data, MB_OK);
    editFullName->SetFocus();
  }
  else
  {
   // do stuff
    if(!dbTransaction->Active)
      dbTransaction->StartTransaction();
    map<string, string> field_map;
    field_map["username"] = editUserName->Text.c_str();
    field_map["pass"] = editPassword->Text.c_str();
    field_map["item"] = editFullName->Text.c_str();
    field_map["title"] = editTitle->Text.c_str();
    field_map["contact"] = editContact->Text.c_str();
    field_map["group_id"] = lookupTables->IdOf("groups", cboGroup->Text.c_str());
    field_map["user_position_id"] = lookupTables->IdOf("user_position_types", cboPosition->Text.c_str());
    field_map["user_discipline_id"] = lookupTables->IdOf("user_discipline_types", cboDiscipline->Text.c_str());
    field_map["employee_number"] = editEmployeeNum->Text.c_str();
    if (checkValid->Checked)
     field_map["valid"] = "1";
    else
     field_map["valid"] = "0";
    if (checkCanLogIn->Checked) // jhaley 20110104
     field_map["can_log_in"] = "1";
    else
     field_map["can_log_in"] = "0";
    if (checkRole->Checked)
     field_map["is_role"] = "1";
    else
     field_map["is_role"] = "0";
    string tax_entity_id = GetValidLinkId(txtProvider);
    if (tax_entity_id == "")
      field_map["tax_entity_id"] = "0";
    else
      field_map["tax_entity_id"] = tax_entity_id;
    string person_id = GetValidLinkId(txtPerson);
    if (person_id == "")
      field_map["person_id"] = "0";
    else
      field_map["person_id"] = person_id;
    if(checkPassword->Checked)
      field_map["password_expired"] = "1";
    else
      field_map["password_expired"] = "0";
    field_map["i_level"] = IntToString(trackBar->Position);
    if (incoming_values["id"] != "new")
    {
      field_map["id"] = incoming_values["id"];
      map<string, int> leave_alone;
      for (map<string, string>::iterator itr=field_map.begin(); itr!=field_map.end(); itr++)
        leave_alone[itr->first] = sql_no_uppercasing;
      ExecuteUpdateStatement(dbTransaction, "users", field_map, leave_alone);
    }
    else
    {
      field_map["id"] = GetNextId(dbTransaction, "users");
      map<string, int> leave_alone;
      for (map<string, string>::iterator itr=field_map.begin(); itr!=field_map.end(); itr++)
        leave_alone[itr->first] = sql_no_uppercasing;
      ExecuteInsertStatement(dbTransaction, "users", field_map, leave_alone);
    }
    /*
    if(return_vec)
    {
      return_vec->push_back(field_map["id"]);
      return_vec->push_back(field_map["username"]);
    } */
    dbTransaction->Commit();
    lookupTables->ExpectRefresh("users");
    atlas->Notify("users.id", field_map["id"]);
    Close();
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddUser::btnProviderSearchClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> provider_return_vector;
  FORM_TRY
    TformSearchTaxEntity * providerSearch = new TformSearchTaxEntity(NULL,&provider_return_vector);
    providerSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! provider_return_vector.empty())
    CreateLink(txtProvider, btnProviderSearch, this, provider_return_vector[0], "tax_entities");
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddUser::btnPersonSearchClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> person_return_vector;
  FORM_TRY
        TformSearchPerson * personSearch = new TformSearchPerson(NULL,&person_return_vector);
        string full_name = editFullName->Text.c_str();
        int first_space = full_name.find_first_of(" ");
        personSearch->editFirstName->Text = full_name.substr(0, first_space).c_str();
        personSearch->editLastName->Text = full_name.substr(first_space + 1, full_name.length() - first_space).c_str();
        personSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! person_return_vector.empty())
    CreateLink(txtPerson, btnPersonSearch, this, person_return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddUser::lblAppointmentsClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialMakeUserViewable *make_viewable = new TformSpecialMakeUserViewable(NULL, lblId->Caption.c_str());
    make_viewable->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddUser::lblExternalSchedulerClick(TObject *Sender)
{
  set<string> initial_ids;
  set<string> return_set;
  string id;

  // get the user's current set of external appointment scheduler records
  string sql = string("select group_id from external_appt_schedulers where user_id = '") + lblId->Caption.c_str() + "' ";
  SqlToSet(dbDatabase, sql, initial_ids);

  // pass the current IDs into the selector form so that we don't need to figure out what's added or removed.
  if (!initial_ids.empty())
    return_set = initial_ids;

  bool result = false;
  
  TformSpecialSelectGroups *select_group_form = NULL;
  FORM_TRY
    select_group_form = new TformSpecialSelectGroups(NULL, NULL, &return_set, false, &result);
  FORM_CATCH
  select_group_form->ShowTaskModal(this);

  if (!result) // user cancelled?
    return;

  // need to do all operations below on the same transaction
  TIBTransaction *local_transaction = NULL;
  FORM_TRY
    local_transaction = new TIBTransaction(NULL);
  FORM_CATCH

  bool error = false;
  try
  {
    StdTransaction(local_transaction, dbDatabase);

    // Delete existing
    sql = string("delete from external_appt_schedulers where user_id = '") + lblId->Caption.c_str() + "' ";
    if (ExecuteStatement(local_transaction, sql))
    {
      // Create new
      for (set<string>::iterator i_grp = return_set.begin(); i_grp != return_set.end(); ++i_grp)
      {
        sql = string("insert into external_appt_schedulers (user_id, group_id) "
                     "values (") + lblId->Caption.c_str() + ", " + *i_grp + ")";
        if (!ExecuteStatement(local_transaction, sql))
        {
          PSay("Could not insert new external appointment schedulers", m_database_error, MB_OK);
          error = true;
          break;
        }
      }
    }
    else
    {
      PSay("Could not delete old external appointment schedulers", m_database_error, MB_OK);
      error = true;
    }
  }
  catch(...)
  {
    PSay("An exception occured while trying to create or delete external appointment schedulers", m_database_error, MB_OK);
    error = true;
  }

  if (local_transaction->Active)
  {
    if (error)
      local_transaction->Rollback();
    else
      local_transaction->Commit();
  }
  delete local_transaction;
}
//---------------------------------------------------------------------------

