//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialAddValues.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialAddValues *formSpecialAddValues;
//---------------------------------------------------------------------------
__fastcall TformSpecialAddValues::TformSpecialAddValues(TComponent* Owner, map<string, string> params, TComboBox *p_custom_box)
        : TformSpecialGeneric(Owner)
{
  parameters = params;
  custom_box = p_custom_box;
  atlas->RequestNotificationWhen(parameters["table_name"], "", rel_any, as_int, this,
         RefreshHandler(&(TformSpecialAddValues::AtlasRefresh)));
  RefreshCurrentList();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddValues::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddValues::btnAddClick(TObject *Sender)
{
  if (! lookupTables->IsInLookUpTable(parameters["table_name"], editNewValue->Text.c_str()))
  {
    if (parameters["unsafe_add"] == "true")
      lookupTables->UnsafeAddValue(parameters["table_name"], editNewValue->Text.c_str(), custom_box);
    else
      lookupTables->AddValue(parameters["table_name"], editNewValue->Text.c_str(), custom_box);

    atlas->Notify(parameters["table_name"], editNewValue->Text.c_str());

    if (parameters["unsafe_add"] == "true")
    {
      RefreshCurrentList();    
      editNewValue->Text = "";
      editNewValue->SetFocus();
    }
    else
      Close();
  }
  else
    PSay("That value already exists and can't be added again", m_warning, MB_OK);
}
//---------------------------------------------------------------------------
void TformSpecialAddValues::RefreshCurrentList()
{
  vector<string> items_vec = lookupTables->GetValueList(parameters["table_name"], custom_box);
  TListItem * row;
  listCurrentValues->Items->Clear();
  for(vector<string>::iterator itr = items_vec.begin(); itr != items_vec.end(); itr++)
  {
    row = listCurrentValues->Items->Add();
    row->Caption = itr->c_str();
  }
}
//---------------------------------------------------------------------------
void TformSpecialAddValues::AtlasRefresh(int request_num, string matched_value)
{
  RefreshCurrentList();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddValues::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  atlas->CancelRequestFrom((TForm *)this);
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAddValues::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  TformSpecialGeneric::FormShortCut(Msg, Handled);
  /*
  if(HIBYTE(GetAsyncKeyState(VK_CONTROL)))
  {
    Handled = true;
    if ((Msg.CharCode == 'a') || (Msg.CharCode == 'A'))
      btnAddClick(NULL);
    else
      Handled = false;
  }
  else
    Handled = false;
  */
}
//---------------------------------------------------------------------------

