//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialAppointmentToTaskAttacher.h"
#include "codeRecordAppointment.h"
//---------------------------------------------------------------------------
#include "codeSpecialSqlViewer.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialAppointmentToTaskAttacher *formSpecialAppointmentToTaskAttacher;
//---------------------------------------------------------------------------
__fastcall TformSpecialAppointmentToTaskAttacher::TformSpecialAppointmentToTaskAttacher(TComponent* Owner,
  string p_task_id, string p_person_id, TIBTransaction * p_transaction, vector<string> *p_return_id_vec, bool allow_auto_close) : TformSpecialGeneric(Owner)
{
  task_id = p_task_id;
  person_id = p_person_id;
  dbTransaction = p_transaction;
  return_id_vec = p_return_id_vec;

  if (person_id != "0")
  {
    sql = "select appointments.begin_date, appointments.appointment_time, "
          //"person_names.first_name || ' ' || person_names.last_name || ' ' || person_names.suffix, "
          "tax_entities.name, created_for_user.item, created_by_user.item, "
          "appt_reason_types.item, appt_location_types.item, "
          "appointments.description, visit_outcome_types.item, appointments.task_id, appointments.current_id, appointments.id "
          "from appointments "
          "left join people on appointments.person_id = people.id "
          "left join person_names on people.person_names_id = person_names.id "
          "left join tax_entities on appointments.tax_entity_id = tax_entities.id "
          "left join users created_for_user on appointments.created_for = created_for_user.id "
          "left join users created_by_user on appointments.created_by = created_by_user.id "
          "left join appt_reason_types on appointments.appt_reason_id = appt_reason_types.id "
          "left join appt_location_types on appointments.appt_location_id = appt_location_types.id "
          "left join visit_outcome_types on appointments.visit_outcome_id = visit_outcome_types.id "
           //" and appointments.visit_outcome_id not in (" + lookupTables->IdOf("visit_outcome_types", "As Scheduled") + ","
           //lookupTables->IdOf("visit_outcome_types", "As Scheduled") + ")"  // Paul == stupid
           " where appointments.person_id = '" + person_id + "' ";
    if (!(optionsPermissions["admin.all_appointments"]["enabled"] == "true"))
      sql+="and exists (select * from appointment_viewers where user_id = " + current_userid + " and appointment_id = appointments.id) ";
    sql += "and appointments.task_id in ('" + task_id + "', '0') "
           "order by appointments.begin_date desc, appointments.appointment_time, tax_entities.name ";
  }

  DebugSql(this, &sql, other_forms, 9, dbTransaction);

  Filter.SetListViewHandle(listAppointments);
  Filter.SetSecurity("appointments");
  Filter.SetTransaction(dbTransaction);
  Filter.AddColumnSpec("Date", "appointments", as_date, true, 100);
  Filter.AddColumnSpec("Time", "appointments", as_time, true, 75);
  Filter.AddColumnSpec("Tax Entity", "tax_entities", as_text, false, 130, rawString);
  Filter.AddColumnSpec("Created For", "appointments", as_text, false, 100);
  Filter.AddColumnSpec("Created By", "appointments", as_text, false, 100);
  Filter.AddColumnSpec("Reason", "appointments", as_text, false, 90);
  Filter.AddColumnSpec("Location", "appointments", as_text, false, 90);
  Filter.AddColumnSpec("Description", "appointments", as_text, true, 150, sentenceString);
  Filter.AddColumnSpec("Outcome", "appointments", as_text, false, 90);
  Filter.AddColumnSpec("Task Id", "internal_id", as_int, false, 80);
  Filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  Filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  Filter.FetchPreferences("searchappointment.filter");
  Filter.SetCheck(true);
  //Filter.SetCompress(true);
  Filter.SetAddEdit(this, NULL, EditRecord(&(TformSpecialAppointmentToTaskAttacher::EditAppointment)));
  Filter.SetCheck(this, CheckRecord(&(TformSpecialAppointmentToTaskAttacher::CheckAppointment)));
  Filter.SetSQLStatement (sql);
  Filter.ForceRefreshDataSet();
  if (allow_auto_close)
   timerClose->Enabled = true;
}
//---------------------------------------------------------------------------
void TformSpecialAppointmentToTaskAttacher::EditAppointment()
{
  map<string, string> temp_map;
  temp_map["id"] = Filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordAppointment *view_appointment = new TformRecordAppointment(NULL, temp_map);
    view_appointment->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
bool TformSpecialAppointmentToTaskAttacher::CheckAppointment(const map<string, string> &row)
{
 map<string, string>::const_iterator col = row.find("Task Id");
 if (col != row.end())
 {
  if (col->second == task_id)
   return true;
 }
 return false;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAppointmentToTaskAttacher::btnCloseClick(TObject *Sender)
{
   // ModalResult = mrCancel;
   Close();  // calling Close() will make sure the form closes when it's called form->Show() and
             // also conveniently close the form with ModalResult = mrCancel when called form->ShowModal()
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAppointmentToTaskAttacher::btnSaveClick(TObject *Sender)
{
  vector<string> all_id, checked_id, unchecked_id;
  all_id = Filter.GetAllID();         // all IDs
  checked_id = Filter.GetMultiID();   // checked IDs
  // build "unchecked IDs" vector now (from elements of all_id NOT in checked_id)
  for(vector<string>::iterator itr = all_id.begin(); itr != all_id.end(); itr++)
     if((find(checked_id.begin(), checked_id.end(), (*itr)) == checked_id.end()) && ((*itr) != ""))
        unchecked_id.push_back(*itr);

  string AllIDs, CheckedIDs, UncheckedIDs;
  AllIDs = VecToCommaString(all_id);
  CheckedIDs = VecToCommaString(checked_id);
  UncheckedIDs = VecToCommaString(unchecked_id);

  try
  {
    if(!dbTransaction->Active)
      dbTransaction->StartTransaction();
    string save_sql;
    if(!checked_id.empty())
    {
      save_sql = "update appointments set task_id = '" + task_id + "' where appointments.id in ('" + ReplaceStringWithString(CheckedIDs, ", ", "', '") + "')";
      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      ExecuteStatement(dbTransaction, save_sql);
    }
    if(!unchecked_id.empty())
    {
      save_sql = "update appointments set task_id = '0' where appointments.id in ('" + ReplaceStringWithString(UncheckedIDs, ", ", "', '") + "')"
                 " and task_id = '" + task_id + "'";
      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      ExecuteStatement(dbTransaction, save_sql);
    }
    atlas->Notify("appointments.task_id", task_id);
    // atlas->Notify("appointments.task_id", 0);
  }
  catch (...)
  {
    PSay("Unable to attach requested appointments.  One or more of the appointments may be currently unlocked for editing.", m_program_error, MB_OK);
    ModalResult = mrAbort;  // will cause BeforeSave() to return false, rolling back the transaction in record generic
    return;
  }

  // notify all potentially open appointment forms that changes have occurred
  if(return_id_vec)
     for(vector<string>::iterator itr = all_id.begin(); itr != all_id.end(); itr++)
        if((*itr) != "")
           return_id_vec->push_back((*itr));
           //atlas->Notify("appointments.id", (*itr));

  // transaction was passed to us and we don't know what state it -should- be in,
  // so the calling form is responsible for commit, delete, etc.
  ModalResult = mrOk;  // because this form is called ShowModal, this will close the form also
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAppointmentToTaskAttacher::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnSave->Click();
  else
    Handled = false;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAppointmentToTaskAttacher::timerCloseTimer(TObject *Sender)
{
 // I -so- did not want to have to do it this way. -Philip
 // I mean, really. I can't set Visible=false in the constructor to avoid flashing,
 // I can't set ModalResult = mrOk in the constructor nor FormShow,
 // I don't want to have to throw() in the constructor, though that -would- work (but require calling code to change) ...
 // This is just not good. But I can't think of anything else right now.
 // Oh, and it was confusing having this form pop up when there was nothing for the user to do but hit 'Save'.
 if (!Filter.GetDatasetSize())
  ModalResult = mrOk;
}
//---------------------------------------------------------------------------

