//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialAttachActivitiesToLogsheets.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialAttachActivitiesToLogsheets *formSpecialAttachActivitiesToLogsheets;
//---------------------------------------------------------------------------
__fastcall TformSpecialAttachActivitiesToLogsheets::TformSpecialAttachActivitiesToLogsheets(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  this->IconIndex = -1;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialAttachActivitiesToLogsheets::btnStartClick(
      TObject *Sender)
{
 Processing(true);
 string sql;
 vector<map<string, string> > activities_dates_vector;
 vector<map<string, string> > activity_logsheets_vector;
 dbTransaction = new TIBTransaction(NULL);
 StdTransaction(dbTransaction, dbDatabase);
 bool transaction_status = true;

 /* TODO -c FIX:  Holy shit, where to begin.  So here's the logic this follows now:
 
    - select ALL activities without an activity_logsheet attached
    - loop through them
      - for EACH one, run a select statement just to see if a logsheet already exists
        which we can attach the activity to (activity falls within logsheet date range)
        - if so, execute an UPDATE statement to attach JUST that activity
        - if not, create a new logsheet, THEN execute an update statement to attach it

    and here's the logic it SHOULD follow:
    - select all activity_logsheets that do NOT have a logsheet already in existance,
      to which we can attach the activity to (activity falls within logsheet date range)
    - we only need one logsheet per missing month--so we can either do this in the SQL,
      or strip the extras after fetching the data--I'd prefer the SQL route, with an
      EXTRACT and some GROUP BY action, I think
    - loop through these activities, creating a new logsheet for each one.  Notice how
      we're only creating missing logsheets once (per month), not once per month per
      activity for that month?  Yeaaaahhh.
    - now we're guaranteed to have every logsheet we need in order to attach all the
      activities that need attaching:
      - NOW we select a list of all activities where activity_logsheet_id = 0 ... AND
        update them, all in one fucking statement: (untested, off the top of my head)
        update activities set activity_logsheet_id = (select first 1 activity_logsheet_id from activity_logsheets
        where activities.date_of_activity between activity_logsheets.begin_date and activity_logsheets.end_date)
        where activity_logsheet_id = 0 or activity_logsheet_id is null; // note that NULL really shouldn't happen
        Might COALESCE (select ... , 0) where ... just to be safe (if for some reason there STILL isn't
        a logsheet to attach to, we'd rather activity_logsheet_id remain 0 rather than going to NULL

    this fixes:
    - number of SQL statements is two TOTAL, plus the insert statements to create new logsheets,
      rather than a guaranteed two PER ACTIVITY (one select and one update), plus the inserts
    - does not create new logsheets multiple times
 */

 sql = "select activities.id, activities.person_id, activities.date_of_activity "
       "from activities "
       //"left join people on activities.person_id = people.id "
       "where activity_logsheet_id = 0 " /* " and people.current_id > 0 " */ // what???
       "and date_of_activity is not null";
 if (SqlToVecMap(dbTransaction, sql, activities_dates_vector))
 {
  for (unsigned int i = 0; i < activities_dates_vector.size(); i++)
  {
   sql="select activity_logsheets.id, activity_logsheets.begin_date, activity_logsheets.end_date "
       "from activity_logsheets "
       "where activity_logsheets.person_id = '" + activities_dates_vector[i]["person_id"]  + "' and "
       "activity_logsheets.begin_date < '" + activities_dates_vector[i]["date_of_activity"] + "' and "
       "activity_logsheets.end_date > '" + activities_dates_vector[i]["date_of_activity"] + "'";
   if (SqlToVecMap(dbTransaction, sql, activity_logsheets_vector))
   {
    if (activity_logsheets_vector.size() > 0)
    {
      sql = "update activities set activity_logsheet_id = '" + activity_logsheets_vector[0]["id"] + "' "
            "where activities.person_id = '" + activities_dates_vector[i]["person_id"] + "' and "
            "activities.date_of_activity between '" + activity_logsheets_vector[0]["begin_date"] + "' and "
            "'" + activity_logsheets_vector[0]["end_date"] + "' and activity_logsheet_id = 0";

      ExecuteStatement(dbTransaction, sql);
    }
    else
    {
     if (checkAutoGenMissingLogsheets->Checked == true)
     {
      Pdate * end_of_month_date = new Pdate(activities_dates_vector[i]["date_of_activity"], mdy | yyyy);
      Pdate * beginning_of_month_date = new Pdate(activities_dates_vector[i]["date_of_activity"], mdy | yyyy);
      beginning_of_month_date->day = 1;
      end_of_month_date->month++;
      end_of_month_date->day = 1;
      end_of_month_date->mod(-1,in_days);
      //PSay("date of activity: " + activities_dates_vector[i]["date_of_activity"] + " -> " + beginning_of_month_date->OutDate(mdy | yyyy) + " - " + end_of_month_date->OutDate(mdy | yyyy), m_message, MB_OK);
      // TODO -c FIX: Bryan should have done this as an ExecuteInsertStatement with a call to GetNextID, etc.  Standardize.
      sql = "insert into activity_logsheets "
                   "(id, current_id, last_update_stamp, last_updated_by, "
                    "person_id, "
                    "begin_date, end_date, "
                    "date_turned_in) "
            "values (gen_id(activity_logsheets_gen,1), 4, '" + RightNow() + "', '" + current_userid + "', "
                    "'" + activities_dates_vector[i]["person_id"] + "', "
                    "'" + beginning_of_month_date->OutDate(mdy | yyyy) + "', '" + end_of_month_date->OutDate(mdy | yyyy) + "', "
                    "'" + end_of_month_date->OutDate(mdy | yyyy) + "')";


      if (ExecuteStatement(dbTransaction, sql))
      {
       sql="select activity_logsheets.id, activity_logsheets.begin_date, activity_logsheets.end_date "
           "from activity_logsheets "
           "where activity_logsheets.person_id = '" + activities_dates_vector[i]["person_id"]  + "' and "
           "activity_logsheets.begin_date <= '" + activities_dates_vector[i]["date_of_activity"] + "' and "
           "activity_logsheets.end_date >= '" + activities_dates_vector[i]["date_of_activity"] + "'";
       if (SqlToVecMap(dbTransaction, sql, activity_logsheets_vector))
       {
        if (activity_logsheets_vector.size() > 0)
        {
         sql = "update activities set activity_logsheet_id = '" + activity_logsheets_vector[0]["id"] + "' "
               "where activities.person_id = '" + activities_dates_vector[i]["person_id"] + "' and "
               "activities.date_of_activity between '" + activity_logsheets_vector[0]["begin_date"] + "' and "
               "'" + activity_logsheets_vector[0]["end_date"] + "' and "
               "activities.activity_logsheet_id = 0";
         if (!ExecuteStatement(dbTransaction, sql))
         {
          dbTransaction->Rollback();
          PSay("Database operation could not be completed.", m_database_error, MB_OK);
          transaction_status = false;
          break;
         }

         // done?

         // TODO -c HACK: let's clean up the stupidness that Bryan's code sometimes creates - logsheets with no activities on them
         sql = "delete from activity_logsheets where not exists (select * from activities where activity_logsheet_id = activity_logsheets.id)";
         ExecuteStatement(dbTransaction, sql);
        }
        else
        {
         PSay("SQL Statement returned no values!",m_message,MB_OK);
        }
       }
       else
       {
        dbTransaction->Rollback();
        PSay("Database operation could not be completed.", m_database_error, MB_OK);
        transaction_status = false;
        break;
       }
      }
      else
      {
       dbTransaction->Rollback();
       PSay("Database operation could not be completed.", m_database_error, MB_OK);
       transaction_status = false;
       break;
      }
     }
    }
   }
   else
   {
    dbTransaction->Rollback();
    PSay("Database operation could not be completed.", m_database_error, MB_OK);
    transaction_status = false;
    break;
   }
   activity_logsheets_vector.clear();
   this->Repaint();
  }
 }
 else
 {
  dbTransaction->Rollback();
  PSay("Database operation could not be completed.", m_database_error, MB_OK);
  transaction_status = false;
 }
 if (transaction_status == true)
 {
  dbTransaction->Commit();
  PSay("Operation completed successfully.", m_message, MB_OK);
 }
 else
 {
  dbTransaction->Rollback();
  PSay("Database operation could not be completed.", m_message, MB_OK);
 }
 Processing(false);
}
//---------------------------------------------------------------------------

