//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialBugs.h"
#include "codeRecordBug.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSpecialBugs *formSpecialBugs;
//---------------------------------------------------------------------------
__fastcall TformSpecialBugs::TformSpecialBugs(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  this->IconIndex = 26;
  // basesql gets all results; it can be further restricted by the drop-down menus
  basesql = "select bug_priority_types.item priority, "
            "       bug_status_types.item status, "
            "       bug_types.item bug_type, "
            "       e.item created_for_user, "
            "       groups.item created_for_group, "
            "       a.item reported_by, "
            "       bugs.reported_on reported_on, "
            "       b.item created_by, "
            "       bugs.created_on created_on, "
            "       c.item claimed_by, "
            "       bugs.claimed_on claimed_on, "
            "       d.item fixed_by, "
            "       bugs.fixed_on fixed_on, "
            "       bugs.due_on due_on, "
/*          "       bugs.symptoms symptoms, "
            "       bugs.probable_cause probable_cause, "
            "       bugs.probable_location probable_location, "
            "       bugs.probable_solution probable_solution, "
            "       bugs.actual_cause actual_cause, "
            "       bugs.actual_location actual_location, "
            "       bugs.actual_solution actual_solution, "
*/          "       bugs.current_id current_id, "
            "       bugs.id id "
            "from   bugs, users a, users b, users c, users d, users e, groups, bug_types, bug_priority_types, bug_status_types "
            "where  bugs.reported_by = a.id and "
            "       bugs.created_by = b.id and  "
            "       bugs.claimed_by = c.id and "
            "       bugs.fixed_by = d.id and "
            "       bugs.created_for_user = e.id and "
            "       bugs.created_for_group = groups.id and "
            "       bugs.bug_priority_id = bug_priority_types.id and "
            "       bugs.bug_type_id = bug_types.id and "
            "       bugs.status_id = bug_status_types.id and "
            "       bugs.id > 0 ";
  statussql = claimedsql = reportedsql = createdforsql = "";
  bugs_filter.SetListViewHandle(listBugs);
  bugs_filter.SetSecurity("");
  bugs_filter.AddColumnSpec("Priority", "", as_text, true, 85);
  bugs_filter.AddColumnSpec("Status", "", as_text, true, 70);
  bugs_filter.AddColumnSpec("Type", "", as_text, true, 150);
  bugs_filter.AddColumnSpec("For Employee", "", as_text, true, 150);
  bugs_filter.AddColumnSpec("For Department", "", as_text, true, 150);
  bugs_filter.AddColumnSpec("Reported By", "", as_text, true, 150);
  bugs_filter.AddColumnSpec("Reported On", "", as_date, false, 85);
  bugs_filter.AddColumnSpec("Created By", "", as_text, true, 150);
  bugs_filter.AddColumnSpec("Created On", "", as_date, false, 85);
  bugs_filter.AddColumnSpec("Claimed By", "", as_text, true, 150);
  bugs_filter.AddColumnSpec("Claimed On", "", as_date, false, 85);
  bugs_filter.AddColumnSpec("Fixed By", "", as_text, true, 150);
  bugs_filter.AddColumnSpec("Fixed On", "", as_date, false, 85);
  bugs_filter.AddColumnSpec("Due On", "", as_date, true, 85);
/*bugs_filter.AddColumnSpec("Description", "", as_text, true, 300, sentenceString);
  bugs_filter.AddColumnSpec("Probable Cause", "", as_text, false, 150, sentenceString);
  bugs_filter.AddColumnSpec("Probable Location", "", as_text, false, 150, sentenceString);
  bugs_filter.AddColumnSpec("Probable Solution", "", as_text, false, 150, sentenceString);
  bugs_filter.AddColumnSpec("Actual Cause", "", as_text, false, 150, sentenceString);
  bugs_filter.AddColumnSpec("Actual Location", "", as_text, false, 150, sentenceString);
  bugs_filter.AddColumnSpec("Actual Solution", "", as_text, false, 150, sentenceString);
*/bugs_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  bugs_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  bugs_filter.FetchPreferences("specialbugs.bugs_filter");
  bugs_filter.SetHeader(true);
  bugs_filter.SetIconStatus(true);
  bugs_filter.SetAddEdit(this, AddRecord(&(TformSpecialBugs::AddBug)), EditRecord(&(TformSpecialBugs::EditBug)));
  bugs_filter.SetInform(this, InformForm(&(TformSpecialBugs::DoFilterStuff)));
  bugs_request = atlas->RequestNotificationWhen("bugs.id", "", rel_any, as_int, this,
                       RefreshHandler(&(TformSpecialBugs::AtlasRefreshListView)));

  SqlToCommaString(dbDatabase, "select id from users where group_id = " + current_groupid, myDepartment);

  custom_status_start = popupViewStatus->Items->Count;  // the slot where the first "custom" entry goes
  vector<string> bug_statuses = lookupTables->GetValueList("bug_status_types");
  for (unsigned int i = 0; i < bug_statuses.size(); i++)
  {
     //PSay ("Adding" + bug_statuses[i], m_debug, MB_OK);
     TMenuItem *menuitem = new TMenuItem(popupViewStatus);
     menuitem->Name = ("menuStatus" + StripAll(bug_statuses[i], " ")).c_str();
     menuitem->Caption = bug_statuses[i].c_str();
     menuitem->RadioItem = false;
     menuitem->OnClick = menuClick;
     popupViewStatus->Items->Add(menuitem);
  }

  //PSay(optionsPreferences["menus"]["specialbugs.status"], m_debug, MB_OK);
  if (optionsPreferences["menus"]["specialbugs.status"] != "")
  {
     vector<string> statuschecked;
     SplitStringToVec(StripAll(optionsPreferences["menus"]["specialbugs.status"], " "), ",", statuschecked);
     for (unsigned int i=0; i<statuschecked.size(); i++)
      if (popupViewStatus->Items->Items[StringToInt(statuschecked[i])]->Caption != "-") // if I add a menu item and it loads preferences, it could end up checking the separator, which messes stuff up, so explicitly prevent that
        popupViewStatus->Items->Items[StringToInt(statuschecked[i])]->Checked = true;
  }
  if (optionsPreferences["menus"]["specialbugs.reportedby"] != "")
     popupViewReportedBy->Items->Items[StringToInt(optionsPreferences["menus"]["specialbugs.reportedby"])]->Checked = true;
  if (optionsPreferences["menus"]["specialbugs.createdfor"] != "")
     popupViewCreatedFor->Items->Items[StringToInt(optionsPreferences["menus"]["specialbugs.createdfor"])]->Checked = true;
  if (optionsPreferences["menus"]["specialbugs.claimed"] != "")
     popupViewClaimed->Items->Items[StringToInt(optionsPreferences["menus"]["specialbugs.claimed"])]->Checked = true;

  menuClick(NULL);
}
//---------------------------------------------------------------------------
void TformSpecialBugs::EditBug()
{
  map<string, string> temp_map;
  temp_map["id"] = bugs_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordBug * edit_bug = new TformRecordBug(NULL, temp_map);
    edit_bug->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformSpecialBugs::AddBug()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["created_by"] = current_userid;
  temp_map["created_on"] = DateToStr(Date()).c_str();
  FORM_TRY
    TformRecordBug * add_bug = new TformRecordBug(NULL, temp_map);
    add_bug->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformSpecialBugs::AtlasRefreshListView(int request_num, string matched_value)
{
  if(request_num == bugs_request)
    bugs_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
void TformSpecialBugs::DoFilterStuff()
{
  this->Caption = string("Bug Log - " + IntToString(bugs_filter.GetResultSize())).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialBugs::menuClick(TObject *Sender)
{
  statussql = claimedsql = reportedsql = createdforsql = "";
  if (Sender)
  {
     TMenuItem *menu_item = ((TMenuItem*)(Sender));
     if (menu_item->RadioItem == true)               // radio
        menu_item->Checked = true;
     else if (menu_item->Caption == "-")             // separator
        menu_item->Checked = false;
     else
        menu_item->Checked = !(menu_item->Checked);  // check

     // If we customize what's checked on the status menu, check "Custom"
     if (menu_item->Owner == popupViewStatus && menu_item->MenuIndex >= custom_status_start)
        popupViewStatus->Items->Items[custom_status_start-3]->Checked = true;
  }

// Status

  if (popupViewStatus->Items->Items[0]->Checked == true)          // Status all
    for (int i=custom_status_start; i<popupViewStatus->Items->Count; i++)
       popupViewStatus->Items->Items[i]->Checked = true;
  else if (popupViewStatus->Items->Items[1]->Checked == true)     // Status all incomplete
    for (int i=custom_status_start; i<popupViewStatus->Items->Count; i++)
       popupViewStatus->Items->Items[i]->Checked =
         (StripAll(popupViewStatus->Items->Items[i]->Caption.c_str(), "&") != "Complete");
  else if (popupViewStatus->Items->Items[2]->Checked == true)     // Status all pending
  {
    for (int i=custom_status_start; i<popupViewStatus->Items->Count; i++)
       popupViewStatus->Items->Items[i]->Checked =
         (!is_in(StripAll(popupViewStatus->Items->Items[i]->Caption.c_str(), "&"), "Complete", "Rejected", "Suspended", NULL));
    statussql = " and bugs.current_id+1>3 ";
  }
  else if (popupViewStatus->Items->Items[3]->Checked == true)     // Status custom
     ;  // do nothing, handled below
  else if (popupViewStatus->Items->Items[4]->Checked == true)     // Status none
    for (int i=custom_status_start; i<popupViewStatus->Items->Count; i++)
       popupViewStatus->Items->Items[i]->Checked = false;

  vector<string> checked_items;
  for (int i=custom_status_start; i<popupViewStatus->Items->Count; i++)
     if (popupViewStatus->Items->Items[i]->Checked == true)
        checked_items.push_back(lookupTables->IdOf("bug_status_types", StripAll(popupViewStatus->Items->Items[i]->Caption.c_str(), "&")));
  if (!checked_items.empty())
     statussql += " and bugs.status_id in (" + VecToCommaString(checked_items) + ") ";
  else
     statussql += " and bugs.status_id is null ";

// Reported By

  if (popupViewReportedBy->Items->Items[0]->Checked == true)     // Reported by all
    reportedsql += "";                                           // Items[1] is a separator
  else if (popupViewReportedBy->Items->Items[2]->Checked == true)// Reported by me
    reportedsql += " and bugs.reported_by = " + current_userid;
  else if (popupViewReportedBy->Items->Items[3]->Checked == true)// Reported by my department
    reportedsql += " and bugs.reported_by in (" + myDepartment + ")";

// Created For

  if (popupViewCreatedFor->Items->Items[0]->Checked == true)     // Created for all
    createdforsql += "";                                          // Items[1] is a separator
  else if (popupViewCreatedFor->Items->Items[2]->Checked == true)// Created for me
    createdforsql += " and bugs.created_for_user = " + current_userid;
  else if (popupViewCreatedFor->Items->Items[3]->Checked == true)// Created for my department
    createdforsql += " and (bugs.created_for_user in (" + myDepartment + ") or bugs.created_for_group = " + current_groupid + ")";

// Claimed By

  if (popupViewClaimed->Items->Items[0]->Checked == true)        // Claimed all
    claimedsql += "";                                            // Items[1] is a separator
  else if (popupViewClaimed->Items->Items[2]->Checked == true)   // Claimed mine
    claimedsql += " and bugs.claimed_by = " + current_userid;
  else if (popupViewClaimed->Items->Items[3]->Checked == true)   // Claimed not mine
    claimedsql += " and bugs.claimed_by != 0 and bugs.claimed_by != " + current_userid;
  else if (popupViewClaimed->Items->Items[4]->Checked == true)   // Claimed all claimed
    claimedsql += " and bugs.claimed_by != 0";
  else if (popupViewClaimed->Items->Items[5]->Checked == true)   // Claimed unclaimed
    claimedsql += " and bugs.claimed_by = 0";

  MakeButtonsGo();
  string sql = basesql + statussql + reportedsql + createdforsql + claimedsql;
  bugs_filter.SetSQLStatement(sql);
  bugs_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialBugs::btnCloseClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialBugs::FormClose(TObject *Sender, TCloseAction &Action)
{
  // find the ones that are checked
  int i, reportedbychecked, createdforchecked, claimedchecked;
  vector<string> statuschecked;
  for (i = 0; i < popupViewStatus->Items->Count; i++)
     if (popupViewStatus->Items->Items[i]->Checked == true)
        statuschecked.push_back(IntToString(i));
  for (i = 0; i < popupViewReportedBy->Items->Count; i++)
     if (popupViewReportedBy->Items->Items[i]->Checked == true)
        reportedbychecked = i;
  for (i = 0; i < popupViewCreatedFor->Items->Count; i++)
     if (popupViewCreatedFor->Items->Items[i]->Checked == true)
        createdforchecked = i;
  for (i = 0; i < popupViewClaimed->Items->Count; i++)
     if (popupViewClaimed->Items->Items[i]->Checked == true)
        claimedchecked = i;
  // stick it in the preferences map so it will come up that way next time
  optionsPreferences["menus"]["specialbugs.status"] = StripAll(VecToCommaString(statuschecked), " ");
  optionsPreferences["menus"]["specialbugs.reportedby"] = IntToString(reportedbychecked);
  optionsPreferences["menus"]["specialbugs.createdfor"] = IntToString(createdforchecked);
  optionsPreferences["menus"]["specialbugs.claimed"] = IntToString(claimedchecked);
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void TformSpecialBugs::MakeButtonsGo()
{
   int checked = 0;
   TPopupMenu *menu = popupViewStatus;
   for (int i=0; i < custom_status_start; i++)
      if (menu->Items->Items[i]->Checked == true) checked = i;
   btnViewStatus->Caption = (StripAll(menu->Items->Items[checked]->Caption.c_str(), "&") + " Status").c_str();

   checked = 0;
   menu = popupViewReportedBy;
   for (int i=0; i<menu->Items->Count; i++)
      if (menu->Items->Items[i]->Checked == true) checked = i;
   btnViewReportedBy->Caption = ("Reported by " + StripAll(menu->Items->Items[checked]->Caption.c_str(), "&")).c_str();

   checked = 0;
   menu = popupViewCreatedFor;
   for (int i=0; i<menu->Items->Count; i++)
      if (menu->Items->Items[i]->Checked == true) checked = i;
   btnViewCreatedFor->Caption = ("Created for " + StripAll(menu->Items->Items[checked]->Caption.c_str(), "&")).c_str();

   checked = 0;
   menu = popupViewClaimed;
   for (int i=0; i<menu->Items->Count; i++)
      if (menu->Items->Items[i]->Checked == true) checked = i;
   btnViewClaimed->Caption = (StripAll(menu->Items->Items[checked]->Caption.c_str(), "&") + " Claims").c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialBugs::btnClick(TObject *Sender)
{
   if (Sender)
   {
     ((TToolButton*)(Sender))->Down = true;
     ((TToolButton*)(Sender))->Down = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialBugs::btnDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   if (Sender)
   {
     ((TToolButton*)(Sender))->Down = true;
     ((TToolButton*)(Sender))->Down = false;
   }
}
//---------------------------------------------------------------------------



