//---------------------------------------------------------------------------

#ifndef codeSpecialCachedFilesH
#define codeSpecialCachedFilesH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <Db.hpp>
#include <IBDatabase.hpp>
//---------------------------------------------------------------------------
class TformSpecialCachedFiles : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TTreeView *treeFiles;
        TIBDatabase *dbUploadDatabase;
        TGroupBox *groupFileBox;
        TLabel *lblUploadedAt;
        TLabel *lblTimestamp;
        TLabel *lblUploadedBy;
        TLabel *lblUserName;
        TCheckBox *checkIsValid;
        TLabel *lblSha1Hash;
        TLabel *lblHashCode;
        TCheckBox *checkCachedLocal;
        TToolButton *btnClose;
        TToolButton *btnUploadNew;
        TToolButton *btnDownload;
        TToolButton *btnDropLocal;
        TLabel *lblComments;
        TRichEdit *editChanges;
        void __fastcall FormShow(TObject *Sender);
        void __fastcall treeFilesChange(TObject *Sender, TTreeNode *Node);
        void __fastcall btnCloseClick(TObject *Sender);
        void __fastcall btnUploadNewClick(TObject *Sender);
        void __fastcall btnDownloadClick(TObject *Sender);
        void __fastcall btnDropLocalClick(TObject *Sender);
private:	// User declarations
        struct sDBObject;
        struct sFileObject
        {
          sDBObject *database; // parent database
          int index;           // index into database's raw_files vector
          TTreeNode *node;     // corresponding tree node w/Data pointer set to this structure
        };
        struct sDBObject
        {
          string server_name;                     // "name" of database (the IP address actually)
          string server_file;                     // database file
          bool   is_global_db;                    // if true, this is the "main" database for Prometheus
          map<string, TTreeNode *> node_map;      // for ensuring uniqueness of path nodes
          TTreeNode *root_node;                   // root node for this database
          pvecmap raw_files;                      // raw file information from the database
          map<string, sFileObject> file_objects;  // file structures for the tree nodes (key is ID)
        };

        map<string, sDBObject> databases;

        void AddDatabases(TIBTransaction *dbTransaction);
        TTreeNode *CreateNodesForPath(string &path, sDBObject &dbObject);
        void AddFiles(sDBObject &dbObject);
        void BuildFileTree();
public:		// User declarations
        __fastcall TformSpecialCachedFiles(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TformSpecialCachedFiles *formSpecialCachedFiles;
//---------------------------------------------------------------------------
#endif
