//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialCallLog.h"
#include "codeSpecialNewInterofficeReferral.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialCallLog *formSpecialCallLog;
//---------------------------------------------------------------------------
__fastcall TformSpecialCallLog::TformSpecialCallLog(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  this->IconIndex = 23;
  lookupTables->RegisterComboBox("users", cboEmployee);
  lblReceptionist->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
  txtMissedCallReferral->Font->Color = link_color;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialCallLog::btnSaveClick(TObject *Sender)
{
  if (IsValidOnScreen())
  {
    map<string, string> field_map;
    TIBTransaction * dbTransaction = new TIBTransaction(NULL);

    StdTransaction(dbTransaction, dbDatabase, false);

    field_map["call_time"] = RightNow();
    field_map["caller_name"] = editCaller->Text.c_str();
    field_map["employee_id"] = lookupTables->IdOf("users", cboEmployee->Text.c_str());
    field_map["receptionist_id"] = current_userid;
    field_map["last_updated_by"] = current_userid;
    field_map["last_update_stamp"] = RightNow();
    field_map["note"] = editNotes->Text.c_str();
    field_map["current_id"] = "4";

    if (ExecuteInsertStatement(dbTransaction, "call_log", field_map))
    {
      cboEmployee->Text = "";
      editCaller->Text = "";
      editNotes->Text = "";
      editCaller->SetFocus();
    }
    else
      PSay("Error logging call", m_database_error, MB_OK);
  }
}
//---------------------------------------------------------------------------
bool TformSpecialCallLog::IsValidOnScreen()
{
  bool result = true;
  if (editCaller->Text == "")
  {
    PSay("Please enter a caller name", m_missing_data, MB_OK);
    editCaller->SetFocus();
    result = false;
  }
  else if (! lookupTables->IsInLookUpTable("users", cboEmployee->Text.c_str()) || cboEmployee->Text == "")
  {
    PSay("Please enter a valid employee name", m_invalid_data, MB_OK);
    cboEmployee->SetFocus();
    result = false;
  }
  return result;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialCallLog::cboEmployeeKeyPress(TObject *Sender, char &Key)
{
  if(Key == (char)VK_RETURN)
    btnSaveClick(Sender);
  else
    FindComboBoxItem(Sender, Key);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialCallLog::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialCallLog::FormClose(TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("users", cboEmployee);
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialCallLog::cboReceptionistKeyPress(TObject *Sender, char &Key)
{
  FindComboBoxItem(Sender, Key);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialCallLog::txtMissedCallReferralClick(TObject *Sender)
{
  if (IsValidOnScreen())
  {
    string person_id = GetOneField(dbDatabase, "select person_id from users where id = '" + lookupTables->IdOf("users", lblReceptionist->Caption.c_str()) + "'");
    FORM_TRY
      TformSpecialNewInterofficeReferral *new_referral = new TformSpecialNewInterofficeReferral(NULL, person_id);
      new_referral->Show();
      new_referral->cboFrom->Text = lblReceptionist->Caption;
      new_referral->cboTo->Text = cboEmployee->Text;
      new_referral->editNote->Text = editCaller->Text + " called at " + AnsiString(RightNow().c_str()) +  " regarding:  " + editNotes->Text;
      new_referral->cboReason->Text = "Missed Call";
    FORM_CATCH
  }
}
//---------------------------------------------------------------------------

