//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialCaregiverLimits.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialCaregiverLimits *formSpecialCaregiverLimits;
//---------------------------------------------------------------------------
__fastcall TformSpecialCaregiverLimits::TformSpecialCaregiverLimits(TComponent* Owner, map<string, string> p_parameters)
        : TformSpecialGeneric(Owner)
{
 Processing(true);
 if (IsInt(p_parameters["id"]))
  person_id = p_parameters["id"];

 CreateLink(staticPerson, NULL, this, person_id, "people", "");
 Pdate date_as_of;
 date_as_of.InDate(Date());
 selectPeriod->Position = date_as_of.year;

 cmbQuarter->Items->Add("January - March");
 cmbQuarter->Items->Add("April   - June");
 cmbQuarter->Items->Add("July    - September");
 cmbQuarter->Items->Add("October - December");
 cmbQuarter->ItemIndex = 0;

 quarterly_limit = 400.00;
 lblAllowed->Caption = FinancialToString(quarterly_limit).c_str();

 RefreshAmounts();

 Processing(false);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialCaregiverLimits::btnCloseClick(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialCaregiverLimits::editPeriodChange(
      TObject *Sender)
{
 RefreshAmounts();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialCaregiverLimits::cmbQuarterChange(
      TObject *Sender)
{
 RefreshAmounts();
}
//---------------------------------------------------------------------------
void TformSpecialCaregiverLimits::RefreshAmounts()
{
 Processing(true);
 int quarter = cmbQuarter->ItemIndex + 1;
 string begin_date;
 string end_date;
 string year = editPeriod->Text.c_str();
 switch ( quarter )
 {
  case 1 :
    begin_date = "1/1/" + year;
    end_date = "3/31/" + year;
    break;

  case 2 :
    begin_date = "4/1/" + year;
    end_date = "6/30/" + year;
    break;

  case 3 :
    begin_date = "7/1/" + year;
    end_date = "9/30/" + year;
    break;

  case 4 :
    begin_date = "10/1/" + year;
    end_date = "12/31/" + year;
    break;

  default :
    begin_date = "mm/dd/yyyy";
    end_date = "mm/dd/yyyy";
    PSay("Please select a quarter", m_missing_data, MB_OK);
    return;
 }
 string expense_account = lookupTables->IdOf("account_types", "Expense");
 string cash_account    = lookupTables->IdOf("account_types", "Cash");


 // TODO: come back and change sub-selects in where clause to use lookup table instead of hard coding 071 in where clause of sub-select

 // the following sql was modified from TformSpecialPersonLimits
 string sql_bill_exp =  "select sum(transactions.debit_amount - transactions.credit_amount) "
                        "from tasks cob_tasks "
                        "inner join tasks visit_tasks on visit_tasks.parent_task_id = cob_tasks.id "
                        "inner join bills on bills.task_id = visit_tasks.id "
                        "inner join transactions on transactions.bill_id = bills.id "
                        "inner join services_provided on cob_tasks.services_provided_id = services_provided.id "
                        "inner join accounts on transactions.account_id = accounts.id "
                        "where cob_tasks.person_id = " + person_id +
                        " and cob_tasks.services_provided_id != 0" // and cob_tasks.services_provided_id is not null"
                        " and visit_tasks.parent_task_id != 0" // and visit_tasks.parent_task_id is not null"
                        " and accounts.account_type_id = " + expense_account +
                        " and cob_tasks.date_of_task between '" + begin_date +
                        "' and '" + end_date + "'"
                        " and transactions.account_id in (select accounts.id from accounts inner join acc_level_one on accounts.acc_level_one_id = acc_level_one.id where accounts.account_type_id = " + lookupTables->IdOf("account_types", "Expense") + " and acc_level_one.short_item = \'071\') ";
 string bill_exp = GetOneField(dbDatabase, sql_bill_exp);
 string remaining = FinancialToString(quarterly_limit - StringToFinancial(bill_exp), false);

 lblPeriod->Caption =    (begin_date + " - " + end_date).c_str();
 lblPaid->Caption =      StringToAmount(bill_exp).c_str();
 lblRemaining->Caption = StringToAmount(remaining).c_str();

 Processing(false);
}
//---------------------------------------------------------------------------
