//---------------------------------------------------------------------------

#ifndef codeSpecialChatH
#define codeSpecialChatH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <ScktComp.hpp>
#include <Menus.hpp>
#include <ImgList.hpp>
#include <Dialogs.hpp>
//#include <OleCtrls.hpp>
//---------------------------------------------------------------------------
class message_class
{
  public:
    string timestamp;
    string message;
};

class tab_info_class
{
  public:
    TTabSheet *tab_sheet;
    TRichEdit *received_messages;
    TRichEdit *message_to_send;
    string short_name;
    vector<message_class> lines;
};

class TformSpecialChat : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *btnClose;
        TListView *listUsers;
        TPageControl *pageMessages;
        TToolButton *btnInvisible;
        TPopupMenu *popupClose;
        TMenuItem *menuCloseTab;
        TPopupMenu *popupOptions;
        TMenuItem *menuSaveConversation;
        TSaveDialog *dialogSave;
        TMenuItem *menuShowTimestamp;
        TMenuItem *N1;
        TMenuItem *N2;
        TMenuItem *menuCopySelected;
        TMenuItem *menuCopyAll;
        TPopupMenu *popupPaste;
        TMenuItem *menuPaste;
        TMenuItem *menuCopy;
        void __fastcall btnCloseClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall SendingEditKeyPress(TObject *Sender, char &Key);
        void __fastcall TabSheetShow(TObject *Sender);
        void __fastcall menuCloseTabClick(TObject *Sender);
        void __fastcall pageMessagesMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall FormActivate(TObject *Sender);
        void __fastcall menuShowTimestampClick(TObject *Sender);
        void __fastcall menuCopySelectedClick(TObject *Sender);
        void __fastcall menuCopyAllClick(TObject *Sender);
        void __fastcall menuPasteClick(TObject *Sender);
        void __fastcall menuCopyClick(TObject *Sender);
        void __fastcall listUsersDblClick(TObject *Sender);
        void __fastcall menuSaveConversationClick(TObject *Sender);
private:	// User declarations
        TTimer *flash_timer;
        int busy_icon;
        int normal_icon;
        int idle_icon;
        int new_message_icon;
        set<string> users_with_permissions;
        set<string> users_not_chatting;
        int not_chatting_request;
        map<string, map<string, string> > connection_info;
        map<string, map<string, string> > user_info;
        map<string, map<string, string> > previous_user_info;
        map<string, tab_info_class> tab_info;
        map<string, list<string> > chat_messages;
        int last_clicked_sheet_index;
        string this_user_name;
        bool first_property_set; 

        void AtlasRefresh(int request_num, string matched_value);
        void HandleIncomingMessages(string channel);
        void CreateUserIdMap();        
        void UpdateListView();
        bool UsersLoggedInChanged();
        void UpdateIcons();
        void AddNewTab(string user_id);
        void ShowChatMessages();
        void SendMessage(TRichEdit *sending_box);
        void ShowTimestamps(bool p_to_show);
        void ShowLoginTimestamps();
public:		// User declarations
        __fastcall TformSpecialChat(TComponent* Owner);
        void SetFlashTimer(TTimer *p_timer);

};
//---------------------------------------------------------------------------
extern PACKAGE TformSpecialChat *formSpecialChat;
//---------------------------------------------------------------------------
#endif
