//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialCheckSentNotification.h"
#include "codeRecordPurchaseReq.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialCheckSent *formSpecialCheckSent;
//---------------------------------------------------------------------------
__fastcall TformSpecialCheckSent::TformSpecialCheckSent(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
 PSay("This screen has been deprecated and replaced,\nplease report to a programmer how you came across this message!", m_warning, MB_OK);
 /*
 panelSelectArea->Color = title_bar_color;
 Start();
 ResetFirstPage();
 GotoFirstPage();
 */
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialCheckSent::buttonBackClick(TObject *Sender)
{
 // back button
 if (pageCheckSentNotification->ActivePageIndex == 1)
 {
  GotoFirstPage();
 }
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialCheckSent::buttonNextClick(TObject *Sender)
{
 // next button
 if (pageCheckSentNotification->ActivePageIndex == 0)
 {
  if (purchase_req_filter.GetMultiID().size() > 0)
  {
   // technically, should make sure all PR's were to same tax entity, or
   // force them through a previous screen. at this point... i don't care
   // anymore.
   purchase_reqs_grouped = purchase_req_filter.GetMultiID();

   in_purchase_request = "('";
   for (vector<string>::iterator i_pr = purchase_reqs_grouped.begin(); i_pr != purchase_reqs_grouped.end();
        i_pr ++)
   {
    if (i_pr != purchase_reqs_grouped.begin())
     in_purchase_request += ", '";
    in_purchase_request += *i_pr + "'";
   }
   in_purchase_request += ") ";

   string test_multi_tax_sql = "select distinct tax_entities.id from tax_entities "
                               "inner join bills on bills.actual_tax_id = tax_entities.id "
                               "where bills.purchase_req_id in " + in_purchase_request;

   list<string> tax_id_used;
   if (SqlToList(dbDatabase, test_multi_tax_sql, tax_id_used))
   {
    if (tax_id_used.size() == 1)
    {
     only_tax_id = *(tax_id_used.begin());
     if (editCheckNumber->Text != "" && IsInt(editCheckNumber->Text.c_str()))
     {
      ResetSecondPage();
      GotoSecondPage();
     }
     else
     {
      PSay("You must enter a valid, numeric check number.", m_invalid_data, MB_OK);
      editCheckNumber->SetFocus();
     }
    }
    else
    {
     PSay("Not all of the selected purchase requests were to be paid to the same tax entity.", m_invalid_data, MB_OK);
     listPR->SetFocus();
    }
    // end of technicality
   }
   else
   {
    PSay("Error checking for multiple tax entities on a single check.", m_database_error, MB_OK);
   }
  }
  else
  {
   PSay("You must select at least one purcase request.", m_missing_data, MB_OK);
   listPR->SetFocus();
  }
 }
 else
 if (pageCheckSentNotification->ActivePageIndex == 1)
 {
  // *done above* need to check that all these PR's go to the same provider/vendor -- it not, that's an error
  // *done below* need to then create a check for that provider/vendor, with the correct date on it, etc.
  // *done below* need to then update all the PR's to point to this check
  // then need to hunt down all the obligated amounts which should be, at this point,
  //  linked to the bill itself (thanks to a new algorithm i've decided on, which i'll now describe)
  //  [when the first bill is received for a particular COB, the originally obligated amounts are negated
  //   via a new set of obligations. new ones are thereafter created for the bill itself, to be negated by
  //   checks. in order to negate the COB obligated moneys, expense funds will be 'reimbursed'. bills will
  //   then create their own expense records, more exact than those of the freakin' COB's. this check then
  //   goes and negates the obligated amounts posted against bills included on these PR's in favor of cash
  //   transactions. thus, the circle is complete.]
  //  so we have obligated amounts in the form of transactions against the bill, of types obligated and
  //  expense. we now create cash transactions and reverse the obligated transactions. we leave the expense
  //  transactions alone, unless jennifer comes up with a bright idea concerning modified amounts on PR's,
  //  for which i would hate her to the end of time itself.
  //  (**) -- ashley worries that users won't know what they can and cannot edit. they need to be taught
  //          to use the wizards for this stuff, and -also- taught what other stuff they can use. i simply
  //          cannot trust them to keep this ledger balanced any other way. none.

  // *done*, make sure the new bill screens take care of the above algorithm.
  // *done*, was here. read above to know what the algorithm was that needed to be implemented.
  // *done*, check on screens like the prepare PR screen to make sure it's not grabbing transactions
  //         from places that don't matter anymore thanks to this algorithm. by the time a PR is being
  //         made, only transactions linked to bills matter, not ones linked only to tasks. those are
  //         used to create bills. in fact ... i think things make more sense this way.
  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  dbTransaction->DefaultDatabase = dbDatabase;
  dbTransaction->StartTransaction();
  try
  {
   dbTransaction->DefaultDatabase = dbDatabase;
   dbTransaction->Active = true;
   string check_id = GetNextId(dbTransaction, "checks");
   if (check_id == "")
   {
    PSay("Failed to retrieve new check id.", m_database_error, MB_OK);
    throw(1);
   }

   map<string, string> sql_insert_check;
   sql_insert_check["id"] = check_id;
   sql_insert_check["current_id"] = "4";
   sql_insert_check["last_update_stamp"] = RightNow();
   sql_insert_check["last_updated_by"] = current_userid;
   sql_insert_check["tax_entity_id"] = only_tax_id;
   sql_insert_check["check_number"] = editCheckNumber->Text.c_str();
   sql_insert_check["date_sent"] = Pdate(dateCheckSent->Date).OutDate(mdy | yyyy);

   if (!ExecuteInsertStatement(dbTransaction, "checks", sql_insert_check))
   {
    PSay("Failed to create check record.", m_database_error, MB_OK);
    throw(2);
   }

   string sql_update_purchase_req = "update purchase_reqs set check_id = '" + check_id + "' where id in " + in_purchase_request;

   if (!ExecuteStatement(dbTransaction, sql_update_purchase_req))
   {
    PSay("Failed to update the purchase requests included on this check.\nAnother user may be in the process of editing said purchase request.", m_warning, MB_OK);
    throw(3);
   }

   // 2003/03/31 -- (philip)
   //            .. there was a rather large mistake here.
   //            .. we -had- been considering the sum() of -expense- account transactions;
   //            .. however, the true rule is to consider the sum of the -payable- account transactions!
   //            .. therefore, code has been modified below to correct for this.
   //            .. and why was i grouping by acc_level_one_id, etc. ?
   string sql_select_obligated = "select accounts.id payable_account_id, "
                                 "bills.id ob_bill_id, "
                                 "sum(transactions.credit_amount - transactions.debit_amount) ob_amount "
                                 "from transactions inner join accounts on transactions.account_id = accounts.id "
                                 "inner join bills on transactions.bill_id = bills.id where bills.purchase_req_id in " + in_purchase_request +
                                 "and accounts.account_type_id = " + lookupTables->IdOf("account_types", "Payable") + " "
                                 "group by accounts.id, bills.id ";
   // PSay(sql_select_obligated, m_message, MB_OK);
   vector<map<string, string> > obligated_on_bills;
   SqlToVecMap(dbTransaction, sql_select_obligated, obligated_on_bills);

   for (vector<map<string, string> >::iterator i_obligated_amount = obligated_on_bills.begin();
        i_obligated_amount != obligated_on_bills.end(); i_obligated_amount++)
   {
    // for each, we both want to bring back down to zero, -and- want to also create a cash transaction
    /* TODO: here, we're considering totals ... it's kinda nasty, but the forms that allow entry of account
      (mostly transactions) data need to have handling for the map<account, amount> */

    // what do we do with negative amounts as the sum(CR-DB) of obligated amounts?
    // might as well ignore $0.00 amounts, if there are any ...
    // for everything else: debit the obligated accounts back
    //                      credit the cash account as well (both go down)

    // first, figure out the essentials.

    string payable_account_id = (*i_obligated_amount)["payable_account_id"];
    acc_info payable_account = InfoById (payable_account_id);
    acc_info cash_account    = EquivAccountInfo (cash_ref, payable_account_id);

    if (cash_account.IsClosed() || !cash_account.IsFound())
    {
     PSay("Could not identify the specific cash account to be used for this transaction.\nMight you perhaps have paid against an expense account for which there is no equivalent cash account?", m_missing_data, MB_OK);
     throw(5);
    }

    string cash_account_id = cash_account.id;

    string obligated_string_amount = (*i_obligated_amount)["ob_amount"];
    financial obligated_float_amount = StringToFinancial(obligated_string_amount);
    if (obligated_float_amount < 0.00)
    {
     PSay("A negative amount has been obligated for this bill. Effects may be odd. Continuing.", m_warning, MB_OK);
    }

    if (obligated_float_amount == 0.00)
    {
     // too lazy to put the following in an if statement and do the indentation.
     PSay("No moneys have been obligated for this bill. Why did we spend $0 for an item, and use a purchase request at all? \nNo new transactions will be added. Continuing.", m_warning, MB_OK);
     break;
    }

    map<string, string> transaction_core;
    transaction_core["transaction_number"] = labelTransactionNumber->Caption.c_str();
    transaction_core["effective_date"] = Pdate(dateCheckSent->Date).OutDate(mdy | yyyy); // TODO: EFFECTIVE_DATE
    transaction_core["current_id"] = "4";
    transaction_core["last_update_stamp"] = RightNow(); // TODO: this function should try to be accurate to the database's current_timestamp() function
    transaction_core["last_updated_by"] = current_userid;
    transaction_core["tax_entity_id"] = only_tax_id;
    transaction_core["note"] = "Payment of check #" + string(editCheckNumber->Text.c_str());
    transaction_core["task_id"] = "0"; // TODO: make sure we know that setting a task_id on a TX means obligated on COB, not a bill?
    transaction_core["bill_id"] = (*i_obligated_amount)["ob_bill_id"];

    map<string, string> reverse_obligated = transaction_core;
    reverse_obligated["id"] = GetNextId(dbTransaction, "transactions");
    reverse_obligated["account_id"] = payable_account_id;
    reverse_obligated["credit_amount"] = "0.00";
    reverse_obligated["debit_amount"] = FinancialToString(obligated_float_amount);

    map<string, string> forward_cash = transaction_core;
    forward_cash["id"] = GetNextId(dbTransaction, "transactions");
    forward_cash["account_id"] = cash_account_id;
    forward_cash["credit_amount"] = FinancialToString(obligated_float_amount);
    forward_cash["debit_amount"] = "0.00";

    if (!ExecuteInsertStatement(dbTransaction, "transactions", reverse_obligated))
    {
     PSay("Failed to insert a reverse_obligated transaction.", m_database_error, MB_OK);
     throw(6);
    }

    if (!ExecuteInsertStatement(dbTransaction, "transactions", forward_cash))
    {
     PSay("Failed to insert a forward_cash transaction.", m_database_error, MB_OK);
     throw(7);
    }
   }

   dbTransaction->Commit();
   ResetFirstPage();
   GotoFirstPage();
  }
  catch(...)
  {
   dbTransaction->Rollback();
  }
  delete dbTransaction;
 }
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialCheckSent::buttonCancelClick(TObject *Sender)
{
 // cancel button
 ResetFirstPage();
 GotoFirstPage();
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialCheckSent::buttonCloseClick(TObject *Sender)
{
 // close button
 Close();
}
//---------------------------------------------------------------------------
void TformSpecialCheckSent::Start()
{
 purchase_req_filter_request = 0;

 purchase_req_filter.SetListViewHandle(listPR);
 purchase_req_filter.SetSecurity("purchase_reqs");
 purchase_req_filter.AddColumnSpec("Number" , "purchase_reqs", as_text, true, 180);
 purchase_req_filter.AddColumnSpec("Sent",    "purchase_reqs", as_int, true, 80);
 purchase_req_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 purchase_req_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 purchase_req_filter.FetchPreferences("specialchecksentnotification.purchase_req_filter");
 purchase_req_filter.SetCheck(true);
 purchase_req_filter.SetSQLStatement("");
 purchase_req_filter.RefreshDataSet();
 purchase_req_filter.SetAddEdit(this, NULL, NULL);
 purchase_req_filter.SetAddEdit(this, NULL, EditRecord(&(TformSpecialCheckSent::EditPurchaseReq)));

 return;
}
//---------------------------------------------------------------------------
void TformSpecialCheckSent::Stop()
{
 atlas->CancelRequestFrom(this);
 return;
}
//---------------------------------------------------------------------------
void TformSpecialCheckSent::ResetFirstPage()
{
 string sql = "select purchase_reqs.purchase_req_number, purchase_reqs.date_sent, "
              "purchase_reqs.current_id, purchase_reqs.id from purchase_reqs "
              "where purchase_reqs.check_id = '0' and purchase_reqs.id > '0'";
 if (purchase_req_filter_request != 0)
  atlas->CancelRequest(purchase_req_filter_request);
 purchase_req_filter_request = atlas->RequestNotificationWhen ("purchase_reqs", "0", rel_any, as_int, this, RefreshHandler(&(TformSpecialCheckSent::AtlasScreen)));
 dateCheckSent->Date = Date();
 editCheckNumber->Text = "";
 purchase_req_filter.SetSQLStatement(sql);
 purchase_req_filter.RefreshDataSet();
 // purchase_req_filter.CheckAll();
 ResetSecondPage();
 return;
}
//---------------------------------------------------------------------------
void TformSpecialCheckSent::ResetSecondPage()
{
 labelTransactionNumber->Caption = GetOneField(dbDatabase, "select gen_id(transact_number_gen, 1) from uno").c_str();
 return;
}
//---------------------------------------------------------------------------
void TformSpecialCheckSent::GotoFirstPage()
{
 staticHeader->Caption = "1 of 2 - Select purchase requests to group together as one check";
 pageCheckSentNotification->ActivePageIndex = 0;
 buttonBack->Enabled = false;
 buttonNext->Enabled = true;
 buttonNext->Caption = "Next >>";
 return;
}
//---------------------------------------------------------------------------
void TformSpecialCheckSent::GotoSecondPage()
{
 staticHeader->Caption = "2 of 2 - Confirm grouping of purchase requests";
 pageCheckSentNotification->ActivePageIndex = 1;
 buttonBack->Enabled = true;
 buttonNext->Enabled = true;
 buttonNext->Caption = "Finish";
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialCheckSent::FormClose(TObject *Sender,
      TCloseAction &Action)
{
 Stop();
 TformSpecialGeneric::FormClose(Sender, Action);
 return;
}
//---------------------------------------------------------------------------
bool TformSpecialCheckSent::AtlasScreen (int req_num)
{
 if (req_num == purchase_req_filter_request)
  purchase_req_filter.RefreshDataSet();
 return true;
}
//---------------------------------------------------------------------------
void TformSpecialCheckSent::EditPurchaseReq()
{
 map<string, string> params;
 params["id"] = purchase_req_filter.GetSelectedRecordID();
 FORM_TRY
   TformRecordPurchaseReq * edit_pr = new TformRecordPurchaseReq(NULL, params);
   edit_pr->Show();
 FORM_CATCH
 return;
}
//---------------------------------------------------------------------------




