//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "codeSpecialDataMerge.h"
#include "codeSpecialDataMergePrompt.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialDataMerge *formSpecialDataMerge;
//---------------------------------------------------------------------------
__fastcall TformSpecialDataMerge::TformSpecialDataMerge(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
   this->IconIndex = 21;
   if (!RefreshTables()) Close();
//   btnGo->Enabled = false;
   lastSelectedTable = "";
   lastTable = "";
   progressMajor->Visible = false;
   progressMinor->Visible = false;

   listMerge1->Tag = int(&DataFilter1);
   listMerge2->Tag = int(&DataFilter2);
   DataFilter1.SetListViewHandle(listMerge1);
   DataFilter1.SetHeader(true);
   DataFilter1.SetIconStatus(true);
   DataFilter2.SetListViewHandle(listMerge2);
   DataFilter2.SetHeader(true);
   DataFilter2.SetIconStatus(true);

 floating_log_window = NULL;
 editLog = NULL;

 FORM_TRY
  floating_log_window = new TForm((TComponent*)NULL);
 FORM_CATCH
 FORM_TRY
  editLog = new TRichEdit(floating_log_window);
 FORM_CATCH
 floating_log_window->BorderStyle = bsSizeToolWin;
 floating_log_window->AutoSize = false;
 floating_log_window->Width = Screen->Width;
 floating_log_window->Height = 350;
 floating_log_window->Left = 0;
 floating_log_window->Top = Screen->Height - floating_log_window->Height;
 floating_log_window->Caption = "Debugging log";
 editLog->Parent = floating_log_window;
 editLog->HideSelection = false;
 editLog->ReadOnly = false;
 editLog->ScrollBars = ssVertical;
 editLog->Align = alClient;
 floating_log_window->Visible = true;
}
//---------------------------------------------------------------------------
bool TformSpecialDataMerge::RefreshTables()
{
   vector<string> table_vec;
   string table_sql;
   table_sql = "select rdb$relation_name from rdb$relations ";
//   if (!btnShowRDB->Down)
     table_sql+= "where rdb$relation_name not like 'RDB$%' ";
   table_sql += "order by rdb$relation_name";
   cboTable->OnChange = NULL;
   cboTable->Items->BeginUpdate();
   cboTable->Items->Clear();
   bool result = true;
   if (SqlToVec(dbDatabase, table_sql, table_vec))
   {
     for (unsigned int i=0; i<table_vec.size(); i++)
       cboTable->Items->Add(StripTrailing(table_vec[i], " ").c_str());
   }
   else
   {
     Log("Could not get list of tables from the database");
     result = false;
   }
   cboTable->Text = "";
   cboTable->Items->EndUpdate();
   cboTable->OnChange = cboTableChange;
   return result;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataMerge::cboTableKeyPress(TObject *Sender, char &Key)
{
  FindComboBoxItem(Sender, Key);
  cboTableChange(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataMerge::cboTableChange(TObject *Sender)
{
  if (cboTable->Items->IndexOf(cboTable->Text) != -1)
  {
    if (lastSelectedTable != string(cboTable->Text.c_str()))
    {
      vector<string> pk;
      if (GetTablePrimaryKey (dbDatabase, cboTable->Text.c_str(), pk))
        editPk->Text = pk[0].c_str();
      else
        editPk->Text = "";
      lastSelectedTable = string(cboTable->Text.c_str());
    }
  }
  else
    editPk->Text = "";
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataMerge::btnGoClick(TObject *Sender)
{
  //Log(IntToString(cboTable->Items->IndexOf(cboTable->Text)));
  if (cboTable->Items->IndexOf(cboTable->Text) != -1 && editPk->Text != "" && editPkValue1->Text != "" && editPkValue2->Text != "")
  {
    // So it turns out the reason all this new/delete stuff was necessary, according to philip, is that
    // a vector can move around in memory at random, if it decides it needs more room, etc.  So rather
    // than doing it this way, I -could- have done it with a list.  But done's done and it works, so
    // I'ma leave it.  But -next- time....  :-)
    for (vector<node_data_type*>::iterator i = link_data.begin(); i != link_data.end(); i++)
      delete *i;
    link_data.clear();
    treeMerge->Items->Clear();
    listMerge1->Items->Clear();
    listMerge2->Items->Clear();
    fks_to_merge.clear();

    link_data.push_back(new node_data_type(is_root, "", "", cboTable->Text.c_str(), editPk->Text.c_str(), "", editPkValue1->Text.c_str(), ""));
    Merge1Root = treeMerge->Items->Add(NULL, LowercaseString((cboTable->Text + "." + editPk->Text + " = " + editPkValue1->Text).c_str()).c_str());
    Merge1Root->ImageIndex = 5;
    Merge1Root->SelectedIndex = 5;
    Merge1Root->Data = (void *)(link_data[link_data.size()-1]);

    link_data.push_back(new node_data_type(is_root, "", "", cboTable->Text.c_str(), editPk->Text.c_str(), "", editPkValue2->Text.c_str(), ""));
    Merge2Root = treeMerge->Items->Add(NULL, LowercaseString((cboTable->Text + "." + editPk->Text + " = " + editPkValue2->Text).c_str()).c_str());
    Merge2Root->ImageIndex = 5;
    Merge2Root->SelectedIndex = 5;
    Merge2Root->Data = (void *)(link_data[link_data.size()-1]);

    PopulateLinks(cboTable->Text.c_str(), editPk->Text.c_str(), editPkValue1->Text.c_str(), link_data, Merge1Root);
    PopulateLinks(cboTable->Text.c_str(), editPk->Text.c_str(), editPkValue2->Text.c_str(), link_data, Merge2Root);
    //treeMerge->AlphaSort();
    lastTable = string(cboTable->Text.c_str());
  }
}
//---------------------------------------------------------------------------
void TformSpecialDataMerge::PopulateLinks(string rec_table, string rec_pk, string rec_pk_value, vector<node_data_type *>& links, TTreeNode* ParentNode)
{
   if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "DataMerge: Populating links for " + rec_table + "." + rec_pk + "(" + rec_pk_value + ")");
   if (rec_pk_value == "0")
     if(PSay("Searching for links to a PK of value 0 may take a while and cause your computer to seem unresponsive.\n\nAre you sure you want to continue?", m_confirmation, MB_YESNO) == IDNO)
       return;

   Processing(true);
   vector<string> rec_fields;
   TIBTransaction * dbTransaction = new TIBTransaction(NULL);
   TIBDataSet * dbDataSet = new TIBDataSet(NULL);
   try
   {
     // Set up transaction and data set (to get columns to feed to the filter object)
     if (StdTransaction(dbTransaction, dbDatabase))
     {
       if (!GetFieldsFromTable(dbTransaction, rec_table, rec_fields))
       {
         Log("Error getting table's fields");
         return;
       }

       progressMajor->Position = 0;
       progressMajor->Max = rec_fields.size();
       progressMajor->Visible = true;
       // loop through fields
       for (unsigned int i = 0; i < rec_fields.size(); i++)
       {
         // get the PK that this field in the record links to (if any)
         string from_rec_table;
         vector<string> from_rec_fields;
         // if the record field is an FK...
         if (GetPrimaryKey(dbTransaction, rec_table, rec_fields[i], from_rec_table, from_rec_fields))
         {
           // get the value of the key
           string rec_fk_value = GetOneField(dbTransaction, "select " + rec_fields[i] + " from " + rec_table + " where " + rec_pk + " = " + rec_pk_value);
           if (rec_fk_value != "")
           {
             links.push_back(new node_data_type(from_parent, rec_table, rec_fields[i], from_rec_table, from_rec_fields[0], rec_pk, rec_fk_value, rec_pk_value));
             string SubNodeText = LowercaseString(from_rec_table) + " linked from " + LowercaseString(rec_table) + "." + LowercaseString(rec_fields[i]);
             TTreeNode* SubNode = treeMerge->Items->AddChild(ParentNode, SubNodeText.c_str());
             SubNode->ImageIndex = 1;
             SubNode->SelectedIndex = 1;
             string SubSubNodeText = LowercaseString(from_rec_table) + "." + LowercaseString(rec_fields[0]) + " = " + rec_fk_value;
             TTreeNode* SubSubNode = treeMerge->Items->AddChild(SubNode, SubSubNodeText.c_str());
             SubSubNode->ImageIndex = 3;
             SubSubNode->SelectedIndex = 3;
             SubSubNode->Data = (void *)(links[links.size()-1]);
           }
         }

         // get FKs to this field in the record (if any)
         vector<map<string, string> > to_rec_fields_vecmap;
         if (GetForeignKeys (dbTransaction, rec_table, rec_fields[i], to_rec_fields_vecmap))
         {
           progressMinor->Position = 0;
           progressMinor->Max = to_rec_fields_vecmap.size();
           progressMinor->Visible = true;
           Application->ProcessMessages();
           // I'ma stick it in a multimap cause I think that'll be handier (in alph order so same table together; can do ctrl-break processing to add branches).
           multimap<string, string> to_rec_fields_map;
           for (unsigned int j = 0; j != to_rec_fields_vecmap.size(); j++)
             to_rec_fields_map.insert(pair<string, string>(to_rec_fields_vecmap[j]["fk_table"], to_rec_fields_vecmap[j]["fk_field"]));
           //to_rec_fields_map
           // k, now loop through the multimap, keeping track of last/current fk_table... when table changes, new branch... otherwise, run the SQL to get all
           // related records of that type and add them under that table.  Yep.
           string last_fk_table = "";
           TTreeNode* SubNode = NULL;
           for (multimap<string, string>::iterator itr = to_rec_fields_map.begin(); itr!= to_rec_fields_map.end(); itr++)
           {
             if (itr->first != last_fk_table)
             {
               // first, if the last subnode created has no children, we don't need it in the tree:
               if (SubNode)
                 if (SubNode->Count == 0)
                   SubNode->Delete();
                 else
                   SubNode->Text = SubNode->Text + (" " + IntToString(SubNode->Count) + " times by:").c_str();
               // create new node for the new fk_table
               string SubNodeText = LowercaseString(itr->first) + " links to " + LowercaseString(rec_table) + "." + LowercaseString(rec_fields[i]) + "(" + rec_pk_value + ")";
               SubNode = treeMerge->Items->AddChild(ParentNode, SubNodeText.c_str());
               SubNode->ImageIndex = 2;
               SubNode->SelectedIndex = 2;
             }
             vector<string> to_rec_table_pk;
             /*if (*/GetTablePrimaryKey (dbDatabase, itr->first.c_str(), to_rec_table_pk)/*)*/;
             {
               string use_pk = (!to_rec_table_pk.empty()) ? to_rec_table_pk[0] : string("*");
               string show_pk = (!to_rec_table_pk.empty()) ? to_rec_table_pk[0] : string("???");
               string sql = "select " + use_pk + " from " + itr->first + " where " + itr->second + " = " + rec_pk_value;
               vector<string> to_rec_fk_values;
               if (SqlToVec(dbDatabase, sql, to_rec_fk_values))

               {
                 progressMinor->Max += to_rec_fk_values.size();
                 // we've got some matching fk's to add to the tree
                 for (unsigned int k=0; k<to_rec_fk_values.size(); k++)
                 {
                   links.push_back(new node_data_type(to_parent, itr->first, itr->second, rec_table, rec_fields[i], use_pk, rec_pk_value, to_rec_fk_values[k]));
                   string SubSubNodeText = LowercaseString(itr->first) + "." + LowercaseString(itr->second) + " (" +
                      LowercaseString(itr->first) + "." + LowercaseString(show_pk) + " = " + to_rec_fk_values[k] + ")";
                   TTreeNode* SubSubNode = treeMerge->Items->AddChild(SubNode, SubSubNodeText.c_str());
                   // While we -could- just do GetForeignKeys below, when we do the actual merge, we've already done that in this function -and- looked at each of those FKs
                   // to see which are actually being used.  It would be nice if we could store that in some useful way for later so we don't have to do it again.  This is
                   // a bit hack-ish; the set is global and not passed and ... yeah.  But it works, so I'll leave it for now.
                   //fks_to_merge.insert()
                   // end hack-ish-ness
                   SubSubNode->ImageIndex = 4;
                   SubSubNode->SelectedIndex = 4;
                   SubSubNode->Data = (void *)(links[links.size()-1]);
                   progressMinor->Position++;
                 } // for k
               }
               else
                 Log("Error getting PK '" + show_pk + "' from " + itr->first + "table '" + itr->first + "'.");

               last_fk_table = itr->first;
             }
             //else
             //  Log("Unable to determine PK in table " + itr->first + ".");
             progressMinor->Position++;
           } // for each FK in map
           progressMinor->Visible = false;
           // in case the very last subnode had no children (matching FK records)
           if (SubNode)
             if (SubNode->Count == 0)
               SubNode->Delete();
             else
               SubNode->Text = SubNode->Text + (" " + IntToString(SubNode->Count) + " times by:").c_str();
         } // GetForeignKeys
         progressMajor->Position++;
         Application->ProcessMessages();
       } // for i
     }
     else
     {
       PSay("Error setting up transaction", m_database_error, MB_OK);
       if (dbTransaction->Active)
         dbTransaction->Rollback();
     }
   }
   catch (...)
   {
      PSay("Error executing query", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
   }
   delete dbTransaction;
   delete dbDataSet;
   if (ParentNode)
     ParentNode->Expand(false);
   progressMajor->Visible = false;
   Processing(false);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataMerge::menuTreeExpandClick(TObject *Sender)
{
  if (treeMerge->Selected)
  {
    if (treeMerge->Selected->Data && treeMerge->Selected->Count == 0) // has data, not already populated
    {
      //if(PSay("About to convert ->Data to node_data*.  Continue?", m_confirmation, MB_YESNO) == IDNO) return;
      node_data_type *node_data = (node_data_type *)treeMerge->Selected->Data;
      switch (node_data->link_direction)
      {
        case to_parent:
          //if(PSay("Getting links for " + node_data->fk_table + "." + node_data->fk_table_pk_field + " == " + node_data->fk_table_pk_field_value+".  Continue?", m_message, MB_YESNO) == IDNO) return;
          PopulateLinks(node_data->fk_table, node_data->fk_table_pk_field, node_data->fk_table_pk_field_value, link_data, treeMerge->Selected);
          break;
        case from_parent:
          //if(PSay("Getting links for " + node_data->pk_table + "." + node_data->pk_field + " == " + node_data->pk_field_value+".  Continue?", m_message, MB_YESNO) == IDNO) return;
          PopulateLinks(node_data->pk_table, node_data->pk_field, node_data->pk_field_value, link_data, treeMerge->Selected);
          break;
      }
    }
    else
      PSay("You must select a valid node.", m_message, MB_OK);
  }
  else
    PSay("You must select a valid node.", m_message, MB_OK);
} 
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataMerge::treeMergeChange(TObject *Sender, TTreeNode *Node)
{
  classFilterObject *Filter;
  if (Node == Merge1Root || Node->HasAsParent(Merge1Root))
    Filter = &DataFilter1;
  else
    Filter = &DataFilter2;
  vector<node_data_type *> nodes_data;
  if (Node)
  {
    //node_data_type *node_data;
    Processing(true);
    if (Node->Data)
    {
      nodes_data.push_back((node_data_type *)Node->Data);
    }
    TTreeNode *ChildNode = Node->getFirstChild();
    while (ChildNode)
    {
      if (ChildNode->Data)
      {
        nodes_data.push_back((node_data_type *)ChildNode->Data);
      }
      ChildNode = Node->GetNextChild(ChildNode);
    }
    // process vector, adding to listview and string grid
    vector<string> pk_values;
    map<string, string> fk;
    vector<string> fks;
    for (unsigned int i = 0; i != nodes_data.size(); i++)
    {
      if (nodes_data[i]->link_direction == to_parent)
      {
        pk_values.push_back(nodes_data[i]->fk_table_pk_field_value);
        fk[nodes_data[i]->fk_field] = nodes_data[i]->pk_field_value;
      }
      else
        pk_values.push_back(nodes_data[i]->pk_field_value);
    }
    for (map<string,string>::iterator itr=fk.begin(); itr!=fk.end(); itr++)
      fks.push_back(itr->first + " = '" + itr->second + "'");
    if (!nodes_data.empty())
    {
      string sql = (nodes_data[0]->link_direction == to_parent) ?
        //"select * from " + nodes_data[0]->fk_table + " where " + SafeInClause(nodes_data[0]->fk_table_pk_field, pk_values) :
        /* Why didn't I just use the FK, rather than a whole mess of foreign PKs?  Like this: */
        "select * from " + nodes_data[0]->fk_table + " where " + VecToDelimString(fks, "", "", " or ") :
        "select * from " + nodes_data[0]->pk_table + " where " + SafeInClause(nodes_data[0]->pk_field, pk_values) ;
      TDateTime start_time = Now();
      Filter->SetAutoColumnSpecs(true, btnDataFormatByType->Down);
      Filter->SetSQLStatement(sql);
      Filter->RefreshDataSet();
      Filter->SetHint(" " + IntToString(Filter->GetResultSize()) + " results found (in " +
        Ptime (Now() - start_time).OutTime(military | withsec) + ")"); 
    }
  }
  Processing(false);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataMerge::FormClose(TObject *Sender, TCloseAction &Action)
{
  // So it turns out the reason all this new/delete stuff was necessary, according to philip, is that
  // a vector can move around in memory at random, if it decides it needs more room, etc.  So rather
  // than doing it this way, I -could- have done it with a list.  But done's done and it works, so
  // I'ma leave it.  But -next- time....  :-)
  if (floating_log_window) delete floating_log_window;
  for (vector<node_data_type*>::iterator i = link_data.begin(); i != link_data.end(); i++)
    delete *i;
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataMerge::btnMergeClick(TObject *Sender)
{
 if (floating_log_window && editLog)
 {
  editLog->Lines->Clear();
  floating_log_window->BringToFront();
 }
 last_message_stamp = CurrentPstamp();

  vector<map<string, string> > test_vecmap;
  string merge_from_record_exists_sql = "select * from " + string(cboTable->Text.c_str()) +
    " where " + string(editPk->Text.c_str()) + " = " + string(editPkValue1->Text.c_str());
  Log(merge_from_record_exists_sql);
  SqlToVecMap(dbDatabase, merge_from_record_exists_sql, test_vecmap);
  if (test_vecmap.empty())
  {
    Log("ERROR: Merge-from record does not exist!");
    return;
  }
  test_vecmap.clear();
  string merge_to_record_exists_sql = "select * from " + string(cboTable->Text.c_str()) +
    " where " + string(editPk->Text.c_str()) + " = " + string(editPkValue2->Text.c_str());
  Log(merge_to_record_exists_sql);
  SqlToVecMap(dbDatabase, merge_to_record_exists_sql, test_vecmap);
  if (test_vecmap.empty())
  {
    Log("ERROR: Merge-into record does not exist!");
    return;
  }
  test_vecmap.clear();

  TIBTransaction * merge_transaction = new TIBTransaction(NULL);
  StdTransaction (merge_transaction, dbDatabase);
  /* DONE: AND, after I'm done moving those over I get the fun-fun task of doing the rest of the merge... comparing all the
   fields in the two records and asking the user which one they want to keep if they're different.  Yaaaay. */
  FORM_TRY
    TformSpecialDataMergePrompt * prompt = new TformSpecialDataMergePrompt(NULL, cboTable->Text.c_str(), editPk->Text.c_str(), editPkValue1->Text.c_str(), editPkValue2->Text.c_str(), merge_transaction);
    // They get one chance to cancel.  After that, we do this thing.
    if (prompt->ShowTaskModal(this) == mrOk)
    {
      // The Prompt form has already moved over the values the user indicated they wish to keep from the "from" record to the
      // "to" record, so now we update foreign keys that point to the record we'll be deleting, to point to the one we're keeping:
      TTreeNode *Node = Merge1Root;
      set<string> sql_to_run;
      // Loop through the nodes and build a set of SQL statements that need to be run
      while (Node && Node != Merge2Root)
      {
        if (Node->Data)
        {
          //Log("Lev: " + IntToString(Node->Level));
          if(Node->Level == 2) // we just care about the first level of expansion, even if there've been more
          {
            node_data_type *node_data = (node_data_type *)Node->Data;
            if (node_data->link_direction == to_parent)
            {
              string sql = "update " + node_data->fk_table + " set " + node_data->fk_field + " = " + editPkValue2->Text.c_str() + " where " + node_data->fk_field + " = " + editPkValue1->Text.c_str(); //node_data->pk_field_value;
              if(sql_to_run.find(sql) == sql_to_run.end())
              {
                sql_to_run.insert(sql);
              }
            }
          }
        }
        Node = Node->GetNext();
      }
      // and now run them
      for (set<string>::iterator itr = sql_to_run.begin(); itr != sql_to_run.end(); itr++)
      {
        try
        {
          Log(*itr);
          if(!ExecuteStatement(merge_transaction, *itr))
            throw(last_sql_lib_error.message);
        }
        catch (string error)
        {
          if(merge_transaction->Active)
            merge_transaction->Rollback();
          Log("ERROR: Update of foreign keys failed.  Aborting.  Last SqlLib error:\n" + error);
          return;
        }
        catch (...)
        {
          if(merge_transaction->Active)
            merge_transaction->Rollback();
          Log("ERROR: Update of foreign keys failed.  Aborting.");
          return;
        }
      }

    }
    else
    {
      // they cancelled the Prompt dialog.  We'll inform them the merge was not performed.
      Log("You have aborted the merge or the merge has failed.  The merge was not performed.");
      return;
    }
  FORM_CATCH

  try
  {
    string sql = "delete from " + string(cboTable->Text.c_str()) + " where " + string(editPk->Text.c_str()) + " = '" + string(editPkValue1->Text.c_str()) + "'";
    Log(sql);
    if(!ExecuteStatement(merge_transaction, sql))
      throw(last_sql_lib_error.message);
  }
  catch (string error)
  {
    if(merge_transaction->Active)
      merge_transaction->Rollback();
    Log("ERROR: Deletion of old record failed.  Aborting.  Last SqlLib error:\n" + error);
    return;
  }
  catch (...)
  {
    if(merge_transaction->Active)
      merge_transaction->Rollback();
    Log("ERROR: Deletion of old record failed.  Aborting.");
    return;
  }

  if(merge_transaction->Active)
    merge_transaction->Commit();
  Log("SUCCESS: Record successfully merged.");
  return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataMerge::pbCautionPaint(TObject *Sender)
{
  TPaintBox* pb = (TPaintBox*)(Sender); 
  TColor pen_color;
  int h = pb->ClientHeight;
  for (int x = -(h/2); x < pb->ClientRect.right; x++)
  {
    int ofs = x < 0 ? x+8 : x;
    switch (ofs%8)
    {
      case 0:  // all colors are GBR
        pen_color = 0x07839B;
        break;
      case 1:
      case 2:
      case 3:
        pen_color = 0x000000;
        break;
      case 4:
        pen_color = 0x00374B;
        break;
      case 5:
      case 6:
      case 7:
        pen_color = 0x13CBDB;
        break;
    }
    pb->Canvas->Pen->Color = pen_color;
    pb->Canvas->MoveTo(x, h);
    pb->Canvas->LineTo(x+(h/2), 0);
  }

/*
  // tile that mofo
  TPaintBox* pb = (TPaintBox*)(Sender);
  HDC pDC = pb->Canvas->Handle;
  SelectPalette(pDC, imgCaution->Picture->Bitmap->Palette, true);
  RealizePalette(pDC);
  TRect rect = pbCaution->ClientRect;
  Log(IntToString(rect.Width()) + "x" + IntToString(rect.Height()));
  HDC dc = CreateCompatibleDC(pDC);
  HBITMAP bmap = imgCaution->Picture->Bitmap->Handle;
  HBITMAP pOldBitmap = SelectObject(dc, bmap);
  int bmw, bmh;
  bmw = imgCaution->Picture->Bitmap->Width;
  bmh = imgCaution->Picture->Bitmap->Height;
  int xo=0, yo=0;

  for (yo = 0; yo < rect.bottom; yo += bmh)
  {
    for (xo = 0; xo < rect.right; xo += bmw)
    {
      BitBlt (&pDC, xo, yo, rect.right, rect.bottom, &dc, 0, 0, SRCCOPY);
    }
  }
  SelectObject(dc, pOldBitmap);
*/
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataMerge::treeMergeMouseMove(TObject *Sender,TShiftState Shift, int X, int Y)
{
  TTreeNode* Node = treeMerge->GetNodeAt(X, Y);
  string hint = "";
  if(Node)
    if(Node->Data)
    {
      node_data_type * node_data = (node_data_type *)Node->Data;
      hint += "direction:  ";
      if(node_data->link_direction == to_parent)
        hint += "to parent\n";
      else if(node_data->link_direction == from_parent)
        hint += "from parent\n";
      else if(node_data->link_direction == is_root)
        hint += "is root\n";
      hint += "fk table:  " + node_data->fk_table + "\n";
      hint += "fk field:  " + node_data->fk_field + "\n";
      hint += "pk table:  " + node_data->pk_table + "\n";
      hint += "pk field:  " + node_data->pk_field + "\n";
      hint += "fk table pk field:  " + node_data->fk_table_pk_field + "\n";
      hint += "pk field value:  " + node_data->pk_field_value + "\n";
      hint += "fk table pk field value:  " + node_data->fk_table_pk_field_value + "\n";
    }
  treeMerge->Hint = hint.c_str();
  treeMerge->ShowHint = true;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataMerge::treeMergeMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
  TTreeNode* Node = treeMerge->GetNodeAt(X, Y);
  if (Node)
    treeMerge->Selected = Node;
}
//---------------------------------------------------------------------------
void TformSpecialDataMerge::Log(string message)
{
  Pstamp now_stamp = CurrentPstamp();
  string full_message = "[" + now_stamp.OutStamp(datefirst | ymd | yyyy | left_zeros | military) + "]" +
                        "[" + GetTimeSince(now_stamp, last_message_stamp) + "] " + StripTrailing(StripTrailing(message, "\n"), "\r") + "\r\n";
  last_message_stamp = now_stamp;
  if (editLog) editLog->Lines->Add(ReplaceStringWithString(full_message, "\r", "").c_str());
  Application->ProcessMessages();
}
//---------------------------------------------------------------------------

