//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "codeSpecialDataMergePrompt.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialDataMergePrompt *formSpecialDataMergePrompt;
//---------------------------------------------------------------------------
__fastcall TformSpecialDataMergePrompt::TformSpecialDataMergePrompt(TComponent* Owner, string table, string pk, string value1, string value2, TIBTransaction* tx)
        : TformSpecialGeneric(Owner)
{
  merge_table = table;
  merge_pk = pk;
  merge_pk_value1 = value1;
  merge_pk_value2 = value2;
  allow_close = false;
  merge_transaction = tx;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataMergePrompt::FormShow(TObject *Sender)
{
  from_rec.clear();
  to_rec.clear();
  string sql;
  sql = "select * from " + merge_table + " where " + merge_pk + " = " + merge_pk_value1;
  SqlToVecMap(dbDatabase, sql, from_rec);
  sql = "select * from " + merge_table + " where " + merge_pk + " = " + merge_pk_value2;
  SqlToVecMap(dbDatabase, sql, to_rec);
  GetFieldsFromTable(dbDatabase, merge_table, table_fields);

  DoStuff();

  TformSpecialGeneric::FormShow(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataMergePrompt::FormCloseQuery(TObject *Sender, bool &CanClose)
{
  CanClose = allow_close;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataMergePrompt::FormClose(TObject *Sender, TCloseAction &Action)
{
  Action = caFree;
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void TformSpecialDataMergePrompt::DoStuff()
{
  int max_width1 = 0, max_width2 = 0, column_padding = 24, column_spacing = 16;
  int from_width, from_height, to_width, to_height;
  for (unsigned int i = 0; i < table_fields.size(); i++)
  {
    //Application->MessageBox(("'" + from_rec[0][LowercaseString(table_fields[i])] + "'").c_str(), "debug", MB_OK);
    if(!GetTextExtent(panelValues, panelValues->Font, from_rec[0][LowercaseString(table_fields[i])], from_width, from_height))
      PSay("GetTextExtent failed on '" + from_rec[0][LowercaseString(table_fields[i])] + "'", m_debug, MB_OK);
    //Application->MessageBox(("'" + to_rec[0][LowercaseString(table_fields[i])] + "'").c_str(), "debug", MB_OK);
    if(!GetTextExtent(panelValues, panelValues->Font, to_rec[0][LowercaseString(table_fields[i])], to_width, to_height))
      PSay("GetTextExtent failed on '" + to_rec[0][LowercaseString(table_fields[i])] + "'", m_debug, MB_OK);
    if (from_width > max_width1) max_width1 = from_width;
    if (to_width > max_width2) max_width2 = to_width;
  }

  lblValue2->Left = max_width1 + column_padding + column_spacing;
  int row = 1;
  for (unsigned int i = 0; i < table_fields.size(); i++)
  {
    // only show the fields which are not equal, and are not the PK
    if (from_rec[0][LowercaseString(table_fields[i])] != to_rec[0][LowercaseString(table_fields[i])] &&
        LowercaseString(table_fields[i]) != LowercaseString(merge_pk))
    {
      TLabel* aLabel = new TLabel(panelKeys);
      aLabel->Parent = panelKeys;
      aLabel->Anchors << akLeft << akTop;
      aLabel->Left = 0;
      aLabel->Top = (row)*24;
      aLabel->Height = 13;
      aLabel->Caption = table_fields[i].c_str();
      aLabel->AutoSize = true;
      aLabel->Visible = true;
      aLabel->Enabled = true;

      TPanel* aPanel = new TPanel(panelValues);
      aPanel->Parent = panelValues;
      aPanel->ParentFont = true;
      aPanel->Anchors << akLeft << akTop;
      aPanel->BevelInner = bvNone;
      aPanel->BevelOuter = bvNone;
      aPanel->Caption = "";
      aPanel->Left = 0;
      aPanel->Top = (row)*24;
      aPanel->AutoSize = true;
      aPanel->Visible = true;
      aPanel->Enabled = true;

      if (GetTextExtent(aPanel, aPanel->Font, from_rec[0][LowercaseString(table_fields[i])], from_width, from_height))
        if (GetTextExtent(aPanel, aPanel->Font, to_rec[0][LowercaseString(table_fields[i])], to_width, to_height))
        {
          TRadioButton* aRadio1 = new TRadioButton(aPanel);
          aRadio1->Parent = aPanel;
          aRadio1->ParentFont = true;
          aRadio1->Anchors << akLeft << akTop;
          aRadio1->Left = 0;
          aRadio1->Top = 0;
          aRadio1->Height = 17;
          aRadio1->Width = max_width1 + column_padding;
          aRadio1->Caption = from_rec[0][LowercaseString(table_fields[i])].c_str();
          aRadio1->Visible = true;
          aRadio1->Enabled = true;

          merge_from_fields.push_back(merge_from_type(aRadio1, table_fields[i], from_rec[0][LowercaseString(table_fields[i])]));

          TRadioButton* aRadio2 = new TRadioButton(aPanel);
          aRadio2->Parent = aPanel;
          aRadio1->ParentFont = true;
          aRadio2->Anchors << akLeft << akTop;
          aRadio2->Left = aRadio1->Left + aRadio1->Width + column_spacing;
          aRadio2->Top = 0;
          aRadio2->Height = 17;
          aRadio2->Width = max_width2 + column_padding;
          aRadio2->Caption = to_rec[0][LowercaseString(table_fields[i])].c_str();
          aRadio2->Visible = true;
          aRadio2->Enabled = true;
          aRadio2->Checked = true;
        }
        else
          PSay("GetTextExtent failed on '" + from_rec[0][LowercaseString(table_fields[i])] + "'", m_debug, MB_OK);
      else
        PSay("GetTextExtent failed on '" + to_rec[0][LowercaseString(table_fields[i])] + "'", m_debug, MB_OK);

      row++;
    }
  }
  panelValues->Left = panelKeys->Left + panelKeys->Width + column_spacing;
  scrollValues->HorzScrollBar->Position = 0;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataMergePrompt::btnFinishClick(TObject *Sender)
{
  for (unsigned int i = 0; i < merge_from_fields.size(); i++)
  {
    // We check all of the "from" record radio buttons.  If they're checked, we
    // move the value from this (the record to delete) to the record we keep
    string sql;
    try
    {
      if (merge_from_fields[i].radio->Checked)
      {
        sql = "update " + merge_table + " set " + merge_from_fields[i].key + " = '" + merge_from_fields[i].value + "' " +
          "where " + merge_pk + " = '" + merge_pk_value2 + "'";
        if(!ExecuteStatement(merge_transaction, sql))
          throw(1);
      }
    }
    catch (...)
    {
      if(merge_transaction->Active)
        merge_transaction->Rollback();
      PSay("Update of record to keep failed.  Aborting.\n\nSQL that failed:\n" + sql, m_database_error, MB_OK);
      allow_close = true;
      ModalResult = mrAbort;
      Close();
    }
  }

  allow_close = true;
  ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataMergePrompt::btnCancelClick(TObject *Sender)
{
  allow_close = true;
  ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataMergePrompt::CautionPaint(TObject *Sender)
{
  TPaintBox* pb = (TPaintBox*)(Sender);
  TColor pen_color;
  int h = pb->ClientHeight;
  for (int x = -(h/2); x < pb->ClientRect.right; x++)
  {
    int ofs = x < 0 ? x+8 : x;
    switch (ofs%8)
    {
      case 0:  // all colors are GBR
        pen_color = 0x07839B;
        break;
      case 1:
      case 2:
      case 3:
        pen_color = 0x000000;
        break;
      case 4:
        pen_color = 0x00374B;
        break;
      case 5:
      case 6:
      case 7:
        pen_color = 0x13CBDB;
        break;
    }
    pb->Canvas->Pen->Color = pen_color;
    pb->Canvas->MoveTo(x, h);
    pb->Canvas->LineTo(x+(h/2), 0);
  }
/*
  // tile that mofo
  TPaintBox* pb = (TPaintBox*)(Sender);
  HDC pDC = pb->Canvas->Handle;
  TRect rect = pbCaution1->ClientRect;
  PSay(IntToString(rect.Width()) + "x" + IntToString(rect.Height()), m_debug, MB_OK);
  HDC dc = CreateCompatibleDC(pDC);
  HBITMAP bmap = imgCaution->Picture->Bitmap->Handle;
  HBITMAP pOldBitmap = SelectObject(dc, bmap);
  int bmw, bmh;
  bmw = imgCaution->Picture->Bitmap->Width;
  bmh = imgCaution->Picture->Bitmap->Height;
  int xo=0, yo=0;

  for (yo = 0; yo < rect.bottom; yo += bmh)
  {
    for (xo = 0; xo < rect.right; xo += bmw)
    {
      BitBlt (&pDC, xo, yo, rect.right, rect.bottom, &dc, 0, 0, SRCCOPY);
    }
  }
  SelectObject(dc, pOldBitmap);
*/
  // fuck it, I'll draw the damn thing myself

}
//---------------------------------------------------------------------------

