//--------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "codeSpecialDataNavigate.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma link "ttreelistview"
#pragma resource "*.dfm"
TformSpecialDataNavigate *formSpecialDataNavigate;
//---------------------------------------------------------------------------
__fastcall TformSpecialDataNavigate::TformSpecialDataNavigate(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
   this->IconIndex = 22;
   if (!RefreshTables()) Close();
//   btnGo->Enabled = false;
   lastSelectedTable = "";
   lastTable = "";
   progressMajor->Visible = false;
   progressMinor->Visible = false;

   listNav->Tag = int(&DataFilter);
   DataFilter.SetListViewHandle(listNav);
   DataFilter.SetHeader(true);
   DataFilter.SetIconStatus(true);
   panelInstructions->Color = title_bar_color;
}
//---------------------------------------------------------------------------
bool TformSpecialDataNavigate::RefreshTables()
{
   vector<string> table_vec;
   string table_sql;
   table_sql = "select rdb$relation_name from rdb$relations ";
//   if (!btnShowRDB->Down)
     table_sql+= "where rdb$relation_name not like 'RDB$%' ";
   table_sql += "order by rdb$relation_name";
   cboTable->OnChange = NULL;
   cboTable->Items->BeginUpdate();
   cboTable->Items->Clear();
   bool result = true;
   if (SqlToVec(dbDatabase, table_sql, table_vec))
   {
     for (unsigned int i=0; i<table_vec.size(); i++)
       cboTable->Items->Add(StripTrailing(table_vec[i], " ").c_str());
   }
   else
   {
     PSay("Could not get list of tables from the database", m_database_error, MB_OK);
     result = false;
   }
   cboTable->Text = "";
   cboTable->Items->EndUpdate();
   cboTable->OnChange = cboTableChange;
   return result;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataNavigate::cboTableKeyPress(TObject *Sender, char &Key)
{
   FindComboBoxItem(Sender, Key);
   cboTableChange(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataNavigate::cboTableChange(TObject *Sender)
{
  if (cboTable->Items->IndexOf(cboTable->Text) != -1 && lastSelectedTable != string(cboTable->Text.c_str()))
  {
    cboPk->Items->Clear();
    vector<string> rec_fields, pk;
    if (!GetFieldsFromTable(dbDatabase, cboTable->Text.c_str(), rec_fields))
    {
      PSay("Error getting table's fields", m_database_error, MB_OK);
      return;
    }
    for (unsigned int i=0; i<rec_fields.size(); i++)
      cboPk->Items->Add(rec_fields[i].c_str());
    if (GetTablePrimaryKey (dbDatabase, cboTable->Text.c_str(), pk))
      cboPk->ItemIndex = cboPk->Items->IndexOf(pk[0].c_str());
    else ;
      // cboPk->Text = "";

    lastSelectedTable = string(cboTable->Text.c_str());
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataNavigate::btnGoClick(TObject *Sender)
{
   if (cboTable->Items->IndexOf(cboTable->Text) != -1 && cboPk->Text != "" && editPkValue->Text != "")
   {
      // So it turns out the reason all this new/delete stuff was necessary, according to philip, is that
      // a vector can move around in memory at random, if it decides it needs more room, etc.  So rather
      // than doing it this way, I -could- have done it with a list.  But done's done and it works, so
      // I'ma leave it.  But -next- time....  :-)
      for (vector<node_data_type*>::iterator i = link_data.begin(); i != link_data.end(); i++)
        delete *i;
      link_data.clear();
      treeNav->Items->Clear();
      listNav->Items->Clear();
      link_data.push_back(new node_data_type(is_root, "", "", cboTable->Text.c_str(), cboPk->Text.c_str(), "", editPkValue->Text.c_str(), ""));
      TTreeNode* Root = treeNav->Items->Add(NULL, LowercaseString((cboTable->Text + "." + cboPk->Text + " = " + editPkValue->Text).c_str()).c_str());
      Root->ImageIndex = 5;
      Root->SelectedIndex = 5;
      Root->Data = (void *)(link_data[link_data.size()-1]);

      PopulateLinks(cboTable->Text.c_str(), cboPk->Text.c_str(), editPkValue->Text.c_str(), link_data, Root);
      //treeNav->AlphaSort();
      lastTable = string(cboTable->Text.c_str());
   }
}
//---------------------------------------------------------------------------
void TformSpecialDataNavigate::PopulateLinks(string rec_table, string rec_pk, string rec_pk_value, vector<node_data_type *>& links, TTreeNode* ParentNode)
{
   if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "DataNavigate: Populating links for " + rec_table + "." + rec_pk + "(" + rec_pk_value + ")");
   if (rec_pk_value == "0")
     if(PSay("Searching for links to a PK of value 0 may take a while and cause your computer to seem unresponsive.\n\nAre you sure you want to continue?", m_confirmation, MB_YESNO) == IDNO)
       return;

   Processing(true);
   vector<string> rec_fields;
   TIBTransaction * dbTransaction = new TIBTransaction(NULL);
   try
   {
     // Set up transaction and data set (to get columns to feed to the filter object)
     if (StdTransaction(dbTransaction, dbDatabase))
     {
       if (!GetFieldsFromTable(dbTransaction, rec_table, rec_fields))
       {
         PSay("Error getting table's fields", m_database_error, MB_OK);
         return;
       }

       progressMajor->Position = 0;
       progressMajor->Max = rec_fields.size();
       progressMajor->Visible = true;
       // loop through fields
       for (unsigned int i = 0; i < rec_fields.size(); i++)
       {
         // get the PK that this field in the record links to (if any)
         string from_rec_table;
         vector<string> from_rec_fields;
         // if the record field is an FK...
         if (GetPrimaryKey(dbTransaction, rec_table, rec_fields[i], from_rec_table, from_rec_fields))
         {
           // get the value of the key
           string rec_fk_value = GetOneField(dbTransaction, "select " + rec_fields[i] + " from " + rec_table + " where " + rec_pk + " = " + rec_pk_value);
           if (rec_fk_value != "")
           {
             links.push_back(new node_data_type(from_parent, rec_table, rec_fields[i], from_rec_table, from_rec_fields[0], rec_pk, rec_fk_value, rec_pk_value));
             string SubNodeText = LowercaseString(from_rec_table) + " linked from " + LowercaseString(rec_table) + "." + LowercaseString(rec_fields[i]);
             TTreeNode* SubNode = treeNav->Items->AddChild(ParentNode, SubNodeText.c_str());
             SubNode->ImageIndex = 1;
             SubNode->SelectedIndex = 1;
             string SubSubNodeText = LowercaseString(from_rec_table) + "." + LowercaseString(rec_fields[0]) + " = " + rec_fk_value;
             TTreeNode* SubSubNode = treeNav->Items->AddChild(SubNode, SubSubNodeText.c_str());
             SubSubNode->ImageIndex = 3;
             SubSubNode->SelectedIndex = 3;
             SubSubNode->Data = (void *)(links[links.size()-1]);
           }
         }

         // get FKs to this field in the record (if any)
         vector<map<string, string> > to_rec_fields_vecmap;
         if (GetForeignKeys (dbTransaction, rec_table, rec_fields[i], to_rec_fields_vecmap))
         {
           progressMinor->Position = 0;
           progressMinor->Max = to_rec_fields_vecmap.size();
           progressMinor->Visible = true;
           Application->ProcessMessages();
           // I'ma stick it in a multimap cause I think that'll be handier (in alph order so same table together; can do ctrl-break processing to add branches).
           multimap<string, string> to_rec_fields_map;
           for (unsigned int j = 0; j != to_rec_fields_vecmap.size(); j++)
             to_rec_fields_map.insert(pair<string, string>(to_rec_fields_vecmap[j]["fk_table"], to_rec_fields_vecmap[j]["fk_field"]));
           //to_rec_fields_map
           // k, now loop through the multimap, keeping track of last/current fk_table... when table changes, new branch... otherwise, run the SQL to get all
           // related records of that type and add them under that table.  Yep.
           string last_fk_table = "";
           TTreeNode* SubNode = NULL;
           for (multimap<string, string>::iterator itr = to_rec_fields_map.begin(); itr!= to_rec_fields_map.end(); itr++)
           {
             if (itr->first != last_fk_table)
             {
               // first, if the last subnode created has no children, we don't need it in the tree:
               if (SubNode)
                 if (SubNode->Count == 0)
                   SubNode->Delete();
                 else
                   SubNode->Text = SubNode->Text + (" " + IntToString(SubNode->Count) + " times by:").c_str();
               // create new node for the new fk_table
               string SubNodeText = LowercaseString(itr->first) + " links to " + LowercaseString(rec_table) + "." + LowercaseString(rec_fields[i]) + "(" + rec_pk_value + ")";
               SubNode = treeNav->Items->AddChild(ParentNode, SubNodeText.c_str());
               SubNode->ImageIndex = 2;
               SubNode->SelectedIndex = 2;
             }
             vector<string> to_rec_table_pk;
             if (GetTablePrimaryKey (dbDatabase, itr->first.c_str(), to_rec_table_pk))
             {
               string sql = "select " + to_rec_table_pk[0] + " from " + itr->first + " where " + itr->second + " = " + rec_pk_value;
               vector<string> to_rec_fk_values;
               if (SqlToVec(dbDatabase, sql, to_rec_fk_values))
               {
                 progressMinor->Max += to_rec_fk_values.size();
                 // we've got some matching fk's to add to the tree
                 for (unsigned int k=0; k<to_rec_fk_values.size(); k++)
                 {
                   links.push_back(new node_data_type(to_parent, itr->first, itr->second, rec_table, rec_fields[i], to_rec_table_pk[0], rec_pk_value, to_rec_fk_values[k]));
                   string SubSubNodeText = LowercaseString(itr->first) + "." + LowercaseString(itr->second) + " (" +
                      LowercaseString(itr->first) + "." + LowercaseString(to_rec_table_pk[0]) + " = " + to_rec_fk_values[k] + ")";
                   TTreeNode* SubSubNode = treeNav->Items->AddChild(SubNode, SubSubNodeText.c_str());
                   SubSubNode->ImageIndex = 4;
                   SubSubNode->SelectedIndex = 4;
                   SubSubNode->Data = (void *)(links[links.size()-1]);
                   progressMinor->Position++;
                 } // for k
               }
               else
                 PSay("Error getting PK '" + to_rec_table_pk[0] + "' from " + itr->first + "table '" + itr->first + "'.", m_message, MB_OK);

               last_fk_table = itr->first;
             }
             else
               PSay("Unable to determine PK in table " + itr->first + ".", m_database_error, MB_OK);
             progressMinor->Position++;
           } // for each FK in map
           progressMinor->Visible = false;
           // in case the very last subnode had no children (matching FK records)
           if (SubNode)
             if (SubNode->Count == 0)
               SubNode->Delete();
             else
               SubNode->Text = SubNode->Text + (" " + IntToString(SubNode->Count) + " times by:").c_str();
         } // GetForeignKeys
         progressMajor->Position++;
         Application->ProcessMessages();
       } // for i
     }
     else
     {
       PSay("Error setting up transaction", m_database_error, MB_OK);
       if (dbTransaction->Active)
         dbTransaction->Rollback();
     }
   }
   catch (...)
   {
      PSay("Error executing query", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
   }
   delete dbTransaction;
   if (ParentNode)
     ParentNode->Expand(false);
   progressMajor->Visible = false;
   Processing(false);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataNavigate::menuTreeExpandClick(TObject *Sender)
{
  if (treeNav->Selected)
  {
    if (treeNav->Selected->Data && treeNav->Selected->Count == 0) // has data, not already populated
    {
      //if(PSay("About to convert ->Data to node_data*.  Continue?", m_confirmation, MB_YESNO) == IDNO) return;
      node_data_type *node_data = (node_data_type *)treeNav->Selected->Data;
      switch (node_data->link_direction)
      {
        case to_parent:
          //if(PSay("Getting links for " + node_data->fk_table + "." + node_data->fk_table_pk_field + " == " + node_data->fk_table_pk_field_value+".  Continue?", m_message, MB_YESNO) == IDNO) return;
          PopulateLinks(node_data->fk_table, node_data->fk_table_pk_field, node_data->fk_table_pk_field_value, link_data, treeNav->Selected);
          break;
        case from_parent:
          //if(PSay("Getting links for " + node_data->pk_table + "." + node_data->pk_field + " == " + node_data->pk_field_value+".  Continue?", m_message, MB_YESNO) == IDNO) return;
          PopulateLinks(node_data->pk_table, node_data->pk_field, node_data->pk_field_value, link_data, treeNav->Selected);
          break;
      }
    }
    else
      PSay("You must select a valid node.", m_message, MB_OK);
  }
  else
    PSay("You must select a valid node.", m_message, MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataNavigate::treeNavChange(TObject *Sender, TTreeNode *Node)
{
  int i, j;

  for (i = 0; i < gridNav->ColCount; i++)
    for (j = 0; j < gridNav->RowCount; j++)
      gridNav->Cells[i][j] = "";
  gridNav->ColCount = 1;
  gridNav->RowCount = 1;
//  gridNav->Cells[0][0] = "";

  vector<node_data_type *> nodes_data;
  if (Node)
  {
    //node_data_type *node_data;
    Processing(true);
    if (Node->Data)
    {
      nodes_data.push_back((node_data_type *)Node->Data);
      if (radioNodeData->Checked)
      {
        gridNav->ColCount = 2;
        gridNav->FixedCols = 1;
        gridNav->RowCount += 7;
        DoNodeData(nodes_data[nodes_data.size()-1]);
      }
    }
    TTreeNode *ChildNode = Node->getFirstChild();
    while (ChildNode)
    {
      if (ChildNode->Data)
      {
        nodes_data.push_back((node_data_type *)ChildNode->Data);
        if (radioNodeData->Checked)
        {
          gridNav->ColCount = 2;
          gridNav->FixedCols = 1;
          gridNav->RowCount += (gridNav->RowCount == 1) ? 7 : 9;
          DoNodeData(nodes_data[nodes_data.size()-1]);
        }
      }
      ChildNode = Node->GetNextChild(ChildNode);
    }
    // process vector, adding to listview and string grid
    vector<string> pk_values;
    for (unsigned int i = 0; i != nodes_data.size(); i++)
    {
      if (nodes_data[i]->link_direction == to_parent)
        pk_values.push_back(nodes_data[i]->fk_table_pk_field_value);
      else
        pk_values.push_back(nodes_data[i]->pk_field_value);
    }
    if (!nodes_data.empty())
    {
      string sql = (nodes_data[0]->link_direction == to_parent) ?
        "select * from " + nodes_data[0]->fk_table + " where " + SafeInClause(nodes_data[0]->fk_table_pk_field, pk_values) :
        "select * from " + nodes_data[0]->pk_table + " where " + SafeInClause(nodes_data[0]->pk_field, pk_values) ;
      TDateTime start_time = Now();
      DataFilter.SetAutoColumnSpecs(true, btnDataFormatByType->Down);
      DataFilter.SetSQLStatement(sql);
      DataFilter.RefreshDataSet();
      DataFilter.SetHint(" " + IntToString(DataFilter.GetResultSize()) + " results found (in " +
        Ptime (Now() - start_time).OutTime(military | withsec) + ")");

      // grab the listview's dataset, loop through and make the data grid go.
      if (radioRecordData->Checked)
      {
        if (DataFilter.GetDatasetSize() > 0)
        {
          // top row looked useless. removed. wish to use DrawCell to remove the '3D' effect from the left side, but that means extra code.
          gridNav->ColCount = DataFilter.GetDatasetSize()+1;
          gridNav->RowCount = DataFilter.GetFieldNames().size();
          gridNav->FixedRows = 0;
          gridNav->FixedCols = 1;
          int current_record = 0;
          for (deque<vector<string> >::const_iterator z = DataFilter.GetRawData().begin(); z != DataFilter.GetRawData().end(); z++)
          {
            //if (nodes_data[0]->link_direction == to_parent)
            //  gridNav->Cells[current_record+1][0] = dbDataSet->Fields->Fields[nodes_data[0]->fk_table_pk_field.c_str()]->DisplayText;
            //else
            //  gridNav->Cells[current_record+1][0] = dbDataSet->Fields->Fields[nodes_data[0]->pk_field.c_str()]->DisplayText;
            for (int i = 0; i < DataFilter.GetFieldNames().size(); i++)
            {
              if (gridNav->Cells[0][i] == "")
                gridNav->Cells[0][i] = LowercaseString(DataFilter.GetFieldNames()[i]).c_str();
              gridNav->Cells[current_record+1][i] = (*z)[i].c_str();
            }
            current_record++;
          }
        }
      }
    }
  }
  else
  {
    gridNav->Cells[0][0] = "no data";
  }
  Processing(false);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataNavigate::FormClose(TObject *Sender, TCloseAction &Action)
{
  // So it turns out the reason all this new/delete stuff was necessary, according to philip, is that
  // a vector can move around in memory at random, if it decides it needs more room, etc.  So rather
  // than doing it this way, I -could- have done it with a list.  But done's done and it works, so
  // I'ma leave it.  But -next- time....  :-)
  for (vector<node_data_type*>::iterator i = link_data.begin(); i != link_data.end(); i++)
    delete *i;
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void TformSpecialDataNavigate::DoNodeData(node_data_type * node_data)
{
  gridNav->Cells[0][gridNav->RowCount-8] = "direction";
  if(node_data->link_direction == to_parent)
    gridNav->Cells[1][gridNav->RowCount-8] = "to parent";
  else if(node_data->link_direction == from_parent)
    gridNav->Cells[1][gridNav->RowCount-8] = "from parent";
  else if(node_data->link_direction == is_root)
    gridNav->Cells[1][gridNav->RowCount-8] = "is root";
  gridNav->Cells[0][gridNav->RowCount-7] = "fk table";
  gridNav->Cells[1][gridNav->RowCount-7] = node_data->fk_table.c_str();
  gridNav->Cells[0][gridNav->RowCount-6] = "fk field";
  gridNav->Cells[1][gridNav->RowCount-6] = node_data->fk_field.c_str();
  gridNav->Cells[0][gridNav->RowCount-5] = "pk table";
  gridNav->Cells[1][gridNav->RowCount-5] = node_data->pk_table.c_str();
  gridNav->Cells[0][gridNav->RowCount-4] = "pk field";
  gridNav->Cells[1][gridNav->RowCount-4] = node_data->pk_field.c_str();
  gridNav->Cells[0][gridNav->RowCount-3] = "fk table pk field";
  gridNav->Cells[1][gridNav->RowCount-3] = node_data->fk_table_pk_field.c_str();
  gridNav->Cells[0][gridNav->RowCount-2] = "pk field value";
  gridNav->Cells[1][gridNav->RowCount-2] = node_data->pk_field_value.c_str();
  gridNav->Cells[0][gridNav->RowCount-1] = "fk table pk field value";
  gridNav->Cells[1][gridNav->RowCount-1] = node_data->fk_table_pk_field_value.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataNavigate::radioDataClick(TObject *Sender)
{
  treeNavChange(NULL, treeNav->Selected);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataNavigate::treeNavMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
  TTreeNode* Node = treeNav->GetNodeAt(X, Y);
  if (Node)
    treeNav->Selected = Node;
}
//---------------------------------------------------------------------------

