//---------------------------------------------------------------------------

#ifndef codeSpecialDataNavigateH
#define codeSpecialDataNavigateH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>
#include "ttreelistview.h"
#include <ImgList.hpp>
#include <Menus.hpp>
#include <Grids.hpp>
//---------------------------------------------------------------------------
enum link_direction_types {to_parent, from_parent, is_root};

class node_data_type
{
public:
   node_data_type (link_direction_types pLinkDirection, string pFkTable, string pFkField,
     string pPkTable, string pPkField, string pFkTablePkField, string pPkFieldValue, string pFkTablePkFieldValue)
   {
     link_direction = pLinkDirection; fk_table = pFkTable; fk_field = pFkField;
     pk_table = pPkTable; pk_field = pPkField; fk_table_pk_field = pFkTablePkField;
     pk_field_value = pPkFieldValue; fk_table_pk_field_value = pFkTablePkFieldValue;
   };

   link_direction_types link_direction;
   string fk_table;
   string fk_field;
   string pk_table;
   string pk_field;
   string fk_table_pk_field;
   string pk_field_value;
   string fk_table_pk_field_value;
};
//---------------------------------------------------------------------------
class TformSpecialDataNavigate : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TImageList *imageArrows;
        TPopupMenu *popupTree;
        TMenuItem *menuTreeExpand;
        TPanel *panelNav;
        TPanel *panelTop;
        TPanel *panelLeft;
        TTreeView *treeNav;
        TPanel *panelRight;
        TStringGrid *gridNav;
        TProgressBar *progressMajor;
        TProgressBar *progressMinor;
        TToolButton *btnDataFormatByType;
        TToolButton *btnInvisible;
        TSplitter *splitHoriz;
        TPanel *panelInstructions;
        TPanel *panelTable;
        TLabel *lblId;
        TLabel *lblTable;
        TLabel *lblPK;
        TEdit *editPkValue;
        TComboBox *cboTable;
        TButton *btnGo;
        TComboBox *cboPk;
        TPanel *panelBottom;
        TListView *listNav;
        TSplitter *splitVert;
        TRadioButton *radioRecordData;
        TRadioButton *radioNodeData;
        TBevel *bevelRight;
        void __fastcall cboTableKeyPress(TObject *Sender, char &Key);
        void __fastcall cboTableChange(TObject *Sender);
        void __fastcall btnGoClick(TObject *Sender);
        void __fastcall menuTreeExpandClick(TObject *Sender);
        void __fastcall treeNavChange(TObject *Sender, TTreeNode *Node);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall radioDataClick(TObject *Sender);
        void __fastcall treeNavMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
private:	// User declarations
        bool RefreshTables();
        string lastSelectedTable;
        string lastTable;
        vector<node_data_type *> link_data;
        void PopulateLinks(string, string, string, vector<node_data_type *>&, TTreeNode*);
        void DoNodeData(node_data_type * node_data);
        classFilterObject DataFilter;
public:		// User declarations
        __fastcall TformSpecialDataNavigate(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TformSpecialDataNavigate *formSpecialDataNavigate;
//---------------------------------------------------------------------------
#endif
