//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialDataQuery.h"
#include "codeSpecialSqlViewer.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma link "IBExtract"
#pragma resource "*.dfm"
TformSpecialDataQuery *formSpecialDataQuery;
//---------------------------------------------------------------------------
__fastcall TformSpecialDataQuery::TformSpecialDataQuery(TComponent* Owner, TIBTransaction *p_transaction, string p_sql)
  : TformSpecialGeneric(Owner)
{
  this->IconIndex = 20;
  pageDataQuery->ActivePageIndex = 0;
  current_query = 0;
  last_select_query = "";
  last_non_select_query = "";
  committed = true;

  received_transaction = tt_none;
  if (!p_transaction)
  {
//    PSay("Creating a new transaction!", m_message, MB_OK);
    DQTransaction = new TIBTransaction(NULL);
    if(!StdTransaction(DQTransaction, dbDatabase))
      PSay("Error setting up transaction", m_database_error, MB_OK);
  }
  else
  {
//    PSay("Using existing transaction!", m_message, MB_OK);
    received_transaction = tt_inactive;
    try
    {
      DQTransaction = p_transaction;
      if (!DQTransaction->Active)
        DQTransaction->StartTransaction();
      else
        received_transaction = tt_active;
    }
    catch (...)
    {
      PSay("Error using existing transaction", m_database_error, MB_OK);
    }
  }

  dbTable = new TIBTable(NULL);
  dbTable->Database = dbDatabase;
  listData->Tag = int(&DataFilter);
  DataFilter.SetListViewHandle(listData);
  DataFilter.SetTransaction(DQTransaction); // filter should be using the same transaction to view data that we're using
  DataFilter.SetHeader(true);               // to run queries, or it's all sort of useless, isn't it?
  //DataFilter.SetIconStatus(true);
  DataFilter.SetCompress(true);
  DataFilter.SetMulti(true);

  //TableInfoFilter.SetListViewHandle(listTableInfo);
  //DataFilter.FetchPreferences("");
  DataFilter.SetHeader(true);
  DataFilter.SetIconStatus(true);
  TableInfoListview = new edit_listview();
  TableInfoListview->setup_listview(listTableInfo);
  //                 add_or_modify_column(string column_name, string column_title, bool column_visible, int column_position, int column_width, int column_sort_type, int column_show_type)
  TableInfoListview->add_or_modify_column("field_position",   "Pos",               true,                0,                   -1,               as_int,               prettyString);
  TableInfoListview->add_or_modify_column("field_name",       "Name",              true,                1,                   -1,               as_text,              prettyString);
  TableInfoListview->add_or_modify_column("field_type",       "Type",              true,                2,                   -1,               as_text,              prettyString);
  TableInfoListview->add_or_modify_column("length",           "Len",               true,                3,                   -1,               as_int,               prettyString);
  TableInfoListview->add_or_modify_column("field_source",     "Source",            true,                4,                   -1,               as_text,              prettyString);
  TableInfoListview->add_or_modify_column("character_set",    "Char Set",          true,                5,                   -1,               as_text,              prettyString);
  TableInfoListview->add_or_modify_column("collation",        "Collation",         true,                6,                   -1,               as_text,              prettyString);
  TableInfoListview->add_or_modify_column("allow_null",       "Nulls",             true,                7,                   -1,               as_text,              prettyString);
  TableInfoListview->add_or_modify_column("default",          "Default",           true,                8,                   -1,               as_text,              prettyString);
  TableInfoListview->add_or_modify_column("constraint_type",  "Constraint",        true,                9,                   -1,               as_text,              prettyString);
  TableInfoListview->add_or_modify_column("owner_name",       "Owner",             true,                10,                  -1,               as_text,              prettyString);
  TableInfoListview->add_or_modify_column("fk_table",         "FK Table",          true,                11,                  -1,               as_text,              prettyString);
  TableInfoListview->add_or_modify_column("fk_field",         "FK Field",          true,                12,                  -1,               as_text,              prettyString);
  TableInfoListview->add_or_modify_column("indexed_by",       "Index",             true,                13,                  -1,               as_text,              prettyString);
  TableInfoListview->add_or_modify_column("constraint_name",  "Constraint Name",   true,                14,                  -1,               as_text,              prettyString);

  // if (!RefreshTables()) Close(); // drawer does this itself

  panelSQLPosition->Color = title_bar_color;
  //DataFilter.SetAddEdit(this, AddRecord(NULL, NULL));
  //data_request = atlas->RequestNotificationWhen("bugs.id", "", rel_any, as_int, this,
  //                      RefreshHandler(&(TformSpecialBugs::AtlasRefreshListView)));

  FORM_TRY
    dq_objects_window                = new TformDrawerDataQuery(NULL);
  FORM_CATCH
  dq_objects_window->DrawerOwner    = this;
  dq_objects_window->Width          = 200;
  dq_objects_window->DrawerPosition = akLeft;
  if (p_sql == "")
  {
    dq_objects_window->DrawerExpanded = true;
    btnDQObjects->Down = true;
  }
  else
  {
    pageDataQuery->ActivePage = tabSql;
    editSql->Text = p_sql.c_str();
  }

  dq_objects_window->listDomains->OnChange          = ObjectsListChange;
  dq_objects_window->listTables->OnChange           = ObjectsListChange;
  dq_objects_window->listViews->OnChange            = ObjectsListChange;
  dq_objects_window->listIndexes->OnChange          = ObjectsListChange;
  dq_objects_window->listStoredProcedures->OnChange = ObjectsListChange;
  dq_objects_window->listGenerators->OnChange       = ObjectsListChange;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::btnObjectInfoRefreshClick(TObject *Sender)
{
  // RefreshTableInfo(treeDataQuery->Selected->Text.c_str());
  TListView *object_list = dq_objects_window->GetActiveList();
  string object_type = object_list->Column[0]->Caption.c_str();
  string object_selected;
  if (object_list->Selected)
  {
    object_selected = object_list->Selected->Caption.c_str();
    //PSay("Object changed:  " + object_type + " -> " + object_selected, m_message, MB_OK);
    RefreshObjectInfo(object_type, object_selected);
  }
  else
    object_selected = ""; // not that it matters
}
//---------------------------------------------------------------------------
void TformSpecialDataQuery::RefreshTableInfo(string table_name)
{
  listTableInfo->Items->BeginUpdate();
  //listTableInfo->Items->Clear();
  TableInfoListview->clear_data();
  if ((dq_objects_window->GetActiveList())->Selected)
  {
    string column_info_sql =
      "select RelFld.rdb$field_position pos, "
      "  RelFld.rdb$field_name field_name, "
      "  RelFld.rdb$field_source, "
      "  Flds.rdb$field_type, "
      "  Flds.rdb$segment_length, "
      "  Flds.rdb$field_sub_type, "
      "  Flds.rdb$field_length, "
      "  Flds.rdb$field_scale, "
      "  Flds.rdb$default_source def_dom, "
      "  RelFld.rdb$default_source def_native, "
      "  RelFld.rdb$null_flag nulls1, "
      "  Flds.rdb$null_flag nulls2, "
      "  Flds.rdb$system_flag, "
      "  Flds.rdb$dimensions, "
      "  Flds.rdb$character_length, "
      "  Flds.rdb$field_precision, "
      "  Flds.rdb$character_set_id, "
      "  Flds.rdb$collation_id, "
      "  Idx1.rdb$unique_flag is_unique, "
//          "  FldTyp.rdb$type_name field_type, "
//          "  SubTyp.rdb$type_name field_sub_type, "
      "  RelCon.rdb$constraint_type constraint_type, "
      "  Rel.rdb$owner_name owner_name, "
      "  Idx2.rdb$relation_name fk_table, "
      "  ISeg2.rdb$field_name fk_field, "
      "  Idx1.rdb$index_name indexed_by, "
      "  RelCon.rdb$constraint_name constraint_name "
      "from rdb$relations Rel inner join rdb$relation_fields RelFld on Rel.rdb$relation_name = RelFld.rdb$relation_name "
      "  inner join rdb$fields Flds on RelFld.rdb$field_source = Flds.rdb$field_name "
//          "  left  join rdb$types FldTyp on Flds.rdb$field_type = FldTyp.rdb$type and FldTyp.rdb$field_name = 'RDB$FIELD_TYPE' "
//          "  left  join rdb$types SubTyp on Flds.rdb$field_sub_type = SubTyp.rdb$type and SubTyp.rdb$field_name = 'RDB$FIELD_SUB_TYPE' "
      "  left  join ( "
      "    rdb$relation_constraints RelCon right join rdb$indices Idx1 on Idx1.rdb$index_name = RelCon.rdb$index_name "
      "      and Idx1.rdb$relation_name = '" + table_name + "' and RelCon.rdb$relation_name = Idx1.rdb$relation_name "
      "    left join rdb$indices Idx2 on Idx1.rdb$foreign_key = Idx2.rdb$index_name "
      "    inner join rdb$index_segments ISeg1 on Idx1.rdb$index_name = ISeg1.rdb$index_name "
      "    left join rdb$index_segments ISeg2 on Idx1.rdb$foreign_key = ISeg2.rdb$index_name "
      "  ) on RelFld.rdb$field_name = ISeg1.rdb$field_name and RelFld.rdb$relation_name = Idx1.rdb$relation_name "
      "where Rel.rdb$relation_name = '" + table_name + "' ";
    DebugSql(this, &column_info_sql, other_forms, 9);

    if (!DQTransaction->Active)
      DQTransaction->StartTransaction();

    TIBExtract * IBExtract = new TIBExtract(this);
    IBExtract->Database = dbDatabase;

    vector<map<string, string> > column_info_vec;
    map<string, string> insert_map;
/*    string column_info_sql =
      "select A.rdb$field_name, A.rdb$field_source, B.rdb$field_type, B.rdb$segment_length, B.rdb$field_sub_type, "
      "  B.rdb$field_length, B.rdb$field_scale, B.rdb$default_source def_dom, A.rdb$default_source def_native, "
      "  A.rdb$null_flag nulls1, B.rdb$null_flag nulls2, B.rdb$system_flag, B.rdb$dimensions, B.rdb$character_length, "
      "  B.rdb$field_precision, B.rdb$character_set_id, B.rdb$collation_id "
      "from rdb$relation_fields A, rdb$fields B "
      "where A.rdb$relation_name = '" + table_name + "' and A.rdb$field_source = B.rdb$field_name "
      "order by A.rdb$relation_name, rdb$field_position ";
*/
    SqlToVecMap(DQTransaction, column_info_sql, column_info_vec);

    vector<map<string, string> > table_info;
    table_info.clear();
    try
    {
      //if (!ExecuteStatement(DQTransaction, "delete from temp_data_query")) throw(1);

      for (unsigned int i = 0; i < column_info_vec.size(); i++)
      {
        insert_map.clear();
        insert_map["field_position"] = column_info_vec[i]["pos"];
        insert_map["field_name"] = StripTrailing(column_info_vec[i]["field_name"], " ");
        insert_map["field_source"] = StripTrailing(column_info_vec[i]["rdb$field_source"], " ");

        // Convert useless integers to text descriptions, store in new extra columns in the same vecmap
        if (StringToInt(column_info_vec[i]["rdb$dimensions"]) > 0)
          insert_map["field_type"] = (IBExtract->GetArrayField(StripTrailing(column_info_vec[i]["rdb$field_source"], " ").c_str())).c_str();

        string extra_field_type_info = IBExtract->GetFieldType(StringToInt(column_info_vec[i]["rdb$field_type"]),
                                                               StringToInt(column_info_vec[i]["rdb$field_sub_type"]),
                                                               StringToInt(column_info_vec[i]["rdb$field_scale"]),
                                                               StringToInt(column_info_vec[i]["length"]),
                                                               StringToInt(column_info_vec[i]["rdb$field_precision"]),
                                                               StringToInt(column_info_vec[i]["rdb$segment_length"]) ).c_str();
        insert_map["field_type"] += (" " + extra_field_type_info);

        if (column_info_vec[i]["rdb$character_set_id"] != "" && column_info_vec[i]["rdb$character_set_id"] != "0")
          insert_map["character_set"] = IBExtract->GetCharacterSets(StringToInt(column_info_vec[i]["rdb$character_set_id"]), 0, false).c_str();

        if (column_info_vec[i]["rdb$collation_id"] != "" && column_info_vec[i]["rdb$collation_id"] != "0")
          insert_map["collation"] = IBExtract->GetCharacterSets(StringToInt(column_info_vec[i]["character_set_id"]), StringToInt(column_info_vec[i]["rdb$collation_id"]), false).c_str();

        insert_map["allow_nulls"] = (StringToInt(column_info_vec[i]["nulls1"]) == 1 || StringToInt(column_info_vec[i]["nulls2"]) == 1) ? "No" : "Yes";

        if (column_info_vec[i]["def_dom"] != "")
          insert_map["default"] = StripTrailing(column_info_vec[i]["def_dom"], " ");

        if (column_info_vec[i]["def_native"] != "")
          insert_map["default"] = StripTrailing(column_info_vec[i]["def_native"], " ");

        if (insert_map["default"].substr(0, 8) == "DEFAULT ")
           insert_map["default"] = insert_map["default"].substr(8);

        //if (column_info_vec[i]["rdb$field_source"].substr(0, 4) == "RDB$" || StringToInt(column_info_vec[i]["rdb$system_flag"]) == 1)
        //  insert_map["field_type"] = "(" + StripTrailing(column_info_vec[i]["rdb$field_source"], " ") + ") " + insert_map["field_type"];

        string len;
        if (table_name.substr(0, 4) == "RDB$")
          len = column_info_vec[i]["rdb$field_length"];
        else
          len = column_info_vec[i]["rdb$character_length"];

        if (len != "")
          insert_map["field_type"] += ("(" + len + ")");

        // throw field info into temp table
        //if (!ExecuteInsertStatement(DQTransaction, "temp_data_query", insert_map)) throw(1);

        insert_map["constraint_type"] = column_info_vec[i]["constraint_type"];
        insert_map["owner_name"] = StripTrailing(column_info_vec[i]["owner_name"], " ");
        insert_map["fk_table"] = StripTrailing(column_info_vec[i]["fk_table"], " ");
        insert_map["fk_field"] = StripTrailing(column_info_vec[i]["fk_field"], " ");
        insert_map["indexed_by"] = StripTrailing(column_info_vec[i]["indexed_by"], " ");
        insert_map["constraint_name"] = StripTrailing(column_info_vec[i]["constraint_name"], " ");

        table_info.push_back(insert_map);
        //string sql = "select * from temp_data_query";
        //TableInfoFilter.SetSQLStatement(sql);
        //TableInfoFilter.RefreshDataSet();

        listTableInfo->Items->EndUpdate();
      }
    }
    catch (...)
    {
      PSay("Error getting table information.", m_database_error, MB_OK);
    }

    TableInfoListview->import_data(table_info);

    delete IBExtract;
  }
  // Was testing some new functions...
  //map<string, string> field_map;
  //CreateInsertMap (DQTransaction, treeDataQuery->Selected->Text.c_str(), field_map);
  //PSay(MapToDelimString(field_map, "", "", "; ", "'", "'", "'", "'", "="), m_debug, MB_OK);
}
//---------------------------------------------------------------------------
void TformSpecialDataQuery::FetchData(string sql)
{
  if (!DQTransaction->Active)
    DQTransaction->StartTransaction();

  string plan;
  bool execute_ok = true;
  if (!GetSqlPlan(DQTransaction, sql, plan))
  {
    int return_value = PSay("SQL failed to generate a plan successfully.  The last SQLlib error was:\n\n" + last_sql_lib_error.message + "\n\nExecute this SQL anyways?", m_warning, MB_YESNO);
    if (return_value == IDNO)
      execute_ok = false;
  }

  if(execute_ok)
  {
    committed = false;
    AddQuery(sql);
    TDateTime start_time = Now();
    Processing(true);
    string query_type = LowercaseString(StripLeading(sql, " ").substr(0, 6));
    if (query_type == "select" || LowercaseString(StripLeading(sql, " ").substr(0, 4)) == "with")
    {
      last_select_query = sql;
      DataFilter.SetAutoColumnSpecs(true, btnDataFormatByType->Down);
      DataFilter.SetSQLStatement(sql);
      DataFilter.RefreshDataSet();
      this->Caption = ("Data Query - " + IntToString(DataFilter.GetResultSize()) + " results found (in " +
        Ptime (Now() - start_time).OutTime(military | withsec) + ")").c_str();
    }
    else
    {
      if (!ExecuteStatement(DQTransaction, sql))
      {
        PSay("Error executing query", m_database_error, MB_OK);
        pageDataQuery->ActivePageIndex = 1;
      }
      else last_non_select_query = sql;
    }
    Processing(false);
  }
}
//---------------------------------------------------------------------------
void TformSpecialDataQuery::AddQuery(string sql)
{
  sql_queries.push_back(sql);
  if (current_query == sql_queries.size())
    current_query++;
  else
    current_query = sql_queries.size();
  SetPrevNext();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::btnSqlPreviousClick(TObject *Sender)
{
  current_query--;
  SetPrevNext();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::btnSqlNextClick(TObject *Sender)
{
  current_query++;
  SetPrevNext();
}
//---------------------------------------------------------------------------
void TformSpecialDataQuery::SetPrevNext()
{
  btnSqlPrevious->Enabled = current_query > 0;
  btnSqlNext->Enabled = current_query < sql_queries.size();
  if (current_query == sql_queries.size())
    editSql->Text = "";
  else
    editSql->Text = sql_queries[current_query].c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if(HIBYTE(GetAsyncKeyState(VK_MENU)))  // "VK_MENU" is the Alt key (because that makes sense, you know)
  {
    Handled = true;
    if ((Msg.CharCode == 'e') || (Msg.CharCode == 'E'))
      btnSqlExecute->Click();
    else
      Handled = false;
  }
  else
    Handled = false;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::btnCloseClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::btnDataRefreshClick(TObject *Sender)
{
   //FetchData();
   DataFilter.RefreshDataSet();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::btnSqlExecuteClick(TObject *Sender)
{
   //sql = editSql->Text.c_str();
   pageDataQuery->ActivePageIndex = 1;
   FetchData(editSql->Text.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::btnDataFormatByTypeClick(TObject *Sender)
{
  //FetchData(sql_queries[current_query-1]);
  if (last_select_query != "")
    FetchData(last_select_query);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::btnSqlGeneratePlanClick(TObject *Sender)
{
  if (!DQTransaction->Active)
    DQTransaction->StartTransaction();

  string plan;
  if (GetSqlPlan(DQTransaction, editSql->Text.c_str(), plan))
  {
     plan = TranslateSqlPlan(DQTransaction, plan);
     PSay("SQL validated successfully.  Plan produced: \n\n" + plan, m_message, MB_OK);
  }
  else
     PSay("SQL failed to generate a plan successfully.  The last SQLlib error was:\n\n" + last_sql_lib_error.message, m_message, MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::btnDataShowBlobsClick(TObject *Sender)
{
  btnDataGetTableData->Click();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::btnDataGetTableDataClick(TObject *Sender)
{
  if (!(dq_objects_window->GetActiveList())->Selected)
  {
    PSay("Select something first, maybe?", m_message, MB_OK);
    return;
  }
  string table_name = (dq_objects_window->GetActiveList())->Selected->Caption.c_str();
  try
  {
    dbTable = new TIBTable(NULL);
    dbTable->Database = dbDatabase;
    dbTable->Active = false;
    dbTable->TableName = table_name.c_str();
    dbTable->Active = true;
  }
  catch (...)
  {
    PSay("Unable to initialize TIBTable object.", m_database_error, MB_OK);
    return;
  }

  fieldNames.clear();

  string ft_name;
  for (int i = 0; i != dbTable->Fields->Count; i++)
  {
    TFieldType ft = dbTable->Fields->Fields[i]->DataType;
    switch (ft)
    {
      case ftUnknown:      ft_name = "unknown"; break;
      case ftString:       ft_name = "string"; break;
      case ftSmallint:     ft_name = "smallint"; break;
      case ftInteger:      ft_name = "integer"; break;
      case ftWord:         ft_name = "word"; break;
      case ftBoolean:      ft_name = "boolean"; break;
      case ftFloat:        ft_name = "float"; break;
      case ftCurrency:     ft_name = "currency"; break;
      case ftBCD:          ft_name = "binary-coded decimal"; break;
      case ftDate:         ft_name = "date"; break;
      case ftTime:         ft_name = "time"; break;
      case ftDateTime:     ft_name = "date-time stamp"; break;
      case ftBytes:        ft_name = "bytes"; break;
      case ftVarBytes:     ft_name = "var-bytes"; break;
      case ftAutoInc:      ft_name = "auto-inc"; break;
      case ftBlob:         ft_name = "blob"; break;
      case ftMemo:         ft_name = "memo"; break;
      case ftGraphic:      ft_name = "graphic"; break;
      case ftFmtMemo:      ft_name = "formatted memo"; break;
      case ftParadoxOle:   ft_name = "Paradox OLE"; break;
      case ftDBaseOle:     ft_name = "dBASE OLE"; break;
      case ftTypedBinary:  ft_name = "typed binary"; break;
      case ftCursor:       ft_name = "Oracle output cursor"; break;
      case ftFixedChar:    ft_name = "fixed character"; break;
      case ftWideString:   ft_name = "wide string"; break;
      case ftLargeint:     ft_name = "large integer"; break;
      case ftADT:          ft_name = "abstract data type"; break;
      case ftArray:        ft_name = "array"; break;
      case ftReference:    ft_name = "REF"; break;
      case ftDataSet:      ft_name = "DataSet"; break;
      case ftOraBlob:      ft_name = "Oracle 8 BLOB"; break;
      case ftOraClob:      ft_name = "Oracle 8 CLOB"; break;
      case ftVariant:      ft_name = "variant (unknown/undetermined)"; break;
      case ftInterface:    ft_name = "references to interfaces"; break;
      case ftIDispatch:    ft_name = "references to IDispatch interfaces"; break;
      case ftGuid:         ft_name = "globally unique identifier (GUID) values"; break;
    };

    if (btnDataShowBlobs->Down || ft_name != "blob")
       fieldNames.push_back(StripTrailing(string(dbTable->Fields->Fields[i]->FieldName.c_str()), " "));
  } // for

  //editSql->Text = ("select " + VecToCommaString(fieldNames) + " from " + table_name).c_str();
  pageDataQuery->ActivePageIndex = 1;
  FetchData(("select " + VecToCommaString(fieldNames) + " from " + table_name).c_str());
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::editSqlSelectionChange(TObject *Sender)
{
   staticSQLPosition->Caption = ("cursor row: " + IntToString(editSql->CaretPos.y+1) +
     "; col: " + IntToString(editSql->CaretPos.x+1) + "; abs. pos: " + IntToString(editSql->SelStart)).c_str();

/* TODO -c not_working: Try grabbing the TEdit's handle and catching WM_PASTE or whatever it's called,
   and stripping out rich text that way */
/* TNotifyEvent save_event = editSql->OnSelectionChange;
   editSql->OnSelectionChange = NULL;
   int save_sel_start = editSql->SelStart;
   int save_sel_length = editSql->SelLength;
   editSql->SelStart = 0;
   editSql->SelLength = editSql->Text.Length();
   editSql->SelAttributes->Assign(editSql->DefAttributes);
   editSql->SelStart = save_sel_start;
   editSql->SelLength = save_sel_length;
   editSql->OnSelectionChange = save_event;
*/
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::tabSqlShow(TObject *Sender)
{
  editSql->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::btnDQObjectsClick(TObject *Sender)
{
  dq_objects_window->DrawerExpanded = btnDQObjects->Down;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::ObjectsListChange(TObject *Sender, TListItem *Item, TItemChange Change)
{
  TListView *object_list = (TListView *)Sender;
  string object_type = object_list->Column[0]->Caption.c_str();
  string object_selected;
  if (object_list->Selected)
  {
    object_selected = object_list->Selected->Caption.c_str();
    //PSay("Object changed:  " + object_type + " -> " + object_selected, m_message, MB_OK);
  }
  else
    object_selected = "";

  if ((object_selected != "") && (object_type != previous_object_type || object_selected != previous_object_selected))
  {
    RefreshObjectInfo(object_type, object_selected);
    previous_object_type = object_type;
    previous_object_selected = object_selected;
  }
}
//---------------------------------------------------------------------------
void TformSpecialDataQuery::RefreshObjectInfo(string object_type, string object_selected)
{
  if (object_type == "Domains")
  {
  }
  else if (object_type == "Tables")
  {
    RefreshTableInfo(object_selected);
  }
  else if (object_type == "Views")
  {
    RefreshTableInfo(object_selected);  // works for views too
  }
  else if (object_type == "Indexes")
  {
  }
  else if (object_type == "Stored Procedures")
  {
  }
  else if (object_type == "Generators")
  {
  }
}
//---------------------------------------------------------------------------
void TformSpecialDataQuery::DrawerIsChanging (TformSpecialGeneric * Drawer, bool Expanding)
{
  if (Drawer == dq_objects_window)
    btnDQObjects->Down = dq_objects_window->DrawerExpanded;
  TformSpecialGeneric::DrawerIsChanging(Drawer, Expanding);
  return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::btnSqlCommitClick(TObject *Sender)
{
  if (DQTransaction->Active)
    DQTransaction->Commit();
  committed = true;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::btnSqlRollbackClick(TObject *Sender)
{
  if (DQTransaction->Active)
    DQTransaction->Rollback();
  committed = true;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDataQuery::FormCloseQuery(TObject *Sender,bool &CanClose)
{
  CanClose = true;
  // if we weren't passed a transaction initially (none) or were passed an inactive one
  // then ask them if they want to commit, rollback, or continue working
  if (!committed && received_transaction != tt_active)
  {
    int return_value = PSay("You have executed queries that will be lost if you do not save now.\nWould you like to save your changes?", m_confirmation, MB_YESNOCANCEL);
    // As per standard:  Yes saves and exits, No exits without saving, Cancel just aborts the FormClose
    if (return_value == IDYES)
    {
      if (DQTransaction->Active)
        DQTransaction->Commit();
      if (received_transaction == tt_none) // we created the transaction initially, so clean up.
        delete DQTransaction;
    }
    else if (return_value == IDNO)
    {
      if (DQTransaction->Active)
        DQTransaction->Rollback();
      if (received_transaction == tt_none) // we created the transaction initially, so clean up.
        delete DQTransaction;
    }
    else if (return_value == IDCANCEL)
      CanClose = false;
  }
  // we were passed an active transaction, be nice and return it in the same state.
  if (received_transaction == tt_active)
    if (!DQTransaction->Active)
      DQTransaction->StartTransaction();
}
//---------------------------------------------------------------------------
void TformSpecialDataQuery::Launch(TformSpecialGeneric *modalParent, TIBTransaction *dbTransaction, string sql)
{
  FORM_TRY
    TformSpecialDataQuery *DQ = new TformSpecialDataQuery(NULL, dbTransaction, sql);
    DQ->ShowTaskModal(modalParent);
  FORM_CATCH
}
//---------------------------------------------------------------------------
bool TformSpecialDataQuery::HasPermissionToExecute()
{
  return optionsPermissions["special.data_query"]["enabled"] == "true";
}
//---------------------------------------------------------------------------

