//---------------------------------------------------------------------------

#ifndef codeSpecialDataQueryH
#define codeSpecialDataQueryH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <Ibtable.hpp>
#include <ExtCtrls.hpp>
#include "IBExtract.hpp"
#include "codeDrawerDataQuery.h"
//---------------------------------------------------------------------------
enum transaction_type {tt_none, tt_active, tt_inactive};

class TformSpecialDataQuery : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *btnClose;
        TToolButton *btnDQObjects;
        TToolButton *btnShowRDB;
        TToolButton *div14;
        TPanel *panelRight;
        TPageControl *pageDataQuery;
        TTabSheet *tabObjectInfo;
        TListView *listTableInfo;
        TPanel *panelButtons;
        TSplitter *Splitter2;
        TToolBar *toolTableInfo;
        TToolButton *div7;
        TToolButton *btnObjectInfoRefresh;
        TToolButton *div8;
        TTabSheet *tabData;
        TListView *listData;
        TPanel *panelData;
        TSplitter *Splitter1;
        TToolBar *toolData;
        TToolButton *div13;
        TToolButton *btnDataGetTableData;
        TToolButton *div4;
        TToolButton *btnDataRefresh;
        TToolButton *div5;
        TToolButton *btnDataFormatByType;
        TToolButton *btnDataShowBlobs;
        TToolButton *div6;
        TTabSheet *tabSql;
        TPanel *panelSql;
        TSplitter *splitLeftRight;
        TToolBar *toolSql;
        TToolButton *div1;
        TToolButton *btnSqlExecute;
        TToolButton *btnSqlGeneratePlan;
        TToolButton *div2;
        TToolButton *btnSqlCommit;
        TToolButton *btnSqlRollback;
        TToolButton *div3;
        TPanel *panelEditSQL;
        TBevel *bevelEditSQL;
        TPanel *panelSQLPosition;
        TStaticText *staticSQLPosition;
        TRichEdit *editSql;
        TToolButton *ToolButton1;
        TToolButton *btnSqlPrevious;
        TToolButton *btnSqlNext;
        void __fastcall FormShortCut(TWMKey &Msg, bool &Handled);
        void __fastcall btnCloseClick(TObject *Sender);
        void __fastcall btnDataRefreshClick(TObject *Sender);
        void __fastcall btnSqlExecuteClick(TObject *Sender);
        void __fastcall btnSqlGeneratePlanClick(TObject *Sender);
        void __fastcall btnObjectInfoRefreshClick(TObject *Sender);
        void __fastcall btnDataFormatByTypeClick(TObject *Sender);
        void __fastcall btnDataGetTableDataClick(TObject *Sender);
        void __fastcall btnDataShowBlobsClick(TObject *Sender);
        void __fastcall editSqlSelectionChange(TObject *Sender);
        void __fastcall tabSqlShow(TObject *Sender);
        void __fastcall btnDQObjectsClick(TObject *Sender);
        void __fastcall btnSqlPreviousClick(TObject *Sender);
        void __fastcall btnSqlNextClick(TObject *Sender);
        void __fastcall btnSqlCommitClick(TObject *Sender);
        void __fastcall btnSqlRollbackClick(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
private:	// User declarations
        void __fastcall ObjectsListChange(TObject *Sender, TListItem *Item, TItemChange Change);
        void FetchData(string sql);
        void RefreshTableInfo(string table_name);
        void RefreshObjectInfo(string object_type, string object_selected);
        void AddQuery(string sql);
        void SetPrevNext();

        vector<string> tableNames;
        vector<string> fieldNames;
        TIBTable * dbTable;
        string permission;
        classFilterObject DataFilter;
        edit_listview *TableInfoListview;
        //classFilterObject TableInfoFilter;
        TformDrawerDataQuery *dq_objects_window;
        string previous_object_type;
        string previous_object_selected;

        vector<string> sql_queries;
        unsigned int current_query;
        string last_select_query;
        string last_non_select_query;
        bool committed;
        transaction_type received_transaction;

        TIBTransaction * DQTransaction;
protected:
        void DrawerIsChanging (TformSpecialGeneric * Drawer, bool Expanding);
public:		// User declarations
        __fastcall TformSpecialDataQuery(TComponent* Owner, TIBTransaction *p_dbTransaction = NULL, string p_sql = "");
        static void Launch(TformSpecialGeneric *modalParent, TIBTransaction *dbTransaction, string sql);
        static bool HasPermissionToExecute();
};
//---------------------------------------------------------------------------
extern PACKAGE TformSpecialDataQuery *formSpecialDataQuery;
//---------------------------------------------------------------------------
#endif
