//---------------------------------------------------------------------------

#ifndef codeSpecialDebugH
#define codeSpecialDebugH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>
#include "codeSpecialGeneric.h"
#include "codeQueryMagic.h"
#include "query_factories.h"
#include "codeRubberContainer.h"
#include "codeFrameObservationList.h"
#include "codeSectionsGeneric.h"
#include "codeHalfButton.h"
#include "codeFrameCheckListDropDown.h"
#include "codeBaseDropDown.h"
#include "codeListBoxDropDown.h"

struct random_range
{
 int l;
 int w;
 random_range ()
 {
  Clear();
 }
 virtual void Clear ()
 {
 }
 virtual void ConsiderValue (string v) = 0;
 virtual float CalcValue (string v) = 0;
 virtual string GetMin () = 0;
 virtual string GetMax () = 0;
};

struct date_random_range : public random_range
{
 bool has_v;
 Pdate m;
 Pdate M;
 date_random_range () : random_range ()
 {
 }
 virtual void Clear ()
 {
  has_v = false;
 }
 virtual void ConsiderValue (string v)
 {
  Pdate t(v, global_mode);
  if (!has_v)
  {
   m = t;
   M = t;
   has_v = true;
  } else
  {
   m = min(m, t);
   M = max(M, t);
  }
 }
 virtual float CalcValue (string v)
 {
  if (!has_v)
   return 0.00;
  Pdate t(v, global_mode);
  if (m == M)
   return 0.00;
  return ((t - m) + 0.00) / (M - m);
 }
 virtual string GetMin ()
 {
  return m.OutDate(global_mode);
 }
 virtual string GetMax ()
 {
  return M.OutDate(global_mode);
 }
};

struct float_random_range : public random_range
{
 bool has_v;
 float m;
 float M;
 float_random_range () : random_range ()
 {
 }
 virtual void Clear ()
 {
  has_v = false;
 }
 virtual void ConsiderValue (string v)
 {
  float t = StringToFloat(v);
  if (!has_v)
  {
   m = t;
   M = t;
   has_v = true;
  } else
  {
   m = min(m, t);
   M = max(M, t);
  }
 }
 virtual float CalcValue (string v)
 {
  if (!has_v)
   return 0.00;
  float t = StringToFloat(v);
  if (M - m < 0.01)
   return 0.00;
  return (t - m) / (M - m);
 }
 virtual string GetMin ()
 {
  return FloatToString(m);
 }
 virtual string GetMax ()
 {
  return FloatToString(M);
 }
};

//---------------------------------------------------------------------------
class TformSpecialDebug : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *buttonClose;
        TToolButton *buttonInvisible;
        TSectionsGeneric *sectionFormatAddress;
        TSectionsGeneric *sectionObservations;
        TframeObservationList *frameObservations;
        TEdit *editAddress;
        TLabel *lblWhat;
        TLabel *lblFormattedAddress;
        TSectionsGeneric *sectionForms;
        TButton *buttonIntakeWizard;
        TSectionsGeneric *SectionsGeneric1;
        TComboBox *ComboBox1;
        TDateTimePicker *DateTimePicker1;
        THalfButton *HalfButton1;
        THalfButton *HalfButton2;
        TComboBox *ComboBox2;
        THalfButton *HalfButton3;
        TEdit *Edit1;
        TComboBox *ComboBox3;
        TComboBox *ComboBox4;
        THalfButton *HalfButton4;
        TEdit *Edit2;
        TLabel *Label1;
        TComboBox *ComboBox6;
        TDateTimePicker *DateTimePicker2;
        THalfButton *HalfButton6;
        TComboBox *ComboBox7;
        TComboBox *ComboBox8;
        THalfButton *HalfButton7;
        TComboBox *ComboBox9;
        TComboBox *ComboBox10;
        TEdit *Edit4;
        TComboBox *ComboBox11;
        TComboBox *ComboBox12;
        TEdit *Edit5;
        TComboBox *ComboBox13;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label5;
        TLabel *Label6;
        TLabel *Label7;
        TLabel *Label8;
        TLabel *Label9;
        TComboBox *ComboBox5;
        THalfButton *HalfButton5;
        TLabel *Label10;
        TButton *btnClientReport2;
        TButton *btnFormatAllAddresses;
        TButton *buttonGPRA;
        TButton *btnWorkflow;
        TListBoxDropDown *Bob;
        TSectionsGeneric *sectionConversion;
        TEdit *editDec;
        TLabel *dec;
        TButton *btnToHex;
        TLabel *lblHex;
        TButton *btnToDec;
        TEdit *editHex;
        TButton *btnNewTaskSearch;
        TButton *btnOutcomeReport;
        TButton *btnAssessment;
        TButton *btnAssess2;
        TButton *btnThrowException;
        TButton *btnCrash;
        TSectionsGeneric *SectionsGeneric2;
        TLabel *lblPhysAddress;
        TEdit *editPhysAddr;
        TButton *Button1;
        TEdit *editLogicalAddr;
        void __fastcall buttonCloseClick(TObject *Sender);
        void __fastcall buttonInvisibleClick(TObject *Sender);
        void __fastcall TframeObservationslistObservationsAdvancedCustomDrawSubItem(
          TCustomListView *Sender, TListItem *Item, int SubItem,
          TCustomDrawState State, TCustomDrawStage Stage,
          bool &DefaultDraw);
        void __fastcall editAddressClick(TObject *Sender);
        void __fastcall editAddressChange(TObject *Sender);
        void __fastcall buttonIntakeWizardClick(TObject *Sender);
        void __fastcall btnClientReport2Click(TObject *Sender);
        void __fastcall btnFormatAllAddressesClick(TObject *Sender);
        void __fastcall buttonGPRAClick(TObject *Sender);
        void __fastcall btnWorkflowClick(TObject *Sender);
        void __fastcall btnToHexClick(TObject *Sender);
        void __fastcall btnToDecClick(TObject *Sender);
        void __fastcall btnNewTaskSearchClick(TObject *Sender);
        void __fastcall btnOutcomeReportClick(TObject *Sender);
        void __fastcall btnAssessmentClick(TObject *Sender);
        void __fastcall btnAssess2Click(TObject *Sender);
        void __fastcall btnThrowExceptionClick(TObject *Sender);
        void __fastcall btnCrashClick(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
private:	// User declarations
        vector<random_range*> r;
        bool b;
public:		// User declarations
        __fastcall TformSpecialDebug(TComponent* Owner);
        __fastcall ~TformSpecialDebug();
};
//---------------------------------------------------------------------------
extern PACKAGE TformSpecialDebug *formSpecialDebug;
//---------------------------------------------------------------------------
#endif
