//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialDeletePerson.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialDeletePerson *formSpecialDeletePerson;
//---------------------------------------------------------------------------
__fastcall TformSpecialDeletePerson::TformSpecialDeletePerson(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDeletePerson::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialDeletePerson::btnRunClick(TObject *Sender)
{
  string to_delete = editDelete->Text.c_str();
  if (to_delete == "")
  {
    PSay("Please enter an id number", m_missing_data, MB_OK);
    editDelete->SetFocus();
  }
  else
  {
    Processing(true);

    unsigned int hyphen_at = to_delete.find("-", 0);
    if (hyphen_at == string::npos)
       deletePerson(to_delete);
    else
    {
       string from = StripTrailing(to_delete.substr(0, hyphen_at), " ");
       string to = StripLeading(to_delete.substr(hyphen_at + 1), " ");
       int really_delete = PSay(("Delete people " + from + " to " + to + "?").c_str(), m_confirmation, MB_YESNO);
       if (really_delete == IDYES)
       {
          for (int i = StringToInt(from); i <= StringToInt(to); i++)
             deletePerson(IntToString(i));
       }
    }
  }
}
//---------------------------------------------------------------------------
bool TformSpecialDeletePerson::deletePerson(string to_delete)
{
   bool result = true;
   TIBTransaction * dbTransaction = new TIBTransaction(NULL);

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      vector<map<string, string> > table_list;
      string sql;
      string error;
      string table_name;

      dbTransaction->StartTransaction();
      // download list of tables that have person_id
      sql = "select item from merge_person_types where id > 0 and valid = 1";
      SqlToVecMap(dbTransaction, sql, table_list);
      // update fk triggers in people table
      sql = "update people set person_names_id = 0 where id = " + to_delete;
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating person_names fk in people";
        throw error;
      }
      sql = "update people set affiliations_id = 0 where id = " + to_delete;
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating affiliations fk in people";
        throw error;
      }
      sql = "update people set person_contact_info_id = 0 where id = " + to_delete;
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating person_contact_info fk in people";
        throw error;
      }
      // delete records with this person id from tables downloaded from person_merge_types
      for(vector<map<string, string> >::iterator itr = table_list.begin(); itr != table_list.end(); itr++)
      {
        table_name = LowercaseString((*itr)["item"]);
        if (table_name == "relationships")
        {
          sql = "delete from relationships where person_a_id = " + to_delete;
          if (! ExecuteStatement(dbTransaction, sql))
          {
            error = "Error deleting from relationships";
            throw error;
          }
          sql = "delete from relationships where person_b_id = " + to_delete;
          if (! ExecuteStatement(dbTransaction, sql))
          {
            error = "Error deleting from relationships";
            throw error;
          }
        }
        else if (table_name == "appointments")
        {
          sql = "delete from appointment_viewers where appointment_id in (select appointments.id "
                "from appointments where person_id = " + to_delete + ")";
          if(ExecuteStatement(dbTransaction, sql))
          {
            sql = "delete from appointments where person_id = " + to_delete;
            if(! ExecuteStatement(dbTransaction, sql))
            {
              error = "Error deleting from appointments";
              throw error;
            }
          }
          else
          {
            error = "Error deleting from appointment viewers";
            throw error;
          }
        }
        else
        {
          sql = "delete from " + table_name + " where person_id = " + to_delete;
          if (! ExecuteStatement(dbTransaction, sql))
          {
            error = "Error deleting from " + table_name;
            throw error;
          }
        }
      } // end for
      sql = "delete from people where id = " + to_delete;
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error deleting from people table";
        throw error;
      }
      dbTransaction->Commit();
      editDelete->Text = "";
      editDelete->SetFocus();
      Processing(false);      
    }
    catch (string message)
    {
      Processing(false);
      PSay(message, m_database_error, MB_OK);
      dbTransaction->Rollback();
    }
    catch (...)
    {
      Processing(false);
      result = false;
      dbTransaction->Rollback();
    }

    delete dbTransaction;
    return result;
}
