//---------------------------------------------------------------------------

#ifndef codeSpecialDiabRegistryH
#define codeSpecialDiabRegistryH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include "codeRubberContainer.h"
#include "codePaddedBox.h"
//---------------------------------------------------------------------------
class classFilterRegistrySource : public classFilterSource
{
 private:
  // input
  classFilterObject * FFilter;

  // output
  vector<string> field_names;
  vector<TFieldType> field_types;
  deque<vector<string> > field_values;
  unsigned int row_index;
  map<string, string> sql;
 public:
  classFilterRegistrySource();
  virtual bool Begin(TIBTransaction * dbTransaction);
  virtual unsigned int GetFieldCount();
  virtual bool GetFieldNames(vector<string> & field_vec);
  virtual bool GetFieldTypes(vector<TFieldType> & field_vec);
  virtual bool GetRow(vector<string> & field_vec);
  virtual void End();
  virtual ~classFilterRegistrySource();

  virtual void SetFilter (classFilterObject * f);

  bool only_show_registry_changes;
};
//---------------------------------------------------------------------------
class classFilterNewDiabeticSource : public classFilterSource
{
 private:
  // input
  classFilterObject * FFilter;

  // output
  vector<string> field_names;
  vector<TFieldType> field_types;
  deque<vector<string> > field_values;
  unsigned int row_index;
  map<string, string> sql;
 public:
  classFilterNewDiabeticSource();
  virtual bool Begin(TIBTransaction * dbTransaction);
  virtual unsigned int GetFieldCount();
  virtual bool GetFieldNames(vector<string> & field_vec);
  virtual bool GetFieldTypes(vector<TFieldType> & field_vec);
  virtual bool GetRow(vector<string> & field_vec);
  virtual void End();
  virtual ~classFilterNewDiabeticSource();

  virtual void SetFilter (classFilterObject * f);

  bool only_show_positive_visits;
};
//---------------------------------------------------------------------------
class classFilterAtRiskSource : public classFilterSource
{
 private:
  // input
  classFilterObject * FFilter;

  // output
  vector<string> field_names;
  vector<TFieldType> field_types;
  deque<vector<string> > field_values;
  unsigned int row_index;
  map<string, string> sql;
 public:
  classFilterAtRiskSource();
  virtual bool Begin(TIBTransaction * dbTransaction);
  virtual unsigned int GetFieldCount();
  virtual bool GetFieldNames(vector<string> & field_vec);
  virtual bool GetFieldTypes(vector<TFieldType> & field_vec);
  virtual bool GetRow(vector<string> & field_vec);
  virtual void End();
  virtual ~classFilterAtRiskSource();

  virtual void SetFilter (classFilterObject * f);

  bool only_show_positive_visits;
};
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
class TformSpecialDiabRegistry : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *btnRefreshAll;
        TToolButton *btnCantSeeMe;
        TPaddedBox *padEverything;
        TPageControl *pageRegistry;
        TTabSheet *sheetWelcome;
        TPaddedBox *padWelcome;
        TRichEdit *richWelcome;
        TTabSheet *sheetRegistry;
        TRubberContainer *rubberRegistry;
        TListView *listRegistry;
        TPanel *panelRegistry;
        TTabSheet *sheetNewDiabetics;
        TRubberContainer *rubberNewDiabetics;
        TListView *listNewDiabetics;
        TPanel *panelNewDiabetics;
        TTabSheet *sheetAtRisk;
        TRubberContainer *rubberAtRisk;
        TListView *listAtRisk;
        TPanel *panelAtRisk;
        TLabel *lblRefreshRegistry;
        TButton *btnRefreshRegistry;
        TLabel *lblRefreshNewDiabetics;
        TButton *btnRefreshNewDiabetics;
        TLabel *lblRefreshAtRisk;
        TButton *btnRefreshAtRisk;
        TPanel *panelRegistryControls;
        TCheckBox *checkRegistryChanges;
        TPanel *panelNewDiabeticControls;
        TCheckBox *checkNewDiabeticVisits;
        TPanel *panelAtRiskControls;
        TCheckBox *checkAtRiskVisits;
        void __fastcall pageRegistryChange(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall btnRefreshRegistryClick(TObject *Sender);
        void __fastcall btnRefreshNewDiabeticsClick(TObject *Sender);
        void __fastcall btnRefreshAtRiskClick(TObject *Sender);
        void __fastcall btnRefreshAllClick(TObject *Sender);
        void __fastcall checkRegistryChangesClick(TObject *Sender);
        void __fastcall checkNewDiabeticVisitsClick(TObject *Sender);
        void __fastcall checkAtRiskVisitsClick(TObject *Sender);
private:	// User declarations
        vector<string> instructions;
        classFilterRegistrySource * RegistryDataSource;
        classFilterNewDiabeticSource * NewDiabeticDataSource;
        classFilterAtRiskSource * AtRiskDataSource;
        map<string, string> sql;
        TIBTransaction *our_transaction;
        int enrollment_request;
public:		// User declarations
        __fastcall TformSpecialDiabRegistry(TComponent* Owner);
        void EditEnrollment();
        void EditNewDiabetic();
        void EditAtRisk();
        void DoFilterStuff();
        void SetUpAtlasRequests();
        bool AtlasRefreshListView(int request_num, string matched_value);
};
//---------------------------------------------------------------------------
extern PACKAGE TformSpecialDiabRegistry *formSpecialDiabRegistry;
//---------------------------------------------------------------------------
#endif
