//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialExportActivityReport.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialExportActivityReport *formSpecialExportActivityReport;
//---------------------------------------------------------------------------
__fastcall TformSpecialExportActivityReport::TformSpecialExportActivityReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialExportActivityReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialExportActivityReport::btnRunClick(
      TObject *Sender)
{
  if(editFileName->Text != "")
  {
    toolsStandard->SetFocus();
    string file_name = editFileName->Text.c_str();
    fstream output_file;
    output_file.open(file_name.c_str(), ios::out | ios::trunc);
    if (output_file.is_open())
    {
      string sql;
      TIBTransaction * dbTransaction = new TIBTransaction(NULL);
      TIBDataSet * dbDataSet = new TIBDataSet(NULL);
      TStringList * sqlstmt = new TStringList;

      sql = "select people.id, activities.date_of_activity, activity_code_types.item activity_code, "
            "intensity_types.item intensity, "
            "activities.distance, activities.time_spent, activities.steps "
            "from activities "
            "inner join people on activities.person_id = people.id "
            "inner join activity_code_types on activities.activity_code_id = activity_code_types.id "
            "inner join intensity_types on activities.intensity_id = intensity_types.id "
            "where "
            "exists (select SE.id from enrollment SE " // jhaley: changed steps_member -> enrollment
             "where SE.person_id = people.id and SE.current_id+1 >= 4 and "
             "SE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "STEPS Participant") + "' and "
             "SE.enrollment_status_id = '" + lookupTables->IdOf("enrollment_status_types", "Member") + "') and "
            "activities.date_of_activity >= '" + Pdate(dateBegin->Date).OutDate(mdy | yyyy) + "' and "
            "activities.date_of_activity <= '" + Pdate(dateEnd->Date).OutDate(mdy | yyyy) + "' and "
            "people.current_id >= 3 and activities.current_id >= 3 and "
            "exists (select DCE.id from enrollment DCE "  // jhaley: changed is_diabetes_client -> enrollment
             "where DCE.person_id = people.id and DCE.current_id+1 >= 4 and "
             "DCE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "') "
            "order by people.id, activities.date_of_activity";

      try
      {
        StdTransaction(dbTransaction, dbDatabase);
        dbDataSet->Database = dbDatabase;
        dbDataSet->Transaction = dbTransaction;
        dbDataSet->UniDirectional = false;
        sqlstmt->Clear();
        sqlstmt->Add(sql.c_str());
        dbTransaction->StartTransaction();
        dbDataSet->SelectSQL = sqlstmt;
        dbDataSet->Open();
        output_file << "Id,Date,Activity,Intensity,Time,Distance,Steps\n";
        while (! dbDataSet->Eof)
        {
          output_file << dbDataSet->FieldByName("id")->AsString.c_str() << ","
                      << dbDataSet->FieldByName("date_of_activity")->AsString.c_str() << ","
                      << PrettyString(dbDataSet->FieldByName("activity_code")->AsString.c_str()) << ","
                      << PrettyString(dbDataSet->FieldByName("intensity")->AsString.c_str()) << ","
                      << dbDataSet->FieldByName("time_spent")->AsString.c_str() << ","
                      << dbDataSet->FieldByName("distance")->AsString.c_str() << ","
                      << dbDataSet->FieldByName("steps")->AsString.c_str() << endl;
          dbDataSet->Next();
        }

        dbDataSet->Close();
        dbTransaction->Commit();
        output_file.close();
      }
      catch(...)
      {
        PSay("Could not get info from database.", m_database_error, MB_OK);
      }
      delete dbTransaction;
      delete dbDataSet;
      delete sqlstmt;
      Close();
    }
    else
      PSay("Could not write to the file", m_program_error, MB_OK);
  }
  else
    PSay("Please enter a file name.", m_missing_data, MB_OK);
}
//---------------------------------------------------------------------------
