//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialExportMeasurementReport.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialExportMeasurementReport *formSpecialExportMeasurementReport;
//---------------------------------------------------------------------------
__fastcall TformSpecialExportMeasurementReport::TformSpecialExportMeasurementReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialExportMeasurementReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialExportMeasurementReport::btnRunClick(
      TObject *Sender)
{
  if(editFileName->Text != "")
  {
    toolsStandard->SetFocus();
    string file_name = editFileName->Text.c_str();
    fstream output_file;
    output_file.open(file_name.c_str(), ios::out | ios::trunc);
    if (output_file.is_open())
    {
      string sql;
      TIBTransaction * dbTransaction = new TIBTransaction(NULL);
      TIBDataSet * dbDataSet = new TIBDataSet(NULL);
      TStringList * sqlstmt = new TStringList;

      sql = "select people.id, obs_response_sets.date_of_observation, "
            "people.birth_date, gender_types.item gender, tribe_types.item tribe, "
            "obs_height.response_metric height, "
            "obs_weight.response_metric weight, "
            "obs_waist.response_metric waist, "
            "obs_hip.response_metric hip, "
            "obs_tricep.response_metric tricep, "
            "obs_calf.response_metric calf, "
            "obs_bmi.response_metric bmi "
            "from people "
            "left join affiliations on affiliations.id = people.affiliations_id "
            "left join tribe_types on affiliations.tribe_id = tribe_types.id "
            "left join gender_types on people.gender_id = gender_types.id "
            "inner join obs_response_sets on obs_response_sets.person_id = people.id "
             "left join obs_responses obs_height on obs_height.obs_response_set_id = obs_response_sets.id and obs_height.obs_question_id = 2 "
             "left join obs_responses obs_weight on obs_weight.obs_response_set_id = obs_response_sets.id and obs_weight.obs_question_id = 3 "
             "left join obs_responses obs_waist on obs_waist.obs_response_set_id = obs_response_sets.id and obs_waist.obs_question_id = 4 "
             "left join obs_responses obs_hip on obs_hip.obs_response_set_id = obs_response_sets.id and obs_hip.obs_question_id = 5 "
             "left join obs_responses obs_tricep on obs_tricep.obs_response_set_id = obs_response_sets.id and obs_tricep.obs_question_id = 6 "
             "left join obs_responses obs_calf on obs_calf.obs_response_set_id = obs_response_sets.id and obs_calf.obs_question_id = 7 "
             "left join obs_responses obs_bmi on obs_bmi.obs_response_set_id = obs_response_sets.id and obs_bmi.obs_question_id = 1 "
            "where "
            "exists (select DCE.id from enrollment DCE where DCE.person_id = people.id and DCE.current_id+1 >= 4 and " // jhaley: changed is_diabetes_client -> enrollment
             "DCE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "') and "
            "exists (select SE.id from enrollment SE "    // jhaley: changed steps_member -> enrollment
             "where SE.person_id = people.id and SE.current_id+1 >= 4 and "
             "SE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "STEPS Participant") + "' and "
             "SE.enrollment_status_id = '" + lookupTables->IdOf("enrollment_status_types", "Member") + "') and "
            "obs_response_sets.is_steps_observation = 1 and "
            "obs_response_sets.date_of_observation >= '" + Pdate(dateBegin->Date).OutDate(mdy | yyyy) + "' and "
            "obs_response_sets.date_of_observation <= '" + Pdate(dateEnd->Date).OutDate(mdy | yyyy) + "' and "
            "obs_response_sets.current_id >= 3 and "
            "affiliations.tribe_id not in (0,33,34,53,54,64,90,98) "; // TODO -c MAGIC: tribe_types id's
            "order by people.id, obs_response_sets.date_of_observation";

      try
      {
        StdTransaction(dbTransaction, dbDatabase);
        dbDataSet->Database = dbDatabase;
        dbDataSet->Transaction = dbTransaction;
        dbDataSet->UniDirectional = false;
        sqlstmt->Clear();
        sqlstmt->Add(sql.c_str());
        dbDataSet->SelectSQL = sqlstmt;
        dbDataSet->Open();
        output_file << "Id,Date,Date of Birth,Gender,Tribe,Height,Weight,Waist,Hip,Tricep,Calf,BMI\n";
        while (! dbDataSet->Eof)
        {
          // you know what's funny? it's in debugging this code that I (re?)discovered that this whole block evaluates end-to-front, because of operator precedence. I started with errors about "BMI" and finished with errors about date_of_measurement. pretty cool, eh? (but is it efficient?) -- philip
          output_file << dbDataSet->FieldByName("id")->AsString.c_str() << ","
                      << dbDataSet->FieldByName("date_of_observation")->AsString.c_str() << ","
                      << dbDataSet->FieldByName("birth_date")->AsString.c_str() << ","
                      << PrettyString(dbDataSet->FieldByName("gender")->AsString.c_str()) << ","
                      << PrettyString(dbDataSet->FieldByName("tribe")->AsString.c_str()) << ","
                      << dbDataSet->FieldByName("height")->AsString.c_str() << ","
                      << dbDataSet->FieldByName("weight")->AsString.c_str() << ","
                      << dbDataSet->FieldByName("waist")->AsString.c_str() << ","
                      << dbDataSet->FieldByName("hip")->AsString.c_str() << ","
                      << dbDataSet->FieldByName("tricep")->AsString.c_str() << ","
                      << dbDataSet->FieldByName("calf")->AsString.c_str() << ", "
                      << dbDataSet->FieldByName("bmi")->AsString.c_str() << endl;
          dbDataSet->Next();
        }

        dbDataSet->Close();
        dbTransaction->Commit();
        output_file.close();
      }
      catch(...)
      {
        PSay("Could not get info from database.", m_database_error, MB_OK);
      }
      delete dbTransaction;
      delete dbDataSet;
      delete sqlstmt;
      Close();
    }
    else
      PSay("Could not write to the file", m_program_error, MB_OK);
  }
  else
    PSay("Please enter a file name.", m_missing_data, MB_OK);
}
//---------------------------------------------------------------------------
