//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialGPRA.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialGPRA *formSpecialGPRA;
//---------------------------------------------------------------------------
__fastcall TformSpecialGPRA::TformSpecialGPRA(TComponent* Owner, string source_table_name)
        : TformSpecialGeneric(Owner)
{
 list_queries.setup_listview(listQueries, false);
 list_queries.add_or_modify_column("query_name", "Name", true, 0, 120, as_text, rawString);
 list_queries.add_or_modify_column("query_definition", "Definition", false, 1, 120, as_text, rawString);
 list_queries.setup_callbacks((TForm*)this, InformForm(&(TformSpecialGPRA::QuerySelected)), NULL);

 list_parameters.setup_listview(listParameters, false);
 list_parameters.add_or_modify_column("param_name", "Name", true, 0, 120, as_text, rawString);
 list_parameters.add_or_modify_column("param_definition", "Definition", false, 1, 120, as_text, rawString);
 list_parameters.setup_callbacks((TForm*)this, InformForm(&(TformSpecialGPRA::ParameterSelected)), NULL);

 list_indicators.setup_listview(listParameters, false);
 list_indicators.add_or_modify_column("indic_name", "Name", true, 0, 120, as_text, rawString);
 list_indicators.add_or_modify_column("indic_type", "Type", true, 1, 60, as_text, rawString);
 list_indicators.add_or_modify_column("indic_definition", "Definition", true, 2, 60, as_text, rawString);
 list_indicators.add_or_modify_column("indic_cnt", "Count", false, 3, 60, as_text, rawString);
 list_indicators.add_or_modify_column("indic_num", "Numerator", false, 4, 60, as_text, rawString);
 list_indicators.add_or_modify_column("indic_den", "Denominator", false, 5, 60, as_text, rawString);
 list_indicators.setup_callbacks((TForm*)this, InformForm(&(TformSpecialGPRA::IndicatorSelected)), NULL);

 FSourceTableName = source_table_name;

 /* I'll need to set up one query context per parameter set, later
 FORM_TRY
  context = new query_context(dbDatabase);
  context->Transaction->Commit();
 FORM_CATCH
 */

 /* I need one of these per query 
 FORM_TRY
  query_container = new TframeQueryContainer(this);
  query_container->Parent = panelQuery;
  query_container->Align  = alClient;
  query_container->Context = context;
  query_container->SourceTableName = FSourceTableName.c_str();
 FORM_CATCH
 */
}
//---------------------------------------------------------------------------
void TformSpecialGPRA::QuerySelected ()
{
 map<string, string> row_data;
 if (!list_queries.get_current_row(row_data))
 {
  row_data["query_name"] = "";
  row_data["query_definition"] = "";
  buttonSaveQuery->Caption = "Add";
 } else
  buttonSaveQuery->Caption = "Save";

 // update controls to reflect data in row_data
 editQueryName->Text = row_data["query_name"].c_str();
 // load it up!
 // row_data["query_definition"];

/*
 TWinControl * wanted_box = FindNextControl(scrollProcedures, true, true, false);
 if (wanted_box && wanted_box->Enabled && IsVisible(wanted_box))
  this->ActiveControl = wanted_box;
*/
}
//---------------------------------------------------------------------------
void TformSpecialGPRA::ParameterSelected ()
{
 map<string, string> row_data;
 if (!list_parameters.get_current_row(row_data))
 {
  row_data["param_name"] = "";
  row_data["param_definition"] = "";
  buttonSaveParameter->Caption = "Add";
 } else
  buttonSaveParameter->Caption = "Save";

 // update controls to reflect data in row_data
 editParameterName->Text = row_data["param_name"].c_str();
 // load it up!
 // row_data["query_definition"];
}
//---------------------------------------------------------------------------
void TformSpecialGPRA::IndicatorSelected ()
{
 map<string, string> row_data;
 if (!list_indicators.get_current_row(row_data))
 {
  row_data["indic_name"] = "";
  row_data["indic_type"] = "";
  row_data["indic_definition"] = "";
  row_data["indic_cnt"] = "";
  row_data["indic_num"] = "";
  row_data["indic_den"] = "";
  buttonSaveIndicator->Caption = "Add";
 } else
  buttonSaveIndicator->Caption = "Save";

 // update controls to reflect data in row_data
 editQueryName->Text = row_data["query_name"].c_str();
 // load it up!
 // row_data["query_definition"];
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialGPRA::buttonAddQueryClick(TObject *Sender)
{
 listQueries->Selected = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialGPRA::buttonAddParameterClick(TObject *Sender)
{
 listParameters->Selected = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialGPRA::buttonAddIndicatorClick(TObject *Sender)
{
 listIndicators->Selected = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialGPRA::buttonRemoveQueryClick(TObject *Sender)
{
 list_queries.remove_current_row(true);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialGPRA::buttonRemoveParameterClick(TObject *Sender)
{
 list_parameters.remove_current_row(true);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialGPRA::buttonRemoveIndicatorClick(TObject *Sender)
{
 list_indicators.remove_current_row(true);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialGPRA::buttonClearQueryClick(TObject *Sender)
{
 list_queries.clear_data();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialGPRA::buttonClearParameterClick(TObject *Sender)
{
 list_parameters.clear_data();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialGPRA::buttonClearIndicatorClick(TObject *Sender)
{
 list_indicators.clear_data();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialGPRA::buttonSaveQueryClick(TObject *Sender)
{
 // check validity here first
 // ...

 map<string, string> row_data;
 row_data["query_name"] = editQueryName->Text.c_str();
 row_data["query_definition"] = "";

 set<string> dupe_columns;
 dupe_columns.insert("query_definition");

 if (list_queries.is_future_duplicate (row_data, dupe_columns))
 {
  PSay("You already have a query named '" + row_data["query_name"] + "'.", m_duplicate_data, MB_OK);
  return;
 }

 dupe_columns.clear();
 dupe_columns.insert("query_name");

 if (list_queries.is_future_duplicate (row_data, dupe_columns))
  if (IDNO == PSay("You already have another query with this exact definition.\nAre you sure you want to save this one anyway?", m_duplicate_data, MB_YESNO))
   return;

 list_queries.add_or_modify_row_data(row_data, false);
 listQueries->Selected = NULL;
}
//---------------------------------------------------------------------------

