//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialGeneralJournal.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialGeneralJournal *formSpecialGeneralJournal;
//---------------------------------------------------------------------------
__fastcall TformSpecialGeneralJournal::TformSpecialGeneralJournal(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
 this->IconIndex = 0;
/*  these are in allsymbols.h!
#define acc_none           0
#define acc_budget         1
#define acc_non_budget     2
#define acc_yearly         4
#define acc_non_yearly     8
#define acc_closed        16
#define acc_non_closed    32
#define acc_cash          64
#define acc_payable      128
#define acc_receivable   256
#define acc_revenue      512
#define acc_expense     1024
#define acc_equity      2048
#define acc_asset       4096
#define acc_indirect    8192
*/
 acceptable_payments = acc_none;
// acceptable_payments |= acc_non_budget;  // take care of this below based on check box
 acceptable_payments |= acc_non_closed;
 acceptable_payments |= acc_non_yearly;
 acceptable_payments |= acc_yearly;
 acceptable_payments |= acc_expense;
 acceptable_payments |= acc_receivable;

 acceptable_offset_payments = acc_none;
 acceptable_offset_payments |= acc_non_budget;
 acceptable_offset_payments |= acc_non_closed;
 acceptable_offset_payments |= acc_non_yearly;
 acceptable_offset_payments |= acc_yearly;
 acceptable_offset_payments |= acc_payable;
 acceptable_offset_payments |= acc_revenue;
 acceptable_offset_payments |= acc_expense;
 acceptable_offset_payments |= acc_receivable;
 acceptable_offset_payments |= acc_cash;
 acceptable_offset_payments |= acc_equity;

 cboType->Items->Add("");
 cboType->Items->Add("accounts payable");
 cboType->Items->Add("accounts receivable");
 cboType->Items->Add("cash");
 cboType->Items->Add("equity");
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialGeneralJournal::buttonAddPaymentClick(
      TObject *Sender)
{
 // setup account
 map<string, string> wanted_account = PartsByMask (editAccount);
 bool looking_for_budget= (cbIsBudget->Checked);
 acc_info requested_account = InfoByParts (wanted_account, looking_for_budget);

 // setup amounts
 string given_debit_amount = AmountToString(editDebitAmount->Text.c_str());
 string given_credit_amount = AmountToString(editCreditAmount->Text.c_str());

 // setup offset account
 map<string, string> wanted_offset_account = PartsByMask (editOffsetAccount);
 bool looking_for_offset_budget = 0; // a budget account should never be the offset account on this screen
 acc_info requested_offset_account = InfoByParts (wanted_offset_account, looking_for_offset_budget);

 // setup offset amounts
 string given_offset_debit_amount = AmountToString(editOffsetDebitAmount->Text.c_str());
 string given_offset_credit_amount = AmountToString(editOffsetCreditAmount->Text.c_str());

 if (requested_account.Matches(acceptable_payments) && requested_offset_account.Matches(acceptable_offset_payments))
 {
  if (StringToFloat(given_debit_amount) > 0.00)
  {
    if (StringToFloat(given_credit_amount) != 0.00)
    {
      PSay("You may not enter an amount for both the credit and the debit.", m_invalid_data, MB_OK);
      return;
    }
    if (StringToFloat(given_offset_debit_amount) > 0.00)
    {
      PSay("You may not have a debit transaction for both your account and offset account.", m_invalid_data, MB_OK);
      return;
    }
    if (StringToFloat(given_offset_credit_amount) != StringToFloat(given_debit_amount))
    {
      PSay("Your credit in your offset account must equal your debit in the regular account.", m_invalid_data, MB_OK);
      return;
    }
  }
  if (StringToFloat(given_credit_amount) > 0.00)
  {
    if (StringToFloat(given_debit_amount) != 0.00)
    {
      PSay("You may not enter an amount for both the credit and the debit.", m_invalid_data, MB_OK);
      return;
    }
    if (StringToFloat(given_offset_credit_amount) > 0.00)
    {
      PSay("You may not have a credit transaction for both your account and offset account.", m_invalid_data, MB_OK);
      return;
    }
    if (StringToFloat(given_offset_debit_amount) != StringToFloat(given_credit_amount))
    {
      PSay("Your debit in your offset account must equal your credit in the regular account.", m_invalid_data, MB_OK);
      return;
    }
  }
  // if we have made it this far we are probably safe, but I am leaving the block here for another if statement just in case
  {
   TListItem * new_row = NULL;
   bool is_new = false;
   if (listAmounts->Selected)
   {
     new_row = listAmounts->Selected;
   }
   else
   {
    new_row = listAmounts->Items->Add();
    is_new = true;
   }
   if (new_row)
   {
    new_row->Caption = editAccount->Text;
    new_row->SubItems->Clear();
    new_row->SubItems->Add((StringToAmount(given_debit_amount)).c_str());
    new_row->SubItems->Add((StringToAmount(given_credit_amount)).c_str());
    new_row->SubItems->Add((editReason->Text.c_str()));
    new_row->SubItems->Add("No");   // this is not the offset
      if (is_budget)
        new_row->SubItems->Add("Yes");  // this is the budget account
      else
        new_row->SubItems->Add("No");   // this is not the budget account
    new_row->SubItems->Add(requested_account.id.c_str());
    listAmounts->Selected = NULL;
    editAccount->Text = "000-0000000-000-000";
    editDebitAmount->Text = "0.00";       
    editCreditAmount->Text = "0.00";

    // do offset row
    if (is_new)
    {
      new_row = listAmounts->Items->Add();
    }
    else
    {
      new_row = listAmounts->Items->Item[new_row->Index + 1];
    }
    if (new_row)
    {
      new_row->Caption = editOffsetAccount->Text;
      new_row->SubItems->Clear();
      new_row->SubItems->Add((StringToAmount(given_offset_debit_amount)).c_str());
      new_row->SubItems->Add((StringToAmount(given_offset_credit_amount)).c_str());
      new_row->SubItems->Add((editReason->Text.c_str()));
      new_row->SubItems->Add("Yes");  // this is the offset
      new_row->SubItems->Add("No");   // this is not the budget account
      new_row->SubItems->Add(requested_offset_account.id.c_str());
      listAmounts->Selected = NULL;
      editOffsetAccount->Text = "000-0000000-000-000";
      editOffsetDebitAmount->Text = "0.00";
      editOffsetCreditAmount->Text = "0.00";
    }

    // reset the screen for the next entry
    if(cbIsBudget->Checked)
    {
     cboType->Text = "equity";
     typePanel->Enabled = false;
    }
    else
    {
     cboType->Text = "";
     typePanel->Enabled = true;
    }
    editReason->Text = "";
    editAccount->SetFocus();

   }
   else
   {
     PSay("Cannot add row.", m_database_error, MB_OK);
   }
  }
 }
 else
 {
  PSay("The account you have specified either does not exist,\nor cannot be referenced on this screen.", m_missing_data, MB_OK);
  editAccount->SetFocus();
 }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialGeneralJournal::buttonDeletePaymentClick(
      TObject *Sender)
{
  TListItem * row = NULL;
  if (listAmounts->Selected)
  {
    row = listAmounts->Selected;

    if (string(row->SubItems->Strings[3].c_str()) == "No")
    {
      row = listAmounts->Items->Item[row->Index + 1];
      row->Delete();
      row = NULL;
    }
    else if (string(row->SubItems->Strings[3].c_str()) == "Yes")
    {
      row = listAmounts->Items->Item[row->Index - 1];
      row->Delete();
      row = NULL;
    }
    listAmounts->Selected->Delete();
    listAmounts->Selected = NULL;

    editAccount->Text = "000-0000000-000-000";
    editDebitAmount->Text = "0.00";
    editCreditAmount->Text = "0.00";
    editOffsetAccount->Text = "000-0000000-000-000";
    editOffsetDebitAmount->Text = "0.00";
    editOffsetCreditAmount->Text = "0.00";

    // reset the screen for the next entry
    if(cbIsBudget->Checked)
    {
     cboType->Text = "equity";
     typePanel->Enabled = false;
    }
    else
    {
     cboType->Text = "";
     typePanel->Enabled = true;
    }
    editReason->Text = "";
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialGeneralJournal::listAmountsSelectItem(
      TObject *Sender, TListItem *Item, bool Selected)
{
 if (listAmounts->SelCount)
 {
/*
  //PSay("Modifying!", m_message, MB_OK);
  edit_account->Text = listAmounts->Selected->Caption;
  editDebitAmount->Text = listAmounts->Selected->SubItems->Strings[0];  
  editCreditAmount->Text = listAmounts->Selected->SubItems->Strings[1];
  editReason->Text = listAmounts->Selected->SubItems->Strings[2];
*/
 }
 else // otherwise, they unselected, so we want a new one entered
 {
    editAccount->Text = "000-0000000-000-000";
    editDebitAmount->Text = "0.00";
    editCreditAmount->Text = "0.00";
    editOffsetAccount->Text = "000-0000000-000-000";
    editOffsetDebitAmount->Text = "0.00";
    editOffsetCreditAmount->Text = "0.00";
    cboType->Text = "";
    editReason->Text = "";
 }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialGeneralJournal::btnSetOffsetClick(
      TObject *Sender)
{
 string type = cboType->Text.c_str();
 if (type == "ar" ||
     type == "accounts receivable" ||
     type == "a/r" ||
     type == "ap" ||
     type == "accounts payable" ||
     type == "a/p" ||
     type == "cash" ||
     type == "equity")
 {
   // validate and set amounts
   if(string(editDebitAmount->Text.c_str()) != "0.00" && string(editCreditAmount->Text.c_str()) != "0.00")
   {
     PSay("You may not enter an amount in both the debit and credit fields.", m_invalid_data, MB_OK);
     return;
   }
   else if(string(editDebitAmount->Text.c_str()) != "0.00")
   {
     editOffsetCreditAmount->Text = editDebitAmount->Text;
   }
   else if(string(editCreditAmount->Text.c_str()) != "0.00")
   {
     editOffsetDebitAmount->Text =  editCreditAmount->Text;
   }
   else
   {
     PSay("You did not enter an amount.", m_missing_data, MB_OK);
     return;
   }

   // make sure they aren't trying to beat the original if check
   if (type == "equity" && (!cbIsBudget->Checked))
   {
     PSay("Only budget accounts may offset to equity.", m_invalid_data, MB_OK);
     return;
   }
   else if (type == "equity" && (cbIsBudget->Checked))
   {
     type = "balance";
   }

   // simplify later coding
   if (type == "accounts receivable" || type == "a/r")
     type = "ar";
   if (type == "accounts payable" || type == "a/p")
     type = "ap";

   // get the account parts (eg fund, line item, dept, and sub-dept) then set whether budget or non-budget is acceptable
   map<string, string> wanted_account = PartsByMask (editAccount);
   if (cbIsBudget->Checked)
      acceptable_payments |= acc_budget;
   else
      acceptable_payments |= acc_non_budget;
   bool looking_for_budget = (cbIsBudget->Checked);
   acc_info requested_account = InfoByParts (wanted_account, looking_for_budget);

   // Jennifer wants an expense account to be able to offset to a revenue account to handle things like correctly Carolyn's cell phone bill
   string offset_account;
   if (requested_account.GetType() == expense_acc && type == "ar")
   {
     int answer = PSay("Are you sure you want a receivable offset for an EXPENSE account?", m_confirmation, MB_YESNO);
     if (answer == IDNO)
       return;
     map<string, string> account_parts = PartsByMask (editAccount);
     string fund_num = account_parts["one"];
     string gl_num = GetOneField(dbDatabase, "select short_item from acc_level_two where item = \'Accounts Receivable\'");
     string dept = "000";                       // ar and ap never keep track of dept
     string sub_dept = "000";                   // ar and ap never keep track of dept
     offset_account = fund_num + "-" + gl_num + "-" + dept + "-" + sub_dept;
     editOffsetAccount->Text = offset_account.c_str();
     return;
   }
   else if (requested_account.GetType() == revenue_acc && type == "ap")
   {
     int answer = PSay("Are you sure you want a payable offset for a REVENUE account?", m_confirmation, MB_YESNO);
     if (answer == IDNO)
       return;
     map<string, string> account_parts = PartsByMask (editAccount);
     string fund_num = account_parts["one"];
     string gl_num = GetOneField(dbDatabase, "select short_item from acc_level_two where item = \'Accounts Payable\'");
     string dept = "000";                       // ar and ap never keep track of dept
     string sub_dept = "000";                   // ar and ap never keep track of dept
     offset_account = fund_num + "-" + gl_num + "-" + dept + "-" + sub_dept;
     editOffsetAccount->Text = offset_account.c_str();
     return;
   }
   else     // else it is a regular entry and us Philip's function to get the offset
   {
     if (type == "ar" || type == "ap")
       type = "pending";
     type += "_account_id";

     offset_account = EquivAccount (StringToLinkType(type), requested_account.id);
     if (offset_account == "")
     {
       PSay("The account you have specified either does not exist,\nor cannot be referenced on this screen.", m_missing_data, MB_OK);
       return;
     }
     string sql =  "select name from accounts where id = " + offset_account;
     editOffsetAccount->Text = GetOneField(dbDatabase, sql).c_str();
   }

   // setup budget
   if (cbIsBudget->Checked)
   {
     is_budget = true;
   }
   else
   {
     is_budget = false;
   }
 }
 else
 {
   PSay("The type you entered is invalid.\nThe valid accounts are:"
       "\naccounts payable\naccounts receivable\ncash\nequity", m_invalid_data, MB_OK);
 }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialGeneralJournal::btnCancelClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialGeneralJournal::brnFinishClick(TObject *Sender)
{
 // finish
 int user_answer = PSay("This change could be difficult to undo. Please make sure you truly intended this action.", m_confirmation, MB_YESNO);
 if (user_answer == IDNO)
  return;

 TIBTransaction * dbTransaction = new TIBTransaction(NULL);
 try
 {
  dbTransaction->DefaultDatabase = dbDatabase;
  dbTransaction->DefaultAction = TARollback;
  dbTransaction->StartTransaction();

  string current_transaction_number = GetNextId(dbTransaction, "transact_number");
  TListItem * current_row = NULL;

  string task_id     = "0";
  string provider_id = "0";
  string bill_id     = "0";

  map<string, string> insert_transaction;
  insert_transaction["current_id"] = "4";
  insert_transaction["last_update_stamp"] = RightNow();
  insert_transaction["last_updated_by"] = current_userid;
  insert_transaction["task_id"] = task_id;
  insert_transaction["bill_id"] = bill_id;
  insert_transaction["tax_entity_id"] = provider_id;
  insert_transaction["effective_date"] = CurrentDate(); // TODO: EFFECTIVE_DATE
  insert_transaction["credit_amount"] = "0.00";
  insert_transaction["debit_amount"] = "0.00";
  insert_transaction["transaction_number"] = current_transaction_number;

  for (int i = 0; i < listAmounts->Items->Count; i++)
  {
   current_row = listAmounts->Items->Item[i];

   insert_transaction["id"] = GetNextId(dbTransaction, "transactions");
   insert_transaction["note"] = current_row->SubItems->Strings[2].c_str();
   insert_transaction["account_id"] = current_row->SubItems->Strings[5].c_str();
   insert_transaction["debit_amount"] = AmountToString(current_row->SubItems->Strings[0].c_str());
   insert_transaction["credit_amount"] = AmountToString(current_row->SubItems->Strings[1].c_str());

   if (!ExecuteInsertStatement(dbTransaction, "transactions", insert_transaction))
    throw (3);
  }
  dbTransaction->Commit();
  Close();
 }
 catch (...)
 {
  if (dbTransaction->Active)
   dbTransaction->Rollback();
  PSay("Couldn't modify the accounts payable related to this item, internal error.", m_database_error, MB_OK);
 }
 delete dbTransaction;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialGeneralJournal::cbIsBudgetClick(
      TObject *Sender)
{
  if(cbIsBudget->Checked)
  {
   cboType->ItemIndex = 4;
   typePanel->Enabled = false;
  }
  else
  {
   cboType->ItemIndex = 0;
   editOffsetAccount->Text = "";
   editOffsetDebitAmount->Text = "0.00";
   editOffsetCreditAmount->Text = "0.00";
   typePanel->Enabled = true;
  }
}
//---------------------------------------------------------------------------
