//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialHL7Settings.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialHL7Settings *formSpecialHL7Settings;
//---------------------------------------------------------------------------
__fastcall TformSpecialHL7Settings::TformSpecialHL7Settings(TComponent* Owner, hl7_batch & _batch)
        : TformSpecialGeneric(Owner), batch(_batch)
{
 // fill in screen from batch object
 batch_to_screen(batch);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialHL7Settings::buttonSaveClick(TObject *Sender)
{
 // save batch object from screen
 hl7_batch temp;
 if (screen_to_batch(temp))
 {
  batch = temp;
  Close();
 }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialHL7Settings::buttonFetchBatchNumberClick(TObject *Sender)
{
 // fetch a new number, yo!
 editBatchNumber->Text = GetNextId(dbDatabase, "hl7_batch").c_str(); // "hl7_batch_gen"
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialHL7Settings::buttonCancelClick(TObject *Sender)
{
 // cancel without saving
 Close();
}
//---------------------------------------------------------------------------
void TformSpecialHL7Settings::batch_to_screen (hl7_batch b)
{
 editElementCharacter->Text      = b.GetSeparator(hl7_element).c_str();
 editRepetitionCharacter->Text   = b.GetSeparator(hl7_repetition).c_str();
 editComponentCharacter->Text    = b.GetSeparator(hl7_component).c_str();
 editSubComponentCharacter->Text = b.GetSeparator(hl7_subcomponent).c_str();
 editEscapeCharacter->Text       = b.GetEscapeSequence().c_str();

 editBatchNumber->Text           = b.batch_number.c_str();
 editResendBatchNumber->Text     = b.resend_batch_number.c_str();
 editSendingApplication->Text    = b.sending_application.c_str();
 editSendingFacility->Text       = b.sending_facility.c_str();
 editSendingFacilityId->Text     = b.sending_facility_id.c_str();
 editReceivingApplication->Text  = b.receiving_application.c_str();
 editReceivingFacility->Text     = b.receiving_facility.c_str();
 editComment->Text               = b.comment.c_str();
 comboStatus->Text               = b.status.c_str(); // TODO: drop-down, possible values, etc.
 editVersion->Text               = b.version.c_str();
}
//---------------------------------------------------------------------------
bool TformSpecialHL7Settings::screen_to_batch (hl7_batch & b)
{
 b.separators.clear(); // TODO: a bit messy to do it this way, would be nicer if it were more OO somehow

 b.SetSeparator(hl7_segment, "\n"); // DONE: is this the correct escape value? - jhaley: Apparently so.

 if (!b.SetSeparator(hl7_element, editElementCharacter->Text.c_str()))
 {
  PSay("Element character invalid or duplicated elsewhere.", m_invalid_data, MB_OK);
  return false;
 }

 if (!b.SetSeparator(hl7_repetition, editRepetitionCharacter->Text.c_str()))
 {
  PSay("Repetition character invalid or duplicated elsewhere.", m_invalid_data, MB_OK);
  return false;
 }

 if (!b.SetSeparator(hl7_component, editComponentCharacter->Text.c_str()))
 {
  PSay("Component character invalid or duplicated elsewhere.", m_invalid_data, MB_OK);
  return false;
 }

 if (!b.SetSeparator(hl7_subcomponent, editSubComponentCharacter->Text.c_str()))
 {
  PSay("Sub-component character invalid or duplicated elsewhere.", m_invalid_data, MB_OK);
  return false;
 }

 if (! b.SetEscapeSequence(editEscapeCharacter->Text.c_str()))
 {
  PSay("Escape character invalid or duplicated elsewhere.", m_invalid_data, MB_OK);
  return false;
 }

 // TODO: validation?
 b.batch_number          = editBatchNumber->Text.c_str();
 b.resend_batch_number   = editResendBatchNumber->Text.c_str();
 b.sending_application   = editSendingApplication->Text.c_str();
 b.sending_facility      = editSendingFacility->Text.c_str();
 b.sending_facility_id   = editSendingFacilityId->Text.c_str();
 b.receiving_application = editReceivingApplication->Text.c_str();
 b.receiving_facility    = editReceivingFacility->Text.c_str();
 b.comment               = editComment->Text.c_str();
 b.status                = comboStatus->Text.c_str();
 b.version               = editVersion->Text.c_str();

 return true;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialHL7Settings::buttonDefaultsClick(
      TObject *Sender)
{
 // reset!
 hl7_batch defaults;
 batch_to_screen(defaults);
}
//---------------------------------------------------------------------------

