//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialHandleCob.h"
#include "codeRecordCobRequest.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialHandleCob *formSpecialHandleCob;
//---------------------------------------------------------------------------
__fastcall TformSpecialHandleCob::TformSpecialHandleCob(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  this->IconIndex = 8;
  string sql;

  sql = "select level_types.item, cast(cob_requests.last_update_stamp as date), "
        "person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix, "
        "cob_requests.diagnosis, cob_requests.services_required, tax_entities.name, "
        "cob_requests.current_id, cob_requests.id "
        "from cob_requests, level_types, tax_entities, people "
        "left join person_names on people.person_names_id = person_names.id "
        "where cob_requests.level_id = level_types.id and "
        "cob_requests.tax_entity_id = tax_entities.id and "
        "cob_requests.person_id = people.id and "
        "cob_requests.cob_created = 0";

  cob_filter.SetListViewHandle(listRequests);
  cob_filter.SetSecurity("cob_requests");
  cob_filter.AddColumnSpec("Level", "cob_requests", as_text, true, 90);
  cob_filter.AddColumnSpec("Date", "cob_requests", as_text, true, 90);
  cob_filter.AddColumnSpec("Patient", "cob_requests", as_text, true, 110);
  cob_filter.AddColumnSpec("Diagnosis", "cob_requests", as_text, true, 150);
  cob_filter.AddColumnSpec("Service Requested", "cob_requests", as_text, true, 160);
  cob_filter.AddColumnSpec("Referrer", "cob_requests", as_text, true, 120, rawString);
  cob_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  cob_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  cob_filter.FetchPreferences("specialhandlecob.cob_filter");
  cob_filter.SetHeader(true);
  cob_filter.SetIconStatus(true);
  cob_filter.SetSQLStatement(sql);
  cob_filter.RefreshDataSet();
  cob_filter.SetAddEdit(this, NULL, EditRecord(&(TformSpecialHandleCob::EditRequest)));
  cob_request = atlas->RequestNotificationWhen("cob_requests.id", "", rel_any, as_int, this,
                       RefreshHandler(&(TformSpecialHandleCob::AtlasRefreshListView)));
  timer->Enabled = true;
}
//---------------------------------------------------------------------------
void TformSpecialHandleCob::EditRequest()
{
  map<string, string> temp_map;
  temp_map["id"] = cob_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordCobRequest * edit_request = new TformRecordCobRequest(NULL, temp_map);
    edit_request->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformSpecialHandleCob::AtlasRefreshListView(int request_num, string matched_value)
{
  if(request_num == cob_request)
    cob_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialHandleCob::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialHandleCob::timerTimer(TObject *Sender)
{
  cob_filter.RefreshDataSet();        
}
//---------------------------------------------------------------------------

