//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialHtmlPreview.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma link "SHDocVw_OCX"
#pragma resource "*.dfm"
TformSpecialHtmlPreview *formSpecialHtmlPreview;
//---------------------------------------------------------------------------
__fastcall TformSpecialHtmlPreview::TformSpecialHtmlPreview(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
 please_restore = false;
 close_count = 0;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialHtmlPreview::buttonCloseClick(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialHtmlPreview::SetURL (string Value)
{
 webPreview->Navigate(WideString(Value.c_str()));
}
//---------------------------------------------------------------------------
void TformSpecialHtmlPreview::PrintPreview()
{
 GrabHeaderFooterSettings();
 SetHeaderFooterSettings();
 webPreview->ExecWB(Shdocvw_tlb::OLECMDID_PRINTPREVIEW, Shdocvw_tlb::OLECMDEXECOPT_DONTPROMPTUSER, NULL, NULL);
}
//---------------------------------------------------------------------------
void TformSpecialHtmlPreview::Do(string URL)
{
 FORM_TRY
  TformSpecialHtmlPreview * z = new TformSpecialHtmlPreview(NULL);
  z->URL = URL;
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void TformSpecialHtmlPreview::DoPrintPreview(string URL)
{
 FORM_TRY
  TformSpecialHtmlPreview * z = new TformSpecialHtmlPreview(NULL);
  z->URL = URL;
  // z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialHtmlPreview::buttonPreviewClick(TObject *Sender)
{
 PrintPreview();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialHtmlPreview::timerCloseTimer(TObject *Sender)
{
 // TODO -c HACK: just so we're clear -- this is the worst hack EVAR
 // ... there's no event to tell us the print-preview is done ...
 // ... there's no message to tell us it's done ...
 // ... there's no property to tell us it's done ...
 // ... the command for opening the print-preview remains in state 3 (supported + enabled) the whole time ...
 // ... yes, there are some "not busy" messages, but they could happen a random number of times, based on user actions (print, cancel, print, cancel, close preview, etc.)
 // The following code detects -any- open:
 //  - print preview (actual preview)
 //  - print settings (header, footer, etc.)
 //  - print dialog (# of pages)
 // ... which isn't ideal, but as the window is hidden, we'll just sit here and wait it out.
 // if they have something else open, well, then, we'll stay open until it's -all- gone ...
 // and regardless, P will kill the window when it closes. yay.

 // note that i'm not sure which window handle this returns --
 // in my test, i had an IE window open with print-preview going before running the test,
 // it saw that window handle, unless this window had a print-preview, in which case it saw this one, then back again ...
 // and I'm not seeing a "list all windows of this specified CLASS" function anywhere. just "get one pointer" ...

 HWND h = FindWindow("Internet Explorer_TridentDlgFrame", NULL);
 if (!h)
 {
  close_count++;
  if (close_count > 5) // just to be safe -- seems like it picks up a '0' at first while the window is still being created, even though we enabled this after the call to ExecWB?
   Close();
 }
}
//---------------------------------------------------------------------------
void TformSpecialHtmlPreview::GrabHeaderFooterSettings()
{
 HKEY key;
 if (ERROR_SUCCESS == RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Microsoft\\Internet Explorer\\PageSetup", 0, KEY_ALL_ACCESS, &key))
 {
  header_size = 1024;
  RegQueryValueEx(key, "header", NULL, NULL, previous_header, &header_size);
  footer_size = 1024;
  RegQueryValueEx(key, "footer", NULL, NULL, previous_footer, &footer_size);

  RegCloseKey(key);
 }
 if (ERROR_SUCCESS == RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Microsoft\\Internet Explorer\\Main", 0, KEY_ALL_ACCESS, &key))
 {
  background_size = 1024;
  RegQueryValueEx(key, "Print_Background", NULL, NULL, previous_background, &background_size);

  RegCloseKey(key);
 }
}
//---------------------------------------------------------------------------
void TformSpecialHtmlPreview::RestoreHeaderFooterSettings()
{
 HKEY key;
 please_restore = false;
 if (ERROR_SUCCESS == RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Microsoft\\Internet Explorer\\PageSetup", 0, KEY_ALL_ACCESS, &key))
 {
  RegSetValueEx(key, "header", NULL, REG_SZ, previous_header, header_size);
  RegSetValueEx(key, "footer", NULL, REG_SZ, previous_footer, footer_size);
  RegCloseKey(key);
 }
 if (ERROR_SUCCESS == RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Microsoft\\Internet Explorer\\Main", 0, KEY_ALL_ACCESS, &key))
 {
  RegSetValueEx(key, "Print_Background", NULL, REG_SZ, previous_background, background_size);
  RegCloseKey(key);
 }
}
//---------------------------------------------------------------------------
void TformSpecialHtmlPreview::SetHeaderFooterSettings()
{
 HKEY key;
 please_restore = true;
 if (ERROR_SUCCESS == RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Microsoft\\Internet Explorer\\PageSetup", 0, KEY_ALL_ACCESS, &key))
 {
  string wanted_header = "";
  string wanted_footer = "&b&b&p of &P";
  RegSetValueEx(key, "header", NULL, REG_SZ, wanted_header.c_str(), wanted_header.length() + 1);
  RegSetValueEx(key, "footer", NULL, REG_SZ, wanted_footer.c_str(), wanted_footer.length() + 1);
  RegCloseKey(key);
 }
 if (ERROR_SUCCESS == RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Microsoft\\Internet Explorer\\Main", 0, KEY_ALL_ACCESS, &key))
 {
  string wanted_background = "yes";
  RegSetValueEx(key, "Print_Background", NULL, REG_SZ, wanted_background.c_str(), wanted_background.length() + 1);
  RegCloseKey(key);
 }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialHtmlPreview::FormClose(TObject *Sender,
      TCloseAction &Action)
{
 if (please_restore)
  RestoreHeaderFooterSettings();
 Action = caFree;
 TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialHtmlPreview::webPreviewDocumentComplete(
      TObject *Sender, LPDISPATCH pDisp, TVariant *URL)
{
 // auto-preview if invisible, otherwise don't ... and request to close automatically "later" (whenever convenient)
 if (!(this->Visible))
 {
  PrintPreview();
  timerClose->Enabled = true;
 }
}
//---------------------------------------------------------------------------

