//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialIdleWarning.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialIdleWarning *formSpecialIdleWarning;
//---------------------------------------------------------------------------
__fastcall TformSpecialIdleWarning::TformSpecialIdleWarning(TComponent* Owner)
        : TformSpecialGeneric(Owner), timerAmount(0)
{
}
//---------------------------------------------------------------------------
__fastcall TformSpecialIdleWarning::~TformSpecialIdleWarning()
{
  timerText->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialIdleWarning::timerTextTimer(TObject *Sender)
{
  if(lockState == STATE_COUNTDOWN)
  {
    if(timerAmount > 0)
    {
      timerAmount -= 1;
      lblSeconds->Caption = (IntToString(timerAmount) + " seconds.").c_str();
      //FlashWindow(Handle, TRUE);
    }
    else
    {
      lockState = STATE_LOCKED;
      LockWorkStation();
      timerAmount = 890; // stay in this state for a while (just shy of 15 minutes)
      lblIdleText->Caption   = "Your workstation was locked for security purposes.";
      lblSeconds->Caption    = "";
      lblCancelText->Caption = "Click or close this dialog to continue working.";
    }
  }
  else if(lockState == STATE_LOCKED)
  {
    if(timerAmount > 0) // Count down
      timerAmount -= 1;
    else if(Visible)
      lockState = STATE_WAITING; // Waiting for user to dismiss. Can be reactivated to count down again.
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialIdleWarning::scrollStandardClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void TformSpecialIdleWarning::SetTimerAmount(int seconds)
{
  timerAmount = seconds;

  lblIdleText->Caption   = "Your workstation will be locked due to inactivity in ";
  lblSeconds->Caption    = (IntToString(timerAmount) + " seconds.").c_str();
  lblCancelText->Caption = "Click or close this dialog to cancel this action.";

  FLASHWINFO flwi;
  flwi.cbSize    = sizeof(FLASHWINFO);
  flwi.hwnd      = Handle;
  flwi.dwFlags   = FLASHW_ALL;
  flwi.uCount    = seconds/2;
  flwi.dwTimeout = 1000;
  FlashWindowEx(&flwi);

  lockState = STATE_COUNTDOWN;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialIdleWarning::btnCancelClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialIdleWarning::CreateParams(TCreateParams &Params)
{
  // NB: Bypassing TformSpecialGeneric::CreateParams entirely.
  TForm::CreateParams(Params);
  Params.ExStyle |= (WS_EX_APPWINDOW | WS_EX_TOPMOST);
}
//---------------------------------------------------------------------------
