//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialIntake.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialIntake *formSpecialIntake;
//---------------------------------------------------------------------------
__fastcall TformSpecialIntake::TformSpecialIntake(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
// jhaley 20110125: Moved here from TformPrometheusMenu
void TformSpecialIntake::DoIntake()
{
  Screen->Cursor = crHourGlass;
  TformSpecialIntake *intake_form = NULL;
  FORM_TRY
    intake_form = new TformSpecialIntake(NULL);
  FORM_CATCH
  intake_form->lblGeneralPage->Caption = "Page 1 of 2";
  intake_form->generalInfo->Prepare();
  intake_form->generalInfo->QRPrinter->Save(PMakeTempFilePath("page1.qrp").c_str());
  //intake_form->lblInsurancePage->Caption = "Page 2 of 3";
  //intake_form->insuranceInfo->Prepare();
  //intake_form->insuranceInfo->QRPrinter->Save(PMakeTempFilePath("page2.qrp").c_str());
  intake_form->lblMedicalConsentPage->Caption = "Page 2 of 2";
  //intake_form->consent->Prepare();
  //intake_form->consent->QRPrinter->Save(PMakeTempFilePath("page3.qrp").c_str());
  // They now want the treatment/release/assignment thing to print always, not just release/assignment
  intake_form->medicalConsent->Prepare();
  intake_form->medicalConsent->QRPrinter->Save(PMakeTempFilePath("page2.qrp").c_str());
  intake_form->CloseNow();
  TQRPageList *source = new TQRPageList();
  TQRPageList *destination = new TQRPageList();
  destination->Stream = new TQRStream(100000);
  string file_name;
  for(int i = 1; i <= 2; i++)
  {
    file_name = PMakeTempFilePath(string("page") + IntToString(i) + ".qrp");
    source->Clear();
    source->LoadFromFile(file_name.c_str());
    destination->AddPage(source->GetPage(1));
  }
  // save all files together
  destination->Finish();
  string temp_filepath = PMakeTempFilePath("complete.qrp");
  destination->SaveToFile(temp_filepath.c_str());
  // load combined report and preview
  TQRPrinter *printer_thing = InitTQRPrinter();
  printer_thing->Load(temp_filepath.c_str());
  Screen->Cursor = crDefault;
  printer_thing->PreviewModal();
  delete printer_thing;
  delete source;
  delete destination;
}
//---------------------------------------------------------------------------
// jhaley 20110125: Moved here from TformPrometheusMenu
void TformSpecialIntake::DoIntakeMedHistory()
{
  Screen->Cursor = crHourGlass;
  TformSpecialIntake *intake_form = NULL;
  FORM_TRY
    intake_form = new TformSpecialIntake(NULL);
  FORM_CATCH
  intake_form->lblGeneralPage->Caption = "Page 1 of 3";
  intake_form->generalInfo->Prepare();
  intake_form->generalInfo->QRPrinter->Save(PMakeTempFilePath("page1.qrp").c_str());
  /*
  intake_form->lblInsurancePage->Caption = "Page 2 of 3";
  intake_form->insuranceInfo->Prepare();
  intake_form->insuranceInfo->QRPrinter->Save(PMakeTempFilePath("page2.qrp").c_str());
  */
  intake_form->lblMedicalPage->Caption = "Page 2 of 3";
  intake_form->medicalHistory->Prepare();
  intake_form->medicalHistory->QRPrinter->Save(PMakeTempFilePath("page2.qrp").c_str());
  intake_form->lblMedicalConsentPage->Caption = "Page 3 of 3";
  intake_form->medicalConsent->Prepare();
  intake_form->medicalConsent->QRPrinter->Save(PMakeTempFilePath("page3.qrp").c_str());
  intake_form->CloseNow();
  TQRPageList *source = new TQRPageList();
  TQRPageList *destination = new TQRPageList();
  destination->Stream = new TQRStream(100000);
  string file_name;
  for(int i = 1; i <= 3; i++)
  {
    file_name = PMakeTempFilePath(string("page") + IntToString(i) + ".qrp");
    source->Clear();
    source->LoadFromFile(file_name.c_str());
    destination->AddPage(source->GetPage(1));
  }
  destination->Finish();
  string temp_filepath = PMakeTempFilePath("complete.qrp");
  destination->SaveToFile(temp_filepath.c_str());
  TQRPrinter *printer_thing = InitTQRPrinter();
  printer_thing->Load(temp_filepath.c_str());
  Screen->Cursor = crDefault;
  printer_thing->PreviewModal();
  delete printer_thing;
  delete source;
  delete destination;
}
//---------------------------------------------------------------------------
// jhaley 20110722: New for Optometry intake data
void TformSpecialIntake::DoIntakeMedHistoryOpto()
{
  Screen->Cursor = crHourGlass;
  TformSpecialIntake *intake_form = NULL;
  FORM_TRY
    intake_form = new TformSpecialIntake(NULL);
  FORM_CATCH
  intake_form->lblGeneralPage->Caption = "Page 1 of 4";
  intake_form->generalInfo->Prepare();
  intake_form->generalInfo->QRPrinter->Save(PMakeTempFilePath("page1.qrp").c_str());

  intake_form->lblMedicalPage->Caption = "Page 2 of 4";
  intake_form->medicalHistory->Prepare();
  intake_form->medicalHistory->QRPrinter->Save(PMakeTempFilePath("page2.qrp").c_str());

  intake_form->lblOptoPage->Caption = "Page 3 of 4";
  intake_form->reportOpto->Prepare();
  intake_form->reportOpto->QRPrinter->Save(PMakeTempFilePath("page3.qrp").c_str());

  intake_form->lblMedicalConsentPage->Caption = "Page 4 of 4";
  intake_form->medicalConsent->Prepare();
  intake_form->medicalConsent->QRPrinter->Save(PMakeTempFilePath("page4.qrp").c_str());
  intake_form->CloseNow();

  TQRPageList *source = new TQRPageList();
  TQRPageList *destination = new TQRPageList();
  destination->Stream = new TQRStream(100000);
  string file_name;
  for(int i = 1; i <= 4; i++)
  {
    file_name = PMakeTempFilePath(string("page") + IntToString(i) + ".qrp");
    source->Clear();
    source->LoadFromFile(file_name.c_str());
    destination->AddPage(source->GetPage(1));
  }
  destination->Finish();
  string temp_filepath = PMakeTempFilePath("complete.qrp");
  destination->SaveToFile(temp_filepath.c_str());
  TQRPrinter *printer_thing = InitTQRPrinter();
  printer_thing->Load(temp_filepath.c_str());
  Screen->Cursor = crDefault;
  printer_thing->PreviewModal();
  delete printer_thing;
  delete source;
  delete destination;
}
//---------------------------------------------------------------------------

