//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialLatestInsurance.h"
#include "codeRecordPerson.h"
#include "html_reporting.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialLatestInsurance *formSpecialLatestInsurance;
//---------------------------------------------------------------------------
__fastcall TformSpecialLatestInsurance::TformSpecialLatestInsurance(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
 // filter stuff
 list_insurance.SetListViewHandle(listInsurance);
 list_insurance.SetSecurity("insurance_policies");
 list_insurance.AddColumnSpec("Name", "people", as_text, true, 150);
 list_insurance.AddColumnSpec("CDIB", "affiliations", as_int, true, 60);
 list_insurance.AddColumnSpec("Phone Number", "person_contact_info", as_text, true, 90, prettyPhoneString);
 list_insurance.AddColumnSpec("Insurance Co.", "tax_entities", as_text, true, 120, rawString);
 list_insurance.AddColumnSpec("Policy Number",  "insurance_policies", as_text, true, 100, rawString);
 list_insurance.AddColumnSpec("Policy Start",   "insurance_policies", as_date, true, 90);
 list_insurance.AddColumnSpec("Polciy Stop",    "insurance_policies", as_date, true, 90);
 list_insurance.AddColumnSpec("Cover. Start", "insurance_coverage", as_date, true, 90);
 list_insurance.AddColumnSpec("Cover. Stop",  "insurance_coverage", as_date, true, 90);
 list_insurance.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 list_insurance.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 list_insurance.FetchPreferences("specialupdatesneeded.medicaid_filter");
 // list_insurance.SetCheck(true); // why did i want this?
 list_insurance.SetCompress(true);
 list_insurance.SetAddEdit(this, NULL, EditRecord(&(TformSpecialLatestInsurance::EditPerson)));

 list_insurance_types.SetListViewHandle(listInsuranceTypes);
 list_insurance_types.SetSecurity("insurance_policies");
 list_insurance_types.AddColumnSpec("Type", "insurance_policies", as_text, true, 120);
 list_insurance_types.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 list_insurance_types.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 list_insurance_types.SetCompress(false);
 list_insurance_types.SetIconStatus(false);
 list_insurance_types.SetHeader(false);
 list_insurance_types.SetCheck(true);
 list_insurance_types.FetchPreferences("speciallatestinsurance.types_filter");
 list_insurance_types.SetSQLStatement("select item, 4, id from insurance_types where id > 0");
 list_insurance_types.RefreshDataSet();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLatestInsurance::buttonCloseClick(
      TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
void TformSpecialLatestInsurance::EditPerson()
{
  map<string, string> temp_map;
  temp_map["id"] = list_insurance.GetSelectedRecordID();
  TformRecordPerson::Do(temp_map);
}
//---------------------------------------------------------------------------
void TformSpecialLatestInsurance::RefreshSome()
{
 string sql;

 vector<string> relevant_ins_types;
 string rit;

 vector<string> relevant_tax_entities;
 string rte;

 relevant_ins_types = list_insurance_types.GetMultiID();
 rit = VecToCommaString(relevant_ins_types);
 if (rit.empty())
  rit = "-1";

 if (!SqlToVec(dbDatabase, "select distinct tax_entity_id from insurance_policies where insurance_id in (" + rit + ")", relevant_tax_entities))
  PSay("Failed to retrieve a list of appropriate insurance carriers.", m_database_error, MB_OK);
 rte = VecToCommaString(relevant_tax_entities);
 if (rte.empty())
  rte = "-1";

 sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix, "
       "affiliations.cdib, person_contact_info.phone_number, "
       "tax_entities.name, op.policy_number, "
       "op.start_date, op.stop_date, "
       "oc.start_date, oc.stop_date, "
       "people.current_id, people.id "
       "from people "
       "left join person_names on people.person_names_id = person_names.id "
       "left join affiliations on people.affiliations_id = affiliations.id "
       "left join person_contact_info on people.person_contact_info_id = person_contact_info.id "
       "inner join insurance_coverage oc on ";

 if (!radioOne->Checked)
  sql += "oc.person_id = people.id ";
 else
  sql += "oc.id = "
          "(select first 1 ic.id "
          "from insurance_coverage ic "
          "left join insurance_policies ip on ip.id = ic.insurance_policy_id "
          "where ic.person_id = people.id and ip.tax_entity_id in (" + rte + ") "
          "order by ic.stop_date desc, ip.stop_date, ic.current_id, ip.current_id, ic.start_date desc, ip.start_date) ";

 sql += "inner join insurance_policies op on oc.insurance_policy_id = op.id "
        "left join tax_entities on op.tax_entity_id = tax_entities.id "
        "where "
        "people.death_date is null and "
        "affiliations.tribe_id = " + lookupTables->IdOf("tribe_types", "Absentee Shawnee Tribes of Oklahoma") + " and "
        "exists (select uc.id from insurance_coverage uc inner join insurance_policies up on up.id = uc.insurance_policy_id where uc.person_id = people.id and up.tax_entity_id in (" + rte + "))";

 if (radioSome->Checked)
  sql += " and insurance_policies.tax_entity_id in (" + rte + ")";

 list_insurance.SetSQLStatement(sql);
 list_insurance.RefreshDataSet();
}
//---------------------------------------------------------------------------
void TformSpecialLatestInsurance::Do()
{
 FORM_TRY
  TformSpecialLatestInsurance * z = new TformSpecialLatestInsurance(NULL);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLatestInsurance::buttonRefreshClick(TObject *Sender)
{
 RefreshSome();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLatestInsurance::buttonPrintClick(
      TObject *Sender)
{
 htmlAutoGenerateFilterReport(&list_insurance, "Latest insurance report");
}
//---------------------------------------------------------------------------

