//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialLedger.h"
#include "codeRecordAccount.h"
#include "codeRecordTransaction.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialLedger *formSpecialLedger;
//---------------------------------------------------------------------------
__fastcall TformSpecialLedger::TformSpecialLedger(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
 // set up the viewed_dimensions vector with default 5-level tree.

 pageLedger->ActivePageIndex = 0;

 ResetLevelInfo();
 ResetAccounts();
 RedrawLevelList();
 RedrawLevelDemo();
 RedrawLevelFull();

 // now the first tab ...
 lookupTables->RegisterComboBox("account_types", comboAccountType);

 accounts_filter.SetListViewHandle(listAccounts);
 accounts_filter.SetSecurity("accounts");
 accounts_filter.AddColumnSpec("Account", "accounts", as_text, true, 220);
 accounts_filter.AddColumnSpec("Budget", "accounts", as_text, true, 60, prettyBoolString);
 accounts_filter.AddColumnSpec("Disabled", "accounts", as_text, true, 60, prettyBoolString);
 accounts_filter.AddColumnSpec("Yearly", "accounts", as_text, true, 60, prettyBoolString);
 accounts_filter.AddColumnSpec("Cycle", "accounts", as_text, true, 100);
 accounts_filter.AddColumnSpec("Type", "accounts", as_text, true, 100);
 accounts_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 accounts_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 accounts_filter.FetchPreferences("specialledger.accounts_filter");
 accounts_filter.SetIconStatus(false);
 accounts_filter.SetCheck(true);
 accounts_filter.SetSQLStatement("");
 accounts_filter.RefreshDataSet();
 accounts_filter.SetAddEdit(this, AddRecord(&(TformSpecialLedger::AddAccount)),
                                  EditRecord(&(TformSpecialLedger::EditAccount)));
 accounts_request = atlas->RequestNotificationWhen("accounts.id", "0",
                  rel_any, as_int, this, RefreshHandler(&(TformSpecialLedger::AtlasScreen)));

 transactions_filter.SetListViewHandle(listTransactions);
 transactions_filter.SetSecurity("transactions");
 transactions_filter.AddColumnSpec("Tax Entity", "tax_entities", as_text, true, 120, rawString);
 transactions_filter.AddColumnSpec("Eff. Date", "transactions", as_date, true, 75);
 transactions_filter.AddColumnSpec("Fisc. Date", "transactions", as_date, true, 75);
 transactions_filter.AddColumnSpec("Account", "accounts", as_text, true, 140);
 transactions_filter.AddColumnSpec("Type", "accounts", as_text, true, 75);
 transactions_filter.AddColumnSpec("Note", "transactions", as_text, false, 120, sentenceString);
 transactions_filter.AddColumnSpec("Debit", "transactions", as_double, true, 75, nonzeroAmountString);
 transactions_filter.AddColumnSpec("Credit", "transactions", as_double, true, 75, nonzeroAmountString);
 transactions_filter.AddColumnSpec("Trans #", "transactions", as_int, true, 75);
 transactions_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 transactions_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 transactions_filter.FetchPreferences("specialledger.accounts_filter");
 transactions_filter.SetIconStatus(false);
 transactions_filter.SetSQLStatement("");
 transactions_filter.RefreshDataSet();
 transactions_filter.SetAddEdit(this, NULL, EditRecord(&(TformSpecialLedger::EditTransaction)));
 transactions_request = atlas->RequestNotificationWhen("transactions.id", "0",
                  rel_any, as_int, this, RefreshHandler(&(TformSpecialLedger::AtlasScreen)));
 this->IconIndex = 0;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLedger::buttonSearchAccountsClick(
      TObject *Sender)
{
  // for the second tab
  RedrawLevelFull();

  // for the first tab
  RedrawAccounts();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialLedger::buttonSearchTransactionsClick(
      TObject *Sender)
{
 RedrawTransactions();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialLedger::listViewedDimensionsChange(
      TObject *Sender, TListItem *Item, TItemChange Change)
{
 // maybe they checked / unchecked something, refresh -stuff-
 if (enable_list_checking)
 {
  vector<level_info> viewed_copy = viewed_dimensions;
  viewed_dimensions.clear();
  TListItem * latest_item = NULL;
  for (int i = 0; i < listViewedDimensions->Items->Count; i++)
  {
   latest_item = listViewedDimensions->Items->Item[i];
   viewed_dimensions.push_back(level_info(latest_item->Caption.c_str(),
                                          latest_item->SubItems->Strings[0].c_str(),
                                          latest_item->Checked));
  }
  if (viewed_dimensions != viewed_copy)
  {
   RedrawLevelDemo();
   RedrawLevelFull();
  }
 }
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialLedger::buttonIncreaseDimensionClick(
      TObject *Sender)
{
 // make more important
 if (listViewedDimensions->SelCount)
 {
  string match_with = listViewedDimensions->Selected->Caption.c_str();
  for (unsigned int i = 1; i != viewed_dimensions.size(); i++)
  {
   if (viewed_dimensions[i].level_name == match_with)
   {
    level_info temp_level = viewed_dimensions[i - 1];
    viewed_dimensions[i - 1] = viewed_dimensions[i];
    viewed_dimensions[i] = temp_level;
    break;
   }
  }
  RedrawLevelList();
  RedrawLevelFull();
  RedrawLevelDemo();

  for (int j = 0; j < listViewedDimensions->Items->Count; j++)
   if (listViewedDimensions->Items->Item[j]->Caption == match_with.c_str())
    listViewedDimensions->Items->Item[j]->Selected = true;
  listViewedDimensions->SetFocus();
 }
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialLedger::buttonDecreaseDimensionClick(
      TObject *Sender)
{
 // make less important
 if (listViewedDimensions->SelCount)
 {
  string match_with = listViewedDimensions->Selected->Caption.c_str();
  for (unsigned int i = 0; i != viewed_dimensions.size() - 1; i++)
  {
   if (viewed_dimensions[i].level_name == match_with)
   {
    level_info temp_level = viewed_dimensions[i + 1];
    viewed_dimensions[i + 1] = viewed_dimensions[i];
    viewed_dimensions[i] = temp_level;
    break;
   }
  }
  RedrawLevelList();
  RedrawLevelFull();
  RedrawLevelDemo();

  for (int j = 0; j < listViewedDimensions->Items->Count; j++)
   if (listViewedDimensions->Items->Item[j]->Caption == match_with.c_str())
    listViewedDimensions->Items->Item[j]->Selected = true;
  listViewedDimensions->SetFocus();
 }
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialLedger::buttonResetDimensionClick(
      TObject *Sender)
{
 // reset to default fund/gl/dep/subdep/subacc, all visible
 ResetLevelInfo();
 RedrawLevelList();
 RedrawLevelFull();
 RedrawLevelDemo();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialLedger::treeAccountsClick(TObject *Sender)
{
 // select an account for viewing on the first page
 if (treeAccounts->Selected)
 {
  map<TTreeNode*, string>::iterator i_node = tree_clicking.find(treeAccounts->Selected);
  if (i_node != tree_clicking.end())
  {
   for (vector<account_info>::iterator i_account = accounts.begin();
        i_account != accounts.end(); i_account++)
   {
    if (i_account->id == i_node->second)
    {
     editAccount->Text = i_account->account_pure.c_str();
     comboAccountType->Text = PrettyString(i_account->long_type).c_str();
     checkIsBudget->Checked = i_account->is_budget;
     checkNotIsBudget->Checked = !i_account->is_budget;
     checkIsClosed->Checked = i_account->is_closed;
     checkNotIsClosed->Checked = !i_account->is_closed;
     checkIsYearly->Checked = i_account->is_yearly;
     checkNotIsYearly->Checked = !i_account->is_yearly;
     checkExactMatch->Checked = true;
     break;
    }
   }
  }
  else
  {
   i_node = tree_partial.find(treeAccounts->Selected);
   if (i_node != tree_partial.end())
   {
    editAccount->Text = i_node->second.c_str();
    editAccount->Text = ReplaceAnyCharWithString(string(editAccount->Text.c_str()), " ", "0").c_str();
    comboAccountType->Text = "";
    checkIsBudget->Checked = true;
    checkNotIsBudget->Checked = true;
    checkIsClosed->Checked = true;
    checkNotIsClosed->Checked = true;
    checkIsYearly->Checked = true;
    checkNotIsYearly->Checked = true;
    checkExactMatch->Checked = false;
   }
  }
 }
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialLedger::treeAccountsDblClick(TObject *Sender)
{
 // get more info about said account (yup yup!)
 if (treeAccounts->Selected)
 {
  // PSay(treeAccounts->Selected->Text.c_str(), m_message, MB_OK);
  map<TTreeNode*, string>::iterator i_node = tree_clicking.find(treeAccounts->Selected);
  if (i_node != tree_clicking.end())
  {
   // open up the TformRecordAccounts screen for this id ...
   map<string, string> param_list;
   param_list["id"] = i_node->second;
   FORM_TRY
     TformRecordAccount * account_record = new TformRecordAccount (NULL, param_list);
     account_record->Show();
   FORM_CATCH
  }
 }
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLedger::buttonCloseClick(TObject *Sender)
{
 // close =)
 Close();
}
//---------------------------------------------------------------------------
void TformSpecialLedger::RedrawLevelDemo ()
{
 // redraw the tree-view preview that helps people understand what they're
 // looking at (maybe redundant, but sue me already!)
 treeDemo->Items->Clear();
 TTreeNode * last_used = NULL;
 for (vector<level_info>::iterator i_level = viewed_dimensions.begin();
      i_level != viewed_dimensions.end(); i_level++)
 {
  if (i_level->show_field)
  {
   if (last_used)
    last_used = treeDemo->Items->AddChild(last_used, i_level->level_name.c_str());
   else
    last_used = treeDemo->Items->Add(NULL, i_level->level_name.c_str());
  }
 }

 // now make it expand! wooha
 for (int i = 0; i < treeDemo->Items->Count; i++)
 {
  treeDemo->Items->Item[0]->Expand(true);
 }
 return;
}
//---------------------------------------------------------------------------
void TformSpecialLedger::RedrawLevelList ()
{
 enable_list_checking = false;
 listViewedDimensions->Items->Clear();
 TListItem * latest_item;
 for (vector<level_info>::iterator i_level = viewed_dimensions.begin();
      i_level != viewed_dimensions.end(); i_level++)
 {
  latest_item = listViewedDimensions->Items->Add();
  latest_item->Caption = i_level->level_name.c_str();
  latest_item->SubItems->Add (i_level->field_name.c_str());
  latest_item->Checked = i_level->show_field;
 }
 enable_list_checking = true;
 return;
}
//---------------------------------------------------------------------------
struct where_to_add
{
 TTreeNode * latest_sibling; // add sibling to this if value is different starting here
 string      latest_value;   // last value shown to user
 string      field_name;     // field name to compare on
 where_to_add (TTreeNode * p_latest_sibling, string p_latest_value, string p_field_name) :
  latest_sibling(p_latest_sibling), latest_value(p_latest_value), field_name(p_field_name) {};
};
//---------------------------------------------------------------------------
void TformSpecialLedger::RedrawLevelFull ()
{
 TTreeNode * latest_parent = NULL;   // accounts get added here, not to anything above
 TTreeNode * top_node = NULL;
 string account_to_show;
 string branch_to_show;
 string current_value;
 string current_desc;
 string partial_account;
 vector<where_to_add>::iterator clearing_next;
 vector<where_to_add> tree_building;
 int account_count = 0;

 treeAccounts->Items->Clear();
 tree_clicking.clear();
 tree_partial.clear();
 latest_parent = treeAccounts->Items->Add(latest_parent, "Root of all accounts");
 top_node = latest_parent;

 tree_partial.insert(pair<TTreeNode*, string>(latest_parent, ""));

 // reset full_tree_compare for the correct whatsit
 full_tree_compare.compare_order.clear();
 for (unsigned int i = 0; i < viewed_dimensions.size(); i++)
  if (viewed_dimensions[i].show_field)
  {
   full_tree_compare.compare_order.push_back(viewed_dimensions[i].field_name);
   tree_building.push_back(where_to_add(NULL, "", viewed_dimensions[i].field_name));
  }
 // after sorting by the visibly sorted fields ... let's sort by the rest, in the
 // order shown on screen ... looks better especially when nothing is selected.
 for (unsigned int i = 0; i < viewed_dimensions.size(); i++)
  if (!viewed_dimensions[i].show_field)
   full_tree_compare.compare_order.push_back(viewed_dimensions[i].field_name);

 // sort by at least one column, in order given, for columns wanted
 sort(accounts.begin(), accounts.end(), full_tree_compare);

 // now display the tree!
 for (vector<account_info>::iterator i_account = accounts.begin();
      i_account != accounts.end(); i_account++)
 {
  // for each account ...
  // if it qualifies ...
  account_to_show = "";
  partial_account = "";
  if (!(
      (!checkIsClosed->Checked && i_account->is_closed) ||
      (!checkNotIsClosed->Checked && !i_account->is_closed) ||
      (!checkIsBudget->Checked && i_account->is_budget) ||
      (!checkNotIsBudget->Checked && !i_account->is_budget) ||
      (!checkIsYearly->Checked && i_account->is_yearly) ||
      (!checkNotIsYearly->Checked && !i_account->is_yearly)))
  {
   for (vector<where_to_add>::iterator i_where = tree_building.begin();
        i_where != tree_building.end(); i_where++)
   {
    // for each category level ...
    // if current value is not the same as the latest one, add new node for this
    // value as a sibling to the previous one, and reset all following pointers to
    // null. set latest_parent to the new node. if latest_sibling is null, create a
    // child under latest_parent, and use that as the new latest_sibling.
    current_value = i_account->account_desc[i_where->field_name].short_name;
    current_desc = i_account->account_desc[i_where->field_name].long_name;
    partial_account += string(current_value + "-");
    // account_to_show += current_value + "-";
    if (current_value != i_where->latest_value)
    {
     branch_to_show = current_value + " (" + current_desc + ")";
     if (i_where->latest_sibling)
     {
      i_where->latest_sibling = treeAccounts->Items->Add(i_where->latest_sibling, branch_to_show.c_str());
      tree_partial.insert(pair<TTreeNode*, string>(i_where->latest_sibling, partial_account));
      //PSay(current_value, m_message, MB_OK);
     }
     else
     {
      i_where->latest_sibling = treeAccounts->Items->AddChild(latest_parent, branch_to_show.c_str());
      tree_partial.insert(pair<TTreeNode*, string>(i_where->latest_sibling, partial_account));
      //PSay(current_value, m_message, MB_OK);
     }
     i_where->latest_value = current_value;
     latest_parent = i_where->latest_sibling;
     clearing_next = i_where;
     clearing_next++;
     while (clearing_next != tree_building.end())
     {
      clearing_next->latest_sibling = NULL;
      clearing_next->latest_value = "";
      clearing_next++;
     }
    }
   }
   // create the account as a leaf under all the categories above, as a child to latest_parent.
   account_to_show = i_account->account_pure + " (";
   account_to_show += (i_account->is_budget ? "Budget/" : "Actual/");
   account_to_show += (i_account->is_closed ? "Closed/" : "Open/");
   account_to_show += (i_account->is_yearly ? "Yearly)" : "Non-year)");
   tree_clicking.insert(pair<TTreeNode*, string>(treeAccounts->Items->AddChild(latest_parent, account_to_show.c_str()), i_account->id));
   account_count++;
   //PSay(i_account->account_name, m_message, MB_OK);
  }
 }
 labelAccountCount->Caption = string(IntToString(account_count) + " accounts listed").c_str();
 top_node->Expand(false);
 return;
}
//---------------------------------------------------------------------------
void TformSpecialLedger::ResetLevelInfo ()
{
 viewed_dimensions.clear();
 viewed_dimensions.push_back(level_info("Fund", "acc_level_one", true));
 viewed_dimensions.push_back(level_info("General Ledger", "acc_level_two", true));
 viewed_dimensions.push_back(level_info("Department", "acc_level_three", true));
 viewed_dimensions.push_back(level_info("Sub-Department", "acc_level_four", false));
 enable_list_checking = true;
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLedger::FormClose(TObject *Sender,
      TCloseAction &Action)
{
 // unregister combo's
 // closing stuff
 enable_list_checking = false;
 lookupTables->UnregisterComboBox("account_types", comboAccountType);
 TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void TformSpecialLedger::ResetAccounts ()
{
 vector<map<string,string> > account_vector;
 string sql = "select accounts.id id, "
              "acc_level_one.id one_id, acc_level_one.short_item one_short, acc_level_one.item one_long, "
              "acc_level_two.id two_id, acc_level_two.short_item two_short, acc_level_two.item two_long, "
              "acc_level_three.id three_id, acc_level_three.short_item three_short, acc_level_three.item three_long, "
              "acc_level_four.id four_id, acc_level_four.short_item four_short, acc_level_four.item four_long, "
              "accounts.name name, accounts.description note, "
              "accounts.account_type_id type_id, account_types.item type_item, "
              "month_types.id cycle_id, month_types.item cycle_item, "
              "accounts.is_budget is_budget, accounts.is_closed is_closed, accounts.is_yearly is_yearly "
              "from "
              "accounts, account_types, month_types, acc_level_one, acc_level_two, "
              "acc_level_three, acc_level_four "
              "where "
              "accounts.acc_level_one_id = acc_level_one.id and "
              "accounts.acc_level_two_id = acc_level_two.id and "
              "accounts.acc_level_three_id = acc_level_three.id and "
              "accounts.acc_level_four_id = acc_level_four.id and "
              "accounts.account_type_id = account_types.id and "
              "accounts.bill_cycle_id = month_types.id";

 if (SqlToVecMap(dbDatabase, sql, account_vector))
 {
  // now, organize this into the freakin' accounts vector<account_info>
  for (vector<map<string, string> >::iterator i_account = account_vector.begin();
       i_account != account_vector.end(); i_account++)
  {
   account_info new_account;
   new_account.id = (*i_account)["id"];
   new_account.account_name = (*i_account)["name"];
   new_account.account_note = (*i_account)["note"];
   new_account.id_type = (*i_account)["type_id"];
   new_account.long_type = (*i_account)["type_item"];
   new_account.id_cycle = (*i_account)["cycle_id"];
   new_account.month_cycle = (*i_account)["cycle_item"];
   new_account.is_budget = ((*i_account)["is_budget"] == "1");
   new_account.is_closed = ((*i_account)["is_closed"] == "1");
   new_account.is_yearly = ((*i_account)["is_yearly"] == "1");
   new_account.account_desc.insert(pair<string, account_level>("acc_level_one", account_level((*i_account)["one_id"], (*i_account)["one_short"], (*i_account)["one_long"])));
   new_account.account_desc.insert(pair<string, account_level>("acc_level_two", account_level((*i_account)["two_id"], (*i_account)["two_short"], (*i_account)["two_long"])));
   new_account.account_desc.insert(pair<string, account_level>("acc_level_three", account_level((*i_account)["three_id"], (*i_account)["three_short"], (*i_account)["three_long"])));
   new_account.account_desc.insert(pair<string, account_level>("acc_level_four", account_level((*i_account)["four_id"], (*i_account)["four_short"], (*i_account)["four_long"])));
   new_account.account_pure = (*i_account)["one_short"] + "-" +
                              (*i_account)["two_short"] + "-" +
                              (*i_account)["three_short"] + "-" +
                              (*i_account)["four_short"];
   accounts.push_back(new_account);
  }
 }
 else
  PSay("Failed to retrieve account information", m_database_error, MB_OK);
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialLedger::checkIsClosedClick(TObject *Sender)
{
 // checking or unchecking stuff, yup.
 if (!checkIsClosed->Checked && !checkNotIsClosed->Checked)
  checkNotIsClosed->Checked = true;
 if (!checkIsBudget->Checked && !checkNotIsBudget->Checked)
  checkNotIsBudget->Checked = true;
 if (!checkIsYearly->Checked && !checkNotIsYearly->Checked)
  checkIsYearly->Checked = true;
}
//---------------------------------------------------------------------------
void TformSpecialLedger::RedrawAccounts ()
{
  // account search
  map<string, string> account_parts = PartsByMask (editAccount);

  string sql = "select accounts.name, accounts.is_budget, accounts.is_closed, accounts.is_yearly, month_types.item, account_types.item, accounts.current_id, accounts.id "
               "from accounts left join month_types on accounts.bill_cycle_id = month_types.id left join account_types on accounts.account_type_id = account_types.id ";
  string where = "";

  if (checkIsBudget->Checked && !checkNotIsBudget->Checked)
  {
   if (!where.empty()) where += " and ";
    where += "accounts.is_budget = '1' ";
  }
  if (!checkIsBudget->Checked && checkNotIsBudget->Checked)
  {
   if (!where.empty()) where += " and ";
    where += "accounts.is_budget = '0' ";
  }

  if (checkIsClosed->Checked && !checkNotIsClosed->Checked)
  {
   if (!where.empty()) where += " and ";
    where += "accounts.is_closed = '1' ";
  }
  if (!checkIsClosed->Checked && checkNotIsClosed->Checked)
  {
   if (!where.empty()) where += " and ";
    where += "accounts.is_closed = '0' ";
  }

  if (checkIsYearly->Checked && !checkNotIsYearly->Checked)
  {
   if (!where.empty()) where += " and ";
    where += "accounts.is_yearly = '1' ";
  }
  if (!checkIsYearly->Checked && checkNotIsYearly->Checked)
  {
   if (!where.empty()) where += " and ";
    where += "accounts.is_yearly = '0' ";
  }

  if (comboAccountType->Text != "")
  {
   if (!where.empty()) where += " and ";
   if (lookupTables->IsInLookUpTable("account_types", comboAccountType->Text.c_str()))
    where += "accounts.account_type_id = '" + lookupTables->IdOf("account_types", comboAccountType->Text.c_str()) + "'";
  }
  if (checkExactMatch->Checked || account_parts["one"] != "000")
  {
   sql   += ", acc_level_one ";
   if (!where.empty()) where += " and ";
   where += "accounts.acc_level_one_id = acc_level_one.id and acc_level_one.short_item = '" + account_parts["one"] + "'";
  }
  if (checkExactMatch->Checked || account_parts["two"] != "0000000")
  {
   sql   += ", acc_level_two ";
   if (!where.empty()) where += " and ";
   where += "accounts.acc_level_two_id = acc_level_two.id and acc_level_two.short_item = '" + account_parts["two"] + "'";
  }
  if (checkExactMatch->Checked || account_parts["three"] != "000")
  {
   sql   += ", acc_level_three ";
   if (!where.empty()) where += " and ";
   where += "accounts.acc_level_three_id = acc_level_three.id and acc_level_three.short_item = '" + account_parts["three"] + "'";
  }
  if (checkExactMatch->Checked || account_parts["four"] != "000")
  {
   sql   += ", acc_level_four ";
   if (!where.empty()) where += " and ";
   where += "accounts.acc_level_four_id = acc_level_four.id and acc_level_four.short_item = '" + account_parts["four"] + "'";
  }

  if (!where.empty())
   where = "where " + where;
  string final_sql = sql + where;

  accounts_filter.SetSQLStatement(final_sql);
  accounts_filter.RefreshDataSet();
 return;
}
//---------------------------------------------------------------------------
void TformSpecialLedger::RedrawTransactions ()
{
 // transaction search
 bool is_valid = true;
 string begin_date = editStartDate->Text.c_str();
 string end_date = editEndDate->Text.c_str();
 vector<string> account_vec = accounts_filter.GetMultiID();

 if (!begin_date.empty())
  if (!Pdate(begin_date, mdy | yy).IsValidDate())
  {
   PSay("Please enter a valid beginning date for transactions, or none at all.", m_invalid_data, MB_OK);
   is_valid = false;
  }

 if (!end_date.empty())
  if (!Pdate(end_date, mdy | yy).IsValidDate())
  {
   PSay("Please enter a valid ending date for transactions, or none at all.", m_invalid_data, MB_OK);
   is_valid = false;
  }

 if (is_valid)
 {
  string sql = "select tax_entities.name, transactions.effective_date, transactions.fiscal_date, "
               "accounts.name, account_types.item, "
               "transactions.note, transactions.debit_amount, transactions.credit_amount, "
               "transactions.transaction_number, transactions.current_id, transactions.id "
               "from transactions "
               "inner join accounts on transactions.account_id = accounts.id "
               "inner join account_types on accounts.account_type_id = account_types.id "
               "left join tax_entities on transactions.tax_entity_id = tax_entities.id ";
  string where;

  if (!begin_date.empty())
  {
   if (where.empty())
    where = "where ";
   else
    where += " and ";
   where += "transactions.effective_date >= '" + Pdate(begin_date, mdy | yy).OutDate(mdy | yyyy) + "' ";
  }
  if (!end_date.empty())
  {
   if (where.empty())
    where = "where ";
   else
    where += " and ";
   where += "transactions.effective_date <= '" + Pdate(end_date, mdy | yy).OutDate(mdy | yyyy) + "' ";
  }

  if (!account_vec.empty())
  {
   if (where.empty())
    where = "where ";
   else
    where += " and ";
   where += "transactions.account_id in (";
   for (vector<string>::iterator i_acc = account_vec.begin(); i_acc != account_vec.end(); i_acc++)
   {
    if (i_acc != account_vec.begin())
     where += ", ";
    where += (*i_acc);
   }
   where += ") ";
  } else
  {
   if (where.empty())
    where = "where ";
   else
    where += " and ";
   where += "transactions.account_id < 0 ";
  }

  //  where += " and transactions.current_id > 2";

  sql += where;

  // done -- the three bottom things of accumulated values
  string amountsql = "select sum(transactions.credit_amount) credit_sum, sum(transactions.debit_amount) debit_sum "
                     "from transactions inner join accounts on transactions.account_id = accounts.id ";
  amountsql += where;
  map<string, string> summary_map;

  if (SqlToMap(dbDatabase, amountsql, summary_map))
  {
   string credit_sum = summary_map["credit_sum"];
   string debit_sum = summary_map["debit_sum"];

   financial credit_sum_f = StringToFinancial(credit_sum);
   financial debit_sum_f = StringToFinancial(debit_sum);
   // Philip used abs(credit_sum_f - debit_sum_f) but abs() returns an int!  Since we don't want to lose cents...
   financial net_sum_f = credit_sum_f - debit_sum_f;
   if (net_sum_f < 0) net_sum_f = -net_sum_f;
   // We now return you to your regularly scheduled ledger
   string net_sum = FinancialToString(net_sum_f);

   labelSumCR->Caption  = StringToAmount(credit_sum).c_str();
   labelSumDR->Caption  = StringToAmount(debit_sum).c_str();
   labelSumNet->Caption = StringToAmount(net_sum).c_str();
  }
  else
  {
   labelSumCR->Caption  = "unavailable";
   labelSumDR->Caption  = "unavailable";
   labelSumNet->Caption = "unavailable";
  }

  transactions_filter.SetSQLStatement(sql);
  transactions_filter.RefreshDataSet();
 }
 return;
}
//---------------------------------------------------------------------------
void TformSpecialLedger::AtlasScreen(int request_num, string matched_value)
{
 // refresh -stuff-
 if (request_num == accounts_request)
  accounts_filter.RefreshDataSet();
 if (request_num == transactions_request)
  transactions_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
void TformSpecialLedger::AddAccount ()
{
 map<string, string> temp_map;
 temp_map["id"] = "NEW";
 FORM_TRY
   TformRecordAccount * edit_account = new TformRecordAccount(NULL, temp_map);
   edit_account->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void TformSpecialLedger::EditAccount ()
{
 map<string, string> temp_map;
 temp_map["id"] = accounts_filter.GetSelectedRecordID();
 FORM_TRY
   TformRecordAccount * edit_account = new TformRecordAccount(NULL, temp_map);
   edit_account->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void TformSpecialLedger::EditTransaction ()
{
 map<string, string> temp_map;
 temp_map["id"] = transactions_filter.GetSelectedRecordID();
 FORM_TRY
   TformRecordTransaction * edit_transaction = new TformRecordTransaction(NULL, temp_map);
   edit_transaction->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLedger::buttonCheckAllClick(TObject *Sender)
{
 // check all
 accounts_filter.CheckAll();
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLedger::buttonUncheckAllClick(TObject *Sender)
{
 // uncheck all
 accounts_filter.UncheckAll();
 return;
}
//---------------------------------------------------------------------------

