//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialLicenses.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialLicenses *formSpecialLicenses;
//---------------------------------------------------------------------------
// License Data
// These are hard-coded for several reasons:
// 1. They have to be maintained in the source code anyway, at the point where the actual code is contained in the
//    project, and their validity is dependent on that fact.
// 2. They have to move with the source anywhere it may go, even if it went to a new/different database or found
//    applications in a mobile "jr." version, etc.
// 3. The license text is large, and difficult to format when control characters can't be embedded directly.
//
struct license_t
{
  const char *license_name; // Name to display in the combo box
  const char *license_text; // Text of the license
};

static license_t licenses[] =
{
  // License for Base64 encoder/decoder code contained in vectoredexception.cpp; derived from libjson
  // License style: 2-clause BSD variant
  {
    "libjson",

    "Copyright 2010 Jonathan Wallace. All rights reserved.\r\n\r\n"
    "Redistribution and use in source and binary forms, with or without modification, are permitted provided that the "
    "following conditions are met:\r\n\r\n"
    "\t1. Redistributions of source code must retain the above copyright notice, this list of conditions and the "
    "following disclaimer.\r\n\r\n"
    "\t2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the "
    "following disclaimer in the documentation and/or other materials provided with the distribution.\r\n\r\n"
    "THIS SOFTWARE IS PROVIDED BY JONATHAN WALLACE ''AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT "
    "LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO "
    "EVENT SHALL JONATHAN WALLACE OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, "
    "OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF "
    "USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN "
    "CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS "
    "SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\r\n\r\n"
    "The views and conclusions contained in the software and documentation are those of the authors and should not be "
    "interpreted as representing official policies, either expressed or implied, of Jonathan Wallace."
  },
  { NULL, NULL } // must be last
};
//---------------------------------------------------------------------------
__fastcall TformSpecialLicenses::TformSpecialLicenses(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  license_t *current_license = licenses;

  while(current_license->license_name)
  {
    cboLicense->Items->Add(current_license->license_name);
    ++current_license;
  }
  cboLicense->ItemIndex = 0;
  cboLicenseChange(cboLicense);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLicenses::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLicenses::cboLicenseChange(TObject *Sender)
{
  int license_num = cboLicense->ItemIndex;

  if(license_num >= 0)
  {
    memoLicense->Lines->Clear();
    memoLicense->Text = licenses[license_num].license_text;
  }
}
//---------------------------------------------------------------------------
