//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialLookupTableInfo.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialLookupTableInfo *formSpecialLookupTableInfo;
//---------------------------------------------------------------------------
__fastcall TformSpecialLookupTableInfo::TformSpecialLookupTableInfo(TComponent* Owner, map<string, string> params)
        : TformSpecialGeneric(Owner)
{
  parameters = params;
  lookupTables->RegisterComboBox("display_types", cboDisplay);
  dbTransaction = new TIBTransaction(NULL);
  dbDataSet = new TIBDataSet(NULL);
  string sql;
  try
  {
    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;
    if ((parameters["id"] != "") && (parameters["id"] != "0"))
    {
      sql = "select table_name, display_option, valid_option, can_add_to, autoload_option "
            "from lookup_tables where id = " + parameters["id"];
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();
      if (dbDataSet->Eof == false)
      {
        editTableName->Text = LowercaseString(dbDataSet->FieldByName("table_name")->AsString.c_str()).c_str();
        cboDisplay->Text = LowercaseString(lookupTables->ValueOf("display_types",
          dbDataSet->FieldByName("display_option")->AsString.c_str())).c_str();
        // yes, this is correct... change look up table class if it's that disturbing
        if (dbDataSet->FieldByName("valid_option")->AsString == "1")
          checkShowInvalid->Checked = false;
        else
          checkShowInvalid->Checked = true;
        if (dbDataSet->FieldByName("can_add_to")->AsString == "1")
          checkCanAdd->Checked = true;
        else
          checkCanAdd->Checked = false;
        if (dbDataSet->FieldByName("autoload_option")->AsString == "1")
          checkAutoload->Checked = true;
        else
          checkAutoload->Checked = false;
      }
      dbDataSet->Close();
    }
    if (dbTransaction->Active)
      dbTransaction->Commit();
  }
  catch(...)
  {
    PSay("Error setting up database objects", m_database_error, MB_OK);
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLookupTableInfo::cboDisplayKeyPress(
      TObject *Sender, char &Key)
{
  FindComboBoxItem(Sender, Key);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLookupTableInfo::cboShowInvalidKeyPress(
      TObject *Sender, char &Key)
{
  FindComboBoxItem(Sender, Key);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLookupTableInfo::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLookupTableInfo::btnSaveClick(TObject *Sender)
{
  string table_name = editTableName->Text.c_str();
  if (table_name.find_first_of(" ") != string::npos)
  {
    PSay("Please don't enter spaces in table names\n"
      "If the table you created has a space in the name, change the name of the table", m_invalid_data, MB_OK);
    editTableName->SetFocus();
  }
  else if (! lookupTables->IsInLookUpTable("display_types", cboDisplay->Text.c_str()))
  {
    PSay("Please enter a valid display option", m_invalid_data, MB_OK);
    cboDisplay->SetFocus();
  }
  else
  {
    map<string, string> field_map;
    bool is_update = false;
    string sql;

    if ((parameters["id"] != "") && (parameters["id"] != "0"))
    {
      is_update = true;
      field_map["id"] = parameters["id"];
    }

    field_map["table_name"] = table_name;
    field_map["display_option"] = lookupTables->IdOf("display_types", cboDisplay->Text.c_str());
    if (checkShowInvalid->Checked)
      field_map["valid_option"] = "0";
    else
      field_map["valid_option"] = "1";
    if (checkCanAdd->Checked)
      field_map["can_add_to"] = "1";
    else
      field_map["can_add_to"] = "0";
    if (checkAutoload->Checked)
      field_map["autoload_option"] = "1";
    else
      field_map["autoload_option"] = "0";
    if (is_update)
    {
      if (ExecuteUpdateStatement(dbTransaction, "lookup_tables", field_map))
        Close();
    }
    else
    {
      try
      {
        sql = "select id, item, valid from " + table_name;
        dbTransaction->StartTransaction();
        dbDataSet->SelectSQL->Add(sql.c_str());
        dbDataSet->Open();
        dbDataSet->Close();
        dbTransaction->Commit();
        sql = "select id from lookup_tables where table_name = '" + table_name + "'";
        if (GetOneField(dbTransaction, sql) != "")
        {
          PSay("That table is already added", m_duplicate_data, MB_OK);
          Close();
        }
        else if (ExecuteInsertStatement(dbTransaction, "lookup_tables", field_map))
          Close();
      }
      catch (...)
      {
        PSay("That table does not exist or does not have the columns id, item, and valid", m_invalid_data, MB_OK);
        editTableName->SetFocus();
      }
    } // end else if new record
  } // end else if valid data
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLookupTableInfo::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("display_types", cboDisplay);
  delete dbTransaction;
  delete dbDataSet;
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
