//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialLookupTables.h"
#include "codeSpecialLookupTableInfo.h"
#include "codeSpecialAddValues.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialLookupTables *formSpecialLookupTables;
//---------------------------------------------------------------------------
__fastcall TformSpecialLookupTables::TformSpecialLookupTables(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  RefreshTableList();
  if(optionsPermissions["special.add_to_lookup_tables"]["enabled"] != "true")
    menuAddValue->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLookupTables::menuAddClick(TObject *Sender)
{
  map<string, string> temp_map;
  FORM_TRY
    TformSpecialLookupTableInfo * addForm = new TformSpecialLookupTableInfo(NULL, temp_map);
    addForm->ShowTaskModal(this);
  FORM_CATCH
  RefreshTableList();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLookupTables::menuAddValueClick(TObject *Sender)
{
  if(listTables->SelCount > 0)
  {
    map<string, string> temp_map;
    temp_map["table_name"] = listTables->Selected->Caption.c_str();
    temp_map["unsafe_add"] = "true";
    FORM_TRY
      TformSpecialAddValues * addValueForm = new TformSpecialAddValues(NULL, temp_map);
      addValueForm->Show();
    FORM_CATCH
  }
}
//---------------------------------------------------------------------------
void TformSpecialLookupTables::RefreshTableList()
{
  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql = "select id, table_name, can_add_to, display_option, valid_option, autoload_option "
               " from lookup_tables where id > 0 order by table_name";
  TListItem * row;
  listTables->Items->Clear();
  try
  {
    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    dbDataSet->SelectSQL->Clear();
    dbDataSet->SelectSQL->Add(sql.c_str());

    dbDataSet->Open();
    dbDataSet->First();
    while (! dbDataSet->Eof)
    {
      row = listTables->Items->Add();
      row->Caption = LowercaseString(dbDataSet->FieldByName("table_name")->AsString.c_str()).c_str();
      if (dbDataSet->FieldByName("display_option")->AsString == "0")      // TODO -c MAGIC NUMBER :
        row->SubItems->Add("pretty");
      else if (dbDataSet->FieldByName("display_option")->AsString == "1") // TODO -c MAGIC NUMBER :
        row->SubItems->Add("uppercase");
      else if (dbDataSet->FieldByName("display_option")->AsString == "2") // TODO -c MAGIC NUMBER :
        row->SubItems->Add("lowercase");
      else if (dbDataSet->FieldByName("display_option")->AsString == "3") // TODO -c MAGIC NUMBER :
        row->SubItems->Add("sentence");
      else if (dbDataSet->FieldByName("display_option")->AsString == "4") // TODO -c MAGIC NUMBER :
        row->SubItems->Add("nothing");
      else
        row->SubItems->Add("unknown");
      if (dbDataSet->FieldByName("valid_option")->AsString == "0")
        row->SubItems->Add("true");
      else
        row->SubItems->Add("false");
      if (dbDataSet->FieldByName("can_add_to")->AsString == "1")
        row->SubItems->Add("true");
      else
        row->SubItems->Add("false");
      if (dbDataSet->FieldByName("autoload_option")->AsString == "1")
        row->SubItems->Add("true");
      else
        row->SubItems->Add("false");
      row->SubItems->Add(dbDataSet->FieldByName("id")->AsString);

      dbDataSet->Next();
    }
    dbDataSet->Close();
    sql = "select count(id) from lookup_tables where id > 0";
    string caption = "Lookup Tables - " + GetOneField(dbTransaction, sql) + " results found";
    this->Caption = caption.c_str();
    dbTransaction->Commit();
  }
  catch(...)
  {

  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLookupTables::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLookupTables::listTablesDblClick(TObject *Sender)
{
  if(listTables->SelCount > 0)
  {
    map<string, string> temp_map;
    temp_map["id"] = listTables->Selected->SubItems->Strings[4].c_str();
    FORM_TRY
      TformSpecialLookupTableInfo * addForm = new TformSpecialLookupTableInfo(NULL, temp_map);
      addForm->ShowTaskModal(this);
    FORM_CATCH
    RefreshTableList();
  }
 // open look up table info form
}
//--------------------------------------------------------------------------- 
void __fastcall TformSpecialLookupTables::addPopupPopup(TObject *Sender)
{
  if(listTables->SelCount < 0)
    menuAddValue->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialLookupTables::menuRefreshClick(TObject *Sender)
{
  if(listTables->SelCount > 0)
  {
    string table_name = listTables->Selected->Caption.c_str();
    atlas->Notify(table_name, "");
  }
}
//---------------------------------------------------------------------------

