//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialMakeLike.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialMakeLike *formSpecialMakeLike;
//---------------------------------------------------------------------------
__fastcall TformSpecialMakeLike::TformSpecialMakeLike(TComponent* Owner, string userid)
        : TformSpecialGeneric(Owner)
{
  string all_users_sql = "select id, item, 1 valid from users order by item"; // make valid = 1 for all
  lookupTables->RegisterComboBox("users", cboUser, all_users_sql);
  to_update = userid;
  string title = "Make ";
  title += PrettyString(lookupTables->ValueOf("users", userid));
  if (title[title.length()-1] != 's')
    title += "'s ";
  else
    title += "' ";
  title += "permissions like";
  lblUser->Caption = title.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialMakeLike::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("users", cboUser);
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialMakeLike::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialMakeLike::btnSaveClick(TObject *Sender)
{
  if (! lookupTables->IsInLookUpTable("users", cboUser->Text.c_str()))
  {
    PSay("Please enter a valid user", m_invalid_data, MB_OK);
    cboUser->SetFocus();
  }
  else
  {
    TIBTransaction *dbTransaction = new TIBTransaction(NULL);
    string sql;
    string make_like = lookupTables->IdOf("users", cboUser->Text.c_str());
    vector<map<string, string> > permissions_vec;
    map<string, string> to_insert;
    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbTransaction->StartTransaction();
      sql = "delete from permissions where user_id = " + to_update;
      if (ExecuteStatement(dbTransaction, sql))
      {
        sql = "select s, k, v from permissions where user_id = " + make_like;
        if (SqlToVecMap(dbTransaction, sql, permissions_vec))
        {
          for (vector<map<string, string> >::iterator itr = permissions_vec.begin(); itr != permissions_vec.end(); itr++)
          {
            to_insert.clear();
            to_insert["user_id"] = to_update;
            to_insert["s"] = (*itr)["s"];
            to_insert["k"] = (*itr)["k"];
            to_insert["v"] = (*itr)["v"];
            if (! ExecuteInsertStatement(dbTransaction, "permissions", to_insert))
              throw "Error inserting new permissions";
          }
          dbTransaction->Commit();
        }
        else
           throw "Error selecting permissions";
      }
      else
        throw "Error deleting old permissions";
    }
    catch (string message)
    {
      if (dbTransaction->Active)
        dbTransaction->Rollback();
      PSay(message, m_database_error, MB_OK);
    }
    catch(...)
    {
      if (dbTransaction->Active)
        dbTransaction->Rollback();
      PSay("Could not perform update", m_database_error, MB_OK);
    }

    delete dbTransaction;
    Close();
  }
}
//---------------------------------------------------------------------------
