//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialMakeUserViewable.h"
#include "codeSpecialSelectGroups.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialMakeUserViewable *formSpecialMakeUserViewable;
//---------------------------------------------------------------------------
__fastcall TformSpecialMakeUserViewable::TformSpecialMakeUserViewable(TComponent* Owner, string p_user_id)
        : TformSpecialGeneric(Owner)
{
  user_id = p_user_id;
  ShowUsers();
}
//---------------------------------------------------------------------------
void TformSpecialMakeUserViewable::ShowUsers()
{
  TListItem *row;
  vector<map<string, string> > user_vec;
  txtUser->Caption = lookupTables->ValueOf("users", user_id).c_str();
  string sql = "select users.id, users.item from users where id > 0 order by item";
  SqlToVecMap(dbDatabase, sql, user_vec);
  listUsers->Items->Clear();
  for(vector<map<string, string> >::iterator itr = user_vec.begin(); itr != user_vec.end(); itr++)
  {
    row = listUsers->Items->Add();
    row->Caption = (*itr)["item"].c_str();
    row->SubItems->Add((*itr)["id"].c_str());
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialMakeUserViewable::menuAddByGroupsClick(TObject *Sender)
{
  set<string> return_set;
  string id;
  FORM_TRY
    TformSpecialSelectGroups * select_group_form = new TformSpecialSelectGroups(NULL, &return_set, NULL, false);
    select_group_form->ShowTaskModal(this);
  FORM_CATCH
  if(! return_set.empty())
  {
    TListItem * row;
    for (int i = 0; i < listUsers->Items->Count; i++)
    {
      row = listUsers->Items->Item[i];
      id = row->SubItems->Strings[0].c_str();
      if (return_set.find(id) != return_set.end())
        row->Checked = true;
      else
        row->Checked = false;
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialMakeUserViewable::btnCancelClick(
      TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialMakeUserViewable::btnSaveClick(TObject *Sender)
{
  TIBTransaction *dbTransaction = new TIBTransaction(NULL);
  try
  {
    Processing(true);
    dbTransaction->DefaultDatabase = dbDatabase;
    dbTransaction->StartTransaction();
    string sql;
    string id;
    vector<string> id_vec;
    map<string, string> insert_map;

    /* This is SOOOO SLOOOOOW.  I'm making this select statement not retarded, and replacing the iterative insert process with a batch one.

    // Get a list of appointments that need to be made viewable to this uesr:
    // not (not exists viewable record for each user) == inverse set of records
    // not viewable to each user == set of records viewable to all of the users;
    // also don't return appointment id's if they're -already- viewable to the
    // user we're updating... otherwise we'll create dupes that'll show multiple
    // times on the scheduler, appt report, etc....
    sql = "select appointments.id from appointments "
          "where not "
            "(not exists "
              "(select appointment_viewers.id "
               "from appointment_viewers "
               "where appointment_viewers.appointment_id = appointments.id "
                "and appointment_viewers.user_id in (" + VecToCommaString(id_vec) + ")"
               ")"
            ") and "
          "(not exists"
           "(select * "
            "from appointment_viewers "
            "where appointment_viewers.appointment_id = appointments.id and appointment_viewers.user_id = " + user_id +
           ")"
          ")";

    SqlToVec(dbTransaction, sql, id_vec);
    insert_map["last_updated_by"] = current_userid;
    insert_map["last_update_stamp"] = RightNow();
    insert_map["current_id"] = "4";
    insert_map["user_id"] = user_id;
    for(vector<string>::iterator itr = id_vec.begin(); itr != id_vec.end(); itr++)
    {
      insert_map["id"] = GetNextId(dbTransaction, "appointment_viewers");
      insert_map["appointment_id"] = (*itr);
      ExecuteInsertStatement(dbTransaction, "appointment_viewers", insert_map);
    }
   */
    sql = "";
    for (int i = 0; i < listUsers->Items->Count; i++)
    {
      id = listUsers->Items->Item[i]->SubItems->Strings[0].c_str();
      if (listUsers->Items->Item[i]->Checked)
      {
        // id_vec.push_back(id); // not anymore!
        // Select distinct appointment_id from appointment_viewers where user_id = first_one
        // [ and exists (select * from appointment_viewers where same appointment id and user_id = next_id ]
        // [ ... repeat as necessary for additionally selected users ... ]
        // and not appointment_viewers record for this (appointment_id, user_id) already exists (don't want dupes!)
        if (sql == "")
          sql = "insert into appointment_viewers (last_updated_by, last_update_stamp, current_id, user_id, appointment_id) "
                "select distinct " + current_userid + ", '" + RightNow() + "', 4, " + user_id + ", "
                "OT.appointment_id from appointment_viewers OT where OT.user_id = " + id + " "
                "and not exists (select * from appointment_viewers IT where IT.appointment_id = OT.appointment_id and IT.user_id = " + user_id + ") ";
        else
          sql += "and exists (select * from appointment_viewers IT where IT.appointment_id = OT.appointment_id and IT.user_id = " + id + ") ";
      }
    }
    DebugSql(this, &sql, other_forms, 9, dbTransaction);
    ExecuteStatement(dbTransaction, sql);

    dbTransaction->Commit();
    Processing(false);
  }
  catch(...)
  {
    if(dbTransaction->Active)
      dbTransaction->Rollback();
    Processing(false);
    PSay("Error adding new records", m_database_error, MB_OK);
  }

  delete dbTransaction;
  Close();
}
//---------------------------------------------------------------------------

