//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialMergePerson.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialMergePerson *formSpecialMergePerson;
//---------------------------------------------------------------------------
__fastcall TformSpecialMergePerson::TformSpecialMergePerson(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialMergePerson::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialMergePerson::btnRunClick(TObject *Sender)
{
  string to_delete = editDelete->Text.c_str();
  string to_merge = editMerge->Text.c_str();
  if ((to_delete == "") || (to_merge == ""))
  {
    PSay("Please enter both id numbers", m_missing_data, MB_OK);
    editDelete->SetFocus();
  }
  else
  {
    Processing(true);
    TIBTransaction * dbTransaction = new TIBTransaction(NULL);

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      vector<map<string, string> > table_list;
      string sql;
      string error;
      string table_name;

      dbTransaction->StartTransaction();
      // download list of tables that have person_id
      sql = "select item from merge_person_types where id > 0 and valid = 1";
      SqlToVecMap(dbTransaction, sql, table_list);
      // update fk triggers in people table
      sql = "update people set person_names_id = 0 where id = " + to_delete;
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating person_names fk in people";
        throw error;
      }
      sql = "update people set affiliations_id = 0 where id = " + to_delete;
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating affiliations fk in people";
        throw error;
      }
      sql = "update people set person_contact_info_id = 0 where id = " + to_delete;
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating person_contact_info fk in people";
        throw error;
      }
      // update person id's in tables downloaded from person_merge_types
      for(vector<map<string, string> >::iterator itr = table_list.begin(); itr != table_list.end(); itr++)
      {
        table_name = LowercaseString((*itr)["item"]);
        if (table_name == "relationships")
        {
          sql = "update " + table_name + " set person_a_id = " + to_merge + " where person_a_id = " + to_delete;
          if (! ExecuteStatement(dbTransaction, sql))
          {
            error = "Error updating relationships";
            throw error;
          }
          sql = "update " + table_name + " set person_b_id = " + to_merge + " where person_b_id = " + to_delete;
          if (! ExecuteStatement(dbTransaction, sql))
          {
            error = "Error updating relationships";
            throw error;
          }
        }
        else
        {
          sql = "update " + table_name + " set person_id = " + to_merge + " where person_id = " + to_delete;
          if (! ExecuteStatement(dbTransaction, sql))
          {
            error = "Error updating " + table_name;
            throw error;
          }
        }
      } // end for
      sql = "delete from people where id = " + to_delete;
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error deleting from people table";
        throw error;
      }
      dbTransaction->Commit();
      editDelete->Text = "";
      editMerge->Text = "";
      editDelete->SetFocus();
      Processing(false);
    }
    catch (string message)
    {
      Processing(false);
      PSay(message, m_database_error, MB_OK);
      if(dbTransaction->Active)
        dbTransaction->Rollback();
    }
    catch (...)
    {
      Processing(false);    
      PSay("Error starting or commiting transaction", m_database_error, MB_OK);
      if(dbTransaction->Active)
        dbTransaction->Rollback();
    }

  }
}
//---------------------------------------------------------------------------
