//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialMergeTaxEntity.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialMergeTaxEntity *formSpecialMergeTaxEntity;
//---------------------------------------------------------------------------
__fastcall TformSpecialMergeTaxEntity::TformSpecialMergeTaxEntity(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialMergeTaxEntity::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialMergeTaxEntity::btnRunClick(TObject *Sender)
{
  string to_delete = editDelete->Text.c_str();
  string to_merge = editMerge->Text.c_str();
  if ((to_delete == "") || (to_merge == ""))
  {
    PSay("Please enter both id numbers", m_missing_data, MB_OK);
    editDelete->SetFocus();
  }
  else
  {
    Processing(true);
    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    string error;

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      string sql;

      dbTransaction->StartTransaction();
      vector<string> fkVec;
      fkVec.push_back("tax_addresses");
      fkVec.push_back("appointments");
      fkVec.push_back("beh_out_treatment");
      fkVec.push_back("checks");
      fkVec.push_back("cob_requests");
      fkVec.push_back("insurance_coverage");
      fkVec.push_back("insurance_policies");
      fkVec.push_back("purchase_reqs");
      fkVec.push_back("services_provided");
      fkVec.push_back("tasks");
      fkVec.push_back("transactions");
      fkVec.push_back("users");
      for (unsigned int i = 0; i != fkVec.size(); i++)
      {
         sql = "update " + fkVec[i] + " set tax_entity_id = " + to_merge + " where tax_entity_id = " + to_delete;
         if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", sql.c_str());
         if (! ExecuteStatement(dbTransaction, sql))
         {
           error = "Error updating fk in " + fkVec[i];
           throw error;
         }
      }
      sql = "update bills set provider_tax_id = " + to_merge + " where provider_tax_id = " + to_delete;
      if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", sql.c_str());
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating provider_tax_id fk in bills";
        throw error;
      }
      sql = "update bills set facility_tax_id = " + to_merge + " where facility_tax_id = " + to_delete;
      if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", sql.c_str());
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating facility_tax_id fk in bills";
        throw error;
      }
      sql = "update bills set group_tax_id = " + to_merge + " where group_tax_id = " + to_delete;
      if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", sql.c_str());
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating group_tax_id fk in bills";
        throw error;
      }
      sql = "update bills set actual_tax_id = " + to_merge + " where actual_tax_id = " + to_delete;
      if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", sql.c_str());
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating actual_tax_id fk in bills";
        throw error;
      }
      sql = "update people set diab_provider_id = " + to_merge + " where diab_provider_id = " + to_delete;
      if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", sql.c_str());
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating diab_provider_id fk in people";
        throw error;
      }
      sql = "update referrals set by_provider_id = " + to_merge + " where by_provider_id = " + to_delete;
      if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", sql.c_str());
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating by_provider_id fk in referrals";
        throw error;
      }
      sql = "update referrals set by_facility_id = " + to_merge + " where by_facility_id = " + to_delete;
      if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", sql.c_str());
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating by_facility_id fk in referrals";
        throw error;
      }
      sql = "update referrals set to_provider_id = " + to_merge + " where to_provider_id = " + to_delete;
      if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", sql.c_str());
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating to_provider_id fk in referrals";
        throw error;
      }
      sql = "update referrals set to_facility_id = " + to_merge + " where to_facility_id = " + to_delete;
      if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", sql.c_str());
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating to_facility_id fk in referrals";
        throw error;
      }
      fkVec.clear();
      sql = "update tax_entities set current_id = 4 where id = " + to_merge;
      if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", sql.c_str());
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating current_id";
        throw error;
      }
      sql = "update tax_entities set last_update_stamp = '" + RightNow() + "' where id = " + to_merge;
      if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", sql.c_str());
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating current_id";
        throw error;
      }
      sql = "update tax_entities set last_updated_by = " + current_userid + " where id = " + to_merge;
      if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", sql.c_str());
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error updating current_id";
        throw error;
      }

      fkVec.push_back("tax_entity_id");
//      fkVec.push_back("insurance_id");
      fkVec.push_back("beh_care_id");
      fkVec.push_back("beh_agency_id");
      fkVec.push_back("beh_pop_id");
      fkVec.push_back("is_referring");

      fkVec.push_back("name");

      string from, to;
      for (unsigned int i = 0; i != fkVec.size(); i++)
      {
         sql = "select " + fkVec[i] + " from tax_entities where id = " + to_delete;
         from = GetOneField(dbTransaction, sql);
         sql = "select " + fkVec[i] + " from tax_entities where id = " + to_merge;
         to = GetOneField(dbTransaction, sql);
         if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", ("old value: '" + from + "'; new value: '" + to + "'").c_str());
         if ((from != "") && (to == ""))
         {
            if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "old data not in new field, merging...");
            sql = "update tax_entities set " + fkVec[i] + " = '" + from + "' where id = " + to_merge;
            if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", sql.c_str());
            if (! ExecuteStatement(dbTransaction, sql))
            {
               error = "Error updating " + fkVec[i];
               throw error;
            }
         }
         else if ((from != "") && (from != to))
         {
            if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "collision... prompting...");
            int result = PSay((fkVec[i] + " exists in both records.\n\n" +
                                                  "Old record (" + to_delete + ") value is:  " + from + "\n" +
                                                  "New record (" + to_merge + ") value is:  " + to + "\n\n" +
                                                  "Select Yes to overwrite the new value with the old value\n" +
                                                  "or No to leave the new value alone.").c_str(), m_warning, MB_YESNO);
            if (result == IDYES)
            {
               if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "collision... merging...");
               sql = "update tax_entities set " + fkVec[i] + " = '" + SafeSQLString(from) + "' where id = " + to_merge;
               if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", sql.c_str());
               if (! ExecuteStatement(dbTransaction, sql))
               {
                  error = "Error updating " + fkVec[i];
                  throw error;
               }
            }
         }
         else
            if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "fields identical, ignoring...");

      }

      sql = "delete from tax_entities where id = " + to_delete;
      if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", sql.c_str());
      if (! ExecuteStatement(dbTransaction, sql))
      {
        error = "Error deleting tax_entity";
        throw error;
      }

      dbTransaction->Commit();
      editDelete->Text = "";
      editMerge->Text = "";
      Processing(false);
    }
    catch (EIBInterBaseError & the_error)
    {
      Processing(false);
      PSay((the_error.Message).c_str(), m_database_error, MB_OK);
    }
    catch (...)
    {
      Processing(false);
      PSay(error, m_database_error, MB_OK);
      dbTransaction->Rollback();
    }
  }
}
//---------------------------------------------------------------------------

