//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialMetricConversion.h"
#include "metric_conversion.cpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeHalfButton"
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialMetricConversion *formSpecialMetricConversion;
//---------------------------------------------------------------------------
__fastcall TformSpecialMetricConversion::TformSpecialMetricConversion(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
 IconIndex = 54;

 lookupTables->RegisterComboBox("units", comboSrc);
 // lookupTables->RegisterComboBox("units", comboDest);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialMetricConversion::FormClose(TObject *Sender,
      TCloseAction &Action)
{
 lookupTables->UnregisterComboBox(comboSrc);
 lookupTables->UnregisterComboBox(comboDest);
 TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialMetricConversion::buttonCloseClick(
      TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialMetricConversion::comboSrcChange(
      TObject *Sender)
{
 // unregister, re-register with only proper units?
 lookupTables->UnregisterComboBox(comboDest);

 if (!lookupTables->IsInLookUpTable("units", comboSrc))
  return;
 string src_unit_id = lookupTables->IdOf("units", comboSrc);
 string src_dim_id = GetOneField(dbDatabase, "select dimension_id from units where id = " + src_unit_id);
 lookupTables->RegisterComboBox("units", comboDest, "select id, item, valid from units where dimension_id = " + src_dim_id + " order by item");

 Convert();
}
//---------------------------------------------------------------------------
void TformSpecialMetricConversion::Convert()
{
 editDest->Text = "";

 // convert!
 if (!lookupTables->IsInLookUpTable("units", comboSrc))
  return;
 if (!lookupTables->IsInLookUpTable("units", comboDest))
  return;

 string src_unit_id = lookupTables->IdOf("units", comboSrc);
 string dest_unit_id = lookupTables->IdOf("units", comboDest);

 // order doesn't matter -- (src,dest) and (dest,src) should be the same.
 if (!CanConvertMetric(dbDatabase, src_unit_id, dest_unit_id))
  return;

 // TODO: StringToFloat seems to chop off some characters? that's a bad thing. have to see what can be done to improve precision.
 if (!IsFloat(editSrc->Text.c_str()))
  return;
 editDest->Text = FloatToStringApprox(FloatConvertMetric(dbDatabase, StringToFloat(editSrc->Text.c_str()), src_unit_id, dest_unit_id), 8).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialMetricConversion::editSrcChange(
      TObject *Sender)
{
 Convert();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialMetricConversion::comboDestChange(
      TObject *Sender)
{
 Convert();
}
//---------------------------------------------------------------------------

