//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialModifyPayable.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialModifyPayable *formSpecialModifyPayable;
//---------------------------------------------------------------------------
__fastcall TformSpecialModifyPayable::TformSpecialModifyPayable(TComponent* Owner, string bill_number, string task_number)
        : TformSpecialGeneric(Owner)
{
 panelSelectArea->Color = title_bar_color;
 bill_id = bill_number;
 task_id = task_number;

 if (bill_id != "" && IsInt(bill_id))
 {
  is_for_bill = true;
  task_id = "0";
 }
 else
 {
  is_for_bill = false;
  bill_id = "0";
 }


 acceptable_payments = acc_none;
 acceptable_payments |= acc_non_budget;
 acceptable_payments |= acc_non_closed;
 acceptable_payments |= acc_non_yearly;
 acceptable_payments |= acc_yearly;
 acceptable_payments |= acc_expense;


 acceptable_payments |= acc_receivable;

 string sql_find_payments = "select accounts.name name, accounts.id id, sum(transactions.debit_amount - transactions.credit_amount) total_exp from transactions inner join accounts on transactions.account_id = accounts.id where accounts.account_type_id = " + lookupTables->IdOf("account_types", "Expense");
 if (is_for_bill)
  sql_find_payments += " and transactions.bill_id = " + bill_id;
 else
  sql_find_payments += " and transactions.task_id = " + task_id;
 sql_find_payments += " group by accounts.id, accounts.name";

 SetAccountAmount(editAccount, editAmount, listPayments, acceptable_payments);

 if (SqlToVecMap(dbDatabase, sql_find_payments, expenses_so_far))
 {
  for (vector<map<string, string> >::iterator i_exp = expenses_so_far.begin(); i_exp != expenses_so_far.end(); i_exp++)
  {
   TListItem * new_row = NULL;
   new_row = listPayments->Items->Add();
   new_row->Caption = (*i_exp)["name"].c_str();
   new_row->SubItems->Clear();
   new_row->SubItems->Add((StringToAmount((*i_exp)["total_exp"])).c_str());
   new_row->SubItems->Add((*i_exp)["id"].c_str());
   listPayments->Selected = NULL;
  }
 } else
  PSay("Error while trying to fetch transactions to date on this item", m_database_error, MB_OK);

  // check for a purchase request -- if true then they can modify the account, but not the amount
  bill_is_on_purchase_req = false;

  // check to see if the pr is on a check.  if true then do not allow them to modify account or amount
  bill_is_on_purchase_req_on_check = false;

  if (is_for_bill)
  {
   string sql_verify_no_purchase_req = "select bills.purchase_req_id from bills where bills.id = " + bill_id;
   string found_purchase_req_id = GetOneField(dbDatabase, sql_verify_no_purchase_req);
   if (found_purchase_req_id != "" && found_purchase_req_id != "0")
    bill_is_on_purchase_req = true;

   string sql_verify_no_check = "select purchase_reqs.check_id from purchase_reqs inner join bills on bills.purchase_req_id = purchase_reqs.id where bills.id = " + bill_id;
   string found_check = GetOneField(dbDatabase, sql_verify_no_check);
   if (found_check != "" && found_check != "0")
    bill_is_on_purchase_req_on_check = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialModifyPayable::buttonAddPaymentClick(
      TObject *Sender)
{
 if (bill_is_on_purchase_req_on_check)
 {
   PSay("Can't add payments to a bill that is on a check.", m_warning, MB_OK);
   return;
 }
 else if (bill_is_on_purchase_req)
 {
   bool account_found = false;
   // find the account that is equal to they one they entered. if the amount does not match them do not let them add it
   for (vector<map<string, string> >::iterator i_exp = expenses_so_far.begin(); i_exp != expenses_so_far.end(); i_exp++)
   {
     if (string(editAccount->Text.c_str()) == (*i_exp)["name"])
     {
       account_found = true;
       if (string(editAmount->Text.c_str()) != (*i_exp)["total_exp"])
       {
         PSay("This bill is on a PR.  You may not change the amount this bill is for.", m_warning, MB_OK);
         return;

       }
     }
   }
   // they can not add a new account and amount.
   if (!account_found)
   {
     if (listPayments->SelCount == 0)
     {
       PSay("This bill is on a PR.  You may not add an amount to this bill.", m_warning, MB_OK);
       return;
     }
   }
 }
 // add payment
 AddAccountAmount (editAccount, editAmount, listPayments, acceptable_payments);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialModifyPayable::buttonDeletePaymentClick(
      TObject *Sender)
{
 if (bill_is_on_purchase_req_on_check)
 {
   PSay("Can't remove payments from a bill that is on a check.", m_warning, MB_OK);
   return;
 }
 else if (bill_is_on_purchase_req)
 {
   PSay("This bill is on a PR.  You may not remove payments.", m_warning, MB_OK);
   return;
 }
 // delete payment
 DelAccountAmount (editAccount, editAmount, listPayments, acceptable_payments);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialModifyPayable::listPaymentsSelectItem(
      TObject *Sender, TListItem *Item, bool Selected)
{
 // select payment
 ModAccountAmount (editAccount, editAmount, listPayments, acceptable_payments);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialModifyPayable::buttonFinishClick(
      TObject *Sender)
{
 // finish
 int user_answer = PSay("This change could be difficult to undo. Please make sure you truly intended this action.", m_confirmation, MB_YESNO);
 if (user_answer == IDNO)
  return;

 TIBTransaction * dbTransaction = new TIBTransaction(NULL);
 try
 {
  dbTransaction->DefaultDatabase = dbDatabase;
  dbTransaction->DefaultAction = TARollback;
  dbTransaction->StartTransaction();

  if (!bill_is_on_purchase_req_on_check)
  {
    // this time, we don't want to re-obligate stuff. instead ... we want to cancel the expense and the payable, rather than the cash and the anti-obligation
    // TODO: some sort of group by? select only fields needed?

    string current_transaction_number = GetNextId(dbTransaction, "transact_number");

    string sql_select_expense = "select * from transactions inner join accounts on transactions.account_id = accounts.id where accounts.account_type_id = " + lookupTables->IdOf("account_types", "Expense");

    if (is_for_bill)
     sql_select_expense += " and transactions.bill_id = " + bill_id;
    else
     sql_select_expense += " and transactions.task_id = " + task_id;

    vector<map<string, string> > expense_transactions;
    SqlToVecMap(dbTransaction, sql_select_expense, expense_transactions);

    for (vector<map<string, string> >::iterator i_old = expense_transactions.begin();
         i_old != expense_transactions.end(); i_old++)
    {
     map<string, string> reverse_transaction_core;
     reverse_transaction_core["transaction_number"] = current_transaction_number;
     reverse_transaction_core["effective_date"] = CurrentDate(); // TODO: EFFECTIVE_DATE
     reverse_transaction_core["current_id"] = "4";
     reverse_transaction_core["last_update_stamp"] = RightNow();
     reverse_transaction_core["last_updated_by"] = current_userid;
     reverse_transaction_core["tax_entity_id"] = (*i_old)["tax_entity_id"];
     reverse_transaction_core["task_id"] = (*i_old)["task_id"];
     reverse_transaction_core["bill_id"] = (*i_old)["bill_id"];

     map<string, string> reverse_transaction_payable = reverse_transaction_core;
     map<string, string> reverse_transaction_self = reverse_transaction_core;

     string payable_account_id = EquivAccount (pending_ref, (*i_old)["account_id"]);
     string self_account_id = (*i_old)["account_id"];

     if (payable_account_id != "")
     {
      reverse_transaction_payable["note"] = "Cancelling of payable transactions on bill or task because a/p is being modified";
      reverse_transaction_payable["id"] = GetNextId(dbTransaction, "transactions");
      reverse_transaction_payable["account_id"] = payable_account_id;
      reverse_transaction_payable["credit_amount"] = (*i_old)["credit_amount"];
      reverse_transaction_payable["debit_amount"] = (*i_old)["debit_amount"];
      if (!ExecuteInsertStatement(dbTransaction, "transactions", reverse_transaction_payable))
      {
       PSay("Failed to insert a reversal (payable) transaction.", m_database_error, MB_OK);
       throw(15);
      }
     }
     else
     {
      PSay("Could not identify the accounts payable account to undo based on the expense account used.", m_missing_data, MB_OK);
      throw(16);
     }

     if (self_account_id != "")
     {
      reverse_transaction_self["note"] = "Cancelling of expense transactions on bill or task because a/p is being modified";
      reverse_transaction_self["id"] = GetNextId(dbTransaction, "transactions");
      reverse_transaction_self["account_id"] = self_account_id;
      reverse_transaction_self["credit_amount"] = (*i_old)["debit_amount"];
      reverse_transaction_self["debit_amount"] = (*i_old)["credit_amount"];
      if (!ExecuteInsertStatement(dbTransaction, "transactions", reverse_transaction_self))
      {
       PSay("Failed to insert a reversal (expense) transaction.", m_database_error, MB_OK);
       throw(14);
      }
     }
     else
     {
      PSay("Could not identify the expense (self) account to undo based on the expense account used.", m_missing_data, MB_OK);
      throw(17);
     }
    }

   string provider_id = "0";
   string sql_select_provider_id;
   if (is_for_bill)
    sql_select_provider_id = "select bills.actual_tax_id from bills where bills.id = " + bill_id;
   else
    sql_select_provider_id = "select services_provided.tax_entity_id from services_provided inner join tasks on tasks.services_provided_id = services_provided.id where tasks.id = " + task_id;

   provider_id = GetOneField(dbTransaction, sql_select_provider_id);
   if (provider_id == "")
    provider_id = "0";

   // now that we've reversed the a/p, we wnat to put it back in, if any was given. yup.
   map<string, string> insert_transaction_core;
   insert_transaction_core["current_id"] = "4";
   insert_transaction_core["last_update_stamp"] = RightNow();
   insert_transaction_core["last_updated_by"] = current_userid;
   insert_transaction_core["task_id"] = task_id;
   insert_transaction_core["bill_id"] = bill_id;
   insert_transaction_core["tax_entity_id"] = provider_id;
   insert_transaction_core["effective_date"] = CurrentDate(); // TODO: EFFECTIVE_DATE
   insert_transaction_core["credit_amount"] = "0.00";
   insert_transaction_core["debit_amount"] = "0.00";
   insert_transaction_core["transaction_number"] = current_transaction_number;

   map<string, string> all_payments = GetAccountAmount(listPayments);
   for (map<string, string>::iterator i_payment = all_payments.begin(); i_payment != all_payments.end(); i_payment++)
   {
    // for each, we see only the expense account listed, but we need to remember to also deal
    // with the payable account too! so for each of these, figure out what the A/P account is,
    // and run transactions against it too

    acc_info pay_account = EquivAccountInfo (pending_ref, i_payment->first);
    if (pay_account.IsClosed() || !pay_account.IsFound())
    {
     PSay("An accounts payable account number could not be found to match this expense account.", m_missing_data, MB_OK);
     throw(2);
    }
    string id_of_pay_account = pay_account.id;

    map<string, string> expense_transaction = insert_transaction_core;
    map<string, string> payable_transaction = insert_transaction_core;

    expense_transaction["id"] = GetNextId(dbTransaction, "transactions");
    expense_transaction["note"] = "Modified expense on task or bill";
    expense_transaction["account_id"] = i_payment->first;
    expense_transaction["debit_amount"] = AmountToString(i_payment->second);

    payable_transaction["id"] = GetNextId(dbTransaction, "transactions");
    payable_transaction["note"] = "Modified payable on task or bill";
    payable_transaction["account_id"] = id_of_pay_account;
    payable_transaction["credit_amount"] = AmountToString(i_payment->second);

    if (!ExecuteInsertStatement(dbTransaction, "transactions", expense_transaction))
     throw (3);

    if (!ExecuteInsertStatement(dbTransaction, "transactions", payable_transaction))
     throw (4);
   }
  }
  else
  {
    PSay("Can't modify payments on a bill after a check has been posted.", m_warning, MB_OK);
  }
  dbTransaction->Commit();

  // if there is a balance of zero left on the bill then mark it as deleted
  string sql = "select (sum(transactions.debit_amount) - sum(transactions.credit_amount)) balance "
               "from bills "
               "left join transactions on bills.id = transactions.bill_id "
               "left join accounts on transactions.account_id = accounts.id "
               "where accounts.account_type_id = '" + lookupTables->IdOf("account_types", "EXPENSE") + "' and "
               "bills.id = " + bill_id;
  string transaction_balance = GetOneField(dbDatabase, sql);
  if (StringToFinancial(transaction_balance) == 0.00)
    {
     sql = "update bills set current_id = 0 where id = " + bill_id;
     if (!ExecuteStatement(dbDatabase, sql))
       {
        PSay("There is a balance of 0.00 on this bill, but the the program is unable ot mark it as deleted.", m_database_error, MB_OK);
       }
    }

  Close();
 }
 catch (...)
 {
  if (dbTransaction->Active)
   dbTransaction->Rollback();
  PSay("Couldn't modify the accounts payable related to this item.", m_database_error, MB_OK);
 }
 delete dbTransaction;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialModifyPayable::buttonCloseClick(
      TObject *Sender)
{
 // close
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialModifyPayable::FormClose(TObject *Sender,
      TCloseAction &Action)
{
 // on form close
 TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialModifyPayable::editAmountKeyPress(
      TObject *Sender, char &Key)
{
  if (bill_is_on_purchase_req)
  {
    PSay("This bill is on a PR.  Its amount can not be modified", m_warning, MB_OK);
    Key = '\0';
  }
}
//---------------------------------------------------------------------------

