//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialMultipleWarningsBlocks.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialMultipleWarningsBlocks *formSpecialMultipleWarningsBlocks;
//---------------------------------------------------------------------------
__fastcall TformSpecialMultipleWarningsBlocks::TformSpecialMultipleWarningsBlocks(TComponent* Owner, vector<warning_row> & p_warning_rows)
        : TformSpecialGeneric(Owner), warning_rows(p_warning_rows)
{
 IconIndex = 41;

 // setup listview from incoming data, keep track of reference (above)
 unsigned int known_size = warning_rows.size();
 for (unsigned int i = 0; i < known_size; i++)
  list_row_to_warn_row[warning_rows[i].AddToListview(listItems)] = i;

 // TODO: go to first -unchecked- item (if any) that can be checked (not gray)
 if (listItems->Items->Count)
  listItems->Items->Item[0]->Selected = true;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialMultipleWarningsBlocks::buttonCloseClick(
      TObject *Sender)
{
 ModalResult = mrOk;
 Close();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialMultipleWarningsBlocks::listItemsMouseMove(
      TObject *Sender, TShiftState Shift, int X, int Y)
{
  x_pos = X;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialMultipleWarningsBlocks::listItemsClick(
      TObject *Sender)
{
 if (listItems->SelCount > 0)
 {
  TListItem * row = listItems->Selected;

  x_pos -= row->Position.x - 2; // TODO -c MAGIC : no idea where '2' comes from exactly, or when it might change. -- actually, that's border width. just forgot to update comments elesewhere.

  int i;
  int left = 0;
  for (i = 0; i < listItems->Columns->Count; i++)
  {
   if (x_pos >= left && x_pos < left + min(imageList->Width, listItems->Columns->Items[i]->Width))
    break;
   left += listItems->Columns->Items[i]->Width;
  }

  // only one column is clickable at all, and it's not at the end as it was on permissions screens
  if (i == 1)
  {
   if (row->SubItemImages[0] == 0)
    row->SubItemImages[0] = 1;
   else if (row->SubItemImages[0] == 1)
    row->SubItemImages[0] = 0;
  }
 }
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialMultipleWarningsBlocks::FormClose(
      TObject *Sender, TCloseAction &Action)
{
 // record changes (go back through listview, modify appropriately in-place)
 for (map<TListItem *, unsigned int>::iterator i_row = list_row_to_warn_row.begin(); i_row != list_row_to_warn_row.end(); i_row++)
  warning_rows[i_row->second].GetFromListitem(i_row->first);

 TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialMultipleWarningsBlocks::listItemsKeyPress(
      TObject *Sender, char &Key)
{
 // space -> click in [x] column!
 if (listItems->SelCount > 0)
 {
  TListItem * row = listItems->Selected;
  if (row->SubItemImages[0] == 0)
   row->SubItemImages[0] = 1;
  else if (row->SubItemImages[0] == 1)
   row->SubItemImages[0] = 0;

  if (listItems->Items->Count - listItems->Selected->Index > 1)
   listItems->Items->Item[listItems->Selected->Index + 1]->Selected = true;
  else
   listItems->Selected = NULL;
 } else
  buttonClose->Click();
}
//---------------------------------------------------------------------------
/*

// in the wizard's .h file
 #include "codeSpecialMultipleWarningsBlocks.h"
 // find warnings/blocks per-page, so we can back up / move forward in the wizard, sync the warnings
 vector<warning_row> warning_rows;
 void UpdateWarnings (int page_index);

// in wizard::IsValidPage

 // remove warnings for all pages not in the back-history, including this current page
 // that which has already been seen, stays.
 // (no reason to ask again if it can be easily avoided.)

 for (vector<warning_row>::iterator i_row = warning_rows.begin(); i_row != warning_rows.end(); *//* note: nothing *//*)
  if (!HistoryIncludes((int)(i_row->identifier)) || (int)(i_row->identifier) == page_index)
   i_row = warning_rows.erase(i_row);
  else
   i_row++;


// further down

 // test for dependency-driven warnings on that pop-up thingie? (move stuff from there to this function?)
 UpdateWarnings(page_index);
 return CanOverrideWarnings(warning_rows);

 // rather than return true

// how this got used, for a bit (testing)

void TformWizardNewContractHealthItem::UpdateWarnings (int page_index)
{
 if (page_index == start_page)
 {
  // born, not dead
  // tribal affiliations

  // TODO: is_enrolled stored proc?
  map<string, string> person_info;
  vector<map<string, string> > affiliations_info;

  bool person_info_okay = SqlToMap(dbDatabase, "select birth_date, death_date from people where id = " + selected_person_id, person_info);
  bool affiliations_info_okay = SqlToVecMap(dbDatabase, "select join_date, relinquish_date, cdib, tribe_id from affiliations where person_id = " + selected_person_id, affiliations_info);

  if (!person_info_okay)
   warning_rows.push_back(warning_row(warning_icon_error, warning_check_unchecked, "Database error while verifying this person is alive today.", (void *)page_index));
  else
  if ((person_info["birth_date"] != "" && Pdate(person_info["birth_date"], global_mode) > Pdate(Date())) ||
      (person_info["death_date"] != "" && Pdate(person_info["death_date"], global_mode) < Pdate(Date())))
  {
   warning_rows.push_back(warning_row(warning_icon_warning, warning_check_unchecked, "Person is not alive today.", (void *)page_index));
   warning_rows.push_back(warning_row(warning_icon_warning, warning_check_none, "Born: " + person_info["birth_date"] + ", Died: " + person_info["death_date"], (void *)page_index));
  }

  if (!affiliations_info_okay)
   warning_rows.push_back(warning_row(warning_icon_error, warning_check_unchecked, "Database error while verifying this person is enrolled with the AST today.", (void *)page_index));
  else
  {
   bool found_current_ast = false;
   for (vector<map<string, string> >::iterator i_aff = affiliations_info.begin(); i_aff != affiliations_info.end(); i_aff++)
    if ((*i_aff)["tribe_id"] == lookupTables->IdOf("tribe_types", "ABSENTEE SHAWNEE TRIBES OF OKLAHOMA") &&
        ((*i_aff)["join_date"] == "" || Pdate((*i_aff)["join_date"], global_mode) <= Pdate(Date())) &&
        ((*i_aff)["relinquish_date"] == "" || Pdate((*i_aff)["relinquish_date"], global_mode) >= Pdate(Date())) &&
        (*i_aff)["cdib"] != "")
     found_current_ast = true;
   if (!found_current_ast)
   {
    warning_rows.push_back(warning_row(warning_icon_warning, warning_check_unchecked, "Person is not enrolled with the AST today. Other affiliations (if any) may be found listed below.", (void *)page_index));
    for (vector<map<string, string> >::iterator i_aff = affiliations_info.begin(); i_aff != affiliations_info.end(); i_aff++)
     warning_rows.push_back(warning_row(warning_icon_warning, warning_check_none, "From " + (*i_aff)["join_date"] + " to " + (*i_aff)["relinquish_date"] + ", CDIB " + (*i_aff)["cdib"] + " with " + PrettyString(lookupTables->ValueOf("tribe_types", (*i_aff)["tribe_id"])), (void *)page_index));
   }
  }

  warning_rows.push_back(warning_row(warning_icon_warning, warning_check_unchecked, "Notes", (void *)page_index));
 }

 switch (page_index)
 {
  // whichever we should get to first? (first time we get a date, that is)
  case 9: // appointment
  case 14: // visit
  {
   string was_alive = GetOneField(dbDatabase, "");
   string was_enrolled = GetOneField(dbDatabase, "");
   warning_rows.push_back(warning_row(warning_icon_warning, warning_check_unchecked, "Duplicate COB", (void *)page_index));
   warning_rows.push_back(warning_row(warning_icon_warning, warning_check_unchecked, "Duplicate Bill", (void *)page_index));
   break;
  }
 }
 return;
}
//---------------------------------------------------------------------------
*//*
  // note: don't some of these depend on information gained later in the thingie?
  // does it also depend on what we're doing? (bill vs. cob vs. bill+cob)
  // some of this would be better "as we go" rather than all up-front. that's a problem.

  when do we get:
   person_id   : 0 or 7
   date        : 14 (if bill) or 9 (if cob only)
   selected_cob: 0

  person_id only:
   enrolled tribal affiliation
   born, not dead
   warning/blocking notes

  person_id + date:
   existing cob
   existing bill

  person_id + selected_cob:
   already a bill on it (already a message box?)

  // 7 - already similar MVA case
       -> eh ... not doing MVA yet
  // 8 - already MVA this might go with (when not creating the MVA)
       -> eh, again, MVA isn't working (thanks for leaving suddenly Cynthia ... grr.)
*//*
//---------------------------------------------------------------------------

*/

