//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialNewBudgetMod.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialNewBudgetMod *formSpecialNewBudgetMod;
//---------------------------------------------------------------------------
__fastcall TformSpecialNewBudgetMod::TformSpecialNewBudgetMod(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
 panelSelectArea->Color = title_bar_color;
 ResetAll();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewBudgetMod::buttonBackClick(TObject *Sender)
{
 // back
 if (pageBudgetMod->ActivePageIndex == 1)
 {
  pageBudgetMod->ActivePageIndex = 0;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewBudgetMod::buttonNextClick(TObject *Sender)
{
 // next
 bool allow_change = true;
 if (pageBudgetMod->ActivePageIndex == 0)
 {
  // Next page, from first page
  // must be same type (taken care of by the filters that change with radio buttons)
  // must balance (absolutely)
  financial sum_from = 0.0;
  financial sum_to = 0.0;

  map<string, string> amounts_from = GetAccountAmount(listFromAccounts);
  map<string, string> amounts_to   = GetAccountAmount(listToAccounts);

  // PSay(string("Moving from " + IntToString(amounts_from.size()) + " budgets to " + IntToString(amounts_to.size()) + " budgets."), m_message, MB_OK);


  for (map<string, string>::iterator i_from = amounts_from.begin(); i_from != amounts_from.end(); i_from++)
   sum_from += StringToFinancial(i_from->second);

  for (map<string, string>::iterator i_to = amounts_to.begin(); i_to != amounts_to.end(); i_to++)
   sum_to += StringToFinancial(i_to->second);

  //PSay(string("Moving $" + FloatToString(sum_from) + " to $" + FloatToString(sum_to) + "."), m_message, MB_OK);

  if (sum_to != sum_from)
  {
   allow_change = false;
   string error_message = "This transaction does not balance: ";
   error_message += FinancialToString(sum_from, true);
   error_message += " vs. ";
   error_message += FinancialToString(sum_to, true);
   PSay(error_message, m_invalid_data, MB_OK);
  }
  else if (sum_to < 1.00)
  {
   allow_change = false;
   PSay("Budget mods must be of at least $1.00.", m_invalid_data, MB_OK);
  }

  string sql_get_account_names = "select accounts.id, accounts.name from accounts where is_budget = 1 and is_closed = 0";
  map<string, string> budget_names;
  if (!SqlToValueMap(dbDatabase, sql_get_account_names, budget_names))
  {
   allow_change = false;
   PSay("Could not retrieve names of budget accounts.", m_database_error, MB_OK);
  }

  string sql_get_current_budgets;
  if (radioExpenseBudget->Checked)
   sql_get_current_budgets = "select accounts.id, sum(transactions.debit_amount - transactions.credit_amount) from transactions right join accounts on transactions.account_id = accounts.id where accounts.account_type_id = 4 and accounts.is_budget = 1 and accounts.is_closed = 0 group by accounts.id";
  else
   sql_get_current_budgets = "select accounts.id, sum(transactions.credit_amount - transactions.debit_amount) from transactions right join accounts on transactions.account_id = accounts.id where accounts.account_type_id = 5 and accounts.is_budget = 1 and accounts.is_closed = 0 group by accounts.id";
  map<string, string> budget_amounts;
  if (!SqlToValueMap(dbDatabase, sql_get_current_budgets, budget_amounts))
  {
   allow_change = false;
   PSay("Could not retrieve current budget amounts.", m_database_error, MB_OK);
  }

  for (map<string, string>::iterator i_from = amounts_from.begin(); i_from != amounts_from.end(); i_from++)
  {
   financial budget_amount = StringToFinancial(budget_amounts[i_from->first]);
   financial budget_change = StringToFinancial(i_from->second);
   financial budget_effect = budget_amount - budget_change;
   if (budget_effect < 0.00)
   {
    allow_change = false;
    PSay(string("Your change would leave account " + budget_names[i_from->first] + " with a negative budget of $" + FinancialToString(budget_effect, true) + " which is not particularly good."), m_invalid_data, MB_OK);
   }
  }

  for (map<string, string>::iterator i_to = amounts_to.begin(); i_to != amounts_to.end(); i_to++)
  {
   financial budget_amount = StringToFinancial(budget_amounts[i_to->first]);
   financial budget_change = StringToFinancial(i_to->second);
   financial budget_effect = budget_amount + budget_change;
   if (budget_effect < 0.00)
   {
    allow_change = false;
    PSay(string("Your change would leave account " + budget_names[i_to->first] + " with a negative budget of $" + FinancialToString(budget_effect, true) + " which is not particularly good.").c_str(), m_invalid_data, MB_OK);
   }
  }

  if (allow_change)
  {
   sheetFinal->Show();
   staticHeader->Caption = "2 of 2 - Complete and confirm budget modification";
   buttonBack->Enabled = true;
   buttonNext->Caption = "Finish";
  }
 }
 else
 {
  // Finish

  if (allow_change)
  {
   // database stuff
   map<string, string> amounts_from = GetAccountAmount(listFromAccounts);
   map<string, string> amounts_to   = GetAccountAmount(listToAccounts);

   TIBTransaction * dbTransaction = new TIBTransaction(NULL);
   try
   {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbTransaction->DefaultAction = TARollback;
    dbTransaction->StartTransaction();

    map<string, string> temp_transaction;
    for (map<string, string>::iterator i_from = amounts_from.begin(); i_from != amounts_from.end(); i_from++)
    {
     temp_transaction.clear();
     temp_transaction["id"] = GetNextId(dbTransaction, "transactions");
     temp_transaction["current_id"] = "4";
     temp_transaction["last_update_stamp"] = RightNow();
     temp_transaction["last_updated_by"] = current_userid;
     temp_transaction["task_id"] = "0";
     temp_transaction["bill_id"] = "0";
     temp_transaction["tax_entity_id"] = "0";
     temp_transaction["account_id"] = i_from->first;
     temp_transaction["effective_date"] = Pdate(dateEffective->Date).OutDate(mdy | yyyy);
     temp_transaction["note"] = editReason->Text.c_str();
     if (radioExpenseBudget->Checked)
     {
      temp_transaction["credit_amount"] = AmountToString(i_from->second);
      temp_transaction["debit_amount"] = "0.00";
     }
     else
     {
      temp_transaction["debit_amount"] = AmountToString(i_from->second);
      temp_transaction["credit_amount"] = "0.00";
     }
     temp_transaction["transaction_number"] = labelTransactionNumber->Caption.c_str();
     atlas->Notify("transactions.id", temp_transaction["id"]);
     atlas->Notify("transactions.account_id", temp_transaction["account_id"]);
     if (!ExecuteInsertStatement(dbTransaction, "transactions", temp_transaction))
      throw (4);
    }
    for (map<string, string>::iterator i_to = amounts_to.begin(); i_to != amounts_to.end(); i_to++)
    {
     temp_transaction.clear();
     temp_transaction["id"] = GetNextId(dbTransaction, "transactions");
     temp_transaction["current_id"] = "4";
     temp_transaction["last_update_stamp"] = RightNow();
     temp_transaction["last_updated_by"] = current_userid;
     temp_transaction["task_id"] = "0";
     temp_transaction["bill_id"] = "0";
     temp_transaction["tax_entity_id"] = "0";
     temp_transaction["account_id"] = i_to->first;
     temp_transaction["effective_date"] = Pdate(dateEffective->Date).OutDate(mdy | yyyy);
     temp_transaction["note"] = editReason->Text.c_str();
     if (radioExpenseBudget->Checked)
     {
      temp_transaction["debit_amount"] = AmountToString(i_to->second);
      temp_transaction["credit_amount"] = "0.00";
     }
     else
     {
      temp_transaction["credit_amount"] = AmountToString(i_to->second);
      temp_transaction["debit_amount"] = "0.00";
     }
     temp_transaction["transaction_number"] = labelTransactionNumber->Caption.c_str();
     atlas->Notify("transactions.id", temp_transaction["id"]);
     atlas->Notify("transactions.account_id", temp_transaction["account_id"]);
     if (!ExecuteInsertStatement(dbTransaction, "transactions", temp_transaction))
      throw (19);
    }
    dbTransaction->Commit();

    ResetAll();
   }
   catch (...)
   {
    if (dbTransaction->Active)
     dbTransaction->Rollback();
    PSay("Couldn't save these transactions, please contact your systems administrator.", m_database_error, MB_OK);
   }
   delete dbTransaction;
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewBudgetMod::buttonCancelClick(
      TObject *Sender)
{
 // cancel
 ResetAll();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewBudgetMod::buttonAddFromClick(
      TObject *Sender)
{
 // add to top list
 AddAccountAmount(editFromAccount, editFromAmount, listFromAccounts, accept_accounts_from);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewBudgetMod::buttonDelFromClick(
      TObject *Sender)
{
 // del from top list
 DelAccountAmount(editFromAccount, editFromAmount, listFromAccounts, accept_accounts_from);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewBudgetMod::buttonAddToClick(TObject *Sender)
{
 // add in bottom list
 AddAccountAmount(editToAccount, editToAmount, listToAccounts, accept_accounts_to);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewBudgetMod::buttonDelToClick(TObject *Sender)
{
 // del from bottom list
 DelAccountAmount(editToAccount, editToAmount, listToAccounts, accept_accounts_to);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewBudgetMod::RadioBudgetTypeClick(TObject *Sender)
{
 // changing types of budget?
 ResetAll();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewBudgetMod::buttonClosedClick(
      TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewBudgetMod::listFromAccountsSelectItem(
      TObject *Sender, TListItem *Item, bool Selected)
{
 // mod
 ModAccountAmount(editFromAccount, editFromAmount, listFromAccounts, accept_accounts_from);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewBudgetMod::listToAccountsSelectItem(
      TObject *Sender, TListItem *Item, bool Selected)
{
 // mod
 ModAccountAmount(editToAccount, editToAmount, listToAccounts, accept_accounts_to);
}
//---------------------------------------------------------------------------
void TformSpecialNewBudgetMod::ResetAll()
{
 pageBudgetMod->ActivePageIndex = 0;
 buttonBack->Enabled = false;
 buttonNext->Caption = "Next >>";

 accept_accounts_from = acc_none;
 accept_accounts_from |= acc_budget;
 accept_accounts_from |= acc_non_closed;
 accept_accounts_from |= acc_non_yearly;
 accept_accounts_from |= acc_yearly;

 if (radioExpenseBudget->Checked)
  accept_accounts_from |= acc_expense;
 else
  accept_accounts_from |= acc_expense;

 accept_accounts_to = accept_accounts_from;
 SetAccountAmount(editFromAccount, editFromAmount, listFromAccounts, accept_accounts_from);
 SetAccountAmount(editToAccount, editToAmount, listToAccounts, accept_accounts_to);

 dateEffective->Date = Date();
 // dateEffective->Date.CurrentDate();
 editReason->Text = "";
 labelTransactionNumber->Caption = GetOneField(dbDatabase, "select gen_id(transact_number_gen, 1) from uno").c_str();
 staticHeader->Caption = "1 of 2 - Select accounts and amounts of budget modification";
}
//---------------------------------------------------------------------------

