//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialNewCOB.h"
#include "codeSearchPerson.h"
#include "codeSearchTaxEntity.h"
#include "codeSpecialPersonLimits.h"
#include "codeRecordInsuranceCoverage.h"
#include "codeRecordServiceProvided.h"
#include "launchPrintCobReport.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialNewCOB *formSpecialNewCOB;
//---------------------------------------------------------------------------
__fastcall TformSpecialNewCOB::TformSpecialNewCOB(TComponent* Owner)
        : TformSpecialGeneric(Owner)                   
{
 panelSelectArea->Color = title_bar_color;
 Start();
 ResetFirstPage();
 GotoFirstPage();
 services_request = 0;
 insurance_request = 0;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewCOB::buttonPatientSearchClick(
      TObject *Sender)
{
 // search patient
 vector<string> return_vector;
 FORM_TRY
   TformSearchPerson * find_person = new TformSearchPerson(NULL, &return_vector);
   find_person->ShowTaskModal();
 FORM_CATCH

 if (return_vector.size() == 1)
 {
  first_patient_id = return_vector[0];
  CreateLink(staticPatient, buttonPatientSearch, this, first_patient_id, "people", "");

  if((first_patient_id != "") && (first_patient_id != "0"))
  {
   string sql;
   sql = "select a.name, insurance_types.item, insurance_policies.policy_number, insurance_policies.group_number, "
         "area_types.item, insurance_benefits.note, "
         "insurance_policies.start_date, insurance_policies.stop_date, coverage_types.item, "
         "source_types.item, insurance_policies.name_on_policy, b.name, insurance_coverage.person_code, "
         "insurance_coverage.name_on_card, insurance_coverage.current_id, insurance_coverage.id "
         "from insurance_coverage "
         "left join insurance_policies on insurance_policies.id = insurance_coverage.insurance_policy_id "
         "left join coverage_types on coverage_types.id = insurance_policies.coverage_id "
         "left join source_types on source_types.id = insurance_policies.source_id "
         "left join insurance_benefits on insurance_policies.id = insurance_benefits.insurance_policy_id "
         "left join area_types on area_types.id = insurance_benefits.area_id "
         "left join tax_entities a on a.id = insurance_policies.tax_entity_id "
         "left join insurance_types on insurance_types.id = a.insurance_id "
         "left join tax_entities b on b.id = insurance_coverage.tax_entity_id "
         "where insurance_coverage.person_id = " + first_patient_id;
   insurance_filter.SetSQLStatement (sql);
   insurance_filter.RefreshDataSet();
   insurance_filter.SetAddEdit(this, AddRecord(&(TformSpecialNewCOB::AddInsurance)), EditRecord(&(TformSpecialNewCOB::EditInsurance)));
   atlas->CancelRequest(insurance_request);
   insurance_request = atlas->RequestNotificationWhen("insurance_coverage.person_id", first_patient_id, rel_e, as_int, this,
                       RefreshHandler(&(TformSpecialNewCOB::AtlasScreen)));
  }
 }
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::buttonProviderSearchClick(
      TObject *Sender)
{
 // search provider, update listview below
 vector<string> return_vector;
 FORM_TRY
   TformSearchTaxEntity * find_provider = new TformSearchTaxEntity(NULL, &return_vector);
   find_provider->ShowTaskModal();
 FORM_CATCH

 if (return_vector.size() == 1)
 {
  first_provider_id = return_vector[0];
  first_service_id = "";
  CreateLink(staticProvider, buttonProviderSearch, this, first_provider_id, "tax_entities", "");
  ResetServices(first_provider_id);
 }
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewCOB::ReferringProviderSearchClick(
      TObject *Sender)
{
 // search provider, update listview below
 vector<string> return_vector;
 FORM_TRY
   TformSearchTaxEntity * find_referring_provider = new TformSearchTaxEntity(NULL, &return_vector);
   find_referring_provider->ShowTaskModal();
 FORM_CATCH

 if (return_vector.size() == 1)
 {
  first_referring_id = return_vector[0];
  CreateLink(staticReferringProvider, ReferringProviderSearch, this, first_referring_id, "tax_entities", "");
 }
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewCOB::listServicesProvidedSelectItem(
      TObject *Sender, TListItem *Item, bool Selected)
{
 // select or deselect stuff ... or some such.
 first_service_id = services_filter.GetSelectedRecordID();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::listReferringPhysiciansSelectItem(
      TObject *Sender, TListItem *Item, bool Selected)
{
 // select or unselect referring physician        
 // select or deselect stuff ... or some such.
 first_referring_id = referrer_filter.GetSelectedRecordID();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::buttonAddAmountClick(TObject *Sender)
{
 // add or edit obligation        
 AddAccountAmount (editAccount, editAmount, listPayments, acceptable_payments);
 RefreshBudgetInfo();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::buttonDeleteAmountClick(TObject *Sender)
{
 // edit obligation, yup
 DelAccountAmount (editAccount, editAmount, listPayments, acceptable_payments);
 RefreshBudgetInfo();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::buttonBackClick(TObject *Sender)
{
 // back
 if (pageCOB->ActivePageIndex == 1)
  GotoFirstPage();
 else
 if (pageCOB->ActivePageIndex == 2)
  GotoSecondPage();
 else
 if (pageCOB->ActivePageIndex == 3)
  GotoThirdPage();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::buttonNextClick(TObject *Sender)
{
 // next
 if (pageCOB->ActivePageIndex == 0)
 {
  if (first_patient_id == "" || first_patient_id == "0")
  {
   PSay("You must select a patient in order to continue.", m_missing_data, MB_OK);
   return;
  } else
  if (first_service_id == "" || first_service_id == "0")
  {
   PSay("You must select a provider and a provider service.", m_missing_data, MB_OK);
   return;
  }
  if (second_patient_id != first_patient_id)
   ResetSecondPage();
  GotoSecondPage();
 } else
 if (pageCOB->ActivePageIndex == 1)
 {
  GotoThirdPage();
 } else
 if (pageCOB->ActivePageIndex == 2)
 {
  if (editReason->Text == "")
  {
   int user_answer = PSay("You have not specified a reason/diagnosis for this COB. Would you like to continue anyway?", m_confirmation, MB_YESNO);
   if (user_answer == IDNO)
    return;
  } else
  if (editUsage->Text == "")
  {
   int user_answer = PSay("You have not specified a usage note for the funds to be allocated to this COB. Would you like to continue anyway?", m_confirmation, MB_YESNO);
   if (user_answer == IDNO)
    return;
  }
  GotoFourthPage();
 } else
 if (pageCOB->ActivePageIndex == 3)
 {
  map<string, string> all_payments = GetAccountAmount (listPayments);
  float payment_amount = 0.00;
  for (map<string, string>::iterator i_payment = all_payments.begin(); i_payment != all_payments.end(); i_payment++)
   payment_amount += StringToFloat(AmountToString(i_payment->second));

  if (payment_amount == 0.00)
  {
   int user_answer = PSay("You have not specified any amount limit/moneys to be obligated. Would you like to continue anyway?", m_confirmation, MB_YESNO);
   if (user_answer == IDNO)
    return;
  } else
  if (payment_amount < 0.00)
  {
   PSay("Please specify a positive or zero amount to obligate.", m_invalid_data, MB_OK);
   return;
  }

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  try
  {
   dbTransaction->DefaultDatabase = dbDatabase;
   dbTransaction->DefaultAction = TARollback;
   dbTransaction->StartTransaction();

   map<string, string> insert_cob;
   insert_cob["id"] = GetNextId(dbTransaction, "tasks");
   insert_cob["current_id"] = "4";
   insert_cob["last_update_stamp"] = RightNow();
   insert_cob["last_updated_by"] = current_userid;
   insert_cob["person_id"] = first_patient_id;
   insert_cob["event_id"] = "0";
   insert_cob["group_id"] = "5"; // TODO -c MAGIC NUMBER :
   insert_cob["date_of_task"] = CurrentDate();
   insert_cob["time_of_task"] = CurrentTime();
   insert_cob["time_spent"] = "";
   insert_cob["mileage"] = "";
   insert_cob["task_comments"] = editReason->Text.c_str();
   insert_cob["visit_time_spent"] = "";
   insert_cob["visit_comments"] = editUsage->Text.c_str();
   insert_cob["method_id"] = "0"; // TODO :
   insert_cob["direction_id"] = "0"; // TODO :
   insert_cob["classification_id"] = "0"; // stupid field that needs to go away // TODO :
   insert_cob["beh_meeting_id"] = "0";
   insert_cob["beh_visit_id"] = "0";
   insert_cob["beh_activity_id"] = "0";
   insert_cob["visit_location_id"] = "0";
   insert_cob["is_educational"] = "0";
   insert_cob["is_personal"] = "0";
   insert_cob["diab_activity_id"] = "0";
   insert_cob["diab_contact_id"] = "0";
   insert_cob["diab_meeting_id"] = "0";
   insert_cob["diab_task_id"] = "0";
   insert_cob["diab_program_id"] = "0";
   insert_cob["user_id"] = current_userid; // TODO :
   insert_cob["visit_outcome_id"] = "0";
   insert_cob["com_meeting_id"] = "0";
   insert_cob["com_activity_id"] = "0";
   insert_cob["com_visit_id"] = "0";
   insert_cob["new_client"] = "0";
   insert_cob["beh_city_id"] = "0";
   insert_cob["beh_appt_id"] = "0";
   insert_cob["beh_service_id"] = "0";
   insert_cob["com_dept_id"] = "0";
   insert_cob["tax_entity_id"] = "0"; // intentionally left this way
   insert_cob["parent_task_id"] = "0";
   insert_cob["patient_control_number"] = "";
   insert_cob["services_provided_id"] = first_service_id;
   insert_cob["in_progress"] = "0";
   insert_cob["preconditions_note"] = "";
   insert_cob["followup_note"] = "";
   insert_cob["reported_by_note"] = "";
   insert_cob["hospitalized"] = "0";
   insert_cob["given_room"] = "0";
   insert_cob["cob_number"] = insert_cob["id"];
   insert_cob["care_service_id"] = "0";
   insert_cob["care_classification_id"] = "0";

   set<string> do_not_uppercase;
   do_not_uppercase.insert("task_comments");
   do_not_uppercase.insert("visit_comments");

   if (!ExecuteInsertStatement(dbTransaction, "tasks", insert_cob, 0, do_not_uppercase))
    throw (1);

   map<string, string> insert_appt;
   insert_appt["id"] = GetNextId(dbTransaction, "appointments");
   insert_appt["current_id"] = "4";
   insert_appt["last_update_stamp"] = RightNow();
   insert_appt["last_updated_by"] = current_userid;
   insert_appt["created_by"] = current_userid;
   insert_appt["created_for"] = "0"; //current_userid;
   insert_appt["description"] = "COB Number " +  insert_cob["cob_number"];
   Pdate appt_date(editDateService->Date);
   insert_appt["repeating_string"] = "0,0,0|0,0,0|0,0,0|0,0,0";
   insert_appt["begin_date"] = appt_date.OutDate(mdy | yyyy);
   insert_appt["end_date"] = appt_date.OutDate(mdy | yyyy);
   insert_appt["appointment_date"] = appt_date.OutDate(mdy | yyyy);
   insert_appt["appointment_time"] = Ptime(editTimeService->Time).OutTime(military | withsec);
   insert_appt["single_date"] = "1";
   insert_appt["duration"] = "30";
   insert_appt["duration_id"] = lookupTables->IdOf("duration_types", "Minutes");
   insert_appt["person_id"] = first_patient_id;
   insert_appt["visit_outcome_id"] = "0";
   insert_appt["tax_entity_id"] = first_provider_id;
   insert_appt["task_id"] = insert_cob["id"];
   Pstamp begin_stamp(insert_appt["appointment_date"] + " " + insert_appt["appointment_time"], mdy | yyyy | military | withsec | datefirst);
   Pstamp end_stamp = begin_stamp;
   end_stamp.mod(30, in_minutes);
   insert_appt["final_end_stamp"] = end_stamp.OutStamp(mdy | yyyy | military | withsec | datefirst);
   if (!ExecuteInsertStatement(dbTransaction, "appointments", insert_appt))
    throw (7);

   if (first_referring_id != "")
   {
    map<string, string> insert_ref;
    map<string, string> insert_note;
    insert_ref["id"] = GetNextId(dbTransaction, "referrals");
    insert_ref["current_id"] = "4";
    insert_ref["last_update_stamp"] = RightNow();
    insert_ref["last_updated_by"] = current_userid;
    insert_ref["person_id"] = insert_cob["person_id"];
    insert_ref["by_provider_id"] = first_referring_id;
    insert_ref["by_facility_id"] = "0";
    insert_ref["to_provider_id"] = first_provider_id;
    insert_ref["to_facility_id"] = "0";
    insert_ref["date_of_referral"] = CurrentDate();
    insert_ref["beh_refer_id"] = "0";
    insert_ref["com_refer_id"] = "0";
    insert_ref["diab_refer_id"] = "0";
    insert_ref["task_id"] = insert_cob["id"];
    insert_ref["todo_status_id"] = "0";
    if (!ExecuteInsertStatement(dbTransaction, "referrals", insert_ref))
     throw (8);

    insert_note["id"] = GetNextId(dbTransaction, "referral_notes");
    insert_note["current_id"] = "4";
    insert_note["last_update_stamp"] = RightNow();
    insert_note["last_updated_by"] = current_userid;
    insert_note["referral_id"] = insert_ref["id"];
    insert_note["date_of_note"] = insert_ref["date_of_referral"];
    insert_note["note"] = "COB-style referral";
    if (!ExecuteInsertStatement(dbTransaction, "referral_notes", insert_note))
     throw (8);
   }

   map<string, string> insert_transaction_core;
   insert_transaction_core["current_id"] = "4";
   insert_transaction_core["last_update_stamp"] = RightNow();
   insert_transaction_core["last_updated_by"] = current_userid;
   insert_transaction_core["task_id"] = insert_cob["id"];
   insert_transaction_core["bill_id"] = "0";
   insert_transaction_core["tax_entity_id"] = first_provider_id;
   insert_transaction_core["effective_date"] = insert_appt["appointment_date"]; // CurrentDate(); -- changed 2/13/2003 by philip, at user request
   insert_transaction_core["credit_amount"] = "0.00";
   insert_transaction_core["debit_amount"] = "0.00";
   insert_transaction_core["transaction_number"] = GetNextId(dbTransaction, "transact_number");

   map<string, string> all_payments = GetAccountAmount(listPayments);
   for (map<string, string>::iterator i_payment = all_payments.begin(); i_payment != all_payments.end(); i_payment++)
   {
    // for each, we see only the expense account listed, but we need to remember to also deal
    // with the payable account too! so for each of these, figure out what the A/P account is,
    // and run transactions against it too

    acc_info pay_account = EquivAccountInfo (pending_ref, i_payment->first);

    if (pay_account.IsClosed() || !pay_account.IsFound())
    {
     PSay("An accounts payable account number could not be found to match this expense account.", m_missing_data, MB_OK);
     throw(2);
    }

    string id_of_pay_account = pay_account.id;

    map<string, string> expense_transaction = insert_transaction_core;
    map<string, string> payable_transaction = insert_transaction_core;

    expense_transaction["id"] = GetNextId(dbTransaction, "transactions");
    expense_transaction["note"] = "Expense for COB number " + insert_cob["cob_number"];
    expense_transaction["account_id"] = i_payment->first;
    expense_transaction["debit_amount"] = AmountToString(i_payment->second);

    payable_transaction["id"] = GetNextId(dbTransaction, "transactions");
    payable_transaction["note"] = "Payable for COB number " + insert_cob["cob_number"];
    payable_transaction["account_id"] = id_of_pay_account;
    payable_transaction["credit_amount"] = AmountToString(i_payment->second);

    if (!ExecuteInsertStatement(dbTransaction, "transactions", expense_transaction))
     throw (3);

    if (!ExecuteInsertStatement(dbTransaction, "transactions", payable_transaction))
     throw (4);
   }

   dbTransaction->Commit();

   // insert_er_cob["id"] to launch the thingie
   FORM_TRY
     TformLaunchPrintCobReport * offer_to_print_cob = new TformLaunchPrintCobReport(NULL, insert_cob["id"]);
     offer_to_print_cob->ShowTaskModal();
   FORM_CATCH

   ResetFirstPage();
   GotoFirstPage();
  }
  catch (...)
  {
   if (dbTransaction->Active)
    dbTransaction->Rollback();
   PSay("Couldn't save the COB.", m_database_error, MB_OK);
  }
  delete dbTransaction;
 }
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::buttonCancelClick(TObject *Sender)
{
 // cancel
 ResetFirstPage();
 GotoFirstPage();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::buttonCloseClick(TObject *Sender)
{
 // close
 Close();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::staticUsualDentalClick(TObject *Sender)
{
 // $1000 Yearly limit, anything over this amount the client will be responsible for
 editUsage->Text = editUsage->Text + "$1000 yearly limit, anything over this amount will be the responsibility of the client. Bill private insurance first, A.S.T. is the payor of last resort.";
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::staticUsualOrthoClick(TObject *Sender)
{
 // $2000 lifetime limit, anything over this amount the client will be responsible for
 editUsage->Text = editUsage->Text + "$2000 lifetime limit, anything over this amount will be the responsibility of the client.";
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::staticUsualVisionClick(TObject *Sender)
{
 // $200 + $100 yearly limit, anyth....
 editUsage->Text = editUsage->Text + "$200 yearly limit, anything over this amount will be the responsibility of the client.";
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::staticUsualMedicalClick(TObject *Sender)
{
 // grab from serena ... nah.
 // instead, append --
 // ast is payor of last resort
 // more cob for more testing
 editUsage->Text = editUsage->Text + "A.S.T. is the payor of last resort. New authorizations will be required for additional treatment and/or testing.";
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::staticUsualHearingClick(TObject *Sender)
{
 // $1500 every three years, anything above ...
 editUsage->Text = editUsage->Text + "$1500 limit per three-year period, anything over this amount will be the responsibility of the client.";
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::FormClose(TObject *Sender,
      TCloseAction &Action)
{
 // on close
 Stop();
 TformSpecialGeneric::FormClose(Sender, Action);
}

//---------------------------------------------------------------------------
void TformSpecialNewCOB::Start()
{
 // setup ... stuff. like drop-downs and filters.
 //       classFilterObject coverage_filter;
 //       classFilterObject services_filter;
 acceptable_payments = acc_none;
 acceptable_payments |= acc_non_budget;
 acceptable_payments |= acc_non_closed;
 acceptable_payments |= acc_non_yearly;
 acceptable_payments |= acc_yearly;
 acceptable_payments |= acc_expense;

 staticPersonLimits->Font->Color = link_color;

 services_filter.SetListViewHandle(listServicesProvided);
 services_filter.SetSecurity("services_provided");
 services_filter.AddColumnSpec("Service", "services_provided", as_text, true, 140);
 services_filter.AddColumnSpec("Area", "services_provided", as_text, true, 80);
 services_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 services_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 services_filter.FetchPreferences("recordspecialnewcob.services_filter");
 services_filter.SetIconStatus(true);
 services_filter.SetSQLStatement("");
 services_filter.RefreshDataSet();

 referrer_filter.SetListViewHandle(listReferringPhysicians);
 referrer_filter.SetSecurity("tax_entities");
 referrer_filter.AddColumnSpec("Name", "tax_entities", as_text, true, 240);
 referrer_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 referrer_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 referrer_filter.FetchPreferences("recordspecialnewcob.referrer_filter");
 referrer_filter.SetHeader(false);
 referrer_filter.SetIconStatus(true);
 referrer_filter.SetSQLStatement("select tax_entities.name, tax_entities.current_id, tax_entities.id from tax_entities where tax_entities.is_referring = 1");
 referrer_filter.RefreshDataSet();

 insurance_filter.SetListViewHandle(listInsurance);
 insurance_filter.SetSecurity("insurance_coverage");
 insurance_filter.AddColumnSpec("Company", "tax_entities", as_text, true, 140);
 insurance_filter.AddColumnSpec("Medical Type", "tax_entities", as_text, true, 100);
 insurance_filter.AddColumnSpec("Policy Number", "insurance_policies", as_text, true, 120, rawString);
 insurance_filter.AddColumnSpec("Group Number", "insurance_policies", as_text, true, 120, rawString);
 insurance_filter.AddColumnSpec("Coverage Type", "insurance_benefits", as_text, true, 100);
 insurance_filter.AddColumnSpec("Coverage Note", "insurance_benefits", as_text, true, 120);
 insurance_filter.AddColumnSpec("Effective Date", "insurance_policies", as_date, true, 120);
 insurance_filter.AddColumnSpec("Termination Date", "insurance_policies", as_date, false, 120);
 insurance_filter.AddColumnSpec("Coverage", "insurance_policies", as_text, false, 120);
 insurance_filter.AddColumnSpec("Source", "insurance_policies", as_text, false, 120);
 insurance_filter.AddColumnSpec("Name on Policy", "insurance_policies", as_text, false, 120);
 insurance_filter.AddColumnSpec("PCP", "tax_entities", as_text, true, 120);
 insurance_filter.AddColumnSpec("Person Code", "insurance_coverage", as_int, false, 100);
 insurance_filter.AddColumnSpec("Name on Card", "insurance_coverage", as_text, false, 100);
 insurance_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 insurance_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 insurance_filter.FetchPreferences("recordspecialnewcob.insurance_filter");
 insurance_filter.SetIconStatus(true);
 insurance_filter.SetSQLStatement("");
 insurance_filter.RefreshDataSet();

 if (optionsPermissions["special.outside_referral"]["enabled"] == "true") 
   cboOutsideReferral->Enabled = true;

 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewCOB::RefreshBudgetInfo()
{
 map<string, string> all_payments = GetAccountAmount (listPayments);
 float payment_amount = 0.00;
 for (map<string, string>::iterator i_payment = all_payments.begin(); i_payment != all_payments.end(); i_payment++)
  payment_amount += StringToFloat(AmountToString(i_payment->second));

 labelAmountPayment->Caption = StringToAmount(FloatToString(payment_amount)).c_str();
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewCOB::Stop()
{
 // undo any drop-downs?
}
//---------------------------------------------------------------------------
void TformSpecialNewCOB::ResetFirstPage()
{
 first_patient_id = "";
 first_service_id = "";
 first_provider_id = "";
 editDateService->DateTime = Date().CurrentDate();
 editTimeService->DateTime = Time().CurrentTime();

 CreateLink(staticPatient, buttonPatientSearch, this, first_patient_id, "people", "");
 CreateLink(staticProvider, buttonProviderSearch, this, first_provider_id, "tax_entities", "");  
 CreateLink(staticReferringProvider, ReferringProviderSearch, this, first_referring_id, "tax_entities", "");
 ResetServices(first_provider_id);
 ResetSecondPage();
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewCOB::ResetSecondPage()
{
 ResetThirdPage();
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewCOB::ResetThirdPage()
{
 ResetFourthPage();
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewCOB::ResetFourthPage()
{
 SetAccountAmount (editAccount, editAmount, listPayments, acceptable_payments);
 RefreshBudgetInfo();
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewCOB::GotoFirstPage()
{
 staticHeader->Caption = "1 of 4 - Select patient, provider service, and referrer";
 buttonBack->Enabled = false;
 buttonNext->Caption = "Next >>";
 pageCOB->ActivePageIndex = 0;
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewCOB::GotoSecondPage()
{
 staticHeader->Caption = "2 of 4 - Examine patient's insurance and limits information";
 buttonBack->Enabled = true;
 buttonNext->Caption = "Next >>";
 pageCOB->ActivePageIndex = 1;
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewCOB::GotoThirdPage()
{
 staticHeader->Caption = "3 of 4 - Enter visit information for printed COB";
 buttonBack->Enabled = true;
 buttonNext->Caption = "Next >>";
 pageCOB->ActivePageIndex = 2;
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewCOB::GotoFourthPage()
{
 staticHeader->Caption = "4 of 4 - Enter obligations and complete COB";
 buttonBack->Enabled = true;
 buttonNext->Caption = "Finish";
 pageCOB->ActivePageIndex = 3;
 return;
}
//---------------------------------------------------------------------------
bool TformSpecialNewCOB::AtlasScreen(int request_num)
{
 if (request_num == services_request)
  services_filter.RefreshDataSet();
 if (request_num == insurance_request)
  insurance_filter.RefreshDataSet();
 return true;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::staticPersonLimitsClick(TObject *Sender)
{
 // go to ... stuff.
 map<string, string> params;
 params["id"] = first_patient_id;
 FORM_TRY
  TformSpecialPersonLimits * see_limits = new TformSpecialPersonLimits(NULL, params);
  see_limits->Show();
 FORM_CATCH
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewCOB::ResetServices(string given_id)
{
 if (given_id == "" || !IsInt(given_id))
 {
  services_filter.SetSQLStatement("");
  services_filter.SetAddEdit(this, NULL, NULL);
 }
 else
 {
  string sql_select_services = "select service_types.item, area_types.item, services_provided.current_id, services_provided.id "
                               "from services_provided "
                               "inner join service_types on services_provided.service_id = service_types.id "
                               "inner join area_types on services_provided.area_id = area_types.id "
                               "where services_provided.current_id >  2 and "
                               "services_provided.tax_entity_id = " + given_id;

  services_filter.SetSQLStatement(sql_select_services);
  services_filter.RefreshDataSet();
  services_filter.SetAddEdit(this, AddRecord(&(TformSpecialNewCOB::AddServiceProvided)), EditRecord(&(TformSpecialNewCOB::EditServiceProvided)));
  atlas->CancelRequest(services_request);
  services_request = atlas->RequestNotificationWhen("services_provided.tax_entity_id", given_id, rel_e, as_int, this,
                      RefreshHandler(&(TformSpecialNewCOB::AtlasScreen)));
 }

 services_filter.RefreshDataSet();
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::listPaymentsSelectItem(TObject *Sender,
      TListItem *Item, bool Selected)
{
 // select an amount thingie
 ModAccountAmount (editAccount, editAmount, listPayments, acceptable_payments);
 RefreshBudgetInfo();
}
//---------------------------------------------------------------------------
void TformSpecialNewCOB::AddInsurance()
{
 map<string, string> params;
 params["person_id"] = first_patient_id;
 FORM_TRY
  TformRecordInsuranceCoverage * add_coverage = new TformRecordInsuranceCoverage(NULL, params);
  add_coverage->Show();
 FORM_CATCH
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewCOB::EditInsurance()
{
 map<string, string> params;
 params["id"] = insurance_filter.GetSelectedRecordID();
 FORM_TRY
  TformRecordInsuranceCoverage * edit_coverage = new TformRecordInsuranceCoverage(NULL, params);
  edit_coverage->Show();
 FORM_CATCH
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewCOB::AddServiceProvided()
{
 if (first_provider_id != "")
 {
  map<string, string> params;
  params["tax_entity_id"] = first_provider_id;
  FORM_TRY
   TformRecordServiceProvided * add_service = new TformRecordServiceProvided(NULL, params);
   add_service->Show();
  FORM_CATCH
 }
 else
  PSay("Cannot add a service provided without specifying which provider is to have the new service.", m_missing_data, MB_OK);
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewCOB::EditServiceProvided()
{
 map<string, string> params;
 params["id"] = services_filter.GetSelectedRecordID();
 FORM_TRY
  TformRecordServiceProvided * edit_service = new TformRecordServiceProvided(NULL, params);
  edit_service->Show();
 FORM_CATCH
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::staticInsuredMedicalClick(TObject *Sender)
{
 editUsage->Text = editUsage->Text + "Bill private insurance first, A.S.T. is the payor of last resort. We pay deductible, copay, and residual if insurance protocol is followed.";
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewCOB::staticUsualCaregiverClick(
      TObject *Sender)
{
 // $400 per quarter per person
 editUsage->Text = editUsage->Text + "$400 Quarterly limit, anything over this amount will be the responsibility of the client.";
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::rboOutsideReferralClick(
      TObject *Sender)
{
  if (rboOutsideReferral->Checked)
   {
    referralPanel->Enabled = false;
    ReferringProviderSearch->Enabled = true;
   }
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewCOB::rboReferringPhysicianInstructionsClick(
      TObject *Sender)
{
   if (rboReferringPhysicianInstructions->Checked)
   {
    referralPanel->Enabled = true;
    ReferringProviderSearch->Enabled = false;
   }
}
//---------------------------------------------------------------------------

