//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialNewER.h"
#include "codeSearchPerson.h"
#include "codeSearchTaxEntity.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialNewER *formSpecialNewER;
//---------------------------------------------------------------------------
__fastcall TformSpecialNewER::TformSpecialNewER(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
 panelSelectArea->Color = title_bar_color;
 Start();
 ResetFirstPage();
 GotoFirstPage();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewER::buttonPatientSearchClick(
      TObject *Sender)
{
 // search patient
 vector<string> return_vector;
 FORM_TRY
   TformSearchPerson * find_person = new TformSearchPerson(NULL, &return_vector);
   find_person->ShowTaskModal();
 FORM_CATCH

 if (return_vector.size() == 1)
 {
  first_patient_id = return_vector[0];
  CreateLink(staticPatient, buttonPatientSearch, this, first_patient_id, "people", "");
 }
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewER::buttonProviderSearchClick(
      TObject *Sender)
{
 // search provider, update listview below
 vector<string> return_vector;
 FORM_TRY
   TformSearchTaxEntity * find_provider = new TformSearchTaxEntity(NULL, &return_vector);
   find_provider->ShowTaskModal();
 FORM_CATCH

 if (return_vector.size() == 1)
 {
  first_provider_id = return_vector[0];
  first_service_id = "";
  CreateLink(staticProvider, buttonProviderSearch, this, first_provider_id, "tax_entities", "");
  ResetServices(first_provider_id);
 }
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewER::buttonBackClick(TObject *Sender)
{
 // back
 if (pageER->ActivePageIndex == 1)
  GotoFirstPage();
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewER::buttonNextClick(TObject *Sender)
{
 // next or finish
 if (pageER->ActivePageIndex == 0)
 {
  if (first_patient_id == "" || first_patient_id == "0")
  {
   PSay("You must select a patient for whom to create this Emergency Room notification.", m_missing_data, MB_OK);
   return;
  } else
  if (first_provider_id == "" || first_provider_id == "0")
  {
   PSay("Please select the hospital at which the patient is being, will be, or has been seen.", m_missing_data, MB_OK);
   return;
  } else
  if (first_service_id == "")
  {
   PSay("You must select a specific provider service so that obligations can be categorized against the patient's monetary limits.", m_missing_data, MB_OK);
   return;
  }
  if (second_patient_id != first_patient_id ||
      second_service_id != first_service_id)
   ResetSecondPage();
  GotoSecondPage();
 } else
 if (pageER->ActivePageIndex == 1)
 {
  if (editReason->Text == "" && editPreCond->Text == "" && editFollowup->Text == "" && editReportedBy->Text == "" && checkWasHosp->Checked == false && checkWasRoom->Checked == false)
  {
   // just a warning
   int user_answer = PSay("None of the information on this screen is currently required, but it is recommened\nthat a bit more information be entered. Are you really sure you didn't mean to say more?", m_confirmation, MB_YESNO);
   if (user_answer == IDNO)
    return;
  }

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  try
  {
   dbTransaction->DefaultDatabase = dbDatabase;
   dbTransaction->DefaultAction = TARollback;
   dbTransaction->StartTransaction();

   map<string, string> insert_er_cob;
   insert_er_cob["id"] = GetNextId(dbTransaction, "tasks");
   insert_er_cob["current_id"] = "4";
   insert_er_cob["last_update_stamp"] = RightNow();
   insert_er_cob["last_updated_by"] = current_userid;
   insert_er_cob["person_id"] = second_patient_id;
   insert_er_cob["event_id"] = "0";
   insert_er_cob["group_id"] = "5"; // TODO -c MAGIC NUMBER :
   insert_er_cob["date_of_task"] = Pdate(editDateService->Date).OutDate(mdy | yyyy);
   insert_er_cob["time_of_task"] = Ptime(editTimeService->Time).OutTime(military | withsec);
   insert_er_cob["time_spent"] = "";
   insert_er_cob["mileage"] = "";
   insert_er_cob["task_comments"] = editReason->Text.c_str();
   insert_er_cob["visit_time_spent"] = "";
   insert_er_cob["visit_comments"] = "";
   insert_er_cob["method_id"] = "0"; // TODO :
   insert_er_cob["direction_id"] = "0"; // TODO :
   insert_er_cob["classification_id"] = "0"; // stupid field that needs to go away // TODO :
   insert_er_cob["beh_meeting_id"] = "0";
   insert_er_cob["beh_visit_id"] = "0";
   insert_er_cob["beh_activity_id"] = "0";
   insert_er_cob["visit_location_id"] = "0";
   insert_er_cob["is_educational"] = "0";
   insert_er_cob["is_personal"] = "0";
   insert_er_cob["diab_activity_id"] = "0";
   insert_er_cob["diab_contact_id"] = "0";
   insert_er_cob["diab_meeting_id"] = "0";
   insert_er_cob["diab_task_id"] = "0";
   insert_er_cob["diab_program_id"] = "0";
   insert_er_cob["user_id"] = current_userid; // TODO :
   insert_er_cob["visit_outcome_id"] = "0";
   insert_er_cob["com_meeting_id"] = "0";
   insert_er_cob["com_activity_id"] = "0";
   insert_er_cob["com_visit_id"] = "0";
   insert_er_cob["new_client"] = "0";
   insert_er_cob["beh_city_id"] = "0";
   insert_er_cob["beh_appt_id"] = "0";
   insert_er_cob["beh_service_id"] = "0";
   insert_er_cob["com_dept_id"] = "0";
   insert_er_cob["tax_entity_id"] = "0"; // intentionally left this way
   insert_er_cob["parent_task_id"] = "0";
   insert_er_cob["patient_control_number"] = "";
   insert_er_cob["services_provided_id"] = second_service_id;
   insert_er_cob["in_progress"] = "0";
   insert_er_cob["preconditions_note"] = editPreCond->Text.c_str();
   insert_er_cob["followup_note"] = editFollowup->Text.c_str();
   insert_er_cob["reported_by_note"] = editReportedBy->Text.c_str();
   insert_er_cob["hospitalized"] = checkWasHosp->Checked ? "1" : "0";
   insert_er_cob["given_room"] = checkWasRoom->Checked ? "1" : "0";
   // insert_er_cob["cob_number"]

   if (!ExecuteInsertStatement(dbTransaction, "tasks", insert_er_cob))
    throw (1);

   dbTransaction->Commit();
   ResetFirstPage();
   GotoFirstPage();
  }
  catch (...)
  {
   if (dbTransaction->Active)
    dbTransaction->Rollback();
   PSay("Couldn't save the ER notification.", m_database_error, MB_OK);
  }
  delete dbTransaction;
 }
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewER::buttonCancelClick(TObject *Sender)
{
 // cancel
 ResetFirstPage();
 GotoFirstPage();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewER::buttonCloseClick(TObject *Sender)
{
 // close
 Close();
}
//---------------------------------------------------------------------------
void TformSpecialNewER::GotoFirstPage()
{
 staticHeader->Caption = "1 of 2 - Enter COB-equivalent information";
 buttonBack->Enabled = false;
 buttonNext->Caption = "Next >>";
 pageER->ActivePageIndex = 0;
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewER::GotoSecondPage()
{
 second_patient_id = first_patient_id;
 second_service_id = first_service_id;

 staticHeader->Caption = "2 of 2 - Enter extra visit information";
 buttonBack->Enabled = true;
 buttonNext->Caption = "Finish";
 pageER->ActivePageIndex = 1;
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewER::ResetFirstPage()
{
 first_patient_id = "";
 first_service_id = "";
 first_provider_id = "";
 editDateService->DateTime = Date().CurrentDate();
 editTimeService->DateTime = Time().CurrentTime();

 CreateLink(staticPatient, buttonPatientSearch, this, first_patient_id, "people", "");
 CreateLink(staticProvider, buttonProviderSearch, this, first_provider_id, "tax_entities", "");
 ResetServices(first_provider_id);
 ResetSecondPage();
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewER::ResetSecondPage()
{
 editReason->Text = "";
 editPreCond->Text = "";
 editFollowup->Text = "";
 editReportedBy->Text = "";
 checkWasHosp->Checked = false;
 checkWasRoom->Checked = false;
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewER::Start()
{
 services_filter.SetListViewHandle(listServicesProvided);
 services_filter.SetSecurity("services_provided");
 services_filter.AddColumnSpec("Service", "services_provided", as_text, true, 140);
 services_filter.AddColumnSpec("Area", "services_provided", as_text, true, 80);
 services_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 services_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 services_filter.FetchPreferences("recordspecialnewer.services_filter");
 services_filter.SetIconStatus(true);
 services_filter.SetSQLStatement("");
 services_filter.RefreshDataSet();
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewER::Stop()
{
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewER::FormClose(TObject *Sender,
      TCloseAction &Action)
{
 // on close
 Stop();
 TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
bool TformSpecialNewER::AtlasScreen(int request_num)
{
 if (request_num == services_request)
  services_filter.RefreshDataSet();
 return true;
}
//---------------------------------------------------------------------------
void TformSpecialNewER::ResetServices(string given_id)
{
 if (given_id == "" || !IsInt(given_id))
 {
  services_filter.SetSQLStatement("");
 }
 else
 {
  string sql_select_services = "select service_types.item, area_types.item, services_provided.current_id, services_provided.id "
                               "from services_provided "
                               "inner join service_types on services_provided.service_id = service_types.id "
                               "inner join area_types on services_provided.area_id = area_types.id "
                               "where services_provided.current_id >  2 and "
                               "services_provided.tax_entity_id = " + given_id;

  services_filter.SetSQLStatement(sql_select_services);
 }

 services_filter.RefreshDataSet();
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewER::listServicesProvidedSelectItem(
      TObject *Sender, TListItem *Item, bool Selected)
{
 // select or deselect stuff ... or some such.
 first_service_id = services_filter.GetSelectedRecordID();
}
//---------------------------------------------------------------------------

