//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialNewInterofficeReferral.h"
#include "codeSearchPerson.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialNewInterofficeReferral *formSpecialNewInterofficeReferral;
//---------------------------------------------------------------------------
__fastcall TformSpecialNewInterofficeReferral::TformSpecialNewInterofficeReferral(TComponent* Owner, string p_person_id)
        : TformSpecialGeneric(Owner)
{
  //person_id = p_person_id;
  CreateLink(txtPerson, btnPersonSearch, this, p_person_id, "people");
  lookupTables->RegisterComboBox("users", cboFrom);
  lookupTables->RegisterComboBox("users", cboTo);

  string group_sql = "select id, item, valid from referral_reason_types where group_id in ("+SetToCommaString(GetSpecialGroupPermissions("general"))+") and valid = 1 order by item";
  lookupTables->RegisterComboBox("referral_reason_types", cboReason, group_sql);

  cboFrom->Text = lookupTables->ValueOf("users", current_userid).c_str();
  dateReferral->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewInterofficeReferral::btnPersonSearchClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtPerson, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewInterofficeReferral::FormClose(TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("users", cboFrom);
  lookupTables->UnregisterComboBox("users", cboTo);
  lookupTables->UnregisterComboBox("referral_reason_types", cboReason);
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewInterofficeReferral::btnCancelClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewInterofficeReferral::btnSaveClick(TObject *Sender)
{
  if(IsValidOnScreen())
    if(Save())
      Close();
}
//---------------------------------------------------------------------------
bool TformSpecialNewInterofficeReferral::IsValidOnScreen()
{
  if(GetValidLinkId(txtPerson) == "")
  {
    PSay("Please enter the person the referral is for", m_missing_data, MB_OK);
    btnPersonSearch->SetFocus();
    return false;
  }
  else if(! lookupTables->IsInLookUpTable("users", cboFrom->Text.c_str()))
  {
    PSay("Please enter a valid employee", m_invalid_data, MB_OK);
    cboFrom->SetFocus();
    return false;
  }
  else if(cboFrom->Text == "")
  {
    PSay("Please enter an employee", m_missing_data, MB_OK);
    cboFrom->SetFocus();
    return false;
  }
  else if(! lookupTables->IsInLookUpTable("users", cboTo->Text.c_str()))
  {
    PSay("Please enter a valid employee", m_invalid_data, MB_OK);
    cboTo->SetFocus();
    return false;
  }
  else if(cboTo->Text == "")
  {
    PSay("Please enter an employee", m_missing_data, MB_OK);
    cboTo->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("referral_reason_types", cboReason->Text.c_str()))
  {
    PSay("Please enter a valid reason", m_invalid_data, MB_OK);
    cboReason->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
bool TformSpecialNewInterofficeReferral::Save()
{
  AtlasClear();
  TIBTransaction *dbTransaction = new TIBTransaction(NULL);
  map<string, string> insert_map;
  string from_tax_id;
  string to_tax_id;
  string referral_id;
  string temp;
  bool to_return = true;
  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbTransaction->StartTransaction();

    temp = "select tax_entity_id from users where id = " + lookupTables->IdOf("users", cboFrom->Text.c_str());
    from_tax_id = GetOneField(dbTransaction, temp);
    temp = "select tax_entity_id from users where id = " + lookupTables->IdOf("users", cboTo->Text.c_str());
    to_tax_id = GetOneField(dbTransaction, temp);
    if((from_tax_id == "0") || (from_tax_id == ""))
      throw 1;
    if((to_tax_id == "0") || (to_tax_id == ""))
      throw 2;

    referral_id = GetNextId(dbTransaction, "referrals");
    insert_map["id"] = referral_id;
    insert_map["current_id"] = "4";
    insert_map["last_update_stamp"] = RightNow();
    insert_map["last_updated_by"] = current_userid;
    insert_map["person_id"] = GetValidLinkId(txtPerson);
    insert_map["by_provider_id"] = from_tax_id;
    insert_map["by_facility_id"] = "0";
    insert_map["to_provider_id"] = to_tax_id;
    insert_map["to_facility_id"] = "0";
    insert_map["date_of_referral"] = Pdate(dateReferral->Date).OutDate(mdy | yyyy);
    insert_map["task_id"] = "0";
    insert_map["todo_status_id"] = lookupTables->IdOf("todo_status_types", "Not begun");
    insert_map["referral_reason_id"] = lookupTables->IdOf("referral_reason_types", cboReason->Text.c_str());
    if(! ExecuteInsertStatement(dbTransaction, "referrals", insert_map))
      throw 3;
    AtlasAdd("referrals", insert_map);
    if (insert_map["to_provider_id"] != user_taxid)
     AtlasAdd("hack.referrals", "to_provider_id", insert_map["to_provider_id"]);

    insert_map.clear();
    insert_map["id"] = GetNextId(dbTransaction, "referral_notes");
    insert_map["current_id"] = "4";
    insert_map["last_update_stamp"] = RightNow();
    insert_map["last_updated_by"] = current_userid;
    insert_map["referral_id"] = referral_id;
    insert_map["date_of_note"] = Pdate(dateReferral->Date).OutDate(mdy | yyyy);
    insert_map["note"] = editNote->Text.c_str();
    if(! ExecuteInsertStatement(dbTransaction, "referral_notes", insert_map))
      throw 3;
    AtlasAdd("referral_notes", insert_map);

    // string user_to_send_to = GetOneField(dbTransaction, "select username from users where id = " + lookupTables->IdOf("users", cboTo->Text.c_str()));
    // message_router->SendMessageToAny("user_name", user_to_send_to, "referrals", cboFrom->Text.c_str());

    dbTransaction->Commit();
    AtlasSend();
  }
  catch(int error_code)
  {
    dbTransaction->Rollback();
    if(error_code == 1)
    {
      temp = cboFrom->Text.c_str();
      PSay(string(temp + " is not set up to make interoffice referrals.\n"
        "Please contact your administrator to set up this employee"), m_warning, MB_OK);
    }
    else if(error_code == 2)
    {
      temp = cboTo->Text.c_str();
      PSay(string(temp + " is not set up to receive interoffice referrals.\n"
        "Please contact your administrator to set up this employee"), m_warning, MB_OK);
    }
    else if(error_code == 3)
      PSay("Error saving referral", m_database_error, MB_OK);
    else
      PSay("Unkown error", m_program_error, MB_OK);
    to_return = false;
  }
  catch(...)
  {
    if(dbTransaction->Active)
      dbTransaction->Rollback();
    PSay("Error saving referral", m_database_error, MB_OK);
    to_return = false;
  }
  delete dbTransaction;
  return to_return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewInterofficeReferral::btnSaveAndAddAnotherClick(TObject *Sender)
{
  if(IsValidOnScreen())
  {
    if(Save())
    {
      // 3/16/05 - users request way to send the same referral to multiple people.  The simplest solution is to use
      // "save and add another" and simply not clear anything but the "To" field (note "From" still gets reset. Should it?)
      // person_id = "";
      // CreateLink(txtPerson, btnPersonSearch, this, person_id, "people");
      cboFrom->Text = lookupTables->ValueOf("users", current_userid).c_str();
      cboTo->Text = "";
      // editNote->Text = "";
      // dateReferral->Date = Date();
      // cboReason->Text = "";
      btnPersonSearch->SetFocus();
    }
  }
}
//---------------------------------------------------------------------------

