//---------------------------------------------------------------------------

#ifndef codeSpecialNewTransportationTasksH
#define codeSpecialNewTransportationTasksH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
//---------------------------------------------------------------------------
struct pick_up_info
{
 string person_id;
 int diff_odometer;
 financial diff_time;
 Ptime pick_up_time;
 pick_up_info(string p, int o, financial d, Ptime t) : person_id (p), diff_odometer(o), diff_time(d), pick_up_time (t) {};
};
//---------------------------------------------------------------------------
class TformSpecialNewTransportationTasks : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TListView *listStops;
        TButton *buttonStopAdd;
        TButton *buttonStopRemove;
        TButton *buttonStopClear;
        TButton *buttonStopSave;
        TEdit *editMileage;
        TComboBox *comboAction;
        TComboBox *comboPerson;
        TLabel *_labelUser;
        TComboBox *comboUser;
        TLabel *_labelDate;
        TDateTimePicker *dateLog;
        TLabel *_labelOdometer;
        TLabel *_labelAction;
        TStaticText *staticPerson;
        TBitBtn *buttonSearchPerson;
        TLabel *labelPerson;
        TToolButton *buttonSave;
        TToolButton *buttonClose;
        TLabel *_labelTime;
        TLabel *labelNote;
        TEdit *editNote;
        TLabel *_labelMiles;
        TDateTimePicker *timeStop;
        void __fastcall comboActionChange(TObject *Sender);
        void __fastcall comboActionKeyPress(TObject *Sender, char &Key);
        void __fastcall buttonStopSaveClick(TObject *Sender);
        void __fastcall buttonStopAddClick(TObject *Sender);
        void __fastcall buttonStopRemoveClick(TObject *Sender);
        void __fastcall buttonStopClearClick(TObject *Sender);
        void __fastcall buttonSearchPersonClick(TObject *Sender);
        void __fastcall buttonSaveClick(TObject *Sender);
        void __fastcall buttonCloseClick(TObject *Sender);
        void __fastcall comboPersonKeyPress(TObject *Sender, char &Key);
private:	// User declarations
        string person_id;
        vector<string> person_id_to_name;
        edit_listview list_stops;
        void StopSelected ();
        void RefreshPersonCombo(string id_to_select);
        string InterpretPersonCombo();
        void GetStopsSortedByMileage(vector<map<string, string> > & sorted_data);
        void GetStopsSortedByTime(vector<map<string, string> > & sorted_data);
        void ClearScreen();
public:		// User declarations
        __fastcall TformSpecialNewTransportationTasks(TComponent* Owner);
        __fastcall ~TformSpecialNewTransportationTasks();
        static void Do ();
};
//---------------------------------------------------------------------------
extern PACKAGE TformSpecialNewTransportationTasks *formSpecialNewTransportationTasks;
//---------------------------------------------------------------------------
#endif
