//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialNewVendorBill.h"
#include "codeSearchTaxEntity.h"
#include "codeSpecialSelectGroups.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialNewVendorBill *formSpecialNewVendorBill;
//---------------------------------------------------------------------------
__fastcall TformSpecialNewVendorBill::TformSpecialNewVendorBill(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
 panelSelectArea->Color = title_bar_color;
 lastRadioChecked = 1;
 Start();
 ResetFirstPage();
 GotoFirstPage();
}
//---------------------------------------------------------------------------
void TformSpecialNewVendorBill::Start()
{
 // register combo boxes, etc.
 //lookupTables->RegisterComboBox("users", comboUser);

 dateInvoiceDate->Date = StrToDate(CurrentDate().c_str());
 acceptable_payments = acc_none;
 acceptable_payments |= acc_non_budget;
 acceptable_payments |= acc_non_closed;
 acceptable_payments |= acc_non_yearly;
 acceptable_payments |= acc_yearly;
 acceptable_payments |= acc_expense;

 acceptable_payments_for_emp = acc_none;
 acceptable_payments_for_emp |= acc_non_budget;
 acceptable_payments_for_emp |= acc_non_closed;
 acceptable_payments_for_emp |= acc_non_yearly;
 acceptable_payments_for_emp |= acc_yearly;
 acceptable_payments_for_emp |= acc_receivable;

 if (radioGroup->Checked)
 {
    comboUser->Style = Stdctrls::csDropDownList;
    comboUser->Clear();
    comboUser->Items->Add("Right click to add departments");
    comboUser->ItemIndex = comboUser->Items->Count - 1;
 }
 else if (radioUser->Checked)
 {
    comboUser->Style = Stdctrls::csDropDown;
    lookupTables->RegisterComboBox("users", comboUser);
    comboUser->PopupMenu = popupGroups;
 }
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewVendorBill::Stop()
{
 // unregister combo boxes, etc.
 //lookupTables->UnregisterComboBox("users", comboUser);
 if (radioGroup->Checked)
    ;
 else if (radioUser->Checked)
    lookupTables->UnregisterComboBox("users", comboUser);
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewVendorBill::ResetFirstPage()
{
 emp_pay = false;

 CreateLink(staticVendor, NULL, this, "", "tax_entities", "");
 labelVendorTaxID->Caption = "?";
 CreateLink(staticFinalVendor, NULL, this, "", "tax_entities", "");
 labelFinalTaxID->Caption = "?";

 pay_tax_id = "";
 comboUser->Text = "";
 editReason->Text = "";
 editInvoiceNumber->Text = "";
 editInvoiceAmount->Text = "0.00";
 comboUser->Text = lookupTables->ValueOf("users", "").c_str();
 radioUser->Checked = true;
 radioClick(NULL);

 ResetSecondPage();
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewVendorBill::ResetSecondPage()
{
 CreateLink(staticForAccountNumber, NULL, this, "", "accounts", "");

 SetAccountAmount (editAccount, editAmount, listPayments, acceptable_payments);
 RefreshBudgetInfo();
 ResetThirdPage();
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewVendorBill::ResetThirdPage()
{
// new payment page for employees
 CreateLink(staticIndividual, NULL, this, "", "tax_entities", "");

 SetAccountAmount (editARAccount, editARAmount, listARPayments, acceptable_payments_for_emp);
 ResetFourthPage();
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewVendorBill::ResetFourthPage()
{
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewVendorBill::GotoFirstPage()
{
 staticHeader->Caption = "1 of 3 or 4 depending on employee payment - Enter invoice information";
 buttonBack->Enabled = false;
 buttonNext->Caption = "Next >>";
 pageVendorWizard->ActivePageIndex = 0;
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewVendorBill::GotoSecondPage()
{
 labelAmountCharges->Caption = StringToAmount(editInvoiceAmount->Text.c_str()).c_str();

 if (emp_pay)
   staticHeader->Caption = "2 of 4 - Enter payment information";
 else
   staticHeader->Caption = "2 of 3 - Enter payment information";

 buttonBack->Enabled = true;
 buttonNext->Caption = "Next >>";
 pageVendorWizard->ActivePageIndex = 1;
 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewVendorBill::GotoThirdPage()
{
 labelARAmountCharges->Caption = editInvoiceAmount->Text;
 staticHeader->Caption = "3 of 4 - Enter employee payment information";

 RefreshARLableInfo();
 labelARAmountCharges->Caption = StringToAmount(editInvoiceAmount->Text.c_str()).c_str();

 buttonBack->Enabled = true;
 buttonNext->Caption = "Next >>";
 pageVendorWizard->ActivePageIndex = 2;
// new payment page for employees
}
//---------------------------------------------------------------------------
void TformSpecialNewVendorBill::GotoFourthPage()
{
 if (emp_pay)
 {
   staticHeader->Caption = "4 of 4 - Confirm entry of vendor bill";
   emp_pay_label_panel->Visible = true;
   no_emp_pay_label_panel->Visible = false;
 }
 else
 {
   staticHeader->Caption = "3 of 3 - Confirm entry of vendor bill";  
   emp_pay_label_panel->Visible = false;
   no_emp_pay_label_panel->Visible = true;
 }

 float payment_amount = 0.00;
 multimap<string, string> all_payments = GetMultiAccountAmount(listPayments);
 // combine expensie account payments with account recievable payments from employees

 for (multimap<string, string>::iterator i_payment = all_payments.begin(); i_payment != all_payments.end(); i_payment++)
 {
    payment_amount += StringToFloat(AmountToString(i_payment->second));
 }

 labelSumBeingPaid->Caption = StringToAmount(FloatToString(payment_amount)).c_str();
 labelSumBeingCharged->Caption = StringToAmount(editInvoiceAmount->Text.c_str()).c_str();

 if (emp_pay)
 {
   labelSumBeingPaidNonEmp->Caption = FloatToString(payment_amount).c_str();
   payment_amount = 0.0;
   // combine expensie account payments with account recievable payments from employees
   multimap<string, string> ar_payments = GetMultiAccountAmount(listARPayments);
   for (multimap<string, string>::iterator i_payment = ar_payments.begin(); i_payment != ar_payments.end(); i_payment++)
   {
      payment_amount += StringToFloat(AmountToString(i_payment->second));
   }
  labelSumBeingPaidEmp->Caption = FloatToString(payment_amount).c_str();
  labelSumBeingChargedEmp->Caption = StringToAmount(editInvoiceAmount->Text.c_str()).c_str();
 }

 buttonBack->Enabled = true;
 buttonNext->Caption = "Finish";
 pageVendorWizard->ActivePageIndex = 3;
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewVendorBill::buttonBackClick(TObject *Sender)
{
 // back
 if (pageVendorWizard->ActivePageIndex == 1)
  GotoFirstPage();
 else if (pageVendorWizard->ActivePageIndex == 2)
  GotoSecondPage();
 else if (pageVendorWizard->ActivePageIndex == 3 && emp_pay)
  GotoThirdPage();
 else if(pageVendorWizard->ActivePageIndex == 3 && !emp_pay)
  GotoSecondPage();
 else
   PSay("There is no way you should ever get here.", m_program_error, MB_OK);
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewVendorBill::buttonNextClick(TObject *Sender)
{
 // next
 // TODO :
 if (pageVendorWizard->ActivePageIndex == 0)
 {
  // after basic info
  if (cboEmpPay->Checked)
     emp_pay = true;
  else
     emp_pay = false;

  Pdate today_date;
  Pdate invoice_date;
  today_date.InDate(TDateTime::CurrentDate());
  invoice_date.InDate(dateInvoiceDate->DateTime);

  if (invoice_date > today_date)
  {
   if (IDYES != PSay("The invoice date specified is in the future. This seems unlikely. Are you sure?", m_confirmation, MB_YESNO))
    return;
  }

  if (labelVendorTaxID->Caption == "?")
  {
   PSay("Please select a vendor.", m_invalid_data, MB_OK);
   return;
  }
  else
  if (labelVendorTaxID->Caption == "none")
  {
   PSay("The vendor you are paying does not have a tax ID.\nYou may click on the link and edit the vendor's information once you have the\ntax ID number, then return here, and to refresh, re-select the vendor through\nthe search screen (by clicking on the magnifying glass.)", m_missing_data, MB_OK);
   return;
  }
  else
  if ((comboUser->Text != "") && (! lookupTables->IsInLookUpTable("users", comboUser->Text.c_str())) && (radioUser->Checked))
  {
   PSay("Please select a valid employee.", m_invalid_data, MB_OK);
   return;
  }
  else
  if (comboUser->Text.c_str() == "Right click to add departments")
  {
   PSay("Please select a valid department", m_invalid_data, MB_OK);
   return;
  }
  else
  if (!IsFloat(editInvoiceAmount->Text.c_str()) || !(StringToFloat(editInvoiceAmount->Text.c_str()) > 0.00))
  {
   PSay("Please enter a positive invoice amount for this bill.", m_invalid_data, MB_OK);
   return;
  }
  else
  {
   if (editInvoiceNumber->Text == "")
   {
    int sure_answer = PSay("You did not enter an invoice number. This is not an error, but remember that by entering an invoice\nnumber duplicates can be found before accidents occur.\nWould you like to proceed without entering an invoice number?", m_confirmation, MB_YESNO);
    if (sure_answer == IDNO)
     return;
   }
   else
   {
    // got past the simple stuff. now we check for duplicate invoice number, which we're at least supposed to ask about.
    // we need to make this the combination of invoice number and actual_tax_id so it will be a unique combination
    // company a and company b could have the same invoice number for the say pay period
    string sql_find_dup_invoice = "select count(*) from bills where bills.invoice_number = '" + ReplaceStringWithString(editInvoiceNumber->Text.c_str(), "'", "''") + "'";
    string count_of_dup = GetOneField(dbDatabase, sql_find_dup_invoice);
    if (IsInt(count_of_dup))
    {
     if (StringToInt(count_of_dup) > 0)
     {
      int user_answer = PSay("Based on the invoice number given, duplicate entry of this bill is suspected.\nPlease use the bill search screen to check before continuing. Would you like to continue anyway, despite the possible duplicate?", m_confirmation, MB_YESNO);
      if (user_answer == IDNO)
       return;
     }
    }
    else
    {
     PSay("Error checking for duplicates.", m_database_error, MB_OK);
     return;
    }
   }
   // accomplish something, finally
   GotoSecondPage();
  }
 }
 else
 if (pageVendorWizard->ActivePageIndex == 1)
 {
  // after payments
  map<string, string> all_payments = GetAccountAmount (listPayments);
  float payment_amount = 0.00;
  float charged_amount = 0.00;
  for (map<string, string>::iterator i_payment = all_payments.begin(); i_payment != all_payments.end(); i_payment++)
   payment_amount += StringToFloat(AmountToString(i_payment->second));
  charged_amount = StringToFloat(AmountToString(labelAmountCharges->Caption.c_str()));

  if (payment_amount < 0.00)
  {
   // error
   PSay("Please enter a positive value for the payment amount.", m_invalid_data, MB_OK);
   return;
  } else
  if (payment_amount == 0.00)
  {
   // error
   PSay("Please enter an amount greater than zero for the payment amount.", m_invalid_data, MB_OK);
   return;
  } else
  if ((payment_amount > charged_amount) && !emp_pay)
  {
   // warning
   int user_answer = PSay("Are you sure you want to pay more than the charged amount?", m_confirmation, MB_YESNO);
   if (user_answer == IDNO)
    return;
  } else
  if ((payment_amount < charged_amount) && !emp_pay)
  {
   // warning
   int user_answer = PSay("Are you sure you want to pay less than the charged amount?", m_confirmation, MB_YESNO);
   if (user_answer == IDNO)
    return;
  }
  // accomplish something
  if (emp_pay)
     GotoThirdPage();
  else
     GotoFourthPage();
 }
 else
 if (pageVendorWizard->ActivePageIndex == 2)
 {
  // if part of a vendor bill is due to an employee's personal expenses (ie cingular cell phone bill) then put their payment into account recievable (ask Jennifer (accountant in Finance) if further explanation is needed)
  // after payments
  float payment_amount = 0.00;
  float charged_amount = 0.00;
  multimap<string, string> all_payments = GetMultiAccountAmount(listPayments);

  // combine expensie account payments with account recievable payments from employees
  multimap<string, string> ar_payments = GetMultiAccountAmount(listARPayments);
  all_payments.insert(ar_payments.begin(), ar_payments.end());
  for (multimap<string, string>::iterator i_payment = all_payments.begin(); i_payment != all_payments.end(); i_payment++)
  {
     payment_amount += StringToFloat(AmountToString(i_payment->second));
  }
  charged_amount = StringToFloat(AmountToString(labelAmountCharges->Caption.c_str()));
  if (payment_amount < 0.00)
  {
   // error
   PSay("Please enter a positive value for the payment amount.", m_invalid_data, MB_OK);
   return;
  } else
  if (payment_amount == 0.00)
  {
   // error
   PSay("Please enter an amount greater than zero for the payment amount.", m_invalid_data, MB_OK);
   return;
  } else
  if (payment_amount > charged_amount)
  {
   // warning
   int user_answer = PSay("Are you sure you want to pay more than the charged amount?", m_confirmation, MB_YESNO);
   if (user_answer == IDNO)
    return;
  } else
  if (payment_amount < charged_amount)
  {
   // warning
   int user_answer = PSay("Are you sure you want to pay less than the charged amount?", m_confirmation, MB_YESNO);
   if (user_answer == IDNO)
    return;
  }

  // accomplish something
  ResetFourthPage();
  GotoFourthPage();
 }
 else
 if (pageVendorWizard->ActivePageIndex == 3)
 {
  // after confirm
  // at this point, not much to verify, eh? go ahead and finish stuff off.
  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  try
  {
   dbTransaction->DefaultDatabase = dbDatabase;
   dbTransaction->DefaultAction = TARollback;
   dbTransaction->StartTransaction();

   map<string, string> insert_bill;
   insert_bill["id"] = GetNextId(dbTransaction, "bills");
   insert_bill["current_id"] = "4";
   insert_bill["last_update_stamp"] = RightNow();
   insert_bill["last_updated_by"] = current_userid;
   insert_bill["task_id"] = "0";
//  PSay(comboUser->Text.c_str(), m_message, MB_OK);
   if (radioGroup->Checked)
   {
      insert_bill["group_or_user"] = "0";
      insert_bill["groups"] = comboUser->Text.c_str();
      insert_bill["user_id"] = "0";
   }
   else if (radioUser->Checked)
   {
      insert_bill["group_or_user"] = "1";
      insert_bill["user_id"] = lookupTables->IdOf("users", comboUser->Text.c_str());
      insert_bill["groups"] = "";
   }

   Pdate invoice_date;
   invoice_date.InDate(dateInvoiceDate->DateTime);

   //insert_bill["user_id"] = lookupTables->IdOf("users", comboUser->Text.c_str());
   insert_bill["insurance_coverage_id"] = "0";
   insert_bill["provider_tax_id"] = "0";
   insert_bill["facility_tax_id"] = "0";
   insert_bill["group_tax_id"] = "0";
   insert_bill["actual_tax_id"] = pay_tax_id;
   insert_bill["purchase_req_id"] = "0";
   insert_bill["total_charge"] = editInvoiceAmount->Text.c_str();
   insert_bill["invoice_amount"] = editInvoiceAmount->Text.c_str();
   insert_bill["paid_amount"] = labelSumBeingPaid->Caption.c_str();
   insert_bill["bill_id"] = lookupTables->IdOf("bill_types", "Incoming Vendor Bill");
   insert_bill["bill_date"] = invoice_date.OutDate(global_mode); // CurrentDate(); -- changed 2/20/2003 by philip, user request (transaction changed below as well)
   insert_bill["invoice_number"] = editInvoiceNumber->Text.c_str();
   insert_bill["note"] = editReason->Text.c_str();

   if (!ExecuteInsertStatement(dbTransaction, "bills", insert_bill))
    throw (1);

   map<string, string> insert_transaction_core;
   insert_transaction_core["current_id"] = "4";
   insert_transaction_core["last_update_stamp"] = RightNow();
   insert_transaction_core["last_updated_by"] = current_userid;
   insert_transaction_core["task_id"] = "0";
   insert_transaction_core["bill_id"] = insert_bill["id"];
   insert_transaction_core["tax_entity_id"] = pay_tax_id;
   insert_transaction_core["effective_date"] = insert_bill["bill_date"]; // CurrentDate(); -- changed 2/20/2003 by philip, see above
   insert_transaction_core["credit_amount"] = "0.00";
   insert_transaction_core["debit_amount"] = "0.00";
   insert_transaction_core["transaction_number"] = GetNextId(dbTransaction, "transact_number");


   map<string, string> all_payments = GetAccountAmount(listPayments);
   // get account payments with account recievable payments from employees
   if (emp_pay)
   {
      // go through all account id's and amounts, and for each account id get all the emp payments, and then if there are
      // any matching amounts save it else wait until another iteration of the outer for loop for the match to occur
      multimap<string, string> ar_payments = GetMultiAccountAmount(listARPayments);
      // see below
      map<string, string> duplicate_watch;
      // go through all account id's and amounts from the list view
      for (multimap<string, string>::iterator i_payment = ar_payments.begin(); i_payment != ar_payments.end(); i_payment++)
      {
        // if there is the same account twice with both amounts being the same then the second for loop saves the transactions
        // both times since it is looking it up based on amount.  this doubles the transactions
        // here I want to catch that situation, and stop it from occuring
        if (duplicate_watch[i_payment->first] == i_payment->second)
        {
          continue;
        }
        else
        {
          duplicate_watch[i_payment->first] = i_payment->second;
        }
        acc_info pay_account = (cboDirectWithdrawal->Checked) ? EquivAccountInfo (cash_ref, i_payment->first) : EquivAccountInfo (pending_ref, i_payment->first);

//        PSay(i_payment->first, m_message, MB_OK);

        // for all a/r payments to the same a/r account get each employee that is paying to that a/r account
        pair< multimap< string, map<string, string> >::iterator,
          multimap< string, map<string, string> >::iterator > tax_id_range;

        // get all amounts and tax id's that correspond to the current account id -- multimap <account_id, map <amount, tax_id> > all as strings of course
        tax_id_range = individual_tax_id.equal_range(i_payment->first);
        for (multimap<string, map<string, string> >::iterator itr = tax_id_range.first; itr != tax_id_range.second; itr++)
        {
//          PSay(itr->second[i_payment->second], m_message, MB_OK);
          // if there is no tax id that corresponds to the current amount then there is no need to save it.
          // since we are dealing with multiple maps the match will occur in another iteration of the outer for loop
          if (itr->second[i_payment->second] == "")
          {
            continue;
          }
          // Philip's code, see his documentation on it
          if (pay_account.IsClosed() || !pay_account.IsFound())
          {
           PSay("An accounts payable account number could not be found to match this expense account.", m_missing_data, MB_OK);
           throw(2);
          }

          string id_of_pay_account = pay_account.id;

          map<string, string> expense_transaction = insert_transaction_core;
          map<string, string> offset_transaction = insert_transaction_core;

          expense_transaction["id"] = GetNextId(dbTransaction, "transactions");    
          expense_transaction["note"] = "Recievable for individual " + itr->second[i_payment->second];
          expense_transaction["account_id"] = i_payment->first;              
          expense_transaction["tax_entity_id"] = itr->second[i_payment->second];
          expense_transaction["debit_amount"] = AmountToString(i_payment->second);



          offset_transaction["id"] = GetNextId(dbTransaction, "transactions");
          offset_transaction["note"] = (cboDirectWithdrawal->Checked) ? "Cash " : "Expense ";
          offset_transaction["note"] += "for vendor invoice " + string(editInvoiceNumber->Text.c_str());
          offset_transaction["account_id"] = id_of_pay_account;
          offset_transaction["tax_entity_id"] = itr->second[i_payment->second];
          offset_transaction["credit_amount"] = AmountToString(i_payment->second);

//          PSay(itr->second[i_payment->second], m_message, MB_OK);

          if (!ExecuteInsertStatement(dbTransaction, "transactions", expense_transaction))
           throw (3);

          if (!ExecuteInsertStatement(dbTransaction, "transactions", offset_transaction))
           throw (4);
        }
      }
   }
   // take care of all non-ar payments
   for (map<string, string>::iterator i_payment = all_payments.begin(); i_payment != all_payments.end(); i_payment++)
   {
    // for each, we see only the expense account listed, but we need to remember to also deal
    // with the payable account too! so for each of these, figure out what the A/P account is,
    // and run transactions against it too

    acc_info pay_account = (cboDirectWithdrawal->Checked) ? EquivAccountInfo (cash_ref, i_payment->first) : EquivAccountInfo (pending_ref, i_payment->first);

    if (pay_account.IsClosed() || !pay_account.IsFound())
    {
     PSay("An accounts payable account number could not be found to match this expense account.", m_missing_data, MB_OK);
     throw(2);
    }

    string id_of_pay_account = pay_account.id;

    map<string, string> expense_transaction = insert_transaction_core;
    map<string, string> offset_transaction = insert_transaction_core;

    expense_transaction["id"] = GetNextId(dbTransaction, "transactions");
    expense_transaction["note"] = "Expense for vendor invoice " + string(editInvoiceNumber->Text.c_str());
    expense_transaction["account_id"] = i_payment->first;
    expense_transaction["debit_amount"] = AmountToString(i_payment->second);

    offset_transaction["id"] = GetNextId(dbTransaction, "transactions");
    offset_transaction["note"] = (cboDirectWithdrawal->Checked) ? "Cash " : "Payable ";
    offset_transaction["note"] += "for vendor invoice " + string(editInvoiceNumber->Text.c_str());
    offset_transaction["account_id"] = id_of_pay_account;
    offset_transaction["credit_amount"] = AmountToString(i_payment->second);

    if (!ExecuteInsertStatement(dbTransaction, "transactions", expense_transaction))
     throw (3);

    if (!ExecuteInsertStatement(dbTransaction, "transactions", offset_transaction))
     throw (4);
   }

   dbTransaction->Commit();
   ResetFirstPage();
   GotoFirstPage();
  }
  catch (...)
  {
   if (dbTransaction->Active)
    dbTransaction->Rollback();
   PSay("Couldn't save a new vendor bill.", m_database_error, MB_OK);
  }
  delete dbTransaction;
 }
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewVendorBill::buttonCancelClick(
      TObject *Sender)
{
 // cancel
 ResetFirstPage();
 GotoFirstPage();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewVendorBill::buttonCloseClick(
      TObject *Sender)
{
 // close
 Close();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewVendorBill::FormClose(TObject *Sender,
      TCloseAction &Action)
{
 // on close
 Stop();
 TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewVendorBill::editAccountExit(TObject *Sender)
{
 // on exit of this control (account number) we'll hunt it down ... figure
 // they can learn how that works, right?
 // TODO: train them to look at this!
 RefreshBudgetInfo();
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewVendorBill::buttonSearchVendorClick(
      TObject *Sender)
{
 // go fetch a vendor and stuff
 vector<string> return_vector;
 FORM_TRY
   TformSearchTaxEntity * get_vendor = new TformSearchTaxEntity (NULL, &return_vector);
   get_vendor->ShowTaskModal(this);
 FORM_CATCH

 if (return_vector.size() == 1)
 {
  pay_tax_id = return_vector[0];
  CreateLink(staticVendor, buttonSearchVendor, this, pay_tax_id, "tax_entities", "");
  CreateLink(staticFinalVendor, NULL, this, pay_tax_id, "tax_entities", "");
  labelVendorTaxID->Caption = "?";
  labelFinalTaxID->Caption = "?";
  if (pay_tax_id != "" && IsInt(pay_tax_id))
  {
   string sql_find_tax_id_number = "select taxid from tax_entities where id = '" + pay_tax_id + "'";
   string returned_tax_id_number = GetOneField(dbDatabase, sql_find_tax_id_number);
   if (returned_tax_id_number.length() < 9)
   {
    labelVendorTaxID->Caption = "none";
    labelFinalTaxID->Caption = "none";
   }
   else
   {
    labelVendorTaxID->Caption = returned_tax_id_number.c_str();
    labelFinalTaxID->Caption = returned_tax_id_number.c_str();
   }
  }
  ResetSecondPage();
 }
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewVendorBill::buttonSearchIndividualClick(TObject *Sender)
{
 // get individual name and id
 vector<string> return_vector;
 FORM_TRY
  TformSearchTaxEntity * get_individual = new TformSearchTaxEntity (NULL, &return_vector);
  get_individual->ShowTaskModal(this);
 FORM_CATCH

 if (return_vector.size() > 0)
 {
  current_individual_tax_id = return_vector[0];
  string taxID = return_vector[0];
  CreateLink(staticIndividual, buttonSearchIndividual, this, taxID, "tax_entities", "");
  labelEmpTaxID->Caption = "?";
  if (taxID != "" && IsInt(taxID))
  {
   string sql_find_tax_id_number = "select taxid from tax_entities where id = '" + taxID + "'";
   string returned_tax_id_number = GetOneField(dbDatabase, sql_find_tax_id_number);
   if (returned_tax_id_number.length() < 9)
   {
    labelEmpTaxID->Caption = "none";
   }
   else
   {
    labelEmpTaxID->Caption = returned_tax_id_number.c_str();
   }
  }
//  ResetSecondPage();
 }
 else
 {
  CreateLink(staticVendor, buttonSearchVendor, this, "", "tax_entities", "");
  labelEmpTaxID->Caption = "none";
 }
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewVendorBill::buttonSavePaymentClick(
      TObject *Sender)
{
 // add account/amount
 AddAccountAmount (editAccount, editAmount, listPayments, acceptable_payments);
 RefreshBudgetInfo();
 return;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialNewVendorBill::buttonDeletePaymentClick(
      TObject *Sender)
{
 // remove account/amount
 DelAccountAmount (editAccount, editAmount, listPayments, acceptable_payments);
 RefreshBudgetInfo();
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewVendorBill::buttonSaveARPaymentClick(
      TObject *Sender)
{
 // get account
 map<string, string> wanted_account = PartsByMask (editARAccount);
 bool looking_for_budget = (acc_budget & acceptable_payments_for_emp);
 acc_info requested_account = InfoByParts (wanted_account, looking_for_budget);
 // add account key to map<string, string> for amount (key) and tax id (value) to the multimap
 pair< multimap< string, map<string, string> >::iterator,
  multimap< string, map<string, string> >::iterator > tax_ids;
 tax_ids = individual_tax_id.equal_range(requested_account.id);
 pair<string, map<string, string> > key_value_pair;
 key_value_pair.first = requested_account.id;
 key_value_pair.second[StringToAmount(editARAmount->Text.c_str()).c_str()] = current_individual_tax_id;
 individual_tax_id.insert(key_value_pair);
 
 // add account/amount
 AddAccountAmount (editARAccount, editARAmount, listARPayments, acceptable_payments_for_emp);
 RefreshARLableInfo();
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewVendorBill::buttonDeleteARPaymentClick(
      TObject *Sender)
{
 // remove account/amount
 DelAccountAmount (editARAccount, editARAmount, listARPayments, acceptable_payments_for_emp);
 RefreshARLableInfo();
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewVendorBill::listPaymentsSelectItem(
      TObject *Sender, TListItem *Item, bool Selected)
{
 // select item (for editing of account/amount)
 ModAccountAmount (editAccount, editAmount, listPayments, acceptable_payments);
 RefreshBudgetInfo();
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewVendorBill::listARPaymentsSelectItem(
      TObject *Sender, TListItem *Item, bool Selected)
{
 // select item (for editing of account/amount)
 ModAccountAmount (editARAccount, editARAmount, listARPayments, acceptable_payments_for_emp);

 if (listARPayments->SelCount)
 {
   // copied syntax to get the id of the account
   map<string, string> wanted_account = PartsByMask (editARAccount);
   bool looking_for_budget = (acc_budget & acceptable_payments_for_emp);
   acc_info requested_account = InfoByParts (wanted_account, looking_for_budget);

   // get the user for the account clicked on
   pair< multimap< string, map<string, string> >::iterator,
     multimap< string, map<string, string> >::iterator > tax_entity_id_range;

   tax_entity_id_range = individual_tax_id.equal_range(requested_account.id);
   vector<string> tax_id;
   for (multimap<string, map<string, string> >::iterator itr = tax_entity_id_range.first; itr != tax_entity_id_range.second; itr++)
   {
     if (itr->second[editARAmount->Text.c_str()] != "")
     {
       tax_id.push_back(itr->second[editARAmount->Text.c_str()]);
     }
   }

   CreateLink(staticIndividual, buttonSearchIndividual, this, tax_id[0], "tax_entities", "");
   labelEmpTaxID->Caption = "?";
   if (tax_id[0] != "" && IsInt(tax_id[0]))
   {
     string sql_find_tax_id_number = "select taxid from tax_entities where id = '" + tax_id[0] + "'";
     string returned_tax_id_number = GetOneField(dbDatabase, sql_find_tax_id_number);
     if (returned_tax_id_number.length() < 9)
     {
      labelEmpTaxID->Caption = "none";
     }
     else
     {
      labelEmpTaxID->Caption = returned_tax_id_number.c_str();
     }
   }
 }

 return;
}
//---------------------------------------------------------------------------
void TformSpecialNewVendorBill::RefreshBudgetInfo()
{
 string found_budgeted_amount =  "";
 string found_expensed_amount =  "";
 string account_fk = "";
 string budget_fk = "";

 if (editAccount->Text != "000-0000000-000-000")
 {
  map<string, string> account_parts = PartsByMask (editAccount);
  acc_info account_stuff = InfoByParts (account_parts, false);
  acc_info budget_stuff = InfoByParts (account_parts, true);
  account_fk = account_stuff.id;
  budget_fk = budget_stuff.id;
  if (account_stuff.IsFound() && !account_stuff.IsClosed() &&
      budget_stuff.IsFound() && !budget_stuff.IsClosed())
  {
   string sql_select_budgeted_amount = "select sum(transactions.debit_amount - transactions.credit_amount) "
                                       "from transactions inner join accounts on transactions.account_id = accounts.id "
                                       "where accounts.id = '" + budget_fk + "'";

   string sql_select_expensed_amount = "select sum(transactions.debit_amount - transactions.credit_amount) "
                                       "from transactions inner join accounts on transactions.account_id = accounts.id "
                                       "where accounts.id = '" + account_fk + "'";

   if (budget_fk != "")
    found_budgeted_amount = GetOneField(dbDatabase, sql_select_budgeted_amount);
   if (account_fk != "")
    found_expensed_amount = GetOneField(dbDatabase, sql_select_expensed_amount);
  }
 }

 map<string, string> all_payments = GetAccountAmount (listPayments);
 float payment_amount = 0.00;
 for (map<string, string>::iterator i_payment = all_payments.begin(); i_payment != all_payments.end(); i_payment++)
  payment_amount += StringToFloat(AmountToString(i_payment->second));

 labelAmountPayment->Caption = StringToAmount(FloatToString(payment_amount)).c_str();

 if (found_budgeted_amount == "")
  found_budgeted_amount = "0.00";

 if (found_expensed_amount == "")
  found_expensed_amount = "0.00";

 CreateLink(staticForAccountNumber, NULL, this, account_fk, "accounts", "");
 float budgeted_amount = StringToFloat(found_budgeted_amount);
 float expensed_amount = StringToFloat(found_expensed_amount);
 float remaining_amount = budgeted_amount - expensed_amount;
 CreateLink(staticForAccountNumber, NULL, this, account_fk, "accounts", "");
 labelAmountBudgeted->Caption   = StringToAmount(FloatToString(budgeted_amount)).c_str();
 labelAmountExpensed->Caption   = StringToAmount(FloatToString(expensed_amount)).c_str();
 labelAmountRemaining->Caption  = StringToAmount(FloatToString(remaining_amount)).c_str();
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewVendorBill::menuAddByGroupsClick(
      TObject *Sender)
{
  set<string> return_set;
  FORM_TRY
    TformSpecialSelectGroups * select_group_form = new TformSpecialSelectGroups(NULL, NULL, &return_set);
    select_group_form->ShowTaskModal(this);
  FORM_CATCH
  if(! return_set.empty())
  {
    string comma_sep = "";
    set<string>::iterator itr;
    for (itr = return_set.begin(); itr != return_set.end(); itr++)
    {
      comma_sep = comma_sep + (*itr) + ",";
    }
    comma_sep = comma_sep.substr(0, comma_sep.size() - 1);
    string sql = "select short_item from groups where id in (" + comma_sep + ");";
    vector<map<string, string> > names;
    SqlToVecMap(dbDatabase, sql, names);
    string departments = "";
    for (unsigned int i = 0; i != names.size(); i++)
    {
       departments = departments + names[i]["short_item"].c_str() + ", ";
    }
    comboUser->Clear();
    comboUser->Items->Add(departments.substr(0, departments.size() - 2).c_str());
    comboUser->ItemIndex = comboUser->Items->Count - 1;
  }
  else
     comboUser->Text = "";
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialNewVendorBill::radioClick(TObject *Sender)
{
   int currentRadioChecked;
   if (radioGroup->Checked)
      currentRadioChecked = 0;
   else if (radioUser->Checked)
      currentRadioChecked = 1;
   if (currentRadioChecked != lastRadioChecked)
   {
      if (radioGroup->Checked)
      {
         lookupTables->UnregisterComboBox("users", comboUser);
         comboUser->Style = Stdctrls::csDropDownList;
         comboUser->Clear();
         comboUser->Items->Add("Right click to add departments");
         comboUser->ItemIndex = comboUser->Items->Count - 1;
         comboUser->PopupMenu = popupGroups;
      }
      else if (radioUser->Checked)
      {
         comboUser->Style = Stdctrls::csDropDown;
         comboUser->Clear();
         lookupTables->RegisterComboBox("users", comboUser);
      }
   }
   lastRadioChecked = currentRadioChecked;
}
//---------------------------------------------------------------------------
void TformSpecialNewVendorBill::RefreshARLableInfo()
{
 // update the amount paid label
 float payment_amount = 0.00;
 multimap<string, string> all_payments = GetMultiAccountAmount(listPayments);

 // combine expensie account payments with account recievable payments from employees
 multimap<string, string> ar_payments = GetMultiAccountAmount(listARPayments);
 all_payments.insert(ar_payments.begin(), ar_payments.end());
 for (multimap<string, string>::iterator i_payment = all_payments.begin(); i_payment != all_payments.end(); i_payment++)
 {
    payment_amount += StringToFloat(AmountToString(i_payment->second));
 }

 labelARAmountPayment->Caption = FloatToString(payment_amount).c_str();
}
//---------------------------------------------------------------------------

