//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialOrderShoes.h"
#include "codeRecordIncentive.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialOrderShoes *formSpecialOrderShoes;
//---------------------------------------------------------------------------
__fastcall TformSpecialOrderShoes::TformSpecialOrderShoes(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  this->IconIndex = 24;
  string sql;
  sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix, "
        "incentives.note, "
        "incentives.current_id, incentives.id "
        "from incentives, people "
        "left join person_names on person_names.id = people.person_names_id "
        "where incentives.person_id = people.id and "
        "incentives.incentive_id = " + lookupTables->IdOf("incentive_types", "Shoes") + " and "
        "incentives.date_ordered is null "
        "order by person_names.last_name, person_names.first_name";
  person_filter.SetListViewHandle(listClients);
  person_filter.SetSecurity("incentives");
  person_filter.AddColumnSpec("Name", "people", as_text, true, 130);
  person_filter.AddColumnSpec("Note", "people", as_text, true, 205, sentenceString);
  person_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  person_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  person_filter.FetchPreferences("specialordershoes.person_filter");
  person_filter.SetAddEdit(this, AddRecord(&(TformSpecialOrderShoes::AddOrderRecord)),
                           EditRecord(&(TformSpecialOrderShoes::ViewRecord)));
  person_request = atlas->RequestNotificationWhen("incentives.incentive_id", lookupTables->IdOf("incentive_types", "Shoes"), rel_any, as_int, this,
                               RefreshHandler(&(TformSpecialOrderShoes::AtlasRefreshListView)));
  person_filter.SetCheck(true);
  person_filter.SetCompress(true);
  person_filter.SetSQLStatement(sql);
  person_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialOrderShoes::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialOrderShoes::btnSaveClick(TObject *Sender)
{
  vector<string> selected_id_vec = person_filter.GetMultiID();
  if(! selected_id_vec.empty())
  {
    TIBTransaction *dbTransaction = new TIBTransaction(NULL);
    map<string, string> field_map;
    map<string, string> change_map;
    string today = CurrentDate();
    string now = RightNow();

    field_map["last_update_stamp"] = now;
    field_map["last_updated_by"] = current_userid;
    field_map["date_ordered"] = today;
    change_map["id"] = "1";
    change_map["table_name"] = "incentives";
    change_map["field_name"] = "date_ordered";
    change_map["previous_value"] = "";
    change_map["present_value"] = today;
    change_map["change_stamp"] = now;
    change_map["change_by"] = current_userid;

    try
    {
      StdTransaction(dbTransaction, dbDatabase);
      for (vector<string>::iterator itr = selected_id_vec.begin(); itr != selected_id_vec.end(); itr++)
      {
        field_map["id"] = *itr;
        if (! ExecuteUpdateStatement(dbTransaction, "incentives", field_map))
          throw 1;

        change_map["record_id"] = *itr;
        if(! ExecuteInsertStatement(dbTransaction, "change_log", change_map))
          throw 1;
      }
      dbTransaction->Commit();
    }
    catch (...)
    {
      if (dbTransaction->Active)
        dbTransaction->Rollback();
      PSay("Could not perform update", m_database_error, MB_OK);
    }
    delete dbTransaction;
  }
  Close();
}
//---------------------------------------------------------------------------
void TformSpecialOrderShoes::ViewRecord()
{
  map<string,string> temp_map;
  temp_map["id"] = person_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordIncentive * incentiveRecord = new TformRecordIncentive(NULL, temp_map);
    incentiveRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformSpecialOrderShoes::AddOrderRecord()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["incentive_id"] = lookupTables->IdOf("incentive_types", "Shoes");
  FORM_TRY
    TformRecordIncentive * incentiveRecord = new TformRecordIncentive(NULL, temp_map);
    incentiveRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformSpecialOrderShoes::AtlasRefreshListView(int request_num, string matched_value)
{
  if(request_num == person_request)
    person_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialOrderShoes::btnSelectAllClick(TObject *Sender)
{
  person_filter.CheckAll();        
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialOrderShoes::btnUnselectAllClick(TObject *Sender)
{
  person_filter.UncheckAll();        
}
//---------------------------------------------------------------------------

