//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeprometheus.h"
#include "codeSpecialPermissionsDiff.h"
#include "codeSpecialAddUser.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialPermissionsDiff *formSpecialPermissionsDiff;
//---------------------------------------------------------------------------
__fastcall TformSpecialPermissionsDiff::TformSpecialPermissionsDiff(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  this->IconIndex = 44;
  string sql = "select users.item, groups.item, users.valid, users.id "
               "from users, groups "
               "where users.group_id = groups.id and "
               "users.id > 0"; // and users.valid = 1";
  user_filter.SetListViewHandle(listUsers);
  user_filter.SetSecurity("users");
  user_filter.AddColumnSpec("User", "users", as_text, true, 115);
  user_filter.AddColumnSpec("Group", "users", as_text, true, 115);
  user_filter.AddColumnSpec("Valid", "users", as_text, true, 35, prettyBoolString);
  user_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  user_filter.FetchPreferences("specialpermissionsdiff.user_filter");
  user_filter.SetCompress(true);
  user_filter.SetCheck(true);
  user_filter.SetSQLStatement(sql);
  user_filter.RefreshDataSet();
  user_filter.SetAddEdit(this, AddRecord(&(TformSpecialPermissionsDiff::AddUser)),
                         EditRecord(&(TformSpecialPermissionsDiff::EditUser)));
  user_request = atlas->RequestNotificationWhen("users.id", "0", rel_any, as_int, this,
                 RefreshHandler(&(TformSpecialPermissionsDiff::AtlasRefresh)));

  /*
  possible_permissions_request = atlas->RequestNotificationWhen("possible_permissions", "0", rel_any, as_int, this,
                                 RefreshHandler(&(TformSpecialPermissionsDiff::AtlasRefresh)));
  */
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialPermissionsDiff::listPermissionsClick(TObject *Sender)
{
  // determine x and y position
  if (listPermissions->SelCount > 0)
  {
    TListItem * row = listPermissions->Selected;

    x_pos -= row->Position.x - 2; // TODO -c MAGIC : no idea where '2' comes from exactly, or when it might change.

    int i;
    int left = 0;
    for (i = 0; i < listPermissions->Columns->Count; i++)
    {
     if (x_pos >= left && x_pos < left + min(imageList->Width, listPermissions->Columns->Items[i]->Width))
      break;
     left += listPermissions->Columns->Items[i]->Width;
    }

    if (i > 1 && (i-1 < row->SubItems->Count))
    {
     row->SubItemImages[i-1] = (row->SubItemImages[i-1] + 1) % 2;

     // now, for all currently selected rows, modify rows such that their column value matches this one exactly
     TItemStates selected = TItemStates() << isSelected;
     for (TListItem * Item = listPermissions->Selected; Item != NULL; Item = listPermissions->GetNextItem(Item, sdAll, selected))
      Item->SubItemImages[i-1] = row->SubItemImages[i-1];
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialPermissionsDiff::listPermissionsMouseMove(
      TObject *Sender, TShiftState Shift, int X, int Y)
{
  x_pos = X;        
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialPermissionsDiff::buttonSearchClick(TObject *Sender)
{
 // search
 vector<string> selected_users = user_filter.GetMultiID();

 if (!selected_users.empty())
 {
  string sql_get_all = "select permissions.s, permissions.k, permissions.v, permissions.user_id from permissions where user_id in (" + VecToCommaString(selected_users) + ")";
  vector<map<string, string> > result_all;
  if (!SqlToVecMap(dbDatabase, sql_get_all, result_all))
  {
   PSay("Failed to retrieve full list of permissions for the selected users.", m_database_error, MB_OK);
   return;
  }

  vector<bool> empty_v;
  empty_v.resize(selected_users.size(), false);
  // map<string, unsigned int> id_to_place;
  id_to_place.clear();
  for (unsigned int i = 0; i < selected_users.size(); i++)
   id_to_place[selected_users[i]] = i;

  // map<string, map<string, vector<bool> > > sk_v;
  sk_v.clear();

  string this_s;
  string this_k;
  string prev_s;
  string prev_k;
  map<string, map<string, vector<bool> > >::iterator i_s;
  map<string, vector<bool> >::iterator i_k;

  for (vector<map<string, string> >::iterator i_row = result_all.begin(); i_row != result_all.end(); i_row++)
  {
   this_s = (*i_row)["s"];
   this_k = (*i_row)["k"];

   if (this_s != prev_s)
   {
    i_s = sk_v.find(this_s);
    if (i_s == sk_v.end())
     i_s = sk_v.insert(pair<string, map<string, vector<bool> > >(this_s, map<string, vector<bool> >())).first;
   }

   if (this_s != prev_s || this_k != prev_k)
   {
    i_k = i_s->second.find(this_k);
    if (i_k == i_s->second.end())
     i_k = i_s->second.insert(pair<string, vector<bool> >(this_k, empty_v)).first;
   }

   i_k->second[id_to_place[(*i_row)["user_id"]]] = ((*i_row)["v"] == "TRUE");
  }

  TListColumn * new_column;
  listPermissions->Columns->Clear();

  new_column = listPermissions->Columns->Add();
  new_column->Caption = "Section";
  new_column->Width = 150;

  new_column = listPermissions->Columns->Add();
  new_column->Caption = "Key";
  new_column->Width = 75;

  for (vector<string>::iterator i_user = selected_users.begin(); i_user != selected_users.end(); i_user++)
  {
   new_column = listPermissions->Columns->Add();
   new_column->Caption = lookupTables->ValueOf("users", *i_user).c_str();
   new_column->Width = 75;
  }

  TListItem * new_row;
  listPermissions->Items->Clear();
  for (i_s = sk_v.begin(); i_s != sk_v.end(); i_s++)
  {
   for (i_k = i_s->second.begin(); i_k != i_s->second.end(); i_k++)
   {
    bool varies = false;
    bool last_bool = false;
    for (unsigned int a = 0; a < i_k->second.size(); a++)
    {
     if (!a)
      last_bool = i_k->second[a];
     else
      if (last_bool != i_k->second[a])
       varies = true;
    }

    if (!varies)
     break;

    new_row = listPermissions->Items->Add();
    new_row->Caption = LowercaseString(i_s->first).c_str();
    new_row->SubItems->Add(LowercaseString(i_k->first).c_str());
    new_row->ImageIndex = -1;

    for (unsigned int b = 0; b < i_k->second.size(); b++)
    {
     new_row->SubItems->Add("");
     new_row->SubItemImages[b+1] = ((i_k->second[b]) ? 1 : 0);
    }
   }
  }

 }
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialPermissionsDiff::buttonUpdateClick(TObject *Sender)
{
 // update crap


 TIBTransaction * dbTransaction = NULL;
 try
 {
  dbTransaction = new TIBTransaction(NULL);
  if (!dbTransaction)
   throw(1);

  StdTransaction(dbTransaction, dbDatabase);

  // find differences between currently [x] data and what was used to [x] it in the first place ...
  TListItem * temp_row = NULL;
  string s;
  string k;
  string id;
  bool had_permission;
  bool has_permission;
  map<string, string> insert_map;
  for (int i = 0; i < listPermissions->Items->Count; i++)
  {
   temp_row = listPermissions->Items->Item[i];
   s  = UppercaseString(temp_row->Caption.c_str());
   k  = UppercaseString(temp_row->SubItems->Strings[0].c_str());
   for (map<string, unsigned int>::iterator i_user = id_to_place.begin(); i_user != id_to_place.end(); i_user++)
   {
    id = i_user->first;
    had_permission = sk_v[s][k][i_user->second];
    has_permission = (temp_row->SubItemImages[i_user->second + 1] == 1);

    // PSay("s, k, id, pos, had, has:" + s + ", " + k + ", " + id + ", [" + IntToString(i_user->second) + "], " + (had_permission ? string("true") : string("false")) + ", " + (has_permission ? string("true") : string("false")), m_debug, MB_OK);

    if (had_permission && !has_permission)
    {
     if (!ExecuteStatement(dbTransaction, "delete from permissions where s = '" + s + "' and k = '" + k + "' and user_id = " + id))
      throw(2);
    } else
    if (!had_permission && has_permission)
    {
     insert_map["s"] = s;
     insert_map["k"] = k;
     insert_map["v"] = "TRUE";
     insert_map["user_id"] = id;

     if (!ExecuteInsertStatement(dbTransaction, "permissions", insert_map))
      throw(2);
    }
   }
  }

  dbTransaction->Commit();
 } catch(...)
 {
  PSay("Failed to update permissions.", m_database_error, MB_OK);
  if (dbTransaction && dbTransaction->Active)
   dbTransaction->Rollback();
 }
 delete dbTransaction;

}
//---------------------------------------------------------------------------
void __fastcall TformSpecialPermissionsDiff::buttonCloseClick(TObject *Sender)
{
 // close
 Close();
}
//---------------------------------------------------------------------------
void TformSpecialPermissionsDiff::AtlasRefresh(int request_num, string matched_value)
{
 if (request_num == user_request)
  user_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
void TformSpecialPermissionsDiff::AddUser()
{
   map<string,string> to_pass;
  to_pass["id"] = "new";
  FORM_TRY
    TformSpecialAddUser * editUserForm = new TformSpecialAddUser(NULL, to_pass, NULL);
    editUserForm->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformSpecialPermissionsDiff::EditUser()
{
  map<string,string> to_pass;
  vector<string> return_vec;
  to_pass["id"] = user_filter.GetSelectedRecordID();
  FORM_TRY
    TformSpecialAddUser * editUserForm = new TformSpecialAddUser(NULL, to_pass, &return_vec);
    editUserForm->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------

