//---------------------------------------------------------------------------

#ifndef codeSpecialPersonLimitsH
#define codeSpecialPersonLimitsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include "ttreelistview.h"
#include <ImgList.hpp>
#include <Menus.hpp>
#include <algorithm>
//---------------------------------------------------------------------------
string YearList(int reference_year, int param_year, int num_years)
{
 string answer;
 int offset = (reference_year - (num_years - 1)) % num_years;
 int base_of_period = ((param_year - offset) / num_years) * num_years;
 for (int i = 0; i < num_years; i++)
 {
  if (i)
   answer += ", ";
  answer += IntToString(base_of_period + i + offset);
 }
 return answer;
}
//---------------------------------------------------------------------------
class TformSpecialPersonLimits : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *buttonClose;
        TToolButton *buttonUseless;
        TLabel *labelPerson;
        TStaticText *staticPerson;
        TPopupMenu *popupColumns;
        TMenuItem *checkPeriod;
        TMenuItem *checkArea;
        TMenuItem *checkAccount;
        TMenuItem *N1;
        TMenuItem *checkCOBExpenses;
        TMenuItem *checkVisExpenses;
        TMenuItem *N2;
        TMenuItem *checkTotExpenses;
        TMenuItem *checkLimits;
        TListView *listTotals;
        TLabel *Label2;
        TPanel *panelOldStuff;
        TPanel *panelMoneySummary;
        TLabel *labelMoneyExpensed;
        TLabel *labelMoneyAllowed;
        TLabel *labelMoneyMedical;
        TLabel *labelExpensedMedical;
        TLabel *labelRemainingDental;
        TLabel *labelExpensedDental;
        TLabel *labelAllowedDental;
        TLabel *labelMoneyDental;
        TLabel *labelMoneyOrtho;
        TLabel *labelAllowedOrtho;
        TLabel *labelExpensedOrtho;
        TLabel *labelRemainingOrtho;
        TLabel *labelRemainingVision;
        TLabel *labelExpensedVision;
        TLabel *labelAllowedVision;
        TLabel *labelMoneyVision;
        TLabel *labelMoneyGaming;
        TLabel *labelAllowedGaming;
        TLabel *labelExpensedGaming;
        TLabel *labelRemainingGaming;
        TLabel *labelMoneyRemaining;
        TLabel *labelMoneyHearing;
        TLabel *labelAllowedHearing;
        TLabel *labelExpensedHearing;
        TLabel *labelRemainingHearing;
        TLabel *labelMoneyPeriod;
        TLabel *labelPeriodDental;
        TLabel *labelPeriodVision;
        TLabel *labelPeriodHearing;
        TLabel *labelPeriodGaming;
        TLabel *labelPeriodMedical;
        TLabel *labelMoneyObligated;
        TLabel *labelObligatedMedical;
        TLabel *labelObligatedDental;
        TLabel *labelObligatedOrtho;
        TLabel *labelObligatedVision;
        TLabel *labelObligatedHearing;
        TLabel *labelObligatedGaming;
        TLabel *labelMoneyPaid;
        TLabel *labelPaidMedical;
        TLabel *labelPaidDental;
        TLabel *labelPaidOrtho;
        TLabel *labelPaidVision;
        TLabel *labelPaidHearing;
        TLabel *labelPaidGaming;
        TLabel *labelMoneyTotal;
        TLabel *labelExpensedTotal;
        TLabel *labelObligatedTotal;
        TLabel *labelPaidTotal;
        TLabel *labelPeriodTotal;
        TLabel *labelPeriodOrtho;
        TLabel *labelPeriod;
        TEdit *editPeriod;
        TUpDown *selectPeriod;
        TLabel *Label1;
        TBevel *Bevel1;
        void __fastcall buttonCloseClick(TObject *Sender);
        void __fastcall editPeriodChange(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall checkPeriodClick(TObject *Sender);
        void __fastcall checkAreaClick(TObject *Sender);
        void __fastcall checkAccountClick(TObject *Sender);
        void __fastcall checkCOBExpensesClick(TObject *Sender);
        void __fastcall checkVisExpensesClick(TObject *Sender);
        void __fastcall checkTotExpensesClick(TObject *Sender);
        void __fastcall checkLimitsClick(TObject *Sender);
private:	// User declarations
        bool hack_used_2005_vision_money;

        string person_id;
        void RefreshAmounts();
        void FetchAmounts();
        void ProcessAmounts();
        vector<map<string, string> > processed_combo_data;
        edit_listview * totals_listview;
        void total_selected ();
public:		// User declarations
        __fastcall TformSpecialPersonLimits(TComponent* Owner, map<string, string> p_parameters);
};
//---------------------------------------------------------------------------
extern PACKAGE TformSpecialPersonLimits *formSpecialPersonLimits;
//---------------------------------------------------------------------------
#endif
