//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialPossibleSurveyAnswers.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialPossibleSurveyAnswers *formSpecialPossibleSurveyAnswers;
//---------------------------------------------------------------------------
__fastcall TformSpecialPossibleSurveyAnswers::TformSpecialPossibleSurveyAnswers(TComponent* Owner, string p_survey_question_id)
        : TformSpecialGeneric(Owner)
{
  survey_question_id = p_survey_question_id;

  TIBTransaction *dbTransaction = new TIBTransaction(NULL);
  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbTransaction->StartTransaction();
    string sql;
    list<string> response_list;
    TListItem *row;

    sql = "select question from survey_questions where id = " + survey_question_id;
    txtQuestion->Caption = SentenceString(GetOneField(dbTransaction, sql)).c_str();
    sql = "select response from question_responses where survey_question_id = " + survey_question_id + " "
          "order by response";
    SqlToList(dbTransaction, sql, response_list);
    listResponses->Items->Clear();
    for(list<string>::iterator itr = response_list.begin(); itr != response_list.end(); itr++)
    {
      row = listResponses->Items->Add();
      row->Caption = SentenceString(*itr).c_str();
    }
    dbTransaction->Commit();
  }
  catch(...)
  {
    if(dbTransaction->Active)
      dbTransaction->Rollback();
    PSay("Error loading possible responses", m_database_error, MB_OK);
  }
  delete dbTransaction;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialPossibleSurveyAnswers::btnAddClick(
      TObject *Sender)
{
  TListItem *row;
  row = listResponses->Items->Add();
  row->Caption = SentenceString(editNew->Text.c_str()).c_str();
  editNew->Text = "";
  editNew->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialPossibleSurveyAnswers::btnCancelClick(
      TObject *Sender)
{
 int return_value = PSay("You have made changes that will be lost if you do not save now.\nWould you like to save your changes?", m_confirmation, MB_YESNO);
 if (return_value == IDYES)
   btnSaveClick(NULL);
 else
   Close();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialPossibleSurveyAnswers::btnSaveClick(
      TObject *Sender)
{
  int item_count = listResponses->Items->Count;
  if(item_count > 0)
  {
    Processing(true);
    string sql;
    string this_item;
    map<string, string> insert_map;
    TIBTransaction *dbTransaction = new TIBTransaction(NULL);
    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbTransaction->StartTransaction();

      sql = "delete from question_responses where survey_question_id = " + survey_question_id;
      ExecuteStatement(dbTransaction, sql);
      insert_map["current_id"] = "4";
      insert_map["last_updated_by"] = current_userid;
      insert_map["last_update_stamp"] = RightNow();
      insert_map["survey_question_id"] = survey_question_id;
      for(int i = 0; i < item_count; i++)
      {
        this_item = listResponses->Items->Item[i]->Caption.c_str();
//        insert_map["id"] = GetNextId(dbTransaction, "question_responses");
        insert_map["response"] = this_item;
        ExecuteInsertStatement(dbTransaction, "question_responses", insert_map);
      }
      dbTransaction->Commit();
    }
    catch(...)
    {
      if(dbTransaction->Active)
        dbTransaction->Rollback();
      PSay("Error saving responses", m_database_error, MB_OK);
    }
    delete dbTransaction;
    Processing(false);    
    Close();
  }
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialPossibleSurveyAnswers::menuDeleteClick(
      TObject *Sender)
{
  if(listResponses->SelCount > 0)
    listResponses->Items->Delete(listResponses->Selected->Index);
}
//---------------------------------------------------------------------------


