//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialPreparePurchaseReqs.h"
#include "codeRecordTaxEntity.h"
#include "codeRecordIncomingBill.h"
#include "launchPRReport.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialPreparePurchaseReqs *formSpecialPreparePurchaseReqs;
//---------------------------------------------------------------------------
__fastcall TformSpecialPreparePurchaseReqs::TformSpecialPreparePurchaseReqs(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
 PSay("This screen has been deprecated and replaced,\nplease report to a programmer how you came across this message!", m_warning, MB_OK, "deprecated");
 /*
 panelSelectArea->Color = title_bar_color;
 Start();
 ResetFirstPage();
 GotoFirstPage();
 if(optionsPermissions["special.edit_pr_number"]["enabled"] == "true")
    prPanel->Enabled = true;
 else
    prPanel->Enabled = false;
 */
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialPreparePurchaseReqs::buttonBackClick(TObject *Sender)
{
 // back
 if (pagePreparePurchaseReqs->ActivePageIndex == 1)
 {
  GotoFirstPage();
 } else
 if (pagePreparePurchaseReqs->ActivePageIndex == 2)
 {
  GotoSecondPage();
 }
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialPreparePurchaseReqs::buttonNextClick(TObject *Sender)
{
 // next
 if (pagePreparePurchaseReqs->ActivePageIndex == 0)
 {
  if (first_current_tax_id != "")
  {
   if (GetOneField(dbDatabase, "select tin.identifier "
                               "from tax_entities "
                               "left join entity_ids tin on tin.tax_entity_id = tax_entities.id and tin.current_id >= 3 and tin.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "TIN/EIN") + "' "
                               "where tax_entities.id = '" + first_current_tax_id + "'") != "")
   {
    if (editPRNumber->Text != "" && IsInt(editPRNumber->Text.c_str()))
    {
       vector<map<string,string> > stupid_person_check;
       string sql = "select purchase_req_number from purchase_reqs "
                    "where purchase_req_number = '" + string(editPRNumber->Text.c_str()) + "'";
       SqlToVecMap(dbDatabase, sql, stupid_person_check);
       if (stupid_person_check.empty())
       {
          if (StringToInt(editPRNumber->Text.c_str()) <= StringToInt(GetOneField(dbDatabase, "select gen_id(pr_auto_num_gen, 0) from uno").c_str()))
          {
             // We passed the non-empty, seemingly valid tax entity id, non-empty, numeric PR number,
             // the stupid person PR number, and too-big PR number checks successfully, so go to next page
             if (first_current_tax_id != second_current_tax_id)
              ResetSecondPage();
             GotoSecondPage();
          }
          else
          {
             PSay("You have chosen to override the automatically generated PR number.  However, the \n"
                  "PR number you entered is greater than the number of the next PR to be issued. \n\n"
                  "We know of no reason you should be able to do this and doing so would cause \n"
                  "problems with the database, so this action is not allowed.", m_warning, MB_OK);
          }
       }
       else
       {
          int stupid_answer = PSay(
                                   "You have chosen to override the automatically generated PR number.  However, a \n"
                                   "PR with this PR number already exists. \n\n"
                                   "The only situation where you should continue is if the previous PR has been \n"
                                   "voided and has also already been sent to Finance. \n"
                                   "If the previous PR has been voided but not yet sent to finance, please use the \n"
                                   "auto-generated PR number that was provided. \n"
                                   "If you are sure that you wish to create another PR with this same number, \n"
                                   "choose Yes, otherwise choose No to go back and change it.\n\n"
                                   "Are you SURE you want to use this PR number?", m_confirmation, MB_YESNO);
          if (stupid_answer == IDYES)
          {
             // They've chosen to go on despite having entered an existing PR number...
             // Thus we will have two with the same number in the database... yay
             if (first_current_tax_id != second_current_tax_id)
             ResetSecondPage();
             GotoSecondPage();
          }
          else
          {
             // was auto-generating PR number here, but that didn't make sense so I removed it

          }

       }
    }
    else
    {
     PSay("Please enter a valid, numeric purchase request number.", m_invalid_data, MB_OK);
     editPRNumber->SetFocus();
    }
   }
   else
   {
    PSay("Vendors or providers without a valid Tax ID number cannot be paid. \nPlease edit this tax entity's Tax ID number before proceeding.", m_missing_data, MB_OK);
    listTaxEntities->SetFocus();
   }
  }
  else
  {
   PSay("Please select at least one vendor or provider for which to pay bills.", m_missing_data, MB_OK);
   listTaxEntities->SetFocus();
  }
 } else
 if (pagePreparePurchaseReqs->ActivePageIndex == 1)
 {
  second_bills_to_pay = bills_filter.GetMultiID();
  if (!second_bills_to_pay.empty())
  {
   if (second_bills_to_pay != third_bills_to_pay)
    ResetThirdPage();
   GotoThirdPage();
  }
  else
  {
   PSay("Please select at least one bill to pay.", m_missing_data, MB_OK);
   listBills->SetFocus();
  }
 } else
 if (pagePreparePurchaseReqs->ActivePageIndex == 2)
 {
  // create new PR record
  // attempt to lock all given bills and update pr fk
  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  try
  {
   dbTransaction->DefaultDatabase = dbDatabase;
   dbTransaction->DefaultAction = TARollback;
   dbTransaction->StartTransaction();

   map<string, string> new_purchase_req;
   new_purchase_req["id"] = GetNextId(dbTransaction, "purchase_reqs");
   new_purchase_req["current_id"] = "4";
   new_purchase_req["last_update_stamp"] = RightNow();
   new_purchase_req["last_updated_by"] = current_userid;
   new_purchase_req["check_id"] = "0";
   new_purchase_req["tax_entity_id"] = second_current_tax_id;
   new_purchase_req["date_sent"] = Pdate(datePRDate->Date).OutDate(mdy | yyyy);
   new_purchase_req["purchase_req_number"] = editPRNumber->Text.c_str();
   if (!ExecuteInsertStatement(dbTransaction, "purchase_reqs", new_purchase_req))
    throw (3);

   string update_sql = "update bills set purchase_req_id = '" + new_purchase_req["id"] + "' where id in ('";
   for (vector<string>::iterator i_bill_id = third_bills_to_pay.begin(); i_bill_id != third_bills_to_pay.end(); i_bill_id++)
   {
    if (i_bill_id != third_bills_to_pay.begin())
     update_sql += "', '";
    update_sql += *i_bill_id;
   }
   update_sql += "')";

   if (!ExecuteStatement(dbTransaction, update_sql))
    throw(7);
   dbTransaction->Commit();
   // TODO: based on check boxes, show reports for PR, bills, unmarked bills, and vendor bills!

    FORM_TRY
      TformLaunchPRReport * print_pr = new TformLaunchPRReport(NULL, new_purchase_req["id"]);
      print_pr->ShowTaskModal(this);
    FORM_CATCH


   ResetFirstPage();
   GotoFirstPage();
  }
  catch (...)
  {
   if (dbTransaction->Active)
    dbTransaction->Rollback();
   PSay("Couldn't save a new PR, or some bills were already locked by another user.", m_database_error, MB_OK);
  }
  delete dbTransaction;
 }
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialPreparePurchaseReqs::buttonCancelClick(TObject *Sender)
{
 // cancel
 ResetFirstPage();
 GotoFirstPage();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialPreparePurchaseReqs::buttonCloseClick(TObject *Sender)
{
 // close
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialPreparePurchaseReqs::comboTaxEntityTypeChange(TObject *Sender)
{
 // on change of the drop-down thingie
 ResetFirstPage();
}
//---------------------------------------------------------------------------
void TformSpecialPreparePurchaseReqs::ResetFirstPage()
{
 auto_gen_PR_number = GetOneField(dbDatabase, "select gen_id(pr_auto_num_gen, 1) from uno");
 if(optionsPermissions["special.edit_pr_number"]["enabled"] != "true")
   editPRNumber->Text = auto_gen_PR_number.c_str();
 else if (optionsPermissions["special.suggest_pr_number"]["enabled"] == "true")
   editPRNumber->Text = auto_gen_PR_number.c_str();
 string incoming_prov_bills = lookupTables->IdOf("bill_types", "INCOMING PROVIDER BILL");
 string incoming_vend_bills = lookupTables->IdOf("bill_types", "INCOMING VENDOR BILL");

 if (incoming_prov_bills == "" || incoming_vend_bills == "")
 {
  PSay("Missing lookup table value in bill_types", m_database_error, MB_OK);
  return;
 }

 // the commented-out sections DO work, but they take longer ... not the case with the sql
 // for the second page, but it can be fixed the same way (don't join with accounts, just sub-select
 // all accounts you want transactions for ... )
 // in test runs, screen opens without delay without info, takes 10 to 20 seconds with extra info.
 // kinda sick, hunh?
 string sql = "select tax_entities.name, count (distinct bills.id), "
              "sum(bills.invoice_amount), "
              "sum(bills.total_charge), "
              // "sum(transactions.credit_amount - transactions.debit_amount), "
              "tax_entity_types.item, tax_entities.current_id, tax_entities.id "
              "from tax_entities "
              "inner join bills on bills.actual_tax_id = tax_entities.id "
              "inner join bill_types on bills.bill_id = bill_types.id "
              "inner join tax_entity_types on tax_entity_types.id = tax_entities.tax_entity_id "
              // "left join transactions on transactions.bill_id = bills.id and "
              // "transactions.current_id > '2' and transactions.account_id in ("
              // "select accounts.id from accounts where account_type_id = " + lookupTables->IdOf("account_types", "Payable") +
              // " and accounts.current_id > '2') where "
              " where "
              "bills.current_id > '2' and tax_entities.current_id > '2' and "
              "bills.purchase_req_id = '0' and bill_types.id in ('";
 sql += incoming_prov_bills;
 sql += "', '";
 sql += incoming_vend_bills;
 sql += "') ";

 if (tax_filter_request != 0)
  atlas->CancelRequest(tax_filter_request);

 if (comboTaxEntityType->Text != "" && lookupTables->IsInLookUpTable("tax_entity_types", comboTaxEntityType->Text.c_str()))
 {
  string specific_tax_entity_type = incoming_prov_bills = lookupTables->IdOf("tax_entity_types", comboTaxEntityType->Text.c_str());
  sql += "and tax_entity_types.id = '";
  sql += specific_tax_entity_type;
  sql += "' ";
  tax_filter_request = atlas->RequestNotificationWhen ("tax_entities.tax_entity_id", specific_tax_entity_type, rel_e, as_int, this, RefreshHandler(&(TformSpecialPreparePurchaseReqs::AtlasScreen)));
 }
 else
 {
  tax_filter_request = atlas->RequestNotificationWhen ("tax_entities.id", "0", rel_any, as_int, this, RefreshHandler(&(TformSpecialPreparePurchaseReqs::AtlasScreen)));
 }

 sql += "group by tax_entities.name, tax_entity_types.item, tax_entities.current_id, tax_entities.id order by 2 descending, 1 ascending";

 tax_entities_filter.SetSQLStatement(sql);
 tax_entities_filter.RefreshDataSet();
 first_current_tax_id = "";
 datePRDate->DateTime = Date().CurrentDate();

 ResetSecondPage();
 return;
}
//---------------------------------------------------------------------------
void TformSpecialPreparePurchaseReqs::ResetSecondPage()
{
 string sql;
 second_current_tax_id = first_current_tax_id;
 if (second_current_tax_id != "")
 {
  sql = "select "
        "person_names.last_name || ', ' || person_names.first_name, "
        "users.item, "
        "tasks.date_of_task, "
        "bills.bill_date, "
        "bills.invoice_amount, "
        "bills.total_charge, "
//        "sum(obligated.credit_amount - obligated.debit_amount), "
//        "sum(expensed.debit_amount - expensed.credit_amount), "
//        "sum(spent.debit_amount - spent.credit_amount), "
        "bills.current_id, bills.id "
        "from bills "
        "left join tasks on bills.task_id = tasks.id and tasks.current_id > '2' "
        "left join people on tasks.person_id = people.id "
        "left join person_names on people.person_names_id = person_names.id "
        "left join users on bills.user_id = users.id "
//        "left join transactions obligated  on obligated.bill_id = bills.id and obligated.current_id > '2' "
        /*
        "left join transactions expensed   on expensed.bill_id = bills.id and expensed.current_id > '2' "
        "left join transactions spent      on spent.bill_id = bills.id and spent.current_id > '2' "
        */
//        "inner join accounts ob_accounts    on obligated.account_id = ob_accounts.id and "
//        "ob_accounts.account_type_id = '" + lookupTables->IdOf("account_types", "PAYABLE") + "' "
        /*
        "left join accounts exp_accounts   on expensed.account_id = exp_accounts.id and "
        "exp_accounts.account_type_id = '" + lookupTables->IdOf("account_types", "EXPENSE") + "' "
        "left join accounts spent_accounts on spent.account_id = spent_accounts.id and "
        "spent_accounts.account_type_id = '" + lookupTables->IdOf("account_types", "CASH") + "' "
        */
        "where bills.actual_tax_id = '" + second_current_tax_id + "' and "
        "bills.purchase_req_id = '0' and bills.id > '0' "
        "order by person_names.last_name, person_names.first_name ";
//        "group by "
//        "person_names.last_name, person_names.first_name, "
//        "users.item, tasks.date_of_task, bills.bill_date, bills.invoice_amount, "
//        "bills.total_charge, bills.current_id, bills.id";
 }

 // TODO: *elsewhere* examine problem of duplicate bills, etc.
 // DONE: deleted bills? deleted tasks? -- i think i handled that.

 if (bill_filter_request != 0)
  atlas->CancelRequest(bill_filter_request);
 bill_filter_request = atlas->RequestNotificationWhen ("bills.actual_tax_id", second_current_tax_id, rel_e, as_int, this, RefreshHandler(&(TformSpecialPreparePurchaseReqs::AtlasScreen)));

 bills_filter.SetSQLStatement(sql);
 bills_filter.RefreshDataSet();
 bills_filter.CheckAll();

 ResetThirdPage();
 return;
}
//---------------------------------------------------------------------------
void TformSpecialPreparePurchaseReqs::ResetThirdPage()
{
 third_bills_to_pay = second_bills_to_pay;
 return;
}
//---------------------------------------------------------------------------
void TformSpecialPreparePurchaseReqs::GotoFirstPage()
{
 staticHeader->Caption = "1 of 3 - Select a tax entity to pay bills for";
 sheetSelectTaxEntity->Show();
 buttonBack->Enabled = false;
 buttonNext->Caption = "Next >>";
 return;
}
//---------------------------------------------------------------------------
void TformSpecialPreparePurchaseReqs::GotoSecondPage()
{
 staticHeader->Caption = "2 of 3 - Select bills to pay for a given tax entity";
 sheetSelectBills->Show();
 buttonBack->Enabled = true;
 buttonNext->Caption = "Next >>";
 return;
}
//---------------------------------------------------------------------------
void TformSpecialPreparePurchaseReqs::GotoThirdPage()
{
 staticHeader->Caption = "3 of 3 - Select printing options for purchase request";
 sheetFinal->Show();
 buttonBack->Enabled = true;
 buttonNext->Caption = "Finish";
 return;
}
//---------------------------------------------------------------------------
void TformSpecialPreparePurchaseReqs::Start ()
{
 lookupTables->RegisterComboBox("tax_entity_types", comboTaxEntityType);
 tax_filter_request = 0;
 bill_filter_request = 0;

 tax_entities_filter.SetListViewHandle(listTaxEntities);
 tax_entities_filter.SetSecurity("tax_entities");
 tax_entities_filter.AddColumnSpec("Name" , "tax_entities", as_text, true, 150, rawString);
 tax_entities_filter.AddColumnSpec("Bills", "bills", as_int, true, 40);
 tax_entities_filter.AddColumnSpec("Invoice",     "bills", as_double, true, 80, amountString);
 tax_entities_filter.AddColumnSpec("Charges",     "bills", as_double, true, 80, amountString);
// tax_entities_filter.AddColumnSpec("Obligated",   "transactions", as_double, true, 80, amountString);
// tax_entities_filter.AddColumnSpec("Expensed",    "transactions", as_double, true, 80, amountString);
// tax_entities_filter.AddColumnSpec("Paid (cash)", "transactions", as_double, true, 80, amountString);
 tax_entities_filter.AddColumnSpec("Type", "tax_entities", as_text, true, 80);
 tax_entities_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 tax_entities_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 tax_entities_filter.FetchPreferences("specialpreparepurchasereqs.tax_entities_filter");
 tax_entities_filter.SetSQLStatement("");
 tax_entities_filter.RefreshDataSet();
 tax_entities_filter.SetAddEdit(this, NULL, EditRecord(&(TformSpecialPreparePurchaseReqs::EditTaxEntity)));

 bills_filter.SetListViewHandle(listBills);
 bills_filter.SetSecurity("bills");
 bills_filter.AddColumnSpec("Name" ,       "person_names", as_text, true, 120);
 bills_filter.AddColumnSpec("Employee" ,   "bills", as_text, true, 120);
 bills_filter.AddColumnSpec("Date" ,       "tasks", as_date, true, 80);
 bills_filter.AddColumnSpec("Received" ,   "bills", as_date, true, 80);
 bills_filter.AddColumnSpec("Invoice",     "bills", as_double, true, 80, nonzeroAmountString );
 bills_filter.AddColumnSpec("Charges",     "bills", as_double, true, 80, nonzeroAmountString );
// bills_filter.AddColumnSpec("Obligated",   "transactions", as_double, true, 80, nonzeroAmountString );
// bills_filter.AddColumnSpec("Expensed",    "transactions", as_double, true, 80, amountString);
// bills_filter.AddColumnSpec("Paid (cash)", "transactions", as_double, true, 80, amountString);
 bills_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 bills_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 bills_filter.FetchPreferences("specialpreparepurchasereqs.bills_filter");
 bills_filter.SetCheck(true);
 bills_filter.SetSQLStatement("");
 bills_filter.RefreshDataSet();
 bills_filter.SetAddEdit(this, NULL, EditRecord(&(TformSpecialPreparePurchaseReqs::EditBill)));

 return;
}
//---------------------------------------------------------------------------
void TformSpecialPreparePurchaseReqs::Stop ()
{
 lookupTables->UnregisterComboBox("tax_entity_types", comboTaxEntityType);
 atlas->CancelRequestFrom(this);
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialPreparePurchaseReqs::listTaxEntitiesSelectItem(
      TObject *Sender, TListItem *Item, bool Selected)
{
 // select a different tax entity?
 first_current_tax_id = tax_entities_filter.GetSelectedRecordID();
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialPreparePurchaseReqs::FormClose(TObject *Sender, TCloseAction &Action)
{
 // closing ...
 Stop();
 TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void TformSpecialPreparePurchaseReqs::EditTaxEntity()
{
 map<string,string> temp_map;
 temp_map["id"] = tax_entities_filter.GetSelectedRecordID();
 FORM_TRY
   TformRecordTaxEntity * tax_entity = new TformRecordTaxEntity(NULL, temp_map);
   tax_entity->Show();
 FORM_CATCH
 return;
}
//---------------------------------------------------------------------------
void TformSpecialPreparePurchaseReqs::EditBill()
{
 map<string, string> params;
 params["id"] = bills_filter.GetSelectedRecordID();
 FORM_TRY
   TformRecordIncomingBill * edit_bill = new TformRecordIncomingBill(NULL, params);
   edit_bill->Show();
 FORM_CATCH
 return;
}
//---------------------------------------------------------------------------
bool TformSpecialPreparePurchaseReqs::AtlasScreen(int req_num, string matched_value)
{
 if (req_num == bill_filter_request)
  bills_filter.RefreshDataSet();
 if (req_num == tax_filter_request)
  tax_entities_filter.RefreshDataSet();
 return true;
}
//---------------------------------------------------------------------------

