//---------------------------------------------------------------------------

#ifndef codeSpecialProgressTreeH
#define codeSpecialProgressTreeH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include "ttreelistview.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
//---------------------------------------------------------------------------


// Description, Status, Time so far, Time total, Completed %, (Items so far, Items total,)
// -> if starting with items, have it guess time based on how long it's taken so far?
// -> if starting with time, don't try to guess items.
// -> in fact, perhaps only show time (derived or direct) but not item counts? (except by special request?)

enum progress_row_status_types {progress_not_begun, progress_working, progress_finished, progress_cancelled, progress_broken};
enum progress_row_indicator_types {progress_cost_to_cost, progress_cost_to_time, progress_time_to_time};

class progress_row
{
 string id;
 string parent_id;
 string description;
 unsigned int ordinal_position;
 progress_row_status_types status;
 progress_row_indicator_types indicator;

 Ptime start_time;
 Ptime time_spent;
 Ptime time_required;
 unsigned int cost_spent;
 unsigned int cost_required;
};

//---------------------------------------------------------------------------
class TformSpecialProgressTree : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *buttonClose;
        TToolButton *buttonUseless;
private:	// User declarations
public:		// User declarations
        __fastcall TformSpecialProgressTree(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TformSpecialProgressTree *formSpecialProgressTree;
//---------------------------------------------------------------------------
#endif
