//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialReceiveShoes.h"
#include "codeRecordIncentive.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialReceiveShoes *formSpecialReceiveShoes;
//---------------------------------------------------------------------------
__fastcall TformSpecialReceiveShoes::TformSpecialReceiveShoes(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  this->IconIndex = 24;
  string sql;
  sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix name, "
        "incentives.date_ordered, incentives.current_id, incentives.id "
        "from incentives, people "
        "left join person_names on person_names.id = people.person_names_id "
        "where incentives.person_id = people.id and "
        "incentives.incentive_id = " + lookupTables->IdOf("incentive_types", "Shoes") + " and "
        "incentives.date_ordered is not null and "
        "incentives.received_from_nike = 0 "
        "order by person_names.last_name, person_names.first_name";
  person_filter.SetListViewHandle(listClients);
  person_filter.SetSecurity("incentives");
  person_filter.AddColumnSpec("Name", "people", as_text, true, 150);
  person_filter.AddColumnSpec("Date Ordered", "incentives", as_date, true, 100);
  person_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  person_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  person_filter.FetchPreferences("specialreceiveshoes.person_filter");
  person_filter.SetAddEdit(this, NULL, EditRecord(&(TformSpecialReceiveShoes::ViewRecord)));
  person_filter.SetCheck(true);
  person_filter.SetCompress(true);
  person_filter.SetSQLStatement(sql);
  person_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReceiveShoes::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReceiveShoes::btnSaveClick(TObject *Sender)
{
  vector<string> selected_id_vec = person_filter.GetMultiID();
  if(! selected_id_vec.empty())
  {
    TIBTransaction *dbTransaction = new TIBTransaction(NULL);
    map<string, string> field_map;
    map<string, string> change_map;
    string now = RightNow();

    field_map["last_update_stamp"] = now;
    field_map["last_updated_by"] = current_userid;
    field_map["received_from_nike"] = "1";
    change_map["id"] = "1";
    change_map["table_name"] = "incentives";
    change_map["field_name"] = "received_from_nike";
    change_map["previous_value"] = "0";
    change_map["present_value"] = "1";
    change_map["change_stamp"] = now;
    change_map["change_by"] = current_userid;

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbTransaction->StartTransaction();
      for (vector<string>::iterator itr = selected_id_vec.begin(); itr != selected_id_vec.end(); itr++)
      {
        field_map["id"] = *itr;
        if (! ExecuteUpdateStatement(dbTransaction, "incentives", field_map))
          throw 1;

        change_map["record_id"] = *itr;
        if(! ExecuteInsertStatement(dbTransaction, "change_log", change_map))
          throw 1;
      }
      dbTransaction->Commit();
    }
    catch (...)
    {
      if (dbTransaction->Active)
        dbTransaction->Rollback();
      PSay("Could not perform update", m_database_error, MB_OK);
    }
    delete dbTransaction;
  }
  Close();
}
//---------------------------------------------------------------------------
void TformSpecialReceiveShoes::ViewRecord()
{
  map<string,string> temp_map;
  temp_map["id"] = person_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordIncentive * incentiveRecord = new TformRecordIncentive(NULL, temp_map);
    incentiveRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReceiveShoes::btnSelectAllClick(
      TObject *Sender)
{
  person_filter.CheckAll();        
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialReceiveShoes::btnUnselectAllClick(
      TObject *Sender)
{
  person_filter.UncheckAll();        
}
//---------------------------------------------------------------------------

