//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "codeSpecialReusableAccountingInsert.h"
#include "codeSearchTaxEntity.h"
#include "codeSearchAccount.h"
#include "codeRecordAccount.h"
#include "control_break_objects.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialReusableAccountingInsert *formSpecialReusableAccountingInsert;
//---------------------------------------------------------------------------
__fastcall TformSpecialReusableAccountingInsert::TformSpecialReusableAccountingInsert(TComponent* Owner, reusable_accounting_insert_parameters * p_params)
        : TformSpecialGeneric(Owner)
{
 // just hope it's not null!
 params = p_params;

 total_target = params->target_amount;

 if (!(params->is_change))
  this->Caption = this->Caption + " - initial conditions (positive amounts only)";
 else
  this->Caption = this->Caption + " - changes, corrections (negative amounts allowed)";

 // disable buttons we don't like
 // (note that currently, inventory is permanently disabled,
 //  at least in the sense that the button is disabled on the form,
 //  and no amount of changing the bools will help it ... errr ...
 //  plenty of ways around that. sorry. oops. i don't care.)
 if (!params->show_inventory)
  buttonInventory->Enabled = false;
 if (!params->show_expense)
  buttonExpense->Enabled = false;   
 if (!params->show_forward)
  buttonForward->Enabled = false;
 if (!params->show_revenue)
  buttonRevenue->Enabled = false;

 // switch to first allowed page
 if (buttonInventory->Enabled)
 {
  buttonInventory->Down = true;
  sheetInventory->Show();
 } else
 if (buttonExpense->Enabled)
 {
  buttonExpense->Down = true;
  sheetExpense->Show();
 } else
 if (buttonForward->Enabled)
 {
  buttonForward->Down = true;
  sheetForward->Show();
 } else
 if (buttonRevenue->Enabled)
 {
  buttonRevenue->Down = true;
  sheetRevenue->Show();
 } else
 {
  buttonResult->Down = true;
  sheetResult->Show();
 }

 edit_inventory.setup_listview(listInventory, false);
 edit_inventory.add_or_modify_column("item_type_id",  "Item type id",      false, 0, 60,  as_int,    rawString);
 edit_inventory.add_or_modify_column("item_type",     "Item type",         true,  1, 120, as_text,   prettyString);
 edit_inventory.add_or_modify_column("is_unique",     "Unique",            false, 2, 60,  as_int,    prettyBoolString);
 edit_inventory.add_or_modify_column("size_type_id",  "Size type id",      false, 3, 60,  as_int,    rawString);
 edit_inventory.add_or_modify_column("size_type",     "Size type",         false, 4, 60,  as_text,   prettyString);
 edit_inventory.add_or_modify_column("cost_per_size", "Cost",              true,  5, 60,  as_double, amountString);
 edit_inventory.add_or_modify_column("quantity",      "Quantity",          true,  6, 60,  as_double, amountString);
 edit_inventory.add_or_modify_column("unique_number", "Unique identifier", true,  7, 120, as_text,   rawString);
 edit_inventory.setup_callbacks((TForm*)this, InformForm(&(TformSpecialReusableAccountingInsert::InventoryRowSelected)), NULL);
 edit_inventory.import_data(params->inventory_data);

 edit_expense.setup_listview(listExpense, false);
 edit_expense.add_or_modify_column("expense_account_id",   "Expense account id", false, 0, 60,  as_int,    rawString);
 edit_expense.add_or_modify_column("payable_account_id",   "Payable account id", false, 1, 60,  as_int,    rawString);
 edit_expense.add_or_modify_column("cash_account_id",      "Cash account id",    false, 2, 60,  as_int,    rawString);
 edit_expense.add_or_modify_column("tax_entity_id",        "Tax entity id",      false, 3, 60,  as_int,    rawString);
 edit_expense.add_or_modify_column("expense_account_name", "Account",            true,  4, 130, as_text,   rawString);
 edit_expense.add_or_modify_column("tax_entity_name",      "Payee",              false, 5, 120, as_text,   prettyString);
 edit_expense.add_or_modify_column("payable_amount",       "Payable",            true,  6, 75,  as_double, nonzeroAmountString);
 edit_expense.add_or_modify_column("paid_amount",          "Paid",               true,  7, 75,  as_double, nonzeroAmountString);
 edit_expense.setup_callbacks((TForm*)this, InformForm(&(TformSpecialReusableAccountingInsert::ExpenseRowSelected)), NULL);
 edit_expense.import_data(params->expense_data);

 edit_forward.setup_listview(listForward, false);
 edit_forward.add_or_modify_column("receivable_account_id",   "Receivable account id", false, 0, 60,  as_int,    rawString);
 edit_forward.add_or_modify_column("payable_account_id",      "Payable account id",    false, 1, 60,  as_int,    rawString);
 edit_forward.add_or_modify_column("cash_account_id",         "Cash account id",       false, 2, 60,  as_int,    rawString);
 edit_forward.add_or_modify_column("tax_entity_id_from",      "Tax entity id payor",   false, 3, 60,  as_int,    rawString);
 edit_forward.add_or_modify_column("tax_entity_id_to",        "Tax entity id payee",   false, 4, 60,  as_int,    rawString);
 edit_forward.add_or_modify_column("receivable_account_name", "Account",               true,  5, 130, as_text,   rawString);
 edit_forward.add_or_modify_column("tax_entity_name_from",    "Payor",                 true,  6, 120, as_text,   prettyString);
 edit_forward.add_or_modify_column("tax_entity_name_to",      "Payee",                 false, 7, 120, as_text,   prettyString);
 edit_forward.add_or_modify_column("receivable_amount",       "Receivable",            true,  8, 75,  as_double, nonzeroAmountString);
 edit_forward.add_or_modify_column("received_amount",         "Received",              true,  9, 75,  as_double, nonzeroAmountString);
 edit_forward.add_or_modify_column("payable_amount",          "Payable",               true, 10, 75,  as_double, nonzeroAmountString);
 edit_forward.add_or_modify_column("paid_amount",             "Paid",                  true, 11, 75,  as_double, nonzeroAmountString);
 edit_forward.setup_callbacks((TForm*)this, InformForm(&(TformSpecialReusableAccountingInsert::ForwardRowSelected)), NULL);
 edit_forward.import_data(params->forward_data);

 edit_revenue.setup_listview(listRevenue, false);
 edit_revenue.add_or_modify_column("revenue_account_id",      "Revenue account id",    false, 0, 60,  as_int,    rawString);
 edit_revenue.add_or_modify_column("receivable_account_id",   "Receivable account id", false, 1, 60,  as_int,    rawString);
 edit_revenue.add_or_modify_column("cash_account_id",         "Cash account id",       false, 2, 60,  as_int,    rawString);
 edit_revenue.add_or_modify_column("tax_entity_id",           "Tax entity id",         false, 3, 60,  as_int,    rawString);
 edit_revenue.add_or_modify_column("revenue_account_name",    "Account",               true,  4, 130, as_text,   rawString);
 edit_revenue.add_or_modify_column("tax_entity_name",         "Payor",                 true,  5, 120, as_text,   prettyString);
 edit_revenue.add_or_modify_column("receivable_amount",       "Receivable",            true,  6, 75,  as_double, nonzeroAmountString);
 edit_revenue.add_or_modify_column("received_amount",         "Received",              true,  7, 75,  as_double, nonzeroAmountString);
 edit_revenue.setup_callbacks((TForm*)this, InformForm(&(TformSpecialReusableAccountingInsert::RevenueRowSelected)), NULL);
 edit_revenue.import_data(params->revenue_data);

 edit_before.setup_listview(listBefore, false);
 edit_change.setup_listview(listChange, false);
 edit_after.setup_listview(listAfter, false);

 edit_budget.setup_listview(listBudgets, false);
 edit_budget.add_or_modify_column("account_id",      "Account id",      false, 0, 60,  as_int,    rawString);
 edit_budget.add_or_modify_column("account_name",    "Account",         true,  1, 130, as_text,   rawString);
 edit_budget.add_or_modify_column("original_budget", "Original budget", true,  2, 75,  as_double, amountString);
 edit_budget.add_or_modify_column("old_expenses",    "Old expenses",    true,  3, 75,  as_double, amountString);
 edit_budget.add_or_modify_column("old_budget",      "Old budget",      true,  4, 75,  as_double, amountString);
 edit_budget.add_or_modify_column("new_expenses",    "New expenses",    true,  5, 75,  as_double, amountString);
 edit_budget.add_or_modify_column("new_budget",      "New budget",      true,  6, 75,  as_double, amountString);

 MaskSetup (editExpenseAccount);
 MaskSetup (editForwardAccount);
 MaskSetup (editRevenueAccount);

 current_inventory_tax_entity_id    = params->default_inventory_tax_entity_id;
 current_expense_tax_entity_id      = params->default_expense_tax_entity_id;
 current_forward_tax_entity_id_from = params->default_forward_tax_entity_id_from;
 current_forward_tax_entity_id_to   = params->default_forward_tax_entity_id_to;
 current_revenue_tax_entity_id      = params->default_revenue_tax_entity_id;

 CreateLink (staticInventoryTaxEntity, buttonInventorySearchTaxEntity, this, current_inventory_tax_entity_id, "tax_entities", "table.tax_entities", true);
 CreateLink (staticExpenseTaxEntity, buttonExpenseSearchTaxEntity, this, current_expense_tax_entity_id, "tax_entities", "table.tax_entities", false);
 CreateLink (staticForwardTaxEntityFrom, buttonForwardSearchTaxEntityFrom, this, current_forward_tax_entity_id_from, "tax_entities", "table.tax_entities", true);
 CreateLink (staticForwardTaxEntityTo, buttonForwardSearchTaxEntityTo, this, current_forward_tax_entity_id_to, "tax_entities", "table.tax_entities", false);
 CreateLink (staticRevenueTaxEntity, buttonRevenueSearchTaxEntity, this, current_revenue_tax_entity_id, "tax_entities", "table.tax_entities", true);

 RefreshSummary();

 treeSummary->Items->Item[0]->Expand(false);
 treeSummary->Items->Item[1]->Expand(false);
 treeSummary->Items->Item[4]->Expand(false);
 treeSummary->Items->Item[9]->Expand(false);
 treeSummary->Items->Item[12]->Expand(false);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonSaveClick(TObject *Sender)
{
 // take final situation data from the 'after' listview, as it already has everything added together!
 vector<map<string, string> > end_result;
 edit_after.export_data(end_result);

 // do not allow saving if any of the following are negative:
 // [x] - any account/entity entry, other than cash accounts.
 financial temp_change_amount;
 for (vector<map<string, string> >::iterator i_row = end_result.begin(); i_row != end_result.end(); i_row++)
 {
  temp_change_amount = StringToFinancial((*i_row)["change_amount"]);
  if (temp_change_amount < 0.00 && StringToAccountType((*i_row)["account_type"]) != cash_acc)
  {
   PSay("Please correct the following problem before saving:\n" + (*i_row)["account_type"] + " account " + (*i_row)["account_name"] + " will have a net change of " + FinancialToString(temp_change_amount, true) + " for " + (*i_row)["tax_entity_name"] + ".\nOther than cash accounts, no account/entity pairs may be negative when you close this screen.", m_invalid_data, MB_OK);
   return;
  }
 }
 // we should also avoid the following:
 // from the same tax entity, having:
 // [x] - positive cash -and- positive payable or expense
 // [x] - negative cash -and- positive receivable or revenue
 // [x] - both positive payable or expense -and- positive receivable or revenue
 map<string, map<account_types, financial> > entity_type_amount;
 map<string, map<account_types, financial> >::iterator i_entity;
 map<account_types, financial>::iterator i_type;
 map<string, string> entity_names;
 account_types row_type;
 financial row_amount;

 // calculate, per entity, per type of account, the total end result.
 for (vector<map<string, string> >::iterator i_row = end_result.begin(); i_row != end_result.end(); i_row++)
 {
  row_type   = StringToAccountType((*i_row)["account_type"]);
  row_amount = StringToFinancial((*i_row)["change_amount"]);
  i_entity   = entity_type_amount.find((*i_row)["tax_entity_id"]);
  if (i_entity != entity_type_amount.end())
  {
   i_type = i_entity->second.find(row_type);
   if (i_type != i_entity->second.end())
    i_type->second += row_amount;
   else
    i_entity->second[row_type] = row_amount;
  } else
  {
   // all the values we'll be looking at, zero by default ...
   entity_type_amount[(*i_row)["tax_entity_id"]][cash_acc]       = (financial)0.00;
   entity_type_amount[(*i_row)["tax_entity_id"]][expense_acc]    = (financial)0.00;
   entity_type_amount[(*i_row)["tax_entity_id"]][revenue_acc]    = (financial)0.00;
   entity_type_amount[(*i_row)["tax_entity_id"]][receivable_acc] = (financial)0.00;
   entity_type_amount[(*i_row)["tax_entity_id"]][payable_acc]    = (financial)0.00;
   // ... except for the one we already know about!
   entity_type_amount[(*i_row)["tax_entity_id"]][row_type] = row_amount;
   entity_names[(*i_row)["tax_entity_id"]] = PrettyString((*i_row)["tax_entity_name"]);
  }
 }

 // the following is quite likely to nag the user -- they will meet multiple conditions at once.
 // this was done on purpose -- i won't keep them (yet) from doing these things, but damn it,
 // they'd better mean to. a lot.
 for (i_entity = entity_type_amount.begin(); i_entity != entity_type_amount.end(); i_entity++)
 {
  if (i_entity->second[cash_acc] > 0.00 && i_entity->second[payable_acc] > 0.00)
   if (IDNO == PSay("Please correct the following problem before saving:\n" + entity_names[i_entity->first] + " has both a positive cash balance and a positive payable balance.\nThis indicates that we both owe money to, and have received money from, the same entity.\n\nAre you absolutely sure you want this to be the case?", m_confirmation, MB_YESNO))
    return;
  if (i_entity->second[cash_acc] > 0.00 && i_entity->second[expense_acc] > 0.00)
   if (IDNO == PSay("Please correct the following problem before saving:\n" + entity_names[i_entity->first] + " has both a positive cash balance and a positive expense balance.\nThis indicates that we both owe (or have paid) money to, and have received money from, the same entity.\n\nAre you absolutely sure you want this to be the case?", m_confirmation, MB_YESNO))
    return;
  if (i_entity->second[cash_acc] < 0.00 && i_entity->second[receivable_acc] > 0.00)
   if (IDNO == PSay("Please correct the following problem before saving:\n" + entity_names[i_entity->first] + " has both a negative cash balance and a positive receivable balance.\nThis indicates that we both are owed money from, and have paid money to, the same entity.\n\nAre you absolutely sure you want this to be the case?", m_confirmation, MB_YESNO))
    return;
  if (i_entity->second[cash_acc] < 0.00 && i_entity->second[revenue_acc] > 0.00)
   if (IDNO == PSay("Please correct the following problem before saving:\n" + entity_names[i_entity->first] + " has both a negative cash balance and a positive revenue balance.\nThis indicates that we both are owed (or have been paid) money from, and have paid money to, the same entity.\n\nAre you absolutely sure you want this to be the case?", m_confirmation, MB_YESNO))
    return;
  if (i_entity->second[payable_acc] > 0.00 && i_entity->second[receivable_acc] > 0.00)
   if (IDNO == PSay("Please correct the following problem before saving:\n" + entity_names[i_entity->first] + " has both a positive payable balance and a positive receivable balance.\nThis indicates that we both owe money to, and are owed money from, the same entity.\n\nAre you absolutely sure you want this to be the case?", m_confirmation, MB_YESNO))
    return;
  if (i_entity->second[expense_acc] > 0.00 && i_entity->second[revenue_acc] > 0.00)
   if (IDNO == PSay("Please correct the following problem before saving:\n" + entity_names[i_entity->first] + " has both a positive expense balance and a positive revenue balance.\nThis indicates that we both owe (or have paid) money to, and are owed (or have been paid) money from, the same entity.\n\nAre you absolutely sure you want this to be the case?", m_confirmation, MB_YESNO))
    return;
  if (i_entity->second[payable_acc] > 0.00 && i_entity->second[revenue_acc] > 0.00)
   if (IDNO == PSay("Please correct the following problem before saving:\n" + entity_names[i_entity->first] + " has both a positive payable balance and a positive revenue balance.\nThis indicates that we both owe money to, and are owed (or have been paid) money from, the same entity.\n\nAre you absolutely sure you want this to be the case?", m_confirmation, MB_YESNO))
    return;
  if (i_entity->second[expense_acc] > 0.00 && i_entity->second[receivable_acc] > 0.00)
   if (IDNO == PSay("Please correct the following problem before saving:\n" + entity_names[i_entity->first] + " has both a positive expense balance and a positive receivable balance.\nThis indicates that we both owe (or have paid) money to, and are owed money from, the same entity.\n\nAre you absolutely sure you want this to be the case?", m_confirmation, MB_YESNO))
    return;
 }

 // save this form, go back
 edit_inventory.export_data(params->inventory_data);
 edit_expense.export_data(params->expense_data);
 edit_forward.export_data(params->forward_data);
 edit_revenue.export_data(params->revenue_data);
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonCancelClick(TObject *Sender)
{
 // cancel this form, go back
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonInventoryClick(TObject *Sender)
{
 // switch to inventory tab
 sheetInventory->Show();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonExpenseClick(TObject *Sender)
{
 // switch to expense tab
 sheetExpense->Show();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonForwardClick(TObject *Sender)
{
 // switch to forward tab
 sheetForward->Show();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonRevenueClick(TObject *Sender)
{
 // switch to revenue tab
 sheetRevenue->Show();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonInventoryAddClick(TObject *Sender)
{
 // add inventory item
 listInventory->Selected = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonInventoryRemoveClick(TObject *Sender)
{
 // remove inventory item
 edit_inventory.remove_current_row(true);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonInventorySaveClick(TObject *Sender)
{
 // save inventory item
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonInventorySearchTaxEntityClick(TObject *Sender)
{
 // search inventory tax entity
 FORM_TRY
  vector<string> results;
  TformSearchTaxEntity * search = new TformSearchTaxEntity(NULL, &results);
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   current_inventory_tax_entity_id = results.front();
   CreateLink (staticInventoryTaxEntity, buttonInventorySearchTaxEntity, this, current_inventory_tax_entity_id, "tax_entities", "table.tax_entities", true);
  }
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonInventorySearchItemTypeClick(TObject *Sender)
{
 // search inventory item type
}
//---------------------------------------------------------------------------
void TformSpecialReusableAccountingInsert::InventoryRowSelected()
{
 // inventory item selected
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonExpenseAddClick(TObject *Sender)
{
 // add expense item
 listExpense->Selected = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonExpenseRemoveClick(TObject *Sender)
{
 // remove expense item
 edit_expense.remove_current_row(true);
 RefreshSummary();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonExpenseSaveClick(TObject *Sender)
{
 // save expense item
 if (!IsAmount(editExpensePayable->Text.c_str()))
  {PSay("Payable amount must be valid and positive.", m_invalid_data, MB_OK); return;}
 if (!IsAmount(editExpensePaid->Text.c_str()))
  {PSay("Paid amount must be valid and positive.", m_invalid_data, MB_OK); return;}

 financial amount_payable   = StringToFinancial(editExpensePayable->Text.c_str());
 financial amount_paid      = StringToFinancial(editExpensePaid->Text.c_str());
 financial amount_pay_total = amount_payable + amount_paid;

 if (!params->is_change)
 {
  if (amount_payable < 0.00)
   {PSay("Payable amount must be valid and positive.", m_invalid_data, MB_OK); return;}
  if (amount_paid < 0.00)
   {PSay("Paid amount must be valid and positive.", m_invalid_data, MB_OK); return;}
  if (amount_pay_total < 0.01)
   {PSay("At least one of the payable or paid amounts must be non-zero.", m_invalid_data, MB_OK); return;}
 }

 acc_info about_expense_expense = InfoByMask (editExpenseAccount, false);
 acc_info about_expense_payable = about_expense_expense.EquivAccountInfo(pending_ref);
 acc_info about_expense_cash    = about_expense_expense.EquivAccountInfo(cash_ref);

 map<string, string> row_data;
 row_data["expense_account_id"]   = about_expense_expense.id;
 row_data["payable_account_id"]   = about_expense_payable.id;
 row_data["cash_account_id"]      = about_expense_cash.id;
 row_data["tax_entity_id"]        = current_expense_tax_entity_id;
 row_data["expense_account_name"] = editExpenseAccount->Text.c_str();
 row_data["tax_entity_name"]      = staticExpenseTaxEntity->Caption.c_str();
 row_data["payable_amount"]       = FinancialToString(amount_payable, true);
 row_data["paid_amount"]          = FinancialToString(amount_paid, true);

 if (!about_expense_expense.IsFound() || about_expense_expense.id == "0")
  {PSay("Expense account indicated could not be found.", m_invalid_data, MB_OK); return;}
 if (!about_expense_payable.IsFound() || about_expense_payable.id == "0")
  {PSay("Payable account implied by the expense account could not be found.", m_database_error, MB_OK); return;}
 if (!about_expense_cash.IsFound() || about_expense_cash.id == "0")
  {PSay("Cash account implied by the expense account could not be found.", m_database_error, MB_OK); return;}

 if (!about_expense_expense.Matches(acc_non_budget | acc_yearly | acc_non_yearly | acc_non_closed | acc_expense))
  {PSay("Expense account indicated is of the wrong type.\nIt is either disabled, or not an actual expense account at all.", m_database_error, MB_OK); return;}
 if (!about_expense_payable.Matches(acc_non_budget | acc_yearly | acc_non_yearly | acc_non_closed | acc_payable))
  {PSay("Payable account implied by expense account is of the wrong type.\nIt is either disabled, or not an actual payable account at all.", m_database_error, MB_OK); return;}
 if (!about_expense_cash.Matches(acc_non_budget | acc_yearly | acc_non_yearly | acc_non_closed | acc_cash))
  {PSay("Cash account implied by expense account is of the wrong type.\nIt is either disabled, or not an actual cash account at all.", m_database_error, MB_OK); return;}

 if (row_data["tax_entity_id"] == "0")
  {PSay("No payee (tax entity) provided.", m_invalid_data, MB_OK); return;}

 set<string> dupe_columns;
 dupe_columns.insert("tax_entity_id");
 dupe_columns.insert("expense_account_id");
 if (edit_expense.is_future_duplicate (row_data, dupe_columns))
  {PSay("Saving this row as it is would create a duplicate entry in the list.\nYou may not have two rows with the same account and payee (tax entity.)", m_invalid_data, MB_OK); return;}

 edit_expense.add_or_modify_row_data(row_data, false);
 listExpense->Selected = NULL;

 RefreshSummary();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonExpenseExpandAccountClick(TObject *Sender)
{
 // expand expense account
 FORM_TRY
  string id;
  id = IdByMask (editExpenseAccount, false);
  if (!id.empty())
  {
   map<string, string> params;
   params["id"] = id;
   TformRecordAccount * expand = new TformRecordAccount(NULL, params);
   expand->Show();
  } else
   PSay("Unable to expand account information: account not found.", m_invalid_data, MB_OK);
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonExpenseSearchAccountClick(TObject *Sender)
{
 // search expense account
 FORM_TRY
  vector<string> results;
  TformSearchAccount * search = new TformSearchAccount(NULL, &results);
  search->comboAccountType->Text = "Expense";
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   current_expense_account_id = results.front();
   MaskById (editExpenseAccount, current_expense_account_id);
  }
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonExpenseSearchTaxEntityClick(TObject *Sender)
{
 // search expense tax entity
 FORM_TRY
  vector<string> results;
  TformSearchTaxEntity * search = new TformSearchTaxEntity(NULL, &results);
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   current_expense_tax_entity_id = results.front();
   CreateLink (staticExpenseTaxEntity, buttonExpenseSearchTaxEntity, this, current_expense_tax_entity_id, "tax_entities", "table.tax_entities", false);
  }
 FORM_CATCH
}
//---------------------------------------------------------------------------
void TformSpecialReusableAccountingInsert::ExpenseRowSelected()
{
 // expense item selected
 // row selected: fill in the data fields for editing
 map<string, string> row_data;
 if (!edit_expense.get_current_row(row_data))
 {
  // set default values
  row_data["expense_account_id"]   = "0";
  row_data["payable_account_id"]   = "0";
  row_data["cash_account_id"]      = "0";
  row_data["tax_entity_id"]        = params->default_expense_tax_entity_id;
  row_data["expense_account_name"] = "none";
  row_data["tax_entity_name"]      = "none";
  row_data["payable_amount"]       = "0.00";
  row_data["paid_amount"]          = "0.00";
 }
 // update controls to reflect data in row_data
 current_expense_tax_entity_id = row_data["tax_entity_id"];
 current_expense_account_id    = row_data["expense_account_id"];

 MaskById (editExpenseAccount, current_expense_account_id);
 CreateLink(staticExpenseTaxEntity, buttonExpenseSearchTaxEntity, this, row_data["tax_entity_id"], "tax_entities", "table.tax_entities", false);
 editExpensePayable->Text = StringToAmount(row_data["payable_amount"]).c_str();
 editExpensePaid->Text    = StringToAmount(row_data["paid_amount"]).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonForwardAddClick(TObject *Sender)
{
 // add forward item
 listForward->Selected = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonForwardRemoveClick(TObject *Sender)
{
 // remove forward item
 edit_forward.remove_current_row(true);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonForwardSaveClick(TObject *Sender)
{
 // save forward item
 if (!IsAmount(editForwardReceivable->Text.c_str()))
  {PSay("Receivable amount must be valid and positive.", m_invalid_data, MB_OK); return;}
 if (!IsAmount(editForwardReceived->Text.c_str()))
  {PSay("Received amount must be valid and positive.", m_invalid_data, MB_OK); return;}
 if (!IsAmount(editForwardPaid->Text.c_str()))
  {PSay("Paid amount must be valid and positive.", m_invalid_data, MB_OK); return;}

 financial amount_receivable = StringToFinancial(editForwardReceivable->Text.c_str());
 financial amount_received   = StringToFinancial(editForwardReceived->Text.c_str());
 financial amount_rec_total  = (amount_receivable + amount_received);
 financial amount_paid       = StringToFinancial(editForwardPaid->Text.c_str());
 financial amount_payable    = amount_rec_total - amount_paid;

 if (!params->is_change)
 {
  if (amount_receivable < 0.00)
   {PSay("Receivable amount must be valid and positive.", m_invalid_data, MB_OK); return;}
  if (amount_received < 0.00)
   {PSay("Received amount must be valid and positive.", m_invalid_data, MB_OK); return;}
  if (amount_paid < 0.00)
   {PSay("Paid amount must be valid and positive.", m_invalid_data, MB_OK); return;}
  if (amount_rec_total < 0.01)
   {PSay("At least one of the receivable or received amounts must be non-zero.", m_invalid_data, MB_OK); return;}
  if (amount_payable < 0.00)
   {PSay("You may not have paid more than the receivable and received amounts combined.", m_invalid_data, MB_OK); return;}
 }
 
 acc_info about_forward_receivable = InfoByMask (editForwardAccount, false);
 acc_info about_forward_payable    = about_forward_receivable.EquivAccountInfo(repay_ref);
 acc_info about_forward_cash       = about_forward_receivable.EquivAccountInfo(cash_ref);

 map<string, string> row_data;
 row_data["receivable_account_id"]   = about_forward_receivable.id;
 row_data["payable_account_id"]      = about_forward_payable.id;
 row_data["cash_account_id"]         = about_forward_cash.id;
 row_data["tax_entity_id_from"]      = current_forward_tax_entity_id_from;
 row_data["tax_entity_id_to"]        = current_forward_tax_entity_id_to;
 row_data["receivable_account_name"] = editForwardAccount->Text.c_str();
 row_data["tax_entity_name_from"]    = staticForwardTaxEntityFrom->Caption.c_str();
 row_data["tax_entity_name_to"]      = staticForwardTaxEntityTo->Caption.c_str();
 row_data["receivable_amount"]       = FinancialToString(amount_receivable, true);
 row_data["received_amount"]         = FinancialToString(amount_received, true);
 row_data["payable_amount"]          = FinancialToString(amount_payable, true);
 row_data["paid_amount"]             = FinancialToString(amount_paid, true);

 if (!about_forward_receivable.IsFound() || about_forward_receivable.id == "0")
  {PSay("Receivable account indicated could not be found.", m_invalid_data, MB_OK); return;}
 if (!about_forward_payable.IsFound() || about_forward_payable.id == "0")
  {PSay("Payable account implied by the receivable account could not be found.", m_database_error, MB_OK); return;}
 if (!about_forward_cash.IsFound() || about_forward_cash.id == "0")
  {PSay("Cash account implied by the receivable account could not be found.", m_database_error, MB_OK); return;}

 if (!about_forward_receivable.Matches(acc_non_budget | acc_yearly | acc_non_yearly | acc_non_closed | acc_receivable))
  {PSay("Receivable account indicated is of the wrong type.\nIt is either disabled, or not an actual receivable account at all.", m_database_error, MB_OK); return;}
 if (!about_forward_payable.Matches(acc_non_budget | acc_yearly | acc_non_yearly | acc_non_closed | acc_payable))
  {PSay("Payable account implied by receivable account is of the wrong type.\nIt is either disabled, or not an actual payable account at all.", m_database_error, MB_OK); return;}
 if (!about_forward_cash.Matches(acc_non_budget | acc_yearly | acc_non_yearly | acc_non_closed | acc_cash))
  {PSay("Cash account implied by receivable account is of the wrong type.\nIt is either disabled, or not an actual cash account at all.", m_database_error, MB_OK); return;}

 if (row_data["tax_entity_id_from"] == "0")
  {PSay("No payor (tax entity) provided.", m_invalid_data, MB_OK); return;}
 if (row_data["tax_entity_id_to"] == "0")
  {PSay("No payee (tax entity) provided.", m_invalid_data, MB_OK); return;}

 set<string> dupe_columns;
 dupe_columns.insert("tax_entity_id_from");
 dupe_columns.insert("tax_entity_id_to");
 dupe_columns.insert("receivable_account_id");
 if (edit_forward.is_future_duplicate (row_data, dupe_columns))
  {PSay("Saving this row as it is would create a duplicate entry in the list.\nYou may not have two rows with the same account, payor (tax entity,) and payee (tax entity.)", m_invalid_data, MB_OK); return;}

 edit_forward.add_or_modify_row_data(row_data, false);
 listForward->Selected = NULL;

 RefreshSummary();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonForwardSearchTaxEntityFromClick(TObject *Sender)
{
 // search forward tax entity (from)
 FORM_TRY
  vector<string> results;
  TformSearchTaxEntity * search = new TformSearchTaxEntity(NULL, &results);
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   current_forward_tax_entity_id_from = results.front();
   CreateLink (staticForwardTaxEntityFrom, buttonForwardSearchTaxEntityFrom, this, current_forward_tax_entity_id_from, "tax_entities", "table.tax_entities", true);
  }
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonForwardExpandAccountClick(TObject *Sender)
{
 // expand forward account
 FORM_TRY
  string id;
  id = IdByMask (editForwardAccount, false);
  if (!id.empty())
  {
   map<string, string> params;
   params["id"] = id;
   TformRecordAccount * expand = new TformRecordAccount(NULL, params);
   expand->Show();
  } else
   PSay("Unable to expand account information: account not found.", m_invalid_data, MB_OK);
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonForwardSearchAccountClick(TObject *Sender)
{
 // search forward account
 FORM_TRY
  vector<string> results;
  TformSearchAccount * search = new TformSearchAccount(NULL, &results);
  search->comboAccountType->Text = "Receivable";
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   current_forward_account_id = results.front();
   MaskById (editForwardAccount, current_forward_account_id);
  }
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonForwardSearchTaxEntityToClick(TObject *Sender)
{
 // search forward tax entity (to)
 FORM_TRY
  vector<string> results;
  TformSearchTaxEntity * search = new TformSearchTaxEntity(NULL, &results);
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   current_forward_tax_entity_id_to = results.front();
   CreateLink (staticForwardTaxEntityTo, buttonForwardSearchTaxEntityTo, this, current_forward_tax_entity_id_to, "tax_entities", "table.tax_entities", false);
  }
 FORM_CATCH
}
//---------------------------------------------------------------------------
void TformSpecialReusableAccountingInsert::ForwardRowSelected()
{
 // forward item selected
 // row selected: fill in the data fields for editing
 map<string, string> row_data;
 if (!edit_forward.get_current_row(row_data))
 {
  // set default values
  row_data["receivable_account_id"]   = "0";
  row_data["payable_account_id"]      = "0";
  row_data["cash_account_id"]         = "0";
  row_data["tax_entity_id_from"]      = params->default_forward_tax_entity_id_from;
  row_data["tax_entity_id_to"]        = params->default_forward_tax_entity_id_to;
  row_data["receivable_account_name"] = "none";
  row_data["tax_entity_name_from"]    = "none";
  row_data["tax_entity_name_to"]      = "none";
  row_data["receivable_amount"]       = "0.00";
  row_data["received_amount"]         = "0.00";
  row_data["payable_amount"]          = "0.00";
  row_data["paid_amount"]             = "0.00";
 }
 // update controls to reflect data in row_data
 current_forward_tax_entity_id_from = row_data["tax_entity_id_from"];
 current_forward_tax_entity_id_to   = row_data["tax_entity_id_to"];
 current_forward_account_id         = row_data["receivable_account_id"];

 MaskById (editForwardAccount, current_forward_account_id);
 CreateLink(staticForwardTaxEntityFrom, buttonForwardSearchTaxEntityFrom, this, row_data["tax_entity_id_from"], "tax_entities", "table.tax_entities", true);
 CreateLink(staticForwardTaxEntityTo, buttonForwardSearchTaxEntityTo, this, row_data["tax_entity_id_to"], "tax_entities", "table.tax_entities", false);
 editForwardReceivable->Text = row_data["receivable_amount"].c_str();
 editForwardReceived->Text   = row_data["received_amount"].c_str();
 editForwardPaid->Text       = row_data["paid_amount"].c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonRevenueAddClick(TObject *Sender)
{
 // add revenue item
 listRevenue->Selected = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonRevenueRemoveClick(TObject *Sender)
{
 // remove revenue item
 edit_revenue.remove_current_row(true);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonRevenueSaveClick(TObject *Sender)
{
 // save revenue item
 if (!IsAmount(editRevenueReceivable->Text.c_str()))
  {PSay("Receivable amount must be valid and positive.", m_invalid_data, MB_OK); return;}
 if (!IsAmount(editRevenueReceived->Text.c_str()))
  {PSay("Received amount must be valid and positive.", m_invalid_data, MB_OK); return;}

 financial amount_receivable = StringToFinancial(editRevenueReceivable->Text.c_str());
 financial amount_received   = StringToFinancial(editRevenueReceived->Text.c_str());
 financial amount_rec_total  = amount_receivable + amount_received;

 if (!params->is_change)
 {
  if (amount_receivable < 0.00)
   {PSay("Receivable amount must be valid and positive.", m_invalid_data, MB_OK); return;}
  if (amount_received < 0.00)
   {PSay("Received amount must be valid and positive.", m_invalid_data, MB_OK); return;}
  if (amount_rec_total < 0.01)
   {PSay("At least one of the receivable or received amounts must be non-zero.", m_invalid_data, MB_OK); return;}
 }

 current_revenue_account_id = IdByMask (editRevenueAccount, false);
 acc_info about_revenue_revenue    = InfoByMask (editRevenueAccount, false);
 acc_info about_revenue_receivable = about_revenue_revenue.EquivAccountInfo(pending_ref);
 acc_info about_revenue_cash       = about_revenue_revenue.EquivAccountInfo(cash_ref);

 map<string, string> row_data;
 row_data["revenue_account_id"]    = about_revenue_revenue.id;
 row_data["receivable_account_id"] = about_revenue_receivable.id;
 row_data["cash_account_id"]       = about_revenue_cash.id;
 row_data["tax_entity_id"]         = current_revenue_tax_entity_id;
 row_data["revenue_account_name"]  = editRevenueAccount->Text.c_str();
 row_data["tax_entity_name"]       = staticRevenueTaxEntity->Caption.c_str();
 row_data["receivable_amount"]     = FinancialToString(amount_receivable, true);
 row_data["received_amount"]       = FinancialToString(amount_received, true);

 if (!about_revenue_revenue.IsFound() || about_revenue_revenue.id == "0")
  {PSay("Revenue account indicated could not be found.", m_invalid_data, MB_OK); return;}
 if (!about_revenue_receivable.IsFound() || about_revenue_receivable.id == "0")
  {PSay("Receivable account implied by the revenue account could not be found.", m_database_error, MB_OK); return;}
 if (!about_revenue_cash.IsFound() || about_revenue_cash.id == "0")
  {PSay("Cash account implied by the revenue account could not be found.", m_database_error, MB_OK); return;}

 if (!about_revenue_revenue.Matches(acc_non_budget | acc_yearly | acc_non_yearly | acc_non_closed | acc_revenue))
  {PSay("Revenue account indicated is of the wrong type.\nIt is either disabled, or not an actual revenue account at all.", m_database_error, MB_OK); return;}
 if (!about_revenue_receivable.Matches(acc_non_budget | acc_yearly | acc_non_yearly | acc_non_closed | acc_receivable))
  {PSay("Receivable account implied by revenue account is of the wrong type.\nIt is either disabled, or not an actual receivable account at all.", m_database_error, MB_OK); return;}
 if (!about_revenue_cash.Matches(acc_non_budget | acc_yearly | acc_non_yearly | acc_non_closed | acc_cash))
  {PSay("Cash account implied by revenue account is of the wrong type.\nIt is either disabled, or not an actual cash account at all.", m_database_error, MB_OK); return;}

 if (row_data["tax_entity_id"] == "0")
  {PSay("No payor (tax entity) provided.", m_invalid_data, MB_OK); return;}

 set<string> dupe_columns;
 dupe_columns.insert("tax_entity_id");
 dupe_columns.insert("revenue_account_id");
 if (edit_revenue.is_future_duplicate (row_data, dupe_columns))
  {PSay("Saving this row as it is would create a duplicate entry in the list.\nYou may not have two rows with the same account and payee (tax entity.)", m_invalid_data, MB_OK); return;}

 edit_revenue.add_or_modify_row_data(row_data, false);
 listRevenue->Selected = NULL;

 RefreshSummary();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonRevenueSearchTaxEntityClick(TObject *Sender)
{
 // search revenue tax entity
 FORM_TRY
  vector<string> results;
  TformSearchTaxEntity * search = new TformSearchTaxEntity(NULL, &results);
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   current_revenue_tax_entity_id = results.front();
   CreateLink (staticRevenueTaxEntity, buttonRevenueSearchTaxEntity, this, current_revenue_tax_entity_id, "tax_entities", "table.tax_entities", true);
  }
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonRevenueExpandAccountClick(TObject *Sender)
{
 // expand revenue account
 FORM_TRY
  string id;
  id = IdByMask (editRevenueAccount, false);
  if (!id.empty())
  {
   map<string, string> params;
   params["id"] = id;
   TformRecordAccount * expand = new TformRecordAccount(NULL, params);
   expand->Show();
  } else
   PSay("Unable to expand account information: account not found.", m_invalid_data, MB_OK);
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonRevenueSearchAccountClick(TObject *Sender)
{
 // search revenue account
 FORM_TRY
  vector<string> results;
  TformSearchAccount * search = new TformSearchAccount(NULL, &results);
  search->comboAccountType->Text = "Revenue";
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   current_revenue_account_id = results.front();
   MaskById (editRevenueAccount, current_revenue_account_id);
  }
 FORM_CATCH
}
//---------------------------------------------------------------------------
void TformSpecialReusableAccountingInsert::RevenueRowSelected()
{
 // revenue item selected
 // row selected: fill in the data fields for editing
 map<string, string> row_data;
 if (!edit_revenue.get_current_row(row_data))
 {
  // set default values
  row_data["revenue_account_id"]    = "0";
  row_data["receivable_account_id"] = "0";
  row_data["cash_account_id"]       = "0";
  row_data["tax_entity_id"]         = params->default_expense_tax_entity_id;
  row_data["revenue_account_name"]  = "none";
  row_data["tax_entity_name"]       = "none";
  row_data["receivable_amount"]     = "0.00";
  row_data["received_amount"]       = "0.00";
 }
 // update controls to reflect data in row_data
 current_revenue_tax_entity_id = row_data["tax_entity_id"];
 current_revenue_account_id    = row_data["revenue_account_id"];

 MaskById (editRevenueAccount, current_revenue_account_id);
 CreateLink(staticRevenueTaxEntity, buttonRevenueSearchTaxEntity, this, row_data["tax_entity_id"], "tax_entities", "table.tax_entities", true);
 editRevenueReceivable->Text  = row_data["receivable_amount"].c_str();
 editRevenueReceived->Text    = row_data["received_amount"].c_str();
}
//---------------------------------------------------------------------------
void TformSpecialReusableAccountingInsert::RefreshSummary()
{
 // temp objects for adding
 reusable_accounting_insert_parameters temp = (*params);
 edit_expense.export_data(temp.expense_data);
 edit_forward.export_data(temp.forward_data);
 edit_revenue.export_data(temp.revenue_data);
 financial_adder adding_machine;

 // new data
 financial expense_payable    = (get_vec_map_column_sum(temp.expense_data, "payable_amount", adding_machine.reset())).local_sum;
 financial expense_paid       = (get_vec_map_column_sum(temp.expense_data, "paid_amount", adding_machine.reset())).local_sum;
 financial forward_receivable = (get_vec_map_column_sum(temp.forward_data, "receivable_amount", adding_machine.reset())).local_sum;
 financial forward_received   = (get_vec_map_column_sum(temp.forward_data, "received_amount", adding_machine.reset())).local_sum;
 financial forward_payable    = (get_vec_map_column_sum(temp.forward_data, "payable_amount", adding_machine.reset())).local_sum;
 financial forward_paid       = (get_vec_map_column_sum(temp.forward_data, "paid_amount", adding_machine.reset())).local_sum;
 financial revenue_receivable = (get_vec_map_column_sum(temp.revenue_data, "receivable_amount", adding_machine.reset())).local_sum;
 financial revenue_received   = (get_vec_map_column_sum(temp.revenue_data, "received_amount", adding_machine.reset())).local_sum;

 // before (detail)
 // vector<map<string, string> > before_data;
 before_data = temp.GetOldPreviewTransactions();
 // edit_before.clear_data();
 // edit_before.import_data(before_data);
 checkBeforeClick(NULL);

 // change (detail)
 // vector<map<string, string> > change_data;
 change_data  = temp.GetNewPreviewTransactions();
 // edit_change.clear_data();
 // edit_change.import_data(change_data);
 checkChangeClick(NULL);

 // after (detail)
 // vector<map<string, string> > after_data;
 after_data  = temp.GetAllPreviewTransactions();
 // edit_after.clear_data();
 // edit_after.import_data(after_data);
 checkAfterClick(NULL);

 // budgets (detail)
 map<string, acc_info> about_accounts;
 map<string, financial> original_budgets;
 map<string, financial> old_expenses;
 map<string, financial> new_expenses;
 acc_info about_budget;
 string account_id;
 vector<map<string, string> > budget_data;
 map<string, string> budget_row;

 for (vector<map<string, string> >::iterator i_changes = change_data.begin(); i_changes != change_data.end(); i_changes++)
 {
  account_id = (*i_changes)["account_id"];
  // first time we've come across this account? off we go ... getting stuff!
  if (about_accounts.find(account_id) == about_accounts.end())
   about_accounts[account_id] = InfoById(account_id);

  if (about_accounts[account_id].IsType(expense_acc))
  {
   if (new_expenses.find(account_id) == new_expenses.end())
   {
    about_budget = about_accounts[account_id].EquivAccountInfo(budget_ref);
    new_expenses[account_id] = 0.00;
    old_expenses[account_id] = about_accounts[account_id].GetCurrentBalance();
    original_budgets[account_id] = about_budget.GetCurrentBalance();
   }
   new_expenses[account_id] += StringToFinancial((*i_changes)["change_amount"]);
  }

 }

 for(map<string, financial>::iterator i_acc = original_budgets.begin(); i_acc != original_budgets.end(); i_acc++)
 {
  budget_row["account_id"]      = i_acc->first;
  budget_row["account_name"]    = about_accounts[i_acc->first].GetTextName();
  budget_row["original_budget"] = FinancialToString(i_acc->second, true);
  budget_row["old_expenses"]    = FinancialToString(old_expenses[i_acc->first], true);
  budget_row["old_budget"]      = FinancialToString(i_acc->second - old_expenses[i_acc->first], true);
  budget_row["new_expenses"]    = FinancialToString(new_expenses[i_acc->first], true);
  budget_row["new_budget"]      = FinancialToString(i_acc->second - (old_expenses[i_acc->first] + new_expenses[i_acc->first]), true);
  budget_data.push_back(budget_row);
 }

 edit_budget.clear_data();
 edit_budget.import_data(budget_data);

 financial temp_old_expense    = 0.00;
 financial temp_old_payable    = 0.00;
 financial temp_old_paid       = 0.00;
 financial temp_old_revenue    = 0.00;
 financial temp_old_receivable = 0.00;
 financial temp_old_received   = 0.00;

 financial temp_value;
 account_types temp_type;
 string temp_entity;
 for (vector<map<string, string> >::iterator i_old = before_data.begin(); i_old != before_data.end(); i_old++)
 {
  temp_entity = (*i_old)["tax_entity_id"];
  temp_value  = StringToFinancial((*i_old)["change_amount"]);
  temp_type   = StringToAccountType((*i_old)["account_type"]);
  switch (temp_type)
  {
   case expense_acc: temp_old_expense += temp_value; break;
   case payable_acc: temp_old_payable += temp_value; break;
   case revenue_acc: temp_old_revenue += temp_value; break;
   case receivable_acc: temp_old_receivable += temp_value; break;
   case cash_acc:
    // we'll just assume that if it's positive cash, then, uh, we 'received' it ... yeah ...
    // that's even if it's a mistake being corrected (which should reduce 'paid')
    // otherwise we'd have to match it up with the tax entities, and try to guess.
    // yes, we can look at the list of people in the 'revenue' section, but ...
    // what if the same tax entity is in multiple places? say, forward -and- revenue ...
    // or better yet, somehow we pay to ourselves or receive from ourselves? yuck.
    // so no, it's not perfectly accurate.
    if (temp_value > 0)
     temp_old_received += temp_value;
    else
     temp_old_paid -= temp_value; // it's negative, so we subtract it to add a positive amount =) it works. trust me.
    break;
   default: /* ignore */ break;
  }
 }

 // text summaries
 chg_expense = expense_payable + expense_paid;
 chg_expense_payable = expense_payable;
 chg_expense_paid = expense_paid;
 chg_forward = forward_receivable + forward_received;
 chg_forward_payable = forward_payable;
 chg_forward_paid = forward_paid;
 chg_forward_receivable = forward_receivable;
 chg_forward_received = forward_received;
 chg_revenue = revenue_receivable + revenue_received;
 chg_revenue_receivable = revenue_receivable;
 chg_revenue_received = revenue_received;

 total_expense    = chg_expense + temp_old_expense;
 total_payable    = chg_expense_payable + chg_forward_payable + temp_old_payable;
 total_paid       = chg_expense_paid + chg_forward_paid + temp_old_paid;
 total_revenue    = chg_revenue + temp_old_revenue;
 total_receivable = chg_revenue_receivable + chg_forward_receivable + temp_old_receivable;
 total_received   = chg_revenue_received + chg_forward_received + temp_old_received;
 total_payment    = total_payable + total_paid;

 treeSummary->Repaint();
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::FormClose(TObject *Sender, TCloseAction &Action)
{
 Action = caFree;
 TformSpecialGeneric::FormClose(Sender, Action);
 if (Action == caFree)
 {
  edit_inventory.setup_listview(NULL, false);
  edit_expense.setup_listview(NULL, false);
  edit_forward.setup_listview(NULL, false);
  edit_revenue.setup_listview(NULL, false);
  edit_before.setup_listview(NULL, false);
  edit_change.setup_listview(NULL, false);
  edit_after.setup_listview(NULL, false);
  edit_budget.setup_listview(NULL, false);
 }
}
//---------------------------------------------------------------------------
void reusable_accounting_insert_parameters::AddFinancial (map<string, map<string, financial> > & data, string a, string b, financial c)
{
 map<string, map<string, financial> >::iterator i_a;
 map<string, financial>::iterator i_b;

 i_a = data.find(a);
 if (i_a != data.end())
 {
  i_b = i_a->second.find(b);
  if (i_b != i_a->second.end())
   i_b->second += c;
  else
   i_a->second[b] = c;
 } else
  data[a][b] = c;
 return;
}
//---------------------------------------------------------------------------
void reusable_accounting_insert_parameters::SubFinancial (map<string, map<string, financial> > & data, string a, string b, financial c)
{
 map<string, map<string, financial> >::iterator i_a;
 map<string, financial>::iterator i_b;

 i_a = data.find(a);
 if (i_a != data.end())
 {
  i_b = i_a->second.find(b);
  if (i_b != i_a->second.end())
   i_b->second -= c;
  else
   i_a->second[b] = -c;
 } else
  data[a][b] = -c;
 return;
}
//---------------------------------------------------------------------------
void reusable_accounting_insert_parameters::ImportOldTransactions(vector<map<string, string> > & prior_data)
{
 vector<map<string, string> >::iterator i;
 map<string, string> temp_row;
 prior_transactions.clear();
 map<string, acc_info> about_accounts;
 string entity_id;
 string account_id;
 financial debit_amount;
 financial credit_amount;
 financial change_amount;

 for (i = prior_data.begin(); i != prior_data.end(); i++)
 {
  entity_id     = (*i)["tax_entity_id"];
  account_id    = (*i)["account_id"];

  if (about_accounts.find(account_id) == about_accounts.end())
   about_accounts[account_id] = InfoById(account_id);

  debit_amount  = StringToFinancial((*i)["debit_amount"]);
  credit_amount = StringToFinancial((*i)["credit_amount"]);
  change_amount = debit_amount - credit_amount;

  if (about_accounts[account_id].IsDebitPositive())
   AddFinancial(prior_transactions, account_id, entity_id, change_amount);
  else
   SubFinancial(prior_transactions, account_id, entity_id, change_amount);

  /* TODO -- this is where expense_data, forward_data, and revenue_data -might- wind up with extra data.
     however, we'd still have to decide -what- to put in each:
     - easy to put all expense accounts into expense_data, with appropriate references, tax_id, and 0.00 amounts
     - easy to do the same with revenue
     - not so easy to do so with receivables -- those same receivables could have come from revenue ... oops?
     so we'd wind up with blank rows in forward_data that are created by the use of the revenue section.
     that could be bad. must investigate what the users would like best. */
 }
}
//---------------------------------------------------------------------------
map<string, map<string, financial> > reusable_accounting_insert_parameters::GetNewRawTransactions ()
{
 map<string, map<string, financial> > account_entity_amount;
 map<string, map<string, financial> >::iterator i_account;
 vector<map<string, string> >::iterator i;

 for (i = expense_data.begin(); i != expense_data.end(); i++)
 {
  // expense
  AddFinancial (account_entity_amount, (*i)["expense_account_id"], (*i)["tax_entity_id"], StringToFinancial((*i)["payable_amount"]) + StringToFinancial((*i)["paid_amount"]));
  // payable
  AddFinancial (account_entity_amount, (*i)["payable_account_id"], (*i)["tax_entity_id"], StringToFinancial((*i)["payable_amount"]));
  // cash
  SubFinancial (account_entity_amount, (*i)["cash_account_id"], (*i)["tax_entity_id"], StringToFinancial((*i)["paid_amount"]));
 }

 for (i = forward_data.begin(); i != forward_data.end(); i++)
 {
  // receivable
  AddFinancial (account_entity_amount, (*i)["receivable_account_id"], (*i)["tax_entity_id_from"], StringToFinancial((*i)["receivable_amount"]));
  // received
  AddFinancial (account_entity_amount, (*i)["cash_account_id"], (*i)["tax_entity_id_from"], StringToFinancial((*i)["received_amount"]));
  // payable
  AddFinancial (account_entity_amount, (*i)["payable_account_id"], (*i)["tax_entity_id_to"], StringToFinancial((*i)["payable_amount"]));
  // paid
  SubFinancial (account_entity_amount, (*i)["cash_account_id"], (*i)["tax_entity_id_to"], StringToFinancial((*i)["paid_amount"]));
 }

 for (i = revenue_data.begin(); i != revenue_data.end(); i++)
 {
  // revenue
  AddFinancial (account_entity_amount, (*i)["revenue_account_id"], (*i)["tax_entity_id"], StringToFinancial((*i)["receivable_amount"]) + StringToFinancial((*i)["received_amount"]));
  // receivable
  AddFinancial (account_entity_amount, (*i)["receivable_account_id"], (*i)["tax_entity_id"], StringToFinancial((*i)["receivable_amount"]));
  // cash
  AddFinancial (account_entity_amount, (*i)["cash_account_id"], (*i)["tax_entity_id"], StringToFinancial((*i)["received_amount"]));
 }
 return account_entity_amount;
}
//---------------------------------------------------------------------------
map<string, map<string, financial> > reusable_accounting_insert_parameters::GetOldRawTransactions ()
{
 return prior_transactions;
}
//---------------------------------------------------------------------------
map<string, map<string, financial> > reusable_accounting_insert_parameters::GetAllRawTransactions ()
{
 map<string, map<string, financial> > old_stuff, new_stuff, all_stuff;
 map<string, map<string, financial> >::iterator i_a;
 map<string, financial>::iterator i_b;

 old_stuff = GetOldRawTransactions();
 new_stuff = GetNewRawTransactions();
 all_stuff = old_stuff;

 for (i_a = new_stuff.begin(); i_a != new_stuff.end(); i_a++)
  for (i_b = i_a->second.begin(); i_b != i_a->second.end(); i_b++)
   AddFinancial (all_stuff, i_a->first, i_b->first, i_b->second);

 return all_stuff;
}
//---------------------------------------------------------------------------
vector<map<string, string> > reusable_accounting_insert_parameters::GetFinalTransactions (map<string, string> default_row, map<string, map<string, financial> > change_data)
{
 map<string, string> temp_row;
 vector<map<string, string> > answer;
 map<string, map<string, financial> >::iterator i_account;
 map<string, financial>::iterator i_entity;
 acc_info about_account;
 bool is_debit_positive;

 // put default values in for the calling function -- things like dates, bills, tasks, etc.
 // move amounts to the correct debit/credit column, etc.
 for (i_account = change_data.begin(); i_account != change_data.end(); i_account++)
 {
  about_account = InfoById(i_account->first);
  is_debit_positive = about_account.IsDebitPositive();

  for (i_entity = i_account->second.begin(); i_entity != i_account->second.end(); i_entity++)
  {
   if (i_entity->second != 0.00)
   {
    temp_row = default_row;
    temp_row["account_id"] = i_account->first;
    temp_row["tax_entity_id"] = i_entity->first;
    // i'm sure there was a way of being more clever with the following, but ... bah humbug.
    if (i_entity->second > 0.00)
    {
     temp_row[is_debit_positive ? "debit_amount" : "credit_amount"] = FinancialToString(i_entity->second);
     temp_row[is_debit_positive ? "credit_amount" : "debit_amount"] = "0.00";
    } else
    {
     temp_row[is_debit_positive ? "credit_amount" : "debit_amount"] = FinancialToString(i_entity->second * -1.00);
     temp_row[is_debit_positive ? "debit_amount" : "credit_amount"] = "0.00";
    }
    answer.push_back(temp_row);
   }
  }
 }

 return answer;
}
//---------------------------------------------------------------------------
vector<map<string, string> > reusable_accounting_insert_parameters::GetNewFinalTransactions (map<string, string> default_row)
{
 return GetFinalTransactions(default_row, GetNewRawTransactions());
}
//---------------------------------------------------------------------------
vector<map<string, string> > reusable_accounting_insert_parameters::GetOldFinalTransactions (map<string, string> default_row)
{
 return GetFinalTransactions(default_row, GetOldRawTransactions());
}
//---------------------------------------------------------------------------
vector<map<string, string> > reusable_accounting_insert_parameters::GetAllFinalTransactions (map<string, string> default_row)
{
 return GetFinalTransactions(default_row, GetAllRawTransactions());
}
//---------------------------------------------------------------------------
vector<map<string, string> > reusable_accounting_insert_parameters::GetPreviewTransactions (map<string, map<string, financial> > change_data)
{
 map<string, string> temp_row;
 vector<map<string, string> > answer;
 map<string, map<string, financial> >::iterator i_account;
 map<string, financial>::iterator i_entity;
 acc_info about_account;

 // put default values in for the calling function -- things like dates, bills, tasks, etc.
 // move amounts to the correct debit/credit column, etc.
 for (i_account = change_data.begin(); i_account != change_data.end(); i_account++)
 {
  about_account = InfoById(i_account->first);

  for (i_entity = i_account->second.begin(); i_entity != i_account->second.end(); i_entity++)
  {
   // in a lot of cases, it just looks better to list zero-amounts. people get less confused about empty lists.
   // if (i_entity->second != 0.00)
   {
    temp_row.clear();
    temp_row["account_id"]      = i_account->first;
    temp_row["account_name"]    = about_account.GetTextName();
    temp_row["account_type"]    = AccountTypeToString(about_account.GetType());
    temp_row["tax_entity_id"]   = i_entity->first;
    temp_row["tax_entity_name"] = GetOneField(dbDatabase, "select tax_entities.name from tax_entities where tax_entities.id = " + i_entity->first);
    temp_row["change_amount"]   = FinancialToString(i_entity->second);
    answer.push_back(temp_row);
   }
  }
 }

 return answer;
}
//---------------------------------------------------------------------------
vector<map<string, string> > reusable_accounting_insert_parameters::GetNewPreviewTransactions ()
{
 return GetPreviewTransactions(GetNewRawTransactions());
}
//---------------------------------------------------------------------------
vector<map<string, string> > reusable_accounting_insert_parameters::GetOldPreviewTransactions ()
{
 return GetPreviewTransactions(GetOldRawTransactions());
}
//---------------------------------------------------------------------------
vector<map<string, string> > reusable_accounting_insert_parameters::GetAllPreviewTransactions ()
{
 return GetPreviewTransactions(GetAllRawTransactions());
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonInventoryClearClick(TObject *Sender)
{
 // clear inventory
 edit_inventory.clear_data();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonExpenseClearClick(TObject *Sender)
{
 // clear expenses
 edit_expense.clear_data();
 RefreshSummary();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonForwardClearClick(TObject *Sender)
{
 // clear forwarding
 edit_forward.clear_data();
 RefreshSummary();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonRevenueClearClick(TObject *Sender)
{
 // clear revenue
 edit_revenue.clear_data();
 RefreshSummary();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::buttonResultClick(TObject *Sender)
{
 sheetResult->Show();
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialReusableAccountingInsert::treeSummaryExpanded(
      TObject *Sender, TTreeNode *Node)
{
 // expand and collapse: tries to only redraw as necessary, but because of scrollbar, all needs redrawing
 treeSummary->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::treeSummaryCollapsed(TObject *Sender, TTreeNode *Node)
{
 // expand and collapse: tries to only redraw as necessary, but because of scrollbar, all needs redrawing
 treeSummary->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::treeSummaryAdvancedCustomDrawItem(
      TCustomTreeView *Sender, TTreeNode *Node, TCustomDrawState State,
      TCustomDrawStage Stage, bool &PaintImages, bool &DefaultDraw)
{
 // draw the amount to the right!

 if (Stage == cdPostPaint)
 {
  TRect whole_row  = Node->DisplayRect(false);
  TRect just_text  = Node->DisplayRect(true);
  TRect text_right = just_text;
  text_right.right = whole_row.right;
  // i had considered filling with blue -inside- the dotted line,
  // but that would require the ability to clear the background first,
  // to make sure the dotted line was yellow on white. only, see below,
  // that wasn't possible for some unknown reason. so ... this is useless too.
  // TRect inner_box  = TRect(text_right.left + 1, text_right.top + 1, text_right.right - 1, text_right.bottom - 1);

  if (State.Contains(cdsSelected))
  {
   // don't try to fill with clWindow first, then clHighlight!
   // that results in the text rendering white on white later,
   // for not apparent reason! i must be mad. but i'm angry anyway.
   // -- philip, middle of the night, april 8th 2003
   Sender->Canvas->Brush->Color = clHighlight;
   Sender->Canvas->FillRect(text_right);
   if (State.Contains(cdsFocused))
    Sender->Canvas->DrawFocusRect(text_right);
  } else
  {
   Sender->Canvas->Brush->Color = clWindow;
   Sender->Canvas->FillRect(text_right);
  }

  string to_be_drawn = "";

  switch (Node->StateIndex)
  {
   case 0: /* change total */break;
   case 1: to_be_drawn = FinancialToString(chg_expense, true); break;
   case 2: to_be_drawn = FinancialToString(chg_expense_payable, true); break;
   case 3: to_be_drawn = FinancialToString(chg_expense_paid, true); break;
   case 4: to_be_drawn = FinancialToString(chg_forward, true); break;
   case 5: to_be_drawn = FinancialToString(chg_forward_payable, true); break;
   case 6: to_be_drawn = FinancialToString(chg_forward_paid, true); break;
   case 7: to_be_drawn = FinancialToString(chg_forward_receivable, true); break;
   case 8: to_be_drawn = FinancialToString(chg_forward_received, true); break;
   case 9: to_be_drawn = FinancialToString(chg_revenue, true); break;
   case 10: to_be_drawn = FinancialToString(chg_revenue_receivable, true); break;
   case 11: to_be_drawn = FinancialToString(chg_revenue_received, true); break;
   case 12: /* total ... total! */ break;
   case 13: to_be_drawn = FinancialToString(total_expense, true); break;
   case 14: to_be_drawn = FinancialToString(total_payable, true); break;
   case 15: to_be_drawn = FinancialToString(total_paid, true); break;
   case 16: to_be_drawn = FinancialToString(total_revenue, true); break;
   case 17: to_be_drawn = FinancialToString(total_receivable, true); break;
   case 18: to_be_drawn = FinancialToString(total_received, true); break;
   case 19: to_be_drawn = FinancialToString(total_payment, true); break;
   case 20: to_be_drawn = FinancialToString(total_target, true); break;
  }

  string node_text = Node->Text.c_str();
  int second_text_width = Sender->Canvas->TextWidth(to_be_drawn.c_str());
  int margin            = (whole_row.Height() - Sender->Canvas->TextHeight(Node->Text)) / 2;
  int second_left       = whole_row.right - second_text_width - margin - (whole_row.Height() / 3);
  int top               = whole_row.top + margin;
  int first_left        = just_text.left + margin;
  int first_text_width  = Sender->Canvas->TextWidth(node_text.c_str());
  int useful_chars      = node_text.length();
  while ((second_left - (first_text_width + first_left) < margin) && !node_text.empty())
  {
   useful_chars--;
   node_text = string(Node->Text.c_str()).substr(0, useful_chars) + "...";
   first_text_width  = Sender->Canvas->TextWidth(node_text.c_str());
  }

  Sender->Canvas->TextOut(first_left, top, node_text.c_str());
  Sender->Canvas->TextOut(second_left, top, to_be_drawn.c_str());
  PaintImages = false;
  DefaultDraw = false;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::FormResize(TObject *Sender)
{
 // if it resizes enough to cause the scrollbar to (dis)appear, then it needs to redraw to stay right-justified
 treeSummary->Repaint();
 TformSpecialGeneric::FormResize(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::FormShortCut(TWMKey &Msg, bool &Handled)
{
  TformSpecialGeneric::FormShortCut(Msg, Handled);
  /*
  if(HIBYTE(GetAsyncKeyState(VK_CONTROL)))
  {
    Handled = true;
    if (((Msg.CharCode == 's') || (Msg.CharCode == 'S')) && buttonSave->Enabled)
      buttonSaveClick(NULL);
    else if (((Msg.CharCode == 'c') || (Msg.CharCode == 'C')) && buttonCancel->Enabled)
      buttonCancelClick(NULL);
    else if (((Msg.CharCode == 'i') || (Msg.CharCode == 'I')) && buttonInventory->Enabled)
    {
      buttonInventory->Down = true;
      buttonInventoryClick(NULL);
    }
    else if (((Msg.CharCode == 'e') || (Msg.CharCode == 'E')) && buttonExpense->Enabled)
    {
      buttonExpense->Down = true;
      buttonExpenseClick(NULL);
    }
    else if (((Msg.CharCode == 'f') || (Msg.CharCode == 'F')) && buttonForward->Enabled)
    {
      buttonForward->Down = true;
      buttonForwardClick(NULL);
    }
    else if (((Msg.CharCode == 'r') || (Msg.CharCode == 'R')) && buttonRevenue->Enabled)
    {
      buttonRevenue->Down = true;
      buttonRevenueClick(NULL);
    }
    else if (((Msg.CharCode == 'd') || (Msg.CharCode == 'D')) && buttonResult->Enabled)
    {
      buttonResult->Down = true;
      buttonResultClick(NULL);
    }
    else
      Handled = false;
  }
  else
    Handled = false;
  TformSpecialGeneric::FormShortCut(Msg, Handled);
  */
}
//---------------------------------------------------------------------------
void reusable_accounting_insert_parameters::SetupTransactionSummaryView (edit_listview & listview_handler, bool show_account_name, bool show_tax_entity_name)
{
 listview_handler.clear_columns();
 if (show_account_name)
 {
  listview_handler.add_or_modify_column("account_name",    "Account",    true,  1, 130, as_text, rawString);
  listview_handler.add_or_modify_column("account_id",      "Account Id", false, 2,  60, as_int, rawString);
 }
 if (show_tax_entity_name)
 {
  listview_handler.add_or_modify_column("tax_entity_name", "Entity",     true,  3, 60 + (show_account_name ? 0 : 80), as_text, prettyString);
  listview_handler.add_or_modify_column("tax_entity_id",   "Entity Id",  false, 4, 60, as_int, rawString);
 }
 // always

 listview_handler.add_or_modify_column("account_type",    "Type",        true,  5, (60 + (show_account_name ? 0 : 50) + (show_tax_entity_name ? 0 : 60) + (!show_account_name && !show_tax_entity_name ? 80 : 0)), as_text, prettyString);
 listview_handler.add_or_modify_column("change_amount",   "Amount",      true,  6, 75, as_double, amountString);
}
//---------------------------------------------------------------------------
void reusable_accounting_insert_parameters::RefreshTransactionSummaryView (edit_listview & listview_handler, bool show_account_name, bool show_tax_entity_name, vector<map<string, string> > & preview_data)
{
 listview_handler.clear_data();
 SetupTransactionSummaryView (listview_handler, show_account_name, show_tax_entity_name);

 vector<map<string, string> > local_data = preview_data;
 vector<map<string, string> > output_data;
 vector<pair<string, cb_sorting_object<string> *> > sorting_methods;
 map<string, cb_aggregate_object<string> *> summing_methods;

 if (show_account_name)
 {
  sorting_methods.push_back(pair<string, cb_sorting_object<string> *>("account_name", new sort_less_than<string>()));
  sorting_methods.push_back(pair<string, cb_sorting_object<string> *>("account_id", new sort_less_than<string>()));
 }
 sorting_methods.push_back(pair<string, cb_sorting_object<string> *>("account_type", new sort_less_than<string>()));
 if (show_tax_entity_name)
 {
  sorting_methods.push_back(pair<string, cb_sorting_object<string> *>("tax_entity_name", new sort_less_than<string>()));
  sorting_methods.push_back(pair<string, cb_sorting_object<string> *>("tax_entity_id", new sort_less_than<string>()));
 }

 summing_methods["change_amount"] = new aggregate_callback_wrapper<string, financial, aggregate_sum<financial> >(StringToFinancial, FinancialToStringEx);

 output_data.reserve(local_data.size());
 do_control_break(local_data, output_data, sorting_methods, summing_methods);

 listview_handler.import_data(output_data);

 // prevent memory leaks
 cb_deallocate_sorting_map(sorting_methods);
 cb_deallocate_aggregate_map(summing_methods);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::checkBeforeClick(TObject *Sender)
{
 reusable_accounting_insert_parameters::RefreshTransactionSummaryView (edit_before, checkBeforeShowAccount->Checked, checkBeforeShowName->Checked, before_data);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::checkChangeClick(TObject *Sender)
{
 reusable_accounting_insert_parameters::RefreshTransactionSummaryView (edit_change, checkChangesShowAccount->Checked, checkChangesShowName->Checked, change_data);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialReusableAccountingInsert::checkAfterClick(TObject *Sender)
{
 reusable_accounting_insert_parameters::RefreshTransactionSummaryView (edit_after, checkAfterShowAccount->Checked, checkAfterShowName->Checked, after_data);
}
//---------------------------------------------------------------------------



