//---------------------------------------------------------------------------
// TODO : Add logging for "all" received messages listview and maybe sent messages as well?
#include <vcl.h>
#pragma hdrstop

#include "codeSpecialRouterAdministration.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma link "codeRubberContainer"
#pragma link "codeSectionsGeneric"
#pragma link "codeSoftDropShadow"
#pragma resource "*.dfm"
TformSpecialRouterAdministration *formSpecialRouterAdministration;

#define keep_only 1000
//---------------------------------------------------------------------------
__fastcall TformSpecialRouterAdministration::TformSpecialRouterAdministration(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  this->IconIndex = 45;
  notification_channel = "server_notifications";
  panelSelectArea->Color = title_bar_color;
  pageMessages->ActivePageIndex = 0;
  comboSelectArea->ItemIndex = 0;
  column_count = 0;
  get_properties = true;
  connections_listview = new edit_listview();
  connections_listview->setup_listview(listConnections, true);

  is_connect_successful = 0;
  sockFormClientSocket->Address = optionsIni["server"]["message_router_ip"].c_str();
  sockFormClientSocket->Port = StringToInt(optionsIni["server"]["message_router_port"]);
  form_message_router = new classTcpipMessaging(sockFormClientSocket);
  sockFormClientSocket->Open();
  while(is_connect_successful == 0)
  {
    Application->HandleMessage();
  }
  if (is_connect_successful == 2)
  {
    PSay("Error connecting to message server", m_program_error, MB_OK);
    timerReconnect->Enabled = true;
  }
  form_message_router->SetValue("computer_name", computer_name);
  form_message_router->SetValue("user_name", PGlobals->current_username);
  form_message_router->SetValue("full_name", current_fullname);
  form_message_router->SetValue("client_type", "router admin");
  form_message_router->SetValue("version_number", PGlobals->current_version);
  form_message_router->SetValue("gds_version", PGlobals->gds_version);

  form_message_router->RequestServerNotification ("notifications", "client_connect");
  form_message_router->RequestServerNotification ("notifications", "client_disconnect");
  form_message_router->RequestServerNotification ("notifications", "set_property");
  form_message_router->RequestServerNotification ("notifications", "unset_property");

  timerGetMessages->Enabled = true;
  timerGetProperties->Enabled = true;
  timerStatus->Enabled = true;

  BuildSendOptionsTree();

  refreshTransaction = new TIBTransaction(NULL);
  StdTransaction(refreshTransaction, dbDatabase);

  filter_atlas_handler["mon"].filter->SetListViewHandle(listMon);
  filter_atlas_handler["mon"].filter->SetTransaction(refreshTransaction);
  filter_atlas_handler["mon"].filter->SetSecurity("");
  filter_atlas_handler["mon"].filter->AddColumnSpec("IP", "", as_text, true, 90);
  filter_atlas_handler["mon"].filter->AddColumnSpec("AttachSt?", "", as_text, true, 40, prettyBoolString);
  filter_atlas_handler["mon"].filter->AddColumnSpec("Login", "", as_stamp, true, 30);
  filter_atlas_handler["mon"].filter->AddColumnSpec("LoggedIn", "", as_int, true, 40);
  filter_atlas_handler["mon"].filter->AddColumnSpec("RemoteProc", "", as_text, true, 45, rawString);
  filter_atlas_handler["mon"].filter->AddColumnSpec("AttachId", "", as_int, false, 40);
  filter_atlas_handler["mon"].filter->AddColumnSpec("TxSt?", "", as_text, true, 40, prettyBoolString);
  filter_atlas_handler["mon"].filter->AddColumnSpec("TxTime", "", as_stamp, true, 30);
  filter_atlas_handler["mon"].filter->AddColumnSpec("TxRunTime", "", as_int, true, 40);
  filter_atlas_handler["mon"].filter->AddColumnSpec("Tx Id", "", as_int, false, 40);
  /* there are a bunch more transaction columns I'm leaving off because they don't seem useful */
  filter_atlas_handler["mon"].filter->AddColumnSpec("StmtSt?", "", as_text, true, 40, prettyBoolString);
  filter_atlas_handler["mon"].filter->AddColumnSpec("StmtTime", "", as_stamp, true, 30);
  filter_atlas_handler["mon"].filter->AddColumnSpec("StmtRunTime", "", as_int, true, 40);
  filter_atlas_handler["mon"].filter->AddColumnSpec("SQL", "", as_text, true, 300);
  filter_atlas_handler["mon"].filter->AddColumnSpec("StmtId", "", as_int, false, 40);
  filter_atlas_handler["mon"].filter->AddColumnSpec("IoGrp", "", as_int, true, 20);
  filter_atlas_handler["mon"].filter->AddColumnSpec("IoRead", "", as_int, true, 40);
  filter_atlas_handler["mon"].filter->AddColumnSpec("IoWrite", "", as_int, true, 40);
  filter_atlas_handler["mon"].filter->AddColumnSpec("IoFetch", "", as_int, true, 40);
  filter_atlas_handler["mon"].filter->AddColumnSpec("IoMark", "", as_int, true, 40);
  filter_atlas_handler["mon"].filter->AddColumnSpec("MemGrp", "", as_int, true, 20);
  filter_atlas_handler["mon"].filter->AddColumnSpec("MemUsed", "", as_int, true, 50);
  filter_atlas_handler["mon"].filter->AddColumnSpec("MemAlloc", "", as_int, true, 50);
  filter_atlas_handler["mon"].filter->AddColumnSpec("MemMaxUsed", "", as_int, true, 60);
  filter_atlas_handler["mon"].filter->AddColumnSpec("MemMaxAlloc", "", as_int, true, 60);
  filter_atlas_handler["mon"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 30);
  filter_atlas_handler["mon"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 40);
  filter_atlas_handler["mon"].filter->FetchPreferences("specialrouteradmin.mon");
  filter_atlas_handler["mon"].filter->SetIconStatus(true);
  filter_atlas_handler["mon"].filter->SetSQLStatement("");
  filter_atlas_handler["mon"].filter->RefreshDataSet();
  filter_atlas_handler["mon"].filter->SetAddEdit(this, NULL, NULL);
}
//---------------------------------------------------------------------------
void TformSpecialRouterAdministration::BuildSendOptionsTree()
{ // Build options tree, mapping each node to the appropriate page (can't do this at design time!)
//  TTreeNode* CurrBranch = NULL;
  TTreeNode* CurrLeaf = NULL;
  option_nodes.clear();
//  CurrBranch = treeMessageTypes->Items->Add(NULL, "INI file");
//  CurrBranch->Data = NULL;
    CurrLeaf = treeIni->Items->Add(NULL, "Get a value from the user's INI file");
     option_nodes.push_back(pair<option_type, int>(GetIniValue, sheetOptionsGetIni->PageIndex));
     CurrLeaf->Data = (void*)(&option_nodes.back());
    CurrLeaf = treeIni->Items->Add(NULL, "Set a value in the user's INI file");
     option_nodes.push_back(pair<option_type, int>(SetIniValue, sheetOptionsSetIni->PageIndex));
     CurrLeaf->Data = (void*)(&option_nodes.back());
    CurrLeaf = treeIni->Items->Add(NULL, "Get a copy of the user's INI file");
     option_nodes.push_back(pair<option_type, int>(GetIni, sheetOptionsBlank->PageIndex));
     CurrLeaf->Data = (void*)(&option_nodes.back());
    CurrLeaf = treeIni->Items->Add(NULL, "Save user's INI file");
     option_nodes.push_back(pair<option_type, int>(SaveIni, sheetOptionsBlank->PageIndex));
     CurrLeaf->Data = (void*)(&option_nodes.back());
    treeIni->FullExpand();
//  CurrBranch = treeMessageTypes->Items->Add(NULL, "Messages");
//  CurrBranch->Data = NULL;
    CurrLeaf = treeMessages->Items->Add(NULL, "Send an atlas message");
     option_nodes.push_back(pair<option_type, int>(SendAtlas, sheetOptionsSendAtlas->PageIndex));
     CurrLeaf->Data = (void*)(&option_nodes.back());
    CurrLeaf = treeMessages->Items->Add(NULL, "Send a text message");
     option_nodes.push_back(pair<option_type, int>(SendText, sheetOptionsTextMessage->PageIndex));
     CurrLeaf->Data = (void*)(&option_nodes.back());
    CurrLeaf = treeMessages->Items->Add(NULL, "Send a custom message");
     option_nodes.push_back(pair<option_type, int>(SendCustom, sheetOptionsCustomMessage->PageIndex));
     CurrLeaf->Data = (void*)(&option_nodes.back());
    treeMessages->FullExpand();
//  CurrBranch = treeMessageTypes->Items->Add(NULL, "Special");
//  CurrBranch->Data = NULL;
    CurrLeaf = treeSpecial->Items->Add(NULL, "Run a program on remote machine");
     option_nodes.push_back(pair<option_type, int>(RunProgram, sheetOptionsPath->PageIndex));
     CurrLeaf->Data = (void*)(&option_nodes.back());
    CurrLeaf = treeSpecial->Items->Add(NULL, "Close the program");
     option_nodes.push_back(pair<option_type, int>(CloseProgram, sheetOptionsBlank->PageIndex));
     CurrLeaf->Data = (void*)(&option_nodes.back());
    CurrLeaf = treeSpecial->Items->Add(NULL, "Close connection to messaging server");
     option_nodes.push_back(pair<option_type, int>(CloseConnection, sheetOptionsBlank->PageIndex));
     CurrLeaf->Data = (void*)(&option_nodes.back());
    CurrLeaf = treeSpecial->Items->Add(NULL, "Ping the program");
     option_nodes.push_back(pair<option_type, int>(PingProgram, sheetOptionsBlank->PageIndex));
     CurrLeaf->Data = (void*)(&option_nodes.back());
    treeSpecial->FullExpand();
//  CurrBranch = treeMessageTypes->Items->Add(NULL, "Server");
//  CurrBranch->Data = NULL;
    CurrLeaf = treeServer->Items->Add(NULL, "Get a list of all properties");
     option_nodes.push_back(pair<option_type, int>(GetServerList, sheetOptionsServerList->PageIndex));
     CurrLeaf->Data = (void*)(&option_nodes.back());
    CurrLeaf = treeServer->Items->Add(NULL, "Get the server's status");
     option_nodes.push_back(pair<option_type, int>(GetServerStatus, sheetOptionsServerStatus->PageIndex));
     CurrLeaf->Data = (void*)(&option_nodes.back());
    CurrLeaf = treeServer->Items->Add(NULL, "Set a value for this connection");
     option_nodes.push_back(pair<option_type, int>(SetServerValue, sheetOptionsServerSet->PageIndex));
     CurrLeaf->Data = (void*)(&option_nodes.back());
    CurrLeaf = treeServer->Items->Add(NULL, "Shut down the messaging server");
     option_nodes.push_back(pair<option_type, int>(ShutdownServer, sheetOptionsBlank->PageIndex));
     CurrLeaf->Data = (void*)(&option_nodes.back());
    treeServer->FullExpand();
  //get page index for thingie // int node_data = (int)treeMessageTypes->Selected->Data;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::sockFormClientSocketConnect(
      TObject *Sender, TCustomWinSocket *Socket)
{
 try
 {
  is_connect_successful = 1;
  sockFormClientSocket->OnRead = sockFormClientSocketRead;
  sockFormClientSocket->OnWrite = sockFormClientSocketWrite;

    timerReconnect->Enabled = false;

    listConnections->Items->Clear();
    txtStatus->Caption = "Getting status...";

    form_message_router->RequestServerNotification ("notifications", "client_connect");
    form_message_router->RequestServerNotification ("notifications", "client_disconnect");
    form_message_router->RequestServerNotification ("notifications", "set_property");
    form_message_router->RequestServerNotification ("notifications", "unset_property");

    timerGetMessages->Enabled = true;
    timerGetProperties->Enabled = true;

    form_message_router->SetValue("computer_name", computer_name);
    form_message_router->SetValue("user_name", PGlobals->current_username);
    form_message_router->SetValue("full_name", current_fullname);
    form_message_router->SetValue("client_type", "router admin");
    form_message_router->SendMessageToAll (optionsIni["server"]["other_put"], PGlobals->current_username + " has reconnected to the message server");
 }
 catch (ESocketError & the_error) { }

}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::sockFormClientSocketError(
      TObject *Sender, TCustomWinSocket *Socket, TErrorEvent ErrorEvent, int &ErrorCode)
{
  is_connect_successful = 2;
  ErrorCode = 0;
  timerReconnect->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::sockFormClientSocketRead(TObject *Sender, TCustomWinSocket *Socket)
{
  form_message_router->AttemptRead();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::sockFormClientSocketWrite(TObject *Sender, TCustomWinSocket *Socket)
{
  form_message_router->AttemptWrite();
  sockFormClientSocket->OnWrite = sockFormClientSocketWrite;
}
//---------------------------------------------------------------------------
void TformSpecialRouterAdministration::FillConnectionsListView()
{
  int column_width;
  int column_type;
  int column_display;
  if((int)column_header_set.size() != column_count)
  {
    connections_listview->clear_columns();
    column_count = 0;
    for(set<string>::iterator header_itr = column_header_set.begin(); header_itr != column_header_set.end(); header_itr++)
    {
      if((*header_itr) == "client_type")
        column_width = 61;
      else if((*header_itr) == "computer_name")
        column_width = 91;
      else if((*header_itr) == "connection_id")
        column_width = 24;
      else if((*header_itr) == "database")
        column_width = 57;
      else if((*header_itr) == "db_connection")
        column_width = 23;
      else if((*header_itr) == "full_name")
        column_width = 121;
      else if((*header_itr) == "gds_version")
        column_width = 72;
      else if((*header_itr) == "ip_address")
        column_width = 67;
      else if((*header_itr) == "is_idle")
        column_width = 29;
      else if((*header_itr) == "login_timestamp")
        column_width = 109;
      else if((*header_itr) == "user_id")
        column_width = 30;
      else if((*header_itr) == "user_name")
        column_width = 58;
      else if((*header_itr) == "version_number")
        column_width = 57;
      else
        column_width = 100;
      if((*header_itr) == "connection_id")
        column_type = as_int;
      else if((*header_itr) == "login_timestamp")
        column_type = as_stamp;
      else
        column_type = as_text;
      if((*header_itr) == "full_name")
        column_display = prettyString;
      else
        column_display = lowercaseString;
      connections_listview->add_or_modify_column((*header_itr), (*header_itr), true, column_count, column_width, column_type, column_display);
      column_count++;
    }
  }

  vector<map<string, string> > listview_vec_map;
  map<string, string> temp_map;
  for(map<string, map<string, string> >::iterator outer_itr = property_map.begin(); outer_itr != property_map.end(); outer_itr++)
  {
    temp_map.clear();
    for(map<string, string>::iterator inner_itr = outer_itr->second.begin(); inner_itr != outer_itr->second.end(); inner_itr++)
    {
      temp_map[inner_itr->first] = inner_itr->second;
    }
    temp_map["connection_id"] = outer_itr->first;
    listview_vec_map.push_back(temp_map);
  }
  connections_listview->clear_data();
  connections_listview->import_data(listview_vec_map);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::comboSelectAreaChange(TObject *Sender)
{
  if(comboSelectArea->Text == "Send messages")
    sheetSendMessages->Show();
  else if(comboSelectArea->Text == "View sent messages")
    sheetSentMessages->Show();
  else if(comboSelectArea->Text == "View received messages")
    sheetReceivedMessages->Show();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::timerGetMessagesTimer(TObject *Sender)
{
  if(sockFormClientSocket->Active)
  {
  list<string> all_channels = form_message_router->GetAllChannels();
  list<string> channels_with_messages = form_message_router->GetChannelsWithMessages();
  string message;

  for(list<string>::iterator itr = all_channels.begin(); itr != all_channels.end(); itr++)
  {
    if(listening_channel_map.find((*itr)) == listening_channel_map.end())
      if((*itr) != "form_status_channel")
        AddChannelTab((*itr));
  }
  for(list<string>::iterator itr = channels_with_messages.begin(); itr != channels_with_messages.end(); itr++)
  {
    while(form_message_router->IsMessageWaiting((*itr)))
    {
      message = form_message_router->GetNextMessage((*itr));
      if((*itr) != "form_status_channel")
        AddReceivedMessageToListView((*itr), message);
      else
        txtStatus->Caption = message.c_str();

      if((*itr) == "notifications")
      {
        get_properties = true;
      }
      else if((*itr) == "properties")
      {
        if(message == "starting properties")
        {
          column_header_set.clear();
          property_map.clear();
        }
        else if(message == "ending properties")
        {
          FillConnectionsListView();
        }
        else
        {
          int first_sep;
          int second_sep;
          string connection_number;
          string property_name;
          string property_value;
          Pstamp temp_stamp;

          first_sep = message.find_first_of("~");
          second_sep = message.find("~", first_sep + 1);
          connection_number = message.substr(0, first_sep);
          property_name = message.substr(first_sep + 1, second_sep - first_sep - 1);
          property_value = message.substr(second_sep + 1, message.length() - second_sep);
          if((property_name == "login_timestamp") && (property_value != ""))
          {
            temp_stamp.InStamp(property_value, datefirst | ymd | yyyy | military | withsec);
            property_value = temp_stamp.OutStamp(datefirst | mdy | yyyy | military | withsec);
          }
          if(property_name == "full_name")
            property_value = PrettyString(property_value);
          else
            property_value = LowercaseString(property_value);
          property_map[connection_number][property_name] = property_value;
          column_header_set.insert(property_name);
          property_map[connection_number]["connection_id"] = connection_number;
          column_header_set.insert("connection_id");
        }
      } // end else if channel=properties
    } // end while is message waiting
  } // end for loop
  }
  else
  {
    txtStatus->Caption = "Server is not running";
    timerGetMessages->Enabled = false;
    timerGetProperties->Enabled = false;    
  }
}
//---------------------------------------------------------------------------
void TformSpecialRouterAdministration::AddChannelTab(string channel_name)
{
  TTabSheet * new_sheet = new TTabSheet(pageReceivedMessages);
  new_sheet->Caption = channel_name.c_str();
  new_sheet->PageControl = pageReceivedMessages;
  new_sheet->Parent = pageReceivedMessages;

  TListView* list_view = new TListView(new_sheet);
  TAnchors stupid;
  stupid << akLeft << akRight << akTop << akBottom;
  list_view->Anchors = stupid;
  list_view->Left = listReceivedAll->Left;
  list_view->Top = listReceivedAll->Top;
  list_view->Width = listReceivedAll->Width;
  list_view->Height = listReceivedAll->Height;
  list_view->ViewStyle = vsReport;
  list_view->ShowColumnHeaders = true;
  list_view->ReadOnly = true;
  list_view->RowSelect = true;
  list_view->HideSelection = false;

  TListColumn * column = list_view->Columns->Add();
  column->Width = 600;
  column->Caption = "Message";
  column = list_view->Columns->Add();
  column->Width = 120;
  column->Caption = "Time Received";

  list_view->Parent = new_sheet;
  pageReceivedMessages->ActivePageIndex = 0;

  listening_channel_map[channel_name] = list_view;
}
//---------------------------------------------------------------------------
void TformSpecialRouterAdministration::AddReceivedMessageToListView(string channel_name, string message)
{
  if (!(checkLogOnly->Enabled && checkLogOnly->Checked))
  {
    string received_time = RightNow();

    // add to the list view for all channels
    TListItem *row = listReceivedAll->Items->Insert(0);
    row->Caption = message.c_str();
    row->SubItems->Add(channel_name.c_str());
    row->SubItems->Add(received_time.c_str());

    // add to the list view on the appropriate tab
    TListView *list_view = listening_channel_map[channel_name];
    row = list_view->Items->Insert(0);
    row->Caption = message.c_str();
    row->SubItems->Add(received_time.c_str());

    DeleteExtraItems(listReceivedAll);
    DeleteExtraItems(list_view);
  }

  if (checkLogReceivedMessages->Checked) // log (listening) channel messages to file
  { // open file for output if we don't already have an fstream for it
    if(channel_log_map.find(channel_name) == channel_log_map.end())
    { // channel_log_map is a map<string, fstream>
      channel_log_map[channel_name] = new fstream(("router_admin_" + channel_name + ".log").c_str(), ios::out | ios::app);
      if (channel_log_map[channel_name]->is_open())
        (*channel_log_map[channel_name]) << ("Opening session on " + string(Now().DateString().c_str()) + " at " + string(Now().TimeString().c_str()) + "\n");
    }
    // if we're good to go, go for it
    if (channel_log_map[channel_name]->is_open())
    {
      (*channel_log_map[channel_name]) << message << '\n';
    }
    else ; // file should be open, but for some reason isn't.  Give an error?
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::timerGetPropertiesTimer(TObject *Sender)
{
  if(get_properties)
  {
    form_message_router->GetProperties("properties");
    get_properties = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::timerStatusTimer(TObject *Sender)
{
  form_message_router->GetServerStatus("form_status_channel");
}
//---------------------------------------------------------------------------
void TformSpecialRouterAdministration::DeleteExtraItems(TListView *list_view)
{
  int item_count = list_view->Items->Count;
  if(item_count > keep_only)
  {
    for(int i = keep_only; i < item_count; i++)
      list_view->Items->Delete(i);
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::sockFormClientSocketDisconnect(TObject *Sender, TCustomWinSocket *Socket)
{
  sockFormClientSocket->OnRead = NULL;
  sockFormClientSocket->OnWrite = NULL;
  timerReconnect->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::timerReconnectTimer(TObject *Sender)
{
  if (sockFormClientSocket->Active)
   sockFormClientSocket->Close();
  is_connect_successful = 0;
  sockFormClientSocket->Open();
//   while(is_connect_successful == 0)
//    Application->ProcessMessages();
/*
  if(is_connect_successful == 1)
  {
    listConnections->Items->Clear();
    txtStatus->Caption = "Getting status...";
    timerReconnect->Enabled = false;

    form_message_router->RequestServerNotification ("notifications", "client_connect");
    form_message_router->RequestServerNotification ("notifications", "client_disconnect");
    form_message_router->RequestServerNotification ("notifications", "set_property");
    form_message_router->RequestServerNotification ("notifications", "unset_property");

    timerGetMessages->Enabled = true;
    timerGetProperties->Enabled = true;

    form_message_router->SetValue("computer_name", computer_name);
    form_message_router->SetValue("user_name", PGlobals->current_username);
    form_message_router->SetValue("full_name", current_fullname);
    form_message_router->SetValue("client_type", "router admin");
    form_message_router->SendMessageToAll (optionsIni["server"]["other_put"], PGlobals->current_username + " has reconnected to the message server");

  }
*/
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::treeChange(TObject *Sender, TTreeNode *Node)
{

  bool all_is_well = true;
  if (Node->TreeView->Selected)
  {
    if (Node->TreeView->Selected->Data)
    {
      pair<option_type, int>* option_node = (pair<option_type, int>*)Node->TreeView->Selected->Data;
      int options_page = option_node->second;
      if (options_page >= 0 && options_page < pagesMessageOptions->PageCount)
      {
        // We have a few special cases where the same page is used by different options and thus we need
        // to enable/disable controls when switching pages.  We do that here.
/*        option_type selected_option;
        selected_option = option_node->first;
        switch (selected_option)
        {
          case GetIniValue: lblGetIniValue->Visible   = false; editGetIniValue->Visible = false; break;
          case SetIniValue: lblSetIniValue->Visible   = true;  editSetIniValue->Visible = true;  break;
          case SendText   : lblCustomChannel->Visible = false; editChannel->Visible  = false; break;
          case SendCustom : lblCustomChannel->Visible = true;  editChannel->Visible  = true;  break;
          case RunProgram:
          case CloseProgram:
          case CloseConnection:
          case PingProgram:
          case GetServerList:
          case GetServerStatus:
          case SetServerValue:
          case ShutdownServer:
        }
        // End special cases.  Now we show the page.
*/
        pagesMessageOptions->ActivePageIndex = options_page;
      }
      else
        all_is_well = false;
    }
    else
      all_is_well = false;
  }
  else
    all_is_well = false;

  if (!all_is_well)
    pagesMessageOptions->ActivePageIndex = 0;  // that's the blank page, folks

//DisableSelectedPanels();
/*  if (!treeMessageTypes->Selected || //treeMessageTypes->Selected->Level == 0
     sheetOptionsBlank->PageCount)
  {
    sheetOptionsBlank->Show()
    panelSendOptionsButtons->Visible = false;
  }
  else
*/
/*
panelSendOptionsButtons->Visible = true;
if(cboMessageType->Text == "Run a program on remote machine")
{
  panelPath->Visible = true;
  lblChannel->Caption = optionsIni["server"]["admin_get"].c_str();
}
else if(cboMessageType->Text == "Send a command to program")
{
  panelCommand->Visible = true;
  lblChannel->Caption = optionsIni["server"]["admin_get"].c_str();
}
else if(cboMessageType->Text == "Send a text message")
{
  panelMessage->Visible = true;
  lblChannel->Caption = optionsIni["server"]["admin_get"].c_str();
}
else if(cboMessageType->Text == "Send a text message and receive notification that it was received")
{
  panelMessage->Visible = true;
  lblChannel->Caption = optionsIni["server"]["admin_get"].c_str();
}
else if(cboMessageType->Text == "Get a value from the user's INI file")
{
  panelGetIni->Visible = true;
  lblChannel->Caption = optionsIni["server"]["admin_get"].c_str();
}
else if(cboMessageType->Text == "Set a value in the user's INI file")
{
  panelSetIni->Visible = true;
  lblChannel->Caption = optionsIni["server"]["admin_get"].c_str();
}
else if(cboMessageType->Text == "Send an atlas message")
{
  panelAtlas->Visible = true;
  lblChannel->Caption = optionsIni["server"]["atlas_get"].c_str();
}
else if(cboMessageType->Text == "Send a custom message")
{
  panelCustom->Visible = true;
  lblChannel->Caption = "";
}
else
{
  lblChannel->Caption = "";
}
*/
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::btnSendClick(TObject *Sender)
{
  string message_to_send = "";
  string message_to_display = "";
  string channel = "";
  bool all_is_well = false;
  option_type selected_option;
  if(listConnections->SelCount < 1)
  { // TODO : should not have to select a connection for messages to the server
    all_is_well = false;
    PSay("Please select a connection(s) to send to", m_missing_data, MB_OK);
    listConnections->SetFocus();
  }
  if (treeIni->Selected)
  {
    if (treeIni->Selected->Data)
    {
      pair<option_type, int>* option_node = (pair<option_type, int>*)treeIni->Selected->Data;
      selected_option = option_node->first;
      all_is_well = true;
    }
  }
  if (treeMessages->Selected)
  {
    if (treeMessages->Selected->Data)
    {
      pair<option_type, int>* option_node = (pair<option_type, int>*)treeMessages->Selected->Data;
      selected_option = option_node->first;
      all_is_well = true;
    }
  }
  if (treeSpecial->Selected)
  {
    if (treeSpecial->Selected->Data)
    {
      pair<option_type, int>* option_node = (pair<option_type, int>*)treeSpecial->Selected->Data;
      selected_option = option_node->first;
      all_is_well = true;
    }
  }
  if (treeServer->Selected)
  {
    if (treeServer->Selected->Data)
    {
      pair<option_type, int>* option_node = (pair<option_type, int>*)treeServer->Selected->Data;
      selected_option = option_node->first;
      all_is_well = true;
    }
  }
  if (all_is_well)
  {
    switch(selected_option)
    {
      case GetIniValue:
        channel = "commands";
        if(editGetIniSection->Text == "")
        {
          all_is_well = false;
          PSay("Please enter a section", m_missing_data, MB_OK);
          editGetIniSection->SetFocus();
        }
        else if(editGetIniKey->Text == "")
        {
          all_is_well = false;
          PSay("Please enter a key", m_missing_data, MB_OK);
          editGetIniKey->SetFocus();
        }
        else
          message_to_send = "get:" + string(editGetIniSection->Text.c_str()) + "." +
                            string(editGetIniKey->Text.c_str());
        break;
      case SetIniValue:
        channel = "commands";
        if(editSetIniSection->Text == "")
        {
          all_is_well = false;
          PSay("Please enter a section", m_missing_data, MB_OK);
          editSetIniSection->SetFocus();
        }
        else if(editSetIniKey->Text == "")
        {
          all_is_well = false;
          PSay("Please enter a key", m_missing_data, MB_OK);
          editSetIniKey->SetFocus();
        }
        else if(editSetIniValue->Text == "")
        {
          all_is_well = false;
          PSay("Please enter a value", m_missing_data, MB_OK);
          editSetIniValue->SetFocus();
        }
        else
          message_to_send = "set:" + string(editSetIniSection->Text.c_str()) + "." +
                            string(editSetIniKey->Text.c_str()) + "=" + string(editSetIniValue->Text.c_str());
        break;
      case GetIni:
        channel = optionsIni["server"]["admin_get"];
        message_to_send = "cmd:diagnose";
        break;
      case SaveIni:
        channel = optionsIni["server"]["admin_get"];
        message_to_send = "cmd:save";
        break;
      case SendAtlas:
        channel = optionsIni["server"]["atlas_get"];
        if(editAtlasKey->Text == "")
        {
          all_is_well = false;
          PSay("Please enter a key", m_missing_data, MB_OK);
          editAtlasKey->SetFocus();
        }
        else if(editAtlasValue->Text == "")
        {
          all_is_well = false;
          PSay("Please enter a value", m_missing_data, MB_OK);
          editAtlasValue->SetFocus();
        }
        else
          message_to_send = string(editAtlasKey->Text.c_str()) + "|" + string(editAtlasValue->Text.c_str());
        break;
      case SendText:
        channel = optionsIni["server"]["admin_get"];
        if(editTextMessage->Text != "")
        {
          if(checkSendTextReceiveNotification->Checked)
            message_to_send = "ack:" + string(editTextMessage->Text.c_str());
          else
            message_to_send = "say:" + string(editTextMessage->Text.c_str());
        }
        else
        {
          all_is_well = false;
          PSay("Please enter a message to send", m_missing_data, MB_OK);
          editTextMessage->SetFocus();
        }
        break;
      case SendCustom:
        if(editChannel->Text == "")
        {
          all_is_well = false;
          PSay("Please enter a channel", m_missing_data, MB_OK);
          editChannel->SetFocus();
        }
        else if(editCustomMessage->Text == "")
        {
          all_is_well = false;
          PSay("Please enter a message", m_missing_data, MB_OK);
          editCustomMessage->SetFocus();
        }
        else
        {
          message_to_send = editCustomMessage->Text.c_str();
          channel = editChannel->Text.c_str();
        }
        break;
      case RunProgram:
        channel = "commands";
        if(editPath->Text == "")
        {
          all_is_well = false;
          PSay("Please enter a path", m_missing_data, MB_OK);
          editPath->SetFocus();
        }
        else
          message_to_send = "run:" + string(editPath->Text.c_str());
        break;
      case CloseProgram:
        channel = optionsIni["server"]["admin_get"];
        message_to_send = "cmd:close";
        break;
      case CloseConnection:
        channel = optionsIni["server"]["admin_get"];
        message_to_send = "cmd:closemessaging";
        break;
      case PingProgram:
        channel = optionsIni["server"]["admin_get"];
        message_to_send = "cmd:ping";
        break;
      case GetServerList:
        if(editServerListChannel->Text == "")
        {
          all_is_well = false;
          PSay("Please enter a channel", m_missing_data, MB_OK);
          editServerListChannel->SetFocus();
        }
        else if(editServerListChannel->Text == "properties")
        {
          all_is_well = false;
          PSay("Please do not use \"properties\" as the channel because it is used by this form", m_warning, MB_OK);
          editServerListChannel->SetFocus();
        }
        else
        {
          form_message_router->GetProperties(editServerListChannel->Text.c_str());
          message_to_display = "server~list~" + string(editServerListChannel->Text.c_str());
        }
        AddSentMessageToList(message_to_display, RightNow());
        break;
      case GetServerStatus:
        if(editServerStatusChannel->Text == "")
        {
          all_is_well = false;
          PSay("Please enter a channel", m_missing_data, MB_OK);
          editServerStatusChannel->SetFocus();
        }
        else
        {
          form_message_router->GetServerStatus(editServerStatusChannel->Text.c_str());
          message_to_display = "server~status~" + string(editServerStatusChannel->Text.c_str());
        }
        AddSentMessageToList(message_to_display, RightNow());
        break;
      case SetServerValue:
        if(editServerSetKey->Text == "")
        {
          all_is_well = false;
          PSay("Please enter a key", m_missing_data, MB_OK);
          editServerSetKey->SetFocus();
        }
        else if(editServerSetValue->Text == "")
        {
          all_is_well = false;
          PSay("Please enter a value", m_missing_data, MB_OK);
          editServerSetValue->SetFocus();
        }
        else
        {
          form_message_router->SetValue(editServerSetKey->Text.c_str(), editServerSetValue->Text.c_str());
          message_to_display = "set~" + string(editServerSetKey->Text.c_str()) + "~" +
                               string(editServerSetValue->Text.c_str());
        }
        AddSentMessageToList(message_to_display, RightNow());
        break;
      case ShutdownServer:
        if(PSay("Are you sure you want to shut down the server?", m_confirmation, MB_YESNO) == 6)
        {
          form_message_router->SendMessageToServer("exit");
          message_to_display = "server~exit";
        }
        else
          all_is_well = false;
        AddSentMessageToList(message_to_display, RightNow());
        break;
    }
  }

  if(all_is_well && channel != "" && message_to_send != "")
  {
    vector<map<string, string> > data_vec;
    string connection_id;
    connections_listview->export_selected_data(data_vec);
    string time_to_display = RightNow();
    for(vector<map<string, string> >::iterator itr = data_vec.begin(); itr != data_vec.end(); itr++)
    {
      connection_id = (*itr)["connection_id"];
      form_message_router->SendMessageToConnection(StringToInt(connection_id), channel, message_to_send);
      AddSentMessageToList("to~" + connection_id + "~" + channel + "~" + message_to_send, time_to_display);
      if(message_to_send == "cmd:closemessaging")
      {
        form_message_router->CloseConnection(StringToInt(connection_id));
        AddSentMessageToList("server~close~" + connection_id, time_to_display);
      }
    }
    //Paul doesn't like this//ClearSelectedPanels();
    //Paul doesn't like this//DisableSelectedPanels();
    listConnections->SetFocus();
  }
  if (menuSwitchAfterSend->Checked)
    sheetReceivedMessages->Show();

  if (!all_is_well)
    PSay("Some kind of error occurred.", m_debug, MB_OK);
}
//---------------------------------------------------------------------------
void TformSpecialRouterAdministration::AddSentMessageToList(string message, string time)
{
  // exempt from log_to_screen--should apply just incoming messages, probably
  TListItem *row = listSentMessages->Items->Insert(0);
  row->Caption = message.c_str();
  row->SubItems->Add(time.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::FormClose(TObject *Sender, TCloseAction &Action)
{
  timerGetProperties->Enabled = false;
  timerGetMessages->Enabled = false;
  sockFormClientSocket->OnRead = NULL;
  sockFormClientSocket->OnWrite = NULL;
  sockFormClientSocket->Close();
  delete connections_listview;
  delete form_message_router;
  CloseLogFiles();
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::treeChanging(
      TObject *Sender, TTreeNode *Node, bool &AllowChange)
{
/*
  if (Node->Level == 0)
    AllowChange = false;
  else
    AllowChange = true;
*/
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::treeCollapsing(
      TObject *Sender, TTreeNode *Node, bool &AllowCollapse)
{
  AllowCollapse = false;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::checkLogReceivedMessagesClick(TObject *Sender)
{
  if (!checkLogReceivedMessages->Checked)
    CloseLogFiles();
  checkLogOnly->Enabled = checkLogReceivedMessages->Checked;
}
//---------------------------------------------------------------------------
void TformSpecialRouterAdministration::CloseLogFiles()
{
  for (map<string, fstream  *>::iterator itr = channel_log_map.begin(); itr != channel_log_map.end(); itr++)
     if (itr->second)
     {
       if(itr->second->is_open())
       {
         *(itr->second) << ("Closing session on " + string(Now().DateString().c_str()) + " at " + string(Now().TimeString().c_str()) + "\n\n");
         itr->second->close();
       }
       delete itr->second;
     }
  channel_log_map.clear();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::sheetSqlMonShow(TObject *Sender)
{
  RefreshMonList();
}
//---------------------------------------------------------------------------
void TformSpecialRouterAdministration::RefreshMonList()
{
  if (refreshTransaction)
  {
    if (refreshTransaction->Active)
      refreshTransaction->Commit();
    delete refreshTransaction;
  }
  refreshTransaction = new TIBTransaction(NULL);
  StdTransaction(refreshTransaction, dbDatabase);
  filter_atlas_handler["mon"].filter->SetTransaction(refreshTransaction);
  // fetch from mon$ tables
  string sql =
  "select "
   "a.mon$remote_address, a.mon$state, a.mon$timestamp, cast((current_timestamp - a.mon$timestamp)*86400 as integer), a.mon$remote_process, a.mon$attachment_id a_id, "
   "t.mon$state, t.mon$timestamp, cast((current_timestamp - t.mon$timestamp)*86400 as integer), t.mon$transaction_id t_id, "
   // t.mon$top_transaction, t.mon$oldest_transaction, t.mon$oldest_active, t.mon$isolation_mode, t.mon$lock_timeout, t.mon$read_only, t.mon$auto_commit, t.mon$auto_undo, "
   "s.mon$state, s.mon$timestamp, cast((current_timestamp - a.mon$timestamp)*86400 as integer), s.mon$sql_text, s.mon$statement_id s_id, "
   "i.mon$stat_group, i.mon$page_reads, i.mon$page_writes, i.mon$page_fetches, i.mon$page_marks, "
   "m.mon$stat_group, m.mon$memory_used, m.mon$memory_allocated, m.mon$max_memory_used, m.mon$max_memory_allocated, "
   //"case when s.mon$state = 1 then 4 else 2 end current_id, s.mon$statement_id internal_id "
   "case (coalesce(s.mon$state, 0) * 4 + coalesce(t.mon$state, 0) * 2 + coalesce(a.mon$state, 0)) "
   "when 0 then 0 when 1 then 2 when 2 then 1 when 3 then 4 when 7 then 5 else 3 end current_id, s.mon$statement_id internal_id "
  "from mon$attachments a "
  "left join mon$statements s on s.mon$attachment_id = a.mon$attachment_id "
  "left join mon$transactions t on s.mon$transaction_id = t.mon$transaction_id "
  "left join mon$io_stats i on i.mon$stat_id = s.mon$stat_id "
  "left join mon$memory_usage m on m.mon$stat_id = s.mon$stat_id "
  // "where a.mon$attachment_id <> current_connection " // too restrictive
  "order by a.mon$remote_address ";
  filter_atlas_handler["mon"].filter->SetSQLStatement(sql);
  filter_atlas_handler["mon"].filter->RefreshDataSet();
  timerMon->Enabled = checkRefresh->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::listMonSelectItem(TObject *Sender, TListItem *Item, bool Selected)
{
  string id = filter_atlas_handler["mon"].filter->GetSelectedRecordID();
  if (!IsBlankOrZero(id))
  {
    vector<map<string, string> > selected = filter_atlas_handler["mon"].filter->GetAllData (false, true);
    //Application->MessageBox(("\"" + id + "\":\n\n" + ).c_str(), "debug", MB_OK);
    editSQL->Text = selected[0]["SQL"].c_str();
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::timerMonTimer(TObject *Sender)
{
  if (IsInt(editRefresh->Text.c_str()))
  {
    editRefresh->Color = clWindow;
    timerMon->Interval = StrToInt(editRefresh->Text);
  }
  else
  {
    editRefresh->Color = clBad;
    return;
  }
  if (IsVisible(panelSqlMon))
    RefreshMonList();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::checkRefreshClick(TObject *Sender)
{
  timerMon->Enabled = checkRefresh->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::btnKillStatementClick(TObject *Sender)
{
  string id = filter_atlas_handler["mon"].filter->GetSelectedRecordID();
  if (!IsBlankOrZero(id))
  {
    vector<map<string, string> > selected = filter_atlas_handler["mon"].filter->GetAllData (true, true);
    vector<string> ids; VecMapColumnToVec(selected, ids, "s_id", false);
    string sql = "delete from mon$statements where " + SafeInClause("mon$statement_id", ids);
    // Application->MessageBox(sql.c_str(), "debug", MB_OK);
    bool all_is_well = false;
    AnsiString msg = "unknown failure";
    try
    { all_is_well = ExecuteStatement(refreshTransaction, sql); }
    catch (EIBInterBaseError &err)
    { msg = err.Message; }
    catch (EIBError & err)
    { msg = err.Message; }
    if (!all_is_well)
    {
      Screen->Cursor = crDefault;
      PSay(msg.c_str(), m_database_error, MB_OK);
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::btnKillTransactionClick(TObject *Sender)
{
  string id = filter_atlas_handler["mon"].filter->GetSelectedRecordID();
  if (!IsBlankOrZero(id))
  {
    vector<map<string, string> > selected = filter_atlas_handler["mon"].filter->GetAllData (true, true);
    vector<string> ids; VecMapColumnToVec(selected, ids, "t_id", false);
    string sql = "delete from mon$transactions where " + SafeInClause("mon$transaction_id", ids);
    // Application->MessageBox(sql.c_str(), "debug", MB_OK);
    bool all_is_well = false;
    AnsiString msg = "unknown failure";
    try
    { all_is_well = ExecuteStatement(refreshTransaction, sql); }
    catch (EIBInterBaseError &err)
    { msg = err.Message; }
    catch (EIBError & err)
    { msg = err.Message; }
    if (!all_is_well)
    {
      Screen->Cursor = crDefault;
      PSay(msg.c_str(), m_database_error, MB_OK);
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::btnKillAttachmentClick(TObject *Sender)
{
  string id = filter_atlas_handler["mon"].filter->GetSelectedRecordID();
  if (!IsBlankOrZero(id))
  {
    vector<map<string, string> > selected = filter_atlas_handler["mon"].filter->GetAllData (true, true);
    vector<string> ids; VecMapColumnToVec(selected, ids, "a_id", false);
    string sql = "delete from mon$attachments where " + SafeInClause("mon$attachment_id", ids);
    // Application->MessageBox(sql.c_str(), "debug", MB_OK);
    bool all_is_well = false;
    AnsiString msg = "unknown failure";
    try
    { all_is_well = ExecuteStatement(refreshTransaction, sql); }
    catch (EIBInterBaseError &err)
    { msg = err.Message; }
    catch (EIBError & err)
    { msg = err.Message; }
    if (!all_is_well)
    {
      Screen->Cursor = crDefault;
      PSay(msg.c_str(), m_database_error, MB_OK);
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialRouterAdministration::btnRefreshClick(TObject *Sender)
{
  RefreshMonList();
}
//---------------------------------------------------------------------------

