//---------------------------------------------------------------------------

#ifndef codeSpecialRouterAdministrationH
#define codeSpecialRouterAdministrationH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <Menus.hpp>
#include <ScktComp.hpp>
#include <ExtCtrls.hpp>
#include "codeRubberContainer.h"
#include "codeSectionsGeneric.h"
#include "codeSoftDropShadow.h"
//---------------------------------------------------------------------------
enum option_type {GetIniValue, SetIniValue, GetIni, SaveIni, SendAtlas, SendText, SendCustom, RunProgram,
 CloseProgram, CloseConnection, PingProgram, GetServerList, GetServerStatus, SetServerValue, ShutdownServer};

class TformSpecialRouterAdministration : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TClientSocket *sockFormClientSocket;
        TPageControl *pageMessages;
        TTabSheet *sheetSendMessages;
        TPanel *panelSelectArea;
        TComboBox *comboSelectArea;
        TStaticText *staticSelectArea;
        TTabSheet *sheetReceivedMessages;
        TTabSheet *sheetSentMessages;
        TListView *listSentMessages;
        TToolButton *btnClose;
        TToolButton *btnInvisible;
        TPageControl *pageReceivedMessages;
        TTabSheet *sheetReceivedAll;
        TListView *listReceivedAll;
        TTimer *timerGetMessages;
        TTimer *timerGetProperties;
        TTimer *timerStatus;
        TTimer *timerReconnect;
        TPanel *panelSendMessages;
        TPanel *panelSendTop;
        TSplitter *splitSend;
        TPanel *panelSendOptions;
        TSplitter *splitSendOptions;
        TPanel *panelSendOptionsLeft;
        TPanel *panelSendOptionsRight;
        TPageControl *pagesMessageOptions;
        TTabSheet *sheetOptionsBlank;
        TTabSheet *sheetOptionsSetIni;
        TLabel *lblSetIniValue;
        TLabel *lblSetIniKey;
        TLabel *lblSetIniSection;
        TEdit *editSetIniValue;
        TEdit *editSetIniKey;
        TEdit *editSetIniSection;
        TTabSheet *sheetOptionsSendAtlas;
        TLabel *lblAtlasValue;
        TLabel *lblAtlasKey;
        TEdit *editAtlasKey;
        TEdit *editAtlasValue;
        TTabSheet *sheetOptionsTextMessage;
        TCheckBox *checkSendTextReceiveNotification;
        TTabSheet *sheetOptionsPath;
        TLabel *lblPathLabel;
        TEdit *editPath;
        TTabSheet *sheetOptionsServerList;
        TLabel *lblServerList;
        TEdit *editServerListChannel;
        TTabSheet *sheetOptionsServerStatus;
        TLabel *lblServerStatusChannel;
        TEdit *editServerStatusChannel;
        TTabSheet *sheetOptionsServerSet;
        TLabel *lblServerSetKey;
        TLabel *lblServerSetValue;
        TEdit *editServerSetKey;
        TEdit *editServerSetValue;
        TPanel *panelServerStatus;
        TGroupBox *groupStatus;
        TStaticText *txtStatus;
        TTabSheet *sheetOptionsCustomMessage;
        TEdit *editChannel;
        TLabel *lblCustomChannel;
        TLabel *lblTextMessage;
        TEdit *editTextMessage;
        TLabel *lblCustomMessage;
        TEdit *editCustomMessage;
        TTabSheet *sheetOptionsGetIni;
        TLabel *lblGetIniSection;
        TEdit *editGetIniSection;
        TLabel *lblGetIniKey;
        TEdit *editGetIniKey;
        TPopupMenu *menuSend;
        TMenuItem *menuSwitchAfterSend;
        TMenuItem *menuClearAfterSend;
        TToolBar *toolSend;
        TToolButton *ToolButton1;
        TToolButton *btnSend;
        TToolButton *btnInvisible2;
        TPanel *panelReceivedMessagesOptions;
        TCheckBox *checkLogReceivedMessages;
        TCheckBox *checkLogOnly;
        TRubberContainer *RubberContainer1;
        TListView *listConnections;
        TScrollBox *scrollLeft;
        TSectionsGeneric *sectionIni;
        TTreeView *treeIni;
        TSectionsGeneric *sectionMessages;
        TTreeView *treeMessages;
        TSectionsGeneric *sectionSpecial;
        TTreeView *treeSpecial;
        TSectionsGeneric *sectionServer;
        TTreeView *treeServer;
        TTabSheet *sheetSqlMon;
        TPanel *panelSqlMon;
        TSplitter *splitMon;
        TPanel *panelMonTop;
        TRubberContainer *rubberMon;
        TListView *listMon;
        TPanel *panelMonBottom;
        TPageControl *pageMon;
        TTabSheet *sheetSQL;
        TRubberContainer *rubberSQL;
        TTabSheet *sheetActions;
        TRichEdit *editSQL;
        TPanel *panelMonOptions;
        TSectionsGeneric *sectionOptions;
        TTimer *timerMon;
        TCheckBox *checkRefresh;
        TEdit *editRefresh;
        TLabel *Label1;
        TButton *btnKillStatement;
        TButton *btnKillTransaction;
        TButton *btnKillAttachment;
        TLabel *lblTxInfo;
        TLabel *lblAtInfo;
        TButton *btnRefresh;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall sockFormClientSocketRead(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall sockFormClientSocketWrite(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall sockFormClientSocketConnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall sockFormClientSocketError(TObject *Sender,
          TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
          int &ErrorCode);
        void __fastcall comboSelectAreaChange(TObject *Sender);
        void __fastcall btnSendClick(TObject *Sender);
        void __fastcall btnCloseClick(TObject *Sender);
        void __fastcall timerGetMessagesTimer(TObject *Sender);
        void __fastcall timerGetPropertiesTimer(TObject *Sender);
        void __fastcall timerStatusTimer(TObject *Sender);
        void __fastcall sockFormClientSocketDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall timerReconnectTimer(TObject *Sender);
        void __fastcall treeChange(TObject *Sender,
          TTreeNode *Node);
        void __fastcall treeChanging(TObject *Sender,
          TTreeNode *Node, bool &AllowChange);
        void __fastcall treeCollapsing(TObject *Sender,
          TTreeNode *Node, bool &AllowCollapse);
        void __fastcall checkLogReceivedMessagesClick(TObject *Sender);
        void __fastcall sheetSqlMonShow(TObject *Sender);
        void __fastcall listMonSelectItem(TObject *Sender, TListItem *Item,
          bool Selected);
        void __fastcall timerMonTimer(TObject *Sender);
        void __fastcall checkRefreshClick(TObject *Sender);
        void __fastcall btnKillStatementClick(TObject *Sender);
        void __fastcall btnKillTransactionClick(TObject *Sender);
        void __fastcall btnKillAttachmentClick(TObject *Sender);
        void __fastcall btnRefreshClick(TObject *Sender);
private:	// User declarations
        map<string, map<string, string> > property_map;
        set<string> column_header_set;
        map<string, TListView *> listening_channel_map;
        map<string, fstream  *> channel_log_map;
        bool get_properties;
        int is_connect_successful;
        string notification_channel;
        classTcpipMessaging * form_message_router;
        edit_listview * connections_listview;
        void BuildSendOptionsTree();
        int column_count;
        list<pair<option_type, int> > option_nodes;
        void CloseLogFiles();
public:		// User declarations
        __fastcall TformSpecialRouterAdministration(TComponent* Owner);
        void FillConnectionsListView();
        void AddSentMessageToList(string message, string time);
        void AddChannelTab(string channel_name);
        void AddReceivedMessageToListView(string channel_name, string message);
        void DeleteExtraItems(TListView *list_view);
private:
        void RefreshMonList();
        TIBTransaction* refreshTransaction;
};
//---------------------------------------------------------------------------
extern PACKAGE TformSpecialRouterAdministration *formSpecialRouterAdministration;
//---------------------------------------------------------------------------
#endif
