//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialSaveListView.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialSaveListView *formSpecialSaveListView;
//---------------------------------------------------------------------------
__fastcall TformSpecialSaveListView::TformSpecialSaveListView(TComponent* Owner, TListView * p_what_to_save)
        : TformSpecialGeneric(Owner)
{
 what_to_save = p_what_to_save;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSaveListView::editFileNameDblClick(
      TObject *Sender)
{
 // open a dialog box to select a file
 dialogSaveFile->Execute();
 editFileName->Text = dialogSaveFile->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSaveListView::buttonSaveClick(TObject *Sender)
{
 buttonSave->Enabled = false;
 buttonCancel->Enabled = false;

 // save file
 fstream save_file;
 save_file.open (editFileName->Text.c_str(), ios::out | ios::trunc);
 if (save_file)
 {
  // CSV
  // headers
  if (checkHeaders->Checked)
  {
   int number_of_headers = what_to_save->Columns->Count;
   for (int k = 0; k <= number_of_headers; k++)
   {
    if (k)
     save_file << ",";
    save_file << "\"" << ReplaceStringWithString(what_to_save->Columns->Items[k]->Caption.c_str(), "\"", "\"\"");
    save_file << "\"\n";
   }
  }

  // data
  int number_of_lines = what_to_save->Items->Count;
  for (int i = 0; i < number_of_lines; i++)
  {
   TListItem * one_line = what_to_save->Items->Item[i];
   save_file << "\"" << ReplaceStringWithString(one_line->Caption.c_str(), "\"", "\"\"");
   save_file << "\"";
   int number_of_subitems = one_line->SubItems->Count;
   // no longer save 'id' by default, must make it visible with special internal_id permission
   for (int j = 0; j < number_of_subitems - 1; j++)
   {
    save_file << ",\"" << ReplaceStringWithString(one_line->SubItems->Strings[j].c_str(), "\"", "\"\"");
    save_file << "\"";
   }
   save_file << endl;
  }
  save_file.close();
 }
 else
  PSay("Cannot save file, file cannot be opened for writing.", m_program_error, MB_OK);

 buttonSave->Enabled = true;
 buttonCancel->Enabled = true;
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSaveListView::buttonCancelClick(
      TObject *Sender)
{
 // go away
 Close();
}
//---------------------------------------------------------------------------
