//---------------------------------------------------------------------------

#include <vcl.h>
#include <Printers.hpp>
#pragma hdrstop

#include "codeSpecialSchedule2.h"
#include "codeRecordToDo.h"
#include "codeSearchTaxEntity.h"
#include "codeRecordAppointment.h"
#include "codeSpecialSelectGroups.h"
#include "launchAppointmentReport.h"
#include "reportDaySchedule.h"
#include "codePrometheus.h"
#include <Printers.hpp>
#include "derivedheaders.h"
extern TformSpecialSchedule2 * scheduling_window;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformSpecialSchedule2 *formSpecialSchedule2;
//---------------------------------------------------------------------------
__fastcall TformSpecialSchedule2::TformSpecialSchedule2(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  this->IconIndex = 25;

  string g2u_sql = "select groups.id group_id, users.id user_id, groups.item group_name, users.item user_name, "
                   " groups.valid, users.valid, groups.has_appointments group_has_appt, users.has_appointments u_has_appt "
                   "from groups inner join users on users.group_id = groups.id "
                   "order by groups.id, users.id ";
  SqlToVecMap(dbDatabase, g2u_sql, groups_to_users);

  dateJumpTo->Date = Now();
  /* // these aren't needed anymore
  if((optionsPermissions["special.diab.general"]["enabled"] != "true") &&
     (optionsPermissions["special.den.general"]["enabled"] != "true"))
     menuLocationBlock->Visible = false;

  if((optionsPermissions["special.diab.general"]["enabled"] != "true") &&
     (optionsPermissions["special.lac.general"]["enabled"] != "true"))
     menuReasonBlock->Visible = false;
  */

  hide_inactive_groups = (optionsPreferences["schedule"]["hide_inactive_groups"] == "") ? true :
                          (bool)StringToInt(optionsPreferences["schedule"]["hide_inactive_groups"]);
  menuHideInactiveGroups->Checked = hide_inactive_groups;
  show_inactive_users = (optionsPreferences["schedule"]["show_inactive_users"] == "") ? true :
                         (bool)StringToInt(optionsPreferences["schedule"]["show_inactive_users"]);
  menuShowInactiveUsers->Checked = show_inactive_users;

  // jhaley 20100820: support for hiding the clock icons
  checkShowClocks->Checked = (optionsPreferences["schedule"]["show_clock_icons"] == "") ? true :
                              (bool)StringToInt(optionsPreferences["schedule"]["show_clock_icons"]);

  pageOptions->ActivePageIndex = 0;
  FillListViews();
  // set up filter for todo list view
  todo_sql = "select priority_types.item, todo_status_types.item, todo.due_date, "
        "todo.item, todo.current_id, todo.id from todo, priority_types, todo_status_types "
        "where todo.user_id = " + current_userid + " and "
        "todo.todo_status_id = todo_status_types.id and "
        "todo.priority_id = priority_types.id ";
  string temp_sql = todo_sql;
  if(optionsPreferences["schedule"]["todo_view"] == "completed")
  {
    menuViewCompleted->Checked = true;
    temp_sql += "and todo.todo_status_id = " + lookupTables->IdOf("todo_status_types", "Complete");
  }
  else if(optionsPreferences["schedule"]["todo_view"] == "all")
    menuViewAll->Checked = true;
  else
  {
    menuViewIncomplete->Checked = true;
    temp_sql += "and todo.todo_status_id != " + lookupTables->IdOf("todo_status_types", "Complete");
  }

  temp_sql += " order by priority_id ascending, todo.last_update_stamp ascending";
  todo_filter.SetListViewHandle (listToDo);
  todo_filter.SetSecurity("todo");
  todo_filter.AddColumnSpec("Priority", "todo", as_text, true, 80, prettyString);
  todo_filter.AddColumnSpec("Status", "todo", as_text, true, 80, prettyString);
  todo_filter.AddColumnSpec("Due Date", "todo", as_date, true, 80, prettyString);
  todo_filter.AddColumnSpec("Item", "todo", as_text, true, 320, sentenceString);
  todo_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  todo_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  todo_filter.FetchPreferences("specialschedule2.todo_filter");
  todo_filter.SetIconStatus(false);
  todo_filter.SetSQLStatement (temp_sql);
  todo_filter.RefreshDataSet();
  todo_filter.SetAddEdit(this, AddRecord(&(TformSpecialSchedule2::AddToDoItem)),
                         EditRecord(&(TformSpecialSchedule2::EditToDoItem)));
  todo_request = atlas->RequestNotificationWhen("todo.user_id", current_userid, rel_e, as_int, this,
                         RefreshHandler(&(TformSpecialSchedule2::AtlasRefreshUser)));

  if(optionsPreferences["schedule"]["calendar_view"] == "week_calendar")
  {
    menuWeek->Checked = true;
    current_calendar_view = week_calendar;
  }
  else if(optionsPreferences["schedule"]["calendar_view"] == "month_calendar")
  {
    menuMonth->Checked = true;
    current_calendar_view = month_calendar;
  }
  else if(optionsPreferences["schedule"]["calendar_view"] == "year_calendar")
  {
    menuYear->Checked = true;
    current_calendar_view = year_calendar;
  }
  else if(optionsPreferences["schedule"]["calendar_view"] == "block_day_calendar")
  {
    menuDayBlock->Checked = true;
    current_calendar_view = block_day_calendar;
  }
  else if(optionsPreferences["schedule"]["calendar_view"] == "block_location_calendar")
  {
    menuLocationBlock->Checked = true;
    current_calendar_view = block_location_calendar;
  }
  else if(optionsPreferences["schedule"]["calendar_view"] == "block_reason_calendar")
  {
    menuReasonBlock->Checked = true;
    current_calendar_view = block_reason_calendar;
  }
  else if(optionsPreferences["schedule"]["calendar_view"] == "block_userpos_calendar")
  {
    menuReasonBlock->Checked = true;
    current_calendar_view = block_userpos_calendar;
  }
  else if(optionsPreferences["schedule"]["calendar_view"] == "block_outcome_calendar")
  {
    menuLocationBlock->Checked = true;
    current_calendar_view = block_outcome_calendar;
  }
  else if(optionsPreferences["schedule"]["calendar_view"] == "block_provider_calendar")
  {
    menuProviderBlock->Checked = true;
    current_calendar_view = block_provider_calendar;
  }
  else if(optionsPreferences["schedule"]["calendar_view"] == "block_week_calendar")
  {
    menuWeekBlock->Checked = true;
    current_calendar_view = block_week_calendar;
  }
  else
  {
    menuDay->Checked = true;
    current_calendar_view = day_calendar;
  }
  CalendarViewChanged();

  string temp_tax_entity_id;
  if(optionsPreferences["schedule"]["radio_checked"] == "tax_entity")
  {
    radioProvider->Checked = true;
    temp_tax_entity_id = optionsPreferences["schedule"]["tax_entity_id"];
    listGroups->Enabled = false;
    listUsers->Enabled = false;
  }
  else
  {
    temp_tax_entity_id = "";
    radioUsers->Checked = true;
    string group_id_string = optionsPreferences["schedule"]["group_id_string"];
    CheckItems(group_id_string, listGroups);
    string user_id_string = optionsPreferences["schedule"]["user_id_string"];
    /*
    // deserialize, merge, serialize again
    set<string> group_ids, user_ids;
    SplitStringToSet(group_id_string, ", ", group_ids);
    SplitStringToSet(user_id_string, ", ", user_ids);
    for (unsigned int i=0; i<groups_to_users.size(); i++)
      if (group_ids.find(groups_to_users[i]["group_id"]) != group_ids.end())
        user_ids.insert(groups_to_users[i]["user_id"]);
    user_id_string = SetToCommaString(user_ids);
    // and continue..
    */
    if(user_id_string == "")
      user_id_string = current_userid;
    listUsers->OnChange = NULL;
    CheckItems(user_id_string, listUsers);
    listUsers->OnChange = listUsersChange;
    txtProvider->Enabled = false;
    btnProviderSearch->Enabled = false;
  }

  string outcome_id_string = optionsPreferences["schedule"]["outcome_id_string"];
  if(outcome_id_string == "")
  {
    outcome_id_string = "0," + lookupTables->IdOf("visit_outcome_types", "As Scheduled") + ","
                             + lookupTables->IdOf("visit_outcome_types", "Walk-In") + ","
                             + lookupTables->IdOf("visit_outcome_types", "Arrived Late");
  }
  CheckItems(outcome_id_string, listOutcome);
  string current_id_string = optionsPreferences["schedule"]["current_id_string"];
  if(current_id_string == "")
    current_id_string = "3, 4, 5";
  CheckItems(current_id_string, listCurrentTypes);


  CreateLink(txtProvider, btnProviderSearch, this, temp_tax_entity_id, "tax_entities");
  if(optionsPermissions["table.tax_entities"]["view"] != "true")
  {
    radioProvider->Enabled = false;
    txtProvider->Enabled = false;
    btnProviderSearch->Enabled = false;
  }

  previous_checked_groups = GetCheckedIdVec(listGroups);
  previous_checked_users = GetCheckedIdVec(listUsers);
  previous_checked_outcomes = GetCheckedIdVec(listOutcome);
  previous_checked_current_types = GetCheckedIdVec(listCurrentTypes);

  checked_groups_state = VecToSet(GetCheckedIdVec(listGroups));
  checked_users_state = VecToSet(GetCheckedIdVec(listUsers));

  previous_tax_id = temp_tax_entity_id;
  if(radioUsers->Checked)
    previous_radio_checked = 0;
  else
    previous_radio_checked = 1;

  current_date = CurrentPdate();
  DownloadUserColors();
  paintCalendar->Width = scrollCalendar->Width;
  txtNext->Left = scrollCalendar->Width - txtNext->Width - 5;
  schedule_class = NULL;
  schedule_class = new classScheduling(paintCalendar->Canvas, paintCalendar->Width, paintCalendar->Height,
                                       CurrentPdate(), CurrentPdate(), user_color_map, 1.0, 9, false, checkShowClocks->Checked);
  txtNext->Color = schedule_class->GetTitleBarColor();
  txtPrevious->Color = schedule_class->GetTitleBarColor();

  SetUpAtlasRequests(previous_checked_users);
  DownloadAppointmentsFromDatabase();

  if(optionsPreferences["schedule"]["last_page_viewed"] == "todo")
    sheetToDo->Show();
  else
    if(pageViewArea->ActivePage != sheetCalendar)
      sheetCalendar->Show();
  scheduling_window = this;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::FormClose(TObject *Sender, TCloseAction &Action)
{
  scheduling_window = NULL;
  if (current_calendar_view == block_outcome_calendar)
    menuCalendarClick(menuDay); // can't exit in Block by Outcome view; switch to Day view

  if(menuViewIncomplete->Checked)
    optionsPreferences["schedule"]["todo_view"] = "incomplete";
  else if(menuViewCompleted->Checked)
    optionsPreferences["schedule"]["todo_view"] = "completed";
  else if(menuViewAll->Checked)
    optionsPreferences["schedule"]["todo_view"] = "all";

  optionsPreferences["schedule"]["show_inactive_users"] = IntToString(BoolToInt(show_inactive_users));
  optionsPreferences["schedule"]["hide_inactive_groups"] = IntToString(BoolToInt(hide_inactive_groups));

  // jhaley 20100820: store option for showing clocks
  optionsPreferences["schedule"]["show_clock_icons"] = IntToString(BoolToInt(checkShowClocks->Checked));

  if(pageViewArea->ActivePage == sheetCalendar)
    optionsPreferences["schedule"]["last_page_viewed"] = "calendar";
  else if(pageViewArea->ActivePage == sheetToDo)
    optionsPreferences["schedule"]["last_page_viewed"] = "todo";

  if(current_calendar_view == day_calendar)
    optionsPreferences["schedule"]["calendar_view"] = "day_calendar";
  else if(current_calendar_view == week_calendar)
    optionsPreferences["schedule"]["calendar_view"] = "week_calendar";
  else if(current_calendar_view == month_calendar)
    optionsPreferences["schedule"]["calendar_view"] = "month_calendar";
  else if(current_calendar_view == year_calendar)
    optionsPreferences["schedule"]["calendar_view"] = "year_calendar";
  else if(current_calendar_view == block_day_calendar)
    optionsPreferences["schedule"]["calendar_view"] = "block_day_calendar";
  else if(current_calendar_view == block_location_calendar)
    optionsPreferences["schedule"]["calendar_view"] = "block_location_calendar";
  else if(current_calendar_view == block_reason_calendar)
    optionsPreferences["schedule"]["calendar_view"] = "block_reason_calendar";
  else if(current_calendar_view == block_userpos_calendar)
    optionsPreferences["schedule"]["calendar_view"] = "block_userpos_calendar";
  else if(current_calendar_view == block_outcome_calendar)
    optionsPreferences["schedule"]["calendar_view"] = "block_outcome_calendar";
  else if(current_calendar_view == block_provider_calendar)
    optionsPreferences["schedule"]["calendar_view"] = "block_provider_calendar";
  else if(current_calendar_view == block_week_calendar)
    optionsPreferences["schedule"]["calendar_view"] = "block_week_calendar";

  if(radioProvider->Checked)
  {
    optionsPreferences["schedule"]["radio_checked"] = "tax_entity";
    optionsPreferences["schedule"]["tax_entity_id"] = GetValidLinkId(txtProvider);
  }
  else
  {
    optionsPreferences["schedule"]["radio_checked"] = "users";
    optionsPreferences["schedule"]["group_id_string"] = GetCheckedIdString(listGroups);
    optionsPreferences["schedule"]["user_id_string"] = GetCheckedIdString(listUsers);
  }

  optionsPreferences["schedule"]["outcome_id_string"] = GetCheckedIdString(listOutcome);
  optionsPreferences["schedule"]["current_id_string"] = GetCheckedIdString(listCurrentTypes);


  if(schedule_class)
    delete schedule_class;
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::FillListViews(bool just_groups_and_users)
{
  TIBTransaction *dbTransaction = new TIBTransaction(NULL);
  dbTransaction->DefaultDatabase = dbDatabase;
  dbTransaction->StartTransaction();

  string sql;
  TListItem *row;
  vector<map<string, string> > result_map;

  listGroups->OnChange = NULL;
  listUsers->OnChange = NULL;

  sql = "select item, id from groups where has_appointments = 1 and id > 0 ";
  if (hide_inactive_groups)
    sql += " and valid = 1 ";
  sql += "order by item";
  SqlToVecMap(dbTransaction, sql, result_map);
  listGroups->Items->Clear();
  for(vector<map<string, string> >::iterator itr = result_map.begin(); itr != result_map.end(); itr++)
  {
    row = listGroups->Items->Add();
    row->Caption = PrettyString((*itr)["item"]).c_str();
    row->SubItems->Add((*itr)["id"].c_str());
  }

  sql = "select item, id from users where has_appointments = 1 and id > 0 ";
  if (!show_inactive_users)
    sql += " and (valid = 1 or is_role = 1) ";
  sql += "order by item";
  SqlToVecMap(dbTransaction, sql, result_map);
  listUsers->Items->Clear();
  for(vector<map<string, string> >::iterator itr = result_map.begin(); itr != result_map.end(); itr++)
  {
    row = listUsers->Items->Add();
    row->Caption = PrettyString((*itr)["item"]).c_str();
    row->SubItems->Add((*itr)["id"].c_str());
  }

  listGroups->OnChange = listGroupsChange;
  listUsers->OnChange = listUsersChange;

  if (!just_groups_and_users)
  {
    sql = "select visit_outcome_types.item, visit_outcome_types.id from visit_outcome_types "
          "where visit_outcome_types.valid = 1 order by visit_outcome_types.item";
    SqlToVecMap(dbTransaction, sql, result_map);
    listOutcome->Items->Clear();
    for(vector<map<string, string> >::iterator itr = result_map.begin(); itr != result_map.end(); itr++)
    {
      row = listOutcome->Items->Add();
      row->Caption = PrettyString((*itr)["item"]).c_str();
      row->SubItems->Add((*itr)["id"].c_str());
    }

    sql = "select current_types.item, current_types.id from current_types "
          "order by current_types.id";
    SqlToVecMap(dbTransaction, sql, result_map);
    listCurrentTypes->Items->Clear();
    for(vector<map<string, string> >::iterator itr = result_map.begin(); itr != result_map.end(); itr++)
    {
      row = listCurrentTypes->Items->Add();
      row->Caption = PrettyString((*itr)["item"]).c_str();
      row->SubItems->Add((*itr)["id"].c_str());
    }
  }
  dbTransaction->Commit();
  delete dbTransaction;
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::CheckItems(string id_string, TListView *list_view, bool flip_to)
{
  set<string> id_set;
  SplitStringToSet(id_string, ", ", id_set);
  int row_count = list_view->Items->Count;
  string current_id;
  for(int i = 0; i < row_count; i++)
  {
    current_id = list_view->Items->Item[i]->SubItems->Strings[0].c_str();
    if(id_set.find(current_id) != id_set.end())
      list_view->Items->Item[i]->Checked = flip_to;
  }
}
//---------------------------------------------------------------------------
string TformSpecialSchedule2::GetCheckedIdString(TListView *list_view)
{
  int row_count = list_view->Items->Count;
  vector<string> id_vec;
  for(int i = 0; i < row_count; i++)
  {
    if(list_view->Items->Item[i]->Checked)
      id_vec.push_back(list_view->Items->Item[i]->SubItems->Strings[0].c_str());
  }
  if(! id_vec.empty())
    return VecToCommaString(id_vec);
  else
    return "";
}
//---------------------------------------------------------------------------
vector<string> TformSpecialSchedule2::GetCheckedIdVec(TListView *list_view)
{
  int row_count = list_view->Items->Count;
  vector<string> id_vec;
  for(int i = 0; i < row_count; i++)
  {
    if(list_view->Items->Item[i]->Checked)
      id_vec.push_back(list_view->Items->Item[i]->SubItems->Strings[0].c_str());
  }
  return id_vec;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::btnCalendarClick(TObject *Sender)
{
  sheetCalendar->Show();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::btnToDoClick(TObject *Sender)
{
  sheetToDo->Show();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuCalendarClick(TObject *Sender)
{
  UncheckAllItems(popupCalendar);
  ((TMenuItem *)Sender)->Checked = true;

  if(Sender == menuDay)
    current_calendar_view = day_calendar;
  else if(Sender == menuWeek)
    current_calendar_view = week_calendar;
  else if(Sender == menuMonth)
    current_calendar_view = month_calendar;
  else if(Sender == menuYear)
    current_calendar_view = year_calendar;
  else if(Sender == menuDayBlock)
    current_calendar_view = block_day_calendar;
  else if(Sender == menuLocationBlock)
    current_calendar_view = block_location_calendar;
  else if(Sender == menuReasonBlock)
    current_calendar_view = block_reason_calendar;
  else if(Sender == menuUserPosBlock)
    current_calendar_view = block_userpos_calendar;
  else if(Sender == menuOutcomeBlock)
    current_calendar_view = block_outcome_calendar;
  else if(Sender == menuProviderBlock)
    current_calendar_view = block_provider_calendar;
  else if(Sender == menuWeekBlock)
    current_calendar_view = block_week_calendar;
  DownloadIfDatesChanged();
  CalendarViewChanged();
  FormResize(NULL);

  if(pageViewArea->ActivePage == sheetCalendar)
    paintCalendarPaint(NULL);
  else
    sheetCalendar->Show();
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::CalendarViewChanged()
{
  vector<string> current_outcomes_state = GetCheckedIdVec(listOutcome);
  if (current_calendar_view == block_outcome_calendar && previous_calendar_view != block_outcome_calendar)
  { // save outcomes currently checked, then check them all (default for block view by outcomes)
    saved_outcomes_state = current_outcomes_state;
    menuCheckAllAppointmentTypesClick(NULL);
    DownloadIfNecessary();
    DrawCalendar(schedule_class);
  }
  else if (current_calendar_view != block_outcome_calendar && previous_calendar_view == block_outcome_calendar)
  { // restore previous state
    menuUncheckAllAppointmentTypesClick(NULL);
    CheckItems(VecToCommaString(saved_outcomes_state), listOutcome);
    DownloadIfNecessary();
    DrawCalendar(schedule_class);
  }
  previous_calendar_view = current_calendar_view;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuViewIncompleteClick(TObject *Sender)
{
  UncheckAllItems(popupToDo);
  ((TMenuItem *)Sender)->Checked = true;
  sheetToDo->Show();
  string temp_sql = todo_sql;
  if(menuViewIncomplete->Checked)
   temp_sql += "and todo.todo_status_id != " + lookupTables->IdOf("todo_status_types", "Complete") +
               " order by priority_id ascending, todo.last_update_stamp ascending";
  else if(menuViewCompleted->Checked)
   temp_sql += "and todo.todo_status_id = " + lookupTables->IdOf("todo_status_types", "Complete") +
               " order by priority_id ascending, todo.last_update_stamp ascending";
  else
   temp_sql += "order by priority_id ascending, todo.last_update_stamp ascending";
  todo_filter.SetSQLStatement(temp_sql);
  todo_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::popupCalendarPopup(TObject *Sender)
{
  btnCalendar->Down = false;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::popupToDoPopup(TObject *Sender)
{
  btnToDo->Down = false;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::paintCalendarPaint(TObject *Sender)
{
  DrawCalendar(schedule_class);
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::UncheckAllItems(TPopupMenu *popup_menu)
{
  int item_count = popup_menu->Items->Count;
  for(int i = 0; i < item_count; i++)
    popup_menu->Items->Items[i]->Checked = false;
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::DrawCalendar(classScheduling *class_to_use, bool to_printer)
{
  // jhaley: 20100820: try it here...
  if(checkShowClocks->Checked != class_to_use->GetShowClockIcons())
    class_to_use->SetShowClockIcons(checkShowClocks->Checked);

  if(current_calendar_view == day_calendar)
    class_to_use->DrawDayCalendar(all_appointments);
  else if(current_calendar_view == week_calendar)
    class_to_use->DrawWeekCalendar(all_appointments);
  else if(current_calendar_view == month_calendar)
    class_to_use->DrawMonthCalendar(all_appointments);
  else if(current_calendar_view == year_calendar)
  {
    if(to_printer)
      class_to_use->DrawYearCalendar(clWhite);
    else
      class_to_use->DrawYearCalendar(clBtnFace);
  }
  else if(current_calendar_view == block_day_calendar)
    class_to_use->DrawBlockDayCalendar(all_appointments);
  else if(current_calendar_view == block_location_calendar)
    class_to_use->DrawBlockLocationCalendar(all_appointments);
  else if(current_calendar_view == block_reason_calendar)
    class_to_use->DrawBlockReasonCalendar(all_appointments);
  else if(current_calendar_view == block_userpos_calendar)
    class_to_use->DrawBlockUserPosCalendar(all_appointments);
  else if(current_calendar_view == block_outcome_calendar)
    class_to_use->DrawBlockOutcomeCalendar(all_appointments);
  else if(current_calendar_view == block_provider_calendar)
    class_to_use->DrawBlockProviderCalendar(all_appointments);
  else if(current_calendar_view == block_week_calendar)
    class_to_use->DrawBlockWeekCalendar(all_appointments);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::FormResize(TObject *Sender)
{
  if (!scheduling_window)
    return;

  try
  {
    int height_needed;
    if(current_calendar_view == day_calendar || current_calendar_view == week_calendar ||
       current_calendar_view == block_day_calendar || current_calendar_view == block_location_calendar ||
       current_calendar_view == block_reason_calendar || current_calendar_view == block_outcome_calendar ||
       current_calendar_view == block_provider_calendar || current_calendar_view == block_week_calendar ||
       current_calendar_view == block_userpos_calendar)
    {
      height_needed = schedule_class->GetHeightNeeded(all_appointments, current_calendar_view);
      if(height_needed > scrollCalendar->Height)
      {
        paintCalendar->Height = height_needed;
        schedule_class->SetCanvasDimensions(paintCalendar->Width, height_needed);
      }
      else
      {
        paintCalendar->Height = scrollCalendar->Height;
        schedule_class->SetCanvasDimensions(paintCalendar->Width, paintCalendar->Height);
      }
    }
    else
    {
      paintCalendar->Height = scrollCalendar->Height;
      schedule_class->SetCanvasDimensions(paintCalendar->Width, paintCalendar->Height);
    }
  }
  catch(...)
  {
  }
  TformSpecialGeneric::FormResize(Sender);
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::AtlasRefreshUser(int request_num, string matched_value)
{
  // jhaley 20110901: suspect Atlas refresh recursion may be behind a rash of problems with the scheduler, because
  // it uses ShowTaskModal for launching several child forms...
  if(!IsAtlasReady())
    return;

  if(request_num == todo_request)
    todo_filter.RefreshDataSet();
  else if(atlas_request_set.find(request_num) != atlas_request_set.end())
  {
    //PSay(matched_value, m_message, MB_OK);
    for (unsigned int i=0; i<groups_to_users.size(); i++)
    {
      if (groups_to_users[i]["user_id"] == matched_value)
      { // if the user doesn't have appointments, then they're not going to show up on the scheduler; let's fix that
        if (IsBlankOrZero(groups_to_users[i]["has_appointments"]))
        {
          if (panelBig->Visible) // if they've already got the settings panel open, we need do very little
            FreshenUsersAndGroups();
          else // otherwise, we need to -make- it visible in order to access the controls that are on it...
          {
            // try to be as non-intrusive as we can because I don't see an easy way to hide the graphical blip of the
            // sidebar popping out and back in
            int w = panelBig->Width;
            panelBig->Width = panelTiny->Width;
            btnShowBiggerClick(NULL);
            FreshenUsersAndGroups();
            btnShowTinyClick(NULL);
            panelBig->Width = w;
          }
        }
        break;
      }
    }
    DownloadAppointmentsFromDatabase();
    DrawCalendar(schedule_class);
  }
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::AtlasRefreshTaxEntity(int request_num, string matched_value)
{
  // jhaley 20110901: suspect Atlas refresh recursion may be behind a rash of problems with the scheduler, because
  // it uses ShowTaskModal for launching several child forms...
  if(!IsAtlasReady())
    return;

  /*if(request_num == todo_request)
    todo_filter.RefreshDataSet();
  else*/ // can't get here from there.
  if(atlas_request_set.find(request_num) != atlas_request_set.end())
  {
    DownloadAppointmentsFromDatabase();
    DrawCalendar(schedule_class);
  }
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::AddToDoItem()
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  FORM_TRY
    TformRecordToDo *todo_record = new TformRecordToDo(NULL, temp_map);
    todo_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::EditToDoItem()
{
  map<string, string> temp_map;
  temp_map["id"] = todo_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordToDo *todo_record = new TformRecordToDo(NULL, temp_map);
    todo_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuGoToTodayClick(TObject *Sender)
{
  current_date = CurrentPdate();
  schedule_class->SetCurrentDate(current_date);
  DrawCalendar(schedule_class);        
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::txtPreviousClick(TObject *Sender)
{
  GoToPrevious();
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::ChangeCurrentDate(int amount_to_change)
{
  if(current_calendar_view == day_calendar || current_calendar_view == block_day_calendar ||
     current_calendar_view == block_location_calendar || current_calendar_view == block_outcome_calendar ||
     current_calendar_view == block_provider_calendar || current_calendar_view == block_reason_calendar ||
     current_calendar_view == block_userpos_calendar)
    current_date.mod(amount_to_change, in_days);
  else if((current_calendar_view == week_calendar) || (current_calendar_view == block_week_calendar))
    current_date.mod(amount_to_change, in_weeks);
  else if(current_calendar_view == month_calendar)
    current_date.mod(amount_to_change, in_months);
  else if(current_calendar_view == year_calendar)
    current_date.mod(amount_to_change, in_years);
  dateJumpTo->DateTime = current_date.OutDate();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::txtNextClick(TObject *Sender)
{
  GoToNext();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::btnShowTinyClick(TObject *Sender)
{
  scrollCalendar->Enabled = true;
  panelBig->Visible = false;
  panelTiny->Visible = true;
  panelTiny->Height = sheetCalendar->Height;
  DownloadIfNecessary();
  DrawCalendar(schedule_class);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::btnShowBiggerClick(TObject *Sender)
{
  scrollCalendar->Enabled = false;
  panelBig->Visible = true;
  panelBig->Height = sheetCalendar->Height;
  panelTiny->Visible = false;
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::DownloadAppointmentsFromDatabase()
{
  if(current_calendar_view != year_calendar)
  {
    Screen->Cursor = crHourGlass;
    vector<string> user_ids;
    if(radioUsers->Checked)
      user_ids = GetCheckedIdVec(listUsers);
    set<string> can_see_charts = GetSpecialGroupPermissions("charts");
    string chart_loc_sql =
      "select first 1 chart_location_id from groups where has_charts = 1 and chart_location_id > 0 and "
       + SafeInClause("id", SetToVec(can_see_charts));
    string chart_location = GetOneField(dbDatabase, chart_loc_sql);
    bool show_chart = chart_location != "";
    /*
    if(optionsPermissions["special.lac.charts"]["enabled"] == "true")
    {
      show_chart = true;
      chart_location = lookupTables->IdOf("groups", "Little Axe Clinic");
    }
    if(optionsPermissions["special.sc.charts"]["enabled"] == "true")
    {
      show_chart = true;
      chart_location = lookupTables->IdOf("groups", "Shawnee Clinic");
    }
    if(optionsPermissions["special.den.charts"]["enabled"] == "true")
    {
      show_chart = true;
      //chart_location = lookupTables->IdOf("groups", "Dental Clinic");
      chart_location = lookupTables->IdOf("groups", "Little Axe Clinic");
    }
    */
    schedule_class->GetBeginEndDates(begin_download_date, end_download_date, current_calendar_view);
    map<string, vector<string> > ids_to_match;
    ids_to_match["visit_outcome_id"] = GetCheckedIdVec(listOutcome);
    ids_to_match["current_id"] = GetCheckedIdVec(listCurrentTypes);
    DownloadAppointments(dbDatabase, begin_download_date, end_download_date, current_userid, user_ids, vector<string>(), GetValidLinkId(txtProvider),
                         all_appointments, ids_to_match, (optionsPermissions["admin.all_appointments"]["enabled"] == "true"),
                         show_chart, "" /*chart_location*/);
    Screen->Cursor = crDefault;
  }
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::DownloadUserColors()
{
  map<string, string> temp_map;
  string sql = "select users.id, users.user_color from users"; // where users.valid = 1 and users.id > 0";
  SqlToValueMap(dbDatabase, sql, temp_map);
  for(map<string, string>::iterator itr = temp_map.begin(); itr != temp_map.end(); itr++)
    user_color_map[itr->first] = (TColor)StringToInt(itr->second);
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::SetUpAtlasRequests(vector<string> incoming)
{
  for(set<int>::iterator itr = atlas_request_set.begin(); itr != atlas_request_set.end(); itr++)
    atlas->CancelRequest(*itr);
  atlas_request_set.clear();
  if(radioUsers->Checked)
  {
    // take the users that are checked, and add to that list ALL OTHER users in the DEPARTMENTS
    // that are checked ... that way users that don't has_appointments will be included in the set
    // of appointments we're listening for, in case they ever START having appts created for them...
    set<string> group_ids, user_ids;
    user_ids = VecToSet(incoming);
    group_ids = VecToSet(GetCheckedIdVec(listGroups));
    for (unsigned int i=0; i<groups_to_users.size(); i++)
      if (group_ids.find(groups_to_users[i]["group_id"]) != group_ids.end() || IsBlankOrZero(groups_to_users[i]["user_has_appt"]))
        user_ids.insert(groups_to_users[i]["user_id"]);

    for(set<string>::iterator itr = user_ids.begin(); itr != user_ids.end(); itr++)
      atlas_request_set.insert(atlas->RequestNotificationWhen("appointments.created_for", (*itr), rel_e, as_int, this,
                               RefreshHandler(&(TformSpecialSchedule2::AtlasRefreshUser))));
  }
  else
    atlas_request_set.insert(atlas->RequestNotificationWhen("appointments.tax_entity_id", GetValidLinkId(txtProvider), rel_e, as_int, this,
                             RefreshHandler(&(TformSpecialSchedule2::AtlasRefreshTaxEntity))));
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::DownloadIfNecessary()
{
  bool must_download = false;
  bool must_redo_atlas = false;
  vector<string> checked_users = GetCheckedIdVec(listUsers);
  if(radioUsers->Checked)
  {
    if(previous_radio_checked == 1)
    {
      must_download = true;
      must_redo_atlas = true;
    }
    else if(checked_users != previous_checked_users) // if they changed groups, users would automatically
    {                            // change to reflect that, so that would be caught here too, right?  right.
      must_download = true;
      must_redo_atlas = true;
    }
  }
  else
  {
    if(previous_radio_checked == 0)
    {
      must_download = true;
      must_redo_atlas = true;
    }
    else if(GetValidLinkId(txtProvider) != previous_tax_id)
    {
      must_download = true;
      must_redo_atlas = true;
    }
  }

  vector<string> checked_outcomes = GetCheckedIdVec(listOutcome);
  if(checked_outcomes != previous_checked_outcomes)
    must_download = true;
  previous_checked_outcomes = checked_outcomes;
  vector<string> checked_current_types = GetCheckedIdVec(listCurrentTypes);
  if(checked_current_types != previous_checked_current_types)
    must_download = true;
  previous_checked_current_types = checked_current_types;

  if(radioUsers->Checked)
  {
    previous_radio_checked = 0;
    previous_checked_users = checked_users;
    previous_tax_id = "";
  }
  else
  {
    previous_radio_checked = 1;
    previous_checked_users.clear();
    previous_tax_id = GetValidLinkId(txtProvider);
  }
  if(must_download)
  {
    DownloadAppointmentsFromDatabase();
    if(must_redo_atlas)
      SetUpAtlasRequests(checked_users);
  }
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::DownloadIfDatesChanged()
{
  Pdate begin_date_shown;
  Pdate end_date_shown;
  schedule_class->GetBeginEndDates(begin_date_shown, end_date_shown, current_calendar_view);
  range<Pdate> shown_range = range<Pdate> (begin_date_shown, end_date_shown);
  range<Pdate> downloaded_range = range<Pdate> (begin_download_date, end_download_date);
  if(! downloaded_range.EncompassEq(shown_range))
    DownloadAppointmentsFromDatabase();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::btnProviderSearchClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchTaxEntity * providerSearch = new TformSearchTaxEntity(NULL,&return_vector);
    providerSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtProvider, btnProviderSearch, this, return_vector[0], "tax_entities");
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::radioUsersClick(TObject *Sender)
{
  if(radioUsers->Checked)
  {
    txtProvider->Enabled = false;
    btnProviderSearch->Enabled = false;
    listGroups->Enabled = true;
    listUsers->Enabled = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::radioProviderClick(TObject *Sender)
{
  if(radioProvider->Checked)
  {
    listGroups->Enabled = false;
    listUsers->Enabled = false;
    txtProvider->Enabled = true;
    btnProviderSearch->Enabled = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::paintCalendarMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if(Button == mbLeft)
  {
    if (!timerStopClickStupidity->Enabled) // if the timer's going, click stupidity isn't.
    {
      timerStopClickStupidity->Enabled = true; // prevent them double clicking things they shouldn't
      string id = schedule_class->GetAppointmentIdAtPosition(X, Y);
      if(id != "")
      {
        map<string, string> temp_map;
        temp_map["id"] = id;
        FORM_TRY
          TformRecordAppointment *appt_form = new TformRecordAppointment(NULL, temp_map);
          appt_form->Show();
        FORM_CATCH
      }
      else
      {
        bool one_found;
        Pstamp date_found;
        schedule_class->GetStampAtPosition(X, Y, one_found, date_found);
        if(one_found)
        {
          current_date = (Pdate)date_found;
          schedule_class->SetCurrentDate(current_date);
          current_calendar_view = day_calendar;
          UncheckAllItems(popupCalendar);
          menuDay->Checked = true;
          DownloadIfDatesChanged();
          FormResize(NULL);
          DrawCalendar(schedule_class);
        }
      }
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::paintCalendarMouseMove(
      TObject *Sender, TShiftState Shift, int X, int Y)
{
  cur_x_pos = X;
  cur_y_pos = Y;
  string id = schedule_class->GetAppointmentIdAtPosition(cur_x_pos, cur_y_pos);
  if(id != "")
    Screen->Cursor = crHandPoint;
  else
    Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuAddAppointmentClick(TObject *Sender)
{
  bool one_found;
  Pstamp stamp_found;
  string column_name;
  schedule_class->GetStampAtPosition(cur_x_pos, cur_y_pos, one_found, stamp_found, column_name);
  map<string, string> temp_map;
  temp_map["id"] = "new";
  if(one_found)
  {
    temp_map["display_date"] = stamp_found.OutDate(mdy | yyyy);
    temp_map["appointment_time"] = stamp_found.OutTime(military | withsec);
  }

  /* they've right clicked and selected Add Appointment.  We're going to look at what column
     the mouse is in and set fields appropriately; e.g., if they're in block by provider mode,
     then create an appointment with the same provider; if in block by reason mode, create an
     appointment with the same reason, etc.  It just seems polite, and potentially time-saving. */

  TformRecordAppointment *appt_form = NULL;
  FORM_TRY
    appt_form = new TformRecordAppointment(NULL, temp_map);
  FORM_CATCH_RETURN("TformRecordAppointment", )

  appt_form->Show();

  string location_dept = "";
  string reason_dept = ""; // matches logic in scheduling.cpp
  string userpos = "";
  string provider = "";
  if (optionsPermissions["special.diab.general"]["enabled"] == "true")
  {
    location_dept = "Diabetes";
    reason_dept = "Diabetes";
  }
  if (optionsPermissions["special.den.general"]["enabled"] == "true")
    location_dept = "Dental";
  if (optionsPermissions["special.lac.general"]["enabled"] == "true")
    reason_dept = "Medical";

  if(current_calendar_view == block_location_calendar)
  {
    if (location_dept == "Diabetes")
      appt_form->cboLocation->Text = column_name.c_str();
    else if (location_dept == "Dental")
      appt_form->cboLocation->Text = column_name.c_str();
  }
  else if(current_calendar_view == block_reason_calendar)
  {
    if (reason_dept == "Diabetes")
      appt_form->cboReason->Text = column_name.c_str();
    else if (reason_dept == "Medical")
    {
      // whose brilliant idea was it to concatenate fields?  oh, right.  mine.
      string item_sql =
        "select item "
        "from appt_reason_types "
        "where coalesce(cast(appt_reason_types.ordinal as varchar(10)) || ' - ' || appt_reason_types.item, '') = '"
        + column_name + "'";
      string item = GetOneField(dbDatabase, item_sql);
      appt_form->cboReason->Text = item.c_str();
    }
  }
  else if(current_calendar_view == block_provider_calendar)
  {
    vector<map<string, string> > provider_map;
    string sql = "select tax_entities.id tax_entity_id, users.id user_id, users.item user_name "
                 "from tax_entities "
                 "left join users on users.tax_entity_id = tax_entities.id "
                 "where tax_entities.name = '" + column_name + "' "
                 "order by users.item nulls last";
    /*
    TIBTransaction *dbTransaction = new TIBTransaction(NULL);
    StdTransaction(dbTransaction, dbDatabase);
    QueryData(this, dbTransaction, sql);
    */

    SqlToVecMap(dbDatabase, sql, provider_map); // we want tax entities that match a user first
    string local_tax_entity_id = "0";
    if (provider_map[0]["user_name"] != "")
    {
      appt_form->cboUser->Text = provider_map[0]["user_name"].c_str();
      appt_form->btnAddProvider->Click();
    }
    else
    {
      local_tax_entity_id = provider_map[0]["tax_entity_id"];
      CreateLink(appt_form->txtProvider, appt_form->btnProviderSearch, appt_form, local_tax_entity_id, "tax_entities");
    }
  }
  else if(current_calendar_view == block_userpos_calendar)
  {
    /* we can't automatically pick anything, since we don't know -which- provider to use, only the type.  I suppose
       we could pass in the provider type, and then the record form could restrict the created-for user combo box to
       just users of that type, but that also seems potentially confusing.  */
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::FormMouseWheelDown(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
  if(scrollCalendar->Visible)
    scrollCalendar->VertScrollBar->Position += scrollCalendar->VertScrollBar->Increment;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::FormMouseWheelUp(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
  if(scrollCalendar->Visible)
    scrollCalendar->VertScrollBar->Position -= scrollCalendar->VertScrollBar->Increment;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuAddByGroupsClick(TObject *Sender)
{
  /* this was from the popup menu that is no longer used...
  set<string> return_set;
  string id;
  FORM_TRY
    TformSpecialSelectGroups * select_group_form = new TformSpecialSelectGroups(NULL, &return_set, NULL);
    select_group_form->ShowTaskModal(this);
  FORM_CATCH
  if(! return_set.empty())
  {
    TListItem * row;
    for (int i = 0; i < listUsers->Items->Count; i++)
    {
      row = listUsers->Items->Item[i];
      id = row->SubItems->Strings[0].c_str();
      if (return_set.find(id) != return_set.end())
        row->Checked = true;
      else
        row->Checked = false;
    }
  }
  */
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuCheckAllUsersClick(TObject *Sender)
{
  for (int i = 0; i < listUsers->Items->Count; i++)
    listUsers->Items->Item[i]->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuUncheckAllUsersClick(TObject *Sender)
{
  for (int i = 0; i < listUsers->Items->Count; i++)
    listUsers->Items->Item[i]->Checked = false;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuCheckAllGroupsClick(TObject *Sender)
{
  for (int i = 0; i < listGroups->Items->Count; i++)
    listGroups->Items->Item[i]->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuUncheckAllGroupsClick(TObject *Sender)
{
  for (int i = 0; i < listGroups->Items->Count; i++)
    listGroups->Items->Item[i]->Checked = false;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuCheckAllAppointmentTypesClick(TObject *Sender)
{
  for (int i = 0; i < listOutcome->Items->Count; i++)
    listOutcome->Items->Item[i]->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuUncheckAllAppointmentTypesClick(TObject *Sender)
{
  for (int i = 0; i < listOutcome->Items->Count; i++)
    listOutcome->Items->Item[i]->Checked = false;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuCheckAllCurrentTypesClick(TObject *Sender)
{
  for (int i = 0; i < listCurrentTypes->Items->Count; i++)
    listCurrentTypes->Items->Item[i]->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuUncheckAllCurrentTypesClick(TObject *Sender)
{
  for (int i = 0; i < listCurrentTypes->Items->Count; i++)
    listCurrentTypes->Items->Item[i]->Checked = false;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::dateJumpToCloseUp(TObject *Sender)
{
  FocusAway();
  FocusBack();
  current_date = Pdate(dateJumpTo->Date);
  schedule_class->SetCurrentDate(current_date);
  DownloadIfDatesChanged();
  DrawCalendar(schedule_class);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::FormShortCut(TWMKey &Msg, bool &Handled)
{
  // CTRL, ALT, and SHIFT are all off
  if(!HIBYTE(GetAsyncKeyState(VK_CONTROL)) &&
     !HIBYTE(GetAsyncKeyState(VK_MENU)) &&
     !HIBYTE(GetAsyncKeyState(VK_SHIFT)))
  {
    Handled = true;
    if (panelTiny->Visible)
    { // these shortcuts should only work if they're NOT in the middle of changing settings.
      // menu item shortcuts
      if(Msg.CharCode == VK_F2)  menuDay->Click();
      else if(Msg.CharCode == VK_F3)  menuWeek->Click();
      else if(Msg.CharCode == VK_F4)  menuMonth->Click();
      else if(Msg.CharCode == VK_F5)  menuYear->Click();
      else if(Msg.CharCode == VK_F6  && menuLocationBlock->Visible)  menuLocationBlock->Click();
      else if(Msg.CharCode == VK_F7  && menuReasonBlock->Visible)    menuReasonBlock->Click();
      else if(Msg.CharCode == VK_F8  && menuOutcomeBlock->Visible)   menuOutcomeBlock->Click();
      else if(Msg.CharCode == VK_F9  && menuProviderBlock->Visible)  menuProviderBlock->Click();
      else if(Msg.CharCode == VK_F10 && menuUserPosBlock->Visible)   menuUserPosBlock->Click();
      else if(Msg.CharCode == VK_F11)  menuWeekBlock->Click();
      else if(Msg.CharCode == VK_F12) menuGoToToday->Click();

      else if(Msg.CharCode == VK_LEFT)  GoToPrevious();
      else if(Msg.CharCode == VK_RIGHT) GoToNext();

      else if((Msg.CharCode == VK_RETURN) && (dateJumpTo->Focused()))
      {
        FocusAway();
        FocusBack();
        current_date = Pdate(dateJumpTo->Date);
        schedule_class->SetCurrentDate(current_date);
        DownloadIfDatesChanged();
        DrawCalendar(schedule_class);
      }
      else
        Handled = false;
    }
  }
  else if(HIBYTE(GetAsyncKeyState(VK_CONTROL)))
  {
    Handled = true;
    if (panelTiny->Visible && (Msg.CharCode == 's' || Msg.CharCode == 'S')) // Settings
      btnShowBiggerClick(NULL);
    else if (panelBig->Visible && (Msg.CharCode == 's' || Msg.CharCode == 'S')) // Save (settings)
      btnShowTinyClick(NULL);
    else
      Handled = false;
  }
  else
    Handled = false;

  TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::GoToNext()
{
  ChangeCurrentDate(1);
  schedule_class->SetCurrentDate(current_date);
  DownloadIfDatesChanged();
  FormResize(NULL);
  DrawCalendar(schedule_class);
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::GoToPrevious()
{
  ChangeCurrentDate(-1);
  schedule_class->SetCurrentDate(current_date);
  DownloadIfDatesChanged();
  FormResize(NULL);
  DrawCalendar(schedule_class);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::timerStopClickStupidityTimer(TObject *Sender)
{
  /* When you double click the title bar to maximize the window, the MouseUp event
     triggers for the paintbox that is now, but was not before, under the mouse
     (because the title bar moved up, relative to the mouse).  So what happense is
     you double click the title bar and suddenly the scheduler ALSO switches to
     Day View because that's what clicking on a day (in the paintbox, but not on
     an appointment) does.  So ... let's try and prevent it... */

  timerStopClickStupidity->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::FormCanResize(TObject *Sender,
  int &NewWidth, int &NewHeight, bool &Resize)
{
  /* User's resizing.  Maybe maximizing, maybe not.  But they can't simultaneously
     be clicking on the paintbox, regardless.  Start the timer. */
  timerStopClickStupidity->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuPrintWhatYouSeeClick(TObject *Sender)
{
  if(pageViewArea->ActivePage == sheetCalendar)
  {
    Processing(true);
    if (dialogPrint->Execute())
    {
      TPrinter * printer_object = Printer();
      printer_object->Title = "Prometheus schedule";
      if((current_calendar_view == month_calendar) || (current_calendar_view == year_calendar))
        printer_object->Orientation = poLandscape;
      else
        printer_object->Orientation = poPortrait;
      classScheduling *printer_class = new classScheduling(printer_object->Canvas, printer_object->PageWidth,
                                       printer_object->PageHeight, schedule_class->GetCurrentDate(), CurrentPdate(),
                                       user_color_map, 0.9, 9, true, checkShowClocks->Checked);
      printer_object->BeginDoc();
      DrawCalendar(printer_class, true);
      printer_object->EndDoc();
      if(printer_class)
        delete printer_class;
    }
    Processing(false);
  }
  else
  {
    // TODO: print report of todo stuff
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuPrintAppointmentReportClick(TObject *Sender)
{
  TformLaunchAppointmentReport *appt_report = NULL;
  FORM_TRY
    appt_report = new TformLaunchAppointmentReport(NULL, &all_appointments);
  FORM_CATCH_RETURN("TformLaunchAppointmentReport", )

  Pdate begin_date_shown;
  Pdate end_date_shown;
  set<string> clinics;
  string clinics_sql = "select id from groups where clinic_id > 0 and has_charts = 1"; // clinics have charts

  schedule_class->GetBeginEndDates(begin_date_shown, end_date_shown, current_calendar_view);
  appt_report->dateBegin->Date = begin_date_shown.OutDate();
  appt_report->dateEnd->Date   = end_date_shown.OutDate();
  SqlToSet(dbDatabase, clinics_sql, clinics);
  if(clinics.find(current_groupid) != clinics.end())
    appt_report->radioClinic->Checked = true;
  appt_report->dateBegin->Enabled = false;
  appt_report->dateEnd->Enabled   = false;

  appt_report->ShowTaskModal(this);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::btnPrintClick(TObject *Sender)
{
  menuPrintAppointmentReportClick(NULL);  // default shall be the appt report
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::listGroupsChange(TObject *Sender, TListItem *Item, TItemChange Change)
{
  // sigh.  "Change" doesn't tell us more than that the "state" changed, which could be Selected OR Checked
  // So let's do a bunch of extra fucking work to figure out if they [un]checked this item...
  // if it's unchecked now and previously checked (in the set) OR
  //         checked now and previously unchecked (not in the set), then we do our thing
  /*
  PSay("group_id: " + string(Item->SubItems->Strings[0].c_str()) + "\n"
       "Item->Checked: " + IntToString(BoolToInt(Item->Checked)) + "\n"
       "in group_ids: " + IntToString(BoolToInt(checked_groups_state.find(Item->SubItems->Strings[0].c_str()) != checked_groups_state.end())) + "\n",
       m_message, MB_OK);
  */

  if(!Item || !Item->SubItems || !Item->SubItems->Count)
    return; // Invalid list items??

  bool check_changed = (!Item->Checked && checked_groups_state.find(Item->SubItems->Strings[0].c_str()) != checked_groups_state.end()) ||
                       (Item->Checked && checked_groups_state.find(Item->SubItems->Strings[0].c_str()) == checked_groups_state.end());
  if (check_changed)
  {
    listUsers->OnChange = NULL; // yeah, we don't want [un]checking to trigger the other listview's OnChange...
    set<string> user_ids;
    // find users that are part of the indicated group
    for (unsigned int i=0; i<groups_to_users.size(); i++)
    {
      if (string(Item->SubItems->Strings[0].c_str()) == groups_to_users[i]["group_id"])
        user_ids.insert(groups_to_users[i]["user_id"]);
    }
    string user_id_string = SetToCommaString(user_ids);
    // then we check or uncheck those users by ID, depending on whether the group was checked or unchecked.
    CheckItems(user_id_string, listUsers, Item->Checked);
    checked_groups_state = VecToSet(GetCheckedIdVec(listGroups));
    checked_users_state  = VecToSet(GetCheckedIdVec(listUsers));
    listUsers->OnChange  = listUsersChange;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::listUsersChange(TObject *Sender, TListItem *Item, TItemChange Change)
{
  // sigh.  "Change" doesn't tell us more than that the "state" changed, which could be Selected OR Checked
  // So let's do a bunch of extra fucking work to figure out if they [un]checked this item...
  // if it's (previously) checked but in the set OR (previously) unchecked but not in the set, the Checked status changed.
  /*
  PSay("user_id: " + string(Item->SubItems->Strings[0].c_str()) + "\n"
       "Item->Checked: " + IntToString(BoolToInt(Item->Checked)) + "\n"
       "in user_ids: " + IntToString(BoolToInt(checked_users_state.find(Item->SubItems->Strings[0].c_str()) != checked_users_state.end())) + "\n",
       m_message, MB_OK);
  */

  if(!Item || !Item->SubItems || !Item->SubItems->Count)
    return; // Invalid list items??

  // if it's unchecked now and previously checked (in the set) OR
  //         checked now and previously unchecked (not in the set), then we do our thing
  bool check_changed = (!Item->Checked && checked_users_state.find(Item->SubItems->Strings[0].c_str()) != checked_users_state.end()) ||
                       (Item->Checked && checked_users_state.find(Item->SubItems->Strings[0].c_str()) == checked_users_state.end());
  if (check_changed)
  {
    listGroups->OnChange = NULL; // yeah, we don't want [un]checking to trigger the other listview's OnChange...
    // if they're unchecking a user, then the group they're part of is no longer complete, and we
    // should uncheck it also.
    if (!Item->Checked)
    {
      string group_id;
      // find the group that the indicated user is part of
      for (unsigned int i=0; i<groups_to_users.size(); i++)
      {
        if (string(Item->SubItems->Strings[0].c_str()) == groups_to_users[i]["user_id"])
        {
          group_id = groups_to_users[i]["group_id"];
          break;
        }
      }
      // uncheck the group
      CheckItems(group_id, listGroups, false);
    }
    else
    /* TODO: look to see if ALL users in a group became checked as a result
       of checking this user.  If so, check that group (if not already) */
    ;
    listGroups->OnChange = listGroupsChange;
    checked_groups_state = VecToSet(GetCheckedIdVec(listGroups));
    checked_users_state  = VecToSet(GetCheckedIdVec(listUsers));
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuShowInactiveUsersClick(TObject *Sender)
{
  show_inactive_users = !show_inactive_users;
  menuShowInactiveUsers->Checked = show_inactive_users;
  FreshenUsersAndGroups();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuHideInactiveGroupsClick(TObject *Sender)
{
  hide_inactive_groups = !hide_inactive_groups;
  menuHideInactiveGroups->Checked = hide_inactive_groups;
  FreshenUsersAndGroups();
}
//---------------------------------------------------------------------------
void TformSpecialSchedule2::FreshenUsersAndGroups()
{
  if (radioUsers->Checked)
  {
    // save current IDs
    string group_ids = VecToCommaString(GetCheckedIdVec(listGroups));
    string user_ids  = VecToCommaString(GetCheckedIdVec(listUsers));
    // refresh listviews (SQL will have changed)
    FillListViews(true);
    // disable OnChange events while we re-check items by ID
    listGroups->OnChange = NULL;
    listUsers->OnChange = NULL;
    CheckItems(group_ids, listGroups);
    CheckItems(user_ids, listUsers);
    // restore OnChange events
    listGroups->OnChange = listGroupsChange;
    listUsers->OnChange = listUsersChange;
    // update
    checked_groups_state = VecToSet(GetCheckedIdVec(listGroups));
    checked_users_state  = VecToSet(GetCheckedIdVec(listUsers));
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSchedule2::menuPrintDayScheduleClick(TObject *Sender)
{
  if(current_calendar_view == day_calendar)
    TformReportDaySchedule::Do(all_appointments, schedule_class->GetCurrentDate(), true);
  else
    PSay("Please change to 'Day' calendar view first.", m_reminder, MB_OK);
}
//---------------------------------------------------------------------------

