//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialScreenStatistics.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialScreenStatistics *formSpecialScreenStatistics;
//---------------------------------------------------------------------------
__fastcall TformSpecialScreenStatistics::TformSpecialScreenStatistics(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  string min_date = GetOneField(dbDatabase, "select min(event_date) from usage_log where event_name = 'form opened'");
  Pdate min_p_date(min_date, mdy | yyyy);
  Pdate today_p_date = CurrentPdate();
  int date_difference = (today_p_date - min_p_date) + 1;
  string sql = "select usage_log.form_name, sum(usage_log.occurances), "
               "sum(usage_log.occurances)/" + IntToString(date_difference) + ".0 * 7/5, 4, 1 "
               "from usage_log "
               "where usage_log.event_date >= '" + min_p_date.OutDate(mdy | yyyy) + "' and "
               "usage_log.event_date <= '" + today_p_date.OutDate(mdy | yyyy) + "' and "
               "usage_log.event_name = 'form opened' "
               "group by usage_log.form_name";
  usage_filter.SetListViewHandle (listUsage);
  usage_filter.SetSecurity("usage_log");
  usage_filter.AddColumnSpec("Form Name", "usage_log", as_text, true, 205, rawString);
  usage_filter.AddColumnSpec("Times Opened", "usage_log", as_int, true, 100);
  usage_filter.AddColumnSpec("Average per Day", "usage_log", as_int, true, 100, statString);
  usage_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  usage_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  usage_filter.FetchPreferences("specialscreenstatistics.usage_filter");
  usage_filter.SetCompress(true);
  usage_filter.SetSQLStatement (sql);
  usage_request = atlas->RequestNotificationWhen("usage_log.id", "1", rel_any, as_int, this,
                               RefreshHandler(&(TformSpecialScreenStatistics::AtlasRefreshListView)));
  usage_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
void TformSpecialScreenStatistics::AtlasRefreshListView(int request_num, string matched_value)
{
  if(request_num == usage_request)
    usage_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialScreenStatistics::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------

