//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialSelectGroups.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialSelectGroups *formSpecialSelectGroups;
//---------------------------------------------------------------------------
__fastcall TformSpecialSelectGroups::TformSpecialSelectGroups(TComponent* Owner, set<string> * p_user_set, set<string> * p_group_set,
                                                              bool p_ogwu,bool *p_result_dest)
        : TformSpecialGeneric(Owner)
{
  user_set = p_user_set;
  group_set = p_group_set;
  only_groups_with_users = p_ogwu;
  result_dest = p_result_dest;
  DisplayGroups();
}

//---------------------------------------------------------------------------
void TformSpecialSelectGroups::DisplayGroups()
{
  string sql = "select groups.id, groups.item from groups ";
  if (only_groups_with_users)
    sql += "inner join users on users.group_id = groups.id and users.valid = 1 ";
  sql += "where groups.id > 0 and groups.valid = 1 ";
  if (only_groups_with_users)
    sql += "group by groups.id, groups.item having count(users.id) > 0 ";
  sql += "order by groups.item";
  vector<map<string, string> > field_vec;
  SqlToVecMap(dbDatabase, sql, field_vec);
  TListItem * row;
  listGroups->Items->Clear();
  for (vector<map<string, string> >::iterator itr = field_vec.begin(); itr != field_vec.end(); itr++)
  {
    row = listGroups->Items->Add();
    row->Caption = PrettyString((*itr)["item"]).c_str();
    row->SubItems->Add((*itr)["id"].c_str());

    // jhaley 20110128: if group_set is valid and is not initially empty, check any items it contains
    if (group_set && group_set->find((*itr)["id"]) != group_set->end())
      row->Checked = true;
  }

  // jhaley: clear group_set
  if (group_set)
    group_set->clear();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSelectGroups::btnCancelClick(TObject *Sender)
{
  if (result_dest)
    *result_dest = false; // cancelled
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSelectGroups::btnSelectClick(TObject *Sender)
{
  vector<map<string, string> > user_vec;
  vector<string> group_ids;
  string sql;
  string where = "";
  for (int i = 0; i < listGroups->Items->Count; i++)
  {
    if(listGroups->Items->Item[i]->Checked)
       group_ids.push_back(listGroups->Items->Item[i]->SubItems->Strings[0].c_str());
  }
  if (! group_ids.empty())
  {
    if (user_set)
    {
      sql = "select id from users ";
      for (vector<string>::iterator group_itr = group_ids.begin(); group_itr != group_ids.end(); group_itr++)
        where += "group_id = " + (*group_itr) + " or ";
      if (where != "")
      {
        where = where.substr(0, where.length()-3);
        sql = sql + " where " + where + " order by item";

        SqlToVecMap(dbDatabase, sql, user_vec);
        if (! user_vec.empty())
        {
           user_set->clear();
           for(vector<map<string, string> >::iterator user_itr = user_vec.begin(); user_itr != user_vec.end(); user_itr++)
             user_set->insert((*user_itr)["id"]);
        }
      }
    }
    if (group_set)
    {
      for (vector<string>::iterator group_itr = group_ids.begin(); group_itr != group_ids.end(); group_itr++)
       group_set->insert(*group_itr);
    }
  } // end if group ids not empty

  if (result_dest)
    *result_dest = true; // selected

  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSelectGroups::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = false;
  if(Msg.CharCode == VK_RETURN)
  {
    Handled = true;
    btnSelectClick(NULL);
  }
}
//---------------------------------------------------------------------------

