//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialSentReferrals.h"
#include "codeSpecialNewInterofficeReferral.h"
#include "codeRecordReferral.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialSentReferrals *formSpecialSentReferrals;
//---------------------------------------------------------------------------
__fastcall TformSpecialSentReferrals::TformSpecialSentReferrals(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  this->IconIndex = 40;
  user_tax_id = GetOneField(dbDatabase, "select tax_entity_id from users where id = " + current_userid);
  if((user_tax_id == "") && (user_tax_id == "0"))
  {
    PSay("You are unable to use this referral system. "
         "Please contact a programmer to complete the setup.", m_warning, MB_OK);
  }
  else
  {
    sql = "select referrals.date_of_referral, users.item, "
          "person_names.first_name || ' ' || person_names.last_name || ' ' || person_names.suffix, "
          "todo_status_types.item, referral_reason_types.item, referral_notes.note, "
          "referrals.current_id, referrals.id "
          "from referrals "
          "inner join tax_entities on referrals.to_provider_id = tax_entities.id "
          "inner join users on users.tax_entity_id = tax_entities.id "
          "inner join todo_status_types on referrals.todo_status_id = todo_status_types.id "
          "inner join people on referrals.person_id = people.id "
          "left join person_names on people.person_names_id = person_names.id "
          "inner join referral_reason_types on referrals.referral_reason_id = referral_reason_types.id "
          "inner join referral_notes on referral_notes.id = (select first 1 id from referral_notes RN "
           "where RN.referral_id = referrals.id and current_id+1 > 3 order by date_of_note desc) "
          "where referrals.by_provider_id = " + user_tax_id;
    vector<string> id_vec;
    SqlToVec(dbDatabase, "select users.tax_entity_id from users where users.valid = 1 and "
             "users.tax_entity_id > 0", id_vec);
    sql += " and referrals.to_provider_id in (" + VecToCommaString(id_vec) + ")";
    temp_sql = sql + " and referrals.todo_status_id != " + lookupTables->IdOf("todo_status_types", "Complete");
    referrals_filter.SetListViewHandle (listReferrals);
    referrals_filter.SetSecurity("referrals");
    referrals_filter.AddColumnSpec("Date", "referrals", as_date, true, 90);
    referrals_filter.AddColumnSpec("Referred To", "referrals", as_text, true, 120);
    referrals_filter.AddColumnSpec("Person", "referrals", as_text, true, 120);
    referrals_filter.AddColumnSpec("Status", "referrals", as_text, true, 100);
    referrals_filter.AddColumnSpec("Reason", "referrals", as_text, true, 120);
    referrals_filter.AddColumnSpec("Last Message", "referrals", as_text, true, 150, sentenceString);
    referrals_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
    referrals_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
    referrals_filter.FetchPreferences("specialsentreferrals.referrals_filter");
    referrals_filter.SetIconStatus(true);
    referrals_filter.SetSQLStatement (temp_sql);
    referrals_filter.RefreshDataSet();
    referrals_filter.SetAddEdit(this, AddRecord(&(TformSpecialSentReferrals::AddReferral)),
                                      EditRecord(&(TformSpecialSentReferrals::EditReferral)));
    referrals_request = atlas->RequestNotificationWhen("referrals.by_provider_id", user_tax_id, rel_e, as_int, this,
                        RefreshHandler(&(TformSpecialSentReferrals::AtlasRefreshListView)));
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSentReferrals::menuViewAllClick(TObject *Sender)
{
  ((TMenuItem *)Sender)->Checked = true;
  if(menuViewAll->Checked)
  {
    temp_sql = sql;
    this->Caption = "Sent Referrals - All";
  }
  else if(menuViewAllIncomplete->Checked)
  {
    temp_sql = sql + " and referrals.todo_status_id != " + lookupTables->IdOf("todo_status_types", "Complete");
    this->Caption = "Sent Referrals - All Incomplete";
  }
  else if(menuNotBegun->Checked)
  {
    temp_sql = sql + " and referrals.todo_status_id = " + lookupTables->IdOf("todo_status_types", "Not begun");
    this->Caption = "Sent Referrals - Not Begun";
  }
  else if(menuInProgress->Checked)
  {
    temp_sql = sql + " and referrals.todo_status_id = " + lookupTables->IdOf("todo_status_types", "In progress");
    this->Caption = "Sent Referrals - In Progress";
  }
  else if(menuComplete->Checked)
  {
    temp_sql = sql + " and referrals.todo_status_id = " + lookupTables->IdOf("todo_status_types", "Complete");
    this->Caption = "Sent Referrals - Complete";
  }
  else if(menuOverdue->Checked)
  {
    temp_sql = sql + " and referrals.todo_status_id = " + lookupTables->IdOf("todo_status_types", "Overdue");
    this->Caption = "Sent Referrals - Overdue";
  }
  else if(menuSuspended->Checked)
  {
    temp_sql = sql + " and referrals.todo_status_id = " + lookupTables->IdOf("todo_status_types", "Suspended");
    this->Caption = "Sent Referrals - Suspended";
  }
  referrals_filter.SetSQLStatement(temp_sql);
  referrals_filter.RefreshDataSet();

}
//---------------------------------------------------------------------------
void TformSpecialSentReferrals::AddReferral()
{
  FORM_TRY
    TformSpecialNewInterofficeReferral *new_referral = new TformSpecialNewInterofficeReferral(NULL);
    new_referral->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformSpecialSentReferrals::EditReferral()
{
  map<string, string> temp_map;
  temp_map["id"] = referrals_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordReferral *edit_referral = new TformRecordReferral(NULL, temp_map);
    edit_referral->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSentReferrals::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void TformSpecialSentReferrals::AtlasRefreshListView(int request_num, string matched_value)
{
  if(request_num == referrals_request)
    referrals_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSentReferrals::btnCreateClick(TObject *Sender)
{
  AddReferral();
}
//---------------------------------------------------------------------------

