//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialSettings.h"
#include "codePrometheus.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma link "codeFrameTreeDropDown"
#pragma resource "*.dfm"
TformSpecialSettings *formSpecialSettings;
// static
preferences_changed_closure TformSpecialSettings::preferences_changed;
TMainMenu* TformSpecialSettings::prometheus_menu;
//---------------------------------------------------------------------------
__fastcall TformSpecialSettings::TformSpecialSettings(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  this->IconIndex = 29;
  MaskSetup (maskDefaultAccount);
  lblSample->Font->Color = link_color;
  panelTitleBar->Color   = title_bar_color;
  temp_link_color        = link_color;
  temp_bar_color         = title_bar_color;
  checkSplash->Checked            = (optionsIni["server"]["auto_close_splash"] == "true");
  checkReminders->Checked         = (optionsPreferences["appointments"]["reminders"] == "true");
  checkTaskbar->Checked           = (optionsPreferences["windows"]["to_taskbar"] == "true");
  checkChat->Checked              = (optionsPreferences["chat"]["do_not_receive_messages"] == "true");
  checkHints->Checked             = (optionsPreferences["filter"]["no_persistent_hints"] == "true");
  checkIcons->Checked             = (optionsPreferences["icons"]["no_menu_icons"] == "true");
  checkAutosizeColumns->Checked   = (optionsPreferences["filter"]["always_autosize_columns"] == "true");
  checkAutoUnlockRecords->Checked = (optionsPreferences["record_generic"]["auto_unlock"] == "true");
  checkAutoOpenFavorites->Checked = (optionsPreferences["search_generic"]["auto_open_favorites"] == "true");
  checkAutoOpenPageList->Checked  = (optionsPreferences["wizard_generic"]["auto_open_pagelist"] == "true");
  checkAutoOpenHelp->Checked      = (optionsPreferences["special_generic"]["auto_open_help"] == "true");
  if (optionsPreferences["accounting"]["default_account"] != "")
   maskDefaultAccount->Text       = optionsPreferences["accounting"]["default_account"].c_str();
  checkPRPrint->Checked           = (optionsPreferences["accounting"]["simple_pr_print"] == "true");

  if(optionsPermissions["admin.glass"]["enabled"] == "true")
    checkGlass->Checked = (optionsPreferences["special_generic"]["glass"] == "true");
  else
  {
    checkGlass->Checked = false;
    checkGlass->Enabled = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSettings::lblSampleClick(TObject *Sender)
{
  linkColorDialog->Color = temp_link_color;
  if (linkColorDialog->Execute())
  {
    temp_link_color = linkColorDialog->Color;
    lblSample->Font->Color = temp_link_color;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSettings::panelTitleBarClick(TObject *Sender)
{
  barColorDialog->Color = temp_bar_color;
  if (barColorDialog->Execute())
  {
    temp_bar_color = barColorDialog->Color;
    panelTitleBar->Color = temp_bar_color;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSettings::btnSaveClick(TObject *Sender)
{
  link_color = temp_link_color;
  title_bar_color = temp_bar_color;

  string temp_quick_menu_string;
  for (int i = 0; i < listQuickMenus->Items->Count; i++)
   temp_quick_menu_string += string(i ? "," : "") + listQuickMenus->Items->Item[i]->SubItems->Strings[0].c_str();

  optionsPreferences["menu"]["quick_access"] = temp_quick_menu_string;

  optionsPreferences["color"]["link_color"]      = IntToString(int(link_color));
  optionsPreferences["color"]["title_bar_color"] = IntToString(int(title_bar_color));

  optionsPreferences["appointments"]["reminders"]             = (checkReminders->Checked) ? "true" : "false";
  optionsPreferences["server"]["auto_close_splash"]           = (checkSplash->Checked) ? "true" : "false";
  optionsPreferences["windows"]["to_taskbar"]                 = (checkTaskbar->Checked) ? "true" : "false";
  optionsPreferences["chat"]["do_not_receive_messages"]       = (checkChat->Checked) ? "true" : "false";
  optionsPreferences["filter"]["no_persistent_hints"]         = (checkHints->Checked) ? "true" : "false";
  optionsPreferences["icons"]["no_menu_icons"]                = (checkIcons->Checked) ? "true" : "false";
  optionsPreferences["filter"]["always_autosize_columns"]     = (checkAutosizeColumns->Checked) ? "true" : "false";
  optionsPreferences["record_generic"]["auto_unlock"]         = (checkAutoUnlockRecords->Checked) ? "true" : "false";
  optionsPreferences["search_generic"]["auto_open_favorites"] = (checkAutoOpenFavorites->Checked) ? "true" : "false";
  optionsPreferences["wizard_generic"]["auto_open_pagelist"]  = (checkAutoOpenPageList->Checked) ? "true" : "false";
  optionsPreferences["special_generic"]["auto_open_help"]     = (checkAutoOpenHelp->Checked) ? "true" : "false";
  optionsPreferences["accounting"]["default_account"]         = maskDefaultAccount->Text.c_str();
  optionsPreferences["accounting"]["simple_pr_print"]         = (checkPRPrint->Checked) ? "true" : "false";

  if(optionsPermissions["admin.glass"]["enabled"] == "true")
    optionsPreferences["special_generic"]["glass"] = (checkGlass->Checked) ? "true" : "false";
  else
    optionsPreferences["special_generic"]["glass"] = "false";

  SaveOptionsToFile("prometheus.ini", optionsIni);
  if (preferences_changed) preferences_changed();
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSettings::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void TformSpecialSettings::RecurseMenuItem(TMenuItem *menu_item, TTreeNode *tree_node, unsigned int & k)
{
 int submenu_items = menu_item->Count;
 if (submenu_items && tree_node)
  tree_node->ImageIndex = 1;
 for(int j = 0; j < submenu_items; j++)
 {
  if (menu_item->Items[j]->Visible && menu_item->Items[j]->Caption != "-")
  {
   TTreeNode * new_node = NULL;
   if (tree_node)
   {
    new_node = treedropQuickMenus->treeValues->Items->AddChild(tree_node,
      ReplaceStringWithString(ReplaceStringWithString(ReplaceStringWithString(menu_item->Items[j]->Caption.c_str(), "&&", "@"), "&", ""), "@", "&").c_str());
   }
   else
   {
    new_node = treedropQuickMenus->treeValues->Items->Add(NULL,
      ReplaceStringWithString(ReplaceStringWithString(ReplaceStringWithString(menu_item->Items[j]->Caption.c_str(), "&&", "@"), "&", ""), "@", "&").c_str());
   }
   new_node->Data = (void*)k;
   original_menu_object_names.push_back(menu_item->Items[j]->Name.c_str());
   k++;
   RecurseMenuItem(menu_item->Items[j], new_node, k);
   new_node->Expanded = true;
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSettings::timerShowTreeTimer(TObject *Sender)
{
 // why not do this in the constructor?
 // because accessing this screen from the menu causes the File menu to not be in its proper place:
 // it gets reparented as a popup, and then moved back after the screen appears.
 // so we wait until it's back, and -then- we grab everything.

 timerShowTree->Enabled = false;

 unsigned int k = 0;
 original_menu_object_names.clear();
 RecurseMenuItem(prometheus_menu->Items, NULL, k);

 vector<string> temp_quick_menus;
 SplitStringToVec(optionsPreferences["menu"]["quick_access"], ",", temp_quick_menus);
 for (unsigned int i = 0; i < temp_quick_menus.size(); i++)
 {
  if (temp_quick_menus[i] != "")
  {
   TMenuItem * z = (TMenuItem*)(FindMenuItemByNameInsensitive(prometheus_menu->Items, temp_quick_menus[i]));
   bool already_added = false;
   for (int i = 0; i < listQuickMenus->Items->Count; i++)
    if (listQuickMenus->Items->Item[i]->SubItems->Strings[0] == z->Name)
     already_added = true;

   if (z && z->Visible && z->Enabled && !already_added)
   {
    TListItem * w = listQuickMenus->Items->Add();
    w->Caption = FullyQualifiedMenuItemName(z).c_str();
    w->SubItems->Add(z->Name.c_str());
   }
   listQuickMenus->Selected = NULL;
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSettings::buttonAddClick(TObject *Sender)
{
 if (treedropQuickMenus->treeValues->Selected &&
     treedropQuickMenus->treeValues->Selected->ImageIndex != 1)
 {
  unsigned int k = (unsigned int)(treedropQuickMenus->treeValues->Selected->Data);
  TMenuItem * z = (TMenuItem*)(FindMenuItemByNameInsensitive(prometheus_menu->Items, original_menu_object_names[k]));

  for (int i = 0; i < listQuickMenus->Items->Count; i++)
   if (listQuickMenus->Items->Item[i]->SubItems->Strings[0].c_str() == original_menu_object_names[k])
   {
    PSay("You have already added this item to your list of quick-access menus.", m_duplicate_data, MB_OK);
    return;
   }

  TListItem * w = listQuickMenus->Items->Add();
  w->Caption = FullyQualifiedMenuItemName(z).c_str();
  w->SubItems->Add(original_menu_object_names[k].c_str());
  listQuickMenus->Selected = w;
 } else
  PSay("You must select a non-folder item from the drop-down.", m_missing_data, MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSettings::buttonRemoveClick(TObject *Sender)
{
 if (listQuickMenus->Selected)
  listQuickMenus->Selected->Delete();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSettings::buttonMoveUpClick(TObject *Sender)
{
 if (listQuickMenus->Selected)
  if (listQuickMenus->Selected->Index > 0)
  {
   int curr_index = listQuickMenus->Selected->Index;
   TListItem * prev = listQuickMenus->Items->Item[curr_index - 1];
   TListItem * temp = listQuickMenus->Items->Insert(curr_index + 1);
   temp->Assign(prev);
   prev->Delete();
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSettings::buttonMoveDownClick(TObject *Sender)
{
 if (listQuickMenus->Selected)
  if (listQuickMenus->Selected->Index < listQuickMenus->Items->Count - 1)
  {
   int curr_index = listQuickMenus->Selected->Index;
   TListItem * next = listQuickMenus->Items->Item[curr_index + 1];
   TListItem * temp = listQuickMenus->Items->Insert(curr_index);
   temp->Assign(next);
   next->Delete();
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialSettings::buttonClearClick(TObject *Sender)
{
 listQuickMenus->Items->Clear();
}
//---------------------------------------------------------------------------

