//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialStepsForm.h"
#include "codeSpecialParQForm.h"
#include "codeSpecialReachContract.h"
#include "codeSpecialDoctorStatementForm.h"
#include "codeSpecialMonthlyActivityForm.h"
#include "codeSpecialStepsAffiliates.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialStepsForm *formSpecialStepsForm;
//---------------------------------------------------------------------------
__fastcall TformSpecialStepsForm::TformSpecialStepsForm(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialStepsForm::coverpageAfterPreview(TObject *Sender)
{
//  Close();  // form not used; never called; not needed        
}
//---------------------------------------------------------------------------
// jhaley 20110125: Moved here from TformPrometheusMenu
void TformSpecialStepsForm::Do()
{
  // Doesn't need to be done as a composite report any longer since only one of
  // the three pages prints.  Too lazy to fix it.
  // And too lazy to convert it to a composite report "the right way" too.
  Screen->Cursor = crHourGlass;
  TformSpecialStepsForm *steps_form = NULL;
  FORM_TRY
   steps_form = new TformSpecialStepsForm(NULL);
  FORM_CATCH
  steps_form->page1->Prepare();
  steps_form->page1->QRPrinter->Save(PMakeTempFilePath("page1.qrp").c_str());
  //steps_form->page2->Prepare();
  //steps_form->page2->QRPrinter->Save(PMakeTempFilePath("page2.qrp").c_str());
  steps_form->CloseNow();
  TQRPageList *source = new TQRPageList();
  TQRPageList *destination = new TQRPageList();
  destination->Stream = new TQRStream(100000);
  string file_name;
  for(int i = 1; i <= 1; i++)
  {
    file_name = PMakeTempFilePath(string("page") + IntToString(i) + ".qrp");
    source->Clear();
    source->LoadFromFile(file_name.c_str());
    destination->AddPage(source->GetPage(1));
  }
  // save all files together
  destination->Finish();
  string temp_filepath = PMakeTempFilePath("complete.qrp");
  destination->SaveToFile(temp_filepath.c_str());
  // load combined report and preview
  TQRPrinter *printer_thing = InitTQRPrinter();
  printer_thing->Load(temp_filepath.c_str());
  Screen->Cursor = crDefault;
  printer_thing->PreviewModal();
  delete printer_thing;
  delete source;
  delete destination;
}
//---------------------------------------------------------------------------
// jhaley 20110125: Moved from TformPrometheusMenu
void TformSpecialStepsForm::DoPacket()
{
  string class_name = "TformSpecialStepsForm";

  Screen->Cursor = crHourGlass;

  TformSpecialStepsForm * steps_form = NULL;
  AV_TRY
   FORM_TRY
    steps_form = new TformSpecialStepsForm(NULL);
   FORM_CATCH
  AV_CATCH
  /*
  steps_form->coverpage->Prepare();
  steps_form->coverpage->QRPrinter->Save(PMakeTempFilePath("page1.qrp").c_str());

  TformSpecialIntake * intake_form = new TformSpecialIntake(NULL);
  intake_form->lblGeneralPage->Caption = "Page 1 of 3";
  intake_form->generalInfo->Prepare();
  intake_form->generalInfo->QRPrinter->Save(PMakeTempFilePath("page2.qrp").c_str());
  intake_form->lblInsurancePage->Caption = "Page 2 of 3";
  intake_form->insuranceInfo->Prepare();
  intake_form->insuranceInfo->QRPrinter->Save(PMakeTempFilePath("page3.qrp").c_str());
  intake_form->lblConsentPage->Caption = "Page 3 of 3";
  intake_form->consent->Prepare();
  intake_form->consent->QRPrinter->Save(PMakeTempFilePath("page4.qrp").c_str());
  intake_form->CloseNow();
  */
  steps_form->page1->Prepare();
  steps_form->page1->QRPrinter->Save(PMakeTempFilePath("page1.qrp").c_str());
  /*
  steps_form->page2->Prepare();
  steps_form->page2->QRPrinter->Save(PMakeTempFilePath("page6.qrp").c_str());
  */
  steps_form->CloseNow();

  TformSpecialReachContract * contract = NULL;
  AV_TRY
   FORM_TRY
    contract = new TformSpecialReachContract(NULL);
   FORM_CATCH
  AV_CATCH
  contract->page1->Prepare();
  contract->page1->QRPrinter->Save(PMakeTempFilePath("page2.qrp").c_str());
  contract->page2->Prepare();
  contract->page2->QRPrinter->Save(PMakeTempFilePath("page3.qrp").c_str());
  contract->CloseNow();

  TformSpecialParQForm * form = NULL;
  AV_TRY
   FORM_TRY
    form = new TformSpecialParQForm(NULL);
   FORM_CATCH
  AV_CATCH
  form->page1->Prepare();
  form->page1->QRPrinter->Save(PMakeTempFilePath("page4.qrp").c_str());
  form->CloseNow();

  TformSpecialDoctorStatementForm * form1 = NULL;
  AV_TRY
   FORM_TRY
    form1 = new TformSpecialDoctorStatementForm(NULL);
   FORM_CATCH
  AV_CATCH
  form1->page1->Prepare();
  form1->page1->QRPrinter->Save(PMakeTempFilePath("page5.qrp").c_str());
  form1->CloseNow();

  TformSpecialMonthlyActivityForm * activity_form = NULL;
  AV_TRY
   FORM_TRY
    activity_form = new TformSpecialMonthlyActivityForm(NULL);
   FORM_CATCH
  AV_CATCH
  activity_form->page1->Prepare();
  activity_form->page1->QRPrinter->Save(PMakeTempFilePath("page6.qrp").c_str());

  TIBTransaction *activity_transaction = new TIBTransaction(NULL);
  TIBDataSet *activity_dataset = new TIBDataSet(NULL);
  StdTransaction(activity_transaction, dbDatabase);
  activity_dataset->Database = dbDatabase;
  activity_dataset->Transaction = activity_transaction;
  activity_dataset->UniDirectional = false;
  activity_dataset->SelectSQL->Add("select item from activity_code_types where valid = 1 and id > 0 order by item");
  activity_dataset->Open();
  activity_form->activity_codes->DataSet = activity_dataset;
  activity_form->txtCode->DataSet = activity_dataset;
  activity_form->txtCode->DataField = "item";
  activity_form->activity_codes->Prepare();
  activity_form->activity_codes->QRPrinter->Save(PMakeTempFilePath("page7.qrp").c_str());
  activity_dataset->Close();
  activity_transaction->Commit();
  delete activity_transaction;
  delete activity_dataset;
  activity_form->CloseNow();
  /*
  TformSpecialChildConsent * form2 = new TformSpecialChildConsent(NULL);
  form2->page1->Prepare();
  form2->page1->QRPrinter->Save(PMakeTempFilePath("page11.qrp").c_str());
  form2->CloseNow();
  */

  TformSpecialStepsAffiliates * steps_affiliates = NULL;
  AV_TRY
   FORM_TRY
    steps_affiliates = new TformSpecialStepsAffiliates(NULL);
   FORM_CATCH
  AV_CATCH
  steps_affiliates->pageAffiliates->Prepare();
  steps_affiliates->pageAffiliates->QRPrinter->Save(PMakeTempFilePath("page8.qrp").c_str());
  steps_affiliates->CloseNow();

  TQRPageList * source      = NULL;
  TQRPageList * destination = NULL;
  TQRPrinter *printer_thing = NULL;

  AV_TRY
   FORM_TRY
    source = new TQRPageList();
   FORM_CATCH
  AV_CATCH
  AV_TRY
   FORM_TRY
    destination = new TQRPageList();
   FORM_CATCH
  AV_CATCH
  AV_TRY
   FORM_TRY
    destination->Stream = new TQRStream(100000);
   FORM_CATCH
  AV_CATCH
  AV_TRY
   FORM_TRY
    printer_thing = InitTQRPrinter();
   FORM_CATCH
  AV_CATCH

  string file_name;
  for(int i = 1; i <= 8; i++)
  {
    file_name = PMakeTempFilePath(string("page") + IntToString(i) + ".qrp");
    source->Clear();
    source->LoadFromFile(file_name.c_str());
    destination->AddPage(source->GetPage(1));
  }
  // save all files together
  destination->Finish();
  string temp_filepath = PMakeTempFilePath("complete.qrp");
  destination->SaveToFile(temp_filepath.c_str());
  // load combined report and preview
  printer_thing->Load(temp_filepath.c_str());
  Screen->Cursor = crDefault;
  printer_thing->PreviewModal();
  delete printer_thing;
  delete source;
  delete destination;
}
//---------------------------------------------------------------------------
