//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialTimesheet.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialTimesheet *formSpecialTimesheet;
//---------------------------------------------------------------------------
__fastcall TformSpecialTimesheet::TformSpecialTimesheet(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
   this->IconIndex = -1;
   total_regular_hours = 0.00;
   total_overtime_hours = 0.00;
   total_regular_rounded = 0.00;
   total_overtime_rounded = 0.00;
   timesheet.clear();
   dateRegular->Date = StrToDate(Now().DateString());
   just_started = true;
   saved = false;

   dateRegularChange(NULL);
}
//---------------------------------------------------------------------------
void TformSpecialTimesheet::AddListItem(string reg_date, string pre_lunch_from,
   string pre_lunch_to, string post_lunch_from, string post_lunch_to, bool add_to_map)
{
 Ptime start_time1, start_time2;
 Ptime end_time1, end_time2;

 start_time1.InTime(pre_lunch_from, military | withoutsec);
 end_time1.InTime(pre_lunch_to, military | withoutsec);
 start_time2.InTime(post_lunch_from, military | withoutsec);
 end_time2.InTime(post_lunch_to, military | withoutsec);

 float lunch_time;
 if (post_lunch_from != "0:00")
 {
   if (start_time2 < end_time1)
   {
     start_time2.mod(12, in_hours);
     lunch_time = (float)(start_time2 - end_time1) / 60;
     start_time2.mod(-12, in_hours);
   }
   else
     lunch_time = (float)(start_time2 - end_time1) / 60;
 }

 if (end_time1 < start_time1) end_time1.mod(12, in_hours);
 if (end_time2 < start_time2) end_time2.mod(12, in_hours);

 float minutes_done1 = (float)(end_time1 - start_time1) / 60;
 float minutes_done2 = (float)(end_time2 - start_time2) / 60;
 float hours_done1 = ((float)minutes_done1 / 60);
 float hours_done2 = ((float)minutes_done2 / 60);
 total_regular_hours = total_regular_hours + hours_done1 + hours_done2;

 TListItem* new_row = listRegularHoursWorked->Items->Add();
 new_row->Caption = reg_date.c_str();
 new_row->SubItems->Add(start_time1.OutTime(military | withoutsec).c_str());
 new_row->SubItems->Add(end_time1.OutTime(military | withoutsec).c_str());
 new_row->SubItems->Add(StringToAmount(FloatToString(lunch_time)).c_str());
 new_row->SubItems->Add(start_time2.OutTime(military | withoutsec).c_str());
 new_row->SubItems->Add(end_time2.OutTime(military | withoutsec).c_str());
 new_row->SubItems->Add(StringToAmount(FloatToString(hours_done1 + hours_done2)).c_str());

 if (add_to_map)
 {
    timesheet_info info_line;
    info_line.regular_date = reg_date;
    info_line.pre_lunch_from = start_time1.OutTime(military | withoutsec);
    info_line.pre_lunch_to = end_time1.OutTime(military | withoutsec);
    info_line.post_lunch_from = start_time2.OutTime(military | withoutsec);
    info_line.post_lunch_to = end_time2.OutTime(military | withoutsec);
    timesheet[IntToString(listRegularHoursWorked->Items->Count)] = info_line;
 }

 double fraction, integer;
 double rounded_hours = hours_done1 + hours_done2;
 fraction = modf(rounded_hours, &integer);

 if ( fraction < (7.0 / 60.0))
    rounded_hours = integer + 0.00;
 else if ( fraction < (22.0 / 60.0) )
    rounded_hours = integer + 0.25;
 else if ( fraction < (37.0 / 60.0) )
    rounded_hours = integer + 0.50;
 else if ( fraction < (52.0 / 60.0) )
    rounded_hours = integer + 0.75;
 else
    rounded_hours = integer + 1.00;

 total_regular_rounded += rounded_hours;

 new_row->SubItems->Add(StringToAmount(FloatToString(rounded_hours)).c_str());

 lblRegularTotalHours->Caption = StringToAmount(FloatToString(total_regular_hours)).c_str();
 lblRegularRoundedHours->Caption = StringToAmount(FloatToString(total_regular_rounded)).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTimesheet::btnNextClick(TObject *Sender)
{
 // actually insert time and calculate stuff

 if (editPreLunchFromMinutes->Text == "") editPreLunchFromMinutes->Text = "00";
 if (editPreLunchToMinutes->Text == "") editPreLunchToMinutes->Text = "00";
 string pre_lunch_from = string(editPreLunchFromHours->Text.c_str() + string(":") + editPreLunchFromMinutes->Text.c_str());
 string pre_lunch_to = string(editPreLunchToHours->Text.c_str() + string(":") + editPreLunchToMinutes->Text.c_str());

 if (editPostLunchFromHours->Text == "") editPostLunchFromHours->Text = "0";
 if (editPostLunchFromMinutes->Text == "") editPostLunchFromMinutes->Text = "00";
 string post_lunch_from = string(editPostLunchFromHours->Text.c_str() + string(":") + editPostLunchFromMinutes->Text.c_str());
 if (editPostLunchToHours->Text == "") editPostLunchToHours->Text = "0";
 if (editPostLunchToMinutes->Text == "") editPostLunchToMinutes->Text = "00";
 string post_lunch_to = string(editPostLunchToHours->Text.c_str() + string(":") + editPostLunchToMinutes->Text.c_str());

 AddListItem(DateToStr(dateRegular->Date).c_str(), pre_lunch_from, pre_lunch_to, post_lunch_from, post_lunch_to, true);

 if (dateRegular->Date < week_end)
    dateRegular->Date++;
 editPreLunchFromHours->Text = "";
 editPreLunchFromMinutes->Text = "";
 editPreLunchToHours->Text = "";
 editPreLunchToMinutes->Text = "";
 editPostLunchFromHours->Text = "";
 editPostLunchFromMinutes->Text = "";
 editPostLunchToHours->Text = "";
 editPostLunchToMinutes->Text = "";
 editPreLunchFromHours->SetFocus();
 saved = false;  // ?
}
//---------------------------------------------------------------------------
void TformSpecialTimesheet::RefreshList()
{
   listRegularHoursWorked->Items->Clear();

   string reg_date, pre_lunch_from, pre_lunch_to, post_lunch_from, post_lunch_to;

   for (map<string, timesheet_info>::iterator itr = timesheet.begin(); itr != timesheet.end(); itr++)
   {
     reg_date = (*itr).second.regular_date;
     pre_lunch_from = (*itr).second.pre_lunch_from;
     pre_lunch_to = (*itr).second.pre_lunch_to;
     post_lunch_from = (*itr).second.post_lunch_from;
     post_lunch_to = (*itr).second.post_lunch_to;

     AddListItem(reg_date, pre_lunch_from, pre_lunch_to, post_lunch_from, post_lunch_to, false);
   }
}
//---------------------------------------------------------------------------
void TformSpecialTimesheet::ChangeWeek(TDate dest_date)
{
   // save previous week range
   prev_week_begin = week_begin;
   prev_week_end = week_end;
   // get new one
   week_begin = dest_date;
   while (week_begin.DayOfWeek() > 1)  // get Sunday of the week
      week_begin--;
   week_end = week_begin + 6;          // Saturday is 6 days later
   // if form just opened, set prev_ to current range rather than leave garbage
   if (just_started)
   {
      prev_week_begin = week_begin;
      prev_week_end = week_end;
   }
   // reset the label that indicates the current week
   lblWeek->Caption = week_begin.FormatString("dddd mmmm dd, yyyy") + " - " + week_end.FormatString("dddd mmmm dd, yyyy");
   // reset the time/date picker if it's not in the correct week
   if ((dateRegular->Date < week_begin) || (dateRegular->Date > week_end))
      dateRegular->DateTime = week_begin;

   LoadData();

   just_started = false;
}
//---------------------------------------------------------------------------
void TformSpecialTimesheet::LoadData()
{
   if ((week_begin.DateString() != prev_week_begin.DateString()) && !saved)
   {
      int answer = PSay("You have made modifications to the data for this week but have "
                   "selected a date from a different week.  Would you like to save your changes first?  Answering "
                   "no will lose any changes you have made to this data.", m_warning, MB_YESNO);
      if (answer == IDYES)
         btnSaveClick(NULL);
   }
   if (week_begin.DateString() != prev_week_begin.DateString() || just_started)
   {
      Processing(true);

      TIBTransaction * dbTransaction = new TIBTransaction(NULL);
      TIBDataSet * dbDataSet = new TIBDataSet(NULL);

      try
      {
        dbTransaction->DefaultDatabase = dbDatabase;
        dbTransaction->StartTransaction();

        string sql;

        vector<map<string, string> > sel_map;

        sql = "select * from timesheets where date_worked >= '" + string(week_begin.DateString().c_str()) +
              "' and date_worked <= '" + string(week_end.DateString().c_str()) + "'"
              " and user_id = '" + current_userid + "' order by date_worked, is_after_lunch";
        SqlToVecMap(dbTransaction, sql, sel_map);

        timesheet.clear();
        for (unsigned int i = 0; i != sel_map.size(); i++)
        {
           timesheet[sel_map[i]["id"]].user_id = sel_map[i]["user_id"];
           timesheet[sel_map[i]["id"]].regular_date = sel_map[i]["date_worked"];
           if (sel_map[i]["is_after_lunch"] == "0")
           {
              timesheet[sel_map[i]["id"]].pre_lunch_from = sel_map[i]["time_worked_from"];
              timesheet[sel_map[i]["id"]].pre_lunch_to = sel_map[i]["time_worked_to"];
           }
           else
           {
              timesheet[sel_map[i]["id"]].post_lunch_from = sel_map[i]["time_worked_from"];
              timesheet[sel_map[i]["id"]].post_lunch_to = sel_map[i]["time_worked_to"];
           }
        }
        // DebugTimesheet();

        dbTransaction->Commit();
        saved = true;
      }
      catch (...)
      {
        Processing(false);      
        PSay("Error loading hours", m_database_error, MB_OK);
        if (dbTransaction->Active)
          dbTransaction->Rollback();
      }

      // (hopefully) temporary fix to reset the totals
      total_regular_hours = 0.00;
      total_overtime_hours = 0.00;
      total_regular_rounded = 0.00;
      total_overtime_rounded = 0.00;
      lblRegularTotalHours->Caption = StringToAmount(FloatToString(total_regular_hours)).c_str();
      lblRegularRoundedHours->Caption = StringToAmount(FloatToString(total_regular_rounded)).c_str();
      lblOTTotalHours->Caption = StringToAmount(FloatToString(total_overtime_hours)).c_str();
      lblOTRoundedHours->Caption = StringToAmount(FloatToString(total_overtime_rounded)).c_str();

      RefreshList();

      delete dbTransaction;
      delete dbDataSet;

      Processing(false);
   }
}
//---------------------------------------------------------------------------
void TformSpecialTimesheet::SaveData()
{
  Screen->Cursor = crHourGlass;
  btnSave->Enabled = false;
  btnClose->Enabled = false;
  toolsStandard->SetFocus();
  this->Update();

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);

  try
  {
    // Set up transaction for use of temp tables
    dbTransaction->DefaultDatabase = dbDatabase;
    dbTransaction->StartTransaction();

    // Run the SQL to fill the temp tables the report will be using
    string sql;

    map<string, string> insert_map;

    for (map<string, timesheet_info>::iterator itr = timesheet.begin(); itr != timesheet.end(); itr++)
    {
      sql = "delete from timesheets where date_worked = '" + (*itr).second.regular_date + "' and user_id = '" + current_userid + "'";
      ExecuteStatement(dbTransaction, sql);

      if ((*itr).second.pre_lunch_from != "" && (*itr).second.pre_lunch_to != "")
      {
         insert_map.clear();
         insert_map["id"] = GetNextId(dbTransaction, "timesheets");
         insert_map["user_id"] = current_userid;
         insert_map["time_worked_from"] = (*itr).second.pre_lunch_from;
         insert_map["time_worked_to"] = (*itr).second.pre_lunch_to;
         insert_map["date_worked"] = (*itr).second.regular_date;
         insert_map["is_after_lunch"] = "0";
         ExecuteInsertStatement(dbTransaction, "timesheets", insert_map);
      }

      if ((*itr).second.post_lunch_from != "" && (*itr).second.post_lunch_to != "")
      {
         insert_map.clear();
         insert_map["id"] = GetNextId(dbTransaction, "timesheets");
         insert_map["user_id"] = current_userid;
         insert_map["time_worked_from"] = (*itr).second.post_lunch_from;
         insert_map["time_worked_to"] = (*itr).second.post_lunch_to;
         insert_map["date_worked"] = (*itr).second.regular_date;
         insert_map["is_after_lunch"] = "1";
         ExecuteInsertStatement(dbTransaction, "timesheets", insert_map);
      }
    }

    dbTransaction->Commit();
    saved = true;
  }
  catch (...)
  {
    PSay("Error saving hours", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }

  delete dbTransaction;
  delete dbDataSet;

  btnSave->Enabled = true;
  btnClose->Enabled = true;
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTimesheet::editPreLunchFromHoursKeyPress(TObject *Sender, char &Key)
{
   if (Key == ':')
   {
     editPreLunchFromMinutes->SetFocus();
     Key = NULL;
   }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTimesheet::editPreLunchToHoursKeyPress(TObject *Sender, char &Key)
{
   if (Key == ':')
   {
     editPreLunchToMinutes->SetFocus();
     Key = NULL;
   }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTimesheet::editPostLunchFromHoursKeyPress(TObject *Sender, char &Key)
{
   if (Key == ':')
   {
     editPostLunchFromMinutes->SetFocus();
     Key = NULL;
   }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTimesheet::editPostLunchToHoursKeyPress(TObject *Sender, char &Key)
{
   if (Key == ':')
   {
     editPostLunchToMinutes->SetFocus();
     Key = NULL;
   }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTimesheet::editPreLunchFromMinutesKeyPress(TObject *Sender, char &Key)
{
   if ((Key == VK_BACK) && (editPreLunchFromMinutes->Text == ""))
      editPreLunchFromHours->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTimesheet::editPreLunchToMinutesKeyPress(TObject *Sender, char &Key)
{
   if ((Key == VK_BACK) && (editPreLunchToMinutes->Text == ""))
      editPreLunchToHours->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTimesheet::editPostLunchFromMinutesKeyPress(TObject *Sender, char &Key)
{
   if ((Key == VK_BACK) && (editPostLunchFromMinutes->Text == ""))
      editPostLunchFromHours->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTimesheet::editPostLunchToMinutesKeyPress(TObject *Sender, char &Key)
{
   if ((Key == VK_BACK) && (editPostLunchToMinutes->Text == ""))
      editPostLunchToHours->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTimesheet::btnCloseClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTimesheet::btnSaveClick(TObject *Sender)
{
   SaveData();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTimesheet::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnNext->Click();
  else
    Handled = false;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTimesheet::dateRegularChange(TObject *Sender)
{
   if ((dateRegular->Date < week_begin) || (dateRegular->Date > week_end))
      ChangeWeek(dateRegular->Date);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTimesheet::editChange(TObject *Sender)
{
   saved = false;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTimesheet::lblPrevWeekClick(TObject *Sender)
{
   ChangeWeek(week_begin - 7);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTimesheet::lblNextWeekClick(TObject *Sender)
{
   ChangeWeek(week_begin + 7);
}
//---------------------------------------------------------------------------
void TformSpecialTimesheet::DebugTimesheet()
{
  for (map<string, timesheet_info>::iterator itr = timesheet.begin(); itr != timesheet.end(); itr++)
  {
     PSay(string(itr->first + '\n' +
                                    itr->second.regular_date + '\n' +
                                    itr->second.pre_lunch_from + " -> " + itr->second.pre_lunch_to + '\n' +
                                    itr->second.post_lunch_from + " -> " + itr->second.post_lunch_to).c_str(),
                             m_message, MB_OK);
  }
}
//---------------------------------------------------------------------------


