//---------------------------------------------------------------------------

#ifndef codeSpecialTimesheetH
#define codeSpecialTimesheetH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <Grids.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
struct timesheet_info
{
   string user_id;
   string regular_date;
   string pre_lunch_from;
   string pre_lunch_to;
   string post_lunch_from;
   string post_lunch_to;
};

class TformSpecialTimesheet : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *btnSave;
        TToolButton *btnClose;
        TToolButton *JoeSeparator;
        TGroupBox *groupRegular;
        TListView *listRegularHoursWorked;
        TLabel *lblRegularTotal;
        TLabel *lblRegularTotalHours;
        TEdit *editPreLunchToMinutes;
        TLabel *lblPreLunchToColon;
        TEdit *editPreLunchToHours;
        TLabel *lblPreLunchTo;
        TEdit *editPreLunchFromMinutes;
        TLabel *lblPreLunchFromColon;
        TEdit *editPreLunchFromHours;
        TEdit *editPostLunchFromHours;
        TEdit *editPostLunchFromMinutes;
        TLabel *lblLunch;
        TLabel *editPostLunchTo;
        TEdit *editPostLunchToHours;
        TEdit *editPostLunchToMinutes;
        TButton *btnNext;
        TLabel *lblPostLunchFromColon;
        TLabel *lblPostLunchToColon;
        TGroupBox *groupOT;
        TListView *listOTHoursWorked;
        TLabel *lblOTTotal;
        TLabel *lblOTTotalHours;
        TLabel *labelRegularRounded;
        TLabel *lblRegularRoundedHours;
        TLabel *labelOTRounded;
        TDateTimePicker *dateRegular;
        TLabel *lblRegularForDate;
        TLabel *lblOTRoundedHours;
        TLabel *lblRegularForTimes;
        TStaticText *lblNextWeek;
        TStaticText *lblPrevWeek;
        TLabel *lblWeek;
        void __fastcall btnNextClick(TObject *Sender);
        void __fastcall editPreLunchFromHoursKeyPress(TObject *Sender,
          char &Key);
        void __fastcall editPreLunchToHoursKeyPress(TObject *Sender,
          char &Key);
        void __fastcall editPostLunchFromHoursKeyPress(TObject *Sender,
          char &Key);
        void __fastcall editPostLunchToHoursKeyPress(TObject *Sender,
          char &Key);
        void __fastcall editPreLunchFromMinutesKeyPress(TObject *Sender,
          char &Key);
        void __fastcall editPreLunchToMinutesKeyPress(TObject *Sender,
          char &Key);
        void __fastcall editPostLunchFromMinutesKeyPress(TObject *Sender,
          char &Key);
        void __fastcall editPostLunchToMinutesKeyPress(TObject *Sender,
          char &Key);
        void __fastcall btnCloseClick(TObject *Sender);
        void __fastcall btnSaveClick(TObject *Sender);
        void __fastcall FormShortCut(TWMKey &Msg, bool &Handled);
        void __fastcall dateRegularChange(TObject *Sender);
        void __fastcall editChange(TObject *Sender);
        void __fastcall lblPrevWeekClick(TObject *Sender);
        void __fastcall lblNextWeekClick(TObject *Sender);
private:	// User declarations
        float total_regular_hours;
        float total_regular_rounded;
        float total_overtime_hours;
        float total_overtime_rounded;
        map<string, timesheet_info> timesheet;
        TDate week_begin, prev_week_begin;
        TDate week_end, prev_week_end;
        bool just_started, saved;
        void AddListItem(string, string, string, string, string, bool);
        void RefreshList();
        void ChangeWeek(TDate);
        void LoadData();
        void SaveData();
        void DebugTimesheet();
public:		// User declarations
        __fastcall TformSpecialTimesheet(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TformSpecialTimesheet *formSpecialTimesheet;
//---------------------------------------------------------------------------
#endif
