//---------------------------------------------------------------------------

#ifndef codeSpecialTransactionEntryH
#define codeSpecialTransactionEntryH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <Mask.hpp>
#include <ToolWin.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
void SetupTransactionSummaryView   (edit_listview & listview_handler, bool show_account_name, bool show_tax_entity_name);
void RefreshTransactionSummaryView (edit_listview & listview_handler, bool show_account_name, bool show_tax_entity_name, const vector<map<string, string> > & preview_data);
//---------------------------------------------------------------------------
class TformSpecialTransactionEntry : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *buttonSave;
        TToolButton *buttonCancel;
        TPageControl *pageTransactions;
        TTabSheet *sheetTransactions;
        TTabSheet *sheetBudgets;
        TGroupBox *groupTransactions;
        TLabel *_labelAccount;
        TLabel *_labelAmount;
        TLabel *_labelDollar0;
        TLabel *_labelTaxEntity;
        TLabel *labelSplitUpBy;
        TListView *listTransactions;
        TButton *buttonTransactionsAdd;
        TButton *buttonTransactionsRemove;
        TButton *buttonTransactionsClear;
        TEdit *editAccount;
        TButton *buttonExpandAccount;
        TBitBtn *buttonSearchAccount;
        TEdit *editAmount;
        TButton *buttonTransactionsSave;
        TStaticText *staticTaxEntity;
        TBitBtn *buttonSearchTaxEntity;
        TButton *buttonTransactionsRevert;
        TCheckBox *checkShowAccount;
        TCheckBox *checkShowName;
        TToolButton *buttonTransactions;
        TToolButton *buttonBudgets;
        TToolButton *sepB;
        TGroupBox *groupBudgets;
        TListView *listBudgets;
        TLabel *_labelBalance;
        TLabel *labelBalance;
        TCheckBox *checkDisableMagic;
        TButton *buttonTransactionsBalance;
        TBitBtn *buttonTransactionsConvert;
        TPopupMenu *popupTransactionsConvert;
        TMenuItem *menuConvertToExpense;
        TMenuItem *menuConvertToPayable;
        TMenuItem *menuConvertToCash;
        TMenuItem *menuConvertToReceivable;
        TMenuItem *menuConvertToRevenue;
        TMenuItem *N1;
        TMenuItem *menuConvertToEquity;
        TMenuItem *menuConvertToAsset;
        TBitBtn *buttonFrequentAccounts;
        TPopupMenu *popupFrequentAccounts;
        TMenuItem *N2;
        TMenuItem *menuAddFrequentAccount;
        TMenuItem *menuRemoveFrequentAccount;
        void __fastcall checkShowClick(TObject *Sender);
        void __fastcall buttonTransactionsAddClick(TObject *Sender);
        void __fastcall buttonTransactionsRemoveClick(TObject *Sender);
        void __fastcall buttonTransactionsClearClick(TObject *Sender);
        void __fastcall buttonTransactionsRevertClick(TObject *Sender);
        void __fastcall buttonTransactionsSaveClick(TObject *Sender);
        void __fastcall buttonExpandAccountClick(TObject *Sender);
        void __fastcall buttonSearchAccountClick(TObject *Sender);
        void __fastcall buttonSearchTaxEntityClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall buttonSaveClick(TObject *Sender);
        void __fastcall buttonCancelClick(TObject *Sender);
        void __fastcall buttonTransactionsClick(TObject *Sender);
        void __fastcall buttonBudgetsClick(TObject *Sender);
        void __fastcall buttonTransactionsBalanceClick(TObject *Sender);
        void __fastcall sheetBudgetsShow(TObject *Sender);
        void __fastcall menuConvertToAnyClick(TObject *Sender);
        void __fastcall popupTransactionsConvertPopup(TObject *Sender);
        void __fastcall buttonTransactionsConvertClick(TObject *Sender);
        void __fastcall buttonFrequentAccountsClick(TObject *Sender);
        void __fastcall menuAddFrequentAccountClick(TObject *Sender);
        void __fastcall menuUseFrequentAccountClick(TObject *Sender);
        void __fastcall menuRemoveFrequentAccountClick(TObject *Sender);
        void __fastcall editAmountKeyPress(TObject *Sender, char &Key);
private:	// User declarations
        bool use_entities;

        transaction_summary original_data;
        transaction_summary current_data;
        transaction_summary * return_current_data;
        // transaction_summary difference_data = current_data - original_data

        edit_listview edit_transactions;
        edit_listview edit_budgets;
        string current_tax_entity_id;
        string default_tax_entity_id;
        financial default_amount;

        map<string, financial> budget_amounts;

        bool was_balanced;
        void TransactionRowSelected ();
        void CheckCurrentBalance ();
        void RefreshBudgets ();
        void RefreshFrequentAccounts();
public:		// User declarations
        __fastcall TformSpecialTransactionEntry(TComponent* Owner, const transaction_summary & p_original_data, transaction_summary * p_current_data, string p_default_tax_entity_id, financial p_default_amount, bool p_use_entities);
};
//---------------------------------------------------------------------------
extern PACKAGE TformSpecialTransactionEntry *formSpecialTransactionEntry;
//---------------------------------------------------------------------------
#endif
