//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialTransactionSummary.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialTransactionSummary *formSpecialTransactionSummary;
//---------------------------------------------------------------------------
__fastcall TformSpecialTransactionSummary::TformSpecialTransactionSummary(TComponent* Owner, string p_item_id, string p_item_table)
        : TformSpecialGeneric(Owner), summarizer(this, listBefore)
{
  item_id = p_item_id;
  item_table = p_item_table;
  if (item_table == "tasks")
    tx_fk = "task_id";
  else if (item_table == "bills")
    tx_fk = "bill_id";
  else if (item_table == "tax_entities")
    tx_fk = "tax_entity_id";
  else if (item_table == "accounts")
    tx_fk = "account_id";

  if (Owner)
    panelTopLink->Visible = false;

  string get_old_transactions;
  if (item_table == "purchase_reqs")
    get_old_transactions = "select * from transactions inner join bills on transactions.bill_id = bills.id where bills.purchase_req_id = " + item_id;
  else if (item_table == "checks")
  {
    get_old_transactions = "select * from transactions inner join bills on transactions.bill_id = bills.id "
                           "inner join purchase_reqs on bills.purchase_req_id = purchase_reqs.id where purchase_reqs.check_id = " + item_id;
  }
  else
    get_old_transactions = "select * from transactions where " + tx_fk + " = " + item_id;

  // jhaley: use summarizer utility class - it's not just the founder, it's a client too.
  summarizer.SetSQLStatement(get_old_transactions);
  summarizer.SetRecord(item_table, item_id, tx_fk, RefreshHandler(&(TformSpecialTransactionSummary::AtlasEvent)));

  // jhaley: also needed here now, to initially setup link, since summarizer only invokes its own RefreshDataSet method and
  // not this class's Atlas event handler during its construction.
  CreateLink(staticItem, NULL, this, item_id, item_table);
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTransactionSummary::checkBeforeClick(TObject *Sender)
{
  // refresh the stuff - jhaley: use summarizer
  summarizer.SetShowAccount(checkBeforeShowAccount->Checked);
  summarizer.SetShowName(checkBeforeShowName->Checked);
  summarizer.CheckBoxClicked();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTransactionSummary::buttonCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialTransactionSummary::FormClose(TObject *Sender, TCloseAction &Action)
{
  Action = caFree;
  TformSpecialGeneric::FormClose(Sender, Action);
  summarizer.Close(Action); // jhaley: use summarizer
}
//---------------------------------------------------------------------------
void TformSpecialTransactionSummary::AtlasEvent(int request_num, string matched_value)
{
  CreateLink(staticItem, NULL, this, item_id, item_table);
  summarizer.AtlasRefresh(request_num, matched_value); // jhaley: use summarizer
}
//---------------------------------------------------------------------------
// jhaley 20100908: classTransactionSummarizer methods start here vvvv
//---------------------------------------------------------------------------
//  Constructor:
classTransactionSummarizer::classTransactionSummarizer(TformSpecialGeneric *p_parent_form, TListView *p_list_view)
  : sql(""), is_valid(false), show_account(true), show_name(true), id_request_num(0), fk_request_num(0),
    parent_form(p_parent_form), list_view(p_list_view), edit_before(), params()
{
  edit_before.setup_listview(list_view, false);
}
//---------------------------------------------------------------------------
// Form close handler
void classTransactionSummarizer::Close(TCloseAction Action)
{
  if (Action == caFree)
    edit_before.setup_listview(NULL, false);
}
//---------------------------------------------------------------------------
// Refresh the list view
void classTransactionSummarizer::RefreshDataSet()
{
  if (!is_valid)
    return;

  vector<map<string, string> > old_transactions;

  if (!SqlToVecMap(dbDatabase, sql, old_transactions))
  {
    parent_form->PSay("Failed to retrieve old transactions for this item.", m_database_error, MB_OK);
    return;
  }

  params = transaction_summary(old_transactions);

  CheckBoxClicked();
}
//---------------------------------------------------------------------------
// Atlas refresh handler
void classTransactionSummarizer::AtlasRefresh(int request_num, string matched_value)
{
  if (request_num > 0 && (request_num != id_request_num && request_num != fk_request_num))
    return;
  RefreshDataSet();
}

//---------------------------------------------------------------------------
// Call to empty this out, typically from IsNewAgain
void classTransactionSummarizer::Clear()
{
  if (is_valid)
  {
    is_valid = false;
    SetSQLStatement("");
    edit_before.clear_data();
  }
}
//---------------------------------------------------------------------------
// Check box click handler
void classTransactionSummarizer::CheckBoxClicked()
{
  if (!is_valid)
    return;

  vector<map<string, string> > current_data = params.GetPreviewOutput(true);
  RefreshTransactionSummaryView(edit_before, show_account, show_name, current_data);
}
//---------------------------------------------------------------------------
// Set show_account status for sorting/grouping
void classTransactionSummarizer::SetShowAccount(bool p_show_account)
{
  show_account = p_show_account;
}
//---------------------------------------------------------------------------
// Set show_name status for sorting/grouping
void classTransactionSummarizer::SetShowName(bool p_show_name)
{
  show_name = p_show_name;
}
//---------------------------------------------------------------------------
// Set record data - call SetSQLStatment first.
void classTransactionSummarizer::SetRecord(const string &p_item_table, const string &p_item_id, const string &p_tx_fk, RefreshHandler refresh_method)
{
  if (sql == "") // must have valid SQL first.
    return;

  // comment moved here from TformSpecialTransactionSummary constructor - still a valid issue, though I don't see how it can
  // be changed since this relies so heavily on RefreshTransactionSummaryView, which doesn't play with filters AFAIK:

  // BEFORE YOU ASK -- yes, this could have been done with a filter. would have looked the same.
  // but as i already had code to do this elsewhere, and they're used to this (that is, they don't
  // expect to hide columns at random, especially when they're also grouping, etc.)
  // TODO -c HACK : yes, you're welcome to fix this with a filter if it's driving you batty. this is a quick hack and it works.
  // (we don't have an awful lot of listviews that do grouping ... not even search screens ... )

  id_request_num = atlas->RequestNotificationWhen(p_item_table + ".id", p_item_id, rel_e, as_int, parent_form, refresh_method);
  fk_request_num = atlas->RequestNotificationWhen("transactions." + p_tx_fk, p_item_id, rel_e, as_int, parent_form, refresh_method);
  is_valid = true;
  RefreshDataSet();
}
//---------------------------------------------------------------------------
// Set SQL query
void classTransactionSummarizer::SetSQLStatement(const string &p_sql)
{
  sql = p_sql;
}
//---------------------------------------------------------------------------

