//---------------------------------------------------------------------------

#ifndef codeSpecialUpdatesNeededH
#define codeSpecialUpdatesNeededH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TformSpecialUpdatesNeeded : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *btnClose;
        TToolButton *btnView;
        TPopupMenu *popupView;
        TMenuItem *menuConsents;
        TMenuItem *menuMedicaid;
        TListView *listPeople;
        TToolButton *btnSelectAll;
        TToolButton *btnUnselectAll;
        TToolButton *sepB;
        TToolButton *btnPrint;
        TPopupMenu *popupReport;
        TMenuItem *menuPrintReport;
        TMenuItem *menuPrintLabels;
        TListView *listMedicaid;
        TToolButton *btnSelection;
        TPopupMenu *popupSelection;
        TMenuItem *menuCheck;
        TMenuItem *menuUncheck;
        TMenuItem *menuFlip;
        TToolButton *btnDates;
        TPopupMenu *popupDates;
        TMenuItem *menuDatesLastSix;
        TMenuItem *menuDatesNoCutoff;
        void __fastcall btnCloseClick(TObject *Sender);
        void __fastcall btnSelectAllClick(TObject *Sender);
        void __fastcall btnUnselectAllClick(TObject *Sender);
        void __fastcall menuMedicaidClick(TObject *Sender);
        void __fastcall menuConsentsClick(TObject *Sender);
        void __fastcall menuPrintReportClick(TObject *Sender);
        void __fastcall btnViewClick(TObject *Sender);
        void __fastcall btnPrintClick(TObject *Sender);
        void __fastcall popupViewPopup(TObject *Sender);
        void __fastcall popupReportPopup(TObject *Sender);
        void __fastcall menuPrintLabelsClick(TObject *Sender);
        void __fastcall btnSelectionClick(TObject *Sender);
        void __fastcall popupSelectionPopup(TObject *Sender);
        void __fastcall popupSelectionItemClick(TObject *Sender);
        void __fastcall btnDatesClick(TObject *Sender);
        void __fastcall popupDatesPopup(TObject *Sender);
        void __fastcall menuDatesLastSixClick(TObject *Sender);
        void __fastcall menuDatesNoCutoffClick(TObject *Sender);
private:	// User declarations
        classFilterObject person_filter;
        classFilterObject medicaid_filter;
        string consent_sql;
        string consent_having_all_sql;
        string consent_having_sixmo_sql;
        string medicaid_sql;
        string caption;
        Pdate children_date;
        Pdate six_months;
        Pdate five_months;
        Pdate medicaid_weeks;
        vector<int> atlas_requests;
        vector<string> medicaid_companies_vec;
public:		// User declarations
        __fastcall TformSpecialUpdatesNeeded(TComponent* Owner, bool show_consents);
        void EditPerson();
        void DisplayConsents();
        void DisplayMedicaid();
        void SetUpAtlasRequests();
        bool AtlasRefreshListView(int request_num, string matched_value);
        void DoFilterStuff();
};
//---------------------------------------------------------------------------
extern PACKAGE TformSpecialUpdatesNeeded *formSpecialUpdatesNeeded;
//---------------------------------------------------------------------------
#endif
