//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "codeSpecialUploadComputerRx.h"
#include "reportNewPharmacyPeople.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialUploadComputerRx *formSpecialUploadComputerRx;
//---------------------------------------------------------------------------
__fastcall TformSpecialUploadComputerRx::TformSpecialUploadComputerRx(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialUploadComputerRx::editDirectoryDblClick(TObject *Sender)
{
/* This code requires
   #include <shlobj.h>
   which is broken under BCB5.  The workaround is to also add the conditional
   include NO_WIN32_LEAN_AND_MEAN to the project options, which I've done.
*/
    BROWSEINFO    info;
    char          szDir[MAX_PATH];
    char          szDisplayName[MAX_PATH];
    LPITEMIDLIST  pidl;
    LPMALLOC      pShellMalloc;
                              
    // SHBrowseForFolder returns a PIDL. The memory for the PIDL is
    // allocated by the shell. Eventually, we will need to free this
    // memory, so we need to get a pointer to the shell malloc COM
    // object that will free the PIDL later on.
    if(SHGetMalloc(&pShellMalloc) == NO_ERROR)
    {
        // if we were able to get the shell malloc object,
        // then proceed by initializing the BROWSEINFO stuct
        memset(&info, 0x00,sizeof(info));
        info.hwndOwner = Handle;                 // Owner window
        info.pidlRoot  = 0;                      // root folder
        info.pszDisplayName = szDisplayName;     // return display name
        info.lpszTitle = "Select the directory containing the ComputerRx CSV files."; // label caption
        info.ulFlags   = BIF_RETURNONLYFSDIRS;   // config flags
        info.lpfn = 0;                           // callback function

        // execute the browsing dialog
        pidl = SHBrowseForFolder(&info);

        // pidl will be null if they cancel the browse dialog.
        // pidl will be not null when they select a folder
        if(pidl)
        {
            // try to convert the pidl to a display string
            // return is true if success
            if(SHGetPathFromIDList(pidl, szDir))
            {
                // set one caption to the directory path
                editDirectory->Text = szDir;
            }

            // set another caption based on the display name
            //Label2->Caption = info.pszDisplayName;

            // use the shell malloc com object to free the pidl.
            // then call Relasee to signal that we don't need
            // the shell malloc object anymore
            pShellMalloc->Free(pidl);
        }
        pShellMalloc->Release();
    }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialUploadComputerRx::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialUploadComputerRx::btnUploadClick(TObject *Sender)
{
  if(IsValidOnScreen())
  {
    btnUpload->Enabled = false;
    btnClose->Enabled = false;
    this->Update();

    fstream input_file;
    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    string sql;
    string pharmacy_type_id;
    string pharmacy_location_id;
    string person_id;
    string dob;
    string cdib;
    string last_name;
    string message;
    string first_name;
    string line;
    string store_number = "";
    list<string> new_people;
    map<string, string> insert_map;
    map<string, string> person_map;
    map<string, string> affiliations_map; // don't currently have this but maybe ComputerRx can get us this info in the export files
    map<string, string> name_map;
    map<string, string> store_map;
    vector<map<string, string> > store_vec;
    string bill_month = "";
    string bill_year = "";\
    bool all_is_well = true;

    StdTransaction(dbTransaction, dbDatabase);

    directory_name = editDirectory->Text.c_str();
    if(directory_name.substr(directory_name.length()-1, 1) != "\\")
      directory_name += "\\";

    // Drug Data is the easiest to upload, and DailySalesRx links to it, so let's upload it first.
    input_file.open((directory_name + "DailySalesRx.csv").c_str(), ios::in | ios::nocreate);
    if(input_file && all_is_well)
    {
      try
      {
        pharmacy_type_id = lookupTables->IdOf("pharmacy_types", "Wal Mart");
        sql = "select store_number, id from pharmacy_locations where pharmacy_id = " + pharmacy_type_id;
        SqlToVecMap(dbTransaction, sql, store_vec);
        for(vector<map<string, string> >::iterator itr = store_vec.begin(); itr != store_vec.end(); itr++)
          store_map[(*itr)["store_number"]] = (*itr)["id"];

        float total_amount_billed = 0.00;
        while (! input_file.eof())
        {
          insert_map.clear();
          getline(input_file, line);
          if (line.substr(0, 1) == "2")
          {
            pharmacy_location_id = "";
            store_number = IntToString(StringToInt(line.substr(16, 6)));
            pharmacy_location_id = store_map[store_number];

            if (pharmacy_location_id == "")
            {
              pharmacy_location_id = GetNextId(dbTransaction, "pharmacy_locations");
              insert_map["store_number"] = store_number;
              insert_map["address"] = StripTrailing(line.substr(48, 20), " ");
              insert_map["city"] = StripTrailing(line.substr(68, 18), " ");
              insert_map["state"] = StripTrailing(line.substr(86, 2), " ");
              string zip = StripTrailing(line.substr(88, 9), " ");
              if(zip.substr(5) == "0000") zip = zip.substr(0, 5);
              if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "codeSpecialUploadWalMart: store #: '" + store_number + "', zip: '" + zip + "'");
              insert_map["zip"] = zip;
              insert_map["phone"] = StripTrailing(line.substr(97, 10), " ");
              insert_map["id"] = pharmacy_location_id;
              insert_map["pharmacy_id"] = pharmacy_type_id;
              //ExecuteInsertStatement(dbTransaction, "pharmacy_locations", insert_map);
            }
          }
          // end if record type 2

          else if (line.substr(0, 1) == "4")
          {
            insert_map["pharmacy_location_id"] = pharmacy_location_id;
            insert_map["rx_number"] = StripTrailing(line.substr(28, 7), " ");
            insert_map["dispense_date"] = line.substr(39, 2) + "/" + line.substr(41, 2) +
                                         "/" + line.substr(35, 4);
            insert_map["ndc_number"] = line.substr(43, 11);
            string drug_name = UppercaseString(StripTrailing(line.substr(54, 30), " "));
            string drug_strength = StripLeading(UppercaseString(StripTrailing(line.substr(468, 10), " ")), "0");
            if (drug_strength.length() > 0)
            {
               float actual_strength = StringToFloat(drug_strength) / 100;
               drug_name = drug_name + " - " + FloatToString(actual_strength) + " MG";
            }
            insert_map["drug_name"] = drug_name;
            insert_map["refill_number"] = IntToString(StringToInt(line.substr(84, 2)));
            insert_map["quantity_filled"] = IntToString(StringToInt(line.substr(86, 5)));
            insert_map["days_supply"] = IntToString(StringToInt(line.substr(91, 3)));
            insert_map["ingredient_cost"] = ConvertStupidNumber(line.substr(96, 6));
            insert_map["dispense_cost"] = ConvertStupidNumber(line.substr(102, 6));
            insert_map["copay"] = ConvertStupidNumber(line.substr(108, 6));
            insert_map["tax"] = ConvertStupidNumber(line.substr(114, 6));
            insert_map["amount_billed"] = ConvertStupidNumber(line.substr(120, 6));
            if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "codeSpecialUploadWalMart: drug: '" + drug_name + "', $" + insert_map["amount_billed"]);
            total_amount_billed += StringToFloat(insert_map["amount_billed"]);
            first_name = UppercaseString(StripTrailing(line.substr(126, 12), " "));
            if(first_name.find(" ") != string::npos)
              first_name = first_name.substr(0, first_name.find_first_of(" "));
            if (first_name == "")
              first_name = " ";
            last_name = UppercaseString(StripTrailing(line.substr(138, 15), " "));
            last_name = StripTrailing(StripTrailing(last_name, ","), " ");;
            if(last_name.find(" ") != string::npos)
              if ((last_name.substr(0, last_name.find_first_of(" ")) != "LITTLE") &&
                  (last_name.substr(0, last_name.find_first_of(" ")) != "NEW"))
              {
                 last_name = last_name.substr(0, last_name.find_first_of(" "));
                 last_name = StripTrailing(StripTrailing(last_name, ","), " ");;
              }
            if (last_name == "")
              last_name = " ";
            if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "codeSpecialUploadWalMart: name: '" + first_name + " " + last_name + "'");
            dob = line.substr(157, 2) + "/" + line.substr(159, 2) + "/" + line.substr(153, 4);

            if (dob == "11/11/1911") dob = "";
            cdib = StripTrailing(StripLeading(line.substr(162, 18), "0"), " ");

            insert_map["physician_dea_number"] = StripTrailing(line.substr(202, 10), " ");
            insert_map["bill_month"] = bill_month;
            insert_map["bill_year"] = bill_year;
            insert_map["current_id"] = "4";
            insert_map["last_updated_by"] = current_userid;
            insert_map["last_update_stamp"] = RightNow();

            insert_map["id"] = GetNextId(dbTransaction, "pharmacy_info");
            ExecuteInsertStatement(dbTransaction, "pharmacy_info", insert_map);
          }
        } // end while
        input_file.close();

      } // end try
      catch (EIBError &error)
      {
        if (dbTransaction->Active)
          dbTransaction->Rollback();
        message = "There was an error:\n";
        message += error.Message.c_str();
        PSay(message, m_database_error, MB_OK);
      }
    } // end if input file
    else
    {
      PSay("Could not open DrugData.csv", m_program_error, MB_OK);
      all_is_well = false;
    }

    //Apparently we don't care about DailyThirdPartyData (attempts to bill insurance for the patient)
    //or InsuranceCompanyData (it looks pretty useless and we--well, we don't care).

    //So let's take care of this big file that tracks prescriptions filled.  We'll create people as we go,
    //if necessary.  "If necessary" will be more interesting with this data than Wal/Eck since we don't have
    //a DOB, SSN, or CDIB to help.  Oh, but we have an address.  Great.  Yeah.  That'll help tons.
    input_file.open((directory_name + "DailySalesRx.csv").c_str(), ios::in | ios::nocreate);
    if(input_file && all_is_well)
    {
      try
      {
        dbTransaction->DefaultDatabase = dbDatabase;
        dbTransaction->StartTransaction();
        pharmacy_type_id = lookupTables->IdOf("pharmacy_types", "Wal Mart");
        sql = "select store_number, id from pharmacy_locations where pharmacy_id = " + pharmacy_type_id;
        SqlToVecMap(dbTransaction, sql, store_vec);
        for(vector<map<string, string> >::iterator itr = store_vec.begin(); itr != store_vec.end(); itr++)
          store_map[(*itr)["store_number"]] = (*itr)["id"];

        float total_amount_billed = 0.00;
        while (! input_file.eof())
        {
          insert_map.clear();
          getline(input_file, line);
          if (line.substr(0, 1) == "2")
          {
            pharmacy_location_id = "";
            store_number = IntToString(StringToInt(line.substr(16, 6)));
            pharmacy_location_id = store_map[store_number];

            if (pharmacy_location_id == "")
            {
              pharmacy_location_id = GetNextId(dbTransaction, "pharmacy_locations");
              insert_map["store_number"] = store_number;
              insert_map["address"] = StripTrailing(line.substr(48, 20), " ");
              insert_map["city"] = StripTrailing(line.substr(68, 18), " ");
              insert_map["state"] = StripTrailing(line.substr(86, 2), " ");
              string zip = StripTrailing(line.substr(88, 9), " ");
              if(zip.substr(5) == "0000") zip = zip.substr(0, 5);
              if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "codeSpecialUploadWalMart: store #: '" + store_number + "', zip: '" + zip + "'");
              insert_map["zip"] = zip;
              insert_map["phone"] = StripTrailing(line.substr(97, 10), " ");
              insert_map["id"] = pharmacy_location_id;
              insert_map["pharmacy_id"] = pharmacy_type_id;
              //ExecuteInsertStatement(dbTransaction, "pharmacy_locations", insert_map);
            }
          }
          // end if record type 2

          else if (line.substr(0, 1) == "4")
          {
            insert_map["pharmacy_location_id"] = pharmacy_location_id;
            insert_map["rx_number"] = StripTrailing(line.substr(28, 7), " ");
            insert_map["dispense_date"] = line.substr(39, 2) + "/" + line.substr(41, 2) +
                                         "/" + line.substr(35, 4);
            insert_map["ndc_number"] = line.substr(43, 11);
            string drug_name = UppercaseString(StripTrailing(line.substr(54, 30), " "));
            string drug_strength = StripLeading(UppercaseString(StripTrailing(line.substr(468, 10), " ")), "0");
            if (drug_strength.length() > 0)
            {
               float actual_strength = StringToFloat(drug_strength) / 100;
               drug_name = drug_name + " - " + FloatToString(actual_strength) + " MG";
            }
            insert_map["drug_name"] = drug_name;
            insert_map["refill_number"] = IntToString(StringToInt(line.substr(84, 2)));
            insert_map["quantity_filled"] = IntToString(StringToInt(line.substr(86, 5)));
            insert_map["days_supply"] = IntToString(StringToInt(line.substr(91, 3)));
            insert_map["ingredient_cost"] = ConvertStupidNumber(line.substr(96, 6));
            insert_map["dispense_cost"] = ConvertStupidNumber(line.substr(102, 6));
            insert_map["copay"] = ConvertStupidNumber(line.substr(108, 6));
            insert_map["tax"] = ConvertStupidNumber(line.substr(114, 6));
            insert_map["amount_billed"] = ConvertStupidNumber(line.substr(120, 6));
            if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "codeSpecialUploadWalMart: drug: '" + drug_name + "', $" + insert_map["amount_billed"]);
            total_amount_billed += StringToFloat(insert_map["amount_billed"]);
            first_name = UppercaseString(StripTrailing(line.substr(126, 12), " "));
            if(first_name.find(" ") != string::npos)
              first_name = first_name.substr(0, first_name.find_first_of(" "));
            if (first_name == "")
              first_name = " ";
            last_name = UppercaseString(StripTrailing(line.substr(138, 15), " "));
            last_name = StripTrailing(StripTrailing(last_name, ","), " ");;
            if(last_name.find(" ") != string::npos)
              if ((last_name.substr(0, last_name.find_first_of(" ")) != "LITTLE") &&
                  (last_name.substr(0, last_name.find_first_of(" ")) != "NEW"))
              {
                 last_name = last_name.substr(0, last_name.find_first_of(" "));
                 last_name = StripTrailing(StripTrailing(last_name, ","), " ");;
              }
            if (last_name == "")
              last_name = " ";
            if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "codeSpecialUploadWalMart: name: '" + first_name + " " + last_name + "'");
            dob = line.substr(157, 2) + "/" + line.substr(159, 2) + "/" + line.substr(153, 4);

            if (dob == "11/11/1911") dob = "";
            cdib = StripTrailing(StripLeading(line.substr(162, 18), "0"), " ");

            insert_map["physician_dea_number"] = StripTrailing(line.substr(202, 10), " ");
            insert_map["bill_month"] = bill_month;
            insert_map["bill_year"] = bill_year;
            insert_map["current_id"] = "4";
            insert_map["last_updated_by"] = current_userid;
            insert_map["last_update_stamp"] = RightNow();

            sql = "select people.id from people, person_names, affiliations where person_names.person_id = "
                  "people.id and person_names.last_name = '" + SafeSQLString(last_name) + "' and "
                  "person_names.first_name = '" + SafeSQLString(first_name) + "' and "
                  "affiliations.person_id = people.id";
            if (dob != "") sql = sql + " and people.birth_date = '" + SafeSQLString(dob) + "'";

            person_id = GetOneField(dbTransaction, sql);
            if(person_id != "")
            {
              insert_map["person_id"] = person_id;
            }
            else
            {
              person_id = GetNextId(dbTransaction, "people");

              person_map.clear();
              person_map["id"] = person_id;
              person_map["current_id"] = "4";
              person_map["last_updated_by"] = current_userid;
              person_map["last_update_stamp"] = RightNow();
              person_map["birth_date"] = dob;
              person_map["gender_id"] = "0";
              person_map["marital_id"] = "0";
              person_map["head_household_id"] = person_id;
              person_map["refused_beh_services"] = "0";
              person_map["person_names_id"] = "0";
              person_map["affiliations_id"] = "0";
              person_map["person_contact_info_id"] = "0";
              person_map["race_id"] = "0";
              person_map["lac_diab_client"] = "0";
              person_map["asc_diab_client"] = "0";
              person_map["in_beh_jurisdiction"] = "0";
              person_map["is_primary_support"] = "0";
              person_map["refused_public_services"] = "0";
              person_map["refused_com_services"] = "0";
              person_map["diab_provider_id"] = "0";
              if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "codeSpecialUploadWalMart: inserting into people");
              ExecuteInsertStatement(dbTransaction, "people", person_map);

              affiliations_map.clear();
              affiliations_map["id"] = person_id;
              affiliations_map["current_id"] = "4";
              affiliations_map["last_updated_by"] = current_userid;
              affiliations_map["last_update_stamp"] = RightNow();
              affiliations_map["person_id"] = person_id;
              affiliations_map["cdib"] = cdib;
              affiliations_map["tribe_id"] = lookupTables->IdOf("tribe_types", "ABSENTEE SHAWNEE TRIBES OF OKLAHOMA");
              // Join and Relinquish Dates will be null since we're not setting them...
              ExecuteInsertStatement(dbTransaction, "affiliations", affiliations_map);

              name_map.clear();
              name_map["id"] = GetNextId(dbTransaction, "person_names");
              name_map["current_id"] = "4";
              name_map["last_updated_by"] = current_userid;
              name_map["last_update_stamp"] = RightNow();
              name_map["person_id"] = person_id;
              name_map["last_name"] = last_name;
              name_map["first_name"] = first_name;
              name_map["middle_name"] = " ";
              name_map["prefix"] = " ";
              name_map["suffix"] = " ";
              ExecuteInsertStatement(dbTransaction, "person_names", name_map);

              new_people.push_back(person_id);
              insert_map["person_id"] = person_id;
            }

            insert_map["id"] = GetNextId(dbTransaction, "pharmacy_info");
            ExecuteInsertStatement(dbTransaction, "pharmacy_info", insert_map);
          }
        } // end while
        input_file.close();

        if(! new_people.empty())
        {
          sql = "select people.id, person_names.last_name || ', ' || person_names.first_name name, "
                "people.birth_date, affiliations.cdib from people left join person_names on "
                "people.person_names_id = person_names.id "
                "left join affiliations on affiliations.person_id = people.id "
                "where people.id in (";
          for(list<string>::iterator itr = new_people.begin(); itr != new_people.end(); itr++)
            sql += *itr + ", ";
          sql = sql.substr(0, sql.length() - 2);
          sql += ")";
          TIBDataSet * dbDataset = new TIBDataSet(NULL);
          dbDataset->Database = dbDatabase;
          dbDataset->Transaction = dbTransaction;

          dbDataset->SelectSQL->Add(sql.c_str());
          dbDataset->Open();

          FORM_TRY
             TformReportNewPharmacyPeople * report_form = new TformReportNewPharmacyPeople(NULL);
             report_form->report->DataSet = dbDataset;
             report_form->lblDateTitle->Caption = DateToStr(Date());
             report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
             report_form->txtId->DataSet = dbDataset;
             report_form->txtId->DataField = "id";
             report_form->txtName->DataSet = dbDataset;
             report_form->txtName->DataField = "name";
             report_form->txtDob->DataSet = dbDataset;
             report_form->txtDob->DataField = "birth_date";
             report_form->txtCDIB->DataSet = dbDataset;
             report_form->txtCDIB->DataField = "cdib";
             report_form->report->Preview();
          FORM_CATCH
          dbDataset->Close();
          delete dbDataset;
        }
        dbTransaction->Commit();

        PSay("Total amount billed:  $" + StringToAmount(FloatToString(total_amount_billed)), m_message, MB_OK);
      } // end try
      catch (EIBError &error)
      {
        if (dbTransaction->Active)
          dbTransaction->Rollback();
        message = "There was an error:\n";
        message += error.Message.c_str();
        PSay(message, m_database_error, MB_OK);
      }
    } // end if input file
    else
    {
      PSay("Could not open DailySalesRx.csv.  Import aborted.", m_program_error, MB_OK);
      all_is_well = false;
    }

    delete dbTransaction;

    btnUpload->Enabled = true;
    btnClose->Enabled = true;
  } // end if is valid on screen}
}
//---------------------------------------------------------------------------
bool TformSpecialUploadComputerRx::IsValidOnScreen()
{
  if(editDirectory->Text == "")
  {
    PSay("Please select a directory", m_missing_data, MB_OK);
    editDirectory->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------