//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialUploadEckerd.h"
#include "reportNewPharmacyPeople.h"
#define y2kcutoff 5
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialUploadEckerd *formSpecialUploadEckerd;
//---------------------------------------------------------------------------
__fastcall TformSpecialUploadEckerd::TformSpecialUploadEckerd(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  upDownYear->Position = Pstamp(RightNow(), mdy | yyyy | datefirst | withsec).year;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialUploadEckerd::editFileNameDblClick(TObject *Sender)
{
  if(openDialog->Execute())
  {
    file_name = openDialog->FileName.c_str();
    editFileName->Text = file_name.c_str();
    cboMonth->SetFocus();
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialUploadEckerd::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialUploadEckerd::btnUploadClick(TObject *Sender)
{
  if(IsValidOnScreen())
  {
    btnUpload->Enabled = false;
    btnClose->Enabled = false;
    this->Update();

    fstream input_file;
    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    unsigned int from = 0;
    string sql;
    string pharmacy_type_id;
    string pharmacy_id;
    string person_id;
    string dob;
    string cdib;
    string last_name;
    string message;
    string first_name;
    string file_contents;
    string store_number = "";
    list<string> new_people;
    map<string, string> insert_map;
    map<string, string> person_map;
    map<string, string> affiliations_map;
    map<string, string> name_map;
    map<string, string> store_map;
    vector<map<string, string> > store_vec;
    string bill_month = lookupTables->IdOf("month_types", cboMonth->Text.c_str());
    string bill_year = editYear->Text.c_str();

    input_file.open(file_name.c_str(), ios::in | ios::nocreate);
    if(input_file)
    {
      try
      {
        StdTransaction(dbTransaction, dbDatabase);
        getline (input_file, file_contents);
        file_contents = file_contents.substr(0, file_contents.length() - 1);
        pharmacy_type_id = lookupTables->IdOf("pharmacy_types", "Eckerd");
        sql = "select store_number, id from pharmacy_locations where pharmacy_id = " + pharmacy_type_id;
        SqlToVecMap(dbTransaction, sql, store_vec);
        for(vector<map<string, string> >::iterator itr = store_vec.begin(); itr != store_vec.end(); itr++)
          store_map[(*itr)["store_number"]] = (*itr)["id"];

        while (from != string::npos)
        {
          insert_map.clear();
          if(from < file_contents.length() - 195)
          {
            store_number = file_contents.substr(from, 4);
            insert_map["pharmacy_location_id"] = store_map[store_number];            
            insert_map["rx_number"] = file_contents.substr(from + 4, 7);
            insert_map["refill_number"] = IntToString(StringToInt(file_contents.substr(from + 11, 3)));
            insert_map["dispense_date"] = file_contents.substr(from + 16, 2) + "/" +
              file_contents.substr(from + 18, 2) + "/" + file_contents.substr(from + 14, 2);
            last_name = UppercaseString(StripTrailing(StripAll(file_contents.substr(from + 42, 15), "*+-"), " "));
            last_name = StripTrailing(StripTrailing(last_name, ","), " ");;
            if(last_name.find(" ") != string::npos)
              if ((last_name.substr(0, last_name.find_first_of(" ")) != "LITTLE") &&
                  (last_name.substr(0, last_name.find_first_of(" ")) != "NEW"))
              {
                 last_name = last_name.substr(0, last_name.find_first_of(" "));
                 last_name = StripTrailing(StripTrailing(last_name, ","), " ");;
              }
            if (last_name == "")
              last_name = " ";
            first_name = UppercaseString(StripTrailing(StripAll(file_contents.substr(from + 57, 10), "*+-"), " "));
            if(first_name.find(" ") != string::npos)
              first_name = first_name.substr(0, first_name.find_first_of(" "));
            if (first_name == "")
              first_name = " ";
            if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "codeSpecialUploadEckerd: name: '" + first_name + " " + last_name + "'");
            dob = file_contents.substr(from + 67, 2) + "/" +
                  file_contents.substr(from + 69, 2) + "/" + file_contents.substr(from + 71, 2);
            if (StringToInt(dob.substr(6)) > y2kcutoff)
              dob = dob.substr(0, 6) + "19" + dob.substr(6, 2);
            else
              dob = dob.substr(0, 6) + "20" + dob.substr(6, 2);
            cdib = StripTrailing(StripLeading(file_contents.substr(from + 22, 20), "0"), " ");

            insert_map["physician_name"] = StripTrailing(file_contents.substr(from + 75, 26), " ");
            insert_map["physician_dea_number"] = StripTrailing(file_contents.substr(from + 101, 10), " ");
            insert_map["ndc_number"] = file_contents.substr(from + 111, 11);
            insert_map["drug_name"] = StripTrailing(file_contents.substr(from + 122, 25), " ");
            insert_map["quantity_filled"] = IntToString(StringToInt(file_contents.substr(from + 147, 3)));
            insert_map["ingredient_cost"] = TwoDecimals(file_contents.substr(from + 150, 9));
            insert_map["dispense_cost"] = TwoDecimals(file_contents.substr(from + 159, 9));
            insert_map["tax"] = TwoDecimals(file_contents.substr(from + 168, 9));
            insert_map["copay"] = TwoDecimals(file_contents.substr(from + 177, 9));
            insert_map["amount_billed"] = TwoDecimals(file_contents.substr(from + 186, 9));
            insert_map["bill_month"] = bill_month;
            insert_map["bill_year"] = bill_year;
            insert_map["current_id"] = "4";
            insert_map["last_updated_by"] = current_userid;
            insert_map["last_update_stamp"] = RightNow();

            sql = "select people.id from people, person_names where person_names.person_id = "
                  "people.id and person_names.last_name = '" + last_name + "' and "
                  "person_names.first_name = '" + first_name + "' and "
                  "people.birth_date = '" + dob + "'";

            person_id = GetOneField(dbTransaction, sql);
            if(person_id != "")
            {
              insert_map["person_id"] = person_id;
              if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "codeSpecialUploadEckerd: using existing person_id: " + person_id);
            }
            else
            {
              person_id = GetNextId(dbTransaction, "people");

              person_map.clear();
              person_map["id"] = person_id;
              person_map["current_id"] = "4";
              person_map["last_updated_by"] = current_userid;
              person_map["last_update_stamp"] = RightNow();
              person_map["birth_date"] = dob;
              person_map["gender_id"] = "0";
              person_map["marital_id"] = "0";
              person_map["head_household_id"] = person_id;
              person_map["refused_beh_services"] = "0";
              person_map["person_names_id"] = "0";
              person_map["affiliations_id"] = "0";
              person_map["person_contact_info_id"] = "0";
              person_map["race_id"] = "0";
              person_map["lac_diab_client"] = "0";
              person_map["asc_diab_client"] = "0";
              person_map["in_beh_jurisdiction"] = "0";
              person_map["is_primary_support"] = "0";
              person_map["refused_public_services"] = "0";
              person_map["refused_com_services"] = "0";
              person_map["diab_provider_id"] = "0";
              if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "codeSpecialUploadEckerd: inserting into people");
              ExecuteInsertStatement(dbTransaction, "people", person_map);

              affiliations_map.clear();
              affiliations_map["id"] = person_id;
              affiliations_map["current_id"] = "4";
              affiliations_map["last_updated_by"] = current_userid;
              affiliations_map["last_update_stamp"] = RightNow();
              affiliations_map["person_id"] = person_id;
              affiliations_map["cdib"] = cdib;
              affiliations_map["tribe_id"] = lookupTables->IdOf("tribe_types", "ABSENTEE SHAWNEE TRIBES OF OKLAHOMA");
              // Join and Relinquish Dates will be null since we're not setting them...
              ExecuteInsertStatement(dbTransaction, "affiliations", affiliations_map);

              name_map.clear();
              name_map["id"] = GetNextId(dbTransaction, "person_names");
              name_map["current_id"] = "4";
              name_map["last_updated_by"] = current_userid;
              name_map["last_update_stamp"] = RightNow();
              name_map["person_id"] = person_id;
              name_map["first_name"] = first_name;
              name_map["last_name"] = last_name;
              name_map["middle_name"] = " ";
              name_map["prefix"] = " ";
              name_map["suffix"] = " ";
              if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "codeSpecialUploadEckerd: inserting into person_names");
              ExecuteInsertStatement(dbTransaction, "person_names", name_map);

              new_people.push_back(person_id);
              insert_map["person_id"] = person_id;
              if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "codeSpecialUploadEckerd: using new person_id: " + person_id);
            }
            if(debug_level[other_forms]>=2 && message_router) message_router->SendMessageToAll("debug", "codeSpecialUploadEckerd: inserting into pharmacy_info");
            insert_map["id"] = GetNextId(dbTransaction, "pharmacy_info");
            ExecuteInsertStatement(dbTransaction, "pharmacy_info", insert_map);
            from = from + 200;
          }
          else
            from = string::npos;
        } // end while ! npos

        if(! new_people.empty())
        {
/*          sql = "select people.id, person_names.last_name || ', ' || person_names.first_name name, "
                "people.birth_date from people left join person_names on people.person_names_id = "
                "person_names.id where people.id in (";
                */
          sql = "select people.id, person_names.last_name || ', ' || person_names.first_name name, "
                "people.birth_date, affiliations.cdib "
                "from people left join person_names on people.person_names_id = person_names.id "
                "left join affiliations on affiliations.person_id = people.id "
                "where people.id in (";
          for(list<string>::iterator itr = new_people.begin(); itr != new_people.end(); itr++)
            sql += *itr + ", ";
          sql = sql.substr(0, sql.length() - 2);
          sql += ")";
          TIBDataSet * dbDataset = new TIBDataSet(NULL);
          dbDataset->Database = dbDatabase;
          dbDataset->Transaction = dbTransaction;

          dbDataset->SelectSQL->Add(sql.c_str());
          dbDataset->Open();

          FORM_TRY
            TformReportNewPharmacyPeople * report_form = new TformReportNewPharmacyPeople(NULL);
            report_form->report->DataSet = dbDataset;
            report_form->lblDateTitle->Caption = CurrentDate().c_str();
            report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
            report_form->txtId->DataSet = dbDataset;
            report_form->txtId->DataField = "id";
            report_form->txtName->DataSet = dbDataset;
            report_form->txtName->DataField = "name";
            report_form->txtDob->DataSet = dbDataset;
            report_form->txtDob->DataField = "birth_date";
            //report_form->lblCDIB->Enabled = false;
            //report_form->txtCDIB->Enabled = false;
            report_form->txtCDIB->DataSet = dbDataset;
            report_form->txtCDIB->DataField = "cdib";
            report_form->report->Preview();
          FORM_CATCH
          dbDataset->Close();
          delete dbDataset;
        }
       }
      catch(EIBError &error)
      {
        if (dbTransaction->Active)
          dbTransaction->Rollback();
        message = "There was an error:\n";
        message += error.Message.c_str();
        PSay(message, m_database_error, MB_OK);
      }
      input_file.close();

      dbTransaction->Commit();
    }
    else
    {
      PSay("Could not open file", m_program_error, MB_OK);
    }
    delete dbTransaction;

    btnUpload->Enabled = true;
    btnClose->Enabled = true;
  }
}
//---------------------------------------------------------------------------
bool TformSpecialUploadEckerd::IsValidOnScreen()
{
  if(editFileName->Text == "")
  {
    PSay("Please select a file", m_missing_data, MB_OK);
    editFileName->SetFocus();
    return false;
  }
  else if(! lookupTables->IsInLookUpTable("month_types", cboMonth->Text.c_str()))
  {
    PSay("Please enter a valid month", m_invalid_data, MB_OK);
    cboMonth->SetFocus();
    return false;
  }
  else if(! IsInt(editYear->Text.c_str()))
  {
    PSay("Please enter a valid year", m_invalid_data, MB_OK);
    editYear->SetFocus();
    return false;
  }
  else if(editYear->Text == "")
  {
    PSay("Please enter a year", m_missing_data, MB_OK);
    editYear->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialUploadEckerd::cboYearKeyPress(TObject *Sender,
      char &Key)
{
  FindComboBoxItem(Sender, Key);        
}
//---------------------------------------------------------------------------


