//---------------------------------------------------------------------------

#ifndef codeSpecialUploadFileH
#define codeSpecialUploadFileH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>
#include <Db.hpp>
#include <IBDatabase.hpp>
//---------------------------------------------------------------------------
class TformSpecialUploadFile : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TLabel *lblLocalFile;
        TLabel *lblUploadTo;
        TLabel *lblComments;
        TLabel *lblVersion;
        TEdit *editFileName;
        TEdit *editVersion;
        TRichEdit *editComments;
        TOpenDialog *openDialog;
        TEdit *editUploadTo;
        TToolButton *btnUpload;
        TToolButton *btnClose;
        TIBDatabase *dbUploadDatabase;
        TProgressBar *progressUpload;
        void __fastcall editFileNameDblClick(TObject *Sender);
        void __fastcall btnCloseClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall btnUploadClick(TObject *Sender);
private:	// User declarations
        pvecstr  databases;       // all databases, passed here from the cached file manager
        string   global_database; // the global Prometheus database, to which we're already connected
        pmapstrs file_info;       // file information, passed in from the cached file manager if upping a new version
        int      progress_step;   // amount finishing one upload will step the progress bar
        bool    *did_upload;      // if we upload a file, mark it here so the parent form can refresh the tree view.
public:		// User declarations
        __fastcall TformSpecialUploadFile(TComponent* Owner, vector<string> &p_databases, string p_global_database,
                                          map<string, string> &init_file, bool *p_did_upload = NULL);
};
//---------------------------------------------------------------------------
extern PACKAGE TformSpecialUploadFile *formSpecialUploadFile;
//---------------------------------------------------------------------------
#endif
