//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "codeSpecialViewChangeLog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialViewChangeLog *formSpecialViewChangeLog;
//---------------------------------------------------------------------------
__fastcall TformSpecialViewChangeLog::TformSpecialViewChangeLog(TComponent* Owner, string table_name, string id)
        : TformSpecialGeneric(Owner)
{
   record_table_name = table_name;
   record_id = id;

   this->Caption = string("Change Log - " + record_table_name + " [" + record_id + "]").c_str();

   changes_filter.SetListViewHandle(listChanges);
   changes_filter.SetSecurity(record_table_name);
   changes_filter.AddColumnSpec("Table", record_table_name, as_text, false, 75);
   changes_filter.AddColumnSpec("ID", record_table_name, as_text, false, 40);
   changes_filter.AddColumnSpec("Updated By", record_table_name, as_text, true, 100);
   changes_filter.AddColumnSpec("Update Stamp", record_table_name, as_date, true, 75);
   changes_filter.AddColumnSpec("Field", record_table_name, as_text, true, 100);
   changes_filter.AddColumnSpec("Old Value", record_table_name, as_text, true, 150);
   changes_filter.AddColumnSpec("New Value", record_table_name, as_text, true, 150);
   changes_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 40);
   changes_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 40);
   changes_filter.FetchPreferences("special.change_log");
   changes_filter.SetHeader(true);
   changes_filter.SetIconStatus(false);
   changes_filter.SetAddEdit(this, NULL, NULL);
   changes_request = atlas->RequestNotificationWhen("change_log.id", "", rel_any, as_int, this,
                        RefreshHandler(&(TformSpecialViewChangeLog::AtlasRefreshListView)));

   sql = "select table_name, record_id, users.item, change_stamp, field_name, previous_value, present_value, 4, change_log.id "
         "from change_log inner join users on change_log.change_by = users.id "
         "where table_name = '" + UppercaseString(record_table_name) + "' and record_id = '" + record_id + "' ";

   // PrometheusMessage(sql, "debug", mb_ok);
   changes_filter.SetSQLStatement(sql);
   changes_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
void TformSpecialViewChangeLog::AtlasRefreshListView(int request_num, string matched_value)
{
  if(request_num == changes_request)
    changes_filter.RefreshDataSet();
  this->Caption = string("Change Log - " + record_table_name + " [" + record_id + "]").c_str();
}

void __fastcall TformSpecialViewChangeLog::btnCloseClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------

