//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialVoidCheck.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialVoidCheck *formSpecialVoidCheck;
//---------------------------------------------------------------------------
__fastcall TformSpecialVoidCheck::TformSpecialVoidCheck(TComponent* Owner, string check_number)
        : TformSpecialGeneric(Owner)
{
 panelSelectArea->Color = title_bar_color;
 check_id = check_number;
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialVoidCheck::buttonCloseClick(TObject *Sender)
{
 // on close
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialVoidCheck::buttonFinishClick(TObject *Sender)
{
 // on finish
 int user_answer = PSay("This change could be difficult to undo. Please make sure you truly intended this action. Do you want to continue?", m_confirmation, MB_YESNO);
 if (user_answer == IDNO)
  return;

 TIBTransaction * dbTransaction = new TIBTransaction(NULL);
 try
 {
  dbTransaction->DefaultDatabase = dbDatabase;
  dbTransaction->DefaultAction = TARollback;
  dbTransaction->StartTransaction();

  string sql_verify_check_number = "select checks.id from checks where id = " + check_id;
  check_id = GetOneField(dbTransaction, sql_verify_check_number);

  string current_transaction_number = GetNextId(dbTransaction, "transact_number");

  if (check_id != "")
  {
   // if the user wants to cancel a check then mark it as deleted so they know it isn't valid anymore
   string sql;
   sql = "update checks set checks.current_id = 0 where checks.id = " + check_id;
   if (!ExecuteStatement(dbTransaction, sql))
     {
      PSay("Cannot to mark this check as deleted.", m_database_error, MB_OK);
     }

   // both bottom options require this step -- reobligating the freakin' bills
   if (checkOne->Checked || checkTwo->Checked)
   {
    // start by reversing
    // TODO: some sort of group by? select only fields needed?

    /* TODO :
       nasty problem -- this needs to go based on the sum of PAYABLES, not EXPENSES ...
       this means that accounts of type cash need links back to payables
       (we don't un-do receivables ... just payables) */
    /* TODO :
       possibly, we can undo entire transaction-groups all at once. need some way of tracking
       which screen made what changes, and find the changes made by the ... "putting on a check". screen. thing.
       that means DB changes. oh well. darn. but grrrr. */

    // it'd be silly to ask them to redo all the transactions themselves, especially
    // as the new screen (reusableaccountinginsert) doesn't show the detail, just the grouped detail.
    // there's no historical element to it like "and then, glendine went and did something stupid, ..."

    // for all we know, we had already paid half the invoice, and the check paid the second half. we don't
    // want to be re-obligating all the money, when only half should be. so ... stuff. (yes, i know,
    // business rules probably say they either pay it all or none ... but i can't be too safe.)

    PSay("Temporary warning: the two bottom options may result in incorrect re-obligation of moneys.\nThis will, eventually, be resolved, but in the mean time, you should check the bills and purchase requests manually before processing them further,\nespecially if you plan to do more than just put these items on a different check. We apologize for the inconvenience this may cause.\n(Exact problem: currently, the total amount expensed will be re-applied as payables, and cash amounts will be cancelled.)", m_warning, MB_YESNO);

    string sql_select_expense = "select * from transactions inner join bills on transactions.bill_id = bills.id inner join purchase_reqs on bills.purchase_req_id = purchase_reqs.id inner join accounts on transactions.account_id = accounts.id where purchase_reqs.check_id = " + check_id + " and accounts.account_type_id = " + lookupTables->IdOf("account_types", "Expense");
    vector<map<string, string> > expense_transactions;
    SqlToVecMap(dbTransaction, sql_select_expense, expense_transactions);

    for (vector<map<string, string> >::iterator i_old = expense_transactions.begin();
         i_old != expense_transactions.end(); i_old++)
    {
     map<string, string> reverse_transaction_core;
     reverse_transaction_core["transaction_number"] = current_transaction_number;
     reverse_transaction_core["effective_date"] = CurrentDate(); // TODO: EFFECTIVE_DATE
     reverse_transaction_core["current_id"] = "4";
     reverse_transaction_core["last_update_stamp"] = RightNow();
     reverse_transaction_core["last_updated_by"] = current_userid;
     reverse_transaction_core["tax_entity_id"] = (*i_old)["tax_entity_id"];
     reverse_transaction_core["task_id"] = (*i_old)["task_id"];
     reverse_transaction_core["bill_id"] = (*i_old)["bill_id"];

     map<string, string> reverse_transaction_cash = reverse_transaction_core;
     map<string, string> reverse_transaction_payable = reverse_transaction_core;

     string cash_account_id = EquivAccount (cash_ref, (*i_old)["account_id"]);
     string payable_account_id = EquivAccount (pending_ref, (*i_old)["account_id"]);

     if (cash_account_id != "")
     {
      reverse_transaction_cash["note"] = "Cancelling of cash transactions on bills because check is being cancelled";
      reverse_transaction_cash["id"] = GetNextId(dbTransaction, "transactions");
      reverse_transaction_cash["account_id"] = cash_account_id;
      reverse_transaction_cash["credit_amount"] = (*i_old)["credit_amount"];
      reverse_transaction_cash["debit_amount"] = (*i_old)["debit_amount"];
      if (!ExecuteInsertStatement(dbTransaction, "transactions", reverse_transaction_cash))
      {
       PSay("Failed to insert a reversal (cash) transaction.", m_database_error, MB_OK);
       throw(9);
      }
     }
     else
     {
      PSay("Could not identify the cash account to undo based on the expense account used.", m_missing_data, MB_OK);
      throw(4);
     }

     if (payable_account_id != "")
     {
      reverse_transaction_payable["note"] = "Cancelling of reverse payable transactions on bills because check is being cancelled";
      reverse_transaction_payable["id"] = GetNextId(dbTransaction, "transactions");
      reverse_transaction_payable["account_id"] = payable_account_id;
      reverse_transaction_payable["credit_amount"] = (*i_old)["debit_amount"];
      reverse_transaction_payable["debit_amount"] = (*i_old)["credit_amount"];
      if (!ExecuteInsertStatement(dbTransaction, "transactions", reverse_transaction_payable))
      {
       PSay("Failed to insert a reversal (payable) transaction.", m_database_error, MB_OK);
       throw(6);
      }
     }
     else
     {
      PSay("Could not identify the accounts payable account to undo based on the expense account used.", m_missing_data, MB_OK);
      throw(5);
     }
    }

    if (checkOne->Checked)
    {
     // continue by unlinking purchase_reqs from the check
     string sql_unlink_purchase_reqs = "update purchase_reqs set check_id = 0 where check_id = " + check_id;
     if (!ExecuteStatement(dbTransaction, sql_unlink_purchase_reqs))
     {
      PSay("Failed to unlink purchase requests from the check.\nMake sure you don't have any of the purchase request records locked for update.", m_database_error, MB_OK);
      throw(7);
     }
    } else
    if (checkTwo->Checked)
    {
     // mark purchase reqs as deleted that are no longer valid
     string sql_mark_purchase_reqs_as_deleted = "update purchase_reqs set current_id = 0 where check_id = " + check_id;
     if (!ExecuteStatement(dbTransaction, sql_mark_purchase_reqs_as_deleted))
     {
      PSay("Unable to mark purchase requests as deleted.", m_database_error, MB_OK);
      throw(18);
     }
     string sql_find_purchase_requests = "select purchase_reqs.id from purchase_reqs where purchase_reqs.check_id = " + check_id;
     set<string> purchase_reqs_to_detach;
     if (SqlToSet(dbTransaction, sql_find_purchase_requests, purchase_reqs_to_detach))
     {
      for (set<string>::iterator i_pr = purchase_reqs_to_detach.begin(); i_pr != purchase_reqs_to_detach.end(); i_pr++)
      {
       string sql_unlink_bills = "update bills set purchase_req_id = 0 where purchase_req_id = " + (*i_pr);
       if (!ExecuteStatement(dbTransaction, sql_unlink_bills))
       {
        PSay("Failed to unlink bills from purchase requests included on this check.\nMake sure you don't have any of the bill records locked for update.", m_database_error, MB_OK);
        throw(12);
       }
      }
     }
     else
     {
      PSay("Failed to find the purchase requests associated with this check.", m_missing_data, MB_OK);
      throw(13);
     }
    }
   } else
   if (checkThree->Checked)
   {
    // mark purchase reqs as deleted that are no longer valid
    string sql_mark_purchase_reqs_as_deleted = "update purchase_reqs set current_id = 0 where check_id = " + check_id;
    if (!ExecuteStatement(dbTransaction, sql_mark_purchase_reqs_as_deleted))
    {
     PSay("Unable to mark purchase requests as deleted.", m_database_error, MB_OK);
     throw(19);
    }
    // mark bills as deleted that are no longer valid
    string sql_get_all_bills = "select purchase_reqs.id from checks inner join purchase_reqs on checks.id = purchase_reqs.check_id and checks.id = " + check_id;
    vector<map<string, string> > purchase_reqs_vec;
    if (!SqlToVecMap(dbTransaction, sql_get_all_bills, purchase_reqs_vec))
    {
     PSay("Unable to obtain a list of bills to mark as deleted.", m_database_error, MB_OK);
     throw(20);
    }
    for (unsigned int i = 0; i < purchase_reqs_vec.size(); i++)
    {
      // mark bills as deleted that are no longer valid
      string sql_mark_bills_as_deleted = "update bills set current_id = 0 where purchase_req_id = " + purchase_reqs_vec[i]["id"];
      if (!ExecuteStatement(dbTransaction, sql_mark_bills_as_deleted))
      {
       PSay("Unable to mark bills as deleted.", m_database_error, MB_OK);
       throw(21);
      }
    }
    // this time, we don't want to re-obligate stuff. instead ... we want to cancel the expense and the cash, rather than the cash and the anti-obligation
    // TODO: some sort of group by? select only fields needed?
    string sql_select_expense = "select * from transactions inner join bills on transactions.bill_id = bills.id inner join purchase_reqs on bills.purchase_req_id = purchase_reqs.id inner join accounts on transactions.account_id = accounts.id where purchase_reqs.check_id = " + check_id + " and accounts.account_type_id = " + lookupTables->IdOf("account_types", "Expense");
    vector<map<string, string> > expense_transactions;
    SqlToVecMap(dbTransaction, sql_select_expense, expense_transactions);

    for (vector<map<string, string> >::iterator i_old = expense_transactions.begin();
         i_old != expense_transactions.end(); i_old++)
    {
     map<string, string> reverse_transaction_core;
     reverse_transaction_core["transaction_number"] = current_transaction_number;
     reverse_transaction_core["effective_date"] = CurrentDate(); // TODO: EFFECTIVE_DATE
     reverse_transaction_core["current_id"] = "4";
     reverse_transaction_core["last_update_stamp"] = RightNow();
     reverse_transaction_core["last_updated_by"] = current_userid;
     reverse_transaction_core["tax_entity_id"] = (*i_old)["tax_entity_id"];
     reverse_transaction_core["task_id"] = (*i_old)["task_id"];
     reverse_transaction_core["bill_id"] = (*i_old)["bill_id"];

     map<string, string> reverse_transaction_cash = reverse_transaction_core;
     map<string, string> reverse_transaction_self = reverse_transaction_core;

     string cash_account_id = EquivAccount (cash_ref, (*i_old)["account_id"]);
     string self_account_id = (*i_old)["account_id"];

     if (cash_account_id != "")
     {
      reverse_transaction_cash["note"] = "Cancelling of cash transactions on bills because check is being cancelled";
      reverse_transaction_cash["id"] = GetNextId(dbTransaction, "transactions");
      reverse_transaction_cash["account_id"] = cash_account_id;
      reverse_transaction_cash["credit_amount"] = (*i_old)["credit_amount"];
      reverse_transaction_cash["debit_amount"] = (*i_old)["debit_amount"];
      if (!ExecuteInsertStatement(dbTransaction, "transactions", reverse_transaction_cash))
      {
       PSay("Failed to insert a reversal (cash) transaction.", m_database_error, MB_OK);
       throw(15);
      }
     }
     else
     {
      PSay("Could not identify the cash account to undo based on the expense account used.", m_missing_data, MB_OK);
      throw(16);
     }

     if (self_account_id != "")
     {
      reverse_transaction_self["note"] = "Cancelling of expense transactions on bills because check is being cancelled";
      reverse_transaction_self["id"] = GetNextId(dbTransaction, "transactions");
      reverse_transaction_self["account_id"] = self_account_id;
      reverse_transaction_self["credit_amount"] = (*i_old)["debit_amount"];
      reverse_transaction_self["debit_amount"] = (*i_old)["credit_amount"];
      if (!ExecuteInsertStatement(dbTransaction, "transactions", reverse_transaction_self))
      {
       PSay("Failed to insert a reversal (expense) transaction.", m_database_error, MB_OK);
       throw(14);
      }
     }
     else
     {
      PSay("Could not identify the expense (self) account to undo based on the expense account used.", m_missing_data, MB_OK);
      throw(17);
     }
    }
    // we don't care to unlink anything at all!
   } else
   {
    PSay("Magically, you've managed to not tell me what to do!", m_missing_data, MB_OK);
   }
  }
  else
  {
   PSay("The check identifier sent when this form opened could not be verified as valid.", m_missing_data, MB_OK);
  }

  dbTransaction->Commit();
  Close();
 }
 catch (...)
 {
  if (dbTransaction->Active)
   dbTransaction->Rollback();
  PSay("Couldn't void the check, internal error.", m_database_error, MB_OK);
 }
 delete dbTransaction;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialVoidCheck::FormClose(TObject *Sender,
      TCloseAction &Action)
{
 // on form close
 TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
