//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeSpecialWaitingReferrals.h"
#include "codeRecordReferral.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialWaitingReferrals *formSpecialWaitingReferrals;
//---------------------------------------------------------------------------
__fastcall TformSpecialWaitingReferrals::TformSpecialWaitingReferrals(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  this->IconIndex = 40;
//  user_tax_id = GetOneField(dbDatabase, "select tax_entity_id from users where id = " + current_userid);
  if((user_taxid == "") && (user_taxid == "0"))
  {
    PSay("You are unable to use this referral system. Please contact a programmer to complete the setup.", m_warning, MB_OK);
  }
  else
  {
    sql = "select referrals.date_of_referral, users.item, "
          "person_names.first_name || ' ' || person_names.last_name || ' ' || person_names.suffix, "
          "todo_status_types.item, referral_reason_types.item, referral_notes.note, "
          "referrals.current_id, referrals.id "
          "from referrals "
          "inner join tax_entities tby on referrals.by_provider_id = tby.id "
          "inner join users on users.tax_entity_id = tby.id "
          "inner join todo_status_types on referrals.todo_status_id = todo_status_types.id "
          "inner join people on referrals.person_id = people.id "
          "left join person_names on people.person_names_id = person_names.id "
          "inner join referral_reason_types on referrals.referral_reason_id = referral_reason_types.id "
          "inner join referral_notes on referral_notes.id = (select first 1 RN.id from referral_notes RN "
           "where RN.referral_id = referrals.id and RN.current_id+1 > 3 order by RN.date_of_note desc) "
          "where referrals.to_provider_id = " + user_taxid + " ";
          // "and users.valid = 1 ";

    // TODO: by default, no completes? we don't remember the setting, do we ... ouch. optionsPreferences anyone?
    temp_sql = sql + " and referrals.todo_status_id != " + lookupTables->IdOf("todo_status_types", "Complete");
    referrals_filter.SetListViewHandle (listReferrals);
    referrals_filter.SetSecurity("referrals");
    referrals_filter.AddColumnSpec("Date", "referrals", as_date, true, 90);
    referrals_filter.AddColumnSpec("Referred By", "referrals", as_text, true, 120);
    referrals_filter.AddColumnSpec("Person", "referrals", as_text, true, 120);
    referrals_filter.AddColumnSpec("Status", "referrals", as_text, true, 100);
    referrals_filter.AddColumnSpec("Reason", "referrals", as_text, true, 120);
    referrals_filter.AddColumnSpec("Last Message", "referrals", as_text, true, 150, sentenceString);
    referrals_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
    referrals_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
    referrals_filter.FetchPreferences("specialwaitingreferrals.referrals_filter");
    referrals_filter.SetIconStatus(true);
    referrals_filter.SetSQLStatement (temp_sql);
    referrals_filter.RefreshDataSet();
    referrals_filter.SetAddEdit(this, NULL, EditRecord(&(TformSpecialWaitingReferrals::EditReferral)));
    referrals_request = atlas->RequestNotificationWhen("referrals.to_provider_id", user_taxid, rel_e, as_int, this,
                        RefreshHandler(&(TformSpecialWaitingReferrals::AtlasRefreshListView)));
  }
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialWaitingReferrals::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------

void __fastcall TformSpecialWaitingReferrals::menuViewAllClick(
      TObject *Sender)
{
  ((TMenuItem *)Sender)->Checked = true;
  if(menuViewAll->Checked)
  {
    temp_sql = sql;
    this->Caption = "Pending Referrals - All";
  }
  else if(menuViewAllIncomplete->Checked)
  {
    temp_sql = sql + " and referrals.todo_status_id != " + lookupTables->IdOf("todo_status_types", "Complete");
    this->Caption = "Pending Referrals - All Incomplete";
  }
  else if(menuNotBegun->Checked)
  {
    temp_sql = sql + " and referrals.todo_status_id = " + lookupTables->IdOf("todo_status_types", "Not begun");
    this->Caption = "Pending Referrals - Not Begun";
  }
  else if(menuInProgress->Checked)
  {
    temp_sql = sql + " and referrals.todo_status_id = " + lookupTables->IdOf("todo_status_types", "In progress");
    this->Caption = "Pending Referrals - In Progress";
  }
  else if(menuComplete->Checked)
  {
    temp_sql = sql + " and referrals.todo_status_id = " + lookupTables->IdOf("todo_status_types", "Complete");
    this->Caption = "Pending Referrals - Complete";
  }
  else if(menuOverdue->Checked)
  {
    temp_sql = sql + " and referrals.todo_status_id = " + lookupTables->IdOf("todo_status_types", "Overdue");
    this->Caption = "Pending Referrals - Overdue";
  }
  else if(menuSuspended->Checked)
  {
    temp_sql = sql + " and referrals.todo_status_id = " + lookupTables->IdOf("todo_status_types", "Suspended");
    this->Caption = "Pending Referrals - Suspended";
  }
  referrals_filter.SetSQLStatement(temp_sql);
  referrals_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------
void TformSpecialWaitingReferrals::EditReferral()
{
  map<string, string> temp_map;
  temp_map["id"] = referrals_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordReferral *edit_referral = new TformRecordReferral(NULL, temp_map);
    edit_referral->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformSpecialWaitingReferrals::AtlasRefreshListView(int request_num, string matched_value)
{
  if(request_num == referrals_request)
    referrals_filter.RefreshDataSet();
}
//---------------------------------------------------------------------------

