//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeWizardAccountAdjustments.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeWizardGeneric"
#pragma resource "*.dfm"
TformWizardAccountAdjustments *formWizardAccountAdjustments;
//---------------------------------------------------------------------------
__fastcall TformWizardAccountAdjustments::TformWizardAccountAdjustments(TComponent* Owner)
        : TformWizardGeneric(Owner)
{
 edit_after.setup_listview(listAfter, false);
 // SetExpectedPages(1);
 Initialize();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardAccountAdjustments::checkAfterShowAccountClick(
      TObject *Sender)
{
 vector<map<string, string> > current_data = after_changes.GetPreviewOutput(true);
 RefreshTransactionSummaryView(edit_after, checkAfterShowAccount->Checked, false, current_data);
}
//---------------------------------------------------------------------------
void __fastcall TformWizardAccountAdjustments::buttonChangeClick(
      TObject *Sender)
{
 // open accounting entry screen
 FORM_TRY
  TformSpecialTransactionEntry * query = new TformSpecialTransactionEntry(NULL, before_changes, &after_changes, "0", 0.00, false);
  query->ShowTaskModal(this);
  vector<map<string, string> > current_data = after_changes.GetPreviewOutput(true);
  RefreshTransactionSummaryView(edit_after, checkAfterShowAccount->Checked, false, current_data);
 FORM_CATCH
       
}
//---------------------------------------------------------------------------
void __fastcall TformWizardAccountAdjustments::FormClose(TObject *Sender,
      TCloseAction &Action)
{
 // wish to close, but we'll ask first, and if it's confirmed, go ahead and close controls
 Action = caFree;
 TformWizardGeneric::FormClose(Sender, Action);
 if (Action == caFree)
  edit_after.setup_listview(NULL, false);        
}
//---------------------------------------------------------------------------
bool TformWizardAccountAdjustments::IsValidPage (int page_index)
{
 switch (page_index)
 {
  case 0:
  {
   // TODO: if we do wind up verifying cases that shouldn't be allowed ... do so here.

   /* TODO: don't let them screw with pending accounts (payable/receivable) ... possibly not revenue either.
            maybe allow cash modification (try to make stuff match "cash in bank",) certainly expense modification.
            equity? (making cash change by itself requires this)
            negative expense? (undo other similar changes) */
   return true;
  }
  default:
   PSay("IsValidPage() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return false;
 }
}
//---------------------------------------------------------------------------
int TformWizardAccountAdjustments::WhereNext (int page_index)
{
 return TformWizardGeneric::last_wizard_page;
}
//---------------------------------------------------------------------------
bool TformWizardAccountAdjustments::ProcessPage (int page_index)
{
 switch (page_index)
 {
  case 0:
  {
   return true;
  }
  default:
   PSay("ProcessPage() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return false;
 }
}
//---------------------------------------------------------------------------
void TformWizardAccountAdjustments::SetupPage (int page_index)
{
 switch (page_index)
 {
  case 0:
  {
   transaction_summary empty_summary;
   before_changes = empty_summary;
   after_changes = empty_summary;
   edit_after.clear_data();
   editTransactionNote->Text = "";
   checkAfterShowAccountClick(NULL);
   dateEffectiveDate->Date = TDateTime::CurrentDate();
   // does this look fairly empty to anyone else?
   break;
  }
  default:
   PSay("SetupPage() is trying to access a page that does not exist.", m_program_error, MB_OK);
   break;
 }
}
//---------------------------------------------------------------------------

void TformWizardAccountAdjustments::PageLockStatus (int page_index, bool locked)
{
 switch (page_index)
 {
  case 0:
   buttonChange->Enabled = !locked;
   editTransactionNote->Enabled = !locked;
   dateEffectiveDate->Enabled = !locked;
  default:
   PSay("PageLockStatus() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return;
 }
}
//---------------------------------------------------------------------------
bool TformWizardAccountAdjustments::FinishWizard ()
{
 // save transactions on the item ... yay!
 AtlasClear();
 TIBTransaction * dbTransaction = new TIBTransaction(NULL);
 StdTransaction(dbTransaction, dbDatabase);
 try
 {
  string date_to_use = Pdate(dateEffectiveDate->Date).OutDate(global_mode);

  map<string, string> default_row;
  default_row["current_id"]         = "4";
  default_row["last_update_stamp"]  = RightNow();
  default_row["last_updated_by"]    = current_userid;
  default_row["task_id"]            = "0";
  default_row["bill_id"]            = "0";
  default_row["effective_date"]     = date_to_use;
  default_row["note"]               = (editTransactionNote->Text == "") ? "Account adjustments without supporting documentation" : editTransactionNote->Text.c_str();
  default_row["transaction_number"] = GetNextId(dbTransaction, "transact_number");

  // not watching 'before_changes' as it should be empty (if this changes ... yeah. do stuff here. involving (after - before).stuff)
  vector<map<string, string> > tx = after_changes.GetFinalOutput(default_row);
  vector<map<string, string> >::iterator i_tx;

  // setup id
  for (i_tx = tx.begin(); i_tx != tx.end(); i_tx++)
  {
   (*i_tx)["id"] = GetNextId(dbTransaction, "transactions");
   if (!ExecuteInsertStatement(dbTransaction, "transactions", (*i_tx)))
    throw(2);
   AtlasAdd("transactions", (*i_tx));
  }

  dbTransaction->Commit();
  delete dbTransaction;
  AtlasSend();
  return true;
 }
 catch (...)
 {
  PSay("FinishWizard() failed to complete the insertion process (unforeseen error.)\nVendor bill and associated transactions have not been saved.", m_database_error, MB_OK);
  dbTransaction->Rollback();
  delete dbTransaction;
  AtlasClear();
  return false;
 }
}
//---------------------------------------------------------------------------
void TformWizardAccountAdjustments::Do()
{
 FORM_TRY
  TformWizardAccountAdjustments * z = new TformWizardAccountAdjustments(NULL);
  z->Show();
 FORM_CATCH
 return;
}
//---------------------------------------------------------------------------

