//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeWizardAccountCloseEquity.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeWizardGeneric"
#pragma resource "*.dfm"
TformWizardAccountCloseEquity *formWizardAccountCloseEquity;
//---------------------------------------------------------------------------
__fastcall TformWizardAccountCloseEquity::TformWizardAccountCloseEquity(TComponent* Owner)
        : TformWizardGeneric(Owner)
{
 start_page = 0;
 // SetExpectedPages(2);
 lookupTables->RegisterComboBox("month_types", comboYearlyCycle);

 filter_accounts.SetListViewHandle(listAccounts);
 filter_accounts.SetSecurity("accounts");
 filter_accounts.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 filter_accounts.AddColumnSpec("Account", "accounts", as_text, true, 150);
 filter_accounts.AddColumnSpec("Balance", "transactions", as_double, true, 150, nonzeroAmountString);
 filter_accounts.FetchPreferences("wizardcloseaccountsequity.filter_accounts");
 filter_accounts.SetCheck(true);
 filter_accounts.SetSQLStatement("");
 filter_accounts.RefreshDataSet();

 Initialize();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardAccountCloseEquity::radioPeriodBudgetsClick(
      TObject *Sender)
{
 // either of the first two radio buttons
 if (radioYearlyBudgets->Checked)
  RecurseEnabled(panelYearlyBudgets, true);
 else
  RecurseEnabled(panelYearlyBudgets, false);
 return;
}
//---------------------------------------------------------------------------
bool TformWizardAccountCloseEquity::IsValidPage (int page_index)           // true/false: this page is without errors
{
 // we'll see about that
 switch (page_index)
 {
  case 0:
   if (radioYearlyBudgets->Checked)
   {
    int month_chosen = StringToInt(lookupTables->IdOf("month_types", comboYearlyCycle->Text.c_str()));
    if (month_chosen < 1 || month_chosen > 12)
    {
     PSay("You must select one of the entries in the month drop-down before continuing.\nThis is done to make sure the effective date on the transactions makes sense for all the accounts you're working on.", m_invalid_data, MB_OK);
     return false;
    }

    Pdate temp_date;
    Pdate temp_date_after;
    temp_date.InDate(dateActionEffective->Date);
    temp_date_after = temp_date + 1;
    if (((temp_date.month + 1)%12) != month_chosen || temp_date_after.day != 1)
    {
     if (IDNO == PSay("You have opted to close accounts on a date other than the day before the beginning of a new budget period.\nAre you absolutely sure you would like to close these accounts on an unusual date?", m_confirmation, MB_YESNO))
      return false;
    }
   }
   
   return true;
   // break;
  case 1:
   // second page -- at least one account must be checked, and ... can we prevent them from selecting negative expense accounts?
   selected_accounts = filter_accounts.GetMultiID();
   if (selected_accounts.empty())
   {
    PSay("You must select at least one account to close before continuing.", m_missing_data, MB_OK);
    return false;
   }
   return true;
   // break;
  default:
   PSay("This page of the wizard cannot be validated as it is not recognized.", m_program_error, MB_OK);
   return false;
   // break;
 }
}
//---------------------------------------------------------------------------
int TformWizardAccountCloseEquity::WhereNext   (int page_index)           // page_index of the next page to visit, based on current page number
{
 // no harm done, eh?
 if (page_index == 1)
  return TformWizardGeneric::last_wizard_page;
 else
  return (page_index + 1);
}
//---------------------------------------------------------------------------
bool TformWizardAccountCloseEquity::ProcessPage (int page_index)           // actually go from A to B, ... no reset, no messing with other stuff?
{
 // we'll see about that
 switch (page_index)
 {
  case 0:
   // nothing to do, really
   return true;
  case 1:
  {
   return true;
  }
  default:
   PSay("ProcessPage() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return false;
 }
}
//---------------------------------------------------------------------------
void TformWizardAccountCloseEquity::SetupPage   (int page_index)           // make this page ready to be shown based on other data
{
 // we'll see about that
 switch (page_index)
 {
  case 0:
   radioYearlyBudgets->Checked = true;
   radioExpenseBudgets->Checked = true;
   checkClosedBudgets->Checked = false;
   comboYearlyCycle->Text = "January";
   // dateActionEffective->Date = Date(); -- when doing this over and over again, it's good to remember the old dates, whatever they were
   radioPeriodBudgetsClick(NULL);
   break;
  case 1:
   try
   {
    Pdate effective_date;
    Pdate ignore_date;

    string sql_actual;

    effective_date.InDate(dateActionEffective->Date);
    ignore_date.InDate(dateLastTransaction->Date);

    // e and f change here
    string sql_a_deb        = "select accounts.id, accounts.name, sum(transactions.debit_amount - transactions.credit_amount) ";
    string sql_a_cred       = "select accounts.id, accounts.name, sum(transactions.credit_amount - transactions.debit_amount) ";
    string sql_b_actual_id  = "from accounts left join transactions on transactions.account_id = accounts.id ";
    string sql_c_date       = "and transactions.effective_date <= '" + effective_date.OutDate(mdy | yyyy) + "' and transactions.last_update_stamp < '" + ignore_date.OutDate(mdy | yyyy) + " 00:00:00' ";
    string sql_d_expense    = "where accounts.is_budget = 0 and accounts.account_type_id = 4 ";
    string sql_d_revenue    = "where accounts.is_budget = 0 and accounts.account_type_id = 5 ";
    string sql_e_closed     = (checkClosedBudgets->Checked) ? "" : "and accounts.is_closed = 0 ";
    string sql_f_yearly     = (radioNonYearlyBudgets->Checked) ? string("and accounts.is_yearly = 0 ") : "and accounts.is_yearly = 1 and accounts.bill_cycle_id = " + lookupTables->IdOf("month_types", comboYearlyCycle->Text.c_str()) + " ";
    string sql_g_group      = "group by accounts.id, accounts.name"; // having sum(transactions.debit_amount - transactions.credit_amount) != 0.00";

    // a, b, and d change here
    if (radioExpenseBudgets->Checked)
     sql_actual  = sql_a_deb + sql_b_actual_id + sql_c_date + sql_d_expense + sql_e_closed + sql_f_yearly +  sql_g_group;
    else
     sql_actual  = sql_a_cred + sql_b_actual_id + sql_c_date + sql_d_revenue + sql_e_closed + sql_f_yearly +  sql_g_group;

    filter_accounts.SetSQLStatement(sql_actual);
    filter_accounts.RefreshDataSet();
   } catch (...)
   {
    PSay("Something went wrong while trying to retrieve the current account status information.", m_database_error, MB_OK);
    return;
   }
   break;
  default:
   PSay("The wizard is attempting to set up a page that does not exist.\nPlease inform your system administrator soon.", m_program_error, MB_OK);
   break;
 }
}
//---------------------------------------------------------------------------

void __fastcall TformWizardAccountCloseEquity::FormClose(TObject *Sender,
      TCloseAction &Action)
{
 // close
 Action = caFree;
 TformWizardGeneric::FormClose(Sender, Action);
 if (Action != caNone)
 {
  lookupTables->UnregisterComboBox("month_types", comboYearlyCycle);
 }
}
//---------------------------------------------------------------------------

void TformWizardAccountCloseEquity::PageLockStatus (int page_index, bool locked)
{
 switch (page_index)
 {
  case 0:
   groupAccountPeriod->Enabled = !locked;
   groupAccountType->Enabled = !locked;
   groupActionDate->Enabled = !locked;
   return;
  case 1:
   return;
  default:
   PSay("PageLockStatus() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return;
 }
}
//---------------------------------------------------------------------------

void __fastcall TformWizardAccountCloseEquity::listAccountsChanging(
      TObject *Sender, TListItem *Item, TItemChange Change,
      bool &AllowChange)
{
 AllowChange = !WizardLocked();
}
//---------------------------------------------------------------------------
bool TformWizardAccountCloseEquity::FinishWizard ()
{
 TIBTransaction * dbTransaction = new TIBTransaction(NULL);
 StdTransaction (dbTransaction, dbDatabase);

 vector<map<string, string> > database_rows_to_insert;
 map<string, string> account_actual;
 map<string, string> account_equity;

 map<string, string> current_database_row;
 map<string, string> default_database_row;

 Pdate effective_date;
 Pdate renewal_date;
 Pdate ignore_date;

 effective_date.InDate(dateActionEffective->Date);
 ignore_date.InDate(dateLastTransaction->Date);

 renewal_date = effective_date;
 renewal_date.mod(+1, in_days);

 default_database_row["current_id"]         = "4";
 default_database_row["last_update_stamp"]  = effective_date.OutDate(mdy | yyyy) + " 23:59:00"; // RightNow(); -- hack, because ... it's a long story. the 'ignore transactions after ...' thing means a lot in this case. screws us over.
 default_database_row["last_updated_by"]    = current_userid;
 default_database_row["task_id"]            = "0";
 default_database_row["bill_id"]            = "0";
 default_database_row["tax_entity_id"]      = "0";
 default_database_row["credit_amount"]      = "0.00";
 default_database_row["debit_amount"]       = "0.00";
 default_database_row["transaction_number"] = GetNextId(dbTransaction, "transact_number");
 default_database_row["effective_date"]     = effective_date.OutDate(mdy | yyyy);

 // TODO :
 string sql_actual;
 string sql_pending;
 string sql_equity;

 // e and f change here
 string sql_a_deb        = "select accounts.id, sum(transactions.debit_amount - transactions.credit_amount) ";
 string sql_a_cred       = "select accounts.id, sum(transactions.credit_amount - transactions.debit_amount) ";
 string sql_b_actual_id  = "from accounts left join transactions on transactions.account_id = accounts.id ";
 // string sql_b_pending_id = "from accounts left join transactions on transactions.account_id = accounts.pending_account_id ";
 string sql_c_date       = "and transactions.fiscal_date <= '" + effective_date.OutDate(mdy | yyyy) + "' and transactions.last_update_stamp < '" + ignore_date.OutDate(mdy | yyyy) + " 00:00:00' ";
 string sql_d_expense    = "where accounts.is_budget = 0 and accounts.account_type_id = 4 ";
 string sql_d_revenue    = "where accounts.is_budget = 0 and accounts.account_type_id = 5 ";
 string sql_e_closed     = (checkClosedBudgets->Checked) ? "" : "and accounts.is_closed = 0 ";
 string sql_f_yearly     = (radioNonYearlyBudgets->Checked) ? string("and accounts.is_yearly = 0 ") : "and accounts.is_yearly = 1 and accounts.bill_cycle_id = " + lookupTables->IdOf("month_types", comboYearlyCycle->Text.c_str()) + " ";
 string sql_g_group      = "group by accounts.id having accounts.id in (" + VecToCommaString(selected_accounts) + ")";

 // a, b, and d change here
 if (radioExpenseBudgets->Checked)
 {
  sql_actual  = sql_a_deb + sql_b_actual_id + sql_c_date + sql_d_expense + sql_e_closed + sql_f_yearly +  sql_g_group;
  sql_equity  = "select accounts.id, accounts.balance_account_id from accounts " + sql_d_expense + sql_e_closed + sql_f_yearly;
 } else
 {
  sql_actual  = sql_a_cred + sql_b_actual_id + sql_c_date + sql_d_revenue + sql_e_closed + sql_f_yearly +  sql_g_group;
  sql_equity  = "select accounts.id, accounts.balance_account_id from accounts " + sql_d_revenue + sql_e_closed + sql_f_yearly;
 }

 string val_actual;
 string val_equity;
 financial actual_amount;

 string sql_update_actual_min_fiscal_dates;
 string sql_update_budget_min_fiscal_dates;
 string sql_update_fiscal_dates;

 /* TODO -c HACK : declarations were moved outside the try/catch block because a call to throw() was causing some sort of
    cascaded access violation resulting in 'abnormal program termination'. the access violations seemed to be in
    string_r.h in the "long  __removeReference ()" function call, at the line "return __unSafeRemoveReference();".
    (example: when a negative expense account was found, before condition was allowed again because it was happening.)
    couldn't find any documentation showing this should be true, but it did -seem- to be true. seems to be fixed?
    this hasn't seemed to be a problem in other code, and seems specifically related to the deallocation / destruction
    of strings, or subclasses of string.
 */
 try
 {

  SqlToValueMap(dbTransaction, sql_actual, account_actual);
  SqlToValueMap(dbTransaction, sql_equity, account_equity);

  for (map<string, string>::iterator i_actual = account_actual.begin(); i_actual != account_actual.end(); i_actual++)
  {
   if (i_actual->second != "")
   {
    val_actual     = i_actual->second;
    val_equity     = account_equity[i_actual->first];
    actual_amount  = StringToFinancial(val_actual);

    if (!val_equity.empty())
    {
     if (actual_amount > 0.00)
     {
      // against account
      current_database_row = default_database_row;
      current_database_row["id"] = GetNextId(dbTransaction, "transactions");
      current_database_row["account_id"] = i_actual->first;
      current_database_row["note"] = "Closing account balance into equity (account)";
      current_database_row["transaction_id"] = lookupTables->IdOf("transaction_types", "Closing Balance");
      current_database_row[radioExpenseBudgets->Checked ? "credit_amount" : "debit_amount"] = FinancialToString(actual_amount, false);
      database_rows_to_insert.push_back(current_database_row);

      // against equity
      current_database_row = default_database_row;
      current_database_row["id"] = GetNextId(dbTransaction, "transactions");
      current_database_row["account_id"] = val_equity;
      current_database_row["note"] = "Closing account balance into equity (equity)";
      current_database_row["transaction_id"] = lookupTables->IdOf("transaction_types", "Closing Balance");
      current_database_row[radioExpenseBudgets->Checked ? "debit_amount" : "credit_amount"] = FinancialToString(actual_amount, false);
      database_rows_to_insert.push_back(current_database_row);
     } else
     if (actual_amount == 0.00)
     {
      // nothing to do, except that there were transactions, rather than none
      // -- no longer true. there may have been none. i needed all accounts to show up, so they would get their min_fiscal_date fixed.
      // having 0.00 values doesn't hurt anything. nothing happens here.
     } else
     if (actual_amount < 0.00)
     {
      // negative? should this happen? warn user?
      //PSay(string("An account is in a state where to be closed, a negative amount would need to be posted.\nThis should absolutely never happen.\nInternal account number: " + i_actual->first), m_warning, MB_OK);
      //throw(1);
      int result_of_question = PSay(string("An account is in a state of relative absurdity: negative expenses or revenue.\nThis should absolutely never happen.\nInternal account number: " + i_actual->first + "\nWould you like to process this account anyway?\nPressing 'no' will skip this item, 'cancel' will abort the entire request.\nOtherwise, the account will be closed, albeit oddly."), m_warning, MB_YESNOCANCEL);
      if (result_of_question == IDCANCEL)
       throw(1);
      else if (result_of_question == IDYES)
      {
       // fix this one too! in reverse! and backward! with a flag! (okay, maybe not the flag.)

       // NOTE: following is reversed version of above. debit/credit flipped positions. amount is negated so it'll be positive again.

       // against account
       current_database_row = default_database_row;
       current_database_row["id"] = GetNextId(dbTransaction, "transactions");
       current_database_row["account_id"] = i_actual->first;
       current_database_row["note"] = "Closing account balance into equity (account)";
       current_database_row["transaction_id"] = lookupTables->IdOf("transaction_types", "Closing Balance");
       current_database_row[radioExpenseBudgets->Checked ? "debit_amount" : "credit_amount"] = FinancialToString(-actual_amount, false);
       database_rows_to_insert.push_back(current_database_row);

       // against equity
       current_database_row = default_database_row;
       current_database_row["id"] = GetNextId(dbTransaction, "transactions");
       current_database_row["account_id"] = val_equity;
       current_database_row["note"] = "Closing account balance into equity (equity)";
       current_database_row["transaction_id"] = lookupTables->IdOf("transaction_types", "Closing Balance");
       current_database_row[radioExpenseBudgets->Checked ? "credit_amount" : "debit_amount"] = FinancialToString(-actual_amount, false);
       database_rows_to_insert.push_back(current_database_row);
      }
      else
      {
       // just skip it. ignore this entry entirely.
      }
     }
    } else
    {
     // TODO: no equity account, cannot close (warn user)
     PSay(string("An account has been found without an attached equity account.\nThis should not happen.\nInternal account number: " + i_actual->first), m_warning, MB_OK);
     throw(1);
    }
   } else
   {
    // no expenses/revenue on this account, nothing to close? do we bother with a db:0/cr:0 transaction?
   }
  }

  for (vector<map<string, string> >::iterator i_database_row = database_rows_to_insert.begin();
       i_database_row != database_rows_to_insert.end(); i_database_row++)
   if (!ExecuteInsertStatement(dbTransaction, "transactions", (*i_database_row)))
    throw(1);

  // -- now, after the reversals have been inserted ...
  // - update the min_fiscal_date to bring it up to date with the right date
  // - update all transactions that weren't matched previously, and update their fiscal_date to match the new one.

  sql_update_actual_min_fiscal_dates = "update accounts "
                                       "set min_fiscal_date = '" + renewal_date.OutDate(mdy | yyyy) + "' "
                                       "where accounts.id in (" + VecToCommaString(selected_accounts) + ")";

  sql_update_budget_min_fiscal_dates = "update accounts "
                                       "set min_fiscal_date = '" + renewal_date.OutDate(mdy | yyyy) + "' "
                                       "where accounts.actual_account_id in (" + VecToCommaString(selected_accounts) + ")";

  if (!ExecuteStatement(dbTransaction, sql_update_actual_min_fiscal_dates))
   throw(1);

  if (!ExecuteStatement(dbTransaction, sql_update_budget_min_fiscal_dates))
   throw(2);

  sql_update_fiscal_dates = "update transactions "
                            "set fiscal_date = '" + renewal_date.OutDate(mdy | yyyy) + "' "
                            "where (transactions.effective_date < '" + renewal_date.OutDate(mdy | yyyy) + "' "
                            "and transactions.last_update_stamp >= '" + ignore_date.OutDate(mdy | yyyy) + " 00:00:00') "
                            "and transactions.account_id in (" + VecToCommaString(selected_accounts) + ")";
  if (!ExecuteStatement(dbTransaction, sql_update_fiscal_dates))
   throw(3);

  dbTransaction->Commit();
  delete dbTransaction;
  return true;
 }
 catch (...)
 {
  if (dbTransaction->Active)
   dbTransaction->Rollback();
  delete dbTransaction;
  PSay("Transactions could not be inserted to perform closing changes as requested, or request was aborted.\nPlease inform your systems administrator of any problems encountered.", m_database_error, MB_OK);
  return false;
 }
}
//---------------------------------------------------------------------------
void TformWizardAccountCloseEquity::Do()
{
 FORM_TRY
  TformWizardAccountCloseEquity * z = new TformWizardAccountCloseEquity(NULL);
  z->Show();
 FORM_CATCH
 return;
}
//---------------------------------------------------------------------------

