//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#pragma warn -8057

#include "codeWizardGeneric.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformWizardGeneric *formWizardGeneric;
//---------------------------------------------------------------------------
__fastcall TformWizardGeneric::TformWizardGeneric(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  // message_router->SendMessageToAll("wizard_debug", "constructor: starting");

  // constructor ... doesn't need to do much, now that special generic is doing a lot of it ...

  // notes to self -- what is the order in which 'next' should be processed?
  // what needs to get done is:
  // -- check current page, make sure it's okay (AllowNext)
  // -- find out where we're going next (WhereNext)
  // -- reset all pages after the current one to their default state, or just reset next form? (ResetPage)
  // -- process the current page's data (GoNext)
  // -- setup the page(s) we're going to (GoNext)
  // -- go to the next page (GoNext -- ancestor)
  // -- make sure the history is updated with the page we were just on (GoNext -- ancestor)
  // -- need to know how we are relative to the end ... finish/can't go back, etc.
  // -- profit (oops, forgot)

  // three pages, A(0), B(1), C(2) ... stuff gets written to the db after C
  //            A      B      C
  // Back      ----   Back   Back
  //            -      A      B
  // Next      Next   Next   Finish/Save
  //            B      C      A
  // Cancel    ----   Cancel Cancel (Start Over, or whatever Bryan thinks is best)
  //            -      A      A
  // Close     Close  Close  Close
  // history    0      1      2
  // expected   3      3      3
  // start      0      0      0

  IconIndex = 13;
  // imagesRecordTypes->GetIcon(13, this->Icon);
  close_quickly         = false;
  close_on_finish       = false;
  start_page            = 0;
  // expected_number_pages = 0;
  panelTitle->Color     = title_bar_color;

  // TODO -c WEIRD: jhaley - shouldn't this be its own TformDrawerGeneric descendent and not a hacked-up generic?
  FORM_TRY
    page_list_window = new TformDrawerGeneric(NULL);
  FORM_CATCH
  page_list_window->labelDrawerName->Caption = "Page list";
  page_list_window->DrawerOwner    = this;
  page_list_window->Width          = 200;
  page_list_window->DrawerPosition = akLeft;
  page_list_window->KidnapControl(listWizardPages); // TODO -c AWFUL: jhaley - ohgod ohgod ohgod >_>

  if (optionsPreferences["wizard_generic"]["auto_open_pagelist"] == "true")
    page_list_window->DrawerExpanded = true;

  // message_router->SendMessageToAll("wizard_debug", "constructor: finishing");

  // after this, we expect the client form to set start_page, call Initialize() and start doing stuff.
  // expected_number_pages can be set by ... err ... ResetPage(start_page). that should be okay, yes?
}
//---------------------------------------------------------------------------
void __fastcall TformWizardGeneric::buttonBackClick(TObject *Sender)
{
  // message_router->SendMessageToAll("wizard_debug", "buttonBackClick: starting");
  AV_TRY
    // back
    Processing (true);
    if (!page_history.empty())
    {
      // message_router->SendMessageToAll("wizard_debug", "buttonBackClick: top() is "
      //   + IntToString(page_history.top()) + ", size() is " + IntToString(page_history.size()));
      int back_page = page_history.top();
      page_history.pop();
      if(PageExists(back_page))
      {
        ChangePage (back_page);
        // and no, we don't put it back in the history!
      }
    }
    else
    {
      PSay("The wizard would like to go back one page, but you're already as far back as it remembers you being!\n"
           "Please contact a programmer immediately.", m_program_error, MB_OK);
    }
    Processing (false);
  AV_CATCH
  // message_router->SendMessageToAll("wizard_debug", "buttonBackClick: finishing");
}
//---------------------------------------------------------------------------
void __fastcall TformWizardGeneric::buttonNextClick(TObject *Sender)
{
  // message_router->SendMessageToAll("wizard_debug", "buttonNextClick: starting");
  AV_TRY
    // next/finish (if about to reach the last page, which should confirm stuff)
    Processing (true);
    int this_page = pageStandard->ActivePageIndex;
    if (IsValidPage (this_page))
    {
      if (int(page_history.size() + 1) >= NumberOfPages() /* expected_number_pages */ )
      {
        // message_router->SendMessageToAll("wizard_debug",
        //   "buttonNextClick: page history size dictated ProcessPage() then StartOver()");
        if (_ProcessPage (this_page))
        {
          if (_FinishWizard ())
          {
            if (close_on_finish)
              CloseNow();
            else
              StartOver ();
          }
          else
          {
            PSay("An unexpected error is preventing you from saving your work.\nPlease contact a programmer.",
                 m_program_error, MB_OK);
          }
        }
        else
        {
          PSay("An unexpected error is preventing you from leaving this page.\nPlease contact a programmer.",
               m_program_error, MB_OK);
        }
      }
      else
      {
        int next_page = WhereNextWrapper (this_page);
        // message_router->SendMessageToAll("wizard_debug", "buttonNextClick: page history size said to go to "
        //   + IntToString(next_page) + " next, with current history size of " + IntToString(page_history.size()));
        if (PageExists(next_page))
        {
          if (_ProcessPage (this_page))
          {
            _SetupPage   (next_page);
            page_history.push(this_page);
            ChangePage  (next_page);
          }
          else
          {
            PSay("An unexpected error is preventing you from leaving this page.\nPlease contact a programmer.",
                 m_program_error, MB_OK);
          }
        }
        else
        {
          PSay("The wizard believes you should now proceed to a page that doesn't exist!\n"
               "Please contact a programmer immediately.", m_program_error, MB_OK);
        }
      }
    }
    else
    {
      // assume IsValidPage will show a message box with the error ... if not, well, too bad. just won't work.
    }
    Processing(false);
  AV_CATCH
  // message_router->SendMessageToAll("wizard_debug", "buttonNextClick: finishing");
}
//---------------------------------------------------------------------------
void __fastcall TformWizardGeneric::buttonResetClick(TObject *Sender)
{
  // message_router->SendMessageToAll("wizard_debug", "buttonResetClick: starting");
  // cancel/reset (go back to first page)
  AV_TRY
    Processing (true);
    StartOver();
    Processing (false);
  AV_CATCH
  // message_router->SendMessageToAll("wizard_debug", "buttonResetClick: finishing");
}
//---------------------------------------------------------------------------
void __fastcall TformWizardGeneric::buttonCloseClick(TObject *Sender)
{
  // message_router->SendMessageToAll("wizard_debug", "buttonCloseClick: requested");
  // close
  Close();
}
//---------------------------------------------------------------------------
void TformWizardGeneric::Initialize ()
{
  // message_router->SendMessageToAll("wizard_debug", "Initialize: starting");
  // in case we want to mess with tabs on the page, need to do it in initialize, not constructor (only page exists here)
  // might want to make sure all tabs are set to TabVisible=false?
  // anything else?
  // the derived form -must- set start_page, and should keep expected_number_pages updated as it goes ...
  StartOver();
  // message_router->SendMessageToAll("wizard_debug", "Initialize: finishing");
}
//---------------------------------------------------------------------------
// from special generic, determine if -really- busy (deprecated)
bool TformWizardGeneric::IsBusy()
{
  // can be overriden, but ... this is probably going away.
  return false;
}
//---------------------------------------------------------------------------
// from special generic, close ... do special stuff if needed.
bool TformWizardGeneric::CloseNow ()
{
  // message_router->SendMessageToAll("wizard_debug", "CloseNow: requested");
  close_quickly = true;
  Close();
  return true;
}
//---------------------------------------------------------------------------
/*
// left label
void TformWizardGeneric::SetPageTitle (string page_title)
{
  labelPageTitle->Caption = page_title.c_str();
}
*/
//---------------------------------------------------------------------------
/*
// x of y -- this is the y, x is size() of page_history
void TformWizardGeneric::SetExpectedPages (int expected_pages)
{
  expected_number_pages = expected_pages;
  RefreshPageNumbers();
}
*/
//---------------------------------------------------------------------------
// just make sure the integer is valid
bool TformWizardGeneric::PageExists(int page_index)
{
  return (page_index >= 0 && page_index < pageStandard->PageCount);
}
//---------------------------------------------------------------------------
// change and make sure buttons are correct
void TformWizardGeneric::ChangePage(int page_index)
{
  // message_router->SendMessageToAll("wizard_debug", "ChangePage: starting, moving to " + IntToString(page_index));
  AV_TRY
    pageStandard->ActivePageIndex = page_index;
    labelPageTitle->Caption = pageStandard->ActivePage->Caption;
    RefreshPageNumbers();

    buttonBack->Enabled  = !page_history.empty();
    if (int(page_history.size() + 1) >= NumberOfPages() /* expected_number_pages */)
      buttonNext->Caption = "&Save";
    else
      buttonNext->Caption = "&Next >>";

    PopulatePageList();
  AV_CATCH
  // message_router->SendMessageToAll("wizard_debug", "ChangePage: finishing, moved to " + IntToString(page_index));
}
//---------------------------------------------------------------------------
// true/false: we care to see this page (simplify WhereNext by coding this only once)
bool TformWizardGeneric::SkipPage(int page_index)
{
  return false; // always show page unless overridden
}
//---------------------------------------------------------------------------
// true/false: this page is without errors
bool TformWizardGeneric::IsValidPage(int page_index)
{
  // nothing yet -- must override
  return true;
}
//---------------------------------------------------------------------------
int TformWizardGeneric::WhereNextWrapper(int page_index)
{
  int temp = _WhereNext(page_index);

  while (_SkipPage(temp))
    temp = _WhereNext(temp);

  return temp;
}
//---------------------------------------------------------------------------
// page_index of the next page to visit, based on current page number
int TformWizardGeneric::WhereNext(int page_index)
{
  if(page_index < pageStandard->PageCount-1)
    return page_index+1;
  else
    return last_wizard_page;
}
//---------------------------------------------------------------------------
// reset given page, use existing info to fill it in, etc.
void TformWizardGeneric::SetupPage(int page_index)
{
  // nothing yet -- must override
  return;
}
//---------------------------------------------------------------------------
// actually go from A to B, ... no reset, no messing with other stuff?
bool TformWizardGeneric::ProcessPage(int page_index)
{
  // nothing yet -- must override
  return true;
}
//---------------------------------------------------------------------------
// go back to the basics and try again. Cancel and first opening do this.
void TformWizardGeneric::StartOver()
{
  AV_TRY
    // message_router->SendMessageToAll("wizard_debug", "StartOver: starting");
    // start over, yes.
    if (PageExists(start_page))
    {
      while (!page_history.empty())
        page_history.pop();
      _SetupPage (start_page);
      ChangePage (start_page);
    }
    else
    {
      PSay("The wizard would like to take you back to the beginning, but isn't sure where the beginning is!\n"
           "Please inform a programmer immediately.", m_program_error, MB_OK);
    }
    // message_router->SendMessageToAll("wizard_debug", "StartOver: finishing");
  AV_CATCH
}
//---------------------------------------------------------------------------
bool TformWizardGeneric::FinishWizard ()
{
  // nothing, must override
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardGeneric::FormClose(TObject *Sender, TCloseAction &Action)
{
  if (!close_quickly)
  {
    if (!page_history.empty())
    {
      int user_answer;
      user_answer = PSay("Changes are saved each time you press 'finish,' but not before.\n"
                         "Are you sure you want to ABANDON your unsaved work?", m_confirmation, MB_YESNO);
      if (user_answer == IDNO)
      {
        Action = caNone;
        return;
      }
    }
  }

  if (Action != caNone)
    TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void TformWizardGeneric::RefreshPageNumbers()                  // just do the above. and stuff.
{
  AV_TRY
    //                                                               expected_number_pages
    string caption = IntToString(page_history.size() + 1) + " of " + IntToString(NumberOfPages()) + "  ";
    labelPageNumbers->Caption = caption.c_str();
  AV_CATCH
  // message_router->SendMessageToAll("wizard_debug", "RefreshPageNumbers: " + string(labelPageNumbers->Caption.c_str()));
}
//---------------------------------------------------------------------------
void __fastcall TformWizardGeneric::FormShortCut(TWMKey &Msg, bool &Handled)
{
 // message_router->SendMessageToAll("wizard_debug", "FormShortCut: wow, someone's using the keyboard!");

  TformSpecialGeneric::FormShortCut(Msg, Handled);

  // TODO: really, make sure we can use alt+keys, and let it happen automatically, remove this crap ...
  // control+ isn't appropriate. argh. shouldn't have gotten them accustomed to it.

  if(HIBYTE(GetAsyncKeyState(VK_CONTROL)))
  {
    Handled = true;
    if (((Msg.CharCode == 'b') || (Msg.CharCode == 'B')) && buttonBack->Enabled)
      buttonBackClick(NULL);  // go back
    else if (((Msg.CharCode == 'n') || (Msg.CharCode == 'N')) && buttonNext->Enabled && buttonNext->Caption == "&Next >>")
      buttonNextClick(NULL);  // next page
    else if (((Msg.CharCode == 's') || (Msg.CharCode == 'S')) && buttonNext->Enabled && buttonNext->Caption == "&Save")
      buttonNextClick(NULL);  // finish, save
    /*
    else if (((Msg.CharCode == 's') || (Msg.CharCode == 'S')) && buttonReset->Enabled)
      buttonResetClick(NULL);  // start over
    // No!  Bad!  Ctrl-C is "copy".  Esc works for cancel/close.  -Paul
    else if (((Msg.CharCode == 'c') || (Msg.CharCode == 'C')) && buttonClose->Enabled)
      buttonCloseClick(NULL);  // go away
    */
    else
      Handled = false;
  }
  else
    Handled = false;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardGeneric::listWizardPagesSelectItem(TObject *Sender, TListItem *Item, bool Selected)
{
  AV_TRY
    if (!page_list_window->DrawerExpanded || IsProcessing())
    {
      // message_router->SendMessageToAll("wizard_debug", "listWizardPageSelectItem: avoiding possible conflict");
      return;
    }

    // message_router->SendMessageToAll("wizard_debug", "listWizardPageSelectItem: starting");
    // TODO: wizard page selected
    for(set<int>::iterator i_page = locked_pages.begin(); i_page != locked_pages.end(); i_page++)
      _PageLockStatus (*i_page, false);

    // message_router->SendMessageToAll("wizard_debug", "listWizardPageSelectItem: unlocked any locked pages");

    locked_pages.clear();

    // message_router->SendMessageToAll("wizard_debug", "listWizardPageSelectItem: cleared the list of locked pages");

    int moving_to_page = ((item_to_page_info*)(Item->Data))->page_index;

    // message_router->SendMessageToAll("wizard_debug", "listWizardPageSelectItem: moving to "
    //   + IntToString(moving_to_page));

    if (((item_to_page_info*)(Item->Data))->is_current == true)
    {
      // message_router->SendMessageToAll("wizard_debug",
      //  "listWizardPageSelectItem: it's the in-progress page, going to enable things");
      pageStandard->ActivePageIndex = moving_to_page;

      labelPageTitle->Caption   = pageStandard->ActivePage->Caption;
      string pgnum_caption = IntToString(Item->Index + 1) + " of " + IntToString(NumberOfPages()) + "  ";
      labelPageNumbers->Caption = pgnum_caption.c_str();

      buttonBack->Enabled  = !page_history.empty();
      buttonClear->Enabled = true;
      buttonNext->Enabled  = true;
      buttonReset->Enabled = true;
      // message_router->SendMessageToAll("wizard_debug", "listWizardPageSelectItem: it's the in-progress page, done");
    }
    else
    {
      // message_router->SendMessageToAll("wizard_debug", "listWizardPageSelectItem: some random page, locking things");
      locked_pages.insert(moving_to_page);
      _PageLockStatus (moving_to_page, true);

      pageStandard->ActivePageIndex = moving_to_page;

      labelPageTitle->Caption   = pageStandard->ActivePage->Caption;
      string pgnum_caption = IntToString(Item->Index + 1) + " of " + IntToString(NumberOfPages()) + "  ";
      labelPageNumbers->Caption = pgnum_caption.c_str();

      buttonBack->Enabled  = false;
      buttonClear->Enabled = false;
      buttonNext->Enabled  = false;
      buttonReset->Enabled = false;
      // message_router->SendMessageToAll("wizard_debug", "listWizardPageSelectItem: some random page, done");
    }
    // message_router->SendMessageToAll("wizard_debug", "listWizardPageSelectItem: finishing");
  AV_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformWizardGeneric::buttonWizardPagesClick(TObject *Sender)
{
 // message_router->SendMessageToAll("wizard_debug",
 //   string("buttonWizardPagesClick: the drawer will be ")
 //   + ((buttonWizardPages->Down) ? string("open") : string("closed")));
 page_list_window->DrawerExpanded = buttonWizardPages->Down;
}
//---------------------------------------------------------------------------
void TformWizardGeneric::PopulatePageList()
{
  AV_TRY
    // message_router->SendMessageToAll("wizard_debug", "PopulatePageList: starting");
    // TODO: some of this seems dangerous, as it relies (as does most of WizardGeneric's code) on
    // pageStandard->ActivePageIndex

    listWizardPages->Items->Clear();

    // where we've been ...
    stack<int, list<int> > copy_of_history = page_history;
    TListItem * new_item = NULL;
    int temp = start_page;
    int count_visited = 0;
    while (!copy_of_history.empty())
    {
      temp = copy_of_history.top();
      copy_of_history.pop();
      new_item = listWizardPages->Items->Insert(0);
      new_item->Caption = pageStandard->Pages[temp]->Caption;
      new_item->Data = new item_to_page_info(temp, true, false);
      new_item->ImageIndex = -1;
      count_visited++;
    }

    // where we are ...
    new_item = listWizardPages->Items->Add();
    new_item->Caption = pageStandard->ActivePage->Caption;
    new_item->Data = new item_to_page_info(pageStandard->ActivePageIndex, true, true);
    new_item->ImageIndex = 0;

    // where we're going ...
    temp = pageStandard->ActivePageIndex;
    int next = temp;
    while (WhereNextWrapper(temp) != TformWizardGeneric::last_wizard_page)
    {
      next = WhereNextWrapper(temp);
      new_item = listWizardPages->Items->Add();
      new_item->Caption = pageStandard->Pages[next]->Caption;
      new_item->Data = new item_to_page_info(next, false, false);
      new_item->ImageIndex = -1;
      temp = next;
    }

    listWizardPages->Items->Item[count_visited]->Selected = true;
    // message_router->SendMessageToAll("wizard_debug", "PopulatePageList: finishing");
  AV_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformWizardGeneric::listWizardPagesCustomDrawItem(
      TCustomListView *Sender, TListItem *Item, TCustomDrawState State,
      bool &DefaultDraw)
{
  AV_TRY
    if (((item_to_page_info*)(Item->Data))->is_clickable != true)
      Sender->Canvas->Font->Color = clGray;
  AV_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformWizardGeneric::listWizardPagesChanging(
      TObject *Sender, TListItem *Item, TItemChange Change,
      bool &AllowChange)
{
  AV_TRY
    // TODO -c BUG : jhaley 20101026: a null pointer check is evidently needed here, but should it set false, or true?
    // only block if they're trying to ->Selected a non-clickable
    if (Change == ctState && ((item_to_page_info*)(Item->Data))->is_clickable != true)
      AllowChange = false;
    else
      AllowChange = true;
  AV_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformWizardGeneric::buttonClearClick(TObject *Sender)
{
  AV_TRY
    // message_router->SendMessageToAll("wizard_debug", "buttonClearClick: starting");
    // maybe we should ask for confirmation? could really annoy them to hit this accidentally.
    Processing (true);
    int this_page = pageStandard->ActivePageIndex;
    // message_router->SendMessageToAll("wizard_debug", "buttonClearClick: clearing " + IntToString(this_page));
    if (PageExists (this_page))
      _SetupPage (this_page);
    else
    {
      PSay("The wizard couldn't clear the page, because it doesn't seem to exist.\n"
           "Please report this problem to a programmer immediately.", m_program_error, MB_OK);
    }
    Processing (false);
    // message_router->SendMessageToAll("wizard_debug", "buttonClearClick: finishing");
  AV_CATCH
}
//---------------------------------------------------------------------------
bool TformWizardGeneric::WizardLocked ()
{
  // message_router->SendMessageToAll("wizard_debug", string("WizardLocked: ")
  //  + ((!locked_pages.empty()) ? string("true") : string("false")));
  return !(locked_pages.empty());
}
//---------------------------------------------------------------------------
void TformWizardGeneric::PageLockStatus (int page_index, bool locked)
{
 // nothing yet -- must override
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardGeneric::listWizardPagesDeletion(
      TObject *Sender, TListItem *Item)
{
  AV_TRY
    delete Item->Data;
  AV_CATCH
}
//---------------------------------------------------------------------------
int TformWizardGeneric::NumberOfPages ()
{
  int answer = 0;

  AV_TRY
    // where we've been ...
    stack<int, list<int> > copy_of_history = page_history;
    while (!copy_of_history.empty())
    {
      copy_of_history.pop();
      answer++;
    }

    // where we are ...
    answer++;

    // where we're going ...
    int temp = pageStandard->ActivePageIndex;
    while (WhereNextWrapper(temp) != TformWizardGeneric::last_wizard_page)
    {
      temp = WhereNextWrapper(temp);
      answer++;
    }
  AV_CATCH

  // yes, that.
  return answer;
}
//---------------------------------------------------------------------------
void TformWizardGeneric::DrawerIsChanging (TformSpecialGeneric * Drawer, bool Expanding)
{
  AV_TRY
    if (Drawer == page_list_window)
      buttonWizardPages->Down = page_list_window->DrawerExpanded;
    TformSpecialGeneric::DrawerIsChanging(Drawer, Expanding);
  AV_CATCH
}
//---------------------------------------------------------------------------
bool TformWizardGeneric::HistoryIncludes (int page_index)
{
  bool answer = false;

  AV_TRY
    // all pages we've been to ...
    stack<int, list<int> > copy_of_history = page_history;
    while (!copy_of_history.empty())
    {
      if (copy_of_history.top() == page_index)
      {
        answer = true;
        break;
      }
      copy_of_history.pop();
    }
  AV_CATCH

  // current page isn't in the history yet!
  if (pageStandard->ActivePageIndex == page_index)
    answer = true;

  return answer;
}
//---------------------------------------------------------------------------
bool TformWizardGeneric::_SkipPage (int page_index)
{
  bool answer = false;

  try
  {
    answer = SkipPage(page_index);
  }
  catch(EAccessViolation &av)
  {
    PPretendToSay(av.Message.c_str(), m_program_error,
      "Access Violation caught: " + string(__FILE__) + "; "
      + string(__FUNC__) + "(" + IntToString(page_index) + "); "
      + IntToString(__LINE__));
  }

  return answer;
}
//---------------------------------------------------------------------------
bool TformWizardGeneric::_IsValidPage (int page_index)
{
  bool answer = false;

  try
  {
    answer = IsValidPage(page_index);
  }
  catch(EAccessViolation &av)
  {
    PPretendToSay(av.Message.c_str(), m_program_error,
      "Access Violation caught: " + string(__FILE__) + "; "
      + string(__FUNC__) + "(" + IntToString(page_index) + "); "
      + IntToString(__LINE__));
  }

  return answer;
}
//---------------------------------------------------------------------------
int TformWizardGeneric::_WhereNext (int page_index)
{
  int answer = 0;
  try
  {
    answer = WhereNext(page_index);
  }
  catch(EAccessViolation &av)
  {
    PPretendToSay(av.Message.c_str(), m_program_error,
      "Access Violation caught: " + string(__FILE__) + "; "
      + string(__FUNC__) + "(" + IntToString(page_index) + "); "
      + IntToString(__LINE__));
  }

  return answer;
}
//---------------------------------------------------------------------------
bool TformWizardGeneric::_ProcessPage (int page_index)
{
  bool answer = false;

  try
  {
    answer = ProcessPage(page_index);
  }
  catch(EAccessViolation &av)
  {
    PPretendToSay(av.Message.c_str(), m_program_error,
      "Access Violation caught: " + string(__FILE__) + "; "
      + string(__FUNC__) + "(" + IntToString(page_index) + "); "
      + IntToString(__LINE__));
  }

  return answer;
}
//---------------------------------------------------------------------------
void TformWizardGeneric::_SetupPage (int page_index)
{
  try
  {
    SetupPage(page_index);
  }
  catch(EAccessViolation &av)
  {
    PPretendToSay(av.Message.c_str(), m_program_error,
      "Access Violation caught: " + string(__FILE__) + "; "
      + string(__FUNC__) + "(" + IntToString(page_index) + "); "
      + IntToString(__LINE__));
  }
}
//---------------------------------------------------------------------------
bool TformWizardGeneric::_FinishWizard ()
{
  bool answer = false;

  AV_TRY
    answer = FinishWizard();
  AV_CATCH

  return answer;
}
//---------------------------------------------------------------------------
void TformWizardGeneric::_PageLockStatus (int page_index, bool locked)
{
  try
  {
    PageLockStatus(page_index, locked);
  }
  catch(EAccessViolation &av)
  {
    PPretendToSay(av.Message.c_str(), m_program_error,
      "Access Violation caught: " + string(__FILE__) + "; "
      + string(__FUNC__) + "(" + IntToString(page_index) + ", "
      + (locked ? string("true") : string("false")) + "); " + IntToString(__LINE__));
  }
}
//---------------------------------------------------------------------------

