//---------------------------------------------------------------------------

#ifndef codeWizardGenericH
#define codeWizardGenericH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>

#include <stack>
#include "codeDrawerGeneric.h"

struct item_to_page_info
{
 item_to_page_info (int index, bool clickable, bool current) : page_index (index), is_clickable (clickable), is_current (current) {};
 int  page_index;
 bool is_clickable;
 bool is_current;
};

//---------------------------------------------------------------------------
class TformWizardGeneric : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *buttonBack;
        TToolButton *buttonNext;
        TToolButton *sepA;
        TToolButton *buttonReset;
        TToolButton *buttonClose;
        TPanel *panelTitle;
        TPageControl *pageStandard;
        TLabel *labelPageTitle;
        TLabel *labelPageNumbers;
        TListView *listWizardPages;
        TToolButton *sepC;
        TToolButton *buttonWizardPages;
        TToolButton *buttonClear;
        TImageList *imagesWizardPageList;
        TBevel *bevelWizard;
        void __fastcall buttonBackClick(TObject *Sender);
        void __fastcall buttonNextClick(TObject *Sender);
        void __fastcall buttonResetClick(TObject *Sender);
        void __fastcall buttonCloseClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall FormShortCut(TWMKey &Msg, bool &Handled);
        void __fastcall listWizardPagesSelectItem(TObject *Sender,
          TListItem *Item, bool Selected);
        void __fastcall buttonWizardPagesClick(TObject *Sender);
        void __fastcall listWizardPagesCustomDrawItem(
          TCustomListView *Sender, TListItem *Item, TCustomDrawState State,
          bool &DefaultDraw);
        void __fastcall listWizardPagesChanging(TObject *Sender,
          TListItem *Item, TItemChange Change, bool &AllowChange);
        void __fastcall buttonClearClick(TObject *Sender);
        void __fastcall listWizardPagesDeletion(TObject *Sender,
          TListItem *Item);
private:	// User declarations
        TformDrawerGeneric * page_list_window;

        bool virtual _SkipPage    (int page_index);
        bool virtual _IsValidPage (int page_index);
         int virtual _WhereNext   (int page_index);
        bool virtual _ProcessPage (int page_index);
        void virtual _SetupPage   (int page_index);
        bool virtual _FinishWizard ();
        void virtual _PageLockStatus (int page_index, bool locked);
protected:
        // data
        stack <int, list<int> > page_history; // note: we're specifying what structure (list) the stack is using, not a pair<,> of stuff
        set<int> locked_pages;

        // int expected_number_pages;
        int start_page;
        bool close_quickly;
        bool close_on_finish;
        // functions
        bool virtual IsBusy   ();                            // from special generic, determine if -really- busy (deprecated?)
        bool virtual CloseNow ();                            // from special generic, close ... do special stuff if needed.

        void virtual Initialize ();                          // in case we want to mess with tabs on the page, need to do it in initialize, not constructor (only page exists here)

        void DrawerIsChanging (TformSpecialGeneric * Drawer, bool Expanding);
        // void         SetExpectedPages (int expected_pages);  // x of y -- this is the y, x is size() of page_history
        int          NumberOfPages ();
        void         RefreshPageNumbers ();                  // just do the above. and stuff.
        bool         PageExists  (int page_index);           // just make sure the integer is valid
        void         ChangePage  (int page_index);           // change and make sure buttons are correct
        void         StartOver        ();                    // go back to the basics and try again. Cancel and first opening do this.
        void         PopulatePageList ();                    // draw the list on the left
        bool         WizardLocked     ();                    // user is roaming, looking at other pages
        bool         HistoryIncludes (int page_index);       // have we been there?
         int         WhereNextWrapper (int page_index);

        bool virtual SkipPage    (int page_index);           // true/false: we care to see this page (simplify WhereNext by coding this only once)
        bool virtual IsValidPage (int page_index);           // true/false: this page is without errors
         int virtual WhereNext   (int page_index);           // page_index of the next page to visit, based on current page number
        bool virtual ProcessPage (int page_index);           // actually go from A to B, ... no reset, no messing with other stuff?
        void virtual SetupPage   (int page_index);           // make this page ready to be shown based on other data
        bool virtual FinishWizard ();                        // actually save data here, rather than in ProcessPage()

        void virtual PageLockStatus (int page_index, bool locked); // user goes to a page they're not editing, or leaves it
public:		// User declarations
        __fastcall TformWizardGeneric(TComponent* Owner);
        static const int last_wizard_page = -1;
};
//---------------------------------------------------------------------------
extern PACKAGE TformWizardGeneric *formWizardGeneric;
//---------------------------------------------------------------------------
#endif
