//-------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeWizardIntakeNewPerson.h"
#include "codeSearchTaxEntity.h"
#include "codeSearchInsurancePolicy.h"
#include "codeSearchPerson.h"
#include "codeRecordPerson.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeWizardGeneric"
#pragma resource "*.dfm"
TformWizardIntakeNewPerson *formWizardIntakeNewPerson;
//---------------------------------------------------------------------------
__fastcall TformWizardIntakeNewPerson::TformWizardIntakeNewPerson(TComponent* Owner)
        : TformWizardGeneric(Owner)
{
  // General
  lookupTables->RegisterComboBox("gender_types", cboGender);
  lookupTables->RegisterComboBox("marital_types", cboMarital);
  lookupTables->RegisterComboBox("tribe_types", cboTribe);
  affiliations_listview.setup_listview(listAffiliations);
  affiliations_listview.add_or_modify_column("tribe","Tribe",true,0,-1,as_text,prettyString);
  affiliations_listview.add_or_modify_column("cdib","CDIB",true,1,-1,as_text,rawString);
  affiliations_listview.add_or_modify_column("id","Internal Id",false,2,-1,as_int,intString);
  affiliations_listview.setup_callbacks((TForm*)this, InformForm(&(TformWizardIntakeNewPerson::AffiliationSelected)), NULL);

  // Addresses
//lookupTables->RegisterComboBox("county_types", cboCounty); // we need this
  lookupTables->RegisterComboBox("state_types", cboState);
  lookupTables->RegisterComboBox("contact_info_types", cboAddressType);
  lookupTables->RegisterComboBox("residence_types", cboResidence);

  addresses_listview.setup_listview(listAddresses);
  addresses_listview.add_or_modify_column("place","Place",true,0,-1,as_text,prettyString);
  addresses_listview.add_or_modify_column("line1","Address",true,1,-1,as_text,addressString);
  addresses_listview.add_or_modify_column("city","City",true,2,-1,as_text,prettyString);
  addresses_listview.add_or_modify_column("state","State",true,3,-1,as_text,prettyString);
  addresses_listview.add_or_modify_column("zip","Zip",true,4,-1,as_text,prettyString);
  addresses_listview.add_or_modify_column("country","Country",true,5,-1,as_text,prettyString);
  addresses_listview.add_or_modify_column("residence","Residence",true,6,-1,as_text,prettyString);
  addresses_listview.add_or_modify_column("trust_lands","Trust Lands",true,7,-1,as_text,prettyString);
  addresses_listview.add_or_modify_column("phone_number","Phone Number",true,8,-1,as_text,prettyPhoneString);
  addresses_listview.add_or_modify_column("notes","Notes",true,9,-1,as_text,prettyString);
  addresses_listview.add_or_modify_column("id","Internal Id",false,10,-1,as_int,intString);
  addresses_listview.setup_callbacks((TForm*)this, InformForm(&(TformWizardIntakeNewPerson::AddressSelected)), NULL);

  // Relationships
  lookupTables->RegisterComboBox("gender_types", cboRelGender);
  lookupTables->RegisterComboBox("tribe_types", cboRelTribe);
  lookupTables->RegisterComboBox("relationship_types", cboRelRelationship);
  CreateLink(txtRelExistingPerson, btnRelExistingPersonSearch, this, rel_person_id, "people", "", true, first_middle_last);

  relationships_listview.setup_listview(listRelationships);
  relationships_listview.add_or_modify_column("person_type","Person",true,0,-1,as_text,prettyString);
  relationships_listview.add_or_modify_column("relationship","Relationship",true,1,-1,as_text,prettyString);
  relationships_listview.add_or_modify_column("prefix","Prefix",true,2,-1,as_text,prettyString);
  relationships_listview.add_or_modify_column("first_name","First Name",true,3,-1,as_text,prettyString);
  relationships_listview.add_or_modify_column("middle_name","Middle Name",true,4,-1,as_text,prettyString);
  relationships_listview.add_or_modify_column("last_name","Last Name",true,5,-1,as_text,prettyString);
  relationships_listview.add_or_modify_column("suffix","Suffix",true,6,-1,as_text,prettyString);
  relationships_listview.add_or_modify_column("ssn","SSN",true,7,-1,as_text,prettySSNString);
  relationships_listview.add_or_modify_column("dob","DOB",true,8,-1,as_date,prettyString);
  relationships_listview.add_or_modify_column("gender","Gender",true,9,-1,as_text,prettyString);
  relationships_listview.add_or_modify_column("is_emergency","Emergency",true,10,-1,as_text,prettyBoolString);
  relationships_listview.add_or_modify_column("is_responsible","Responsible",true,11,-1,as_text,prettyBoolString);
  relationships_listview.add_or_modify_column("is_banned","Banned",true,12,-1,as_text,prettyBoolString);
  relationships_listview.add_or_modify_column("id","Internal Id",false,13,-1,as_int,intString);
  relationships_listview.setup_callbacks((TForm*)this, InformForm(&(TformWizardIntakeNewPerson::RelationshipSelected)), NULL);

  rel_people_filter.SetListViewHandle(listRelationMatches);
  rel_people_filter.SetSecurity("people");
  rel_people_filter.AddColumnSpec("Prefix", "person_names", as_text, false, -1);
  rel_people_filter.AddColumnSpec("First name", "person_names", as_text, true, -1);
  rel_people_filter.AddColumnSpec("Middle name", "person_names", as_text, true, -1);
  rel_people_filter.AddColumnSpec("Last name", "person_names", as_text, true, -1);
  rel_people_filter.AddColumnSpec("Suffix", "person_names", as_text, true, -1);
  rel_people_filter.AddColumnSpec("DOB", "people", as_date, true, -1);
  rel_people_filter.AddColumnSpec("CDIB", "affiliations", as_text, true, -1, lowercaseString);
  rel_people_filter.AddColumnSpec("Tribe", "affiliations", as_text, true, -2);
  rel_people_filter.AddColumnSpec("SSN", "people", as_text, true, -1, prettySSNString);
  rel_people_filter.AddColumnSpec("Gender", "people", as_text, true, -1);
  rel_people_filter.AddColumnSpec("Current Id", "current_id", as_int, false, -1);
  rel_people_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, -1);
  rel_people_filter.SetAddEdit(this, NULL, EditRecord(&(TformWizardIntakeNewPerson::EditRelPeople)));
  rel_people_filter.FetchPreferences("wizardintake.rel_people_filter");
  rel_people_filter.SetSQLStatement("");
  rel_people_filter.RefreshDataSet();

  // Insurance
  CreateLink(txtPolicy, btnPolicySearch, this, policy_id, "insurance_policies");
  CreateLink(txtCompany, btnCompanySearch, this, company_id, "tax_entities");
  CreateLink(txtPcp, btnPcpSearch, this, pcp_id, "tax_entities");
  lookupTables->RegisterComboBox("coverage_types", cboCoverage);
  lookupTables->RegisterComboBox("source_types", cboSource);

  insurance_listview.setup_listview(listInsurance);
  insurance_listview.add_or_modify_column("company","Company",true,0,-1,as_text,prettyString);
  insurance_listview.add_or_modify_column("policy_number","Policy Number",true,1,-1,as_text,rawString);
  insurance_listview.add_or_modify_column("group_number","Group Number",true,2,-1,as_text,rawString);
  insurance_listview.add_or_modify_column("start_date","Effective Date",true,3,-1,as_date,prettyString);
  insurance_listview.add_or_modify_column("stop_date","Termination Date",true,4,-1,as_date,prettyString);
  insurance_listview.add_or_modify_column("coverage","Coverage",true,5,-1,as_text,prettyString);
  insurance_listview.add_or_modify_column("source","Source",true,6,-1,as_text,prettyString);
  insurance_listview.add_or_modify_column("name_on_policy","Name on Policy",true,7,-1,as_text,prettyString);
  insurance_listview.add_or_modify_column("pcp","PCP",true,8,-1,as_text,prettyString);
  insurance_listview.add_or_modify_column("person_code","Person Code",true,9,-1,as_int,intString);
  insurance_listview.add_or_modify_column("name_on_card","Name on Card",true,10,-1,as_text,prettyString);
  insurance_listview.add_or_modify_column("policy_id","Policy Id",false,11,-1,as_int,intString);
  insurance_listview.add_or_modify_column("coverage_id","Coverage Id",false,12,-1,as_int,intString);
  insurance_listview.setup_callbacks((TForm*)this, InformForm(&(TformWizardIntakeNewPerson::InsuranceSelected)), NULL);

/*insurance_filter.SetListViewHandle(listPolicies);
  insurance_filter.SetSecurity("insurance_policies");
  insurance_filter.AddColumnSpec("Company", "tax_entities", as_text, true, 145, rawString);
  insurance_filter.AddColumnSpec("Policy Number", "insurance_policies", as_text, true, 100, rawString);
  insurance_filter.AddColumnSpec("Group Number", "insurance_policies", as_text, false, 100, rawString);
  insurance_filter.AddColumnSpec("Effective Date", "insurance_policies", as_date, false, 100);
  insurance_filter.AddColumnSpec("Termination Date", "insurance_policies", as_date, false, 100);
  insurance_filter.AddColumnSpec("Coverage", "insurance_policies", as_text, false, 100);
  insurance_filter.AddColumnSpec("Source", "insurance_policies", as_text, false, 100);
  insurance_filter.AddColumnSpec("Name on Policy", "insurance_policies", as_text, true, 120);
  insurance_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  insurance_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  insurance_filter.FetchPreferences("wizardintake.insurance_filter");
  insurance_filter.SetCompress(true);
  insurance_filter.SetCheck(true);
  insurance_filter.SetSQLStatement("");
  insurance_filter.RefreshDataSet();
*/
  benefits_filter.SetListViewHandle(listBenefits);
  benefits_filter.SetSecurity("insurance_benefits");
  benefits_filter.AddColumnSpec("Area", "insurance_benefits", as_text, true, 120);
  benefits_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  benefits_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  benefits_filter.SetCompress(true);
  benefits_filter.SetHeader(false);
  benefits_filter.SetCheck(true);
  benefits_filter.FetchPreferences("wizardintake.benefits_filter");
  benefits_filter.SetSQLStatement("select item, 4, id from area_types where id > 0");
  benefits_filter.RefreshDataSet();

  // Insurance extra

  string location_groups_sql = "select id, item, valid from groups where has_charts = 1 or id = 0 order by item"; // clinics have charts
  lookupTables->RegisterComboBox("groups", cboChartLocation, location_groups_sql);

  // Medical history
/*
  medications_listview.setup_listview(listMedMedications);
  allergies_listview.setup_listview(listMedAllergies);
*/

  //atlas requests
  request_rel_person_id = 0;
  request_policy_id = 0;

  Initialize();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardIntakeNewPerson::FormClose(TObject *Sender,TCloseAction &Action)
{
  // page 1
  lookupTables->UnregisterComboBox("tribe_types", cboTribe);
  lookupTables->UnregisterComboBox("gender_types", cboGender);
  lookupTables->UnregisterComboBox("contact_info_types", cboAddressType);
  lookupTables->UnregisterComboBox("residence_types", cboResidence);
  lookupTables->UnregisterComboBox("state_types", cboState);
  // page 2
  lookupTables->UnregisterComboBox("coverage_types", cboCoverage);
  lookupTables->UnregisterComboBox("source_types", cboSource);
  // page 4
  lookupTables->UnregisterComboBox("groups", cboChartLocation);

  Action = caFree;
  TformWizardGeneric::FormClose(Sender, Action);
  if (Action != caNone)
  {
    // cleanup
    // helper window is handled automatically (wizard closes, thus drawer closes, thus unkidnapping, etc.)
  }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardIntakeNewPerson::RelationshipFieldExit(TObject *Sender)
{
  if(editRelFirstName->Text != "" && editRelLastName->Text != "")
  {
    bool do_tribe = (cboRelTribe->Text != "" && lookupTables->IsInLookUpTable("tribe_types", cboRelTribe->Text.c_str()));
    bool do_gender = (cboRelGender->Text != "" && lookupTables->IsInLookUpTable("gender_types", cboRelGender->Text.c_str()));
    bool do_affiliations = (editRelCDIB->Text != "" || do_tribe);
    string sql = "select PN.prefix, PN.first_name, PN.middle_name, PN.last_name, PN.suffix, "
                 " P.birth_date, A.cdib, TT.item, P.social_security_number, GT.item, P.current_id, P.id "
                 "from people P inner join person_names PN on P.person_names_id = PN.id "
                 " left join affiliations A on A.person_id = P.id and A.current_id >= 3 "
                 " left join tribe_types TT on A.tribe_id = TT.id and TT.current_id >= 3 "
                 " left join gender_types GT on P.gender_id = GT.id and GT.current_id >= 3 ";
    sql += "where PN.first_name = '" + SafeSQLString(UppercaseString(editRelFirstName->Text.c_str())) + "' "
           " and PN.last_name = '" + SafeSQLString(UppercaseString(editRelLastName->Text.c_str())) + "' ";
    if(editRelPrefix->Text != "")
      sql += " and PN.prefix = '" + SafeSQLString(UppercaseString(editRelPrefix->Text.c_str())) + "' ";
    if(editRelSuffix->Text != "")
      sql += " and PN.suffix = '" + SafeSQLString(UppercaseString(editRelSuffix->Text.c_str())) + "' ";
    if(editRelSSN->Text != "")
      sql += " and P.social_security_number = '" + StripAllExcept(editRelSSN->Text.c_str(), uints) + "' ";
    if(editRelDOB->Text != "" && Pdate(editRelDOB->Text.c_str(), global_mode).IsValidDate())
      sql += " and P.birth_date = '" + Pdate(editRelDOB->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
    if(do_gender)
      sql += " and P.gender_id = '" + lookupTables->IdOf("gender_types", cboRelGender->Text.c_str()) + "' ";
    if(editRelCDIB->Text != "")
      sql += " and A.cdib = '" + SafeSQLString(editRelCDIB->Text.c_str()) + "' ";
    if(do_tribe)
      sql += " and A.tribe_id = '" + lookupTables->IdOf("tribe_types", cboRelTribe->Text.c_str()) + "' ";
    rel_people_filter.SetSQLStatement(sql);
    rel_people_filter.RefreshDataSet();
  }
  else
  {
    // if I switch to button-activated rather than automatically finding matches, I'd need a warning message here
  }
}
//---------------------------------------------------------------------------
bool TformWizardIntakeNewPerson::EditRelPeople(const string & p_id)
{
  map<string,string> temp_map;
  temp_map["id"] = rel_people_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordPerson * personRecord = new TformRecordPerson(NULL, temp_map);
    personRecord->Show();
  FORM_CATCH
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardIntakeNewPerson::RelationshipFieldEnter(TObject *Sender)
{
  radioRelNewPerson->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardIntakeNewPerson::btnCompanySearchClick(TObject *Sender)
{
  vector<string> return_vector;
  FORM_TRY
    TformSearchTaxEntity * companySearch = new TformSearchTaxEntity(NULL,&return_vector);
    companySearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
  {
    company_id = return_vector[0];
    CreateLink(txtCompany, btnCompanySearch, this, company_id, "tax_entities");
  }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardIntakeNewPerson::btnPolicySearchClick(TObject *Sender)
{
  vector<string> return_vector;
  FORM_TRY
    TformSearchInsurancePolicy * policySearch = new TformSearchInsurancePolicy(NULL,&return_vector);
    policySearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
  {
    policy_id = return_vector[0];
    CreateLink(txtPolicy, btnPolicySearch, this, policy_id, "insurance_policies");
  }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardIntakeNewPerson::btnPcpSearchClick(TObject *Sender)
{
  vector<string> return_vector;
  FORM_TRY
    TformSearchTaxEntity * pcpSearch = new TformSearchTaxEntity(NULL,&return_vector);
    pcpSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
  {
    pcp_id = return_vector[0];
    CreateLink(txtPcp, btnPcpSearch, this, pcp_id, "tax_entities");
  }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardIntakeNewPerson::btnRelExistingPersonSearchClick(TObject *Sender)
{
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * relPersonSearch = new TformSearchPerson(NULL,&return_vector);
    relPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
  {
    rel_person_id = return_vector[0];
    CreateLink(txtRelExistingPerson, btnRelExistingPersonSearch, this, rel_person_id, "people");
  }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardIntakeNewPerson::btnRelUseExistingClick(TObject *Sender)
{
  if (listRelationMatches->Selected)
  {
    rel_person_id = rel_people_filter.GetSelectedRecordID();
    CreateLink(txtRelExistingPerson, btnRelExistingPersonSearch, this, rel_person_id, "people");
    radioRelExistingPerson->Checked = true;
  }
  else
    PSay("You must select a person from the list to the left.  If the list is empty, "
         "and you've entered a first and last name above, then no matches were found.\n\n"
         "If you think there should have been a match and there wasn't, press the search "
         "button below and search for the person manually.", m_message, MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TformWizardIntakeNewPerson::buttonRelationsSaveClick(TObject *Sender)
{
  // Creating a new person
  map<string, string> row_data;

  bool have_relationship = (cboRelRelationship->Text != "" && lookupTables->IsInLookUpTable("relationship_types", cboRelRelationship->Text.c_str()));
  if (!have_relationship)
  {
    PSay("Please select a relationship.", m_invalid_data, MB_OK);
    return;
  }

  if(radioRelNewPerson->Checked)
  {
    bool have_prefix       = editRelPrefix->Text != "";
    bool have_first_name   = editRelFirstName->Text != "";
    bool have_middle_name  = editRelMiddleName->Text != "";
    bool have_last_name    = editRelLastName->Text != "";
    bool have_suffix       = editRelSuffix->Text != "";
    bool have_ssn          = editRelSSN->Text != "";
    bool have_dob          = editRelDOB->Text != "" && Pdate(editRelDOB->Text.c_str(), global_mode).IsValidDate();
    bool have_gender       = (cboRelGender->Text != "" && lookupTables->IsInLookUpTable("gender_types", cboRelGender->Text.c_str()));
    bool have_cdib         = editRelCDIB->Text != "";
    bool have_tribe        = (cboRelTribe->Text != "" && lookupTables->IsInLookUpTable("tribe_types", cboRelTribe->Text.c_str()));
    bool have_affiliation  = (have_cdib || have_tribe);

    if (!have_first_name)
    {
      PSay("Please enter a first name.", m_invalid_data, MB_OK);
      return;
    }

    if (!have_last_name)
    {
      PSay("Please enter a last name.", m_invalid_data, MB_OK);
      return;
    }

    row_data["person_type"]     = "New";
    row_data["relationship"]    = cboRelRelationship->Text.c_str();
    row_data["prefix"]          = editRelPrefix->Text.c_str();
    row_data["first_name"]      = editRelFirstName->Text.c_str();
    row_data["middle_name"]     = editRelMiddleName->Text.c_str();
    row_data["last_name"]       = editRelLastName->Text.c_str();
    row_data["suffix"]          = editRelSuffix->Text.c_str();
    row_data["ssn"]             = StripAllExcept(editRelSSN->Text.c_str(), uints);
    row_data["dob"]             = Pdate(editRelDOB->Text.c_str(), mdy | yy).OutDate(mdy | yyyy);
    row_data["gender"]          = cboRelGender->Text.c_str();
    row_data["is_emergency"]    = checkRelEmergencyContact->Checked ? "1" : "0";
    row_data["is_responsible"]  = checkRelResponsibleParty->Checked ? "1" : "0";
    row_data["is_banned"]       = checkRelBanned->Checked ? "1" : "0";
    row_data["id"]              = "new";
  }
  // Using existing person
  else
  {
    // DONE:  (I think?) add the same columns as above, except get the data via SQL
    vector<map<string, string> > person_vec;
    string sql = "select PN.prefix, PN.first_name, PN.middle_name, PN.last_name, PN.suffix, "
                 " P.birth_date, A.cdib, TT.item, P.social_security_number, GT.item gender, P.current_id, P.id person_id "
                 "from people P inner join person_names PN on P.person_names_id = PN.id "
                 " left join affiliations A on A.person_id = P.id "
                 " left join tribe_types TT on A.tribe_id = TT.id "
                 " left join gender_types GT on P.gender_id = GT.id "
                 "where P.id = " + rel_person_id;
    SqlToVecMap(dbDatabase, sql, person_vec);
    row_data["person_type"]     = "Existing";
    row_data["relationship"]    = cboRelRelationship->Text.c_str();
    row_data["prefix"]          = person_vec[0]["prefix"];
    row_data["first_name"]      = person_vec[0]["first_name"];
    row_data["middle_name"]     = person_vec[0]["middle_name"];
    row_data["last_name"]       = person_vec[0]["last_name"];
    row_data["suffix"]          = person_vec[0]["suffix"];
    row_data["ssn"]             = person_vec[0]["social_security_number"];
    row_data["dob"]             = person_vec[0]["birth_date"];
    row_data["gender"]          = person_vec[0]["gender"];
    row_data["is_emergency"]    = checkRelEmergencyContact->Checked ? "1" : "0";
    row_data["is_responsible"]  = checkRelResponsibleParty->Checked ? "1" : "0";
    row_data["is_banned"]       = checkRelBanned->Checked ? "1" : "0";
    row_data["id"]              = person_vec[0]["person_id"];
  }
  set<string> dupe_columns;
  dupe_columns.insert("id");
  dupe_columns.insert("first_name");
  dupe_columns.insert("middle_name");
  dupe_columns.insert("last_name");
  dupe_columns.insert("suffix");

  if (relationships_listview.is_future_duplicate (row_data, dupe_columns))
  {
    if (IDNO == PSay("This row seems likely to be a duplicate of a row already in the list.  Please make sure you are not entering the same person twice.\n\nDo you want to save it anyway?", m_duplicate_data, MB_YESNO))
    return;
  }

  relationships_listview.add_or_modify_row_data(row_data, false);

  //RefreshTotals();
  listRelationships->Selected = NULL;
  RecursiveClear(panelRelNewPerson);
  RecursiveClear(panelRelRelationship);
  //if (buttonSearchCaseEntity->Enabled && IsVisible(buttonSearchCaseEntity))
  // this->ActiveControl = buttonSearchCaseEntity;

  //TWinControl * wanted_box = FindNextControl(scrollProcedures, true, true, false);
  //if (wanted_box && wanted_box->Enabled && IsVisible(wanted_box))
  //  wanted_box->SetFocus();
}
//---------------------------------------------------------------------------
void TformWizardIntakeNewPerson::AtlasNotification (int request_num, string matched_value)
{
  if (request_num == request_rel_person_id)
    RefreshRelPersonId();
  else if (request_num == request_policy_id)
    RefreshPolicyId();
  /*
  // ... now the ones about -just- a listview
  if (request_num == request_cobs_person_id)
  {
    list_cobs.RefreshDataSet();
  } else
  */
}
//---------------------------------------------------------------------------
void TformWizardIntakeNewPerson::RelationshipSelected()
{
  map<string, string> row_data;
  if (!relationships_listview.get_current_row(row_data))
  {
   // set default values
    row_data["relationship"]    = "";
    row_data["prefix"]          = "";
    row_data["first_name"]      = "";
    row_data["middle_name"]     = "";
    row_data["last_name"]       = "";
    row_data["suffix"]          = "";
    row_data["ssn"]             = "";
    row_data["dob"]             = "";
    row_data["gender"]          = "";
    row_data["is_emergency"]    = "0";
    row_data["is_responsible"]  = "0";
    row_data["is_banned"]       = "0";
    row_data["id"]              = "";
  }
  // update controls to reflect data in row_data
  if(row_data["person_type"] != "New")
  {
    RecursiveClear(panelRelNewPerson);
    rel_person_id = row_data["person_id"];
    RefreshRelPersonId();
  }
  else
  {
    cboRelRelationship->Text    = row_data["relationship"].c_str();
    editRelPrefix->Text         = row_data["prefix"].c_str();
    editRelFirstName->Text      = row_data["first_name"].c_str();
    editRelMiddleName->Text     = row_data["middle_name"].c_str();
    editRelLastName->Text       = row_data["last_name"].c_str();
    editRelSuffix->Text         = row_data["suffix"].c_str();
    editRelSSN->Text            = row_data["ssn"].c_str();
    editRelDOB->Text            = row_data["dob"].c_str();
    cboRelGender->Text          = row_data["gender"].c_str();
    checkRelEmergencyContact->Checked = row_data["is_emergency"] == "1";
    checkRelResponsibleParty->Checked = row_data["is_responsible"] == "1";
    checkRelBanned->Checked     = row_data["is_banned"] == "1";
  }
  if (btnRelExistingPersonSearch->Enabled && IsVisible(btnRelExistingPersonSearch))
    this->ActiveControl = btnRelExistingPersonSearch;
}
//---------------------------------------------------------------------------
void TformWizardIntakeNewPerson::RefreshRelPersonId ()
{
  if (rel_person_id == "" || !IsInt(rel_person_id))
    rel_person_id = "0";

  atlas->CancelRequest(request_rel_person_id);
  request_rel_person_id = atlas->RequestNotificationWhen("people.id", rel_person_id, rel_e, as_int, this, RefreshHandler(&(TformWizardIntakeNewPerson::AtlasNotification)));

  CreateLink(txtRelExistingPerson, btnRelExistingPersonSearch, this, rel_person_id, "people", "", true, first_middle_last);
}
//---------------------------------------------------------------------------
void __fastcall TformWizardIntakeNewPerson::buttonRelationsAddClick(TObject *Sender)
{
  listRelationships->Selected = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardIntakeNewPerson::buttonRelationsRemoveClick(TObject *Sender)
{
  relationships_listview.remove_current_row(true);
}
//---------------------------------------------------------------------------
void __fastcall TformWizardIntakeNewPerson::buttonRelationsClearClick(TObject *Sender)
{
  relationships_listview.clear_data();
}
//---------------------------------------------------------------------------
void TformWizardIntakeNewPerson::RefreshPolicyId ()
{
  if (policy_id == "" || !IsInt(policy_id))
    policy_id = "0";

  atlas->CancelRequest(request_policy_id);
  request_policy_id = atlas->RequestNotificationWhen("insurance_policies.id", policy_id, rel_e, as_int, this, RefreshHandler(&(TformWizardIntakeNewPerson::AtlasNotification)));

  CreateLink(txtPolicy, btnPolicySearch, this, policy_id, "insurance_policies");
}
//---------------------------------------------------------------------------
void TformWizardIntakeNewPerson::InsuranceSelected()
{
  map<string, string> row_data;
  if (!insurance_listview.get_current_row(row_data))
  {
   // set default values
   row_data[""] = "";
  }
  // update controls to reflect data in row_data
  policy_id = row_data["policy_id"];

  RefreshPolicyId();
  if (btnPolicySearch->Enabled && IsVisible(btnPolicySearch))
    this->ActiveControl = btnPolicySearch;
}
//---------------------------------------------------------------------------
void TformWizardIntakeNewPerson::AffiliationSelected()
{
  map<string, string> row_data;
  if (!affiliations_listview.get_current_row(row_data))
  {
   // set default values
   row_data[""] = "";
  }
  // update controls to reflect data in row_data
  affiliation_id = row_data["id"];

/* no search button
  RefreshPolicyId();
  if (btnPolicySearch->Enabled && IsVisible(btnPolicySearch))
    this->ActiveControl = btnPolicySearch;
*/
}
//---------------------------------------------------------------------------
void TformWizardIntakeNewPerson::AddressSelected()
{
  map<string, string> row_data;
  if (!insurance_listview.get_current_row(row_data))
  {
   // set default values
   row_data[""] = "";
  }
  // update controls to reflect data in row_data
  address_id = row_data["id"];

/* no search button
  RefreshPolicyId();
  if (btnPolicySearch->Enabled && IsVisible(btnPolicySearch))
    this->ActiveControl = btnPolicySearch;
*/
}
//---------------------------------------------------------------------------

