//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeWizardModifyTransactions.h"
#include "codeRecordIncomingBill.h"
#include "codeRecordOutgoingBill.h"
#include "codeRecordTaskCob.h"
#include "codeRecordTaskLac.h"
#include "codeRecordTaskDen.h"
#include "codePrometheus.h" // (for DefaultAction)
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeWizardGeneric"
#pragma resource "*.dfm"
TformWizardModifyTransactions *formWizardModifyTransactions;
//---------------------------------------------------------------------------
__fastcall TformWizardModifyTransactions::TformWizardModifyTransactions(TComponent* Owner, string p_id, modifiable_item_types p_type)
        : TformWizardGeneric(Owner)
{
 // TODO: reminder -- go looking for all the "TODO -- effective date" notes ... or however it is i put those in ...

 bool is_valid_id = true;
 bool is_correct_id = true;

 given_id = p_id;
 given_type = p_type;

 string sql_verify_object_exists;

 allowed_billing_groups.clear();
 allowed_billing_groups.push_back(lookupTables->IdOf("groups", "Dental Clinic"));
 allowed_billing_groups.push_back(lookupTables->IdOf("groups", "Little Axe Clinic"));

 if (!IsInt (p_id) || p_id.empty())
  is_valid_id = false;

 switch (p_type)
 {
  case mod_cob:
   sql_verify_object_exists = "select id from tasks where tasks.person_id != 0 and tasks.services_provided_id > 0 and tasks.parent_task_id = 0 and tasks.id = " + p_id;
   given_table = "tasks";
   break;
  case mod_visit:
   sql_verify_object_exists = "select id from tasks where tasks.person_id != 0 and tasks.group_id in (" + VecToCommaString(allowed_billing_groups) + ") and tasks.id = " + p_id;
   given_table = "tasks";
   break;
  case mod_in_bill:
   sql_verify_object_exists = "select id from bills where bills.bill_id = " + lookupTables->IdOf("bill_types", "Incoming Vendor Bill") + " or bills.id = " + lookupTables->IdOf("bill_types", "Incoming Provider Bill") + " and bills.id = " + p_id;
   given_table = "bills";
   break;
  case mod_out_bill:
   sql_verify_object_exists = "select id from bills where bills.bill_id = " + lookupTables->IdOf("bill_types", "Outgoing Provider Bill") + " and bills.id = " + p_id;
   given_table = "bills";
   break;
  case mod_purchase_req:
   sql_verify_object_exists = "select id from purchase_reqs where purchase_reqs.id = " + p_id;
   given_table = "purchase_reqs";
   break;
  case mod_check:
   sql_verify_object_exists = "select id from checks where checks.id = " + p_id;
   given_table = "checks";
   break;
 }

 if (sql_verify_object_exists.empty() || GetOneField(dbDatabase, sql_verify_object_exists).empty())
  is_correct_id = false;

 in_bill_filter.SetListViewHandle(listIncomingBills);
 in_bill_filter.SetSecurity("bills.incoming");
 in_bill_filter.AddColumnSpec("Person", "people", as_text, true, 120);
 in_bill_filter.AddColumnSpec("Date", "bills", as_date, true, 75);
 in_bill_filter.AddColumnSpec("Primary Tax Entity", "insurance_coverage", as_text, true, 75);
 in_bill_filter.AddColumnSpec("Provider", "tax_entities", as_text, true, 75, rawString);
 in_bill_filter.AddColumnSpec("Facility", "tax_entities", as_text, true, 75, rawString);
 in_bill_filter.AddColumnSpec("Group", "tax_entities", as_text, true, 75, rawString);
 in_bill_filter.AddColumnSpec("Insurance", "tax_entities", as_text, true, 75, prettyString);
 in_bill_filter.AddColumnSpec("Invoice Number", "bills", as_text, true, 75, prettyString);
 in_bill_filter.AddColumnSpec("PR Number", "purchase_reqs", as_int, true, 75);
 in_bill_filter.AddColumnSpec("Check Number", "checks", as_int, true, 75);
 in_bill_filter.AddColumnSpec("Invoice Amount", "bills", as_double, true, 75, amountString);
 in_bill_filter.AddColumnSpec("Type", "bills", as_text, true, 75, prettyString);
 in_bill_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 in_bill_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 in_bill_filter.SetAddEdit(this, NULL, EditRecord(&(TformWizardModifyTransactions::ZoomIncomingBill)));
 in_bill_filter.FetchPreferences("wizardmodifytransactions.in_bill_filter");
 in_bill_filter.SetSQLStatement("");
 in_bill_filter.RefreshDataSet();

 out_bill_filter.SetListViewHandle(listOutgoingBills);
 out_bill_filter.SetSecurity("bills.outgoing");
 out_bill_filter.AddColumnSpec("Person", "people", as_text, true, 120, prettyString);
 out_bill_filter.AddColumnSpec("Date", "bills", as_date, true, 75);
 out_bill_filter.AddColumnSpec("Primary Tax Entity", "insurance_coverage", as_text, true, 120, prettyString);
 out_bill_filter.AddColumnSpec("Provider", "tax_entities", as_text, true, 80, rawString);
 out_bill_filter.AddColumnSpec("Facility", "tax_entities", as_text, true, 80, rawString);
 out_bill_filter.AddColumnSpec("Group", "tax_entities", as_text, true, 80, rawString);
 out_bill_filter.AddColumnSpec("Insurance", "tax_entities", as_text, true, 80, prettyString);
 out_bill_filter.AddColumnSpec("Invoice Number", "bills", as_text, true, 75);
 out_bill_filter.AddColumnSpec("PR Number", "purchase_reqs", as_int, true, 75);
 out_bill_filter.AddColumnSpec("Check Number", "checks", as_int, true, 75);
 out_bill_filter.AddColumnSpec("Invoice Amount", "bills", as_double, true, 75, amountString);
 out_bill_filter.AddColumnSpec("Type", "bills", as_text, true, 75, prettyString);
 out_bill_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 out_bill_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 out_bill_filter.SetAddEdit(this, NULL, EditRecord(&(TformWizardModifyTransactions::ZoomOutgoingBill)));
 out_bill_filter.FetchPreferences("wizardmodifytransactions.out_bill_filter");
 out_bill_filter.SetSQLStatement("");
 out_bill_filter.RefreshDataSet();

 cob_filter.SetListViewHandle(listCOBs);
 cob_filter.SetSecurity("tasks.cob");
 cob_filter.AddColumnSpec("Person", "people", as_text, true, 120, prettyString);
 cob_filter.AddColumnSpec("Date", "tasks", as_date, true, 75);
 cob_filter.AddColumnSpec("Appt. Date", "appointments", as_date, true, 75);
 cob_filter.AddColumnSpec("Time", "tasks", as_time, true, 75);
 cob_filter.AddColumnSpec("COB Number", "tasks", as_int, true, 75);
 cob_filter.AddColumnSpec("Service", "services_provided", as_text, true, 120, prettyString);
 cob_filter.AddColumnSpec("Reason", "tasks", as_text, true, 80, rawString);
 cob_filter.AddColumnSpec("Limits", "tasks", as_text, true, 80, rawString);
 cob_filter.AddColumnSpec("Preconditions", "tasks", as_text, false, 80, sentenceString);
 cob_filter.AddColumnSpec("Follow up", "tasks", as_text, false, 80, sentenceString);
 cob_filter.AddColumnSpec("Reported by", "tasks", as_text, false, 80, sentenceString);
 cob_filter.AddColumnSpec("Hospitalized", "tasks", as_text, false, 75, prettyBoolString);
 cob_filter.AddColumnSpec("Given Room", "tasks", as_text, false, 75, prettyBoolString);
 cob_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 cob_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 cob_filter.SetAddEdit(this, NULL, EditRecord(&(TformWizardModifyTransactions::ZoomCob)));
 cob_filter.FetchPreferences("wizardmodifytransactions.cob_filter");
 cob_filter.SetSQLStatement("");
 cob_filter.RefreshDataSet();

 visit_filter.SetListViewHandle(listVisits);
 visit_filter.SetSecurity("tasks");
 visit_filter.AddColumnSpec("Person", "people", as_text, true, 120, prettyString);
 visit_filter.AddColumnSpec("Provider", "tax_entities", as_date, true, 120, rawString);
 visit_filter.AddColumnSpec("Date", "tasks", as_date, true, 75);
 visit_filter.AddColumnSpec("Appt. Date", "appointments", as_date, true, 75);
 visit_filter.AddColumnSpec("Time", "tasks", as_time, true, 75);
 visit_filter.AddColumnSpec("Reason", "tasks", as_text, true, 80, sentenceString);
 visit_filter.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 visit_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 visit_filter.SetAddEdit(this, NULL, EditRecord(&(TformWizardModifyTransactions::ZoomVisit)));
 visit_filter.FetchPreferences("wizardmodifytransactions.visit_filter");
 visit_filter.SetSQLStatement("");
 visit_filter.RefreshDataSet();

 edit_after.setup_listview(listAfter, false);

 // needs to handle task_id, bill_id, purchase_req_id, or check_id ... and check permissions a -lot-!
 // should allow modification of tasks and bills (unless bill is on a purchase request -- permissions) ... and of
 // any bills on a purchase request, if ... permissions. and all bills on a check. more permissions. you get the idea.

 // also, when modifying stuff, it'd be nice to put in blank (amounts all == 0.00) rows for every account/entity
 // that is known to have been used in the past, even though we may not be able to guess the original amounts.
 // that way, makes it easier to go back and just say "yeah, that one, do stuff to it" ... rather than re-entering
 // (which involves searching) each account/tax_entity you feel the need to change. or something.

 if (is_valid_id && is_correct_id)
 {
  // SetExpectedPages(2);
  Initialize();
 } else
 {
  // SetExpectedPages(1);
  Initialize();
  buttonNext->Enabled = false;
 }
}
//---------------------------------------------------------------------------
bool TformWizardModifyTransactions::IsValidPage (int page_index)
{
 switch (page_index)
 {
  case 0:
  {
   if (radioModChildIncomingBill->Checked)
   {
    result_id = in_bill_filter.GetSelectedRecordID();
    result_type = mod_in_bill;
    result_table = "bills";
    if (result_id == "")
    {
     PSay ("You must select the incoming bill you wish to modify.", m_missing_data, MB_OK);
     return false;
    }
   } else
   if (radioModChildOutgoingBill->Checked)
   {
    result_id = out_bill_filter.GetSelectedRecordID();
    result_type = mod_out_bill;
    result_table = "bills";
    if (result_id == "")
    {
     PSay ("You must select the outgoing bill you wish to modify.", m_missing_data, MB_OK);
     return false;
    }
   } else
   if (radioModChildCob->Checked)
   {
    result_id = cob_filter.GetSelectedRecordID();
    result_type = mod_cob;
    result_table = "tasks";
    if (result_id == "")
    {
     PSay ("You must select the coordination of benefits you wish to modify.", m_missing_data, MB_OK);
     return false;
    }
   } else
   if (radioModChildVisit->Checked)
   {
    result_id = visit_filter.GetSelectedRecordID();
    result_type = mod_visit;
    result_table = "tasks";
    if (result_id == "")
    {
     PSay ("You must select the visit you wish to modify.", m_missing_data, MB_OK);
     return false;
    }
   } else
   {
    result_id = given_id;
    result_type = given_type;
    result_table = given_table;
    if (result_id == "")
    {
     PSay ("Somehow, no item has been selected at all. Please notify a programmer.", m_missing_data, MB_OK);
     return false;
    }
   }

   // TODO: might warn them if some things will be refused later (expenses on a bill already on a PR, for instance)

   return true;
  }
  case 1:
  {
   /* TODO: if we do wind up verifying cases that shouldn't be allowed (bill on pr),
      then this page will be asking for confirmation, checking permissions, etc. ... */

   if (after_changes.GetCountEntitiesOut() > 1)
   {
    PSay("You are not currently allowed to pay multiple entities at the same time.\nThis includes any entity for which moneys have been expensed, are payable, or cash has been paid.", m_invalid_data, MB_OK);
    return false;
   }

   return true;
  }
  default:
   PSay("IsValidPage() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return false;
 }
}
//---------------------------------------------------------------------------
int TformWizardModifyTransactions::WhereNext (int page_index)
{
 if (page_index == 1)
  return TformWizardGeneric::last_wizard_page;
 else
  return (page_index + 1);
}
//---------------------------------------------------------------------------
bool TformWizardModifyTransactions::ProcessPage (int page_index)
{
 switch (page_index)
 {
  case 0:
  {
   // if we passed the IsValid thing, result_id, result_type, result_table should be set.
   string get_old_transactions;
   string get_std_tax_entity_id;

   if (result_table == "bills")
   {
    get_old_transactions  = "select * from transactions where transactions.bill_id = " + result_id;
    get_std_tax_entity_id = "select actual_tax_id from bills where bills.id = " + result_id;
   } else
   if (result_type == mod_cob)
   {
    get_old_transactions = "select * from transactions where transactions.task_id = " + result_id;
    get_std_tax_entity_id = "select services_provided.tax_entity_id from services_provided inner join tasks on tasks.services_provided_id = services_provided.id where tasks.id = " + result_id;
   } else
   if (result_type == mod_visit)
   {
    get_old_transactions = "select * from transactions where transactions.task_id = " + result_id;
    get_std_tax_entity_id = "select tasks.tax_entity_id from tasks where tasks.id = " + result_id;
   } else
    return true; // not sure what i meant to do here?

   vector<map<string, string> > old_transactions;
   if (!SqlToVecMap(dbDatabase, get_old_transactions, old_transactions))
    if (IDNO == PSay ("Failed to retrieve old transactions for this item. You will not be shown the effects of your changes!\nWould you like to continue anyway?", m_database_error, MB_YESNO))
     return false; // i was returning? that's a bit weird. at least now i can cancel changing pages.


   std_tax_entity_id = GetOneField(dbDatabase, get_std_tax_entity_id);
   before_changes.RawInput(old_transactions);

   return true;
  }
  case 1:
  {
   return true;
  }
  default:
   PSay("ProcessPage() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return false;
 }
}
//---------------------------------------------------------------------------
void TformWizardModifyTransactions::SetupPage (int page_index)
{
 switch (page_index)
 {
  case 0:
  {
   radioModSelf->Enabled              = false;
   radioModChildIncomingBill->Enabled = false;
   radioModChildOutgoingBill->Enabled = false;
   radioModChildCob->Enabled          = false;
   radioModChildVisit->Enabled        = false;

   string std_bill_sql;
   string in_bill_sql;
   string std_in_bill_sql;
   string out_bill_sql;
   string std_out_bill_sql;
   string cob_sql;
   string std_cob_sql;
   string visit_sql;
   string std_visit_sql;

   std_bill_sql = "select person_names.last_name || ', ' || person_names.first_name, "
                  "bills.bill_date, actual_entity.name, provider_entity.name, "
                  "facility_entity.name, group_entity.name, insurance_entity.name, "
                  "bills.invoice_number, purchase_reqs.purchase_req_number, "
                  "checks.check_number, bills.invoice_amount, bill_types.item, "
                  "bills.current_id, bills.id "
                  "from bills inner join tasks on bills.task_id = tasks.id "
                  "inner join people on tasks.person_id = people.id "
                  "inner join person_names on person_names.id = people.person_names_id "
                  "inner join insurance_coverage on bills.insurance_coverage_id = insurance_coverage.id "
                  "inner join tax_entities insurance_entity on insurance_coverage.tax_entity_id = insurance_entity.id "
                  "inner join tax_entities actual_entity on bills.actual_tax_id = actual_entity.id "
                  "inner join tax_entities provider_entity on bills.provider_tax_id = provider_entity.id "
                  "inner join tax_entities facility_entity on bills.facility_tax_id = facility_entity.id "
                  "inner join tax_entities group_entity on bills.group_tax_id = group_entity.id "
                  "inner join purchase_reqs on bills.purchase_req_id = purchase_reqs.id "
                  "inner join checks on purchase_reqs.check_id = checks.id "
                  "inner join bill_types on bills.bill_id = bill_types.id ";

   std_in_bill_sql = std_bill_sql + "and bill_types.id in (" + lookupTables->IdOf("bill_types", "Incoming Vendor Bill") + ", " + lookupTables->IdOf("bill_types", "Incoming Provider Bill") + ") ";

   std_out_bill_sql = std_bill_sql + "and bill_types.id in (" + lookupTables->IdOf("bill_types", "Outgoing Provider Bill") + ") ";

   // NOTE USES VIEW
   std_cob_sql = "select person_names.last_name || ', ' || person_names.first_name, "
                 "tasks.date_of_task, appointments.begin_date, appointments.appointment_time, "
                 "tasks.cob_number, service_types.item, tasks.task_comments, tasks.visit_comments, "
                 "tasks.preconditions_note, tasks.followup_note, tasks.reported_by_note, "
                 "tasks.hospitalized, tasks.given_room, tasks.current_id, tasks.id "
                 "from cob_tasks tasks "
                 "inner join people on tasks.person_id = people.id "
                 "inner join person_names on person_names.id = people.person_names_id "
                 "inner join services_provided on tasks.services_provided_id = services_provided.id "
                 "inner join service_types on services_provided.service_id = service_types.id "
                 "left join appointments on appointments.id = (select max(appointments.id) from appointments where appointments.task_id = tasks.id) ";

   std_visit_sql = "select person_names.last_name || ', ' || person_names.first_name, "
                   "tax_entities.name, "
                   "tasks.date_of_task, appointments.begin_date, appointments.appointment_time, "
                   "tasks.task_comments, tasks.current_id, tasks.id "
                   "from tasks "
                   "inner join tax_entities on tasks.tax_entity_id = tax_entities.id "
                   "inner join people on tasks.person_id = people.id "
                   "inner join person_names on person_names.id = people.person_names_id "
                   "left join appointments on appointments.id = (select max(appointments.id) from appointments where appointments.task_id = tasks.id) ";

   CreateLink(staticModSelf, NULL, this, given_id, given_table);

   // hack -- this sub-select could be run from within each statement (and was running this way,)
   // but it seems FB 1.0 has a problem with sub-selects not using indeces if ...
   // well, basically if it doesn't feel like it. you can sometimes help (as i tried to)
   // by using a fake relational operator (self-evident, doesn't change the result)
   // alongside the sub-select. didn't seem to help. this seems to run a -little- faster.

   vector<string> found_sub_select_id;

   switch (given_type)
   {
    case mod_cob:
    {
     radioModSelf->Enabled = true;
     radioModChildIncomingBill->Enabled = true;
     in_bill_sql = std_in_bill_sql + "where tasks.parent_task_id = " + given_id;
     break;
    }
    case mod_visit:
    {
     radioModSelf->Enabled = true;
     radioModChildOutgoingBill->Enabled = true;
     out_bill_sql = std_out_bill_sql + "where bills.task_id = " + given_id;
     break;
    }
    case mod_in_bill:
    {
     radioModSelf->Enabled = true;
     radioModChildCob->Enabled = true;
     SqlToVec(dbDatabase, "select tasks.parent_task_id from tasks inner join bills on tasks.id = bills.task_id where bills.id = " + given_id + " and parent_task_id != 0", found_sub_select_id);
     if (!found_sub_select_id.empty())
      if (found_sub_select_id[0] != "")
       cob_sql = std_cob_sql + "where tasks.id in (" + VecToCommaString(found_sub_select_id) + ") ";
     break;
    }
    case mod_out_bill:
    {
     radioModSelf->Enabled = true;
     radioModChildVisit->Enabled = true;
     visit_sql = std_visit_sql + "where tasks.id = " + GetOneField(dbDatabase, "select bills.task_id from bills where id = " + given_id);
     break;
    }
    case mod_purchase_req:
    {
     radioModChildIncomingBill->Enabled = true;
     radioModChildCob->Enabled = true;
     in_bill_sql = std_bill_sql + "where bills.purchase_req_id = " + given_id;
     SqlToVec(dbDatabase, "select tasks.parent_task_id from tasks inner join bills on bills.task_id = tasks.id where bills.purchase_req_id = " + given_id + " and parent_task_id != 0", found_sub_select_id);
     if (!found_sub_select_id.empty())
      if (found_sub_select_id[0] != "")
       cob_sql = std_cob_sql + "where tasks.id in (" +  VecToCommaString(found_sub_select_id) + ") ";
     break;
    }
    case mod_check:
    {
     radioModChildIncomingBill->Enabled = true;
     radioModChildCob->Enabled = true;
     in_bill_sql = std_bill_sql + "where purchase_reqs.check_id = " + given_id;
     SqlToVec(dbDatabase, "select tasks.parent_task_id from tasks inner join bills on bills.task_id = tasks.id inner join purchase_reqs on bills.purchase_req_id = purchase_reqs.id where purchase_reqs.check_id = " + given_id + " and parent_task_id != 0", found_sub_select_id);
     if (!found_sub_select_id.empty())
      if (found_sub_select_id[0] != "")
       cob_sql = std_cob_sql + "where tasks.id in (" + VecToCommaString(found_sub_select_id) + ") ";
     break;
    }
   }

   if (radioModSelf->Enabled)
    radioModSelf->Checked = true;
   else if (radioModChildIncomingBill->Enabled)
    radioModChildIncomingBill->Checked = true;
   else if (radioModChildOutgoingBill->Enabled)
    radioModChildOutgoingBill->Checked = true;
   else if (radioModChildCob->Enabled)
    radioModChildCob->Checked = true;
   else if (radioModChildVisit->Enabled)
    radioModChildVisit->Checked = true;
   else
    return;

   in_bill_filter.SetSQLStatement(in_bill_sql);
   in_bill_filter.RefreshDataSet();
   out_bill_filter.SetSQLStatement(out_bill_sql);
   out_bill_filter.RefreshDataSet();
   cob_filter.SetSQLStatement(cob_sql);
   cob_filter.RefreshDataSet();
   visit_filter.SetSQLStatement(visit_sql);
   visit_filter.RefreshDataSet();

   break;
  }
  case 1:
  {
   editTransactionNote->Text = "";
   after_changes = before_changes;
   checkAfterClick(NULL);
   // TODO: second page needs stuff on it, like confirmation if they're doing something stupid

   // on bills:
   //  -> on incoming vendor bill, incoming provider bill
   //      -> if they've -changed- expenses at all (up or down)
   //          -> if it's not on a check yet, reprint and resend!
   //          -> if it -is- on a check, finance had better already know about it!
   //      -> if they've increased receivable for anyone
   //          -> that person should be informed!
   //      -> if they've -changed- payable at all
   //          -> ask if maybe this would have been better done through pr/checks?
   //  -> on outgoing provider bill
   //      -> if they've -changed- revenue at all ...
   //          -> wtf? now what? no!
   //      -> if they leave any amount still receivable, but less ...
   //          -> remind them they should be billing another insurance company, etc.
   //             (really, they shouldn't have used this screen ... they need to re-obligate on the visit too!)

   // (note) they really shouldn't be allowed to put, on a single outgoing provider bill, multiple tax_entities as owing us money
   // (note) when lax bills, it should go like this:
   // (note) they should wait to receive payment/rejection from each payor, before billing the next-in-line!
   //        . they want $100 for the service
   //          . add $100 in revenue on visit
   //          . add $100 in receivable on visit
   //        . they bill insurance A for $100
   //          . create a bill for A
   //          . add $100 in revenue on bill A
   //          . add $100 in receivable on bill A
   //          . sub $100 in revenue on visit
   //          . sub $100 in receivable on visit
   //        . they get $46 from A, considered full payment from A
   //          . sub $100 in revenue on bill A
   //          . sub $100 in receivable on bill A
   //          . add $46 in revenue on bill A
   //          . add $46 in cash on bill A
   //          . add $54 in revenue on visit
   //          . add $54 in receivable on visit
   //        . they bill insurance B for $54
   //          . create a bill for B
   //          . add $54 in revenue on bill B
   //          . add $54 in receivable on bill B
   //          . sub $54 in revenue on visit
   //          . sub %54 in receivable on visit
   //        [...]
   //        . there remains after all insurance is exhausted, $22 in revenue/receivable on the visit
   //          . ask if the client should be forgiven of the remaining charges

   // on tasks:
   //  -> on cobs:
   //      -> if the result of the change is that there's still payable on the cob,
   //          -> if there are some visits, and all have bills ...
   //              -> warn that it may never de-obligate!
   //  -> on visits at little axe / dental / other billing center?
   //      -> if little axe means to charge more
   //          -> shouldn't they create a new bill item, and put the amount being billed on there? (outgoing provider bill)
   //      -> if they mean to receive less ...
   //          -> shouldn't they be paying people back?

   // map<string, string> default_row;
   // vector<map<string, string> > tx_new = params.GetNewFinalTransactions(default_row);
   // vector<map<string, string> > tx_all = params.GetAllFinalTransactions(default_row);
   // vector<map<string, string> >::iterator i_tx;

   // rules go here!
   // TODO : TODO TODO and in case it's not obvious, TODO!!!
   switch (result_type)
   {
    case mod_in_bill:
     break;
    case mod_out_bill:
     break;
    case mod_cob:
     break;
    case mod_visit:
     break;
   }

   break;
  }
  default:
   PSay("SetupPage() is trying to access a page that does not exist.", m_program_error, MB_OK);
   break;
 }
}
//---------------------------------------------------------------------------
void TformWizardModifyTransactions::ZoomIncomingBill ()
{
  map<string,string> temp_map;
  temp_map["id"] = in_bill_filter.GetSelectedRecordID();
  FORM_TRY
   TformRecordIncomingBill * rec = new TformRecordIncomingBill(NULL, temp_map);
   rec->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformWizardModifyTransactions::ZoomOutgoingBill ()
{
  map<string,string> temp_map;
  temp_map["id"] = out_bill_filter.GetSelectedRecordID();
  FORM_TRY
   TformRecordOutgoingBill * rec = new TformRecordOutgoingBill(NULL, temp_map);
   rec->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformWizardModifyTransactions::ZoomCob ()
{
  map<string,string> temp_map;
  temp_map["id"] = cob_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordTaskCob * rec = new TformRecordTaskCob(NULL, temp_map);
    rec->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformWizardModifyTransactions::radioModAnyClick(TObject *Sender)
{
 pageSelection->ActivePageIndex = ((TRadioButton*)Sender)->Tag;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardModifyTransactions::checkAfterClick(TObject *Sender)
{
 vector<map<string, string> > current_data = after_changes.GetPreviewOutput(true);
 RefreshTransactionSummaryView (edit_after, checkAfterShowAccount->Checked, checkAfterShowName->Checked, current_data);
}
//---------------------------------------------------------------------------
void __fastcall TformWizardModifyTransactions::buttonChangeClick(TObject *Sender)
{
 FORM_TRY
  TformSpecialTransactionEntry * query = new TformSpecialTransactionEntry(NULL, before_changes, &after_changes, std_tax_entity_id, 0.00, true);
  query->ShowTaskModal(this);
  vector<map<string, string> > current_data = after_changes.GetPreviewOutput(true);
  RefreshTransactionSummaryView (edit_after, checkAfterShowAccount->Checked, checkAfterShowName->Checked, current_data);
 FORM_CATCH
}
//---------------------------------------------------------------------------
void TformWizardModifyTransactions::PageLockStatus (int page_index, bool locked)
{
 switch (page_index)
 {
  case 0:
   panelActionSelection->Enabled = !locked;
   return;
  case 1:
   buttonChange->Enabled = !locked;
   editTransactionNote->Enabled = !locked;
   return;
  default:
   PSay("PageLockStatus() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardModifyTransactions::listIncomingBillsChanging(
      TObject *Sender, TListItem *Item, TItemChange Change, bool &AllowChange)
{
 AllowChange = !WizardLocked();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardModifyTransactions::listOutgoingBillsChanging(
      TObject *Sender, TListItem *Item, TItemChange Change, bool &AllowChange)
{
 AllowChange = !WizardLocked();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardModifyTransactions::listCOBsChanging(
      TObject *Sender, TListItem *Item, TItemChange Change, bool &AllowChange)
{
 AllowChange = !WizardLocked();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardModifyTransactions::listVisitsChanging(
      TObject *Sender, TListItem *Item, TItemChange Change, bool &AllowChange)
{
 AllowChange = !WizardLocked();
}
//---------------------------------------------------------------------------
bool TformWizardModifyTransactions::FinishWizard ()
{
 set<string> account_ids;
 set<string> entity_ids;

 // save transactions on the item ... yay!
 AtlasClear();
 TIBTransaction * dbTransaction = new TIBTransaction(NULL);
 StdTransaction(dbTransaction, dbDatabase);
 map<string, string> default_row;
 try
 {
  string date_to_use;
  map<string, string> parent_item_data; // to send over atlas, for refreshing stuff!

  if (!SqlToMap(dbTransaction, "select * from " + result_table + " where id = " + result_id, parent_item_data))
   throw(3);

  AtlasAdd(result_table, parent_item_data);

  if (result_table == "tasks")
   date_to_use = GetOneField(dbTransaction, "select first 1 begin_date from appointments where appointments.task_id = " + result_id + " order by current_id desc");
  else
   date_to_use = parent_item_data["bill_date"];

  // last resort?
  if (date_to_use.empty())
   date_to_use = Pdate(TDateTime::CurrentDate()).OutDate(global_mode);

  default_row["current_id"]         = "4";
  default_row["last_update_stamp"]  = RightNow();
  default_row["last_updated_by"]    = current_userid;
  default_row["task_id"]            = (result_table == "tasks") ? result_id : string("0");
  default_row["bill_id"]            = (result_table == "bills") ? result_id : string("0");
  default_row["effective_date"]     = date_to_use; // TODO: what effective date?
  default_row["note"]               = (editTransactionNote->Text == "") ? "Modification entries for accounting item (cob or bill)" : editTransactionNote->Text.c_str(); // TODO: better notes
  default_row["transaction_number"] = GetNextId(dbTransaction, "transact_number");

  vector<map<string, string> > tx = (after_changes - before_changes).GetFinalOutput(default_row);
  vector<map<string, string> >::iterator i_tx;

  // setup id
  for (i_tx = tx.begin(); i_tx != tx.end(); i_tx++)
  {
   account_ids.insert((*i_tx)["account_id"]);
   entity_ids.insert((*i_tx)["tax_entity_id"]);
   (*i_tx)["id"] = GetNextId(dbTransaction, "transactions");
   if (!ExecuteInsertStatement(dbTransaction, "transactions", (*i_tx)))
    throw(4);
   AtlasAdd("transactions", (*i_tx));
  }

  dbTransaction->Commit();
  delete dbTransaction;
  AtlasSend();
  return true;
 }
 catch (...)
 {
  string t;
  if (!IsBlankOrZero(default_row["task_id"]))
   if (!LockRecordForUpdate(dbTransaction, "tasks", default_row["task_id"]))
    t += "A related COB, task, or visit was being updated at the same time.\n";
  if (!IsBlankOrZero(default_row["bill_id"]))
   if (!LockRecordForUpdate(dbTransaction, "bills", default_row["bill_id"]))
    t += "A related bill was being updated at the same time.\n";
  for(set<string>::iterator i = account_ids.begin(); i != account_ids.end(); i++)
   if (!LockRecordForUpdate(dbTransaction, "accounts", *i))
   {
    t += "A related account was being updated at the same time.\n";
    break;
   }
  for(set<string>::iterator i = entity_ids.begin(); i != entity_ids.end(); i++)
   if (!LockRecordForUpdate(dbTransaction, "tax_entities", *i))
   {
    t += "A related tax entity was being updated at the same time.\n";
    break;
   }
  if (!t.empty())
  {
   t = "\n\n" + t;
   t += "\nIf you are updating related records, then leave this window open,\nsave or undo your work on those other screens,\nand come back and try [Finish] again when ready.\n\nIf another user is updating records, this might be slightly more difficult to work out.";
  }

  PSay("Unable to save transaction changes." + t, m_database_error, MB_OK);
  dbTransaction->Rollback();
  delete dbTransaction;
  AtlasClear();
  return false;
 }
}
//---------------------------------------------------------------------------
void TformWizardModifyTransactions::Do()
{
 ::PSay("WziardModifyTransactions may not be launched without parameters.", m_debug, MB_OK, "TformWizardModifyTransactions::static Do()");
}
//---------------------------------------------------------------------------
void TformWizardModifyTransactions::Do (string p_id, modifiable_item_types p_type)
{
 FORM_TRY
  TformWizardModifyTransactions * z = new TformWizardModifyTransactions(NULL, p_id, p_type);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void TformWizardModifyTransactions::ZoomVisit ()
{
  /*
  map<string,string> temp_map;
  temp_map["id"] = visit_filter.GetSelectedRecordID();
  // TODO: could be either TaskLac or TaskDen (or TaskDiab or TaskBeh?)
  FORM_TRY
    TformRecordTaskLac * rec = new TformRecordTaskLac(NULL, temp_map);
    rec->Show();
  FORM_CATCH
  */
  DefaultAction(visit_filter.GetSelectedRecordID(), "tasks");
}
//---------------------------------------------------------------------------
void __fastcall TformWizardModifyTransactions::FormClose(TObject *Sender, TCloseAction &Action)
{
  // wish to close, but we'll ask first, and if it's confirmed, go ahead and close controls
  Action = caFree;
  TformWizardGeneric::FormClose(Sender, Action);
  if (Action == caFree)
   edit_after.setup_listview(NULL, false);
}
//---------------------------------------------------------------------------

