//---------------------------------------------------------------------------

#ifndef codeWizardModifyTransactionsH
#define codeWizardModifyTransactionsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeWizardGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include "codeSpecialTransactionEntry.h"
#include <ImgList.hpp>

enum modifiable_item_types {mod_cob, mod_in_bill, mod_out_bill, mod_visit, mod_purchase_req, mod_check};

//---------------------------------------------------------------------------
class TformWizardModifyTransactions : public TformWizardGeneric
{
__published:	// IDE-managed Components
        TTabSheet *sheetA;
        TTabSheet *sheetConfirm;
        TGroupBox *groupSelection;
        TStaticText *staticModSelf;
        TGroupBox *groupSelectChild;
        TPageControl *pageSelection;
        TTabSheet *sheetSelf;
        TTabSheet *sheetIncomingBills;
        TListView *listIncomingBills;
        TTabSheet *sheetOutgoingBills;
        TListView *listOutgoingBills;
        TTabSheet *sheetCOBs;
        TTabSheet *sheetVisits;
        TListView *listCOBs;
        TListView *listVisits;
        TGroupBox *groupTransactions;
        TLabel *_labelSplitInformationBy;
        TListView *listAfter;
        TButton *buttonChange;
        TCheckBox *checkAfterShowAccount;
        TCheckBox *checkAfterShowName;
        TLabel *labelBetaWarning;
        TEdit *editTransactionNote;
        TLabel *_labelTransactionNote;
        TPanel *panelActionSelection;
        TRadioButton *radioModSelf;
        TRadioButton *radioModChildIncomingBill;
        TRadioButton *radioModChildOutgoingBill;
        TRadioButton *radioModChildCob;
        TRadioButton *radioModChildVisit;
        void __fastcall radioModAnyClick(TObject *Sender);
        void __fastcall checkAfterClick(TObject *Sender);
        void __fastcall buttonChangeClick(TObject *Sender);
        void __fastcall listIncomingBillsChanging(TObject *Sender,
          TListItem *Item, TItemChange Change, bool &AllowChange);
        void __fastcall listOutgoingBillsChanging(TObject *Sender,
          TListItem *Item, TItemChange Change, bool &AllowChange);
        void __fastcall listCOBsChanging(TObject *Sender, TListItem *Item,
          TItemChange Change, bool &AllowChange);
        void __fastcall listVisitsChanging(TObject *Sender,
          TListItem *Item, TItemChange Change, bool &AllowChange);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
        classFilterObject in_bill_filter;
        classFilterObject out_bill_filter;
        classFilterObject cob_filter;
        classFilterObject visit_filter;

        edit_listview edit_after;

        string given_id;
        modifiable_item_types given_type;
        string given_table;

        string result_id;
        modifiable_item_types result_type;
        string result_table;

        // TEST - reusable_accounting_insert_parameters params;
        transaction_summary before_changes;
        transaction_summary after_changes;
        string std_tax_entity_id;
        
        vector<string> allowed_billing_groups;

        void ZoomIncomingBill ();
        void ZoomOutgoingBill ();
        void ZoomCob ();
        void ZoomVisit ();
protected:
        bool IsValidPage (int page_index);           // true/false: this page is without errors
         int WhereNext   (int page_index);           // page_index of the next page to visit, based on current page number
        bool ProcessPage (int page_index);           // actually go from A to B, ... no reset, no messing with other stuff?
        void SetupPage   (int page_index);           // make this page ready to be shown based on other data
        bool FinishWizard ();                        // actually save data here, rather than in ProcessPage()
        void PageLockStatus (int page_index, bool locked);
public:		// User declarations
        __fastcall TformWizardModifyTransactions(TComponent* Owner, string p_id, modifiable_item_types p_type);
        static void Do();
        static void Do (string p_id, modifiable_item_types p_type);
};
//---------------------------------------------------------------------------
extern PACKAGE TformWizardModifyTransactions *formWizardModifyTransactions;
//---------------------------------------------------------------------------
#endif
