//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeWizardNewBudget.h"
#include "codeRecordAccount.h"
#include "codeSpecialNewBudgetMod.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeWizardGeneric"
#pragma resource "*.dfm"
TformWizardNewBudgetEntry *formWizardNewBudgetEntry;
//---------------------------------------------------------------------------
__fastcall TformWizardNewBudgetEntry::TformWizardNewBudgetEntry(TComponent* Owner)
        : TformWizardGeneric(Owner)
{
 // TODO: setup link to budget mod screen
 start_page = 0;
 // SetExpectedPages(2);
 budget_listview = new edit_listview();
 budget_listview->setup_listview(listAccountBudgets);
 budget_listview->add_or_modify_column("account_id", "Id", false, 0, 0, as_int, prettyString);
 //budget_listview->add_or_modify_column("account_name", "Account", true, 1, 130, as_text, prettyString); // fuck you no
 budget_listview->add_or_modify_column("fund", "Fund", true, 1, 75, as_text, prettyString);
 budget_listview->add_or_modify_column("line_item", "Line Item", true, 2, 100, as_text, prettyString);
 budget_listview->add_or_modify_column("department", "Dept.", true, 3, 75, as_text, prettyString);
 budget_listview->add_or_modify_column("subdepartment", "Sub-dept.", true, 4, 75, as_text, prettyString);
 budget_listview->add_or_modify_column("account_budget", "Budget", true, 5, 80, as_double, amountString);
 budget_listview->add_or_modify_column("action_type", "Action", true, 6, 55, as_text, prettyString);
 budget_listview->add_or_modify_column("action_date", "As of", true, 7, 70, as_date, prettyString);
 budget_listview->add_or_modify_column("action_amount", "Amount", true, 8, 80, as_double, amountString);
 budget_listview->add_or_modify_column("action_note", "Note", false, 8, 80, as_text, sentenceString);
 budget_listview->add_or_modify_column("account_cycle", "Cycle", false, 9, 60, as_int, prettyString);
 budget_listview->add_or_modify_column("account_equity_id", "Equity Id", false, 0, 0, as_int, prettyString);
 budget_listview->setup_callbacks((TForm*)this, InformForm(&(TformWizardNewBudgetEntry::accountselected)), InformForm(&(TformWizardNewBudgetEntry::accountzoomed)));
 lookupTables->RegisterComboBox("month_types", comboYearlyCycle);
 Initialize();
}
//---------------------------------------------------------------------------
bool TformWizardNewBudgetEntry::IsValidPage (int page_index)           // true/false: this page is without errors
{
 switch(page_index)
 {
  case 0:
   if (radioYearlyBudgets->Checked)
   {
    if (StringToInt(lookupTables->IdOf("month_types", comboYearlyCycle->Text.c_str())) > 0 && StringToInt(lookupTables->IdOf("month_types", comboYearlyCycle->Text.c_str())) < 13)
     return true;
    else
    {
     PSay("You must select one of the entries in the month drop-down before continuing.\nThis is done to make sure the default date on the transactions makes sense for all the budgets you're working on.", m_invalid_data, MB_OK);
     return false;
    }
   } else
   if (radioNonYearlyBudgets->Checked)
   {
    return true;
   } else
   {
    PSay("You must select either Yearly or Non-yearly budgets as your action before continuing.", m_missing_data, MB_OK);
    return false;
   }
   // break;
  case 1:
   {
    vector<map<string, string> > listview_data;
    budget_listview->export_data(listview_data);
    for (vector<map<string, string> >::iterator i_listview_row = listview_data.begin();
         i_listview_row != listview_data.end(); i_listview_row++)
    {
     if ((*i_listview_row)["action_type"] == "None")
     {
      financial temp_amount  = StringToFinancial((*i_listview_row)["account_budget"]);
      if (temp_amount < 0.00)
      {
       PSay(string("An account will be left with a negative budget.\nYou must do something to fix account " + (*i_listview_row)["account_name"] + " before continuing."), m_warning, MB_OK);
       return false;
      }
     }
    }
   }
   return true;
   // break;
  default:
   PSay("This page of the wizard cannot be validated as it is not recognized.", m_program_error, MB_OK);
   return false;
 }
}
//---------------------------------------------------------------------------
int TformWizardNewBudgetEntry::WhereNext   (int page_index)           // page_index of the next page to visit, based on current page number
{
 if (page_index == 1)
  return TformWizardGeneric::last_wizard_page;
 else
  return (page_index + 1);
}
//---------------------------------------------------------------------------
bool TformWizardNewBudgetEntry::ProcessPage (int page_index)           // actually go from A to B, ... no reset, no messing with other stuff?
{
 switch (page_index)
 {
  case 0:
   // nothing really needs to be done yet -- setuppage will take care of downloading into the listview
   return true;
  case 1:
  {
   return true;
  }
  default:
   PSay("ProcessPage() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return false;
 }
}
//---------------------------------------------------------------------------
void TformWizardNewBudgetEntry::SetupPage   (int page_index)           // make this page ready to be shown based on other data
{
 switch (page_index)
 {
  case 0:
   radioYearlyBudgets->Checked = true;
   radioExpenseBudgets->Checked = true;
   checkClosedBudgets->Checked = false;
   comboYearlyCycle->Text = "January";
   radioBudgetActionClick(NULL);
   radioBudgetChangeClick(NULL);
   break;
  case 1:
   budget_listview->clear_data();

   string sql_get_current_budgets;
   vector<map<string, string> > initial_data;
   string month_id = lookupTables->IdOf("month_types", comboYearlyCycle->Text.c_str());

   default_effective_date.InDate(TDateTime::CurrentDate());
   if (month_id != "")
   {
    default_effective_date.day = 1; //always default to the first of -something-
    int month_number = StringToInt(month_id);
    if (abs(month_number - default_effective_date.month) > 6)
     if (default_effective_date.month > month_number)
      default_effective_date.year++;
     else
      default_effective_date.year--;
    else
     ; // stay in current year ...
    default_effective_date.month = StringToInt(month_id);
   }
   dateAddAsOf->DateTime     = default_effective_date.OutDate(); // Paul didn't like Philip's defaults
   dateReplaceAsOf->DateTime = default_effective_date.OutDate(); // Paul didn't like Philip's defaults

   sql_get_current_budgets = "select accounts.id account_id, acc_level_one.short_item fund, acc_level_two.short_item line_item, "
                             "acc_level_three.short_item department, acc_level_four.short_item subdepartment, "
                             "accounts.bill_cycle_id account_cycle, accounts.balance_account_id account_equity_id, ";
                             
   if (radioRevenueBudgets->Checked)
    sql_get_current_budgets += "sum(transactions.credit_amount - transactions.debit_amount) account_budget ";
   else
    sql_get_current_budgets += "sum(transactions.debit_amount - transactions.credit_amount) account_budget ";

   sql_get_current_budgets += "from accounts "
                              "inner join acc_level_one on accounts.acc_level_one_id = acc_level_one.id "
                              "inner join acc_level_two on accounts.acc_level_two_id = acc_level_two.id "
                              "inner join acc_level_three on accounts.acc_level_three_id = acc_level_three.id "
                              "inner join acc_level_four on accounts.acc_level_four_id = acc_level_four.id "
                              "left join transactions on transactions.account_id = accounts.id "
                              "where is_budget = 1 ";
   if (radioYearlyBudgets->Checked)
   {
    sql_get_current_budgets += "and is_yearly = 1 ";
    if (month_id != "")
     sql_get_current_budgets += "and bill_cycle_id = " + month_id + " ";
   } else
   {
    sql_get_current_budgets += "and is_yearly = 0 ";
   }

   if (radioRevenueBudgets->Checked)
    sql_get_current_budgets += "and accounts.account_type_id = " + lookupTables->IdOf("account_types", "Revenue") + " ";
   else
    sql_get_current_budgets += "and accounts.account_type_id = " + lookupTables->IdOf("account_types", "Expense") + " ";

   if (!checkClosedBudgets->Checked)
    sql_get_current_budgets += "and accounts.is_closed = 0 ";

   sql_get_current_budgets += "group by accounts.id, acc_level_one.short_item, acc_level_two.short_item, "
                              "acc_level_three.short_item, acc_level_four.short_item, "
                              "accounts.bill_cycle_id, accounts.balance_account_id ";

   TIBTransaction * dbTransaction = new TIBTransaction(NULL);
   StdTransaction(dbTransaction, dbDatabase);
   DebugSql(this, &sql_get_current_budgets, other_forms, 9, dbTransaction);
   if (SqlToVecMap(dbDatabase, sql_get_current_budgets, initial_data))
   {
    for (vector<map<string, string> >::iterator i_row = initial_data.begin(); i_row != initial_data.end(); i_row++)
    {
     (*i_row)["action_type"] = "None";
    }
    budget_listview->import_data(initial_data);
   } else
    PSay("The current budget information could not be retrieved from the database. Please inform your system administrator.", m_database_error, MB_OK);
   break;
 }
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewBudgetEntry::radioBudgetActionClick(TObject *Sender)
{
 // change panel active/inactive status
 if (radioYearlyBudgets->Checked)
  RecurseEnabled(panelYearlyBudgets, true);
 else
  RecurseEnabled(panelYearlyBudgets, false);
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewBudgetEntry::radioBudgetChangeClick(TObject *Sender)
{
 // change panel active/inactive status
 if (radioChangeNone->Checked)
 {
  RecurseEnabled(panelBudgetAdd, false);
  RecurseEnabled(panelBudgetReplace, false);
 } else
 if (radioChangeAdd->Checked)
 {
  RecurseEnabled(panelBudgetAdd, true);
  RecurseEnabled(panelBudgetReplace, false);
 } else
 {
  RecurseEnabled(panelBudgetAdd, false);
  RecurseEnabled(panelBudgetReplace, true);
 }
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewBudgetEntry::FormClose(TObject *Sender, TCloseAction &Action)
{
 Action = caFree;
 TformWizardGeneric::FormClose(Sender, Action);
 if (Action != caNone)
 {
  lookupTables->UnregisterComboBox("month_types", comboYearlyCycle);
  delete budget_listview;
 }
}
//---------------------------------------------------------------------------
void TformWizardNewBudgetEntry::accountselected ()
{
 // user has selected data (listview->data box)
 if (pageStandard->ActivePageIndex == 1)
 {
  if (listAccountBudgets->Selected)
  {
   RecurseEnabled (groupBudgetChange, true);
   groupBudgetChange->SetFocus();
   map<string, string> row_data;
   if (budget_listview->get_current_row(row_data))
   {
    if (row_data["action_type"] == "Add")
    {
     radioChangeAdd->Checked = true;
     editAddAmount->SetFocus(); // Paul didn't like Philip's defaults
    }
    else if (row_data["action_type"] == "Replace")
    {
     radioChangeReplace->Checked = true;
     editReplaceAmount->SetFocus(); // Paul didn't like Philip's defaults
    }
    else
    {
     /*radioChangeNone->Checked = true*/; // Paul didn't like Philip's defaults
     if (panelBudgetAdd->Enabled) editAddAmount->SetFocus();
     if (panelBudgetReplace->Enabled) editReplaceAmount->SetFocus();
    }

    radioBudgetChangeClick(NULL);
    //dateAddAsOf->DateTime     = default_effective_date.OutDate(); // Paul didn't like Philip's defaults
    //dateReplaceAsOf->DateTime = default_effective_date.OutDate(); // Paul didn't like Philip's defaults
    editAddAmount->Text       = "0.00";
    editReplaceAmount->Text   = "0.00";

    Pdate temp_date;

    if (radioChangeAdd->Checked)
    {
     if (row_data["action_date"] != "")
     {
      temp_date.InDate(row_data["action_date"], mdy | yy);
      dateAddAsOf->DateTime = (temp_date).OutDate();
     }
     if (row_data["action_amount"] != "")
      editAddAmount->Text = row_data["action_amount"].c_str();
    } else
    if (radioChangeReplace->Checked)
    {
     if (row_data["action_date"] != "")
     {
      temp_date.InDate(row_data["action_date"], mdy | yy);
      dateReplaceAsOf->DateTime = (temp_date).OutDate();
     }
     if (row_data["action_amount"] != "")
      editReplaceAmount->Text = row_data["action_amount"].c_str();
    }

    editNote->Text = row_data["action_note"].c_str();
   } else
   {
    PSay("You have selected a row, but for some reason the data cannot be retrieved to be processed. You should report this immediately.", m_program_error, MB_OK);
   }
  } else
  {
   //RecurseEnabled (groupBudgetChange, false); // Paul didn't like Philip's defaults
   //listAccountBudgets->SetFocus(); // Paul didn't like Philip's defaults
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewBudgetEntry::buttonSaveBudgetChangeClick(TObject *Sender)
{
 // as opposed to the above, this does an add/modify thingie (data box->listview)
 if (listAccountBudgets->Selected)
 {
  map<string, string> row_data;
  if (budget_listview->get_current_row(row_data))
  {
   bool data_okay = false;
   Pdate temp_date;
   financial change_amount   = 0.00;
   financial original_amount = 0.00;
   financial new_amount      = 0.00;
   if (radioChangeAdd->Checked)
   {
    temp_date.InDate(dateAddAsOf->DateTime);
    if (temp_date.IsValidDate())
    {
     if (IsAmount(editAddAmount->Text.c_str()))
     {
      change_amount   = StringToFinancial(editAddAmount->Text.c_str());
      original_amount = StringToFinancial(row_data["account_budget"]);
      new_amount = original_amount + change_amount;
      if (new_amount >= 0.00)
      {
       row_data["action_type"]   = "Add";
       row_data["action_date"]   = temp_date.OutDate(mdy | yyyy);
       row_data["action_amount"] = FinancialToString(change_amount, false);
       data_okay = true;
      } else
       PSay(string("Please enter a dollar amount for the budget change that will not result in a negative budget in the future.\n" + FinancialToString(original_amount, true) + " + " + FinancialToString(change_amount, true) + " = " + FinancialToString(new_amount)), m_invalid_data, MB_OK);
     } else
      PSay("Please enter a valid dollar amount for the budget change.", m_invalid_data, MB_OK);
    } else
     PSay("Please enter a valid effective date for the budget change.", m_invalid_data, MB_OK);
   } else
   if (radioChangeReplace->Checked)
   {
    temp_date.InDate(dateReplaceAsOf->DateTime);
    if (temp_date.IsValidDate())
    {
     if (IsAmount(editReplaceAmount->Text.c_str()))
     {
      financial temp_amount = StringToFinancial(editReplaceAmount->Text.c_str());
      if (temp_amount >= 0.00)
      {
       row_data["action_type"]   = "Replace";
       row_data["action_date"]   = temp_date.OutDate(mdy | yyyy);
       row_data["action_amount"] = FinancialToString(temp_amount, false);
       data_okay = true;
      } else
       PSay("Please enter a positive dollar amount for the budget change.", m_invalid_data, MB_OK);
     } else
      PSay("Please enter a valid dollar amount for the budget change.", m_invalid_data, MB_OK);
    } else
     PSay("Please enter a valid effective date for the budget change.", m_invalid_data, MB_OK);
   } else
   {
    row_data["action_type"]   = "None";
    row_data["action_date"]   = "";
    row_data["action_amount"] = "";
    data_okay = true;
   }

   row_data["action_note"] = editNote->Text.c_str();

   if (data_okay)
   {
    if (!budget_listview->add_or_modify_row_data(row_data, true))
    {
     PSay("Changes to this item could not be stored for some reason.", m_program_error, MB_OK);
    } else
     /*listAccountBudgets->SetFocus() */; // Paul didn't like Philip's defaults
   }
  } else
  {
   PSay("You have selected a row, but for some reason the data cannot be retrieved to be processed. You should report this immediately.", m_program_error, MB_OK);
  }
 } else
 {
  PSay("You may not create new accounts from this screen.\nYou must therefore keep off the grass, and only select existing account budgets to edit.", m_warning, MB_OK);
 }
}
//---------------------------------------------------------------------------
void TformWizardNewBudgetEntry::accountzoomed ()
{
 if (listAccountBudgets->Selected)
 {
  map<string, string> row_data;
  if (budget_listview->get_current_row(row_data))
  {
   map<string, string> params;
   params["id"] = row_data["account_id"];
   FORM_TRY
     TformRecordAccount * more_info = new TformRecordAccount(NULL, params);
     more_info->Show();
   FORM_CATCH
  } else
  {
   PSay("You have double-clicked a row, but for some reason the data cannot be retrieved to be processed. You should report this immediately.", m_program_error, MB_OK);
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewBudgetEntry::staticBudgetModInsteadClick(TObject *Sender)
{
 FORM_TRY
   TformSpecialNewBudgetMod * wiz = new TformSpecialNewBudgetMod(NULL);
   wiz->Show();
 FORM_CATCH
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewBudgetEntry::editAmountKeyPress(TObject *Sender, char &Key)
{
   if (Key == VK_RETURN)
      buttonSaveBudgetChange->Click();
}
//---------------------------------------------------------------------------
void TformWizardNewBudgetEntry::PageLockStatus (int page_index, bool locked)
{
 switch (page_index)
 {
  case 0:
   groupAccountPeriod->Enabled = !locked;
   groupAccountType->Enabled = !locked;
   return;
  case 1:
   groupBudgetChange->Enabled = !locked;
   return;
  default:
   PSay("PageLockStatus() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewBudgetEntry::listAccountBudgetsChanging(TObject *Sender, TListItem *Item, TItemChange Change, bool &AllowChange)
{
 // hopefully, if it were possible to lock the second page, this would block that enabling/disabling code from running?
 AllowChange = !WizardLocked();
}
//---------------------------------------------------------------------------
bool TformWizardNewBudgetEntry::FinishWizard ()
{
 // save changes from listview to the database
 // for each non-None account ...
 // if replace:
 //  as of AsOf, credit (expense) or debit (revenue) the budget as it stands at that moment
 //              debit (expense) or credit (revenue) the equity-budget associated
 //  as of AsOf, debit (expense) or credit (revenue) the budget by the amount shown
 //              credit (expense) or debit (revenue) the equity-budget associated
 // if add:
 //  as of AsOf, debit (expense) or credit (revenue) the budget by the amount shown
 //              credit (expense) or debit (revenue) the equity-budget associated

 vector<map<string, string> > listview_rows_to_process;
 map<string, string> current_listview_row;

 vector<map<string, string> > database_rows_to_insert;
 map<string, string> current_database_row;
 map<string, string> default_database_row;

 budget_listview->export_data(listview_rows_to_process);

 TIBTransaction * dbTransaction = new TIBTransaction(NULL);
 StdTransaction (dbTransaction, dbDatabase);

 default_database_row["current_id"]         = "4";
 default_database_row["last_update_stamp"]  = RightNow();
 default_database_row["last_updated_by"]    = current_userid;
 default_database_row["task_id"]            = "0";
 default_database_row["bill_id"]            = "0";
 default_database_row["tax_entity_id"]      = "0";
 default_database_row["credit_amount"]      = "0.00";
 default_database_row["debit_amount"]       = "0.00";
 default_database_row["transaction_number"] = GetNextId(dbTransaction, "transact_number");

 try
 {
  for (vector<map<string, string> >::iterator i_listview_row = listview_rows_to_process.begin();
       i_listview_row != listview_rows_to_process.end(); i_listview_row++)
  {
   current_listview_row = (*i_listview_row);

   // if replacing, bring budget amount down to zero first (or up to zero if someone's been stupid)
   if (current_listview_row["action_type"] == "Replace")
   {
    // against budget

    string sql_get_budget_as_of_date = "select ";
    if (radioExpenseBudgets->Checked)
     sql_get_budget_as_of_date += " sum(debit_amount - credit_amount) ";
    else
     sql_get_budget_as_of_date += " sum(credit_amount - debit_amount) ";
    sql_get_budget_as_of_date += " from transactions where account_id = " + current_listview_row["account_id"] + " and effective_date <= '" + current_listview_row["action_date"] + "' ";

    string budget_as_of_date = GetOneField(dbTransaction, sql_get_budget_as_of_date);
    if (budget_as_of_date == "")
     budget_as_of_date = "0.00";

    current_database_row = default_database_row;
    current_database_row["id"] = GetNextId(dbTransaction, "transactions");
    current_database_row["account_id"] = current_listview_row["account_id"];
    current_database_row["effective_date"] = current_listview_row["action_date"];
    current_database_row["note"] = string("Closing budget balance into equity (budget):") + current_listview_row["action_note"];
    current_database_row["transaction_id"] = lookupTables->IdOf("transaction_types", "Closing Balance");
    current_database_row[radioExpenseBudgets->Checked ? "credit_amount" : "debit_amount"] = budget_as_of_date;
    ExecuteInsertStatement(dbTransaction, "transactions", current_database_row);

    // against equity
    current_database_row = default_database_row;
    current_database_row["id"] = GetNextId(dbTransaction, "transactions");
    current_database_row["account_id"] = current_listview_row["account_equity_id"];
    current_database_row["effective_date"] = current_listview_row["action_date"];
    current_database_row["note"] = string("Closing budget balance into equity (equity):") + current_listview_row["action_note"];
    current_database_row["transaction_id"] = lookupTables->IdOf("transaction_types", "Closing Balance");
    current_database_row[radioExpenseBudgets->Checked ? "debit_amount" : "credit_amount"] = budget_as_of_date;
    ExecuteInsertStatement(dbTransaction, "transactions", current_database_row);
   }

   // if replacing or adding, add the new budget amount (see above, this works)
   if (current_listview_row["action_type"] != "None")
   {
    // against equity
    current_database_row = default_database_row;
    current_database_row["id"] = GetNextId(dbTransaction, "transactions");
    current_database_row["account_id"] = current_listview_row["account_equity_id"];
    current_database_row["effective_date"] = current_listview_row["action_date"];
    current_database_row["note"] = string("Opening budget balance from equity (budget):") + current_listview_row["action_note"];
    current_database_row["transaction_id"] = lookupTables->IdOf("transaction_types", "Opening Balance");
    current_database_row[radioExpenseBudgets->Checked ? "credit_amount" : "debit_amount"] = current_listview_row["action_amount"];
    ExecuteInsertStatement(dbTransaction, "transactions", current_database_row);

    // against budget
    current_database_row = default_database_row;
    current_database_row["id"] = GetNextId(dbTransaction, "transactions");
    current_database_row["account_id"] = current_listview_row["account_id"];
    current_database_row["effective_date"] = current_listview_row["action_date"];
    current_database_row["note"] = string("Opening budget balance from equity (equity):") + current_listview_row["action_note"];
    current_database_row["transaction_id"] = lookupTables->IdOf("transaction_types", "Opening Balance");
    current_database_row[radioExpenseBudgets->Checked ? "debit_amount" : "credit_amount"] = current_listview_row["action_amount"];
    ExecuteInsertStatement(dbTransaction, "transactions", current_database_row);
   }

   // if none, then, do nothing for this row.
  }
  dbTransaction->Commit();
  delete dbTransaction;
  return true;
 } catch (...)
 {
  dbTransaction->Rollback();
  PSay("Transactions could not be inserted to perform budget changes as requested.\nPlease inform your systems administrator.", m_database_error, MB_OK);
  delete dbTransaction;
  return false;
 }
}
//---------------------------------------------------------------------------
void TformWizardNewBudgetEntry::Do()
{
 FORM_TRY
  TformWizardNewBudgetEntry * z = new TformWizardNewBudgetEntry(NULL);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------



