//---------------------------------------------------------------------------

// TODO: (listed below -- short-term stuff)
// x WhereNext needs to route through the dupe screens (around it automatically would be nice)
// x find where that "empty sql statement" is, if it matters, because ...
// x remove warning screen from here (don't remove from project, might still be useful)
// x dupe_cobs needs some sql written that doesn't suck (check dupe_bills for logical errors, extend reach?)
//   -> rather, might need to look at more dates, maybe do more joins (catch more stuff?)
// - make sure refreshing always works
// x warn if lists aren't empty, don't move forward without [yes]
// x warn if moving away from notes listview while warn/block items are visible and unchecked
//   -> other departments? that could suck.
//   -> prevent block-bypass without permission, allow with (logging later)
// x reselect transaction data before applying difference (or use some other transaction paradigm!)
// - make damned sure it works no matter what you do to it.

// - pages 9 and 14 are mutually exclusive, and in the same (possible) spot in the chain of events, and have the same fields. merge? (different captions, slightly different semantics)
// x use HistoryIncludes more in the save_data sections (don't assume pages will have been done, in case stuff changes again.)

// - fix those stupid other transactions (200k of them)
// - write good documentation so they'll have -some- sort of help with this (even if they don't read it?)

// - moving stuff between COB and Bill -- some way to automatically convert entries for "entity on COB" to "entity on bill"? and then remove message box?

#include <vcl.h>
#pragma hdrstop

#include "codeWizardNewContractHealthItem.h"
#include "codeSearchPerson.h"
#include "codeSearchTaxEntity.h"
#include "codeSearchTaskCob.h"
#include "codeRecordConsent.h"
#include "codeRecordTaskCob.h"
#include "codeRecordInsuranceCoverage.h"
#include "codeRecordServiceProvided.h"
#include "codeRecordPersonNotes.h"
#include "codeRecordTaxEntity.h"
#include "codeRecordIncomingBill.h"
#include "codeRecordOutgoingBill.h"
#include "codeRecordTaskCob.h"
#include "codeRecordTaskLac.h"
#include "codeRecordTaskDen.h"
#include "codeSearchCode.h"
#include "codeRecordEntityContract.h"
#include "codePrometheus.h"

// testing
#include "codeRecordBill.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeWizardGeneric"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformWizardNewContractHealthItem *formWizardNewContractHealthItem;
//---------------------------------------------------------------------------
__fastcall TformWizardNewContractHealthItem::TformWizardNewContractHealthItem(TComponent* Owner, bool p_is_bill)
        : TformWizardGeneric(Owner)
{
 if (p_is_bill)
 {
  start_page = 0;
  this->Caption = "New Contract Health Item - Provider Bill";
  buttonHelper->Visible = true;
 } else
 {
  start_page = 7;
  this->Caption = "New Contract Health Item - Coordination of Benefits";
  buttonHelper->Visible = false;
 }

 helper_window   = NULL;
 embedded_limits = NULL;

 FORM_TRY
  helper_window                = new TformDrawerGeneric(NULL);
 FORM_CATCH
 helper_window->labelDrawerName->Caption = "Payment helper";
 helper_window->DrawerOwner    = this;
 helper_window->Width          = 218;
 helper_window->DrawerPosition = akRight;
 helper_window->KidnapControl(panelPaymentHelper);

 // combo boxes
 lookupTables->RegisterComboBox("todo_status_types", comboOutReferralStatus);
 string group_sql = "select id, item, valid from referral_reason_types where group_id in ("+SetToCommaString(GetSpecialGroupPermissions("general"))+") and valid = 1 order by item";
 lookupTables->RegisterComboBox("referral_reason_types", comboOutReferralReason, group_sql);
/*if (optionsPermissions["special.beh.general"]["enabled"] != "true")
   comboOutReferralReasonBehavioral->Enabled = false;
 if (optionsPermissions["special.com.general"]["enabled"] != "true")
   comboOutReferralReasonCommunity->Enabled = false;
 if (optionsPermissions["special.diab.general"]["enabled"] != "true")
   comboOutReferralReasonDiabetes->Enabled = false;
*/
 // set up column definitions
 list_cases.SetListViewHandle(listCases);
 list_cases.SetSecurity("cases");
 list_cases.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 list_cases.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 list_cases.SetIconStatus(true);
 list_cases.FetchPreferences("wizardnewcontracthealthitem.cases_filter");
 list_cases.SetSQLStatement("");
 list_cases.RefreshDataSet();
 list_cases.SetAddEdit(this, NULL, EditRecord(&(TformWizardNewContractHealthItem::EditCase)));

 list_consents.SetListViewHandle (listConsents);
 list_consents.SetSecurity("consents");
 list_consents.AddColumnSpec("Date", "consents", as_date, true, 80);
 list_consents.AddColumnSpec("Type of Consent", "consents", as_text, true, 200);
 list_consents.AddColumnSpec("Note", "consents", as_text, false, 140, sentenceString);
 list_consents.AddColumnSpec("Group", "consents", as_text, true, 100);
 list_consents.AddColumnSpec("Event", "participations", as_text, false, 140);
 list_consents.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 list_consents.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 list_consents.SetIconStatus(true);
 list_consents.FetchPreferences("wizardnewcontracthealthitem.consents_filter");
 list_consents.SetSQLStatement ("");
 list_consents.RefreshDataSet();
 list_consents.SetAddEdit(this, AddRecord(&(TformWizardNewContractHealthItem::AddConsent)), EditRecord(&(TformWizardNewContractHealthItem::EditConsent)));

 list_cobs.SetListViewHandle(listExistingCob);
 list_cobs.SetSecurity("tasks.cob");
 list_cobs.AddColumnSpec("Bills", "bills", as_int, true, 60);
 list_cobs.AddColumnSpec("Date", "tasks", as_date, true, 80);
 list_cobs.AddColumnSpec("Appt. Date", "appointments", as_date, true, 80);
 list_cobs.AddColumnSpec("Time", "tasks", as_time, true, 80);
 list_cobs.AddColumnSpec("COB Number", "tasks", as_int, true, 100);
 list_cobs.AddColumnSpec("Provider", "tax_entities", as_text, true, 140, rawString);
 list_cobs.AddColumnSpec("Service", "services_provided", as_text, true, 140);
 list_cobs.AddColumnSpec("Area", "services_provided", as_text, true, 140);
 list_cobs.AddColumnSpec("Obligated Amount", "tasks", as_double, true, 130, nonzeroAmountString);
 list_cobs.AddColumnSpec("Reason", "tasks", as_text, true, 130, rawString);
 list_cobs.AddColumnSpec("Limits", "tasks", as_text, false, 130, rawString);
 list_cobs.AddColumnSpec("Preconditions", "tasks", as_text, false, 130, sentenceString);
 list_cobs.AddColumnSpec("Follow up", "tasks", as_text, false, 130, sentenceString);
 list_cobs.AddColumnSpec("Reported by", "tasks", as_text, false, 130, sentenceString);
 list_cobs.AddColumnSpec("Hospitalized", "tasks", as_text, false, 130, prettyBoolString);
 list_cobs.AddColumnSpec("Given Room", "tasks", as_text, false, 130, prettyBoolString);
 list_cobs.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 list_cobs.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 list_cobs.SetIconStatus(true);
 list_cobs.FetchPreferences("wizardnewcontracthealthitem.cob_filter");
 list_cobs.SetSQLStatement("");
 list_cobs.RefreshDataSet();
 list_cobs.SetAddEdit(this, NULL, EditRecord(&(TformWizardNewContractHealthItem::EditCob)));

 list_insurances.SetListViewHandle (listInsurance);
 list_insurances.SetSecurity("insurance_coverage");
 list_insurances.AddColumnSpec("Company", "tax_entities", as_text, true, 140, rawString);
 list_insurances.AddColumnSpec("Medical Type", "tax_entities", as_text, true, 100);
 list_insurances.AddColumnSpec("Policy Number", "insurance_policies", as_text, true, 120, rawString);
 list_insurances.AddColumnSpec("Group Number", "insurance_policies", as_text, true, 120, rawString);
 list_insurances.AddColumnSpec("Coverage Type", "insurance_benefits", as_text, true, 100);
 list_insurances.AddColumnSpec("Coverage Note", "insurance_benefits", as_text, true, 120);
 list_insurances.AddColumnSpec("Effective Date", "insurance_policies", as_date, true, 120);
 list_insurances.AddColumnSpec("Termination Date", "insurance_policies", as_date, false, 120);
 list_insurances.AddColumnSpec("Coverage", "insurance_policies", as_text, false, 120);
 list_insurances.AddColumnSpec("Source", "insurance_policies", as_text, false, 120);
 list_insurances.AddColumnSpec("Name on Policy", "insurance_policies", as_text, false, 120);
 list_insurances.AddColumnSpec("PCP", "tax_entities", as_text, true, 120, rawString);
 list_insurances.AddColumnSpec("Person Code", "insurance_coverage", as_int, false, 100);
 list_insurances.AddColumnSpec("Name on Card", "insurance_coverage", as_text, false, 100);
 list_insurances.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 list_insurances.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 list_insurances.SetIconStatus(true);
 list_insurances.FetchPreferences("wizardnewcontracthealthitem.coverage_filter");
 list_insurances.SetSQLStatement ("");
 list_insurances.RefreshDataSet();
 list_insurances.SetAddEdit(this, AddRecord(&(TformWizardNewContractHealthItem::AddInsurance)), EditRecord(&(TformWizardNewContractHealthItem::EditInsurance)));

 list_notes.SetListViewHandle (listNotes);
 list_notes.SetSecurity("person_notes.common");
 list_notes.AddColumnSpec("Date", "person_notes", as_date, true, 100);
 list_notes.AddColumnSpec("Note", "person_notes", as_text, true, 150, sentenceString);
 list_notes.AddColumnSpec("Warning", "person_notes", as_text, true, 80, prettyString);
 list_notes.AddColumnSpec("Group", "person_notes", as_text, true, 100);
 list_notes.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 list_notes.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 list_notes.SetIconStatus(true);
 list_notes.FetchPreferences("wizardnewcontracthealthitem.notes_filter");
 list_notes.SetSQLStatement("");
 list_notes.SetCheck(true);
 list_notes.RefreshDataSet();
 list_notes.SetAddEdit(this, AddRecord(&(TformWizardNewContractHealthItem::AddNote)), EditRecord(&(TformWizardNewContractHealthItem::EditNote)));

 list_referrers.SetListViewHandle(listReferrers);
 list_referrers.SetSecurity("tax_entities");
 list_referrers.AddColumnSpec("Name", "tax_entities", as_text, true, 240, rawString);
 list_referrers.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 list_referrers.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 list_referrers.SetHeader(false);
 list_referrers.SetIconStatus(true);
 list_referrers.FetchPreferences("wizardewcontracthealthitem.referrer_filter");
 // never changes -- yay! (yes, it was this way in the code I copied it from.)
 list_referrers.SetSQLStatement("select tax_entities.name, tax_entities.current_id, tax_entities.id from tax_entities where tax_entities.is_referring = 1");
 list_referrers.RefreshDataSet();
 list_referrers.SetAddEdit(this, NULL, EditRecord(&(TformWizardNewContractHealthItem::EditReferrer)));

 list_services.SetListViewHandle(listServices);
 list_services.SetSecurity("services_provided");
 list_services.AddColumnSpec("Service", "services_provided", as_text, true, 140);
 list_services.AddColumnSpec("Area", "services_provided", as_text, true, 80);
 list_services.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 list_services.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 list_services.SetIconStatus(true);
 list_services.FetchPreferences("wizardnewcontracthealthitem.services_filter");
 list_services.SetSQLStatement("");
 list_services.RefreshDataSet();
 // add-edit done elsewhere, as 'service_provider_id' isn't guaranteed to exist

 list_dupe_cobs.SetListViewHandle(listDupeCOBs);
 list_dupe_cobs.SetSecurity("tasks.cob");
 list_dupe_cobs.AddColumnSpec("Person", "people", as_text, true, 120, prettyString);
 list_dupe_cobs.AddColumnSpec("Date", "tasks", as_date, true, 75);
 list_dupe_cobs.AddColumnSpec("Appt. Date", "appointments", as_date, true, 75);
 list_dupe_cobs.AddColumnSpec("Time", "tasks", as_time, true, 75);
 list_dupe_cobs.AddColumnSpec("COB Number", "tasks", as_int, true, 75);
 list_dupe_cobs.AddColumnSpec("Service", "services_provided", as_text, true, 120, prettyString);
 list_dupe_cobs.AddColumnSpec("Reason", "tasks", as_text, true, 80, rawString);
 list_dupe_cobs.AddColumnSpec("Limits", "tasks", as_text, true, 80, rawString);
 list_dupe_cobs.AddColumnSpec("Preconditions", "tasks", as_text, false, 80, sentenceString);
 list_dupe_cobs.AddColumnSpec("Follow up", "tasks", as_text, false, 80, sentenceString);
 list_dupe_cobs.AddColumnSpec("Reported by", "tasks", as_text, false, 80, sentenceString);
 list_dupe_cobs.AddColumnSpec("Hospitalized", "tasks", as_text, false, 75, prettyBoolString);
 list_dupe_cobs.AddColumnSpec("Given Room", "tasks", as_text, false, 75, prettyBoolString);
 list_dupe_cobs.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 list_dupe_cobs.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 list_dupe_cobs.SetAddEdit(this, NULL, EditRecord(&(TformWizardNewContractHealthItem::EditDupeCob)));
 list_dupe_cobs.FetchPreferences("wizardnewcontracthealthitem.dupe_cob_filter");
 list_dupe_cobs.SetSQLStatement("");
 list_dupe_cobs.RefreshDataSet();

 list_dupe_visits.SetListViewHandle(listDupeVisits);
 list_dupe_visits.SetSecurity("tasks");
 list_dupe_visits.AddColumnSpec("Person", "people", as_text, true, 120, prettyString);
 list_dupe_visits.AddColumnSpec("Provider", "tax_entities", as_date, true, 120, rawString);
 list_dupe_visits.AddColumnSpec("Date", "tasks", as_date, true, 75);
 list_dupe_visits.AddColumnSpec("Appt. Date", "appointments", as_date, true, 75);
 list_dupe_visits.AddColumnSpec("Time", "tasks", as_time, true, 75);
 list_dupe_visits.AddColumnSpec("Reason", "tasks", as_text, true, 80, sentenceString);
 list_dupe_visits.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 list_dupe_visits.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 list_dupe_visits.SetAddEdit(this, NULL, EditRecord(&(TformWizardNewContractHealthItem::EditDupeVisit)));
 list_dupe_visits.FetchPreferences("wizardnewcontracthealthitem.dupe_visit_filter");
 list_dupe_visits.SetSQLStatement("");
 list_dupe_visits.RefreshDataSet();

 list_dupe_bills.SetListViewHandle (listDupeBills);
 list_dupe_bills.SetSecurity("bills");
 list_dupe_bills.AddColumnSpec("Person", "people", as_text, true, 120);
 list_dupe_bills.AddColumnSpec("Date", "bills", as_date, true, 75);
 list_dupe_bills.AddColumnSpec("Primary Tax Entity", "insurance_coverage", as_text, true, 75);
 list_dupe_bills.AddColumnSpec("Provider", "tax_entities", as_text, true, 75, rawString);
 list_dupe_bills.AddColumnSpec("Facility", "tax_entities", as_text, true, 75, rawString);
 list_dupe_bills.AddColumnSpec("Group", "tax_entities", as_text, true, 75, rawString);
 list_dupe_bills.AddColumnSpec("Insurance", "tax_entities", as_text, true, 75, prettyString);
 list_dupe_bills.AddColumnSpec("Invoice Number", "bills", as_text, true, 75, prettyString);
 list_dupe_bills.AddColumnSpec("PR Number", "purchase_reqs", as_int, true, 75);
 list_dupe_bills.AddColumnSpec("Check Number", "checks", as_int, true, 75);
 list_dupe_bills.AddColumnSpec("Invoice Amount", "bills", as_double, true, 75, amountString);
 list_dupe_bills.AddColumnSpec("Type", "bills", as_text, true, 75, prettyString);
 list_dupe_bills.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 list_dupe_bills.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 list_dupe_bills.SetAddEdit(this, NULL, EditRecord(&(TformWizardNewContractHealthItem::EditDupeBill)));
 list_dupe_bills.FetchPreferences("wizardnewcontracthealthitem.dupe_bill_filter");
 list_dupe_bills.SetSQLStatement ("");
 list_dupe_bills.RefreshDataSet();

 // jhaley 20100902 - Setup overview list filters
 source_overview_insurances = NULL;
 FORM_TRY
   source_overview_insurances = new classFilterVecmapSource();
 FORM_CATCH
 source_overview_insurances->SetFilter(&list_overview_insurances); // ownership is assumed by the filter

 list_overview_insurances.SetListViewHandle(listOverviewInsurance);
 list_overview_insurances.SetSecurity("insurance_coverage");
 list_overview_insurances.AddColumnSpec("Coverage Type", "insurance_benefits", as_text, true, 120);
 list_overview_insurances.AddColumnSpec("Company", "tax_entities", as_text, true, 210, rawString);
 list_overview_insurances.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 list_overview_insurances.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 list_overview_insurances.SetAddEdit(this, NULL, EditRecord(&(TformWizardNewContractHealthItem::EditOverviewInsurance)));
 list_overview_insurances.SetHeader(false);
 list_overview_insurances.SetIconStatus(true);
 list_overview_insurances.FetchPreferences("wizardnewcontracthealthitem.overview_coverage_filter");
 list_overview_insurances.SetDataSource(source_overview_insurances);
 list_overview_insurances.RefreshDataSet();

 source_overview_consents = NULL;
 FORM_TRY
   source_overview_consents = new classFilterVecmapSource();
 FORM_CATCH
 source_overview_consents->SetFilter(&list_overview_consents);

 list_overview_consents.SetListViewHandle(listOverviewConsents);
 list_overview_consents.SetSecurity("consents");
 list_overview_consents.AddColumnSpec("Consent Status", "consents", as_text, true, 330, rawString);
 list_overview_consents.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 list_overview_consents.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 list_overview_consents.SetAddEdit(this, NULL, EditRecord(&(TformWizardNewContractHealthItem::EditOverviewConsent)));
 list_overview_consents.SetIconStatus(true);
 list_overview_consents.FetchPreferences("wizardnewcontracthealthitem.overview_consents_filter");
 list_overview_consents.SetDataSource(source_overview_consents);
 list_overview_consents.RefreshDataSet();

 source_overview_notes = NULL;
 FORM_TRY
   source_overview_notes = new classFilterVecmapSource();
 FORM_CATCH
 source_overview_notes->SetFilter(&list_overview_notes);

 list_overview_notes.SetListViewHandle(listOverviewNotes);
 list_overview_notes.SetSecurity("person_notes.common");
 list_overview_notes.AddColumnSpec("Warnings and Blocks", "person_notes", as_text, true, 330, rawString);
 list_overview_notes.AddColumnSpec("Current Id", "current_id", as_int, false, 80);
 list_overview_notes.AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
 list_overview_notes.SetAddEdit(this, NULL, EditRecord(&(TformWizardNewContractHealthItem::EditOverviewNote)));
 list_overview_notes.SetIconStatus(true);
 list_overview_notes.FetchPreferences("wizardnewcontracthealthitem.overview_notes_filter");
 list_overview_notes.SetDataSource(source_overview_notes);
 list_overview_notes.RefreshDataSet();

 // edit_listview below
 list_case_entities.setup_listview(listCaseEntities, false);
 list_case_entities.add_or_modify_column("case_entity_id",      "Entity id", false, 0, 60,  as_int,  rawString);
 list_case_entities.add_or_modify_column("case_entity_name",    "Entity",     true, 1, 120, as_text, prettyString);
 list_case_entities.add_or_modify_column("case_entity_type_id", "Reason id", false, 2, 60,  as_int,  rawString);
 list_case_entities.add_or_modify_column("case_entity_type",    "Reason",     true, 3, 120,  as_text, prettyString);
 list_case_entities.setup_callbacks((TForm*)this, InformForm(&(TformWizardNewContractHealthItem::CaseEntitySelected)), NULL);

 list_conditions.setup_listview(listConditions, false);
 list_conditions.add_or_modify_column("condition_index", "Index", true, 0, 60,  as_int,  rawString);
 list_conditions.add_or_modify_column("condition_code",  "Code",  true, 1, 120, as_text, prettyString);
 list_conditions.add_or_modify_column("condition_note",  "Note", false, 2, 120, as_text, prettyString);
 list_conditions.setup_callbacks((TForm*)this, InformForm(&(TformWizardNewContractHealthItem::ConditionSelected)), NULL);

 list_procedures.setup_listview(listProcedures, false);
 list_procedures.add_or_modify_column("procedure_date_from", "From",       true,  0, 60, as_date,   prettyString);
 list_procedures.add_or_modify_column("procedure_date_to",   "To",        false,  1, 60, as_date,   prettyString);
 list_procedures.add_or_modify_column("procedure_place_os",  "Place",     false,  2, 60, as_text,   rawString);
 list_procedures.add_or_modify_column("procedure_type_os",   "Type",      false,  3, 60, as_text,   rawString);
 list_procedures.add_or_modify_column("procedure_code",      "Code",       true,  4, 60, as_text,   prettyString);
 list_procedures.add_or_modify_column("procedure_modifier",  "Modifier",  false,  5, 60, as_text,   rawString);
 list_procedures.add_or_modify_column("procedure_diagnosis", "Diagnosis", false,  6, 60, as_text,   rawString);
 list_procedures.add_or_modify_column("procedure_note",      "Note",       true,  7, 90, as_text,   prettyString);
 list_procedures.add_or_modify_column("procedure_units",     "Units",     false,  8, 60, as_int,    rawString);
 list_procedures.add_or_modify_column("procedure_charges",   "Charges",    true,  9, 90, as_double, nonzeroAmountString);
 list_procedures.add_or_modify_column("procedure_residuals", "Residuals",  true, 10, 90, as_double, nonzeroAmountString);
 list_procedures.add_or_modify_column("procedure_allowed",   "Allowed",   false, 11, 90, as_double, nonzeroAmountString);
 list_procedures.add_or_modify_column("procedure_payment",   "Payment",    true, 12, 90, as_double, nonzeroAmountString);
 list_procedures.add_or_modify_column("procedure_tooth",     "Tooth",     false, 13, 60, as_text,   prettyString);
 list_procedures.add_or_modify_column("procedure_surface",   "Surface",   false, 14, 60, as_text,   prettyString);
 list_procedures.add_or_modify_column("procedure_epsdt",     "EPSDT",     false, 15, 60, as_text,   prettyString);
 list_procedures.add_or_modify_column("procedure_emg",       "EMG",       false, 16, 60, as_text,   prettyString);
 list_procedures.add_or_modify_column("procedure_cob",       "COB",       false, 17, 60, as_text,   prettyString);
 list_procedures.setup_callbacks((TForm*)this, InformForm(&(TformWizardNewContractHealthItem::ProcedureSelected)), NULL);

 // refreshing below puts in column headers as necessary
 list_old_cob_transactions.setup_listview(listOldCOBTransactions, false);
 list_new_cob_transactions.setup_listview(listNewCOBTransactions, false);
 list_new_bill_transactions.setup_listview(listNewBillTransactions, false);

 RefreshCOBTransactionsClick(NULL);
 RefreshBillTransactionsClick(NULL);

 list_out_referrals.setup_listview(listOutReferrals, false);
 list_out_referrals.add_or_modify_column("out_referral_entity_id",   "Entity id",   false,  0, 60,  as_int,  rawString);
 list_out_referrals.add_or_modify_column("out_referral_is_user",     "Inter-office", true,  1, 60, as_text, prettyBoolString);
 list_out_referrals.add_or_modify_column("out_referral_entity_name", "Entity",       true,  2, 80, as_text, prettyString);
 list_out_referrals.add_or_modify_column("out_referral_note",        "Note",         true,  3, 80, as_text, sentenceString);
 list_out_referrals.add_or_modify_column("out_referral_status",      "Status",       true,  4, 80, as_text, prettyString);
 list_out_referrals.add_or_modify_column("out_referral_reason",      "Reason",       false, 5, 80, as_text, prettyString);
 list_out_referrals.setup_callbacks((TForm*)this, InformForm(&(TformWizardNewContractHealthItem::OutReferralSelected)), NULL);

 // clear all sorts of variables. damn integers. always getting in the way.
 // mostly, I don't want atlas trying to compare request numbers with invalid integers.
 request_case_entity_id                = 0;
 request_out_referrer_id               = 0;
 request_cob_id                        = 0;
 request_provider_id                   = 0;
 request_facility_id                   = 0;
 request_group_id                      = 0;
 request_person_id                     = 0;
 request_service_provider_id           = 0;
 request_referrer_id                   = 0;
 request_cobs_person_id                = 0;
 request_cases_person_id               = 0;
 request_services_provided_provider_id = 0;
 request_consents_person_id            = 0;
 request_insurance_person_id           = 0;
 request_notes_person_id               = 0;
 request_referrers_is_referrer         = 0;

 staticAppointmentContract->Font->Color = link_color;

 Initialize();
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::RefreshCaseEntityId ()
{
 if (chosen_case_entity_id == "" || !IsInt(chosen_case_entity_id))
  chosen_case_entity_id = "0";

 atlas->CancelRequest(request_case_entity_id);
 request_case_entity_id = atlas->RequestNotificationWhen("tax_entities.id", chosen_case_entity_id, rel_e, as_int, this, RefreshHandler(&(TformWizardNewContractHealthItem::AtlasNotification)));

 CreateLink(staticCaseEntity, buttonSearchCaseEntity, this, chosen_case_entity_id, "tax_entities", "", true);
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::RefreshOutReferrerId ()
{
 if (chosen_out_referrer_id == "" || !IsInt(chosen_out_referrer_id))
  chosen_out_referrer_id = "0";

 atlas->CancelRequest(request_out_referrer_id);
 request_out_referrer_id = atlas->RequestNotificationWhen("tax_entities.id", chosen_out_referrer_id, rel_e, as_int, this, RefreshHandler(&(TformWizardNewContractHealthItem::AtlasNotification)));

 CreateLink(staticOutReferralEntity, buttonSearchOutReferralEntity, this, chosen_out_referrer_id, "tax_entities", "", true);
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::RefreshCobId ()
{
 if (selected_cob_id == "" || !IsInt(selected_cob_id))
  selected_cob_id = "0";

 atlas->CancelRequest(request_cob_id);
 request_cob_id = atlas->RequestNotificationWhen("tasks.id", selected_cob_id, rel_e, as_int, this, RefreshHandler(&(TformWizardNewContractHealthItem::AtlasNotification)));

 CreateLink(staticCOB, buttonSearchCOB, this, selected_cob_id, "tasks", "", true);

 if (selected_cob_id != "0")
 {
  selected_person_id = GetOneField(dbDatabase, "select person_id from tasks where tasks.id = " + selected_cob_id);
  RefreshPersonId();
  set<string> set_cob_id;
  set_cob_id.insert(selected_cob_id);
  list_cobs.SetCheckedWhereID(set_cob_id, true);
  list_cobs.MoveToFirstUsefulItem();
 }
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::RefreshProviderId ()
{
 if (selected_provider_id == "" || !IsInt(selected_provider_id))
  selected_provider_id = "0";

 atlas->CancelRequest(request_provider_id);
 request_provider_id = atlas->RequestNotificationWhen("tax_entities.id", selected_provider_id, rel_e, as_int, this, RefreshHandler(&(TformWizardNewContractHealthItem::AtlasNotification)));

 CreateLink(staticTaxProvider, buttonSearchTaxProvider, this, selected_provider_id, "tax_entities", "", true);
 buttonRelevantProviderContract->Enabled = (selected_provider_id != "0");
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::RefreshFacilityId ()
{
 if (selected_facility_id == "" || !IsInt(selected_facility_id))
  selected_facility_id = "0";

 atlas->CancelRequest(request_facility_id);
 request_facility_id = atlas->RequestNotificationWhen("tax_entities.id", selected_facility_id, rel_e, as_int, this, RefreshHandler(&(TformWizardNewContractHealthItem::AtlasNotification)));

 CreateLink(staticTaxFacility, buttonSearchTaxFacility, this, selected_facility_id, "tax_entities", "", true);
 buttonRelevantFacilityContract->Enabled = (selected_facility_id != "0");
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::RefreshGroupId ()
{
 if (selected_group_id == "" || !IsInt(selected_group_id))
  selected_group_id = "0";

 atlas->CancelRequest(request_group_id);
 request_group_id = atlas->RequestNotificationWhen("tax_entities.id", selected_group_id, rel_e, as_int, this, RefreshHandler(&(TformWizardNewContractHealthItem::AtlasNotification)));

 CreateLink(staticTaxGroup, buttonSearchTaxGroup, this, selected_group_id, "tax_entities", "", true);
 buttonRelevantGroupContract->Enabled = (selected_group_id != "0");
}
//---------------------------------------------------------------------------
// jhaley 20100902: Subroutine method for RefreshPersonId: refreshes the list views on the Overview tab of the Wizard's second page
void TformWizardNewContractHealthItem::RefreshOverviews()
{
  // Insurance Overview
  vector<map<string, string> > source_vecmap = list_insurances.GetAllData(true);
  vector<map<string, string> > dest_vecmap;
  vector<string> area_types_vec;
  SqlToVec(dbDatabase, "select item from area_types where id > 0 and valid = 1 order by item", area_types_vec);

  // first add field names to the destination vector-map; use numeric prefixes in the field names to force lexical sorting
  // (the default less<string> comparator will put them in order by the numeric prefix) - this is needed because VecmapSource
  // expects them to be in the same order as the filter columnspecs, and defining a custom comparator for std::map is a LOT
  // more work for no gain.
  map<string, string> field_names;
  field_names["0_area_type"] = "0_area_type";
  field_names["1_ins_name"] = "1_ins_name";
  field_names["2_current_id"] = "2_current_id";
  field_names["3_internal_id"] = "3_internal_id";
  dest_vecmap.push_back(field_names);

  // for each area type...
  for (vector<string>::iterator i_area = area_types_vec.begin(); i_area != area_types_vec.end(); i_area++)
  {
    bool found = false;
    // for each insurance coverage...
    for (vector<map<string, string> >::iterator i_coverage = source_vecmap.begin(); i_coverage != source_vecmap.end(); i_coverage++)
    {
      if (UppercaseString(*i_area) == UppercaseString((*i_coverage)["area_item"]) &&
          ((*i_coverage)["current_id"] == lookupTables->IdOf("current_types", "Current") ||
           (*i_coverage)["current_id"] == lookupTables->IdOf("current_types", "Primary")))
      {
        // found a match for this area type; create a "current" row displaying its values
        map<string, string> dest_row;
        dest_row["0_area_type"]   = *i_area;
        dest_row["1_ins_name"]    = (*i_coverage)["ins_name"];
        dest_row["2_current_id"]  = lookupTables->IdOf("current_types", "Current");
        dest_row["3_internal_id"] = (*i_coverage)["id"];
        dest_vecmap.push_back(dest_row);
        found = true;
        break;
      }
    }
    // not found? create a "Deleted" row (isn't this abuse of the current_types for a semantically unrelated purpose? :P )
    if (!found)
    {
      map<string, string> dest_row;
      dest_row["0_area_type"]   = *i_area;
      dest_row["1_ins_name"]    = "No coverage for this area";
      dest_row["2_current_id"]  = lookupTables->IdOf("current_types", "Deleted");
      dest_row["3_internal_id"] = IntToString(0);
      dest_vecmap.push_back(dest_row);
    }
  } // end for
  source_overview_insurances->SetSource(dest_vecmap);
  list_overview_insurances.RefreshDataSet();

  // Consents Overview
  source_vecmap = list_consents.GetAllData(true);
  dest_vecmap.clear();
  Pdate now_date = Now();
  Pdate cutoff_date = now_date;
  cutoff_date.mod(-6, in_months); // must be within last six months
  Pdate newest_date;
  bool found_consent_date = false;
  string newest_consent_id = "";

  // add field names
  field_names.clear();
  field_names["0_consent_status"] = "0_consent_status";
  field_names["1_current_id"] = "1_current_id";
  field_names["2_internal_id"] = "2_internal_id";
  dest_vecmap.push_back(field_names);

  for (vector<map<string, string> >::iterator i_consent = source_vecmap.begin(); i_consent != source_vecmap.end(); i_consent++)
  {
    Pdate this_date;
    this_date.InDate((*i_consent)["signature_date"], mdy | yyyy);

    if (!found_consent_date || this_date >= newest_date)
    {
      found_consent_date = true;
      newest_date = this_date;
      newest_consent_id = (*i_consent)["id"];
    }
  }
  if (found_consent_date)
  {
    string last_consent_signed_at;
    FriendlyDiffDate(now_date.OutDate(mdy|yyyy), newest_date.OutDate(mdy|yyyy), last_consent_signed_at, "", false);
    map<string, string> dest_row;

    if (newest_date >= cutoff_date)
    {
      dest_row["0_consent_status"] = "Last signed " + last_consent_signed_at;
      dest_row["1_current_id"]     = lookupTables->IdOf("current_types", "Current");
      dest_row["2_internal_id"]    = newest_consent_id;
    }
    else // Some exist but they're too old? Saying there are none would be a bit misleading.
    {
      dest_row["0_consent_status"] = "Last signed more than 6 months ago";
      dest_row["1_current_id"]     = lookupTables->IdOf("current_types", "Deleted");
      dest_row["2_internal_id"]    = newest_consent_id;
    }
    dest_vecmap.push_back(dest_row);
  }
  else
  {
    map<string, string> dest_row;
    dest_row["0_consent_status"] = "No consents have been signed";
    dest_row["1_current_id"]     = lookupTables->IdOf("current_types", "Deleted");
    dest_row["2_internal_id"]    = IntToString(0);
    dest_vecmap.push_back(dest_row);
  }
  source_overview_consents->SetSource(dest_vecmap);
  list_overview_consents.RefreshDataSet();

  // Notes Overview
  source_vecmap = list_notes.GetAllData(true);
  dest_vecmap.clear();

  // jhaley 20110617: Look for completed appointments that have an Optometry reason in the prior year
  Pdate one_yr_date = now_date;
  one_yr_date.mod(-1, in_years);
  string appts_sql =
    "select count(distinct A.id) "
    "from appointments A "
    "inner join appt_reason_types ART on A.appt_reason_id = ART.id "
    "where A.person_id = '" + selected_person_id + "' and A.begin_date >= '" + one_yr_date.OutDate(mdy|yyyy) + "' "
    "and A.current_id >= 2 and A.visit_outcome_id in ("
    + lookupTables->IdOf("visit_outcome_types", "As Scheduled") + ", "
    + lookupTables->IdOf("visit_outcome_types", "Walk-In")      + ", "
    + lookupTables->IdOf("visit_outcome_types", "Arrived Late") + ") "
    "and ART.appt_service_id = " + lookupTables->IdOf("appt_service_types", "Optometry");
  string appts_count_str  = GetOneField(dbDatabase, appts_sql);
  int    opto_appts_count = StringToInt(appts_count_str);

  // haleyjd 20110929: Look for denied Medicaid applications in the past 6 mo.
  Pdate six_mo_ago = now_date;
  six_mo_ago.mod(-6, in_months);
  string medicaid_appl_sql =
    "select count(distinct APPL.id) "
    "from insurance_applications APPL "
    "where APPL.current_id >= 2 and APPL.person_id = '" + selected_person_id + "' and APPL.is_denied = 1 and "
    "APPL.last_update_stamp >= '" + six_mo_ago.OutDate(mdy | yyyy) + "' and "
    "APPL.insurance_app_id = " + lookupTables->IdOf("insurance_app_types", "Medicaid application");
  string appls_count_str      = GetOneField(dbDatabase, medicaid_appl_sql);
  int    medicaid_appls_count = StringToInt(appls_count_str);

  // add field names
  field_names.clear();
  field_names["0_note_status"] = "0_note_status";
  field_names["1_current_id"]  = "1_current_id";
  field_names["2_internal_id"] = "2_internal_id";
  dest_vecmap.push_back(field_names);
  int warnings_count = 0;
  int blocks_count = 0;

  // Find warnings and blocks
  for (vector<map<string, string> >::iterator i_note = source_vecmap.begin(); i_note != source_vecmap.end(); i_note++)
  {
    string warn_id  = lookupTables->IdOf("warning_types", "Warn");
    string block_id = lookupTables->IdOf("warning_types", "Block");

    // jhaley 20101118: probably best to compare against the correct column value ;) ('note' -> 'warn_item')
    if (UppercaseString((*i_note)["warn_item"]) == UppercaseString(lookupTables->ValueOf("warning_types", warn_id)))
      ++warnings_count;
    else if(UppercaseString((*i_note)["warn_item"]) == UppercaseString(lookupTables->ValueOf("warning_types", block_id)))
      ++blocks_count;
  }
  if (warnings_count == 0)
  {
    map<string, string> dest_row;
    dest_row["0_note_status"] = "No warnings";
    dest_row["1_current_id"]  = lookupTables->IdOf("current_types", "Current");
    dest_row["2_internal_id"] = IntToString(0);
    dest_vecmap.push_back(dest_row);
  }
  else
  {
    map<string, string> dest_row;
    dest_row["0_note_status"] = IntToString(warnings_count) + " warning" + (warnings_count > 1 ? "s" : "");
    dest_row["1_current_id"]  = lookupTables->IdOf("current_types", "Deleted");
    dest_row["2_internal_id"] = IntToString(0);
    dest_vecmap.push_back(dest_row);
  }
  if (blocks_count == 0)
  {
    map<string, string> dest_row;
    dest_row["0_note_status"] = "No blocks";
    dest_row["1_current_id"]  = lookupTables->IdOf("current_types", "Current");
    dest_row["2_internal_id"] = IntToString(0);
    dest_vecmap.push_back(dest_row);
  }
  else
  {
    map<string, string> dest_row;
    dest_row["0_note_status"] = IntToString(blocks_count) + " block" + (blocks_count > 1 ? "s" : "");
    dest_row["1_current_id"]  = lookupTables->IdOf("current_types", "Deleted");
    dest_row["2_internal_id"] = IntToString(0);
    dest_vecmap.push_back(dest_row);
  }
  if (opto_appts_count > 0)
  {
    map<string, string> dest_row;
    dest_row["0_note_status"] = IntToString(opto_appts_count) + " Optometry appointment(s) this year";
    dest_row["1_current_id"]  = lookupTables->IdOf("current_types", "Incorrect"); // !
    dest_row["2_internal_id"] = IntToString(0);
    dest_vecmap.push_back(dest_row);
  }
  if(medicaid_appls_count > 0)
  {
    map<string, string> dest_row;
    dest_row["0_note_status"] = IntToString(medicaid_appls_count) + " Medicaid application(s) denied in last 6 mos.";
    dest_row["1_current_id"]  = lookupTables->IdOf("current_types", "Incorrect"); // !
    dest_row["2_internal_id"] = IntToString(0);
    dest_vecmap.push_back(dest_row);
  }

  source_overview_notes->SetSource(dest_vecmap);
  list_overview_notes.RefreshDataSet();
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::RefreshPersonId ()
{
 // just reset it. don't screw around.
 if (selected_person_id == "" || !IsInt(selected_person_id))
  selected_person_id = "0";
 string sql;

 atlas->CancelRequest(request_person_id);
 atlas->CancelRequest(request_cobs_person_id);
 atlas->CancelRequest(request_cases_person_id);
 atlas->CancelRequest(request_consents_person_id);
 atlas->CancelRequest(request_insurance_person_id);
 atlas->CancelRequest(request_notes_person_id);

 request_person_id = atlas->RequestNotificationWhen("people.id", selected_person_id, rel_e, as_int, this,
                       RefreshHandler(&(TformWizardNewContractHealthItem::AtlasNotification)));
 request_cobs_person_id = atlas->RequestNotificationWhen("tasks.person_id", selected_person_id, rel_e, as_int, this,
                       RefreshHandler(&(TformWizardNewContractHealthItem::AtlasNotification)));
 request_cases_person_id = atlas->RequestNotificationWhen("cases.person_id", selected_person_id, rel_e, as_int, this,
                       RefreshHandler(&(TformWizardNewContractHealthItem::AtlasNotification)));
 request_consents_person_id = atlas->RequestNotificationWhen("consents.person_id", selected_person_id, rel_e, as_int,
                       this, RefreshHandler(&(TformWizardNewContractHealthItem::AtlasNotification)));
 request_insurance_person_id = atlas->RequestNotificationWhen("insurance_coverage.person_id", selected_person_id, rel_e,
                       as_int, this, RefreshHandler(&(TformWizardNewContractHealthItem::AtlasNotification)));
 request_notes_person_id = atlas->RequestNotificationWhen("person_notes.person_id", selected_person_id, rel_e, as_int,
                       this, RefreshHandler(&(TformWizardNewContractHealthItem::AtlasNotification)));

 CreateLink(staticPatient, buttonSearchPatient, this, selected_person_id, "people", "", start_page == 0); // for consistency only. not really necessary.
 CreateLink(staticPatient2, buttonSearchPatient2, this, selected_person_id, "people", "", start_page == 0); // for consistency only. not really necessary.
 CreateLink(staticPerson, buttonSearchPerson, this, selected_person_id, "people", "", start_page == 7); // if creating a bill, don't let them change this!

 // copied from recordPerson, then modified slightly (added count of bills, not using initial_state["id"] as it doesn't
 //  make sense, changed "tasks" to "cobs" so the sub-query would work.)
 // jhaley 20100818: must use alias 'A' throughout for Firebird 2.x compliance.
 sql = "select "
       "(select count(bills.id) "
       " from bills inner join tasks visits on visits.id = bills.task_id "
       " where visits.parent_task_id = cobs.id), "
       "cobs.date_of_task, A.appointment_date, cobs.time_of_task, cobs.cob_number, "
       "tax_entities.name, service_types.item, area_types.item, "
       "sum(transactions.credit_amount - transactions.debit_amount), "
       "cobs.task_comments, cobs.visit_comments, cobs.preconditions_note, cobs.followup_note, "
       "cobs.reported_by_note, cobs.hospitalized, cobs.given_room, cobs.current_id, cobs.id "
       "from tasks cobs "
       "left join transactions on transactions.task_id = cobs.id "
       "and transactions.account_id in (select accounts.id from accounts where accounts.account_type_id = " + lookupTables->IdOf("account_types", "Payable") + ") "
       "inner join people on cobs.person_id = people.id "
       "inner join services_provided on cobs.services_provided_id = services_provided.id "
       "inner join tax_entities on services_provided.tax_entity_id = tax_entities.id "
       "inner join service_types on services_provided.service_id = service_types.id "
       "inner join area_types on services_provided.area_id = area_types.id "
       "left join appointments A on A.id = (select first 1 IA.id from appointments IA where IA.task_id = cobs.id and IA.current_id >= 3 order by IA.appointment_date desc) "
       "where cobs.group_id = " + lookupTables->IdOf("groups", "Contract Health") + " and "
       "cobs.services_provided_id > 0 and "
       "cobs.person_id = " + selected_person_id + " "
       "group by cobs.id, cobs.date_of_task, A.appointment_date, cobs.time_of_task, cobs.cob_number, "
       "cobs.task_comments, tax_entities.name, service_types.item, area_types.item, "
       "cobs.visit_comments, cobs.preconditions_note, cobs.followup_note, "
       "cobs.reported_by_note, cobs.hospitalized, cobs.given_room, cobs.current_id ";

 if (selected_person_id != "0")
  list_cobs.SetSQLStatement(sql);
 else
  list_cobs.SetSQLStatement("");
 list_cobs.RefreshDataSet();

 // TODO: table doesn't exactly exist yet ...
 /*
 sql = "select ... from cases ... where cases.person_id = " + selected_person_id;
 list_cases.SetSQLStatement(sql);
 list_cases.RefreshDataSet();
 */

 sql = "select consents.signature_date, consent_types.item, consents.note, "
       "groups.item, event_name_types.item event_name, "
       "consents.current_id, consents.id "
       "from consents, consent_types, participations, events, groups, event_name_types "
       "where consents.consent_id = consent_types.id and "
       "consents.participations_id = participations.id and "
       "participations.event_id = events.id and "
       "events.event_name_id = event_name_types.id and "
       "consents.group_id = groups.id and "
       "consents.person_id = " + selected_person_id;
 if (selected_person_id != "0")
  list_consents.SetSQLStatement(sql);
 else
  list_consents.SetSQLStatement("");
 list_consents.RefreshDataSet();

 sql = "select ins_co.name ins_name, insurance_types.item, insurance_policies.policy_number, insurance_policies.group_number, "
       "area_types.item area_item, insurance_benefits.note, "
       "insurance_policies.start_date, insurance_policies.stop_date, coverage_types.item, "
       "source_types.item, insurance_policies.name_on_policy, pcp.name pcp_name, insurance_coverage.person_code, "
       "insurance_coverage.name_on_card, insurance_coverage.current_id, insurance_coverage.id "
       "from insurance_coverage "
       "left join insurance_policies on insurance_policies.id = insurance_coverage.insurance_policy_id "
       "left join coverage_types on coverage_types.id = insurance_policies.coverage_id "
       "left join source_types on source_types.id = insurance_policies.source_id "
       "left join insurance_benefits on insurance_policies.id = insurance_benefits.insurance_policy_id "
       "left join area_types on area_types.id = insurance_benefits.area_id "
       "left join tax_entities ins_co on ins_co.id = insurance_policies.tax_entity_id "
       "left join insurance_types on insurance_types.id = insurance_policies.insurance_id "
       "left join tax_entities pcp on pcp.id = insurance_coverage.tax_entity_id "
       "where insurance_coverage.person_id = " + selected_person_id;
 if (selected_person_id != "0")
  list_insurances.SetSQLStatement(sql);
 else
  list_insurances.SetSQLStatement("");
 list_insurances.RefreshDataSet();

 // TODO -c SYNC : stolen directly from recordPerson, keep them in sync or move them elsewhere (I'd prefer the "elsewhere" solution)
 // TODO -c TIME : unnecessary sorting removed here, not yet in recordPerson
 string where = "";
 sql = "select cast(person_notes.last_update_stamp as date) some_date, "
       "person_notes.note, warning_types.item warn_item, groups.item group_item, person_notes.current_id, person_notes.id "
       "from person_notes "
       "inner join groups on groups.id = person_notes.group_id "
       "inner join warning_types on warning_types.id = person_notes.warning_id "
       "where person_notes.person_id = '" + selected_person_id + "' and "
       "person_notes.group_id = '" + current_groupid + "' ";

 // jhaley 20101229: The warns/blocks visible here are now based on the user's group and not their permissions. Should
 // this prove to be unsatisfactory for whatever reason, we'll come up with something fancier. I am saving the below
 // in case it should be useful if/when the time comes. Although I think it can be done better using GetGroupPermissions.
 /*
 if (optionsPermissions["table.person_notes.common"]["view"] == "true")
  where += "person_notes.group_id = 0 or ";
 if (optionsPermissions["table.person_notes.diab"]["view"] == "true")
  where += "person_notes.group_id = " + lookupTables->IdOf("groups", "Diabetes") + " or ";
 if (optionsPermissions["table.person_notes.beh"]["view"] == "true")
  where += "person_notes.group_id = " + lookupTables->IdOf("groups", "Behavioral Health") + " or ";
 if (optionsPermissions["table.person_notes.com"]["view"] == "true")
  where += "person_notes.group_id = " + lookupTables->IdOf("groups", "Community Health") + " or ";
 if (optionsPermissions["table.person_notes.pub"]["view"] == "true")
  where += "person_notes.group_id = " + lookupTables->IdOf("groups", "Public Health") + " or ";
 if (optionsPermissions["table.person_notes.lac"]["view"] == "true")
  where += "person_notes.group_id = " + lookupTables->IdOf("groups", "Little Axe Clinic") + " or ";
 if (optionsPermissions["table.person_notes.cob"]["view"] == "true")
  where += "person_notes.group_id = " + lookupTables->IdOf("groups", "Contract Health") + " or ";
 if (optionsPermissions["table.person_notes.den"]["view"] == "true")
  where += "person_notes.group_id = " + lookupTables->IdOf("groups", "Dental Clinic") + " or ";
 if (where != "")
  sql += "(" + where.substr(0, where.length()-3) + ") and ";
 */

 if (selected_person_id != "0")
   list_notes.SetSQLStatement(sql);
 else
   list_notes.SetSQLStatement("");
 list_notes.RefreshDataSet();

 // jhaley: Refresh the overview lists as well, and do it after all the above so that we pull in the fresh data.
 RefreshOverviews();
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::RefreshServiceProviderId ()
{
 if (selected_service_provider_id == "" || !IsInt(selected_service_provider_id))
 {
  selected_service_provider_id = "0";
  SetApptContractsLinkText();
 }
 string sql;

 atlas->CancelRequest(request_service_provider_id);
 atlas->CancelRequest(request_services_provided_provider_id);

 request_service_provider_id = atlas->RequestNotificationWhen("tax_entities.id", selected_service_provider_id, rel_e,
   as_int, this, RefreshHandler(&(TformWizardNewContractHealthItem::AtlasNotification)));
 request_services_provided_provider_id = atlas->RequestNotificationWhen("services_provided.tax_entity_id",
   selected_service_provider_id, rel_e, as_int, this, RefreshHandler(&(TformWizardNewContractHealthItem::AtlasNotification)));

 CreateLink(staticServiceProvider, buttonSearchServiceProvider, this, selected_service_provider_id, "tax_entities", "", true);

 sql = "select service_types.item, area_types.item, services_provided.current_id, services_provided.id "
       "from services_provided "
       "inner join service_types on service_types.id = services_provided.service_id "
       "inner join area_types on area_types.id = services_provided.area_id "
       "where services_provided.tax_entity_id = " + selected_service_provider_id;
 if (selected_service_provider_id != "0")
 {
  list_services.SetSQLStatement(sql);
  list_services.SetAddEdit(this, AddRecord (&(TformWizardNewContractHealthItem::AddService)),
                                 EditRecord(&(TformWizardNewContractHealthItem::EditService)));
  list_services.ForceRefreshDataSet();
  if (listServices->Items->Count)
   listServices->Items->Item[0]->Selected = true;
 }
 else
 {
  list_services.SetSQLStatement("");
  list_services.SetAddEdit(this, NULL, EditRecord(&(TformWizardNewContractHealthItem::EditService))); // doesn't matter, no data anyway!
 }
 list_services.RefreshDataSet();
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::RefreshReferrerId ()
{
 if (selected_referrer_id == "" || !IsInt(selected_referrer_id))
  selected_referrer_id = "0";
 string sql;

 atlas->CancelRequest(request_referrer_id);
 request_referrer_id = atlas->RequestNotificationWhen("tax_entities.id", selected_referrer_id, rel_e, as_int, this,
   RefreshHandler(&(TformWizardNewContractHealthItem::AtlasNotification)));

 CreateLink(staticReferrer, buttonSearchReferrer, this, selected_referrer_id, "tax_entities", "", true);
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::RefreshEventDate ()
{
 // hope they can't refresh person_id without -also- refreshing the date? otherwise need to link the two together
 //  (call this from refreshpersonid)
 // use event_date and selected_person_id together.
 // TODO: set event_date in appropriate pages ... do we need two? (visit vs. appointment? wait, do we ever ask both?
 //  no? hope not.)
 // TODO: SetupPage, ProcessPage, etc. for wherever dupes are processed
 // TODO: handle warnings/blocks on that page too (these changes sorta go together)
 string sql;

 // extend the search just a tad
 string between_clause = "between '" + (event_date - 1).OutDate(global_mode) + "' and '" + (event_date + 1).OutDate(global_mode) + "'";

 if (!IsInt(selected_person_id))
  PSay("selected_person_id is not a valid integer, will cause query to fail.", m_debug, MB_OK, selected_person_id);

 if (event_date.IsValidDate())
 {
  sql = "select person_names.last_name || ', ' || person_names.first_name, "
        "tasks.date_of_task, appointments.begin_date, appointments.appointment_time, "
        "tasks.cob_number, service_types.item, tasks.task_comments, tasks.visit_comments, "
        "tasks.preconditions_note, tasks.followup_note, tasks.reported_by_note, "
        "tasks.hospitalized, tasks.given_room, tasks.current_id, tasks.id "
        "from cob_tasks tasks "
        "inner join people on tasks.person_id = people.id "
        "inner join person_names on person_names.id = people.person_names_id "
        "inner join services_provided on tasks.services_provided_id = services_provided.id "
        "inner join service_types on services_provided.service_id = service_types.id "
        "left join appointments on appointments.id = (select max(appointments.id) from appointments where appointments.task_id = tasks.id and appointments.current_id >= 3) "
        "where "                                     // TODO -c HACK: above: getting max(id) from appointments, Philip says, is a hack.  He wrote it, so I believe him!
        "tasks.person_id = " + selected_person_id + " and "
        "(tasks.date_of_task " + between_clause + " or "
        "appointments.begin_date " + between_clause + ")";

  if (selected_cob_id != "0" && selected_cob_id != "")
  {
   if (!IsInt(selected_cob_id))
    PSay("selected_cob_id is not a valid integer, but isn't blank, will cause query to fail.", m_debug, MB_OK, selected_cob_id);

   sql += " and tasks.id != " + selected_cob_id;
  }

  list_dupe_cobs.SetSQLStatement(sql);
 } else
  list_dupe_cobs.SetSQLStatement("");
 list_dupe_cobs.RefreshDataSet();

 if (event_date.IsValidDate())
 {
  sql = "select person_names.last_name || ', ' || person_names.first_name, "
        "tax_entities.name, "
        "tasks.date_of_task, appointments.begin_date, appointments.appointment_time, "
        "tasks.task_comments, tasks.current_id, tasks.id "
        "from tasks "
        "left join people on tasks.person_id = people.id "
        "left join tax_entities on tasks.tax_entity_id = tax_entities.id "
        "left join person_names on people.person_names_id = person_names.id "
        "left join appointments on appointments.id = (select max(appointments.id) from appointments where appointments.task_id = tasks.id) "
        "where "
        "tasks.person_id = " + selected_person_id + " and "
        "tasks.date_of_task " + between_clause;

  list_dupe_visits.SetSQLStatement(sql);
 } else
  list_dupe_visits.SetSQLStatement("");
 list_dupe_visits.RefreshDataSet();

 if (event_date.IsValidDate())
 {
  sql = "select person_names.last_name || ', ' || person_names.first_name, "
        "bills.bill_date, actual_entity.name, provider_entity.name, "
        "facility_entity.name, group_entity.name, insurance_entity.name, "
        "bills.invoice_number, purchase_reqs.purchase_req_number, "
        "checks.check_number, bills.invoice_amount, bill_types.item, "
        "bills.current_id, bills.id "
        "from bills inner join tasks on bills.task_id = tasks.id "
        "inner join people on tasks.person_id = people.id "
        "inner join person_names on person_names.id = people.person_names_id "
        "inner join insurance_coverage on bills.insurance_coverage_id = insurance_coverage.id "
        "inner join tax_entities insurance_entity on insurance_coverage.tax_entity_id = insurance_entity.id "
        "inner join tax_entities actual_entity on bills.actual_tax_id = actual_entity.id "
        "inner join tax_entities provider_entity on bills.provider_tax_id = provider_entity.id "
        "inner join tax_entities facility_entity on bills.facility_tax_id = facility_entity.id "
        "inner join tax_entities group_entity on bills.group_tax_id = group_entity.id "
        "inner join purchase_reqs on bills.purchase_req_id = purchase_reqs.id "
        "inner join checks on purchase_reqs.check_id = checks.id "
        "inner join bill_types on bills.bill_id = bill_types.id "
        "and bill_types.id in (" + lookupTables->IdOf("bill_types", "Incoming Vendor Bill") + ", " + lookupTables->IdOf("bill_types", "Incoming Provider Bill") + ") "
        "where "
        "bills.bill_date " + between_clause + " and "
        "tasks.person_id = " + selected_person_id;

  list_dupe_bills.SetSQLStatement(sql);
 } else
  list_dupe_bills.SetSQLStatement("");
 list_dupe_bills.RefreshDataSet();
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::RefreshTotals ()
{
 sum_procedure_charges   = financial(0.00);
 sum_procedure_residuals = financial(0.00);
 sum_procedure_allowed   = financial(0.00);
 sum_procedure_payments  = financial(0.00);
 sum_bill_charges        = financial(0.00);
 sum_bill_residuals      = financial(0.00);

 financial_adder adding_machine;

 sum_procedure_charges   = (list_procedures.get_column_sum("procedure_charges", adding_machine.reset())).local_sum;
 sum_procedure_residuals = (list_procedures.get_column_sum("procedure_residuals", adding_machine.reset())).local_sum;
 sum_procedure_allowed   = (list_procedures.get_column_sum("procedure_allowed", adding_machine.reset())).local_sum;
 sum_procedure_payments  = (list_procedures.get_column_sum("procedure_payment", adding_machine.reset())).local_sum;

 // DONE: show as empty those that are actually going to be NULL in the db, rather than as $0.00 ?

 // bill
 bool is_charges = (editOriginalCharges->Text != "");
 bool is_residuals = (editResidualCharges->Text != "");
 sum_bill_charges   = StringToFinancial(editOriginalCharges->Text.c_str());
 sum_bill_residuals = StringToFinancial(editResidualCharges->Text.c_str());
 labelHelperBillOriginalCharges->Caption = is_charges ? ("$ " + FinancialToString(sum_bill_charges, true)).c_str() : "(blank)";
 labelHelperBillResidualCharges->Caption = is_residuals ? ("$ " + FinancialToString(sum_bill_residuals, true)).c_str() : "(blank)";
 CreateLink(staticHelperPayTo, NULL, this, selected_actual_id, "tax_entities", "", true);

 // procedures
 labelHelperProcedureOriginalCharges->Caption = ("$ " + FinancialToString(sum_procedure_charges, true)).c_str();
 labelHelperProcedureResidualCharges->Caption = ("$ " + FinancialToString(sum_procedure_residuals, true)).c_str();
 labelHelperProcedureAllowed->Caption = ("$ " + FinancialToString(sum_procedure_allowed, true)).c_str();
 labelHelperProcedurePayment->Caption = ("$ " + FinancialToString(sum_procedure_payments, true)).c_str();

 // transactions
 financial total_bill_payment = tx_result_bill.GetEntityPayment(selected_actual_id);
 labelHelperTransactionPayment->Caption = ("$ " + FinancialToString(total_bill_payment, true)).c_str();

 // setup controls just right, alright?

 list<TWinControl *> temp;
 temp.push_back(panelHelperBillSummary);
 temp.push_back(panelHelperBillOriginalCharges);
 temp.push_back(panelHelperBillResidualCharges);
 temp.push_back(panelHelperBillPayTo);
 temp.push_back(panelHelperProcedureSummary);
 temp.push_back(panelHelperProcedureOriginalCharges);
 if (radioIsUB->Checked || radioIsOther->Checked)
  temp.push_back(panelHelperProcedureResidualCharges);
 temp.push_back(panelHelperProcedureAllowed);
 temp.push_back(panelHelperProcedurePayment);
 temp.push_back(panelHelperTransactionSummary);
 temp.push_back(panelHelperTransactionPayment);
 SetupControlsForInline (panelPaymentHelper, temp);
 panelPaymentHelperResize(panelPaymentHelper);
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::AtlasNotification (int request_num, string matched_value)
{
 if (request_num == request_case_entity_id)
 {
  RefreshCaseEntityId();
 }
 else if (request_num == request_out_referrer_id)
 {
  RefreshOutReferrerId();
 }
 else if (request_num == request_cob_id)
 {
  RefreshCobId();
 }
 else if (request_num == request_provider_id)
 {
  RefreshProviderId();
 }
 else if (request_num == request_facility_id)
 {
  RefreshFacilityId();
 }
 else if (request_num == request_group_id)
 {
  RefreshGroupId();
 }
 else if (request_num == request_person_id)
 {
  RefreshPersonId();
  RefreshEventDate();
 }
 else if (request_num == request_service_provider_id)
 {
  RefreshServiceProviderId();
 }
 else if (request_num == request_referrer_id)
 {
  RefreshReferrerId();
 }
 else if (request_num == request_cobs_person_id)        // ... now the ones about -just- a listview
 {
  list_cobs.RefreshDataSet();
 }
 else if (request_num == request_cases_person_id)
 {
  list_cases.RefreshDataSet();
 }
 else if (request_num == request_services_provided_provider_id)
 {
  list_services.RefreshDataSet();
 }
 else if (request_num == request_consents_person_id)
 {
  list_consents.RefreshDataSet();
 }
 else if (request_num == request_insurance_person_id)
 {
  list_insurances.RefreshDataSet();
 }
 else if (request_num == request_notes_person_id)
 {
  list_notes.RefreshDataSet();
 }
 else if (request_num == request_referrers_is_referrer)
 {
  list_referrers.RefreshDataSet();
 }
}
//---------------------------------------------------------------------------
bool TformWizardNewContractHealthItem::IsValidPage (int page_index)
{
 switch (page_index)
 {
  case 0: // creating a new bill (maybe decide to create a COB)
  {
   // selected_cob_id = "0";
   if (!radioCOBCreate->Checked)
   {
    // if selecting a COB, make sure one is selected (record ID), and ... [warn for other bills, etc.?]
    if (radioCOBSelect->Checked)
    {
     selected_cob_id = list_cobs.GetSelectedRecordID();
     if (selected_cob_id == "" || !IsInt(selected_cob_id) || StringToInt(selected_cob_id) == 0)
     {
      PSay ("You must select a COB, Non-Referral, or ER/72-hour Notice from the list to continue.", m_missing_data, MB_OK);
      return false;
     }
    }

    // selecting a cob directly (seems simple enough, but more irritating, likely)
    // if selecting a COB number, make sure it exists (and record ID)
    if (radioCOBKnown->Checked ||
        radioCOBSearch->Checked)
    {
     if (selected_cob_id == "" || !IsInt(selected_cob_id) || StringToInt(selected_cob_id) == 0)
     {
      PSay("Please select a COB via the COB-search button provided, \n"
           "or by entering a number and pressing '>', \n"
           "or the option of your choice.", m_missing_data, MB_OK);
      return false;
     }
    }

    /* TODO: look at cob, see if we don't like it
             other visits
             other bills */
    string sql_count_tasks = "select count(tasks.id) from tasks where tasks.parent_task_id = " + selected_cob_id;
    string sql_count_bills = "select count(bills.id) from tasks inner join bills on bills.task_id = tasks.id where tasks.parent_task_id = " + selected_cob_id;

    string count_tasks;
    string count_bills;
    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    try
    {
     StdTransaction(dbTransaction, dbDatabase);
     count_tasks = GetOneField(dbTransaction, sql_count_tasks);
     count_bills = GetOneField(dbTransaction, sql_count_bills);
     dbTransaction->Commit();
     delete dbTransaction;
    } catch (...)
    {
     delete dbTransaction;
     PSay ("Failed to look up visit and bill information for this COB.", m_database_error, MB_OK);
     return false;
    }

    int int_count_tasks = StringToInt(count_tasks);
    int int_count_bills = StringToInt(count_bills);

    if (int_count_tasks || int_count_bills)
    {
     if (IDNO == PSay("This COB already has " + count_tasks + " visits, and " + count_bills + " bills attached.\n"
                      "Are you sure you wish to continue anyway?", m_confirmation, MB_YESNO))
      return false;
    }

    // this will set selected_person_id and call RefreshPersonId() automatically for us -- ain't it grand?
    // note: this likely has repercussions involving the use of transactions ... at the end, we should probably
    // pull person_id from the COB again, just in case something changed magically behind our backs, rather than
    // use the unreliable selected_person_id thing.

    // this refresh seems slightly trivial, though it updates the link for cob ... which isn't a -bad- thing, precisely. grr.
    RefreshCobId();

   }
   else
   {
    // if creating a COB ... nothing to check yet? (dupes)
    //      .. we'll ask them to select a patient here, make SURE they don't see what they want, then use that.
    //      .. that way, we get two birdies with the same stone. poor birdies. poor stone.
    if (selected_person_id == "" || !IsInt(selected_person_id) || StringToInt(selected_person_id) == 0)
    {
     PSay("Please specify the patient for whom you're creating the bill.\n"
          "Also, please make sure that the COB doesn't already exist somewhere in the list above.",
          m_missing_data, MB_OK);
     return false;
    }
   }
   // return true;
   break;
  }
  case 1: // eligibility screen (maybe decide to create an MVA)
  {
   // notes all checked off, permission to proceed for blocks?
   vector<map<string, string> > all_notes = list_notes.GetAllData(true);
   vector<string> all_checked_notes = list_notes.GetMultiID();
   sort (all_checked_notes.begin(), all_checked_notes.end());

   unsigned int count_warnings = 0;
   unsigned int count_blocks = 0;
   unsigned int count_checked_warnings = 0;
   unsigned int count_checked_blocks = 0;

   bool can_override = (optionsPermissions["special.note_block_override"]["enabled"] == "true");

   for (vector<map<string, string> >::iterator i_note = all_notes.begin(); i_note != all_notes.end(); i_note++)
   {
    string id_field = (*i_note)["id"];
    string type_field = (*i_note)["warn_item"];
    bool is_warn  = (lookupTables->IdOf("warning_types", type_field) == lookupTables->IdOf("warning_types", "Warn"));
    bool is_block = (lookupTables->IdOf("warning_types", type_field) == lookupTables->IdOf("warning_types", "Block"));
    if (is_warn)
     count_warnings++;
    else if (is_block)
     count_blocks++;
    if (binary_search(all_checked_notes.begin(), all_checked_notes.end(), id_field))
    {
     if (is_warn)
      count_checked_warnings++;
     else if (is_block)
      count_checked_blocks++;
    }
   }

   if (!can_override && count_blocks)
   {
    // can't override the blocks
    BlockOverrideErrorMessage(); // jhaley - use new common routine
    pageEligibility->ActivePage = sheetNotes;
    return false;
   }
   else if (count_warnings - count_checked_warnings || count_blocks - count_checked_blocks)
   {
    // you forgot to check stuff
    PSay("You have not checked off all notes bearing a warning level of some sort.\n"
         "You must do so before continuing to indicate you have read all of them, and wish to override them all.",
         m_missing_data, MB_OK);
    pageEligibility->ActivePage = sheetNotes;
    return false;
   }
   else if (count_blocks)
   {
    // you checked, but still must confirm message box
    if (IDNO == PSay("Are you sure you wish to override these 'block' notes?", m_confirmation, MB_YESNO))
     return false;
   }

   // TODO: make sure they have a recent consent
   // "Consent for [treatment, ]release of information and assignment of benefits" within the past 6 months?
   Pdate six_months_ago = Pdate(Date());
   six_months_ago.mod(-6, in_months);
   vector<string> c_id;
   c_id.push_back(lookupTables->IdOf("consent_types", "Consent for release of information and assignment of benefits"));
   c_id.push_back(lookupTables->IdOf("consent_types", "Consent for treatment, release of information, and assignment of benefits"));
   string sql;
   sql = "select count(*) from consents"
         " where person_id = " + selected_person_id +
         " and consent_id in (" + VecToCommaString(c_id) + ") "
         " and signature_date > '" + six_months_ago.OutDate(global_mode) + "'"
         " and current_id > 2";
   string ans;
   ans = GetOneField(dbDatabase, sql);
   if (!IsInt(ans) || StringToInt(ans) < 1)
   {
    string message = "This person does not have a valid, recent (last 6 months) consent of type:\n";
    for (unsigned int i = 0; i < c_id.size(); i++)
      message += ("\"" + lookupTables->ValueOf("consent_types", c_id[i]) + "\"\n");
    message += "\nAre you sure you want to continue anyway?";
    if (IDNO == PSay(message, m_confirmation, MB_YESNO))
    {
     pageEligibility->ActivePage = sheetConsents;
     return false;
    }
   }
   // if selecting a case, make sure one is selected (record ID)
   if (radioCaseSelect->Checked)
   {
    selected_case_id = list_cases.GetSelectedRecordID();
    if (selected_case_id == "" || !IsInt(selected_case_id) || StringToInt(selected_case_id) == 0)
    {
     PSay ("You must select a case from the list to continue.", m_missing_data, MB_OK);
     return false;
    }
   }
   // if creating a case ... nothing to check yet? (dupes)
   // return true;
   break;
  }
  case 2: // create a new MVA
  {
   // TODO: type of case (combo)

   // date/reason (at least one?)
   if (editCaseDescription->Text == "")
   {
    if (IDNO == PSay("You have not entered a description for this case.\n"
                     "Are you sure you want to continue?", m_missing_data, MB_YESNO))
     return false;
   }

   // valid dates
   if (editCaseAccidentDate->Text != "" && !Pdate(editCaseAccidentDate->Text.c_str(),global_mode).IsValidDate())
   {
    PSay ("Please enter a valid accident date.", m_invalid_data, MB_OK);
    return false;
   }

   if (editCaseReportDate->Text != "" && !Pdate(editCaseReportDate->Text.c_str(),global_mode).IsValidDate())
   {
    PSay ("Please enter a valid report date.", m_invalid_data, MB_OK);
    return false;
   }

   if (editCaseSubrogationDate->Text != "" && !Pdate(editCaseSubrogationDate->Text.c_str(),global_mode).IsValidDate())
   {
    PSay ("Please enter a valid subrogation agreement date.", m_invalid_data, MB_OK);
    return false;
   }

   // dates in order (accident <= report <= subrogation)
   if (editCaseAccidentDate->Text != "" &&
       editCaseReportDate->Text != "" &&
       Pdate(editCaseAccidentDate->Text.c_str(),global_mode) >
       Pdate(editCaseReportDate->Text.c_str(),global_mode))
   {
    PSay ("Please enter accident and report dates such that the accident does not come after the report of the accident.", m_invalid_data, MB_OK);
    return false;
   }

   if (editCaseReportDate->Text != "" &&
       editCaseSubrogationDate->Text != "" &&
       Pdate(editCaseReportDate->Text.c_str(),global_mode) >
       Pdate(editCaseSubrogationDate->Text.c_str(),global_mode))
   {
    PSay ("Please enter report and subrogation dates such that the report does not come after the subrogation agreement.", m_invalid_data, MB_OK);
    return false;
   }

   if (editCaseAccidentDate->Text != "" &&
       editCaseSubrogationDate->Text != "" &&
       Pdate(editCaseAccidentDate->Text.c_str(),global_mode) >
       Pdate(editCaseSubrogationDate->Text.c_str(),global_mode))
   {
    PSay ("Please enter accident and subrogation dates such that the accident does not come after the subrogation agreement.", m_invalid_data, MB_OK);
    return false;
   }

   // warn if no entities involved?
   vector<map<string, string> > temp_case_entities;
   list_case_entities.export_data(temp_case_entities);
   if (temp_case_entities.empty())
   {
    if (IDNO == PSay("You have not added any entities to this case.\nAre you sure you want to continue?", m_missing_data, MB_YESNO))
     return false;
   }

   // return true;
   break;
  }
  case 3: // bill information (providers, type of bill)
  {
   // make sure there's an entity selected where the radio thing is
   // make sure the selected entity has a Tax ID, warn otherwise? // DONE: disabled for now, too irritating
   if (radioPayProvider->Checked)
   {
    if (selected_provider_id == "0")
    {
     PSay("Please select a provider to pay.", m_missing_data, MB_OK);
     return false;
    }
    else
    {
     string provider_tax_id =
       GetOneField(dbDatabase,
         "select tin.identifier "
         "from tax_entities "
         "left join entity_ids tin on tin.tax_entity_id = tax_entities.id and "
         "  tin.current_id >= 3 and tin.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "TIN/EIN") + "' "
         "where tax_entities.id = " + selected_provider_id);
     if (provider_tax_id.empty() || provider_tax_id.length() != 9 || provider_tax_id.find_first_not_of("9") == string::npos)
     {
      if (IDNO == PSay(string(staticTaxProvider->Caption.c_str()) +
                       ":\nThis provider does not seem to have a valid federal Tax ID number.\n"
                       "If you can, please find out what it is, and have it entered.\n"
                       "Do you want to continue anyway?", m_missing_data, MB_YESNO))
       return false;
     }
    }
   }
   else if (radioPayFacility->Checked)
   {
    if (selected_facility_id == "0")
    {
     PSay("Please select a facility to pay.", m_missing_data, MB_OK);
     return false;
    }
    else
    {
     string facility_tax_id =
       GetOneField(dbDatabase,
         "select tin.identifier "
         "from tax_entities "
         "left join entity_ids tin on tin.tax_entity_id = tax_entities.id and tin.current_id >= 3 "
         "  and tin.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "TIN/EIN") + "' "
         "where tax_entities.id = " + selected_facility_id);
     if (facility_tax_id.empty() || facility_tax_id.length() != 9 || facility_tax_id.find_first_not_of("9") == string::npos)
     {
      if (IDNO == PSay(string(staticTaxFacility->Caption.c_str()) +
                       ":\nThis facility does not seem to have a valid federal Tax ID number.\n"
                       "If you can, please find out what it is, and have it entered.\n"
                       "Do you want to continue anyway?", m_missing_data, MB_YESNO))
       return false;
     }
    }
   } else
   if (radioPayGroup->Checked)
   {
    if (selected_group_id == "0")
    {
     PSay("Please select a group to pay.", m_missing_data, MB_OK);
     return false;
    }
    else
    {
     string group_tax_id =
       GetOneField(dbDatabase,
         "select tin.identifier "
         "from tax_entities "
         "left join entity_ids tin on tin.tax_entity_id = tax_entities.id and tin.current_id >= 3 "
         "  and tin.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "TIN/EIN") + "' "
         "where tax_entities.id = " + selected_group_id);
     if (group_tax_id.empty() || group_tax_id.length() != 9 || group_tax_id.find_first_not_of("9") == string::npos)
     {
      if (IDNO == PSay(string(staticTaxGroup->Caption.c_str()) +
                       ":\nThis group does not seem to have a valid federal Tax ID number.\n"
                       "If you can, please find out what it is, and have it entered.\n"
                       "Do you want to continue anyway?", m_missing_data, MB_YESNO))
       return false;
     }
    }
   }
   else
   {
    PSay("Please select an entity to pay.", m_missing_data, MB_OK);
    return false;
   }

   // charges, valid
   // at least residual charges, original are less important
   // charges -- in order (original => residual)
   if (editOriginalCharges->Text != "" &&
       !IsAmount(editOriginalCharges->Text.c_str()))
   {
    PSay("Please enter a valid amount for the original charges.", m_invalid_data, MB_OK);
    return false;
   }

   if (editResidualCharges->Text != "" &&
       !IsAmount(editResidualCharges->Text.c_str()))
   {
    PSay("Please enter a valid amount for the residual charges.", m_invalid_data, MB_OK);
    return false;
   }

   if (editOriginalCharges->Text != "" &&
       editResidualCharges->Text != "" &&
       StringToFinancial(editOriginalCharges->Text.c_str()) < StringToFinancial(editResidualCharges->Text.c_str()))
   {
    PSay("Please enter original and residual charges such that residual charges are not greater than original charges.", m_invalid_data, MB_OK);
    return false;
   }

   if (StringToFinancial(editOriginalCharges->Text.c_str()) < financial(0.00) ||
       StringToFinancial(editResidualCharges->Text.c_str()) < financial(0.00))
   {
    PSay("You may not enter any negative dollar amounts.", m_invalid_data, MB_OK);
    return false;
   }

   // return true;
   break;
  }
  case 4: // conditions
  {
   if (listConditions->Items->Count == 0)
    if (IDNO == PSay("You have not entered any diagnosed/treated conditions.\n"
                     "Are you sure you want to continue anyway?", m_missing_data, MB_YESNO))
     return false;
   // return true;
   break;
  }
  case 5: // procedures
  {
   // TODO: diagnosis-to-condition links might be verified here ...
   if (listProcedures->Items->Count == 0)
   {
    if (IDNO == PSay("You have not entered any procedures.\n"
                     "No procedures means no procedure charges, which will be reflected on the justification page(s) "
                     "of any PRs involved.  Are you sure you want to proceed?", m_missing_data, MB_YESNO))
     return false;
   }
   break;
  }
  case 6: // bill transactions (and modifying COB transactions)
  {
   // don't pay several people, make sure we're paying the entity indicated on the bill
   if (tx_result_cob.GetCountEntitiesOut() > 1)
   {
    PSay("You are not currently allowed to obligate money to multiple entities at the same time on a COB.\n"
         "This includes any entity for which moneys have been expensed, are payable, or cash has been paid.",
         m_invalid_data, MB_OK);
    return false;
   }

   if (tx_result_bill.GetCountEntitiesOut() > 1)
   {
    PSay("You are not currently allowed to pay multiple entities at the same time on a bill.\n"
         "This includes any entity for which moneys have been expensed, are payable, or cash has been paid.",
         m_invalid_data, MB_OK);
    return false;
   }

   financial total_bill_payment  = tx_result_bill.GetEntityPayment(selected_actual_id); // set by ProcessPage somewhere
   // financial total_cob_payment = tx_result_cob.GetEntityPayment(/* TODO: */ "");

   // make'em blink
/*
   if (sum_procedure_payments < financial(0.01))
   {
    PSay(string("You have not indicated that you intend to pay for any of the procedures performed.\n"
         "At least one payment amount is now required to proceed."), m_confirmation, MB_OK);
    return false;
   }
*/

   if (editResidualCharges->Text != "" && total_bill_payment != sum_bill_residuals && sum_procedure_payments < financial(0.01))
    if (IDNO == PSay(string("Your payment amount does not exactly match the residual amount indicated on the bill itself.\n"
                     "Please double-check the numbers using the helper window on the right.\n"
                     "Would you like to continue anyway?"), m_confirmation, MB_YESNO))
     return false;

   if (sum_procedure_payments > financial(0.00) && total_bill_payment != sum_procedure_payments)
    if (IDNO == PSay(string("Your payment amount does not exactly match the sum of the payment amounts indicated per-procedure.\n"
                     "Please double-check the numbers using the helper window on the right.\n"
                     "Would you like to continue anyway?"), m_confirmation, MB_YESNO))
     return false;

   if (total_bill_payment < financial(0.01))
    if (IDNO == PSay(string("You have indicated that no moneys have been, nor are to be, paid to the provider/bill/facility/whatever.\n"
                     "This is valid only in extremely rare cases.\n"
                     "Press the 'Change' button to fix this.\n"
                     "Are you sure you want to continue?"), m_confirmation, MB_YESNO))
     return false;

   // TODO: warn if they leave COB obligated? (don't prevent!)
/*
   if (total_cob_payment != financial(0.00))
    if (IDNO == PSay(string("Your payment of $" + FinancialToString(total_bill_payment, true) +
                     " does not match the expected payment of $"
                     + FinancialToString(StringToFinancial(editResidualCharges->Text.c_str()), true) +
                     " based on the residual charges amount given.\n"
                     "Are you sure you want to continue?"), m_confirmation, MB_YESNO))
     return false;
   if (total_bill_payment < 0.01)
    if (IDNO == PSay(string("You have indicated that no moneys have been, nor are to be, paid to the provider/bill/facility/whatever.\n"
                     "This is valid only in extremely rare cases.\n"
                     "Press the 'Change' button to fix this.\n"
                     "Are you sure you want to continue?"), m_confirmation, MB_YESNO))
     return false;
*/
   // return true;
   break;
  }
  case 7: // creating a new COB
  {
   // make sure someone is selected!
   if (selected_person_id == "0")
   {
    PSay ("Please select a patient receiving services.", m_missing_data, MB_OK);
    return false;
   }

   // if creating a COB because of a Bill, make sure names match -- automatic

   // make sure service is selected, record ID
   if (selected_service_provider_id == "0")
   {
    PSay ("Please select a provider rendering services.", m_missing_data, MB_OK);
    return false;
   }

   if (listServices->Selected)
   {
    selected_service_id = list_services.GetSelectedRecordID();
   } else
   {
    PSay ("Please select a service from this provider, or if there are none, create one and select it.", m_missing_data, MB_OK);
    return false;
   }

   // if creating a COB because of a Bill, ... non-ref only? -- later
   if (!radioNonReferral->Checked && start_page == 0)
   {
    if (IDNO == PSay ("You are attempting to create something other than a non-referral COB along with a provider bill.\n"
                      "Are you sure you want to do this?", m_invalid_data, MB_YESNO))
     return false;
   }
   // return true;
   break;
  }
  case 8: // incoming referral
  {
   // if searching for a provider, make sure one is selected, record ID
   if (radioReferrerSearch->Checked)
   {
    if (selected_referrer_id == "0")
    {
     PSay ("Please select a referring physician or facility via the search button.", m_missing_data, MB_OK);
     return false;
    }
   } else
   // if selecting a provider, make sure one is selected, record ID
   if (radioReferrerSelect->Checked)
   {
    if (listReferrers->Selected)
    {
     selected_referrer_id = list_referrers.GetSelectedRecordID();
     RefreshReferrerId();
    } else
    {
     PSay ("Please select a referring physician or facility from the list.", m_missing_data, MB_OK);
     return false;
    }
   }

   // return true;
   break;
  }
  case 9: // appointment information (date, time, reason)
  {
   // if creating bill, date not in the future?
   // TODO: should we even ask this for a bill-bound COB? who cares about the appointment if it's a non-referral?
   if (editApptReason->Text == "")
    if (IDNO == PSay("You have not entered a reason note for the appointment.\n"
                     "Are you sure you want to continue?", m_missing_data, MB_YESNO))
     return false;
   // return true;
   break;
  }
  case 10: // limit notes (standard text)
  {
   // warn if empty?
   if (editLimits->Text == "")
   {
    if (IDNO == PSay("Are you sure you want to continue without entering limit notes?", m_missing_data, MB_YESNO))
     return false;
   }
   // return true;
   break;
  }
  case 11: // hospitalization (preconditions, followups, room, etc.)
  {
   // warning copied from codeSpecialNewER
   if (editPreCond->Text == "" && editFollowup->Text == "" && editReportedBy->Text == "" &&
       checkWasHosp->Checked == false && checkWasRoom->Checked == false)
    if (IDNO == PSay("None of the information on this screen is currently required, but it is recommened\n"
                     "that a bit more information be entered. Are you really sure you didn't mean to say more?",
                     m_confirmation, MB_YESNO))
     return false;
   // return true;
   break;
  }
  case 12: // COB transactions
  {
   // not obligating to several people, make sure we obligate to the right person
   // if creating bill, let user skip this without warning if empty (not a problem)

   // DONE: do we really need to show this if creating a bill? i doubt it. -- we just won't.

   // don't pay several people, make sure we're paying the entity indicated on the bill
   if (tx_result_cob.GetCountEntitiesOut() > 1)
   {
    PSay("You are not currently allowed to obligate money to multiple entities at the same time on a COB.\n"
         "This includes any entity for which moneys have been expensed, are payable, or cash has been paid.",
         m_invalid_data, MB_OK);
    return false;
   }

   financial total_cob_payment  = tx_result_cob.GetEntityPayment(selected_service_provider_id);
   if (total_cob_payment < financial(0.01))
    if (IDNO == PSay(string("You have indicated that no moneys have been, nor are to be, paid to the service provider.\n"
                     "Press the 'Change' button to fix this.\n"
                     "Are you sure you want to continue?"), m_confirmation, MB_YESNO))
     return false;

   // return true;
   break;
  }
  case 13: // outgoing referrals
  {
   // eh ... nothing to check? at all?
   // return true;
   break;
  }
  case 14: // visit information (date, time, reason)
  {
   // comparison directly didn't seem to do the math properly? wtf?
   if (Pdate(dateVisitDate->Date) > Pdate(Date()))
    if (IDNO == PSay("The visit date given is in the future; it is unlikely we will receive a bill ahead of time.\n"
                     "Are you sure you want to continue?", m_invalid_data, MB_YESNO))
     return false;

   if (editVisitReason->Text == "")
    if (IDNO == PSay("You have not entered a reason note for the visit.\nAre you sure you want to continue?",
                     m_missing_data, MB_YESNO))
     return false;
   // return true;
   break;
  }
  case 15:
  {
   vector<string> problems_found;
   if (list_dupe_cobs.GetDatasetSize())
    problems_found.push_back("COBs");
   if (list_dupe_visits.GetDatasetSize())
    problems_found.push_back("visits");
   if (list_dupe_bills.GetDatasetSize())
    problems_found.push_back("bills");

   if (!problems_found.empty())
   {
    string bob;

    // a
    // a and b
    // a, b and c
    // a, b, c and d
    unsigned int s = problems_found.size();
    bob += problems_found[0];
    for (unsigned int i = 1; i < s - 1; i++)
     bob += ", " + problems_found[i];
    if (s > 1)
     bob += " and " + problems_found[s - 1];

    string explanation = "Based on patient and date information, duplicate " + bob + " have been found.\n"
                         "Having reviewed these possible duplicates, are you sure you want to continue anyway?";
    if (IDNO == PSay(explanation, m_confirmation, MB_YESNO))
     return false;
   }

   // HERE              
   // TODO -c MAGIC: tribe's name is here, should be in the db somewhere as an option accessible from random places
   // (particularly reports, header/footer stuff, etc.!)
   string tribe_name = "Absentee Shawnee Tribes of Oklahoma";
   string sql = "select (select result from is_enrolled(affiliations.id, '" + event_date.OutDate(global_mode)
     + "')) res from affiliations where person_id = " + selected_person_id
     + " and tribe_id = " + lookupTables->IdOf("tribe_types", tribe_name);
   vector<string> enrolled_yes_no;
   if (!SqlToVec(dbDatabase, sql, enrolled_yes_no))
   {
    PSay("Error while verifying tribal enrollment for a given date.", m_database_error, MB_OK);
    return false;
   }

   bool has_enroll = false;
   for (vector<string>::iterator i_enr = enrolled_yes_no.begin(); i_enr != enrolled_yes_no.end(); i_enr++)
    if (*i_enr == "1")
     has_enroll = true;

   if (!has_enroll)
    if (IDNO == PSay("As of " + event_date.OutDate(global_mode) + ", this person either:\n"
                     "a) Was not yet born, or\n"
                     "b) Was already dead, or\n"
                     "c) Was not actively enrolled with " + tribe_name + ".\n\n"
                     "Are you sure you want to continue?", m_invalid_data, MB_YESNO))
     return false;

   // return true;
   break;
  }
  default:
   PSay("IsValidPage() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return false;
 }

 // history:
 // I had routed all of them (via "break;") here so I could centralize the use of the warnings/blocks screen,
 // inserting things at random and checking them here. as you can see, uh, it's gone. and ... we could uncomment
 // all of those "return true;" statements above.
 return true;
}
//---------------------------------------------------------------------------
// true/false: we care to see this page (simplify WhereNext by coding this only once)
bool TformWizardNewContractHealthItem::SkipPage    (int page_index)
{
 // TODO: more optionsPermissions-based skipping of pages, if so (see below)
 //       - make sure this screen is usable (openable, finishable) only if all the absolute minimums are had
 //       - make sure the whole "FinishWizard" function verifies, for each chunk, the HistoryIncludes() function for it
 //         (and more as appropriate, incl. permissions themselves?)
 switch (page_index)
 {
  case 2: // create new mva
   if (!radioCaseCreate->Checked)
    return true;
   break;

  case 7: // new cob
   if (start_page == 0 && !radioCOBCreate->Checked)
    return true;
   break;

  case 8: // incoming referrals
   if (!radioCoordinationOfBenefits->Checked || (start_page == 0 && !radioCOBCreate->Checked))
    return true;
  case 13: // outgoing referrals (and incoming too)
   if (optionsPermissions["table.referrals"]["insert"] != "true")
    return true;
   break;

  case 10: // limits
   if (!radioCoordinationOfBenefits->Checked || start_page == 0)
    return true;
   break;

  case 9: // appointment info
   if (start_page == 0)
    return true;
   break;

  case 11: // ER info
   if (!radioEmergencyRoomNotice->Checked || (start_page == 0 && !radioCOBCreate->Checked))
    return true;
   break;

  case 14: // visit info
   if (start_page != 0)
    return true;
   break;
 }
 return false;
}
//---------------------------------------------------------------------------
int TformWizardNewContractHealthItem::WhereNext   (int page_index)
{
 // more work needed for cob, er, non-ref
 switch (page_index)
 {
  case 0: // creating a new bill (maybe decide to create a COB)
   return 7;
  case 1: // eligibility screen (maybe decide to create an MVA)
   return 2;
  case 2: // create a new MVA
   return 8;
  case 3: // bill information (providers, type of bill)
    return 4;
  case 4: // conditions
   return 5;
  case 5: // procedures
   return 6;
  case 6: // bill transactions (and modifying COB transactions)
   return TformWizardGeneric::last_wizard_page;
  case 7: // creating a new COB
   return 1;
  case 8: // incoming referral
   return 9;
  case 9: // appointment information (date, time, reason)
   return 14;
  case 10: // limit notes (standard text)
   return 11;
  case 11: // hospitalization (preconditions, followups, room, etc.)
   if (start_page == 0)
    return 3;
   else
    return 12;
  case 12: // COB transactions
   return 13;
  case 13: // outgoing referrals
   return TformWizardGeneric::last_wizard_page;
  case 14: // visit information, inserted before page '3'
   return 15;
  case 15: // dupe cobs, dupe bills (based on event_date + selected_person_id)
   return 10;
  default:
   return TformWizardGeneric::last_wizard_page;
 }
}
//---------------------------------------------------------------------------
bool TformWizardNewContractHealthItem::ProcessPage (int page_index)
{
 switch (page_index)
 {
  case 0: // creating a new bill (maybe decide to create a COB)
  {
   if (!radioCOBCreate->Checked)
   {
    string get_cob_transactions;
    string get_cob_tax_entity_id;

    get_cob_transactions  = "select * from transactions where transactions.task_id = " + selected_cob_id;
    get_cob_tax_entity_id =
      "select services_provided.tax_entity_id "
      "from services_provided "
      "inner join tasks on tasks.services_provided_id = services_provided.id "
      "where tasks.id = " + selected_cob_id;

    vector<map<string, string> > cob_transactions;
    if (!SqlToVecMap(dbDatabase, get_cob_transactions, cob_transactions))
    {
     PSay ("Failed to retrieve old transactions for this item.", m_database_error, MB_OK);
     return false;
    }

    default_result_cob_entity_id = GetOneField(dbDatabase, get_cob_tax_entity_id);

    tx_original_cob.RawInput(cob_transactions);
   } else
   {
    // just in case
    tx_original_cob = transaction_summary();
    selected_cob_id = "0";
    RefreshCobId();
   }

   return true;
  }
  case 1: // eligibility screen (maybe decide to create an MVA)
  case 2: // create a new MVA
   return true;
  case 3: // bill information (providers, type of bill)
  {
   if (radioPayProvider->Checked)
    selected_actual_id = selected_provider_id;
   else
   if (radioPayFacility->Checked)
    selected_actual_id = selected_facility_id;
   else
   if (radioPayGroup->Checked)
    selected_actual_id = selected_group_id;
   else
    selected_actual_id = "0";
   return true;
  }
  case 4: // conditions
  case 5: // procedures
   return true;
  case 6: // bill transactions (and modifying COB transactions)
  {
   if (last_offset_used)
   {
    Width -= last_offset_used;
    helper_window->Left -= last_offset_used;
   }

   return true;
  }
  case 7: // creating a new COB
  case 8: // incoming referral
   return true;
  case 9: // appointment information (date, time, reason)
   event_date = Pdate(dateApptDate->DateTime);
   RefreshEventDate();
   return true;
  case 10: // limit notes (standard text)
  case 11: // hospitalization (preconditions, followups, room, etc.)
  case 12: // COB transactions
   return true;
  case 13: // outgoing referrals
  {
   return true;
  }
  case 14: // visit information
   event_date = Pdate(dateVisitDate->DateTime);
   RefreshEventDate();
   return true;
  case 15:
   return true;
  default:
   PSay("ProcessPage() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return false;
 }
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::SetupPage   (int page_index)
{
 if (page_index == start_page) // if it was open, close it again at the beginning of the wizard
  helper_window->DrawerExpanded = false;
 if (page_index == 5 && !(helper_window->DrawerExpanded))
 {
  helper_window->DrawerExpanded = true;
  this->SetFocus();
 }

 last_offset_used = 0;

 switch (page_index)
 {
  case 0: // creating a new bill (maybe decide to create a COB)
  {
   // minimal permissions checking
   // TODO: should really be doing more permissions checking, ne?
   radioCOBCreate->Enabled = (optionsPermissions["table.tasks.cob"]["insert"] == "true");
   buttonSearchPatient2->Enabled = (optionsPermissions["table.tasks.cob"]["insert"] == "true");

   SwitchRadioSelection(radioCOBKnown);
   editCobNumber->Text    = "";

   // reset values and refresh
   selected_cob_id    = "0";
   selected_person_id = "0";
   RefreshCobId();
   RefreshPersonId(); // TODO -c TIME : not expected to be called indirectly in this case (for now?)
   return;
  }
  case 1: // eligibility screen (maybe decide to create an MVA)
  {
   pageEligibility->ActivePageIndex = 0;

   // find problems, display warnings.
   // RefreshChecklist();

   SwitchRadioSelection(radioCaseNone);

   // reset values and refresh
   selected_case_id = "0";
   // RefreshCaseId(); -- no such thing, not needed (doesn't affect any other controls)
   return;
  }
  case 2: // create a new MVA
  {
   // top portion
   comboCaseType->Text           = "";
   editCaseAccidentDate->Text    = "";
   editCaseDescription->Text     = "";
   editCaseReportDate->Text      = "";
   editCaseSubrogationDate->Text = "";

   // bottom portion
   list_case_entities.clear_data();
   chosen_case_entity_id     = "0";
   comboCaseEntityType->Text = "";
   RefreshCaseEntityId();
   return;
  }
  case 3: // bill information (providers, type of bill)
  {
   selected_provider_id = "0";
   selected_facility_id = "0";
   selected_group_id    = "0";
   selected_actual_id   = "0";

   // try to guess
   if (selected_cob_id != "0" && selected_cob_id != "")
   {
    selected_provider_id = GetOneField(dbDatabase,
      "select services_provided.tax_entity_id "
      "from services_provided "
      "inner join tasks on tasks.services_provided_id = services_provided.id "
      "where tasks.id = " + selected_cob_id);
    selected_actual_id = selected_provider_id;
   } else
   {
    selected_provider_id = selected_service_provider_id;
    selected_actual_id = selected_provider_id;
   }

   RefreshProviderId();
   RefreshFacilityId();
   RefreshGroupId();

   // note: if later we allowe actual_id to be set to a non-provider_id value, maybe we should select the one we set
   // it to, eh? just in case?
   SwitchRadioSelection(radioPayProvider);
   SwitchRadioSelection(radioIsHCFA);

   editOriginalCharges->Text = "";
   editResidualCharges->Text = "";
   editControlNumber->Text   = "";
   return;
  }
  case 4: // conditions
  {
   list_conditions.clear_data();
   editConditionIndex->Text = "";
   editConditionCode->Text  = "";

   // change who's visible, reorganize
   list<TWinControl *> temp;
   if (!radioIsUB->Checked)
    temp.push_back(panelConditionIndex);
   temp.push_back(panelConditionCode);
   if (radioIsHCFA->Checked)
    temp.push_back(panelConditionNote);
   SetupControlsForInline (scrollConditions, temp);
   scrollConditionsResize(scrollConditions);

   RefreshTotals();
   return;
  }
  case 5: // procedures
  {
   list_procedures.clear_data();
   editProcedureFrom->Text      = "";
   editProcedureTo->Text        = "";
   editProcedurePlace->Text     = "";
   editProcedureType->Text      = "";
   editProcedureCode->Text      = "";
   editProcedureMod->Text       = "";
   editProcedureDiagnosis->Text = "";
   editProcedureNote->Text      = "";
   editProcedureUnits->Text     = "";
   editProcedureCharges->Text   = "";
   editProcedureResiduals->Text = "";
   editProcedureAllowed->Text   = "";
   editProcedurePayment->Text   = "";
   editProcedureTooth->Text     = "";
   editProcedureSurface->Text   = "";
   editProcedureEPSDT->Text     = "";
   editProcedureEMG->Text       = "";
   editProcedureCOB->Text       = "";

   // change who's visible, reorganize
   list<TWinControl *> temp;
   if (radioIsHCFA->Checked)
   {
    temp.push_back(panelProcedureFrom);
    temp.push_back(panelProcedureTo);
    temp.push_back(panelProcedurePlace);
    temp.push_back(panelProcedureType);
    temp.push_back(panelProcedureCode);
    temp.push_back(panelProcedureMod);
    temp.push_back(panelProcedureDiagnosis);
    temp.push_back(panelProcedureCharges);
    temp.push_back(panelProcedureUnits);
    temp.push_back(panelProcedureAllowed);
    temp.push_back(panelProcedurePayment);
    temp.push_back(panelProcedureNote);
   }
   else if (radioIsUB->Checked)
   {
    temp.push_back(panelProcedureNote);
    temp.push_back(panelProcedureCode);
    temp.push_back(panelProcedureFrom);
    temp.push_back(panelProcedureTo); // newly added
    temp.push_back(panelProcedureUnits);
    temp.push_back(panelProcedureCharges);
    temp.push_back(panelProcedureResiduals);
    temp.push_back(panelProcedureAllowed);
    temp.push_back(panelProcedurePayment);
   }
   else if (radioIsADA->Checked)
   {
    temp.push_back(panelProcedureFrom);
    temp.push_back(panelProcedureTooth);
    temp.push_back(panelProcedureSurface);
    temp.push_back(panelProcedureDiagnosis);
    temp.push_back(panelProcedureCode);
    temp.push_back(panelProcedureUnits);
    temp.push_back(panelProcedureNote);
    temp.push_back(panelProcedureCharges);
    temp.push_back(panelProcedureAllowed);
    temp.push_back(panelProcedurePayment);
   }
   else if (radioIsOther->Checked)
   {
    temp.push_back(panelProcedureFrom);
    temp.push_back(panelProcedureTo);
    temp.push_back(panelProcedureUnits);
    temp.push_back(panelProcedureNote);
    temp.push_back(panelProcedureCharges);
    temp.push_back(panelProcedureResiduals);
    temp.push_back(panelProcedureAllowed);
    temp.push_back(panelProcedurePayment);
   }
   SetupControlsForInline (scrollProcedures, temp);
   scrollProceduresResize(scrollProcedures);

   RefreshTotals();
   return;
  }
  case 6: // bill transactions (and modifying COB transactions)
  {
   // be at least 475 wide ... and try to get the drawer to move, too. not responding to width-changes only. not sure why.
   if (Width < 475)
   {
    last_offset_used = 475 - Width;
    Width += last_offset_used;
    helper_window->Left += last_offset_used;
   }

   if (selected_cob_id != "0")
   {
    // reset to original, default_... should still be set (ProcessPage(0))
    tx_result_cob = tx_original_cob;
   } else
   {
    // reset to nothing, make sure default is set.
    tx_result_cob = transaction_summary ();
    default_result_cob_entity_id = selected_service_provider_id;
   }

   tx_result_bill = transaction_summary();

   RefreshBillTransactionsClick(NULL);

   return;
  }
  case 7: // creating a new COB
  {
   if (start_page == 7)
   {
    selected_person_id = "0";
    RefreshPersonId();
   }

   selected_service_provider_id = "0";
   selected_service_id          = "0";
   SetApptContractsLinkText();
   RefreshServiceProviderId();

   radioNonReferral->Enabled = (start_page == 0);

   if (start_page == 0)
    SwitchRadioSelection(radioNonReferral);
   else
    SwitchRadioSelection(radioCoordinationOfBenefits);

   return;
  }
  case 8: // incoming referral
  {
   SwitchRadioSelection(radioReferrerNone);
   selected_referrer_id = "0";
   RefreshReferrerId();
   return;
  }
  case 9: // appointment information (date, time, reason)
  {
   Ptime time_now(Time());
   time_now.second = 0;
   dateApptDate->Date   = Date();
   dateApptTime->Time   = time_now.OutTime();
   editApptReason->Text = "";
   return;
  }
  case 10: // limit notes (standard text)
  {
   editLimits->Text = "";
   for (int i = 0; i < listStandardText->Items->Count; i++)
    listStandardText->Checked[i] = false;
   return;
  }
  case 11: // hospitalization (preconditions, followups, room, etc.)
  {
   editPreCond->Text     = "";
   editFollowup->Text    = "";
   editReportedBy->Text  = "";
   checkWasHosp->Checked = false;
   checkWasRoom->Checked = false;
   return;
  }
  case 12: // COB transactions
  {
   // clear the cob stuff, update the form
   tx_result_cob = transaction_summary();
   RefreshCOBTransactionsClick(NULL);
   return;
  }
  case 13: // outgoing referrals
  {
   list_out_referrals.clear_data();
   chosen_out_referrer_id       = "0";
   editOutReferralNote->Text    = "";
   comboOutReferralStatus->Text = "Not Begun";
   comboOutReferralReason->Text = "";
   RefreshOutReferrerId();
   return;
  }
  case 14: // visit information
  {
   // page 9 no longer appears -with page 14, so some of the following didn't make sense anymore.
   // pull from the appointment, if one was created? pull from appointments, if cob already existed?
   if (selected_cob_id == "0" || selected_cob_id == "")
   {
    Ptime time_now(Time());
    time_now.second = 0;
    dateVisitDate->Date   = Date();
    dateVisitTime->Time   = time_now.OutTime();
    editVisitReason->Text = "";
   } else
   {
    // get from db?
    string sql_get_date_time =
      "select first 1 end_date, appointment_time "
      "from appointments "
      "where task_id = " + selected_cob_id + " order by visit_outcome_id asc, current_id desc";
    map<string, string> found_record;
    if (SqlToMap(dbDatabase, sql_get_date_time, found_record) && !found_record.empty()) // depending on order of evaluation (short-circuit, with side-effects)
    {
     Pdate then_date(found_record["end_date"], global_mode);
     Ptime then_time(found_record["appointment_time"], global_mode);
     dateVisitDate->Date = then_date.OutDate();
     dateVisitTime->Time = then_time.OutTime();
     editVisitReason->Text = string("Appointment was for: "
       + GetOneField(dbDatabase, "select task_comments from tasks where id = " + selected_cob_id)).c_str();
    }
    else
    {
     // error, so ... solution? rather than error? yes. prettier.
     Ptime time_now(Time());
     time_now.second = 0;
     dateVisitDate->Date   = Date();
     dateVisitTime->Time   = time_now.OutTime();
     editVisitReason->Text = "";
    }
   }
   return;
  }
  case 15:
   return;
  default:
   PSay("SetupPage() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return;
 }
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::PageLockStatus (int page_index, bool locked)
{
 switch (page_index)
 {
  case 0: // creating a new bill (maybe decide to create a COB)
  {
   radioCOBKnown->Enabled         = !locked; // TODO: see below
   radioCOBSelect->Enabled        = !locked; // TODO: technically, should require COB/view ...
   radioCOBSearch->Enabled        = !locked; // TODO: see above
   radioCOBCreate->Enabled        = !locked && (optionsPermissions["table.tasks.cob"]["insert"] == "true");
   editCobNumber->Enabled         = !locked;
   buttonVerifyCOBNumber->Enabled = !locked;
   buttonSearchPatient->Enabled   = !locked;
   buttonSearchPatient2->Enabled  = !locked && (optionsPermissions["table.tasks.cob"]["insert"] == "true");
   buttonSearchCOB->Enabled       = !locked;
   return;
  }
  case 1: // eligibility screen (maybe decide to create an MVA)
  {
   radioCaseNone->Enabled   = !locked;
   radioCaseSelect->Enabled = !locked;
   radioCaseCreate->Enabled = !locked;
   return;
  }
  case 2: // create a new MVA
  {
   comboCaseType->Enabled           = !locked;
   editCaseAccidentDate->Enabled    = !locked;
   editCaseDescription->Enabled     = !locked;
   editCaseReportDate->Enabled      = !locked;
   editCaseSubrogationDate->Enabled = !locked;

   buttonCaseEntityAdd->Enabled     = !locked;
   buttonCaseEntityRemove->Enabled  = !locked;
   buttonCaseEntityClear->Enabled = !locked;
   buttonCaseEntitySave->Enabled    = !locked;

   buttonSearchCaseEntity->Enabled  = !locked;
   comboCaseEntityType->Enabled     = !locked;
   return;
  }
  case 3: // bill information (providers, type of bill)
  {
   radioPayProvider->Enabled        = !locked;
   radioPayFacility->Enabled        = !locked;
   radioPayGroup->Enabled           = !locked;
   buttonSearchTaxProvider->Enabled = !locked;
   buttonSearchTaxFacility->Enabled = !locked;
   buttonSearchTaxGroup->Enabled    = !locked;
   groupBillType->Enabled           = !locked;
   groupAmounts->Enabled            = !locked;
   return;
  }
  case 4: // conditions
  {
   buttonConditionAdd->Enabled = !locked;
   buttonConditionRemove->Enabled = !locked;
   buttonConditionClear->Enabled = !locked;
   buttonConditionSave->Enabled = !locked;
   scrollConditions->Enabled = !locked;

   return;
  }
  case 5: // procedures
  {
   buttonProcedureAdd->Enabled = !locked;
   buttonProcedureRemove->Enabled = !locked;
   buttonProcedureClear->Enabled = !locked;
   buttonProcedureSave->Enabled = !locked;
   scrollProcedures->Enabled = !locked;

   return;
  }
  case 6: // bill transactions (and modifying COB transactions)
  {
   buttonMoveCOBTransactionsDown->Enabled = !locked;
   buttonMoveBillTransactionsUp->Enabled  = !locked;

   buttonOldCOBTransactionsClear->Enabled   = !locked;
   buttonOldCOBTransactionsChange->Enabled  = !locked;
   buttonNewBillTransactionsClear->Enabled  = !locked;
   buttonNewBillTransactionsChange->Enabled = !locked;
   return;
  }
  case 7: // creating a new COB
  {
   buttonSearchPerson->Enabled          = !locked && start_page == 7;
   buttonSearchServiceProvider->Enabled = !locked;
   groupCOBTypeSelection->Enabled       = !locked;
   return;
  }
  case 8: // incoming referral
  {
   radioReferrerNone->Enabled    = !locked;
   radioReferrerSearch->Enabled  = !locked;
   radioReferrerSelect->Enabled  = !locked;
   buttonSearchReferrer->Enabled = !locked;
   return;
  }
  case 9: // appointment information (date, time, reason)
  {
   groupAppointment->Enabled = !locked;
   return;
  }
  case 10: // limit notes (standard text)
  {
   groupCoordOfBenefits->Enabled = !locked;
   return;
  }
  case 11: // hospitalization (preconditions, followups, room, etc.)
  {
   groupEmergencyRoom->Enabled = !locked;
   return;
  }
  case 12: // COB transactions
  {
   buttonNewCOBTransactionsClear->Enabled  = !locked;
   buttonNewCOBTransactionsChange->Enabled = !locked;
   return;
  }
  case 13: // outgoing referrals
  {
   buttonOutReferralAdd->Enabled    = !locked;
   buttonOutReferralRemove->Enabled = !locked;
   buttonOutReferralClear->Enabled  = !locked;
   buttonOutReferralSave->Enabled   = !locked;

   buttonSearchOutReferralEntity->Enabled = !locked;
   editOutReferralNote->Enabled           = !locked;
   return;
  }
  case 14: // visit information
  {
   groupVisit->Enabled = !locked;
   return;
  }
  case 15: // dupe cobs, bills
  {
   groupDuplicates->Enabled = !locked;
   return;
  }
  default:
   PSay("PageLockStatus() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonSearchPatientClick(TObject *Sender)
{
 FORM_TRY
  vector<string> results;
  TformSearchPerson * search = new TformSearchPerson(NULL, &results);
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   selected_person_id = results.front();
   RefreshPersonId();
  }
 FORM_CATCH

 if (Sender == buttonSearchPatient)
  SwitchRadioSelection(radioCOBSelect);
 else
 if (Sender == buttonSearchPatient2) 
 SwitchRadioSelection(radioCOBCreate);
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonSearchCaseEntityClick(TObject *Sender)
{
 FORM_TRY
  vector<string> results;
  TformSearchTaxEntity * search = new TformSearchTaxEntity(NULL, &results);
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   chosen_case_entity_id = results.front();
   RefreshCaseEntityId();
  }
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonSearchTaxProviderClick(TObject *Sender)
{
 FORM_TRY
  vector<string> results;
  TformSearchTaxEntity * search = new TformSearchTaxEntity(NULL, &results);
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   selected_provider_id = results.front();
   RefreshProviderId();
  }
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonSearchTaxFacilityClick(TObject *Sender)
{
 FORM_TRY
  vector<string> results;
  TformSearchTaxEntity * search = new TformSearchTaxEntity(NULL, &results);
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   selected_facility_id = results.front();
   RefreshFacilityId();
  }
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonSearchTaxGroupClick(TObject *Sender)
{
 FORM_TRY
  vector<string> results;
  TformSearchTaxEntity * search = new TformSearchTaxEntity(NULL, &results);
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   selected_group_id = results.front();
   RefreshGroupId();
  }
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonSearchPersonClick(TObject *Sender)
{
 FORM_TRY
  vector<string> results;
  TformSearchPerson * search = new TformSearchPerson(NULL, &results);
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   selected_person_id = results.front();
   RefreshPersonId();
  }
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonSearchServiceProviderClick(TObject *Sender)
{
 FORM_TRY
  vector<string> results;
  TformSearchTaxEntity * search = new TformSearchTaxEntity(NULL, &results);
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   selected_service_provider_id = results.front();
   SetApptContractsLinkText();
   RefreshServiceProviderId();
  }
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonSearchReferrerClick(TObject *Sender)
{
 FORM_TRY
  vector<string> results;
  TformSearchTaxEntity * search = new TformSearchTaxEntity(NULL, &results);
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   selected_referrer_id = results.front();
   RefreshReferrerId();
  }
 FORM_CATCH
 SwitchRadioSelection(radioReferrerSearch);
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonSearchOutReferralEntityClick(TObject *Sender)
{
 FORM_TRY
  vector<string> results;
  TformSearchTaxEntity * search = new TformSearchTaxEntity(NULL, &results);
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   chosen_out_referrer_id = results.front();
   RefreshOutReferrerId();
  }
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonSearchCOBClick(TObject *Sender)
{
 // go find the COB using the COB search screen
 FORM_TRY
  vector<string> results;
  TformSearchTaskCob * search = new TformSearchTaskCob(NULL, &results);
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   selected_cob_id = results.front();
   RefreshCobId();
  }
 FORM_CATCH
 SwitchRadioSelection(radioCOBSearch);
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::listExistingCobChanging(TObject *Sender, TListItem *Item,
   TItemChange Change, bool &AllowChange)
{
 AllowChange = !WizardLocked();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::listCasesChanging(TObject *Sender, TListItem *Item,
  TItemChange Change, bool &AllowChange)
{
 AllowChange = !WizardLocked();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::listServicesChanging(TObject *Sender, TListItem *Item,
  TItemChange Change, bool &AllowChange)
{
 AllowChange = !WizardLocked();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::listReferrersChanging(TObject *Sender, TListItem *Item,
  TItemChange Change, bool &AllowChange)
{
 AllowChange = !WizardLocked();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonCaseEntityAddClick(TObject *Sender)
{
 listCaseEntities->Selected = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonCaseEntityRemoveClick(TObject *Sender)
{
 list_case_entities.remove_current_row(true);
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonCaseEntityClearClick(TObject *Sender)
{
 list_case_entities.clear_data();
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::CaseEntitySelected()
{
 map<string, string> row_data;
 if (!list_case_entities.get_current_row(row_data))
 {
  // set default values
  row_data["case_entity_id"]      = "0";
  row_data["case_entity_name"]    = "";
  row_data["case_entity_type_id"] = "0";
  row_data["case_entity_type"]    = "";
 }
 // update controls to reflect data in row_data
 chosen_case_entity_id     = row_data["case_entity_id"];
 comboCaseEntityType->Text = row_data["case_entity_type"].c_str();
 RefreshCaseEntityId();
 if (buttonSearchCaseEntity->Enabled && IsVisible(buttonSearchCaseEntity))
  this->ActiveControl = buttonSearchCaseEntity;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonCaseEntitySaveClick(TObject *Sender)
{
 if (chosen_case_entity_id == "0")
 {
  PSay("Please select an entity to attach to this case before continuing.", m_missing_data, MB_OK);
  return;
 }

 // TODO: verify combo

 map<string, string> row_data;
 row_data["case_entity_id"]      = chosen_case_entity_id;
 row_data["case_entity_name"]    = staticCaseEntity->Caption.c_str();
 row_data["case_entity_type_id"] = "0"; // debug
 row_data["case_entity_type"]    = comboCaseEntityType->Text.c_str(); // debug? case-sensitive?

 set<string> dupe_columns;
 dupe_columns.insert("case_entity_id");
 dupe_columns.insert("case_entity_type_id");
 if (list_case_entities.is_future_duplicate (row_data, dupe_columns))
 {
  PSay("Saving this row as it is would create a duplicate entry in the list.\n"
       "You may not have two rows with the same entity and reason.", m_duplicate_data, MB_OK);
  return;
 }

 list_case_entities.add_or_modify_row_data(row_data, false);
 listCaseEntities->Selected = NULL;
 if (buttonSearchCaseEntity->Enabled && IsVisible(buttonSearchCaseEntity))
  this->ActiveControl = buttonSearchCaseEntity;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonMoveCOBTransactionsDownClick(TObject *Sender)
{
 PSay("When moving transactions between a COB and a bill,\n"
      "please make sure the entities paid are still the ones intended.\n"
      "The bill may not always pay the entity indicated on the COB.", m_reminder, MB_OK);

 tx_result_bill = tx_result_cob;
 tx_result_cob  = transaction_summary();
 vector<map<string, string> > current_data;
 current_data = tx_result_bill.GetPreviewOutput(false);
 RefreshTransactionSummaryView (list_new_bill_transactions, checkBillShowAccount->Checked, checkBillShowEntity->Checked, current_data);
 current_data = tx_result_cob.GetPreviewOutput(true);
 RefreshTransactionSummaryView (list_old_cob_transactions, checkBillShowAccount->Checked, checkBillShowEntity->Checked, current_data);
 RefreshTotals ();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonMoveBillTransactionsUpClick(TObject *Sender)
{
 tx_result_cob = tx_result_bill;
 tx_result_bill  = transaction_summary();
 vector<map<string, string> > current_data;
 current_data = tx_result_cob.GetPreviewOutput(true);
 RefreshTransactionSummaryView (list_old_cob_transactions, checkBillShowAccount->Checked, checkBillShowEntity->Checked, current_data);
 current_data = tx_result_bill.GetPreviewOutput(false);
 RefreshTransactionSummaryView (list_new_bill_transactions, checkBillShowAccount->Checked, checkBillShowEntity->Checked, current_data);
 RefreshTotals ();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonOldCOBTransactionsClearClick(TObject *Sender)
{
 tx_result_cob = transaction_summary ();
 vector<map<string, string> > current_data = tx_result_cob.GetPreviewOutput(true);
 RefreshTransactionSummaryView (list_old_cob_transactions, checkBillShowAccount->Checked, checkBillShowEntity->Checked, current_data);
 RefreshTotals ();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonOldCOBTransactionsChangeClick(TObject *Sender)
{
 FORM_TRY
  TformSpecialTransactionEntry * query = new TformSpecialTransactionEntry(NULL, (tx_original_cob), &tx_result_cob, default_result_cob_entity_id, 0.00, true);
  query->ShowTaskModal(this);
  vector<map<string, string> > current_data = tx_result_cob.GetPreviewOutput(true);
  RefreshTransactionSummaryView (list_old_cob_transactions, checkBillShowAccount->Checked, checkBillShowEntity->Checked, current_data);
 FORM_CATCH
 RefreshTotals ();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonNewBillTransactionsClearClick(TObject *Sender)
{
 tx_result_bill = transaction_summary ();
 vector<map<string, string> > current_data = tx_result_bill.GetPreviewOutput(false);
 RefreshTransactionSummaryView (list_new_bill_transactions, checkBillShowAccount->Checked, checkBillShowEntity->Checked, current_data);
 RefreshTotals ();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonNewBillTransactionsChangeClick(TObject *Sender)
{
 financial likely_default_amount = (sum_procedure_payments > financial(0.00)) ? sum_procedure_payments :
                                   (sum_procedure_allowed > financial(0.00)) ? sum_procedure_allowed :
                                   (sum_procedure_residuals > financial(0.00)) ? sum_procedure_residuals :
                                   (sum_procedure_charges > financial(0.00)) ? sum_procedure_charges :
                                   (sum_bill_residuals > financial(0.00)) ? sum_bill_residuals :
                                   (sum_bill_charges > financial(0.00)) ? sum_bill_charges :
                                   financial(0.00);

 FORM_TRY
  TformSpecialTransactionEntry * query = new TformSpecialTransactionEntry(NULL, transaction_summary(), &tx_result_bill, selected_actual_id, likely_default_amount, true);
  query->ShowTaskModal(this);
  vector<map<string, string> > current_data = tx_result_bill.GetPreviewOutput(false);
  RefreshTransactionSummaryView (list_new_bill_transactions, checkBillShowAccount->Checked, checkBillShowEntity->Checked, current_data);
 FORM_CATCH
 RefreshTotals ();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonAddTextClick(TObject *Sender)
{
 // add from list, whatever's checked, then uncheck them
 for (int i = 0; i < listStandardText->Items->Count; i++)
  if (listStandardText->Checked[i])
  {
   if (editLimits->Text.Length() + listStandardText->Items->Strings[i].Length() <= editLimits->MaxLength)
   {
    editLimits->Text = editLimits->Text + listStandardText->Items->Strings[i] + " ";
    listStandardText->Checked[i] = false;
   }
  }

 editLimits->SelStart = editLimits->Text.Length();
 editLimits->SelLength = 0;
 editLimits->Perform(EM_SCROLLCARET, 0, 0);
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonNewCOBTransactionsClearClick(TObject *Sender)
{
 vector<map<string, string> > current_data = tx_result_cob.GetPreviewOutput(true);
 RefreshTransactionSummaryView (list_new_cob_transactions, checkCOBShowAccount->Checked, checkCOBShowEntity->Checked, current_data);
 RefreshTotals ();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonNewCOBTransactionsChangeClick(TObject *Sender)
{
 FORM_TRY
  TformSpecialTransactionEntry * query = new TformSpecialTransactionEntry(NULL, transaction_summary(), &tx_result_cob, selected_service_provider_id, 0.00, true);
  query->ShowTaskModal(this);
  vector<map<string, string> > current_data = tx_result_cob.GetPreviewOutput(true);
  RefreshTransactionSummaryView (list_new_cob_transactions, checkCOBShowAccount->Checked, checkCOBShowEntity->Checked, current_data);
 FORM_CATCH
 RefreshTotals ();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonOutReferralAddClick(TObject *Sender)
{
 listOutReferrals->Selected = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonOutReferralRemoveClick(TObject *Sender)
{
 list_out_referrals.remove_current_row(true);
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonOutReferralClearClick(TObject *Sender)
{
 list_out_referrals.clear_data();
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::OutReferralSelected()
{
 map<string, string> row_data;
 if (!list_out_referrals.get_current_row(row_data))
 {
  // set default values
  row_data["out_referral_entity_id"]   = "0";
  row_data["out_referral_is_user"]     = "0";
  row_data["out_referral_entity_name"] = "";
  row_data["out_referral_note"]        = "";
  row_data["out_referral_status"]      = "Not Begun";
  row_data["out_referral_reason"]      = "";
 }
 // update controls to reflect data in row_data
 chosen_out_referrer_id                = row_data["out_referral_entity_id"];
 editOutReferralNote->Text             = row_data["out_referral_note"].c_str();
 comboOutReferralStatus->Text          = row_data["out_referral_status"].c_str();
 comboOutReferralReason->Text          = row_data["out_referral_reason"].c_str();
 RefreshOutReferrerId();
 if (buttonSearchOutReferralEntity->Enabled && IsVisible(buttonSearchOutReferralEntity))
  this->ActiveControl = buttonSearchOutReferralEntity;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonOutReferralSaveClick(TObject *Sender)
{
 if (chosen_out_referrer_id == "0")
 {
  PSay("Please select an entity to which a referral is to be made before continuing.", m_missing_data, MB_OK);
  this->ActiveControl = buttonSearchOutReferralEntity;
  return;
 }

 // verify validity of combo boxes
 if (!lookupTables->IsInLookUpTable("todo_status_types", comboOutReferralStatus->Text.c_str()))
 {
   PSay("Please enter a valid status", m_invalid_data, MB_OK);
   this->ActiveControl = comboOutReferralStatus;
   return;
 }

 if (!lookupTables->IsInLookUpTable("referral_reason_types", comboOutReferralReason->Text.c_str()))
 {
   PSay("Please enter a valid reason", m_invalid_data, MB_OK);
   this->ActiveControl = comboOutReferralReason;
   return;
 }

 map<string, string> row_data;
 row_data["out_referral_entity_id"]   = chosen_out_referrer_id;
 row_data["out_referral_is_user"]     = ((GetOneField(dbDatabase, "select id from users where tax_entity_id = " + chosen_out_referrer_id) == "") ? "0" : "1");
 row_data["out_referral_entity_name"] = staticOutReferralEntity->Caption.c_str();
 row_data["out_referral_note"]        = editOutReferralNote->Text.c_str();
 row_data["out_referral_status"]      = comboOutReferralStatus->Text.c_str();
 row_data["out_referral_reason"]      = comboOutReferralReason->Text.c_str();

 set<string> dupe_columns;
 dupe_columns.insert("out_referral_entity_id");
 if (list_out_referrals.is_future_duplicate (row_data, dupe_columns))
 {
  PSay("Saving this row as it is would create a duplicate entry in the list.\nYou may not have two rows with the same entity.", m_duplicate_data, MB_OK);
  return;
 }

 list_out_referrals.add_or_modify_row_data(row_data, false);
 listOutReferrals->Selected = NULL;
 if (buttonSearchOutReferralEntity->Enabled && IsVisible(buttonSearchOutReferralEntity))
  this->ActiveControl = buttonSearchOutReferralEntity;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::RefreshBillTransactionsClick(TObject *Sender)
{
 vector<map<string, string> > cob_data = tx_result_cob.GetPreviewOutput(true);
 RefreshTransactionSummaryView (list_old_cob_transactions, checkBillShowAccount->Checked, checkBillShowEntity->Checked, cob_data);

 vector<map<string, string> > bill_data = tx_result_bill.GetPreviewOutput(false);
 RefreshTransactionSummaryView (list_new_bill_transactions, checkBillShowAccount->Checked, checkBillShowEntity->Checked, bill_data);
 RefreshTotals ();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::RefreshCOBTransactionsClick(TObject *Sender)
{
 vector<map<string, string> > cob_data = tx_result_cob.GetPreviewOutput(true);
 RefreshTransactionSummaryView (list_new_cob_transactions, checkCOBShowAccount->Checked, checkCOBShowEntity->Checked, cob_data);
 RefreshTotals ();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonVerifyCOBNumberClick(TObject *Sender)
{
 SwitchRadioSelection(radioCOBKnown);
 
 // go pull stuff
 string cob_number = editCobNumber->Text.c_str();
 if (cob_number.empty() || !IsInt(cob_number))
 {
  PSay ("Please enter a COB number to search for.", m_missing_data, MB_OK);
  return;
 }

 // try to find the id that matches it
 vector<string> matched_tasks;
 if (SqlToVec(dbDatabase, "select tasks.id from tasks where tasks.services_provided_id > 0 and tasks.cob_number = '"
                          + IntToString(StringToInt(cob_number)) + "'", matched_tasks))
 {
  if (matched_tasks.size() < 1)
  {
   PSay ("No COBs were found with that number. Please try another number, or another search method.", m_invalid_data, MB_OK);
   return;
  } else
  if (matched_tasks.size() > 1)
  {
   PSay ("There are " + IntToString(matched_tasks.size()) + " COBs with that exact number.\n"
         "Please try a different search method to exactly the COB you intended.", m_invalid_data, MB_OK);
   return;
  } else
  if (matched_tasks.size() == 1)
  {
   // congratulations!
   selected_cob_id = matched_tasks[0];
   // this refresh seems fairly necessary.
   RefreshCobId();
   SwitchRadioSelection(radioCOBSelect);
  }
 } else
 {
  PSay ("An error occurred while trying to find a COB matching your description.\n"
        "Please report this problem; in the mean time, try another method.", m_database_error, MB_OK);
  return;
 }
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::EditCase()
{
 // nothing yet, as cases (and recordCase) don't exist.
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::AddConsent()
{
 map<string,string> temp_map;
 temp_map["id"]        = "new";
 temp_map["person_id"] = selected_person_id;
 FORM_TRY
  TformRecordConsent * consentRecord = new TformRecordConsent(NULL, temp_map);
  consentRecord->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::EditConsent()
{
 map<string,string> temp_map;
 temp_map["id"] = list_consents.GetSelectedRecordID();
 FORM_TRY
  TformRecordConsent * consentRecord = new TformRecordConsent(NULL, temp_map);
  consentRecord->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::EditCob()
{
 map<string,string> temp_map;
 temp_map["id"] = list_cobs.GetSelectedRecordID();
 FORM_TRY
  TformRecordTaskCob * cobRecord = new TformRecordTaskCob(NULL, temp_map);
  cobRecord->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::EditDupeCob()
{
 map<string,string> temp_map;
 temp_map["id"] = list_dupe_cobs.GetSelectedRecordID();
 FORM_TRY
  TformRecordTaskCob * cobRecord = new TformRecordTaskCob(NULL, temp_map);
  cobRecord->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::EditDupeVisit()
{
  DefaultAction(list_dupe_visits.GetSelectedRecordID(), "tasks");
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::EditDupeBill()
{
 map<string, string> temp_map;
 temp_map["id"] = list_dupe_bills.GetSelectedRecordID();
 string bill_id = GetOneField(dbDatabase, "select bill_id from bills where id = " + temp_map["id"]);
 if((bill_id == lookupTables->IdOf("bill_types", "incoming provider bill")) ||
    (bill_id == lookupTables->IdOf("bill_types", "incoming vendor bill")))
 {
  FORM_TRY
   TformRecordIncomingBill * in_bill = new TformRecordIncomingBill(NULL, temp_map);
   in_bill->Show();
  FORM_CATCH
 }
 else if(bill_id == lookupTables->IdOf("bill_types", "outgoing provider bill"))
 {
  FORM_TRY
   TformRecordOutgoingBill * out_bill = new TformRecordOutgoingBill(NULL, temp_map);
   out_bill->Show();
  FORM_CATCH
 }
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::AddInsurance()
{
 map<string, string> params;
 params["id"] = "new";
 params["person_id"] = selected_person_id;
 FORM_TRY
  TformRecordInsuranceCoverage * add_coverage = new TformRecordInsuranceCoverage(NULL, params);
  add_coverage->Show();
 FORM_CATCH
 return;
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::EditInsurance()
{
 map<string, string> params;
 params["id"] = list_insurances.GetSelectedRecordID();
 FORM_TRY
  TformRecordInsuranceCoverage * edit_coverage = new TformRecordInsuranceCoverage(NULL, params);
  edit_coverage->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::AddNote()
{
  map<string,string> temp_map;
  temp_map["id"]        = "new";
  temp_map["person_id"] = selected_person_id;
  temp_map["group_id"]  = "0";
  FORM_TRY
   TformRecordPersonNotes * noteRecord = new TformRecordPersonNotes(NULL, temp_map);
   noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::EditNote()
{
  map<string,string> temp_map;
  temp_map["id"] = list_notes.GetSelectedRecordID();
  FORM_TRY
   TformRecordPersonNotes * noteRecord = new TformRecordPersonNotes(NULL, temp_map);
   noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::EditReferrer()
{
 map<string,string> temp_map;
 temp_map["id"] = list_referrers.GetSelectedRecordID();
 FORM_TRY
  TformRecordTaxEntity * tax_entity = new TformRecordTaxEntity(NULL, temp_map);
  tax_entity->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::AddService()
{
 map<string,string> temp_map;
 temp_map["id"] = "new";
 temp_map["tax_entity_id"] = selected_service_provider_id;
 FORM_TRY
  TformRecordServiceProvided * serviceRecord = new TformRecordServiceProvided(NULL, temp_map);
  serviceRecord->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::EditService()
{
 map<string,string> temp_map;
 temp_map["id"] = list_services.GetSelectedRecordID();
 FORM_TRY
  TformRecordServiceProvided * serviceRecord = new TformRecordServiceProvided(NULL, temp_map);
  serviceRecord->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::listStandardTextDblClick(TObject *Sender)
{
 // add from list, whatever's selected
 for (int i = 0; i < listStandardText->Items->Count; i++)
  if (listStandardText->Selected[i])
   if (editLimits->Text.Length() + listStandardText->Items->Strings[i].Length() <= editLimits->MaxLength)
    editLimits->Text = editLimits->Text + listStandardText->Items->Strings[i] + " ";

 editLimits->SelStart = editLimits->Text.Length();
 editLimits->SelLength = 0;
 editLimits->Perform(EM_SCROLLCARET, 0, 0);
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::CreateCase(TIBTransaction *dbTransaction, pmapstrs default_row, string &fk_case)
{
 pmapstrs default_case;
 pmapstrs default_case_entity;

 if (!CreateInsertMap(dbTransaction, "cases", default_case))
  throw(90);
 if (!CreateInsertMap(dbTransaction, "case_entities", default_case_entity))
  throw(91);

 MergeMap(default_case, default_row);
 MergeMap(default_case_entity, default_row);

 vector<map<string, string> > listview_data;
 map<string, string> insert_row;

 // - case
 fk_case = GetNextId(dbTransaction, "cases");
 insert_row = default_case;
 insert_row["id"]               = fk_case;
 insert_row["description"]      = editCaseDescription->Text.c_str();
 insert_row["accident_date"]    = Pdate(editCaseAccidentDate->Text.c_str(), global_mode).OutDate(global_mode);
 insert_row["report_date"]      = Pdate(editCaseReportDate->Text.c_str(), global_mode).OutDate(global_mode);
 insert_row["subrogation_date"] = Pdate(editCaseSubrogationDate->Text.c_str(), global_mode).OutDate(global_mode);

 if (!ExecuteInsertStatement(dbTransaction, "cases", insert_row))
  throw(1);
 AtlasAdd("cases", insert_row);

 // - case entities
 if (!list_case_entities.export_data(listview_data))
  throw(2);

 for (pvecmap::iterator i_ent = listview_data.begin(); i_ent != listview_data.end(); i_ent++)
 {
  insert_row = default_case_entity;
  insert_row["id"]             = GetNextId(dbTransaction, "case_entities");
  insert_row["case_entity_id"] = (*i_ent)["case_entity_type_id"];
  insert_row["tax_entity_id"]  = (*i_ent)["case_entity_id"];
  // ...

  if (!ExecuteInsertStatement(dbTransaction, "case_entities", insert_row))
   throw(3);
  AtlasAdd("case_entities", insert_row);
 }
}
//---------------------------------------------------------------------------
string TformWizardNewContractHealthItem::CreateCob(TIBTransaction *dbTransaction, pmapstrs default_row, string &fk_case, string &fk_cob)
{
 // jhaley 20101118: Need to return ID of new COB, as the record screen cannot be opened until the transaction is
 //  committed.
 string id_to_return;

 // TODO: this is disabled because cases / case_entities don't exist in the db yet
 if (false && HistoryIncludes(2))
  CreateCase(dbTransaction, default_row, fk_case);

 map<string, string> default_task;
 map<string, string> default_appointment;
 map<string, string> default_transaction;
 map<string, string> default_referral;
 map<string, string> default_referral_note;
 vector<map<string, string> > listview_data;

 if (!CreateInsertMap(dbTransaction, "tasks", default_task))
 throw(92);
 if (!CreateInsertMap(dbTransaction, "appointments", default_appointment))
  throw(93);
 if (!CreateInsertMap(dbTransaction, "transactions", default_transaction))
  throw(94);
 if (!CreateInsertMap(dbTransaction, "referrals", default_referral))
  throw(95);
 if (!CreateInsertMap(dbTransaction, "referral_notes", default_referral_note))
  throw(96);

 MergeMap(default_task, default_row);
 MergeMap(default_appointment, default_row);
 MergeMap(default_transaction, default_row);
 MergeMap(default_referral, default_row);
 MergeMap(default_referral_note, default_row);

 map<string, string> insert_row;

 // TODO: in the case of Non-Ref Bills, appointment == visit for date/time/comment.

 // - cob
 id_to_return = fk_cob = GetNextId(dbTransaction, "tasks");
 insert_row = default_task;
 insert_row["id"]                   = fk_cob;
 insert_row["person_id"]            = selected_person_id;
 insert_row["services_provided_id"] = selected_service_id;
 // TODO: Paul seems to think this might be a bad idea, as other departments now create COB's
 //  (though I'm still confused as to why, and how that affects other departments)
 insert_row["group_id"]             = lookupTables->IdOf("groups", "Contract Health");
 insert_row["date_of_task"]         = CurrentDate();
 insert_row["time_of_task"]         = CurrentTime();
 if (HistoryIncludes(9))
  insert_row["task_comments"]       = editApptReason->Text.c_str(); // reason
 if (HistoryIncludes(10))
  insert_row["visit_comments"]      = editLimits->Text.c_str();     // usage / limits
 insert_row["user_id"]              = current_userid;
 insert_row["cob_number"]           = fk_cob; // yes, that's what codeSpecialNewCOB does/did
 if (radioCoordinationOfBenefits->Checked)
  insert_row["cob_id"] = lookupTables->IdOf("cob_types", "Coordination of Benefits");
 else if (radioNonReferral->Checked)
  insert_row["cob_id"] = lookupTables->IdOf("cob_types", "Non-referral");
 else if (radioEmergencyRoomNotice->Checked)
  insert_row["cob_id"] = lookupTables->IdOf("cob_types", "ER/72-hour Notice");
 else
  insert_row["cob_id"] = "0"; // this shouldn't be possible when creating a ... a ... cob. right.
 // PSay("cob_id = " + insert_row["cob_id"], m_debug, MB_OK);
 // insert_row["case_id"]              = fk_case;
 // not caught by automation
 // but -is- caught by default values in the database
/*
 insert_row["hospitalized"]       = "0";
 insert_row["given_room"]         = "0";
 insert_row["is_educational"]     = "0";
 insert_row["is_personal"]        = "0";
 insert_row["new_client"]         = "0";
 insert_row["in_progress"]        = "0";
*/

 // - ER data on cob
 if (HistoryIncludes(11))
 {
  insert_row["preconditions_note"] = editPreCond->Text.c_str();
  insert_row["followup_note"]      = editFollowup->Text.c_str();
  insert_row["reported_by_note"]   = editReportedBy->Text.c_str();
  insert_row["hospitalized"]       = checkWasHosp->Checked ? "1" : "0";
  insert_row["given_room"]         = checkWasRoom->Checked ? "1" : "0";
 }

 map<string, int> leave_comments_alone;
 leave_comments_alone["task_comments"] = sql_no_uppercasing;
 leave_comments_alone["visit_comments"] = sql_no_uppercasing;
 if (!ExecuteInsertStatement(dbTransaction, "tasks", insert_row, leave_comments_alone))
  throw(4);
 AtlasAdd("tasks", insert_row);

 // - appointment
 if (HistoryIncludes(9))
 {
  // end-stamp should be adjusted if the "duration" field winds up being different later.
  string appointment_date = Pdate(dateApptDate->Date).OutDate(mdy | yyyy);
  string appointment_time = Ptime(dateApptTime->Time).OutTime(military | withoutsec);
  Pstamp appointment_begin_stamp(appointment_date + " " + appointment_time, mdy | yyyy | military | withoutsec | datefirst);
  Pstamp appointment_end_stamp = appointment_begin_stamp;
  appointment_end_stamp.mod(30, in_minutes);

  insert_row = default_appointment;
  insert_row["id"]               = GetNextId(dbTransaction, "appointments");
  insert_row["task_id"]          = fk_cob;
  insert_row["tax_entity_id"]    = selected_service_provider_id;
  insert_row["created_by"]       = current_userid;
  insert_row["group_id"]         = current_groupid;
  insert_row["description"]      = "COB Number " + fk_cob; // it's the same as cob_number, which is what codeSpecialNewCOB uses/used
  insert_row["repeating_string"] = "0,0,0|0,0,0|0,0,0|0,0,0";
  insert_row["begin_date"]       = appointment_date;
  insert_row["end_date"]         = appointment_date;
  insert_row["appointment_date"] = appointment_date;
  insert_row["appointment_time"] = appointment_time;
  insert_row["single_date"]      = "1";
  insert_row["duration"]         = "30";
  insert_row["duration_id"]      = lookupTables->IdOf("duration_types", "Minutes");
  insert_row["person_id"]        = selected_person_id;
  insert_row["final_end_stamp"]  = appointment_end_stamp.OutStamp(mdy | yyyy | military | withsec | datefirst);

  if (!ExecuteInsertStatement(dbTransaction, "appointments", insert_row))
   throw(5);
  AtlasAdd("appointments", insert_row);
 }

 // - cob transactions (only if new)
 if (HistoryIncludes(12))
 {
  insert_row = default_transaction;
  insert_row["task_id"]            = fk_cob;
  insert_row["effective_date"]     = Pdate(dateApptDate->Date).OutDate(global_mode);
  insert_row["note"]               = "Initial entries for coordination of benefits";
  insert_row["transaction_number"] = GetNextId(dbTransaction, "transact_number");

  // ignore tx_original_cob in this case
  vector<map<string, string> > cob_tx = tx_result_cob.GetFinalOutput(insert_row);
  vector<map<string, string> >::iterator i_tx;

  // setup id
  for (i_tx = cob_tx.begin(); i_tx != cob_tx.end(); i_tx++)
  {
   (*i_tx)["id"] = GetNextId(dbTransaction, "transactions");
   if (!ExecuteInsertStatement(dbTransaction, "transactions", (*i_tx)))
    throw(20);
   AtlasAdd("transactions", (*i_tx));
  }
 }

 if (HistoryIncludes(8)) // incoming referral
 {
  insert_row = default_referral;
  insert_row["id"]               = GetNextId(dbTransaction, "referrals");
  insert_row["task_id"]          = fk_cob;
  insert_row["person_id"]        = selected_person_id;
  insert_row["by_provider_id"]   = selected_referrer_id;
  insert_row["to_provider_id"]   = selected_service_provider_id;
  insert_row["date_of_referral"] = Pdate(Date()).OutDate(global_mode);
  insert_row["todo_status_id"]   = "0"; // this was true in new-cob, but new-referral starts with "Not Begun" // TODO: decide what status to start with

  if (!ExecuteInsertStatement(dbTransaction, "referrals", insert_row))
   throw(21);
  AtlasAdd("referrals", insert_row);
  if (insert_row["to_provider_id"] != user_taxid)
   AtlasAdd("hack.referrals", "to_provider_id", insert_row["to_provider_id"]);
 }

 if (HistoryIncludes(13)) // outgoing referral
 {
  if (!list_out_referrals.export_data(listview_data))
   throw(8);

  string referring_from_id = GetOneField(dbTransaction, "select tax_entity_id from users where users.id = " + current_userid);
  if (referring_from_id == "")
   referring_from_id = "0"; // just some safety-net stuff.

  for (vector<map<string, string> >::iterator i_ent = listview_data.begin(); i_ent != listview_data.end(); i_ent++)
  {
   insert_row = default_referral;
   insert_row["id"]                 = GetNextId(dbTransaction, "referrals");
   insert_row["task_id"]            = fk_cob;
   insert_row["person_id"]          = selected_person_id;
   insert_row["by_provider_id"]     = referring_from_id;
   insert_row["to_provider_id"]     = (*i_ent)["out_referral_entity_id"];
   insert_row["date_of_referral"]   = Pdate(Date()).OutDate(global_mode);
   insert_row["todo_status_id"]     = lookupTables->IdOf("todo_status_types", (*i_ent)["out_referral_status"]);
   insert_row["referral_reason_id"] = lookupTables->IdOf("referral_reason_types", (*i_ent)["out_referral_reason"]);
   // BOB

   string remember_id = insert_row["id"];

   if (!ExecuteInsertStatement(dbTransaction, "referrals", insert_row))
    throw(21);
   AtlasAdd("referrals", insert_row);
   if (insert_row["to_provider_id"] != user_taxid)
    AtlasAdd("hack.referrals", "to_provider_id", insert_row["to_provider_id"]);

   // notes
   if (!(*i_ent)["out_referral_note"].empty())
   {
    insert_row = default_referral_note;
    insert_row["id"]               = GetNextId(dbTransaction, "referral_notes");
    insert_row["referral_id"]      = remember_id;
    insert_row["note"]             = (*i_ent)["out_referral_note"];
    insert_row["date_of_note"]     = Pdate(Date()).OutDate(global_mode);

    if (!ExecuteInsertStatement(dbTransaction, "referral_notes", insert_row))
     throw(22);
    AtlasAdd("referral_notes", insert_row);
   }
  }
 }
 // jhaley 20101118
 return id_to_return;
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::CreateBill(TIBTransaction *dbTransaction, pmapstrs default_row, string &fk_case, string &fk_cob)
{
 // make them equal to any defaults we have on hand,
 // override blank ones as things are created.
 // make errors if stuff doesn't get overriden sometimes.

 string fk_visit = "-1";
 string fk_cond  = "-1";
 string fk_proc  = "-1";
 string fk_bill  = "-1";

 vector<map<string, string> > listview_data;
 map<string, string> insert_row;

 // default insertion rows with zero-id values as necessary
 map<string, string> default_task;
 map<string, string> default_transaction;
 map<string, string> default_condition;
 map<string, string> default_procedure;
 map<string, string> default_procedure_reason;
 map<string, string> default_bill;
 map<string, string> default_procedure_payment;

 if (!CreateInsertMap(dbTransaction, "tasks", default_task))
  throw(92);
 if (!CreateInsertMap(dbTransaction, "transactions", default_transaction))
  throw(94);
 if (!CreateInsertMap(dbTransaction, "conditions", default_condition))
  throw(95);
 if (!CreateInsertMap(dbTransaction, "procedures", default_procedure))
  throw(96);
 if (!CreateInsertMap(dbTransaction, "procedure_reasons", default_procedure_reason))
  throw(97);
 if (!CreateInsertMap(dbTransaction, "bills", default_bill))
  throw(98);
 if (!CreateInsertMap(dbTransaction, "procedure_payments", default_procedure_payment))
  throw(99);

 MergeMap(default_task, default_row);
 MergeMap(default_transaction, default_row);
 MergeMap(default_condition, default_row);
 MergeMap(default_procedure, default_row);
 MergeMap(default_procedure_reason, default_row);
 MergeMap(default_bill, default_row);
 MergeMap(default_procedure_payment, default_row);

 // implies CreateCase
 if (HistoryIncludes(7))
  CreateCob(dbTransaction, default_row, fk_case, fk_cob);

 // - visit
 insert_row = default_task;
 fk_visit = GetNextId(dbTransaction, "tasks");
 insert_row["id"]                     = fk_visit;
 insert_row["parent_task_id"]         = fk_cob;
 insert_row["person_id"]              = selected_person_id;
 insert_row["tax_entity_id"]          = selected_provider_id;
 insert_row["group_id"]               = lookupTables->IdOf("groups", "Contract Health");
 insert_row["date_of_task"]           = Pdate(dateVisitDate->Date).OutDate(global_mode);
 insert_row["time_of_task"]           = Ptime(dateVisitTime->Time).OutTime(global_mode | withoutsec);
 insert_row["method_id"]              = lookupTables->IdOf("method_types", "Visit");
 insert_row["patient_control_number"] = editControlNumber->Text.c_str();
 if (HistoryIncludes(14))
  insert_row["task_comments"]          = editVisitReason->Text.c_str();
 // not caught by automation
 // but -is- caught by default values in the database
/*
 insert_row["hospitalized"]       = "0";
 insert_row["given_room"]         = "0";
 insert_row["is_educational"]     = "0";
 insert_row["is_personal"]        = "0";
 insert_row["new_client"]         = "0";
 insert_row["in_progress"]        = "0";
*/

 map<string, int> leave_reason_alone;
 leave_reason_alone["task_comments"] = sql_no_uppercasing;
 if (!ExecuteInsertStatement(dbTransaction, "tasks", insert_row, leave_reason_alone))
  throw(6);
 AtlasAdd("tasks", insert_row);

 // - bill
 insert_row = default_bill;
 fk_bill                       = GetNextId(dbTransaction, "bills");
 insert_row["id"]              = fk_bill;
 insert_row["task_id"]         = fk_visit;
 insert_row["provider_tax_id"] = selected_provider_id;
 insert_row["facility_tax_id"] = selected_facility_id;
 insert_row["group_tax_id"]    = selected_group_id;
 insert_row["actual_tax_id"]   = selected_actual_id;
 insert_row["total_charge"]    = ((editOriginalCharges->Text != "") ? FinancialToString(StringToFinancial(editOriginalCharges->Text.c_str())) : string(""));
 insert_row["invoice_amount"]  = ((editResidualCharges->Text != "") ? FinancialToString(StringToFinancial(editResidualCharges->Text.c_str())) : string(""));
 insert_row["paid_amount"]     = FinancialToString(tx_result_bill.GetEntityPayment(selected_actual_id));
 insert_row["bill_id"]         = lookupTables->IdOf("bill_types", "Incoming Provider Bill");
 insert_row["bill_date"]       = CurrentDate();

 if (!ExecuteInsertStatement(dbTransaction, "bills", insert_row))
  throw(7);
 AtlasAdd("bills", insert_row);

 /*
  (ignoring people and tax entities, which we don't create here)
  NULL  <- case
  case  <- cob
  cob   <- visit
  visit <- bill
  visit <- condition
  visit <- procedure
  condition <- procedure_reason
  procedure <- procedure_reason
  bill      <- procedure_payment
  procedure <- procedure_payment
 */

 // - conditions
 map<string, string> condition_to_index;
 if (!list_conditions.export_data(listview_data))
  throw(8);

 for (vector<map<string, string> >::iterator i_ent = listview_data.begin(); i_ent != listview_data.end(); i_ent++)
 {
  insert_row = default_condition;
  insert_row["id"]             = GetNextId(dbTransaction, "conditions");
  insert_row["person_id"]      = selected_person_id;
  insert_row["task_id"]        = fk_visit;
  insert_row["note"]           = (*i_ent)["condition_note"]; // TODO: default note from code_types? on-screen? other?
  insert_row["code"]           = (*i_ent)["condition_code"];
  insert_row["index_number"]   = (*i_ent)["condition_index"];
  insert_row["condition_id"]   = lookupTables->IdOf("condition_types", "Condition");
  insert_row["start_date"]     = Pdate(dateVisitDate->Date).OutDate(global_mode); // date of visit
  insert_row["group_id"]       = lookupTables->IdOf("groups", "Contract Health");

  condition_to_index[insert_row["id"]] = insert_row["index_number"];
  if (!ExecuteInsertStatement(dbTransaction, "conditions", insert_row))
   throw(9);
  AtlasAdd("conditions", insert_row);
 }

 // - procedures
 map<string, financial> procedure_to_residual;
 map<string, financial> procedure_to_allowed;
 map<string, financial> procedure_to_payment;
 if (!list_procedures.export_data(listview_data))
  throw(13);

 string this_id;
 for (vector<map<string, string> >::iterator i_ent = listview_data.begin(); i_ent != listview_data.end(); i_ent++)
 {
  insert_row = default_procedure;
  insert_row["id"]               = GetNextId(dbTransaction, "procedures");
  insert_row["task_id"]          = fk_visit;
  insert_row["start_date"]       = (*i_ent)["procedure_date_from"];
  insert_row["stop_date"]        = (*i_ent)["procedure_date_to"];
  insert_row["place_of_service"] = (*i_ent)["procedure_place_os"];
  insert_row["type_of_service"]  = (*i_ent)["procedure_type_os"];
  insert_row["cpt_hcpcs"]        = (*i_ent)["procedure_code"];
  insert_row["modifier"]         = (*i_ent)["procedure_modifier"];
  insert_row["charges"]          = (*i_ent)["procedure_charges"];
  insert_row["days_units"]       = (*i_ent)["procedure_units"];
  insert_row["local_use"]        = (*i_ent)["procedure_note"];
  insert_row["tooth_position"]   = (*i_ent)["procedure_tooth"];
  insert_row["tooth_surface"]    = (*i_ent)["procedure_surface"];
  insert_row["epsdt"]            = (*i_ent)["procedure_epsdt"];
  insert_row["emg"]              = (*i_ent)["procedure_emg"];
  insert_row["cob"]              = (*i_ent)["procedure_cob"];
  // TODO: renumber throw()'s, maybe, eventually? now that some are no longer needed?

  // - store for later use, payment value for this procedure
  if (!(*i_ent)["procedure_residuals"].empty())
   procedure_to_residual[insert_row["id"]] = StringToFinancial((*i_ent)["procedure_residuals"]);
  if (!(*i_ent)["procedure_allowed"].empty())
   procedure_to_allowed[insert_row["id"]] = StringToFinancial((*i_ent)["procedure_allowed"]);
  if (!(*i_ent)["procedure_payment"].empty())
   procedure_to_payment[insert_row["id"]] = StringToFinancial((*i_ent)["procedure_payment"]);
  this_id = insert_row["id"];

  if (!ExecuteInsertStatement(dbTransaction, "procedures", insert_row))
   throw(14);
  AtlasAdd("procedures", insert_row);

  // - procedure_reasons
  for (map<string, string>::iterator i_cond = condition_to_index.begin(); i_cond != condition_to_index.end(); i_cond++)
  {
   if (!(*i_ent)["procedure_diagnosis"].empty() && !i_cond->second.empty() && (*i_ent)["procedure_diagnosis"].find(i_cond->second) != string::npos)
   {
    insert_row = default_procedure_reason;
    insert_row["id"]           = GetNextId(dbTransaction, "procedure_reasons");
    insert_row["procedure_id"] = this_id;
    insert_row["condition_id"] = (i_cond->first);

    if (!ExecuteInsertStatement(dbTransaction, "procedure_reasons", insert_row))
     throw(15);
    AtlasAdd("procedure_reasons", insert_row);
   }
  }
 }

 // - procedure_payments
 set<string> procedure_keys;
 for (map<string, financial>::iterator i_temp = procedure_to_residual.begin(); i_temp != procedure_to_residual.end(); i_temp++)
  procedure_keys.insert(i_temp->first);
 for (map<string, financial>::iterator i_temp = procedure_to_allowed.begin(); i_temp != procedure_to_allowed.end(); i_temp++)
  procedure_keys.insert(i_temp->first);
 for (map<string, financial>::iterator i_temp = procedure_to_payment.begin(); i_temp != procedure_to_payment.end(); i_temp++)
  procedure_keys.insert(i_temp->first);
 map<string, financial>::iterator i_find;
 for (set<string>::iterator i_proc = procedure_keys.begin(); i_proc != procedure_keys.end(); i_proc++)
 {
   insert_row = default_procedure_payment;
   insert_row["id"]              = GetNextId(dbTransaction, "procedure_payments");
   insert_row["bill_id"]         = fk_bill;
   insert_row["procedure_id"]    = (*i_proc);

   i_find = procedure_to_residual.find((*i_proc));
   if (i_find != procedure_to_residual.end())
    insert_row["amount_charged"] = FinancialToString(i_find->second);

   i_find = procedure_to_allowed.find((*i_proc));
   if (i_find != procedure_to_allowed.end())
    insert_row["amount_allowed"] = FinancialToString(i_find->second);

   i_find = procedure_to_payment.find((*i_proc));
   if (i_find != procedure_to_payment.end())
    insert_row["amount_paid"] = FinancialToString(i_find->second);

   if (!ExecuteInsertStatement(dbTransaction, "procedure_payments", insert_row))
    throw(19);
   AtlasAdd("procedure_payments", insert_row);
 }

 // - bill transactions
 insert_row = default_transaction;
 insert_row["bill_id"]            = fk_bill;
 insert_row["effective_date"]     = Pdate(dateVisitDate->Date).OutDate(global_mode);
 insert_row["note"]               = "Initial entries for incoming provider bill";
 insert_row["transaction_number"] = GetNextId(dbTransaction, "transact_number");

 vector<map<string, string> > bill_tx = tx_result_bill.GetFinalOutput(insert_row);
 vector<map<string, string> >::iterator i_tx;
 // setup id
 for (i_tx = bill_tx.begin(); i_tx != bill_tx.end(); i_tx++)
 {
  (*i_tx)["id"] = GetNextId(dbTransaction, "transactions");
  if (!ExecuteInsertStatement(dbTransaction, "transactions", (*i_tx)))
   throw(20);
  AtlasAdd("transactions", (*i_tx));
 }

 // - cob transactions (if not a new cob)
 insert_row = default_transaction;
 insert_row["task_id"]            = fk_cob;
 insert_row["effective_date"]     = Pdate(dateVisitDate->Date).OutDate(global_mode);
 insert_row["note"]               = "Adjusting entries for coordination of benefits";
 insert_row["transaction_number"] = GetNextId(dbTransaction, "transact_number");

 // reselect stuff before doing the math
 // TODO: could be avoided by locking the cob task for update (do we care to do it that way? means keeping a tx open, etc.)
 tx_original_cob = transaction_summary();
 if (!radioCOBCreate->Checked)
 {
  string get_cob_transactions;
  get_cob_transactions  = "select * from transactions where transactions.task_id = " + selected_cob_id;
  vector<map<string, string> > cob_transactions;
  if (!SqlToVecMap(dbTransaction, get_cob_transactions, cob_transactions))
  {
   PSay ("Failed to retrieve old transactions for this item.", m_database_error, MB_OK);
   throw(37);
  }
  tx_original_cob.RawInput(cob_transactions);
 }

 vector<map<string, string> > cob_tx = (tx_result_cob - tx_original_cob).GetFinalOutput(insert_row);
 // setup id
 for (i_tx = cob_tx.begin(); i_tx != cob_tx.end(); i_tx++)
 {
  (*i_tx)["id"] = GetNextId(dbTransaction, "transactions");
  if (!ExecuteInsertStatement(dbTransaction, "transactions", (*i_tx)))
   throw(20);
  AtlasAdd("transactions", (*i_tx));
 }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::sheetLimitsShow(TObject *Sender)
{
 // maybe setup stuff here instead?
 map<string, string> params;
 params["id"] = selected_person_id;

 if (embedded_limits)
 {
  embedded_limits->Close();
  embedded_limits = NULL;
 }

 FORM_TRY
  embedded_limits = new TformSpecialPersonLimits(panelLimits, params);
  embedded_limits->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::FormClose(TObject *Sender, TCloseAction &Action)
{
 Action = caFree;
 TformWizardGeneric::FormClose(Sender, Action);
 if (Action != caNone)
 {
  // unregister combo boxes
  lookupTables->UnregisterComboBox("todo_status_types", comboOutReferralStatus);
  lookupTables->UnregisterComboBox("referral_reason_types", comboOutReferralReason);

  // cleanup
  if (embedded_limits)
  {
   embedded_limits->Close();
   embedded_limits = NULL;
  }
  // helper window is handled automatically (wizard closes, thus drawer closes, thus unkidnapping, etc.)
 }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonHelperClick(TObject *Sender)
{
 // helper window in/out
 helper_window->DrawerExpanded = buttonHelper->Down;
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::DrawerIsChanging (TformSpecialGeneric * Drawer, bool Expanding)
{
 if (Drawer == helper_window)
  buttonHelper->Down = helper_window->DrawerExpanded;
 TformWizardGeneric::DrawerIsChanging(Drawer, Expanding);
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::scrollProceduresResize(TObject *Sender)
{
  if(ComponentState.Contains(csDestroying) || ComponentState.Contains(csFreeNotification))
    return;

  try
  {
    int vertical_needed = ArrangeControlsInline(scrollProcedures, false, 15);
    scrollProcedures->Height = vertical_needed;
    scrollProcedures->Top = scrollProcedures->Parent->ClientHeight - scrollProcedures->Height;
    // don't ask me why the above is needed. resizing things with alignments just doesn't always work.
  }
  catch (...)
  {
  }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonConditionAddClick(TObject *Sender)
{
 // add condition        
 listConditions->Selected = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonConditionRemoveClick(TObject *Sender)
{
 // remove condition
 list_conditions.remove_current_row(true);
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonConditionClearClick(TObject *Sender)
{
 // clear condition
 list_conditions.clear_data();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonConditionSaveClick(TObject *Sender)
{
 // save condition

 if (IsVisible(editConditionIndex) && editConditionIndex->Text == "")
 {
  PSay("Please enter a condition index number.", m_missing_data, MB_OK);
  return;
 }

 if (IsVisible(editConditionIndex) && !IsInt(editConditionIndex->Text.c_str()))
 {
  PSay("Please enter a valid condition index number.", m_missing_data, MB_OK);
  return;
 }

 if (IsVisible(editConditionCode) && editConditionCode->Text == "")
 {
  PSay("Please enter a condition code.", m_missing_data, MB_OK);
  return;
 }

 map<string, string> row_data;
 row_data["condition_index"] = editConditionIndex->Text.c_str();
 row_data["condition_code"]  = editConditionCode->Text.c_str();
 row_data["condition_note"]  = editConditionNote->Text.c_str();

 if (IsVisible(editConditionIndex))
 {
  set<string> dupe_columns;
  dupe_columns.insert("condition_index");
  if (list_conditions.is_future_duplicate (row_data, dupe_columns))
  {
   PSay("Saving this row as it is would create a duplicate entry in the list.\n"
        "You may not have two rows with the same index number.", m_duplicate_data, MB_OK);
   return;
  }
 }

 set<string> dupe_columns;
 dupe_columns.insert("condition_code");
 if (list_conditions.is_future_duplicate (row_data, dupe_columns))
 {
  PSay("Saving this row as it is would create a duplicate entry in the list.\n"
       "You may not have two rows with the same code.", m_duplicate_data, MB_OK);
  return;
 }

 list_conditions.add_or_modify_row_data(row_data, false);
 listConditions->Selected = NULL;

 TWinControl * wanted_box = FindNextControl(scrollConditions, true, true, false);
 if (wanted_box && wanted_box->Enabled && IsVisible(wanted_box))
  this->ActiveControl = wanted_box;
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::ConditionSelected ()
{
 // select condition

 map<string, string> row_data;
 if (!list_conditions.get_current_row(row_data))
 {
  // set default values
  row_data["condition_index"] = "";

  // auto-increment?
  if (panelConditionIndex->Visible)
  {
   vector<map<string, string> > all_conditions;
   list_conditions.export_data(all_conditions);
   int lowest_number = 0;
   int temp_number = 0;
   for (vector<map<string, string> >::iterator i = all_conditions.begin(); i != all_conditions.end(); i++)
   {
    if (IsInt((*i)["condition_index"]))
    {
     temp_number = StringToInt((*i)["condition_index"]);
     lowest_number = max(lowest_number, temp_number);
    }
   }
   lowest_number++;
   row_data["condition_index"] = IntToString(lowest_number);
  }

  row_data["condition_code"]  = "";
  row_data["condition_note"]  = "";
 }

 // update controls to reflect data in row_data
 editConditionIndex->Text = row_data["condition_index"].c_str();
 editConditionCode->Text  = row_data["condition_code"].c_str();
 editConditionNote->Text  = row_data["condition_note"].c_str();

 TWinControl * wanted_box = FindNextControl(scrollConditions, true, true, false);
 if (wanted_box && wanted_box->Enabled && IsVisible(wanted_box))
  this->ActiveControl = wanted_box;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonProcedureAddClick(TObject *Sender)
{
 // add procedure
 listProcedures->Selected = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonProcedureRemoveClick(TObject *Sender)
{
 // remove procedure
 list_procedures.remove_current_row(true);
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonProcedureClearClick(TObject *Sender)
{
 // clear procedures
 list_procedures.clear_data();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonProcedureSaveClick(TObject *Sender)
{
 // save procedure

 bool is_from      = IsVisible(editProcedureFrom) && (editProcedureFrom->Text != "");
 bool is_to        = IsVisible(editProcedureTo) && (editProcedureTo->Text != "");
 bool is_units     = IsVisible(editProcedureUnits) && (editProcedureUnits->Text != "");
 bool is_charges   = IsVisible(editProcedureCharges) && (editProcedureCharges->Text != "");
 bool is_residuals = IsVisible(editProcedureResiduals) && (editProcedureResiduals->Text != "");
 bool is_allowed   = IsVisible(editProcedureAllowed) && (editProcedureAllowed->Text != "");
 bool is_payment   = IsVisible(editProcedurePayment) && (editProcedurePayment->Text != "");
 financial charges   = StringToFinancial(editProcedureCharges->Text.c_str());
 financial residuals = StringToFinancial(editProcedureResiduals->Text.c_str());
 financial allowed   = StringToFinancial(editProcedureAllowed->Text.c_str());
 financial payment   = StringToFinancial(editProcedurePayment->Text.c_str());

 if (is_from && !Pdate(editProcedureFrom->Text.c_str(), global_mode).IsValidDate())
 {
  PSay("Please enter a valid 'from' date.", m_invalid_data, MB_OK);
  return;
 }

 if (is_to && !Pdate(editProcedureTo->Text.c_str(), global_mode).IsValidDate())
 {
  PSay("Please enter a valid 'to' date.", m_invalid_data, MB_OK);
  return;
 }

 if (IsVisible(editProcedureCode) && editProcedureCode->Text == "")
 {
  if (IDNO == PSay("You have not entered a procedure code.\n"
                   "Are you sure you want to continue?", m_missing_data, MB_YESNO))
   return;
 }

 // TODO: make sure the diagnosis field has something useful in it?
 // maybe provide them with that verification page with a grid of code-to-code [x]?

 if (is_units && !IsInt(editProcedureUnits->Text.c_str()))
 {
  PSay("Please enter a valid or blank 'units / qty' count (integer).", m_invalid_data, MB_OK);
  return;
 }

 if (is_charges && !IsAmount(editProcedureCharges->Text.c_str()))
 {
  PSay("Please enter a valid or blank 'charges' amount.", m_invalid_data, MB_OK);
  return;
 }

 if (is_residuals && !IsAmount(editProcedureResiduals->Text.c_str()))
 {
  PSay("Please enter a valid or blank 'residuals' amount.", m_invalid_data, MB_OK);
  return;
 }

 if (is_allowed && !IsAmount(editProcedureAllowed->Text.c_str()))
 {
  PSay("Please enter a valid or blank 'allowed' amount.", m_invalid_data, MB_OK);
  return;
 }

 if (is_payment && !IsAmount(editProcedurePayment->Text.c_str()))
 {
  PSay("Please enter a valid or blank 'payment' amount.", m_invalid_data, MB_OK);
  return;
 }

 if ((is_charges && charges < financial(0.00)) ||
     (is_residuals && residuals < financial(0.00)) ||
     (is_allowed && allowed < financial(0.00)) ||
     (is_payment && payment < financial(0.00)))
 {
  PSay("You may not enter any negative dollar amounts.", m_invalid_data, MB_OK);
  return;
 }

 if (is_charges && is_residuals && residuals > charges)
 {
  PSay("Please make sure the residuals are not greater than the charges.", m_invalid_data, MB_OK);
  return;
 }

 if (is_charges && is_payment && payment > charges)
 {
  PSay("Please make sure the payment is not greater than the charges.", m_invalid_data, MB_OK);
  return;
 }

 if (is_residuals && is_payment && payment > residuals)
 {
  PSay("Please make sure the payment is not greater than the residuals.", m_invalid_data, MB_OK);
  return;
 }

 if (is_allowed && is_payment && payment > allowed)
 {
  PSay("Please make sure the payment is not greater than the allowed amount.", m_invalid_data, MB_OK);
  return;
 }

 if (is_allowed && is_residuals && residuals < allowed)
 {
  PSay("Please make sure the allowed amount is not greater than the residuals.", m_invalid_data, MB_OK);
  return;
 }

 if (is_allowed && is_charges && charges < allowed)
 {
  PSay("Please make sure the allowed amount is not greater than the charges.", m_invalid_data, MB_OK);
  return;
 }

 map<string, string> row_data;
 row_data["procedure_date_from"] = is_from ? Pdate(editProcedureFrom->Text.c_str(), global_mode).OutDate(global_mode) : string("");
 row_data["procedure_date_to"]   = is_to ? Pdate(editProcedureTo->Text.c_str(), global_mode).OutDate(global_mode) : string("");
 row_data["procedure_place_os"]  = IsVisible(editProcedurePlace) ? editProcedurePlace->Text.c_str() : "";
 row_data["procedure_type_os"]   = IsVisible(editProcedureType) ? editProcedureType->Text.c_str() : "";
 row_data["procedure_code"]      = IsVisible(editProcedureCode) ? editProcedureCode->Text.c_str() : "";
 row_data["procedure_modifier"]  = IsVisible(editProcedureMod) ? editProcedureMod->Text.c_str() : "";
 row_data["procedure_diagnosis"] = IsVisible(editProcedureDiagnosis) ? editProcedureDiagnosis->Text.c_str() : "";
 row_data["procedure_units"]     = is_units ? IntToString(StringToInt(editProcedureUnits->Text.c_str())) : string("");
 row_data["procedure_note"]      = IsVisible(editProcedureNote) ? editProcedureNote->Text.c_str() : "";
 row_data["procedure_charges"]   = is_charges ? FinancialToString(charges) : string("");
 row_data["procedure_residuals"] = is_residuals ? FinancialToString(residuals) : string("");
 row_data["procedure_allowed"]   = is_allowed ? FinancialToString(allowed) : string("");
 row_data["procedure_payment"]   = is_payment ? FinancialToString(payment) : string("");
 row_data["procedure_tooth"]     = IsVisible(editProcedureTooth) ? editProcedureTooth->Text.c_str() : "";
 row_data["procedure_surface"]   = IsVisible(editProcedureSurface) ? editProcedureSurface->Text.c_str() : "";
 row_data["procedure_epsdt"]     = IsVisible(editProcedureEPSDT) ? editProcedureEPSDT->Text.c_str() : "";
 row_data["procedure_emg"]       = IsVisible(editProcedureEMG) ? editProcedureEMG->Text.c_str() : "";
 row_data["procedure_cob"]       = IsVisible(editProcedureCOB) ? editProcedureCOB->Text.c_str() : "";

 set<string> dupe_columns;
 if (IsVisible(editProcedureFrom)) dupe_columns.insert("procedure_date_from");
 if (IsVisible(editProcedureTo)) dupe_columns.insert("procedure_date_to");
 if (IsVisible(editProcedureCode)) dupe_columns.insert("procedure_code");
 if (IsVisible(editProcedureMod)) dupe_columns.insert("procedure_modifier");
 if (IsVisible(editProcedureDiagnosis)) dupe_columns.insert("procedure_diagnosis");
 if (IsVisible(editProcedureTooth)) dupe_columns.insert("procedure_tooth");
 if (IsVisible(editProcedureSurface)) dupe_columns.insert("procedure_surface");

 bool found_a_value = false;
 for (set<string>::iterator i_f = dupe_columns.begin(); i_f != dupe_columns.end(); i_f++)
 {
  if (row_data[*i_f] != "")
  {
   found_a_value = true;
   break;
  }
 }
 if (!found_a_value)
 {
  PSay("Please enter at least one of the following fields, as available:\n"
       "from date, to date, code, modifier, diagnosis, tooth, surface.", m_missing_data, MB_OK);
  return;
 }

 if (list_procedures.is_future_duplicate (row_data, dupe_columns))
 {
  if (IDNO == PSay("Saving this row as it is would likely create a duplicate entry in the list.\n"
                   "Are you sure you want to save it anyway?", m_duplicate_data, MB_YESNO))
   return;
 }

 list_procedures.add_or_modify_row_data(row_data, false);
 RefreshTotals();
 listProcedures->Selected = NULL;

 TWinControl * wanted_box = FindNextControl(scrollProcedures, true, true, false);
 if (wanted_box && wanted_box->Enabled && IsVisible(wanted_box))
  this->ActiveControl = wanted_box;
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::ProcedureSelected ()
{
 // select procedure
 map<string, string> row_data;
 if (!list_procedures.get_current_row(row_data))
 {
  // set default values
  row_data["procedure_date_from"] = "";
  row_data["procedure_date_to"]   = "";
  row_data["procedure_place_os"]  = "";
  row_data["procedure_type_os"]   = "";
  row_data["procedure_code"]      = "";
  row_data["procedure_modifier"]  = "";
  row_data["procedure_diagnosis"] = "";
  row_data["procedure_note"]      = "";
  row_data["procedure_units"]     = "";
  row_data["procedure_charges"]   = "";
  row_data["procedure_residuals"] = "";
  row_data["procedure_allowed"]   = "";
  row_data["procedure_payment"]   = "";
  row_data["procedure_tooth"]     = "";
  row_data["procedure_surface"]   = "";
  row_data["procedure_epsdt"]     = "";
  row_data["procedure_emg"]       = "";
  row_data["procedure_cob"]       = "";
 }

 // update controls to reflect data in row_data
 editProcedureFrom->Text      = row_data["procedure_date_from"].c_str();
 editProcedureTo->Text        = row_data["procedure_date_to"].c_str();
 editProcedurePlace->Text     = row_data["procedure_place_os"].c_str();
 editProcedureType->Text      = row_data["procedure_type_os"].c_str();
 editProcedureCode->Text      = row_data["procedure_code"].c_str();
 editProcedureMod->Text       = row_data["procedure_modifier"].c_str();
 editProcedureDiagnosis->Text = row_data["procedure_diagnosis"].c_str();
 editProcedureNote->Text      = row_data["procedure_note"].c_str();
 editProcedureUnits->Text     = row_data["procedure_units"].c_str();
 editProcedureCharges->Text   = row_data["procedure_charges"].c_str();
 editProcedureResiduals->Text = row_data["procedure_residuals"].c_str();
 editProcedureAllowed->Text   = row_data["procedure_allowed"].c_str();
 editProcedurePayment->Text   = row_data["procedure_payment"].c_str();
 editProcedureTooth->Text     = row_data["procedure_tooth"].c_str();
 editProcedureSurface->Text   = row_data["procedure_surface"].c_str();
 editProcedureEPSDT->Text     = row_data["procedure_epsdt"].c_str();
 editProcedureEMG->Text       = row_data["procedure_emg"].c_str();
 editProcedureCOB->Text       = row_data["procedure_cob"].c_str();

 TWinControl *wanted_box = FindNextControl(scrollProcedures, true, true, false);
 if (wanted_box && wanted_box->Enabled && IsVisible(wanted_box))
  this->ActiveControl = wanted_box;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::editKeyPress(TObject *Sender, char &Key)
{
 TEdit * edit_box = (TEdit *)Sender;
 TWinControl * wanted_box = NULL;
 if (Key == VK_RETURN)
 {
  wanted_box = FindNextControl(edit_box, true, true, false);
  Key = 0;
 }
 else if (Key == VK_BACK)
 {
  if (edit_box->Text == "")
   wanted_box = FindNextControl(edit_box, false, true, false);
  // don't set Key = 0, prevents legit backspacing
 }
 if (wanted_box && wanted_box->Enabled && IsVisible(wanted_box))
  this->ActiveControl = wanted_box;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::scrollConditionsResize(TObject *Sender)
{
  if(ComponentState.Contains(csDestroying) || ComponentState.Contains(csFreeNotification))
    return;

  try
  {
    int vertical_needed = ArrangeControlsInline(scrollConditions, false, 15);
    scrollConditions->Height = vertical_needed;
    scrollConditions->Top = scrollConditions->Parent->ClientHeight - scrollConditions->Height;
    // don't ask me why the above is needed. resizing things with alignments just doesn't always work.
  }
  catch (...)
  {
  }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::listReferrersSelectItem(TObject *Sender, TListItem *Item, bool Selected)
{
  SwitchRadioSelection(radioReferrerSelect);
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::listExistingCobSelectItem(TObject *Sender, TListItem *Item, bool Selected)
{
  SwitchRadioSelection(radioCOBSelect);
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::sheetE_ConditionsShow(TObject *Sender)
{
 // focus?        
 ConditionSelected();
/*
 TWinControl * wanted_box = FindNextControl(scrollConditions, true, true, false);
 if (wanted_box && wanted_box->Enabled && IsVisible(wanted_box))
  this->ActiveControl = wanted_box;
*/
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::sheetF_ProceduresShow(TObject *Sender)
{
 // focus?
 ProcedureSelected();
/*
 TWinControl * wanted_box = FindNextControl(scrollProcedures, true, true, false);
 if (wanted_box && wanted_box->Enabled && IsVisible(wanted_box))
  this->ActiveControl = wanted_box;
*/
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::sheetA_NewBillShow(TObject *Sender)
{
 // focus?
 if (IsVisible(editCobNumber) && editCobNumber->Enabled)
  this->ActiveControl = editCobNumber;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::sheetG_PayBillShow(TObject *Sender)
{
 // focus?
 if (IsVisible(buttonNewBillTransactionsChange) && buttonNewBillTransactionsChange->Enabled)
  this->ActiveControl = buttonNewBillTransactionsChange;
}
//---------------------------------------------------------------------------
bool TformWizardNewContractHealthItem::FinishWizard ()
{
 bool success = false;

 TIBTransaction * dbTransaction = NULL;
 try
 {
  dbTransaction = new TIBTransaction(NULL);
  if (!dbTransaction)
   throw(0);
  StdTransaction(dbTransaction, dbDatabase);

  map<string, string> default_row;
  default_row["current_id"]        = "4";
  default_row["last_update_stamp"] = RightNow();
  default_row["last_updated_by"]   = current_userid;

  string fk_case  = selected_case_id;
  string fk_cob   = selected_cob_id; // this line was broken by a last-minute change (moving stuff here)
                                     // having a value won't break CreateCob(), as it immediately overwrites the variable.

  AtlasClear();

  string cob_id = ""; // jhaley 20101118
  if (start_page == 0)
   CreateBill(dbTransaction, default_row, fk_case, fk_cob);
  else if (start_page == 7)
   cob_id = CreateCob(dbTransaction, default_row, fk_case, fk_cob);
  else
   throw(-7);

  dbTransaction->Commit();
  AtlasSend();

  // jhaley 20120202: The ARRA form letter is not used any longer, so, don't do this at it was the only real point.
  /*
  // jhaley 20101118: Open the COB task record screen once the transaction is committed
  if (!IsBlankOrZero(cob_id))
  {
    map<string, string> cob_params;
    cob_params["id"] = cob_id;
    FORM_TRY
      TformRecordTaskCob *formCob = new TformRecordTaskCob(NULL, cob_params);
      formCob->Show();
    FORM_CATCH
    this->BringToFront();
  }
  */

  if (HistoryIncludes(7))
  {
   bool was_processing = IsProcessing();
   Processing(false);
   // people creating non-referrals as part of creating bills just want the launch screen so they can write down the number
   // people creating cob's want to just print, and don't care about the launch screen
   // yay!
   if (HistoryIncludes(0))
    TformLaunchPrintCobReport::Do(fk_cob, this);
   else
    TformLaunchPrintCobReport::DoSilently(fk_cob);
   Processing(was_processing);
  }

  success = true;
 }
 catch (int e)
 {
  PSay ("An error has been encountered. Your changes have not been saved.\n"
        "You may try again if the problem can be solved on your end (records open for editing, etc.)\n"
        "Please inform a programmer of this problem; the error log will have more information on its source.",
        m_program_error, MB_OK, "FinishWizard() failed on outer block for (" + IntToString(e) + ") reason");
 }
 catch (...)
 {
  PSay ("An error has been encountered. Your changes have not been saved.\n"
        "You may try again if the problem can be solved on your end (records open for editing, etc.)\n"
        "Please inform a programmer of this problem; the error log will have more information on its source.",
        m_program_error, MB_OK, "FinishWizard() failed on outer block for (...) reason");
 }

 if (dbTransaction)
 {
   if(dbTransaction->Active)
     dbTransaction->Rollback();
   delete dbTransaction;
 }

 return success;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::editProcedureFromExit(TObject *Sender)
{
 // moved stuff out of here ...
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::editProcedureToEnter(TObject *Sender)
{
 // ... yeah, to here.
 if (IsVisible(editProcedureFrom) && IsVisible(editProcedureTo) && editProcedureTo->Text == "")
 {
  editProcedureTo->Text = editProcedureFrom->Text;
  editProcedureTo->SelStart = 0;
  editProcedureTo->SelLength = editProcedureTo->Text.Length();
 }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::editCobNumberKeyPress(TObject *Sender, char &Key)
{
 if (Key == VK_RETURN)
 {
  buttonVerifyCOBNumber->Click();
  Key = 0;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::panelPaymentHelperResize(TObject *Sender)
{
 try
 {
  ArrangeControlsInline(panelPaymentHelper, false, 0);
  staticHelperPayTo->Refresh();
 }
 catch (...)
 {
 }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonExpandConditionCodeClick(TObject *Sender)
{
 if (editConditionCode->Text != "")
 {
  FORM_TRY
   TformSearchCode * codeSearch = new TformSearchCode(NULL, NULL);
   codeSearch->cboCode->Text = "ICD-9";
   codeSearch->editCode->Text = editConditionCode->Text;
   codeSearch->Show();
   codeSearch->buttonSearch->Click();
  FORM_CATCH
 }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonExpandProcedureCodeClick(TObject *Sender)
{
 if (editProcedureCode->Text != "")
 {
  FORM_TRY
   TformSearchCode * codeSearch = new TformSearchCode(NULL, NULL);
   codeSearch->cboCode->Text  = "";
   codeSearch->editCode->Text = editProcedureCode->Text;
   codeSearch->Show();
   codeSearch->buttonSearch->Click();
  FORM_CATCH
 }
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::Do()
{
 // assumptions?
 TformWizardNewContractHealthItem::Do(false);
}
//---------------------------------------------------------------------------
void TformWizardNewContractHealthItem::Do(bool p_is_bill)
{
 FORM_TRY
  TformWizardNewContractHealthItem * z = new TformWizardNewContractHealthItem(NULL, p_is_bill);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::staticAppointmentContractClick(TObject *Sender)
{
  TformRecordEntityContract::FindAppropriate(selected_service_provider_id, Pdate(dateApptDate->DateTime));
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonRelevantProviderContractClick(
      TObject *Sender)
{
 TformRecordEntityContract::FindAppropriate(selected_provider_id, Pdate(dateVisitDate->DateTime));
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonRelevantFacilityContractClick(
      TObject *Sender)
{
 TformRecordEntityContract::FindAppropriate(selected_facility_id, Pdate(dateVisitDate->DateTime));
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewContractHealthItem::buttonRelevantGroupContractClick(
      TObject *Sender)
{
 TformRecordEntityContract::FindAppropriate(selected_group_id, Pdate(dateVisitDate->DateTime));
}
//---------------------------------------------------------------------------
// jhaley 20100903: Added to allow clicking on the insurance overview list.
void TformWizardNewContractHealthItem::EditOverviewInsurance()
{
  string selected_id = list_overview_insurances.GetSelectedRecordID();

  if (!IsBlankOrZero(selected_id))
  {
    pageEligibility->ActivePage = sheetInsurance;

    set<string> just_one_id;
    just_one_id.insert(selected_id);
    list_insurances.SetCheckedWhereID(just_one_id, true);
    list_insurances.MoveToFirstUsefulItem();
  }
  else if (IDOK == PSay("There is no insurance coverage for this coverage area.\n"
                        "Do you want to review the existing coverage?", m_confirmation, MB_OKCANCEL))
  {
    // Let's not allow adding one until they've at least looked at what exists. So here, we only offer to show the tab
    // and not to create one directly. Also, not asking and just going first leads to looking at whatever item was
    // previously selected (if any), which is misleading at best.
    pageEligibility->ActivePage = sheetInsurance;
  }
}
//---------------------------------------------------------------------------
// jhaley 20100903: Added to allow clicking on the consents overview list.
void TformWizardNewContractHealthItem::EditOverviewConsent()
{
  string selected_id = list_overview_consents.GetSelectedRecordID();
  bool has_add_perms = list_consents.HasSecurityAdd(); // 20100907: Don't do a runaround on the filter permissions mechanism.

  if (!IsBlankOrZero(selected_id))
  {
    pageEligibility->ActivePage = sheetConsents;

    set<string> just_one_id;
    just_one_id.insert(selected_id);
    list_consents.SetCheckedWhereID(just_one_id, true);
    list_consents.MoveToFirstUsefulItem();
  }
  else if (has_add_perms && IDOK == PSay("There are no consents for this patient.\n"
                                         "Do you want to create a new consent?", m_confirmation, MB_OKCANCEL))
  {
    // When there are no consents, it makes sense to offer to add one directly.
    AddConsent();
  }
}
//---------------------------------------------------------------------------
// jhaley 20100903: Added to allow clicking on the notes overview list.
void TformWizardNewContractHealthItem::EditOverviewNote()
{
  // Just go to the main page.
  pageEligibility->ActivePage = sheetNotes;
}
//---------------------------------------------------------------------------
// jhaley 20110921: Added to display # of contracts in link on page 4
void TformWizardNewContractHealthItem::SetApptContractsLinkText(bool default_text)
{
  if(default_text || // If default_text is true, always set the default text.
     !IsInt(selected_service_provider_id) || IsBlankOrZero(selected_service_provider_id))
  {
    staticAppointmentContract->Caption = "View contract(s) effective on the appointment date";
  }
  else
  {
    int num_contracts =
      TformRecordEntityContract::CheckNumContracts(selected_service_provider_id, Pdate(dateApptDate->DateTime));

    if(num_contracts >= 0)
    {
      staticAppointmentContract->Caption =
        (string("View ") + IntToString(num_contracts) + " contract(s) effective on the appointment date").c_str();
    }
    else
    {
      // Uh oh... >_>
      staticAppointmentContract->Caption = "View contract(s) effective on the appointment date (error getting number)";
    }
  }
}
//---------------------------------------------------------------------------
