//---------------------------------------------------------------------------

#ifndef codeWizardNewContractHealthItemH
#define codeWizardNewContractHealthItemH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeWizardGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <Buttons.hpp>
#include <CheckLst.hpp>
#include "codeDrawerGeneric.h"
#include <ImgList.hpp>
#include "codeSpecialTransactionEntry.h"
#include "codeSpecialPersonLimits.h"
#include "launchPrintCobReport.h"
#include "codeRubberContainer.h"
//---------------------------------------------------------------------------
class TformWizardNewContractHealthItem : public TformWizardGeneric
{
__published:	// IDE-managed Components
        TTabSheet *sheetA_NewBill;
        TTabSheet *sheetB_Eligibility;
        TTabSheet *sheetC_NewCase;
        TTabSheet *sheetD_Bill;
        TTabSheet *sheetE_Conditions;
        TTabSheet *sheetF_Procedures;
        TTabSheet *sheetG_PayBill;
        TTabSheet *sheetH_NewCOB;
        TTabSheet *sheetI_InReferrals;
        TTabSheet *sheetJ_Appointment;
        TTabSheet *sheetK_Limits;
        TTabSheet *sheetL_ER;
        TTabSheet *sheetN_OutReferrals;
        TGroupBox *groupCob;
        TLabel *_labelEditCobNumber;
        TLabel *_labelStaticPatient;
        TLabel *_labelExistingCobEr;
        TRadioButton *radioCOBKnown;
        TRadioButton *radioCOBSelect;
        TEdit *editCobNumber;
        TStaticText *staticPatient;
        TBitBtn *buttonSearchPatient;
        TRadioButton *radioCOBCreate;
        TListView *listExistingCob;
        TGroupBox *groupTaxEntities;
        TRadioButton *radioPayProvider;
        TStaticText *staticTaxProvider;
        TBitBtn *buttonSearchTaxProvider;
        TBitBtn *buttonSearchTaxFacility;
        TStaticText *staticTaxFacility;
        TRadioButton *radioPayFacility;
        TRadioButton *radioPayGroup;
        TStaticText *staticTaxGroup;
        TBitBtn *buttonSearchTaxGroup;
        TGroupBox *groupBillType;
        TRadioButton *radioIsHCFA;
        TRadioButton *radioIsUB;
        TGroupBox *groupAmounts;
        TLabel *_labelOriginalCharges;
        TLabel *_labelResidualCharges;
        TLabel *_labelControlNumber;
        TEdit *editOriginalCharges;
        TEdit *editResidualCharges;
        TEdit *editControlNumber;
        TGroupBox *groupTransactionSummary;
        TLabel *_labelBillSummary;
        TCheckBox *checkBillShowAccount;
        TCheckBox *checkBillShowEntity;
        TGroupBox *groupPatient;
        TLabel *_labelPatient;
        TStaticText *staticPerson;
        TBitBtn *buttonSearchPerson;
        TGroupBox *groupProvider;
        TLabel *_labelProvider;
        TLabel *_labelService;
        TStaticText *staticServiceProvider;
        TBitBtn *buttonSearchServiceProvider;
        TListView *listServices;
        TGroupBox *groupReferrer;
        TLabel *_labelReferrerSearch;
        TLabel *_labelReferrerSelect;
        TRadioButton *radioReferrerNone;
        TRadioButton *radioReferrerSelect;
        TRadioButton *radioReferrerSearch;
        TListView *listReferrers;
        TStaticText *staticReferrer;
        TBitBtn *buttonSearchReferrer;
        TGroupBox *groupAppointment;
        TLabel *_labelApptDate;
        TLabel *_labelApptTime;
        TLabel *_labelApptReason;
        TDateTimePicker *dateApptDate;
        TDateTimePicker *dateApptTime;
        TRichEdit *editApptReason;
        TGroupBox *groupEmergencyRoom;
        TLabel *_labelPreCond;
        TLabel *_labelFollowup;
        TLabel *_labelReportedBy;
        TRichEdit *editPreCond;
        TRichEdit *editFollowup;
        TCheckBox *checkWasHosp;
        TCheckBox *checkWasRoom;
        TEdit *editReportedBy;
        TGroupBox *groupCoordOfBenefits;
        TLabel *_labelLimits;
        TLabel *_labelStandardText;
        TLabel *_labelDoubleClick;
        TButton *buttonAddText;
        TTabSheet *sheetM_PayCOB;
        TGroupBox *groupTransactions;
        TLabel *_labelCOBSummary;
        TListView *listNewCOBTransactions;
        TButton *buttonNewCOBTransactionsChange;
        TCheckBox *checkCOBShowAccount;
        TCheckBox *checkCOBShowEntity;
        TGroupBox *groupCaseEntities;
        TListView *listCaseEntities;
        TButton *buttonCaseEntityAdd;
        TButton *buttonCaseEntityRemove;
        TButton *buttonCaseEntityClear;
        TButton *buttonCaseEntitySave;
        TStaticText *staticCaseEntity;
        TBitBtn *buttonSearchCaseEntity;
        TLabel *_labelCaseEntity;
        TLabel *_labelCaseEntityType;
        TComboBox *comboCaseEntityType;
        TGroupBox *groupCase;
        TEdit *editCaseAccidentDate;
        TEdit *editCaseDescription;
        TEdit *editCaseReportDate;
        TEdit *editCaseSubrogationDate;
        TComboBox *comboCaseType;
        TLabel *_labelCaseType;
        TLabel *_labelCaseAccidentDate;
        TLabel *_labelCaseDescription;
        TLabel *_labelCaseReportDate;
        TLabel *_labelCaseSubrogationDate;
        TButton *buttonNewCOBTransactionsClear;
        TGroupBox *groupOutReferrals;
        TListView *listOutReferrals;
        TButton *buttonOutReferralAdd;
        TButton *buttonOutReferralRemove;
        TButton *buttonOutReferralClear;
        TButton *buttonOutReferralSave;
        TGroupBox *groupCOBTypeSelection;
        TRadioButton *radioCoordinationOfBenefits;
        TRadioButton *radioNonReferral;
        TRadioButton *radioEmergencyRoomNotice;
        TLabel *_labelOutReferralEntity;
        TStaticText *staticOutReferralEntity;
        TBitBtn *buttonSearchOutReferralEntity;
        TEdit *editOutReferralNote;
        TLabel *_labelOutReferralNote;
        TTabSheet *sheetO_Visit;
        TGroupBox *groupVisit;
        TLabel *_labelVisitDate;
        TLabel *_labelVisitTime;
        TLabel *_labelVisitReason;
        TDateTimePicker *dateVisitDate;
        TDateTimePicker *dateVisitTime;
        TRichEdit *editVisitReason;
        TLabel *_labelStaticPatient2;
        TStaticText *staticPatient2;
        TBitBtn *buttonSearchPatient2;
        TRadioButton *radioCOBSearch;
        TLabel *_labelStaticCOB;
        TStaticText *staticCOB;
        TBitBtn *buttonSearchCOB;
        TLabel *_labelObligation;
        TPanel *panelLimitNotes;
        TRichEdit *editLimits;
        TCheckListBox *listStandardText;
        TSplitter *splitterLimitNotes;
        TPanel *panelResultTransactions;
        TSplitter *splitterResultTransactions;
        TRadioButton *radioIsADA;
        TToolButton *buttonHelper;
        TGroupBox *groupProcedures;
        TButton *buttonProcedureAdd;
        TButton *buttonProcedureRemove;
        TButton *buttonProcedureClear;
        TGroupBox *groupConditions;
        TButton *buttonConditionAdd;
        TButton *buttonConditionRemove;
        TButton *buttonConditionClear;
        TButton *buttonConditionSave;
        TButton *buttonProcedureSave;
        TPanel *panelProcedures;
        TScrollBox *scrollProcedures;
        TPanel *panelProcedureFrom;
        TLabel *_labelProcedureFrom;
        TEdit *editProcedureFrom;
        TPanel *panelProcedureTo;
        TLabel *_labelProcedureTo;
        TEdit *editProcedureTo;
        TPanel *panelProcedurePlace;
        TLabel *_labelProcedurePlace;
        TEdit *editProcedurePlace;
        TPanel *panelProcedureCode;
        TLabel *_labelProcedureCode;
        TEdit *editProcedureCode;
        TPanel *panelProcedureMod;
        TLabel *_labelProcedureMod;
        TEdit *editProcedureMod;
        TPanel *panelProcedureDiagnosis;
        TLabel *_labelProcedureDiagnosis;
        TEdit *editProcedureDiagnosis;
        TPanel *panelProcedureCharges;
        TLabel *_labelProcedureCharges;
        TEdit *editProcedureCharges;
        TPanel *panelProcedureUnits;
        TLabel *_labelProcedureUnits;
        TEdit *editProcedureUnits;
        TPanel *panelProcedureNote;
        TLabel *_labelProcedureNote;
        TEdit *editProcedureNote;
        TPanel *panelProcedurePayment;
        TLabel *_labelProcedurePayment;
        TEdit *editProcedurePayment;
        TPanel *panelProcedureResiduals;
        TLabel *_labelProcedureResiduals;
        TEdit *editProcedureResiduals;
        TPanel *panelProcedureTooth;
        TLabel *_labelProcedureTooth;
        TEdit *editProcedureTooth;
        TPanel *panelProcedureSurface;
        TLabel *_labelProcedureSurface;
        TEdit *editProcedureSurface;
        TPanel *panelProcedureType;
        TLabel *_labelProcedureType;
        TEdit *editProcedureType;
        TPanel *panelProcedureEPSDT;
        TLabel *_labelProcedureEPSDT;
        TEdit *editProcedureEPSDT;
        TPanel *panelProcedureEMG;
        TLabel *_labelProcedureEMG;
        TEdit *editProcedureEMG;
        TPanel *panelProcedureCOB;
        TLabel *_labelProcedureCOB;
        TEdit *editProcedureCOB;
        TPanel *panelConditions;
        TScrollBox *scrollConditions;
        TPanel *panelConditionIndex;
        TLabel *_labelConditionIndex;
        TEdit *editConditionIndex;
        TPanel *panelConditionCode;
        TLabel *_labelConditionCode;
        TEdit *editConditionCode;
        TPanel *panelConditionsSplitter;
        TPanel *panelProceduresSplitter;
        TPanel *panelConditionNote;
        TLabel *_labelConditionNote;
        TEdit *editConditionNote;
        TPanel *panelProcedureAllowed;
        TLabel *_labelProcedureAllowed;
        TEdit *editProcedureAllowed;
        TTabSheet *sheetP_Duplicates;
        TGroupBox *groupDuplicates;
        TPanel *panelDupes;
        TSplitter *splitterDupes;
        TPanel *panelDupeBills;
        TLabel *_labelDupeBills;
        TListView *listDupeBills;
        TPanel *panelDupeCOBs;
        TLabel *_labelDupeCOBs;
        TListView *listDupeCOBs;
        TSplitter *Splitter1;
        TPanel *panelDupeVisits;
        TLabel *_labelDupeVisits;
        TListView *listDupeVisits;
        TPanel *panelOldCOBTransactions;
        TPanel *panelNewBillTransactions;
        TListView *listOldCOBTransactions;
        TListView *listNewBillTransactions;
        TButton *buttonOldCOBTransactionsClear;
        TButton *buttonOldCOBTransactionsChange;
        TButton *buttonNewBillTransactionsClear;
        TButton *buttonNewBillTransactionsChange;
        TLabel *_labelDeobligation;
        TLabel *_labelPayment;
        TButton *buttonMoveCOBTransactionsDown;
        TButton *buttonMoveBillTransactionsUp;
        TListView *listConditions;
        TListView *listProcedures;
        TBitBtn *buttonVerifyCOBNumber;
        TLabel *_labelDollarCharges;
        TLabel *_labelDollarResidual;
        TLabel *_labelDollarProcedureResiduals;
        TLabel *_labelDollarProcedureCharges;
        TLabel *_labelDollarProcedurePayment;
        TLabel *_labelDollarProcedureAllowed;
        TRadioButton *radioIsOther;
        TLabel *lblStatus;
        TComboBox *comboOutReferralStatus;
        TLabel *lblReason;
        TComboBox *comboOutReferralReason;
        TPanel *panelPaymentHelper;
        TPanel *panelHelperBillSummary;
        TLabel *_labelHelperBillSummary;
        TPanel *panelHelperBillOriginalCharges;
        TLabel *_labelHelperBillOriginalCharges;
        TLabel *labelHelperBillOriginalCharges;
        TPanel *panelHelperBillResidualCharges;
        TLabel *_labelHelperBillResidualCharges;
        TLabel *labelHelperBillResidualCharges;
        TPanel *panelHelperBillPayTo;
        TLabel *_labelHelperBillPayTo;
        TStaticText *staticHelperPayTo;
        TPanel *panelHelperProcedureSummary;
        TLabel *_labelHelperProcedureSummary;
        TPanel *panelHelperProcedureOriginalCharges;
        TLabel *_labelHelperProcedureOriginalCharges;
        TLabel *labelHelperProcedureOriginalCharges;
        TPanel *panelHelperProcedureResidualCharges;
        TLabel *_labelHelperProcedureResidualCharges;
        TLabel *labelHelperProcedureResidualCharges;
        TPanel *panelHelperProcedureAllowed;
        TLabel *_labelHelperProcedureAllowed;
        TLabel *labelHelperProcedureAllowed;
        TPanel *panelHelperProcedurePayment;
        TLabel *_labelHelperProcedurePayment;
        TLabel *labelHelperProcedurePayment;
        TPanel *panelHelperTransactionSummary;
        TLabel *_labelHelperTransactionSummary;
        TPanel *panelHelperTransactionPayment;
        TLabel *labelHelperTransactionPayment;
        TLabel *_labelHelperTransactionPayment;
        TButton *buttonExpandConditionCode;
        TButton *buttonExpandProcedureCode;
        TStaticText *staticAppointmentContract;
        TBitBtn *buttonRelevantProviderContract;
        TBitBtn *buttonRelevantFacilityContract;
        TBitBtn *buttonRelevantGroupContract;
        TPageControl *pageEligibility;
        TTabSheet *sheetInsurance;
        TListView *listInsurance;
        TTabSheet *sheetCases;
        TLabel *_labelCase;
        TListView *listCases;
        TRadioButton *radioCaseNone;
        TRadioButton *radioCaseCreate;
        TRadioButton *radioCaseSelect;
        TTabSheet *sheetConsents;
        TListView *listConsents;
        TTabSheet *sheetNotes;
        TListView *listNotes;
        TTabSheet *sheetLimits;
        TPanel *panelLimits;
        TTabSheet *sheetOverview;
        TLabel *_labelOverviewInsurance;
        TLabel *_labelOverviewConsents;
        TLabel *_labelOverviewNotes;
        TRubberContainer *rubberOverviewInsurance;
        TListView *listOverviewInsurance;
        TRubberContainer *RubberContainer1;
        TListView *listOverviewConsents;
        TRubberContainer *RubberContainer2;
        TListView *listOverviewNotes;
        void __fastcall buttonSearchPatientClick(TObject *Sender);
        void __fastcall buttonSearchCaseEntityClick(TObject *Sender);
        void __fastcall buttonSearchTaxProviderClick(TObject *Sender);
        void __fastcall buttonSearchTaxFacilityClick(TObject *Sender);
        void __fastcall buttonSearchTaxGroupClick(TObject *Sender);
        void __fastcall buttonSearchPersonClick(TObject *Sender);
        void __fastcall buttonSearchServiceProviderClick(TObject *Sender);
        void __fastcall buttonSearchReferrerClick(TObject *Sender);
        void __fastcall buttonSearchOutReferralEntityClick(
          TObject *Sender);
        void __fastcall buttonSearchCOBClick(TObject *Sender);
        void __fastcall listExistingCobChanging(TObject *Sender,
          TListItem *Item, TItemChange Change, bool &AllowChange);
        void __fastcall listCasesChanging(TObject *Sender, TListItem *Item,
          TItemChange Change, bool &AllowChange);
        void __fastcall listServicesChanging(TObject *Sender,
          TListItem *Item, TItemChange Change, bool &AllowChange);
        void __fastcall listReferrersChanging(TObject *Sender,
          TListItem *Item, TItemChange Change, bool &AllowChange);
        void __fastcall buttonCaseEntityAddClick(TObject *Sender);
        void __fastcall buttonCaseEntityRemoveClick(TObject *Sender);
        void __fastcall buttonCaseEntityClearClick(TObject *Sender);
        void __fastcall buttonCaseEntitySaveClick(TObject *Sender);
        void __fastcall buttonMoveCOBTransactionsDownClick(
          TObject *Sender);
        void __fastcall buttonMoveBillTransactionsUpClick(TObject *Sender);
        void __fastcall buttonOldCOBTransactionsClearClick(
          TObject *Sender);
        void __fastcall buttonOldCOBTransactionsChangeClick(
          TObject *Sender);
        void __fastcall buttonNewBillTransactionsClearClick(
          TObject *Sender);
        void __fastcall buttonNewBillTransactionsChangeClick(
          TObject *Sender);
        void __fastcall buttonAddTextClick(TObject *Sender);
        void __fastcall buttonNewCOBTransactionsClearClick(
          TObject *Sender);
        void __fastcall buttonNewCOBTransactionsChangeClick(
          TObject *Sender);
        void __fastcall buttonOutReferralAddClick(TObject *Sender);
        void __fastcall buttonOutReferralRemoveClick(TObject *Sender);
        void __fastcall buttonOutReferralClearClick(TObject *Sender);
        void __fastcall buttonOutReferralSaveClick(TObject *Sender);
        void __fastcall RefreshBillTransactionsClick(TObject *Sender);
        void __fastcall RefreshCOBTransactionsClick(TObject *Sender);
        void __fastcall buttonVerifyCOBNumberClick(TObject *Sender);
        void __fastcall listStandardTextDblClick(TObject *Sender);
        void __fastcall sheetLimitsShow(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall buttonHelperClick(TObject *Sender);
        void __fastcall scrollProceduresResize(TObject *Sender);
        void __fastcall buttonConditionAddClick(TObject *Sender);
        void __fastcall buttonConditionRemoveClick(TObject *Sender);
        void __fastcall buttonConditionClearClick(TObject *Sender);
        void __fastcall buttonConditionSaveClick(TObject *Sender);
        void __fastcall buttonProcedureAddClick(TObject *Sender);
        void __fastcall buttonProcedureRemoveClick(TObject *Sender);
        void __fastcall buttonProcedureClearClick(TObject *Sender);
        void __fastcall buttonProcedureSaveClick(TObject *Sender);
        void __fastcall editKeyPress(TObject *Sender,
          char &Key);
        void __fastcall scrollConditionsResize(TObject *Sender);
        void __fastcall listReferrersSelectItem(TObject *Sender,
          TListItem *Item, bool Selected);
        void __fastcall listExistingCobSelectItem(TObject *Sender,
          TListItem *Item, bool Selected);
        void __fastcall sheetE_ConditionsShow(TObject *Sender);
        void __fastcall sheetF_ProceduresShow(TObject *Sender);
        void __fastcall sheetA_NewBillShow(TObject *Sender);
        void __fastcall sheetG_PayBillShow(TObject *Sender);
        void __fastcall editProcedureFromExit(TObject *Sender);
        void __fastcall editProcedureToEnter(TObject *Sender);
        void __fastcall editCobNumberKeyPress(TObject *Sender, char &Key);
        void __fastcall panelPaymentHelperResize(TObject *Sender);
        void __fastcall buttonExpandConditionCodeClick(TObject *Sender);
        void __fastcall buttonExpandProcedureCodeClick(TObject *Sender);
        void __fastcall staticAppointmentContractClick(TObject *Sender);
        void __fastcall buttonRelevantProviderContractClick(
          TObject *Sender);
        void __fastcall buttonRelevantFacilityContractClick(
          TObject *Sender);
        void __fastcall buttonRelevantGroupContractClick(TObject *Sender);
private:	// User declarations
        // VARIABLES
        TformDrawerGeneric * helper_window;
        TformSpecialPersonLimits * embedded_limits;
        int last_offset_used;

        // list handlers
        // ... read-only lists
        classFilterObject list_cases;
        classFilterObject list_consents;
        classFilterObject list_cobs;
        classFilterObject list_insurances;
        classFilterObject list_notes;
        classFilterObject list_referrers;
        classFilterObject list_services;
        classFilterObject list_dupe_cobs;
        classFilterObject list_dupe_visits;
        classFilterObject list_dupe_bills;
        classFilterObject list_overview_insurances; // jhaley 20100902
        classFilterObject list_overview_consents;
        classFilterObject list_overview_notes;
        // ... read-write lists
        edit_listview list_case_entities;
        edit_listview list_procedures;
        edit_listview list_conditions;
        edit_listview list_new_bill_transactions;
        edit_listview list_new_cob_transactions;
        edit_listview list_old_cob_transactions;
        edit_listview list_out_referrals;

        // filter data sources - jhaley 20100902
        classFilterVecmapSource *source_overview_insurances;
        classFilterVecmapSource *source_overview_consents;
        classFilterVecmapSource *source_overview_notes;

        // searched/selected id values
        // ... accounting
        string default_result_cob_entity_id;
        // ... read-write lists
        string chosen_case_entity_id;
        string chosen_out_referrer_id;
        // ... read-only lists, links
        string selected_cob_id;
        string selected_case_id;
        string selected_provider_id;
        string selected_facility_id;
        string selected_group_id;
        string selected_person_id;
        string selected_service_provider_id;
        string selected_service_id;
        string selected_referrer_id;
        // ... extra
        string selected_actual_id; // result of provider_id / facility_id / group_id
        Pdate  event_date;

        // atlas requests
        // ... for links (temp or not)
        int request_case_entity_id;
        int request_out_referrer_id;
        int request_cob_id;
        int request_provider_id;
        int request_facility_id;
        int request_group_id;
        int request_person_id;
        int request_service_provider_id;
        int request_referrer_id;
        // ... and for listviews
        int request_cobs_person_id;
        int request_cases_person_id;
        int request_services_provided_provider_id;
        int request_consents_person_id;
        int request_insurance_person_id;
        int request_notes_person_id;
        int request_referrers_is_referrer;
        int request_dupe_cob_id;
        int request_dupe_bill_id;

        // accounting
        financial sum_bill_charges;
        financial sum_bill_residuals;
        financial sum_procedure_charges;
        financial sum_procedure_residuals;
        financial sum_procedure_allowed;
        financial sum_procedure_payments;
        transaction_summary tx_original_cob;
        transaction_summary tx_result_cob;
        transaction_summary tx_result_bill;

        // FUNCTIONS
        // redraw links, upon manual or atlas-generated change
        void RefreshCaseEntityId ();
        void RefreshOutReferrerId ();
        void RefreshCobId ();
        void RefreshProviderId ();
        void RefreshFacilityId ();
        void RefreshGroupId ();
        void RefreshOverviews(); // jhaley 20100902
        void RefreshPersonId ();
        void RefreshServiceProviderId ();
        void RefreshReferrerId ();
        void RefreshEventDate ();


        // callbacks for rows being selected
        void CaseEntitySelected ();
        void ConditionSelected ();
        void ProcedureSelected ();
        void OutReferralSelected ();

        // callbacks for add/edit
        // void AddCase();
        void EditCase();
        void AddConsent();
        void EditConsent();
        // void AddCob();
        void EditCob();
        void EditDupeCob();
        void EditDupeVisit();
        void EditDupeBill();
        void AddInsurance();
        void EditInsurance();
        void AddNote();
        void EditNote();
        // void AddReferrer();
        void EditReferrer();
        void AddService();
        void EditService();
        void EditOverviewInsurance(); // jhaley
        void EditOverviewConsent();
        void EditOverviewNote();
        void SetApptContractsLinkText(bool default_text = false); // jhaley

        // other
        void   CreateCase(TIBTransaction * dbTransaction, map<string, string> default_row, string & fk_case);
        string CreateCob (TIBTransaction * dbTransaction, map<string, string> default_row, string & fk_case, string & fk_cob);
        void   CreateBill(TIBTransaction * dbTransaction, map<string, string> default_row, string & fk_case, string & fk_cob);
        // void RefreshChecklist();
        void RefreshTotals ();
        void DrawerIsChanging (TformSpecialGeneric * Drawer, bool Expanding);

        void AtlasNotification (int request_num, string matched_value);

        bool SkipPage    (int page_index);
        bool IsValidPage (int page_index);
         int WhereNext   (int page_index);
        bool ProcessPage (int page_index);
        void SetupPage   (int page_index);
        bool FinishWizard ();
        void PageLockStatus (int page_index, bool locked);
public:		// User declarations
        __fastcall TformWizardNewContractHealthItem(TComponent* Owner, bool p_is_bill);
        static void Do();
        static void Do(bool p_is_bill);
};
//---------------------------------------------------------------------------
extern PACKAGE TformWizardNewContractHealthItem *formWizardNewContractHealthItem;
//---------------------------------------------------------------------------
#endif
