//---------------------------------------------------------------------------

#ifndef codeWizardNewPurchaseRequestH
#define codeWizardNewPurchaseRequestH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeWizardGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>
//---------------------------------------------------------------------------
class TformWizardNewPurchaseRequest : public TformWizardGeneric
{
__published:	// IDE-managed Components
        TTabSheet *sheetA;
        TTabSheet *sheetB;
        TGroupBox *groupTaxEntity;
        TGroupBox *groupBills;
        TListView *listTaxEntities;
        TListView *listBills;
        TTabSheet *sheetC;
        TGroupBox *groupPurchaseReq;
        TLabel *_labelPrintingInstructions;
        TLabel *_labelSummaryTaxEntity;
        TStaticText *staticSummaryTaxEntity;
        TLabel *_labelSummaryTaxNumber;
        TLabel *labelSummaryTaxNumber;
        TLabel *_labelSummaryTaxEntityAddress;
        TLabel *labelSummaryTaxEntityAddress1;
        TLabel *labelSummaryTaxEntityAddress2;
        TLabel *labelSummaryTaxEntityAddress3;
        TLabel *_labelPurchaseReqDate;
        TRadioButton *radioUseGenerator;
        TRadioButton *radioUseSpecialNumber;
        TEdit *editPurchaseReqNumber;
        TDateTimePicker *datePurchaseReqDate;
        TEdit *editExpReason;
        TLabel *_labelExpReason;
        void __fastcall listBillsChanging(TObject *Sender, TListItem *Item,
          TItemChange Change, bool &AllowChange);
        void __fastcall listTaxEntitiesChanging(TObject *Sender,
          TListItem *Item, TItemChange Change, bool &AllowChange);
private:	// User declarations
        classFilterObject tax_entities_filter;
        classFilterObject bills_filter;

        string chosen_tax_entity_id;
        vector<string> chosen_bill_id;
        Pdate chosen_date;
        string chosen_number;
        bool use_chosen_number;

        int tax_request_any;
        int tx_request_any;
        int bill_request_any;

        int tax_request_specific;
        int tx_request_specific;
        int bill_request_specific;

        void EditTaxEntity();
        void EditBill();
        void AtlasScreen (int request_num, string matched_value);
        void RefreshTaxEntityInfo ();
        bool CheckBill(const map<string, string> & p_row);
protected:
        bool IsValidPage (int page_index);
         int WhereNext   (int page_index);
        bool ProcessPage (int page_index);
        void SetupPage   (int page_index);
        bool FinishWizard ();
        void PageLockStatus (int page_index, bool locked);
public:		// User declarations
        __fastcall TformWizardNewPurchaseRequest(TComponent* Owner);
        static void Do();
};
//---------------------------------------------------------------------------
extern PACKAGE TformWizardNewPurchaseRequest *formWizardNewPurchaseRequest;
//---------------------------------------------------------------------------
#endif
