//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#pragma warn -8057

#include "codeSearchTaxEntity.h"
#include "codeWizardNewVendorBill.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeWizardGeneric"
#pragma resource "*.dfm"
TformWizardNewVendorBill *formWizardNewVendorBill;
//---------------------------------------------------------------------------
__fastcall TformWizardNewVendorBill::TformWizardNewVendorBill(TComponent* Owner)
        : TformWizardGeneric(Owner)
{
 // no combo boxes at all at this point!
 // links set up in SetupPage() with values
 // SetExpectedPages(3);

 edit_after.setup_listview(listAfter, false);

 Initialize();
}
//--------------------------------------------------------------------------- 
bool TformWizardNewVendorBill::IsValidPage (int page_index)
{
 switch (page_index)
 {
  case 0:
  {
   // [x] - tax entity must be set
   // [x] - tax entity must have a federal tax id number of some sort
   // [?] - if invoice number is given, check for dupes
   //       else, warn no check is being performed
   // [x] - date must be set, should be before today (warn otherwise)
   // [x] - invoice amount must be set, greater than zero
   if (invoice_tax_entity_id.empty() || invoice_tax_entity_id == "0")
   {
    PSay("No payee (tax entity) provided.", m_invalid_data, MB_OK);
    return false;
   }

   string found_tax_id_number = GetOneField(dbDatabase, "select tin.identifier "
                                                        "from tax_entities "
                                                        "left join entity_ids tin on tin.tax_entity_id = tax_entities.id and tin.current_id >= 3 and tin.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "TIN/EIN") + "' "
                                                        "where tax_entities.id = " + invoice_tax_entity_id);
   if (found_tax_id_number.empty())
   {
    PSay("Payee (tax entity) has no federal tax id number.", m_invalid_data, MB_OK);
    return false;
   }

   if (Pdate(dateInvoiceDate->Date) > Pdate(Date()))
   {
    if (IDNO == PSay("The invoice date you have specified seems suspicious.\nMost invoices are for items or services purchased in the past, not the present or future.\nAre you sure you want to continue with the given invoice date?", m_invalid_data, MB_YESNO))
     return false;
   }

   if (!IsAmount(editInvoiceAmount->Text.c_str()))
   {
    PSay("Invalid invoice amount indicated.", m_invalid_data, MB_OK);
    return false;
   }

   if (StringToFinancial(editInvoiceAmount->Text.c_str()) <= financial(0.00))
   {
    PSay("Invoice amount must be positive.", m_invalid_data, MB_OK);
    return false;
   }

   string given_invoice_number = editInvoiceNumber->Text.c_str();
   // a) tax entity
   // b) invoice number
   // c) date
   // d) amount
   string invoice_amount = FinancialToString(StringToFinancial(editInvoiceAmount->Text.c_str()));

   string find_ = "select count(*) from bills where ";
   string find_a = "actual_tax_id = " + invoice_tax_entity_id + " ";
   string find_b = "invoice_number = '" + given_invoice_number + "' ";
   string find_c = "bill_date = '" + Pdate(dateInvoiceDate->Date).OutDate(global_mode) + "' ";
   string find_d = "(total_charge = " + invoice_amount + " or "
                   "invoice_amount = " + invoice_amount + " or "
                   "paid_amount = " + invoice_amount + ") ";
   string find_same_ab = find_ + find_a + "and " + find_b;
   string find_same_abc = find_same_ab + "and " + find_c;
   string find_same_abcd = find_same_abc + "and " + find_d;
   string find_same_abd = find_same_ab + "and " + find_d;
   string find_same_ac  = find_ + find_a + "and " + find_c;
   string find_same_acd = find_ + find_a + "and " + find_c + "and " + find_d;
   string find_same_bcd = find_ + find_b + "and " + find_c + "and " + find_d;

   string count_same_ab   = GetOneField(dbDatabase, find_same_ab);
   string count_same_abc  = GetOneField(dbDatabase, find_same_abc);
   string count_same_abcd = GetOneField(dbDatabase, find_same_abcd);
   string count_same_abd  = GetOneField(dbDatabase, find_same_abd);
   string count_same_ac   = GetOneField(dbDatabase, find_same_ac);
   string count_same_acd  = GetOneField(dbDatabase, find_same_acd);
   string count_same_bcd  = GetOneField(dbDatabase, find_same_bcd);

   if (count_same_ab != "0" || count_same_abc != "0" || count_same_abcd != "0" || count_same_abd != "0" || count_same_ac != "0" || count_same_acd != "0" || count_same_bcd != "0")
   {
    string message_about_duplicates = "The following is a summary of possible duplicates:\n\n";
    message_about_duplicates += count_same_ab + " with the same vendor and invoice number;\n";
    message_about_duplicates += count_same_abc + " with the same vendor, invoice number, and date;\n";
    message_about_duplicates += count_same_abcd + " with the same vendor, invoice number, date, and amount;\n";
    message_about_duplicates += count_same_abd + " with the same vendor, invoice number, and amount;\n";
    message_about_duplicates += count_same_ac + " with the same vendor and date;\n";
    message_about_duplicates += count_same_acd + " with the same vendor, date, and amount;\n";
    message_about_duplicates += count_same_bcd + " with the same invoice number, date, and amount.\n\n";
    message_about_duplicates += "(Some of the above numbers may overlap, depending on the criteria matched.)\n";
    message_about_duplicates += "Are you sure you would like to continue?";
    if (IDNO == PSay(message_about_duplicates, m_duplicate_data, MB_YESNO))
     return false;
   }

   return true;
  }
  case 1:
  {
   // [x] - check payment to make sure it's enough to cover the charges
   // [x] - if not, remind the user they may hit 'change' to fix it
   financial total_payment = financial(0.00);
   /*
   for (vector<map<string, string> >::iterator i_exp = params.expense_data.begin(); i_exp != params.expense_data.end(); i_exp++)
    total_payment += (StringToFinancial((*i_exp)["payable_amount"]) + StringToFinancial((*i_exp)["paid_amount"]));
   for (vector<map<string, string> >::iterator i_rev = params.forward_data.begin(); i_rev != params.forward_data.end(); i_rev++)
    total_payment += (StringToFinancial((*i_rev)["payable_amount"]) + StringToFinancial((*i_rev)["paid_amount"]));
   */

   // make sure we're not paying several tax entities!
   if (params.GetCountEntitiesOut() > 1)
   {
    PSay("You are not currently allowed to pay multiple entities at the same time.\nThis includes any entity for which moneys have been expensed, are payable, or cash has been paid.", m_invalid_data, MB_OK);
    return false;
   }

   total_payment = params.GetEntityPayment(invoice_tax_entity_id);

   if (total_payment != StringToFinancial(editInvoiceAmount->Text.c_str()))
    if (IDNO == PSay(string("Your payment of $" + FinancialToString(total_payment, true) + " does not match the expected payment of $" + FinancialToString(StringToFinancial(editInvoiceAmount->Text.c_str()), true)+ " based on the invoice amount given.\nAre you sure you want to continue?"), m_confirmation, MB_YESNO))
     return false;
   // the following is me being nice: they could be using this to track a phone bill entirely to be paid by employees, or just to show the invoice -was- received, etc.
   if (total_payment < financial(0.01))
    if (IDNO == PSay(string("You have indicated that no moneys have been, nor are to be, paid to the vendor.\nThis is valid only in extremely rare cases.\nPress the 'Change' button to fix this.\nAre you sure you want to continue?"), m_confirmation, MB_YESNO))
     return false;
   return true;
  }
  case 2:
  {
   return true;
  }
  default:
   PSay("IsValidPage() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return false;
 }
}
//---------------------------------------------------------------------------
int TformWizardNewVendorBill::WhereNext (int page_index)
{
 if (page_index == 2)
  return TformWizardGeneric::last_wizard_page;
 else
  return (page_index + 1);
}
//---------------------------------------------------------------------------
bool TformWizardNewVendorBill::ProcessPage (int page_index)
{
 switch (page_index)
 {
  case 0:
  {
   return true;
  }
  case 1:
  {
   return true;
  }
  case 2:
  {
   return true;
  }
  default:
  {
   PSay("ProcessPage() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return false;
  }
 }
}
//---------------------------------------------------------------------------
void TformWizardNewVendorBill::SetupPage (int page_index)
{
 switch (page_index)
 {
  case 0:
   // [x] - blank fields, today's date
   atlas->CancelRequestFrom(this);
   invoice_tax_entity_id = "0";
   DisplayTaxEntityInfo (0, "");
   editInvoiceDescription->Text = "";
   editInvoiceNumber->Text = "";
   dateInvoiceDate->Date = TDateTime::CurrentDate();
   editInvoiceAmount->Text = "0.00";
   return;
  case 1:
  {
   params = transaction_summary();
   checkAfterClick(NULL);
   return;
  }
  case 2:
  {
   // [x] - prepare captions for summary
   DisplayTaxEntityInfo (0, "");

   // amounts
   f_invoice = StringToFinancial(editInvoiceAmount->Text.c_str());
   f_payable = financial(0.00);
   f_paid    = financial(0.00);
   f_payment = financial(0.00);

   map<string, map<account_types, financial> > type_ent_amount = params.GetEntityTypeAmount();
   if (type_ent_amount[invoice_tax_entity_id].find(payable_acc) != type_ent_amount[invoice_tax_entity_id].end())
    f_payable += type_ent_amount[invoice_tax_entity_id][payable_acc];
   if (type_ent_amount[invoice_tax_entity_id].find(cash_acc) != type_ent_amount[invoice_tax_entity_id].end())
    f_paid    -= type_ent_amount[invoice_tax_entity_id][cash_acc];

   f_payment = f_payable + f_paid;
   labelSummaryTotalInvoice->Caption      = ("$" + FinancialToString(f_invoice, true)).c_str();
   labelSummaryTotalPayable->Caption      = ("$" + FinancialToString(f_payable, true)).c_str();
   labelSummaryTotalPaid->Caption         = ("$" + FinancialToString(f_paid,    true)).c_str();
   labelSummaryTotalPayment->Caption      = ("$" + FinancialToString(f_payment, true)).c_str();
   return;
  }
  default:
   PSay("SetupPage() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewVendorBill::buttonInvoiceSearchTaxEntityClick(TObject *Sender)
{
 // search for main tax entity to pay
 FORM_TRY
  vector<string> results;
  TformSearchTaxEntity * search = new TformSearchTaxEntity(NULL, &results);
  search->ShowTaskModal(this);
  if (!results.empty())
  {
   invoice_tax_entity_id = results.front();
   atlas->CancelRequestFrom(this);
   atlas->RequestNotificationWhen("tax_entities.id", invoice_tax_entity_id, rel_e, as_int, this, RefreshHandler(&(TformWizardNewVendorBill::DisplayTaxEntityInfo)));
   atlas->RequestNotificationWhen("tax_addresses.tax_entity_id", invoice_tax_entity_id, rel_e, as_int, this, RefreshHandler(&(TformWizardNewVendorBill::DisplayTaxEntityInfo)));
   DisplayTaxEntityInfo(0, "");
  }
 FORM_CATCH
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewVendorBill::FormClose(TObject *Sender, TCloseAction &Action)
{
 // wish to close, but we'll ask first, and if it's confirmed, go ahead and close controls
 Action = caFree;
 TformWizardGeneric::FormClose(Sender, Action);
 if (Action == caFree)
  edit_after.setup_listview(NULL, false);
}
//---------------------------------------------------------------------------
void TformWizardNewVendorBill::DisplayTaxEntityInfo (int request_num, string matched_value)
{
 // ignore the number, we don't care!
 // tax entity info
 CreateLink (staticInvoiceTaxEntity, buttonInvoiceSearchTaxEntity, this, invoice_tax_entity_id, "tax_entities", "table.tax_entities");
 CreateLink (staticSummaryTaxEntity, NULL, this, invoice_tax_entity_id, "tax_entities", "table.tax_entities");
 map<string, string> info_about_entity;
 if (!SqlToMap(dbDatabase, "select tin.identifier o_tax_number, tax_addresses.line1 o_line_1, tax_addresses.line2 o_line_2, tax_addresses.city o_city, state_types.item o_state, tax_addresses.zip o_zip, country_types.item o_country "
                           "from tax_entities "
                           "inner join tax_addresses on tax_addresses.id = tax_entities.billing_address_id "
                           "inner join state_types on state_types.id = tax_addresses.state_id "
                           "inner join country_types on country_types.id = tax_addresses.country_id "
                           "left join entity_ids tin on tin.tax_entity_id = tax_entities.id and tin.current_id >= 3 and tin.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "TIN/EIN") + "' "
                           "where tax_entities.id = " + invoice_tax_entity_id, info_about_entity))
  PSay("Failed to retrieve federal tax id number and billing address information, SqlToMap() failed.", m_database_error, MB_OK);

 labelSummaryTaxNumber->Caption         = (info_about_entity["o_tax_number"]).c_str();
 labelSummaryTaxEntityAddress1->Caption = FormatAddress(info_about_entity["o_line_1"]).c_str();
 labelSummaryTaxEntityAddress2->Caption = FormatAddress(info_about_entity["o_line_2"]).c_str();
 labelSummaryTaxEntityAddress3->Caption = PrettyString(info_about_entity["o_city"] + ", " + info_about_entity["o_state"] + ", " + info_about_entity["o_zip"]).c_str();
 if (!info_about_entity["o_country"].empty())
  labelSummaryTaxEntityAddress3->Caption = labelSummaryTaxEntityAddress3->Caption + PrettyString(" (" + info_about_entity["o_country"] + ")").c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewVendorBill::checkAfterClick(TObject *Sender)
{
 // stuff
 vector<map<string, string> > current_data = params.GetPreviewOutput(false);
 RefreshTransactionSummaryView (edit_after, checkAfterShowAccount->Checked, checkAfterShowName->Checked, current_data);
}
//---------------------------------------------------------------------------
void __fastcall TformWizardNewVendorBill::buttonChangeClick(TObject *Sender)
{
 FORM_TRY
  TformSpecialTransactionEntry * query = new TformSpecialTransactionEntry(NULL, transaction_summary(), &params, invoice_tax_entity_id, StringToFinancial(editInvoiceAmount->Text.c_str()), true);
  query->ShowTaskModal(this);
  vector<map<string, string> > current_data = params.GetPreviewOutput(true);
  RefreshTransactionSummaryView (edit_after, checkAfterShowAccount->Checked, checkAfterShowName->Checked, current_data);
 FORM_CATCH
}
//---------------------------------------------------------------------------
void TformWizardNewVendorBill::PageLockStatus (int page_index, bool locked)
{
 switch (page_index)
 {
  case 0:
   buttonInvoiceSearchTaxEntity->Enabled = !locked;
   editInvoiceDescription->Enabled = !locked;
   editInvoiceNumber->Enabled = !locked;
   dateInvoiceDate->Enabled = !locked;
   editInvoiceAmount->Enabled = !locked;
   return;
  case 1:
   buttonChange->Enabled = !locked;
   return;
  case 2:
   return;
  default:
   PSay("PageLockStatus() is trying to access a page that does not exist.", m_program_error, MB_OK);
   return;
 }
}
//---------------------------------------------------------------------------
bool TformWizardNewVendorBill::FinishWizard ()
{
 // [x] - save bill
 // [x] - save transactions
 // [ ] - save inventory
 AtlasClear();
 TIBTransaction * dbTransaction = new TIBTransaction(NULL);
 StdTransaction(dbTransaction, dbDatabase);
 try
 {
  map<string, string> bill_row;
  string this_bill_id = GetNextId(dbTransaction, "bills");
  bill_row["id"]                    = this_bill_id;
  bill_row["current_id"]            = "4";
  bill_row["last_update_stamp"]     = RightNow();
  bill_row["last_updated_by"]       = current_userid;
  bill_row["task_id"]               = "0";
  bill_row["group_or_user"]         = "0"; // the meaning of these three fields was never made -quite- clear
  bill_row["groups"]                = "";  // contained a comma-sep list of abbrev. of dept. names. -- why?
  bill_row["user_id"]               = "0"; // contained a user id -- still unsure why.
  bill_row["insurance_coverage_id"] = "0";
  bill_row["provider_tax_id"]       = "0";
  bill_row["facility_tax_id"]       = "0";
  bill_row["group_tax_id"]          = "0";
  bill_row["actual_tax_id"]         = invoice_tax_entity_id;
  bill_row["purchase_req_id"]       = "0";
  bill_row["total_charge"]          = FinancialToString(f_invoice, false, 2); // (cost initially -- before anyone pays for anything, cost of service and goods)
  bill_row["invoice_amount"]        = FinancialToString(f_invoice, false, 2); // (cost this time -- other payments already done by us or others, discounts, etc.)
  bill_row["paid_amount"]           = FinancialToString(f_payment, false, 2); // i do not like this field -- it was caused by paradox, never removed it (SHOULD use transactions only!)
  bill_row["bill_id"]               = lookupTables->IdOf("bill_types", "Incoming Vendor Bill");
  bill_row["bill_date"]             = Pdate(dateInvoiceDate->Date).OutDate(global_mode);
  bill_row["invoice_number"]        = editInvoiceNumber->Text.c_str();
  bill_row["note"]                  = editInvoiceDescription->Text.c_str();

  if (!ExecuteInsertStatement(dbTransaction, "bills", bill_row))
   throw(1);
  AtlasAdd("bills", bill_row);

  map<string, string> default_row;
  default_row["current_id"]         = "4";
  default_row["last_update_stamp"]  = RightNow();
  default_row["last_updated_by"]    = current_userid;
  default_row["task_id"]            = "0";
  default_row["bill_id"]            = this_bill_id;
  default_row["effective_date"]     = Pdate(dateInvoiceDate->Date).OutDate(global_mode);
  default_row["note"]               = "Initial entries for vendor invoice (" + string(editInvoiceNumber->Text.c_str()) + ")";
  default_row["transaction_number"] = GetNextId(dbTransaction, "transact_number");
  /*GetNewFinalTransactions(default_row);*/
  vector<map<string, string> > tx = params.GetFinalOutput(default_row);
  vector<map<string, string> >::iterator i_tx;

  // setup tax_entity_id, debit_amount, credit_amount
  for (i_tx = tx.begin(); i_tx != tx.end(); i_tx++)
  {
   (*i_tx)["id"] = GetNextId(dbTransaction, "transactions");
   if (!ExecuteInsertStatement(dbTransaction, "transactions", (*i_tx)))
    throw(2);
   AtlasAdd("transactions", (*i_tx));
  }

  dbTransaction->Commit();
  delete dbTransaction;
  AtlasSend();
  return true;
 } catch (...)
 {
  PSay("FinishWizard() failed to complete the insertion process (unforeseen error.)\nVendor bill and associated transactions have not been saved.", m_database_error, MB_OK);
  dbTransaction->Rollback();
  delete dbTransaction;
  AtlasClear();
  return false;
 }
}
//---------------------------------------------------------------------------
void TformWizardNewVendorBill::Do()
{
 FORM_TRY
  TformWizardNewVendorBill * z = new TformWizardNewVendorBill(NULL);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

