//---------------------------------------------------------------------------

#ifndef codeWizardObservationOptionSetH
#define codeWizardObservationOptionSetH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeWizardGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include <Graphics.hpp>
//---------------------------------------------------------------------------
class TformWizardObservationOptionSet : public TformWizardGeneric
{
__published:	// IDE-managed Components
        TTabSheet *sheetSelect;
        TTabSheet *sheetModify;
        TTabSheet *sheetConvert;
        TListView *listOptions;
        TEdit *editOptionItem;
        TButton *buttonOptionAdd;
        TButton *buttonOptionRemove;
        TButton *buttonOptionClear;
        TButton *buttonOptionSave;
        TButton *buttonOptionUp;
        TButton *buttonOptionDown;
        TComboBox *comboOptionSet;
        TListView *listConversions;
        TButton *buttonConversionSave;
        TComboBox *comboOption;
        TEdit *editOptionSetItem;
        TRadioButton *radioModify;
        TRadioButton *radioCreate;
        TListView *listQuestions;
        TLabel *_labelUsedBy;
        void __fastcall buttonOptionAddClick(TObject *Sender);
        void __fastcall buttonOptionRemoveClick(TObject *Sender);
        void __fastcall buttonOptionClearClick(TObject *Sender);
        void __fastcall buttonOptionSaveClick(TObject *Sender);
        void __fastcall buttonOptionUpClick(TObject *Sender);
        void __fastcall buttonOptionDownClick(TObject *Sender);
        void __fastcall buttonConversionSaveClick(TObject *Sender);
        void __fastcall radioModifyClick(TObject *Sender);
        void __fastcall comboOptionKeyPress(TObject *Sender, char &Key);
        void __fastcall comboOptionSetChange(TObject *Sender);
private:	// User declarations
        edit_listview list_options;
        edit_listview list_conversions;
        string chosen_obs_option_set_id;
        classFilterObject list_questions;

        void OptionSelected ();
        void ConversionSelected ();
        void NormalizeOptions ();

        bool SkipPage    (int page_index);
        bool IsValidPage (int page_index);
         int WhereNext   (int page_index);
        bool ProcessPage (int page_index);
        void SetupPage   (int page_index);
        bool FinishWizard ();
        void PageLockStatus (int page_index, bool locked);

public:		// User declarations
        __fastcall TformWizardObservationOptionSet(TComponent* Owner);
        __fastcall ~TformWizardObservationOptionSet();
        static void Do();
        static void Do(string obs_option_set_id);
};
//---------------------------------------------------------------------------
extern PACKAGE TformWizardObservationOptionSet *formWizardObservationOptionSet;
//---------------------------------------------------------------------------
#endif
