 //---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeWorkflowGeneric.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codePaddedBox"
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformWorkflowGeneric *formWorkflowGeneric;
//---------------------------------------------------------------------------
__fastcall TformWorkflowGeneric::TformWorkflowGeneric(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("wf_items"))
{
  // set up filters
  Initialize();
}
//---------------------------------------------------------------------------
bool TformWorkflowGeneric::ScreenStart()
{
  // register combo boxes
  if (TformRecordGeneric::ScreenStart())
  {
    // at this point we will either have:
    // new record:       id of "new"
    //                   document id passed in from constructor
    // existing record:  id passed in from constructor
    //                   document id (and all other data) pulled from DB
    // We SHOULD have a document id either way at this point.
    // What should we do if we don't?

    // use document id to build the chain of states.  we start with
    // document type's wf_state_id (initial state), and join through items,
    // actions, transitions, to walk the chain of previous states.  go!

    // To get the chain of states the item has been through, we need to take the union of
    // 1) Document tied to initial state, tied to item to use its created_on value
    // 2) Document tied to item tied to action, using action's changed_on value
    string sql;
    sql = "select item.created_on changed_on, doc.id doc_id, item.id item_id, state.id state_id, state.frame_name "
          "from wf_document_types doc "
          "left join wf_items item on item.wf_document_id = doc.id "
          "inner join wf_states state on doc.wf_state_id = state.id "
          "where doc.id = '" + initial_state["wf_document_id"] + "'";
    if (IsInt(initial_state["id"]) && initial_state["id"] != "")
      sql += "union "
             "select actions.changed_on, doc.id, item.id, state.id, state.frame_name "
             "from wf_document_types doc "
             "left join wf_items item on item.wf_document_id = doc.id "
             "inner join wf_actions actions on actions.wf_item_id = item.id "
             "inner join wf_transitions trans on actions.wf_transition_id = trans.id "
             "inner join wf_states state on trans.new_wf_state_id = state.id "
             "where item.id = '" + initial_state["id"] + "'";
             "order by 1 desc";
    // store this in some sort of structure to use internally, to pass to frames, etc.
    DebugSql(this, &sql, other_forms, 9, lock_transaction);
    SqlToVecMap(dbDatabase, sql, state_info);
    if (!state_info.empty())
      PSay(MapToDelimString(state_info[0], "{", "}", "", "'", "'", "'", "'", ","), m_debug, MB_OK);
    else
      PSay("state_info is empty!", m_debug, MB_OK);
    return true;
  }
  else return false;
}
//---------------------------------------------------------------------------
bool TformWorkflowGeneric::ScreenStop()
{
  // unregister combo boxes
  return TformRecordGeneric::ScreenStop();
}
//---------------------------------------------------------------------------
bool TformWorkflowGeneric::IsValidOnScreen()
{
  return true;
}
//---------------------------------------------------------------------------
bool TformWorkflowGeneric::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  return TformRecordGeneric::PutDataOnScreen();
}
//---------------------------------------------------------------------------
bool TformWorkflowGeneric::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id

  ending_state["id"] = initial_state["id"];

  return TformRecordGeneric::GetDataFromScreen();
}
//---------------------------------------------------------------------------
bool TformWorkflowGeneric::ScreenLock()
{
  // disable panels containing editable controls

  return TformRecordGeneric::ScreenLock();
}
//---------------------------------------------------------------------------
bool TformWorkflowGeneric::ScreenUnlock()
{
  // enable panels containing editable controls

  return TformRecordGeneric::ScreenUnlock();
}
//---------------------------------------------------------------------------
bool TformWorkflowGeneric::CheckForUselessRecord()
{
  return true;
}
//---------------------------------------------------------------------------
bool TformWorkflowGeneric::IsNewAgain()
{
  // reset filters:
  // SetSQLStatement(string("")); RefreshDataSet(); SetAddEdit(this, NULL, NULL);
  return TformRecordGeneric::IsNewAgain();
}
//---------------------------------------------------------------------------
bool TformWorkflowGeneric::NotNewAnymore()
{
  // activate filters again:
  // SetSQLStatement(sql); RefreshDataSet(); SetAddEdit(this, AddRecord(&(Tform::Func)), EditRecord(&(Tform::Func)));
  // setup atlas notifications:
  // int_request = atlas->RequestNotificationWhen("table.field key", "value", rel_how, as_what, this, RefreshHandler(&(Tform::AtlasRefreshListViews)));

  return TformRecordGeneric::NotNewAnymore();
}
//---------------------------------------------------------------------------
/*
bool TformWorkflowGeneric::AtlasRefreshListViews(int request_num, string matched_value)
{
  // if (request_num == int_request) // from NotNewAnymore
  //   notes_filter.RefreshDataSet();

  return true;
}
//---------------------------------------------------------------------------
void TformWorkflowGeneric::AddNote()
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["bug_id"] = initial_state["id"];
  temp_map["status_id"] = initial_state["status_id"];
  FORM_TRY
    TformRecordBugNotes * note = new TformRecordBugNotes(NULL, temp_map);
    note->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformWorkflowGeneric::EditNote()
{
  map<string, string> temp_map;
  temp_map["id"] = notes_filter.GetSelectedRecordID();
  FORM_TRY
    TformRecordBugNotes * note = new TformRecordBugNotes(NULL, temp_map);
    note->Show();
  FORM_CATCH
}
*/
//---------------------------------------------------------------------------
void TformWorkflowGeneric::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformWorkflowGeneric * z = new TformWorkflowGeneric(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

