//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

void ViewSql(string sql, TIBTransaction *t)
{
  // pass address of local variable.  will be modified and returned here, but
  // the value the calling function is using won't be changed
  TformSpecialSqlViewer *viewer = NULL;
  if (TformSpecialSqlViewer::HasPermissionToExecute())
    viewer = TformSpecialSqlViewer::Launch(non_modal, NULL, &sql, t);
  if (viewer)
  {
    viewer->btnOk->Enabled = false;            // view only after all
    viewer->btnRunUnmodified->Enabled = false; // jhaley - also turn off the newer "Run Unmodified" button
  }
}

void EditSql(TformSpecialGeneric * modalParent, string * sql, TIBTransaction *t)
{
  // pass pointer we received, which is the address of the calling function's
  // variable, so it gets changed and passed back to the calling function
  if (TformSpecialSqlViewer::HasPermissionToExecute())
    TformSpecialSqlViewer::Launch(task_modal, modalParent, sql, t);
}

void DebugSql(TformSpecialGeneric * modalParent, string * sql, debug_form_types d_form_type, int d_level, TIBTransaction *t)
{
  #ifdef tcpip_messaging_h
  if(debug_level[d_form_type]>=d_level)
    EditSql(modalParent, sql, t);
  #endif
}

void QueryData(TformSpecialGeneric *modalParent, TIBTransaction *dbTransaction, string sql)
{
  if (TformSpecialDataQuery::HasPermissionToExecute())
    TformSpecialDataQuery::Launch(modalParent, dbTransaction, sql);
}

