#ifndef DERIVEDHEADERS_H
#define DERIVEDHEADERS_H

#include "baseheaders.h"
// here because, well, if it goes in baseheaders, you get a circular dependency
// of sqlviewer->specialgeneric->baseheaders->sqlviewer, etc.
#include "codeSpecialSqlViewer.h"
#include "codeSpecialDataQuery.h"

void ViewSql(string sql, TIBTransaction *t = NULL);
void EditSql(TformSpecialGeneric * modalParent, string * sql, TIBTransaction *t = NULL);
void DebugSql(TformSpecialGeneric * modalParent, string * sql, debug_form_types d_form_type = other_forms, int d_level = 1, TIBTransaction *t = NULL);
void QueryData(TformSpecialGeneric *modalParent, TIBTransaction *dbTransaction, string sql);

class progress_container
{
 struct progress_item
 {
  Pstamp timestamp;
  string message;
  progress_item (string _message)
  {
   timestamp = CurrentPstamp();
   message   = _message;
  }
 };
 vector<progress_item> progress;
 Pstamp last_timestamp;
 public:
  progress_container() { last_timestamp = CurrentPstamp(); }
  string Report ()
  {
   string answer;
   vector<progress_item>::iterator i, last_i;
   for (i = progress.begin(), last_i = progress.begin(); i != progress.end(); i++)
   {
    string elapsed = GetTimeSince(i->timestamp, last_i->timestamp);
    answer += "[" + i->timestamp.OutStamp(datefirst | ymd | yyyy | left_zeros | military) + "]" +
              (elapsed != "" ? "[" + elapsed + "] " : string("")) + i->message + "\n";
    last_i = i;
   }
   answer += "\nRun time, start to finish:  " + GetTimeSince(progress[progress.size()-1].timestamp, progress[0].timestamp) + "\n";
   return answer;
  }
  void Mark (string message)
  {
   progress.push_back(progress_item(message));
   last_timestamp = progress[progress.size()-1].timestamp;
  }
};

#endif
