#ifndef prometheus_externs
#define prometheus_externs

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <Menus.hpp>
#include <Db.hpp>
#include <IBCustomDataSet.hpp>
#include <IBDatabase.hpp>
#include <IBSQL.hpp>
#include <ImgList.hpp>
#include <string>
#include <vector>
#include <map>
#include <list>
#include "allsymbols.h"

using namespace std;

// utilities

class classLookUpTableWrapper;
extern classLookUpTableWrapper *lookupTables;

class classTcpipMessaging;
extern classTcpipMessaging * message_router;

//class sql_error;                       // in sqllib
//extern sql_error last_sql_lib_error;   // in sqllib

extern char * hardcoded_usps_abbrs []; // in util.cpp
extern char * show_type_names [];      // in util.cpp
extern char * sort_type_names [];      // in util.cpp

class classNetworkRequestHandler;
extern classNetworkRequestHandler * atlas;


// prometheus

extern TImageList * imagesCurrent;
extern TImageList * imagesRecordTypes;
extern TIBDatabase * dbDatabase;

extern TPopupMenu * popupListActions;
extern TPopupMenu * popupCurrentTypes;
extern TPopupMenu * popupLookupTables;

extern map<string, map<string, string> > optionsIni;

extern map<string, map<string, string> > optionsPreferences;
extern map<string, map<string, string> > optionsPermissions;

extern map<string, string> site_settings;

//extern map<debug_form_types, int> debug_level;

// jhaley 20110708: It's come to light that Borland and VCL have some issues with the order of execution at program
// shutdown by which it's possible to have global static objects destroyed before your program has finished executing.
// In order to avoid this, and to improve encapsulation in general, I am slowly moving globals into this structure,
// which is allocated at startup and is allowed to live until the process is completely destroyed (ie. it is
// deliberately not deleted). For that reason don't put anything in here which needs explicit destruction logic
// executed on it.

class classFilterObject;

class classPrometheusGlobals
{
public: // All members are public, for convenience of access.
  // Version information
  string           current_version;     // change in project options only now
  map<string, int> current_version_map; // jhaley 20110215: also store as map for ease of access to components
  string           gds_version;

  // User identification
  string current_username;
  string current_groupname;

  // Temp files
  string current_system_tempdir; // jhaley 20100824: I need this too, for the EXE, which can't be deleted on exit.
  string current_tempdir;        // jhaley 20100823: temporary directory global - everything in here is deleted on exit.

  // Lists of objects
  list<classFilterObject *> pending_refreshes; // Filters that need deferred refresh
};
extern classPrometheusGlobals *PGlobals;

extern string current_userid;
extern string current_fullname;
extern string current_groupid;
extern string computer_name;
extern string user_taxid;

extern TColor link_color;
extern TColor title_bar_color;
extern TColor today_circle_color;
extern TColor today_date_color;
extern TColor calendar_background;
extern TColor title_bar;
extern TColor title_text;
extern TColor week_titles;
extern TColor hor_line;
extern TColor date_color;
extern TColor grid_line_color;

#endif