//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "codeRecordParticipationsBeh.h"
#include "codeSearchPerson.h"
#include "codeSearchEvent.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma resource "*.dfm"
TformRecordParticipationsBeh *formRecordParticipationsBeh;
//---------------------------------------------------------------------------
__fastcall TformRecordParticipationsBeh::TformRecordParticipationsBeh(TComponent* Owner, map<string,string> p_parameters)
        : TformRecordGeneric(Owner, p_parameters, string("participations"))
{
  Initialize();
}
//---------------------------------------------------------------------------
bool TformRecordParticipationsBeh::ScreenStart()
{
  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordParticipationsBeh::ScreenStop()
{

  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordParticipationsBeh::IsValidOnScreen()
{
  // check to make sure that the values entered in the combo boxe
  // corrospond to values in that look up table.
  // check to make sure the dates entered are valid
  // give the user a message box and prompt to re-enter if incorrect
  // make sure there is a link to a person, although there's not much the user
  // can do to fix that if there's not
  if ((initial_state["event_id"] == "") || (initial_state["event_id"] == "0"))
  {
    PSay("Please attach an event", m_missing_data, MB_OK);
    btnEventSearch->SetFocus();
    return false;
  }
  else if ((initial_state["person_id"] == "") || (initial_state["person_id"] == "0"))
  {
    PSay("Please attach a person", m_missing_data, MB_OK);
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------

bool TformRecordParticipationsBeh::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  // get the person name associated with the person id that was either selected
  // from the database if it's an existing record, or passed to the form if
  // it's a new record. display the name as a link to the person record.

  CreateLink(txtPerson, btnPersonSearch, this, initial_state["person_id"], "people");
  CreateLink(txtEvent, btnEventSearch, this, initial_state["event_id"], "events");

  TformRecordGeneric::PutDataOnScreen();
  return true; // what can really go wrong?
}
//---------------------------------------------------------------------------
bool TformRecordParticipationsBeh::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id
  ending_state["group_id"] = lookupTables->IdOf("groups", "Behavioral Health");
  ending_state["event_id"] = initial_state["event_id"];
  ending_state["person_id"] = initial_state["person_id"];
  ending_state["diab_special_id"] = "0";
  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();

  return true; // again, not much can go wrong here
}
//---------------------------------------------------------------------------
bool TformRecordParticipationsBeh::ScreenLock()
{
  // disable panel containing edit boxes
  panelGroup->Enabled = false;
  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordParticipationsBeh::ScreenUnlock()
{
  // enable panel containing edit boxes
  panelGroup->Enabled = true;
  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordParticipationsBeh::btnPersonSearchClick(
      TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
  {
    initial_state["person_id"] = return_vector[0];
    CreateLink(txtPerson, btnPersonSearch, this, initial_state["person_id"], "people");
  }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordParticipationsBeh::btnEventSearchClick(
      TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchEvent * eventSearch = new TformSearchEvent(NULL,&return_vector, lookupTables->IdOf("groups", "Behavioral Health"));
    eventSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
  {
    initial_state["event_id"] = return_vector[0];
    CreateLink(txtEvent, btnEventSearch, this, initial_state["event_id"], "events");
  }
}
//---------------------------------------------------------------------------
bool TformRecordParticipationsBeh::CheckForUselessRecord()
{
  return true;
}
//---------------------------------------------------------------------------
void TformRecordParticipationsBeh::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordParticipationsBeh * z = new TformRecordParticipationsBeh(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------

