//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchBehClientEventReport.h"
#include "reportBehClientEvent.h"
#include "codeSearchPerson.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchBehClientEventReport *formLaunchBehClientEventReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchBehClientEventReport::TformLaunchBehClientEventReport(TComponent* Owner, string id)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Date();
  dateEnd->Date = Date();
  person_id = id;
  CreateLink(txtName, btnPersonSearch, this, person_id, "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehClientEventReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehClientEventReport::btnRunClick(
      TObject *Sender)
{
 if (person_id != "")
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Event report for " + GetPersonName(dbDatabase, person_id, first_last);

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select events.date_of_event, event_name_types.item event_name, event_type_types.item event_type, case "
            "when event_location_types.zip_code_id = 0 then event_location_types.item "
            "when event_location_types.item = '' then (zip_codes.city || ', ' || zip_codes.state) "
            "else (zip_codes.city || ', ' || zip_codes.state || ' - ' || event_location_types.item) end location "
            "from events "
            "inner join participations on participations.event_id = events.id "
            "inner join event_name_types on events.event_name_id = event_name_types.id "
            "inner join event_type_types on events.event_type_id = event_type_types.id "
            "inner join event_location_types on events.event_location_id = event_location_types.id "
            "inner join zip_codes on event_location_types.zip_code_id = zip_codes.id "
            "where participations.person_id = '" + person_id + "' and "
            "events.date_of_event >= '" + begin_date + "' and "
            "events.date_of_event <= '" + end_date + "' and "
            "events.current_id >= 3 and participations.current_id >= 3 and "
            "events.group_id = '" + lookupTables->IdOf("groups", "Behavioral Health") + "' "
            "order by events.date_of_event";

      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportBehClientEvent * eventReport = new TformReportBehClientEvent(NULL);
        eventReport->eventReport->DataSet = dbDataSet;
        eventReport->lblTitle->Caption = title.c_str();
        eventReport->lblDateTitle->Caption = date_title.c_str();
        eventReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        eventReport->txtDate->DataSet = dbDataSet;
        eventReport->txtDate->DataField = "date";
        eventReport->txtName->DataSet = dbDataSet;
        eventReport->txtName->DataField = "event_name";
        eventReport->txtType->DataSet = dbDataSet;
        eventReport->txtType->DataField = "event_type";
        eventReport->txtLocation->DataSet = dbDataSet;
        eventReport->txtLocation->DataField = "location";
        Processing(false);
        eventReport->eventReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();

    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }
  else
  {
    PSay("Please enter a client name", m_missing_data, MB_OK);
    btnPersonSearch->SetFocus();
  }        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehClientEventReport::btnPersonSearchClick(
      TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
  {
    person_id = return_vector[0];
    CreateLink(txtName, btnPersonSearch, this, person_id, "people");
  }         
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehClientEventReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;
}
//---------------------------------------------------------------------------

