//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchComPatientDescriptive.h"
#include "reportComPatientDescriptive.h"
#include "reportComPatientDescript.h"
#include "reportComPatientTotals.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchComPatientDescriptive *formLaunchComPatientDescriptive;
//---------------------------------------------------------------------------
__fastcall TformLaunchComPatientDescriptive::TformLaunchComPatientDescriptive(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  times_run = 0;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComPatientDescriptive::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComPatientDescriptive::btnRunClick(TObject *Sender)
{
  PSay("This report seems to be in limbo -- please have a talk with your programmer about what it ought to be doing.", m_message, MB_OK);
  return;

  Processing(true);
  dbDirectDataSet = new TIBDataSet(NULL);
  dbDescriptDataSet = new TIBDataSet(NULL);
  dbTotalsDataSet = new TIBDataSet(NULL);
  dbTransaction = new TIBTransaction(NULL);

  TQRPageList * source = new TQRPageList();
  TQRPageList * destination = new TQRPageList();
  destination->Stream = new TQRStream(100000);
  TQRPrinter * printer_thing = InitTQRPrinter();

   try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbDirectDataSet->Database = dbDatabase;
    dbDirectDataSet->Transaction = dbTransaction;
    dbDirectDataSet->UniDirectional = false;
    dbDescriptDataSet->Database = dbDatabase;
    dbDescriptDataSet->Transaction = dbTransaction;
    dbDescriptDataSet->UniDirectional = false;
    dbTotalsDataSet->Database = dbDatabase;
    dbTotalsDataSet->Transaction = dbTransaction;
    dbTotalsDataSet->UniDirectional = false;
    dbTransaction->StartTransaction();

    compositeReport->Prepare();
    string file_name = PMakeTempFilePath("page1.qrp");
    ((TQuickRep *)(compositeReport->Reports->First()))->QRPrinter->Save(file_name.c_str());
    // add page 1
    source->Clear();
    source->LoadFromFile(file_name.c_str());
    for (int j = 1; j <= source->PageCount; j++)
      destination->AddPage(source->GetPage(j));
    destination->Finish();
    string temp_filepath = PMakeTempFilePath("complete.qrp");
    destination->SaveToFile(temp_filepath.c_str());
    // load combined report and preview
    printer_thing->Load(temp_filepath.c_str());
    Processing(false);
    printer_thing->PreviewModal();

    dbDirectDataSet->Close();
    dbDescriptDataSet->Close();
    dbTotalsDataSet->Close();
    dbTransaction->Commit();

  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDirectDataSet;
  delete dbDescriptDataSet;
  delete dbTotalsDataSet;
  delete printer_thing;
  delete source;
  delete destination;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComPatientDescriptive::compositeReportAddReport(TObject *Sender)
{

 if (times_run == 0)
  {
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;


    try
    {
     /*
     sql = "select distinct people.id, people.gender, age_group.id from "
           "people inner join visits on tasks.person_id = people.id "
           "where tasks.group_id = " + initial_state["group_id"] +
           "right join age_group on age_group.age_min <= (select p_age from calc_age(people.birth_date) "
           "and age_group.age_max >= (select p_age from calc_age(people.birth_date) and
           "tasks.date_of_task <= " + dateBegin + " and "
           "tasks.date_of_task >= " + dateEnd ;

     ExecuteInsertStatement(dbTransaction, "temp_age_groups", to_insert);

     sql = "select temp_age_group.id, count(temp_age_group.id) from age_group where "
           "temp_age_group.gender_id = " + lookupTables->IdOf("gender_types", "Male") +
           "group by temp_age_group.id";

     ExecuteInsertStatement(dbTransaction, "temp_male_group", to_insert);

     sql = "select temp_age_group.id, count(temp_age_group.id) from age_group where "
           "temp_age_group.gender_id = " + lookupTables->IdOf("gender_types", "Female") +
           "group by temp_age_group.id";

     ExecuteInsertStatement(dbTransaction, "temp_female_group", to_insert);

     sql = "select age_group.id, temp_male_group.count, temp_female_group.count "
           "from age_group inner join temp_male_count on age_group.id = temp_male_count.age_group_id "
           "inner join temp_female_count on age_group.id = temp_female_count.age_group_id ";

     ExecuteInsertStatement(dbTransaction, "temp_patient_descriptive", to_insert);

     sql = "select age_group_id, male_count, female_count from temp_patient_descriptive ";

      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportComPatientDescript * clientReport = new TformReportComPatientDescript(NULL);
        clientReport->clientReport->DataSet = dbDataSet;
        clientReport->lblTitle->Caption = date_title.c_str();
        clientReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        clientReport->txtName->DataSet = dbDataSet;
        clientReport->txtName->DataField = "name";
        clientReport->txtSSN->DataSet = dbDataSet;
        clientReport->txtSSN->DataField = "social_security_number";
        clientReport->txtDOB->DataSet = dbDataSet;
        clientReport->txtDOB->DataField = "birth_date";
        clientReport->txtCDIB->DataSet = dbDataSet;
        clientReport->txtCDIB->DataField = "cdib";
        clientReport->txtTribe->DataSet = dbDataSet;
        clientReport->txtTribe->DataField = "tribe";
        clientReport->txtAddress->DataSet = dbDataSet;
        clientReport->txtAddress->DataField = "address";
        clientReport->txtPhone->DataSet = dbDataSet;
        clientReport->txtPhone->DataField = "phone_number";
        clientReport->clientReport->Preview();
      FORM_CATCH

      dbDataSet->Close();
      dbTransaction->Commit();
     */
    }
    catch (...)
    {
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    times_run++;
  }

}
//---------------------------------------------------------------------------
  /* //place values for page1
     TformReportComPatientDescriptive * directReport = new TformReportComPatientDescriptive(NULL);

     sql = "select count(people.is_com_client) from people inner join tasks on "
           "people.id = tasks.person_id where people.is_com_client = 1 and "
           "tasks.date_of_task >= '" + begin_date + "' and "
           "tasks.date_of_task <= '" + end_date + "' and tasks.current_id >=3 and "
           "tasks.new_client = 1";

      directReport->lblNew->Caption = GetOneField(dbTransaction, sql).c_str();

      directReport->lblDateTitle->Caption = date_title.c_str();

      sql = "select count(people.is_com_client) from people inner join tasks on "
            "people.id = tasks.person_id where people.is_com_client = 1 and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' and tasks.current_id >=3";

      directReport->lblServices->Caption = GetOneField(dbTransaction, sql).c_str();
      int total = StrToInt(directReport->lblServices->Caption);
      int Tnew = StrToInt(directReport->lblNew->Caption);
      directReport->lblTotal->Caption = IntToStr(total + Tnew);

      compositeReport->Reports->Add(directReport->page1);


      //place values for page2
      TformReportComPatientDescript * descriptReport = new TformReportComPatientDescript(NULL);
      //male and female between the ages 0-4
      int age1 = 0;
      age1 -= age1 * 2;
      int age2 = 4;
      age2 -= age2 * 2;
      Pdate date1(DateToStr(Now()).c_str(), mdy | yyyy);
      Pdate date2(DateToStr(Now()).c_str(), mdy | yyyy);
      date1.mod(age1, in_years);
      date2.mod(age2, in_years);

      sql = "select count(people.id) from people inner join affiliations on "
            "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
            "where people.is_com_client = 1 and people.gender_id = 1 " ;
      sql += " and people.birth_date <= '" + date1.OutDate(mdy | yyyy) + "' and "
             "people.birth_date >= '" + date2.OutDate(mdy | yyyy) + "' and "
             "people.birth_date is not null ";
      sql +=" and "
            "exists (select tasks.id from tasks where tasks.person_id = people.id and "
            "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
            "tasks.group_id = 4 and tasks.current_id > 2) ";

      descriptReport->lblMale0->Caption = GetOneField(dbTransaction, sql).c_str();

      sql =  "select count(people.id) from people inner join affiliations on "
             "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
             "where people.is_com_client = 1 and people.gender_id = 0 " ;
      sql += " and people.birth_date <= '" + date1.OutDate(mdy | yyyy) + "' and "
             "people.birth_date >= '" + date2.OutDate(mdy | yyyy) + "' and "
             "people.birth_date is not null ";
      sql += " and "
             "exists (select tasks.id from tasks where tasks.person_id = people.id and "
             "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
             "tasks.group_id = 4 "
             "and tasks.current_id > 2) ";
      descriptReport->lblFemale0->Caption = GetOneField(dbTransaction, sql).c_str();

      //male and female between the ages 5-9
      int age3 = 5;
      age3 -= age3 * 2;
      int age4 = 9;
      age4 -= age4 * 2;
      Pdate date3(DateToStr(Now()).c_str(), mdy | yyyy);
      Pdate date4(DateToStr(Now()).c_str(), mdy | yyyy);
      date3.mod(age3, in_years);
      date4.mod(age4, in_years);

      sql =  "select count(people.id) from people inner join affiliations on "
             "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
             "where people.is_com_client = 1 and people.gender_id = 1 " ;
      sql += " and people.birth_date <= '" + date3.OutDate(mdy | yyyy) + "' and "
             "people.birth_date >= '" + date4.OutDate(mdy | yyyy) + "' and "
             "people.birth_date is not null ";
      sql += " and "
             "exists (select tasks.id from tasks where tasks.person_id = people.id and "
             "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
             "tasks.group_id = 4 "
             "and tasks.current_id > 2) ";
      descriptReport->lblMale5->Caption = GetOneField(dbTransaction, sql).c_str();

      sql =  "select count(people.id) from people inner join affiliations on "
             "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
             "where people.is_com_client = 1 and people.gender_id = 0 " ;
      sql += " and people.birth_date <= '" + date3.OutDate(mdy | yyyy) + "' and "
             "people.birth_date >= '" + date4.OutDate(mdy | yyyy) + "' and "
             "people.birth_date is not null ";
      sql += " and "
             "exists (select tasks.id from tasks where tasks.person_id = people.id and "
             "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
             "tasks.group_id = 4 "
             "and tasks.current_id > 2) ";
      descriptReport->lblFemale5->Caption = GetOneField(dbTransaction, sql).c_str();

      //male and female between the ages 10-14
      int age5 = 10;
      age5 -= age5 * 2;
      int age6 = 14;
      age6 -= age6 * 2;
      Pdate date5(DateToStr(Now()).c_str(), mdy | yyyy);
      Pdate date6(DateToStr(Now()).c_str(), mdy | yyyy);
      date5.mod(age5, in_years);
      date6.mod(age6, in_years);
      //male
      sql =  "select count(people.id) from people inner join affiliations on "
             "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
             "where people.is_com_client = 1 and people.gender_id = 1 " ;
      sql += " and people.birth_date <= '" + date5.OutDate(mdy | yyyy) + "' and "
             "people.birth_date >= '" + date6.OutDate(mdy | yyyy) + "' and "
             "people.birth_date is not null ";
      sql += " and "
             "exists (select tasks.id from tasks where tasks.person_id = people.id and "
             "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
             "tasks.group_id = 4 "
             "and tasks.current_id > 2) ";
      descriptReport->lblMale10->Caption = GetOneField (dbTransaction, sql).c_str();

      //female
      sql =  "select count(people.id) from people inner join affiliations on "
             "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
             "where people.is_com_client = 1 and people.gender_id = 0 " ;
      sql += " and people.birth_date <= '" + date5.OutDate(mdy | yyyy) + "' and "
             "people.birth_date >= '" + date6.OutDate(mdy | yyyy) + "' and "
             "people.birth_date is not null ";
      sql += " and "
             "exists (select tasks.id from tasks where tasks.person_id = people.id and "
             "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
             "tasks.group_id = 4 "
             "and tasks.current_id > 2) ";
      descriptReport->lblFemale10->Caption = GetOneField (dbTransaction, sql).c_str();

      //male and female between the ages of 15-19
      int age7 = 15;
      age7 -= age7 * 2;
      int age8 = 19;
      age8 -= age8 * 2;
      Pdate date7(DateToStr(Now()).c_str(), mdy | yyyy);
      Pdate date8(DateToStr(Now()).c_str(), mdy | yyyy);
      date7.mod(age7, in_years);
      date8.mod(age8, in_years);

      //male
      sql =  "select count(people.id) from people inner join affiliations on "
             "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
             "where people.is_com_client = 1 and people.gender_id = 0 " ;
      sql += " and people.birth_date <= '" + date7.OutDate(mdy | yyyy) + "' and "
             "people.birth_date >= '" + date8.OutDate(mdy | yyyy) + "' and "
             "people.birth_date is not null ";
      sql += " and "
             "exists (select tasks.id from tasks where tasks.person_id = people.id and "
             "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
             "tasks.group_id = 4 "
             "and tasks.current_id > 2) ";
       descriptReport->lblMale15->Caption = GetOneField (dbTransaction, sql).c_str();

      //female
      sql =  "select count(people.id) from people inner join affiliations on "
             "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
             "where people.is_com_client = 1 and people.gender_id = 0 " ;
      sql += " and people.birth_date <= '" + date7.OutDate(mdy | yyyy) + "' and "
             "people.birth_date >= '" + date8.OutDate(mdy | yyyy) + "' and "
             "people.birth_date is not null ";
      sql += " and "
             "exists (select tasks.id from tasks where tasks.person_id = people.id and "
             "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
             "tasks.group_id = 4 "
             "and tasks.current_id > 2) ";
       descriptReport->lblFemale15->Caption = GetOneField (dbTransaction, sql).c_str();

      //male and female between the ages of 20-24
      int age9 = 20;
      age9 -= age9 * 2;
      int age10 = 24;
      age10 -= age10 * 2;
      Pdate date9(DateToStr(Now()).c_str(), mdy | yyyy);
      Pdate date10(DateToStr(Now()).c_str(), mdy | yyyy);
      date9.mod(age9, in_years);
      date10.mod(age10, in_years);

      //male
      sql =  "select count(people.id) from people inner join affiliations on "
             "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
             "where people.is_com_client = 1 and people.gender_id = 0 " ;
      sql += " and people.birth_date <= '" + date9.OutDate(mdy | yyyy) + "' and "
             "people.birth_date >= '" + date10.OutDate(mdy | yyyy) + "' and "
             "people.birth_date is not null ";
      sql += " and "
             "exists (select tasks.id from tasks where tasks.person_id = people.id and "
             "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
             "tasks.group_id = 4 "
             "and tasks.current_id > 2) ";
     descriptReport->lblMale20->Caption = GetOneField (dbTransaction, sql).c_str();

     //female
      sql =  "select count(people.id) from people inner join affiliations on "
             "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
             "where people.is_com_client = 1 and people.gender_id = 0 " ;
      sql += " and people.birth_date <= '" + date9.OutDate(mdy | yyyy) + "' and "
             "people.birth_date >= '" + date10.OutDate(mdy | yyyy) + "' and "
             "people.birth_date is not null ";
      sql += " and "
             "exists (select tasks.id from tasks where tasks.person_id = people.id and "
             "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
             "tasks.group_id = 4 "
             "and tasks.current_id > 2) ";
      descriptReport->lblFemale20->Caption = GetOneField (dbTransaction, sql).c_str();

      //male and female between the ages of 25-44
      int age11 = 25;
      age11 -= age11 * 2;
      int age12 = 44;
      age12 -=age12 * 2;
      Pdate date11(DateToStr(Now()).c_str(), mdy | yyyy);
      Pdate date12(DateToStr(Now()).c_str(), mdy | yyyy);
      date11.mod(age7, in_years);
      date12.mod(age8, in_years);

      //male
      sql =  "select count(people.id) from people inner join affiliations on "
             "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
             "where people.is_com_client = 1 and people.gender_id = 0 " ;
      sql += " and people.birth_date <= '" + date11.OutDate(mdy | yyyy) + "' and "
             "people.birth_date >= '" + date12.OutDate(mdy | yyyy) + "' and "
             "people.birth_date is not null ";
      sql += " and "
             "exists (select tasks.id from tasks where tasks.person_id = people.id and "
             "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
             "tasks.group_id = 4 "
             "and tasks.current_id > 2) ";
      descriptReport->lblMale25->Caption = GetOneField (dbTransaction, sql).c_str();

      //female
      sql =  "select count(people.id) from people inner join affiliations on "
             "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
             "where people.is_com_client = 1 and people.gender_id = 0 " ;
      sql += " and people.birth_date <= '" + date11.OutDate(mdy | yyyy) + "' and "
             "people.birth_date >= '" + date12.OutDate(mdy | yyyy) + "' and "
             "people.birth_date is not null ";
      sql += " and "
             "exists (select tasks.id from tasks where tasks.person_id = people.id and "
             "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
             "tasks.group_id = 4 "
             "and tasks.current_id > 2) ";
       descriptReport->lblFemale25->Caption = GetOneField (dbTransaction, sql).c_str();

      //male and female between the ages of 45-63
      int age13 = 45;
      age13 -= age13 * 2;
      int age14 = 63;
      age14 -= age14 * 2;
      Pdate date13(DateToStr(Now()).c_str(), mdy | yyyy);
      Pdate date14(DateToStr(Now()).c_str(), mdy | yyyy);
      date13.mod(age13, in_years);
      date14.mod(age14, in_years);

      //male
      sql =  "select count(people.id) from people inner join affiliations on "
             "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
             "where people.is_com_client = 1 and people.gender_id = 0 " ;
      sql += " and people.birth_date <= '" + date13.OutDate(mdy | yyyy) + "' and "
             "people.birth_date >= '" + date14.OutDate(mdy | yyyy) + "' and "
             "people.birth_date is not null ";
      sql += " and "
             "exists (select tasks.id from tasks where tasks.person_id = people.id and "
             "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
             "tasks.group_id = 4 "
             "and tasks.current_id > 2) ";
      descriptReport->lblMale45->Caption = GetOneField (dbTransaction, sql).c_str();

      //female
      sql =  "select count(people.id) from people inner join affiliations on "
             "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
             "where people.is_com_client = 1 and people.gender_id = 0 " ;
      sql += " and people.birth_date <= '" + date13.OutDate(mdy | yyyy) + "' and "
             "people.birth_date >= '" + date14.OutDate(mdy | yyyy) + "' and "
             "people.birth_date is not null ";
      sql += " and "
             "exists (select tasks.id from tasks where tasks.person_id = people.id and "
             "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
             "tasks.group_id = 4 "
             "and tasks.current_id > 2) ";
       descriptReport->lblFemale45->Caption = GetOneField (dbTransaction, sql).c_str();

      //male and female 64 and over
      int age15 = 64;
      age15 -= age15 * 2;
      Pdate date15(DateToStr(Now()).c_str(), mdy | yyyy);
      date15.mod(age15, in_years);

      //male
      sql =  "select count(people.id) from people inner join affiliations on "
             "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
             "where people.is_com_client = 1 and people.gender_id = 0 " ;
      sql += " and people.birth_date >= '" + date15.OutDate(mdy | yyyy) + "' and "
             "people.birth_date is not null ";
      sql += " and "
             "exists (select tasks.id from tasks where tasks.person_id = people.id and "
             "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
             "tasks.group_id = 4 "
             "and tasks.current_id > 2) ";
      descriptReport->lblMale64->Caption = GetOneField (dbTransaction, sql).c_str();

     //female
     sql =  "select count(people.id) from people inner join affiliations on "
             "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
             "where people.is_com_client = 1 and people.gender_id = 0 " ;
      sql += " and people.birth_date >= '" + date15.OutDate(mdy | yyyy) + "' and "
             "people.birth_date is not null ";
      sql += " and "
             "exists (select tasks.id from tasks where tasks.person_id = people.id and "
             "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
             "tasks.group_id = 4 "
             "and tasks.current_id > 2) ";
      descriptReport->lblFemale64->Caption = GetOneField (dbTransaction, sql).c_str();

      compositeReport->Reports->Add(descriptReport->page2);



      //place values for page 3 on the form
      TformReportComPatientTotals * totalsReport = new TformReportComPatientTotals(NULL);

      sql = "select count(people.id) from people inner join affiliations on "
            "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
            "where people.is_com_client = 1 and people.gender_id = 1 and "
            "exists (select tasks.id from tasks where tasks.person_id = people.id and "
            "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
            "tasks.group_id = 4 "
            "and tasks.current_id > 2) ";

      totalsReport->lblMaleAb->Caption = GetOneField(dbTransaction, sql).c_str();


      sql = "select count(people.id) from people inner join affiliations on "
            "people.affiliations_id = affiliations.id and affiliations.tribe_id = 1 "
            "where people.is_com_client = 1 and people.gender_id = 0 and "
            "exists (select tasks.id from tasks where tasks.person_id = people.id and "
            "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
            "tasks.group_id = 4 "
            "and tasks.current_id > 2)";

      totalsReport->lblFemaleAb->Caption = GetOneField(dbTransaction, sql).c_str();


      sql = "select count(people.id) from people inner join affiliations on "
            "people.affiliations_id = affiliations.id and affiliations.tribe_id != 1 "
            "where people.is_com_client = 1 and people.gender_id = 1 and "
            "exists (select tasks.id from tasks where tasks.person_id = people.id and "
            "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
            "tasks.group_id = 4 "
            "and tasks.current_id > 2)";

      totalsReport->lblMaleNon->Caption = GetOneField(dbTransaction, sql).c_str();


      sql = "select count(people.id) from people inner join affiliations on "
            "people.affiliations_id = affiliations.id and affiliations.tribe_id != 1 "
            "where people.is_com_client = 1 and people.gender_id = 0 and "
            "exists (select tasks.id from tasks where tasks.person_id = people.id and "
            "tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' and "
            "tasks.group_id = 4 "
            "and tasks.current_id > 2)";

      totalsReport->lblFemaleNon->Caption = GetOneField(dbTransaction, sql).c_str();

      compositeReport->Reports->Add(totalsReport->page3);   */
//---------------------------------------------------------------------------
void __fastcall TformLaunchComPatientDescriptive::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

