#ifndef FORMHEADERS_H
#define FORMHEADERS_H

// as far as i know, this file is now only used by codePrometheus.cpp, so that
// it knows how to launch every form that can be launched from there. it's also
// nice to have as a listing, but forgetting an entry here may no longer break
// everything, since forms are responsible for #including any forms they depend
// on (and only the ones they depend on.)
// thus, this list may be shrinkable, if codePrometheus doesn't need the stuff
// anymore. wouldn't surprise me. a lot of these forms only get launched from
// others (and are thus #included by association.)

#include "prometheus_util.h"

// all the forms' .h files
#include "baseheaders.h"

// actual derived forms
#include "codeSpecialGeneric.h" // (included by the above, oh well)
#include "codeRecordGeneric.h"
#include "codeSearchGeneric.h"
#include "codeWizardGeneric.h"
#include "launchGeneric.h"

// derived from recordGeneric
#include "codeRecordAccount.h"
#include "codeRecordActivity.h"
#include "codeRecordAffiliations.h"
#include "codeRecordAppointment.h"
#include "codeRecordBehOutsideTreatment.h"
#include "codeRecordBug.h"
#include "codeRecordChart.h"
#include "codeRecordCheck.h"
#include "codeRecordCobRequest.h"
#include "codeRecordComDrug.h"
#include "codeRecordComHealth.h"
#include "codeRecordComNutrition.h"
#include "codeRecordComVisit.h"
#include "codeRecordCondition.h"
#include "codeRecordCondition.h"
#include "codeRecordConsent.h"
#include "codeRecordContactInfo.h"
#include "codeRecordDeferredCOB.h"
#include "codeRecordDenial.h"
#include "codeRecordDenialLetter.h"
#include "codeRecordDiabScore.h"
#include "codeRecordEntityContract.h"
#include "codeRecordEvent.h"
#include "codeRecordFitnessAttendance.h"
#include "codeRecordFitnessMembership.h"
#include "codeRecordFitnessPerson.h"
#include "codeRecordIncomingBill.h"
#include "codeRecordInsuranceCoverage.h"
#include "codeRecordInsurancePolicy.h"
#include "codeRecordLogsheet.h"
#include "codeRecordName.h"
#include "codeRecordObservationQuestion.h"
#include "codeRecordObservationResponseSet.h"
#include "codeRecordOutgoingBill.h"
#include "codeRecordParticipationsDiab.h"
#include "codeRecordPerson.h"
#include "codeRecordPersonNotes.h"
#include "codeRecordProcedure.h"
#include "codeRecordPurchaseReq.h"
#include "codeRecordReferral.h"
#include "codeRecordRelationship.h"
#include "codeRecordServiceProvided.h"
#include "codeRecordSurvey.h"
#include "codeRecordTaskBeh.h"
#include "codeRecordTaskCare.h"
#include "codeRecordTaskCob.h"
#include "codeRecordTaskCobVisit.h"
#include "codeRecordTaskCom.h"
#include "codeRecordTaskDen.h"
#include "codeRecordTaskDiab.h"
#include "codeRecordTaskLac.h"
#include "codeRecordTaskTrans.h"
#include "codeRecordTaxEntity.h"
#include "codeRecordToDo.h"
#include "codeRecordTransaction.h"
#include "codeRecordTreatmentBeh.h"
#include "codeRecordWaiver.h"

// derived from searchGeneric
#include "codeSearchAccount.h"
#include "codeSearchActivity.h"
#include "codeSearchAppointment.h"
#include "codeSearchBill.h"
#include "codeSearchBugLog.h"
#include "codeSearchCallLog.h"
#include "codeSearchCheck.h"
#include "codeSearchCode.h"
#include "codeSearchComPubTask.h"
#include "codeSearchCrashLog.h"
#include "codeSearchDeferredCOB.h"
#include "codeSearchDenial.h"
#include "codeSearchDenialLetter.h"
#include "codeSearchDiabEducation.h"
#include "codeSearchEvent.h"
#include "codeSearchFDADrug.h"
#include "codeSearchFeeSchedule.h"
#include "codeSearchFitnessMembership.h"
#include "codeSearchInsuranceApplication.h"
#include "codeSearchInsurancePolicy.h"
#include "codeSearchLogsheet.h"
#include "codeSearchMessageBoxLog.h"
#include "codeSearchObsResponseSet.h"
#include "codeSearchPerson.h"
#include "codeSearchPubTask.h"
#include "codeSearchPurchaseReq.h"
#include "codeSearchServiceProvided.h"
#include "codeSearchSurvey.h"
#include "codeSearchTaskBeh.h"
#include "codeSearchTaskCare.h"
#include "codeSearchTaskCob.h"
#include "codeSearchTaskCobVisit.h"
#include "codeSearchTaskCom.h"
#include "codeSearchTaskDiab.h"
#include "codeSearchTaskLac.h"
#include "codeSearchTaskPub.h"
#include "codeSearchTaskTrans.h"
#include "codeSearchTaxEntity.h"
#include "codeSearchTransaction.h"

// derived from specialGeneric
#include "codeEnrollmentDiabRegistry.h"
#include "codeEnrollmentDiabSteps.h"
#include "codeFilterPreferences.h"
#include "codeSpecialAction.h"
#include "codeSpecialAddTable.h"
#include "codeSpecialAddUser.h"
#include "codeSpecialAddValues.h"
#include "codeSpecialAppointmentReminders.h"
#include "codeSpecialAttachActivitiesToLogsheets.h"
#include "codeSpecialBugs.h"
#include "codeSpecialCallLog.h"
#include "codeSpecialChangePassword.h"
#include "codeSpecialChat.h"
#include "codeSpecialCheckSentNotification.h"
#include "codeSpecialChildConsent.h"
#include "codeSpecialClinicVisit.h"
#include "codeSpecialComChildForm.h"
#include "codeSpecialComDrugRegimenForm.h"
#include "codeSpecialComForm.h"
#include "codeSpecialComNewbornForm.h"
#include "codeSpecialComPostpartumForm.h"
#include "codeSpecialComPrenatalForm.h"
#include "codeSpecialComTaskForm.h"
#include "codeSpecialDataMerge.h"
#include "codeSpecialDataNavigate.h"
#include "codeSpecialDataQuery.h"
#include "codeSpecialDebug.h"
#include "codeSpecialDeletePerson.h"
#include "codeSpecialDiabInactive.h"
#include "codeSpecialDiabWarningLetter.h"
#include "codeSpecialDischargeBeh.h"
#include "codeSpecialDoctorStatementForm.h"
#include "codeSpecialDropTempViews.h"
#include "codeSpecialExportActivityReport.h"
#include "codeSpecialExportHL7ForIHS.h"
#include "codeSpecialExportListview.h"
#include "codeSpecialExportMeasurementReport.h"
#include "codeSpecialGeneralJournal.h"
#include "codeSpecialHandleCob.h"
#include "codeSpecialIntake.h"
#include "codeSpecialLatestInsurance.h"
#include "codeSpecialLedger.h"
#include "codeSpecialLicenses.h"
#include "codeSpecialLookupTableInfo.h"
#include "codeSpecialLookupTables.h"
#include "codeSpecialMergePerson.h"
#include "codeSpecialMergeTaxEntity.h"
#include "codeSpecialMetricConversion.h"
#include "codeSpecialMonthlyActivityForm.h"
#include "codeSpecialNewBudgetMod.h"
#include "codeSpecialNewInterofficeReferral.h"
#include "codeSpecialNewTransportationTasks.h"
#include "codeSpecialObservationQuestionSetEditor.h"
#include "codeSpecialObservationStatistics.h"
#include "codeSpecialObsExpectedRanges.h"
#include "codeSpecialOrderShoes.h"
#include "codeSpecialParQForm.h"
#include "codeSpecialPermissions.h"
#include "codeSpecialPermissionsDiff.h"
#include "codeSpecialPermissionsToUsers.h"
#include "codeSpecialPersonLimits.h"
#include "codeSpecialPreparePurchaseReqs.h"
#include "codeSpecialPrometheusVersionLog.h"
#include "codeSpecialQuery.h"
#include "codeSpecialReachContract.h"
#include "codeSpecialReceiveShoes.h"
#include "codeSpecialReminder.h"
#include "codeSpecialRouterAdministration.h"
#include "codeSpecialSaveListView.h"
#include "codeSpecialSchedule2.h"
#include "codeSpecialScreenStatistics.h"
#include "codeSpecialSentReferrals.h"
#include "codeSpecialSettings.h"
#include "codeSpecialSqlViewer.h"
#include "codeSpecialStepsAffiliates.h"
#include "codeSpecialStepsForm.h"
#include "codeSpecialTimesheet.h"
#include "codeSpecialUpdatesNeeded.h"
#include "codeSpecialUploadComputerRx.h"
#include "codeSpecialUploadEckerd.h"
#include "codeSpecialUploadVersion.h"
#include "codeSpecialUploadWalMart.h"
#include "codeSpecialUserColors.h"
#include "codeSpecialViewChangeLog.h"
#include "codeSpecialViewCode.h"
#include "codeSpecialViewReport.h"
#include "codeSpecialWaitingReferrals.h"
#include "launchAmountsByProviderService.h"
#include "launchAppointmentReport.h"
#include "launchBehActivityReport.h"
#include "launchBehConditionReport.h"
#include "launchBehLocalTreatmentReport.h"
#include "launchBehMeetingReport.h"
#include "launchBehOutsideTreatmentReport.h"
#include "launchBehProgramReport.h"
#include "launchBehReferralReport.h"
#include "launchBehTaskReport.h"
#include "launchBehVisitReports.h"
#include "launchBudgetModsReport.h"
#include "launchBudgetReport.h"
#include "launchCallLogReport.h"
#include "launchCareSummary.h"
#include "launchChefReport.h"
#include "launchClinicPatientListReport.h"
#include "launchCobProductivityReport.h"
#include "launchCobSummaryReport.h"
#include "launchComCommentReport.h"
#include "launchComCommentReport.h"
#include "launchComEducationReport.h"
#include "launchComMeasurements.h"
#include "launchComPersonVisitReport.h"
#include "launchComPublicHealthReport.h"
#include "launchComServicesReport.h"
#include "launchComVisitReport.h"
#include "launchComWorkloadReport.h"
#include "launchDentalAppointmentReport.h"
#include "launchDepartmentCallLogReport.h"
#include "launchDepartmentCallTotalsReport.h"
#include "launchDepartmentContactsReport.h"
#include "launchDiabActivitiesByOutcomeReport.h"
#include "launchDiabActivityReport.h"
#include "launchDiabActivitySummaryReport.h"
#include "launchDiabAttendanceReport.h"
#include "launchDiabAvgScoresPerTopicReport.h"
#include "launchDiabCheckCountReport.h"
#include "launchDiabClientReport.h"
#include "launchDiabCommentReport.h"
#include "launchDiabContactReport.h"
#include "launchDiabEmployeeTaskReport.h"
#include "launchEventListingReport.h"
#include "launchDiabHoursReport.h"
#include "launchDiabLogsheetReport.h"
#include "launchDiabLogsheetSummaryReport.h"
#include "launchDiabMeasurementComparisonReport.h"
#include "launchDiabMeasurementCountReport.h"
#include "launchDiabMeasurementLabels.h"
#include "launchDiabMeasurementReport.h"
#include "launchDiabMeasureSummaryReport.h"
#include "launchDiabMeetingReport.h"
#include "launchDiabMileageReport.h"
#include "launchDiabNewMembershipLetters.h"
#include "launchDiabOverweightReport.h"
#include "launchDiabParticipationReport.h"
#include "launchDiabPeopleNotSeenReport.h"
#include "launchDiabRegistryReport.h"
#include "launchDiabReminderLettersReport.h"
#include "launchDiabScoreSummaryReport.h"
#include "launchDiabStaffActivityReport.h"
#include "launchDiabStarSessionReport.h"
#include "launchDiabTaskReport.h"
#include "launchDiabTribalReport.h"
#include "launchEckerdReports.h"
#include "launchEmployeeCallLogReport.h"
#include "launchEmployeeCallTotalsReport.h"
#include "launchEventByClientReport.h"
#include "launchFitnessAttendanceReport.h"
#include "launchFitnessMembershipReport.h"
#include "launchFitnessMembershipSummaryReport.h"
#include "launchFitnessReleaseReport.h"
#include "launchFitnessWaitingListReport.h"
#include "launchIHSReport.h"
#include "launchIncentiveReport.h"
#include "launchInsuranceByAppointmentReport.h"
#include "launchInsuranceStatisticsReport.h"
#include "launchIntake.h"
#include "launchIntakeFormReport.h"
#include "launchLogDetailAllUsers.h"
#include "launchLogInAveragesAllUsers.h"
#include "launchLogPerUser.h"
#include "launchLogsheetsForDateRangePerPerson.h"
#include "launchLogSummary.h"
#include "launchLogTotalsPerUser.h"
#include "launchMonthlyActivityLogReport.h"
#include "launchMonthlyObligatedReport.h"
#include "launchObligatedAccountsReport.h"
#include "launchObligatedProviderReport.h"
#include "launchObligatedServiceReport.h"
#include "launchPatientLoadByDepartment.h"
#include "launchPendingAccountsReport.h"
#include "launchPendingShoeReport.h"
#include "launchPharmStateReport.h"
#include "launchProviderLabels.h"
#include "launchProviderSummaryReport.h"
#include "launchPublicCommentReport.h"
#include "launchPublicEducationReport.h"
#include "launchPublicMeasurement.h"
#include "launchPublicVisitReport.h"
#include "launchReceptionistLogReport.h"
#include "launchServiceProvidedReport.h"
#include "launchShoesOrderedReport.h"
#include "launchSpendersReport.h"
#include "launchStepsCheckReport.h"
#include "launchTransportationSummaryReport.h"
#include "launchUsageLogPerFormReport.h"
#include "launchUsageLogPerUser.h"
#include "launchUsageLogPerUserByDate.h"
#include "launchUsageLogSummary.h"
#include "launchUsageLogSummaryByDate.h"
#include "launchYearlyPharmacyReport.h"
#include "reportDiabParticipation.h"
// don't add forms to this list if they are not opened from the main menu

// derived from SpecialListview (needed in prometheus_util.h)
#include "codeSpecialSelectListview.h";

// derived from launchGeneric
#include "launchApptOutcomeDetailReport.h"
#include "launchARRAExemptionForm.h"
#include "launchBehWorkloadReport.h"
#include "launchCHSBillingWorkloadReport.h"
#include "launchDenialLettersReport.h"
#include "launchDentalBillingDataReport.h"
#include "launchDiabApptReport.h"
#include "launchDollarsWithProceduresReport.h"
#include "launchEnrollment.h"
#include "launchFormLetter.h"
#include "launchInsuranceChargeAnalysisReport.h"
#include "launchMailingLabels.h"
#include "launchObligatedAndExpensedReports.h"
#include "launchOptometryAppointments.h"
#include "launchProceduresWithoutChargesReport.h"
#include "launchProcsByProvider.h"
#include "launchSoonerCare.h"
#include "launchTaskDemoReport.h"
#include "launchVendorBillsOverAmountReport.h"

// derived from wizardGeneric
#include "codeWizardAccountAdjustments.h"
#include "codeWizardAccountCloseEquity.h"
#include "codeWizardIntakeNewPerson.h"
#include "codeWizardLaunchIndicatorReports.h"
#include "codeWizardNewAccount.h"
#include "codeWizardNewBudget.h"
#include "codeWizardNewCheck.h"
#include "codeWizardNewContractHealthItem.h"
#include "codeWizardNewPerson.h"
#include "codeWizardNewPurchaseRequest.h"
#include "codeWizardNewReferral.h"
#include "codeWizardNewVendorBill.h"
#include "codeWizardObservationOptionSet.h"

// main forms (extra)
#include "codePrometheusSplash.h"
#include "codeLoginBox.h"
#include "codePrometheusAbout.h"
#include "codeMessaging.h"

#endif
