//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "framePrometheusMenu.h"
#include "codePrometheus.h"
#include "formheaders.h"
#include "codeRelationGeneric.h"
#include "action_factories.h"
#include "codeSpecialDisambiguate.h"
#include "deferred_messages.h"
extern TformSpecialChat *chat_window;
extern TformSpecialSchedule2 *scheduling_window;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TframePrometheusMenu *framePrometheusMenu;
//---------------------------------------------------------------------------
__fastcall TframePrometheusMenu::TframePrometheusMenu(TComponent* Owner)
        : TFrame(Owner)
{
}
//---------------------------------------------------------------------------
void TframePrometheusMenu::SetParentForm(TformPrometheusMenu *pForm)
{
  Form = pForm;
}
//---------------------------------------------------------------------------
TControlBar *TframePrometheusMenu::GetControlBar()
{
  return barMenu;
}
//---------------------------------------------------------------------------
TToolBar *TframePrometheusMenu::GetToolBar()
{
  return toolsPrometheus;
}
//---------------------------------------------------------------------------
TMainMenu *TframePrometheusMenu::GetMainMenu()
{
  return menuPrometheusMenu;
}
//---------------------------------------------------------------------------
// jhaley 20110415: Return the system tray popup menu
TPopupMenu *TframePrometheusMenu::GetTrayPopupMenu()
{
  return menuPopup;
}
//---------------------------------------------------------------------------
void TframePrometheusMenu::EnableMenus(bool all_is_well)
{
  // the menu items in this function are organized by top level menu
  // item they occur under. the items should be listed in this function
  // in the same order as they occur on the menu (makes them easier to find!)

  // all of the menu items now have the prefix "menuSection"
  // for example, all items under the search menu have the prefix menuSearch
  // this standard had been loosly followed before, so i went ahead
  // and changed the rest to match

  // disable all menu items with a tag of 0
  // enable all menu items with a tag of 2
  Form->RecurseMenu(menuPrometheusMenu, 0, false);
  if(dbDatabase->TestConnected())
    Form->RecurseMenu(menuPrometheusMenu, 1, true);
  else
    Form->RecurseMenu(menuPrometheusMenu, 1, false);
  Form->RecurseMenu(menuPrometheusMenu, 2, true);

  //-------------------------------------------------------------------------------------------
  // File
  //-------------------------------------------------------------------------------------------

  if (Form->logged_in)
  {
    menuChangePassword->Visible = true;
    menuResetDefaults->Visible = true;
    menuSettings->Visible = true;
  }

  // to be less confusing, hopefully?
  if (Form->logged_in)
   menuSwitchUsers->Caption = "Switch users...";
  else
   menuSwitchUsers->Caption = "Log in...";

  //-------------------------------------------------------------------------------------------
  // Search
  //-------------------------------------------------------------------------------------------

  // Administration
  menuSearchBugLog->Visible        = (optionsPermissions["table.bugs"           ]["view"] == "true");
  menuSearchCrashLog->Visible      = (optionsPermissions["table.crash_logs"     ]["view"] == "true");
  menuSearchMessageBoxLog->Visible = (optionsPermissions["table.message_box_log"]["view"] == "true");

  menuSearchPerson->Visible = (optionsPermissions["table.people"]["view"] == "true");
  menuSearchMedicalCode->Visible = (optionsPermissions["table.codes"]["view"] == "true") ;
  menuSearchMedicalFeeSchedule->Visible = (optionsPermissions["table.codes"]["view"] == "true" &&
                                           optionsPermissions["special.fee_schedule"]["enabled"] == "true");
  menuSearchAppointment->Visible = (optionsPermissions["table.appointments"]["view"] == "true");
  if (optionsPermissions["table.tasks.cob"]["view"] == "true")
  {
    menuSearchCob->Visible = true;
    menuSearchCobVisit->Visible = true;
  }
  menuSearchCHSDeferredCOB->Visible = (optionsPermissions["table.deferred_cobs"]["view"] == "true"); // jhaley 20120301
  menuSearchInsurancePolicy->Visible = (optionsPermissions["table.insurance_policies"]["view"] == "true");
  menuSearchAccount->Visible = (optionsPermissions["table.accounts"]["view"] == "true");
  menuSearchCheck->Visible = (optionsPermissions["table.checks"]["view"] == "true");
  menuSearchPr->Visible = (optionsPermissions["table.purchase_reqs"]["view"] == "true");
  if(optionsPermissions["table.bills.incoming"]["view"] == "true")
  {
    menuSearchIncomingVendorBill->Visible = true;
    menuSearchIncomingProviderBill->Visible = true;
  }
  menuSearchOutgoingProviderBill->Visible = (optionsPermissions["table.bills.outgoing"]["view"] == "true");
  menuSearchTaxEntity->Visible = (optionsPermissions["table.tax_entities"]["view"] == "true");
  menuSearchServiceProvided->Visible = (optionsPermissions["table.services_provided"]["view"] == "true");
  menuSearchTransaction->Visible = (optionsPermissions["table.transactions"]["view"] == "true");
  menuSearchMedicalVisit->Visible = (optionsPermissions["table.tasks.lac"]["view"] == "true" ||
                                     optionsPermissions["table.tasks.sc"]["view"] == "true");
  menuSearchTaskDen->Visible = (optionsPermissions["table.tasks.den"]["view"] == "true");
  menuSearchTaskBeh->Visible = (optionsPermissions["table.tasks.beh"]["view"] == "true");
  menuSearchEventBeh->Visible = (optionsPermissions["table.events.beh"]["view"] == "true");
  menuSearchEventCare->Visible = (optionsPermissions["table.events.care"]["view"] == "true");
  menuSearchEventCom->Visible = (optionsPermissions["table.events.com"]["view"] == "true");
  menuSearchEventPub->Visible = (optionsPermissions["table.events.pub"]["view"] == "true");
  menuSearchEventMedical->Visible = (optionsPermissions["table.tasks.lac"]["view"] == "true" ||
                                     optionsPermissions["table.tasks.sc"]["view"] == "true");
  menuSearchEventDen->Visible = (optionsPermissions["table.events.den"]["view"] == "true");
  menuSearchTaskDiab->Visible = (optionsPermissions["table.tasks.diab"]["view"] == "true");
  menuSearchEventDiab->Visible = (optionsPermissions["table.events.diab"]["view"] == "true");
  menuSearchFitnessMembership->Visible = (optionsPermissions["table.fitness_memberships"]["view"] == "true");
  menuSearchActivity->Visible = (optionsPermissions["table.activities"]["view"] == "true");
  menuSearchDiabEducation->Visible = (optionsPermissions["table.diab_education"]["view"] == "true");
  menuSearchDiabLogsheet->Visible = (optionsPermissions["table.activity_logsheets"]["view"] == "true");
  menuSearchDiabSurvey->Visible = (optionsPermissions["table.surveys"]["view"] == "true");
  menuSearchCallLog->Visible = (optionsPermissions["table.call_log"]["view"] == "true");

  if(optionsPermissions["table.tasks.com"]["view"] == "true")
  {
    menuSearchVisitCom->Visible = true;
    menuSearchTaskCom->Visible = true;
  }
  if(optionsPermissions["table.tasks.pub"]["view"] == "true")
  {
    menuSearchTaskPub->Visible = true;
    menuSearchVisitPub->Visible = true;
  }

  menuSearchTaskCare->Visible = (optionsPermissions["table.tasks.care"]["view"] == "true");
  menuSearchTaskTrans->Visible = (optionsPermissions["table.tasks.trans"]["view"] == "true");
  menuSearchObsResponseSet->Visible = (optionsPermissions["table.obs_response_sets"]["view"] == "true");
  menuSearchDenial->Visible = (optionsPermissions["table.denials"]["view"] == "true");
  menuSearchDenialLetter->Visible = (optionsPermissions["table.denial_letters"]["view"] == "true");

  // jhaley 20110512: FDA drug search is globally visible
  menuSearchFDADrugs->Visible = true;

  //-------------------------------------------------------------------------------------------
  // Create
  //-------------------------------------------------------------------------------------------

  menuCreateAccount->Visible = (optionsPermissions["table.accounts"]["insert"] == "true");
  menuCreateTaxEntity->Visible = (optionsPermissions["table.tax_entities"]["insert"] == "true");
  menuCreateBudgetMod->Visible = ((optionsPermissions["table.transactions"]["insert"] == "true") &&
                                  (optionsPermissions["table.accounts"]["view"] == "true") &&
                                  (optionsPermissions["special.budget_mod"]["enabled"] == "true") &&
                                  (optionsPermissions["special.budget_mod"]["enabled"] == "true"));
  menuCreateCheck->Visible = ((optionsPermissions["table.checks"]["insert"] == "true") &&
                              (optionsPermissions["table.accounts"]["view"] == "true") &&
                              (optionsPermissions["table.purchase_reqs"]["update"] == "true") &&
                              (optionsPermissions["table.transactions"]["insert"] == "true"));
  menuCreatePR->Visible = ((optionsPermissions["table.purchase_reqs"]["insert"] == "true") &&
                           (optionsPermissions["table.accounts"]["view"] == "true") &&
                           (optionsPermissions["table.bills.incoming"]["update"] == "true"));

  if((optionsPermissions["table.accounts"]["view"] == "true") &&
     (optionsPermissions["table.transactions"]["insert"] == "true"))
  {
    if (optionsPermissions["table.bills"]["insert"] == "true")
    {
      menuCreateContractHealthBill->Visible = true;
      //menuCreateVendorBill->Visible = true;
      menuCreateVendorBill->Visible = true;
    }
    if (optionsPermissions["table.tasks.cob"]["insert"] == "true")
    {
       menuCreateContractHealthCOB->Visible = true;
    }
  }

  // jhaley 20120228: deferred COBs
  menuCreateCHSDeferredCOB->Visible = (optionsPermissions["table.deferred_cobs"]["insert"] == "true");

  menuCreateMedicalVisit->Visible = (optionsPermissions["table.tasks.lac"]["insert"] == "true" ||
                                     optionsPermissions["table.tasks.sc"]["insert"] == "true");
  menuCreateMedicalEvent->Visible = (optionsPermissions["table.events.sc"]["insert"] == "true");
  menuCreateDentalClinicVisit->Visible = (optionsPermissions["table.tasks.den"]["insert"] == "true");
  menuCreateCobRequest->Visible = (optionsPermissions["table.cob_requests"]["insert"] == "true");
  menuCreateTaskBeh->Visible = (optionsPermissions["table.tasks.beh"]["insert"] == "true");
  menuCreateEventBeh->Visible = (optionsPermissions["table.events.beh"]["insert"] == "true");

  if(optionsPermissions["table.tasks.diab"]["insert"] == "true")
  {
    menuCreateTaskDiab->Visible = true;
    menuCreateDiabetesPhoneCall->Visible = true;
    menuCreateDiabetesClientVisit->Visible = true;
    menuCreateDiabetesMailout->Visible = true;
  }

  menuCreateEventDiab->Visible = (optionsPermissions["table.events.diab"]["insert"] == "true");
  menuCreateFitnessMembership->Visible = (optionsPermissions["table.fitness_memberships"]["insert"] == "true");
  menuCreateDiabSurvey->Visible = (optionsPermissions["table.surveys"]["insert"] == "true");
  menuCreateDiabLogsheet->Visible = (optionsPermissions["table.activity_logsheets"]["insert"] == "true");
  menuCreateEventCare->Visible = (optionsPermissions["table.events.care"]["insert"] == "true");
  menuCreateComAdultVisit->Visible = (optionsPermissions["table.tasks.com"]["insert"]=="true");
  menuCreateComDrugRegimen->Visible = (optionsPermissions["table.com_drug_regimen.com"]["insert"]=="true") ;
  menuCreateEventCom->Visible = (optionsPermissions["table.events.com"]["insert"] == "true");
  menuCreateTaskCom->Visible = (optionsPermissions["table.tasks.com"]["insert"]=="true");
  if(optionsPermissions["table.tasks.pub"]["insert"] =="true")
  {
    menuCreatePubAdultVisit->Visible = true;
    menuCreateChildVisit->Visible = true;
    menuCreateNewbornVisit->Visible = true;
    menuCreatePrenatalVisit->Visible = true;
    menuCreatePostpartumVisit->Visible = true;
    menuCreatePublicTask->Visible = true;
  }

  menuCreatePublicEvent->Visible = (optionsPermissions["table.events.pub"]["insert"] == "true");
  menuCreatePublicDrug->Visible = (optionsPermissions["table.com_drug_regimen.pub"]["insert"]=="true");

  menuCreateTaskCare->Visible = (optionsPermissions["table.tasks.care"]["insert"] == "true");
  menuCreateTaskTrans->Visible = (optionsPermissions["table.tasks.trans"]["insert"] == "true");
  menuCreateTasksTrans->Visible = (optionsPermissions["table.tasks.trans"]["insert"] == "true");

  menuCreatePerson->Visible = ((optionsPermissions["table.people"]["insert"] == "true") &&
                               (optionsPermissions["table.person_names"]["insert"] == "true") &&
                               (optionsPermissions["table.affiliations"]["insert"] == "true") &&
                               (optionsPermissions["table.person_contact_info"]["insert"] == "true") &&
                               (optionsPermissions["table.person_notes"]["insert"] == "true"));

  menuCreateInterofficeReferral->Visible = (optionsPermissions["table.referrals"]["insert"] == "true");
  menuCreateReferralWizard->Visible = (optionsPermissions["table.referrals"]["insert"] == "true");    // jhaley 20111114

  //-------------------------------------------------------------------------------------------
  // Report
  //-------------------------------------------------------------------------------------------

  // administration
  if(optionsPermissions["report.admin"]["enabled"] == "true")
  {
    menuReportPermissions->Visible = (optionsPermissions["admin.edit_permissions"]["enabled"] == "true");
    if((optionsPermissions["table.usage_log"]["view"] == "true") &&
      (optionsPermissions["admin.screen_statistics"]["enabled"] == "true"))
    {
      menuReportUsageLog->Visible = true;
      menuReportUsageLogSummaryPerUser->Visible = true;
      menuReportUsageLogSummaryPerUserByDate->Visible = true;
      menuReportUsageLogSummaryAllUsers->Visible = true;
      menuReportUsageLogSummaryAllUsersByDate->Visible = true;
      menuReportUsageLogPerForm->Visible = true;
    }
    if(optionsPermissions["table.log_log"]["view"] == "true")
    {
      menuReportLogLog->Visible = true;
      menuReportLogTotalsPerUser->Visible = true;
      menuReportLogDetailPerUser->Visible = true;
      menuReportLogTotalsAllUsers->Visible = true;
      menuReportLogDetailAllUsers->Visible = true;
      menuReportLogAveragesAllUsers->Visible = true;
    }
    menuReportAdminContactsPerDepartment->Visible = ((optionsPermissions["table.tasks"]["view"] == "true")      &&
                                                     (optionsPermissions["table.tasks.beh"]["view"] == "true")  &&
                                                     (optionsPermissions["table.tasks.cob"]["view"] == "true")  &&
                                                     (optionsPermissions["table.tasks.com"]["view"] == "true")  &&
                                                     (optionsPermissions["table.tasks.den"]["view"] == "true")  &&
                                                     (optionsPermissions["table.tasks.diab"]["view"] == "true") &&
                                                     (optionsPermissions["table.tasks.lac"]["view"] == "true")  &&
                                                     (optionsPermissions["table.tasks.pub"]["view"] == "true")  &&
                                                     (optionsPermissions["table.tasks.sc"]["view"] == "true")   &&
                                                     (optionsPermissions["table.tasks.trans"]["view"] == "true"));
    menuReportAdminPatientLoadByDepartment->Visible = // menuReportAdminContactsPerDepartment->Visible && // overly restrictive
                                                      optionsPermissions["table.people"]["view"] == "true"      &&
                                                      optionsPermissions["table.tasks"]["view"] == "true"       &&
                                                     ( // one or more of the following
                                                      optionsPermissions["table.tasks.beh"]["view"] == "true"   ||
                                                      optionsPermissions["table.tasks.cob"]["view"] == "true"   ||
                                                      optionsPermissions["table.tasks.com"]["view"] == "true"   ||
                                                      optionsPermissions["table.tasks.den"]["view"] == "true"   ||
                                                      optionsPermissions["table.tasks.diab"]["view"] == "true"  ||
                                                      optionsPermissions["table.tasks.lac"]["view"] == "true"   ||
                                                      optionsPermissions["table.tasks.pub"]["view"] == "true"   ||
                                                      optionsPermissions["table.tasks.sc"]["view"] == "true"    ||
                                                      optionsPermissions["table.tasks.trans"]["view"] == "true" );

    menuReportAdminDollarsProcedures->Visible     = ((optionsPermissions["table.tasks"]["view"] == "true")      &&
                                                     (optionsPermissions["table.codes"]["view"] == "true")      &&
                                                     (optionsPermissions["table.procedures"]["view"] == "true"));

    menuReportAdminProceduresWithoutCharges->Visible = ((optionsPermissions["table.tasks"]["view"] == "true")    &&
                                                        (optionsPermissions["table.codes"]["view"] == "true")   &&
                                                        (optionsPermissions["table.procedures"]["view"] == "true"));
  }

  // appointments - jhaley 20110113
  if(optionsPermissions["report.appointments"]["enabled"] == "true")
  {
    menuReportAppointment->Visible = ((optionsPermissions["table.appointments.people"]["view"] == "true") &&
                                      (optionsPermissions["table.appointments"]["view"] == "true"));

    menuReportReminderLetters->Visible = ((optionsPermissions["table.appointments.people"]["view"] == "true") &&
                                          (optionsPermissions["table.appointments"]["view"] == "true") &&
                                          ((optionsPermissions["special.den.general"]["enabled"] == "true") ||
                                           (optionsPermissions["special.diab.general"]["enabled"] == "true") ||
                                           (optionsPermissions["special.beh.general"]["enabled"] == "true") ||
                                           (optionsPermissions["special.lac.general"]["enabled"] == "true") ||
                                           (optionsPermissions["special.sc.general"]["enabled"] == "true")));

    // jhaley 20110413: DM client appointments report for Tara
    menuReportDMClientAppointments->Visible = (optionsPermissions["report.appointments.dmclients"]["enabled"] == "true");

    menuInsuranceByAppointmentReport->Visible = ((optionsPermissions["table.appointments.people"]["view"] == "true") &&
                                                 (optionsPermissions["table.appointments"]["view"] == "true") &&
                                                 (optionsPermissions["table.insurance_coverage"]["view"] == "true") &&
                                                 (optionsPermissions["table.insurance_policies"]["view"] == "true"));

    // jhaley 20110408: optometry monthly appointments report
    // TODO/FIXME: Optometry is more and more needing to be a separate department...
    menuReportOptometryAppts->Visible = (optionsPermissions["table.appointments.sc"]["view"] == "true");

    // jhaley 20110113: appt outcome details report for Rhiannon
    menuReportAppointmentOutcomeDetails->Visible = (optionsPermissions["table.appointments"]["view"] == "true");
  }


  // behavioral health
  if (optionsPermissions["report.beh"]["enabled"] == "true")
  {
    if(optionsPermissions["table.people.beh"]["view"] == "true")
    {
      menuReportBehClients->Visible = true;
      menuReportBehConditions->Visible = (optionsPermissions["table.conditions.beh"]["view"] == "true");
      menuReportBehClientEvent->Visible = (optionsPermissions["table.events"]["view"] == "true");
      menuReportBehLocalTreatment->Visible = (optionsPermissions["table.beh_treatment"]["view"] == "true");
      menuReportBehOutsideTreatment->Visible = (optionsPermissions["table.beh_out_treatment"]["view"] == "true");
      menuReportBehClientTasks->Visible = (optionsPermissions["table.tasks.beh"]["view"] == "true");
    }
    if(optionsPermissions["table.tasks.beh"]["view"] == "true")
    {
      menuReportBehActivity->Visible = true;
      menuReportBehEvent->Visible = true;
      menuReportBehMeeting->Visible = true;
      menuReportBehVisit->Visible = true;
      // jhaley 20110407: BEH workload report
      menuReportBehWorkload->Visible = ((optionsPermissions["table.events.beh"]["view"] == "true") &&
                                        (optionsPermissions["table.appointments.beh"]["view"] == "true"));
    }
    menuReportBehPatientList->Visible = (optionsPermissions["table.charts.beh"]["view"] == "true");
    menuReportBehComment->Visible = ((optionsPermissions["table.people.beh"]["view"] == "true") &&
                                     (optionsPermissions["table.person_notes.beh"]["view"] == "true"));
    menuReportBehProgram->Visible = ((optionsPermissions["table.people.beh"]["view"] == "true") &&
                                     (optionsPermissions["table.tasks.beh"]["view"] == "true") &&
                                     (optionsPermissions["table.affiliations"]["view"] == "true"));
  }
  
  // call log
  if(optionsPermissions["report.call_log"]["enabled"] == "true")
  {
    menuReportLog->Visible = true;
    menuReportDeptLog->Visible = true;
    menuReportEmployeeLog->Visible = true;
    menuReportRecepLog->Visible = true;
    menuReportDepartmentTotals->Visible = true;
    menuReportEmployeeTotals->Visible = true;
  }

  // caregiver
  if(optionsPermissions["report.care"]["enabled"] == "true")
  {
    if((optionsPermissions["table.people.care"]["view"] == "true") && (optionsPermissions["table.tasks.care"]["view"] == "true"))
    {
      menuReportCaregiverSummary->Visible = true;
    }
  }

  // community health
  if(optionsPermissions["report.com"]["enabled"] == "true")
  {
    if(optionsPermissions["table.people.com"]["view"] == "true")
    {
      menuReportComClient->Visible = true;
      menuReportComClientComment->Visible = (optionsPermissions["table.person_notes.com"]["view"] == "true");
      menuReportComClientEducation->Visible = (optionsPermissions["table.com_health_edu"]["view"] == "true");
      menuReportComClientEvent->Visible = (optionsPermissions["table.events.com"]["view"] == "true");
      menuReportComClientMetric->Visible = (optionsPermissions["table.obs_response_sets"]["view"] == "true"); // TODO: .com permission only?
      menuReportComClientVisit->Visible = (optionsPermissions["table.tasks.com"]["view"] == "true");
      menuReportComPatientList->Visible = (optionsPermissions["table.charts.com"]["view"] == "true");
    }
    if(optionsPermissions["table.tasks.com"]["view"] == "true")
    {
      menuReportComMonthly->Visible = true;
      menuReportComMonthlyServices->Visible = true;
      menuReportComMonthlyWorkload->Visible = true;
      menuReportComVisitNurse->Visible = true;
    }
  }

  // contract health
  if (optionsPermissions["report.cob"]["enabled"] == "true")
  {
    if (optionsPermissions["report.services"]["enabled"] == "true")
    {
      if((optionsPermissions["table.tasks"            ]["view"] == "true") &&
         (optionsPermissions["table.transactions"     ]["view"] == "true") &&
         (optionsPermissions["table.accounts"         ]["view"] == "true") &&
         (optionsPermissions["table.tax_entities"     ]["view"] == "true") &&
         (optionsPermissions["table.bills"            ]["view"] == "true") &&
         (optionsPermissions["table.purchase_reqs"    ]["view"] == "true") &&
         (optionsPermissions["table.services_provided"]["view"] == "true") &&
         (optionsPermissions["table.checks"           ]["view"] == "true"))
      {
        menuReportContractObligatedAndExpensedReports->Visible = true;
        menuReportContractObligatedPaidServicesRendered->Visible = true;
        menuReportContractObligatedPaidByProvider->Visible = true;
        menuReportContractPaidAmountsByProviderService->Visible = true;
        menuReportContractObligatedPaidByAccounts->Visible = true;
      }
      // jhaley 20110217: refined required permissions for this report to only what can be viewed on it
      menuReportCHSBillingWorkload->Visible = ((optionsPermissions["table.purchase_reqs"]["view"] == "true") &&
                                               (optionsPermissions["table.bills"        ]["view"] == "true") &&
                                               (optionsPermissions["table.tax_entities" ]["view"] == "true") &&
                                               (optionsPermissions["table.transactions" ]["view"] == "true") &&
                                               (optionsPermissions["table.entity_ids"   ]["view"] == "true"));
    }

    menuReportServiceProvided->Visible = ((optionsPermissions["table.tasks.cob"]["view"] == "true") &&
                                          (optionsPermissions["table.bills"]["view"] == "true"));
    if ((optionsPermissions["table.accounts"]["view"] == "true") &&
        (optionsPermissions["table.checks"]["view"] == "true") &&
        (optionsPermissions["table.purchase_reqs"]["view"] == "true") &&
        (optionsPermissions["report.budget"]["enabled"] == "true"))
    {
      menuReportContractBudget->Visible = true;
      menuReportBudgetMods->Visible = true; // TODO: doesn't actually require checks/PR's ?
    }

    if ((optionsPermissions["table.transactions"]["view"] == "true") &&
        (optionsPermissions["table.people.cob"]["view"] == "true") &&
        (optionsPermissions["table.tax_entities"]["view"] == "true") &&
        (optionsPermissions["table.tasks.cob"]["view"] == "true") &&
        (optionsPermissions["table.bills"]["view"] == "true") &&
        (optionsPermissions["table.purchase_reqs"]["view"] == "true") &&
        (optionsPermissions["table.checks"]["view"] == "true"))
    {
      menuReportMontlyObligated->Visible = true;
      menuReportContractChef->Visible = true;
      menuReportProviderSummary->Visible = true;
      if (optionsPermissions["table.tasks"]["view"] == "true")
       menuReportAccountingAging->Visible = true;
    }

    // jhaley 20100929: vendors w/expenses over amount report:
    menuReportContractVendors->Visible = ((optionsPermissions["table.transactions"]["view"] == "true")  &&
                                          (optionsPermissions["table.tax_entities"]["view"] == "true")  &&
                                          (optionsPermissions["table.bills"]["view"] == "true")         &&
                                          (optionsPermissions["table.purchase_reqs"]["view"] == "true") &&
                                          (optionsPermissions["table.checks"]["view"] == "true"));

    menuReportContractPatientList->Visible = (optionsPermissions["table.charts.cob"]["view"] == "true");
    menuReportContractHealthProductivity->Visible = (optionsPermissions["table.tasks.cob"]["view"] == "true");
    menuReportInsuranceStatistics->Visible = ((optionsPermissions["table.insurance_coverage"]["view"] == "true") &&
                                              (optionsPermissions["table.insurance_policies"]["view"] == "true") &&
                                              (optionsPermissions["table.people"]["view"] == "true"));
    menuReportTaxEntityLabels->Visible = ((optionsPermissions["table.tax_entities"]["view"] == "true") &&
                                          (optionsPermissions["table.tax_addresses"]["view"] == "true") &&
                                          (optionsPermissions["table.bills"]["view"] == "true"));
    menuIHSReport->Visible = ((optionsPermissions["table.tasks"]["view"] == "true") &&
                              (optionsPermissions["table.people"]["view"] == "true") &&
                              (optionsPermissions["table.pharmacy_info"]["view"] == "true") &&
                              (optionsPermissions["report.ihs"]["enabled"] == "true"));
    menuIHS_NDW_HL7Export->Visible = (optionsPermissions["admin.beta"]["enabled"] == "true") && menuIHSReport->Visible;

    // jhaley 20101117: ARRA exemption form letter - only requires access to tax_entities data, but also creates CHS
    // mailing tasks (as of 20110714!)
    menuReportARRALetter->Visible = (optionsPermissions["table.tax_entities"]["view"] == "true" &&
                                     optionsPermissions["table.tasks.cob"]["insert"] == "true");

    menuReportUpdateFormLetters->Visible = (optionsPermissions["table.people"]["view"] == "true" &&
                                            optionsPermissions["table.charts"]["view"] == "true" &&
                                            optionsPermissions["table.tasks.cob"]["insert"] == "true");
  }

  // dental
  if (optionsPermissions["report.dental"]["enabled"] == "true")
  {
    menuReportDentalPatientList->Visible = (optionsPermissions["table.charts.den"]["view"] == "true");
    menuReportDentalBillingData->Visible = (optionsPermissions["table.tasks.den"]["view"] == "true" &&
                                            optionsPermissions["table.people"]["view"] == "true" &&
                                            optionsPermissions["table.bills"]["view"] == "true" &&
                                            optionsPermissions["table.procedures"]["view"] == "true" &&
                                            optionsPermissions["table.insurance_coverage"]["view"] == "true" &&
                                            optionsPermissions["table.insurance_policies"]["view"] == "true");
  }

  // diabetes
  if(optionsPermissions["report.diab"]["enabled"] == "true")
  {
    if(optionsPermissions["table.people.diab"]["view"] == "true")
    {
      menuReportDiabClient->Visible = true;
      menuReportDiabClientActivity->Visible = (optionsPermissions["table.activities"]["view"] == "true");
      menuDiabClientEventReport->Visible = (optionsPermissions["table.events.diab"]["view"] == "true" &&
                                            optionsPermissions["table.participations.diab"]["view"] == "true");
      menuReportDiabClientMeasurement->Visible = (optionsPermissions["table.obs_response_sets"]["view"] == "true"); // TODO: not .diab like .com?
      menuReportDiabClientTask->Visible = (optionsPermissions["table.tasks.diab"]["view"] == "true");
      menuReportDiabClientFitnessAttendance->Visible = (optionsPermissions["table.fitness_memberships"]["view"] == "true");
      menuReportDiabClientLogsheets->Visible = (optionsPermissions["table.fitness_memberships"]["view"] == "true");
      menuReportDiabClientLogsheetsPerPerson->Visible = (optionsPermissions["table.fitness_memberships"]["view"] == "true");
      menuReportDiabClientTribal->Visible = (optionsPermissions["table.affiliations"]["view"] == "true");
      menuReportDiabClientComment->Visible = (optionsPermissions["table.person_notes.diab"]["view"] == "true");
      menuReportDiabOverweightReport->Visible = ((optionsPermissions["table.affiliations"]["view"] == "true") &&
                                                (optionsPermissions["table.obs_response_sets"]["view"] == "true")); // TODO: .diab?
      menuReportDiabClientActivitySummary->Visible = (optionsPermissions["table.activities"]["view"] == "true");
      menuReportDiabClientLogsheetSummary->Visible = (optionsPermissions["table.activity_logsheets"]["view"] == "true");
      menuReportDiabStarSession->Visible = (optionsPermissions["table.affiliations"]["view"] == "true");
      if(optionsPermissions["table.diab_education"]["view"] == "true")
      {
        menuReportDiabEducation->Visible = true;
        menuReportDiabAverageScores->Visible = true;
        menuReportDiabScoreSummary->Visible = true;
      }
      if(optionsPermissions["table.fitness_memberships"]["view"] == "true")
      {
        menuReportDiabFitness->Visible = true;
        menuReportDiabClientAttendanceSummary->Visible = true;
        menuReportFitnessMembershipsByFacility->Visible = true;
        menuReportMembershipsSummary->Visible = true;
        menuReportFitnessReleases->Visible = true;
        menuReportFitnessWaitingList->Visible = true;
        menuReportDiabNewMemberships->Visible = true;
      }
      if(optionsPermissions["table.obs_response_sets"]["view"] == "true") // TODO: not .diab?
      {
        menuReporDiabMeasurementLabels->Visible = true;
        menuReportMeasurementCount->Visible = true;
        menuReportDiabClientMeasurementsSummary->Visible = true;
        menuReportDiabMeasurementComparison->Visible = true;
      }
      menuReportDiabParticipation->Visible = (optionsPermissions["table.participations.diab"]["view"] == "true");
    }
    if(optionsPermissions["table.tasks.diab"]["view"] == "true")
    {
      menuReportDiabTask->Visible = true;
      menuReportDiabEmployeeActivity->Visible = true;
      menuReportDiabStaffContacts->Visible = true;
      menuReportDiabMeetings->Visible = true;
      menuReportDiabEmpHours->Visible = true;
      menuReportDiabEmpTask->Visible = true;
      menuReportDiabMileage->Visible = true;
    }
    if(optionsPermissions["table.incentives"]["view"] == "true")
    {
      menuReportDiabIncentive->Visible = true;
      menuReportDiabPendingShoes->Visible = true;
      menuReportDiabShoesOrdered->Visible = true;
      menuReportStepsCheck->Visible = true;
      menuReportDiabCheckCount->Visible = true;
      menuReportIncentive->Visible = true;
    }
    menuReportDiabExport->Visible = true;
    menuReportExportActivity->Visible = ((optionsPermissions["table.people.diab"]["view"] == "true") &&
                                         (optionsPermissions["table.activities"]["view"] == "true"));
    menuReportExportMeasurement->Visible = ((optionsPermissions["table.people.diab"]["view"] == "true") &&
                                            (optionsPermissions["table.obs_response_sets"]["view"] == "true")); // TODO: .diab
    //menuReportDiabGraphs->Visible = true;
    //menuReportDiabTribalGraph->Visible = ((optionsPermissions["table.affiliations"]["view"] == "true") &&
    //                                      (optionsPermissions["table.people.diab"]["view"] == "true"));
    menuReportDiabRegistry->Visible = ((optionsPermissions["table.tasks.diab"]["view"] == "true") &&
                                       (optionsPermissions["table.appointments.people"]["view"] == "true") &&
                                       (optionsPermissions["table.conditions.diab"]["view"] == "true")) ;
    menuReportDiabPeopleNotSeen->Visible = ((optionsPermissions["table.tasks.diab"]["insert"] == "true") &&
                                           (optionsPermissions["table.conditions"]["view"] == "true"));
    menuReportDiabEvent->Visible = (optionsPermissions["table.events.diab"]["view"] == "true") ;
    menuReportDiabActivitiesbyOutcome->Visible = ((optionsPermissions["table.appointments.people"]["view"] == "true") &&
                                                  (optionsPermissions["table.people.diab"]["view"] == "true")) ;
  }

  // forms

  if (optionsPermissions["report.forms.intake"]["enabled"] == "true")
  {
    menuReportFormIntake->Visible = true;
    menuReportFormIntakeMedHist->Visible = true;
    menuReportFormIntakeOpto->Visible = true;
  }
  if (optionsPermissions["report.forms.com"]["enabled"] == "true")
  {
    menuReportFormCom->Visible = true;
    menuReportFormComAdult->Visible = true;
    menuReportFormComDrug->Visible = true;
  }
  if (optionsPermissions["report.forms.steps"]["enabled"] == "true")
  {
    menuReportFormDiab->Visible = true;
    menuReportFormSteps->Visible = true;
    menuReportFormParQ->Visible = true;
    menuReportFormDoctorStatement->Visible = true;
    menuReportFormActivityLog->Visible = true;
    menuReportFormChildAssent->Visible = true;
    menuReportFormReachContract->Visible = true;
    menuReportFormStepsPacket->Visible = true;
  }

  if (optionsPermissions["report.forms.pub"]["enabled"] == "true")
  {
    menuReportFormPublic->Visible = true;
    menuReportFormPubChild->Visible = true;
    menuReportFormPubPrenatal->Visible = true;
    menuReportFormPubNewborn->Visible = true;
    menuReportFormPubPostpartum->Visible = true;
    menuReportFormPubDrug->Visible = true;
  }

  // medical

  if (optionsPermissions["report.lac"]["enabled"] == "true" || optionsPermissions["report.sc"]["enabled"] == "true")
  {
    menuReportMedicalPatientList->Visible = (optionsPermissions["table.charts.lac"]["view"] == "true" ||
                                             optionsPermissions["table.charts.sc"]["view"] == "true");

    // jhaley 20111109: SoonerCare demographics report
    menuReportMedicalSC->Visible = (optionsPermissions["table.people"]["view"] == "true" &&
                                    optionsPermissions["table.person_contact_info"]["view"] == "true" &&
                                    optionsPermissions["table.insurance_coverage"]["view"] == "true" &&
                                    optionsPermissions["table.affiliations"]["view"] == "true");
  }

  // pharmacy

  if(optionsPermissions["admin.upload_pharmacy_data"]["enabled"] == "true")
  {
    menuReportUploadWalMart->Visible = true;
    menuReportUploadEckerd->Visible = true;
    menuReportUploadComputerRx->Visible = true;
  }
  if (optionsPermissions["report.waleck"]["enabled"] == "true")
  {
    menuReportEckerd->Visible = true;
    menuReportWalState->Visible = true;
    menuReportWalSpenders->Visible = true;
    menuReportYearlyPharmacy->Visible = true;
  }

  // public health

  if (optionsPermissions["report.pub"]["enabled"] == "true")
  {
    if (optionsPermissions["table.people.pub"]["view"] == "true")
    {
      menuReportPublicClients->Visible = true;
      menuReportPublicClientVisit->Visible = (optionsPermissions["table.tasks.pub"]["view"] == "true");
      menuReportPublicClientEvents->Visible = (optionsPermissions["table.events.pub"]["view"] == "true");
      menuReportPublicClientsMeasurement->Visible = (optionsPermissions["table.obs_response_sets"]["view"] == "true"); // TODO: .pub
      menuReportPublicClientEdu->Visible = (optionsPermissions["table.com_health_edu"]["view"] == "true");
      menuReportPublicClientComments->Visible = (optionsPermissions["table.person_notes.com"]["view"] == "true");
    }
    menuReportPublicHealthMonthly->Visible = (optionsPermissions["table.tasks.pub"]["view"] == "true");
  }

  // purchasing/supply - jhaley 20120510

  if (optionsPermissions["report.supp"]["enabled"] == "true")
  {
    menuReportPurchasingWorkload->Visible = ((optionsPermissions["table.purchase_reqs"]["view"] == "true") &&
                                             (optionsPermissions["table.bills"        ]["view"] == "true") &&
                                             (optionsPermissions["table.tax_entities" ]["view"] == "true") &&
                                             (optionsPermissions["table.transactions" ]["view"] == "true") &&
                                             (optionsPermissions["table.entity_ids"   ]["view"] == "true"));
  }

  // transportation

  if (optionsPermissions["report.trans"]["enabled"] == "true")
  {
    menuReportTransportationSummary->Visible = (optionsPermissions["table.tasks.trans"]["view"] == "true");
  }

  // other

  menuReportClient->Visible = ((optionsPermissions["report.people"]["enabled"] == "true") &&
                               (optionsPermissions["table.people"]["view"] == "true") &&
                               (optionsPermissions["table.person_contact_info"]["view"] == "true"));
  menuReportCobSummary->Visible = (optionsPermissions["admin.beta"]["enabled"] == "true");
  menuReportDenialLetters->Visible = (optionsPermissions["table.denial_letters"]["view"] == "true");
  menuSpecialEnrollment->Visible = (optionsPermissions["table.enrollment"]["view"] == "true");
  menuReportEventListing->Visible = (optionsPermissions["table.events"]["view"] == "true");   // jhaley 20100811
  menuReportEventsByClient->Visible = (optionsPermissions["table.events"]["view"] == "true"); // jhaley 20100806

  menuReportInsuranceChargeAnalysis->Visible = ((optionsPermissions["table.bills"]["view"] == "true") && // jhaley 20100914
                                                (optionsPermissions["table.insurance_coverage"]["view"] == "true") &&
                                                (optionsPermissions["table.insurance_policies"]["view"] == "true"));

  // jhaley 20110826: Generic mailing labels report
  menuReportMailingLabels->Visible = ((optionsPermissions["table.people"]["view"]              == "true") &&
                                      (optionsPermissions["table.person_contact_info"]["view"] == "true") &&
                                      (optionsPermissions["table.charts"]["view"]              == "true"));

  // jhaley 20110711: procedures by provider report
  menuReportProcsByProvider->Visible = ((optionsPermissions["table.tasks"]["view"]        == "true") &&
                                        (optionsPermissions["table.conditions"]["view"]   == "true") &&
                                        (optionsPermissions["table.procedures"]["view"]   == "true") &&
                                        (optionsPermissions["table.codes"]["view"]        == "true") &&
                                        (optionsPermissions["table.tax_entities"]["view"] == "true"));

  menuReportTaskDemographics->Visible = (optionsPermissions["table.tasks"]["view"] == "true");

  //-------------------------------------------------------------------------------------------
  // Special
  //-------------------------------------------------------------------------------------------

  if (Form->logged_in)
    menuSpecialBugs->Visible = true; // TODO: this one was a bit odd (changed while fixing auto-log-out)

  menuSpecialCallLog->Visible = (optionsPermissions["table.call_log"]["insert"] == "true") ;
  menuSpecialSchedule->Visible = (optionsPermissions["special.schedule"]["enabled"] == "true");
  menuSpecialChat->Visible = (optionsPermissions["special.chat"]["enabled"] == "true");
  menuSpecialTimesheet->Visible = (optionsPermissions["special.timesheet"]["enabled"] == "true") ;
  menuSpecialRequestedCob->Visible = (optionsPermissions["special.handle_cob_requests"]["enabled"] == "true") ;
  menuSpecialGeneralJournal->Visible = (optionsPermissions["special.gen_journal"]["enabled"] == "true");
  // menuSpecialAccountAdjustments->Visible = (optionsPermissions["special.gen_journal"]["enabled"] == "true");
  menuSpecialLedger->Visible = (optionsPermissions["special.ledger"]["enabled"] == "true");
  menuSpecialGeneralJournal->Visible = (optionsPermissions["special.gen_journal"]["enabled"] == "true");
  menuSpecialCloseAccounts->Visible  = ((optionsPermissions["special.close_accounts"]["enabled"] == "true") &&
                                        (optionsPermissions["table.accounts"]["view"] == "true") &&
                                        (optionsPermissions["table.transactions"]["insert"] == "true"));
  menuSpecialNewBudgetEntry->Visible = ((optionsPermissions["special.budget_entry"]["enabled"] == "true") &&
                                        (optionsPermissions["table.accounts"]["view"] == "true") &&
                                        (optionsPermissions["table.transactions"]["insert"] == "true"));

  menuSpecialUpdatesNeeded->Visible = (optionsPermissions["special.updates_needed"]["enabled"] == "true");
  menuSpecialMedicaidAboutToExpire->Visible = (optionsPermissions["special.updates_needed"]["enabled"] == "true");
  menuSpecialLatestInsurance->Visible = (optionsPermissions["special.latest_insurance"]["enabled"] == "true");

  menuSpecialDischargeBehClients->Visible = (optionsPermissions["table.treatment.beh"]["update"] == "true") ;

  if(optionsPermissions["special.referral_tracking"]["enabled"] == "true")
  {
    menuSpecialWaitingReferrals->Visible = (optionsPermissions["table.referrals"]["update"] == "true");
    menuSpecialSentReferrals->Visible = (optionsPermissions["table.referrals"]["insert"] == "true");
  }

  // the only reason i'm putting a group restriction on this is because no other departments have
  // form letters to use with it. i don't want a special permission or anything,
  // i just don't want to clutter people's menus who don't need it
  menuSpecialAppointmentReminders->Visible = ((optionsPermissions["table.appointments"]["view"] == "true") &&
                                             ((optionsPermissions["special.diab.general"]["enabled"] == "true") ||
                                             (optionsPermissions["special.mis.general"]["enabled"] == "true")));
  menuSpecialDiabetesRegistry->Visible = optionsPermissions["special.diab.general"]["enabled"] == "true";
  menuSpecialDiabetesSteps->Visible =    optionsPermissions["special.diab.general"]["enabled"] == "true";
  menuSpecialAttachActivitiesToLogsheets->Visible = ((optionsPermissions["table.activities"]["update"] == "true") &&
                                                     (optionsPermissions["table.activity_logsheets"]["insert"] == "true"));
  menuSpecialInactiveClients->Visible = ((optionsPermissions["table.activities"]["view"] == "true") &&
                                         (optionsPermissions["table.obs_response_sets"]["view"] == "true") &&
                                         (optionsPermissions["table.people.diab"]["update"] == "true"));
  if (optionsPermissions["special.order_shoes"]["enabled"] == "true")
  {
    menuSpecialOrderShoes->Visible = true;
    menuSpecialReceiveShoes->Visible = true;
  }
  menuSpecialDiabWarningLetters->Visible = ((optionsPermissions["table.fitness_memberships"]["update"] == "true") &&
                                           (optionsPermissions["table.tasks.diab"]["insert"] == "true"));
   /*
   // We've decided the bug log is visible by default, haven't we?  Yes we have.
   // but we don't want to do this automatically b/c we want to be able to take it away
   // from Stupid Users (TM) if need be.
   menuSpecialBugs->Visible = ((optionsPermissions["table.bugs"]["insert"] == "true") &&
                              (optionsPermissions["table.bugs"]["view"] == "true") &&
                              (optionsPermissions["table.bugs"]["update"] == "true")) ;
  */
  menuSpecialDataQuery->Visible = (optionsPermissions["special.data_query"]["enabled"] == "true") ;
  menuSpecialDataMerge->Visible = (optionsPermissions["special.data_merge"]["enabled"] == "true") ;
  menuSpecialDataNavigation->Visible = (optionsPermissions["special.data_navigate"]["enabled"] == "true") ;
  menuSpecialDeletePerson->Visible = (optionsPermissions["admin.delete_person"]["enabled"] == "true") ;
  menuSpecialEditLookup->Visible = (optionsPermissions["admin.edit_lookup_tables"]["enabled"] == "true") ;

  // TODO -- inaccurate?
  menuSpecialEditObservationOptionSet->Visible = (optionsPermissions["table.obs_questions"]["update"] == "true");
  menuSpecialEditObservationQuestionSet->Visible = (optionsPermissions["table.obs_questions"]["update"] == "true");
  menuSpecialCachedObservationStatistics->Visible = (optionsPermissions["table.obs_questions"]["update"] == "true");
  menuSpecialEditObservationExpectedRanges->Visible = (optionsPermissions["table.obs_questions"]["view"] == "true");

  if(optionsPermissions["admin.edit_permissions"]["enabled"] == "true")
  {
    menuSpecialEditPermissions->Visible = true;
    menuSpecialFindUsersWithPermissions->Visible = true;
    menuSpecialDiffUserPermissions->Visible = true;
  }
  menuSpecialEditColors->Visible = (optionsPermissions["admin.edit_user_colors"]["enabled"] == "true") ;
  menuSpecialMergePeople->Visible = (optionsPermissions["admin.merge_person"]["enabled"] == "true") ;
  menuSpecialMergeTaxEntities->Visible = (optionsPermissions["admin.merge_tax_entity"]["enabled"] == "true") ;
  menuSpecialRouterAdministration->Visible = (optionsPermissions["admin.router_administration"]["enabled"] == "true");
  menuSpecialUploadVersion->Visible = (optionsPermissions["admin.upload_versions"]["enabled"] == "true") ;
  menuSpecialScreenStatistics->Visible = (optionsPermissions["admin.screen_statistics"]["enabled"] == "true");

  menuSpecialDebug->Visible = (optionsPermissions["admin.component_testing"]["enabled"] == "true");
  menuSpecialDropTempViews->Visible = (optionsPermissions["admin.component_testing"]["enabled"] == "true"); // TODO: temporary

  // wait ... REPORT permissions? wtf?
  menuReportQueryPeople->Visible = (optionsPermissions["report.people"]["enabled"] == "true");
  menuReportQueryVisits->Visible = (optionsPermissions["report.visits"]["enabled"] == "true");
  menuReportQueryObservations->Visible = (optionsPermissions["report.obs_response_sets"]["enabled"] == "true");
  // (optionsPermissions["admin.component_testing"]["enabled"] == "true"); // DONE: temporary

  // TODO: extra specific permission for budgets?
  Form->ShowUsefulFolders(menuFile);
  Form->ShowUsefulFolders(menuSearch);
  Form->ShowUsefulFolders(menuCreate);
  Form->ShowUsefulFolders(menuReport);
  Form->ShowUsefulFolders(menuSpecial);
  Form->ShowUsefulFolders(menuHelp);

  CreatePopupMenu(); // jhaley 20110415
}
//---------------------------------------------------------------------------
// jhaley 20110415: Recursively walks the source menu and adds copies of its items to the destination menu
void TframePrometheusMenu::CreatePopupRecursive(TMenuItem *dst, TMenuItem *src)
{
  TMenuItem *m;
  int i;

  for(i = 0; i < src->Count; i++)
  {
    m = new TMenuItem(this);
    dst->Add(m);
    m->Caption    = src->Items[i]->Caption;
    m->OnClick    = src->Items[i]->OnClick;
    m->Tag        = src->Items[i]->Tag;
    m->ImageIndex = src->Items[i]->ImageIndex;
    m->Visible    = src->Items[i]->Visible;
    if(src->Items[i]->Count > 0)
      CreatePopupRecursive(m, src->Items[i]);
  }
}
//---------------------------------------------------------------------------
// jhaley 20110415: Create a popup menu that is a copy of the main menu.
void TframePrometheusMenu::CreatePopupMenu()
{
  menuPopup->Items->Clear();
  CreatePopupRecursive(menuPopup->Items, menuPrometheusMenu->Items);
}
//---------------------------------------------------------------------------
// Note: When adding new menu items, please cut & paste the created event
// handler into its appropriate section, in the same order as the menu items,
// to keep them in order from now on. This will make for superior organization
// and easier ability to find stuff when something needs to change.
// Keep all non-event-handler code north of this comment.
//---------------------------------------------------------------------------
// **************************************************************************
// *** FILE MENU ************************************************************
// **************************************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCloseAllFormsClick(TObject *Sender)
{
  // jhaley 20110119: This action must be deferred if there are open report forms.
  if (Form->NumReportsOpen() > 0)
  {
    classDeferredMessageQueue *q = Form->menu_msg_queue;
    if (q)
    {
      q->ScheduleMessage(q->CreateMessage("MainMenuListener", "MainMenuListener", "CloseAllForms", "ReportsOpen", 5));
      if (!q->IsLocked())
        q->LockQueue(); // Do not accept any more events while this is pending
    }
  }
  else
    Form->CloseAllForms();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuChangePasswordClick(TObject *Sender)
{
  // TODO: open up a TformRecordUsesomeone'r to modify personal information like password. this way they can't
  //  randomly open it. Note that security on that form could be weird!
  FORM_TRY
    TformSpecialChangePassword *changePasswordScreen = new TformSpecialChangePassword(NULL, false);
    changePasswordScreen->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuResetDefaultsClick(TObject *Sender)
{
  if(Form->PSay("Are you sure you want to reset all settings to defaults?", m_confirmation, MB_YESNO) == 6)
  {
    optionsPreferences.clear();
    Form->PreferencesChanged();
  }
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSettingsClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialSettings *settingsScreen = new TformSpecialSettings(NULL);
    settingsScreen->ShowModal();
  FORM_CATCH
  Form->SavePreferences();
  atlas->Notify("chat.users_not_chatting", current_userid);
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSwitchUsersClick(TObject *Sender)
{
  // jhaley 20110121: Defer action if reports are open
  if (Form->NumReportsOpen() > 0)
  {
    classDeferredMessageQueue *q = Form->menu_msg_queue;
    if (q)
    {
      q->ScheduleMessage(q->CreateMessage("MainMenuListener", "MainMenuListener", "SwitchUsers", "ReportsOpen"));
      if (!q->IsLocked())
        q->LockQueue(); // Do not accept any further events while this is pending
    }
  }
  else
    Form->DoSwitchUsers();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuVersionNotesClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialPrometheusVersionLog *log = new TformSpecialPrometheusVersionLog(NULL);
    log->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuExitClick(TObject *Sender)
{
  Form->Close();
}
//---------------------------------------------------------------------------
// **************************************************************************
// *** SEARCH MENU **********************************************************
// **************************************************************************
//---------------------------------------------------------------------------
// ****** SEARCH->ACCOUNTING ************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchIncomingVendorBillClick(TObject *Sender)
{
  string bill_id = lookupTables->IdOf("bill_types", "incoming vendor bill");
  FORM_TRY
    TformSearchBill *billSearch = new TformSearchBill(NULL, NULL, bill_id);
    billSearch->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchIncomingProviderBillClick(TObject *Sender)
{
  string bill_id = lookupTables->IdOf("bill_types", "incoming provider bill");
  FORM_TRY
    TformSearchBill *billSearch = new TformSearchBill(NULL, NULL, bill_id);
    billSearch->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchOutgoingProviderBillClick(TObject *Sender)
{
  string bill_id = lookupTables->IdOf("bill_types", "outgoing provider bill");
  FORM_TRY
    TformSearchBill *billSearch = new TformSearchBill(NULL, NULL, bill_id);
    billSearch->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchAccountClick(TObject *Sender)
{
  FORM_TRY
    TformSearchAccount *find_acc = new TformSearchAccount(NULL, NULL);
    find_acc->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchCheckClick(TObject *Sender)
{
  FORM_TRY
    TformSearchCheck *check_search = new TformSearchCheck(NULL, NULL);
    check_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchPrClick(TObject *Sender)
{
  FORM_TRY
    TformSearchPurchaseReq *pr_search = new TformSearchPurchaseReq(NULL, NULL);
    pr_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchTransactionClick(TObject *Sender)
{
  FORM_TRY
    TformSearchTransaction *transaction_search = new TformSearchTransaction(NULL, NULL);
    transaction_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SEARCH->ADMINISTRATION ********************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchBugLogClick(TObject *Sender)
{
  FORM_TRY
    TformSearchBugLog *buglog_search = new TformSearchBugLog(NULL, NULL);
    buglog_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchCrashLogClick(TObject *Sender)
{
  FORM_TRY
    TformSearchCrashLog *crash_search = new TformSearchCrashLog(NULL, NULL);
    crash_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchMessageBoxLogClick(TObject *Sender)
{
  FORM_TRY
    TformSearchMessageBoxLog *log_search = new TformSearchMessageBoxLog(NULL, NULL);
    log_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SEARCH->BEHAVIORAL HEALTH *****************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchEventBehClick(TObject *Sender)
{
  FORM_TRY
    TformSearchEvent *eventSearch = new TformSearchEvent(NULL, NULL, lookupTables->IdOf("groups", "Behavioral Health"));
    eventSearch->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchTaskBehClick(TObject *Sender)
{
  FORM_TRY
    TformSearchTaskBeh *formBehTaskSearch = new TformSearchTaskBeh(NULL, NULL);
    formBehTaskSearch->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SEARCH->CALL LOG **************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchCallLogClick(TObject *Sender)
{
  FORM_TRY
    TformSearchCallLog *callSearch = new TformSearchCallLog(NULL, NULL);
    callSearch->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SEARCH->CAREGIVER *************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchEventCareClick(TObject *Sender)
{
  FORM_TRY
    TformSearchEvent *search_event = new TformSearchEvent(NULL, NULL, lookupTables->IdOf("groups", "Caregiver Support Program"));
    search_event->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchTaskCareClick(TObject *Sender)
{
  FORM_TRY
    TformSearchTaskCare *search_task = new TformSearchTaskCare(NULL, NULL);
    search_task->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SEARCH->COMMUNITY HEALTH ******************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchEventComClick(TObject *Sender)
{
  FORM_TRY
    TformSearchEvent *search_event = new TformSearchEvent(NULL, NULL, lookupTables->IdOf("groups", "Community Health"));
    search_event->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchTaskComClick(TObject *Sender)
{
  FORM_TRY
    TformSearchComTask *search_task = new TformSearchComTask(NULL, NULL);
    search_task->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchVisitComClick(TObject *Sender)
{
  FORM_TRY
    TformSearchTaskCom * search = new TformSearchTaskCom(NULL, NULL);
    search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SEARCH->CONTRACT HEALTH *******************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchCobClick(TObject *Sender)
{
  FORM_TRY
    TformSearchTaskCob *cob_search = new TformSearchTaskCob(NULL, NULL);
    cob_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchCobVisitClick(TObject *Sender)
{
  FORM_TRY
    TformSearchTaskCobVisit *cob_visit_search = new TformSearchTaskCobVisit(NULL, NULL);
    cob_visit_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchCHSDeferredCOBClick(TObject *Sender)
{
  TformSearchDeferredCOB *defCOBSearch = NULL;
  FORM_TRY
    defCOBSearch = new TformSearchDeferredCOB(NULL, NULL);
  FORM_CATCH_RETURN("TformSearchDeferredCOB", )
  defCOBSearch->Show();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchReferralClick(TObject *Sender)
{
  /* TODO ? */ ;
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchServiceProvidedClick(TObject *Sender)
{
  FORM_TRY
    TformSearchServiceProvided *service_search = new TformSearchServiceProvided(NULL, NULL);
    service_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SEARCH->DENTAL CLINIC *********************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchEventDenClick(TObject *Sender)
{
  // jhaley 20100811: Added to allow event search for dental clinic group.
  FORM_TRY
    TformSearchEvent *event_search = new TformSearchEvent(NULL, NULL, lookupTables->IdOf("groups", "Dental Clinic"));
    event_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchTaskDenClick(TObject *Sender)
{
  FORM_TRY
    TformSearchTaskLac *visit_search = new TformSearchTaskLac(NULL, NULL);
    visit_search->cboClinic->Text = "Dental Clinic"; // TODO -c ENCAPSULATION : should probably call a method of TformSearchTaskLac
    visit_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SEARCH->DIABETES **************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchActivityClick(TObject *Sender)
{
  FORM_TRY
    TformSearchActivity *activity_search = new TformSearchActivity(NULL, NULL);
    activity_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchDiabEducationClick(TObject *Sender)
{
  FORM_TRY
    TformSearchDiabEducation *education_search = new TformSearchDiabEducation(NULL, NULL, "");
    education_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchEventDiabClick(TObject *Sender)
{
  FORM_TRY
    TformSearchEvent *event_search = new TformSearchEvent(NULL, NULL, lookupTables->IdOf("groups", "Diabetes"));
    event_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchFitnessMembershipClick(TObject *Sender)
{
  FORM_TRY
    TformSearchFitnessMembership *membership_search = new TformSearchFitnessMembership(NULL, NULL);
    membership_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchDiabLogsheetClick(TObject *Sender)
{
  FORM_TRY
    TformSearchLogsheet *logsheet_search = new TformSearchLogsheet(NULL, NULL);
    logsheet_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchDiabSurveyClick(TObject *Sender)
{
  FORM_TRY
    TformSearchSurvey *survey_search = new TformSearchSurvey(NULL, NULL, lookupTables->IdOf("groups", "Diabetes"));
    survey_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchTaskDiabClick(TObject *Sender)
{
  FORM_TRY
    TformSearchTaskDiab *task_search = new TformSearchTaskDiab(NULL, NULL);
    task_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SEARCH->MEDICAL CLINIC ********************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchMedicalCodeClick(TObject *Sender)
{
  FORM_TRY
    TformSearchCode *code_search = new TformSearchCode(NULL, NULL);
    code_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchEventMedicalClick(TObject *Sender)
{
  // jhaley 20100810: Added to allow event search for medical clinic groups.
  TformSearchEvent::DoMedical(Form);
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchMedicalFeeScheduleClick(TObject *Sender)
{
  FORM_TRY
    TformSearchFeeSchedule *search_fee_schedule = new TformSearchFeeSchedule(NULL, NULL);
    search_fee_schedule->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchMedicalVisitClick(TObject *Sender)
{
  FORM_TRY
    TformSearchTaskLac *visit_search = new TformSearchTaskLac(NULL, NULL);
    visit_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SEARCH->PUBLIC HEALTH *********************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchEventPubClick(TObject *Sender)
{
  FORM_TRY
    TformSearchEvent *search_event = new TformSearchEvent(NULL, NULL, lookupTables->IdOf("groups", "Public Health"));
    search_event->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchTaskPubClick(TObject *Sender)
{
  FORM_TRY
    TformSearchPubTask *search_task = new TformSearchPubTask(NULL, NULL);
    search_task->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchVisitPubClick(TObject *Sender)
{
  FORM_TRY
    TformSearchTaskPub *task_search = new TformSearchTaskPub(NULL, NULL);
    task_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SEARCH->TRANSPORTATION ********************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchTaskTransClick(TObject *Sender)
{
  FORM_TRY
    TformSearchTaskTrans *task_search = new TformSearchTaskTrans(NULL, NULL);
    task_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SEARCH MISC *******************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchAppointmentClick(TObject *Sender)
{
  FORM_TRY
    TformSearchAppointment *appt_search = new TformSearchAppointment(NULL, NULL);
    appt_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchDenialClick(TObject *Sender)
{
  TformSearchDenial *denial_search;
  FORM_TRY
    denial_search = new TformSearchDenial(NULL, NULL);
  FORM_CATCH_RETURN("TformSearchDenial", )
  denial_search->Show();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchDenialLetterClick(TObject *Sender)
{
  FORM_TRY
    TformSearchDenialLetter *letter_search = new TformSearchDenialLetter(NULL, NULL);
    letter_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// jhaley 20110512: Allow searching the FDA drug database from the main menu
void __fastcall TframePrometheusMenu::menuSearchFDADrugsClick(TObject *Sender)
{
  FORM_TRY
    TformSearchFDADrug *drugSearch = new TformSearchFDADrug(NULL, NULL);
    drugSearch->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchInsuranceApplicationClick(TObject *Sender)
{
  FORM_TRY
    TformSearchInsuranceApplication *ins_app = new TformSearchInsuranceApplication(NULL, NULL);
    ins_app->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchInsurancePolicyClick(TObject *Sender)
{
  FORM_TRY
    TformSearchInsurancePolicy *policy_search = new TformSearchInsurancePolicy(NULL, NULL);
    policy_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchObsResponseSetClick(TObject *Sender)
{
  TformSearchObsResponseSet::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchPersonClick(TObject *Sender)
{
  FORM_TRY
    TformSearchPerson *person_search = new TformSearchPerson(NULL, NULL);
    person_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSearchTaxEntityClick(TObject *Sender)
{
  FORM_TRY
    TformSearchTaxEntity *entity_search = new TformSearchTaxEntity(NULL, NULL);
    entity_search->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// **************************************************************************
// *** CREATE MENU **********************************************************
// **************************************************************************
//---------------------------------------------------------------------------
// ****** CREATE->ACCOUNTING ************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateAccountClick(TObject *Sender)
{
  FORM_TRY
    TformWizardNewAccount *wiz = new TformWizardNewAccount(NULL);
    wiz->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateBudgetModClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialNewBudgetMod *mod_wizard = new TformSpecialNewBudgetMod(NULL);
    mod_wizard->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateCheckClick(TObject *Sender)
{
  FORM_TRY
    TformWizardNewCheck *wiz = new TformWizardNewCheck(NULL);
    wiz->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateContractHealthBillClick(TObject *Sender)
{
  FORM_TRY
    TformWizardNewContractHealthItem *wiz = new TformWizardNewContractHealthItem(NULL, true);
    wiz->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreatePRClick(TObject *Sender)
{
  FORM_TRY
    TformWizardNewPurchaseRequest * wiz = new TformWizardNewPurchaseRequest(NULL);
    wiz->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateVendorBillClick(TObject *Sender)
{
  FORM_TRY
    TformWizardNewVendorBill *wiz = new TformWizardNewVendorBill(NULL);
    wiz->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** CREATE->BEHAVIORAL HEALTH *****************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateEventBehClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Behavioral Health");
  FORM_TRY
    TformRecordEvent *event_record = new TformRecordEvent(NULL, temp_map);
    event_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateTaskBehClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Behavioral Health");
  FORM_TRY
    TformRecordTaskBeh *task_record = new TformRecordTaskBeh(NULL, temp_map);
    task_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** CREATE->CAREGIVER *************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateEventCareClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Caregiver Support Program");
  FORM_TRY
    TformRecordEvent *event_record = new TformRecordEvent(NULL, temp_map);
    event_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateTaskCareClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Caregiver Support Program");
  FORM_TRY
    TformRecordTaskCare *caregiver_task = new TformRecordTaskCare(NULL, temp_map);
    caregiver_task->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** CREATE->COMMUNITY HEALTH ******************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateComAdultVisitClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["com_dept_id"] = lookupTables->IdOf("com_dept_types", "adult");
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  FORM_TRY
    TformRecordComVisit *task_record = new TformRecordComVisit(NULL, temp_map);
    task_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateComDrugRegimenClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  FORM_TRY
    TformRecordComDrug *add_drugs = new TformRecordComDrug(NULL, temp_map);
    add_drugs->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateEventComClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  FORM_TRY
    TformRecordEvent *event_record = new TformRecordEvent(NULL, temp_map);
    event_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateTaskComClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  FORM_TRY
    TformRecordTaskCom *task_record = new TformRecordTaskCom(NULL, temp_map);
    task_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** CREATE->CONTRACT HEALTH *******************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateContractHealthCOBClick(TObject *Sender)
{
  FORM_TRY
    TformWizardNewContractHealthItem *wiz = new TformWizardNewContractHealthItem(NULL, false);
    wiz->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateCHSDeferredCOBClick(TObject *Sender)
{
  pmapstrs temp_map;
  temp_map["id"] = "new";
  TformRecordDeferredCOB *deferredCOB = NULL;
  FORM_TRY
    deferredCOB = new TformRecordDeferredCOB(NULL, temp_map);
  FORM_CATCH_RETURN("TformRecordDeferredCOB", )
  deferredCOB->Show();
}
//---------------------------------------------------------------------------
// ****** CREATE->DENTAL CLINIC *********************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateDentalClinicVisitClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  FORM_TRY
    TformRecordTaskDen *den_visit = new TformRecordTaskDen(NULL, temp_map);
    den_visit->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** CREATE->DIABETES **************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateDiabetesClientVisitClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["user_id"] = current_userid;
  temp_map["date_of_task"] = CurrentDate();
  temp_map["time_spent"] = "0.5";
  temp_map["method_id"] = lookupTables->IdOf("method_types", "Visit");
  temp_map["diab_contact_id"] = lookupTables->IdOf("diab_contact_types", "Contact");
  temp_map["classification_id"] = lookupTables->IdOf("classification_types", "Client");
  temp_map["group_id"] = lookupTables->IdOf("groups", "Diabetes");
  FORM_TRY
    TformRecordTaskDiab *diabetes_task = new TformRecordTaskDiab(NULL, temp_map);
    diabetes_task->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateEventDiabClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Diabetes");
  FORM_TRY
    TformRecordEvent *event_record = new TformRecordEvent(NULL, temp_map);
    event_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateFitnessMembershipClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  FORM_TRY
    TformRecordFitnessMembership *fitness_record = new TformRecordFitnessMembership(NULL, temp_map);
    fitness_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateDiabLogsheetClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  FORM_TRY
    TformRecordLogsheet *logsheet_record = new TformRecordLogsheet(NULL, temp_map);
    logsheet_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateDiabetesMailoutClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["user_id"] = current_userid;
  temp_map["date_of_task"] = CurrentDate();
  temp_map["method_id"] = lookupTables->IdOf("method_types", "Mail");
  temp_map["diab_contact_id"] = lookupTables->IdOf("diab_contact_types", "Contact");
  temp_map["direction_id"] = lookupTables->IdOf("direction_types", "Outgoing");
  temp_map["classification_id"] = lookupTables->IdOf("classification_types", "Client");
  temp_map["group_id"] = lookupTables->IdOf("groups", "Diabetes");
  FORM_TRY
    TformRecordTaskDiab *diabetes_task = new TformRecordTaskDiab(NULL, temp_map);
    diabetes_task->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateDiabetesPhoneCallClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["user_id"] = current_userid;
  temp_map["date_of_task"] = CurrentDate();
  temp_map["time_spent"] = "0.08";
  temp_map["method_id"] = lookupTables->IdOf("method_types", "Phone");
  temp_map["diab_contact_id"] = lookupTables->IdOf("diab_contact_types", "Contact");
  temp_map["classification_id"] = lookupTables->IdOf("classification_types", "Client");
  temp_map["group_id"] = lookupTables->IdOf("groups", "Diabetes");
  FORM_TRY
    TformRecordTaskDiab *diabetes_task = new TformRecordTaskDiab(NULL, temp_map);
    diabetes_task->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateDiabSurveyClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Diabetes");
  FORM_TRY
    TformRecordSurvey *new_survey = new TformRecordSurvey(NULL, temp_map);
    new_survey->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateTaskDiabClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Diabetes");
  FORM_TRY
    TformRecordTaskDiab *diabetes_task = new TformRecordTaskDiab(NULL, temp_map);
    diabetes_task->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** CREATE->MEDICAL CLINIC ********************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateMedicalEventClick(TObject *Sender)
{
  pmapstrs temp_map;
  temp_map["id"] = "new";

  // jhaley 20110822: Now allows SC or LAC dynamically
  TformRecordEvent::DoCreateMedical(Form, NULL, temp_map);
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateMedicalVisitClick(TObject *Sender)
{
  Form->PSay("Please create visits by opening the appointment form and clicking\non the Task/Visit link.", m_reminder, MB_OK);
}
//---------------------------------------------------------------------------
// ****** CREATE->PUBLIC HEALTH *********************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreatePubAdultVisitClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] =  "new";
  temp_map["com_dept_id"] = lookupTables->IdOf("com_dept_types", "adult");
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  FORM_TRY
    TformRecordComVisit *task_record = new TformRecordComVisit(NULL, temp_map);
    task_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateChildVisitClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["com_dept_id"] = lookupTables->IdOf("com_dept_types", "child");
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  FORM_TRY
    TformRecordComVisit *task_record = new TformRecordComVisit(NULL, temp_map);
    task_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateNewbornVisitClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] =  "new";
  temp_map["com_dept_id"] = lookupTables->IdOf("com_dept_types", "newborn");
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  FORM_TRY
    TformRecordComVisit *task_record = new TformRecordComVisit(NULL, temp_map);
    task_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreatePostpartumVisitClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["com_dept_id"] = lookupTables->IdOf("com_dept_types", "postpartum");
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  FORM_TRY
    TformRecordComVisit *task_record = new TformRecordComVisit(NULL, temp_map);
    task_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreatePrenatalVisitClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["com_dept_id"] = lookupTables->IdOf("com_dept_types", "prenatal");
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  FORM_TRY
    TformRecordComVisit * task_record = new TformRecordComVisit(NULL, temp_map);
    task_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreatePublicDrugClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  FORM_TRY
    TformRecordComDrug *add_drugs = new TformRecordComDrug(NULL, temp_map);
    add_drugs->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreatePublicEventClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  FORM_TRY
    TformRecordEvent *event_record = new TformRecordEvent(NULL, temp_map);
    event_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreatePublicTaskClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] =  "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  FORM_TRY
    TformRecordTaskCom *task_record = new TformRecordTaskCom(NULL, temp_map);
    task_record->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** CREATE->TRANSPORTATION ********************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateTaskTransClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  FORM_TRY
    TformRecordTaskTrans *trans_task = new TformRecordTaskTrans(NULL, temp_map);
    trans_task->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateTasksTransClick(TObject *Sender)
{
  TformSpecialNewTransportationTasks::Do();
}
//---------------------------------------------------------------------------
// ****** CREATE MISC *******************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateCobRequestClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  FORM_TRY
    TformRecordCobRequest *cob_request = new TformRecordCobRequest(NULL, temp_map);
    cob_request->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateInterofficeReferralClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialNewInterofficeReferral *new_referral = new TformSpecialNewInterofficeReferral(NULL);
    new_referral->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreatePersonClick(TObject *Sender)
{
  TformWizardNewPerson::Do();
}
//---------------------------------------------------------------------------
// jhaley 20111114: New Referral Wizard
void __fastcall TframePrometheusMenu::menuCreateReferralWizardClick(TObject *Sender)
{
  TformWizardNewReferral::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuCreateTaxEntityClick(TObject *Sender)
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  FORM_TRY
    TformRecordTaxEntity *new_provider = new TformRecordTaxEntity(NULL, temp_map);
    new_provider->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// **************************************************************************
// *** REPORT MENU **********************************************************
// **************************************************************************
//---------------------------------------------------------------------------
// ****** REPORT->ACCOUNTING ************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportAccountingAgingClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchPendingAccountsReport *rep = new TformLaunchPendingAccountsReport(NULL);
    rep->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportContractBudgetClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchBudgetReport *budget_report = new TformLaunchBudgetReport(NULL);
    budget_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportBudgetModsClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchBudgetModsReport *budget_mods_report = new TformLaunchBudgetModsReport(NULL);
    budget_mods_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORT->ADMINISTRATION ********************************************
//---------------------------------------------------------------------------
// ********* REPORT->ADMINISTRATION->LOG LOG ********************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportLogTotalsPerUserClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchLogTotalsPerUser *report = new TformLaunchLogTotalsPerUser(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportLogDetailPerUserClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchLogPerUser *report = new TformLaunchLogPerUser(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportLogAveragesAllUsersClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchLogInAveragesAllUsers *report = new TformLaunchLogInAveragesAllUsers(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportLogTotalsAllUsersClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchLogSummary *report = new TformLaunchLogSummary(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportLogDetailAllUsersClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchLogDetailAllUsers *report = new TformLaunchLogDetailAllUsers(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ********* REPORT->ADMINISTRATION->USAGE LOG ******************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportUsageLogSummaryPerUserClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchUsageLogPerUser *report = new TformLaunchUsageLogPerUser(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportUsageLogSummaryPerUserByDateClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchUsageLogPerUserByDate *report = new TformLaunchUsageLogPerUserByDate(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportUsageLogSummaryAllUsersClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchUsageLogSummary *report = new TformLaunchUsageLogSummary(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportUsageLogSummaryAllUsersByDateClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchUsageLogSummaryByDate *report = new TformLaunchUsageLogSummaryByDate(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportUsageLogPerFormClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchUsagePerFormReport *usage_log_report = new TformLaunchUsagePerFormReport(NULL);
    usage_log_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORT->ADMINISTRATION MISC ***************************************
//----------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportAdminContactsPerDepartmentClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDepartmentContactsReport *contact_report = new TformLaunchDepartmentContactsReport(NULL);
    contact_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportAdminDollarsProceduresClick(TObject *Sender)
{
  // jhaley 20100827: Added for new Dollars Assoc. with Procedures report
  FORM_TRY
    TformLaunchDollarsWithProceduresReport *dollars_report = new TformLaunchDollarsWithProceduresReport(NULL);
    dollars_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportAdminPatientLoadByDepartmentClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchPatientLoadByDepartmentReport *patient_load_report = new TformLaunchPatientLoadByDepartmentReport(NULL);
    patient_load_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportAdminProceduresWithoutChargesClick(TObject *Sender)
{
  // jhaley 20100927: Added for new Procedures W/O Charges report
  FORM_TRY
    TformLaunchProceduresWithoutChargesReport *procedures_report = new TformLaunchProceduresWithoutChargesReport(NULL);
    procedures_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORT->APPOINTMENTS **********************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportAppointmentClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchAppointmentReport *appt_report = new TformLaunchAppointmentReport(NULL);
    appt_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportReminderLettersClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabReminderLettersReport *launch_form = new TformLaunchDiabReminderLettersReport(NULL);
    launch_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDMClientAppointmentsClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabApptReport *launch_form = new TformLaunchDiabApptReport(NULL);
    launch_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuInsuranceByAppointmentReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchInsuranceByAppointmentReport *rep = new TformLaunchInsuranceByAppointmentReport(NULL);
    rep->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportOptometryApptsClick(TObject *Sender)
{
  // jhaley 20110408: Launch optometry monthly appointments report
  FORM_TRY
    TformLaunchOptometryAppointments *launch_opto = new TformLaunchOptometryAppointments(NULL);
    launch_opto->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportAppointmentOutcomeDetailsClick(TObject *Sender)
{
  // jhaley 20110113: Launch appointment outcome details report
  FORM_TRY
    TformLaunchApptOutcomeDetailReport *launch_appt = new TformLaunchApptOutcomeDetailReport(NULL);
    launch_appt->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORTS->BEHAVIORAL HEALTH ****************************************
//---------------------------------------------------------------------------
// ********* REPORTS->BEHAVIORAL HEALTH->CLIENTS ****************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportBehConditionsClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchBehConditionReport *condition_report = new TformLaunchBehConditionReport(NULL, "");
    condition_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportBehClientEventClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchEventByClientReport *event_report = new TformLaunchEventByClientReport(NULL, "", lookupTables->IdOf("groups", "Behavioral Health"));
    event_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportBehLocalTreatmentClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchBehLocalTreatmentReport *local_treatment_report = new TformLaunchBehLocalTreatmentReport(NULL, "");
    local_treatment_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportBehOutsideTreatmentClick(TObject *Sender)
{
  FORM_TRY
    TfromLaunchBehOutsideTreatmentReport *outside_treatment_report = new TfromLaunchBehOutsideTreatmentReport(NULL, "");
    outside_treatment_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportBehPatientListClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchClinicPatientListReport *patient_list = new TformLaunchClinicPatientListReport(NULL, lookupTables->IdOf("groups", "Behavioral Health"));
    patient_list->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuBehReferralsReportClick(TObject *Sender)
{
  /* TODO? */;
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportBehClientTasksClick(TObject *Sender)
{
  FORM_TRY
    TfromLaunchBehTaskReport *task_report = new TfromLaunchBehTaskReport(NULL, "");
    task_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORTS->BEHAVIORAL HEALTH MISC ***********************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportBehActivityClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchBehActivityReport *activity_report = new TformLaunchBehActivityReport(NULL);
    activity_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportBehCommentClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabCommentReport *report = new TformLaunchDiabCommentReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportBehEventClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchEventListingReport *event_report = new TformLaunchEventListingReport(NULL, lookupTables->IdOf("groups", "Behavioral Health"));
    event_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportBehMeetingClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchBehMeetingReport *meeting_report = new TformLaunchBehMeetingReport(NULL);
    meeting_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportBehProgramClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchBehProgramReport *program_report = new TformLaunchBehProgramReport(NULL);
    program_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportBehVisitClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchBehVisitReports *visit_report = new TformLaunchBehVisitReports(NULL);
    visit_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportBehWorkloadClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchBehWorkloadReport *wl_report = new TformLaunchBehWorkloadReport(NULL);
    wl_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORT->CALL LOG **************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportLogClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchCallLogReport *log_report = new TformLaunchCallLogReport(NULL);
    log_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDeptLogClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDepartmentCallLogReport *report = new TformLaunchDepartmentCallLogReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportEmployeeLogClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchEmployeeLogReport *employee_log_report = new TformLaunchEmployeeLogReport(NULL);
    employee_log_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportRecepLogClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchReceptionistLogReport *receptionist_log_report = new TformLaunchReceptionistLogReport(NULL);
    receptionist_log_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDepartmentTotalsClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDepartmentCallTotalsReport *report = new TformLaunchDepartmentCallTotalsReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportEmployeeTotalsClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchEmployeeCallTotalsReport *employee_totals_report = new TformLaunchEmployeeCallTotalsReport(NULL);
    employee_totals_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORT->CAREGIVER *************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportCaregiverSummaryClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchCareSummary *caregiver_summary_report = new TformLaunchCareSummary(NULL);
    caregiver_summary_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORT->COMMUNITY HEALTH ******************************************
//---------------------------------------------------------------------------
// ********* REPORT->COMMUNITY HEALTH->CLIENT *******************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportComClientCommentClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchComCommentReport *comment_report = new TformLaunchComCommentReport(NULL, "");
    comment_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportComClientEducationClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchComEducation *education_report = new TformLaunchComEducation(NULL, "");
    education_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportComClientEventClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchEventByClientReport *event_report = new TformLaunchEventByClientReport(NULL, "", lookupTables->IdOf("groups", "Community Health"));
    event_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportComClientMetricClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchComMeasurementReport *measurement_report = new TformLaunchComMeasurementReport(NULL, "");
    measurement_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportComClientVisitClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchComPersonVisitReport *visit_report = new TformLaunchComPersonVisitReport(NULL, "");
    visit_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ********* REPORT->COMMUNITY HEALTH->MONTHLY ******************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportComMonthlyServicesClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchComServicesReport *services_report = new TformLaunchComServicesReport(NULL);
    services_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportComMonthlyWorkloadClick(TObject *Sender)
{
  FORM_TRY
    TformComWorkloadReport *workload_report = new TformComWorkloadReport(NULL);
    workload_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORT->COMMUNITY HEALTH MISC *************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportComVisitNurseClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchComVisitReport *nurse_report = new TformLaunchComVisitReport(NULL, "");
    nurse_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportComPatientListClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchClinicPatientListReport *patient_list = new TformLaunchClinicPatientListReport(NULL, lookupTables->IdOf("groups", "Community Health"));
    patient_list->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORT->CONTRACT HEALTH *******************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportContractObligatedAndExpensedReportsClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchObligatedAndExpensedReports *ob_and_pd = new TformLaunchObligatedAndExpensedReports(NULL);
    ob_and_pd->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportContractObligatedPaidServicesRenderedClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchObligatesServiceReport *report = new TformLaunchObligatesServiceReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportContractObligatedPaidByProviderClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchObligatedProviderReport *provider_report = new TformLaunchObligatedProviderReport(NULL);
    provider_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportContractObligatedPaidByAccountsClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchObligatedAmountsReport *ob_and_pd_by_account_report = new TformLaunchObligatedAmountsReport(NULL);
    ob_and_pd_by_account_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportContractPaidAmountsByProviderServiceClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchAmountsByProviderService *amounts_by_provider_service_report = new TformLaunchAmountsByProviderService(NULL);
    amounts_by_provider_service_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportServiceProvidedClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchServiceProvidedReport *service_report = new TformLaunchServiceProvidedReport(NULL);
    service_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportContractChefClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchChefReport *chef_report = new TformLaunchChefReport(NULL);
    chef_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportContractHealthProductivityClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchCobProductivityReport *productivity_report = new TformLaunchCobProductivityReport(NULL);
    productivity_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportMontlyObligatedClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchMontlyObligatedReport *ob_report = new TformLaunchMontlyObligatedReport(NULL);
    ob_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportContractPatientListClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchClinicPatientListReport *patient_list = new TformLaunchClinicPatientListReport(NULL, lookupTables->IdOf("groups", "Contract Health"));
    patient_list->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportProviderSummaryClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchProviderSummaryReport *provider_report = new TformLaunchProviderSummaryReport(NULL);
    provider_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportCHSBillingWorkloadClick(TObject *Sender)
{
  string group_id = lookupTables->IdOf("groups", "Third Party Billing"); // jhaley 20120510: run as always
  TformLaunchCHSBillingWorkloadReport *chs_billing_workload = NULL;

  FORM_TRY
    chs_billing_workload = new TformLaunchCHSBillingWorkloadReport(NULL, group_id);
  FORM_CATCH_RETURN("TformLaunchCHSBillingWorkloadReport", )

  chs_billing_workload->Show();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportContractVendorsClick(TObject *Sender)
{
  // jhaley 20100929: Added for new Vendors with Expenses Over Amount report
  FORM_TRY
    TformLaunchVendorBillsOverAmountReport *vendor_report = new TformLaunchVendorBillsOverAmountReport(NULL);
    vendor_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportARRALetterClick(TObject *Sender)
{
  // jhaley 20101117: Launch CHS's ARRA exemption form letter (for convenience; also available from COB record screen)
  FORM_TRY
    TformLaunchARRAExemptionForm *launchARRA = new TformLaunchARRAExemptionForm(NULL, "", ""); // blank IDs
    launchARRA->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportInsuranceStatisticsClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchInsuranceStatisticsReport *insurance_report = new TformLaunchInsuranceStatisticsReport(NULL);
    insurance_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportTaxEntityLabelsClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchProviderLabels *mailing_labels = new TformLaunchProviderLabels(NULL);
    mailing_labels->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportUpdateFormLettersClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchFormLetter *form_letter = new TformLaunchFormLetter(NULL, "");
    form_letter->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuIHSReportClick(TObject *Sender)
{
  // IHS report for dan cameron
  FORM_TRY
    TformLaunchIHSReport *bob = new TformLaunchIHSReport(NULL);
    bob->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuIHS_NDW_HL7ExportClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialExportHL7ForIHS *exp = new TformSpecialExportHL7ForIHS(NULL);
    exp->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORT->DENTAL CLINIC *********************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDentalApptScheduleClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDentalApptReport *den_appt_report = new TformLaunchDentalApptReport(NULL);
    den_appt_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDentalBillingDataClick(TObject *Sender)
{
  // jhaley 20100825: Added for new Dental Billing Data report
  FORM_TRY
    TformLaunchDentalBillingDataReport *billing_report = new TformLaunchDentalBillingDataReport(NULL);
    billing_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDentalPatientListClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchClinicPatientListReport *patient_list = new TformLaunchClinicPatientListReport(NULL, lookupTables->IdOf("groups", "Dental Clinic"));
    patient_list->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORT->DIABETES **************************************************
//---------------------------------------------------------------------------
// ********* REPORT->DIABETES->CLIENTS **************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabClientActivityClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabActivityReport *activity_report = new TformLaunchDiabActivityReport(NULL, "");
    activity_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuDiabClientEventReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchEventByClientReport *event_report = new TformLaunchEventByClientReport(NULL, "", lookupTables->IdOf("groups", "Diabetes"));
    event_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabClientFitnessAttendanceClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabAttendaceReport *attendance_report = new TformLaunchDiabAttendaceReport(NULL, "");
    attendance_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabClientLogsheetsClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabLogsheetReport *logsheet_report = new TformLaunchDiabLogsheetReport(NULL, "");
    logsheet_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabClientLogsheetsPerPersonClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchLogsheetsForDateRangePerPerson *report = new TformLaunchLogsheetsForDateRangePerPerson(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabClientMeasurementClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabMeasurementReport *measurement_report = new TformLaunchDiabMeasurementReport(NULL, "");
    measurement_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabClientTaskClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabTaskReport *task_report = new TformLaunchDiabTaskReport(NULL, "");
    task_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabClientActivitySummaryClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabActivitySummaryReport *report = new TformLaunchDiabActivitySummaryReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabActivitiesbyOutcomeClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabActivitiesByOutcome *activities_form = new TformLaunchDiabActivitiesByOutcome(NULL);
    activities_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabClientCommentClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabCommentReport *report = new TformLaunchDiabCommentReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabClientLogsheetSummaryClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabLogsheetSummaryReport *report = new TformLaunchDiabLogsheetSummaryReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabMeasurementComparisonClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabMeasurementComparisonReport *diab_report = new TformLaunchDiabMeasurementComparisonReport(NULL);
    diab_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReporDiabMeasurementLabelsClick(TObject *Sender)
{
  TformLaunchDiabMeasurementLabels::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportMeasurementCountClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabMeasurementCountReport *meas_count_report = new TformLaunchDiabMeasurementCountReport(NULL);
    meas_count_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabClientMeasurementsSummaryClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabMeasureSummaryReport *report = new TformLaunchDiabMeasureSummaryReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabOverweightReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabOverweightReport *overweight_report = new TformLaunchDiabOverweightReport(NULL);
    overweight_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabParticipationClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabParticipationReport *part_report = new TformLaunchDiabParticipationReport(NULL);
    part_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabStarSessionClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabStarSessionReport *rep = new TformLaunchDiabStarSessionReport(NULL);
    rep->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabClientTribalClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabTribalReport *report = new TformLaunchDiabTribalReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ********* REPORT->DIABETES->EDUCATION ************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabAverageScoresClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabAvgScoresPerTopicReport *report = new TformLaunchDiabAvgScoresPerTopicReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabScoreSummaryClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabScoreSummaryReport *report = new TformLaunchDiabScoreSummaryReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ********* REPORT->DIABETES->EXPORT ***************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportExportActivityClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialExportActivityReport *report = new TformSpecialExportActivityReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportExportMeasurementClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialExportMeasurementReport *report = new TformSpecialExportMeasurementReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ********* REPORT->DIABETES->FITNESS **************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabClientAttendanceSummaryClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchFitnessAttendanceReport *report = new TformLaunchFitnessAttendanceReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFitnessMembershipsByFacilityClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchFitnessMembershipSummaryReport *report = new TformLaunchFitnessMembershipSummaryReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportMembershipsSummaryClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchFitnessMembershipReport *report = new TformLaunchFitnessMembershipReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFitnessReleasesClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchFitnessReleaseReport *report = new TformLaunchFitnessReleaseReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFitnessWaitingListClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchFitnessWaitingListReport *waiting_report = new TformLaunchFitnessWaitingListReport(NULL);
    waiting_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabNewMembershipsClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabNewMembershipLetters *new_letters = new TformLaunchDiabNewMembershipLetters(NULL);
    new_letters->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ********* REPORT->DIABETES->GRAPHS ***************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabTribalGraphClick(TObject *Sender)
{
  /* TODO? */ ;
}
//---------------------------------------------------------------------------
// ********* REPORT->DIABETES->INCENTIVES ***********************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabCheckCountClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabCheckCountReport *check_report = new TformLaunchDiabCheckCountReport(NULL);
    check_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportIncentiveClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchIncentiveReport *incentive_report = new TformLaunchIncentiveReport(NULL);
    incentive_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabPendingShoesClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchPendingShoeReport *pending_report = new TformLaunchPendingShoeReport(NULL);
    pending_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabShoesOrderedClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchShoesOrderedReport *shoe_report = new TformLaunchShoesOrderedReport(NULL);
    shoe_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportStepsCheckClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchStepsCheckReport *check_report = new TformLaunchStepsCheckReport(NULL);
    check_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ********* REPORT->DIABETES->TASKS ****************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabEmpHoursClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabHoursReport *report = new TformLaunchDiabHoursReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabMeetingsClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabMeetingReport *report = new TformLaunchDiabMeetingReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabMileageClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabMileageReport *report = new TformLaunchDiabMileageReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabEmployeeActivityClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabStaffActivityReport * report = new TformLaunchDiabStaffActivityReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabStaffContactsClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabContactReport *contact_report = new TformLaunchDiabContactReport(NULL);
    contact_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabEmpTaskClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabEmployeeTaskReport *report = new TformLaunchDiabEmployeeTaskReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORT->DIABETES MISC
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabRegistryClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabRegistryReport *diab_registry = new TformLaunchDiabRegistryReport(NULL);
    diab_registry->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabEventClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchEventListingReport *report = new TformLaunchEventListingReport(NULL, lookupTables->IdOf("groups", "Diabetes"));
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDiabPeopleNotSeenClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabPeopleNotSeenReport *report = new TformLaunchDiabPeopleNotSeenReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORT->FORMS *****************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormIntakeClick(TObject *Sender)
{
  TformSpecialIntake::DoIntake();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormIntakeMedHistClick(TObject *Sender)
{
  TformSpecialIntake::DoIntakeMedHistory();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormIntakeOptoClick(TObject *Sender)
{
  TformSpecialIntake::DoIntakeMedHistoryOpto(); // jhaley 20110722: Extra intake info for Optometry
}
//---------------------------------------------------------------------------
// ********* REPORT->FORMS->COMMUNITY HEALTH ********************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormComAdultClick(TObject *Sender)
{
  TformSpecialAdultVisit::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormComDrugClick(TObject *Sender)
{
  TformSpecialDrugRegimenForm::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormComTaskClick(TObject *Sender)
{
  TformSpecialComTaskForm::Do();
}
//---------------------------------------------------------------------------
// ********* REPORT->FORMS->DIABETES ****************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormChildAssentClick(TObject *Sender)
{
  TformSpecialChildConsent::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormDoctorStatementClick(TObject *Sender)
{
  TformSpecialDoctorStatementForm::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormActivityLogClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchMonthlyActivityLogReport *report = new TformLaunchMonthlyActivityLogReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormParQClick(TObject *Sender)
{
  TformSpecialParQForm::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormReachContractClick(TObject *Sender)
{
  TformSpecialReachContract::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormStepsInfoClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialStepsForm *info_form = new TformSpecialStepsForm(NULL);
    info_form->coverpage->Preview();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormStepsClick(TObject *Sender)
{
  TformSpecialStepsForm::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormStepsPacketClick(TObject *Sender)
{
  TformSpecialStepsForm::DoPacket();
}
//---------------------------------------------------------------------------
// ********* REPORT->FORMS->PUBLIC HEALTH ***********************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormPubChildClick(TObject *Sender)
{
  TformSpecialComChildForm::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormPubDrugClick(TObject *Sender)
{
  TformSpecialDrugRegimenForm::Do(); // NB: Code was duplicated from the other menu item that launches this.
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormPubNewbornClick(TObject *Sender)
{
  TformSpecialComNewbornForm::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormPubPostpartumClick(TObject *Sender)
{
  TformSpecialComPostpartumForm::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportFormPubPrenatalClick(TObject *Sender)
{
  TformSpecialComPrenatalForm::Do();
}
//---------------------------------------------------------------------------
// ****** REPORT->MEDICAL CLINIC ********************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportMedicalPatientListClick(TObject *Sender)
{
  FORM_TRY
    // We're not passing a clinic_id because they could be running as LAC or SC; they'll have to pick one on this form....
    TformLaunchClinicPatientListReport *patient_list = new TformLaunchClinicPatientListReport(NULL, "0");
    patient_list->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportMedicalSCClick(TObject *Sender)
{
  TformLaunchSoonerCare *reportForm = NULL;
  FORM_TRY
    reportForm = new TformLaunchSoonerCare(NULL);
  FORM_CATCH_RETURN("TformLaunchSoonerCare", )
  reportForm->Show();
}
//---------------------------------------------------------------------------
// ****** REPORT->PHARMACY **************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportUploadEckerdClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialUploadEckerd *upload_form = new TformSpecialUploadEckerd(NULL);
    upload_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportUploadWalMartClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialUploadWalMart *upload_form = new TformSpecialUploadWalMart(NULL);
    upload_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportUploadComputerRxClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialUploadComputerRx *upload_form = new TformSpecialUploadComputerRx(NULL);
    upload_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportEckerdClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchEckerdReports *eckerd_reports = new TformLaunchEckerdReports(NULL);
    eckerd_reports->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportWalStateClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchPharmStateReport *state_report = new TformLaunchPharmStateReport(NULL);
    state_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportWalSpendersClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchSpendersReport *spenders_report = new TformLaunchSpendersReport(NULL);
    spenders_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportYearlyPharmacyClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchYearlyPharmacyReport *pharm_report = new TformLaunchYearlyPharmacyReport(NULL);
    pharm_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDailyDrugSalesClick(TObject *Sender)
{
  /* TODO? */;
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportMonthlyDrugSalesClick(TObject *Sender)
{
  /* TODO? */;
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportYearlyDrugSalesClick(TObject *Sender)
{
  /* TODO? */;
}
//---------------------------------------------------------------------------
// ****** REPORT->PUBLIC HEALTH *********************************************
//---------------------------------------------------------------------------
// ********* REPORT->PUBLIC HEALTH->CLIENTS *********************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportPublicClientCommentsClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchPublicCommentReport *comment_report = new TformLaunchPublicCommentReport(NULL, "");
    comment_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportPublicClientEduClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchPublicEducation *education_report = new TformLaunchPublicEducation(NULL, "");
    education_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportPublicClientEventsClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchEventByClientReport *event_report = new TformLaunchEventByClientReport(NULL, "", lookupTables->IdOf("groups", "Public Health"));
    event_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportPublicClientsMeasurementClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchPublicMeasurementReport *measurement_report = new TformLaunchPublicMeasurementReport(NULL, "");
    measurement_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportPublicClientVisitClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchPublicVisitReport *visit_report = new TformLaunchPublicVisitReport(NULL, "");
    visit_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORT->PUBLIC HEALTH MISC ****************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportPublicHealthMonthlyClick(TObject *Sender)
{
  FORM_TRY
    TformComPublicHealthReport *public_report = new TformComPublicHealthReport(NULL);
    public_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORT->PURCHASING/SUPPLY *****************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportPurchasingWorkloadClick(TObject *Sender)
{
  string group_id = lookupTables->IdOf("groups", "Purchasing/Supply"); // jhaley 20120510: run as Purchasing Dept
  TformLaunchCHSBillingWorkloadReport *billing_workload = NULL;

  FORM_TRY
    billing_workload = new TformLaunchCHSBillingWorkloadReport(NULL, group_id);
  FORM_CATCH_RETURN("TformLaunchCHSBillingWorkloadReport", )

  billing_workload->Show();
}
//---------------------------------------------------------------------------
// ****** REPORT->TRANSPORTATION ********************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportTransportationSummaryClick(TObject *Sender)
{
  TformLaunchTransportationSummaryReport::Do();
}
//---------------------------------------------------------------------------
// ****** REPORT->QUERIES AND ACTIONS ***************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportQueryPeopleClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialQuery *z = new TformSpecialQuery(NULL, "people");
    z->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportQueryObservationsClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialQuery *z = new TformSpecialQuery(NULL, "obs_response_sets");
    z->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportQueryVisitsClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialQuery *z = new TformSpecialQuery(NULL, "tasks");
    z->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** REPORT MISC *******************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportClientClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabClientReport *report = new TformLaunchDiabClientReport(NULL);
    report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportCobSummaryClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchCobSummary *cob_summary = new TformLaunchCobSummary(NULL);
    cob_summary->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportDenialLettersClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDenialLettersReport *denial_letters = new TformLaunchDenialLettersReport(NULL);
    denial_letters->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialEnrollmentClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchEnrollmentReport *enroll_report = new TformLaunchEnrollmentReport(NULL);
    enroll_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportEventListingClick(TObject *Sender)
{
  // jhaley 20100811: Added to allow department-generic event listing report use
  FORM_TRY
    // passing no group_id parameter allows the user to view events for all groups for which they have permission.
    TformLaunchEventListingReport *eventReport = new TformLaunchEventListingReport(NULL);
    eventReport->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportEventsByClientClick(TObject *Sender)
{
  // jhaley 20100806: Added to support view of all department events by client, now that the report supports this.
  FORM_TRY
    // jhaley: note that not passing the third parameter to the constructor will activate "all groups" mode.
    TformLaunchEventByClientReport *event_report = new TformLaunchEventByClientReport(NULL, "");
    event_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportInsuranceChargeAnalysisClick(TObject *Sender)
{
  // jhaley 20100914: Added for new Insurance Charge Analysis report
  FORM_TRY
    TformLaunchInsuranceChargeAnalysisReport *analysis_report = new TformLaunchInsuranceChargeAnalysisReport(NULL);
    analysis_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportMailingLabelsClick(TObject *Sender)
{
  // jhaley 20110826: Launch mailing labels report
  FORM_TRY
    TformLaunchMailingLabels *label_report = new TformLaunchMailingLabels(NULL);
    label_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportProcsByProviderClick(TObject *Sender)
{
  // jhaley 20110711: Launch procedures by provider report
  FORM_TRY
    TformLaunchProcsByProvider *procs_report = new TformLaunchProcsByProvider(NULL);
    procs_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuReportTaskDemographicsClick(TObject *Sender)
{
  // jhaley 20101122: Launch task demographics report
  FORM_TRY
    TformLaunchTaskDemoReport *task_demo = new TformLaunchTaskDemoReport(NULL);
    task_demo->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// **************************************************************************
// *** SPECIAL MENU *********************************************************
// **************************************************************************
//---------------------------------------------------------------------------
// ****** SPECIAL->ACCOUNTING ***********************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialAccountAdjustmentsClick(TObject *Sender)
{
  FORM_TRY
    TformWizardAccountAdjustments *wiz = new TformWizardAccountAdjustments(NULL);
    wiz->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialNewBudgetEntryClick(TObject *Sender)
{
  // wizard to enter the new budget amounts for yearly and non-yearly accounts
  FORM_TRY
    TformWizardNewBudgetEntry *wiz = new TformWizardNewBudgetEntry(NULL);
    wiz->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialCloseAccountsClick(TObject *Sender)
{
  // wizard to move expenses and revenues to equity at the end of a cycle
  FORM_TRY
    TformWizardAccountCloseEquity *wiz = new TformWizardAccountCloseEquity(NULL);
    wiz->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialGeneralJournalClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialGeneralJournal *general_journal = new TformSpecialGeneralJournal(NULL);
    general_journal->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialLedgerClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialLedger *ledger = new TformSpecialLedger(NULL);
    ledger->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SPECIAL->ADMINISTRATION *******************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialDataQueryClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialDataQuery *DQ = new TformSpecialDataQuery(NULL);
    DQ->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialDataMergeClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialDataMerge *DM = new TformSpecialDataMerge(NULL);
    DM->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialDataNavigationClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialDataNavigate *DN = new TformSpecialDataNavigate(NULL);
    DN->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialDiffUserPermissionsClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialPermissionsDiff *thing = new TformSpecialPermissionsDiff(NULL);
    thing->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialEditPermissionsClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialPermissions *edit_permissions = new TformSpecialPermissions(NULL);
    edit_permissions->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialFindUsersWithPermissionsClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialPermissionsToUsers *permissions_form = new TformSpecialPermissionsToUsers(NULL);
    permissions_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialEditLookupClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialLookupTables *lookup_table_form = new TformSpecialLookupTables(NULL);
    lookup_table_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialEditColorsClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialUserColors *user_color_screen = new TformSpecialUserColors(NULL);
    user_color_screen->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialRouterAdministrationClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialRouterAdministration *router_admin = new TformSpecialRouterAdministration(NULL);
    router_admin->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialUploadVersionClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialUploadVersion *upload_form = new TformSpecialUploadVersion(NULL);
    upload_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialDropTempViewsClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialDropTempViews *z = new TformSpecialDropTempViews(NULL);
    z->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialScreenStatisticsClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialScreenStatistics *screen_statistics = new TformSpecialScreenStatistics(NULL);
    screen_statistics->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialEditObservationOptionSetClick(TObject *Sender)
{
  TformWizardObservationOptionSet::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialEditObservationQuestionSetClick(TObject *Sender)
{
  TformSpecialObservationQuestionSetEditor::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialEditObservationExpectedRangesClick(TObject *Sender)
{
  TformSpecialObsExpectedRanges::Do("", "");
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialCachedObservationStatisticsClick(TObject *Sender)
{
  TformSpecialObservationStatistics::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialDebugClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialDebug *z = new TformSpecialDebug(NULL);
    z->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialDeletePersonClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialDeletePerson *person_delete = new TformSpecialDeletePerson(NULL);
    person_delete->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialMergePeopleClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialMergePerson *person_merge = new TformSpecialMergePerson(NULL);
    person_merge->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialMergeTaxEntitiesClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialMergeTaxEntity *merge_tax_entity = new TformSpecialMergeTaxEntity(NULL);
    merge_tax_entity->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SPECIAL->BEHAVIORAL HEALTH ****************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialDischargeBehClientsClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialDischargeBeh * discharge_beh = new TformSpecialDischargeBeh(NULL);
    discharge_beh->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SPECIAL->CALL LOG *************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialCallLogClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialCallLog *call_log = new TformSpecialCallLog(NULL);
    call_log->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SPECIAL->CONTRACT HEALTH ******************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialRequestedCobClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialHandleCob  *handle_cob = new TformSpecialHandleCob(NULL);
    handle_cob->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialMedicaidAboutToExpireClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialUpdatesNeeded *update_form = new TformSpecialUpdatesNeeded(NULL, false);
    update_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialLatestInsuranceClick(TObject *Sender)
{
  TformSpecialLatestInsurance::Do();
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialUpdatesNeededClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialUpdatesNeeded *update_form = new TformSpecialUpdatesNeeded(NULL, true);
    update_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SPECIAL->DIABETES *************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialAppointmentRemindersClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialAppointmentReminders *reminder_screen = new TformSpecialAppointmentReminders(NULL);
    reminder_screen->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialAttachActivitiesToLogsheetsClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialAttachActivitiesToLogsheets *attach = new TformSpecialAttachActivitiesToLogsheets(NULL);
    attach->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialInactiveClientsClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialDiabInactive *inactive_clients = new TformSpecialDiabInactive(NULL);
    inactive_clients->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialOrderShoesClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialOrderShoes *order_form = new TformSpecialOrderShoes(NULL);
    order_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialReceiveShoesClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialReceiveShoes *receive_form = new TformSpecialReceiveShoes(NULL);
    receive_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialDiabetesRegistryClick(TObject *Sender)
{
  FORM_TRY
    TformEnrollmentDiabRegistry *registry = new TformEnrollmentDiabRegistry(NULL);
    registry->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialDiabetesStepsClick(TObject *Sender)
{
  FORM_TRY
    TformEnrollmentDiabSteps *steps = new TformEnrollmentDiabSteps(NULL);
    steps->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialDiabWarningLettersClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialDiabWarningLetter *warning_letters = new TformSpecialDiabWarningLetter(NULL);
    warning_letters->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// ****** SPECIAL MISC ******************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialBugsClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialBugs *special_bugs = new TformSpecialBugs(NULL);
    special_bugs->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialChatClick(TObject *Sender)
{
  if (chat_window)
    chat_window->Show();
  else
  {
    FORM_TRY
      TformSpecialChat *chat_form = new TformSpecialChat(NULL);
      chat_window = chat_form;
      chat_form->Show();
    FORM_CATCH
  }
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialScheduleClick(TObject *Sender)
{
  if (scheduling_window)
    scheduling_window->Show();
  else
  {
    FORM_TRY
      TformSpecialSchedule2 *schedule = new TformSpecialSchedule2(NULL);
      schedule->Show();
    FORM_CATCH
  }
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialTimesheetClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialTimesheet *timesheet = new TformSpecialTimesheet(NULL);
    timesheet->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialWaitingReferralsClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialWaitingReferrals *referral_form = new TformSpecialWaitingReferrals(NULL);
    referral_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialSentReferralsClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialSentReferrals *referral_form = new TformSpecialSentReferrals(NULL);
    referral_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialMetricConversionClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialMetricConversion *z = new TformSpecialMetricConversion(NULL);
    z->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuSpecialViewReportClick(TObject *Sender)
{
  // open form to view a saved quick report
  FORM_TRY
    TformSpecialViewReport *viewer = new TformSpecialViewReport(NULL);
    viewer->reportViewer->Preview(); // TODO -c ENCAPSULATION : Should probably be a method of TformSpecialViewReport.
  FORM_CATCH
}
//---------------------------------------------------------------------------
// **************************************************************************
// *** HELP MENU ************************************************************
// **************************************************************************
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuHelpPrometheusClick(TObject *Sender)
{
  AnsiString x = "http://prometheus"; // TODO -c WEIRD : wry?
  ShellExecute(0, "open", static_cast<const char*>(x.data()), NULL, NULL, SW_SHOW);
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuAboutClick(TObject *Sender)
{
  FORM_TRY
    TformPrometheusAbout * about_screen = new TformPrometheusAbout(this);
    about_screen->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TframePrometheusMenu::menuHelpLicensesClick(TObject *Sender)
{
  FORM_TRY
    TformSpecialLicenses *license_screen = new TformSpecialLicenses(NULL);
    license_screen->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------

