# Based on NSIS MUI Basic Example Script written by Joost Verburg (thx!)
  !include "MUI.nsh"
  Name "Prometheus"
  OutFile "PrometheusInstall.exe"
  InstallDir "$PROGRAMFILES\Prometheus"
 
  ShowInstDetails show
  RequestExecutionLevel admin
  
;--------------------------------
;Pages
  !insertmacro MUI_PAGE_WELCOME
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
 
    # These indented statements modify settings for MUI_PAGE_FINISH
    !define MUI_FINISHPAGE_NOAUTOCLOSE
    !define MUI_FINISHPAGE_RUN
    !define MUI_FINISHPAGE_RUN_NOTCHECKED
    !define MUI_FINISHPAGE_RUN_TEXT "Start Prometheus"
    !define MUI_FINISHPAGE_RUN_FUNCTION "LaunchLink"
  !insertmacro MUI_PAGE_FINISH
 
;Languages
!insertmacro MUI_LANGUAGE "English"
 
!define ARP "Software\Microsoft\Windows\CurrentVersion\Uninstall\Prometheus"
 
;--------------------------------
# No components page, so this is anonymous
Section "Dummy Section" SecDummy
  SetOutPath "$INSTDIR"
  File prometheus.exe
  WriteUninstaller "$INSTDIR\Uninstall.exe"
  WriteRegStr HKLM "${ARP}" "DisplayName" "Prometheus"
  WriteRegStr HKLM "${ARP}" "UninstallString" "$\"$INSTDIR\Uninstall.exe$\""
  WriteRegStr HKLM "${ARP}" "Publisher" "Absentee Shawnee Tribal Health Systems, Inc."
  SetShellVarContext all
  CreateShortCut "$DESKTOP\Prometheus.lnk" "$INSTDIR\prometheus.exe"
SectionEnd
 
Section "Uninstall"
  Delete "$INSTDIR\prometheus.exe"
  DeleteRegKey HKLM "${ARP}"
  SetShellVarContext all
  Delete "$DESKTOP\Prometheus.lnk"
SectionEnd
 
Function LaunchLink
  ExecShell "" "$DESKTOP\Prometheus.lnk"
FunctionEnd