//---------------------------------------------------------------------------
#ifndef launchAppointmentReportH
#define launchAppointmentReportH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include "codeFrameCheckListDropDown.h"
#include "scheduling.h"
#include "codeBaseDropDown.h"
#include "codeCheckListDropDown.h"
#include "codePaddedBox.h"
//---------------------------------------------------------------------------
enum refresh_how {refresh_none, refresh_what_then_which, refresh_which_then_what};
class TformLaunchAppointmentReport : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *btnRun;
        TToolButton *btnClose;
        TGroupBox *groupWhich;
        TBitBtn *btnTaxEntitySearch;
        TGroupBox *groupHow;
        TRadioButton *radioOutcome;
        TRadioButton *radioListing;
        TRadioButton *radioClinic;
        TRadioButton *radioSimplified;
        TLabel *lblBegin;
        TDateTimePicker *dateBegin;
        TLabel *lblEndDate;
        TDateTimePicker *dateEnd;
        TBevel *Bevel1;
        TBevel *Bevel2;
        TPanel *panelSource;
        TPanel *panelPeople;
        TRadioButton *radioPeople;
        TRadioButton *radioAll;
        TRadioButton *radioUserList;
        TListView *listUsers;
        TRadioButton *radioTaxEntity;
        TStaticText *txtTaxEntity;
        TToolBar *toolTaxEntitySearch;
        TToolButton *btnTest;
        TRadioButton *radioSchedule;
        TBevel *Bevel3;
        TPanel *panelClinicDailyReport;
        TLabel *lblRoles;
        TCheckBox *checkSuperbill;
        TCheckBox *checkLabels;
        TPanel *panelCorners1;
        TImage *imageReport1;
        TRadioButton *radioUL1;
        TRadioButton *radioLL1;
        TRadioButton *radioUR1;
        TRadioButton *radioLR1;
        TCheckBox *checkProviderNotes;
        TPanel *panelCorners2;
        TImage *imageReport2;
        TRadioButton *radioUL2;
        TRadioButton *radioLL2;
        TRadioButton *radioUR2;
        TRadioButton *radioLR2;
        TPanel *panelLabels;
        TEdit *editLabelsPerPerson;
        TEdit *editStartingLabel;
        TStaticText *txtPrint;
        TStaticText *txtLabelsPerPatient;
        TCheckBox *checkShowDateTime;
        TCheckBox *checkDetailedListing;
        TCheckBox *checkPrintIntakesSignature;
        TCheckBox *checkReminderLetters;
        TBevel *Bevel4;
        TRadioButton *radioDateSort;
        TRadioButton *radioPersonSort;
        TEdit *editStartingMailingLabel;
        TCheckListDropDown *cbddRole;
        TRadioButton *radioSummaryOutcomes;
        TRadioButton *radioSummaryNone;
        TRadioButton *radioSheetLabels;
        TRadioButton *radioSpooledLabels;
        TRadioButton *radioGroup;
        TComboBox *cboGroup;
        TPaddedBox *paddedSuggestions;
        TLabel *labelSuggestions;
        TPanel *panelArrow;
        TImage *imageArrow;
        TPanel *Panel1;
        TImage *Image1;
        TPaddedBox *PaddedBox1;
        TLabel *lblNew;
        TCheckBox *checkExcludeBlocks;
        void __fastcall btnRunClick(TObject *Sender);
        void __fastcall btnTaxEntitySearchClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall btnCloseClick(TObject *Sender);
        void __fastcall WhatToPrintChange(TObject *Sender);
        void __fastcall FormShortCut(TWMKey &Msg, bool &Handled);
        void __fastcall WhichToPrintChange(TObject *Sender);
        void __fastcall staticAddUsersFromGroupsClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall cboGroupChange(TObject *Sender);
private:	// User declarations
        refresh_how refresh_what;
        int user_request;
        bool has_scheduler_data;
        classFilterObject user_filter;
        bool refresh_pending;
        void AtlasRefresh(int request_num, string matched_value);
        PApptOccurrenceMap *all_appointments;
        void RefreshDependencies();
public:		// User declarations
        __fastcall TformLaunchAppointmentReport(TComponent* Owner, PApptOccurrenceMap * p_appt_set = NULL);
        bool IsValidOnScreen();
};
//---------------------------------------------------------------------------
extern PACKAGE TformLaunchAppointmentReport *formLaunchAppointmentReport;
//---------------------------------------------------------------------------
#endif
