//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchBehActivityReport.h"
#include "reportBehActivity.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchBehActivityReport *formLaunchBehActivityReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchBehActivityReport::TformLaunchBehActivityReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Date();
  dateEnd->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehActivityReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehActivityReport::btnRunClick(TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {

    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;


    sql = "select beh_activity_types.item activity, tasks.date_of_task, users.item || ', ' || users.title employee, "
          "beh_meeting_types.item meeting_type, case "
          "when event_location_types.zip_code_id = 0 then event_location_types.item "
          "when event_location_types.item = '' then (zip_codes.city || ', ' || zip_codes.state) "
          "else (zip_codes.city || ', ' || zip_codes.state || ' - ' || event_location_types.item) end city, "
          "tasks.time_spent "
          "from tasks "
          "inner join beh_activity_types on tasks.beh_activity_id = beh_activity_types.id "
          "inner join users on tasks.user_id = users.id "
          "inner join event_location_types on tasks.event_location_id = event_location_types.id "
          "inner join zip_codes on event_location_types.zip_code_id = zip_codes.id "
          "inner join beh_meeting_types on tasks.beh_meeting_id = beh_meeting_types.id "
          "where tasks.group_id = '" + lookupTables->IdOf("groups", "Behavioral Health") + "' and "
          "tasks.date_of_task >= '" + begin_date + "' and "
          "tasks.date_of_task <= '" + end_date + "' and "
          "beh_activity_types.id > 0 and tasks.current_id >= 3 "
          "order by beh_activity_types.item, tasks.date_of_task ";

    dbTransaction->StartTransaction();
    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportBehActivity * activityReport = new TformReportBehActivity(NULL);
      activityReport->activityReport->DataSet = dbDataSet;
      activityReport->groupBand->Expression = "activity";
      activityReport->lblDateTitle->Caption = date_title.c_str();
      activityReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      activityReport->txtType->DataSet = dbDataSet;
      activityReport->txtType->DataField = "activity";
      activityReport->txtDate->DataSet = dbDataSet;
      activityReport->txtDate->DataField = "date_of_task";
      activityReport->txtEmployee->DataSet = dbDataSet;
      activityReport->txtEmployee->DataField = "employee";
      activityReport->txtDescription->DataSet = dbDataSet;
      activityReport->txtDescription->DataField = "meeting_type";
      activityReport->txtLocation->DataSet = dbDataSet;
      activityReport->txtLocation->DataField = "city";
      activityReport->exprHours->Expression = "FORMATNUMERIC('###0.00', (time_spent / 60))";
      activityReport->exprTotal->Expression = "FORMATNUMERIC('###0.00', (SUM(time_spent) / 60))";
      Processing(false);
      activityReport->activityReport->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
  }

  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }

  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehActivityReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

