//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchBehConditionReport.h"
#include "codeSearchPerson.h"
#include "reportBehCondition.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchBehConditionReport *formLaunchBehConditionReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchBehConditionReport::TformLaunchBehConditionReport(TComponent* Owner, string id)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Date();
  dateEnd->Date = Date();
  CreateLink(txtName, btnPersonSearch, this, id, "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehConditionReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehConditionReport::btnRunClick(TObject *Sender)
{
  string person_id = GetValidLinkId(txtName);
  if (person_id != "")
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Condition report for " + GetPersonName(dbDatabase, person_id, first_last);

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select conditions.start_date, conditions.stop_date, conditions.code, "
            "conditions.note from conditions "
            "where conditions.person_id = " + person_id + " and "
            "((conditions.start_date is null) or ((conditions.start_date <= '" + begin_date + "') and "
            "(conditions.start_date <= '" + end_date + "'))) and "
            "conditions.group_id = " + lookupTables->IdOf("groups", "Behavioral Health") + " and "
            "conditions.current_id >= 3 "
            "order by conditions.start_date, conditions.stop_date, conditions.code, conditions.note";

      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportBehCondition * conditionReport = new TformReportBehCondition(NULL);
        conditionReport->conditionReport->DataSet = dbDataSet;
        conditionReport->lblTitle->Caption = title.c_str();
        conditionReport->lblDateTitle->Caption = date_title.c_str();
        conditionReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        conditionReport->txtStartDate->DataSet = dbDataSet;
        conditionReport->txtStartDate->DataField = "start_date";
        conditionReport->txtStopDate->DataSet = dbDataSet;
        conditionReport->txtStopDate->DataField = "stop_date";
        conditionReport->txtCode->DataSet = dbDataSet;
        conditionReport->txtCode->DataField = "code";
        conditionReport->txtNote->DataSet = dbDataSet;
        conditionReport->txtNote->DataField = "note";
        Processing(false);
        conditionReport->conditionReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }
  else
  {
    PSay("Please enter a client name", m_missing_data, MB_OK);
    btnPersonSearch->SetFocus();
  }                
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehConditionReport::btnPersonSearchClick(
      TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtName, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehConditionReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

