//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchBehEventReport.h"
#include "reportBehEvent.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchBehEventReport *formLaunchBehEventReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchBehEventReport::TformLaunchBehEventReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Date();
  dateEnd->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehEventReport::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehEventReport::btnRunClick(TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {
    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    sql = "select events.id, event_type_types.item event_type, event_name_types.item event_name, "
          "events.date_of_event, case "
          "when event_location_types.zip_code_id = 0 then event_location_types.item "
          "when event_location_types.item = '' then (zip_codes.city || ', ' || zip_codes.state) "
          "else (zip_codes.city || ', ' || zip_codes.state || ' - ' || event_location_types.item) end location, "
          "events.number_attended, users.item employee, tasks.time_spent "
          "from event_type_types, event_location_types, zip_codes, event_name_types, "
          "events left join tasks on tasks.event_id = events.id  and tasks.event_id > 0 and "
          "tasks.group_id = '" + lookupTables->IdOf("groups", "Behavioral Health") + "' and "
          "tasks.date_of_task >= '" + begin_date + "' and "
          "tasks.date_of_task <= '" + end_date + "' "
          "left join users on tasks.user_id = users.id "
          "where events.event_type_id = event_type_types.id and "
          "events.event_location_id = event_location_types.id and "
          "event_location_types.zip_code_id = zip_codes.id and "
          "events.event_name_id = event_name_types.id and "
          "events.date_of_event >= '" + begin_date + "' and "
          "events.date_of_event <= '" + end_date + "' and "
          "events.group_id = '" + lookupTables->IdOf("groups", "Behavioral Health") + "' "
          "order by event_type_types.item, events.date_of_event ";

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportBehEvent * eventReport = new TformReportBehEvent(NULL);
      eventReport->eventReport->DataSet = dbDataSet;
      eventReport->groupBand->Expression = "id";
      eventReport->lblDateTitle->Caption = date_title.c_str();
      eventReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      eventReport->txtType->DataSet = dbDataSet;
      eventReport->txtType->DataField = "event_type";
      eventReport->txtEventName->DataSet = dbDataSet;
      eventReport->txtEventName->DataField = "event_name";
      eventReport->txtDate->DataSet = dbDataSet;
      eventReport->txtDate->DataField = "date_of_event";
      eventReport->txtLocation->DataSet = dbDataSet;
      eventReport->txtLocation->DataField = "location";
      eventReport->txtNumberAttended->DataSet = dbDataSet;
      eventReport->txtNumberAttended->DataField = "number_attended";
      eventReport->txtEmployee->DataSet = dbDataSet;
      eventReport->txtEmployee->DataField = "employee";
      eventReport->exprHours->Expression = "FORMATNUMERIC('###0.00', (time_spent / 60))";
      eventReport->exprTotalEvents->Expression = "COUNT";
      eventReport->exprTotalHours->Expression = "FORMATNUMERIC('##0.00', (SUM(time_spent) / 60))";
      Processing(false);
      eventReport->eventReport->Preview();
      dbDataSet->Close();
      dbTransaction->Commit();
    FORM_CATCH
  }
  catch (...)
  {
   Processing(false);    
   PSay("Error running report", m_database_error, MB_OK);
   if (dbTransaction->Active)
     dbTransaction->Rollback();
  }

  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehEventReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;
}
//---------------------------------------------------------------------------

