//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchBehLocalTreatmentReport.h"
#include "codeSearchPerson.h"
#include "reportBehLocalTreatment.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchBehLocalTreatmentReport *formLaunchBehLocalTreatmentReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchBehLocalTreatmentReport::TformLaunchBehLocalTreatmentReport(TComponent* Owner, string id)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Date();
  dateEnd->Date = Date();
  CreateLink(txtName, btnPersonSearch, this, id, "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehLocalTreatmentReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehLocalTreatmentReport::btnRunClick(
      TObject *Sender)
{
  string person_id = GetValidLinkId(txtName);
  if (person_id != "")
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Local treatment report for " + GetPersonName(dbDatabase, person_id, first_last);

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select beh_treatment.admit_date, beh_treatment.discharge_date, beh_discharge_types.item reason, "
            "beh_treatment.comments from beh_treatment, beh_discharge_types "
            "where beh_treatment.person_id = " + person_id + " and "
            "beh_treatment.beh_discharge_id = beh_discharge_types.id and "
            "beh_treatment.admit_date >= '" + begin_date + "' and "
            "beh_treatment.admit_date <= '" + end_date + "' and "
            "beh_treatment.current_id >= 3 "
            "order by beh_treatment.admit_date";

      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportBehLocalTreatment * treatmentReport = new TformReportBehLocalTreatment(NULL);
        treatmentReport->treatmentReport->DataSet = dbDataSet;
        treatmentReport->lblTitle->Caption = title.c_str();
        treatmentReport->lblDateTitle->Caption = date_title.c_str();
        treatmentReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        treatmentReport->txtAdmitDate->DataSet = dbDataSet;
        treatmentReport->txtAdmitDate->DataField = "admit_date";
        treatmentReport->txtDischargeDate->DataSet = dbDataSet;
        treatmentReport->txtDischargeDate->DataField = "discharge_date";
        treatmentReport->txtReason->DataSet = dbDataSet;
        treatmentReport->txtReason->DataField = "reason";
        treatmentReport->txtNote->DataSet = dbDataSet;
        treatmentReport->txtNote->DataField = "comments";
        Processing(false);
        treatmentReport->treatmentReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);       
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }
  else
  {
    PSay("Please enter a client name", m_missing_data, MB_OK);
    btnPersonSearch->SetFocus();
  }                        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehLocalTreatmentReport::btnPersonSearchClick(
      TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtName, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehLocalTreatmentReport::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

