//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchBehMeetingReport.h"
#include "reportBehMeeting.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchBehMeetingReport *formLaunchBehMeetingReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchBehMeetingReport::TformLaunchBehMeetingReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Date();
  dateEnd->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehMeetingReport::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehMeetingReport::btnRunClick(TObject *Sender)
{
  Processing(true);
  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {
    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;


    sql = "select tasks.date_of_task, users.item employee, "
          "beh_meeting_types.item meeting_type, case "
          "when event_location_types.zip_code_id = 0 then event_location_types.item "
          "when event_location_types.item = '' then (zip_codes.city || ', ' || zip_codes.state) "
          "else (zip_codes.city || ', ' || zip_codes.state || ' - ' || event_location_types.item) end location, "
          "tasks.time_spent "
          "from tasks "
          "inner join users on tasks.user_id = users.id "
          "inner join beh_meeting_types on tasks.beh_meeting_id = beh_meeting_types.id "
          "inner join event_location_types on tasks.event_location_id = event_location_types.id "
          "inner join zip_codes on event_location_types.zip_code_id = zip_codes.id "
          "where tasks.beh_meeting_id > 0 and "
          "tasks.group_id = '" + lookupTables->IdOf("groups", "Behavioral Health") + "' and "
          "tasks.date_of_task >= '" + begin_date + "' and "
          "tasks.date_of_task <= '" + end_date + "' "
          "order by tasks.date_of_task, users.item";

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportBehMeeting * meetingReport = new TformReportBehMeeting(NULL);
      meetingReport->meetingReport->DataSet = dbDataSet;
      meetingReport->lblDateTitle->Caption = date_title.c_str();
      meetingReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      meetingReport->txtDate->DataField = "date_of_task";
      meetingReport->txtDate->DataSet = dbDataSet;
      meetingReport->txtEmployee->DataField = "employee";
      meetingReport->txtEmployee->DataSet = dbDataSet;
      meetingReport->txtMeeting->DataField = "meeting_type";
      meetingReport->txtMeeting->DataSet = dbDataSet;
      meetingReport->txtLocation->DataField = "location";
      meetingReport->txtLocation->DataSet = dbDataSet;
      meetingReport->exprTime->Expression = "FORMATNUMERIC('##0.00', (time_spent / 60))";
      meetingReport->exprTotal->Expression = "FORMATNUMERIC('##0.00', (SUM(time_spent) / 60))";
      Processing(false);
      meetingReport->meetingReport->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();

  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehMeetingReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

