//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchBehOutsideTreatmentReport.h"
#include "reportBehOutsideTreatment.h"
#include "codeSearchPerson.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TfromLaunchBehOutsideTreatmentReport *fromLaunchBehOutsideTreatmentReport;
//---------------------------------------------------------------------------
__fastcall TfromLaunchBehOutsideTreatmentReport::TfromLaunchBehOutsideTreatmentReport(TComponent* Owner, string id)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Date();
  dateEnd->Date = Date();
  CreateLink(txtName, btnPersonSearch, this, id, "people");
}
//---------------------------------------------------------------------------
void __fastcall TfromLaunchBehOutsideTreatmentReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TfromLaunchBehOutsideTreatmentReport::btnRunClick(
      TObject *Sender)
{
 string person_id = GetValidLinkId(txtName);
 if (person_id != "")
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Outside treatment report for " + GetPersonName(dbDatabase, person_id, first_last);

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select beh_out_treatment.begin_date, beh_out_treatment.end_date, "
            "tax_entities.name facility, patient_types.item patient_type, "
            "beh_out_treatment.doctor_name, "
            "beh_out_treatment.medications "
            "from beh_out_treatment, tax_entities, patient_types "
            "where beh_out_treatment.tax_entity_id = tax_entities.id and "
            "beh_out_treatment.patient_id = patient_types.id and "
            "beh_out_treatment.person_id = " + person_id + " and "
            "(((beh_out_treatment.begin_date >= '" + begin_date + "') and "
            "(beh_out_treatment.begin_date <= '" + end_date + "')) or "
            "(beh_out_treatment.begin_date is null)) and "
            "beh_out_treatment.current_id >= 3 "
            "order by beh_out_treatment.begin_date";

      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportBehOutsideTreatment * treatmentReport = new TformReportBehOutsideTreatment(NULL);
        treatmentReport->treatmentReport->DataSet = dbDataSet;
        treatmentReport->lblTitle->Caption = title.c_str();
        treatmentReport->lblDateTitle->Caption = date_title.c_str();
        treatmentReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        treatmentReport->txtBeginDate->DataSet = dbDataSet;
        treatmentReport->txtBeginDate->DataField = "begin_date";
        treatmentReport->txtEndDate->DataSet = dbDataSet;
        treatmentReport->txtEndDate->DataField = "end_date";
        treatmentReport->txtFacility->DataSet = dbDataSet;
        treatmentReport->txtFacility->DataField = "facility";
        treatmentReport->txtPatient->DataSet = dbDataSet;
        treatmentReport->txtPatient->DataField = "patient";
        treatmentReport->txtDoctor->DataSet = dbDataSet;
        treatmentReport->txtDoctor->DataField = "doctor_name";
        treatmentReport->txtMedications->DataSet = dbDataSet;
        treatmentReport->txtMedications->DataField = "medications";
        Processing(false);
        treatmentReport->treatmentReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);    
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }
  else
  {
    PSay("Please enter a client name", m_missing_data, MB_OK);
    btnPersonSearch->SetFocus();
  }                
}
//---------------------------------------------------------------------------
void __fastcall TfromLaunchBehOutsideTreatmentReport::btnPersonSearchClick(
      TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtName, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TfromLaunchBehOutsideTreatmentReport::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

