//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchBehReferralReport.h"
#include "reportBehReferral.h"
#include "codeSearchPerson.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchBehReferralReport *formLaunchBehReferralReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchBehReferralReport::TformLaunchBehReferralReport(TComponent* Owner, string id)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Date();
  dateEnd->Date = Date();
  CreateLink(txtName, btnPersonSearch, this, id, "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehReferralReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehReferralReport::btnRunClick(TObject *Sender)
{
  string person_id = GetValidLinkId(txtName);
  if (person_id != "")
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Referral report for " + GetPersonName(dbDatabase, person_id, first_last);

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select beh_referrals.date_of_referral, beh_facilities.name facility, "
            "direction_types.item direction, beh_reason_types.item reason, "
            "beh_referrals.referred_to, beh_referrals.referred_by "
            "from beh_referrals, beh_facilities, direction_types, beh_reason_types "
            "where beh_referrals.beh_facility_id = beh_facilities.id and "
            "beh_referrals.direction_id = direction_types.id and "
            "beh_referrals.beh_reason_id = beh_reason_types.id and "
            "beh_referrals.person_id = " + person_id + " and "
            "(((beh_referrals.date_of_referral >= '" + begin_date + "') and "
            "(beh_referrals.date_of_referral <= '" + end_date + "')) or "
            "(beh_referrals.date_of_referral is null)) and "
            "beh_referrals.current_id >= 3 "
            "order by beh_referrals.date_of_referral";

      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportBehReferral * referralReport = new TformReportBehReferral(NULL);
        referralReport->referralReport->DataSet = dbDataSet;
        referralReport->lblTitle->Caption = title.c_str();
        referralReport->lblDateTitle->Caption = date_title.c_str();
        referralReport->txtDate->DataSet = dbDataSet;
        referralReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        referralReport->txtDate->DataField = "date_of_referral";
        referralReport->txtFacility->DataSet = dbDataSet;
        referralReport->txtFacility->DataField = "facility";
        referralReport->txtDirection->DataSet = dbDataSet;
        referralReport->txtDirection->DataField = "direction";
        referralReport->txtReason->DataSet = dbDataSet;
        referralReport->txtReason->DataField = "reason";
        referralReport->txtTo->DataSet = dbDataSet;
        referralReport->txtTo->DataField = "referred_to";
        referralReport->txtBy->DataSet = dbDataSet;
        referralReport->txtBy->DataField = "referred_by";
        Processing(false);
        referralReport->referralReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
     }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }
  else
  {
    PSay("Please enter a client name", m_missing_data, MB_OK);
    btnPersonSearch->SetFocus();
  }        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehReferralReport::btnPersonSearchClick(
      TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtName, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehReferralReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

