//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchBehTaskReport.h"
#include "reportBehTask.h"
#include "codeSearchPerson.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TfromLaunchBehTaskReport *fromLaunchBehTaskReport;
//---------------------------------------------------------------------------
__fastcall TfromLaunchBehTaskReport::TfromLaunchBehTaskReport(TComponent* Owner, string id)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Date();
  dateEnd->Date = Date();
  CreateLink(txtName, btnPersonSearch, this, id, "people");
}
//---------------------------------------------------------------------------
void __fastcall TfromLaunchBehTaskReport::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TfromLaunchBehTaskReport::btnRunClick(TObject *Sender)
{
  string person_id = GetValidLinkId(txtName);
  if (person_id != "")
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Task/visit report for " + GetPersonName(dbDatabase, person_id, first_last);

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select tasks.date_of_task, method_types.item method, direction_types.item direction, "
            "beh_visit_types.item visit_type, visit_location_types.item location, beh_service_types.item service_type, "
            "visit_outcome_types.item visit_outcome, tasks.new_client, tasks.task_comments || ' ' || tasks.visit_comments comments "
            "from tasks, method_types, direction_types, beh_visit_types, visit_location_types, "
            "beh_service_types, visit_outcome_types "
            "where tasks.method_id = method_types.id and "
            "tasks.direction_id = direction_types.id and "
            "tasks.beh_visit_id = beh_visit_types.id and "
            "tasks.visit_location_id = visit_location_types.id and "
            "tasks.beh_service_id = beh_service_types.id and "
            "tasks.visit_outcome_id = visit_outcome_types.id and "
            "(((tasks.date_of_task >= '" + begin_date + "') and "
            "(tasks.date_of_task <= '" + end_date + "')) or "
            "(tasks.date_of_task is null)) and "
            "tasks.person_id = " + person_id + " and "
            "tasks.current_id >= 3 and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Behavioral Health") +
            " order by tasks.date_of_task";

      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportBehTask * taskReport = new TformReportBehTask(NULL);
        taskReport->taskReport->DataSet = dbDataSet;
        taskReport->lblTitle->Caption = title.c_str();
        taskReport->lblDateTitle->Caption = date_title.c_str();
        taskReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        taskReport->txtDate->DataSet = dbDataSet;
        taskReport->txtDate->DataField = "date_of_task";
        taskReport->txtMethod->DataSet = dbDataSet;
        taskReport->txtMethod->DataField = "method";
        taskReport->txtDirection->DataSet = dbDataSet;
        taskReport->txtDirection->DataField = "direction";
        taskReport->txtVisitType->DataSet = dbDataSet;
        taskReport->txtVisitType->DataField = "visit_type";
        taskReport->txtLocation->DataSet = dbDataSet;
        taskReport->txtLocation->DataField = "location";
        taskReport->txtServiceType->DataSet = dbDataSet;
        taskReport->txtServiceType->DataField = "service_type";
        taskReport->txtOutcome->DataSet = dbDataSet;
        taskReport->txtOutcome->DataField = "visit_outcome";
        taskReport->exprNew->Expression = "IF(new_client = '1', 'Yes', 'No')";
        taskReport->txtComments->DataSet = dbDataSet;
        taskReport->txtComments->DataField = "comments";
        Processing(false);
        taskReport->taskReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);   
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }
  else
  {
    PSay("Please enter a client name", m_missing_data, MB_OK);
    btnPersonSearch->SetFocus();
  }
}
//---------------------------------------------------------------------------
void __fastcall TfromLaunchBehTaskReport::btnPersonSearchClick(
      TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtName, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TfromLaunchBehTaskReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

