//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "launchBehVisitReports.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchBehVisitReports *formLaunchBehVisitReports;
//---------------------------------------------------------------------------
__fastcall TformLaunchBehVisitReports::TformLaunchBehVisitReports(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Date();
  dateEnd->Date = Date();
  times_run = 0;
//  FORM_TRY
//        locationsReport = new TformReportBehVisitLocations(NULL);
//  FORM_CATCH

}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehVisitReports::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehVisitReports::btnRunClick(TObject *Sender)
{
  dbLocationsDataSet = new TIBDataSet(NULL);
  dbTypesDataSet = new TIBDataSet(NULL);
  dbTotalsDataSet = new TIBDataSet(NULL);
  dbTransaction = new TIBTransaction(NULL);
  Processing(true);
  TQRPageList * source = new TQRPageList();
  TQRPageList * destination = new TQRPageList();
  destination->Stream = new TQRStream(100000);
  TQRPrinter * printer_thing = InitTQRPrinter();

  FORM_TRY
        totalsReport = new TformReportBehTotalServices(NULL);
  FORM_CATCH
  FORM_TRY
        typesReport = new TformReportBehVisitTypes(NULL);
  FORM_CATCH
  try
  {
     FORM_TRY
        locationsReport = new TformReportBehVisitLocations(NULL);
        StdTransaction(dbTransaction, dbDatabase);
        dbLocationsDataSet->Database = dbDatabase;
        dbLocationsDataSet->Transaction = dbTransaction;
        dbLocationsDataSet->UniDirectional = false;
        dbTypesDataSet->Database = dbDatabase;
        dbTypesDataSet->Transaction = dbTransaction;
        dbTypesDataSet->UniDirectional = false;
        dbTotalsDataSet->Database = dbDatabase;
        dbTotalsDataSet->Transaction = dbTransaction;
        dbTotalsDataSet->UniDirectional = false;

        compositeReport->Prepare();
        string file_name = PMakeTempFilePath("page1.qrp");
        ((TQuickRep *)(compositeReport->Reports->First()))->QRPrinter->Save(file_name.c_str());
        // add page 1
        source->Clear();
        source->LoadFromFile(file_name.c_str());
        destination->AddPage(source->GetPage(1));
        destination->Finish();
        string temp_filepath = PMakeTempFilePath("complete.qrp");
        destination->SaveToFile(temp_filepath.c_str());
        // load combined report and preview
        printer_thing->Load(temp_filepath.c_str());
        Processing(false);
        printer_thing->PreviewModal();
     FORM_CATCH

     dbLocationsDataSet->Close();
     dbTypesDataSet->Close();
     dbTotalsDataSet->Close();
     dbTransaction->Commit();
     totalsReport->CloseNow();
     typesReport->CloseNow();
     locationsReport->CloseNow();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }

  delete dbTransaction;
  delete dbLocationsDataSet;
  delete dbTypesDataSet;
  delete dbTotalsDataSet;
  delete printer_thing;
  delete source;
  delete destination;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehVisitReports::compositeReportAddReports(TObject *Sender)
{
  if (times_run == 0)
  {
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;

    try
    {
      sql = "select count(tasks.id) total from tasks "
            "left join visit_location_types on tasks.visit_location_id = visit_location_types.id "
            "left join beh_visit_types on tasks.beh_visit_id = beh_visit_types.id "
            "where tasks.new_client = 1 and "
            "tasks.current_id >= 3 and tasks.visit_location_id > 0 and tasks.beh_visit_id > 0 and "
            "visit_location_types.valid = 1 and beh_visit_types.valid = 1 and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Behavioral Health") + " and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "'";
      dbTotalsDataSet->SelectSQL->Add(sql.c_str());
      dbTotalsDataSet->Open();
      dbTotalsDataSet->First();

      totalsReport->totalsReport->DataSet = dbTotalsDataSet;
      totalsReport->txtNewClients->DataSet = dbTotalsDataSet;
      totalsReport->lblDateTitle->Caption = date_title.c_str();
      totalsReport->txtNewClients->DataField = "total";
      sql = "select count(tasks.id) from tasks "
            "left join visit_location_types on tasks.visit_location_id = visit_location_types.id "
            "left join beh_visit_types on tasks.beh_visit_id = beh_visit_types.id "
            "where "//tasks.person_id > 0 and "
            "tasks.current_id >= 3 and "
            "tasks.visit_location_id > 0 and tasks.beh_visit_id > 0 and "
            "visit_location_types.valid = 1 and beh_visit_types.valid = 1 and "
//            "tasks.visit_location_id != " + lookupTables->IdOf("visit_location_types", "Phone") + " and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Behavioral Health") + " and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "'";
      totalsReport->lblServices->Caption = GetOneField(dbTransaction, sql).c_str();
      sql = "select count(tasks.id) from tasks "
            "left join visit_location_types on tasks.visit_location_id = visit_location_types.id "
            "left join beh_visit_types on tasks.beh_visit_id = beh_visit_types.id "
            "where "
            "visit_location_types.valid = 1 and beh_visit_types.valid = 1 and "
            "tasks.method_id = " + lookupTables->IdOf("method_types", "Phone") + " and "
            "tasks.current_id >= 3 and beh_visit_id = 0 and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Behavioral Health") + " and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "'";
      totalsReport->lblPhone->Caption = GetOneField(dbTransaction, sql).c_str();
      compositeReport->Reports->Add(totalsReport->totalsReport);

/*
      sql = "select beh_visit_types.item reason, count(tasks.id) visits, "
            "sum(tasks.time_spent) minutes "
            "from beh_visit_types left join tasks on tasks.beh_visit_id = beh_visit_types.id and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Behavioral Health") + " and "
            "tasks.current_id >= 3 and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' "
            "where beh_visit_types.valid = 1 and tasks.beh_visit_id > 0 and "
            "tasks.visit_location_id > 0 "
//            "tasks.visit_location_id != " + lookupTables->IdOf("visit_location_types", "Phone") +
            " group by beh_visit_types.item order by beh_visit_types.item";
  Change where to and so we get all items and add where beh_visit_types.id > 0 so we don't get the blank one
*/
      sql = "select beh_visit_types.item reason, count(tasks.id) visits, "
            "sum(tasks.time_spent) minutes "
            "from beh_visit_types left join tasks on tasks.beh_visit_id = beh_visit_types.id and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Behavioral Health") + " and "
            "tasks.current_id >= 3 and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' and "
            "tasks.beh_visit_id > 0 and "
            "tasks.visit_location_id > 0 "
            "left join visit_location_types on tasks.visit_location_id = visit_location_types.id "
            "where beh_visit_types.id > 0 and beh_visit_types.valid = 1 and "
            "(visit_location_types.valid is null or visit_location_types.valid = 1) "
//            "tasks.visit_location_id != " + lookupTables->IdOf("visit_location_types", "Phone") +
            " group by beh_visit_types.item order by beh_visit_types.item";

      dbTypesDataSet->SelectSQL->Add(sql.c_str());

/*
      sql = "select visit_location_types.item location, count(tasks.id) visits, "
            "sum(tasks.mileage) miles "
            "from visit_location_types left join tasks on "
            "tasks.visit_location_id = visit_location_types.id and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Behavioral Health") + " and "
            "tasks.current_id >= 3 and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' "
            "where visit_location_types.valid = 1 and tasks.visit_location_id > 0 and "
            "tasks.beh_visit_id > 0 "
//            "tasks.visit_location_id != " + lookupTables->IdOf("visit_location_types", "Phone") +
            " group by visit_location_types.item order by visit_location_types.item";
  Change where to and so we get all items and add where visit_location_types.id > 0 so we don't get the blank one
*/


      sql = "select visit_location_types.item location, count(tasks.id) visits, "
            "sum(tasks.mileage) miles "
            "from visit_location_types left join tasks on "
            "tasks.visit_location_id = visit_location_types.id and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Behavioral Health") + " and "
            "tasks.current_id >= 3 and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' and "
            "visit_location_types.valid = 1 and tasks.beh_visit_id > 0 and "
            "tasks.visit_location_id > 0 "
            "left join beh_visit_types on tasks.beh_visit_id = beh_visit_types.id "
            "where visit_location_types.id > 0 and visit_location_types.valid = 1 and "
            "(beh_visit_types.valid is null or beh_visit_types.valid = 1) "
//            "tasks.visit_location_id != " + lookupTables->IdOf("visit_location_types", "Phone") +
            " group by visit_location_types.item order by visit_location_types.item";

      dbLocationsDataSet->SelectSQL->Add(sql.c_str());

      dbTypesDataSet->Open();
      dbTypesDataSet->First();
      dbLocationsDataSet->Open();
      dbLocationsDataSet->First();

      typesReport->typesReport->DataSet = dbTypesDataSet;
      typesReport->txtType->DataSet = dbTypesDataSet;
      typesReport->txtType->DataField = "reason";
      typesReport->txtVisits->DataSet = dbTypesDataSet;
      typesReport->txtVisits->DataField = "visits";
      typesReport->exprHours->Expression = "FORMATNUMERIC('#,##0', (minutes / 60))";
      typesReport->exprTotalVisits->Expression = "SUM(visits)";
      typesReport->exprTotalHours->Expression = "FORMATNUMERIC('#,##0', SUM((minutes / 60)))";
      compositeReport->Reports->Add(typesReport->typesReport);

      locationsReport->locationsReport->DataSet = dbLocationsDataSet;
      locationsReport->txtLocation->DataSet = dbLocationsDataSet;
      locationsReport->txtLocation->DataField = "location";
      locationsReport->txtVisits->DataSet = dbLocationsDataSet;
      locationsReport->txtVisits->DataField = "visits";
      locationsReport->exprMiles->Expression = "FORMATNUMERIC('#,##0.00', miles)";
      locationsReport->exprTotalVisits->Expression = "SUM(visits)";
      locationsReport->exprTotalMiles->Expression = "FORMATNUMERIC('#,##0.00', SUM(miles))";
      compositeReport->Reports->Add(locationsReport->locationsReport);
    }
    catch (...)
    {
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    times_run++;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehVisitReports::compositeReportFinished(TObject *Sender)
{
  // in case
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBehVisitReports::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

