//and you could still use a non-correlated sub-select to say
//
// accounts ... on ... and accounts.acc_level_*_id in (select acc_level_*.id from acc_level_* where short_item like '') or whatever
//non-correlated subqueries won't slow you down nearly as much as a join can
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchBudgetReport.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchBudgetReport *formLaunchBudgetReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchBudgetReport::TformLaunchBudgetReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  lookupTables->RegisterComboBox("month_types", comboCycle);

  // some defaults.
  Pdate today_date(Date());
  Pdate begin_date = today_date;
  begin_date.day   = 1;

  if (1 > begin_date.month)
   begin_date.mod(-1, in_years);
  begin_date.month = 1;

  Pdate end_date = begin_date;
  end_date.mod(1, in_years);
  end_date.mod(-1, in_days);

  dateBeginDate->Date = begin_date.OutDate();
  dateEndDate->Date   = end_date.OutDate();
  dateAsOfDate->Date  = end_date.OutDate();
  comboCycle->Text = lookupTables->ValueOf("month_types", "1").c_str();

  // old order: check_number, pr_number, bill_number, tx_date, entity_name
  comboOrder->ItemIndex = 0; // closest to the old order?
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBudgetReport::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBudgetReport::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    buttonNewRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
// Summary
//---------------------------------------------------------------------------
/*
void TformLaunchBudgetReport::RunSummaryBudgetReport()
{
  Processing(true);
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);

  try
  {
    // Set up transaction for use of temp tables
    dbTransaction->DefaultDatabase = dbDatabase;
    dbTransaction->StartTransaction();

    bool is_exact = checkIsExactMatch->Enabled && checkIsExactMatch->Checked;
    vector<string> acct_req;
    map<string, string> account_parts = PartsByMask (maskAccount);

    if (checkByMask->Checked)
      for (map<string, string>::iterator i_part = account_parts.begin(); i_part != account_parts.end(); i_part++)
       if (!is_exact && i_part->second.find_first_not_of ("0") == string::npos)
        acct_req.push_back("");
       else
       {
        string acc_level = "acc_level_" + i_part->first;
        acct_req.push_back(" and " + acc_level + "_id in (select id from " + acc_level + " where short_item = '" + i_part->second + "') ");
       }
    // Run the SQL to fill the temp tables the report will be using
    string sql;

    sql = "delete from temp_budget_summary1";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(1);

    // dept/budget/fund_id and budget amount
    sql = "insert into temp_budget_summary1 "
          "select acc_level_one_id fund_id, acc_level_two_id budget_id, acc_level_three_id dept_id, 1, "
          "       sum(debit_amount - credit_amount), 0, 0 "
          "from transactions inner join accounts on transactions.account_id = accounts.id and transactions.task_id = 0 "
          "where accounts.account_type_id = 4 and is_budget = 1 " // no no no, bad // and transactions.effective_date >= '1/1/2002' "
          "and transactions.effective_date <= '" + end_date + "' ";
    for (unsigned int i = 0; i != acct_req.size(); i++)
       sql += acct_req[i];
    sql += "group by acc_level_one.id, acc_level_two.id, acc_level_three.id; ";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(2);

    // expenses to date
    sql = "insert into temp_budget_summary1 "
          "select acc_level_one_id fund_id, acc_level_two_id budget_id, acc_level_three_id dept_id, 2, "
          "       0, sum(debit_amount - credit_amount), 0 "
          "from transactions inner join accounts on transactions.account_id = accounts.id and transactions.task_id = 0 "
          "where accounts.account_type_id = 4 and is_budget = 0 " // no no no, bad // and transactions.effective_date >= '1/1/2002' "
          "and transactions.effective_date <= '" + end_date + "' ";
    for (unsigned int i = 0; i != acct_req.size(); i++)
       sql += acct_req[i];
    sql += "group by acc_level_one.id, acc_level_two.id, acc_level_three.id; ";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(3);

    sql = "insert into temp_budget_summary1 "
          "select acc_level_one_id fund_id, acc_level_two_id budget_id, acc_level_three_id dept_id, 3, "
          "       0, 0, sum(debit_amount - credit_amount) "
          "from transactions inner join accounts on transactions.account_id = accounts.id and transactions.task_id = 0 "
          "where accounts.account_type_id = 4 and is_budget = 0 and transactions.effective_date >= '" + begin_date + "' and "
          "      transactions.effective_date <= '" + end_date + "' ";
    for (unsigned int i = 0; i != acct_req.size(); i++)
       sql += acct_req[i];
    sql += "group by acc_level_one.id, acc_level_two.id, acc_level_three.id; ";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(4);

    sql = "delete from temp_budget_summary2";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(5);

    sql = "insert into temp_budget_summary2 "
          "select A.fund_id, A.budget_id, A.department_id, "
          "       acc_level_one.short_item || ' - ' || acc_level_one.item || ' - Department  ' || acc_level_three.short_item || ' - ' || acc_level_three.item title, "
          "       acc_level_two.short_item || ' - ' || acc_level_two.item line_item, "
          "       A.budget_amount, B.amount_spent_to_date, C.amount_spent_between_dates "
          "from temp_budget_summary1 A inner join temp_budget_summary1 B "
          "        on A.current_statement = 1 and B.current_statement = 2 and "
          "           B.fund_id = A.fund_id and B.budget_id = A.budget_id and B.department_id = A.department_id "
          "     inner join temp_budget_summary1 C "
          "        on B.current_statement = 2 and C.current_statement = 3 and "
          "           C.fund_id = B.fund_id and C.budget_id = B.budget_id and C.department_id = B.department_id "
          "     left join acc_level_one on A.fund_id = acc_level_one.id "
          "     left join acc_level_two on A.budget_id = acc_level_two.id "
          "     left join acc_level_three on A.department_id = acc_level_three.id ";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(6);

    dbTransaction->Commit();
    dbTransaction->StartTransaction();

    // Create the report
    FORM_TRY
      TformReportBudget * bsReport = new TformReportBudget(NULL);
      bsReport->is_summary = true;
      // Set the date from/to since that's the only thing the report doesn't have access to
      bsReport->lblDateTitle->Caption = date_title.c_str();
      dbTransaction->DefaultDatabase = dbDatabase;
      dbTransaction->Active = true;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      sql = "select * from temp_budget_summary2 order by fund_id, department_id, budget_id";
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();
      bsReport->reportBudget->DataSet = dbDataSet;
      bsReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      bsReport->txtLineItem->DataSet = dbDataSet;
      bsReport->txtLineItem->DataField = "line_item";
      bsReport->exprBudgetAmount->Expression = "FORMATNUMERIC('$###,###,##0.00', budget_amount)";
      bsReport->exprAmountSpent->Expression = "FORMATNUMERIC('$###,###,##0.00', amount_spent_to_date)";
      bsReport->exprAmountRemaining->Expression = "FORMATNUMERIC('$###,###,##0.00', budget_amount - amount_spent_to_date)";
      bsReport->exprPercentSpent->Expression = "FORMATNUMERIC('##0.00', amount_spent_to_date / budget_amount * 100)";
      Processing(false);
      bsReport->reportBudget->Preview();
    FORM_CATCH

    sql = "delete from temp_budget_summary1";
    ExecuteStatement(dbTransaction, sql);
    sql = "delete from temp_budget_summary2";
    ExecuteStatement(dbTransaction, sql);

    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
// Detail
//---------------------------------------------------------------------------
void TformLaunchBudgetReport::RunDetailBudgetReport()
{
  Processing(true);

  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);

  try
  {
    // Set up transaction for use of temp tables
    dbTransaction->DefaultDatabase = dbDatabase;
    dbTransaction->StartTransaction();

    bool is_exact = checkIsExactMatch->Enabled && checkIsExactMatch->Checked;
    vector<string> acct_req;
    map<string, string> account_parts = PartsByMask (maskAccount);

    if (checkByMask->Checked)
      for (map<string, string>::iterator i_part = account_parts.begin(); i_part != account_parts.end(); i_part++)
       if (!is_exact && i_part->second.find_first_not_of ("0") == string::npos)
         acct_req.push_back("");
       else
//         acct_req.push_back(" and acc_level_" + i_part->first + ".short_item = " + i_part->second + " ");
       {
        string acc_level = "acc_level_" + i_part->first;
        acct_req.push_back(" and " + acc_level + "_id in (select " + acc_level + ".id from " + acc_level + " where " + acc_level + ".short_item = '" + i_part->second + "') ");
       }

    // Run the SQL to fill the temp tables the report will be using
    string sql;

    sql = "delete from temp_budget_detail1";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(10);

    // dept/budget/fund_id and budget amount
    sql = "insert into temp_budget_detail1 "
          "select acc_level_one_id fund_id, acc_level_two_id budget_id, acc_level_three_id dept_id, 1, "
          "       sum(debit_amount - credit_amount), 0, 0, 0, ' ', 0, NULL "
          "from transactions inner join accounts on transactions.account_id = accounts.id and accounts.account_type_id = 4 and is_budget = 1 and transactions.task_id = 0 "
          // no no no, bad // "where transactions.effective_date >= '1/1/2002' "
          "where transactions.effective_date <= '" + end_date + "' ";
    for (unsigned int i = 0; i != acct_req.size(); i++)
       sql += acct_req[i];
    sql += "group by acc_level_one.id, acc_level_two.id, acc_level_three.id; ";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(11);

    // budget to date
    sql = "insert into temp_budget_detail1 "
          "select acc_level_one_id fund_id, acc_level_two_id budget_id, acc_level_three_id dept_id, 2, "
          "       0, sum(debit_amount - credit_amount), 0, 0, ' ', 0, NULL "
          "from transactions inner join accounts on transactions.account_id = accounts.id and accounts.account_type_id = 4 and is_budget = 0 and transactions.task_id = 0 "
          "where " // no no no, bad // transactions.effective_date >= '1/1/2002' and "
          "      transactions.effective_date <= '" + end_date + "' ";
    for (unsigned int i = 0; i != acct_req.size(); i++)
       sql += acct_req[i];
    sql += "group by acc_level_one.id, acc_level_two.id, acc_level_three.id; ";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(12);

    // transactions on a bill on a PR: use PR tax entity and date_sent (and get PR number and check number of course)
    sql = "insert into temp_budget_detail1 "
          "select acc_level_one_id fund_id, acc_level_two_id budget_id, acc_level_three_id dept_id, 3, "
          "       0, 0, sum(debit_amount - credit_amount), purchase_req_number, tax_entities.name, check_number, purchase_reqs.date_sent "
          "from transactions inner join accounts on transactions.account_id = accounts.id and accounts.account_type_id = 4 and is_budget = 0 and transactions.task_id = 0 "
          "                  inner join bills on bills.id = transactions.bill_id and transactions.bill_id != 0 "
          "                  inner join purchase_reqs on purchase_reqs.id = bills.purchase_req_id and bills.purchase_req_id > 0 "
          "                  left join tax_entities on purchase_reqs.tax_entity_id = tax_entities.id "
          "                  left join checks on purchase_reqs.check_id = checks.id "
          "where purchase_reqs.date_sent between '" + begin_date + "' and '" + end_date + "' ";
          // Philip says no: (transactions.effective_date between '" + begin_date + "' and '" + end_date + "') or "
    for (unsigned int i = 0; i != acct_req.size(); i++)
       sql += acct_req[i];
    sql += "group by acc_level_one.id, acc_level_two.id, acc_level_three.id, purchase_req_number, purchase_reqs.date_sent, tax_entities.name, check_number ";
//    sql += "order by acc_level_one.id, acc_level_two.id, acc_level_three.id, purchase_req_number, purchase_reqs.date_sent, tax_entities.name, check_number; ";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(13);

    // transactions on a bill not on a PR: use bill actual tax entity and bill_date
    sql = "insert into temp_budget_detail1 "
          "select acc_level_one_id fund_id, acc_level_two_id budget_id, acc_level_three_id dept_id, 3, "
          "       0, 0, sum(debit_amount - credit_amount), 0, tax_entities.name, 0, bills.bill_date "
          "from transactions inner join accounts on transactions.account_id = accounts.id and accounts.account_type_id = 4 and is_budget = 0 and transactions.task_id = 0 "
          "                  inner join bills on bills.id = transactions.bill_id and transactions.bill_id != 0 and bills.purchase_req_id = 0 "
          "                  left join tax_entities on bills.actual_tax_id = tax_entities.id "
          "where bills.bill_date between '" + begin_date + "' and '" + end_date + "' ";
          // Philip says no: (transactions.effective_date between '" + begin_date + "' and '" + end_date + "') or "
    for (unsigned int i = 0; i != acct_req.size(); i++)
       sql += acct_req[i];
    sql += "group by acc_level_one.id, acc_level_two.id, acc_level_three.id, bills.bill_date, tax_entities.name ";
//    sql += "order by acc_level_one.id, acc_level_two.id, acc_level_three.id, bills.bill_date, tax_entities.name; ";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(14);

    // transactions not on a bill: use '(Budget Adjusting Entry)' and effective_date
    sql = "insert into temp_budget_detail1 "
          "select acc_level_one_id fund_id, acc_level_two_id budget_id, acc_level_three_id dept_id, 3, "
          "       0, 0, sum(debit_amount - credit_amount), 0, '(Budget Adjustment: tx #' || cast(transactions.id as varchar(25)) || ')', 0, transactions.effective_date "
          "from transactions inner join accounts on transactions.account_id = accounts.id and accounts.account_type_id = 4 and is_budget = 0 and transactions.bill_id = 0 and transactions.task_id = 0 "
          "where transactions.effective_date between '" + begin_date + "' and '" + end_date + "' ";
    for (unsigned int i = 0; i != acct_req.size(); i++)
       sql += acct_req[i];
    sql += "group by acc_level_one.id, acc_level_two.id, acc_level_three.id, transactions.effective_date ";
//    sql += "order by acc_level_one.id, acc_level_two.id, acc_level_three.id, transactions.effective_date; ";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(15);

    sql = "delete from temp_budget_detail2";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(16);

    sql = "insert into temp_budget_detail2 "
          "select A.fund_id, A.budget_id, A.department_id, "
          "       acc_level_one.short_item || ' - ' || acc_level_one.item || ' - Department  ' || acc_level_three.short_item || ' - ' || acc_level_three.item title, "
          "       acc_level_two.short_item || ' - ' || acc_level_two.item line_item, "
          "       A.budget_amount, B.amount_spent_to_date, C.amount_spent_between_dates, C.pr_Number, C.provider, C.check_number, C.active_date "
          "from temp_budget_detail1 A inner join temp_budget_detail1 B "
          "        on A.current_statement = 1 and B.current_statement = 2 and "
          "           B.fund_id = A.fund_id and B.budget_id = A.budget_id and B.department_id = A.department_id "
          "     inner join temp_budget_detail1 C "
          "        on B.current_statement = 2 and C.current_statement = 3 and "
          "           C.fund_id = B.fund_id and C.budget_id = B.budget_id and C.department_id = B.department_id "
          "     left join acc_level_one on A.fund_id = acc_level_one.id "
          "     left join acc_level_two on A.budget_id = acc_level_two.id "
          "     left join acc_level_three on A.department_id = acc_level_three.id ";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(17);

    dbTransaction->Commit();
    dbTransaction->StartTransaction();

    // Create the report
    FORM_TRY
      TformReportBudget * bsReport = new TformReportBudget(NULL);
      bsReport->is_summary = false;
      // Set the date from/to since that's the only thing the report doesn't have access to
      bsReport->lblDateTitle->Caption = date_title.c_str();
      dbTransaction->DefaultDatabase = dbDatabase;
      dbTransaction->Active = true;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      sql = "select * from temp_budget_detail2 order by fund_id, department_id, budget_id, pr_number, provider, active_date ";
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();
      bsReport->reportBudget->DataSet = dbDataSet;
      bsReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      bsReport->txtLineItem->DataSet = dbDataSet;
      bsReport->txtLineItem->DataField = "line_item";
      bsReport->textEntityName->DataSet   = dbDataSet;
      bsReport->textEntityName->DataField = "provider";
      bsReport->exprPRNumber->Expression = "pr_number";
      bsReport->exprDate->Expression = "active_date";
      bsReport->exprInvoiceAmount->Expression = "FORMATNUMERIC('$###,###,##0.00', amount_spent_between_dates)";
      bsReport->exprCheckNumber->Expression = "check_number";
      bsReport->exprBudgetAmount->Expression = "FORMATNUMERIC('$###,###,##0.00', budget_amount)";
      bsReport->exprAmountSpent->Expression = "FORMATNUMERIC('$###,###,##0.00', amount_spent_to_date)";
      bsReport->exprAmountRemaining->Expression = "FORMATNUMERIC('$###,###,##0.00', budget_amount - amount_spent_to_date)";
      bsReport->exprPercentSpent->Expression = "FORMATNUMERIC('##0.00', amount_spent_to_date / budget_amount * 100)";
//      bsReport->exprTotalAmountSpent->Expression = "FORMATNUMERIC('$###,###,##0.00', SUM(amount_spent_to_date))";
      Processing(false);
      bsReport->reportBudget->Preview();
    FORM_CATCH

    sql = "delete from temp_budget_detail1";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(18);
    sql = "delete from temp_budget_detail2";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(19);

    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
*/
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// New Summary
//---------------------------------------------------------------------------
void TformLaunchBudgetReport::RunNewSummaryBudgetReport()
{
  Processing(true);

  string sql;
  string date_title = "Budgets as of " + end_date + " and " + ((radioExpense->Checked) ? "Expenses" : "Revenues") + " between " + begin_date + " and " + end_date + string(", using ") + ((radioEffective->Checked) ? "Effective (service)" : "Fiscal") + string(" Dates");

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);

  progress_container z;

  try
  {
    StdTransaction(dbTransaction, dbDatabase);

    z.Mark("transaction started");

    sql = "delete from temp_budget_summary1";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(20);

    z.Mark("temp_budget_summary cleared");

    // dept/budget/fund_id and budget amount
    // also grabs expenses to date ... all in one query, rather than two. (only difference was is_budget anyway!)
    sql = "insert into temp_budget_summary1 "
          "select " +
          ((use_one) ? string("acc_level_one.id, ") : string("0, ")) +
          ((use_two) ? string("acc_level_two.id, ") : string("0, ")) +
          ((use_three) ? string("acc_level_three.id, ") : string("0, ")) +
          ((use_four) ? string("acc_level_four.id, ") : string("0, ")) +
          "accounts.is_budget, "
          "sum(" + deb_cred + "), 0, 0 "
          "from accounts "
          "inner join acc_level_one   on accounts.acc_level_one_id   = acc_level_one.id   "
          "inner join acc_level_two   on accounts.acc_level_two_id   = acc_level_two.id   "
          "inner join acc_level_three on accounts.acc_level_three_id = acc_level_three.id "
          "inner join acc_level_four  on accounts.acc_level_four_id  = acc_level_four.id  "
          "left join transactions on transactions.account_id = accounts.id "
          "and transactions." + date_field + " <= '" + end_date + "' "
          "and (accounts.is_budget = 1 or transactions." + date_field + " >= '" + begin_date + "') ";
    // sql += acct_req;
    sql += join_clause;
    sql += " where 1=1 " + where_clause;
    sql += "group by " +
           ((use_one) ? string("acc_level_one.id, ") : string("")) +
           ((use_two) ? string("acc_level_two.id, ") : string("")) +
           ((use_three) ? string("acc_level_three.id, ") : string("")) +
           ((use_four) ? string("acc_level_four.id, ") : string("")) +
           "accounts.is_budget";

    { string plan; if (GetSqlPlan (dbTransaction, sql, plan)) { plan = TranslateSqlPlan(dbTransaction, plan); z.Mark("\nSQL:\n" + sql + "\n\nPLAN:\n" + plan); } }

    DebugSql(this, &sql, other_forms, 9, dbTransaction);
    if (!ExecuteStatement(dbTransaction, sql))
     throw(21);

    // TODO: speed problem is above!
    z.Mark("inserted into temp_budget_summary1");

    sql = "delete from temp_budget_summary2";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(22);

    z.Mark("temp_budget_summary2 cleared");

    // TODO: this insert could be avoided if we trusted aliases so the report could pull from the select directly (only an order by is added while running the report)
    // TODO: inner join? is that good enough? already changed above to a 'accounts left transactions' rather than 'transactions left accounts'

          // "acc_level_one.short_item || ' - ' || acc_level_one.item || ' - Department  ' || acc_level_three.short_item || ' - ' || acc_level_three.item title, "
          // "acc_level_two.short_item || ' - ' || acc_level_two.item line_item, "

    sql = "insert into temp_budget_summary2 "
          "select "
          "A.fund_id, "
          "A.budget_id, "
          "A.department_id, "
          "A.subdept_id, "
          "'' " +
           (checkBreakPageOne->Checked ? string("|| 'Fund ' || acc_level_one.short_item || ': ' || acc_level_one.item || ' ' ") : string ("")) +
           (checkBreakPageTwo->Checked ? string("|| 'Line ' || acc_level_two.short_item || ': ' || acc_level_two.item || ' ' ") : string ("")) +
           (checkBreakPageThree->Checked ? string("|| 'Dept ' || acc_level_three.short_item || ': ' || acc_level_three.item || ' ' ") : string ("")) +
           (checkBreakPageFour->Checked ? string("|| 'Sub ' || acc_level_four.short_item || ': ' || acc_level_four.item || ' ' ") : string ("")) +
          ", '' " +
           (checkBreakSectionOne->Checked ? string("|| acc_level_one.short_item || ': ' || acc_level_one.item || ' ' ") : string ("")) +
           (checkBreakSectionTwo->Checked ? string("|| acc_level_two.short_item || ': ' || acc_level_two.item || ' ' ") : string ("")) +
           (checkBreakSectionThree->Checked ? string("|| acc_level_three.short_item || ': ' || acc_level_three.item || ' ' ") : string ("")) +
           (checkBreakSectionFour->Checked ? string("|| acc_level_four.short_item || ': ' || acc_level_four.item || ' ' ") : string ("")) +
          ", "
          "A.budget_amount, B.budget_amount, 0.00 "
          "from temp_budget_summary1 A "
          "inner join temp_budget_summary1 B "
          "on A.current_statement = 1 and B.current_statement = 0 and "
          "B.fund_id = A.fund_id and "
          "B.budget_id = A.budget_id and "
          "B.department_id = A.department_id and "
          "B.subdept_id = A.subdept_id "
          "left join acc_level_one on A.fund_id = acc_level_one.id "
          "left join acc_level_two on A.budget_id = acc_level_two.id "
          "left join acc_level_three on A.department_id = acc_level_three.id "
          "left join acc_level_four on A.subdept_id = acc_level_four.id ";

    { string plan; if (GetSqlPlan (dbTransaction, sql, plan)) { plan = TranslateSqlPlan(dbTransaction, plan); z.Mark("\nSQL:\n" + sql + "\n\nPLAN:\n" + plan); } }

    DebugSql(this, &sql, other_forms, 9, dbTransaction);
    if (!ExecuteStatement(dbTransaction, sql))
     throw(23);

    z.Mark("inserted into temp_budget_summary2");

    // Create the report
    FORM_TRY
      TformReportBudget * bsReport = new TformReportBudget(NULL);
      SetupReportBreaks(bsReport);
      bsReport->is_summary = true;
      // Set the date from/to since that's the only thing the report doesn't have access to
      bsReport->lblDateTitle->Caption = date_title.c_str();
      dbTransaction->DefaultDatabase = dbDatabase;
      dbTransaction->Active = true;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      sql = "select temp_budget_summary2.* from temp_budget_summary2 "
            "left join acc_level_one on acc_level_one.id = fund_id "
            "left join acc_level_two on acc_level_two.id = budget_id "
            "left join acc_level_three on acc_level_three.id = department_id "
            "left join acc_level_four on acc_level_four.id = subdept_id "
            "order by acc_level_one.short_item, acc_level_three.short_item, acc_level_two.short_item, acc_level_four.short_item";

      { string plan; if (GetSqlPlan (dbTransaction, sql, plan)) { plan = TranslateSqlPlan(dbTransaction, plan); z.Mark("\nSQL:\n" + sql + "\n\nPLAN:\n" + plan); } }

      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      z.Mark("opened final dataset");

      bsReport->reportBudget->DataSet = dbDataSet;
      bsReport->txtLineItem->DataSet  = dbDataSet;
      bsReport->lblUser->Caption                = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      bsReport->txtLineItem->DataField          = "line_item";
      bsReport->exprBudgetAmount->Expression    = "FORMATNUMERIC('$###,###,##0.00', budget_amount)";
      bsReport->exprAmountSpent->Expression     = "FORMATNUMERIC('$###,###,##0.00', amount_spent_to_date)";
      bsReport->exprAmountRemaining->Expression = "FORMATNUMERIC('$###,###,##0.00', budget_amount - amount_spent_to_date)";
      // bsReport->exprPercentSpent->Expression    = "FORMATNUMERIC('##0.00', amount_spent_to_date / budget_amount * 100)";
      Processing(false);
      bsReport->reportBudget->Preview();
    FORM_CATCH

    ViewSql(z.Report()); // hack. yup.

    sql = "delete from temp_budget_summary1";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(24);
    sql = "delete from temp_budget_summary2";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(25);

    dbTransaction->Commit();
  }
  catch (int oops)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK, "oops number: " + IntToString(oops) + "; last_sql_lib_error: " + last_sql_lib_error.message);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK, "oops number: none; last_sql_lib_error: " + last_sql_lib_error.message);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
// New Detail
//---------------------------------------------------------------------------
void TformLaunchBudgetReport::RunNewDetailBudgetReport()
{
  Processing(true);

  progress_container z;

  string sql;
  string date_title = "Budgets as of " + end_date + " and " + ((radioExpense->Checked) ? "Expenses" : "Revenues") + " between " + begin_date + " and " + end_date + string(", using ") + ((radioEffective->Checked) ? "Effective (service)" : "Fiscal") + string(" Dates");

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);

  try
  {
    StdTransaction(dbTransaction, dbDatabase);

    z.Mark("transaction started");

    sql = "delete from temp_budget_new_detail where statement_num < 3";
    DebugSql(this, &sql, other_forms, 9, dbTransaction);
    if (!ExecuteStatement(dbTransaction, sql))
     throw(30);

    z.Mark("temp_budget_new_detail cleared < 3");

    // dept/budget/fund_id and budget amount
    sql = "insert into temp_budget_new_detail "
          "select " +
          ((use_one) ? string("acc_level_one.id, ") : string("0, ")) +
          ((use_two) ? string("acc_level_two.id, ") : string("0, ")) +
          ((use_three) ? string("acc_level_three.id, ") : string("0, ")) +
          ((use_four) ? string("acc_level_four.id, ") : string("0, ")) +
          "'', '', "
          "sum(" + deb_cred + "), 0, 0, 0, accounts.is_budget, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL "
          "from accounts "
          "inner join acc_level_one   on accounts.acc_level_one_id   = acc_level_one.id   "
          "inner join acc_level_two   on accounts.acc_level_two_id   = acc_level_two.id   "
          "inner join acc_level_three on accounts.acc_level_three_id = acc_level_three.id "
          "inner join acc_level_four  on accounts.acc_level_four_id  = acc_level_four.id  "
          "left join transactions on transactions.account_id = accounts.id "
          "and ((accounts.is_budget = 1 and transactions." + date_field + " <= '" + end_date + "') "
          "   or (accounts.is_budget = 0 and transactions." + date_field + " between '" + begin_date + "' and '" + end_date + "')) ";
    // sql += acct_req;
    sql += join_clause;
    sql += " where 1=1 " + where_clause;
    sql += "group by " +
           ((use_one) ? string("acc_level_one.id, ") : string("")) +
           ((use_two) ? string("acc_level_two.id, ") : string("")) +
           ((use_three) ? string("acc_level_three.id, ") : string("")) +
           ((use_four) ? string("acc_level_four.id, ") : string("")) +
           "accounts.is_budget";

    { string plan; if (GetSqlPlan (dbTransaction, sql, plan)) { plan = TranslateSqlPlan(dbTransaction, plan); z.Mark("\nSQL:\n" + sql + "\n\nPLAN:\n" + plan); } }

    DebugSql(this, &sql, other_forms, 9, dbTransaction);
    if (!ExecuteStatement(dbTransaction, sql))
     throw(31);

    z.Mark("inserted into temp_budget_new_detail: budget amounts");

    sql = "insert into temp_budget_new_detail "
          "select " +
          ((use_one) ? string("acc_level_one.id, ") : string("0, ")) +
          ((use_two) ? string("acc_level_two.id, ") : string("0, ")) +
          ((use_three) ? string("acc_level_three.id, ") : string("0, ")) +
          ((use_four) ? string("acc_level_four.id, ") : string("0, ")) +
          "'', '', "
          "sum(" + deb_cred + "), 0, 0, 0, 2, "
          "checks.id, checks.check_number, checks.date_sent, "
          "purchase_reqs.id, purchase_reqs.purchase_req_number, purchase_reqs.date_sent, "
          "bills.id, bills.invoice_number, bills.bill_date, "
          "transactions." + date_field + ", tax_entities.id, tax_entities.name "
          "from accounts "
          "inner join acc_level_one   on accounts.acc_level_one_id   = acc_level_one.id   "
          "inner join acc_level_two   on accounts.acc_level_two_id   = acc_level_two.id   "
          "inner join acc_level_three on accounts.acc_level_three_id = acc_level_three.id "
          "inner join acc_level_four  on accounts.acc_level_four_id  = acc_level_four.id  "
          "left join transactions on transactions.account_id = accounts.id "
          "and transactions." + date_field + " between '" + begin_date + "' and '" + end_date + "' "
          "left join tax_entities on tax_entities.id = transactions.tax_entity_id and transactions.tax_entity_id > 0 "
          "left join bills on bills.id = transactions.bill_id and transactions.bill_id > 0 "
          "left join purchase_reqs on purchase_reqs.id = bills.purchase_req_id and bills.purchase_req_id > 0 "
          "left join checks on checks.id = purchase_reqs.check_id and purchase_reqs.check_id > 0 "
          "where accounts.is_budget = 0 ";
    sql += acct_req;
    sql += "group by " +
           ((use_one) ? string("acc_level_one.id, ") : string("")) +
           ((use_two) ? string("acc_level_two.id, ") : string("")) +
           ((use_three) ? string("acc_level_three.id, ") : string("")) +
           ((use_four) ? string("acc_level_four.id, ") : string("")) +
           "checks.id, checks.check_number, checks.date_sent, "
           "purchase_reqs.id, purchase_reqs.purchase_req_number, purchase_reqs.date_sent, "
           "bills.id, bills.invoice_number, bills.bill_date, "
           "transactions." + date_field + ", tax_entities.id, tax_entities.name ";

    { string plan; if (GetSqlPlan (dbTransaction, sql, plan)) { plan = TranslateSqlPlan(dbTransaction, plan); z.Mark("\nSQL:\n" + sql + "\n\nPLAN:\n" + plan); } }

    DebugSql(this, &sql, other_forms, 9, dbTransaction);
    if (!ExecuteStatement(dbTransaction, sql))
     throw(32);

    z.Mark("inserted into temp_budget_new_detail: expense amounts");

    /*
    // transactions on a bill on a PR: use PR tax entity and date_sent (and get PR number and check number of course)
    sql = "insert into temp_budget_detail1 "
          "select acc_level_one.id fund_id, acc_level_two.id budget_id, acc_level_three.id dept_id, 3, "
          "       0, 0, sum(debit_amount - credit_amount), purchase_req_number, tax_entities.name, check_number, purchase_reqs.date_sent "
          "from transactions left join accounts on transactions.account_id = accounts.id and accounts.account_type_id = 4 and is_budget = 0 "
          "                  left join acc_level_one on accounts.acc_level_one_id = acc_level_one.id "
          "                  left join acc_level_two on accounts.acc_level_two_id = acc_level_two.id "
          "                  left join acc_level_three on accounts.acc_level_three_id = acc_level_three.id "
          "                  left join acc_level_four on accounts.acc_level_four_id = acc_level_four.id "
          "                  inner join bills on bills.id = transactions.bill_id and transactions.bill_id != 0 "
          "                  inner join purchase_reqs on purchase_reqs.id = bills.purchase_req_id and bills.purchase_req_id > 0 "
          "                  left join tax_entities on purchase_reqs.tax_entity_id = tax_entities.id "
          "                  left join checks on purchase_reqs.check_id = checks.id "
          "where purchase_reqs.date_sent between '" + begin_date + "' and '" + end_date + "' ";
          // Philip says no: (transactions.effective_date between '" + begin_date + "' and '" + end_date + "') or "
    for (unsigned int i = 0; i != acct_req.size(); i++)
       sql += acct_req[i];
    sql += "group by acc_level_one.id, acc_level_two.id, acc_level_three.id, purchase_req_number, purchase_reqs.date_sent, tax_entities.name, check_number ";
//    sql += "order by acc_level_one.id, acc_level_two.id, acc_level_three.id, purchase_req_number, purchase_reqs.date_sent, tax_entities.name, check_number; ";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(33);

    // transactions on a bill not on a PR: use bill actual tax entity and bill_date
    sql = "insert into temp_budget_detail1 "
          "select acc_level_one.id fund_id, acc_level_two.id budget_id, acc_level_three.id dept_id, 3, "
          "       0, 0, sum(debit_amount - credit_amount), 0, tax_entities.name, 0, bills.bill_date "
          "from transactions left join accounts on transactions.account_id = accounts.id and accounts.account_type_id = 4 and is_budget = 0 "
          "                  left join acc_level_one on accounts.acc_level_one_id = acc_level_one.id "
          "                  left join acc_level_two on accounts.acc_level_two_id = acc_level_two.id "
          "                  left join acc_level_three on accounts.acc_level_three_id = acc_level_three.id "
          "                  left join acc_level_four on accounts.acc_level_four_id = acc_level_four.id "
          "                  inner join bills on bills.id = transactions.bill_id and transactions.bill_id != 0 and bills.purchase_req_id = 0 "
          "                  left join tax_entities on bills.actual_tax_id = tax_entities.id "
          "where bills.bill_date between '" + begin_date + "' and '" + end_date + "' ";
          // Philip says no: (transactions.effective_date between '" + begin_date + "' and '" + end_date + "') or "
    for (unsigned int i = 0; i != acct_req.size(); i++)
       sql += acct_req[i];
    sql += "group by acc_level_one.id, acc_level_two.id, acc_level_three.id, bills.bill_date, tax_entities.name ";
//    sql += "order by acc_level_one.id, acc_level_two.id, acc_level_three.id, bills.bill_date, tax_entities.name; ";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(34);

    // transactions not on a bill: use '(Budget Adjusting Entry)' and effective_date
    sql = "insert into temp_budget_detail1 "
          "select acc_level_one.id fund_id, acc_level_two.id budget_id, acc_level_three.id dept_id, 3, "
          "       0, 0, sum(debit_amount - credit_amount), 0, '(Budget Adjusting Entry)', 0, transactions.effective_date "
          "from transactions left join accounts on transactions.account_id = accounts.id and accounts.account_type_id = 4 and is_budget = 0 "
          "                  left join acc_level_one on accounts.acc_level_one_id = acc_level_one.id "
          "                  left join acc_level_two on accounts.acc_level_two_id = acc_level_two.id "
          "                  left join acc_level_three on accounts.acc_level_three_id = acc_level_three.id "
          "                  left join acc_level_four on accounts.acc_level_four_id = acc_level_four.id "
          "                  left join bills on bills.id = transactions.bill_id and transactions.bill_id = 0 "
          "where transactions.effective_date between '" + begin_date + "' and '" + end_date + "' ";
    for (unsigned int i = 0; i != acct_req.size(); i++)
       sql += acct_req[i];
    sql += "group by acc_level_one.id, acc_level_two.id, acc_level_three.id, transactions.effective_date ";
//    sql += "order by acc_level_one.id, acc_level_two.id, acc_level_three.id, transactions.effective_date; ";
    if (!ExecuteStatement(dbTransaction, sql))
     throw(35);
    */

    sql = "delete from temp_budget_new_detail where statement_num > 2";
    DebugSql(this, &sql, other_forms, 9, dbTransaction);
    if (!ExecuteStatement(dbTransaction, sql))
     throw(36);

    z.Mark("temp_budget_new_detail cleared > 2");

    // A: budgets (is_budget = 1)
    // B: total expenses/revenue (is_budget = 0)
    // C: detail rows (statement_num is 2)
    // in all cases, there should be at least one row per account that is being searched
    sql = "insert into temp_budget_new_detail "
          "select "
          "A.fund_id, "
          "A.budget_id, "
          "A.department_id, "
          "A.subdept_id, "
          "'' " +
           (checkBreakPageOne->Checked ? string("|| 'Fund ' || acc_level_one.short_item || ': ' || acc_level_one.item || ' ' ") : string ("")) +
           (checkBreakPageTwo->Checked ? string("|| 'Line ' || acc_level_two.short_item || ': ' || acc_level_two.item || ' ' ") : string ("")) +
           (checkBreakPageThree->Checked ? string("|| 'Dept ' || acc_level_three.short_item || ': ' || acc_level_three.item || ' ' ") : string ("")) +
           (checkBreakPageFour->Checked ? string("|| 'Sub ' || acc_level_four.short_item || ': ' || acc_level_four.item || ' ' ") : string ("")) +
          ", '' " +
           (checkBreakSectionOne->Checked ? string("|| acc_level_one.short_item || ': ' || acc_level_one.item || ' ' ") : string ("")) +
           (checkBreakSectionTwo->Checked ? string("|| acc_level_two.short_item || ': ' || acc_level_two.item || ' ' ") : string ("")) +
           (checkBreakSectionThree->Checked ? string("|| acc_level_three.short_item || ': ' || acc_level_three.item || ' ' ") : string ("")) +
           (checkBreakSectionFour->Checked ? string("|| acc_level_four.short_item || ': ' || acc_level_four.item || ' ' ") : string ("")) +
          ", "
          "0, A.amount, B.amount, C.amount, 3, "
          "C.check_id, C.check_number, C.check_date, "
          "C.pr_id, C.pr_number, C.pr_date, "
          "C.bill_id, C.bill_number, C.bill_date, "
          "C.tx_date, C.entity_id, C.entity_name "
          "from temp_budget_new_detail A "
          "left join temp_budget_new_detail B "
          // "on A.statement_num = 1 and B.statement_num = 0 "
          "on B.statement_num = 0 "
          "and B.fund_id = A.fund_id and B.budget_id = A.budget_id and B.department_id = A.department_id and B.subdept_id = A.subdept_id "
          "left join temp_budget_new_detail C "
          // "on A.statement_num = 1 and C.statement_num = 2 "
          "on C.statement_num = 2 "
          "and C.fund_id = A.fund_id and C.budget_id = A.budget_id and C.department_id = A.department_id and C.subdept_id = A.subdept_id "
          "left join acc_level_one on A.fund_id = acc_level_one.id "
          "left join acc_level_two on A.budget_id = acc_level_two.id "
          "left join acc_level_three on A.department_id = acc_level_three.id "
          "left join acc_level_four on A.subdept_id = acc_level_four.id "
          "where A.statement_num = 1";

    { string plan; if (GetSqlPlan (dbTransaction, sql, plan)) { plan = TranslateSqlPlan(dbTransaction, plan); z.Mark("\nSQL:\n" + sql + "\n\nPLAN:\n" + plan); } }

    DebugSql(this, &sql, other_forms, 9, dbTransaction);
    if (!ExecuteStatement(dbTransaction, sql))
     throw(37);

    z.Mark("inserted into temp_budget_new_detail: budget-to-expense join");

    // dbTransaction->Commit();
    // dbTransaction->StartTransaction();

    // Create the report
    FORM_TRY
      TformReportBudget * bsReport = new TformReportBudget(NULL);
      SetupReportBreaks(bsReport);
      bsReport->is_summary = false;
      // Set the date from/to since that's the only thing the report doesn't have access to
      bsReport->lblDateTitle->Caption = date_title.c_str();
      dbTransaction->DefaultDatabase = dbDatabase;
      dbTransaction->Active = true;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      string raw_order = comboOrder->Text.c_str();
      raw_order = ReplaceStringWithString(raw_order, "check", "check_number");
      raw_order = ReplaceStringWithString(raw_order, "purchase request", "pr_number");
      raw_order = ReplaceStringWithString(raw_order, "bill", "bill_number");
      raw_order = ReplaceStringWithString(raw_order, "date", "tx_date");
      raw_order = ReplaceStringWithString(raw_order, "name", "entity_name");

      sql = "select temp_budget_new_detail.* from temp_budget_new_detail "
            "left join acc_level_one on acc_level_one.id = fund_id "
            "left join acc_level_two on acc_level_two.id = budget_id "
            "left join acc_level_three on acc_level_three.id = department_id "
            "left join acc_level_four on acc_level_four.id = subdept_id "
            "where statement_num = 3 order by acc_level_one.short_item, acc_level_three.short_item, acc_level_two.short_item, acc_level_four.short_item, " +
            raw_order /* "check_number, pr_number, bill_number, tx_date, entity_name " */;

      { string plan; if (GetSqlPlan (dbTransaction, sql, plan)) { plan = TranslateSqlPlan(dbTransaction, plan); z.Mark("\nSQL:\n" + sql + "\n\nPLAN:\n" + plan); } }

      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      z.Mark("opened final dataset");

      bsReport->reportBudget->DataSet = dbDataSet;
      bsReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();

      bsReport->txtLineItem->DataSet      = dbDataSet;
      bsReport->txtLineItem->DataField    = "line_item";
      bsReport->textEntityName->DataSet   = dbDataSet;
      bsReport->textEntityName->DataField = "entity_name";

      bsReport->exprCheckNumber->Expression = "check_number";
      bsReport->exprPRNumber->Expression    = "pr_number";
      bsReport->exprBillNumber->Expression  = "bill_number";
      bsReport->exprDate->Expression        = "tx_date";
      bsReport->exprInvoiceAmount->Expression   = "FORMATNUMERIC('$###,###,##0.00', tx_amount)";
      bsReport->exprBudgetAmount->Expression    = "FORMATNUMERIC('$###,###,##0.00', budget_amount)";
      bsReport->exprAmountSpent->Expression     = "FORMATNUMERIC('$###,###,##0.00', current_amount)";
      bsReport->exprAmountRemaining->Expression = "FORMATNUMERIC('$###,###,##0.00', budget_amount - current_amount)";
      // bsReport->exprPercentSpent->Expression    = "FORMATNUMERIC('##0.00', 100.00 * current_amount / budget_amount)";
//    bsReport->exprTotalAmountSpent->Expression = "FORMATNUMERIC('$###,###,##0.00', SUM(amount_spent_to_date))";
      Processing(false);
      bsReport->reportBudget->Preview();
    FORM_CATCH

    ViewSql(z.Report());

    /* Removed temporarily so I can pull the data and drop it in Excel for reconciliation. */
    sql = "delete from temp_budget_new_detail";
    DebugSql(this, &sql, other_forms, 9, dbTransaction);
    if (!ExecuteStatement(dbTransaction, sql))
     throw(38);
    dbTransaction->Commit();
  }
  catch (int oops)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK, "oops number: " + IntToString(oops) + "; last_sql_lib_error: " + last_sql_lib_error.message);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK, "oops number: none; last_sql_lib_error: " + last_sql_lib_error.message);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchBudgetReport::buttonNewRunClick(TObject *Sender)
{
  // check validity of request before continuing

  Processing(true);

  join_clause = "";
  where_clause = "";

  acct_req      = "";
  begin_date    = Pdate(dateBeginDate->Date).OutDate(mdy | yyyy);
  end_date      = Pdate(dateEndDate->Date).OutDate(mdy | yyyy);
  date_field    = (radioEffective->Checked) ? "effective_date" : "fiscal_date";
  account_parts = PartsByMask (editAccountPattern);

  if (radioDetailed->Checked && comboOrder->ItemIndex == -1)
  {
   PSay("Please select a sort-order for the detailed items on the report.", m_missing_data, MB_OK);
   Processing(false);
   return;
  }

  if (comboCycle->Text != "" && !lookupTables->IsInLookUpTable("month_types", comboCycle))
  {
   PSay("Please enter a valid month for the 'cycle' field. It designates the month in which an account is expected to have budgets changed.", m_invalid_data, MB_OK);
   Processing(false);
   return;
  }

  if (Pdate(dateBeginDate->Date) > Pdate(dateEndDate->Date))
  {
   PSay("You have entered a 'begin' date that comes after your 'end' date. This is unlikely to be what you want.", m_invalid_data, MB_OK);
   Processing(false);
   return;
  }

  // warn them if ...
  // - begin date isn't x/1/year
  // - begin date isn't 1/1/year and 'cycle' is blank or january
  // - end date isn't within a year of begin date

  int required_month = 1;
  if (comboCycle->Text != "")
   required_month = StringToInt(lookupTables->IdOf("month_types", comboCycle->Text.c_str()));

  if (Pdate(dateBeginDate->Date).day != 1)
   if (IDNO == PSay("You have asked a report to start on a day other than the first of a month.\nAs budgets should always open on the first day of a month, it seems unlikely that your budgets and your expenses or revenues will be synchronized.\nWould you like to continue anyway?", m_warning, MB_YESNO))
   {
    Processing(false);
    return;
   }

  if (required_month != Pdate(dateBeginDate->Date).month)
   if (IDNO == PSay("A budget report will show you only the effect of non-budget transactions matching your date range.\nAs it stands, this report may show you more or less than you were expecting to see. Try to make sure your 'begin date' matches up with the 'cycles' restriction.\nThis will guarantee that you won't show expenses or revenues starting from a date other than when budgets should have started.\nWould you like to continue anyway?", m_warning, MB_YESNO))
   {
    Processing(false);
    return;
   }

  Pdate one_year_after_begin = Pdate(dateBeginDate->Date);
  one_year_after_begin.mod(+1, in_years);
  if (Pdate(dateEndDate->Date) > one_year_after_begin)
   if (IDNO == PSay("You are asking for a budget report that spans more than a year.\nAs year-end closing transactions and changes to budgets from year to year cannot be properly displayed, this is likely to cause trouble.\nWould you like to continue anyway?", m_warning, MB_YESNO))
   {
    Processing(false);
    return;
   }

  string sql_find_account_cycles = "select distinct accounts.bill_cycle_id from accounts "
                                   "inner join acc_level_one on acc_level_one.id = accounts.acc_level_one_id "
                                   "inner join acc_level_two on acc_level_two.id = accounts.acc_level_two_id "
                                   "inner join acc_level_three on acc_level_three.id = accounts.acc_level_three_id "
                                   "inner join acc_level_four on acc_level_four.id = accounts.acc_level_four_id "
                                   "where accounts.id > 0 ";
  if (radioExpense->Checked)
   sql_find_account_cycles += (" and account_type_id = " + lookupTables->IdOf("account_types", "Expense") + " ");
  else
   sql_find_account_cycles += (" and account_type_id = " + lookupTables->IdOf("account_types", "Revenue") + " ");

  // TODO -c REDUNDANT: this is done twice ... also done below.  Why?
  if (checkIgnoreDisabled->Checked)
  {
   acct_req += " and accounts.is_closed = 0 ";
   where_clause += "and accounts.is_closed = 0 ";
  }

  for (map<string, string>::iterator i_part = account_parts.begin(); i_part != account_parts.end(); i_part++)
   if (checkExactMatch->Checked || i_part->second.find_first_not_of ("0") != string::npos)
    sql_find_account_cycles += (" and acc_level_" + i_part->first + ".short_item = '" + i_part->second + "' ");
  vector<string> found_months;
  if (!SqlToVec(dbDatabase, sql_find_account_cycles, found_months))
  {
   PSay("Failed to verify the sanity of the account number / cycle combination.", m_database_error, MB_OK);
   Processing(false);
   return;
  } else
  {
   if (found_months.empty())
   {
    PSay("There are no accounts matching the account number / type (everything but the 'cycle') description given.", m_warning, MB_OK);
    Processing(false);
    return;
   } else
   if (found_months.size() > 1)
   {
    vector<string> month_names;
    for (vector<string>::iterator i_m = found_months.begin(); i_m != found_months.end(); i_m++)
     month_names.push_back(lookupTables->ValueOf("month_types", *i_m));

    if (comboCycle->Text != "")
    {
     bool is_included = false;
     string looking_for = lookupTables->IdOf("month_types", comboCycle->Text.c_str());
     for (vector<string>::iterator i_m = found_months.begin(); i_m != found_months.end(); i_m++)
     {
      if (*i_m == looking_for)
      {
       is_included = true;
       break;
      }
     }

     string message_to_give;
     if (is_included)
      message_to_give = "The accounts matching the account number / type description will cycle in several different months.\n(" + VecToCommaString(month_names) + ")\nOnly accounts cycling in " + lookupTables->ValueOf("month_types", looking_for) + " will be shown.\nAre you sure you want to continue?";
     else
      message_to_give = "The accounts matching the account number / type description will cycle in several different months, none of which are " + lookupTables->ValueOf("month_types", looking_for) + ".\n(" + VecToCommaString(month_names) + ")\nAre you sure you want to continue?";
     if (IDNO == PSay(message_to_give, m_confirmation, MB_YESNO))
     {
      Processing(false);
      return;
     }

    } else
    if (IDNO == PSay("The accounts matching the account number / type description will cycle in several different months.\n(" + VecToCommaString(month_names) + ")\nThis will make it difficult to get a good budget report.\nAre you sure you want to continue?", m_confirmation, MB_YESNO))
    {
     Processing(false);
     return;
    }
   } else
   {
    if (comboCycle->Text != "")
     if (found_months[0] != lookupTables->IdOf("month_types", comboCycle->Text.c_str()))
     {
      if (IDNO == PSay("The accounts matching the account number / type description will cycle in " + lookupTables->ValueOf("month_types", found_months[0]) + " rather than in " + string(comboCycle->Text.c_str()) + " as you requested.\nAre you sure you want to continue?", m_confirmation, MB_YESNO))
      {
       Processing(false);
       return;
      }
     }
   }
  }



  use_one   = checkBreakPageOne->Checked   || checkBreakSectionOne->Checked;
  use_two   = checkBreakPageTwo->Checked   || checkBreakSectionTwo->Checked;
  use_three = checkBreakPageThree->Checked || checkBreakSectionThree->Checked;
  use_four  = checkBreakPageFour->Checked  || checkBreakSectionFour->Checked;

/*
  if (!(use_one || use_two || use_three || use_four))
  {
   PSay("You have not selected any break points.", m_missing_data, MB_OK);
   Processing(false);
   return;
  }
*/

  // mask
  for (map<string, string>::iterator i_part = account_parts.begin(); i_part != account_parts.end(); i_part++)
   if (checkExactMatch->Checked || i_part->second.find_first_not_of ("0") != string::npos)
   {
    acct_req += (" and acc_level_" + i_part->first + ".short_item = '" + i_part->second + "' ");
    where_clause += (" and acc_level_" + i_part->first + ".short_item = '" + i_part->second + "' ");
   }
  // cycle
  if (comboCycle->Text != "")
  {
   acct_req += (" and accounts.bill_cycle_id = " + lookupTables->IdOf("month_types", comboCycle->Text.c_str()) + " ");
   where_clause += (" and accounts.bill_cycle_id = " + lookupTables->IdOf("month_types", comboCycle->Text.c_str()) + " ");
  }
  // type
  if (radioExpense->Checked)
  {
   acct_req += (" and account_type_id = " + lookupTables->IdOf("account_types", "Expense") + " ");
   where_clause += (" and account_type_id = " + lookupTables->IdOf("account_types", "Expense") + " ");
   deb_cred = "transactions.debit_amount - transactions.credit_amount";
  } else
  {
   acct_req += (" and account_type_id = " + lookupTables->IdOf("account_types", "Revenue") + " ");
   where_clause += (" and account_type_id = " + lookupTables->IdOf("account_types", "Revenue") + " ");
   deb_cred = "transactions.credit_amount - transactions.debit_amount";
  }
  // disabled
  // TODO -c REDUNDANT: this is done twice ... also done above.  Why?
  if (checkIgnoreDisabled->Checked)
  {
   acct_req += " and accounts.is_closed = 0 ";
   where_clause += " and accounts.is_closed = 0 ";
  }

  // always ignore these, i suppose -- or not.
  if (!checkIncludeTasks->Checked)
  {
   acct_req += " and transactions.task_id = 0 ";
   join_clause += " and transactions.task_id = 0 ";
  }

  // TODO: this should be fixed with a boolean in the db instead!
  if (!checkIncludeReversals->Checked)
  {
   acct_req += " and transactions.transaction_id != " + lookupTables->IdOf("transaction_types", "Closing Balance") + " ";
   join_clause += " and transactions.transaction_id != " + lookupTables->IdOf("transaction_types", "Closing Balance") + " ";
  }

  // PSay("acct_req: " + acct_req, m_debug, MB_OK);

  if(radioSummarized->Checked)
     RunNewSummaryBudgetReport();
  else if(radioDetailed->Checked)
     RunNewDetailBudgetReport();

  Processing(false);
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchBudgetReport::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("month_types", comboCycle);
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchBudgetReport::checkBreakAnyClick(
      TObject *Sender)
{
 if (checkBreakPageOne->Checked && checkBreakSectionOne->Checked)
  if (Sender == checkBreakPageOne)
   checkBreakSectionOne->Checked = false;
  else
   checkBreakPageOne->Checked = false;

 if (checkBreakPageTwo->Checked && checkBreakSectionTwo->Checked)
  if (Sender == checkBreakPageTwo)
   checkBreakSectionTwo->Checked = false;
  else
   checkBreakPageTwo->Checked = false;

 if (checkBreakPageThree->Checked && checkBreakSectionThree->Checked)
  if (Sender == checkBreakPageThree)
   checkBreakSectionThree->Checked = false;
  else
   checkBreakPageThree->Checked = false;

 if (checkBreakPageFour->Checked && checkBreakSectionFour->Checked)
  if (Sender == checkBreakPageFour)
   checkBreakSectionFour->Checked = false;
  else
   checkBreakPageFour->Checked = false;
}
//---------------------------------------------------------------------------
void TformLaunchBudgetReport::SetupReportBreaks(TformReportBudget * rep)
{
 if (!rep)
  return;

 rep->GroupHeaderBand->Expression  = "";
 rep->GroupHeaderBand2->Expression = "";

 vector<string> page_breaks;
 vector<string> section_breaks;

 if (checkBreakPageOne->Checked)
  page_breaks.push_back("STR(fund_id)");
 if (checkBreakPageTwo->Checked)
  page_breaks.push_back("STR(budget_id)");
 if (checkBreakPageThree->Checked)
  page_breaks.push_back("STR(department_id)");
 if (checkBreakPageFour->Checked)
  page_breaks.push_back("STR(subdept_id)");

 if (checkBreakSectionOne->Checked)
  section_breaks.push_back("STR(fund_id)");
 if (checkBreakSectionTwo->Checked)
  section_breaks.push_back("STR(budget_id)");
 if (checkBreakSectionThree->Checked)
  section_breaks.push_back("STR(department_id)");
 if (checkBreakSectionFour->Checked)
  section_breaks.push_back("STR(subdept_id)");

 rep->GroupHeaderBand->Expression  = VecToDelimString(page_breaks, "", "", " + ").c_str();
 rep->GroupHeaderBand2->Expression = VecToDelimString(section_breaks, "", "", " + ").c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchBudgetReport::comboOrderKeyPress(
      TObject *Sender, char &Key)
{
 FindComboBoxItemAndSetItemIndex(Sender, Key);
}
//---------------------------------------------------------------------------

