//---------------------------------------------------------------------------

#ifndef launchBudgetReportH
#define launchBudgetReportH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <Mask.hpp>
#include <ExtCtrls.hpp>
#include "reportBudget.h"
//---------------------------------------------------------------------------
class TformLaunchBudgetReport : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *btnClose;
        TGroupBox *groupReport;
        TGroupBox *groupDate;
        TGroupBox *groupAccount;
        TRadioButton *radioDetailed;
        TRadioButton *radioSummarized;
        TEdit *editAccountPattern;
        TCheckBox *checkExactMatch;
        TLabel *labelAccountLike;
        TBevel *bevelDates;
        TComboBox *comboCycle;
        TLabel *labelCycle;
        TRadioButton *radioExpense;
        TRadioButton *radioRevenue;
        TToolButton *buttonNewRun;
        TCheckBox *checkIgnoreDisabled;
        TGroupBox *groupBreaks;
        TCheckBox *checkBreakPageOne;
        TCheckBox *checkBreakPageTwo;
        TCheckBox *checkBreakPageThree;
        TCheckBox *checkBreakPageFour;
        TCheckBox *checkBreakSectionOne;
        TCheckBox *checkBreakSectionTwo;
        TCheckBox *checkBreakSectionThree;
        TCheckBox *checkBreakSectionFour;
        TLabel *_labelBreakPage;
        TLabel *_labelBreakSection;
        TLabel *_labelBreakOne;
        TLabel *_labelBreakTwo;
        TLabel *_labelBreakThree;
        TLabel *_labelBreakFour;
        TGroupBox *groupInclude;
        TCheckBox *checkIncludeTasks;
        TCheckBox *checkIncludeReversals;
        TLabel *_labelSuggestReversals;
        TPanel *panelDateFields;
        TRadioButton *radioEffective;
        TRadioButton *radioFiscal;
        TPanel *panelDateValues;
        TRadioButton *radioDumb;
        TLabel *labelBeginDate;
        TLabel *labelEndDate;
        TDateTimePicker *dateBeginDate;
        TDateTimePicker *dateEndDate;
        TRadioButton *radioSmart;
        TLabel *_labelAsOfDate;
        TDateTimePicker *dateAsOfDate;
        TGroupBox *groupDetailSort;
        TComboBox *comboOrder;
        void __fastcall btnCloseClick(TObject *Sender);
        void __fastcall FormShortCut(TWMKey &Msg, bool &Handled);
        void __fastcall buttonNewRunClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall checkBreakAnyClick(TObject *Sender);
        void __fastcall comboOrderKeyPress(TObject *Sender, char &Key);
private:	// User declarations
        // void RunSummaryBudgetReport();
        // void RunDetailBudgetReport();
        void RunNewSummaryBudgetReport();
        void RunNewDetailBudgetReport();
        void SetupReportBreaks(TformReportBudget * rep);

        bool use_one;
        bool use_two;
        bool use_three;
        bool use_four;

        string begin_date;
        string end_date;
        string date_field;
        string acct_req;

        string join_clause;
        string where_clause;

        string deb_cred;
        map<string, string> account_parts;

public:		// User declarations
        __fastcall TformLaunchBudgetReport(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TformLaunchBudgetReport *formLaunchBudgetReport;
//---------------------------------------------------------------------------
#endif
