//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchCareSummary.h"
#include "reportCareSummary.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchCareSummary *formLaunchCareSummary;
//---------------------------------------------------------------------------
__fastcall TformLaunchCareSummary::TformLaunchCareSummary(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  Pdate begin_date = CurrentPdate();
  begin_date.month = 1;
  begin_date.day = 1;
  dateBegin->Date = begin_date.OutDate();
  dateEnd->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchCareSummary::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchCareSummary::btnRunClick(TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);

  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbTransaction->Active = true;

    // dbTransaction->Commit();
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;

    // delete from temp tables
    string sql = "delete from temp_care_summary";
    ExecuteStatement(dbTransaction, sql);

    // education count
    /*
    string edu_count_sql = "select count(distinct(tasks.person_id)) "
                           "from com_health_edu "
                           "left join tasks on com_health_edu.task_id = tasks.id "
                           "where (com_health_edu.care_topic_id > 0 or com_health_edu.care_classification_id > 0) and "
                           "(tasks.date_of_task between '" + begin_date + "' and '" + end_date + "'); ";
    string edu_count = GetOneField(dbTransaction, edu_count_sql);
    */

    // respite care client count
    /*
    string respite_count_sql = "select count(distinct(person_id)) from enrollment "
                               "where enrollment.current_id+1 >= 4 and enrollment.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Caregiver Client") + "' ";
    string respite_count = GetOneField(dbTransaction, respite_count_sql);
    */
    string service_units;
    service_units  = "insert into temp_care_summary "
                   "select care_service_types.id, care_service_types.item, count(distinct(tasks.id)), count(distinct(tasks.person_id)) "
                   "from care_service_types "
                   "left join tasks_to_care_services on tasks_to_care_services.care_service_id = care_service_types.id "
                   "left join tasks on tasks_to_care_services.task_id = tasks.id "
                   "     and (tasks.date_of_task between '" + begin_date + "' and '" + end_date + "') "
                   "where (care_service_types.id != 0) "
                   "group by care_service_types.id, care_service_types.item;";
    ExecuteStatement(dbTransaction, service_units);

    string tasks_events_count;
    tasks_events_count  = "select temp_care_summary.care_service_types, "
                          "       temp_care_summary.service_units, "
                          "       count(distinct(events.id)) num_of_events, "
                          "       sum(events.number_attended) attendance "
                          "from temp_care_summary "
                          "left join events on temp_care_summary.care_service_types_id  = events.care_service_id "
                          "     and (events.date_of_event between '" + begin_date + "'  and '" + end_date + "')"
                          "where (temp_care_summary.care_service_types_id != 0) "
                          "group by temp_care_summary.care_service_types, temp_care_summary.service_units;";

//    dbTransaction->StartTransaction();
    dbDataSet->SelectSQL->Add(tasks_events_count.c_str());
    dbDataSet->Open();
    dbDataSet->First();

      FORM_TRY
        // title stuff and report
        TformReportCareSummary * report_form = new TformReportCareSummary(NULL);
        report_form->report->DataSet = dbDataSet;
        report_form->lblDateTitle->Caption = date_title.c_str();
        report_form->txtType->DataSet = dbDataSet;
        report_form->txtType->DataField = "care_service_types";
        report_form->exprServiceUnits->Expression = "FORMATNUMERIC('###,##0', service_units)";
        report_form->exprTotalEvents->Expression = "FORMATNUMERIC('###,##0', num_of_events)";
        report_form->exprTotalAttendance->Expression = "FORMATNUMERIC('###,##0', attendance)";
//        report_form->lblTotalRepiteCare->Caption = respite_count.c_str();
//        report_form->lblTotalEdu->Caption = edu_count.c_str();
        report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str(); 
        Processing(false);
        report_form->report->Preview();
      FORM_CATCH

    // delete from temp tables
    sql = "delete from temp_care_summary";
    ExecuteStatement(dbTransaction, sql);

    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch(...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;

  Processing(false);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchCareSummary::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------


