//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchChefReport.h"
#include "reportChef.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchChefReport *formLaunchChefReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchChefReport::TformLaunchChefReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  Pdate begin_date = CurrentPdate();
  begin_date.month = 1;
  begin_date.day = 1;
  dateBegin->Date = begin_date.OutDate();
  dateEnd->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchChefReport::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchChefReport::btnRunClick(TObject *Sender)
{

  if (! IsFloat(editAmount->Text.c_str()))
  {
    PSay("Please enter a valid amount", m_invalid_data, MB_OK);
    editAmount->SetFocus();
  }
  else
  {
    Processing(true);
    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;

    try
    {

      dbTransaction->DefaultDatabase = dbDatabase;
      dbTransaction->Active = true;
      // dbTransaction->Commit();
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      /*
      Ashley's SQL that I (Matt) started with
      // get amount obligated -- for absolutely everyone, for a given date period (amount still promised)
        select people.id,
        sum(ob_transactions.credit_amount - ob_transactions.debit_amount)
        from people
        inner join tasks cob_tasks on cob_tasks.person_id = people.id
        inner join transactions ob_transactions on ob_transactions.task_id = cob_tasks.id
        inner join accounts ob_accounts on ob_transactions.account_id = ob_accounts.id
        where ob_accounts.account_type_id = 3 // payable
        // and ob_transactions.effective_date > '1/1/2002' // predicted, slows it down
        and cob_tasks.group_id = 5 // contract health
        and cob_tasks.services_provided_id > 0 // a service was provided
        and cob_tasks.date_of_task between '1/1/2002' and '1/1/2003'   // period of cobs
        group by people.id;
      // get amount paid -- for absolutely everyone, for a given date period (amount actually spent)
        select people.id,
        sum(paid_transactions.debit_amount - paid_transactions.credit_amount)
        from people
        inner join tasks visit_tasks on visit_tasks.person_id = people.id
        inner join bills on bills.task_id = visit_tasks.id
        inner join transactions paid_transactions on paid_transactions.bill_id = bills.id
        inner join accounts paid_accounts on paid_transactions.account_id = paid_accounts.id
        where people.id > 0
        and paid_accounts.account_type_id = 4 // expense
        and bills.bill_date > '1/1/2002' // predicted, and seems to speed it up
        // and transactions.effective_date > '1/1/2002' // predicted, but slows it down
        and visit_tasks.date_of_task between '1/1/2002' and '1/1/2003' // period of visits
        and visit_tasks.parent_task_id > 0 // visit, not cob
        and visit_tasks.group_id = 5 // contract health
        group by people.id;
*/

      // delete from temp tables
      sql = "delete from temp_chef_data";
      ExecuteStatement(dbTransaction, sql);
      sql = "delete from temp_chef_over";
      ExecuteStatement(dbTransaction, sql);
      
      // get obligated data
      // NOTE USES VIEW
      sql = "insert into temp_chef_data (person_id, tax_entity_id, amount_obligated) "
            "select people.id, "
            "       tax_entities.id, "
            "       sum(ob_transactions.credit_amount - ob_transactions.debit_amount) "
            "from people "
            "inner join cob_tasks on cob_tasks.person_id = people.id "
            "inner join transactions ob_transactions on ob_transactions.task_id = cob_tasks.id "
            "inner join tax_entities on tax_entities.id = ob_transactions.tax_entity_id "
            "inner join accounts ob_accounts on ob_transactions.account_id = ob_accounts.id "
            "where ob_accounts.account_type_id = " + lookupTables->IdOf("account_types", "PAYABLE") + " "
            "  and ob_transactions.effective_date > '" + begin_date + "' "
            "  and cob_tasks.group_id = '" + lookupTables->IdOf("groups", "CONTRACT HEALTH") + "' "
//            "  and cob_tasks.services_provided_id > 0 " // not needed since we are using cob_tasks view
            "  and cob_tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' "
            "group by people.id, tax_entities.id;";
      ExecuteStatement(dbTransaction, sql);

      // get paid data
      // NOTE USES VIEW
      sql = "insert into temp_chef_data (person_id, tax_entity_id, amount_paid, visit_task_id) "
            "select people.id, "
            "       tax_entities.id, "
            "       sum(paid_transactions.debit_amount - paid_transactions.credit_amount), "
            "       visit_tasks.id "
            "from people "
            "inner join visit_tasks on visit_tasks.person_id = people.id "
            "inner join bills on bills.task_id = visit_tasks.id "
            "inner join transactions paid_transactions on paid_transactions.bill_id = bills.id "
            "inner join tax_entities on tax_entities.id = paid_transactions.tax_entity_id "
            "inner join accounts paid_accounts on paid_transactions.account_id = paid_accounts.id "
            "where people.id > 0 "
            "  and paid_accounts.account_type_id = '" + lookupTables->IdOf("account_types", "EXPENSE") + "' "
            "  and bills.bill_date > '" + begin_date + "' "
            "  and paid_transactions.effective_date > '" + begin_date + "' " // jhaley 20110118: Fixed for Firebird 2.x alias compliance
            "  and visit_tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' "
//            "and visit_tasks.parent_task_id > 0 " // not needed since we are using visit_tasks view
            "and visit_tasks.group_id = '" + lookupTables->IdOf("groups", "CONTRACT HEALTH") + "' "
            "group by people.id, tax_entities.id, visit_tasks.id;";
      ExecuteStatement(dbTransaction, sql);

      // a quick way to specify the ones we want, I am open to suggestions for a quicker way
      sql = "insert into temp_chef_over (person_id) "
            "select person_id from temp_chef_data group by person_id having (sum(amount_obligated) + sum(amount_paid)) >=" + string(editAmount->Text.c_str());
      ExecuteStatement(dbTransaction, sql);

      // put it all together
      // NOTE USES VIEW
      sql = "select people.id person_id, person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix person_name, "
            "       tax_entities.name provider, "
            "       temp_chef_data.amount_obligated, "
            "       temp_chef_data.amount_paid, "
            "       visit_tasks.date_of_task service_date, "
            "       checks.check_number, "
            "       checks.date_sent paid_date, "
            "       (temp_chef_data.amount_obligated + temp_chef_data.amount_paid) amount_expensed " 
            "from temp_chef_over "
            "left join people on people.id = temp_chef_over.person_id "
            "left join person_names on person_names.id = people.person_names_id "
            "left join temp_chef_data on temp_chef_data.person_id = temp_chef_over.person_id "
            "left join tax_entities on tax_entities.id = temp_chef_data.tax_entity_id "
            "left join visit_tasks on visit_tasks.id = temp_chef_data.visit_task_id "
            "left join bills on bills.task_id = visit_tasks.id "
            "left join purchase_reqs on bills.purchase_req_id = purchase_reqs.id "
            "left join checks on purchase_reqs.check_id = checks.id "
            "order by person_names.last_name, person_names.first_name, 9 desc /* amount_expensed */;";

      // dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportChef * report_form = new TformReportChef(NULL);
        report_form->report->DataSet = dbDataSet;
        report_form->lblDateTitle->Caption = date_title.c_str();
        report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        report_form->txtName->DataSet = dbDataSet;
        report_form->txtName->DataField = "person_name";
        report_form->txtProvider->DataSet = dbDataSet;
        report_form->txtProvider->DataField = "provider";
        report_form->txtServiceDate->DataSet = dbDataSet;
        report_form->txtServiceDate->DataField = "service_date";
        report_form->txtCheck->DataSet = dbDataSet;
        report_form->txtCheck->DataField = "check_number";
        report_form->exprObAmount->Expression = "FORMATNUMERIC('$###,###0.00', amount_obligated)";
        report_form->exprPaidAmount->Expression = "FORMATNUMERIC('$###,###0.00', amount_paid)";
        report_form->exprExpensedAmount->Expression = "FORMATNUMERIC('$###,###0.00', amount_expensed)";
        report_form->exprTotalObligation->Expression = "FORMATNUMERIC('$###,###0.00', sum(amount_obligated))";
        report_form->exprTotalPaid->Expression = "FORMATNUMERIC('$###,###0.00', sum(amount_paid))";
        report_form->exprTotalExpenses->Expression = "FORMATNUMERIC('$###,###0.00', sum(amount_expensed))";
        Processing(false);
        report_form->report->Preview();
      FORM_CATCH

      dbDataSet->Close();

      // delete from temp tables
      sql = "delete from temp_chef_data";
      ExecuteStatement(dbTransaction, sql);
      sql = "delete from temp_chef_over";
      ExecuteStatement(dbTransaction, sql);

      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }

}
//---------------------------------------------------------------------------
void __fastcall TformLaunchChefReport::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

