//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchClientReport.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma link "codeSectionsGeneric"
#pragma link "codeInlineContainer"
#pragma link "launchGeneric"
#pragma link "codeFrameCodeTaxonomy"
#pragma link "codeSoftDropShadow"
#pragma link "codeFrameCheckListDropDown"
#pragma link "codeQuery__PeopleByAffiliation"
#pragma link "codeQueryGeneric"
#pragma link "codeHalfButton"
#pragma link "codeBaseDropDown"
#pragma link "codeCheckListDropDown"
#pragma link "codeRubberContainer"
#pragma resource "*.dfm"
TformLaunchClientReport *formLaunchClientReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchClientReport::TformLaunchClientReport(TComponent* Owner)
        : TformLaunchGeneric(Owner)
{
/*
  cbddAges->Filter->SetSecurity("people");
  cbddAges->Filter->AddColumnSpec("Area", "people", as_text, true, 120);
  cbddAges->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  cbddAges->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  cbddAges->Filter->SetSQLStatement("select item, 4, id from area_types where id > 0");
  cbddAges->Filter->ForceRefreshDataSet();
  cbddAges->DisplayFieldName = "Area";
  cbddAges->DropDownHeight = 144;
*/
  // Philip had a clever idea.  No, really he did.  For things like users, where by default you may not want to see EVERY employee EVER
  // all the time, but may have occasion to select employees no longer here; use Filter's built in functionality to filter those results
  // ... the names even make sense.  Current vs. Expired employee.  And ... yeah.
  // TODO -c : now how do I make them, by default, show only Current?
  string clever_current_id = "case when valid = 1 then '" + lookupTables->IdOf("current_types", "Current") + "' else '" + lookupTables->IdOf("current_types", "Expired") + "' end";
  editAliveOn->Text = CurrentDate().c_str();
  editDiagnosedStart->Text = CurrentDate().c_str();
  editDiagnosedStop->Text = CurrentDate().c_str();
  editUndiagnosedStart->Text = CurrentDate().c_str();
  editUndiagnosedStop->Text = CurrentDate().c_str();
  cboTasksWith->ItemIndex = 0;
  cbddTasksGroup->Filter->SetSecurity("");
  cbddTasksGroup->Filter->AddColumnSpec("Department", "", as_text, true, 200);
  cbddTasksGroup->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 40);
  cbddTasksGroup->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 60);
  cbddTasksGroup->Filter->SetSQLStatement("select item, " + clever_current_id + ", id from groups where id > 0");
  cbddTasksGroup->Filter->FetchPreferences("clientreport.task_department");
  cbddTasksGroup->Filter->SetIconStatus(true);
  cbddTasksGroup->Filter->ForceRefreshDataSet();
  cbddTasksGroup->DisplayFieldName = "Department";
  cbddTasksGroup->DropDownHeight = 144;
  cbddTasksUser->Filter->SetSecurity("");
  cbddTasksUser->Filter->AddColumnSpec("Employee", "", as_text, true, 200);
  cbddTasksUser->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 40);
  cbddTasksUser->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 60);
  cbddTasksUser->Filter->SetSQLStatement("select item, " + clever_current_id + ", id from users where id > 0");
  cbddTasksUser->Filter->FetchPreferences("clientreport.task_employee");
  cbddTasksUser->Filter->SetIconStatus(true);
  cbddTasksUser->Filter->ForceRefreshDataSet();
  cbddTasksUser->DisplayFieldName = "Employee";
  cbddTasksUser->DropDownHeight = 144;
  cbddTasksMethod->Filter->SetSecurity("");
  cbddTasksMethod->Filter->AddColumnSpec("Contact Method", "", as_text, true, 200);
  cbddTasksMethod->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 40);
  cbddTasksMethod->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 60);
  cbddTasksMethod->Filter->SetSQLStatement("select item, " + clever_current_id + ", id from method_types where id > 0");
  cbddTasksMethod->Filter->FetchPreferences("clientreport.task_method");
  cbddTasksMethod->Filter->SetIconStatus(true);
  cbddTasksMethod->Filter->ForceRefreshDataSet();
  cbddTasksMethod->DisplayFieldName = "Contact Method";
  cbddTasksMethod->DropDownHeight = 144;
  editTasksStart->Text = CurrentDate().c_str();
  editTasksStop->Text = CurrentDate().c_str();
  cboObservationsWith->ItemIndex = 0;
  cbddObservationsGroup->Filter->SetSecurity("");
  cbddObservationsGroup->Filter->AddColumnSpec("Department", "", as_text, true, 200);
  cbddObservationsGroup->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 40);
  cbddObservationsGroup->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 60);
  cbddObservationsGroup->Filter->SetSQLStatement("select item, " + clever_current_id + ", id from groups where id > 0");
  cbddObservationsGroup->Filter->FetchPreferences("clientreport.observations_department");
  cbddObservationsGroup->Filter->SetIconStatus(true);
  cbddObservationsGroup->Filter->ForceRefreshDataSet();
  cbddObservationsGroup->DisplayFieldName = "Department";
  cbddObservationsGroup->DropDownHeight = 144;
  cbddObsQuestionSets->Filter->SetSecurity("");
  cbddObsQuestionSets->Filter->AddColumnSpec("Panel", "", as_text, true, 200);
  cbddObsQuestionSets->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 40);
  cbddObsQuestionSets->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 60);
  cbddObsQuestionSets->Filter->SetSQLStatement("select item, " + clever_current_id + ", id from obs_question_set_types where id > 0");
  cbddObsQuestionSets->Filter->FetchPreferences("clientreport.obs_panel");
  cbddObsQuestionSets->Filter->SetIconStatus(true);
  cbddObsQuestionSets->Filter->ForceRefreshDataSet();
  cbddObsQuestionSets->DisplayFieldName = "Panel";
  cbddObsQuestionSets->DropDownHeight = 144;
  editObservationsStart->Text = CurrentDate().c_str();
  editObservationsStop->Text = CurrentDate().c_str();
  cboStepsObservation->ItemIndex = 0;
  cboReferralsWith->ItemIndex = 0;
  editReferralsStart->Text = CurrentDate().c_str();
  editReferralsStop->Text = CurrentDate().c_str();
  cboAppointmentsWith->ItemIndex = 0;
  cbddAppointmentsGroup->Filter->SetSecurity("");
  cbddAppointmentsGroup->Filter->AddColumnSpec("Department", "", as_text, true, 200);
  cbddAppointmentsGroup->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 40);
  cbddAppointmentsGroup->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 60);
  cbddAppointmentsGroup->Filter->SetSQLStatement("select item, " + clever_current_id + ", id from groups where id > 0");
  cbddAppointmentsGroup->Filter->FetchPreferences("clientreport.appointments_department");
  cbddAppointmentsGroup->Filter->SetIconStatus(true);
  cbddAppointmentsGroup->Filter->ForceRefreshDataSet();
  cbddAppointmentsGroup->DisplayFieldName = "Department";
  cbddAppointmentsGroup->DropDownHeight = 144;
  cbddAppointmentsBy->Filter->SetSecurity("");
  cbddAppointmentsBy->Filter->AddColumnSpec("Employee", "", as_text, true, 200);
  cbddAppointmentsBy->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 40);
  cbddAppointmentsBy->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 60);
  cbddAppointmentsBy->Filter->SetSQLStatement("select item, " + clever_current_id + ", id from users where id > 0");
  cbddAppointmentsBy->Filter->FetchPreferences("clientreport.appointments_by");
  cbddAppointmentsBy->Filter->SetIconStatus(true);
  cbddAppointmentsBy->Filter->ForceRefreshDataSet();
  cbddAppointmentsBy->DisplayFieldName = "Employee";
  cbddAppointmentsBy->DropDownHeight = 144;
  cbddAppointmentsFor->Filter->SetSecurity("");
  cbddAppointmentsFor->Filter->AddColumnSpec("Employee", "", as_text, true, 200);
  cbddAppointmentsFor->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 40);
  cbddAppointmentsFor->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 60);
  cbddAppointmentsFor->Filter->SetSQLStatement("select item, " + clever_current_id + ", id from users where id > 0");
  cbddAppointmentsFor->Filter->FetchPreferences("clientreport.appointments_for");
  cbddAppointmentsFor->Filter->SetIconStatus(true);
  cbddAppointmentsFor->Filter->ForceRefreshDataSet();
  cbddAppointmentsFor->DisplayFieldName = "Employee";
  cbddAppointmentsFor->DropDownHeight = 144;
  cbddAppointmentsOutcome->Filter->SetSecurity("");
  cbddAppointmentsOutcome->Filter->AddColumnSpec("Outcome", "", as_text, true, 200);
  cbddAppointmentsOutcome->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 40);
  cbddAppointmentsOutcome->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 60);
  cbddAppointmentsOutcome->Filter->SetSQLStatement("select item, " + clever_current_id + ", id from visit_outcome_types where id > 0");
  cbddAppointmentsOutcome->Filter->FetchPreferences("clientreport.appointments_for");
  cbddAppointmentsOutcome->Filter->SetIconStatus(true);
  cbddAppointmentsOutcome->Filter->ForceRefreshDataSet();
  cbddAppointmentsOutcome->DisplayFieldName = "Outcome";
  cbddAppointmentsOutcome->DropDownHeight = 144;
  editAppointmentsStart->Text = CurrentDate().c_str();
  editAppointmentsStop->Text = CurrentDate().c_str();
  cboParticipationsWith->ItemIndex = 0;
  cbddParticipationsGroup->Filter->SetSecurity("");
  cbddParticipationsGroup->Filter->AddColumnSpec("Department", "", as_text, true, 200);
  cbddParticipationsGroup->Filter->AddColumnSpec("Current Id", "current_id", as_int, false, 40);
  cbddParticipationsGroup->Filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 60);
  cbddParticipationsGroup->Filter->SetSQLStatement("select item, " + clever_current_id + ", id from groups where id > 0");
  cbddParticipationsGroup->Filter->FetchPreferences("clientreport.participations_department");
  cbddParticipationsGroup->Filter->SetIconStatus(true);
  cbddParticipationsGroup->Filter->ForceRefreshDataSet();
  cbddParticipationsGroup->DisplayFieldName = "Department";
  cbddParticipationsGroup->DropDownHeight = 144;
  editParticipationsStart->Text = CurrentDate().c_str();
  editParticipationsStop->Text = CurrentDate().c_str();  
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchClientReport::SectionOpen(TObject *Sender)
{
  inlineSections->Arrange();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchClientReport::SectionClose(TObject *Sender)
{
  inlineSections->Arrange();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchClientReport::ClearDateField(TObject *Sender)
{
  THalfButton *btnSender = (THalfButton*)(Sender);
  if (btnSender)
  {
   TEdit *editRecipient = (TEdit*)(btnSender->Associate);
   if (editRecipient)
    editRecipient->Text = "";
  }
}
//---------------------------------------------------------------------------


