//---------------------------------------------------------------------------

#ifndef launchClientReportH
#define launchClientReportH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include "codeSectionsGeneric.h"
#include "codeInlineContainer.h"
#include "launchGeneric.h"
#include "codeFrameCodeTaxonomy.h"
#include "codeSoftDropShadow.h"
#include "codeFrameCheckListDropDown.h"
#include <Buttons.hpp>
#include "codeQuery__PeopleByAffiliation.h"
#include "codeQueryGeneric.h"
#include "codeHalfButton.h"
#include "codeBaseDropDown.h"
#include "codeCheckListDropDown.h"
#include "codeRubberContainer.h"
//---------------------------------------------------------------------------
class TformLaunchClientReport : public TformLaunchGeneric
{
__published:	// IDE-managed Components
        TInlineContainer *inlineSections;
        TSectionsGeneric *sectionAge;
        TSoftDropShadow *dropAge;
        TCheckBox *checkAges;
        TCheckBox *checkAlive;
        TEdit *editAliveOn;
        TCheckBox *checkBornIn;
        TComboBox *cboBirthMonth;
        TSectionsGeneric *sectionCodes;
        TSoftDropShadow *dropCodes;
        TLabel *lblDiagnosedStop;
        TLabel *lblDiagnosedStart;
        TLabel *lblUndiagnosedStart;
        TLabel *labelUndiagnosedStop;
        TframeCodeTaxonomy *frameDiagnosed;
        TCheckBox *checkDiabetic;
        TCheckBox *checkDiagnosed;
        TCheckBox *checkUndiagnosed;
        TEdit *editDiagnosedStart;
        TEdit *editDiagnosedStop;
        TframeCodeTaxonomy *frameUndiagnosed;
        TEdit *editUndiagnosedStart;
        TEdit *editUndiagnosedStop;
        TSectionsGeneric *sectionTasks;
        TSoftDropShadow *dropTasks;
        TLabel *lblTasksWith;
        TLabel *lblTasksStart;
        TLabel *labelTasksStop;
        TCheckBox *checkTasks;
        TCheckBox *checkTasksGroup;
        TCheckBox *checkTasksUser;
        TCheckBox *checkTasksTaxEntity;
        TBitBtn *buttonTasksTaxEntity;
        TStaticText *staticTasksTaxEntity;
        TCheckBox *checkTasksMethod;
        TComboBox *cboTasksWith;
        TEdit *editTasksStart;
        TEdit *editTasksStop;
        TCheckListDropDown *cbddTasksGroup;
        TCheckListDropDown *cbddTasksUser;
        TCheckListDropDown *cbddTasksMethod;
        TSectionsGeneric *sectionParticipations;
        TSoftDropShadow *dropParticipations;
        TLabel *lblParticipationsWith;
        TLabel *lblParticipationsStart;
        TLabel *labelParticipationsStop;
        TCheckBox *checkParticipations;
        TCheckBox *checkParticipationsGroup;
        TComboBox *cboParticipationsWith;
        TEdit *editParticipationsStart;
        TEdit *editParticipationsStop;
        TCheckListDropDown *cbddParticipationsGroup;
        TSectionsGeneric *sectionObservations;
        TSoftDropShadow *dropMeasurements;
        TLabel *lblObservationsWith;
        TLabel *lblObservationsStart;
        TLabel *labelObservationsStop;
        TLabel *lblStepsObservation;
        TCheckBox *checkObservations;
        TCheckBox *checkObservationsGroup;
        TComboBox *cboObservationsWith;
        TEdit *editObservationsStart;
        TEdit *editObservationsStop;
        TCheckListDropDown *cbddObservationsGroup;
        TCheckListDropDown *cbddObsQuestionSets;
        TCheckBox *checkObsQuestionSets;
        TCheckBox *checkStepsObservation;
        TComboBox *cboStepsObservation;
        TSectionsGeneric *sectionAppointments;
        TSoftDropShadow *dropAppointments;
        TLabel *lblAppointmentsWith;
        TLabel *lblAppointmentsStart;
        TLabel *labelAppointmentsStop;
        TCheckBox *checkAppointments;
        TCheckBox *checkAppointmentsBy;
        TCheckBox *checkAppointmentsFor;
        TCheckBox *checkAppointmentsProvider;
        TBitBtn *buttonAppointmentsProvider;
        TStaticText *staticAppointmentsTaxEntity;
        TCheckBox *checkAppointmentsOutcome;
        TComboBox *cboAppointmentsWith;
        TCheckBox *checkAppointmentsGroup;
        TEdit *editAppointmentsStart;
        TEdit *editAppointmentsStop;
        TCheckListDropDown *cbddAppointmentsGroup;
        TCheckListDropDown *cbddAppointmentsBy;
        TCheckListDropDown *cbddAppointmentsFor;
        TCheckListDropDown *cbddAppointmentsOutcome;
        TSectionsGeneric *sectionReferrals;
        TSoftDropShadow *dropReferrals;
        TLabel *lblReferralsWith;
        TLabel *lblReferralsStart;
        TLabel *labelReferralsStop;
        TCheckBox *checkReferrals;
        TComboBox *cboReferralsWith;
        TEdit *editReferralsStart;
        TEdit *editReferralsStop;
        TCheckBox *checkReferralsFrom;
        TStaticText *staticReferralsFrom;
        TBitBtn *buttonReferralsFrom;
        TCheckBox *checkReferralsTo;
        TStaticText *staticReferralsTo;
        TBitBtn *buttonReferralsTo;
        TSectionsGeneric *sectionAffiliations;
        TSoftDropShadow *dropAffiliations;
        TCheckBox *checkAffiliationss;
        TframeQuery__PeopleByAffiliation *frameAffiliations;
        THalfButton *btnClearUndiagnosedStart;
        THalfButton *btnClearUndiagnosedStop;
        THalfButton *btnClearDiagnosedStart;
        THalfButton *btnClearDiagnosedStop;
        THalfButton *btnClearTasksStart;
        THalfButton *btnClearTasksStop;
        THalfButton *btnClearObservationsStart;
        THalfButton *btnClearObservationsStop;
        THalfButton *btnClearReferralsStart;
        THalfButton *btnClearReferralsStop;
        THalfButton *btnClearAppointmentsStart;
        THalfButton *btnClearAppointmentsStop;
        THalfButton *btnClearParticipationsStart;
        THalfButton *btnClearParticipationsStop;
        TPanel *panelAge;
        TLabel *lblAnd;
        TRadioButton *radioAgeCombo;
        TRadioButton *radioBetweenAges;
        TEdit *editAge1;
        TEdit *editAge2;
        TCheckListDropDown *cbddAges;
        TComboBox *cboAges;
        TPanel *Panel1;
        TRadioButton *radioNonDiabetics;
        TRadioButton *radioDiabetics;
        TPanel *panelTasksGroup;
        TRadioButton *radioTasksGroupAny;
        TRadioButton *radioTasksGroupAll;
        TPanel *panelTasksUser;
        TRadioButton *radioTasksUserAny;
        TRadioButton *radioTasksUserAll;
        TPanel *panelTasksMethod;
        TRadioButton *radioTasksMethodAny;
        TRadioButton *radioTasksMethodAll;
        TPanel *panelObservationsGroup;
        TRadioButton *radioObservationsGroupAny;
        TRadioButton *radioObservationsGroupAll;
        TPanel *panelObsQuestionSet;
        TRadioButton *radioObsQuestionSetAny;
        TRadioButton *radioObsQuestionSetAll;
        TPanel *panelAppointmentsGroup;
        TRadioButton *radioAppointmentsGroupAny;
        TRadioButton *radioAppointmentsGroupAll;
        TPanel *panelAppointmentsBy;
        TRadioButton *radioAppointmentsByAny;
        TRadioButton *radioAppointmentsByAll;
        TPanel *panelAppointmentsFor;
        TRadioButton *radioAppointmentsForAny;
        TRadioButton *radioAppointmentsForAll;
        TPanel *panelAppointmentsOutcome;
        TRadioButton *radioAppointmentsOutcomeAny;
        TRadioButton *radioAppointmentsOutcomeAll;
        TPanel *panelParticipationsGroup;
        TRadioButton *radioParticipationsGroupAny;
        TRadioButton *radioParticipationsGroupAll;
        TSectionsGeneric *sectionEnrollment;
        TSoftDropShadow *dropEnrollment;
        TLabel *lblClient;
        TScrollBox *scrollEnrollment;
        TSectionsGeneric *sectionEnrollmentBeh;
        TSoftDropShadow *SoftDropShadow2;
        TCheckBox *checkBehClient;
        TCheckBox *checkBehJurisdiction;
        TCheckBox *checkBehRefused;
        TCheckBox *checkPrimarySupport;
        TSectionsGeneric *sectionEnrollmentCom;
        TSoftDropShadow *SoftDropShadow3;
        TCheckBox *checkComClient;
        TCheckBox *checkComRefused;
        TSectionsGeneric *sectionEnrollmentCare;
        TSoftDropShadow *SoftDropShadow4;
        TCheckBox *CheckBox1;
        TSectionsGeneric *sectionEnrollmentDiab;
        TSoftDropShadow *shadowEnrollment;
        TCheckBox *checkDiabClient;
        TCheckBox *checkMailingList;
        TCheckBox *checkLAC;
        TCheckBox *checkASC;
        TCheckBox *checkSteps;
        TCheckBox *checkStar;
        TCheckBox *checkResourceCenter;
        TSectionsGeneric *sectionEnrollmentPub;
        TSoftDropShadow *SoftDropShadow6;
        TCheckBox *checkPubClient;
        TCheckBox *checkPubRefused;
        TSectionsGeneric *SectionsGeneric1;
        TSoftDropShadow *SoftDropShadow1;
        TLabel *lblGender;
        TComboBox *cboGender;
        TSectionsGeneric *sectionInsurance;
        TSoftDropShadow *SoftDropShadow7;
        TCheckBox *checkCVD;
        void __fastcall SectionOpen(TObject *Sender);
        void __fastcall SectionClose(TObject *Sender);
        void __fastcall ClearDateField(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TformLaunchClientReport(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TformLaunchClientReport *formLaunchClientReport;
//---------------------------------------------------------------------------
#endif
