//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchComEducationReport.h"
#include "codeSearchPerson.h"
#include "reportComEducation.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchComEducation *formLaunchComEducation;
//---------------------------------------------------------------------------
__fastcall TformLaunchComEducation::TformLaunchComEducation(TComponent* Owner, string id)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  CreateLink(txtName, btnPersonSearch, this, id, "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComEducation::btnPersonSearchClick(
      TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtName, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComEducation::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComEducation::btnRunClick(TObject *Sender)
{
  string person_id = GetValidLinkId(txtName);
  if (person_id != "")
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Education report for " + GetPersonName(dbDatabase, person_id, first_last);

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select tasks.date_of_task,  "
            "com_topic_types.item topic, com_method_types.item method, com_evaluation_types.item evaluation, "
            "users.item staff "
            "from tasks, com_health_edu, com_topic_types, com_method_types, com_evaluation_types, users "
            "where "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' and "
            "tasks.person_id = " + person_id + " and "
            "tasks.current_id >= 3  and "
            "com_health_edu.com_topic_id = com_topic_types.id and "
            "com_health_edu.com_method_id = com_method_types.id and "
            "com_health_edu.com_evaluation_id = com_evaluation_types.id and "
            "tasks.user_id = users.id and "
            "tasks.id = com_health_edu.task_id and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Community Health");
      sql += "order by tasks.date_of_task";


      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportComEducation * educationReport = new TformReportComEducation(NULL);
        educationReport->educationReport->DataSet = dbDataSet;
        educationReport->lblTitle->Caption = title.c_str();
        educationReport->lblDateTitle->Caption = date_title.c_str();
        educationReport->txtDate->DataSet = dbDataSet;
        educationReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        educationReport->txtDate->DataField = "date_of_task";
        educationReport->txtType->DataSet = dbDataSet;
        educationReport->txtType->DataField = "topic";
        educationReport->txtMethod->DataSet = dbDataSet;
        educationReport->txtMethod->DataField = "method";
        educationReport->txtEvaluation->DataSet = dbDataSet;
        educationReport->txtEvaluation->DataField = "evaluation";
        educationReport->txtStaff->DataSet = dbDataSet;
        educationReport->txtStaff->DataField = "staff";
        Processing(false);
        educationReport->educationReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();

    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }
  else
  {
    PSay("Please enter a client name", m_missing_data, MB_OK);
    btnPersonSearch->SetFocus();
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComEducation::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

