//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchComPersonVisitReport.h"
#include "codeSearchPerson.h"
#include "reportComPersonVisit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchComPersonVisitReport *formLaunchComPersonVisitReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchComPersonVisitReport::TformLaunchComPersonVisitReport(TComponent* Owner, string id)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  CreateLink(txtName, btnPersonSearch, this, id, "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComPersonVisitReport::btnPersonSearchClick(
      TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtName, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComPersonVisitReport::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComPersonVisitReport::btnRunClick(TObject *Sender)
{
 string person_id = GetValidLinkId(txtName);
 if (person_id != "")
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Visit report for " + GetPersonName(dbDatabase, person_id, first_last);

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select tasks.date_of_task, com_visit_types.item visit_types, visit_location_types.item location, "
            "tasks.time_spent, users.item staff, task_purpose_types.item task_types "
            "from tasks "
            "inner join com_visit_types on tasks.com_visit_id = com_visit_types.id "
            "inner join visit_location_types on tasks.visit_location_id = visit_location_types.id "
            "inner join users on tasks.user_id = users.id "
            "inner join task_purpose_types on tasks.task_purpose_id = task_purpose_types.id "
            "where tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' and "
            "tasks.person_id = '" + person_id + "' and "
            "tasks.current_id >= 3 and "
            "tasks.group_id = '" + lookupTables->IdOf("groups", "Community Health") + "' "
            "order by tasks.id";

      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportComVisit * visitReport = new TformReportComVisit(NULL);
        visitReport->reportComVisit->DataSet = dbDataSet;
        visitReport->lblTitle->Caption = title.c_str();
        visitReport->lblDateTitle->Caption = date_title.c_str();
        visitReport->txtDate->DataSet = dbDataSet;
        visitReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        visitReport->txtDate->DataField = "date_of_task";
        visitReport->txtVisitType->DataSet = dbDataSet;
        visitReport->txtVisitType->DataField = "visit_types";
        visitReport->txtLocation->DataSet = dbDataSet;
        visitReport->txtLocation->DataField = "location";
        visitReport->exprPatientTime->Expression = "FORMATNUMERIC('##0.00', time_spent)";
        visitReport->txtStaff->DataSet = dbDataSet;
        visitReport->txtStaff->DataField = "staff";
        visitReport->txtTaskType->DataSet = dbDataSet;
        visitReport->txtTaskType->DataField = "task_types";
        Processing(false);
        visitReport->reportComVisit->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;
  }
  else
  {
    PSay("Please enter a client name", m_missing_data, MB_OK);
    btnPersonSearch->SetFocus();
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComPersonVisitReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

