//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchComPublicHealthReport.h"
#include "reportPublicWorkloadTotals.h"
#include "reportPublicWorkloadTasks.h"
#include "reportPublicWorkloadVisit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformComPublicHealthReport *formComPublicHealthReport;
//---------------------------------------------------------------------------
__fastcall TformComPublicHealthReport::TformComPublicHealthReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformComPublicHealthReport::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformComPublicHealthReport::btnRunClick(TObject *Sender)
{
  Processing(true);
  dbVisitDataSet = new TIBDataSet(NULL);
  dbTypesDataSet = new TIBDataSet(NULL);
  dbTotalsDataSet = new TIBDataSet(NULL);
  dbTransaction = new TIBTransaction(NULL);

  TQRPageList * source = new TQRPageList();
  TQRPageList * destination = new TQRPageList();
  destination->Stream = new TQRStream(100000);
  TQRPrinter * printer_thing = InitTQRPrinter();


  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbVisitDataSet->Database = dbDatabase;
    dbVisitDataSet->Transaction = dbTransaction;
    dbVisitDataSet->UniDirectional = false;
    dbTypesDataSet->Database = dbDatabase;
    dbTypesDataSet->Transaction = dbTransaction;
    dbTypesDataSet->UniDirectional = false;
    dbTotalsDataSet->Database = dbDatabase;
    dbTotalsDataSet->Transaction = dbTransaction;
    dbTotalsDataSet->UniDirectional = false;
    dbTransaction->StartTransaction();

    compositeReport->Prepare();
    string file_name = PMakeTempFilePath("page1.qrp");
    ((TQuickRep *)(compositeReport->Reports->First()))->QRPrinter->Save(file_name.c_str());
    // add page 1
    source->Clear();
    source->LoadFromFile(file_name.c_str());
    destination->AddPage(source->GetPage(1));
    destination->Finish();
    string temp_filepath = PMakeTempFilePath("complete.qrp");
    destination->SaveToFile(temp_filepath.c_str());
    // load combined report and preview
    printer_thing->Load(temp_filepath.c_str());
    Processing(false);
    printer_thing->PreviewModal();

    dbVisitDataSet->Close();
    dbTypesDataSet->Close();
    dbTotalsDataSet->Close();
    dbTransaction->Commit();

  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbVisitDataSet;
  delete dbTypesDataSet;
  delete dbTotalsDataSet;
  delete printer_thing;
  delete source;
  delete destination;
}
//---------------------------------------------------------------------------
void __fastcall TformComPublicHealthReport::compositeReportAddReport(
      TObject *Sender)
{
  int num_nurses = 1;

  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {
    //first composite report
    FORM_TRY
      TformReportPublicWorkloadTotals * workloadReport = new TformReportPublicWorkloadTotals(NULL);
      workloadReport->lblDateTitle->Caption = date_title.c_str();
      sql = "select count(distinct (tasks.person_id)) total from tasks where "
            "tasks.current_id >= 3 and tasks.group_id = " + lookupTables->IdOf("groups", "Public Health") + " and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' and "
            "((tasks.method_id = " + lookupTables->IdOf("method_types", "Phone") + ") or "
            "(tasks.visit_location_id > 0 and tasks.com_visit_id > 0))";
      workloadReport->lblPatients->Caption = GetOneField(dbTransaction, sql).c_str();
      sql = "select count(tasks.id) "
            "from tasks "
            "where tasks.group_id = " + lookupTables->IdOf("groups", "Public Health") + " and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' and "
            "tasks.com_dept_id = 0 and "  // added so the filter wouldn't pull visits (they should come up on a different screen)
            "tasks.method_id = " + lookupTables->IdOf("method_types", "Phone");
      int phonne_contacts = StringToInt(GetOneField(dbTransaction, sql));
      workloadReport->lblPhoneVisits->Caption = IntToString(phonne_contacts).c_str();
      sql = "select count(tasks.id) from tasks where tasks.person_id > 0 and "
            "tasks.current_id >= 3 and "
            "tasks.visit_location_id > 0 and tasks.com_visit_id > 0 and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Public Health") + " and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "'";
      workloadReport->lblContacts->Caption = IntToString(StringToInt(GetOneField(dbTransaction, sql)) + phonne_contacts).c_str();
      Pdate date1(begin_date, mdy|yyyy);
      Pdate date2(end_date, mdy|yyyy);
      int count = 0;
      while (date1<=date2)
      {
       if ((date1.DayOfWeek() < 7) &  (date1.DayOfWeek() > 1))
        count ++;
       date1++;
      }
      sql = "select sum(time_spent) from tasks where "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Public Health") + " and "
            "tasks.com_activity_id > 0 and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' and "
            "tasks.current_id >= 3";
      string hours = GetOneField(dbTransaction, sql).c_str();
      float WorkingHours = StringToFloat(hours.c_str());
      WorkingHours = WorkingHours / 8;
      double WorkingDays = count - WorkingHours;
      workloadReport->lblDays->Caption = FloatToString(WorkingDays).c_str();
      workloadReport->lblPatientLoad->Caption = FloatToString(StringToFloat(workloadReport->lblContacts->Caption.c_str()) / WorkingDays).c_str();
      string adpl = FloatToString(StringToFloat(workloadReport->lblPatientLoad->Caption.c_str())/num_nurses).c_str();
      adpl = adpl.substr(1,5);
      workloadReport->lblADPL->Caption = adpl.c_str();
      compositeReport->Reports->Add(workloadReport->workloadReport);
    FORM_CATCH

    FORM_TRY
      // second page in composite report
      TformReportPublicWorkloadVisit * workloadVisitreport = new TformReportPublicWorkloadVisit(NULL);
      sql = "select com_visit_types.item location, count(tasks.time_spent) visits "
            "from com_visit_types left join tasks on tasks.com_visit_id = com_visit_types.id and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Public Health") + " and "
            "tasks.current_id >= 3 and tasks.person_id > 0 and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' "
            "where com_visit_types.valid = 1 and tasks.com_visit_id > 0 "
            "group by com_visit_types.item order by com_visit_types.item";
      dbVisitDataSet->SelectSQL->Add(sql.c_str());
      dbVisitDataSet->Open();
      dbVisitDataSet->First();
      workloadVisitreport->workloadVisitreport->DataSet = dbVisitDataSet;
      workloadVisitreport->txtType->DataSet = dbVisitDataSet;
      workloadVisitreport->txtType->DataField = "location";
      workloadVisitreport->txtTypeCount->DataSet = dbVisitDataSet;
      workloadVisitreport->txtTypeCount->DataField = "visits";
      workloadVisitreport->exprTotalType->Expression = "FORMATNUMERIC('#,##0', SUM(visits))";
      compositeReport->Reports->Add(workloadVisitreport->workloadVisitreport);
    FORM_CATCH

    FORM_TRY
      // third composite report
      sql = "select com_activity_types.item location, count(tasks.id) visits "
            "from com_activity_types left join tasks on "
            "tasks.com_activity_id = com_activity_types.id and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Public Health") + " and "
            "tasks.current_id >= 3 and  "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' "
            "where com_activity_types.valid = 1 and tasks.com_activity_id > 0 "
            "group by com_activity_types.item order by com_activity_types.item";
      dbTypesDataSet->SelectSQL->Add(sql.c_str());
      dbTypesDataSet->Open();
      dbTypesDataSet->First();
      TformReportPublicWorkloadTasks * workloadTaskreport = new TformReportPublicWorkloadTasks(NULL);
      workloadTaskreport->workloadTaskreport->DataSet = dbTypesDataSet;
      workloadTaskreport->txtActivities->DataSet = dbTypesDataSet;
      workloadTaskreport->txtActivities->DataField = "location";
      workloadTaskreport->exprHours->Expression = "FORMATNUMERIC('#,##0', visits)";
      workloadTaskreport->exprTotalHours->Expression = "FORMATNUMERIC('#,##0', SUM((visits)))";
      compositeReport->Reports->Add(workloadTaskreport->workloadTaskreport);
    FORM_CATCH
  }
  catch (...)
  {
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
}
//---------------------------------------------------------------------------

void __fastcall TformComPublicHealthReport::compositeReportFinished(
      TObject *Sender)
{
 //just in case
}
//---------------------------------------------------------------------------

void __fastcall TformComPublicHealthReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

