//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchComServicesReport.h"
#include "reportComServicesVisit.h"
#include "reportComServicesLocation.h"
#include "reportComServicesTotals.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchComServicesReport *formLaunchComServicesReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchComServicesReport::TformLaunchComServicesReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  times_run = 0;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComServicesReport::btnCloseClick(
      TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComServicesReport::btnRunClick(TObject *Sender)
{
  Processing(true);
  dbLocationsDataSet = new TIBDataSet(NULL);
  dbTypesDataSet = new TIBDataSet(NULL);
  dbTotalsDataSet = new TIBDataSet(NULL);
  dbTransaction = new TIBTransaction(NULL);

  TQRPageList * source = new TQRPageList();
  TQRPageList * destination = new TQRPageList();
  destination->Stream = new TQRStream(100000);
  TQRPrinter * printer_thing = InitTQRPrinter();

 
  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbLocationsDataSet->Database = dbDatabase;
    dbLocationsDataSet->Transaction = dbTransaction;
    dbLocationsDataSet->UniDirectional = false;
    dbTypesDataSet->Database = dbDatabase;
    dbTypesDataSet->Transaction = dbTransaction;
    dbTypesDataSet->UniDirectional = false;
    dbTotalsDataSet->Database = dbDatabase;
    dbTotalsDataSet->Transaction = dbTransaction;
    dbTotalsDataSet->UniDirectional = false;
    dbTransaction->StartTransaction();

    compositeReport->Prepare();
    string file_name = PMakeTempFilePath("page1.qrp");
    ((TQuickRep *)(compositeReport->Reports->First()))->QRPrinter->Save(file_name.c_str());
    // add page 1
    source->Clear();
    source->LoadFromFile(file_name.c_str());
    destination->AddPage(source->GetPage(1));
    destination->Finish();
    string temp_filepath = PMakeTempFilePath("complete.qrp");
    destination->SaveToFile(temp_filepath.c_str());
    // load combined report and preview
    printer_thing->Load(temp_filepath.c_str());
    Processing(false);
    printer_thing->PreviewModal();
    
    dbLocationsDataSet->Close();
    dbTypesDataSet->Close();
    dbTotalsDataSet->Close();
    dbTransaction->Commit();

  }
  catch (...)
  {
      Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbLocationsDataSet;
  delete dbTypesDataSet;
  delete dbTotalsDataSet;
  delete printer_thing;
  delete source;
  delete destination;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComServicesReport::compositeReportAddReport(
      TObject *Sender)
{
  if (times_run == 0)
  {
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;

    try
    {
      sql = "select count(tasks.id) total from tasks where tasks.new_client = 1 and "
            "tasks.current_id >= 3 and tasks.com_visit_id > 0 and tasks.visit_location_id >0 and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "'";
      dbTotalsDataSet->SelectSQL->Add(sql.c_str());
      dbTotalsDataSet->Open();
      dbTotalsDataSet->First();

      FORM_TRY
        TformReportComServicesTotals * totalsReport = new TformReportComServicesTotals(NULL);
        totalsReport->totalsReport->DataSet = dbTotalsDataSet;
        totalsReport->txtNewClients->DataSet = dbTotalsDataSet;
        totalsReport->lblDateTitle->Caption = date_title.c_str();
        totalsReport->txtNewClients->DataField = "total";
        sql = "select count(tasks.id) from tasks where tasks.person_id > 0 and "
              "tasks.current_id >= 3 and "
              "tasks.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
              "tasks.date_of_task >= '" + begin_date + "' and "
              "tasks.date_of_task <= '" + end_date + "'";
        totalsReport->lblServices->Caption = GetOneField(dbTransaction, sql).c_str();
        compositeReport->Reports->Add(totalsReport->totalsReport);

        sql = "select com_visit_types.item reason, count(tasks.id) visits, sum(tasks.mileage) miles "
              "from com_visit_types left join tasks on tasks.com_visit_id = com_visit_types.id and "
              "tasks.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
              "tasks.current_id >= 3 and "
              "tasks.person_id > 0 and "
              "tasks.date_of_task >= '" + begin_date + "' and "
              "tasks.date_of_task <= '" + end_date + "' "
              "where com_visit_types.valid = 1 and tasks.com_visit_id > 0 and "
              "tasks.visit_location_id > 0 "
              "group by com_visit_types.item order by com_visit_types.item";
        dbTypesDataSet->SelectSQL->Add(sql.c_str());

        sql = "select visit_location_types.item location, count(tasks.id) visits "
              "from visit_location_types left join tasks on "
              "tasks.visit_location_id = visit_location_types.id and "
              "tasks.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
              "tasks.current_id >= 3 and "
              "tasks.person_id > 0 and "
              "tasks.date_of_task >= '" + begin_date + "' and "
              "tasks.date_of_task <= '" + end_date + "' "
              "where visit_location_types.valid = 1 and tasks.visit_location_id > 0 "
              "group by visit_location_types.item order by visit_location_types.item";
        dbLocationsDataSet->SelectSQL->Add(sql.c_str());
      FORM_CATCH

      dbTypesDataSet->Open();
      dbTypesDataSet->First();
      dbLocationsDataSet->Open();
      dbLocationsDataSet->First();

      FORM_TRY
        TformReportComServicesVisit * visitReport = new TformReportComServicesVisit(NULL);
        visitReport->visitReport->DataSet = dbTypesDataSet;
        visitReport->txtType->DataSet = dbTypesDataSet;
        visitReport->txtType->DataField = "reason";
        visitReport->txtVisits->DataSet = dbTypesDataSet;
        visitReport->txtVisits->DataField = "visits";
        visitReport->exprMiles->Expression = PrettyString("miles").c_str();
        visitReport->exprTotalVisits->Expression = "SUM(visits)";
        visitReport->exprTotalMiles->Expression = "FORMATNUMERIC('#,##0', SUM(miles))";
        compositeReport->Reports->Add(visitReport->visitReport);
      FORM_CATCH

      FORM_TRY
        TformReportComVisitLocations * locationsReport = new TformReportComVisitLocations(NULL);
        locationsReport->locationsReport->DataSet = dbLocationsDataSet;
        locationsReport->txtLocation->DataSet = dbLocationsDataSet;
        locationsReport->txtLocation->DataField = "location";
        locationsReport->txtVisits->DataSet = dbLocationsDataSet;
        locationsReport->txtVisits->DataField = "visits";
        locationsReport->exprTotalVisits->Expression = "SUM(visits)";
        compositeReport->Reports->Add(locationsReport->locationsReport);
      FORM_CATCH
    }
    catch (...)
    {
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    times_run++;
  }

}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComServicesReport::compositeReportFinished(
      TObject *Sender)
{
   //in case
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchComServicesReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

