//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
                                               
#include "launchComVisitReport.h"
#include "codeSearchPerson.h"
#include "reportComVisit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchComVisitReport *formLaunchComVisitReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchComVisitReport::TformLaunchComVisitReport(TComponent* Owner, string id)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  CreateLink(txtName, btnPersonSearch, this, id, "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComVisitReport::btnPersonSearchOnClick(
      TObject *Sender)
{
   // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtName, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComVisitReport::btnCloseOnClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchComVisitReport::btnRunOnClick(TObject *Sender)
{
 string person_id = GetValidLinkId(txtName);
 if (person_id != "")
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Visit report for " + GetPersonName(dbDatabase, person_id, first_last);

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select tasks.date_of_task, tasks.id,  "
            "tasks.person_id, person_names.first_name, person_names.last_name, "
            "affiliations.cdib, tasks.current_id,   "
            "tasks.mileage, tasks.time_spent, com_visit_types.item visit "
            "from tasks, person_names, affiliations, com_visit_types "
            "where tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
            "tasks.current_id >= 3  and "
            "tasks.com_visit_id = com_visit_types.id and "
            "tasks.person_id = person_names.person_id and "
            "tasks.person_id = affiliations.person_id "
            "order by tasks.id";

      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportComDailyVisit * visitReport = new TformReportComDailyVisit(NULL);
        visitReport->visitReport->DataSet = dbDataSet;
        visitReport->lblTitle->Caption = title.c_str();
        visitReport->lblDateTitle->Caption = date_title.c_str();
        visitReport->txtDate->DataSet = dbDataSet;
        visitReport->txtDate->DataField = "date_of_task";
        visitReport->txtCDIB->DataSet = dbDataSet;
        visitReport->txtCDIB->DataField = "cdib";
        visitReport->txtFirstName->DataSet = dbDataSet;
        visitReport->txtFirstName->DataField = "first_name";
        visitReport->txtLastName->DataSet = dbDataSet;
        visitReport->txtLastName->DataField = "last_name";
        visitReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        // visitReport->txtDate->DataField = "date_of_visit";
        visitReport->txtVisit->DataSet = dbDataSet;
        //visitReport->txtVisit->DataField = PrettyString(lookupTables->ValueOf("com_visit_types", "tasks.com_visit_id")).c_str();
        visitReport->exprMileage->Expression = "FORMATNUMERIC('##0.00', mileage)";
        visitReport->exprPatientTime->Expression = "FORMATNUMERIC('##0.00', time_spent)";
        visitReport->txtVisit->DataField = "visit";
        Processing(false);
        visitReport->visitReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;
  }
  else
  {
    PSay("Please enter a client name", m_missing_data, MB_OK);
    btnPersonSearch->SetFocus();
  }
}

//---------------------------------------------------------------------------
void __fastcall TformLaunchComVisitReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

