//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchComWorkloadReport.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformComWorkloadReport *formComWorkloadReport;
//---------------------------------------------------------------------------
__fastcall TformComWorkloadReport::TformComWorkloadReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformComWorkloadReport::compositeReportAdd(TObject *Sender)
{
// change to count where visits > 0
  int num_nurses = 3;

  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {
    FORM_TRY
      workloadReport = new TformReportComWorkload(NULL);
      workloadReport->lblDateTitle->Caption = date_title.c_str();
      //first composite report
      sql = "select count(distinct (tasks.person_id)) total from tasks where "
            "tasks.current_id >= 3 and tasks.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' and "
            "((tasks.method_id = " + lookupTables->IdOf("method_types", "Phone") + ") or "
            "(tasks.visit_location_id > 0 and tasks.com_visit_id > 0))";
      workloadReport->lblPatients->Caption = GetOneField(dbTransaction, sql).c_str();

      sql = "select count(tasks.id) "
            "from tasks "
            "where tasks.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' and "
            "tasks.com_visit_id = 0 and "  // added so the filter wouldn't pull visits (they should come up on a different screen)
            "tasks.method_id = " + lookupTables->IdOf("method_types", "Phone");
      int phone_contacts = StringToInt(GetOneField(dbTransaction, sql));
      workloadReport->lblPhoneVisits->Caption = IntToString(phone_contacts).c_str();

      sql = "select count(tasks.id) from tasks where tasks.person_id > 0 and "
            "tasks.current_id >= 3 and "
            "tasks.visit_location_id > 0 and tasks.com_visit_id > 0 and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "'";
      workloadReport->lblContacts->Caption = IntToString(StringToInt(GetOneField(dbTransaction, sql)) + phone_contacts).c_str();

      Pdate date1(begin_date, mdy|yyyy);
      Pdate date2(end_date, mdy|yyyy);
      int count = 0;

      while (date1<=date2)
      {
        if ((date1.DayOfWeek() < 7) && (date1.DayOfWeek() > 1))
        count ++;
       date1++;
      }

      sql = "select sum(time_spent) from tasks where "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
            "tasks.com_activity_id > 0 and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' and "
            "tasks.current_id >= 3";
      string hours = GetOneField(dbTransaction, sql).c_str();
      float WorkingHours = StringToFloat(hours.c_str());
      WorkingHours = WorkingHours / 8;
      double WorkingDays = count - WorkingHours;
      workloadReport->lblDays->Caption = FloatToString(WorkingDays).c_str();
      workloadReport->lblPatientLoad->Caption = FloatToString(StringToFloat(workloadReport->lblContacts->Caption.c_str()) / WorkingDays).c_str();
      string adpl = FloatToString(StringToFloat(workloadReport->lblPatientLoad->Caption.c_str())/num_nurses).c_str();
      adpl = adpl.substr(1,5);
      workloadReport->lblADPL->Caption = adpl.c_str();
      compositeReport->Reports->Add(workloadReport->workloadReport);
    FORM_CATCH

    FORM_TRY
      // second page in composite report
      workloadVisitreport = new TformReportComWorkloadVisit(NULL);
      sql = "select com_visit_types.item location, count(tasks.id) visits "
            "from com_visit_types left join tasks on tasks.com_visit_id = com_visit_types.id and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
            "tasks.current_id >= 3 and tasks.person_id > 0 and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' "
            "where com_visit_types.valid = 1 and tasks.com_visit_id > 0 and tasks.visit_location_id > 0 "
            "group by com_visit_types.item order by com_visit_types.item";
      dbVisitDataSet->SelectSQL->Add(sql.c_str());
      dbVisitDataSet->Open();
      dbVisitDataSet->First();
      workloadVisitreport->workloadVisitReport->DataSet = dbVisitDataSet;
      workloadVisitreport->txtActivities->DataSet = dbVisitDataSet;
      workloadVisitreport->txtActivities->DataField = "location";
      workloadVisitreport->exprHours->Expression = "FORMATNUMERIC('#,##0', visits)";
      workloadVisitreport->exprTotalHours->Expression = "FORMATNUMERIC('#,##0', SUM((visits)))";
      compositeReport->Reports->Add(workloadVisitreport->workloadVisitReport);
    FORM_CATCH

    FORM_TRY
      // third composite report
      workloadTaskreport = new TformComWorkloadTask(NULL);
      sql = "select com_activity_types.item location, sum(tasks.time_spent) visits "
            "from com_activity_types left join tasks on "
            "tasks.com_activity_id = com_activity_types.id and "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
            "tasks.current_id >= 3 and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' "
            "where com_activity_types.valid = 1 " // and tasks.com_activity_id > 0 " -- Paul removed this at the same time he tried fixing composite reports
            "group by com_activity_types.item order by com_activity_types.item";
      dbTypesDataSet->SelectSQL->Add(sql.c_str());
      dbTypesDataSet->Open();
      dbTypesDataSet->First();
      workloadTaskreport->workloadTaskReport->DataSet = dbTypesDataSet;
      workloadTaskreport->txtType->DataSet = dbTypesDataSet;
      workloadTaskreport->txtType->DataField = "location";
      workloadTaskreport->txtTypeCount->DataSet = dbTypesDataSet;
      workloadTaskreport->txtTypeCount->DataField = "visits";
      workloadTaskreport->exprTotalType->Expression = "FORMATNUMERIC('#,##0', SUM(visits))";
      compositeReport->Reports->Add(workloadTaskreport->workloadTaskReport);
    FORM_CATCH

/*
    com_learner_types <-> com_health_edu
    com_adult_topic_types <-> com_health_edu
    com_method_types <-> com_health_edu
    com_evaluation_types <-> com_health_edu
    com_health_edu <-> tasks
*/

    FORM_TRY
      // more composite report ...
      workloadTopicreport = new TformComWorkloadTopic(NULL);
      sql = "select com_adult_topic_types.item topic, count(tasks.id) visits "
            "from com_adult_topic_types "
            "inner join com_health_edu on com_health_edu.com_adult_topic_id = com_adult_topic_types.id "
            "inner join tasks on com_health_edu.task_id = tasks.id "
            "where "
            "tasks.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
            "tasks.current_id >= 3 and "
            "tasks.person_id > 0 and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' "
            "and "
            "com_adult_topic_types.valid = 1 and "
            "com_adult_topic_types.id > 0 "
            "group by com_adult_topic_types.item order by com_adult_topic_types.item";
      dbTopicsDataSet->SelectSQL->Add(sql.c_str());
      dbTopicsDataSet->Open();
      dbTopicsDataSet->First();
      workloadTopicreport->workloadTopicReport->DataSet = dbTopicsDataSet;
      workloadTopicreport->textType->DataSet     = dbTopicsDataSet;
      workloadTopicreport->textType->DataField   = "topic";
      workloadTopicreport->textCount->DataSet    = dbTopicsDataSet;
      workloadTopicreport->textCount->DataField  = "visits";
      workloadTopicreport->exprTotal->Expression = "FORMATNUMERIC('#,##0', SUM(visits))";
      compositeReport->Reports->Add(workloadTopicreport->workloadTopicReport);
    FORM_CATCH
  }
  catch (...)
  {
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
}
//---------------------------------------------------------------------------
void __fastcall TformComWorkloadReport::compositeReportFinished(
      TObject *Sender)
{
   //in case
}
//---------------------------------------------------------------------------

void __fastcall TformComWorkloadReport::btnRunClick(TObject *Sender)
{
  Processing(true);
  dbVisitDataSet = new TIBDataSet(NULL);
  dbTypesDataSet = new TIBDataSet(NULL);
  dbTopicsDataSet = new TIBDataSet(NULL);
  dbTotalsDataSet = new TIBDataSet(NULL);
  dbTransaction = new TIBTransaction(NULL);

  TQRPageList * source = new TQRPageList();
  TQRPageList * destination = new TQRPageList();
  destination->Stream = new TQRStream(100000);
  TQRPrinter * printer_thing = InitTQRPrinter();

  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbVisitDataSet->Database = dbDatabase;
    dbVisitDataSet->Transaction = dbTransaction;
    dbVisitDataSet->UniDirectional = false;
    dbTypesDataSet->Database = dbDatabase;
    dbTypesDataSet->Transaction = dbTransaction;
    dbTypesDataSet->UniDirectional = false;
    dbTopicsDataSet->Database = dbDatabase;
    dbTopicsDataSet->Transaction = dbTransaction;
    dbTopicsDataSet->UniDirectional = false;
    dbTotalsDataSet->Database = dbDatabase;
    dbTotalsDataSet->Transaction = dbTransaction;
    dbTotalsDataSet->UniDirectional = false;
    dbTransaction->StartTransaction();

     compositeReport->Prepare();
     string file_name = PMakeTempFilePath("page1.qrp");
    ((TQuickRep *)(compositeReport->Reports->First()))->QRPrinter->Save(file_name.c_str());
    // add page 1
    source->Clear();
    source->LoadFromFile(file_name.c_str());
    // meta_file = source->GetPage(1);
    // destination->AddPage(meta_file);
    for (int i = 1; i <= source->PageCount; i++)
      destination->AddPage(source->GetPage(i));
    destination->Finish();
    string temp_filepath = PMakeTempFilePath("complete.qrp");
    destination->SaveToFile(temp_filepath.c_str());
    // load combined report and preview
    printer_thing->Load(temp_filepath.c_str());
    Processing(false);
    printer_thing->PreviewModal();

    workloadReport->CloseNow();
    workloadVisitreport->CloseNow();
    workloadTaskreport->CloseNow();
    workloadTopicreport->CloseNow();

    dbVisitDataSet->Close();
    dbTypesDataSet->Close();
    dbTopicsDataSet->Close();
    dbTotalsDataSet->Close();
    dbTransaction->Commit();

  }
  catch (...)
  {
    Processing(false);  
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbVisitDataSet;
  delete dbTypesDataSet;
  delete dbTopicsDataSet;
  delete dbTotalsDataSet;
  delete printer_thing;
  delete source;
  delete destination;
}
//---------------------------------------------------------------------------

void __fastcall TformComWorkloadReport::btnCloseClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------

void __fastcall TformComWorkloadReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

