//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDentalAppointmentReport.h"
#include "reportDentalAppointment.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDentalApptReport *formLaunchDentalApptReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDentalApptReport::TformLaunchDentalApptReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
   dateFor->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDentalApptReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDentalApptReport::btnCloseClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDentalApptReport::btnRunClick(TObject *Sender)
{
  Processing(true);

  dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string for_date = DateToStr(dateFor->Date).c_str();

  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    sql = "select * from appointments where appointment_date = '" + string(DateToStr(dateFor->Date).c_str()) + "'";

    dbTransaction->StartTransaction();
    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportDentalAppt * report_form = new TformReportDentalAppt(NULL);
      DownloadUserColors();
      Pdate begin_date, end_date;
      begin_date.InDate(dateFor->DateTime);
      end_date.InDate(dateFor->DateTime);
      schedule_class = new classScheduling(report_form->image->Canvas, report_form->image->Width, report_form->image->Height,
                       begin_date, end_date, user_color_map);
      DownloadAppointmentsFromDatabase();
      schedule_class->DrawBlockDayCalendar(all_appointments);
      //blockCalendar = new classScheduler();
      //blockCalendar->DrawBlockCalendar();
      report_form->report->DataSet = dbDataSet;
/*  report_form->groupBand->Expression = "staff";
    report_form->lblDateTitle->Caption = date_title.c_str();
    report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
    report_form->txtStaff->DataSet = dbDataSet;
    report_form->txtStaff->DataField = "staff";
    report_form->txtMethod->DataSet = dbDataSet;
    report_form->txtMethod->DataField = "method";
    report_form->exprContacts->Expression = "FORMATNUMERIC('0', total_contacts)";
    report_form->exprTotal->Expression = "FORMATNUMERIC('0', SUM(total_contacts))";
*/
      Processing(false);
      // report_form->image->
      report_form->report->Preview();
    FORM_CATCH

    dbDataSet->Close();
    dbTransaction->Commit();

  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }

  delete dbTransaction;
  delete dbDataSet;
  if (schedule_class) delete schedule_class;

}
//---------------------------------------------------------------------------
void TformLaunchDentalApptReport::DownloadUserColors()
{
  map<string, string> temp_map;
  string sql = "select users.id, users.user_color from users where users.valid = 1 and users.id > 0";
  SqlToValueMap(dbDatabase, sql, temp_map);
  for(map<string, string>::iterator itr = temp_map.begin(); itr != temp_map.end(); itr++)
    user_color_map[itr->first] = (TColor)StringToInt(itr->second);
}
//---------------------------------------------------------------------------
void TformLaunchDentalApptReport::DownloadAppointmentsFromDatabase()
{
    Screen->Cursor = crHourGlass;
    vector<string> user_ids;
    SqlToVec(dbTransaction, "select id from users where users.valid = 1 and users.id > 0", user_ids);

    Pdate begin_download_date, end_download_date;
    begin_download_date.InDate(dateFor->DateTime);
    end_download_date.InDate(dateFor->DateTime);
    schedule_class->GetBeginEndDates(begin_download_date, end_download_date, block_day_calendar);
    map<string, vector<string> > ids_to_match;
    // ids_to_match["visit_outcome_id"] = "0,1,2,3,4,5,6,7";
    // ids_to_match["current_id"] = "0,1,2,3,4,5";
    DownloadAppointments(dbDatabase, begin_download_date, end_download_date, current_userid, user_ids, vector<string>(), "",
                         all_appointments, ids_to_match, (optionsPermissions["admin.all_appointments"]["enabled"] == "true"),
                         false, "");
    Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------

