//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDepartmentCallLogReport.h"
#include "reportDepartmentCallLog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDepartmentCallLogReport *formLaunchDepartmentCallLogReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDepartmentCallLogReport::TformLaunchDepartmentCallLogReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  lookupTables->RegisterComboBox("groups", cboGroup);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDepartmentCallLogReport::btnRunClick(
      TObject *Sender)
{
  if (! lookupTables->IsInLookUpTable("groups", cboGroup->Text.c_str()))
  {
    PSay("Please enter a valid department", m_invalid_data, MB_OK);
    cboGroup->SetFocus();
  }
  else
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Call Log for " + string(cboGroup->Text.c_str());

    try
    {
      StdTransaction(dbTransaction, dbDatabase);
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select cast(call_log.call_time as date) call_date, "
            "cast(call_log.call_time as time) call_time, "
            "call_log.caller_name, users.item employee_name, "
            "(select users.item from users "
            "where users.id = call_log.receptionist_id) receptionist_name, call_log.note "
            "from call_log, users where call_log.employee_id in "
            "(select users.id from users where users.group_id = " +
            lookupTables->IdOf("groups", cboGroup->Text.c_str()) + ") and "
            "call_log.employee_id = users.id and "
            "call_log.call_time >= '" + begin_date + " 00:01:00'and "
            "call_log.call_time <= '" + end_date + " 23:59:01' "
            "order by call_log.call_time";

      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportDepartmentCallLog * report = new TformReportDepartmentCallLog(NULL);
        report->departmentLogReport->DataSet = dbDataSet;
        report->lblTitle->Caption = title.c_str();
        report->lblDateTitle->Caption = date_title.c_str();
        report->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        report->txtDate->DataSet = dbDataSet;
        report->txtDate->DataField = "call_date";
        report->txtTime->DataSet = dbDataSet;
        report->txtTime->DataField = "call_time";
        report->txtCaller->DataSet = dbDataSet;
        report->txtCaller->DataField = "caller_name";
        report->txtEmployee->DataSet = dbDataSet;
        report->txtEmployee->DataField = "employee_name";
        report->txtReceptionist->DataSet = dbDataSet;
        report->txtReceptionist->DataField = "receptionist_name";
        report->txtNote->DataSet = dbDataSet;
        report->txtNote->DataField = "note";
        Processing(false);
        report->departmentLogReport->Preview();
      FORM_CATCH

      dbDataSet->Close();
      dbTransaction->Commit();

    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDepartmentCallLogReport::FormClose(
      TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("groups", cboGroup);
  TformSpecialGeneric::FormClose(Sender, Action);        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDepartmentCallLogReport::btnCloseClick(
      TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDepartmentCallLogReport::cboGroupKeyPress(
      TObject *Sender, char &Key)
{
  FindComboBoxItem(Sender, Key);        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDepartmentCallLogReport::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

