//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDepartmentCallTotalsReport.h"
#include "reportDepartmentCallTotals.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDepartmentCallTotalsReport *formLaunchDepartmentCallTotalsReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDepartmentCallTotalsReport::TformLaunchDepartmentCallTotalsReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDepartmentCallTotalsReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDepartmentCallTotalsReport::btnRunClick(
      TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {
    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;


    sql = "select groups.item department, "
          "(select count (call_log.call_time) from call_log "
          "where call_log.employee_id in "
          "(select users.id from users "
          "where users.group_id = groups.id) and "
          "call_log.call_time >= '" + begin_date + " 00:01:00' and "
          "call_log.call_time <= '" + end_date + " 23:59:00') total_calls "
          "from groups order by groups.item";

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportDepartmentCallTotals * totalsReport = new TformReportDepartmentCallTotals(NULL);
      totalsReport->departmentTotalsReport->DataSet = dbDataSet;
      totalsReport->lblDateTitle->Caption = date_title.c_str();
      totalsReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      totalsReport->txtDepartment->DataSet = dbDataSet;
      totalsReport->txtDepartment->DataField = "department";
      totalsReport->txtTotal->DataSet = dbDataSet;
      totalsReport->txtTotal->DataField = "total_calls";
      totalsReport->exprTotal->Expression = "SUM(total_calls)";
      Processing(false);
      totalsReport->departmentTotalsReport->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }

  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDepartmentCallTotalsReport::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

