//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabActivitiesByOutcomeReport.h"
#include "reportDiabActivitiesByOutcome.h"
#include "scheduling.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabActivitiesByOutcome *formLaunchDiabActivitiesByOutcome;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabActivitiesByOutcome::TformLaunchDiabActivitiesByOutcome(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  lookupTables->RegisterComboBox("users", cboEmployee);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabActivitiesByOutcome::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabActivitiesByOutcome::btnRunClick(TObject *Sender)
{
  if(lookupTables->IsInLookUpTable("users", cboEmployee->Text.c_str()))
  {
    Processing(true);

//  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
//  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    Pdate begin_date;
    begin_date.InDate(dateBegin->Date);
    Pdate end_date;
    end_date.InDate(dateEnd->Date);
    string date_title = begin_date.OutDate(mdy | yyyy) + " - " + end_date.OutDate(mdy | yyyy);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbTransaction->StartTransaction();
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;
      string sql;

      ExecuteStatement(dbTransaction, "delete from appointment_reports");
      PApptOccurrenceMap all_appointments;
      vector<string> user_ids;
      if(radioDepartment->Checked)
        SqlToVec(dbTransaction, "select id from users where group_id = " + lookupTables->IdOf("groups", "Diabetes") +
                 " and valid = 1", user_ids);
      else
        user_ids.push_back(lookupTables->IdOf("users", cboEmployee->Text.c_str()));
      PApptIDMapVec ids_to_match;
      ids_to_match["current_id"].push_back("3");
      ids_to_match["current_id"].push_back("4");
      ids_to_match["current_id"].push_back("5");
      pmapstrs insert_map;
      DownloadAppointments(dbDatabase, begin_date, end_date, current_userid, user_ids, vector<string>(), "",
                           all_appointments, ids_to_match, (optionsPermissions["admin.all_appointments"]["enabled"] == "true"),
                           false, "");
      for(PApptOccurrenceMap::iterator itr = all_appointments.begin(); itr != all_appointments.end(); itr++)
      {
        for(PApptOccurrenceSet::iterator set_itr = itr->second.begin(); set_itr != itr->second.end(); set_itr++)
        {
          insert_map["id"] = (*set_itr).id;
          insert_map["appt_date"] = itr->first.OutDate(mdy | yyyy);
          insert_map["appt_time"] = (*set_itr).range_begin.OutTime(military | withsec);
          ExecuteInsertStatement(dbTransaction, "appointment_reports", insert_map);
        }
      }
      sql = "select case when ART.item = '' then '(Unspecified)' else ART.item end reason, "
            "case when VOT.item = '' then '(Unspecified)' else VOT.item end outcome, "
            "count(appointment_reports.id) the_count "
            "from appointment_reports "
            "inner join appointments on appointment_reports.id = appointments.id "
            "left  join appt_reason_types ART on appointments.appt_reason_id = ART.id "
            "left  join visit_outcome_types VOT on appointments.visit_outcome_id = VOT.id "
            "where 1=1 ";
      if(checkClients->Checked)
        sql += "and appointments.person_id > 0 ";
      if(checkNoBlocks->Checked) // jhaley 20110720
        sql += "and appointments.appt_reason_id <> " + lookupTables->IdOf("appt_reason_types", "Block Schedule");
      sql += "group by 1, 2";

      string title = "Appointment Reasons by Outcome - ";
      if(radioEmployee->Checked)
        title += cboEmployee->Text.c_str();
      else if(radioDepartment->Checked) // TODO: seems like it could easily work for any department to me
        title += "Diabetes";
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      // Create the report
      TformReportDiabActivitiesByOutcome * report;
      FORM_TRY
        report = new TformReportDiabActivitiesByOutcome(NULL);
      FORM_CATCH
      report->lblTitle->Caption = title.c_str();
      report->lblDateTitle->Caption = date_title.c_str();
      report->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      report->report->DataSet = dbDataSet;
      report->bandGroup->Expression = "reason";
      report->txtReason->DataSet = dbDataSet;
      report->txtReason->DataField = "reason";
      report->txtOutcome->DataSet = dbDataSet;
      report->txtOutcome->DataField = "outcome";
      report->txtCount->DataSet = dbDataSet;
      report->txtCount->DataField = "the_count";
      report->exprTotal->Expression = "SUM(the_count)";
      Processing(false);
      report->report->Preview();

      dbDataSet->Close();
      
      ExecuteStatement(dbTransaction, "delete from appointment_reports");
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabActivitiesByOutcome::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabActivitiesByOutcome::FormClose(
      TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("users", cboEmployee);
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------

