//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabActivityReport.h"
#include "codeSearchPerson.h"
#include "reportDiabActivity.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabActivityReport *formLaunchDiabActivityReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabActivityReport::TformLaunchDiabActivityReport(TComponent* Owner, string id)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  CreateLink(txtName, btnPersonSearch, this, id, "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabActivityReport::btnPersonSearchClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtName, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabActivityReport::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabActivityReport::btnRunClick(TObject *Sender)
{
  string person_id = GetValidLinkId(txtName);
  if (person_id != "")
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Activity report for " + GetPersonName(dbDatabase, person_id, first_last);

    try
    {
      StdTransaction(dbTransaction, dbDatabase);
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select activities.date_of_activity, activity_code_types.item activity, "
            "intensity_types.item intensity, activities.distance, activities.time_spent, "
            "activities.steps "
            "from activities, activity_code_types, intensity_types "
            "where activities.activity_code_id = activity_code_types.id and "
            "activities.intensity_id = intensity_types.id and "
            "activities.date_of_activity >= '" + begin_date + "' and "
            "activities.date_of_activity <= '" + end_date + "' and "
            "activities.person_id = " + person_id + " and "
            "activities.current_id >= 3 "
            "order by activities.date_of_activity";

      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportDiabActivity * activityReport = new TformReportDiabActivity(NULL);
        activityReport->activityReport->DataSet = dbDataSet;
        activityReport->lblTitle->Caption = title.c_str();
        activityReport->lblDateTitle->Caption = date_title.c_str();
        activityReport->txtDate->DataSet = dbDataSet;
        activityReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        activityReport->txtDate->DataField = "date_of_activity";
        activityReport->txtActivity->DataSet = dbDataSet;
        activityReport->txtActivity->DataField = "activity";
        activityReport->txtIntensity->DataSet = dbDataSet;
        activityReport->txtIntensity->DataField = "intensity";
        activityReport->exprTime->Expression = "FORMATNUMERIC('##0.00', time_spent)";
        activityReport->exprDistance->Expression = "FORMATNUMERIC('##0.00', distance)";
        activityReport->exprSteps->Expression = "FORMATNUMERIC('##,##0.00', steps)";
        Processing(false);
        activityReport->activityReport->Preview();
      FORM_CATCH


      dbDataSet->Close();
      dbTransaction->Commit();

    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }
  else
  {
    PSay("Please enter a client name", m_missing_data, MB_OK);
    btnPersonSearch->SetFocus();
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabActivityReport::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

