//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabActivitySummaryReport.h"
#include "reportDiabActivitySummary.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabActivitySummaryReport *formLaunchDiabActivitySummaryReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabActivitySummaryReport::TformLaunchDiabActivitySummaryReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabActivitySummaryReport::btnCloseClick(
      TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabActivitySummaryReport::btnRunClick(
      TObject *Sender)
{
  Processing(true);
  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {
    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix name, "
          "activities.date_of_activity, "
          "activity_code_types.item activity, intensity_types.item intensity, activities.distance, "
          "activities.time_spent, activities.steps "
          "from activities "
          "inner join intensity_types on activities.intensity_id = intensity_types.id "
          "inner join activity_code_types on activities.activity_code_id = activity_code_types.id "
          "inner join people on activities.person_id = people.id "
          "left join person_names on people.person_names_id = person_names.id "
          "where activities.date_of_activity between '" + begin_date + "' and '" + end_date + "' and "
          "people.current_id >= 3 and "
          //"people.is_diabetes_client = 1 and "
          "exists (select DCE.id from enrollment DCE where DCE.person_id = people.id and DCE.current_id+1 >= 4 and "
          " DCE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "') and "
          "activities.current_id >= 3 "
          "order by person_names.last_name, person_names.first_name, "
          "activities.date_of_activity";

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportDiabActivitySummary * activityReport = new TformReportDiabActivitySummary(NULL);
      activityReport->activityReport->DataSet = dbDataSet;
      activityReport->lblDateTitle->Caption = date_title.c_str();
      activityReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      activityReport->txtName->DataSet = dbDataSet;
      activityReport->txtName->DataField = "name";
      activityReport->txtDate->DataSet = dbDataSet;
      activityReport->txtDate->DataField = "date_of_activity";
      activityReport->txtActivity->DataSet = dbDataSet;
      activityReport->txtActivity->DataField = "activity";
      activityReport->txtIntensity->DataSet = dbDataSet;
      activityReport->txtIntensity->DataField = "intensity";
      activityReport->exprTime->Expression = "FORMATNUMERIC('##0.00', time_spent)";
      activityReport->exprDistance->Expression = "FORMATNUMERIC('##0.00', distance)";
      activityReport->exprSteps->Expression = "FORMATNUMERIC('#,##0.00', steps)";
      Processing(false);
      activityReport->activityReport->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabActivitySummaryReport::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

