//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabAttendanceReport.h"
#include "codeSearchPerson.h"
#include "reportDiabAttendance.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabAttendaceReport *formLaunchDiabAttendaceReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabAttendaceReport::TformLaunchDiabAttendaceReport(TComponent* Owner, string id)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  CreateLink(txtName, btnPersonSearch, this, id, "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabAttendaceReport::btnPersonSearchClick(
      TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtName, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabAttendaceReport::btnCloseClick(
      TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabAttendaceReport::btnRunClick(
      TObject *Sender)
{
  string person_id = GetValidLinkId(txtName);
  if (person_id != "")
  {
    Processing(true);
    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Fitness attendance report for " + GetPersonName(dbDatabase, person_id, first_last) +
                   " grouped by fitness membership";

    try
    {
      StdTransaction(dbTransaction, dbDatabase);
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select fit_facility_types.item facility, fitness_memberships.begin_date, "
            "fitness_attendance.date_of_attendance, fitness_memberships.id "
            "from fit_facility_types, fitness_memberships, fitness_attendance "
            "where fitness_attendance.person_id = " + person_id + " and "
            "fitness_attendance.fitness_membership_id = fitness_memberships.id and "
            "fitness_memberships.fit_facility_id = fit_facility_types.id and "
            "fitness_attendance.date_of_attendance >= '" + begin_date + "' and "
            "fitness_attendance.date_of_attendance <= '" + end_date + "' and "
            "fitness_attendance.current_id >= 3 "
            "order by fitness_memberships.id, fitness_attendance.date_of_attendance";

      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportDiabAttendance * attendanceReport = new TformReportDiabAttendance(NULL);
        attendanceReport->activityReport->DataSet = dbDataSet;
        attendanceReport->lblTitle->Caption = title.c_str();
        attendanceReport->lblDateTitle->Caption = date_title.c_str();
        attendanceReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        attendanceReport->groupBand->Expression = "id";
        attendanceReport->txtFacility->DataSet = dbDataSet;
        attendanceReport->txtFacility->DataField = "facility";
        attendanceReport->txtSignUp->DataSet = dbDataSet;
        attendanceReport->txtSignUp->DataField = "begin_date";
        attendanceReport->txtAttendance->DataSet = dbDataSet;
        attendanceReport->txtAttendance->DataField = "date_of_attendance";
        Processing(false);
        attendanceReport->activityReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;
  }
  else
  {
    PSay("Please enter a client name", m_database_error, MB_OK);
    btnPersonSearch->SetFocus();
  }        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabAttendaceReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

