//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabAvgScoresPerTopicReport.h"
#include "reportDiabAvgScoresPerTopic.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabAvgScoresPerTopicReport *formLaunchDiabAvgScoresPerTopicReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabAvgScoresPerTopicReport::TformLaunchDiabAvgScoresPerTopicReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabAvgScoresPerTopicReport::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabAvgScoresPerTopicReport::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabAvgScoresPerTopicReport::btnRunClick(TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;
  string unique_people;

  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;
    dbTransaction->StartTransaction();
    sql = "select count(distinct person_id) from diab_education where "
          "((diab_education.pre_test_date >= '" + begin_date + "' and diab_education.pre_test_date <= '" + end_date + "') or "
          "(diab_education.post_test_date >= '" + begin_date + "' and diab_education.post_test_date <= '" + end_date + "'))";
    unique_people = GetOneField(dbTransaction, sql);

    sql = "select diab_topic_types.item topic, count(outer_table.id) total_clients, sum(outer_table.pre_score) pre_score_sum, "
          "(select count(pre_inner.pre_score) from diab_education pre_inner where pre_inner.pre_score is not null "
           "and pre_inner.pre_test_date is not null and pre_inner.person_id > 0 and "
           "pre_inner.diab_topic_id = outer_table.diab_topic_id and "
           "((pre_inner.pre_test_date >= '" + begin_date + "' and pre_inner.pre_test_date <= '" + end_date + "') or "
            "(pre_inner.post_test_date >= '" + begin_date + "' and pre_inner.post_test_date <= '" + end_date + "'))) pre_score_count, "
          "sum(outer_table.post_score) post_score_sum, "
          "(select count(post_inner.post_score) from diab_education post_inner where post_inner.post_score is not null "
           "and post_inner.post_test_date is not null and post_inner.person_id > 0 and "
           "post_inner.diab_topic_id = outer_table.diab_topic_id and "
           "((post_inner.pre_test_date >= '" + begin_date + "' and post_inner.pre_test_date <= '" + end_date + "') or "
            "(post_inner.post_test_date >= '" + begin_date + "' and post_inner.post_test_date <= '" + end_date + "'))) post_score_count "
          "from diab_education outer_table "
          "inner join diab_topic_types on outer_table.diab_topic_id = diab_topic_types.id "
          "where outer_table.person_id > 0 and "
          "((outer_table.pre_test_date >= '" + begin_date + "' and outer_table.pre_test_date <= '" + end_date + "') or "
          "(outer_table.post_test_date >= '" + begin_date + "' and outer_table.post_test_date <= '" + end_date + "')) "
          "group by diab_topic_types.item, outer_table.diab_topic_id";

    DebugSql(this, &sql, other_forms, 9, dbTransaction);

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportDiabAvgScoresPerTopic * report_form = new TformReportDiabAvgScoresPerTopic(NULL);
      report_form->report->DataSet = dbDataSet;
      report_form->lblDateTitle->Caption = date_title.c_str();
      report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      report_form->txtTopic->DataSet = dbDataSet;
      report_form->txtTopic->DataField = "topic";
      report_form->exprPeople->Expression = "total_clients";
      report_form->exprAvgPreScore->Expression = "IF(pre_score_count > 0, FORMATNUMERIC('0.0', pre_score_sum / pre_score_count), '0.0')";
      report_form->exprAvgPostScore->Expression = "IF(post_score_count > 0, FORMATNUMERIC('0.0', post_score_sum / post_score_count), '0.0')";
      report_form->exprAvgImprovement->Expression = "IF(post_score_count > 0, FORMATNUMERIC('0.0', (post_score_sum / post_score_count) - (pre_score_sum / pre_score_count)), '0.0')";
      report_form->lblTotalPeople->Caption = unique_people.c_str();
      report_form->exprTotalAvgPreScore->Expression = "FORMATNUMERIC('0.0', SUM(pre_score_sum) / SUM(pre_score_count))";
      report_form->exprTotalAvgPostScore->Expression = "IF(SUM(post_score_count) > 0, FORMATNUMERIC('0.0', SUM(post_score_sum) / SUM(post_score_count)), '0.0')";
      report_form->exprTotalAvgImprovement->Expression = "IF(SUM(post_score_count) > 0, FORMATNUMERIC('0.0', (SUM(post_score_sum) / SUM(post_score_count)) - "
                                                         "(SUM(pre_score_sum) / SUM(pre_score_count))), '0.0')";
      Processing(false);
      report_form->report->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
