//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabCareSummaryReport.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "launchGeneric"
#pragma resource "*.dfm"

#include "reportDiabCareSummary.h"
TformLaunchDiabCareSummaryReport *formLaunchDiabCareSummaryReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabCareSummaryReport::TformLaunchDiabCareSummaryReport(TComponent* Owner, string p_id)
        : TformLaunchGeneric(Owner)
{
  Pdate today_date(Date());
  Pdate begin_date = today_date;
  begin_date.day   = 1;           // first day of this month
  Pdate end_date = begin_date;    // first day of this month
  begin_date.mod(-1, in_months);  // first day of last month
  end_date.mod(-1, in_days);      // last day of last month

  dateBegin->Date = begin_date.OutDate();
  dateEnd->Date   = end_date.OutDate();
}
//---------------------------------------------------------------------------
bool TformLaunchDiabCareSummaryReport::BeforeRunReport()
{
  dbDataset = NULL;
  dbDataset = new TIBDataSet(NULL);
  return TformLaunchGeneric::BeforeRunReport();
}
//---------------------------------------------------------------------------
bool TformLaunchDiabCareSummaryReport::RunReport()
{
  checkpoint_branch = "Main";
  checkpoint = 0;
  string sql;

/*
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  dbDataset->Database = dbDatabase;
  dbDataset->Transaction = report_transaction;
  dbDataset->UniDirectional = false;

  TformReportCHSBillingWorkload *report = NULL;
  FORM_TRY
    report = new TformReportCHSBillingWorkload(NULL);
  FORM_CATCH

  string group_id = lookupTables->IdOf("groups", "Third Party Billing");

  vector<string> employee_vec;
  sql = "select coalesce(users.item, '') || ' - ' || coalesce(users.title, '') employee "
        "from users where users.valid = 1 and "
        "users.group_id = '" + group_id + "' "
        "order by users.i_level desc, users.item";
  SqlToVec(report_transaction, sql, employee_vec);
  for(vector<string>::iterator itr = employee_vec.begin(); itr != employee_vec.end(); itr++)
     report->memoEmployees->Lines->Add((*itr).c_str());

  sql = "select bill_types.id bill_id, bill_types.item bill_type, area_types.id area_id, area_types.item area_type, tax_entities.id tax_entity_id, tax_entities.name, "
        "tin.identifier, sum(transactions.debit_amount - transactions.credit_amount) paid, count(bills.id) num_bills, count(distinct(bills.purchase_req_id)) num_prs "
        "from tax_entities "
        "right join bills on bills.actual_tax_id = tax_entities.id "
        "inner join bill_types on bills.bill_id = bill_types.id "
        "left join purchase_reqs on bills.purchase_req_id = purchase_reqs.id "
        "inner join transactions on transactions.bill_id = bills.id and transactions.account_id in (select accounts.id from accounts where account_type_id = " + lookupTables->IdOf("account_types", "Expense") + ") "
        "left join tasks visit on bills.task_id = visit.id and visit.parent_task_id > 0 and visit.group_id = " + lookupTables->IdOf("groups", "Contract Health") + " and visit.services_provided_id = 0 "
        "left join tasks cob on visit.parent_task_id = cob.id and cob.parent_task_id = 0 and cob.group_id = " + lookupTables->IdOf("groups", "Contract Health") + " and cob.services_provided_id > 0 "
        "left join services_provided on cob.services_provided_id = services_provided.id "
        "left join area_types on services_provided.area_id = area_types.id "
        "left join entity_ids tin on tin.tax_entity_id = tax_entities.id and tin.current_id >= 3 and tin.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "TIN/EIN") + "' "
        "where bills.purchase_req_id > 0 and tax_entities.id > 0 and purchase_reqs.date_sent between '" + begin_date + "' and '" + end_date + "' "
        "and purchase_reqs.last_updated_by in (select id from users where group_id = " + group_id + ") "
        "group by bill_types.id, bill_types.item, area_types.id, area_types.item, tax_entities.id, tax_entities.name, tin.identifier, tax_entities.current_id, tax_entities.id "
        "having sum(transactions.debit_amount - transactions.credit_amount) > 0.00 "
        "order by bill_types.item, bill_types.id, area_types.item, area_types.id, tax_entities.name, tax_entities.id ";

  DebugSql(this, &sql, report_transaction, other_forms, 9);

  dbDataset->SelectSQL->Clear();
  dbDataset->SelectSQL->Add(sql.c_str());
  dbDataset->Open();
  dbDataset->First();

  report->report->DataSet = dbDataset;
  report->lblDateTitle->Caption = date_title.c_str();
  report->lblUser->Caption = current_fullname.c_str();
  report->txtBillType->DataSet = dbDataset;
  report->txtBillType->DataField = "bill_type";
  report->txtServiceArea->DataSet = dbDataset;
  report->txtServiceArea->DataField = "area_type";
  report->txtTaxEntity->DataSet = dbDataset;
  report->txtTaxEntity->DataField = "name";
  report->txtTaxID->DataSet = dbDataset;
  report->txtTaxID->DataField = "taxid";
  report->txtBills->DataSet = dbDataset;
  report->txtBills->DataField = "num_bills";
  report->txtPRs->DataSet = dbDataset;
  report->txtPRs->DataField = "num_prs";
  report->exprPaid->Expression = "FORMATNUMERIC('$###,###,##0.00', paid)";
  report->exprPaidServiceTotal->Expression = "FORMATNUMERIC('$###,###,##0.00', SUM(paid))";
  report->exprBillsServiceTotal->Expression = "FORMATNUMERIC('###,###,##0', SUM(num_bills))";
  report->exprPRsServiceTotal->Expression = "FORMATNUMERIC('###,###,##0', SUM(num_prs))";
  report->exprPaidBillTypeTotal->Expression = "FORMATNUMERIC('$###,###,##0.00', SUM(paid))";
  report->exprBillsBillTypeTotal->Expression = "FORMATNUMERIC('###,###,##0', SUM(num_bills))";
  report->exprPRsBillTypeTotal->Expression = "FORMATNUMERIC('###,###,##0', SUM(num_prs))";

  report->bandGroupHeader->Expression = "bill_id";
  report->bandGroupHeader->Height = 22;

  report->bandGroupHeader2->Expression = "area_id";
  report->bandGroupHeader2->Height = 22;

  vector<map<string, string> > letters;
  sql = "select area_types.item area, count(denial_letters.id) num_letters "
        "from denial_letters "
        "inner join services_provided on denial_letters.services_provided_id = services_provided.id "
        "inner join area_types on services_provided.area_id = area_types.id "
        "where denial_letters.date_processed between '" + begin_date + "' and '" + end_date + "' "
        "group by area_types.id, area_types.item "
        "having count(denial_letters.id) > 0 "
        "order by area_types.item ";
  DebugSql(this, &sql, report_transaction, other_forms, 9);
  SqlToVecMap(report_transaction, sql, letters);
  if (letters.empty())
  {
    report->bandSummary->Enabled = false;
    report->bandSummary->Height = 0;
    report->bandSummaryChild->Enabled = false;
    report->bandSummaryChild->Height = 0;
  }
  else
  {
    int total_letters = 0;
    for (vector<map<string, string> >::iterator itr = letters.begin(); itr != letters.end(); itr++)
    {
      report->memoLetterType->Lines->Add((PrettyString((*itr)["area"])).c_str());
      report->memoLetterCount->Lines->Add((PrettyString((*itr)["num_letters"])).c_str());
      total_letters += StringToInt((*itr)["num_letters"]);
    }
    report->lblLetterTotal->Caption = IntToString(total_letters).c_str();
  }

// commented out starting here
  if (radioDetail->Checked)
  {
    report->bandDetail->Height = 16;
    report->bandChild->Enabled = true;
    report->bandChild->Height = 16;

    report->txtPersonName->DataSet = dbDataset;
    report->txtPersonName->DataField = "person_name";
    report->txtCobDate->DataSet = dbDataset;
    report->txtCobDate->DataField = "cob_date";
    report->txtCobNumber->DataSet = dbDataset;
    report->txtCobNumber->DataField = "cob_number";
    report->txtCobExpense->DataSet = dbDataset;
    report->txtCobExpense->DataField = "cob_expense";                   // TODO:  Expense fields should be Expression's, FORMATNUMERIC'd
    report->txtUnpaidVisitDate->DataSet = dbDataset;
    report->txtUnpaidVisitDate->DataField = "unpaid_visit_date";
    report->txtUnpaidBillDate->DataSet = dbDataset;
    report->txtUnpaidBillDate->DataField = "unpaid_bill_date";
    report->txtUnpaidPrDate->DataSet = dbDataset;
    report->txtUnpaidPrDate->DataField = "unpaid_pr_date";
    report->txtUnpaidPrNumber->DataSet = dbDataset;
    report->txtUnpaidPrNumber->DataField = "unpaid_pr_number";
    report->txtUnpaidExpense->DataSet = dbDataset;
    report->txtUnpaidExpense->DataField = "unpaid_expense";
    report->txtPaidVisitDate->DataSet = dbDataset;
    report->txtPaidVisitDate->DataField = "paid_visit_date";
    report->txtPaidBillDate->DataSet = dbDataset;
    report->txtPaidBillDate->DataField = "paid_bill_date";
    report->txtPaidPrDate->DataSet = dbDataset;
    report->txtPaidPrDate->DataField = "paid_pr_date";
    report->txtPaidPrNumber->DataSet = dbDataset;
    report->txtPaidPrNumber->DataField = "paid_pr_number";
    report->txtPaidCheckDate->DataSet = dbDataset;
    report->txtPaidCheckDate->DataField = "paid_check_date";
    report->txtPaidCheckNumber->DataSet = dbDataset;
    report->txtPaidCheckNumber->DataField = "paid_check_number";
    report->txtPaidExpense->DataSet = dbDataset;
    report->txtPaidExpense->DataField = "paid_expense";

    report->exprTotalCobVisits->Expression = "SUM(cob_visits)";
    report->exprTotalCobPeople->Expression = "SUM(cob_people)";
    report->exprTotalCobAmount->Expression = "FORMATNUMERIC('$###,###,##0.00', SUM(cob_expense))";
    report->exprTotalUnpaidVisits->Expression = "SUM(unpaid_visits)";
    report->exprTotalUnpaidPeople->Expression = "SUM(unpaid_people)";
    report->exprTotalUnpaidAmount->Expression = "FORMATNUMERIC('$###,###,##0.00', SUM(unpaid_expense))";
    report->exprTotalPaidVisits->Expression = "SUM(paid_visits)";
    report->exprTotalPaidPeople->Expression = "SUM(paid_people)";
    report->exprTotalPaidAmount->Expression = "FORMATNUMERIC('$###,###,##0.00', SUM(paid_expense))";

    if (how_to_run == by_service || how_to_run == by_service_area)
    {
      report->txtProvider->Enabled = false;      // because this data isn't useful in by_service mode
      report->lblProvider->Enabled = false;      // because that column is now empty
      report->txtDetailProvider->Enabled = true; // because we don't have a provider on the group header rows so we put it on the per-visit rows
      report->txtDetailProvider->DataSet = dbDataset;
      report->txtDetailProvider->DataField = "provider"; // and populate it, yup
    }
  }
  else
  {
    report->bandDetail->Height = 0;
    report->bandChild->Enabled = false;
    report->bandChild->Height = 0;

    report->exprTotalCobVisits->Expression = "SUM(cob_visits)";
    report->exprTotalCobPeople->Expression = "SUM(cob_people)";
    report->exprTotalCobAmount->Expression = "FORMATNUMERIC('$###,###,##0.00', SUM(cob_amount))";
    report->exprTotalUnpaidVisits->Expression = "SUM(unpaid_visits)";
    report->exprTotalUnpaidPeople->Expression = "SUM(unpaid_people)";
    report->exprTotalUnpaidAmount->Expression = "FORMATNUMERIC('$###,###,##0.00', SUM(unpaid_amount))";
    report->exprTotalPaidVisits->Expression = "SUM(paid_visits)";
    report->exprTotalPaidPeople->Expression = "SUM(paid_people)";
    report->exprTotalPaidAmount->Expression = "FORMATNUMERIC('$###,###,##0.00', SUM(paid_amount))";
  }
*/

//  Processing(false);
//  report->report->Preview();

  dbDataset->Close();

  return true;
}
//---------------------------------------------------------------------------
bool TformLaunchDiabCareSummaryReport::AfterRunReport()
{
  delete dbDataset;

  bool all_is_well = TformLaunchGeneric::AfterRunReport();

  /*  err ... copy paste oversight?  This stuff is from the CHS obligated/paid (expensed) report...
  all_is_well = all_is_well && ExecuteStatement(report_transaction, "delete from temp_obpd_cobs"); checkpoint++;
  all_is_well = all_is_well && ExecuteStatement(report_transaction, "delete from temp_obpd_visits"); checkpoint++;
  all_is_well = all_is_well && ExecuteStatement(report_transaction, "delete from temp_obpd_cob_expense"); checkpoint++;
  all_is_well = all_is_well && ExecuteStatement(report_transaction, "delete from temp_obpd_bill_expense"); checkpoint++;
  all_is_well = all_is_well && ExecuteStatement(report_transaction, "delete from temp_obpd_totals"); checkpoint++;
  all_is_well = all_is_well && ExecuteStatement(report_transaction, "delete from temp_obpd_services_provided"); checkpoint++;
  */
  return all_is_well;
}
//---------------------------------------------------------------------------

