//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabCheckCountReport.h"
#include "reportDiabCheckCount.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabCheckCountReport *formLaunchDiabCheckCountReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabCheckCountReport::TformLaunchDiabCheckCountReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabCheckCountReport::btnRunClick(
      TObject *Sender)
{
 // run report
 if ((editLessThan->Text != "") && IsInt(editLessThan->Text.c_str()) && (StringToInt(editLessThan->Text.c_str()) > 0))
 {
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;

  try
  {
   dbTransaction->DefaultDatabase = dbDatabase;
   dbDataSet->Database = dbDatabase;
   dbDataSet->Transaction = dbTransaction;
   dbDataSet->UniDirectional = false;

   // TODO: last date of measurement / measurements isn't very precise about which department did it, which questions were asked/answered, group_id ... all those important things.
   sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix name, "
         "(select min(obs_response_sets.date_of_observation) from obs_response_sets where "
          "people.id = obs_response_sets.person_id) date_of_measurement, "
         "(select count(incentives.id) from incentives where incentives.person_id = people.id and "
          "incentives.current_id >= 3 and incentives.incentive_id = " + lookupTables->IdOf("incentive_types", "Check") + ") check_count "
         "from people "
         "left join person_names on people.person_names_id = person_names.id "
         "where people.current_id >= 3 and "
         "exists (select enrollment.id from enrollment "   // jhaley: changed steps_member -> enrollment
          "where enrollment.person_id = people.id and enrollment.current_id+1 >= 4 and "
          "enrollment.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "STEPS Participant") + "' and "
          "enrollment.enrollment_status_id = '" + lookupTables->IdOf("enrollment_status_types", "Member") + "') and "
         "(select count(incentives.id) from incentives where incentives.person_id = people.id and "
          "incentives.current_id >= 3 and "
          "incentives.incentive_id = " + lookupTables->IdOf("incentive_types", "Check") + " and "
          "incentives.date_sent_to_finance is not null) < '" + string(editLessThan->Text.c_str())+ "' "
         "order by 3, person_names.last_name, person_names.first_name";

   dbTransaction->StartTransaction();
   dbDataSet->SelectSQL->Add(sql.c_str());
   dbDataSet->Open();
   dbDataSet->First();

   FORM_TRY
     TformReportDiabCheckCount * check_count_report = new TformReportDiabCheckCount(NULL);
     check_count_report->check_count_report->DataSet = dbDataSet;
     if (editLessThan->Text == "1")
       check_count_report->labelTitle->Caption = string("Steps participants that have had less than " + string(editLessThan->Text.c_str()) + " check so far").c_str();
     else
       check_count_report->labelTitle->Caption = string("Steps participants that have had less than " + string(editLessThan->Text.c_str()) + " checks so far").c_str();
     check_count_report->labelUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
     check_count_report->textName->DataSet = dbDataSet;
     check_count_report->textName->DataField = "name";
     check_count_report->textDate->DataSet = dbDataSet;
     check_count_report->textDate->DataField = "date_of_measurement";
     check_count_report->textCount->DataSet = dbDataSet;
     check_count_report->textCount->DataField = "check_count";
     Processing(false);
     check_count_report->check_count_report->Preview();
   FORM_CATCH
   dbDataSet->Close();
   dbTransaction->Commit();
  }
  catch (...)
  {
   Processing(false);
   PSay("Error running report", m_database_error, MB_OK);
   if (dbTransaction->Active)
    dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
 }
 else
  PSay("Please enter a valid number of checks", m_invalid_data, MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabCheckCountReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabCheckCountReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

