//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabCommentReport.h"
#include "reportDiabComment.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabCommentReport *formLaunchDiabCommentReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabCommentReport::TformLaunchDiabCommentReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  if (optionsPermissions["report.beh"]["enabled"] != "true")
    checkBeh->Enabled = false;
  if (optionsPermissions["report.diab"]["enabled"] != "true")
  {
    checkDiabetes->Enabled = false;
    checkSteps->Enabled = false;
    checkCondition->Enabled = false;
  }
  if (optionsPermissions["special.beh.general"]["enabled"] == "true")
    checkBeh->Checked = true;

}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabCommentReport::btnRunClick(TObject *Sender)
{
  Processing(true);
  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string date_title = "Comment Report - ";
  date_title += DateToStr(Now()).c_str();
  string where;

  try
  {
    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix name, "
          "current_types.item current_type, "
          "cast(person_notes.last_update_stamp as date) last_update, person_notes.note "
          "from people left join person_names on people.person_names_id = person_names.id, "
          "person_notes, current_types "
          "where person_notes.person_id = people.id and "
          "person_notes.current_id = current_types.id ";
    if (checkDiabetes->Checked)
    {
      // jhaley: changed is_diabetes_client -> enrollment
      sql += "and exists (select DCE.id from enrollment DCE where DCE.person_id = people.id and DCE.current_id+1 >= 4 and "
             " DCE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "') ";
    }
    if (checkBeh->Checked)
    {
      // jhaley: changed is_beh_client -> enrollment
      sql += "and exists (select BCE.id from enrollment BCE where BCE.person_id = people.id and BCE.current_id+1 >= 4 and "
             " BCE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Behavioral Health Client") + "') ";
    }

    if(checkGroup->Checked)
    {
      if((PGlobals->current_groupname == "Behavioral Health") && (optionsPermissions["table.person_notes.beh"]["view"] == "true"))
        sql += "and person_notes.group_id = " + lookupTables->IdOf("groups", "Behavioral Health") + " ";
      else if((PGlobals->current_groupname == "Contract Health") && (optionsPermissions["table.person_notes.cob"]["view"] == "true"))
        sql += "and person_notes.group_id = " + lookupTables->IdOf("groups", "Contract Health") + " ";
      else if((PGlobals->current_groupname == "Community Health") && (optionsPermissions["table.person_notes.com"]["view"] == "true"))
        sql += "and person_notes.group_id = " + lookupTables->IdOf("groups", "Community Health") + " ";
      else if((PGlobals->current_groupname == "Dental Clinic") && (optionsPermissions["table.person_notes.den"]["view"] == "true"))
        sql += "and person_notes.group_id = " + lookupTables->IdOf("groups", "Dental Clinic") + " ";
      else if((PGlobals->current_groupname == "Diabetes") && (optionsPermissions["table.person_notes.diab"]["view"] == "true"))
        sql += "and person_notes.group_id = " + lookupTables->IdOf("groups", "Diabetes") + " ";
      else if((PGlobals->current_groupname == "Little Axe Clinic") && (optionsPermissions["table.person_notes.lac"]["view"] == "true"))
        sql += "and person_notes.group_id = " + lookupTables->IdOf("groups", "Little Axe Clinic") + " ";
    }
    else
    {
      if(optionsPermissions["table.person_notes.beh"]["view"] != "true")
        sql += "and person_notes.group_id != " + lookupTables->IdOf("groups", "Behavioral Health") + " ";
      if(optionsPermissions["table.person_notes.cob"]["view"] != "true")
        sql += "and person_notes.group_id != " + lookupTables->IdOf("groups", "Contract Health") + " ";
      if(optionsPermissions["table.person_notes.com"]["view"] != "true")
        sql += "and person_notes.group_id != " + lookupTables->IdOf("groups", "Community Health") + " ";
      if(optionsPermissions["table.person_notes.common"]["view"] != "true")
        sql += "and person_notes.group_id != 0 ";
      if(optionsPermissions["table.person_notes.den"]["view"] != "true")
        sql += "and person_notes.group_id != " + lookupTables->IdOf("groups", "Dental Clinic") + " ";
      if(optionsPermissions["table.person_notes.diab"]["view"] != "true")
        sql += "and person_notes.group_id != " + lookupTables->IdOf("groups", "Diabetes") + " ";
      if(optionsPermissions["table.person_notes.lac"]["view"] != "true")
        sql += "and person_notes.group_id != " + lookupTables->IdOf("groups", "Little Axe Clinic") + " ";
    }

    if (checkDeleted->Checked)
      where += "person_notes.current_id = " + lookupTables->IdOf("current_types", "Deleted") + " or ";
    if (checkIncorrect->Checked)
      where += "person_notes.current_id = " + lookupTables->IdOf("current_types", "Incorrect") + " or ";
    if (checkExpired->Checked)
      where += "person_notes.current_id = " + lookupTables->IdOf("current_types", "Expired") + " or ";
    if (checkIncomplete->Checked)
      where += "person_notes.current_id = " + lookupTables->IdOf("current_types", "Incomplete") + " or ";
    if (checkCurrent->Checked)
      where += "person_notes.current_id = " + lookupTables->IdOf("current_types", "Current") + " or ";
    if (checkPrimary->Checked)
      where += "person_notes.current_id = " + lookupTables->IdOf("current_types", "Primary") + " or ";
    if (where != "")
    {
      where = where.substr(0, where.length()-4);
      where = "and (" + where + ") ";
      sql = sql + " " + where;
    }
    // jhaley: changed steps_member -> enrollment
    if (checkSteps->Checked)
      sql += "and exists (select enrollment.id from enrollment "
             "where enrollment.person_id = people.id and enrollment.current_id+1 >= 4 and "
             "enrollment.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "STEPS Participant") + "' and "
             "enrollment.enrollment_status_id = '" + lookupTables->IdOf("enrollment_status_types", "Member") + "') ";

    if (checkCondition->Checked)
      sql += "and exists (select conditions.id from conditions where conditions.person_id = people.id and "
             "(conditions.code='250' or conditions.code like '250.%')) ";
    if (editContains->Text != "")
      sql += "and person_notes.note like '%" + SafeSQLString(editContains->Text.c_str()) + "%' ";

    sql += "order by person_names.last_name, person_names.first_name";

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportDiabComment * report = new TformReportDiabComment(NULL);
      report->reportComments->DataSet = dbDataSet;
      report->lblTitle->Caption = date_title.c_str();
      report->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      report->txtName->DataSet = dbDataSet;
      report->txtName->DataField = "name";
      report->txtDate->DataSet = dbDataSet;
      report->txtDate->DataField = "last_update";
      report->txtType->DataSet = dbDataSet;
      report->txtType->DataField = "current_type";
      report->txtComment->DataSet = dbDataSet;
      report->txtComment->DataField = "note";
      Processing(false);
      report->reportComments->Preview();
    FORM_CATCH

    dbDataSet->Close();
    dbTransaction->Commit();

  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabCommentReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabCommentReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

