//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabContactReport.h"
#include "reportDiabContact.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabContactReport *formLaunchDiabContactReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabContactReport::TformLaunchDiabContactReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabContactReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabContactReport::btnRunClick(TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {

    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;


    sql =  "select users.item staff, method_types.item method, count(tasks.id) total_contacts "
           "from users "
           "inner join tasks on tasks.user_id = users.id "
           "inner join method_types on tasks.method_id = method_types.id "
           "where "
           "tasks.group_id = " + lookupTables->IdOf("groups", "Diabetes") + " and "
           "tasks.current_id >= 3 and "
           "tasks.method_id > 0 and "
           "tasks.user_id > 0 and "
           "tasks.date_of_task >= '" + begin_date + "' and "
           "tasks.date_of_task <= '" + end_date + "' ";
    if (checkWithPeople->Checked)
      sql += "and tasks.person_id > 0 ";
    sql += "group by users.item, method_types.item";

    dbTransaction->StartTransaction();
    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportDiabContact * report_form = new TformReportDiabContact(NULL);
      if (checkWithPeople->Checked) // += doesn't work because AnsiString is a bastard.
        report_form->lblTitle->Caption = report_form->lblTitle->Caption + " (contacts with people)";
      report_form->report->DataSet = dbDataSet;
      report_form->groupBand->Expression = "staff";
      report_form->lblDateTitle->Caption = date_title.c_str();
      report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      report_form->txtStaff->DataSet = dbDataSet;
      report_form->txtStaff->DataField = "staff";
      report_form->txtMethod->DataSet = dbDataSet;
      report_form->txtMethod->DataField = "method";
      report_form->exprContacts->Expression = "FORMATNUMERIC('0', total_contacts)";
      report_form->exprTotal->Expression = "FORMATNUMERIC('0', SUM(total_contacts))";
      Processing(false);
      report_form->report->Preview();
    FORM_CATCH

    dbDataSet->Close();
    dbTransaction->Commit();

  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }

  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabContactReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

