//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabEmployeeTaskReport.h"
#include "reportDiabEmployeeTask.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabEmployeeTaskReport *formLaunchDiabEmployeeTaskReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabEmployeeTaskReport::TformLaunchDiabEmployeeTaskReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  lookupTables->RegisterComboBox("users", cboEmployee);
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabEmployeeTaskReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabEmployeeTaskReport::FormClose(
      TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("users", cboEmployee);
  TformSpecialGeneric::FormClose(Sender, Action);         
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabEmployeeTaskReport::btnRunClick(
      TObject *Sender)
{
  if (! lookupTables->IsInLookUpTable("users", cboEmployee->Text.c_str()))
  {
    PSay("Please enter a valid employee name", m_invalid_data, MB_OK);
    cboEmployee->SetFocus();
  }
  else
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Tasks for " + string(cboEmployee->Text.c_str());

    try
    {
      StdTransaction(dbTransaction, dbDatabase);
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      sql = "select tasks.date_of_task, users.item employee, event_name_types.item event, "
            "person_names.first_name || ' ' || person_names.last_name || ' ' || person_names.suffix client, "
            "tasks.time_spent, tasks.mileage, "
            "diab_contact_types.item contact_type, method_types.item method, direction_types.item direction, "
            "program_types.item program, "
            "task_purpose_types.item task_type, classification_types.item class, "
            "diab_meeting_types.item meeting, diab_activity_types.item activity, tasks.is_educational, tasks.is_personal, "
            "tasks.task_comments "
            "from tasks "
            "inner join users on tasks.user_id = users.id "
            "inner join events on tasks.event_id = events.id "
            "inner join event_name_types on events.event_name_id = event_name_types.id "
            "inner join diab_contact_types on tasks.diab_contact_id = diab_contact_types.id "
            "inner join method_types on tasks.method_id = method_types.id "
            "inner join direction_types on tasks.direction_id = direction_types.id "
            "inner join program_types on tasks.program_id = program_types.id "
            "inner join task_purpose_types on tasks.task_purpose_id = task_purpose_types.id "
            "inner join classification_types on tasks.classification_id = classification_types.id "
            "inner join diab_meeting_types on tasks.diab_meeting_id = diab_meeting_types.id "
            "inner join diab_activity_types on tasks.diab_activity_id = diab_activity_types.id "
            "inner join people on tasks.person_id = people.id "
            "left join person_names on people.person_names_id = person_names.id "
            "where tasks.user_id = " + lookupTables->IdOf("users", cboEmployee->Text.c_str()) + " and "
            "tasks.current_id >= 3 and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' "
            "order by tasks.date_of_task";

      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportDiabEmployeeTask * report = new TformReportDiabEmployeeTask(NULL);
        report->tasksReport->DataSet = dbDataSet;
        report->lblTitle->Caption = title.c_str();
        report->lblDateTitle->Caption = date_title.c_str();
        report->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        report->txtEvent->DataSet = dbDataSet;
        report->txtEvent->DataField = "event";
        report->txtClient->DataSet = dbDataSet;
        report->txtClient->DataField = "client";
        report->txtDate->DataSet = dbDataSet;
        report->txtDate->DataField = "date_of_task";
        report->txtContactType->DataSet = dbDataSet;
        report->txtContactType->DataField = "contact_type";
        report->txtMethod->DataSet = dbDataSet;
        report->txtMethod->DataField = "method";
        report->txtMeeting->DataSet = dbDataSet;
        report->txtMeeting->DataField = "meeting";
        report->exprDirection->Expression = "IF(direction = 'INCOMING', 'In', 'Out')";
        report->exprTime->Expression = "FORMATNUMERIC('#0.00', time_spent)";
        report->txtProgram->DataSet = dbDataSet;
        report->txtProgram->DataField = "program";
        report->exprTaskType->Expression = "PRETTY(task_type)";
        report->txtClass->DataSet = dbDataSet;
        report->txtClass->DataField = "class";
        report->txtActivity->DataSet = dbDataSet;
        report->txtActivity->DataField = "activity";
        report->exprMileage->Expression = "FORMATNUMERIC('#0.00', mileage)";
        report->exprEducational->Expression = "IF(is_educational = 1, 'Yes', 'No')";
        report->exprPersonal->Expression = "IF(is_personal = 1, 'Yes', 'No')";
        report->txtComments->DataSet = dbDataSet;
        report->txtComments->DataField = "task_comments";
        Processing(false);
        report->tasksReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;
  }             
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabEmployeeTaskReport::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

