 //---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabHoursReport.h"
#include "reportDiabHours.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabHoursReport *formLaunchDiabHoursReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabHoursReport::TformLaunchDiabHoursReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  lookupTables->RegisterComboBox("users", cboEmployee);
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabHoursReport::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabHoursReport::btnRunClick(TObject *Sender)
{
  if (cboEmployee->Text == "" || ! lookupTables->IsInLookUpTable("users", cboEmployee->Text.c_str()))
  {
    PSay("Please enter a valid employee name", m_invalid_data, MB_OK);
    cboEmployee->SetFocus();
  }
  else
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string total_sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Hours for " + string(cboEmployee->Text.c_str());
    string expression_str;
    string key;
    map<string, int> totals_map;

    try
    {
      StdTransaction(dbTransaction, dbDatabase);
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      sql = "select tasks.date_of_task, program_types.item program, "
            "sum(tasks.time_spent) total_hours "
            "from tasks "
            "inner join program_types on tasks.program_id = program_types.id "
            "where tasks.user_id = " + lookupTables->IdOf("users", cboEmployee->Text.c_str()) + " and "
            "tasks.time_spent > 0 and "
            "tasks.current_id >= 3 and tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' "
            "group by tasks.date_of_task, program_types.item";

      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      while (! dbDataSet->Eof)
      {
        key = dbDataSet->FieldByName("program")->AsString.c_str();
        if (key == "")
          key = "BLANK";
        totals_map[key] += dbDataSet->FieldByName("total_hours")->AsInteger;
        dbDataSet->Next();
      }
      dbDataSet->First();

      FORM_TRY
        TformReportDiabHours * report = new TformReportDiabHours(NULL);
        report->hoursReport->DataSet = dbDataSet;
        report->lblTitle->Caption = title.c_str();
        report->lblDateTitle->Caption = date_title.c_str();
        report->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        report->groupBand->Expression = "date_of_task";
        report->txtDate->DataSet = dbDataSet;
        report->txtDate->DataField = "date_of_task";
        report->txtProgram->DataSet = dbDataSet;
        report->txtProgram->DataField = "program";
        report->exprTime->Expression = "FORMATNUMERIC('##0.00', total_hours)";
        report->exprTotalHours->Expression = "FORMATNUMERIC('##0.00', SUM(total_hours))";
        expression_str = "FORMATNUMERIC('##0.00', " + IntToString(totals_map["BLANK"]) + ")";
        report->exprBlankHours->Expression = expression_str.c_str();
        expression_str = "FORMATNUMERIC('##0.00', " + IntToString(totals_map["DIABETES"]) + ")";
        report->exprDiabetesHours->Expression = expression_str.c_str();
        expression_str = "FORMATNUMERIC('##0.00', " + IntToString(totals_map["REACH"]) + ")";
        report->exprReachHours->Expression = expression_str.c_str();
        expression_str = "FORMATNUMERIC('##0.00', " + IntToString(totals_map["GENERAL"]) + ")";
        report->exprGeneralHours->Expression = expression_str.c_str();
        Processing(false);
        report->hoursReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);     
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;
  }        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabHoursReport::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("users", cboEmployee);
  TformSpecialGeneric::FormClose(Sender, Action);        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabHoursReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

