//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabLogsheetReport.h"
#include "codeSearchPerson.h"
#include "reportDiabLogsheet.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabLogsheetReport *formLaunchDiabLogsheetReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabLogsheetReport::TformLaunchDiabLogsheetReport(TComponent* Owner, string id)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  CreateLink(txtName, btnPersonSearch, this, id, "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabLogsheetReport::btnPersonSearchClick(
      TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtName, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabLogsheetReport::btnCloseClick(
      TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabLogsheetReport::btnRunClick(TObject *Sender)
{
  string person_id = GetValidLinkId(txtName);
  if (person_id != "")
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Logsheet report for " + GetPersonName(dbDatabase, person_id, first_last);

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      sql = "select activity_logsheets.date_turned_in, activity_logsheets.begin_date, activity_logsheets.end_date, "
            "count(activities.id) Total "
            "from "
            "activity_logsheets inner join activities on activities.activity_logsheet_id = activity_logsheets.id "
            "inner join people on activity_logsheets.person_id = people.id "
            "where "
            "exists (select enrollment.id from enrollment "   // jhaley: changed steps_member -> enrollment
             "where enrollment.person_id = people.id and enrollment.current_id+1 >= 4 and "
             "enrollment.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "STEPS Participant") + "' and "
             "enrollment.enrollment_status_id = '" + lookupTables->IdOf("enrollment_status_types", "Member") + "') and "
            "activity_logsheets.person_id = " + person_id + " and "
            "activity_logsheets.begin_date >= '" + begin_date + "' and "
            "activity_logsheets.end_date <= '" + end_date + "' "
            "group by "
            "activity_logsheets.date_turned_in, activity_logsheets.begin_date, activity_logsheets.end_date ";

      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportDiabLogsheet * logsheetReport = new TformReportDiabLogsheet(NULL);
        logsheetReport->logsheetReport->DataSet = dbDataSet;
        logsheetReport->lblTitle->Caption = title.c_str();
        logsheetReport->lblDateTitle->Caption = date_title.c_str();
        logsheetReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        logsheetReport->txtDateTurnedIn->DataSet = dbDataSet;
        logsheetReport->txtDateTurnedIn->DataField = "date_turned_in";
        logsheetReport->txtBeginDate->DataSet = dbDataSet;
        logsheetReport->txtBeginDate->DataField = "begin_date";
        logsheetReport->txtEndDate->DataSet = dbDataSet;
        logsheetReport->txtEndDate->DataField = "end_date";
        logsheetReport->txtTotalActivities->DataSet = dbDataSet;
        logsheetReport->txtTotalActivities->DataField = "Total";
        logsheetReport->exprTotalActivities->Expression = "SUM(total)";
        Processing(false);
        logsheetReport->logsheetReport->Preview();
      FORM_CATCH


      dbDataSet->Close();
      dbTransaction->Commit();

    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }
  else
  {
    PSay("Please enter a client name", m_missing_data, MB_OK);
    btnPersonSearch->SetFocus();
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabLogsheetReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
