//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabMeasureSummaryReport.h"
#include "reportDiabMeasureSummary.h"
#include "reportDiabMeasureLabSummary.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#include "codeSpecialSqlViewer.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabMeasureSummaryReport *formLaunchDiabMeasureSummaryReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabMeasureSummaryReport::TformLaunchDiabMeasureSummaryReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabMeasureSummaryReport::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabMeasureSummaryReport::btnRunClick(TObject *Sender)
{
  if ((! IsInt(editMoreThan->Text.c_str())) || (StringToInt(editMoreThan->Text.c_str()) < 0))
  {
    PSay("Please enter a valid number", m_invalid_data, MB_OK);
    editMoreThan->SetFocus();
  }
  else if ((! IsInt(editLessThan->Text.c_str())) || (StringToInt(editLessThan->Text.c_str()) < 0))
  {
    PSay("Please enter a valid number", m_invalid_data, MB_OK);
    editLessThan->SetFocus();
  }
  else
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;

    try
    {
      StdTransaction(dbTransaction, dbDatabase);
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix name, people.id person_id, ";
      sql += "obs_response_sets.date_of_observation, ";
      if (radioSteps->Checked)
       sql += "obs_height.response_metric height, "
              "obs_weight.response_metric weight, "
              "obs_waist.response_metric waist, "
              "obs_hip.response_metric hip, "
              "obs_tricep.response_metric tricep, "
              "obs_calf.response_metric calf, "
              "obs_bmi.response_metric bmi ";
      else
       sql += "obs_bmi.response_metric bmi, "
              "obs_bs.response_metric blood_sugar, "
              "obs_ha1c.response_metric ha1c, "
              "obs_bp.response_text blood_pressure, "
              "max(consents.signature_date) last_consent ";
      sql += "from obs_response_sets "
             "inner join people on people.id = obs_response_sets.person_id "
             "left join person_names on people.person_names_id = person_names.id ";
      if (radioLab->Checked)
       sql += "left join consents on consents.person_id = people.id and consents.current_id > 2 ";

      if (radioSteps->Checked)
       sql += "left join obs_responses obs_height on obs_height.obs_response_set_id = obs_response_sets.id and obs_height.obs_question_id = " + lookupTables->IdOf("obs_questions", "Height") + " "
              "left join obs_responses obs_weight on obs_weight.obs_response_set_id = obs_response_sets.id and obs_weight.obs_question_id = " + lookupTables->IdOf("obs_questions", "Weight") + " "
              "left join obs_responses obs_waist on obs_waist.obs_response_set_id = obs_response_sets.id and obs_waist.obs_question_id = " + lookupTables->IdOf("obs_questions", "Waist") + " "
              "left join obs_responses obs_hip on obs_hip.obs_response_set_id = obs_response_sets.id and obs_hip.obs_question_id = " + lookupTables->IdOf("obs_questions", "Hip") + " "
              "left join obs_responses obs_tricep on obs_tricep.obs_response_set_id = obs_response_sets.id and obs_tricep.obs_question_id = " + lookupTables->IdOf("obs_questions", "Tricep") + " "
              "left join obs_responses obs_calf on obs_calf.obs_response_set_id = obs_response_sets.id and obs_calf.obs_question_id = " + lookupTables->IdOf("obs_questions", "Calf") + " "
              "left join obs_responses obs_bmi on obs_bmi.obs_response_set_id = obs_response_sets.id and obs_bmi.obs_question_id = " + lookupTables->IdOf("obs_questions", "Body-Mass Index") + " ";
      else
       sql += "left join obs_responses obs_bmi on obs_bmi.obs_response_set_id = obs_response_sets.id and obs_bmi.obs_question_id = " + lookupTables->IdOf("obs_questions", "Body-Mass Index") + " "
              "left join obs_responses obs_bs on obs_bs.obs_response_set_id = obs_response_sets.id and obs_bs.obs_question_id = " + lookupTables->IdOf("obs_questions", "Blood Sugar") + " "
              "left join obs_responses obs_ha1c on obs_ha1c.obs_response_set_id = obs_response_sets.id and obs_ha1c.obs_question_id = " + lookupTables->IdOf("obs_questions", "Hemoglobin A1C") + " "
              "left join obs_responses obs_bp on obs_bp.obs_response_set_id = obs_response_sets.id and obs_bp.obs_question_id = " + lookupTables->IdOf("obs_questions", "Blood Pressure (w/slash)") + " ";

      sql += "where "
             "obs_response_sets.date_of_observation >= '" + begin_date + "' and "
             "obs_response_sets.date_of_observation <= '" + end_date +"' and "
             "obs_response_sets.group_id = " + lookupTables->IdOf("groups", "Diabetes") + " and "
             "obs_response_sets.current_id > 2 and "
             "people.current_id > 2 and "
             "exists (select DCE.id from enrollment DCE where DCE.person_id = people.id and DCE.current_id+1 >= 4 and " // jhaley: changed is_diabetes_client -> enrollment
             " DCE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "') ";
      if (checkSteps->Checked)
        sql += " and obs_response_sets.is_steps_observation = 1 ";
      if (checkEvent->Checked)
        sql += " and obs_response_sets.participations_id != 0 ";

      if (radioSteps->Checked)
       sql += "and ("
              "obs_height.response_metric is not null or "
              "obs_weight.response_metric is not null or "
              "obs_waist.response_metric is not null or "
              "obs_hip.response_metric is not null or "
              "obs_tricep.response_metric is not null or "
              "obs_calf.response_metric is not null or "
              "obs_bmi.response_metric is not null"
              ") ";
      else
       sql += "and ("
              "obs_bmi.response_metric is not null or "
              "obs_bs.response_metric is not null or "
              "obs_ha1c.response_metric is not null or "
              "obs_bp.response_text is not null"
              ") ";

      sql += "group by people.id, person_names.last_name, person_names.first_name, person_names.suffix, "
             "obs_response_sets.date_of_observation, ";
      if (radioSteps->Checked)
       sql += "obs_height.response_metric, "
              "obs_weight.response_metric, "
              "obs_waist.response_metric, "
              "obs_hip.response_metric, "
              "obs_tricep.response_metric, "
              "obs_calf.response_metric, "
              "obs_bmi.response_metric ";
      else
       sql += "obs_bmi.response_metric, "
              "obs_bs.response_metric, "
              "obs_ha1c.response_metric, "
              "obs_bp.response_text ";

/*
      sql += "having 1=1 ";
      if (editMoreThan->Text != "")
       sql += " and count(obs_response_sets.id) > " + string(editMoreThan->Text.c_str()) + " ";
      if (editLessThan->Text != "")
       sql += " and count(obs_response_sets.id) < " + string(editMoreThan->Text.c_str()) + " ";
*/

      sql += "order by person_names.last_name, person_names.first_name, obs_response_sets.date_of_observation";

      DebugSql(this, &sql, other_forms, 9);

      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->UniDirectional = false;
      dbDataSet->Open();
      dbDataSet->First();


      map<string, int> meas_count;
      string p;
      set<string> people_to_exclude;
      if (editMoreThan->Text != "" || editLessThan->Text != "")
      {
       // draw up a list of person_id's to ignore in the final report ...
       // yes, hackish, but I didn't like the original subselects, you can't use the count directly,
       // and I didn't want to run two separate statements, nor repeat the sql with minute differences by accident.
       // so. we do it this, hackish, way. yay!
       while (!dbDataSet->Eof)
       {
        p = dbDataSet->FieldByName("person_id")->AsString.c_str();
        if (meas_count.find(p) == meas_count.end())
         meas_count[p] = 1;
        else
         meas_count[p]++;
        dbDataSet->Next();
       }
       dbDataSet->First();
       bool has_min = (editMoreThan->Text != "");
       bool has_max = (editLessThan->Text != "");
       int min_count = StringToInt(editMoreThan->Text.c_str());
       int max_count = StringToInt(editLessThan->Text.c_str());
       for (map<string, int>::iterator i = meas_count.begin(); i != meas_count.end(); i++)
        if ((has_min && i->second <= min_count) ||
            (has_max && i->second >= max_count))
         people_to_exclude.insert(i->first);
      }

      if (radioSteps->Checked)
      {
        FORM_TRY
          TformReportDiabMeasureSummary * measureReport = new TformReportDiabMeasureSummary(NULL, people_to_exclude);
          measureReport->measureReport->DataSet = dbDataSet;
          measureReport->lblDateTitle->Caption = date_title.c_str();
          measureReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
          measureReport->txtName->DataSet = dbDataSet;
          measureReport->txtName->DataField = "name";
          measureReport->txtDate->DataSet = dbDataSet;
          measureReport->txtDate->DataField = "date_of_observation";
          measureReport->exprHeight->Expression = "FORMATNUMERIC('##0.00', height)";
          measureReport->exprWeight->Expression = "FORMATNUMERIC('##0.00', weight)";
          measureReport->exprWaist->Expression = "FORMATNUMERIC('##0.00', waist)";
          measureReport->exprHip->Expression = "FORMATNUMERIC('##0.00', hip)";
          measureReport->exprTricep->Expression = "FORMATNUMERIC('##0.00', tricep)";
          measureReport->exprCalf->Expression = "FORMATNUMERIC('##0.00', calf)";
          measureReport->exprBMI->Expression = "FORMATNUMERIC('##0.00', bmi)";
          Processing(false);
          measureReport->measureReport->Preview();
        FORM_CATCH
      }
      else // radioLab->Checked
      {
        FORM_TRY
          TformReportDiabMeasureLabSummary * measureReport = new TformReportDiabMeasureLabSummary(NULL, people_to_exclude);
          measureReport->measureReport->DataSet = dbDataSet;
          measureReport->lblDateTitle->Caption = date_title.c_str();
          measureReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
          measureReport->txtName->DataSet = dbDataSet;
          measureReport->txtName->DataField = "name";
          measureReport->txtDate->DataSet = dbDataSet;
          measureReport->txtDate->DataField = "date_of_observation";
          measureReport->txtBloodPressure->DataSet = dbDataSet;
          measureReport->txtBloodPressure->DataField = "blood_pressure";
          measureReport->txtLastConsent->DataSet = dbDataSet;
          measureReport->txtLastConsent->DataField = "last_consent";
          measureReport->exprBMI->Expression = "FORMATNUMERIC('##0.00', bmi)";
          //measureReport->exprHeight->Expression = "FORMATNUMERIC('##0.00', height)";
          //measureReport->exprWeight->Expression = "FORMATNUMERIC('##0.00', weight)";
          measureReport->exprBloodSugar->Expression = "FORMATNUMERIC('###', blood_sugar)";
          measureReport->exprHa1c->Expression = "FORMATNUMERIC('##0.0', ha1c)";
          Processing(false);
          measureReport->measureReport->Preview();
        FORM_CATCH
      }
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabMeasureSummaryReport::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

