//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabMeasurementCountReport.h"
#include "reportDiabMeasurementCount.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabMeasurementCountReport *formLaunchDiabMeasurementCountReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabMeasurementCountReport::TformLaunchDiabMeasurementCountReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  lookupTables->RegisterComboBox("tribe_types", cboTribe);

  // jhaley 20101109: Changed diab_client_types box to use Diabetes Client subset of enrollment_status_types
  string sql = "select id, item, valid from enrollment_status_types "
               "where enrollment_id = 0 or enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "' ";
  lookupTables->RegisterComboBox("enrollment_status_types", cboClient, sql);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabMeasurementCountReport::btnRunClick(
      TObject *Sender)
{
 // run report
 if ((editLessThan->Text != "") && IsInt(editLessThan->Text.c_str()) && (StringToInt(editLessThan->Text.c_str()) > 0))
 {
  if(! lookupTables->IsInLookUpTable("tribe_types", cboTribe->Text.c_str()))
  {
   PSay("Please enter a valid tribe", m_invalid_data, MB_OK);
   cboTribe->SetFocus();
  }
  else if (! lookupTables->IsInLookUpTable("enrollment_status_types", cboClient))
  {
    PSay("Please enter a valid client type", m_invalid_data, MB_OK);
    cboClient->SetFocus();
  }
  else if (! Pdate (editSince->Text.c_str(), mdy | yy).IsValidDate() && ! (editSince->Text == ""))
  {
    PSay("Please enter a valid date", m_invalid_data, MB_OK);
    editSince->SetFocus();
  }
  else
  {
   Processing(true);

   TIBTransaction * dbTransaction = new TIBTransaction(NULL);
   TIBDataSet * dbDataSet = new TIBDataSet(NULL);
   string sql;

   try
   {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix name, "
          "person_contact_info.phone_number phone_number, "
          "(select count(obs_response_sets.id) from obs_response_sets where obs_response_sets.person_id = people.id and "
          "obs_response_sets.current_id > 2 and obs_response_sets.is_steps_observation = 1) meas_count, "
          "(select max(obs_response_sets.date_of_observation) from obs_response_sets where obs_response_sets.person_id = people.id and "
          "obs_response_sets.current_id > 2 and obs_response_sets.is_steps_observation = 1) last_measurement "
          "from people left join person_names on people.person_names_id = person_names.id "
          "left join person_contact_info on people.person_contact_info_id = person_contact_info.id "
          "left join affiliations on people.affiliations_id = affiliations.id "
          "where people.current_id >= 3 and "
          "exists (select enrollment.id from enrollment "    // jhaley: changed steps_member -> enrollment
           "where enrollment.person_id = people.id and enrollment.current_id+1 >= 4 and "
           "enrollment.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "STEPS Participant") + "' and "
           "enrollment.enrollment_status_id = '" + lookupTables->IdOf("enrollment_status_types", "Member") + "') and ";
    // jhaley: changed to check for enrollment existence (was people.diab_client_id)
    if (cboClient->Text != "")
      sql += "exists (select DCE.id from enrollment DCE where DCE.person_id = people.id and DCE.current_id+1 >= 4 and "
             " DCE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "' and "
             " DCE.enrollment_status_id = '" + lookupTables->IdOf("enrollment_status_types", cboClient) + "') and ";
    if (cboTribe->Text != "")
      sql += "affiliations.tribe_id = " + lookupTables->IdOf("tribe_types", cboTribe->Text.c_str()) + " and ";
    sql += "(select count(obs_response_sets.id) from obs_response_sets where obs_response_sets.person_id = people.id and "
          "obs_response_sets.current_id > 2 and obs_response_sets.is_steps_observation = 1) < '" + string(editLessThan->Text.c_str())+ "' ";
    if (editSince->Text != "")
      sql += " and (select max(obs_response_sets.date_of_observation) from obs_response_sets where obs_response_sets.person_id = people.id and "
          "obs_response_sets.current_id > 2 and obs_response_sets.is_steps_observation = 1) < ' " + Pdate(editSince->Text.c_str(), mdy | yy).OutDate(mdy | yyyy) + "' ";
    sql += "order by 3, person_names.last_name, person_names.first_name";

    dbTransaction->StartTransaction();
    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportDiabMeasurementCount * meas_count_report = new TformReportDiabMeasurementCount(NULL);
      meas_count_report->meas_count_report->DataSet = dbDataSet;
      meas_count_report->labelTitle->Caption = string("Names and contact information for Steps participants that have had less than " + string(editLessThan->Text.c_str()) + " measurements so far").c_str();
      meas_count_report->labelUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      meas_count_report->textName->DataSet = dbDataSet;
      meas_count_report->textName->DataField = "name";
      meas_count_report->textPhone->DataSet = dbDataSet;
      meas_count_report->textPhone->DataField = "phone_number";
      meas_count_report->textCount->DataSet = dbDataSet;
      meas_count_report->textCount->DataField = "meas_count";
      meas_count_report->textDate->DataSet = dbDataSet;
      meas_count_report->textDate->DataField = "last_measurement";
      Processing(false);
      meas_count_report->meas_count_report->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
   }
   catch (...)
   {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
     dbTransaction->Rollback();
   }
   delete dbTransaction;
   delete dbDataSet;
  }
 }
 else
  PSay("Please enter a valid number of measurements", m_invalid_data, MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabMeasurementCountReport::btnCloseClick(
      TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabMeasurementCountReport::FormClose(
      TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("tribe_types", cboTribe);
  lookupTables->UnregisterComboBox("enrollment_status_types", cboClient);
  TformSpecialGeneric::FormClose(Sender, Action);        
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchDiabMeasurementCountReport::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

