//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabMeasurementLabels.h"
#include "reportMailingLabels.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabMeasurementLabels *formLaunchDiabMeasurementLabels;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabMeasurementLabels::TformLaunchDiabMeasurementLabels(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void TformLaunchDiabMeasurementLabels::Do()
{
 FORM_TRY
  TformLaunchDiabMeasurementLabels * z = new TformLaunchDiabMeasurementLabels(NULL);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabMeasurementLabels::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabMeasurementLabels::btnRunClick(
      TObject *Sender)
{
  if((! IsInt(editLessThan->Text.c_str())) || (editLessThan->Text == ""))
  {
    PSay("Please enter a number", m_invalid_data, MB_OK);
    editLessThan->SetFocus();
  }
  else
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      sql = "select people.id, person_names.first_name || ' ' || person_names.last_name || ' ' || person_names.suffix full_name, "
            "person_contact_info.line1, person_contact_info.line2, "
            "person_contact_info.city || ', ' || state_types.abbreviation || '  ' || person_contact_info.zip city "
            "from people inner join person_names on people.person_names_id = person_names.id "
            "inner join person_contact_info on people.person_contact_info_id = person_contact_info.id "
            "inner join state_types on person_contact_info.state_id = state_types.id "
            "where person_contact_info.line1 is not null and person_contact_info.city is not null and "
            "exists (select enrollment.id from enrollment "    // jhaley: changed steps_member -> enrollment
             "where enrollment.person_id = people.id and enrollment.current_id+1 >= 4 and "
             "enrollment.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "STEPS Participant") + "' and "
             "enrollment.enrollment_status_id = '" + lookupTables->IdOf("enrollment_status_types", "Member") + "') and "
            "person_contact_info.zip is not null and person_contact_info.state_id > 0 and "
            "(select count(*) from obs_response_sets where obs_response_sets.person_id = people.id and "
            "obs_response_sets.is_steps_observation = 1 and obs_response_sets.current_id >= 3) < " + string(editLessThan->Text.c_str()) + " "
            "order by person_names.last_name, person_names.first_name";

      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportMailingLabels * report = new TformReportMailingLabels(NULL);
        report->labelReport->DataSet = dbDataSet;
        report->txtName->DataSet = dbDataSet;
        report->txtName->DataField = "full_name";
        report->txtAddress1->DataSet = dbDataSet;
        report->txtAddress1->DataField = "line1";
        Processing(false);
        report->labelReport->Preview();
      FORM_CATCH

      if((checkTask->Checked) && (dbDataSet->RecordCount > 0))
      {
        vector<string> person_id_vec;
        string person_id_string;
        dbDataSet->First();
        while(! dbDataSet->Eof)
        {
          person_id_vec.push_back(dbDataSet->FieldByName("id")->AsString.c_str());
          dbDataSet->Next();
        }
        person_id_string = VecToCommaString(person_id_vec);
        sql = "insert into tasks (id, current_id, last_update_stamp, last_updated_by, user_id, person_id, group_id, "
              "date_of_task, task_comments, method_id, direction_id, classification_id, diab_contact_id, diab_activity_id) "
              "select (select gen_id(tasks_gen, 1) from uno), 4, '" + RightNow() + "', " + current_userid + ", " + current_userid + ", "
              "people.id, " + lookupTables->IdOf("groups", "Diabetes") + ", '" + CurrentDate() + "', "
              "'REMINDER LETTER FOR STEPS MEASUREMENT', " + lookupTables->IdOf("method_types", "Mail") + ", " +
              lookupTables->IdOf("direction_types", "Outgoing") + ", " + lookupTables->IdOf("classification_types", "Client") + ", " +
              lookupTables->IdOf("diab_contact_types", "Contact") + ", " +
              lookupTables->IdOf("diab_activity_types", "Steps measurement reminder letter") + " "
              "from people where people.id in (" + person_id_string + ")";
        if(! ExecuteStatement(dbTransaction, sql))
          throw 1;
      }

      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }
}
//---------------------------------------------------------------------------
