//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabMeetingReport.h"
#include "reportDiabMeeting.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabMeetingReport *formLaunchDiabMeetingReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabMeetingReport::TformLaunchDiabMeetingReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  }
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabMeetingReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabMeetingReport::btnRunClick(TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {
    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;


    sql = "select users.item staff, diab_meeting_types.item meeting, sum(tasks.time_spent) total "
          "from users, diab_meeting_types, tasks "
          "where tasks.user_id = users.id and "
          "tasks.diab_meeting_id = diab_meeting_types.id and "
          "tasks.group_id = " + lookupTables->IdOf("groups", "Diabetes") + " and "
          "tasks.date_of_task >= '" + begin_date + "' and "
          "tasks.date_of_task <= '" + end_date + "' and "
          "tasks.current_id >= 3 "
          "group by users.item, diab_meeting_types.item";

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportDiabMeeting * meetingReport = new TformReportDiabMeeting(NULL);
      meetingReport->meetingReport->DataSet = dbDataSet;
      meetingReport->groupBand->Expression = "staff";
      meetingReport->lblDateTitle->Caption = date_title.c_str();
      meetingReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      meetingReport->txtStaff->DataSet = dbDataSet;
      meetingReport->txtStaff->DataField = "staff";
      meetingReport->txtMeeting->DataSet = dbDataSet;
      meetingReport->txtMeeting->DataField = "meeting";
      meetingReport->exprHours->Expression = "FORMATNUMERIC('#,##0.00', total)";
      Processing(false);
      meetingReport->meetingReport->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabMeetingReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

