//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabMileageReport.h"
#include "reportDiabMileage.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabMileageReport *formLaunchDiabMileageReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabMileageReport::TformLaunchDiabMileageReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabMileageReport::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabMileageReport::btnRunClick(TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {
    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;


    sql = "select tasks.date_of_task, users.item employee, tasks.mileage "
          "from tasks, users where tasks.user_id = users.id and "
          "tasks.group_id = " + lookupTables->IdOf("groups", "Diabetes") + " and "
          "tasks.mileage > 0 and tasks.current_id >= 3 and "
          "tasks.date_of_task >= '" + begin_date + "' and "
          "tasks.date_of_task <= '" + end_date + "' "
          "order by tasks.date_of_task, users.item";

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportDiabMileage * report = new TformReportDiabMileage(NULL);
      report->mileageReport->DataSet = dbDataSet;
      report->lblDateTitle->Caption = date_title.c_str();
      report->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      report->txtDate->DataSet = dbDataSet;
      report->txtDate->DataField = "date_of_task";
      report->txtName->DataSet = dbDataSet;
      report->txtName->DataField = "employee";
      report->exprMileage->Expression = "FORMATNUMERIC('##0.00', mileage)";
      report->exprTotal->Expression = "FORMATNUMERIC('#,##0.00', SUM(mileage))";
      Processing(false);
      report->mileageReport->Preview(); 
    FORM_CATCH    
    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }

  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabMileageReport::FormShortCut(TWMKey &Msg,bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

