//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabNewMembershipLetters.h"
#include "reportMailingLabels.h";
#include "reportDiabMembershipsReady.h"
#include "reportDiabNewMembershipLetter.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabNewMembershipLetters *formLaunchDiabNewMembershipLetters;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabNewMembershipLetters::TformLaunchDiabNewMembershipLetters(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  lookupTables->RegisterComboBox("fit_facility_types", cboFacility);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabNewMembershipLetters::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
bool TformLaunchDiabNewMembershipLetters::IsValidOnScreen()
{
  if((editNumber->Text == "") || (! IsInt(editNumber->Text.c_str())) || (StringToInt(editNumber->Text.c_str()) <= 0))
  {
    PSay("Please enter a valid number of letters to print", m_invalid_data, MB_OK);
    editNumber->SetFocus();
    return false;
  }
  else if(! lookupTables->IsInLookUpTable("fit_facility_types", cboFacility->Text.c_str()))
  {
    PSay("Please enter a valid facility", m_invalid_data, MB_OK);
    cboFacility->SetFocus();
    return false;
  }
  else if(cboFacility->Text == "")
  {
    PSay("Please enter a facility", m_missing_data, MB_OK);
    cboFacility->SetFocus();
    return false;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabNewMembershipLetters::btnRunClick(
      TObject *Sender)
{
  if(IsValidOnScreen())
  {
    Processing(true);
    string sql;
    TIBTransaction *dbTransaction = new TIBTransaction(NULL);
    TIBDataSet *dbDataset = new TIBDataSet(NULL);

    try
    {
      TformReportMailingLabels *label_form = new TformReportMailingLabels(NULL);
      TformReportDiabMembershipsReady *waiting_report = new TformReportDiabMembershipsReady(NULL);
      TformReportDiabNewMembershipLetter *waiting_letter = new TformReportDiabNewMembershipLetter(NULL);
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataset->Database = dbDatabase;
      dbDataset->Transaction = dbTransaction;
      dbTransaction->StartTransaction();

      vector<string> membership_id_vec;
      ExecuteStatement(dbTransaction, "delete from temp_waiting_list");
      sql = "select first " + string(editNumber->Text.c_str()) + " id from fitness_memberships where "
            "fitness_memberships.fit_facility_id = " + lookupTables->IdOf("fit_facility_types", cboFacility->Text.c_str()) + " and "
            "fitness_memberships.is_waiting = 1 and fitness_memberships.current_id >= 3 "
            "order by fitness_memberships.waiting_list_date ascending";
      SqlToVec(dbTransaction, sql, membership_id_vec);
      for(vector<string>::iterator itr = membership_id_vec.begin(); itr != membership_id_vec.end(); itr++)
      {
        sql = "insert into temp_waiting_list (id) values (" + *itr + ")";;
        if(! ExecuteStatement(dbTransaction, sql))
          throw 1;
      }
      sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix last_first, "
            "person_names.first_name || ' ' || person_names.last_name first_last, "
            "person_contact_info.line1, person_contact_info.line2, "
            "person_contact_info.city || ', ' || state_types.abbreviation || '  ' || "
            "person_contact_info.zip city, person_contact_info.phone_number, "
            "fit_facility_types.item facility, fitness_memberships.waiting_list_date "
            "from fitness_memberships "
            "inner join fit_facility_types on fitness_memberships.fit_facility_id = fit_facility_types.id "
            "inner join fitness_people on fitness_people.fitness_membership_id = fitness_memberships.id "
            "inner join people on fitness_people.person_id = people.id "
            "left join person_names on people.person_names_id = person_names.id "
            "left join person_contact_info on people.person_contact_info_id = person_contact_info.id "
            "left join state_types on person_contact_info.state_id = state_types.id "
            "where fitness_people.is_primary = 1 and "
            "fitness_memberships.id in (select temp_waiting_list.id from temp_waiting_list) "
            "order by fitness_memberships.waiting_list_date";
      dbDataset->Close();
      dbDataset->SelectSQL->Clear();
      dbDataset->SelectSQL->Add(sql.c_str());
      dbDataset->Open();

      waiting_report->waiting_list_report->DataSet = dbDataset;
      waiting_report->lblDateTitle->Caption = CurrentDate().c_str();
      waiting_report->lblUser->Caption = current_fullname.c_str();
      waiting_report->txtFacility->DataSet = dbDataset;
      waiting_report->txtFacility->DataField = "facility";
      waiting_report->txtName->DataSet = dbDataset;
      waiting_report->txtName->DataField = "last_first";
      waiting_report->txtDate->DataSet = dbDataset;
      waiting_report->txtDate->DataField = "waiting_list_date";
      waiting_report->txtPhone->DataSet = dbDataset;
      waiting_report->txtPhone->DataField = "phone_number";

      waiting_letter->new_letter->DataSet = dbDataset;
      waiting_letter->txtNewPerson->DataSet = dbDataset;
      waiting_letter->txtNewPerson->DataField = "first_last";
      waiting_letter->txtNewLine1->DataSet = dbDataset;
      waiting_letter->txtNewLine1->DataField = "line1";
      waiting_letter->txtNewLine2->DataSet = dbDataset;
      waiting_letter->txtNewLine2->DataField = "city";

      label_form->labelReport->DataSet = dbDataset;
      label_form->txtName->DataSet = dbDataset;
      label_form->txtName->DataField = "first_last";
      label_form->txtAddress1->DataSet = dbDataset;
      label_form->txtAddress1->DataField = "line1";

      Processing(false);
      waiting_report->waiting_list_report->Preview();
      waiting_letter->new_letter->Preview();
      label_form->labelReport->Preview();

      if(checkTask->Checked)
      {
        Processing(true);
        sql = "insert into tasks (id, current_id, last_update_stamp, last_updated_by, person_id, group_id, "
              "date_of_task, method_id, direction_id, task_comments, diab_activity_id, user_id, fitness_membership_id) "
              "select (select gen_id(tasks_gen, 1) from uno), 4, '" + RightNow() + "', " + current_userid + ", "
              "fitness_people.person_id, " + lookupTables->IdOf("groups", "Diabetes") + ", '" +
              CurrentDate() + "', " + lookupTables->IdOf("method_types", "Mail") + ", " +
              lookupTables->IdOf("direction_types", "Outgoing") + ", 'NEW FITNESS MEMBERSHIP AVAILABLE LETTER', " +
              lookupTables->IdOf("diab_activity_types", "New fitness membership letter") + ", " + current_userid + ", "
              "fitness_memberships.id "
              "from fitness_memberships "
              "inner join fitness_people on fitness_people.fitness_membership_id = fitness_memberships.id "
              "where fitness_memberships.id in (select temp_waiting_list.id from temp_waiting_list) and "
              "fitness_people.is_primary = 1";
        if (! ExecuteStatement(dbTransaction, sql))
          throw 1;
        Processing(false);
      }
      ExecuteStatement(dbTransaction, "delete from temp_waiting_list");
      dbDataset->Close();
      dbTransaction->Commit();
    }
    catch(...)
    {
      Processing(false);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
      PSay("Error printing letters", m_database_error, MB_OK);
    }
    delete dbDataset;
    delete dbTransaction;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabNewMembershipLetters::FormClose(
      TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("fit_facility_types", cboFacility);
  TformSpecialGeneric::FormClose(Sender, Action);        
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchDiabNewMembershipLetters::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

