//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabOverweightReport.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabOverweightReport *formLaunchDiabOverweightReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabOverweightReport::TformLaunchDiabOverweightReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  cboBmi->ItemIndex = 0;
  cboAge->ItemIndex = 0;
  cboTribe->ItemIndex = 0;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabOverweightReport::btnGoClick(
      TObject *Sender)
{
  if(IsValidOnScreen())
  {
    editTotal->Text = "";
    Processing(true);
    string sql;
    string select;
    string from;
    string where;

    select = "select count(distinct obs_response_sets.person_id) ";
    from = "from obs_response_sets "
           "inner join people on obs_response_sets.person_id = people.id "
           "inner join obs_responses obs_bmi on obs_bmi.obs_response_set_id = obs_response_sets.id and obs_question_id = " + lookupTables->IdOf("obs_questions", "Body-Mass Index") + " ";
    where = "where obs_bmi.response_metric > ";
    if(cboBmi->Text == "between 25 and 30 (overweight)")
      where += "25 and obs_bmi.response_metric <= 30";
    else if(cboBmi->Text == "over 30 (obese)")
      where += "30 ";
    if(checkClient->Checked)
    {
      //where += "and people.is_diabetes_client = 1 ";
      where += "and exists (select DCE.id from enrollment DCE where DCE.person_id = people.id and DCE.current_id+1 >= 4 and "
               "DCE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "') ";
    }

    if(cboAge->Text == "under 18")
    {
      Pdate compare_date = CurrentPdate();
      compare_date.mod(-18, in_years);
      where += "and people.birth_date >= '" + compare_date.OutDate(mdy | yyyy) + "' ";
    }
    else if(cboAge->Text == "over 65")
    {
      Pdate compare_date = CurrentPdate();
      compare_date.mod(-65, in_years);
      where += "and people.birth_date <= '" + compare_date.OutDate(mdy | yyyy) + "' ";
    }

    if(cboTribe->Text == "AST only")
    {
      from += "inner join affiliations on people.affiliations_id = affiliations.id "
              "and affiliations.tribe_id = " + lookupTables->IdOf("tribe_types", "Absentee Shawnee Tribes of Oklahoma") + " ";
    }
    else if(cboTribe->Text == "Native Americans only")
    {
      from += "inner join affiliations on people.affiliations_id = affiliations.id "
              "and affiliations.tribe_id > 0 "
              "and affiliations.tribe_id != " + lookupTables->IdOf("tribe_types", "Non-indian") + " "
              "and affiliations.tribe_id != " + lookupTables->IdOf("tribe_types", "Unknown") + " ";
    }

    if(checkDiabetes->Checked)
    {
      from += "inner join conditions on conditions.person_id = people.id and conditions.current_id >= 3 "
              "and (conditions.code='250' or conditions.code like '250.%') ";
    }

    if(checkArea->Checked)
    {
      from += "inner join person_contact_info on people.person_contact_info_id = person_contact_info.id ";
      where += "and person_contact_info.zip in (select item from local_zip_types) ";
    }

    sql = select + from + where;

    editTotal->Text = GetOneField(dbDatabase, sql).c_str();
    Processing(false);
  }
}
//---------------------------------------------------------------------------
bool TformLaunchDiabOverweightReport::IsValidOnScreen()
{
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabOverweightReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnGo->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchDiabOverweightReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------

