//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabParticipationReport.h"
#include "reportDiabParticipation.h"
#include "codeSearchEvent.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabParticipationReport *formLaunchDiabParticipationReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabParticipationReport::TformLaunchDiabParticipationReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  cboOrder->Items->Add("Client Name");
  cboOrder->Items->Add("Event Date");
  cboOrder->Items->Add("Event Name");
  cboOrder->Items->Add("Special Info");
  cboOrder->Items->Add("Note");
  cboOrder->Items->Add("Client Type");
  cboOrder->Items->Add("Steps");
  cboOrder->Items->Add("CDIB");
  cboOrder->Items->Add("Tribal Affiliation");  
  CreateLink(txtEvent, btnEventSearch, this, "0", "events");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabParticipationReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabParticipationReport::btnRunClick(
      TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;
  vector<map<string, string> > client_types_vec;
  string total;
  int previous_top = 60;

  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    FORM_TRY
      TformReportDiabParticipation * report = new TformReportDiabParticipation(NULL);
      dbTransaction->StartTransaction();
      sql = "select id, item from enrollment_status_types "
            "where enrollment_id = 0 or enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "' order by item";
      SqlToVecMap(dbTransaction, sql, client_types_vec);
      for(vector<map<string, string> >::iterator itr = client_types_vec.begin();
          itr != client_types_vec.end(); itr++)
      {
        sql = "select count(participations.id) "
              "from events "
              "inner join participations on participations.event_id = events.id "
              "inner join people on participations.person_id = people.id "
              "where participations.current_id >= 3 and events.current_id >= 3 and people.current_id >= 3 and "
              "exists (select DCE.id from enrollment DCE where DCE.person_id = people.id and DCE.current_id+1 >= 4 and "
              " DCE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "' and "
              " DCE.enrollment_status_id = '" + (*itr)["id"] + "') and "
              "events.group_id = " + lookupTables->IdOf("groups", "Diabetes") + " and "
              "events.date_of_event >= '" + begin_date + "' and events.date_of_event <= '" + end_date + "' ";
        if (checkComments->Checked)
           sql += " and participations.note is not null ";
         total = GetOneField(dbTransaction, sql);
        if (total != "0")
        {
          TQRLabel * lblType = new TQRLabel(report);
          report->summaryBand->Height += lblType->Height + 4;
          lblType->BringToFront();
          lblType->Caption = PrettyString((*itr)["item"]).c_str();
          lblType->Top = previous_top + 16;
          lblType->Left = 0;
          lblType->Parent = report->summaryBand;
          TQRLabel * lblTotal = new TQRLabel(report);
          lblTotal->BringToFront();
          lblTotal->Caption = total.c_str();
          lblTotal->Top = previous_top + 16;
          lblTotal->Left = lblType->Left + lblType->Width + 12;
          lblTotal->Parent = report->summaryBand;
          previous_top = lblType->Top;
        }
      }
      sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix name, "
            "events.date_of_event, event_name_types.item event_name, diab_special_types.item special_info, participations.note, "
            "case when steps_enrollment.id is not null then 1 else 0 end steps_member, "    // jhaley: changed steps_member -> enrollment
            "affiliations.cdib, enrollment_status_types.item client_type, "
            "tribe_types.item tribe, person_contact_info.phone_number "
            "from participations "
            "inner join people on participations.person_id = people.id "
            "inner join events on participations.event_id = events.id "
            "inner join diab_special_types on participations.diab_special_id = diab_special_types.id "
            "inner join enrollment DCE on DCE.person_id = people.id and DCE.current_id+1 >= 4 and " // jhaley: changed diab_client_id -> enrollment
            " DCE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "' "
            "inner join enrollment_status_types on DCE.enrollment_status_id = enrollment_status_types.id "
            "inner join event_name_types on events.event_name_id = event_name_types.id "
            "left join person_names on people.person_names_id = person_names.id "
            "left join affiliations on people.affiliations_id = affiliations.id "
            "left join tribe_types on affiliations.tribe_id = tribe_types.id "
            "left join person_contact_info on people.person_contact_info_id = person_contact_info.id "
            "left join enrollment steps_enrollment on steps_enrollment.person_id = people.id and steps_enrollment.current_id+1 >= 4 and "
             "steps_enrollment.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "STEPS Participant") + "' and "
             "steps_enrollment.enrollment_status_id = '" + lookupTables->IdOf("enrollment_status_types", "Member") + "' "
            "where "
            "participations.current_id+1 >= 4 and events.current_id+1 >= 4 and people.current_id+1 >= 4 and "
            "events.group_id = " + lookupTables->IdOf("groups", "Diabetes") + " and "
            "events.date_of_event >= '" + begin_date + "' and events.date_of_event <= '" + end_date + "' ";
      if (checkComments->Checked)
        sql += " and (participations.note is not null or participations.note != '') ";
      if (editNote->Text != "")
        sql += " and participations.note like '%" + SafeSQLString(editNote->Text.c_str()) + "%' ";
      string event_id = GetValidLinkId(txtEvent);
      if(event_id != "")
        sql += " and participations.event_id = '" + event_id + "' ";
      if(cboOrder->Text == "Client Name")
        sql += "order by person_names.last_name, person_names.first_name, events.date_of_event";
      else if(cboOrder->Text == "Event Date")
        sql += "order by events.date_of_event, person_names.last_name, person_names.first_name";
      else if(cboOrder->Text == "Event Name")
       sql += "order by event_name_types.item, person_names.last_name, person_names.first_name";
      else if(cboOrder->Text == "Special Info")
       sql += "order by diab_special_types.item, person_names.last_name, person_names.first_name, events.date_of_event";
      else if(cboOrder->Text == "Note")
       sql += "order by participations.note, person_names.last_name, person_names.first_name, events.date_of_event";
      else if(cboOrder->Text == "Client Type")
       sql += "order by enrollment_status_types.item, person_names.last_name, person_names.first_name";
      else if(cboOrder->Text == "Steps")
       sql += "order by case when steps_enrollment.id is not null then 1 else 0 end, person_names.last_name, person_names.first_name";
      else if(cboOrder->Text == "CDIB")
       sql += "order by affiliations.cdib, person_names.last_name, person_names.first_name";
      else if(cboOrder->Text == "Tribal Affiliation")
       sql += "order by tribe_types.item, person_names.last_name, person_names.first_name";
      else
       sql += "order by person_names.last_name, person_names.first_name, events.date_of_event";
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();
      report->participationReport->DataSet = dbDataSet;
      report->lblDateTitle->Caption = date_title.c_str();
      report->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      report->txtName->DataSet = dbDataSet;
      report->txtName->DataField = "name";
      report->txtDate->DataSet = dbDataSet;
      report->txtDate->DataField = "date_of_event";
      report->txtEvent->DataSet = dbDataSet;
      report->txtEvent->DataField = "event_name";
      report->txtSpecial->DataSet = dbDataSet;
      report->txtSpecial->DataField = "special_info";
      report->txtNote->DataSet = dbDataSet;
      report->txtNote->DataField = "note";
      report->txtClient->DataSet = dbDataSet;
      report->txtClient->DataField = "client_type";
      report->txtCDIB->DataSet = dbDataSet;
      report->txtCDIB->DataField = "cdib";
      report->txtTribe->DataSet = dbDataSet;
      report->txtTribe->DataField = "tribe";
      report->txtPhoneNumber->DataSet = dbDataSet;
      report->txtPhoneNumber->DataField = "phone_number";
      report->exprSteps->Expression = "IF(steps_member = '1', 'Yes', 'No')";
      report->exprStepsTotal->Expression = "SUM(steps_member)";
      Processing(false);
      report->participationReport->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }

  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabParticipationReport::btnEventSearchClick(
      TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchEvent * eventSearch = new TformSearchEvent(NULL,&return_vector,lookupTables->IdOf("groups", "Diabetes"));
    eventSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtEvent, btnEventSearch, this, return_vector[0], "events");
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchDiabParticipationReport::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

