//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "launchDiabPeopleNotSeenReport.h"
#include "reportDiabClient.h"
#include "reportMailingLabels.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabPeopleNotSeenReport *formLaunchDiabPeopleNotSeenReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabPeopleNotSeenReport::TformLaunchDiabPeopleNotSeenReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBeginDepartment->Date = Date();
  dateEndDepartment->Date = Date();
  dateBeginDiabetes->Date = Date();
  dateEndDiabetes->Date = Date();
  lookupTables->RegisterComboBox("users", cboEmployee);
  lookupTables->RegisterComboBox("method_types", cboMethod);
  lookupTables->RegisterComboBox("diab_activity_types", cboActivity);

  RecurseEnabled(panelOther, false);
  RecurseEnabled(panelDiabetes, false);

  if(optionsPermissions["table.tasks.diab"]["insert"] == "true")
  {
    cboEmployee->Text = lookupTables->ValueOf("users", current_userid).c_str();
    cboMethod->Text = "Mail";
  }
  else
    checkTasks->Enabled = false;
  RecurseEnabled(panelTask, false);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabPeopleNotSeenReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabPeopleNotSeenReport::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
bool TformLaunchDiabPeopleNotSeenReport::IsValidOnScreen()
{
  if(checkTasks->Checked)
  {
    if(! lookupTables->IsInLookUpTable("users", cboEmployee->Text.c_str()))
    {
      PSay("Please enter a valid employee", m_invalid_data, MB_OK);
      cboEmployee->SetFocus();
      return false;
    }
    else if(! lookupTables->IsInLookUpTable("method_types", cboMethod->Text.c_str()))
    {
      PSay("Please enter a valid method", m_invalid_data, MB_OK);
      cboMethod->SetFocus();
      return false;
    }
    else if(! lookupTables->IsInLookUpTable("diab_activity_types", cboActivity->Text.c_str()))
    {
      PSay("Please enter a valid activity", m_invalid_data, MB_OK);
      cboActivity->SetFocus();
      return false;
    }
    else
     return true;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabPeopleNotSeenReport::btnRunClick(
      TObject *Sender)
{
  if(IsValidOnScreen())
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_dep_date = Pdate(dateBeginDepartment->Date).OutDate(mdy | yyyy);
    string end_dep_date =  Pdate(dateEndDepartment->Date).OutDate(mdy | yyyy);
    string begin_diab_date = Pdate(dateBeginDiabetes->Date).OutDate(mdy | yyyy);
    string end_diab_date =  Pdate(dateEndDiabetes->Date).OutDate(mdy | yyyy);
    string diab_group_id = lookupTables->IdOf("groups", "Diabetes");

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;
      dbTransaction->StartTransaction();

      sql = "select people.id person_id, person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix last_first, "
            "person_names.first_name || ' ' || person_names.last_name || ' ' || person_names.suffix first_last, "
            "people.birth_date, person_contact_info.line1, person_contact_info.line2, "
            "person_contact_info.city || ', ' || state_types.abbreviation || '  ' || person_contact_info.zip city, "
            "people.birth_date, person_contact_info.line1 || '  ' || "
            "person_contact_info.city || ', ' || state_types.abbreviation || '  ' || person_contact_info.zip all_lines, "
            "person_contact_info.phone_number, "
            "affiliations.cdib, tribe_types.item tribe, people.birth_date, people.social_security_number "
            "from people "
            "left join person_names on people.person_names_id = person_names.id "
            "left join affiliations on people.affiliations_id = affiliations.id "
            "left join tribe_types on affiliations.tribe_id = tribe_types.id "
            "left join person_contact_info on people.person_contact_info_id = person_contact_info.id "
            "left join state_types on person_contact_info.state_id = state_types.id "
            "where not exists(select tasks.id from tasks where tasks.person_id = people.id and "
            "tasks.group_id = " + diab_group_id + " and tasks.current_id >= 3";
      if(checkDiabetes->Checked)
        sql += " and tasks.date_of_task >= '" + begin_diab_date + "' and "
               "tasks.date_of_task <= '" + end_diab_date + "'";
      sql += ") and exists(select tasks.id from tasks where tasks.person_id = people.id and "
            "tasks.group_id != " + diab_group_id + " and tasks.current_id >= 3";
      if(checkOtherDepartment->Checked)
        sql += " and tasks.date_of_task >= '" + begin_dep_date + "' and "
               "tasks.date_of_task <= '" + end_dep_date + "'";
      sql += ") and exists(select conditions.id from conditions where conditions.person_id = people.id "
            "and (conditions.code='250' or conditions.code like '250.%') and conditions.current_id >= 3 "
            "and (conditions.condition_id = 0 or conditions.condition_id = 5)) "
            "order by person_names.last_name, person_names.first_name, people.birth_date";

      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportDiabClient * report_form = new TformReportDiabClient(NULL);
        report_form->clientReport->DataSet = dbDataSet;
        report_form->lblTitle->Caption = string("Clients not being seen by the Diabetes department as of " + CurrentDate()).c_str();
        report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        report_form->txtName->DataSet = dbDataSet;
        report_form->txtName->DataField = "last_first";
        report_form->txtSSN->DataSet = dbDataSet;
        report_form->txtSSN->DataField = "social_security_number";
        report_form->txtDOB->DataSet = dbDataSet;
        report_form->txtDOB->DataField = "birth_date";
        report_form->txtCDIB->DataSet = dbDataSet;
        report_form->txtCDIB->DataField = "cdib";
        report_form->txtTribe->DataSet = dbDataSet;
        report_form->txtTribe->DataField = "tribe";
        report_form->txtAddress->DataSet = dbDataSet;
        report_form->txtAddress->DataField = "all_lines";
        report_form->txtPhone->DataSet = dbDataSet;
        report_form->txtPhone->DataField = "phone_number";
        Processing(false);
        report_form->clientReport->Preview();

        if(checkLabels->Checked)
        {
          TformReportMailingLabels *label_form = new TformReportMailingLabels(NULL);
          label_form->labelReport->DataSet = dbDataSet;
          label_form->txtName->DataSet = dbDataSet;
          label_form->txtName->DataField = "first_last";
          label_form->txtAddress1->DataSet = dbDataSet;
          label_form->txtAddress1->DataField = "line1";
          Processing(false);
          label_form->labelReport->Preview();
        }
      FORM_CATCH

      if(checkTasks->Checked)
      {
        Processing(true);
        map<string, string> insert_map;
        insert_map["last_updated_by"] = current_userid;
        insert_map["last_update_stamp"] = RightNow();
        insert_map["current_id"] = "4";
        insert_map["date_of_task"] = CurrentDate();
        insert_map["group_id"] = diab_group_id;
        insert_map["user_id"] = lookupTables->IdOf("users", cboEmployee->Text.c_str());
        insert_map["method_id"] = lookupTables->IdOf("method_types", cboMethod->Text.c_str());
        insert_map["diab_activity_id"] = lookupTables->IdOf("diab_activity_types", cboActivity->Text.c_str());
        insert_map["task_comments"] = editNote->Text.c_str();
        dbDataSet->First();
        while(! dbDataSet->Eof)
        {
          insert_map["id"] = GetOneField(dbTransaction, "select gen_id(tasks_gen, 1) from uno");        
          insert_map["person_id"] = dbDataSet->FieldByName("person_id")->AsString.c_str();
          ExecuteInsertStatement(dbTransaction, "tasks", insert_map);
          dbDataSet->Next();
        }
        Processing(false);
      }
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabPeopleNotSeenReport::checkOtherDepartmentClick(
      TObject *Sender)
{
  if(checkOtherDepartment->Checked)
    RecurseEnabled(panelOther, true);
  else
    RecurseEnabled(panelOther, false);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabPeopleNotSeenReport::checkDiabetesClick(
      TObject *Sender)
{
  if(checkDiabetes->Checked)
    RecurseEnabled(panelDiabetes, true);
  else
    RecurseEnabled(panelDiabetes, false);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabPeopleNotSeenReport::checkTasksClick(
      TObject *Sender)
{
  if(checkTasks->Checked)
    RecurseEnabled(panelTask, true);
  else
    RecurseEnabled(panelTask, false);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabPeopleNotSeenReport::FormClose(
      TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("users", cboEmployee);
  lookupTables->UnregisterComboBox("method_types", cboMethod);
  lookupTables->UnregisterComboBox("diab_activity_types", cboActivity);
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
