//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "derivedheaders.h"
#include "launchDiabRegistryReport.h"
#include "reportDiabRegistry.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabRegistryReport *formLaunchDiabRegistryReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabRegistryReport::TformLaunchDiabRegistryReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabRegistryReport::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabRegistryReport::checkDatesClick(TObject *Sender)
{
  if(checkDates->Checked)
  {
    lblBeginDate->Enabled = true;
    lblEndDate->Enabled = true;
    dateBegin->Enabled = true;
    dateEnd->Enabled = true;
  }
  else
  {
    lblBeginDate->Enabled = false;
    lblEndDate->Enabled = false;
    dateBegin->Enabled = false;
    dateEnd->Enabled = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabRegistryReport::btnRunClick(TObject *Sender)
{
  if (checkLacDiab->Checked && (editMinVisits->Text == "" || (!IsInt(editMinVisits->Text.c_str())) ))
  {
     PSay("You must enter a valid number of visits", m_message, MB_OK);
     return;
  }
  // TODO:  enable delete from temp table at end again, when sure report is working
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;

  try
  {
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;

    TDateTime start_time = Now();
    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    dbTransaction->StartTransaction();

    sql = "delete from temp_diab_registry;";
    ExecuteStatement(dbTransaction, sql);

    //string lac_conditions_tasks = "from conditions left join tasks on conditions.task_id = tasks.id and conditions.person_id = OC.person_id "
    //                             "where conditions.current_id >= 3 and tasks.current_id >= 3 "
    //                             "      and conditions.group_id in (" + lookupTables->IdOf("groups", "LITTLE AXE CLINIC") + "," + lookupTables->IdOf("groups", "SHAWNEE CLINIC") + "," + lookupTables->IdOf("groups", "DIABETES") + ") "
    //                             "      and (conditions.code='250' or conditions.code like '250.%') and conditions.condition_id = " + lookupTables->IdOf("condition_types", "CONDITION");

    if (checkLacDiab->Checked)
    {
       // 1) get all people with diabetes and their first associated task for LAC or diabetes (e.g. their diagnosis date)
       sql = "insert into temp_diab_registry "
             "    select conditions.person_id, min(tasks.date_of_task), 1, NULL, NULL, NULL, min(conditions.code), NULL, NULL, NULL, NULL, NULL, NULL "
             "    from conditions left join tasks on conditions.task_id = tasks.id "
             "    where conditions.current_id >= 3 and tasks.current_id >= 3 "
//             "         and conditions.group_id in (" + lookupTables->IdOf("groups", "LITTLE AXE CLINIC") + "," + lookupTables->IdOf("groups", "SHAWNEE CLINIC") + "," + lookupTables->IdOf("groups", "DIABETES") + ") "
             "         and (conditions.code='250' or conditions.code like '250.%') and conditions.condition_id = " + lookupTables->IdOf("condition_types", "CONDITION") +
             "         and not exists (select * from temp_diab_registry where temp_diab_registry.person_id = conditions.person_id) "
             "    group by conditions.person_id";
       DebugSql(this, &sql, other_forms, 9, dbTransaction);
       if (!ExecuteStatement(dbTransaction, sql)) throw (1);
    }
    TDateTime end_statement1 = Now();
    if (checkStar->Checked)
    {
       // 2) get all people who are STAR participants and their related info (IF they have any)
       sql = "insert into temp_diab_registry "
             "    select people.id, min(tasks.date_of_task), 2, NULL, NULL, NULL, min(tasks.date_of_task), NULL, NULL, NULL, NULL, NULL, NULL "
             "    from people left join conditions OC on OC.person_id = people.id and OC.current_id >= 3 "
             "         left join tasks on OC.task_id = tasks.id and tasks.current_id >= 3 "
             "    where people.current_id >= 3 "
             "         and exists (select SPE.id from enrollment SPE where SPE.person_id = people.id and SPE.current_id+1 >= 4 and " // jhaley: changed star_participant -> enrollment
             "                     SPE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "STAR Participant") + "') "
             "         and not exists (select * from temp_diab_registry where temp_diab_registry.person_id = people.id) "
             "    group by people.id";
       DebugSql(this, &sql, other_forms, 9, dbTransaction);
       if (!ExecuteStatement(dbTransaction, sql)) throw (2);
    }
    TDateTime end_statement2 = Now();
    if (checkAnderson->Checked)
    {
       // 3) get all people with a 250 code diagnosed by Dr. Anderson (on a Contract Health COB visit)
       // TODO -c MAGIC : note Dr. Anderson (tax id 1683) is hard coded.  Ew.  But Ruby wanted just her.
       sql = "insert into temp_diab_registry "
             "    select OC.person_id, min(tasks.date_of_task), 3, NULL, NULL, NULL, min(OC.code), NULL, NULL, NULL, NULL, NULL, NULL "
             "    from conditions OC left join tasks on OC.task_id = tasks.id "
             "    where tasks.tax_entity_id = 1683 and OC.current_id >= 3 and tasks.current_id >= 3"
             "         and OC.group_id = " + lookupTables->IdOf("groups", "CONTRACT HEALTH") + " "
             "         and (OC.code='250' or OC.code like '250.%') and OC.condition_id = " + lookupTables->IdOf("condition_types", "CONDITION") +
             "         and not exists (select * from temp_diab_registry where temp_diab_registry.person_id = OC.person_id) "
             "    group by OC.person_id";
       DebugSql(this, &sql, other_forms, 9, dbTransaction);
       if (!ExecuteStatement(dbTransaction, sql)) throw (3);
    }
    TDateTime end_statement3 = Now();

    string restrict_dates = "tasks.date_of_task >= '" + string(DateToStr(dateBegin->Date).c_str()) + "' and tasks.date_of_task <= '" + string(DateToStr(dateEnd->Date).c_str()) + "'";
    string get_visit_count = "select count(id) from tasks where person_id = temp_diab_registry.person_id and tasks.current_id >= 3 and group_id in (" + lookupTables->IdOf("groups", "LITTLE AXE CLINIC") + "," + lookupTables->IdOf("groups", "SHAWNEE CLINIC") + ")";

    if (checkLacDiab->Checked)
    {
       string MinVisits = editMinVisits->Text.c_str();
       // 4) now get the most recent visit date for people who have had at least MinVisits visits @ LAC within the date range
       // -which falls in the given date range- if specified
       sql =    "insert into temp_diab_registry "
                "   select temp_diab_registry.person_id, temp_diab_registry.diag_date, 4, max(tasks.date_of_task), (" + get_visit_count + "), NULL, temp_diab_registry.diag_code, NULL, NULL, NULL, NULL, NULL, NULL "
                "   from temp_diab_registry left join tasks on tasks.person_id = temp_diab_registry.person_id "
                "        and tasks.group_id in (" + lookupTables->IdOf("groups", "LITTLE AXE CLINIC") + "," + lookupTables->IdOf("groups", "SHAWNEE CLINIC") + "," + lookupTables->IdOf("groups", "DIABETES") + ") "
                "        and tasks.method_id != " + lookupTables->IdOf("method_types", "MAIL") + " and tasks.current_id >= 3 "
                "   where temp_diab_registry.current_statement = 1 ";
       if (checkDates->Checked == true)
         sql += "   and " + restrict_dates + " ";

       sql += "group by temp_diab_registry.person_id, temp_diab_registry.diag_date, temp_diab_registry.diag_code";
       if (StringToInt(MinVisits) > 0)
       {
         sql += " having (" + get_visit_count;
         if (checkDates->Checked)
           sql += " and " + restrict_dates;
         sql += + ") >= " + MinVisits + " ";
       }
       DebugSql(this, &sql, other_forms, 9, dbTransaction);
       if (!ExecuteStatement(dbTransaction, sql)) throw (4);
    }
    TDateTime end_statement4 = Now();

    // 5) now get the most recent visit for the STAR and Dr. Anderson people (no visit count requirement)
    // -which falls in the given date range- if specified
    sql =    "insert into temp_diab_registry "
             "   select temp_diab_registry.person_id, temp_diab_registry.diag_date, 5, max(tasks.date_of_task), (" + get_visit_count + "), NULL, temp_diab_registry.diag_code, NULL, NULL, NULL, NULL, NULL, NULL "
             "   from temp_diab_registry left join tasks on tasks.person_id = temp_diab_registry.person_id "
             "        and tasks.group_id in (" + lookupTables->IdOf("groups", "LITTLE AXE CLINIC") + "," + lookupTables->IdOf("groups", "SHAWNEE CLINIC") + "," + lookupTables->IdOf("groups", "DIABETES") + ") "
             "        and tasks.method_id != " + lookupTables->IdOf("method_types", "MAIL") + " and tasks.current_id >= 3 ";
    if (checkDates->Checked == true)
      sql += "        and " + restrict_dates + " ";
    sql += "where temp_diab_registry.current_statement in (2, 3) "
           "group by temp_diab_registry.person_id, temp_diab_registry.diag_date, temp_diab_registry.diag_code;";
    DebugSql(this, &sql, other_forms, 9, dbTransaction);
    if (!ExecuteStatement(dbTransaction, sql)) throw (5);

    TDateTime end_statement5 = Now();

    // 6) get their most recent appointment date (created for them by a user either at LAC or in diabetes)
    sql = "insert into temp_diab_registry "
          "select temp_diab_registry.person_id, temp_diab_registry.diag_date, 6, temp_diab_registry.last_visit_date, temp_diab_registry.visit_count, "
          " max(appointments.appointment_date), temp_diab_registry.diag_code, NULL, NULL, NULL, NULL, NULL, NULL "
          "from temp_diab_registry "
          "left join appointments on appointments.person_id = temp_diab_registry.person_id and appointments.current_id >= 3 "
          "left join users on appointments.created_for = users.id and "
          " users.group_id in (" + lookupTables->IdOf("groups", "LITTLE AXE CLINIC") + ", "
                                 + lookupTables->IdOf("groups", "SHAWNEE CLINIC") + ", "
                                 + lookupTables->IdOf("groups", "DIABETES") + ") "
          "where temp_diab_registry.current_statement in (4, 5) ";
    sql += "group by temp_diab_registry.person_id, temp_diab_registry.diag_date, temp_diab_registry.last_visit_date, "
           " temp_diab_registry.visit_count, temp_diab_registry.diag_code;";
    DebugSql(this, &sql, other_forms, 9, dbTransaction);
    if (!ExecuteStatement(dbTransaction, sql))
      throw (6);

    TDateTime end_statement6 = Now();

    // 7) A name would be a nice thing to associate with them at some point...
    sql = "insert into temp_diab_registry "
             "select temp_diab_registry.person_id, temp_diab_registry.diag_date, 7, temp_diab_registry.last_visit_date, temp_diab_registry.visit_count, "
                    "temp_diab_registry.last_appt_date, temp_diab_registry.diag_code, "
                    "person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.middle_name || ' ' || person_names.suffix, "
                    "case when client_enrollment.id is not null then 1 else 0 end is_diabetes_client, " // jhaley: changed diab_client_id -> enrollment
                    "case when star_enrollment.id is not null then 1 else 0 end star_participant, "     // jhaley: changed star_participant -> enrollment
                    "(select first 1 charts.chart_number from charts where charts.person_id = temp_diab_registry.person_id and "
                      "charts.location_id in ("
                      + lookupTables->IdOf("location_types", "LITTLE AXE CLINIC") + "," + lookupTables->IdOf("location_types", "SHAWNEE CLINIC") +
                      ") and charts.current_id >= 3), " // jhaley 20101007: was missing a ')' here before the 'and', and used wrong table for Shawnee Clinic
                    "people.birth_date, "
                    "case when steps_enrollment.id is not null then '1' else '0' end steps_member "
             "from temp_diab_registry "
             "inner join people on people.id = temp_diab_registry.person_id and people.current_id >= 3 and death_date is null "
             "left join person_names on person_names.id = people.person_names_id "
             "left join enrollment steps_enrollment on steps_enrollment.person_id = people.id and steps_enrollment.current_id+1 >= 4 and "
               "steps_enrollment.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "STEPS Participant") + "' and "
               "steps_enrollment.enrollment_status_id = '" + lookupTables->IdOf("enrollment_status_types", "Member") + "' "
             "left join enrollment client_enrollment on client_enrollment.person_id = people.id and client_enrollment.current_id+1 >= 4 and "
               "client_enrollment.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "' "
             "left join enrollment star_enrollment on star_enrollment.person_id = people.id and star_enrollment.current_id+1 >= 4 and "
               "star_enrollment.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "STAR Participant") + "' "
             "where temp_diab_registry.current_statement = 6 ";
    DebugSql(this, &sql, other_forms, 9, dbTransaction);
    if (!ExecuteStatement(dbTransaction, sql)) throw (7);

    TDateTime end_statement7 = Now();

    // TODO: Leave this out and make them actually read the appointment date; this makes it look like they haven't had an appt ever just because they haven't in the given date range
    // IDEA: Leave it out and then format that field OnPrint on the report so it's grey if < dateBegin, or black otherwise.  Yay, visual feedback!
    if (checkDates->Checked == true)
    {
       sql = "update temp_diab_registry set last_appt_date = null where last_appt_date < '" + string(DateToStr(dateBegin->Date).c_str()) + "' and current_statement = 7;";
       ExecuteStatement(dbTransaction, sql);
    }

    TDateTime end_time = Now();
    PSay(("Running time of statements:\n"
          "Statement 1:  " + string((end_statement1 - start_time).TimeString().c_str()) + "\n"
          "Statement 2:  " + string((end_statement2 - end_statement1).TimeString().c_str()) + "\n"
          "Statement 3:  " + string((end_statement3 - end_statement2).TimeString().c_str()) + "\n"
          "Statement 4:  " + string((end_statement4 - end_statement3).TimeString().c_str()) + "\n"
          "Statement 5:  " + string((end_statement5 - end_statement4).TimeString().c_str()) + "\n"
          "Statement 6:  " + string((end_statement6 - end_statement5).TimeString().c_str()) + "\n"
          "Statement 7:  " + string((end_statement7 - end_statement6).TimeString().c_str()) + "\n"
          "Total:        " + string((end_time - start_time).TimeString().c_str()) + "\n"
          ), m_message, MB_OK);


    sql = "select distinct(temp_diab_registry.*) from temp_diab_registry where current_statement = 7 order by name";

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportDiabRegistry * report_form = new TformReportDiabRegistry(NULL);
      report_form->report->DataSet = dbDataSet;
      report_form->lblDateTitle->Caption = date_title.c_str();
      report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      report_form->txtName->DataSet = dbDataSet;
      report_form->txtName->DataField = "name";
      report_form->txtDOB->DataSet = dbDataSet;
      report_form->txtDOB->DataField = "dob";
      report_form->txtApptDate->DataSet = dbDataSet;
      report_form->txtApptDate->DataField = "last_appt_date";
      report_form->txtVisitDate->DataSet = dbDataSet;
      report_form->txtVisitDate->DataField = "last_visit_date";
      report_form->txtChartNum->DataSet = dbDataSet;
      report_form->txtChartNum->DataField = "chart_number";
      report_form->txtCode->DataSet = dbDataSet;
      report_form->txtCode->DataField = "diag_code";
      report_form->txtDiagDate->DataSet = dbDataSet;
      report_form->txtDiagDate->DataField = "diag_date";
  //    report_form->txtProvider->DataSet = dbDataSet;
  //    report_form->txtProvider->DataField = "diag_provider";
      report_form->exprClient->Expression = "IF(is_diabetes_client = '1', 'Yes', 'No')";
      report_form->exprStar->Expression = "IF(star_participant = '1', 'Yes', 'No')";
      report_form->exprSteps->Expression = "IF(steps_member = '1', 'Yes', 'No')";
      report_form->txtVisitCount->DataSet = dbDataSet;
      report_form->txtVisitCount->DataField = "visit_count";
      Processing(false);
      report_form->report->Preview();
    FORM_CATCH
    dbDataSet->Close();

    ExecuteStatement(dbTransaction, "delete from temp_diab_registry");
    dbTransaction->Commit();
  }
  catch (int sql_statement)
  {
    Processing(false);
    PSay("Error running report.\nError executing SQL statement " + IntToString(sql_statement) + "\n\n" + last_sql_lib_error.message, m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report.\nNot an SQL error.", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }

  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchDiabRegistryReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

