//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabScoreSummaryReport.h"
#include "reportDiabScoreSummary.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabScoreSummaryReport *formLaunchDiabScoreSummaryReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabScoreSummaryReport::TformLaunchDiabScoreSummaryReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabScoreSummaryReport::btnCloseClick(
      TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabScoreSummaryReport::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;         

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabScoreSummaryReport::btnRunClick(
      TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;
  string unique_people;

  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;
    dbTransaction->StartTransaction();

    sql = "select count(distinct person_id) from diab_education where "
          "((diab_education.pre_test_date >= '" + begin_date + "' and diab_education.pre_test_date <= '" + end_date + "') or "
          "(diab_education.post_test_date >= '" + begin_date + "' and diab_education.post_test_date <= '" + end_date + "'))";
    unique_people = GetOneField(dbTransaction, sql);

    sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix full_name, "
          "diab_topic_types.item topic, diab_education.pre_test_date, diab_education.pre_score, "
          "diab_education.post_test_date, diab_education.post_score "
          "from diab_education "
          "inner join diab_topic_types on diab_education.diab_topic_id = diab_topic_types.id "
          "inner join people on diab_education.person_id = people.id "
          "inner join person_names on people.person_names_id = person_names.id "
          "where diab_education.person_id > 0 and "
          "((diab_education.pre_test_date >= '" + begin_date + "' and diab_education.pre_test_date <= '" + end_date + "') or "
          "(diab_education.post_test_date >= '" + begin_date + "' and diab_education.post_test_date <= '" + end_date + "')) "
          "order by person_names.last_name, person_names.first_name, diab_topic_types.item";

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportDiabScoreSummary * report_form = new TformReportDiabScoreSummary(NULL);
      report_form->report->DataSet = dbDataSet;
      report_form->lblDateTitle->Caption = date_title.c_str();
      report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      report_form->txtPerson->DataSet = dbDataSet;
      report_form->txtPerson->DataField = "full_name";
      report_form->txtTopic->DataSet = dbDataSet;
      report_form->txtTopic->DataField = "topic";
      report_form->txtPreTestDate->DataSet = dbDataSet;
      report_form->txtPreTestDate->DataField = "pre_test_date";
      report_form->txtPreScore->DataSet = dbDataSet;
      report_form->txtPreScore->DataField = "pre_score";
      report_form->txtPostTestDate->DataSet = dbDataSet;
      report_form->txtPostTestDate->DataField = "post_test_date";
      report_form->txtPostScore->DataSet = dbDataSet;
      report_form->txtPostScore->DataField = "post_score";
      report_form->lblTotalPeople->Caption = unique_people.c_str();
      Processing(false);
      report_form->report->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
