//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabStaffActivityReport.h"
#include "reportDiabStaffActivity.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabStaffActivityReport *formLaunchDiabStaffActivityReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabStaffActivityReport::TformLaunchDiabStaffActivityReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabStaffActivityReport::btnCloseClick(
      TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabStaffActivityReport::btnRunClick(
      TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {
    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;


    sql =  "select users.item staff, diab_activity_types.item activity, sum(tasks.time_spent) total_time, count(tasks.id) total_contacts "
           "from users "
           "inner join tasks on tasks.user_id = users.id "
           "inner join diab_activity_types on tasks.diab_activity_id = diab_activity_types.id "
           "where "
           "tasks.group_id = " + lookupTables->IdOf("groups", "Diabetes") + " and "
           "tasks.current_id >= 3 and "
           //"tasks.diab_activity_id > 0 and "
           "tasks.user_id > 0 and "
           "tasks.date_of_task >= '" + begin_date + "' and "
           "tasks.date_of_task <= '" + end_date + "' ";
    if (checkWithPeople->Checked)
      sql += "and tasks.person_id > 0 ";
    sql += "group by users.item, diab_activity_types.item";

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportDiabStaffActivity * activityReport = new TformReportDiabStaffActivity(NULL);
      activityReport->activityReport->DataSet = dbDataSet;
      activityReport->groupBand->Expression = "staff";
      activityReport->lblDateTitle->Caption = date_title.c_str();
      activityReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      activityReport->txtStaff->DataSet = dbDataSet;
      activityReport->txtStaff->DataField = "staff";
      activityReport->txtActivity->DataSet = dbDataSet;
      activityReport->txtActivity->DataField = "activity";
      activityReport->exprHours->Expression = "FORMATNUMERIC('#,##0.00', total_time)";
      activityReport->exprContacts->Expression = "FORMATNUMERIC('0', total_contacts)";
      activityReport->exprTotal->Expression = "FORMATNUMERIC('0', SUM(total_contacts))";
      Processing(false);
      activityReport->activityReport->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabStaffActivityReport::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------


