//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabStarSessionReport.h"
#include "reportDiabStarSession.h"
//---------------------------------------------------------------------------
#include "codeSpecialSqlViewer.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabStarSessionReport *formLaunchDiabStarSessionReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabStarSessionReport::TformLaunchDiabStarSessionReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabStarSessionReport::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabStarSessionReport::btnRunClick(TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;
  string session = string(editSession->Text.c_str());
  if(session == "" || !IsInt(session) || StringToInt(session) < 0 || StringToInt(session) > 5)
  {
    PSay("Enter a valid session number.", m_invalid_data, MB_OK);
    Processing(false);
    return;
  }

  try
  {
    TDateTime start_time = Now();
    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    dbTransaction->StartTransaction();

    sql = "select last_name || ', ' || first_name || ' ' || middle_name || ' ' || suffix name, people.id person_id, "
          " people.birth_date birth_date, affiliations.cdib cdib, tribe_types.item tribe, "
          " appointments.begin_date begin_date, visit_outcome_types.item outcome, "
          " person_contact_info.phone_number phone_number, tasks.id task_id, appt_reason_types.item reason, diab_activity_types.item activity "
          "from people "
          " left join person_names on people.person_names_id = person_names.id and people.current_id >= 3 and person_names.current_id >= 3 "
          " left join person_contact_info on people.person_contact_info_id = person_contact_info.id and person_contact_info.current_id >= 3 "
          " left join affiliations on people.affiliations_id = affiliations.id and affiliations.current_id >= 3 "
          " left join tribe_types on affiliations.tribe_id = tribe_types.id and tribe_types.valid = 1 "
          " inner join appointments on appointments.person_id = people.id and appointments.current_id >= 3 "
          " left join visit_outcome_types on appointments.visit_outcome_id = visit_outcome_types.id and visit_outcome_types.valid = 1 "
          " left join appt_reason_types on appointments.appt_reason_id = appt_reason_types.id and appt_reason_types.valid = 1 "
          " left join tasks on tasks.id = appointments.task_id and tasks.current_id >= 3 "
          " left join diab_activity_types on tasks.diab_activity_id = diab_activity_types.id and diab_activity_types.valid = 1 "
          "where "
          "exists (select SPE.id from enrollment SPE where SPE.person.id = people.id and SPE.current_id+1 >= 4 and " // jhaley: changed star_participant -> enrollment
          " SPE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "STAR Participant") + "') and "
          "UPPER(appt_reason_types.item) like 'STAR SESSION " + session + "' and "
          "people.id > 0 ";
    if(checkDates->Checked)
      sql += " and appointments.begin_date between '" + begin_date + "' and '" + end_date + "' ";
    sql += "order by last_name, first_name, middle_name, suffix, cdib, begin_date ";

    DebugSql(this, &sql, other_forms, 9);

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportDiabStarSession * report_form = new TformReportDiabStarSession(NULL);
      report_form->report->DataSet = dbDataSet;
      report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      report_form->lblTitle->Caption = ReplaceStringWithString(report_form->lblTitle->Caption.c_str(), "X", IntToString(StringToInt(editSession->Text.c_str()))).c_str();
      if (checkDates->Checked)
        report_form->lblDateTitle->Caption = date_title.c_str();
      else
        report_form->lblDateTitle->Caption = "";
      report_form->txtName->DataSet = dbDataSet;
      report_form->txtName->DataField = "name";
      //report_form->txtPersonID->DataSet = dbDataSet;
      //report_form->txtPersonID->DataField = "person_id";
      report_form->txtDOB->DataSet = dbDataSet;
      report_form->txtDOB->DataField = "birth_date";
      report_form->txtCDIB->DataSet = dbDataSet;
      report_form->txtCDIB->DataField = "cdib";
      report_form->txtTribe->DataSet = dbDataSet;
      report_form->txtTribe->DataField = "tribe";
      report_form->txtApptDate->DataSet = dbDataSet;
      report_form->txtApptDate->DataField = "begin_date";
      report_form->txtOutcome->DataSet = dbDataSet;
      report_form->txtOutcome->DataField = "outcome";
      report_form->txtPhone->DataSet = dbDataSet;
      report_form->txtPhone->DataField = "phone_number";
      report_form->exprTasked->Expression = "IF(task_id > 0, 'Yes', 'No')";
      report_form->exprTasked2->Expression = "IF(reason <> '', 'Yes', 'No')";
      report_form->exprTasked3->Expression = "IF(reason = activity, 'Yes', 'No')";
      Processing(false);
      report_form->report->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }

  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabStarSessionReport::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabStarSessionReport::checkDatesClick(TObject *Sender)
{
  if(checkDates->Checked)
  {
    lblBeginDate->Enabled = true;
    lblEndDate->Enabled = true;
    dateBegin->Enabled = true;
    dateEnd->Enabled = true;
  }
  else
  {
    lblBeginDate->Enabled = false;
    lblEndDate->Enabled = false;
    dateBegin->Enabled = false;
    dateEnd->Enabled = false;
  }
}
//---------------------------------------------------------------------------

