//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabTaskReport.h"
#include "codeSearchPerson.h"
#include "reportDiabTask.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabTaskReport *formLaunchDiabTaskReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabTaskReport::TformLaunchDiabTaskReport(TComponent* Owner, string id)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  CreateLink(txtName, btnPersonSearch, this, id, "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabTaskReport::btnPersonSearchClick(
      TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtName, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabTaskReport::btnRunClick(TObject *Sender)
{
  string person_id = GetValidLinkId(txtName);
  if (person_id != "")
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Task report for " + GetPersonName(dbDatabase, person_id, first_last);

    try
    {
      StdTransaction(dbTransaction, dbDatabase);
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select tasks.date_of_task, users.item staff, tasks.time_spent, "
            "method_types.item method, direction_types.item direction, program_types.item program, "
            "task_purpose_types.item task_type, diab_activity_types.item activity_type "
            "from tasks "
            "inner join users on tasks.user_id = users.id "
            "inner join events on tasks.event_id = events.id "
            "inner join method_types on tasks.method_id = method_types.id "
            "inner join direction_types on tasks.direction_id = direction_types.id "
            "inner join program_types on tasks.program_id = program_types.id "
            "inner join task_purpose_types on tasks.task_purpose_id = task_purpose_types.id "
            "inner join diab_activity_types on tasks.diab_activity_id = diab_activity_types.id "
            "where tasks.group_id = " + lookupTables->IdOf("groups", "Diabetes") + " and "
            "tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' and "
            "tasks.person_id = '" + person_id + "' and "
            "tasks.current_id >= 3 "
            "order by tasks.date_of_task ";

      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportDiabTask * taskReport = new TformReportDiabTask(NULL);
        taskReport->taskReport->DataSet = dbDataSet;
        taskReport->lblTitle->Caption = title.c_str();
        taskReport->lblDateTitle->Caption = date_title.c_str();
        taskReport->txtDate->DataSet = dbDataSet;
        taskReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        taskReport->txtDate->DataField = "date_of_task";
        taskReport->txtStaff->DataSet = dbDataSet;
        taskReport->txtStaff->DataField = "staff";
        taskReport->exprTime->Expression = "FORMATNUMERIC('##0.00', time_spent)";
        taskReport->txtMethod->DataSet = dbDataSet;
        taskReport->txtMethod->DataField = "method";
        taskReport->txtDirection->DataSet = dbDataSet;
        taskReport->txtDirection->DataField = "direction";
        taskReport->txtProgram->DataSet = dbDataSet;
        taskReport->txtProgram->DataField = "program";
        taskReport->txtTaskType->DataSet = dbDataSet;
        taskReport->txtTaskType->DataField = "task_type";
        taskReport->txtActivityType->DataSet = dbDataSet;
        taskReport->txtActivityType->DataField = "activity_type";
        Processing(false);
        taskReport->taskReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;
  }
  else
  {
    PSay("Please enter a client name", m_missing_data, MB_OK);
    btnPersonSearch->SetFocus();
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabTaskReport::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabTaskReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

