//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchDiabTribalReport.h"
#include "reportDiabTribal.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchDiabTribalReport *formLaunchDiabTribalReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchDiabTribalReport::TformLaunchDiabTribalReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabTribalReport::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabTribalReport::btnRunClick(TObject *Sender)
{
  Processing(true);
  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string date_title = "Client served grouped by tribal affiliation - " + CurrentDate();
  Pdate child_date = CurrentPdate();
  child_date.mod(-18, in_years);
  Pdate fifty_date = CurrentPdate();
  fifty_date.mod(-55, in_years);  

  try
  {
    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;


    sql = "select tribe_types.item tribe, count(people.id) the_count "
          "from people left join affiliations on affiliations.id = people.affiliations_id "
          "and affiliations.current_id >= 3 "
          "left join tribe_types on affiliations.tribe_id = tribe_types.id "
          "where "
          "exists (select DCE.id from enrollment DCE where DCE.person_id = people.id and DCE.current_id+1 >= 4 and " // jhaley: changed is_diabetes_client -> enrollment
          " DCE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "') and "
          "people.current_id >= 3 and affiliations.current_id >= 3 and ";
    if (checkMailingList->Checked)
    {
      // jhaley: changed on_diab_mailing_list -> enrollment
      sql += "exists (select MLE.id from enrollment MLE where MLE.person_id = people.id and MLE.current_id+1 >= 4 and "
             " MLE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "On Diabetes Mailing List") + "') and ";
    }
    if (checkDiabetes->Checked)
      sql += "exists (select * from conditions where conditions.person_id = people.id and "
             "(conditions.code='250' or conditions.code like '250.%') and conditions.current_id >= 3) and ";
    if (checkSteps->Checked)
    {
      // jhaley: changed steps_member -> enrollment
      sql += "exists (select SE.id from enrollment SE "
             "where SE.person_id = people.id and SE.current_id+1 >= 4 and "
             "SE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "STEPS Participant") + "' and "
             "SE.enrollment_status_id = '" + lookupTables->IdOf("enrollment_status_types", "Member") + "') and ";
    }
    if (checkFitness->Checked)
      sql += "exists (select fitness_people.person_id from fitness_people, fitness_memberships where "
             "people.id = fitness_people.person_id and fitness_memberships.id = "
             "fitness_people.fitness_membership_id and "
             "fitness_memberships.end_date is null and fitness_people.current_id >= 3 and "
             "fitness_memberships.current_id >= 3) and ";
    if (checkChild->Checked)
      sql += "people.birth_date >= '" + child_date.OutDate(mdy | yyyy) + "' and ";
    if (checkFifty->Checked)
      sql += "people.birth_date <= '" + fifty_date.OutDate(mdy | yyyy) + "' and ";
    sql = sql.substr(0, sql.length()-4);
    sql += " group by tribe_types.item order by tribe_types.item";

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportDiabTribal * tribalReport = new TformReportDiabTribal(NULL);
      tribalReport->tribalReport->DataSet = dbDataSet;
      tribalReport->lblTitle->Caption = date_title.c_str();
      tribalReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      tribalReport->txtTribe->DataSet = dbDataSet;
      tribalReport->txtTribe->DataField = "tribe";
      tribalReport->txtTotal->DataSet = dbDataSet;
      tribalReport->txtTotal->DataField = "the_count";
      tribalReport->exprTotal->Expression = "SUM(the_count)";
      Processing(false);
      tribalReport->tribalReport->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchDiabTribalReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

