//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchEckerdReports.h"
#include "reportEckerd1.h"
#include "reportEckerd2.h"
#include "reportEckerd3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchEckerdReports *formLaunchEckerdReports;
//---------------------------------------------------------------------------
__fastcall TformLaunchEckerdReports::TformLaunchEckerdReports(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  upDownYear->Position = Pstamp(RightNow(), mdy | yyyy | datefirst | withsec).year;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchEckerdReports::btnRunClick(TObject *Sender)
{
  if(! lookupTables->IsInLookUpTable("month_types", cboMonth->Text.c_str()))
  {
    PSay("Please enter a valid month", m_invalid_data, MB_OK);
    cboMonth->SetFocus();
  }
  else if(editYear->Text == "")
  {
    PSay("Please enter a year", m_missing_data, MB_OK);
    editYear->SetFocus();
  }
  else if(! IsInt(editYear->Text.c_str()))
  {
    PSay("Please enter a valid year", m_invalid_data, MB_OK);
    editYear->SetFocus();
  }
  else
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    TStringList * sqlstmt = new TStringList;
    string bill_month = cboMonth->Text.c_str();
    string bill_month_id = lookupTables->IdOf("month_types", cboMonth->Text.c_str());
    string bill_year = editYear->Text.c_str();
    string sqlstring;
    string title;
    string date_title = bill_month + " " + bill_year;
    try
    {
      StdTransaction(dbTransaction, dbDatabase);
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      string pharmacy_id = lookupTables->IdOf("pharmacy_types", "Eckerd");

      sqlstring = "select person_names.last_name, person_names.first_name, affiliations.cdib, "
                  "pharmacy_locations.store_number, pharmacy_info.rx_number, pharmacy_info.drug_name, "
                  "pharmacy_info.amount_billed, pharmacy_info.dispense_date, pharmacy_info.physician_name "
                  "from pharmacy_info, pharmacy_locations, people "
                  "left join person_names on people.person_names_id = person_names.id "
                  "left join affiliations on people.affiliations_id = affiliations.id "
                  "where pharmacy_info.pharmacy_location_id = pharmacy_locations.id and "
                  "pharmacy_locations.pharmacy_id = " + pharmacy_id + " and "
                  "pharmacy_info.person_id = people.id and "
                  "pharmacy_info.bill_month = " + bill_month_id + " and "
                  "bill_year = " + bill_year + " order by person_names.last_name, person_names.first_name";
      sqlstmt->Add(sqlstring.c_str());

      dbDataSet->SelectSQL = sqlstmt;
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportEckerd1 * report1 = new TformReportEckerd1(NULL);
        report1->eckerdReport1->DataSet = dbDataSet;
        report1->lblDateTitle->Caption = date_title.c_str();
        report1->txtLastName->DataSet = dbDataSet;
        report1->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        report1->txtLastName->DataField = "last_name";
        report1->txtFirstName->DataSet = dbDataSet;
        report1->txtFirstName->DataField = "first_name";
        report1->txtCDIB->DataSet = dbDataSet;
        report1->txtCDIB->DataField = "cdib";
        report1->txtStoreNumber->DataSet = dbDataSet;
        report1->txtStoreNumber->DataField = "store_number";
        report1->txtRxNumber->DataSet = dbDataSet;
        report1->txtRxNumber->DataField = "rx_number";
        report1->txtPhysician->DataSet = dbDataSet;
        report1->txtPhysician->DataField = "physician_name";
        report1->txtDrugName->DataSet = dbDataSet;
        report1->txtDrugName->DataField = "drug_name";
        report1->exprAmountBilled->Expression = "FORMATNUMERIC('$ #,##0.00', amount_billed)";
        report1->txtDispenseDate->DataSet = dbDataSet;
        report1->txtDispenseDate->DataField = "dispense_date";
        report1->exprTotal->Expression = "FORMATNUMERIC('$ ###,##0.00', SUM(amount_billed))";
        Processing(false);
        report1->eckerdReport1->Preview();
      FORM_CATCH

      FORM_TRY
        TformReportEckerd2 * report2 = new TformReportEckerd2(NULL);
        report2->eckerdReport2->DataSet = dbDataSet;
        report2->lblDateTitle->Caption = date_title.c_str();
        report2->txtStoreNumber->DataSet = dbDataSet;
        report2->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        report2->txtStoreNumber->DataField = "store_number";
        report2->txtRxNumber->DataSet = dbDataSet;
        report2->txtRxNumber->DataField = "rx_number";
        report2->txtDrugName->DataSet = dbDataSet;
        report2->txtDrugName->DataField = "drug_name";
        report2->exprAmountBilled->Expression = "FORMATNUMERIC('$ #,##0.00', amount_billed)";
        report2->txtDispenseDate->DataSet = dbDataSet;
        report2->txtDispenseDate->DataField = "dispense_date";
        report2->exprTotal->Expression = "FORMATNUMERIC('$ ###,##0.00', SUM(amount_billed))";
        report2->eckerdReport2->Preview();
        dbDataSet->Close();
      FORM_CATCH

      sqlstring = "select pharmacy_locations.store_number, sum(pharmacy_info.amount_billed) total_amount, "
                  "count(pharmacy_info.id) claims_count "
                  "from pharmacy_locations, pharmacy_info "
                  "where pharmacy_info.pharmacy_location_id = pharmacy_locations.id and "
                  "pharmacy_locations.pharmacy_id = " + pharmacy_id + " and "
                  "pharmacy_info.bill_month = " + bill_month_id + " and "
                  "pharmacy_info.bill_year = " + bill_year +
                  " group by pharmacy_locations.store_number";
      sqlstmt->Clear();
      sqlstmt->Add(sqlstring.c_str());
      dbDataSet->SelectSQL = sqlstmt;
      dbDataSet->Open();
      dbDataSet->First();

      title = "Eckerd Totals Per Store - " + date_title;

      FORM_TRY
        TformReportEckerd3 * report3 = new TformReportEckerd3(NULL);
        report3->eckerdReport3->DataSet = dbDataSet;
        report3->lblTitle->Caption = title.c_str();
        report3->txtStoreNumber->DataSet = dbDataSet;
        report3->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        report3->txtStoreNumber->DataField = "store_number";
        report3->exprAmount->Expression = "FORMATNUMERIC('$ ###,##0.00', total_amount)";
        report3->exprClaims->Expression = "claims_count";
        report3->exprTotalAmount->Expression = "FORMATNUMERIC('$ ###,##0.00', SUM(total_amount))";
        report3->exprTotalClaims->Expression = "SUM(claims_count)";
        report3->eckerdReport3->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;
    delete sqlstmt;
  }

}
//---------------------------------------------------------------------------
void __fastcall TformLaunchEckerdReports::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchEckerdReports::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

