//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchEmployeeCallLogReport.h"
#include "reportEmployeeCallLog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchEmployeeLogReport *formLaunchEmployeeLogReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchEmployeeLogReport::TformLaunchEmployeeLogReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  lookupTables->RegisterComboBox("users", cboEmployee);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchEmployeeLogReport::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchEmployeeLogReport::btnRunClick(TObject *Sender)
{
  if (cboEmployee->Text == "" || ! lookupTables->IsInLookUpTable("users", cboEmployee->Text.c_str()))
  {
    PSay("Please enter a valid employee name", m_invalid_data, MB_OK);
    cboEmployee->SetFocus();
  }
  else
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Call Log for " + string(cboEmployee->Text.c_str());

    try
    {
      StdTransaction(dbTransaction, dbDatabase);
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select cast(call_log.call_time as date) call_date, "
            "cast(call_log.call_time as time) call_time, call_log.caller_name, "
            "users.item receptionist_name, call_log.note "
            "from call_log, users where call_log.receptionist_id = users.id and "
            "call_log.employee_id = " + lookupTables->IdOf("users", cboEmployee->Text.c_str()) + " and "
            "call_log.call_time >= '" + begin_date + " 00:01:00' and "
            "call_log.call_time <= '" + end_date + " 23:59:00' "
            "order by call_time";

      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportEmployeeCallLog * employeeLogReport = new TformReportEmployeeCallLog(NULL);
        employeeLogReport->employeeLogReport->DataSet = dbDataSet;
        employeeLogReport->lblTitle->Caption = title.c_str();
        employeeLogReport->lblDateTitle->Caption = date_title.c_str();
        employeeLogReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        employeeLogReport->txtDate->DataSet = dbDataSet;
        employeeLogReport->txtDate->DataField = "call_date";
        employeeLogReport->txtTime->DataSet = dbDataSet;
        employeeLogReport->txtTime->DataField = "call_time";
        employeeLogReport->txtCaller->DataSet = dbDataSet;
        employeeLogReport->txtCaller->DataField = "caller_name";
        employeeLogReport->txtReceptionist->DataSet = dbDataSet;
        employeeLogReport->txtReceptionist->DataField = "receptionist_name";
        employeeLogReport->txtNote->DataSet = dbDataSet;
        employeeLogReport->txtNote->DataField = "note";
        Processing(false);
        employeeLogReport->employeeLogReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchEmployeeLogReport::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("users", cboEmployee);
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchEmployeeLogReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

