//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchEmployeeCallTotalsReport.h"
#include "reportEmployeeCallTotals.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchEmployeeCallTotalsReport *formLaunchEmployeeCallTotalsReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchEmployeeCallTotalsReport::TformLaunchEmployeeCallTotalsReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchEmployeeCallTotalsReport::btnRunClick(
      TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {

    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;


    sql = "select users.item employee, (select count (call_log.call_time) "
          "from call_log where call_log.employee_id = users.id and "
          "call_log.call_time >= '" + begin_date + " 00:01:00' and "
          "call_log.call_time <= '" + end_date + " 23:59:00') total_calls "
          "from users order by users.item";

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportEmployeeCallTotals * totalsReport = new TformReportEmployeeCallTotals(NULL);
      totalsReport->employeeTotalsReport->DataSet = dbDataSet;
      totalsReport->lblDateTitle->Caption = date_title.c_str();
      totalsReport->txtEmployee->DataSet = dbDataSet;
      totalsReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      totalsReport->txtEmployee->DataField = "employee";
      totalsReport->txtTotal->DataSet = dbDataSet;
      totalsReport->txtTotal->DataField = "total_calls";
      totalsReport->exprTotal->Expression = "SUM(total_calls)";
      Processing(false);
      totalsReport->employeeTotalsReport->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchEmployeeCallTotalsReport::btnCloseClick(
      TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchEmployeeCallTotalsReport::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

