//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchFitnessAttendanceReport.h"
#include "reportFitnessAttendance.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchFitnessAttendanceReport *formLaunchFitnessAttendanceReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchFitnessAttendanceReport::TformLaunchFitnessAttendanceReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  lookupTables->RegisterComboBox("fit_facility_types", cboFacility);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessAttendanceReport::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessAttendanceReport::btnRunClick(TObject *Sender)
{
  if (lookupTables->IsInLookUpTable("fit_facility_types", cboFacility->Text.c_str()))
  {
    Processing(true);
    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string person_total;
    string memberships_total;

    try
    {
      StdTransaction(dbTransaction, dbDatabase);
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      sql = "select count(fitness_memberships.id) "
            "from fitness_memberships, fit_facility_types "
            "where fitness_memberships.fit_facility_id = fit_facility_types.id and "
            "fitness_memberships.current_id >= 3 and ";
      if (cboFacility->Text != "")
        sql += "fitness_memberships.fit_facility_id = " +
               lookupTables->IdOf("fit_facility_types", cboFacility->Text.c_str()) + " and ";
      sql += "fitness_memberships.end_date is null and fitness_memberships.is_waiting = 0";
      memberships_total = GetOneField(dbTransaction, sql);

      sql = "select count(fitness_people.id) "
            "from people, fitness_memberships, fitness_people, fit_facility_types "
            "where fitness_people.person_id = people.id and "
            "fitness_people.fitness_membership_id = fitness_memberships.id and "
            "fitness_memberships.fit_facility_id = fit_facility_types.id and "
            "people.current_id >= 3 and "
            "exists (select DCE.id from enrollment DCE where DCE.person_id = people.id and DCE.current_id+1 >= 4 and "  // jhaley: changed is_diabetes_client -> enrollment
            " DCE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "') and "
            "fitness_memberships.current_id >= 3 and fitness_memberships.is_waiting = 0 and "
            "fitness_people.current_id >= 3 and ";
      if (cboFacility->Text != "")
        sql += "fitness_memberships.fit_facility_id = " +
               lookupTables->IdOf("fit_facility_types", cboFacility->Text.c_str()) + " and ";
      sql += "fitness_memberships.end_date is null ";
      person_total = GetOneField(dbTransaction, sql);

      sql =  "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix name, "
             "fit_facility_types.item facility, fitness_memberships.begin_date, fitness_attendance.date_of_attendance, "
             "fitness_people.is_primary, fitness_memberships.id, people.id person_id "
             "from people ";
      if (checkAttendanceInDateRange->Checked)
        sql += "inner join ";
      else
        sql += "left join ";
      sql += "fitness_attendance on people.id = fitness_attendance.person_id and "
             "fitness_attendance.date_of_attendance >= '" + begin_date + "' and "
             "fitness_attendance.date_of_attendance <= '" + end_date + "' "
             "left join person_names on people.person_names_id = person_names.id, fitness_people, "
             "fitness_memberships, fit_facility_types "
             "where fitness_people.person_id = people.id and "
             "fitness_people.fitness_membership_id = fitness_memberships.id and "
             "fitness_memberships.fit_facility_id = fit_facility_types.id and ";
      if (cboFacility->Text != "")
        sql += "fitness_memberships.fit_facility_id = " +
               lookupTables->IdOf("fit_facility_types", cboFacility->Text.c_str()) + " and ";
      sql += "fitness_memberships.end_date is null and "
             "fitness_memberships.current_id >= 3 and fitness_memberships.is_waiting = 0 and "
             "fitness_people.current_id >= 3 and "
             "people.current_id >= 3 "
             "order by fitness_memberships.id, fitness_people.is_primary descending, "
             "person_names.last_name, person_names.first_name, "
             "fitness_attendance.date_of_attendance";

      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportFitnessAttendance * report = new TformReportFitnessAttendance(NULL);
        if (checkAttendanceInDateRange->Checked) // += doesn't work because AnsiString is a bastard.
          report->lblTitle->Caption = report->lblTitle->Caption + " (with attendance in date range)";
        report->attendanceReport->DataSet = dbDataSet;
        report->lblDateTitle->Caption = date_title.c_str();
        report->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        report->lblTotalClients->Caption = person_total.c_str();
        report->lblTotalMemberships->Caption = memberships_total.c_str();
        report->groupBand->Expression = "id";
        report->txtFacility->DataSet = dbDataSet;
        report->txtFacility->DataField = "facility";
        report->txtSignUp->DataSet = dbDataSet;
        report->txtSignUp->DataField = "begin_date";
        report->txtName->DataSet = dbDataSet;
        report->exprPrimary->Expression = "IF(is_primary = '1', 'x', '')";
        report->txtName->DataField = "name";
        report->txtDate->DataSet = dbDataSet;
        report->txtDate->DataField = "date_of_attendance";
        Processing(false);
        report->attendanceReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;
  }
  else
    PSay("Please enter a valid facility", m_invalid_data, MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessAttendanceReport::FormClose(TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("fit_facility_types", cboFacility);
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessAttendanceReport::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

