//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchFitnessMembershipReport.h"
#include "reportFitnessMembership.h"
#include "codeSpecialExportListview.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchFitnessMembershipReport *formLaunchFitnessMembershipReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchFitnessMembershipReport::TformLaunchFitnessMembershipReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  lookupTables->RegisterComboBox("fit_facility_types", cboFacility);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessMembershipReport::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
bool TformLaunchFitnessMembershipReport::IsValidOnScreen()
{
  if(radioPrintOne->Checked)
  {
    if(! lookupTables->IsInLookUpTable("fit_facility_types", cboFacility->Text.c_str()))
      return false;
    else if(cboFacility->Text == "")
      return false;
    else
      return true;
  }
  else
    return true;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessMembershipReport::btnRunClick(TObject *Sender)
{
  if(!IsValidOnScreen())
  {
    PSay("Please enter a valid facility", m_invalid_data, MB_OK);
    cboFacility->SetFocus();
    return;
  }

  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;

  try
  {
    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    if(radioCharge->Checked)
    {
      sql = "delete from temp_fitness_report";
      ExecuteStatement(dbTransaction, sql);

      sql = "insert into temp_fitness_report (fitness_membership_id, fit_facility_id, fitness_person_id, is_primary, "
            "begin_date, person_name, birth_date, primary_name) "
            "select outer_memberships.id, outer_memberships.fit_facility_id, fitness_people.id, fitness_people.is_primary, "
            "outer_memberships.begin_date, "
            "person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix full_name, "
            "people.birth_date, "
            "(select first 1 person_names.last_name || ', ' || person_names.first_name "
            "from fitness_memberships inner_memberships "
            "inner join fitness_people on fitness_people.fitness_membership_id = inner_memberships.id and "
            "fitness_people.is_primary = 1 "
            "inner join people on fitness_people.person_id = people.id "
            "left join person_names on people.person_names_id = person_names.id "
            "where inner_memberships.id = outer_memberships.id) primary_name "
            "from fitness_memberships outer_memberships "
            "inner join fitness_people on fitness_people.fitness_membership_id = outer_memberships.id and "
            "fitness_people.current_id >= 3 "
            "inner join fit_facility_types on outer_memberships.fit_facility_id = fit_facility_types.id "
            "inner join people on fitness_people.person_id = people.id "
            "left join person_names on people.person_names_id = person_names.id "
            "left join person_contact_info on people.person_contact_info_id = person_contact_info.id "
            "where outer_memberships.current_id >= 3 and outer_memberships.is_waiting = 0 "
            "and outer_memberships.end_date is null and outer_memberships.begin_date <= '" + CurrentDate() + "'";
      if(radioPrintOne->Checked)
        sql += "and outer_memberships.fit_facility_id = " + lookupTables->IdOf("fit_facility_types", cboFacility->Text.c_str());
      ExecuteStatement(dbTransaction, sql);

      // st gregs charges
      if(((radioPrintOne->Checked) && (cboFacility->Text == "St. Gregs")) || (radioPrintAll->Checked))
      {
        Pdate today = CurrentPdate();
        Pdate fourteen_date = CurrentPdate();
        Pdate seventeen_date = CurrentPdate();
        fourteen_date.mod(-14, in_years);
        seventeen_date.mod(-18, in_years);
        seventeen_date.mod(-1, in_days);
        string facility_id = lookupTables->IdOf("fit_facility_types", "St. Gregs");
        sql = "update temp_fitness_report set charge = 13 where fit_facility_id = " + facility_id + " "
              "and is_primary = 1";
        ExecuteStatement(dbTransaction, sql);
        sql = "update temp_fitness_report set charge = 0 where fit_facility_id = " + facility_id + " "
              "and is_primary != 1 and birth_date > '" + fourteen_date.OutDate(mdy | yyyy) +"'";
        ExecuteStatement(dbTransaction, sql);
        sql = "update temp_fitness_report set charge = 8 where fit_facility_id = " + facility_id + " "
              "and is_primary != 1 and birth_date >= '" + seventeen_date.OutDate(mdy | yyyy) +"' "
              "and birth_date <= '" + fourteen_date.OutDate(mdy | yyyy) + "'";
        ExecuteStatement(dbTransaction, sql);
        sql = "update temp_fitness_report set charge = 13.5 where fit_facility_id = " + facility_id + " "
              " and charge is null";
        ExecuteStatement(dbTransaction, sql);
      }
      if(((radioPrintOne->Checked) && (cboFacility->Text == "The Health Club")) || (radioPrintAll->Checked))
      {
        string facility_id = lookupTables->IdOf("fit_facility_types", "The Health Club");
        sql = "update temp_fitness_report outer_table set charge = 35 where (select count(*) from temp_fitness_report inner_table "
              "where outer_table.fitness_membership_id = inner_table.fitness_membership_id) = 1 and outer_table.is_primary = 1 and fit_facility_id = " + facility_id + " ";
        ExecuteStatement(dbTransaction, sql);
        sql = "update temp_fitness_report outer_table set charge = 45 where (select count(*) from temp_fitness_report inner_table "
              "where outer_table.fitness_membership_id = inner_table.fitness_membership_id) = 2 and outer_table.is_primary = 1 and fit_facility_id = " + facility_id + " ";
        ExecuteStatement(dbTransaction, sql);
        sql = "update temp_fitness_report outer_table set charge = 55 where (select count(*) from temp_fitness_report inner_table "
              "where outer_table.fitness_membership_id = inner_table.fitness_membership_id) > 2 and outer_table.is_primary = 1 and fit_facility_id = " + facility_id + " ";
        ExecuteStatement(dbTransaction, sql);
      }
      // put other charges here

      sql = "select fit_facility_types.item facility, temp_fitness_report.person_name, "
            "temp_fitness_report.birth_date, temp_fitness_report.begin_date, "
            "temp_fitness_report.is_primary, temp_fitness_report.charge, temp_fitness_report.fitness_membership_id, "
            "temp_fitness_report.primary_name "
            "from temp_fitness_report "
            "inner join fit_facility_types on temp_fitness_report.fit_facility_id = fit_facility_types.id "
            "order by fit_facility_types.item, temp_fitness_report.primary_name, temp_fitness_report.fitness_membership_id, "
            "temp_fitness_report.is_primary descending, temp_fitness_report.birth_date ascending";
    }
    else
    {
      sql = "select fit_facility_types.item facility, "
            "person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix person_name, "
            "people.birth_date, outer_memberships.begin_date, "
            "fitness_people.is_primary, person_contact_info.phone_number, outer_memberships.id fitness_membership_id, "
            "(select person_names.last_name || ', ' || person_names.first_name "
            "from fitness_memberships inner_memberships "
            "inner join fitness_people on fitness_people.fitness_membership_id = inner_memberships.id and "
            "fitness_people.is_primary = 1 "
            "inner join people on fitness_people.person_id = people.id "
            "left join person_names on people.person_names_id = person_names.id "
            "where inner_memberships.id = outer_memberships.id) primary_name "
            "from fitness_memberships outer_memberships "
            "inner join fitness_people on fitness_people.fitness_membership_id = outer_memberships.id and "
            "fitness_people.current_id >= 3 "
            "inner join fit_facility_types on outer_memberships.fit_facility_id = fit_facility_types.id "
            "inner join people on fitness_people.person_id = people.id "
            "left join person_names on people.person_names_id = person_names.id "
            "left join person_contact_info on people.person_contact_info_id = person_contact_info.id "
            "where outer_memberships.current_id >= 3 and outer_memberships.is_waiting = 0 "
            "and outer_memberships.end_date is null and outer_memberships.begin_date <= '" + CurrentDate() + "'";
      if(radioPrintOne->Checked)
        sql += "and outer_memberships.fit_facility_id = " + lookupTables->IdOf("fit_facility_types", cboFacility->Text.c_str()) + " ";
      sql += "order by fit_facility_types.item, 8, outer_memberships.id, fitness_people.is_primary descending, "
             "people.birth_date ascending";
    }
    dbDataSet->SelectSQL->Add(sql.c_str());

    if(checkPrint->Checked)
    {
      dbDataSet->Open();
      dbDataSet->First();
      FORM_TRY
        TformReportFitnessMembership * report = new TformReportFitnessMembership(NULL, radioCharge->Checked);
        report->membershipReport->DataSet = dbDataSet;
        if(radioPrintAll->Checked)
          report->lblTitle->Caption = string("Active Fitness Memberships - " + CurrentDate()).c_str();
        else
          report->lblTitle->Caption = string("Active Fitness Memberships at " + string(cboFacility->Text.c_str()) + " - " + CurrentDate()).c_str();
        report->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        report->groupBand->Expression = "fitness_membership_id";
        report->txtFacility->DataSet = dbDataSet;
        report->txtFacility->DataField = "facility";
        report->txtName->DataSet = dbDataSet;
        report->txtName->DataField = "person_name";
        report->txtBirthday->DataSet = dbDataSet;
        report->txtBirthday->DataField = "birth_date";
        report->txtJoinDate->DataSet = dbDataSet;
        report->txtJoinDate->DataField = "begin_date";
        report->exprPrimary->Expression = "IF(is_primary = 1, 'Yes', ' ')";
        if(radioCharge->Checked)
        {
          report->txtCharge->DataSet = dbDataSet;
          report->txtCharge->DataField = "charge";
          report->exprTotalCharge->Expression = "FORMATNUMERIC('$##,##0.00', SUM(charge))";
        }
        else
        {
          report->lblCharge->Caption = "Phone Number";
          report->txtCharge->DataSet = dbDataSet;
          report->txtCharge->DataField = "phone_number";
          report->lblTotalCharge->Caption = "";
          report->exprTotalCharge->Expression = "";
          report->lblTotalPrimaryLabel->Caption = "";
          report->lblTotalPrimary->Caption = "";
          report->lblTotalFamilyLabel->Caption = "";
          report->lblTotalFamily->Caption = "";
          report->lblTotalChildrenLabel->Caption = "";
          report->lblTotalChildren->Caption = "";
          report->lblTotalFreeLabel->Caption = "";
          report->lblTotalFree->Caption = "";
        }
        Processing(false);
        report->membershipReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
    }
    if(checkExport->Checked)
    {
      classFilterObject temp_filter;
      temp_filter.SetListViewHandle(listDummy); // jhaley 20101007: filters seem to require a listview object; otherwise, expect crashes.
      temp_filter.SetTransaction(dbTransaction);
      temp_filter.SetSecurity("fitness_memberships");
      temp_filter.AddColumnSpec("Facility", "fitness_memberships", as_text, true, 100);
      temp_filter.AddColumnSpec("Name", "fitness_memberships", as_text, true, 100);
      temp_filter.AddColumnSpec("Birthday", "fitness_memberships", as_date, true, 100);
      temp_filter.AddColumnSpec("Join Date", "fitness_memberships", as_date, true, 100);
      temp_filter.AddColumnSpec("Primary", "fitness_memberships", as_text, true, 100, prettyBoolString);
      if(radioPhone->Checked)
        temp_filter.AddColumnSpec("Phone Number", "fitness_memberships", as_text, true, 100, prettyPhoneString);
      else
        temp_filter.AddColumnSpec("Total Charge", "fitness_memberships", as_double, true, 100, dollarString);
      temp_filter.AddColumnSpec("Internal Id", "internal_id", as_int, false, 100);
      temp_filter.SetSQLStatement(sql);
      temp_filter.ForceRefreshDataSet();
      Processing(false);      
      FORM_TRY
        TformSpecialExportListview *export_form = new TformSpecialExportListview(NULL, &temp_filter);
        export_form->ShowModal(); // jhaley: This will have to be modal, not task modal, or else we can't delete from the temp table safely
      FORM_CATCH
    }

    if (radioCharge->Checked)
      ExecuteStatement(dbTransaction, "delete from temp_fitness_report");
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessMembershipReport::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessMembershipReport::FormClose(TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("fit_facility_types", cboFacility);
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessMembershipReport::radioPrintAllClick(TObject *Sender)
{
  if(radioPrintAll->Checked)
    cboFacility->Enabled = false;
  else
    cboFacility->Enabled = true;
}
//---------------------------------------------------------------------------

