//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchFitnessReleaseReport.h"
#include "reportFitnessRelease.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchFitnessReleaseReport *formLaunchFitnessReleaseReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchFitnessReleaseReport::TformLaunchFitnessReleaseReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessReleaseReport::radioDoctorClick(
      TObject *Sender)
{
  radioClient->Checked = false;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessReleaseReport::radioClientClick(
      TObject *Sender)
{
  radioDoctor->Checked = false;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessReleaseReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessReleaseReport::btnRunClick(
      TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string date_title = CurrentDate();

  try
  {
    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;


    sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix name, "
          "fit_facility_types.item facility, fitness_memberships.begin_date, "
          "fitness_people.doctor_name, fitness_people.sent_letter "
          "from people, person_names, fitness_memberships, fitness_people, fit_facility_types "
          "where fitness_memberships.fit_facility_id = fit_facility_types.id and "
          "fitness_people.fitness_membership_id = fitness_memberships.id and "
          "fitness_people.person_id = people.id and "
          "person_names.id = people.person_names_id and "
          "fitness_people.needs_release = 1 and "
          "fitness_people.current_id >= 3 and "
          "fitness_memberships.current_id >= 3 and "
          "people.current_id >= 3 and "
          "exists (select DCE.id from enrollment DCE where DCE.person_id = people.id and DCE.current_id+1 >= 4 and " // jhaley: changed is_diabetes_client -> enrollment
          " DCE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "') and "
          "fitness_memberships.end_date is null ";

    if (radioDoctor->Checked)
      sql += "order by fitness_people.doctor_name";
    else
      sql += "order by person_names.last_name, person_names.first_name";

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportFitnessRelease * releaseReport = new TformReportFitnessRelease(NULL);
      releaseReport->releaseReport->DataSet = dbDataSet;
      releaseReport->lblDateTitle->Caption = date_title.c_str();
      releaseReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      releaseReport->txtName->DataSet = dbDataSet;
      releaseReport->txtName->DataField = "name";
      releaseReport->txtFacility->DataSet = dbDataSet;
      releaseReport->txtFacility->DataField = "facility";
      releaseReport->txtDate->DataSet = dbDataSet;
      releaseReport->txtDate->DataField = "begin_date";
      releaseReport->txtDoctor->DataSet = dbDataSet;
      releaseReport->txtDoctor->DataField = "doctor_name";
      releaseReport->exprLetter->Expression = "IF(sent_letter = 1, 'Yes', 'No')";
      Processing(false);
      releaseReport->releaseReport->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessReleaseReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

