//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchFitnessWaitingListReport.h"
#include "reportFitnessWaitingList.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchFitnessWaitingListReport *formLaunchFitnessWaitingListReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchFitnessWaitingListReport::TformLaunchFitnessWaitingListReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  lookupTables->RegisterComboBox("fit_facility_types", cboFacility);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessWaitingListReport::btnRunClick(TObject *Sender)
{
  if ((lookupTables->IsInLookUpTable("fit_facility_types", cboFacility->Text.c_str()))
       && (cboFacility->Text != ""))
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string total;

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;
      dbTransaction->StartTransaction();

      sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix name, "
            "       fit_facility_types.item facility, affiliations.cdib cdib, person_contact_info.phone_number phone_number, "
            "       fitness_memberships.waiting_list_date add_date, fitness_memberships.comments comments "
            "from people left join person_names on person_names.id = people.person_names_id "
            "     left join person_contact_info on people.person_contact_info_id = person_contact_info.id "
            "     left join affiliations on people.affiliations_id = affiliations.id, "
            "     fitness_memberships, fitness_people, fit_facility_types "
            "where fitness_people.person_id = people.id and "
            "      fitness_people.fitness_membership_id = fitness_memberships.id and "
            "      fitness_memberships.fit_facility_id = fit_facility_types.id and "
            "      fitness_people.is_primary = 1 and "
            "      people.current_id >= 3 and "
            //"      people.is_diabetes_client = 1 and "
            "      exists (select DCE.id from enrollment DCE where DCE.person_id = people.id and DCE.current_id+1 >= 4 and "
            "        DCE.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "Diabetes Client") + "') and "
            "      fitness_memberships.current_id >= 3 and fitness_memberships.is_waiting = 1 and "
            "      fitness_people.current_id >= 3 and ";
      sql += "fitness_memberships.fit_facility_id = " +
               lookupTables->IdOf("fit_facility_types", cboFacility->Text.c_str());
      sql += "order by waiting_list_date, fitness_memberships.last_update_stamp";

      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportFitnessWaitingList * report = new TformReportFitnessWaitingList(NULL);
        report->reportWaitingList->DataSet = dbDataSet;
        report->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        report->txtFacility->DataSet = dbDataSet;
        report->txtFacility->DataField = "facility";
        report->txtName->DataSet = dbDataSet;
        report->txtName->DataField = "name";
        report->txtListAddDate->DataSet = dbDataSet;
        report->txtListAddDate->DataField = "add_date";
        report->txtPhoneNumber->DataField = "phone_number";
        report->txtPhoneNumber->DataSet = dbDataSet;
        report->txtCDIB->DataSet = dbDataSet;
        report->txtCDIB->DataField = "cdib";
        report->txtComments->DataSet = dbDataSet;
        report->txtComments->DataField = "comments";
        Processing(false);
        report->reportWaitingList->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;
  }
  else
    PSay("Please enter a valid facility", m_invalid_data, MB_OK);

}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessWaitingListReport::btnCloseClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchFitnessWaitingListReport::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

