//---------------------------------------------------------------------------

#ifndef launchGenericH
#define launchGenericH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
//---------------------------------------------------------------------------
enum run_status_types {lg_not_running, lg_running, lg_run_failure, lg_run_success};

class TformLaunchGeneric : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *btnRunReport;
        TToolButton *btnSave;
        TToolButton *sepGeneric1;
        TToolButton *btnLoad;
        TToolButton *sepGeneric2;
        TToolButton *btnCloseScreen;
        void __fastcall btnRunReportClick(TObject *Sender);
        void __fastcall btnSaveClick(TObject *Sender);
        void __fastcall btnLoadClick(TObject *Sender);
        void __fastcall btnCloseScreenClick(TObject *Sender);
        void __fastcall FormShortCut(TWMKey &Msg, bool &Handled);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
        // checkpoint branch is the prefix (if available) and checkpoint the suffix.  So if your
        // report has mulitple lines of logic, you could effectively have it say errors occurred
        // at A-1, A-2, Cleanup-1, etc.; rather than just a number, which could be reached multiple ways
        // (thus being rather meaningless for users to tell you it got to checkpoint 22).
        AnsiString Fcheckpoint_branch;
        int Fcheckpoint;
        void FreeDataSets();
protected:
        void __fastcall SetCheckpointBranch(AnsiString Value);
        void __fastcall SetCheckpoint(int Value);
        bool virtual IsValidOnScreen();
        bool virtual BeforeRunReport();
        bool virtual RunReport();
        bool virtual AfterRunReport();
        bool virtual SaveReportCriteria();
        bool virtual LoadReportCriteria();
        bool virtual CloseReport();        // jhaley: Do *not* override this to do resource release!
        bool virtual DoCleanup();
        void Cleanup();
        TIBDataSet *AddDataSet();
        void InitDataSet(TIBDataSet *dataSet, const string &sql);
        void SetupQRDBText(TControl *txtControl, TIBDataSet *dataSet, const string &name);
        TIBTransaction *report_transaction;
        vector<TIBDataSet *> data_sets; // jhaley: managed datasets
        run_status_types run_status;
        // rather than displaying errors as they occur in the descended form, then displaying a generic
        // error at the end, you can simply build "detailed" information you would have displayed during
        // report generation, stick it in this string, and it'll be appended to the generic error that
        // launch generic throws.  Cleanup will also display any information you add during the cleanup
        // process, otherwise it'll PPretendToSay instead (silent message, only DB logged).  This way
        // the user won't be confronted with cascading errors, yeah?
        string extra_error_info;
        TDateTime report_start_time;
        TDateTime report_stop_time;
public:		// User declarations
        __fastcall TformLaunchGeneric(TComponent* Owner);
__published:
        __property AnsiString checkpoint_branch = {read=Fcheckpoint_branch, write=SetCheckpointBranch};
        __property int        checkpoint        = {read=Fcheckpoint, write=SetCheckpoint};
};
//---------------------------------------------------------------------------
extern PACKAGE TformLaunchGeneric *formLaunchGeneric;
//---------------------------------------------------------------------------
#endif
