//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchIHSReport.h"
#include "codeRecordPerson.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchIHSReport *formLaunchIHSReport;

// if you're going to move stuff around, resize the form to its minimum sizes first!

// jhaley: enumeration to represent indices into fk_table_lookup, for symbolic access
enum
{
  fk_lookup_table_name,
  fk_lookup_foreign_key,
  fk_lookup_node_name,
  fk_array_stride       // multiplier representing the number of fields in the array.
};

// jhaley: enumeration to match below array:
// If thou addeth unto one, thou shalt add equally unto the other.
// If thou taketh away from one, thou shalt take away equally from the other.
// (In all seriousness, this eliminates the problem of magic numbers being used to bounds-check the array).
enum
{
  fk_classification_types,
  fk_direction_types,
  fk_groups,
  fk_visit_location_types,
  fk_method_types,
  fk_visit_outcome_types,
  fk_beh_activity_types,
  fk_beh_appt_types,
  fk_beh_meeting_types,
  fk_beh_service_types,
  fk_beh_visit_types,
  fk_diab_activity_types,
  fk_diab_contact_types,
  fk_diab_meeting_types,
  fk_task_purpose_types,
  fk_program_types,
  fk_com_activity_types,
  fk_com_meeting_types,
  fk_com_visit_types,
  fk_care_classification_types,
  fk_care_meeting_types,
  fk_numforeignkeys
};

// i swear the number came out on its own ... =)
// haha I ruined it!  --Paul
//  - and I got rid of it entirely to eliminate use of magic numbers ;) --James
const char *fk_table_lookup [fk_array_stride * fk_numforeignkeys] =
{
// "table_name"                , "people.foreign_key"     , "name in tree view",
// General
   "classification_types"      , "classification_id"      , "Classification",
   "direction_types"           , "direction_id"           , "Direction",
   "groups"                    , "group_id"               , "Group",
   "visit_location_types"      , "visit_location_id"      , "Location",
   "method_types"              , "method_id"              , "Method",
   "visit_outcome_types"       , "visit_outcome_id"       , "Outcome", // no longer used, removed from tree view
// Behavioral
   "beh_activity_types"        , "beh_activity_id"        , "Activity",
   "beh_appt_types"            , "beh_appt_id"            , "Appointment",
   "beh_meeting_types"         , "beh_meeting_id"         , "Meeting",
   "beh_service_types"         , "beh_service_id"         , "Service",
   "beh_visit_types"           , "beh_visit_id"           , "Visit",
// Diabetes
   "diab_activity_types"       , "diab_activity_id"       , "Activity",
   "diab_contact_types"        , "diab_contact_types"     , "Contact",
   "diab_meeting_types"        , "diab_meeting_id"        , "Meeting",
   "task_purpose_types"        , "task_purpose_id"        , "Task",
   "program_types"             , "program_id"             , "Program",
// Community / Public
   "com_activity_types"        , "com_activity_id"        , "Activity",
   "com_meeting_types"         , "com_meeting_id"         , "Meeting",
   "com_visit_types"           , "com_visit_id"           , "Visit",
// Caregiver
   "care_classification_types" , "care_classification_id" , "Classification",
   "care_meeting_types"        , "care_meeting_id"        , "Meeting",
};

//---------------------------------------------------------------------------
__fastcall TformLaunchIHSReport::TformLaunchIHSReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
 pageIHS->ActivePageIndex = 0;
 pageOptions->ActivePageIndex = 0;

 filter_field_values.SetListViewHandle(listFieldValues);
 filter_field_values.SetSecurity("tasks");
 filter_field_values.AddColumnSpec("Id", "internal_id", as_int, false, 25);
 filter_field_values.AddColumnSpec("Value", "tasks", as_text, true, 175);
 filter_field_values.SetIconStatus(false);
 filter_field_values.SetHeader(false);
 filter_field_values.SetCheck(true);
 filter_field_values.SetCompress(true);
 filter_field_values.SetCheck(this, CheckRecord(&(TformLaunchIHSReport::AskCheckFieldValue)));
 filter_field_values.FetchPreferences("launch_ihs_report.field_values");
 filter_field_values.SetSQLStatement("");
 filter_field_values.RefreshDataSet();

 groupRuleOptions->Enabled = false;

 filter_screen_report.SetListViewHandle(listReport);
 filter_screen_report.SetSecurity("people");
 filter_screen_report.AddColumnSpec("Id", "internal_id", as_int, false, 25);
 filter_screen_report.AddColumnSpec("Current Id", "current_id", as_int, false, 25);
 filter_screen_report.AddColumnSpec("First name", "person_names", as_text, true, 100);
 filter_screen_report.AddColumnSpec("Middle name", "person_names", as_text, true, 50);
 filter_screen_report.AddColumnSpec("Last name", "person_names", as_text, true, 100);
 filter_screen_report.AddColumnSpec("Gender", "people", as_text, true, 50);
 filter_screen_report.AddColumnSpec("Birth date", "people", as_date, true, 75);
 filter_screen_report.AddColumnSpec("Death date", "people", as_date, true, 75);
 filter_screen_report.AddColumnSpec("Social Security #", "people", as_text, true, 75);
 filter_screen_report.AddColumnSpec("CDIB #", "affiliations", as_text, true, 75);
 filter_screen_report.AddColumnSpec("Tribal Affiliation", "affiliations", as_text, true, 150);
 filter_screen_report.AddColumnSpec("Join date", "affiliations", as_text, true, 75);
 filter_screen_report.AddColumnSpec("Leave date", "affiliations", as_text, true, 75);
 filter_screen_report.AddColumnSpec("Address (1)", "person_contact_info", as_text, true, 100, addressString);
 filter_screen_report.AddColumnSpec("Address (2)", "person_contact_info", as_text, true, 100, addressString);
 filter_screen_report.AddColumnSpec("City", "person_contact_info", as_text, true, 75);
 filter_screen_report.AddColumnSpec("State", "person_contact_info", as_text, true, 75, uppercaseString);
 filter_screen_report.AddColumnSpec("Zip", "person_contact_info", as_int, true, 75, prettyZipString);
 filter_screen_report.AddColumnSpec("Country", "person_contact_info", as_text, true, 100);
 filter_screen_report.AddColumnSpec("Last visit", "tasks", as_date, true, 75);
 filter_screen_report.AddColumnSpec("Visit count", "tasks", as_int, true, 50);
 filter_screen_report.SetIconStatus(true);
 filter_screen_report.SetHeader(true);
 filter_screen_report.FetchPreferences("launch_ihs_report.screen_report");
 filter_screen_report.SetAddEdit(this, NULL, EditRecord(&(TformLaunchIHSReport::EditPerson)));
 filter_screen_report.SetInform (this, InformForm(&(TformLaunchIHSReport::RefreshSummary)));
 filter_screen_report.SetSQLStatement("");
 filter_screen_report.RefreshDataSet();

 filter_rule_report.SetListViewHandle(listRuleReport);
 filter_rule_report.SetSecurity("tasks");
 filter_rule_report.AddColumnSpec("Rule", "tasks", as_text, true, 100);
 filter_rule_report.AddColumnSpec("People", "tasks", as_text, true, 50);
 filter_rule_report.AddColumnSpec("Contacts", "tasks", as_text, true, 50);
 filter_rule_report.SetIconStatus(false);
 filter_rule_report.SetHeader(true);
 filter_rule_report.SetCompress(true);
 filter_rule_report.FetchPreferences("launch_ihs_report.rule_report");
 filter_rule_report.SetSQLStatement("");
 filter_rule_report.RefreshDataSet();

 is_saving_because_checked = false;
 is_closing = false;
 dbPrepReport = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchIHSReport::buttonShowOptionsClick(TObject *Sender)
{
 // go back to options page
 filter_screen_report.SetSQLStatement("");
 filter_screen_report.RefreshDataSet();
 buttonPrepareReport->Enabled = true;
 buttonShowOptions->Enabled = false;
 pageIHS->ActivePageIndex = 0;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchIHSReport::buttonNewRuleClick(TObject *Sender)
{
 // add new rule
 int i = 1;
 bool done = false;
 string attempt_name;

 while (!done)
 {
  attempt_name = "unnamed task rule " + IntToString(i);
  if (current_task_rules.find(attempt_name) == current_task_rules.end())
  {
   done = true;
   task_rule blank_rule;
   current_task_rules.insert(pair<string, task_rule>(attempt_name,blank_rule));
  } else
  {
   i++;
  }
 }

 UpdateRuleList();
 TListItem * bob = listRules->FindCaption(0, attempt_name.c_str(), false, true, false);
 if (bob)
  bob->Selected = true;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchIHSReport::buttonDeleteRuleClick(TObject *Sender)
{
 // delete selected rule
 if (listRules->Selected)
 {
  current_task_rules.erase(listRules->Selected->Caption.c_str());
  listRules->Selected->Delete();
 }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchIHSReport::buttonImportRulesClick(TObject *Sender)
{
 // import rules from disk

 // give them a chance to abort if they don't mean to do this
 if (!current_task_rules.empty())
 {
  if (IDOK != PSay("You already have some rules loaded.\n"
                   "By continuing, your current rule set will be lost (unless you have saved it to disk)\n"
                   "and will be replaced by the rules you import.\nDo you want to continue?",
                   m_confirmation, MB_OKCANCEL))
   return;
 }

 /*
 [rule name 1]
 table_number_1=id,id,id,...
 table_number_2=id,id,id,...
 ...
 [rule name 2]
 ...
 */

 if (dialogImportOptions->Execute())
 {
  map<string, map<string, string> > rule_options;
  string filename = dialogImportOptions->FileName.c_str();
  if (FileExists(filename.c_str()))
  {
   if (LoadOptionsFromFile(filename, rule_options))
   {
    task_rule_set     new_task_rules;
    task_rule         new_task_rule;
    set<string>       new_condition;
    int               new_condition_table;
    string            new_condition_table_name;

    for (map<string, map<string, string> >::iterator i_rule = rule_options.begin(); i_rule != rule_options.end(); i_rule++)
    {
     new_task_rule.clear();
     for (map<string, string>::iterator i_condition = i_rule->second.begin(); i_condition != i_rule->second.end(); i_condition++)
     {
      if (IsInt(i_condition->first))
      {
       new_condition_table = StringToInt(i_condition->first);
       if (new_condition_table >= 0 && new_condition_table < fk_numforeignkeys) // jhaley 20110707: Corrected to use
       {                                                                        // proper bound via enumeration!
        new_condition_table_name = GetTableName(new_condition_table);

        new_condition.clear();
        SplitStringToSet(i_condition->second, ", ", new_condition);
        for (set<string>::iterator i_id = new_condition.begin(); i_id != new_condition.end(); i_id++)
        {
         if (IsInt(*i_id))
         {
          if (!lookupTables->IsValidId(new_condition_table_name, *i_id))
          {
           PSay("The options file contains an invalid condition: value selected that does not exist in the specified lookup table.\nNo changes have been made to your current rule set.", m_invalid_data, MB_OK);
           return;
          }
         }
         else
         {
          PSay("The options file contains an invalid condition: non-integer value identifier.\nNo changes have been made to your current rule set.", m_invalid_data, MB_OK);
          return;
         }
        }

        if (!new_condition.empty())
         new_task_rule[new_condition_table] = new_condition;
       }
       else
       {
        PSay("The options file contains an invalid condition: specified lookup table does not exist.\nNo changes have been made to your current rule set.", m_invalid_data, MB_OK);
        return;
       }
      }
      else
      {
       PSay("The options file contains an invalid condition: non-integer table identifier.\nNo changes have been made to your current rule set.", m_invalid_data, MB_OK);
       return;
      }
     }
     if (!new_task_rule.empty())
      new_task_rules[i_rule->first] = new_task_rule;
    }

    current_task_rules = new_task_rules;
    UpdateRuleList();
   }
   else
   {
    PSay("Something went wrong while importing from file.\nNo changes have been made to your current rule set.", m_warning, MB_OK);
    return;
   }
  }
  else
  {
   PSay("The file specified does not exist.\nNo changes have been made to your current rule set.", m_warning, MB_OK);
   return;
  }
 }
 else
 {
  // PSay("No file was selected, or you chose not to proceed with importing.\nNo changes have been made to your current rule set.", m_message, MB_OK);
  // return;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchIHSReport::buttonExportRulesClick(TObject *Sender)
{
 // export rules to disk
 if (current_task_rules.empty())
 {
  if (IDOK != PSay("You have not created any rules yet. The exported options file will be blank. Do you wan to continue with the export?", m_confirmation, MB_OKCANCEL))
   return;
 }

 if (dialogExportOptions->Execute())
 {
  string filename;
  map<string, map<string, string> > save_options;
  map<string, string> save_rule;

  filename = dialogExportOptions->FileName.c_str();

  for (task_rule_set::iterator i_rule = current_task_rules.begin(); i_rule != current_task_rules.end(); i_rule++)
  {
   save_rule.clear();
   for (task_rule::iterator i_condition = i_rule->second.begin(); i_condition != i_rule->second.end(); i_condition++)
   {
    if (!i_condition->second.empty())
    {
     save_rule[IntToString(i_condition->first)] = SetToCommaString(i_condition->second);
    }
   }
   if (!save_rule.empty())
    save_options[i_rule->first] = save_rule;
  }

  if (!SaveOptionsToFile(filename, save_options))
  {
   PSay("Something went wrong while trying to save your rules to disk.\nYour rules have not been saved.", m_warning, MB_OK);
   return;
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchIHSReport::listRulesSelectItem(TObject *Sender,
      TListItem *Item, bool Selected)
{
 // eep, abort!
 if (is_closing)
  return;

 // go to selected rule, forget changes to currently selected rule, if any
 if (listRules->Selected)
 {
  current_rule_name = listRules->Selected->Caption.c_str();
  groupRuleOptions->Enabled = true;
  current_task_rule = current_task_rules[current_rule_name];
  UpdateRuleView();
 } else
 {
  task_rule empty_rule;
  current_task_rule = empty_rule;
  current_rule_name = "";
  UpdateRuleView();
  if (treeFields->Selected)
   treeFields->Selected->Selected = false;
  groupRuleOptions->Enabled = false;
 }
}
//---------------------------------------------------------------------------
bool TformLaunchIHSReport::PrepareIhsTemp (TIBTransaction * dbTransaction, date_range report_period, bool use_task, bool use_rx, task_rule_set & task_rules)
{
 // temp_ihs_report_1: (grouped by person and by data source)
 // person_id, latest_date, contact_count, data_source
 // temp_ihs_report_2: (grouped and summarized again)
 // person_id, latest_date, contact_count

 // delete the contents of the temp table being used
 if (!ExecuteStatement(dbTransaction, "delete from temp_ihs_report_1"))
 {
  PSay("Existing contents of temp_ihs_report_1 could not be removed prior to insertion of new data.", m_database_error, MB_OK);
  return false;
 }

 // insert latest pharmacy contacts within range
 if (use_rx)
 {
  string sql =
    "insert into temp_ihs_report_1 (person_id, latest_date, contact_count, data_source) "
    "select pharmacy_info.person_id, max(pharmacy_info.dispense_date), count(distinct pharmacy_info.dispense_date), "
    "'remote pharmacies' "
    "from pharmacy_info "
    "where pharmacy_info.dispense_date between '"
    + report_period.From().OutDate(global_mode) + "' and '" + report_period.Until().OutDate(global_mode) +
    "' and pharmacy_info.person_id > 0 "
    "group by pharmacy_info.person_id, pharmacy_info.pharmacy_location_id";

  if (!ExecuteStatement (dbTransaction, sql))
  {
   PSay("Failed to insert temporary contact data based on remote pharmacy data.", m_database_error, MB_OK);
   return false;
  }
 }

 // insert latest task contacts within range, per department
 if (use_task)
 {
  for (task_rule_set::iterator i_rule = task_rules.begin(); i_rule != task_rules.end(); i_rule++)
  {
   string sql =
     "insert into temp_ihs_report_1 (person_id, latest_date, contact_count, data_source) "
     "select tasks.person_id, max(tasks.date_of_task), count(*), 'tasks: " + i_rule->first + "' "
     "from tasks "
     "where tasks.date_of_task between '"
     + report_period.From().OutDate(global_mode) + "' and '" + report_period.Until().OutDate(global_mode) +
     "' and tasks.person_id != 0 and tasks.current_id > 2 and tasks.services_provided_id = 0 and tasks.person_id > 0 ";

   for (task_rule::iterator i_condition = i_rule->second.begin(); i_condition != i_rule->second.end(); i_condition++)
   {
    // just in case an empty one makes it to here -- they always have values. should be fk. thus, empty set would mean
    // it has to be null, thus never true.
    if (!i_condition->second.empty())
    {
     sql += " and " + GetFkName(i_condition->first) + " in (" + SetToCommaString(i_condition->second) + ") ";
    }
   }
   sql += " group by tasks.person_id";
   if (!ExecuteStatement (dbTransaction, sql))
   {
    PSay(("Failed to insert temporary contact data based on visit and task rule named '" + i_rule->first + "'."),
         m_database_error, MB_OK);
    return false;
   }
  }
 }

 // we'll then join stuff back together, again taking total and latest of selected assortment, joining to people and
 // addresses and tribe stuff

 // delete the contents of the temp table being used
 if (!ExecuteStatement(dbTransaction, "delete from temp_ihs_report_2"))
 {
  PSay("Existing contents of temp_ihs_report_2 could not be removed prior to insertion of new data.",
       m_database_error, MB_OK);
  return false;
 }

 // insert latest pharmacy contacts within range
 if (use_rx)
 {
  string sql =
    "insert into temp_ihs_report_2 "
    "select temp_ihs_report_1.person_id, max(temp_ihs_report_1.latest_date), sum(temp_ihs_report_1.contact_count) "
    "from temp_ihs_report_1 "
    "group by temp_ihs_report_1.person_id";

  if (!ExecuteStatement (dbTransaction, sql))
  {
   PSay("Failed to insert temporary summarized contact data based on first phase of the report.", m_database_error, MB_OK);
   return false;
  }
 }

 return true;
}
//---------------------------------------------------------------------------
string TformLaunchIHSReport::GetTableName (int i)
{
  if (i >= 0 && i < fk_numforeignkeys) // jhaley 20110707: Use enumeration, not magic numbers
  {
    return fk_table_lookup[fk_array_stride * i + fk_lookup_table_name]; // jhaley 20110707: Use symbolic identifiers
  }
  else
    return string("unknown" + IntToString(i)+ "table");
}
//---------------------------------------------------------------------------
string TformLaunchIHSReport::GetFkName (int i)
{
  if (i >= 0 && i < fk_numforeignkeys)
  {
    return fk_table_lookup[fk_array_stride * i + fk_lookup_foreign_key];
  }
  else
    return string("unknown" + IntToString(i)+ "fk");
}
//---------------------------------------------------------------------------
string TformLaunchIHSReport::GetNodeName (int i)
{
  if (i >= 0 && i < fk_numforeignkeys)
  {
    return fk_table_lookup[fk_array_stride * i + fk_lookup_node_name];
  }
  else
    return string("unknown" + IntToString(i)+ "node");
}
//---------------------------------------------------------------------------
void TformLaunchIHSReport::UpdateRuleView()
{
 // eep, abort!
 if (is_closing)
  return;

 updating_rule_view = true;
 if (listRules->Selected)
  editRuleName->Text = current_rule_name.c_str();

 UpdateFieldTree();
 if (!is_saving_because_checked)
  treeFieldsChange(NULL, treeFields->Selected);

 is_saving_because_checked = false;
 updating_rule_view = false;
 return;
}
//---------------------------------------------------------------------------
void TformLaunchIHSReport::UpdateRuleList()
{
 // eep, abort!
 if (is_closing)
  return;

 string current_selection_caption = "";
 if (listRules->Selected)
 {
  current_selection_caption = listRules->Selected->Caption.c_str();
  listRules->Selected->Selected = false;
 }

 listRules->Items->Clear();
 for (task_rule_set::iterator i_rule = current_task_rules.begin(); i_rule != current_task_rules.end(); i_rule++)
 {
  TListItem * bob = listRules->Items->Add();
  bob->Caption = i_rule->first.c_str();
 }

 if (!current_selection_caption.empty())
 {
  TListItem * bob = listRules->FindCaption(0, current_selection_caption.c_str(), false, true, false);
  if (bob)
   bob->Selected = true;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchIHSReport::treeFieldsChange(TObject *Sender, TTreeNode *Node)
{
 // eep, abort!
 if (is_closing)
  return;

 // just updated the listview on the right with the right stuff
 if (Node)
 {
  int current_field = Node->StateIndex;
  if (current_field > -1)
  {
   string table_name = GetTableName(current_field);
   id_to_be_checked = current_task_rule[current_field];
   filter_field_values.SetSQLStatement("select id, item from " + table_name + " where valid = 1");
   filter_field_values.RefreshDataSet();
  }
  else
  {
   // make a blank listview
   filter_field_values.SetSQLStatement("");
   filter_field_values.RefreshDataSet();
  }
 }
 else
 {
  // make a blank listview
  filter_field_values.SetSQLStatement("");
  filter_field_values.RefreshDataSet();
 }
}
//---------------------------------------------------------------------------
bool TformLaunchIHSReport::AskCheckFieldValue(map<string, string> & row_data)
{
 if (id_to_be_checked.find(row_data["Id"]) != id_to_be_checked.end())
  return true;
 else
  return false;
}
//---------------------------------------------------------------------------
void TformLaunchIHSReport::SaveFieldValues()
{
 // eep, abort!
 if (is_closing)
  return;

 if (!updating_rule_view)
 {
  if (treeFields->Selected)
  {
   int current_field = treeFields->Selected->StateIndex;
   if (current_field > -1)
   {
    // blank set first
    set<string> larry;
    current_task_rule[current_field] = larry;

    vector<string> tomato = filter_field_values.GetMultiID();
    // if less than total, but more than none, set to that instead
    if (int(tomato.size()) < filter_field_values.GetResultSize())
    {
     VecToSet(tomato, larry);
     if (!larry.empty())
      current_task_rule[current_field] = larry;
    }
   }
  }
 }
}
//---------------------------------------------------------------------------
void TformLaunchIHSReport::UpdateFieldTree()
{
  // eep, abort!
  if(is_closing)
    return;

  for(int i = 0; i < treeFields->Items->Count; i++)
  {
    TTreeNode *guy = treeFields->Items->Item[i];
    if(guy && guy->StateIndex > -1)
    {
      guy->Text = GetNodeName(guy->StateIndex).c_str();
      task_rule::iterator i_condition = current_task_rule.find(guy->StateIndex);
      if(i_condition != current_task_rule.end() && !i_condition->second.empty())
      {
        guy->Text = string(GetNodeName(guy->StateIndex) + " (" + IntToString(i_condition->second.size()) + ")").c_str();
      }
    }
  }
}
//---------------------------------------------------------------------------
bool TformLaunchIHSReport::SaveRule()
{
 // eep, abort! abort!
 if (is_closing)
 {
  return false;
 }
 else
 {
  // save current rule
  // make sure the name's not already taken
  string new_rule_name = editRuleName->Text.c_str();

  task_rule_set::iterator i_rule = current_task_rules.find(current_rule_name);
  if (i_rule != current_task_rules.end())
  {
   // save what they were working on
   SaveFieldValues();
   // make sure the name's not already taken
   string new_rule_name = editRuleName->Text.c_str();
   task_rule_set::iterator i_name = current_task_rules.find(new_rule_name);
   if (i_name == current_task_rules.end() || i_name == i_rule)
   {
    current_task_rules.erase(i_rule);
    current_task_rules[new_rule_name] = current_task_rule;

    TListItem * row = listRules->FindCaption(0, current_rule_name.c_str(), false, true, false);
    if (row)
     row->Caption = new_rule_name.c_str();

    current_rule_name = new_rule_name;

    UpdateRuleView();
   } else
   {
    // name already in use elsewhere
    PSay("The rule name you have chosen is already in use by another rule.\nRule names must be unique.",
         m_invalid_data, MB_OK);
    return false;
   }
  }
  else
  {
   // modifying a non-existing thingie
  }
  return true;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchIHSReport::editRuleNameChange(TObject *Sender)
{
 SaveRule();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchIHSReport::FormClose(TObject *Sender, TCloseAction &Action)
{
  // TODO: keep other events from firing (on select mostly)
  is_closing = true;

  if (dbPrepReport)
  {
    // jhaley: note these were commented out - was there a reason? 
    ExecuteStatement(dbPrepReport, "delete from temp_ihs_report_1");
    ExecuteStatement(dbPrepReport, "delete from temp_ihs_report_2");

    dbPrepReport->Commit();
    delete dbPrepReport;
    dbPrepReport = NULL;
  }
  Action = caFree;
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchIHSReport::buttonPrepareReportClick(TObject *Sender)
{
 // start a transaction and make other stuff visible. or some such.
 if (checkUseTasks->Checked || checkUsePharmacy->Checked)
 {
  if (checkUseTasks->Checked && current_task_rules.empty())
  {
   PSay("You have asked to use tasks as a source of information, but you have not created any rules.\n"
        "As it stands, no data will be pulled from tasks.", m_missing_data, MB_OK);
  }
  else
  {
   from.InDate(datePeriodFrom->DateTime);
   until.InDate(datePeriodTo->DateTime);

   if (from > until)
   {
    PSay("The beginning date should not be later in time than the ending date.", m_invalid_data, MB_OK);
   }
   else
   {
    date_range report_period = date_range(from, until);
    if (!dbPrepReport)
    {
     dbPrepReport = new TIBTransaction(NULL);
     SpyTransaction(dbPrepReport, dbDatabase);
    }

    if (PrepareIhsTemp (dbPrepReport, report_period, checkUseTasks->Checked, checkUsePharmacy->Checked, current_task_rules))
    {
     string new_sql = "select people.id, people.current_id, "
                      "person_names.first_name, person_names.middle_name, person_names.last_name, "
                      "gender_types.item, people.birth_date, people.death_date, people.social_security_number, "
                      "affiliations.cdib, tribe_types.item, affiliations.join_date, affiliations.relinquish_date, "
                      "person_contact_info.line1, person_contact_info.line2, person_contact_info.city, "
                      "state_types.item, person_contact_info.zip, country_types.item, "
                      "temp_ihs_report_2.latest_date, temp_ihs_report_2.contact_count "
                      "from temp_ihs_report_2 "
                      "inner join people on temp_ihs_report_2.person_id = people.id "
                      "inner join person_names on people.person_names_id = person_names.id "
                      "inner join affiliations on people.affiliations_id = affiliations.id "
                      "inner join person_contact_info on people.person_contact_info_id = person_contact_info.id "
                      "inner join gender_types on people.gender_id = gender_types.id "
                      "inner join tribe_types on affiliations.tribe_id = tribe_types.id "
                      "inner join state_types on person_contact_info.state_id = state_types.id "
                      "inner join country_types on person_contact_info.country_id = country_types.id ";

     // main report
     filter_screen_report.SetTransaction(dbPrepReport);
     filter_screen_report.SetSQLStatement(new_sql);
     filter_screen_report.RefreshDataSet();

     // rule report
     string sql_rule_report = "select temp_ihs_report_1.data_source, count(*), sum(contact_count) from temp_ihs_report_1 group by data_source";
     filter_rule_report.SetTransaction(dbPrepReport);
     filter_rule_report.SetSQLStatement(sql_rule_report);
     filter_rule_report.RefreshDataSet();

     buttonPrepareReport->Enabled = false;
     buttonShowOptions->Enabled = true;
     pageIHS->ActivePageIndex = 1;
    }
    else
    {
     PSay("Failed to prepare initial stage of report (temporary summary ihs data.)", m_database_error, MB_OK);
     dbPrepReport->Rollback();
     delete dbPrepReport;
     dbPrepReport = NULL;
    }
   }
  }
 }
 else
 {
  PSay("You must select at least one source of data. This report is meaningless otherwise.", m_missing_data, MB_OK);
 }
}
//---------------------------------------------------------------------------
void TformLaunchIHSReport::EditPerson(const string & p_id)
{
 map<string, string> params;
 params["id"] = p_id;

 FORM_TRY
  TformRecordPerson * person = new TformRecordPerson(NULL, params);
  person->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchIHSReport::listFieldValuesChange(
      TObject *Sender, TListItem *Item, TItemChange Change)
{
 if (!is_closing && !updating_rule_view && Change == ctState)
 {
  is_saving_because_checked = true;
  SaveRule();
 }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchIHSReport::buttonCloseClick(TObject *Sender)
{
 Close();        
}
//---------------------------------------------------------------------------
void TformLaunchIHSReport::RefreshSummary ()
{
 if (is_closing)
  return;
 if (dbPrepReport)
 {
  // days in period
  int num_days = (until - from) + 1;

  // count(distinct person_id) -- already distinct via the group_by's
  int num_people = filter_screen_report.GetDatasetSize();

  // sum(contact_count)
  int num_contacts = StringToInt(GetOneField(dbPrepReport, "select sum(contact_count) from temp_ihs_report_2"));

  // avg(contact_count)
  float avg_contacts = (num_people) ? ((float)num_contacts / (float)num_people) : 0.00;

  labelDatePeriod->Caption = string(from.OutDate(global_mode) + " - " + until.OutDate(global_mode)).c_str();
  labelTotalDays->Caption = IntToString(num_days).c_str();
  labelTotalPeople->Caption = IntToString(num_people).c_str();
  labelTotalContacts->Caption = IntToString(num_contacts).c_str();
  labelAverageContactsPerPerson->Caption = FloatToString(avg_contacts).c_str();
 }
}
//---------------------------------------------------------------------------

