//---------------------------------------------------------------------------

#ifndef launchIHSReportH
#define launchIHSReportH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
typedef map<int, set<string> > task_rule;     // int indicating fk/lookup_table to sets of valid id's
typedef map<string, task_rule> task_rule_set; // rule name to condition (see above)
//---------------------------------------------------------------------------
class TformLaunchIHSReport : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *buttonShowOptions;
        TPageControl *pageIHS;
        TTabSheet *sheetOptions;
        TTabSheet *sheetUpdateScreen;
        TPageControl *pageOptions;
        TTabSheet *sheetGeneralOptions;
        TTabSheet *sheetTaskOptions;
        TGroupBox *groupPeriod;
        TLabel *labelDateFrom;
        TLabel *labelDateTo;
        TDateTimePicker *datePeriodFrom;
        TDateTimePicker *datePeriodTo;
        TGroupBox *groupSources;
        TCheckBox *checkUsePharmacy;
        TCheckBox *checkUseTasks;
        TGroupBox *groupRuleOptions;
        TLabel *labelRuleName;
        TEdit *editRuleName;
        TTreeView *treeFields;
        TListView *listFieldValues;
        TGroupBox *groupRules;
        TListView *listRules;
        TButton *buttonImportRules;
        TButton *buttonExportRules;
        TButton *buttonNewRule;
        TButton *buttonDeleteRule;
        TLabel *labelRuleExplanation;
        TLabel *labelVisitExplanation;
        TListView *listReport;
        TOpenDialog *dialogImportOptions;
        TSaveDialog *dialogExportOptions;
        TToolButton *buttonPrepareReport;
        TToolButton *buttonClose;
        TToolButton *ToolButton1;
        TPanel *panelTotals;
        TLabel *labelTotalContacts;
        TLabel *labelAverageContactsPerPerson;
        TLabel *labelTotalPeople;
        TLabel *labelExplainB;
        TLabel *labelExplainC;
        TLabel *labelExplainD;
        TLabel *labelTotalDays;
        TLabel *labelExplainA;
        TListView *listRuleReport;
        TLabel *labelDatePeriod;
        TLabel *labelPharmacyExplanation;
        void __fastcall buttonShowOptionsClick(TObject *Sender);
        void __fastcall buttonNewRuleClick(TObject *Sender);
        void __fastcall buttonDeleteRuleClick(TObject *Sender);
        void __fastcall buttonImportRulesClick(TObject *Sender);
        void __fastcall buttonExportRulesClick(TObject *Sender);
        void __fastcall listRulesSelectItem(TObject *Sender,
          TListItem *Item, bool Selected);
        void __fastcall treeFieldsChange(TObject *Sender, TTreeNode *Node);
        void __fastcall editRuleNameChange(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall buttonPrepareReportClick(TObject *Sender);
        void __fastcall listFieldValuesChange(TObject *Sender,
          TListItem *Item, TItemChange Change);
        void __fastcall buttonCloseClick(TObject *Sender);
private:	// User declarations
        task_rule_set     current_task_rules;
        task_rule         current_task_rule;
        bool              updating_rule_view;
        bool              is_closing;
        bool              is_saving_because_checked;
        Pdate from;
        Pdate until;
        classFilterObject filter_field_values;
        classFilterObject filter_screen_report;
        classFilterObject filter_rule_report;
        set<string>       id_to_be_checked;

        bool PrepareIhsTemp (TIBTransaction * dbTransaction, date_range report_period, bool use_task, bool use_rx, task_rule_set & task_rules);
        string GetTableName (int i);
        string GetFkName (int i);
        string GetNodeName (int i);
        string current_rule_name;
        void UpdateRuleView();
        void UpdateRuleList();
        void UpdateFieldTree();
        bool AskCheckFieldValue(map<string, string> & row_data);
        void SaveFieldValues();
        bool SaveRule();
        void EditPerson(const string & p_id);
        void RefreshSummary();
        TIBTransaction * dbPrepReport;
public:		// User declarations
        __fastcall TformLaunchIHSReport(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TformLaunchIHSReport *formLaunchIHSReport;
//---------------------------------------------------------------------------
#endif
