//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchIncentiveReport.h"
#include "reportIncentive.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchIncentiveReport *formLaunchIncentiveReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchIncentiveReport::TformLaunchIncentiveReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchIncentiveReport::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchIncentiveReport::btnRunClick(TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {

    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;


    sql = "select incentive_types.item incentive_type, count(incentives.id) the_count "
          "from incentive_types left join incentives on "
          "incentives.incentive_id = incentive_types.id and "
          "(incentives.date_received >= '" + begin_date + "' or "
          "incentives.date_sent_to_finance >= '" + begin_date + "' or "
          "incentives.date_ordered >= '" + begin_date + "') and "
          "(incentives.date_received <= '" + end_date + "' or "
          "incentives.date_sent_to_finance <= '" + end_date + "' or "
          "incentives.date_ordered <= '" + end_date + "') "
          "where incentive_types.id > 0 "
          "group by incentive_types.item "
          "order by incentive_types.item";

    dbTransaction->StartTransaction();
    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportIncentive * incentiveReport = new TformReportIncentive(NULL);
      incentiveReport->incentiveReport->DataSet = dbDataSet;
      incentiveReport->lblDateTitle->Caption = date_title.c_str();
      incentiveReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      incentiveReport->txtType->DataSet = dbDataSet;
      incentiveReport->txtType->DataField = "incentive_type";
      incentiveReport->txtTotal->DataSet = dbDataSet;
      incentiveReport->txtTotal->DataField = "the_count";
      incentiveReport->exprTotal->Expression = "SUM(the_count)";
      Processing(false);
      incentiveReport->incentiveReport->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchIncentiveReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

