//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchInsuranceByAppointmentReport.h"
#include "reportInsuranceByAppointment.h"
#include "scheduling.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchInsuranceByAppointmentReport *formLaunchInsuranceByAppointmentReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchInsuranceByAppointmentReport::TformLaunchInsuranceByAppointmentReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  lookupTables->RegisterComboBox("groups", cboDepartment);
  cboDepartment->Text = lookupTables->ValueOf("groups", current_groupid).c_str();
  dateBegin->Date =Date();
  dateEnd->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchInsuranceByAppointmentReport::btnRunClick(TObject *Sender)
{
  if(IsValidOnScreen())
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbTransaction->StartTransaction();
      ExecuteStatement(dbTransaction, "delete from appointment_reports");

      PApptOccurrenceMap all_appointments;
      vector<string> user_ids;
      string sql;
      Pdate begin_date;
      begin_date.InDate(dateBegin->Date);
      Pdate end_date;
      end_date.InDate(dateEnd->Date);
      string date_title = begin_date.OutDate(mdy | yyyy) + " - " + end_date.OutDate(mdy | yyyy);
      SqlToVec(dbTransaction, "select id from users where group_id = " + lookupTables->IdOf("groups", cboDepartment->Text.c_str()) +
               " and valid = 1", user_ids);
      map<string, vector<string> > ids_to_match;
      ids_to_match["current_id"].push_back("3");
      ids_to_match["current_id"].push_back("4");
      ids_to_match["current_id"].push_back("5");
      DownloadAppointments(dbDatabase, begin_date, end_date, current_userid, user_ids, vector<string>(), "", all_appointments, ids_to_match,
                           (optionsPermissions["admin.all_appointments"]["enabled"] == "true"), false, "");
      map<string, string> insert_map;
      for(PApptOccurrenceMap::iterator itr = all_appointments.begin(); itr != all_appointments.end(); itr++)
      {
        for(PApptOccurrenceSet::iterator set_itr = itr->second.begin(); set_itr != itr->second.end(); set_itr++)
        {
          insert_map["id"] = (*set_itr).id;
          insert_map["appt_date"] = itr->first.OutDate(mdy | yyyy);
          insert_map["appt_time"] = (*set_itr).range_begin.OutTime(military | withsec);
          ExecuteInsertStatement(dbTransaction, "appointment_reports", insert_map);
        }
      }
      sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix name, "
            "appointment_reports.appt_date, appointment_reports.appt_time, "
            "created_for_user.item created_for, "
            "tax_entities.name insurance_company, "
            "insurance_policies.start_date, insurance_policies.stop_date "
            //"created_by_user.item created_by, "
            //"appointments.duration || ' ' || duration_types.item duration, "
            //"appointments.description, visit_outcome_types.item outcome "
            "from appointment_reports "
            "inner join appointments on appointment_reports.id = appointments.id "
            "left join users created_for_user on appointments.created_for = created_for_user.id "
            //"left join users created_by_user on appointments.created_by = created_by_user.id "
            //"left join duration_types on appointments.duration_id = duration_types.id "
            //"left join visit_outcome_types on appointments.visit_outcome_id = visit_outcome_types.id "
            "left join people on appointments.person_id = people.id "
            "left join person_names on people.person_names_id = person_names.id "
            "left join insurance_coverage on insurance_coverage.person_id = people.id and insurance_coverage.current_id >= 3 "
            "left join insurance_policies on insurance_coverage.insurance_policy_id = insurance_policies.id and insurance_policies.current_id >= 3 "
            "left join tax_entities on insurance_policies.tax_entity_id = tax_entities.id "
            "where (insurance_policies.stop_date is null or insurance_policies.stop_date > '" + begin_date.OutDate(mdy | yyyy) + "') "
            "order by appointment_reports.appt_date, appointment_reports.appt_time ";

        dbDataSet->SelectSQL->Clear();
        dbDataSet->SelectSQL->Add(sql.c_str());
        dbDataSet->Open();
        dbDataSet->First();

        FORM_TRY
          TformReportInsuranceByAppointment * report_form = new TformReportInsuranceByAppointment(NULL);
          report_form->report->DataSet = dbDataSet;
          report_form->lblTitle->Caption = ReplaceStringWithString(report_form->lblTitle->Caption.c_str(), "Department", cboDepartment->Text.c_str()).c_str();
          report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
          report_form->lblDateTitle->Caption = date_title.c_str();
          report_form->txtPerson->DataSet = dbDataSet;
          report_form->txtPerson->DataField = "name";
          report_form->txtDate->DataSet = dbDataSet;
          report_form->txtDate->DataField = "appt_date";
          report_form->txtTime->DataSet = dbDataSet;
          report_form->txtTime->DataField = "appt_time";
          report_form->txtFor->DataSet = dbDataSet;
          report_form->txtFor->DataField = "created_for";
          report_form->txtInsuranceCompany->DataSet = dbDataSet;
          report_form->txtInsuranceCompany->DataField = "insurance_company";
          report_form->txtStartDate->DataSet = dbDataSet;
          report_form->txtStartDate->DataField = "start_date";
          report_form->txtStopDate->DataSet = dbDataSet;
          report_form->txtStopDate->DataField = "stop_date";
          Processing(false);
          report_form->report->Preview();
        FORM_CATCH

      ExecuteStatement(dbTransaction, "delete from appointment_reports");
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch(...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;

    Processing(false);
  }// end if isvalidonscreen

}
//---------------------------------------------------------------------------
bool TformLaunchInsuranceByAppointmentReport::IsValidOnScreen()
{
  if(cboDepartment->Text == "")
  {
    PSay("Please select a department", m_missing_data, MB_OK);
    cboDepartment->SetFocus();
    return false;
  }
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchInsuranceByAppointmentReport::btnCloseClick(TObject *Sender)
{
   Close();        
}
//---------------------------------------------------------------------------

