//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchInsuranceStatisticsReport.h"
#include "reportInsuranceStatistics.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchInsuranceStatisticsReport *formLaunchInsuranceStatisticsReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchInsuranceStatisticsReport::TformLaunchInsuranceStatisticsReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchInsuranceStatisticsReport::btnCloseClick(
      TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchInsuranceStatisticsReport::btnRunClick(
      TObject *Sender)
{
  Processing(true);
  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  string sql;
  string today = CurrentDate();
  string title = "Insurance statistics - " + today;
  float total_people;
  string total_str;
  int coverage_int;
  string coverage_str;
  int temp_int;
  float temp_float;

  // TODO: jhaley - this entire report needs to be either A. eliminated or B. rewritten ground-up.
  // It should be pulling insurance_types, not looking at tax entities. This is highly unreliable and isn't working
  // correctly. (ex: Medicaid says 0%, yeah right!!!). I also doubt these queries need to be run separately, since
  // Firebird 2.x features are now available.
  set<string> medicaid_id;
  set<string> medicare_a_id;
  set<string> medicare_b_id;
  set<string> medicare_d_id;
  set<string> medicare_adv_id;

  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbTransaction->StartTransaction();

    FORM_TRY
      TformReportInsuranceStatistics * report_form = new TformReportInsuranceStatistics(NULL);
      report_form->lblTitle->Caption = title.c_str();
      report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();

      // jhaley TODO: WHY ARE THERE MORE THAN ONE OF THESE?!?!? >___<
      SqlToSet(dbTransaction, "select id from tax_entities where upper(name) = 'MEDICAID'",   medicaid_id);
      SqlToSet(dbTransaction, "select id from tax_entities where upper(name) = 'MEDICARE A'", medicare_a_id);
      SqlToSet(dbTransaction, "select id from tax_entities where upper(name) = 'MEDICARE B'", medicare_b_id);
      SqlToSet(dbTransaction, "select id from tax_entities where upper(name) = 'MEDICARE D'", medicare_d_id);
      SqlToSet(dbTransaction, "select id from tax_entities where upper(name) = 'MEDICARE ADVANTAGE'", medicare_adv_id);

      // total people
      sql = "select count(distinct people.id) "
            "from people left join affiliations on people.affiliations_id = affiliations.id "
            "where affiliations.tribe_id = " + lookupTables->IdOf("tribe_types", "Absentee Shawnee Tribes of Oklahoma") + " and "
            "affiliations.relinquish_date is null and "
            "affiliations.current_id >= 3 and "
            "people.current_id >= 3";
      total_str = GetOneField(dbTransaction, sql);
      total_people = StringToFloat(total_str);
      report_form->lblTotal->Caption = total_str.c_str();

      // people with medicaid
      sql = "select count(distinct people.id) "
            "from people left join affiliations on people.affiliations_id = affiliations.id "
            "inner join insurance_coverage on insurance_coverage.person_id = people.id "
            "inner join insurance_policies on insurance_coverage.insurance_policy_id = insurance_policies.id "
            "where affiliations.tribe_id = " + lookupTables->IdOf("tribe_types", "Absentee Shawnee Tribes of Oklahoma") + " and "
            "affiliations.relinquish_date is null and "
            "affiliations.current_id >= 3 and "
            "people.current_id >= 3 and " +
            SafeInClause("insurance_policies.tax_entity_id", SetToVec(medicaid_id)) + " and "
            "(insurance_policies.stop_date >= '" + today + "' "
           "or insurance_policies.stop_date is null)";
      temp_float = StringToFloat(GetOneField(dbTransaction, sql));
      report_form->lblMedicaid->Caption = string(IntToString((int)(temp_float / total_people * 100)) + "%").c_str();

      // people with medicare
      sql = "select count(distinct people.id) "
            "from people left join affiliations on people.affiliations_id = affiliations.id "
            "inner join insurance_coverage on insurance_coverage.person_id = people.id "
            "inner join insurance_policies on insurance_coverage.insurance_policy_id = insurance_policies.id "
            "where affiliations.tribe_id = " + lookupTables->IdOf("tribe_types", "Absentee Shawnee Tribes of Oklahoma") + " and "
            "affiliations.relinquish_date is null and "
            "affiliations.current_id >= 3 and "
            "people.current_id >= 3 and (" +
              SafeInClause("insurance_policies.tax_entity_id", SetToVec(medicare_a_id)) + " or " +
              SafeInClause("insurance_policies.tax_entity_id", SetToVec(medicare_b_id)) + " or " +
              SafeInClause("insurance_policies.tax_entity_id", SetToVec(medicare_d_id)) + " or " +
              SafeInClause("insurance_policies.tax_entity_id", SetToVec(medicare_adv_id)) +
            ") and "
            "(insurance_policies.stop_date >= '" + today + "' or insurance_policies.stop_date is null)";
      temp_float = StringToFloat(GetOneField(dbTransaction, sql));
      report_form->lblMedicare->Caption = string(IntToString((int)(temp_float / total_people * 100)) + "%").c_str();

      // people with private insurance
      sql = "select count(distinct people.id) "
            "from people left join affiliations on people.affiliations_id = affiliations.id "
            "inner join insurance_coverage on insurance_coverage.person_id = people.id "
            "inner join insurance_policies on insurance_coverage.insurance_policy_id = insurance_policies.id "
            "where affiliations.tribe_id = " + lookupTables->IdOf("tribe_types", "Absentee Shawnee Tribes of Oklahoma") + " and "
            "affiliations.relinquish_date is null and "
            "affiliations.current_id >= 3 and "
            "people.current_id >= 3 and "
            "not (" + SafeInClause("insurance_policies.tax_entity_id", SetToVec(medicaid_id)) + ") and "
            "not (" + SafeInClause("insurance_policies.tax_entity_id", SetToVec(medicare_a_id)) + ") and "
            "not (" + SafeInClause("insurance_policies.tax_entity_id", SetToVec(medicare_b_id)) + ") and "  // jhaley TODO: What about D and Advantage?
            "(insurance_policies.stop_date >= '" + today + "' "
            "or insurance_policies.stop_date is null)";
      temp_float = StringToFloat(GetOneField(dbTransaction, sql));
      report_form->lblPrivate->Caption = string(IntToString((int)(temp_float / total_people * 100)) + "%").c_str();

      // people with insurance of any kind
      // first find out how many people do have insurance and subtract from the total
      // to find out how many don't
      sql = "select count(distinct people.id) "
            "from people left join affiliations on people.affiliations_id = affiliations.id "
            "inner join insurance_coverage on insurance_coverage.person_id = people.id "
            "inner join insurance_policies on insurance_coverage.insurance_policy_id = insurance_policies.id "
            "where affiliations.tribe_id = " + lookupTables->IdOf("tribe_types", "Absentee Shawnee Tribes of Oklahoma") + " and "
            "affiliations.relinquish_date is null and "
            "affiliations.current_id >= 3 and "
            "people.current_id >= 3 and "
            "(insurance_policies.stop_date >= '" + today + "' "
            "or insurance_policies.stop_date is null)";
      coverage_str = GetOneField(dbTransaction, sql);
      coverage_int = StringToInt(coverage_str);
      temp_int = total_people - coverage_int;
      report_form->lblNoCoverage->Caption = string(IntToString((temp_int / total_people) * 100) + "%").c_str();

      Processing(false);
      report_form->report->Preview();
    FORM_CATCH
    dbTransaction->Commit();
  }
  /*
  catch(EIBError &error)
  {
    string message;
    Processing(false);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
    message = "There was an error:\n";
    message += error.Message.c_str();
    PSay(message, m_database_error, MB_OK);
  }
  */
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchInsuranceStatisticsReport::FormShortCut(
      TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

