//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchIntake.h"
#include "html_reporting.h"
#include "codeSpecialHtmlPreview.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchIntake *formLaunchIntake;
//---------------------------------------------------------------------------
__fastcall TformLaunchIntake::TformLaunchIntake(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchIntake::buttonCloseClick(TObject *Sender)
{
 Close();        
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchIntake::buttonRunClick(TObject *Sender)
{
 Run();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchIntake::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    buttonRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
void TformLaunchIntake::Do()
{
 FORM_TRY
  TformLaunchIntake * z = new TformLaunchIntake(NULL);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
string OptionalAttribute (string attribute, string value)
{
 if (value.empty())
  return "";
 else
  return " " + attribute + "='" + value + "'";
}
string OptionalValue (string value)
{
 if (value.empty())
  return "&nbsp;";
 else
  return value;
}
string StartFieldRow (string css_class)
{
 return "<table width=100% cellspacing=0 cellpadding=0" + OptionalAttribute("class", css_class) + "><tr>";
}
string StopFieldRow ()
{
 return "</tr></table>";
}

string ShowCheckElement (string _label, bool checked)
{
 return "<span style='vertical-align: baseline;'><span style='font-size: 6pt; float: left; width: 2em;'><span style='float: bottom; margin-left: 10px; height: 1em; width: 1em; border: 1px solid black;'><b>" + string((checked) ? "X" : "&nbsp;") + "</b></span></span><span style='float: left; margin-left: 10px; margin-right: 10px;'>" + _label + "</span></span>";
}

string ShowFieldElement (string width, string css_class, string _label, string label_class, string _value, string value_class)
{
 return "<td" + OptionalAttribute("width", width) + " valign=top>" +
        StartFieldRow(css_class) +
        "<td valign=top" + OptionalAttribute("class", label_class) + ">" + OptionalValue(_label) + "</td>"
        "<td style='padding-bottom: 1px solid black; margin-left: 5px solid white; margin-right: 5px solid white; width: 100%;'" + OptionalAttribute("class", value_class) + ">" + OptionalValue(_value) + "</td>" +
        StopFieldRow() +
        "</td>";
}

void TformLaunchIntake::Run()
{
 // stuff!
 Processing(true);
 TIBTransaction * dbTransaction = NULL;
 try
 {
  FORM_TRY
   dbTransaction = new TIBTransaction(NULL);
  FORM_CATCH
  StdTransaction(dbTransaction, dbDatabase);

  ofstream ze_file;
  ze_file.open("intake.html", ios::trunc | ios::out);
  if (!ze_file.is_open())
  {
   PSay("Failed to create temporary file for report output.", m_debug, MB_OK);
   throw(97);
  }

  htmlStart(ze_file, "Absentee Shawnee Tribal Health System Intake Form", "", false, false);
  ze_file << "NOTE: Please print clearly and fill in every blank or check the correct response. Use n/a if not applicable.<br>"
             "Date: <span class=underlined width=10em>&nbsp;</span>";
  // ze_file << "Correct information by crossing it out and filling in current information in the additional blank area below it.<br>";

  htmlSectionStart(ze_file, false);
  htmlPrettyBar(ze_file, "General information");
  htmlSectionContinue(ze_file);

  ze_file << StartFieldRow("markup")
          << ShowFieldElement("100%", "", "Name: ", "inlabel", "noname00", "invalue")
          << StopFieldRow();
  ze_file << StartFieldRow("markup")
          << ShowFieldElement("33%", "", "SSN: ", "inlabel", "000-00-0000", "invalue")
          << ShowFieldElement("33%", "", "Gender: ", "inlabel", "??Male", "invalue")
          << ShowFieldElement("", "", "Date of birth: ", "inlabel", "00/00/0000", "invalue")
          << StopFieldRow();
  ze_file << StartFieldRow("markup")
          << ShowFieldElement("25%", "", "CDIB/Roll #: ", "inlabel", "1234", "invalue")
          << ShowFieldElement("", "", "Tribe: ", "inlabel", "Some tribe or other", "invalue")
          << ShowFieldElement("25%", "", "Join date: ", "inlabel", "00/00/0000", "invalue")
          << StopFieldRow();
  ze_file << StartFieldRow("markup")
          << ShowFieldElement("75%", "", "Marital status: ", "inlabel", ShowCheckElement("Single", false) + ShowCheckElement("Married", false) + ShowCheckElement("Divorced", true) + ShowCheckElement("Widowed", false), "invalue")
          << ShowFieldElement("25%", "", "Test: ", "inlabel", "", "invalue")
          << StopFieldRow();
  htmlSectionStop(ze_file);

  htmlSectionStart(ze_file, false);
  htmlPrettyBar(ze_file, "Contact information");
  htmlSectionContinue(ze_file);

  htmlSectionStop(ze_file);

  htmlStop(ze_file);
  ze_file.close();

  string real_cwd = GetCurrentDir().c_str();
  dbTransaction->Commit();
  Processing(false);
  TformSpecialHtmlPreview::DoPrintPreview(real_cwd + "\\intake.html");
 }
 catch (...)
 {
  Processing(false);
  PSay("Error running intake report", m_database_error, MB_OK);
 }
 delete dbTransaction;
}
//---------------------------------------------------------------------------
