//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchLogDetailAllUsers.h"
#include "reportLogDetailAllUsers.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchLogDetailAllUsers *formLaunchLogDetailAllUsers;
//---------------------------------------------------------------------------
__fastcall TformLaunchLogDetailAllUsers::TformLaunchLogDetailAllUsers(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Date();
  dateEnd->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchLogDetailAllUsers::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchLogDetailAllUsers::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;         

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchLogDetailAllUsers::btnRunClick(TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    sql = "select log_log.log_timestamp, log_log.computer_name, log_log.is_log_in, "
          "users.item user_name "
          "from log_log inner join users on log_log.user_id = users.id "
          "where cast(log_log.log_timestamp as date) >= '" + begin_date + "' and "
          "cast(log_log.log_timestamp as date) <= '" + end_date + "' "
          "order by log_log.log_timestamp descending";

    dbTransaction->StartTransaction();
    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportLogDetailAllUsers * report = new TformReportLogDetailAllUsers(NULL);
      report->logReport->DataSet = dbDataSet;
      report->lblDateTitle->Caption = date_title.c_str();
      report->lblUser->Caption = current_fullname.c_str();
      report->txtTimestamp->DataSet = dbDataSet;
      report->txtTimestamp->DataField = "log_timestamp";
      report->txtUser->DataSet = dbDataSet;
      report->txtUser->DataField = "user_name";
      report->txtComputer->DataSet = dbDataSet;
      report->txtComputer->DataField = "computer_name";
      report->txtAction->DataSet = dbDataSet;
      report->txtAction->DataField = "is_log_in";
      sql = "select count(*) from log_log "
            "where cast(log_log.log_timestamp as date) >= '" + begin_date + "' and "
            "cast(log_log.log_timestamp as date) <= '" + end_date + "' and "
            "log_log.is_log_in = 1";
      report->lblTotal->Caption = GetOneField(dbTransaction, sql).c_str();
      Processing(false);
      report->logReport->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------

