//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchLogInAveragesAllUsers.h"
#include "reportLogInAveragesAllUsers.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchLogInAveragesAllUsers *formLaunchLogInAveragesAllUsers;
//---------------------------------------------------------------------------
__fastcall TformLaunchLogInAveragesAllUsers::TformLaunchLogInAveragesAllUsers(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Date();
  dateEnd->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchLogInAveragesAllUsers::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchLogInAveragesAllUsers::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;          

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchLogInAveragesAllUsers::btnRunClick(
      TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  Pdate begin_date = dateBegin->Date;
  Pdate end_date =  dateEnd->Date;
  int date_difference = (end_date - begin_date) + 1;
  string date_title = begin_date.OutDate(mdy | yyyy) + " - " + end_date.OutDate(mdy | yyyy);

  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    sql = "select users.item user_name, count(log_log_view.id) total_logins, "
          "(count(log_log_view.id) / " + IntToString(date_difference) + ".0) the_average "
          "from users left join log_log_view on log_log_view.user_id = users.id and "
          "log_log_view.log_date >= '" + begin_date.OutDate(mdy | yyyy) + "' and "
          "log_log_view.log_date <= '" + end_date.OutDate(mdy | yyyy) + "' and "
          "log_log_view.is_log_in = 1 "
          "where users.id > 0 and users.valid = 1 "
          "group by users.item ";
    if(radioOrderUser->Checked)
      sql += "order by users.item";
    else if(radioOrderAverage->Checked)
      sql += "order by 2 descending, users.item ascending";

    dbTransaction->StartTransaction();
    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportLogInAveragesAllUsers * report = new TformReportLogInAveragesAllUsers(NULL);
      report->logReport->DataSet = dbDataSet;
      report->lblDateTitle->Caption = date_title.c_str();
      report->lblUser->Caption = current_fullname.c_str();
      report->txtUser->DataSet = dbDataSet;
      report->txtUser->DataField = "user_name";
      report->txtTotal->DataSet = dbDataSet;
      report->txtTotal->DataField = "total_logins";
      report->exprAverage->Expression = "FORMATNUMERIC('#0.0', the_average*(7.0/5.0))";
      report->exprTotalLogins->Expression = "SUM(total_logins)";
      report->exprTotalAverage->Expression = "FORMATNUMERIC('#0.0', (SUM(the_average)/SUM(total_logins) * (7.0/5.0)))";
      Processing(false);
      report->logReport->Preview();
    FORM_CATCH

    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
