//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchLogPerUser.h"
#include "reportLogPerUser.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchLogPerUser *formLaunchLogPerUser;
//---------------------------------------------------------------------------
__fastcall TformLaunchLogPerUser::TformLaunchLogPerUser(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  lookupTables->RegisterComboBox("users", cboUser);
  dateBegin->Date = Date();
  dateEnd->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchLogPerUser::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchLogPerUser::FormClose(TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("users", cboUser);
  TformSpecialGeneric::FormClose(Sender, Action);          
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchLogPerUser::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;           

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchLogPerUser::btnRunClick(TObject *Sender)
{
  if (cboUser->Text == "" || ! lookupTables->IsInLookUpTable("users", cboUser->Text.c_str()))
  {
    PSay("Please enter a valid user", m_invalid_data, MB_OK);
    cboUser->SetFocus();
  }
  else
  {
    Processing(true);
    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Log detail for " + string(cboUser->Text.c_str());

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      sql = "select log_log.log_timestamp, log_log.computer_name, log_log.is_log_in "
            "from log_log "
            "where user_id = " + lookupTables->IdOf("users", cboUser->Text.c_str()) + " and "
            "cast(log_log.log_timestamp as date) >= '" + begin_date + "' and "
            "cast(log_log.log_timestamp as date) <= '" + end_date + "' "
            "order by log_log.log_timestamp descending";

      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportLogPerUser * report = new TformReportLogPerUser(NULL);
        report->logReport->DataSet = dbDataSet;
        report->lblTitle->Caption = title.c_str();
        report->lblDateTitle->Caption = date_title.c_str();
        report->lblUser->Caption = current_fullname.c_str();
        report->txtTimestamp->DataSet = dbDataSet;
        report->txtTimestamp->DataField = "log_timestamp";
        report->txtComputer->DataSet = dbDataSet;
        report->txtComputer->DataField = "computer_name";
        report->txtAction->DataSet = dbDataSet;
        report->txtAction->DataField = "is_log_in";
        sql = "select count(*) from log_log "
              "where user_id = " + lookupTables->IdOf("users", cboUser->Text.c_str()) + " and "
              "cast(log_log.log_timestamp as date) >= '" + begin_date + "' and "
              "cast(log_log.log_timestamp as date) <= '" + end_date + "' and "
              "log_log.is_log_in = 1";
        report->lblTotal->Caption = GetOneField(dbTransaction, sql).c_str();
        Processing(false);
        report->logReport->Preview();
      FORM_CATCH

      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;
  }
}
//---------------------------------------------------------------------------
