//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchLogSummary.h"
#include "reportLogSummary.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchLogSummary *formLaunchLogSummary;
//---------------------------------------------------------------------------
__fastcall TformLaunchLogSummary::TformLaunchLogSummary(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Date();
  dateEnd->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchLogSummary::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchLogSummary::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;           

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchLogSummary::btnRunClick(TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    sql = "select log_log_view.log_date, "
          "count(distinct log_log_view.user_id) distinct_users, "
          "count(log_log_view.id) total_logins "
          "from log_log_view "
          "where log_log_view.log_date >= '" + begin_date + "' and "
          "log_log_view.log_date <= '" + end_date + "' and "
          "log_log_view.is_log_in = 1 "
          "group by log_log_view.log_date "
          "order by log_log_view.log_date descending";

    dbTransaction->StartTransaction();
    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportLogSummary * report = new TformReportLogSummary(NULL);
      report->usageReport->DataSet = dbDataSet;
      report->lblDateTitle->Caption = date_title.c_str();
      report->lblUser->Caption = current_fullname.c_str();
      report->txtDate->DataSet = dbDataSet;
      report->txtDate->DataField = "log_date";
      report->txtUsers->DataSet = dbDataSet;
      report->txtUsers->DataField = "distinct_users";
      report->txtLogIn->DataSet = dbDataSet;
      report->txtLogIn->DataField = "total_logins";
      report->exprAverage->Expression = "FORMATNUMERIC('#0.0', total_logins/distinct_users)";
      sql = "select count(distinct log_log_view.user_id) distinct_users from log_log_view "
          "where log_log_view.log_date >= '" + begin_date + "' and "
          "log_log_view.log_date <= '" + end_date + "' and "
          "log_log_view.is_log_in = 1";
      report->lblTotalUsers->Caption = GetOneField(dbTransaction, sql).c_str();
      report->exprTotalLogIns->Expression = "SUM(total_logins)";
      if((report->lblTotalUsers->Caption != "0") && (report->lblTotalUsers->Caption != ""))
      {
        float users = StringToFloat(report->lblTotalUsers->Caption.c_str());
        string expression = "FORMATNUMERIC('#0.0', SUM(total_logins)/" + FloatToString(users) + ")";
        report->exprTotalAverage->Expression = expression.c_str();
      }
      else
        report->exprTotalAverage->Expression = "";
      Processing(false);
      report->usageReport->Preview();
    FORM_CATCH

    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------

