//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchLogTotalsPerUser.h"
#include "reportLogTotalsPerUser.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchLogTotalsPerUser *formLaunchLogTotalsPerUser;
//---------------------------------------------------------------------------
__fastcall TformLaunchLogTotalsPerUser::TformLaunchLogTotalsPerUser(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  lookupTables->RegisterComboBox("users", cboUser);
  dateBegin->Date = Date();
  dateEnd->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchLogTotalsPerUser::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchLogTotalsPerUser::FormClose(TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("users", cboUser);
  TformSpecialGeneric::FormClose(Sender, Action);            
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchLogTotalsPerUser::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;         

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchLogTotalsPerUser::btnRunClick(TObject *Sender)
{
  if (cboUser->Text == "" || ! lookupTables->IsInLookUpTable("users", cboUser->Text.c_str()))
  {
    PSay("Please enter a valid user", m_invalid_data, MB_OK);
    cboUser->SetFocus();
  }
  else
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Log in totals for " + string(cboUser->Text.c_str());

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      sql = "select log_log_view.log_date, "
            "count(log_log_view.id) total_logins "
            "from log_log_view "
            "where log_log_view.log_date >= '" + begin_date + "' and "
            "log_log_view.log_date <= '" + end_date + "' and "
            "log_log_view.is_log_in = 1 and "
            "log_log_view.user_id = " + lookupTables->IdOf("users", cboUser->Text.c_str()) + " "
            "group by log_log_view.log_date "
            "order by log_log_view.log_date descending";

      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportLogTotalsPerUser * report = new TformReportLogTotalsPerUser(NULL);
        report->logReport->DataSet = dbDataSet;
        report->lblTitle->Caption = title.c_str();
        report->lblDateTitle->Caption = date_title.c_str();
        report->lblUser->Caption = current_fullname.c_str();
        report->txtDate->DataSet = dbDataSet;
        report->txtDate->DataField = "log_date";
        report->txtLogIn->DataSet = dbDataSet;
        report->txtLogIn->DataField = "total_logins";
        report->exprAverage->Expression = "FORMATNUMERIC('#0.0', AVERAGE(total_logins))";    // todo - format numeric
        Processing(false);
        report->logReport->Preview();
      FORM_CATCH

      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;
  }        
}
//---------------------------------------------------------------------------

