//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchLogsheetsForDateRangePerPerson.h"
#include "reportLogsheetsForDateRangePerPerson.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchLogsheetsForDateRangePerPerson *formLaunchLogsheetsForDateRangePerPerson;
//---------------------------------------------------------------------------
__fastcall TformLaunchLogsheetsForDateRangePerPerson::TformLaunchLogsheetsForDateRangePerPerson(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchLogsheetsForDateRangePerPerson::btnRunClick(TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix name, "
          "count(activity_logsheets.id) total "
          "from "
          "activity_logsheets inner join people on activity_logsheets.person_id = people.id "
          "left join person_names on people.person_names_id = person_names.id "
          "where "
          "exists (select enrollment.id from enrollment "   // jhaley: changed steps_member -> enrollment
           "where enrollment.person_id = people.id and enrollment.current_id+1 >= 4 and "
           "enrollment.enrollment_id = '" + lookupTables->IdOf("enrollment_types", "STEPS Participant") + "' and "
           "enrollment.enrollment_status_id = '" + lookupTables->IdOf("enrollment_status_types", "Member") + "') and "
          "activity_logsheets.date_turned_in >= '" + begin_date + "' and "
          "activity_logsheets.date_turned_in <= '" + end_date + "' "
          "group by person_names.last_name, person_names.first_name, person_names.suffix "
          "order by person_names.last_name, person_names.first_name";

    dbTransaction->StartTransaction();
    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportLogsheetsForDateRangePerPerson * logsheetReport = new TformReportLogsheetsForDateRangePerPerson(NULL);
      logsheetReport->logsheetReport->DataSet = dbDataSet;
      logsheetReport->lblDateTitle->Caption = date_title.c_str();
      logsheetReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      logsheetReport->txtPersonName->DataSet = dbDataSet;
      logsheetReport->txtPersonName->DataField = "name";
      logsheetReport->txtTotalLogsheets->DataSet = dbDataSet;
      logsheetReport->txtTotalLogsheets->DataField = "Total";
      logsheetReport->exprTotalLogsheets->Expression = "SUM(total)";
      Processing(false);
      logsheetReport->logsheetReport->Preview();
    FORM_CATCH

    dbDataSet->Close();
    dbTransaction->Commit();

  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }

  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchLogsheetsForDateRangePerPerson::btnCancelClick(
      TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------

