//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchMonthlyActivityLogReport.h"
#include "codeSpecialMonthlyActivityForm.h"
#include "scheduling.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchMonthlyActivityLogReport *formLaunchMonthlyActivityLogReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchMonthlyActivityLogReport::TformLaunchMonthlyActivityLogReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  upDownYear->Position = Pstamp(RightNow(), mdy | yyyy | datefirst | withsec).year;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchMonthlyActivityLogReport::btnCloseClick(
      TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchMonthlyActivityLogReport::btnRunClick(
      TObject *Sender)
{
  if(editYear->Text == "")
  {
    PSay("Please enter a year", m_missing_data, MB_OK);
    editYear->SetFocus();
  }
  else if(! IsInt(editYear->Text.c_str()))
  {
    PSay("Please enter a valid year", m_invalid_data, MB_OK);
    editYear->SetFocus();
  }
  else if(cboMonth->Text == "")
  {
    PSay("Please enter a month", m_missing_data, MB_OK);
    cboMonth->SetFocus();
  }
  else
  {
    if (dialogPrint->Execute())
    {
      Processing(true);
      TPrinter * printer_object = Printer();
      printer_object->Title = "Prometheus schedule";
      string the_date = lookupTables->IdOf("month_types", cboMonth->Text.c_str()) + "/1/" +
                        string(editYear->Text.c_str());
      Pdate to_print(the_date, mdy | yyyy);

      printer_object->Title = "Monthly activity log";
      printer_object->Orientation = poLandscape;
      classScheduling *printer_class = new classScheduling(printer_object->Canvas, printer_object->PageWidth,
                                       printer_object->PageHeight* 0.85, to_print, CurrentPdate(),
                                       map<string, TColor> (), 0.9, 9, true);
//      PSay(IntToString(dialogPrint->Copies), m_debug, MB_OK);
      printer_object->BeginDoc();
//      for(int i = 1; i <= dialogPrint->Copies; i++)
//      {
        printer_class->DrawMonthCalendar(PApptOccurrenceMap());

        TCanvas *canvas = printer_object->Canvas;
        int y_position= printer_class->GetYStartPosition();
        int x_position = printer_class->GetXStartPosition();
        canvas->Font->Size = 9;
        canvas->Font->Color = clBlack;
        int text_height = canvas->TextHeight("Sample");

        canvas->Font->Size = 16;
        canvas->Font->Style = TFontStyles()<< fsBold;
        x_position += (text_height * 3.0);
        y_position -= text_height * 2.0;
        canvas->TextOut(x_position, y_position, "STEPS Log Sheet");
        x_position += canvas->TextWidth("STEPS Log Sheet") + (text_height * 24.0);
        canvas->Font->Size = 12;
        canvas->TextOut(x_position, y_position, "Name:______________________________");
        canvas->Font->Style = TFontStyles();

        canvas->Font->Size = 9;
        y_position = printer_class->GetYEndPosition();
        x_position = printer_class->GetXStartPosition();
        y_position += (float)text_height * 1.0;
        canvas->TextOut(x_position, y_position, "Return to:");
        y_position += (float)text_height * 1.7;
        canvas->TextOut(x_position, y_position, "Absentee Shawnee Tribe Wellness & Diabetes");
        y_position += (float)text_height * 1.05;
        canvas->TextOut(x_position, y_position, "Education Program");
        y_position += (float)text_height * 1.05;
        canvas->TextOut(x_position, y_position, "15702 East Highway 9");
        y_position += (float)text_height * 1.05;
        canvas->TextOut(x_position, y_position, "Norman, OK  73026");
        y_position += (float)text_height * 1.7;
        canvas->TextOut(x_position, y_position, "Phone: 405-360-0698");
        y_position += (float)text_height * 1.05;
        canvas->TextOut(x_position, y_position, "Fax: 405-573-6734");

        x_position += canvas->TextWidth("Absentee Shawnee Tribe Wellness & Diabetes") + ((float)text_height * 4.0);
        y_position = printer_class->GetYEndPosition() + ((float)text_height * 1.0);
        canvas->TextOut(x_position, y_position, "What to include in log sheet:");
        y_position += (float)text_height * 1.7;
        canvas->TextOut(x_position, y_position, "Activity: Code of the activity you are engaged in");
        y_position += (float)text_height * 1.7;
        canvas->TextOut(x_position, y_position, "Intensity: Low, moderate (walking, bicycling,");
        y_position += (float)text_height * 1.05;
        canvas->TextOut(x_position, y_position, "vacuuming, gardening), or vigorous (running,");
        y_position += (float)text_height * 1.05;
        canvas->TextOut(x_position, y_position, "aerobics, heavy yard work, sports)");
        y_position += (float)text_height * 1.7;
        canvas->TextOut(x_position, y_position, "Time: Minutes spent engaged in activity");
        y_position += (float)text_height * 1.7;
        canvas->TextOut(x_position, y_position, "Distance: Distance achieved during activity, if applicable");

        x_position += canvas->TextWidth("Distance: Distance achieved during activity, if applicable") + ((float)text_height * 3.5);
        y_position = printer_class->GetYEndPosition() + ((float)text_height * 0.5);
        canvas->Font->Style = TFontStyles()<< fsBold;
        canvas->Font->Size = 16;
        canvas->TextOut(x_position, y_position, "Absentee Shawnee Tribe");
        y_position += (float)text_height * 1.5;
        canvas->TextOut(x_position + (text_height * 3.0), y_position, "STEPS Program");
        canvas->Font->Style = TFontStyles();
        y_position += (float)text_height * 3.0;
        canvas->Font->Size = 9;
        canvas->TextOut(x_position, y_position, "Activity log sheets are due monthly for all");
        y_position += (float)text_height * 1.05;
        canvas->TextOut(x_position, y_position, "STEPS participants");
        y_position += (float)text_height * 1.7;
        canvas->TextOut(x_position, y_position, "STEPS measurements are taken every 6 months");

//        if(i < dialogPrint->Copies)
//          printer_object->NewPage();
//      }
      printer_object->EndDoc();
      if(printer_class)
        delete printer_class;

      TformSpecialMonthlyActivityForm * activity_form = new TformSpecialMonthlyActivityForm(NULL);
      TIBTransaction *activity_transaction = new TIBTransaction(NULL);
      TIBDataSet *activity_dataset = new TIBDataSet(NULL);
      try
      {
        activity_transaction->DefaultDatabase = dbDatabase;
        activity_dataset->Database = dbDatabase;
        activity_dataset->Transaction = activity_transaction;
        activity_dataset->UniDirectional = false;
        activity_transaction->StartTransaction();
        activity_dataset->SelectSQL->Add("select item from activity_code_types where valid = 1 and id > 0 order by item");
        activity_dataset->Open();
        activity_form->activity_codes->DataSet = activity_dataset;
        activity_form->txtCode->DataSet = activity_dataset;
        activity_form->txtCode->DataField = "item";
        activity_form->activity_codes->Prepare();
//        for(int i = 1; i <= dialogPrint->Copies; i++)
          activity_form->activity_codes->Print();
        activity_dataset->Close();
        activity_transaction->Commit();
      }
      catch(...)
      {
        if(activity_transaction->Active)
          activity_transaction->Rollback();
        PSay("Error getting activity codes", m_database_error, MB_OK);
      }
      delete activity_transaction;
      delete activity_dataset;
      activity_form->CloseNow();

      Processing(false);
    }
  }
}
//---------------------------------------------------------------------------
