//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchMonthlyObligatedReport.h"
#include "reportMonthlyObligated.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchMontlyObligatedReport *formLaunchMontlyObligatedReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchMontlyObligatedReport::TformLaunchMontlyObligatedReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  Pdate today = CurrentPdate();
  if(today.year > 100)
    upDownYear->Position = today.year;
  else if(today.year >= 90)
    upDownYear->Position = (today.year + 1900);
  else
    upDownYear->Position = (today.year + 2000);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchMontlyObligatedReport::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchMontlyObligatedReport::btnRunClick(TObject *Sender)
{
  string year = editYear->Text.c_str();
  if(! IsInt(year))
  {
    PSay("Please enter a valid number for year", m_invalid_data, MB_OK);
    editYear->SetFocus();
  }
  else if ((StringToInt(year) < 1990) || (StringToInt(year) > 2050))
  {
    PSay("Please enter a valid year", m_invalid_data, MB_OK);
    editYear->SetFocus();
  }
  else
  {
    Processing(true);
    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    string sql;
    string begin_date;
    string end_date;
    string month;
    map<string, string> result_map;
    financial total = 0;

    /*
// TODO -c HACK: this report is stupidly trying to hack around FB 1.0 problems, and doesn't even do so well. code for 1.5 and fix for 1.0 below.

select
extract(month from cob_tasks.date_of_task) mo,
sum(transactions.credit_amount - transactions.debit_amount) total_obligated,
count(distinct cob_tasks.id) total_cobs,
count(distinct cob_tasks.person_id) total_people
from
transactions
inner join
accounts on transactions.account_id = accounts.id and
accounts.account_type_id = 3
inner join cob_tasks on transactions.task_id = cob_tasks.id
where (transactions.note is null or transactions.note not like 'CANCELLING%')
and cob_tasks.date_of_task between '1/1/2004' and '12/31/2004'
group by extract(month from cob_tasks.date_of_task)

-> This code runs on FB 1.5, takes 7 seconds. The problem is aliasing for group-by: a view could probably do it too, for FB 1.0

We can create a view that gives us the 'extract(month from...' information, so we can group by the output of that.
What precisely needs to be in that view is debatable. Will look again soon, or upgrade to 1.5.

Note: the sql above should be modified to return entries for all months, not just ones with data (preferably), unless nobody cares.

create view cob_tasks_mo_ye (
   ID ,
   CURRENT_ID ,
   LAST_UPDATE_STAMP ,
   LAST_UPDATED_BY ,
   PERSON_ID ,
   EVENT_ID ,
   GROUP_ID ,
   DATE_OF_TASK ,
   TIME_OF_TASK ,
   TIME_SPENT ,
   MILEAGE ,
   TASK_COMMENTS ,
   VISIT_TIME_SPENT ,
   VISIT_COMMENTS ,
   METHOD_ID ,
   DIRECTION_ID ,
   CLASSIFICATION_ID ,
   BEH_MEETING_ID ,
   BEH_VISIT_ID ,
   BEH_ACTIVITY_ID ,
   VISIT_LOCATION_ID ,
   IS_EDUCATIONAL ,
   IS_PERSONAL ,
   DIAB_ACTIVITY_ID ,
   DIAB_CONTACT_ID ,
   DIAB_MEETING_ID ,
   DIAB_TASK_ID ,
   PROGRAM_ID ,
   USER_ID ,
   VISIT_OUTCOME_ID ,
   COM_MEETING_ID ,
   COM_ACTIVITY_ID ,
   COM_VISIT_ID ,
   NEW_CLIENT ,
   BEH_CITY_ID ,
   BEH_APPT_ID ,
   BEH_SERVICE_ID ,
   COM_DEPT_ID ,
   TAX_ENTITY_ID ,
   PARENT_TASK_ID ,
   PATIENT_CONTROL_NUMBER ,
   SERVICES_PROVIDED_ID ,
   IN_PROGRESS ,
   PRECONDITIONS_NOTE ,
   FOLLOWUP_NOTE ,
   REPORTED_BY_NOTE ,
   HOSPITALIZED ,
   GIVEN_ROOM ,
   COB_NUMBER ,
   COB_ID ,
//   CONTACTS_ADDED ,
   CARE_CLASSIFICATION_ID ,
   CARE_SERVICE_ID ,
   CARE_MEETING_ID ,
   DIAB_EDUCATION_ID ,
   FITNESS_MEMBERSHIP_ID ,
   EVENT_LOCATION_ID,
   mo,
   ye
  )
  as
select cob_tasks.*, extract(month from cob_tasks.date_of_task) mo, extract(year from cob_tasks.date_of_task) ye from cob_tasks;

-> the following works, slowly.

select
cob_tasks_mo_ye.mo mo,
sum(transactions.credit_amount - transactions.debit_amount) total_obligated,
count(distinct cob_tasks_mo_ye.id) total_cobs,
count(distinct cob_tasks_mo_ye.person_id) total_people
from
transactions
inner join
accounts on transactions.account_id = accounts.id and
accounts.account_type_id = 3
inner join cob_tasks_mo_ye on transactions.task_id = cob_tasks_mo_ye.id
where (transactions.note is null or transactions.note not like 'CANCELLING%')
and cob_tasks_mo_ye.ye = 2004
group by cob_tasks_mo_ye.mo

-> and we want indexing, yes?

select
cob_tasks_mo_ye.mo mo,
sum(transactions.credit_amount - transactions.debit_amount) total_obligated,
count(distinct cob_tasks_mo_ye.id) total_cobs,
count(distinct cob_tasks_mo_ye.person_id) total_people
from
transactions
inner join
accounts on transactions.account_id = accounts.id and
accounts.account_type_id = 3
inner join cob_tasks_mo_ye on transactions.task_id = cob_tasks_mo_ye.id
where (transactions.note is null or transactions.note not like 'CANCELLING%')
and cob_tasks_mo_ye.date_of_task between '1/1/2004' and '12/31/2004'
group by cob_tasks_mo_ye.mo

-> nevermind, still took 5 minutes. not sure why. must investigate what 1.5 is doing differently in the first statement (way above)

    */

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbTransaction->StartTransaction();

      FORM_TRY
      TformReportMontlyObligated * report_form = new TformReportMontlyObligated(NULL);
      report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      report_form->lblTitle->Caption = string("Amount Obligated per Month - " + year).c_str();
      report_form->lblTotal->Caption = string("Total amount obligated for " + year + ": ").c_str();

      for(int i = 1; i <= 12; i++)
      {
        month = IntToString(i);
       // NOTE USES VIEW
       // TODO: FIXME WHAT THE HELL IS THIS CODE DOING AND WHY?! (posted by philip on 7/14/2003, paul doesn't know either -- matt's code?)
        sql = "select sum(transactions.credit_amount - transactions.debit_amount) total_obligated, "
              "count(distinct cob_tasks.id) total_cobs, "
              "count(distinct cob_tasks.person_id) total_people "
              "from transactions inner join accounts on transactions.account_id = accounts.id "
              "inner join cob_tasks on transactions.task_id = cob_tasks.id "
              "where accounts.account_type_id = " + lookupTables->IdOf("account_types", "Payable") + " and "
              "(transactions.note is null or (transactions.note not like 'CANCELLING%' and transactions.note not like 'ADJUSTING ENTRIES FOR COORDINATION OF BENEFITS%')) and "  // 'cancelling of cob' got replaced, at some point, by the other message in CHI Wizard, leading to confusion
//              "transactions.note not like 'Cancelling of COB%' and "
              "cob_tasks.date_of_task between '" + month + "/1/" + year + "' and '" + month + "/";
        if(i == 1)
        {
          sql += "31/" + year + "'";
          SqlToMap(dbTransaction, sql, result_map);
          if(result_map["total_obligated"] == "")
            result_map["total_obligated"] = "0";
          total += StringToFinancial(result_map["total_obligated"]);
          report_form->exprJanObg->Expression = string("FORMATNUMERIC('$###,###0.00', " + result_map["total_obligated"] + ")").c_str();
          report_form->exprJanClients->Expression = string("FORMATNUMERIC('0', " + result_map["total_people"] + ")").c_str();
          report_form->exprJanCob->Expression = string("FORMATNUMERIC('0', " + result_map["total_cobs"] + ")").c_str();
          if(result_map["total_cobs"] == "0")
            report_form->exprJanAvgCob->Expression = "FORMATNUMERIC('$0.00', 0)";
          else
            report_form->exprJanAvgCob->Expression = string("FORMATNUMERIC('$##,###0.00', " + result_map["total_obligated"] + "/" + result_map["total_cobs"] + ")").c_str();

        }
        else if(i == 2)
        {
          bool leap = false;
          int i_year = StringToInt(year);
          if(! i_year % 4)
          {
            leap = true;
            if(! i_year % 100)
            {
              leap = false;
              if(! i_year % 400)
                leap = true;
            }
          }
          if(leap)
            sql += "29/" + year + "'";
          else
            sql += "28/" + year + "'";
          SqlToMap(dbTransaction, sql, result_map);
          if(result_map["total_obligated"] == "")
            result_map["total_obligated"] = "0";
          total += StringToFinancial(result_map["total_obligated"]);
          report_form->exprFebObg->Expression = string("FORMATNUMERIC('$###,###0.00', " + result_map["total_obligated"] + ")").c_str();
          report_form->exprFebClients->Expression = string("FORMATNUMERIC('0', " + result_map["total_people"] + ")").c_str();
          report_form->exprFebCob->Expression = string("FORMATNUMERIC('0', " + result_map["total_cobs"] + ")").c_str();
          if(result_map["total_cobs"] == "0")
            report_form->exprFebAvgCob->Expression = "FORMATNUMERIC('$0.00', 0)";
          else
            report_form->exprFebAvgCob->Expression = string("FORMATNUMERIC('$##,###0.00', " + result_map["total_obligated"] + "/" + result_map["total_cobs"] + ")").c_str();
        }
        else if(i == 3)
        {
          sql += "21/" + year + "'";  // TODO: ?!?!?!?!
          SqlToMap(dbTransaction, sql, result_map);
          if(result_map["total_obligated"] == "")
            result_map["total_obligated"] = "0";
          total += StringToFinancial(result_map["total_obligated"]);
          report_form->exprMarObg->Expression = string("FORMATNUMERIC('$###,###0.00', " + result_map["total_obligated"] + ")").c_str();
          report_form->exprMarClients->Expression = string("FORMATNUMERIC('0', " + result_map["total_people"] + ")").c_str();
          report_form->exprMarCob->Expression = string("FORMATNUMERIC('0', " + result_map["total_cobs"] + ")").c_str();
          if(result_map["total_cobs"] == "0")
            report_form->exprMarAvgCob->Expression = "FORMATNUMERIC('$0.00', 0)";
          else
            report_form->exprMarAvgCob->Expression = string("FORMATNUMERIC('$##,###0.00', " + result_map["total_obligated"] + "/" + result_map["total_cobs"] + ")").c_str();
        }
        else if(i == 4)
        {
          sql += "30/" + year + "'";
          SqlToMap(dbTransaction, sql, result_map);
          if(result_map["total_obligated"] == "")
            result_map["total_obligated"] = "0";
          total += StringToFinancial(result_map["total_obligated"]);
          report_form->exprAprObg->Expression = string("FORMATNUMERIC('$###,###0.00', " + result_map["total_obligated"] + ")").c_str();
          report_form->exprAprClients->Expression = string("FORMATNUMERIC('0', " + result_map["total_people"] + ")").c_str();
          report_form->exprAprCob->Expression = string("FORMATNUMERIC('0', " + result_map["total_cobs"] + ")").c_str();
          if(result_map["total_cobs"] == "0")
            report_form->exprAprAvgCob->Expression = "FORMATNUMERIC('$0.00', 0)";
          else
            report_form->exprAprAvgCob->Expression = string("FORMATNUMERIC('$##,###0.00', " + result_map["total_obligated"] + "/" + result_map["total_cobs"] + ")").c_str();
        }
        else if(i == 5)
        {
          sql += "31/" + year + "'";
          SqlToMap(dbTransaction, sql, result_map);
          if(result_map["total_obligated"] == "")
            result_map["total_obligated"] = "0";
          total += StringToFinancial(result_map["total_obligated"]);
          report_form->exprMayObg->Expression = string("FORMATNUMERIC('$###,###0.00', " + result_map["total_obligated"] + ")").c_str();
          report_form->exprMayClients->Expression = string("FORMATNUMERIC('0', " + result_map["total_people"] + ")").c_str();
          report_form->exprMayCob->Expression = string("FORMATNUMERIC('0', " + result_map["total_cobs"] + ")").c_str();
          if(result_map["total_cobs"] == "0")
            report_form->exprMayAvgCob->Expression = "FORMATNUMERIC('$0.00', 0)";
          else
            report_form->exprMayAvgCob->Expression = string("FORMATNUMERIC('$##,###0.00', " + result_map["total_obligated"] + "/" + result_map["total_cobs"] + ")").c_str();
        }
        else if(i == 6)
        {
          sql += "30/" + year + "'";
          SqlToMap(dbTransaction, sql, result_map);
          if(result_map["total_obligated"] == "")
            result_map["total_obligated"] = "0";
          total += StringToFinancial(result_map["total_obligated"]);
          report_form->exprJunObg->Expression = string("FORMATNUMERIC('$###,###0.00', " + result_map["total_obligated"] + ")").c_str();
          report_form->exprJunClients->Expression = string("FORMATNUMERIC('0', " + result_map["total_people"] + ")").c_str();
          report_form->exprJunCob->Expression = string("FORMATNUMERIC('0', " + result_map["total_cobs"] + ")").c_str();
          if(result_map["total_cobs"] == "0")
            report_form->exprJunAvgCob->Expression = "FORMATNUMERIC('$0.00', 0)";
          else
            report_form->exprJunAvgCob->Expression = string("FORMATNUMERIC('$##,###0.00', " + result_map["total_obligated"] + "/" + result_map["total_cobs"] + ")").c_str();
        }
        else if(i == 7)
        {
          sql += "31/" + year + "'";
          SqlToMap(dbTransaction, sql, result_map);
          if(result_map["total_obligated"] == "")
            result_map["total_obligated"] = "0";
          total += StringToFinancial(result_map["total_obligated"]);
          report_form->exprJulObg->Expression = string("FORMATNUMERIC('$###,###0.00', " + result_map["total_obligated"] + ")").c_str();
          report_form->exprJulClients->Expression = string("FORMATNUMERIC('0', " + result_map["total_people"] + ")").c_str();
          report_form->exprJulCob->Expression = string("FORMATNUMERIC('0', " + result_map["total_cobs"] + ")").c_str();
          if(result_map["total_cobs"] == "0")
            report_form->exprJulAvgCob->Expression = "FORMATNUMERIC('$0.00', 0)";
          else
            report_form->exprJulAvgCob->Expression = string("FORMATNUMERIC('$##,###0.00', " + result_map["total_obligated"] + "/" + result_map["total_cobs"] + ")").c_str();
        }
        else if(i == 8)
        {
          sql += "21/" + year + "'";
          SqlToMap(dbTransaction, sql, result_map);
          if(result_map["total_obligated"] == "")
            result_map["total_obligated"] = "0";
          total += StringToFinancial(result_map["total_obligated"]);
          report_form->exprAugObg->Expression = string("FORMATNUMERIC('$###,###0.00', " + result_map["total_obligated"] + ")").c_str();
          report_form->exprAugClients->Expression = string("FORMATNUMERIC('0', " + result_map["total_people"] + ")").c_str();
          report_form->exprAugCob->Expression = string("FORMATNUMERIC('0', " + result_map["total_cobs"] + ")").c_str();
          if(result_map["total_cobs"] == "0")
            report_form->exprAugAvgCob->Expression = "FORMATNUMERIC('$0.00', 0)";
          else
            report_form->exprAugAvgCob->Expression = string("FORMATNUMERIC('$##,###0.00', " + result_map["total_obligated"] + "/" + result_map["total_cobs"] + ")").c_str();
        }
        else if(i == 9)
        {
          sql += "30/" + year + "'";
          SqlToMap(dbTransaction, sql, result_map);
          if(result_map["total_obligated"] == "")
            result_map["total_obligated"] = "0";
          total += StringToFinancial(result_map["total_obligated"]);
          report_form->exprSepObg->Expression = string("FORMATNUMERIC('$###,###0.00', " + result_map["total_obligated"] + ")").c_str();
          report_form->exprSepClients->Expression = string("FORMATNUMERIC('0', " + result_map["total_people"] + ")").c_str();
          report_form->exprSepCob->Expression = string("FORMATNUMERIC('0', " + result_map["total_cobs"] + ")").c_str();
          if(result_map["total_cobs"] == "0")
            report_form->exprSepAvgCob->Expression = "FORMATNUMERIC('$0.00', 0)";
          else
            report_form->exprSepAvgCob->Expression = string("FORMATNUMERIC('$##,###0.00', " + result_map["total_obligated"] + "/" + result_map["total_cobs"] + ")").c_str();
        }
        else if(i == 10)
        {
          sql += "31/" + year + "'";
          SqlToMap(dbTransaction, sql, result_map);
          if(result_map["total_obligated"] == "")
            result_map["total_obligated"] = "0";
          total += StringToFinancial(result_map["total_obligated"]);
          report_form->exprOctObg->Expression = string("FORMATNUMERIC('$###,###0.00', " + result_map["total_obligated"] + ")").c_str();
          report_form->exprOctClients->Expression = string("FORMATNUMERIC('0', " + result_map["total_people"] + ")").c_str();
          report_form->exprOctCob->Expression = string("FORMATNUMERIC('0', " + result_map["total_cobs"] + ")").c_str();
          if(result_map["total_cobs"] == "0")
            report_form->exprOctAvgCob->Expression = "FORMATNUMERIC('$0.00', 0)";
          else
            report_form->exprOctAvgCob->Expression = string("FORMATNUMERIC('$##,###0.00', " + result_map["total_obligated"] + "/" + result_map["total_cobs"] + ")").c_str();
        }
        else if(i == 11)
        {
          sql += "30/" + year + "'";
          SqlToMap(dbTransaction, sql, result_map);
          if(result_map["total_obligated"] == "")
            result_map["total_obligated"] = "0";
          total += StringToFinancial(result_map["total_obligated"]);
          report_form->exprNovObg->Expression = string("FORMATNUMERIC('$###,###0.00', " + result_map["total_obligated"] + ")").c_str();
          report_form->exprNovClients->Expression = string("FORMATNUMERIC('0', " + result_map["total_people"] + ")").c_str();
          report_form->exprNovCob->Expression = string("FORMATNUMERIC('0', " + result_map["total_cobs"] + ")").c_str();
          if(result_map["total_cobs"] == "0")
            report_form->exprNovAvgCob->Expression = "FORMATNUMERIC('$0.00', 0)";
          else
            report_form->exprNovAvgCob->Expression = string("FORMATNUMERIC('$##,###0.00', " + result_map["total_obligated"] + "/" + result_map["total_cobs"] + ")").c_str();
        }
        else if(i == 12)
        {
          sql += "31/" + year + "'";
          SqlToMap(dbTransaction, sql, result_map);
          if(result_map["total_obligated"] == "")
            result_map["total_obligated"] = "0";
          total += StringToFinancial(result_map["total_obligated"]);
          report_form->exprDecObg->Expression = string("FORMATNUMERIC('$###,###0.00', " + result_map["total_obligated"] + ")").c_str();
          report_form->exprDecClients->Expression = string("FORMATNUMERIC('0', " + result_map["total_people"] + ")").c_str();
          report_form->exprDecCob->Expression = string("FORMATNUMERIC('0', " + result_map["total_cobs"] + ")").c_str();
          if(result_map["total_cobs"] == "0")
            report_form->exprDecAvgCob->Expression = "FORMATNUMERIC('$0.00', 0)";
          else
            report_form->exprDecAvgCob->Expression = string("FORMATNUMERIC('$##,###0.00', " + result_map["total_obligated"] + "/" + result_map["total_cobs"] + ")").c_str();
        }
      }
      report_form->exprTotalObg->Expression = string("FORMATNUMERIC('$#,###,###0.00'," +  FinancialToString(total, false) + ")").c_str();

      // TODO: why are there varying numbers of # marks in the above FORMATNUMERICs? does it clip? should it?

      Processing(false);
      report_form->report->Preview();
      FORM_CATCH
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchMontlyObligatedReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

