//---------------------------------------------------------------------------

#ifndef launchPatientHealthSummaryH
#define launchPatientHealthSummaryH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "launchGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include "codeRubberContainer.h"
#include "html_reporting.h"
//---------------------------------------------------------------------------
class TformLaunchPatientHealthSummary : public TformLaunchGeneric
{
__published:	// IDE-managed Components
        TLabel *lblVisits1;
        TLabel *lblVisits2;
        TEdit *editVisits;
        TRadioButton *radioMyDepartment;
        TRadioButton *radioAnyDepartment;
        TRubberContainer *rubberGroups;
        TListView *listGroups;
        TLabel *lblChart;
        TComboBox *cboClinic;
protected:
        bool IsValidOnScreen();
        bool RunReport();
        bool BeforeRunReport();
        bool AfterRunReport();
private:	// User declarations
        set<string> person_ids;
        classFilterObject group_filter;
        set<string> general_group_permissions;
        void htmlAddPerson(ostream & o, map<string, string> person_row, bool new_page);
        void htmlAddConditions(ostream & o, vector<map<string, string> > condition_rows);
        void htmlAddProcedures(ostream & o, vector<map<string, string> > procedure_rows);
        void htmlAddMeasurements(ostream & o, vector<map<string, string> > measurement_rows);
public:		// User declarations
        __fastcall TformLaunchPatientHealthSummary(TComponent* Owner, set<string> &p_person_ids);
        __fastcall virtual ~TformLaunchPatientHealthSummary();
        static void Do(set<string> &p_person_ids);
};
//---------------------------------------------------------------------------
extern PACKAGE TformLaunchPatientHealthSummary *formLaunchPatientHealthSummary;
//---------------------------------------------------------------------------
#endif


