//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "derivedheaders.h"
#include "launchPatientLoadByDepartment.h"
#include "reportPatientLoadByDepartment.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchPatientLoadByDepartmentReport *formLaunchPatientLoadByDepartmentReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchPatientLoadByDepartmentReport::TformLaunchPatientLoadByDepartmentReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  lookupTables->RegisterComboBox("groups", cboDepartment);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchPatientLoadByDepartmentReport::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchPatientLoadByDepartmentReport::FormClose(TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("groups", cboDepartment);
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchPatientLoadByDepartmentReport::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchPatientLoadByDepartmentReport::btnRunClick(TObject *Sender)
{
  if (!lookupTables->IsInLookUpTable("groups", cboDepartment->Text.c_str()) || cboDepartment->Text == "")
  {
    PSay("Please enter a valid department.", m_invalid_data, MB_OK);
    return;
  }
  if (!radioTotalVisits->Checked && !radioTotalPeople->Checked && !radioAverageVisits->Checked && !radioAveragePeople->Checked &&
      !radioAppointmentOutcomes->Checked)
  {
    PSay("Check at least one of the boxes to choose which report(s) to run.", m_invalid_data, MB_OK);
    return;
  }

  if (cboDepartment->Text == "Behavioral Health")
  {
   if (optionsPermissions["table.tasks.beh"]["view"] != "true")
   {
     PSay("You do not have permission to view Behavioral Health tasks/visits.", m_invalid_data, MB_OK);
     return;
   }
  }
  else if (cboDepartment->Text == "Caregiver Support Program")
  {
   if (optionsPermissions["table.tasks.care"]["view"] != "true")
   {
     PSay("You do not have permission to view Caregiver tasks/visits.", m_invalid_data, MB_OK);
     return;
   }
  }
  else if (cboDepartment->Text == "Contract Health")
  {
   if (optionsPermissions["table.tasks.cob"]["view"] != "true")
   {
     PSay("You do not have permission to view Contract Health tasks/visits.", m_invalid_data, MB_OK);
     return;
   }
  }
  else if (cboDepartment->Text == "Community Health")
  {
   if (optionsPermissions["table.tasks.com"]["view"] != "true")
   {
     PSay("You do not have permission to view Community Health tasks/visits.", m_invalid_data, MB_OK);
     return;
   }
  }
  else if (cboDepartment->Text == "Dental Clinic")
  {
   if (optionsPermissions["table.tasks.den"]["view"] != "true")
   {
     PSay("You do not have permission to view dental clinic tasks/visits.", m_invalid_data, MB_OK);
     return;
   }
  }
  else if (cboDepartment->Text == "Diabetes")
  {
   if (optionsPermissions["table.tasks.diab"]["view"] != "true")
   {
     PSay("You do not have permission to view diabetes tasks/visits.", m_invalid_data, MB_OK);
     return;
   }
  }
  else if (cboDepartment->Text == "Little Axe Clinic")
  {
   if (optionsPermissions["table.tasks.lac"]["view"] != "true")
   {
     PSay("You do not have permission to view these medical clinic tasks/visits.", m_invalid_data, MB_OK);
     return;
   }
  }
  else if (cboDepartment->Text == "Shawnee Clinic")
  {
   if (optionsPermissions["table.tasks.sc"]["view"] != "true")
   {
     PSay("You do not have permission to view these medical clinic tasks/visits.", m_invalid_data, MB_OK);
     return;
   }
  }
  else if (cboDepartment->Text == "Public Health")
  {
   if (optionsPermissions["table.tasks.pub"]["view"] != "true")
   {
     PSay("You do not have permission to view Public Health Nursing tasks/visits.", m_invalid_data, MB_OK);
     return;
   }
  }
  else if (cboDepartment->Text == "Transportation")
  {
   if (optionsPermissions["table.tasks.trans"]["view"] != "true")
   {
     PSay("You do not have permission to view Transportation tasks/visits.", m_invalid_data, MB_OK);
     return;
   }
  }
  else
  {
    PSay("The department you selected doesn't have tasks/visits.  If you feel this to be in error, contact us.", m_invalid_data, MB_OK);
    return;
  }

  Processing(true);

  dbTransaction = new TIBTransaction(NULL);
  dbTotDataSet = new TIBDataSet(NULL);
  dbDOWDataSet = new TIBDataSet(NULL);
  dbMOYDataSet = new TIBDataSet(NULL);
  dbWOYDataSet = new TIBDataSet(NULL);

  string sql, sub_sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;
  string sel_group_id = lookupTables->IdOf("groups", cboDepartment->Text.c_str());

  bool is_visits = radioTotalVisits->Checked || radioAverageVisits->Checked;
  bool is_outcomes = radioAppointmentOutcomes->Checked;

  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbTotDataSet->Database = dbDatabase;
    dbTotDataSet->Transaction = dbTransaction;
    dbTotDataSet->UniDirectional = false;
    dbDOWDataSet->Database = dbDatabase;
    dbDOWDataSet->Transaction = dbTransaction;
    dbDOWDataSet->UniDirectional = false;
    dbMOYDataSet->Database = dbDatabase;
    dbMOYDataSet->Transaction = dbTransaction;
    dbMOYDataSet->UniDirectional = false;
    dbWOYDataSet->Database = dbDatabase;
    dbWOYDataSet->Transaction = dbTransaction;
    dbWOYDataSet->UniDirectional = false;
    dbTransaction->StartTransaction();
    TformReportPatientLoadByDepartment * pt_load = NULL;
    FORM_TRY
      pt_load = new TformReportPatientLoadByDepartment(NULL, radioAppointmentOutcomes->Enabled);
    FORM_CATCH
    pt_load->lblDateTitle->Caption = date_title.c_str();
    pt_load->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();

    sql = "delete from temp_governor_people";
    if (!ExecuteStatement(dbTransaction, sql))
      throw(1);
    /* TODO -c FIX: At some point, task screens should probably be updated to provide a mechanism, be it manual
       or automatic, to fill in the provider based on the user, and make it required if the task is with a person.
       For example, a >> button like on the appointments record screen. */
    // jhaley 20120105 - this is causing serious problems running this report. Disabled for now (or possibly forever).
    #if 0
    sql = "update tasks set tax_entity_id = (select tax_entity_id from users where users.id = tasks.user_id) "
          "where tasks.tax_entity_id = 0 and tasks.user_id > 0";
    if (!ExecuteStatement(dbTransaction, sql))
      throw(2);
    #endif
    sql = "delete from temp_governor_tasks";
    if (!ExecuteStatement(dbTransaction, sql))
      throw(3);

    if (!radioAppointmentOutcomes->Checked)
    {
      sql = "insert into temp_governor_tasks "
            "select * from view_governor_tasks where task_date between '" + begin_date + "' and '" + end_date + "' "
            //"and tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "')"; // what?  why??
            "and group_id = '" + sel_group_id + "'";
    }
    else // jhaley 20101001: Load by appointment outcome - this can just barely squeak by with using the same temp table.
    {
      // jhaley 201011102: Expecting appointment tax entities to have services provided that make sense for their department
      // is not working (I didn't notice this during initial testing somehow), so until/unless that can be fixed, an
      // alternate solution is necessary. For now, at least, it should suffice to use the service areas that a particular
      // group would find relevant as insurance coverage. In the long run this is not a good solution.
      string service_areas = " and 1 "; // Default: don't care about area_id at all. If any insurance appears we call them insured.
      vector<string> relevant_area_types;
      if (sel_group_id == lookupTables->IdOf("groups", "Behavioral Health")) // Behavioral
      {
        relevant_area_types.push_back(lookupTables->IdOf("area_types", "Medical"));
        relevant_area_types.push_back(lookupTables->IdOf("area_types", "Prescription"));
        relevant_area_types.push_back(lookupTables->IdOf("area_types", "Psych Inpatient"));
        relevant_area_types.push_back(lookupTables->IdOf("area_types", "Out-of-Network"));
      }
      else if (sel_group_id == lookupTables->IdOf("groups", "Shawnee Clinic") || // Medical clinic groups
               sel_group_id == lookupTables->IdOf("groups", "Little Axe Clinic"))
      {
        relevant_area_types.push_back(lookupTables->IdOf("area_types", "Vision"));
        relevant_area_types.push_back(lookupTables->IdOf("area_types", "Medical"));
        relevant_area_types.push_back(lookupTables->IdOf("area_types", "Hearing"));
        relevant_area_types.push_back(lookupTables->IdOf("area_types", "Prescription"));
        relevant_area_types.push_back(lookupTables->IdOf("area_types", "Out-of-Network"));
      }
      else if (sel_group_id == lookupTables->IdOf("groups", "Dental Clinic")) // Dental
      {
        relevant_area_types.push_back(lookupTables->IdOf("area_types", "Dental"));
        // TODO: what about "Orthodontics" coverage? The manual report doesn't consider it so I'm not either, for now.
      }
      // All other groups will just use all insurance. Don't know what might be relevant to the areas they cover, so
      // trying to restrict it is pointless without such info.

      if (!relevant_area_types.empty())
        service_areas = " and " + SafeInClause("IIB.area_id", relevant_area_types) + " ";

      sql = "insert into temp_governor_tasks (task_id, task_dow, task_woy, task_moy, task_date, task_time, tax_entity_id, group_id, person_id, is_insured) "
            "select appointments.id, "
            " case extract(weekday from appointments.begin_date) "
            " when 0 then 'Sunday' when 1 then 'Monday' when 2 then 'Tuesday' when 3 then 'Wednesday' when 4 then 'Thursday' when 5 then 'Friday' "
            " when 6 then 'Saturday' else '' end, "
            " extract(week from appointments.begin_date), extract(month from appointments.begin_date), "
            " appointments.begin_date, appointments.appointment_time, "
            " case when (appointments.tax_entity_id is null or appointments.tax_entity_id = 0) then "
            "  (select users.tax_entity_id from users where users.id = appointments.created_for) else appointments.tax_entity_id end, "
            " appointments.group_id, appointments.person_id, "
            " case when exists "
            " (select IIC.id "                          // jhaley 20101213: use "new" insurance logic adapted from 2010 annual report, as requested by Paul.
            "  from insurance_coverage IIC "            // TODO : use "newer" logic w/creation_stamp field
            "  inner join insurance_policies IIP on IIC.insurance_policy_id = IIP.id "
            "  inner join insurance_benefits IIB on IIB.insurance_policy_id = IIP.id "
            "   and IIB.is_covered = 1 " + service_areas + " "    // jhaley: service areas workaround.
            "  where IIC.person_id = appointments.person_id and "
            "  (IIC.start_date <= appointments.begin_date or (IIC.start_date is null and IIC.last_update_stamp <= appointments.begin_date)) and "
            "  (IIC.stop_date  >  appointments.begin_date or (IIC.stop_date  is null and IIC.current_id+1 > 3)) and "
            "  (IIP.stop_date  >  appointments.begin_date or (IIP.stop_date  is null and IIP.current_id+1 > 3))) "
            " then 1 else 0 end "
            "from appointments "                       // jhaley 20101213: person_id > 0 excludes 'new patient' no shows...
            "where appointments.current_id+1 > 3 and " // jhaley 20110720: ...so now we exclude Block Schedule appointments.
            "appointments.appt_reason_id <> " + lookupTables->IdOf("appt_reason_types", "Block Schedule") + " and "
            "appointments.begin_date between '" + begin_date + "' and '" + end_date + "' and "
            "appointments.group_id = '" + sel_group_id + "'";
    }

    DebugSql(this, &sql, other_forms, 9, dbTransaction);
    if (!ExecuteStatement(dbTransaction, sql))
      throw(4);


    sql = "insert into temp_governor_people "
          "select * from view_governor_people";
    if (!ExecuteStatement(dbTransaction, sql))
      throw(5);


    sql = "select cast(count(distinct task_date) as decimal(5,2)) active_days "
          "from view_governor_tasks2 "
          //"where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "')"; // what?  why??
          "where group_id = '" + sel_group_id + "'";

    QueryData(this, dbTransaction, sql);
    string active_days = GetOneField(dbTransaction, sql);

    vector<string> active_users;
    sql = "select distinct outer_T.tax_entity_id "
          "from view_governor_tasks2 outer_T "
          // "where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "')" // what?  why??
          "where outer_T.group_id = '" + sel_group_id + "' "
          "and outer_T.tax_entity_id > 0 order by "
          "(select count(*) "
           "from view_governor_tasks2 inner_T "
           "where inner_T.tax_entity_id = outer_T.tax_entity_id "
           "and inner_T.group_id = '" + sel_group_id + "') desc";
    DebugSql(this, &sql, other_forms, 9, dbTransaction);
    if (!SqlToVec(dbTransaction, sql, active_users))
      throw(5);

    if (radioTotalVisits->Checked)
    { // TOTAL VISITS
      pt_load->lblTitle->Caption = ("Patient Load by Total Visits - " + string(cboDepartment->Text.c_str())).c_str();
      pt_load->lblTotalsSection->Caption = "Total Daily Visits";
      pt_load->lblDOWSection->Caption = "Total Daily Visits by Day of the Week";
      pt_load->lblMOYSection->Caption = "Total Daily Visits by Month of the Year";
      pt_load->lblWOYSection->Caption = "Total Daily Visits by Week of the Year";
      sql =  "select "
             "count(*) visits, "
             "count(case when is_tribal = 1 then 1 else NULL end) ast, "
             "count(case when is_tribal = 1 and is_insured = 1 then 1 else NULL end) ast_ins, "
             "count(case when is_tribal = 0 then person_id else NULL end) nonast, "
             "count(case when is_tribal = 0 and is_insured = 1 then 1 else NULL end) nonast_ins, "
             "count(case when is_diabetic = 1 then person_id else NULL end) diabetic, "
             "count(case when is_diabetic = 1 and is_insured = 1 then 1 else NULL end) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(case when tax_entity_id = '" + active_users[i] + "' then person_id else NULL end) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 "
      //"where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "') "; // what?  why?
      "where group_id = '" + sel_group_id + "'";


      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbTotDataSet->SelectSQL->Add(sql.c_str());
      dbTotDataSet->Open();
      dbTotDataSet->First();

      sql =  "select "
             "task_dow, "
             "count(*) visits, "
             "count(case when is_tribal = 1 then 1 else NULL end) ast, "
             "count(case when is_tribal = 1 and is_insured = 1 then 1 else NULL end) ast_ins, "
             "count(case when is_tribal = 0 then person_id else NULL end) nonast, "
             "count(case when is_tribal = 0 and is_insured = 1 then 1 else NULL end) nonast_ins, "
             "count(case when is_diabetic = 1 then person_id else NULL end) diabetic, "
             "count(case when is_diabetic = 1 and is_insured = 1 then 1 else NULL end) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(case when tax_entity_id = '" + active_users[i] + "' then person_id else NULL end) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 left join dow_types on UPPER(task_dow) = UPPER(dow_types.item) "
             //" where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "') " // what?  why?
             "where group_id = '" + sel_group_id + "' "
             " group by dow_types.id, task_dow order by dow_types.id ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbDOWDataSet->SelectSQL->Add(sql.c_str());
      dbDOWDataSet->Open();
      dbDOWDataSet->First();

      sql =  "select "
             "extract(year from task_date) task_year, task_moy, "
             "count(*) visits, "
             "count(case when is_tribal = 1 then 1 else NULL end) ast, "
             "count(case when is_tribal = 1 and is_insured = 1 then 1 else NULL end) ast_ins, "
             "count(case when is_tribal = 0 then person_id else NULL end) nonast, "
             "count(case when is_tribal = 0 and is_insured = 1 then 1 else NULL end) nonast_ins, "
             "count(case when is_diabetic = 1 then person_id else NULL end) diabetic, "
             "count(case when is_diabetic = 1 and is_insured = 1 then 1 else NULL end) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(case when tax_entity_id = '" + active_users[i] + "' then person_id else NULL end) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 "
              //"where tax_entity_id in (select tax_entity_id from user where group_id = '" + sel_group_id + "') " // what?  why?
             "where group_id = '" + sel_group_id + "' "
             "group by 1, 2 order by 1, 2 ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbMOYDataSet->SelectSQL->Add(sql.c_str());
      dbMOYDataSet->Open();
      dbMOYDataSet->First();

      sql =  "select "
             "extract(year from task_date) task_year, task_woy, "
             "count(*) visits, " //whoops! / cast(count(distinct task_date) as decimal(5,2)) visits, "
             "count(case when is_tribal = 1 then 1 else NULL end) ast, "
             "count(case when is_tribal = 1 and is_insured = 1 then 1 else NULL end) ast_ins, "
             "count(case when is_tribal = 0 then person_id else NULL end) nonast, "
             "count(case when is_tribal = 0 and is_insured = 1 then 1 else NULL end) nonast_ins, "
             "count(case when is_diabetic = 1 then person_id else NULL end) diabetic, "
             "count(case when is_diabetic = 1 and is_insured = 1 then 1 else NULL end) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(case when tax_entity_id = '" + active_users[i] + "' then person_id else NULL end) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 "
             //"where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "') " // what?  why?
             "where group_id = '" + sel_group_id + "' "
             "group by 1, 2 order by 1, 2 ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbWOYDataSet->SelectSQL->Add(sql.c_str());
      dbWOYDataSet->Open();
      dbWOYDataSet->First();
    } // END TOTAL VISITS
    else if (radioTotalPeople->Checked)
    { // TOTAL PEOPLE
      pt_load->lblTitle->Caption = ("Patient Load by Total Unique People - " + string(cboDepartment->Text.c_str())).c_str();
      pt_load->lblTotalsSection->Caption = "Total Unique People";
      pt_load->lblDOWSection->Caption = "Total Unique People by Day of the Week";
      pt_load->lblMOYSection->Caption = "Total Unique People by Month of the Year";
      pt_load->lblWOYSection->Caption = "Total Unique People by Week of the Year";

      sql =  "select "
             "count(distinct person_id) people, "
             "count(distinct case when is_tribal = 1 then person_id else NULL end) ast, "
             "count(distinct case when is_tribal = 1 and is_insured = 1 then person_id else NULL end) ast_ins, "
             "count(distinct case when is_tribal = 0 then person_id else NULL end) nonast, "
             "count(distinct case when is_tribal = 0 and is_insured = 1 then person_id else NULL end) nonast_ins, "
             "count(distinct case when is_diabetic = 1 then person_id else NULL end) diabetic, "
             "count(distinct case when is_diabetic = 1 and is_insured = 1 then person_id else NULL end) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(distinct case when tax_entity_id = '" + active_users[i] + "' then person_id else NULL end) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 "
             //"where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "') "; // what?  why?
             "where group_id = '" + sel_group_id + "' ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbTotDataSet->SelectSQL->Add(sql.c_str());
      dbTotDataSet->Open();
      dbTotDataSet->First();

      sql =  "select "
             "task_dow, "
             "count(distinct person_id) people, "
             "count(distinct case when is_tribal = 1 then person_id else NULL end) ast, "
             "count(distinct case when is_tribal = 1 and is_insured = 1 then person_id else NULL end) ast_ins, "
             "count(distinct case when is_tribal = 0 then person_id else NULL end) nonast, "
             "count(distinct case when is_tribal = 0 and is_insured = 1 then person_id else NULL end) nonast_ins, "
             "count(distinct case when is_diabetic = 1 then person_id else NULL end) diabetic, "
             "count(distinct case when is_diabetic = 1 and is_insured = 1 then person_id else NULL end) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(distinct case when tax_entity_id = '" + active_users[i] + "' then person_id else NULL end) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 left join dow_types on UPPER(task_dow) = UPPER(dow_types.item) "
             //" where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "') " // what?  why?
             "where group_id = '" + sel_group_id + "'"
             " group by dow_types.id, task_dow order by dow_types.id ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbDOWDataSet->SelectSQL->Add(sql.c_str());
      dbDOWDataSet->Open();
      dbDOWDataSet->First();

      sql =  "select "
             "extract(year from task_date) task_year, task_moy, "
             "count(distinct person_id) people, "
             "count(distinct case when is_tribal = 1 then person_id else NULL end) ast, "
             "count(distinct case when is_tribal = 1 and is_insured = 1 then person_id else NULL end) ast_ins, "
             "count(distinct case when is_tribal = 0 then person_id else NULL end) nonast, "
             "count(distinct case when is_tribal = 0 and is_insured = 1 then person_id else NULL end) nonast_ins, "
             "count(distinct case when is_diabetic = 1 then person_id else NULL end) diabetic, "
             "count(distinct case when is_diabetic = 1 and is_insured = 1 then person_id else NULL end) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(distinct case when tax_entity_id = '" + active_users[i] + "' then person_id else NULL end) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 "
             //"where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "') " // what?  why?
             "where group_id = '" + sel_group_id + "' "
             "group by 1, 2 order by 1, 2 ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbMOYDataSet->SelectSQL->Add(sql.c_str());
      dbMOYDataSet->Open();
      dbMOYDataSet->First();

      sql =  "select "
             "extract(year from task_date) task_year, task_woy, "
             "count(distinct person_id) people, "
             "count(distinct case when is_tribal = 1 then person_id else NULL end) ast, "
             "count(distinct case when is_tribal = 1 and is_insured = 1 then person_id else NULL end) ast_ins, "
             "count(distinct case when is_tribal = 0 then person_id else NULL end) nonast, "
             "count(distinct case when is_tribal = 0 and is_insured = 1 then person_id else NULL end) nonast_ins, "
             "count(distinct case when is_diabetic = 1 then person_id else NULL end) diabetic, "
             "count(distinct case when is_diabetic = 1 and is_insured = 1 then person_id else NULL end) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(distinct case when tax_entity_id = '" + active_users[i] + "' then person_id else NULL end) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 "
             //"where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "')" // what?  why?
             "where group_id = '" + sel_group_id + "' "
             "group by 1, 2 order by 1, 2 ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbWOYDataSet->SelectSQL->Add(sql.c_str());
      dbWOYDataSet->Open();
      dbWOYDataSet->First();
    } // END TOTAL PEOPLE
    else if (radioAverageVisits->Checked)
    { // AVERAGE VISITS
      pt_load->lblTitle->Caption = ("Patient Load by Average Daily Visits - " + string(cboDepartment->Text.c_str())).c_str();
      pt_load->lblTotalsSection->Caption = "Average Daily Visits";
      pt_load->lblDOWSection->Caption = "Average Daily Visits by Day of the Week";
      pt_load->lblMOYSection->Caption = "Average Daily Visits by Month of the Year";
      pt_load->lblWOYSection->Caption = "Average Daily Visits by Week of the Year";
      sql =  "select "
             "count(*) / cast(count(distinct task_date) as decimal(5,2)) visits, "
             "count(case when is_tribal = 1 then 1 else NULL end) / cast(count(distinct task_date) as decimal(5,2)) ast, "
             "count(case when is_tribal = 1 and is_insured = 1 then 1 else NULL end) / cast(count(distinct task_date) as decimal(5,2)) ast_ins, "
             "count(case when is_tribal = 0 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) nonast, "
             "count(case when is_tribal = 0 and is_insured = 1 then 1 else NULL end) / cast(count(distinct task_date) as decimal(5,2)) nonast_ins, "
             "count(case when is_diabetic = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) diabetic, "
             "count(case when is_diabetic = 1 and is_insured = 1 then 1 else NULL end) / cast(count(distinct task_date) as decimal(5,2)) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(case when tax_entity_id = '" + active_users[i] + "' then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 "
             //"where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "') "; // what?  why?
             "where group_id = '" + sel_group_id + "' ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbTotDataSet->SelectSQL->Add(sql.c_str());
      dbTotDataSet->Open();
      dbTotDataSet->First();

      sql =  "select "
             "task_dow, "
             "count(*) / cast(count(distinct task_date) as decimal(5,2)) visits, "
             "count(case when is_tribal = 1 then 1 else NULL end) / cast(count(distinct task_date) as decimal(5,2)) ast, "
             "count(case when is_tribal = 1 and is_insured = 1 then 1 else NULL end) / cast(count(distinct task_date) as decimal(5,2)) ast_ins, "
             "count(case when is_tribal = 0 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) nonast, "
             "count(case when is_tribal = 0 and is_insured = 1 then 1 else NULL end) / cast(count(distinct task_date) as decimal(5,2)) nonast_ins, "
             "count(case when is_diabetic = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) diabetic, "
             "count(case when is_diabetic = 1 and is_insured = 1 then 1 else NULL end) / cast(count(distinct task_date) as decimal(5,2)) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(case when tax_entity_id = '" + active_users[i] + "' then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 left join dow_types on UPPER(task_dow) = UPPER(dow_types.item) "
             //" where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "') " // what?  why?
             "where group_id = '" + sel_group_id + "' "
             " group by dow_types.id, task_dow order by dow_types.id ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbDOWDataSet->SelectSQL->Add(sql.c_str());
      dbDOWDataSet->Open();
      dbDOWDataSet->First();

      sql =  "select "
             "extract(year from task_date) task_year, task_moy, "
             "count(*) / cast(count(distinct task_date) as decimal(5,2)) visits, "
             "count(case when is_tribal = 1 then 1 else NULL end) / cast(count(distinct task_date) as decimal(5,2)) ast, "
             "count(case when is_tribal = 1 and is_insured = 1 then 1 else NULL end) / cast(count(distinct task_date) as decimal(5,2)) ast_ins, "
             "count(case when is_tribal = 0 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) nonast, "
             "count(case when is_tribal = 0 and is_insured = 1 then 1 else NULL end) / cast(count(distinct task_date) as decimal(5,2)) nonast_ins, "
             "count(case when is_diabetic = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) diabetic, "
             "count(case when is_diabetic = 1 and is_insured = 1 then 1 else NULL end) / cast(count(distinct task_date) as decimal(5,2)) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(case when tax_entity_id = '" + active_users[i] + "' then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 "
             //"where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "') " // what?  why?
             "where group_id = '" + sel_group_id + "' "
             "group by 1, 2 order by 1, 2 ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbMOYDataSet->SelectSQL->Add(sql.c_str());
      dbMOYDataSet->Open();
      dbMOYDataSet->First();

      sql =  "select "
             "extract(year from task_date) task_year, task_woy, "
             "count(*) / cast(count(distinct task_date) as decimal(5,2)) visits, "
             "count(case when is_tribal = 1 then 1 else NULL end) / cast(count(distinct task_date) as decimal(5,2)) ast, "
             "count(case when is_tribal = 1 and is_insured = 1 then 1 else NULL end) / cast(count(distinct task_date) as decimal(5,2)) ast_ins, "
             "count(case when is_tribal = 0 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) nonast, "
             "count(case when is_tribal = 0 and is_insured = 1 then 1 else NULL end) / cast(count(distinct task_date) as decimal(5,2)) nonast_ins, "
             "count(case when is_diabetic = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) diabetic, "
             "count(case when is_diabetic = 1 and is_insured = 1 then 1 else NULL end) / cast(count(distinct task_date) as decimal(5,2)) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(case when tax_entity_id = '" + active_users[i] + "' then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 "
             //"where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "') " // what?  why?
             "where group_id = '" + sel_group_id + "' "
             "group by 1, 2 order by 1, 2 ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbWOYDataSet->SelectSQL->Add(sql.c_str());
      dbWOYDataSet->Open();
      dbWOYDataSet->First();
    } // END AVERAGE VISITS
    else if (radioAveragePeople->Checked)
    { // AVERAGE PEOPLE
      pt_load->lblTitle->Caption = ("Patient Load by Average Daily Unique People - " + string(cboDepartment->Text.c_str())).c_str();
      pt_load->lblTotalsSection->Caption = "Average Daily Unique People";
      pt_load->lblDOWSection->Caption = "Average Daily Unique People by Day of the Week";
      pt_load->lblMOYSection->Caption = "Average Daily Unique People by Month of the Year";
      pt_load->lblWOYSection->Caption = "Average Daily Unique People by Week of the Year";

      sql =  "select "
             "count(distinct person_id) / cast(count(distinct task_date) as decimal(5,2)) people, "
             "count(distinct case when is_tribal = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) ast, "
             "count(distinct case when is_tribal = 1 and is_insured = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) ast_ins, "
             "count(distinct case when is_tribal = 0 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) nonast, "
             "count(distinct case when is_tribal = 0 and is_insured = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) nonast_ins, "
             "count(distinct case when is_diabetic = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) diabetic, "
             "count(distinct case when is_diabetic = 1 and is_insured = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(distinct case when tax_entity_id = '" + active_users[i] + "' then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 "
             //"where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "'); "; // what?  why?
             "where group_id = '" + sel_group_id + "' ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbTotDataSet->SelectSQL->Add(sql.c_str());
      dbTotDataSet->Open();
      dbTotDataSet->First();

      sql =  "select "
             "task_dow, "
             "count(distinct person_id) / cast(count(distinct task_date) as decimal(5,2)) people, "
             "count(distinct case when is_tribal = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) ast, "
             "count(distinct case when is_tribal = 1 and is_insured = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) ast_ins, "
             "count(distinct case when is_tribal = 0 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) nonast, "
             "count(distinct case when is_tribal = 0 and is_insured = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) nonast_ins, "
             "count(distinct case when is_diabetic = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) diabetic, "
             "count(distinct case when is_diabetic = 1 and is_insured = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(distinct case when tax_entity_id = '" + active_users[i] + "' then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 left join dow_types on UPPER(task_dow) = UPPER(dow_types.item) "
             //" where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "') " // what?  why?
             "where group_id = '" + sel_group_id + "' "
             " group by dow_types.id, task_dow order by dow_types.id ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbDOWDataSet->SelectSQL->Add(sql.c_str());
      dbDOWDataSet->Open();
      dbDOWDataSet->First();

      sql =  "select "
             "extract(year from task_date) task_year, task_moy, "
             "count(distinct person_id) / cast(count(distinct task_date) as decimal(5,2)) people, "
             "count(distinct case when is_tribal = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) ast, "
             "count(distinct case when is_tribal = 1 and is_insured = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) ast_ins, "
             "count(distinct case when is_tribal = 0 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) nonast, "
             "count(distinct case when is_tribal = 0 and is_insured = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) nonast_ins, "
             "count(distinct case when is_diabetic = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) diabetic, "
             "count(distinct case when is_diabetic = 1 and is_insured = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(distinct case when tax_entity_id = '" + active_users[i] + "' then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 "
             // "where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "') " // what?  why?
             "where group_id = '" + sel_group_id + "' "
             "group by 1, 2 order by 1, 2 ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbMOYDataSet->SelectSQL->Add(sql.c_str());
      dbMOYDataSet->Open();
      dbMOYDataSet->First();

      sql =  "select "
             "extract(year from task_date) task_year, task_woy, "
             "count(distinct person_id) / cast(count(distinct task_date) as decimal(5,2)) people, "
             "count(distinct case when is_tribal = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) ast, "
             "count(distinct case when is_tribal = 1 and is_insured = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) ast_ins, "
             "count(distinct case when is_tribal = 0 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) nonast, "
             "count(distinct case when is_tribal = 0 and is_insured = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) nonast_ins, "
             "count(distinct case when is_diabetic = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) diabetic, "
             "count(distinct case when is_diabetic = 1 and is_insured = 1 then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(distinct case when tax_entity_id = '" + active_users[i] + "' then person_id else NULL end) / cast(count(distinct task_date) as decimal(5,2)) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 "
             // "where tax_entity_id in (select tax_entity_id from users where group_id = '" + sel_group_id + "') group by task_woy; "; // what?  why?
             "where group_id = '" + sel_group_id + "' "
             "group by 1, 2 order by 1, 2 ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbWOYDataSet->SelectSQL->Add(sql.c_str());
      dbWOYDataSet->Open();
      dbWOYDataSet->First();
    } // END AVERAGE PEOPLE
    else if (radioAppointmentOutcomes->Checked) // jhaley 20101001: appointment outcomes variation
    {
      is_visits = true;

      pt_load->lblTitle->Caption = ("Patient Load by Appointment Outcomes - " + string(cboDepartment->Text.c_str())).c_str();
      pt_load->lblTotalsSection->Caption = "Total Visits By Outcome";
      pt_load->lblDOWSection->Caption = "Total Visits by Outcome, by Day of the Week";
      pt_load->lblMOYSection->Caption = "Total Visits by Outcome, by Month of the Year";
      pt_load->lblWOYSection->Caption = "Total Visits by Outcome, by Week of the Year";

      // jhaley 20101001: This is going to work a little differently in this mode... it needs grouping, so turn on all the
      // group bands full-force.
      pt_load->bandDOWGroup->Expression = "task_dow";
      pt_load->txtDOWGroupName->DataSet = dbDOWDataSet;
      pt_load->txtDOWGroupName->DataField = "task_dow";
      pt_load->bandMOYGroup->Expression = "task_moy";
      pt_load->txtMOYGroupName->DataSet = dbMOYDataSet;
      pt_load->txtMOYGroupName->DataField = "task_moy";
      pt_load->bandWOYGroup->Expression = "task_woy";
      pt_load->txtWOYGroupName->DataSet = dbWOYDataSet;
      pt_load->txtWOYGroupName->DataField = "task_woy";

      // Do the totals, PER OUTCOME.
      sql =  "select "
             "case when visit_outcome_types.item = '' then '(NOT INDICATED)' else visit_outcome_types.item end visit_outcome, "
             "count(*) visits, "
             "count(case when is_tribal = 1 then 1 else NULL end) ast, "
             "count(case when is_tribal = 1 and is_insured = 1 then 1 else NULL end) ast_ins, "
             "count(case when is_tribal = 0 then view_governor_tasks2.person_id else NULL end) nonast, "
             "count(case when is_tribal = 0 and is_insured = 1 then 1 else NULL end) nonast_ins, "
             "count(case when is_diabetic = 1 then view_governor_tasks2.person_id else NULL end) diabetic, "
             "count(case when is_diabetic = 1 and is_insured = 1 then 1 else NULL end) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(case when view_governor_tasks2.tax_entity_id = '" + active_users[i] + "' then view_governor_tasks2.person_id else NULL end) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 "
             "left join appointments on view_governor_tasks2.task_id = appointments.id "
             "left join visit_outcome_types on appointments.visit_outcome_id = visit_outcome_types.id "
             "where view_governor_tasks2.group_id = '" + sel_group_id + "' "
             "group by 1 order by 1 ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbTotDataSet->SelectSQL->Add(sql.c_str());
      dbTotDataSet->Open();
      dbTotDataSet->First();

      // Also, enable the txtVisitOutcome control and turn off the label for "Entire Date Range"
      // Note that setting an OnPrint event for the label and trying to use it for this purpose does *NOT* work, and I
      // believe it has something to do with the report compositing feature but I'm not sure - the label receives twice
      // as many OnPrint events as there are data rows and somehow only displays the last value encountered on every row.
      pt_load->lblEntireDateRange->Enabled = false;
      pt_load->txtVisitOutcome->Enabled = true;
      pt_load->txtVisitOutcome->DataSet = dbTotDataSet;
      pt_load->txtVisitOutcome->DataField = "visit_outcome";

      // Do grouping by Day of Week, AND by Outcome.
      sql =  "select "
             "task_dow, "
             "case when visit_outcome_types.item = '' then '(NOT INDICATED)' else visit_outcome_types.item end visit_outcome, "
             "count(*) visits, "
             "count(case when is_tribal = 1 then 1 else NULL end) ast, "
             "count(case when is_tribal = 1 and is_insured = 1 then 1 else NULL end) ast_ins, "
             "count(case when is_tribal = 0 then view_governor_tasks2.person_id else NULL end) nonast, "
             "count(case when is_tribal = 0 and is_insured = 1 then 1 else NULL end) nonast_ins, "
             "count(case when is_diabetic = 1 then view_governor_tasks2.person_id else NULL end) diabetic, "
             "count(case when is_diabetic = 1 and is_insured = 1 then 1 else NULL end) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(case when view_governor_tasks2.tax_entity_id = '" + active_users[i] + "' then view_governor_tasks2.person_id else NULL end) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 left join dow_types on UPPER(task_dow) = UPPER(dow_types.item) "
             "left join appointments on view_governor_tasks2.task_id = appointments.id "
             "left join visit_outcome_types on appointments.visit_outcome_id = visit_outcome_types.id "
             "where view_governor_tasks2.group_id = '" + sel_group_id + "' "
             " group by dow_types.id, task_dow, 2 order by dow_types.id, 2 ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbDOWDataSet->SelectSQL->Add(sql.c_str());
      dbDOWDataSet->Open();
      dbDOWDataSet->First();

      // Do grouping by Month of Year, AND by Outcome.
      sql =  "select "
             "extract(year from task_date) task_year, task_moy, "
             "case when visit_outcome_types.item = '' then '(NOT INDICATED)' else visit_outcome_types.item end visit_outcome, "
             "count(*) visits, "
             "count(case when is_tribal = 1 then 1 else NULL end) ast, "
             "count(case when is_tribal = 1 and is_insured = 1 then 1 else NULL end) ast_ins, "
             "count(case when is_tribal = 0 then view_governor_tasks2.person_id else NULL end) nonast, "
             "count(case when is_tribal = 0 and is_insured = 1 then 1 else NULL end) nonast_ins, "
             "count(case when is_diabetic = 1 then view_governor_tasks2.person_id else NULL end) diabetic, "
             "count(case when is_diabetic = 1 and is_insured = 1 then 1 else NULL end) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(case when view_governor_tasks2.tax_entity_id = '" + active_users[i] + "' then view_governor_tasks2.person_id else NULL end) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 "
             "left join appointments on view_governor_tasks2.task_id = appointments.id "
             "left join visit_outcome_types on appointments.visit_outcome_id = visit_outcome_types.id "
             "where view_governor_tasks2.group_id = '" + sel_group_id + "' "
             "group by 1, 2, 3 order by 1, 2, 3 ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbMOYDataSet->SelectSQL->Add(sql.c_str());
      dbMOYDataSet->Open();
      dbMOYDataSet->First();

      // Do grouping by Week of Year, AND by Outcome
      sql =  "select "
             "extract(year from task_date) task_year, task_woy, "
             "case when visit_outcome_types.item = '' then '(NOT INDICATED)' else visit_outcome_types.item end visit_outcome, "
             "count(*) visits, "
             "count(case when is_tribal = 1 then 1 else NULL end) ast, "
             "count(case when is_tribal = 1 and is_insured = 1 then 1 else NULL end) ast_ins, "
             "count(case when is_tribal = 0 then view_governor_tasks2.person_id else NULL end) nonast, "
             "count(case when is_tribal = 0 and is_insured = 1 then 1 else NULL end) nonast_ins, "
             "count(case when is_diabetic = 1 then view_governor_tasks2.person_id else NULL end) diabetic, "
             "count(case when is_diabetic = 1 and is_insured = 1 then 1 else NULL end) diabetic_ins, ";
      for (unsigned int i=0; i<active_users.size(); i++)
        sql+="count(case when view_governor_tasks2.tax_entity_id = '" + active_users[i] + "' then view_governor_tasks2.person_id else NULL end) te_" + active_users[i] + ", ";
      sql = sql.substr(0, sql.length() - 2);
      sql += " from view_governor_tasks2 "
             "left join appointments on view_governor_tasks2.task_id = appointments.id "
             "left join visit_outcome_types on appointments.visit_outcome_id = visit_outcome_types.id "
             "where view_governor_tasks2.group_id = '" + sel_group_id + "' "
             "group by 1, 2, 3 order by 1, 2, 3 ";

      DebugSql(this, &sql, other_forms, 9, dbTransaction);
      dbWOYDataSet->SelectSQL->Add(sql.c_str());
      dbWOYDataSet->Open();
      dbWOYDataSet->First();
    }

    // jhaley: If not doing appointment outcomes, turn off all group headers.
    if (!radioAppointmentOutcomes->Checked)
    {
      pt_load->bandDOWGroup->Enabled = false;
      pt_load->bandMOYGroup->Enabled = false;
      pt_load->bandWOYGroup->Enabled = false;
    }

    pt_load->reportTotalsSection->DataSet = dbTotDataSet;
    pt_load->reportDOWSection->DataSet = dbDOWDataSet;
    pt_load->reportMOYSection->DataSet = dbMOYDataSet;
    pt_load->reportWOYSection->DataSet = dbWOYDataSet;

    pt_load->txtTotalsRowTotal->DataSet = dbTotDataSet;
    pt_load->txtTotalsRowTotal->DataField = is_visits ? "visits" : "people";
    pt_load->txtTotalsAST->DataSet = dbTotDataSet;
    pt_load->txtTotalsAST->DataField = "ast";
    pt_load->txtTotalsInsuredAST->DataSet = dbTotDataSet;
    pt_load->txtTotalsInsuredAST->DataField = "ast_ins";
    pt_load->txtTotalsNonAST->DataSet = dbTotDataSet;
    pt_load->txtTotalsNonAST->DataField = "nonast";
    pt_load->txtTotalsInsuredNonAST->DataSet = dbTotDataSet;
    pt_load->txtTotalsInsuredNonAST->DataField = "nonast_ins";
    pt_load->txtTotalsDiabetic->DataSet = dbTotDataSet;
    pt_load->txtTotalsDiabetic->DataField = "diabetic";
    pt_load->txtTotalsInsuredDiabetic->DataSet = dbTotDataSet;
    pt_load->txtTotalsInsuredDiabetic->DataField = "diabetic_ins";

    pt_load->txtDOWRowName->DataSet = dbDOWDataSet;
    pt_load->txtDOWRowName->DataField = !is_outcomes ? "task_dow" : "visit_outcome";
    pt_load->txtDOWRowTotal->DataSet = dbDOWDataSet;
    pt_load->txtDOWRowTotal->DataField = is_visits ? "visits" : "people";
    pt_load->txtDOWAST->DataSet = dbDOWDataSet;
    pt_load->txtDOWAST->DataField = "ast";
    pt_load->txtDOWInsuredAST->DataSet = dbDOWDataSet;
    pt_load->txtDOWInsuredAST->DataField = "ast_ins";
    pt_load->txtDOWNonAST->DataSet = dbDOWDataSet;
    pt_load->txtDOWNonAST->DataField = "nonast";
    pt_load->txtDOWInsuredNonAST->DataSet = dbDOWDataSet;
    pt_load->txtDOWInsuredNonAST->DataField = "nonast_ins";
    pt_load->txtDOWDiabetic->DataSet = dbDOWDataSet;
    pt_load->txtDOWDiabetic->DataField = "diabetic";
    pt_load->txtDOWInsuredDiabetic->DataSet = dbDOWDataSet;
    pt_load->txtDOWInsuredDiabetic->DataField = "diabetic_ins";

    pt_load->txtMOYRowName->DataSet = dbMOYDataSet;
    pt_load->txtMOYRowName->DataField = !is_outcomes ? "task_moy" : "visit_outcome";
    pt_load->txtMOYRowTotal->DataSet = dbMOYDataSet;
    pt_load->txtMOYRowTotal->DataField = is_visits ? "visits" : "people";
    pt_load->txtMOYAST->DataSet = dbMOYDataSet;
    pt_load->txtMOYAST->DataField = "ast";
    pt_load->txtMOYInsuredAST->DataSet = dbMOYDataSet;
    pt_load->txtMOYInsuredAST->DataField = "ast_ins";
    pt_load->txtMOYNonAST->DataSet = dbMOYDataSet;
    pt_load->txtMOYNonAST->DataField = "nonast";
    pt_load->txtMOYInsuredNonAST->DataSet = dbMOYDataSet;
    pt_load->txtMOYInsuredNonAST->DataField = "nonast_ins";
    pt_load->txtMOYDiabetic->DataSet = dbMOYDataSet;
    pt_load->txtMOYDiabetic->DataField = "diabetic";
    pt_load->txtMOYInsuredDiabetic->DataSet = dbMOYDataSet;
    pt_load->txtMOYInsuredDiabetic->DataField = "diabetic_ins";

    pt_load->txtWOYRowName->DataSet = dbWOYDataSet;
    pt_load->txtWOYRowName->DataField = !is_outcomes ? "task_woy" : "visit_outcome";
    pt_load->txtWOYRowTotal->DataSet = dbWOYDataSet;
    pt_load->txtWOYRowTotal->DataField = is_visits ? "visits" : "people";
    pt_load->txtWOYAST->DataSet = dbWOYDataSet;
    pt_load->txtWOYAST->DataField = "ast";
    pt_load->txtWOYInsuredAST->DataSet = dbWOYDataSet;
    pt_load->txtWOYInsuredAST->DataField = "ast_ins";
    pt_load->txtWOYNonAST->DataSet = dbWOYDataSet;
    pt_load->txtWOYNonAST->DataField = "nonast";
    pt_load->txtWOYInsuredNonAST->DataSet = dbWOYDataSet;
    pt_load->txtWOYInsuredNonAST->DataField = "nonast_ins";
    pt_load->txtWOYDiabetic->DataSet = dbWOYDataSet;
    pt_load->txtWOYDiabetic->DataField = "diabetic";
    pt_load->txtWOYInsuredDiabetic->DataSet = dbWOYDataSet;
    pt_load->txtWOYInsuredDiabetic->DataField = "diabetic_ins";

    int text_left = pt_load->txtTotalsInsuredDiabetic->Left + pt_load->txtTotalsInsuredDiabetic->Width + 8;
    int text_width = pt_load->txtTotalsInsuredDiabetic->Width + 0;

    TQRLabel  *newest_column_header = NULL;
    TQRDBText *newest_column_value  = NULL;

    for (unsigned int i=0; i<active_users.size(); i++)
    {
      string employee_name_sql = "select first_name || ' ' || last_name from people inner join users on users.person_id = people.id "
                                 "inner join person_names on people.person_names_id = person_names.id "
                                 "where users.tax_entity_id = '" + active_users[i] + "'";

      newest_column_header               = new TQRLabel(pt_load->reportTop);
      newest_column_header->Parent       = pt_load->bandTitleChild;
      newest_column_header->Caption      = PrettyString(GetOneField(dbTransaction, employee_name_sql)).c_str();
      newest_column_header->AutoSize     = false;
      newest_column_header->AutoStretch  = true;
      newest_column_header->Left         = text_left;
      newest_column_header->Width        = text_width;
      newest_column_header->Top          = 2;
      newest_column_header->Height       = 16;
      newest_column_header->Transparent  = true;
      newest_column_header->Alignment    = taRightJustify;
      newest_column_header->WordWrap     = true;
      newest_column_header->Font->Name   = "Arial Narrow";
      newest_column_header->Font->Size   = 9;

      newest_column_value                = new TQRDBText(this);
      newest_column_value->Parent        = pt_load->bandTotalsDetail;
      newest_column_value->AutoSize      = false;
      newest_column_value->AutoStretch   = false;
      newest_column_value->Left          = text_left;
      newest_column_value->Width         = text_width;
      newest_column_value->Top           = 2;
      newest_column_value->Height        = 16;
      newest_column_value->Transparent   = true;
      newest_column_value->Alignment     = taRightJustify;
      newest_column_value->WordWrap      = true;
      newest_column_value->Font->Size    = 8;
      newest_column_value->DataSet       = dbTotDataSet;
      newest_column_value->DataField     = ("te_" + active_users[i]).c_str();

      newest_column_value                = new TQRDBText(this);
      newest_column_value->Parent        = pt_load->bandDOWDetail;
      newest_column_value->AutoSize      = false;
      newest_column_value->AutoStretch   = false;
      newest_column_value->Left          = text_left;
      newest_column_value->Width         = text_width;
      newest_column_value->Top           = 2;
      newest_column_value->Height        = 16;
      newest_column_value->Transparent   = true;
      newest_column_value->Alignment     = taRightJustify;
      newest_column_value->WordWrap      = true;
      newest_column_value->Font->Size    = 8;
      newest_column_value->DataSet       = dbDOWDataSet;
      newest_column_value->DataField     = ("te_" + active_users[i]).c_str();

      newest_column_value                = new TQRDBText(this);
      newest_column_value->Parent        = pt_load->bandMOYDetail;
      newest_column_value->AutoSize      = false;
      newest_column_value->AutoStretch   = false;
      newest_column_value->Left          = text_left;
      newest_column_value->Width         = text_width;
      newest_column_value->Top           = 2;
      newest_column_value->Height        = 16;
      newest_column_value->Transparent   = true;
      newest_column_value->Alignment     = taRightJustify;
      newest_column_value->WordWrap      = true;
      newest_column_value->Font->Size    = 8;
      newest_column_value->DataSet       = dbMOYDataSet;
      newest_column_value->DataField     = ("te_" + active_users[i]).c_str();

      newest_column_value                = new TQRDBText(this);
      newest_column_value->Parent        = pt_load->bandWOYDetail;
      newest_column_value->AutoSize      = false;
      newest_column_value->AutoStretch   = false;
      newest_column_value->Left          = text_left;
      newest_column_value->Width         = text_width;
      newest_column_value->Top           = 2;
      newest_column_value->Height        = 16;
      newest_column_value->Transparent   = true;
      newest_column_value->Alignment     = taRightJustify;
      newest_column_value->WordWrap      = true;
      newest_column_value->Font->Size    = 8;
      newest_column_value->DataSet       = dbWOYDataSet;
      newest_column_value->DataField     = ("te_" + active_users[i]).c_str();

      text_left += (text_width + 1);
    }

    Processing(false);
    pt_load->compositeReport->Prepare();
    pt_load->compositeReport->Preview();
    pt_load->CloseNow();
    dbTotDataSet->Close();
    dbDOWDataSet->Close();
    dbMOYDataSet->Close();
    dbWOYDataSet->Close();

    ExecuteStatement(dbTransaction, "delete from temp_governor_tasks");
    ExecuteStatement(dbTransaction, "delete from temp_governor_people");
    dbTransaction->Commit();
  }
  catch (int i)
  {
    Processing(false);
    PSay("Error running report.  Error number: " + IntToString(i), m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report.  Unknown error.", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbTotDataSet;
  delete dbDOWDataSet;
  delete dbMOYDataSet;
  delete dbWOYDataSet;
}
//---------------------------------------------------------------------------


