//---------------------------------------------------------------------------

#ifndef launchPendingAccountsReportH
#define launchPendingAccountsReportH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>
#include <CheckLst.hpp>

#define placeholder_from  string("@@from@@")
#define placeholder_where string("@@where@@")

struct recursive_data_source
{
 string table_and_alias;
 string where_clause;
 string wanted_fields;
 string exists_value;
 bool   is_visited;
 recursive_data_source () {is_visited = false;}
 recursive_data_source (string t_and_a, string where, string fields, string exists, bool visited)
  {table_and_alias = t_and_a; where_clause = where; wanted_fields = fields; exists_value = exists; is_visited = visited;}
};

struct recursive_data_source_link
{
 string a_source_name;
 string b_source_name;
 string join_clause;
 recursive_data_source_link (string source_a, string source_b, string join)
  {a_source_name = source_a; b_source_name = source_b; join_clause = join;}
};

string RecursiveTableJoinSqlGenerator (map<string, recursive_data_source> & source_tables,
                                       vector<recursive_data_source_link> & source_joins,
                                       string this_source,
                                       bool is_root_node);

//---------------------------------------------------------------------------
class TformLaunchPendingAccountsReport : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TToolButton *buttonRun;
        TToolButton *buttonClose;
        TGroupBox *groupType;
        TGroupBox *groupMisc;
        TCheckBox *checkShowItems;
        TComboBox *comboAccountType;
        TGroupBox *groupSources;
        TLabel *_labelParent;
        TGroupBox *groupBills;
        TCheckBox *checkBillsVisits;
        TCheckBox *checkBillsCoords;
        TCheckBox *checkBillsPurchaseReqs;
        TCheckBox *checkBillsChecks;
        TGroupBox *groupVisits;
        TCheckBox *checkVisitsCoords;
        TCheckBox *checkVisitsBills;
        TCheckBox *checkVisitsPurchaseReqs;
        TCheckBox *checkVisitsChecks;
        TGroupBox *groupNone;
        TListView *listSources;
        TButton *buttonSourcesAdd;
        TButton *buttonSourcesRemove;
        TButton *buttonSourcesClear;
        TButton *buttonSourcesSave;
        TComboBox *comboParent;
        TGroupBox *groupCoords;
        TCheckBox *checkCoordsVisits;
        TCheckBox *checkCoordsBills;
        TCheckBox *checkCoordsPurchaseReqs;
        TCheckBox *checkCoordsChecks;
        TGroupBox *groupDays;
        TLabel *_labelDay;
        TListView *listDays;
        TButton *buttonDaysAdd;
        TButton *buttonDaysRemove;
        TButton *buttonDaysClear;
        TButton *buttonDaysSave;
        TEdit *editDayNumber;
        TLabel *_labelAccountType;
        TCheckBox *checkShowItemTotal;
        TLabel *_labelAccountTypeTotals;
        TRadioButton *radioShowByItems;
        TRadioButton *radioShowByTotals;
        TRadioButton *radioShowByEither;
        TListView *listAccountTypes;
        TRadioButton *radioShowByBoth;
        void __fastcall buttonDaysAddClick(TObject *Sender);
        void __fastcall buttonDaysRemoveClick(TObject *Sender);
        void __fastcall buttonDaysClearClick(TObject *Sender);
        void __fastcall buttonDaysSaveClick(TObject *Sender);
        void __fastcall buttonRunClick(TObject *Sender);
        void __fastcall buttonCloseClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall buttonSourcesAddClick(TObject *Sender);
        void __fastcall buttonSourcesRemoveClick(TObject *Sender);
        void __fastcall buttonSourcesClearClick(TObject *Sender);
        void __fastcall comboParentChange(TObject *Sender);
        void __fastcall buttonSourcesSaveClick(TObject *Sender);
private:	// User declarations
        map<string, recursive_data_source> all_source_tables;
        vector<recursive_data_source_link> all_source_links;
        classFilterObject filter_account_types;

        edit_listview edit_days;
        edit_listview edit_sources;
        void DayRowSelected ();
        void DataSourceSelected ();

        TCheckBoxState StateByNumber (string c_num);
        string         NumberByState (TCheckBoxState c_state);
public:		// User declarations
        __fastcall TformLaunchPendingAccountsReport(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TformLaunchPendingAccountsReport *formLaunchPendingAccountsReport;
//---------------------------------------------------------------------------
#endif
