//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchPendingShoeReport.h"
#include "reportPendingShoe.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchPendingShoeReport *formLaunchPendingShoeReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchPendingShoeReport::TformLaunchPendingShoeReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchPendingShoeReport::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchPendingShoeReport::btnRunClick(TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string date_title = CurrentDate();

  try
  {
    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    sql = "select ST.item || SST.item group_field, ST.item shoe_type, SST.item shoe_size, "
          "(select count(I2.id) "
           "from incentives I2 "
           "inner join shoe_types ST2 on I2.shoe_id = ST2.id "
           "inner join shoe_size_types SST2 on I2.shoe_size_id = SST2.id "
           "where I2.current_id >= 3 and "
           "ST2.item = ST.item and SST2.item = SST.item and "
           "I2.date_ordered is null and I2.incentive_id = " + lookupTables->IdOf("incentive_types", "Shoes") + ") quantity, "
          "PN.last_name || ', ' || PN.first_name || ' ' || PN.suffix name, I.note "
          "from incentives I "
          "inner join shoe_types ST on I.shoe_id = ST.id "
          "inner join shoe_size_types SST on I.shoe_size_id = SST.id "
          "inner join people P on I.person_id = P.id "
          "left join person_names PN on P.person_names_id = PN.id "
          "where I.current_id >= 3 and I.date_ordered is null and " +
          "I.incentive_id = " + lookupTables->IdOf("incentive_types", "Shoes") + " "
          "order by ST.item, SST.item, PN.last_name, PN.first_name";
    DebugSql(this, &sql, other_forms, 9, dbTransaction);

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportPendingShoe * shoeReport = new TformReportPendingShoe(NULL);
      sql = "select count(*) from incentives where date_ordered is null and current_id >= 3 and "
            "incentive_id = " + lookupTables->IdOf("incentive_types", "Shoes");
      shoeReport->shoeReport->DataSet = dbDataSet;
      shoeReport->groupBand->Expression = "group_field";
      shoeReport->lblDateTitle->Caption = date_title.c_str();
      shoeReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      shoeReport->txtType->DataSet = dbDataSet;
      shoeReport->txtType->DataField = "shoe_type";
      shoeReport->txtSize->DataSet = dbDataSet;
      shoeReport->txtSize->DataField = "shoe_size";
      shoeReport->txtQuantity->DataSet = dbDataSet;
      shoeReport->txtQuantity->DataField = "quantity";
      shoeReport->txtName->DataSet = dbDataSet;
      shoeReport->txtName->DataField = "name";
      shoeReport->txtNote->DataSet = dbDataSet;
      shoeReport->txtNote->DataField = "note";
      shoeReport->lblTotalQuantity->Caption = GetOneField(dbTransaction, sql).c_str();
      Processing(false);
      shoeReport->shoeReport->Preview();
    FORM_CATCH

    dbDataSet->Close();
    dbTransaction->Commit();

  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }

  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchPendingShoeReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

