//---------------------------------------------------------------------------

#ifndef launchPersonProviderInfoReportH
#define launchPersonProviderInfoReportH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <Buttons.hpp>
#include <QuickRpt.hpp>
#include "reportPersonProviderInfo.h"
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TformLaunchPersonProviderInfoReport : public TformSpecialGeneric
{
__published:	// IDE-managed Components
        TStaticText *staticPerson;
        TStaticText *staticTaxEntityFrom;
        TStaticText *staticTaxEntityTo;
        TBitBtn *buttonSearchTaxEntityTo;
        TBitBtn *buttonSearchTaxEntityFrom;
        TBitBtn *buttonSearchPerson;
        TLabel *_labelPatient;
        TLabel *_labelReferrer;
        TLabel *_labelProvider;
        TToolButton *buttonRun;
        TToolButton *buttonClose;
        TQRCompositeReport *compositeReport;
        void __fastcall buttonRunClick(TObject *Sender);
        void __fastcall buttonCloseClick(TObject *Sender);
        void __fastcall buttonSearchPersonClick(TObject *Sender);
        void __fastcall buttonSearchTaxEntityFromClick(TObject *Sender);
        void __fastcall buttonSearchTaxEntityToClick(TObject *Sender);
        void __fastcall compositeReportAddReports(TObject *Sender);
        void __fastcall compositeReportFinished(TObject *Sender);
private:	// User declarations
        string person_id;
        string tax_entity_from_id;
        string tax_entity_to_id;

        TIBTransaction * dbTransaction;
        list<TformReportPersonProviderInfo *> report_forms;
        list<TIBDataSet *> report_datasets;
        void StartNewForm();
        void StartNewDataset();
        void SetupTitle(TformReportPersonProviderInfo * report_form, TIBDataSet * report_dataset);
        void SetupContact(TformReportPersonProviderInfo * report_form, TIBDataSet * report_dataset);
        void SetupInsurance(TformReportPersonProviderInfo * report_form, TIBDataSet * report_dataset);
        void SetupBlanks(TformReportPersonProviderInfo * report_form, TIBDataSet * report_dataset);
public:		// User declarations
        __fastcall TformLaunchPersonProviderInfoReport(TComponent* Owner, string patient_id, string referrer_id, string provider_id);
};
//---------------------------------------------------------------------------
extern PACKAGE TformLaunchPersonProviderInfoReport *formLaunchPersonProviderInfoReport;
//---------------------------------------------------------------------------
#endif
