//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchPharmStateReport.h"
#include "reportPharmState.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchPharmStateReport *formLaunchPharmStateReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchPharmStateReport::TformLaunchPharmStateReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  upDownYear->Position = Pstamp(RightNow(), mdy | yyyy | datefirst | withsec).year;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchPharmStateReport::btnRunClick(TObject *Sender)
{
  if(! lookupTables->IsInLookUpTable("month_types", cboMonth->Text.c_str()))
  {
    PSay("Please enter a valid month", m_invalid_data, MB_OK);
    cboMonth->SetFocus();
  }
  else if(editYear->Text == "")
  {
    PSay("Please enter a year", m_missing_data, MB_OK);
    editYear->SetFocus();
  }
  else if(! IsInt(editYear->Text.c_str()))
  {
    PSay("Please enter a valid year", m_invalid_data, MB_OK);
    editYear->SetFocus();
  }
  else
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string bill_month = cboMonth->Text.c_str();
    string bill_month_id = lookupTables->IdOf("month_types", cboMonth->Text.c_str());
    string bill_year = editYear->Text.c_str();
    string sqlstring;
    string title;
    string date_title = bill_month + " " + bill_year;
    try
    {
      StdTransaction(dbTransaction, dbDatabase);
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      sqlstring = "select state_types.item, sum(pharmacy_info.amount_billed) amt_billed "
                  "from state_types, pharmacy_info, pharmacy_locations "
                  "where pharmacy_locations.state = state_types.abbreviation and "
                  "pharmacy_locations.pharmacy_id = " + lookupTables->IdOf("pharmacy_types", "Wal Mart") + " and "
                  "pharmacy_locations.id = pharmacy_info.pharmacy_location_id and "
                  "pharmacy_info.bill_month = " + bill_month_id + " and "
                  "pharmacy_info.bill_year = " + bill_year +
                  " group by state_types.item order by state_types.item";

      dbDataSet->SelectSQL->Add(sqlstring.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportPharmState * stateReport = new TformReportPharmState(NULL);
        stateReport->stateReport->DataSet = dbDataSet;
        stateReport->lblDateTitle->Caption = date_title.c_str();
        stateReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        stateReport->txtState->DataSet = dbDataSet;
        stateReport->txtState->DataField = "item";
        stateReport->exprAmount->Expression = "FORMATNUMERIC('$ #,##0.00', amt_billed)";
        stateReport->exprTotal->Expression = "FORMATNUMERIC('$ ###,##0.00', SUM(amt_billed))";
        Processing(false);
        stateReport->stateReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchPharmStateReport::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchPharmStateReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

