//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchProcsDoneReport.h"
#include "codeSpecialAddProcsDone.h"
#include "reportProcsDone.h"
#include "codeSearchPerson.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchProcsDoneReport *formLaunchProcsDoneReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchProcsDoneReport::TformLaunchProcsDoneReport(TComponent* Owner, string p_person_id)
        : TformSpecialGeneric(Owner)
{
  txtAddProcedures->Font->Color = link_color;
  CreateLink(txtPerson, btnPersonSearch, this, p_person_id, "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchProcsDoneReport::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchProcsDoneReport::btnRunClick(TObject *Sender)
{
  string person_id = GetValidLinkId(txtPerson);
  if (person_id != "")
  {
    Processing(true);
    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string title = "Procedure report for " + GetPersonName(dbDatabase, person_id, first_last);
    set<string> procedure_set;
    map<string, vector<string> > procedure_map;
    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      sql = "select procedures.cpt_hcpcs from procedures "
            "inner join tasks on procedures.task_id = tasks.id and tasks.current_id >= 3 "
            "where tasks.person_id = " + person_id + " "
            "and procedures.current_id >= 3";
      SqlToSet(dbTransaction, sql, procedure_set);

      sql = "select procs_done_types.item, procs_done_codes.code "
            "from procs_done_types "
            "left join procs_done_codes on procs_done_codes.procs_done_id = procs_done_types.id";
      SqlToMapStringVec(dbTransaction, sql, procedure_map);

      sql = "select procs_done_types.item "
            "from procs_done_types "
            "order by procs_done_types.item";

      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportProcsDone * report = new TformReportProcsDone(NULL, procedure_set, procedure_map);
        report->report->DataSet = dbDataSet;
        report->lblTitle->Caption = title.c_str();
        report->lblUser->Caption = current_fullname.c_str();
        report->txtDetail->DataSet = dbDataSet;
        report->txtDetail->DataField = "item";
        report->txtCheck->DataSet = dbDataSet;
        report->txtCheck->DataField = "item";
        Processing(false);
        report->report->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }
  else
  {
    PSay("Please enter a person", m_missing_data, MB_OK);
    btnPersonSearch->SetFocus();
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchProcsDoneReport::txtAddProceduresClick(
      TObject *Sender)
{
  FORM_TRY
    TformSpecialAddProcsDone *add_procedures = new TformSpecialAddProcsDone(NULL);
    add_procedures->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchProcsDoneReport::btnPersonSearchClick(
      TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtPerson, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchProcsDoneReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;        

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
