//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchPublicCommentReport.h"
#include "codeSearchPerson.h"
#include "reportPublicComment.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchPublicCommentReport *formLaunchPublicCommentReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchPublicCommentReport::TformLaunchPublicCommentReport(TComponent* Owner, string id)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  CreateLink(txtName, btnPersonSearch, this, id, "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchPublicCommentReport::btnRunClick(TObject *Sender)
{
  string person_id = GetValidLinkId(txtName);
  if (person_id != "")
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Comment report for " + GetPersonName(dbDatabase, person_id, first_last);

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select tasks.date_of_task, task_notes.note, users.item from tasks, "
            "task_notes, users where tasks.date_of_task >= '" + begin_date + "' and "
            "tasks.date_of_task <= '" + end_date + "' and "
            "tasks.person_id = " + lookupTables->IdOf("groups", "Public Health") + " and "
            "tasks.current_id >= 3 and "
            "tasks.user_id = users.id and tasks.group_id = " + lookupTables->IdOf("groups", "Public Health") + " and "
            "task_notes.task_id = tasks.id";


      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportPublicComment * commentReport = new TformReportPublicComment(NULL);
        commentReport->commentReport->DataSet = dbDataSet;
        commentReport->lblTitle->Caption = title.c_str();
        commentReport->lblDateTitle->Caption = date_title.c_str();
        commentReport->txtDate->DataSet = dbDataSet;
        commentReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        commentReport->txtDate->DataField = "date_of_task";
        commentReport->txtComment->DataSet = dbDataSet;
        commentReport->txtComment->DataField = "topic";
        commentReport->txtStaff->DataSet = dbDataSet;
        commentReport->txtStaff->DataField = "staff";
        Processing(false);
        commentReport->commentReport->Preview();
      FORM_CATCH

      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }
  else
  {
    PSay("Please enter a client name", m_missing_data, MB_OK);
    btnPersonSearch->SetFocus();
  }

}
//---------------------------------------------------------------------------
void __fastcall TformLaunchPublicCommentReport::btnCloseClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchPublicCommentReport::btnPersonSearchClick(
      TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchPerson * formPersonSearch = new TformSearchPerson(NULL,&return_vector);
    formPersonSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtName, btnPersonSearch, this, return_vector[0], "people");
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchPublicCommentReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

