//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchReceptionistLogReport.h"
#include "reportReceptionistLog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchReceptionistLogReport *formLaunchReceptionistLogReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchReceptionistLogReport::TformLaunchReceptionistLogReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
  lookupTables->RegisterComboBox("users", cboReceptionist);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchReceptionistLogReport::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchReceptionistLogReport::FormClose(
      TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("users", cboReceptionist);
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchReceptionistLogReport::btnRunClick(TObject *Sender)
{
  if (cboReceptionist->Text == "" || ! lookupTables->IsInLookUpTable("users", cboReceptionist->Text.c_str()))
  {
    PSay("Please enter a valid receptionist name", m_invalid_data, MB_OK);
    cboReceptionist->SetFocus();
  }
  else
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Receptionist Log for " + string(cboReceptionist->Text.c_str());

    try
    {
      StdTransaction(dbTransaction, dbDatabase);
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;


      sql = "select cast(call_log.call_time as date) call_date, "
            "cast(call_log.call_time as time) call_time, call_log.caller_name, "
            "users.item employee_name, call_log.note "
            "from call_log, users where call_log.employee_id = users.id and "
            "call_log.receptionist_id = " + lookupTables->IdOf("users", cboReceptionist->Text.c_str()) + " and "
            "call_log.call_time >= '" + begin_date + " 00:01:00' and "
            "call_log.call_time <= '" + end_date + " 23:59:00' "
            "order by call_time";

      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportReceptionistLog * receptionistLogReport = new TformReportReceptionistLog(NULL);
        receptionistLogReport->receptionistLogReport->DataSet = dbDataSet;
        receptionistLogReport->lblTitle->Caption = title.c_str();
        receptionistLogReport->lblDateTitle->Caption = date_title.c_str();
        receptionistLogReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        receptionistLogReport->txtDate->DataSet = dbDataSet;
        receptionistLogReport->txtDate->DataField = "call_date";
        receptionistLogReport->txtTime->DataSet = dbDataSet;
        receptionistLogReport->txtTime->DataField = "call_time";
        receptionistLogReport->txtCaller->DataSet = dbDataSet;
        receptionistLogReport->txtCaller->DataField = "caller_name";
        receptionistLogReport->txtEmployee->DataSet = dbDataSet;
        receptionistLogReport->txtEmployee->DataField = "employee_name";
        receptionistLogReport->txtNote->DataSet = dbDataSet;
        receptionistLogReport->txtNote->DataField = "note";
        Processing(false);
        receptionistLogReport->receptionistLogReport->Preview();
      FORM_CATCH
      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchReceptionistLogReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

