//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchServiceProvidedReport.h"
#include "reportServiceProvided.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchServiceProvidedReport *formLaunchServiceProvidedReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchServiceProvidedReport::TformLaunchServiceProvidedReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  lookupTables->RegisterComboBox("service_types", cboService);
  dateBegin->Date =Date();
  dateEnd->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchServiceProvidedReport::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchServiceProvidedReport::FormClose(
      TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("service_types", cboService);
  TformSpecialGeneric::FormClose(Sender, Action);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchServiceProvidedReport::btnRunClick(TObject *Sender)
{
  if (cboService->Text == "" || ! lookupTables->IsInLookUpTable("service_types", cboService->Text.c_str()))
  {
    PSay("Please enter a valid service", m_invalid_data, MB_OK);
    cboService->SetFocus();
  }
  else
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Service Report - " + string(cboService->Text.c_str());

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      // NOTE USES VIEW
      sql = "select tax_entities.name, count(visit_tasks.id) visits, sum(credit_amount - debit_amount) amount_paid "
            "from tax_entities "
            "inner join services_provided on services_provided.tax_entity_id = tax_entities.id "
            "left join (visit_tasks "
            "inner join bills on bills.task_id = visit_tasks.id "
            "inner join transactions on transactions.bill_id = bills.id "
            "inner join accounts on transactions.account_id = accounts.id and "
            "account_type_id = " + lookupTables->IdOf("account_types", "Cash") + ") "
            "on visit_tasks.tax_entity_id = tax_entities.id and "
            "visit_tasks.date_of_task >= '" + begin_date + "' and "
            "visit_tasks.date_of_task <= '" + end_date + "' "
            "where services_provided.service_id = " + lookupTables->IdOf("service_types", cboService->Text.c_str()) + " "
            "and exists (select * from cob_tasks where visit_tasks.parent_task_id = cob_tasks.id and cob_tasks.services_provided_id = services_provided.id) "
            "group by tax_entities.name";
      DebugSql(this, &sql, other_forms, 9);
      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportServiceProvided * report_form = new TformReportServiceProvided(NULL);
        report_form->report->DataSet = dbDataSet;
        report_form->lblTitle->Caption = title.c_str();
        report_form->lblDateTitle->Caption = date_title.c_str();
        report_form->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        report_form->txtProvider->DataSet = dbDataSet;
        report_form->txtProvider->DataField = "name";
        report_form->txtVisits->DataSet = dbDataSet;
        report_form->txtVisits->DataField = "visits";
        report_form->exprPaid->Expression = "FORMATNUMERIC('$###,###0.00', amount_paid)";
        report_form->exprTotal->Expression = "FORMATNUMERIC('$###,###0.00', SUM(amount_paid))";
        Processing(false);
        report_form->report->Preview();
      FORM_CATCH

      dbDataSet->Close();
      dbTransaction->Commit();

    }
    catch (...)
    {
      Processing(false);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
      PSay("Error running report", m_database_error, MB_OK);
    }

    delete dbTransaction;
    delete dbDataSet;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchServiceProvidedReport::FormShortCut(TWMKey &Msg, bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

