//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchShoesOrderedReport.h"
#include "reportShoesOrdered.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchShoesOrderedReport *formLaunchShoesOrderedReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchShoesOrderedReport::TformLaunchShoesOrderedReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchShoesOrderedReport::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchShoesOrderedReport::btnRunClick(TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {

    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;


    sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix name, "
          "shoe_types.item shoe_type, shoe_size_types.item shoe_size, incentives.date_ordered, "
          "incentives.received_by_person, incentives.received_from_nike "
          "from incentives, shoe_types, shoe_size_types, "
          "people left join person_names on people.person_names_id = person_names.id "
          "where incentives.person_id = people.id and "
          "incentives.shoe_id = shoe_types.id and "
          "incentives.shoe_size_id = shoe_size_types.id and "
          "incentives.date_ordered >= '" + begin_date + "' and "
          "incentives.date_ordered <= '" + end_date + "' and "
          "incentives.incentive_id = " + lookupTables->IdOf("incentive_types", "Shoes") + " and "
          "incentives.current_id >= 3 ";

    if (radioNike->Checked)
      sql += "and incentives.received_from_nike = 1 ";
    else if (radioClient->Checked)
      sql += "and incentives.received_from_nike = 0 ";

    sql += "order by person_names.last_name, person_names.first_name, "
           "incentives.date_ordered";

    dbTransaction->StartTransaction();
    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportShoesOrdered * shoeReport = new TformReportShoesOrdered(NULL);
      shoeReport->shoeReport->DataSet = dbDataSet;
      shoeReport->lblDateTitle->Caption = date_title.c_str();
      shoeReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      shoeReport->txtName->DataSet = dbDataSet;
      shoeReport->txtName->DataField = "name";
      shoeReport->txtShoeType->DataSet = dbDataSet;
      shoeReport->txtShoeType->DataField = "shoe_type";
      shoeReport->txtShoeSize->DataSet = dbDataSet;
      shoeReport->txtShoeSize->DataField = "shoe_size";
      shoeReport->txtDate->DataSet = dbDataSet;
      shoeReport->txtDate->DataField = "date_ordered";
      shoeReport->exprReceivedFrom->Expression = "IF(received_from_nike = '1', 'Yes', ' No')";
      shoeReport->exprReceivedBy->Expression = "IF(received_by_person = '1', 'Yes', ' No')";
      Processing(false);
      shoeReport->shoeReport->Preview();
    FORM_CATCH
    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }

  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchShoesOrderedReport::radioNikeClick(
      TObject *Sender)
{
  radioNike->Checked = true;
  radioClient->Checked = false;
  radioAll->Checked = false;
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchShoesOrderedReport::radioClientClick(
      TObject *Sender)
{
  radioNike->Checked = false;
  radioClient->Checked = true;
  radioAll->Checked = false;
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchShoesOrderedReport::radioAllClick(
      TObject *Sender)
{
  radioNike->Checked = false;
  radioClient->Checked = false;
  radioAll->Checked = true;        
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchShoesOrderedReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

