//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchSpendersReport.h"
#include "reportSpenders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchSpendersReport *formLaunchSpendersReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchSpendersReport::TformLaunchSpendersReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  upDownYear->Position = Pstamp(RightNow(), mdy | yyyy | datefirst | withsec).year;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchSpendersReport::btnRunClick(TObject *Sender)
{
  if(! lookupTables->IsInLookUpTable("month_types", cboMonth->Text.c_str()))
  {
    PSay("Please enter a valid month", m_invalid_data, MB_OK);
    cboMonth->SetFocus();
  }
  else if(editYear->Text == "")
  {
    PSay("Please enter a year", m_missing_data, MB_OK);
    editYear->SetFocus();
  }
  else if(! IsInt(editYear->Text.c_str()))
  {
    PSay("Please enter a valid year", m_invalid_data, MB_OK);
    editYear->SetFocus();
  }
  else
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    TIBSQL * dbSQL = new TIBSQL(NULL);
    string bill_month = cboMonth->Text.c_str();
    string bill_month_id = lookupTables->IdOf("month_types", cboMonth->Text.c_str());
    string bill_year = editYear->Text.c_str();
    string sqlstring;
    string title;
    string date_title = "Wal Mart Pharmacies: " + bill_month + " " + bill_year;
    string summary_date = "Total for " + bill_month + ": ";
    vector<string> top_five;
    financial month_total;
    string temp;

    try
    {
      StdTransaction(dbTransaction, dbDatabase);
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;
      dbSQL->Database = dbDatabase;
      dbSQL->Transaction = dbTransaction;

      dbSQL->SQL->Text = "delete from pharmacy_report";

      dbSQL->ExecQuery();
      sqlstring = "insert into pharmacy_report (person_id, amount) "
                  "select pharmacy_info.person_id, sum(pharmacy_info.amount_billed) "
                  "from pharmacy_info, pharmacy_locations "
                  "where pharmacy_locations.pharmacy_id = " + lookupTables->IdOf("pharmacy_types", "Wal Mart") + " and "
                  "pharmacy_locations.id = pharmacy_info.pharmacy_location_id and "
                  "pharmacy_info.bill_month = " + bill_month_id + " and "
                  "pharmacy_info.bill_year = " + bill_year +
                  " group by pharmacy_info.person_id";
      dbSQL->SQL->Text = sqlstring.c_str();
      dbSQL->ExecQuery();
      sqlstring = "select person_id, amount from pharmacy_report "
                  "order by amount descending";
      dbDataSet->SelectSQL->Add(sqlstring.c_str());
      dbDataSet->Open();
      dbDataSet->First();
      for (int i = 0; (i < 5) && (! dbDataSet->Eof); i++, dbDataSet->Next())
        top_five.push_back(dbDataSet->FieldByName("person_id")->AsString.c_str());
      dbDataSet->Close();
//      if(top_five.empty())
//        PSay("the vector is empty", m_message, MB_OK);

      sqlstring = "select sum(pharmacy_info.amount_billed) month_total "
                  "from pharmacy_info, pharmacy_locations "
                  "where pharmacy_locations.pharmacy_id = " + lookupTables->IdOf("pharmacy_types", "Wal Mart") + " and "
                  "pharmacy_locations.id = pharmacy_info.pharmacy_location_id and "
                  "pharmacy_info.bill_month = " + bill_month_id + " and "
                  "pharmacy_info.bill_year = " + bill_year;
      dbDataSet->SelectSQL->Clear();
      dbDataSet->SelectSQL->Add(sqlstring.c_str());
      dbDataSet->Open();
      dbDataSet->First();
      month_total = StringToFinancial(dbDataSet->FieldByName("month_total")->AsString.c_str());
      dbDataSet->Close();

      sqlstring = "select pharmacy_info.person_id, affiliations.cdib, person_names.last_name, "
                  "person_names.first_name, pharmacy_info.drug_name, "
                  "pharmacy_info.amount_billed, pharmacy_locations.city, "
                  "pharmacy_locations.state "
                  "from pharmacy_info, pharmacy_locations, people "
                  "left join person_names on people.person_names_id = person_names.id "
                  "left join affiliations on people.affiliations_id = affiliations.id "
                  "where pharmacy_info.person_id = people.id and "
                  "pharmacy_locations.pharmacy_id = " + lookupTables->IdOf("pharmacy_types", "Wal Mart") + " and "
                  "pharmacy_locations.id = pharmacy_info.pharmacy_location_id and "
                  "pharmacy_info.bill_month = " + bill_month_id + " and "
                  "pharmacy_info.bill_year = " + bill_year + " and "
                  "pharmacy_info.person_id in (";
      for (unsigned int i = 0; (i < 5) && (i < top_five.size()); i++)
        sqlstring += "'" + top_five[i] + "', ";
      sqlstring = sqlstring.substr(0, sqlstring.length() - 2);
      sqlstring += ") order by person_names.last_name, person_names.first_name";
//      PSay(sqlstring, m_message, MB_OK);
      dbDataSet->SelectSQL->Clear();
      dbDataSet->SelectSQL->Add(sqlstring.c_str());
      dbDataSet->Open();
      dbDataSet->First();
      string current_cdib;
      string total_str;
      financial current_total = 0.00;
      current_cdib = dbDataSet->FieldByName("person_id")->AsString.c_str();
      while (! dbDataSet->Eof)
      {
        if (current_cdib == dbDataSet->FieldByName("person_id")->AsString.c_str())
          current_total += StringToFinancial(dbDataSet->FieldByName("amount_billed")->AsString.c_str());
        else
        {
          total_str = "$ " + FinancialToString(current_total, true);
          total_vec.push_back(total_str);
          current_cdib = dbDataSet->FieldByName("person_id")->AsString.c_str();
          current_total = StringToFinancial(dbDataSet->FieldByName("amount_billed")->AsString.c_str());
        }
        dbDataSet->Next();
      }
      total_str = "$ " + FinancialToString(current_total, true);
      total_vec.push_back(total_str);

      FORM_TRY
        TformReportSpenders * spendersReport = new TformReportSpenders(NULL, total_vec);
        spendersReport->spendersReport->DataSet = dbDataSet;
        spendersReport->lblTitle->Caption = date_title.c_str();
        spendersReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
        spendersReport->groupBand->Expression = "person_id";
        spendersReport->txtCDIB->DataSet = dbDataSet;
        spendersReport->txtCDIB->DataField = "cdib";
        spendersReport->txtLastName->DataSet = dbDataSet;
        spendersReport->txtLastName->DataField = "last_name";
        spendersReport->txtFirstName->DataSet = dbDataSet;
        spendersReport->txtFirstName->DataField = "first_name";
        spendersReport->txtDrugName->DataSet = dbDataSet;
        spendersReport->txtDrugName->DataField = "drug_name";
        spendersReport->exprAmount->Expression = "FORMATNUMERIC('$ #,##0.00', amount_billed)";
        spendersReport->txtCity->DataSet = dbDataSet;
        spendersReport->txtCity->DataField = "city";
        spendersReport->txtState->DataSet = dbDataSet;
        spendersReport->txtState->DataField = "state";
        spendersReport->lblTotalFor->Caption = summary_date.c_str();
        spendersReport->exprTotal->Expression = "FORMATNUMERIC('$ ###,##0.00', SUM(amount_billed))";
        temp = "FORMATNUMERIC('$ ###,##0.00', " + FinancialToString(month_total) + ")";
        spendersReport->exprMonthTotal->Expression = temp.c_str();
        temp = "FORMATNUMERIC('% #0.00', (SUM(amount_billed) / " + FinancialToString(month_total) + ") * 100)";
        spendersReport->exprPercentage->Expression = temp.c_str();
        Processing(false);
        spendersReport->spendersReport->Preview();
      FORM_CATCH
      ExecuteStatement(dbTransaction, "delete from pharmacy_report");

      dbDataSet->Close();
      dbTransaction->Commit();

    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }

    delete dbTransaction;
    delete dbDataSet;
  }

}
//---------------------------------------------------------------------------
void __fastcall TformLaunchSpendersReport::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
string TformLaunchSpendersReport::GetCurrentTotal(unsigned int position)
{
  if (position < total_vec.size())
    return total_vec[position];
  else
    return "0";
}
void __fastcall TformLaunchSpendersReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

