//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchStepsCheckReport.h"
#include "reportStepsCheck.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchStepsCheckReport *formLaunchStepsCheckReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchStepsCheckReport::TformLaunchStepsCheckReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Now();
  dateEnd->Date = Now();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchStepsCheckReport::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchStepsCheckReport::btnRunClick(TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
  string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
  string date_title = begin_date + " - " + end_date;

  try
  {
    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    sql = "select person_names.last_name || ', ' || person_names.first_name || ' ' || person_names.suffix name, "
          "incentives.date_sent_to_finance, incentives.check_number, "
          "incentives.amount "
          "from people left join person_names on people.person_names_id = person_names.id, "
          "incentives "
          "where people.id = incentives.person_id and "
          "incentives.incentive_id = " + lookupTables->IdOf("incentive_types", "Check") + " and "
          "incentives.date_sent_to_finance >= '" + begin_date + "' and "
          "incentives.date_sent_to_finance <= '" + end_date + "' "
          "order by person_names.last_name, person_names.first_name, "
          "incentives.date_sent_to_finance";

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportStepsCheck * checkReport = new TformReportStepsCheck(NULL);
      checkReport->checkReport->DataSet = dbDataSet;
      checkReport->lblDateTitle->Caption = date_title.c_str();
      checkReport->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
      checkReport->txtName->DataSet = dbDataSet;
      checkReport->txtName->DataField = "name";
      checkReport->txtDate->DataSet = dbDataSet;
      checkReport->txtDate->DataField = "date_sent_to_finance";
      checkReport->txtCheckNum->DataSet = dbDataSet;
      checkReport->txtCheckNum->DataField = "check_number";
      checkReport->exprAmount->Expression = "FORMATNUMERIC('$##0.00', amount)";
      checkReport->exprTotal->Expression = "FORMATNUMERIC('$##,##0.00', SUM(amount))";
      Processing(false);
      checkReport->checkReport->Preview();
    FORM_CATCH

    dbDataSet->Close();
    dbTransaction->Commit();

  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }

  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchStepsCheckReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

