//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop                                        

#include "launchTransportationSummaryReport.h"
#include "html_reporting.h"
#include "codeSpecialHtmlPreview.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchTransportationSummaryReport *formLaunchTransportationSummaryReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchTransportationSummaryReport::TformLaunchTransportationSummaryReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
 dateBegin->Date = Date();
 dateEnd->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchTransportationSummaryReport::buttonCloseClick(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
// very local
string _f(string a)
{
 return FinancialToString(StringToFinancial(a));
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchTransportationSummaryReport::buttonRunClick(TObject *Sender)
{
 Processing(true);

 if (dateBegin->DateTime > dateEnd->DateTime)
 {
  PSay("The begin and end date are not in order.", m_invalid_data, MB_OK);
  Processing(false);
  return;
 }

 // go!
 TIBTransaction * dbTransaction = NULL;
 try
 {
  if ((optionsPermissions["table.tasks.trans"]["view"] == "true"))
  {
   FORM_TRY
    dbTransaction = new TIBTransaction(NULL);
   FORM_CATCH
   StdTransaction(dbTransaction, dbDatabase);

   ofstream ze_file;
   ze_file.open("transp.html", ios::trunc | ios::out);
   if (!ze_file.is_open())
   {
    PSay("Failed to create temporary file for report output.", m_debug, MB_OK);
    throw(97);
   }
   htmlStart(ze_file, "Transportation Report<br>" + Pdate(dateBegin->DateTime).OutDate(global_mode) + " - " + Pdate(dateEnd->DateTime).OutDate(global_mode));

   string a, b, g;
   a = "'" + Pdate(dateBegin->DateTime).OutDate(global_mode) + "'";
   b = "'" + Pdate(dateEnd->DateTime).OutDate(global_mode) + "'";
   g = lookupTables->IdOf("groups", "Transportation");

   string sql1 = "select tasks.transp_action_id, transp_action_types.item trans_item, tasks.user_id, users.item user_item, "
                 "sum(tasks.time_spent) sum_hours, count(tasks.id) cnt_trips, count(distinct case when tasks.person_id != 0 then tasks.person_id else null end) cnt_people, sum(tasks.mileage) sum_miles, avg(tasks.time_spent) avg_hours, avg(tasks.mileage) avg_miles "
                 "from tasks "
                 "left join transp_action_types on transp_action_types.id = tasks.transp_action_id and transp_action_types.valid = 1 "
                 "left join users on users.id = tasks.user_id "
                 "where tasks.current_id + 1 > 3 and "
                 "tasks.group_id = " + g + " and "
                 "tasks.date_of_task between " + a + " and " + b + " "
                 "group by transp_action_types.item, tasks.transp_action_id, users.item, tasks.user_id ";

   string sql2 = "select tasks.transp_action_id, transp_action_types.item trans_item, "
                 "sum(tasks.time_spent) sum_hours, count(tasks.id) cnt_trips, count(distinct case when tasks.person_id != 0 then tasks.person_id else null end) cnt_people, sum(tasks.mileage) sum_miles, avg(tasks.time_spent) avg_hours, avg(tasks.mileage) avg_miles "
                 "from tasks "
                 "left join transp_action_types on transp_action_types.id = tasks.transp_action_id and transp_action_types.valid = 1 "
                 "where tasks.current_id + 1 > 3 and "
                 "tasks.group_id = " + g + " and "
                 "tasks.date_of_task between " + a + " and " + b + " "
                 "group by transp_action_types.item, tasks.transp_action_id ";

   string sql3 = "select tasks.user_id, users.item user_item, "
                 "sum(tasks.time_spent) sum_hours, count(tasks.id) cnt_trips, count(distinct case when tasks.person_id != 0 then tasks.person_id else null end) cnt_people, sum(tasks.mileage) sum_miles, avg(tasks.time_spent) avg_hours, avg(tasks.mileage) avg_miles "
                 "from tasks "
                 "left join users on users.id = tasks.user_id "
                 "where tasks.current_id + 1 > 3 and "
                 "tasks.group_id = " + g + " and "
                 "tasks.date_of_task between " + a + " and " + b + " "
                 "group by users.item, tasks.user_id ";

   string sql4 = "select "
                 "sum(tasks.time_spent) sum_hours, count(tasks.id) cnt_trips, count(distinct case when tasks.person_id != 0 then tasks.person_id else null end) cnt_people, sum(tasks.mileage) sum_miles, avg(tasks.time_spent) avg_hours, avg(tasks.mileage) avg_miles "
                 "from tasks "
                 "left join users on users.id = tasks.user_id "
                 "where tasks.current_id + 1 > 3 and "
                 "tasks.group_id = " + g + " and "
                 "tasks.date_of_task between " + a + " and " + b + " ";

   vector<map<string, string> > result1;
   vector<map<string, string> > result2;
   vector<map<string, string> > result3;
   vector<map<string, string> > result4;

   // TODO: error handling?
   SqlToVecMap(dbTransaction, sql1, result1);
   SqlToVecMap(dbTransaction, sql2, result2);
   SqlToVecMap(dbTransaction, sql3, result3);
   SqlToVecMap(dbTransaction, sql4, result4);

   for (vector<map<string, string> >::reverse_iterator i = result2.rbegin(); i != result2.rend(); i++)
   {
    htmlPrettyBar(ze_file, PrettyString((*i)["trans_item"]));
    ze_file << "<table class='datatable' width=100%>"
               "<thead>"
               "<tr>"
               "<td align=right><i>Employee</i></td>"
               "<td align=right><i>Hours</i></td>"
               "<td align=right><i>Tasks</i></td>"
               "<td align=right><i>People</i></td>"
               "<td align=right><i>Miles</i></td>"
               "<td align=right><i>Hours/Task</i></td>"
               "<td align=right><i>Miles/Task</i></td>"
               "</tr>"
               "</thead>"
               "<tbody>";
    for (vector<map<string, string> >::iterator j = result1.begin(); j != result1.end(); j++)
     if ((*j)["transp_action_id"] == (*i)["transp_action_id"])
     {
      ze_file << "<tr>"
                 "<td align=right>" << PrettyString((*j)["user_item"]) << "</td>"
                 "<td align=right>" << _f((*j)["sum_hours"]) << "</td>"
                 "<td align=right>" << (*j)["cnt_trips"] << "</td>"
                 "<td align=right>" << (*j)["cnt_people"] << "</td>"
                 "<td align=right>" << (*j)["sum_miles"] << "</td>"
                 "<td align=right>" << _f((*j)["avg_hours"]) << "</td>"
                 "<td align=right>" << _f((*j)["avg_miles"]) << "</td>"
                 "</tr>";
     }

    // top border refuses to appear, despite border-collapse: collpase on the table. not sure why. investigate later.
    ze_file << "<tr style='border-top: 1px solid black !important;'>"
               "<td align=right>" << "Totals" << "</td>"
               "<td align=right>" << _f((*i)["sum_hours"]) << "</td>"
               "<td align=right>" << (*i)["cnt_trips"] << "</td>"
               "<td align=right>" << (*i)["cnt_people"] << "</td>"
               "<td align=right>" << (*i)["sum_miles"] << "</td>"
               "<td align=right>" << _f((*i)["avg_hours"]) << "</td>"
               "<td align=right>" << _f((*i)["avg_miles"]) << "</td>"
               "</tr>"
               "</tbody>"
               "</table>";
   }

   htmlPrettyBar(ze_file, "Totals");
   ze_file << "<table class='datatable' width=100%>"
              "<thead>"
              "<tr>"
              "<td align=right><i>Employee</i></td>"
              "<td align=right><i>Hours</i></td>"
              "<td align=right><i>Tasks</i></td>"
              "<td align=right><i>People</i></td>"
              "<td align=right><i>Miles</i></td>"
              "<td align=right><i>Hours/Task</i></td>"
              "<td align=right><i>Miles/Task</i></td>"
              "</tr>"
              "</thead>"
              "<tbody>";
   for (vector<map<string, string> >::iterator k = result3.begin(); k != result3.end(); k++)
    ze_file << "<tr>"
               "<td align=right>" << PrettyString((*k)["user_item"]) << "</td>"
               "<td align=right>" << _f((*k)["sum_hours"]) << "</td>"
               "<td align=right>" << (*k)["cnt_trips"] << "</td>"
               "<td align=right>" << (*k)["cnt_people"] << "</td>"
               "<td align=right>" << (*k)["sum_miles"] << "</td>"
               "<td align=right>" << _f((*k)["avg_hours"]) << "</td>"
               "<td align=right>" << _f((*k)["avg_miles"]) << "</td>"
               "</tr>";
   // top border refuses to appear, despite border-collapse: collpase on the table. not sure why. investigate later.
   vector<map<string, string> >::iterator l = result4.begin();
   if (l != result4.end())
    ze_file << "<tr style='border-top: 1px solid black !important;'>"
               "<td align=right>" << "Totals" << "</td>"
               "<td align=right>" << _f((*l)["sum_hours"]) << "</td>"
               "<td align=right>" << (*l)["cnt_trips"] << "</td>"
               "<td align=right>" << (*l)["cnt_people"] << "</td>"
               "<td align=right>" << (*l)["sum_miles"] << "</td>"
               "<td align=right>" << _f((*l)["avg_hours"]) << "</td>"
               "<td align=right>" << _f((*l)["avg_miles"]) << "</td>"
               "</tr>";
   ze_file << "</tbody>"
              "</table>";

   htmlStop(ze_file);
   ze_file.close();

   string real_cwd = GetCurrentDir().c_str();
   dbTransaction->Commit();
   Processing(false);
   TformSpecialHtmlPreview::DoPrintPreview(real_cwd + "\\transp.html");
  } else
   PSay("You do not have permission to see transportation tasks.", m_program_error, MB_OK);
 }
 catch (...)
 {
   Processing(false);
   PSay("Error running audit report", m_database_error, MB_OK);
 }
 delete dbTransaction;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchTransportationSummaryReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    buttonRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
void TformLaunchTransportationSummaryReport::Do()
{
 FORM_TRY
  TformLaunchTransportationSummaryReport * z = new TformLaunchTransportationSummaryReport(NULL);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
