//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchUsageLogPerUser.h"
#include "reportUsageLogPerUser.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchUsageLogPerUser *formLaunchUsageLogPerUser;
//---------------------------------------------------------------------------
__fastcall TformLaunchUsageLogPerUser::TformLaunchUsageLogPerUser(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  lookupTables->RegisterComboBox("users", cboUser);
  dateBegin->Date = Date();
  dateEnd->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchUsageLogPerUser::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchUsageLogPerUser::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("users", cboUser);
  TformSpecialGeneric::FormClose(Sender, Action);           
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchUsageLogPerUser::btnRunClick(TObject *Sender)
{
  if (cboUser->Text == "" || ! lookupTables->IsInLookUpTable("users", cboUser->Text.c_str()))
  {
    PSay("Please enter a valid user", m_invalid_data, MB_OK);
    cboUser->SetFocus();
  }
  else
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Usage log summary for " + string(cboUser->Text.c_str());

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      sql = "select usage_log.form_name, sum(usage_log.occurances) total_occurances "
            "from usage_log "
            "where usage_log.user_id = " + lookupTables->IdOf("users", cboUser->Text.c_str()) + " and "
            "usage_log.event_date >= '" + begin_date + "' and "
            "usage_log.event_date <= '" + end_date + "' and "
            "usage_log.event_name = 'form opened' "
            "group by usage_log.form_name";
      if(radioOrderUsage->Checked)
        sql += " order by 2 descending";

      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportUsageLogPerUser * report = new TformReportUsageLogPerUser(NULL);
        report->usageReport->DataSet = dbDataSet;
        report->lblTitle->Caption = title.c_str();
        report->lblDateTitle->Caption = date_title.c_str();
        report->lblUser->Caption = current_fullname.c_str();
        report->txtName->DataSet = dbDataSet;
        report->txtName->DataField = "form_name";
        report->txtTimesOpened->DataSet = dbDataSet;
        report->txtTimesOpened->DataField = "total_occurances";
        // for some reason the stupid expression field won't show the total correctly
        // so i'm having to do it by hand
        sql = "select sum(usage_log.occurances) from usage_log "
              "where usage_log.user_id = " + lookupTables->IdOf("users", cboUser->Text.c_str()) + " and "
              "usage_log.event_date >= '" + begin_date + "' and "
              "usage_log.event_date <= '" + end_date + "' and "
              "usage_log.event_name = 'form opened'";
        report->lblTotal->Caption = GetOneField(dbTransaction, sql).c_str();
        Processing(false);
        report->usageReport->Preview();
      FORM_CATCH

      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;
  }                   
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchUsageLogPerUser::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
