//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchUsageLogPerUserByDate.h"
#include "reportUsageLogPerUserByDate.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchUsageLogPerUserByDate *formLaunchUsageLogPerUserByDate;
//---------------------------------------------------------------------------
__fastcall TformLaunchUsageLogPerUserByDate::TformLaunchUsageLogPerUserByDate(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  lookupTables->RegisterComboBox("users", cboUser);
  dateBegin->Date = Date();
  dateEnd->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchUsageLogPerUserByDate::btnCloseClick(
      TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchUsageLogPerUserByDate::FormClose(
      TObject *Sender, TCloseAction &Action)
{
  lookupTables->UnregisterComboBox("users", cboUser);
  TformSpecialGeneric::FormClose(Sender, Action);         
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchUsageLogPerUserByDate::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;             

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

void __fastcall TformLaunchUsageLogPerUserByDate::btnRunClick(
      TObject *Sender)
{
  if (cboUser->Text == "" || ! lookupTables->IsInLookUpTable("users", cboUser->Text.c_str()))
  {
    PSay("Please enter a valid user", m_invalid_data, MB_OK);
    cboUser->SetFocus();
  }
  else
  {
    Processing(true);

    TIBTransaction * dbTransaction = new TIBTransaction(NULL);
    TIBDataSet * dbDataSet = new TIBDataSet(NULL);
    string sql;
    string begin_date = Pdate(dateBegin->Date).OutDate(mdy | yyyy);
    string end_date =  Pdate(dateEnd->Date).OutDate(mdy | yyyy);
    string date_title = begin_date + " - " + end_date;
    string title = "Usage log summary for " + string(cboUser->Text.c_str()) + " grouped by date";

    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbDataSet->Database = dbDatabase;
      dbDataSet->Transaction = dbTransaction;
      dbDataSet->UniDirectional = false;

      sql = "select usage_log.event_date, usage_log.form_name, sum(usage_log.occurances) total_occurances "
            "from usage_log where usage_log.event_name = 'form opened' and "
            "usage_log.event_date >= '" + begin_date + "' and "
            "usage_log.event_date <= '" + end_date + "' and "
            "usage_log.user_id = " + lookupTables->IdOf("users", cboUser->Text.c_str()) + " "
            "group by usage_log.event_date, usage_log.form_name "
            "order by usage_log.event_date descending, ";
      if(radioOrderForm->Checked)
        sql += "usage_log.form_name ascending";
      else if(radioOrderUsage->Checked)
        sql += "3 descending, usage_log.form_name ascending";

      dbTransaction->StartTransaction();
      dbDataSet->SelectSQL->Add(sql.c_str());
      dbDataSet->Open();
      dbDataSet->First();

      FORM_TRY
        TformReportUsageLogPerUserByDate * report = new TformReportUsageLogPerUserByDate(NULL);
        report->usageReport->DataSet = dbDataSet;
        report->groupBand->Expression = "event_date";
        report->lblTitle->Caption = title.c_str();
        report->lblDateTitle->Caption = date_title.c_str();
        report->lblUser->Caption = current_fullname.c_str();
        report->txtDate->DataSet = dbDataSet;
        report->txtDate->DataField = "event_date";
        report->txtName->DataSet = dbDataSet;
        report->txtName->DataField = "form_name";
        report->txtTimesOpened->DataSet = dbDataSet;
        report->txtTimesOpened->DataField = "total_occurances";
  //      report->exprTotal->Expression = "SUM(total_occurances)";
        // it's really pissing me off, but for some reason the expression refuses to work
        // just so you know, i hate quick reports
        sql = "select sum(usage_log.occurances) from usage_log "
              "where usage_log.event_date >= '" + begin_date + "' and "
              "usage_log.event_date <= '" + end_date + "' and "
              "usage_log.event_name = 'form opened' and "
              "usage_log.user_id = " + lookupTables->IdOf("users", cboUser->Text.c_str());
        report->lblTotal->Caption = GetOneField(dbTransaction, sql).c_str();
        Processing(false);
        report->usageReport->Preview();
      FORM_CATCH

      dbDataSet->Close();
      dbTransaction->Commit();
    }
    catch (...)
    {
      Processing(false);
      PSay("Error running report", m_database_error, MB_OK);
      if (dbTransaction->Active)
        dbTransaction->Rollback();
    }
    delete dbTransaction;
    delete dbDataSet;
  }        
}
//---------------------------------------------------------------------------

