//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchUsageLogSummary.h"
#include "reportUsageLogSummary.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchUsageLogSummary *formLaunchUsageLogSummary;
//---------------------------------------------------------------------------
__fastcall TformLaunchUsageLogSummary::TformLaunchUsageLogSummary(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  dateBegin->Date = Date();
  dateEnd->Date = Date();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchUsageLogSummary::btnCloseClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchUsageLogSummary::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;             

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchUsageLogSummary::btnRunClick(TObject *Sender)
{
  Processing(true);

  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  string sql;
  Pdate begin_date = dateBegin->Date;
  Pdate end_date =  dateEnd->Date;
  string date_title = begin_date.OutDate(mdy | yyyy) + " - " + end_date.OutDate(mdy | yyyy);
  int date_difference = (end_date - begin_date) + 1;

  try
  {
    dbTransaction->DefaultDatabase = dbDatabase;
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    sql = "select usage_log.form_name, sum(usage_log.occurances) total_occurances, "
          "sum(usage_log.occurances)/" + IntToString(date_difference) + ".0 the_average "
          "from usage_log "
          "where usage_log.event_date >= '" + begin_date.OutDate(mdy | yyyy) + "' and "
          "usage_log.event_date <= '" + end_date.OutDate(mdy | yyyy) + "' and "
          "usage_log.event_name = 'form opened' "
          "group by usage_log.form_name";
    if(radioOrderUsage->Checked)
      sql += " order by 2 descending";

    dbTransaction->StartTransaction();
    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    FORM_TRY
      TformReportUsageLogSummary * report = new TformReportUsageLogSummary(NULL);
      report->usageReport->DataSet = dbDataSet;
      report->lblDateTitle->Caption = date_title.c_str();
      report->lblUser->Caption = current_fullname.c_str();
      report->txtName->DataSet = dbDataSet;
      report->txtName->DataField = "form_name";
      report->txtTimesOpened->DataSet = dbDataSet;
      report->txtTimesOpened->DataField = "total_occurances";
      report->exprAverage->Expression = "FORMATNUMERIC('#0.0', the_average*(7/5))";
      sql = "select sum(usage_log.occurances) from usage_log "
            "where usage_log.event_date >= '" + begin_date.OutDate(mdy | yyyy) + "' and "
            "usage_log.event_date <= '" + end_date.OutDate(mdy | yyyy) + "' and "
            "usage_log.event_name = 'form opened'";
      report->lblTotal->Caption = GetOneField(dbTransaction, sql).c_str();
      Processing(false);
      report->usageReport->Preview();
    FORM_CATCH

    dbDataSet->Close();
    dbTransaction->Commit();
  }
  catch (...)
  {
    Processing(false);
    PSay("Error running report", m_database_error, MB_OK);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
  }
  delete dbTransaction;
  delete dbDataSet;
}
//---------------------------------------------------------------------------
