//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "launchYearlyPharmacyReport.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformLaunchYearlyPharmacyReport *formLaunchYearlyPharmacyReport;
//---------------------------------------------------------------------------
__fastcall TformLaunchYearlyPharmacyReport::TformLaunchYearlyPharmacyReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
  upDownYear->Position = Pstamp(RightNow(), mdy | yyyy | datefirst | withsec).year;
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchYearlyPharmacyReport::btnCloseClick(
      TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchYearlyPharmacyReport::btnRunClick(
      TObject *Sender)
{
  if(editYear->Text == "")
  {
    PSay("Please enter a year", m_missing_data, MB_OK);
    editYear->SetFocus();
  }
  else if(! IsInt(editYear->Text.c_str()))
  {
    PSay("Please enter a valid year", m_invalid_data, MB_OK);
    editYear->SetFocus();
  }
  else
  {
    Processing(true);

    TQRPageList * source = new TQRPageList();
    TQRPageList * destination = new TQRPageList();
    destination->Stream = new TQRStream(100000);
    TQRPrinter * printer_thing = InitTQRPrinter();

    dbWalShawneeDataSet = new TIBDataSet(NULL);
    dbWalOtherDataSet = new TIBDataSet(NULL);
    dbEckShawneeDataSet = new TIBDataSet(NULL);
    dbEckOtherDataSet = new TIBDataSet(NULL);
    dbAllWalDataSet = new TIBDataSet(NULL);
    dbAllEckDataSet = new TIBDataSet(NULL);
    dbTransaction = new TIBTransaction(NULL);
    report_form = new TformReportYearlyPharmacy(NULL);
    
    try
    {
      dbTransaction->DefaultDatabase = dbDatabase;
      dbWalShawneeDataSet->Database = dbDatabase;
      dbWalShawneeDataSet->Transaction = dbTransaction;
      dbWalShawneeDataSet->UniDirectional = false;
      dbWalOtherDataSet->Database = dbDatabase;
      dbWalOtherDataSet->Transaction = dbTransaction;
      dbWalOtherDataSet->UniDirectional = false;
      dbEckShawneeDataSet->Database = dbDatabase;
      dbEckShawneeDataSet->Transaction = dbTransaction;
      dbEckShawneeDataSet->UniDirectional = false;
      dbEckOtherDataSet->Database = dbDatabase;
      dbEckOtherDataSet->Transaction = dbTransaction;
      dbEckOtherDataSet->UniDirectional = false;
      dbAllWalDataSet->Database = dbDatabase;
      dbAllWalDataSet->Transaction = dbTransaction;
      dbAllWalDataSet->UniDirectional = false;
      dbAllEckDataSet->Database = dbDatabase;
      dbAllEckDataSet->Transaction = dbTransaction;
      dbAllEckDataSet->UniDirectional = false;

      dbTransaction->StartTransaction();
      compositeReport->Prepare();

      string file_name = PMakeTempFilePath("page1.qrp");
      ((TQuickRep *)(compositeReport->Reports->First()))->QRPrinter->Save(file_name.c_str());
      source->Clear();
      source->LoadFromFile(file_name.c_str());
      for (int i = 1; i <= source->PageCount; i++)
        destination->AddPage(source->GetPage(i));
      destination->Finish();
      string temp_filepath = PMakeTempFilePath("complete.qrp");
      destination->SaveToFile(temp_filepath.c_str());
      // load combined report and preview
      printer_thing->Load(temp_filepath.c_str());
      Processing(false);
      printer_thing->PreviewModal();

      dbWalShawneeDataSet->Close();
      dbWalOtherDataSet->Close();
      dbEckShawneeDataSet->Close();
      dbEckOtherDataSet->Close();
      dbAllWalDataSet->Close();
      dbAllEckDataSet->Close();
      dbTransaction->Commit();
      report_form->CloseNow();
    }
    catch(...)
    {
      Processing(false);  
      if(dbTransaction->Active)
        dbTransaction->Rollback();
      PSay("Error running report", m_database_error, MB_OK);
    }
    report_form->CloseNow();

    delete dbWalShawneeDataSet;
    delete dbWalOtherDataSet;
    delete dbEckShawneeDataSet;
    delete dbEckOtherDataSet;
    delete dbAllWalDataSet;
    delete dbAllEckDataSet;    
    delete dbTransaction;

    delete printer_thing;
    delete source;
    delete destination;
  }
}
//---------------------------------------------------------------------------
void TformLaunchYearlyPharmacyReport::DrawGraph(TQRImage *image, TIBDataSet* dbDataSet, string pharmacy)
{
  TCanvas * canvas = image->Canvas;
  string title = pharmacy + " Pharmacy Usage";
  string y_title = "$ 100,000.00";
  int x_box_start;
  int y_box_start;
  int box_height;
  int box_width;
  int y_increment = 0;
  financial max = 0.00;
  int num_of_lines = 0;
  int current_y;
  float current_y_value;
  string y_label;
  string max_str = "";
  list<month_struct> data_list;
  month_struct temp_struct;

  // put data in the map and determine the max value
  dbDataSet->First();
  while(! dbDataSet->Eof)
  {
    temp_struct.month_name = dbDataSet->FieldByName("month_name")->AsString.c_str();
    temp_struct.amount_billed = StringToFinancial(dbDataSet->FieldByName("amount_billed")->AsString.c_str());
    if(temp_struct.amount_billed > max)
      max = temp_struct.amount_billed;
    data_list.push_back(temp_struct);
    dbDataSet->Next();
  }
  dbDataSet->First();

  // draw title of chart
  canvas->Font->Name = "Arial";
  canvas->Font->Size = 10;
  canvas->Font->Style = TFontStyles() << fsBold;
  canvas->TextOut(((image->Width/2) - (canvas->TextWidth(title.c_str()) / 2)), 10, title.c_str());

  // draw box for graph
  canvas->Pen->Color = clBlack;
  canvas->Brush->Color = clWhite;  
  x_box_start = canvas->TextWidth(y_title.c_str()) + 5;
  y_box_start = canvas->TextHeight(title.c_str()) + 30;
  box_height = image->Height - y_box_start - 90;//100;
  box_width = image->Width - x_box_start - 20;
  canvas->MoveTo(x_box_start, y_box_start);
  canvas->LineTo(x_box_start, y_box_start + box_height);
  canvas->MoveTo(x_box_start, y_box_start + box_height);
  canvas->LineTo(x_box_start + box_width, y_box_start + box_height);
  canvas->MoveTo(x_box_start + box_width, y_box_start + box_height);
  canvas->LineTo(x_box_start + box_width, y_box_start);
  canvas->MoveTo(x_box_start + box_width, y_box_start);
  canvas->LineTo(x_box_start, y_box_start);

  // draw y titles
  if(max < 15000.00)
  {
    y_increment = 1000;
    max_str = FinancialToString(max, false, 2);
    num_of_lines = StringToInt(max_str.substr(0, 1));
  }
  else if(max < 100000.00)
  {
    y_increment = 10000;
    max_str = FinancialToString(max, false, 2);
    num_of_lines = StringToInt(max_str.substr(0, 1));
  }

  canvas->Font->Size = 8;
  canvas->Font->Style = TFontStyles();
  current_y = y_box_start + box_height;
  current_y_value = 0.0;
  int max_label_width;
  int this_label_width;
  int label_left;

  for(int i = 0; i <= (num_of_lines + 1); i++)
  {
    // draw a horizontal line if not on an edge already
    if((i != 0) && (i != (num_of_lines + 1)))
    {
//      canvas->Pen->Color = clGray;
      canvas->Pen->Color = TColor(0x00B4B4B4);
      canvas->MoveTo(x_box_start + 1, current_y);
      canvas->LineTo(x_box_start + box_width, current_y);
    }
    y_label = "$" + StringToAmount(FloatToString(current_y_value));
    if(i == 0)
      max_label_width = canvas->TextWidth(y_label.c_str());
    label_left = x_box_start - max_label_width - 5;
    this_label_width = canvas->TextWidth(y_label.c_str());
    canvas->TextOut(label_left + max_label_width - this_label_width,
                    current_y - (canvas->TextHeight(y_label.c_str()) / 2), y_label.c_str());
    current_y -= (int)((float)box_height / (num_of_lines + 1.0));
    current_y_value += y_increment;
  } // end for

  // new stuff i've added
  int current_month = 1;
  int x_increment = box_width / 11;
  int current_x = x_box_start;
  int y_max_value = num_of_lines * y_increment;
  int y_multiplier = y_max_value / box_height;
  int last_y;
  if(y_multiplier == 0)
    last_y = y_box_start + box_height;
  else
    last_y = y_box_start + box_height + (y_increment / y_multiplier)
               - ((int)data_list.begin()->amount_billed.AsLongDouble() / y_multiplier);
  int this_y;
  int last_x = current_x;

  LOGFONT lf; // Windows native font structure
  canvas->Brush->Style = bsClear; // set the brush style to transparent
  ZeroMemory(&lf, sizeof(LOGFONT));
  lf.lfHeight = 12;
  lf.lfEscapement = 10 * 90; // degrees to rotate
  lf.lfOrientation = 10 * 90;
  lf.lfCharSet = DEFAULT_CHARSET;
  strcpy(lf.lfFaceName, "Arial");
  canvas->Font->Handle = CreateFontIndirect(&lf);
  int this_title_width;
  int longest_title_width = canvas->TextWidth("September");
  int title_bottom = box_height + y_box_start + longest_title_width + 5;
  int this_title_bottom;

  canvas->Pen->Color = clBlack;
  for(list<month_struct>::iterator itr = data_list.begin(); itr != data_list.end(); itr++)
  {
    this_title_width = canvas->TextWidth(PrettyString(itr->month_name).c_str());
    this_title_bottom = title_bottom - longest_title_width + this_title_width;
    canvas->TextOut(current_x, this_title_bottom, PrettyString(itr->month_name).c_str()); // output the rotated font
    if(y_multiplier == 0)
      this_y = y_box_start + box_height;
    else
      this_y = y_box_start + box_height + (y_increment / y_multiplier) - (itr->amount_billed.AsLongDouble() / y_multiplier);
    if(itr->amount_billed > 0.00)
    {
      canvas->MoveTo(last_x, last_y);
      canvas->LineTo(current_x, this_y);
    }

    last_y = this_y;
    last_x = current_x;
    current_month++;
    current_x += x_increment;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchYearlyPharmacyReport::compositeReportAddReports(
      TObject *Sender)
{
  string sql;
  string year = editYear->Text.c_str();
//  list<string> wal_id_list;
//  list<string> eck_id_list;
  map<string, string> totals_map;
  string distinct_people = "1";

  try
  {
    sql = "select month_types.id, month_types.item month_name, count(pharmacy_info.id) rx_filled, "
          "sum(pharmacy_info.amount_billed) amount_billed, "
          "count(distinct pharmacy_info.person_id) distinct_people "
          "from month_types left join pharmacy_info on pharmacy_info.bill_month = month_types.id "
          "and pharmacy_info.bill_year = " + year + " and "
          "pharmacy_info.pharmacy_location_id > 3 "
          "group by month_types.item, month_types.id "
          "order by month_types.id";

    dbAllWalDataSet->SelectSQL->Clear();
    dbAllWalDataSet->SelectSQL->Add(sql.c_str());
    dbAllWalDataSet->Open();
    dbAllWalDataSet->First();

    sql = "select count(distinct pharmacy_info.person_id) "
          "from pharmacy_info where pharmacy_info.bill_year = " + year +
          " and pharmacy_info.pharmacy_location_id > 3";
    distinct_people = GetOneField(dbTransaction, sql).c_str();

    report_form->reportAllWal->DataSet = dbAllWalDataSet;
    report_form->lblTitle5->Caption = string("Pharmacy Report - " + year).c_str();
    report_form->txtPeriod5->DataSet = dbAllWalDataSet;
    report_form->txtPeriod5->DataField = "month_name";
    report_form->txtRxFilled5->DataSet = dbAllWalDataSet;
    report_form->txtRxFilled5->DataField = "rx_filled";
    report_form->exprAmount5->Expression = "FORMATNUMERIC('$#,##0.00', amount_billed)";
    report_form->txtPeople5->DataSet = dbAllWalDataSet;
    report_form->txtPeople5->DataField = "distinct_people";
    report_form->exprPeopleCost5->Expression = "FORMATNUMERIC('$#,##0.00', (amount_billed/distinct_people))";
    report_form->exprRxCost5->Expression = "FORMATNUMERIC('$#,##0.00', (amount_billed/rx_filled))";
    report_form->exprTotalFilled5->Expression = "SUM(rx_filled)";
    report_form->exprTotalAmount5->Expression = "FORMATNUMERIC('$#,##0.00', SUM(amount_billed))";
    if(StringToInt(distinct_people) > 0)
      report_form->exprTotalPerMember5->Expression = string("FORMATNUMERIC('$#,##0.00', (SUM(amount_billed)/" +
                                                    distinct_people + "))").c_str();
    report_form->exprTotalRxCost5->Expression = "FORMATNUMERIC('$#,##0.00', (SUM(amount_billed)/SUM(rx_filled)))";
    report_form->lblTotalPeople5->Caption = distinct_people.c_str();

    DrawGraph(report_form->chartWal, dbAllWalDataSet, "Wal Mart");

    compositeReport->Reports->Add(report_form->reportAllWal);

    //----------------------------

    sql = "select month_types.id, month_types.item month_name, count(pharmacy_info.id) rx_filled, "
          "sum(pharmacy_info.amount_billed) amount_billed, "
          "count(distinct pharmacy_info.person_id) distinct_people "
          "from month_types left join pharmacy_info on pharmacy_info.bill_month = month_types.id "
          "and pharmacy_info.bill_year = " + year + " and "
          "pharmacy_info.pharmacy_location_id <= 3 "
          "group by month_types.item, month_types.id "
          "order by month_types.id";

    dbAllEckDataSet->SelectSQL->Clear();
    dbAllEckDataSet->SelectSQL->Add(sql.c_str());
    dbAllEckDataSet->Open();
    dbAllEckDataSet->First();

    sql = "select count(distinct pharmacy_info.person_id) "
          "from pharmacy_info where pharmacy_info.bill_year = " + year +
          " and pharmacy_info.pharmacy_location_id <= 3";
    distinct_people = GetOneField(dbTransaction, sql).c_str();

    report_form->reportAllEck->DataSet = dbAllEckDataSet;
    report_form->lblTitle6->Caption = string("Pharmacy Report - " + year).c_str();
    report_form->txtPeriod6->DataSet = dbAllEckDataSet;
    report_form->txtPeriod6->DataField = "month_name";
    report_form->txtRxFilled6->DataSet = dbAllEckDataSet;
    report_form->txtRxFilled6->DataField = "rx_filled";
    report_form->exprAmount6->Expression = "FORMATNUMERIC('$#,##0.00', amount_billed)";
    report_form->txtPeople6->DataSet = dbAllEckDataSet;
    report_form->txtPeople6->DataField = "distinct_people";
    report_form->exprPeopleCost6->Expression = "FORMATNUMERIC('$#,##0.00', (amount_billed/distinct_people))";
    report_form->exprRxCost6->Expression = "FORMATNUMERIC('$#,##0.00', (amount_billed/rx_filled))";
    report_form->exprTotalFilled6->Expression = "SUM(rx_filled)";
    report_form->exprTotalAmount6->Expression = "FORMATNUMERIC('$#,##0.00', SUM(amount_billed))";
    if(StringToInt(distinct_people) > 0)
      report_form->exprTotalPerMember6->Expression = string("FORMATNUMERIC('$#,##0.00', (SUM(amount_billed)/" +
                                                    distinct_people + "))").c_str();
    report_form->exprTotalRxCost6->Expression = "FORMATNUMERIC('$#,##0.00', (SUM(amount_billed)/SUM(rx_filled)))";
    report_form->lblTotalPeople6->Caption = distinct_people.c_str();

    DrawGraph(report_form->chartEck, dbAllEckDataSet, "Eckerd");    

    compositeReport->Reports->Add(report_form->reportAllEck);

    //----------------------------

    sql = "select month_types.id, month_types.item month_name, count(pharmacy_info.id) rx_filled, "
          "sum(pharmacy_info.amount_billed) amount_billed, "
          "count(distinct pharmacy_info.person_id) distinct_people "
          "from month_types left join pharmacy_info on pharmacy_info.bill_month = month_types.id "
          "and pharmacy_info.bill_year = " + year + " and "
          "pharmacy_info.pharmacy_location_id = 184 "
          "group by month_types.item, month_types.id "
          "order by month_types.id";

    dbWalShawneeDataSet->SelectSQL->Clear();
    dbWalShawneeDataSet->SelectSQL->Add(sql.c_str());
    dbWalShawneeDataSet->Open();
    dbWalShawneeDataSet->First();

    sql = "select count(distinct pharmacy_info.person_id) "
          "from pharmacy_info where pharmacy_info.bill_year = " + year + " and "
          "pharmacy_info.pharmacy_location_id = 184";
    distinct_people = GetOneField(dbTransaction, sql).c_str();

    report_form->reportWalShawnee->DataSet = dbWalShawneeDataSet;
    report_form->lblTitle1->Caption = string("Pharmacy Report - " + year).c_str();
    report_form->txtPeriod1->DataSet = dbWalShawneeDataSet;
    report_form->txtPeriod1->DataField = "month_name";
    report_form->txtRxFilled1->DataSet = dbWalShawneeDataSet;    
    report_form->txtRxFilled1->DataField = "rx_filled";
    report_form->exprAmount1->Expression = "FORMATNUMERIC('$#,##0.00', amount_billed)";
    report_form->txtPeople1->DataSet = dbWalShawneeDataSet;
    report_form->txtPeople1->DataField = "distinct_people";
    report_form->exprPeopleCost1->Expression = "FORMATNUMERIC('$#,##0.00', (amount_billed/distinct_people))";
    report_form->exprRxCost1->Expression = "FORMATNUMERIC('$#,##0.00', (amount_billed/rx_filled))";
    report_form->exprTotalFilled1->Expression = "SUM(rx_filled)";
    report_form->exprTotalAmount1->Expression = "FORMATNUMERIC('$#,##0.00', SUM(amount_billed))";
    if(StringToInt(distinct_people) > 0)
      report_form->exprTotalPerMember1->Expression = string("FORMATNUMERIC('$#,##0.00', (SUM(amount_billed)/" +
                                                    distinct_people + "))").c_str();
    report_form->exprTotalRxCost1->Expression = "FORMATNUMERIC('$#,##0.00', (SUM(amount_billed)/SUM(rx_filled)))";
    report_form->lblTotalPeople1->Caption = distinct_people.c_str();

    compositeReport->Reports->Add(report_form->reportWalShawnee);

    //----------------------------
    sql = "select month_types.id, month_types.item month_name, count(pharmacy_info.id) rx_filled, "
          "sum(pharmacy_info.amount_billed) amount_billed, "
          "count(distinct pharmacy_info.person_id) distinct_people "
          "from month_types left join pharmacy_info on pharmacy_info.bill_month = month_types.id "
          "and pharmacy_info.bill_year = " + year + " and "
          "pharmacy_info.pharmacy_location_id != 184 and "
          "pharmacy_info.pharmacy_location_id > 3 "
          "group by month_types.item, month_types.id "
          "order by month_types.id";

    dbWalOtherDataSet->SelectSQL->Clear();
    dbWalOtherDataSet->SelectSQL->Add(sql.c_str());
    dbWalOtherDataSet->Open();
    dbWalOtherDataSet->First();

    sql = "select count(distinct pharmacy_info.person_id) "
          "from pharmacy_info where pharmacy_info.bill_year = " + year + " and "
          "pharmacy_info.pharmacy_location_id = 184";
    distinct_people = GetOneField(dbTransaction, sql).c_str();

    report_form->reportWalOther->DataSet = dbWalOtherDataSet;
    report_form->txtPeriod2->DataSet = dbWalOtherDataSet;
    report_form->txtPeriod2->DataField = "month_name";
    report_form->txtRxFilled2->DataSet = dbWalOtherDataSet;
    report_form->txtRxFilled2->DataField = "rx_filled";
    report_form->exprAmount2->Expression = "FORMATNUMERIC('$#,##0.00', amount_billed)";
    report_form->txtPeople2->DataSet = dbWalOtherDataSet;
    report_form->txtPeople2->DataField = "distinct_people";
    report_form->exprPeopleCost2->Expression = "FORMATNUMERIC('$#,##0.00', (amount_billed/distinct_people))";
    report_form->exprRxCost2->Expression = "FORMATNUMERIC('$#,##0.00', (amount_billed/rx_filled))";
    report_form->exprTotalFilled2->Expression = "SUM(rx_filled)";
    report_form->exprTotalAmount2->Expression = "FORMATNUMERIC('$#,##0.00', SUM(amount_billed))";
    if(StringToInt(distinct_people) > 0)
      report_form->exprTotalPerMember2->Expression = string("FORMATNUMERIC('$#,##0.00', (SUM(rx_filled)/" +
                                                    distinct_people + "))").c_str();
    report_form->exprTotalRxCost2->Expression = "FORMATNUMERIC('$#,##0.00', (SUM(amount_billed)/SUM(rx_filled)))";
    report_form->lblTotalPeople2->Caption = distinct_people.c_str();

    sql = "select count(pharmacy_info.id) rx_filled, "
          "sum(pharmacy_info.amount_billed) amount_billed, "
          "count(distinct pharmacy_info.person_id) distinct_people "
          "from pharmacy_info "
          "where pharmacy_info.pharmacy_location_id > 3 and "
          "pharmacy_info.bill_year = " + year;
    SqlToMap(dbTransaction, sql, totals_map);
    report_form->lblWalTotalFilled->Caption = totals_map["rx_filled"].c_str();
    report_form->exprWalTotalAmount->Expression = string("FORMATNUMERIC('$###,##0.00', " + totals_map["amount_billed"] + ")").c_str();
    report_form->lblWalTotalPeople->Caption = totals_map["distinct_people"].c_str();
    report_form->exprWalTotalPerMember->Expression = string("FORMATNUMERIC('$#,##0.00', (" +
       totals_map["amount_billed"] + "/" + totals_map["distinct_people"] + "))").c_str();
    report_form->exprWalTotalRxCost->Expression = string("FORMATNUMERIC('$#,##0.00', (" +
       totals_map["amount_billed"] + "/" + totals_map["rx_filled"] + "))").c_str();

    compositeReport->Reports->Add(report_form->reportWalOther);

    //----------------------------

    sql = "select month_types.id, month_types.item month_name, count(pharmacy_info.id) rx_filled, "
          "sum(pharmacy_info.amount_billed) amount_billed, "
          "count(distinct pharmacy_info.person_id) distinct_people "
          "from month_types left join pharmacy_info on pharmacy_info.bill_month = month_types.id "
          "and pharmacy_info.bill_year = " + year + " and "
          "pharmacy_info.pharmacy_location_id = 3 "
          "group by month_types.item, month_types.id "
          "order by month_types.id";

    dbEckShawneeDataSet->SelectSQL->Clear();
    dbEckShawneeDataSet->SelectSQL->Add(sql.c_str());
    dbEckShawneeDataSet->Open();
    dbEckShawneeDataSet->First();

    sql = "select count(distinct pharmacy_info.person_id) "
          "from pharmacy_info where pharmacy_info.bill_year = " + year + " and "
          "pharmacy_info.pharmacy_location_id = 3";
    distinct_people = GetOneField(dbTransaction, sql).c_str();


    report_form->reportEckShawnee->DataSet = dbEckShawneeDataSet;
    report_form->lblTitle3->Caption = string("Pharmacy Report - " + year).c_str();
    report_form->txtPeriod3->DataSet = dbEckShawneeDataSet;
    report_form->txtPeriod3->DataField = "month_name";
    report_form->txtRxFilled3->DataSet = dbEckShawneeDataSet;
    report_form->txtRxFilled3->DataField = "rx_filled";
    report_form->exprAmount3->Expression = "FORMATNUMERIC('$#,##0.00', amount_billed)";
    report_form->txtPeople3->DataSet = dbEckShawneeDataSet;
    report_form->txtPeople3->DataField = "distinct_people";
    report_form->exprPeopleCost3->Expression = "FORMATNUMERIC('$#,##0.00', (amount_billed/distinct_people))";
    report_form->exprRxCost3->Expression = "FORMATNUMERIC('$#,##0.00', (amount_billed/rx_filled))";
    report_form->exprTotalFilled3->Expression = "SUM(rx_filled)";
    report_form->exprTotalAmount3->Expression = "FORMATNUMERIC('$#,##0.00', SUM(amount_billed))";
    if(StringToInt(distinct_people) > 0)
      report_form->exprTotalPerMember3->Expression = string("FORMATNUMERIC('$#,##0.00', (SUM(amount_billed)/" +
                                                    distinct_people + "))").c_str();
    report_form->exprTotalRxCost3->Expression = "FORMATNUMERIC('$#,##0.00', (SUM(amount_billed)/SUM(rx_filled)))";
    report_form->lblTotalPeople3->Caption = distinct_people.c_str();

    compositeReport->Reports->Add(report_form->reportEckShawnee);

    //----------------------------

    sql = "select month_types.id, month_types.item month_name, count(pharmacy_info.id) rx_filled, "
          "sum(pharmacy_info.amount_billed) amount_billed, "
          "count(distinct pharmacy_info.person_id) distinct_people "
          "from month_types left join pharmacy_info on pharmacy_info.bill_month = month_types.id "
          "and pharmacy_info.bill_year = " + year + " and "
          "pharmacy_info.pharmacy_location_id < 3 "
          "group by month_types.item, month_types.id "
          "order by month_types.id";

    dbEckOtherDataSet->SelectSQL->Clear();
    dbEckOtherDataSet->SelectSQL->Add(sql.c_str());
    dbEckOtherDataSet->Open();
    dbEckOtherDataSet->First();

    sql = "select count(distinct pharmacy_info.person_id) "
          "from pharmacy_info where pharmacy_info.bill_year = " + year + " and "
          "pharmacy_info.pharmacy_location_id < 3";
    distinct_people = GetOneField(dbTransaction, sql).c_str();

    report_form->reportEckOther->DataSet = dbEckOtherDataSet;
    report_form->txtPeriod4->DataSet = dbEckOtherDataSet;
    report_form->txtPeriod4->DataField = "month_name";
    report_form->txtRxFilled4->DataSet = dbEckOtherDataSet;
    report_form->txtRxFilled4->DataField = "rx_filled";
    report_form->exprAmount4->Expression = "FORMATNUMERIC('$#,##0.00', amount_billed)";
    report_form->txtPeople4->DataSet = dbEckOtherDataSet;
    report_form->txtPeople4->DataField = "distinct_people";
    report_form->exprPeopleCost4->Expression = "FORMATNUMERIC('$#,##0.00', (amount_billed/distinct_people))";
    report_form->exprRxCost4->Expression = "FORMATNUMERIC('$#,##0.00', (amount_billed/rx_filled))";
    report_form->exprTotalFilled4->Expression = "SUM(rx_filled)";
    report_form->exprTotalAmount4->Expression = "FORMATNUMERIC('$#,##0.00', SUM(amount_billed))";
    if(StringToInt(distinct_people) > 0)
      report_form->exprTotalPerMember4->Expression = string("FORMATNUMERIC('$#,##0.00', (SUM(rx_filled)/" +
                                                    distinct_people + "))").c_str();
    report_form->exprTotalRxCost4->Expression = "FORMATNUMERIC('$#,##0.00', (SUM(amount_billed)/SUM(rx_filled)))";
    report_form->lblTotalPeople4->Caption = distinct_people.c_str();

    sql = "select count(pharmacy_info.id) rx_filled, "
          "sum(pharmacy_info.amount_billed) amount_billed, "
          "count(distinct pharmacy_info.person_id) distinct_people "
          "from pharmacy_info "
          "where pharmacy_info.pharmacy_location_id <= 3 and "
          "pharmacy_info.bill_year = " + year;
    SqlToMap(dbTransaction, sql, totals_map);
    report_form->lblEckTotalFilled->Caption = totals_map["rx_filled"].c_str();
    report_form->exprEckTotalAmount->Expression = string("FORMATNUMERIC('$###,##0.00', " + totals_map["amount_billed"] + ")").c_str();
    report_form->lblEckTotalPeople->Caption = totals_map["distinct_people"].c_str();
    report_form->exprEckTotalPerMember->Expression = string("FORMATNUMERIC('$#,##0.00', (" +
       totals_map["amount_billed"] + "/" + totals_map["distinct_people"] + "))").c_str();
    report_form->exprEckTotalRxCost->Expression = string("FORMATNUMERIC('$#,##0.00', (" +
       totals_map["amount_billed"] + "/" + totals_map["rx_filled"] + "))").c_str();

    sql = "select count(pharmacy_info.id) rx_filled, "
          "sum(pharmacy_info.amount_billed) amount_billed, "
          "count(distinct pharmacy_info.person_id) distinct_people "
          "from pharmacy_info "
          "where pharmacy_info.bill_year = " + year;
    SqlToMap(dbTransaction, sql, totals_map);
    report_form->lblAllTotalFilled->Caption = totals_map["rx_filled"].c_str();
    report_form->exprAllTotalAmount->Expression = string("FORMATNUMERIC('$###,##0.00', " + totals_map["amount_billed"] + ")").c_str();
    report_form->lblAllTotalPeople->Caption = totals_map["distinct_people"].c_str();
    report_form->exprAllTotalPerMember->Expression = string("FORMATNUMERIC('$#,##0.00', (" +
       totals_map["amount_billed"] + "/" + totals_map["distinct_people"] + "))").c_str();
    report_form->exprAllTotalRxCost->Expression = string("FORMATNUMERIC('$#,##0.00', (" +
       totals_map["amount_billed"] + "/" + totals_map["rx_filled"] + "))").c_str();

    compositeReport->Reports->Add(report_form->reportEckOther);

  //----------------------------

  }
  catch(...)
  {

  }
}
//---------------------------------------------------------------------------
void __fastcall TformLaunchYearlyPharmacyReport::FormShortCut(TWMKey &Msg,
      bool &Handled)
{
  Handled = true;
  if (Msg.CharCode == VK_RETURN)
    btnRun->Click();
  else
    Handled = false;

  if (!Handled)
    TformSpecialGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------

