//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reportAppointmentListing.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformReportAppointmentListing *formReportAppointmentListing;
//---------------------------------------------------------------------------
__fastcall TformReportAppointmentListing::TformReportAppointmentListing(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformReportAppointmentListing::reportAfterPreview(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------

void __fastcall TformReportAppointmentListing::txtForPrint(TObject *sender,
      AnsiString &Value)
{
  Value = PrettyString(Value.c_str()).c_str();        
}
//---------------------------------------------------------------------------

void __fastcall TformReportAppointmentListing::txtPersonPrint(
      TObject *sender, AnsiString &Value)
{
  string temp = Value.c_str();
  if(temp.length() <= 3)
    temp = "";
  else
    temp = PrettyString(temp);
  Value = temp.c_str();        
}
//---------------------------------------------------------------------------

void __fastcall TformReportAppointmentListing::txtDescriptionPrint(
      TObject *sender, AnsiString &Value)
{
  Value = SentenceString(Value.c_str()).c_str();        
}
//---------------------------------------------------------------------------

void __fastcall TformReportAppointmentListing::txtDurationPrint(
      TObject *sender, AnsiString &Value)
{
  string temp = Value.c_str();
  temp = LowercaseString(temp);
  if(temp.length() > 3)
  {
    if((temp[0] == '1') && (temp[1] == ' '))
      temp = temp.substr(0, temp.length()-1);
  }
  Value = temp.c_str();
}
//---------------------------------------------------------------------------

void __fastcall TformReportAppointmentListing::bandSimpleAppointmentBeforePrint(
      TQRCustomBand *Sender, bool &PrintBand)
{
 // code copied and modified from recordAppointment
 int duration = StringToInt(reportSimple->DataSet->FieldByName("duration")->AsString.c_str());
 string duration_type = LowercaseString(lookupTables->ValueOf("duration_types", reportSimple->DataSet->FieldByName("duration_id")->AsString.c_str()));

 Pdate beg_date(reportSimple->DataSet->FieldByName("appt_date")->AsString.c_str(), global_mode);
 Ptime beg_time(reportSimple->DataSet->FieldByName("appt_time")->AsString.c_str(), global_mode);
 Pstamp beg_stamp;
 Pstamp end_stamp;
 beg_stamp.InDate(beg_date); // TODO: really need some better constructors, and a "Pstamp operator + (Pdate, Ptime)"
 beg_stamp.InTime(beg_time);
 end_stamp = beg_stamp;

 if((duration > 0) && (duration_type != ""))
 {
   if(duration_type == "minutes")
     end_stamp.mod(duration, in_minutes);
   else if(duration_type == "hours")
     end_stamp.mod(duration, in_hours);
   else if(duration_type == "days")
     end_stamp.mod(duration, in_days);
   else if(duration_type == "weeks")
     end_stamp.mod(duration, in_weeks);
   else if(duration_type == "months")
     end_stamp.mod(duration, in_months);
   else if(duration_type == "years")
     end_stamp.mod(duration, in_years);
 }
 if ((Pdate)beg_stamp == (Pdate)end_stamp)
  labelSimpleTime->Caption = string(beg_stamp.OutTime(global_mode) + " - " + end_stamp.OutTime(global_mode)).c_str();
 else
  labelSimpleTime->Caption = string(beg_stamp.OutTime(global_mode) + " - " + end_stamp.OutStamp(global_mode)).c_str();

 // labelSimpleTime->Caption = labelSimpleTime->Caption + string(IntToString(duration) + " " + duration_type).c_str();
}
//---------------------------------------------------------------------------


void __fastcall TformReportAppointmentListing::bandSimpleDateBeforePrint(
      TQRCustomBand *Sender, bool &PrintBand)
{
 // set name of day of week
 Pdate temp(reportSimple->DataSet->FieldByName("appt_date")->AsString.c_str(), global_mode);
 labelSimpleDayName->Caption = temp.NameOfDay().c_str();
}
//---------------------------------------------------------------------------

