//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "reportBudget.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformReportBudget *formReportBudget;
//---------------------------------------------------------------------------
__fastcall TformReportBudget::TformReportBudget(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
   // GroupHeaderBand->Expression = "STR(fund_id) + STR(department_id)";
   // GroupHeaderBand2->Expression = "STR(budget_id)";
   GroupTitle->Expression = "title";
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudget::GroupChildBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
   if (is_summary)
   {
      GroupChild->Height = 0;
      PrintBand = false;
   } else
   {
    if (string(textEntityName->DataSet->FieldByName("tx_date")->AsString.c_str()) == "")
     PrintBand = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudget::DetailBandBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
   if (is_summary)
   {
      DetailBand->Height = 0;
      PrintBand = false;
   } else
   {
    if (string(textEntityName->DataSet->FieldByName("tx_date")->AsString.c_str()) == "")
     PrintBand = false;
    textEntityName->Transparent = true;
    if (StringToFinancial(textEntityName->DataSet->FieldByName("tx_amount")->AsString.c_str()) == 0.00)
     PrintBand = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudget::GroupFooterBand2BeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
   if (is_summary)
   {
      GroupFooterBand2->Height = 0;
      PrintBand = false;
   } else
   {
    if (StringToFinancial(labelTotalCheck->Caption.c_str()) == 0.00 &&
        StringToFinancial(labelTotalPurchaseReq->Caption.c_str()) == 0.00 &&
        StringToFinancial(labelTotalBill->Caption.c_str()) == 0.00 &&
        StringToFinancial(labelTotalOther->Caption.c_str()) == 0.00)
     PrintBand = false;

    labelTotalCheck->Font->Color       = (StringToFinancial(labelTotalCheck->Caption.c_str()) != 0.00) ? clGray : clWhite;
    labelTotalPurchaseReq->Font->Color = (StringToFinancial(labelTotalPurchaseReq->Caption.c_str()) != 0.00) ? clGray : clWhite;
    labelTotalBill->Font->Color        = (StringToFinancial(labelTotalBill->Caption.c_str()) != 0.00) ? clGray : clWhite;
    labelTotalOther->Font->Color       = (StringToFinancial(labelTotalOther->Caption.c_str()) != 0.00) ? clGray : clWhite;

    labelOnACheck->Font->Color       = (StringToFinancial(labelTotalCheck->Caption.c_str()) != 0.00) ? clGray : clWhite;
    labelOnAPurchaseReq->Font->Color = (StringToFinancial(labelTotalPurchaseReq->Caption.c_str()) != 0.00) ? clGray : clWhite;
    labelOnABill->Font->Color        = (StringToFinancial(labelTotalBill->Caption.c_str()) != 0.00) ? clGray : clWhite;
    labelOnNothing->Font->Color      = (StringToFinancial(labelTotalOther->Caption.c_str()) != 0.00) ? clGray : clWhite;

    labelTotalCheck->Caption       = ("$" + string(labelTotalCheck->Caption.c_str())).c_str();
    labelTotalPurchaseReq->Caption = ("$" + string(labelTotalPurchaseReq->Caption.c_str())).c_str();
    labelTotalBill->Caption        = ("$" + string(labelTotalBill->Caption.c_str())).c_str();
    labelTotalOther->Caption       = ("$" + string(labelTotalOther->Caption.c_str())).c_str();
   }
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudget::GroupFooterBandBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
//   GroupFooterBand->Height = 0;
//   PrintBand = false;
   if (is_summary)
   {
      financial amount_spent  = StringToFinancial(lblTotalAmountSpent->Caption.c_str());
      financial amount_budget = StringToFinancial(lblTotalBudgetAmount->Caption.c_str());
      if (amount_budget != 0.00)
       lblTotalPercentSpent->Caption = FinancialToString(100.00 * amount_spent / amount_budget, false, 1).c_str(); // TODO: with_comma screws up precision
      else
       lblTotalPercentSpent->Caption = ""; // "unk."

      lblTotalAmountSpent->Caption = ("$" + string(lblTotalAmountSpent->Caption.c_str())).c_str();
      lblTotalBudgetAmount->Caption = ("$" + string(lblTotalBudgetAmount->Caption.c_str())).c_str();
      lblTotalAmountRemaining->Caption = ("$" + string(lblTotalAmountRemaining->Caption.c_str())).c_str();
   }
   else
   {
      GroupFooterBand->Height = 0;
      PrintBand = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudget::exprAmountSpentPrint(TObject *sender, AnsiString &Value)
{
   if (is_summary)
   {
      financial original_amount    = StringToFinancial(lblTotalAmountSpent->Caption.c_str());
      financial updated_amount     = StringToFinancial(Value.c_str());
      lblTotalAmountSpent->Caption = FinancialToString(original_amount + updated_amount, true).c_str();

      last_spent_amount = StringToFinancial(Value.c_str());
   }
}
//---------------------------------------------------------------------------

void __fastcall TformReportBudget::GroupFooterBandAfterPrint(TQRCustomBand *Sender, bool BandPrinted)
{
// reset to zero after printing it
    lblTotalAmountSpent->Caption     = "0.00";
    lblTotalBudgetAmount->Caption    = "0.00";
    lblTotalAmountRemaining->Caption = "0.00";
    lblTotalPercentSpent->Caption    = "0.0";
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudget::GroupHeaderBand2BeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
/*
   if (!is_summary)
   {
      // QRShape3->Pen->Width = 3;
      txtLineItem->Font->Style = TFontStyles()<< fsBold;
   }
*/
   // if summary, eliminate the extra horizontal line between line items
   if (/*is_summary && */QRShape3->Enabled)
   {
      int line_height = QRShape3->Height;
      QRShape3->Enabled = false;
      GroupHeaderBand2->Height -= line_height;
   }
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudget::exprCheckNumberPrint(TObject *sender, AnsiString &Value)
{
   if (Value == "0")
      Value = "";
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudget::reportBudgetAfterPreview(TObject *Sender)
{
   // No memory leaks today, thanks!
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudget::lblTitlePrint(TObject *sender, AnsiString &Value)
{
   if (!is_summary)
      Value = "Detail Budget Report";
}
//----------------------------------------------------------------------------
void __fastcall TformReportBudget::reportBudgetBeforePrint(
      TCustomQuickRep *Sender, bool &PrintReport)
{
   lblTotalAmountSpent->Caption = "0.00";
   // is_budget_adjustment = false;
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudget::textEntityNamePrint(TObject *sender,AnsiString &Value)
{
    //Value = PrettyString(Value.c_str()).c_str();
    textEntityName->Transparent = false;
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudget::exprBudgetAmountPrint(TObject *sender, AnsiString &Value)
{
   if (is_summary)
   {
      financial original_amount     = StringToFinancial(lblTotalBudgetAmount->Caption.c_str());
      financial updated_amount      = StringToFinancial(Value.c_str());
      lblTotalBudgetAmount->Caption = FinancialToString(original_amount + updated_amount, true).c_str();

      last_budget_amount = StringToFinancial(Value.c_str());
   }
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudget::exprAmountRemainingPrint(TObject *sender, AnsiString &Value)
{
   if (is_summary)
   {
      financial original_amount        = StringToFinancial(lblTotalAmountRemaining->Caption.c_str());
      financial updated_amount         = StringToFinancial(Value.c_str());
      lblTotalAmountRemaining->Caption = FinancialToString(original_amount + updated_amount, true).c_str();
   }
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudget::GroupFooterBand2AfterPrint(TQRCustomBand *Sender, bool BandPrinted)
{
 labelTotalCheck->Caption       = "0.00";
 labelTotalPurchaseReq->Caption = "0.00";
 labelTotalBill->Caption        = "0.00";
 labelTotalOther->Caption       = "0.00";
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudget::exprInvoiceAmountPrint(TObject *sender, AnsiString &Value)
{
 if (textEntityName->DataSet->FieldByName("check_id")->AsString != "")
  labelTotalCheck->Caption = FinancialToString(StringToFinancial(labelTotalCheck->Caption.c_str()) + StringToFinancial(Value.c_str()), true).c_str();
 else if (textEntityName->DataSet->FieldByName("pr_id")->AsString != "")
  labelTotalPurchaseReq->Caption = FinancialToString(StringToFinancial(labelTotalPurchaseReq->Caption.c_str()) + StringToFinancial(Value.c_str()), true).c_str();
 else if (textEntityName->DataSet->FieldByName("bill_id")->AsString != "")
  labelTotalBill->Caption = FinancialToString(StringToFinancial(labelTotalBill->Caption.c_str()) + StringToFinancial(Value.c_str()), true).c_str();
 else
  labelTotalOther->Caption = FinancialToString(StringToFinancial(labelTotalOther->Caption.c_str()) + StringToFinancial(Value.c_str()), true).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudget::labelPercentSpentPrint(TObject *sender,AnsiString &Value)
{
 if (last_budget_amount != 0.00)
  Value = FinancialToString(100.00 * last_spent_amount / last_budget_amount, false, 1).c_str(); // TODO: with_comma screws up precision
 else
  Value = ""; // "unk."
}
//---------------------------------------------------------------------------

