//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reportBudgetMods.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformReportBudgetMods *formReportBudgetMods;
//---------------------------------------------------------------------------
__fastcall TformReportBudgetMods::TformReportBudgetMods(TComponent* Owner, map<string, vector<financial> > * p_extra_data)
        : TformSpecialGeneric(Owner), extra_data(p_extra_data)
{
 reprint_note = true;
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudgetMods::reportBudgetModsAfterPreview(
      TObject *Sender)
{
 Close(); // no memory leaks?
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudgetMods::bandTransactionBeforePrint(
      TQRCustomBand *Sender, bool &PrintBand)
{
 string current_note = string(reportBudgetMods->DataSet->FieldByName("note")->AsString.c_str());
 txtNote->Enabled = (current_note != previous_note || reprint_note || txtGroupInfo->DataField != "fiscal_date");
 reprint_note = false;
 previous_note = current_note;

 // fill in amounts
 string tx_id = string(reportBudgetMods->DataSet->FieldByName("tx_id")->AsString.c_str());
 map<string, vector<financial> >::iterator i_tx_info = (*extra_data).find(tx_id);
 if (i_tx_info != (*extra_data).end() && i_tx_info->second.size() > 2)
 {
  labelPreviousBudget->Caption = FinancialToString(i_tx_info->second[0], true).c_str();
  labelMod->Caption            = FinancialToString(i_tx_info->second[1], true).c_str();
  labelNewBudget->Caption      = FinancialToString(i_tx_info->second[2], true).c_str();
 } else
 {
  labelPreviousBudget->Caption = "error";
  labelMod->Caption            = tx_id.c_str();
  labelNewBudget->Caption      = IntToString(i_tx_info->second.size()).c_str();
 }
}
//---------------------------------------------------------------------------
void __fastcall TformReportBudgetMods::txtNotePrint(TObject *sender,
      AnsiString &Value)
{
 Value = SentenceString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------


void __fastcall TformReportBudgetMods::bandNumberBeforePrint(
      TQRCustomBand *Sender, bool &PrintBand)
{
 // hide if not needed?
 if (txtGroupInfo->DataField != "fiscal_date")
  bandNumber->Height = 0;
}
//---------------------------------------------------------------------------

void __fastcall TformReportBudgetMods::bandGroupInfoAfterPrint(
      TQRCustomBand *Sender, bool BandPrinted)
{
 reprint_note = true;
}
//---------------------------------------------------------------------------

