//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reportBulkEOB.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformReportBulkEOB *formReportBulkEOB;
//---------------------------------------------------------------------------
__fastcall TformReportBulkEOB::TformReportBulkEOB(TComponent* Owner, bool is_justification)
        : TformSpecialGeneric(Owner)
{
 t_charged = t_billed = t_allowed = t_paid = financial(0.00);
 is_t_charged = is_t_billed = is_t_allowed = is_t_paid = false;
 z_charged = z_billed = z_allowed = z_paid = financial(0.00);

 if (!is_justification)
 {
  R_report   = qpBulkEOB;
  D_charged  = qrpCharged;
  D_billed   = qrpBilled;
  D_allowed  = qrpAllowed;                                        
  D_writeoff = qrpWriteOff;
  D_paid     = qrpPaid;
  T_charged  = qrpTotalCharged;
  T_billed   = qrpTotalBilled;
  T_allowed  = qrpTotalAllowed;
  T_writeoff = qrpTotalWriteOff;
  T_paid     = qrpTotalPaid;
 } else
 {
  R_report   = reportJustification;
  D_charged  = numCharged;
  D_billed   = NULL;
  D_allowed  = numAllowed;
  D_writeoff = NULL;
  D_paid     = numPaid;
  T_charged  = totCharged;
  T_billed   = NULL;
  T_allowed  = totAllowed;
  T_writeoff = NULL;
  T_paid     = totPaid;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformReportBulkEOB::bandGroupBeforePrint(
      TQRCustomBand *Sender, bool &PrintBand)
{
 if (Sender == bandGroup)
  bandGroup->Frame->DrawTop = !(qpBulkEOB->DataSet->Bof);
 else
  bandPatientHeader->Height = /*(reportJustification->DataSet->Bof) ? 0 :*/ 8; // that didn't quite work out after page transitions -- might check the above too?
}
//---------------------------------------------------------------------------
void __fastcall TformReportBulkEOB::w(TObject *sender,
      AnsiString &Value)
{
 Value = PrettyString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportBulkEOB::bandDetailBeforePrint(
      TQRCustomBand *Sender, bool &PrintBand)
{
 if (R_report == reportJustification)
 {
  string new_id = R_report->DataSet->FieldByName("id")->AsString.c_str();
  if (new_id != prev_id)
  {
   textName->Caption = PrettyString(R_report->DataSet->FieldByName("name")->AsString.c_str()).c_str();
   textAccount->Caption = R_report->DataSet->FieldByName("patient_control_number")->AsString.c_str();
  } else
  {
   textName->Caption = "";
   textAccount->Caption = "";
  }
  prev_id = R_report->DataSet->FieldByName("id")->AsString.c_str();
 }

 // setup fields
 string s_charged = R_report->DataSet->FieldByName("charged")->AsString.c_str();
 string s_billed  = R_report->DataSet->FieldByName("billed")->AsString.c_str();
 string s_allowed = R_report->DataSet->FieldByName("allowed")->AsString.c_str();
 string s_paid    = R_report->DataSet->FieldByName("paid")->AsString.c_str();

 financial f_charged = StringToFinancial(s_charged);
 financial f_billed  = StringToFinancial(s_billed);
 financial f_allowed = StringToFinancial(s_allowed);
 financial f_paid    = StringToFinancial(s_paid);

 if (s_charged != "")
 {
  if (D_charged)
   D_charged->Caption = ("$ " + FinancialToString(f_charged, true)).c_str();
  is_t_charged = true;
  t_charged += f_charged;
 } else
  if (D_charged)
   D_charged->Caption = "unk.";

 if (s_billed != "")
 {
  if (D_billed)
   D_billed->Caption = ("$ " + FinancialToString(f_billed, true)).c_str();
  is_t_billed = true;
  t_billed += f_billed;
 } else
  if (D_billed)
   D_billed->Caption = "unk.";

 if (s_allowed != "")
 {
  if (D_allowed)
   D_allowed->Caption = ("$ " + FinancialToString(f_allowed, true)).c_str();
  is_t_allowed = true;
  t_allowed += f_allowed;
 } else
  if (D_allowed)
   D_allowed->Caption = "unk.";

 if (s_paid != "")
 {
  if (D_paid)
   D_paid->Caption = ("$ " + FinancialToString(f_paid, true)).c_str();
  is_t_paid = true;
  t_paid += f_paid;
 } else
  if (D_paid)
   D_paid->Caption = "unk.";

 if (s_billed != "" && s_paid != "")
 {
  financial f_writeoff = f_billed - f_paid;
  if (D_writeoff)
   D_writeoff->Caption = ("$ " + FinancialToString(f_writeoff, true)).c_str();
 } else
  if (D_writeoff)
   D_writeoff->Caption = "unk.";
}
//---------------------------------------------------------------------------
void __fastcall TformReportBulkEOB::bandtotalsBeforePrint(
      TQRCustomBand *Sender, bool &PrintBand)
{
 if (T_charged)
  if (is_t_charged)
   T_charged->Caption = ("$ " + FinancialToString(t_charged, true)).c_str();
  else
   T_charged->Caption = "unk.";

 if (T_billed)
  if (is_t_billed)
   T_billed->Caption = ("$ " + FinancialToString(t_billed, true)).c_str();
  else
   T_billed->Caption = "unk.";

 if (T_allowed)
  if (is_t_allowed)
   T_allowed->Caption = ("$ " + FinancialToString(t_allowed, true)).c_str();
  else
   T_allowed->Caption = "unk.";

 if (T_paid)
  if (is_t_paid)
   T_paid->Caption = ("$ " + FinancialToString(t_paid, true)).c_str();
  else
   T_paid->Caption = "unk.";

 if (T_writeoff)
  if (is_t_billed && is_t_paid)
  {
   financial t_writeoff = t_billed - t_paid;
   T_writeoff->Caption = ("$ " + FinancialToString(t_writeoff, true)).c_str();
  } else
   T_writeoff->Caption = "unk.";

 // absolute totals
 z_charged += t_charged;
 z_billed  += t_billed;
 z_allowed += t_allowed;
 z_paid    += t_paid;
   
 t_charged = t_billed = t_allowed = t_paid = financial(0.00);
 is_t_charged = is_t_billed = is_t_allowed = is_t_paid = false;
}
//---------------------------------------------------------------------------
void __fastcall TformReportBulkEOB::QRBand4BeforePrint(
      TQRCustomBand *Sender, bool &PrintBand)
{
 sumCharged->Caption = ("$ " + FinancialToString(z_charged, true)).c_str();
 // sumBilled->Caption = ("$ " + FinancialToString(t_billed, true)).c_str();
 sumAllowed->Caption = ("$ " + FinancialToString(z_allowed, true)).c_str();
 sumPaid->Caption    = ("$ " + FinancialToString(z_paid, true)).c_str();
}
//---------------------------------------------------------------------------


