//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reportCHSBillingDenialLetter.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformReportCHSBillingDenialLetter *formReportCHSBillingDenialLetter;
//---------------------------------------------------------------------------
__fastcall TformReportCHSBillingDenialLetter::TformReportCHSBillingDenialLetter(TComponent* Owner, map<string,string> &p_vars)
        : TformSpecialGeneric(Owner)
{
  vars = p_vars;
}
//---------------------------------------------------------------------------
void __fastcall TformReportCHSBillingDenialLetter::reportAfterPreview(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformReportCHSBillingDenialLetter::sysDatePrint(TObject *sender, AnsiString &Value)
{
  // Prettify date?
}
//---------------------------------------------------------------------------
void __fastcall TformReportCHSBillingDenialLetter::txtDateProcessedPrint(TObject *sender, AnsiString &Value)
{
  // I'd like to convert it to long format (March 21, 2007) but Pdate.OutDate doesn't seem to support that and I'm feeling lazy
}
//---------------------------------------------------------------------------
void __fastcall TformReportCHSBillingDenialLetter::txtPersonPrint(TObject *sender, AnsiString &Value)
{
  Value = PrettyString( GetPersonName(dbDatabase, Value.c_str(), first_middle_last) ).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportCHSBillingDenialLetter::txtProviderPrint(TObject *sender, AnsiString &Value)
{
  Value = PrettyString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportCHSBillingDenialLetter::txtDatesOfServicePrint(TObject *sender, AnsiString &Value)
{
  AnsiString end_date = report->DataSet->FieldByName("end_date_of_service")->AsString.c_str();
  if (end_date != "" && end_date != Value) // shouldn't be empty; should equal begin date
    Value = Value + " - " + end_date;
}
//---------------------------------------------------------------------------
void __fastcall TformReportCHSBillingDenialLetter::lblDatesOfServicePrint(TObject *sender, AnsiString &Value)
{
  AnsiString end_date = report->DataSet->FieldByName("end_date_of_service")->AsString.c_str();
  if (end_date == "" || end_date == Value) // shouldn't be empty; should equal begin date
    lblDatesOfService->Caption = "Date of Service:";
  else
    lblDatesOfService->Caption = "Dates of Service:";
}
//---------------------------------------------------------------------------
void __fastcall TformReportCHSBillingDenialLetter::txtGreetingPrint(TObject *sender, AnsiString &Value)
{
  string temp = Value.c_str();
  if(temp == lookupTables->IdOf("gender_types", "Male"))
    Value = "Dear Sir: ";
  else if(temp == lookupTables->IdOf("gender_types", "Female"))
    Value = "Dear Madam: ";
  else
    Value = "Dear Sir or Madam: ";
}
//---------------------------------------------------------------------------
void __fastcall TformReportCHSBillingDenialLetter::txtReasonPrint(TObject *sender, AnsiString &Value)
{
  string reason = Value.c_str();
  for (map<string, string>::iterator itr = vars.begin(); itr != vars.end(); itr++)
    reason = ReplaceStringWithString(reason, itr->first, itr->second);
  Value = reason.c_str();
}
//---------------------------------------------------------------------------
void TformReportCHSBillingDenialLetter::Do(string denial_letter_id)
{
  map<string, string> special_var;
  // yeah, redundant, but I'm just ready for it to work at this point
  map<string, string> denial_stuff;
  SqlToMap(dbDatabase, "select person_id, date_processed from denial_letters where id = '" + denial_letter_id + "' ", denial_stuff);

  // TODO: This was stolen from launchIntakeFormReport and should be a generic function (or two)
  map<string, string> consent_map;
  SqlToMap(dbDatabase, "select first 1 consents.signature_date consent_on, groups.item consent_at "
                       "from consents inner join consent_types on consent_types.id = consents.consent_id "
                       "left join groups on consents.group_id = groups.id "
                       "where consent_types.item like '%RELEASE%' and person_id = '" + denial_stuff["person_id"] + "' and current_id > 2 "
                       "order by consents.signature_date desc", consent_map);
  consent_map["consent_on"];
  string time_since_last_consent;
  if (consent_map["consent_on"] != "")
  {
    Pdate now_date(denial_stuff["date_processed"], global_mode); // relative to the date on the letter makes sense, neh?
    Pdate then_date(consent_map["consent_on"], global_mode);
    if (then_date.IsValidDate())
    {
     // hey, see, i was feeling polite ... this could be move to a slightly prettier version of that function that -assumes- we're talking about 'today'
     // but what if we were talking about some random date? then we'd want "before" and "after" rather than "ago" and "hence", and "today", "tomorrow", and "yesterday" would be far messier. ("that day", "the day before", "the day after"?)
     // i don't want to build right now.
     if (now_date == then_date)
      time_since_last_consent = " (today)";
     else if (now_date == then_date + 1)
      time_since_last_consent = " (yesterday)";
     else if (now_date == then_date - 1)
      time_since_last_consent = " (tomorrow)";
     else if (now_date > then_date)
      time_since_last_consent = " (" + GetTimeSince(now_date, then_date) + " ago)";
     else if (now_date < then_date)
      time_since_last_consent = " (" + GetTimeSince(now_date, then_date) + " hence)";
    }
  } else time_since_last_consent = "Never";

  special_var["$last_updated$"] = consent_map["consent_on"] + time_since_last_consent;
  special_var["$clinic_phone$"] = FormatPhoneNumber(GetOneField(dbDatabase,
    "select tax_addresses.phone_number "
    "from groups inner join tax_entities on groups.facility_id = tax_entities.id "
    "inner join tax_addresses on tax_addresses.id = "
      "(select first 1 id from tax_addresses "
      "where tax_addresses.tax_entity_id = tax_entities.id and tax_addresses.current_id+1 >= 4 "
      "order by tax_addresses.last_update_stamp desc) "
    "where groups.id = '" + lookupTables->IdOf("groups", "Little Axe Clinic") + "' " ));

  map<string, string> usermap;
  SqlToMap(dbDatabase, "select item name, title from users where id = '" + current_userid + "' ", usermap);

  TIBTransaction *dbLetterTransaction = new TIBTransaction(NULL);
  TIBDataSet *dbLetterDataset = new TIBDataSet(NULL);
  try
  {
    TformReportCHSBillingDenialLetter *report_form = NULL;
    FORM_TRY
      report_form = new TformReportCHSBillingDenialLetter(NULL, special_var);
    FORM_CATCH
    dbLetterTransaction->DefaultDatabase = dbDatabase;
    dbLetterDataset->Database = dbDatabase;
    dbLetterDataset->Transaction = dbLetterTransaction;
    dbLetterDataset->UniDirectional = false;
    dbLetterTransaction->StartTransaction();

    report_form->memoSignature->Lines->Add((PrettyString(usermap["name"])).c_str());
    report_form->memoSignature->Lines->Add((PrettyString(usermap["title"])).c_str());

    string sql =
      "select DL.person_id, DL.begin_date_of_service, DL.end_date_of_service, "
      "TE.name provider, DL.amount, P.gender_id, DRT.description reason, DL.date_processed "
      "from denial_letters DL "
      "inner join denial_reasons DR on DR.denial_letter_id = DL.id "
      "inner join denial_reason_types DRT on DR.denial_reason_id = DRT.id "
      "inner join services_provided SP on DL.services_provided_id = SP.id "
      "inner join service_types ST on SP.service_id = ST.id "
      "inner join tax_entities TE on SP.tax_entity_id = TE.id "
      "inner join people P on DL.person_id = people.id "
      "where DL.id = '" + denial_letter_id + "' ";
    dbLetterDataset->SelectSQL->Add(sql.c_str());
    dbLetterDataset->Open();

    report_form->report->DataSet = dbLetterDataset;
    report_form->txtDateProcessed->DataSet = dbLetterDataset;
    report_form->txtDateProcessed->DataField = "date_processed";
    report_form->txtPerson->DataSet = dbLetterDataset;
    report_form->txtPerson->DataField = "person_id"; // OnPrint will fetch name
    report_form->txtProvider->DataSet = dbLetterDataset;
    report_form->txtProvider->DataField = "provider";
    report_form->txtDatesOfService->DataSet = dbLetterDataset;
    report_form->txtDatesOfService->DataField = "begin_date_of_service";
    report_form->txtGreeting->DataSet = dbLetterDataset;
    report_form->txtGreeting->DataField = "gender_id";
    report_form->exprAmount->Expression = "FORMATNUMERIC('$###,###,##0.00', amount)";
    report_form->txtReason->DataSet = dbLetterDataset;
    report_form->txtReason->DataField = "reason";

    report_form->report->Preview();

    dbLetterDataset->Close();
    dbLetterTransaction->Commit();
  }
  catch(...)
  {
    if (dbLetterTransaction->Active)
      dbLetterTransaction->Rollback();
    ::PSay("Error printing letter", m_database_error, MB_OK, "reportDiabAppointmentLetter::Do");
  }
  delete dbLetterDataset;
  delete dbLetterTransaction;
}
//---------------------------------------------------------------------------

