//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reportClinicAppointments.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformReportClinicAppointments *formReportClinicAppointments;
//---------------------------------------------------------------------------
__fastcall TformReportClinicAppointments::TformReportClinicAppointments(TComponent* Owner, TIBDataSet* dbDataSet, AnsiString p_summary_field, string p_pri_ins_type)
        : TformSpecialGeneric(Owner)
{
  summary_field = p_summary_field;
  if (summary_field == "")
  { // suck it up
    memoType->Enabled = false;
    memoTypeCount->Enabled = false;
    summaryBand->Height = 34;
    summaryBandChild->Enabled = false;
  }
  set<string> person_ids;
  if (!dbDataSet->Active)
    dbDataSet->Open();
  dbDataSet->First();
  LogIt("appointment_report.log", "begin extracting person_id's for 'reportClinicAppointments'");
  while (! dbDataSet->Eof)
  {
    person_ids.insert(dbDataSet->Fields->FieldByName("person_id")->AsString.c_str());
    dbDataSet->Next();
  }
  LogIt("appointment_report.log", "done extracting person_id's for 'reportClinicAppointments'");
  pri_ins_type = p_pri_ins_type;
  string sql;
  sql = "select cov.person_id, insurance_types.item ins_type, tax_entities.name ins_co "
        "from insurance_coverage cov "
        "inner join insurance_policies pol on cov.insurance_policy_id = pol.id "
        "inner join tax_entities on pol.tax_entity_id = tax_entities.id ";
  if (pri_ins_type != "")
    sql += "inner join insurance_benefits ben on ben.insurance_policy_id = pol.id and ben.area_id = '" + lookupTables->IdOf("area_types", pri_ins_type) + "' ";
  sql += "left join insurance_types on pol.insurance_id = insurance_types.id "
         "where " + SafeInClause("cov.person_id", SetToVec(person_ids)) + " and "
         "(cov.stop_date is null or cov.stop_date > current_date) and "
         "pol.current_id+1 >= 4 and cov.current_id+1 >= 4 "
         "order by cov.person_id, insurance_types.item";
  DebugSql(this, &sql, other_forms, 9);
  bool all_is_well;
  try
  {
    LogIt("appointment_report.log", "begin fetching insurance coverage for 'reportClinicAppointments'");
    all_is_well = SqlToVecMap(dbDatabase, sql, ins);
    LogIt("appointment_report.log", "end fetching insurance coverage for 'reportClinicAppointments'");
    dbDataSet->First();
  }
  catch (...)
  {
    all_is_well = false;
  }
  if (!all_is_well)
    Close(); // or something else?  will this break QR, like everything else does?
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicAppointments::reportAfterPreview(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicAppointments::reportBeforePrint(TCustomQuickRep *Sender, bool &PrintReport)
{
  summary_map.clear();
  memoType->Lines->Clear();
  memoTypeCount->Lines->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicAppointments::txtPatientPrint(TObject *sender, AnsiString &Value)
{
  string temp = Value.c_str();
  if(temp.length() <= 3)
    temp = "";
  else
    temp = PrettyString(temp);
  Value = temp.c_str();

  // -----

/*
  string person_id = report->DataSet->Fields->FieldByName("person_id")->AsString.c_str();
  string medicare = "";
  string priv = "";
  string sql;
  sql = "select tax_entities.name ins_co, insurance_types.item ins_type "
        "from insurance_coverage cov "
        "inner join insurance_policies pol on cov.insurance_policy_id = pol.id "
        "inner join tax_entities on pol.tax_entity_id = tax_entities.id ";
  if (pri_ins_type != "")
    sql += "inner join insurance_benefits ben on ben.insurance_policy_id = pol.id and ben.area_id = '" + lookupTables->IdOf("area_types", pri_ins_type) + "' ";
  sql += "left join insurance_types on pol.insurance_id = insurance_types.id "
         "where cov.person_id = '" + person_id + "' and "
         "(cov.stop_date is null or cov.stop_date > current_date) and "
         "pol.current_id+1 >= 4 and cov.current_id+1 >= 4 ";
  // DebugSql(this, &sql, other_forms, 9); // no, stop it.
  vector<map<string, string> > ins;
  SqlToVecMap(dbDatabase, sql, ins);
*/
  string medicare = "";
  string priv = "";
  vector<map<string, string> >::iterator itr = ins.begin();
  string person_id = report->DataSet->Fields->FieldByName("person_id")->AsString.c_str();
  while (itr!=ins.end() && (*itr)["person_id"] != person_id)
    itr++;
  while (itr!=ins.end() && (*itr)["person_id"] == person_id)
  {
    string ins_type = (*itr)["ins_type"];
    string ins_co   = UppercaseString((*itr)["ins_co"]);
    if (LikeString("MEDICARE _", ins_type))
      medicare += ins_type[ins_type.size()-1];
    else if (LikeString(ins_type, "%MEDICAID%"))
      ; // do nothing, already handled
    //else if (ins_type == "VETERAN") // we don't care?
    else // treat all else like private insurance
      priv += ((*itr)["ins_co"] + "; ");
    itr++;
  }
  priv = priv.substr(0, priv.size()-2);
  lblMedicareValue->Caption = medicare.c_str();
  lblPrivateInsuranceValue->Caption = priv.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicAppointments::txtReasonPrint(TObject *sender, AnsiString &Value)
{
  string desc = ReplaceStringWithString(ReplaceAnyCharWithString(Value.c_str(), "\a\f\n\r\t", "; "), "; ; ", "; ");
  Value = SentenceString(desc).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicAppointments::txtHomePhonePrint(TObject *sender, AnsiString &Value)
{ // squeeeeeeze
  string phone = ReplaceStringWithString(FormatPhoneNumber(Value.c_str()), "(405) ", "");
  if (phone.length() > 8) phone = StripAllExcept(phone, "0123456789");
  Value = phone.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicAppointments::txtWorkPhonePrint(TObject *sender, AnsiString &Value)
{ // squeeeeeeze
  string phone = ReplaceStringWithString(FormatPhoneNumber(Value.c_str()), "(405) ", "");
  if (phone.length() > 8) phone = StripAllExcept(phone, "0123456789");
  Value = phone.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicAppointments::txtDurationPrint(TObject *sender, AnsiString &Value)
{
  string temp = Value.c_str();
  temp = LowercaseString(temp);
  /*
  if(temp.length() > 3) // cute. 1 hours = 1 hour, etc.
  {
    if((temp[0] == '1') && (temp[1] == ' '))
      temp = temp.substr(0, temp.length()-1);
  }
  */ // but no longer necessary
  temp = ReplaceStringWithString(temp, ".00", "");
  temp = ReplaceStringWithString(temp, " ", "");
  Value = temp.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicAppointments::txtProviderPrint(TObject *sender, AnsiString &Value)
{
  string provider = Value.c_str();
  provider = provider.substr(0, provider.find(","));
  if (provider.find(" ") != string::npos)
    provider = provider.substr(0, 1) + provider.substr(provider.find_last_of(" ")); // first initial + last name
  Value = provider.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicAppointments::txtTimePrint(TObject *sender, AnsiString &Value)
{
  Ptime T(Value.c_str(), military);
  Value = ReplaceStringWithString(ReplaceStringWithString(T.OutTime(withoutsec), " ", ""), "m", "").c_str(); // 10:00 am becomes 10:00a
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicAppointments::detailBandAfterPrint(TQRCustomBand *Sender, bool BandPrinted)
{ // aggregate whatever it is we're aggregating.  Ready, steady, go!
  AnsiString field_value = PrettyString(report->DataSet->FieldByName(summary_field)->AsString.c_str()).c_str();
  if (field_value == "") field_value = "(blank)";
  if (summary_map.find(field_value) == summary_map.end()) // I think it defaults to 0 for value when adding a key, but just in case...
    summary_map[field_value] = 0;
  summary_map[field_value]++;
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicAppointments::summaryBandBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
  for(map<AnsiString, unsigned int>::iterator itr = summary_map.begin(); itr != summary_map.end(); itr++)
  {
    memoType->Lines->Add(itr->first);
    memoTypeCount->Lines->Add(IntToString(itr->second).c_str());
  }
}
//---------------------------------------------------------------------------

