//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reportClinicPatientList.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformReportClinicPatientList *formReportClinicPatientList;
//---------------------------------------------------------------------------
__fastcall TformReportClinicPatientList::TformReportClinicPatientList(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void TformReportClinicPatientList::Execute(TformSpecialGeneric *calling_form, bool print_all, bool print_some, bool print_inactive,
                                           string min_visits, string begin_date, string end_date, string clinic_id,
                                           bool all_charts, bool active_charts, bool inactive_charts, int tribal)
{
  TIBTransaction * dbTransaction = NULL;
  TIBDataSet * dbDataSet = NULL;

  string date_title = begin_date + " - " + end_date;
  if (date_title == " - ") date_title = "";

  string group_name;
  string chart_location;

  try
  {
    dbTransaction = new TIBTransaction (NULL);
    dbDataSet = new TIBDataSet(NULL);
    StdTransaction(dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;

    group_name = GetOneField(dbTransaction, "select item from groups where id = '" + clinic_id + "'");
    chart_location = GetOneField(dbTransaction, "select chart_location_id from groups where id = '" + clinic_id + "'");
    /*
    string current_status;
    if (all_charts)
      current_status = "";
    else if (active_charts)
      current_status = " and current_id >= 3 ";
    else if (inactive_charts)
      current_status = " and current_id < 3 ";

    string sql = "select last_name || ', ' || first_name || ' ' || middle_name || ' ' || suffix name, birth_date, chart_number, phone_number "
                 "from people left  join person_names on people.person_names_id = person_names.id and person_names.current_id >= 3 "
                             "left  join person_contact_info on people.home_phone_id = person_contact_info.id and person_contact_info.current_id >= 3 ";
    sql +=   "inner join charts outer_charts on outer_charts.id = (select first 1 inner_charts.id from charts inner_charts where inner_charts.person_id = people.id and inner_charts.location_id = '" + chart_location + "'" + current_status + ") ";

    if (print_some)
    { // select just the stuff we ARE printing then
      string restrict_dates = "tasks.date_of_task >= '" + begin_date + "' and tasks.date_of_task <= '" + end_date + "'";
      string get_visit_count = "select count(id) from tasks where person_id = people.id and tasks.current_id >= 3 and "
                               "group_id in (select id from groups where chart_location_id = '" + chart_location + "') "
                               //"group_id = '" + clinic_id + "'
                               "and tasks.method_id = '" + lookupTables->IdOf("method_types", "Visit") + "' ";
      sql += "where (" + get_visit_count + " and " + restrict_dates + ") >= " + min_visits + " ";
    }
    if (print_inactive)
    { // select just the stuff we ARE printing then
      string restrict_dates = "tasks.date_of_task >= '" + begin_date + "' and tasks.date_of_task <= '" + end_date + "'";
      string get_visit_count = "select count(id) from tasks where person_id = people.id and tasks.current_id >= 3 and "
                               //"group_id = '" + clinic_id + "' "
                               "group_id in (select id from groups where chart_location_id = '" + chart_location + "') "
                               "and tasks.method_id = '" + lookupTables->IdOf("method_types", "Visit") + "' ";
      sql += "where (" + get_visit_count + " and " + restrict_dates + ") = 0 ";
    }
    sql += "order by last_name, first_name, middle_name, suffix, birth_date";
    */
    // verified to be unnecessary - transaction is rolled back unconditionally.
    //ExecuteStatement(dbTransaction, "delete from temp_clinic_patient_charts");
    //ExecuteStatement(dbTransaction, "delete from temp_clinic_patient_tasks");

    // jhaley 20101112: using a couple of temp tables makes this a whole minute or more faster when doing joins with tasks
    string sql = "insert into temp_clinic_patient_charts (person_id, person_names_id, birth_date, chart_number, phone_number) "
                 "select people.id, person_names.id, people.birth_date, outer_charts.chart_number, person_contact_info.phone_number "
                 "from people "
                 "left join person_names on people.person_names_id = person_names.id and person_names.current_id+1 >= 4 "
                 "left join person_contact_info on people.home_phone_id = person_contact_info.id and person_contact_info.current_id+1 >= 4 "
                 "inner join charts outer_charts on outer_charts.id = "
                 "(select first 1 inner_charts.id from charts inner_charts "
                 " where inner_charts.person_id = people.id and inner_charts.location_id = '" + chart_location + "' ";

    if (!all_charts)
    {
      if (active_charts)
        sql += " and inner_charts.current_id+1 >= 4) ";
      else if (inactive_charts)
        sql += " and inner_charts.current_id+1 < 4) ";
    }
    else
      sql += ") ";

    // jhaley 20101112: Allow optional restriction to AST members only, Non-AST people only, or just everyone (the default)
    switch(tribal)
    {
    case ast_only:
      sql += "where exists (select A.id from affiliations A where people.affiliations_id = A.id and A.current_id+1 >= 4 "
             "and A.tribe_id = '" + lookupTables->IdOf("tribe_types", "Absentee Shawnee Tribes of Oklahoma") + "') ";
      break;
    case nonast_only:
      sql += "where not exists (select A.id from affiliations A where people.affiliations_id = A.id and A.current_id+1 >= 4 "
             "and A.tribe_id = '" + lookupTables->IdOf("tribe_types", "Absentee Shawnee Tribes of Oklahoma") + "') ";
      break;
    default: // includes 'everyone'
      break;
    }

    DebugSql(NULL, &sql, other_forms, 9);
    if (!ExecuteStatement(dbTransaction, sql))
      throw(1);

    if (print_some || print_inactive)
    {
      sql = "insert into temp_clinic_patient_tasks (person_id, task_count) "
            "select people.id, count(tasks.id) "
            "from people "
            "inner join tasks on people.id = tasks.person_id and tasks.current_id+1 >= 4 and "
            "tasks.group_id in (select id from groups where chart_location_id = '" + chart_location + "') "
            "and tasks.method_id = '" + lookupTables->IdOf("method_types", "Visit") + "' "
            "and tasks.date_of_task between '" + begin_date + "' and '" + end_date + "' "
            "group by people.id ";
      DebugSql(NULL, &sql, other_forms, 9);
      if (!ExecuteStatement(dbTransaction, sql))
        throw(2);
    }

    sql = "select last_name || ', ' || first_name || ' ' || middle_name || ' ' || suffix name, birth_date, chart_number, phone_number "
          "from temp_clinic_patient_charts "
          "left join person_names on temp_clinic_patient_charts.person_names_id = person_names.id ";
    if (print_some)
    {
      sql += "inner join temp_clinic_patient_tasks on temp_clinic_patient_charts.person_id = temp_clinic_patient_tasks.person_id "
             "where temp_clinic_patient_tasks.task_count >= '" + min_visits + "' ";
    }
    if (print_inactive)
    {
      sql += "where not exists (select * from temp_clinic_patient_tasks where temp_clinic_patient_charts.person_id = temp_clinic_patient_tasks.person_id) ";
    }
    sql += "order by last_name, first_name, middle_name, suffix, birth_date";

    // grr to static functions ... no instantiated class to use for 'this' ... bleh.
    DebugSql(NULL, &sql, other_forms, 9);

    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();

    TformReportClinicPatientList *report;
    FORM_TRY
      report = new TformReportClinicPatientList(NULL);
    FORM_CATCH

    report->lblDateTitle->Caption = date_title.c_str();
    report->clinicPatientList->DataSet = dbDataSet;

    report->lblUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
    report->lblTitle->Caption = ReplaceStringWithString(string(report->lblTitle->Caption.c_str()), "Some Clinic", PrettyString(group_name)).c_str();
    report->txtName->DataSet = dbDataSet;
    report->txtName->DataField = "name";
    report->txtDOB->DataSet = dbDataSet;
    report->txtDOB->DataField = "birth_date";
    report->txtChart->DataSet = dbDataSet;
    report->txtChart->DataField = "chart_number";
    report->txtPhone->DataSet = dbDataSet;
    report->txtPhone->DataField = "phone_number";

    calling_form->Processing(false);
    report->clinicPatientList->Preview();
    dbDataSet->Close();
  }
  catch (int i)
  {
    calling_form->Processing(false);
    ::PSay("Error running report: error #" + IntToString(i), m_database_error, MB_OK, "TformReportClinicPatientList::Execute");
  }
  catch (...)
  {
    calling_form->Processing(false);
    ::PSay("Error running report", m_database_error, MB_OK, "TformReportClinicPatientList::Execute");
  }
  calling_form->Processing(false);

  delete dbDataSet;
  if (dbTransaction && dbTransaction->Active)
    dbTransaction->Rollback();
  delete dbTransaction;
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicPatientList::txtPhonePrint(TObject *sender, AnsiString &Value)
{
  Value = FormatPhoneNumber(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicPatientList::txtNamePrint(TObject *sender,AnsiString &Value)
{
  Value = PrettyString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicPatientList::clinicPatientListAfterPreview(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

