//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reportClinicSuperBill.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformReportClinicSuperBill *formReportClinicSuperBill;
//---------------------------------------------------------------------------
__fastcall TformReportClinicSuperBill::TformReportClinicSuperBill(TComponent* Owner, bool p_keep_open_when_done, bool p_print_top_row)
        : TformSpecialGeneric(Owner)
{
  vert_pos = vp_bottom;
  horiz_pos = hp_right;

  print_top_row = p_print_top_row;
  keep_open_when_done = p_keep_open_when_done;

  if (print_top_row)
  {
    vert_ofs = lblChart->Top;
    horiz_ofs = lblChart->Left;
  }
  else
  {
    vert_ofs = lblName->Top;
    horiz_ofs = lblName->Left;
    //switch SSN and code
    int top_row = lblSsn->Top;
    lblSsn->Top = lblCode->Top;
    txtSsn->Top = lblCode->Top;
    lblCode->Top = top_row;
    txtCode->Top = top_row;
    //disable the ones we don't want
    lblChart->Enabled = false;
    txtChart->Enabled = false;
    lblCode->Enabled = false;
    txtCode->Enabled = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicSuperBill::reportBeforePrint(TCustomQuickRep *Sender, bool &PrintReport)
{
  // we only really need these two...
  if (horiz_pos == hp_left) ToLeft();
  if (vert_pos == vp_top) ToTop();
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicSuperBill::reportAfterPreview(TObject *Sender)
{
  if (!keep_open_when_done)
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicSuperBill::txtNamePrint(TObject *sender, AnsiString &Value)
{
  Value = PrettyString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicSuperBill::txtSsnPrint(TObject *sender, AnsiString &Value)
{
  Value = PrettySSN(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicSuperBill::txtTimePrint(TObject *sender, AnsiString &Value)
{
  Ptime temp(Value.c_str(), military | withsec);
  Value = temp.OutTime(ampm | withoutsec).c_str();
}
//---------------------------------------------------------------------------
void TformReportClinicSuperBill::ToTop()
{
  if (vert_pos == vp_bottom)
  {
    lblChart->Top = lblChart->Top - vert_ofs;
    txtChart->Top = txtChart->Top - vert_ofs;
    lblName->Top = lblName->Top - vert_ofs;
    txtName->Top = txtName->Top - vert_ofs;
    lblDob->Top = lblDob->Top - vert_ofs;
    txtDob->Top = txtDob->Top - vert_ofs;
    lblGender->Top = lblGender->Top - vert_ofs;
    txtGender->Top = txtGender->Top - vert_ofs;
    lblCode->Top = lblCode->Top - vert_ofs;
    txtCode->Top = txtCode->Top - vert_ofs;
    lblSsn->Top = lblSsn->Top - vert_ofs;
    txtSsn->Top = txtSsn->Top - vert_ofs;
    lblDate->Top = lblDate->Top - vert_ofs;
    lblDateTime->Top = lblDateTime->Top - vert_ofs;
    vert_pos = vp_top;
  }
}
//---------------------------------------------------------------------------
void TformReportClinicSuperBill::ToBottom()
{
  if (vert_pos == vp_top)
  {
    lblChart->Top = lblChart->Top + vert_ofs;
    txtChart->Top = txtChart->Top + vert_ofs;
    lblName->Top = lblName->Top + vert_ofs;
    txtName->Top = txtName->Top + vert_ofs;
    lblDob->Top = lblDob->Top + vert_ofs;
    txtDob->Top = txtDob->Top + vert_ofs;
    lblGender->Top = lblGender->Top + vert_ofs;
    txtGender->Top = txtGender->Top + vert_ofs;
    lblCode->Top = lblCode->Top + vert_ofs;
    txtCode->Top = txtCode->Top + vert_ofs;
    lblSsn->Top = lblSsn->Top + vert_ofs;
    txtSsn->Top = txtSsn->Top + vert_ofs;
    lblDate->Top = lblDate->Top + vert_ofs;
    lblDateTime->Top = lblDateTime->Top + vert_ofs;
    vert_pos = vp_bottom;
  }
}
//---------------------------------------------------------------------------
void TformReportClinicSuperBill::ToLeft()
{
  if (horiz_pos == hp_right)
  {
    lblChart->Left = lblChart->Left - horiz_ofs;
    txtChart->Left = txtChart->Left - horiz_ofs;
    lblName->Left = lblName->Left - horiz_ofs;
    txtName->Left = txtName->Left - horiz_ofs;
    lblDob->Left = lblDob->Left - horiz_ofs;
    txtDob->Left = txtDob->Left - horiz_ofs;
    lblGender->Left = lblGender->Left - horiz_ofs;
    txtGender->Left = txtGender->Left - horiz_ofs;
    lblCode->Left = lblCode->Left - horiz_ofs;
    txtCode->Left = txtCode->Left - horiz_ofs;
    lblSsn->Left = lblSsn->Left - horiz_ofs;
    txtSsn->Left = txtSsn->Left - horiz_ofs;
    lblDate->Left = lblDate->Left - horiz_ofs;
    lblDateTime->Left = lblDateTime->Left - horiz_ofs;
    horiz_pos = hp_left;
  }
}
//---------------------------------------------------------------------------
void TformReportClinicSuperBill::ToRight()
{
  if (horiz_pos == hp_left)
  {
    lblChart->Left = lblChart->Left + horiz_ofs;
    txtChart->Left = txtChart->Left + horiz_ofs;
    lblName->Left = lblName->Left + horiz_ofs;
    txtName->Left = txtName->Left + horiz_ofs;
    lblDob->Left = lblDob->Left + horiz_ofs;
    txtDob->Left = txtDob->Left + horiz_ofs;
    lblGender->Left = lblGender->Left + horiz_ofs;
    txtGender->Left = txtGender->Left + horiz_ofs;
    lblCode->Left = lblCode->Left + horiz_ofs;
    txtCode->Left = txtCode->Left + horiz_ofs;
    lblSsn->Left = lblSsn->Left + horiz_ofs;
    txtSsn->Left = txtSsn->Left + horiz_ofs;
    lblDate->Left = lblDate->Left + horiz_ofs;
    lblDateTime->Left = lblDateTime->Left + horiz_ofs;
    horiz_pos = hp_right;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformReportClinicSuperBill::lblDateTimePrint(TObject *sender, AnsiString &Value)
{
  Value = report->DataSet->FieldByName("appt_date")->AsString + " " +
          report->DataSet->FieldByName("appt_time")->AsString;
}
//---------------------------------------------------------------------------
void TformReportClinicSuperBill::Execute(TformSpecialGeneric *calling_form, TDataSet * dbDataSet, corner_types set1, corner_types set2, bool print_chart_and_code)
{
  Application->ProcessMessages();
  TformReportClinicSuperBill * bill_form;
  FORM_TRY
    bill_form = new TformReportClinicSuperBill(NULL, true, print_chart_and_code);
  FORM_CATCH
  bill_form->report->DataSet = dbDataSet;
  if (print_chart_and_code)
  {
    bill_form->txtChart->DataSet = dbDataSet;
    bill_form->txtChart->DataField = "chart_number";
    bill_form->txtCode->DataSet = dbDataSet;
    bill_form->txtCode->DataField = "tribal_code";
  }
  bill_form->txtName->DataSet = dbDataSet;
  bill_form->txtName->DataField = "person_name";
  bill_form->txtSsn->DataSet = dbDataSet;
  bill_form->txtSsn->DataField = "social_security_number";
  bill_form->txtGender->DataSet = dbDataSet;
  bill_form->txtGender->DataField = "gender";
  bill_form->txtDob->DataSet = dbDataSet;
  bill_form->txtDob->DataField = "birth_date";
  calling_form->Processing(true);
  if (set1 != ct_none)
  {
    switch (set1)
    {
      case ct_upper_left:  bill_form->ToTop(); bill_form->ToLeft(); break;
      case ct_upper_right: bill_form->ToTop(); bill_form->ToRight(); break;
      case ct_lower_left:  bill_form->ToBottom(); bill_form->ToLeft(); break;
      case ct_lower_right: bill_form->ToBottom(); bill_form->ToRight(); break;
    }
    calling_form->Processing(false);
    bill_form->report->Preview();
  }
  calling_form->Processing(true);
  if (set2 != ct_none)
  {
    switch (set2)
    {
      case ct_upper_left:  bill_form->ToTop(); bill_form->ToLeft(); break;
      case ct_upper_right: bill_form->ToTop(); bill_form->ToRight(); break;
      case ct_lower_left:  bill_form->ToBottom(); bill_form->ToLeft(); break;
      case ct_lower_right: bill_form->ToBottom(); bill_form->ToRight(); break;
    }
    calling_form->Processing(false);
    bill_form->report->Preview();
  }
  bill_form->Close();
  Application->ProcessMessages();
}
//---------------------------------------------------------------------------

