//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reportDenialLetter.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformReportDenialLetter *formReportDenialLetter;
//---------------------------------------------------------------------------
__fastcall TformReportDenialLetter::TformReportDenialLetter(TComponent* Owner, map<string, map<string,string> >&p_vars)
        : TformSpecialGeneric(Owner)
{
  vars = p_vars;
}
//---------------------------------------------------------------------------
void __fastcall TformReportDenialLetter::reportAfterPreview(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDenialLetter::sysDatePrint(TObject *sender, AnsiString &Value)
{
  // Prettify date?
}
//---------------------------------------------------------------------------
void __fastcall TformReportDenialLetter::txtDateProcessedPrint(TObject *sender, AnsiString &Value)
{
  // long format (March 21, 2007)
  Pdate tempdate(Value.c_str(), global_mode);
  Value = (tempdate.NameOfMonth() + " " + IntToString(tempdate.day) + ", " + IntToString(tempdate.year)).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDenialLetter::txtPersonPrint(TObject *sender, AnsiString &Value)
{
  Value = PrettyString( GetPersonName(dbDatabase, Value.c_str(), first_middle_last) ).c_str();

  memoAddress->Lines->Clear();
  AnsiString temp;
  temp = report->DataSet->FieldByName("line1")->AsString;
  if (temp != "")
  {
    memoAddress->Lines->Add(FormatAddress(temp.c_str()).c_str());
    temp = report->DataSet->FieldByName("line2")->AsString;
    if (temp != "")
      memoAddress->Lines->Add(FormatAddress(temp.c_str()).c_str());
    temp = (PrettyString(report->DataSet->FieldByName("city")->AsString.c_str()) + ", " +
            UppercaseString(report->DataSet->FieldByName("state")->AsString.c_str()) + "  " +
            FormatZipCode(report->DataSet->FieldByName("zip")->AsString.c_str())).c_str();
    memoAddress->Lines->Add(temp);
  }
}
//---------------------------------------------------------------------------
void __fastcall TformReportDenialLetter::txtProviderPrint(TObject *sender, AnsiString &Value)
{
  Value = PrettyString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDenialLetter::txtDatesOfServicePrint(TObject *sender, AnsiString &Value)
{
  // TODO: jhaley - not needed any more?
}
//---------------------------------------------------------------------------
void __fastcall TformReportDenialLetter::lblDatesOfServicePrint(TObject *sender, AnsiString &Value)
{
  // TODO: jhaley - not needed any more?
}
//---------------------------------------------------------------------------
void __fastcall TformReportDenialLetter::txtGreetingPrint(TObject *sender, AnsiString &Value)
{
  string temp = Value.c_str();
  if(temp == lookupTables->IdOf("gender_types", "Male"))
    Value = "Dear Sir: ";
  else if(temp == lookupTables->IdOf("gender_types", "Female"))
    Value = "Dear Madam: ";
  else
    Value = "Dear Sir or Madam: ";
}
//---------------------------------------------------------------------------
void __fastcall TformReportDenialLetter::txtReasonPrint(TObject *sender, AnsiString &Value)
{
  string reason = Value.c_str();
  string id = report->DataSet->FieldByName("denial_letter_id")->AsString.c_str();
  for (map<string, string>::iterator itr = vars[id].begin(); itr != vars[id].end(); itr++)
    reason = ReplaceStringWithString(reason, itr->first, itr->second);
  Value = reason.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDenialLetter::bandAddressBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
  // TODO: jhaley - not needed any more?
}
//---------------------------------------------------------------------------
void __fastcall TformReportDenialLetter::bandGreetingBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
  // jhaley 20100709: text is now stored in the database by authority type
  string auth_id    = report->DataSet->FieldByName("denial_authority_id")->AsString.c_str();
  string status_id  = report->DataSet->FieldByName("denial_status_id")->AsString.c_str();
  string field_name;

  // third-party billing letters never have resolved status, so for the sake of old ones, use the denial text
  // in that situation.
  if (status_id == lookupTables->IdOf("denial_status_types", "Resolved") &&
      auth_id   != lookupTables->IdOf("denial_authority_types", "Third Party Billing"))
    field_name = "approval_greeting";
  else
    field_name = "denial_greeting";

  string greet_text = GetOneField(dbDatabase, "select " + field_name + " from denial_authority_types "
                                              "where id = '" + auth_id + "' ");
  memoPreamble->Lines->Clear();
  memoPreamble->Lines->Add(greet_text.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TformReportDenialLetter::bandBodyBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
  // jhaley 20100709: text is now stored in the database by authority type
  string auth_id    = report->DataSet->FieldByName("denial_authority_id")->AsString.c_str();
  string status_id  = report->DataSet->FieldByName("denial_status_id")->AsString.c_str();
  string field_name;

  // see above for info on why TPB resolved is ignored.
  if (status_id == lookupTables->IdOf("denial_status_types", "Resolved") &&
      auth_id   != lookupTables->IdOf("denial_authority_types", "Third Party Billing"))
    field_name = "approval_body";
  else
    field_name = "denial_body";

  string body_text  = GetOneField(dbDatabase, "select " + field_name + " from denial_authority_types "
                                              "where id = '" + auth_id + "' ");
  memoBody->Lines->Clear();
  memoBody->Lines->Add(body_text.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TformReportDenialLetter::bandResolutionBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
  // jhaley 20100709: text is now stored in the database by authority type
  string auth_id    = report->DataSet->FieldByName("denial_authority_id")->AsString.c_str();
  string status_id  = report->DataSet->FieldByName("denial_status_id")->AsString.c_str();
  string field_name;

  // see above for info on why TPB resolved is ignored.
  if (status_id == lookupTables->IdOf("denial_status_types", "Resolved") &&
      auth_id   != lookupTables->IdOf("denial_authority_types", "Third Party Billing"))
    field_name = "approval_resolution";
  else
    field_name = "denial_resolution";

  string resol_text = GetOneField(dbDatabase, "select " + field_name + " from denial_authority_types "
                                              "where id = '" + auth_id + "' ");
  memoResolution->Lines->Clear();
  memoResolution->Lines->Add(resol_text.c_str());
}
//---------------------------------------------------------------------------
void TformReportDenialLetter::Do(vector<string> denial_letter_ids, string one_date, bool duplicates)
{
  map<string, map<string, string> > special_var;
  // yeah, redundant, but I'm just ready for it to work at this point
  vector<map<string, string> > denial_stuff;

  // jhaley 20100712: adjusted this query - person_id is now in the denials table.
  SqlToVecMap(dbDatabase, "select denial_letters.id denial_letter_id, "
                          "denials.person_id, denial_letters.date_processed "
                          "from denial_letters "
                          "inner join denials on denials.id = denial_letters.denial_id "
                          "where " + SafeInClause("denial_letters.id", denial_letter_ids) + " "
                          "order by denial_letters.id, denial_letters.date_processed", denial_stuff);

  map<string, string> consent_map;
  for (vector<map<string, string> >::iterator itr = denial_stuff.begin(); itr != denial_stuff.end(); itr++)
  {
    consent_map.clear();
    // TODO: This was stolen from launchIntakeFormReport and should be a generic function (or two)
    SqlToMap(dbDatabase, "select first 1 consents.signature_date consent_on, groups.item consent_at "
                         "from consents inner join consent_types on consent_types.id = consents.consent_id "
                         "left join groups on consents.group_id = groups.id "
                         "where consent_types.item like '%RELEASE%' and person_id = '" + (*itr)["person_id"] + "' and current_id > 2 "
                         "order by consents.signature_date desc", consent_map);
    consent_map["consent_on"];
    string time_since_last_consent;
    if (consent_map["consent_on"] != "")
    {
      Pdate now_date((*itr)["date_processed"], global_mode); // relative to the date on the letter makes sense, neh?
      Pdate then_date(consent_map["consent_on"], global_mode);
      if (then_date.IsValidDate())
      {
       // hey, see, i was feeling polite ... this could be move to a slightly prettier version of that function that
       // -assumes- we're talking about 'today' but what if we were talking about some random date? then we'd want
       // "before" and "after" rather than "ago" and "hence", and "today", "tomorrow", and "yesterday" would be far
       // messier. ("that day", "the day before", "the day after"?)
       // i don't want to build right now.
       if (now_date == then_date)
        time_since_last_consent = " (today)";
       else if (now_date == then_date + 1)
        time_since_last_consent = " (yesterday)";
       else if (now_date == then_date - 1)
        time_since_last_consent = " (tomorrow)";
       else if (now_date > then_date)
        time_since_last_consent = " (" + GetTimeSince(now_date, then_date) + " ago)";
       else if (now_date < then_date)
        time_since_last_consent = " (" + GetTimeSince(now_date, then_date) + " hence)";
      }
    } else time_since_last_consent = "Never";

    special_var[(*itr)["denial_letter_id"]]["$last_updated$"] = consent_map["consent_on"] + time_since_last_consent;
    special_var[(*itr)["denial_letter_id"]]["$clinic_phone$"] = FormatPhoneNumber(GetOneField(dbDatabase,
      "select tax_addresses.phone_number "
      "from groups inner join tax_entities on groups.facility_id = tax_entities.id "
      "inner join tax_addresses on tax_addresses.id = "
        "(select first 1 id from tax_addresses "
        "where tax_addresses.tax_entity_id = tax_entities.id and tax_addresses.current_id+1 >= 4 "
        "order by tax_addresses.last_update_stamp desc) "
      "where groups.id = '" + lookupTables->IdOf("groups", "Little Axe Clinic") + "' " ));
  }

  //map<string, string> usermap;
  //SqlToMap(dbDatabase, "select item name, title from users where id = '" + current_userid + "' ", usermap);

  bool doing_duplicates = false;
  do
  {
    TIBTransaction *dbLetterTransaction = new TIBTransaction(NULL);
    TIBDataSet *dbLetterDataset = new TIBDataSet(NULL);
    TformReportDenialLetter *report_form = NULL;
    try
    {
      FORM_TRY
        report_form = new TformReportDenialLetter(NULL, special_var);
      FORM_CATCH
      dbLetterTransaction->DefaultDatabase = dbDatabase;
      dbLetterDataset->Database = dbDatabase;
      dbLetterDataset->Transaction = dbLetterTransaction;
      dbLetterDataset->UniDirectional = false;
      dbLetterTransaction->StartTransaction();

      //report_form->memoSignature->Lines->Add((PrettyString(usermap["name"])).c_str());
      //report_form->memoSignature->Lines->Add((PrettyString(usermap["title"])).c_str());

      // jhaley 20100712: join with denials; denial_items fields removed.
      string sql =
        "select DL.id denial_letter_id, DN.person_id, DL.denial_authority_id, DL.denial_status_id, "
        "TE.name provider, P.gender_id, DRT.description reason, ";
      if (one_date == "")
        sql += "DL.date_processed, ";
      else
        sql += "'" + one_date + "' date_processed, ";
      sql +=
        "case when mailing_info.id is not null then coalesce(mailing_info.line1, '') else coalesce(home_info.line1, '') end line1, "
        "case when mailing_info.id is not null then coalesce(mailing_info.line2, '') else coalesce(home_info.line2, '') end line2, "
        "case when mailing_info.id is not null then coalesce(mailing_info.city,  '') else coalesce(home_info.city,  '') end city, "
        "case when mailing_info.id is not null then coalesce(mailing_state.abbreviation, '') else coalesce(home_state.abbreviation, '') end state, "
        "case when mailing_info.id is not null then coalesce(mailing_info.zip,   '') else coalesce(home_info.zip,   '') end zip ";
      if (doing_duplicates) // jhaley: pull chart no. when printing duplicate letters
        sql += ", (select first 1 CH.chart_number from charts CH where CH.person_id = P.id and CH.current_id+1 > 3 and "
               "CH.location_id = '" + lookupTables->IdOf("location_types", "Contract Health") + "') chart_no ";
      sql +=
        "from denial_letters DL "
        "left join denial_reasons DR on DR.denial_letter_id = DL.id "
        "left join denial_reason_types DRT on DR.denial_reason_id = DRT.id "
        "left join denials DN on DN.id = DL.denial_id "
        "inner join services_provided SP on DN.services_provided_id = SP.id "
        "inner join service_types ST on SP.service_id = ST.id "
        "inner join tax_entities TE on SP.tax_entity_id = TE.id "
        "inner join people P on DN.person_id = P.id " // jhaley 20101115: Corrected to use alias for Firebird 2.x compliance
        "left join person_contact_info mailing_info on mailing_info.id = "
        " (select first 1 i_address.id from person_contact_info i_address where i_address.person_id = P.id and "
        "  i_address.current_id+1 >= 4 and i_address.contact_info_id = " + lookupTables->IdOf("contact_info_types", "Mail") +
        "  and i_address.line1 is not null order by last_update_stamp desc nulls last) "
        "left join state_types mailing_state on mailing_info.state_id = mailing_state.id "
        "left join person_contact_info home_info on home_info.id = "
        " (select first 1 i_address.id from person_contact_info i_address where i_address.person_id = P.id and "
        "  i_address.current_id+1 >= 4 and i_address.contact_info_id = " + lookupTables->IdOf("contact_info_types", "Home") +
        "  and i_address.line1 is not null order by last_update_stamp desc nulls last) "
        "left join state_types home_state on home_info.state_id = home_state.id "
        "where " + SafeInClause("DL.id", denial_letter_ids);
      DebugSql(NULL, &sql, other_forms, 9, dbLetterTransaction);
      dbLetterDataset->SelectSQL->Add(sql.c_str());
      dbLetterDataset->Open();

      report_form->report->DataSet = dbLetterDataset;
      report_form->bandLetterhead->Expression = "denial_letter_id";
      report_form->txtDateProcessed->DataSet = dbLetterDataset;
      report_form->txtDateProcessed->DataField = "date_processed";
      report_form->txtPerson->DataSet = dbLetterDataset;
      report_form->txtPerson->DataField = "person_id"; // OnPrint will fetch name
      report_form->txtProvider->DataSet = dbLetterDataset;
      report_form->txtProvider->DataField = "provider";
      report_form->txtGreeting->DataSet = dbLetterDataset;
      report_form->txtGreeting->DataField = "gender_id";
      report_form->txtReason->DataSet = dbLetterDataset;
      report_form->txtReason->DataField = "reason";

      if (doing_duplicates) // When printing duplicates, display the CHS chart number in the upper left-hand corner
      {
        report_form->lblChartNo->Enabled = true;
        report_form->txtChartNo->Enabled = true;
        report_form->txtChartNo->DataSet = dbLetterDataset;
        report_form->txtChartNo->DataField = "chart_no";
      }
      else
      {
        report_form->lblChartNo->Enabled = false;
        report_form->txtChartNo->Enabled = false;
      }

      report_form->Processing(false);

      if (duplicates)
        report_form->report->PreviewModal(); // Need to do modal preview if printing duplicates for filing
      else
        report_form->report->Preview();

      dbLetterDataset->Close();
      dbLetterTransaction->Commit();
    }
    catch(...)
    {
      if (report_form)
        report_form->Processing(false);
      if (dbLetterTransaction->Active)
        dbLetterTransaction->Rollback();
      ::PSay("Error printing letter", m_database_error, MB_OK, "reportDenialLetter::Do");
    }
    delete dbLetterDataset;
    delete dbLetterTransaction;
  }
  while (duplicates && (doing_duplicates ? false : (doing_duplicates = true, true))); // If duplicates is set, this will run twice.
}
//---------------------------------------------------------------------------
// jhaley 20100712: DOS items must be handled separately now, since there may be any number of them
// attached to a given letter. Putting them into the dataset doesn't work, as it causes all the reasons
// to get duplicated as well. So here we'll retrieve them separately and populate some memo controls on
// the report manually. (There is probably a more "reporty" way to do this...)
void __fastcall TformReportDenialLetter::bandRegardingBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
  string status_id = report->DataSet->FieldByName("denial_status_id")->AsString.c_str();
  string letter_id = report->DataSet->FieldByName("denial_letter_id")->AsString.c_str();
  string auth_id   = report->DataSet->FieldByName("denial_authority_id")->AsString.c_str();
  string sql_str = "select begin_date_of_service, end_date_of_service, billed_amount, patient_amount, payable_amount "
                   "from denial_items "
                   "where denial_letter_id = '" + letter_id + "' and current_id >= 2 "
                   "order by begin_date_of_service ";
  vector<map<string, string> > vec_map;

  // note that for the sake of old TPB letters, they are always treated as denials.
  bool is_approval = (status_id == lookupTables->IdOf("denial_status_types", "Resolved") &&
                      auth_id   != lookupTables->IdOf("denial_authority_types", "Third Party Billing"));

  // change Regarding label if this is a "resolved" (aka approved) item
  // change Payable label also - becomes "Denied" column for denial letters
  string orig_regarding_caption = lblRegarding->Caption.c_str();
  string orig_payable_caption = lblPayable->Caption.c_str();
  if (is_approval)
  {
    lblRegarding->Caption = ReplaceStringWithString(orig_regarding_caption, "Denial", "Approval").c_str();
    lblPayable->Caption   = ReplaceStringWithString(orig_payable_caption,   "Denied", "Payable").c_str();
  }
  else
  {
    lblRegarding->Caption = ReplaceStringWithString(orig_regarding_caption, "Approval", "Denial").c_str();
    lblPayable->Caption   = ReplaceStringWithString(orig_payable_caption,   "Payable",  "Denied").c_str();
  }

  // get all the denial_items for this letter
  SqlToVecMap(dbDatabase, sql_str, vec_map);

  // set defaults for memo visibility
  memoDOS->Enabled = true;
  memoAmount->Enabled = true;
  lblPatient->Enabled = true;
  memoPatient->Enabled = true;
  lblPayable->Enabled = true;
  memoPayable->Enabled = true;

  // be sure they start out empty
  memoDOS->Lines->Clear();
  memoAmount->Lines->Clear();
  memoPatient->Lines->Clear();
  memoPayable->Lines->Clear();

  for (vector<map<string, string> >::iterator i_item = vec_map.begin(); i_item != vec_map.end(); i_item++)
  {
    Pdate begin_date;
    Pdate end_date;
    string date_range_str;

    begin_date.InDate((*i_item)["begin_date_of_service"], mdy | yyyy);
    end_date.InDate((*i_item)["end_date_of_service"], mdy | yyyy);

    // preserved the old formatting for dates - if they're the same, only display a single date
    if (end_date != begin_date)
      date_range_str = begin_date.OutDate(mdy | yyyy) + " - " + end_date.OutDate(mdy | yyyy);
    else
      date_range_str = begin_date.OutDate(mdy | yyyy);

    memoDOS->Lines->Add(date_range_str.c_str());

    // add the amount
    memoAmount->Lines->Add(FormatString((*i_item)["billed_amount"], dollarString).c_str());

    // When this letter is for an approved item, everything works normally...
    if (is_approval)
    {
      if ((*i_item)["patient_amount"] != "")
        memoPatient->Lines->Add(FormatString((*i_item)["patient_amount"], dollarString).c_str());
      else
        memoPatient->Lines->Add("(none)"); // still here for the sake of old reports lacking this value.

      if ((*i_item)["payable_amount"] != "")
        memoPayable->Lines->Add(FormatString((*i_item)["payable_amount"], dollarString).c_str());
      else
        memoPayable->Lines->Add("(none)");
    }
    else // But if it's an ordinary denial letter, the "Payable" column transforms into a Denied column which repeats Pt.Resp.
    {
      if ((*i_item)["patient_amount"] != "")
      {
        string fmt = FormatString((*i_item)["patient_amount"], dollarString);
        memoPatient->Lines->Add(fmt.c_str());
        memoPayable->Lines->Add(fmt.c_str());
      }
      else
      {
        memoPatient->Lines->Add("(none)"); // still here for the sake of old reports lacking this value.
        memoPayable->Lines->Add("(none)");
      }
    } // end else
  } // end for loop
}
//---------------------------------------------------------------------------
// jhaley 20100715: Get the proper signature for the current letter's authority.
void __fastcall TformReportDenialLetter::bandSignatureBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
  string auth_id = report->DataSet->FieldByName("denial_authority_id")->AsString.c_str();
  string sql = "select tax_entities.name name, users.title "
               "from users "
               "inner join tax_entities on users.tax_entity_id = tax_entities.id "
               "where users.id = (select user_id from denial_authority_types where denial_authority_types.id = '" + auth_id + "') ";
  map<string, string> usermap;

  SqlToMap(dbDatabase, sql, usermap);

  memoSignature->Lines->Clear();
  memoSignature->Lines->Add((PrettyString(usermap["name"])).c_str());
  memoSignature->Lines->Add((PrettyString(usermap["title"])).c_str());
}
//---------------------------------------------------------------------------
// jhaley 20100715: Disable the detail band (with the reasons) when printing an approval letter.
void __fastcall TformReportDenialLetter::bandDetailBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
  string status_id = report->DataSet->FieldByName("denial_status_id")->AsString.c_str();

  bandDetail->Enabled = (status_id != lookupTables->IdOf("denial_status_types", "Resolved"));
}
//---------------------------------------------------------------------------

