//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reportDentalBillingData.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformReportDentalBillingData *formReportDentalBillingData;
//---------------------------------------------------------------------------
__fastcall TformReportDentalBillingData::TformReportDentalBillingData(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingData::billReportBeforePrint(TCustomQuickRep *Sender, bool &PrintReport)
{
  group_bill_count = 0;
  total_bill_count = 0;
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingData::billReportAfterPreview(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingData::bandGroupHeaderBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
  group_bill_count = 0;
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingData::bandDetailAfterPrint(TQRCustomBand *Sender, bool BandPrinted)
{
  // this always prints at least once even if the dataset is empty; don't show "1" for zero bills.
  if (!billReport->DataSet->IsEmpty())
  {
    group_bill_count++;
    total_bill_count++;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingData::lblTotalBillsMonthDisplayPrint(TObject *sender, AnsiString &Value)
{
  Value = StringToAmount(IntToString(group_bill_count), 0, 0).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingData::lblTotalBillsDisplayPrint(TObject *sender, AnsiString &Value)
{
  /* this isn't necessary; reset your totals in the report's BeforePrint() function.
  // the total count of bills should not increase if the report is printed out
  if(total_bill_count == last_total_bill_count * 2)
    total_bill_count = last_total_bill_count;
  else
    last_total_bill_count = total_bill_count;
  */
  Value = StringToAmount(IntToString(total_bill_count), 0, 0).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingData::exprMonthPrint(TObject *sender, AnsiString &Value)
{
  Value = PrettyString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingData::txtNamePrint(TObject *sender, AnsiString &Value)
{
  Value = PrettyString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingData::lblMonthTotalsPrint(TObject *sender, AnsiString &Value)
{
  Value = ("Totals for " + PrettyString(billReport->DataSet->FieldByName("month_name")->AsString.c_str())).c_str();
}
//---------------------------------------------------------------------------

