//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reportDentalBillingForm.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformReportDentalBillingForm *formReportDentalBillingForm;
//---------------------------------------------------------------------------
__fastcall TformReportDentalBillingForm::TformReportDentalBillingForm(TComponent* Owner, map<string,string> p_entities)
        : TformSpecialGeneric(Owner)
{
  LogIt("ada_claim.log", "begin local constructor");
  entities = p_entities;
  LogIt("ada_claim.log", "end local constructor");
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingForm::reportAfterPreview(TObject *Sender)
{
  // right?  I mean ... right?  Why wasn't this being done?
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingForm::ADA_reportAfterPreview(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingForm::txtPrettyPrint(TObject *sender, AnsiString &Value)
{
  Value = PrettyString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingForm::txtDoubleDigitPrint(TObject *sender, AnsiString &Value)
{
  Value = PadString(Value.c_str(), pad_left, '0', 2).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingForm::bandADAHeaderBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
  lblProcedureTotalFee->Caption = "0.00";

  memoADAInsurance->Lines->Clear();
  memoADAInsurance->Lines->Add(ADA_report->DataSet->FieldByName("pt_ins_company1")->AsString);
  //memoADAInsurance->Lines->Add("" /*plan*/);
  memoADAInsurance->Lines->Add(FormatAddress(ADA_report->DataSet->FieldByName("pt_ins_address1")->AsString.c_str()).c_str());
  memoADAInsurance->Lines->Add((PrettyString(ADA_report->DataSet->FieldByName("pt_ins_city1")->AsString.c_str()) + ", " +
                                UppercaseString(ADA_report->DataSet->FieldByName("pt_ins_state1")->AsString.c_str()) + "  " +
                                FormatZipCode(ADA_report->DataSet->FieldByName("pt_ins_zip1")->AsString.c_str())).c_str());

  memoADAOtherIns->Lines->Clear();
  memoADAOtherIns->Lines->Add(ADA_report->DataSet->FieldByName("pt_ins_company2")->AsString);
  //memoADAOtherIns->Lines->Add("" /*plan*/);
  memoADAOtherIns->Lines->Add(FormatAddress(ADA_report->DataSet->FieldByName("pt_ins_address2")->AsString.c_str()).c_str());
  memoADAOtherIns->Lines->Add((PrettyString(ADA_report->DataSet->FieldByName("pt_ins_city2")->AsString.c_str()) + ", " +
                                UppercaseString(ADA_report->DataSet->FieldByName("pt_ins_state2")->AsString.c_str()) + "  " +
                                FormatZipCode(ADA_report->DataSet->FieldByName("pt_ins_zip2")->AsString.c_str())).c_str());

  memoPolicyholder->Lines->Clear();
  memoPolicyholder->Lines->Add(PrettyString(ADA_report->DataSet->FieldByName("policyholder1")->AsString.c_str()).c_str());
  memoPolicyholder->Lines->Add(FormatAddress(ADA_report->DataSet->FieldByName("policyholder_address1")->AsString.c_str()).c_str());
  memoPolicyholder->Lines->Add((PrettyString(ADA_report->DataSet->FieldByName("policyholder_city1")->AsString.c_str()) + ", " +
                                UppercaseString(ADA_report->DataSet->FieldByName("policyholder_state1")->AsString.c_str()) + "  " +
                                FormatZipCode(ADA_report->DataSet->FieldByName("policyholder_zip1")->AsString.c_str())).c_str());

  memoPatient->Lines->Clear();
  memoPatient->Lines->Add(PrettyString(ADA_report->DataSet->FieldByName("pt_name")->AsString.c_str()).c_str());
  memoPatient->Lines->Add(FormatAddress(ADA_report->DataSet->FieldByName("pt_address_street")->AsString.c_str()).c_str());
  memoPatient->Lines->Add((PrettyString(ADA_report->DataSet->FieldByName("pt_address_city")->AsString.c_str()) + ", " +
                                UppercaseString(ADA_report->DataSet->FieldByName("pt_address_state")->AsString.c_str()) + "  " +
                                FormatZipCode(ADA_report->DataSet->FieldByName("pt_address_zip")->AsString.c_str())).c_str());
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingForm::bandADAFooterBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
  memoRemarks->Lines->Clear();
  memoRemarks->Lines->Add(ADA_report->DataSet->FieldByName("remarks")->AsString);

  memoClinic->Lines->Clear();
  memoClinic->Lines->Add(entities["clinic_name"].c_str());
  memoClinic->Lines->Add(FormatAddress(entities["clinic_address"]).c_str());
  memoClinic->Lines->Add((PrettyString(entities["clinic_city"]) + ", " +
                                UppercaseString(entities["clinic_state"]) + "  " +
                                FormatZipCode(entities["clinic_zip"])).c_str());

  memoDentist->Lines->Clear();
  memoDentist->Lines->Add(FormatAddress(ADA_report->DataSet->FieldByName("dentist_address")->AsString.c_str()).c_str());
  memoDentist->Lines->Add((PrettyString(ADA_report->DataSet->FieldByName("dentist_city")->AsString.c_str()) + ", " +
                                UppercaseString(ADA_report->DataSet->FieldByName("dentist_state")->AsString.c_str()) + "  " +
                                FormatZipCode(ADA_report->DataSet->FieldByName("dentist_zip")->AsString.c_str())).c_str());
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingForm::exprProcedureFeePrint(TObject *sender, AnsiString &Value)
{ // so god-awful ugly and seemingly inefficient.  Blame Philip.  I asked him how he'd do it.
  lblProcedureTotalFee->Caption =
    StringToAmount(FloatToString(
       StringToFloat(AmountToString(lblProcedureTotalFee->Caption.c_str())) +
       StringToFloat(AmountToString(Value.c_str()))
    )).c_str();
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void TformReportDentalBillingForm::DoADA(vector<string> claims)
{
  TformReportDentalBillingForm *report_form = NULL;

  LogIt("ada_claim.log", "creating form");
  FORM_TRY
    report_form = new TformReportDentalBillingForm(NULL);
  FORM_CATCH_RETURN("TformReportDentalBillingForm", )
  LogIt("ada_claim.log", "done creating form");

  LogIt("ada_claim.log", "starting up");
  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  TIBDataSet * dbDataSet = new TIBDataSet(NULL);
  int reportstage = 0;

  report_form->Processing(true);

  try
  {
    StdTransaction (dbTransaction, dbDatabase);
    dbDataSet->Database = dbDatabase;
    dbDataSet->Transaction = dbTransaction;
    dbDataSet->UniDirectional = false;
    string sql;

    map<string, string> entities;
    string entity_sql;
    entity_sql = "select "
                 "  facility.name clinic_name, "
                 "  facility_addr.line1 || case when facility_addr.line2 is not null and facility_addr.line2 != '' "
                 "    then ' / ' || facility_addr.line2 else '' end clinic_address, "
                 "  facility_addr.city clinic_city, "
                 "  facility_st.abbreviation clinic_state, "
                 "  facility_addr.zip clinic_zip, "
                 "  facility_addr.phone_number clinic_phone, "
                 "  facility_npi.identifier clinic_npi, "
                 "  facility_license.identifier clinic_license, "
                 "  facility_tin.identifier clinic_tin, "
                 "  '122300000X' dentist_code "
                 "from groups grp "
                 "left join tax_entities facility on grp.facility_id = facility.id "
                 "left join entity_ids facility_npi on facility_npi.tax_entity_id = facility.id and facility_npi.current_id >= 3 and "
                 "  facility_npi.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "NPI") + "' "
                 "left join entity_ids facility_license on facility_license.tax_entity_id = facility.id and facility_license.current_id >= 3 and "
                 "  facility_license.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "OK License") + "' "
                 "left join entity_ids facility_tin on facility_tin.tax_entity_id = facility.id and facility_tin.current_id >= 3 and "
                 "  facility_tin.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "TIN/EIN") + "' "
                 "left join tax_addresses facility_addr on facility.billing_address_id = facility_addr.id "
                 "left join state_types facility_st on facility_addr.state_id = facility_st.id "
                 "where grp.id = '" + lookupTables->IdOf("groups", "Dental Clinic") + "' ";

    ++reportstage; // 1
    DebugSql(NULL, &entity_sql, other_forms, 9);
    LogIt("ada_claim.log", "fetching entity info");
    SqlToMap(dbTransaction, entity_sql, entities);
    LogIt("ada_claim.log", "done fetching entity info");

    // jhaley 20110719: Form is now created above. Just set the entities here.
    ++reportstage; // 2
    report_form->entities = entities;

    ++reportstage; // 3
    LogIt("ada_claim.log", "emptying temp table");
    string rel_sql;
    rel_sql = "delete from temp_relationships_view";
    if (!ExecuteStatement(dbTransaction, rel_sql))
    {
      ::PSay("Failed to empty temporary table", m_database_error, MB_OK, "reportDentalBillingForm::DoADA");
      LogIt("ada_claim.log", "failed emptying temp table");
      return;
    }
    LogIt("ada_claim.log", "done emptying temp table");

    ++reportstage; // 4
    rel_sql = "insert into temp_relationships_view (id, original_id, current_id, last_update_stamp, last_updated_by, person_a_id, person_b_id, a_is_emergency, b_is_emergency, a_is_banned, b_is_banned, a_is_responsible, b_is_responsible, same_household, rel_a_to_b_id, rel_b_to_a_id) "
              "select gen_id(temp_relationships_view_gen, 1), id, current_id, last_update_stamp, last_updated_by, person_a_id, person_b_id, a_is_emergency, b_is_emergency, a_is_banned, b_is_banned, a_is_responsible, b_is_responsible, same_household, rel_a_to_b_id, rel_b_to_a_id "
              "from relationships";
    LogIt("ada_claim.log", "populating temp table (1 of 2)");
    if (!ExecuteStatement(dbTransaction, rel_sql))
    {
      ::PSay("Failed to put first set of data into temporary table", m_database_error, MB_OK, "reportDentalBillingForm::DoADA");
      LogIt("ada_claim.log", "failed populating temp table (1 of 2)");
      return;
    }
    ++reportstage; // 5
    rel_sql = "insert into temp_relationships_view (id, original_id, current_id, last_update_stamp, last_updated_by, person_a_id, person_b_id, a_is_emergency, b_is_emergency, a_is_banned, b_is_banned, a_is_responsible, b_is_responsible, same_household, rel_a_to_b_id, rel_b_to_a_id) "
              "select gen_id(temp_relationships_view_gen, 1), id, current_id, last_update_stamp, last_updated_by, person_b_id, person_a_id, b_is_emergency, a_is_emergency, b_is_banned, a_is_banned, b_is_responsible, a_is_responsible, same_household, rel_b_to_a_id, rel_a_to_b_id "
              "from relationships";
    LogIt("ada_claim.log", "populating temp table (2 of 2)");
    if (!ExecuteStatement(dbTransaction, rel_sql))
    {
      ::PSay("Failed to put second set of data into temporary table", m_database_error, MB_OK, "reportDentalBillingForm::DoADA");
      LogIt("ada_claim.log", "failed populating temp table (2 of 2)");
      return;
    }
    LogIt("ada_claim.log", "done populating temp table");

    ++reportstage; // 6
    LogIt("ada_claim.log", "getting chart location");
    string chart_location = GetOneField(dbTransaction, "select chart_location_id from groups where id = '" + lookupTables->IdOf("groups", "Dental Clinic") + "'");
    LogIt("ada_claim.log", "done getting chart location");

    /* TODO: Everything up to this point only has to be run -once- per bill, even if multiple bills are to be run in one batch.
             The *following* SQL is the only statement that would need to be changed to accomodate such a batch-run. */
    sql = "select "
            "pt_ins_t1.name pt_ins_company1, "
            "'' pt_ins_plan1, "
            "pt_ins_t_ba1.line1 || case when pt_ins_t_ba1.line2 is not null and pt_ins_t_ba1.line2 != '' then ' / ' || pt_ins_t_ba1.line2 else '' end pt_ins_address1, "
            "pt_ins_t_ba1.city pt_ins_city1, "
            "pt_ins_t_st1.abbreviation pt_ins_state1, "
            "pt_ins_t_ba1.zip pt_ins_zip1, "
            "case when pt_ins_c2.id is null then 'X' else '' end other_ins_no, "
            "case when pt_ins_c2.id is not null then 'X' else '' end other_ins_yes, "
            "case when pt_ins_p2.name_on_policy is not null and pt_ins_p2.name_on_policy != '' then pt_ins_p2.name_on_policy else pt_ins_phn2.first_name || case when pt_ins_phn2.middle_name is not null and pt_ins_phn2.middle_name != '' then ' ' || pt_ins_phn2.middle_name else '' end || pt_ins_phn2.last_name || case when pt_ins_phn2.suffix is not null and pt_ins_phn2.suffix != '' then ' ' || pt_ins_phn2.suffix else '' end end policyholder2, "
            "pt_ins_ph2.birth_date policyholder_dob2, "
            "case when pt_ins_ph2.gender_id = '" + lookupTables->IdOf("gender_types", "Male") + "' then 'X' else '' end policyholder_male2, "
            "case when pt_ins_ph2.gender_id = '" + lookupTables->IdOf("gender_types", "Female") + "' then 'X' else '' end policyholder_female2, "
            "pt_ins_p2.policy_number policy_number2, "
            "pt_ins_p2.group_number group_number2, "
            "case when patient.id = pt_ins_ph2.id then 'X' else '' end pt_ph_rel_self2, "
            "case when pt_ins_ph_rel2.rel_b_to_a_id in ('" + lookupTables->IdOf("relationship_types", "Husband") + "','" + lookupTables->IdOf("relationship_types", "Wife") + "') then 'X' else '' end pt_ph_rel_spouse2, "
            "case when pt_ins_ph_rel2.b_is_responsible = 1 or pt_ins_ph_rel2.rel_b_to_a_id in ('" + lookupTables->IdOf("relationship_types", "Legal Guardian") + "','" + lookupTables->IdOf("relationship_types", "Legal Responsibility") + "','" + lookupTables->IdOf("relationship_types", "Power Of Attorney") + "') then 'X' else '' end pt_ph_rel_dependent2, "
            "case when patient.id != pt_ins_ph2.id and pt_ins_ph_rel2.rel_b_to_a_id not in ('" + lookupTables->IdOf("relationship_types", "Legal Guardian") + "','" + lookupTables->IdOf("relationship_types", "Legal Responsibility") + "','" + lookupTables->IdOf("relationship_types", "Power Of Attorney") + "','" + lookupTables->IdOf("relationship_types", "Husband") + "','" + lookupTables->IdOf("relationship_types", "Wife") + "') and pt_ins_ph_rel2.b_is_responsible = 0 then 'X' else '' end pt_ph_rel_other2, "
            "pt_ins_t2.name pt_ins_company2, "
            "'' pt_ins_plan2, "
            "pt_ins_t_ba2.line1 || case when pt_ins_t_ba2.line2 is not null and pt_ins_t_ba2.line2 != '' then ' / ' || pt_ins_t_ba2.line2 else '' end pt_ins_address2, "
            "pt_ins_t_ba2.city pt_ins_city2, "
            "pt_ins_t_st2.abbreviation pt_ins_state2, "
            "pt_ins_t_ba2.zip pt_ins_zip2, "
            "case when pt_ins_p1.name_on_policy is not null and pt_ins_p1.name_on_policy != '' then pt_ins_p1.name_on_policy else pt_ins_phn1.first_name || case when pt_ins_phn1.middle_name is not null and pt_ins_phn1.middle_name != '' then ' ' || pt_ins_phn1.middle_name else '' end || pt_ins_phn1.last_name || case when pt_ins_phn1.suffix is not null and pt_ins_phn1.suffix != '' then ' ' || pt_ins_phn1.suffix else '' end end policyholder1, "
            "pt_ins_ph_a1.line1 || case when pt_ins_ph_a1.line2 is not null and pt_ins_ph_a1.line2 != '' then ' / ' || pt_ins_ph_a1.line2 else '' end policyholder_address1, "
            "pt_ins_ph_a1.city policyholder_city1, "
            "pt_ins_ph_a_st1.abbreviation policyholder_state1, "
            "pt_ins_ph_a1.zip policyholder_zip1, "
            "pt_ins_ph1.birth_date policyholder_dob1, "
            "case when pt_ins_ph1.gender_id = '" + lookupTables->IdOf("gender_types", "Male") + "' then 'X' else '' end policyholder_male1, "
            "case when pt_ins_ph1.gender_id = '" + lookupTables->IdOf("gender_types", "Female") + "' then 'X' else '' end policyholder_female1, "
            "pt_ins_p1.policy_number policy_number1, "
            "pt_ins_p1.group_number group_number1, "
            "case when pt_ins_p1.source_id = '" + lookupTables->IdOf("source_types", "Employer") + "' then '1' else '0' end insured_through_employer1, "
            "pt_ins_ph_empn1.last_name employer_name1, "
            "case when patient.id = pt_ins_ph1.id then 'X' else '' end pt_ph_rel_self1, "
            "case when pt_ins_ph_rel1.rel_b_to_a_id in ('" + lookupTables->IdOf("relationship_types", "Husband") + "','" + lookupTables->IdOf("relationship_types", "Wife") + "') then 'X' else '' end pt_ph_rel_spouse1, "
            "case when pt_ins_ph_rel1.b_is_responsible = 1 or pt_ins_ph_rel1.rel_b_to_a_id in ('" + lookupTables->IdOf("relationship_types", "Legal Guardian") + "','" + lookupTables->IdOf("relationship_types", "Legal Responsibility") + "','" + lookupTables->IdOf("relationship_types", "Power Of Attorney") + "') then 'X' else '' end pt_ph_rel_dependent1, "
            "case when patient.id != pt_ins_ph1.id and pt_ins_ph_rel1.rel_b_to_a_id not in ('" + lookupTables->IdOf("relationship_types", "Legal Guardian") + "','" + lookupTables->IdOf("relationship_types", "Legal Responsibility") + "','" + lookupTables->IdOf("relationship_types", "Power Of Attorney") + "','" + lookupTables->IdOf("relationship_types", "Husband") + "','" + lookupTables->IdOf("relationship_types", "Wife") + "') and pt_ins_ph_rel1.b_is_responsible = 0 then 'X' else '' end pt_ph_rel_other1, "
            /* student status: FTS, PTS */
            "patient_name.last_name || ', ' || patient_name.first_name || ', ' || substring(patient_name.middle_name from 1 for 1) || ', ' || patient_name.suffix pt_name, "
            "patient_address.line1 || case when patient_address.line2 is not null and patient_address.line2 != '' then ' / ' || patient_address.line2 else '' end pt_address_street, "
            "patient_address.city pt_address_city, "
            "pt_ins_t_st2.abbreviation pt_address_state, "
            "patient_address.zip pt_address_zip, "
            "patient.birth_date patient_dob, "
            "case when patient.gender_id = '" + lookupTables->IdOf("gender_types", "Male") + "' then 'X' else '' end patient_male, "
            "case when patient.gender_id = '" + lookupTables->IdOf("gender_types", "Female") + "' then 'X' else '' end patient_female, "
            "den_chart.chart_number, "
            "px.start_date px_date, "
            "px.tooth_position px_tooth_number, "
            "px.tooth_surface px_tooth_surface, "
            "px.cpt_hcpcs px_code, "
            "codes.description px_description, "
            "px.charges px_fee, "
            "'               ' || claim.note remarks, "
            "claim.ada_radiographs radiographs, "
            "claim.ada_oral_images oral_images, "
            "claim.ada_models models, "
            "case when claim.ada_ortho_tx = 1 then '' else 'X' end ortho_no, "
            "case when claim.ada_ortho_tx = 1 then 'X' else '' end ortho_yes, "
            "claim.ada_ortho_placed ortho_date, "
            "claim.ada_ortho_remaining ortho_months, "
            "case when claim.ada_job_injury = 1 then 'X' else '' end job_injury, "
            "case when claim.ada_auto_injury = 1 then 'X' else '' end auto_injury, "
            "case when claim.ada_other_injury = 1 then 'X' else '' end other_injury, "
            "claim.ada_injury_date injury_date, "
            "auto_st.abbreviation injury_state, "
            "provider.name dentist_name, "
            "provider_addr.line1 || case when provider_addr.line2 is not null and provider_addr.line2 != '' then ' / ' || provider_addr.line2 else '' end dentist_address, "
            "provider_addr.city dentist_city, "
            "provider_st.abbreviation dentist_state, "
            "provider_addr.zip dentist_zip, "
            "provider_addr.phone_number dentist_phone, "
            "provider_npi.identifier dentist_npi, "
            "provider_license.identifier dentist_license "
          "from bills claim "
          "left join tasks visit on claim.task_id = visit.id "
          "left join tax_entities vp on visit.tax_entity_id = vp.id " // provider on the visit
          "left join users vpu on vpu.tax_entity_id = vp.id " // user account of that provider
          "left join tax_entities provider on vpu.under_provider_id = provider.id " // doctor/dentist that this provider is *under* (head-of-practice)
          "left join entity_ids provider_npi on provider_npi.tax_entity_id = provider.id and provider_npi.current_id >= 3 and provider_npi.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "NPI") + "' "
          "left join entity_ids provider_license on provider_license.tax_entity_id = provider.id and provider_license.current_id >= 3 and provider_license.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "OK License") + "' "
          "left join tax_addresses provider_addr on provider.physical_address_id = provider_addr.id "
          "left join state_types provider_st on provider_addr.state_id = provider_st.id "
          "left join people patient on visit.person_id = patient.id "
          "left join person_names patient_name on patient.person_names_id = patient_name.id "
          "left join person_contact_info patient_address on patient.home_address_id = patient_address.id "
          "left join charts den_chart on den_chart.id = (select first 1 ic.id from charts ic where ic.person_id = patient.id and ic.location_id = '" + chart_location + "' and ic.current_id+1 > 3 order by last_update_stamp desc) "
          "left join insurance_coverage pt_ins_c1 on pt_ins_c1.person_id = patient.id and pt_ins_c1.id = claim.insurance_coverage_id "
          "left join insurance_policies pt_ins_p1 on pt_ins_c1.insurance_policy_id = pt_ins_p1.id "
          "left join insurance_benefits pt_ins_b1 on pt_ins_b1.insurance_policy_id = pt_ins_p1.id and pt_ins_b1.area_id = '" + lookupTables->IdOf("area_types", "Dental") + "' "
          "left join tax_entities pt_ins_t1 on pt_ins_p1.tax_entity_id = pt_ins_t1.id "
          "left join tax_addresses pt_ins_t_ba1 on pt_ins_t1.billing_address_id = pt_ins_t_ba1.id "
          "left join state_types pt_ins_t_st1 on pt_ins_t_ba1.state_id = pt_ins_t_st1.id "
          "left join people pt_ins_ph1 on pt_ins_p1.policy_holder_id = pt_ins_ph1.id "
          "left join person_contact_info pt_ins_ph_a1 on pt_ins_ph1.home_address_id = pt_ins_ph_a1.id "
          "left join state_types pt_ins_ph_a_st1 on pt_ins_ph_a1.state_id = pt_ins_ph_a_st1.id "
          "left join person_names pt_ins_phn1 on pt_ins_ph1.person_names_id = pt_ins_phn1.id "
          "left join temp_relationships_view pt_ins_ph_rel1 on pt_ins_ph_rel1.id = (select first 1 trv.id from temp_relationships_view trv where trv.person_a_id = patient.id and trv.person_b_id = pt_ins_ph1.id and trv.current_id+1>3 order by last_update_stamp desc) "
          "left join people pt_ins_ph_emp1 on pt_ins_p1.person_id = pt_ins_ph_emp1.id "
          "left join person_names pt_ins_ph_empn1 on pt_ins_ph_emp1.person_names_id = pt_ins_ph_empn1.id "
          "left join state_types auto_st on claim.ada_injury_state = auto_st.id "

          "left join insurance_coverage pt_ins_c2 on pt_ins_c2.id = "
           "(select first 1 other_ins_c.id "
            "from insurance_coverage other_ins_c "
                 "inner join insurance_policies other_ins_p on other_ins_c.insurance_policy_id = other_ins_p.id "
                 "inner join insurance_benefits other_ins_b on other_ins_b.insurance_policy_id = other_ins_p.id "
            "where other_ins_c.person_id = patient.id and other_ins_c.id != pt_ins_c1.id "  /* Rhiannon tells me they don't want it to include medical ... only other *dental* insurance, if they have any */
                  "and other_ins_b.area_id in ('" + lookupTables->IdOf("area_types", "Dental") + /*"','" + lookupTables->IdOf("area_types", "Medical") +*/ "') "
                  "and (other_ins_c.start_date is null or other_ins_c.start_date <= claim.bill_date) "
                  "and (other_ins_c.stop_date is null or other_ins_c.stop_date > claim.bill_date) ) "
          "left join insurance_policies pt_ins_p2 on pt_ins_c2.insurance_policy_id = pt_ins_p2.id "
          "left join tax_entities pt_ins_t2 on pt_ins_p2.tax_entity_id = pt_ins_t2.id "
          "left join tax_addresses pt_ins_t_ba2 on pt_ins_t2.billing_address_id = pt_ins_t_ba2.id "
          "left join state_types pt_ins_t_st2 on pt_ins_t_ba2.state_id = pt_ins_t_st2.id "
          "left join people pt_ins_ph2 on pt_ins_p2.policy_holder_id = pt_ins_ph2.id "
          "left join person_names pt_ins_phn2 on pt_ins_ph2.person_names_id = pt_ins_phn2.id "
          "left join temp_relationships_view pt_ins_ph_rel2 on pt_ins_ph_rel2.id = (select first 1 trv.id from temp_relationships_view trv where trv.person_a_id = patient.id and trv.person_b_id = pt_ins_ph2.id and trv.current_id+1>3 order by last_update_stamp desc) "

          "left join procedures px on px.task_id = visit.id and px.current_id+1>3 "
          "left join codes on px.cpt_hcpcs = codes.code and codes.code_id in ('" + lookupTables->IdOf("code_types", "CPT-4") + "','" + lookupTables->IdOf("code_types", "HCPCS") + "','" + lookupTables->IdOf("code_types", "MEDICAID") + "') " 

          "where " + SafeInClause("claim.id", claims) + " "
          "order by claim.id, px.start_date";

    ++reportstage; // 7
    DebugSql(NULL, &sql, other_forms, 9);
    LogIt("ada_claim.log", "fetching data for report");
    dbDataSet->SelectSQL->Add(sql.c_str());
    dbDataSet->Open();
    dbDataSet->First();
    LogIt("ada_claim.log", "done fetching data for report");
    /* I'm feeling REALLY nice today, so let's go ahead and do a quick scan of the data, see if anything obvious is missing, and if so, warn them */
    ++reportstage; // 8
    LogIt("ada_claim.log", "checking for any obviously missing data");
    string missing = "";
    if (dbDataSet->FieldByName("pt_ins_company1")->AsString == "") missing += "(3) Dental insurance company's name\n";
    if (dbDataSet->FieldByName("pt_ins_address1")->AsString == "") missing += "(3) Dental insurance company's address\n";
    if (dbDataSet->FieldByName("pt_ins_city1")->AsString == "") missing += "(3) Dental insurance company's city\n";
    if (dbDataSet->FieldByName("pt_ins_state1")->AsString == "") missing += "(3) Dental insurance company's state\n";
    if (dbDataSet->FieldByName("pt_ins_zip1")->AsString == "") missing += "(3) Dental insurance company's zip code\n";
    if (dbDataSet->FieldByName("other_ins_yes")->AsString == "X")
    {
      if (dbDataSet->FieldByName("policyholder2")->AsString == "") missing += "(5) Other insurance coverage, policyholder's name\n";
      if (dbDataSet->FieldByName("policyholder_dob2")->AsString == "") missing += "(6) Other insurance coverage, policyholder's DOB\n";
      if (dbDataSet->FieldByName("policyholder_male2")->AsString == "" && dbDataSet->FieldByName("policyholder_female2")->AsString == "") missing += "(7) Other insurance coverage, policyholder's gender\n";
      if (dbDataSet->FieldByName("policy_number2")->AsString == "") missing += "(8) Other insurance coverage, policy number/subscriber ID\n";
      if (dbDataSet->FieldByName("group_number2")->AsString == "") missing += "(9) Other insurance coverage, group number/plan number\n";
      if (dbDataSet->FieldByName("pt_ph_rel_self2")->AsString == "" && dbDataSet->FieldByName("pt_ph_rel_spouse2")->AsString == "" &&
          dbDataSet->FieldByName("pt_ph_rel_dependent2")->AsString == "" && dbDataSet->FieldByName("pt_ph_rel_other2")->AsString == "") missing += "(10) Other insurance coverage, patient's relationship to policyholder\n";
      if (dbDataSet->FieldByName("pt_ins_company2")->AsString == "") missing += "(11) Other insurance company's name\n";
      if (dbDataSet->FieldByName("pt_ins_address2")->AsString == "") missing += "(11) Other insurance company's address\n";
      if (dbDataSet->FieldByName("pt_ins_city2")->AsString == "") missing += "(11) Other insurance company's city\n";
      if (dbDataSet->FieldByName("pt_ins_state2")->AsString == "") missing += "(11) Other insurance company's state\n";
      if (dbDataSet->FieldByName("pt_ins_zip2")->AsString == "") missing += "(11) Other insurance company's zip code\n";
    }
    if (dbDataSet->FieldByName("policyholder1")->AsString == "") missing += "(12) Dental insurance coverage, policyholder's name\n";
    if (dbDataSet->FieldByName("policyholder_address1")->AsString == "") missing += "(12) Dental insurance coverage, policyholder's address\n";
    if (dbDataSet->FieldByName("policyholder_city1")->AsString == "") missing += "(12) Dental insurance coverage, policyholder's city\n";
    if (dbDataSet->FieldByName("policyholder_state1")->AsString == "") missing += "(12) Dental insurance coverage, policyholder's state\n";
    if (dbDataSet->FieldByName("policyholder_zip1")->AsString == "") missing += "(12) Dental insurance coverage, policyholder's zip code\n";
    if (dbDataSet->FieldByName("policyholder_dob1")->AsString == "") missing += "(13) Dental insurance coverage, policyholder's DOB\n";
    if (dbDataSet->FieldByName("policyholder_male1")->AsString == "" && dbDataSet->FieldByName("policyholder_female1")->AsString == "") missing += "(14) Dental insurance coverage, policyholder's gender\n";
    if (dbDataSet->FieldByName("policy_number1")->AsString == "") missing += "(15) Dental insurance coverage, policy number/subscriber ID\n";
    if (dbDataSet->FieldByName("group_number1")->AsString == "") missing += "(16) Dental insurance coverage, group number/plan number\n";
    if (dbDataSet->FieldByName("insured_through_employer1")->AsString == "1")
      if (dbDataSet->FieldByName("employer_name1")->AsString == "") missing += "(17) Dental insurance coverage, Employer name\n";
    if (dbDataSet->FieldByName("pt_ph_rel_self1")->AsString == "" && dbDataSet->FieldByName("pt_ph_rel_spouse1")->AsString == "" &&
        dbDataSet->FieldByName("pt_ph_rel_dependent1")->AsString == "" && dbDataSet->FieldByName("pt_ph_rel_other1")->AsString == "") missing += "(18) Dental insurance coverage, patient's relationship to policyholder\n";
    if (dbDataSet->FieldByName("pt_name")->AsString == "") missing += "(20) Patient's name\n";
    if (dbDataSet->FieldByName("pt_address_street")->AsString == "") missing += "(20) Patient's address\n";
    if (dbDataSet->FieldByName("pt_address_city")->AsString == "") missing += "(20) Patient's city\n";
    if (dbDataSet->FieldByName("pt_address_state")->AsString == "") missing += "(20) Patient's state\n";
    if (dbDataSet->FieldByName("pt_address_zip")->AsString == "") missing += "(20) Patient's zip code\n";
    if (dbDataSet->FieldByName("patient_dob")->AsString == "") missing += "(21) Patient's DOB\n";
    if (dbDataSet->FieldByName("patient_male")->AsString == "" && dbDataSet->FieldByName("patient_female")->AsString == "") missing += "(22) Patient's gender\n";
    if (dbDataSet->FieldByName("chart_number")->AsString == "") missing += "(21) Patient's chart number\n";
    if (dbDataSet->FieldByName("ortho_yes")->AsString == "X")
    {
      if (dbDataSet->FieldByName("ortho_date")->AsString == "") missing += "(41) Date appliance placed\n";
      if (dbDataSet->FieldByName("ortho_months")->AsString == "") missing += "(42) Months of Treatment Remaining\n";
    }
    if (dbDataSet->FieldByName("job_injury")->AsString == "X" || dbDataSet->FieldByName("auto_injury")->AsString == "X" || dbDataSet->FieldByName("other_injury")->AsString == "X")
      if(dbDataSet->FieldByName("injury_date")->AsString == "") missing += "(46) Date of Accident";
    if (dbDataSet->FieldByName("auto_injury")->AsString == "X")
      if(dbDataSet->FieldByName("injury_state")->AsString == "") missing += "(47) Auto Accident State";
    LogIt("ada_claim.log", "done checking for any obviously missing data");

    ++reportstage; // 9
    bool all_is_well = true;
    if (missing != "")
    {
      LogIt("ada_claim.log", "missing data: waiting on user response");
      int answer = ::PSay("Some data appears to be missing:\n\n" + missing + "\nAre you sure you want to print the claim as-is?", m_warning, MB_YESNO, "reportDentalBillingForm::DoADA");
      if (answer == IDNO)
      {
        all_is_well = false;
        LogIt("ada_claim.log", "missing data: abort");
      }
      else
        LogIt("ada_claim.log", "missing data: continue");
    }

    ++reportstage; // 10
    if (all_is_well)
    {
      LogIt("ada_claim.log", "running report");
      report_form->ADA_report->DataSet = dbDataSet;
      report_form->txtADAOtherInsNo->DataSet = dbDataSet;
      report_form->txtADAOtherInsNo->DataField = "other_ins_no";
      report_form->txtADAOtherInsYes->DataSet = dbDataSet;
      report_form->txtADAOtherInsYes->DataField = "other_ins_yes";
      report_form->txtADAOtherInsPolicyholder->DataSet = dbDataSet;
      report_form->txtADAOtherInsPolicyholder->DataField = "policyholder2";

      report_form->txtADAOtherInsDOB->DataSet = dbDataSet;
      report_form->txtADAOtherInsDOB->DataField = "policyholder_dob2";
      report_form->txtADAOtherInsMale->DataSet = dbDataSet;
      report_form->txtADAOtherInsMale->DataField = "policyholder_male2";
      report_form->txtADAOtherInsFemale->DataSet = dbDataSet;
      report_form->txtADAOtherInsFemale->DataField = "policyholder_female2";
      report_form->txtADAOtherInsPolicyNumber->DataSet = dbDataSet;
      report_form->txtADAOtherInsPolicyNumber->DataField = "policy_number2";
      report_form->txtADAOtherInsGroupNumber->DataSet = dbDataSet;
      report_form->txtADAOtherInsGroupNumber->DataField = "group_number2";
      report_form->txtADAOtherInsRelSelf->DataSet = dbDataSet;
      report_form->txtADAOtherInsRelSelf->DataField = "pt_ph_rel_self2";
      report_form->txtADAOtherInsRelSpouse->DataSet = dbDataSet;
      report_form->txtADAOtherInsRelSpouse->DataField = "pt_ph_rel_spouse2";
      report_form->txtADAOtherInsRelChild->DataSet = dbDataSet;
      report_form->txtADAOtherInsRelChild->DataField = "pt_ph_rel_dependent2";
      report_form->txtADAOtherInsRelOther->DataSet = dbDataSet;
      report_form->txtADAOtherInsRelOther->DataField = "pt_ph_rel_other2";
      report_form->txtADAPrimaryInsDOB->DataSet = dbDataSet;
      report_form->txtADAPrimaryInsDOB->DataField = "policyholder_dob1";
      report_form->txtADAPrimaryInsMale->DataSet = dbDataSet;
      report_form->txtADAPrimaryInsMale->DataField = "policyholder_male1";
      report_form->txtADAPrimaryInsFemale->DataSet = dbDataSet;
      report_form->txtADAPrimaryInsFemale->DataField = "policyholder_female1";
      report_form->txtADAPrimaryInsPolicyNumber->DataSet = dbDataSet;
      report_form->txtADAPrimaryInsPolicyNumber->DataField = "policy_number1";
      report_form->txtADAPrimaryInsGroupNumber->DataSet = dbDataSet;
      report_form->txtADAPrimaryInsGroupNumber->DataField = "group_number1";
      report_form->txtADAPrimaryInsEmployer->DataSet = dbDataSet;
      report_form->txtADAPrimaryInsEmployer->DataField = "employer_name1";
      report_form->txtADAPrimaryInsRelSelf->DataSet = dbDataSet;
      report_form->txtADAPrimaryInsRelSelf->DataField = "pt_ph_rel_self1";
      report_form->txtADAPrimaryInsRelSpouse->DataSet = dbDataSet;
      report_form->txtADAPrimaryInsRelSpouse->DataField = "pt_ph_rel_spouse1";
      report_form->txtADAPrimaryInsRelChild->DataSet = dbDataSet;
      report_form->txtADAPrimaryInsRelChild->DataField = "pt_ph_rel_dependent1";
      report_form->txtADAPrimaryInsRelOther->DataSet = dbDataSet;
      report_form->txtADAPrimaryInsRelOther->DataField = "pt_ph_rel_other1";
      report_form->txtADAPatientDOB->DataSet = dbDataSet;
      report_form->txtADAPatientDOB->DataField = "patient_dob";
      report_form->txtADAPatientMale->DataSet = dbDataSet;
      report_form->txtADAPatientMale->DataField = "patient_male";
      report_form->txtADAPatientFemale->DataSet = dbDataSet;
      report_form->txtADAPatientFemale->DataField = "patient_female";
      report_form->txtADAPatientChartNumber->DataSet = dbDataSet;
      report_form->txtADAPatientChartNumber->DataField = "chart_number";
      report_form->txtProcedureDate->DataSet = dbDataSet;
      report_form->txtProcedureDate->DataField = "px_date";
      report_form->txtToothNumbers->DataSet = dbDataSet;
      report_form->txtToothNumbers->DataField = "px_tooth_number";
      report_form->txtProcedureToothSurface->DataSet = dbDataSet;
      report_form->txtProcedureToothSurface->DataField = "px_tooth_surface";
      report_form->txtProcedureCode->DataSet = dbDataSet;
      report_form->txtProcedureCode->DataField = "px_code";
      report_form->txtProcedureDescription->DataSet = dbDataSet;
      report_form->txtProcedureDescription->DataField = "px_description";
      report_form->exprProcedureFee->Expression = "FORMATNUMERIC('##,##0.00', px_fee)";
      //report_form->exprProcedureTotalFee->Expression = "FORMATNUMERIC('##,##0.00', SUM(px_fee))";

      report_form->txtRadiographs->DataSet = dbDataSet;
      report_form->txtRadiographs->DataField = "radiographs";
      report_form->txtOralImages->DataSet = dbDataSet;
      report_form->txtOralImages->DataField = "oral_images";
      report_form->txtModels->DataSet = dbDataSet;
      report_form->txtModels->DataField = "models";
      report_form->txtOrthoNo->DataSet = dbDataSet;
      report_form->txtOrthoNo->DataField = "ortho_no";
      report_form->txtOrthoYes->DataSet = dbDataSet;
      report_form->txtOrthoYes->DataField = "ortho_yes";
      report_form->txtOrthoDatePlaced->DataSet = dbDataSet;
      report_form->txtOrthoDatePlaced->DataField = "ortho_date";
      report_form->txtOrthoMonthsRemaining->DataSet = dbDataSet;
      report_form->txtOrthoMonthsRemaining->DataField = "ortho_months";
      report_form->txtJobInjury->DataSet = dbDataSet;
      report_form->txtJobInjury->DataField = "job_injury";
      report_form->txtAutoInjury->DataSet = dbDataSet;
      report_form->txtAutoInjury->DataField = "auto_injury";
      report_form->txtOtherInjury->DataSet = dbDataSet;
      report_form->txtOtherInjury->DataField = "other_injury";
      report_form->txtAccidentDate->DataSet = dbDataSet;
      report_form->txtAccidentDate->DataField = "injury_date";
      report_form->txtAccidentState->DataSet = dbDataSet;
      report_form->txtAccidentState->DataField = "injury_state";
      report_form->txtDentistSignature->DataSet = dbDataSet;
      report_form->txtDentistSignature->DataField = "dentist_name";
      report_form->txtDentistNPI->DataSet = dbDataSet;
      report_form->txtDentistNPI->DataField = "dentist_npi";
      report_form->txtDentistLicense->DataSet = dbDataSet;
      report_form->txtDentistLicense->DataField = "dentist_license";
      report_form->txtDentistCode->DataSet = dbDataSet;
      report_form->txtDentistCode->DataField = "dentist_code";
      report_form->txtDentistPhone->DataSet = dbDataSet;
      report_form->txtDentistPhone->DataField = "dentist_phone";

      AnsiString today = CurrentDate().c_str();
      report_form->lblSignedReleaseOfInfo->Caption = today;
      report_form->lblSignedAssignmentOfBenefits->Caption = today;
      report_form->lblDentistSigned->Caption = today;
      report_form->lblClinicNPI->Caption = entities["clinic_npi"].c_str();
      report_form->lblClinicLicense->Caption = entities["clinic_license"].c_str();
      report_form->lblClinicTIN->Caption = entities["clinic_tin"].c_str();
      report_form->lblClinicPhone->Caption = ReplaceStringWithString(ReplaceStringWithString(ReplaceStringWithString(FormatPhoneNumber(entities["clinic_phone"]), "(", ""), ")", "    "), "-", "      ").c_str();
//      report_form->lblDentistSignature->Caption = entities["dentist_name"].c_str();
//      report_form->lblDentistNPI->Caption = entities["dentist_npi"].c_str();
//      report_form->lblDentistLicense->Caption = entities["dentist_license"].c_str();
//      report_form->lblDentistCode->Caption = entities["dentist_code"].c_str();
//      report_form->lblDentistPhone->Caption = ReplaceStringWithString(ReplaceStringWithString(ReplaceStringWithString(FormatPhoneNumber(entities["dentist_phone"]), "(", ""), ")", "    "), "-", "      ").c_str();

      ++reportstage; // 11
      report_form->Processing(false);
      LogIt("ada_claim.log", "previewing report");
      report_form->ADA_report->Preview();

      LogIt("ada_claim.log", "shutting down");
    } // end all_is_well

    reportstage = 12;
    dbDataSet->Close();

    ++reportstage; // 13
    ExecuteStatement(dbTransaction, "delete from temp_relationships_view");
    dbTransaction->Commit();
  } // end try
  catch(...)
  {
    // jhaley 20101214: A very non-descript error is occasionally occuring somewhere above. Hopefully this will help narrow it down...
    string message = "Error printing claim form - reached stage #" + IntToString(reportstage);
    LogIt("ada_claim.log", message.c_str());
    if (report_form)
      report_form->Processing(false);
    if (dbTransaction->Active)
      dbTransaction->Rollback();
    ::PSay(message.c_str(), m_database_error, MB_OK, "reportDentalBillingForm::DoADA");
  }
  delete dbDataSet;
  delete dbTransaction;
  LogIt("ada_claim.log", "done");
  report_form->Processing(false); // just in case
}
//---------------------------------------------------------------------------
void __fastcall TformReportDentalBillingForm::txtDentistPhonePrint(TObject *sender, AnsiString &Value)
{
  Value = ReplaceStringWithString(ReplaceStringWithString(ReplaceStringWithString(FormatPhoneNumber(Value.c_str()), "(", ""), ")", "    "), "-", "      ").c_str();
}
//---------------------------------------------------------------------------

