//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reportDiabAppointmentLetter.h"
#include "reportMailingLabels.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformReportDiabAppointmentLetter *formReportDiabAppointmentLetter;
//---------------------------------------------------------------------------
__fastcall TformReportDiabAppointmentLetter::TformReportDiabAppointmentLetter(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabAppointmentLetter::txtPersonPrint(TObject *sender, AnsiString &Value)
{
  Value = PrettyString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabAppointmentLetter::txtTimePrint(TObject *sender, AnsiString &Value)
{
  Ptime temp_time(Value.c_str(), military | withsec);
  Value = temp_time.OutTime(ampm | withoutsec).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabAppointmentLetter::txtDurationPrint(TObject *sender, AnsiString &Value)
{
  string temp = Value.c_str();
  int first_space = temp.find_first_of(" ");
  if((first_space > 0) && (temp.length() > 2))
  {
    if((first_space == 1) && (temp[0] == '1'))
    {
      temp = temp.substr(0, temp.length() - 1);
    }
  }
  Value = PrettyString(temp).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabAppointmentLetter::txtGreetingPrint(TObject *sender, AnsiString &Value)
{
  string temp = Value.c_str();
  if(temp == lookupTables->IdOf("gender_types", "Male"))
    Value = "Dear Sir: ";
  else if(temp == lookupTables->IdOf("gender_types", "Female"))
    Value = "Dear Madam: ";
  else
    Value = "Dear Sir or Madam: ";
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabAppointmentLetter::reportAfterPreview(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabAppointmentLetter::txtDes(TObject *sender, AnsiString &Value)
{
  Value = ReplaceStringWithString(SentenceString(Value.c_str()), "\n", "  ").c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabAppointmentLetter::txtLocationPrint(TObject *sender, AnsiString &Value)
{
  Value = ReplaceStringWithString(PrettyString(Value.c_str()), "\n", "  ").c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabAppointmentLetter::txtAddressPrint(TObject *sender, AnsiString &Value)
{
  Value = FormatAddress(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabAppointmentLetter::lblDepartmentPrint(TObject *sender, AnsiString &Value)
{
  //if (Value == UpperCase(Value)) // then it's not yet prettified
  //  Value = ReplaceStringWithString(PrettyString(Value.c_str()), "Ast", "AST").c_str(); // Yeah, AST thing is a hack.  Sue me.
}
//---------------------------------------------------------------------------
void TformReportDiabAppointmentLetter::Do(vector<string> appointment_ids, string group_id, bool order_by_name,
                                          bool print_mailing_labels, int starting_label)
{
  string group_name = lookupTables->ValueOf("groups", group_id);
  TIBTransaction *dbLetterTransaction = new TIBTransaction(NULL);
  TIBDataSet *dbLetterDataset = new TIBDataSet(NULL);
  string sql;
  string temp = "";
  vector<string> employee_vec;
  map<string, string> dept_info;
  TformReportDiabAppointmentLetter *report_form = NULL;
  TformReportMailingLabels *label_form = NULL;
  
  try
  {
    FORM_TRY
      report_form = new TformReportDiabAppointmentLetter(NULL);
    FORM_CATCH
    dbLetterTransaction->DefaultDatabase = dbDatabase;
    dbLetterDataset->Database = dbDatabase;
    dbLetterDataset->Transaction = dbLetterTransaction;
    dbLetterDataset->UniDirectional = false;
    dbLetterTransaction->StartTransaction();

    sql = "select coalesce(users.item, '') || ' - ' || coalesce(users.title, '') employee "
          "from users where users.valid = 1 and "
          "users.group_id = '" + group_id + "' "
          "order by users.i_level desc, users.item";
    DebugSql(NULL, &sql, other_forms, 9, dbLetterTransaction);
    SqlToVec(dbLetterTransaction, sql, employee_vec);
    for(vector<string>::iterator itr = employee_vec.begin(); itr != employee_vec.end(); itr++)
       report_form->memoEmployees->Lines->Add((*itr).c_str());

    sql = "select tax_entities.name, "
          "coalesce(groups.phone_number, tax_addresses.phone_number) phn_no, " // jhaley - allow group-specific Phone #
          "coalesce(groups.fax_number, tax_addresses.fax_number) fax_no, "     //        - and fax # as well
          "coalesce(tax_addresses.line1, '') || ' ' || coalesce(tax_addresses.line2, '') address, "
          "tax_addresses.city, "
          "state_types.abbreviation state, "
          "tax_addresses.zip "
          "from groups "
          "left join tax_entities on groups.facility_id = tax_entities.id "
          "left join tax_addresses on tax_addresses.id = "
          "  case when tax_entities.physical_address_id > 0 then "
          "    tax_entities.physical_address_id "
          "  else "
          "    tax_entities.billing_address_id "
          "  end "
          "left join state_types on tax_addresses.state_id = state_types.id "
          "where groups.id = '" + group_id + "' ";
    DebugSql(NULL, &sql, other_forms, 9, dbLetterTransaction);
    SqlToMap(dbLetterTransaction, sql, dept_info);
    //::PSay(MapToDelimString(dept_info, "{", "}", "", "'", "'", "'", "'", ","), m_debug, MB_OK, "reportDiabAppointmentLetter::Do");

    report_form->lblDepartment->Caption =
      ReplaceStringWithString(ReplaceStringWithString(dept_info["name"], "Absentee Shawnee Tribe", "AST"), "Absentee Shawnee ", "").c_str();

    report_form->bandNotes->Enabled = false;
    string contact = "If you cannot keep this appointment please call the ";
    if (group_name == "Diabetes")
    {
     contact += "Diabetes & Wellness Program";
     report_form->lblStaff->Caption = "Diabetes & Wellness Staff";
     report_form->memoEmployees->Enabled = false; // jhaley 20110718 - disabled at Tara's request.
    }
    else if (group_name == "Little Axe Clinic" || group_name == "Shawnee Clinic")
    {
     contact += "Clinic";
     report_form->lblStaff->Caption = "The Clinic Staff";
     report_form->memoNotes->Lines->Add("Please note the service for which you are scheduled, above.  This is the only "
                                        "service that will be provided during this visit.  Any other service must be "
                                        "scheduled in advance.");
     report_form->bandNotes->Enabled = true;
     report_form->memoEmployees->Enabled = false;
    }
    else if (group_name == "Dental Clinic")
    {
     contact += "Dental Clinic";
     report_form->lblStaff->Caption = "The Dental Clinic Staff";
     report_form->memoEmployees->Enabled = false;
    }
    else
    {
     contact += group_name;
     report_form->lblStaff->Caption = ("The " + group_name + " Staff").c_str();
    }
    contact += " at ";
    contact += FormatPhoneNumberNoBreak(dept_info["phn_no"]) + "."; // jhaley: Use non-breaking formatting here.
    report_form->lblContact->Caption = contact.c_str();

    report_form->txtAstInfo->Lines->Clear();
    report_form->txtAstInfo->Lines->Add(FormatAddress(dept_info["address"]).c_str());
    report_form->txtAstInfo->Lines->Add((PrettyString(dept_info["city"]) + ", " + UppercaseString(dept_info["state"]) + "  " + dept_info["zip"]).c_str());
    report_form->txtAstInfo->Lines->Add((FormatPhoneNumber(dept_info["phn_no"]) + " phone").c_str());
    report_form->txtAstInfo->Lines->Add((FormatPhoneNumber(dept_info["fax_no"]) + " fax").c_str());

    sql  = "select "
           "coalesce(first_name, '') || "  // TODO -c CLEANUP: jhaley - this can be done in a manner much simpler
           " (case when middle_name != '' then ' ' else '' end) || coalesce(middle_name, '') || "
           " (case when last_name   != '' then ' ' else '' end) || coalesce(last_name,   '') || "
           " (case when suffix      != '' then ' ' else '' end) || coalesce(suffix,      '') full_name, "
           "case when mailing_info.id is not null "
           " then coalesce(mailing_info.line1, '') "
           " else coalesce(home_info.line1, '') "
           "end line1, "
           "case when mailing_info.id is not null "
           " then coalesce(mailing_info.line2, '') "
           " else coalesce(home_info.line2, '') "
           "end line2, "
           "case when mailing_info.id is not null "
           " then coalesce(mailing_info.city, '') || ', ' || coalesce(mailing_state.abbreviation, '') || '  ' || coalesce(mailing_info.zip, '') "
           " else coalesce(home_info.city, '') || ', ' || coalesce(home_state.abbreviation, '') || '  ' || coalesce(home_info.zip, '') "
           "end city, "
           "o_person.gender_id, "
           "appointments.appointment_date, "
           "appointments.appointment_time, "
           "cast(appointments.duration as int) || ' ' || duration_types.item duration, "
           "appointments.description, "
           "case when appt_location_types.item != '' then appt_location_types.item else '<unknown>' end location, "
           "appt_reason_types.item reason "
           "from appointments "
           "inner join duration_types on appointments.duration_id = duration_types.id "
           "inner join people o_person on appointments.person_id = o_person.id and o_person.id > 0 " // jhaley 20110706: Not person 0!
           "inner join person_names on o_person.person_names_id = person_names.id "
           "left join person_contact_info mailing_info on mailing_info.id = (select first 1 id "
           " from person_contact_info i_address where i_address.person_id = o_person.id and "
           " i_address.current_id+1 >= 4 and i_address.contact_info_id = " + lookupTables->IdOf("contact_info_types", "Mail") +
           " and i_address.line1 is not null order by last_update_stamp desc nulls last) "
           "left join state_types mailing_state on mailing_info.state_id = mailing_state.id "
           "left join person_contact_info home_info on home_info.id = (select first 1 id from "
           " person_contact_info i_address where i_address.person_id = o_person.id and i_address.current_id+1 >= 4 and "
           " i_address.contact_info_id = " + lookupTables->IdOf("contact_info_types", "Home") +
           " and i_address.line1 is not null order by last_update_stamp desc nulls last) "
           "left join state_types home_state on home_info.state_id = home_state.id "
           "left join appt_reason_types on appointments.appt_reason_id = appt_reason_types.id "
           "left join appt_location_types on appointments.appt_location_id = appt_location_types.id ";

    sql += "where " + SafeInClause("appointments.id", appointment_ids);
    if (order_by_name)
     sql += "order by last_name, first_name, middle_name, birth_date ";
    else
     sql += "order by appointment_date, appointment_time ";
    DebugSql(NULL, &sql, other_forms, 9, dbLetterTransaction);
    dbLetterDataset->SelectSQL->Add(sql.c_str());
    dbLetterDataset->Open();

    report_form->report->DataSet = dbLetterDataset;
    report_form->txtPerson->DataSet = dbLetterDataset;
    report_form->txtPerson->DataField = "full_name";
    report_form->txtLine1->Enabled = false;
    report_form->exprLine1->Expression = "line1 + ' ' + line2";
    report_form->txtLine2->DataSet = dbLetterDataset;
    report_form->txtLine2->DataField = "city";
    report_form->txtGreeting->DataSet = dbLetterDataset;
    report_form->txtGreeting->DataField = "gender_id";
    report_form->txtReason->DataSet = dbLetterDataset;
    report_form->txtReason->DataField = "reason";
    report_form->txtDate->DataSet = dbLetterDataset;
    report_form->txtDate->DataField = "appointment_date";
    report_form->txtTime->DataSet = dbLetterDataset;
    report_form->txtTime->DataField = "appointment_time";
    report_form->txtDuration->DataSet = dbLetterDataset;
    report_form->txtDuration->DataField = "duration";
    report_form->txtLocation->DataSet = dbLetterDataset;
    report_form->txtLocation->DataField = "location";

    report_form->Processing(false);
    report_form->report->Preview();

    dbLetterDataset->First();

    FORM_TRY
      label_form = new TformReportMailingLabels(NULL, IntToString(starting_label - 1));
    FORM_CATCH
    label_form->labelReport->DataSet = dbLetterDataset;
    label_form->txtName->DataSet = dbLetterDataset;
    label_form->txtName->DataField = "full_name";
    label_form->txtAddress1->DataSet = dbLetterDataset;
    label_form->txtAddress1->DataField = "line1";
    label_form->Processing(false);
    label_form->labelReport->Preview();

    dbLetterDataset->Close();
    dbLetterTransaction->Commit();
  }
  catch(...)
  {
    if (report_form) report_form->Processing(false);
    if (label_form)  label_form->Processing(false);
    if (dbLetterTransaction->Active)
      dbLetterTransaction->Rollback();
    ::PSay("Error printing letter", m_database_error, MB_OK, "reportDiabAppointmentLetter::Do");
  }
  delete dbLetterDataset;
  delete dbLetterTransaction;
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabAppointmentLetter::lblHeaderPrint(TObject *sender, AnsiString &Value)
{
  // Since NULL makes QuickReport not fire the Print events, and since we don't print the ACTUAL field
  // value receive ANYWAY, it makes a lot more sense for this to be a Label than a Text field.  And
  // this-a-way it always has a value, always prints, always shows up, yeah?  Good.
  // DONE: check the appt_reason_id to determine if this is a STAR appointment

  string temp = report->DataSet->FieldByName("reason")->AsString.c_str();
  if(temp.find("SESSION") != string::npos)
    temp = "Your Diabetes Education Session has been scheduled for the following date and time:";
  else
    temp = "Your appointment has been scheduled for the following date and time:";
  Value = temp.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabAppointmentLetter::bandReasonBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
  if (report->DataSet->FieldByName("reason")->AsString == "" ||
      report->DataSet->FieldByName("reason")->AsString == "<unknown>")
  {
    PrintBand = false;
    bandReason->Height = 0;
  }
  else
    bandReason->Height = 56;
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabAppointmentLetter::bandLocationBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
  if (report->DataSet->FieldByName("location")->AsString == "" ||
      report->DataSet->FieldByName("location")->AsString == "<unknown>")
  {
    PrintBand = false;
    bandLocation->Height = 0;
  }
  else
    bandLocation->Height = 56;
}
//---------------------------------------------------------------------------

