//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reportDiabMeasureSummary.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformReportDiabMeasureSummary *formReportDiabMeasureSummary;
//---------------------------------------------------------------------------
__fastcall TformReportDiabMeasureSummary::TformReportDiabMeasureSummary(TComponent* Owner, set<string> & to_exclude)
        : TformSpecialGeneric(Owner)
{
 shown_row_count = 0;
 person_id_to_exclude = to_exclude;
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabMeasureSummary::txtNamePrint(TObject *sender, AnsiString &Value)
{
  Value = PrettyString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabMeasureSummary::measureReportAfterPreview(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabMeasureSummary::detailBandAfterPrint(
      TQRCustomBand *Sender, bool BandPrinted)
{
 // If you try to access the field and the dataset is empty you'll get an EVariantError and diabetes
 // will complain that the report doesn't run (when it should just produce a blank report).
 if (!measureReport->DataSet->IsEmpty())
  if (person_id_to_exclude.find(measureReport->DataSet->FieldByName("person_id")->AsString.c_str()) == person_id_to_exclude.end())
  {
   unique_people.insert(StringToInt(AnsiString(measureReport->DataSet->FieldValues["person_id"]).c_str()));
   shown_row_count++;
  }
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabMeasureSummary::measureReportBeforePrint(
      TCustomQuickRep *Sender, bool &PrintReport)
{
   unique_people.clear();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabMeasureSummary::lblUniquePeoplePrint(
      TObject *sender, AnsiString &Value)
{
   Value = IntToString(unique_people.size()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabMeasureSummary::detailBandBeforePrint(
      TQRCustomBand *Sender, bool &PrintBand)
{
 if (!measureReport->DataSet->IsEmpty())
 {
  if (person_id_to_exclude.find(measureReport->DataSet->FieldByName("person_id")->AsString.c_str()) != person_id_to_exclude.end())
   PrintBand = false;
  else
   PrintBand = true;
 }
}
//---------------------------------------------------------------------------

void __fastcall TformReportDiabMeasureSummary::lblShownMeasPrint(
      TObject *sender, AnsiString &Value)
{
   Value = IntToString(shown_row_count).c_str();
}
//---------------------------------------------------------------------------

