//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reportDiabStarSession.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformReportDiabStarSession *formReportDiabStarSession;
//---------------------------------------------------------------------------
__fastcall TformReportDiabStarSession::TformReportDiabStarSession(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabStarSession::txtNamePrint(TObject *sender, AnsiString &Value)
{
  Value = PrettyString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabStarSession::txtTribePrint(TObject *sender, AnsiString &Value)
{
  Value = PrettyString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabStarSession::txtOutcomePrint(TObject *sender, AnsiString &Value)
{
  Value = PrettyString(Value.c_str()).c_str();
  outcome_totals[Value.c_str()]++;
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabStarSession::txtPhonePrint(TObject *sender, AnsiString &Value)
{
  Value = FormatPhoneNumber(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabStarSession::detailBandAfterPrint(TQRCustomBand *Sender, bool BandPrinted)
{
  // If you try to access the field and the dataset is empty you'll get an EVariantError and diabetes
  // will complain that the report doesn't run (when it should just produce a blank report).
  if (!report->DataSet->IsEmpty())
  {
    unique_people.insert(StringToInt(AnsiString(report->DataSet->FieldValues["person_id"]).c_str()));
  }
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabStarSession::reportBeforePrint(TCustomQuickRep *Sender, bool &PrintReport)
{
  unique_people.clear();
  outcome_totals.clear();
  memoOutcomeTypes->Lines->Clear();
  memoOutcomes->Lines->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabStarSession::lblUniquePeoplePrint(TObject *sender, AnsiString &Value)
{
  Value = IntToString(unique_people.size()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabStarSession::summaryBandBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
  for(map<string, int>::iterator itr = outcome_totals.begin(); itr != outcome_totals.end(); itr++)
  {
    memoOutcomeTypes->Lines->Add(itr->first.c_str());
    memoOutcomes->Lines->Add(IntToString(itr->second).c_str());
  }
}
//---------------------------------------------------------------------------
void __fastcall TformReportDiabStarSession::reportAfterPreview(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
