//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reportIntakeForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformIntakeReport *formIntakeReport;
//---------------------------------------------------------------------------
__fastcall TformIntakeReport::TformIntakeReport(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
 // 32 between the top of a label or text field and its corresponding correction line
 // 16 between a correction line and the top property of the next label
 // 24 between the top of a label or text field and the top of its corresponding lable 
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::qrpInsPolicyHolderPrint(TObject *sender, AnsiString &Value)
{
 Value = PrettyString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::qrpInsPhonePrint(TObject *sender, AnsiString &Value)
{
 Value = FormatPhoneNumber(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
//  insuranceInfo->NewPage();
void __fastcall TformIntakeReport::intakeReport1AfterPreview(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::intakeReport2AfterPreview(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::intakeReport3AfterPreview(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::intakeReport4AfterPreview(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::intakeReport5AfterPreview(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::medicalConsentAfterPreview(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::intakeReport6AfterPreview(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::DetailBand4BeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
 // get to setup checkboxes, yay!
 // also ... hide controls that have no text?

 TDataSet * d = intakeReport4->DataSet;

 is_ppo->Enabled = (d->FieldByName("insurance_type")->AsString == "PPO");
 is_hmo->Enabled = (d->FieldByName("insurance_type")->AsString == "HMO");

 is_single->Enabled = (d->FieldByName("coverage_type")->AsString == "SINGLE");
 is_family->Enabled = (d->FieldByName("coverage_type")->AsString == "FAMILY");

 is_employer->Enabled = (d->FieldByName("source_type")->AsString == "EMPLOYER");
 is_group->Enabled    = (d->FieldByName("source_type")->AsString == "GROUP");
 is_nongroup->Enabled = (d->FieldByName("source_type")->AsString == "NON-GROUP");

 // don't want to deal with the potential NULL vs. 0 issue. this seemed safer. greater than 1? sure hope not. that'd suck.
 is_medical->Enabled      = (d->FieldByName("is_medical")->AsString == "1");
 is_dental->Enabled       = (d->FieldByName("is_dental")->AsString == "1");
 is_vision->Enabled       = (d->FieldByName("is_vision")->AsString == "1");
 is_prescription->Enabled = (d->FieldByName("is_rx")->AsString == "1");

 is_self->Enabled      = (d->FieldByName("relationship_type")->AsString == "SELF");
 is_spouse->Enabled    = (d->FieldByName("relationship_type")->AsString == "HUSBAND") ||
                         (d->FieldByName("relationship_type")->AsString == "WIFE");
 is_parent->Enabled    = (d->FieldByName("relationship_type")->AsString == "MOTHER") ||
                         (d->FieldByName("relationship_type")->AsString == "FATHER");
 is_other_rel->Enabled = (d->FieldByName("relationship_type")->AsString != "") &&
                         !(is_self->Enabled) && !(is_spouse->Enabled) && !(is_parent->Enabled);

 shapeRelOther->Enabled        = (d->FieldByName("relationship_type")->AsString == "");
 shapeInsCo->Enabled           = (d->FieldByName("name")->AsString == "");
 shapeInsPhone->Enabled        = (d->FieldByName("phone_number")->AsString == "");
 shapeInsGroup->Enabled        = (d->FieldByName("group_number")->AsString == "");
 shapeInsPolicy->Enabled       = (d->FieldByName("policy_number")->AsString == "");
 shapeInsBIN->Enabled          = (d->FieldByName("bin_number")->AsString == "");
 shapeInsPCN->Enabled          = (d->FieldByName("processor_control_number")->AsString == "");
 shapeInsPC->Enabled           = (d->FieldByName("person_code")->AsString == "");
 shapeInsStart->Enabled        = (d->FieldByName("start_date")->AsString == "");
 shapeInsEnd->Enabled          = (d->FieldByName("stop_date")->AsString == "");

 shapeInsPolicyHolder->Enabled = (d->FieldByName("name_on_policy")->AsString == "");
 shapeInsDoctor->Enabled       = (StripTrailing(d->FieldByName("doctor")->AsString.c_str(), " ") == "");
 // shapeInsDoctorNum->Enabled = (d->FieldByName("pcp_ins_num")->AsString == "");

 string line1 = d->FieldByName("holder_line1")->AsString.c_str();
 string line2 = d->FieldByName("holder_line2")->AsString.c_str();
 string city  = PrettyString(d->FieldByName("holder_city")->AsString.c_str());
 string state = d->FieldByName("holder_state")->AsString.c_str();
 string zip   = FormatZipCode(d->FieldByName("holder_zip")->AsString.c_str());

 string addressa = FormatAddress(line1 + (line1 != "" && line2 != "" ? ", " : "") + line2);
 string addressb = city + (city != "" ? ", " : "")
                 + state + (zip != "" ? " " : "")
                 + zip;
 string address = addressa + (addressa != "" && addressb != "" ? ", " : "") + addressb;

 qrpInsPolicyHolderAddress->Caption   = address.c_str();
 shapeInsPolicyHolderAddress->Enabled = (qrpInsPolicyHolderAddress->Caption == "");
 shapeInsPolicyHolderGender->Enabled  = (d->FieldByName("holder_gender")->AsString == "");
 shapeInsPolicyHolderDOB->Enabled     = (d->FieldByName("holder_dob")->AsString == "");
 shapeInsPolicyHolderSSN->Enabled     = (d->FieldByName("holder_ssn")->AsString == "");
 shapeInsPolicyHolderPhone->Enabled   = (d->FieldByName("holder_phone")->AsString == "");
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::PageHeaderBand1BeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
 shapeLastConsentDate->Enabled  = (qrpLastConsentDate->Caption == "");
 shapeNames->Enabled  = (qrpNames->Caption == "");
 shapeGender->Enabled = (qrpGender->Caption == "");
 shapeDOB->Enabled    = (qrpDOB->Caption == "");
 shapeCDIB->Enabled   = (qrpCDIB->Caption == "");
 shapeTribe->Enabled  = (qrpTribe->Caption == "");
 shapeSSN->Enabled    = (qrpSSN->Caption == "");
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::qrpAddressPhonePrint(TObject *sender, AnsiString &Value)
{
 Value = FormatPhoneNumber(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::qrpRelNamePrint(TObject *sender, AnsiString &Value)
{
 Value = StripLeading(StripTrailing(PrettyString(Value.c_str()), " "), " ").c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::qrpRelPhonePrint(TObject *sender, AnsiString &Value)
{
 Value = FormatPhoneNumber(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
// ADDRESSES
void __fastcall TformIntakeReport::DetailBand2BeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
 TDataSet * d = intakeReport2->DataSet;

 string line1 = d->FieldByName("line1")->AsString.c_str();
 string line2 = d->FieldByName("line2")->AsString.c_str();
 string city  = PrettyString(d->FieldByName("city")->AsString.c_str());
 string state = PrettyString(d->FieldByName("state")->AsString.c_str()); // note: for insurance, we use ABBREVIATION to save space, but not here?
 string zip   = FormatZipCode(d->FieldByName("zip")->AsString.c_str());

 string address_a = FormatAddress(line1 + (line1 != "" && line2 != "" ? ", " : "") + line2);
 string address_b = city + (city != "" ? ", " : "")
                  + state + (zip != "" ? " " : "")
                  + zip;

 string t = d->FieldByName("addr_type")->AsString.c_str();
 if (!t.empty())
  labelAddressType->Caption = ("Address (" + PrettyString(t) + "):").c_str();

 qrpAddressA->Caption = address_a.c_str();
 qrpAddressB->Caption = address_b.c_str();

// qrpAddressA->Caption = d->FieldByName("line1")->AsString + (d->FieldByName("line1")->AsString != "" && d->FieldByName("line2")->AsString != "" ? ", " : "") + d->FieldByName("line2")->AsString;
// qrpAddressB->Caption = d->FieldByName("city")->AsString + (d->FieldByName("city")->AsString != "" ? ", " : "") + d->FieldByName("state")->AsString + string((FormatZipCode(d->FieldByName("zip")->AsString.c_str()) != "" ? " " : "") + FormatZipCode(d->FieldByName("zip")->AsString.c_str())).c_str() + (d->FieldByName("country")->AsString != "" ? (" (" + d->FieldByName("country")->AsString + ")") : AnsiString(""));

 shapeAddressA->Enabled     = (qrpAddressA->Caption == "");
 shapeAddressB->Enabled     = (qrpAddressB->Caption == "");
 shapeAddressPhone->Enabled = (d->FieldByName("phone_number")->AsString == "");

 // jhaley 20100930: trust lands checkboxes
 if (line1 == "" && line2 == "" && city == "" && state == "" && zip == "")
 {
   yes_trustland->Enabled = false;
   no_trustland->Enabled = false;
 }
 else
 {
   yes_trustland->Enabled = (d->FieldByName("trust_lands")->AsString == "1");
   no_trustland->Enabled = !yes_trustland->Enabled;
 }
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::DetailBand3BeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
 TDataSet * d = intakeReport3->DataSet;

 qrpRelType->Caption = SentenceString(
                       AnsiString(d->FieldByName("relationship_type")->AsString +
                       AnsiString(d->FieldByName("is_emergency")->AsString == "1" ? ", emergency contact" : "") +
                       AnsiString(d->FieldByName("is_responsible")->AsString == "1" ? ", responsible party" : "") +
                       AnsiString(d->FieldByName("is_banned")->AsString == "1" ? ", restricted from info" : "")).c_str()).c_str();

 shapeRelType->Enabled  = (qrpRelType->Caption == "");
 shapeRelName->Enabled  = (d->FieldByName("name")->AsString == "");
 shapeRelPhone->Enabled = (StripTrailing(d->FieldByName("phone_number")->AsString.c_str(), " ") == "");
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::QRBand4BeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
 TDataSet * d = intakeReport6->DataSet;

 shapeVetDate->Enabled  = (d->FieldByName("vet_date")->AsString == "");
 shapeMedicareNum->Enabled  = (d->FieldByName("medicare_number")->AsString == "");
 shapeMedicaidNum->Enabled  = (d->FieldByName("medicaid_number")->AsString == "");

 yes_vet->Enabled = (d->FieldByName("has_vet")->AsString == "1");
 no_vet->Enabled = !yes_vet->Enabled;

 yes_med_a->Enabled = (d->FieldByName("has_medicare_a")->AsString == "1");
 // no_med_a->Enabled = !yes_med_a->Enabled;

 yes_med_b->Enabled = (d->FieldByName("has_medicare_b")->AsString == "1");
 // no_med_b->Enabled = !yes_med_b->Enabled;

 yes_med_d->Enabled = (d->FieldByName("has_medicare_d")->AsString == "1");
 // no_med_d->Enabled = !yes_med_d->Enabled;

 yes_med_adv->Enabled = (d->FieldByName("has_medicare_adv")->AsString == "1"); // jhaley 20110715

 yes_med->Enabled = (d->FieldByName("has_medicaid")->AsString == "1");
 no_med->Enabled = !yes_med->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::qrpSSNPrint(TObject *sender,AnsiString &Value)
{
 Value =  PrettySSN(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::qrpInsPolicyHolderGenderPrint(TObject *sender, AnsiString &Value)
{
 Value = PrettyString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::qrpInsPolicyHolderSSNPrint(TObject *sender, AnsiString &Value)
{
 Value = PrettySSN(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::qrpInsPolicyHolderPhonePrint(TObject *sender, AnsiString &Value)
{
 Value = FormatPhoneNumber(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::qrpRelTypePrint(TObject *sender, AnsiString &Value)
{
  // we don't like strings that start with a comma.  sloppy.
  string v = Value.c_str();
  if (LikeString(", %", v))
  {
    v = v.substr(2);
    v = UppercaseString(v.substr(0, 1)) + v.substr(1);
  }
  Value = v.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformIntakeReport::qrpRelOtherPrint(TObject *sender, AnsiString &Value)
{
  Value = LowercaseString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------

