//---------------------------------------------------------------------------
// when using this form, you must alias the second line of the address as line2
// in your sql statement and the city/state/zip line as city
// you don't need to assign those fields to a text object, but they -must-
// be selected so this form can properly place the optional second address
// line properly

#include <vcl.h>
#pragma hdrstop

#include "reportMailingLabels.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformReportMailingLabels *formReportMailingLabels;
//---------------------------------------------------------------------------
__fastcall TformReportMailingLabels::TformReportMailingLabels(TComponent* Owner, string p_num_of_blanks)
        : TformSpecialGeneric(Owner)
{
  // there's a reason we didn't pass this as an integer.  Somewhere there's already a constructor that takes
  // a TComponent* followed by an int, and it thinks we're calling that ... which causes a stack overflow in
  // SpecialGeneric's constructor.  It's deja vu all over again.
  num_of_blanks = StringToInt(p_num_of_blanks);
  if (num_of_blanks < 0) num_of_blanks = 0;
  print_raw_names = false;
}
//---------------------------------------------------------------------------
void __fastcall TformReportMailingLabels::labelReportBeforePrint(TCustomQuickRep *Sender, bool &PrintReport)
{
  label_number = 1;
  is_priming_pump = false;
  is_shooting_blanks = false;
}
//---------------------------------------------------------------------------
void __fastcall TformReportMailingLabels::labelReportAfterPreview(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformReportMailingLabels::infoBandBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
  is_shooting_blanks = label_number <= num_of_blanks;

  if (is_priming_pump || is_shooting_blanks)
    labelReport->DataSet->Prior(); // jhaley: NB - totally useless; does not work.
  else
  {
    string address2 = txtName->DataSet->Fields->FieldByName("line2")->AsString.c_str();
    string city = txtName->DataSet->Fields->FieldByName("city")->AsString.c_str();
    if(address2 == "")
    {
      lblAddress2->Caption = PrettyString(city).c_str();
      lblCity->Caption = "";
    }
    else
    {
      lblAddress2->Caption = FormatAddress(address2).c_str();
      lblCity->Caption = PrettyString(city).c_str();
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TformReportMailingLabels::infoBandAfterPrint(TQRCustomBand *Sender, bool BandPrinted)
{
  if (!(labelReport->DataSet->Bof))
    if (!is_shooting_blanks)
      is_priming_pump = false;
  else
    if (num_of_blanks > 0)
      is_priming_pump = true;

  label_number++;
}
//---------------------------------------------------------------------------
void __fastcall TformReportMailingLabels::txtNamePrint(TObject *sender, AnsiString &Value)
{
  if (is_shooting_blanks)
    Value = "";
  else if (!print_raw_names)
    Value = PrettyString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportMailingLabels::txtAddress1Print(TObject *sender, AnsiString &Value)
{
  if (is_shooting_blanks)
    Value = "";
  else
    Value = FormatAddress(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportMailingLabels::otherPrint(TObject *sender, AnsiString &Value)
{
  if (is_shooting_blanks)
    Value = "";
}
//---------------------------------------------------------------------------

