//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reportObsQuestionSet.h"
#include "metric_conversion.h"
#include "derivedheaders.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformSpecialObsQuestionSetReport *formSpecialObsQuestionSetReport;
//---------------------------------------------------------------------------
__fastcall TformSpecialObsQuestionSetReport::TformSpecialObsQuestionSetReport(TComponent* Owner, TIBTransaction* pdbTransaction, bool psemi_filled)
        : TformSpecialGeneric(Owner)
{
 dbTransaction = pdbTransaction;
 semi_filled = psemi_filled;
}
//---------------------------------------------------------------------------
void __fastcall TformSpecialObsQuestionSetReport::bandDetailBeforePrint(
      TQRCustomBand *Sender, bool &PrintBand)
{
 // Setup crap.
 TDataSet * z = reportObsQuestionSet->DataSet;
 unsigned int obs_question_type_id = StringToInt(z->FieldByName("obs_question_type_id")->AsString.c_str());
 bool no_response = (z->FieldByName("id")->AsString == "");
 bool no_response_set = (z->FieldByName("obs_response_set_id")->AsString == "");
 bool no_range = (z->FieldByName("obs_expected_range_id")->AsString == "");

 // TODO: shouldn't this be an option?
 // HACK: overrides the above/following code, to show blanks for data-entry on questions that -could- have been answered but weren't. just in case.
 if (semi_filled)
  no_response_set = no_response;

 // decide later if this is a good idea or not (the use of labels where text/expressions could work)
 labelQuestion->Caption  = /* z->FieldByName("short_item")->AsString + ": " + */ z->FieldByName("long_item")->AsString + (IsBlankOrZero(z->FieldByName("is_calculated")->AsString.c_str()) ? "" : " (calculated)");
 labelNumeric->Caption        = "";
 labelUnit->Caption           = "";
 labelReferenceRange->Caption = "";
 labelStatus->Caption         = "";
 memoText->Lines->Clear();
 memoText->Frame->DrawBottom = false;
 labelNumeric->Frame->DrawBottom = false;

 // make sure only the correct fields are visible. they're opaque, so this should work.
 // if no id, underline text, present list of choices with checkboxes, show true/false for circling, underline range value
 switch (obs_question_type_id)
 {
  case 1: // CHOICE
  case 3: // ORDINAL
   memoText->BringToFront();
   if (!no_range && obs_question_type_id == 3) // don't try this with choice!
   {
    labelReferenceRange->Caption = (lookupTables->ValueOf("obs_option_types", z->FieldByName("min_obs_option_id")->AsString.c_str()) + " - " + lookupTables->ValueOf("obs_option_types", z->FieldByName("max_obs_option_id")->AsString.c_str())).c_str();
    if (!no_response)
    {
     int v = StringToInt(GetOneField(dbTransaction, string("select rank from obs_option_types where id = ") + z->FieldByName("obs_option_id")->AsString.c_str()));
     if (!IsBlankOrZero(z->FieldByName("min_obs_option_id")->AsString.c_str()) &&  v < StringToInt(GetOneField(dbTransaction, string("select rank from obs_option_types where id = ") + z->FieldByName("min_obs_option_id")->AsString.c_str())))
      labelStatus->Caption = "Low";
     else if (!IsBlankOrZero(z->FieldByName("max_obs_option_id")->AsString.c_str()) &&  v > StringToInt(GetOneField(dbTransaction, string("select rank from obs_option_types where id = ") + z->FieldByName("max_obs_option_id")->AsString.c_str())))
      labelStatus->Caption = "High";
     else // if (!IsBlankOrZero(z->FieldByName("min_obs_option_id")->AsString.c_str()) && !IsBlankOrZero(z->FieldByName("max_obs_option_id")->AsString.c_str()))
      labelStatus->Caption = "Normal";
    }
   }
   if (no_response_set)
   {
    memoText->Lines->Add("Check one:");
    vector<string> all_choices;
    SqlToVec(dbTransaction, ("select item from obs_option_types where valid = 1 and obs_option_set_id = " + z->FieldByName("obs_option_set_id")->AsString + " order by rank asc").c_str(), all_choices);
    for (vector<string>::iterator i = all_choices.begin(); i != all_choices.end(); i++)
     memoText->Lines->Add(("(  ) " + PrettyString(*i)).c_str());
   }
   else if (no_response)
    memoText->Lines->Add("" /*"<none>"*/);
   else
    memoText->Lines->Add(lookupTables->ValueOf("obs_option_types", z->FieldByName("obs_option_id")->AsString.c_str()).c_str());
   break;
  case 2: // TEXT
   memoText->BringToFront();
   if (no_response_set)
    memoText->Frame->DrawBottom = true;
   else if (no_response)
    memoText->Lines->Add("" /*"<none>"*/);
   else
    memoText->Lines->Add(z->FieldByName("response_text")->AsString);
   break;
  case 4: // METRIC
   memoText->SendToBack();
   if (!no_range)
   {
    labelReferenceRange->Caption = string(z->FieldByName("min_response_metric")->AsString.c_str() + string(" - ") + z->FieldByName("max_response_metric")->AsString.c_str()).c_str();
    if (!no_response)
    {
     float v = StringToFloat(z->FieldByName("response_metric")->AsString.c_str());
     if (z->FieldByName("min_response_metric")->AsString != "" &&  v < StringToFloat(z->FieldByName("min_response_metric")->AsString.c_str()))
      labelStatus->Caption = "Low";
     else if (z->FieldByName("max_response_metric")->AsString != "" &&  v > StringToFloat(z->FieldByName("max_response_metric")->AsString.c_str()))
      labelStatus->Caption = "High";
     else // if (z->FieldByName("min_response_metric")->AsString != "" && z->FieldByName("max_response_metric")->AsString != "")
      labelStatus->Caption = "Normal";
    }
   }
   labelUnit->Caption = lookupTables->ValueOf("units", z->FieldByName("question_unit_id")->AsString.c_str()).c_str();
   if (no_response_set)
    labelNumeric->Frame->DrawBottom = true;
   else if (no_response)
    labelNumeric->Caption = "" /*"<none>"*/;
   else
    labelNumeric->Caption = FinancialToString(StringToFinancial(z->FieldByName("response_metric")->AsString.c_str()), false, 2).c_str();
   break;
  case 5: // DATE
   memoText->SendToBack();
   if (no_response_set)
    labelNumeric->Frame->DrawBottom = true;
   else if (no_response)
    labelNumeric->Caption = "" /*"<none>"*/;
   else
    labelNumeric->Caption = Pdate(z->FieldByName("response_date")->AsString.c_str(), global_mode).OutDate(global_mode).c_str();
   break;
 }
}
//---------------------------------------------------------------------------
void TformSpecialObsQuestionSetReport::Run(string obs_question_set_id, string obs_response_set_id, string person_id, string gender_id, string obs_date, bool semi_filled)
{
 TIBTransaction * dbTransaction = NULL;
 TIBDataSet * dbDataSet = NULL;
 try
 {
  // make sure we get them. damn it. 'course, we don't catch anything thrown, so ... hmmm.
  // paul flipped out. i decided to be nice.
  // while (!dbTransaction)
   dbTransaction = new TIBTransaction (NULL);
  // while (!dbDataSet)
   dbDataSet = new TIBDataSet(NULL);
  StdTransaction(dbTransaction, dbDatabase);
  dbDataSet->Database = dbDatabase;
  dbDataSet->Transaction = dbTransaction;
  dbDataSet->UniDirectional = false;
  string person_name;

  if (IsBlankOrZero(gender_id) && !IsBlankOrZero(person_id))
   gender_id = GetOneField(dbTransaction, "select gender_id from people where id = " + person_id);
  if (IsBlankOrZero(obs_question_set_id) && !IsBlankOrZero(obs_response_set_id))
   obs_question_set_id = GetOneField(dbTransaction, "select obs_question_set_id from obs_response_sets where id = " + obs_response_set_id);
  if (IsBlankOrZero(obs_date) && !IsBlankOrZero(obs_response_set_id))
   obs_date = Pdate(GetOneField(dbTransaction, "select date_of_observation from obs_response_sets where id = " + obs_response_set_id), global_mode).OutDate(global_mode);
  if (!IsBlankOrZero(person_id))
   person_name = GetPersonName(dbTransaction, person_id, last_first);

  // at least try to make sure they're usable integers. won't be -good-, but ... meh.
  if (IsBlankOrZero(gender_id))
   gender_id = "0";
  if (IsBlankOrZero(obs_response_set_id))
   obs_response_set_id = "0";
  if (IsBlankOrZero(obs_question_set_id))
   obs_question_set_id = "0";

  string sql = "select "
               "obs_questions.id obs_question_id, "
               "obs_questions.obs_question_id obs_question_type_id, "
               "obs_questions.long_item, obs_questions.item, obs_questions.short_item, "
               "obs_questions.cpt_code, "
               "obs_questions.unit_id question_unit_id, "
               "obs_questions.obs_option_set_id, "
               "obs_questions_in_sets.obs_question_set_id, "
               "obs_questions.is_calculated, ";
  // responses, if any
  if (IsBlankOrZero(obs_response_set_id))
        sql += "NULL id, "
               "NULL obs_response_set_id, "
               "0 obs_option_id, "
               "NULL response_text, "
               "NULL response_metric, "
               "NULL response_date, ";
  else
        sql += "obs_responses.id, "
              + obs_response_set_id + " obs_response_set_id, "
               "obs_responses.obs_option_id, "
               "obs_responses.response_text, "
               "obs_responses.response_metric, "
               "obs_responses.response_date, ";
  // expected responses, if any
        sql += "obs_expected_ranges.min_response_metric, "
               "obs_expected_ranges.max_response_metric, "
               "obs_expected_ranges.min_obs_option_id, "
               "obs_expected_ranges.max_obs_option_id, "
               "obs_expected_ranges.id obs_expected_range_id "
  // joins ...
               "from obs_questions "
               "left join obs_expected_ranges on "
               "obs_expected_ranges.obs_question_id = obs_questions.id and ";
  if (IsBlankOrZero(gender_id))
        sql += "(obs_expected_ranges.gender_id = 0) "; // won't know what to show in these cases, don't want to show "all"
  else
        sql += "(obs_expected_ranges.gender_id = " + gender_id + " or obs_expected_ranges.gender_id = 0) ";

        sql += "left join obs_questions_in_sets on "
               "(obs_questions_in_sets.obs_question_id = obs_questions.id "
               "and obs_questions_in_sets.obs_question_set_id = " + obs_question_set_id + ") ";
  if (!IsBlankOrZero(obs_response_set_id))
        sql += string(semi_filled ? "left" : "inner") + " join obs_responses on "
               "(obs_responses.obs_question_id = obs_questions.id "
               "and obs_responses.obs_response_set_id = " + obs_response_set_id + ") "
               "where "
               "(obs_responses.obs_response_set_id is not null or obs_questions.is_calculated = 0) and "
               "(obs_responses.obs_response_set_id is not null or obs_questions_in_sets.obs_question_set_id is not null) ";
  else
        sql += "where obs_questions_in_sets.obs_question_set_id is not null and obs_questions.is_calculated = 0 "; // unknown?
        sql += "order by obs_questions_in_sets.sequence asc";

  DebugSql(NULL, &sql, other_forms, 9);

  FORM_TRY
   TformSpecialObsQuestionSetReport* r = new TformSpecialObsQuestionSetReport(NULL, dbTransaction, semi_filled);
   dbDataSet->SelectSQL->Add(sql.c_str());
   dbDataSet->Open();
   dbDataSet->First();
   r->reportObsQuestionSet->DataSet = dbDataSet;

   // r->_labelUser->Caption = PrettyString(lookupTables->ValueOf("users", current_userid)).c_str();
   r->labelTitle->Caption = ("Observation Set: " + lookupTables->ValueOf("obs_question_set_types", obs_question_set_id)).c_str();
   r->labelPersonDateOther->Caption = "";
   if (!IsBlankOrZero(person_id))
   {
    r->labelPersonDateOther->Caption = r->labelPersonDateOther->Caption + person_name.c_str(); // += doesn't work
    if (obs_date != "")
     r->labelPersonDateOther->Caption = r->labelPersonDateOther->Caption + (" on " + obs_date).c_str(); // += doesn't work
   }
   r->reportObsQuestionSet->Preview();
   dbDataSet->Close();
  FORM_CATCH
 }
 catch (...)
 {
  // how terribly generic.
  ::PSay("Error running report", m_database_error, MB_OK, "TformSpecialObsQuestionSetReport::static Run");
 }

 delete dbDataSet;
 if (dbTransaction && dbTransaction->Active)
  dbTransaction->Commit(); // commit is cheaper than rollback server-side. either should be fine. could use read-only mode.
 delete dbTransaction;
}
//---------------------------------------------------------------------------

