//---------------------------------------------------------------------------

#ifndef reportPersonAuditH
#define reportPersonAuditH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "codeSpecialGeneric.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Qrctrls.hpp>
#include <QuickRpt.hpp>
#include <ToolWin.hpp>
#include "x_serialization.h"
#include <iostream>
#include <fstream>
//---------------------------------------------------------------------------
struct person_audit_report_options
{
 struct _person
 {
  string chart_location_id;
 };
 struct _code_category
 {
  enum _code_category_subset_types {ccs_all, ccs_earliest, ccs_latest};

  string category;
  xValue codes;
  _code_category_subset_types type;
  int count;

  _code_category() {type = ccs_all;};
  _code_category(xValue init);
  easy_streaming_dataset* create_condition_stream(TIBTransaction* dbTransaction, string source_view);
  easy_streaming_dataset* create_procedure_stream(TIBTransaction* dbTransaction, string source_view);
  // you'll also notice that I didn't bother making two classes here, when I probably should have.
  // see farther down for my explanation. (hint: it's not a nice logical one.)
  void slice_up(list<map<string, string> > & all_items);
 };
 struct _conditions
 {
  vector<_code_category> requests;
 };
 struct _procedures
 {
  vector<_code_category> requests;
 };
 struct _meas_desired
 {
  enum _meas_desired_subset_types {mds_none, mds_all, mds_all_avg, mds_latest, mds_latest_avg};
  string obs_id;
  _meas_desired_subset_types type;
  int count;

  _meas_desired() {type = mds_all;};
  _meas_desired(xValue init);
  easy_streaming_dataset* create_measurement_stream(TIBTransaction* dbTransaction, string source_view);
  void slice_up(list<map<string, string> > & all_items);
  // you'll note that I don't -care- about making _code_category and _meas_desired both derive from a common ancestor, eh? well, if you hadn't noticed, I -don't- care. It's late, the governor probably wants to fire me, and I don't care. You probably wouldn't either. Miscreant.
 };
 struct _measurements
 {
  vector<_meas_desired> requests;
 };

 _person person;
 _conditions conditions;
 _procedures procedures;
 _measurements measurements;

 person_audit_report_options() {};
 person_audit_report_options(xValue & xoptions);
};
//---------------------------------------------------------------------------
class TformReportPersonAudit : public TformSpecialGeneric
{
__published:	// IDE-managed Components
private:	// User declarations
        person_audit_report_options options;
        xValue xOptions;

        void htmlAddPerson(ostream & o, map<string, string> person_row, bool new_page);
        void htmlAddConditions(ostream & o, list<map<string, string> > condition_rows);
        void htmlAddProcedures(ostream & o, list<map<string, string> > procedure_rows);
        void htmlAddMeasurements(ostream & o, list<map<string, string> > measurement_rows);
        // void htmlAddMeasurements(ostream & o, string p_id, vector<easy_streaming_dataset*> & streams);

        void Run (TIBTransaction * dbTransaction, string source_view, xValue & xoptions);
public:		// User declarations
        void static Do (TIBTransaction * dbTransaction, string source_view, xValue & xoptions);
        __fastcall TformReportPersonAudit(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TformReportPersonAudit *formReportPersonAudit;
//---------------------------------------------------------------------------
#endif
