//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "reportProceduresWithoutCharges.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeSpecialGeneric"
#pragma resource "*.dfm"
TformReportProceduresWithoutCharges *formReportProceduresWithoutCharges;
//---------------------------------------------------------------------------
__fastcall TformReportProceduresWithoutCharges::TformReportProceduresWithoutCharges(TComponent* Owner)
        : TformSpecialGeneric(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformReportProceduresWithoutCharges::reportProceduresAfterPreview(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TformReportProceduresWithoutCharges::reportProceduresBeforePrint(TCustomQuickRep *Sender, bool &PrintReport)
{
  grand_total_revenue = 0.0f;
  month_total_revenue = 0.0f;
  group_total_revenue = 0.0f;
}
//---------------------------------------------------------------------------
void __fastcall TformReportProceduresWithoutCharges::lblDetailPotentialPrint(TObject *sender, AnsiString &Value)
{
  if (!reportProcedures->DataSet->IsEmpty())
  {
    int   num_procedures = reportProcedures->DataSet->FieldByName("procedure_count")->AsInteger;
    float scheduled_fee  = reportProcedures->DataSet->FieldByName("fee")->AsFloat;
    float this_revenue   = num_procedures * scheduled_fee;

    grand_total_revenue += this_revenue;
    month_total_revenue += this_revenue;
    group_total_revenue += this_revenue;

    Value = FormatString(FloatToString(this_revenue), dollarString).c_str();
  }
  else
    Value = FormatString(FloatToString(0.0f), dollarString).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportProceduresWithoutCharges::bandGroupYearMoBeforePrint(TQRCustomBand *Sender, bool &PrintBand)
{
  //bandGroupYearMo->Height = 0;
}
//---------------------------------------------------------------------------
void __fastcall TformReportProceduresWithoutCharges::lblMonthPotentialPrint(TObject *sender, AnsiString &Value)
{
  Value = FormatString(FloatToString(month_total_revenue), dollarString).c_str();
  month_total_revenue = 0.0f;
}
//---------------------------------------------------------------------------
void __fastcall TformReportProceduresWithoutCharges::lblDeptPotentialPrint(TObject *sender, AnsiString &Value)
{
  Value = FormatString(FloatToString(group_total_revenue), dollarString).c_str();
  group_total_revenue = 0.0f;
}
//---------------------------------------------------------------------------
void __fastcall TformReportProceduresWithoutCharges::lblSummaryPotentialPrint(TObject *sender, AnsiString &Value)
{
  Value = FormatString(FloatToString(grand_total_revenue), dollarString).c_str();
  grand_total_revenue = 0.0f;
}
//---------------------------------------------------------------------------

void __fastcall TformReportProceduresWithoutCharges::txtDepartmentPrint(
      TObject *sender, AnsiString &Value)
{
  Value = PrettyString(Value.c_str()).c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportProceduresWithoutCharges::exprGroupDeptPrint(TObject *sender, AnsiString &Value)
{
  Value = PrettyString(Value.c_str()).c_str();        
}
//---------------------------------------------------------------------------
void __fastcall TformReportProceduresWithoutCharges::lblTotalForMonthPrint(TObject *sender, AnsiString &Value)
{
  string month_total_caption = string("Total for ") + reportProcedures->DataSet->FieldByName("yearmo")->AsString.c_str() + ":";

  Value = month_total_caption.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TformReportProceduresWithoutCharges::lblTotalForDeptPrint(TObject *sender, AnsiString &Value)
{
  string dept_total_caption = string("Total for ") + PrettyString(reportProcedures->DataSet->FieldByName("department")->AsString.c_str()) + ":";

  Value = dept_total_caption.c_str();
}
//---------------------------------------------------------------------------

