#ifndef tinyrecord_concentrator_h
#define tinyrecord_concentrator_h

// can we have a AllowSameAs property? letting the -base- part of wizard-new-person be a 'same' value would be scary ... we don't have events to hide rels & ins, and the circular possibilities are nasty.

#include <string>
#include <set>
#include <vector>
using namespace std;

class TframeTinyRecordMagic;

class tr_magic_concentrator
{
 public:
 struct tr_cached_item
 {
  string stn;
  string desc;
  TframeTinyRecordMagic * item;
  tr_cached_item (string _stn, string _desc, TframeTinyRecordMagic * _item) : stn(_stn), desc(_desc), item(_item) {};
 };
 private:
  set<TframeTinyRecordMagic*> FMagics;
  vector<tr_cached_item> FCachedList;
 public:
  tr_magic_concentrator ();
  ~tr_magic_concentrator ();

  void Add (TframeTinyRecordMagic * to_add);
  void Remove (TframeTinyRecordMagic * to_remove);
  bool Exists (TframeTinyRecordMagic * to_test);
  void List (TframeTinyRecordMagic * list_into);
  void Refresh ();
  TframeTinyRecordMagic * Find (string _stn, string _id, TframeTinyRecordMagic * not_this_one = NULL);
};
bool operator < (const tr_magic_concentrator::tr_cached_item & lhs, const tr_magic_concentrator::tr_cached_item & rhs) {return rhs.desc < lhs.desc;};

#endif
