/*

   Prometheus Stub Launcher

   Cached Files Module

   This is the same as in Prometheus, but is cut down to the parts that are
   relevant to management of local files and the cache directory tree only.

*/

#ifndef CACHED_FILES_H__
#define CACHED_FILES_H__

#include <string>
#include <utility>

using namespace std;

namespace FileCache
{
   // Utilities
   string GetBasePath(void);
   string RemoveTrailingSlash(const string &source_path);
   string RemoveLeadingSlash(const string &source_path);
   string PathConcatenate(const string &base, const string &newpart);
   bool   DirectoryExists(const string &path, bool test_if_full_perms);
   bool   FileExists(const string &path, const string &file);
   bool   FileExistsInCache(const string &path, const string &file);
   bool   CreateDirectory(const string &dir_name);
   bool   CreateDirectoryRecursive(const string &path);
   bool   CopyIntoCache(const string &file, const string &relativedir);
   bool   DropFromCache(const string &path, const string &file);
   pair<string, string> GetFileSpec(const string &full_path);
}

#endif

// EOF

