/*

  Prometheus Stub Launcher

  Stub Configuration File Parsing

*/

#ifndef STUBCONFIG_H__
#define STUBCONFIG_H__

#include <string>
#include <map>

class StubConfig
{
public:
   typedef std::map<std::string, std::string> ValueMap;

protected:
   ValueMap cfgValues;
   
   // parsing state
   int textPos;
   int parseState;
   std::string token;
   std::string variable;

   enum
   {
      TSTATE_SCAN,
      TSTATE_INVAR
   };

   enum
   {
      STATE_EXPECTVAR,
      STATE_EXPECTEQUALS,
      STATE_EXPECTVALUE,
      NUMSTATES
   };

   StubConfig() : cfgValues(), token(), variable() {}

   void nextToken(const char *input);
   void parse(const char *input);

   // parser state handlers
   void doExpectVar();
   void doExpectEquals();
   void doExpectValue();

   // parser state table
   static void (StubConfig::*States[])();

public:
   static StubConfig &ReadStubConfig();

   ValueMap &getValueMap() { return cfgValues; }
};

#endif

// EOF

