// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'QRPDFFilt.pas' rev: 5.00

#ifndef QRPDFFiltHPP
#define QRPDFFiltHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <pdfobjs.hpp>	// Pascal unit
#include <grimgctrl.hpp>	// Pascal unit
#include <QRCtrls.hpp>	// Pascal unit
#include <QR3Const.hpp>	// Pascal unit
#include <QuickRpt.hpp>	// Pascal unit
#include <QRPrntr.hpp>	// Pascal unit
#include <QRExport.hpp>	// Pascal unit
#include <ComCtrls.hpp>	// Pascal unit
#include <DBTables.hpp>	// Pascal unit
#include <Db.hpp>	// Pascal unit
#include <Printers.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Buttons.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <StdCtrls.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Qrpdffilt
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TQRPAbstractExportFilter;
class PASCALIMPLEMENTATION TQRPAbstractExportFilter : public Qrprntr::TQRExportFilter 
{
	typedef Qrprntr::TQRExportFilter inherited;
	
private:
	Classes::TStream* FStream;
	Extended FCharWidth;
	Extended FCharHeight;
	Extended FPaperWidth;
	Extended FPaperHeight;
	int FLineCount;
	int FColCount;
	bool FPageProcessed;
	
protected:
	AnsiString __fastcall GetText(Extended X, Extended Y, Graphics::TFont* &Font);
	virtual AnsiString __fastcall GetFilterName();
	virtual AnsiString __fastcall GetDescription();
	virtual AnsiString __fastcall GetExtension();
	void __fastcall WriteToStream(const AnsiString AText);
	void __fastcall WriteLnToStream(const AnsiString AText);
	virtual void __fastcall CreateStream(AnsiString Filename);
	virtual void __fastcall CloseStream(void);
	virtual void __fastcall ProcessPage(void);
	virtual void __fastcall StorePage(void);
	__property Classes::TStream* Stream = {read=FStream, write=FStream};
	__property bool PageProcessed = {read=FPageProcessed, write=FPageProcessed, nodefault};
	__property Extended CharWidth = {read=FCharWidth, write=FCharWidth};
	__property Extended CharHeight = {read=FCharHeight, write=FCharHeight};
	__property Extended PaperWidth = {read=FPaperWidth, write=FPaperWidth};
	__property Extended PaperHeight = {read=FPaperHeight, write=FPaperHeight};
	__property int LineCount = {read=FLineCount, write=FLineCount, nodefault};
	__property int ColCount = {read=FColCount, write=FColCount, nodefault};
	
public:
	virtual void __fastcall Start(int PaperWidth, int PaperHeight, Graphics::TFont* Font);
	virtual void __fastcall Finish(void);
	virtual void __fastcall EndPage(void);
	virtual void __fastcall NewPage(void);
	virtual void __fastcall AcceptGraphic(Extended Xoff, Extended Yoff, Controls::TControl* GControl);
	virtual void __fastcall TextOut(Extended X, Extended Y, Graphics::TFont* Font, Graphics::TColor BGColor
		, Classes::TAlignment Alignment, AnsiString Text);
public:
	#pragma option push -w-inl
	/* TQRExportFilter.Create */ inline __fastcall TQRPAbstractExportFilter(AnsiString Filename) : Qrprntr::TQRExportFilter(
		Filename) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TQRPAbstractExportFilter(void) { }
	#pragma option pop
	
};


class DELPHICLASS TQRPDFDocumentFilter;
class PASCALIMPLEMENTATION TQRPDFDocumentFilter : public TQRPAbstractExportFilter 
{
	typedef TQRPAbstractExportFilter inherited;
	
private:
	bool FFreeStream;
	Graphics::TColor FBodyColor;
	AnsiString FExtraBody;
	bool FFirstPage;
	int FPageLength;
	int FPageNumber;
	int FNextPicnum;
	Pdfobjs::TPDFItemRec FPDFItem;
	bool FTextOnTop;
	bool FConcatenating;
	int FReportnum;
	int FLeftMargin;
	int FTopMargin;
	void __fastcall SetTextOnTop(bool bval);
	
protected:
	virtual AnsiString __fastcall GetFilterName();
	virtual AnsiString __fastcall GetDescription();
	virtual AnsiString __fastcall GetExtension();
	virtual bool __fastcall GetStreaming(void);
	virtual void __fastcall CreateStream(AnsiString Filename);
	virtual void __fastcall CloseStream(void);
	
public:
	__fastcall TQRPDFDocumentFilter(AnsiString filename);
	__fastcall virtual ~TQRPDFDocumentFilter(void);
	virtual void __fastcall StorePage(void);
	virtual void __fastcall TextOut(Extended X, Extended Y, Graphics::TFont* Font, Graphics::TColor BGColor
		, Classes::TAlignment Alignment, AnsiString Text);
	virtual void __fastcall ProcessPage(void);
	virtual void __fastcall Start(int PaperWidth, int PaperHeight, Graphics::TFont* Font);
	virtual void __fastcall Finish(void);
	void __fastcall SetMargins(int TopMarg, int Leftmarg);
	virtual void __fastcall NewPage(void);
	virtual void __fastcall EndPage(void);
	void __fastcall EndConcat(void);
	void __fastcall StartConcat(void);
	virtual void __fastcall AcceptGraphic(Extended Xoff, Extended Yoff, Controls::TControl* GControl);
	void __fastcall AddFontMap(AnsiString ssmap);
	__property int PageLength = {read=FPageLength, write=FPageLength, nodefault};
	__property Stream ;
	__property bool FreeStream = {read=FFreeStream, write=FFreeStream, nodefault};
	__property bool TextOnTop = {read=FTextOnTop, write=SetTextOnTop, nodefault};
	__property bool Concatenating = {read=FConcatenating, write=FConcatenating, nodefault};
	__property int Reportnum = {read=FReportnum, write=FReportnum, nodefault};
	__property int TopMargin = {read=FTopMargin, write=FTopMargin, nodefault};
	__property int LeftMargin = {read=FLeftMargin, write=FLeftMargin, nodefault};
};


//-- var, const, procedure ---------------------------------------------------
static const Extended PointsPerMM = 2.834646E+00;
static const Shortint IT_TEXT = 0x1;
static const Shortint IT_NEWPAGE = 0x2;
static const Shortint IT_GRAPHIC = 0x3;
static const Shortint IT_IMAGE = 0x4;
static const Shortint S_BOX = 0x0;
static const Shortint S_CIRCLE = 0x1;
static const Shortint S_HLINE = 0x2;
static const Shortint S_VLINE = 0x3;
static const Shortint S_OBLIQUE = 0x4;
static const Shortint S_TOPBOTTOM = 0x5;
static const Shortint S_LEFTRIGHT = 0x6;
static const Shortint S_ROUNDRECT = 0x7;
static const Byte ORD0 = 0x30;
static const Byte ORDA = 0x41;

}	/* namespace Qrpdffilt */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Qrpdffilt;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// QRPDFFilt
