//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "codeRecordActivity.h"
#include "codeRecordAffiliations.h"
#include "codeRecordAppointment.h"
#include "codeRecordBehOutsideTreatment.h"
#include "codeRecordCaseNotes.h"
#include "codeRecordChart.h"
#include "codeRecordCheck.h"
#include "codeRecordComDrug.h"
#include "codeRecordComHealth.h"
#include "codeRecordComNutrition.h"
#include "codeRecordComVisit.h"
#include "codeRecordCondition.h"
#include "codeRecordConsent.h"
#include "codeRecordContactInfo.h"
#include "codeRecordDeferredCOB.h"
#include "codeRecordDenialLetter.h"
#include "codeRecordDenial.h"
#include "codeRecordDiabScore.h"
#include "codeRecordDiabScore.h"
#include "codeRecordEnrollment.h"
#include "codeRecordForm.h"
#include "codeRecordFitnessAttendance.h"
#include "codeRecordFitnessMembership.h"
#include "codeRecordGoal.h"
#include "codeRecordIncentive.h"
#include "codeRecordIncomingBill.h"
#include "codeRecordInsuranceApplication.h"
#include "codeRecordInsuranceCoverage.h"
#include "codeRecordLogsheet.h"
#include "codeRecordName.h"
#include "codeRecordOutgoingBill.h"
//#include "codeRecordParticipationsBeh.h"
#include "codeRecordParticipationsDiab.h"
#include "codeRecordPatientAssessment.h"
#include "codeRecordPerson.h"
#include "codeRecordPersonNotes.h"
#include "codeRecordProcedure.h"
#include "codeRecordPurchaseReq.h"
#include "codeRecordReferral.h"
#include "codeRecordRelationship.h"
#include "codeRecordTaskBeh.h"
#include "codeRecordTaskCob.h"
#include "codeRecordTaskCobVisit.h"
#include "codeRecordTaskCom.h"
#include "codeRecordTaskDen.h"
#include "codeRecordTaskDiab.h"
#include "codeRecordTaskLac.h"
#include "codeRecordTaskNotes.h"
#include "codeRecordTreatmentBeh.h"
#include "codeSearchTaxEntity.h"
#include "codeSpecialCaregiverLimits.h"
#include "codeSpecialDisambiguate.h" // for Disambiguation
#include "codeSpecialHouseholdMod.h"
#include "codeSpecialPersonLimits.h"
#include "codeSpecialRelationshipGraph.h"
#include "codeWizardNewPerson.h"
#include "launchBehConditionReport.h"
#include "launchBehLocalTreatmentReport.h"
#include "launchBehOutsideTreatmentReport.h"
#include "launchBehReferralReport.h"
#include "launchBehTaskReport.h"
#include "launchComCommentReport.h"
#include "launchComEducationReport.h"
#include "launchComMeasurements.h"
#include "launchComPersonVisitReport.h"
#include "launchDiabAttendanceReport.h"
#include "launchDiabCareSummaryReport.h"
#include "launchDiabLogsheetReport.h"
#include "launchDiabMeasurementReport.h"
#include "launchDiabTaskReport.h"
#include "launchEventByClientReport.h"
#include "launchIntakeFormReport.h"
#include "launchPatientDemographicsReport.h"
#include "launchPatientHealthSummary.h"
#include "launchPersonProviderInfoReport.h"
#include "launchProcsDoneReport.h"
#include "launchPublicCommentReport.h"
#include "launchPublicEducationReport.h"
//#include "launchPublicEventReport.h"
#include "launchPublicMeasurement.h"
#include "launchPublicVisitReport.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "codeRecordGeneric"
#pragma link "codeFrameDependencyGraph"
#pragma link "codeFrameObservationList"
#pragma link "codeRelationGeneric"
#pragma link "codeRelationMagic"
#pragma link "codeRubberContainer"
#pragma link "codeValueGeneric"
#pragma resource "*.dfm"
TformRecordPerson *formRecordPerson;
//---------------------------------------------------------------------------
__fastcall TformRecordPerson::TformRecordPerson(TComponent* Owner, map<string,string> & p_parameters, int initial_page_number)
        : TformRecordGeneric(Owner, p_parameters, string("people"))
{
  filter_atlas_handler["names"].filter->SetListViewHandle(listNames);
  filter_atlas_handler["names"].filter->SetSecurity("person_names");
  filter_atlas_handler["names"].filter->AddColumnSpec("Default Name", "person_names", as_text, true, 28);
  filter_atlas_handler["names"].filter->AddColumnSpec("Prefix", "person_names", as_text, false, 30);
  filter_atlas_handler["names"].filter->AddColumnSpec("First Name", "person_names", as_text, true, 85);
  filter_atlas_handler["names"].filter->AddColumnSpec("Middle Name", "person_names", as_text, true, 75);
  filter_atlas_handler["names"].filter->AddColumnSpec("Last Name", "person_names", as_text, true, 90);
  filter_atlas_handler["names"].filter->AddColumnSpec("Sfx", "person_names", as_text, false, 30);
  filter_atlas_handler["names"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 20);
  filter_atlas_handler["names"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 40);
  filter_atlas_handler["names"].filter->FetchPreferences("recordperson.names_filter");
  filter_atlas_handler["names"].filter->SetIconStatus(true);
  filter_atlas_handler["names"].filter->SetSQLStatement("");
  filter_atlas_handler["names"].filter->RefreshDataSet();

  filter_atlas_handler["affiliations"].filter->SetListViewHandle(listAffiliations);
  filter_atlas_handler["affiliations"].filter->SetSecurity("affiliations");
  filter_atlas_handler["affiliations"].filter->AddColumnSpec("Default Affiliation", "affiliations", as_text, true, 28);
  filter_atlas_handler["affiliations"].filter->AddColumnSpec("CDIB", "affiliations", as_text, true, 70);
  filter_atlas_handler["affiliations"].filter->AddColumnSpec("Tribe", "affiliations", as_text, true, 150);
  filter_atlas_handler["affiliations"].filter->AddColumnSpec("Join Date", "affiliations", as_date, true, 80);
  filter_atlas_handler["affiliations"].filter->AddColumnSpec("Rel. Date", "affiliations", as_date, true, 80);
  filter_atlas_handler["affiliations"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 20);
  filter_atlas_handler["affiliations"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 40);
  filter_atlas_handler["affiliations"].filter->FetchPreferences("recordperson.affiliations_filter");
  filter_atlas_handler["affiliations"].filter->SetIconStatus(true);
  filter_atlas_handler["affiliations"].filter->SetSQLStatement("");
  filter_atlas_handler["affiliations"].filter->RefreshDataSet();

  filter_atlas_handler["contacts"].filter->SetListViewHandle (listContacts);
  filter_atlas_handler["contacts"].filter->SetSecurity("person_contact_info");
  filter_atlas_handler["contacts"].filter->AddColumnSpec("Defaults", "person_names", as_text, true, 85, rawString);
  filter_atlas_handler["contacts"].filter->AddColumnSpec("Place", "person_contact_info", as_text, true, 43);
  filter_atlas_handler["contacts"].filter->AddColumnSpec("Address", "person_contact_info", as_text, true, 145, addressString);
  filter_atlas_handler["contacts"].filter->AddColumnSpec("City", "person_contact_info", as_text, true, 75);
  filter_atlas_handler["contacts"].filter->AddColumnSpec("State", "person_contact_info", as_text, true, 30, uppercaseString);
  filter_atlas_handler["contacts"].filter->AddColumnSpec("Zip", "person_contact_info", as_text, false, 70, prettyZipString);
  filter_atlas_handler["contacts"].filter->AddColumnSpec("Country", "person_contact_info", as_text, false, 85);
  filter_atlas_handler["contacts"].filter->AddColumnSpec("Residence", "person_contact_info", as_text, false, 40);
  filter_atlas_handler["contacts"].filter->AddColumnSpec("Trust Lands", "person_contact_info", as_text, false, 30, prettyBoolString);
  filter_atlas_handler["contacts"].filter->AddColumnSpec("Phone Number", "person_contact_info", as_text, true, 95, prettyPhoneString);
  filter_atlas_handler["contacts"].filter->AddColumnSpec("E-mail Address", "person_contact_info", as_text, false, 135, lowercaseString);
  filter_atlas_handler["contacts"].filter->AddColumnSpec("Notes", "person_contact_info", as_text, false, 120, sentenceString);
  filter_atlas_handler["contacts"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 20);
  filter_atlas_handler["contacts"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 40);
  filter_atlas_handler["contacts"].filter->FetchPreferences("recordperson.contacts_filter");
  filter_atlas_handler["contacts"].filter->SetIconStatus(true);
  filter_atlas_handler["contacts"].filter->SetSQLStatement ("");
  filter_atlas_handler["contacts"].filter->RefreshDataSet();

  filter_atlas_handler["consents"].filter->SetListViewHandle (listConsents);
  filter_atlas_handler["consents"].filter->SetSecurity("consents");
  filter_atlas_handler["consents"].filter->AddColumnSpec("Date", "consents", as_date, true, 80);
  filter_atlas_handler["consents"].filter->AddColumnSpec("Type of Consent", "consents", as_text, true, 200);
  filter_atlas_handler["consents"].filter->AddColumnSpec("Note", "consents", as_text, false, 140, sentenceString);
  filter_atlas_handler["consents"].filter->AddColumnSpec("Dept.", "consents", as_text, true, 100);
  filter_atlas_handler["consents"].filter->AddColumnSpec("Event", "participations", as_text, false, 140, rawString);
  filter_atlas_handler["consents"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["consents"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["consents"].filter->FetchPreferences("recordperson.consents_filter");
  filter_atlas_handler["consents"].filter->SetIconStatus(true);
  filter_atlas_handler["consents"].filter->SetSQLStatement ("");
  filter_atlas_handler["consents"].filter->RefreshDataSet();

  filter_atlas_handler["appointments"].filter->SetListViewHandle (listAppointments);
  filter_atlas_handler["appointments"].filter->SetSecurity("appointments.people");
  filter_atlas_handler["appointments"].filter->AddColumnSpec("Provider", "appointments", as_text, false, 100, rawString);
  filter_atlas_handler["appointments"].filter->AddColumnSpec("Date", "appointments", as_date, true, 90/*, repeatingString*/);
  filter_atlas_handler["appointments"].filter->AddColumnSpec("Time", "appointments", as_text, true, 80);
  filter_atlas_handler["appointments"].filter->AddColumnSpec("Description", "appointments", as_text, true, 130, sentenceString);
  filter_atlas_handler["appointments"].filter->AddColumnSpec("Created For", "appointments", as_text, true, 100);
  filter_atlas_handler["appointments"].filter->AddColumnSpec("Outcome", "appointments", as_text, false, 90);
  filter_atlas_handler["appointments"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["appointments"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["appointments"].filter->FetchPreferences("recordperson.appointments_filter");
  filter_atlas_handler["appointments"].filter->SetIconStatus(true);
  filter_atlas_handler["appointments"].filter->SetSQLStatement ("");
  filter_atlas_handler["appointments"].filter->RefreshDataSet();

  filter_atlas_handler["referrals"].filter->SetListViewHandle (listReferrals);
  filter_atlas_handler["referrals"].filter->SetSecurity("referrals");
  filter_atlas_handler["referrals"].filter->AddColumnSpec("Date", "referrals", as_date, true, 90);
  filter_atlas_handler["referrals"].filter->AddColumnSpec("Referred By (Facility)", "referrals", as_text, true, 200);
  filter_atlas_handler["referrals"].filter->AddColumnSpec("Referred By (Provider)", "referrals", as_text, true, 200);
  filter_atlas_handler["referrals"].filter->AddColumnSpec("Referred To (Facility)", "referrals", as_text, true, 200);
  filter_atlas_handler["referrals"].filter->AddColumnSpec("Referred To (Provider)", "referrals", as_text, true, 200);
  if (optionsPermissions["special.beh.general"]["enabled"] == "true")
    filter_atlas_handler["referrals"].filter->AddColumnSpec("Reason", "referrals", as_text, false, 100);
  else if (optionsPermissions["special.com.general"]["enabled"] == "true")
    filter_atlas_handler["referrals"].filter->AddColumnSpec("Reason", "referrals", as_text, false, 100);
  else if (optionsPermissions["special.diab.general"]["enabled"] == "true")
    filter_atlas_handler["referrals"].filter->AddColumnSpec("Reason", "referrals", as_text, false, 100);
  else
    filter_atlas_handler["referrals"].filter->AddColumnSpec("Reason", "NEVER", as_text, false, 100); /* we don't have a simple boolean "can see this", nor an option for "permisson A OR permission B OR ..." */
  filter_atlas_handler["referrals"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["referrals"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["referrals"].filter->FetchPreferences("recordperson.referrals_filter");
  filter_atlas_handler["referrals"].filter->SetIconStatus(true);
  filter_atlas_handler["referrals"].filter->SetSQLStatement ("");
  filter_atlas_handler["referrals"].filter->RefreshDataSet();


  filter_atlas_handler["diab_notes"].filter->SetListViewHandle (listDiabComments);
  filter_atlas_handler["diab_notes"].filter->SetSecurity("person_notes.diab");
  filter_atlas_handler["diab_notes"].filter->AddColumnSpec("Date", "person_notes", as_date, true, 80);
  filter_atlas_handler["diab_notes"].filter->AddColumnSpec("Note", "person_notes", as_text, true, 270, sentenceString);
  filter_atlas_handler["diab_notes"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["diab_notes"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["diab_notes"].filter->FetchPreferences("recordperson.diab_notes_filter");
  filter_atlas_handler["diab_notes"].filter->SetIconStatus(true);
  filter_atlas_handler["diab_notes"].filter->SetSQLStatement("");
  filter_atlas_handler["diab_notes"].filter->RefreshDataSet();

  filter_atlas_handler["diab_conditions"].filter->SetListViewHandle (listDiabConditions);
  filter_atlas_handler["diab_conditions"].filter->SetSecurity("conditions.diab");
  filter_atlas_handler["diab_conditions"].filter->AddColumnSpec("Condition Type", "conditions", as_text, true, 120);
  filter_atlas_handler["diab_conditions"].filter->AddColumnSpec("Start Date", "conditions", as_date, false, 100);
  filter_atlas_handler["diab_conditions"].filter->AddColumnSpec("Stop Date", "conditions", as_date, false, 100);
  filter_atlas_handler["diab_conditions"].filter->AddColumnSpec("Code", "conditions", as_text, true, 100);
  filter_atlas_handler["diab_conditions"].filter->AddColumnSpec("Note", "conditions", as_text, false, 100, sentenceString);
  filter_atlas_handler["diab_conditions"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["diab_conditions"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["diab_conditions"].filter->FetchPreferences("recordperson.diab_conditions_filter");
  filter_atlas_handler["diab_conditions"].filter->SetIconStatus(true);
  filter_atlas_handler["diab_conditions"].filter->SetSQLStatement("");
  filter_atlas_handler["diab_conditions"].filter->RefreshDataSet();

  filter_atlas_handler["fitness"].filter->SetListViewHandle(listFitness);
  filter_atlas_handler["fitness"].filter->SetSecurity("fitness_memberships");
  filter_atlas_handler["fitness"].filter->AddColumnSpec("Facility", "fitness_memberships", as_text, true, 120);
  filter_atlas_handler["fitness"].filter->AddColumnSpec("Begin Date", "fitness_memberships", as_date, true, 100);
  filter_atlas_handler["fitness"].filter->AddColumnSpec("Cancel Date", "fitness_memberships", as_date, true, 100);
  filter_atlas_handler["fitness"].filter->AddColumnSpec("Is waiting", "fitness_memberships", as_text, true, 100, prettyBoolString);
  filter_atlas_handler["fitness"].filter->AddColumnSpec("Wait add date", "fitness_memberships", as_date, true, 100);
  filter_atlas_handler["fitness"].filter->AddColumnSpec("Comments", "fitness_memberships", as_text, true, 100, sentenceString);
  filter_atlas_handler["fitness"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["fitness"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["fitness"].filter->FetchPreferences("recordperson.fitness_filter");
  filter_atlas_handler["fitness"].filter->SetIconStatus(true);
  filter_atlas_handler["fitness"].filter->SetSQLStatement("");
  filter_atlas_handler["fitness"].filter->RefreshDataSet();

  filter_atlas_handler["fitness_attendance"].filter->SetListViewHandle(listFitnessAttendance);
  filter_atlas_handler["fitness_attendance"].filter->SetSecurity("fitness_attendance");
  filter_atlas_handler["fitness_attendance"].filter->AddColumnSpec("Facility", "fitness_memberships", as_text, true, 120);
  filter_atlas_handler["fitness_attendance"].filter->AddColumnSpec("Attendance Date", "fitness_attendance", as_date, true, 120);
  filter_atlas_handler["fitness_attendance"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["fitness_attendance"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["fitness_attendance"].filter->FetchPreferences("recordperson.fitness_attendance_filter");
  filter_atlas_handler["fitness_attendance"].filter->SetIconStatus(true);
  filter_atlas_handler["fitness_attendance"].filter->SetSQLStatement("");
  filter_atlas_handler["fitness_attendance"].filter->RefreshDataSet();

  filter_atlas_handler["diab_task"].filter->SetListViewHandle(listDiabTasks);
  filter_atlas_handler["diab_task"].filter->SetSecurity("tasks.diab");
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Staff", "tasks", as_text, true, 110);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Event", "events", as_text, false, 110, rawString);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Time Spent", "tasks", as_double, true, 100);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Mileage", "tasks", as_double, false, 80);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Type of Contact", "tasks", as_text, false, 120);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Method of Contact", "tasks", as_text, true, 130);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("In/Out", "tasks", as_text, false, 80);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Program", "tasks", as_text, false, 90);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Task Type", "tasks", as_text, false, 120);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Classification", "tasks", as_text, false, 110);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Meeting Type", "tasks", as_text, false, 110);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Activity Type", "tasks", as_text, true, 110);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Is Educational", "tasks", as_text, false, 110, prettyBoolString);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Is Personal", "tasks", as_text, false, 100, prettyBoolString);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Comments", "tasks", as_text, false, 150, sentenceString);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["diab_task"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["diab_task"].filter->FetchPreferences("recordperson.diab_task_filter");
  filter_atlas_handler["diab_task"].filter->SetIconStatus(true);
  filter_atlas_handler["diab_task"].filter->SetSQLStatement("");
  filter_atlas_handler["diab_task"].filter->RefreshDataSet();

  filter_atlas_handler["diab_education"].filter->SetListViewHandle(listDiabEducation);
  filter_atlas_handler["diab_education"].filter->SetSecurity("diab_education");
  filter_atlas_handler["diab_education"].filter->AddColumnSpec("Topic", "diab_education", as_text, true, 100);
  filter_atlas_handler["diab_education"].filter->AddColumnSpec("Pre-Test Date", "diab_education", as_date, true, 110);
  filter_atlas_handler["diab_education"].filter->AddColumnSpec("Pre-Score", "diab_education", as_double, true, 90);
  filter_atlas_handler["diab_education"].filter->AddColumnSpec("Post-Test Date", "diab_education", as_date, true, 110);
  filter_atlas_handler["diab_education"].filter->AddColumnSpec("Post-Score", "diab_education", as_double, true, 90);
  filter_atlas_handler["diab_education"].filter->AddColumnSpec("Note", "diab_education", as_text, true, 110, sentenceString);
  filter_atlas_handler["diab_education"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["diab_education"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["diab_education"].filter->FetchPreferences("recordperson.diab_education_filter");
  filter_atlas_handler["diab_education"].filter->SetIconStatus(true);
  filter_atlas_handler["diab_education"].filter->SetSQLStatement("");
  filter_atlas_handler["diab_education"].filter->RefreshDataSet();

  filter_atlas_handler["diab_event"].filter->SetListViewHandle(listDiabEvents);
  filter_atlas_handler["diab_event"].filter->SetSecurity("participations");
  filter_atlas_handler["diab_event"].filter->AddColumnSpec("Date", "events", as_date, true, 80);
  filter_atlas_handler["diab_event"].filter->AddColumnSpec("Event Name", "events", as_text, true, 130, rawString);
  filter_atlas_handler["diab_event"].filter->AddColumnSpec("Event Type", "events", as_text, true, 100, rawString);
  filter_atlas_handler["diab_event"].filter->AddColumnSpec("Location", "events", as_text, true, 160, rawString);
  filter_atlas_handler["diab_event"].filter->AddColumnSpec("Attendance", "events", as_text, false, 100);
  filter_atlas_handler["diab_event"].filter->AddColumnSpec("Description", "events", as_text, false, 140, sentenceString);
  filter_atlas_handler["diab_event"].filter->AddColumnSpec("Special Info", "participations", as_text, false, 90);
  filter_atlas_handler["diab_event"].filter->AddColumnSpec("Note", "participations", as_text, false, 130);
  filter_atlas_handler["diab_event"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["diab_event"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["diab_event"].filter->FetchPreferences("recordperson.diab_event_filter");
  filter_atlas_handler["diab_event"].filter->SetIconStatus(true);
  filter_atlas_handler["diab_event"].filter->SetSQLStatement("");
  filter_atlas_handler["diab_event"].filter->RefreshDataSet();

  filter_atlas_handler["diab_logsheet"].filter->SetListViewHandle(listDiabLogsheets);
  filter_atlas_handler["diab_logsheet"].filter->SetSecurity("activity_logsheets");
  filter_atlas_handler["diab_logsheet"].filter->AddColumnSpec("Date Turned In", "activity_logsheets", as_date, true, 115);
  filter_atlas_handler["diab_logsheet"].filter->AddColumnSpec("Begin Date", "activity_logsheets", as_date, true, 95);
  filter_atlas_handler["diab_logsheet"].filter->AddColumnSpec("End Date", "activity_logsheets", as_date, true, 90);
  filter_atlas_handler["diab_logsheet"].filter->AddColumnSpec("Total Activities", "activity_logsheets", as_int, true, 110);
  filter_atlas_handler["diab_logsheet"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["diab_logsheet"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["diab_logsheet"].filter->FetchPreferences("recordperson.diab_logsheet_filter");
  filter_atlas_handler["diab_logsheet"].filter->SetIconStatus(true);
  filter_atlas_handler["diab_logsheet"].filter->SetSQLStatement("");
  filter_atlas_handler["diab_logsheet"].filter->RefreshDataSet();

  filter_atlas_handler["incentives"].filter->SetListViewHandle(listIncentives);
  filter_atlas_handler["incentives"].filter->SetSecurity("incentives");
  filter_atlas_handler["incentives"].filter->AddColumnSpec("Date", "incentives", as_date, true, 80);
  filter_atlas_handler["incentives"].filter->AddColumnSpec("Type", "incentives", as_text, true, 100);
  filter_atlas_handler["incentives"].filter->AddColumnSpec("Shirt Type", "incentives", as_text, true, 100);
  filter_atlas_handler["incentives"].filter->AddColumnSpec("Shirt Size", "incentives", as_text, false, 100);
  filter_atlas_handler["incentives"].filter->AddColumnSpec("Date Sent to Finance", "incentives", as_date, false, 150);
  filter_atlas_handler["incentives"].filter->AddColumnSpec("Check Number", "incentives", as_text, false, 100);
  filter_atlas_handler["incentives"].filter->AddColumnSpec("Amount", "incentives", as_double, true, 100);
  filter_atlas_handler["incentives"].filter->AddColumnSpec("Shoe Type", "incentives", as_text, true, 100, sentenceString);
  filter_atlas_handler["incentives"].filter->AddColumnSpec("Shoe Size", "incentives", as_text, false, 100, sentenceString);
  filter_atlas_handler["incentives"].filter->AddColumnSpec("Date Ordered", "incentives", as_date, true, 110);
  filter_atlas_handler["incentives"].filter->AddColumnSpec("Received from Nike", "incentives", as_text, false, 130, prettyBoolString);
  filter_atlas_handler["incentives"].filter->AddColumnSpec("Received by Client", "incentives", as_text, false, 130, prettyBoolString);
  filter_atlas_handler["incentives"].filter->AddColumnSpec("Note", "incentives", as_text, false, 100);
  filter_atlas_handler["incentives"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["incentives"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["incentives"].filter->FetchPreferences("recordperson.incentives_filter");
  filter_atlas_handler["incentives"].filter->SetIconStatus(true);
  filter_atlas_handler["incentives"].filter->SetSQLStatement("");
  filter_atlas_handler["incentives"].filter->RefreshDataSet();

  filter_atlas_handler["goals"].filter->SetListViewHandle(listGoals);
  filter_atlas_handler["goals"].filter->SetSecurity("goals");
  filter_atlas_handler["goals"].filter->AddColumnSpec("Date Entered", "goals", as_date, true, 110);
  filter_atlas_handler["goals"].filter->AddColumnSpec("Current Activity Level", "goals", as_text, true, 120);
  filter_atlas_handler["goals"].filter->AddColumnSpec("Times Per Week", "goals", as_text, true, 120);
  filter_atlas_handler["goals"].filter->AddColumnSpec("Length Per Session", "goals", as_text, true, 120);
  filter_atlas_handler["goals"].filter->AddColumnSpec("Activity Goal", "goals", as_text, true, 120, sentenceString);
  filter_atlas_handler["goals"].filter->AddColumnSpec("Times Per Week Goal", "goals", as_text, true, 120, sentenceString);
  filter_atlas_handler["goals"].filter->AddColumnSpec("Time Per Session Goal", "goals", as_text, true, 120, sentenceString);
  filter_atlas_handler["goals"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["goals"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["goals"].filter->FetchPreferences("recordperson.goals_filter");
  filter_atlas_handler["goals"].filter->SetIconStatus(true);
  filter_atlas_handler["goals"].filter->SetSQLStatement("");
  filter_atlas_handler["goals"].filter->RefreshDataSet();

  filter_atlas_handler["beh_local_treatment"].filter->SetListViewHandle(listBehTreatment);
  filter_atlas_handler["beh_local_treatment"].filter->SetSecurity("beh_treatment");
  filter_atlas_handler["beh_local_treatment"].filter->AddColumnSpec("Admit Date", "beh_treatment", as_date, true, 100);
  filter_atlas_handler["beh_local_treatment"].filter->AddColumnSpec("Discharge Date", "beh_treatment", as_date, true, 120);
  filter_atlas_handler["beh_local_treatment"].filter->AddColumnSpec("Reason for Discharge", "beh_treatment", as_text, true, 150);
  filter_atlas_handler["beh_local_treatment"].filter->AddColumnSpec("Comments", "beh_treatment", as_text, false, 140, sentenceString);
  filter_atlas_handler["beh_local_treatment"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["beh_local_treatment"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["beh_local_treatment"].filter->FetchPreferences("recordperson.beh_local_treatment_filter");
  filter_atlas_handler["beh_local_treatment"].filter->SetIconStatus(true);
  filter_atlas_handler["beh_local_treatment"].filter->SetSQLStatement("");
  filter_atlas_handler["beh_local_treatment"].filter->RefreshDataSet();

  filter_atlas_handler["beh_out_treatment"].filter->SetListViewHandle(listBehOutsideTreatment);
  filter_atlas_handler["beh_out_treatment"].filter->SetSecurity("beh_treatment");
  filter_atlas_handler["beh_out_treatment"].filter->AddColumnSpec("Facility", "tax_entities", as_text, true, 100, rawString);
  filter_atlas_handler["beh_out_treatment"].filter->AddColumnSpec("Patient Type", "beh_treatment", as_text, true, 120);
  filter_atlas_handler["beh_out_treatment"].filter->AddColumnSpec("Begin Date", "beh_treatment", as_date, true, 100);
  filter_atlas_handler["beh_out_treatment"].filter->AddColumnSpec("End Date", "beh_treatment", as_date, true, 100);
  filter_atlas_handler["beh_out_treatment"].filter->AddColumnSpec("Physician", "beh_treatment", as_text, false, 100);
  filter_atlas_handler["beh_out_treatment"].filter->AddColumnSpec("Medications", "beh_treatment", as_text, false, 140, sentenceString);
  filter_atlas_handler["beh_out_treatment"].filter->AddColumnSpec("Notes", "beh_treatment", as_text, false, 140, sentenceString);
  filter_atlas_handler["beh_out_treatment"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["beh_out_treatment"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["beh_out_treatment"].filter->FetchPreferences("recordperson.beh_out_treatment_filter");
  filter_atlas_handler["beh_out_treatment"].filter->SetIconStatus(true);
  filter_atlas_handler["beh_out_treatment"].filter->SetSQLStatement("");
  filter_atlas_handler["beh_out_treatment"].filter->RefreshDataSet();

  filter_atlas_handler["beh_notes"].filter->SetListViewHandle (listBehComments);
  filter_atlas_handler["beh_notes"].filter->SetSecurity("person_notes.beh");
  filter_atlas_handler["beh_notes"].filter->AddColumnSpec("Note", "person_notes", as_text, true, 350, sentenceString);
  filter_atlas_handler["beh_notes"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["beh_notes"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["beh_notes"].filter->FetchPreferences("recordperson.beh_notes_filter");
  filter_atlas_handler["beh_notes"].filter->SetIconStatus(true);
  filter_atlas_handler["beh_notes"].filter->SetSQLStatement("");
  filter_atlas_handler["beh_notes"].filter->RefreshDataSet();

  filter_atlas_handler["beh_forms"].filter->SetListViewHandle(listBehForms);
  filter_atlas_handler["beh_forms"].filter->SetSecurity("forms.beh");
  filter_atlas_handler["beh_forms"].filter->AddColumnSpec("Form", "forms.beh", as_text, true, 160);
  filter_atlas_handler["beh_forms"].filter->AddColumnSpec("Completed", "forms.beh", as_date, true, 85);
  filter_atlas_handler["beh_forms"].filter->AddColumnSpec("Note", "forms.beh", as_text, false, 160, sentenceString);
  filter_atlas_handler["beh_forms"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["beh_forms"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["beh_forms"].filter->FetchPreferences("recordperson.beh_forms_filter");
  filter_atlas_handler["beh_forms"].filter->SetIconStatus(true);
  filter_atlas_handler["beh_forms"].filter->SetSQLStatement("");
  filter_atlas_handler["beh_forms"].filter->RefreshDataSet();

  filter_atlas_handler["beh_task"].filter->SetListViewHandle(listTasksBeh);
  filter_atlas_handler["beh_task"].filter->SetSecurity("tasks.beh");
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Staff", "tasks", as_text, true, 110);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Event", "events", as_text, false, 110, rawString);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Time Spent", "tasks", as_double, true, 100);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Mileage", "tasks", as_double, false, 80);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Method of Contact", "tasks", as_text, true, 130);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("In/Out", "tasks", as_text, true, 80);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Classification", "tasks", as_text, false, 110);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Meeting Type", "tasks", as_text, false, 110);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Activity Type", "tasks", as_text, true, 110);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Program Type", "tasks", as_text, true, 110, rawString);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Task Type", "tasks", as_text, false, 120);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Task Comments", "tasks", as_text, false, 150, sentenceString);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("New Client", "tasks", as_text, false, 100, prettyBoolString);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Visit Type", "tasks", as_text, true, 110);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Location", "tasks", as_text, false, 130);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Outcome", "tasks", as_text, false, 110);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Time Spent w/Client", "tasks", as_double, false, 100);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Visit Comments", "tasks", as_text, false, 150,sentenceString);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["beh_task"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["beh_task"].filter->FetchPreferences("recordperson.beh_task_filter");
  filter_atlas_handler["beh_task"].filter->SetSQLStatement("");
  filter_atlas_handler["beh_task"].filter->RefreshDataSet();

  filter_atlas_handler["beh_event"].filter->SetListViewHandle(listEventsBeh);
  filter_atlas_handler["beh_event"].filter->SetSecurity("participations");
  filter_atlas_handler["beh_event"].filter->AddColumnSpec("Date", "events", as_date, true, 80);
  filter_atlas_handler["beh_event"].filter->AddColumnSpec("Event Name", "events", as_text, true, 100, rawString);
  filter_atlas_handler["beh_event"].filter->AddColumnSpec("Event Type", "events", as_text, true, 110, rawString);
  filter_atlas_handler["beh_event"].filter->AddColumnSpec("Location", "events", as_text, true, 160, rawString);
  filter_atlas_handler["beh_event"].filter->AddColumnSpec("Attendance", "events", as_text, false, 100);
  filter_atlas_handler["beh_event"].filter->AddColumnSpec("Description", "events", as_text, false, 140, sentenceString);
  filter_atlas_handler["beh_event"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["beh_event"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["beh_event"].filter->FetchPreferences("recordperson.beh_event_filter");
  filter_atlas_handler["beh_event"].filter->SetIconStatus(true);
  filter_atlas_handler["beh_event"].filter->SetSQLStatement("");
  filter_atlas_handler["beh_event"].filter->RefreshDataSet();

  filter_atlas_handler["beh_conditions"].filter->SetListViewHandle (listBehConditions);
  filter_atlas_handler["beh_conditions"].filter->SetSecurity("conditions.beh");
  filter_atlas_handler["beh_conditions"].filter->AddColumnSpec("Condition Type", "conditions", as_text, false, 120);
  filter_atlas_handler["beh_conditions"].filter->AddColumnSpec("Start Date", "conditions", as_date, false, 100);
  filter_atlas_handler["beh_conditions"].filter->AddColumnSpec("Stop Date", "conditions", as_date, false, 100);
  filter_atlas_handler["beh_conditions"].filter->AddColumnSpec("Code", "conditions", as_text, true, 100);
  filter_atlas_handler["beh_conditions"].filter->AddColumnSpec("Note", "conditions", as_text, true, 180, sentenceString);
  filter_atlas_handler["beh_conditions"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["beh_conditions"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["beh_conditions"].filter->FetchPreferences("recordperson.beh_conditions_filter");
  filter_atlas_handler["beh_conditions"].filter->SetIconStatus(true);
  filter_atlas_handler["beh_conditions"].filter->SetSQLStatement("");
  filter_atlas_handler["beh_conditions"].filter->RefreshDataSet();

  filter_atlas_handler["beh_procedures"].filter->SetListViewHandle (listBehProcedures);
  filter_atlas_handler["beh_procedures"].filter->SetSecurity("procedures");
  filter_atlas_handler["beh_procedures"].filter->AddColumnSpec("Start Date", "procedures", as_date, true, 100);
  filter_atlas_handler["beh_procedures"].filter->AddColumnSpec("Stop Date", "procedures", as_date, false, 100);
  filter_atlas_handler["beh_procedures"].filter->AddColumnSpec("Place of Service", "procedures", as_text, false, 110);
  filter_atlas_handler["beh_procedures"].filter->AddColumnSpec("Type of Service", "procedures", as_text, false, 110);
  filter_atlas_handler["beh_procedures"].filter->AddColumnSpec("Cpt/Hcpcs Code", "procedures", as_text, true, 110);
  filter_atlas_handler["beh_procedures"].filter->AddColumnSpec("Modifier", "procedures", as_text, false, 110);
  filter_atlas_handler["beh_procedures"].filter->AddColumnSpec("Charges", "procedures", as_double, true, 90, amountString);
  filter_atlas_handler["beh_procedures"].filter->AddColumnSpec("Days/Units", "procedures", as_int, false, 100);
  filter_atlas_handler["beh_procedures"].filter->AddColumnSpec("EPSDT", "procedures", as_text, false, 90);
  filter_atlas_handler["beh_procedures"].filter->AddColumnSpec("EMG", "procedures", as_text, false, 90);
  filter_atlas_handler["beh_procedures"].filter->AddColumnSpec("COB", "procedures", as_text, false, 90);
  filter_atlas_handler["beh_procedures"].filter->AddColumnSpec("Local Use", "procedures", as_text, false, 100);
  filter_atlas_handler["beh_procedures"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["beh_procedures"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["beh_procedures"].filter->FetchPreferences("recordperson.beh_procedures_filter");
  filter_atlas_handler["beh_procedures"].filter->SetIconStatus(true);
  filter_atlas_handler["beh_procedures"].filter->SetSQLStatement("");
  filter_atlas_handler["beh_procedures"].filter->RefreshDataSet();

  filter_atlas_handler["community_visit"].filter->SetListViewHandle (listComVisit);
  filter_atlas_handler["community_visit"].filter->SetSecurity ("tasks");
  filter_atlas_handler["community_visit"].filter->AddColumnSpec("Date", "tasks", as_date, true, 120);
  filter_atlas_handler["community_visit"].filter->AddColumnSpec("Staff", "tasks", as_text, true, 120);
  filter_atlas_handler["community_visit"].filter->AddColumnSpec("Type", "tasks", as_text, true, 100);
  filter_atlas_handler["community_visit"].filter->AddColumnSpec("Location", "tasks", as_text, true, 140);
  filter_atlas_handler["community_visit"].filter->AddColumnSpec("Outcome", "tasks", as_text, true, 120);
  filter_atlas_handler["community_visit"].filter->AddColumnSpec("Mileage", "tasks", as_double, true, 120);
  filter_atlas_handler["community_visit"].filter->AddColumnSpec("Length", "tasks", as_double, true, 120);
  filter_atlas_handler["community_visit"].filter->AddColumnSpec("Form", "tasks", as_text, false, 50);
  filter_atlas_handler["community_visit"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["community_visit"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["community_visit"].filter->FetchPreferences("recordperson.community_visit_filter");
  filter_atlas_handler["community_visit"].filter->SetSQLStatement("");
  filter_atlas_handler["community_visit"].filter->RefreshDataSet();

  filter_atlas_handler["community_comments"].filter->SetListViewHandle (listComComments);
  filter_atlas_handler["community_comments"].filter->SetSecurity("task_notes.com");
  filter_atlas_handler["community_comments"].filter->AddColumnSpec("Notes", "task_notes", as_text, true, 300, sentenceString);
  filter_atlas_handler["community_comments"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["community_comments"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["community_comments"].filter->FetchPreferences("recordperson.community_comments_filter");
  filter_atlas_handler["community_comments"].filter->SetSQLStatement("");
  filter_atlas_handler["community_comments"].filter->RefreshDataSet();


  filter_atlas_handler["community_conditions"].filter->SetListViewHandle(listComCondition);
  filter_atlas_handler["community_conditions"].filter->SetSecurity("conditions.com");
  filter_atlas_handler["community_conditions"].filter->AddColumnSpec("Condition Type", "conditions", as_text, true, 120);
  filter_atlas_handler["community_conditions"].filter->AddColumnSpec("Begin", "conditions", as_date, false, 100);
  filter_atlas_handler["community_conditions"].filter->AddColumnSpec("End", "conditions", as_date, false, 100);
  filter_atlas_handler["community_conditions"].filter->AddColumnSpec("Code", "conditions", as_text, true, 100);
  filter_atlas_handler["community_conditions"].filter->AddColumnSpec("Note", "conditions", as_text, false, 100, sentenceString);
  filter_atlas_handler["community_conditions"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["community_conditions"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["community_conditions"].filter->SetIconStatus(true);
  filter_atlas_handler["community_conditions"].filter->FetchPreferences("recordperson.community_conditions_filter");
  filter_atlas_handler["community_conditions"].filter->SetSQLStatement("");
  filter_atlas_handler["community_conditions"].filter->RefreshDataSet();

  filter_atlas_handler["community_edu"].filter->SetListViewHandle(listComEducation);
  filter_atlas_handler["community_edu"].filter->SetSecurity("com_health_edu");
  filter_atlas_handler["community_edu"].filter->AddColumnSpec("Topic", "com_health_edu", as_text, true, 80);
  filter_atlas_handler["community_edu"].filter->AddColumnSpec("Learner", "com_health_edu", as_text, true,80);
  filter_atlas_handler["community_edu"].filter->AddColumnSpec("Method", "com_health_edu",as_text,true,80);
  filter_atlas_handler["community_edu"].filter->AddColumnSpec("Evaluation", "com_health_edu", as_text, true, 80);
  filter_atlas_handler["community_edu"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["community_edu"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["community_edu"].filter->FetchPreferences("recordperson.community_edu_filter");
  filter_atlas_handler["community_edu"].filter->SetSQLStatement("");
  filter_atlas_handler["community_edu"].filter->RefreshDataSet();

  filter_atlas_handler["community_nutrition"].filter->SetListViewHandle(listComNutrition);
  filter_atlas_handler["community_nutrition"].filter->SetSecurity("com_nutrition");
  filter_atlas_handler["community_nutrition"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["community_nutrition"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["community_nutrition"].filter->AddColumnSpec("Method", "com_nutrition", as_text, true, 120);
  filter_atlas_handler["community_nutrition"].filter->AddColumnSpec("Formula", "com_nutrition", as_text, true, 120);
  filter_atlas_handler["community_nutrition"].filter->AddColumnSpec("Ingredients", "com_nutrition", as_int, true, 120);
  filter_atlas_handler["community_nutrition"].filter->AddColumnSpec("Number of Feedings", "com_nutrition", as_text, true, 120);
  filter_atlas_handler["community_nutrition"].filter->AddColumnSpec("Feeding Time", "com_nutrition", as_text, true, 120);
  filter_atlas_handler["community_nutrition"].filter->AddColumnSpec("Amount (oz)", "com_nutrition", as_int, true, 80);
  filter_atlas_handler["community_nutrition"].filter->AddColumnSpec("Number of Stools", "com_nutrition", as_int, false, 80);
  filter_atlas_handler["community_nutrition"].filter->AddColumnSpec("Feeding Observed", "com_nutrition", as_text,true, 80);
  filter_atlas_handler["community_nutrition"].filter->AddColumnSpec("Diaper Number", "com_nutrition", as_text, false, 80);
  filter_atlas_handler["community_nutrition"].filter->AddColumnSpec("Task_id", "com_nutrition", as_text, false, 80);
  filter_atlas_handler["community_nutrition"].filter->FetchPreferences("recordperson.community_nutrition_filter");
  filter_atlas_handler["community_nutrition"].filter->SetSQLStatement("");
  filter_atlas_handler["community_nutrition"].filter->RefreshDataSet();

  filter_atlas_handler["community_drug"].filter->SetListViewHandle(listComDrug);
  filter_atlas_handler["community_drug"].filter->SetSecurity("com_drug_regimen");
  filter_atlas_handler["community_drug"].filter->AddColumnSpec("Medication", "com_drug_regimen", as_text, true, 100);
  filter_atlas_handler["community_drug"].filter->AddColumnSpec("Dosage", "com_drug_regimen", as_text, true, 80, lowercaseString);
  filter_atlas_handler["community_drug"].filter->AddColumnSpec("Medication Type", "com_drug_regimen", as_text, true, 100);
  filter_atlas_handler["community_drug"].filter->AddColumnSpec("Frequency", "com_drug_regimen", as_text, true, 100);
  filter_atlas_handler["community_drug"].filter->AddColumnSpec("RX Number", "com_drug_regimen", as_text, true, 80);
  filter_atlas_handler["community_drug"].filter->AddColumnSpec("Status", "com_drug_regimen", as_text, true, 80);
  filter_atlas_handler["community_drug"].filter->AddColumnSpec("Person Id", "com_drug_regimen", as_int, false, 80);
  filter_atlas_handler["community_drug"].filter->AddColumnSpec("Date Ordered", "com_drug_regimen", as_date, true, 80);
  filter_atlas_handler["community_drug"].filter->AddColumnSpec("Date Discontinued", "com_drug_regimen", as_date, true, 80);
  filter_atlas_handler["community_drug"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["community_drug"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["community_drug"].filter->FetchPreferences("recordperson.community_drug_filter");
  filter_atlas_handler["community_drug"].filter->SetSQLStatement("");
  filter_atlas_handler["community_drug"].filter->RefreshDataSet();

  filter_atlas_handler["community_task"].filter->SetListViewHandle(listComTask);
  filter_atlas_handler["community_task"].filter->SetSecurity("tasks.com");
  filter_atlas_handler["community_task"].filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  filter_atlas_handler["community_task"].filter->AddColumnSpec("Staff", "tasks", as_text, true, 110);
  filter_atlas_handler["community_task"].filter->AddColumnSpec("Event", "events", as_text, false, 110, rawString);
  filter_atlas_handler["community_task"].filter->AddColumnSpec("Time Spent", "tasks", as_double, true, 100);
  filter_atlas_handler["community_task"].filter->AddColumnSpec("Mileage", "tasks", as_double, false, 80);
  filter_atlas_handler["community_task"].filter->AddColumnSpec("Method of Contact", "tasks", as_text, true, 130);
  filter_atlas_handler["community_task"].filter->AddColumnSpec("In/Out", "tasks", as_text, true, 80);
  filter_atlas_handler["community_task"].filter->AddColumnSpec("Task Type", "tasks", as_text, false, 120);
  filter_atlas_handler["community_task"].filter->AddColumnSpec("Classification", "tasks", as_text, false, 110);
  filter_atlas_handler["community_task"].filter->AddColumnSpec("Meeting Type", "tasks", as_text, false, 110);
  filter_atlas_handler["community_task"].filter->AddColumnSpec("Activity Type", "tasks", as_text, true, 110);
  filter_atlas_handler["community_task"].filter->AddColumnSpec("Task Comments", "tasks", as_text, false, 150, sentenceString);
  filter_atlas_handler["community_task"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["community_task"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["community_task"].filter->FetchPreferences("recordperson.community_task_filter");
  filter_atlas_handler["community_task"].filter->SetSQLStatement("");
  filter_atlas_handler["community_task"].filter->RefreshDataSet();

  filter_atlas_handler["community_assessment"].filter->SetListViewHandle(listComAssessment);
  filter_atlas_handler["community_assessment"].filter->SetSecurity("patient_assessment");
  filter_atlas_handler["community_assessment"].filter->AddColumnSpec("Name",        "person_names", as_text, true, 120);
  filter_atlas_handler["community_assessment"].filter->AddColumnSpec("Date",        "tasks",        as_date, true,  80);
  filter_atlas_handler["community_assessment"].filter->AddColumnSpec("Current Id",  "current_id",   as_int,  false, 80);
  filter_atlas_handler["community_assessment"].filter->AddColumnSpec("Internal Id", "internal_id",  as_int,  false, 80);
  filter_atlas_handler["community_assessment"].filter->FetchPreferences("recordperson.community_assessment_filter");
  filter_atlas_handler["community_assessment"].filter->SetIconStatus(true);
  filter_atlas_handler["community_assessment"].filter->SetSQLStatement("");
  filter_atlas_handler["community_assessment"].filter->RefreshDataSet();

  filter_atlas_handler["community_event"].filter->SetListViewHandle(listComEvents);
  filter_atlas_handler["community_event"].filter->SetSecurity("participations");
  filter_atlas_handler["community_event"].filter->AddColumnSpec("Date", "events", as_date, true, 80);
  filter_atlas_handler["community_event"].filter->AddColumnSpec("Event Name", "events", as_text, true, 100, rawString);
  filter_atlas_handler["community_event"].filter->AddColumnSpec("Event Type", "events", as_text, true, 100, rawString);
  filter_atlas_handler["community_event"].filter->AddColumnSpec("Location", "events", as_text, true, 160, rawString);
  filter_atlas_handler["community_event"].filter->AddColumnSpec("Attendance", "events", as_text, false, 100);
  filter_atlas_handler["community_event"].filter->AddColumnSpec("Description", "events", as_text, false, 140, sentenceString);
  filter_atlas_handler["community_event"].filter->AddColumnSpec("Note", "participations", as_text, false, 130);
  filter_atlas_handler["community_event"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["community_event"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["community_event"].filter->FetchPreferences("recordperson.community_event_filter");
  filter_atlas_handler["community_event"].filter->SetIconStatus(true);
  filter_atlas_handler["community_event"].filter->SetSQLStatement("");
  filter_atlas_handler["community_event"].filter->RefreshDataSet();

  //public health

  filter_atlas_handler["public_visit"].filter->SetListViewHandle (listPublicVisit);
  filter_atlas_handler["public_visit"].filter->SetSecurity ("tasks.pub");
  filter_atlas_handler["public_visit"].filter->AddColumnSpec("Date", "tasks", as_date, true, 120);
  filter_atlas_handler["public_visit"].filter->AddColumnSpec("Staff", "tasks", as_text, true, 120);
  filter_atlas_handler["public_visit"].filter->AddColumnSpec("Type", "tasks", as_text, true,100);
  filter_atlas_handler["public_visit"].filter->AddColumnSpec("Location", "tasks", as_text, true, 140);
  filter_atlas_handler["public_visit"].filter->AddColumnSpec("Outcome", "tasks", as_text, true, 120);
  filter_atlas_handler["public_visit"].filter->AddColumnSpec("Mileage", "tasks", as_double, true, 120);
  filter_atlas_handler["public_visit"].filter->AddColumnSpec("Length", "tasks", as_double, true, 120);
  filter_atlas_handler["public_visit"].filter->AddColumnSpec("Form", "tasks", as_text, false, 50);
  filter_atlas_handler["public_visit"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["public_visit"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["public_visit"].filter->FetchPreferences("recordperson.public_visit_filter");
  filter_atlas_handler["public_visit"].filter->SetSQLStatement("");
  filter_atlas_handler["public_visit"].filter->RefreshDataSet();

  filter_atlas_handler["public_comments"].filter->SetListViewHandle (listPublicComments);
  filter_atlas_handler["public_comments"].filter->SetSecurity("task_notes.pub");
  filter_atlas_handler["public_comments"].filter->AddColumnSpec("Notes", "task_notes", as_text, true, 300, sentenceString);
  filter_atlas_handler["public_comments"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["public_comments"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["public_comments"].filter->FetchPreferences("recordperson.public_comments_filter");
  filter_atlas_handler["public_comments"].filter->SetSQLStatement("");
  filter_atlas_handler["public_comments"].filter->RefreshDataSet();

  filter_atlas_handler["public_conditions"].filter->SetListViewHandle(listPublicConditions);
  filter_atlas_handler["public_conditions"].filter->SetSecurity("conditions.pub");
  filter_atlas_handler["public_conditions"].filter->AddColumnSpec("Condition Type", "conditions", as_text, true, 120);
  filter_atlas_handler["public_conditions"].filter->AddColumnSpec("Begin", "conditions", as_date, false, 100);
  filter_atlas_handler["public_conditions"].filter->AddColumnSpec("End", "conditions", as_date, false, 100);
  filter_atlas_handler["public_conditions"].filter->AddColumnSpec("Code", "conditions", as_text, true, 100);
  filter_atlas_handler["public_conditions"].filter->AddColumnSpec("Note", "conditions", as_text, false, 100, sentenceString);
  filter_atlas_handler["public_conditions"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["public_conditions"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["public_conditions"].filter->SetIconStatus(true);
  filter_atlas_handler["public_conditions"].filter->FetchPreferences("recordperson.public_conditions_filter");
  filter_atlas_handler["public_conditions"].filter->SetSQLStatement("");
  filter_atlas_handler["public_conditions"].filter->RefreshDataSet();

  filter_atlas_handler["public_edu"].filter->SetListViewHandle(listPublicEdu);
  filter_atlas_handler["public_edu"].filter->SetSecurity("com_health_edu");
  filter_atlas_handler["public_edu"].filter->AddColumnSpec("Topic", "com_health_edu", as_text, true, 80);
  filter_atlas_handler["public_edu"].filter->AddColumnSpec("Learner", "com_health_edu", as_text, true,80);
  filter_atlas_handler["public_edu"].filter->AddColumnSpec("Method", "com_health_edu",as_text,true,80);
  filter_atlas_handler["public_edu"].filter->AddColumnSpec("Evaluation", "com_health_edu", as_text, true, 80);
  filter_atlas_handler["public_edu"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["public_edu"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["public_edu"].filter->FetchPreferences("recordperson.public_edu_filter");
  filter_atlas_handler["public_edu"].filter->SetSQLStatement("");
  filter_atlas_handler["public_edu"].filter->RefreshDataSet();

  filter_atlas_handler["public_nutrition"].filter->SetListViewHandle(listPublicNutrition);
  filter_atlas_handler["public_nutrition"].filter->SetSecurity("com_nutrition");
  filter_atlas_handler["public_nutrition"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["public_nutrition"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["public_nutrition"].filter->AddColumnSpec("Method", "com_nutrition", as_text, true, 120);
  filter_atlas_handler["public_nutrition"].filter->AddColumnSpec("Formula", "com_nutrition", as_text, true, 120);
  filter_atlas_handler["public_nutrition"].filter->AddColumnSpec("Ingredients", "com_nutrition", as_int, true, 120);
  filter_atlas_handler["public_nutrition"].filter->AddColumnSpec("Number of Feedings", "com_nutrition", as_text, true, 120);
  filter_atlas_handler["public_nutrition"].filter->AddColumnSpec("Feeding Time", "com_nutrition", as_text, true, 120);
  filter_atlas_handler["public_nutrition"].filter->AddColumnSpec("Amount (oz)", "com_nutrition", as_int, true, 80);
  filter_atlas_handler["public_nutrition"].filter->AddColumnSpec("Number of Stools", "com_nutrition", as_int, false, 80);
  filter_atlas_handler["public_nutrition"].filter->AddColumnSpec("Feeding Observed", "com_nutrition", as_text,true, 80);
  filter_atlas_handler["public_nutrition"].filter->AddColumnSpec("Diaper Number", "com_nutrition", as_text, false, 80);
  filter_atlas_handler["public_nutrition"].filter->AddColumnSpec("Task_id", "com_nutrition", as_text, false, 80);
  filter_atlas_handler["public_nutrition"].filter->FetchPreferences("recordperson.public_nutrition_filter");
  filter_atlas_handler["public_nutrition"].filter->SetSQLStatement("");
  filter_atlas_handler["public_nutrition"].filter->RefreshDataSet();


  filter_atlas_handler["public_drug"].filter->SetListViewHandle(listPublicDrug);
  filter_atlas_handler["public_drug"].filter->SetSecurity("com_drug_regimen");
  filter_atlas_handler["public_drug"].filter->AddColumnSpec("Medication", "com_drug_regimen", as_text, true, 100);
  filter_atlas_handler["public_drug"].filter->AddColumnSpec("Dose", "com_drug_regimen", as_int, true, 80);
  filter_atlas_handler["public_drug"].filter->AddColumnSpec("Medication Type", "com_drug_regimen", as_text, true, 100);
  filter_atlas_handler["public_drug"].filter->AddColumnSpec("Frequency", "com_drug_regimen", as_text, true, 100);
  filter_atlas_handler["public_drug"].filter->AddColumnSpec("RX Number", "com_drug_regimen", as_text, true, 80);
  filter_atlas_handler["public_drug"].filter->AddColumnSpec("Status", "com_drug_regimen", as_text, true, 80);
  filter_atlas_handler["public_drug"].filter->AddColumnSpec("Person Id", "com_drug_regimen", as_int, false, 80);
  filter_atlas_handler["public_drug"].filter->AddColumnSpec("Date Ordered", "com_drug_regimen", as_date, true, 80);
  filter_atlas_handler["public_drug"].filter->AddColumnSpec("Date Discontinued", "com_drug_regimen", as_date, true, 80);
  filter_atlas_handler["public_drug"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["public_drug"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["public_drug"].filter->FetchPreferences("recordperson.public_drug_filter");
  filter_atlas_handler["public_drug"].filter->SetSQLStatement("");
  filter_atlas_handler["public_drug"].filter->RefreshDataSet();


  filter_atlas_handler["public_task"].filter->SetListViewHandle(listPublicTask);
  filter_atlas_handler["public_task"].filter->SetSecurity("tasks.pub");
  filter_atlas_handler["public_task"].filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  filter_atlas_handler["public_task"].filter->AddColumnSpec("Staff", "tasks", as_text, true, 110);
  filter_atlas_handler["public_task"].filter->AddColumnSpec("Event", "events", as_text, false, 110, rawString);
  filter_atlas_handler["public_task"].filter->AddColumnSpec("Time Spent", "tasks", as_double, true, 100);
  filter_atlas_handler["public_task"].filter->AddColumnSpec("Mileage", "tasks", as_double, false, 80);
  filter_atlas_handler["public_task"].filter->AddColumnSpec("Method of Contact", "tasks", as_text, true, 130);
  filter_atlas_handler["public_task"].filter->AddColumnSpec("In/Out", "tasks", as_text, true, 80);
  filter_atlas_handler["public_task"].filter->AddColumnSpec("Task Type", "tasks", as_text, false, 120);
  filter_atlas_handler["public_task"].filter->AddColumnSpec("Classification", "tasks", as_text, false, 110);
  filter_atlas_handler["public_task"].filter->AddColumnSpec("Meeting Type", "tasks", as_text, false, 110);
  filter_atlas_handler["public_task"].filter->AddColumnSpec("Activity Type", "tasks", as_text, true, 110);
  filter_atlas_handler["public_task"].filter->AddColumnSpec("Task Comments", "tasks", as_text, false, 150, sentenceString);
  filter_atlas_handler["public_task"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["public_task"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["public_task"].filter->FetchPreferences("recordperson.public_task_filter");
  filter_atlas_handler["public_task"].filter->SetSQLStatement("");
  filter_atlas_handler["public_task"].filter->RefreshDataSet();

  filter_atlas_handler["public_event"].filter->SetListViewHandle(listPublicEvents);
  filter_atlas_handler["public_event"].filter->SetSecurity("participations");
  filter_atlas_handler["public_event"].filter->AddColumnSpec("Date", "events", as_date, true, 80);
  filter_atlas_handler["public_event"].filter->AddColumnSpec("Event Name", "events", as_text, true, 100, rawString);
  filter_atlas_handler["public_event"].filter->AddColumnSpec("Event Type", "events", as_text, true, 130, rawString);
  filter_atlas_handler["public_event"].filter->AddColumnSpec("Location", "events", as_text, true, 160, rawString);
  filter_atlas_handler["public_event"].filter->AddColumnSpec("Attendance", "events", as_text, false, 100);
  filter_atlas_handler["public_event"].filter->AddColumnSpec("Description", "events", as_text, false, 140, sentenceString);
  filter_atlas_handler["public_event"].filter->AddColumnSpec("Note", "participations", as_text, false, 130);
  filter_atlas_handler["public_event"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["public_event"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["public_event"].filter->FetchPreferences("recordperson.public_event_filter");
  filter_atlas_handler["public_event"].filter->SetIconStatus(true);
  filter_atlas_handler["public_event"].filter->SetSQLStatement("");
  filter_atlas_handler["public_event"].filter->RefreshDataSet();

  filter_atlas_handler["common_notes"].filter->SetListViewHandle (listCommonPersonNotes);
  filter_atlas_handler["common_notes"].filter->SetSecurity("person_notes.common");
  filter_atlas_handler["common_notes"].filter->AddColumnSpec("Date", "person_notes", as_date, true, 80);
  filter_atlas_handler["common_notes"].filter->AddColumnSpec("Note", "person_notes", as_text, true, 210, sentenceString);
  filter_atlas_handler["common_notes"].filter->AddColumnSpec("Warning", "person_notes", as_text, true, 80, prettyString);
  filter_atlas_handler["common_notes"].filter->AddColumnSpec("Dept.", "person_notes", as_text, true, 100);
  filter_atlas_handler["common_notes"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["common_notes"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["common_notes"].filter->FetchPreferences("recordperson.common_notes_filter");
  filter_atlas_handler["common_notes"].filter->SetIconStatus(true);
  filter_atlas_handler["common_notes"].filter->SetSQLStatement("");
  filter_atlas_handler["common_notes"].filter->RefreshDataSet();

  filter_atlas_handler["charts"].filter->SetListViewHandle (listCharts);
  filter_atlas_handler["charts"].filter->SetSecurity("charts");
  filter_atlas_handler["charts"].filter->AddColumnSpec("Location", "charts", as_text, true, 95);
  filter_atlas_handler["charts"].filter->AddColumnSpec("Chart Number", "charts", as_text, true, 80);
  filter_atlas_handler["charts"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["charts"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["charts"].filter->FetchPreferences("recordperson.charts_filter");
  filter_atlas_handler["charts"].filter->SetIconStatus(true);
  filter_atlas_handler["charts"].filter->SetSQLStatement("");
  filter_atlas_handler["charts"].filter->RefreshDataSet();

  filter_atlas_handler["relationships"].filter->SetListViewHandle (listRelationships);
  filter_atlas_handler["relationships"].filter->SetSecurity("relationships");
  filter_atlas_handler["relationships"].filter->AddColumnSpec("Name", "relationships", as_text, true, 150, prettyString);
  filter_atlas_handler["relationships"].filter->AddColumnSpec("Relationship", "relationships", as_text, true, 80, prettyString);
  filter_atlas_handler["relationships"].filter->AddColumnSpec("Same Household", "relationships", as_text, true, 100, prettyBoolString);
  filter_atlas_handler["relationships"].filter->AddColumnSpec("Emergency", "relationships", as_text, true, 60, prettyBoolString);
  filter_atlas_handler["relationships"].filter->AddColumnSpec("Emergency (I am)", "relationships", as_text, false, 60, prettyBoolString);
  filter_atlas_handler["relationships"].filter->AddColumnSpec("Banned", "relationships", as_text, true, 60, prettyBoolString);
  filter_atlas_handler["relationships"].filter->AddColumnSpec("Banned (I am)", "relationships", as_text, false, 60, prettyBoolString);
  filter_atlas_handler["relationships"].filter->AddColumnSpec("Responsible", "relationships", as_text, true, 60, prettyBoolString);
  filter_atlas_handler["relationships"].filter->AddColumnSpec("Responsible (I am)", "relationships", as_text, false, 60, prettyBoolString);
  filter_atlas_handler["relationships"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["relationships"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["relationships"].filter->FetchPreferences("recordperson.relationships_filter");
  filter_atlas_handler["relationships"].filter->SetIconStatus(true);
  filter_atlas_handler["relationships"].filter->SetSQLStatement("");
  filter_atlas_handler["relationships"].filter->RefreshDataSet();

  filter_atlas_handler["lac_notes"].filter->SetListViewHandle (listLacComments);
  filter_atlas_handler["lac_notes"].filter->SetSecurity("person_notes.lac");
  filter_atlas_handler["lac_notes"].filter->AddColumnSpec("Clinic", "person_notes", as_text, true, 100);
  filter_atlas_handler["lac_notes"].filter->AddColumnSpec("Date", "person_notes", as_date, true, 80);
  filter_atlas_handler["lac_notes"].filter->AddColumnSpec("Note", "person_notes", as_text, true, 270, sentenceString);
  filter_atlas_handler["lac_notes"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["lac_notes"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["lac_notes"].filter->FetchPreferences("recordperson.lac_notes_filter");
  filter_atlas_handler["lac_notes"].filter->SetIconStatus(true);
  filter_atlas_handler["lac_notes"].filter->SetSQLStatement("");
  filter_atlas_handler["lac_notes"].filter->RefreshDataSet();

  filter_atlas_handler["lac_tasks"].filter->SetListViewHandle(listLacTasks);
  filter_atlas_handler["lac_tasks"].filter->SetSecurity("tasks.lac");
  filter_atlas_handler["lac_tasks"].filter->AddColumnSpec("Clinic", "tasks", as_text, true, 100);
  filter_atlas_handler["lac_tasks"].filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  filter_atlas_handler["lac_tasks"].filter->AddColumnSpec("Time", "tasks", as_time, true, 80);
  filter_atlas_handler["lac_tasks"].filter->AddColumnSpec("Provider", "tasks", as_text, true, 110, rawString);
  filter_atlas_handler["lac_tasks"].filter->AddColumnSpec("Task Type", "tasks", as_text, false, 120);
  filter_atlas_handler["lac_tasks"].filter->AddColumnSpec("Time Spent", "tasks", as_double, false, 100);
  filter_atlas_handler["lac_tasks"].filter->AddColumnSpec("New Patient", "tasks", as_int, false, 100, prettyBoolString);
  filter_atlas_handler["lac_tasks"].filter->AddColumnSpec("Comments", "tasks", as_text, false, 150, sentenceString);
  filter_atlas_handler["lac_tasks"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["lac_tasks"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["lac_tasks"].filter->FetchPreferences("recordperson.lac_tasks_filter");
  filter_atlas_handler["lac_tasks"].filter->SetIconStatus(true);
  filter_atlas_handler["lac_tasks"].filter->SetSQLStatement("");
  filter_atlas_handler["lac_tasks"].filter->RefreshDataSet();

  filter_atlas_handler["lac_procedures"].filter->SetListViewHandle (listLacProcedures);
  filter_atlas_handler["lac_procedures"].filter->SetSecurity("procedures");
  filter_atlas_handler["lac_procedures"].filter->AddColumnSpec("Clinic", "procedures", as_text, true, 100);
  filter_atlas_handler["lac_procedures"].filter->AddColumnSpec("Start Date", "procedures", as_date, true, 100);
  filter_atlas_handler["lac_procedures"].filter->AddColumnSpec("Stop Date", "procedures", as_date, false, 100);
  filter_atlas_handler["lac_procedures"].filter->AddColumnSpec("Place of Service", "procedures", as_text, false, 110);
  filter_atlas_handler["lac_procedures"].filter->AddColumnSpec("Type of Service", "procedures", as_text, false, 110);
  filter_atlas_handler["lac_procedures"].filter->AddColumnSpec("Cpt/Hcpcs Code", "procedures", as_text, true, 110);
  filter_atlas_handler["lac_procedures"].filter->AddColumnSpec("Modifier", "procedures", as_text, false, 110);
  filter_atlas_handler["lac_procedures"].filter->AddColumnSpec("Charges", "procedures", as_double, true, 90, amountString);
  filter_atlas_handler["lac_procedures"].filter->AddColumnSpec("Days/Units", "procedures", as_int, false, 100);
  filter_atlas_handler["lac_procedures"].filter->AddColumnSpec("EPSDT", "procedures", as_text, false, 90);
  filter_atlas_handler["lac_procedures"].filter->AddColumnSpec("EMG", "procedures", as_text, false, 90);
  filter_atlas_handler["lac_procedures"].filter->AddColumnSpec("COB", "procedures", as_text, false, 90);
  filter_atlas_handler["lac_procedures"].filter->AddColumnSpec("Local Use", "procedures", as_text, false, 100);
  filter_atlas_handler["lac_procedures"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["lac_procedures"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["lac_procedures"].filter->FetchPreferences("recordperson.lac_procedures_filter");
  filter_atlas_handler["lac_procedures"].filter->SetIconStatus(true);
  filter_atlas_handler["lac_procedures"].filter->SetSQLStatement("");
  filter_atlas_handler["lac_procedures"].filter->RefreshDataSet();

  // jhaley 20100812: clinic events filter
  filter_atlas_handler["lac_event"].filter->SetListViewHandle(listClinicEvents);
  filter_atlas_handler["lac_event"].filter->SetSecurity("participations");
  filter_atlas_handler["lac_event"].filter->AddColumnSpec("Date", "events", as_date, true, 80);
  filter_atlas_handler["lac_event"].filter->AddColumnSpec("Event Name", "events", as_text, true, 100, rawString);
  filter_atlas_handler["lac_event"].filter->AddColumnSpec("Event Type", "events", as_text, true, 110, rawString);
  filter_atlas_handler["lac_event"].filter->AddColumnSpec("Location", "events", as_text, true, 160, rawString);
  filter_atlas_handler["lac_event"].filter->AddColumnSpec("Attendance", "events", as_text, false, 100);
  filter_atlas_handler["lac_event"].filter->AddColumnSpec("Description", "events", as_text, false, 140, sentenceString);
  filter_atlas_handler["lac_event"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["lac_event"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["lac_event"].filter->FetchPreferences("recordperson.lac_event_filter");
  filter_atlas_handler["lac_event"].filter->SetIconStatus(true);
  filter_atlas_handler["lac_event"].filter->SetSQLStatement("");
  filter_atlas_handler["lac_event"].filter->RefreshDataSet();

  filter_atlas_handler["den_notes"].filter->SetListViewHandle (listDenComments);
  filter_atlas_handler["den_notes"].filter->SetSecurity("person_notes.den");
  filter_atlas_handler["den_notes"].filter->AddColumnSpec("Date", "person_notes", as_date, true, 80);
  filter_atlas_handler["den_notes"].filter->AddColumnSpec("Note", "person_notes", as_text, true, 270, sentenceString);
  filter_atlas_handler["den_notes"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["den_notes"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["den_notes"].filter->FetchPreferences("recordperson.den_notes_filter");
  filter_atlas_handler["den_notes"].filter->SetIconStatus(true);
  filter_atlas_handler["den_notes"].filter->SetSQLStatement("");
  filter_atlas_handler["den_notes"].filter->RefreshDataSet();

  filter_atlas_handler["den_tasks"].filter->SetListViewHandle(listDenTasks);
  filter_atlas_handler["den_tasks"].filter->SetSecurity("tasks.den");
  filter_atlas_handler["den_tasks"].filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  filter_atlas_handler["den_tasks"].filter->AddColumnSpec("Time", "tasks", as_time, true, 80);
  filter_atlas_handler["den_tasks"].filter->AddColumnSpec("Provider", "tasks", as_text, true, 110, rawString);
  filter_atlas_handler["den_tasks"].filter->AddColumnSpec("Task Type", "tasks", as_text, false, 120);
  filter_atlas_handler["den_tasks"].filter->AddColumnSpec("Time Spent", "tasks", as_double, false, 100);
  filter_atlas_handler["den_tasks"].filter->AddColumnSpec("New Patient", "tasks", as_int, false, 100, prettyBoolString);
  filter_atlas_handler["den_tasks"].filter->AddColumnSpec("Comments", "tasks", as_text, false, 150, sentenceString);
  filter_atlas_handler["den_tasks"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["den_tasks"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["den_tasks"].filter->FetchPreferences("recordperson.den_tasks_filter");
  filter_atlas_handler["den_tasks"].filter->SetIconStatus(true);
  filter_atlas_handler["den_tasks"].filter->SetSQLStatement("");
  filter_atlas_handler["den_tasks"].filter->RefreshDataSet();

  filter_atlas_handler["den_procedures"].filter->SetListViewHandle (listDenProcedures);
  filter_atlas_handler["den_procedures"].filter->SetSecurity("procedures");
  filter_atlas_handler["den_procedures"].filter->AddColumnSpec("Start Date", "procedures", as_date, true, 100);
  filter_atlas_handler["den_procedures"].filter->AddColumnSpec("Stop Date", "procedures", as_date, false, 100);
  filter_atlas_handler["den_procedures"].filter->AddColumnSpec("Place of Service", "procedures", as_text, false, 110);
  filter_atlas_handler["den_procedures"].filter->AddColumnSpec("Type of Service", "procedures", as_text, false, 110);
  filter_atlas_handler["den_procedures"].filter->AddColumnSpec("Cpt/Hcpcs Code", "procedures", as_text, true, 110);
  filter_atlas_handler["den_procedures"].filter->AddColumnSpec("Modifier", "procedures", as_text, false, 110);
  filter_atlas_handler["den_procedures"].filter->AddColumnSpec("Charges", "procedures", as_double, true, 90, amountString);
  filter_atlas_handler["den_procedures"].filter->AddColumnSpec("Days/Units", "procedures", as_int, false, 100);
  filter_atlas_handler["den_procedures"].filter->AddColumnSpec("EPSDT", "procedures", as_text, false, 90);
  filter_atlas_handler["den_procedures"].filter->AddColumnSpec("EMG", "procedures", as_text, false, 90);
  filter_atlas_handler["den_procedures"].filter->AddColumnSpec("COB", "procedures", as_text, false, 90);
  filter_atlas_handler["den_procedures"].filter->AddColumnSpec("Local Use", "procedures", as_text, false, 100);
  filter_atlas_handler["den_procedures"].filter->AddColumnSpec("Tooth Position", "procedures", as_text, false, 50);
  filter_atlas_handler["den_procedures"].filter->AddColumnSpec("Tooth Surface", "procedures", as_text, false, 75);
  filter_atlas_handler["den_procedures"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["den_procedures"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["den_procedures"].filter->FetchPreferences("recordperson.den_procedures_filter");
  filter_atlas_handler["den_procedures"].filter->SetIconStatus(true);
  filter_atlas_handler["den_procedures"].filter->SetSQLStatement("");
  filter_atlas_handler["den_procedures"].filter->RefreshDataSet();

  filter_atlas_handler["den_bills"].filter->SetListViewHandle(listDentalBills);
  filter_atlas_handler["den_bills"].filter->SetSecurity("bills.outgoing.den");
  filter_atlas_handler["den_bills"].filter->AddColumnSpec("Date Billed", "bills", as_date, true, 120);
  filter_atlas_handler["den_bills"].filter->AddColumnSpec("Provider", "tax_entities", as_text, true, 150, rawString);
  filter_atlas_handler["den_bills"].filter->AddColumnSpec("Facility", "tax_entities", as_text, true, 150, rawString);
  filter_atlas_handler["den_bills"].filter->AddColumnSpec("Invoice Amount", "bills", as_double, true, 110, amountString);
  filter_atlas_handler["den_bills"].filter->AddColumnSpec("Total Amount", "bills", as_double, true, 110, amountString);
  filter_atlas_handler["den_bills"].filter->AddColumnSpec("Paid Amount", "bills", as_double, true, 110, amountString);
  filter_atlas_handler["den_bills"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["den_bills"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["den_bills"].filter->FetchPreferences("recordperson.den_bills_filter");
  filter_atlas_handler["den_bills"].filter->SetSQLStatement("");
  filter_atlas_handler["den_bills"].filter->RefreshDataSet();

  // jhaley 20100812: dental events filter
  filter_atlas_handler["den_event"].filter->SetListViewHandle(listDentalEvents);
  filter_atlas_handler["den_event"].filter->SetSecurity("participations");
  filter_atlas_handler["den_event"].filter->AddColumnSpec("Date", "events", as_date, true, 80);
  filter_atlas_handler["den_event"].filter->AddColumnSpec("Event Name", "events", as_text, true, 100, rawString);
  filter_atlas_handler["den_event"].filter->AddColumnSpec("Event Type", "events", as_text, true, 110, rawString);
  filter_atlas_handler["den_event"].filter->AddColumnSpec("Location", "events", as_text, true, 160, rawString);
  filter_atlas_handler["den_event"].filter->AddColumnSpec("Attendance", "events", as_text, false, 100);
  filter_atlas_handler["den_event"].filter->AddColumnSpec("Description", "events", as_text, false, 140, sentenceString);
  filter_atlas_handler["den_event"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["den_event"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["den_event"].filter->FetchPreferences("recordperson.den_event_filter");
  filter_atlas_handler["den_event"].filter->SetIconStatus(true);
  filter_atlas_handler["den_event"].filter->SetSQLStatement("");
  filter_atlas_handler["den_event"].filter->RefreshDataSet();

  filter_atlas_handler["cob"].filter->SetListViewHandle(listCobs);
  filter_atlas_handler["cob"].filter->SetSecurity("tasks.cob");
  filter_atlas_handler["cob"].filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  filter_atlas_handler["cob"].filter->AddColumnSpec("Appt. Date", "appointments", as_date, true, 80);
  filter_atlas_handler["cob"].filter->AddColumnSpec("Time", "tasks", as_time, true, 80);
  filter_atlas_handler["cob"].filter->AddColumnSpec("COB Number", "tasks", as_int, true, 100);
  filter_atlas_handler["cob"].filter->AddColumnSpec("Provider", "tax_entities", as_text, true, 140, rawString);
  filter_atlas_handler["cob"].filter->AddColumnSpec("Service", "services_provided", as_text, true, 140);
  filter_atlas_handler["cob"].filter->AddColumnSpec("Area", "services_provided", as_text, true, 140);
  filter_atlas_handler["cob"].filter->AddColumnSpec("Obligated Amount", "tasks", as_double, true, 130, amountString);
  filter_atlas_handler["cob"].filter->AddColumnSpec("Reason", "tasks", as_text, true, 130, rawString);
  filter_atlas_handler["cob"].filter->AddColumnSpec("Limits", "tasks", as_text, true, 130, rawString);
  filter_atlas_handler["cob"].filter->AddColumnSpec("Preconditions", "tasks", as_text, false, 130, sentenceString);
  filter_atlas_handler["cob"].filter->AddColumnSpec("Follow up", "tasks", as_text, false, 130, sentenceString);
  filter_atlas_handler["cob"].filter->AddColumnSpec("Reported by", "tasks", as_text, false, 130, sentenceString);
  filter_atlas_handler["cob"].filter->AddColumnSpec("Hospitalized", "tasks", as_text, false, 130, prettyBoolString);
  filter_atlas_handler["cob"].filter->AddColumnSpec("Given Room", "tasks", as_text, false, 130, prettyBoolString);
  filter_atlas_handler["cob"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["cob"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["cob"].filter->FetchPreferences("recordperson.cob_filter");
  filter_atlas_handler["cob"].filter->SetSQLStatement("");
  filter_atlas_handler["cob"].filter->RefreshDataSet();

  filter_atlas_handler["cob_visit"].filter->SetListViewHandle(listCobVisits);
  filter_atlas_handler["cob_visit"].filter->SetSecurity("tasks");
  filter_atlas_handler["cob_visit"].filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  filter_atlas_handler["cob_visit"].filter->AddColumnSpec("Time", "tasks", as_time, true, 80);
  filter_atlas_handler["cob_visit"].filter->AddColumnSpec("COB Number", "tasks", as_int, true, 100);
  filter_atlas_handler["cob_visit"].filter->AddColumnSpec("Tax Entity", "tax_entities", as_text, true, 140, rawString);
  filter_atlas_handler["cob_visit"].filter->AddColumnSpec("Reason", "tasks", as_text, true, 130, sentenceString);
  filter_atlas_handler["cob_visit"].filter->AddColumnSpec("Account #", "tasks", as_text, true, 130, prettyString);
  filter_atlas_handler["cob_visit"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["cob_visit"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["cob_visit"].filter->FetchPreferences("recordperson.cob_visit_filter");
  filter_atlas_handler["cob_visit"].filter->SetSQLStatement("");
  filter_atlas_handler["cob_visit"].filter->RefreshDataSet();

  filter_atlas_handler["deferred_cob"].filter->SetListViewHandle(listConDefCOBs);
  filter_atlas_handler["deferred_cob"].filter->SetSecurity("deferred_cobs");
  filter_atlas_handler["deferred_cob"].filter->AddColumnSpec("Date",          "deferred_cobs",     as_date, true,   80);
  filter_atlas_handler["deferred_cob"].filter->AddColumnSpec("Referred By",   "tax_entities",      as_text, true,  120);
  filter_atlas_handler["deferred_cob"].filter->AddColumnSpec("Provider",      "tax_entities",      as_text, true,  120);
  filter_atlas_handler["deferred_cob"].filter->AddColumnSpec("Service",       "services_provided", as_text, true,  120);
  filter_atlas_handler["deferred_cob"].filter->AddColumnSpec("Area",          "services_provided", as_text, true,   80);
  filter_atlas_handler["deferred_cob"].filter->AddColumnSpec("Reason",        "deferred_cobs",     as_text, true,  120, rawString);
  filter_atlas_handler["deferred_cob"].filter->AddColumnSpec("Status",        "deferred_cobs",     as_text, true,  100, rawString);
  filter_atlas_handler["deferred_cob"].filter->AddColumnSpec("Approved",      "deferred_cobs",     as_text, true,   80, prettyBoolString);
  filter_atlas_handler["deferred_cob"].filter->AddColumnSpec("Current Id",    "current_id",        as_int,  false,  80);
  filter_atlas_handler["deferred_cob"].filter->AddColumnSpec("Internal Id",   "internal_id",       as_int,  false,  80);
  filter_atlas_handler["deferred_cob"].filter->FetchPreferences("recordperson.deferred_cob_filter");
  filter_atlas_handler["deferred_cob"].filter->SetSQLStatement("");
  filter_atlas_handler["deferred_cob"].filter->RefreshDataSet();

  filter_atlas_handler["cob_bills"].filter->SetListViewHandle(listCobBills);
  filter_atlas_handler["cob_bills"].filter->SetSecurity("bills.incoming");
  filter_atlas_handler["cob_bills"].filter->AddColumnSpec("Date Received", "bills", as_date, true, 120);
  filter_atlas_handler["cob_bills"].filter->AddColumnSpec("DOS", "bills", as_date, true, 120);
  filter_atlas_handler["cob_bills"].filter->AddColumnSpec("Provider", "tax_entities", as_text, true, 150, rawString);
  filter_atlas_handler["cob_bills"].filter->AddColumnSpec("Facility", "tax_entities", as_text, true, 150, rawString);
  filter_atlas_handler["cob_bills"].filter->AddColumnSpec("Group", "tax_entities", as_text, true, 150, rawString);
  filter_atlas_handler["cob_bills"].filter->AddColumnSpec("Invoice Number", "bills", as_text, true, 100);
  filter_atlas_handler["cob_bills"].filter->AddColumnSpec("PR Number", "purchase_reqs", as_int, true, 100);
  filter_atlas_handler["cob_bills"].filter->AddColumnSpec("Check Number", "checks", as_int, true, 100);
  filter_atlas_handler["cob_bills"].filter->AddColumnSpec("Invoice Amount", "bills", as_double, true, 110, amountString);
  filter_atlas_handler["cob_bills"].filter->AddColumnSpec("Total Amount", "bills", as_double, true, 110, amountString);
  filter_atlas_handler["cob_bills"].filter->AddColumnSpec("Paid Amount", "bills", as_double, true, 110, amountString);
  filter_atlas_handler["cob_bills"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["cob_bills"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["cob_bills"].filter->FetchPreferences("recordperson.cob_bills_filter");
  filter_atlas_handler["cob_bills"].filter->SetSQLStatement("");
  filter_atlas_handler["cob_bills"].filter->RefreshDataSet();

  filter_atlas_handler["con_denial"].filter->SetListViewHandle(listConDenials);
  filter_atlas_handler["con_denial"].filter->SetSecurity("denials");
  filter_atlas_handler["con_denial"].filter->AddColumnSpec("Provider", "tax_entities", as_text, true, 150, rawString);
  filter_atlas_handler["con_denial"].filter->AddColumnSpec("Service", "services_provided", as_text, true, 110);
  filter_atlas_handler["con_denial"].filter->AddColumnSpec("Authority", "denial_letters", as_text, true, 110, rawString);
  filter_atlas_handler["con_denial"].filter->AddColumnSpec("Status", "denial_letters", as_text, true, 60, rawString);
  filter_atlas_handler["con_denial"].filter->AddColumnSpec("DOS From", "denial_items", as_date, true, 80);
  filter_atlas_handler["con_denial"].filter->AddColumnSpec("DOS To", "denial_items", as_date, true, 80);
  filter_atlas_handler["con_denial"].filter->AddColumnSpec("Billed amount", "denial_items", as_double, true, 80, amountString);
  filter_atlas_handler["con_denial"].filter->AddColumnSpec("Patient owes", "denial_items", as_double, true, 80, amountString);
  filter_atlas_handler["con_denial"].filter->AddColumnSpec("Payable amount", "denial_items", as_double, true, 90, amountString);
  filter_atlas_handler["con_denial"].filter->AddColumnSpec("Effective date", "denial_letters", as_date, true, 80);
  filter_atlas_handler["con_denial"].filter->AddColumnSpec("Date processed", "denial_letters", as_date, true, 80);
  filter_atlas_handler["con_denial"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["con_denial"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["con_denial"].filter->FetchPreferences("recordperson.con_denial_filter");
  filter_atlas_handler["con_denial"].filter->SetSQLStatement("");
  filter_atlas_handler["con_denial"].filter->RefreshDataSet();

  // jhaley 20110707: CHS mail outs
  filter_atlas_handler["chs_mail"].filter->SetListViewHandle(listCHSMail);
  filter_atlas_handler["chs_mail"].filter->SetSecurity("tasks.cob");
  filter_atlas_handler["chs_mail"].filter->AddColumnSpec("Date",        "tasks",       as_date, true,   80);
  filter_atlas_handler["chs_mail"].filter->AddColumnSpec("Staff",       "tasks",       as_text, true,  100);
  filter_atlas_handler["chs_mail"].filter->AddColumnSpec("Method",      "tasks",       as_text, true,   60, prettyString);
  filter_atlas_handler["chs_mail"].filter->AddColumnSpec("Direction",   "tasks",       as_text, true,   70, prettyString);
  filter_atlas_handler["chs_mail"].filter->AddColumnSpec("Comments",    "tasks",       as_text, true,  220, rawString);
  filter_atlas_handler["chs_mail"].filter->AddColumnSpec("Current Id",  "current_id",  as_int,  false,  80);
  filter_atlas_handler["chs_mail"].filter->AddColumnSpec("Internal Id", "internal_id", as_int,  false,  80);
  filter_atlas_handler["chs_mail"].filter->FetchPreferences("recordperson.chs_mail_filter");
  filter_atlas_handler["chs_mail"].filter->SetSQLStatement("");
  filter_atlas_handler["chs_mail"].filter->RefreshDataSet();

  filter_atlas_handler["lac_bills"].filter->SetListViewHandle(listClinicBills);
  filter_atlas_handler["lac_bills"].filter->SetSecurity("bills.outgoing");
  filter_atlas_handler["lac_bills"].filter->AddColumnSpec("Clinic", "bills", as_text, true, 100);
  filter_atlas_handler["lac_bills"].filter->AddColumnSpec("Date Billed", "bills", as_date, true, 120);
  filter_atlas_handler["lac_bills"].filter->AddColumnSpec("Provider", "tax_entities", as_text, true, 150, rawString);
  filter_atlas_handler["lac_bills"].filter->AddColumnSpec("Facility", "tax_entities", as_text, true, 150, rawString);
  filter_atlas_handler["lac_bills"].filter->AddColumnSpec("Invoice Amount", "bills", as_double, true, 110, amountString);
  filter_atlas_handler["lac_bills"].filter->AddColumnSpec("Total Amount", "bills", as_double, true, 110, amountString);
  filter_atlas_handler["lac_bills"].filter->AddColumnSpec("Paid Amount", "bills", as_double, true, 110, amountString);
  filter_atlas_handler["lac_bills"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["lac_bills"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["lac_bills"].filter->FetchPreferences("recordperson.lac_bills_filter");
  filter_atlas_handler["lac_bills"].filter->SetSQLStatement("");
  filter_atlas_handler["lac_bills"].filter->RefreshDataSet();

  filter_atlas_handler["pharmacy"].filter->SetListViewHandle (listPharmacy);
  filter_atlas_handler["pharmacy"].filter->SetSecurity("pharmacy_info");
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("Dispense Date", "pharmacy_info", as_date, true, 110);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("Pharmacy name", "pharmacy_info", as_text, true, 100);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("City", "pharmacy_info", as_text, false, 100);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("State", "pharmacy_info", as_text, false, 90);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("Amount Billed", "pharmacy_info", as_double, true, 90, amountString);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("Amount Paid", "pharmacy_info", as_double, false, 90, amountString);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("Ingredient Cost", "pharmacy_info", as_double, false, 100, amountString);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("Dispense Cost", "pharmacy_info", as_double, false, 100, amountString);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("Tax", "pharmacy_info", as_double, false, 90, amountString);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("Copay", "pharmacy_info", as_double, false, 90, amountString);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("Drug Name", "pharmacy_info", as_text, true, 120);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("NDC Number", "pharmacy_info", as_text, true, 100);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("RX Number", "pharmacy_info", as_int, false, 90);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("Refill Number", "pharmacy_info", as_int, false, 100);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("Quantity Filled", "pharmacy_info", as_int, false, 110);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("Days Supply", "pharmacy_info", as_int, false, 90);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("Physician Name", "pharmacy_info", as_text, false, 90);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("Physicain Dea Number", "pharmacy_info", as_text, false, 150);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["pharmacy"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["pharmacy"].filter->FetchPreferences("recordperson.pharmacy_filter");
  filter_atlas_handler["pharmacy"].filter->SetIconStatus(true);
  filter_atlas_handler["pharmacy"].filter->SetSQLStatement ("");
  filter_atlas_handler["pharmacy"].filter->RefreshDataSet();

  filter_atlas_handler["case_notes"].filter->SetListViewHandle (listCaseNotes);
  filter_atlas_handler["case_notes"].filter->SetSecurity("case_notes");
  filter_atlas_handler["case_notes"].filter->AddColumnSpec("Date", "case_notes", as_date, true, 80);
  filter_atlas_handler["case_notes"].filter->AddColumnSpec("Note", "case_notes", as_text, true, 270, rawString);
  filter_atlas_handler["case_notes"].filter->AddColumnSpec("Dept.", "case_notes", as_text, true, 100);
  filter_atlas_handler["case_notes"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["case_notes"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["case_notes"].filter->FetchPreferences("recordperson.case_notes_filter");
  filter_atlas_handler["case_notes"].filter->SetIconStatus(true);
  filter_atlas_handler["case_notes"].filter->SetSQLStatement("");
  filter_atlas_handler["case_notes"].filter->RefreshDataSet();

  filter_atlas_handler["cob_notes"].filter->SetListViewHandle (listCobNotes);
  filter_atlas_handler["cob_notes"].filter->SetSecurity("person_notes.cob");
  filter_atlas_handler["cob_notes"].filter->AddColumnSpec("Date", "person_notes", as_date, true, 80);
  filter_atlas_handler["cob_notes"].filter->AddColumnSpec("Note", "person_notes", as_text, true, 270, sentenceString);
  filter_atlas_handler["cob_notes"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["cob_notes"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["cob_notes"].filter->FetchPreferences("recordperson.cob_notes_filter");
  filter_atlas_handler["cob_notes"].filter->SetIconStatus(true);
  filter_atlas_handler["cob_notes"].filter->SetSQLStatement("");
  filter_atlas_handler["cob_notes"].filter->RefreshDataSet();

  filter_atlas_handler["any_conditions"].filter->SetListViewHandle (listConditions);
  filter_atlas_handler["any_conditions"].filter->SetSecurity("conditions.common");
  filter_atlas_handler["any_conditions"].filter->AddColumnSpec("Condition Type", "conditions", as_text, true, 100);
  filter_atlas_handler["any_conditions"].filter->AddColumnSpec("Diagnosed", "tasks", as_text, true, 60, prettyBoolString);
  filter_atlas_handler["any_conditions"].filter->AddColumnSpec("Start Date", "conditions", as_date, true, 80);
  filter_atlas_handler["any_conditions"].filter->AddColumnSpec("Stop Date", "conditions", as_date, false, 80);
  filter_atlas_handler["any_conditions"].filter->AddColumnSpec("Code", "conditions", as_text, true, 80);
  filter_atlas_handler["any_conditions"].filter->AddColumnSpec("Note", "conditions", as_text, true, 140, sentenceString);
  filter_atlas_handler["any_conditions"].filter->AddColumnSpec("Description", "conditions", as_text, true, 140, sentenceString);
  filter_atlas_handler["any_conditions"].filter->AddColumnSpec("Dept.", "conditions", as_text, true, 80);
  filter_atlas_handler["any_conditions"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["any_conditions"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["any_conditions"].filter->FetchPreferences("recordperson.any_conditions_filter");
  filter_atlas_handler["any_conditions"].filter->SetIconStatus(true);
  filter_atlas_handler["any_conditions"].filter->SetSQLStatement("");
  filter_atlas_handler["any_conditions"].filter->RefreshDataSet();

  filter_atlas_handler["enrollment"].filter->SetListViewHandle (listEnrollment);
  filter_atlas_handler["enrollment"].filter->SetSecurity("enrollment");
  filter_atlas_handler["enrollment"].filter->AddColumnSpec("Type", "enrollment", as_text, true, 200);
  filter_atlas_handler["enrollment"].filter->AddColumnSpec("Enroll No.", "enrollment", as_text, true, 80);
  filter_atlas_handler["enrollment"].filter->AddColumnSpec("Status", "enrollment", as_text, true, 100);
  filter_atlas_handler["enrollment"].filter->AddColumnSpec("Enroll Date", "enrollment", as_date, true, 90);
  filter_atlas_handler["enrollment"].filter->AddColumnSpec("Un-enroll Date", "enrollment", as_date, true, 90);
  filter_atlas_handler["enrollment"].filter->AddColumnSpec("Comments", "conditions", as_text, false, 140, sentenceString);
  filter_atlas_handler["enrollment"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["enrollment"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["enrollment"].filter->FetchPreferences("recordperson.enrollment_filter");
  filter_atlas_handler["enrollment"].filter->SetIconStatus(true);
  filter_atlas_handler["enrollment"].filter->SetSQLStatement("");
  filter_atlas_handler["enrollment"].filter->RefreshDataSet();

  filter_atlas_handler["ins_app"].filter->SetListViewHandle (listInsApps);
  filter_atlas_handler["ins_app"].filter->SetSecurity("insurance_applications");
  filter_atlas_handler["ins_app"].filter->AddColumnSpec("Type", "insurance_applications", as_text, true, 120);
  filter_atlas_handler["ins_app"].filter->AddColumnSpec("Mailed", "insurance_applications", as_text, true, 75, prettyBoolString);
  filter_atlas_handler["ins_app"].filter->AddColumnSpec("Date Mailed", "insurance_applications", as_date, true, 80);
  filter_atlas_handler["ins_app"].filter->AddColumnSpec("Mailed By", "insurance_applications", as_text, true, 90);
  filter_atlas_handler["ins_app"].filter->AddColumnSpec("Completed", "insurance_applications", as_text, true, 75, prettyBoolString);
  filter_atlas_handler["ins_app"].filter->AddColumnSpec("Completed By", "insurance_applications", as_text, true, 90);
  filter_atlas_handler["ins_app"].filter->AddColumnSpec("Received", "insurance_applications", as_text, true, 75, prettyBoolString);
  filter_atlas_handler["ins_app"].filter->AddColumnSpec("Date Received", "insurance_applications", as_date, true, 80);
  filter_atlas_handler["ins_app"].filter->AddColumnSpec("Received At", "insurance_applications", as_text, true, 90);
  filter_atlas_handler["ins_app"].filter->AddColumnSpec("Faxed", "insurance_applications", as_text, true, 75, prettyBoolString);
  filter_atlas_handler["ins_app"].filter->AddColumnSpec("Date Faxed", "insurance_applications", as_date, true, 80);
  filter_atlas_handler["ins_app"].filter->AddColumnSpec("Faxed To", "tax_entities", as_text, true, 150, rawString);
  filter_atlas_handler["ins_app"].filter->AddColumnSpec("Faxed By", "insurance_applications", as_text, true, 90);
  filter_atlas_handler["ins_app"].filter->AddColumnSpec("Note", "insurance_applications", as_text, true, 200, rawString);
  filter_atlas_handler["ins_app"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["ins_app"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["ins_app"].filter->FetchPreferences("recordperson.ins_app_filter");
  filter_atlas_handler["ins_app"].filter->SetIconStatus(true);
  filter_atlas_handler["ins_app"].filter->SetSQLStatement ("");
  filter_atlas_handler["ins_app"].filter->RefreshDataSet();

  filter_atlas_handler["coverage"].filter->SetListViewHandle (listCoverage);
  filter_atlas_handler["coverage"].filter->SetSecurity("insurance_coverage");
  filter_atlas_handler["coverage"].filter->AddColumnSpec("Company", "tax_entities", as_text, true, 140, rawString);
  filter_atlas_handler["coverage"].filter->AddColumnSpec("Medical Type", "tax_entities", as_text, true, 100);
  filter_atlas_handler["coverage"].filter->AddColumnSpec("Policy Number", "insurance_policies", as_text, true, 120, rawString);
  filter_atlas_handler["coverage"].filter->AddColumnSpec("Group Number", "insurance_policies", as_text, true, 120, rawString);
  filter_atlas_handler["coverage"].filter->AddColumnSpec("Coverage Type", "insurance_benefits", as_text, true, 100);
  filter_atlas_handler["coverage"].filter->AddColumnSpec("Coverage Note", "insurance_benefits", as_text, true, 120);
  filter_atlas_handler["coverage"].filter->AddColumnSpec("Effective Date", "insurance_policies", as_date, true, 120);
  filter_atlas_handler["coverage"].filter->AddColumnSpec("Termination Date", "insurance_policies", as_date, false, 120);
  filter_atlas_handler["coverage"].filter->AddColumnSpec("Coverage", "insurance_policies", as_text, false, 120);
  filter_atlas_handler["coverage"].filter->AddColumnSpec("Source", "insurance_policies", as_text, false, 120);
  filter_atlas_handler["coverage"].filter->AddColumnSpec("Name on Policy", "insurance_policies", as_text, false, 120);
  filter_atlas_handler["coverage"].filter->AddColumnSpec("PCP", "tax_entities", as_text, true, 120, rawString);
  filter_atlas_handler["coverage"].filter->AddColumnSpec("Person Code", "insurance_coverage", as_int, false, 100);
  filter_atlas_handler["coverage"].filter->AddColumnSpec("Name on Card", "insurance_coverage", as_text, false, 100);
  filter_atlas_handler["coverage"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["coverage"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["coverage"].filter->FetchPreferences("recordperson.coverage_filter");
  filter_atlas_handler["coverage"].filter->SetIconStatus(true);
  filter_atlas_handler["coverage"].filter->SetSQLStatement ("");
  filter_atlas_handler["coverage"].filter->RefreshDataSet();

  filter_atlas_handler["caregiver_cob"].filter->SetListViewHandle(listCaregiverCOB);
  filter_atlas_handler["caregiver_cob"].filter->SetSecurity("tasks");
  filter_atlas_handler["caregiver_cob"].filter->AddColumnSpec("Date", "tasks", as_date, true, 80);
  filter_atlas_handler["caregiver_cob"].filter->AddColumnSpec("Appt. Date", "appointments", as_date, true, 80);
  filter_atlas_handler["caregiver_cob"].filter->AddColumnSpec("Time", "tasks", as_time, true, 80);
  filter_atlas_handler["caregiver_cob"].filter->AddColumnSpec("COB Number", "tasks", as_int, true, 100);
  filter_atlas_handler["caregiver_cob"].filter->AddColumnSpec("Provider", "tax_entities", as_text, true, 75, rawString);
  filter_atlas_handler["caregiver_cob"].filter->AddColumnSpec("Service", "services_provided", as_text, true, 90);
  filter_atlas_handler["caregiver_cob"].filter->AddColumnSpec("Obligated Amount", "tasks", as_double, true, 130, amountString);
  filter_atlas_handler["caregiver_cob"].filter->AddColumnSpec("Reason", "tasks", as_text, true, 130, sentenceString);
  filter_atlas_handler["caregiver_cob"].filter->AddColumnSpec("Limits", "tasks", as_text, true, 130, sentenceString);
  filter_atlas_handler["caregiver_cob"].filter->AddColumnSpec("Preconditions", "tasks", as_text, false, 130, sentenceString);
  filter_atlas_handler["caregiver_cob"].filter->AddColumnSpec("Follow up", "tasks", as_text, false, 130, sentenceString);
  filter_atlas_handler["caregiver_cob"].filter->AddColumnSpec("Reported by", "tasks", as_text, false, 130, sentenceString);
  filter_atlas_handler["caregiver_cob"].filter->AddColumnSpec("Hospitalized", "tasks", as_text, false, 130, prettyBoolString);
  filter_atlas_handler["caregiver_cob"].filter->AddColumnSpec("Given Room", "tasks", as_text, false, 130, prettyBoolString);
  filter_atlas_handler["caregiver_cob"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["caregiver_cob"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["caregiver_cob"].filter->FetchPreferences("recordperson.cob_filter");
  filter_atlas_handler["caregiver_cob"].filter->SetSQLStatement("");
  filter_atlas_handler["caregiver_cob"].filter->RefreshDataSet();

  filter_atlas_handler["caregiver_bills"].filter->SetListViewHandle(listCaregiverBills);
  filter_atlas_handler["caregiver_bills"].filter->SetSecurity("bills.incoming");
  filter_atlas_handler["caregiver_bills"].filter->AddColumnSpec("Date Received", "bills", as_date, true, 120);
  filter_atlas_handler["caregiver_bills"].filter->AddColumnSpec("DOS", "bills", as_date, true, 120);
  filter_atlas_handler["caregiver_bills"].filter->AddColumnSpec("Provider", "tax_entities", as_text, true, 150, rawString);
  filter_atlas_handler["caregiver_bills"].filter->AddColumnSpec("Facility", "tax_entities", as_text, true, 150, rawString);
  filter_atlas_handler["caregiver_bills"].filter->AddColumnSpec("Group", "tax_entities", as_text, true, 150, rawString);
  filter_atlas_handler["caregiver_bills"].filter->AddColumnSpec("Invoice Number", "bills", as_text, true, 100);
  filter_atlas_handler["caregiver_bills"].filter->AddColumnSpec("PR Number", "purchase_reqs", as_int, true, 100);
  filter_atlas_handler["caregiver_bills"].filter->AddColumnSpec("Check Number", "checks", as_int, true, 100);
  filter_atlas_handler["caregiver_bills"].filter->AddColumnSpec("Invoice Amount", "bills", as_double, true, 110, amountString);
  filter_atlas_handler["caregiver_bills"].filter->AddColumnSpec("Total Amount", "bills", as_double, true, 110, amountString);
  filter_atlas_handler["caregiver_bills"].filter->AddColumnSpec("Paid Amount", "bills", as_double, true, 110, amountString);
  filter_atlas_handler["caregiver_bills"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["caregiver_bills"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["caregiver_bills"].filter->FetchPreferences("recordperson.cob_bills_filter");
  filter_atlas_handler["caregiver_bills"].filter->SetSQLStatement("");
  filter_atlas_handler["caregiver_bills"].filter->RefreshDataSet();

  // jhaley 20100804: common events view
  filter_atlas_handler["common_events"].filter->SetListViewHandle(listCommonPersonEvents);
  filter_atlas_handler["common_events"].filter->SetSecurity("participations");
  filter_atlas_handler["common_events"].filter->AddColumnSpec("Department", "events", as_text, true, 120);
  filter_atlas_handler["common_events"].filter->AddColumnSpec("Date", "events", as_date, true, 80);
  filter_atlas_handler["common_events"].filter->AddColumnSpec("Event Name", "events", as_text, true, 140, rawString);
  filter_atlas_handler["common_events"].filter->AddColumnSpec("Event Type", "events", as_text, true, 100, rawString);
  filter_atlas_handler["common_events"].filter->AddColumnSpec("Location", "events", as_text, true, 160, rawString);
  filter_atlas_handler["common_events"].filter->AddColumnSpec("Attendance", "events", as_text, false, 100);
  filter_atlas_handler["common_events"].filter->AddColumnSpec("Description", "events", as_text, false, 140, sentenceString);
  filter_atlas_handler["common_events"].filter->AddColumnSpec("Note", "participations", as_text, false, 130);
  filter_atlas_handler["common_events"].filter->AddColumnSpec("Current Id", "current_id", as_int, false, 80);
  filter_atlas_handler["common_events"].filter->AddColumnSpec("Internal Id", "internal_id", as_int, false, 80);
  filter_atlas_handler["common_events"].filter->FetchPreferences("recordperson.common_events_filter");
  filter_atlas_handler["common_events"].filter->SetSQLStatement("");
  filter_atlas_handler["common_events"].filter->RefreshDataSet();

  Initialize();

  string name_of_wanted_page;
  if (initial_page_number >= pageSelectArea->PageCount || initial_page_number < 0)
   initial_page_number = 0; // if outside the range, don't try.
  name_of_wanted_page = pageSelectArea->Pages[initial_page_number]->Caption.c_str();
  int index_of_combo_item = comboSelectArea->Items->IndexOf(name_of_wanted_page.c_str());
  if (index_of_combo_item < 0)
   index_of_combo_item = 0; // if it can't find it, default to page 0 ... we don't have a "blank" page to use instead!
  comboSelectArea->ItemIndex = index_of_combo_item;
  pageSelectArea->ActivePageIndex = initial_page_number;

  listQuickIcons->SmallImages = imagesRecordTypes;
  if (optionsPermissions["admin.beta"]["enabled"] == "true")
    listQuickIcons->Width = 18;

  // for a consistently heighted sheetGeneral
  comboSelectAreaChange(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::comboSelectAreaChange(TObject *Sender)
{
  if (comboSelectArea->Text == "General")
    sheetGeneral->Show();
  else if (comboSelectArea->Text == "Common")
    sheetCommon->Show();
  else if (comboSelectArea->Text == "Consents")
    sheetConsents->Show();
  else if (comboSelectArea->Text == "Appointments")
    sheetAppointments->Show();
  else if (comboSelectArea->Text == "Enrollment")
    sheetEnrollment->Show();
  else if (comboSelectArea->Text == "Referrals")
    sheetReferrals->Show();
  else if (comboSelectArea->Text == "Insurance")
    sheetInsurance->Show();
  else if (comboSelectArea->Text == "Relations")
    sheetRelations->Show();
  else if (comboSelectArea->Text == "Case Management")
    sheetCases->Show();
  else if (comboSelectArea->Text == "Contract Health")
    sheetContractHealth->Show();
  else if (comboSelectArea->Text == "Medical Clinic")
    sheetClinic->Show();
  else if (comboSelectArea->Text == "Dental Clinic")
    sheetDental->Show();
  else if (comboSelectArea->Text == "Diabetes")
    sheetDiabetes->Show();
  else if (comboSelectArea->Text == "Conditions")
    sheetConditions->Show();
  else if (comboSelectArea->Text == "Pharmacy")
    sheetPharmacy->Show();
  else if (comboSelectArea->Text == "Behavioral")
    sheetBehavioral->Show();
  else if (comboSelectArea->Text == "Community")
    sheetCommunity->Show();
  else if (comboSelectArea->Text == "Public Health")
    sheetPublicHealth->Show();
  else if (comboSelectArea->Text == "Caregiver")
    sheetCaregiver->Show();
  else if (comboSelectArea->Text == "Debug Relationships")
    sheetRelationships2->Show();

  // it occurs to me that we would do well to have an AutoSize() function that takes a TWinConrol and
  // - recurses over its Conrols and if
  //   - Conrols[i] has Align of alClient (or alLeft or alRight for height calculation; or alTop or alBottom for width calculation)
  //     - then set Controls[i] as the new root, reset height/width (as appropriate) and recurse -its- conrols
  //   - if Visible, look at Top and Height and if > calculated height so far, make this the new calculated height
  // - when done, return height/width (whatever was requested, or just return both)
  // VCL provides an autosizing bools on some conrols, but not all of them, and only for height, not width.  Plus you might just
  // want to *know* the value without actually resizing.  So, yes, this would be handy.  Then this function could go away.

  // Of course, what this does NOT account for is (ugh) cases where you have something like a bunch of panels stacked, all alTop etc.
  // and the middle one is not Visible; you should account for the other two though.  You'd have to do an initial pass scanning Align
  // to figure out which components to delve into, and which not to bother with.

  int i = 0, top = 0, height = 0;
  bool done = false;
  while (i < pageSelectArea->ActivePage->ControlCount && !done)
  {
   if (pageSelectArea->ActivePage->Controls[i]->InheritsFrom(__classid(TPanel)))
   {
    top = pageSelectArea->ActivePage->Controls[i]->Top;
    height = pageSelectArea->ActivePage->Controls[i]->Height;
    done = true;
   }
   i++;
  }
  top += max(0, pageSelectArea->ActivePage->Top);
  if (!done)
    height = pageSelectArea->ActivePage->Height; // dunno; don't have a decent fallback plan; this will just set = height it already is
  this->Constraints->MaxHeight = top + height + extra_space;
  this->Constraints->MinHeight = top + height + extra_space;
}
//---------------------------------------------------------------------------
bool TformRecordPerson::ScreenStart()
{
  // set the font color for all links
  txtUpdate->Font->Color = link_color;
  txtUpdateNoSignature->Font->Color = link_color;
  txtUpdateWMedicalConsent->Font->Color = link_color;
  txtUpdateWDentalConsent->Font->Color = link_color;
  txtDemographics->Font->Color = link_color;
  txtConditions->Font->Color = link_color;
  txtProcedures->Font->Color = link_color;
  txtCaregiverLimits->Font->Color = link_color;
  txtPatientProviderInfo->Font->Color = link_color;
  txtWizard->Font->Color = link_color;
  txtHealthSummary->Font->Color = link_color;

  staticPersonLimits->Font->Color = link_color;
  staticViewRelationshipGraph->Font->Color = link_color;
  staticViewFamilyTree->Font->Color = link_color;
  staticModifyHeadHousehold->Font->Color = link_color;

  lblDiabLogsheetReport->Font->Color = link_color;
  lblDiabMeasureReport->Font->Color = link_color;
  lblDiabTaskReport->Font->Color = link_color;
  lblDiabEventReport->Font->Color = link_color;
  lblDiabCareSummaryReport->Font->Color = link_color;
  lblFitnessAttendanceReport->Font->Color = link_color;
  lblBehConditionReport->Font->Color = link_color;
  lblBehLocalTreatmentReport->Font->Color = link_color;
  lblBehOutsideTreatmentReport->Font->Color = link_color;
  lblBehTaskReport->Font->Color = link_color;
  lblBehEventReport->Font->Color = link_color;
  lblComVisitReport->Font->Color = link_color;
  lblComEducationReport->Font->Color = link_color;
  lblComMeasurementReport->Font->Color = link_color;
  lblComEventReport->Font->Color = link_color;
  lblComCommentsReport->Font->Color = link_color;
  lblPublicVisitReport->Font->Color = link_color;
  lblPublicEduReport->Font->Color = link_color;
  lblPublicMetricReport->Font->Color = link_color;
  lblPublicCommentReport->Font->Color = link_color;
  lblPublicEventReport->Font->Color = link_color;
//  lblCheckReport->Font->Color = link_color;
//  lblShoeReport->Font->Color = link_color;

  extra_space = this->Height - pageSelectArea->Height + 8;
  //extra_space = 60;

  if(optionsPermissions["table.people"]["view"] == "true")
  {
    comboSelectArea->Items->Add("General");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("General");
    new_row->ImageIndex = 50;
  }
  if(optionsPermissions["table.people.common"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Common");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Common");
    new_row->ImageIndex = 21;
  }
  // General and Common are the only things I think should be up front.  Let's
  // put the other non-deptartmental things in alph order so they're easier to find  --Paul
  if(optionsPermissions["table.appointments.people"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Appointments");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Appointments");
    new_row->ImageIndex = 25;
  }
  if(optionsPermissions["table.conditions"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Conditions");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Conditions");
    new_row->ImageIndex = 10;
  }
  if(optionsPermissions["table.consents"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Consents");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Consents");
    new_row->ImageIndex = 8;
  }
  if(optionsPermissions["table.enrollment"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Enrollment");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Enrollment");
    new_row->ImageIndex = 16;
  }
  if(optionsPermissions["table.insurance_coverage"]["view"] == "true" ||
     optionsPermissions["table.insurance_applications"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Insurance");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Insurance");
    new_row->ImageIndex = 0;
  }
  if(optionsPermissions["table.referrals"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Referrals");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Referrals");
    new_row->ImageIndex = 40;
  }
  if(optionsPermissions["table.relationships"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Relations");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Relations");
    new_row->ImageIndex = 33;
  }
  // let's try to keep the departments in alph order, shall we?  --Paul
  if(optionsPermissions["table.people.beh"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Behavioral");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Behavioral");
    new_row->ImageIndex = 15;
  }
  if(optionsPermissions["table.tasks.care"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Caregiver");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Caregiver");
    new_row->ImageIndex = 7;
  }
  if(optionsPermissions["table.people.com"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Community");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Community");
    new_row->ImageIndex = 11;
  }
  if(optionsPermissions["table.people.cases"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Case Management");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Case Management");
    new_row->ImageIndex = 6;
  }
  if(optionsPermissions["table.people.cob"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Contract Health");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Contract Health");
    new_row->ImageIndex = 6;
  }
  if(optionsPermissions["table.people.den"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Dental Clinic");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Dental Clinic");
    new_row->ImageIndex = 39;
  }
  if(optionsPermissions["table.people.diab"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Diabetes");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Diabetes");
    new_row->ImageIndex = 24;
  }
  if(optionsPermissions["table.people.lac"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Medical Clinic");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Medical Clinic");
    new_row->ImageIndex = 9;
  }
  if(optionsPermissions["table.pharmacy_info"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Pharmacy");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Pharmacy");
    new_row->ImageIndex = 32;
  }
  if(optionsPermissions["table.people.com"]["view"] == "true")
  {
    comboSelectArea->Items->Add("Public Health");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Public Health");
    new_row->ImageIndex = 31;
  }
  if(optionsPermissions["admin.beta"]["enabled"] == "true")
  {
    comboSelectArea->Items->Add("Debug Relationships");
    TListItem* new_row = listQuickIcons->Items->Add();
    new_row->Caption = "";
    new_row->SubItems->Add("Debug Relationships");
    new_row->ImageIndex = 19;
  }

  // show the general info sheet
  sheetGeneral->Show();

  // set the title bar color
  panelSelectArea->Color = title_bar_color;

  comboSelectArea->ItemIndex = 0;
  pageDiabetes->ActivePageIndex = 0;
  pageBehavioral->ActivePageIndex = 0;
  pageClinic->ActivePageIndex = 0;
  pageDental->ActivePageIndex = 0;
  pageCases->ActivePageIndex = 0;
  pageContractHealth->ActivePageIndex = 0;
  pageCommon->ActivePageIndex = 0;
  // pageConditions->ActivePageIndex = 0;
  pageCommunity->ActivePageIndex = 0;
  pagePublic->ActivePageIndex = 0;

  lookupTables->RegisterComboBox("gender_types", comboGender);
  lookupTables->RegisterComboBox("marital_types", comboMarital);
  lookupTables->RegisterComboBox("race_types", cboRace);

  TformRecordGeneric::ScreenStart();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordPerson::ScreenStop()
{
  // unregister combo boxes
  lookupTables->UnregisterComboBox("gender_types", comboGender);
  lookupTables->UnregisterComboBox("marital_types", comboMarital);
  lookupTables->UnregisterComboBox("race_types", cboRace);

  TformRecordGeneric::ScreenStop();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordPerson::IsValidOnScreen()
{
  string sql = "select id from people where social_security_number = '" +
               StripAllExcept(editSSN->Text.c_str(), uints) + "'";
  if ((StripAllExcept(editSSN->Text.c_str(), uints).length() != 9) && (editSSN->Text != ""))
  {
    PSay(string("Please enter a valid ssn (" + StripAllExcept(editSSN->Text.c_str(), ints) + ")").c_str(), m_invalid_data, MB_OK);
    editSSN->Show();
    editSSN->SetFocus();
    return false;
  }
  else if (! Pdate (editBirth->Text.c_str(), mdy | yy).IsValidDate() && ! (editBirth->Text == ""))
  {
    PSay("Please enter a valid birth date", m_invalid_data, MB_OK);
    editBirth->Show();
    editBirth->SetFocus();
    return false;
  }
  if (! Pdate (editDeath->Text.c_str(), mdy | yy).IsValidDate() && ! (editDeath->Text == ""))
  {
    PSay("Please enter a valid death date", m_invalid_data, MB_OK);
    editDeath->Show();
    editDeath->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("gender_types", comboGender->Text.c_str()))
  {
    PSay("Please enter a valid gender", m_invalid_data, MB_OK);
    comboGender->Show();
    comboGender->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("martial_types", comboMarital->Text.c_str()))
  {
    PSay("Please enter a valid marital status", m_invalid_data, MB_OK);
    comboMarital->Show();
    comboMarital->SetFocus();
    return false;
  }
  else if (! IsAmount(editIncome->Text.c_str()))
  {
    PSay("Please enter a valid number for yearly income ([$][-| |+]digits[.[digits]])", m_invalid_data, MB_OK);
    editIncome->Show();
    editIncome->SetFocus();
    return false;
  }
  else if (! lookupTables->IsInLookUpTable("race_types", cboRace->Text.c_str()))
  {
    PSay("Please enter a valid race", m_invalid_data, MB_OK);
    cboRace->Show();
    cboRace->SetFocus();
    return false;
  }
  else if ((editSSN->Text != "") && (is_new_record) && (GetOneField(dbDatabase, sql) != ""))
  {
    PSay("This person already exists.\n"
                            "Please select \"Person...\" from the \"Search...\"\n"
                            "menu to find and edit the existing record.", m_warning, MB_OK);
    return false;
  }
  else if ((ending_state["current_id"] != "" && StringToInt(ending_state["current_id"]) < 3) ||
           (ending_state["current_id"] == "" && initial_state["current_id"] != "" && StringToInt(initial_state["current_id"]) < 3))
  { // Deleted, Incorrect, Expired
    string current_type = LowercaseString(lookupTables->ValueOf("current_types", ending_state["current_id"]));
    if (current_type == "") // record started out deleted/incorrect/expired and they haven't changed it.  so we use initial_state instead.
      current_type = LowercaseString(lookupTables->ValueOf("current_types", initial_state["current_id"]));
    int response;
    response = PSay(
               "You have chosen to mark this person as " + current_type + ".  This should very rarely happen.\n\n"
               "People are global, meaning you can see the same people everyone else can see in the\n"
               "system and vice versa.  If you mark a person as " + current_type + ", that person might not show\n"
               "up on the reports run by other departments.\n"
               "If you feel that this person was created in error and needs to be fixed, either edit\n"
               "the person's information yourself or contact someone who has permission to do so.\n\n"
               "If the person is a duplicate of an existing person and actually does need to be marked as \n"
               + current_type + ", please contact the programmers and explain the situation so that it can\n"
               "actually be removed from the system.\n\n"
               "If you continue you will mark this person as " + current_type + ".\n"
               "Are you SURE you want to do this?", m_warning, MB_YESNO, string("person_id = ") + initial_state["id"]); // jhaley: echo ID in other_info
    if (response == IDYES)
    {
      response = PSay(
                 "As previously mentioned, there are really very few reasons to mark a person as " + current_type + ".\n"
                 "Are you marking this person " + current_type + " because their name has changed?", m_confirmation, MB_YESNO);
      if(response == IDYES)
      {
        PSay("If this person's name has changed, edit their name but do\n"
        "not mark them as " + current_type + ". Please mark them as current before continuing", m_message, MB_OK);
        return false;
      }
      else
      {
        response = PSay(
                   "Are you marking this person " + current_type + " because their address has changed?", m_confirmation, MB_YESNO);
        if(response == IDYES)
        {
          PSay("If this person's address has changed, edit their address but do not mark\n"
          "them as " + current_type + ". Please mark them as current before continuing", m_message, MB_OK);
          return false;
        }
        else
        {
          response = PSay(
                     "Are you marking this person " + current_type + " because they are deceased?", m_confirmation, MB_YESNO);
          if(response == IDYES)
          {
            PSay("Do not mark people as " + current_type + " if they are deceased and do not remove any of their information.\n"
            "This person's information may still need to be accessed in the future. Please mark them as current before continuing", m_message, MB_OK);
            return false;
          }
          else
          {
            response = PSay(
                       "Are you marking this person " + current_type + " because any other personal information has changed?", m_confirmation, MB_YESNO);
            if(response == IDYES)
            {
              PSay("If this person's information has changed, edit the information but do not mark\n"
              "them as " + current_type + ". Please mark them as current before continuing.", m_message, MB_OK);
              return false;
            }
            else
            {
              response = PSay(
                         "Are you marking this person " + current_type + " because they are no longer served by your department?", m_confirmation, MB_YESNO);
              if(response == IDYES)
              {
                PSay("Though your department may no longer be serving this person their information will still be needed for reports.\n"
                "They may also be other departments who need this person's information. Please mark this person as current before continuing", m_message, MB_OK);
                return false;
              }
              else
              {
                response = PSay(
                           "Are you marking this person " + current_type + " because they are in the database more than once?", m_confirmation, MB_YESNO);
                if(response == IDYES)
                {
                  PSay("In this case, please contact a programmer to completly remove the person from the database.\n"
                  "Please mark the person as current for now and contact a programmer as soon as possible", m_message, MB_OK);
                  return false;
                }
                else
                {
                  response = PSay(
                             "Are you marking this person " + current_type + " because you or someone else made a mistake entering their data?", m_confirmation, MB_YESNO);
                  if(response == IDYES)
                  {
                    PSay("In this case, mark the incorrect data as incorrect, but not the person.\n", m_message, MB_OK);
                    return false;
                  }
                  else
                  {
                    /*
                    response = PSay(
                               "It appears that you may have a reason to mark this person as " + current_type + ".\n"
                               "However, please remember that other departments may have information about this person\n"
                               "that you cannot see and may still need them to appear on reports.\n"
                               "Are you absolutely sure that you want to mark this person as " + current_type + "?", m_confirmation, MB_YESNO);
                    if(response == IDYES)
                      return true;
                    else
                      return false;
                    */
                    PSay("We regret to inform you that invalidating people entirely has been disabled due to problems it was causing.  If you have a specific case that you think requires it, contact a programmer and we'll resolve it.", m_message, MB_OK);
                    return false;
                  }
                }
              }
            }
          }
        }
      }
    }
    else
      return false;  // They are not sure they want to do this.

  } // end else if marked as deleted/incorrect/expired
  else
    return true;
}
//---------------------------------------------------------------------------
// jhaley 20101029: Search for an enrollment using a vecmap, to avoid repeated queries on similar criteria, and duplicated code to
// check for each possible enrollment/enrollment status pair.
bool TformRecordPerson::DetermineEnrollment(vector<map<string, string> > &enrollments, string enrollment_type, const char *status_type)
{
  string enrollment_id = lookupTables->IdOf("enrollment_types", enrollment_type);
  string status_id = "";

  if (status_type)
    status_id = lookupTables->IdOf("enrollment_status_types", status_type);

  for (vector<map<string, string> >::iterator i_row = enrollments.begin(); i_row != enrollments.end(); i_row++)
  {
    if ((*i_row)["enrollment_id"] == enrollment_id) // enrolled in the program
    {
      if (status_id == "" || (*i_row)["enrollment_status_id"] == status_id) // don't care about status, or has that status if we do
        return true; // found a valid enrollment.
    }
  }

  // either not enrolled in the program at all, or not enrolled with the specified status
  return false;
}
//---------------------------------------------------------------------------
// jhaley 20101116: Get the corresponding status description for a given enrollment type from the enrollments vecmap.
string TformRecordPerson::GetEnrollmentStatus(vector<map<string, string> > &enrollments, string enrollment_type)
{
  string enrollment_id = lookupTables->IdOf("enrollment_types", enrollment_type);

  for (vector<map<string, string> >::iterator i_row = enrollments.begin(); i_row != enrollments.end(); i_row++)
  {
    if ((*i_row)["enrollment_id"] == enrollment_id) // enrolled in the program; return the status
      return lookupTables->ValueOf("enrollment_status_types", (*i_row)["enrollment_status_id"]);
  }

  // Not found
  return "";
}
//---------------------------------------------------------------------------
bool TformRecordPerson::PutDataOnScreen()
{
  // put the values on the form from the map initial_state
  // values may have come from GetDataFromDatabase if it's an existing record,
  // or values may have been passed to the form in this map if it's a new record

  editSSN->Text = PrettySSN(initial_state["social_security_number"]).c_str();
  editOccupation->Text = PrettyString(initial_state["occupation"]).c_str();
  editBirth->Text = initial_state["birth_date"].c_str();
  editDeath->Text = initial_state["death_date"].c_str();
  comboGender->Text = PrettyString(lookupTables->ValueOf("gender_types", initial_state["gender_id"])).c_str();
  comboMarital->Text = PrettyString(lookupTables->ValueOf("marital_types", initial_state["marital_id"])).c_str();
  editIncome->Text = StringToAmount(initial_state["yearly_income"]).c_str();
  editEducation->Text = PrettyString(initial_state["last_grade_completed"]).c_str();
  cboRace->Text = PrettyString(lookupTables->ValueOf("race_types", initial_state["race_id"])).c_str();

  if (initial_state["lac_diab_client"] == "1")
    checkLacDiabClient->Checked = true;
  else
    checkLacDiabClient->Checked = false;

  if (initial_state["asc_diab_client"] == "1")
    checkAscDiabClient->Checked = true;
  else
    checkAscDiabClient->Checked = false;

  // jhaley 20101029: Download all enrollments in one step.
  vector<map<string, string> > enrollments;
  if (!is_new_record)
  {
    string enroll_sql = "select id, enrollment_id, enrollment_status_id "
                        "from enrollment "
                        "where person_id = '" + initial_state["id"] + "' and current_id+1 >= 4 ";
    SqlToVecMap(dbDatabase, enroll_sql, enrollments);
  }

  // jhaley 20101029: set enrollment checkboxes, which are now read-only, strictly for informative purposes.
  checkDiabClient->Checked      = DetermineEnrollment(enrollments, "Diabetes Client");
  checkDiabMailingList->Checked = DetermineEnrollment(enrollments, "On Diabetes Mailing List");
  checkStepsMember->Checked     = DetermineEnrollment(enrollments, "STEPS Participant", "Member");
  checkStepsAffiliate->Checked  = DetermineEnrollment(enrollments, "STEPS Participant", "Affiliate");
  checkStarParticipant->Checked = DetermineEnrollment(enrollments, "STAR Participant");
  checkCVDParticipant->Checked  = DetermineEnrollment(enrollments, "Healthy Heart Participant");
  checkBehClient->Checked       = DetermineEnrollment(enrollments, "Behavioral Health Client");
  checkComClient->Checked       = DetermineEnrollment(enrollments, "Community Health Client");
  checkPublicClient->Checked    = DetermineEnrollment(enrollments, "Public Health Client");
  checkCareClient->Checked      = DetermineEnrollment(enrollments, "Caregiver Client");
  checkResource->Checked        = DetermineEnrollment(enrollments, "Resource Center Membership"); // 20101116: this too.

  // jhaley: Get Diabetes enrollment type
  string enrollment_status = GetEnrollmentStatus(enrollments, "Diabetes Client");
  if (enrollment_status == "") // Don't just put "" here as that's really confusing; nothing will show up.
  {
    if (checkDiabClient->Checked)
      enrollment_status = "(Unspecified)";
    else
      enrollment_status = "(Not a client)";
  }
  lblDiabClientType->Caption = enrollment_status.c_str();

  if (initial_state["refused_beh_services"] == "1")
    checkRefused->Checked = true;
  else
    checkRefused->Checked = false;
  if (initial_state["in_beh_jurisdiction"] == "1")
    checkJurisdiction->Checked = true;
  else
    checkJurisdiction->Checked = false;
  if (initial_state["refused_com_service"] == "1")
    checkComRefusedServices->Checked = true;
  else
    checkComRefusedServices->Checked = false;
  if (initial_state["refused_public_services"] == "1")
    checkPublicRefused->Checked = true;
  else
    checkPublicRefused->Checked = false;
  if (initial_state["is_primary_support"] == "1")
    checkPrimarySupport->Checked = true;
  else
    checkPrimarySupport->Checked = false;

  if (initial_state["id"] != "new")
    staticHeaderName->Caption = GetPersonName(dbDatabase, initial_state["id"]).c_str();

  CreateLink(txtProvider, btnProviderSearch, this, initial_state["diab_provider_id"], "tax_entities");
  CreateLink(staticHeadHousehold, NULL, this, initial_state["head_household_id"], "people");
  temp_head_of_household = initial_state["head_household_id"];
  if (temp_head_of_household.empty())
   temp_head_of_household = "0";

  if(optionsPermissions["report.diab"]["enabled"] != "true")
  {
    lblDiabTaskReport->Enabled = false;
    lblDiabEventReport->Enabled = false;
    lblDiabCareSummaryReport->Enabled = false;
    lblDiabLogsheetReport->Enabled = false;
    lblDiabMeasureReport->Enabled = false;
    lblFitnessAttendanceReport->Enabled = false;
  }

  TformRecordGeneric::PutDataOnScreen();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordPerson::GetDataFromScreen()
{
  // place the values currently on the screen into
  // the map that will be used to update or insert the record
  // the parent form will call the insert or update function, and get the id
  // number if necessary and take care of current_id

  ending_state["social_security_number"] = StripAllExcept(editSSN->Text.c_str(), uints);
  ending_state["occupation"] = editOccupation->Text.c_str();
  if (editBirth->Text != "")
    ending_state["birth_date"] = Pdate (editBirth->Text.c_str(), global_mode).OutDate(global_mode).c_str();
  else
    ending_state["birth_date"] = "";
  if (editDeath->Text != "")
    ending_state["death_date"] = Pdate (editDeath->Text.c_str(), global_mode).OutDate(global_mode).c_str();
  else
    ending_state["death_date"] = "";
  ending_state["gender_id"] = lookupTables->IdOf("gender_types", comboGender->Text.c_str()).c_str();
  ending_state["marital_id"] = lookupTables->IdOf("marital_types", comboMarital->Text.c_str()).c_str();
  if (editIncome->Text != "")
    ending_state["yearly_income"] = AmountToString(editIncome->Text.c_str());
  else
    ending_state["yearly_income"] = "";
  if (editEducation->Text != "")
    ending_state["last_grade_completed"] = editEducation->Text.c_str();
  else
    ending_state["last_grade_completed"] = "";
  ending_state["race_id"] = lookupTables->IdOf("race_types", cboRace->Text.c_str()).c_str();

  if (checkLacDiabClient->Checked)
    ending_state["lac_diab_client"] = "1";
  else
    ending_state["lac_diab_client"] = "0";
  if (checkAscDiabClient->Checked)
    ending_state["asc_diab_client"] = "1";
  else
    ending_state["asc_diab_client"] = "0";
 if (checkComRefusedServices->Checked)
    ending_state["refused_com_services"] = "1";
  else
    ending_state["refused_com_services"] = "0";
  if (checkPublicRefused->Checked)
    ending_state["refused_public_services"] = "1";
  else
    ending_state["refused_public_services"] = "0";
  if (checkRefused->Checked)
    ending_state["refused_beh_services"] = "1";
  else
    ending_state["refused_beh_services"] = "0";
  if (checkJurisdiction->Checked)
    ending_state["in_beh_jurisdiction"] = "1";
  else
    ending_state["in_beh_jurisdiction"] = "0";
  if (checkPrimarySupport->Checked)
    ending_state["is_primary_support"] = "1";
  else
    ending_state["is_primary_support"] = "0";
  string diab_provider_id = GetValidLinkId(txtProvider);
  if(diab_provider_id == "")
    ending_state["diab_provider_id"] = "0";
  else
    ending_state["diab_provider_id"] = diab_provider_id;
  ending_state["beh_code_id"] = "0";
  ending_state["head_household_id"] = temp_head_of_household;

  ending_state["id"] = initial_state["id"];

  TformRecordGeneric::GetDataFromScreen();

  return true;
}
//---------------------------------------------------------------------------
bool TformRecordPerson::ScreenLock()
{
  // disable panels
  panelGeneral->Enabled = false;
  panelRelations->Enabled = false;
  panelDiabetesGeneral->Enabled = false;
  panelDiabClientCBs->Enabled = false;
  panelBehGeneral->Enabled = false;
  panelComClient->Enabled = false;
  panelPublicClient->Enabled = false;
  panelCaregiverLock->Enabled = false;
  btnProviderSearch->Enabled = false; // jhaley: let's not allow searching for a Diabetes Provider while the form is locked

  TformRecordGeneric::ScreenLock();
  return true;
}
//---------------------------------------------------------------------------
bool TformRecordPerson::ScreenUnlock()
{
  // enable panels
  panelGeneral->Enabled = true;
  panelRelations->Enabled = true;
  //panelDiabetesGeneral->Enabled = true; - jhaley: all these controls are now read-only.
  panelDiabClientCBs->Enabled = true;
  panelBehGeneral->Enabled = true;
  panelComClient->Enabled = true;
  panelPublicClient->Enabled = true; 
  panelCaregiverLock->Enabled = true;
  btnProviderSearch->Enabled = true;

  TformRecordGeneric::ScreenUnlock();
  return true;
}
//---------------------------------------------------------------------------
void TformRecordPerson::SetConstraints()
{
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::comboGenderKeyPress(TObject *Sender,
      char &Key)
{
  FindComboBoxItem(Sender, Key);
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::comboMaritalKeyPress(TObject *Sender,
      char &Key)
{
  FindComboBoxItem(Sender, Key);
}
//---------------------------------------------------------------------------
/*
void __fastcall TformRecordPerson::comboClientTypeKeyPress(TObject *Sender,
      char &Key)
{
  FindComboBoxItem(Sender, Key);
}
*/
//---------------------------------------------------------------------------
bool TformRecordPerson::IsNewAgain()
{
 frameCommonObservations->SetSource(obs_list_none, "0");
 frameClinicObservations->SetSource(obs_list_none, "0");
 frameComObservations->SetSource(obs_list_none, "0");
 framePubObservations->SetSource(obs_list_none, "0");
 frameDiabObservations->SetSource(obs_list_none, "0");

 TformRecordGeneric::IsNewAgain();
 return true;
}
//---------------------------------------------------------------------------
bool TformRecordPerson::NotNewAnymore()
{
  frameCommonObservations->SetSource(obs_list_person, initial_state["id"]);
  frameCommonObservations->UnRestrictByGroups(); // just in case? (not needed)

  vector<string> t;
  t.resize(1);

  frameComObservations->SetSource(obs_list_person, initial_state["id"]);
  t[0] = lookupTables->IdOf("groups", "Community Health");
  frameComObservations->RestrictByGroups(t);

  frameDiabObservations->SetSource(obs_list_person, initial_state["id"]);
  t[0] = lookupTables->IdOf("groups", "Diabetes");
  frameDiabObservations->RestrictByGroups(t);

  framePubObservations->SetSource(obs_list_person, initial_state["id"]);
  t[0] = lookupTables->IdOf("groups", "Public Health");
  framePubObservations->RestrictByGroups(t);

  frameClinicObservations->SetSource(obs_list_person, initial_state["id"]);
  t[0] = lookupTables->IdOf("groups", "Little Axe Clinic");
  t.push_back(lookupTables->IdOf("groups", "Shawnee Clinic")); // just in case, for now?
  frameClinicObservations->RestrictByGroups(t);

  string sql;
  string where;

  // TODO: permissions
  txtPatientProviderInfo->Enabled = true;
  txtDemographics->Enabled = true;
  txtWizard->Enabled = true;
  txtHealthSummary->Enabled = true;
  // debugging only!
  // staticViewFamilyTree->Visible = (optionsPermissions["admin.beta"]["enabled"] == "true");

  if ((optionsPermissions["table.people"]["view"] == "true") &&
      (optionsPermissions["table.person_names"]["view"] == "true") &&
      (optionsPermissions["table.affiliations"]["view"] == "true") &&
      (optionsPermissions["table.person_contact_info"]["view"] == "true") &&
      (optionsPermissions["table.insurance_coverage"]["view"] == "true") &&
      (optionsPermissions["table.insurance_policies"]["view"] == "true") &&
      (optionsPermissions["table.consents"]["view"] == "true"))
  {
    txtUpdate->Enabled = true;
    txtUpdateNoSignature->Enabled = true;
    txtUpdateWMedicalConsent->Enabled = true;
    txtUpdateWDentalConsent->Enabled = true;
  }

//  if(optionsPermissions["table.conditions"]["view"] == "true")
//    txtConditions->Enabled = true;

  if(optionsPermissions["table.procedures"]["view"] == "true")
    txtProcedures->Enabled = true;

  if (optionsPermissions["table.person_names"]["view"] == "true")
  {
    sql = "select case when person_names.id = '" + initial_state["person_names_id"] + "' then '*' else ' ' end, "
          "person_names.prefix, person_names.first_name, person_names.middle_name, "
          "person_names.last_name, person_names.suffix, person_names.current_id, "
          "person_names.id "
          "from person_names "
          "where person_names.person_id = " + initial_state["id"];
    filter_atlas_handler["names"].filter->SetSQLStatement(sql);
    filter_atlas_handler["names"].filter->RefreshDataSet();
    filter_atlas_handler["names"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddName)),
                            EditRecord(&(TformRecordPerson::EditName)));
    filter_atlas_handler["names"].request = atlas->RequestNotificationWhen("person_names.person_id", initial_state["id"], rel_e, as_int, this,
                    RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.affiliations"]["view"] == "true")
  {
    sql = "select case when affiliations.id = '" + initial_state["affiliations_id"] + "' then '*' else ' ' end, "
          "affiliations.cdib, tribe_types.item, affiliations.join_date, "
          "affiliations.relinquish_date, affiliations.current_id, affiliations.id "
          "from affiliations, tribe_types "
          "where affiliations.tribe_id = tribe_types.id and "
          "affiliations.person_id = " + initial_state["id"];
    filter_atlas_handler["affiliations"].filter->SetSQLStatement(sql);
    filter_atlas_handler["affiliations"].filter->RefreshDataSet();
    filter_atlas_handler["affiliations"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddAffiliation)),
                                   EditRecord(&(TformRecordPerson::EditAffiliation)));
    filter_atlas_handler["affiliations"].request = atlas->RequestNotificationWhen("affiliations.person_id", initial_state["id"], rel_e, as_int, this,
                           RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.enrollment"]["view"] == "true")
  {
    sql = "select ET.item, E.enrollment_number, ES.item, E.admit_date, E.remit_date, E.comments, E.current_id, E.id "
          "from enrollment E "
          "inner join enrollment_types ET on E.enrollment_id = ET.id "
          "inner join enrollment_status_types ES on E.enrollment_status_id = ES.id "
          "where E.person_id = " + initial_state["id"];
    filter_atlas_handler["enrollment"].filter->SetSQLStatement(sql);
    filter_atlas_handler["enrollment"].filter->RefreshDataSet();
    filter_atlas_handler["enrollment"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddEnrollment)),
                                   EditRecord(&(TformRecordPerson::EditEnrollment)));
    filter_atlas_handler["enrollment"].request = atlas->RequestNotificationWhen("enrollment.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.person_contact_info"]["view"] == "true")
  {
    sql = "select case when person_contact_info.id = '" + initial_state["mailing_address_id"] + "' then 'MA ' else cast('' as varchar(3)) end || "
                 "case when person_contact_info.id = '" + initial_state["home_address_id"] + "' then 'HA ' else cast('' as varchar(3)) end || "
                 "case when person_contact_info.id = '" + initial_state["work_address_id"] + "' then 'WA ' else cast('' as varchar(3)) end || "
                 "case when person_contact_info.id = '" + initial_state["home_phone_id"] + "' then 'HP ' else cast('' as varchar(3)) end || "
                 "case when person_contact_info.id = '" + initial_state["work_phone_id"] + "' then 'WP ' else cast('' as varchar(3)) end || "
                 "case when person_contact_info.id = '" + initial_state["cell_phone_id"] + "' then 'CP ' else cast('' as varchar(3)) end, "
          "contact_info_types.item place, "
          "person_contact_info.line1 || case when person_contact_info.line2 != '' then ' ' || person_contact_info.line2 else '' end address, "
          "person_contact_info.city, state_types.abbreviation state, "
          "person_contact_info.zip, country_types.item country, "
          "residence_types.item residence, person_contact_info.trust_lands, "
          "person_contact_info.phone_number, person_contact_info.email_address, "
          "person_contact_info.notes, "
          "person_contact_info.current_id, person_contact_info.id "
          "from person_contact_info, contact_info_types, state_types, "
          "country_types, residence_types "
          "where contact_info_types.id = person_contact_info.contact_info_id and "
          "state_types.id = person_contact_info.state_id and "
          "country_types.id = person_contact_info.country_id and "
          "residence_types.id = person_contact_info.residence_id and "
          "person_contact_info.person_id = " + initial_state["id"];
    filter_atlas_handler["contacts"].filter->SetSQLStatement (sql);
    filter_atlas_handler["contacts"].filter->RefreshDataSet();
    filter_atlas_handler["contacts"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddContactInfo)),
                               EditRecord(&(TformRecordPerson::EditContactInfo)));
    filter_atlas_handler["contacts"].request = atlas->RequestNotificationWhen("person_contact_info.person_id", initial_state["id"], rel_e, as_int, this,
                       RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.consents"]["view"] == "true")
  {
    sql = "select consents.signature_date, consent_types.item, consents.note, "
          "groups.item, event_name_types.item, "
          "consents.current_id, consents.id "
          "from consents, consent_types, participations, events, groups, event_name_types "
          "where consents.consent_id = consent_types.id and "
          "consents.participations_id = participations.id and "
          "participations.event_id = events.id and "
          "events.event_name_id = event_name_types.id and "
          "consents.group_id = groups.id and "
          "consents.person_id = " + initial_state["id"];
    filter_atlas_handler["consents"].filter->SetSQLStatement (sql);
    filter_atlas_handler["consents"].filter->RefreshDataSet();
    filter_atlas_handler["consents"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddConsent)),
                               EditRecord(&(TformRecordPerson::EditConsent)));
    filter_atlas_handler["consents"].request = atlas->RequestNotificationWhen("consents.person_id", initial_state["id"], rel_e, as_int, this,
                       RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.appointments.people"]["view"] == "true")
  {
    sql = "select tax_entities.name, "
          //"appointments.repeating_string || '|' || appointments.begin_date || '|' || appointments.end_date, " // WTF?
          "appointments.begin_date, "
          "appointments.appointment_time, appointments.description, "
          "users.item, visit_outcome_types.item, appointments.current_id, appointments.id "
          "from appointments "
          "inner join users on appointments.created_for = users.id "
          "inner join visit_outcome_types on appointments.visit_outcome_id = visit_outcome_types.id "
          "inner join tax_entities on appointments.tax_entity_id = tax_entities.id "
          "where appointments.person_id = " + initial_state["id"];
    filter_atlas_handler["appointments"].filter->SetSQLStatement (sql);
    filter_atlas_handler["appointments"].filter->RefreshDataSet();
    filter_atlas_handler["appointments"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddAppointment)),
                               EditRecord(&(TformRecordPerson::EditAppointment)));
    filter_atlas_handler["appointments"].request = atlas->RequestNotificationWhen("appointments.person_id", initial_state["id"], rel_e, as_int, this,
                          RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.referrals"]["view"] == "true")
  {
    sql = "select referrals.date_of_referral, a.name, b.name, c.name, d.name, referral_reason_types.item, "
          "referrals.current_id, referrals.id "
          "from referrals, tax_entities a, tax_entities b, tax_entities c, tax_entities d, referral_reason_types "
          "where referrals.by_facility_id = a.id and "
          "referrals.by_provider_id = b.id and "
          "referrals.to_facility_id = c.id and "
          "referrals.to_provider_id = d.id and "
          "referrals.referral_reason_id = referral_reason_types.id and "
          "referrals.person_id = " + initial_state["id"];
    filter_atlas_handler["referrals"].filter->SetSQLStatement (sql);
    filter_atlas_handler["referrals"].filter->RefreshDataSet();
    filter_atlas_handler["referrals"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddReferral)),
                               EditRecord(&(TformRecordPerson::EditReferral)));
    filter_atlas_handler["referrals"].request = atlas->RequestNotificationWhen("referrals.person_id", initial_state["id"], rel_e, as_int, this,
                          RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.person_notes.diab"]["view"] == "true")
  {
    sql = "select cast(person_notes.last_update_stamp as date), "
          "person_notes.note, person_notes.current_id, person_notes.id "
          "from person_notes "
          "where person_notes.group_id = " + lookupTables->IdOf("groups", "Diabetes") +
          "and person_notes.person_id = " + initial_state["id"] + " order by person_notes.last_update_stamp";
    filter_atlas_handler["diab_notes"].filter->SetSQLStatement(sql);
    filter_atlas_handler["diab_notes"].filter->RefreshDataSet();
    filter_atlas_handler["diab_notes"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddDiabPersonNote)),
                                 EditRecord(&(TformRecordPerson::EditDiabPersonNote)));
    filter_atlas_handler["diab_notes"].request = atlas->RequestNotificationWhen("person_notes.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.conditions.diab"]["view"] == "true")
  {
    sql = "select condition_types.item, conditions.start_date, conditions.stop_date, "
          "conditions.code, conditions.note, conditions.current_id, conditions.id "
          "from conditions, condition_types "
          "where conditions.condition_id = condition_types.id and "
          "conditions.person_id = " + initial_state["id"] + " and "
          "conditions.group_id = " + lookupTables->IdOf("groups", "Diabetes");
    filter_atlas_handler["diab_conditions"].filter->SetSQLStatement(sql);
    filter_atlas_handler["diab_conditions"].filter->RefreshDataSet();
    filter_atlas_handler["diab_conditions"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddDiabCondition)),
                                  EditRecord(&(TformRecordPerson::EditDiabCondition)));
    filter_atlas_handler["diab_conditions"].request = atlas->RequestNotificationWhen("conditions.person_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.fitness_people"]["view"] == "true")
  {
    sql = "select fit_facility_types.item facility, fitness_memberships.begin_date, "
          "fitness_memberships.end_date,fitness_memberships.is_waiting, "
          "fitness_memberships.waiting_list_date, fitness_memberships.comments, "
          "fitness_memberships.current_id, fitness_memberships.id "
          "from fitness_memberships, fit_facility_types, fitness_people "
           "where fitness_memberships.fit_facility_id = fit_facility_types.id and "
          "fitness_people.fitness_membership_id = fitness_memberships.id and "
          "fitness_people.person_id = " + initial_state["id"];
    filter_atlas_handler["fitness"].filter->SetSQLStatement(sql);
    filter_atlas_handler["fitness"].filter->RefreshDataSet();
    filter_atlas_handler["fitness"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddFitnessMembership)),
                               EditRecord(&(TformRecordPerson::EditFitnessMembership)));
    filter_atlas_handler["fitness"].request = atlas->RequestNotificationWhen("fitness_people.person_id", initial_state["id"], rel_any, as_int, this,
                       RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.fitness_attendance"]["view"] == "true")
  {
    sql = "select fit_facility_types.item, fitness_attendance.date_of_attendance, "
          "fitness_attendance.current_id, fitness_attendance.id "
          "from fit_facility_types, fitness_attendance, fitness_memberships "
          "where fitness_attendance.person_id = " + initial_state["id"] + " and "
          "fitness_attendance.fitness_membership_id = fitness_memberships.id and "
          "fitness_memberships.fit_facility_id = fit_facility_types.id "
          "order by fitness_attendance.date_of_attendance";
    filter_atlas_handler["fitness_attendance"].filter->SetSQLStatement(sql);
    filter_atlas_handler["fitness_attendance"].filter->RefreshDataSet();
    filter_atlas_handler["fitness_attendance"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddFitnessAttendance)),
                               EditRecord(&(TformRecordPerson::EditFitnessAttendance)));
    filter_atlas_handler["fitness_attendance"].request = atlas->RequestNotificationWhen("fitness_attendance.person_id", initial_state["id"], rel_e, as_int, this,
                       RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.tasks.diab"]["view"] == "true")
  {
    sql = "select tasks.date_of_task, users.item, event_name_types.item, tasks.time_spent, tasks.mileage, "
          "diab_contact_types.item, method_types.item, direction_types.item, program_types.item, "
          "task_purpose_types.item, classification_types.item, "
          "diab_meeting_types.item, diab_activity_types.item, tasks.is_educational, tasks.is_personal, "
          "tasks.task_comments, tasks.current_id, tasks.id "
          "from tasks "
          "inner join users on tasks.user_id = users.id "
          "inner join events on tasks.event_id = events.id "
          "inner join event_name_types on events.event_name_id = event_name_types.id "
          "inner join diab_contact_types on tasks.diab_contact_id = diab_contact_types.id "
          "inner join method_types on tasks.method_id = method_types.id "
          "inner join direction_types on tasks.direction_id = direction_types.id "
          "inner join program_types on tasks.program_id = program_types.id "
          "inner join task_purpose_types on tasks.task_purpose_id = task_purpose_types.id "
          "inner join classification_types on tasks.classification_id = classification_types.id "
          "inner join diab_meeting_types on tasks.diab_meeting_id = diab_meeting_types.id "
          "inner join diab_activity_types on tasks.diab_activity_id = diab_activity_types.id "
          "where tasks.group_id = " + lookupTables->IdOf("groups", "Diabetes") + " and "
          "tasks.person_id = " + initial_state["id"];
    filter_atlas_handler["diab_task"].filter->SetSQLStatement(sql);
    filter_atlas_handler["diab_task"].filter->RefreshDataSet();
    filter_atlas_handler["diab_task"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddDiabTask)),
                                EditRecord(&(TformRecordPerson::EditDiabTask)));
    filter_atlas_handler["diab_task"].request = atlas->RequestNotificationWhen("tasks.person_id", initial_state["id"], rel_e, as_int, this,
                        RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.diab_education"]["view"] == "true")
  {
    sql = "select diab_topic_types.item, diab_education.pre_test_date, diab_education.pre_score, "
          "diab_education.post_test_date, diab_education.post_score, diab_education.note, "
          "diab_education.current_id, diab_education.id "
          "from diab_education, diab_topic_types "
          "where diab_education.diab_topic_id = diab_topic_types.id and "
          "diab_education.person_id = " + initial_state["id"];
    filter_atlas_handler["diab_education"].filter->SetSQLStatement(sql);
    filter_atlas_handler["diab_education"].filter->RefreshDataSet();
    filter_atlas_handler["diab_education"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddDiabEducation)),
                                EditRecord(&(TformRecordPerson::EditDiabEducation)));
    filter_atlas_handler["diab_education"].request = atlas->RequestNotificationWhen("diab_education.person_id", initial_state["id"], rel_e, as_int, this,
                             RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.participations.diab"]["view"] == "true")
  {
    sql = "select events.date_of_event, event_name_types.item, event_type_types.item, case "
          "when event_location_types.zip_code_id = 0 then event_location_types.item "
          "when event_location_types.item = '' then (zip_codes.city || ', ' || zip_codes.state) "
          "else (zip_codes.city || ', ' || zip_codes.state || ' - ' || event_location_types.item) end location_item, "
          "events.number_attended, events.description, diab_special_types.item, participations.note, "
          "participations.current_id, participations.id "
          "from events "
          "inner join event_name_types on events.event_name_id = event_name_types.id "
          "inner join event_type_types on events.event_type_id = event_type_types.id "
          "inner join event_location_types on events.event_location_id = event_location_types.id "
          "inner join zip_codes on event_location_types.zip_code_id = zip_codes.id "
          "inner join participations on participations.event_id = events.id "
          "inner join diab_special_types on participations.diab_special_id = diab_special_types.id "
          "where events.group_id = '" + lookupTables->IdOf("groups", "Diabetes") + "' and "
          "participations.person_id = '" + initial_state["id"] + "' ";

    filter_atlas_handler["diab_event"].filter->SetSQLStatement(sql);
    filter_atlas_handler["diab_event"].filter->RefreshDataSet();
    filter_atlas_handler["diab_event"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddDiabParticipation)),
                                 EditRecord(&(TformRecordPerson::EditDiabParticipation)));
    filter_atlas_handler["diab_event"].request = atlas->RequestNotificationWhen("participations.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }
  if (optionsPermissions["table.activity_logsheets"]["view"] == "true")
  {
    sql = "select activity_logsheets.date_turned_in, activity_logsheets.begin_date, "
          "activity_logsheets.end_date, count(activities.id), activity_logsheets.current_id, activity_logsheets.id "
          "from activity_logsheets left join activities on activities.activity_logsheet_id = activity_logsheets.id "
          "where activity_logsheets.person_id = " + initial_state["id"] + " " +
          "group by activity_logsheets.id, activity_logsheets.current_id, activity_logsheets.last_update_stamp, "
          "activity_logsheets.last_updated_by, activity_logsheets.person_id, activity_logsheets.date_turned_in, "
          "activity_logsheets.begin_date, activity_logsheets.end_date";
    filter_atlas_handler["diab_logsheet"].filter->SetSQLStatement(sql);
    filter_atlas_handler["diab_logsheet"].filter->RefreshDataSet();
    filter_atlas_handler["diab_logsheet"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddDiabLogsheet)),
                                    EditRecord(&(TformRecordPerson::EditDiabLogsheet)));
    filter_atlas_handler["diab_logsheet"].request = atlas->RequestNotificationWhen("activity_logsheets.person_id", initial_state["id"], rel_e, as_int, this,
                            RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
    filter_atlas_handler["diab_logsheet_activity"].request = atlas->RequestNotificationWhen("activities.person_id", initial_state["id"], rel_e, as_int, this,
                                     RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if(optionsPermissions["table.incentives"]["view"] == "true")
  {
    sql = "select incentives.date_received, incentive_types.item, shirt_types.item, shirt_size_types.item, "
          "incentives.date_sent_to_finance, incentives.check_number, incentives.amount, "
          "shoe_types.item, shoe_size_types.item, incentives.date_ordered, "
          "incentives.received_from_nike, incentives.received_by_person, incentives.note, "
          "incentives.current_id, incentives.id "
          "from incentives, incentive_types, shirt_types, shirt_size_types, "
          "shoe_types, shoe_size_types "
          "where incentives.incentive_id = incentive_types.id and "
          "incentives.shirt_id = shirt_types.id and "
          "incentives.shirt_size_id = shirt_size_types.id and "
          "incentives.shoe_id = shoe_types.id and "
          "incentives.shoe_size_id = shoe_size_types.id and "
          "incentives.person_id = " + initial_state["id"];
    filter_atlas_handler["incentives"].filter->SetSQLStatement(sql);
    filter_atlas_handler["incentives"].filter->RefreshDataSet();
    filter_atlas_handler["incentives"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddIncentive)),
                                 EditRecord(&(TformRecordPerson::EditIncentive)));
    filter_atlas_handler["incentive"].request = atlas->RequestNotificationWhen("incentives.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if(optionsPermissions["table.goals"]["view"] == "true")
  {
    sql = "select goals.date_entered, activity_level_types.item, frequency_types.item, length_types.item, "
          "goals.activity_goal, goals.times_goal, goals.amount_goal, goals.current_id, "
          "goals.id "
          "from goals, activity_level_types, frequency_types, length_types "
          "where goals.activity_level_id = activity_level_types.id and "
          "goals.frequency_id = frequency_types.id and "
          "goals.length_id = length_types.id and "
          "goals.person_id = " + initial_state["id"];
    filter_atlas_handler["goals"].filter->SetSQLStatement(sql);
    filter_atlas_handler["goals"].filter->RefreshDataSet();
    filter_atlas_handler["goals"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddGoal)),
                                 EditRecord(&(TformRecordPerson::EditGoal)));
    filter_atlas_handler["goal"].request = atlas->RequestNotificationWhen("goals.person_id", initial_state["id"], rel_e, as_int, this,
                   RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.beh_treatment"]["view"] == "true")
  {
    sql = "select beh_treatment.admit_date, beh_treatment.discharge_date, "
          "beh_discharge_types.item, beh_treatment.comments, "
          "beh_treatment.current_id, beh_treatment.id "
          "from beh_treatment, beh_discharge_types "
          "where beh_treatment.beh_discharge_id = beh_discharge_types.id and "
          "beh_treatment.person_id = " + initial_state["id"];
    filter_atlas_handler["beh_local_treatment"].filter->SetSQLStatement(sql);
    filter_atlas_handler["beh_local_treatment"].filter->RefreshDataSet();
    filter_atlas_handler["beh_local_treatment"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddBehTreatment)),
                                          EditRecord(&(TformRecordPerson::EditBehTreatment)));
    filter_atlas_handler["beh_local_treatment"].request = atlas->RequestNotificationWhen("beh_treatment.person_id", initial_state["id"], rel_e, as_int, this,
                                 RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.beh_out_treatment"]["view"] == "true")
  {
    sql = "select tax_entities.name, patient_types.item, beh_out_treatment.begin_date, "
          "beh_out_treatment.end_date, beh_out_treatment.doctor_name, beh_out_treatment.medications, "
          "beh_out_treatment.notes, beh_out_treatment.current_id, beh_out_treatment.id "
          "from beh_out_treatment, tax_entities, patient_types "
          "where beh_out_treatment.tax_entity_id = tax_entities.id and "
          "beh_out_treatment.patient_id = patient_types.id and "
          "beh_out_treatment.person_id = " + initial_state["id"];
    filter_atlas_handler["beh_out_treatment"].filter->SetSQLStatement(sql);
    filter_atlas_handler["beh_out_treatment"].filter->RefreshDataSet();
    filter_atlas_handler["beh_out_treatment"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddBehOutTreatment)),
                                        EditRecord(&(TformRecordPerson::EditBehOutTreatment)));
    filter_atlas_handler["beh_out_treatment"].request = atlas->RequestNotificationWhen("beh_out_treatment.person_id", initial_state["id"], rel_e, as_int, this,
                                RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.person_notes.beh"]["view"] == "true")
  {
    sql = "select person_notes.note, person_notes.current_id, person_notes.id "
          "from person_notes "
          "where person_notes.group_id = " + lookupTables->IdOf("groups", "Behavioral Health") +
          " and person_notes.person_id = " + initial_state["id"];
    filter_atlas_handler["beh_notes"].filter->SetSQLStatement(sql);
    filter_atlas_handler["beh_notes"].filter->RefreshDataSet();
    filter_atlas_handler["beh_notes"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddBehPersonNote)),
                                  EditRecord(&(TformRecordPerson::EditBehPersonNote)));
    filter_atlas_handler["beh_notes"].request = atlas->RequestNotificationWhen("person_notes.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.forms.beh"]["view"] == "true")
  {
    sql = "select form_types.item, forms.date_of_completion, forms.note, forms.current_id, forms.id "
          "from forms "
          "inner join form_types on forms.form_id = form_types.id "
          "where forms.group_id = " + lookupTables->IdOf("groups", "Behavioral Health") +
          " and forms.person_id = " + initial_state["id"];
    filter_atlas_handler["beh_forms"].filter->SetSQLStatement(sql);
    filter_atlas_handler["beh_forms"].filter->RefreshDataSet();
    filter_atlas_handler["beh_forms"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddBehForm)),
                                  EditRecord(&(TformRecordPerson::EditBehForm)));
    filter_atlas_handler["beh_forms"].request = atlas->RequestNotificationWhen("forms.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.tasks.beh"]["view"] == "true")
  {
    sql = "select tasks.date_of_task, users.item, event_name_types.item, "
          "tasks.time_spent, tasks.mileage, method_types.item, "
          "direction_types.item, classification_types.item, beh_meeting_types.item, "
          "beh_activity_types.item, program_types.item, task_purpose_types.item, tasks.task_comments, "
          "tasks.new_client, beh_visit_types.item, visit_location_types.item, "
          "visit_outcome_types.item, tasks.visit_time_spent, tasks.visit_comments, "
          "tasks.current_id, tasks.id "
          "from tasks "
          "inner join users on tasks.user_id = users.id "
          "inner join events on tasks.event_id = events.id "
          "inner join event_name_types on events.event_name_id = event_name_types.id "
          "inner join method_types on tasks.method_id = method_types.id "
          "inner join direction_types on tasks.direction_id = direction_types.id "
          "inner join beh_meeting_types on tasks.beh_meeting_id = beh_meeting_types.id "
          "inner join classification_types on tasks.classification_id = classification_types.id "
          "inner join beh_activity_types on tasks.beh_activity_id = beh_activity_types.id "
          "inner join program_types on tasks.program_id = program_types.id "
          "inner join task_purpose_types on tasks.task_purpose_id = task_purpose_types.id "
          "inner join beh_visit_types on tasks.beh_visit_id = beh_visit_types.id "
          "inner join visit_location_types on tasks.visit_location_id = visit_location_types.id "
          "inner join visit_outcome_types on tasks.visit_outcome_id = visit_outcome_types.id "
          "where tasks.id > 0 and "
          "tasks.group_id = " + lookupTables->IdOf("groups", "Behavioral Health") + " and "
          "tasks.person_id = " + initial_state["id"];

    filter_atlas_handler["beh_task"].filter->SetSQLStatement(sql);
    filter_atlas_handler["beh_task"].filter->RefreshDataSet();
    filter_atlas_handler["beh_task"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddBehTask)),
                                EditRecord(&(TformRecordPerson::EditBehTask)));
    filter_atlas_handler["beh_task"].request = atlas->RequestNotificationWhen("tasks.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.participations.beh"]["view"] == "true")
  {
    sql = "select events.date_of_event, event_name_types.item, event_type_types.item, case "
          "when event_location_types.zip_code_id = 0 then event_location_types.item "
          "when event_location_types.item = '' then (zip_codes.city || ', ' || zip_codes.state) "
          "else (zip_codes.city || ', ' || zip_codes.state || event_location_types.item) end location_item, "
          "events.number_attended, events.description, participations.current_id, participations.id "
          "from participations "
          "inner join events on participations.event_id = events.id "
          "inner join event_name_types on events.event_name_id = event_name_types.id "
          "inner join event_type_types on events.event_type_id = event_type_types.id "
          "inner join event_location_types on events.event_location_id = event_location_types.id "
          "inner join zip_codes on event_location_types.zip_code_id = zip_codes.id "
          "where participations.person_id = '" + initial_state["id"] + "' and "
          "events.group_id = '" + lookupTables->IdOf("groups", "Behavioral Health") + "' ";
    filter_atlas_handler["beh_event"].filter->SetSQLStatement(sql);
    filter_atlas_handler["beh_event"].filter->RefreshDataSet();
    filter_atlas_handler["beh_event"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddBehParticipation)),
                                EditRecord(&(TformRecordPerson::EditBehParticipation)));
    filter_atlas_handler["beh_event"].request = atlas->RequestNotificationWhen("participations.person_id", initial_state["id"], rel_e, as_int, this,
                        RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.conditions.beh"]["view"] == "true")
  {
    sql = "select condition_types.item, conditions.start_date, conditions.stop_date, "
          "conditions.code, conditions.note, conditions.current_id, conditions.id "
          "from conditions, condition_types "
          "where conditions.condition_id = condition_types.id and "
          "conditions.person_id = " + initial_state["id"] + " and "
          "conditions.group_id = " + lookupTables->IdOf("groups", "Behavioral Health");
    filter_atlas_handler["beh_conditions"].filter->SetSQLStatement(sql);
    filter_atlas_handler["beh_conditions"].filter->RefreshDataSet();
    filter_atlas_handler["beh_conditions"].filter->SetAddEdit(this, NULL /*AddRecord(&(TformRecordPerson::AddBehCondition))*/,
                                  EditRecord(&(TformRecordPerson::EditBehCondition)));
    filter_atlas_handler["beh_conditions"].request = atlas->RequestNotificationWhen("conditions.person_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.procedures"]["view"] == "true")
  {
    sql = "select procedures.start_date, procedures.stop_date, procedures.place_of_service, "
          "procedures.type_of_service, procedures.cpt_hcpcs, procedures.modifier, "
          "procedures.charges, procedures.days_units, procedures.epsdt, procedures.emg, procedures.cob, "
          "procedures.local_use, procedures.current_id, procedures.id "
          "from procedures, tasks "
          "where procedures.task_id = tasks.id and "
          "tasks.group_id = " + lookupTables->IdOf("groups", "Behavioral Health") + " and "
          "tasks.person_id = " + initial_state["id"];
    filter_atlas_handler["beh_procedures"].filter->SetSQLStatement(sql);
    filter_atlas_handler["beh_procedures"].filter->RefreshDataSet();
    filter_atlas_handler["beh_procedures"].filter->SetAddEdit(this, NULL, EditRecord(&(TformRecordPerson::EditBehProcedure)));
    filter_atlas_handler["beh_procedure"].request = atlas->RequestNotificationWhen("procedures.id", initial_state["id"], rel_any, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.tasks.com"]["view"] == "true")
  {
    sql = "select tasks.date_of_task, users.item, "
          "com_visit_types.item, visit_location_types.item,visit_outcome_types.item, "
          "tasks.mileage, tasks.time_spent, "
          "tasks.com_dept_id, tasks.current_id, tasks.id "
          "from tasks, users, com_visit_types, visit_location_types, visit_outcome_types, com_dept_types "
          "where tasks.person_id = " + initial_state["id"] + " and "
          "tasks.visit_location_id = visit_location_types.id and "
          "tasks.visit_outcome_id = visit_outcome_types.id  and "
          "tasks.com_visit_id = com_visit_types.id and "
          "tasks.com_dept_id = com_dept_types.id and "
          "tasks.user_id = users.id and "
//          "tasks.group_id = " + lookupTables->IdOf("groups", "Community Health");
          "tasks.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
          "tasks.com_dept_id > 0";  // added so the filter wouldn't pull phone tasks (they have their own list view and should come up on a different screen)

    filter_atlas_handler["community_visit"].filter->SetSQLStatement(sql);
    filter_atlas_handler["community_visit"].filter->RefreshDataSet();
    filter_atlas_handler["community_visit"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddComVisit)),
                                            EditRecord (&(TformRecordPerson::EditComVisit)));
    filter_atlas_handler["community_visit"].request = atlas->RequestNotificationWhen("tasks.person_id", initial_state["id"], rel_e, as_int, this,
                               RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.task_notes.com"]["view"] == "true")
  {
    sql =  "select task_notes.note, task_notes.current_id, task_notes.id "
           "from task_notes "
           "inner join tasks on tasks.person_id = " + initial_state["id"] +
           "where tasks.current_id >= 3 and "
           "task_notes.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
           "task_notes.task_id = tasks.id ";

    filter_atlas_handler["community_comments"].filter->SetSQLStatement(sql);
    filter_atlas_handler["community_comments"].filter->RefreshDataSet();
    filter_atlas_handler["community_comments"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddComComments)),
                                         EditRecord (&(TformRecordPerson::EditComComments)));
    filter_atlas_handler["community_comments"].request = atlas->RequestNotificationWhen("task_notes.task_id", initial_state["task_id"], rel_any,
                                   as_int, this, RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }
  if (optionsPermissions["table.conditions.com"]["view"] == "true")
  {
    sql = "select condition_types.item, conditions.start_date, conditions.stop_date, "
          "conditions.code, conditions.note, conditions.current_id, conditions.id "
          "from conditions, condition_types "
          "where conditions.condition_id = condition_types.id and "
          "conditions.person_id = " + initial_state["id"] + " and "
          "conditions.group_id = " + lookupTables->IdOf("groups", "Community Health");

    filter_atlas_handler["community_conditions"].filter->SetSQLStatement(sql);
    filter_atlas_handler["community_conditions"].filter->RefreshDataSet();
    filter_atlas_handler["community_conditions"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddComConditions)),
                                            EditRecord (&(TformRecordPerson::EditComConditions)));
    filter_atlas_handler["community_conditions"].request = atlas->RequestNotificationWhen("conditions.task_id", initial_state["task_id"], rel_any, as_int, this,
                               RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }


  if (optionsPermissions["table.tasks.com"]["view"] == "true")
  {
    sql = "select tasks.date_of_task, users.item, event_name_types.item, "
          "tasks.time_spent, tasks.mileage, method_types.item, "
          "direction_types.item, task_purpose_types.item, classification_types.item, com_meeting_types.item, "
          "com_activity_types.item, tasks.task_comments,  "
          "tasks.current_id, tasks.id "
          "from tasks "
          "inner join users on tasks.user_id = users.id "
          "inner join events on tasks.event_id = events.id "
          "inner join method_types on tasks.method_id = method_types.id "
          "inner join direction_types on tasks.direction_id = direction_types.id "
          "inner join task_purpose_types on tasks.task_purpose_id = task_purpose_types.id "
          "inner join com_meeting_types on tasks.com_meeting_id = com_meeting_types.id "
          "inner join classification_types on tasks.classification_id = classification_types.id "
          "inner join com_activity_types on tasks.com_activity_id = com_activity_types.id "
          "inner join event_name_types on events.event_name_id = event_name_types.id "
          "where tasks.id > 0 and "
          "tasks.group_id = '" + lookupTables->IdOf("groups", "Community Health") + "' and "
          "tasks.person_id = '" + initial_state["id"] + "' and "
          "tasks.com_dept_id = 0";  // added so the filter wouldn't pull visits (they have their own list view and should come up on a different screen)

    filter_atlas_handler["community_task"].filter->SetSQLStatement(sql);
    filter_atlas_handler["community_task"].filter->RefreshDataSet();
    filter_atlas_handler["community_task"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddComTask)),
                                           EditRecord(&(TformRecordPerson::EditComTask)));
    filter_atlas_handler["community_task"].request = atlas->RequestNotificationWhen("tasks.person_id", initial_state["id"], rel_e, as_int, this,
                               RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.patient_assessment"]["view"] == "true")
  {
    sql = "select (PN.last_name || ', ' || PN.first_name), T.date_of_task, PA.current_id, PA.id "
          "from patient_assessment PA "
          "inner join tasks  T on PA.task_id = T.id "
          "inner join people P on T.person_id = P.id "
          "left  join person_names PN on P.person_names_id = PN.id "
          "where T.id > 0 and "
          "T.group_id = '" + lookupTables->IdOf("groups", "Community Health") + "' and "
          "T.person_id = '" + initial_state["id"] + "' ";

    filter_atlas_handler["community_assessment"].filter->SetSQLStatement(sql);
    filter_atlas_handler["community_assessment"].filter->RefreshDataSet();
    filter_atlas_handler["community_assessment"].filter->SetAddEdit(this,
                                                                    AddRecord(&TformRecordPerson::AddComAssessment),
                                                                    EditRecord(&TformRecordPerson::EditComAssessment));
    filter_atlas_handler["community_assessment"].request =
      atlas->RequestNotificationWhen("tasks.person_id", initial_state["id"], rel_e, as_int, this,
                                     RefreshHandler(&TformRecordPerson::AtlasRefreshListViews));
  }

  if (optionsPermissions["table.com_health_edu"]["view"] == "true")
  {
    sql = "select com_adult_topic_types.item, "
          "com_learner_types.item, com_method_types.item, com_evaluation_types.item, "
          "com_health_edu.current_id, com_health_edu.id "
          "from com_health_edu, com_learner_types, com_adult_topic_types, com_method_types, com_evaluation_types "
          "inner join tasks on tasks.person_id = " + initial_state["id"] +
          "where com_learner_types.id = com_health_edu.com_learner_id and "
          "com_adult_topic_types.id = com_health_edu.com_adult_topic_id and "
          "com_method_types.id = com_health_edu.com_method_id and "
          "com_evaluation_types.id = com_evaluation_id and "
          "com_health_edu.task_id = tasks.id and "
          "com_health_edu.group_id = " + lookupTables->IdOf("groups", "Community Health");

    filter_atlas_handler["community_edu"].filter->SetSQLStatement(sql);
    filter_atlas_handler["community_edu"].filter->RefreshDataSet();
    filter_atlas_handler["community_edu"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddComEdu)),
                                           EditRecord (&(TformRecordPerson::EditComEdu)));
    filter_atlas_handler["community_edu"].request = atlas->RequestNotificationWhen("com_health_edu.task_id", initial_state["task_id"], rel_any, as_int, this,
                             RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }
  if (optionsPermissions["table.com_drug_regimen"]["view"] == "true")
  {
    sql = "select com_drug_regimen.medication, com_drug_regimen.dosage, com_medication_types.item, "
          "com_frequency_types.item, com_drug_regimen.rx_number, com_status_types.item, "
          "com_drug_regimen.person_id, com_drug_regimen.date_ordered, com_drug_regimen.date_discontinued, "
          "com_drug_regimen.id, com_drug_regimen.current_id "
          "from com_drug_regimen, com_medication_types, "
          "com_frequency_types, com_status_types where  "
          "com_frequency_types.id = com_drug_regimen.com_frequency_id and "
          "com_medication_types.id = com_drug_regimen.com_medication_id and "
          "com_status_types.id = com_drug_regimen.com_status_id and "
          "com_drug_regimen.group_id = " + lookupTables->IdOf("groups", "Community Health") + " and "
          "com_drug_regimen.person_id = " + initial_state["id"];



    filter_atlas_handler["community_drug"].filter->SetSQLStatement(sql);
    filter_atlas_handler["community_drug"].filter->RefreshDataSet();
    filter_atlas_handler["community_drug"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddComDrug)),
                                            EditRecord (&(TformRecordPerson::EditComDrug)));
    filter_atlas_handler["community_drug"].request = atlas->RequestNotificationWhen("com_drug_regimen.person_id", initial_state["id"], rel_any, as_int, this,
                               RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }
   
  if (optionsPermissions["table.participations.com"]["view"] == "true")
  {
    sql = "select events.date_of_event, event_name_types.item, event_type_types.item, case "
          "when event_location_types.zip_code_id = 0 then event_location_types.item "
          "when event_location_types.item = '' then (zip_codes.city || ', ' || zip_codes.state) "
          "else (zip_codes.city || ', ' || zip_codes.state || ' - ' || event_location_types.item) end location_item, "
          "events.number_attended, events.description, "
          "participations.note, participations.current_id, participations.id "
          "from events "
          "inner join event_type_types on events.event_type_id = event_type_types.id "
          "inner join event_location_types on events.event_location_id = event_location_types.id "
          "inner join zip_codes on event_location_types.zip_code_id = zip_codes.id "
          "inner join participations on participations.event_id = events.id "
          "inner join event_name_types on events.event_name_id = event_name_types.id "
          "where events.group_id = '" + lookupTables->IdOf("groups", "Community Health") + "' and "
          "participations.person_id = '" + initial_state["id"] + "' ";

    filter_atlas_handler["community_event"].filter->SetSQLStatement(sql);
    filter_atlas_handler["community_event"].filter->RefreshDataSet();
    filter_atlas_handler["community_event"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddComParticipation)),
                                 EditRecord(&(TformRecordPerson::EditComParticipation)));
    filter_atlas_handler["community_event"].request = atlas->RequestNotificationWhen("participations.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

   //public health
  if (optionsPermissions["table.tasks.pub"]["view"] == "true")
  {
    sql = "select tasks.date_of_task, users.item, "
          "com_visit_types.item, visit_location_types.item,visit_outcome_types.item, "
          "tasks.mileage, tasks.time_spent, "
          "tasks.com_dept_id, tasks.current_id, tasks.id "
          "from tasks, users, com_visit_types, visit_location_types, visit_outcome_types, com_dept_types "
          "where tasks.person_id = " + initial_state["id"] + " and "
          "tasks.visit_location_id = visit_location_types.id and "
          "tasks.visit_outcome_id = visit_outcome_types.id  and "
          "tasks.com_visit_id = com_visit_types.id and "
          "tasks.com_dept_id = com_dept_types.id and "
          "tasks.user_id = users.id and "
          "tasks.com_visit_id > 0 and "  // added so the filter wouldn't pull phone tasks (they should come up on a different screen)
          "tasks.group_id = " + lookupTables->IdOf("groups", "Public Health");

    filter_atlas_handler["public_visit"].filter->SetSQLStatement(sql);
    filter_atlas_handler["public_visit"].filter->RefreshDataSet();
    filter_atlas_handler["public_visit"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddPublicVisit)),
                                            EditRecord (&(TformRecordPerson::EditPublicVisit)));
    filter_atlas_handler["public_visit"].request = atlas->RequestNotificationWhen("tasks.person_id", initial_state["id"], rel_any, as_int, this,
                               RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.task_notes.pub"]["view"] == "true")
  {
   sql =  "select task_notes.note, task_notes.current_id, "
          "task_notes.id from tasks,  "
          "task_notes where "
          "tasks.person_id = " + initial_state["id"] + " and "
          "tasks.current_id >= 3 and "
          "task_notes.group_id = "  + lookupTables->IdOf("groups", "Public Health") + " and "
          "task_notes.task_id = tasks.id";

   filter_atlas_handler["public_comments"].filter->SetSQLStatement(sql);
   filter_atlas_handler["public_comments"].filter->RefreshDataSet();
   filter_atlas_handler["public_comments"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddPublicComments)),
                                         EditRecord (&(TformRecordPerson::EditPublicComments)));
   filter_atlas_handler["public_comments"].request = atlas->RequestNotificationWhen("task_notes.task_id", initial_state["task_id"], rel_any, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }
  if (optionsPermissions["table.conditions.pub"]["view"] == "true")
  {
    sql = "select condition_types.item, conditions.start_date, conditions.stop_date, "
          "conditions.code, conditions.note, conditions.current_id, conditions.id "
          "from conditions, condition_types "
          "where conditions.condition_id = condition_types.id and "
          "conditions.person_id = " + initial_state["id"] + " and "
          "conditions.group_id = " + lookupTables->IdOf("groups", "Public Health");

    filter_atlas_handler["public_conditions"].filter->SetSQLStatement(sql);
    filter_atlas_handler["public_conditions"].filter->RefreshDataSet();
    filter_atlas_handler["public_conditions"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddPublicConditions)),
                                            EditRecord (&(TformRecordPerson::EditPublicConditions)));
    filter_atlas_handler["public_conditions"].request = atlas->RequestNotificationWhen("conditions.person_id", initial_state["id"], rel_any, as_int, this,
                               RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }


  if (optionsPermissions["table.tasks.pub"]["view"] == "true")
  {
    sql = "select tasks.date_of_task, users.item, event_name_types.item, "
          "tasks.time_spent, tasks.mileage, method_types.item, "
          "direction_types.item, task_purpose_types.item, classification_types.item, com_meeting_types.item, "
          "com_activity_types.item, tasks.task_comments,  "
          "tasks.current_id, tasks.id "
          "from tasks "
          "inner join users on tasks.user_id = users.id "
          "inner join events on tasks.event_id = events.id "
          "inner join method_types on tasks.method_id = method_types.id "
          "inner join direction_types on tasks.direction_id = direction_types.id "
          "inner join task_purpose_types on tasks.task_purpose_id = task_purpose_types.id "
          "inner join com_meeting_types on tasks.com_meeting_id = com_meeting_types.id "
          "inner join classification_types on tasks.classification_id = classification_types.id "
          "inner join com_activity_types on tasks.com_activity_id = com_activity_types.id "
          "inner join event_name_types on events.event_name_id = event_name_types.id "
          "where tasks.id > 0 and "
          "tasks.group_id = '" + lookupTables->IdOf("groups", "Public Health") + "' and "
          "tasks.person_id = '" + initial_state["id"] + "' and "
          "tasks.com_dept_id = 0 and "
          "tasks.com_visit_id = 0";  // added so the filter wouldn't pull visits (they should come up on a different screen)

    filter_atlas_handler["public_task"].filter->SetSQLStatement(sql);
    filter_atlas_handler["public_task"].filter->RefreshDataSet();
    filter_atlas_handler["public_task"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddPublicTask)),
                                            EditRecord (&(TformRecordPerson::EditPublicTask)));
    filter_atlas_handler["public_task"].request = atlas->RequestNotificationWhen("tasks.person_id", initial_state["id"], rel_any, as_int, this,
                               RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.com_health_edu"]["view"] == "true")
  {
    sql = "select com_adult_topic_types.item, "
          "com_learner_types.item, com_method_types.item, com_evaluation_types.item, "
          "com_health_edu.current_id, com_health_edu.id "
          "from com_health_edu, com_learner_types, com_adult_topic_types, com_method_types, com_evaluation_types "
          "inner join tasks on tasks.person_id = '" + initial_state["id"] + "' "
          "where com_learner_types.id = com_health_edu.com_learner_id and "
          "com_adult_topic_types.id = com_health_edu.com_adult_topic_id and "
          "com_method_types.id = com_health_edu.com_method_id and "
          "com_evaluation_types.id = com_evaluation_id and "
          "com_health_edu.task_id = tasks.id and "
          "com_health_edu.group_id = " + lookupTables->IdOf("groups", "Public Health");

    filter_atlas_handler["public_edu"].filter->SetSQLStatement(sql);
    filter_atlas_handler["public_edu"].filter->RefreshDataSet();
    filter_atlas_handler["public_edu"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddPublicEdu)),
                                           EditRecord (&(TformRecordPerson::EditPublicEdu)));
    filter_atlas_handler["public_edu"].request = atlas->RequestNotificationWhen("com_health_edu.task_id", initial_state["task_id"], rel_any, as_int, this,
                             RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.com_nutrition"]["view"] == "true")
  {
    sql = "select com_nutrition.id, com_nutrition.current_id, com_feeding_types.item, "
          "com_formula_types.item, com_ingredient_types.item, com_nutrition.feeding_number, "
          "com_nutrition.feeding_time, com_nutrition.feeding_amount, com_nutrition.stool_number, "
          "com_nutrition.feeding_observed, com_nutrition.diaper_number, "
          "com_nutrition.task_id "
          "from com_nutrition, com_ingredient_types, com_formula_types, com_feeding_types "
          "inner join tasks on tasks.person_id = '" + initial_state["id"] + "' "
          "where com_ingredient_types.id = com_nutrition.com_ingredient_id and "
          "com_formula_types.id = com_nutrition.com_formula_id and  "
          "com_feeding_types.id = com_nutrition.com_feeding_id and "
          "com_nutrition.task_id = tasks.id";
    filter_atlas_handler["public_nutrition"].filter->SetSQLStatement(sql);
    filter_atlas_handler["public_nutrition"].filter->RefreshDataSet();
    filter_atlas_handler["public_nutrition"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddPublicNutrition)),
                                            EditRecord (&(TformRecordPerson::EditPublicNutrition)));
    filter_atlas_handler["public_nutrition"].request = atlas->RequestNotificationWhen("com_nutrition.task_id", initial_state["task_id"], rel_any, as_int, this,
                               RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.com_drug_regimen"]["view"] == "true")
  {
    sql = "select com_drug_regimen.medication, com_drug_regimen.dosage, com_medication_types.item, "
          "com_frequency_types.item, com_drug_regimen.rx_number, com_status_types.item, "
          "com_drug_regimen.person_id, com_drug_regimen.date_ordered, com_drug_regimen.date_discontinued, "
          "com_drug_regimen.id, com_drug_regimen.current_id "
          "from com_drug_regimen, com_medication_types, "
          "com_frequency_types, com_status_types where  "
          "com_frequency_types.id = com_drug_regimen.com_frequency_id and "
          "com_medication_types.id = com_drug_regimen.com_medication_id and "
          "com_status_types.id = com_drug_regimen.com_status_id and "
          "com_drug_regimen.group_id = " + lookupTables->IdOf("groups", "Public Health") + " and "
          "com_drug_regimen.person_id = " + initial_state["id"];


    filter_atlas_handler["public_drug"].filter->SetSQLStatement(sql);
    filter_atlas_handler["public_drug"].filter->RefreshDataSet();
    filter_atlas_handler["public_drug"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddPubDrug)),
                                            EditRecord (&(TformRecordPerson::EditPubDrug)));
    filter_atlas_handler["public_drug"].request = atlas->RequestNotificationWhen("com_drug_regimen.person_id", initial_state["id"], rel_any, as_int, this,
                               RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.participations.pub"]["view"] == "true")
  {
    sql = "select events.date_of_event, event_name_types.item, event_type_types.item, case "
          "when event_location_types.zip_code_id = 0 then event_location_types.item "
          "when event_location_types.item = '' then (zip_codes.city || ', ' || zip_codes.state) "
          "else (zip_codes.city || ', ' || zip_codes.state || ' - ' || event_location_types.item) end location_item, "
          "events.number_attended, events.description, participations.note, participations.current_id, participations.id "
          "from events "
          "inner join event_type_types on events.event_type_id = event_type_types.id "
          "inner join event_location_types on events.event_location_id = event_location_types.id "
          "inner join zip_codes on event_location_types.zip_code_id = zip_codes.id "
          "inner join participations on participations.event_id = events.id "
          "inner join event_name_types on events.event_name_id = event_name_types.id "
          "where "
         // Uhm... why was this commented out?  This query produced a damn near outer join between these tables
         // Note that I've moved all this to the inner joins above (... where they belong  :-P)
         // "com_event_id = com_event_types.id and "
         // "events.com_event_loc_id = com_event_loc_types.id and "
         // "participations.event_id = events.id and "
          "participations.person_id = " + initial_state["id"] + " and "
          "events.group_id = " + lookupTables->IdOf("groups", "Public Health");

    filter_atlas_handler["public_event"].filter->SetSQLStatement(sql);
    filter_atlas_handler["public_event"].filter->RefreshDataSet();
    filter_atlas_handler["public_event"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddPublicParticipation)),
                                 EditRecord(&(TformRecordPerson::EditPublicParticipation)));
    filter_atlas_handler["public_event"].request = atlas->RequestNotificationWhen("participations.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.person_notes"]["view"] == "true")
  {
    where = "";
    sql = "select cast(person_notes.last_update_stamp as date), "
          "person_notes.note, warning_types.item, groups.item, person_notes.current_id, person_notes.id "
          "from person_notes "
          "inner join groups on groups.id = person_notes.group_id "
          "inner join warning_types on warning_types.id = person_notes.warning_id "
          "where 1 = 1 and ";
    // TODO : this can be replaced by GetGroupPermissions like on table.person_notes.(lac|sc) below
    set<string> allowed_groups = GetGroupPermissions("table.person_notes", "", "view", "true");
    if (!allowed_groups.empty())
      where += SafeInClause("person_notes.group_id", SetToVec(allowed_groups));
    if (where != "")
      sql += "(" + /*where.substr(0, where.length()-3)*/ where + ") and ";
    sql += "person_notes.person_id = " + initial_state["id"] + " order by person_notes.last_update_stamp";
    filter_atlas_handler["common_notes"].filter->SetSQLStatement(sql);
    filter_atlas_handler["common_notes"].filter->RefreshDataSet();
    filter_atlas_handler["common_notes"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddCommonPersonNote)),
                                   EditRecord(&(TformRecordPerson::EditCommonPersonNote)));
    filter_atlas_handler["common_notes"].request = atlas->RequestNotificationWhen("person_notes.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  set<string> can_view;

  if (optionsPermissions["table.charts"]["view"] == "true")
  {
    can_view = GetGroupPermissions("table.charts", "", "view", "true");
    where = "";
    sql = "select location_types.item, charts.chart_number, charts.current_id, charts.id "
          "from charts "
          //"inner join groups on charts.location_id = groups.chart_location_id and groups.has_charts = 1 and charts.location_id > 0 "
          "inner join groups on charts.group_id = groups.id "
          "inner join location_types on charts.location_id = location_types.id "
          "where charts.person_id = " + initial_state["id"] + " "
          "and " + SafeInClause("groups.id", SetToVec(can_view));
    filter_atlas_handler["charts"].filter->SetSQLStatement(sql);
    filter_atlas_handler["charts"].filter->RefreshDataSet();
    filter_atlas_handler["charts"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddChart)),
                             EditRecord(&(TformRecordPerson::EditChart)));
    filter_atlas_handler["charts"].request = atlas->RequestNotificationWhen("charts.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  // conditions filter thing is -elsewhere-
  checkShowConditionsClick(NULL);

  if (optionsPermissions["table.relationships"]["view"] == "true")
  {
    sql = "select person_names.first_name || ' ' || person_names.last_name || ' ' || person_names.suffix, "
          "relationship_types.item, "
          "relationships.same_household, "
          "relationships.b_is_emergency, relationships.a_is_emergency, "
          "relationships.b_is_banned, relationships.a_is_banned, "
          "relationships.b_is_responsible, relationships.a_is_responsible, "
          "relationships.current_id, relationships.id "
          "from relationships "
          "left join people on relationships.person_b_id = people.id "
          "left join person_names on person_names.id = people.person_names_id "
          "left join relationship_types on relationship_types.id = relationships.rel_b_to_a_id "
          "where relationships.person_a_id = '" + initial_state["id"] + "' "
          "union "
          "select person_names.first_name || ' ' || person_names.last_name || ' ' || person_names.suffix, "
          "relationship_types.item, "
          "relationships.same_household, "
          "relationships.a_is_emergency, relationships.b_is_emergency, "
          "relationships.a_is_banned, relationships.b_is_banned, "
          "relationships.a_is_responsible, relationships.b_is_responsible, "
          "relationships.current_id, relationships.id "
          "from relationships left join people on relationships.person_a_id = people.id "
          "left join person_names on person_names.id = people.person_names_id "
          "left join relationship_types on relationship_types.id = relationships.rel_a_to_b_id "
          "where relationships.person_b_id = '" + initial_state["id"] + "' ";
    filter_atlas_handler["relationships"].filter->SetSQLStatement(sql);
    filter_atlas_handler["relationships"].filter->RefreshDataSet();
    filter_atlas_handler["relationships"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddRelationship)),
                                          EditRecord(&(TformRecordPerson::EditRelationship)));
    filter_atlas_handler["relationships_a"].request = atlas->RequestNotificationWhen("relationships.person_a_id", initial_state["id"], rel_e, as_int, this,
                    RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
    filter_atlas_handler["relationships_b"].request = atlas->RequestNotificationWhen("relationships.person_b_id", initial_state["id"], rel_e, as_int, this,
                    RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  set<string> med_clinics, clinics_can_view;
  sql = "select id from groups where clinic_id = " + lookupTables->IdOf("clinic_types", "Medical");
  SqlToSet(dbDatabase, sql, med_clinics);

  can_view.clear();
  clinics_can_view.clear();
  can_view = GetGroupPermissions("table.person_notes", "", "view", "true");
  clinics_can_view = intersect(can_view, med_clinics);

  if (optionsPermissions["table.person_notes.lac"]["view"] == "true" ||
      optionsPermissions["table.person_notes.sc"]["view"] == "true")
  {
    sql = "select groups.item clinic, cast(person_notes.last_update_stamp as date), "
          "person_notes.note, person_notes.current_id, person_notes.id "
          "from person_notes "
          "inner join groups on person_notes.group_id = groups.id "
          "where " + SafeInClause("person_notes.group_id", SetToVec(clinics_can_view)) +
          " and person_notes.person_id = " + initial_state["id"] + " order by person_notes.last_update_stamp";
    filter_atlas_handler["lac_notes"].filter->SetSQLStatement(sql);
    filter_atlas_handler["lac_notes"].filter->RefreshDataSet();
    filter_atlas_handler["lac_notes"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddLacPersonNote)),
                                 EditRecord(&(TformRecordPerson::EditLacPersonNote)));
    filter_atlas_handler["lac_note"].request = atlas->RequestNotificationWhen("person_notes.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  can_view.clear();
  clinics_can_view.clear();
  can_view = GetGroupPermissions("table.tasks", "", "view", "true");
  clinics_can_view = intersect(can_view, med_clinics);

  if (optionsPermissions["table.tasks.lac"]["view"] == "true" ||
      optionsPermissions["table.tasks.sc"]["view"] == "true")
  {
    sql = "select groups.item clinic, tasks.date_of_task, tasks.time_of_task, tax_entities.name, "
          "task_purpose_types.item, tasks.time_spent, tasks.new_client, tasks.task_comments, tasks.current_id, tasks.id "
          "from tasks "
          "inner join tax_entities on tasks.tax_entity_id = tax_entities.id "
          "inner join task_purpose_types on tasks.task_purpose_id = task_purpose_types.id "
          "inner join groups on tasks.group_id = groups.id "
          "where " + SafeInClause("tasks.group_id", SetToVec(clinics_can_view)) +
          " and tasks.person_id = " + initial_state["id"] + " order by tasks.date_of_task";
    filter_atlas_handler["lac_tasks"].filter->SetSQLStatement(sql);
    filter_atlas_handler["lac_tasks"].filter->RefreshDataSet();
    filter_atlas_handler["lac_tasks"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddLacTask)),
                                 EditRecord(&(TformRecordPerson::EditLacTask)));
    filter_atlas_handler["lac_task"].request = atlas->RequestNotificationWhen("tasks.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }
  if (optionsPermissions["table.procedures"]["view"] == "true")
  {
    sql = "select groups.item clinic, procedures.start_date, procedures.stop_date, procedures.place_of_service, "
          "procedures.type_of_service, procedures.cpt_hcpcs, procedures.modifier, "
          "procedures.charges, procedures.days_units, procedures.epsdt, procedures.emg, procedures.cob, "
          "procedures.local_use, procedures.current_id, procedures.id "
          "from procedures "
          "inner join tasks on procedures.task_id = tasks.id "
          "inner join groups on tasks.group_id = groups.id "
          "where " + SafeInClause("tasks.group_id", SetToVec(clinics_can_view)) +
          " and tasks.person_id = " + initial_state["id"];
    filter_atlas_handler["lac_procedures"].filter->SetSQLStatement(sql);
    filter_atlas_handler["lac_procedures"].filter->RefreshDataSet();
    filter_atlas_handler["lac_procedures"].filter->SetAddEdit(this, NULL, EditRecord(&(TformRecordPerson::EditLacProcedure)));
    filter_atlas_handler["lac_procedure"].request = atlas->RequestNotificationWhen("tasks.person_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  can_view.clear();
  clinics_can_view.clear();
  can_view = GetGroupPermissions("table.participations", "", "view", "true");
  clinics_can_view = intersect(can_view, med_clinics);

  if (optionsPermissions["table.participations.lac"]["view"] == "true" ||
      optionsPermissions["table.participations.sc"]["view"] == "true")
  {
    sql = "select events.date_of_event, event_name_types.item, event_type_types.item, case "
          "when event_location_types.zip_code_id = 0 then event_location_types.item "
          "when event_location_types.item = '' then (zip_codes.city || ', ' || zip_codes.state) "
          "else (zip_codes.city || ', ' || zip_codes.state || event_location_types.item) end location_item, "
          "events.number_attended, events.description, participations.current_id, participations.id "
          "from participations "
          "inner join events on participations.event_id = events.id "
          "inner join event_name_types on events.event_name_id = event_name_types.id "
          "inner join event_type_types on events.event_type_id = event_type_types.id "
          "inner join event_location_types on events.event_location_id = event_location_types.id "
          "inner join zip_codes on event_location_types.zip_code_id = zip_codes.id "
          "where participations.person_id = '" + initial_state["id"] + "' and "
          + SafeInClause("events.group_id", SetToVec(clinics_can_view));
    filter_atlas_handler["lac_event"].filter->SetSQLStatement(sql);
    filter_atlas_handler["lac_event"].filter->RefreshDataSet();
    filter_atlas_handler["lac_event"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddLacParticipation)),
                                EditRecord(&(TformRecordPerson::EditLacParticipation)));
    filter_atlas_handler["lac_event"].request = atlas->RequestNotificationWhen("participations.person_id", initial_state["id"], rel_e, as_int, this,
                          RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.person_notes.den"]["view"] == "true")
  {
    sql = "select cast(person_notes.last_update_stamp as date), "
          "person_notes.note, person_notes.current_id, person_notes.id "
          "from person_notes "
          "where person_notes.group_id = " + lookupTables->IdOf("groups", "Dental Clinic") +
          " and person_notes.person_id = " + initial_state["id"] + " order by person_notes.last_update_stamp";
    filter_atlas_handler["den_notes"].filter->SetSQLStatement(sql);
    filter_atlas_handler["den_notes"].filter->RefreshDataSet();
    filter_atlas_handler["den_notes"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddDenPersonNote)),
                                 EditRecord(&(TformRecordPerson::EditDenPersonNote)));
    filter_atlas_handler["den_note"].request = atlas->RequestNotificationWhen("person_notes.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.tasks.den"]["view"] == "true")
  {
    sql = "select tasks.date_of_task, tasks.time_of_task, tax_entities.name, task_purpose_types.item, "
          "tasks.time_spent, tasks.new_client, tasks.task_comments, tasks.current_id, tasks.id "
          "from tasks "
          "inner join tax_entities on tasks.tax_entity_id = tax_entities.id "
          "inner join task_purpose_types on tasks.task_purpose_id = task_purpose_types.id "
          "where tasks.group_id = '" + lookupTables->IdOf("groups", "Dental Clinic") + "' "
          " and tasks.person_id = '" + initial_state["id"] + "' order by tasks.date_of_task";
    filter_atlas_handler["den_tasks"].filter->SetSQLStatement(sql);
    filter_atlas_handler["den_tasks"].filter->RefreshDataSet();
    filter_atlas_handler["den_tasks"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddDenTask)),
                                 EditRecord(&(TformRecordPerson::EditDenTask)));
    filter_atlas_handler["den_task"].request = atlas->RequestNotificationWhen("person_notes.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.procedures"]["view"] == "true")
  {
    sql = "select procedures.start_date, procedures.stop_date, procedures.place_of_service, "
          "procedures.type_of_service, procedures.cpt_hcpcs, procedures.modifier, "
          "procedures.charges, procedures.days_units, procedures.epsdt, procedures.emg, procedures.cob, "
          "procedures.local_use, procedures.tooth_position, procedures.tooth_surface, procedures.current_id, procedures.id "
          "from procedures, tasks "
          "where procedures.task_id = tasks.id and "
          "tasks.group_id = " + lookupTables->IdOf("groups", "Dental Clinic") + " and "
          "tasks.person_id = " + initial_state["id"];
    filter_atlas_handler["den_procedures"].filter->SetSQLStatement(sql);
    filter_atlas_handler["den_procedures"].filter->RefreshDataSet();
    filter_atlas_handler["den_procedures"].filter->SetAddEdit(this, NULL, EditRecord(&(TformRecordPerson::EditDenProcedure)));
    filter_atlas_handler["den_procedure"].request = atlas->RequestNotificationWhen("procedures.id", initial_state["id"], rel_any, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.participations.den"]["view"] == "true")
  {
    sql = "select events.date_of_event, event_name_types.item, event_type_types.item, case "
          "when event_location_types.zip_code_id = 0 then event_location_types.item "
          "when event_location_types.item = '' then (zip_codes.city || ', ' || zip_codes.state) "
          "else (zip_codes.city || ', ' || zip_codes.state || event_location_types.item) end location_item, "
          "events.number_attended, events.description, participations.current_id, participations.id "
          "from participations "
          "inner join events on participations.event_id = events.id "
          "inner join event_name_types on events.event_name_id = event_name_types.id "
          "inner join event_type_types on events.event_type_id = event_type_types.id "
          "inner join event_location_types on events.event_location_id = event_location_types.id "
          "inner join zip_codes on event_location_types.zip_code_id = zip_codes.id "
          "where participations.person_id = '" + initial_state["id"] + "' and "
          "events.group_id = '" + lookupTables->IdOf("groups", "Dental Clinic") + "' ";
    filter_atlas_handler["den_event"].filter->SetSQLStatement(sql);
    filter_atlas_handler["den_event"].filter->RefreshDataSet();
    filter_atlas_handler["den_event"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddDenParticipation)),
                                EditRecord(&(TformRecordPerson::EditDenParticipation)));
    filter_atlas_handler["den_event"].request = atlas->RequestNotificationWhen("participations.person_id", initial_state["id"], rel_e, as_int, this,
                        RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.pharmacy_info"]["view"] == "true")
  {
    sql = "select pharmacy_info.dispense_date, pharmacy_types.item, pharmacy_locations.city, pharmacy_locations.state, "
          "pharmacy_info.amount_billed, pharmacy_info.paid_amount, "
          "pharmacy_info.ingredient_cost, pharmacy_info.dispense_cost, pharmacy_info.tax, pharmacy_info.copay, "
          "pharmacy_info.drug_name, pharmacy_info.ndc_number, pharmacy_info.rx_number, pharmacy_info.refill_number, "
          "pharmacy_info.quantity_filled, pharmacy_info.days_supply, pharmacy_info.physician_name, "
          "pharmacy_info.physician_dea_number, pharmacy_info.current_id , pharmacy_info.id "
          "from pharmacy_info, pharmacy_types, pharmacy_locations "
          "where pharmacy_info.pharmacy_location_id = pharmacy_locations.id and "
          "pharmacy_locations.pharmacy_id = pharmacy_types.id and "
          "pharmacy_info.person_id = " + initial_state["id"];
    filter_atlas_handler["pharmacy"].filter->SetSQLStatement(sql);
    filter_atlas_handler["pharmacy"].filter->RefreshDataSet();
    filter_atlas_handler["pharmacy"].filter->SetAddEdit(this, NULL, NULL);
    filter_atlas_handler["pharmacy"].request = atlas->RequestNotificationWhen("pharmacy_info.person_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.tasks.cob"]["view"] == "true")
  {
    // jhaley 20100818: must use table alias 'A' throughout for Firebird 2.x compliance 
    sql = "select tasks.date_of_task, A.appointment_date, tasks.time_of_task, tasks.cob_number, "
          "tax_entities.name, service_types.item, area_types.item, "
          "sum(transactions.credit_amount - transactions.debit_amount), "
          "tasks.task_comments, tasks.visit_comments, tasks.preconditions_note, tasks.followup_note, "
          "tasks.reported_by_note, tasks.hospitalized, tasks.given_room, tasks.current_id, tasks.id "
          "from tasks "
          "left join transactions on transactions.task_id = tasks.id "
          "and transactions.account_id in (select accounts.id from accounts where accounts.account_type_id = " + lookupTables->IdOf("account_types", "Payable") + ") "
          "inner join people on tasks.person_id = people.id "
          "inner join services_provided on tasks.services_provided_id = services_provided.id "
          "inner join tax_entities on services_provided.tax_entity_id = tax_entities.id "
          "inner join service_types on services_provided.service_id = service_types.id "
          "inner join area_types on services_provided.area_id = area_types.id "
          "left join appointments A on A.id = (select first 1 IA.id from appointments IA where IA.task_id = tasks.id and IA.current_id >= 3 order by IA.appointment_date desc) "
          "where tasks.group_id = " + lookupTables->IdOf("groups", "Contract Health") + " and "
          "tasks.services_provided_id > 0 and "
          "tasks.person_id = '" + initial_state["id"] + "' " // NO // and appointments.current_id >= 3 "
          "group by tasks.id, tasks.date_of_task, A.appointment_date, tasks.time_of_task, tasks.cob_number, "
          "tasks.task_comments, tax_entities.name, service_types.item, area_types.item, "
          "tasks.visit_comments, tasks.preconditions_note, tasks.followup_note, "
          "tasks.reported_by_note, tasks.hospitalized, tasks.given_room, tasks.current_id ";
    filter_atlas_handler["cob"].filter->SetSQLStatement(sql);
    filter_atlas_handler["cob"].filter->RefreshDataSet();
    filter_atlas_handler["cob"].filter->SetAddEdit(this, NULL, EditRecord(&(TformRecordPerson::EditCob)));
    filter_atlas_handler["cob"].request = atlas->RequestNotificationWhen("tasks.person_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.tasks.cob"]["view"] == "true")
  {
    sql = "select visit.date_of_task, visit.time_of_task, cob.cob_number, "
          "tax_entities.name, visit.task_comments, visit.patient_control_number, visit.current_id, visit.id "
          "from tasks cob, tax_entities, tasks visit "
          "where visit.parent_task_id = cob.id and "
          "visit.tax_entity_id = tax_entities.id and "
          "visit.group_id = " + lookupTables->IdOf("groups", "Contract Health") + " and "
          "visit.parent_task_id <> 0 and "
          //"(visit.services_provided_id = 0 or visit.services_provided_id is null) and " - jhaley: This is old logic.
          "visit.person_id = " + initial_state["id"];
    filter_atlas_handler["cob_visit"].filter->SetSQLStatement(sql);
    filter_atlas_handler["cob_visit"].filter->RefreshDataSet();
    filter_atlas_handler["cob_visit"].filter->SetAddEdit(this, NULL, EditRecord(&(TformRecordPerson::EditCobVisit)));
    filter_atlas_handler["cob_visit"].request = atlas->RequestNotificationWhen("tasks.person_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.deferred_cobs"]["view"] == "true")
  {
    sql =
      "select DCOB.date_of_deferral, REF.name, PROV.name, SERV.item, AREA.item, REAS.item, STAT.item, DCOB.is_approved, "
      " DCOB.current_id, DCOB.id "
      "from deferred_cobs DCOB "
      "inner join people P on DCOB.person_id = P.id "
      "inner join tax_entities REF on DCOB.provider_id = REF.id "
      "inner join services_provided SP on DCOB.services_provided_id = SP.id "
      "inner join tax_entities PROV on SP.tax_entity_id = PROV.id "
      "inner join service_types SERV on SP.service_id = SERV.id "
      "inner join area_types AREA on SP.area_id = AREA.id "
      "inner join deferral_reason_types REAS on DCOB.deferral_reason_id = REAS.id "
      "inner join deferral_status_types STAT on DCOB.deferral_status_id = STAT.id "
      "where DCOB.person_id = " + initial_state["id"];
    filter_atlas_handler["deferred_cob"].filter->SetSQLStatement(sql);
    filter_atlas_handler["deferred_cob"].filter->RefreshDataSet();
    filter_atlas_handler["deferred_cob"].filter->SetAddEdit(this,
      AddRecord(&TformRecordPerson::AddDeferredCOB), EditRecord(&TformRecordPerson::EditDeferredCOB));
    filter_atlas_handler["deferred_cob"].request = atlas->RequestNotificationWhen("deferred_cobs.person_id",
      initial_state["id"], rel_e, as_int, this, RefreshHandler(&TformRecordPerson::AtlasRefreshListViews));
  }

  if (optionsPermissions["table.denials"]["view"] == "true")
  {
    sql = "select tax_entities.name, service_types.item, denial_authority_types.item, denial_status_types.item, "
          "denial_items.begin_date_of_service, denial_items.end_date_of_service, "
          "denial_items.billed_amount, denial_items.patient_amount, denial_items.payable_amount, denial_letters.effective_date, denial_letters.date_processed, "
          "denial_letters.current_id, denials.id "
          "from denials "
          "inner join services_provided on denials.services_provided_id = services_provided.id "
          "inner join tax_entities on services_provided.tax_entity_id = tax_entities.id "
          "inner join service_types on services_provided.service_id = service_types.id "
          "left join denial_letters on denial_letters.denial_id = denials.id "
          "left join denial_authority_types on denial_letters.denial_authority_id = denial_authority_types.id "
          "left join denial_status_types on denial_letters.denial_status_id = denial_status_types.id "
          "left join denial_items on denial_items.denial_letter_id = denial_letters.id "
          "where denials.person_id = '" + initial_state["id"] + "' ";
    filter_atlas_handler["con_denial"].filter->SetSQLStatement(sql);
    filter_atlas_handler["con_denial"].filter->RefreshDataSet();
    filter_atlas_handler["con_denial"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddConDenial)), EditRecord(&(TformRecordPerson::EditConDenial)));

    filter_atlas_handler["con_denial_id"].request = atlas->RequestNotificationWhen("denials.id", "", rel_any, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));

    // jhaley 20100708: Note that these are requests for fake person_id fields from the denial_letters & denial_items tables.
    // When a Letter or DOS item is added, it will send a notification for that field, which will refresh this list view.
    filter_atlas_handler["con_denial"].request = atlas->RequestNotificationWhen("denial_letters.person_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
    filter_atlas_handler["con_denial_items"].request = atlas->RequestNotificationWhen("denial_items.person_id", initial_state["id"], rel_e, as_int, this,
                                 RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.tasks.cob"]["view"] == "true")
  {
    // jhaley 20110707: CHS mail outs
    sql = "select T.date_of_task, U.item, MT.item, DT.item, T.task_comments, T.current_id, T.id "
          "from tasks T "
          "left join users U on T.user_id = U.id "
          "left join method_types MT on T.method_id = MT.id "
          "left join direction_types DT on T.direction_id = DT.id "
          "where T.group_id = " + lookupTables->IdOf("groups", "Contract Health") + " and "
          "T.method_id = " + lookupTables->IdOf("method_types", "Mail") + " and "
          "T.person_id = '" + initial_state["id"] + "' ";

    filter_atlas_handler["chs_mail"].filter->SetSQLStatement(sql);
    filter_atlas_handler["chs_mail"].filter->RefreshDataSet();
    // No add or edit, yet at least. These are currently only generated from the ARRA form letter.
    filter_atlas_handler["chs_mail"].request =
      atlas->RequestNotificationWhen("tasks.person_id", "", rel_e, as_int, this,
                                     RefreshHandler(&TformRecordPerson::AtlasRefreshListViews));
  }

  if (optionsPermissions["table.bills.incoming"]["view"] == "true")
  {
    sql = "select bills.bill_date, tasks.date_of_task, a.name, b.name, c.name, bills.invoice_number, "
          "purchase_reqs.purchase_req_number, checks.check_number, bills.invoice_amount, "
          "bills.total_charge, bills.paid_amount, bills.current_id, bills.id "
          "from bills, tasks, purchase_reqs, checks, tax_entities a, tax_entities b, tax_entities c "
          "where bills.purchase_req_id = purchase_reqs.id and "
          "purchase_reqs.check_id = checks.id and "
          "bills.bill_id = " + lookupTables->IdOf("bill_types", "Incoming provider bill") + " and "
          "bills.provider_tax_id = a.id and "
          "bills.facility_tax_id = b.id and "
          "bills.group_tax_id = c.id and "
          "bills.task_id = tasks.id and "
          "tasks.person_id = " + initial_state["id"];
    filter_atlas_handler["cob_bills"].filter->SetSQLStatement(sql);
    filter_atlas_handler["cob_bills"].filter->RefreshDataSet();
    filter_atlas_handler["cob_bills"].filter->SetAddEdit(this, NULL, EditRecord(&(TformRecordPerson::EditCobBill)));
    filter_atlas_handler["cob_bills"].request = atlas->RequestNotificationWhen("tasks.person_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.bills.outgoing.lac"]["view"] == "true" ||
      optionsPermissions["table.bills.outgoing.sc"]["view"] == "true")
  {
    sql = "select groups.item clinic, bills.bill_date, a.name, b.name, "
          "bills.invoice_amount, bills.total_charge, bills.paid_amount, bills.current_id, bills.id "
          "from bills "
          "inner join tasks on bills.task_id = tasks.id "
          "inner join purchase_reqs on bills.purchase_req_id = purchase_reqs.id "
          "inner join checks on purchase_reqs.check_id = checks.id "
          "inner join tax_entities a on bills.provider_tax_id = a.id "
          "inner join tax_entities b on bills.facility_tax_id = b.id "
          "inner join groups on tasks.group_id = groups.id "
          "where "
          "bills.bill_id = " + lookupTables->IdOf("bill_types", "Outgoing provider bill") + " and "
          "tasks.group_id in (" +  lookupTables->IdOf("groups", "Little Axe Clinic") + ", " + lookupTables->IdOf("groups", "Shawnee Clinic") + ") and "
          "tasks.person_id = " + initial_state["id"];
    filter_atlas_handler["lac_bills"].filter->SetSQLStatement(sql);
    filter_atlas_handler["lac_bills"].filter->RefreshDataSet();
    filter_atlas_handler["lac_bills"].filter->SetAddEdit(this, NULL, EditRecord(&(TformRecordPerson::EditLacBill)));
    filter_atlas_handler["lac_bills"].request = atlas->RequestNotificationWhen("tasks.person_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.bills.outgoing.den"]["view"] == "true")
  {
    sql = "select bills.bill_date, a.name, b.name, "
          "bills.invoice_amount, bills.total_charge, bills.paid_amount, bills.current_id, bills.id "
          "from bills, tasks, purchase_reqs, checks, tax_entities a, tax_entities b "
          "where bills.purchase_req_id = purchase_reqs.id and "
          "purchase_reqs.check_id = checks.id and "
          "bills.bill_id = " + lookupTables->IdOf("bill_types", "Outgoing provider bill") + " and "
          "bills.provider_tax_id = a.id and "
          "bills.facility_tax_id = b.id and "
          "bills.task_id = tasks.id and "
          "tasks.group_id = " + lookupTables->IdOf("groups", "Dental Clinic") + " and "          
          "tasks.person_id = " + initial_state["id"];
    filter_atlas_handler["den_bills"].filter->SetSQLStatement(sql);
    filter_atlas_handler["den_bills"].filter->RefreshDataSet();
    filter_atlas_handler["den_bills"].filter->SetAddEdit(this, NULL, EditRecord(&(TformRecordPerson::EditDenBill)));
    filter_atlas_handler["den_bills"].request = atlas->RequestNotificationWhen("tasks.person_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.case_notes"]["view"] == "true")
  {
    can_view.clear();
    can_view = GetGroupPermissions("table.case_notes", "", "view", "true");
    sql = "select cast(case_notes.last_update_stamp as date), "
          "case_notes.note, groups.item, case_notes.current_id, case_notes.id "
          "from case_notes "
          "inner join groups on case_notes.group_id = groups.id "
          "where " + SafeInClause("group_id", SetToVec(can_view)) +
          " and case_notes.person_id = " + initial_state["id"] + " order by case_notes.last_update_stamp";
    filter_atlas_handler["case_notes"].filter->SetSQLStatement(sql);
    filter_atlas_handler["case_notes"].filter->RefreshDataSet();
    filter_atlas_handler["case_notes"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddCaseNote)),
                                 EditRecord(&(TformRecordPerson::EditCaseNote)));
    filter_atlas_handler["case_notes"].request = atlas->RequestNotificationWhen("case_notes.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.person_notes.cob"]["view"] == "true")
  {
    sql = "select cast(person_notes.last_update_stamp as date), "
          "person_notes.note, person_notes.current_id, person_notes.id "
          "from person_notes "
          "where person_notes.group_id = " + lookupTables->IdOf("groups", "Contract Health") +
          " and person_notes.person_id = " + initial_state["id"] + " order by person_notes.last_update_stamp";
    filter_atlas_handler["cob_notes"].filter->SetSQLStatement(sql);
    filter_atlas_handler["cob_notes"].filter->RefreshDataSet();
    filter_atlas_handler["cob_notes"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddCobPersonNote)),
                                 EditRecord(&(TformRecordPerson::EditCobPersonNote)));
    filter_atlas_handler["cob_notes"].request = atlas->RequestNotificationWhen("person_notes.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.insurance_applications"]["view"] == "true")
  {
    sql = "select IAT.item, IA.is_mailed, IA.mailed_on, IAMB.item, "
                 "IA.is_completed, IAR.item, "
                 "IA.is_received, IA.received_on, IAL.item, "
                 "IA.is_faxed, IA.faxed_on, IAFT.name, IAFB.item, IA.notes, "
                 "IA.current_id, IA.id "
          "from insurance_applications IA "
          "inner join insurance_app_types IAT on IA.insurance_app_id = IAT.id "
          "inner join users IAMB on IA.mailed_by = IAMB.id "
          "inner join insurance_app_location_types IAL on IA.received_at = IAL.id "
          "inner join relationship_types IAR on IA.completed_by = IAR.id "
          "inner join tax_entities IAFT on IA.faxed_to = IAFT.id "
          "inner join users IAFB on IA.faxed_by = IAFB.id "
          "where IA.person_id = " + initial_state["id"];
    filter_atlas_handler["ins_app"].filter->SetSQLStatement(sql);
    filter_atlas_handler["ins_app"].filter->RefreshDataSet();
    filter_atlas_handler["ins_app"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddInsApp)), EditRecord(&(TformRecordPerson::EditInsApp)));
    filter_atlas_handler["ins_app"].request = atlas->RequestNotificationWhen("insurance_applications.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  if (optionsPermissions["table.insurance_coverage"]["view"] == "true")
  {
    sql = "select ins_co.name, insurance_types.item, insurance_policies.policy_number, insurance_policies.group_number, "
          "area_types.item, insurance_benefits.note, "
          "insurance_policies.start_date, insurance_policies.stop_date, coverage_types.item, "
          "source_types.item, insurance_policies.name_on_policy, pcp.name, insurance_coverage.person_code, "
          "insurance_coverage.name_on_card, insurance_coverage.current_id, insurance_coverage.id "
          "from insurance_coverage "
          "left join insurance_policies on insurance_policies.id = insurance_coverage.insurance_policy_id "
          "left join coverage_types on coverage_types.id = insurance_policies.coverage_id "
          "left join source_types on source_types.id = insurance_policies.source_id "
          "left join insurance_types on insurance_types.id = insurance_policies.insurance_id "
          "left join insurance_benefits on insurance_policies.id = insurance_benefits.insurance_policy_id "
          "left join area_types on area_types.id = insurance_benefits.area_id "
          "left join tax_entities ins_co on ins_co.id = insurance_policies.tax_entity_id "
          "left join tax_entities pcp on pcp.id = insurance_coverage.tax_entity_id "
          "where insurance_coverage.person_id = " + initial_state["id"];
    filter_atlas_handler["coverage"].filter->SetSQLStatement(sql);
    filter_atlas_handler["coverage"].filter->RefreshDataSet();
    filter_atlas_handler["coverage"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddCoverage)), EditRecord(&(TformRecordPerson::EditCoverage)));
    filter_atlas_handler["coverage"].request = atlas->RequestNotificationWhen("insurance_coverage.person_id", initial_state["id"], rel_e, as_int, this,
                         RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

// DONE -c MATT_STUPID: used serivce type respite care rather than hard coding fund 071, which has already changed (now they use 112 and will likely change yearly)

  if (optionsPermissions["table.tasks.cob"]["view"] == "true")
  {
    // jhaley 20100818: must use alias 'A' throughout for Firebird 2.x compliance
    sql = "select tasks.date_of_task, A.appointment_date, tasks.time_of_task, tasks.cob_number, "
          "tax_entities.name provider, service_types.item service_provided, "
          "sum(transactions.credit_amount - transactions.debit_amount), "
          "tasks.task_comments, tasks.visit_comments, tasks.preconditions_note, tasks.followup_note, "
          "tasks.reported_by_note, tasks.hospitalized, tasks.given_room, tasks.current_id, tasks.id "
          "from tasks "
          "left join transactions on transactions.task_id = tasks.id "
          "inner join people on tasks.person_id = people.id "
          "inner join services_provided on tasks.services_provided_id = services_provided.id "
          "inner join tax_entities on services_provided.tax_entity_id = tax_entities.id "
          "inner join service_types on services_provided.service_id = service_types.id "
          "left join appointments A on A.id = (select first 1 IA.id from appointments IA where IA.task_id = tasks.id and IA.current_id >= 3 order by IA.appointment_date desc) "
          "where tasks.group_id = " + lookupTables->IdOf("groups", "Contract Health") + " and "
          "tasks.services_provided_id > 0 and "
          "tasks.person_id = '" + initial_state["id"] + "' "
//        "and transactions.account_id = (select accounts.id from accounts inner join acc_level_one on accounts.acc_level_one_id = acc_level_one.id where accounts.account_type_id = " + lookupTables->IdOf("account_types", "Payable") + " and acc_level_one.short_item = \'071\') "
          "and services_provided.service_id = 168 " // NO // and appointments.current_id >= 3 "
          "group by tasks.id, tasks.date_of_task, A.appointment_date, tasks.time_of_task, tasks.cob_number, "
          "tasks.task_comments, tax_entities.name, service_types.item, "
          "tasks.visit_comments, tasks.preconditions_note, tasks.followup_note, "
          "tasks.reported_by_note, tasks.hospitalized, tasks.given_room, tasks.current_id ";
    filter_atlas_handler["caregiver_cob"].filter->SetSQLStatement(sql);
    filter_atlas_handler["caregiver_cob"].filter->RefreshDataSet();
    filter_atlas_handler["caregiver_cob"].filter->SetAddEdit(this, NULL, EditRecord(&(TformRecordPerson::EditCob)));
    filter_atlas_handler["cob"].request = atlas->RequestNotificationWhen("tasks.person_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

// TODO: come back and change sub-select in where clause to use lookup table instead of hard coding 071 in where clause of sub-select
  if (optionsPermissions["table.bills.incoming"]["view"] == "true")
  {
    sql = "select bills.bill_date, tasks.date_of_task, a.name, b.name, c.name, bills.invoice_number, "
          "purchase_reqs.purchase_req_number, checks.check_number, bills.invoice_amount, "
          "bills.total_charge, bills.paid_amount, bills.current_id, bills.id "
          "from bills, tasks, purchase_reqs, checks, tax_entities a, tax_entities b, tax_entities c, transactions "
          "where bills.purchase_req_id = purchase_reqs.id and "
          "purchase_reqs.check_id = checks.id and "
          "bills.bill_id = " + lookupTables->IdOf("bill_types", "Incoming provider bill") + " and "
          "bills.provider_tax_id = a.id and "
          "bills.facility_tax_id = b.id and "
          "bills.group_tax_id = c.id and "
          "bills.task_id = tasks.id and "
          "tasks.person_id = " + initial_state["id"] + " and "
          "bills.id = transactions.bill_id and "
          "transactions.account_id in "
           "(select accounts.id from accounts inner join acc_level_one on accounts.acc_level_one_id = acc_level_one.id "
            "where accounts.account_type_id = " + lookupTables->IdOf("account_types", "Expense") +
            " and acc_level_one.short_item = \'071\') ";
    filter_atlas_handler["caregiver_bills"].filter->SetSQLStatement(sql);
    filter_atlas_handler["caregiver_bills"].filter->RefreshDataSet();
    filter_atlas_handler["caregiver_bills"].filter->SetAddEdit(this, NULL, EditRecord(&(TformRecordPerson::EditCobBill)));
    filter_atlas_handler["cob_bills"].request = atlas->RequestNotificationWhen("tasks.person_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  // jhaley 20100804: Common events view
  set<string> group_perms = GetGroupPermissions("table.events", "", "view", "true");
  if (group_perms.size() > 0)
  {
    sql = "select groups.item, events.date_of_event, event_name_types.item, event_type_types.item, case "
          "when event_location_types.zip_code_id = 0 then event_location_types.item "
          "when event_location_types.item = '' then (zip_codes.city || ', ' || zip_codes.state) "
          "else (zip_codes.city || ', ' || zip_codes.state || ' - ' || event_location_types.item) end location_item, "
          "events.number_attended, events.description, participations.note, participations.current_id, participations.id "
          "from events "
          "inner join groups on events.group_id = groups.id "
          "inner join event_type_types on events.event_type_id = event_type_types.id "
          "inner join event_location_types on events.event_location_id = event_location_types.id "
          "inner join zip_codes on event_location_types.zip_code_id = zip_codes.id "
          "inner join participations on participations.event_id = events.id "
          "inner join event_name_types on events.event_name_id = event_name_types.id "
          "where " + SafeInClause("events.group_id", SetToVec(group_perms)) + " and "
          "participations.person_id = '" + initial_state["id"] + "' ";

    filter_atlas_handler["common_events"].filter->SetSQLStatement(sql);
    filter_atlas_handler["common_events"].filter->RefreshDataSet();
    filter_atlas_handler["common_events"].filter->SetAddEdit(this,
                                    AddRecord(&(TformRecordPerson::AddCommonParticipation)),
                                    EditRecord(&(TformRecordPerson::EditCommonParticipation)));
    filter_atlas_handler["common_events"].request = atlas->RequestNotificationWhen("participations.person_id", initial_state["id"], rel_e, as_int,
                              this, RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }

  TformRecordGeneric::NotNewAnymore();
  return true;
}

//---------------------------------------------------------------------------
void TformRecordPerson::AddBehTreatment()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordTreatmentBeh * treatmentRecord = new TformRecordTreatmentBeh(NULL, temp_map);
    treatmentRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditBehTreatment()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["beh_local_treatment"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordTreatmentBeh * treatmentRecord = new TformRecordTreatmentBeh(NULL, temp_map);
    treatmentRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditContactInfo()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["contacts"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordContactInfo * contactInfoRecord = new TformRecordContactInfo(NULL, temp_map);
    contactInfoRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddContactInfo()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordContactInfo * contactInfoRecord = new TformRecordContactInfo(NULL, temp_map);
    contactInfoRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditName()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["names"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordName * nameRecord = new TformRecordName(NULL, temp_map);
    nameRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddName()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordName * nameRecord = new TformRecordName(NULL, temp_map);
    nameRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditAffiliation()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["affiliations"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordAffiliation * affiliationRecord = new TformRecordAffiliation(NULL, temp_map);
    affiliationRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddAffiliation()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordAffiliation * affiliationRecord = new TformRecordAffiliation(NULL, temp_map);
    affiliationRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditEnrollment()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["enrollment"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordEnrollment * enrollmentRecord = new TformRecordEnrollment(NULL, temp_map);
    enrollmentRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddEnrollment()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordEnrollment * enrollmentRecord = new TformRecordEnrollment(NULL, temp_map);
    enrollmentRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
bool TformRecordPerson::AtlasRefreshListViews(int request_num, string matched_value)
{
  if (!IsAtlasReady()) // jhaley 20101210: Cannot currently service this refresh request
    return true;       // TODO : remembering the request and trying again later might be nicer than just returning...

  // these were being treated specially, so I left them as such
  if (request_num == filter_atlas_handler["names"].request)
  {
    filter_atlas_handler["names"].filter->RefreshDataSet();
    if (initial_state["id"] != "new")
      staticHeaderName->Caption = GetPersonName(dbDatabase, initial_state["id"]).c_str();
  }
  else if (request_num == filter_atlas_handler["community_nutrition"].request)
   ; // community_nutrition"].filter->RefreshDataSet();
  else if (request_num == filter_atlas_handler["diab_logsheet"].request || request_num == filter_atlas_handler["diab_logsheet_activity"].request)
    filter_atlas_handler["diab_logsheet"].filter->RefreshDataSet();
  else if (request_num == filter_atlas_handler["relationships_a"].request || request_num == filter_atlas_handler["relationships_b"].request)
    filter_atlas_handler["relationships"].filter->RefreshDataSet();
  else if (request_num == filter_atlas_handler["con_denial_id"].request || request_num == filter_atlas_handler["con_denial"].request || request_num == filter_atlas_handler["con_denial_items"].request)
    filter_atlas_handler["con_denial"].filter->RefreshDataSet();
  // but for everything else...
  else
  {
    for (map<string, filter_atlas_wrapper>::iterator itr = filter_atlas_handler.begin(); itr != filter_atlas_handler.end(); itr++)
      if (request_num == itr->second.request)
        itr->second.filter->RefreshDataSet();
  }

  return true;
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddDiabLogsheet()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordLogsheet * logsheetRecord = new TformRecordLogsheet(NULL, temp_map);
    logsheetRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditDiabLogsheet()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["diab_logsheet"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordLogsheet * logsheetRecord = new TformRecordLogsheet(NULL, temp_map);
    logsheetRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddDiabTask()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Diabetes");
  FORM_TRY
    TformRecordTaskDiab * diabetesTaskRecord = new TformRecordTaskDiab(NULL, temp_map);
    diabetesTaskRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------

void TformRecordPerson::EditDiabTask()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["diab_task"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordTaskDiab * diabetesTaskRecord = new TformRecordTaskDiab(NULL, temp_map);
    diabetesTaskRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddDiabEducation()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordDiabScore * diabetesEducationRecord = new TformRecordDiabScore(NULL, temp_map);
    diabetesEducationRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------

void TformRecordPerson::EditDiabEducation()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["diab_education"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordDiabScore * diabetesEducationRecord = new TformRecordDiabScore(NULL, temp_map);
    diabetesEducationRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddDiabParticipation()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"]  = lookupTables->IdOf("groups", "Diabetes");
  FORM_TRY
    TformRecordParticipationsDiab * diabetesParticipationRecord = new TformRecordParticipationsDiab(NULL, temp_map);
    diabetesParticipationRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------

void TformRecordPerson::EditDiabParticipation()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["diab_event"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordParticipationsDiab * diabetesParticipationRecord = new TformRecordParticipationsDiab(NULL, temp_map);
    diabetesParticipationRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblDiabTaskReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabTaskReport * taskReport = new TformLaunchDiabTaskReport(NULL, initial_state["id"]);
    taskReport->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblDiabLogsheetReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabLogsheetReport * logsheetReport = new TformLaunchDiabLogsheetReport(NULL, initial_state["id"]);
    logsheetReport->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblDiabEventReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchEventByClientReport * eventReport = new TformLaunchEventByClientReport(NULL, initial_state["id"], lookupTables->IdOf("groups", "Diabetes"));
    eventReport->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblDiabMeasureReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabMeasurementReport * measurementReport = new TformLaunchDiabMeasurementReport(NULL, initial_state["id"]);
    measurementReport->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddFitnessMembership()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordFitnessMembership * fitnessRecord = new TformRecordFitnessMembership(NULL, temp_map);
    fitnessRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditFitnessMembership()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["fitness"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordFitnessMembership * fitnessRecord = new TformRecordFitnessMembership(NULL, temp_map);
    fitnessRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddFitnessAttendance()
{
  if (listFitness->SelCount > 0)
  {
    map<string,string> temp_map;
    temp_map["id"] = "new";
    temp_map["person_id"] = initial_state["id"];
    temp_map["fitness_membership_id"] = filter_atlas_handler["fitness"].filter->GetSelectedRecordID();
    FORM_TRY
      TformRecordFitnessAttendance * fitnessRecord = new TformRecordFitnessAttendance(NULL, temp_map);
      fitnessRecord->Show();
    FORM_CATCH
  }
  else
    PSay("Please select which membership this attendance is for from the list view above", m_missing_data, MB_OK);

}
//---------------------------------------------------------------------------
void TformRecordPerson::EditFitnessAttendance()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["fitness_attendance"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordFitnessAttendance * fitnessRecord = new TformRecordFitnessAttendance(NULL, temp_map);
    fitnessRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblFitnessAttendanceReportClick(
      TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabAttendaceReport * attendanceReport = new TformLaunchDiabAttendaceReport(NULL, initial_state["id"]);
    attendanceReport->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddCommonPersonNote()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = "0";
  FORM_TRY
    TformRecordPersonNotes * noteRecord = new TformRecordPersonNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditCommonPersonNote()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["common_notes"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordPersonNotes * noteRecord = new TformRecordPersonNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddDiabPersonNote()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Diabetes");
  FORM_TRY
    TformRecordPersonNotes * noteRecord = new TformRecordPersonNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditDiabPersonNote()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["diab_notes"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordPersonNotes * noteRecord = new TformRecordPersonNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddBehPersonNote()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Behavioral Health");
  FORM_TRY
    TformRecordPersonNotes * noteRecord = new TformRecordPersonNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditBehPersonNote()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["beh_notes"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordPersonNotes * noteRecord = new TformRecordPersonNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddBehForm()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Behavioral Health");
  FORM_TRY
    TformRecordForm * formRecord = new TformRecordForm(NULL, temp_map);
    formRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditBehForm()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["beh_forms"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordForm * formRecord = new TformRecordForm(NULL, temp_map);
    formRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddDiabCondition()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Diabetes");
  FORM_TRY
    TformRecordCondition * conditionRecord = new TformRecordCondition(NULL, temp_map);
    conditionRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditDiabCondition()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["diab_conditions"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordCondition * conditionRecord = new TformRecordCondition(NULL, temp_map);
    conditionRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditComVisit()
{
  map<string,string> temp_map;
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  temp_map["id"] = filter_atlas_handler["community_visit"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordComVisit * comVisitRecord = new TformRecordComVisit(NULL, temp_map);
    comVisitRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddComVisit()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["com_dept_id"] = lookupTables->IdOf("com_dept_types", "adult");
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordComVisit * comVisitRecord = new TformRecordComVisit (NULL, temp_map);
    comVisitRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditPublicVisit()
{

  map<string,string> temp_map;
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  temp_map["person_id"] = initial_state["id"];
  temp_map["id"] = filter_atlas_handler["public_visit"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordComVisit * taskRecord = new TformRecordComVisit(NULL, temp_map);
    taskRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddPublicVisit()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  temp_map["person_id"] = initial_state["id"];

  // jhaley: This will allow the user to select a com_dept_type before the form appears.
  TformRecordComVisit::Do(temp_map);
}

//---------------------------------------------------------------------------
void TformRecordPerson::EditComComments()
{
  map<string,string> temp_map;
  temp_map["person_id"] = initial_state["id"];
  temp_map["id"] = filter_atlas_handler["community_comments"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordTaskNotes * noteRecord = new TformRecordTaskNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddComComments()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] =  lookupTables->IdOf("groups", "Community Health");
  FORM_TRY
    TformRecordTaskNotes * noteRecord = new TformRecordTaskNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditPublicComments()
{
  map<string,string> temp_map;
  temp_map["person_id"] = initial_state["id"];
  temp_map["id"] = filter_atlas_handler["public_comments"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordTaskNotes * noteRecord = new TformRecordTaskNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddPublicComments()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] =  lookupTables->IdOf("groups", "Public Health");
  FORM_TRY
    TformRecordTaskNotes * noteRecord = new TformRecordTaskNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditComConditions()
{
  map<string,string> temp_map;
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  temp_map["id"] = filter_atlas_handler["community_conditions"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordCondition * conditionRecord = new TformRecordCondition(NULL, temp_map);
    conditionRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddComConditions()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  FORM_TRY
    TformRecordCondition * conditionRecord = new TformRecordCondition(NULL, temp_map);
    conditionRecord->Show();
  FORM_CATCH
}
//--------------------------------------------------------------------------
void TformRecordPerson::EditPublicConditions()
{
  map<string,string> temp_map;
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  temp_map["id"] = filter_atlas_handler["public_conditions"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordCondition * conditionRecord = new TformRecordCondition(NULL, temp_map);
    conditionRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddPublicConditions()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  FORM_TRY
    TformRecordCondition * conditionRecord = new TformRecordCondition(NULL, temp_map);
    conditionRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditPublicEdu()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["public_edu"].filter->GetSelectedRecordID();
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordComHealth * comHealthRecord = new TformRecordComHealth(NULL, temp_map);
    comHealthRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddPublicEdu()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  FORM_TRY
    TformRecordComHealth * comHealthRecord = new TformRecordComHealth(NULL, temp_map);
    comHealthRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditComEdu()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["community_edu"].filter->GetSelectedRecordID();
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordComHealth * comHealthRecord = new TformRecordComHealth(NULL, temp_map);
    comHealthRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddComEdu()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  FORM_TRY
        TformRecordComHealth * comHealthRecord = new TformRecordComHealth(NULL, temp_map);
        comHealthRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditPublicNutrition()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["public_nutrition"].filter->GetSelectedRecordID();
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  FORM_TRY
    TformRecordComNutrition * comNutritionRecord = new TformRecordComNutrition(NULL, temp_map);
    comNutritionRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddPublicNutrition()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["task_id"] = initial_state["id"];
  FORM_TRY
    TformRecordComNutrition *comNutritionRecord = new TformRecordComNutrition(NULL, temp_map);
    comNutritionRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditComDrug()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["community_drug"].filter->GetSelectedRecordID();
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  FORM_TRY
    TformRecordComDrug * comDrugRecord = new TformRecordComDrug(NULL, temp_map);
    comDrugRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddComDrug()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  temp_map["task_id"] = initial_state["task_id"];
  FORM_TRY
    TformRecordComDrug * comDrugRecord = new TformRecordComDrug(NULL, temp_map);
    comDrugRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditPubDrug()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["public_drug"].filter->GetSelectedRecordID();
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  FORM_TRY
    TformRecordComDrug * comDrugRecord = new TformRecordComDrug(NULL, temp_map);
    comDrugRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddPubDrug()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  temp_map["task_id"] = initial_state["task_id"];
  FORM_TRY
    TformRecordComDrug * comDrugRecord = new TformRecordComDrug(NULL, temp_map);
    comDrugRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddComParticipation()
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  FORM_TRY
    TformRecordParticipationsDiab * comEvent = new TformRecordParticipationsDiab(NULL, temp_map);
    comEvent->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditComParticipation()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["community_event"].filter->GetSelectedRecordID();
  /*
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  */
  FORM_TRY
    TformRecordParticipationsDiab * comEvent = new TformRecordParticipationsDiab(NULL, temp_map);
    comEvent->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddPublicParticipation()
{
  map<string, string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  FORM_TRY
    TformRecordParticipationsDiab * comEvent = new TformRecordParticipationsDiab(NULL, temp_map);
    comEvent->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditPublicParticipation()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["public_event"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordParticipationsDiab * comEvent = new TformRecordParticipationsDiab(NULL, temp_map);
    comEvent->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditComTask()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["community_task"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordTaskCom * communityTaskRecord = new TformRecordTaskCom(NULL, temp_map);
    communityTaskRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddComTask()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Community Health");
  FORM_TRY
    TformRecordTaskCom * communityTaskRecord = new TformRecordTaskCom(NULL, temp_map);
     communityTaskRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
// jhaley 20111028
void TformRecordPerson::EditComAssessment()
{
  map<string, string> temp_map;
  temp_map["id"] = filter_atlas_handler["community_assessment"].filter->GetSelectedRecordID();
  TformRecordPatientAssessment *asmt_form = NULL;
  FORM_TRY
    asmt_form = new TformRecordPatientAssessment(NULL, temp_map);
  FORM_CATCH_RETURN("TformRecordPatientAssessment", )
  asmt_form->Show();
}
//---------------------------------------------------------------------------
// jhaley 20111028
void TformRecordPerson::AddComAssessment()
{
  // Nnnnnn... no. Can't guarantee it would end up being associated with this person if added from here.
  PSay("Please add assessments using the link on the Community Health Adult Visit record screen.", m_reminder, MB_OK);
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditPublicTask()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["public_task"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordTaskCom * communityTaskRecord = new TformRecordTaskCom(NULL, temp_map);
    communityTaskRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddPublicTask()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Public Health");
  FORM_TRY
    TformRecordTaskCom * communityTaskRecord = new TformRecordTaskCom(NULL, temp_map);
    communityTaskRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddRelationship()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_a_id"] = initial_state["id"];
  FORM_TRY
    TformRecordRelationship * relationshipRecord = new TformRecordRelationship(NULL, temp_map);
    relationshipRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditRelationship()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["relationships"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordRelationship * relationshipRecord = new TformRecordRelationship(NULL, temp_map);
    relationshipRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddIncentive()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordIncentive * incentiveRecord = new TformRecordIncentive(NULL, temp_map);
    incentiveRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditIncentive()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["incentives"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordIncentive * incentiveRecord = new TformRecordIncentive(NULL, temp_map);
    incentiveRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddBehTask()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"]  = lookupTables->IdOf("groups", "Behavioral Health");
  FORM_TRY
    TformRecordTaskBeh * behTaskRecord = new TformRecordTaskBeh(NULL, temp_map);
    behTaskRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditBehTask()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["beh_task"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordTaskBeh * behTaskRecord = new TformRecordTaskBeh(NULL, temp_map);
    behTaskRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddBehParticipation()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Behavioral Health");
  FORM_TRY
    TformRecordParticipationsDiab * behParticipationRecord = new TformRecordParticipationsDiab(NULL, temp_map);
    behParticipationRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditBehParticipation()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["beh_event"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordParticipationsDiab * behParticipationRecord = new TformRecordParticipationsDiab(NULL, temp_map);
    behParticipationRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddCommonParticipation()
{
  map<string,string> field_map, params;

  field_map["id"] = "new";
  field_map["person_id"] = initial_state["id"];

  params["prefix"] = "table.participations";
  params["suffix"] = "";
  params["key"]    = "insert";
  params["value"]  = "true";
  params["instructions"] = "You have permission to create participations for multiple departments.  "
                           "Please select a department to which this participation should belong.";
  set<string> group_id_set;
  string group_id_sql = "select groups.id from groups inner join users on users.group_id = groups.id where groups.id > 0 "
                        "and groups.valid = 1 and users.valid = 1 group by groups.id ";
  SqlToSet(dbDatabase, group_id_sql, group_id_set);
  params["include"] = SetToCommaString(group_id_set);
  params["exclude"] = "";
  params["table"]   = "groups";
  params["sql"] = "select id row_id, short_item row_value, item show_value from groups where valid = 1 and id > 0";

  // the participation will always belong to some particular group when using this.
  field_map["group_id"] = TformSpecialDisambiguate::Disambiguate(this, params, PrettyString);

  // For this to happen here, something would have to be very loopy with regard to permissions, but let's check to be safe.
  if (field_map["group_id"] != "")
  {
    FORM_TRY
      TformRecordParticipationsDiab * commonParticipationRecord = new TformRecordParticipationsDiab(NULL, field_map);
      commonParticipationRecord->Show();
    FORM_CATCH
  }
  else
  {
    // This really should not happen.
    PSay("You do not have permission to create a participation from this form. Please contact a programmer.",
         m_program_error, MB_OK);
  }
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditCommonParticipation()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["common_events"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordParticipationsDiab * commonParticipationRecord = new TformRecordParticipationsDiab(NULL, temp_map);
    commonParticipationRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddBehOutTreatment()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordBehOutsideTreatment * treatmentRecord = new TformRecordBehOutsideTreatment(NULL, temp_map);
    treatmentRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditBehOutTreatment()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["beh_out_treatment"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordBehOutsideTreatment * treatmentRecord = new TformRecordBehOutsideTreatment(NULL, temp_map);
    treatmentRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::cboBehCodeKeyPress(TObject *Sender, char &Key)
{
  FindComboBoxItem(Sender, Key);
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddBehCondition()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Behavioral Health");
  FORM_TRY
    TformRecordCondition * conditionRecord = new TformRecordCondition(NULL, temp_map);
    conditionRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditBehCondition()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["beh_conditions"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordCondition * conditionRecord = new TformRecordCondition(NULL, temp_map);
    conditionRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::cboRaceKeyPress(TObject *Sender, char &Key)
{
  FindComboBoxItem(Sender, Key);
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblBehConditionReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchBehConditionReport * condition_report = new TformLaunchBehConditionReport(NULL, initial_state["id"]);
    condition_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblBehLocalTreatmentReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchBehLocalTreatmentReport * local_treatment_report = new TformLaunchBehLocalTreatmentReport(NULL, initial_state["id"]);
    local_treatment_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblBehOutsideTreatmentReportClick(TObject *Sender)
{
  TfromLaunchBehOutsideTreatmentReport * outside_treatment_report = new TfromLaunchBehOutsideTreatmentReport(NULL, initial_state["id"]);
  outside_treatment_report->Show();         
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblBehTaskReportClick(TObject *Sender)
{
  TfromLaunchBehTaskReport * task_report = new TfromLaunchBehTaskReport(NULL, initial_state["id"]);
  task_report->Show();
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblBehEventReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchEventByClientReport * event_report = new TformLaunchEventByClientReport(NULL, initial_state["id"], lookupTables->IdOf("groups", "Behavioral Health"));
    event_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblComEventReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchEventByClientReport * event_report = new TformLaunchEventByClientReport(NULL, initial_state["id"], lookupTables->IdOf("groups", "Community Health"));
    event_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddAppointment()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordAppointment * appointmentRecord = new TformRecordAppointment(NULL, temp_map);
    appointmentRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditAppointment()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["appointments"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordAppointment * appointmentRecord = new TformRecordAppointment(NULL, temp_map);
    appointmentRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddConsent()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordConsent * consentRecord = new TformRecordConsent(NULL, temp_map);
    consentRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditConsent()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["consents"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordConsent * consentRecord = new TformRecordConsent(NULL, temp_map);
    consentRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddReferral()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordReferral * referralRecord = new TformRecordReferral(NULL, temp_map);
    referralRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditReferral()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["referrals"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordReferral * referralRecord = new TformRecordReferral(NULL, temp_map);
    referralRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddChart()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordChart * chartRecord = new TformRecordChart(NULL, temp_map);
    chartRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditChart()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["charts"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordChart * chartRecord = new TformRecordChart(NULL, temp_map);
    chartRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblComVisitReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchComPersonVisitReport * visitReport = new TformLaunchComPersonVisitReport(NULL, initial_state["id"]);
    visitReport->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblComEducationReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchComEducation * educationReport = new TformLaunchComEducation(NULL, initial_state["id"]);
    educationReport->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblComMeasurementReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchComMeasurementReport * measurementReport = new TformLaunchComMeasurementReport(NULL, initial_state["id"]);
    measurementReport->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblComCommentsReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchComCommentReport * commentReport = new TformLaunchComCommentReport(NULL, initial_state["id"]);
    commentReport->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddGoal()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordGoal * goalRecord = new TformRecordGoal(NULL, temp_map);
    goalRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditGoal()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["goals"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordGoal * goalRecord = new TformRecordGoal(NULL, temp_map);
    goalRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddLacPersonNote()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Little Axe Clinic");
  FORM_TRY
    TformRecordPersonNotes * noteRecord = new TformRecordPersonNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditLacPersonNote()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["lac_notes"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordPersonNotes * noteRecord = new TformRecordPersonNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddLacTask()
{
  // jhaley 20100810: rewritten to use Disambiguate and DefaultAction to ensure proper group_id gets set always.
  map<string,string> field_map, params;
  field_map["id"] = "new";
  field_map["person_id"] = initial_state["id"];

  params["prefix"] = "table.tasks";
  params["suffix"] = "";
  params["key"]    = "insert";
  params["value"]  = "true";
  params["instructions"] = "You have permission to create tasks for more than one clinic. Please choose the clinic for which a new task should be created.";
  params["include"] = lookupTables->IdOf("groups", "Little Axe Clinic") + ", " + lookupTables->IdOf("groups", "Shawnee Clinic");
  params["exclude"] = "";
  params["table"]   = "groups";
  params["sql"]     = "select id row_id, short_item row_value, item show_value from groups where valid = 1 and id > 0";

  field_map["group_id"] = TformSpecialDisambiguate::Disambiguate(this, params, PrettyString);
  if (field_map["group_id"] != "")
    DefaultAction("tasks", field_map); // DefaultAction knows how to launch a task form properly.
  else
  {
    // This really should not happen. View of this item is restricted to the groups specified in params["include"].
    PSay("You do not have permission to create a task using this form. Please contact a programmer.", m_program_error, MB_OK);
  }

  // jhaley: this is insufficient; leaves group_id == "" and I don't see it getting set to anything inside the form if
  // is_new_record is true. Major bug I guess.
  /*
  FORM_TRY
    TformRecordTaskLac * lacTaskRecord = new TformRecordTaskLac(NULL, temp_map, "");
    lacTaskRecord->Show();
  FORM_CATCH
  */
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditLacTask()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["lac_tasks"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordTaskLac * lacTaskRecord = new TformRecordTaskLac(NULL, temp_map, "");
    lacTaskRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditLacProcedure()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["lac_procedures"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordProcedure * procedureRecord = new TformRecordProcedure(NULL, temp_map);
    procedureRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddLacParticipation()
{
  map<string,string> field_map, params;
  field_map["id"] = "new";
  field_map["person_id"] = initial_state["id"];

  params["prefix"] = "table.participations";
  params["suffix"] = "";
  params["key"]    = "insert";
  params["value"]  = "true";
  params["instructions"] = "You have permission to create participations for more than one clinic. Please choose the clinic for which a new participation should be created.";
  params["include"] = lookupTables->IdOf("groups", "Little Axe Clinic") + ", " + lookupTables->IdOf("groups", "Shawnee Clinic");
  params["exclude"] = "";
  params["table"]   = "groups";
  params["sql"]     = "select id row_id, short_item row_value, item show_value from groups where valid = 1 and id > 0";

  field_map["group_id"] = TformSpecialDisambiguate::Disambiguate(this, params, PrettyString);
  if (field_map["group_id"] != "")
  {
    FORM_TRY
      TformRecordParticipationsDiab *clinicParticipationRecord = new TformRecordParticipationsDiab(NULL, field_map);
      clinicParticipationRecord->Show();
    FORM_CATCH
  }
  else
  {
    // This really should not happen. View of this item is restricted to the groups specified in params["include"].
    PSay("You do not have permission to create a participation using this form. Please contact a programmer.", m_program_error, MB_OK);
  }
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditLacParticipation()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["lac_event"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordParticipationsDiab * denParticipationRecord = new TformRecordParticipationsDiab(NULL, temp_map);
    denParticipationRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditBehProcedure()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["beh_procedures"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordProcedure * procedureRecord = new TformRecordProcedure(NULL, temp_map);
    procedureRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddDenPersonNote()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Dental Clinic");
  FORM_TRY
    TformRecordPersonNotes * noteRecord = new TformRecordPersonNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditDenPersonNote()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["den_notes"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordPersonNotes * noteRecord = new TformRecordPersonNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddDenTask()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordTaskDen * denTaskRecord = new TformRecordTaskDen(NULL, temp_map);
    denTaskRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditDenTask()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["den_tasks"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordTaskDen * denTaskRecord = new TformRecordTaskDen(NULL, temp_map);
    denTaskRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditDenProcedure()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["den_procedures"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordProcedure * procedureRecord = new TformRecordProcedure(NULL, temp_map);
    procedureRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddDenParticipation()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = lookupTables->IdOf("groups", "Dental Clinic");
  FORM_TRY
    TformRecordParticipationsDiab * denParticipationRecord = new TformRecordParticipationsDiab(NULL, temp_map);
    denParticipationRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditDenParticipation()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["den_event"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordParticipationsDiab * denParticipationRecord = new TformRecordParticipationsDiab(NULL, temp_map);
    denParticipationRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditCob()
{
  map<string,string> temp_map;
  temp_map["id"] = (IsVisible (listCaregiverCOB)) ? filter_atlas_handler["caregiver_cob"].filter->GetSelectedRecordID() : filter_atlas_handler["cob"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordTaskCob * cobRecord = new TformRecordTaskCob(NULL, temp_map);
    cobRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditCobVisit()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["cob_visit"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordTaskCobVisit * cobRecord = new TformRecordTaskCobVisit(NULL, temp_map);
    cobRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditDeferredCOB()
{
  pmapstrs temp_map;
  temp_map["id"] = filter_atlas_handler["deferred_cob"].filter->GetSelectedRecordID();
  TformRecordDeferredCOB *defCOBRecord = NULL;
  FORM_TRY
    defCOBRecord = new TformRecordDeferredCOB(NULL, temp_map);
  FORM_CATCH_RETURN("TformRecordDeferredCOB", )
  defCOBRecord->Show();
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddDeferredCOB()
{
  pmapstrs temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  TformRecordDeferredCOB *defCOBRecord = NULL;
  FORM_TRY
    defCOBRecord = new TformRecordDeferredCOB(NULL, temp_map);
  FORM_CATCH_RETURN("TformRecordDeferredCOB", )
  defCOBRecord->Show();
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditCobBill()
{
  map<string,string> temp_map;
  temp_map["id"] = (IsVisible (listCaregiverBills)) ? filter_atlas_handler["caregiver_bills"].filter->GetSelectedRecordID() : filter_atlas_handler["cob_bills"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordIncomingBill * cobBillRecord = new TformRecordIncomingBill(NULL, temp_map);
    cobBillRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddConDenial()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordDenial * rec = new TformRecordDenial(NULL, temp_map);
    rec->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditConDenial()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["con_denial"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordDenial * rec = new TformRecordDenial(NULL, temp_map);
    rec->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditLacBill()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["lac_bills"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordOutgoingBill * lacBillRecord = new TformRecordOutgoingBill(NULL, temp_map);
    lacBillRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditDenBill()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["den_bills"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordOutgoingBill * denBillRecord = new TformRecordOutgoingBill(NULL, temp_map);
    denBillRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddCaseNote()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];

  // do they have permission to create multiple types of case_notes?  If so, ask them which department the note should be associated with...
  map<string, string> params;
  set<string> groups;
  params["prefix"]       = "table.case_notes";
  params["suffix"]       = "";
  params["key"]          = "insert";
  params["value"]        = "true";
  params["instructions"] = "You have permission to create case management notes for multiple departments.  Please select the department with which to associate this note.";
  string groups_w_users  = "select groups.id from groups inner join users on users.group_id = groups.id where groups.id > 0 and groups.valid = 1 and users.valid = 1 group by groups.id";
  SqlToSet(dbDatabase, groups_w_users, groups);
  params["include"]      = SetToCommaString(groups);
  params["exclude"]      = "";
  params["table"]        = "groups";
                                // PK      // permission-string  // string to show in drop-down
  params["sql"]          = "select id row_id, short_item row_value, item show_value from groups where valid = 1 and id > 0";

  temp_map["group_id"]  = TformSpecialDisambiguate::Disambiguate(this, params, PrettyString);
  if (temp_map["group_id"] == "")
    PSay("You don't seem to have permission to create case management notes for any departments.\n\nFeel free to contact a programmer to request any additional permissions you need.", m_message, MB_OK, "\"" + params["to_include"] + "\" - \"" + params["to_exclude"] + "\"");
  else
  {
    //DefaultAction("case_notes", field_map);
    FORM_TRY
      TformRecordCaseNotes * noteRecord = new TformRecordCaseNotes(NULL, temp_map);
      noteRecord->Show();
    FORM_CATCH
  }
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditCaseNote()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["case_notes"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordCaseNotes * noteRecord = new TformRecordCaseNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddCobPersonNote()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  // this may look inconsistent, but it's RIGHT.  Don't change it to current_groupid like I did.
  // this is so other groups (say 3rd pary billing) can save CHS notes!
  temp_map["group_id"] = lookupTables->IdOf("groups", "Contract Health");
  FORM_TRY
    TformRecordPersonNotes * noteRecord = new TformRecordPersonNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditCobPersonNote()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["cob_notes"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordPersonNotes * noteRecord = new TformRecordPersonNotes(NULL, temp_map);
    noteRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditInsApp()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["ins_app"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordInsuranceApplication * insappRecord = new TformRecordInsuranceApplication(NULL, temp_map);
    insappRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddInsApp()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordInsuranceApplication * ins_app = new TformRecordInsuranceApplication(NULL, temp_map);
    ins_app->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditCoverage()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["coverage"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordInsuranceCoverage * coverageRecord = new TformRecordInsuranceCoverage(NULL, temp_map);
    coverageRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddCoverage()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  FORM_TRY
    TformRecordInsuranceCoverage * coverageRecord = new TformRecordInsuranceCoverage(NULL, temp_map);
    coverageRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblPublicVisitReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchPublicVisitReport * visitReport = new TformLaunchPublicVisitReport(NULL, initial_state["id"]);
    visitReport->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblPublicMetricReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchPublicMeasurementReport * measurementReport = new TformLaunchPublicMeasurementReport(NULL, initial_state["id"]);
    measurementReport->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblPublicEduReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchPublicEducation * eduReport = new TformLaunchPublicEducation(NULL, initial_state["id"]);
    eduReport->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblPublicEventReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchEventByClientReport *eventReport = new TformLaunchEventByClientReport(NULL, initial_state["id"], lookupTables->IdOf("groups", "Public Health"));
    eventReport->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblPublicCommentReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchPublicCommentReport * commentReport = new TformLaunchPublicCommentReport(NULL, initial_state["id"]);
    commentReport->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::txtUpdateClick(TObject *Sender)
{
  TformLaunchIntakeFormReport::DoSilent(this, initial_state["id"], "", true, false);
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::staticPersonLimitsClick(TObject *Sender)
{
 // go see stuff
 map<string, string> params;
 params["id"] = initial_state["id"];
 FORM_TRY
   TformSpecialPersonLimits * see_limits = new TformSpecialPersonLimits(NULL, params);
   see_limits->Show();
 FORM_CATCH
 return;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::btnProviderSearchClick(TObject *Sender)
{
  // create and show new person search form
  vector<string> return_vector;
  FORM_TRY
    TformSearchTaxEntity * providerSearch = new TformSearchTaxEntity(NULL,&return_vector);
    providerSearch->ShowTaskModal(this);
  FORM_CATCH
  if (! return_vector.empty())
    CreateLink(txtProvider, btnProviderSearch, this, return_vector[0], "tax_entities");
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::staticViewRelationshipGraphClick(TObject *Sender)
{
 // open up the graphical thingie of doom
  FORM_TRY
    TformSpecialRelationshipGraph * graph_form = new TformSpecialRelationshipGraph(NULL, initial_state["id"]);
    graph_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::staticModifyHeadHouseholdClick(TObject *Sender)
{
 TformSpecialHouseholdMod * hh_mod;
 // household mod
 if (is_new_record)
 {
  PSay("You can change the head of household once you've saved this record.\nBy default, a new person is the head of his/her own household.", m_message, MB_OK);
 } else
 if (is_editing)
 {
  FORM_TRY
   hh_mod = new TformSpecialHouseholdMod(NULL, temp_head_of_household, lock_transaction);
  FORM_CATCH
  if (hh_mod->ShowTaskModal(this) == mrOk)
  {
   string sql_find_new_head = "select head_household_id from people where id = " + initial_state["id"];
   temp_head_of_household = GetOneField(lock_transaction, sql_find_new_head);
   CreateLink(staticHeadHousehold, NULL, this, temp_head_of_household, "people");
  }
 } else
 {
  TIBTransaction * temp_transaction = new TIBTransaction(NULL);
  StdTransaction (temp_transaction, dbDatabase);
  FORM_TRY
   hh_mod = new TformSpecialHouseholdMod(NULL, temp_head_of_household, temp_transaction);
  FORM_CATCH
  if (hh_mod->ShowTaskModal(this) != mrAbort)
   temp_transaction->Commit();
  else
   temp_transaction->Rollback();
  delete temp_transaction;
  atlas->Notify("people.id", initial_state["id"]);
  // TODO: DOES NOT UPDATE SCREENS WITH RECORDS OPEN FOR OTHER PEOPLE IN THIS SAME HOUSEHOLD!
 }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::txtCaregiverLimitsClick(TObject *Sender)
{
  map<string,string> temp_map;
  temp_map = initial_state;
  FORM_TRY
    TformSpecialCaregiverLimits * caregiver_limits = new TformSpecialCaregiverLimits(NULL, temp_map);
    caregiver_limits->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::treeCobTreeAdvancedCustomDraw(
      TCustomTreeView *Sender, const TRect &ARect, TCustomDrawStage Stage,
      bool &DefaultDraw)
{
 // start drawing the tree view
 treeCobTree->OnAdvancedCustomDraw = NULL;
 progressContractHealthTree->Position = 0;
 Processing(true);
 DrawCobTree();
 Processing(false);
 progressContractHealthTree->Position = 0;
}
//---------------------------------------------------------------------------
void TformRecordPerson::DrawCobTree()
{
 // start a transaction, pass stuff to the RecurseCobTreeItem function
 if (IsInt(initial_state["id"]))
 {
  TIBTransaction * dbTransaction = new TIBTransaction(NULL);
  StdTransaction (dbTransaction, dbDatabase);
  treeCobTree->Images = imagesRecordTypes;
  TTreeNode * root = treeCobTree->Items->Add(NULL, DrawCobTreeItem(node_person, initial_state).c_str());
  root->ImageIndex = 4;
  root->SelectedIndex = 4;
  RecurseCobTreeItem(dbTransaction, root, node_person, initial_state["id"], 1000);
  root->Expanded = true;
  dbTransaction->Commit();
  delete dbTransaction;
 }
}
//---------------------------------------------------------------------------
void TformRecordPerson::RecurseCobTreeItem(TIBTransaction * dbTransaction, TTreeNode * parent_node, node_types parent_type, string parent_id, int chunk_size)
{
 map<string, string>          reusable_map;
 vector<map<string, string> > reusable_vec;
 string                       reusable_string;
 TTreeNode *                  reusable_node;
 int start_pos = progressContractHealthTree->Position;

 switch (parent_type)
 {
  case node_person:
   // select all cob's
   // NOTE USES VIEW
   reusable_string = "select cob_tasks.id, cob_tasks.date_of_task, cob_tasks.preconditions_note, cob_tasks.hospitalized, cob_tasks.given_room, cob_tasks.followup_note, cob_tasks.reported_by_note, services_provided.service_id, services_provided.area_id, tax_entities.name, tin.identifier "
                     "from cob_tasks "
                     "inner join services_provided on cob_tasks.services_provided_id = services_provided.id "
                     "inner join tax_entities on services_provided.tax_entity_id = tax_entities.id "
                     "left join entity_ids tin on tin.tax_entity_id = tax_entities.id and tin.current_id >= 3 and tin.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "TIN/EIN") + "' "
                     "where cob_tasks.person_id = " + parent_id + " and cob_tasks.date_of_task is not null order by cob_tasks.date_of_task";
   SqlToVecMap(dbTransaction, reusable_string, reusable_vec);
   for (vector<map<string, string> >::iterator i_item = reusable_vec.begin(); i_item != reusable_vec.end(); i_item++)
   {
    // check for special ER visits (we can check for other types of tasks here too if we like later)
    reusable_node = treeCobTree->Items->AddChild(parent_node, DrawCobTreeItem(node_cob, *i_item).c_str());
    if ((*i_item)["preconditions_note"] != ""  ||
        (*i_item)["followup_note"]      != ""  ||
        (*i_item)["reported_by_note"]   != ""  ||
        (*i_item)["hospitalized"]       == "1" ||
        (*i_item)["given_room"]         == "1")
    {
     reusable_node->ImageIndex = 10;
     reusable_node->SelectedIndex = 10;
    } else
    {
     reusable_node->ImageIndex = 8;
     reusable_node->SelectedIndex = 8;
    }
    reusable_node->Data = (void *)StringToInt((*i_item)["id"]);
    RecurseCobTreeItem (dbTransaction, reusable_node, node_cob, (*i_item)["id"], (chunk_size / reusable_vec.size()));
   }
   break;
  case node_cob:
   // select all tx's
   reusable_string = "select sum(credit_amount - debit_amount) account_total, accounts.name, accounts.account_type_id "
                     "from transactions "
                     "inner join accounts on transactions.account_id = accounts.id "
                     "where transactions.task_id = " + parent_id +
                     "group by accounts.name, accounts.account_type_id having sum(credit_amount - debit_amount) != 0.00";
   SqlToVecMap(dbTransaction, reusable_string, reusable_vec);
   for (vector<map<string, string> >::iterator i_item = reusable_vec.begin(); i_item != reusable_vec.end(); i_item++)
   {
    reusable_node = treeCobTree->Items->AddChild(parent_node, DrawCobTreeItem(node_account, *i_item).c_str());
    reusable_node->ImageIndex = 0;
    reusable_node->SelectedIndex = 0;
    reusable_node->Data = NULL;
   }

   // select all visits
   // NOTE USES VIEW
   reusable_string = "select visit_tasks.id, visit_tasks.date_of_task, tax_entities.name, tin.identifier "
                     "from visit_tasks "
                     "inner join tax_entities on visit_tasks.tax_entity_id = tax_entities.id "
                     "left join entity_ids tin on tin.tax_entity_id = tax_entities.id and tin.current_id >= 3 and tin.entity_id_id = '" + lookupTables->IdOf("entity_id_types", "TIN/EIN") + "' "
                     "where visit_tasks.parent_task_id = " + parent_id + " order by visit_tasks.date_of_task";
   SqlToVecMap(dbTransaction, reusable_string, reusable_vec);
   for (vector<map<string, string> >::iterator i_item = reusable_vec.begin(); i_item != reusable_vec.end(); i_item++)
   {
    reusable_node = treeCobTree->Items->AddChild(parent_node, DrawCobTreeItem(node_visit, *i_item).c_str());
    reusable_node->ImageIndex = 9;
    reusable_node->SelectedIndex = 9;
    reusable_node->Data = (void *)StringToInt((*i_item)["id"]);
    RecurseCobTreeItem (dbTransaction, reusable_node, node_visit, (*i_item)["id"], (chunk_size / reusable_vec.size()));
   }
   break;
  case node_visit:
   // select all bills
   reusable_string = "select bills.id, bills.bill_date, tax_entities.name from bills inner join tax_entities on bills.actual_tax_id = tax_entities.id where task_id = " + parent_id + " order by bills.bill_date";
   SqlToVecMap(dbTransaction, reusable_string, reusable_vec);
   for (vector<map<string, string> >::iterator i_item = reusable_vec.begin(); i_item != reusable_vec.end(); i_item++)
   {
    reusable_node = treeCobTree->Items->AddChild(parent_node, DrawCobTreeItem(node_bill, *i_item).c_str());
    reusable_node->ImageIndex = 1;
    reusable_node->SelectedIndex = 1;
    reusable_node->Data = (void *)StringToInt((*i_item)["id"]);
    RecurseCobTreeItem (dbTransaction, reusable_node, node_bill, (*i_item)["id"], (chunk_size / reusable_vec.size()));
   }
   break;
  case node_bill:
   // yes, this is an oddity in the tree
   // purchase request -- not really under ... but ... under. be quiet.
   reusable_string = "select purchase_reqs.id, purchase_reqs.date_sent, tax_entities.name from bills inner join purchase_reqs on purchase_reqs.id = bills.purchase_req_id and bills.purchase_req_id != 0 inner join tax_entities on purchase_reqs.tax_entity_id = tax_entities.id where bills.id = " + parent_id;
   SqlToMap(dbTransaction, reusable_string, reusable_map);
   if (!reusable_map.empty())
   {
    reusable_node = treeCobTree->Items->AddChild(parent_node, DrawCobTreeItem(node_purchase_req, reusable_map).c_str());
    reusable_node->ImageIndex = 5;
    reusable_node->SelectedIndex = 5;
    reusable_node->Data = (void *)StringToInt(reusable_map["id"]);
    RecurseCobTreeItem (dbTransaction, reusable_node, node_purchase_req, reusable_map["id"], chunk_size / 2);
   }

   // yes, this is another oddity in the tree
   // check -- yes, i know it should be 'under' purchase_req (actually, should be over, but we can't have two roots) ... easier to read this way. shut up.
   reusable_string = "select checks.id, checks.date_sent, tax_entities.name from bills inner join purchase_reqs on purchase_reqs.id = bills.purchase_req_id and bills.purchase_req_id != 0 inner join checks on purchase_reqs.check_id = checks.id and purchase_reqs.check_id != 0 inner join tax_entities on checks.tax_entity_id = tax_entities.id where bills.id = " + parent_id;
   SqlToMap(dbTransaction, reusable_string, reusable_map);
   if (!reusable_map.empty())
   {
    reusable_node = treeCobTree->Items->AddChild(parent_node, DrawCobTreeItem(node_check, reusable_map).c_str());
    reusable_node->ImageIndex = 2;
    reusable_node->SelectedIndex = 2;
    reusable_node->Data = (void *)StringToInt(reusable_map["id"]);
    RecurseCobTreeItem (dbTransaction, reusable_node, node_check, reusable_map["id"], chunk_size / 2);
   }

   // select all tx's
   reusable_string = "select sum(credit_amount - debit_amount) account_total, accounts.name, accounts.account_type_id from transactions inner join accounts on transactions.account_id = accounts.id where transactions.bill_id = " + parent_id + " group by accounts.name, accounts.account_type_id having sum(credit_amount - debit_amount) != 0.00";
   SqlToVecMap(dbTransaction, reusable_string, reusable_vec);
   for (vector<map<string, string> >::iterator i_item = reusable_vec.begin(); i_item != reusable_vec.end(); i_item++)
   {
    reusable_node = treeCobTree->Items->AddChild(parent_node, DrawCobTreeItem(node_account, *i_item).c_str());
    reusable_node->ImageIndex = 0;
    reusable_node->SelectedIndex = 0;
    reusable_node->Data = NULL;
   }
   break;
  case node_transaction:
   progressContractHealthTree->Position += chunk_size;
   break;
  case node_tax_entity:
   progressContractHealthTree->Position += chunk_size;
   break;
  case node_account:
   progressContractHealthTree->Position += chunk_size;
   break;
  case node_purchase_req:
   progressContractHealthTree->Position += chunk_size;
   break;
  case node_check:
   progressContractHealthTree->Position += chunk_size;
   break;
  default:
   ;
 }

 // keep it all closed for now, let the user expand
 if (parent_node)
  parent_node->Expanded = false;

 // just in case the math wasn't right in the recursion, this'll catch up the slack
 progressContractHealthTree->Position = start_pos + chunk_size;
 return;
}
//---------------------------------------------------------------------------
string TformRecordPerson::DrawCobTreeItem(node_types node_type, map<string, string> node_data)
{
 // add yourself as a child and draw the item
 string new_node_text;
 switch (node_type)
 {
  case node_person:
   new_node_text = string(staticHeaderName->Caption.c_str());
   break;
  case node_cob:
   new_node_text = PrettyDate(node_data["date_of_task"]) + ": cob request for " + lookupTables->ValueOf("service_types", node_data["service_id"]) + " with " + node_data["name"];
   break;
  case node_visit:
   new_node_text = PrettyDate(node_data["date_of_task"]) + ": visit with " + node_data["name"];
   break;
  case node_bill:
   new_node_text = PrettyDate(node_data["bill_date"]) + ": bill received from " + node_data["name"];
   break;
  case node_transaction:
   new_node_text = "Transaction: " + PrettyDate(node_data["effective_date"]) + ", $" + StringToAmount(node_data["debit_amount"]) + " | $" + StringToAmount(node_data["credit_amount"]);
   break;
  case node_tax_entity:
   new_node_text = "Entity: " + node_data["name"];
   break;
  case node_account:
   new_node_text = node_data["name"] + " (" + lookupTables->ValueOf("account_types", node_data["account_type_id"]) + ") $" + FinancialToString(abs(StringToFinancial(node_data["account_total"]).AsLongDouble()), true);
   break;
  case node_purchase_req:
   new_node_text = PrettyDate(node_data["date_sent"]) + " purchase request sent for " + node_data["name"];
   break;
  case node_check:
   new_node_text = PrettyDate(node_data["date_sent"]) + " check sent to " + node_data["name"];
   break;
  default:
   new_node_text = "Unknown object";
 }
 return new_node_text;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::treeCobTreeDblClick(TObject *Sender)
{
 // dbl-click!!!
 TTreeNode * selected_node = treeCobTree->Selected;
 if (selected_node)
 {
  // NOT IDEAL -- but the VCL takes away my ability to say "don't by default expand/collapse" so GRRRR to it.
  selected_node->Expanded = !(selected_node->Expanded);

  if (selected_node->Data)
  {
   int item_id = (int)selected_node->Data;
   int item_icon = selected_node->ImageIndex;
   string item_id_string = IntToString(item_id);
   map<string, string> params;
   params["id"] = item_id_string;
   switch(item_icon)
   {
    case 10:
    case  8:
     // cob
     if (optionsPermissions["table.tasks.cob"]["view"] == "true" && optionsPermissions["table.tasks"]["view"] == "true")
     {
      FORM_TRY
       TformRecordTaskCob * zoom = new TformRecordTaskCob(NULL, params);
       zoom->Show();
      FORM_CATCH
     } else
      PSay("You are not authorized to see information about COB requests and ER notifications.", m_message, MB_OK);
     break;
    case  9:
     // visit
     if (optionsPermissions["table.tasks.cob"]["view"] == "true" && optionsPermissions["table.tasks"]["view"] == "true")
     {
      FORM_TRY
       TformRecordTaskCobVisit * zoom = new TformRecordTaskCobVisit(NULL, params);
       zoom->Show();
      FORM_CATCH
     } else
      PSay("You are not authorized to see information about COB visits.", m_message, MB_OK);
     break;
    case  5:
     // pr
     if (optionsPermissions["table.purchase_reqs"]["view"] == "true")
     {
      FORM_TRY
       TformRecordPurchaseReq * zoom = new TformRecordPurchaseReq(NULL, params);
       zoom->Show();
      FORM_CATCH
     } else
      PSay("You are not authorized to see information about purchase requests.", m_message, MB_OK);
     break;
    case  2:
     // check
     if (optionsPermissions["table.checks"]["view"] == "true")
     {
      FORM_TRY
       TformRecordCheck * zoom = new TformRecordCheck(NULL, params);
       zoom->Show();
      FORM_CATCH
     } else
      PSay("You are not authorized to see information about checks.", m_message, MB_OK);
     break;
    case  1:
     // bill
     if (optionsPermissions["table.bills.incoming"]["view"] == "true" && optionsPermissions["table.bills"]["view"] == "true")
     {
      FORM_TRY
       TformRecordIncomingBill * zoom = new TformRecordIncomingBill(NULL, params);
       zoom->Show();
      FORM_CATCH
     } else
      PSay("You are not authorized to see information about incoming bills.", m_message, MB_OK);
     break;
    default:
     PSay("There is a record number on the selected node, but no associated action.\nThis should be reported to your programmers.", m_program_error, MB_OK);
     break;
   }
  } else
  {
   PSay("No more information is available.\nIf you believe you know of something that would be appropriate,\nplease inform your programmers.", m_message, MB_OK);
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::txtProceduresClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchProcsDoneReport *procedure_report = new TformLaunchProcsDoneReport(NULL, initial_state["id"]);
    procedure_report->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::txtConditionsClick(TObject *Sender)
{
// TODO: yup, something should be done here. like, when we have a report or something. (conditions printout)
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::checkShowConditionsClick(TObject *Sender)
{
  // change listview rules
  if (optionsPermissions["table.conditions"]["view"] == "true")
  {
    set<string> allowed_groups = GetGroupPermissions("table.conditions", "", "view", "true");

    // TODO: possibly dangerous ... members of a group might need stuff taken away from them, even from their own group?
    // TODO: possibly dangerous restricting visibility of conditions such as allergies to only certain providers! - jhaley
    allowed_groups.insert(current_groupid);

    string allowed_groups_list = SetToCommaString(allowed_groups);

    vector<string> wanted_types;
    wanted_types.push_back("0");
    if (checkShowConditionsAllergies->Checked)
     wanted_types.push_back(lookupTables->IdOf("condition_types", "Allergy"));
    if (checkShowConditionsDrugAllergies->Checked)
     wanted_types.push_back(lookupTables->IdOf("condition_types", "Drug Allergy"));
    if (checkShowConditionsOther->Checked)
     wanted_types.push_back(lookupTables->IdOf("condition_types", "Condition"));
    if (checkShowConditionsRelatives->Checked)
     wanted_types.push_back(lookupTables->IdOf("condition_types", "Relative"));

    string wanted_types_list = VecToCommaString(wanted_types);

    if (!allowed_groups_list.empty())
    {
     // if ...
     string sql;

     // HACK: use of +1 again to make it go faster ... works. from 6 seconds to 1, for cdib 2347 (test case)
     sql  = "select condition_types.item, case when conditions.task_id > 0 then '1' else '0' end, conditions.start_date, conditions.stop_date, "
            "conditions.code, conditions.note, codes.description, groups.item, "
            "conditions.current_id, conditions.id "
            "from conditions inner join condition_types on conditions.condition_id = condition_types.id "
            "inner join groups on conditions.group_id = groups.id "
            "left join codes on conditions.code = codes.code "
            "where "
            "conditions.person_id = " + initial_state["id"] + " and ";
     if (!radioShowConditionsBoth->Checked)
     {
       if (radioShowConditionsDiagnosed->Checked)
         sql += "conditions.task_id + 1 > 0 + 1 and ";
       if (radioShowConditionsReported->Checked)
         sql += "conditions.task_id + 1 = 0 + 1 and ";
     }
     sql +=  "conditions.condition_id + 1 - 1 in (" + wanted_types_list + ") and "
             "conditions.group_id + 1 - 1 in (" + allowed_groups_list + ")";

     filter_atlas_handler["any_conditions"].filter->SetSQLStatement(sql);
     filter_atlas_handler["any_conditions"].filter->RefreshDataSet();
    }
    filter_atlas_handler["any_conditions"].filter->SetAddEdit(this, AddRecord(&(TformRecordPerson::AddAnyCondition)),
                                  EditRecord(&(TformRecordPerson::EditAnyCondition)));
    filter_atlas_handler["any_conditions"].request = atlas->RequestNotificationWhen("conditions.person_id", initial_state["id"], rel_e, as_int, this,
                              RefreshHandler(&(TformRecordPerson::AtlasRefreshListViews)));
  }
}
//---------------------------------------------------------------------------
void TformRecordPerson::AddAnyCondition()
{
  map<string,string> temp_map;
  temp_map["id"] = "new";
  temp_map["person_id"] = initial_state["id"];
  temp_map["group_id"] = current_groupid;
  temp_map["task_id"] = "0";
  FORM_TRY
    TformRecordCondition * conditionRecord = new TformRecordCondition(NULL, temp_map);
    conditionRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void TformRecordPerson::EditAnyCondition()
{
  map<string,string> temp_map;
  temp_map["id"] = filter_atlas_handler["any_conditions"].filter->GetSelectedRecordID();
  FORM_TRY
    TformRecordCondition * conditionRecord = new TformRecordCondition(NULL, temp_map);
    conditionRecord->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
bool TformRecordPerson::GetWarningsPreventingContractHealthActions (TIBTransaction * dbTransaction, string person_id, Pdate as_of_date, set<string> & problems_found)
{
 problems_found.clear();

 if (!dbTransaction)
  return false;
 if (!dbTransaction->Active)
  return false;

 // problems to look for:
 // - as of the date specified, the client isn't born yet
 // - as of the date specified, the client is already dead
 // - as of the date specified, no AST affiliations were active
 // - an open note exists specifying a lock (not yet decided where to store that -- some form of person notes?)
 // - they need to sign a form (open note)
 // - they can't have MVA stuff paid (open note)
 // - they ... something else. (open note?)

 map<string, string>          birth_info;
 string                       valid_affiliation_count;
 vector<map<string, string> > important_notes;

 // existing, being born, being dead ... it's all so confusing.
 string sql_find_useful_birth_info = "select birth_date, death_date from people where id = " + person_id;
 if (!SqlToMap(dbTransaction, sql_find_useful_birth_info, birth_info))
  return false;
 if (birth_info["birth_date"] != "" && Pdate(birth_info["birth_date"], global_mode) > as_of_date)
  problems_found.insert(string("This person's date of birth is " + Pdate(birth_info["birth_date"], global_mode).OutDate(global_mode) + ", after the date of service specified."));
 if (birth_info["death_date"] != "" && Pdate(birth_info["death_date"], global_mode) < as_of_date)
  problems_found.insert(string("This person's date of death is " + Pdate(birth_info["death_date"], global_mode).OutDate(global_mode) + ", before the date of service specified."));

 // affiliations. very important.
 string sql_find_useful_affiliations = "select count(*) from affiliations where affiliations.person_id = " + person_id + " and affiliations.tribe_id = " + lookupTables->IdOf("tribe_types", "Absentee Shawnee Tribes Of Oklahoma") + " and (affiliations.join_date is null or affiliations.join_date <= '" + as_of_date.OutDate(global_mode) + "') and (affiliations.relinquish_date is null or affiliations.relinquish_date >= '" + as_of_date.OutDate(global_mode) + "')";
 try
 {
  valid_affiliation_count = GetOneField(dbTransaction, sql_find_useful_affiliations);
 } catch (...) {return false;}

 if (!IsInt(valid_affiliation_count) || StringToInt(valid_affiliation_count) == 0)
  problems_found.insert("This person did not have an valid, ongoing tribal affiliation with the Abs. Shawnee Tr. of Ok. on the date of service specified.");

 // notes of some sort ... very vague.
 string sql_find_interesting_notes = "select * from person_notes where person_id = " + person_id + " and current_id = 5";
 if (!SqlToVecMap(dbTransaction, sql_find_interesting_notes, important_notes))
  return false;

 for(vector<map<string, string> >::iterator i_note = important_notes.begin(); i_note != important_notes.end(); i_note++)
  problems_found.insert(lookupTables->ValueOf("users", (*i_note)["last_updated_by"]) + ", around " + Pstamp((*i_note)["last_update_stamp"], global_mode).OutDate(global_mode) + " notes: " + (*i_note)[""]);

 return true;
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::staticViewFamilyTreeClick(TObject *Sender)
{
 // open up the graphical thingie of doom
  FORM_TRY
    TformSpecialRelationshipGraph * graph_form = new TformSpecialRelationshipGraph(NULL, initial_state["id"], true);
    graph_form->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::txtPatientProviderInfoClick(TObject *Sender)
{
 FORM_TRY
  TformLaunchPersonProviderInfoReport * rep = new TformLaunchPersonProviderInfoReport(NULL, initial_state["id"], "0", "0");
  rep->Show();
 FORM_CATCH       
}
//---------------------------------------------------------------------------
void TformRecordPerson::DoRelationships2Thing()
{
  map<string, set<string> > item_dependencies;
  set<string> temp;

  item_dependencies["root1"] = temp;
  item_dependencies["root2"] = temp;
  item_dependencies["root3"] = temp;
  temp.insert("root1");
  item_dependencies["sub1"] = temp;
  temp.insert("root2");
  item_dependencies["sub2"] = temp;
  temp.clear();
  temp.insert("root3");
  temp.insert("sub1");
  temp.insert("sub2");
  item_dependencies["subsub"] = temp;
  temp.clear();
  temp.insert("subsub");
  temp.insert("root3");
  item_dependencies["subby"] = temp;
  temp.clear();
  temp.insert("subby");
  item_dependencies["bobby"] = temp;
  temp.clear();
  temp.insert("bobby");
  item_dependencies["larry"] = temp;
  temp.clear();
  temp.insert("larry");
  temp.insert("sub1");
  item_dependencies["john"] = temp;
  temp.clear();
  temp.insert("john");
  temp.insert("subsub");
  item_dependencies["weee"] = temp;

  temp.clear();
  item_dependencies["joe"] = temp;
  item_dependencies["mary"] = temp;
  item_dependencies["sarah"] = temp;
  temp.insert("joe");
  temp.insert("mary");
  item_dependencies["zoe"] = temp;
  item_dependencies["mark"] = temp;
  temp.clear();
  temp.insert("mark");
  temp.insert("sarah");
  item_dependencies["joan"] = temp;
  item_dependencies["zak"] = temp;
  item_dependencies["timothy"] = temp;

  /*
  vector<set<string> > bands_of_items;
  dependency_graph (item_dependencies, bands_of_items, true);
  for (vector<set<string> >::iterator i = bands_of_items.begin(); i != bands_of_items.end(); i++)
  {
   PSay("New band", m_debug, MB_OK);
   for (set<string>::iterator j = i->begin(); j != i->end(); j++)
    PSay("Item: " + *j, m_debug, MB_OK);
  }
  */

  // maybe the dependency graph function can return as relationships whatever it couldn't make into dependencies?
  // or it'd be good to split things into:
  // - items
  // - items-in-bands (dependency-determined)
  // - relationships (any, dependency or not)
  vector<pair<string, string> > item_relationships;
  item_relationships.push_back(pair<string, string>("joe", "mary"));
  item_relationships.push_back(pair<string, string>("mark", "sarah"));
  item_relationships.push_back(pair<string, string>("joan", "weee"));

  depgraphRelationships2->SetDependencies(item_dependencies, item_relationships);
  depgraphRelationships2->BandColor = TColor(0x00F0F0F0);
  depgraphRelationships2->BandWidth = 60;
  depgraphRelationships2->Active = true;
}
//---------------------------------------------------------------------------
void TformRecordPerson::Do(map<string, string> & p_parameters)
{
 FORM_TRY
  TformRecordPerson * z = new TformRecordPerson(NULL, p_parameters);
  z->Show();
 FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::pageSelectAreaChange(TObject *Sender)
{
  // Assumption:  There's only one control on the tabsheet, and it's the panel that has everything else on it; the
  // panel's height is set to the desired height of this "page" of the record form.  We can loop though the Components
  // array looking to see if Control[i]->ClassType() == TPanel, etc., but it seems unnecessary at this point.

  // This didn't work because none of the events on the TPageControl, the TTabSheet's, etc. occur AFTER the ActivePage
  // has been updated, thus we'd be setting the height to what it should've been for the LAST visible page.  Grrr.

  // DONE: see code at end of comboSelectAreaChange()

/*  int i = 0;
  bool done = false;
  while (i < pageSelectArea->ActivePage->ControlCount && !done)
  {
   if(pageSelectArea->ActivePage->Controls[i]->InheritsFrom(__classid(TPanel)))
   {
    int height = pageSelectArea->ActivePage->Controls[i]->Height + panelSelectArea->Height + extra_space;
    this->Constraints->MaxHeight = height;
    this->Constraints->MinHeight = height;
    done = true;
   }
  }

  if (pageSelectArea->ActivePage == sheetRelationships2)
    DoRelationships2Thing();
*/
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::sheetRelationships2Show(TObject *Sender)
{
  DoRelationships2Thing();
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::listQuickIconsChange(TObject *Sender, TListItem *Item, TItemChange Change)
{
/* // Wow.  This is buggy as all hell.  Future release, then.
  // switch to the appropriate page (let the combo box do the hard work.
  //PSay(Item->SubItems[1].Text.c_str(), m_debug, MB_OK);
  string name_of_wanted_page = "\"" + string(Item->SubItems[0].Text.c_str()) + "\"";
  //PSay(name_of_wanted_page, m_debug, MB_OK);
  int index_of_combo_item = comboSelectArea->Items->IndexOf(Item->SubItems[0].Text);
  //PSay(IntToString(index_of_combo_item), m_debug, MB_OK);
  if (index_of_combo_item < 0)
   index_of_combo_item = 0; // if it can't find it, default to page 0 ... we don't have a "blank" page to use instead!
  comboSelectArea->ItemIndex = index_of_combo_item;
  comboSelectAreaChange(NULL);
*/
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::txtDemographicsClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchPatientDemographicsReport * demographics = new TformLaunchPatientDemographicsReport(NULL, "people", initial_state["id"], "");
    demographics->ShowTaskModal(this);
  FORM_CATCH
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::txtUpdateNoSignatureClick(TObject *Sender)
{
 TformLaunchIntakeFormReport::DoSilent(this, initial_state["id"], "", true, true);
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::txtWizardClick(TObject *Sender)
{
 TformWizardNewPerson::Do(initial_state["id"]);
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::txtHealthSummaryClick(TObject *Sender)
{
 set<string> id;
 id.insert(initial_state["id"]);
 TformLaunchPatientHealthSummary::Do(id);
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::FormShortCut(TWMKey &Msg, bool &Handled)
{
  // CTRL, ALT, and SHIFT are all off
  if(!HIBYTE(GetAsyncKeyState(VK_CONTROL)) &&
     !HIBYTE(GetAsyncKeyState(VK_MENU)) &&
     !HIBYTE(GetAsyncKeyState(VK_SHIFT)))
  {
    Handled = true;
    if(Msg.CharCode == VK_F2 && comboSelectArea->Items->IndexOf("General") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("General"); comboSelectAreaChange(NULL); }
    if(Msg.CharCode == VK_F3 && comboSelectArea->Items->IndexOf("Behavioral") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Behavioral"); comboSelectAreaChange(NULL); }
    if(Msg.CharCode == VK_F4 && comboSelectArea->Items->IndexOf("Caregiver") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Caregiver"); comboSelectAreaChange(NULL); }
    if(Msg.CharCode == VK_F5 && comboSelectArea->Items->IndexOf("Case Management") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Case Management"); comboSelectAreaChange(NULL); }
    if(Msg.CharCode == VK_F6 && comboSelectArea->Items->IndexOf("Community") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Community"); comboSelectAreaChange(NULL); }
    if(Msg.CharCode == VK_F7 && comboSelectArea->Items->IndexOf("Contract Health") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Contract Health"); comboSelectAreaChange(NULL); }
    if(Msg.CharCode == VK_F8 && comboSelectArea->Items->IndexOf("Dental Clinic") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Dental Clinic"); comboSelectAreaChange(NULL); }
    if(Msg.CharCode == VK_F9 && comboSelectArea->Items->IndexOf("Diabetes") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Diabetes"); comboSelectAreaChange(NULL); }
    if(Msg.CharCode == VK_F10 && comboSelectArea->Items->IndexOf("Medical Clinic") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Medical Clinic"); comboSelectAreaChange(NULL); }
    if(Msg.CharCode == VK_F11 && comboSelectArea->Items->IndexOf("Pharmacy") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Pharmacy"); comboSelectAreaChange(NULL); }
    if(Msg.CharCode == VK_F12 && comboSelectArea->Items->IndexOf("Public Health") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Public Health"); comboSelectAreaChange(NULL); }
    else
      Handled = false;
  }
  else if(HIBYTE(GetAsyncKeyState(VK_CONTROL)))
  {
    Handled = true;
    if((Msg.CharCode == 'a' || Msg.CharCode == 'A') && comboSelectArea->Items->IndexOf("Appointments") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Appointments"); comboSelectAreaChange(NULL); }
    if((Msg.CharCode == 'o' || Msg.CharCode == 'O') && comboSelectArea->Items->IndexOf("Common") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Common"); comboSelectAreaChange(NULL); }
    if((Msg.CharCode == 'd' || Msg.CharCode == 'D') && comboSelectArea->Items->IndexOf("Conditions") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Conditions"); comboSelectAreaChange(NULL); }
    if((Msg.CharCode == 'e' || Msg.CharCode == 'E') && comboSelectArea->Items->IndexOf("Consents") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Consents"); comboSelectAreaChange(NULL); }
    if((Msg.CharCode == 'm' || Msg.CharCode == 'M') && comboSelectArea->Items->IndexOf("Enrollment") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Enrollment"); comboSelectAreaChange(NULL); }
    if((Msg.CharCode == 'i' || Msg.CharCode == 'I') && comboSelectArea->Items->IndexOf("Insurance") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Insurance"); comboSelectAreaChange(NULL); }
    if((Msg.CharCode == 'r' || Msg.CharCode == 'R') && comboSelectArea->Items->IndexOf("Referrals") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Referrals"); comboSelectAreaChange(NULL); }
    if((Msg.CharCode == 'f' || Msg.CharCode == 'F') && comboSelectArea->Items->IndexOf("Relations") > -1)
    { comboSelectArea->ItemIndex = comboSelectArea->Items->IndexOf("Relations"); comboSelectAreaChange(NULL); }
    else
      Handled = false;
  }
  else
    Handled = false;

  TformRecordGeneric::FormShortCut(Msg, Handled);
}
//---------------------------------------------------------------------------
void __fastcall TformRecordPerson::lblDiabCareSummaryReportClick(TObject *Sender)
{
  FORM_TRY
    TformLaunchDiabCareSummaryReport * careSummaryReport = new TformLaunchDiabCareSummaryReport(NULL, initial_state["id"]);
    careSummaryReport->Show();
  FORM_CATCH
}
//---------------------------------------------------------------------------

